"
 COPYRIGHT (c) 1997 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 This is a demo example:

 THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.
"



"{ NameSpace: CodingExamples_GUI }"

GUIDemoApplication subclass:#GUIDemoNoteBook
	instanceVariableNames:'selection'
	classVariableNames:''
	poolDictionaries:''
	category:'examples-GUI'
!

!GUIDemoNoteBook class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 This is a demo example:

 THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
 FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.
"


!

documentation

"
    creating a notebook; dependent on the selected tab, the
    associated application is started in the notebook view.

    [author:]
        Claus Atzkern

    [start with:]
        GUIDemoNoteBook open
        GUIDemo open
"

! !

!GUIDemoNoteBook class methodsFor:'constants'!

slices
    ^ #(
            ( 'Menus'                   'GUIDemoMenu' )
            ( 'SelectionInTree'         'GUIDemoSelectionInTree' )
            ( 'Sliders'                 'GUIDemoSliders' )
       )
! !

!GUIDemoNoteBook class methodsFor:'interface specs'!

windowSpec
    "this window spec was automatically generated by the ST/X UIPainter"

    "do not manually edit this - the painter/builder may not be able to
     handle the specification if its corrupted."

    "
     UIPainter new openOnClass:GUIDemoNoteBook andSelector:#windowSpec
     GUIDemoNoteBook new openInterface:#windowSpec
    "
    "GUIDemoNoteBook open"

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #'window:' 
           #(#WindowSpec
              #'name:' 'NoteBook'
              #'layout:' #(#LayoutFrame 197 0 172 0 536 0 490 0)
              #'label:' 'NoteBook'
              #'min:' #(#Point 10 10)
              #'max:' #(#Point 1160 870)
              #'bounds:' #(#Rectangle 197 172 537 491)
          )
          #'component:' 
           #(#SpecCollection
              #'collection:' 
               #(
                 #(#NoteBookViewSpec
                    #'name:' 'noteBook'
                    #'layout:' #(#LayoutFrame 0 0.0 0 0.0 0 1.0 0 1.0)
                    #'model:' #selectionHolder
                    #'menu:' #listHolder
                    #'useIndex:' true
                    #'canvas:' #canvasHolder
                )
              )
          )
      )
! !

!GUIDemoNoteBook methodsFor:'aspects'!

canvasHolder
    "in the example, we are using a SubCanvas"

    |holder|

    (holder := builder bindingAt:#canvasHolder) isNil ifTrue:[
        builder aspectAt:#canvasHolder put:(holder := SubCanvas new).
    ].
    ^ holder
!

listHolder
    "gets the labels assigned to the tabs
    "
    ^ self class slices collect:[:aSlice| aSlice first ]
!

selectionHolder
    "automatically generated by UIPainter ..."

    |holder|

    (holder := builder bindingAt:#selectionHolder) isNil ifTrue:[
        holder := AspectAdaptor new subject:self; forAspect:#selection.
        builder aspectAt:#selectionHolder put:holder.
    ].
    ^ holder
! !

!GUIDemoNoteBook methodsFor:'selection'!

selection
    "get the selection
    "
    ^ selection
!

selection:something
    "set the selection; update canvas
    "
    |canvas className cls|

    selection ~~ something ifTrue:[
        selection := something.
        self showCR:'selection changed to index: ', selection printString.

        selection ~~ 0 ifTrue:[
            className := (self class slices at:selection) last.
            cls := Smalltalk classNamed:className.
            cls isNil ifTrue:[
                "/ try in my namespace
                cls := self class nameSpace classNamed:className
            ].
            cls isNil ifTrue:[
                self showCR:'no class named:' , className
            ] ifFalse:[
                self showCR:'load application: ', cls name asString.
                self canvasHolder value client:(cls new).
            ]
        ].
    ].

    "Modified: 9.9.1997 / 03:32:51 / cg"
! !

!GUIDemoNoteBook class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/clients/Demos/GUIDemoNoteBook.st,v 1.4 1997/10/29 20:20:51 cg Exp $'
! !
