'From Smalltalk/X, Version:2.10.8 on 25-nov-1995 at 10:13:05 pm'                !

Object subclass:#CommunicationInterface
	 instanceVariableNames:'interface process'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'contrib-PVM-Support'
!

!CommunicationInterface class methodsFor:'documentation'!

documentation
"
    documentation to be added.
"
!

examples
"
    examples to be added.
"
!

history

    "Created: 19.9.1995 / 11:45:08 / robert"
    "Modified: 22.11.1995 / 18:41:10 / robert"
!

version
^ '$Header: /cvs/stx/stx/contrib/libPVM/CommIF.st,v 1.2 1997/01/11 19:18:22 cg Exp $'! !

!CommunicationInterface class methodsFor:'creating an instance of myself'!

new: aProcessName
    "create an new communication interface"

    | inst |

    inst := super new.
    inst register: aProcessName.
    ^inst

    "Modified: 18.11.1995 / 19:50:41 / robert"
! !

!CommunicationInterface methodsFor:'accessing'!

process
    "return process"

    ^ process

    "Modified: 08.09.1995 / 18:17:34 / robert"
!

process:something
    "set process"

    process := something.

    "Modified: 08.09.1995 / 18:17:34 / robert"
! !

!CommunicationInterface methodsFor:'initialization'!

deRegister
    "leave the group in PVM and close the PVM-lightWeightProcess into Smalltalk"

    "ask the interface"
    process isNil ifTrue:[
	self warn: 'CommunicationInterface has a zombie task - still try to deregister with PVM'.
    ].
    
    interface removeProcess: process processName.
    process := nil.
    interface := nil.

    "Modified: 25.11.1995 / 21:36:51 / robert"
!

register: aProcessName
    "setup the instance"

    interface := PVMInterface new.  "get theOneAndOnlyInstace of PVMInterface"
    process := nil.
    "register my local GroupName into the general PVM Group Server"

    process := interface addProcess: aProcessName.

    "check for success"
    process isNil ifTrue:[
	self warn: 'connection for ', aProcessName, 'failed'.
    ].

    ^ process

    "Modified: 25.11.1995 / 21:11:10 / robert"
! !

!CommunicationInterface methodsFor:'marshalling'!

boss: anObject
    "marshall anObject and return it as aBytearray"

    | aStream |

    aStream := ReadWriteStream on: ByteArray new.
    anObject storeBinaryOn: aStream.
    ^aStream contents asByteArray

    "Created: 27.9.1995 / 14:52:09 / robert"
    "Modified: 18.11.1995 / 18:34:46 / robert"
!

unBoss: aByteArray
    "unmarshall aByteArray and return the orgiginal object"

    | aStream anObj |

    aStream := ReadWriteStream on: aByteArray.

    anObj := Object readBinaryFrom: aStream.

    ^anObj

    "Created: 27.9.1995 / 14:52:09 / robert"
    "Modified: 18.11.1995 / 18:34:57 / robert"
! !

!CommunicationInterface methodsFor:'send / receive Data'!

receive
    "receive an Object from the partner task"

    | anObject rawObjectasByteArray |

    rawObjectasByteArray := process receive.
    "now a raw coded object is in the receive buffer"

    "unBOSS it and return to sender"
    anObject := self unBoss: rawObjectasByteArray.

    ^anObject

    "Created: 19.9.1995 / 12:20:25 / robert"
    "Modified: 18.11.1995 / 18:45:13 / robert"
!

registerPartnerTask
    | members myID|

    "second level of communication
	- must be called once 
	- find a partner to talk or to listen to"


    "store the partner local in the process - 
    the application MUST NOT know the partner task ID 
    because it can change while using it (e.g. pvmgs-reorg groups)"

    "ask the interface for other members in the group (as PVMTaskIDs"
    members := interface pvmGetMembersOfGroup: process processName.

"/   (members size printString,' members found') printNL.

    members size > 0 ifFalse:[
	^false.
    ].

    myID := interface myTaskID.
"/    ('my TaskID is ',myID hexPrintString) printNL.

    members do:[:aPVMTaskID|
"/        ( aPVMTaskID hexPrintString) printNL.
	aPVMTaskID = myID ifFalse:[
	    "tell our process to whom it should talk to"
	    process partnerTaskID: aPVMTaskID.
	    ^true.    
	].
    ].

    "return true if one was found - else false"

    ^false.

    "Modified: 25.11.1995 / 22:10:35 / robert"
!

send: anObject
    "delivers an Object to the prevoiusly registered reciver"

    |aByteArray aStream |
    
    aByteArray := self boss: anObject.

    "only the process knows to whom to send the data"
    process send: aByteArray.

    "Modified: 22.11.1995 / 18:39:59 / robert"
! !
