'From Smalltalk/X, Version:2.10.8 on 25-nov-1995 at 10:05:37 pm'                !

Object subclass:#MiniTestApplicationForPVM
	 instanceVariableNames:'aCommunicationInterface'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'contrib-PVM-Demos'
!

!MiniTestApplicationForPVM class methodsFor:'documentation'!

documentation
"
    This class demonstrates the usage of the CommunicationInterface which uses PVM as TransportAgent
"

    "Created: 19.9.1995 / 12:07:28 / robert"
!

examples
"this has to run on your sending machine"

"


       |me|
       [

	    me := MiniTestApplicationForPVM new.
	    me doTestSend1.
	] valueOnUnwindDo: [
	    'deregisterMe in the unwindBlock' printNL.
	    me deRegisterMe.
	].
"

"this has to run on your receiving machine"

"
       |me|
       [

	    me := MiniTestApplicationForPVM new.
	    me doTestReceive1.
	] valueOnUnwindDo: [
	    'deregisterMe in the unwindBlock' printNL.
	    me deRegisterMe.
	].
"

    "Created: 19.9.1995 / 12:07:28 / robert"
!

history

    "Created: 19.9.1995 / 12:07:28 / robert"
    "Modified: 21.11.1995 / 14:33:55 / robert"
!

version
^ '$Header: /cvs/stx/stx/contrib/libPVM/MiniTestApplicationForPVM.st,v 1.2 1997/01/11 19:18:23 cg Exp $'! !

!MiniTestApplicationForPVM methodsFor:'dataexchange'!

firstReceiveTest
    "reveice data from my partner task"
    | anObject |

    anObject := aCommunicationInterface receive.
        
    anObject inspect.

"
    MiniTestApplicationForPVM new firstReceiveTest
"

    "Created: 27.9.1995 / 11:04:05 / robert"
    "Modified: 25.11.1995 / 21:33:18 / robert"
!

firstSendTest
    | p anInteger oc anArray aString sendCollection |

    aString := 'Hello I`m on host ', OperatingSystem getHostName, ' logged in as ', OperatingSystem getLoginName.
    aCommunicationInterface send: aString.

"
    MiniTestApplicationForPVM new firstSendTest
"

    "Created: 25.11.1995 / 21:31:42 / robert"
    "Modified: 25.11.1995 / 21:32:27 / robert"
!

receiveDataFromPartner
    "reveice data from my partner task"
    | anObject  receivedDataCollection |

"/    sendCollection add: aString.
"/    sendCollection add: anInteger.
"/    sendCollection add: anArray.
"/    sendCollection add: oc.

    receivedDataCollection := OrderedCollection new: 10.
    1 to: 4 do:[:index|
	('reading object #',index printString) printNL. "for debugging"
	"I know how many items were sent by the server :-))"
	anObject := aCommunicationInterface receive.
	receivedDataCollection add: anObject.
    ].
        
    receivedDataCollection inspect.

"
    MiniTestApplicationForPVM new receiveDataFromPartner
"

    "Created: 27.9.1995 / 11:04:05 / robert"
    "Modified: 25.11.1995 / 21:14:34 / robert"
!

sendDataToPartner
    "send some Objects to the Partner"

    | p anInteger oc anArray aString sendCollection |

    aString := 'Hello I`m on host ', OperatingSystem getHostName, ' logged in as ', OperatingSystem getLoginName.

    anInteger := 100.

    oc := OrderedCollection new.
    oc add: 'hello'.
    oc add: 1234.
    oc add: (Array with: 1 with: 'helloArray').

    anArray := Array with: 1 with: #symbol1 with: 'aString' with: 3.1415926.

    sendCollection := OrderedCollection new.

    sendCollection add: aString.
    sendCollection add: anInteger.
    sendCollection add: anArray.
    sendCollection add: oc.

    " now convert the objects to bytearrays"
    sendCollection do:[:anObject|
	Transcript showCr: 'Object of Class: ', anObject class printString, ' sent'.
	aCommunicationInterface send: anObject.
    ].    

"
    MiniTestApplicationForPVM new sendDataToPartner
"

    "Created: 19.9.1995 / 12:17:46 / robert"
    "Modified: 25.11.1995 / 21:31:19 / robert"
! !

!MiniTestApplicationForPVM methodsFor:'init'!

deRegisterMe
    "close talking channel"

    aCommunicationInterface deRegister.
    'deregister Me' printNL.

    "Created: 19.9.1995 / 12:10:58 / robert"
    "Modified: 25.11.1995 / 21:15:09 / robert"
!

registerMe: aPartnerGroupName
    "make a new Communication interface"

    "register myself in the image with PVM in a PVMGroup - no partner is nessesary for this"    
    aCommunicationInterface := CommunicationInterface new: aPartnerGroupName.

    "Created: 18.11.1995 / 19:51:59 / robert"
    "Modified: 25.11.1995 / 21:27:57 / robert"
!

registerPartner: aPartnerGroupName
    "make a new Communication interface"
    |  status |

    status := aCommunicationInterface registerPartnerTask.
    status ifFalse:[
"/        self warn: 'no partnertask found - check partner application and try again'.
	^false
    ].
    ^true

    "Created: 19.9.1995 / 12:08:30 / robert"
    "Modified: 25.11.1995 / 21:28:16 / robert"
! !

!MiniTestApplicationForPVM methodsFor:'running'!

doTestReceive
    "starting point for communication test suite - Smalltalk - Smalltalk Communication (SSC)"

    |  aPartnerGroupName |

    'starting Smalltalk 2 Smalltalk data communication' printNL.

    aPartnerGroupName := 'SSC-Test'.
    'register me with PVM' printNL.
    self registerMe:  aPartnerGroupName.

    [ self registerPartner: aPartnerGroupName ] whileFalse:[
	|d|
	d := Delay forMilliseconds:1000.
	2 timesRepeat:[d wait].
	'.' print.
    ].
    '' printNL.

    'waiting (synchonous) for the master sending data' printNL.    
    self receiveDataFromPartner.

    'data has been received from partner' printNL.

    self deRegisterMe.
"
       |me|
       [

	    me := MiniTestApplicationForPVM new.
	    me doTestReceive.
	] valueOnUnwindDo: [
	    'deregisterMe in the unwindBlock' printNL.
	    me deRegisterMe.
	].

"

    "Created: 21.11.1995 / 14:18:28 / robert"
    "Modified: 25.11.1995 / 21:25:28 / robert"
!

doTestReceive1
    "starting point for communication test suite - Smalltalk - Smalltalk Communication (SSC)"

    |  aPartnerGroupName |

    'starting Smalltalk 2 Smalltalk data communication' printNL.

    aPartnerGroupName := 'SSC-Test'.
    'register me with PVM' printNL.
    self registerMe:  aPartnerGroupName.

    [ self registerPartner: aPartnerGroupName ] whileFalse:[
	|d|
	d := Delay forMilliseconds:1000.
	2 timesRepeat:[d wait].
	'.' print.
    ].
    '' printNL.

    'waiting (synchonous) for the master sending data' printNL.    
    self firstReceiveTest.

    'data has been received from partner' printNL.

    self deRegisterMe.
"
       |me|
       [

	    me := MiniTestApplicationForPVM new.
	    me doTestReceive1.
	] valueOnUnwindDo: [
	    'deregisterMe in the unwindBlock' printNL.
	    me deRegisterMe.
	].

"

    "Created: 21.11.1995 / 14:18:28 / robert"
    "Modified: 25.11.1995 / 22:05:20 / robert"
!

doTestSend
    "starting point for communication test suite - Smalltalk - Smalltalk Communication (SSC)"

    |  aPartnerGroupName |

    'starting Smalltalk 2 Smalltalk data communication' printNL.

    aPartnerGroupName := 'SSC-Test'.
    'register me with PVM' printNL.
    self registerMe:  aPartnerGroupName.

    'now I`m registered - look for my partner' printNL.

    [ self registerPartner: aPartnerGroupName ] whileFalse:[
	|d|
	d := Delay forMilliseconds:1000.
	10 timesRepeat:[d wait].
	'.' print.
    ].
    '' printNL.

    'ok - now the partner is registered - data can be exchaned' printNL.

    self sendDataToPartner.

    'data has been sent to partner' printNL.

    self deRegisterMe.
"
       |me|
       [

	    me := MiniTestApplicationForPVM new.
	    me doTestSend.
	] valueOnUnwindDo: [
	    'deregisterMe in the unwindBlock' printNL.
	    me deRegisterMe.
	].
"

    "Created: 21.11.1995 / 14:18:28 / robert"
    "Modified: 25.11.1995 / 20:57:12 / robert"
!

doTestSend1
    "starting point for communication test suite - Smalltalk - Smalltalk Communication (SSC)"

    |  aPartnerGroupName |

    'starting Smalltalk 2 Smalltalk data communication' printNL.

    aPartnerGroupName := 'SSC-Test'.
    'register me with PVM' printNL.
    self registerMe:  aPartnerGroupName.

    'now I`m registered - look for my partner' printNL.

    [ self registerPartner: aPartnerGroupName ] whileFalse:[
	|d|
	d := Delay forMilliseconds:1000.
	10 timesRepeat:[d wait].
	'.' print.
    ].
    '' printNL.

    'ok - now the partner is registered - data can be exchaned' printNL.

    self firstSendTest.

    'data has been sent to partner' printNL.

    self deRegisterMe.
"
       |me|
       [

	    me := MiniTestApplicationForPVM new.
	    me doTestSend1.
	] valueOnUnwindDo: [
	    'deregisterMe in the unwindBlock' printNL.
	    me deRegisterMe.
	].
"

    "Created: 21.11.1995 / 14:18:28 / robert"
    "Modified: 25.11.1995 / 22:05:11 / robert"
! !
