'From Smalltalk/X, Version:2.10.8 on 25-nov-1995 at 8:47:27 pm'                 !

Object subclass:#PVMBasicInterface
	 instanceVariableNames:'pvmTaskID typeCodeMap'
	 classVariableNames:'PVMErrorSignal TheOneAndOnlyInstance'
	 poolDictionaries:''
	 category:'contrib-PVM-Support'
!

!PVMBasicInterface primitiveDefinitions!
%{
/* rcsID = $Id: PVMBasicInterface.st,v 1.4 1997/01/11 19:18:26 cg Exp $ */
#include <pvm3.h>
#include <pvmgsd.h>      /* for group handling via PVM GroupServer Task */
/* #include <pvmgdef.h> */    /* --" -- */
#include <stdio.h>
/*
    for debugging purposes call in the c source part
    debugBreakPoint();          in the actual 2.10.5 Release
    __debugBreakPoint();        may work in further releases
    and compile the source with -g instead of -O -fwriteablestrings
*/    

#ifndef __debugBreakPoint
#  define debugBreakPoint __debugBreakPoint
#endif

#define DEBUG_PVMPRIM   debuggingPVMLowLevelInterface

#ifndef __doubleVal
# define __doubleVal __floatVal
#endif

/* this Makro returns a longUnsignedInteger as a taskID for PVM */
/* #define taskIDVal(x)  (*(int *) &(__ByteArrayInstPtr( x )->ba_element[0])) */
#define taskIDVal(x)  (*(int *) (__ByteArrayInstPtr( x )->ba_element)) /* is das gleiche */

#ifndef __isLargeInteger
# define  __isLargeInteger(x)   (__Class(x) == @global(LargeInteger))
# define  __isInteger(x)        (__isSmallInteger(x) || __isLargeInteger(x))
#endif

extern OBJ __MKINT();

#ifdef DEBUG
# define DPRINTF(x)     printf x
#else
# define DPRINTF(x)     /* als nichts */
#endif

%}
! !

!PVMBasicInterface primitiveFunctions!
%{

pvmError() 
{
    DPRINTF(("PVM: pvmError ...\n"));
/*    __errorInterruptWithID__(@symbol(PVMLowLevelInterFace)); /* asynchon processing */
    __immediateErrorInterruptWithID__(@symbol(PVMLowLevelInterFace)); /* syncron processing*/
}

/* --- storeTaskID ------------------------------------------------------ */
#define DEBUGGING
#ifndef DEBUGGING
static 
#endif
int
storeTaskID ( aTaskID, tid )
    OBJ aTaskID;
    int tid;
{
    union {
	char u_char[4];
	unsigned u_uint;
    } val;

    if (aTaskID == nil) {
	pvmError();
	return;
    }

    val.u_uint = (unsigned int) tid;
    __ByteArrayInstPtr( aTaskID )->ba_element[0] = val.u_char[ 0 ];
    __ByteArrayInstPtr( aTaskID )->ba_element[1] = val.u_char[ 1 ];
    __ByteArrayInstPtr( aTaskID )->ba_element[2] = val.u_char[ 2 ];
    __ByteArrayInstPtr( aTaskID )->ba_element[3] = val.u_char[ 3 ];

    return tid;
} /* end of storeTaskID */


/* --- errorHandler ----------------------------------------------------- */
#ifndef DEBUGGING
static 
#endif
void
errorHandler ( rc )
    int rc; /* infoCode returnd by pvm functions) */
{
    /* 33 error codes */
    switch ( rc ) {
	case PvmOk:
	    printf ( "PVM: ok\n" );
	    return;
	    break;
	case PvmBadParam:   /* invalid argument value */
	    /* pvmError(@symbol(PVM_BAD_PARAM)); */
	    printf ( "PVMError: addHosts bad Parameter\n" );
	    break;
	case PvmMismatch:
	    printf ( "PVMError: count mismatch\n");
	    break;
	case PvmOverflow:
	    printf ( "PVMError: value too large\n" );
	    break;        
	case PvmNoData:
	    printf ( "PVMError: End of buffer - no data\n" );
	    break;
	case PvmNoHost:
	    printf ( "PVMError: no such host\n" );
	    break;
	case PvmNoFile:
	    printf ( "PVMError: no such file\n" );
	    break;
	case PvmNoMem:
	    printf ( "PVMError: pvm malloc failed no more memory\n" );
	    break;                
	case PvmBadMsg:
	    printf( "PVMError: can't decode message\n" );
	    break;
	case PvmSysErr:
	    printf ( "PVMError: can't contact local daemon\n" );
	    break;
	case PvmNoBuf:
	    printf ( "PVMError: no current buffer\n" );
	    break;
	case PvmNoSuchBuf:
	    printf ( "PVMError: no such buffer\n" );
	    break;                 
	case PvmNullGroup:
	    printf ( "PVMError: Null group name\n" );
	    break;
	case PvmDupGroup:
	    printf ( "PVMError: already in group\n" );
	    break;
	case PvmNoGroup:
	    printf ( "PVMError: No such group\n" );
	    break;            
	case PvmNotInGroup:
	    printf ( "PVMError not in group\n" );
	    break;    
	case PvmNoInst:
	    printf ( "PVMError: no such instance\n" );
	    break;    
	case PvmHostFail:
	    printf ( "PVMError: host failed\n" );
	    break;
	case PvmNoParent:
	    printf ( "PVMError: no parent task\n" );
	    break;
	case PvmNotImpl:
	    printf ( "PVMError: function not implemented\n" ); 
	    break;
	case PvmDSysErr:
	    printf ( "PVMError: pvmd system errror\n" ); 
	    break;
	case PvmBadVersion:
	    printf ( "PVMError: Version mismatch\n" );
	    break;
	case PvmOutOfRes:
	    printf ( "PVMError: out of resources\n" );
	    break;
	case PvmDupHost:
	    printf ( "PVMError: duplicate host\n" );
	    break;
	case PvmCantStart:
	    printf ( "PVMError: can't start pvmd\n" );
	    break;
	case PvmAlready:    
	    printf ( "PVMError:  host already present\n" );
	    break;
	case PvmNoTask:
	    printf ( "PVMError: no such task\n" );
	    break;    
	case PvmNoEntry:
	    printf ( "PVMError: noch such entry\n" );
	    break;
	case PvmDupEntry:
	    printf ( "PVMError: duplicate entry\n" );
	    break;        
	default:
	    printf ( "PVM: Unknown error: %d\n", rc );
    } /* end switch */

    pvmError();
    return;
} /* end of errorHandler */
%}
! !

!PVMBasicInterface class methodsFor:'documentation'!

documentation
"
    PVMBasicInterface implements neary all PVMLibrary Functions.
    It is used in conjunction with the pvm-daemon (pvmd3).
    For further information on PVM refer to: pvm@msr.epm.ornl.gov
    and read the newsgroup comp.parallel.pvm (strongly recommended)
    The software can be obtained via ftp @ netlib2.cs.utk.edu/pub/pvm3    

"
!

examples
"
    examples to be added.
"
!

history
    "Created: 18.11.1995 / 17:37:52 / robert"
!

version
^ '$Header: /cvs/stx/stx/contrib/libPVM/PVMBasicInterface.st,v 1.4 1997/01/11 19:18:26 cg Exp $'! !

!PVMBasicInterface class methodsFor:'initialization'!

initialize
    "register Interrupthandler for Subsytsem PVM"

    ObjectMemory registerErrorInterruptHandler: self forID: #PVMLowLevelInterFace.
    TheOneAndOnlyInstance := nil.   "this variable must ___not___ be saved in an image"
    PVMErrorSignal isNil ifTrue:[
"PVMErrorSignal := Object errorSignal newSignalMayProceed: false."
	PVMErrorSignal := (Signal new) mayProceed: false.
	PVMErrorSignal notifierString: 'PVM Interface Error'.

	PVMErrorSignal nameClass: self message: #pvmErrorSignal.

	self initializeDefaultErrorAction.  
    ]. 

"
    PVMBasicInterface initialize

"

    "Created: 25.11.1995 / 20:44:14 / robert"
!

initializeDefaultErrorAction
"/    PVMErrorSignal handlerBlock:[:ex |
"/    'handler block called' printNL.
"/         self warn:(ex errorString).
"/     ]
             
    "
    self initializeDefaultErrorAction
    "
!

new
    "create only ONE instance of this class"

    TheOneAndOnlyInstance isNil ifTrue:[
	TheOneAndOnlyInstance := super new.
	[
	    TheOneAndOnlyInstance initialize. 
	] valueOnUnwindDo:[
	    TheOneAndOnlyInstance := nil
	]
    ].
    ^ TheOneAndOnlyInstance
"
    PVMBasicInterface new    

"

    "Created: 25.11.1995 / 15:55:35 / robert"
    "Modified: 25.11.1995 / 20:41:43 / robert"
! !

!PVMBasicInterface class methodsFor:'Signal constants'!

pvmErrorSignal
    ^ PVMErrorSignal
! !

!PVMBasicInterface class methodsFor:'error handling'!

errorInterrupt: id
"/    'PVMBasicInterface class >>errorInterrupt' infoPrintNL.
    self pvmErrorSignal raise.

    "Created: 25.11.1995 / 15:57:13 / robert"
!

errorInterrupt: id with: aParameter
"/    'PVMBasicInterface class>>errorInterrupt:with' printNL.
    self pvmErrorSignal raise.

    "Created: 25.11.1995 / 15:56:48 / robert"
    "Modified: 25.11.1995 / 15:57:20 / robert"
! !

!PVMBasicInterface methodsFor:'accessing'!

pvmTaskID
    ^pvmTaskID
!

typeCodeMap
    "return typeCodeMap"

    ^ typeCodeMap
! !

!PVMBasicInterface methodsFor:'initialization'!

initialize
    "initialize the external PVM Interface for the first time"

    pvmTaskID := self pvmMyTid.         "this must be done ONCE and only ONCE regsiter with the pvmd"
    self pvmInitSend: (self pvmDataDefault).    "the master server is ever XDR"
    self pvmJoinGroup: (self class name printString).
    
    "setup pvmdatatype idenfifiers in a Dictionary with smalltalk datatypes / objects"
    self initializeTypeCodeMap. 
    
    ^self

    "Created: 19.9.1995 / 12:03:34 / robert"
    "Modified: 25.11.1995 / 16:04:07 / robert"
!

initializeTypeCodeMap
    "setup PVM Datatypes to SmalltalkDatatypes lookup table "

    typeCodeMap := Array new: 12.   "static predefined by PVM "
									   "PVM.h-value  type"
    typeCodeMap at: (self typeCodeString + 1) put:  #String .               "  0          string "
    typeCodeMap at: (self typeCodeByte + 1) put:  #ByteArray .              "  1          byte "
    typeCodeMap at: (self typeCodeShort + 1) put:  #SmallInteger .          "  2          short "
    typeCodeMap at: (self typeCodeInt + 1) put:  #SmallInteger .            "  3          int "
    typeCodeMap at: (self typeCodeFloat + 1) put:  #Float .                 "  4          real "
    typeCodeMap at: (self typeCodeComplex + 1) put:  #Float .               "  5          complex "
    typeCodeMap at: (self typeCodeDouble + 1) put:  #Float .                "  6          double "
    typeCodeMap at: (self typeCodeDoubleComplex + 1) put:  #Float .         "  7          double complex "
    typeCodeMap at: (self typeCodeLong + 1) put:  #LargeInteger .           "  8          long integer "
    typeCodeMap at: (self typeCodeUnsignedShort + 1) put:  #SmallInteger .  "  9          unsigned short int "
    typeCodeMap at: (self typeCodeUnsignedInt + 1) put:  #SmallInteger .    " 10          unsigned int "
    typeCodeMap at: (self typeCodeUnsignedLong + 1) put:  #LargeInteger .   " 11          unsigned long int "

    "Created: 19.9.1995 / 12:03:54 / robert"
!

release
    "releases the interface and disconnects
    from local pvmd (quitting virtual machine)"
    
    self pvmLeaveGroup: (self class name printString).  "this must be the last group"
    self pvmExit.
    'pvmProcess shutdown realy' printNL.    
    TheOneAndOnlyInstance := nil.

    "Created: 19.9.1995 / 12:03:47 / robert"
    "Modified: 25.11.1995 / 15:58:45 / robert"
! !

!PVMBasicInterface methodsFor:'primitives EncodingTypes'!

pvmDataDefault
    "XDR Encoding (this is often the default)"
%{
    RETURN( __MKINT( PvmDataDefault ));
%}.
!

pvmDataInPlace
    "data left in place no encoding no copiing"
%{
    RETURN( __MKINT( PvmDataInPlace ));
%}.
!

pvmDataRaw
    "no encoding leave data as it is"
%{    
    RETURN( __MKINT( PvmDataRaw ));
%}.
! !

!PVMBasicInterface methodsFor:'primitives buffers'!

pvmBufferInfo: bufferID
    "private - returns an Array with lengthInBytes, msgTag and
     senderTaskID of the contents of the buffer"

    | bufferInfo aTaskID msgTag "{ Class: SmallInteger }" lengthInBytes "{ Class: SmallInteger }" |

    bufferInfo := PVMBufferInfo new.
    aTaskID := PVMTaskID new.
%{ 
    int c_lengthInBytes, rc;
    int c_msgtag;
    int c_senderTaskID;

    if ( __isInteger( bufferID )) {
	rc = pvm_bufinfo ( __intVal( bufferID ), &c_lengthInBytes, &c_msgtag, &c_senderTaskID );
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    lengthInBytes = __MKINT(c_lengthInBytes);
	    msgTag = __MKINT(c_msgtag);
	    /* convert the TaskID into aPVMTaskID */
	    storeTaskID ( aTaskID, c_senderTaskID );
#ifdef DEBUG_PVMPRIM
	    printf ( "bufinfo: \n" );
	    printf ( "senderTaskID = %x, msgTag = %d, length = %d\n", c_senderTaskID, c_msgtag, c_lengthInBytes );
#endif
	} /* end if */
    } /* end if */
%}.

    bufferInfo noOfBytes: lengthInBytes.
    bufferInfo msgTag: msgTag.
    bufferInfo taskID: aTaskID.
    
    ^bufferInfo 

!

pvmFreeBuffer: aPVMBufferID
    "dispose of a message buffer"
%{ /* NOCONTEXT */
    int rc;

    if ( __isInteger( aPVMBufferID )) {
	rc = pvm_freebuf ( __intVal( aPVMBufferID ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN ( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmGetActiveReciveBufferID
    "returns the message buffer identifier for the active receive buffer"
%{ /* NOCONTEXT */
    int rc = 0;

    rc = pvm_getrbuf( );

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmGetActiveSendBufferID
    "returns the message buffer identifier for the active send buffer"
%{ /* NOCONTEXT */
    int rc = 0;

    rc = pvm_getsbuf();

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmInitSend: enCoding
    "clear default send buffer and specify message encoding"
%{ /* NOCONTEXT */
    int rc;
    /*
    PvmDataDefault  0   XDR
    PvmDataRaw      1   no encoding
    PvmDataInPlace  2   data left in place
    */

    if ( __isInteger( enCoding )) {
	rc = pvm_initsend ( __intVal( enCoding ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN ( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmMkBuffer: enCoding
    "creates a new message buffer"
%{ /* NOCONTEXT */
    int rc;
    /*
    Encoding            Value   Meaning
    PvmDataDefault      0       XDR
    PvmDataRaw          1       no encoding
    PvmDatainPlace      2       data left in place
    */

    if (__isInteger( enCoding )) {
	rc = pvm_mkbuf ( __intVal( enCoding ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN ( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmSetRecvBuffer: aBufferID
    "switches the active receive buffer and saves the previous buffer"
%{ 
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmSetSendBuffer: aBufferID
    "switches the active send buffer to aBufferID"
%{ 
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives daemon services'!

pvmCatchOut: aFileName
    "Catch output from child tasks spawned from within PVM"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmHostSync: aHostID
    "get time-of-day from PVM host"

    aHostID class == PVMTaskID ifFalse:[
	^self error: 'argument must be aPVMTaskID'
    ].
%{ /* NOCONTEXT */
    int rc; 
    struct timeval clks;
    struct timeval delta;

    rc = pvm_hostsync( taskIDVal( aHostID ), &clks, &delta );

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT( rc ) );
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives extended daemon functions'!

pvmRecvFunction: arg
    "redefines the comparison function used to accept messages"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmRegisterHostManager
    "register this task as responsible for adding new PVM hosts"
%{ /* NOCONTEXT */
    int rc = 0;

    /* 
       not implemented 
    
	 I think this wont make sense in smalltalk.
       its better to do this is a small and tiny
       C-Application
    */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmRegisterRessourceManager: aHostInfoStructure
    "registers this task as PVM resource manager"
%{ /* NOCONTEXT */
    int rc = 0;

    /* 
       not implemented 
    
	 I think this wont make sense in smalltalk.
       its better to do this is a small and tiny
       C-Application
    */
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmRegisterTaskManager
    "registers this task responsible for starting new PVM tasks"
%{ /* NOCONTEXT */
    int rc = 0;

    /* 
       not implemented 
    
	 I think this wont make sense in smalltalk.
       its better to do this is a small and tiny
       C-Application
    */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives failure management'!

pvmNotify: event msgTag: aMsgTag task: aTaskID
    "request notification of PVM event such as host failure"

    (aTaskID class = PVMTaskID) ifFalse:[
	^self error: 'aTaskID must be a PVMTaskID'.
    ].

    "
    event can have the following values: (specified in pvm3.h)
    Value           Meaning

    PvmTaskExit     notify if task exits
    PvmHostDelete   notify if host is deleted
    PvmHostAdd      notify if host is added

    "
%{ /* NOCONTEXT */
    int rc, c_taskID[ 1 ];

    if ( __isInteger( aMsgTag ) && __isInteger( event )) {

	c_taskID[ 0 ] = taskIDVal( aTaskID );

	rc = pvm_notify( __intVal( event ), __intVal( aMsgTag ), 1, c_taskID );

	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmPrintError: aString
    "prints the error message of the last PVM call (similar to perror())"
%{ /* NOCONTEXT */
    int rc;

    if ( __isString( aString )) {

	rc = pvm_perror( __stringVal( aString ));

	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT ( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmSendUnixSignal: aTaskID sigNum: aSignalNumber
    "sends a unix-signal to another PVM process"

    aTaskID class == PVMTaskID ifFalse:[
	^self error: 'argument must be a PVMTaskID'
    ].

%{ /* NOCONTEXT */
    int rc = 0;

    if ( __isInteger( aSignalNumber )) {
	rc = pvm_sendsig( taskIDVal( aTaskID ), __intVal( aSignalNumber ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives group functions'!

pvmBarrier: aGroupName numberOfGroupMembers: numberOfGroupMembers
    "Blocks the calling process until all processes in a group have called it"
%{ /* NOCONTEXT */
    int rc;

    if ( __isString( aGroupName ) && __isInteger( numberOfGroupMembers )) {
       rc = pvm_barrier ( __stringVal( aGroupName ), __intVal( numberOfGroupMembers ));
       if ( rc < 0 ) {
	   errorHandler ( rc );
       } else {
	   RETURN( __MKINT( rc ) );
       } /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmBroadCast: aGroup msgTag: aMsgTag
    "broadcasts the data in the active message buffer"
%{ /* NOCONTEXT */
    int rc;

   if ( __isString( aGroup ) && __isInteger( aMsgTag )) {
      rc = pvm_bcast ( __stringVal( aGroup ), __intVal( aMsgTag ));
      if ( rc < 0 ) {
	  errorHandler ( rc );
      } else {
	  RETURN( __MKINT( rc ));
      } /* end if */
   } /* end if */
%}.
    self primitiveFailed
!

pvmGetGroupServerID
    |aTaskID |

    aTaskID := PVMTaskID new.

%{
    int gstid;

    if(( gstid = gs_getgstid() ) > 0 ) {
	storeTaskID ( aTaskID, gstid );
	RETURN( aTaskID );
    };
    RETURN( nil );
%}.

    "Modified: 07.09.1995 / 14:27:20 / robert"
!

pvmGetGroupServerListTag
    "return a constant defined in header pvmgs.h"
%{
    RETURN( __MKINT( GSLS ));
%}

    "Modified: 07.09.1995 / 14:27:32 / robert"
!

pvmGetInst: aGroup taskID: aTaskID
    "returns the instance number in a group of a PVM process"

    aTaskID class == PVMTaskID ifFalse:[
	^self error: '2nd argument must be aTaskID'
    ].
%{ /* NOCONTEXT */
    int rc = 0, tid;

    if ( __isString( aGroup ) && __isInteger( aTaskID )) {
	tid = taskIDVal( aTaskID );
	rc = pvm_getinst( __stringVal( aGroup ), tid );
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));     /* values start at 0 and counting up */
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmGetTid: aGroup instanceNumber: inum
    "returns the taskid of the process identified by a group name and instance number"
    | aTaskID |

    aTaskID := PVMTaskID new.
%{ 
    int rc;

    if (__isString( aGroup ) && __isInteger( inum )) {
	rc = pvm_gettid ( __stringVal( aGroup ), __intVal( inum ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    storeTaskID ( aTaskID, rc );  
	    RETURN( aTaskID );
	} /* end if */
    } /* end if */
%}.
   self primitiveFailed
!

pvmGroupSize: aGroup
    "returns the number of mebers presently in the named group"
%{ /* NOCONTEXT */
    int rc;

    if (__isString( aGroup )) {

	rc = pvm_gsize ( __stringVal( aGroup ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
   } /* end if */
%}.
    self primitiveFailed
!

pvmJoinGroup: aGroup
    "enrolls the calling process in aGroup"
%{ /* NOCONTEXT */
    int rc;

    if ( __isString( aGroup )) {
	rc = pvm_joingroup ( __stringVal( aGroup ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN ( __MKINT( rc ));    /* returns the instance Number in the group */
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmLeaveGroup: aGroup
    "unenrolls the calling process from aGroup"
%{ /* NOCONTEXT */
   int rc;

    if ( __isString( aGroup )) {
	rc = pvm_lvgroup ( __stringVal( aGroup ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));     /* status code is returned */
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmMultiCast: aTidList msgTag: aMsgTag
    "multicasts the data in the active message buffer to a set of tasks"

    | anArray arraySize |

    anArray := aTidList asArray.
    arraySize := anArray size.
%{ /* NOCONTEXT */
    int rc = 0;
    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives host Management'!

pvmAddHost: aHostName
    "adds one host to the virtual machine"
%{ /* NOCONTEXT */
    int rc, statusCode;
    char *hostList[1];

    if ( __isString( aHostName )) {
	hostList[0] = __stringVal( aHostName );
	rc = pvm_addhosts ( hostList, 1, &statusCode );
	/* statusCode and rc shold be the same */
	if ( rc != statusCode ) {
	    printf ( "pvmAddHost: rc and statusCode are not identical - please check!\n" );
	} /* end if */

	if ( rc < 0 || statusCode < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( statusCode ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed.
!

pvmAddHosts: listOfHostNames
    "Adds one or more hots to the virtual machine"

    listOfHostNames do:[:aHostName|
	self addHost: aHostName.
    ].
!

pvmDelHost: aHostName
    "deletes one host from the virtual machine"
%{ /* NOCONTEXT */
    int rc, dontCare;
    char *hostList[1];

    if ( __isString( aHostName )) {
	hostList[0] = __stringVal( aHostName );
	rc = pvm_delhosts ( (char **) hostList, 1, &dontCare );
	if ( rc < 0 ) {
	    errorHandler( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmDelHosts: listOfhosts2Delete
    "deletes more hosts from the virtual machine"

    listOfhosts2Delete do:[ : aHostName|
	self pvmDelHost: aHostName.
    ].

! !

!PVMBasicInterface methodsFor:'primitives manipulating pvmds taskTable'!

pvmDelete: aName request: req
    "*** undocumented function ***
    provides acess to the pvmd taskTable if req = -1 then any 
    req is returnd by pvm_insert"
%{ /* NOCONTEXT */
    int rc;

    if ( __isString( aName ) && __isInteger( req )) {
	rc = pvm_delete ( __stringVal( aName ), __intVal( req ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT ( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmInsert: aName msgTag: aRequestedClassIndex taskID: aTaskID
    " *** undocumented pvm function *** Internal task2pvmd-Communication
    provides access to the internal pvmd taskTable 
    aRequestedClass index = -1 means any Class
    inserts a Process with its Name and its taskID 
    "
    aTaskID class = PVMTaskID ifFalse:[
	^self error: 'argument must be aTaskID'
    ].
        
%{ /* NOCONTEXT */
    int rc = 0;
    
    if ( __isInteger( aRequestedClassIndex ) && __isString( aName )) {
	rc = pvm_insert ( __stringVal( aName), __intVal( aRequestedClassIndex ), taskIDVal( aTaskID ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT ( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmLookup: aTaskName request: aRequestedClass
    "*** undocumented pvm function ***
    provides access to the pvmd taskTable
    request = -1 means any class
    "
   | aTaskID | 
%{ 
    int rc=0, tid;

    if ( __isString( aTaskName ) && __isInteger( aRequestedClass )) { 
	rc = pvm_lookup( __stringVal( aTaskName ), __intVal( aRequestedClass ), &tid );
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    storeTaskID( aTaskID, tid );
	    RETURN( aTaskID );
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives packing/unpacking'!

pvmPackBytes: aByteArray
    "packs aByteArray into the active sendbuffer"

    | arraySize |

    aByteArray class = ByteArray ifFalse:[
	^self error: 'argument must be aByteArray'.
    ].

    arraySize := aByteArray size.

%{ /* NOCONTEXT */
    /* bytearray umkopieren */
    char *data;
    int rc, nitem;

    nitem = __intVal( arraySize );
    data = (char *) __ByteArrayInstPtr(aByteArray)->ba_element;

    /* copy the data to the external pvm send-buffer */
    rc = pvm_pkbyte ( data, nitem, 1 );
    
    /* now the data is in the pvm buffer */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed.
!

pvmPackDouble: aDouble
    "packs aDouble into the sendbuffer"

    aDouble class == Float ifFalse:[
	^self error: 'argument must be aFloat'
    ].

%{ /* NOCONTEXT */
    int rc;
    double c_aDouble;

    c_aDouble = (double) __floatVal( aDouble );
    rc = pvm_pkdouble ( &c_aDouble, 1, 1 );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmPackFloat: aFloat
    "packs aFloat into the sendbuffer"

    aFloat class == Float ifFalse:[
	^self error: 'argument must be aFloat'
    ].

%{ /* NOCONTEXT */
    int rc;
    float c_aFloat;

    c_aFloat = (float) __floatVal ( aFloat );
    rc = pvm_pkfloat( &c_aFloat, 1, 1 );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed.
!

pvmPackInteger: anInteger
   "packs anInteger into the sendbuffer"

    anInteger class == SmallInteger ifFalse:[
	^self error: 'argument must be aSmallInteger'
    ].

%{ 
    int rc, c_anInteger;

    c_anInteger = __intVal ( anInteger );
    rc = pvm_pkint ( &c_anInteger, 1, 1 );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed

    "Modified: 30.08.1995 / 16:59:51 / robert"
!

pvmPackString: aString
    "packs the active message buffer with aString"

    aString class == String ifFalse:[
	^self error: 'argument must be a String'.
    ].  
%{ 
    int rc;
    
    rc = pvm_pkstr ( __stringVal( aString ));

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmUnpackBytes: byteCount
    "unpack bytes from the active receiveBuffer"
    | aByteArray |

    aByteArray := ByteArray new: byteCount.
%{ 
    int  rc, nitem;
    char *c_ByteArray;

    if ( __isInteger( byteCount )) {
	/* get the datapointer of the smalltalk bytearray */
	c_ByteArray = (char *) &__ByteArrayInstPtr( aByteArray )->ba_element[0];
	/* get size to unpack */
	nitem = __intVal( byteCount );

	rc = pvm_upkbyte( c_ByteArray, nitem, 1 /* stride */ );

	if ( rc < 0 ) {
	    errorHandler( rc );
	} else {
	    RETURN( aByteArray );
	} /* end if */
    } /* end if */
%}.
    ^self primitiveFailed
!

pvmUnpackDouble
    "unpacks aDouble from the recvbuffer"

%{ /* NOCONTEXT */
    int rc;
    double c_aDouble;

    rc = pvm_pkdouble ( &c_aDouble, 1, 1 );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKFLOAT( c_aDouble ));
    } /* end if */
%}.
    self primitiveFailed

    "Modified: 06.09.1995 / 10:10:14 / robert"
!

pvmUnpackFloat
    "unpacks aFloat from the recvbuffer"
%{ /* NOCONTEXT */
    int rc;
    float c_aFloat;

    rc = pvm_pkfloat( &c_aFloat, 1, 1 );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKFLOAT( c_aFloat ));
    } /* end if */
%}.
    self primitiveFailed.

    "Modified: 06.09.1995 / 10:09:29 / robert"
!

pvmUnpackInteger
   "unpacks exactly ONE Integer from the recvbuffer"

%{ 
    int rc, c_anInteger;

    rc = pvm_upkint ( &c_anInteger, 1, 1 );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( c_anInteger ));
    } /* end if */
%}.
    self primitiveFailed

    "Modified: 06.09.1995 / 10:08:15 / robert"
!

pvmUnpackIntegerArray: numberOfIntegers
   "unpacks an Integer Array from the recvbuffer"
    | rcArray |
%{ 
    int rc, *c_anIntegerArrayPtr;
    int c_theArraySize;

    if ( __isInteger( numberOfIntegers )) {  
	c_theArraySize = __intVal( numberOfIntegers );
	c_anIntegerArrayPtr = (int *) malloc ( sizeof ( int ) * c_theArraySize );
	rc = pvm_upkint ( c_anIntegerArrayPtr, c_theArraySize, 1 );    /* read from pvm */
	rcArray = __stArrayFromCIntArray( c_anIntegerArrayPtr, c_theArraySize );    /* convert c->stxArray */
	free ( c_anIntegerArrayPtr );   /* release unneeded buffer */
	if ( rc < 0 ) {
	    errorHandler ( rc );
	    RETURN( nil );
	} else {
	    RETURN ( rcArray );
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed

    "Modified: 07.09.1995 / 13:40:11 / robert"
!

pvmUnpackString100
    "special unpacking function for strings
    max len=100 chars excluding terminating 0"

%{ /* NOCONTEXT */
    char buffer[ 101 ];
    int rc = 0;

    rc = pvm_upkstr ( buffer );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKSTRING( buffer ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmUnpackString: aStringSize
    " unpacking function for strings"
    | aString |
%{ 
    char *buffer;
    int rc = 0;

    if ( __isInteger( aStringSize )) {
	if ( buffer = (char *) malloc ( __intVal( aStringSize ) * sizeof ( char ))) {
	    rc = pvm_upkstr ( buffer );
	    if ( rc < 0 ) {
		free ( buffer );
		errorHandler ( rc );
	    } else {
		aString = __MKSTRING( buffer );
		free ( buffer );
		RETURN ( aString );
	    } /* end if */
	} else {
	    printf ( "Memory allocation for pvmUnpackString: size = %d failed", __intVal( aStringSize ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives send / receive'!

pvmNoWaitRecv: aTaskID msgTag: msgTag
    "non blocking receive"

    (aTaskID class = PVMTaskID) ifFalse:[
	^self error: 'taskID must be aPVMTaskID'.
    ].

%{ /* NOCONTEXT */
    int rc, c_taskID;

    if ( __isInteger ( msgTag ) ) {
	c_taskID = taskIDVal( aTaskID );
	rc = pvm_nrecv ( c_taskID, __intVal( msgTag ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmPackSend: arg1 with: arg2 with: arg3 with: arg4 with: arg5
    "Pack and send data in one call"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */

%}.
    self primitiveFailed
!

pvmPrecv: aTaskID msgTag: aMsgTag buffer: aBuffer len: aLen datatype: aDatatype
    "Receives a message directly into a buffer"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmProbe: aTaskID msgTag: aMsgTag
    "checks if a message has arrived"

    aTaskID class == PVMTaskID ifFalse:[
	^self error: 'first argument must be aTaskID'
    ].
%{ /* NOCONTEXT */
    int rc, c_taskID;

    c_taskID = taskIDVal( aTaskID );

    if ( __isInteger( aMsgTag )) {
	rc = pvm_probe ( c_taskID, __intVal( aMsgTag ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN ( __MKINT( rc ));    /* bufferID where the message arrived */
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmRecv: aTaskID msgTag: aMsgTag
    "blocking receive a message"

    aTaskID class == PVMTaskID ifFalse:[
	^self error: 'first argument must be aTaskID'
    ].
%{ /* NOCONTEXT */
    int rc, c_taskID;

    if ( __isInteger ( aMsgTag )) {
	c_taskID = taskIDVal( aTaskID );

	rc = pvm_recv(  c_taskID, __intVal( aMsgTag ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmReduce: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
    "performa a reduce operation over members of the specified group"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmSend: aTaskID msgTag: aMsgTag
    "sends the data in the active message buffer"

    (aTaskID class = PVMTaskID) ifFalse:[
	^self error: 'taskID must be aPVMTaskID'.
    ].

%{ /* NOCONTEXT */
    int rc, c_taskID;

    c_taskID = taskIDVal( aTaskID );

/* needed for debugging
    #ifdef DEBUG_PRIMPVM  
	printf ( "taskID value = %x\n", c_taskID );    
    #endif      
*/
    if ( __isInteger ( aMsgTag )) {
    #ifdef DEBUG_PRIMPVM
	__immediateInterrupt__ = 1;
    #endif      
	rc = pvm_send ( c_taskID, __intVal( aMsgTag ));
    #ifdef DEBUG_PRIMPVM
	__immediateInterrupt__ = 0;
    #endif      
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed

    "Created: 25.11.1995 / 15:35:04 / robert"
!

pvmTimeoutRecv: aTaskID msgTag: aMsgTag timeOut: aTimeOutInSeconds 
    "recieves a message with timeout"

    aTaskID class = PVMTaskID ifFalse:[
	^self error: 'argument must be aTaskID'.
    ].    

    
%{ /* NOCONTEXT */
    int rc = 0, tid;
    struct timeval timeOut;

    if ( __isInteger( aMsgTag ) && __isInteger( aTimeOutInSeconds )) {
	tid = taskIDVal( aTaskID );
	timeOut.tv_sec = __intVal( aTimeOutInSeconds );
	timeOut.tv_usec = 0; 
	rc = pvm_trecv ( tid, __intVal( aMsgTag ), &timeOut );
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));     /* new bufferID */
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives task management'!

pvmKill: aTaskID
    "terminates a specified PVM process"

    aTaskID class = PVMTaskID ifFalse:[
	^self error: 'argument aTid musr be an Instance of PVMTaskID'
    ].
%{ /* NOCONTEXT */
    int rc;

    rc = pvm_kill ( taskIDVal( aTaskID ));

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed.
    ^ -1
!

pvmMyTid
    "returns the taskID of originating the process"

    ^ self getMyTidInto:(PVMTaskID new).
!

getMyTidInto:aTaskID
    "helper: set the taskID of originating the process"

%{  /* UNLIMITEDSTACK */
    int rc;

    rc = pvm_mytid();

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	storeTaskID ( aTaskID, rc );
	RETURN( aTaskID );
    } /* end if */
%}.
    self primitiveFailed.
    ^ -1
!

pvmParent
    "returns the tid of the process that spawned the calling process"
    | aTaskID |

    aTaskID := PVMTaskID new.

%{ 
    int rc;

    rc = pvm_parent ();
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	storeTaskID ( aTaskID, rc );
	RETURN( aTaskID );
    } /* end if */
%}.
    self primitiveFailed
!

pvmSpawn: aTaskName
    "spawns a new process and let pvm decide where to start the process
     (no arguments for the task)"
     | aTaskID |

    aTaskID := PVMTaskID new.
%{
    int tid, rc = 0;

    if ( __isString( aTaskName )) {
	rc = pvm_spawn ( __stringVal( aTaskName ), (char **) 0, 0, "", 1, &tid );
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    storeTaskID ( aTaskID, tid );
	    RETURN ( aTaskID );
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmSpawn: aTaskName onHost: aHostName
    "spawns a new process on aHostName (no arguments for the task)"
    | aTaskID |
    
    aTaskID := PVMTaskID new.
    
%{ 
    int tid, rc = 0;

    if ( __isString( aTaskName ) && __isString( aHostName )) {
	rc = pvm_spawn ( __stringVal( aTaskName ), (char **) 0/*argv*/, 1/* flag*/, __stringVal( aHostName ), 1/*ntasks*/, &tid/* returcodes*/ );
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    storeTaskID ( aTaskID, tid );
	    RETURN ( aTaskID );
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmSpawn: aTaskName withArgs: anArgumentList onHost: aHostName
    "spawns a new process on aHostName with arguments for the task"
    | aTaskID argArray argc |

    anArgumentList class == OrderedCollection ifFalse:[
	^self error: 'anArgumentlList must be an OrderdCollection'
    ].
    argArray := anArgumentList asArray. "must result in c in char **argv"
    argc := argArray size.
%{ 
    int   tid, rc = 0;
    char  **c_argv;

    if ( __isString( aTaskName ) && __isString( aHostName )) {
	rc = pvm_spawn ( __stringVal( aTaskName ), (char **) 0/*argv*/, 1/* flag*/, __stringVal( aHostName ), 1/*ntasks*/, &tid/* returcodes*/ );
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    storeTaskID ( aTaskID, tid );
	    RETURN ( aTaskID );
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmTidToHost: aTaskID
    "returns the host ID on which the specified task is running"

    aTaskID class = PVMTaskID ifFalse:[
	^self error: 'first argument must be aPVMTaskID'
    ].

%{ /* NOCONTEXT */
    int rc, c_taskID;
    c_taskID = taskIDVal( aTaskID );

    rc = pvm_tidtohost( c_taskID );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
! !

!PVMBasicInterface methodsFor:'primitives typeCodes'!

typeCodeByte

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_BYTE ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeComplex

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_CPLX ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeDouble

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_DOUBLE ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeDoubleComplex

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_DCPLX ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeFloat

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_FLOAT ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeInt

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_INT ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeLong

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_LONG ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeShort

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_SHORT ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeString
%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_STR ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeUnsignedInt

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_UINT ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeUnsignedLong

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_ULONG ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
!

typeCodeUnsignedShort

%{ /* NOCONTEXT */
    RETURN( __MKINT( PVM_USHORT ));
%}.    
"
#define PVM_STR                 0       /* string */
#define PVM_BYTE                1       /* byte */
#define PVM_SHORT               2       /* short */
#define PVM_INT                 3       /* int */
#define PVM_FLOAT               4       /* real */
#define PVM_CPLX                5       /* complex */
#define PVM_DOUBLE              6       /* double */
#define PVM_DCPLX               7       /* double complex */
#define PVM_LONG                8       /* long integer */
#define PVM_USHORT              9       /* unsigned short int */
#define PVM_UINT                10      /* unsigned int */
#define PVM_ULONG               11      /* unsigned long int */
"
! !

!PVMBasicInterface methodsFor:'primitives undocumented'!

pvmGather
    "undocumented pvm function"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemnted yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmGetMwId: arg
    "undocumented pvm function see pvm3.h"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmGetfds
    "undocumented pvm function"
%{ /* NOCONTEXT */
    int rc;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmScatter: arg1 with: arg2 with: arg3 with: arg4 with: arg5 with: arg6 with: arg7
    "undocumented PVM function"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmSetmwid: arg1 with: arg2
    "undocumented PVM function"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmStartPvmd: arg1 with: arg2 with: arg3
    "undocumented PVM function"
%{ /* NOCONTEXT */
    int rc = 0;

    /* not implemented yet */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmTickle: arg1 with: arg2 with: arg3 with: arg4
    "undocumented PVM function"
%{ /* NOCONTEXT */
    int rc;

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT ( rc ));
    } /* end if */
%}.
! !

!PVMBasicInterface methodsFor:'primitives virtual machine'!

pvmArchCode: aPVMArchitectureString
    "Look up the integer code for a architecture string.
     Make up one if necessary and cache it"
%{ /* NOCONTEXT */
    int rc;

    if ( __isString( aPVMArchitectureString )) {
	rc = pvm_archcode( __stringVal ( aPVMArchitectureString ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmConfig
    "returns informations about the present virtual machine configuration"
    | rcArray "{ Class:Array }"
      noOfHosts "{ Class:SmallInteger }" |
%{ 
    int rc, i;
    int c_noOfHosts, c_noOfArchs;
    struct pvmhostinfo *hInfo; /* static allocated by pvm routine */

    rc = pvm_config ( &c_noOfHosts, &c_noOfArchs, &hInfo );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	noOfHosts = __MKINT( c_noOfHosts );
    } /* end if */
%}.

    rcArray := Array new: noOfHosts.
    1 to: noOfHosts  do:[ :index| 
	rcArray at: index put: ( PVMHostInfo new ).
    ].    

%{ 
    int rc, i;
    int c_noOfHosts, c_noOfArchs;
    struct pvmhostinfo *dest, *hostArrayPointer; /* static allocated by pvm routine */

    rc = pvm_config ( &c_noOfHosts, &c_noOfArchs, &hostArrayPointer );
#ifdef DEBUG_PVMPRIM
    printf ( "rc of pvm_config was: %d\n", rc );
#endif

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
#ifdef DEBUG_PVMPRIM
	printf ( "noOfHosts found = %d\n", c_noOfHosts );
#endif
	for ( i = 0; i < c_noOfHosts; i++ ) {
	    OBJ *obj;
	    obj = (OBJ *) _ArrayInstPtr( rcArray )->a_element[ i ];
	    dest = (struct pvmhostinfo *) __ByteArrayInstPtr ( obj )->ba_element;
#ifdef DEBUG_PVMPRIM
	    printf ( "i = %d hostName = %s\n ", i, hostArrayPointer[i].hi_name );
#endif
	    *dest = hostArrayPointer[i];    /* (c) Claus Gittinger, thanks */
	} /* end for */

	RETURN( rcArray );
    } /* end if */
%}.
    self primitiveFailed
!

pvmExit
    "tells the local pvmd that this process is leaving PVM"
%{ /* NOCONTEXT */
    int rc;

    rc = pvm_exit ();

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN ( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmGetOpt: anInt
    "Shows various libpvm options"
%{ /* NOCONTEXT */
    int rc = 0;

    if ( __isInteger( anInt )) {
	rc = pvm_getopt ( __longIntVal( anInt ));
	/*
	optionValue (anInt) val meaning
	PvmRoute            1   RoutingPolicy
	PvmDebugMask        2   the debugMask
	PvmAutoErr          3   auto error reporting on console
	PvmOutputTid        4   stdout task for children
	PvmOutputCode       5   output msgtag
	PvmTraceTid         6   trace device for children
	PvmTraceCode        7   trace msgtag
	PvmFragSize         8   message fragmentation size
	PvmResvTids         9   Allow messages to reserved tags and TIDs
	*/
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    /* -----------------
	    PvmRouteReturnCodes:
	    PvmDontRoute    1
	    PvmAllowDirect  2
	    PvmRouteDirect  3
	    ------------------- */
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmHalt
    "shuts down the entire PVM system"
%{ /* NOCONTEXT */
    int rc;

    rc = pvm_halt ();
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT( rc ));
    } /* end if */

%}.
    self primitiveFailed
!

pvmMachineStatus: aHostName
    "returns the status of a host in the virtual machine"
%{ /* NOCONTEXT */
    int rc;

    if (__isString( aHostName )) {
	rc = pvm_mstat( __stringVal( aHostName ));
	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc ));
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmNumberHostsInVM
    "return the number of hosts in the VM"
%{ /* NOCONTEXT */
    int rc, i;
    int dummy1, c_noOfHosts;
    struct pvmhostinfo **dummy;

    rc = pvm_config( &c_noOfHosts, &dummy1, dummy );
    if (rc < 0) {
	errorHandler( rc );
    } else {
	RETURN( __MKINT( c_noOfHosts ));
    } /* end if */
%}.    
    self primitiveFailed.

!

pvmNumberOfArchitecturesInVM
    "return the number of different arches in the VM"
%{ /* NOCONTEXT */
    int rc, i;
    int dummy1, c_noOfArchs;
    struct pvmhostinfo **dummy;

    rc = pvm_config( &dummy1, &c_noOfArchs, dummy );
    if (rc < 0) {
	errorHandler( rc );
    } else {
	RETURN( __MKINT( c_noOfArchs ));
    } /* end if */
%}.    
    self primitiveFailed.

!

pvmProcessStatus: aTaskID
    "returns the status of the specified PVM process"

    aTaskID class == PVMTaskID ifFalse:[
	^self error: 'first argument must be aTaskID'
    ].

%{ /* NOCONTEXT */
    int rc, c_taskID;

    c_taskID = taskIDVal( aTaskID );

    rc = pvm_pstat( c_taskID );
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	RETURN( __MKINT( rc ));
    } /* end if */
%}.
    self primitiveFailed
!

pvmSetOpt: topic value: aValue
    "sets various libpvm options"

    topic isInteger ifFalse:[
	self error: 'topic must be integer'
    ].

    topic >= 1 and: [ topic <=9] ifFalse:[
	self error: 'topic must be 1..9'
    ].
%{ /* NOCONTEXT */
    int rc;

    /* topic:    val meaning                                    possible values
    PvmRoute      1 routing policy
    PvmDebugMask  2 debugmask                                   Number is the debuglevel
    PvmAutoErr    3 auto error reporting                        0/1
    PvmOutputTid  4 stdout device for children                  tid of a Task
    PvmOutputCode 5 output msgtag                               atag
    PvmTraceTid   6 trace device for children                   tid of a task
    PvmTraceCode  7 trace msgtag                                atag
    PvmFragSize   8 message fragment size                       size in bytes
    PvmResvTids   9 allow messages to reserve tags and TIDs     0/1
    */

    /*
    OptionValues for PvmRoute:
    PvmDontRoute        1
    PvmAllowDirect      2
    PvmRouteDirect      3
    */

    if ( __isInteger( aValue )) {

	rc = pvm_setopt( __longIntVal( topic ), __longIntVal( aValue ));

	if ( rc < 0 ) {
	    errorHandler ( rc );
	} else {
	    RETURN( __MKINT( rc )); /* old value is returned */
	} /* end if */
    } /* end if */
%}.
    self primitiveFailed
!

pvmTasksInVM 
    "return information abount the tasks running on the whole virtual machine like ps"
    | noOfTasks "{ Class: SmallInteger } " 
      rcArray   "{ Class: Array }" 
      counter   "{ Class: SmallInteger }" |
%{ 
    int rc = 0, c_nTasks;
    struct pvmtaskinfo *taskArrayPointer;
    
    /* checkout how many tasks are present in the VM */
    rc = pvm_tasks( 0/* where */, &c_nTasks,  &taskArrayPointer );
    #ifdef DEBUG_PVMPRIM_1
	printf ( "rc of pvm_tasks = %d\n", rc );
	printf ( "Number of Tasks found = %d\n", c_nTasks );
    #endif      
    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	/* checkout the information returned in  taskArrayPointer */
	noOfTasks = __MKINT( c_nTasks );
    } /* end if */
%}.
    rcArray := Array new: noOfTasks.
    1 to: noOfTasks do:[:index|
	rcArray at: index put: PVMTaskInfo new.
    ].
%{ 
    int rc = 0, c_nTasks, i;
    struct pvmtaskinfo *taskArrayPointer, *dest;
    OBJ *aPVMTaskInfoObj;

    /* where Parameter:
	0           = all tasks in the VM 
	pvmd taskID = for all tasks on a given host
	tid         = for a specific task
    */

    rc = pvm_tasks( 0/* where */, &c_nTasks, &taskArrayPointer );
	    /*
	       the arrayPointer taskArrayPointer points 
	       to a static allocated structure in PVM consisting of 
	       a list of pvmtaskinfo structs in order 
	    */

    if ( rc < 0 ) {
	errorHandler ( rc );
    } else {
	/* checkout the information returned in  taskArrayPointer 
	   remember that taskArrayPointer is an Array of structs
	*/
	for ( i = 0; i < c_nTasks; i++) {
	    /* write taskInfo into the elements of the rcArray */
	    aPVMTaskInfoObj = (OBJ *) _ArrayInstPtr( rcArray )->a_element[ i ];
	    /* make a Pointer of the adequate structure fom the SmalltalkObject */
	    dest = (struct pvmtaskinfo *) _ByteArrayInstPtr( aPVMTaskInfoObj )->ba_element;
	    /* and take it */
#ifdef DEBUG_PVMPRIM_1
	    printf ( "taskid = %x\n", taskArrayPointer[i].ti_tid);
#endif
	    *dest = taskArrayPointer[i];
	} /* end for */

	RETURN( rcArray );
    } /* end if */
%}.
   self primitiveFailed
!

pvmVersion
%{ /* NOCONTEXT */
    RETURN ( __MKSTRING( pvm_version() ));
%}.
    self primitiveFailed
! !

PVMBasicInterface initialize!
