'From Smalltalk/X, Version:2.10.8 on 25-nov-1995 at 5:08:35 pm'                 !

ObjectView subclass:#PVMConfigToolView
	 instanceVariableNames:'iconView listView textView'
	 classVariableNames:'KnownForms'
	 poolDictionaries:''
	 category:'contrib-PVM-Config-Tool'
!

!PVMConfigToolView class methodsFor:'documentation'!

documentation
"
    Graphical ConfigurationTool for the Parallel Virtual Machine PVM

    PVMView new open

"
!

examples
"
    examples to be added.
"
!

history
    "Created: 19.08.1995 / 17:22:31 / robert"
!

version
"
$Header: /cvs/stx/stx/contrib/libPVM/PVMConfigToolView.st,v 1.2 1997/01/11 19:18:31 cg Exp $
"
! !

!PVMConfigToolView class methodsFor:'cleanup'!

releaseRememberedForms
    KnownForms := nil

    "PVMView releaseRememberedForms"
! !

!PVMConfigToolView class methodsFor:'defaults'!

defaultExtent

    ^(400 @ 300 )

    "Modified: 19.08.1995 / 12:53:34 / robert"

!

defaultLabel
    ^'PVM-Config-Browser'
!

hitDelta
    "when clicking an object, allow for hitDelta pixels around object;
     0 is exact."
    ^ 0
!

icon
    ^ (Form fromFile:'DirObj.xbm' resolution:100)
!

pvmConfigFileName

    ^'/geamb/pvm3/pvm.cfg'
! !

!PVMConfigToolView class methodsFor:'startup'!

open
    ^ self openOn:nil

"
    PVMView new open

"
!

openOn:pathName
    |topView scrollView dirView|

    topView := StandardSystemView new.
    topView extent: (self defaultExtentOn: Display).
    topView icon: self icon.
    topView label: self defaultLabel.
    scrollView := HVScrollableView for: self in: topView.
    scrollView origin:(0.0 @ 0.0) extent:(1.0 @ 1.0).
    dirView := scrollView scrolledView.
    
    topView open.
    dirView updateContents.
    ^ dirView

    "
	PVMView open

    "

    "Modified: 19.08.1995 / 17:12:59 / robert"
! !

!PVMConfigToolView methodsFor:'initializing'!

getMenu
    selection notNil ifTrue:[
	^ PopUpMenu
				labels:(resources array:
				     #(
					'foo'
					'bar'
				       ))
			     selectors:#(
					foo
					bar
					)
    ].    

    ^ PopUpMenu
				labels:(resources array:
				     #(
					'inspect'
				       ))
			     selectors:#(
					inspect
					)

    "Modified: 19.08.1995 / 18:13:58 / robert"
!

initialize

    super initialize.

    doublePressAction := [:pressPoint | self doubleClick: pressPoint].
    pressAction := [:pressPoint | self startSelectOrMove:pressPoint].
    self model: PVMConfigToolModel new.
    self menuMessage:#getMenu.

    "Modified: 08.09.1995 / 17:54:33 / robert"
!

initializeMiddleButtonMenu
    self middleButtonMenu:(PopUpMenu
				labels:(resources array:
				     #(
					'inspect'
				       ))
			     selectors:#(
					inspect
					)
				receiver: self
				     for: self)

    "Modified: 19.08.1995 / 18:13:58 / robert"
!

open
    "setup layout of the Browser"

    | aTopView aPanel aButtonPanel  button1 button2 frame|

    aTopView := StandardSystemView new.
    aTopView label: (self class defaultLabel).
    aTopView extent: (self class defaultExtent).
    aTopView icon: self class icon.

    aPanel :=  VariableVerticalPanel origin: (0.0 @ 50 )
				     corner: (1.0 @ 1.0 )
				     in: aTopView.

    aButtonPanel := HorizontalPanelView origin: ( 0.0 @ 0.0 )
					corner: (1.0 @ 50 )
					in: aTopView.

    "add the buttons over the icon/list View"
    button1 := (Button label: 'Quit' action: [aTopView destroy] in: aButtonPanel).
    button2 := (Toggle label: 'foo' in: aButtonPanel).
    button2 pressAction: [iconView raise ]; releaseAction: [listView raise ].

    frame := SimpleView in: aPanel.
    frame  origin: (0.0 @ 0.0 ) corner: (1.0 @ 0.5 ).

    iconView := ScrollableView for: self class in: frame.
    iconView  origin: (0.0 @ 0.0 ) corner: (1.0 @ 1.0 ).

    listView := ScrollableView for: SelectionInListView in: frame.
    listView  origin: (0.0 @ 0.0 ) corner: (1.0 @ 1.0 ).

    textView := ScrollableView for: EditTextView in: aPanel.
    textView origin: (0.0 @ 0.5 ) corner: (1.0 @ 1.0 ).

    iconView updateContents.     "here the data is filled in into the hostview"
    self readConfigFile.

    aTopView open

"

    PVMConfigToolView new open

"

    "Modified: 08.09.1995 / 17:50:28 / robert"
! !

!PVMConfigToolView methodsFor:'misc queries'!

heightOfContents
    "answer the height of the document in pixels
     in this case, the max y extent is returned"

    ^ (contents inject:0 into:[:maxSoFar :something |
	something frame bottom max:maxSoFar
    ]) + 8

"/    |maxY|
"/
"/    maxY := 0.
"/    contents do:[:something |
"/        (something frame bottom > maxY) ifTrue:[
"/            maxY := something frame bottom
"/        ]
"/    ].
"/  ^ maxY + 8
!

rectangleForScroll
    "no need to waste time looking for objects; need full width always"

    ^ Rectangle left:0 top:0 width:width height:height
!

widthOfContents
    "answer the height of the document in pixels
     in this case, the max y extent is returned"

    ^ contents inject:0 into:[:maxSoFar :something |
	something frame right max:maxSoFar
    ]

"/  |maxX|

"/  maxX := 0.
"/  contents do:[:something |
"/      (something frame right > maxX) ifTrue:[
"/          maxX := something frame right
"/      ]
"/  ].
"/  ^ maxX
! !

!PVMConfigToolView methodsFor:'private'!

canMove:something
    ^ false

!

maximumObjectBounds
    |maxX maxY w h frame|

    "find the widest width and highest height"
    maxX := 0.
    maxY := 0.
    contents do:[:obj |
	frame := obj frame.
	w := frame width.
	h := frame height.
	maxX := maxX max:w.
	maxY := maxY max:h
    ].
    ^ maxX @ maxY
!

readConfigFile
    "get the contens of the PVM Configfile"
    | fileText |

    self cursor:Cursor wait.
    fileText := FileText ofFile: (self class pvmConfigFileName).
    textView contents: fileText.
    self cursor:Cursor normal.


"/   (fileName endsWith:'.tiff') ifTrue:[
"/        image := Image fromFile:fileName.
"/        image notNil ifTrue:[
"/           aForm := image asFormOn:device
"/        ]

    "Modified: 19.08.1995 / 18:31:33 / robert"
!

showObjects
    "show pictures"

    |frame xPos yPos max deltaY spaceX spaceY t w |

    self cursor:Cursor wait.

    "find the widest width and highest height"
    max := self maximumObjectBounds.

    deltaY := max y.
    spaceX := max x + 8 "font widthOf:'wwwwwwwwwwwwwww'" .
    spaceY := 8.
    xPos := 8. 
    yPos := spaceY.

    contents do:[:obj |
	frame := obj frame.
	w := frame width.
	t := (spaceX - w) // 2.
	    obj origin:(xPos + t @ yPos).
	    xPos := xPos + spaceX.
	    ((xPos + spaceX) >= width) ifTrue:[
		xPos := 8.
		yPos := yPos + deltaY + spaceY.
	    ].
    ].
    self contentsChanged.
    shown ifTrue:[
	self redraw
    ].
    self cursor:Cursor normal

    "Modified: 19.08.1995 / 18:16:47 / robert"
!

startRectangleDrag:startPoint
!

updateContents
    "show pictures"

    | anArray iconPath img|

iconPath := '/geamb/pUnit/robert/libPVM/bitmaps/'.

    self removeAllWithoutRedraw.

    "get the actual data"
    anArray := model getVMConfig.

    anArray do:[:aPVMHostInfo |
	|obj nm arch|
	obj := PVMHostObject new.
	obj font:font.
	nm := aPVMHostInfo hostName.
	obj name:nm.

	arch := aPVMHostInfo hostArch.
	img := Image fromFile:(iconPath , nm , '.tiff').
	img isNil ifTrue:[
	    img := Image fromFile:(iconPath , arch , '.tiff').
	    img isNil ifTrue:[
		img := Image fromFile: (iconPath , obj class iconFileName).
	    ]
	].
	obj icon: img.
	obj origin:0@0.
	self addWithoutRedraw: obj.
    ].

    self showObjects.

    "Modified: 08.09.1995 / 18:01:45 / robert"
! !

!PVMConfigToolView methodsFor:'user interaction'!

doubleClick:aPoint
    |anObject|

    anObject := self findObjectAtVisible: aPoint.
    (anObject ~~ selection) ifTrue:[self unselect].
    anObject notNil ifTrue:[
	self cursor:Cursor wait.
	InfoBox new title: 'doubleClick';showAtPointer.
"/ define a doubleClick action
	self cursor:Cursor normal
    ]

    "Modified: 19.08.1995 / 18:02:39 / robert"
! !

