'From Smalltalk/X, Version:2.10.8 on 25-nov-1995 at 9:44:21 pm'                 !

Object subclass:#PVMInterface
	 instanceVariableNames:'processList basicInterface'
	 classVariableNames:'TheOneAndOnlyInstance'
	 poolDictionaries:''
	 category:'contrib-PVM-Support'
!

!PVMInterface class methodsFor:'documentation'!

documentation
"
    Abstract Class for using the PVM Interface
"
!

examples
"
    examples to be added.
"
!

history

    "Modified: 15.08.1995 / 19:00:05 / robert"
!

version
^ '$Header: /cvs/stx/stx/contrib/libPVM/PVMInterface.st,v 1.2 1997/01/11 19:18:34 cg Exp $'! !

!PVMInterface class methodsFor:'initialization'!

initialize
    "setup the class"

    ^super initialize
! !

!PVMInterface class methodsFor:'instance creation'!

new
    "return the instance which is initialized"

    | inst |

    TheOneAndOnlyInstance = nil ifTrue:[
	inst := super new.
	inst initialize.
	TheOneAndOnlyInstance := inst. 
    ].

    ^ TheOneAndOnlyInstance
! !

!PVMInterface methodsFor:'debugging'!

getVirtualMachinePS
    "give a full process status of the Virtual machine"
    | tasksArray |

    self addProcess: 'vm-ps'.

    tasksArray := basicInterface pvmTasksInVM. 

    tasksArray inspect.
    self removeProcess: 'vm-ps'.

"
    PVMInterface new getVirtualMachinePS.

"

    "Created: 18.11.1995 / 20:51:50 / robert"
    "Modified: 18.11.1995 / 21:02:50 / robert"
!

testHelloWorld

    | taskID otherID box aString |

    self addProcess: 'testServer1'.

    otherID := basicInterface pvmSpawn: 'hello_other'.
    Transcript showCr: otherID hexPrintString.
    box := InfoBox new.

    otherID isNil ifFalse:[
	Transcript showCr: 'now waiting for receive the answer'.
	basicInterface pvmRecv: otherID msgTag: 1.
	Transcript showCr: 'got an answer'.
	aString := basicInterface pvmUnpackString100. 
	Transcript showCr: 'String is: ', aString.
	aString := 'from: ', otherID hexPrintString, ': ', aString.
	box := InfoBox new.
	box title: aString.
	box show. 
    ].
    self removeProcess: 'testServer1'.

    "
    PVMInterface new testHelloWorld
    "

    "Created: 18.11.1995 / 20:35:28 / robert"
    "Modified: 18.11.1995 / 21:08:42 / robert"
!

testPVMVersion
    "Checks function of PVMBasicInterface->>pvmVersion"
    | box aString |

    aString := self pvmVersion.
    box := InfoBox new.
    box title: 'Version of PVM is: ',aString.
    box show. 

    "
	PVMInterface new testPVMVersion

    "


	"samples for errorsignal processing"

    "
    PVMBasicInterface pvmErrorSignal catch:[
	PVMInterface new testPVMVersion
    ]
    "

    "
    PVMBasicInterface pvmErrorSignal handle:[:ex |
	ex return
    ] do:[
	PVMInterface new testPVMVersion
    ]
    "
    "
    PVMBasicInterface pvmErrorSignal handle:[:ex |
	self warn:'Bloedmann, starte den Daemon zuerst'.
	ex return.
    ] do:[
	PVMInterface new testPVMVersion
    ]
    "

    "Created: 18.11.1995 / 20:35:37 / robert"
    "Modified: 18.11.1995 / 21:04:33 / robert"
!

testPvmArchCode

    | anInt |

    self addProcess: 'checkArchCode'.

    anInt := basicInterface pvmArchCode: 'LINUX'.  "argument is the arch Name"
    Transcript showCr: 'Archcode = ', anInt printString, ' expected is 12 (source is pvmarchc.c)'.

    anInt := basicInterface pvmArchCode: 'M88K'.  "argument is the arch Name"
    Transcript showCr: 'Archcode = ', anInt printString, ' expected is 11 (source is pvmarchc.c)'.

    anInt := basicInterface pvmArchCode: 'PMAX'.  "argument is the arch Name"
    Transcript showCr: 'Archcode = ', anInt printString, ' expected is 12 (source is pvmarchc.c)'.

    anInt := basicInterface pvmArchCode: 'SUN4'.  "argument is the arch Name"
    Transcript showCr: 'Archcode = ', anInt printString, ' expected is 11 (source is pvmarchc.c)'.


    self removeProcess: 'checkArchCode'.

    "
    PVMInterface new testPvmArchCode
    "

    "Created: 18.11.1995 / 20:35:45 / robert"
    "Modified: 18.11.1995 / 21:05:05 / robert"
!

testPvmBufferInfo

    | anArray otherID  aString aBufferID|

    self addProcess: 'bufferInfo'.

    otherID := basicInterface pvmSpawn: 'hello_other'.
    Transcript showCr: 'ServerID = ',otherID hexPrintString.

    otherID isNil ifFalse:[
	Transcript showCr: 'now waiting for receive the answer'.
	aBufferID := basicInterface pvmRecv: otherID msgTag: 1.
	Transcript showCr: 'BufferID from recv is: ', aBufferID printString.

	anArray := basicInterface pvmBufferInfo:  aBufferID.
	anArray inspect.
	aString := basicInterface pvmUnpackString: 100. 
	Transcript showCr: 'String is: ', aString.
	aString := 'from: ', otherID hexPrintString, ': ', aString.
    ] ifTrue:[
	Transcript showCr: 'failed to spawn a C-Task'
    ].
    self removeProcess: 'bufferInfo'.

    "
    PVMInterface new testPvmBufferInfo 
    "

    "Created: 18.11.1995 / 20:55:23 / robert"
    "Modified: 18.11.1995 / 21:07:41 / robert"
!

testvirtualMachineContents
    "give a full status of the Virtual machine's hosts"
    | hostsArray |

    hostsArray := self pvmConfig. 

    hostsArray inspect.

"
    PVMInterface new testvirtualMachineContents.
"

    "Created: 18.11.1995 / 20:59:09 / robert"
    "Modified: 23.11.1995 / 17:22:46 / robert"
! !

!PVMInterface methodsFor:'group handling'!

pvmGetListOfActiveGroups
    "gets a list of goups actually installed at PVM by the GroupServer"
    | oc groupServerID numberOfGroups aPVMGroupInfo |

    oc := OrderedCollection new.

    groupServerID := basicInterface pvmGetGroupServerID.

    groupServerID isNil ifTrue:[
	'no group server found' printNL.
	^OrderedCollection new.
    ].

    self addProcess: 'GroupListService'.

    "send a request to the server"
    basicInterface pvmInitSend: (basicInterface pvmDataDefault).    "reset the send message buffer"
    basicInterface pvmSend: groupServerID msgTag: (basicInterface pvmGetGroupServerListTag).

    "receiving the data from the server"
    basicInterface pvmRecv: groupServerID msgTag: (basicInterface pvmGetGroupServerListTag).

    "get the number of groups sent by the group server "
    numberOfGroups := basicInterface pvmUnpackInteger.

"/    ('no of groups = ', numberOfGroups printString) printNL.

    numberOfGroups > 0 ifFalse:[
	'no groups registered at groupserver' printNL.
	self removeProcess: 'GroupListService'.
	^OrderedCollection new.
    ].

    "read each group record sent by the groupServer"
    1 to: numberOfGroups do:[:index|
	aPVMGroupInfo := self pvmReadGroupInfo.
	oc add: aPVMGroupInfo.
    ].
    self removeProcess: 'GroupListService'.

    ^oc
"
    PVMInterface new pvmGetListOfActiveGroups
"

    "Modified: 25.11.1995 / 14:41:20 / robert"
!

pvmGetMembersOfGroup: aGroupName
    "retrieve the memerbs of the specified group"
    | allGroups oc aPVMGroupInfoCollection |

    oc := OrderedCollection new.

    (self pvmGroupServerIncludes: aGroupName) ifTrue:[
	allGroups := self pvmGetListOfActiveGroups.
	aPVMGroupInfoCollection := allGroups select: [:grp| grp name = aGroupName].
	"into this InfoObject is a List of pvmids (native int) with the members in the group"
        
	aPVMGroupInfoCollection size > 0 ifTrue:[
	    oc := aPVMGroupInfoCollection first tids.   "contains an oc with PVMTaskIDs" 
"/            'collect the tids' printNL.
	].
    ].

    ^oc

"
    PVMInterface new pvmGetMembersOfGroup: 'processMonitor'

"

    "Created: 22.11.1995 / 18:36:37 / robert"
    "Modified: 25.11.1995 / 20:58:49 / robert"
!

pvmGetServerTIDinGroup: aGroup
    "return a taskID of the Task 0 in aGroup"
    | gSize aTaskID |

    gSize := basicInterface pvmGroupSize: aGroup.
    aTaskID := basicInterface pvmGetTid: aGroup instanceNumber: 0.     "1st task is the server (by convention)"

    ^aTaskID

"
    PVMInterface new pvmGetServerTIDinGroup: 'processMonitor'.
"

    "Modified: 25.11.1995 / 15:22:08 / robert"
!

pvmGroupServerIncludes: aGroupName
    "return whether the named group is in the group server or not"

    | oc elementsFound |


    oc := self pvmGetListOfActiveGroups.
    oc size = 0 ifTrue:[
	^false
    ].

    elementsFound := oc select:[:aPVMGroupInfo| aPVMGroupInfo name = aGroupName ].

    elementsFound size >= 1 ifTrue:[
	^true
    ].

    ^false

"
    PVMInterface new pvmGroupServerIncludes: 'processMonitor'.
"

    "Created: 19.9.1995 / 10:38:59 / robert"
    "Modified: 25.11.1995 / 14:32:10 / robert"
!

pvmReadGroupInfo
    "private - do not use alone; reads list data from the groupserver stream via pvm"
    | aPVMGroupInfo nameLenght name numberOfGroupTids groupLen  maxNTids  aPVMTaskIDList
     barrierCount barrierReached groupTids barrierTidsReached aPVMTaskID aPVMTaskIDListReachedTids |


"/        pvm_initsend(PvmDataDefault);
"/        pvm_pkint(ngroups, 1,1);
"/        for (i=0; i < HASHSIZE; i++) /* go through entire list of groups   */
"/        {
"/            current = hash_list+i;
"/            current = current->next;
"/            while (current !!= (GROUP_LIST_PTR) NULL)
"/            {
"/                 group = current->group;
"/                 pvm_pkint(&(group->len),1,1);
    nameLenght := basicInterface pvmUnpackInteger.        " read the stringlength of this groupname"
"/    ('nameLength = ', nameLenght printString) printNL.

"/                 pvm_pkstr(group->name);
    name := basicInterface pvmUnpackString: nameLenght+1. " read name of the group "
"/    ('name = ', name) printNL.

"/                 pvm_pkint(&(group->ntids), 1, 1);
    numberOfGroupTids := basicInterface pvmUnpackInteger. " read the number of tasksIDs in the server "
"/    (' numberOfGroupTids = ',  numberOfGroupTids printString) printNL.

"/                 pvm_pkint(&(group->maxntids), 1,1);
    maxNTids := basicInterface pvmUnpackInteger.     
"/    (' maxNTids = ',  maxNTids printString) printNL.

"/                 pvm_pkint(&(group->barrier_count), 1, 1);
    barrierCount := basicInterface pvmUnpackInteger.      " read the number of tasks which waitig on barrier"
"/    (' barrierCount = ',  barrierCount printString) printNL.

"/                 pvm_pkint(&(group->barrier_reached),1,1);
    barrierReached := basicInterface pvmUnpackInteger.    " read the number of tasks which reached the barrier count"
"/    (' barrierReached = ',  barrierReached printString) printNL.

"/                 pvm_pkint(group->tids,group->maxntids,1);

     groupTids := basicInterface pvmUnpackIntegerArray: maxNTids.   " read the list with taskids reached the barrier"
"/    groupTids inspect.

"/                 if ( group->barrier_reached > 0)
    barrierReached > 0 ifTrue:[
"/                     pvm_pkint(group->btids, group->barrier_reached, 1); 
	barrierTidsReached := basicInterface pvmUnpackIntegerArray: 1. " read the list of tasks which have reached the barrier"
    ] ifFalse:[
	barrierTidsReached := OrderedCollection new.
    ].
"/                 current = current->next;
"/            }
"/         }
"/         return(PvmOk);

    "save all the collected data in my Smalltalkobject"

    aPVMTaskIDList := OrderedCollection new.
    groupTids do:[:aNative32BitINT|
	aNative32BitINT = -1 ifFalse:[
	    aPVMTaskID := PVMTaskID fromInteger: aNative32BitINT.
	    aPVMTaskIDList add:  aPVMTaskID.
	]
    ].
    aPVMTaskIDListReachedTids := OrderedCollection new.
    barrierTidsReached do:[:aNative32BitINT|
	aPVMTaskID := PVMTaskID fromInteger: aNative32BitINT.
	aPVMTaskIDListReachedTids add: aPVMTaskID.
    ].

    aPVMGroupInfo := PVMGroupInfo new.
    aPVMGroupInfo name: name.
    aPVMGroupInfo tids: aPVMTaskIDList. 
    aPVMGroupInfo barrierTidsReached: aPVMTaskIDListReachedTids.

    ^aPVMGroupInfo

    "Modified: 25.11.1995 / 14:34:29 / robert"
! !

!PVMInterface methodsFor:'info & status'!

myTaskID
    "return my own taskID into PVM VM"

    ^basicInterface pvmTaskID.

"
    PVMInterface new myTaskID

"

    "Created: 25.11.1995 / 15:52:48 / robert"
    "Modified: 25.11.1995 / 15:59:11 / robert"
!

pvmConfig
    "returns all name of hosts in the VM"
    | anArray oc |

    self addProcess: 'pvmConfig'.    
    anArray := basicInterface pvmConfig.
    self removeProcess: 'pvmConfig'.

    ^anArray
"
	PVMInterface new pvmConfig
"

    "Modified: 08.09.1995 / 18:08:16 / robert"
!

pvmHostName
    "returns the name of the local pmvd host"
    | anArray myHostID |

    self addProcess: 'pvmHostName'.    
    anArray := basicInterface pvmConfig.
    self removeProcess: 'pvmHostName'.

    myHostID := self serverID.
    anArray do:[:aHostInfo|
	aHostInfo taskID = myHostID ifTrue:[
	    ^aHostInfo hostName.
	].
    ].
    ^'hostNotFound'
    

"
	PVMInterface new pvmHostName
"

    "Modified: 08.09.1995 / 18:04:52 / robert"
!

pvmHostNameFromTID: aTaskID
    "returns the name of the host on which the specified task is running"
    | anArray  aHostID |


    aTaskID class == PVMTaskID ifFalse:[
	^self error: 'argument must be aTaskID'
    ].

    aHostID := aTaskID hostID.
    Transcript showCr: aHostID hexPrintString.
    self addProcess: 'pvmHostNameFromTID'.    
    anArray := basicInterface pvmConfig.
    self removeProcess: 'pvmHostNameFromTID'.

    anArray do:[:aPVMHostInfo|
	aPVMHostInfo pvmdTaskID = aHostID ifTrue:[
	    ^aPVMHostInfo hostName.
	].
    ].
    ^'hostNotFound'


"
	PVMInterface new pvmHostNameFromTID: (PVMTaskID fromInteger: 16r40002).
"

    "Modified: 08.09.1995 / 18:05:07 / robert"
!

pvmHostNames
    "returns all name of hosts in the VM"
    | anArray oc |

    oc := OrderedCollection new.

    self addProcess: 'pvmHostNames'.    
    anArray := basicInterface pvmConfig.
    self removeProcess: 'pvmHostNames'.
    anArray do:[:aPVMHostInfo|
	oc add: (aPVMHostInfo hostName).
    ].

    ^oc
"
	PVMInterface new pvmHostNames
"

    "Modified: 08.09.1995 / 18:05:22 / robert"
!

pvmMyTaskID
    "return my own Id to the sender"

    ^basicInterface pvmTaskID

    "Created: 22.11.1995 / 18:32:01 / robert"
!

pvmVersion
    "returns the daemon version"
    |  aString |
    self addProcess: 'pvmVersion'.    
    aString := basicInterface pvmVersion.
    self removeProcess: 'pvmVersion'.

    ^aString
"
	PVMInterface new pvmVersion
"

    "Modified: 18.11.1995 / 20:44:51 / robert"
! !

!PVMInterface methodsFor:'initialization'!

initialize
    "setup the instance"

    processList = nil ifTrue:[
	processList := Dictionary new.
    ].

    basicInterface isNil ifTrue:[
	basicInterface := PVMBasicInterface new.
    ].

    ^self

    "Modified: 08.09.1995 / 14:35:27 / robert"
!

release
    "release the interface"

    ((processList size = 0) or: [processList isNil]) ifTrue: [
	basicInterface release.     "disconnect from pvmd"
	TheOneAndOnlyInstance := nil.
    ] ifFalse:[
	self warn: 'can not release interface while processes are active - do nothing'.
    ].

    ^self

    "Modified: 18.11.1995 / 19:20:13 / robert"
! !

!PVMInterface methodsFor:'process handling'!

addProcess: processName
    "create a new PVMProcess and add it to the list"

    | aProcess groupInstNum sendBuffer aSignal |

    (processName class = String) ifFalse:[
	^self error: 'argument must be aString'.
    ].

    aProcess := processList at: processName ifAbsent:[      "check the image local processList"
	aProcess := PVMProcess new.

	"join the group"
"/        aSignal handle:[:theExeption|
"/            "this is the handler for the exeption if join goup fails"
"/            self warn: 'in the exeption- can not join to group', processName.
"/            ^nil
"/        ] do:[
	    groupInstNum := basicInterface pvmJoinGroup: processName.
"/        ].

	aProcess initializeFor: processName groupInst: groupInstNum interface: self.

	"store the new process in the dictionary"
	processList at: processName put: aProcess.  
	^aProcess
    ].

    self warn: 'process is already in use previous process returned'.
    
    ^aProcess

    "Modified: 18.11.1995 / 19:18:14 / robert"
!

removeProcess: aProcessName

    | aProcess |

    aProcess := processList at: aProcessName  ifAbsent: [
	^self error: 'argument is not in processList - very heavy programming (code) error'.
    ].

"/    PVMBasicInterface SigLeaveGroup handler:[:theExeption|
"/        self warn: 'leave group has failed'.
"/    ] do:[
	basicInterface pvmLeaveGroup: aProcessName.
"/    ].
    processList removeKey: aProcessName ifAbsent:[
	^self error: 'argument is not in processList - heavy programming error'.
    ].

    "Modified: 19.9.1995 / 10:45:46 / robert"
! !

!PVMInterface methodsFor:'send / receive'!

receiveDataFrom: aPVMTaskID
    "get a Bytearray from aPVMTaskID"
    |  aMsgTag aBufferInfo |

    aMsgTag := 1.   "transaction number - should come from the basicINterface" 

    aPVMTaskID class = PVMTaskID ifFalse:[
	^self error: '1st arg must be aPVMTaskID'.
    ].
'debug: PVMInterface>>receiveData' printNL.
'sender Task = ', aPVMTaskID hexPrintString printNL.

    "unpack send buffer"
    basicInterface pvmRecv: aPVMTaskID msgTag: aMsgTag.
    aBufferInfo := basicInterface pvmBufferInfo: (basicInterface pvmGetActiveReciveBufferID).

    ^basicInterface pvmUnpackBytes: aBufferInfo noOfBytes.

    "Modified: 25.11.1995 / 21:44:18 / robert"
!

sendData: aByteArray to: aPVMPartnerTaskID
    "deliver the bytearray to aPartnerTaskID"
    |  aMsgTag |

    aMsgTag := 1.   "transaction number - should come from the basicINterface" 

    aByteArray class = ByteArray ifFalse:[
	^self error: '1st arg must be a ByteArray'
    ].

    aPVMPartnerTaskID class = PVMTaskID ifFalse:[
	^self error: '2nd arg must be aPVMTaskID'.
    ].

'debug: PVMInterface>>sendData' printNL.
'receiver = ', aPVMPartnerTaskID hexPrintString printNL.


    "reset send buffer"
    basicInterface pvmInitSend: (basicInterface pvmDataDefault).

    "pack send buffer"
    basicInterface pvmPackBytes: aByteArray.

    "transmit data from sendbuffer to aTaskID"
    ^basicInterface pvmSend: aPVMPartnerTaskID msgTag: aMsgTag.

    "Modified: 25.11.1995 / 21:42:46 / robert"
! !

PVMInterface initialize!
