'From Smalltalk/X, Version:2.10.8 on 25-nov-1995 at 10:12:23 pm'                !

Object subclass:#PVMProcess
	 instanceVariableNames:'instNumInGroup processName interface partnerTaskID transActionID'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'contrib-PVM-Support'
!

!PVMProcess class methodsFor:'documentation'!

documentation
"
   This class is for managing multiple ST/X (LW) processes with PVM.
"
!

examples
"
    See PVMInterface
"
!

history

    "Created: 19.9.1995 / 12:23:09 / robert"
    "Modified: 25.11.1995 / 21:38:31 / robert"
!

version
^ '$Header: /cvs/stx/stx/contrib/libPVM/PVMProcess.st,v 1.2 1997/01/11 19:18:36 cg Exp $'! !

!PVMProcess methodsFor:'accessing'!

instNumInGroup
    "return instNumInGroup"

    ^ instNumInGroup

    "Modified: 08.09.1995 / 14:16:57 / robert"
!

instNumInGroup:something
    "set instNumInGroup"

    instNumInGroup := something.

    "Created: 25.11.1995 / 22:10:54 / robert"
!

interface
    "return interface"

    ^ interface

    "Modified: 08.09.1995 / 11:39:13 / robert"
!

interface:something
    "set interface"

    interface := something.

    "Created: 25.11.1995 / 22:10:54 / robert"
!

partnerTaskID
    "return partnerTaskID"

    ^ partnerTaskID

    "Created: 25.11.1995 / 22:10:54 / robert"
!

partnerTaskID:something
    "set partnerTaskID"

    partnerTaskID := something.

    "Created: 25.11.1995 / 22:10:54 / robert"
!

processName
    "return processName"

    ^ processName

    "Modified: 08.09.1995 / 11:39:13 / robert"
!

processName:something
    "set processName"

    processName := something.

    "Created: 25.11.1995 / 22:10:54 / robert"
!

transActionID
    "return transActionID"

    ^ transActionID

    "Created: 25.11.1995 / 22:10:54 / robert"
!

transActionID:something
    "set transActionID"

    transActionID := something.

    "Created: 25.11.1995 / 22:10:54 / robert"
! !

!PVMProcess methodsFor:'initialization'!

initializeFor: aProcessName groupInst: anInstNum interface: anInterface
    "setup all instvars"

    instNumInGroup := anInstNum.
    interface := anInterface.
    processName := aProcessName.
    partnerTaskID := nil.    
"/    transactionID := interface getTransactionID.


    ^self

    "Modified: 25.11.1995 / 21:40:02 / robert"
! !

!PVMProcess methodsFor:'send / receive'!

receive
    "get the data from another PVM Task"

    partnerTaskID class = PVMTaskID ifFalse:[
	^self error: 'partnerTask must be aPVMTaskID'.
    ].
    ^interface receiveDataFrom: partnerTaskID

    "Modified: 25.11.1995 / 21:39:36 / robert"
!

send: aByteArray
    "sends the data to another PVM Task"


    partnerTaskID class = PVMTaskID ifFalse:[
	^self error: 'partnerTask must be aPVMTaskID'.
    ].
    ^interface sendData: aByteArray to: partnerTaskID

    "Modified: 25.11.1995 / 21:39:47 / robert"
! !

