'From Smalltalk/X, Version:2.10.8 on 25-nov-1995 at 5:08:40 pm'                 !

ByteArray subclass:#PVMTaskID
	 instanceVariableNames:''
	 classVariableNames:''
	 poolDictionaries:''
	 category:'contrib-PVM-Support'
!

!PVMTaskID primitiveDefinitions!
%{
#include <pvm3.h>
#define taskIDVal(x)  (*(int *) (_ByteArrayInstPtr( x )->ba_element ))
struct pvmID {
	unsigned int taskID:18;
	unsigned int hostID:12;
	unsigned int group:1;
	unsigned int schizoid:1;
};


%}
! !

!PVMTaskID class methodsFor:'documentation'!

documentation
"
    Holds a PVM-Task-ID with the bits decoded
"
!

examples
"
    examples to be added.
"
!

history
    "Created: 18.11.1995 / 17:38:32 / robert"
!

version
"
$Header: /cvs/stx/stx/contrib/libPVM/PVMTaskID.st,v 1.2 1997/01/11 19:18:37 cg Exp $
"
! !

!PVMTaskID class methodsFor:'instance creation'!

basicNew
    ^ super basicNew:4
!

basicNew:count
    self shouldNotImplement
!

fromInteger:anInteger
    |inst|

    inst := self new.
    inst basicAt: 1 put: ( anInteger              bitAnd: 16rff).
    inst basicAt: 2 put: ((anInteger bitShift:-8)  bitAnd: 16rff).
    inst basicAt: 3 put: ((anInteger bitShift:-16) bitAnd: 16rff). 
    inst basicAt: 4 put: ((anInteger bitShift:-24) bitAnd: 16rff).
    ^ inst
"

	PVMTaskID fromInteger: (-1).
"

    "Created: 22.11.1995 / 18:02:44 / robert"
    "Modified: 22.11.1995 / 18:04:30 / robert"
! !

!PVMTaskID methodsFor:'accessing'!

asInteger
    "return the value as an Small or Large Integer"

    ^self doubleWordAt: 1

    "Modified: 15.08.1995 / 17:02:16 / robert"
!

group
%{  /* NOCONTEXT */
    struct pvmID *p = (struct pvmID *)(_ByteArrayInstPtr(self)->ba_element);

    RETURN ( __MKSMALLINT(p->group) );
%}
!

group:id
%{  /* NOCONTEXT */
    struct pvmID *p = (struct pvmID *)(_ByteArrayInstPtr(self)->ba_element);

    if (__isSmallInteger(id)) {
	/*
	 * check if __intVal(id) in [0..1]
	 */
	p->group = __intVal(id);
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

hostID
%{  /* NOCONTEXT */
    struct pvmID *p = (struct pvmID *)(_ByteArrayInstPtr(self)->ba_element);

    RETURN ( __MKSMALLINT(p->hostID) );
%}
!

hostID:id
%{  /* NOCONTEXT */
    struct pvmID *p = (struct pvmID *)(_ByteArrayInstPtr(self)->ba_element);

    if (__isSmallInteger(id)) {
	/*
	 * check if __intVal(id) in [0..4095]
	 */
	p->hostID = __intVal(id);
	RETURN ( self );
    }
%}.
    self primitiveFailed
!

taskID
%{  /* NOCONTEXT */
    struct pvmID *p = (struct pvmID *)(_ByteArrayInstPtr(self)->ba_element);

    RETURN ( __MKSMALLINT(p->taskID) );
%}
!

taskID:id
%{  /* NOCONTEXT */
    struct pvmID *p = (struct pvmID *)(_ByteArrayInstPtr(self)->ba_element);

    if (__isSmallInteger(id)) {
	/*
	 * check if __intVal(id) in [0..256k]
	 */
	p->taskID = __intVal(id);
	RETURN ( self );
    }
%}.
    self primitiveFailed
! !

!PVMTaskID methodsFor:'catching byte access'!

basicAt:index put:aByte
    "self shouldNotImplement"
    ^super basicAt:index put:aByte.
! !

!PVMTaskID methodsFor:'comparing'!

= aTaskID
    "implements a equal comparison"

    ^((self asInteger) = (aTaskID asInteger))

    "Modified: 15.08.1995 / 17:02:53 / robert"
! !

!PVMTaskID methodsFor:'copying'!

copy

    ^self class fromInteger: (self asInteger).

    "Modified: 15.08.1995 / 17:11:39 / robert"
! !

!PVMTaskID methodsFor:'printing & storing'!

displayString
    "return a printed representation of the receiver for displaying"
    |w |

    w := (WriteStream on: String new).
    self printOn: w.
    ^w contents.
"

(PVMTaskID fromInteger: 4000404) inspect

"    
!

hexPrintString
    "print TaskID as HExNumber"

    ^(self doubleWordAt:1) hexPrintString
!

printOn: aStream
    "return a printed representation of the receiver for displaying"
    aStream nextPutAll: 'a ',self class name; cr.
    aStream nextPutAll:'TID     = ', ((self doubleWordAt:1) hexPrintString);cr.
    aStream nextPutAll:'  Group  = ', self group displayString;cr.
    aStream nextPutAll:'  HostID = ', self hostID displayString;cr.
    aStream nextPutAll:'  TaskID = ', self taskID displayString;cr.

"

PVMTaskID fromInteger: 16r40014

"


! !

!PVMTaskID methodsFor:'testing'!

testEqual
    "test ="

    | t2 |

    t2 := self copy.

    self = t2 ifTrue:[
	Transcript showCr: 'equal'.
    ] ifFalse:[
	Transcript showCr: 'not equal'.
    ].

    t2 := self class fromInteger: (-1).

    self = t2 ifTrue:[
	Transcript showCr: 'equal'.
    ] ifFalse:[
	Transcript showCr: 'not equal'.
    ].

    ^(self asInteger = 5)


"
    PVMTaskID new testEqual
"

    "Modified: 15.08.1995 / 17:37:56 / robert"
!

testIDVal
    | aTaskID |

    aTaskID := PVMTaskID fromInteger: -1.
%{
     printf ( "TaskID -1 = %d\n", taskIDVal( aTaskID )); 
%}.    
"
	PVMTaskID new testIDVal

"

!

testMinus1
    "tests right functioning of the special case -1"

    self inspect

"

    (PVMTaskID fromInteger: (-1)) testMinus1.


"
! !

