'From Smalltalk/X, Version:2.10.8 on 25-nov-1995 at 5:08:40 pm'                 !

Object subclass:#PVMTestServer
	 instanceVariableNames:'serverProcess aPVMInterface serverName instanceNumberOfPvmGroup'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'contrib-PVM-Support'
!

!PVMTestServer class methodsFor:'documentation'!

documentation
"
    This class is used to test and check the impelementation of PVmBasicInterface
    The Server answers reuests in a free defineable way.    
"
!

examples
"
    examples to be added.
"
!

history
    "Created: 30.08.1995 / 16:50:39 / robert"

    "Modified: 30.08.1995 / 16:50:40 / robert"
!

version
^ '$Header: /cvs/stx/stx/contrib/libPVM/PVMTestServer.st,v 1.2 1997/01/11 19:18:39 cg Exp $'! !

!PVMTestServer methodsFor:'accessing'!

serverProcess
    "return serverProcess"

    ^ serverProcess!

serverProcess:something
    "set serverProcess"

    serverProcess := something.! !

!PVMTestServer methodsFor:'client'!

clientTest
    "client porgram for PVM Server Test"

    | rc serverTaskID interface aTaskID taskName aString |

    "Register with Virtual Machine"
    serverName := 'pvmTestServer'.

    self initialize: serverName.
    aPVMInterface inspect.

    interface := aPVMInterface.     "temporary"

    "get the pvm-task-id of the server / broadcast a message and wait for an answer with timeout"
    aTaskID := interface pvmGetServerTIDinGroup: serverName.
    aTaskID inspect.   

    interface pvmPackInteger: (1234).
    interface pvmSend: aTaskID msgTag: (1234).   "the literal is free definable and my server knows what to answer :-)))"

    rc := interface pvmTimeoutRecv: aTaskID msgTag: (-1) timeOut: 10.
    rc ~= 0 ifFalse:[
	Transcript showCr: 'Nix angekommen innerhalb des Timeouts'
    ] ifTrue:[    
	aString := interface pvmUnpackString100.
	Transcript showCr: 'Answer from ServerTask => ID =',aString.
    ].        


    self release: serverName.

"


	PVMTestServer new clientTest

"

    "Modified: 30.08.1995 / 16:57:51 / robert"
! !

!PVMTestServer methodsFor:'initialization'!

initialize: aLightWeightProcessName
    "initialize the PVM Server Task"

    | aTaskID |

    aPVMInterface := PVMBasicInterface new addNewLightWeightProcess: aLightWeightProcessName.     


!

release: aProcessName
    "Terminates the PVM Server"

    aPVMInterface release: aProcessName.
! !

!PVMTestServer methodsFor:'server'!

getSendDataFor: typeCode
    "chooses data to send back to the requestor in respect of the requested datatype"
    | aClass data |

    "this is a special case"
    typeCode = 1234 ifTrue:[
	^self sendNameAndID.
    ].

    typeCode = 0 ifTrue:[
	"select default data for the answer"
	data := 'This is a String from the PVM ST/X Server'.
	"now pack the data into the pvm Sendbuffer"
	aPVMInterface pvmPackString: data.
	^self
    ].    

    aClass := aPVMInterface typeCodeMap at: typeCode.

    aClass == String ifTrue:[
	"select default data for the answer"
	data := 'This is a String from the PVM ST/X Server'.
	"now pack the data into the pvm Sendbuffer"
	aPVMInterface pvmPackString: data.
    ].

    aClass == ByteArray ifTrue:[
	data := ByteArray new: 20.
	data size do:[:i|
	    ByteArray at: i put: i asCharacter.
	].
	aPVMInterface packBytes: data.

    ].

    aClass == SmallInteger ifTrue:[
	data := 12345.
	aPVMInterface packInteger: data.

    ].

    aClass == Float ifTrue:[
	data := 1.5555.
	aPVMInterface packFloat: data.

    ].

"    aClass == LargeInteger ifTrue:["
"        data := 35000 asLargeInteger."
"        aPVMInterface packInteger: data."
"    ]."

    data isNil ifTrue:[
	self warn: 'type code could not be resolved: ', typeCode printString.
	data := 'type code could not be resolved: ', typeCode printString.
	aPVMInterface pvmPackString: data.
    ].

    ^aClass
!

sendNameAndID
    "Name request"
    | data |

    "this is a name-id request"
    data :=  aPVMInterface clientID hexPrintString, 'pvmTestServer'.
    aPVMInterface pvmPackString: data.

    ^data
!

serverBlock
    "PVM Server Task"

    | aBlock |
    " start server as a Task "
    aBlock := [
	| isThereABufferID  receiveBufferID rcArray typeCode  requestorID aTaskID |

	aTaskID := PVMTaskID fromInteger: -1.   "wildcard"
	aPVMInterface isNil ifTrue:[ Processor activeProcess terminate. ^self ].   
        
	[true] whileTrue:[
	    isThereABufferID := aPVMInterface pvmProbe: aTaskID msgTag: -1.
	    isThereABufferID ~= 0 ifTrue:[
		"now really receive the message"
		receiveBufferID := aPVMInterface pvmRecv: aTaskID msgTag: (-1).

		"unpack buffer (check what message type arrived"
		Transcript showCr: 'message arrived - unpacking'.

		"some sanity checks"
		isThereABufferID = receiveBufferID ifFalse:[
		    Transcript showCr: 'error? receivebufferID !!= bufferID from pvm_probe'.
		].

		rcArray := aPVMInterface pvmBufferInfo: receiveBufferID.

		Transcript showCr: 'BufferInfo: ', rcArray printString.

		"in the transcation ID (returned by bufferInfo is the typeCode of the requested Data"
		typeCode := rcArray at: 2.
		Transcript showCr: 'TypeCode received is ', typeCode printString.
		requestorID := rcArray at: 3.   "this is the originating pvm task"
		Transcript showCr: 'Originating ID is ', (requestorID hexPrintString).

"/                self getSendDataFor: typeCode.

"/                    Transcript show: 'sending data back to task 0x', requestorID hexPrintString.
"/                    aPVMInterface pvmSend: requestorID msgTag: typeCode.
	    ].
	    (Delay forSeconds: 2) wait.  "every x seconds look for a message"
	].
    ].


    ^aBlock
!

serverInit
    "initialize the PVM Server Task"

    Transcript showCr: 'Connecting to PVM'. 
    serverName := 'pvmTestServer'.

    aPVMInterface := PVMBasicInterface new addNewLightWeightProcess: serverName.

    " start server as a Smalltalk Task "
    aPVMInterface isNil ifFalse:[
	serverProcess := [
		[
		    self serverBlock value.
		] valueOnUnwindDo:[
		    Transcript  showCr: 'PVM Server releasing ...'.
		    self serverRelease
		].
	] forkAt: (Processor systemBackgroundPriority).
	serverProcess name: 'PVM Server'.
	serverProcess exitAction: [
	    Transcript  showCr: 'PVM Server is exiting'.
	].
    ].


    "

    | aPVMTestServer |    
    aPVMTestServer := PVMTestServer new.
    aPVMTestServer serverInit.
    InfoBox new title:'End PVM server';show.
    aPVMTestServer serverRelease.

    "
!

serverRelease
    "Terminates the PVM Server"

    serverProcess terminate.
    aPVMInterface release: serverName.
! !

