"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:22'                    !

Object subclass:#MORDGeneralApplicationObject
	instanceVariableNames:'actPA chgPA dbConnection'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDGeneralApp'
!

MORDGeneralApplicationObject class instanceVariableNames:'chgObj cachedAttrDefinitions'

"
 The following class instance variables are inherited by this class:

	Object - 
"
!

!MORDGeneralApplicationObject class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

! !

!MORDGeneralApplicationObject class methodsFor:'MORD-Attributes-Definition'!

abstractClass
  "^<Boolean> This class returns a boolean value to indicate that the class is an abstract class"

  ^true
!

allAttributesDefinition
  "^<OrderedCollection of: (Array | nil)> This method returns all defined persistence attributes
  of the receiver class. Subclasses should add their additional attributes to the collection.

  In Version 0.1 the columns have the following meaning:

  01: name of attribute. This string is the name of the attribute. With this name the
      system created the following methods:

	mord<Name>:    - this method sets the basic attribute, always overwritten
	mord<Name>     - this method gets the basic attribute, always overwritten
	<Name>:        - this method is the high-level setter of an attribute, not overwritten
	<Name>         - this method is the high-level getter of an attribute, not overwritten

      All these methods are stored within the category 'MORD-Attribute-Accessing' on the
      instance side of each class.

  02: notNil-Flag: true or false. This value is an indication, that the attribute should
      not be nil if the instance is going to be stored. In a relational sense this is
      equal to multiplicy of 0|1.

  03: default-Flag: value or nil. This value is the default value of the attribute when 
      initializing a new instance. Within the initialization routine you put deep copies
      of this object into the attribute.

  04: Limited content signature string. Please look for further details in the HTML-based
      documentation from IBM. You should get it with the MORD package.

  05: relation-Flag: true or false. This a boolean value indicating, that the attribute
      is a relation to a class specified by the signature

  06: remark. This is a string containing a description of the attribute

  07: persistence-flag: true or false. This flag indicates, that the attribute has to be
      stored in a database

  08: Domain Specification: This is the name of a String indicating the domain of the
      attribute if attribute is a basic attribute. This is different from the signature.
      Example: The domain 'BillNumber' may be managed by Strings or Integers.

  "

  ^OrderedCollection new 
     addAll: self ownAttributesDefinition ;
     yourself
!

mordDefaultAttributeDefinition: anArray
  "^<Object> This method returns the default value for the persistence attribute defined by
  anArray"

  ^anArray at: 3

!

ownAttributesDefinition
  "^<OrderedCollection of: (Array | nil)> This method returns all defined persistence attributes
  of the receiver class. Subclasses should add their additional attributes to the collection.

  In Version 0.1 the columns have the following meaning:

  01: name of attribute. This string is the name of the attribute. With this name the
      system created the following methods:

	mord<Name>:    - this method sets the basic attribute, always overwritten
	mord<Name>     - this method gets the basic attribute, always overwritten
	<Name>:        - this method is the high-level setter of an attribute, not overwritten
	<Name>         - this method is the high-level getter of an attribute, not overwritten

      All these methods are stored within the category 'MORD-Attribute-Accessing' on the
      instance side of each class.

  02: notNil-Flag: true or false. This value is an indication, that the attribute should
      not be nil if the instance is going to be stored. In a relational sense this is
      equal to multiplicy of 0|1.

  03: default-Flag: value or nil. This value is the default value of the attribute when 
      initializing a new instance. Within the initialization routine you put deep copies
      of this object into the attribute.

  04: Limited content signature string. Please look for further details in the HTML-based
      documentation from IBM. You should get it with the MORD package.

  05: relation-Flag: true or false. This a boolean value indicating, that the attribute
      is a relation to a class specified by the signature

  06: remark. This is a string containing a description of the attribute

  07: persistence-flag: true or false. This flag indicates, that the attribute has to be
      stored in a database

  08: Domain Specification: This is the name of a String indicating the domain of the
      attribute if attribute is a basic attribute. This is different from the signature.
      Example: The domain 'BillNumber' may be managed by Strings or Integers.

  "

  ^OrderedCollection new
! !

!MORDGeneralApplicationObject class methodsFor:'MORD-Instance-Creation'!

newWithDefaultValues

  ^self new mordSetDefaultValues
! !

!MORDGeneralApplicationObject methodsFor:'MORD-Attributes-Private'!

attribute: anInteger
 "^<Object> This method returns the value of the attribute indexed by anInteger"

  ^actPA at: anInteger
!

attribute: anInteger value: anObject
 "This method sets the state of an internal attribute index by anInteger to anObject"

  | oldValue |

  (oldValue := actPA at: anInteger) ~= anObject ifTrue:[
    (chgPA at: anInteger) isNil ifTrue:[ chgPA at: anInteger put: oldValue].
    actPA at: anInteger put: anObject
   ]
! !

!MORDGeneralApplicationObject methodsFor:'MORD-Initialize'!

mordSetDefaultValues
  "This method initializes the new instance with all default values using the attributes definition"

  | attributesDefinition |

  attributesDefinition := self class allAttributesDefinition.
  self actPA: (Array new: attributesDefinition size).
  self chgPA: (Array new: attributesDefinition size).

  1 to: attributesDefinition size do: [ :index |
    self actPA at: index put: (self class mordDefaultAttributeDefinition: (attributesDefinition at: index))
  ]
! !

!MORDGeneralApplicationObject methodsFor:'MORD-Services'!

mordSave
  "^<OrderedCollection of: MORDGeneralSQLStatements> This method saves the content of the 
  receiver into a database via the database handler stored in instance variable 
  dbConnection - which must be a valid connection"

  | sqlStatements |

  sqlStatements := OrderedCollection new.

  1 to: chgPA size do: [ :index |

  ].

  sqlStatements notEmpty ifTrue:[ self dbConnection multipleStatementExecute: sqlStatements ].
  ^sqlStatements

!

mordSaveIn: aMordGeneralDatabaseDescription
  "^<Boolean> This method saves the receiver in  a database described via aMordGeneralDatabaseDescription"

  | validDatabaseConnection |

  (validDatabaseConnection := aMordGeneralDatabaseDescription validConnections) isEmpty ifTrue:[ ^ false ].

  self dbConnection isNil 
    ifTrue:[    self dbConnection: validDatabaseConnection first ].

  ^self mordSave

!

mordSaveVia: aMordGeneralConnection
  "^<Boolean> This method saves the receiver in  a database described via aMordGeneralDatabaseDescription"

  self dbConnection isNil 
    ifTrue:[    self dbConnection: aMordGeneralConnection ].

  ^self mordSave

! !

!MORDGeneralApplicationObject methodsFor:'MORD-Testing'!

toBeSaved
  "^<Boolean> This method returns true, if the content of any persistent attribut has been changed"

  ^(chgPA detect: [ :each | each notNil ] ifNone: [ nil ]) notNil
! !

!MORDGeneralApplicationObject methodsFor:'MORD-Transaction-Services'!

mordRollback
  "I do a rollback on the object side - I set all the attributes to the original value"

  1 to: actPA size do: [ :index | actPA at: index  put: (chgPA at: index) ].
  chgPA := Array new: actPA size 
! !

!MORDGeneralApplicationObject methodsFor:'accessing'!

actPA
    "return the value of the instance variable 'actPA' (automatically generated)"

    ^ actPA!

actPA:something
    "set the value of the instance variable 'actPA' (automatically generated)"

    actPA := something.!

chgPA
    "return the value of the instance variable 'chgPA' (automatically generated)"

    ^ chgPA!

chgPA:something
    "set the value of the instance variable 'chgPA' (automatically generated)"

    chgPA := something.!

dbConnection
    "return the value of the instance variable 'dbConnection' (automatically generated)"

    ^ dbConnection!

dbConnection:something
    "set the value of the instance variable 'dbConnection' (automatically generated)"

    dbConnection := something.! !

!MORDGeneralApplicationObject class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDGeneralApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:22'                    !

Object subclass:#MORDGeneralDatabaseDescription
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDGeneralApp'
!

!MORDGeneralDatabaseDescription class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

! !

!MORDGeneralDatabaseDescription class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDGeneralApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:22'                    !

MORDGeneralDatabaseDescription subclass:#MORDMapDbDescStratA
	instanceVariableNames:'dbHandler connInfo connections'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDGeneralApp'
!

!MORDMapDbDescStratA class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

! !

!MORDMapDbDescStratA methodsFor:'accessing'!

connInfo
    "return the value of the instance variable 'connInfo' (automatically generated)"

    ^ connInfo!

connInfo:something
    "set the value of the instance variable 'connInfo' (automatically generated)"

    connInfo := something.!

connections
    "return the value of the instance variable 'connections' (automatically generated)"

    ^ connections!

connections:something
    "set the value of the instance variable 'connections' (automatically generated)"

    connections := something.!

dbHandler
    "return the value of the instance variable 'dbHandler' (automatically generated)"

    ^ dbHandler!

dbHandler:something
    "set the value of the instance variable 'dbHandler' (automatically generated)"

    dbHandler := something.! !

!MORDMapDbDescStratA class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDGeneralApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:22'                    !

Object subclass:#MORDGeneralSQLStatement
	instanceVariableNames:'statementResult statementString dbHandler'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDGeneralApp'
!

!MORDGeneralSQLStatement class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

!

documentation
"
    This class is an abstract superclass. Each database should have its own
    subclass.

    [author:]
	 (marten@feki)

    [see also:]

    [instance variables:]

    [class variables:]
"
!

examples
"
    examples to be added.
								[exBegin]
    ... add code fragment for 
    ... executable example here ...
								[exEnd]
"
!

history
    "Created: / 13.8.1999 / 21:03:17 / marten"
! !

!MORDGeneralSQLStatement methodsFor:'MORD-Execution'!

execute
  "This method executes the statement"

  self dbHandler notNil ifTrue:[ self dbHandler sqlStatementExecute: self ]

! !

!MORDGeneralSQLStatement methodsFor:'accessing'!

dbHandler
    "return the value of the instance variable 'dbHandler' (automatically generated)"

    ^ dbHandler!

dbHandler:something
    "set the value of the instance variable 'dbHandler' (automatically generated)"

    dbHandler := something.!

statementResult
    "return the value of the instance variable 'statementResult' (automatically generated)"

    ^ statementResult!

statementResult:something
    "set the value of the instance variable 'statementResult' (automatically generated)"

    statementResult := something.!

statementString
    "return the value of the instance variable 'statementString' (automatically generated)"

    ^ statementString!

statementString:something
    "set the value of the instance variable 'statementString' (automatically generated)"

    statementString := something.! !

!MORDGeneralSQLStatement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDGeneralApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:23'                    !

Object subclass:#MORDGeneralRowResult
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDGeneralApp'
!

!MORDGeneralRowResult class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

!

documentation
"
    documentation to be added.

    [author:]
	 (marten@feki)

    [see also:]

    [instance variables:]

    [class variables:]
"
!

examples
"
    examples to be added.
								[exBegin]
    ... add code fragment for 
    ... executable example here ...
								[exEnd]
"
!

history
    "Created: / 13.8.1999 / 21:10:55 / marten"
! !

!MORDGeneralRowResult class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDGeneralApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:23'                    !

Object subclass:#MORDGeneralConnectionInfo
	instanceVariableNames:'information'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDGeneralApp'
!

!MORDGeneralConnectionInfo class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

!

documentation
"
    This class is the abstract superclass of all following subclasses. The classes
    should contain all needed informations how to logon to a database.

    Therefore these classes should be used in conjunction with MORDGeneralConnection
    and MORDGeneralSQLHandler.

    [author:]
	 (marten@feki)

    [see also:]

    [instance variables:]

    [class variables:]
"
!

examples
"
    examples to be added.
								[exBegin]
    ... add code fragment for 
    ... executable example here ...
								[exEnd]
"
!

history
    "Created: / 2.8.1999 / 19:18:48 / marten"
! !

!MORDGeneralConnectionInfo methodsFor:'accessing'!

information
    "return the value of the instance variable 'information' (automatically generated)"

    information isNil ifTrue:[ information := Dictionary new ].
    ^ information
!

information:something
    "set the value of the instance variable 'information' (automatically generated)"

    information := something.! !

!MORDGeneralConnectionInfo class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDGeneralApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:23'                    !

Object subclass:#MORDGeneralResult
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDGeneralApp'
!

!MORDGeneralResult class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

!

documentation
"
    documentation to be added.

    [author:]
	 (marten@feki)

    [see also:]

    [instance variables:]

    [class variables:]
"
!

examples
"
    examples to be added.
								[exBegin]
    ... add code fragment for 
    ... executable example here ...
								[exEnd]
"
!

history
    "Created: / 13.8.1999 / 21:02:06 / marten"
! !

!MORDGeneralResult class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDGeneralApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:23'                    !

Object subclass:#MORDGeneralSQLHandler
	instanceVariableNames:'database inTransaction inAggregationState pendingStatements
		transactionCache objectCache asyncProcess'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDGeneralApp'
!

MORDGeneralSQLHandler class instanceVariableNames:'openHandlers'

"
 The following class instance variables are inherited by this class:

	Object - 
"
!

!MORDGeneralSQLHandler class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

!

documentation
"
    This class is the general superclass of all special subclasss for each type
    of database.

    [author:]
	 (marten@feki)

    [see also:]

    [instance variables:]

    [class variables:]
"
!

examples
"
    examples to be added.
								[exBegin]
    ... add code fragment for 
    ... executable example here ...
								[exEnd]
"
!

history
    "Created: / 13.8.1999 / 21:10:57 / marten"
! !

!MORDGeneralSQLHandler class methodsFor:'initialization'!

initialize
  "self initialize. self allSubclasses do: [ :each | each initialize ]"
  super initialize.
  openHandlers :=  Registry new
! !

!MORDGeneralSQLHandler class methodsFor:'MORD-Accessing'!

openHandlers

  openHandlers isNil ifTrue:[ self initialize ].
  ^openHandlers
! !

!MORDGeneralSQLHandler methodsFor:'MORD-Aggregation-Management'!

clearAggregationState

  self inAggregationState: false
!

clearPendingStatements
  "I delete all waiting statements"

  self pendingStatements: SharedQueue new.
!

flushPendingStatements  
  "I throw all statements away ..."

  self clearPendingStatements


!

setAggregationState

  self inAggregationState: true
! !

!MORDGeneralSQLHandler methodsFor:'MORD-Async-Subsystem'!

addAllStatements: collectionOfMORDGeneralSQLStatements

  self pendingStatements nextPutAll: collectionOfMORDGeneralSQLStatements
!

addStatement: aMORDGeneralSQLStatement

  self pendingStatements nextPut: aMORDGeneralSQLStatement
!

asyncStatementsAvailable
  "^<Boolean> I return true if there are still commands in the asynchronous queue"

  ^self pendingStatements notEmpty


!

collectCommands
  "^<OrderedCollection of: MORDGeneralSQLStatement>"

  | sqlStatementCollection nextStatement actualStatementSize |

  sqlStatementCollection := OrderedCollection new.
  actualStatementSize := 0.

  nextStatement := self pendingStatements next.

  sqlStatementCollection := OrderedCollection new.
  sqlStatementCollection add: nextStatement.
  actualStatementSize := nextStatement statementString size + 1.

  [ self pendingStatements notEmpty
      and:[  (actualStatementSize + self pendingStatements peek statementString size + 1) <= self class maxQueryLength ]
  ] whileTrue:[
    nextStatement := self pendingStatements next.
    sqlStatementCollection add: nextStatement.
    actualStatementSize := actualStatementSize + nextStatement statementString size + 1
  ].
  ^sqlStatementCollection

!

createCommandString: sqlStatementCollection
  "^<String> I create a total sql command string based on all statements in sqlStatementCollection"

  |  commandStream maxSize  |

  maxSize := sqlStatementCollection inject: 0 into: [ :totSize :sqlStatements | totSize + sqlStatements size + 1 ].

  commandStream := WriteStream on: (String new: maxSize).
  sqlStatementCollection do: [ :eachCommand |
    commandStream 
      nextPutAll: eachCommand statementString ;
      nextPut: $;
  ].

  ^commandStream contents
!

startSubProcess
  "This method starts the background asynchronous command executer process"

  self asyncProcess: 
    [  |  sqlCommands  |
     [ true ] whileTrue:[
       (sqlCommands := self collectCommands) notEmpty ifTrue:[
	  self
	    statementAsyncExecute: (self createCommandString: sqlCommands)
	    statements: sqlCommands
       ]
     ]
    ] newProcess.

   self asyncProcess 
     name: 'dbhandler async process' ;
     resume

!

stopSubProcess


  self asyncProcess notNil ifTrue:[

    self asyncProcess terminate.
    self asyncProcess: nil

  ]

! !

!MORDGeneralSQLHandler methodsFor:'MORD-Cache-Management'!

addObjectsToTransactionCache: collectionOfObjects
  "I add all objects in collectionOfObjects to the transaction cache to remember these objects when the transaction is over"

  collectionOfObjects do: [ :eachObject |
    (self transactionCache at: eachObject class ifAbsentPut: [ Dictionary new ])
      at: eachObject oid
      put: eachObject
  ]
! !

!MORDGeneralSQLHandler methodsFor:'MORD-Communication-High-Level'!

connect
  "This method tries to create a new database connection with all default 
  connection parameters - the database library will ask various environment 
  variables or default settings"

  self connect: nil

!

disconnect
  "This method disconnects from the database"

  self connection notNil ifTrue:[
    self nativeDisconnect .
    self connection: nil.
    self stopSubProcess ]

!

newSQLStatement: aString
  "^<hOf MORDGeneralSQLStatement> This method returns a new statement connected to a database handler
  and filled with a new sql statement aString"

  ^(self class defaultStatementClass newSQLStatement: aString)
     dbHandler: self ;
     yourself
!

newSQLStatementExecute: aString
  "^<MORDGeneralSQLStatement> This method creates a new statement connected to a database handler
  and filled with a new sql statement aString and executes it at once"

  ^(self newSQLStatement: aString)
     execute ;
     yourself
!

sqlStatementExecute: aMORDPostgreSQLStatement
  "This method executes a postgre sql statement and collection the results into aMORDPostgreSQLStatement"

  | executedStatements |

  (aMORDPostgreSQLStatement asyncExecution
    ifTrue:[
      executedStatements := self statementAsyncExecute: aMORDPostgreSQLStatement statementString statements: (OrderedCollection with: aMORDPostgreSQLStatement).
      aMORDPostgreSQLStatement statementResult: executedStatements first statementResult.
    ]
    ifFalse:[ 
      aMORDPostgreSQLStatement statementResult: (self statementExecute: aMORDPostgreSQLStatement statementString) ]).





















! !

!MORDGeneralSQLHandler methodsFor:'MORD-Communication-Low-Level'!

statementAsyncExecute: statementString
  "^<OrderedCollection of: MORDPostgreSQLResult> This method executes the statement asynchronous and 
  waits for all results returned by the backend"

  self subclassResponsibility


!

statementExecute: aString
  "^<MORDPostgreSQLResult> This method executes an SQL command contained in aString. The
  command is execute synchronous - therefore this method returns when the backend returns
  the result."


  self subclassResponsibility


! !

!MORDGeneralSQLHandler methodsFor:'MORD-Database-Transaction-Services'!

abortTransaction
  "This method aborts a transaction"


  self clearPendingStatements.
  (self newSQLStatementExecute: 'ABORT') commandSuccessfull 
    ifTrue:[ self inTransaction:  false ]. 





!

autoTransaction
  "^<Boolean>"

  ^true





!

beginTransaction
  "This method starts a transaction"

  self inTransaction: ((self newSQLStatementExecute: 'BEGIN') commandSuccessfull )





!

commitTransaction
  "This method commits a transaction"

  self flushPendingStatements.
  (self newSQLStatementExecute: 'COMMIT') commandSuccessfull 
    ifTrue:[ self inTransaction:  false ]. 




!

executeSQLStringWithTransaction: sqlString
  "This method executes the statement within a transaction"

  self inTransaction ifTrue:[ self commitTransaction ].
  self autoTransaction 
    ifTrue:[  self newSQLStatementExecute: sqlString ]
    ifFalse:[ 
      self beginTransaction.  
      self newSQLStatementExecute: sqlString.
      self commitTransaction ]





!

executeStatementsWithinTransaction: collectionOfStatements
  "This method commits a transaction"






! !

!MORDGeneralSQLHandler methodsFor:'MORD-Datatype Conversion'!

dateToISO8601String: aDate
  "^<String> This method converts the value of aDate to a string usuable for SQL statements"

  ^aDate printFormat: 
     (Array
       with: 3
       with: 2
       with: 1
       with: $- 
       with: 1
       with: 1
       with: true)






!

dateToString: aDate
  "^<String> This method converts the value of aString to a string usuable for SQL statements"

  ^self stringToString: (self dateToISO8601String: aDate)














!

doubleToString: aFloat
  "^<String> This method returns the ascii representation of aFloat usuable for any SQL statement"

  ^aFloat printString


!

floatToString: aFloat
  "^<Integer> This method returns a float in single precision data format from a string representation"

  ^self doubleToString: aFloat














!

integerToString: anInteger
  "^<String> This method returns the ascii representation of anInteger usuable for any SQL statement"

  ^anInteger printString













!

stringToString: aString
  "^<String> This method converts the value of aString to a string usuable for SQL statements"

  ^'''',aString,''''














!

timeToISO8601String: aString
  "^<Date> This method returns a string from a time"

  ^aString printString24HourFormat














!

timeToString: aString
  "^<Date> This method returns a string from a time"

  ^self stringToString: (self timeToISO8601String: aString)














!

timestampToISO8601String: aTimestamp
  "^<String> This method returns a string from a timestamp representation"

  ^(self dateToISO8601String: aTimestamp asDate),' ',(self timeToISO8601String: aTimestamp asTime)














! !

!MORDGeneralSQLHandler methodsFor:'MORD-Testing'!

isConnected
  "^<Boolean> I return true if the connection to the database is still valid"

  self subclassResponsibility
!

validConnection
  "^<Boolean> I return true if the connection to the database is still valid"

  self subclassResponsibility
! !

!MORDGeneralSQLHandler methodsFor:'accessing'!

asyncProcess
    "return the value of the instance variable 'asyncProcess' (automatically generated)"

    ^ asyncProcess!

asyncProcess:something
    "set the value of the instance variable 'asyncProcess' (automatically generated)"

    asyncProcess := something.!

database
    "return the value of the instance variable 'database' (automatically generated)"

    ^ database!

database:something
    "set the value of the instance variable 'database' (automatically generated)"

    database := something.!

inAggregationState
    "return the value of the instance variable 'inAggregationState' (automatically generated)"

    ^ inAggregationState!

inAggregationState:something
    "set the value of the instance variable 'inAggregationState' (automatically generated)"

    inAggregationState := something.!

inTransaction
    "return the value of the instance variable 'inTransaction' (automatically generated)"

    ^ inTransaction!

inTransaction:something
    "set the value of the instance variable 'inTransaction' (automatically generated)"

    inTransaction := something.!

objectCache
    "return the value of the instance variable 'objectCache' (automatically generated)"

    ^ objectCache!

objectCache:something
    "set the value of the instance variable 'objectCache' (automatically generated)"

    objectCache := something.!

pendingStatements
    "return the value of the instance variable 'pendingStatements' (automatically generated)"

    ^ pendingStatements!

pendingStatements:something
    "set the value of the instance variable 'pendingStatements' (automatically generated)"

    pendingStatements := something.!

transactionCache
    "return the value of the instance variable 'transactionCache' (automatically generated)"

    ^ transactionCache!

transactionCache:something
    "set the value of the instance variable 'transactionCache' (automatically generated)"

    transactionCache := something.! !

!MORDGeneralSQLHandler methodsFor:'initialization'!

initialize

  self inTransaction: false.
  self inAggregationState: false.
  self clearPendingStatements.
  self startSubProcess
! !

!MORDGeneralSQLHandler class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDGeneralApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

MORDGeneralSQLHandler initialize!
