"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"

'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:25'                    !

MORDGeneralSQLHandler subclass:#MORDPostgreSQLHandler
	instanceVariableNames:'connection readyForNewCommand'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDPostgreSQLApp'
!

!MORDPostgreSQLHandler class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"
!

documentation
"
    This class is mainly an interface to the C-based library 'libpq' as described in the
    'PostgreSQL ProgrammersGuide' on page 117 to 137.

    The handler-class is the connection between your application and the database. Within
    this class all specific database methods are defined.

    Please notice, that not all features are supported or tested and please notice, that
    the current developer release will be changed in the future - it's not stable in that
    sense, that the methods or the class structure will not change. This will happen !!

    ** Date/Timestyle:

    The PostgresSQL handler is written to handle ISO-based date and time inputs and output 
    only.

    ** Synchronous and Asynchronous execution of statements:

    For each new database handler (or connection) we have an asynchronous process, which
    executes statements in a special queue in the background. With this possibility you
    may be better able to handle execution between server and client. You may consider the
    first results from the server - even if other results from the database are still missing.

    But asynchronous execution is dangerous !!!!!! So be very careful with it !!

   [author:]
	 (marten@toppoint.de)

"
!

examples
"
    Within all examples its assumed, that the sqlHandler has a valid connection

								[exBegin]
    // How to execute a statement

    // Alternative 1
    | sqlStatement sqlhandler |
    ...
    sqlStatement := sqlHandler sqlStringExecute: SELECT NAME,AGE FROM TESTTABLE.
    sqlStatement commandSuccessfull
      ifTrue:[


      ].

    // Alternative 2
    | sqlStatement sqlhandler |
    ...
    sqlStatement := sqlHandler newSQLStatement: SELECT NAME,AGE FROM TESTTABLE.
    sqlStatement execute.
    sqlStatement commandSuccessfull
      ifTrue:[

      ]

								[exEnd]
"
!

history
"Created: / 2.8.1999 / 19:23:10 / marten

19-08-99
  Following statements may be used. They're covered by the tests and they seem to do their
  work:

  Instance-Side
	connect, connect:, disconnect, sqlStatementExecute, sqlStringExecute:
	isConnected, validConnection

  Class-Side
	connect:

  With these methods you can do all the database work you would like to do. You can execute
  any SQL statement and return any results ...
"
! !

!MORDPostgreSQLHandler class methodsFor:'MORD-Constants'!

defaultConnectionInfoClass
  "^<MORDPostgreSQLConnectionInfo> This method returns the class handling the
  information needed to connect to the database"

  ^MORDPostgreSQLConnectionInfo
!

defaultResultClass
  "^<MORDPostgreSQLResult> This method returns the class handling the connection info ..."

  ^MORDPostgreSQLResult
!

defaultStatementClass
  "^<MORDPostgreSQLStatement> This method returns the class handling
  the sql statement execution and the result handling"

  ^MORDPostgreSQLStatement
!

maxQueryLength
  "^<Integer> I return the maximum size of a query string"

  ^8190
! !

!MORDPostgreSQLHandler class methodsFor:'MORD-Database-Management-Services'!

createDatabase: newDBName location: pathStringOrNil withInfo: aMORDPostgreSQLConnectionInfoOrNil
  "^<Boolean> This method creates a temporary connection to a database and creates through
  this connection a new database with name newDBName"

  | sqlHandler newStatement result stream |

  sqlHandler := self connect: aMORDPostgreSQLConnectionInfoOrNil.
  sqlHandler isConnected ifFalse:[ ^false].

  stream := WriteStream on: String new.
  stream
    nextPutAll: 'CREATE DATABASE ' ;
    nextPutAll: newDBName.

  pathStringOrNil notNil ifTrue:[
    stream
      nextPutAll: ' WITH LOCATION = ' ;
      nextPutAll: pathStringOrNil.

  ].

  newStatement := sqlHandler newSQLStatementExecute: stream contents.
  result := newStatement commandSuccessfull.

  sqlHandler disconnect.
  ^result

!

dropDatabase: aDBName withInfo: aMORDPostgreSQLConnectionInfoOrNil
  "^<Boolean> This method creates a temporary connection to a database and drops through
  this connection an old database with name aDBName"

  | sqlHandler newStatement result stream |

  sqlHandler := self connect: aMORDPostgreSQLConnectionInfoOrNil.
  sqlHandler isConnected ifFalse:[ ^false].

  stream := WriteStream on: String new.
  stream
    nextPutAll: 'DROP DATABASE ' ;
    nextPutAll: aDBName.

  newStatement := sqlHandler newSQLStatementExecute: stream contents.
  result := newStatement commandSuccessfull.

  sqlHandler disconnect.
  ^result

! !

!MORDPostgreSQLHandler class methodsFor:'MORD-Domain-Description'!

baseDomainDefinition
 "^<Array of: Array> This method returns all base domain definition this database type does understand. Each different
 database handler subclass should have its own base definitions"


 ^(Array new: 14)
     at:  1 put: (Array with: 'VarString' with: 'VARCHAR' with: true with: false with:1 with: 1 with: 4) ;
     at:  2 put: (Array with: 'SmallInteger' with: 'INT2' with: false with: false with: 0 with: 2 with: 0) ;
     at:  3 put: (Array with: 'Integer' with: 'INT4' with: false with: false with: 0 with: 4 with: 0) ;
     at:  4 put: (Array with: 'LargeInteger' with: 'INT8' with: false with: false with: 0 with: 8 with: 0) ;
     at:  5 put: (Array with: 'Float' with: 'FLOAT4' with: false with: false with: 0  with: 4 with: 0) ;
     at:  6 put: (Array with: 'Double' with: 'FLOAT8' with: false with: false with: 0  with: 8 with: 0) ;
     at:  7 put: (Array with: 'Text' with: 'TEXT' with: false with: false with: 1 with: 1 with: 4) ;
     at:  8 put: (Array with: 'Char' with: 'CHAR' with: false with: false with: 0 with: 1 with: 0) ;
     at:  9 put: (Array with: 'Timestamp' with: 'TIMESTAMP' with: false with: false with: 0 with: 4 with: 0) ;
     at: 10 put: (Array with: 'Time' with: 'TIME' with: false with: false with: 0 with: 4 with: 0) ;
     at: 11 put: (Array with: 'Serial' with: 'SERIAL' with: false with: false with: 0 with: 4 with: 0) ;
     at: 12 put: (Array with: 'Date' with: 'DATE' with: false with: false with: 0 with: 4 with: 0) ;
     at: 13 put: (Array with: 'FixChar' with: 'CHAR' with: true with: false with: 0 with: 1 with: 4) ;
     at: 14 put: (Array with: 'Boolean' with: 'bool' with: false with: false with: 0 with: 1 with: 0) ;
     yourself
! !

!MORDPostgreSQLHandler class methodsFor:'MORD-Domain-Description-Accessing'!

baseDefinition: anArray

 ^anArray at: 2
!

foundBaseDefinition: aString

  ^self baseDomainDefinition 
    detect: [ :each | (each at: 1) = aString ]
    ifNone: [ nil ]


!

postLengthNeeded: anArray

 ^anArray at: 4
!

totalLengthNeeded: anArray

 ^anArray at: 3
! !

!MORDPostgreSQLHandler class methodsFor:'MORD-Instance Creation'!

connect: aMORDPostgreSQLConnectionInfoOrNil
  "^<MORDPostgreSQLHandler> I create a new instance of the receiver class and connect to a database
  described by aMORDPostgreSQLConnectionInfoOrNil. If aMORDPostgreSQLConnectionInfoOrNil is nil, then
  then default logon defintion will be used by the postgresql subsystem - normally some environment
  variable contents
  "

  | anInstance |

  anInstance := self new.
  anInstance
    initialize ;
    connect: aMORDPostgreSQLConnectionInfoOrNil.

  self openHandlers register: anInstance.

  ^anInstance
! !

!MORDPostgreSQLHandler class methodsFor:'Private'!

createDatabase: newDBName dbName: dbName user: username password: password host: hostName

  ^self 
     createDatabase: newDBName 
     location: nil 
     dbName: dbName 
     user: username  
     password: password 
     host: hostName


!

createDatabase: newDBName location: path dbName: dbName user: username password: password host: hostName

  | connectionInfo |

  connectionInfo := self defaultConnectionInfoClass new.

  connectionInfo
    dbName: dbName ;
    host: hostName ;
    password: password ;
    user: username.

  ^self 
     createDatabase: newDBName location: path withInfo: connectionInfo


!

waitForResults: sqlStatements
  "This statement returns, when all results of sqlStatements are available"

  sqlStatements do:[ :eachSQLStatement | eachSQLStatement statementResult ].
! !

!MORDPostgreSQLHandler methodsFor:'MORD-Accessing'!

backendPID
  "^<Integer> This method returns the process id of the backend on the database server.
  If this information is not available I return 0 (zero)"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection)) {
    RETURN( __MKINT(PQbackendPID( __externalAddressVal(__INST(connection)))))
  }
  else
    RETURN( __MKINT(0));
%}.

!

connection
    "^<ExternalAddress | nil> This method returns the external address instance holding the 
    pointer to the connection structure. Otherwise it returns nil"

    ^ connection
!

connection:something
    "set the value of the instance variable 'connection' (automatically generated)"

    connection := something.!

dbName
 "^<String> I return the name of the database I'm connected to. If the information is not
 available I return an empty string"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection))
  {
    RETURN( __MKSTRING( PQdb(  __externalAddressVal(__INST(connection)))));
  }
  else
    RETURN( __MKSTRING(""));
%}.


!

errorMessage
    "^<String>"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection)) {
    RETURN(__MKSTRING(PQerrorMessage(  __externalAddressVal(__INST(connection)))))
  }
  else
    RETURN(__MKSTRING(""));
%}.



!

host
  "^<String> This method returns the name of the host the database is located.
  If this information is not available I return an empty string"

%{
  #include "libpq-fe.h"

  if __isExternalAddress(  __INST(connection)) {
    RETURN( __MKSTRING( PQhost(  __externalAddressVal(__INST(connection)))))
  }
  else
    RETURN(__MKSTRING(""));
%}


!

password
 "^<String> I return the password used for connection to the database. If this 
 information is not available I return an empty string"

%{
  #include "libpq-fe.h"

  if __isExternalAddress(  __INST(connection)) {
    RETURN( __MKSTRING( PQpass(  __externalAddressVal(__INST(connection)))))
  }
  else
    RETURN( __MKSTRING(""))
%}


!

port
  "^<Integer> I return the port number of the remote database server, the backend is 
  running at. If this information is not avaiable I return 0 (zero)"

%{
  #include "libpq-fe.h"

  if __isExternalAddress(  __INST(connection))
  {
    RETURN(__MKINT(PQport(  __externalAddressVal( __INST(connection)))));
  }
  else
    RETURN(__MKINT(0));
%}.

!

readyForNewCommand
    "return the value of the instance variable 'readyForNewCommand' (automatically generated)"

    ^ readyForNewCommand!

readyForNewCommand:something
    "set the value of the instance variable 'readyForNewCommand' (automatically generated)"

    readyForNewCommand := something.!

statusMessage
  "^<String> This method returns a status message about the connection ..."

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection)) {
    RETURN( __MKSTRING( PQresStatus( PQstatus(  __externalAddressVal(__INST(connection))))))
  }
  RETURN( __MKSTRING(""));
%}.

! !

!MORDPostgreSQLHandler methodsFor:'MORD-Communication-High-Level'!

connect: aMORDPostgreSQLConnectionInfoOrNil
  "This method tries to create a new connection to the backend database server"

  self connection:
    (aMORDPostgreSQLConnectionInfoOrNil isNil
      ifTrue:[  self nativeConnect: String new ]
      ifFalse:[ self nativeConnect: aMORDPostgreSQLConnectionInfoOrNil createConnectionString ])

 
!

multipleStatementExecute: collectionOfMORDPostgreSQLStatement
  "^<OrderedCollection of: MORDPostgreSQLStatement> This method executes several 
   SQL statements in ONE transfer to the backend. The results for the different
   statements are separated and returned in the statements itself. This method
   returns when all results are collected from the backend. The active process
   may be supended and resumed until all results are received. Therefore it 
   may be a good idea - if needed - to do a fork around this method call

  Actually nothing is done - only the method is defined and the statements are executed -
  but that's all

  "


  collectionOfMORDPostgreSQLStatement do: [ :eachStatement | self sqlStatementExecute: eachStatement ].
  ^collectionOfMORDPostgreSQLStatement















! !

!MORDPostgreSQLHandler methodsFor:'MORD-Communication-Low-Level'!

cancelRequest
  "^<Boolean> This method cancels the last sql command"

  self validConnection ifTrue:[ self requestCancel ]
!

statementAsyncExecute: statementString statements: statements
  "^<OrderedCollection of: MORDGeneralSQLStatement> This method executes all statements 
  asynchronously. The statementString is the over-all sql-statement string created out
  of all statements. The method fetches all results for this single statement and put
  all the results to the belonging statement"

  | externalAddress index continue  |

  self readyForNewCommand wait.
  index := 0.
  continue := true.
  self lowLevelAsynchronousStatementExecute: statementString.
      [ continue := continue and: [ self isConnected] ] whileTrue: [
	self isBusy ifTrue:[ self waitForData.self consumeInput. ].
	self isBusy
	  ifFalse:[ 
	    (externalAddress := self lowLevelGetSingleSQLResult) notNil 
	      ifTrue:[
		(index := index + 1) <= statements size ifTrue:[
		  (statements at: index)
		     statementResult:
		       (self class defaultResultClass newResult
			  resultHandle: externalAddress ;
			  yourself).
		].
	      ]
	      ifFalse:[
		continue := false
	      ]
	   ].
      ].
  self readyForNewCommand signal.
  ^statements
!

statementExecute: aString
  "^<MORDPostgreSQLResult> This method executes an SQL command contained in aString. The
  command is execute synchronous - therefore this method returns when the backend returns
  the result."

  | externalAddress |

  ^self isConnected 
    ifTrue:[
      self readyForNewCommand wait.
      externalAddress := self lowLevelSynchronStatementExecute: aString.
      self readyForNewCommand signal.
      externalAddress isNil
	ifTrue:[    
	  self class defaultResultClass fatalErrorResult ]
	ifFalse:[   
	  self class defaultResultClass newResult
	    resultHandle: externalAddress].
      ]
    ifFalse:[ self class defaultResultClass fatalErrorResult ].
! !

!MORDPostgreSQLHandler methodsFor:'MORD-Configuration-Services'!

setISO8601DateAndTimeStyle
  "^<Boolean> This method sets the date/time input/output format to the  ISO-Standard"

  ^(self newSQLStatementExecute: 'SET DateStyle TO ''ISO''') commandSuccessfull
! !

!MORDPostgreSQLHandler methodsFor:'MORD-Database-Management-Services'!

createIndexFromDefinition: aDBDescription
  "This method creates all tables needed in a database described by aDBDescription"

  | firstColumn tableDescription columnDescription indexDescription sqlCommandStream columnDescriptions dbDomainDescription baseDomainDescription |

 tableDescription := aDBDescription class mordTableDefinition.
 columnDescription := aDBDescription class mordColumnDefinition.
 indexDescription :=  aDBDescription class mordIndexDefinition.

 1 to: tableDescription size do: [ :tableIndex |

   sqlCommandStream := WriteStream on: String new.
   sqlCommandStream
     nextPutAll: 'CREATE TABLE ' ;
     nextPutAll: (aDBDescription class tableName: (tableDescription at: tableIndex)) ;
     nextPutAll: ' ('.

   columnDescriptions := OrderedCollection new.
   columnDescriptions addAll: 
     (columnDescription select: [ :eachArray | (aDBDescription class tableIndex: eachArray) = tableIndex ]).

   firstColumn := true.

   Transcript cr ; show: sqlCommandStream contents.

 ]



!

createTablesFromDefinition: aDBDescription
  "This method creates all tables needed in a database described by aDBDescription"

  | firstColumn tableDescription columnDescription sqlCommandStream columnDescriptions dbDomainDescription baseDomainDescription |

 tableDescription := aDBDescription class mordTableDefinition.
 columnDescription := aDBDescription class mordColumnDefinition.
 dbDomainDescription :=  aDBDescription class mordDomainDefinition.
 baseDomainDescription := self class baseDomainDefinition.

 1 to: tableDescription size do: [ :tableIndex |

   sqlCommandStream := WriteStream on: String new.
   sqlCommandStream
     nextPutAll: 'CREATE TABLE ' ;
     nextPutAll: (aDBDescription class tableName: (tableDescription at: tableIndex)) ;
     nextPutAll: ' ('.

   columnDescriptions := OrderedCollection new.
   columnDescriptions addAll: 
     (columnDescription select: [ :eachArray | (aDBDescription class columnTableIndex: eachArray) = tableIndex ]).

   firstColumn := true.

   columnDescriptions do: [ :eachColDescArray | | colNameString colDomString colBsDomString colBsDef |

     firstColumn ifFalse:[
       sqlCommandStream nextPut: $, .
	firstColumn := false ].

     colNameString := aDBDescription class columnName: eachColDescArray.
     colDomString := aDBDescription class columnDomain: eachColDescArray.
     ((colBsDomString := aDBDescription class searchBaseDomainString: colDomString) notNil 
       and: [ (colBsDef := self class foundBaseDefinition: colBsDomString) notNil ]) ifTrue:[

	 "Definition of Column-Name and Data Type in SLQ"
	 sqlCommandStream
	   nextPutAll: colNameString ;
	   nextPut: $  ;
	   nextPutAll: (self class baseDefinition: colBsDef).

	 "Definition of Length in SQL"
	 (self class totalLengthNeeded: colBsDef) ifTrue:[
	   sqlCommandStream
	     nextPut: $( ;
	     nextPutAll: (aDBDescription class totalLength: (aDBDescription class searchBaseDomain: colDomString)) printString.
	   (self class postLengthNeeded: colBsDef) ifTrue:[
	     sqlCommandStream
	       nextPut: $, ;
	       nextPutAll: (aDBDescription class postLength: (aDBDescription class searchBaseDomain: colDomString)) printString.
	   ].
	   sqlCommandStream
	     nextPut: $) .
	 ].

	 "Definition of NOT NULL in SQL"
	 (aDBDescription class columnNotNull: eachColDescArray) ifTrue:[
	   sqlCommandStream    
	     nextPut: $  ;
	     nextPutAll: 'NOT NULL'.
	 ].

	 "Definition of UNIQUE in SQL"
	 (aDBDescription class columnUnique: eachColDescArray) ifTrue:[
	   sqlCommandStream    
	     nextPut: $  ;
	     nextPutAll: 'UNIQUE'.
	 ].

	 "Definition of DEFAULT in SQL"
	 (aDBDescription class columnDefault: eachColDescArray) notNil ifTrue:[
	   sqlCommandStream    
	     nextPut: $  ;
	     nextPutAll: 'DEFAULT ' ;
	     nextPutAll: (aDBDescription class columnDefault: eachColDescArray).

	 ].

	 "Definition of PRIMARY KEY in SQL"
	 (aDBDescription class columnPrimaryKey: eachColDescArray) ifTrue:[
	   sqlCommandStream    
	     nextPut: $  ;
	     nextPutAll: 'PRIMARY KEY'.
	 ].

       firstColumn := false.
     ].
   ].

   sqlCommandStream nextPutAll: ')'.

   (aDBDescription class superTableName: (tableDescription at: tableIndex)) notNil ifTrue:[
     sqlCommandStream
       nextPut: $ ;
       nextPutAll: 'INHERITS(' ;
       nextPutAll: ')'
   ].

   Transcript cr ; show: sqlCommandStream contents.

 ]



!

createViewsFromDefinition: aDBDescription
  "This method creates all tables needed in a database described by aDBDescription"

  |  sqlCommandStream |

 1 to: aDBDescription class mordViewDefinition do: [ :viewDefinitionArray |

   sqlCommandStream := WriteStream on: String new.
   sqlCommandStream
     nextPutAll: 'CREATE VIEW ' ;
     nextPutAll: (aDBDescription class viewName: viewDefinitionArray) ;
     nextPutAll: ' AS ' ;
     nextPutAll: (aDBDescription class viewStatement: viewDefinitionArray).

   Transcript cr ; show: sqlCommandStream contents.

 ]



! !

!MORDPostgreSQLHandler methodsFor:'MORD-Database-Notification-Services'!

listenToEvent: eventName
  "^<Boolean> This method tells the backend to send events for relations named eventName"

  ^(self newSQLStatementExecute: ('LISTEN ',self stringToString: eventName)) commandSuccessfull


!

nextNotification
  "^<MORDPostgreSQLNotification | nil> I return the next notification event if one is available ..."

  | aMORDPostgreSQLNotification anExternalAddress |

  (anExternalAddress := self lowLevelNextNotification) isNil
    ifTrue:[ ^nil ].

  ^MORDPostgreSQLNotification newNotification: anExternalAddress
!

unlistenToEvent: eventName
  "^<Boolean> This method tells the backend not to send events for relations named eventName any more"

  ^(self newSQLStatementExecute: ('UNLISTEN ',self stringToString: eventName)) commandSuccessfull


! !

!MORDPostgreSQLHandler methodsFor:'MORD-Datatype Conversion'!

booleanFromString: aString
  "^<Boolean> This method converts a boolean string representation into a boolean"

  ^aString = '''t'''
    or: [ aString = 'true'
      or: [ aString = '1'
	or: [ aString = 'TRUE'
	  or: [ aString = 'y'
	    or: [ aString = 'yes' ]]]]]











!

booleanToString: aBoolean
  "^<String> This method converts the value of aBoolean to a string usuable for SQL statements"

  ^self stringToString: (aBoolean ifTrue:[ 't' ] ifFalse:[ 'f' ])














!

dateFromISO8601String: aString
  "^<Date> This method returns a date from a string representation"

  | readStream year month day |

  readStream := ReadStream on: aString.

  year := (readStream upTo: $- ) asNumber.
  month := (readStream upTo: $-) asNumber.
  day := (readStream upTo: $  ) asNumber.

  ^Date newDay:day month:month year:year














!

dateFromString: aString
  "^<Date> This method returns a date object from a string representation"

  ^self dateFromISO8601String: aString














!

doubleFromString: aString
  "^<Integer> This method returns a float in double precision data format from a string representation"

  ^aString asNumber














!

floatFromString: aString
  "^<Integer> This method returns a float in single precision data format from a string representation"

  ^aString asNumber














!

integerFromString: aString
  "^<Integer> This method returns an integer from a string representation"

  ^aString asNumber truncated














!

stringFromString: aString
  "^<String> This method converts the value of aString to a string usuable for SQL statements"

  ^aString














!

timeFromISO8601String: aString
  "^<Time> This method returns a time from an ISO8601 representation. Please be very carefull, because
  the routine throws aways the milliseconds of the time ... this is a bug"

  | readStream hour minutes seconds rest |

  readStream := ReadStream on: aString.

  hour := (readStream upTo: $: ) asNumber.
  minutes := (readStream upTo: $: ) asNumber.
  seconds := (readStream next: 2  ) asNumber.

  ^Time hours:hour minutes:minutes seconds: seconds














!

timeFromString: aString
  "^<Date> This method returns a float in double precision data format from a string representation"

  ^aString asNumber














!

timestampFromISO8601String: aString
  "^<AbsoluteTime> This method returns a timestamp from a string representation"

  | readStream year month day  hour minutes seconds |

  readStream := ReadStream on: aString.

  year := (readStream upTo: $- ) trimBlanks asNumber.
  month := (readStream upTo: $-) trimBlanks asNumber.
  day := (readStream upTo: $  ) trimBlanks asNumber.
  hour := (readStream upTo: $: ) trimBlanks asNumber.
  minutes := (readStream upTo: $:) trimBlanks asNumber.
  seconds := (readStream upTo: $-  ) trimBlanks asNumber.

  ^AbsoluteTime
     fromDate: (Date newDay:day month:month year:year) 
     andTime: (Time hours:hour minutes:minutes seconds: seconds)















!

timestampFromString: aString
  "^<Timestamp> This method returns a timestamp from a string representation"

  ^self timestampFromISO8601String: aString














!

timestampToString: aTimestamp
  "^<String> This method returns a string from a timestamp representation"

  ^self stringToString: (self timestampToISO8601String: aTimestamp)














! !

!MORDPostgreSQLHandler methodsFor:'MORD-Finalization'!

disposed
  "This method should be called - when the receiver is garbage collected. Actually it did a 
  little bit more - but I have not managed to make it working :-(. It should do a disconnect
  if not used any more, but this brought us several errors ..."

  self connection: nil


! !

!MORDPostgreSQLHandler methodsFor:'MORD-General-Services'!

waitForResults: sqlStatements
  "This statement returns, when all results of sqlStatements are available. Because the statements
   are executed in a defined order the results returns are also in a defined order and via 
   semaphores access of the attribute statementResult we get all results and do not need so
   much cpu power to do the work"

  sqlStatements do:[ :eachSQLStatement | eachSQLStatement statementResult ].
! !

!MORDPostgreSQLHandler methodsFor:'MORD-Low-Level Code'!

consumeInput
  "^<Integer | nil> This method executes the consume input routine within PostgreSQL"

%{
  #include "libpq-fe.h"

  if __isExternalAddress(  __INST(connection)) {
    RETURN(__MKINT(PQconsumeInput(  __externalAddressVal( __INST(connection)))))
  }
  else
    RETURN(nil)
%}.

!

isBusy
  "^<Boolean> This method executes the consume input routine within PostgreSQL"

%{
  #include "libpq-fe.h"

  if __isExternalAddress(  __INST(connection))
  {
    if (PQisBusy(  __externalAddressVal( __INST(connection))) != 0)
    {
      RETURN(true);
    };
    RETURN( false);
  };
  RETURN(false)
%}.

!

lowLevelAsynchronousStatementExecute: statementString
  "^<Integer | nil> This method executes a command on the backend server but does not wait for the results.
  You may read more about this command in chapter 16 in the programmers manual of PostgreSQL"

%{
  #include "libpq-fe.h"

  PGresult *result;

  if (__isString( statementString) & __isExternalAddress( _INST(connection)))
  {
    RETURN( __MKINT(PQsendQuery(  __externalAddressVal(_INST(connection)), __stringVal(statementString))));
  }
  RETURN(nil);
%}.



!

lowLevelGetSingleSQLResult
  "^<ExternalAddress | nil> This method should be used, when remote execution is done
  in asynchronous mode. Read more about this command in chapter 16 inthe programmers
  manual of PostgreSQL ...
  "

%{
  #include "libpq-fe.h"

  PGresult *result ;

  if __isExternalAddress(  __INST(connection)) {
    result = PQgetResult(  __externalAddressVal( __INST(connection)));
    if (result == NULL) {
      RETURN(nil)
    }
    else
      RETURN( __MKEXTERNALADDRESS(result));
  }
  else
    RETURN(nil)
%}.

!

lowLevelNextNotification
  "^<ExternalAddress> This method returns the next notification structure - if an notofication is 
   available. Otherwise it returns nil"

%{
  #include "libpq-fe.h"

  PGnotify *notify;

  if __isExternalAddress( __INST(connection))
  {
    notify = PQnotifies(  __externalAddressVal(__INST(connection)));
    if (notify != NULL)
    {
      RETURN(  __MKEXTERNALADDRESS( notify));
    }
  };
  RETURN(nil);
%}.



!

lowLevelSynchronStatementExecute: statementString
  "^<ExternalAddress | nil>"

%{
  #include "libpq-fe.h"

  PGresult *result;

  if (__isString( statementString) & __isExternalAddress( __INST(connection)))
  {
    result = PQexec(  __externalAddressVal(__INST(connection)), __stringVal(statementString));
    if (result == NULL) {
      RETURN(nil)
    }
    else
      RETURN( __MKEXTERNALADDRESS(result));
  }
  else
    RETURN(nil);
%}.



!

nativeConnect: connectString
  "^<ExternalAddress | nil> This method tries to connect to the database postmaster process. If
   it gets a new connection it returns the PGconn struct pointer as an external Address - otherwise it returns
   nil to indicate, that a new connection could not be made.
   The connectString contains a string holding all informations needed to create the connection. To get more
   information about the format please look at MORDPostgreSQLConnectionInfo.
   02-08-99: Phoenix-MF
  "

%{

  #include "libpq-fe.h"

  PGconn *conn;

  if __isString( connectString)
  {
    conn = PQconnectdb( __stringVal(connectString));
    /* check to see that the backend connection was successfully made */
    if (PQstatus(conn) == CONNECTION_OK)
    {
      RETURN( __MKEXTERNALADDRESS(conn));
    }
  }
  RETURN(nil);
%}.


!

nativeDisconnect
  "This method tries to disconnect from a database. The connection specified by the anExternalAddress is
   being killed.
   02-08-99: Phoenix-MF
  "

%{
  #include "libpq-fe.h"


  if __isExternalAddress(__INST(connection))
  { 
     PQfinish(  __externalAddressVal( __INST(connection)));
  }
%}.
!

options
    "^<String>"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection))
  {
    RETURN( __MKSTRING( PQoptions(  __externalAddressVal(__INST(connection)))));
  }
  RETURN( __MKSTRING(""))
%}.

!

requestCancel
  "^<Boolean> This method returns true, if the cancel request was successfully dispatched.
  Otherwise it returns false and you may ask errorMessage: for the reason"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection))
  {
    if (PQrequestCancel(  __externalAddressVal(__INST(connection))) != 0)
    {
      RETURN( true);
    }
  };
  RETURN(false);
%}.

!

reset
  "This method tries to reset the connect"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection))
  {
    PQreset(  __externalAddressVal(__INST(connection)));
  }
%}.

!

socket
  "^<Integer> This method returns the socket descriptor used for the communication of
  the receiver to the backend database server. I return 0 in case of error"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection))
  {
    RETURN( __MKINT(PQsocket(  __externalAddressVal(__INST(connection)))))
  }
  RETURN(__MKINT(0))
%}.

!

status
    "comment stating purpose of this message"



%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection))
  {
    PQstatus(  __externalAddressVal(__INST(connection)));
  }
%}.

!

tty
    "^ <String>"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection))
  {
     RETURN( __MKSTRING( PQtty(  __externalAddressVal(__INST(connection)))));
  }
  RETURN( __MKSTRING( ""))
%}.
!

userName
  "^<String> This method returns the name of the user used for the connection pgConnectionOrNil"

%{
  #include "libpq-fe.h"

  if __isExternalAddress(__INST(connection))
  {
    RETURN( __MKSTRING( PQuser(  __externalAddressVal(__INST(connection)))));
  }
  else
    RETURN(__MKSTRING( ""));
%}.

!

waitForData
  "This method waits on the socket that any data is received"

  | aSocket |

  aSocket := Socket new.
  aSocket setFileDescriptor: self socket mode: 'r'.
  aSocket readWait.
  ^true
! !

!MORDPostgreSQLHandler methodsFor:'MORD-Testing'!

isConnected
  "^<Boolean> I return true if the connection to the database is still valid"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(connection))
  {
    if (PQstatus( __externalAddressVal(__INST(connection))) == CONNECTION_OK)
    {
      RETURN(true);
    }
  }
  RETURN(false);
%}.

!

validConnection
  "^<Boolean> This method returns true if the receiver has a possible connection - in case
  of this class it has a connection handle"

  ^self connection isNil
    ifTrue:[ false ]
    ifFalse:[ self connection isNil ]

! !

!MORDPostgreSQLHandler methodsFor:'initialization'!

initialize

  super initialize.
  self readyForNewCommand: Semaphore new.
  self readyForNewCommand signal.
! !

!MORDPostgreSQLHandler class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDpostgreSQLApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"



'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:26'                    !

MORDGeneralSQLStatement subclass:#MORDPostgreSQLStatement
	instanceVariableNames:'asyncExecution waitSemaphore'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDPostgreSQLApp'
!

!MORDPostgreSQLStatement class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


!

documentation
"
    Instances of this class manage a SQl statement and held the returned results of
    that statement

    [author:]
	 Marten Feldtmann, marten@toppoint.de

    [see also:]
	 MORDPostgreSQLResult, MORDPostgreSQLHandler

"
!

examples
"
    examples to be added.
								[exBegin]
    ... add code fragment for 
    ... executable example here ...
								[exEnd]
"
!

history
    "Created: / 13.8.1999 / 21:10:38 / marten"
! !

!MORDPostgreSQLStatement class methodsFor:'MORD-Instance creation'!

newSQLStatement: aString
  "^<MORDPostgresSQLStatement> I return a new instance for synchronous execution 
  holding a SQL statement in aString"

 ^self new initialize
    statementString: aString ;
    yourself

! !

!MORDPostgreSQLStatement methodsFor:'MORD-Testing'!

commandSuccessfull
  "^<Boolean> I return true if the command was successfully executed - otherwise I return false"

  ^self statementResult isNil
    ifTrue:[ false ]
    ifFalse:[ self statementResult commandSuccessfull ]
!

resultAvailable
  "^<Boolean> I return true if the command was successfully executed - otherwise I return false"

  ^statementResult notNil

! !

!MORDPostgreSQLStatement methodsFor:'accessing'!

asyncExecution
    "^<Boolean> return the value of the instance variable 'asyncExecution' (automatically generated)"

    ^ asyncExecution
!

asyncExecution:something
    "set the value of the instance variable 'asyncExecution' (automatically generated)"

    asyncExecution := something.!

dbHandler
    "^<MORDPostgreSQLHandler> return the value of the instance variable 'dbHandler' (automatically generated)"

    ^ dbHandler
!

dbHandler:something
    "set the value of the instance variable 'dbHandler' (automatically generated)"

    dbHandler := something.!

statementResult
    "^<MORDPostgreSQLResult> return the value of the instance variable 'statementResult' (automatically generated)"

   (self asyncExecution 
     and: [  statementResult isNil
	and: [ self waitSemaphore isNil ]]) ifTrue:[
     self waitSemaphore: Semaphore new.
     Transcript show: '?'.
     self waitSemaphore wait.
     Transcript show: '!!'.

   ].
    ^ statementResult
!

statementResult:something
    "set the value of the instance variable 'statementResult' (automatically generated)"

    statementResult := something.
    self waitSemaphore notNil ifTrue:[
      self waitSemaphore signalForAll.
      self waitSemaphore: nil
    ]
!

statementString
    "^<String> return the value of the instance variable 'statementString' (automatically generated)"

    ^ statementString
!

statementString:something
    "set the value of the instance variable 'statementString' (automatically generated)"

    statementString := something.!

waitSemaphore
    "return the value of the instance variable 'waitSemaphore' (automatically generated)"

    ^ waitSemaphore!

waitSemaphore:something
    "set the value of the instance variable 'waitSemaphore' (automatically generated)"

    waitSemaphore := something.! !

!MORDPostgreSQLStatement methodsFor:'initialization'!

initialize

  super initialize.
  self asyncExecution: false
! !

!MORDPostgreSQLStatement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDpostgreSQLApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"



'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:26'                    !

MORDGeneralConnectionInfo subclass:#MORDPostgreSQLConnectionInfo
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDPostgreSQLApp'
!

!MORDPostgreSQLConnectionInfo class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


!

documentation
"
    This class is used to hold the information needed to get access to the database. Instances of this
    class may be filled by your application program and then you ask MORDPostgreSQLHandler with
    one of these instances to get in contact with the database you have in mind.

    [author:]
	Marten Feldtmann, marten@toppoint.de

    [see also:]
	MORDPostgreSQLHandler

"
!

examples
"
    // How to get a connection to a database ...
								[exBegin]
    | aConnectionInfo aSQLHandler |

   aConnectionInfo := MORDPostgreSQLConnectioInfo new.

   // Setting the most usual values and options
   aConnectionInfo
     dbName:  NameOfDatabase ;           
     host:    NameOfComputer ;
     user:    NameOfUser ;
     password:Password.

  // Ask the handler to try to connect to the database
  sqlHandler := MORDPostgreSQLHandler connect: aConnectionInfo.

  // Test the connection and do your work according to the result
  sqlHandler isConnected
    ifTrue: [ Transcript cr ; show: Fine - now I can do my work ]
    ifFalse:[ 
      // Alternative 1
      Transcript 
	cr ; 
	show: Error connecting to database: ,aConnectionInfo dbName,. Error Message: ,sqlHandler errorMessage.

      // Alternative 2
      Transcript 
	cr ; 
	show: Error connecting to database: ,sqlHandler dbName,. Error Message: ,sqlHandler errorMessage.
    ].

  // In this release you should disconnect even if you do not get a connection !!
  sqlHandler disconnect.

								[exEnd]
"
!

history
    "Created: / 19.8.1999 / 12:28:40 / support"
! !

!MORDPostgreSQLConnectionInfo class methodsFor:'Constants'!

availableParameters
  "^<Array of: Symbols> I return all settable options used by this connection info ..."

  ^#(host port dbname user password options tty)
! !

!MORDPostgreSQLConnectionInfo methodsFor:'MORD-Accessing'!

dbName
  "^<String | nil> This method returns the name of the database ..."

  ^self information at: #dbname ifAbsent: [ nil ]
!

dbName: aString

  self information at: #dbname put: aString
!

host
  "^<String | nil> I return the name of the host the database backend is running on ..."

  ^self information at: #host ifAbsent: [ nil ]
!

host: aString

  self information at: #host put: aString
!

password
 "^<String | nil> I return the password of the database connection infos"

 ^self information at: #password ifAbsent: [ nil ]
!

password: aString

  self information at: #password put: aString
!

port
  "^<String | nil> This method returns the number of the port the backend server uses"

  ^self information at: #port ifAbsent: [ nil ]
!

port: aString

  self information at: #port put: aString
!

user
  "^<String | nil>I set the user account to log in into the database"

  ^self information at: #user ifAbsent: [ nil ]
!

user: aString
  "I set the user account to log in into the database"

  self information at: #user put: aString
! !

!MORDPostgreSQLConnectionInfo methodsFor:'MORD-Services'!

createConnectionString
  "^<String> This method builds and returns the connection string used for accessing"

  | connectionStream |

  connectionStream := WriteStream on: String new.

  self information associationsDo: [ :eachAssoc | 
    connectionStream
      nextPutAll: eachAssoc key asString ;
      nextPutAll: '=' ;
      nextPutAll: eachAssoc value asString ;
      space.

  ].

  ^connectionStream contents
! !

!MORDPostgreSQLConnectionInfo class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDpostgreSQLApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"



'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:26'                    !

MORDGeneralRowResult subclass:#MORDPostgreSQLRowResult
	instanceVariableNames:'colDescArray rowDataArray'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDPostgreSQLApp'
!

!MORDPostgreSQLRowResult class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


!

documentation
"
    Instances of this class are used to hold the actual data results returns via
    a SELECT statement ...

    [author:]
	 Marten Feldtmann, marten@toppoint.de

    [see also:]
	 MORDPostgreSQLResult, MORDPostgreSQLStatement

    [instance variables:]
	 colDescArray
	   This is an array holding the header-names of each column in the result

	 rowDataArray
	   This is an array of array holding all returns data tuples ...
"
!

examples
"
    examples to be added.
								[exBegin]
    ... add code fragment for 
    ... executable example here ...
								[exEnd]
"
!

history
    "Created: / 13.8.1999 / 21:10:34 / marten"
! !

!MORDPostgreSQLRowResult class methodsFor:'MORD-Instance creation'!

columns: colInteger rows: rowInteger
  "^<MORDPostgreSQLRowResult> This method returns a new instance of the receiver class"

  ^self new
     colDescArray: (Array new: colInteger) ;
     rowDataArray: (Array new: rowInteger) ;
     yourself

! !

!MORDPostgreSQLRowResult methodsFor:'accessing'!

colDescArray
    "^<Array of String> return the value of the instance variable 'colDescArray' (automatically generated)"

    ^ colDescArray
!

colDescArray:something
    "set the value of the instance variable 'colDescArray' (automatically generated)"

    colDescArray := something.!

counts
  "^<Integer> This method returns the number of results available within the receiver"

  ^self rowDataArray size
!

rowDataArray
    "^<Array of: (Array of: String)> 
     return the value of the instance variable 'rowDataArray' (automatically generated)"

    ^ rowDataArray
!

rowDataArray:something
    "set the value of the instance variable 'rowDataArray' (automatically generated)"

    rowDataArray := something.! !

!MORDPostgreSQLRowResult class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDpostgreSQLApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"



'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:26'                    !

MORDGeneralResult subclass:#MORDPostgreSQLResult
	instanceVariableNames:'resultHandle resultCode resultMessage rowResult'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDPostgreSQLApp'
!

MORDPostgreSQLResult class instanceVariableNames:'openResults'

"
 The following class instance variables are inherited by this class:

	MORDGeneralResult - 
	Object - 
"
!

!MORDPostgreSQLResult class methodsFor:'documentation'!

copyright
"
		      This class is part of the MORD-project.

    Our company is not responsible for any damage you get by using this software. 

    You may use this software as it is and on your own risc. You do not have to pay for the
    source when using it in your private or comercial projects/products.

    You get all the source, look at it, improve it and perhaps use it in your projects. 
    Please be so kind to inform me about bugs in this software, improvements you would
    like to see and other tips or suggestions.

    If you use it in your external application you must print the following notice to the 
    user:


		 'Using MORD - Mapping Objects on Relational Databases'



    Newer versions of this software will be made available at our WWW-site: 

				       www.phoenix-edv.com
    Address: 

      Phoenix EDV Systemtechnik GmbH, Fraunhoferstr. 3, 25524 Itzehoe, Germany
      Tel.: +49-(0)-4821-778-280, Fax.: +49-(0)-4821-778-289

	       marten@phoenix-edv.netzservice.de or marten@toppoint.de
"


!

documentation
"
    MORDPostgreSQLResult is a class holding a result of an executed sql statement. Each
    SQL statement creates an instance of this class. You may ask this instance how
    successful the execution was and in case of a select statement you may ask for the
    retuned results.

    [author:]
	 (marten@feki)

    [see also:]
	 MORDPostgreSQLRowResult, MORDPostgreSQLStatement

    [instance variables:]

    [class variables:]
"
!

history
    "Created: / 13.8.1999 / 21:10:31 / marten"
! !

!MORDPostgreSQLResult class methodsFor:'initialization'!

initialize
  "self initialize"

  super initialize.
  openResults :=  Registry new
! !

!MORDPostgreSQLResult class methodsFor:'MORD-Accessing'!

openResults
  "self openResults"

  openResults isNil ifTrue:[ self initialize ].
  openResults
! !

!MORDPostgreSQLResult class methodsFor:'MORD-Instance Creation'!

fatalErrorResult
  "^<MORDPostgreSQLResult> I return a new result which can be treated as an result of a statement
  which created an error"

  | anInstance |

  anInstance := self newResult.

  ^anInstance
    resultCode: anInstance fatalErrorResultValue ;
    resultMessage: anInstance fatalErrorResultString ;
    yourself

!

newResult
  "^<MORDPostgreSQLResult> I return a new emptyResult - please use this statement, because the
  new instance is added to the finalization process ..."

  | anInstance |

  anInstance := self new.
  openResults register: anInstance.
  ^anInstance


! !

!MORDPostgreSQLResult methodsFor:'MORD-Finalization'!

disposed
  "This method should be called - when the receiver is garbage collected"

  self resultHandle notNil ifTrue:[ self release ].
  self resultHandle: nil
! !

!MORDPostgreSQLResult methodsFor:'MORD-Interface'!

allRows
  "^<MORDPostgreSQLRowResult | nil> This method returns all available row results"

  self rowResult: (self rows: self numberOfTuple).
  ^self rowResult
!

allRowsAndDispose
  "This method retrieves all tupples from the result. It gets the resultCode of the statement and
  it gets the resultMessage. After that it releases the result handler to free memory on the
  client side - be careful not to use methods, which needs the result handle !!!!!!!!"

  self allRows.
  self resultCode.
  self resultMessage.
  self disposed
!

numberOfAffectedRows
  "^<Integer> This method returns the number of rows affected by the command"

 ^self lowLevelNumberOfAffectedRows asNumber

!

numberOfTuple
  "^<Integer> This method returns the number of tuples the result can deliver"


%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(resultHandle))
  {
    RETURN(__MKINT(PQntuples(  __externalAddressVal( __INST(resultHandle)))));
  }
  RETURN(__MKINT(0));
%}.


!

resultCode
    "^<Integer> I return the value of the instance variable 'resultCode' (automatically generated)"

    resultCode isNil ifTrue:[ resultCode := self resultState ].
    ^ resultCode.
!

resultMessage
  "^<String> I return the error message of this result"

  resultMessage isNil ifTrue:[ resultMessage := self lowLevelResultMessage ].
  ^resultMessage


!

rows: anInteger
  "^<MORDPostgreSQLRowResult | nil> This method returns the next anInteger results"

  | rowResults columns maxResult |

  maxResult := anInteger min: self numberOfTuple.
  anInteger = 0 ifTrue:[ ^nil].
  columns := self numberOfFields.
  rowResults := MORDPostgreSQLRowResult columns: columns rows: anInteger.
  1 to: columns do: [ :index |
    rowResults colDescArray 
      at: index 
      put: (self nameOfFieldIndexed: (index - 1) ).
  ].
  0 to: (anInteger - 1) do: [ :rowIndex | | rowData |
    rowResults rowDataArray at: (rowIndex + 1) put: (Array new: columns).
    rowData := rowResults rowDataArray at: (rowIndex + 1).
    0 to: (columns - 1) do: [ :colIndex |
      rowData 
	at: (colIndex + 1)
	put:
	  ((self isNullFieldIndexed: colIndex tupelIndex: rowIndex)
	    ifTrue:[  nil ]
	    ifFalse:[ self getValueOfFieldIndexed: colIndex tupelIndex: rowIndex ])
    ].
  ].
  ^rowResults
! !

!MORDPostgreSQLResult methodsFor:'MORD-Low-Level-Code'!

byteSizeOfFieldIndexed: anInteger
  "^<Integer> This method returns the byte size of the field"


%{
  #include "libpq-fe.h"

  if (__isInteger( anInteger) & __isExternalAddress(__INST(resultHandle)))
  {
    RETURN(__MKINT(PQfsize(__externalAddressVal(__INST(resultHandle)),__intVal(anInteger))));
  }
  RETURN(0);
%}.


!

getValueOfFieldIndexed: anInteger tupelIndex: tupelInteger
  "^<String> This method returns the content of the columns indexed by anInteger in 
  the result tuple indexed by tupelInteger"


%{
  #include "libpq-fe.h"

  if (__isInteger( anInteger) & __isInteger( tupelInteger) & __isExternalAddress(__INST(resultHandle)))
  {
    RETURN(__MKSTRING(PQgetvalue(__externalAddressVal(__INST(resultHandle)),__intVal(tupelInteger),__intVal(anInteger))));
  }
  RETURN("");
%}.


!

isNullFieldIndexed: anInteger tupelIndex: tupelInteger
  "^<Boolean> This method returns true, if the column indexed by anInteger in the result tupel indexed
  by tupelInteger is a null value !!"


%{
  #include "libpq-fe.h"

  int rc ;

  if (__isInteger( anInteger) & __isInteger( tupelInteger) & __isExternalAddress(__INST(resultHandle)))
  {
    rc = PQgetisnull(__externalAddressVal(__INST(resultHandle)),__intVal(tupelInteger),__intVal(anInteger));
    if (rc != 0) RETURN(true);
    RETURN(false);
  }
  RETURN(false);
%}.


!

lowLevelNumberOfAffectedRows
  "^<String> This method returns the number (as a string) of rows affected by the command"


%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(resultHandle))
  {
    RETURN(__MKSTRING(PQcmdTuples(  __externalAddressVal(__INST(resultHandle)))));
  }
  RETURN(__MKSTRING("0"));
%}.


!

lowLevelResultMessage
  "^<String> I return the error message of this result"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(resultHandle)) {
    RETURN( __MKSTRING(PQresultErrorMessage(  __externalAddressVal(__INST(resultHandle)))));
  }
  else
    RETURN( __MKSTRING(""))
%}.


!

nameOfFieldIndexed: anInteger
  "^<String> This method returns the name of fields indexed by anInteger within the result"


%{
  #include "libpq-fe.h"

  if (__isInteger( anInteger) & __isExternalAddress( __INST(resultHandle)))
  {
    RETURN(__MKSTRING(PQfname(__externalAddressVal(__INST(resultHandle)),__intVal(anInteger))));
  }
  RETURN("");
%}.




!

numberOfAffectedRows: anExternalAddress
  "^<String> This method returns the number (as a string) of rows affected by the command"


%{
  #include "libpq-fe.h"

  if __isExternalAddress( anExternalAddress)
  {
    RETURN(__MKSTRING(PQcmdTuples(  __externalAddressVal(anExternalAddress))));
  }
  RETURN(__MKSTRING("0"));
%}.


!

numberOfFields
  "^<Integer> This method returns the number of fields (columns) the result can deliver"


%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(resultHandle))
  {
    RETURN(__MKINT(PQnfields(  __externalAddressVal(__INST(resultHandle)))));
  }
  RETURN(__MKINT(0));
%}.


!

release
  "This method is releasing all the memory the result is holding on the frontend. When using
   finalization this method is called automatically by Smalltalk"

%{
  #include "libpq-fe.h"
  if __isExternalAddress(__INST(resultHandle))
  {
    PQclear(  __externalAddressVal(__INST(resultHandle)));
  }
%}.


!

resultState
  "^<Integer | nil> This checks the return state of the result"

%{
  #include "libpq-fe.h"

  if __isExternalAddress( __INST(resultHandle))
  {
    RETURN(__MKINT(PQresultStatus(  __externalAddressVal(__INST(resultHandle)))));
  };
  RETURN(nil)
%}.

! !

!MORDPostgreSQLResult methodsFor:'MORD-Low-Level-Constants'!

badResponseResultValue
  "^<Integer> an unexpected response was recv'd from the backend"

%{
  #include "libpq-fe.h"
  RETURN(__MKINT(PGRES_BAD_RESPONSE));
%}.

!

commandOkResultValue
  "^<Integer> a query command that doesn't return anything was executed properly by the backend"

%{
  #include "libpq-fe.h"
  RETURN(__MKINT(PGRES_COMMAND_OK));
%}.

!

emptyQueryResultValue
  "^<Integer> This checks the return state of the result"

%{
  #include "libpq-fe.h"
  RETURN(__MKINT(PGRES_EMPTY_QUERY));
%}.

!

fatalErrorResultString
  "^<String>"

%{
  #include "libpq-fe.h"
  RETURN(__MKSTRING(PQresStatus(PGRES_FATAL_ERROR)));
%}.

!

fatalErrorResultValue
  "^<Integer>"

%{
  #include "libpq-fe.h"
  RETURN(__MKINT(PGRES_FATAL_ERROR));
%}.

!

nonFatalErrorResultValue
  "^<Integer> This checks the return state of the result"

%{
  #include "libpq-fe.h"
  RETURN(__MKINT(PGRES_NONFATAL_ERROR));
%}.

!

tuplesOkResultValue
  "^<Integer> a query command that returns tuples was executed properly by the backend,
   PGresult contains the result tuples"

%{
  #include "libpq-fe.h"
  RETURN(__MKINT(PGRES_TUPLES_OK));
%}.

! !

!MORDPostgreSQLResult methodsFor:'MORD-Testing'!

commandSuccessfull
  "^<Boolean> This method returns true - if the statement was sucessfully executed. 
  Otherwise it returns false"

  ^ (self resultCode = self commandOkResultValue
      or: [ self resultCode = self emptyQueryResultValue ])
	or: [ self resultCode = self tuplesOkResultValue ]
! !

!MORDPostgreSQLResult methodsFor:'accessing'!

resultCode:something
    "set the value of the instance variable 'resultCode' (automatically generated)"

    resultCode := something.!

resultHandle
    "return the value of the instance variable 'resultHandle' (automatically generated)"

    ^ resultHandle!

resultHandle:something
    "set the value of the instance variable 'resultHandle' (automatically generated)"

    resultHandle := something.!

resultMessage: aString
  "^<String> I return the error message of this result"

  resultMessage := aString


!

rowResult
    "return the value of the instance variable 'rowResult' (automatically generated)"

    ^ rowResult!

rowResult:something
    "set the value of the instance variable 'rowResult' (automatically generated)"

    rowResult := something.! !

!MORDPostgreSQLResult class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDpostgreSQLApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

'From Smalltalk/X, Version:3.5.3 on 23-aug-1999 at 18:01:26'                    !

Object subclass:#MORDPostgreSQLNotification
	instanceVariableNames:'notificationHandle'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Postgres-MORDPostgreSQLApp'
!

MORDPostgreSQLNotification class instanceVariableNames:'openNotifications'

"
 The following class instance variables are inherited by this class:

	Object - 
"
!

!MORDPostgreSQLNotification class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
	 (marten@feki)

    [see also:]

    [instance variables:]

    [class variables:]
"
!

examples
"
    examples to be added.
								[exBegin]
    ... add code fragment for 
    ... executable example here ...
								[exEnd]
"
!

history
    "Created: / 19.8.1999 / 20:11:15 / marten"
! !

!MORDPostgreSQLNotification class methodsFor:'initialization'!

initialize
  "self initialize"

  super initialize.
  openNotifications :=  Registry new




! !

!MORDPostgreSQLNotification class methodsFor:'MORD-Instance Creation'!

newNotification: anExternalAddress
  "^<MORDPostgreSQLNotification> I return a new notification"

  | anInstance |

  anInstance := self new.
  openNotifications register: anInstance.
  ^anInstance

! !

!MORDPostgreSQLNotification methodsFor:'MORD-Finalization'!

disposed
  "This method should be called - when the receiver is garbage collected"

  self notificationHandle notNil ifTrue:[ 
    self releaseNotificationHandle.
    self notificationHandle: nil ].





!

releaseNotificationHandle
  "This method should be called - when the receiver is garbage collected"


%{
  if __isExternalAddress(__INST(notificationHandle))
  {
    free(  __externalAddressVal(__INST(notificationHandle)));
  }
%}.







! !

!MORDPostgreSQLNotification methodsFor:'accessing'!

notificationHandle
    "return the value of the instance variable 'notificationHandle' (automatically generated)"

    ^ notificationHandle!

notificationHandle:something
    "set the value of the instance variable 'notificationHandle' (automatically generated)"

    notificationHandle := something.!

notificationName
  "^<String> This method returns the name of the notification"

%{

  #include "libpq-fe.h"

  PGnotify *notify;

  if __isExternalAddress(__INST(notificationHandle))
  {
    notify =  __externalAddressVal(__INST(notificationHandle));
    RETURN( __MKSTRING( notify->relname ));
  };
  RETURN( __MKSTRING(""));
%}.

! !

!MORDPostgreSQLNotification class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/contrib/libPostgres/MORDpostgreSQLApp.st,v 1.2 2000/08/21 18:02:57 cg Exp $'
! !

MORDPostgreSQLResult initialize!
MORDPostgreSQLNotification initialize!
