/*
 * demonstration of a c-function module
 * with automatic initialization.
 *
 * compile it with:
 *      cc -c demo2.c
 * or simply:
 *      make demo2.o
 *
 * on ELF based systems, make it a shared object with:
 *      ld -shared -o demo2.so demo2.o
 * or simply:
 *      make demo2.so
 *
 * in Smalltalk, load it with:
 *      handle := ObjectFileLoader loadDynamicObject:'demo2.o'  ('demo2.so' on ELF systems)
 *
 * its init-function will automatically be called (returning success here)
 */

void
function1() {
    printf("here is function1 in demo2\n");
}

int
__demo2__Init() {
    printf("this is demo2's init function\n");
    return 1;   /* >= 0 means: OK */
}

void
__demo2__deInit() {
    printf("this is demo2's deinit function\n");
}

