/*
 * demonstration of a c-function module
 * with automatic initialization.
 *
 * compile it with:
 *      cc -c demo3.c
 * or simply:
 *      make demo3.o
 *
 * on ELF based systems, make it a shared object with:
 *      ld -shared -o demo3.so demo3.o
 * or simply:
 *      make demo3.so
 *
 * in Smalltalk, load it with:
 *      handle := ObjectFileLoader loadDynamicObject:'demo3.o'  ('demo3.so' on ELF systems)
 *
 * its init-function will automatically be called (returning failure here)
 */

void
function1() {
    printf("here is function1 in demo3\n");
}

int
__demo3__Init() {
    printf("this is demo3's init function\n");
    return -1;   /* >= 0 means: OK */
}

void
__demo3__deInit() {
    printf("this is demo3's deinit function\n");
}

