Applet subclass:#CosGraph
        instanceVariableNames:'xMin xMax yMin yMax'
        classVariableNames:''
        poolDictionaries:''
        category:'demos-Applets'
!

!CosGraph  class methodsFor:'documentation'!

documentation
"
    an applet which draws a cosine graph.
"



!

examples
"
    see also example page in doc/html/testDocs/testSTX6.html.

                                                                [exBegin]
     HTMLDocumentView openFullOnText:'
<HTML>
<BODY>

<H1>Der Graph der Kosinus Funktion</H1>
<HR>
<APPLET NAME=CosGraph CODE=CosGraph.cls WIDTH=500 HEIGHT=250>
  <PARAM name=foo  value=''hello world''>
  <PARAM name=xmin value=''-4''>
  <PARAM name=xmax value=''4''>
  <PARAM name=ymin value=''-1''>
  <PARAM name=ymax value=''1''>
</APPLET>
<HR>
</BODY>
</HTML>
'
                                                                 [exEnd]
"



! !

!CosGraph methodsFor:'accessing'!

xMax
    "return xMax"

    ^ xMax

    "Created: 8.10.1996 / 17:21:37 / cg"
!

xMax:something
    "set xMax"

    xMax := something.

    "Created: 8.10.1996 / 17:21:37 / cg"
!

xMin
    "return xMin"

    ^ xMin

    "Created: 8.10.1996 / 17:21:37 / cg"
!

xMin:something
    "set xMin"

    xMin := something.

    "Created: 8.10.1996 / 17:21:37 / cg"
!

yMax
    "return yMax"

    ^ yMax

    "Created: 8.10.1996 / 17:21:37 / cg"
!

yMax:something
    "set yMax"

    yMax := something.

    "Created: 8.10.1996 / 17:21:37 / cg"
!

yMin
    "return yMin"

    ^ yMin

    "Created: 8.10.1996 / 17:21:37 / cg"
!

yMin:something
    "set yMin"

    yMin := something.

    "Created: 8.10.1996 / 17:21:37 / cg"
! !

!CosGraph methodsFor:'drawing'!

repaint:aGC
    0 to:width do:[:x |
        aGC displayLineFromX:x
                           y:(self function:x)
                         toX:x+1
                           y:(self function:x+1)
    ]

    "
     self new open
    "

    "Modified: 8.10.1996 / 16:10:36 / cg"
    "Created: 8.10.1996 / 16:11:17 / cg"
! !

!CosGraph methodsFor:'initialize / release'!

init
    xMin := Number readFrom:(self getParameter:'xmin') onError:0.
    xMax := Number readFrom:(self getParameter:'xmax') onError:4.
    yMin := Number readFrom:(self getParameter:'ymin') onError:-1.
    yMax := Number readFrom:(self getParameter:'ymax') onError:1.
! !

!CosGraph methodsFor:'private'!

function:x
    |wX wY y h|

    h := height - 1.

    wX := x * (xMax - xMin) / width + xMin.
    wY := wX cos.
    y := h - ((wY - yMin) * h / (yMax - yMin)).
    ^ y

    "Created: 8.10.1996 / 16:07:24 / cg"
    "Modified: 8.10.1996 / 17:36:30 / cg"
! !

!CosGraph  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/doc/html/testDocs/CosGraph.st,v 1.3 1996/10/08 18:23:13 cg Exp $'
! !
