'From Smalltalk/X, Version:3.1.4 on 24-feb-1997 at 11:58:50 pm'                 !

Applet subclass:#HelloWorldApp3
	instanceVariableNames:'text theFontSize colorIndex redrawProcess'
	classVariableNames:'ColorList'
	poolDictionaries:''
	category:'demos-Applets'
!

!HelloWorldApp3 class methodsFor:'documentation'!

documentation
"
    a simple applet - simply draws hello-world.
    This one fetches the string and the font size from the
    <PARAM> Tags.
"

!

examples
"
    stand alone:
                                                                [exBegin]
        HelloWorldApp3 new init open
                                                                [exEnd]


    in a document:
                                                                [exBegin]
     HTMLDocumentView 
        openFullOnText:'

<HTML>
<BODY>
<P>
My applet says:
<br>
<APPLET CLASS=HelloWorldApp3>
   <PARAM NAME=text VALUE=Wow>
   <PARAM NAME=fontSize VALUE=36>
</APPLET>
</HTML>
'
                                                                [exEnd]
"



! !

!HelloWorldApp3 class methodsFor:'defaults'!

colorList
    |cl|

    ColorList isNil ifTrue:[
        cl := OrderedCollection new.
        255 to:0 by:-16 do:[:r |
            cl add:(Color red:r green:0 blue:(255 - r)).
        ].
        255 to:0 by:-16 do:[:b |
            cl add:(Color red:0 green:(255 - b) blue:b).
        ].
        255 to:0 by:-16 do:[:g |
            cl add:(Color red:(255 - g) green:g blue:0).
        ].

        ColorList := cl.
    ].
    ^ ColorList

    "Created: 3.2.1997 / 16:53:38 / cg"
    "Modified: 4.2.1997 / 16:44:31 / cg"
! !

!HelloWorldApp3 methodsFor:'drawing'!

changeColorAndRedraw
    colorIndex := colorIndex + 1.
    colorIndex > self class colorList size ifTrue:[
	colorIndex := 1.
    ].
    self repaint:(self graphicsContext)

    "Modified: 3.2.1997 / 16:55:42 / cg"
!

repaint:aGC
    aGC font:(Font family:'helvetica' style:#oblique size:theFontSize).
"/    aGC paint:Color black.
"/    aGC displayRectangleX:0 y:0 width:(width - 1) height:(height - 1).

    shown ifFalse:[^ self].

    aGC paint:(self class colorList at:colorIndex).
    aGC displayString:text x:10 y:60

    "
     self new open
    "

    "
     HTMLDocumentView 
        openFullOnText:'

<HTML>
<BODY>
<P>
My applet says:
<br>
<APPLET CLASS=HelloWorldApp3 WIDTH=210 HEIGHT=50>
<PARAM NAME=text VALUE=Wow>
<PARAM NAME=fontSize VALUE=24>
</APPLET>
</HTML>
'
    "

    "Created: 8.10.1996 / 18:27:08 / cg"
    "Modified: 4.2.1997 / 16:45:54 / cg"
! !

!HelloWorldApp3 methodsFor:'initialization'!

destroy
    self stopRedrawProcess.
    super destroy

    "Created: 3.2.1997 / 16:51:02 / cg"
!

init
    |s|

    self extent:(700 @ 70).
    text := self getParameter:'text'.
    text isNil ifTrue:[
	text := 'Hello world'.
    ].
    s := self getParameter:'fontSize'.
    s notNil ifTrue:[
	theFontSize := Integer readFrom:s onError:nil.
    ].
    theFontSize isNil ifTrue:[
	theFontSize := 48
    ].
    colorIndex := 1.
    self startRedrawProcess

    "Created: 8.10.1996 / 18:40:02 / cg"
    "Modified: 3.2.1997 / 16:58:15 / cg"
!

startRedrawProcess
    redrawProcess isNil ifTrue:[
	redrawProcess := [
			    [true] whileTrue:[
				Delay waitForSeconds:2.
				self changeColorAndRedraw.
			    ]
			 ] fork.
    ]

    "Created: 3.2.1997 / 16:51:47 / cg"
    "Modified: 3.2.1997 / 16:51:56 / cg"
!

stopRedrawProcess
    redrawProcess notNil ifTrue:[
	redrawProcess terminate.
	redrawProcess := nil
    ]

    "Modified: 3.2.1997 / 16:52:06 / cg"
! !

!HelloWorldApp3 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/doc/html/testDocs/HelloWorldApp3.st,v 1.5 1997/03/02 10:24:33 cg Exp $'
! !
