Applet subclass:#UnderConstructionBarApplet
	instanceVariableNames:'image xDelta xOffset redrawProcess speed'
	classVariableNames:''
	poolDictionaries:''
	category:'demos-Applets'
!

!UnderConstructionBarApplet  class methodsFor:'documentation'!

documentation
"
    a simple applet showing an animated >>under-construction<< bar
"
!

examples
"
    stand alone:
								[exBegin]
	UnderConstructionBarApplet open
								[exEnd]


    in a document:
								[exBegin]
     HTMLDocumentView openFullOnText:'
<HTML>
<APPLET CLASS=UnderConstructionBarApplet WIDTH=210 HEIGHT=50>
  <PARAM name=speed value=4>
</APPLET>
</HTML>
'
								[exEnd]
"



! !

!UnderConstructionBarApplet methodsFor:'animation'!

animate
    xOffset := xOffset + xDelta.
    xOffset > image width ifTrue:[
	xOffset := xOffset - image width
    ].
    self repaint

    "Created: 9.10.1996 / 12:25:11 / cg"
    "Modified: 9.10.1996 / 12:27:09 / cg"
!

startRedrawProcess
    redrawProcess isNil ifTrue:[
	image := image on:device.

	redrawProcess := [
			    [true] whileTrue:[
				Delay waitForSeconds:0.05.
				shown ifTrue:[
				    self animate.
				]
			    ]
			 ] fork.
    ]

    "Modified: 9.10.1996 / 12:25:19 / cg"
!

stopRedrawProcess
    redrawProcess notNil ifTrue:[
	redrawProcess terminate.
	redrawProcess := nil
    ]

    "Modified: 9.10.1996 / 12:20:14 / cg"
! !

!UnderConstructionBarApplet methodsFor:'initialization'!

destroy
    self stopRedrawProcess.
    super destroy

    "Modified: 9.10.1996 / 12:16:42 / cg"
    "Created: 9.10.1996 / 12:18:14 / cg"
!

init
    image := Image fromFile:'bitmaps/gifImages/artwork/bars/constr.gif'.
    self extent:(image width @ image height).
    xOffset := 0.
    xDelta := Integer readFrom:(self getParameter:'speed') onError:2.

    self startRedrawProcess.

    "Created: 9.10.1996 / 12:14:40 / cg"
    "Modified: 9.10.1996 / 12:27:03 / cg"
! !

!UnderConstructionBarApplet methodsFor:'redrawing'!

repaint:aGC
    aGC displayForm:image x:xOffset negated y:0.
    aGC displayForm:image x:(image width - xOffset) y:0.

    "Created: 9.10.1996 / 12:15:08 / cg"
    "Modified: 9.10.1996 / 12:21:21 / cg"
! !

!UnderConstructionBarApplet  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/doc/html/testDocs/UnderConstructionBarApplet.st,v 1.4 1997/02/11 21:47:31 cg Exp $'
! !
