Applet subclass:#UnderConstructionLampApplet
	instanceVariableNames:'lampImage lampOnImage redrawProcess on delay'
	classVariableNames:''
	poolDictionaries:''
	category:'demos-Applets'
!

!UnderConstructionLampApplet class methodsFor:'documentation'!

documentation
"
    a simple applet showing a blinking construction-lamp
"
!

examples
"
    stand alone:
								[exBegin]
	UnderConstructionLampApplet new open
								[exEnd]


    in a document:
								[exBegin]
     HTMLDocumentView openFullOnText:'
<HTML>
<APPLET CLASS=UnderConstructionLampApplet>
  <PARAM name=delay   value=0.5>
  <PARAM name=image   value=../../doc/html/testDocs/lamp.tiff>
  <PARAM name=onImage value=../../doc/html/testDocs/lampOn.tiff>
</APPLET>
This can be used for unfinished documents.
</HTML>
'
								[exEnd]
"



! !

!UnderConstructionLampApplet methodsFor:'animation'!

animate
    "toggle the on-flag and redraw the image"

    shown ifFalse:[^ self].

    on := on not.
    on ifTrue:[
	self graphicsContext displayForm:lampOnImage x:0 y:0.
    ] ifFalse:[
	self graphicsContext displayForm:lampImage x:0 y:0.
    ].
!

startRedrawProcess
    "fork an animation process"

    redrawProcess isNil ifTrue:[
	lampImage := lampImage on:device.
	lampOnImage := lampOnImage on:device.

	redrawProcess := [
			    [true] whileTrue:[
				Delay waitForSeconds:delay.
				self animate.
			    ]
			 ] fork.
    ]

    "Modified: 9.10.1996 / 12:25:19 / cg"
!

stopRedrawProcess
    "stop any animation process"

    redrawProcess notNil ifTrue:[
	redrawProcess terminate.
	redrawProcess := nil
    ]

    "Modified: 9.10.1996 / 12:20:14 / cg"
! !

!UnderConstructionLampApplet methodsFor:'initialization'!

destroy
    self stopRedrawProcess.
    super destroy

    "Modified: 9.10.1996 / 12:16:42 / cg"
    "Created: 9.10.1996 / 12:18:14 / cg"
!

init
    |base nm nm2|

    "/ look for a codeBase - load image from there.

    base := self getCodeBase.

    nm := self getParameter:'image'.
    nm isNil ifTrue:[
	nm := 'lamp.tiff'
    ].

    nm2 := self getParameter:'onImage'.
    nm2 isNil ifTrue:[
	nm2 := 'lampOn.tiff'
    ].
    "/ this conditional allows the applet to run locally
    "/ (via open-message)

    resolver notNil ifTrue:[
	lampImage := resolver imageFor:(base , '/' , nm).
	lampOnImage := resolver imageFor:(base , '/' , nm2).
    ] ifFalse:[
	lampImage := Image fromFile:(base , '/' , nm).
	lampOnImage := Image fromFile:(base , '/' , nm2).
    ].

    lampImage isNil ifTrue:[
	('missing image: ' , nm) errorPrintCR.
	^ self.
    ].
    lampOnImage isNil ifTrue:[
	('missing image: ' , nm2) errorPrintCR.
	lampImage := nil.
	^ self.
    ].

    "/ resize myself for the images extent.

    self extent:(lampImage width @ lampImage height).
    on := false.
    delay := Number readFrom:(self getParameter:'speed') onError:0.5.

    self startRedrawProcess.

    "Created: 9.10.1996 / 12:14:40 / cg"
    "Modified: 9.10.1996 / 12:27:03 / cg"
! !

!UnderConstructionLampApplet methodsFor:'redrawing'!

repaint:aGC
    lampImage notNil ifTrue:[
	aGC displayForm:lampImage x:0 y:0.
	on ifTrue:[
	    aGC displayForm:lampOnImage x:0 y:0.
	]
    ]    

    "Created: 9.10.1996 / 12:15:08 / cg"
    "Modified: 9.10.1996 / 12:21:21 / cg"
! !

!UnderConstructionLampApplet class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/doc/html/testDocs/UnderConstructionLampApplet.st,v 1.3 1997/03/02 10:52:16 cg Exp $'
! !
