#/bin/sh
#
# AIX_CD_COPY.sh
#
# shell script to copy a CD to hardDisk
# for systems with no rockridge CD format.
# (i.e. poor AIX users).
#
# ATTENTION: 
#   you do NOT need this, if your system
#   supports rockridge CD's properly;
#   i.e. if you do NOT have an AIX box.
#

#
# if invoked without argument, ask for source & destination ...
#  
if [ "$1" != "" ]
then
    SOURCE=$1
    shift
else
    echo CD copy program ....
    echo
    echo
    echo "WARNING - this should only be used with AIX systems."
    echo "because some of the fileProperties (owner, times etc.) are lost"
    echo
    echo Type CTRL-C to change your mind.
    echo 
    echo
    echo please enter the directory where your CD is mounted
    echo i.e. the source directory:
    read SOURCE

    if [ -f $SOURCE/TRANS.TBL ]
    then
	TRANSFILE=TRANS.TBL
    else
        if [ -f $SOURCE/trans.tbl ]
	then
	    TRANSFILE=trans.tbl
	else
	    echo oops - $SOURCE contains neither TRANS.TBL nor a trans.tbl.
	    exit
	fi
    fi
fi

if [ "$1" != "" ]
then
    DEST=$1
    shift
else
    echo please enter the target directory on your disk 
    echo i.e. the destination directory name:
    read DEST

    # copy myself to /tmp,
    # so I know where I'll find me later

    cp AIX_CD_COPY.sh /tmp
fi

#
# see how this system presents the filenames;
# i.e. look for either trans.tbl or TRANS.TBL
#
if [ -f $SOURCE/TRANS.TBL ]
then
    TRANSFILE=TRANS.TBL
else
    if [ -f $SOURCE/trans.tbl ]
    then
        TRANSFILE=trans.tbl
    else
        echo oops - $SOURCE contains neither TRANS.TBL nor a trans.tbl.
    fi
fi

#
# now, a recursive walk ...
#

echo copy all from `pwd`/$SOURCE to $DEST ...

cd $SOURCE

for i in *
do
    if [ $i != $TRANSFILE ]
    then
	#
	# search that file in the TRANS.TBL/trans.tbl file;
	# (xlate to lowercase if trans.tbl / uppercase if TRANS.TBL)
	#
        file=$i
        if [ $TRANSFILE=TRANS.TBL ]
        then
	    # presented as uppercase by cdfs
	    file=`echo $i | tr [a-z] [A-Z]`
            trans=$i
        else
	    # presented as lowercase by cdfs
	    file=`echo $i | tr [A-Z] [a-z]`
            trans=$file
        fi

        if [ -d $i ]
        then
            type=D
        else
	    type=F
        fi

        # look it up in TRANS.TBL
        if [ -f $TRANSFILE ]
        then
            line=`grep "$type $file" $TRANSFILE`
# echo trans.tbl "$type $file" is $line
	    if [ "$line" = "" ]
	    then
		line=`grep "L $file" $TRANSFILE`
		if [ "$line" != "" ]
		then
		    type=L
		fi
	    fi

	    if [ "$line" = "" ]
	    then
echo oops - no translation for "$type $file" in `pwd`
	    else
	        set $line
		if [ "$3" = "" ]
		then
echo oops - no translation for "$type $file" in `pwd`
		else
	            trans=$3
		    link=$4
		fi
	    fi
        else
	    echo no trans.tbl in `pwd`
        fi
    
        if [ "$type" = "D" ]
        then
	    mkdir $DEST/$trans
            /tmp/AIX_CD_COPY.sh $i $DEST/$trans
        else
	    if [ "$type" = "L" ]
	    then
	        echo symbolic link in $DEST  $trans '->' $link
	        (cd $DEST ; ln -s $trans $link)
	    else
	        echo `pwd`/$i '->' $DEST/$trans
	        cp `pwd`/$i $DEST/$trans

		# cdrom copy is r--r--r--
		# make it at least writable for the owner
		chmod +w $DEST/$trans
	    fi
        fi
    fi
done
