"
 COPYRIGHT (c) 2008 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies' }"

Array variableSubclass:#AccessTracingArray
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Programming-Support'
!

!AccessTracingArray class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2008 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    I am an array which triggers a breakpoint when accessed.
    To use, change the class of the Array to investigate (for example, in an inspector)
    to this class (foo changeClassTo:AccessTracingArray),
    enable breakpoints (in the launcher or by evaluating: 'nil enableBreakPoint:#access'
    and execute your code.
    Useful during debugging to catch accesses to an object.

    Note:
        thats a q&d hack - a better solution would be a general trap-on-read/trap in write
        mechanism which works for all objects.

    [author:]
        Claus Gittinger

    [see also:]
        Array 
"
!

examples
"
    Object enableBreakPoint:#access.
    ( #(1 2 3 4) changeClassTo:AccessTracingArray) at:2 put:nil.
    Object disableBreakPoint:#access.
"
! !

!AccessTracingArray methodsFor:'accessing'!

at:index
    self breakPoint:#access.
    ^ super at:index.
!

at:index put:value
    self breakPoint:#access.
    ^ super at:index put:value.
!

basicAt:index
    self breakPoint:#access.
    ^ super basicAt:index.
!

basicAt:index put:value
    self breakPoint:#access.
    ^ super basicAt:index put:value.
! !

!AccessTracingArray class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/AccessTracingArray.st,v 1.1 2008/09/07 15:05:25 cg Exp $'
! !
