"
 COPYRIGHT (c) 1999 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies' }"

SequenceableCollection subclass:#BaseIndexShifter
	instanceVariableNames:'actualCollection base'
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-Sequenceable'
!

!BaseIndexShifter class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1999 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Ever needed a 0-based indexable collection ?
    Ever needed an array to be indexable from $a to $z ?
    or from -50 to +50 ?

    This quick & dirty hack does it for you -
    create it as:
        coll := BaseIndexShifer for:aCollection base:base
    and access elements via:
        coll at:idx             
    and
        coll at:idx put:something
    with idx running from base to base+size-1.

    Warning:
       It may be incomplete protocol-wise - so fix it or forget it.

    [author:]
        Claus Gittinger
"
!

examples
"
                                                                        [exBegin]
    |coll|

    coll := BaseIndexShifter for:(Array new:100) base:0.
    coll at:0 put:12345.
    Transcript showCR:(coll at:0)
                                                                        [exEnd]

                                                                        [exBegin]
    |coll|

    coll := BaseIndexShifter for:(Array new:26 withAll:0) base:$a.
    'lklfjalsfeonbgdbosrjvnaeha' do:[:letter | coll at:letter put:(coll at:letter)+1].
    Transcript showCR:coll keysAndValues
                                                                        [exEnd]

                                                                        [exBegin]
    |coll|

    coll := BaseIndexShifter forClass:Array from:-10 to:10.
    -10 to:10 do:[:i | coll at:i negated put:i].
    Transcript showCR:coll keysAndValues.
    Transcript showCR:coll keys.
                                                                        [exEnd]
"
! !

!BaseIndexShifter class methodsFor:'instance creation'!

for:aCollection base:aMagnitude
    ^ self new actualCollection:aCollection; base:aMagnitude; yourself

    "
     (BaseIndexShifter for:#(1 2 3) base:0) at:0 
     (BaseIndexShifter for:#(1 2 3) base:$a) at:$b 
    "
!

forClass:aCollectionClass from:start to:stop
    ^ self for:(aCollectionClass new:stop-start+1) base:start

    "
     BaseIndexShifter forClass:Array from:-50 to:50
    "

    "Created: / 24-08-2010 / 22:21:05 / cg"
!

forClass:aCollectionClass from:start to:stop withAll:initialValue
    ^ self for:(aCollectionClass new:stop-start+1 withAll:initialValue) base:start

    "
     BaseIndexShifter forClass:Array from:-50 to:50 withAll:0.0
    "

    "Created: / 24-08-2010 / 22:45:09 / cg"
! !

!BaseIndexShifter methodsFor:'accessing'!

at:index
    ^ actualCollection at:(index - base + 1)
!

at:index put:something
    ^ actualCollection at:(index - base + 1) put:something
! !

!BaseIndexShifter methodsFor:'displaying'!

displayString
    ^ actualCollection displayString
! !

!BaseIndexShifter methodsFor:'enumeration'!

do:aBlock
    actualCollection do:aBlock
!

keysAndValuesDo:aBlock
    |k|

    k := base.
    actualCollection do:[:el |
        aBlock value:k value:el.
        k := k + 1
    ].
! !

!BaseIndexShifter methodsFor:'private'!

actualCollection:aCollection
    actualCollection := aCollection
!

base:aNumber
    base := aNumber
! !

!BaseIndexShifter methodsFor:'queries'!

keys
    ^ base to:(base + actualCollection size - 1)

    "Created: / 24-08-2010 / 22:24:22 / cg"
!

size
    ^ actualCollection size
! !

!BaseIndexShifter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/BaseIndexShifter.st,v 1.7 2010/08/24 20:45:51 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/BaseIndexShifter.st,v 1.7 2010/08/24 20:45:51 cg Exp $'
! !
