"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"




"{ Package: 'stx:goodies' }"

Object subclass:#BitBlt
	instanceVariableNames:'sourceForm destForm halftoneForm defaultNib combinationRule destX
		destY sourceX sourceY sourceOrigin clipRect width height colorMap'
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-Support'
!

!BitBlt class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"



!

documentation
"
    This class was added to make pen look ST-80rel2.3-alike.
    Notice:
	This class may be no longer present in newer ST-80 releases

    also notice, that ST/X does not use or need BitBlt in any way.
    This is a demo class - no WARRANTY whatsoever.
    (its main purpose is to provide a home for the Pen class,
     and to be able to try some examples of the BlueBook)


    written spring/summer 89 by claus

    [see also:]
	Pen
	GraphicsContext

    [author:]
	Claus Gittinger
"

! !

!BitBlt class methodsFor:'instance creation'!

destForm:dForm sourceForm:sForm halftoneForm:hForm combinationRule:rule
	       destOrigin:dOrg sourceOrigin:sOrg extent:ext
		 clipRect:clip
    "for compatibility - not really supported"

    ^ self basicNew
	destForm:dForm sourceForm:sForm halftoneForm:hForm 
		  combinationRule:rule
		       destOrigin:dOrg sourceOrigin:sOrg extent:ext
			 clipRect:clip
!

in:aDrawable
    "create a bitBlt which draws into aDrawable"

    |newBitBlt|

    newBitBlt := super new.
    newBitBlt source:aDrawable.
    newBitBlt destForm:aDrawable.
    ^ newBitBlt initialize

    "
     |v p|

     v := View new openAndWait.
     p := Pen in:v.
     p defaultNib:5.
     p home.
     p down.
     p north.
     p go:50.
     p east.
     p go:50.
     p south.
     p go:50.
     p west.
     p go:50
    "

    "Modified: 16.5.1996 / 15:06:33 / cg"
!

new
    "create a bitBlt which draws into the rootWindow
     Not all systems allow this."

    |newBitBlt|

    newBitBlt := super new.
    newBitBlt source:(Screen current rootView).
    newBitBlt destForm:(Screen current rootView).
    ^ newBitBlt initialize

    "Modified: 16.5.1996 / 15:04:34 / cg"
!

toForm:aForm
    ^ self new setDestForm: aForm

! !

!BitBlt class methodsFor:'constants'!

numericRuleFor:aSymbol
"rules:
		0 clearWord:with:
		1 bitAnd:with:
		2 bitAndInvert:with:
		3 sourceWord:with:
		4 bitInvertAnd:with:
		5 destinationWord:with:
		6 bitXor:with:
		7 bitOr:with:
		8 bitInvertAndInvert:with:
		9 bitInvertXor:with:
		10 bitInvertDestination:with:
		11 bitOrInvert:with:
		12 bitInvertSource:with:
		13 bitInvertOr:with:
		14 bitInvertOrInvert:with:
		15 destinationWord:with:
		16 destinationWord:with: unused - was old paint
		17 destinationWord:with: unused - was old mask
		18 addWord:with:
		19 subWord:with:
		20 rgbAdd:with:
		21 rgbSub:with:
		22 OLDrgbDiff:with:
		23 OLDtallyIntoMap:with:
		24 alphaBlend:with:
		25 pixPaint:with:
		26 pixMask:with:
		27 rgbMax:with:
		28 rgbMin:with:
		29 rgbMinInvert:with:
		30 alphaBlendConst:with:
		31 alphaPaintConst:with:
		32 rgbDiff:with:
		33 tallyIntoMap:with:
		34 alphaBlendScaled:with:
    "

    aSymbol == #paintAlpha ifTrue:[^ 31].
    aSymbol == #blendAlpha ifTrue:[^ 30].
    aSymbol == #under ifTrue:[^ 7].
    aSymbol == #reverse ifTrue:[^ 6].
    aSymbol == #paint ifTrue:[^ 25].
    aSymbol == #over ifTrue:[^ 3].
    aSymbol == #copy ifTrue:[^ 3].
    aSymbol == #erase ifTrue:[^ 4].
    aSymbol == #blend ifTrue:[^ 24].
    aSymbol == #and ifTrue:[^ 1].
    self halt.
! !

!BitBlt methodsFor:'accessing'!

clipRect:aRectangle
    clipRect := aRectangle
!

colorMap
    "dummy"

    ^ colorMap
!

colorMap:something
    "dummy"

    colorMap := something.
!

combinationRule:aRule
    "ST-80 compatibility: 
     set the combination rule, which controls how 
     written pixels are to be combined with pixels already present in
     the destination. 
     This is a historical leftover from 1-plane monochrome
     times; nowadays (with pseudoColor or trueColor displays), the combination
     rule makes almost no sense."

    combinationRule := aRule

    "Modified: 22.1.1997 / 18:58:08 / cg"
!

defaultNib:aNumber
    "set the width of the drawing pen, in pixels"

    sourceForm := nil.
    defaultNib := aNumber.
    defaultNib notNil ifTrue:[
	(defaultNib == 1) ifTrue:[
	    destForm lineWidth:0
	] ifFalse:[
	    destForm lineWidth:defaultNib
	]
    ]

    "Modified: 22.1.1997 / 18:58:37 / cg"
!

destForm
    "return the destination for drawing"

    ^ destForm 
!

destForm:aDrawable
    "set the destination for drawing"

    (aDrawable == Screen current) ifTrue:[
        destForm := aDrawable rootView
    ] ifFalse:[
        destForm := aDrawable
    ]

    "Modified: 16.5.1996 / 15:03:19 / cg"
!

destForm:dForm sourceForm:sForm halftoneForm:hForm combinationRule:rule
               destOrigin:dOrg sourceOrigin:sOrg extent:ext
                 clipRect:clip
    "set all relevant state for drawing"

    self destForm:dForm.
    self sourceForm:sForm.
    halftoneForm := hForm.
    combinationRule := rule.
    destX := dOrg x.
    destY := dOrg y.
    sourceX := sOrg x.
    sourceY := sOrg y.
    width := ext x.
    height := ext y.
    clipRect := clip

    "Modified: 22.1.1997 / 18:58:55 / cg"
!

destOrigin:aPoint
    "define an origin for drawing"

    destX := aPoint x.
    destY := aPoint y.

    "Modified: 22.1.1997 / 18:59:09 / cg"
!

destRect: aRectangle 
    "Set the receiver's dest form top left x and y, width and height to be 
    the top left coordinate and extent of the argument, aRectangle."

    destX := aRectangle left.
    destY := aRectangle top.
    width := aRectangle width.
    height := aRectangle height

!

fillColor: aColorOrPattern 
    "The destForm will be filled with this color or pattern of colors.  
     May be an old Color, a new type Color, a Bitmap (see BitBlt comment), a Pattern, or a Form.  6/18/96 tk"

    aColorOrPattern == nil ifTrue: [
        halftoneForm := nil. ^ self
    ].
    destForm == nil ifTrue: [self error: 'Must set destForm first'].
    halftoneForm := aColorOrPattern bitPatternForDepth: destForm depth.
    destForm paint:aColorOrPattern
!

frame:aFrame
    "noop - for protocol completenes"

    ^ self

    "Modified: 22.1.1997 / 18:59:28 / cg"
!

height:h
    height := h
!

setDestForm:aForm
    "set the destination for drawing"

    self destForm:aForm
!

source:aDrawable
    "set the pens source - this clears any defined linewidth and
     draws using the given argument as pen.
     Provided for ST-80 protocol completeness - source form drawing is
     (currently) not implemented."

    (aDrawable == Screen current) ifTrue:[
        sourceForm := aDrawable rootView
    ] ifFalse:[
        sourceForm := aDrawable.
    ].
    defaultNib := nil

    "Modified: 22.1.1997 / 19:02:59 / cg"
!

sourceForm:aDrawable
    "set the pens source - this clears any defined linewidth and
     draws using the given argument as pen.
     Provided for ST-80 protocol completeness - source form drawing is
     (currently) not implemented."

    self source:aDrawable
!

sourceOrigin:aPoint
    "set the pens source origin.
     Provided for ST-80 protocol completeness - source form drawing is
     (currently) not implemented."

    sourceX := aPoint x.
    sourceY := aPoint y.

    "Modified: 22.1.1997 / 19:02:54 / cg"
!

sourceRect: aRectangle 
    "Set the receiver's source form top left x and y, width and height to be 
    the top left coordinate and extent of the argument, aRectangle."

    sourceX := aRectangle left.
    sourceY := aRectangle top.
    width := aRectangle width.
    height := aRectangle height

!

width:w
    width := w
! !

!BitBlt methodsFor:'bit-blitting'!

copyBits
    "perform a bitBlt - requires that all relevant state has been setup
     already.
     This is only a minimum simulation ..."

    sourceForm isNil ifTrue:[
	combinationRule == #copy ifTrue:[
	    "/ a fill ...
	    destForm
		fill:(Rectangle origin:(destX @ destY) extent:(width@height))
		fillColor:halftoneForm.
	    ^ self.
	].
	self halt.
    ].

    halftoneForm isNil ifTrue:[
	"/ a copy/fill

	combinationRule == #copy ifTrue:[
	    "/ a fill ...
	    destForm
		fill:(Rectangle origin:(destX @ destY) extent:(width@height))
		fillColor:sourceForm.
	    ^ self.
	].
	self halt.
    ].

    destForm 
	copy:(Rectangle origin:(destX @ destY) extent:(width@height))
	from:(sourceX @ sourceY)
	in:sourceForm
	rule:combinationRule

    "Modified: 22.1.1997 / 19:01:11 / cg"
!

copyBitsTranslucent:alpha
    "perform a bitBlt - requires that all relevant state has been setup
     already.
     This is only a minimum simulation ..."

    ^ here copyBits
! !

!BitBlt methodsFor:'drawing'!

clear
    "clear my destination"

    destForm clear
!

copyFromX:x y:y width:w height:h
    "perform a bitBlt - requires that all relevant state has been setup
     already"

    destForm copyFrom:sourceForm x:x y:y width:w height:h

    "Modified: 22.1.1997 / 19:01:21 / cg"
!

drawFrom:startPoint to:stopPoint
    "draw a line"

    defaultNib notNil ifTrue:[
	destForm displayLineFrom:startPoint to:stopPoint
    ] ifFalse:[
	"/ need copy loop here to draw source along line ...
    ]

    "Modified: 22.1.1997 / 19:01:44 / cg"
!

drawFromX:startX y:startY toX:stopX y:stopY
    "draw a line"

    defaultNib notNil ifTrue:[
	destForm displayLineFromX:startX y:startY toX:stopX y:stopY
    ] ifFalse:[
	"need copy loop here to draw source along line ..."
    ]

    "Modified: 22.1.1997 / 19:01:49 / cg"
! !

!BitBlt methodsFor:'initialization'!

initialize
    "nothing done here - subclasses may add more"

    ^ self

    "Modified: 22.1.1997 / 19:02:08 / cg"
! !

!BitBlt class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/BitBlt.st,v 1.13 2004/02/19 13:52:53 cg Exp $'
! !
