"{ Package: 'stx:goodies' }"

"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ApplicationModel subclass:#CodeUtility
	instanceVariableNames:'meta'
	classVariableNames:'ProgressReportNotificationSignal'
	poolDictionaries:''
	category:'System-Debugging-Support'
!

!CodeUtility class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
 this class may help you to improve your code -
 (code from here may eventually be brought into the
  SystemBrowser ... for now, take it as a demo/goody).

 File it in, then eval one of:  (see also method comments)

 CodeUtility searchForKeyword:aString
		 will search for methods, where aString is contained
		 in the selector or method comment. 
		 Great help for beginners, when asking: 
			'there must be some method to append a foo' 
		 - let me search for append.
		 Opens a view to show the result after a while.
	     OBSOLETE: this function has already found its way into
		       the browser (apropos).

 CodeUtility searchForString:aString
		 searches in the literal array - to find strings
		 Opens a view to show the result after a while.
	      OBSOLETE: this function has already found its way into
			the browser (search string).

 CodeUtility findClassesWithoutVersion
		 just what the name says - to be prepared for the upcoming
		 source code control system, all classes MUST have a version
		 method which contains its RCS id in a comment.
		 (other source control systems (SCCS for example) may also
		  be supproted in the future)

 CodeUtility findClassesWithoutDocumentation
		 just what the name says
		 All classes should have some doumentation included

 CodeUtility findMethodsWithoutComment
		 just what the name says
		 (I am still working on making this list empty ...-:)
		 I consider it bad style, to NOT have at least some headline
		 comment AND (if appropriate) an example comment at the end.
		 (shame: some of my own code falls into this category ;-)

 CodeUtility findUnsentSelectorsByClass
 CodeUtility findUnsentSelectorsBySelector
		 open a view showing a list of unsent selectors
		 see comment of 'allUnusedSelectors' above.

 CodeUtility allUnusedSelectors
		 return a collection with all unused selectors.

		 Be careful in what you do with this information -
		 there could always be someone doing:
		     'foo perform:(bar asSymbol)'
		 or:
		     Compiler evaluate:someString

		 Dont start to remove the listed methods, without careful
		 thinking ...

 Notice:
    some of the above may take a long time, since all sourcecode (megabytes)
    may have to be processed - especially, if you access the sources via the
    SourceCodeManager (which may checkout files automatically), be prepared
    for a coffee-break.

 there may be more in the future; if you write more goody code of this kind,
 please return it for distribution to others.

 TODO:
     findUnimplementedMethods
		list selectors for which there is no implementor
"
! !

!CodeUtility class methodsFor:'initialization'!

initialize
    ProgressReportNotificationSignal := QuerySignal new.

    "self initialize"

    "Modified: / 6.6.1998 / 20:38:43 / cg"
! !

!CodeUtility class methodsFor:'checking & browsing/displaying'!

browseClassesWithoutDocumentation
    "find & browse all classes which do NOT have a #documentation method"

    SystemBrowser 
	browseClasses:self classesWithoutDocumentation
	title:'classes without a #documentation method'.

    "
     CodeUtility browseClassesWithoutDocumentation
    "
!

browseClassesWithoutVersion
    "find & browse all classes which do NOT have a #version method"

    SystemBrowser 
	browseClasses:self classesWithoutVersion
	title:'classes without a #version method'.

    "
     CodeUtility browseClassesWithoutVersion
    "
!

findClassesWithoutDocumentation
    "find all classes which do NOT have a #documentation method"

    |list|

    list := self classesWithoutDocumentation collect:[:cls | cls name].
    self openViewOn:list title:'classes without documentation'

    "
     CodeUtility findClassesWithoutDocumentation
    "
!

findClassesWithoutVersion
    "find all classes which do not have #version method"

    |list|

    list := self classesWithoutVersion collect:[:cls | cls name].
    self openViewOn:list title:'classes without version'

    "
     CodeUtility findClassesWithoutVersion
    "
!

findMethodsWithoutComment
    "browse all methods which have no comment"

    |list|

    Processor activeProcess withPriority:6 do:[
	list := self methodsWithoutComment.
    ].
    SystemBrowser browseMethods:list title:'methods without comment'.
"/    self openViewOn:list title:'methods without comment'

    "
     CodeUtility findMethodsWithoutComment
    "

    "Modified: / 6.6.1998 / 18:54:43 / cg"
!

findUnsentSelectorsByClass
    "output a list of all selectors which are nowhere sent.
     Notice, this list is not really correct, messages sent by
     the runtime system or by #perform: are not considered and
     therefore included although they should not."

    |allImplementedSelectors list|

    Processor activeProcess withPriority:6 do:[
	allImplementedSelectors := self allUnusedSelectors asSortedCollection.

	list := OrderedCollection new.

	Transcript show:'collecting info ...'; endEntry.
	Smalltalk allBehaviorsDo:[:aClass |
	    |first|

	    first := true.
	    allImplementedSelectors do:[:sel |
		(aClass implements:sel) ifTrue:[
		    first ifTrue:[
			list add:aClass name.
			first := false.
		    ].
		    list add:('    ' , sel)
		].
		(aClass class implements:sel) ifTrue:[
		    first ifTrue:[
			list add:aClass name.
			first := false.
		    ].
		    list add:('    ' , sel)
		]
	    ]
	].
    ].
    Transcript showCR:' done'; endEntry.

    self openViewOn:list title:'unsent selectors'

    "
     CodeUtility findUnsentSelectorsByClass
    "
!

findUnsentSelectorsBySelector
    "output a list of all selectors which are nowhere sent.
     Notice, this list is not really correct, messages sent by
     the runtime system or by #perform: are not considered and
     therefore included although they should not."

    |allImplementedSelectors list|

    Processor activeProcess withPriority:6 do:[
	allImplementedSelectors := self allUnusedSelectors.
	list := OrderedCollection new.

	Transcript show:'collecting info ...'; endEntry.
	allImplementedSelectors asSortedCollection do:[:sel |
	    list add:sel asString.
	    Smalltalk allBehaviorsDo:[:aClass |
		(aClass implements:sel) ifTrue:[
		    list add:('    ' , aClass name)
		].
		(aClass class implements:sel) ifTrue:[
		    list add:('    ' , aClass name , 'class')
		]
	    ]
	]
    ].
    Transcript showCR:' done'; endEntry.

    self openViewOn:list title:'unsent selectors'

    "
     CodeUtility findUnsentSelectorsBySelector
    "
! !

!CodeUtility class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:CodeUtility andSelector:#windowSpec
     CodeUtility new openInterface:#windowSpec
     CodeUtility open
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
	  #window: 
	   #(#WindowSpec
	      #name: 'CodeUtility'
	      #layout: #(#LayoutFrame 33 0 376 0 586 0 810 0)
	      #label: 'CodeUtility'
	      #min: #(#Point 10 10)
	      #max: #(#Point 1280 1024)
	      #bounds: #(#Rectangle 33 376 587 811)
	      #menu: #menu
	      #usePreferredExtent: false
	  )
	  #component: 
	   #(#SpecCollection
	      #collection: 
	       #(
		 #(#SequenceViewSpec
		    #name: 'resultList'
		    #layout: #(#LayoutFrame 0 0.0 0 0.0 0 1.0 -20 1.0)
		    #model: #resultList
		    #menu: #listMenu
		    #hasHorizontalScrollBar: true
		    #hasVerticalScrollBar: true
		    #miniScrollerHorizontal: true
		    #doubleClickSelector: #doBrowseSelectedClass
		    #useIndex: false
		)
		 #(#ProgressIndicatorSpec
		    #name: 'progressIndicator'
		    #layout: #(#LayoutFrame -200 1 -18 1 0 1.0 -2 1)
		    #initiallyInvisible: true
		    #model: #searchProgress
		    #foregroundColor: #(#Color 0.0 0.0 100.0)
		    #backgroundColor: #(#Color 49.9992 100.0 100.0)
		    #showPercentage: false
		)
		 #(#LabelSpec
		    #name: 'activityLabel'
		    #layout: #(#LayoutFrame 0 0 -20 1 -200 1.0 0 1)
		    #labelChannel: #activityHolder
		    #level: -1
		    #adjust: #left
		)
	      )
	  )
      )

    "Modified: / 6.6.1998 / 19:18:48 / cg"
! !

!CodeUtility class methodsFor:'menu specs'!

listMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:CodeUtility andSelector:#menu
     (Menu new fromLiteralArrayEncoding:(CodeUtility menu)) startUp
    "

    <resource: #menu>

    ^
     
       #(#Menu
          
	   #(
	     #(#MenuItem
		#label: 'Browse'
		#translateLabel: true
		#value: #doBrowseSelectedClass
	    )
	  ) nil
	  nil
      )

    "Modified: / 6.6.1998 / 18:12:18 / cg"
    "Created: / 6.6.1998 / 18:13:18 / cg"
!

menu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:CodeUtility andSelector:#menu
     (Menu new fromLiteralArrayEncoding:(CodeUtility menu)) startUp
    "

    <resource: #menu>

    ^
     
       #(#Menu
          
	   #(
	     #(#MenuItem
		#label: 'File'
		#translateLabel: true
		#submenu: 
		 #(#Menu
                    
		     #(
		       #(#MenuItem
			  #label: 'Quit'
			  #translateLabel: true
			  #value: #doQuit
		      )
		    ) nil
		    nil
		)
	    )
	     #(#MenuItem
		#label: 'Search'
		#translateLabel: true
		#submenu: 
		 #(#Menu
                    
		     #(
		       #(#MenuItem
			  #label: 'Documentation'
			  #translateLabel: true
			  #submenu: 
			   #(#Menu
                              
			       #(
				 #(#MenuItem
				    #label: 'Undocumented Classes'
				    #translateLabel: true
				    #value: #doSearchUndocumentedClasses
				)
				 #(#MenuItem
				    #label: 'Undocumented Methods'
				    #translateLabel: true
				    #value: #doSearchUndocumentedMethods
				)
			      ) nil
			      nil
			  )
		      )
		       #(#MenuItem
			  #label: 'Messages'
			  #translateLabel: true
			  #submenu: 
			   #(#Menu
                              
			       #(
				 #(#MenuItem
				    #label: 'Unsent Messages'
				    #translateLabel: true
				    #value: #doSearchUnsentMessages
				)
				 #(#MenuItem
				    #label: '-'
				)
				 #(#MenuItem
				    #label: 'Unimplemented Messages'
				    #translateLabel: true
				    #value: #doSearchUnimplementedMessages
				)
				 #(#MenuItem
				    #label: 'Unimplemented SubclassResponsibility'
				    #translateLabel: true
				    #value: #doSearchUnimplementedSubclassResponsibilities
				)
			      ) nil
			      nil
			  )
		      )
		    ) nil
		    nil
		)
	    )
	     #(#MenuItem
		#label: 'Help'
		#translateLabel: true
		#startGroup: #right
		#submenu: 
		 #(#Menu
                    
		     #(
		       #(#MenuItem
			  #label: 'No help yet'
			  #translateLabel: true
		      )
		    ) nil
		    nil
		)
	    )
	  ) nil
	  nil
      )

    "Modified: / 6.6.1998 / 18:13:35 / cg"
! !

!CodeUtility class methodsFor:'private'!

allUnusedSelectors
    |setOfSelectors|

    "first of all, collect all selectors in a set"

    setOfSelectors := IdentitySet new:6000.

    Transcript show:'collecting selectors ...'; endEntry.
    self allMethodsWithSelectorAndClassDo:[:method :sel :class |
	setOfSelectors add:sel
    ].
    Transcript showCR:' done'; endEntry.

    "
     remove some, known to be never sent
    "
    setOfSelectors removeAll:#(#copyright
			       #documentation
			       #examples 
			       #version).

    "then walk over all methods, removing selectors sent from the set"

    Transcript show:'finding used selectors ...'; endEntry.
    self allMethodsWithSelectorAndClassDo:[:method :sel :class |
	|lits|

	lits := method literals.
	lits notNil ifTrue:[
	    lits do:[:lit |
		"not quite correct but ..."
		(lit isMemberOf:Symbol) ifTrue:[
		    setOfSelectors remove:lit ifAbsent:[]
		]
	    ]
	]
    ].
    Transcript showCR:' done'; endEntry.
    ^ setOfSelectors

    "CodeUtility allUnusedSelectors"
!

classesWithoutDocumentation
    "return a collection of all classes which do NOT have #documentation method.
     Should return an empty collection (at least not containing one of yours ;-)"

    Processor activeProcess withPriority:6 do:[
	|list|

	list := OrderedCollection new.

	self allClassesFrom:Smalltalk allClasses do:[:aClass |
	    aClass isMeta ifFalse:[
		aClass isLoaded ifTrue:[
		    aClass isNameSpace ifFalse:[
			(aClass class implements:#documentation) ifFalse:[
			     list add:aClass
			].
		    ]
		].
	    ].
	].
	^ list sort:[:a :b | a name < b name].
    ].

    "
     CodeUtility classesWithoutDocumentation
    "

    "Modified: / 6.6.1998 / 18:59:42 / cg"
!

classesWithoutVersion
    "return a collection of classes which do not have #version method"

    |list|

    Processor activeProcess withPriority:6 do:[
	list := IdentitySet new.

	self allClassesFrom:(Smalltalk allClasses) do:[:aClass |
	    aClass isMeta ifFalse:[
		aClass isNameSpace ifFalse:[
		    aClass isLoaded ifTrue:[
			aClass isPrivate ifFalse:[
			    (aClass class implements:#version) ifFalse:[
				 list add:aClass
			    ]
			]
		    ].
		]
	    ].
	].
	^ list asOrderedCollection sort:[:a :b | a name < b name]
    ].

    "
     CodeUtility classesWithoutVersion
    "

    "Modified: / 6.6.1998 / 19:01:03 / cg"
!

methodsWithoutComment
    "return a list of all methods which have no comment"

    Processor activeProcess withPriority:6 do:[
	|list|

	list := OrderedCollection new:500.

	self allMethodsWithSelectorAndClassDo:[:method :sel :class |
	    (class isMeta and:[sel == #version]) ifFalse:[
		method comment isNil ifTrue:[
		    list add:(class name , ' ' "'>>'" , sel)
		].
	    ]
	].
	^ list sort.
    ].

    "Created: / 6.6.1998 / 18:38:51 / cg"
    "Modified: / 6.6.1998 / 20:53:02 / cg"
!

openViewOn:aList title:aString
    |top s l|

    top := StandardSystemView new.
    top label:'CodeUtility output of ' , aString.
    s := ScrollableView for:TextView in:top.
    s origin:0.0@0.0 corner:1.0@1.0.
    s scrolledView list:aList.
    top open.
!

progressReport:percent
    "shout out my percentage - dont care if noone is listening"

    ProgressReportNotificationSignal raiseWith:percent

    "Created: / 6.6.1998 / 17:52:05 / cg"
! !

!CodeUtility class methodsFor:'private - helpers'!

allClassesFrom:classList do:aBlock
    "walk over all classes in classList, and evaluate the argument,
     aBlock with the class as argument.
     Informs about progress."

    |nDone nAll percentDone lastProgress|

    self progressReport:0.
    lastProgress := nDone := 0.

    nAll := classList size.

    classList do:[:aClass |
	self activityNotification:'processing ' , aClass name.

	aBlock value:aClass.

	nDone := nDone + 1.

	percentDone := ((nDone / nAll) * 100) rounded.
	percentDone - lastProgress >= 5 ifTrue:[
	    self progressReport:percentDone.
	    lastProgress := percentDone.
	].
    ].

    self progressReport:100.

    "Created: / 6.6.1998 / 18:57:41 / cg"
    "Modified: / 6.6.1998 / 20:45:52 / cg"
!

allMethodsWithSelectorAndClassDo:aThreeArgBlock
    "walk over all methods in the system, and evaluate the argument,
     aThreeArgBlock with the method, the class and the selector as arguments.
     Helper for other utility methods here."


    self allMethodsWithSelectorAndClassFrom:Smalltalk allClasses do:aThreeArgBlock

    "Modified: / 6.6.1998 / 18:58:58 / cg"
!

allMethodsWithSelectorAndClassFrom:classList do:aThreeArgBlock
    "walk over all methods in classList, and evaluate the argument,
     aThreeArgBlock with the method, the class and the selector as arguments.
     Informs about progress.
     Helper for other utility methods here."

    self allClassesFrom:classList do:[:aClass |
	aClass methodDictionary keysAndValuesDo:[:selector :method|
	    aThreeArgBlock value:method value:selector value:aClass
	].
	aClass class methodDictionary keysAndValuesDo:[:selector :method|
	    aThreeArgBlock value:method value:selector value:aClass class
	].
    ].

    "Created: / 6.6.1998 / 18:54:10 / cg"
    "Modified: / 6.6.1998 / 18:58:29 / cg"
! !

!CodeUtility class methodsFor:'searching'!

searchForKeyword:aString
    "outputs a list of methods where keyword occurs in the methods comment,
     or selector.
     This is relatively slow, since all source must be processed."

    |matchString list|

    matchString := '*' , aString , '*'.

    list := OrderedCollection new.

    Processor activeProcess withPriority:6 do:[
	self allMethodsWithSelectorAndClassDo:[:method :sel :class |
	    (matchString match:sel) ifTrue:[
		list add:(class name , '>>' , sel)
	    ] ifFalse:[
		(matchString match:(method comment)) ifTrue:[
		    list add:(class name , '>>' , sel)
		]
	    ]
	]
    ].
    self openViewOn:list title:('search for keyword ''' , aString , '''')


    "
     CodeUtility searchForKeyword:'append'
     CodeUtility searchForKeyword:'stream'
     CodeUtility searchForKeyword:'multiply'
    "
!

searchForString:aString
    "outputs a list of methods where aString is used (can be used to find
     originators of error/output messages).
     Sorry: as of 2.10.4, this does not work, since STC does not (yet)
     put strings into the literal array of compiled code."

    |matchString list|

    matchString := '*' , aString , '*'.

    list := OrderedCollection new.

    Processor activeProcess withPriority:6 do:[
	self allMethodsWithSelectorAndClassDo:[:method :sel :class |
	    method literals notNil ifTrue:[
		method literals do:[:lit |
		    (lit isMemberOf:String) ifTrue:[
			(matchString match:lit) ifTrue:[
			    list add:(class name , '>>' , sel)
			]
		    ]
		]
	    ]
	]
    ].
    self openViewOn:list title:('search for string ''' , aString , '''')

    "
     CodeUtility searchForString:'unchanged'
    "
!

selectorUsage
    "code adapted from Jonathan Pletzkes 'Advanced Smalltalk'

     Claus: this is exactly the kind of inperformant programming,
	    described in the smalltalk performance document;
	    this one takes hours to do its job
	    - see selectorUsage2 for a much faster version ..."

    |massiveDictionary myStream smallDictionary|

    "/ buildDictionary

    Transcript showCR:'build massiveDictionary ...'; endEntry.

    massiveDictionary := Dictionary new.
    (Method allInstances 
	collect:[:each |
	    |who|

	    (who := each who) notNil ifTrue:[
		who at:2
	    ] ifFalse:[
		nil
	    ]
	]) asSet asOrderedCollection do:[:each |
	    massiveDictionary at:each put:((SystemBrowser allCallsOn:each)size)
	].

    Transcript showCR:'build smallDictionary ...'; endEntry.

    smallDictionary := (massiveDictionary asSortedCollection reverse
			select:[:each | each > 100])
			    inject:Dictionary new
			    into:[:res :each |
					res at:each put:(massiveDictionary keyAtValue:each);yourself].

    myStream := (Filename named:'output') writeStream.
    (smallDictionary keys collect:[:each | each asInteger])
	asSortedCollection reverse do:[:key |
					myStream nextPutAll:key printString;
						 tab;
						 nextPutAll:(smallDictionary at:key) printString;
						 cr].
    myStream close

    "
     CodeUtility selectorUsage
    "

    "Modified: 30.1.1997 / 15:58:47 / cg"
!

selectorUsage2
    "count usage of selectors (takes roughly 4 seconds)"

    |selectorBag filteredBag implementedSelectors toBeRemoved allClasses
     assocList sortedAssocList myStream|

    "/
    "/ collect all used selectors
    "/

    selectorBag := Bag identityNew:100000.

    Transcript showCR:'collecting used symbols ...'; endEntry.

    Method allInstances do:[:aMethod |
       "/ walk over all messages sent by this method

       "/ actually, messages also returns the names of globals and
       "/ symbols. We dont care here, filtering things out later
	selectorBag addAll:(aMethod messages).
    ].


    "/
    "/ filter out non-selectors
    "/

"/ (I was) naive:
"/     "/Notice: you may remove elements from a Bag while iterating over it ...
"/
"/     toBeRemoved := IdentitySet new.
"/     allClasses := Smalltalk allClasses.
"/     selectorBag valuesAndCountsDo:[:selector :count |
"/        (allClasses detect:[:aClass | aClass implements:selector] ifNone:nil)
"/        isNil ifTrue:[
"/            "/ that one is not a message
"/            toBeRemoved add:selector
"/        ]
"/     ].
"/
"/     toBeRemoved do:[:selector |
"/         selectorBag removeAllOccurrencesOf:selector ifAbsent:#oops
"/     ].

    Transcript showCR:'collect implemented selectors ...'; endEntry.

"/ thats better:
    implementedSelectors := IdentitySet new.
    Smalltalk allClasses do:[:aClass |
	implementedSelectors addAll:(aClass methodDictionary keys)
    ].

    Transcript showCR:'filter implemented selectors ...'; endEntry.

    filteredBag := Bag identityNew:100000.   
    selectorBag valuesAndCountsDo:[:selector :count |
	(implementedSelectors includes:selector) ifTrue:[
	     filteredBag add:selector withOccurrences:count
	]
    ].

    Transcript showCR:'filter selectors with 100+ uses ...'; endEntry.
    assocList := filteredBag contents associations select:[:a | a value >= 100].

    "/
    "/ sort by usage
    "/

    Transcript showCR:'sort by usage ...'; endEntry.

    sortedAssocList := assocList asSortedCollection:[:a :b | a value > b value].

    myStream := (Filename named:'output') writeStream.
    myStream nextPutAll:'selectors used in 100+ methods:'; cr; cr.

    sortedAssocList do:[:assoc |
	    |k|

	    k := (assoc key printString, ' ') paddedTo:40 with:$..
	    myStream nextPutAll:k;
		     tab;
		     nextPutAll:(assoc value) printString;
		     cr].
    myStream close.

    Transcript showCR:'open viewer ...'; endEntry.
    TextView openOn:'output'.

    "
     CodeUtility selectorUsage2
    "

    "Modified: 30.1.1997 / 15:57:32 / cg"
! !

!CodeUtility methodsFor:'aspects'!

activityHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept in the browser."

    |holder|

    (holder := builder bindingAt:#activityHolder) isNil ifTrue:[
	builder aspectAt:#activityHolder put:(holder :=  ValueHolder new).
    ].
    ^ holder

    "Created: / 6.6.1998 / 19:06:33 / cg"
!

resultList
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept in the browser."

    |holder|

    (holder := builder bindingAt:#resultList) isNil ifTrue:[
	builder aspectAt:#resultList put:(holder :=  SelectionInList new).
    ].
    ^ holder

    "Created: / 6.6.1998 / 17:46:10 / cg"
!

searchProgress
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept in the browser."

    |holder|

    (holder := builder bindingAt:#searchProgress) isNil ifTrue:[
	builder aspectAt:#searchProgress put:(holder :=  100 asValue).
    ].
    ^ holder

    "Created: / 6.6.1998 / 17:46:10 / cg"
    "Modified: / 6.6.1998 / 19:10:31 / cg"
! !

!CodeUtility methodsFor:'helpers'!

busyAction:aBlock
    self withWaitCursorDo:[
	Object activityNotificationSignal handle:[:ex |
	    self activityHolder value:ex errorString.
	    ex resume
	] do:[
	    self showProgressWhile:aBlock
	]
    ]

    "Created: / 6.6.1998 / 19:12:06 / cg"
    "Modified: / 6.6.1998 / 19:18:30 / cg"
!

showProgressWhile:aBlock
    |result progressIndicator|

    progressIndicator := self builder componentAt:#progressIndicator.
    progressIndicator beVisible.
    progressIndicator invalidateRepairNow:true.
    [
	ProgressReportNotificationSignal handle:[:ex |
	    self searchProgress value:ex parameter.
	    ex proceed.
	] do:[
	    result := aBlock value
	].
    ] valueNowOrOnUnwindDo:[
	progressIndicator beInvisible.
    ].
    self activityNotification:nil.

    ^ result

    "Modified: / 6.6.1998 / 20:50:12 / cg"
! !

!CodeUtility methodsFor:'menu actions'!

doBrowseSelectedClass
    |selection words name class sel|

    selection := (self builder componentAt:#resultList) selectionValue.
    words := selection asCollectionOfWords.
    name := words first.
    class := Smalltalk at:(name asSymbol).

    words size == 1 ifTrue:[
	meta == true ifTrue:[
	    class := class class
	].
    ] ifFalse:[
	words size > 2 ifTrue:[
	    (sel := words at:3) asSymbol.
	    class := class class.
	] ifFalse:[
	    (sel := words at:2) asSymbol
	].
    ].
    SystemBrowser openInClass:class selector:sel.

    "Created: / 6.6.1998 / 18:14:58 / cg"
    "Modified: / 6.6.1998 / 20:57:46 / cg"
!

doQuit
    self closeRequest

    "Created: / 6.6.1998 / 17:46:44 / cg"
!

doSearchUndocumentedClasses
    self busyAction:[
	|list|

	list := self class classesWithoutDocumentation.

	list := list collect:[:cls | cls name].
	list sort.
	self resultList list:list.

	meta := true.
    ]

    "Modified: / 6.6.1998 / 19:12:30 / cg"
!

doSearchUndocumentedMethods
    self busyAction:[
	|list|

	list := self class methodsWithoutComment.

	list sort.
	self resultList list:list.

	meta := true.
    ]

    "Created: / 6.6.1998 / 19:03:24 / cg"
    "Modified: / 6.6.1998 / 19:27:36 / cg"
! !

!CodeUtility class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/CodeUtility.st,v 1.13 2000/03/24 17:26:44 cg Exp $'
! !
CodeUtility initialize!
