"{ Package: 'stx:goodies' }"

"
    this class has been extracted from the manchester goodies
    library - it is not covered by the Smalltalk/X copyright.

    The original readme text is:

    COPYRIGHT.
    The above file is a Manchester Goodie protected by copyright.
    These conditions are imposed on the whole Goodie, and on any significant
    part of it which is separately transmitted or stored:
	   * You must ensure that every copy includes this notice, and that
	     source and author(s) of the material are acknowledged.
	   * These conditions must be imposed on anyone who receives a copy.
	   * The material shall not be used for commercial gain without the prior
	     written consent of the author(s).
    Further information on the copyright conditions may be obtained by
    sending electronic mail:
	   To: goodies-lib@cs.man.ac.uk
	   Subject: copyright
    or by writing to The Smalltalk Goodies Library Manager, Dept of
    Computer Science, The University, Manchester M13 9PL, UK

    (C) Copyright 1993 University of Manchester
    For more information about the Manchester Goodies Library (from which 
    this file was distributed) send e-mail:
	   To: goodies-lib@cs.man.ac.uk
	   Subject: help 
"

ValueLink subclass:#ChainLink
	instanceVariableNames:'previousLink'
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-Support'
!

ChainLink comment:'ChainLinks are individual elements in a doubly-linked chain or ring. 
Chains use ChainLinks to hold their elements.  Each ChainLink has an
arbitrary object as its value.

Instance Variables:
	nextLink                <ChainLink or Chain>  The ChainLink after this one or the Chain
itself if this is the last link.
	previousLink    <ChainLink or Chain>  The ChainLink before this one or the
Chain itself if this is the first link.
	value                   <Object>  The arbitrary object associated with this link.'!

!ChainLink class methodsFor:'documentation'!

copyright
"
    this class has been extracted from the manchester goodies
    library - it is not covered by the Smalltalk/X copyright.

    The original readme text is:

    COPYRIGHT.
    The above file is a Manchester Goodie protected by copyright.
    These conditions are imposed on the whole Goodie, and on any significant
    part of it which is separately transmitted or stored:
	   * You must ensure that every copy includes this notice, and that
	     source and author(s) of the material are acknowledged.
	   * These conditions must be imposed on anyone who receives a copy.
	   * The material shall not be used for commercial gain without the prior
	     written consent of the author(s).
    Further information on the copyright conditions may be obtained by
    sending electronic mail:
	   To: goodies-lib@cs.man.ac.uk
	   Subject: copyright
    or by writing to The Smalltalk Goodies Library Manager, Dept of
    Computer Science, The University, Manchester M13 9PL, UK

    (C) Copyright 1993 University of Manchester
    For more information about the Manchester Goodies Library (from which 
    this file was distributed) send e-mail:
	   To: goodies-lib@cs.man.ac.uk
	   Subject: help 
"
!

documentation
"
    ChainLinks are individual elements in a doubly-linked chain or ring. 
    Chains use ChainLinks to hold their elements.  Each ChainLink has an
    arbitrary object as its value.

    [Instance Variables:]
	nextLink        <ChainLink or Chain>  The ChainLink after this one or the Chain
					      itself if this is the last link.

	previousLink    <ChainLink or Chain>  The ChainLink before this one or the
					      Chain itself if this is the first link.

	value           <Object>              The arbitrary object associated with this link.

    [see also:]
	Chain

    [author:]
	carl@ParcPlace.com (Carl Watts)
"
! !

!ChainLink methodsFor:'accessing'!

nextLink
    "Answer the next ChainLink after the receiver."

    ^ nextLink linkAfterPreviousLink

    "Modified: 9.5.1996 / 16:13:29 / cg"
!

previousLink
    "Answer the ChainLink before the receiver."

    ^ previousLink linkBeforeNextLink

    "Modified: 9.5.1996 / 16:13:36 / cg"
! !

!ChainLink methodsFor:'inserting'!

afterInsert: aValue
    "Insert aValue as the value after the receiver in the same chain."

    self afterInsertLink:(ChainLink value:aValue)

    "Modified: 9.5.1996 / 16:13:56 / cg"
!

afterInsertLink: aLink
    "Insert aLink as the link after the receiver."

    aLink previousLink:self nextLink:nextLink

    "Modified: 9.5.1996 / 16:13:51 / cg"
!

beforeInsert: aValue
    "Insert aValue as the link before the receiver in the same Chain."

    self beforeInsertLink:(ChainLink value:aValue)

    "Modified: 9.5.1996 / 16:14:05 / cg"
!

beforeInsertLink: aLink
    "Insert aLink as the link before the receiver in the same Chain."

    aLink previousLink:previousLink nextLink:self

    "Modified: 9.5.1996 / 16:14:13 / cg"
! !

!ChainLink methodsFor:'private'!

linkAfterPreviousLink
    "Answer the link after the receiver's previous link."
    "Double-Dispatched Method.  For the receiver answer self."

    ^ self

    "Modified: 9.5.1996 / 16:14:24 / cg"
!

linkBeforeNextLink
    "Answer the link before the receiver's next link."
    "Double-Dispatched Method.  For the receiver answer self."

    ^ self

    "Modified: 9.5.1996 / 16:14:31 / cg"
!

nextLinkIsFirst
    "Answer if the nextLink is the first link in the chain."
    "Double-dispatched from a ChainLink. 
     The next link can't be the last link in the chain because I'm before it."

    ^ false

    "Modified: 9.5.1996 / 16:14:46 / cg"
!

previousLink: beforeLink nextLink: afterLink
    "Set the links before and after the receiver."

    previousLink := beforeLink.
    nextLink := afterLink.
    previousLink setNextLink: self.
    nextLink setPreviousLink: self

    "Modified: 9.5.1996 / 16:14:51 / cg"
!

previousLinkIsLast
    "Answer if the previousLink is the last link in the chain."
    "Double-dispatched from another ChainLink.  
     The previous link can't be the last link in the chain because I'm after it."

    ^false

    "Modified: 9.5.1996 / 16:15:03 / cg"
!

setNextLink: aLink
    "Set the next ChainLink after the receiver."

    nextLink := aLink

    "Modified: 9.5.1996 / 16:15:07 / cg"
!

setPreviousLink: aLink
    "Set the ChainLink before the receiver."

    previousLink := aLink

    "Modified: 9.5.1996 / 16:15:12 / cg"
! !

!ChainLink methodsFor:'removing'!

remove
    "Remove the receiver from the Chain."

    previousLink setNextLink: nextLink.
    nextLink setPreviousLink: previousLink.
    nextLink := previousLink := nil

    "Modified: 9.5.1996 / 16:15:16 / cg"
! !

!ChainLink methodsFor:'testing'!

isFirst
    "Answer if the receiver is the first link in its chain."

    ^previousLink nextLinkIsFirst

    "Modified: 9.5.1996 / 16:15:21 / cg"
!

isLast
    "Answer if the receiver is the last link in its chain."

    ^nextLink previousLinkIsLast

    "Modified: 9.5.1996 / 16:15:25 / cg"
! !

!ChainLink class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/Collections-ChainLink.st,v 1.5 2000/03/02 14:14:18 cg Exp $'
! !
