"{ Package: 'stx:goodies' }"

"
 This is a Manchester Goodie protected by copyright.
 These conditions are imposed on the whole Goodie, and on any significant
 part of it which is separately transmitted or stored:
	* You must ensure that every copy includes this notice, and that
	  source and author(s) of the material are acknowledged.
	* These conditions must be imposed on anyone who receives a copy.
	* The material shall not be used for commercial gain without the prior
	  written consent of the author(s).

 Further information on the copyright conditions may be obtained by
 sending electronic mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: copyright
 or by writing to The Smalltalk Goodies Library Manager, Dept of
 Computer Science, The University, Manchester M13 9PL, UK

 (C) Copyright 1992 University of Manchester
 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: help 
"


Set subclass:#KeyedSet
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-Unordered'
!

!KeyedSet class methodsFor:'documentation'!

copyright
"
 This is a Manchester Goodie protected by copyright.
 These conditions are imposed on the whole Goodie, and on any significant
 part of it which is separately transmitted or stored:
	* You must ensure that every copy includes this notice, and that
	  source and author(s) of the material are acknowledged.
	* These conditions must be imposed on anyone who receives a copy.
	* The material shall not be used for commercial gain without the prior
	  written consent of the author(s).

 Further information on the copyright conditions may be obtained by
 sending electronic mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: copyright
 or by writing to The Smalltalk Goodies Library Manager, Dept of
 Computer Science, The University, Manchester M13 9PL, UK

 (C) Copyright 1992 University of Manchester
 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: help 
"

!

documentation
"
    [info:]
	NAME            collections-misc
	AUTHOR          miw@cs.man.ac.uk (Mario Wolczko)
	FUNCTION        assorted collection-related things
	ST-VERSION      4.0 4.1
	PREREQUISITES   
	CONFLICTS
	DISTRIBUTION    world
	VERSION         2
	DATE            3 Dec 1991

    A KeyedSet has the ability to locate an element of the set based on its hash,
    using #at:.'
    It is useful, if you want to look for an equal value, and need access to the
    corresponding object.
    (i.e. if there is something equal to my key in the set, which object
     is it).

    [note:]
	claus: should we move these two methods up to Set ?.
        
    [author:]
	Mario Wolczko

    [see also:]
	Set        
"
! !

!KeyedSet methodsFor:'accessing'!

at:key
    "return key if it is present in the set. 
     If it is not, raise an error."

    ^ self at: key ifAbsent: [self errorNotFound]

    "
     |k|
     k := KeyedSet withAll:#('foo' 'bar').
     k at:'foo'. 
     k at:'baz'. 
    "
!

at:key ifAbsent:aBlock
    "return key if it is present in the set. If it is not,
     return the value from aBlock."

    |index|

    index := self find:key ifAbsent:[^ aBlock value].
    ^ keyArray basicAt:index

    "
     |k|
     k := KeyedSet withAll:#('foo' 'bar').
     k at:'foo' ifAbsent:nil. 
     k at:'baz' ifAbsent:nil.  
    "

    "claus: that makes more sense (get the corresponding symbol):
     |k|
     k := KeyedSet withAll:#(foo bar).
     k at:'foo' ifAbsent:nil. 
     k at:'baz' ifAbsent:nil.  
    "

    "Modified: 16.1.1997 / 13:30:27 / cg"
! !

!KeyedSet class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/Collections-KeyedSet.st,v 1.5 2000/03/02 14:14:25 cg Exp $'
! !
