"{ Package: 'stx:goodies' }"

"
 COPYRIGHT.
 The above file is a Manchester Goodie protected by copyright.
 These conditions are imposed on the whole Goodie, and on any significant
 part of it which is separately transmitted or stored:
	* You must ensure that every copy includes this notice, and that
	  source and author(s) of the material are acknowledged.
	* These conditions must be imposed on anyone who receives a copy.
	* The material shall not be used for commercial gain without the prior
	  written consent of the author(s).
 Further information on the copyright conditions may be obtained by
 sending electronic mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: copyright
 or by writing to The Smalltalk Goodies Library Manager, Dept of
 Computer Science, The University, Manchester M13 9PL, UK

 (C) Copyright 1993 University of Manchester
 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: help 
"

Object subclass:#Run
	instanceVariableNames:'length value'
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-Support'
!

!Run class methodsFor:'documentation'!

copyright
"
 COPYRIGHT.
 The above file is a Manchester Goodie protected by copyright.
 These conditions are imposed on the whole Goodie, and on any significant
 part of it which is separately transmitted or stored:
	* You must ensure that every copy includes this notice, and that
	  source and author(s) of the material are acknowledged.
	* These conditions must be imposed on anyone who receives a copy.
	* The material shall not be used for commercial gain without the prior
	  written consent of the author(s).
 Further information on the copyright conditions may be obtained by
 sending electronic mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: copyright
 or by writing to The Smalltalk Goodies Library Manager, Dept of
 Computer Science, The University, Manchester M13 9PL, UK

 (C) Copyright 1993 University of Manchester
 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: help 
"
!

documentation
"
    I represent a sequence of a particular value. 
    I am used by CompressedOrderedCollection.


    [Instance Variables:]
	length          <Integer>       The number of instances of my value
					which I represent.

	value           <Anything>      The value which I represent


    [info:]
	NAME            CompressedOrderedCollection
	AUTHOR          RMD@cs.man.ac.uk
	FUNCTION like RunArrays, for OrderedCollections 
	ST-VERSIONS     2.2
	PREREQUISITES    
	CONFLICTS       
	DISTRIBUTION    world
	VERSION         1.1
	DATE    22 Jan 1989

    [author:]
	RMD@cs.man.ac.uk

    [see also:]
	CompressedOrderedCollection
"
! !

!Run class methodsFor:'instance creation'!

length: anInteger value: anObject
	"Create a run of length anInteger with value anObject."

	^super new length: anInteger value: anObject!

new
	"You probably shouldn't use this"

	self length: 0 value: nil
! !

!Run methodsFor:'accessing'!

length
    "Return the length of this run"

    ^length
!

length: anInteger
    "Set the length of this run"

    length := anInteger
!

length: anInteger value: anObject
    "set the length and value of this run"

    length := anInteger.
    value := anObject
!

value
    "Return the value of this run"

    ^value
!

value: anObject
    "Set the value of this run"

    value := anObject
! !

!Run methodsFor:'adding'!

increaseLength: anInteger
    "Add anInteger to the length."

    length := length + anInteger
!

incrementLength
    "Add one to the length."

    length := length + 1
! !

!Run methodsFor:'printing'!

printOn: aStream 
    "append to aStream a sequence of characters that identifies the receiver. "

    aStream nextPutAll:'a Run(length: ' 
		       , self length printString
		       , ' value: '
		       , self value printString , ')'
!

storeOn: aStream 
    "Append to aStream an expression which, if evaluated, will generate  
    an object similar to the receiver."

    aStream nextPutAll: 'Run new length: '
			 , self length printString
			 , ' value:
			 ' , self value printString
! !

!Run methodsFor:'removing'!

decreaseLength: anInteger
    "Remove anInteger items, returning my value"

    length - anInteger < 0
    ifTrue:[self error: 'under run'].
    length := length - anInteger.
    ^value
!

decrementLength
    "Remove one item, returning my value"

    length <= 0
    ifTrue:[self error: 'under run'].
    length := length - 1.
    ^value
! !

!Run class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/Collections-Run.st,v 1.4 2000/03/02 14:14:28 cg Exp $'
! !
