"{ Package: 'stx:goodies' }"

"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"



Array subclass:#Commander
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-Support'
!

!Commander class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


!

documentation
"
    This class was added as a goody for playing and for ST-80rel2.x compatibility.
    Notice:
	This class may be no longer present in newer ST-80 releases

    also notice, that ST/X does not use or need Commander in any way.
    This is a demo class - no WARRANTY whatsoever.

    written spring/summer 89 by claus

    [see also:]
	BitBlt Pen
	GraphicsContext

    [author:]
	Claus Gittinger

    [start with:]
	CommanderDemo open
"
!

examples
"
								[exBegin]
    |v c|

    v := (View extent:300@300) openAndWait.

    c := Commander new:8 in:v.

    c fanOut.
    c up.
    c go:50.
    c down.

    c spiral:60 angle:89
								[exEnd]


								[exBegin]
    |v c|

    v := (View extent:300@300) openAndWait.

    c := Commander new:8 in:v.

    c lineUpFrom:40@100 to:200@100.
    c up.
    c go:50.
    c down.

    c spiral:60 angle:89
								[exEnd]
"
! !

!Commander class methodsFor:'instance creation'!

new:numberOfPens
    |newCommander|
    newCommander := super new:numberOfPens.
    1 to:numberOfPens do:[ :index |
	newCommander at:index put:Pen new
    ].
    ^ newCommander
!

new:numberOfPens in:aDrawable
    |newCommander|
    newCommander := super new:numberOfPens.
    1 to:numberOfPens do:[ :index |
	newCommander at:index put:(Pen in:aDrawable)
    ].
    ^ newCommander
! !

!Commander methodsFor:'distributing'!

fanOut
    "change all pens directions to point avay from each other"

    |dist|

    dist := (360 / self size).

    self keysAndValuesDo:[:idx :pen |
	pen turn:(idx - 1) * dist
    ]

    "Modified: 16.5.1996 / 16:00:05 / cg"
!

lineUpFrom:startPoint to:endPoint
    "place all pens along a line"

    1 to:self size do:[:index |
	(self at:index)
	    place:startPoint +
		  (endPoint - startPoint * (index - 1)/(self size - 1))
    ]

    "Modified: 16.5.1996 / 16:00:26 / cg"
! !

!Commander methodsFor:'everything else'!

doesNotUnderstand:aMessage
    "this is funny: all message we do not understand, are passed
     on to every Pen - so we do not have to care for all
     possible messages ...(thanks to the Message class)"

    self do:[:each |
	each perform:(aMessage selector) withArguments:(aMessage arguments)
    ]

    "Modified: 16.5.1996 / 15:58:03 / cg"
! !

!Commander class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/Commander.st,v 1.6 2000/03/02 14:14:35 cg Exp $'
! !
