"
    Jun430 (2002/05/28) 

    Copyleft 1996-2002 
        AOKI Atsushi, ODA Tomohiro, HOSHI Takanori, NISHINAKA Yoshiyuki, 
        YAMADA Ryousuke, WATANABE Katsuhiro, Ankur J. Chavda, NISHIHARA Satoshi, MATSUDA Ryouichi, 
        MATSUO Minoru, Brent N. Reeves, ASAOKA Hiroko, and TANAKA Shinichi.
"
"{ Package: 'stx:goodies' }"

Object subclass:#GNUDiff
	instanceVariableNames:'sequence1 sequence2 length1 length2 changedFlags1 changedFlags2
		equivs1 equivs2 equivMax undiscarded1 undiscarded2 realindexes1
		realindexes2 nondiscardedLines fdiag bdiag tooExpensive'
	classVariableNames:''
	poolDictionaries:''
	category:'Jun-Goodies-Difference'
!


!GNUDiff class methodsFor:'instance creation'!

with: aSequence with: anotherSequence 
    | aDifference |

    aDifference := self new.
    aDifference sequence1: aSequence.
    aDifference sequence2: anotherSequence.
    ^aDifference

    "
     (self with:#(1 2 3 4 5 6) with:#(1 2 33 4 5 6)) compare
     (self with:#(1 2 3 5 6) with:#(1 2 33 4 5 6)) compare
    "

    "Modified: / 27-03-2007 / 12:07:30 / cg"
! !

!GNUDiff class methodsFor:'copyright'!

copyright
"
    Jun430 (2002/05/28) 

    Copyleft 1996-2002 
        AOKI Atsushi, ODA Tomohiro, HOSHI Takanori, NISHINAKA Yoshiyuki, 
        YAMADA Ryousuke, WATANABE Katsuhiro, Ankur J. Chavda, NISHIHARA Satoshi, MATSUDA Ryouichi, 
        MATSUO Minoru, Brent N. Reeves, ASAOKA Hiroko, and TANAKA Shinichi.
"

    "Modified: / 27-03-2007 / 12:00:41 / cg"
!

documentation
"
    The GNU diff algorithm.

"

    "Created: / 27-03-2007 / 12:08:54 / cg"
! !

!GNUDiff methodsFor:'accessing'!

changedFlags1
	^changedFlags1
!

changedFlags2
	^changedFlags2
!

sequence1
	^sequence1
!

sequence1: aSequence 
	sequence1 := aSequence.
	length1 := aSequence size.
	changedFlags1 := nil
!

sequence2
	^sequence2
!

sequence2: aSequence 
	sequence2 := aSequence.
	length2 := aSequence size.
	changedFlags2 := nil
! !

!GNUDiff methodsFor:'comparing'!

calcEquivs
    |equivsDictionary|

    equivsDictionary := Dictionary new.
    equivMax := 0.
    1 to:2 do:[:f | 
        (self sequenceAt:f) 
            keysAndValuesDo:[:i :val | 
                (self equivsAt:f) at:i
                    put:(equivsDictionary at:val ifAbsentPut:[ equivMax := equivMax + 1 ]).
            ].
    ].

    "Modified: / 27-03-2007 / 09:28:50 / cg"
!

compare
    "
     This code is based on GNU diffutils 2.7.
     The original C source code should be found at usual GNU sites.

     This algorithm is based on:
            An O(ND) Difference Algorithm and Its Variations
            Eugene Myers
            Algorithmica Vol. 1 No.2, 1986, pp. 251-266
     which can be downloaded from author's homepage at:
            http://www.cs.arizona.edu/people/gene/"
    
    |changed1 changed2|

    equivs1 := Array new:length1.
    equivs2 := Array new:length2.
    self calcEquivs.
    changedFlags1 := Array new:length1 withAll:false.
    changedFlags2 := Array new:length2 withAll:false.
    undiscarded1 := Array new:length1.
    realindexes1 := Array new:length1.
    undiscarded2 := Array new:length2.
    realindexes2 := Array new:length2.
    nondiscardedLines := Array new:2.
    self discardConfusingLines.
    fdiag := Array new:(length1 + length2 + 3).
    bdiag := Array new:(length1 + length2 + 3).
    tooExpensive := ((nondiscardedLines at:1) + (nondiscardedLines at:2)) sqrt 
                rounded max:256.
    self 
        compareSeq:0
        with:(nondiscardedLines at:1)
        with:0
        with:(nondiscardedLines at:2)
        with:false.
    changed1 := SequenceWithSentinel on:changedFlags1 sentinel:false.
    changed2 := SequenceWithSentinel on:changedFlags2 sentinel:false.
    self 
        shiftBoundaries:changed1
        with:changed2
        with:equivs1
        with:length1.
    self 
        shiftBoundaries:changed2
        with:changed1
        with:equivs2
        with:length2.

    "Modified: / 27-03-2007 / 11:29:29 / cg"
!

compareSeq:xoff0 with:xlim0 with:yoff0 with:ylim0 with:minimal 
    |xoff xlim yoff ylim c|

    xoff := xoff0.
    xlim := xlim0.
    yoff := yoff0.
    ylim := ylim0.
    [
        ((xoff < xlim) and:[ yoff < ylim ]) 
            and:[ self compareXvAt:xoff yvAt:yoff ]
    ] whileTrue:[
        xoff := xoff + 1.
        yoff := yoff + 1
    ].
    [
        ((xlim > xoff) and:[ ylim > yoff ]) 
            and:[ self compareXvAt:(xlim - 1) yvAt:(ylim - 1) ]
    ] whileTrue:[
        xlim := xlim - 1.
        ylim := ylim - 1
    ].
    (xoff = xlim) ifTrue:[
        [ yoff < ylim ] whileTrue:[
            changedFlags2 at:(realindexes2 at:(yoff := yoff + 1)) put:true.
        ].
        ^ self.
    ].
    (yoff = ylim) ifTrue:[
        [ xoff < xlim ] whileTrue:[
            changedFlags1 at:(realindexes1 at:(xoff := xoff + 1)) put:true.
        ].
        ^ self.
    ].
    c := self 
                diag:xoff
                with:xlim
                with:yoff
                with:ylim
                with:minimal.
    ((c at:1) = 1) ifTrue:[
        self error:'c = 1'
    ].
    self 
        compareSeq:xoff
        with:(c at:2)
        with:yoff
        with:(c at:3)
        with:((c at:4) at:1).
    self 
        compareSeq:(c at:2)
        with:xlim
        with:(c at:3)
        with:ylim
        with:((c at:4) at:2).

    "Modified: / 27-03-2007 / 09:28:30 / cg"
!

diag:xoff with:xlim with:yoff with:ylim with:minimal 
    |dmin dmax fmid fmin fmax bmid bmin bmax odd c|

    dmin := xoff - ylim.
    dmax := xlim - yoff.
    fmid := xoff - yoff.
    bmid := xlim - ylim.
    fmin := fmid.
    fmax := fmid.
    bmin := bmid.
    bmax := bmid.
    odd := (fmid - bmid) odd.
    self fdiagAt:fmid put:xoff.
    self bdiagAt:bmid put:xlim.
    c := 1.
    [ true ] whileTrue:[
        |bigSnake|

        bigSnake := false.
        (fmin > dmin) ifTrue:[
            fmin := fmin - 1.
            self fdiagAt:(fmin - 1) put:-1
        ] ifFalse:[
            fmin := fmin + 1
        ].
        (fmax < dmax) ifTrue:[
            fmax := fmax + 1.
            self fdiagAt:(fmax + 1) put:-1
        ] ifFalse:[
            fmax := fmax - 1
        ].
        self 
            from:fmax
            downTo:fmin
            by:-2
            do:[:d | 
                |x y oldx tlo thi|

                tlo := self fdiagAt:(d - 1).
                thi := self fdiagAt:(d + 1).
                x := (tlo >= thi) ifTrue:[
                            tlo + 1
                        ] ifFalse:[ thi ].
                oldx := x.
                y := x - d.
                [
                    (x < xlim) and:[ (y < ylim) and:[ self compareXvAt:x yvAt:y ] ]
                ] whileTrue:[
                    x := x + 1.
                    y := y + 1
                ].
                ((x - oldx) > self snakeLimit) ifTrue:[
                    bigSnake := true
                ].
                self fdiagAt:d put:x.
                (odd and:[ (d between:bmin and:bmax) and:[ (self bdiagAt:d) <= x ] ]) ifTrue:[
                    ^ Array 
                        with:(c * 2 - 1)
                        with:x
                        with:y
                        with:(Array with:true with:true)
                ].
            ].
        (bmin > dmin) ifTrue:[
            bmin := bmin - 1.
            self bdiagAt:(bmin - 1) put:self intMax
        ] ifFalse:[
            bmin := bmin + 1
        ].
        (bmax < dmax) ifTrue:[
            bmax := bmax + 1.
            self bdiagAt:(bmax + 1) put:self intMax
        ] ifFalse:[
            bmax := bmax - 1
        ].
        self 
            from:bmax
            downTo:bmin
            by:-2
            do:[:d | 
                |x y oldx tlo thi|

                tlo := self bdiagAt:(d - 1).
                thi := self bdiagAt:(d + 1).
                x := (tlo < thi) ifTrue:[
                            tlo
                        ] ifFalse:[ thi - 1 ].
                oldx := x.
                y := x - d.
                [
                    (x > xoff) 
                        and:[ (y > yoff) and:[ self compareXvAt:(x - 1) yvAt:(y - 1) ] ]
                ] whileTrue:[
                    x := x - 1.
                    y := y - 1
                ].
                ((oldx - x) > self snakeLimit) ifTrue:[
                    bigSnake := true
                ].
                self bdiagAt:d put:x.
                (odd not and:[ (d between:fmin and:fmax) and:[ x <= (self fdiagAt:d) ] ]) ifTrue:[
                    ^ Array 
                        with:(c * 2)
                        with:x
                        with:y
                        with:(Array with:true with:true)
                ].
            ].
        (minimal not) ifTrue:[
            ((c > 200) & bigSnake) ifTrue:[
                |xmid ymid best|

                xmid := 0.
                ymid := 0.
                best := 0.
                self 
                    from:fmax
                    downTo:fmin
                    by:-2
                    do:[:d | 
                        |dd x y v|

                        dd := d - fmid.
                        x := self fdiagAt:d.
                        y := x - d.
                        v := (x - xoff) * 2 - dd.
                        (v > (12 * (c + dd abs))) ifTrue:[
                            ((v > best) 
                                and:[
                                    (x between:(xoff + self snakeLimit) and:(xlim - 1)) 
                                        and:[ y between:(yoff + self snakeLimit) and:(ylim - 1) ]
                                ]) 
                                    ifTrue:[
                                        |k|

                                        k := 1.
                                        [
                                            (k <= self snakeLimit) and:[ self compareXvAt:(x - k) yvAt:(y - k) ]
                                        ] whileTrue:[ k := k + 1 ].
                                        (k = self snakeLimit) ifTrue:[
                                            best := v.
                                            xmid := x.
                                            ymid := y.
                                        ].
                                    ]
                        ].
                    ].
                (best > 0) ifTrue:[
                    ^ Array 
                        with:(c * 2 - 1)
                        with:xmid
                        with:ymid
                        with:(Array with:true with:false)
                ].
                best := 0.
                self 
                    from:bmax
                    downTo:bmin
                    by:-2
                    do:[:d | 
                        |dd x y v|

                        dd := d - bmid.
                        x := self bdiagAt:d.
                        y := x - d.
                        v := (xlim - x) * 2 + dd.
                        (v > (12 * (c + dd abs))) ifTrue:[
                            ((v > best) 
                                and:[
                                    (x between:(xoff + 1) and:(xlim - self snakeLimit)) 
                                        and:[ y between:(yoff + 1) and:(ylim - self snakeLimit) ]
                                ]) 
                                    ifTrue:[
                                        |k|

                                        k := 0.
                                        [
                                            (k < self snakeLimit) and:[ self compareXvAt:(x + k) yvAt:(y + k) ]
                                        ] whileTrue:[ k := k + 1 ].
                                        (k = (self snakeLimit - 1)) ifTrue:[
                                            best := v.
                                            xmid := x.
                                            ymid := y.
                                        ].
                                    ]
                        ].
                    ].
                (best > 0) ifTrue:[
                    ^ Array 
                        with:(c * 2 - 1)
                        with:xmid
                        with:ymid
                        with:(Array with:false with:true)
                ].
            ].
            (c >= tooExpensive) ifTrue:[
                |fxybest fxbest bxybest bxbest|

                fxbest := 0.
                bxbest := 0.
                fxybest := -1.
                self 
                    from:fmax
                    downTo:fmin
                    by:-2
                    do:[:d | 
                        |x y|

                        x := (self fdiagAt:d) min:xlim.
                        y := x - d.
                        (ylim < y) ifTrue:[
                            x := ylim + d.
                            y := ylim
                        ].
                        (fxybest < (x + y)) ifTrue:[
                            fxybest := x + y.
                            fxbest := x.
                        ].
                    ].
                bxybest := self intMax.
                self 
                    from:bmax
                    downTo:bmin
                    by:-2
                    do:[:d | 
                        |x y|

                        x := xoff max:(self bdiagAt:d).
                        y := x - d.
                        (y < yoff) ifTrue:[
                            x := yoff + d.
                            y := yoff
                        ].
                        ((x + y) < bxybest) ifTrue:[
                            bxybest := x + y.
                            bxbest := x.
                        ].
                    ].
                (((xlim + ylim) - bxybest) < (fxybest - (xoff + yoff))) ifTrue:[
                    ^ Array 
                        with:(c * 2 - 1)
                        with:fxbest
                        with:(fxybest - fxbest)
                        with:(Array with:true with:false)
                ] ifFalse:[
                    ^ Array 
                        with:(c * 2 - 1)
                        with:bxbest
                        with:(bxybest - bxbest)
                        with:(Array with:false with:true)
                ].
            ].
        ].
        c := c + 1.
    ].

    "Modified: / 27-03-2007 / 09:28:25 / cg"
!

discardConfusingLines
    |equivCount discarded|

    equivCount := Array with:(Array new:equivMax withAll:0)
                with:(Array new:equivMax withAll:0).
    1 to:2 do:[:f | 
        (self equivsAt:f) do:[:each | 
            (equivCount at:f) at:each put:((equivCount at:f) at:each) + 1
        ].
    ].
    discarded := Array with:(Array new:length1 withAll:0)
                with:(Array new:length2 withAll:0).
    1 to:2 do:[:f | 
        |many tem|

        many := 5.
        tem := (self lengthAt:f) // 64.
        [
            (tem := tem // 2) > 0
        ] whileTrue:[ many := many * 2 ].
        1 to:(self lengthAt:f) do:[:i | 
            ((self equivsAt:f) at:i) ~= 0 ifTrue:[
                |nmatch|

                nmatch := (equivCount at:(3 - f)) at:((self equivsAt:f) at:i).
                (nmatch = 0) ifTrue:[
                    (discarded at:f) at:i put:1
                ].
                (nmatch > many) ifTrue:[
                    (discarded at:f) at:i put:2
                ].
            ].
        ].
    ].
    1 to:2 do:[:f | 
        1 to:(self lengthAt:f) do:[:ii | 
            |i|

            i := ii.
            ((discarded at:f) at:i) = 2 ifTrue:[
                (discarded at:f) at:i put:0.
            ] ifFalse:[
                ((discarded at:f) at:i) ~= 0 ifTrue:[
                    |provisional j length|

                    provisional := 0.
                    j := i.
                    [
                        (j <= (self lengthAt:f)) and:[ ((discarded at:f) at:j) ~= 0 ]
                    ] whileTrue:[
                        ((discarded at:f) at:i) = 2 ifTrue:[
                            provisional := provisional + 1
                        ].
                        j := j + 1.
                    ].
                    ((j > i) and:[ ((discarded at:f) at:(j - 1)) = 2 ]) ifTrue:[
                        j := j - 1.
                        (discarded at:f) at:j put:0.
                        provisional := provisional - 1.
                    ].
                    length := j - i.
                    ((provisional * 4) > length) ifTrue:[
                        [ j > i ] whileTrue:[
                            j := j - 1.
                            ((discarded at:f) at:j) = 2 ifTrue:[
                                (discarded at:f) at:j put:0.
                            ].
                        ].
                    ] ifFalse:[
                        |consec minimum tem|

                        minimum := 1.
                        tem := length // 4.
                        [
                            (tem := tem // 2) > 0
                        ] whileTrue:[ minimum := minimum * 2 ].
                        minimum := minimum + 1.
                        j := 0.
                        consec := 0.
                        [ j < length ] whileTrue:[
                            ((discarded at:f) at:(i + j)) ~= 2 ifTrue:[
                                consec := 0.
                            ] ifFalse:[
                                (minimum = (consec := consec + 1)) ifTrue:[
                                    j := j - consec.
                                ] ifFalse:[
                                    (minimum < consec) ifTrue:[
                                        (discarded at:f) at:(i + j) put:0.
                                    ].
                                ].
                            ].
                            j := j + 1.
                        ].
                        j := 0.
                        consec := 0.
                        [
                            (j < length) 
                                and:[ ((j >= 8) and:[ ((discarded at:f) at:(i + j)) = 1 ]) not ]
                        ] whileTrue:[
                            ((discarded at:f) at:(i + j)) = 2 ifTrue:[
                                consec := 0.
                                (discarded at:f) at:(i + j) put:0.
                            ] ifFalse:[
                                ((discarded at:f) at:(i + j)) = 0 ifTrue:[
                                    consec := 0.
                                ] ifFalse:[
                                    consec := consec + 1.
                                ].
                            ].
                            j := (consec = 3) ifTrue:[
                                        length
                                    ] ifFalse:[ j + 1 ].
                        ].
                        i := i + (length - 1).
                        j := 0.
                        consec := 0.
                        [
                            (j < length) 
                                and:[ ((j >= 8) and:[ ((discarded at:f) at:(i - j)) = 1 ]) not ]
                        ] whileTrue:[
                            ((discarded at:f) at:(i - j)) = 2 ifTrue:[
                                consec := 0.
                                (discarded at:f) at:(i - j) put:0.
                            ] ifFalse:[
                                ((discarded at:f) at:(i - j)) = 0 ifTrue:[
                                    consec := 0.
                                ] ifFalse:[
                                    consec := consec + 1.
                                ].
                            ].
                            j := (consec = 3) ifTrue:[
                                        length
                                    ] ifFalse:[ j + 1 ].
                        ].
                    ].
                ].
            ].
        ].
    ].
    1 to:2 do:[:f | 
        |changed j|

        changed := self changedFlagsAt:f.
        j := 0.
        1 to:(self lengthAt:f) do:[:i | 
            ((discarded at:f) at:i) ~= 0 ifTrue:[
                changed at:i put:true.
            ] ifFalse:[
                j := j + 1.
                (self undiscardedAt:f) at:j put:((self equivsAt:f) at:i).
                (self realindexesAt:f) at:j put:i.
            ].
        ].
        nondiscardedLines at:f put:j.
    ].

    "Modified: / 27-03-2007 / 09:27:02 / cg"
!

shiftBoundaries:changed with:otherChanged with:equivs with:length 
    |i j|

    i := 1.
    j := 1.
    [
        [
            (i <= length) and:[ (changed at:i) not ]
        ] whileTrue:[
            [
                j := j + 1.
                otherChanged at:(j - 1)
            ] whileTrue.
            i := i + 1.
        ].
        i <= length
    ] whileTrue:[
        |runlength start corresponding|

        start := i.
        [
            changed at:(i := i + 1)
        ] whileTrue.
        [ otherChanged at:j ] whileTrue:[
            j := j + 1
        ].
        [
            runlength := i - start.
            [
                (start > 1) and:[ (equivs at:(start - 1)) = (equivs at:(i - 1)) ]
            ] whileTrue:[
                changed at:(start := start - 1) put:true.
                changed at:(i := i - 1) put:false.
                [
                    changed at:(start - 1)
                ] whileTrue:[ start := start - 1 ].
                [
                    otherChanged at:(j := j - 1)
                ] whileTrue.
            ].
            corresponding := (otherChanged at:(j - 1)) ~= 0 ifTrue:[
                        i
                    ] ifFalse:[ length + 1 ].
            [
                (i <= length) and:[ (equivs at:start) = (equivs at:i) ]
            ] whileTrue:[
                changed at:start put:false.
                start := start + 1.
                changed at:i put:true.
                i := i + 1.
                [ changed at:i ] whileTrue:[
                    i := i + 1
                ].
                [
                    otherChanged at:(j := j + 1)
                ] whileTrue:[ corresponding := i ].
            ].
            runlength ~= (i - start)
        ] whileTrue.
        [ corresponding < i ] whileTrue:[
            changed at:(start := start - 1) put:true.
            changed at:(i := i - 1) put:false.
            [
                otherChanged at:(j := j - 1)
            ] whileTrue.
        ].
    ].

    "Modified: / 27-03-2007 / 09:26:35 / cg"
! !

!GNUDiff methodsFor:'private'!

bdiagAt: anIndex 
	^bdiag at: anIndex + length2 + 2
!

bdiagAt: anIndex put: anObject 
	bdiag at: anIndex + length2 + 2 put: anObject
!

changedFlagsAt: anIndex 
	anIndex = 1 ifTrue: [^changedFlags1].
	anIndex = 2 ifTrue: [^changedFlags2].
	^nil
!

compareXvAt: x yvAt: y 
	^(self xvAt: x)
		= (self yvAt: y)
!

equivsAt: anIndex 
	anIndex = 1 ifTrue: [^equivs1].
	anIndex = 2 ifTrue: [^equivs2].
	^nil
!

fdiagAt: anIndex 
	^fdiag at: anIndex + length2 + 2
!

fdiagAt: anIndex put: anObject 
	fdiag at: anIndex + length2 + 2 put: anObject
!

from: max downTo: min by: step do: aBlock 
	| n |
	n := max.
	[n >= min]
		whileTrue: 
			[aBlock value: n.
			n := n + step]
!

intMax
	^SmallInteger maxVal
!

lengthAt: anIndex 
	anIndex = 1 ifTrue: [^length1].
	anIndex = 2 ifTrue: [^length2].
	^nil
!

realindexesAt: anIndex 
	anIndex = 1 ifTrue: [^realindexes1].
	anIndex = 2 ifTrue: [^realindexes2].
	^nil
!

sequenceAt: anIndex 
	anIndex = 1 ifTrue: [^sequence1].
	anIndex = 2 ifTrue: [^sequence2].
	^nil
!

snakeLimit
	^20
!

undiscardedAt: anIndex 
	anIndex = 1 ifTrue: [^undiscarded1].
	anIndex = 2 ifTrue: [^undiscarded2].
	^nil
!

xvAt: anIndex 
	^undiscarded1 at: anIndex + 1
!

yvAt: anIndex 
	^undiscarded2 at: anIndex + 1
! !

!GNUDiff class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/GNUDiff.st,v 1.1 2007/03/27 12:15:11 cg Exp $'
! !
