"
 COPYRIGHT (c) 2000 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies' }"

ArrayedCollection variableSignedLongSubclass:#PointArray
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-Arrayed'
!

!PointArray class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2000 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

!

documentation
"
    Instances of this class store 32bit signed Integer points in place. 
    (i.e. each x[i], y[i] must be in -2147483648 .. 2147483647).
    They may be used to pass data efficiently to the primitive level during high-bandwidth 2D 
    graphics operations (and also to store huge point arrays more compact).
    Written to mimic a corresponding Squeak class.

    [memory requirements:]
        OBJ-HEADER + (size * int-size * 2)

    [author:]
         (cg@exept.de)

    [see also:]

    [instance variables:]

    [class variables:]
"
!

examples
"
                                                                [exBegin]
    |a|

    a := PointArray new:10.
    a at:1 put:(1 @ 1).
    a at:2 put:(10 @ 10).
    a at:3 put:(-10 @ -10).
    a inspect.
                                                                [exEnd]

                                                                [exBegin]
    |a|

    a := PointArray new:1000.
    a atAllPut:(10 @ 10).
    a at:3 put:(-10 @ -10).
    a at:1.     
    a at:3.     
                                                                [exEnd]
"
! !

!PointArray class methodsFor:'instance creation'!

new:n
    "return a new PointArray, holding n (integer-) points"

    ^ super new: n*2


! !

!PointArray methodsFor:'accessing'!

at:index
    "Return the element (e.g., point) at the given index"

    |ix "{ Class: SmallInteger }" |

    ix := index * 2.
    ^ (super at: ix - 1) @ (super at: ix)


!

at: index put: aPoint
    "Store the argument aPoint at the given index."

    |ix "{ Class: SmallInteger }" |

    ix := index * 2.
    super at: ix - 1 put: aPoint x asInteger.
    super at: ix put: aPoint y asInteger.
    ^ aPoint


! !

!PointArray methodsFor:'converting'!

asPointArray
    ^ self.
! !

!PointArray methodsFor:'queries'!

defaultElement
    "Return the default element of the receiver"

    ^0@0


!

size
    "Return the number of elements in the receiver"

    ^ super size // 2

! !

!PointArray class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/PointArray.st,v 1.5 2009/10/04 15:52:34 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/PointArray.st,v 1.5 2009/10/04 15:52:34 cg Exp $'
! !
