"
 COPYRIGHT (c) 2009 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies' }"

Stream subclass:#SelectingStream
	instanceVariableNames:'inputStream block peek peekValid'
	classVariableNames:''
	poolDictionaries:''
	category:'Streams-Misc'
!

!SelectingStream class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2009 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    after an idea of alan knight...

    returns a new read stream, which selects elements of an underlying stream.
"
!

examples
"
[exBegin]
    |s|

    s := SelectingStream 
            on:(#(1 2 3 4 5 6 7 8 9 10) readStream)
            block:[:el | el odd].
    s upToEnd.
[exEnd]

[exBegin]
    |s|

    s := SelectingStream 
            on:(LineReadingStream 
                    on:(SelectingStream class sourceCodeAt:#examples) 
                            readStream)
            block:[:line | line startsWith:'['].
    s upToEnd.
[exEnd]
"
! !

!SelectingStream class methodsFor:'instance creation'!

on:aStream block:aBlock
    ^ self basicNew 
        inputStream:aStream block:aBlock
! !

!SelectingStream methodsFor:'accessing'!

block
    ^ block
!

block:something
    block := something.
!

inputStream
    ^ inputStream
!

inputStream:something
    inputStream := something.
!

inputStream:inputStreamArg block:blockArg 
    inputStream := inputStreamArg.
    block := blockArg.
    peekValid := false
! !

!SelectingStream methodsFor:'queries'!

atEnd
    |e|

    peekValid ifTrue:[^ false].

    [        
        inputStream atEnd ifTrue:[ ^ true ].
        e := inputStream next.
        (block value:e) ifTrue:[
            peek := e.
            peekValid := true.
            ^ false
        ].
    ] loop.
    "/ not reached
! !

!SelectingStream methodsFor:'reading'!

next
    |e|

    peekValid ifTrue:[
        peekValid := false.
        ^ peek
    ].

    [
        inputStream atEnd ifTrue:[
            ^ self signalAtEnd.
        ].
        e := inputStream next.
        (block value:e) ifTrue:[
            ^ e
        ].
    ] loop.
! !

!SelectingStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/SelectingStream.st,v 1.2 2009/05/13 09:08:28 cg Exp $'
! !
