"
 COPYRIGHT (c) 1996 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies' }"

Object subclass:#SimpleStatusMonitor
	instanceVariableNames:'statusList headLineHolder headLineView listView'
	classVariableNames:''
	poolDictionaries:''
	category:'Monitors-System'
!

!SimpleStatusMonitor class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    A baseclass for very simple status display monitors.
    Concrete classes should redefined the updateStatus method
    and place some useful line-collection into the statusList holder.
    (Originally, I needed a monitor for our Linux SMB server -
     so this is a by-product ...)

    See UserMonitor and SambaStatusMonitor as concrete examples.

    [author:]
        Claus Gittinger

    [see also:]
        UserMonitor SambaStatusMonitor
"
! !

!SimpleStatusMonitor class methodsFor:'queries'!

isVisualStartable
    "return true, if this application can be started via #open.
     (to allow start via double-click in the browser)"

    ^ self ~~ SimpleStatusMonitor
! !

!SimpleStatusMonitor class methodsFor:'startup'!

open
    ^ self new open

    "Created: 15.8.1996 / 10:31:56 / cg"
! !

!SimpleStatusMonitor methodsFor:'defaults'!

defaultExtent
    ^ 450@200.

    "Created: 15.8.1996 / 10:35:53 / cg"
    "Modified: 15.8.1996 / 10:38:25 / cg"
!

defaultLabel
    ^ 'Status List'.

    "Created: 15.8.1996 / 10:35:34 / cg"
!

updateInterval
    ^ 5

    "Modified: 15.8.1996 / 10:38:25 / cg"
    "Created: 15.8.1996 / 10:40:08 / cg"
! !

!SimpleStatusMonitor methodsFor:'startup'!

isVisualStartable
    "returns whether this application class can be started via #open"

    ^ (self ~~ SimpleStatusMonitor)

    "Created: / 10.7.1998 / 15:46:02 / cg"
    "Modified: / 10.7.1998 / 15:46:27 / cg"
!

open
    |topView|

    statusList := SelectionInList new.
    headLineHolder := 'no headline defined' asValue.

    topView := StandardSystemView new.
    topView label:(self defaultLabel).
    topView extent:(self defaultExtent).

    headLineView := Label in:topView.
    headLineView origin:0.0@0.0; width:1.0.
    headLineView label:''; adjust:#left.
    headLineView model:headLineHolder.
    headLineView labelMessage:#value.

    listView := HVScrollableView for:ListView miniScrollerH:true in:topView.

    headLineView font:(listView font).

    listView origin:0.0@0.0 corner:1.0@1.0.
    listView topInset:(headLineView preferredExtent y).
    listView model:statusList; aspect:#list.

    headLineView leftInset:(listView scrollBar width 
                             + View viewSpacing
                             + listView leftMargin).

    [
        [topView realized] whileTrue:[
            self updateStatus.
            Delay waitForSeconds:(self updateInterval).
        ]
    ] forkAt:4.

    topView open.

    "
     SimpleStatusMonitor open
    "

    "Created: 15.8.1996 / 10:31:43 / cg"
    "Modified: 15.8.1996 / 11:02:17 / cg"
! !

!SimpleStatusMonitor methodsFor:'status update'!

updateStatus
    statusList list:#('updateStatus should be redefined').

    "Modified: 15.8.1996 / 10:32:38 / cg"
! !

!SimpleStatusMonitor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/SimpleStatusMonitor.st,v 1.8 2006/02/22 10:09:59 stefan Exp $'
! !
