"{ Package: 'stx:goodies' }"

nil subclass:#StreamPositionFixer
	instanceVariableNames:'realStream'
	classVariableNames:''
	poolDictionaries:''
	category:'Streams'
!

!StreamPositionFixer class methodsFor:'documentation'!

documentation
"
    a little stream mimicri to fix the position-incompatibility
    of ST/X.
    Can be wrapped onto a stream (i.e. instead of aStream,
    use StreamPositionFixer on:aStream in your application.).

    Makes positioning 0-based.
        
"
! !

!StreamPositionFixer class methodsFor:'instance creation'!

on:aStream
    ^ self basicNew on:aStream

    "Created: / 18.6.1998 / 22:51:19 / cg"
! !

!StreamPositionFixer methodsFor:'error handling'!

doesNotUnderstand:aMessage
    ^ aMessage sendTo:realStream

    "Modified: / 18.6.1998 / 22:50:05 / cg"
! !

!StreamPositionFixer methodsFor:'mimicri'!

position
    ^ realStream position - 1

    "Created: / 18.6.1998 / 22:50:27 / cg"
!

position:newPosition
    ^ realStream position:(newPosition + 1)

    "Created: / 18.6.1998 / 22:50:40 / cg"
! !

!StreamPositionFixer methodsFor:'private'!

on:aStream
    realStream := aStream

    "Created: / 18.6.1998 / 22:51:04 / cg"
! !

!StreamPositionFixer methodsFor:'queries'!

class
    "return the receivers class"

%{  /* NOCONTEXT */

    RETURN ( __Class(self) );
%}

"
*** WARNING
***
*** this method has been automatically created,
*** since all nil-subclasses should respond to some minimum required
*** protocol.
***
*** Inspection and/or debugging of instances may not be possible,
*** if you remove/change this method. 
"
! !

!StreamPositionFixer methodsFor:'testing'!

isBehavior
    "return true, if the receiver is some kind of class (i.e. behavior);
     false is returned here - the method is only redefined in Behavior."

    ^ false

"
*** WARNING
***
*** this method has been automatically created,
*** since all nil-subclasses should respond to some minimum required
*** protocol.
***
*** Inspection and/or debugging of instances may not be possible,
*** if you remove/change this method. 
"
! !

!StreamPositionFixer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/StreamPositionFixer.st,v 1.3 2000/03/02 14:15:06 cg Exp $'
! !
