"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#BooleanTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Fundamental'
!


!BooleanTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<boolean>'
! !

!BooleanTest methodsFor:'constants'!

canonicalObject

	^true
! !

!BooleanTest methodsFor:'testing'!

testXandOp
	" Fundamental <boolean> "
	self messageSelector: #'&'.

	self conformingValue: [true & true]
		should: [:r| r].

	self conformingValue: [true & false]
		shouldnt: [:r| r].

	self conformingValue: [false & true]
		shouldnt: [:r| r].

	self conformingValue: [false & false]
		shouldnt: [:r| r].
!

testXandX
	" Fundamental <boolean> "
	self messageSelector: #'and:'.

	self conformingValue: [false and: [true]]
		shouldnt: [:r| r].

	self conformingValue: [false and: [nil isNil]]
		shouldnt: [:r| r].

	self conformingValue: [false and: [false]]
		shouldnt: [:r| r].

	self conformingValue: [false and: [nil notNil]]
		shouldnt: [:r| r].

	"No error:"
	self conformingValue: [false and: [nil selector]]
		shouldnt: [:r| r].

	self should: [true and: [nil selector]]
		raise: MessageNotUnderstood.
!

testXeqvX
	" Fundamental <boolean> "
	self messageSelector: #'eqv:'.

	self conformingValue: [true eqv: true]
		should: [:r| r].

	self conformingValue: [true eqv: false]
		shouldnt: [:r| r].

	self conformingValue: [false eqv: true]
		shouldnt: [:r| r].

	self conformingValue: [false eqv: false]
		 should: [:r| r].
!

testXifFalseX
	" Fundamental <boolean> "
	self messageSelector: #'ifFalse:'.

	self conformingValue: [false ifFalse: [0] ]
		should: [:r| r = 0].

	self conformingValue: [true ifFalse: [0] ]
		should: [:r| true "unspecified"].
!

testXifFalseXifTrueX
	" Fundamental <boolean> "
	self messageSelector: #'ifFalse:ifTrue:'.

	self conformingValue: [false
			ifFalse: [0]
			ifTrue: [nil selector]]
		should: [:r| r = 0].

	self conformingValue: [true
			ifFalse: [nil selector]
			ifTrue: [1]]
		should: [:r| r = 1].
!

testXifTrueX
	" Fundamental <boolean> "
	self messageSelector: #'ifTrue:'.

	self conformingValue: [true ifTrue: [1]]
		should: [:r| r = 1].

	self conformingValue: [false ifTrue: [1]]
		should: [:r| true "unspecified"].
!

testXifTrueXifFalseX
	" Fundamental <boolean> "
	self messageSelector: #'ifTrue:ifFalse:'.

	self conformingValue: [true
			ifTrue: [1]
			ifFalse: [nil selector]]
		should: [:r| r = 1].

	self conformingValue: [false
			ifTrue: [nil selector]
			ifFalse: [0 ]]
		should: [:r| r = 0].
!

testXnot
	" Fundamental <boolean> "
	self messageSelector: #'not'.

	self conformingValue: [true not]
		should: [:r| r = false].

	self conformingValue: [false not]
		should: [:r| r = true].
!

testXorOp
	" Fundamental <boolean> "
	self messageSelector: #'|'.

	self conformingValue: [true | true]
		should: [:r| r].

	self conformingValue: [true | false]
		should: [:r| r].

	self conformingValue: [false | true]
		should: [:r| r].

	self conformingValue: [false | false]
		shouldnt: [:r| r].
!

testXorX
	" Fundamental <boolean> "
	self messageSelector: #'or:'.

	self conformingValue: [true or: [true]]
		should: [:r| r].

	self conformingValue: [true or: [false]]
		should: [:r| r].

	"No error:"
	self conformingValue: [true or: [nil selector]]
		should: [:r| r].

	self conformingValue: [false or: [true]]
		should: [:r| r].

	self conformingValue: [false or: [nil isNil]]
		should: [:r| r].

	self conformingValue: [false or: [false]]
		shouldnt: [:r| r].

	self conformingValue: [false or: [nil notNil]]
		shouldnt: [:r| r].

	self should: [false or: [nil selector]]
		raise: MessageNotUnderstood.
!

testXprintString
	" Fundamental <boolean> "
	self messageSelector: #'printString'.

	self conformingValue: [true printString]
		should: [:r| r = 'true'].

	self conformingValue: [false printString]
		should: [:r| r = 'false'].
!

testXxorX
	" Fundamental <boolean> "
	self messageSelector: #'xor:'.

	self conformingValue: [true xor: true]
		shouldnt: [:r| r].

	self conformingValue: [true xor: false]
		should: [:r| r].

	self conformingValue: [false xor: true]
		should: [:r| r].

	self conformingValue: [false xor: false]
		shouldnt: [:r| r].
! !

!BooleanTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/BooleanTest.st,v 1.1 2002/06/21 10:33:24 penk Exp $'
! !
