"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#ClassDescriptionHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Fundamental'
!


!ClassDescriptionHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<classDescription>'
! !

!ClassDescriptionHelper methodsFor:'testing'!

testXallSubclasses
	" Fundamental <classDescription> "
	self messageSelector: #'allSubclasses'.

	"Each element of the result collection supports the protocol
		<classDescription>."
	self conformingValue: [testCase canonicalObject allSubclasses]
		should: [:r|
			r allSatisfy: [:element|
				element respondsToProtocolId: #'<classDescription>']].
!

testXallSuperclasses
	" Fundamental <classDescription> "
	self messageSelector: #'allSuperclasses'.

	"Each element of the result collection supports the protocol
	<classDescription>."
	self conformingValue: [testCase canonicalObject allSuperclasses]
		should: [:r|
			r allSatisfy: [:element|
				element respondsToProtocolId: #'<classDescription>']].
!

testXname
	" Fundamental <classDescription> "
	self messageSelector: #'name'.

	self notDone.
	"The global name of a class object is the global identifier
		that is bound to the class object."
	self conformingValue: [testCase canonicalObject name]
		should: [:r|    true "??Don't know what to test for??"].

!

testXsubclasses
	" Fundamental <classDescription> "
	self messageSelector: #'subclasses'.

	"Each element of the result collection supports the protocol
		<classDescription>.  The order of class objects within
		the collection is unspecified."
	self conformingValue: [testCase canonicalObject subclasses]
		should: [:r|
			r allSatisfy: [:element|
				element respondsToProtocolId: #'<classDescription>']].
!

testXsuperclass
	" Fundamental <classDescription> "
	self messageSelector: #'superclass'.

	"If the receiver is a class object, return the class objects defined by the class definitions from which the class definition of the receiver directly inherits.  If the class definition of the receiver has no superclasses, return nil."
	self conformingValue: [testCase canonicalObject superclass]
		should: [:r|
			(r respondsToProtocolId: #'<classDescription>')
			| (r isNil)].
! !

!ClassDescriptionHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ClassDescriptionHelper.st,v 1.1 2002/06/21 10:23:58 penk Exp $'
! !
