"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#DictionaryFactoryHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!DictionaryFactoryHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Dictionary factory>'
! !

!DictionaryFactoryHelper methodsFor:'testing'!

testXnew
	" ANSI-Collection <Dictionary factory> "
	self messageSelector: #'new'.

	self conformingValue: [testCase canonicalObject new]
		should: [:r| r isEmpty].
!

testXnewX
	" ANSI-Collection <Dictionary factory> "
	self messageSelector: #'new:'.

	self conformingValue: [testCase canonicalObject new: 0]
		should: [:r| r isEmpty].

	self conformingValue: [testCase canonicalObject new: 10]
		should: [:r| r isEmpty].
!

testXwithAllX
	" ANSI-Collection <Dictionary factory> "
	| abstractDictionary dictionaryfactory |
	self messageSelector: #'withAll:'.

	"Return a new collection whose elements are the elements of newElements.
	The effect is the same as evaluating:
		Dictionary new
			addAll: newElements;
			yourself."
	dictionaryfactory := testCase canonicalObject.
	abstractDictionary := testCase canonicalAbstractDictionary.
	self conformingValue: [dictionaryfactory withAll: abstractDictionary]
		should: [:r| r keysDo: [:key |
			(r at: key) = (abstractDictionary at: key)
				ifFalse: [^false].
			^true]]
! !

!DictionaryFactoryHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/DictionaryFactoryHelper.st,v 1.1 2002/06/21 10:23:25 penk Exp $'
! !
