"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#DictionaryFactoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!DictionaryFactoryTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Dictionary factory>'
! !

!DictionaryFactoryTest methodsFor:'constants'!

canonicalAbstractDictionary

	^DictionaryTest canonicalCollection
!

canonicalObject

	^Dictionary
! !

!DictionaryFactoryTest methodsFor:'testing'!

testXnew
	" Collection <Dictionary factory> "
	self messageSelector: #'new'.

	self conformingValue: [Dictionary new]
		should: [:r| r isEmpty].
!

testXnewX
	" Collection <Dictionary factory> "
	self messageSelector: #'new:'.

	self conformingValue: [Dictionary new: 0]
		should: [:r| r isEmpty].

	self conformingValue: [Dictionary new: 10]
		should: [:r| r isEmpty].
!

testXwithAllX
	" Collection <Dictionary factory> "
	| abstractDictionary |
	self messageSelector: #'withAll:'.

	"Return a new collection whose elements are the elements of newElements.
	The effect is the same as evaluating:
		Dictionary new
			addAll: newElements;
			yourself."
	abstractDictionary := self canonicalAbstractDictionary.
self anomaly: [
	self conformingValue: [Dictionary withAll: abstractDictionary]
		should: [:r| r keysDo: [:key |
			(r at: key) = (abstractDictionary at: key)
				ifFalse: [^false].
			^true]].
] for: #(#'DO30' "2001/02/20 Harmon, R. Uses (<collection>, #withAll:)
			which uses Dict, #do: using element value.")
! !

!DictionaryFactoryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/DictionaryFactoryTest.st,v 1.1 2002/06/21 10:28:25 penk Exp $'
! !
