"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#DurationFactoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Date and Time'
!


!DurationFactoryTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Duration factory>'
! !

!DurationFactoryTest methodsFor:'constants'!

canonicalObject

	^Duration
! !

!DurationFactoryTest methodsFor:'testing'!

testXdaysXhoursXminutesXsecondsX
	" Date and Time <Duration factory> "
	| numList retVals |
	self messageSelector: #'days:hours:minutes:seconds:'.

	numList := #(2 -2000000000 2000000000 2.0d0 0 0).
	numList at: 5 put: (1/2).
	numList at: 6 put: (2.0d0 asScaledDecimal: 3).
	retVals := #(3722 -1999996280 2000003720 3.722d3 3.7205d3 3.722d3).

	1 to: numList size do: [:ndx|
		self conformingValue: [Duration days: 0 hours: 1 minutes: 2
				seconds: (numList at: ndx)]
			should: [:r | r asSeconds closeTo: (retVals at: ndx)].

		"If any of the operands are negative, the result is smaller
		by that number of days, hours, minutes, or seconds as appropriate."
		self conformingValue: [Duration days: 0 hours: 1 minutes: -2
				seconds: (numList at: ndx)]
			"- (minutes * 2 no longer added) + (minutes * -2) = 240"
			should: [:r | r asSeconds closeTo: ((retVals at: ndx) - 240)]]
!

testXsecondsX
	" Date and Time <Duration factory> "
	| numList retVals |
	self messageSelector: #'seconds:'.


	numList := #( 2 -2000000000 2000000000 2.0d0 0 0 ).
	numList at: 5 put: (5 / 2).
	numList at: 6 put: (2.0d0 asScaledDecimal: 3).
	retVals := #(2 -2000000000 2000000000 2.0d0 2.5d0 2.0d0).
	1 to: numList size do: [:ndx | 
		self conformingValue: [(Duration seconds: (numList at: ndx))]
			should: [:r| r asSeconds closeTo: (retVals at: ndx)].

		"If seconds is negative, answer a <Duration> that is abs (seconds)
		less than <Duration factory> #zero."
		self conformingValue: [(Duration seconds: 0 - (numList at: ndx))]
			should: [:r| r asSeconds closeTo: 0 - (retVals at: ndx)]].
!

testXzero
	" Date and Time <Duration factory> "
	self messageSelector: #'zero'.

	self conformingValue: [Duration zero]
		should: [:r| r asSeconds = 0].
! !

!DurationFactoryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/DurationFactoryTest.st,v 1.1 2002/06/21 10:27:55 penk Exp $'
! !
