"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#ErrorHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!ErrorHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Error>'
! !

!ErrorHelper methodsFor:'testing'!

testXdefaultAction
	" ANSI-Exception <Error> "
	| errorCls |
	self messageSelector: #'defaultAction'.

	"Refinement: <Error>
		The current computation is terminated. The cause of the error
	should be logged or reported to the user. If the program is operating
	in an interactive debugging environment the computation should be
	suspended and the debugger activated."
	errorCls := testCase canonicalObject class.
self anomaly: [ "Does exactly what it is supposed to: brings up debugger in test.  This is wrapped so resuming can be avoided once confirmed it works."
	self conformingValue: [
			[errorCls signal]
				on: errorCls
				do: [:ex| ex defaultAction]]
		should: [:r| true "UNSPECIFIED"].
] for: #(#'DO30' #'SQ27' #'VW7' "2001/02/20 Harmon, R. No anomaly.").
!

testXisResumable
	" ANSI-Exception <Error> "
	| errorCls |
	self messageSelector: #'isResumable'.

	"Refinement: <Error>
		Answer false. Error exceptions by default are assumed to not be
	resumable. Subclasses may over-ride this definition for situations
	where it is appropriate for an error to be resumable."
	errorCls := testCase canonicalObject class.
	self conformingValue: [
			[errorCls signal]
				on: errorCls
				do: [:ex| ex return: ex isResumable]]
		shouldnt: [:r| r].
! !

!ErrorHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ErrorHelper.st,v 1.1 2002/06/21 10:22:53 penk Exp $'
! !
