"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#ExceptionClassHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!ExceptionClassHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Exception class>'
! !

!ExceptionClassHelper methodsFor:'testing'!

testXhandlesX
	" Exception <Exception class> "
	| object exceptionClass |
	self messageSelector: #'handles:'.

	object := testCase canonicalObject.

	self conformingValue: [[object signal]
			on: object
			do: [:except| except return: (object handles: except)]]
		should: [:r| r].

	exceptionClass := object = Error
		ifTrue: [Notification]
		ifFalse: [Error].
	self conformingValue: [[object signal]
			on: object
			do: [:except| except return: (exceptionClass handles: except)]]
		shouldnt: [:r| r].
!

testXnew
	" Exception <Exception class> "
	self messageSelector: #'new'.

	self conformingValue: [testCase canonicalObject new]
		should: [:r| r respondsToProtocolId: #'<Exception>'].
!

testXsignal
	" Exception <Exception class> "
	| exceptionCls |
	self messageSelector: #'signal'.

	"Refinement: <Exception class>
		The exception signaled conforms to <Exception> with all of its
		<exceptionDescription> attributes set to their default values."
	self notDone. "2001/02/20 Harmon, R.A. Check that attributes set to default."
	exceptionCls := testCase canonicalObject.
	self conformingValue: [
			[exceptionCls signal]
				on: exceptionCls do: [:except| except return: except]]
		should: [:r| r respondsToProtocolId: #'<Exception>'].
! !

!ExceptionClassHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ExceptionClassHelper.st,v 1.1 2002/06/21 10:31:15 penk Exp $'
! !
