"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#ExceptionClassTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!ExceptionClassTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Exception class>'
! !

!ExceptionClassTest methodsFor:'constants'!

canonicalObject

	^Exception
! !

!ExceptionClassTest methodsFor:'testing'!

testXhandlesX
	" Exception <Exception class> "
	self messageSelector: #'handles:'.

	self conformingValue: [
			[Exception signal]
				on: Exception
				do: [:except| except return: (Exception  handles: except)]]
		should: [:r| r].


	self conformingValue: [[
			Exception signal ]
				on: Exception
				do: [:except| except return: (Error  handles: except)]]
		shouldnt: [:r| r].

"Needs additional tests:

Definition: <exceptionSelector>
	This message determines whether the exception handler associated with the receiver may be used to process the argument. Answer true if an associated handler should be used to process exception. Answer false if an associated handler may not be used to process the exception.

Refinement: <Exception class>
	Return true if the class of exception is the receiver or a general subclass of the receiver.
This definition implies that subclasses of an exception class are considered to be subexceptions of the type of exception defined by their superclass. An exception handler that handles an exception class will also handle any exceptions that are instances of the exception class's subclasses.
"
!

testXnew
	" Exception <Exception class> "
	self messageSelector: #'new'.

	"The object returned conforms to <Exception>."
	self conformingValue: [Exception new]
		should: [:r| true].
!

testXsignal
	" Exception <Exception class> "
	self messageSelector: #'signal'.

	self conformingValue: [
			[Exception signal]
				on: Exception
				do: [:except| except return]]
		should: [:r| true "unspecified"].
! !

!ExceptionClassTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ExceptionClassTest.st,v 1.1 2002/06/21 10:28:48 penk Exp $'
! !
