"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#ExceptionDescriptionHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!ExceptionDescriptionHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<exceptionDescription>'
! !

!ExceptionDescriptionHelper methodsFor:'testing'!

testXdefaultAction
	" Exception <exceptionDescription> "
	| exception |
	self messageSelector: #'defaultAction'.

	exception := testCase canonicalObject.

self anomaly: [
	self conformingValue: [exception defaultAction]
		should: [:r | true "unspecified"].
] forDialectAndTestCaseName: #(
	#(#'DO30' "2000/12/06 Harmon, R."
		#(#'ExceptionTest' "signals subclassResponsibility error."))
	#(#'VW7' 
		#(#'ExceptionTest' "signals subclassResponsibility error."))).

self anomaly: [
	self conformingValue: [
			[exception signal]
				on: exception class
				do: [:ex| ex defaultAction]]
		should: [:r | true "unspecified"].
] forDialectAndTestCaseName: #(
	#(#'DO30' "2000/12/06 Harmon, R."
		#(#'ExceptionTest' "signals subclassResponsibility error."))).
!

testXdescription
	" Exception <exceptionDescription> "
	| exception |
	self messageSelector: #'description'.

	exception := testCase canonicalObject.

	self conformingValue: [exception description]
		should: [:r| true "unspecified"].

	self conformingValue: [
			[exception signal]
				on: exception class
				do: [:ex|
					ex return: ex description]]
		should: [:r| true "unspecified"].

"From ExceptionANSITest >> #testXdescription
	?? <exceptionDescription>#description ??
	| exception messageText |
??not sure - spec only says that default should be something 'readable'; well, at least it shouldn't be nil ...??
	self shouldnt: [Exception new description == nil].
	exception := Exception new.
	messageText := 'our chief weapon is fear'.
	exception messageText: messageText.
	self shouldnt: [(exception description indexOfSubCollection: messageText  startingAt: 1) = 0].
"
!

testXisResumable
	" Exception <exceptionDescription> "
	| exception |
	self messageSelector: #'isResumable'.

	exception := testCase canonicalObject.

	self conformingValue: [exception isResumable]
		should: [:r | true "unspecified"].

	self conformingValue: [
			[exception signal]
				on: exception class
				do: [:ex|
					ex return: ex isResumable]]
		should: [:r | true "unspecified"].

"From ExceptionANSITest >> #testXisResumable
	?? <exceptionDescription>#isResumable ??
	#'Exception'.
	self mustBeBoolean: Exception new isResumable.
	self shouldnt: [Error new isResumable].
	self should: [Notification new isResumable].
	self should: [ZeroDivide new isResumable].
	self should: [MessageNotUnderstood new isResumable].
"
!

testXmessageText
	" Exception <exceptionDescription> "
	| exception messageText |
	self messageSelector: #'messageText'.

	exception := testCase canonicalObject.
	self conformingValue: [exception messageText]
		should: [:r| r == nil].

	messageText := 'our chief weapon is fear'.
	exception messageText: messageText.
	self conformingValue: [exception messageText]
		should: [:r| r = messageText].

"From ExceptionANSITest >> #testXmessageText
	?? <exceptionDescription>#messageText ??
	| exception messageText |
	exception := Exception new.
	self should: [exception messageText == nil].
	messageText := 'our chief weapon is fear'.
	exception messageText: messageText.
	self should: [exception messageText = messageText].
"
!

testXtag
	" Exception <exceptionDescription> "
	| exception messageText |
	self messageSelector: #'tag'.

	exception := testCase canonicalObject.
	exception tag: nil.
	self conformingValue: [exception tag]
		should: [:r| r == nil].

	messageText := 'our chief weapon is fear'.
	exception messageText: messageText.
	self conformingValue: [exception tag]
		should: [:r| r = messageText].

	exception tag: 1.
	self conformingValue: [exception tag]
		should: [:r| r = 1].

"From ExceptionANSITest >> #testXtag
	?? <exceptionDescription>#tag ??
	| exception messageText |
	exception := Exception new.
	self should: [exception tag == nil].
	messageText := 'our chief weapon is fear'.
	exception messageText: messageText.
	self should: [exception tag = messageText].
	exception tag: 1.
	self should: [exception tag = 1].
"
! !

!ExceptionDescriptionHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ExceptionDescriptionHelper.st,v 1.1 2002/06/21 10:37:07 penk Exp $'
! !
