"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#ExceptionSelectorHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!ExceptionSelectorHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<exceptionSelector>'
! !

!ExceptionSelectorHelper methodsFor:'testing'!

testXconcatenateOp
	" Exception <exceptionSelector> "
	| object exceptionClass1 exceptionClass2 |
	self messageSelector: #','.

	object := testCase canonicalObject.
	exceptionClass1 := object = Exception
		ifTrue: [Error]
		ifFalse: [Exception].
	exceptionClass2 := object.

	self conformingValue: [exceptionClass1, exceptionClass2 ]
		should: [:r |
			(r handles: exceptionClass1 new)
			& (r handles: exceptionClass2 new)].
!

testXhandlesX
	" Exception <exceptionSelector> "
	| object exceptionClass |
	self messageSelector: #'handles:'.

	object := testCase canonicalObject.
	(object respondsToProtocolId: #'<exceptionSet>') ifTrue: [
		object := Error].

	self conformingValue: [[object signal]
			on: object
			do: [:except| except return: (object handles: except)]]
		should: [:r| r].

	exceptionClass := (object respondsToProtocolId: #'<Error class>')
		ifTrue: [Notification]
		ifFalse: [Error].
	self conformingValue: [[object signal]
			on: object
			do: [:except| except return: (exceptionClass handles: except)]]
		shouldnt: [:r| r].
! !

!ExceptionSelectorHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ExceptionSelectorHelper.st,v 1.1 2002/06/21 10:31:39 penk Exp $'
! !
