"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#ExceptionSetTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!ExceptionSetTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<exceptionSet>'
! !

!ExceptionSetTest methodsFor:'constants'!

canonicalObject

	^ExceptionSet new
! !

!ExceptionSetTest methodsFor:'testing'!

testXconcatenateOp
	" Exception <exceptionSet> "
	| exceptionSet |
	self messageSelector: #','.

	"Definition: <exceptionSelector>
		Return an exception set that contains the receiver and the
		argument exception. This is commonly used to specify a set
		of exception selectors for an exception handler.
	Refinement: <exceptionSet>
		In addition to anotherException the exception set that is
		returned contains all of the exception selectors contained
		in the receiver.
		The returned object may or may not be the same object as
		the receiver."
	self conformingValue: [exceptionSet := Warning, Error]
		should: [:r| (r handles: Warning new) & (r handles: Error new)].

	self conformingValue: [exceptionSet, Notification]
		should: [:r|
			(r handles: Warning new)
			& (r handles: Error new)
			& (r handles: Notification new)].
! !

!ExceptionSetTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ExceptionSetTest.st,v 1.1 2002/06/21 10:24:22 penk Exp $'
! !
