"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#ExtensibleCollectionHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!ExtensibleCollectionHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<extensibleCollection>'
! !

!ExtensibleCollectionHelper methodsFor:'testing'!

testXaddAllX
	" Collection <extensibleCollection> "
	| extensibleCollection addCollection compareCollection |
	self messageSelector: #'addAll:'.

	extensibleCollection := testCase canonicalObject.
	self conformingValue: [extensibleCollection addAll: #(666 777)] 
		should: [:result| (extensibleCollection includes: 777)
			and: [extensibleCollection includes: 666]].

	addCollection := OrderedCollection with: 555 with: 444.
	extensibleCollection := testCase canonicalObject.
	compareCollection := testCase canonicalObject.
	self should: [(addCollection do: [:each |
			extensibleCollection add: each]) = (compareCollection addAll: addCollection)]
!

testXaddX
	" Collection <extensibleCollection> "
	| extensibleCollection |
	self messageSelector: #'add:'.

	extensibleCollection := testCase canonicalObject.
	self conformingValue: [extensibleCollection add: 777]   
		should: [:result| extensibleCollection includes: 777]
!

testXremoveAllX
	" Collection <extensibleCollection> "
	| extensibleCollection removeAll |
	self messageSelector: #'removeAll:'.

	extensibleCollection := testCase canonicalObject.
	removeAll := extensibleCollection.
	self conformingValue: [extensibleCollection removeAll: removeAll]       
		should: [:result| extensibleCollection isEmpty]
!

testXremoveX
	" Collection <extensibleCollection> "
	| extensibleCollection sampleValue |
	self messageSelector: #'remove:'.

	extensibleCollection := testCase canonicalObject.
	extensibleCollection do: [:each| sampleValue := each].
	self conformingValue: [extensibleCollection remove: sampleValue]        
		should: [:result| (extensibleCollection includes: sampleValue) not]
!

testXremoveXifAbsentX
	" Collection <extensibleCollection> "
	| extensibleCollection sampleValue |
	self messageSelector: #'remove:ifAbsent:'.
        
	extensibleCollection := testCase canonicalObject.
	extensibleCollection do: [:each| sampleValue := each].
	self conformingValue: [extensibleCollection
			remove: sampleValue
			ifAbsent: [#'foo']]     
		should: [:result| result = sampleValue].

	self conformingValue: [extensibleCollection
			remove: sampleValue
			ifAbsent: [#foo]]       
		should: [:result| result = #'foo']
! !

!ExtensibleCollectionHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ExtensibleCollectionHelper.st,v 1.1 2002/06/21 10:26:20 penk Exp $'
! !
