"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#FailedMessageTest
	instanceVariableNames:'failedMsg'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Fundamental'
!


!FailedMessageTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<failedMessage>'
! !

!FailedMessageTest methodsFor:'constants'!

canonicalObject
	"Return a Message object, which is created when the VM traps a misunderstood message"

	^failedMsg
! !

!FailedMessageTest methodsFor:'helpers'!

setUp
	"Make a failed message and put it in failedMsg."

	super setUp.
	[nil foo]
		on: MessageNotUnderstood
		do: [:ex| failedMsg := ex message].
! !

!FailedMessageTest methodsFor:'testing'!

testXarguments
	" Fundamental <failedMessage> "
	self messageSelector: #'arguments'.

	"Return a collection containing the arguments of the message that could not be sent. The elements of the collection are ordered, from the first element to the last element, in the same order as the arguments of the message, from left to right. If the message had no arguments, the collection will be empty."

	self conformingValue: [failedMsg arguments]
		should: [:r| r isEmpty].

	[self dum: 1 dum: 2 dum: 3]
		on: MessageNotUnderstood
		do: [:ex| failedMsg := ex message].
	self conformingValue: [failedMsg arguments]
		should: [:r| r size = 3 and: [(r first = 1) & (r last = 3)]].
!

testXselector
	" Fundamental <failedMessage> "
	self messageSelector: #'selector'.

	self conformingValue: [failedMsg selector]
		should: [:r| r = #'foo'].

	[self dum: 1 dum: 2 dum: 3]
		on: MessageNotUnderstood
		do: [:ex| failedMsg := ex message].
	self conformingValue: [failedMsg selector]
		should: [:r | r = #'dum:dum:dum:'].
! !

!FailedMessageTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/FailedMessageTest.st,v 1.1 2002/06/21 10:33:40 penk Exp $'
! !
