"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#FileStreamHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-File Stream'
!


!FileStreamHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<FileStream>'
! !

!FileStreamHelper methodsFor:'testing'!

testXcontents
	" File Stream <FileStream> "
	| textStream binaryStream |
	self messageSelector: #'contents'.

self anomaly: [
	[textStream := testCase textStream.
	binaryStream := testCase binaryStream.
	self conformingValue: [textStream contents]
		should: [:r| self
			compareTextIgnoringLineTermTarget: testCase canonicalContents
			result: r].
	self conformingValue: [binaryStream contents]
		should: [:r| self
			compareTextIgnoringLineTermTarget: testCase canonicalContents
			result: r asString]

	] ensure: [
		textStream close.
		binaryStream close].
] for: #(#'DO30' "2000/12/13 Harmon, R.
Definition: <sequencedStream>
	Returns a collection that contains the receiver's past and future sequence values, in order.
Refinement: <FileStream>
	If the external stream type is #'binary' the returned collection conforms to <ByteArray>. If the external stream type is #'text' the returned collection conforms to <String>.

contents returns only past (up to position) ignoring future.").
!

testXexternalType
	" File Stream <FileStream> "
	| textStream binaryStream |
	self messageSelector: #'externalType'.

	[textStream := testCase textStream.
	binaryStream := testCase binaryStream.

	self conformingValue: [textStream externalType]
		should: [:r | r = #'text'].
	self conformingValue: [binaryStream externalType]
		should: [:r | r = #'binary']

	] ensure: [
		textStream close.
		binaryStream close]
!

testXisBinary
	" File Stream <FileStream> "
	| textStream binaryStream |
	self messageSelector: #'isBinary'.

	[textStream := testCase textStream.
	binaryStream := testCase binaryStream.
	self conformingValue: [textStream isBinary]
		shouldnt: [:r| r].
	self conformingValue: [binaryStream isBinary]
		should: [:r| r]

	] ensure: [
		textStream close.
		binaryStream close]
!

testXisText
	" File Stream <FileStream> "
	| textStream binaryStream |
	self messageSelector: #'isText'.

	[textStream := testCase textStream.
	binaryStream := testCase binaryStream.
	self conformingValue: [textStream isText]
		should: [:r| r].
	self conformingValue: [binaryStream isText]
		shouldnt: [:r| r]

	] ensure: [
		textStream close.
		binaryStream close]
! !

!FileStreamHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/FileStreamHelper.st,v 1.1 2002/06/21 10:35:22 penk Exp $'
! !
