"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#FloatTest
	instanceVariableNames:'float2 magnitudeObjects numberObjects'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Numeric'
!


!FloatTest class methodsFor:'constants'!

magnitudeObjects

	^Dictionary new
		at: #'small'            put: -3000000000.0d0;
		at: #'medium'   put: 1.0d0;
		at: #'large'            put: 3000000000.0d0;
		yourself
!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Float>'
! !

!FloatTest methodsFor:'constants'!

canonicalObject

	^Float pi   "3.141592653589793d0"
!

magnitudeObjects

	^magnitudeObjects
!

numberObjects

	^numberObjects
! !

!FloatTest methodsFor:'helpers'!

createNumberObjects
	| tmp numbers |

	numberObjects := Dictionary new.
	numberObjects
		at: #'numbers' put: #(2.0d0 -2.0d0 0.0);
		at: #'coercing' put: [:number| number asFloat];
		at: #'zero' put: 0.0;
		at: #'*' put: #(
				#(-4.000000000d9 1.0d0 4.0d0 4.0d0 4.0d0 4.000000000d9)
				#(4.000000000d9 -1.0d0 -4.0d0 -4.0d0 -4.0d0 -4.000000000d9)
				#(0.0 0.0 0.0 0.0 0.0 0.0));
		at: #'+' put: #(
				#(-1.999999998d9 2.5d0 4.0d0 4.0d0 4.0d0 2.000000002d9)
				#(-2.000000002d9 -1.5d0 0.0 0.0 0.0 1.999999998d9)
				#(-2.000000000d9 0.5d0 2.0d0 2.0d0 2.0d0 2.000000000d9));
		at: #'-' put: #(
				#(2.000000002d9 1.5d0 0.0 0.0 0.0 -1.999999998d9)
				#(1.999999998d9 -2.5d0 -4.0d0 -4.0d0 -4.0d0 -2.000000002d9)
				#(2.000000000d9 -0.5d0 -2.0d0 -2.0d0 -2.0d0 -2.000000000d9));
		at: #'/' put: #(
				#(-1.0d-9 4.0d0 1.0d0 1.0d0 1.0d0 1.0d-9)
				#(1.0d-9 -4.0d0 -1.0d0 -1.0d0 -1.0d0 -1.0d-9)
				#(0.0 0.0 0.0 0.0 0.0 0.0));
		at: #'//' put: #(
				#(-1 4 1 1 1 0)
				#(0 -4 -1 -1 -1 -1)
				#(0 0 0 0 0 0));
		at: #'<' put: #(
				#(false false false false false true)
				#(false true true true true true)
				#(false true true true true true));
		at: #'=' put: #(
				#(false false true true true false)
				#(false false false false false false)
				#(false false false false false false));
		at: #'>' put: #(
				#(true true false false false false)
				#(true false false false false false)
				#(true false false false false false)).

	"\\" tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2.6d1 -2.6d1 2.65d1 -2.65d1 0.0);
		at: #'posAnswers'       put: #(
			#(-1.999999974d9 0.0 0.0 0.0 0.0 2.6d1)
			#(-2.6d1 0.0 0.0 0.0 0.0 1.999999974d9)
			#(-1.9999999735d9 0.0 0.5d0 0.5d0 0.5d0 2.65d1)
			#(-2.65d1 0.0 1.5d0 1.5d0 1.5d0 1.9999999735d9)
			#(0.0 0.0 0.0 0.0 0.0 0.0));
		at: #'negAnswers'       put: #(
			#(2.6d1 0.0 0.0 0.0 0.0 -1.999999974d9)
			#(1.999999974d9 0.0 0.0 0.0 0.0 -2.6d1)
			#(2.65d1 0.0 -1.5d0 -1.5d0 -1.5d0 -1.9999999735d9)
			#(1.9999999735d9 0.0 -0.5d0 -0.5d0 -0.5d0 -2.65d1)
			#(0.0 0.0 0.0 0.0 0.0 0.0)).
	numberObjects at: #'\\' put: tmp.

	numberObjects
		at: #'abs'              put: #(2.0d0 2.0d0 0.0);
		at: #'asFloat'  put: (numberObjects at: #'numbers');
		at: #'asFloatD' put: (numberObjects at: #'numbers');
		at: #'asFloatE' put: (numberObjects at: #'numbers');
		at: #'asFloatQ' put: (numberObjects at: #'numbers');
		at: #'asFraction'       put: #(2 -2 0).

	"asInteger"     tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2.0d0 2.1d0 2.5d0 -2.0d0 -2.1d0 -2.5d0 0.0);
		at: #'answers'  put: #(2 2 3 -2 -2 -3 0).
	numberObjects at: #'asInteger'  put: tmp.

	"asScaledDecimal:"      tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 2); add: (-2.0d0 asScaledDecimal: 2);
			add: (0.0 asScaledDecimal: 2); yourself);
		at: #'scales'   put: #(2 2 2).
	numberObjects at: #'asScaledDecimal:'   put: tmp.

	"ceiling"       tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2.0d0 2.1d0 2.5d0 -2.0d0 -2.1d0 -2.5d0 0.0);
		at: #'answers'  put: #(2 3 3 -2 -2 -2 0).
	numberObjects at: #'ceiling'    put: tmp.

	"floor" tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2.0d0 2.1d0 2.5d0 -2.0d0 -2.1d0 -2.5d0 0.0);
		at: #'answers'  put: #(2 2 2 -2 -3 -3 0).
	numberObjects at: #'floor' put: tmp.

	"fractionPart"  tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2.65d1 -2.65d1 2.6d1 0.0);
		at: #'answers'  put: #(0.5d0 -0.5d0 0.0 0.0).
	numberObjects at: #'fractionPart' put: tmp.

	"integerPart"   tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2.65d1 -2.65d1 2.6d1 0.0);
		at: #'answers'  put: #(2.6d1 -2.6d1 2.6d1 0.0).
	numberObjects at: #'integerPart' put: tmp.

	numberObjects
		at: #'negated'  put: #(-2.0d0 2.0d0 0.0);
		at: #'negative' put: #(false true false);
		at: #'positive' put: #(true false true);
		at: #'quo:' put: #(
			#(0 4 1 1 1 0)
			#(0 -4 -1 -1 -1 0)
			#(0 0 0 0 0 0)).

	numberObjects at: #'raisedToInteger:' put: #(
		"number integer value"
		#(5.1d0 0 1.0d0) #(5.1d0 1 5.1d0) #(5.1d0 2 2.601d1)
		#(5.1d0 -2 0.0384467512495194d0)).

	numberObjects
		at: #'reciprocal' put: #(2.0d0 -2.0d0).

	"rem:"  tmp := Dictionary new.
	tmp at: #'numbers' put: #(2.60000000015d10 -2.60000000015d10 26.0d9 -26.0d9
				0.0);
		at: #'answers' put: #(
				#(1.5d0 1.5d0 1.5d0 1.5d0 1.5d0 1.5d0)
				#(-1.5d0 -1.5d0 -1.5d0 -1.5d0 -1.5d0 -1.5d0)
				#(0.0 0.0 0.0 0.0 0.0 0.0)
				#(0.0 0.0 0.0 0.0 0.0 0.0)
				#(0.0 0.0 0.0 0.0 0.0 0.0)).
	numberObjects at: #'rem:' put: tmp.

	"rounded"       tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2.0d0 2.1d0 2.5d0 -2.0d0 -2.1d0 -2.5d0 0.0);
		at: #'answers'  put: #(2 2 3 -2 -2 -3 0).
	numberObjects at: #'rounded' put: tmp.

	numberObjects
		at: #'roundTo:' put: #(0.0 3.0d0 4.0d0 4.0d0 4.0d0 0.0);
		at: #'sign'     put: #(1 -1 0).

	"sqrt"  tmp := Dictionary new.
	tmp at: #'numbers'      put: #(26.01d0 4.0d0 0.10d0 0.0);
		at: #'answers'  put: #(5.1d0 2.0d0 0.3162277660168379d0 0).
	numberObjects at: #'sqrt' put: tmp.

	"squared"       tmp := Dictionary new.
	tmp at: #'numbers'      put: #(5.1d0 -5.1d0 0.0);
		at: #'answers'  put: #(26.01d0 26.01d0 0).
	numberObjects at: #'squared' put: tmp.

	numberObjects
		at: #'strictlyPositive' put: #(true false false).

	"truncated"     tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2.0d0 2.1d0 2.5d0 -2.0d0 -2.1d0 -2.5d0 0.0);
		at: #'answers'  put: #(2 2 2 -2 -2 -2 0).
	numberObjects at: #'truncated'  put: tmp.

	numberObjects
		at: #'truncateTo:' put: #(0.0 3.0d0 2.0d0 2.0d0 2.0d0 0.0).
!

setUp

	super setUp.
	float2 := 2.0d0.
	magnitudeObjects := self class magnitudeObjects.
	self createNumberObjects.
! !

!FloatTest methodsFor:'testing'!

testLiterals

	"Test if float literals supported:"
	self should: [1.1e1 = 11.0].
	self should: [1.1d1 = 11.0].
self anomaly: [
	self should: [1.1q1 = 11.0].
	self shouldnt: [1.0q = 1.0].
] for: #(#'DO30' "2000/12/06 Harmon, R. Doesn't accept q").
	self shouldnt: [10e10 = 1.0].
!

testXarcCos
	" Numeric <Float> "
	| float1 |
	self messageSelector: #'arcCos'.

	float1 := 1.0d0.
	self conformingValue: [float1 arcCos]
		should: [:r| r cos closeTo: float1].

	float1 := 0.5d0.
	self conformingValue: [float1 arcCos]
		should: [:r| r cos closeTo: float1].
!

testXarcSin
	" Numeric <Float> "
	| float1 |
	self messageSelector: #'arcSin'.

	float1 := 1.0d0.
	self conformingValue: [float1 arcSin]
		should: [:r| r sin closeTo: float1].

	float1 := 1.0d-5.
	self conformingValue: [float1 arcSin]
		should: [:r| r sin closeTo: float1].
!

testXarcTan
	" Numeric <Float> "
	| float1 |
	self messageSelector: #'arcTan'.

	float1 := 1.0d0.
	self conformingValue: [float1 arcTan]
		should: [:r| r tan closeTo: float1].

	float1 := 1.0d-5.
	self conformingValue: [float1 arcTan]
		should: [:r| r tan closeTo: float1].
!

testXcos
	" Numeric <Float> "
	| float1 |
	self messageSelector: #'cos'.

	float1 := 1.0d0.
	self conformingValue: [float1 cos]
		should: [:r| r arcCos closeTo: float1].

	float1 := 0.5d0.
	self conformingValue: [float1 cos]
		should: [:r| r arcCos closeTo: float1].
!

testXdegreesToRadians
	" Numeric <Float> "
	self messageSelector: #'degreesToRadians'.

	self conformingValue: [float2 degreesToRadians]
		should: [:r| r radiansToDegrees closeTo: float2].
!

testXequalityOp
	" Numeric <Float> "
	| floatA |
	self messageSelector: #'='.

	"receiver = comparand   =>
	receiver hash = comparand hash"
	floatA := 2.0d0.
	self conformingValue: [floatA = float2]
		should: [:r| r & (float2 = floatA)].
	self conformingValue: [float2 = float2]
		should: [:r| r & (float2 hash = float2 hash)].
	self conformingValue: [floatA = float2]
		should: [:r| r & (floatA hash = float2 hash)].
	self conformingValue: [float2 = 2.1d0]
		shouldnt: [:r| r | (float2 hash = 2.1d0 hash)].
!

testXexp
	" Numeric <Float> "
	self messageSelector: #'exp'.

	self conformingValue: [float2 exp]
		should: [:r| r closeTo: (float2 class e raisedTo: float2)].
!

testXfloorLogX
	" Numeric <Float> "
	| float1 |
	self messageSelector: #'floorLog:'.

	self conformingValue: [self canonicalObject floorLog: 10]
		should: [:r| r = 0].

	float1 := 0.25d0.
	self conformingValue: [float1 floorLog: 3]
		should: [:r| r = -2].
!

testXln
	" Numeric <Float> "
	| canonicalObject |
	self messageSelector: #'ln'.

	canonicalObject := self canonicalObject.
	self conformingValue: [canonicalObject ln]
		should: [:r| r exp closeTo: canonicalObject].
!

testXlogX
	" Numeric <Float> "
	| canonicalObject |
	self messageSelector: #'log:'.

	canonicalObject := self canonicalObject.
	self conformingValue: [canonicalObject log: 10]
		should: [:r| (10 raisedTo: r) closeTo: canonicalObject].
!

testXprintString
	" Numeric <Float> "
	| number product string estring |
	self messageSelector: #'printString'.

	"Answer a string which is a valid Smalltalk literal representation
	approximately equal to the receiver."
	self conformingValue: [2.0d0 printString]
		should: [:r| r = '2.0'].
	self conformingValue: [0.0 printString]
		should: [:r| r = '0.0'].
	self conformingValue: [-2.0d0 printString]
		should: [:r| r = '-2.0'].

	"An exponent literal form is
	produced if the value of the exponent is greater than the precision
	of the receiver."
	number := 1.0d0.
	product := number / (10.0d0 raisedTo: Float precision - 1).
	self conformingValue: [product printString]
		should: [:r|
			string := '0.'.
			Float precision - 2 timesRepeat: [string := string, '0'].
			string := string, number asInteger printString.
			estring := '1.0e-', (Float precision - 1) printString.
			r = string | r = estring].

	number := 1.0d0.
	product := number / (10.0d0 raisedTo: Float precision).
	self conformingValue: [product printString]
		should: [:r|
			string := number printString, 'e-', Float precision printString.
			r = string].
!

testXradiansToDegrees
	" Numeric <Float> "
	self messageSelector: #'radiansToDegrees'.

	self conformingValue: [float2 radiansToDegrees]
		should: [:r| r degreesToRadians closeTo: float2].
!

testXsin
	" Numeric <Float> "
	| float1 |
	self messageSelector: #'sin'.

	float1 := 1.0d0.
	self conformingValue: [float1 sin]
		should: [:r| r arcSin closeTo: float1].

	float1 := 0.5d0.
	self conformingValue: [float1 sin]
		should: [:r| r arcSin closeTo: float1].
!

testXtan
	" Numeric <Float> "
	| float1 |
	self messageSelector: #'tan'.

	float1 := 1.0d0.
	self conformingValue: [float1 tan]
		should: [:r| r arcTan closeTo: float1].

	float1 := 0.5d0.
	self conformingValue: [float1 tan]
		should: [:r| r arcTan closeTo: float1].
! !

!FloatTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/FloatTest.st,v 1.1 2002/06/21 10:25:48 penk Exp $'
! !
