"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#FractionFactoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Numeric'
!


!FractionFactoryTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Fraction factory>'
! !

!FractionFactoryTest methodsFor:'others'!

canonicalObject

	^Fraction
! !

!FractionFactoryTest methodsFor:'testing'!

testXnumeratorXdenominatorX
	" Numeric <Fraction factory> "
	| canonicalObject |
	self messageSelector: #'numerator:denominator:'.

	canonicalObject := self canonicalObject.
	"Answer a new fraction whose numerator is top, and whose denominator
	is bottom."
	self conformingValue: [
		canonicalObject
			numerator: 1
			denominator: 2]
		should: [:r| r = (1/2)].

	"It is unspecified whether the result is reduced to the
	smallest possible denominator."
	self conformingValue: [
		canonicalObject
			numerator: 3
			denominator: 6]
		should: [:r| r = (1/2)].

	"If (top = bottom) or ( |bottom = 1) the result conforms to <integer> otherwise it conforms to <Fraction>."
	self conformingValue: [
		canonicalObject
			numerator: 3
			denominator: 3]
		should: [:r| r = 1].

	self conformingValue: [
		canonicalObject
			numerator: 3
			denominator: 1]
		should: [:r| r = 3].

	"If bottom = 0 a ZeroDivide  exception is signaled."
	self should: [
		canonicalObject
			numerator: 3
			denominator: 0]
		raise: ZeroDivide
! !

!FractionFactoryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/FractionFactoryTest.st,v 1.1 2002/06/21 10:33:47 penk Exp $'
! !
