"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#FractionTest
	instanceVariableNames:'magnitudeObjects numberObjects'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Numeric'
!


!FractionTest class methodsFor:'constants'!

magnitudeObjects

	^Dictionary new
		at: #'small' put: -10000000001/3;
		at: #'medium' put: 1/2;
		at: #'large' put: 10000000000/3;
		yourself
!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Fraction>'
! !

!FractionTest methodsFor:'constants'!

canonicalObject

	^1/2
!

magnitudeObjects

	^magnitudeObjects
!

numberObjects

	^numberObjects
! !

!FractionTest methodsFor:'helpers'!

createNumberObjects
        
	| tmp numbers |
	numberObjects := Dictionary new.
	numberObjects
		at: #'numbers' put: (OrderedCollection new
				add: (1/2); add: (-1/2); add: (0/2); yourself);
		at: #'coercing' put: [:number| | numberFraction |
			"Note: Some dialects may automatially reduce this producing
				an integer. 2000/12/16 Harmon, R."
			numberFraction := number asFraction.
			Fraction
				numerator: (numberFraction numerator)
				denominator: (numberFraction denominator)];
		at: #'zero' put: (0/2);
		at: #'*' put: (OrderedCollection new
			add: (OrderedCollection new
				add: -1000000000; add: (1/4); add: 1; add: 1;
				add: 1.0d0; add: 1000000000; yourself);
			add: (OrderedCollection new
				add: 1000000000; add: (-1/4); add: -1; add: -1;
				add: -1.0d0; add: -1000000000; yourself);
			add: (OrderedCollection new
				add: 0; add: 0; add: ScaledDecimal zero; add: 0;
				add: 0.0; add: 0; yourself);
			yourself);
		at: #'+' put: (OrderedCollection new
			add: (OrderedCollection new
				add: (-3999999999/2); add: 1; add: (5/2); add: (5/2);
				add: 2.5d0; add: (4000000001/2); yourself);
			add: (OrderedCollection new
				add: (-4000000001/2); add: 0; add: (3/2); add: (3/2);
				add: 1.5d0; add: (3999999999/2); yourself);
			add: (OrderedCollection new
				add: (-2000000000); add: (1/2);
				add: (2.0d0 asScaledDecimal: 3); add: 2;
				add: 2.0d0; add: 2000000000; yourself);
			yourself);
		at: #'-' put: (OrderedCollection new
			add: (OrderedCollection new
				add: (4000000001/2); add: 0; add: (-3/2); add: (-3/2);
				add: -1.5d0; add: (-3999999999/2); yourself);
			add: (OrderedCollection new
				add: (3999999999/2); add: -1; add: (-5/2); add: (-5/2);
				add: -2.5d0; add: (-4000000001/2); yourself);
			add: (OrderedCollection new
				add: (2000000000); add: (-1/2);
				add: (-2.0d0 asScaledDecimal: 3); add: -2;
				add: -2.0d0; add: -2000000000; yourself);
			yourself);
		at: #'/' put: (OrderedCollection new
			add: (OrderedCollection new
				add: (-1/4000000000); add: 1; add: (1/4); add: (1/4);
				add: 0.25d0; add: (1/4000000000); yourself);
			add: (OrderedCollection new
				add: (1/4000000000); add: -1; add: (-1/4); add: (-1/4);
				add: -0.25d0; add: (-1/4000000000); yourself);
			add: (OrderedCollection new
				add: 0; add: 0; add: (0.0 asScaledDecimal: 3); add: 0;
				add: 0.0; add: 0; yourself);
			yourself);
		at: #'//' put: #(
				#(-1 1 0 0 0 0)
				#(0 -1 -1 -1 -1 -1)
				#(0 0 0 0 0 0));
		at: #'<' put: #(
				#(false false true true true true)
				#(false true true true true true)
				#(false true true true true true));
		at: #'=' put: #(
				#(false true false false false false)
				#(false false false false false false)
				#(false false false false false false));
		at: #'>' put: #(
				#(true false false false false false)
				#(true false false false false false)
				#(true false false false false false)).

	"\\" tmp := Dictionary new.
	tmp at: #'numbers' put: (OrderedCollection new
				add: (1/2); add: (-1/2); add: (3/2); add: (-3/2);
				add: (0/2); yourself);
		at: #'posAnswers' put: (OrderedCollection new
				add: (OrderedCollection new add: (-3999999999/2); add: 0;
					add: (1/2); add: (1/2); add: 0.5d0; add: (1/2);
					yourself);
				add: (OrderedCollection new add: (-1/2); add: 0;
					add: (3/2); add: (3/2); add: 1.5d0;
					add: (3999999999/2); yourself);
				add: (OrderedCollection new add: (-3999999997/2); add: 0;
					add: (3/2); add: (3/2); add: 1.5d0;
					add: (3/2); yourself);
				add: (OrderedCollection new add: (-3/2); add: 0;
					add: (1/2); add: (1/2); add: 0.5d0;
					add: (3999999997/2); yourself);
				add: (OrderedCollection new add: 0; add: 0;
					add: ScaledDecimal zero; add: 0; add: 0.0;
					add: 0; yourself);
				yourself);
		at: #'negAnswers' put: (OrderedCollection new
				add: (OrderedCollection new add: (1/2); add: 0;
					add: (-3/2); add: (-3/2); add: -1.5d0;
					add: (-3999999999/2); yourself);
				add: (OrderedCollection new add: (3999999999/2); add: 0;
					add: (-1/2); add: (-1/2); add: -0.5d0;
					add: (-1/2); yourself);
				add: (OrderedCollection new add: (3/2); add: 0;
					add: (-1/2); add: (-1/2); add: -0.5d0;
					add: (-3999999997/2); yourself);
				add: (OrderedCollection new add: (3999999997/2); add: 0;
					add: (-3/2); add: (-3/2); add: -1.5d0;
					add: (-3/2); yourself);
				add: (OrderedCollection new add: 0; add: 0;
					add: ScaledDecimal zero; add: 0; add: 0.0;
					add: 0; yourself);
				yourself).
	numberObjects at: #'\\' put: tmp.

	numberObjects
		at: #'abs' put: (OrderedCollection new
				add: (1/2); add: (1/2); add: (0/2); yourself);
		at: #'asFloat'  put: #(0.5d0 -0.5d0 0.0);
		at: #'asFloatD' put: (numberObjects at: #'asFloat');
		at: #'asFloatE' put: (numberObjects at: #'asFloat');
		at: #'asFloatQ' put: (numberObjects at: #'asFloat');
		at: #'asFraction' put: (numberObjects at: #'numbers').

	"asInteger"     tmp := Dictionary new.
	tmp at: #'numbers' put: (OrderedCollection new
				add: (1/2); add: (-1/2); add: 0; add: (1/3); yourself);
		at: #'answers'  put: #(1 -1 0 0).
	numberObjects at: #'asInteger'  put: tmp.

	"asScaledDecimal:"      tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: (OrderedCollection new
			add: (0.5d0 asScaledDecimal: 2); add: (-0.5d0 asScaledDecimal: 2);
			add: (0.0 asScaledDecimal: 2); yourself);
		at: #'scales'   put: #(2 2 2).
	numberObjects at: #'asScaledDecimal:'   put: tmp.

	"ceiling"       tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (1/2); add: (-1/2); add: 0; add: (1/3); yourself);
		at: #'answers'  put: #(1 0 0 1).
	numberObjects at: #'ceiling'    put: tmp.

	"floor" tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (1/3); add: (1/2); add: (3/2); add: (-1/2); add: 0;
			yourself);
		at: #'answers'  put: #(0 0 1 -1 0).
	numberObjects at: #'floor' put: tmp.

	"fractionPart"  tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (3/2); add: (-3/2); add: 0; yourself);
		at: #'answers'  put: (OrderedCollection new
			add: (1/2); add: (-1/2); add: 0; yourself).
	numberObjects at: #'fractionPart' put: tmp.

	"integerPart"   tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (3/2); add: (-3/2); add: (1/2); add: 0; yourself);
		at: #'answers'  put: #(1 -1 0 0).
	numberObjects at: #'integerPart' put: tmp.

	numberObjects
		at: #'negated' put: (OrderedCollection new
				add: (-1/2); add: (1/2); add: 0; yourself);
		at: #'negative' put: #(false true false);
		at: #'positive' put: #(true false true);
		at: #'quo:' put: #(
				#(0 1 0 0 0 0)
				#(0 -1 0 0 0 0)
				#(0 0 0 0 0 0)).
	numberObjects at: #'raisedToInteger:' put: (OrderedCollection new
			"number integer answer"
		add: (OrderedCollection new add: (51/10); add: 0;
				add: 1; yourself);
		add: (OrderedCollection new add: (51/10); add: 1;
				add: (51/10); yourself);
		add: (OrderedCollection new add: (51/10); add: 2;
				add: (2601/100); yourself);
		add: (OrderedCollection new add: (51/10); add: 2;
				add: (2601/100); yourself);
		add: (OrderedCollection new add: (51/10); add: -2;
				add: (100/2601); yourself);
		yourself).
	numberObjects
		at: #'reciprocal' put: (OrderedCollection new
				add: (1/2); add: (-1/2); yourself).

	"rem:"  tmp := Dictionary new.
	tmp at: #'numbers' put: (OrderedCollection new
				add: (52000000003/2); add: (-52000000003/2);
				add: (0/2); yourself);
		at: #'answers' put: (OrderedCollection new
		add: (OrderedCollection new add: (3/2); add: (3/2); add: (3/2);
				add: 1.5d0; add: (3/2); add: (3/2); yourself);
		add: (OrderedCollection new add: (-3/2); add: (-3/2); add: (-3/2);
				add: -1.5d0; add: (-3/2); add: (-3/2); yourself);
		add: (OrderedCollection new add: 0; add: 0; add: 0;
				add: 0.0; add: 0; add: ScaledDecimal zero; yourself);
		yourself).
	numberObjects at: #'rem:' put: tmp.

	"rounded"       tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (1/3); add: (1/2); add: (3/2); add: (-1/2); add: (0/2);
			yourself);
		at: #'answers'  put: #(0 1 2 -1 0).
	numberObjects at: #'rounded' put: tmp.

	numberObjects
		at: #'roundTo:' put: (OrderedCollection new
			add: 0; add: (1/2); add: 0; add: 0; add: 0.0; add: 0; yourself);
		at: #'sign'     put: #(1 -1 0).

	"sqrt"  tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (2601/100); add: (1/4); add: (1/10); add: (0/2); yourself);
		at: #'answers'  put: #(5.1d0 0.5d0 0.3162277660168379d0 0).
	numberObjects at: #'sqrt' put: tmp.

	"squared"       tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (51/10); add: (-51/10); add: (0/2); yourself);
		at: #'answers'  put: (OrderedCollection new
			add: (2601/100); add: (2601/100); add: 0; yourself).
	numberObjects at: #'squared' put: tmp.

	numberObjects
		at: #'strictlyPositive' put: #(true false false).

	"truncated"     tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (1/3); add: (1/2); add: (-1/2); add: 0; add: (2/3);
			add: (3/2); yourself);
		at: #'answers'  put: #(0 0 0 0 0 1).
	numberObjects at: #'truncated'  put: tmp.

	numberObjects
		at: #'truncateTo:' put: (OrderedCollection new
			add: 0; add: (1/2); add: 0; add: 0; add: 0.0; add: 0; yourself).
!

setUp

	super setUp.
	magnitudeObjects := self class magnitudeObjects.
	self createNumberObjects.

! !

!FractionTest methodsFor:'testing'!

testXdenominator
	" Numeric <Fraction> "
	self messageSelector: #'denominator'.

	"It is unspecific whether the rational number are maintain in a
	reduced form but messages that reveal the numerator and denominator
	answer values as if the fraction was reduced."
	self conformingValue: [(3/6) denominator] 
		should: [:r| r = 2].
!

testXnumerator
	" Numeric <Fraction> "
	self messageSelector: #'numerator'.

	"It is unspecific whether the rational number are maintain in a
	reduced form but messages that reveal the numerator and denominator
	answer values as if the fraction was reduced."
	self conformingValue: [(3/6) numerator] 
		should: [:r| r = 1].
!

testXprintString
	" Numeric <Fraction> "
	self messageSelector: #'printString'.

	self conformingValue: [(1/2) printString] should: [:r| r = '1/2'].
	self conformingValue: [(1/-2) printString] should: [:r| r = '-1/2'].
	self conformingValue: [(3/33) printString] should: [:r| r = '1/11'].
! !

!FractionTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/FractionTest.st,v 1.1 2002/06/21 10:26:36 penk Exp $'
! !
