"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#IdentityDictionaryFactoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!IdentityDictionaryFactoryTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<IdentityDictionary factory>'
! !

!IdentityDictionaryFactoryTest methodsFor:'constants'!

canonicalAbstractDictionary

	^IdentityDictionaryTest canonicalCollection
!

canonicalObject

	^IdentityDictionary
! !

!IdentityDictionaryFactoryTest methodsFor:'testing'!

testXnew
	" ANSI-Collection <IdentityDictionary factory> "
	self messageSelector: #'new'.

	self conformingValue: [IdentityDictionary new]
		should: [:r| r isEmpty].
!

testXnewX
	" ANSI-Collection <IdentityDictionary factory> "
	self messageSelector: #'new:'.

	self conformingValue: [IdentityDictionary new: 0]
		should: [:r| r isEmpty].

	self conformingValue: [IdentityDictionary new: 10]
		should: [:r| r isEmpty].
!

testXwithAllX
	" ANSI-Collection <IdentityDictionary factory> "
	| abstractDictionary |
	self messageSelector: #'withAll:'.

	"Return a new collection whose elements are the elements of newElements.
	The effect is the same as evaluating:
		IdentityDictionary new
			addAll: newElements;
			yourself."
	abstractDictionary := self canonicalAbstractDictionary.
self anomaly: [
	self conformingValue: [IdentityDictionary withAll: abstractDictionary]
		should: [:r| r keysDo: [:key |
			(r at: key) = (abstractDictionary at: key)
				ifFalse: [^false].
			^true]].
] for: #(#'DO30' "2001/02/20 Harmon, R. Uses (<collection>, #withAll:)
			which uses Dict, #do: using element value.")
! !

!IdentityDictionaryFactoryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/IdentityDictionaryFactoryTest.st,v 1.1 2002/06/21 10:36:19 penk Exp $'
! !
