"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#InitializableCollectionFactoryHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!InitializableCollectionFactoryHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<initializableCollection factory>'
! !

!InitializableCollectionFactoryHelper methodsFor:'testing'!

testXwithAllX
	" Collection <initializableCollection factory> "
	| collection icFactory |
	self messageSelector: #'withAll:'.

	icFactory := testCase canonicalObject.
	collection := testCase canonicalCollection.
	self conformingValue: [icFactory withAll: collection]
		should: [:r| r size = collection size].

	"Errors: If any of the arguments do not meet
		the element type constraints of the result object."
	testCase returnTypeHasLimitedElementTypes ifTrue: [
		| illegalElements |
		illegalElements := Array with: testCase limitedElementTypes.
		self should: [icFactory withAll: illegalElements]
			raise: TestResult error]
!

testXwithX
	" Collection <initializableCollection factory> "
	| element icFactory |
	self messageSelector: #'with:'.

	icFactory := testCase canonicalObject.
	element := testCase canonicalElement.
	self conformingValue: [icFactory with: element]
		should: [:r|
			r size = 1
			& r last = element].

	"Errors: If any of the arguments do not meet
		the element type constraints of the result object."
	testCase returnTypeHasLimitedElementTypes ifTrue: [
		self should: [icFactory with: (testCase limitedElementTypes)]
			raise: TestResult error].
!

testXwithXwithX
	" Collection <initializableCollection factory> "
	| collection icFactory |
	self messageSelector: #'with:with:'.

	icFactory := testCase canonicalObject.
	collection := testCase canonicalCollection.
	self conformingValue: [
			icFactory
				with: collection first
				with: collection last]
		should: [:r|
			r size = 2
			& r first = collection first
			& r last = collection last].

	"Errors: If any of the arguments do not meet
		the element type constraints of the result object."
	testCase returnTypeHasLimitedElementTypes ifTrue: [
		| illegalElement |
		self should: [
			illegalElement := testCase limitedElementTypes.
			icFactory
				with: illegalElement
				with: illegalElement]
			raise: TestResult error].
!

testXwithXwithXwithX
	" Collection <initializableCollection factory> "
	| collectionStrm icFactory |
	self messageSelector: #'with:with:with:'.

	icFactory := testCase canonicalObject.
	collectionStrm := ReadStream on: (testCase canonicalCollection).
	self conformingValue: [
			icFactory
				with: (collectionStrm next)
				with: (collectionStrm next)
				with: (collectionStrm next)]
		should: [:r| | resultStrm |
			resultStrm := ReadStream on: r.
			collectionStrm reset.
			r size = 3
			& resultStrm next = collectionStrm next
			& resultStrm next = collectionStrm next
			& resultStrm next = collectionStrm next].

	"Errors: If any of the arguments do not meet
		the element type constraints of the result object."
	testCase returnTypeHasLimitedElementTypes ifTrue: [
		| illegalElement |
		self should: [
			illegalElement := testCase limitedElementTypes.
			icFactory
				with: illegalElement
				with: illegalElement
				with: illegalElement]
			raise: TestResult error].
!

testXwithXwithXwithXwithX
	" Collection <initializableCollection factory> "
	| collectionStrm icFactory |
	self messageSelector: #'with:with:with:with:'.

	icFactory := testCase canonicalObject.
	collectionStrm := ReadStream on: (testCase canonicalCollection).
	self conformingValue: [
			icFactory
				with: (collectionStrm next)
				with: (collectionStrm next)
				with: (collectionStrm next)
				with: (collectionStrm next)]
		should: [:r| | resultStrm |
			resultStrm := ReadStream on: r.
			collectionStrm reset.
			r size = 4
			& resultStrm next = collectionStrm next
			& resultStrm next = collectionStrm next
			& resultStrm next = collectionStrm next
			& resultStrm next = collectionStrm next].

	"Errors: If any of the arguments do not meet
		the element type constraints of the result object."
	testCase returnTypeHasLimitedElementTypes ifTrue: [
		| illegalElement |
		self should: [
			illegalElement := testCase limitedElementTypes.
			icFactory
				with: illegalElement
				with: illegalElement
				with: illegalElement
				with: illegalElement]
			raise: TestResult error].
! !

!InitializableCollectionFactoryHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/InitializableCollectionFactoryHelper.st,v 1.1 2002/06/21 10:27:08 penk Exp $'
! !
