"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#IntegerTest
	instanceVariableNames:'magnitudeObjects numberObjects'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Numeric'
!


!IntegerTest class methodsFor:'constants'!

magnitudeObjects

	^Dictionary new
		at: #'small' put: -3000000000;
		at: #'medium' put: 1;
		at: #'large' put: 3000000000;
		yourself
!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<integer>'
! !

!IntegerTest methodsFor:'constants'!

canonicalObject

	^47
!

magnitudeObjects

	^magnitudeObjects
!

numberObjects

	^numberObjects
! !

!IntegerTest methodsFor:'helpers'!

createNumberObjects

	| tmp numbers |
	numberObjects := Dictionary new.
	numberObjects
		at: #'numbers'  put: #(2 -2 -2000000000 2000000000 0);
		at: #'coercing' put: [:number| number asInteger];
		at: #'zero' put: 0;
		at: #'*' put: (OrderedCollection new
			add: (OrderedCollection new
				add: -4000000000; add: 1; add: (4.0d0 asScaledDecimal: 3);
				add: 4; add: 4.0d0; add: 4000000000; yourself);
			add: (OrderedCollection new
				add: 4000000000; add: -1; add: (-4.0d0 asScaledDecimal: 3);
				add: -4; add: -4.0d0; add: -4000000000; yourself);
			add: (OrderedCollection new
				add: 4000000000000000000; add: -1000000000;
				add: (-4000000000.0d0 asScaledDecimal: 3);
				add: -4000000000; add: -4000000000.0d0;
				add: -4000000000000000000; yourself);
			add: (OrderedCollection new
				add: -4000000000000000000; add: 1000000000;
				add: (4000000000.0d0 asScaledDecimal: 3);
				add: 4000000000; add: 4000000000.0d0;
				add: 4000000000000000000; yourself);
			add: (OrderedCollection new
				add: 0; add: 0; add: ScaledDecimal zero;
				add: 0; add: 0.0; add: 0; yourself);
			yourself);
		at: #'+' put: (OrderedCollection new
			add: (OrderedCollection new
				add: -1999999998; add: (5/2);
				add: (4.0d0 asScaledDecimal: 3);
				add: 4; add: 4.0d0; add: 2000000002; yourself);
			add: (OrderedCollection new
				add: -2000000002; add: (-3/2); add: ScaledDecimal zero;
				add: 0; add: 0.0; add: 1999999998; yourself);
			add: (OrderedCollection new
				add: -4000000000; add: (-3999999999/2);
				add: (-1999999998.0d0 asScaledDecimal: 3);
				add: -1999999998; add: -1999999998.0d0; add: 0; yourself);
			add: (OrderedCollection new
				add: 0; add: (4000000001/2);
				add: (2000000002.0d0 asScaledDecimal: 3); add: 2000000002;
				add: 2000000002.0d0; add: 4000000000; yourself);
			add: (OrderedCollection new
				add: -2000000000; add: (1/2);
				add: (2.0d0 asScaledDecimal: 3); add: 2; add: 2.0d0;
				add: 2000000000; yourself);
			yourself);
		at: #'-' put: (OrderedCollection new
			add: (OrderedCollection new
				add: 2000000002; add: (3/2);
				add: ScaledDecimal zero;
				add: 0; add: 0.0; add: -1999999998; yourself);
			add: (OrderedCollection new
				add: 1999999998; add: (-5/2);
				add: (-4.0d0 asScaledDecimal: 3);
				add: -4; add: -4.0d0; add: -2000000002; yourself);
			add: (OrderedCollection new
				add: 0; add: (-4000000001/2);
				add: (-2000000002.0d0 asScaledDecimal: 3);
				add: -2000000002; add: -2000000002.0d0;
				add: -4000000000; yourself);
			add: (OrderedCollection new
				add: 4000000000; add: (3999999999/2);
				add: (1999999998.0d0 asScaledDecimal: 3);
				add: 1999999998; add: 1999999998.0d0;
				add: 0; yourself);
			add: (OrderedCollection new
				add: 2000000000; add: (-1/2);
				add: (-2.0d0 asScaledDecimal: 3); add: -2; add: -2.0d0;
				add: -2000000000; yourself);
			yourself);
		at: #'/' put: (OrderedCollection new
			add: (OrderedCollection new
				add: -1/1000000000; add: 4; add: (1.0d0 asScaledDecimal: 3);
				add: 1; add: 1.0d0; add: (1/1000000000); yourself);
			add: (OrderedCollection new
				add: (1/1000000000); add: -4;
				add: (-1.0d0 asScaledDecimal: 3); add: -1; add: -1.0d0;
				add: (-1/1000000000); yourself);
			add: (OrderedCollection new
				add: 1; add: -4000000000;
				add: (-1000000000.0d0 asScaledDecimal: 3);
				add: -1000000000; add: -1000000000.0d0; add: -1; yourself);
			add: (OrderedCollection new
				add: -1; add: 4000000000;
				add: (1000000000.0d0 asScaledDecimal: 3); add: 1000000000;
				add: 1000000000.0d0; add: 1; yourself);
			add: (OrderedCollection new
				add: 0; add: 0; add: ScaledDecimal zero; add: 0;
				add: 0.0; add: 0; yourself);
			yourself);
		at: #'//' put: #(
				#(-1 4 1 1 1 0)
				#(0 -4 -1 -1 -1 -1)
				#(1 -4000000000 -1000000000 -1000000000 -1000000000 -1)
				#(-1 4000000000 1000000000 1000000000 1000000000 1)
				#(0 0 0 0 0 0));
		at: #'<' put: #(
				#(false false false false false true)
				#(false true true true true true)
				#(false true true true true true)
				#(false false false false false false)
				#(false true true true true true));
		at: #'=' put: #(
				#(false false true true true false)
				#(false false false false false false)
				#(true false false false false false)
				#(false false false false false true)
				#(false false false false false false));
		at: #'>' put: #(
				#(true true false false false false)
				#(true false false false false false)
				#(false false false false false false)
				#(true true true true true false)
				#(true false false false false false)).

	"\\" tmp := Dictionary new.
	tmp at: #'numbers' put: #(26 -26 26000000001 -26000000001 0);
		at: #'posAnswers' put: (OrderedCollection new
				add: (OrderedCollection new add: -1999999974; add: 0;
					add: ScaledDecimal zero; add: 0; add: 0.0;
					add: 26; yourself);
				add: (OrderedCollection new add: -26; add: 0;
					add: ScaledDecimal zero; add: 0; add: 0.0;
					add: 1999999974; yourself);
				add: (OrderedCollection new add: -1999999999; add: 0;
					add: (1.0d0 asScaledDecimal: 3); add: 1; add: 1.0d0;
					add: 1; yourself);
				add: (OrderedCollection new add: -1; add: 0;
					add: (1.0d0 asScaledDecimal: 3); add: 1; add: 1.0d0;
					add: 1999999999; yourself);
				add: (OrderedCollection new add: 0; add: 0;
					add: ScaledDecimal zero; add: 0; add: 0.0;
					add: 0; yourself);
				yourself);
		at: #'negAnswers' put: (OrderedCollection new
				add: (OrderedCollection new add: 26; add: 0;
					add: ScaledDecimal zero; add: 0; add: 0.0;
					add: -1999999974; yourself);
				add: (OrderedCollection new add: 1999999974; add: 0;
					add: ScaledDecimal zero; add: 0; add: 0.0;
					add: -26; yourself);
				add: (OrderedCollection new add: 1; add: 0;
					add: (-1.0d0 asScaledDecimal: 3); add: -1; add: -1.0d0;
					add: -1999999999; yourself);
				add: (OrderedCollection new add: 1999999999; add: 0;
					add: (-1.0d0 asScaledDecimal: 3); add: -1; add: -1.0d0;
					add: -1; yourself);
				add: (OrderedCollection new add: 0; add: 0;
					add: ScaledDecimal zero; add: 0; add: 0.0;
					add: 0; yourself);
				yourself).
	numberObjects at: #'\\' put: tmp.

	numberObjects
		at: #'abs'              put: #(2 2 2000000000 2000000000 0);
		at: #'asFloat'  put: #(2.0d0 -2.0d0 -2000000000.0d0 2000000000.0d0 0.0);
		at: #'asFloatD' put: (numberObjects at: #'asFloat');
		at: #'asFloatE' put: (numberObjects at: #'asFloat');
		at: #'asFloatQ' put: (numberObjects at: #'asFloat');
		at: #'asFraction'       put: (numberObjects at: #'numbers').
	tmp := Dictionary new.  "asInteger"
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: (numberObjects at: #'numbers').
	numberObjects at: #'asInteger'  put: tmp.

	"ceiling"       tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: (numberObjects at: #'numbers').
	numberObjects at: #'ceiling'    put: tmp.

	"floor" tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: (numberObjects at: #'numbers').
	numberObjects at: #'floor'      put: tmp.

	"fractionPart"  tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: #(0 0 0 0 0).
	numberObjects at: #'fractionPart'       put: tmp.

	"integerPart"   tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: (numberObjects at: #'numbers').
	numberObjects at: #'integerPart'        put: tmp.

	numberObjects
		at: #'negated'  put: #(-2 2 2000000000 -2000000000 0);
		at: #'negative' put: #(false true true false false);
		at: #'positive' put: #(true false false true true);
		at: #'quo:' put: #(
				#(0 4 1 1 1 0)
				#(0 -4 -1 -1 -1 0)
				#(1 -4000000000 -1000000000 -1000000000 -1000000000 -1)
				#(-1 4000000000 1000000000 1000000000 1000000000 1)
				#(0 0 0 0 0 0)).

	"printString"   tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: #('2' '-2' '-2000000000' '2000000000' '0').
	numberObjects at: #'printString' put: tmp.

	numberObjects at: #'raisedToInteger:' put: #(
		"number integer value"
		#(2 0 1) #(2 1 2) #(2 2 4) #(-2 2 4) #(2 -2 0)).
	((numberObjects at: #'raisedToInteger:') at: 5) at: 3 put: (1/4).

	numberObjects
		at: #'reciprocal' put: #(2 -2 -2000000000 2000000000).

	"rem:"  tmp := Dictionary new.
	tmp at: #'numbers' put: #(2 -2 -2000000000 2000000000 0);
		at: #'answers' put: (OrderedCollection new
				add: (OrderedCollection new add: 2; add: 2; add: 2;
					add: 2.0d0; add: 2; add: (2.0d0 asScaledDecimal: 3);
					yourself);
				add: (OrderedCollection new add: -2; add: -2; add: -2;
					add: -2.0d0; add: -2; add: (-2.0d0 asScaledDecimal: 3);
					yourself);
				add: (OrderedCollection new add: 0; add: 0; add: 0;
					add: 0.0; add: 0; add: ScaledDecimal zero;
					yourself);
				add: (OrderedCollection new add: 0; add: 0; add: 0;
					add: 0.0; add: 0; add: ScaledDecimal zero;
					yourself);
				add: (OrderedCollection new add: 0; add: 0; add: 0;
					add: 0.0; add: 0; add: ScaledDecimal zero;
					yourself);
				yourself).
	numberObjects at: #'rem:' put: tmp.

	"rounded"       tmp := Dictionary new.
	tmp at: #'numbers'      put: #(2 -2 -2000000000 2000000000 0);
		at: #'answers'  put: #(2 -2 -2000000000 2000000000 0).
	numberObjects at: #'rounded' put: tmp.

	numberObjects
		at: #'roundTo:' put: (OrderedCollection new
			add: 0; add: 47; add: (48.0d0 asScaledDecimal: 3);
			add: 48; add: 48.0d0; add: 0; yourself);
		at: #'sign'     put: #(1 -1 -1 1 0).

	"sqrt"  tmp := Dictionary new.
	tmp at: #'numbers'      put: #(4 4000000000000000000 10 0);
		at: #'answers'  put: #(2.0d0 2000000000.0d0 3.16227766016838d0 0).
	numberObjects at: #'sqrt' put: tmp.

	"squared"       tmp := Dictionary new.
	tmp at: #'numbers' put: #(2 -2 -2000000000 2000000000 0);
		at: #'answers' put: #(4 4 4000000000000000000 4000000000000000000 0).
	numberObjects at: #'squared' put: tmp.

	numberObjects
		at: #'strictlyPositive' put: #(true false false true false).

	"truncated"     tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: (numberObjects at: #'numbers').
	numberObjects at: #'truncated'  put: tmp.

	numberObjects
		at: #'truncateTo:' put: (OrderedCollection new
			add: 0; add: 47; add: (46.0d0 asScaledDecimal: 3);
			add: 46; add: 46.0d0; add: 0; yourself).
!

setUp

	super setUp.
	magnitudeObjects := self class magnitudeObjects.
	self createNumberObjects.
! !

!IntegerTest methodsFor:'testing'!

testXallMaskX
	" ANSI-Numeric <integer> "
	self messageSelector: #'allMask:'.

	"Result is undefined if either the receiver
		or the operand is a negative integer."
	self conformingValue: [2r11111111 allMask: 2r11111111]
		should: [:r| r].
	self conformingValue: [2r11111101 allMask: 2r01]
		should: [:r| r].

	self conformingValue: [2r11111101 allMask: 2r11111111]
		shouldnt: [:r| r].

	self conformingValue: [
			2r1000001100100001010101100000000
				allMask: 2r1000001100100001010101100000000]
		should: [:r| r].
	self conformingValue: [
			2r1000001100100001010101100000010
				allMask: 2r010]
		should: [:r| r].

	self conformingValue: [
			2r1000001100100001010101100000000
				allMask: 2r1000001100100001010101100000010]
		shouldnt: [:r| r].
!

testXanyMaskX
	" ANSI-Numeric <integer> "
	self messageSelector: #'anyMask:'.

	"Result is undefined if either the receiver
		or the operand is a negative integer."
	self conformingValue: [2r11111111 anyMask: 2r10000001]
		should: [:r| r].
	self conformingValue: [2r11111101 anyMask: 2r01]
		should: [:r| r].

	self conformingValue: [2r11111101 anyMask: 2r00000010]
		shouldnt: [:r| r].

	self conformingValue: [
			2r1000001100100001010101100000000
				anyMask: 2r1000001100100001010101100000000]
		should: [:r| r].
	self conformingValue: [
			2r1000001100100001010101100000010 anyMask: 2r010]
		should: [:r| r].

	self conformingValue: [
			2r1000001100100001010101100000000 anyMask: 2r01]
		shouldnt: [:r| r].
!

testXasScaledDecimalX
	" ANSI-Numeric <integer> "
	self messageSelector: #'asScaledDecimal:'.

	"The number of significant digits of the answer is the same as the 
	number of decimal digits in the receiver. The scale of the answer is 0."

	self conformingValue: [2 asScaledDecimal: 2]
		should: [:r| r = (2.0d0 asScaledDecimal: 0) & (r scale = 0)].
	self conformingValue: [-2 asScaledDecimal: 2]
		should: [:r| r = (-2.0d0 asScaledDecimal: 0) & (r scale = 0)].
	self conformingValue: [-2000000000 asScaledDecimal: 2]
		should: [:r| r = (-2.0d9 asScaledDecimal: 0) & (r scale = 0)].
	self conformingValue: [2000000000 asScaledDecimal: 2]
		should: [:r| r = (2.0d9 asScaledDecimal: 0) & (r scale = 0)].
	self conformingValue: [0 asScaledDecimal: 2]
		should: [:r| r = (0.0 asScaledDecimal: 0) & (r scale = 0)].
!

testXbitAndX
	" ANSI-Numeric <integer> "
	self messageSelector: #'bitAnd:'.

	"The result is undefined if either the receiver
		or the operand is a negative integer."
	self conformingValue: [2r11111111 bitAnd: 2r11111111]
		should: [:r| r = 2r11111111].
	self conformingValue: [2r11111111 bitAnd: 2r01111111]
		should: [:r| r = 2r01111111].

	self conformingValue: [1100000001 bitAnd: 1]
		should: [:r| r = 1].
	self conformingValue: [1100000001 bitAnd: 1100000000]
		should: [:r| r = 1100000000].
!

testXbitAtX
	" ANSI-Numeric <integer> "
	self messageSelector: #'bitAt:'.

	"The result is undefined if either the receiver is negative."
	self conformingValue: [2r100 bitAt: 3]
		should: [:r| r = 1].
	self conformingValue: [2r100 bitAt: 2]
		should: [:r| r = 0].
	self conformingValue: [2r1000000000000000000000000000000 bitAt: 31]
		should: [:r| r = 1].
	self conformingValue: [2r1000000000000000000000000000000 bitAt: 30]
		should: [:r| r = 0].

	self notDone. "2001/02/20 Harmon, R. A. What should this do?
	self conformingValue: [1 bitAt: 99]
		should: [:r| r = 0]."

	"It is erroneous if index is less that or equal to zero."
self anomaly: [
	self should: [2r100 bitAt: 0]
		raise: Error.
] for: #(#'DO30' "2001/02/20 Harmon, R. Doesn't signal error.").
!

testXbitAtXputX
	" ANSI-Numeric <integer> "
	self messageSelector: #'bitAt:put:'.

	"The result is undefined if either the receiver is negative."
	self conformingValue: [2r100 bitAt: 3 put: 0]
		should: [:r| r = 2r0].
	self conformingValue: [2r100 bitAt: 2 put: 1]
		should: [:r| r = 2r110].

	"Test putting a value not 0 or 1 (will use the low order bit of value:"
	self conformingValue: [2r100 bitAt: 2 put: 5 "2r101"]
		should: [:r| r = 2r110].
	self conformingValue: [2r100 bitAt: 3 put: 4 "2r100"]
		should: [:r| r = 2r0].
	self conformingValue: [2r100 bitAt: 2 put: 4 "2r100"]
		should: [:r| r = 2r100].

	self conformingValue: [
			2r1000000000000000000000000000000 bitAt: 31 put: 0]
		should: [:r| r = 0].
	self conformingValue: [
			2r1000000000000000000000000000000 bitAt: 30 put: 1]
		should: [:r| r = 2r1100000000000000000000000000000].

	"It is erroneous if index is less that or equal to zero."
self anomaly: [
	self should: [2r100 bitAt: 0 put: 1]
		raise: Error.
] for: #(#'DO30' "2001/02/20 Harmon, R. Doesn't signal error.").
!

testXbitOrX
	" ANSI-Numeric <integer> "
	self messageSelector: #'bitOr:'.

	"The result is undefined if either the receiver
		or the operand is a negative integer."
	self conformingValue: [2r1010 bitOr: 2r1000]
		should: [:r| r = 2r1010].
	self conformingValue: [255 bitOr: 0]
		should: [:r| r = 255].
	self conformingValue: [0 bitOr: 1100000000]
		should: [:r| r = 1100000000].
	self conformingValue: [1100000000 bitOr: 1100000001]
		should: [:r| r = 1100000001].
!

testXbitShiftX
	" ANSI-Numeric <integer> "
	self messageSelector: #'bitShift:'.
	"The result is undefined if the receiver is negative"

	"If shift is positive, the receiver is shifted left
		and zeros (0) are shifted in on the right."
	self conformingValue: [2r100 bitShift: 2]
		should: [:r| r = 2r10000].
	"If shift is negative, the receiver is shifted right
		and low order bits are discarded."
	self conformingValue: [2r1010 bitShift: -2]
		should: [:r| r = 2r10].
	self conformingValue: [
			2r1000000000000000000000000000000 bitShift: -30]
		should: [:r| r = 1].
!

testXbitXorX
	" ANSI-Numeric <integer> "
	self messageSelector: #'bitXor:'.
	"The result is undefined if either the receiver
		or the operand is a negative integer."

	self conformingValue: [2r11111111 bitXor: 2r01111111]
		should: [:r| r = 2r10000000].
	self conformingValue: [2r10 bitXor: 2r01]
		should: [:r| r = 2r11].
	self conformingValue: [0 bitXor: 1100000000]
		should: [:r| r = 1100000000].
	self conformingValue: [0 bitXor: 0]
		should: [:r| r = 0].
!

testXeven
	" ANSI-Numeric <integer> "
	self messageSelector: #'even'.

	self conformingValue: [2 even] should: [:r| r].
	self conformingValue: [-2000000000 even] should: [:r| r].
	self conformingValue: [2000000000 even] should: [:r| r].
	self conformingValue: [0 even] should: [:r| r].

	self conformingValue: [1 even] shouldnt: [:r| r].
!

testXfactorial
	" ANSI-Numeric <integer> "
	self messageSelector: #'factorial'.
	"The result is undefined if the receiver is negative."

	self conformingValue: [0 factorial] should: [:r| r = 1].
	self conformingValue: [1 factorial] should: [:r| r = 1].
	self conformingValue: [2 factorial] should: [:r| r = 2].
	self conformingValue: [5 factorial] should: [:r| r = 120].
!

testXgcdX
	" ANSI-Numeric <integer> "
	self messageSelector: #'gcd:'.

	"Answer the largest non-negative integer that divides
	both the receiver and operand with no remainder."
	self conformingValue: [5 gcd: 15]
		should: [:r| r = 5].
	self conformingValue: [2 gcd: -4]
		should: [:r| r = 2].
	self conformingValue: [2 gcd: 3]
		should: [:r| r = 1].
	self conformingValue: [-2000000000 gcd: 15]
		should: [:r| r = 5].
	self conformingValue: [2000000000 gcd: 15]
		should: [:r| r = 5].
	self conformingValue: [3300000000 gcd: -66]
		should: [:r| r = 66].
	"Answer 0 if the receiver and operand are zero."
	self conformingValue: [0 gcd: 0]
		should: [:r| r = 0].

	self notDone. "2001/02/20 Harmon, R. A. What should this do?"
	self conformingValue: [0 gcd: 4]
		should: [:r| r = 4].
!

testXhighBit
	" ANSI-Numeric <integer> "
	self messageSelector: #'highBit'.

	"Answer the index of the most significant non-zero bit
		in the binary representation of the receiver."
	self conformingValue: [2r00001010 highBit]
		should: [:r| r = 4].
	self conformingValue: [2r11111111 highBit]
		should: [:r| r = 8].
	self conformingValue: [2r1000000000000000000000000000000 highBit]
		should: [:r| r = 31].

	"Answer 0 if the receiver is 0."
	self conformingValue: [0 highBit]
		should: [:r| r = 0].

	"The result is undefined if the receiver is negative."
!

testXlcmX
	" ANSI-Numeric <integer> "
	self messageSelector: #'lcm:'.

	"Answer the smallest non-negative integer which is evenly divided
		by both the receiver and operand."
	self conformingValue: [-5 lcm: 15]
		should: [:r| r = 15].
	self conformingValue: [2 lcm: 4]
		should: [:r| r = 4].
	self conformingValue: [-2000000000 lcm: -50]
		should: [:r| r = 2000000000].
	self conformingValue: [2000000000 lcm: 15]
		should: [:r| r = 6000000000].

	"Answer 0 if the receiver and operand are zero."
self anomaly: [
	self conformingValue: [0 lcm: 0]
		should: [:r| r = 0].
] for: #(#'DO30' "2001/02/20 Harmon, R. Answers 1.").

	self notDone. "2001/02/20 Harmon, R. A. What should this do?"
	self conformingValue: [0 lcm: 4]
		should: [:r| r = 0].
!

testXnoMaskX
	" ANSI-Numeric <integer> "
	self messageSelector: #'noMask:'.

	"Answer true if none of the bits that are 1 in the binary
	representation of mask are 1 in the binary representation of the
	receiver.  Answer false otherwise. If the receiver has fewer bits
	than the operand, the receiver is treated as if it were extended
	on the left with zeros to the length of the operand."
	self conformingValue: [255 noMask:  0]
		should: [:r| r].
	self conformingValue: [255 noMask:  1]
		shouldnt: [:r| r].
	self conformingValue: [
			2r1000000000000000000000000000000
				noMask: 2r1000000000000000000000000000001]
		shouldnt: [:r| r].

	"The result is undefined if either the receiver
		or the operand is a negative integer."
!

testXodd
	" ANSI-Numeric <integer> "
	self messageSelector: #'odd'.

	self conformingValue: [1 odd]
		should: [:r| r].
	self conformingValue: [2000000001 odd]
		should: [:r| r].
	self conformingValue: [-2000000001 odd]
		should: [:r| r].

	self conformingValue: [2 odd]
		shouldnt: [:r| r].
	self conformingValue: [-2000000000 odd]
		shouldnt: [:r| r].
	self conformingValue: [2000000000 odd]
		shouldnt: [:r| r].
	self conformingValue: [0 odd]
		shouldnt: [:r| r].
!

testXprintOnXbaseXshowRadixX
	" ANSI-Numeric <integer> "
	| aStream |
	self messageSelector: #'printOn:base:showRadix:'.

	aStream := WriteStream on: String new.

	self conformingValue: [
			2       printOn: aStream
				base: 2
				showRadix: true]
		should: [:r| aStream contents = '2r10'].

	aStream reset.
	self conformingValue: [
			2       printOn: aStream
				base: 2
				showRadix: false]
		should: [:r| aStream contents = '10'].

	aStream reset.
	self conformingValue: [
			-2000000000
				printOn: aStream
				base: 10
				showRadix: true]
		should: [:r| aStream contents = '-10r2000000000'].

	aStream reset.
	self conformingValue: [
			2000000000
				printOn: aStream
				base: 36
				showRadix: false]
		should: [:r| aStream contents = 'X2QXVK'].

	"The result is undefined if base is less than two or greater than 36."
!

testXprintStringRadixX
	" ANSI-Numeric <integer> "
	self messageSelector: #'printStringRadix:'.

	self conformingValue: [2 printStringRadix: 2]
		should: [:r| r = '2r10'].

	self conformingValue: [2 printStringRadix: 16]
		should: [:r| r = '16r2'].

	self conformingValue: [-2000000000 printStringRadix: 36]
		should: [:r| r = '-36rX2QXVK'].

	self conformingValue: [-2000000000 printStringRadix: 2]
		should: [:r| r = '-2r1110111001101011001010000000000'].

	self conformingValue: [2000000000 printStringRadix: 2]
		should: [:r| r = '2r1110111001101011001010000000000'].

	self conformingValue: [-10 printStringRadix: 16]
		should: [:r| r = '-16rA'].

	"The result is undefined if base is less than two or greater than 36."
! !

!IntegerTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/IntegerTest.st,v 1.1 2002/06/21 10:32:53 penk Exp $'
! !
