"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#MainUsingProtocolsTest
	instanceVariableNames:'canonicalObject numberObjects'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-SUnitProtocolFramework'
!

MainUsingProtocolsTest class instanceVariableNames:'protocolIdHold forDialectList arrayOfTriplets canonicalObject shouldValue
	targetSelector'

"
 No other class instance variables are inherited by this class.
"
!


!MainUsingProtocolsTest class methodsFor:'instance creation'!

runSel: targetTestSelector
	"Answer the result of running TestCase testSelector, targetTestSelector."
	| test |
	test := self suite tests detect: [:aTestCase|
		aTestCase testSelector = targetTestSelector].
	^test run
! !

!MainUsingProtocolsTest class methodsFor:'accessing'!

arrayOfTriplets
	"Answer the test arrayOfTriplets."

	^arrayOfTriplets
!

arrayOfTriplets: arrayOfTripletsIn
	"Set the test arrayOfTriplets."

	arrayOfTriplets := arrayOfTripletsIn
!

canonicalObject
	"Answer the test canonicalObject."

	^canonicalObject
!

canonicalObject: canonicalObjectIn
	"Set the test canonicalObject."

	canonicalObject := canonicalObjectIn
!

forDialectList
	"Answer the list of dialects for this anomaly."

	^forDialectList
!

forDialectList: forDialectListIn
	"Set the list of dialects for this anomaly."

	forDialectList := forDialectListIn
!

protocolId
	"Answer the current protocol identifier to use in testing to protocolIdIn."

	protocolIdHold isNil ifTrue: [
		^super protocolId].
	^protocolIdHold
!

protocolId: protocolIdIn
	"Set the current protocol identifier to use in testing to protocolIdIn."

	protocolIdHold := protocolIdIn
!

shouldValue
	"Answer the boolean for the shouldBlock."

	^shouldValue
!

shouldValue: shouldValueIn
	"Set the boolean for the shouldBlock."

	shouldValue := shouldValueIn
!

targetSelector
	"Answer the test target messageSelector."

	^targetSelector
!

targetSelector: targetSelectorIn
	"Set the test target messageSelector."

	targetSelector := targetSelectorIn
! !

!MainUsingProtocolsTest class methodsFor:'initializing'!

initializeClassInstVars

	protocolIdHold := forDialectList := arrayOfTriplets := canonicalObject
		:= shouldValue := targetSelector := nil.
! !

!MainUsingProtocolsTest methodsFor:'helpers'!

canonicalObject

	^canonicalObject
!

createNumberObjects

	numberObjects := Dictionary new.
	numberObjects
		at: #'numbers' put: #(0 2 0.0d0 2.0d0 -2.0d0);
		at: #'zero' put: 0.
!

setUp

	super setUp.
	canonicalObject := self class canonicalObject.
	self createNumberObjects.
!

tearDown

	super tearDown.
!

threeLines
	"Private - test text."

	^'Line 1
Line 2
Line 3
'

	
!

threeLinesDif
	"Private - test text."

	^'Line 1
Line two
Line 3
'

	
! !

!MainUsingProtocolsTest methodsFor:'others'!

numberObjects

	^numberObjects
! !

!MainUsingProtocolsTest methodsFor:'testing'!

testClsXprotoMgr

	self should: [
			self class protoMgr
				respondsToProtocolId: #'<SysProProtocolsManager>'].
	self should: [ProtoMgr == self class protoMgr].
!

testClsXselectorXprotocolIdX

	self messageSelector: #'dummySelector'.
	self should: [
			testSelector = #'testClsXselectorXprotocolIdX'
			& protocolId = #'<aProto>'
			& messageSelector = #'dummySelector'].
!

testClsXsignalAnomalies

	self should: [
			TestCaseUsingProtocols signalAnomalies = self class shouldValue].
!

testClsXsignalAnomaliesX

	self should: [
			TestCaseUsingProtocols signalAnomalies = self class shouldValue].
	self should: [SignalAnomalies == self class shouldValue].
!

testClsXsignalNotDone

	self should: [
			TestCaseUsingProtocols signalNotDone = self class shouldValue].
!

testClsXsignalNotDoneX

	self should: [
			TestCaseUsingProtocols signalNotDone = self class shouldValue].
	self should: [SignalNotDone == self class shouldValue].
!

testXanomalyXforX

self anomaly: [
	1 foobar.
] for: (self class forDialectList).
!

testXcompareStreamIgnoringLineTermTargetXresultX
	| targetStream resultStream |

	"Test Stream:"
	resultStream := ReadWriteStream with: (String new).
	self threeLines do: [:chr| resultStream nextPut: chr].
	resultStream reset.

	targetStream := ReadStream on: self threeLines.
	self should: [
			self compareStreamIgnoringLineTermTarget: targetStream
				result: resultStream].

	targetStream := ReadStream on: self threeLinesDif.
	self shouldnt: [
			self compareStreamIgnoringLineTermTarget: targetStream
				result: resultStream].

	"Test File:"
	resultStream := FileStream write: 'TestFile.jnk'.
	self threeLines do: [:chr| resultStream nextPut: chr].
	resultStream flush.
	resultStream reset.

	targetStream := ReadStream on: self threeLines.
	self should: [
			self compareStreamIgnoringLineTermTarget: targetStream
				result: resultStream].

	targetStream := ReadStream on: self threeLinesDif.
	self shouldnt: [
			self compareStreamIgnoringLineTermTarget: targetStream
				result: resultStream].
!

testXcompareTextIgnoringLineTermTargetXresultX

	"Test Equal:"
	self should: [
			self compareTextIgnoringLineTermTarget: self threeLines
				result: self threeLines copy].

	"Test Different:"
	self shouldnt: [
			self compareTextIgnoringLineTermTarget: self threeLines
				result: self threeLinesDif].
!

testXconformingAssertMessageSelector
        " Tests-SUnit-Protocol-Framework <usingProtocolsTest> "

        self messageSelector: self class targetSelector.

        self conformingAssertMessageSelector.
!

testXconformingMessageSelectorBehavesLikeX
	" Tests-SUnit-Protocol-Framework <usingProtocolsTest> "
	self messageSelector: self class targetSelector.

	self conformingMessageSelectorBehavesLike: self class arrayOfTriplets.
!

testXconformingValueXshouldX
	" Tests-SUnit-Protocol-Framework <usingProtocolsTest> "
	self messageSelector: #'valueTrue'.

	"If there were such a message:"
	self conformingValue: ["self canonicalObject valueTrue" true]
		should: [:r| r].
!

testXconformingValueXshouldXruleReceiverX
	" Tests-SUnit-Protocol-Framework <usingProtocolsTest> "
	| number |
	self messageSelector: self class targetSelector.

	number := self class canonicalObject. 
	self conformingValue: ["Should be dummyPart, but we cheat here:"
			number integerPart ]
		should: [:result | self class shouldValue] 
		ruleReceiver: number.
!

testXconformingValueXshouldXruleReceiverXoperandX
	" Tests-SUnit-Protocol-Framework <usingProtocolsTest> "
	| number posInt2|
	self messageSelector: self class targetSelector.

	number := self class canonicalObject. 
	posInt2 := 2. 
	self conformingValue: [number * posInt2 ]
		should: [:result| self class shouldValue] 
		ruleReceiver: number
		operand: posInt2.
!

testXconformingValueXshouldntX
	" Tests-SUnit-Protocol-Framework <usingProtocolsTest> "
	self messageSelector: #'valueTrue'.

	"If there were such a message:"
	self conformingValue: ["self canonicalObject valueTrue" false]
		shouldnt: [:r| r].
!

testXdebug

	3 zork.
!

testXdebugAsFailure

	self assert: false.
!

testXfileNameXTestFileXjnk

	self should: [
			self fileNameXTestFileXjnk respondsToProtocolId: #'<String>'].
!

testXlineDelimiter

	self should: [self lineDelimiter respondsToProtocolId: #'<String>'].
!

testXmessageSelectorX

	self should: [messageSelector isNil].
	self messageSelector: #'asSymbol'.
	self should: [messageSelector = #'asSymbol'].
!

testXnumbersXbyNumbersXanswersXdoX
	" Tests-SUnit-Protocol-Framework <usingProtocolsTest> "
	| canonicalNumbers mixedNums answers |
	self messageSelector: #'+'.

	"Limited numeric types, and block assert, to simplify test:"
	canonicalNumbers := #(2 0).
	mixedNums := #(0 2 2.0d0).
	answers := #( #(2 4 4.0d0) #(0 2 2.0d0) ).
	self numbers: canonicalNumbers
		byNumbers: mixedNums
		answers: answers
		do: [ :canonicalNumber :mixedNumber :answer|
			self conformingValue: [canonicalNumber + mixedNumber]
				should: [:r| r closeTo: answer]
				ruleReceiver: canonicalNumber
				operand: mixedNumber].
!

testXobjectsXanswersXdoX
	" Tests-SUnit-Protocol-Framework <usingProtocolsTest> "
	| numbers answers |
	self messageSelector: #'abs'.

	"Limited numeric types to simplify test:"
	numbers := numberObjects at: #'numbers'.
	answers := #(0 2 0.0d0 2.0d0  2.0d0).
	self objects: numbers answers: answers do: [:number :answer|
		self conformingValue: [number abs]
			should: [:r| r = answer]].
!

testXobjectsXobjectsXanswersXdoX
	" Tests-SUnit-Protocol-Framework <usingProtocolsTest> "
	| numbers scales answers |
	self messageSelector: #'asScaledDecimal:'.

	"Limited numeric types, and block assert, to simplify test:"
	numbers := numberObjects at: #'numbers'.
	scales := #(0 1 2 3 4 5).
	answers := OrderedCollection new.
	answers
		add: ScaledDecimal zero; add: (2 asScaledDecimal: 1);
		add: ScaledDecimal zero; add: (2.000d0 asScaledDecimal: 3);
		add: (-2.0000d0 asScaledDecimal: 4).

	self objects: numbers objects: scales answers: answers do: [
			:number :numberScale :answer|
		self conformingValue: [number asScaledDecimal: numberScale]
			should: [:r| r = answer]].
!

testXtestSelector

	self should: [self testSelector = #'testXtestSelector'].
! !

!MainUsingProtocolsTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/MainUsingProtocolsTest.st,v 1.1 2002/06/21 10:22:30 penk Exp $'
! !
