"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#MessageNotUnderstoodTest
	instanceVariableNames:'dnu'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!MessageNotUnderstoodTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<MessageNotUnderstood>'
! !

!MessageNotUnderstoodTest methodsFor:'constants'!

canonicalObject

	^dnu
! !

!MessageNotUnderstoodTest methodsFor:'helpers'!

setUp

	super setUp.
	DialectAndVersion = #'SQ27' ifFalse: [
		"This doesn't work in Squeak 2,7 - bypass it for now."
		[nil bogus]
			on: MessageNotUnderstood
			do: [:ex| dnu := ex]].
! !

!MessageNotUnderstoodTest methodsFor:'testing'!

testXisResumable
	" ANSI-Exception <MessageNotUnderstood> "
	self messageSelector: #'isResumable'.

	self conformingValue: [
			[MessageNotUnderstood signal]
				on: MessageNotUnderstood
				do: [:mnu| mnu return: mnu isResumable]]
		should: [:r| r].
!

testXmessage
	" ANSI-Exception <MessageNotUnderstood> "
	self messageSelector: #'message'.

	self conformingValue: [
			[1 bob]
				on: MessageNotUnderstood
				do: [:mnu| mnu return: mnu message]]
		should: [:r| (r selector = #'bob') & (r arguments = Array new)].

	self conformingValue: [
			[1 bob: 2]
				on: MessageNotUnderstood
				do: [:mnu| mnu return: mnu message]]
		should: [:r| (r selector = #'bob:') & (r arguments = #( 2 ))].
!

testXreceiver
	" ANSI-Exception <MessageNotUnderstood> "
	self messageSelector: #'receiver'.

	self conformingValue: [
			[1 bob]
				on: MessageNotUnderstood
				do: [:mnu| mnu return: mnu receiver]]
		should: [:r| r = 1].
! !

!MessageNotUnderstoodTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/MessageNotUnderstoodTest.st,v 1.1 2002/06/21 10:22:38 penk Exp $'
! !
