"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#NiladicBlockTest
	instanceVariableNames:'blk0args canonicalObject'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Valuable'
!


!NiladicBlockTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<niladicBlock>'
! !

!NiladicBlockTest methodsFor:'constants'!

canonicalObject

	^blk0args
!

canonicalValuable

	^Dictionary new
		at: #'block'            put: blk0args;
		at: #'arguments'        put: #();
		yourself
! !

!NiladicBlockTest methodsFor:'helpers'!

setUp
	super setUp.
	blk0args := [Array new].
"
	canonicalObject := [3+4]
"
! !

!NiladicBlockTest methodsFor:'testing'!

testXensureX
	" ANSI-Valuable <niladicBlock> "
	| flag tmp |
	self messageSelector: #'ensure:'.

	flag := 0.
	self conformingValue: [[flag = 0] ensure: [flag := 2]]
		should: [:r| r = true & flag = 2].

	flag := 0.
	self conformingValue: [
		[       [       [flag = 1
				] ensure: [flag := flag + 2]
			] ensure: [flag := flag + 2]
		] ensure: [flag := flag + 2]]
		should: [:r| r = false & flag = 6].

	"Activation of an exception handler from within the receiver is not in and of itself an abnormal termination.  However, if the exception handler for an exception that is not resumable results in termination of the receiver or if its handler block contains a return statement that results in abnormal termination of the receiver, then terminationBlock will be evaluated after evaluation of the exception handler."
 
	flag := 0.
	[tmp := [Notification signal] ensure: [flag := 1]]
		on: Notification
		do: [:notification| notification resume].
	self conformingValue: [tmp]
		should: [:r| flag = 1]. "Chged from = 0 from2000/12/06 Harmon, R."

	self should: [[#(1 2) siz] ensure: [flag := 1]]
		raise: MessageNotUnderstood.

	self should: [[Notification signal] ensure: []]
		raise: Notification.
!

testXifCurtailedX
	" ANSI-Valuable <niladicBlock> "
	| flag tmp |
	self messageSelector: #'ifCurtailed:'.

	self conformingValue: [[flag := 0] ifCurtailed: [flag := 1]]
		should: [:r| r = 0 & flag = 0].

self anomaly: [
	[tmp := [Error signal. 0] ifCurtailed: [flag := 1].
	] on: Error do: [:error| error return: -1].
	self conformingValue: [tmp] should: [:r| r = -1 & flag = 1].
] for: #(#'DO30' "2000/12/06 Harmon, R. r = nil").

	[tmp := [Notification signal. 0] ifCurtailed: [flag := 1]]
		on: Notification
		do: [:notification| notification resume].
	self conformingValue: [ tmp ] should: [:r| r = 0 & flag = 0].
!

testXonXdoX
	" ANSI-Valuable <niladicBlock> "
	self messageSelector: #'on:do:'.

	self conformingValue: [
			[#(1 2) size]
				on: Error
				do: [:error| error return: -1]]
		should: [:r| r = 2].

	self conformingValue: [
			[Error signal. 0]
				on: Error
				do: [:error| error return: -1]]
		should: [:r| r = -1].
! !

!NiladicBlockTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/NiladicBlockTest.st,v 1.1 2002/06/21 10:38:44 penk Exp $'
! !
