"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#NiladicValuableHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Valuable'
!


!NiladicValuableHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<niladicValuable>'
! !

!NiladicValuableHelper methodsFor:'testing'!

testXargumentCount
	" ANSI-Valuable <niladicValuable> "
	| blk0args |
	self messageSelector: #'argumentCount'.

	blk0args := testCase canonicalObject.
	self conformingValue: [blk0args argumentCount]
		should: [:r| r = 0].

!

testXvalue
	" ANSI-Valuable <niladicValuable> "
	| blk0args |
	self messageSelector: #'value'.

	blk0args := testCase canonicalObject.
	self conformingValue: [blk0args value]
		should: [:r| r = #()].
!

testXwhileFalse
	" ANSI-Valuable <niladicValuable> "
	| sum |
	self messageSelector: #'whileFalse'.

	sum := 0.
	self conformingValue: [[(sum := sum + 1) >= 3] whileFalse]
		should: [:r| sum = 3].
!

testXwhileFalseX
	" ANSI-Valuable <niladicValuable> "
	| element aReadStream |
	self messageSelector: #'whileFalse:'.

	aReadStream := ReadStream on: (Array with: 1 with: 2 with: 3).
	self conformingValue: [
			[aReadStream atEnd] whileFalse: [element := aReadStream next]]
		should: [:r| element = 3].

	element := 0.
	self conformingValue: [[element = 0] whileFalse: [element := 1]]
		should: [:r| element = 0].
!

testXwhileTrue
	" ANSI-Valuable <niladicValuable> "
	| sum |
	self messageSelector: #'whileTrue'.

	sum := 0.
	self conformingValue: [[(sum := sum + 1) < 4] whileTrue]
		should: [:r| sum = 4].
!

testXwhileTrueX
	" ANSI-Valuable <niladicValuable> "
	| sum |
	self messageSelector: #'whileTrue:'.

	sum := 0.
	self conformingValue: [[sum < 4] whileTrue: [sum := sum + 1]]
		should: [:r| sum = 4].

	sum := 0.
	self conformingValue: [[sum < 0] whileTrue: [sum := sum + 1]]
		should: [:r| sum = 0].
! !

!NiladicValuableHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/NiladicValuableHelper.st,v 1.1 2002/06/21 10:23:50 penk Exp $'
! !
