"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#NotificationHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!NotificationHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Notification>'
! !

!NotificationHelper methodsFor:'testing'!

testXdefaultAction
	" ANSI-Exception <Notification> "
	| notificationCls |
	self messageSelector: #'defaultAction'.
	notificationCls := testCase canonicalObject class.

	"Refinement: <Notification>
		No action is taken. The value nil is returned as the value
		of the message that signaled the exception."
	self conformingValue: [
			[notificationCls signal]
				on: notificationCls
				do: [:ex| ex defaultAction]]
		should: [:r| r = nil].
!

testXisResumable
	" ANSI-Exception <Notification> "
	| notificationCls |
	self messageSelector: #'isResumable'.

	notificationCls := testCase canonicalObject class.

	"Refinement: <Notification>
		Answer true. Notification exceptions by default
		are specified to be resumable."
	self conformingValue: [
			[notificationCls signal]
				on: notificationCls
				do: [:ex| ex return: ex isResumable]]
		should: [:r| r].

! !

!NotificationHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/NotificationHelper.st,v 1.1 2002/06/21 10:29:12 penk Exp $'
! !
