"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#ObjectHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Fundamental'
!


!ObjectHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Object>'
! !

!ObjectHelper class methodsFor:'initializing'!

resetTestSelectors

	super resetTestSelectors
! !

!ObjectHelper methodsFor:'testing'!

testXclass
	" Fundamental <Object> "
	self messageSelector: #'class'.

	self conformingValue: [testCase canonicalObject class]
		should: [:r | true].

	self conformingValue: [testCase canonicalObject class class]
		should: [:r | true "unspecified"].
!

testXcopy
        " Fundamental <Object> "
        | canonicalObject |
        self messageSelector: #'copy'.

        canonicalObject := testCase canonicalObject.
        self conformingAssertMessageSelector.

        self notDone.
        "Return a new object that must be as similar as possible to the
        receiver in its initial state and behavior.    
        If the receiver is an identity object, return the receiver."

self anomaly: [
        "I think copy must be = (equivalent - interchangeable)
        and may be an identity object (same object as copy).
        Not sure I'm testing this correctly?"
        self conformingValue: [canonicalObject copy]
                should: [:r|
                        (r = canonicalObject)
                        & (r identityHash = canonicalObject identityHash
                                ifTrue: [r == canonicalObject]
                                ifFalse: [r ~~ canonicalObject])].
] forDialectAndTestCaseName: #(
        #(#'DO30' "2000/12/06 Harmon, R."
                #(#'DyadicValuableTest' "r not = canonicalObject"
                #'MessageNotUnderstoodTest'     "r not = canonicalObject"
                #'ErrorTest'    "r not = canonicalObject"
                #'ExceptionSetTest'     "r not = canonicalObject"
                #'ExceptionTest'                "r not = canonicalObject"
                #'MonadicBlockTest'     "r not = canonicalObject"
                #'NiladicBlockTest'     "r not = canonicalObject"
                #'NotificationTest'     "r not = canonicalObject"
                #'ReadStreamTest'       "r not = canonicalObject"
                #'ReadWriteStreamTest'  "r not = canonicalObject"
                #'TranscriptTest'       "r not = canonicalObject"
                #'WarningTest'  "r not = canonicalObject"
                #'WriteStreamTest'      "r not = canonicalObject"
                #'ZeroDivideTest'       "r not = canonicalObject"
                #'BagTest'      "r not = canonicalObject"
                #'DictionaryTest'       "r not = canonicalObject"
                #'IdentityDictionaryTest'       "r not = canonicalObject"
                #'SetTest'      "r not = canonicalObject"
                #'ReadFileStreamTest'   "r not = canonicalObject"
                #'WriteFileStreamTest'  "r not = canonicalObject"
                #'SysProMessageByRuleReturnTest'        "r not = canonicalObject"
                #'SysProMessageParameterTest'   "r not = canonicalObject"
                #'SysProMessageReturnTest'      "r not = canonicalObject"
                #'SysProProtocolTest'   "r not = canonicalObject"))
        #(#'SQ27' "2000/12/06 Harmon, R."
                #( #'' #'DyadicValuableTest'    "r not = canonicalObject"))
        #(#'STX36'  "2000/13/06 penk"
                #( #'ArrayFactoryTest'    "r not = canonicalObject"
                   #'IdentityDictionaryFactoryTest'    "r not = canonicalObject"
                   #'IntervalFactoryTest'    "r not = canonicalObject"))
        #(#'STX41' "2000/13/06 penk"
                #( #'ArrayFactoryTest'    "r not = canonicalObject"
                   #'IdentityDictionaryFactoryTest'    "r not = canonicalObject"
                   #'IntervalFactoryTest'    "r not = canonicalObject")))


        "Any operation that changes the state of the new object should not
        as a side-effect change the state or behavior of the receiver.
        Similarly, any change to the receiver should not as a side-effect
        change the new object."
!

testXdoesNotUnderstandX
	" Fundamental <Object> "
	self messageSelector: #'doesNotUnderstand:'.

	self should: [testCase canonicalObject fooXzzYZ]
		raise: MessageNotUnderstood.
!

testXequalityOp
	" Fundamental <Object> "
	| newObject object1 |
	self messageSelector: #'='.

	"The value of receiver = comparand is true if and only if the value
	of comparand = receiver would also be true. If the value of receiver
	= comparand is true then the receiver and comparand must have
	equivalent hash values.  Or more formally:

		receiver = comparand    =>
		receiver hash = comparand hash" 
	object1 := testCase canonicalObject.
	self conformingValue: [object1 = object1]
		should: [:r| r and: [object1 hash = object1 hash]].

	newObject := Object new.
	self should: [(object1 ~= newObject)
			and: [object1 hash ~= newObject hash]].
!

testXerrorX
	" Fundamental <Object> "
	self messageSelector: #'error:'.

	self conformingValue: [[testCase canonicalObject error: 'dummy']
			on: Error do: [:error| error return: true]]
		should: [:r| r].

	self should: [testCase canonicalObject error: 'dummy']
		raise: Error.
!

testXhash
	" Fundamental <Object> "
	self messageSelector: #'hash'.

	"Any two objects that are considered equivalent using the #=
	message must have the same hash value.  More formally:

		receiver = comparand    =>
		receiver hash = comparand hash"

	self conformingAssertMessageSelector.
!

testXidentityHash
	" Fundamental <Object> "
	self messageSelector: #'identityHash'.

	self conformingAssertMessageSelector.
!

testXidentityOp
	" Fundamental <Object> "
	| newObject object1 |
	self messageSelector: #'=='.

	"The value of receiver == comparand is true if and only if the
	value of comparand == receiver would also be true. If the value
	of receiver == comparand is true then the receiver and comparand
	must have equivalent identity hash values.  Or more formally:

		receiver == comparand =>
		receiver identityHash = comparand identityHash"

	object1 := testCase canonicalObject.
	self conformingValue: [object1 == object1]
		should: [:r| r and: [object1 identityHash = object1 identityHash]].

	newObject := Object new.
	self should: [(object1 ~~ newObject)
			and: [object1 identityHash ~~ newObject identityHash]].
!

testXisKindOfX
	" Fundamental <Object> "
	self messageSelector: #'isKindOf:'.

	"The return value is unspecified if the receiver is a class object or 
	candidateClass is not a class object.
	"
	self notDone."Fix find a test for unspecified rule above ???"
	self conformingValue: [testCase canonicalObject isKindOf: Object]
		should: [:r| r].

	"Metaclass tests:"
	self conformingValue: [testCase canonicalObject class
			isKindOf: Object class]
		should: [:r| "unspecified" true].

	self shouldnt: [testCase canonicalObject == nil
			ifTrue: [false]
			ifFalse: [testCase canonicalObject isKindOf: UndefinedObject]]

!

testXisMemberOfX
	" Fundamental <Object> "
	self messageSelector: #'isMemberOf:'.

	"The return value is unspecified if the receiver is a class object
	or candidateClass is not a class object."
	self conformingValue: [testCase canonicalObject
			isMemberOf: testCase canonicalObject class]
		should: [:r| r].

	self shouldnt: [testCase canonicalObject isMemberOf: ObjectHelper].
!

testXisNil
	" Fundamental <Object> "
	self messageSelector: #'isNil'.

	"The messages #isNil and #notNil must be implemented to produce
	consistent results.  For a given receiver if the result of #isNil
	is true then the result of #notNil must be false."

	self conformingValue: [testCase canonicalObject isNil = (testCase canonicalObject == nil)]
		should: [:r | r]
!

testXnotEqualityOp
	" Fundamental <Object> "
	| anObject newObject |
	self messageSelector: #'~='.

	"The value of receiver ~= comparand is true if and only if the
	value of comparand ~= receiver would also be true."
	anObject := testCase canonicalObject.
	newObject := Object new.
	self conformingValue: [anObject ~= newObject]
		should: [:r| r & (newObject ~= anObject)].

	self conformingValue: [anObject ~= anObject]
		shouldnt: [:r| r].
!

testXnotIdentityOp
	" Fundamental <Object> "
	| object1 |
	self messageSelector: #'~~'.

	"The value of receiver == comparand is true if and only if the value
	of comparand == receiver would also be true. If the value of receiver
	== comparand is true then the receiver and comparand must have
	equivalent identity hash values.  Or more formally:

		receiver == comparand =>
		receiver identityHash = comparand identityHash"
	object1 := testCase canonicalObject.
	self conformingValue: [object1 ~~ Object new]
		should: [:r| r].
!

testXnotNil
	" Fundamental <Object> "
	self messageSelector: #'notNil'.

	"The messages #isNil and #notNil must be implemented to produce
	consistent results.  For a given receiver if the result of #isNil
	is true then the result of #notNil must be false."
	self conformingValue: [testCase canonicalObject notNil
			= (testCase canonicalObject ~~ nil)]
		should: [:r| r]
!

testXperformX
	" Fundamental <Object> "
	self messageSelector: #'perform:'.

	"If the receiver does not have a method for selector normal
	message-not-understood processing is performed as if the computed
	message hand been sent using a message send expression.
	The perform messages and #respondsTo: must be implemented to produce
	consistent results.  A message to perform a selector, selector, for
	a given receiver will result in a message-not-understood condition
	if and only if the value of receiver respondsTo: selector is false.
	Behavior is undefined if the number of arguments does not match that
	implicitly required by  the syntactic form of the selector."
	self conformingValue: [testCase canonicalObject perform: #'yourself']
		should: [:r| r == r].

	self should: [testCase canonicalObject perform: #'3+4']
		raise: MessageNotUnderstood.
!

testXperformXwithArgumentsX
        " Fundamental <Object> "
        self messageSelector: #'perform:withArguments:'.

        "If the receiver does not have a method for the selector normal
        message-not-understood processing is performed as if the computed
        message hand been sent using a message send expression.  If this
        occurs, selector and arguments could be captured.
        The perform messages and #respondsTo: must be implemented to produce
        consistent results. A message to perform a selector, selector, for a
        given receiver will result in a message-not-understood condition if
        and only if the value of receiver respondsTo: selector is false.
        Behavior is undefined if the number of elements in arguments does not
        match that implicitly required by  the syntactic form of the selector."

        self conformingValue: [testCase canonicalObject
                        perform: #'yourself'
                        withArguments: #()]
                should: [:r| (testCase canonicalObject respondsTo: #'yourself')].

        self should: [testCase canonicalObject
                        perform: #'3+4'
                        withArguments: #()]
                raise: MessageNotUnderstood.

self anomaly: [
        self should: [testCase canonicalObject
                        perform: #'notNil'
                        withArguments: #( 1 )] 
                raise: TestResult error.
] for: #(#'STX36' #'STX41' "2002/06/13 penk - no error raised for performs").
!

testXperformXwithX
        " Fundamental <Object> "
        self messageSelector: #'perform:with:'.

        "If the receiver does not have a method for selector normal
        message-not-understood processing is performed as if the computed
        message hand been sent using a message send expression.
        The perform messages and #respondsTo: must be implemented to produce
        consistent results.  A message to perform a selector, selector, for
        a given receiver will result in a message-not-understood condition
        if and only if the value of receiver respondsTo: selector is false.
        Behavior is undefined if the number of arguments does not match that
        implicitly required by  the syntactic form of the selector."

        self conformingValue: [testCase canonicalObject
                        perform: #'~~'
                        with: 1]
                should: [:r| r & (testCase canonicalObject respondsTo: #'~~')].

        self should: [testCase canonicalObject
                        perform: #'bogusParm1:'
                        with: #()]
                raise: MessageNotUnderstood.

self anomaly: [
        self should: [testCase canonicalObject
                        perform: #'isNil'
                        with: 1]
                raise: TestResult error.
] for: #(#'STX36' #'STX41' "2002/06/13 penk - no error raised for performs").
!

testXperformXwithXwithX
        " Fundamental <Object> "
        self messageSelector: #'perform:with:with:'.

        "If the receiver does not have a method for selector normal
        message-not-understood processing is performed as if the computed
        message hand been sent using a message send expression.
        The perform messages and #respondsTo: must be implemented to produce
        consistent results.  A message to perform a selector, selector, for
        a given receiver will result in a message-not-understood condition
        if and only if the value of receiver respondsTo: selector is false.
        Behavior is undefined if the number of arguments does not match that
        implicitly required by  the syntactic form of the selector."

        self conformingValue: [testCase canonicalObject
                        perform: #'perform:with:'
                        with: #'~~'
                        with: 1]
                should: [:r|
                        r & (testCase canonicalObject respondsTo: #perform:with:)].

        self should: [testCase canonicalObject
                        perform: #'bogusParm1:parm2:'
                        with: #()
                        with: #()]
                raise: MessageNotUnderstood.

self anomaly: [
        self should: [testCase canonicalObject
                        perform: #'isNil'
                        with: 1
                        with: 1]
                raise: TestResult error.
] for: #(#'STX36' #'STX41' "2002/06/13 penk - no error raised for performs").
!

testXperformXwithXwithXwithX
        " Fundamental <Object> "
        self messageSelector: #'perform:with:with:with:'.

        self conformingValue: [
                        testCase canonicalObject
                                perform: #'perform:with:with:'
                                with: #'perform:with:'
                                with: #'~~'
                                with: 1]
                should: [:r|
                        r & (testCase canonicalObject respondsTo: #perform:with:)
                        & (testCase canonicalObject respondsTo: #perform:with:with:)].
        "If the receiver does not have a method for selector normal
        message-not-understood processing is performed as if the computed
        message hand been sent using a message send expression.
        The perform messages and #respondsTo: must be implemented to produce
        consistent results.  A message to perform a selector, selector, for
        a given receiver will result in a message-not-understood condition
        if and only if the value of receiver respondsTo: selector is false.
        Behavior is undefined if the number of arguments does not match that
        implicitly required by  the syntactic form of the selector."

        self should: [testCase canonicalObject
                        perform: #'bogusParm1:parm2:'
                        with: #()
                        with: #()
                        with: #()]
                raise: MessageNotUnderstood.

self anomaly: [
        self should: [testCase canonicalObject
                        perform: #'isNil'
                        with: 1
                        with: 1
                        with: 1]
                raise: TestResult error.
] for: #(#'STX36' #'STX41' "2002/06/13 penk - no error raised for performs").
!

testXprintOnX
	" Fundamental <Object> "
	| resultStream |
	self messageSelector: #'printOn:'.

	"The string of characters that would be the result of sending the
	message #printString to the receiver is written to target."
	self conformingValue: [resultStream := WriteStream on: (String new: 10).
			testCase canonicalObject printOn: resultStream]
		should: [:r| (resultStream contents)
			= testCase canonicalObject printString].
!

testXprintString
	" Fundamental <Object> "
	self messageSelector: #'printString'.

	self conformingValue: [testCase canonicalObject printString]
		should: [:r| true].
!

testXrespondsToX
	" Fundamental <Object> "
	self messageSelector: #'respondsTo:'.

	self conformingValue: [testCase canonicalObject respondsTo: #'isNil']
		should: [:r| r].

	self conformingValue: [testCase canonicalObject respondsTo: #'bogus']
		shouldnt: [:r| r].
!

testXyourself
	" Fundamental <Object> "
	| anObject |
	self messageSelector: #'yourself'.

	anObject := testCase canonicalObject.
	self conformingValue: [anObject yourself]
		should: [:r | r == anObject]
! !

!ObjectHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ObjectHelper.st,v 1.1 2002/06/21 10:31:07 penk Exp $'
! !
