"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#PuttableStreamHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Stream'
!


!PuttableStreamHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<puttableStream>'
! !

!PuttableStreamHelper methodsFor:'testing'!

testXcr
	" Stream <puttableStream> "
	self messageSelector: #'cr'.

	self conformingValue: [testCase canonicalObject cr]
		should: [:r| true "UNSPECIFIED"].
	"Harmon Note: I din't think it worth trying to figure out how to test
	the characters written, mostly because stream can be the Transcript."

	"Errors It is erroneous if any element of the end-of-line sequence is
	an object that does not conform to the receiver's sequence value type."
!

testXflush
	" Stream <puttableStream> "
	self messageSelector: #'flush'.

	self conformingAssertMessageSelector.

	self notDone. "Don't know how to check this:
Upon return, if the receiver is a write-back stream, the state of the stream backing store must be consistent with the current state of the receiver.
If the receiver is not a write-back stream, the effect of this message is unspecified.
"
!

testXnextPutAllX
	" Stream <puttableStream> "
	| object testString |
	self messageSelector: #'nextPutAll:'.

	object := testCase canonicalObject.
	testString := 'abc1%ABC'.

self anomaly: [
	self conformingValue: [object nextPutAll: testString]
		should: [:r|
			(object contents
				indexOfSubCollection: testString
				startingAt: 1) > 0].
] forDialectAndTestCaseName: #(
	#(#'DO30' "2001/02/18 Harmon, R."
		#(#'TranscriptTest'     "Firt time this test is run, testString is not found.  All subsequent runs it is found."))).

	"Errors: It is erroneous if any element of aCollection is an object
		that does not conform to the receiver's sequence value type."
	self should: [object nextPutAll: #($a 9 $X)]
		raise: TestResult error.
!

testXnextPutX
	" Stream <puttableStream> "
	| object pos char |
	self messageSelector: #'nextPut:'.

	object := testCase canonicalObject.
	pos := object position.
	char := $a.

	self conformingValue: [object nextPut: char]
		should: [:r|
			object position = (pos + 1)
			& object = Transcript
				ifTrue: [true]
				ifFalse: [object contents first = char]].

	"Errors: It is erroneous if anObject is an object that does not
			conform to the receiver's sequence value type."
	self should: [object nextPut: 9]
		raise: TestResult error.

	self notDone. "Don't know how to check this:
Appends anObject to the receiver's past sequence values. If the receiver's future sequence values is not empty, removes its first object.
"
!

testXspace
	" Stream <puttableStream> "
	self messageSelector: #'space'.

	self conformingValue: [testCase canonicalObject space]
		should: [:r| true "UNSPECIFIED"].
	"Harmon Note: I din't think it worth trying to figure out how to test
	the character written, mostly because stream can be the Transcript."

	"Errors It is erroneous if the space character is an object
		that does not conform to the receiver's sequence value type."
!

testXtab
	" Stream <puttableStream> "
	self messageSelector: #'tab'.

	self conformingValue: [testCase canonicalObject tab]
		should: [:r| true "UNSPECIFIED"].
	"Harmon Note: I din't think it worth trying to figure out how to test
	the character written, mostly because stream can be the Transcript."

	"Errors It is erroneous if the tab character is an object
		that does not conform to the receiver's sequence value type."
! !

!PuttableStreamHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/PuttableStreamHelper.st,v 1.1 2002/06/21 10:34:19 penk Exp $'
! !
