"{ Package: 'stx:goodies/ansiTests/common' }"

FileStreamTest subclass:#ReadFileStreamTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-File Stream'
!


!ReadFileStreamTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<readFileStream>'
! !

!ReadFileStreamTest methodsFor:'constants'!

binaryStream

	| str |
	str := FileStream
		read: self fileNameXTestFileXjnk
		type: #'binary'.
	str reset.
	^str
!

canonicalObject

	^(self textStream)
		reset;
		yourself
!

textStream

	| str |
	str := FileStream read: self fileNameXTestFileXjnk.
	str reset.
	^str
! !

!ReadFileStreamTest methodsFor:'testing'!

testXnextX
	" File Stream <readFileStream> "
	| textStream binaryStream first10 |
	self messageSelector: #'next:'.

	[textStream := self textStream.
	binaryStream := self binaryStream.
	first10 := self canonicalContents copyFrom: 1 to: 10.

	self conformingValue: [textStream next: 10]
		should: [:r| r = first10].
	self conformingValue: [binaryStream next: 10]
		should: [:r | r asString = first10].

	"If amount is equal to 0 an empty collection is returned."
	self conformingValue: [textStream next: 0]
		should: [:r| r isEmpty].
	self conformingValue: [binaryStream next: 0]
		should: [:r | r isEmpty].

	] ensure: [
		textStream close.
		binaryStream close].
!

testXupToX
	" File Stream <readFileStream> "
	| textStream binaryStream thi upToX content ndx char |
	self messageSelector: #'upTo:'.

	[textStream := self textStream.
	binaryStream := self binaryStream.
	char := $s.
	content := self canonicalContents.
	ndx := content indexOf: char.
	"Returns a collection of all of the objects in the receiver up to,
	but not including, the next occurrence of the argument."
	thi := content copyFrom: 1 to: (ndx - 1).
	"Sets the stream to read the object just after the next occurrence
	of the argument."
	upToX := content copyFrom: (ndx + 1) to: (content size).

	self conformingValue: [textStream upTo: char]
		should: [:r| r = thi].
	self conformingValue: [binaryStream upTo: (char codePoint)]
		should: [:r | r asString = thi].

	"If the argument is not found and the end of the stream is encountered,
	an ordered collection of the objects read is returned."
	self conformingValue: [textStream upTo: $X]
		should: [:r| self
			compareTextIgnoringLineTermTarget: upToX
			result: r].
	self conformingValue: [binaryStream upTo: ($X codePoint)]
		should: [:r| self
			compareTextIgnoringLineTermTarget: upToX
			result: r asString].

	] ensure: [
		textStream close.
		binaryStream close].
! !

!ReadFileStreamTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ReadFileStreamTest.st,v 1.1 2002/06/21 10:38:13 penk Exp $'
! !
