"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#ReadStreamTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Stream'
!


!ReadStreamTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<ReadStream>'
! !

!ReadStreamTest methodsFor:'constants'!

canonicalContents

	^'this is the first line', self lineDelimiter, 'this is the last line'
		copy
!

canonicalObject

	^ReadStream on: self canonicalContents
! !

!ReadStreamTest methodsFor:'testing'!

testXnextX
	" ANSI-Stream <ReadStream> "
	| readStream |
	self messageSelector: #'next:'.

	readStream := self canonicalObject.
	readStream reset.

	"next 3 objects t, h, & i:"
	self conformingValue: [readStream next: 3]
		should: [:r| r asArray = 'thi' asArray].

	"next zero objects:"
	self conformingValue: [readStream next: 0]
		should: [:r| r isEmpty].

	"Errors: amount < 0."
	self should: [readStream next: -1]
		raise: TestResult error.
!

testXupToX
	" ANSI-Stream <ReadStream> "
	| readStream contents remainder |
	self messageSelector: #'upTo:'.

	readStream := self canonicalObject.
	readStream reset.

	"up to space & make sure we got space after first word:"
	self conformingValue: [readStream upTo: $ ]
		should: [:r| r = 'this' & readStream next = $i].

	"up to non-existant X & make sure we got everything and at end:"
	contents := self canonicalContents.
	remainder := contents copyFrom: 7 to: (contents size).
	self conformingValue: [readStream upTo: $X]
		should: [:r| r = remainder & readStream atEnd].

	"up to a on stream at end:"
	self conformingValue: [readStream upTo: $a]
		should: [:r| r isEmpty].
! !

!ReadStreamTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ReadStreamTest.st,v 1.1 2002/06/21 10:36:11 penk Exp $'
! !
