"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#ScaledDecimalTest
	instanceVariableNames:'magnitudeObjects numberObjects sclDec2s3'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Numeric'
!


!ScaledDecimalTest class methodsFor:'constants'!

magnitudeObjects

	^Dictionary new
		at: #'small' put: (-3000000000.0d0 asScaledDecimal: 3);
		at: #'medium' put: (1.0001d0 asScaledDecimal: 4);
		at: #'large' put: (3000000000.0d0 asScaledDecimal: 2);
		yourself
!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<scaledDecimal>'
! !

!ScaledDecimalTest methodsFor:'constants'!

canonicalObject

	^sclDec2s3
!

magnitudeObjects

	^magnitudeObjects
!

numberObjects

	^numberObjects
! !

!ScaledDecimalTest methodsFor:'helpers'!

createNumberObjects

	| tmp numbers |
	numberObjects := Dictionary new.
	numberObjects
		at: #'numbers' put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (-2.0d0 asScaledDecimal: 1);
			add: ScaledDecimal zero; yourself);
		at: #'coercing' put: [:number| number asScaledDecimal: 3];
		at: #'zero' put: ScaledDecimal zero;
		at: #'*' put: (OrderedCollection new
			add: (OrderedCollection new
				add: (-4000000000.0d0 asScaledDecimal: 3); add: 1;
				add: (4.0d0 asScaledDecimal: 3);
				add: (4.0d0 asScaledDecimal: 3); add: 4.0d0;
				add: (4000000000.0d0 asScaledDecimal: 3); yourself);
			add: (OrderedCollection new
				add: (4000000000.0d0 asScaledDecimal: 3); add: -1;
				add: (-4.0d0 asScaledDecimal: 3);
				add: (-4.0d0 asScaledDecimal: 3); add: -4.0d0;
				add: (-4000000000.0d0 asScaledDecimal: 3); yourself);
			add: (OrderedCollection new
				add: ScaledDecimal zero; add: 0; add: ScaledDecimal zero;
				add: ScaledDecimal zero; add: 0.0;
				add: ScaledDecimal zero; yourself);
			yourself);
		at: #'+' put: (OrderedCollection new
			add: (OrderedCollection new 
				add: (-1999999998.0d0 asScaledDecimal: 3); add: (5/2);
				add: (4.0d0 asScaledDecimal: 3);
				add: (4.0d0 asScaledDecimal: 3); add: 4.0d0;
				add: (2000000002.0d0 asScaledDecimal: 3); yourself);
			add: (OrderedCollection new 
				add: (-2000000002.0d0 asScaledDecimal: 3); add: (-3/2);
				add: ScaledDecimal zero; add: ScaledDecimal zero; add: 0.0;
				add: (1999999998.0d0 asScaledDecimal: 3); yourself);
			add: (OrderedCollection new 
				add: (-2000000000 asScaledDecimal: 0); add: (1/2);
				add: (2.0d0 asScaledDecimal: 3); add: (2 asScaledDecimal: 0);
				add: 2.0d0; add: (2000000000 asScaledDecimal: 0); yourself);
			yourself);
		at: #'-' put: (OrderedCollection new
			add: (OrderedCollection new 
				add: (2000000002.0d0 asScaledDecimal: 3); add: (3/2);
				add: (0.0 asScaledDecimal: 3);
				add: (0.0 asScaledDecimal: 3); add: 0.0;
				add: (-1999999998.0d0 asScaledDecimal: 3); yourself);
			add: (OrderedCollection new 
				add: (1999999998.0d0 asScaledDecimal: 3); add: (-5/2);
				add: (-4.0d0 asScaledDecimal: 3);
				add: (-4.0d0 asScaledDecimal: 3); add: -4.0d0;
				add: (-2000000002.0d0 asScaledDecimal: 3); yourself);
			add: (OrderedCollection new 
				add: (2000000000 asScaledDecimal: 0); add: (-1/2);
				add: (-2.0d0 asScaledDecimal: 3);
				add: (-2 asScaledDecimal: 0); add: -2.0d0;
				add: (-2000000000 asScaledDecimal: 0); yourself);
			yourself);
		at: #'/' put: (OrderedCollection new
			add: (OrderedCollection new 
				add: ScaledDecimal zero; add: 4;
				add: (1.0d0 asScaledDecimal: 3);
				add: (1.0d0 asScaledDecimal: 3); add: 1.0d0;
				add: ScaledDecimal zero; yourself);
			add: (OrderedCollection new 
				add: ScaledDecimal zero; add: -4;
				add: (-1.0d0 asScaledDecimal: 3);
				add: (-1.0d0 asScaledDecimal: 1); add: -1.0d0;
				add: ScaledDecimal zero; yourself);
			add: (OrderedCollection new 
				add: ScaledDecimal zero; add: 0; add: ScaledDecimal zero;
				add: ScaledDecimal zero; add: 0.0;
				add: ScaledDecimal zero; yourself);
			yourself);
		at: #'//' put: #(
				#(-1 4 1 1 1 0)
				#(0 -4 -1 -1 -1 -1)
				#(0 0 0 0 0 0));
		at: #'<' put: #(
				#(false false false false false true)
				#(false true true true true true)
				#(false true true true true true));
		at: #'=' put: #(
				#(false false true true true false)
				#(false false false false false false)
				#(false false false false false false));
		at: #'>' put: #(
				#(true true false false false false)
				#(true false false false false false)
				#(true false false false false false)).

	"\\" tmp := Dictionary new.
	tmp at: #'numbers' put: (OrderedCollection new
				add: (26.0d0 asScaledDecimal: 3);
				add: (-26.0d0 asScaledDecimal: 3);
				add: (26.5d0 asScaledDecimal: 3);
				add: (-26.5d0 asScaledDecimal: 3);
				add: ScaledDecimal zero; yourself);
		at: #'posAnswers' put: (OrderedCollection new
				add: (OrderedCollection new
					add: (-1999999974.0d0 asScaledDecimal: 3);
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: 0.0;
					add: (26.0d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: (-26.0d0 asScaledDecimal: 3);
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: 0.0;
					add: (1999999974.0d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: (-1999999973.5d0 asScaledDecimal: 3);
					add: 0;
					add: (0.5d0 asScaledDecimal: 3);
					add: (0.5d0 asScaledDecimal: 3);
					add: 0.5d0;
					add: (26.5d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: (-26.5d0 asScaledDecimal: 3);
					add: 0;
					add: (1.5d0 asScaledDecimal: 3);
					add: (1.5d0 asScaledDecimal: 3);
					add: 1.5d0;
					add: (1999999973.5d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: 0.0;
					add: ScaledDecimal zero; yourself);
				yourself);
		at: #'negAnswers' put: (OrderedCollection new
				add: (OrderedCollection new
					add: (26.0d0 asScaledDecimal: 3);
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: 0.0;
					add: (-1999999974.0d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: (1999999974.0d0 asScaledDecimal: 3);
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: 0.0;
					add: (-26.0d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: (26.5d0 asScaledDecimal: 3);
					add: 0;
					add: (-1.5d0 asScaledDecimal: 3);
					add: (-1.5d0 asScaledDecimal: 3);
					add: -1.5d0;
					add: (-1999999973.5d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: (1999999973.5d0 asScaledDecimal: 3);
					add: 0;
					add: (-0.5d0 asScaledDecimal: 3);
					add: (-0.5d0 asScaledDecimal: 3);
					add: -0.5d0;
					add: (-26.5d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: ScaledDecimal zero;
					add: 0.0;
					add: ScaledDecimal zero; yourself);
				yourself).
	numberObjects at: #'\\' put: tmp.

	numberObjects
		at: #'abs' put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (2.0d0 asScaledDecimal: 1);
			add: (ScaledDecimal zero); yourself);
		at: #'asFloat'  put: #(2.0d0 -2.0d0 0.0);
		at: #'asFloatD' put: (numberObjects at: #'asFloat');
		at: #'asFloatE' put: (numberObjects at: #'asFloat');
		at: #'asFloatQ' put: (numberObjects at: #'asFloat');
		at: #'asFraction'       put: #(2 -2 0).

	"asInteger"     tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (2.1d0 asScaledDecimal: 3);
			add: (2.5d0 asScaledDecimal: 3); add: (-2.0d0 asScaledDecimal: 3);
			add: (-2.1d0 asScaledDecimal: 3); add: (-2.5d0 asScaledDecimal: 3);
			add: (ScaledDecimal zero); yourself);
		at: #'answers'  put: #(2 2 3 -2 -2 -3 0).
	numberObjects at: #'asInteger'  put: tmp.

	"asScaledDecimal:"      tmp := Dictionary new.
	tmp at: #'numbers'      put: (numberObjects at: #'numbers');
		at: #'answers'  put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (-2.0d0 asScaledDecimal: 2);
			add: (0.0 asScaledDecimal: 1); yourself);
		at: #'scales'   put: #(3 2 0).
	numberObjects at: #'asScaledDecimal:'   put: tmp.

	"ceiling"       tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (2.1d0 asScaledDecimal: 3);
			add: (2.5d0 asScaledDecimal: 3); add: (-2.0d0 asScaledDecimal: 3);
			add: (-2.1d0 asScaledDecimal: 3); add: (-2.5d0 asScaledDecimal: 3);
			add: (ScaledDecimal zero); yourself);
		at: #'answers'  put: #(2 3 3 -2 -2 -2 0).
	numberObjects at: #'ceiling'    put: tmp.

	"floor" tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (2.1d0 asScaledDecimal: 3);
			add: (2.5d0 asScaledDecimal: 3); add: (-2.0d0 asScaledDecimal: 3);
			add: (-2.1d0 asScaledDecimal: 3); add: (-2.5d0 asScaledDecimal: 3);
			add: (ScaledDecimal zero); yourself);
		at: #'answers'  put: #(2 2 2 -2 -3 -3 0).
	numberObjects at: #'floor' put: tmp.

	"fractionPart"  tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (2.5d0 asScaledDecimal: 3);
			add: (-2.0d0 asScaledDecimal: 3); add: (-2.5d0 asScaledDecimal: 3);
			add: (ScaledDecimal zero); yourself);
		at: #'answers'  put: #(0.0 0.5d0 0.0 -0.5d0 0).
	numberObjects at: #'fractionPart' put: tmp.

	"integerPart"   tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (2.5d0 asScaledDecimal: 3);
			add: (-2.0d0 asScaledDecimal: 3); add: (-2.5d0 asScaledDecimal: 3);
			add: (ScaledDecimal zero); yourself);
		at: #'answers'  put: #(2.0d0 2.0d0 -2.0d0 -2.0d0 0).
	numberObjects at: #'integerPart' put: tmp.

	numberObjects
		at: #'negated' put: (OrderedCollection new
			add: (-2.0d0 asScaledDecimal: 3); add: (2.0d0 asScaledDecimal: 1);
			add: (ScaledDecimal zero); yourself);
		at: #'negative' put: #(false true false);
		at: #'positive' put: #(true false true);
		at: #'quo:' put: #(
				#(0 4 1 1 1 0) #(0 -4 -1 -1 -1 0) #(0 0 0 0 0 0)).

	"printString"   tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (123 asScaledDecimal: 0);
			add: (1.0d0 asScaledDecimal: 1);
			add: (-2.01d0 asScaledDecimal: 2);
			add: (3.500d0 asScaledDecimal: 3);
			add: (-0.12345678901234567890d0 asScaledDecimal: 20);
			add: (ScaledDecimal zero); yourself);
		at: #'answers'  put: #('123s' '1.0s' '-2.01s' '3.500s'
				'-0.12345678901234568379s' '0s').
	numberObjects at: #'printString' put: tmp.

	numberObjects at: #'raisedToInteger:' put: (OrderedCollection new
		"number integer answer"
		add: (OrderedCollection new
			add: (5.1d0 asScaledDecimal: 2); add: 0;
			add: (1.0d0 asScaledDecimal: 2); yourself);
		add: (OrderedCollection new
			add: (5.1d0 asScaledDecimal: 2); add: 1;
			add: (5.1d0 asScaledDecimal: 2); yourself);
		add: (OrderedCollection new
			add: (5.1d0 asScaledDecimal: 2); add: 2;
			add: (26.01d0 asScaledDecimal: 2); yourself);
		add: (OrderedCollection new
			add: (-5.1d0 asScaledDecimal: 2); add: 2;
			add: (26.01d0 asScaledDecimal: 2); yourself);
		add: (OrderedCollection new
			add: (5.1d0 asScaledDecimal: 16); add: -2;
			add: (0.0384467512495194d0 asScaledDecimal: 16); yourself);
		yourself).

	numberObjects
		at: #'reciprocal' put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3);
			add: (-2.0d0 asScaledDecimal: 1); yourself).

	"rem:"  tmp := Dictionary new.
	tmp at: #'numbers' put: (OrderedCollection new
				add: (26000000001.5d0 asScaledDecimal: 3);
				add: (-26000000001.5d0 asScaledDecimal: 3);
				add: (26.0d9 asScaledDecimal: 3);
				add: (-26.0d9 asScaledDecimal: 3);
				add: ScaledDecimal zero; yourself);
		at: #'answers' put: (OrderedCollection new
				add: (OrderedCollection new
					add: (1.5d0 asScaledDecimal: 3);
					add: (1.5d0 asScaledDecimal: 3);
					add: (1.5d0 asScaledDecimal: 3); add: 1.5d0;
					add: (3/2);
					add: (1.5d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: (-1.5d0 asScaledDecimal: 3);
					add: (-1.5d0 asScaledDecimal: 3);
					add: (-1.5d0 asScaledDecimal: 3); add: -1.5d0;
					add: (-3/2);
					add: (-1.5d0 asScaledDecimal: 3); yourself);
				add: (OrderedCollection new
					add: ScaledDecimal zero; add: ScaledDecimal zero;
					add: ScaledDecimal zero; add: 0.0;
					add: ScaledDecimal zero; add: ScaledDecimal zero;
					yourself);
				add: (OrderedCollection new
					add: ScaledDecimal zero; add: ScaledDecimal zero;
					add: ScaledDecimal zero; add: 0.0;
					add: ScaledDecimal zero; add: ScaledDecimal zero;
					yourself);
				add: (OrderedCollection new
					add: ScaledDecimal zero; add: ScaledDecimal zero;
					add: ScaledDecimal zero; add: 0.0;
					add: ScaledDecimal zero; add: ScaledDecimal zero;
					yourself);
				yourself).
	numberObjects at: #'rem:' put: tmp.

	"rounded"       tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (2.1d0 asScaledDecimal: 3);
			add: (2.5d0 asScaledDecimal: 3); add: (-2.0d0 asScaledDecimal: 3);
			add: (-2.1d0 asScaledDecimal: 3); add: (-2.5d0 asScaledDecimal: 3);
			add: ScaledDecimal zero; yourself);
		at: #'answers'  put: #(2 2 3 -2 -2 -3 0).
	numberObjects at: #'rounded' put: tmp.

	numberObjects
		at: #'roundTo:' put: (OrderedCollection new
			add: ScaledDecimal zero; add: 2; add: (2.0d0 asScaledDecimal: 3);
			add: (2 asScaledDecimal: 0); add: 2.0d0; add: ScaledDecimal zero;
			yourself);
		at: #'sign'     put: #(1 -1 0).

	"sqrt"  tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (26.0d0 asScaledDecimal: 0); add: (26.0d0 asScaledDecimal: 1);
			add: (26.01d0 asScaledDecimal: 2);
			add: (26.01d0 asScaledDecimal: 3); add: (ScaledDecimal zero);
			yourself);
		at: #'answers'  put: #(5.099019513592785d0 5.099019513592785d0
			5.1d0 5.1d0 0.0).
	numberObjects at: #'sqrt' put: tmp.

	"squared"       tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (5.1d0 asScaledDecimal: 3);
			add: (-5.1d0 asScaledDecimal: 3);
			add: (5.1d0 asScaledDecimal: 2);
			add: (5.1d0 asScaledDecimal: 1);
			add: (5.1d0 asScaledDecimal: 0);
			add: (ScaledDecimal zero);
			yourself);
		at: #'answers'  put: (OrderedCollection new
			add: (26.010d0 asScaledDecimal: 3);
			add: (26.010d0 asScaledDecimal: 3);
			add: (26.01d0 asScaledDecimal: 2);
			add: (26.0d0 asScaledDecimal: 1);
			add: (26.0d0 asScaledDecimal: 0);
			add: (ScaledDecimal zero);
			yourself).
	numberObjects at: #'squared' put: tmp.

	numberObjects
		at: #'strictlyPositive' put: #(true false false).

	"truncated"     tmp := Dictionary new.
	tmp at: #'numbers'      put: (OrderedCollection new
			add: (2.0d0 asScaledDecimal: 3); add: (2.1d0 asScaledDecimal: 3);
			add: (2.5d0 asScaledDecimal: 3); add: (-2.0d0 asScaledDecimal: 3);
			add: (-2.1d0 asScaledDecimal: 3); add: (-2.5d0 asScaledDecimal: 3);
			add: (ScaledDecimal zero); yourself);
		at: #'answers'  put: #(2 2 2 -2 -2 -2 0).
	numberObjects at: #'truncated'  put: tmp.

	numberObjects
		at: #'truncateTo:' put: (OrderedCollection new
			add: ScaledDecimal zero; add: 2; add: (2.0d0 asScaledDecimal: 3);
			add: (2 asScaledDecimal: 0); add: 2.0d0; add: ScaledDecimal zero;
			yourself).
!

setUp

	super setUp.
	sclDec2s3 := 2.0d0 asScaledDecimal: 3.
	magnitudeObjects := self class magnitudeObjects.
	self createNumberObjects.
! !

!ScaledDecimalTest methodsFor:'testing'!

testLiterals

	self should: [(123.0d0 asScaledDecimal: 0) = (123.0d0 asScaledDecimal: 0)].
	self should: [(123.0d0 asScaledDecimal: 0) = (123.0d0 asScaledDecimal: 0)].
	self should: [(123.0d0 asScaledDecimal: 0) = (123.0d0 asScaledDecimal: 0)].
	self should: [(123.0d0 asScaledDecimal: 1) = (123.0d0 asScaledDecimal: 1)].
	self should: [(123.0d0 asScaledDecimal: 1) = (123.0d0 asScaledDecimal: 1)].
	self should: [(123.0d0 asScaledDecimal: 1) = (123.0d0 asScaledDecimal: 1)].
	self should: [(123.0d0 asScaledDecimal: 3) = (123.0d0 asScaledDecimal: 3)].
	self should: [(123.0d0 asScaledDecimal: 3) = (123.0d0 asScaledDecimal: 3)].
	self should: [(123.0d0 asScaledDecimal: 3) = (123.0d0 asScaledDecimal: 3)].
	self should: [(123.0d0 asScaledDecimal: 3) = (123.0d0 asScaledDecimal: 3)].
	self should: [(123.0d0 asScaledDecimal: 3) = (123.0d0 asScaledDecimal: 3)]
!

testXscale
	" ANSI-Numeric <scaledDecimal> "
	self messageSelector: #'scale'.

	self conformingValue: [(2.0d0 asScaledDecimal: 1) scale]
		should: [:r| r = 1].
	self conformingValue: [(2.00d0 asScaledDecimal: 2) scale]
		should: [:r| r = 2].
	self conformingValue: [(2.0d0 asScaledDecimal: 3) scale]
		should: [:r| r = 3].
! !

!ScaledDecimalTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/ScaledDecimalTest.st,v 1.1 2002/06/21 10:26:51 penk Exp $'
! !
