"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#SequencedCollectionHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!SequencedCollectionHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<sequencedCollection>'
! !

!SequencedCollectionHelper methodsFor:'testing'!

testXatAllPutX
	" Collection <sequencedCollection> "
	| sequencedCollection putValue |
	self messageSelector: #'atAllPut:'.

	sequencedCollection := testCase canonicalObject.
	putValue := (sequencedCollection isKindOf: ByteArray)
		ifTrue: [9]
		ifFalse: [$a].
	self conformingValue: [sequencedCollection atAllPut: putValue]
		should: [:result| (sequencedCollection
			detect: [:each| each ~= putValue ]
			ifNone: [nil]) isNil].

	testCase conformanceOfPutElementOnXatAllPutX: 'ABC'.
!

testXatAllXputX
	" Collection <sequencedCollection> "
	| putValue indices sequencedCollection |
	self messageSelector: #'atAll:put:'.

	sequencedCollection := testCase canonicalObject.
	indices := #(1 2 3).
	putValue := (sequencedCollection isKindOf: ByteArray)
		ifTrue: [9]
		ifFalse: [$a].

	self conformingValue: [sequencedCollection 
			atAll: indices 
			put: putValue]
		should: [:result| (indices 
			detect: [:each| (sequencedCollection at: each) ~= putValue]
			ifNone: [nil]) isNil].

	testCase conformanceOfPutElementOnXatAllXputX: 'ABC'.

	self should: [sequencedCollection 
			atAll: #($a #bee 'See') 
			put: putValue]
		raise: TestResult error.

	self should: [sequencedCollection 
			atAll:#(0 1) 
			put: putValue]
		raise: TestResult error.

	self should: [sequencedCollection 
			atAll: (Array 
				with: 1 
				with: sequencedCollection size + 1)
			put: putValue]
		raise: TestResult error
!

testXatXputX
	" Collection <sequencedCollection> "
	| sequencedCollection putValue |
	self messageSelector: #'at:put:'.

	sequencedCollection := testCase canonicalObject.
	putValue := (sequencedCollection isKindOf: ByteArray)
		ifTrue: [9]
		ifFalse: [$a].

	self conformingValue: [sequencedCollection
			at: 1
			put: putValue]
		should: [:result| (result = putValue)
			& ((sequencedCollection at: 1) = putValue)].

	testCase conformanceOfPutElementOnXatXputX: 'ABC'.

	self should: [sequencedCollection 
			at: -1 
			put: putValue]
		raise: TestResult error.

	self should: [sequencedCollection 
			at: sequencedCollection size + 1
			put: putValue]
		raise: TestResult error.

	self should: [sequencedCollection 
			at: 0
			put: putValue]
		raise: TestResult error.
!

testXreplaceFromXtoXwithObjectX
	" Collection <sequencedCollection> "
	| sequencedCollection putValue |
	self messageSelector: #'replaceFrom:to:withObject:'.

	sequencedCollection := testCase canonicalObject.
	putValue := (sequencedCollection isKindOf: ByteArray)
		ifTrue: [9]
		ifFalse: [$a].

	self conformingValue: [sequencedCollection 
			replaceFrom: 2
			to: 3
			withObject: putValue]
		should: [:result|
			((sequencedCollection at: 2) = putValue)
			& ((sequencedCollection at: 3) = putValue)].

	self should: [sequencedCollection 
			replaceFrom: 0
			to: 1
			withObject: putValue]
		raise: TestResult error.

	self should: [sequencedCollection 
			replaceFrom: sequencedCollection size + 1
			to: 1
			withObject: putValue]
		raise: TestResult error.

	self should: [sequencedCollection 
			replaceFrom: 1
			to: 0
			withObject: putValue]
		raise: TestResult error.

	self should: [sequencedCollection 
			replaceFrom: 1
			to: sequencedCollection size + 1
			withObject: putValue]
		raise: TestResult error
!

testXreplaceFromXtoXwithX
	" Collection <sequencedCollection> "
	| sequencedCollection putValue |
	self messageSelector: #'replaceFrom:to:with:'.

	sequencedCollection := testCase canonicalObject.
	putValue := (sequencedCollection isKindOf: ByteArray)
		ifTrue: [#(9 8)]
		ifFalse: [#($b $a)].

	self conformingValue: [sequencedCollection
			replaceFrom: 2
			to: 3
			with: putValue]
		should: [:result | 
			((sequencedCollection at: 2) = (putValue at: 1))
			& ((sequencedCollection at: 3) = (putValue at: 2))].

	self should: [sequencedCollection
			replaceFrom: 0
			to: 1
			with: putValue]
		raise: TestResult error.

	self should: [sequencedCollection
			replaceFrom: sequencedCollection size + 1
			to: 1
			with: putValue]
		raise: TestResult error.

	self should: [sequencedCollection
			replaceFrom: 1
			to: 0
			with: putValue]
		raise: TestResult error.

	self should: [sequencedCollection
			replaceFrom: 1
			to: sequencedCollection size + 1
			with: putValue]
		raise: TestResult error.

	self should: [sequencedCollection
			replaceFrom:1
			to: 2
			with: #(1 2 3 5)]
		raise: TestResult error.

	self should: [sequencedCollection
				replaceFrom:1
				to: 3
				with: #(1)]
		raise: TestResult error
!

testXreplaceFromXtoXwithXstartingAtX
	" Collection <sequencedCollection> "
	| sequencedCollection putValue |
	self messageSelector: #'replaceFrom:to:with:startingAt:'.

	sequencedCollection := testCase canonicalObject.
	putValue := (sequencedCollection isKindOf: ByteArray)
		ifTrue: [#(9 8 7)]
		ifFalse: [#($c $b $a)].

	self conformingValue: [sequencedCollection
			replaceFrom: 1
			to: 2
			with: putValue
			startingAt: 2]
		should: [:result|
			((sequencedCollection at: 1) = (putValue at: 2))
			& ((sequencedCollection at: 2) = (putValue at: 3))].

	self should: [sequencedCollection
			replaceFrom: 0
			to: 1
			with: putValue
			startingAt: 2]
		raise: TestResult error.

self anomaly: [
	self should: [sequencedCollection
			replaceFrom: sequencedCollection size + 1
			to: 1
			with: putValue
			startingAt: 2]
		raise: TestResult error.

	self should: [sequencedCollection
			replaceFrom: 1
			to: 0
			with: putValue
			startingAt: 2]
		raise: TestResult error.
] for: #(#'DO30' "2000/12/06 Harmon, R. The implem. notes say msg mostly inlined and this anomaly looks really complicated to add err chk fix, and msg is important to system performance.").

	self should: [sequencedCollection
			replaceFrom: 1
			to: sequencedCollection size + 1
			with: putValue
			startingAt: 2]
		raise: TestResult error.

	self should: [sequencedCollection
			replaceFrom: 1
			to: 2
			with: #(1 2 3 5)
			startingAt: 4]
		raise: TestResult error.

	self should: [sequencedCollection
			replaceFrom: 1
			to: 3
			with: #(1 2)
			startingAt: 0]
		raise: TestResult error.

	self should: [sequencedCollection
			replaceFrom: 1
			to: 3
			with: #(1 2)
			startingAt: 3]
		raise: TestResult error
! !

!SequencedCollectionHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SequencedCollectionHelper.st,v 1.1 2002/06/21 10:35:54 penk Exp $'
! !
