"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#SequencedContractibleCollectionHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!SequencedContractibleCollectionHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<sequencedContractibleCollection>'
! !

!SequencedContractibleCollectionHelper methodsFor:'testing'!

testXremoveAtIndexX
	" Collection <sequencedContractibleCollection> "
	| seqCollection getValue getValue2 |
	self messageSelector: #'removeAtIndex:'.

	seqCollection := testCase canonicalObject.
	getValue := seqCollection at: 1.
	getValue2 := seqCollection at: 2.
	self conformingValue: [seqCollection removeAtIndex: 1]
		should: [:result| result = getValue
			and: [(seqCollection at: 1) = getValue2]].

	"Errors If index is 0 or negative."
	self should: [seqCollection removeAtIndex: 0]
		raise: TestResult error.

	"Errors If index is greater than the receiver's size."
	self should: [seqCollection removeAtIndex: seqCollection size + 1]
		raise: TestResult error.
!

testXremoveFirst
	" Collection <sequencedContractibleCollection> "
	| seqCollection getValue getValue2 originalLength |
	self messageSelector: #'removeFirst'.

	seqCollection := testCase canonicalObject.
	getValue := seqCollection at: 1.
	getValue2 := seqCollection at: 2.
	originalLength := seqCollection size.
	self conformingValue: [seqCollection removeFirst]
		should: [:result| result = getValue
			and: [((seqCollection at: 1) = getValue2)
				and: [ seqCollection size = (originalLength - 1)]]].

	"Errors The receiver is empty."
	self should: [testCase emptyCollection removeFirst]
		raise: TestResult error.
!

testXremoveLast
	" Collection <sequencedContractibleCollection> "
	| seqCollection getValue getValue2 originalLength |
	self messageSelector: #'removeLast'.

	seqCollection := testCase canonicalObject.
	originalLength := seqCollection size.
	getValue := seqCollection at: originalLength.
	getValue2 := seqCollection at: originalLength - 1.
	self conformingValue: [seqCollection removeLast]
		should: [:result| result = getValue
			and: [((seqCollection at: (originalLength -1)) = getValue2)
				and: [seqCollection size = (originalLength - 1)]]].

	"Errors The receiver is empty."
	self should: [testCase emptyCollection removeLast]
		raise: TestResult error.
! !

!SequencedContractibleCollectionHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SequencedContractibleCollectionHelper.st,v 1.1 2002/06/21 10:28:10 penk Exp $'
! !
