"{ Package: 'stx:goodies/ansiTests/common' }"

CollectionTest subclass:#SetTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!SetTest class methodsFor:'constants'!

canonicalCollection

	^self canonicalObject
!

canonicalElement

	^2
!

canonicalObject

	^Set
		with: 1
		with: 2
		with: 3
		with: 4
!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^self error: 'Has no restrictions.'.    "DO30"
!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<Set>'
! !

!SetTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^false  "Has no restrictions: DO30"
! !

!SetTest methodsFor:'constants'!

canonicalElement

	^self class canonicalElement
!

canonicalObject

	^self class canonicalObject
!

emptyCollection

	^Set new
! !

!SetTest methodsFor:'subclass tests'!

hasXequalityOpIssues
	"Has a conformance issue"

	^true
! !

!SetTest methodsFor:'testing'!

testXaddAllX
	" Collection <Set> "
	| set oldSize |
	self messageSelector: #'addAll:'.

	set := self canonicalObject.
	oldSize := set size.
	self conformingValue: [set addAll: set copy]
		should: [:r| set size = oldSize].
!

testXaddX
	" Collection <Set> "
	| set oldSize |
	self messageSelector: #'add:'.

	set := self canonicalObject.
	oldSize := set size.
	self conformingValue: [set add: set any]
		should: [:r| set size = oldSize].
!

testXcollectX
	" Collection <Set> "
	| set |
	self messageSelector: #'collect:'.

	set := self canonicalObject.
	self conformingValue: [set collect: [:each| each * 2]]
		should: [:r| r size = 4].

	"Duplicates will not be added."
	self conformingValue: [set collect: [:each| each even]]
		should: [:r| r size = 2].

	"Errors If the elements of the receiver are inappropriate for use
	as arguments to transformer."

	"Errors If the result of evaluating the transformer does not conform
		to any element type restrictions of the collection to be returned."
	self should: [set collect: [:each| each, 'string']]
		raise: TestResult error.
! !

!SetTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SetTest.st,v 1.1 2002/06/21 10:29:26 penk Exp $'
! !
