"{ Package: 'stx:goodies/ansiTests/common' }"

TestCaseHelper subclass:#SignaledExceptionHelper
	instanceVariableNames:'unchanged changed msgReturnValue blkReturnValue value'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Exception'
!


!SignaledExceptionHelper class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<signaledException>'
! !

!SignaledExceptionHelper methodsFor:'From ExceptionANSITest'!

exceptionOuterReturn
	"From ExceptionANSITest"

	^[[Exception signal]
		on: Exception
		do:
			[:except |
			except outer.
			unchanged := false]]
				on: Exception
				do: [:except | except return: true]
!

exceptionPass
	"From ExceptionANSITest"

	" <signaledException>#pass "
	^[[Exception signal]
		on: Exception
		do:
			[:ex |
			ex pass.
			unchanged := false]]
				on: Exception
				do:
					[:ex |
					changed := true.
					ex return]

!

exceptionReturn
	"From ExceptionANSITest"

	^[Exception signal]
		on: Exception
		do: [:except |
			except return.
			unchanged := false]
!

notificationOuterDefault
	"From ExceptionANSITest"

"A bug in Squeak's #outer leads this next thing to an infinite loop ..."
"??"
	value := 1.
	value := [Notification signal]
		on: Notification
		do:
			[:except |
			except outer.
			unchanged := false]. 
"??"

!

notificationOuterResume
	"From ExceptionANSITest"

	[[changed := Notification signal]
		on: Notification
		do: [:except |
			except outer.
			unchanged := false]]
				on: Notification
				do: [:except | except resume: true]
!

resignalExceptionAsNotification
	"From ExceptionANSITest"

	| firstTime |
	firstTime := true.
	^[[Exception signal]
		on: Exception
		do: [:ex |
			firstTime
				ifTrue:
					[firstTime := false.
					ex resignalAs: Notification new.
					unchanged := false]
				ifFalse: [ex pass]]]
				on: Notification
				do: [:ex | ex return: true]
!

resignalNotificationAsException
	"From ExceptionANSITest"

	^[[Notification signal]
		on: Notification
		do: [:ex| ex resignalAs: Exception new.
				unchanged := false]]
			on: Exception
			do: [:ex| ex return: true]
!

resumedException
	"From ExceptionANSITest"

	^[[Exception signal] 
		on: Exception 
		do: [:except |
			except resume: false.
		"Exception isn't resumable - this throws an exception"
			unchanged := false]]
				on: Exception
				do: [:ex | ex return: true]
!

resumedExceptionWithValue
	"From ExceptionANSITest"

	^[[Exception signal] 
		on: Exception 
		do: [:except| except resume: false.
				unchanged := false]]
			on: Exception
			do: [:ex| ex return: true]
!

resumedNotification
	"From ExceptionANSITest"

	[value := Notification signal] 
		on: Notification 
		do: [:except|
			except resume.
			unchanged := false]
!

resumedNotificationWithValue
	"From ExceptionANSITest"

	[changed := Notification signal] 
		on: Notification 
		do: [:except|
			except resume: true.
			unchanged := false]
!

signalExceptionNestedWithError
	"From ExceptionANSITest"

	^[[Exception signal]
		on: Exception
		do: [:exception | exception return: exception isNested]]
			on: Error
			do: [:error | error return]

!

signalNestedException
	"From ExceptionANSITest"

	^[[Exception signal]
		on: Exception
		do: [:exception | exception return: exception isNested]]
			on: Exception
			do: [:exception | exception return]
!

signalUnnestedException
	"From ExceptionANSITest"

	^[Exception signal]
		on: Exception 
		do: [:exception | exception return: exception isNested]
! !

!SignaledExceptionHelper methodsFor:'helpers'!

resignal: object on: exceptionClass as: resignalClass

	DialectAndVersion = #'SQ27' ifTrue: [
		"This doesn't work in Squeak 2,7 - bypass it for now."
		^nil].
	^[      [object signal]
			on: exceptionClass
			do: [:ex|
					ex resignalAs: resignalClass new.
					unchanged := false]
	]       on: resignalClass
		do: [:ex| ex return: true]

"       | firstTime |
	firstTime := true.
	^[[object signal]
		on: exceptionClass
		do: [:ex|
			firstTime
				ifTrue:
					[firstTime := false.
					ex resignalAs: resignalClass new.
					unchanged := false]
				ifFalse: [ex pass]]]
			on: resignalClass
			do: [:ex| ex return: true]
"
!

setUp

	super setUp.
	changed := false.
	unchanged := true.
	blkReturnValue := 0.
	msgReturnValue := 0.
	"Only needed for old code:"
	value := nil.
!

signal: object nestedOn: exceptionClass

	^[[object signal]
		on: exceptionClass
		do: [:exception | exception return: exception isNested]]
			on: exceptionClass
			do: [:exception | exception return]
!

signal: object nestedOn: exceptionClass on: nestedExceptionClass

	^[[object signal]
		on: exceptionClass
		do: [:exception| exception return: exception isNested]]
			on: nestedExceptionClass
			do: [:error| error return]
!

signal: object notNestedOn: exceptionClass

	^[object signal]
		on: exceptionClass
		do: [:exception| exception return: exception isNested]
!

signal: object onAndNestedOn: exceptionClass

	^[[object signal]
		on: exceptionClass
		do: [:exception | exception return: exception isNested]]
			on: exceptionClass
			do: [:exception | exception return]
!

signal: object onResume: exceptionClass

	DialectAndVersion = #'SQ27' ifTrue: [
		"This doesn't work in Squeak 2,7 - bypass it for now."
		^nil].
	^[object signal] 
		on: exceptionClass 
		do: [:except|
			except resume.
			unchanged := false]
!

signal: object onResume: exceptionClass nestedOn: outerClass

	DialectAndVersion = #'SQ27' ifTrue: [
		"This doesn't work in Squeak 2,7 - bypass it for now."
		^nil].
	^[      [object signal] 
			on: exceptionClass 
			do: [:except|
				except resume.
				unchanged := false]
	]       on: outerClass
		do: [:ex| ex return: true]
!

signal: object onResumeValue: exceptionClass

	^[changed := object signal] 
		on: exceptionClass 
		do: [:except|
			except resume: true.
			unchanged := false]
!

signal: object onResumeValue: exceptionClass nestedOn: outerClass

	^[      [object signal] 
			on: exceptionClass 
			do: [:except|
				except resume: false.
				unchanged := false]
	]       on: outerClass
		do: [:ex| ex return: true]
!

signal: object outerDefaultOn: exceptionClass

	^[object signal]
		on: exceptionClass
		do: [:except|
			msgReturnValue := except outer.
			unchanged := false]
!

signal: object outerResumeOnAndNestedOn: exceptionClass

	^[      [changed := object signal]
			on: exceptionClass
			do: [:except|
				msgReturnValue := except outer.
				unchanged := false]
	]       on: exceptionClass
		do: [:except| except resume: true]
!

signal: object outerReturnOnAndNestedOn: exceptionClass

	^[      [object signal]
			on: exceptionClass
			do: [:except|
				msgReturnValue := except outer.
				unchanged := false]
	]       on: exceptionClass
		do: [:except| except return: true]
!

signal: object passOn: exceptionClass nestedOn: outerClass

	^[      [object signal]
			on: exceptionClass
			do: [:ex|
				ex pass.
				unchanged := false]
	]       on: outerClass
		do: [:ex|
			changed := true.
			ex return]
!

signal: object returnOn: exceptionClass

	^[object signal]
		on: exceptionClass
		do: [:except|
			except return.
			unchanged := false]
! !

!SignaledExceptionHelper methodsFor:'testing'!

testXisNested
	" Exception <signaledException> "
	| object objectClass outerClass |
	self messageSelector: #'isNested'.

	object := testCase canonicalObject.
	objectClass := object class.

	self conformingValue: [
			self signal: object
				notNestedOn: objectClass]
		should: [:r| true "unspecified"].

	outerClass := objectClass = Error
		ifTrue: [Notification]
		ifFalse: [Error].

	self conformingValue: [
			self signal: object
				nestedOn: objectClass
				on: outerClass]
		should: [:r| true "unspecified"].

	self conformingValue: [
			self signal: object
				onAndNestedOn: objectClass]
		should: [:r| true "unspecified"].

"From ExceptionANSITest >> #testXisNested
	?? <signaledException>#isNested ??
	self shouldnt: [self signalUnnestedException].
	self shouldnt: [self signalExceptionNestedWithError].
	self should: [self signalNestedException].
??      conformTo: #'<signaledException>' selector: #'isNested'.??
"
!

testXouter
	" Exception <signaledException> "
	| object objectClass |
	self messageSelector: #'outer'.

	object := testCase canonicalObject.
	objectClass := object class.

	self conformingValue: [
			blkReturnValue := self signal: object
				outerReturnOnAndNestedOn: objectClass.
			msgReturnValue]
		should: [:r| r = 0 & changed not & unchanged
					& blkReturnValue].

self anomaly: [ "This is at best a starting point.  I don't understand
		exception handling well enough to sort this out. Harmon, R."
	self setUp.
	self conformingValue: [
			blkReturnValue := self
				signal: object
				outerDefaultOn: objectClass.
			msgReturnValue]
		should: [:r| r = nil & changed not & unchanged not
					& blkReturnValue not].
] forDialectAndTestCaseName: #(
	#(#'DO30' "2000/12/06 Harmon, R. Blows up."
			#(#'ExceptionTest'
			#'ErrorTest'
			#'MessageNotUnderstoodTest'
			#'ZeroDivideTest'
		#'WarningTest' "r -> dev. session mgr"))).

self anomaly: [ "This is at best a starting point.  I don't understand
		exception handling well enough to sort this out. Harmon, R."
	self setUp.
	self conformingValue: [
			blkReturnValue := self
				signal: object
				outerResumeOnAndNestedOn: objectClass.
			msgReturnValue]
		should: [:r| r & changed not & unchanged not
					& blkReturnValue not].
] forDialectAndTestCaseName: #(
	#(#'DO30' "2000/12/06 Harmon, R. Non-contiuable exept."
		#(#'ErrorTest' #'ExceptionTest'))).

"From ExceptionANSITest >> #testXouter
	?? <signaledException>#outer ??
	#'Exception'.
	changed := self exceptionOuterReturn.
	self should: [changed and: [unchanged]].
	self setUp.
	value := self notificationOuterDefault.
	self should: [value == nil and: [unchanged]].
	self setUp.
	self notificationOuterResume.
	self should: [changed and: [unchanged]].
"

!

testXpass
	" Exception <signaledException> "
	| object objectClass |
	self messageSelector: #'pass'.

	object := testCase canonicalObject.
	objectClass := object class.

	self conformingValue: [
			self signal: object
				passOn: objectClass
				nestedOn: objectClass]
		should: [:r| "Return Value none" changed & unchanged].

"From ExceptionANSITest >> #testXpass
	?? <signaledException>#pass ??
	self exceptionPass.
	self should: [changed and: [unchanged]]
"
!

testXresignalAsX
	" Exception <signaledException> "
	| object objectClass resignalClass |
	self messageSelector: #'resignalAs:'.

	object := testCase canonicalObject.
	objectClass := object class.

	resignalClass := objectClass = Exception
		ifTrue: [Error]
		ifFalse: [Exception].

	self conformingValue: [
			self resignal: object
				on: objectClass
				as: resignalClass]
		should: [:r| "Return Value none" changed not & unchanged].

	self notDone. "???Not sure what this tests with firstTime:???
	changed := self resignalExceptionAsNotification."

"From ExceptionANSITest >> #testXresignalAsX
	?? <signaledException>#resignalAs: ??
	changed := self resignalNotificationAsException.
	self should: [changed and: [unchanged]].
	self setUp.
	changed := self resignalExceptionAsNotification.
	self should: [changed and: [unchanged]].
"
!

testXresume
	" Exception <signaledException> "
	| object objectClass |
	self messageSelector: #'resume'.

	object := testCase canonicalObject.
	objectClass := object class.

self anomaly: [ "This is at best a starting point.  I don't understand
		exception handling well enough to sort this out. Harmon, R."
	self conformingValue: [
			self signal: object
				onResume: objectClass]
		should: [:r| "Return Value none" changed not & unchanged].
] forDialectAndTestCaseName: #(
	#(#'DO30' "2000/12/06 Harmon, R. Non-contiuable exept."
		#(#'ErrorTest' #'ExceptionTest'))).


	self setUp.
	self conformingValue: [
			self signal: object
				onResume: objectClass
				nestedOn: objectClass]
		should: [:r| "Return Value none" changed not & unchanged].

"From ExceptionANSITest >> #testXresume
	?? <signaledException>#resume ??
	value := 1.
	self resumedNotification.
	self should: [(value == nil) and: [unchanged]].
	self setUp.
	changed := self resumedException.
	self should: [changed and: [unchanged]]
"
!

testXresumeX
	" Exception <signaledException> "
	| object objectClass |
	self messageSelector: #'resume:'.

	object := testCase canonicalObject.
	objectClass := object class.

self anomaly: [ "This is at best a starting point.  I don't understan
		exception handling well enough to sort this out. Harmon, R."
	self conformingValue: [
			self signal: object
				onResume: objectClass]
		should: [:r| "Return Value" changed not & unchanged].
] forDialectAndTestCaseName: #(
	#(#'DO30' "2000/12/06 Harmon, R. Non-contiuable exept."
		#(#'ErrorTest' #'ExceptionTest'))).

	self setUp.
	self conformingValue: [
			self signal: object
				onResume: objectClass
				nestedOn: objectClass]
		should: [:r| "Return Value none" changed not & unchanged].

"From ExceptionANSITest >> #testXresumeX
	?? <signaledException>#resume: ??
	self resumedNotificationWithValue.
	self should: [changed and: [unchanged]].
	self setUp.
	changed := self resumedExceptionWithValue.
	self should: [changed and: [unchanged]]
"
!

testXretry
	" Exception <signaledException> "
	| object objectClass firstTime |
	self messageSelector: #'retry'.

	object := testCase canonicalObject.
	objectClass := object class.

	firstTime := true.
	self conformingValue: [
			[firstTime
				ifTrue: [object signal] 
				ifFalse: [changed := true]]
					on: objectClass 
					do: [:except|
						firstTime := false.
						except retry.
						unchanged := false]]
		should: [:r| changed and: [unchanged]]

"From ExceptionANSITest >> #testXretry
	?? <signaledException>#retry ??
	| firstTime |
	firstTime := true.
	[firstTime
		ifTrue: [Exception signal] 
		ifFalse: [changed := true]]
			on: Exception 
			do: [:except |
				firstTime := false.
				except retry.
				unchanged := false].
	self should: [changed and: [unchanged]]
"
!

testXretryUsingX
	" Exception <signaledException> "
	| object objectClass |
	self messageSelector: #'retryUsing:'.

	object := testCase canonicalObject.
	objectClass := object class.

	self conformingValue: [
			[object signal]
				on: objectClass
				do: [:except|
					except retryUsing: [changed := true].
					unchanged := false]]
		should: [:r| changed and: [unchanged]]

"From ExceptionANSITest >> #testXretryUsingX
	?? <signaledException>#retryUsing: ??
	[Exception signal]
		on: Exception
		do: [:except |
			except retryUsing: [changed := true].
			unchanged := false].
	self should: [changed and: [unchanged]]
"
!

testXreturn
	" Exception <signaledException> "
	| object objectClass |
	self messageSelector: #'return'.
	object := testCase canonicalObject.
	objectClass := object class.

	"Return nil as the value of the block protected
		by the active exception handler.
	This message does not return to its point of invocation."
	self conformingValue: [
			self signal: object
				returnOn: objectClass]
		should: [:r| r = nil & changed not & unchanged].

"From ExceptionANSITest >> #testXreturn
	?? <signaledException>#return ??
	value := 1.
	value := self exceptionReturn.
	self should: [value == nil and: [unchanged]]
"
!

testXreturnX
	" Exception <signaledException> "
	| object objectClass |
	self messageSelector: #'return:'.

	object := testCase canonicalObject.
	objectClass := object class.

	"Return the argument as the value of the block
		protected by the active exception handler.
	This message does not return to its point of invocation."

	self conformingValue: [
			[object signal]
				on: objectClass
				do: [:except|
					except return: true.
					unchanged := false]]
		should: [:r| r = true & changed not & unchanged].

"From ExceptionANSITest >> #testXreturnX
	?? <signaledException>#return: ??
	changed := [Exception signal]
		on: Exception
		do: [:except |
			except return: true.
			unchanged := false].
	self should: [changed and: [unchanged]]
"
! !

!SignaledExceptionHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SignaledExceptionHelper.st,v 1.1 2002/06/21 10:30:36 penk Exp $'
! !
