"{ Package: 'stx:goodies/ansiTests/common' }"

CollectionTest subclass:#StringTest
	instanceVariableNames:'abcdString emptyCollection magnitudeObjects'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!StringTest class methodsFor:'constants'!

canonicalCollection

	^self canonicalObject
!

canonicalElement

	^self canonicalObject at: 2
!

canonicalObject

	^String withAll: 'abcd'
!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^1              "DO30"
!

magnitudeObjects

	^Dictionary new
		at: #'small' put: 'aaa';
		at: #'medium' put: 'bbbb';
		at: #'large' put: 'zzzzz';
		yourself
!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<String>'
! !

!StringTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^true   "Has restrictions: DO30"
! !

!StringTest methodsFor:'constants'!

canonicalElement

	^abcdString at: 2
!

canonicalObject

	^abcdString copy
!

emptyCollection

	^emptyCollection copy
!

magnitudeObjects

	^magnitudeObjects
! !

!StringTest methodsFor:'helpers'!

setUp

	super setUp.
	abcdString := self class canonicalObject.
	emptyCollection := String new.
	magnitudeObjects := self class magnitudeObjects.
! !

!StringTest methodsFor:'testing'!

testXasString
	" Collection <String> "
	self messageSelector: #'asString'.

	self conformingValue: [abcdString asString]
		should: [:r| r == abcdString].
! !

!StringTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/StringTest.st,v 1.1 2002/06/21 10:25:56 penk Exp $'
! !
