"{ Package: 'stx:goodies/ansiTests/common' }"

CollectionTest subclass:#SymbolTest
	instanceVariableNames:'abcdSymbol emptyCollection magnitudeObjects'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-Collection'
!


!SymbolTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^1              "DO30"

!

magnitudeObjects

	^Dictionary new
		at: #'small' put: #'aaa';
		at: #'medium' put: #'bbbb';
		at: #'large' put: #'zzzzz';
		yourself
!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<symbol>'
! !

!SymbolTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^true   "Has restrictions: DO30"
! !

!SymbolTest methodsFor:'constants'!

canonicalElement

	^abcdSymbol at: 2
!

canonicalObject

	^abcdSymbol
!

emptyCollection

	^emptyCollection
!

magnitudeObjects

	^magnitudeObjects
! !

!SymbolTest methodsFor:'others'!

setUp

	super setUp.
	abcdSymbol := #'abcd'.
	emptyCollection := #''.
	magnitudeObjects := self class magnitudeObjects.

! !

!SymbolTest methodsFor:'testing'!

testXasString
	" Collection <symbol> "
	self messageSelector: #'asString'.

	"Definition: <readableString>
		Answer a string containing the same characters as the receiver,
		in their original order.
	Refinement: <symbol>
		Answer an object that is not identical to the receiver"
	self conformingValue: [abcdSymbol asString]
		should: [:r| (r = 'abcd') & (r ~~ abcdSymbol)].
!

testXasSymbol
	" Collection <symbol> "
	self messageSelector: #'asSymbol'.

	self conformingValue: [abcdSymbol asSymbol]
		should: [:r| r == abcdSymbol].
! !

!SymbolTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SymbolTest.st,v 1.1 2002/06/21 10:25:24 penk Exp $'
! !
