"{ Package: 'stx:goodies/ansiTests/common' }"

MainTestCase subclass:#SysProGroup
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-System-Protocols'
!


!SysProGroup methodsFor:'private'!

addAndDefineBehaviorOfJnkProtos
	"Private - Common protocol creation and deletion code used only by subclasses."

	self addJnkProtoFactory.

SysProProtocolsManager protocol: '<JnkProto factory>'
	defineBehaviorOfMetaclassesOfClasses: 'Object'.

SysProProtocolsManager protocol: '<JnkProto factory>'
	section: 'Description'
	text: 'Represents a System Protocols SUnits test protocol.
'.

SysProProtocolsManager	protocol: '<JnkProto factory>'
	newSelector: 'new'
	parameters: #()
	returnValues: #('<JnkProto> new').

SysProProtocolsManager protocol: '<JnkProto factory>'
	selector: 'new'
	section: 'Synopsis'
	text: 'Answer a new junk object.
'.

SysProProtocolsManager protocol: '<JnkProto factory>'
	selector: 'new'
	section: 'Definition'
	text: 'The object new is junk.
'.

SysProProtocolsManager protocol: '<JnkProto factory>'
	selector: 'new'
	section: 'Errors'
	text: 'If junk is not allowed.
'.

	self addJnkProto.
	self defineJnkProtoBehaviorOfClasses.

SysProProtocolsManager protocol: '<JnkProto>'
	defineBehaviorOfClasses: 'Array Integer'.

	self addDescSecOfJnkProto.

SysProProtocolsManager	protocol: '<JnkProto>'
	newSelector: 'selector'
	parameters: #()
	returnRule: '[ :receiver |	"Sample comment"
	SysProProtocolsManager unaryReturnProtocolIdReceiver: receiver]'.

SysProProtocolsManager protocol: '<JnkProto>'
	selector: 'selector'
	section: 'Synopsis'
	text: 'A System Protocols SUnits test protocol message with rule return.
'.

	self addJnkProtoXselectorParm1.

SysProProtocolsManager protocol: '<JnkProto>'
	selector: 'selectorParm1:'
	section: 'Synopsis'
	text: 'A System Protocols SUnits test protocol message with parm.
'.

SysProProtocolsManager	protocol: '<JnkProto>'
	newSelector: 'selectorParm1:parm2:'
	parameters: #('parm1 <collection> unspecified'
		'parm2 <symbol> captured')
	returnValues: #().

SysProProtocolsManager protocol: '<JnkProto>'
	selector: 'selectorParm1:parm2:'
	section: 'Synopsis'
	text: 'A System Protocols SUnits test protocol message with 2 parms.
'.
!

addDescSecOfJnkProto
	"Private - Common protocol creation and deletion code used only by subclasses."

	SysProProtocolsManager protocol: '<JnkProto>'
		section: 'Description'
		text: 'Represents a 2nd. System Protocols SUnits test protocol.
'.
!

addJnkProto
	"Private - Common protocol creation and deletion code used only by subclasses."

	SysProProtocolsManager
		newProtocol: '<JnkProto>'
		conformsToProtocols: '<nil>, <UndefProto1>'
		protocolGroup: 'Junk Group'
!

addJnkProtoFactory
	"Private - Common protocol creation and deletion code used only by subclasses."

	SysProProtocolsManager
		newProtocol: '<JnkProto factory>'
		conformsToProtocols: '<Object class>'
		protocolGroup: 'Junk Group'
!

addJnkProtoXselectorParm1
	"Private - Common protocol creation and deletion code used only by subclasses."

	SysProProtocolsManager
		protocol: '<JnkProto>'
		newSelector: 'selectorParm1:'
		parameters: #('operand <UndefProto1>|<UndefProto2> uncaptured')
		returnValues: #('<JnkProto> new'
			'<nil> unspecified')
!

defineJnkProtoBehaviorOfClasses
	"Private - Common protocol creation and deletion code used only by subclasses."

	SysProProtocolsManager
		protocol: '<JnkProto>'
		defineBehaviorOfClasses: 'Array Integer'.
!

removeJnkProto
	"Private - Common protocol creation and deletion code used only by subclasses."

	ProtoMgr removeProtocolId: #'<JnkProto>'
!

removeJnkProtoFactory
	"Private - Common protocol creation and deletion code used only by subclasses."

	ProtoMgr removeProtocolId: #'<JnkProto factory>'
!

targetDefineString
	"Private - Common protocol creation result used only by subclasses."

	^'SysProProtocolsManager protocol: ''<JnkProto factory>''
	defineBehaviorOfMetaclassesOfClasses: ''Object''!!

SysProProtocolsManager protocol: ''<JnkProto>''
	defineBehaviorOfClasses: ''Array Integer''!!

'
!

targetProtocolIds
	"Private - Common protocol test result used only by subclasses."

	^#(#'<JnkProto factory>' #'<JnkProto>')
!

targetProtocolsString
	"Private - Common protocol creation result used only by subclasses."

	^'SysProProtocolsManager newProtocol: ''<JnkProto factory>''
	conformsToProtocols: ''<Object class>''
	protocolGroup: ''Junk Group''!!

SysProProtocolsManager protocol: ''<JnkProto factory>''
	section: ''Description''
	text: ''Represents a System Protocols SUnits test protocol.
''!!

SysProProtocolsManager	protocol: ''<JnkProto factory>''
	newSelector: ''new''
	parameters: #()
	returnValues: #(''<JnkProto> new'')!!

SysProProtocolsManager protocol: ''<JnkProto factory>''
	selector: ''new''
	section: ''Definition''
	text: ''The object new is junk.
''!!

SysProProtocolsManager protocol: ''<JnkProto factory>''
	selector: ''new''
	section: ''Errors''
	text: ''If junk is not allowed.
''!!

SysProProtocolsManager protocol: ''<JnkProto factory>''
	selector: ''new''
	section: ''Synopsis''
	text: ''Answer a new junk object.
''!!

SysProProtocolsManager newProtocol: ''<JnkProto>''
	conformsToProtocols: ''<nil>, <UndefProto1>''
	protocolGroup: ''Junk Group''!!

SysProProtocolsManager protocol: ''<JnkProto>''
	section: ''Description''
	text: ''Represents a 2nd. System Protocols SUnits test protocol.
''!!

SysProProtocolsManager	protocol: ''<JnkProto>''
	newSelector: ''selector''
	parameters: #()
	returnRule: ''[ :receiver |	"Sample comment"
	SysProProtocolsManager unaryReturnProtocolIdReceiver: receiver]''!!

SysProProtocolsManager protocol: ''<JnkProto>''
	selector: ''selector''
	section: ''Synopsis''
	text: ''A System Protocols SUnits test protocol message with rule return.
''!!

SysProProtocolsManager	protocol: ''<JnkProto>''
	newSelector: ''selectorParm1:''
	parameters: #(''operand <UndefProto1>|<UndefProto2> uncaptured'')
	returnValues: #(''<JnkProto> new''
		''<nil> unspecified'')!!

SysProProtocolsManager protocol: ''<JnkProto>''
	selector: ''selectorParm1:''
	section: ''Synopsis''
	text: ''A System Protocols SUnits test protocol message with parm.
''!!

SysProProtocolsManager	protocol: ''<JnkProto>''
	newSelector: ''selectorParm1:parm2:''
	parameters: #(''parm1 <collection> unspecified''
		''parm2 <symbol> captured'')
	returnValues: #()!!

SysProProtocolsManager protocol: ''<JnkProto>''
	selector: ''selectorParm1:parm2:''
	section: ''Synopsis''
	text: ''A System Protocols SUnits test protocol message with 2 parms.
''!!

'
! !

!SysProGroup class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SysProGroup.st,v 1.1 2002/06/21 11:07:28 penk Exp $'
! !
