"{ Package: 'stx:goodies/ansiTests/common' }"

SysProMessageAbstractReturn subclass:#SysProMessageByRuleReturn
	instanceVariableNames:'returnValueRuleBlockSourceCode ruleBlock'
	classVariableNames:''
	poolDictionaries:''
	category:'System-Protocols'
!


!SysProMessageByRuleReturn class methodsFor:'instance creation'!

newRetValRuleSourceCode: returnValueRuleSource 
	"Answer a new message by-rule return value."

	(returnValueRuleSource includes: $^) ifTrue: [
		^self error: 'Protocol message return value rule source may not contain a "^".'].
	^self basicNew
		setNewRuleBlockFromRuleSourceCode: returnValueRuleSource;
	 	yourself
! !

!SysProMessageByRuleReturn methodsFor:'accessing'!

returnProtocolIdRuleReceiver: receiver
	"Answer the receiver's protocol message return value protocol identifier depending on the parameter, receiver, the receiver of the protocol message."

	^self ruleBlock value: receiver
!

returnProtocolIdRuleReceiver: receiver operand: operand
	"Answer the receiver's protocol message return value protocol identifier depending on the parameters, receiver and operand, the receiver and operand of the protocol message."

	^self ruleBlock value: receiver value: operand
!

returnValueRuleBlockSourceCode
	"Answer the receiver's rule block source code."

	^returnValueRuleBlockSourceCode
!

ruleBlock
	"Answer the receiver's protocol message return value rule block."

	^ruleBlock
! !

!SysProMessageByRuleReturn methodsFor:'displaying'!

displayOn: target 
	"Write to a stream a textual description of the receiver as a user would want to see it."

	target
		nextPutAll: 'a rule'
!

displayString
	"Answer a string that describes the receiver as a user would want to see it."
	| aStream |
	aStream := WriteStream with: String new.
	self displayOn: aStream.
	^aStream contents
! !

!SysProMessageByRuleReturn methodsFor:'printing'!

printOn: target 
	"Write to a stream a textual description of the receiver as a developer would want to see it."

	super printOn: target.
	target
		nextPut: $(;
		space;
		nextPutAll: self returnValueRuleBlockSourceCode;
		space;
		nextPut: $)
! !

!SysProMessageByRuleReturn methodsFor:'private'!

setNewRuleBlockFromRuleSourceCode: ruleBlockSource 
	"Private - Set the initial state of the receiver."
	| errStr |
	"Dialect specific:"
	ruleBlock := Compiler evaluate: ruleBlockSource logged: false.
	ruleBlock isNil ifTrue: [
		^self error: errStr].
	returnValueRuleBlockSourceCode := ruleBlockSource.
! !

!SysProMessageByRuleReturn class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SysProMessageByRuleReturn.st,v 1.1 2002/06/21 11:07:18 penk Exp $'
! !
