"{ Package: 'stx:goodies/ansiTests/common' }"

SysProGroup subclass:#SysProMessageByRuleReturnTest
	instanceVariableNames:'numberXintegerPartRuleBlk numberXmulPartRuleBlk'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-System Protocols'
!


!SysProMessageByRuleReturnTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<SysProMessageByRuleReturn>'
! !

!SysProMessageByRuleReturnTest methodsFor:'constants'!

canonicalObject

	^numberXintegerPartRuleBlk
! !

!SysProMessageByRuleReturnTest methodsFor:'helpers'!

setUp
	| proto |
	super setUp.
	proto := (ProtoMgr protocolId: #'<number>').

	numberXintegerPartRuleBlk := (proto messageAtSelector: #'integerPart')
		returnValueWithRule.
	numberXmulPartRuleBlk := (proto messageAtSelector: #'*')
		returnValueWithRule.
! !

!SysProMessageByRuleReturnTest methodsFor:'private'!

numberXintegerPartRulePrintString

	^'a SysProMessageByRuleReturn( ', self numberXintegerPartRuleString, ' )'
!

numberXintegerPartRuleString

	^'[ :receiver |	| returnTypeTable |
	"receiver		| result
	------------------|------------------
	<rational>		|<rational>
	------------------|------------------
	<scaledDecimal>	| <scaledDecimal>
	------------------|------------------
	<Float>		| <Float>"

	returnTypeTable := Dictionary new.
	returnTypeTable at: #''<integer>'' put: #''<rational>''.
	returnTypeTable at: #''<Fraction>'' put: #''<rational>''.
	returnTypeTable at: #''<scaledDecimal>'' put: #''<scaledDecimal>''.
	returnTypeTable at: #''<Float>'' put: #''<Float>''.

	returnTypeTable at: (SysProProtocolsManager numericInstanceProtocolId: receiver)]'
! !

!SysProMessageByRuleReturnTest methodsFor:'testing'!

testXdisplayOnX
	" System Protocols <SysProMessageByRuleReturn> "
	| aStream |
	self messageSelector: #'displayOn:'.

	aStream := WriteStream with: String new.

	self conformingValue: [numberXintegerPartRuleBlk displayOn: aStream]
		should: [:r| aStream contents = 'a rule']. 
!

testXdisplayString
	" System Protocols <SysProMessageByRuleReturn> "
	self messageSelector: #'displayString'.

	self conformingValue: [numberXintegerPartRuleBlk displayString]
		should: [:r| r = 'a rule'].
!

testXprintString
	" System Protocols <SysProMessageByRuleReturn> "
	self messageSelector: #'printString'.

	self conformingValue: [numberXintegerPartRuleBlk printString]
		should: [:r| r = self numberXintegerPartRulePrintString].
!

testXreturnProtocolIdRuleReceiverX
	" System Protocols <SysProMessageByRuleReturn> "
	self messageSelector: #'returnProtocolIdRuleReceiver:'.

	self conformingValue: [
			numberXintegerPartRuleBlk returnProtocolIdRuleReceiver: 1.5]
		should: [:r| r = #'<Float>'].

	self conformingValue: [
			numberXintegerPartRuleBlk returnProtocolIdRuleReceiver: 1]
		should: [:r| r = #'<rational>'].
!

testXreturnProtocolIdRuleReceiverXoperandX
	" System Protocols <SysProMessageByRuleReturn> "
	self messageSelector: #'returnProtocolIdRuleReceiver:operand:'.

	self conformingValue: [
			numberXmulPartRuleBlk
				returnProtocolIdRuleReceiver: 1.5
				operand: 1]
		should: [:r| r = #'<Float>'].

	self conformingValue: [
			numberXmulPartRuleBlk
				returnProtocolIdRuleReceiver: 1
				operand: 1]
		should: [:r| r = #'<integer>'].
!

testXreturnValueRuleBlockSourceCode
	" System Protocols <SysProMessageByRuleReturn> "
	self messageSelector: #'returnValueRuleBlockSourceCode'.

	self conformingValue: [
			numberXintegerPartRuleBlk returnValueRuleBlockSourceCode]
		should: [:r| r = self numberXintegerPartRuleString].
!

testXruleBlock
	" System Protocols <SysProMessageByRuleReturn> "
	self messageSelector: #'ruleBlock'.

	self conformingValue: [numberXintegerPartRuleBlk ruleBlock]
		should: [:r| r argumentCount = 1].
! !

!SysProMessageByRuleReturnTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SysProMessageByRuleReturnTest.st,v 1.1 2002/06/21 10:26:04 penk Exp $'
! !
