"{ Package: 'stx:goodies/ansiTests/common' }"

SysProGroup subclass:#SysProMessageParameterFactoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-System Protocols'
!


!SysProMessageParameterFactoryTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<SysProMessageParameter factory>'
! !

!SysProMessageParameterFactoryTest methodsFor:'constants'!

canonicalObject

	^SysProMessageParameter class
! !

!SysProMessageParameterFactoryTest methodsFor:'testing'!

testXnewParmNameXprotocolIdsXaliasingX
	" System Protocols <SysProMessageParameter factory> "
	self messageSelector: #'newParmName:protocolIds:aliasing:'.

	self conformingValue: [
			SysProMessageParameter
				newParmName: 'operand'
				protocolIds: #(#'<UndefProto1>' #'<UndefProto2>')
				aliasing: #'uncaptured']
		should: [:r | (r parmName = 'operand')
			& (r parmProtocolIds asSortedCollection asArray = #(#'<UndefProto1>' #'<UndefProto2>'))
			& (r parmAliasingAttribute == #'uncaptured')]. 

	"Errors: The protocol message parameter aliasing attribute
	is not valid."
	self should: [
			SysProMessageParameter
				newParmName: 'operand'
				protocolIds: #(#'<UndefProto1>')
				aliasing: 'junk']
		raise: TestResult error.
! !

!SysProMessageParameterFactoryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SysProMessageParameterFactoryTest.st,v 1.1 2002/06/21 10:38:28 penk Exp $'
! !
