"{ Package: 'stx:goodies/ansiTests/common' }"

SysProGroup subclass:#SysProMessageParameterTest
	instanceVariableNames:'parmXquoXoperand'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-System Protocols'
!


!SysProMessageParameterTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<SysProMessageParameter>'
! !

!SysProMessageParameterTest methodsFor:'constants'!

canonicalObject

	^parmXquoXoperand
! !

!SysProMessageParameterTest methodsFor:'helpers'!

setUp

	super setUp.
	parmXquoXoperand := ((ProtoMgr protocolId: #'<number>')
		messageAtSelector: #'quo:'
	) parameterList at: 1.
! !

!SysProMessageParameterTest methodsFor:'testing'!

testXdisplayOnX
	" System Protocols <SysProMessageParameter> "
	| aStream |
	self messageSelector: #'displayOn:'.

	aStream := WriteStream with: String new.

	self conformingValue: [parmXquoXoperand displayOn: aStream]
		should: [:r| aStream contents = 'operand <number> unspecified']. 
!

testXdisplayString
	" System Protocols <SysProMessageParameter> "
	self messageSelector: #'displayString'.

	self conformingValue: [parmXquoXoperand displayString]
		should: [:r| r = 'operand <number> unspecified']. 
!

testXparmAliasingAttribute
	" System Protocols <SysProMessageParameter> "
	self messageSelector: #'parmAliasingAttribute'.

	self conformingValue: [parmXquoXoperand parmAliasingAttribute]
		should: [:r| r = #'unspecified'].
!

testXparmName
	" System Protocols <SysProMessageParameter> "
	self messageSelector: #'parmName'.

	self conformingValue: [parmXquoXoperand parmName]
		should: [:r| r = 'operand'].
!

testXparmProtocolIds
	" System Protocols <SysProMessageParameter> "
	| parmXminusOpXoperand |
	self messageSelector: #'parmProtocolIds'.

	self conformingValue: [parmXquoXoperand parmProtocolIds]
		should: [:r| r asArray = #(#'<number>')].

	parmXminusOpXoperand := ((ProtoMgr protocolId: #'<DateAndTime>')
		messageAtSelector: #'-'
	) parameterList at: 1.
	self conformingValue: [parmXminusOpXoperand parmProtocolIds]
		should: [:r| r asSortedCollection asArray
			= #(#'<DateAndTime>' #'<Duration>')].
!

testXprintString
	" System Protocols <SysProMessageParameter> "
	self messageSelector: #'printString'.

	self conformingValue: [parmXquoXoperand printString]
		should: [:r| r = 'a SysProMessageParameter(operand)'].
!

testXstoreAsSingleStringOnX
	" System Protocols <SysProMessageParameter> "
	| aStream |
	self messageSelector: #'storeAsSingleStringOn:'.

	aStream := WriteStream with: String new.

	self conformingValue: [parmXquoXoperand storeAsSingleStringOn: aStream]
		should: [:r| aStream contents = '''operand <number> unspecified''']. 
! !

!SysProMessageParameterTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SysProMessageParameterTest.st,v 1.1 2002/06/21 10:24:45 penk Exp $'
! !
