"{ Package: 'stx:goodies/ansiTests/common' }"

SysProMessageAbstractReturn subclass:#SysProMessageReturn
	instanceVariableNames:'returnValueProtocolId returnValueAliasingAttribute'
	classVariableNames:'ReturnAliasingAttributesConst'
	poolDictionaries:''
	category:'System-Protocols'
!


!SysProMessageReturn class methodsFor:'instance creation'!

newRetValProtocolId: protocolSpec aliasing: attributeSpec 
	"Answer a new message return value."
	| aliasingAttribute |
	aliasingAttribute := attributeSpec asSymbol.
	(ReturnAliasingAttributesConst includes: aliasingAttribute) ifFalse: [
		^self error: 'Protocol message return value aliasing attribute not valid.'].
	^super basicNew
		setNewProtocolId: protocolSpec
		aliasing: aliasingAttribute
! !

!SysProMessageReturn class methodsFor:'constants/aliasing attributes'!

initialize
	"Class initialization.
	 
		SysProMessageReturn initialize
	"
	"Initialize the list of protocol message return value aliasing attribute constants:"
	ReturnAliasingAttributesConst := Set
		with: #'new'
		with: #'state'
		with: #'unspecified'.
! !

!SysProMessageReturn methodsFor:'accessing'!

returnValueAliasingAttribute
	"Answer the receiver's aliasing attribute."

	^returnValueAliasingAttribute
!

returnValueProtocolId
	"Answer the receiver's protocol identifier."

	^returnValueProtocolId
! !

!SysProMessageReturn methodsFor:'displaying'!

displayOn: target 
	"Write to a stream a textual description of the receiver as a user would want to see it."

	target
		nextPutAll: returnValueProtocolId;
		space;
		nextPutAll: returnValueAliasingAttribute
!

displayString
	"Answer a string that describes the receiver as a user would want to see it."
	| aStream |
	aStream := WriteStream with: String new.
	self displayOn: aStream.
	^aStream contents
! !

!SysProMessageReturn methodsFor:'filing'!

storeAsSingleStringOn: target
	"Store the receiver as a single string on target."

	target
		nextPut: $';
		nextPutAll: returnValueProtocolId asString;
		space;
		nextPutAll: returnValueAliasingAttribute;
		nextPut: $'.
! !

!SysProMessageReturn methodsFor:'printing'!

printOn: target 
	"Write to a stream a textual description of the receiver as a developer would want to see it."

	super printOn: target.
	target
		nextPut: $(;
		nextPutAll: returnValueProtocolId;
		space;
		nextPutAll: returnValueAliasingAttribute;
		nextPut: $)
! !

!SysProMessageReturn methodsFor:'private'!

setNewProtocolId: protocolId aliasing: aliasingAttribute 
	"Private - Set the initial state of the receiver."

	returnValueProtocolId := protocolId asSymbol.
	returnValueAliasingAttribute := aliasingAttribute asSymbol
! !

!SysProMessageReturn class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SysProMessageReturn.st,v 1.1 2002/06/21 11:08:29 penk Exp $'
! !
SysProMessageReturn initialize!
