"{ Package: 'stx:goodies/ansiTests/common' }"

SysProGroup subclass:#SysProMessageReturnTest
	instanceVariableNames:'retValStringXnew'
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-System Protocols'
!


!SysProMessageReturnTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<SysProMessageReturn>'
! !

!SysProMessageReturnTest methodsFor:'constants'!

canonicalObject

	^retValStringXnew
! !

!SysProMessageReturnTest methodsFor:'helpers'!

setUp
	| proto |
	super setUp.
	proto := (ProtoMgr protocolId: #'<Character>').
	retValStringXnew := (proto messageAtSelector: #'asString')
		returnValueList at: 1
! !

!SysProMessageReturnTest methodsFor:'testing'!

testXdisplayOnX
	" System Protocols <SysProMessageReturn> "
	| aStream |
	self messageSelector: #'displayOn:'.

	aStream := WriteStream with: String new.

	self conformingValue: [retValStringXnew displayOn: aStream]
		should: [:r| aStream contents = '<String> new']. 

!

testXdisplayString
	" System Protocols <SysProMessageReturn> "
	self messageSelector: #'displayString'.

	self conformingValue: [retValStringXnew displayString]
		should: [:r| r = '<String> new'].
!

testXprintString
	" System Protocols <SysProMessageReturn> "
	self messageSelector: #'printString'.


	self conformingValue: [retValStringXnew printString]
		should: [:r| r = 'a SysProMessageReturn(<String> new)'].
!

testXreturnValueAliasingAttribute
	" System Protocols <SysProMessageReturn> "
	self messageSelector: #'returnValueAliasingAttribute'.

	self conformingValue: [retValStringXnew returnValueAliasingAttribute]
		should: [:r| r = #'new'].
!

testXreturnValueProtocolId
	" System Protocols <SysProMessageReturn> "
	self messageSelector: #'returnValueProtocolId'.

	self conformingValue: [retValStringXnew returnValueProtocolId]
		should: [:r| r = #'<String>'].
!

testXstoreAsSingleStringOnX
	" System Protocols <SysProMessageReturn> "
	| aStream |
	self messageSelector: #'storeAsSingleStringOn:'.

	aStream := WriteStream with: String new.

	self conformingValue: [retValStringXnew storeAsSingleStringOn: aStream]
		should: [:r| aStream contents = '''<String> new''']. 
! !

!SysProMessageReturnTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SysProMessageReturnTest.st,v 1.1 2002/06/21 10:28:56 penk Exp $'
! !
