"{ Package: 'stx:goodies/ansiTests/common' }"

SysProGroup subclass:#SysProProtocolMessageFactoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-ANSI-System Protocols'
!


!SysProProtocolMessageFactoryTest class methodsFor:'constants'!

protocolId
	"Answer the protocol identifier of the protocol the receiver tests."

	^#'<SysProProtocolMessage factory>'
! !

!SysProProtocolMessageFactoryTest methodsFor:'constants'!

canonicalObject

	^SysProProtocolMessage class
! !

!SysProProtocolMessageFactoryTest methodsFor:'testing'!

testXnewMessageSelectorXparametersXreturnRuleX
	" System Protocols <SysProProtocolMessage factory> "
	self messageSelector: #'newMessageSelector:parameters:returnRule:'.

	self conformingValue: [
			SysProProtocolMessage
				newMessageSelector: #'selector'
				parameters: #()
				returnRule: '[ :receiver |	"Sample comment"
	SysProProtocolsManager unaryReturnProtocolIdReceiver: receiver]']
		should: [:r | r messageSelector == #'selector']. 

	"Errors: The protocol message parameter aliasing attribute
	is not valid."
	self should: [
			SysProProtocolMessage
				newMessageSelector: 'selector2:'
				parameters: #('operand <JunkProto3> junk')
				returnRule: '[ :receiver | self]']
		raise: TestResult error.

	"Errors: The protocol message return value rule block source
	will not compile."
	self should: [
			SysProProtocolMessage
				newMessageSelector: #'selector'
				parameters: #()
				returnRule: '[ :receiver | "Will not compile"
					eceiver = self]']
		raise: TestResult error.

	"Errors: The protocol message return value rule block source
	contains a '^'."
	self should: [
			SysProProtocolMessage
				newMessageSelector: 'selector3:'
				parameters: #('operand <JunkProto3> uncaptured')
				returnRule: '[ :receiver | ^self]']
		raise: TestResult error.
!

testXnewMessageSelectorXparametersXreturnValuesX
	" System Protocols <SysProProtocolMessage factory> "
	self messageSelector: #'newMessageSelector:parameters:returnValues:'.

	self conformingValue: [
			SysProProtocolMessage
				newMessageSelector: #'selectorParm1:'
				parameters: #('operand <UndefProto1>|<UndefProto2> uncaptured')
				returnValues: #('<JnkProto>	new'
					'<nil>	unspecified')]
		should: [:r| r messageSelector == #'selectorParm1:']. 

	"Errors: The protocol message parameter or return value
	aliasing attribute is not valid."
	self should: [
			SysProProtocolMessage
				newMessageSelector: 'selector2:'
				parameters: #('operand <UndefProto1> junk')
				returnValues: #()]
		raise: TestResult error.

	self should: [
			SysProProtocolMessage
				newMessageSelector: 'selector3:'
				parameters: #('operand <UndefProto1> uncaptured')
				returnValues: #('<JnkProto>	junk')]
		raise: TestResult error.
! !

!SysProProtocolMessageFactoryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/SysProProtocolMessageFactoryTest.st,v 1.1 2002/06/21 10:29:04 penk Exp $'
! !
