"{ Package: 'stx:goodies/ansiTests/common' }"

TestCase subclass:#TestCaseHelperTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tests-SUnitProtocolFramework'
!


!TestCaseHelperTest methodsFor:'helpers'!

setUp

	super setUp.

	"Add dummy protocol for testing:"
	self addUsingAndHelperProtos.
	"Set the protocol this class tests:"
	MainUsingProtocolsTest protocolId: #'<usingProtocolsTest>'.
!

tearDown
	"Nil out the protocol the main test class tests so it will be bypassed
		when asked for suite of tests, and other class inst. vars.:"
	MainUsingProtocolsTest initializeClassInstVars.

	"Remove dummy protocols:"
	self delUsingAndHelperProtos.
! !

!TestCaseHelperTest methodsFor:'private'!

addUsingAndHelperProtos
	"Private - Add <usingProtocolsTest> to use in testing."
	SysProProtocolsManager
		newProtocol: '<usingProtocolsTest>'
		conformsToProtocols: '<aHelperProto>'
		protocolGroup: 'Junk Group'.

	SysProProtocolsManager
		newProtocol: '<aHelperProto>'
		conformsToProtocols: '<ANY>'
		protocolGroup: 'Junk Group'.

!

delUsingAndHelperProtos
	"Private - Remove dummy <usingProtocolsTest> and <aHelperProto> used in testing."
	(SysProProtocolsManager curMgr
			includesProtocolId:  #'<usingProtocolsTest>'
	) ifTrue: [
		SysProProtocolsManager curMgr
			removeProtocolId: #'<usingProtocolsTest>'].

	(SysProProtocolsManager curMgr
			includesProtocolId:  #'<aHelperProto>'
	) ifTrue: [
		SysProProtocolsManager curMgr
			removeProtocolId: #'<aHelperProto>'].
! !

!TestCaseHelperTest methodsFor:'testing'!

testClsXselectorXattachedToXconformsToProtocolIdX
	| newMainTestCase res |
	newMainTestCase := HelperUsingProtocolsTest
		selector: 'selectorXattachedToXconformsToProtocolIdX'
		attachedTo: MainUsingProtocolsTest
		conformsToProtocolId: '<aHelperProto>'.
	res := newMainTestCase run.
	self should: [res hasPassed].
!

testXanomalyXforDialectAndTestCaseNameX
	| newMainTestCase res |

	newMainTestCase := HelperUsingProtocolsTest
		selector: 'testXanomalyXforDialectAndTestCaseNameX'
		attachedTo: MainUsingProtocolsTest
		conformsToProtocolId: '<aHelperProto>'.
	res := newMainTestCase run.
	self should: [res hasPassed].
!

testXconformingAssertMessageSelector
	| res newMainTestCase |
	SysProProtocolsManager
		protocol: '<aHelperProto>'
		newSelector: 'asLowercase'
		parameters: #()
		returnValues: #('<String> unspecified').

	MainUsingProtocolsTest canonicalObject: 'bozo' copy.
	newMainTestCase := HelperUsingProtocolsTest
		selector: 'testXconformingAssertMessageSelector'
		attachedTo: MainUsingProtocolsTest
		conformsToProtocolId: '<aHelperProto>'.
	res := newMainTestCase run.
	self should: [res hasPassed].
!

testXprintOnX
	| aStream newMainTestCase |

	newMainTestCase := HelperUsingProtocolsTest
		selector: 'testXprintOnX'
		attachedTo: MainUsingProtocolsTest
		conformsToProtocolId: '<aHelperProto>'.
	aStream := WriteStream with: String new.
	newMainTestCase printOn: aStream.
	self should: [aStream contents = 'MainUsingProtocolsTest>>testXprintOnX'].
!

testXrunCase

	TestCaseUsingProtocols signalNotDone ifTrue: [self error: 'not done']
!

testXrunCaseAsFailure

	TestCaseUsingProtocols signalNotDone ifTrue: [self error: 'not done']
! !

!TestCaseHelperTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/ansiTests/common/TestCaseHelperTest.st,v 1.1 2002/06/21 10:30:52 penk Exp $'
! !
