"{ Package: 'stx:goodies/ansiTests/common' }"
!

!PositionableStream methodsFor:'accessing'!

nextToken
	"Answer a <readableString>, the next token in the receiver's element stream, delimited by elements which answer true to #isSeparator., or <nil> if there are no more tokens in the receiver."
	| startPos len |
	#'SysPro'. "1999/12/02 Harmon, R. A. 	Fixed error & changed to return nil if no more tokens to conform to other impls."
	self skipSeparators.
	self atEnd ifTrue: [
		^nil].
	startPos := self position.
	len := 0.
	[self atEnd] whileFalse: [
		self next isSeparator ifTrue: [
			self position: startPos.
			^self next: len].
		len := len + 1].
	self position: startPos.
	^self next: len
! !

!SequenceableCollection methodsFor:'converting'!

asANSITestArray
	"Answer a copy of the receiver with boolean objects substituted for all instances of #'true' or #'false' symbols."
	#'ProtoFramework'. "2000/06/23 Harmon, R. Added to Ralph E. Johnson's CS II VW release."

	^self collect: [:each |
		each collect: [:each1 |
			each1 = #'true'
				ifTrue: [true]
				ifFalse: [each1 = #'false'
					ifTrue: [false]
					ifFalse: [each1]]]]
! !

