"{ Package: 'stx:goodies/ansiTests/stx' }"
!

!ArrayTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^self error: 'Has no restrictions.'.    "DO30"
! !

!ArrayTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^false  "Has no restrictions: DO30"
! !

!BagTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^nil            "DO30"
! !

!BagTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^true   "Has restrictions: DO30"
! !

!ByteArrayTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^'xxx'  "Has restrictions: DO30"
! !

!ByteArrayTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^true   "Has restrictions: DO30"
! !

!Collection methodsFor:'accessing'!

any
	self do: [:each | ^each].
	self error: 'not any'
! !

!DictionaryTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^self error: 'Has no restrictions.'.    "DO30"
! !

!DictionaryTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^false  "Has no restrictions: DO30"
! !

!IdentityDictionaryTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^self error: 'Has no restrictions.'.    "DO30"
! !

!IdentityDictionaryTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^false  "Has no restrictions: DO30"
! !

!IntervalTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^self error: 'Has no restrictions.'.    "DO30"
! !

!IntervalTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^false  "Has no restrictions: DO30"
! !

!OrderedCollectionTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^self error: 'Has no restrictions.'.    "DO30"
! !

!OrderedCollectionTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^false  "Has no restrictions: DO30"
! !

!SetTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^self error: 'Has no restrictions.'.    "DO30"
! !

!SetTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^false  "Has no restrictions: DO30"
! !

!SortedCollectionTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^self error: 'Has no restrictions.'.    "DO30"
! !

!SortedCollectionTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^false  "Has no restrictions: DO30"
! !

!StringTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^1              "DO30"
! !

!StringTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^true   "Has restrictions: DO30"
! !

!SymbolTest class methodsFor:'constants'!

limitedElementTypes
	"Answer an object that can NOT be put in receiver class being tested collection, or signal an error if this dialect has no restrictions."

	^1              "DO30"

! !

!SymbolTest class methodsFor:'public'!

returnTypeHasLimitedElementTypes
	"Answer a <boolean> whether the receiver class being tested restricts the objects that can be put in its collection."

	^true   "Has restrictions: DO30"
! !

!WriteStream methodsFor:'accessing'!

nextPutChunk: chunkString
	"Append the <readableString>, chunkString, to the receiver's stream, doubling embedded terminators."
	| chunkTerminator |
	#'SysPro'. "2001/02/02 Harmon, R. A. Added System Protocols support." 
	chunkTerminator := $!!.
	(chunkString identityIncludes: chunkTerminator)
		ifTrue: [
			chunkString do: [ :character |
				self nextPut: character.
				character == chunkTerminator ifTrue: [
					self nextPut: chunkTerminator]]]
		ifFalse: [self nextPutAll: chunkString].
	self nextPut: chunkTerminator; cr.
! !

