"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/authentication' }"

"{ NameSpace: Authentication }"

Object subclass:#AuthenticationData
	instanceVariableNames:'encodedSecret'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Authentication'
!

!AuthenticationData class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    This is an abstract superclass.
    Subclasses hold authentication data for a user (secret/password). 
    Authenticators are repsonsible to authenticate this data.

    [author:]
        Stefan Vogel (stefan@zwerg)

    [instance variables:]

    [class variables:]

    [see also:]
        Authentication::Authenticator
        Authentication::User
"
! !

!AuthenticationData class methodsFor:'instance creation'!

newForUser:user secret:aSecretString
    "create an instance of myself with secret"

    ^ self new user:user secret:aSecretString
!

newMechanism:mechanismName
    "create an empty instance for a given mechanism"

    ^ (Authenticator authenticatorClassNamed:mechanismName) newAuthenticationData
! !

!AuthenticationData class methodsFor:'queries'!

mechanismName
    "answer the name of the mechanism as known in the protocols"

    self subclassResponsibility
! !

!AuthenticationData methodsFor:'accessing'!

encodedSecret
    ^ encodedSecret
!

encodedSecret:something
    encodedSecret := something.
!

user:user secret:something
    "encode the secret for user and store it"

    self subclassResponsibility
! !

!AuthenticationData methodsFor:'comparing'!

= authenticationData    
    ^ self class == authenticationData class 
        and:[encodedSecret = authenticationData encodedSecret]
!

hash
    ^ encodedSecret hash
! !

!AuthenticationData methodsFor:'storing'!

storeOn:aStream
    aStream nextPutAll:'((Authentication::AuthenticationData newMechanism:'.
    self class mechanismName storeOn:aStream.
    aStream nextPutAll:') encodedSecret:'. 
    encodedSecret storeOn:aStream.
    aStream nextPut:$).
! !

!AuthenticationData class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/authentication/Authentication__AuthenticationData.st,v 1.5 2009/11/09 13:55:52 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/authentication/Authentication__AuthenticationData.st,v 1.5 2009/11/09 13:55:52 stefan Exp $'
! !
