"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/authentication' }"

"{ NameSpace: Authentication }"

Object subclass:#User
	instanceVariableNames:'name realm authenticationMechanisms'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Authentication'
!

!User class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    This is a user that can be authenticated.

    [author:]
        Stefan Vogel (stefan@zwerg)

    [instance variables:]
        name                        String      the name of the user
        realm                       String      the administartive realm of the user
        authenticationMechanisms    Collection  the different authentication mechanisms used to authenticate the user.
                                                They contain the password/secret.

    [class variables:]

    [see also:]
        Authentication::AuthenticationData

"
! !

!User class methodsFor:'instance creation'!

realm:realmString name:nameString secret:secretString
    "create a user and add the data for all implemented mechanism"

    ^ self new 
            realm:realmString;
            name:nameString;
            secret:secretString.
! !

!User methodsFor:'accessing'!

authenticationMechanisms
    ^ authenticationMechanisms
!

authenticationMechanisms:something
    authenticationMechanisms := something.
!

mechanismFor:aMechanismName
    "answer the authentication mechanism representing aMechanismClassname,
     or nil"

    ^ authenticationMechanisms detect:[:each| each class mechanismName = aMechanismName] ifNone:[].
!

name
    ^ name
!

name:something
    name := something.
!

realm
    ^ realm
!

realm:something
    realm := something.
!

secret:aSecretString
    "create authentication data for all known mechanisms"

    authenticationMechanisms := Authenticator knownAuthenticators collect:[:eachAuthenticator| 
        eachAuthenticator newAuthenticationDataFor:self secret:aSecretString
    ]. 
! !

!User methodsFor:'comparing'!

= aUser
    ^ name = aUser name 
        and:[realm = aUser realm
        and:[authenticationMechanisms asSet = aUser authenticationMechanisms asSet]]
!

hash
    ^ name hash xor:realm hash 
! !

!User class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/authentication/Authentication__User.st,v 1.4 2009/09/29 19:31:59 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/authentication/Authentication__User.st,v 1.4 2009/09/29 19:31:59 cg Exp $'
! !
