"{ NameSpace: Benchmarks }"

UnaryConstraint subclass:#EditConstraint
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'benchmarks-DeltaBlue'
!

EditConstraint comment:'I am a unary input constraint used to mark a variable that the client wishes to change.'!


!EditConstraint class methodsFor:'instance creation'!

var: aVariable strength: strengthSymbol
	"Install an edit constraint with the given strength on the given variable."

	^(self new) var: aVariable strength: strengthSymbol! !

!EditConstraint methodsFor:'execution'!

execute
	"Edit constraints do nothing."! !

!EditConstraint methodsFor:'queries'!

includeInPlan
	"Edit constraints have no effect other than to control the planning process."

	^false!

isInput
	"I indicate that a variable is to be changed by imperative code."

	^true! !

!EditConstraint class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/deltaBlue/EditConstraint.st,v 1.4 1997/01/03 17:40:44 cg Exp $'
! !
