"{ NameSpace: Benchmarks }"

UnaryConstraint subclass:#XMouseConstraint
	instanceVariableNames:'xOffset'
	classVariableNames:''
	poolDictionaries:''
	category:'benchmarks-DeltaBlue'
!

XMouseConstraint comment:'I am a unary input constraint that constrains a variable to the current x-coordinate of the mouse. I contain an offset to normalize the coordinate system to one convenient for the target variable.

Instance variables:
	xOffset         constant x-offset <Number>'!


!XMouseConstraint class methodsFor:'instance creation'!

var: aVariable offset: xOffset strength: strengthSymbol
	"Install an XMouse constraint on the given variable with the given offset constant to be added to the raw mouse position."

	^(self new) var: aVariable offset: xOffset strength: strengthSymbol! !

!XMouseConstraint methodsFor:'execution'!

execute
	"Enforce this constraint. Assume that it is satisfied."

	output value: (Sensor mousePoint x + xOffset).! !

!XMouseConstraint methodsFor:'initialize-release'!

var: aVariable offset: aNumber strength: strengthSymbol
	"Install myself with the given variable, x-offset, and strength."

	xOffset _ aNumber.
	self var: aVariable strength: strengthSymbol.! !

!XMouseConstraint methodsFor:'queries'!

isInput
	"I depend on the state of the mouse."

	^true! !

!XMouseConstraint class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/deltaBlue/XMouseConstraint.st,v 1.4 1997/01/03 17:40:30 cg Exp $'
! !
