"{ NameSpace: Benchmarks }"

UnaryConstraint subclass:#YMouseConstraint
	instanceVariableNames:'yOffset'
	classVariableNames:''
	poolDictionaries:''
	category:'benchmarks-DeltaBlue'
!

YMouseConstraint comment:'I am a unary input constraint that constrains a variable to the current y-coordinate of the mouse. I contain an offset to normalize the coordinate system to one convenient for the target variable.

Instance variables:
	yOffset         constant y-offset <Number>'!


!YMouseConstraint class methodsFor:'instance creation'!

var: aVariable offset: yOffset strength: strengthSymbol
	"Install a YMouse constraint on the given variable with the given offset constant to be added to the raw mouse position."

	^(self new) var: aVariable offset: yOffset strength: strengthSymbol! !

!YMouseConstraint methodsFor:'execution'!

execute
	"Enforce this constraint. Assume that it is satisfied."

	output value: (Sensor mousePoint y + yOffset).! !

!YMouseConstraint methodsFor:'initialize-release'!

var: aVariable offset: aNumber strength: strengthSymbol
	"Install myself with the given variable, y-offset, and strength."

	yOffset _ aNumber.
	self var: aVariable strength: strengthSymbol.! !

!YMouseConstraint methodsFor:'queries'!

isInput
	"I depend on the state of the mouse."

	^true! !

!YMouseConstraint class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/deltaBlue/YMouseConstraint.st,v 1.4 1997/01/03 17:40:21 cg Exp $'
! !
