"{ Package: 'stx:goodies/benchmarks/dhrystones' }"

"{ NameSpace: Benchmarks }"

Object subclass:#Dhrystone
	instanceVariableNames:'loopTime'
	classVariableNames:'Array1Glob Array2Glob BoolGlob Char1Glob Char2Glob IntGlob
		LoopCount Record'
	poolDictionaries:''
	category:'benchmarks-Dhrystone'
!

!Dhrystone class methodsFor:'documentation'!

documentation
"
    claus:
        ignore this - its nonsense.
        I hate this program, its output is completely misleading.

    Here is the original comment:

        This class, and the related classes (Object0, Object1 and so
        on), form a tranliteration of the Dhrystone (V1.1) benchmarks from ''C''
        into Smalltalk--80.  Accesses to ''C'' local variables have been
        replaced by accesses of instance variables, or by accesses to
        temporary variables.  Accesses to ''C'' globals have been replaced by
        accesses to instance variables in other objects, using message sends.
        ''C'' function calls have been replaced by the creation of
        some objects which then execute some code.

        The code is as direct a transliteration as possible; it is
        not particularly typical of Smalltalk code.

        While this benchmark is not tailored to Smalltalk in any way,
        it does provide a (non-rigorous) point of comparison
        between Smalltalk-80 implementations.  It may also be useful when
        comparing Smalltalk with other systems.

    claus: 
        The last sentence is definitely wrong. 
        Noone would program like this in smalltalk - therefore, a straight
        1:1 transliteration of a non-object-languages benchmark like Dhrystone
        to smalltalk does not make any sense at all.
        This benchmark is absolutely nonsense - and useless (even misleading).
        If anyone in your group writes code like this; fire him/her !!

   [start with:]
        Dhrystone new doit
"
!

results
"
    Dhrystone new doit

    WARNING: 
        please do not compare those results with
        dhrystone values for C-programs (read the documentation)
        Only compare among ST systems (if at all)

    DUO 1.8Ghz Vista           161290.0
    Duron 1.2Ghz winXP         100000.0
    Athlon 1Ghz linux/egcs      76923.1
    P6/400 linux/elf/egcs       27777.8
    P6/266 linux/elf/gcc        22222.2
    21164/433 (osf1)            18867.9
    P5-200 w95/notebk/bcc       10638.3
"
! !

!Dhrystone class methodsFor:'instance creation'!

new
	"Creates a new instance of the Dhrystone benchmark."

	^super new calculateNullLoopTime

	"Dhrystone initialize."
	"Dhrystone new doit."
	"MessageTally spyOn:[Dhrystone new doit]."
! !

!Dhrystone class methodsFor:'class access'!

array1Glob
	^Array1Glob
!

array1Glob: anArray
	Array1Glob _ anArray
!

array2Glob
	^Array2Glob
!

array2Glob: anArray
	Array2Glob _ anArray
!

boolGlob
	^BoolGlob
!

boolGlob: aBoolean
	BoolGlob _ aBoolean
!

char1Glob
	^Char1Glob
!

char1Glob: aChar
	Char1Glob _ aChar
!

char2Glob
	^Char2Glob
!

char2Glob: aChar
	Char2Glob _ aChar
!

intGlob
	^IntGlob
!

intGlob: anInteger
	IntGlob _ anInteger
!

loopCount
	"Answers with the number of times the loop is 
	 to be repeated."

	^LoopCount
!

record
	"Answers with the LinkedList used instead of the structures
	 in the original C code."

	^Record
! !

!Dhrystone class methodsFor:'class initialization'!

initialize
        "Initialize the class variables, corresponding to globals
         in the 'C' version."

        LoopCount _ 5000 "1000".     "Number of iterations used."
                               "Set this value to 500000
                                for much better accuracy,
                                but only if you can wait all day!!"
        IntGlob _ 0.
        Array1Glob _ Array new: 50.
        Array2Glob _ Array new: 50.
        1 to: Array2Glob size do: [:each | Array2Glob at: each put: (Array new: 50)].

        (Array2Glob at: 8) at: 7 put: 10.
        Record _ LinkedList new.
        Record addLast: DhryRecord new.
        Record addLast: DhryRecord new

        "Dhrystone initialize."
! !

!Dhrystone methodsFor:'actions'!

doit
	"Perform the Dhrystone loops.  Print the result in
	 the System Transcript."

	| runTime benchTime |
	Transcript cr; cr; show: 'Running Dhrystone benchmark (Smalltalk version)....'.

	runTime _ Object0 new doit.
	benchTime _ ((runTime - loopTime) / 1000).
	Transcript cr; show: 'Time for ', Dhrystone loopCount printString.
	Transcript show: ' passes = ',(benchTime printString),' seconds.'.
	Transcript cr; show: 'This system benchmarks at '.
	Transcript show: (Dhrystone loopCount / benchTime) printString.
	Transcript show: ' dhrystones/second.'; cr
! !

!Dhrystone methodsFor:'private'!

calculateNullLoopTime
	"Calculate the time taken by a loop which does nothing."

	loopTime _ (Time millisecondsToRun: [
		Dhrystone loopCount timesRepeat: []]) asFloat
! !

!Dhrystone class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/dhrystones/Dhrystone.st,v 1.13 2007/02/10 16:28:53 cg Exp $'
! !

Dhrystone initialize!
