"{ NameSpace: Benchmarks }"

Object subclass:#Object0
	instanceVariableNames:'intLoc1 intLoc2 intLoc3 charLoc charIndex enumLoc string1Loc
		string2Loc'
	classVariableNames:''
	poolDictionaries:''
	category:'benchmarks-Dhrystone'
!

Object0 comment:'This contains the outer loop of the Dhrystone benchmark
code.'!


!Object0 class methodsFor:'instance creation'!

new
        ^super new initialize! !

!Object0 methodsFor:'actions'!

doit
        "Repeatedly perform the code inside the benchmark loop.
         Answer with the time (in milliseconds) taken for all the loops."

        | time |
        time _ Time millisecondsToRun: [
                Dhrystone loopCount timesRepeat: [
                        Object5 new doit.
                        Object4 new doit.
                        intLoc1 _ 2.
                        intLoc2 _ 3.
                        string2Loc _ 'DHRYSTONE PROGRAM, 2''ND STRING'.
                        enumLoc _ 2.
                        Dhrystone boolGlob: (ObjectF2 new with: string1Loc and: string2Loc) not.
                        [intLoc1 < intLoc2] whileTrue: [
                                intLoc3 _ 5 * intLoc1 - intLoc2.
                                intLoc3 _ Object7 new with: intLoc1 and: intLoc2.
                                intLoc1 _ intLoc1 + 1].
                        Object8 new
                                with: Dhrystone array1Glob
                                with: Dhrystone array2Glob
                                with: intLoc1 with: intLoc3.
                        Object1 new with: Dhrystone record.
                        charIndex _ $A.
                        [charIndex <= Dhrystone char2Glob] whileTrue: [
                                charIndex _ (charIndex asInteger + 1) asCharacter.
                                (enumLoc = (ObjectF1 new with: charIndex and: $C)) ifTrue: [
                                        enumLoc _ Object6 new with: 1]].
                        intLoc3 _ intLoc2 * intLoc1.
                        intLoc2 _ intLoc3 / intLoc1.
                        intLoc2 _ 7 * (intLoc3 - intLoc2) - intLoc1.
                        intLoc1 _ Object2 new with: intLoc1
                ]
        ].
        ^time asFloat
! !

!Object0 methodsFor:'private'!

initialize
        "Sets up some of the instance variables (once only),
         corresponding to locals in the 'C' version, and some class
         variables, corresponding to globals in the 'C' version."

        "Pointers to next record and similar things actually
         done by a LinkedList and Links, which are created
         in Dhrystone class initialize."

        Dhrystone record first discr: 1.
        Dhrystone record first enumComp: 3.
        Dhrystone record first intComp: 40.
        Dhrystone record first stringComp: 'DHRYSTONE PROGRAM, SOME STRING'.

        string1Loc _ 'DHRYSTONE PROGRAM, 1''ST STRING'.
        (Dhrystone array2Glob at: 8) at: 7 put: 10! !

!Object0 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/dhrystones/Object0.st,v 1.4 1997/01/03 17:43:18 cg Exp $'
! !
