"{ NameSpace: Benchmarks }"

TaskState subclass:#TaskControlBlock
	instanceVariableNames:'link identity priority input state function handle'
	classVariableNames:''
	poolDictionaries:''
	category:'benchmarks-RichardsBenchmarks'
!


!TaskControlBlock class methodsFor:'instance creation'!

link: link create: identity priority: priority initialWorkQueue: initialWorkQueue initialState: initialState function: aBlock privateData: privateData 
        ^super new
                link: link
                identity: identity
                priority: priority
                initialWorkQueue: initialWorkQueue
                initialState: initialState
                function: aBlock
                privateData: privateData! !

!TaskControlBlock methodsFor:'accessing'!

identity
        ^identity!

link
        ^link!

priority
        ^priority! !

!TaskControlBlock methodsFor:'initialize'!

link: aLink identity: anIdentity priority: aPriority initialWorkQueue: anInitialWorkQueue initialState: anInitialState function: aBlock privateData: aPrivateData 
        link := aLink.
        identity := anIdentity.
        priority := aPriority.
        input := anInitialWorkQueue.
        packetPending := anInitialState isPacketPending.
        taskWaiting := anInitialState isTaskWaiting.
        taskHolding := anInitialState isTaskHolding.
        function := aBlock.
        handle := aPrivateData

    "Modified: / 13.3.1998 / 11:45:44 / cg"
! !

!TaskControlBlock methodsFor:'scheduling'!

addInput: packet checkPriority: oldTask
        NoWork == input
                ifTrue: 
                        [input := packet.
                        packetPending := true.
                        priority > oldTask priority ifTrue: [^self]]
                ifFalse: 
                        [input := self append: packet head: input].
        ^oldTask

    "Modified: / 13.3.1998 / 11:45:36 / cg"
!

runTask
        | message |
        self isWaitingWithPacket
                ifTrue: 
                        [message := input.
                        input := message link.
                        NoWork == input
                                ifTrue: [self running]
                                ifFalse: [self packetPending]]
                ifFalse: [message := NoWork].
        ^function value: message value: handle

    "Modified: / 13.3.1998 / 11:45:49 / cg"
! !

!TaskControlBlock class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/richards/TaskControlBlock.st,v 1.5 1998/03/13 11:49:59 cg Exp $'
! !
