"{ Package: 'stx:goodies/benchmarks/self' }"

"{ NameSpace: Benchmarks }"

Object subclass:#BenchmarkRunner
	instanceVariableNames:''
	classVariableNames:'Suite'
	poolDictionaries:''
	category:'benchmarks-Self'
!

!BenchmarkRunner class methodsFor:'documentation'!

documentation
"
    some microBenchmarks provided by Urs Hoelzle.

    Should be run twice, if just-in-time compiler is enabled.

    [start with:]
	BenchmarkRunner new run
"
!

results
" (times are for interpreted bytecode / with just in time compilation
   if supported by that architecture)

  BenchmarkRunner new run

  notice: 
        the numbers below could be outdated 
        - we dont update them for every change.
        Also, the BEST time from a number of runs on an unloaded machine
        was taken.
        Do not expect to be able to reproduce them exactly - a variation of
        5-15% is normal, depending on network traffic, memory speed,
        cache fluctuations etc. 
        (especially on PC hardware, the memory bus timing can make a difference)


    machine             | benchmark
                        |
                        | Bubble | Bubble2 | IntMM | IntMM2 |  MM  |  MM2 | Perm | Queens | Queens2 | Quick | Quick2 | Towers | Towers2 | Tree | Tree2 | Sieve | SumFrom | AtAllPut | SumAll | IncrAll | NLoop | Tak |
------------------------+--------+---------+-------+--------+------+------+------+--------+---------+-------+--------+--------+---------+------+-------+-------+---------+----------+--------+---------+-------+-----+
DUO 2.1Ghz vista        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   bcc        ST/X JIT  |      7 |      10 |     5 |      7 |   10 |   10 |    2 |     1  |     3   |     2 |      5 |     2  |      2  |    5 |     2 |     2 |       2 |     -    |      - |       2 |     2 |   1 |
   bcc        ST/X noJIT|     20 |      46 |    13 |     20 |   15 |   26 |   23 |    13  |     7   |    18 |     26 |    36  |     26  |   52 |    23 |    20 |      44 |     -    |      7 |      13 |    41 |  10 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
DUO 1.8Ghz vista        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   bcc        ST/X JIT  |     15 |      15 |     7 |      7 |   13 |   15 |    7 |     1  |     3   |     3 |      5 |     5  |      2  |    6 |     2 |     3 |       7 |     -    |      - |       3 |     5 |   1 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
P-M 1.7Ghz winXP        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   bcc        ST/X JIT  |     26 |      15 |     6 |      8 |   19 |   18 |   11 |     1  |     3   |     3 |      5 |     5  |      3  |    6 |     3 |     3 |       8 |     -    |      - |       3 |     8 |   1 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Duron 1.2Ghz winXP      |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   bcc        ST/X JIT  |     23 |      23 |    10 |     48 |   61 |   48 |    8 |     3  |     5   |     5 |     10 |    11  |      6  |    8 |     8 |     6 |      10 |     -    |      1 |       5 |    10 |   1 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
PentiumIII/700 linux ELF|        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.95  ST/X JIT  |     35 |      37 |    17 |     25 |   66 |   64 |   14 |     8  |     7   |     9 |     14 |    18  |     10  |   16 |    11 |    11 |      25 |     -    |      3 |      13 |    24 |   4 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
PentiumIII/500 linux ELF|        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.95  ST/X JIT  |     53 |      55 |    26 |     37 |   67 |   74 |   20 |    11  |    10   |    13 |     21 |    27  |     14  |   24 |    16 |    16 |      36 |     1    |      3 |      16 |    34 |   6 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Celeron/500 linux ELF   |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.95  ST/X JIT  |     53 |      55 |    24 |     36 |   80 |   82 |   20 |    11  |     9   |    13 |     21 |    26  |     14  |   23 |    16 |    15 |      36 |     2    |      5 |      17 |    34 |   6 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
PentiumII/400 linux ELF |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.91  ST/X JIT  |     62 |      69 |    33 |     46 |   74 |   75 |   27 |    13  |    13   |    19 |     27 |    39  |     19  |   32 |    20 |    19 |      45 |     1    |      4 |      21 |    38 |   8 |
                        |        |      68 |       |     45 |      |      |   26 |        |    12   |    18 |        |    35  |     17  |   30 |       |       |         |          |        |      19 |       |   7 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
DEC alpha 21064/433 OSF1|        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    cc        ST/X   JIT|     82 |      86 |    44 |     61 |  110 |  108 |   39 |    23  |    18   |    22 |     33 |    49  |     27  |   46 |    34 |    29 |      92 |     1    |      6 |      28 |    67 |  12 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Sun Ultra/ES 250 s2.6   |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.91  ST/X JIT  |     79 |      85 |    55 |     69 |  118 |  111 |   37 |    22  |    19   |    36 |     38 |    46  |     27  |   64 |    54 |    37 |     116 | 0 (< 1)  |     10 |      28 |    83 |  13 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
PentiumII/266 linux ELF |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc 2.7.2 ST/X JIT  |     91 |      94 |    47 |     63 |  107 |  113 |   36 |    18  |    18   |    24 |     37 |    50  |     25  |   47 |    29 |    30 |      67 |     1    |      6 |      27 |    49 |  12 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Notebk PII/266 Linux ELF|        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc       ST/X JIT  |    119 |     123 |    60 |     83 |  169 |  181 |   47 |    22  |    22   |    32 |     51 |    65  |     31  |   60 |    39 |    38 |      79 |     4    |      8 |      37 |    54 |  12 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Notebk PII/266 Win95    |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    borland   ST/X JIT  |    123 |     137 |    67 |    109 |  178 |  207 |   41 |    14  |    12   |    26 |     55 |    67  |     27  |   55 |    41 |    27 |      69 |     9    |     20 |      37 |    55 |  11 |
              VW3.0     |     93 |      81 |    48 |     59 |  153 |  156 |   47 |    26  |    24   |    37 |     35 |    62  |     29  |   58 |    34 |    62 |      74 |    26    |     62 |      46 |    64 |   9 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Pentium/200 NoteBk win95|        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    borland   ST/X JIT  |    171 |     189 |   106 |    150 |  292 |  316 |   68 |    31  |    31   |    44 |     79 |    89  |     45  |   96 |    61 |    52 |     113 |    10    |     13 |      55 |    75 |  21 |
    borland   ST/X JIT  |    164 |     179 |    82 |    137 |  272 |  290 |   66 |    26  |    27   |    40 |     67 |    81  |     34  |   81 |    56 |    39 |      97 |    <<    |     13 |      44 |    67 |  13 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Pentium/133 linux a.out |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc 2.7.2 ST/X JIT  |    202 |     209 |   106 |    143 |  292 |  302 |   88 |    41  |    41   |    58 |     88 |   135  |     70  |  225 |    75 |    69 |     152 |     4    |     17 |      63 |   103 |  24 |
    gcc 2.7.2 ST/X NOJIT|    663 |    1007 |   408 |    739 |  694 |  883 |  817 |   318  |   276   |   396 |    562 |  1284  |    938  | 1943 |  1061 |   745 |    2212 |     4    |    186 |     448 |  1787 | 260 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Pentium/120 linux ELF   |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc 2.7.2 ST/X JIT  |    229 |     238 |   121 |    175 |  501 |  575 |  104 |    48  |    48   |    66 |     99 |   190  |     88  |  348 |   111 |    83 |     158 |    12    |     20 |      76 |   118 |  33 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
hp B2000 hpux           |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    cc        ST/X NOJIT|    292 |     480 |   177 |    337 |  238 |  375 |  269 |   127  |   111   |   162 |    224 |   350  |    240  |  522 |   275 |   323 |     988 |     1    |     90 |     228 |   792 | 106 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
DEC alpha 21064/233 OSF1|        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc       ST/X NOJIT|    586 |    1319 |  1103 |   2252 | 1906 | 2779 | 2155 |   511  |   492   |   746 |   1281 |  2814  |   2691  | 7728 |  3843 |   783 |    1917 |    18    |    379 |     750 |  1542 | 690 |
    gcc       ST/X   JIT|    276 |     291 |   226 |    453 |  977 |  925 |  262 |    97  |    82   |   178 |    183 |   421  |    262  |  388 |   321 |   110 |     361 |    17    |     30 |     131 |   182 | 138 |
    gcc taso  ST/X   JIT|    269 |     286 |   181 |    411 |  943 | 1038 |  236 |    66  |    71   |    88 |    139 |   359  |    222  |  335 |   296 |    79 |     215 |    18    |     30 |     132 |   160 | 117 |
                        |    777 |     364 |   221 |    373 |  910 |  964 |  288 |    73  |    69   |   162 |    149 |   439  |    290  |  389 |   310 |    85 |     227 |    17    |     32 |     138 |   165 | 129 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
R4000/150 SGI/Indy 5.3  |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
     cc       ST/X NOJIT|    897 |    1359 |   623 |   1298 | 1145 | 1442 | 1158 |   484  |   416   |   547 |    822 |  1860  |   1426  | 2298 |  2010 |  1027 |    2855 |     9    |    896 |     676 |  2370 | 549 |
     cc       ST/X   JIT|    333 |     337 |   213 |    241 |  379 |  355 |  147 |    85  |    86   |   160 |    163 |   223  |     95  |  185 |   126 |   284 |     692 |     2    |     21 |     144 |   281 |  52 |
    gcc       ST/X   JIT|    418 |     350 |   213 |    264 |  595 |  482 |  156 |   193  |   188   |   248 |    182 |   213  |    142  |  181 |   139 |   292 |     714 |     2    |     21 |     149 |   292 |  64 |
                        |    370 |     396 |   215 |    271 |  569 |  395 |  231 |    89  |    91   |   221 |    184 |   212  |    137  |  198 |   143 |   317 |     737 |     2    |     22 |     178 |   301 |  51 |
                        |    360 |         |   194 |    252 |  413 |      |  155 |    85  |    85   |   173 |    175 |        |    110  |  187 |   136 |       |     716 |          |        |         |   287 |     |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Sun SS10/40 solaris 2.5 |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc 2.7.2 ST/X JIT  |    620 |     632 |   501 |    537 |  778 |  713 |  273 |   170  |   136   |   262 |    271 |   357  |    189  |  489 |   391 |   315 |     703 |     8    |     59 |     223 |   578 |  96 |
   egcs 2.91  ST/X NOJIT|   1706 |    2496 |   990 |   1694 | 1507 | 2236 | 1770 |   776  |   658   |   990 |   1289 |  2509  |   2040  | 3775 |  2361 |  1943 |    5769 |     8    |    554 |    1333 |  4829 | 776 |
   egcs 2.91  ST/X JIT  |    654 |     672 |   435 |    499 |  809 |  793 |  282 |   175  |   139   |   296 |    305 |   384  |    204  |  548 |   412 |   325 |     733 |     8    |     57 |     232 |   605 |  95 |
                        |    659 |     666 |   433 |    480 |  818 |  741 |  285 |   178  |   141   |   297 |    309 |   358  |    190  |  509 |   402 |   323 |     694 |     8    |     58 |     237 |   593 |  91 |
              VW2.5.1   |    590 |     511 |   340 |    407 |  763 |  665 |  292 |   175  |   152   |   247 |    235 |   393  |    178  |  345 |   203 |   408 |     427 |   147    |    309 |     296 |   381 |  54 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
HP 735/100 HPUX10.20    |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
  hp-cc       ST/X NOJIT|   1570 |    2368 |   929 |   1648 | 1394 | 1864 | 1521 |   717  |   588   |   869 |   1154 |  3055  |   2027  | 3031 |  1634 |  1792 |    5297 |    15    |    488 |    1121 |  4322 | 994 |
  compile librun with   |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.91  ST/X NOJIT|    860 |    1589 |   613 |   1705 |  930 | 1668 | 1022 |   395  |   344   |   715 |    781 |  1359  |   1043  | 2861 |  1288 |   975 |    3015 |    15    |    355 |     705 |  2506 | 434 |
  librun & libbasic with|        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.91  ST/X NOJIT|    836 |    1589 |   495 |   1261 |  817 | 1532 | 1051 |   393  |   332   |   495 |    845 |  1328  |   1009  | 2088 |  1128 |   973 |    3011 |     6    |    347 |     703 |  2494 | 437 |
  run, basic, basic2 wt.|        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.91  ST/X NOJIT|    840 |    1439 |   502 |   1064 |  822 | 1318 | 1024 |   394  |   334   |   504 |    715 |  1555  |   1160  | 2102 |  1117 |   970 |    3009 |     6    |    347 |     704 |  2498 | 501 |
  all classLibs with    |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
   egcs 2.91  ST/X NOJIT|    823 |    1415 |   495 |   1035 |  820 | 1398 | 1020 |   384  |   326   |   492 |    685 |  1316  |   1005  | 2100 |  1074 |   944 |    2930 |     6    |    347 |     695 |  2423 | 430 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
486/50      linux ELF   |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc 2.7.2 ST/X JIT  |   1101 |    1124 |   697 |    688 | 1517 | 1382 |  507 |   285  |   232   |   428 |    444 |   942  |    455  | 1339 |   368 |   699 |     915 |     8    |    136 |     604 |  1551 | 270 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
88k Real/IX             |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc 2.7.2           |   1202 |    2482 |   712 |   1447 | 1295 | 2752 | 1698 |   591  |   495   |   701 |   1175 |  2190  |   1690  | 3778 |  2120 |  1375 |    3859 |    11    |    417 |     819 |  3026 | 589 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
Sun ELC     sunos 4.0   |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
    gcc 2.6.2 ST/X JIT  |   1557 |    1944 |  1209 |   1315 | 2084 | 1976 | 1166 |   450  |   478   |   712 |    749 |  1099  |    771  | 1772 |  1452 |  1464 |    3896 |    27    |    111 |     803 |  1004 | 477 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
IBM 320H AIX2.3         |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
     cc       ST/X   JIT|   1690 |    1737 |  1160 |   1385 | 2290 | 1871 |  851 |   489  |   402   |   668 |    701 |   985  |    562  |  976 |   686 |   865 |    2631 |     8    |    136 |     604 |  1551 | 270 |
    gcc       ST/X NOJIT|   5601 |    8865 |  3510 |   9779 | 5011 | 7891 | 8335 |  2865  |  2406   |  3849 |   4875 | 10068  |   8137  |14220 |  8584 |  6350 |   19468 |    10    |   1902 |    4231 | 16252 |2604 |
    gcc       ST/X   JIT|   2110 |    2186 |  1318 |   1616 | 2085 | 2287 | 1031 |   644  |   468   |   953 |   1113 |  1483  |    671  | 1137 |   827 |   950 |    2882 |    10    |    153 |     687 |  1698 | 397 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
NeXT 68k/33 NeXTSTep3.1 |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
     cc       ST/X NOJIT|   5309 |   11475 |  4908 |   7264 | 6562 |11636 | 9072 |  2604  |  3874   |  3347 |   4235 | 14755  |  10323  |14244 |  8484 |  7982 |   20131 |    20    |   1584 |    5234 | 17179 |2907 |
     cc       ST/X   JIT|   3419 |    3574 |  1834 |   1648 | 2524 | 2383 |  933 |   603  |   607   |  1724 |   1785 |  1904  |    978  | 2701 |  1308 |  3391 |   10058 |    21    |    124 |    1439 |  1445 | 615 |
                        |        |         |       |        |      |      |      |        |         |       |        |        |         |      |       |       |         |          |        |         |       |     |
------------------------+--------+---------+-------+--------+------+------+------+--------+---------+-------+--------+--------+---------+------+-------+-------+---------+----------+--------+---------+-------+-----+
                        | Bubble | Bubble2 | IntMM | IntMM2 |  MM  |  MM2 | Perm | Queens | Queens2 | Quick | Quick2 | Towers | Towers2 | Tree | Tree2 | Sieve | SumFrom | AtAllPut | SumAll | IncrAll | NLoop | Tak |
        
taso - linked to use 32bit addresses (generates shorter address-load sequences)
       the 233 alpha as tested had NO cache - a totally useless configuration.
<<   - time too short to be measured; windows95 timer has not enough resolution
"
! !

!BenchmarkRunner class methodsFor:'initialization'!

add: x
	Suite add: x
!

initialize
        Suite := OrderedCollection new.
        Suite addAll: #(BubbleSortBenchmark 
                        BubbleSort2Benchmark 
                        IntMMBenchmark 
                        IntMM2Benchmark 
                        MMBenchmark 
                        MM2Benchmark 
                        PermBenchmark 
" Perm2Benchmark "
                        QueensBenchmark 
                        Queens2Benchmark 
                        QuicksortBenchmark 
                        Quicksort2Benchmark 
                        TowersBenchmark 
                        Towers2Benchmark 
                        TreeSortBenchmark 
                        TreeSort2Benchmark 
" PuzzleBenchmark "
                        SieveBenchmark 
" SumToBenchmark "
" FastSumToBenchmark "
                        SumFromToBenchmark 
" RecurseBenchmark "
                        AtAllPutBenchmark 
                        SumAllBenchmark 
                        IncrementAllBenchmark 
                        NestedLoopBenchmark 
                        TakBenchmark 
" TaklBenchmark "
                )
        "BenchmarkRunner initialize"

    "Modified: / 13.3.1998 / 12:13:41 / cg"
!

initializeMM
        Suite := OrderedCollection new.
        Suite addAll: #( IntMMBenchmark 
                        IntMM2Benchmark 
                        MMBenchmark 
                        MM2Benchmark )
        "BenchmarkRunner initializeMM"

    "Modified: / 13.3.1998 / 12:13:43 / cg"
!

initializeNoMM
        Suite := OrderedCollection new.
        Suite addAll: #(BubbleSortBenchmark 
                        BubbleSort2Benchmark 
                        PermBenchmark 
" Perm2Benchmark "
                        QueensBenchmark 
                        Queens2Benchmark 
                        QuicksortBenchmark 
                        Quicksort2Benchmark 
                        TowersBenchmark 
                        Towers2Benchmark 
                        TreeSortBenchmark 
                        TreeSort2Benchmark 
                        PuzzleBenchmark 
                        SieveBenchmark 
" SumToBenchmark "
" FastSumToBenchmark "
                        SumFromToBenchmark 
" RecurseBenchmark "
                        AtAllPutBenchmark 
                        SumAllBenchmark 
                        IncrementAllBenchmark 
                        NestedLoopBenchmark 
                        TakBenchmark 
" TaklBenchmark "
                )
        "BenchmarkRunner initializeNoMM"

    "Modified: / 13.3.1998 / 12:13:46 / cg"
! !

!BenchmarkRunner methodsFor:'running'!

run
        "BenchmarkRunner new run"
        | avgTotal bestTotal worstTotal avgTime worstTime bestTime
          cTotal fixed cFixed float cFloat size time cTime bm bcl |

        avgTotal := bestTotal := worstTotal := 0.
        cTotal := 0.
        fixed := 0.
        cFixed := 0.
        float := 0.
        cFloat := 0.
        Suite do: 
                [:b |
                bcl := Smalltalk at: b.
                bcl isNil ifTrue:[
                    bcl := Benchmarks at:b
                ].
                bm := bcl new.

                time := Time millisecondsToRun: [bm run].
                avgTime := bestTime := worstTime := time.
                5 timesRepeat:[
                    time := Time millisecondsToRun: [bm run].
                    time < bestTime ifTrue:[
                        bestTime := time
                    ] ifFalse:[
                        time > worstTime ifTrue:[
                            worstTime := time
                        ]
                    ].
                    avgTime := avgTime + time.
                ].
                avgTime := avgTime // 6.

                avgTotal := avgTotal + avgTime.
                bestTotal := bestTotal + bestTime.
                worstTotal := worstTotal + worstTime.

                fixed := fixed + (time * bm fixedBase).
                float := float + (time * bm floatBase).
                cTime := bm cTime.

                Transcript show: b , ': ' , avgTime printString , ' ms;'.
                Transcript show:' [best: ' , bestTime printString , ' worst: ' , worstTime printString , ']'.

                cTime isNil ifTrue:[
                    Transcript show:' C time (sun4/260): ? ms'.
                ] ifFalse:[
                    cTotal := cTotal + cTime.
                    cFixed := cFixed + (cTime * bm fixedBase).
                    cFloat := cFloat + (cTime * bm floatBase).
                    Transcript show:' C time (sun4/260): ' , cTime printString , ' ms; ratio: ' , (avgTime / cTime) asFloat printString.
                ].
                
                Transcript cr].
        Transcript cr.
        Transcript show: 'AvgTotal: ' , avgTotal printString , ' ms; C total: ' , cTotal printString , ' ms; ratio: ' , (avgTotal / cTotal) asFloat printString.
        Transcript cr.
        Transcript show: 'BestTotal: ' , bestTotal printString , ' ms; ratio: ' , (bestTotal / cTotal) asFloat printString.
        Transcript cr.
        Transcript show: 'WorstTotal: ' , worstTotal printString , ' ms; ratio: ' , (worstTotal / cTotal) asFloat printString.
        Transcript cr.
        size := Suite size asFloat.
        fixed := fixed / size.
        float := float / size.
        cFixed := cFixed / size.
        cFloat := cFloat / size.
        Transcript show: 'Fixed:  ' , fixed printString , ';  C: ' , cFixed printString , ';  ratio: ' , (fixed / cFixed) asFloat printString.
        Transcript cr.
        Transcript show: 'Float:  ' , float printString , ';  C: ' , cFloat printString , ';  ratio: ' , (float / cFloat) asFloat printString.
        Transcript cr

    "Modified: / 13.3.1998 / 12:13:59 / cg"
!

runOne
        "BenchmarkRunner initializeNoMM. BenchmarkRunner new runOne"
        | time bm bcl |
        Suite do: 
                [:b |
                bcl := Smalltalk at: b.
                bcl isNil ifTrue:[
                    bcl := Benchmarks at:b
                ].
                bm := bcl new.
                time := Time millisecondsToRun: [bm run].
                Transcript show: b , ': ' , time printString , ' ms'.
                Transcript cr].
        Transcript cr

    "Modified: / 13.3.1998 / 12:14:03 / cg"
!

runTen
        "BenchmarkRunner new runTen"

        | time bm bcl |
        Suite do: 
                [:b |
                bcl := Smalltalk at: b.
                bcl isNil ifTrue:[
                    bcl := Benchmarks at:b
                ].
                bm := bcl new.
                time := Time millisecondsToRun: [10 timesRepeat: [bm run]].
                time := time / 10.
                Transcript show: b , ': ' , time printString , ' ms'.
                Transcript cr].
        Transcript cr

    "Modified: / 13.3.1998 / 12:14:07 / cg"
!

runTests
        "BenchmarkRunner initializeNoMM. BenchmarkRunner new runTests"

        | ctime rtime bm bcl |
        Suite do: 
                [:b | 

                bcl := Smalltalk at: b.
                bcl isNil ifTrue:[
                    bcl := Benchmarks at:b
                ].
                bm := bcl new.
"                Smalltalk garbageCollect. "
                ctime := Time millisecondsToRun: [10 timesRepeat: [bm run]].
"                Smalltalk garbageCollect. "
                rtime := Time millisecondsToRun: [10 timesRepeat: [bm run]].
                ctime := ctime - rtime.
                rtime := rtime / 10.
                Transcript show: b , ': ' , ctime printString, ' ms (compile), ', rtime printString , ' ms (run)'.
                Transcript cr].
        Transcript cr

    "Modified: / 13.3.1998 / 12:14:12 / cg"
!

xrun
        "BenchmarkRunner new xrun"
        | total cTotal fixed cFixed float cFloat size time cTime bm bcl |
        total := 0.
        cTotal := 0.
        fixed := 0.
        cFixed := 0.
        float := 0.
        cFloat := 0.
        Suite do: 
                [:b |
                bcl := Smalltalk at: b.
                bcl isNil ifTrue:[
                    bcl := Benchmarks at:b
                ].
                bm := bcl new.
                time := Time millisecondsToRun: [bm run].
time printCR.
                total := total + time.
                fixed := fixed + (time * bm fixedBase).
                float := float + (time * bm floatBase).
                Transcript cr].
        Transcript cr.
        Transcript show: 'Total: ' , total printString , ' ms'.
        Transcript cr.

    "Modified: / 13.3.1998 / 12:14:18 / cg"
! !

!BenchmarkRunner class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/BenchmarkRunner.st,v 1.128 2011/09/27 15:12:01 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/BenchmarkRunner.st,v 1.128 2011/09/27 15:12:01 cg Exp $'
! !

BenchmarkRunner initialize!
