"{ NameSpace: Benchmarks }"

QuicksortBenchmark subclass:#BubbleSortBenchmark
	instanceVariableNames:'top'
	classVariableNames:'Sortelements SortElements'
	poolDictionaries:''
	category:'benchmarks-Self'
!


!BubbleSortBenchmark class methodsFor:'constants'!

initialize Sortelements := 500 "BubbleSortBenchmark initialize"

    "Modified: / 13.3.1998 / 12:14:27 / cg"
! !

!BubbleSortBenchmark methodsFor:'constants'!

cTimes: mach 
        mach = 'sun4_260' ifTrue: [^180].
        mach = 'sun3_160' ifTrue: [^942]!

fixedBase ^ 1.61! !

!BubbleSortBenchmark methodsFor:'run'!

initarr
        | temp |
        self initrand.
        biggest := -1000000.
        littlest := 1000000.
        sortlist := Array new: Sortelements.
        1 to: Sortelements do: 
                [:i | 
                temp := self rand.
                sortlist at: i put: temp - (temp // 100000 * 100000) - 50000.
                (sortlist at: i)
                        > biggest ifTrue: [biggest := sortlist at: i].
                (sortlist at: i)
                        < littlest ifTrue: [littlest := sortlist at: i]]

    "Modified: / 13.3.1998 / 12:14:31 / cg"
!

run   
        | i  j |
        self initarr.
        top :=    Sortelements.
        [top > 1] whileTrue: [
            i := 1.
            [i < top] whileTrue: [
                (sortlist at: i) > (sortlist at: i + 1) ifTrue: [
                    j := sortlist at: i.
                    sortlist at: i put: (sortlist at: i + 1).
                    sortlist at: i + 1 put: j.
                ].
                i := i + 1.
            ].
            top := top -1.
        ].
        ((sortlist at: 1) ~= littlest or: 
        [(sortlist at: Sortelements) ~= biggest]) ifTrue:
            [self error: 'Error3 in Bubble'  ]

    "Modified: / 13.3.1998 / 12:14:37 / cg"
! !

!BubbleSortBenchmark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/BubbleSortBenchmark.st,v 1.8 1998/03/13 15:35:08 cg Exp $'
! !
BubbleSortBenchmark initialize!
