"{ Package: 'stx:goodies/benchmarks/self' }"

"{ NameSpace: Benchmarks }"

Object subclass:#HanoiBenchmark
	instanceVariableNames:'maxcells stackrange stack cellspace freelist movesdone'
	classVariableNames:''
	poolDictionaries:''
	category:'benchmarks-Self'
!


!HanoiBenchmark methodsFor:'benchmark operations'!

getelement
    |temp|

    freelist > 0 ifTrue:[
        temp := freelist.
        freelist := (cellspace at:freelist) next
    ] ifFalse:[
        self error:'out of space'
    ].
    ^ temp
!

init:s to:n
    self makenull:s.
    n to:1 by:-1 do:[:discctr |
        self push:discctr onTo:s
    ]
!

makenull:s
    stack at:s put:0
!

moveFrom:s1 to:s2
    self push:(self pop:s1) onTo:s2.
    movesdone := movesdone + 1
!

pop:s
    |temp1 temp|

    (stack at:s) > 0 ifFalse:[
        ^ self error:'nothing to pop'
    ].
    temp1 := (cellspace at:(stack at:s)) discsize.
    temp := (cellspace at:(stack at:s)) next.
    (cellspace at:(stack at:s)) next:freelist.
    freelist := stack at:s.
    stack at:s put:temp.
    ^ temp1
!

push:i onTo:s
    |localel|

    (stack at:s) > 0 ifTrue:[
        (cellspace at:(stack at:s)) discsize <= i ifTrue:[
            ^ self error:'disk size error'
        ]
    ].
    localel := self getelement.
    (cellspace at:localel) next:(stack at:s).
    stack at:s put:localel.
    (cellspace at:localel) discsize:i
!

run
    1 to:maxcells do:[:i |
        cellspace at:i put:(HanoiDisk new next:(i - 1))
    ].
    freelist := maxcells.
    self init:1 to:14.
    self makenull:2.
    self makenull:3.
    movesdone := 0.
    self towerI:1 j:2 k:14.
    movesdone == 16383 ifFalse:[
        self error:'error in towers'
    ]
!

towerI:i j:j k:k
    |other|

    k = 1 ifTrue:[
        self moveFrom:i to:j
    ] ifFalse:[
        other := 6 - i - j.
        self towerI:i j:other k:(k - 1).
        self moveFrom:i to:j.
        self towerI:other j:j k:(k - 1)
    ]
! !

!HanoiBenchmark methodsFor:'initialization'!

initialize
    maxcells := 16.
    stackrange := 3.
    stack := Array new:3.
    cellspace := Array new:18.

    "HanoiBenchmark new initialize run"
    "|b|
     b := HanoiBenchmark new initialize.
     Time millisecondsToRun:[b run]"
! !

!HanoiBenchmark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/HanoiBenchmark.st,v 1.6 2001/10/26 14:00:16 penk Exp $'
! !
