"{ NameSpace: Benchmarks }"

AbstractBenchmark subclass:#IntMMBenchmark
	instanceVariableNames:'ma mb mr'
	classVariableNames:'IRowsize'
	poolDictionaries:''
	category:'benchmarks-Self'
!


!IntMMBenchmark class methodsFor:'constants'!

initialize IRowsize := 40 "IntMMBenchmark initialize"

    "Modified: / 13.3.1998 / 12:15:00 / cg"
! !

!IntMMBenchmark methodsFor:'constants'!

cTimes: mach
mach = 'sun4_260' ifTrue: [^270].
mach = 'sun3_160' ifTrue: [^928].!

fixedBase ^1.46! !

!IntMMBenchmark methodsFor:'private'!

initmatrix 
        | m temp |
        m := self mmMatrix.
        1 to: IRowsize do: [:i | 1 to: IRowsize do: 
                        [:j | 
                        temp := self newValue.
                        (m at: i)
                                at: j put: temp - (temp // 120 * 120) - 60]].
        ^m

    "Modified: / 13.3.1998 / 12:15:04 / cg"
!

innerproductOf: a and: b row: row column: column 
        | result |
        result := 0.
        1 to: IRowsize do: [:i | result := ((a at: row)
                                                at: i) * ((b at: i) at: column) + result].
        ^result

    "Modified: / 13.3.1998 / 12:15:07 / cg"
!

makeMatrix: n by: m 
        | r |
        r := Array new: n.
        1 to: r size do: [:i | r at: i put: (Array new: m)].
        ^r

    "Modified: / 13.3.1998 / 12:15:09 / cg"
!

makePuzzleMatrix: n by: m 
        | r |
        r := PuzzleArray new: n.
        0 to: r size - 1 do: [:i | r at: i put: (PuzzleArray new: m)].
        ^r

    "Modified: / 13.3.1998 / 12:15:14 / cg"
!

mmMatrix
        ^self makeMatrix: IRowsize + 1 by: IRowsize + 1!

newValue
        ^self rand! !

!IntMMBenchmark methodsFor:'run'!

run
        self initialize.
        mr := self mmMatrix.
        ma := self initmatrix.
        mb := self initmatrix.
        self initrand.
        1 to: IRowsize do: [:i | 1 to: IRowsize do: [:j | (mr at: i)
                                at: j put: (self
                                        innerproductOf: ma
                                        and: mb
                                        row: i
                                        column: j)]]

    "Modified: / 13.3.1998 / 12:15:22 / cg"
! !

!IntMMBenchmark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/IntMMBenchmark.st,v 1.6 1998/03/13 15:34:53 cg Exp $'
! !
IntMMBenchmark initialize!
