"{ NameSpace: Benchmarks }"

AbstractBenchmark subclass:#PermBenchmark
	instanceVariableNames:'permarray pctr'
	classVariableNames:'Permcount Permrange'
	poolDictionaries:''
	category:'benchmarks-Self'
!


!PermBenchmark class methodsFor:'constants'!

initialize Permcount := 5. Permrange := 10 "PermBenchmark initialize"

    "Modified: / 13.3.1998 / 12:15:47 / cg"
! !

!PermBenchmark methodsFor:'benchmark operations'!

setup
    1 to:Permrange do:[:i |
        permarray at:i put:(i - 1)
    ]
! !

!PermBenchmark methodsFor:'constants'!

cTimes: mach
mach = 'sun4_260' ifTrue: [^110].
mach = 'sun3_160' ifTrue: [^748].!

fixedBase ^ 1.75!

shortPrintString ^'perm'! !

!PermBenchmark methodsFor:'initialization'!

initialize
        permarray := Array new: Permrange.
        1 to: permarray size do: [:i | permarray at: i put: i - 1]

    "Modified: / 13.3.1998 / 12:15:50 / cg"
! !

!PermBenchmark methodsFor:'private'!

permute: n 
        pctr := pctr + 1.
        n ~= 1
                ifTrue: 
                        [self permute: n - 1.
                        n - 1
                                to: 1
                                by: -1
                                do: 
                                        [:k | 
                                        self swap: n with: k.
                                        self permute: n - 1.
                                        self swap: n with: k]]

    "Modified: / 13.3.1998 / 12:15:51 / cg"
!

swap: a with: b 
        | t |
        t := permarray at: a.
        permarray at: a put: (permarray at: b).
        permarray at: b put: t

    "Modified: / 13.3.1998 / 12:15:56 / cg"
! !

!PermBenchmark methodsFor:'running'!

run
        
        pctr := 0.
        Permcount
                timesRepeat: 
                        [self initialize.
                        self permute: 7].
        pctr ~= (8660 *  Permcount) ifTrue: [self error: 'Error in perm']

    "Modified: / 13.3.1998 / 12:15:54 / cg"
! !

!PermBenchmark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/PermBenchmark.st,v 1.5 1998/03/13 15:34:28 cg Exp $'
! !
PermBenchmark initialize!
