"{ NameSpace: Benchmarks }"

AbstractBenchmark subclass:#QueensBenchmark
	instanceVariableNames:''
	classVariableNames:'Queencount'
	poolDictionaries:''
	category:'benchmarks-Self'
!


!QueensBenchmark class methodsFor:'constants'!

initialize Queencount := 50 "QueensBenchmark initialize"

    "Modified: / 13.3.1998 / 12:16:18 / cg"
! !

!QueensBenchmark methodsFor:'constants'!

cTimes: mach 
        mach = 'sun4_260' ifTrue: [^90].
        mach = 'sun3_160' ifTrue: [^532]!

fixedBase ^1.83! !

!QueensBenchmark methodsFor:'private'!

doQueens
        | i a b c x |
        a := Array new: 9.
        b := Array new: 17.
        c := Array new: 15.
        x := Array new: 9.
        i := -7.
        [i <= 16]
                whileTrue: 
                        [(i >= 1 and: [i <= 8])
                                ifTrue: [a at: i put: true].
                        i >= 2 ifTrue: [b at: i put: true].
                        i <= 7 ifTrue: [c at: i + 8 put: true].
                        i := i + 1].
        (self
                tryI: 1
                A: b
                B: a
                C: c
                X: x)
                ifFalse: [self error: 'Error in queens']

    "Modified: / 13.3.1998 / 12:16:22 / cg"
!

tryI: i A: a B: b C: c X: x 
        | j q |
        j := 0.
        q := false.
        [q not and: [j ~= 8]]
                whileTrue: 
                        [j := j + 1.
                        q := false.
                        ((b at: j)
                                and: [(a at: i + j)
                                                and: [c at: i - j + 8]])
                                ifTrue: 
                                        [x at: i put: j.
                                        b at: j put: false.
                                        a at: i + j put: false.
                                        c at: i - j + 8 put: false.
                                        i < 8
                                                ifTrue: 
                                                        [q := self
                                                                                tryI: i + 1
                                                                                A: a
                                                                                B: b
                                                                                C: c
                                                                                X: x.
                                                        q
                                                                ifFalse: 
                                                                        [b at: j put: true.
                                                                        a at: i + j put: true.
                                                                        c at: i - j + 8 put: true]]
                                                ifFalse: [q := true]]].
        ^q

    "Modified: / 13.3.1998 / 12:16:25 / cg"
! !

!QueensBenchmark methodsFor:'run'!

run
        Queencount timesRepeat: [self doQueens]! !

!QueensBenchmark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/QueensBenchmark.st,v 1.5 1998/03/13 15:36:15 cg Exp $'
! !
QueensBenchmark initialize!
