"{ NameSpace: Benchmarks }"

AbstractBenchmark subclass:#QuicksortBenchmark
	instanceVariableNames:'sortlist biggest littlest'
	classVariableNames:'QSortelements'
	poolDictionaries:''
	category:'benchmarks-Self'
!


!QuicksortBenchmark class methodsFor:'constants'!

initialize QSortelements := 5000 "QuicksortBenchmark initialize"

    "Modified: / 13.3.1998 / 12:16:42 / cg"
! !

!QuicksortBenchmark methodsFor:'constants'!

cTimes: mach 
        mach = 'sun4_260' ifTrue: [^100].
        mach = 'sun3_160' ifTrue: [^588]!

fixedBase ^1.92! !

!QuicksortBenchmark methodsFor:'private'!

initarr
        | temp |
        self initrand.
        biggest := -1000000.
        littlest := 1000000.
        sortlist := Array new: QSortelements. 
        1 to: QSortelements do: 
                [:i | 
                temp := self rand.
                sortlist at: i put: temp - (temp // 100000 * 100000) - 50000.
                (sortlist at: i)
                        > biggest ifTrue: [biggest := sortlist at: i].
                (sortlist at: i)
                        < littlest ifTrue: [littlest := sortlist at: i]]

    "Modified: / 13.3.1998 / 12:16:45 / cg"
!

quicksortA: a L: l R: r 
        " quicksort the array A from start to finish"

        | i j x w |
        i := l.
        j := r.
        x := a at: l + r // 2.
        [i <= j]
                whileTrue: 
                        [[(a at: i)
                                < x]
                                whileTrue: [i := i + 1].
                        [x < (a at: j)]
                                whileTrue: [j := j - 1].
                        i <= j
                                ifTrue: 
                                        [w := a at: i.
                                        a at: i put: (a at: j).
                                        a at: j put: w.
                                        i := i + 1.
                                        j := j - 1]].
        l < j ifTrue: [self
                        quicksortA: a
                        L: l
                        R: j].
        i < r ifTrue: [self
                        quicksortA: a
                        L: i
                        R: r]

    "Modified: / 13.3.1998 / 12:16:48 / cg"
! !

!QuicksortBenchmark methodsFor:'run'!

run
        self initarr.
        self
                quicksortA: sortlist
                L: 1
                R: QSortelements.
        ((sortlist at: 1)
                ~= littlest or: [(sortlist at: QSortelements)
                        ~= biggest])
                ifTrue: [self error: ' Error in Quick.']! !

!QuicksortBenchmark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/QuicksortBenchmark.st,v 1.5 1998/03/13 15:34:40 cg Exp $'
! !
QuicksortBenchmark initialize!
