"{ NameSpace: Benchmarks }"

AbstractBenchmark subclass:#Towers2Benchmark
	instanceVariableNames:'stack movesdone'
	classVariableNames:'Maxcells Sentinel Stackrange'
	poolDictionaries:''
	category:'benchmarks-Self'
!


!Towers2Benchmark class methodsFor:'constants'!

initialize Maxcells := 18. Stackrange := 3. Sentinel := Towers2Disk new discSize: 15. "Towers2Benchmark initialize"

    "Modified: / 13.3.1998 / 12:17:12 / cg"
! !

!Towers2Benchmark methodsFor:'constants'!

cTimes: mach 
        mach = 'sun4_260' ifTrue: [^190].
        mach = 'sun3_160' ifTrue: [^1130]!

fixedBase
        ^2.39! !

!Towers2Benchmark methodsFor:'misc'!

init: s to: n 

        n
                to: 1
                by: -1
                do: [:discctr | self push: (Towers2Disk new discSize: discctr) onto: s]!

moveFrom: s1 to: s2 
        self push: (self pop: s1)
                onto: s2.
        movesdone := movesdone + 1

    "Modified: / 13.3.1998 / 12:17:14 / cg"
!

pop: s 
        | result |
        Sentinel == (stack at: s) ifTrue: [self error: 'empty'].
        result := stack at: s.
        stack at: s put: result next.
        ^result

    "Modified: / 13.3.1998 / 12:17:17 / cg"
!

push: d onto: s 
        | localel |
        localel := stack at: s.
        d >= localel ifTrue: [^self error: 'disc size error'].
        stack at: s put: (d next: localel)

    "Modified: / 13.3.1998 / 12:17:19 / cg"
!

towerI: i j: j k: k 
        | other |
        k = 1
                ifTrue: [self moveFrom: i to: j]
                ifFalse: 
                        [other := 6 - i - j.
                        self
                                towerI: i
                                j: other
                                k: k - 1.
                        self moveFrom: i to: j.
                        self
                                towerI: other
                                j: j
                                k: k - 1]

    "Modified: / 13.3.1998 / 12:17:23 / cg"
! !

!Towers2Benchmark methodsFor:'private'!

error: msg
        super error: 'Error in towers: ', msg! !

!Towers2Benchmark methodsFor:'run'!

makenull: s
        stack at: s put: Sentinel!

run
        stack := Array new: Stackrange.
        self makenull: 1.
        self makenull: 2.
        self makenull: 3.
        self init: 1 to: 14.
        movesdone := 0. 
        self
                towerI: 1
                j: 2
                k: 14.
        movesdone = 16383 ifFalse: [self error: ' Error in towers.'].
        "Towers2Benchmark new run"

    "Modified: / 13.3.1998 / 12:17:21 / cg"
! !

!Towers2Benchmark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/Towers2Benchmark.st,v 1.5 1998/03/13 15:33:53 cg Exp $'
! !
Towers2Benchmark initialize!
