"{ NameSpace: Benchmarks }"

QuicksortBenchmark subclass:#TreeSortBenchmark
	instanceVariableNames:'tree'
	classVariableNames:''
	poolDictionaries:''
	category:'benchmarks-Self'
!


!TreeSortBenchmark methodsFor:'constants'!

cTimes: mach 
        mach = 'sun4_260' ifTrue: [^780].
        mach = 'sun3_160' ifTrue: [^1160]!

fixedBase ^2.5! !

!TreeSortBenchmark methodsFor:'private'!

checkTree: p 
        | result |
        result := true.
        p left notNil ifTrue: [p left val <= p val
                        ifTrue: [result := false]
                        ifFalse: [result := (self checkTree: p left)
                                                        and: [result]]].
        p right notNil ifTrue: [p right val >= p val
                        ifTrue: [result := false]
                        ifFalse: [result := (self checkTree: p right)
                                                        and: [result]]].
        ^result

    "Modified: / 13.3.1998 / 12:18:03 / cg"
!

createNode: n
        ^TreeSortNodeBenchmark new val: n!

insert: n Into: t 
        n > t val
                ifTrue: [t left isNil
                                ifTrue: [t left: (self createNode: n)]
                                ifFalse: [self insert: n Into: t left]]
                ifFalse: [n < t val ifTrue: [t right isNil
                                        ifTrue: [t right: (self createNode: n)]
                                        ifFalse: [self insert: n Into: t right]]]! !

!TreeSortBenchmark methodsFor:'run'!

run
        self initarr.
        tree := TreeSortNodeBenchmark new val: (sortlist at: 1).
        2 to: QSortelements do: [:i | self insert: (sortlist at: i)
                        Into: tree].
        (self checkTree: tree)
                ifFalse: [self error: ' Error in Tree.']

    "Modified: / 13.3.1998 / 12:18:05 / cg"
! !

!TreeSortBenchmark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/self/TreeSortBenchmark.st,v 1.5 1998/03/13 15:33:47 cg Exp $'
! !
