"
 COPYRIGHT (c) 1999 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/business' }"

Object subclass:#CurrencyDatabase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Utilities-Business'
!

!CurrencyDatabase class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1999 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Currency database

    ***** NOTICE & WARNING ****

    provides info about
	currency code (international 3-character code)
	country  name
	currency name

     Based on ISO4217 documentation;
     NO WARRANTY:
	the information presented here may be inaccurate or out of date.
"
! !

!CurrencyDatabase class methodsFor:'queries'!

currencyDataBase
    "return an array filled with currency information;
     each elemnt consists of:
	currency code (international 3-character code)
	country  name
	currency name
     Since some currencies are used in multiple countries,
     some currencies appear for more than one country, under possibly different
     names.
     Pseudo currentcies may have a nil country name.
     Based on ISO4217 documentation;
     NO WARRANTY: the information presented here may be inaccurate or out of date."

    ^ #(

	( 'AED' 'United Arab Emirates' 'Dirham'                             )
	( 'AFA' 'Afghanistan'          'Afghani'                            )
	( 'ALL' 'Albania'              'Lek'                                )
	( 'AMD' 'Armenia'              'Dram'                               )
	( 'ANG' 'Netherlands Antilles' 'Guilder'                            )
	( 'ANG' 'Sint Eustatius'       'Netherlands Antilles Guilder'       )
	( 'ANG' 'Sint Maarten'         'Netherlands Antilles Guilder'       )
	( 'ANG' 'Saba'                 'Netherlands Antilles Guilder'       )
	( 'ANG' 'Curao'               'Netherlands Antilles Guilder'       )
	( 'ANG' 'Bonaire'              'Netherlands Antilles Guilder'       )
	( 'ANG' 'Aruba'                'Netherlands Antilles Guilder'       )
	( 'AON' 'Angola'               'New Kwanza'                         )
	( 'ARP' 'Argentina'            'Peso'                               )
	( 'ATS' 'Austria'              'Schilling'                          )
	( 'AUD' 'Australia'               'Dollar'                          )
	( 'AUD' 'Christmas Island'        'Australian Dollar'               )
	( 'AUD' 'Cocos(Keeling) Islands' 'Australian Dollar'               )
	( 'AUD' 'Heard Island and McDonald Islands' 'Australian Dollar'     )
	( 'AUD' 'Keeling(Cocos) Islands' 'Australian Dollar'               )
	( 'AUD' 'Kiribati'                'Australian Dollar'               )
	( 'AUD' 'McDonald Islands and Heard Island' 'Australian Dollar'     )
	( 'AUD' 'Nauru'                   'Australian Dollar'               )
	( 'AUD' 'Norfolk Island'          'Australian Dollar'               )
	( 'AUD' 'Tuvalu'                  'Australian Dollar'               )
	( 'AWF' 'Aruba'                'Florin'                             )
	( 'AZM' 'Azerbaijan'           'Manat'                              )
	( 'BAK' 'Bosnia and Herzegovina' 'Convertible Mark'                 )
	( 'BAK' 'Herzegovina and Bosnia' 'Convertible Mark'                 )
	( 'BBD' 'Barbados'             'Dollar'                             )
	( 'BDT' 'Bangladesh'           'Taka'                               )
	( 'BEF' 'Belgium'              'Franc'                              )
	( 'BGL' 'Bulgaria'             'Lev'                                )
	( 'BHD' 'Bahrain'              'Dinar'                              )
	( 'BIF' 'Burundi'              'Burundi Franc'                      )
	( 'BMD' 'Bermuda'              'Dollar'                             )
	( 'BND' 'Brunei Darussalam'    'Dollar'                             )
	( 'BOB' 'Bolivia'              'Boliviano'                          )
	( 'BRR' 'Brazil'               'Brazilian Real'                     )
	( 'BSD' 'Bahamas'              'Dollar'                             )
	( 'BTR' 'Bhutan'               'Rupee'                              )
	( 'BWP' 'Botswana'             'Pula'                               )
	( 'BYR' 'Belarus'              'Ruble'                              )
	( 'BZD' 'Belize'               'Dollar'                             )
	( 'CAD' 'Canada'               'Dollar'                             )
	( 'CHF' 'Switzerland'          'Franc'                              )
	( 'CHF' 'Liechtenstein'        'Swiss Franc'                        )
	( 'CLP' 'Chile'                'Peso'                               )
	( 'CNY' 'China'                'Yuan Renminbi'                      )
	( 'COP' 'Colombia'             'Peso'                               )
	( 'CRC' 'Costa Rica'           'Colon'                              )
	( 'CSK' 'Czech Republic'       'Koruna'                             )
	( 'CUP' 'Cuba'                 'Peso'                               )
	( 'CVE' 'Cape Verde'           'Escudo'                             )
	( 'CYP' 'Cyprus'               'Pound'                              )
	( 'DEM' 'Germany'              'Deutsche Mark'                      )
	( 'DJF' 'Djibouti'             'Franc'                              )
	( 'DKK' 'Denmark'              'Krone'                              )
	( 'DKK' 'Greenland'            'Danish Krone'                       )
	( 'DKK' 'Faroe Islands'        'Danish Krone'                       )
	( 'DOP' 'Dominican Republic'   'Peso'                               )
	( 'DZD' 'Algeria'              'Algerian Dinar'                     )
	( 'ECS' 'Ecuador'              'Sucre'                              )
	( 'EEK' 'Estonia'              'Kroon'                              )
	( 'EGP' 'Egypt'                'Pound'                              )
	( 'ERN' 'Eritrea'              'Nakfa'                              )
	( 'ESP' 'Spain'                'Peseta'                             )
	( 'ESP' 'Samoa(American)'      'Spanish Peseta'                     )
	( 'ESP' 'Canary Islands'       'Spanish Peseta'                     )
	( 'ESP' 'Baleares(Balearic Islands)'  'Spanish Peseta'              )
	( 'ESP' 'Andorra'              'Spanish Peseta'                     )
	( 'ESP' 'Amercian Samoa'       'Spanish Peseta'                     )
	( 'ETB' 'Ethiopia'             'Birr'                               )
	( 'ETB' 'Eritrea'              'Ethiopian Birr'                     )
	( 'EUR' 'European Economic and Monetary Union(EMU)'  'Euro'         )
	( 'EUR' 'EMU(European Economic and Monetary Union)'  'Euro'         )
	( 'EUR' nil                                          'Euro'         )
	( 'FIM' 'Finland'              'Markka'                             )
	( 'FJD' 'Fiji'                 'Dollar'                             )
	( 'FKP' 'Falkland Islands(Malvinas)'   'Pound'                      )
	( 'FKP' 'Malvinas(Falkland Islands)'   'Pound'                      )
	( 'FRF' 'France'                       'Franc'                      )
	( 'FRF' 'Saint-Martin'                 'French Francs'              )
	( 'FRF' 'Saint Pierre and Miquelon'    'French Franc'               )
	( 'FRF' 'Runion'                      'French Franc'               )
	( 'FRF' 'Monaco'                       'French Franc'               )
	( 'FRF' 'Miquelon and Saint Pierre'    'French Franc'               )
	( 'FRF' 'Mayotte'                      'French Franc'               )
	( 'FRF' 'Martinique'                   'French Franc'               )
	( 'FRF' 'Guadeloupe'                   'French Franc'               )
	( 'FRF' 'Andorra'                      'French Franc'               )
	( 'FRF' 'French Guiana'                'French Franc'               )
	( 'FRF' 'French Southern Territories'  'French Franc'               )
	( 'GBP' 'Great Britain'                'Pound Sterling'             )
	( 'GBP' 'Britain(Great Britain)'       'Pound Sterling'             )
	( 'GBP' 'England(Great Britain)'       'Pound Sterling'             )
	( 'GBP' 'South Georgia'                'British Pounds'             )
	( 'GBP' 'South Sandwich Islands'       'British Pounds'             )
	( 'GBP' 'United Kingdom(Great Britain)'  'Pound Sterling'           )
	( 'GEL' 'Georgia'              'Lari'                               )
	( 'GHC' 'Ghana'                'Cedi'                               )
	( 'GIP' 'Gibraltar'            'Pound'                              )
	( 'GMD' 'Gambia'               'Dalasi'                             )
	( 'GNF' 'Guinea'               'Franc'                              )
	( 'GRD' 'Greece'               'Drachma'                            )
	( 'GTQ' 'Guatemala'            'Quetzal'                            )
	( 'GYD' 'Guyana'               'Dollar'                             )
	( 'HKD' 'Hong Kong'            'Dollar'                             )
	( 'HNL' 'Honduras'             'Lempira'                            )
	( 'HRK' 'Croatia'              'Kuna'                               )
	( 'HTG' 'Haiti'                'Gourde'                             )
	( 'HUF' 'Hungary'              'Forint'                             )
	( 'IDR' 'Indonesia'            'Rupiah'                             )
	( 'IDR' 'Timor(East)'         'Indonesian Rupiah'                  )
	( 'IDR' 'East Timor'           'Indonesian Rupiah'                  )
	( 'IEP' 'Eire(Ireland)'       'Punt'                               )
	( 'IEP' 'Ireland(Eire)'       'Punt'                               )
	( 'ILS' 'Israel'               'Shekel'                             )
	( 'INR' 'India'                'Rupee'                              )
	( 'INR' 'Bhutan'               'Indian Rupee'                       )
	( 'IQD' 'Iraq'                 'Dinar'                              )
	( 'IRR' 'Iran'                 'Rial'                               )
	( 'ISK' 'Iceland'              'Krona'                              )
	( 'ITL' 'Italy'                       'Lira'                        )
	( 'ITL' 'Holy See (Vatican City)'     'Italian Lira'                )
	( 'ITL' 'San Marino'                  'Italian Lira'                )
	( 'ITL' 'Vatican City(The Holy See)'  'Italian Lira'                )
	( 'JMD' 'Jamaica'              'Dollar'                             )
	( 'JOD' 'Jordan'               'Dinar'                              )
	( 'JPY' 'Japan'                'Yen'                                )
	( 'KES' 'Kenya'                'Shilling'                           )
	( 'KGS' 'Kyrgyzstan'           'Som'                                )
	( 'KHR' 'Cambodia'             'Riel'                               )
	( 'KMF' 'Comoros'              'Franc'                              )
	( 'KPW' 'Korea(North)'        'Won'                                )
	( 'KRW' 'Korea(South)'        'Won'                                )
	( 'KWD' 'Kuwait'               'Dinar'                              )
	( 'KYD' 'Cayman Islands'       'Dollar'                             )
	( 'KZT' 'Kazakstan'            'Tenge'                              )
	( 'LAK' 'Laos'                 'Kip'                                )
	( 'LBP' 'Lebanon'              'Pound'                              )
	( 'LKR' 'Sri Lanka'            'Rupee'                              )
	( 'LRD' 'Liberia'              'Dollar'                             )
	( 'LSL' 'Lesotho'              'Loti'                               )
	( 'LTL' 'Lithuania'            'Lita'                               )
	( 'LUF' 'Luxembourg'           'Franc'                              )
	( 'LVL' 'Latvia'               'Lat'                                )
	( 'LYD' 'Libya'                'Dinar'                              )
	( 'MAD' 'Morocco'              'Dirham'                             )
	( 'MAD' 'Sahara(Western)'     'Moroccan Dirham'                    )
	( 'MAD' 'Western Sahara'       'Moroccan Dirham'                    )
	( 'MDL' 'Moldova'              'Leu'                                )
	( 'MGF' 'Madagascar'           'Malagasy Franc'                     )
	( 'MKD' 'Macedonia'            'Denar'                              )
	( 'MMK' 'Myanmar(Burma)'      'Kyat'                               )
	( 'MMK' 'Burma(Myanmar)'      'Kyat'                               )
	( 'MNT' 'Mongolia'             'Tugrik'                             )
	( 'MOP' 'Macau'                'Pataca'                             )
	( 'MRO' 'Mauritania'           'Ouguiya'                            )
	( 'MTL' 'Malta'                'Lira'                               )
	( 'MUR' 'Mauritius'            'Rupee'                              )
	( 'MVR' 'Maldives(Maldive Islands)' 'Rufiyaa'                      )
	( 'MWK' 'Malawi'               'Kwacha'                             )
	( 'MXP' 'Mexico'               'Peso'                               )
	( 'MYR' 'Malaysia'             'Ringgit'                            )
	( 'MZM' 'Mozambique'           'Metical'                            )
	( 'NAD' 'Namibia'              'Dollar'                             )
	( 'NGN' 'Nigeria'              'Naira'                              )
	( 'NIO' 'Nicaragua'            'Cordoba Oro'                        )
	( 'NLG' 'Holland(The Netherlands)' 'Guilder'                       )
	( 'NLG' 'Netherlands(The)'         'Guilder'                       )
	( 'NLG' 'Dutch(The Netherlands)'   'Guilder'                       )
	( 'NOK' 'Norway'                 'Krone'                            )
	( 'NOK' 'Svalbard and Jan Mayen' 'Norwegian Krone'                  )
	( 'NOK' 'Jan Mayen and Svalbard' 'Norwegian Krone'                  )
	( 'NOK' 'Bouvet Island'          'Norwegian Krone'                  )
	( 'NPR' 'Nepal'                'Nepalese Rupee'                     )
	( 'NZD' 'New Zealand'          'Dollar'                             )
	( 'NZD' 'Tokelau'              'New Zealand Dollar'                 )
	( 'NZD' 'Pitcairn Islands'     'New Zealand Dollar'                 )
	( 'NZD' 'Niue'                 'New Zealand Dollar'                 )
	( 'NZD' 'Cook Islands'         'New Zealand Dollar'                 )
	( 'OMR' 'Oman'                 'Sul Rial'                           )
	( 'PAB' 'Panama'               'Balboa'                             )
	( 'PEN' 'Peru'                 'Nuevo Sol'                          )
	( 'PGK' 'Papua New Guinea'     'Kina'                               )
	( 'PHP' 'Philippines'          'Peso'                               )
	( 'PKR' 'Pakistan'             'Rupee'                              )
	( 'PLZ' 'Poland'               'Zloty'                              )
	( 'PTE' 'Portugal'             'Escudo'                             )
	( 'PTE' 'Madeira Islands'      'Portuguese Escudo'                  )
	( 'PTE' 'Azores'               'Portuguese Escudo'                  )
	( 'PYG' 'Paraguay'             'Guarani'                            )
	( 'QAR' 'Qatar'                'Rial'                               )
	( 'ROL' 'Romania'              'Leu'                                )
	( 'RUR' 'Russia'               'Ruble'                              )
	( 'RUR' 'Tajikistan'           'Russian Ruble'                      )
	( 'RWF' 'Rwanda'               'Rwanda Franc'                       )
	( 'SAR' 'Saudi Arabia'         'Riyal'                              )
	( 'SBD' 'Solomon Islands'      'Dollar'                             )
	( 'SBL' 'Seborga'              'Luigino'                            )
	( 'SCR' 'Seychelles'           'Rupee'                              )
	( 'SDD' 'Sudan'                'Dinar'                              )
	( 'SEK' 'Sweden'               'Krona'                              )
	( 'SGD' 'Singapore'            'Dollar'                             )
	( 'SHP' 'Saint Helena'         'Pound'                              )
	( 'SIT' 'Slovenia'             'Tolar'                              )
	( 'SKK' 'Slovakia'             'Koruna'                             )
	( 'SLL' 'Sierra Leone'         'Leone'                              )
	( 'SOS' 'Somalia'              'Shilling'                           )
	( 'SRG' 'Suriname'             'Guilder'                            )
	( 'STD' 'So Tome and Principe' 'Dobra'                             )
	( 'STD' 'Principe and So Tome' 'Dobra'                             )
	( 'SVC' 'El Salvador'          'Colon'                              )
	( 'SYP' 'Syria'                'Pound'                              )
	( 'SZL' 'Swaziland'            'Lilangeni'                          )
	( 'THB' 'Thailand'             'Baht'                               )
	( 'TJR' 'Tajikistan'           'Ruble'                              )
	( 'TMM' 'Turkmenistan'         'Manat'                              )
	( 'TND' 'Tunisia'              'Dinar'                              )
	( 'TOP' 'Tonga'                'Pa''anga'                           )
	( 'TRL' 'Turkey'               'Lira'                               )
	( 'TTD' 'Trinidad and Tobago'  'Dollar'                             )
	( 'TTD' 'Tobago and Trinidad'  'Dollar'                             )
	( 'TWD' 'Taiwan'               'Dollar'                             )
	( 'TZS' 'Tanzania'             'Shilling'                           )
	( 'UAH' 'Ukraine'              'Hryvnia'                            )
	( 'UGX' 'Uganda'               'Shilling'                           )
	( 'USD' 'America(United States of America)'   'US Dollar'          )
	( 'USD' 'American Samoa'                       'US Dollar'          )
	( 'USD' 'American Virgin Islands'              'US Dollar'          )
	( 'USD' 'British Indian Ocean Territory'       'US Dollar'          )
	( 'USD' 'British Virgin Islands'               'US Dollar'          )
	( 'USD' 'Caicos and Turks Islands'             'US Dollar'          )
	( 'USD' 'Guam'                                 'US Dollar'          )
	( 'USD' 'Haiti'                                'US Dollar'          )
	( 'USD' 'Mariana Islands(Northern)'           'US Dollar'          )
	( 'USD' 'Marshall Islands'                     'US Dollar'          )
	( 'USD' 'Micronesia(Federated States of)'     'US Dollar'          )
	( 'USD' 'Midway Islands'                       'US Dollar'          )
	( 'USD' 'Northern Mariana Islands'             'US Dollar'          )
	( 'USD' 'Palau'                                'US Dollar'          )
	( 'USD' 'Panama'                               'US Dollar'          )
	( 'USD' 'Puerto Rico'                          'US Dollar'          )
	( 'USD' 'Samoa(American)'                     'US Dollar'          )
	( 'USD' 'Turks and Caicos Islands'             'US Dollar'          )
	( 'USD' 'US Virgin Islands'                    'US Dollar'          )
	( 'USD' 'United States Minor Outlying Islands' 'US Dollar'          )
	( 'USD' 'United States of America'             'US Dollar'          )
	( 'USD' 'Virgin Islands(American)'            'US Dollar'          )
	( 'USD' 'Virgin Islands(British)'             'US Dollar'          )
	( 'USD' 'Wake Island'                          'US Dollar'          )
	( 'UYU' 'Uruguay'              'Peso'                               )
	( 'UZS' 'Uzbekistan'           'Som'                                )
	( 'VEB' 'Venezuela'            'Bolivar'                            )
	( 'VND' 'Viet Nam'             'Dong'                               )
	( 'VUV' 'Vanuatu'              'Vatu'                               )
	( 'WST' 'West Samoa'           'Tala'                               )
	( 'XAF' 'Gabon'                        'CFA Franc BEAC'             )
	( 'XAF' 'Equatorial Guinea'            'CFA Franc BEAC'             )
	( 'XAF' 'Congo'                        'CFA Franc BEAC'             )
	( 'XAF' 'Central African Republic'     'CFA Franc BEAC'             )
	( 'XAF' 'Cameroon'                     'CFA Franc BEAC'             )
	( 'XAF' 'Chad'                         'CFA Franc BEAC'             )
	( 'XAG' nil                    'Silver Ounces'                      )
	( 'XAU' nil                    'Gold Ounces'                        )
	( 'XCD' 'Saint Kitts and Nevis'                'East Caribbean Dollar'   )
	( 'XCD' 'Saint Lucia'                          'East Caribbean Dollar'   )
	( 'XCD' 'Saint Vincent and The Grenadines'     'East Caribbean Dollar'   )
	( 'XCD' 'Saint Christopher'                    'East Caribbean Dollar'   )
	( 'XCD' 'Nevis and Saint Kitts'                'East Caribbean Dollar'   )
	( 'XCD' 'Montserrat'                           'East Caribbean Dollar'   )
	( 'XCD' 'Grenada'                              'East Caribbean Dollar'   )
	( 'XCD' 'Grenadines(The) and Saint Vincent'    'East Caribbean Dollar'   )
	( 'XCD' 'Dominica'                             'East Caribbean Dollar'   )
	( 'XCD' 'Barbuda and Antigua'                  'East Caribbean Dollar'   )
	( 'XCD' 'Anguilla'                             'East Caribbean Dollar'   )
	( 'XCD' 'Antigua and Barbuda'                  'East Caribbean Dollar'   )
	( 'XDR' nil                    'Special Drawing Right'                   )
	( 'XDR' nil                    'IMF Special Drawing Right'               )
	( 'XOF' 'Togo'                 'CFA Franc BCEAO'                         )
	( 'XOF' 'Senegal'              'CFA Franc BCEAO'                         )
	( 'XOF' 'Niger'                'CFA Franc BCEAO'                         )
	( 'XOF' 'Mali'                 'CFA Franc BCEAO'                         )
	( 'XOF' 'Ivory Coast'          'CFA Franc BCEAO'                         )
	( 'XOF' 'Guinea-Bissau'        'CFA Franc BCEAO'                         )
	( 'XOF' 'Cte D''Ivoire'       'CFA Franc BCEAO'                         )
	( 'XOF' 'Burkina Faso'         'CFA Franc BCEAO'                         )
	( 'XOF' 'Benin'                'CFA Franc BCEAO'                         )
	( 'XPD' nil                    'Palladium Ounces'                        )
	( 'XPF' nil                                         'CFP Franc'          )
	( 'XPF' 'Wallis and Futuna Islands'                 'CFP Franc'          )
	( 'XPF' 'New Caledonia'                             'CFP Franc'          )
	( 'XPF' 'Futuna and Wallis Islands'                 'CFP Franc'          )
	( 'XPF' 'French Polynesia(French Pacific Islands)'  'CFP Franc'          )
	( 'XPF' 'French Pacific Islands(French Polynesia)'  'CFP Franc'          )
	( 'XPT' nil                    'Platinum Ounces'                         )
	( 'YER' 'Yemen'                'Rial'                                    )
	( 'YUN' 'Yugoslavia'            'New Dinar'                              )
	( 'YUN' 'Serbia and Montenegro' 'Yugoslav New Dinar'                     )
	( 'YUN' 'Montenegro and Serbia' 'Yugoslav New Dinar'                     )
	( 'ZAR' 'South Africa'         'Rand'                                    )
	( 'ZAR' 'Namibia'              'South African Rand'                      )
	( 'ZAR' 'Lesotho'              'South African Rand'                      )
	( 'ZMK' 'Zambia'               'Kwacha'                                  )
	( 'ZRN' 'Zaire'                'New Zaire'                               )
	( 'ZWD' 'Zimbabwe'             'Zimbabwe Dollar'                         )

)


! !

!CurrencyDatabase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/business/CurrencyDatabase.st,v 1.3 2005/07/06 08:31:28 cg Exp $'
! !
