"
 COPYRIGHT (c) 2004 eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/business' }"

Object subclass:#LanguageCodeDatabase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Utilities-Business'
!

!LanguageCodeDatabase class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2004 eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Language database

    ***** NOTICE & WARNING ****

    provides info about
        language name
        language code (both 2-letter and 3-letter)

     Based on ISO639 documentation;

     Info on ISO639 is found here: 
        http://www.loc.gov/standards/iso639-2
        http://www.loc.gov/standards/iso639-2/langcodes.html

     NO WARRANTY: 
        the information presented here may be inaccurate or out of date.
"
!

originalData
"
    The information here was extracted from:
        http://www.loc.gov/standards/iso639-2/ISO-639-2_values_8bits.txt

    columns are:
        3-letter language code
        alternative 3-letter language code
        2-letter language code (empty for many languages)
        english name of language
        french name of language

    The files original contents is
------------------------------------
aar||aa|Afar|afar
abk||ab|Abkhazian|abkhaze
ace|||Achinese|aceh
ach|||Acoli|acoli
ada|||Adangme|adangme
ady|||Adyghe; Adygei|adygh
afa|||Afro-Asiatic (Other)|afro-asiatiques, autres langues
afh|||Afrihili|afrihili
afr||af|Afrikaans|afrikaans
aka||ak|Akan|akan
akk|||Akkadian|akkadien
alb|sqi|sq|Albanian|albanais
alb|sqi|sq|Albanian|albanais
ale|||Aleut|aloute
alg|||Algonquian languages|algonquines, langues
amh||am|Amharic|amharique
ang|||English, Old (ca.450-1100)|anglo-saxon (ca.450-1100)
apa|||Apache languages|apache
ara||ar|Arabic|arabe
arc|||Aramaic|aramen
arg||an|Aragonese|aragonais
arm|hye|hy|Armenian|armnien
arm|hye|hy|Armenian|armnien
arn|||Araucanian|araucan
arp|||Arapaho|arapaho
art|||Artificial (Other)|artificielles, autres langues
arw|||Arawak|arawak
asm||as|Assamese|assamais
ast|||Asturian; Bable|asturien; bable
ath|||Athapascan languages|athapascanes, langues
aus|||Australian languages|australiennes, langues
ava||av|Avaric|avar
ave||ae|Avestan|avestique
awa|||Awadhi|awadhi
aym||ay|Aymara|aymara
aze||az|Azerbaijani|azri
bad|||Banda|banda
bai|||Bamileke languages|bamilks, langues
bak||ba|Bashkir|bachkir
bal|||Baluchi|baloutchi
bam||bm|Bambara|bambara
ban|||Balinese|balinais
baq|eus|eu|Basque|basque
baq|eus|eu|Basque|basque
bas|||Basa|basa
bat|||Baltic (Other)|baltiques, autres langues
bej|||Beja|bedja
bel||be|Belarusian|bilorusse
bem|||Bemba|bemba
ben||bn|Bengali|bengali
ber|||Berber (Other)|berbres, autres langues
bho|||Bhojpuri|bhojpuri
bih||bh|Bihari|bihari
bik|||Bikol|bikol
bin|||Bini|bini
bis||bi|Bislama|bichlamar
bla|||Siksika|blackfoot
bnt|||Bantu (Other)|bantoues, autres langues
bos||bs|Bosnian|bosniaque
bra|||Braj|braj
bre||br|Breton|breton
btk|||Batak (Indonesia)|batak (Indonsie)
bua|||Buriat|bouriate
bug|||Buginese|bugi
bul||bg|Bulgarian|bulgare
bur|mya|my|Burmese|birman
bur|mya|my|Burmese|birman
byn|||Blin; Bilin|blin; bilen
cad|||Caddo|caddo
cai|||Central American Indian (Other)|indiennes d'Amrique centrale, autres langues
car|||Carib|caribe
cat||ca|Catalan; Valencian|catalan; valencien
cau|||Caucasian (Other)|caucasiennes, autres langues
ceb|||Cebuano|cebuano
cel|||Celtic (Other)|celtiques, autres langues
cha||ch|Chamorro|chamorro
chb|||Chibcha|chibcha
che||ce|Chechen|tchtchne
chg|||Chagatai|djaghata
chi|zho|zh|Chinese|chinois
chi|zho|zh|Chinese|chinois
chk|||Chuukese|chuuk
chm|||Mari|mari
chn|||Chinook jargon|chinook, jargon
cho|||Choctaw|choctaw
chp|||Chipewyan|chipewyan
chr|||Cherokee|cherokee
chu||cu|Church Slavic; Old Slavonic; Church Slavonic; Old Bulgarian; Old Church Slavonic|slavon d'glise; vieux slave; slavon liturgique; vieux bulgare
chv||cv|Chuvash|tchouvache
chy|||Cheyenne|cheyenne
cmc|||Chamic languages|chames, langues
cop|||Coptic|copte
cor||kw|Cornish|cornique
cos||co|Corsican|corse
cpe|||Creoles and pidgins, English based (Other)|croles et pidgins anglais, autres
cpf|||Creoles and pidgins, French-based (Other)|croles et pidgins franais, autres
cpp|||Creoles and pidgins, Portuguese-based (Other)|croles et pidgins portugais, autres
cre||cr|Cree|cree
crh|||Crimean Tatar; Crimean Turkish|tatar de Crim
crp|||Creoles and pidgins (Other)|croles et pidgins divers
csb|||Kashubian|kachoube
cus|||Cushitic (Other)|couchitiques, autres langues
cze|ces|cs|Czech|tchque
cze|ces|cs|Czech|tchque
dak|||Dakota|dakota
dan||da|Danish|danois
dar|||Dargwa|dargwa
day|||Dayak|dayak
del|||Delaware|delaware
den|||Slave (Athapascan)|esclave (athapascan)
dgr|||Dogrib|dogrib
din|||Dinka|dinka
div||dv|Divehi|maldivien
doi|||Dogri|dogri
dra|||Dravidian (Other)|dravidiennes, autres langues
dsb|||Lower Sorbian|bas-sorabe
dua|||Duala|douala
dum|||Dutch, Middle (ca.1050-1350)|nerlandais moyen (ca. 1050-1350)
dut|nld|nl|Dutch; Flemish|nerlandais; flamand
dut|nld|nl|Dutch; Flemish|nerlandais; flamand
dyu|||Dyula|dioula
dzo||dz|Dzongkha|dzongkha
efi|||Efik|efik
egy|||Egyptian (Ancient)|gyptien
eka|||Ekajuk|ekajuk
elx|||Elamite|lamite
eng||en|English|anglais
enm|||English, Middle (1100-1500)|anglais moyen (1100-1500)
epo||eo|Esperanto|espranto
est||et|Estonian|estonien
ewe||ee|Ewe|w
ewo|||Ewondo|wondo
fan|||Fang|fang
fao||fo|Faroese|froen
fat|||Fanti|fanti
fij||fj|Fijian|fidjien
fin||fi|Finnish|finnois
fiu|||Finno-Ugrian (Other)|finno-ougriennes, autres langues
fon|||Fon|fon
fre|fra|fr|French|franais
frm|||French, Middle (ca.1400-1800)|franais moyen (1400-1800)
fro|||French, Old (842-ca.1400)|franais ancien (842-ca.1400)
fry||fy|Frisian|frison
ful||ff|Fulah|peul
fur|||Friulian|frioulan
gaa|||Ga|ga
gay|||Gayo|gayo
gba|||Gbaya|gbaya
gem|||Germanic (Other)|germaniques, autres langues
geo|kat|ka|Georgian|gorgien
geo|kat|ka|Georgian|gorgien
ger|deu|de|German|allemand
ger|deu|de|German|allemand
gez|||Geez|guze
gil|||Gilbertese|kiribati
gla||gd|Gaelic; Scottish Gaelic|galique; galique cossais
gle||ga|Irish|irlandais
glg||gl|Gallegan|galicien
glv||gv|Manx|manx; mannois
gmh|||German, Middle High (ca.1050-1500)|allemand, moyen haut (ca. 1050-1500)
goh|||German, Old High (ca.750-1050)|allemand, vieux haut (ca. 750-1050)
gon|||Gondi|gond
gor|||Gorontalo|gorontalo
got|||Gothic|gothique
grb|||Grebo|grebo
grc|||Greek, Ancient (to 1453)|grec ancien (jusqu' 1453)
gre|ell|el|Greek, Modern (1453-)|grec moderne (aprs 1453)
gre|ell|el|Greek, Modern (1453-)|grec moderne (aprs 1453)
grn||gn|Guarani|guarani
guj||gu|Gujarati|goudjrati
gwi|||Gwichin|gwichin
hai|||Haida|haida
hat||ht|Haitian; Haitian Creole|hatien; crole hatien
hau||ha|Hausa|haoussa
haw|||Hawaiian|hawaen
heb||he|Hebrew|hbreu
her||hz|Herero|herero
hil|||Hiligaynon|hiligaynon
him|||Himachali|himachali
hin||hi|Hindi|hindi
hit|||Hittite|hittite
hmn|||Hmong|hmong
hmo||ho|Hiri Motu|hiri motu
hsb|||Upper Sorbian|haut-sorabe
hun||hu|Hungarian|hongrois
hup|||Hupa|hupa
iba|||Iban|iban
ibo||ig|Igbo|igbo
ice|isl|is|Icelandic|islandais
ice|isl|is|Icelandic|islandais
ido||io|Ido|ido
iii||ii|Sichuan Yi|yi de Sichuan
ijo|||Ijo|ijo
iku||iu|Inuktitut|inuktitut
ile||ie|Interlingue|interlingue
ilo|||Iloko|ilocano
ina||ia|Interlingua (International Auxiliary Language Association)|interlingua (langue auxiliaire internationale)
inc|||Indic (Other)|indo-aryennes, autres langues
ind||id|Indonesian|indonsien
ine|||Indo-European (Other)|indo-europennes, autres langues
inh|||Ingush|ingouche
ipk||ik|Inupiaq|inupiaq
ira|||Iranian (Other)|iraniennes, autres langues
iro|||Iroquoian languages|iroquoises, langues (famille)
ita||it|Italian|italien
jav||jv|Javanese|javanais
jbo|||Lojban|lojban
jpn||ja|Japanese|japonais
jpr|||Judeo-Persian|judo-persan
jrb|||Judeo-Arabic|judo-arabe
kaa|||Kara-Kalpak|karakalpak
kab|||Kabyle|kabyle
kac|||Kachin|kachin
kal||kl|Kalaallisut; Greenlandic|groenlandais
kam|||Kamba|kamba
kan||kn|Kannada|kannada
kar|||Karen|karen
kas||ks|Kashmiri|kashmiri
kau||kr|Kanuri|kanouri
kaw|||Kawi|kawi
kaz||kk|Kazakh|kazakh
kbd|||Kabardian|kabardien
kha|||Khasi|khasi
khi|||Khoisan (Other)|khoisan, autres langues
khm||km|Khmer|khmer
kho|||Khotanese|khotanais
kik||ki|Kikuyu; Gikuyu|kikuyu
kin||rw|Kinyarwanda|rwanda
kir||ky|Kirghiz|kirghize
kmb|||Kimbundu|kimbundu
kok|||Konkani|konkani
kom||kv|Komi|kom
kon||kg|Kongo|kongo
kor||ko|Korean|coren
kos|||Kosraean|kosrae
kpe|||Kpelle|kpell
krc|||Karachay-Balkar|karatcha balkar
kro|||Kru|krou
kru|||Kurukh|kurukh
kua||kj|Kuanyama; Kwanyama|kuanyama; kwanyama
kum|||Kumyk|koumyk
kur||ku|Kurdish|kurde
kut|||Kutenai|kutenai
lad|||Ladino|judo-espagnol
lah|||Lahnda|lahnda
lam|||Lamba|lamba
lao||lo|Lao|lao
lat||la|Latin|latin
lav||lv|Latvian|letton
lez|||Lezghian|lezghien
lim||li|Limburgan; Limburger; Limburgish|limbourgeois
lin||ln|Lingala|lingala
lit||lt|Lithuanian|lituanien
lol|||Mongo|mongo
loz|||Lozi|lozi
ltz||lb|Luxembourgish; Letzeburgesch|luxembourgeois
lua|||Luba-Lulua|luba-lulua
lub||lu|Luba-Katanga|luba-katanga
lug||lg|Ganda|ganda
lui|||Luiseno|luiseno
lun|||Lunda|lunda
luo|||Luo (Kenya and Tanzania)|luo (Kenya et Tanzanie)
lus|||lushai|Lushai
mac|mkd|mk|Macedonian|macdonien
mac|mkd|mk|Macedonian|macdonien
mad|||Madurese|madourais
mag|||Magahi|magahi
mah||mh|Marshallese|marshall
mai|||Maithili|maithili
mak|||Makasar|makassar
mal||ml|Malayalam|malayalam
man|||Mandingo|mandingue
mao|mri|mi|Maori|maori
mao|mri|mi|Maori|maori
map|||Austronesian (Other)|malayo-polynsiennes, autres langues
mar||mr|Marathi|marathe
mas|||Masai|massa
may|msa|ms|Malay|malais
may|msa|ms|Malay|malais
mdf|||Moksha|moksa
mdr|||Mandar|mandar
men|||Mende|mend
mga|||Irish, Middle (900-1200)|irlandais moyen (900-1200)
mic|||Micmac|micmac
min|||Minangkabau|minangkabau
mis|||Miscellaneous languages|diverses, langues
mkh|||Mon-Khmer (Other)|mn-khmer, autres langues
mlg||mg|Malagasy|malgache
mlt||mt|Maltese|maltais
mnc|||Manchu|mandchou
mni|||Manipuri|manipuri
mno|||Manobo languages|manobo, langues
moh|||Mohawk|mohawk
mol||mo|Moldavian|moldave
mon||mn|Mongolian|mongol
mos|||Mossi|mor
mul|||Multiple languages|multilingue
mun|||Munda languages|mounda, langues
mus|||Creek|muskogee
mwr|||Marwari|marvari
myn|||Mayan languages|maya, langues
myv|||Erzya|erza
nah|||Nahuatl|nahuatl
nai|||North American Indian|indiennes d'Amrique du Nord, autres langues
nap|||Neapolitan|napolitain
nau||na|Nauru|nauruan
nav||nv|Navajo; Navaho|navaho
nbl||nr|Ndebele, South; South Ndebele|ndbl du Sud
nde||nd|Ndebele, North; North Ndebele|ndbl du Nord
ndo||ng|Ndonga|ndonga
nds|||Low German; Low Saxon; German, Low; Saxon, Low|bas allemand; bas saxon; allemand, bas; saxon, bas
nep||ne|Nepali|npalais
new|||Newari|newari
nia|||Nias|nias
nic|||Niger-Kordofanian (Other)|nigro-congolaises, autres langues
niu|||Niuean|niu
nno||nn|Norwegian Nynorsk; Nynorsk, Norwegian|norvgien nynorsk; nynorsk, norvgien
nob||nb|Norwegian Bokml; Bokml, Norwegian|norvgien bokml; bokml, norvgien
nog|||Nogai|noga; nogay
non|||Norse, Old|norrois, vieux
nor||no|Norwegian|norvgien
nso|||Sotho, Northern|sotho du Nord
nub|||Nubian languages|nubiennes, langues
nya||ny|Chichewa; Chewa; Nyanja|chichewa; chewa; nyanja
nym|||Nyamwezi|nyamwezi
nyn|||Nyankole|nyankol
nyo|||Nyoro|nyoro
nzi|||Nzima|nzema
oci||oc|Occitan (post 1500); Provenal|occitan (aprs 1500); provenal
oji||oj|Ojibwa|ojibwa
ori||or|Oriya|oriya
orm||om|Oromo|galla
osa|||Osage|osage
oss||os|Ossetian; Ossetic|osste
ota|||Turkish, Ottoman (1500-1928)|turc ottoman (1500-1928)
oto|||Otomian languages|otomangue, langues
paa|||Papuan (Other)|papoues, autres langues
pag|||Pangasinan|pangasinan
pal|||Pahlavi|pahlavi
pam|||Pampanga|pampangan
pan||pa|Panjabi; Punjabi|pendjabi
pap|||Papiamento|papiamento
pau|||Palauan|palau
peo|||Persian, Old (ca.600-400 B.C.)|perse, vieux (ca. 600-400 av. J.-C.)
per|fas|fa|Persian|persan
per|fas|fa|Persian|persan
phi|||Philippine (Other)|philippines, autres langues
phn|||Phoenician|phnicien
pli||pi|Pali|pali
pol||pl|Polish|polonais
pon|||Pohnpeian|pohnpei
por||pt|Portuguese|portugais
pra|||Prakrit languages|prkrit
pro|||Provenal, Old (to 1500)|provenal ancien (jusqu' 1500)
pus||ps|Pushto|pachto
qaa-qtz |||Reserved for local use|rserve  l'usage local
que||qu|Quechua|quechua
raj|||Rajasthani|rajasthani
rap|||Rapanui|rapanui
rar|||Rarotongan|rarotonga
roa|||Romance (Other)|romanes, autres langues
roh||rm|Raeto-Romance|rhto-roman
rom|||Romany|tsigane
rum|ron|ro|Romanian|roumain
run||rn|Rundi|rundi
rus||ru|Russian|russe
sad|||Sandawe|sandawe
sag||sg|Sango|sango
sah|||Yakut|iakoute
sai|||South American Indian (Other)|indiennes d'Amrique du Sud, autres langues
sal|||Salishan languages|salish, langues
sam|||Samaritan Aramaic|samaritain
san||sa|Sanskrit|sanskrit
sas|||Sasak|sasak
sat|||Santali|santal
scc|srp|sr|Serbian|serbe
scc|srp|sr|Serbian|serbe
sco|||Scots|cossais
scr|hrv|hr|Croatian|croate
scr|hrv|hr|Croatian|croate
sel|||Selkup|selkoupe
sem|||Semitic (Other)|smitiques, autres langues
sga|||Irish, Old (to 900)|irlandais ancien (jusqu' 900)
sgn|||Sign Languages|langues des signes
shn|||Shan|chan
sid|||Sidamo|sidamo
sin||si|Sinhalese|singhalais
sio|||Siouan languages|sioux, langues
sit|||Sino-Tibetan (Other)|sino-tibtaines, autres langues
sla|||Slavic (Other)|slaves, autres langues
slo|slk|sk|Slovak|slovaque
slv||sl|Slovenian|slovne
sma|||Southern Sami|sami du Sud
sme||se|Northern Sami|sami du Nord
smi|||Sami languages (Other)|sami, autres langues
smj|||Lule Sami|sami de Lule
smn|||Inari Sami|sami d'Inari
smo||sm|Samoan|samoan
sms|||Skolt Sami|sami skolt
sna||sn|Shona|shona
snd||sd|Sindhi|sindhi
snk|||Soninke|sonink
sog|||Sogdian|sogdien
som||so|Somali|somali
son|||Songhai|songhai
sot||st|Sotho, Southern|sotho du Sud
spa||es|Spanish; Castilian|espagnol; castillan
srd||sc|Sardinian|sarde
srr|||Serer|srre
ssa|||Nilo-Saharan (Other)|nilo-sahariennes, autres langues
ssw||ss|Swati|swati
suk|||Sukuma|sukuma
sun||su|Sundanese|soundanais
sus|||Susu|soussou
sux|||Sumerian|sumrien
swa||sw|Swahili|swahili
swe||sv|Swedish|sudois
syr|||Syriac|syriaque
tah||ty|Tahitian|tahitien
tai|||Tai (Other)|thaes, autres langues
tam||ta|Tamil|tamoul
tat||tt|Tatar|tatar
tel||te|Telugu|tlougou
tem|||Timne|temne
ter|||Tereno|tereno
tet|||Tetum|tetum
tgk||tg|Tajik|tadjik
tgl||tl|Tagalog|tagalog
tha||th|Thai|tha
tib|bod|bo|Tibetan|tibtain
tib|bod|bo|Tibetan|tibtain
tig|||Tigre|tigr
tir||ti|Tigrinya|tigrigna
tiv|||Tiv|tiv
tkl|||Tokelau|tokelau
tli|||Tlingit|tlingit
tmh|||Tamashek|tamacheq
tog|||Tonga (Nyasa)|tonga (Nyasa)
ton||to|Tonga (Tonga Islands)|tongan (les Tonga)
tpi|||Tok Pisin|tok pisin
tsi|||Tsimshian|tsimshian
tsn||tn|Tswana|tswana
tso||ts|Tsonga|tsonga
tuk||tk|Turkmen|turkmne
tum|||Tumbuka|tumbuka
tup|||Tupi languages|tupi, langues
tur||tr|Turkish|turc
tut|||Altaic (Other)|altaques, autres langues
tvl|||Tuvalu|tuvalu
twi||tw|Twi|twi
tyv|||Tuvinian|touva
udm|||Udmurt|oudmourte
uga|||Ugaritic|ougaritique
uig||ug|Uighur|ougour
ukr||uk|Ukrainian|ukrainien
umb|||Umbundu|umbundu
und|||Undetermined|indtermine
urd||ur|Urdu|ourdou
uzb||uz|Uzbek|ouszbek
vai|||Vai|va
ven||ve|Venda|venda
vie||vi|Vietnamese|vietnamien
vol||vo|Volapk|volapk
vot|||Votic|vote
wak|||Wakashan languages|wakashennes, langues
wal|||Walamo|walamo
war|||Waray|waray
was|||Washo|washo
wel|cym|cy|Welsh|gallois
wel|cym|cy|Welsh|gallois
wen|||Sorbian languages|sorabes, langues
wln||wa|Walloon|wallon
wol||wo|Wolof|wolof
xal|||Kalmyk|kalmouk
xho||xh|Xhosa|xhosa
yao|||Yao|yao
yap|||Yapese|yapois
yid||yi|Yiddish|yiddish
yor||yo|Yoruba|yoruba
ypk|||Yupik languages|yupik, langues
zap|||Zapotec|zapotque
zen|||Zenaga|zenaga
zha||za|Zhuang; Chuang|zhuang; chuang
znd|||Zande|zand
zul||zu|Zulu|zoulou
zun|||Zuni|zuni
"
! !

!LanguageCodeDatabase class methodsFor:'queries'!

languageCode2For:languageName
    "return the 2-character ISO639-1 languageCode for a given language.
     See #languageDataBase for valid names"

    |ucName|

    ucName := languageName asLowercase asUppercaseFirst.
    ^ (self languageDataBase detect:[:entry | (entry at:4) = ucName]) third

    "
     (LanguageCodeDatabase languageCode2For:'afrikaans')      
     (LanguageCodeDatabase languageCode2For:'japanese')      
    "
!

languageCode3For:languageName
    "return the 3-character ISO639-2 languageCode for a given language.
     See #languageDataBase for valid names"

    |ucName|

    ucName := languageName asLowercase asUppercaseFirst.
    ^ (self languageDataBase detect:[:entry | (entry at:4) = ucName]) first

    "
     (LanguageCodeDatabase languageCode3For:'afrikaans')      
     (LanguageCodeDatabase languageCode3For:'japanese')      
    "
!

languageDataBase
    "return an array filled with language information;
     each element consists of:
        1) 3-letter language code (ISO639-2)
        2) alternative 3-letter language code (ISO639-2)
        3) 2-letter language code (ISO639-1)
        4) language name english
        5) language name french

     Based on ISO639 documentation;

     NO WARRANTY: 
        the information presented here may be inaccurate or out of date."

    |lines idx|

    lines := (self class compiledMethodAt:#originalData) source asStringCollection.
    idx := lines findFirst:[:l | l startsWith:'-----'].
    lines := lines copyFrom:idx+1.
    lines := lines select:[:line | line includes:$|].
    ^ lines collect:[:line |
        |fields|

        fields := line asCollectionOfSubstringsSeparatedBy:$|.
        fields
    ].

    "
     self languageDataBase
    "
! !

!LanguageCodeDatabase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/business/LanguageCodeDatabase.st,v 1.1 2004/02/11 16:55:09 cg Exp $'
! !
