'From Smalltalk/X, Version:6.1.2 on 29-08-2010 at 14:04:04'                     !

Application subclass:#ClKernel
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:'ClConstants'
	category:'Constraints-Cassovary-Kernel'
!

!ClKernel class methodsFor:'uncategorized public'!

_PRAGMA_ClConstants

    "%%PRAGMA DECLARE  
        (name: ClConstants isPool: true isConstant: false)
        (name: ExCLError pool: ClConstants)
        (name: ExCLInternalError pool: ClConstants)
        (name: ExCLNotEnoughStays pool: ClConstants)
        (name: ExCLRequiredFailure pool: ClConstants)
        (name: ExCLTooDifficult pool: ClConstants)
        (name: ExCLNonlinearExpression pool: ClConstants)
        (name: ClEpsilon pool: ClConstants)
    "
!

initializeExceptions
    "ACTION
        Note that a variable must be declared for each exception to reside
        in.  The variables are declared in the toBeLoadedCode.
    "

    ExCLError isNil
        ifTrue: [
            ExCLError :=
                (ExError newChild)
                    description: '(ExCLError) An error has occured in CL';
                    yourself].
    ExCLInternalError isNil
        ifTrue: [ 
            ExCLInternalError :=
                (ExCLError newChild)
                    description: '(ExCLInternalError) An internal error has occurred';
                    yourself].
    ExCLTooDifficult isNil
        ifTrue: [
            ExCLTooDifficult :=
                (ExCLError newChild)
                    description: '(ExCLTooDifficult) The constraints are too difficult to solve';
                    yourself].
    ExCLRequiredFailure isNil
        ifTrue: [
            ExCLRequiredFailure :=
                (ExCLError newChild)
                    description: '(ExCLRequiredFailure) A required constraint cannot be satisfied';
                    yourself].
    ExCLNotEnoughStays isNil
        ifTrue: [
            ExCLNotEnoughStays :=
                (ExCLError newChild)
                    description: '(ExCLNotEnoughStays) There are not enough stays to give specific values to every variable';
                    yourself].
    ExCLNonlinearExpression isNil
        ifTrue: [
            ExCLNonlinearExpression :=
                (ExCLError newChild)
                    description: '(ExCLNonlinearExpression) The resulting expression would be nonlinear';
                    yourself].
!

loaded
    "ACTION
        Set up the exceptions.
    "
    super loaded.
    self initializeExceptions.
    self setEpsilon.

!

setEpsilon
    "ACTION
        Set the shared fudge factor for use in testing floats for equality, symbolic weights for
        non-negativity, etc.  This could be changed if an application uses numbers with a very
        different scale.
    "
    ClEpsilon := 1.0e-8.


! !

