"{ Package: 'stx:goodies/communication' }"

Object subclass:#DNSQuery
	instanceVariableNames:'name type dclass'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-DNS'
!

!DNSQuery class methodsFor:'documentation'!

documentation
"
    no warranty; provided AS-IS
    code ported from squeak
"

    "Created: / 22-11-2006 / 12:48:56 / cg"
! !

!DNSQuery class methodsFor:'instance creation'!

name: aString type: anInteger class: bInteger
	^ self new name: aString; type: anInteger; dclass: bInteger
!

readFrom: aStream
	^ self name: (DNSRecord readNameFrom: aStream) type: (aStream nextNumber: 2) class: (aStream nextNumber: 2)
! !

!DNSQuery methodsFor:'accessing'!

dclass
	^ dclass
!

dclass: anInteger
	dclass _ anInteger
!

name
	^ name
!

name: aString
	name _ aString
!

type
	^ type
!

type: anInteger
	type _ anInteger
! !

!DNSQuery methodsFor:'comparing'!

= aDNSQuery
	^ type = aDNSQuery type and: [name = aDNSQuery name and: [dclass = aDNSQuery dclass]]
!

hash
	^ name hash + type + dclass
! !

!DNSQuery methodsFor:'printing'!

printOn: aStream
        aStream
                nextPutAll: name; nextPutAll: ': ';
                nextPutAll: (#(A NS MD MF CNAME SOA MB MG MR NULL WKS PTR HINFO MINFO MX TXT RP AFSDB X25 ISDN RT NSAP #'NSAP-PTR' SIG KEY PX GPOS AAAA) at: type ifAbsent: [type printString]);
                nextPut: $?
! !

!DNSQuery methodsFor:'reading/writing'!

writeNameOn: aStream
	(name findTokens: '.')
		do: [:each |
			each size > 63 ifTrue: [self error: 'invalid name'].
			aStream nextPut: each size; nextPutAll: each asByteArray].
	aStream nextPut: 0
!

writeOn: aStream
	self writeNameOn: aStream.
	aStream nextNumber: 2 put: type; nextNumber: 2 put: dclass
! !

!DNSQuery class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/communication/DNSQuery.st,v 1.4 2011/12/28 23:08:33 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/communication/DNSQuery.st,v 1.4 2011/12/28 23:08:33 cg Exp $'
! !
