"{ Package: 'stx:goodies/communication' }"

LibraryDefinition subclass:#stx_goodies_communication
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_communication class methodsFor:'description'!

excludedFromPreRequisites
    ^ #(
        #'stx:goodies/sunit'    "TestCase - superclass of RegressionTests::FTPClientTest "
    )
!

preRequisites
    ^ #(
        #'stx:libbasic'    "Stream - superclass of JSONReader "
        #'stx:libbasic2'    "Socket - referenced by SunRPC::RPCServer>>loopForever "
        #'stx:libcomp'    "Scanner - superclass of SunRPC::XDRScanner "
        #'stx:libhtml'    "HTMLDocumentView - referenced by URITransmissionServiceAppl>>openDocumentation "
        #'stx:libtool'    "InspectorView - referenced by SunRPC::XDRType>>inspectorClass "
        #'stx:libview'    "Color - referenced by URITransmissionServiceAppl::TransmissionRow>>rowSelBgColor "
        #'stx:libview2'    "Model - superclass of URITransmissionServiceAppl "
        #'stx:libwidg'    "EnterFieldGroup - referenced by URITransmissionServiceAppl>>inputGroup "
    )
! !

!stx_goodies_communication class methodsFor:'description - compilation'!

additionalDefinitions_bc_dot_mak
    ^ '
# see stdHeader_bc for GOODIES_COMM_BASE
LIB_BASE_LD_ARG=-b:$(GOODIES_COMM_BASE)
'
! !

!stx_goodies_communication class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        AbstractFTPSession
        DNSMessage
        DNSQuery
        DNSRecord
        FTPServer
        FTPServerException
        HTTPInterface
        JSONPrinter
        JSONReader
        NVTClient
        NameResolver
        Nfs4Constants
        (#'RegressionTests::FTPClientTest' autoload)
        RemoteImage
        SftpConstants
        #'SunRPC::RPCDefinitions'
        #'SunRPC::RPCEndPoint'
        #'SunRPC::RPCError'
        (#'SunRPC::RPCTest' autoload)
        #'SunRPC::ReadMe'
        #'SunRPC::SimulatedDirectory'
        #'SunRPC::SimulatedFile'
        #'SunRPC::SimulatedFileSystem'
        #'SunRPC::XDRCoder'
        #'SunRPC::XDRItem'
        #'SunRPC::XDRParser'
        (#'SunRPC::XDRParserTest' autoload)
        #'SunRPC::XDRScanner'
        (#'SunRPC::XDRTest' autoload)
        #'SunRPC::XDRType'
        TelnetClient
        URITransmission
        URITransmissionService
        URITransmissionServiceAppl
        #'stx_goodies_communication'
        ARecord
        FTPClient
        FTPSession
        HINFORecord
        MXRecord
        NSRecord
        SMTPClient
        SftpClient
        SmalltalkFTPSession
        #'SunRPC::RPCClient'
        #'SunRPC::RPCOperationError'
        #'SunRPC::RPCServer'
        #'SunRPC::XDRProcedure'
        #'SunRPC::XDRProgram'
        #'SunRPC::XDRProgramVersion'
        UnrecognizedRecord
        SmalltalkShareClient
        SmalltalkShareServer
        #'SunRPC::DemoClient'
        #'SunRPC::DemoServer'
        #'SunRPC::MountClient'
        #'SunRPC::MountServer'
        #'SunRPC::NFSClient'
        #'SunRPC::NFSServer'
        #'SunRPC::PortMapperClient'
        #'SunRPC::PortMapperServer'
        AAAARecord
        CNAMERecord
        EMailContentDescription
        HTTPProxySettings
        HTTPProxyQuery
"/        (SocksSocket autoload)
"/        (SocksSocketTest autoload)
    )

    "Modified: / 29-12-2011 / 00:12:40 / cg"
!

extensionMethodNames
    ^ #(
    )
! !

!stx_goodies_communication class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Communication'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'

    "Modified: / 01-02-2011 / 11:52:51 / cg"
! !

!stx_goodies_communication class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/communication/stx_goodies_communication.st,v 1.25 2011/12/28 23:12:47 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/communication/stx_goodies_communication.st,v 1.25 2011/12/28 23:12:47 cg Exp $'
! !
