"{ Package: 'stx:goodies/compression' }"

ZipWriteStream subclass:#GZipWriteStream
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:'GZipConstants'
	category:'System-Compression'
!


!GZipWriteStream class methodsFor:'class initialization'!

initialize
        Smalltalk isSmalltalkX ifFalse:[
            FileList registerFileReader: self
        ]
!

unload
	FileList unregisterFileReader: self
! !

!GZipWriteStream class methodsFor:'file list services'!

compressFile: fileName
	"Create a compressed file from the file of the given name"

	(FileStream readOnlyFileNamed: fileName) compressFile
!

fileReaderServicesForFile: fullName suffix: suffix
	"Don't offer to compress already-compressed files
	sjc 3-May 2003-added jpeg extension"

	^({ 'gz' . 'sar' . 'zip' . 'gif' . 'jpg' . 'jpeg'. 'pr'. 'png' } includes: suffix)
		ifTrue: [ #() ]
		ifFalse: [ self services ]
!

serviceCompressFile

	^ FileModifyingSimpleServiceEntry 
				provider: self 
				label: 'compress file'
				selector: #compressFile:
				description: 'compress file using gzip compression, making a new file'
!

services
	^ { self serviceCompressFile }
! !

!GZipWriteStream methodsFor:'initialize-release'!

writeFooter
	"Write some footer information for the crc"
	super writeFooter.
	0 to: 3 do:[:i| encoder nextBytePut: (crc >> (i*8) bitAnd: 255)].
	0 to: 3 do:[:i| encoder nextBytePut: (bytesWritten >> (i*8) bitAnd: 255)].
!

writeHeader
	"Write the GZip header"
	encoder nextBits: 16 put: GZipMagic.
	encoder nextBits: 8 put: GZipDeflated.
	encoder nextBits: 8 put: 0. "No flags"
	encoder nextBits: 32 put: 0. "no time stamp"
	encoder nextBits: 8 put: 0. "No extra flags"
	encoder nextBits: 8 put: 0. "No OS type"
! !

!GZipWriteStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/compression/GZipWriteStream.st,v 1.1 2004/10/01 08:18:28 cg Exp $'
! !

GZipWriteStream initialize!
