"{ Package: 'stx:goodies/constraints/cassovary' }"

ClDemoWindow subclass:#ClQuadDemo
	instanceVariableNames:'p1 p2 p3 p4 m1 m2 m3 m4'
	classVariableNames:''
	poolDictionaries:''
	category:'Constraints-Cassovary-Demos'
!


!ClQuadDemo methodsFor:'uncategorized public'!

addAdditionalConstraints
    "no additional constraints for this version"
!

constraintPointsDo: aBlock

    aBlock value: p1.
    aBlock value: p2.
    aBlock value: p3.
    aBlock value: p4.

    aBlock value: m1.
    aBlock value: m2.
    aBlock value: m3.
    aBlock value: m4
!

drawArea
    Smalltalk isSmalltalkX ifTrue:[
        buffer paint: Color black.

        "draw the four sides of the quadrilateral"
        buffer
            displayLineFromX: p1 x value rounded
            y: p1 y value rounded
            toX: p2 x value rounded
            y: p2 y value rounded.
        buffer
            displayLineFromX: p2 x value rounded
            y: p2 y value rounded
            toX: p3 x value rounded
            y: p3 y value rounded.
        buffer
            displayLineFromX: p3 x value rounded
            y: p3 y value rounded
            toX: p4 x value rounded
            y: p4 y value rounded.
        buffer
            displayLineFromX: p4 x value rounded
            y: p4 y value rounded
            toX: p1 x value rounded
            y: p1 y value rounded.

        "draw the lines between the midpoints"
        buffer
            displayLineFromX: m1 x value rounded
            y: m1 y value rounded
            toX: m2 x value rounded
            y: m2 y value rounded.
        buffer
            displayLineFromX: m2 x value rounded
            y: m2 y value rounded
            toX: m3 x value rounded
            y: m3 y value rounded.
        buffer
            displayLineFromX: m3 x value rounded
            y: m3 y value rounded
            toX: m4 x value rounded
            y: m4 y value rounded.
        buffer
            displayLineFromX: m4 x value rounded
            y: m4 y value rounded
            toX: m1 x value rounded
            y: m1 y value rounded
    ] ifFalse:[
        self setForegroundColor: 0.

        "draw the four sides of the quadrilateral"
        buffer
            drawLine: gc
            x1: p1 x value rounded
            y1: p1 y value rounded
            x2: p2 x value rounded
            y2: p2 y value rounded.
        buffer
            drawLine: gc
            x1: p2 x value rounded
            y1: p2 y value rounded
            x2: p3 x value rounded
            y2: p3 y value rounded.
        buffer
            drawLine: gc
            x1: p3 x value rounded
            y1: p3 y value rounded
            x2: p4 x value rounded
            y2: p4 y value rounded.
        buffer
            drawLine: gc
            x1: p4 x value rounded
            y1: p4 y value rounded
            x2: p1 x value rounded
            y2: p1 y value rounded.

        "draw the lines between the midpoints"
        buffer
            drawLine: gc
            x1: m1 x value rounded
            y1: m1 y value rounded
            x2: m2 x value rounded
            y2: m2 y value rounded.
        buffer
            drawLine: gc
            x1: m2 x value rounded
            y1: m2 y value rounded
            x2: m3 x value rounded
            y2: m3 y value rounded.
        buffer
            drawLine: gc
            x1: m3 x value rounded
            y1: m3 y value rounded
            x2: m4 x value rounded
            y2: m4 y value rounded.
        buffer
            drawLine: gc
            x1: m4 x value rounded
            y1: m4 y value rounded
            x2: m1 x value rounded
            y2: m1 y value rounded
    ]

    "Modified: / 28-08-2010 / 18:41:00 / cg"
!

initialize

    super initialize.
    p1 := (ClVariable newWith: 110.0) @ (ClVariable newWith: 10.0).
    p2 := (ClVariable newWith: 210.0) @ (ClVariable newWith: 110.0).
    p3 := (ClVariable newWith: 110.0) @ (ClVariable newWith: 210.0).
    p4 := (ClVariable newWith: 10.0) @ (ClVariable newWith: 110.0).

    m1 := (ClVariable newWith: 160.0) @ (ClVariable newWith: 60.0).
    m2 := (ClVariable newWith: 160.0) @ (ClVariable newWith: 160.0).
    m3 := (ClVariable newWith: 60.0) @ (ClVariable newWith: 160.0).
    m4 := (ClVariable newWith: 60.0) @ (ClVariable newWith: 60.0).

    p1 x name: 'p1x'.
    p1 y name: 'p1y'.
    p2 x name: 'p2x'.
    p2 y name: 'p2y'.
    p3 x name: 'p3x'.
    p3 y name: 'p3y'.
    p4 x name: 'p4x'.
    p4 y name: 'p4y'.

    m1 x name: 'm1x'.
    m1 y name: 'm1y'.
    m2 x name: 'm2x'.
    m2 y name: 'm2y'.
    m3 x name: 'm3x'.
    m3 y name: 'm3y'.
    m4 x name: 'm4x'.
    m4 y name: 'm4y'.

    "add stays on the corner points"
    cs addPointStays: (Array with: p1 with: p2 with: p3 with: p4).

    "set up the midpoint constraints"
    cs addConstraint: (p1 x + p2 x cnEqual: 2.0 * m1 x).
    cs addConstraint: (p2 x + p3 x cnEqual: 2.0 * m2 x).
    cs addConstraint: (p3 x + p4 x cnEqual: 2.0 * m3 x).
    cs addConstraint: (p4 x + p1 x cnEqual: 2.0 * m4 x).
    cs addConstraint: (p1 y + p2 y cnEqual: 2.0 * m1 y).
    cs addConstraint: (p2 y + p3 y cnEqual: 2.0 * m2 y).
    cs addConstraint: (p3 y + p4 y cnEqual: 2.0 * m3 y).
    cs addConstraint: (p4 y + p1 y cnEqual: 2.0 * m4 y).

    self addAdditionalConstraints.
!

title

    ^'Quadrilateral Demo'
! !

!ClQuadDemo class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/constraints/cassovary/ClQuadDemo.st,v 1.1 2010/09/05 16:00:44 cg Exp $'
! !
