"{ Package: 'stx:goodies/constraints/cassovary' }"

Object subclass:#ClStrength
	instanceVariableNames:'name symbolicWeight'
	classVariableNames:'MediumStrength RequiredStrength StrongStrength WeakStrength'
	poolDictionaries:''
	category:'Constraints-Cassovary-Kernel'
!


!ClStrength class methodsFor:'uncategorized private'!

initializeAfterLoad
    "ACTION
        Initialize the class variables to the pre-defined strengths.
    "
        | s m w |

    RequiredStrength := self new.  
    RequiredStrength name: 'required'.

    s := ClSymbolicWeight new.  s at: 1 put: 1.0.  s at: 2 put: 0.0.  s at: 3 put: 0.0.
    StrongStrength := self new.
    StrongStrength name: 'strong'; symbolicWeight: s.

    m := ClSymbolicWeight new.  m at: 1 put: 0.0.  m at: 2 put: 1.0.  m at: 3 put: 0.0.
    MediumStrength := self new.
    MediumStrength name: 'medium'; symbolicWeight: m.

    w := ClSymbolicWeight new.  w at: 1 put: 0.0.  w at: 2 put: 0.0.  w at: 3 put: 1.0.
    WeakStrength := self new.
    WeakStrength name: 'weak'; symbolicWeight: w.
! !

!ClStrength class methodsFor:'uncategorized public'!

medium

    ^MediumStrength
!

nLevels
    "return the number of non-required strengths"
    ^3
!

required

    ^RequiredStrength
!

strengthsDo: block
    "ACTION
        Evaluation the block for each defined strength, strongest to weakest.

    PARAMETERS
        block <Block value: ClStrength>
    "

    block
        value: RequiredStrength;
        value: StrongStrength;
        value: MediumStrength;
        value: WeakStrength
!

strong

    ^StrongStrength
!

weak

    ^WeakStrength
! !

!ClStrength methodsFor:'uncategorized private'!

name
    ^name
!

name: n
    name := n
!

symbolicWeight: w
    symbolicWeight := w
! !

!ClStrength methodsFor:'uncategorized public'!

isRequired

    ^self == RequiredStrength
!

printOn: strm

    strm nextPutAll: self name
!

symbolicWeight  
    ^symbolicWeight
! !

!ClStrength class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/constraints/cassovary/ClStrength.st,v 1.1 2010/09/05 16:02:41 cg Exp $'
! !
