"{ Package: 'stx:goodies/displayLists' }"

DisplayRectangle subclass:#DisplayArc
	instanceVariableNames:'angle'
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-DisplayLists'
!

DisplayArc comment:'Instances of DisplayArc represent elliptical arcs drawn within the rectangles described by their bounding boxes. This is not finished, and does not work at present because I am lazy and use an Arc for display--Arcs only come in full 90-degree quadrants.
Instance Variables
	angle <Interval>	the starting and stopping angles in degrees relative to the positive X axis'
!


!DisplayArc methodsFor:'accessing'!

angle: anInterval
	"Set the receiver's angle to be the argument (start-to-stop in degrees)."
	angle := anInterval
!

selectionHandles
	"Answer the points at which to display selection handles when the receiver is selected."
	^self boundingBox corners
!

start: anInterval
	"Set the starting value of the receiver's angle to be the argument (in degrees)."
	angle start: anInterval
!

stop: anInterval
	"Set the stopping value of the receiver's angle to be the argument (in degrees)."
	angle stop: anInterval
! !

!DisplayArc methodsFor:'displaying'!

displayOn: aDisplayMedium at: aPoint
	"Display the receiver as an arc on the given medium."
	| arc |
	arc := Circle new.
	arc center: self center.
	arc radius: (self width / 2).
"	arc quadrant: 1.	"		"KLUDJ"
	arc displayOn: aDisplayMedium at: aPoint
! !

!DisplayArc methodsFor:'drawing'!

drawOn: aCanvas at: aPoint
	"Display the receiver on the given canvas at the given position."

	fill 
		ifTrue: [aCanvas fillWedge: (self bounds translatedBy: aPoint) 
				startDegrees: angle start spanning: angle size color: color]
		ifFalse: [aCanvas frameWedge: (self bounds translatedBy: aPoint) 
				startDegrees: angle start spanning: angle size 
				width: width color: color]
! !

!DisplayArc methodsFor:'printing'!

printInstVarsOn: aStream
	"Print the receiver's relevant instance variables on the given Stream."
	super printInstVarsOn: aStream.
	angle isNil ifFalse: [aStream nextPutAll: ' angle: '. angle printOn: aStream].
! !

!DisplayArc class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/displayLists/DisplayArc.st,v 1.1 2000/12/01 11:46:12 cg Exp $'
! !
