"{ Package: 'stx:goodies/displayLists' }"

DisplayEllipse subclass:#DisplayCircle
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-DisplayLists'
!

DisplayCircle comment:'Instances of DisplayCircle represent circles within display lists.'
!


!DisplayCircle class methodsFor:'instance creation'!

center: aPt radius: rad color: color
	"Answer an instance of DisplayCircle with the given instance variables."
	^self new origin: aPt - rad; corner: aPt + rad; color: color
! !

!DisplayCircle class methodsFor:'examples'!

circleExample
	"DisplayCircle circleExample"
	Display fillWhite.
	(DisplayCircle circlesX: Display width byY: Display height) display.
	(Delay forSeconds: 2) wait.
	ScheduledControllers restore
!

circlesX: x byY: y
	"Answer a display list with randomly-placed random-color circles over the given extent."
	"(DisplayCircle circlesX: 600 byY: 400) display"
	^self circlesX: x byY: y items: 20
!

circlesX: x byY: y items: items
        "Answer a display list with randomly-placed random-color circles over the given extent."
        "(DisplayCircle circlesX: 600 byY: 400) display"

        | dList rand inset origin radius |
        inset := 64.
        dList := DisplayList new.
        rand := Random new.
        items timesRepeat:
                [origin := (rand nextIntFrom: inset to: x-inset)
                                        @(rand nextIntFrom: inset to: y-inset).
                radius := rand nextIntFrom: 0 to: 64.
                dList add: (DisplayCircle
                                center: origin
                                radius: radius
                                color: DisplayList randomColor)].
        ^dList
! !

!DisplayCircle methodsFor:'drawing'!

drawOn: aCanvas at: aPoint
        "Display the receiver on the given canvas at the given position."

        | borderColor |
        borderColor := DisplayList randomColor.
        fill == true
                ifTrue: [aCanvas fillOval: (self bounds translatedBy: aPoint) 
                                color: color borderWidth: border borderColor: borderColor]
                ifFalse: [aCanvas frameOval: (self bounds translatedBy: aPoint) 
                                width: width color: color]
! !

!DisplayCircle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/displayLists/DisplayCircle.st,v 1.2 2000/12/01 15:20:11 cg Exp $'
! !
