"{ Package: 'stx:goodies/displayLists' }"

DisplayArc subclass:#DisplayEllipse
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-DisplayLists'
!

DisplayEllipse comment:'Instances of DisplayEllipse represent ellipses described by their bounding rectangles. These do not work at present.'
!


!DisplayEllipse methodsFor:'accessing'!

angle: anInterval
	"Set the receiver's angle to be the argument (start-to-stop in degrees)."

	self shouldNotImplement
!

start: anInterval
	"Set the starting value of the receiver's angle to be the argument (in degrees)."

	self shouldNotImplement
!

stop: anInterval
	"Set the stop value of the receiver's angle to be the argument (in degrees)."

	self shouldNotImplement
! !

!DisplayEllipse methodsFor:'drawing'!

drawOn: aCanvas at: aPoint
        "Display the receiver on the given canvas at the given position."

        | borderColor |
        borderColor := DisplayList randomColor.
        fill 
                ifTrue: [aCanvas fillOval: (self bounds translatedBy: aPoint) 
                                color: color borderWidth: border borderColor: borderColor]
                ifFalse: [aCanvas frameOval: (self bounds translatedBy: aPoint) 
                                width: width color: color]
! !

!DisplayEllipse class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/displayLists/DisplayEllipse.st,v 1.2 2000/12/01 15:20:23 cg Exp $'
! !
