"{ Package: 'stx:goodies/displayLists' }"

DisplayObject subclass:#DisplayModel
	instanceVariableNames:'container model'
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-DisplayLists'
!

DisplayModel comment:'An instance of a subclass of the abstract class DisplayModel is a DisplayObject that has some other thing as its "domain model."
Instance Variables
	container		<DisplayModel> the "outer" display item
	model		<Object> the "domain" model
The class DisplayList has loads of example methods; try
	DisplayList testAll
For more notes, see the documentation class protocol in this class'
!

!DisplayModel class methodsFor:'documentation'!

KnownBugs
	"This version is the first release of the MODE on Squeak. 
	Many features were left out in the interest of simplicity. If you want a really sophisticated system, port HotDraw to Squeak.
	Arcs and Ellipses are rather broken because of the weakness of the Squeak (Smalltalk-80) Paths. 
	Splines are black-and-white because I use Form dotOfSize: to draw with.
	There are also some problems with color BitBlt that I haven't fixed yet. (Any help would be most appreciated.)"
	self flag: #Documentation
!

README
	"This is the Squeak MODE DisplayList Framework. It is written to support the MODE's music editing tools, and is not the world's most comprehensive and elegant structured graphics hierarchy. It is, however, one of the simplest and most easily extensible.
	One could easily add support for regular polygons, better arcs, more kinds of paths, etc.
	Note also that the display item hierarchy is separate from the display list editing framework.
The class DisplayList has loads of example methods; try,
	DisplayList testAll
for a good sampler"
	self flag: #Documentation
!

VersionHistory
	"This implementation is MODE 3.0_alpha for Squeak.
	Version History: 
		PCS/Cadmus, Munich,  Spring, 1985 (DoubleTalk);
		CCRMA/PARC, Palo Alto, Late 1987 (HyperScore ToolKit);
		STEIM, Amsterdam, May/June 1990 (MODE 1); 
		Lagoon, Palo Alto, July, 1991-May, 1992 (MODE 1.1);
		SICS, Stockholm, Summer, 1993 (MODE 2);
		CREATE, Santa Barbara, November, 1996 (MODE 3).
The entirety of this software is Copyright (c) 1985-96, Stephen Travis Pope. 
Distribution rights granted according to the Squeak license."
	self flag: #Documentation
! !

!DisplayModel methodsFor:'accessing'!

container
	"Answer the receiver's 'container'."

	^container
!

container: anObject
	"Set the receiver's instance variable 'container' to be anObject."

	container := anObject
!

model
	"Answer the receiver's 'model'."

	^model
!

model: anObject
	"Set the receiver's instance variable 'model' to be anObject."

	model := anObject
! !

!DisplayModel methodsFor:'initialize-release'!

initialize
	"Set up the default state of the receiver"
	^self
! !

!DisplayModel class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/displayLists/DisplayModel.st,v 1.1 2000/12/01 11:46:45 cg Exp $'
! !
