"{ Package: 'stx:goodies/displayLists' }"

DisplayPolyline subclass:#DisplaySpline
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-DisplayLists'
!

DisplaySpline comment:'An instance of DisplaySpline acts like a Spline and can be used as a DisplayItem.'
!


!DisplaySpline class methodsFor:'examples'!

splineExample
	"DisplaySpline splineExample"
	Display fillWhite.
	(DisplaySpline splinesX: Display width byY: Display height) display.
	(Delay forSeconds: 2) wait.
	ScheduledControllers restore
!

splinesX: x byY: y
	"Answer a display list with randomly-placed random-color splines over the given extent."
	"(DisplaySpline splinesX: 600 byY: 400) display"

	^self splinesX: x byY: y items: 20
!

splinesX: x byY: y items: items
        "Answer a display list with randomly-placed random-color splines over the given extent."
        "(DisplaySpline splinesX: 600 byY: 600) display"
        | dList rand inset scale x0 y0 size pointArray |
        inset := 128.
        scale := 128.
        dList := DisplayList new.
        rand := Random new.
        x0 := rand nextIntFrom: inset to: x-inset.
        y0 := rand nextIntFrom: inset to: y-inset.
        items timesRepeat:
                [size := rand nextIntFrom: 4 to: 8.
                pointArray := Array new: size.
                pointArray at: 1 put: (0@0).
                pointArray at: size put: (0@0).
                x0 := y0 := 0.
                2 to: size-1 do: [ :i |
                        x0 := x0 + (rand nextIntFrom: scale negated to: scale).
                        y0 := y0 + (rand nextIntFrom: scale negated to: scale).
                        pointArray at: i put: (x0 @ y0)].
                dList add: ((DisplaySpline
                                origin: ((rand nextIntFrom: inset to: x-inset)
                                                @(rand nextIntFrom: inset to: y-inset)))
                                color: DisplayList randomColor;
                                width: (rand nextIntFrom: 1 to: 4);
                                vertices: pointArray)].
        ^dList
! !

!DisplaySpline methodsFor:'displaying'!

displayOn: aDisplayMedium at: aPoint
	"Stroke the receiver's edges on the supplied DisplayMedium."
	| spline |
	spline := Spline new.
	vertices do: [ :vertex | spline add: vertex].
	spline computeCurve.
	width isNil
		ifFalse: [width ~= 1
			ifTrue: [spline form: (Form dotOfSize: width)]].	"KLUDJ"
	spline displayOn: aDisplayMedium at: aPoint + origin
		clippingBox: aDisplayMedium boundingBox rule: Form over
		fillColor: color
! !

!DisplaySpline class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/displayLists/DisplaySpline.st,v 1.2 2000/12/01 15:20:17 cg Exp $'
! !
