"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFModel subclass:#RTFBordersModel
	instanceVariableNames:'types borders'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFBordersModel class methodsFor:'instance creation'!

fromRectangle: aRectangle
       "Returns a composite with instances of the receiver set from aRectangle."

     ^self new
              rectangle: aRectangle;
                 yourself
!

fromRectangle: aRectangle types: types
       "Returns a composite with instances of the receiver set from aRectangle."

     ^self new
              rectangle: aRectangle;
                 types: types;
          yourself
!

ofSize: aNumber
      "Returns an instance of the receiver set to size aNumber."

    ^self fromRectangle: (aNumber @ aNumber corner: aNumber @ aNumber)
! !

!RTFBordersModel methodsFor:'accessors'!

borderNames
   " Private - Returns the number of borders of the receiver. "

  ^#( top left bottom right )
!

borders
    "Returns the borders of the receiver."

        borders isNil ifTrue: [ self initializeBorders ].
      ^borders
!

borders: aCollection
         "Sets the borders of the receiver."

   borders := aCollection
!

numberOfBorders
       " Private - Returns the number of borders of the receiver. "

  ^self borderNames size
!

type: aBorderType
  "Sets the borders types to aBorderType."

      | array |
      array := Array new: self borders size.
         array atAllPut: aBorderType.
   self types: array
!

types
     "Returns the borders types.
    aCollection of types for each border."

        types isNil ifTrue: [ self initializeTypes ].
  ^types
!

types: aCollection
         "Sets the borders types.
       aCollection of types for each border."

        types := aCollection
!

width: twips
       "Sets the borders of the receiver to twips."

  self width: twips in: #twips
!

width: aNumber in: units
        "Sets the borders of the receiver to twips."

  self borders atAllPut: (self measure: aNumber in: units)
! !

!RTFBordersModel methodsFor:'borders'!

bottom
  "Returns the left border."

    ^self borders at: 3
!

left
  "Returns the left border."

    ^self borders at: 2
!

right
     "Returns the left border."

    ^self borders at: 4
!

top
         "Returns the left border."

    ^self borders at: 1
! !

!RTFBordersModel methodsFor:'initialization'!

initializeBorders
      " Private - Initializes the receiver's borders. "

     borders := Array new: self numberOfBorders.
    self width: 0.
!

initializeTypes
    " Private - Initializes the receiver's type. "

        self type: self borderTypeClass defaultType
! !

!RTFBordersModel methodsFor:'printing'!

rtfSpec
  " Private - Returns the RTF replacement specification of the receiver. "

      | borderNames result current border |
  result := nil.
         borderNames := self borderNames.
       1 to: borderNames size do: [:index|
            border := borderNames at: index.
               current :=
                     (self borderClass new perform: border)
                         ,(self types at: index)
                        ,(self borderSizeClass width: (self perform: border)).
                 result := result isNil ifTrue: [ current ] ifFalse: [ result , current ].
      ].
     ^result
! !

!RTFBordersModel class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFBordersModel.st,v 1.2 2011/01/28 14:27:06 cg Exp $'
! !
