"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFCellFormating subclass:#RTFCellBackgroundPattern
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFCellBackgroundPattern class methodsFor:'query'!

supportedTokens
   "Returns the collection of tokens supported by the receiver."

         ^#(
            'clbgbdiag' 'clbgcross' 'clbgdkbdiag' 'clbgdkcross'
            'clbgdkdcross' 'clbgdkfdiag' 'clbgdkhor' 'clbgdkvert'
          'clbgdcross' 'clbgfdiag' 'clbghoriz' 'clbgvert'
        )
! !

!RTFCellBackgroundPattern methodsFor:'accessors'!

format
   "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
       "Sets the receiver's format."

         format := aFormat
!

token
      "Returns the receiver's token."

       ^self format
! !

!RTFCellBackgroundPattern methodsFor:'settings'!

backwardDiagonal
      "Set the receiver with this format."

  ^self format: 'clbgbdiag'
!

cross
        "Set the receiver with this format."

  ^self format: 'clbgcross'
!

darkBackwardDiagonal
         "Set the receiver with this format."

  ^self format: 'clbgdkbdiag'
!

darkCross
  "Set the receiver with this format."

  ^self format: 'clbgdkcross'
!

darkDiagonalCross
    "Set the receiver with this format."

  ^self format: 'clbgdkdcross'
!

darkForwardDiagonal
         "Set the receiver with this format."

  ^self format: 'clbgdkfdiag'
!

darkHorizontal
      "Set the receiver with this format."

  ^self format: 'clbgdkhor'
!

darkVertical
      "Set the receiver with this format."

  ^self format: 'clbgdkvert'
!

default
      "Set the receiver with the default format."

   ^self horizontal
!

diagonalCross
         "Set the receiver with this format."

  ^self format: 'clbgdcross'
!

forwardDiagonal
    "Set the receiver with this format."

  ^self format: 'clbgfdiag'
!

horizontal
   "Set the receiver with this format."

  ^self format: 'clbghoriz'
!

vertical
   "Set the receiver with this format."

  ^self format: 'clbgvert'
! !

!RTFCellBackgroundPattern class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFCellBackgroundPattern.st,v 1.2 2011/01/28 14:27:32 cg Exp $'
! !
