"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFCellFormating subclass:#RTFCellBorder
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFCellBorder class methodsFor:'query'!

supportedTokens
      "Returns the collection of tokens supported by the receiver."

         ^#( 'clvertalb' 'clvertalc' 'cltxlrtb' 'cltxtbrl' 'clvertalt' )
! !

!RTFCellBorder methodsFor:'accessors'!

format
   "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
  "Sets the receiver's format."

         format := aFormat
!

token
         "Returns the receiver's token."

       ^self format
! !

!RTFCellBorder methodsFor:'settings'!

bottom
    "Set the receiver with this format."

  ^self format: 'clbrdrb'
!

default
   "Set the receiver with the default format."

   ^self left
!

left
         "Set the receiver with this format."

  ^self format: 'clbrdrl'
!

right
  "Set the receiver with this format."

  ^self format: 'clbrdrr'
!

top
       "Set the receiver with this format."

  ^self format: 'clbrdrt'
! !

!RTFCellBorder class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFCellBorder.st,v 1.2 2011/01/28 14:27:34 cg Exp $'
! !
