"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFCellFormating subclass:#RTFCellTextAlignment
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFCellTextAlignment class methodsFor:'instance creation'!

defaultTextAlignment
  "Returns the default alignment for text in cells."

    ^self new right
!

defaultVerticalAlignment
  "Returns the default vertical alignment for text in cells."

   ^self new top
! !

!RTFCellTextAlignment class methodsFor:'query'!

supportedTokens
   "Returns the collection of tokens supported by the receiver."

         ^#( 'clbrdrb' 'clbrdrl' 'clbrdrr' 'clbrdrt' )
! !

!RTFCellTextAlignment methodsFor:'accessors'!

format
  "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
      "Sets the receiver's format."

         format := aFormat
!

token
    "Returns the receiver's token."

       ^self format
! !

!RTFCellTextAlignment methodsFor:'settings'!

bottom
   "Set the receiver with this format."

  ^self format: 'clvertalb'
!

center
  "Set the receiver with this format."

  ^self format: 'clvertalc'
!

default
    "Set the receiver with the default format."

   ^self top
!

left
     "Set the receiver with this format."

  ^self format: 'cltxlrtb'
!

right
    "Set the receiver with this format."

  ^self format: 'cltxtbrl'
!

top
        "Set the receiver with this format."

  ^self format: 'clvertalt'
! !

!RTFCellTextAlignment class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFCellTextAlignment.st,v 1.2 2011/01/28 14:27:46 cg Exp $'
! !
