"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFBordersFormating subclass:#RTFCharacterPattern
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFCharacterPattern class methodsFor:'query'!

supportedTokens
       "Returns the collection of tokens supported by the receiver."

         ^#(
            'chbgbdiag' 'chbgcross' 'chbgdkbdiag' 'chbgdkcross'
            'chbgdkdcross' 'chbgdkfdiag' 'chbgdkhoriz' 'chbgdkvert'
                'chbgdcross' 'chbgfdiag' 'chbghoriz' 'chbgvert'
        )
! !

!RTFCharacterPattern methodsFor:'accessors'!

format
        "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
    "Sets the receiver's format."

         format := aFormat
!

token
    "Returns the receiver's token."

       ^self format
! !

!RTFCharacterPattern methodsFor:'settings'!

backwardDiagonal
         "Set the receiver with this format."

  ^self format: 'chbgbdiag'
!

cross
   "Set the receiver with this format."

  ^self format: 'chbgcross'
!

darkBackwardDiagonal
      "Set the receiver with this format."

  ^self format: 'chbgdkbdiag'
!

darkCross
        "Set the receiver with this format."

  ^self format: 'chbgdkcross'
!

darkDiagonalCross
  "Set the receiver with this format."

  ^self format: 'chbgdkdcross'
!

darkForwardDiagonal
       "Set the receiver with this format."

  ^self format: 'chbgdkfdiag'
!

darkHorizontal
  "Set the receiver with this format."

  ^self format: 'chbgdkhoriz'
!

darkVertical
   "Set the receiver with this format."

  ^self format: 'chbgdkvert'
!

default
   "Set the receiver with the default format."

   ^self horizontal
!

diagonalCross
   "Set the receiver with this format."

  ^self format: 'chbgdcross'
!

forwardDiagonal
    "Set the receiver with this format."

  ^self format: 'chbgfdiag'
!

horizontal
        "Set the receiver with this format."

  ^self format: 'chbghoriz'
!

vertical
        "Set the receiver with this format."

  ^self format: 'chbgvert'
! !

!RTFCharacterPattern class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFCharacterPattern.st,v 1.2 2011/01/28 14:28:00 cg Exp $'
! !
