"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFControlWord subclass:#RTFCharacterSet
	instanceVariableNames:'type'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFCharacterSet class methodsFor:'query'!

supportedTokens
      "Returns the collection of tokens supported by the receiver."

         ^#('ansi' 'ansicpg' 'mac' 'pc' 'pca' 'u' 'uc' 'ud' 'upr')
! !

!RTFCharacterSet methodsFor:'accessing'!

token
        "Returns the token of the receiver."

  ^self type asString
!

type
        "Returns the receiver's type."

        type isNil ifTrue: [ self type: #ansi ].
       ^type
!

type: aType
     "Sets the receiver's type."

   type := aType
! !

!RTFCharacterSet methodsFor:'alternatives'!

ansi
   "Sets the type of the receiver to this character set."

        self type: #ansi "the default"
!

ansiCodePage: n
        "Sets the type of the receiver to this character set.
  This keyword represents the ANSI code page which is used to perform the Unicode to ANSI conversion when writing RTF text.
      N represents the code page in decimal.
         This is typically set to the default ANSI code page of the run-time environment (for example \ansicpg1252 for U.S. Windows)."

         self
           type: #ansicpg;
                parameter: n
!

mac
   "Sets the type of the receiver to this character set."

        self type: #mac "Apple Macintosh"
!

pc
    "Sets the type of the receiver to this character set."

        self type: #pc "IBM PC code page 437"
!

pca
   "Sets the type of the receiver to this character set."

        self type: #pca "IBM PC code page 850 (used by PS/2)"
!

u: n
         "Sets the type of the receiver to this character set.
  This keyword represents a single Unicode character which has no equivalent ANSI representation based on the current ANSI code page.
    N represents the Unicode character value expressed as a decimal number."

      self
           type: #u;
              parameter: n
!

uc: n
     "Sets the type of the receiver to this character set.
  This keyword represents a single Unicode character which has no equivalent ANSI representation based on the current ANSI code page.
    N represents the Unicode character value expressed as a decimal number."

      self
           type: #uc;
             parameter: n
!

ud
      "Sets the type of the receiver to this character set."

        self type: #ud
!

upr
    "Sets the type of the receiver to this character set."

        self type: #upr
! !

!RTFCharacterSet class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFCharacterSet.st,v 1.2 2011/01/28 14:28:12 cg Exp $'
! !
