"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFColorElement subclass:#RTFColorComponent
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFColorComponent class methodsFor:'instance creation'!

blue
    "Returns an instance of the receiver."

        ^self new blue
!

blue: aValue
        "Returns an instance of the receiver."

        ^self new blue: aValue
!

green
        "Returns an instance of the receiver."

        ^self new green
!

green: aValue
  "Returns an instance of the receiver."

        ^self new green: aValue
!

red
         "Returns an instance of the receiver."

        ^self new red
!

red: aValue
         "Returns an instance of the receiver."

        ^self new red: aValue
! !

!RTFColorComponent class methodsFor:'query'!

supportedTokens
  "Returns the collection of tokens supported by the receiver."

         ^#( 'red' 'green' 'blue' )
! !

!RTFColorComponent methodsFor:'accessors'!

format
         "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
        "Sets the receiver's format."

         format := aFormat
!

token
         "Returns the receiver's token."

       ^self format
! !

!RTFColorComponent methodsFor:'initialization'!

initializeParameter
        " Private - Initialize the receiver's parameter. "

    self parameter: 0
! !

!RTFColorComponent methodsFor:'query'!

isBlue
       "Returns true if the receiver is a blue component."

   ^self format = 'blue'
!

isGreen
    "Returns true if the receiver is a green component."

  ^self format = 'green'
!

isRed
    "Returns true if the receiver is a red component."

    ^self format = 'red'
! !

!RTFColorComponent methodsFor:'settings'!

blue
     "Set the format of the receiver."

     self format: 'blue'
!

blue: aValue
  "Set the value and format of the receiver."

   self
           blue;
          value: aValue
!

green
    "Set the format of the receiver."

     self format: 'green'
!

green: aValue
  "Set the value and format of the receiver."

   self
           green;
                 value: aValue
!

red
     "Set the format of the receiver."

     self format: 'red'
!

red: aValue
     "Set the value and format of the receiver."

   self
           red;
           value: aValue
! !

!RTFColorComponent class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFColorComponent.st,v 1.2 2011/01/28 14:28:25 cg Exp $'
! !
