"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFOrderedComposite subclass:#RTFColorDefinition
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFColorDefinition methodsFor:'accessors'!

auto
    "Set the receiver as the auto color."

         elements := OrderedCollection new.

    "
      RTFColorDefinition new auto asRTF
      "
!

blue
  "Returns the green component of the receiver."

        ^self
          detect: [:one| (one isKindOf: RTFColorComponent) and: [ one isBlue ] ]
                 ifNone: [ self add: RTFColorComponent blue ]
!

green
         "Returns the green component of the receiver."

        ^self
          detect: [:one| (one isKindOf: RTFColorComponent) and: [ one isGreen ] ]
                ifNone: [ self add: RTFColorComponent green ]
!

red
    "Returns the red component of the receiver."

  ^self
          detect: [:one| one isKindOf: RTFColorComponent and: [ one isRed ] ]
            ifNone: [ self add: RTFColorComponent red ]
!

red: red green: green blue: blue
        "Set the receiver with red,green,blue values."

        self red value: red.
   self green value: green.
       self blue value: blue.
! !

!RTFColorDefinition methodsFor:'element management'!

add: anElement
  "Add anElement into the receiver."

    (self paranoia and: [ (anElement isKindOf: RTFColorComponent) not ])
   ifTrue: [ ^self error: 'Invalid element.' ].

  ^super add: anElement
! !

!RTFColorDefinition methodsFor:'initialization'!

initializeElements
      " Private - Initializes the receiver's elements. "

    super initializeElements.
      self red;green;blue.
! !

!RTFColorDefinition methodsFor:'printing'!

basicPrintRTFOn: aStream
   "Must write the receiver in RTF source format onto aStream."

  super basicPrintRTFOn: aStream.
        aStream nextPut: $;
! !

!RTFColorDefinition class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFColorDefinition.st,v 1.2 2011/01/28 14:28:27 cg Exp $'
! !
