"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFSingleElement subclass:#RTFControlWord
	instanceVariableNames:'parameter'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!

RTFControlWord class instanceVariableNames:'token'

"
 No other class instance variables are inherited by this class.
"
!


!RTFControlWord class methodsFor:'initialization'!

characterTextTokens
    " Private - Returns the token table for this support. "

       ^#(
            "Paragraph - Character Text"
           ('plain' RTFCharacterReset)
            ('animtext' RTFCharacterAnimation)
             ('b' RTFBold)
          ('caps' RTFAllCapitals)
                ('charscalex' RTFCharacterScale)
               ('deleted' RTFCharacterDeleted)
                ('dn' RTFCharacterSubscript)
           ('embo' RTFEmboss)
             ('impr' RTFEngrave)
            ('sub' RTFSubscript)
           ('nosupersub' RTFNoSuperSubScripting)
          ('expnd' RTFExpansion)
                 ('expndtw' RTFExpansionInTwips)
                ('kerning' RTFKerning)
                 ('f' RTFFontNumber)
            ('fs' RTFFontSize)
             ('i' RTFItalic)
                ('outl' RTFOutline)
            ('scaps' RTFSmallCapitals)
             ('shad' RTFShadow)
             ('strike' RTFStrikethrough)
            ('strikedl' RTFDoubleStrikethrough)
            ('up' RTFCharacterSuperscript)
                 ('super' RTFSuperscript)
               ('v' RTFHidden)
                ('cf' RTFForegroundColor)
              ('cb' RTFBackgroundColor)
              ('cs' RTFCharacterStyle)
               ('lang' RTFCharacterLanguage)
          ('chbrdr' RTFBorder)
           ('chshdng' RTFCharacterShading)
                ('chcfpat' RTFCharacterPatternColor)
           ('chcbpat' RTFCharacterPatternFill)
            ('highlight' RTFHighlightColor)
                ('chtime' RTFTime)
             ('chpgn' RTFPageNumber)
                ('sectnum' RTFSectionNumber)
           ('chftn' RTFAutomaticFootnote)
                 ('chatn' RTFAnnotationReference)
               ('chftnsep' RTFAchorSeparatorForFootnote)
              ('chftnsepc' RTFAchorSeparatorForFootnoteContinuation)
                 ('tab' RTFTab)
                 ('emdash' RTFEmDash)
           ('endash' RTFEnDash)
           ('bullet' RTFBullet)
           ('~' RTFNonBreakingSpace)
              ('''' RTFHexa)
         )
!

colorTableTokens
         " Private - Returns the token table for this support. "

       ^#(
            ('colortbl' RTFColorTableControl)
      )
!

documentAreaTokens
   " Private - Returns the token table for this support. "

       ^#(
            "Document Area"
                'author' 'category' 'comment' 'company'
                'manager' 'operator' 'keywords' 'subject' 'title'
              ('buptim' RTFBackupTime)
               ('creatim' RTFCreationTime)
            ('deff' RTFDefaultFont)
                ('doccomm' RTFDocumentComment)
                 ('version' RTFDocumentVersion)
                 ('hlinkbase' RTFHyperlinkBase)
                 ('id' RTFInternalID)
           ('vern' RTFInternalVersionNumber)
              ('printim' RTFLastPrintTime)
           ('nofchars' RTFNumberOfCharacters)
             ('nofpages' RTFNumberOfPages)
          ('nofwords' RTFNumberOfWords)
          ('revtim' RTFRevisionTime)
             ('edmins' RTFTotalEditingTime)
         )
!

documentFormatingTokens
      " Private - Returns the token table for this support. "

       ^#(
            "Document Formating"
           ('deftab' RTFDefaultTabWidth)
          ('hyphhotz' RTFHyphenationHotZone )
            ('hyphconsec' RTFHyphenationConsecutiveLines)
          ('hyphcaps' RTFHyphenationCapitalize)
          ('hyphauto' RTFAutomaticHyphenation)
           ('linestart' RTFBeginningLineNumber)
           ('fracwidth' RTFFractionalCharacterWidths)
             ('makebackup' RTFMakeBackup)
           ('defformat' RTFIsDefaultFormat)
               ('psover' RTFPrintPostScriptOverText)
          ('doctemp' RTFDocumentIsBoilerplate)
           ('deflang' RTFDefaultLanguage)
                 ('deflangfe' RTFDefaultLanguageID)
             ('windowcaption' RTFWindowCaption)
             ('doctype' RTFDocumentType)
            ('fromtext' RTFDocumentIsPlainText)
            ('viewkind' RTFViewMode)
               ('viewscale' RTFViewScale)
             ('viewzk' RTFViewZoomKind)
             ('fet' RTFFootnoteType)
                ('ftnsep' RTFFootnoteSeparator)
                ('ftnsepc' RTFFootnoteSeparatorContinued)
              ('ftncn' RTFFootnoteContinuedNotice)
           ('aftnsep' RTFEndnotesSeparator)
               ('aftnsepc' RTFEndnotesSeparatorContinued)
             ('aftncn' RTFEndnoteContinuedNotice)
           ('endnotes' RTFFootnotesAtEndOfSection)
                ('enddoc' RTFFootnotesAtEndOfDocument)
                 ('paperw' RTFPaperWidth)
               ('paperh' RTFPaperHeight)
              ('margl' RTFLeftMargin)
                ('margr' RTFRightMargin)
               ('margt' RTFTopMargin)
                 ('margb' RTFBottomMargin)
              ('facingp' RTFFacingPages)
             ('gutter' RTFGutterWidth)
              ('landscape' RTFLandscape)
             ('pgnstart' RTFBeginningPageNumber)
            ('widowctrl' RTFWidowAndOrphanControl)
                 ('formprot' RTFFormProtected)
          ('allprot' RTFNoUnprotectedAreas)
              ('formshade' RTFHasFormShading)
                ('formdisp' RTFFormDisplay)
            ('printdata' RTFPrintDataOnly)
                 ('revprot' RTFProtectedForRevisions)
           ('revisions' RTFRevisions)
             ('revprop' RTFRevisionsDisplayProperties)
              ('revbar' RTFRevisionsBarProperties)
           ('annotprot' RTFOnlyComments)
          ('pgbrdrhead' RTFPageBorderSurroundsHeader)
            ('pgbrdrfoot' RTFPageBorderSurroundsFooter)
            ('pgbrdrt' RTFPageBorderTop)
           ('pgbrdrb' RTFPageBorderBottom)
                ('pgbrdrl' RTFPageBorderLeft)
          ('pgbrdrr' RTFPageBorderRight)
                 ('brdrart' RTFPageBorderArt)
           ('pgbrdrsnap' RTFAlignBordersToEdges)
  )
!

fieldTokens
         " Private - Returns the token table for this support. "

       ^#(
            "Fields"
               ('field' RTFField)
             ('fldinst' RTFFieldInstruction)
                ('fldrslt' RTFFieldResult)
             ('flddirty' RTFFieldDirty)
             ('fldedit' RTFFieldEdited)
             ('fldlock' RTFFieldLocked)
             ('fldpriv' RTFFieldPrivate)
            ('fldalt' RTFFieldAlternate)
   )
!

fontTableTokens
    " Private - Returns the token table for this support. "

       ^#(
            ('fonttbl' RTFFontTableControl)
                ('f' RTFFontNumber)
            ('fcharset' #RTFFontCharacterSet)
              ('fprq' #RTFFontPitch)
                 ('cpg' RTFFontCodePage)
                ('fname' #RTFFontNonTaggedName)
                ('falt' #RTFFontAlternateName)
         )
!

headerAndFooterTokens
        " Private - Returns the token table for this support. "

       ^#(
    "Headers & Footers (no settings needed)"
       )
!

headerTokens
  " Private - Returns the token table for this support. "

       ^#(
            ('rtf' RTFVersion)
     )
!

initializeAllTokens
    " Private - Initializes all the tokens of the framework.
       RTFControlWord initializeAllTokens.
    "

     | aToken support |
     self headerTokens,
     self fontTableTokens,
  self colorTableTokens,
         self documentAreaTokens,
       self documentFormatingTokens,
  self sectionFormatingTokens,
   self headerAndFooterTokens,
    self plainTextTokens,
  self plainTextTabsTokens,
              "Paragraph - Pain Text - Bullets and Numbering"
                "Paragraph - Pain Text - REVISION MARKS FOR PARAGRAPH NUMBERS"
                 "Paragraph - Pain Text - Paragraph Borders"
            "Paragraph - Pain Text - Paragraph Shading"
            "Paragraph - Pain Text - Positioned Objects and Frames"
        self tableTokens,
      self characterTextTokens,
      self fieldTokens
               "more to come..."
      do: [:tuple|
           (tuple isKindOf: String)
               ifTrue: [
                      aToken := tuple.
                       support := ('RTF',(tuple copy at: 1 put: tuple first asUppercase;yourself)) asSymbol.
          ]
              ifFalse: [
                     tuple size = 2 ifFalse: [ self error: 'Invalid tuple format.' ].
                       aToken := tuple first. support := tuple last.
          ].
             support := Smalltalk at: support ifAbsent: [ self error: 'Class not found: ', support ].
               support token: aToken.
         ].
!

initializeToken
    " Private - Initializes the receiver's token. "

       self initializeAllTokens.
      token isNil ifTrue: [   ^self subclassResponsibility ].
!

plainTextTabsTokens
     " Private - Returns the token table for this support. "

       ^#(
            "Paragraph - Pain Text - Tabs"
                 ('tx' RTFTabPosition)
          ('tb' RTFBarTabPosition)
       )
!

plainTextTokens
     " Private - Returns the token table for this support. "

       ^#(
            "Paragraph - Pain Text - Formating"
            ('par' RTFParagraph)
           ('pard' RTFParagraphReset)
             ('s' RTFParagraphStyle)
                ('hyphpar' RTFParagraphHyphenation)
            ('intbl' RTFParagraphInTable)
          ('keep' RTFParagraphKeepIntact)
                ('nowidctlpar' RTFParagraphNoWidowControl)
             ('widctlpar' RTFParagraphWidowControl)
                 ('keepn' RTFParagraphKeepWithNext)
             ('level' RTFParagraphOutlineLevel)
             ('noline' RTFParagraphNoLineNumbering)
                 ('pagebb' RTFParagraphBreakPageBefore)
                 ('sbys' RTFParagraphSideBySide)
                ('subdocument' RTFParagraphSubdocument)
                ('ltrpar' RTFParagraphLeftToRightPrecedence)
           ('rtlpar' RTFParagraphRightToLeftPrecedence)
   )
!

sectionFormatingTokens
       " Private - Returns the token table for this support. "

       ^#(
            "Section Formating"
            ('sectd' RTFSectionReset)
              ('endnhere' RTFEndnotesIncludedInSection)
              ('ds' RTFSectionStyle)
                 ('sectunlocked' RTFSectionUnlocked)
            ('sbknone' RTFSectionBreakNone)
                ('sbkcol'  RTFSectionBreakColumn)
              ('sbkpage'  RTFSectionBreakPage)
               ('sbkeven'  RTFSectionBreakEvenPage)
           ('sbkodd'  RTFSectionBreakOddPage)
             ('cols' RTFSnakingColumns)
             ('colsx' RTFSpaceBetweenColumns)
               ('colno' RTFColumnNumber)
              ('colsr' RTFColumnRightSpace)
          ('colw' RTFColumnWidth)
                ('linebetcol' RTFLineBetweenColumns)
           ('linemod' RTFLineNumberIncrement)
             ('linex' RTFDistanceFromLineToLeftMargin)
              ('linestarts' RTFStartLineNumber)
              ('linerestart' RTFLineNumbersRestart)
          ('lineppage' RTFLineNumbersRestartOnEachPage)
          ('linecont' RTFLineNumbersContinue)
            ('pgwsxn' RTFPageWidth)
                ('pghsxn' RTFPageHeight)
               ('marglsxn' RTFPageLeftMargin)

                ('margrsxn' RTFPageRightMargin)
                ('margtsxn' RTFPageTopMargin)
          ('marblsxn' RTFPageBottomMargin)
               ('guttersxn' RTFPageGutter)
            ('margmirsxn' RTFPageSwitchMargin)
             ('lndscpsxn' RTFPageLandscape)
                 ('titlepg' RTFFirstPageHasSpecialFormat)
               ('headery' RTFPageHeaderFromTop)
               ('footery' RTFPageFooterFromBottom)
            ('pgnstarts' RTFStartPageNumber)
               ('pgncont' RTFContinuousPageNumbering)
                 ('pgnrestart' RTFPageNumberRestart)
            ('pgnstarts' RTFBeginningPageNumber)
           ('pgnstarts' RTFBeginningPageNumber)
           ('pgnhn' RTFPageHeadingLevel)
          ('pgbrdrsnap' RTFPageBorderSnap)
       )
!

tableTokens
        " Private - Returns the token table for this support. "

       ^#(
            "Paragraph - Tables"
           ('row' RTFTableRowElement)
             ('cell' RTFTableCellElement)
           ('trowd' RTFTableRowDefaults)
          ('tcelld' RTFTableCellDefaults)
                ('trgaph' RTFCellsGap)
                 ('cellx' RTFRightBoundary)
             ('clmgf' RTFFirstCellMerged)
           ('clmrg' RTFTableCellMerged)
           ('trleft' RTFRowLeftPosition)
          ('trrh' RTFRowHeight)
          ('trhdr' RTFTableRowHeader)
            ('trkeep' RTFTableRowKeepTogether)
             ('clshdng' RTFCellShading)
             ('clcfpat' RTFCellBackgroundLineColor)
                 ('clcbpat' RTFCellBackgroundBackColor)
         )
! !

!RTFControlWord class methodsFor:'instance creation'!

off
     "Returns a new instance of the receiver set to OFF state."

    ^self new off yourself
!

on
    "Returns a new instance of the receiver set to ON state."

     ^self new on yourself
!

percent: aValue
      "Returns a new instance of the receiver with parameter aValue."

       ^self new
              percent: aValue;
               yourself
!

twips: aValue
  "Returns a new instance of the receiver with parameter aValue."

       ^self new
              twips: aValue;
                 yourself
!

value: aValue
      "Returns a new instance of the receiver with parameter aValue."

       ^self new
              value: aValue;
                 yourself
! !

!RTFControlWord class methodsFor:'query'!

supportedTokens
     "Returns the collection of tokens supported by the receiver.
   The default action is to return a collection with the receiver's token.
        This method can be refined by subclasses."

    ^Array with: self basicToken
! !

!RTFControlWord class methodsFor:'tokens'!

basicToken
    " Private - Returns the receiver's token. "

   ^token
!

token
     "Returns the token to be used when printing the receiver."

    token isNil ifTrue: [ self initializeToken ].
  ^token
!

token: aToken
      "Sets the token to be used when printing the receiver."

       token := aToken
! !

!RTFControlWord methodsFor:'accessing'!

centimeters: aValue
  "Sets the receiver's parameter with a value in centimeters."

  ^self twips: (self measure: aValue in: #cm)
!

inches: aValue
    "Sets the receiver's parameter with a value in inches."

       ^self twips: (self measure: aValue in: #inches)
!

off
  "Sets the value of the receiver to off."

      ^self value: 0
!

on
  "Sets the value of the receiver to on."

       ^self value: 1
!

parameter
     "Returns the receiver's parameter (or nil)."

  parameter isNil ifTrue: [ self initializeParameter ].
  ^parameter
!

parameter: aParameter
        "Sets the receiver's parameter."

      parameter := aParameter
!

percent
         "Returns the cereiver value in %."

    ^self value
!

percent: aValue
         "Sets the cereiver value in %."

       ^self value: aValue
!

token
   "Returns the token to be used when printing the receiver."

    ^self class token
!

twips
         "Returns the receiver's parameter in twips."

  ^self parameter
!

twips: aValue
    "Sets the receiver's parameter with a value in twips."

        self parameter: aValue truncated
!

value
    "Returns the receiver's value."

       parameter isNil ifTrue: [ self initializeValue ].
      ^self parameter
!

value: aValue
        "Sets the receiver's value."

  self parameter: aValue
! !

!RTFControlWord methodsFor:'initialization'!

initializeParameter
      " Private - Initialize the receiver's parameter.
       The default action is to do nothing.
   This method can be refined by subclasses. "
!

initializeValue
     " Private - Initialize the receiver's value.
   The default action is to do nothing.
   This method can be refined by subclasses. "
! !

!RTFControlWord methodsFor:'printing'!

basicPrintRTFOn: aStream
         "Must write the receiver in RTF source format onto aStream."

  aStream nextPut: $\;nextPutAll: self token.
    self printParameterOn: aStream.
!

printParameterOn: aStream
  "Must dump the receiver's parameter(s) onto aStream."

         self parameter notNil ifTrue: [
                self printableParameter printOn: aStream.
      ].
!

printableParameter
    " Private - Returns a printable representation of the receiver's parameter.
    By default numbers are converted to integer values.
    This method can be refined by subclasses."

    | result |
     result := self parameter.
      (result isKindOf: Number) ifTrue: [ ^result asInteger ].
        ^result
! !

!RTFControlWord methodsFor:'query'!

isOff
         "Returns true if the receiver is off."

        ^self value = 0
!

isOn
     "Returns true if the receiver is on."

         ^self value = 1
! !

!RTFControlWord class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFControlWord.st,v 1.2 2011/01/28 14:29:03 cg Exp $'
! !
