"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFSortedComposite subclass:#RTFFieldGroup
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFFieldGroup class methodsFor:'instance creation'!

instructions: instructions results: results
    "Returns an instance of the receiver set with instructions & results."

        | result |
     result := self new.
    result instructions add: (RTFText from: instructions).
         result results add: (RTFText from: results).
   ^result
! !

!RTFFieldGroup class methodsFor:'sorting contents'!

bnfAlternatives
       " Private - Returns the array of extended BNF alternatives for instance's contents. 
   <field>         =       '{' \field <fieldmod>? <fieldinst> <fieldrslt> '}'
     <fieldmod>      =       \flddirty? & \fldedit? & \fldlock? & \fldpriv?
         <fieldinst>     =       '{\*' \fldinst <para>+ <fldalt>? '}'
   <fldalt>        =       \fldalt
        <fieldrslt>     =       '{' \fldrslt <para>+ '}'
       "

     ^#(
            #RTFField
              #RTFFieldModificator
           #RTFFieldInstructions
          #RTFFieldResults
       )
! !

!RTFFieldGroup methodsFor:'accessors'!

dirty
       "Sets the receiver's this modifier."

  ^self oneOf: RTFFieldDirty
!

edited
       "Sets the receiver's this modifier."

  ^self oneOf: RTFFieldEdited
!

instructions
   "Returns the receiver's instructions."

        ^self oneOf: RTFFieldInstructions
!

locked
        "Sets the receiver's this modifier."

  ^self oneOf: RTFFieldLocked
!

private
       "Sets the receiver's this modifier."

  ^self oneOf: RTFFieldPrivate
!

results
  "Returns the receiver's results."

     ^self oneOf: RTFFieldResults
! !

!RTFFieldGroup methodsFor:'initialization'!

initializeElements
        " Private - Initializes the receiver's elements. "

    super initializeElements.
      self elements add: RTFField new.
! !

!RTFFieldGroup methodsFor:'query'!

isGroup
     "Must return true when the receiver is a group."

      ^true
!

isTextElement
   "Must return true when the receiver is a text element."

       ^true
! !

!RTFFieldGroup class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFFieldGroup.st,v 1.2 2011/01/28 14:30:39 cg Exp $'
! !
