"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFComposite subclass:#RTFFile
	instanceVariableNames:'header document'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFFile methodsFor:'accessing'!

document
      "Returns the receiver's document."

    document isNil ifTrue: [ self initializeDocument ].
    ^document
!

document: aDocument
      "Sets the receiver's document."

       document := aDocument
!

elements
     "Must return all the elements of the receiver in a valid order."

      ^Array with: self header with: self document
!

header
   "Returns the receiver's header."

      header isNil ifTrue: [ self initializeHeader ].
        ^header
!

header: aHeader
        "Sets the receiver's header."

         header := aHeader
! !

!RTFFile methodsFor:'initialization'!

initializeDocument
     " Private - Initializes the receiver. "

       document := RTFDocumentArea new.
!

initializeHeader
         " Private - Initializes the receiver. "

       header := RTFHeader new.
! !

!RTFFile methodsFor:'query'!

isGroup
  "Must return true when the receiver is a group."

      ^true
! !

!RTFFile class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFFile.st,v 1.2 2011/01/28 14:30:59 cg Exp $'
! !
