"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFFontInfoItem subclass:#RTFFontFamily
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFFontFamily class methodsFor:'query'!

supportedTokens
     "Returns the collection of tokens supported by the receiver."

         ^#( 'fnil' 'froman' 'fswiss' 'fmodern' 'fscript' 'fdecor' 'ftech' 'fbidi' )
! !

!RTFFontFamily methodsFor:'accessors'!

format
         "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
      "Sets the receiver's format."

         format := aFormat
!

name: aFamilyName
     "Sets the receiver's name."

   self format: 'f',aFamilyName
!

token
         "Returns the receiver's token."

       ^self format
! !

!RTFFontFamily methodsFor:'settings'!

bidi
    "Set the receiver with the this format."

      ^self name: 'bidi'
!

bidirectional
  "Set the receiver with the this format."

      ^self bidi
!

decor
        "Set the receiver with the this format."

      ^self name: 'decor'
!

decoration
   "Set the receiver with the this format."

      ^self decor
!

default
        "Set the receiver with the default format."

   ^self nil
!

modern
    "Set the receiver with the this format."

      ^self name: 'modern'
!

nil
   "Set the receiver with the this format."

      ^self name: 'nil'
!

roman
         "Set the receiver with the this format."

      ^self name: 'roman'
!

script
        "Set the receiver with the this format."

      ^self name: 'script'
!

swiss
        "Set the receiver with the this format."

      ^self name: 'swiss'
!

tech
  "Set the receiver with the this format."

      ^self name: 'tech'
!

techical
        "Set the receiver with the this format."

      ^self tech
! !

!RTFFontFamily class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFFontFamily.st,v 1.2 2011/01/28 14:31:14 cg Exp $'
! !
