"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFControlWord subclass:#RTFHeaderAndFooterControl
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFHeaderAndFooterControl class methodsFor:'query'!

supportedTokens
    "Returns the collection of tokens supported by the receiver."

         ^#( 'footer' 'footerf' 'footerl' 'footerr' 'header' 'headerf' 'headerl' 'headerr' )
! !

!RTFHeaderAndFooterControl methodsFor:'accessors'!

format
       "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
      "Sets the receiver's format."

         format := aFormat
!

token
      "Returns the receiver's token."

       ^self format
! !

!RTFHeaderAndFooterControl methodsFor:'settings'!

default
        "Set the receiver with the default format."

   ^self headerOnAll
!

footerOnAll
      "Set the receiver with this format."

  ^self format: 'footer'
!

footerOnFirst
     "Set the receiver with this format."

  ^self format: 'footerf'
!

footerOnLeft
       "Set the receiver with this format."

  ^self format: 'footerl'
!

footerOnRight
         "Set the receiver with this format."

  ^self format: 'footerr'
!

headerOnAll
   "Set the receiver with this format."

  ^self format: 'header'
!

headerOnFirst
         "Set the receiver with this format."

  ^self format: 'headerf'
!

headerOnLeft
  "Set the receiver with this format."

  ^self format: 'headerl'
!

headerOnRight
  "Set the receiver with this format."

  ^self format: 'headerr'
! !

!RTFHeaderAndFooterControl class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFHeaderAndFooterControl.st,v 1.2 2011/01/28 14:32:28 cg Exp $'
! !
