"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFInformationItem subclass:#RTFInformationTimeItem
	instanceVariableNames:'timeStamp'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFInformationTimeItem class methodsFor:'time stamping'!

timeStampClass
     " Private - returns the time stamp class support. "

   ^TimeStamp
! !

!RTFInformationTimeItem methodsFor:'accessors'!

date
       "Returns the receiver's date."

        ^self timeStamp date
!

date: aDate
  "Sets the receiver's date."

   self timeStamp date: aDate
!

time
    "Returns the receiver's time."

        ^self timeStamp time
!

time: aTime
  "Sets the receiver's time."

   self timeStamp time: aTime
!

timeStamp
  "Returns the receiver's timestamp."

   timeStamp isNil ifTrue: [
              timeStamp := self class timeStampClass
                         date: Date today time: Time now
        ].
     ^timeStamp
!

timeStamp: aTimeStamp
        "Sets the receiver's timestamp."

      timeStamp := aTimeStamp
! !

!RTFInformationTimeItem methodsFor:'printing'!

basicPrintRTFOn: aStream
      "Must write the receiver in RTF source format onto aStream."

  super basicPrintRTFOn: aStream.
        self printTimeStampOn: aStream
!

printTimeStampOn: aStream
     " Private - Write the receiver's time stamp onto aStream."

    | date time |
  date := self date.
     date notNil ifTrue: [
          aStream nextPutAll:
                     '\yr',date year printString
                   ,'\mo',date monthIndex printString
                     ,'\dy',date dayOfMonth printString
     ].
     time := self time.
     time notNil ifTrue: [
          aStream nextPutAll:
                     '\hr',time hours printString
                  ,'\min',time minutes printString
                       ,'\sec',time seconds printString
       ].
! !

!RTFInformationTimeItem methodsFor:'query'!

isGroup
  "Must return true when the receiver is a group."

      ^true
! !

!RTFInformationTimeItem class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFInformationTimeItem.st,v 1.2 2011/01/28 14:32:57 cg Exp $'
! !
