"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFSingleElement subclass:#RTFInlineElement
	instanceVariableNames:'value'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFInlineElement class methodsFor:'instance creation'!

value: aString
       "Returns an instance of the receiver."

        ^self new
              value: aString;
                yourself
! !

!RTFInlineElement methodsFor:'accessors'!

token
        "Returns the token to be used when printing the receiver."

    | stream token |
       stream := ReadStream on: self value.
   stream atEnd ifTrue: [ ^nil ].
         token := stream upTo: $';upTo: $\.
     token := (ReadStream on: token) upTo: $ .
      ^token select: [:c| c isDigit not ]
!

value
   "Returns the receiver's value."

       ^value
!

value: aString
         "Sets the receiver's value."

  value := aString
! !

!RTFInlineElement methodsFor:'printing'!

basicPrintRTFOn: aStream
    "Must write the receiver in RTF source format onto aStream."

  aStream nextPutAll: self value
! !

!RTFInlineElement methodsFor:'query'!

isTextElement
         "Must return true when the receiver is a text element."

       ^true
! !

!RTFInlineElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFInlineElement.st,v 1.2 2011/01/28 14:33:02 cg Exp $'
! !
