"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFPageBordersProperty subclass:#RTFPageBorder
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFPageBorder class methodsFor:'query'!

supportedTokens
        "Returns the collection of tokens supported by the receiver."

         ^#( 'brdrart' ), (#('b' 'l' 'head' 'foot' 'r' 't') collect: [:each| 'pgbrdr',each ])
! !

!RTFPageBorder methodsFor:'accessors'!

format
      "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
       "Sets the receiver's format."

         format := aFormat
!

token
       "Returns the receiver's token."

       ^self format
! !

!RTFPageBorder methodsFor:'settings'!

art: number
  " Set the receiver with border format art"

    self format: 'brdrart'.
        self value: number
!

bottom
       "Set the receiver with the this format."

      ^self surrounds: 'b'
!

default
      "Set the receiver with the default format."

   ^self normal
!

left
      "Set the receiver with the this format."

      ^self surrounds: 'l'
!

normal
   "Set the receiver with the this format."

      ^self surrounds: 'head'
!

reversed
       "Set the receiver with the this format."

      ^self surrounds: 'foot'
!

right
        "Set the receiver with the this format."

      ^self surrounds: 'r'
!

surrounds: what
   " Private - Set the receiver with format surrounding..."

      self format: 'pgbrdr',what.
    self value: nil.
!

top
     "Set the receiver with the this format."

      ^self surrounds: 't'
! !

!RTFPageBorder class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFPageBorder.st,v 1.2 2011/01/28 14:34:30 cg Exp $'
! !
