"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFPageNumberProperty subclass:#RTFPageNumberFormat
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFPageNumberFormat class methodsFor:'query'!

supportedTokens
  "Returns the collection of tokens supported by the receiver."

         ^#( 'pgndec' 'pgnlcltr' 'pgnlcrm' 'pgnucltr' 'pgnucrm' )
! !

!RTFPageNumberFormat methodsFor:'accessors'!

format
      "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
        "Sets the receiver's format."

         format := aFormat
!

token
        "Returns the receiver's token."

       ^self format
! !

!RTFPageNumberFormat methodsFor:'settings'!

decimal
        "Set the receiver with this format."

  self format: 'pgndec'
!

default
  "Set the receiver with the default format."

   ^self decimal
!

lowerCaseLetter
         "Set the receiver with this format."

  self lowercaseLetter
!

lowerCaseRoman
    "Set the receiver with this format."

  self lowercaseRoman
!

lowercaseLetter
      "Set the receiver with this format."

  self format: 'pgnlcltr'
!

lowercaseRoman
        "Set the receiver with this format."

  self format: 'pgnlcrm'
!

upperCaseLetter
        "Set the receiver with this format."

  self uppercaseLetter
!

upperCaseRoman
      "Set the receiver with this format."

  self uppercaseRoman
!

uppercaseLetter
    "Set the receiver with this format."

  self format: 'pgnucltr'
!

uppercaseRoman
         "Set the receiver with this format."

  self format: 'pgnucrm'
! !

!RTFPageNumberFormat class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFPageNumberFormat.st,v 1.2 2011/01/28 14:35:37 cg Exp $'
! !
