"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFPageNumberProperty subclass:#RTFPageSeparatorCharacter
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFPageSeparatorCharacter class methodsFor:'query'!

supportedTokens
    "Returns the collection of tokens supported by the receiver."

         ^#( 'pgnhnsc' 'pgnhnsm' 'pgnhnsn' 'pgnhnsh' 'pgnhnsp' )
! !

!RTFPageSeparatorCharacter methodsFor:'accessors'!

format
     "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
      "Sets the receiver's format."

         format := aFormat
!

token
        "Returns the receiver's token."

       ^self format
! !

!RTFPageSeparatorCharacter methodsFor:'settings'!

colon
      "Set the receiver with this character."

       ^self format: 'pgnhnsc'
!

default
       "Set the receiver with the default format."

   ^self hyphen
!

emDash
        "Set the receiver with this character."

       ^self format: 'pgnhnsm'
!

enDash
   "Set the receiver with this character."

       ^self format: 'pgnhnsn'
!

hyphen
   "Set the receiver with this character."

       ^self format: 'pgnhnsh'
!

period
        "Set the receiver with this character."

       ^self format: 'pgnhnsp'
! !

!RTFPageSeparatorCharacter class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFPageSeparatorCharacter.st,v 1.2 2011/01/28 14:35:46 cg Exp $'
! !
