"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFParagraphFormating subclass:#RTFParagraphAlignment
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFParagraphAlignment class methodsFor:'query'!

supportedTokens
     "Returns the collection of tokens supported by the receiver."

         ^#( 'qc' 'qr' 'ql' 'qj' )
! !

!RTFParagraphAlignment methodsFor:'accessors'!

format
        "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
  "Sets the receiver's format."

         format := aFormat
!

token
         "Returns the receiver's token."

       ^self format
! !

!RTFParagraphAlignment methodsFor:'settings'!

center
       "Set the receiver with this format."

  ^self format: 'qc'
!

centered
        "Set the receiver with this format."

  ^self format: 'qc'
!

default
         "Set the receiver with the default format."

   ^self left
!

justified
      "Set the receiver with this format."

  ^self format: 'qj'
!

left
   "Set the receiver with this format."

  ^self format: 'ql'
!

right
  "Set the receiver with this format."

  ^self format: 'qr'
! !

!RTFParagraphAlignment class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFParagraphAlignment.st,v 1.2 2011/01/28 14:36:03 cg Exp $'
! !
