"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFParagraphFormating subclass:#RTFParagraphBorder
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFParagraphBorder class methodsFor:'instance creation'!

color: aNumber
    "Returns an instance of the receiver."

        ^self new
              setColor: aNumber;
             yourself
!

defaultType
     "Returns an instance of the receiver."

        ^self new
              singleThickness;
               yourself
!

space: aNumber
         "Returns an instance of the receiver."

        ^self new
              space: aNumber;
                yourself
!

width: aNumber
     "Returns an instance of the receiver."

        ^self width: aNumber in: #twips
!

width: aNumber in: units
       "Returns an instance of the receiver."

        ^self new
              width: aNumber in: units;
              yourself
! !

!RTFParagraphBorder class methodsFor:'query'!

supportedTokens
  "Returns the collection of tokens supported by the receiver."

         ^#(
            'brdrbar' 'brdrb' 'box' 'brdrbtw'
              'brdrdash' 'brdrdashsm' 'brdrdash' 'brdrdot'
           'brdrdashd' 'brdrdashdd' 'brdrdb' 'brdrth'
             'brdrwavydb' 'brdremboss' 'brdrengrave' 'brdrhair'
             'brdrl' 'brdrr' 'brdrcf' 'brdrsh'
              'brdrs' 'brsp' 'brdrdashdotstr' 'brdrtnthsg'
           'brdrtnthlg' 'brdrtnthmg' 'brdrthtnsg' 'brdrthtnlg'
            'brdrthtnmg' 'brdrtnthtnsg' 'brdrtnthtnlg' 'brdrtnthtnmg'
              'brdrt' 'brdrtriple' 'brdrwavy' 'brdrw'
        )
! !

!RTFParagraphBorder methodsFor:'accessors'!

format
    "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
  "Sets the receiver's format."

         format := aFormat
!

token
    "Returns the receiver's token."

       ^self format
! !

!RTFParagraphBorder methodsFor:'settings'!

borderOutside
     "Set the receiver with this format."

  ^self format: 'brdrbar'
!

bottom
       "Set the receiver with this format."

  ^self format: 'brdrb'
!

box
         "Set the receiver with this format."

  ^self format: 'box'
!

consecutive
       "Set the receiver with this format."

  ^self format: 'brdrbtw'
!

dash
        "Set the receiver with this format."

  ^self format: 'brdrdash'
!

dashBorder
         "Set the receiver with this format."

  ^self format: 'brdrdashsm'
!

dashed
  "Set the receiver with this format."

  ^self format: 'brdrdash'
!

default
   "Set the receiver with the default format."

   ^self top
!

dot
         "Set the receiver with this format."

  ^self format: 'brdrdot'
!

dotDashBorder
   "Set the receiver with this format."

  ^self format: 'brdrdashd'
!

dotDotDashBorder
  "Set the receiver with this format."

  ^self format: 'brdrdashdd'
!

double
  "Set the receiver with this format."

  ^self format: 'brdrdb'
!

doubleThickness 
        "Set the receiver with this format."

  ^self format: 'brdrth'
!

doubleWavy
   "Set the receiver with this format."

  ^self format: 'brdrwavydb'
!

emboss
         "Set the receiver with this format."

  ^self format: 'brdremboss'
!

engrave
       "Set the receiver with this format."

  ^self format: 'brdrengrave'
!

hair
       "Set the receiver with this format."

  ^self format: 'brdrhair'
!

left
     "Set the receiver with this format."

  ^self format: 'brdrl'
!

right
     "Set the receiver with this format."

  ^self format: 'brdrr'
!

setColor: aNumber
      "Set the receiver with this format."

  self
           format: 'brdrcf';
              value: (self color: aNumber)
!

shadowed
      "Set the receiver with this format."

  ^self format: 'brdrsh'
!

singleThickness 
   "Set the receiver with this format."

  ^self format: 'brdrs'
!

space: aNumber
      "Set the receiver with this format."

  self
           format: 'brsp';
                value: aNumber
!

striped
        "Set the receiver with this format."

  ^self format: 'brdrdashdotstr'
!

thickThin
     "Set the receiver with this format."

  ^self format: 'brdrtnthsg'
!

thickThinLarge
       "Set the receiver with this format."

  ^self format: 'brdrtnthlg'
!

thickThinMedium
   "Set the receiver with this format."

  ^self format: 'brdrtnthmg'
!

thinThick
     "Set the receiver with this format."

  ^self format: 'brdrthtnsg'
!

thinThickLarge
    "Set the receiver with this format."

  ^self format: 'brdrthtnlg'
!

thinThickMedium
      "Set the receiver with this format."

  ^self format: 'brdrthtnmg'
!

thinThickThin
       "Set the receiver with this format."

  ^self format: 'brdrtnthtnsg'
!

thinThickThinLarge
  "Set the receiver with this format."

  ^self format: 'brdrtnthtnlg'
!

thinThickThinMedium
         "Set the receiver with this format."

  ^self format: 'brdrtnthtnmg'
!

top
  "Set the receiver with this format."

  ^self format: 'brdrt'
!

triple
      "Set the receiver with this format."

  ^self format: 'brdrtriple'
!

wavy
      "Set the receiver with this format."

  ^self format: 'brdrwavy'
!

width: aNumber
         "Set the receiver with this format."

  self width: aNumber in: #twips
!

width: aNumber in: units
  "Set the receiver with this format."

  self
           format: 'brdrw';
               twips: (self measure: aNumber in: units)
! !

!RTFParagraphBorder class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFParagraphBorder.st,v 1.2 2011/01/28 14:36:05 cg Exp $'
! !
