"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFParagraphFormating subclass:#RTFParagraphIndentation
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFParagraphIndentation class methodsFor:'query'!

supportedTokens
        "Returns the collection of tokens supported by the receiver."

         ^#( 'fi' 'li' 'ri' )
! !

!RTFParagraphIndentation methodsFor:'accessors'!

format
       "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
        "Sets the receiver's format."

         format := aFormat
!

token
       "Returns the receiver's token."

       ^self format
! !

!RTFParagraphIndentation methodsFor:'initialization'!

initializeValue
   " Private - Initialize the receiver's value. "

        self value: 0
! !

!RTFParagraphIndentation methodsFor:'settings'!

default
      "Set the receiver with the default format."

   ^self firstLine
!

firstLine
    "Set the receiver with this format."

  ^self format: 'fi'
!

left
       "Set the receiver with this format."

  ^self format: 'li'
!

right
      "Set the receiver with this format."

  ^self format: 'ri'
! !

!RTFParagraphIndentation class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFParagraphIndentation.st,v 1.2 2011/01/28 14:36:17 cg Exp $'
! !
