"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFParagraphFormating subclass:#RTFParagraphSpacing
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFParagraphSpacing class methodsFor:'query'!

supportedTokens
       "Returns the collection of tokens supported by the receiver."

         ^#( 'sa' 'sb' 'sl' 'slmult' )
! !

!RTFParagraphSpacing methodsFor:'accessors'!

format
  "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
      "Sets the receiver's format."

         format := aFormat
!

token
      "Returns the receiver's token."

       ^self format
! !

!RTFParagraphSpacing methodsFor:'initialization'!

initializeValue
    " Private - Initialize the receiver's value. "

        self value: 0
! !

!RTFParagraphSpacing methodsFor:'settings'!

after
  "Set the receiver with this format."

  ^self format: 'sa'
!

before
        "Set the receiver with this format."

  ^self format: 'sb'
!

betweenLines
   "Set the receiver with this format."

  ^self format: 'sl'
!

default
      "Set the receiver with the default format."

   ^self before
!

multiple
         "Set the receiver with this format."

  ^self format: 'slmult'
! !

!RTFParagraphSpacing class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFParagraphSpacing.st,v 1.2 2011/01/28 14:36:44 cg Exp $'
! !
