"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFSpecialCharacter subclass:#RTFQuote
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFQuote class methodsFor:'query'!

supportedTokens
   "Returns the collection of tokens supported by the receiver."

         ^#( 'lquote' 'ldblquote' 'rquote' 'rdblquote' )
! !

!RTFQuote methodsFor:'accessors'!

format
      "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
    "Sets the receiver's format."

         format := aFormat
!

token
  "Returns the receiver's token."

       ^self format
! !

!RTFQuote methodsFor:'settings'!

default
   "Set the receiver with the default format."

   ^self left
!

left
         "Set the receiver with this format."

  ^self format: 'lquote'
!

leftDouble
  "Set the receiver with this format."

  ^self format: 'ldblquote'
!

right
  "Set the receiver with this format."

  ^self format: 'rquote'
!

rightDouble
     "Set the receiver with this format."

  ^self format: 'rdblquote'
! !

!RTFQuote class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFQuote.st,v 1.2 2011/01/28 14:37:04 cg Exp $'
! !
