"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFRowFormating subclass:#RTFRowBorder
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFRowBorder class methodsFor:'query'!

supportedTokens
         "Returns the collection of tokens supported by the receiver."

         ^#( 'trbrdrb' 'trbrdrh' 'trbrdrl' 'trbrdrr' 'trbrdrt' 'trbrdrv' )
! !

!RTFRowBorder methodsFor:'accessors'!

format
    "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
   "Sets the receiver's format."

         format := aFormat
!

token
     "Returns the receiver's token."

       ^self format
! !

!RTFRowBorder methodsFor:'settings'!

bottom
  "Set the receiver with this format."

  ^self format: 'trbrdrb'
!

default
    "Set the receiver with the default format."

   ^self left
!

horizontal
         "Set the receiver with this format."

  ^self format: 'trbrdrh'
!

left
    "Set the receiver with this format."

  ^self format: 'trbrdrl'
!

right
    "Set the receiver with this format."

  ^self format: 'trbrdrr'
!

top
   "Set the receiver with this format."

  ^self format: 'trbrdrt'
!

vertical
         "Set the receiver with this format."

  ^self format: 'trbrdrv'
! !

!RTFRowBorder class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFRowBorder.st,v 1.2 2011/01/28 14:37:27 cg Exp $'
! !
