"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFRowFormating subclass:#RTFRowJustification
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFRowJustification class methodsFor:'query'!

supportedTokens
  "Returns the collection of tokens supported by the receiver."

         ^#( 'trqc' 'trql' 'trqr' )
! !

!RTFRowJustification methodsFor:'accessors'!

format
        "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
       "Sets the receiver's format."

         format := aFormat
!

token
   "Returns the receiver's token."

       ^self format
! !

!RTFRowJustification methodsFor:'settings'!

center
         "Set the receiver with this format."

  ^self format: 'trqc'
!

default
  "Set the receiver with the default format."

   ^self left
!

left
     "Set the receiver with this format."

  ^self format: 'trql'
!

right
  "Set the receiver with this format."

  ^self format: 'trqr'
! !

!RTFRowJustification class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFRowJustification.st,v 1.2 2011/01/28 14:37:38 cg Exp $'
! !
