"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFTabFormating subclass:#RTFTabLeader
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFTabLeader class methodsFor:'query'!

supportedTokens
   "Returns the collection of tokens supported by the receiver."

         ^#( 'tldot' 'tleq' 'tlhyph' 'tlth' 'tlul' )
! !

!RTFTabLeader methodsFor:'accessors'!

format
       "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
      "Sets the receiver's format."

         format := aFormat
!

token
      "Returns the receiver's token."

       ^self format
! !

!RTFTabLeader methodsFor:'settings'!

default
       "Set the receiver with the default format."

   ^self dots
!

dots
    "Set the receiver with this format."

  ^self format: 'tldot'
!

equalSign
      "Set the receiver with this format."

  ^self format: 'tleq'
!

hyphens
         "Set the receiver with this format."

  ^self format: 'tlhyph'
!

thickLine
     "Set the receiver with this format."

  ^self format: 'tlth'
!

underline
  "Set the receiver with this format."

  ^self format: 'tlul'
! !

!RTFTabLeader class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFTabLeader.st,v 1.2 2011/01/28 14:38:52 cg Exp $'
! !
