"{ Package: 'stx:goodies/docFormats/rtf' }"

"{ NameSpace: RTF1 }"

RTFExpansion subclass:#RTFUnderline
	instanceVariableNames:'format'
	classVariableNames:''
	poolDictionaries:''
	category:'RTF-Dist'
!


!RTFUnderline class methodsFor:'query'!

supportedTokens
  "Returns the collection of tokens supported by the receiver."

         ^#(
            'ul' 'uldash' 'uldashd' 'uldashdd'
             'uld' 'uldb' 'ulnone' 'ulth' 'ulwave' 'ulw'
    )
! !

!RTFUnderline methodsFor:'accessors'!

format
  "Returns the receiver's format."

      format isNil ifTrue: [ self default ].
         ^format
!

format: aFormat
        "Sets the receiver's format."

         format := aFormat
!

token
      "Returns the receiver's token."

       ^self format
! !

!RTFUnderline methodsFor:'settings'!

continuous
         "Set the receiver with this format."

  ^self format: 'ul'
!

dash
       "Set the receiver with this format."

  ^self format: 'uldash'
!

default
  "Set the receiver with the default format."

   ^self continuous
!

dotDash
        "Set the receiver with this format."

  ^self format: 'uldashd'
!

dotDotDash
    "Set the receiver with this format."

  ^self format: 'uldashdd'
!

dotted
    "Set the receiver with this format."

  ^self format: 'uld'
!

double
         "Set the receiver with this format."

  ^self format: 'uldb'
!

none
      "Set the receiver with this format."

  ^self format: 'ulnone'
!

thick
       "Set the receiver with this format."

  ^self format: 'ulth'
!

wave
  "Set the receiver with this format."

  ^self format: 'ulwave'
!

word
  "Set the receiver with this format."

  ^self format: 'ulw'
! !

!RTFUnderline class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/RTFUnderline.st,v 1.2 2011/01/28 14:39:45 cg Exp $'
! !
