"{ Package: 'stx:goodies/docFormats/rtf' }"

LibraryDefinition subclass:#stx_goodies_docFormats_rtf
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_docFormats_rtf class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:libbasic'    "Object - superclass of RTF1::RTFSectionBreakNone "
    )
! !

!stx_goodies_docFormats_rtf class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'RTF1::RTFElement'
        #'stx_goodies_docFormats_rtf'
        #'RTF1::RTFComposite'
        #'RTF1::RTFSingleElement'
        #'RTF1::RTFControlWord'
        #'RTF1::RTFFile'
        #'RTF1::RTFInlineElement'
        #'RTF1::RTFModel'
        #'RTF1::RTFOrderedComposite'
        #'RTF1::RTFSortedComposite'
        #'RTF1::RTFBordersModel'
        #'RTF1::RTFCellModel'
        #'RTF1::RTFCharacterSet'
        #'RTF1::RTFColorDefinition'
        #'RTF1::RTFColorElement'
        #'RTF1::RTFDefaultFont'
        #'RTF1::RTFDocumentArea'
        #'RTF1::RTFDocumentFormatingProperties'
        #'RTF1::RTFDocumentFormatingProperty'
        #'RTF1::RTFFieldElement'
        #'RTF1::RTFFieldGroup'
        #'RTF1::RTFFieldInstructions'
        #'RTF1::RTFFieldResults'
        #'RTF1::RTFFontElement'
        #'RTF1::RTFGroup'
        #'RTF1::RTFHeader'
        #'RTF1::RTFHeaderAndFooter'
        #'RTF1::RTFHeaderAndFooterControl'
        #'RTF1::RTFHeaderAndFooterGroup'
        #'RTF1::RTFInformationItem'
        #'RTF1::RTFPCData'
        #'RTF1::RTFParagraphText'
        #'RTF1::RTFSectionFormatingProperty'
        #'RTF1::RTFSectionText'
        #'RTF1::RTFShadingModel'
        #'RTF1::RTFSortedGroup'
        #'RTF1::RTFTableDefinition'
        #'RTF1::RTFTableElement'
        #'RTF1::RTFTableModel'
        #'RTF1::RTFTableText'
        #'RTF1::RTFTextElement'
        #'RTF1::RTFVersion'
        #'RTF1::RTFBordersFormating'
        #'RTF1::RTFBulletsAndNumberingFormating'
        #'RTF1::RTFCell'
        #'RTF1::RTFCellFormating'
        #'RTF1::RTFCellShadingModel'
        #'RTF1::RTFCharacterFormating'
        #'RTF1::RTFColorComponent'
        #'RTF1::RTFColorTable'
        #'RTF1::RTFColorTableControl'
        #'RTF1::RTFColumnBordersModel'
        #'RTF1::RTFColumnsFormatingProperty'
        #'RTF1::RTFDocumentVersion'
        #'RTF1::RTFField'
        #'RTF1::RTFFieldAlternate'
        #'RTF1::RTFFieldInstruction'
        #'RTF1::RTFFieldModificator'
        #'RTF1::RTFFieldResult'
        #'RTF1::RTFFontInfoGroup'
        #'RTF1::RTFFontInfoItem'
        #'RTF1::RTFFontTable'
        #'RTF1::RTFFontTableControl'
        #'RTF1::RTFFormInformationProperty'
        #'RTF1::RTFGeneralDocumentFormatingProperty'
        #'RTF1::RTFGeneralSectionFormatingProperty'
        #'RTF1::RTFInformationDataItem'
        #'RTF1::RTFInformationGroup'
        #'RTF1::RTFInformationTimeItem'
        #'RTF1::RTFInformationValue'
        #'RTF1::RTFLineNumberingFormatingProperty'
        #'RTF1::RTFNotesDocumentFormatingProperty'
        #'RTF1::RTFOnlyComments'
        #'RTF1::RTFPageBordersInformationProperty'
        #'RTF1::RTFPageFormatingProperty'
        #'RTF1::RTFPageInformationProperty'
        #'RTF1::RTFParagraphFormating'
        #'RTF1::RTFRevisionsInformationProperty'
        #'RTF1::RTFRow'
        #'RTF1::RTFRowBordersModel'
        #'RTF1::RTFRowFormating'
        #'RTF1::RTFSectionBreakFormatingProperty'
        #'RTF1::RTFSpecialCharacter'
        #'RTF1::RTFTabFormating'
        #'RTF1::RTFTableCellElement'
        #'RTF1::RTFTableFormating'
        #'RTF1::RTFTableRowElement'
        #'RTF1::RTFText'
        #'RTF1::RTFViewDocumentFormatingProperty'
        #'RTF1::RTFAchorSeparatorForFootnote'
        #'RTF1::RTFAchorSeparatorForFootnoteContinuation'
        #'RTF1::RTFAlignBordersToEdges'
        #'RTF1::RTFAllCapitals'
        #'RTF1::RTFAnnotationReference'
        #'RTF1::RTFAuthor'
        #'RTF1::RTFAutomaticFootnote'
        #'RTF1::RTFAutomaticHyphenation'
        #'RTF1::RTFBackgroundColor'
        #'RTF1::RTFBackupTime'
        #'RTF1::RTFBarTabPosition'
        #'RTF1::RTFBeginningLineNumber'
        #'RTF1::RTFBeginningPageNumber'
        #'RTF1::RTFBold'
        #'RTF1::RTFBorder'
        #'RTF1::RTFBreak'
        #'RTF1::RTFBullet'
        #'RTF1::RTFCategory'
        #'RTF1::RTFCellBackgroundBackColor'
        #'RTF1::RTFCellBackgroundLineColor'
        #'RTF1::RTFCellBackgroundPattern'
        #'RTF1::RTFCellBorder'
        #'RTF1::RTFCellShading'
        #'RTF1::RTFCellTextAlignment'
        #'RTF1::RTFCellsGap'
        #'RTF1::RTFCharacterAnimation'
        #'RTF1::RTFCharacterDeleted'
        #'RTF1::RTFCharacterLanguage'
        #'RTF1::RTFCharacterPattern'
        #'RTF1::RTFCharacterPatternColor'
        #'RTF1::RTFCharacterPatternFill'
        #'RTF1::RTFCharacterReset'
        #'RTF1::RTFCharacterScale'
        #'RTF1::RTFCharacterShading'
        #'RTF1::RTFCharacterStyle'
        #'RTF1::RTFCharacterSubscript'
        #'RTF1::RTFCharacterSuperscript'
        #'RTF1::RTFColumnNumber'
        #'RTF1::RTFColumnRightSpace'
        #'RTF1::RTFColumnShadingModel'
        #'RTF1::RTFColumnWidth'
        #'RTF1::RTFComment'
        #'RTF1::RTFCompany'
        #'RTF1::RTFCreationTime'
        #'RTF1::RTFDate'
        #'RTF1::RTFDefaultLanguage'
        #'RTF1::RTFDefaultLanguageID'
        #'RTF1::RTFDefaultTabWidth'
        #'RTF1::RTFDistanceFromLineToLeftMargin'
        #'RTF1::RTFDocumentComment'
        #'RTF1::RTFDocumentIsBoilerplate'
        #'RTF1::RTFDocumentIsPlainText'
        #'RTF1::RTFDocumentType'
        #'RTF1::RTFEmDash'
        #'RTF1::RTFEmboss'
        #'RTF1::RTFEnDash'
        #'RTF1::RTFEndOf'
        #'RTF1::RTFEndnoteContinuedNotice'
        #'RTF1::RTFEndnotesIncludedInSection'
        #'RTF1::RTFEndnotesSeparator'
        #'RTF1::RTFEndnotesSeparatorContinued'
        #'RTF1::RTFEngrave'
        #'RTF1::RTFExpansion'
        #'RTF1::RTFFacingPages'
        #'RTF1::RTFFieldDirty'
        #'RTF1::RTFFieldEdited'
        #'RTF1::RTFFieldLocked'
        #'RTF1::RTFFieldPrivate'
        #'RTF1::RTFFirstCellMerged'
        #'RTF1::RTFFirstPageHasSpecialFormat'
        #'RTF1::RTFFontAlternateName'
        #'RTF1::RTFFontCharacterSet'
        #'RTF1::RTFFontCodePage'
        #'RTF1::RTFFontFamily'
        #'RTF1::RTFFontNonTaggedName'
        #'RTF1::RTFFontPitch'
        #'RTF1::RTFFootnoteContinuedNotice'
        #'RTF1::RTFFootnoteSeparator'
        #'RTF1::RTFFootnoteSeparatorContinued'
        #'RTF1::RTFFootnoteType'
        #'RTF1::RTFFootnotesAtEndOfDocument'
        #'RTF1::RTFFootnotesAtEndOfSection'
        #'RTF1::RTFForegroundColor'
        #'RTF1::RTFFormDisplay'
        #'RTF1::RTFFormProtected'
        #'RTF1::RTFFractionalCharacterWidths'
        #'RTF1::RTFGutterWidth'
        #'RTF1::RTFHasFormShading'
        #'RTF1::RTFHexa'
        #'RTF1::RTFHidden'
        #'RTF1::RTFHighlightColor'
        #'RTF1::RTFHyperlinkBase'
        #'RTF1::RTFHyphenationCapitalize'
        #'RTF1::RTFHyphenationConsecutiveLines'
        #'RTF1::RTFHyphenationHotZone'
        #'RTF1::RTFInternalID'
        #'RTF1::RTFInternalVersionNumber'
        #'RTF1::RTFIsDefaultFormat'
        #'RTF1::RTFKeywords'
        #'RTF1::RTFLandscape'
        #'RTF1::RTFLastPrintTime'
        #'RTF1::RTFLineBetweenColumns'
        #'RTF1::RTFLineNumberIncrement'
        #'RTF1::RTFLineNumbersContinue'
        #'RTF1::RTFLineNumbersRestart'
        #'RTF1::RTFLineNumbersRestartOnEachPage'
        #'RTF1::RTFMakeBackup'
        #'RTF1::RTFManager'
        #'RTF1::RTFMarginProperty'
        #'RTF1::RTFNewParagraph'
        #'RTF1::RTFNoSuperSubScripting'
        #'RTF1::RTFNoUnprotectedAreas'
        #'RTF1::RTFNonBreakingSpace'
        #'RTF1::RTFNumberOfCharacters'
        #'RTF1::RTFNumberOfPages'
        #'RTF1::RTFNumberOfWords'
        #'RTF1::RTFOnlyAnnotations'
        #'RTF1::RTFOperator'
        #'RTF1::RTFPageBorderArt'
        #'RTF1::RTFPageBorderSettings'
        #'RTF1::RTFPageBorderSurroundsFooter'
        #'RTF1::RTFPageBorderSurroundsHeader'
        #'RTF1::RTFPageBordersProperty'
        #'RTF1::RTFPageFooterFromBottom'
        #'RTF1::RTFPageGutter'
        #'RTF1::RTFPageHeaderFromTop'
        #'RTF1::RTFPageHeight'
        #'RTF1::RTFPageLandscape'
        #'RTF1::RTFPageMarginProperty'
        #'RTF1::RTFPageNumber'
        #'RTF1::RTFPageNumberProperty'
        #'RTF1::RTFPageSwitchMargin'
        #'RTF1::RTFPageWidth'
        #'RTF1::RTFPaperHeight'
        #'RTF1::RTFPaperWidth'
        #'RTF1::RTFParagraph'
        #'RTF1::RTFParagraphAlignment'
        #'RTF1::RTFParagraphBorder'
        #'RTF1::RTFParagraphBreakPageBefore'
        #'RTF1::RTFParagraphHyphenation'
        #'RTF1::RTFParagraphInTable'
        #'RTF1::RTFParagraphIndentation'
        #'RTF1::RTFParagraphKeepIntact'
        #'RTF1::RTFParagraphKeepWithNext'
        #'RTF1::RTFParagraphNoLineNumbering'
        #'RTF1::RTFParagraphNoWidowControl'
        #'RTF1::RTFParagraphOutlineLevel'
        #'RTF1::RTFParagraphPrecedence'
        #'RTF1::RTFParagraphReset'
        #'RTF1::RTFParagraphSideBySide'
        #'RTF1::RTFParagraphSpacing'
        #'RTF1::RTFParagraphStyle'
        #'RTF1::RTFParagraphSubdocument'
        #'RTF1::RTFParagraphWidowControl'
        #'RTF1::RTFPlainText'
        #'RTF1::RTFPrintDataOnly'
        #'RTF1::RTFPrintPostScriptOverText'
        #'RTF1::RTFProtectedForRevisions'
        #'RTF1::RTFQuote'
        #'RTF1::RTFRevisionTime'
        #'RTF1::RTFRevisions'
        #'RTF1::RTFRevisionsBarProperties'
        #'RTF1::RTFRevisionsDisplayProperties'
        #'RTF1::RTFRightBoundary'
        #'RTF1::RTFRowBorder'
        #'RTF1::RTFRowGroup'
        #'RTF1::RTFRowHeight'
        #'RTF1::RTFRowJustification'
        #'RTF1::RTFRowLeftPosition'
        #'RTF1::RTFSectionBreakColumn'
        #'RTF1::RTFSectionBreakEvenPage'
        #'RTF1::RTFSectionBreakNone'
        #'RTF1::RTFSectionBreakOddPage'
        #'RTF1::RTFSectionBreakPage'
        #'RTF1::RTFSectionNumber'
        #'RTF1::RTFSectionReset'
        #'RTF1::RTFSectionStyle'
        #'RTF1::RTFSectionUnlocked'
        #'RTF1::RTFSnakingColumns'
        #'RTF1::RTFSpaceBetweenColumns'
        #'RTF1::RTFStartLineNumber'
        #'RTF1::RTFSubject'
        #'RTF1::RTFSubscript'
        #'RTF1::RTFSuperscript'
        #'RTF1::RTFTab'
        #'RTF1::RTFTabLeader'
        #'RTF1::RTFTabPosition'
        #'RTF1::RTFTabStyle'
        #'RTF1::RTFTableCellDefaults'
        #'RTF1::RTFTableCellMerged'
        #'RTF1::RTFTableRowDefaults'
        #'RTF1::RTFTableRowHeader'
        #'RTF1::RTFTableRowKeepTogether'
        #'RTF1::RTFTextFlowProperty'
        #'RTF1::RTFTime'
        #'RTF1::RTFTitle'
        #'RTF1::RTFTotalEditingTime'
        #'RTF1::RTFVerticalAlignmentProperty'
        #'RTF1::RTFViewMode'
        #'RTF1::RTFViewScale'
        #'RTF1::RTFViewZoomKind'
        #'RTF1::RTFWidowAndOrphanControl'
        #'RTF1::RTFWindowCaption'
        #'RTF1::RTFBottomMargin'
        #'RTF1::RTFContinuousPageNumbering'
        #'RTF1::RTFDoubleStrikethrough'
        #'RTF1::RTFExpansionInTwips'
        #'RTF1::RTFFontNumber'
        #'RTF1::RTFFontSize'
        #'RTF1::RTFItalic'
        #'RTF1::RTFKerning'
        #'RTF1::RTFLeftMargin'
        #'RTF1::RTFOutline'
        #'RTF1::RTFPageBorder'
        #'RTF1::RTFPageBorderBottom'
        #'RTF1::RTFPageBorderLeft'
        #'RTF1::RTFPageBorderRight'
        #'RTF1::RTFPageBorderSnap'
        #'RTF1::RTFPageBorderTop'
        #'RTF1::RTFPageBottomMargin'
        #'RTF1::RTFPageHeadingLevel'
        #'RTF1::RTFPageLeftMargin'
        #'RTF1::RTFPageNumberFormat'
        #'RTF1::RTFPageNumberRestart'
        #'RTF1::RTFPageRightMargin'
        #'RTF1::RTFPageSeparatorCharacter'
        #'RTF1::RTFPageTopMargin'
        #'RTF1::RTFParagraphLeftToRightPrecedence'
        #'RTF1::RTFParagraphRightToLeftPrecedence'
        #'RTF1::RTFRightMargin'
        #'RTF1::RTFShadow'
        #'RTF1::RTFSmallCapitals'
        #'RTF1::RTFStartPageNumber'
        #'RTF1::RTFStrikethrough'
        #'RTF1::RTFTextFlow'
        #'RTF1::RTFTopMargin'
        #'RTF1::RTFUnderline'
        #'RTF1::RTFVerticalAlignment'
    )

    "Modified: / 29-01-2011 / 14:22:46 / cg"
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!stx_goodies_docFormats_rtf class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_docFormats_rtf class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/docFormats/rtf/stx_goodies_docFormats_rtf.st,v 1.6 2011/01/29 13:23:34 cg Exp $'
! !
