"{ Package: 'stx:goodies/gitocello' }"

Object subclass:#GCGitWrapper
	instanceVariableNames:'localPath'
	classVariableNames:'CalloutDict GitBinaryPath'
	poolDictionaries:''
	category:'Gitocello-Core'
!


!GCGitWrapper class methodsFor:'preferences'!

gitBinaryPath

	<preference: 'Git binary path'
		category: 'Gitocello'
		description: 'Set the path of the git binary to be used for Gitocello'
		type: #String>
	^ GitBinaryPath ifNil: ['git']
!

gitBinaryPath: aString

	GitBinaryPath := aString.
! !

!GCGitWrapper methodsFor:'accessing'!

localPath
	"Answer the value of localPath"

	^ localPath
!

localPath: anObject
	"Set the value of localPath"

	localPath := anObject
! !

!GCGitWrapper methodsFor:'commands'!

add
	"Just add all"
	self gitCommand: 'add .'
!

add: matchString
	"Add using matchString"
	self gitCommand: 'add ', matchString
!

commit: commitMsg
	"Commit changes to the local repository"
	self gitCommand: 'commit --allow-empty -m "',  commitMsg, '"'
!

dirChangeCommand
	^ SmalltalkImage current platformName asLowercase = 'win32'
		ifTrue: ['cd "', self localPath, '" & ', (self localPath copyUpTo: $:) ,': & ']
		ifFalse: ['cd "', self localPath, '";'].
		
!

gitCommand: aCommandString
	"Enter the local repository and run the 'git' command with the parameters"
	| command |
	command := self dirChangeCommand, ' ', self class gitBinaryPath, ' ', aCommandString.
	GCCallout callout: command.
!

init

	self gitCommand: 'init'
!

origin: aRemoteUrl

	self gitCommand: 'remote rm origin'.
	self gitCommand: 'remote add origin ', aRemoteUrl
!

pull
	"Avoid merging altogether for now"
	self gitCommand: 'pull -s ours origin master'
!

push

	self gitCommand: 'push origin master'
! !

!GCGitWrapper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/gitocello/GCGitWrapper.st,v 1.1 2011/08/31 15:56:58 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gitocello/GCGitWrapper.st,v 1.1 2011/08/31 15:56:58 cg Exp $'
! !
