"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

DatabaseAccessor subclass:#DolphinDatabaseAccessor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpDatabase'
!


!DolphinDatabaseAccessor class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!DolphinDatabaseAccessor methodsFor:'accessing'!

isLoggedIn

	^connection notNil.
! !

!DolphinDatabaseAccessor methodsFor:'executing'!

basicExecuteSQLString: aString
	| resultSet array |
	self log: aString.
	resultSet := connection query: aString.	"Write statements don't like asArray if there's not result. DDL statements don't even like the isEmpty test"
	array := [resultSet isEmpty ifTrue: [#()] ifFalse: [resultSet asArray]]
		on: Dialect error
		do: [:ex | ex return: #()].
	resultSet
		close;
		free.
	^ReadStream on: array read.
!

externalDatabaseErrorSignal

	^Smalltalk at: #DBError
! !

!DolphinDatabaseAccessor methodsFor:'login'!

loginIfError: aBlock

	self
		execute:
			[connection := ((Smalltalk at: #DBConnection) new)
				dsn: currentLogin connectString;
				uid: currentLogin username;
				pwd: currentLogin password;
				connect.]
		ifError: aBlock
!

logout

	connection notNil
		ifTrue:
			[[connection close.] ensure: [connection := nil]].
!

showDialog: aString

	(Smalltalk at: #MessageBox) warning: aString.
! !

!DolphinDatabaseAccessor methodsFor:'transactions'!

beginTransaction

	connection beginRWTxn.
!

commitTransaction
	self log: 'Commit Transaction'.
	connection commitTxn
!

isInTransaction

	^connection isInTransaction
!

rollbackTransaction
	self log: 'Rollback Transaction'.
	connection rollbackTxn
! !

!DolphinDatabaseAccessor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/DolphinDatabaseAccessor.st,v 1.1 2006/07/26 08:42:22 boris Exp $'
! !
