"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpHelper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!GlorpHelper class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpHelper class methodsFor:'classes'!

dialect
	"Provide a way to refer to the dialect class from an extension or class that doesn't include the Glorp namespace, while still avoiding explicit namespace imports (which confuse other dialects when the 'pool dictionaries' don't exist)."
	| glorpNamespace |
	glorpNamespace := Smalltalk at: #Glorp ifAbsent: [nil].
	^((glorpNamespace isNil ifTrue: [Smalltalk] ifFalse: [glorpNamespace]) at: #Dialect ifAbsent: [Smalltalk at: #Dialect]).
!

glorpConstantExpressionClass
	^self dialect glorpConstantExpressionClass
! !

!GlorpHelper class methodsFor:'helpers'!

do: aBlock for: aCollection separatedBy: separatorBlock

	| array |
	array := aCollection asArray.
	1 to: array size do: [:i |
		| each |
		each := array at: i.
		aBlock value: each.
		i = array size ifFalse: [
			separatorBlock value]].
!

print: printBlock on: stream for: aCollection separatedBy: separatorString

	| array |
	array := aCollection asArray.
	1 to: array size do: [:index |
		stream nextPutAll: (printBlock value: (array at: index)).
		index == array size ifFalse: [
			stream nextPutAll: separatorString]].
!

separate: aCollection by: aOneArgumentBlock

	^aCollection inject: Dictionary new into: [:dict :each |
		| val |
		val := aOneArgumentBlock value: each.
		(dict at: val ifAbsentPut: [OrderedCollection new]) add: each].
! !

!GlorpHelper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/GlorpHelper.st,v 1.1 2006/07/26 08:05:13 boris Exp $'
! !
