"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

ProtoObject subclass:#AbstractProxy
	instanceVariableNames:'value isInstantiated'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!AbstractProxy class methodsFor:'instance creation'!

new

	^super new proxyInitialize.
! !

!AbstractProxy methodsFor:'accessing'!

= anObject
	"In VA we inherit this as identity. Need to override"
	^self getValue = anObject.
!

isKindOf: aClass
	self isInstantiated ifTrue: [^value isKindOf: aClass].
	^false
!

uninstantiate

	value := nil.
	isInstantiated := false.
! !

!AbstractProxy methodsFor:'api'!

getValue

	self subclassesMustImplement
! !

!AbstractProxy methodsFor:'dnu handling'!

doesNotUnderstand: aMessage

	^self getValue perform: aMessage selector withArguments: aMessage arguments.
!

doesNotUnderstand: sel args: args 
	"This is the variant for ObjectStudio"
	^self getValue perform: sel withArguments: args.
! !

!AbstractProxy methodsFor:'initialize'!

proxyInitialize

	isInstantiated := false.
! !

!AbstractProxy methodsFor:'notification'!

glorpPostFetch: aSession
!

glorpPostFetchValidate: aSession
! !

!AbstractProxy methodsFor:'overrides'!

basicSize
	^self getValue basicSize.
!

hash
	^self getValue hash.
!

inspect
	^self getValue inspect.
!

inspectorActions
	"Answer a collection of Action instances listing the common actions
	a user might want to perform on an object. They are added to the 
	inspector's Object menu."

	^#()
!

inspectorClasses
	^self getValue inspectorClasses.
!

inspectorCollaborators
	"Answer a collection of Collaborator instances listing the important other
	objects a person looking at this one might want to see. For example,
	collaborators of a view would be its model and the controller.
	Collaborators are added to the inspector's Go menu."

	^#()
!

inspectorExtraAttributes
	^#()
!

inspectorSize
	^0
!

inspectorString
	"For Object Studio compatibility"
	^self printString.
!

instVarAt: index
	^self getValue instVarAt: index.
!

instVarAt: index put: aValue
	^self getValue instVarAt: index put: aValue.
!

isImmutable
	^self getValue isImmutable.
!

store
	"For Object Studio compatibility"
	^self inspectorString.
! !

!AbstractProxy methodsFor:'printing'!

basicPrintOn: aStream 
	aStream nextPut: ${.
	isInstantiated 
		ifTrue: [self getValue basicPrintOn: aStream]
		ifFalse: [aStream nextPutAll: 'uninstantiated proxy'].
	aStream nextPut: $}
!

inspectorHierarchies
	"Answer a collection of instances of Hierarchy describing the hierarchies
	this object is a member of."

	^#()
!

printOn: aStream 
	aStream nextPut: ${.
	isInstantiated 
		ifTrue: [self getValue printOn: aStream]
		ifFalse: [aStream nextPutAll: 'uninstantiated proxy'].
	aStream nextPut: $}
!

printString

	| aStream |
	aStream := WriteStream on: (String new: 16).
	self printOn: aStream.
	^aStream contents
! !

!AbstractProxy methodsFor:'testing'!

isGlorpProxy
	^true.
!

isInstantiated
	isInstantiated isNil ifTrue: [isInstantiated := false].
	^isInstantiated
! !

!AbstractProxy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__AbstractProxy.st,v 1.1 2006/07/25 16:49:36 boris Exp $'
! !
