"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

SQLServerPlatform subclass:#AccessPlatform
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!AccessPlatform class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!AccessPlatform methodsFor:'SQL'!

supportsConstraints

	^false
!

supportsVariableSizedNumerics
	"Return true if this platform can support numbers with a varying size and number of decimal places. Access, notably, doesn't seem to be able to"
	^false.
! !

!AccessPlatform methodsFor:'constants'!

areSequencesExplicitlyCreated

	^false.
!

databaseSequenceClass
	^SQLServerSequence.
!

initializeReservedWords
	reservedWords := Set new.
	reservedWords add: 'timestamp'.
!

maximumLengthOfColumnName
	"^<Integer> I return the max. length of a column name"

	^64
!

maximumLengthOfTableName
	"^<Integer> I return the max. length of a table name"

	^64
!

supportsAuthentication
	^false
!

supportsMillisecondsInTimes
	^false.
!

usesNullForFalse
	"Return true if this database is likely to use nil as an empty string value"
	^true.
! !

!AccessPlatform methodsFor:'conversion-boolean'!

booleanToBooleanConverter
	^DelegatingDatabaseConverter
		named: #booleanToBoolean
		hostedBy: self
		fromStToDb: #convertBooleanToDBBoolean:for:
		fromDbToSt: #convertDBBooleanToBoolean:for:.
! !

!AccessPlatform methodsFor:'services tables'!

endColumnQuote
	^']'.
!

startColumnQuote
	^'['.
! !

!AccessPlatform methodsFor:'testing'!

supportsAliasInCompoundQuery
	"Return true if, when we have a subselect, we can (and/or must) alias the result with a table name. Access doesn't like the table name"
	^false.
!

supportsGroupWritingFor: aCommand
	^false.
!

supportsTableOwners
	"Return true if this platform supports table owners, i.e. expects table names of the form Bern.TW_* rather than just TW_* in its SQL."
"Access, Firebird and PostGreSQL do not, Oracle does, others I know not."

	^false
!

useMicrosoftOuterJoins
	"Return true if we use the Microsoft x *= y syntax for outer joins. Oddly enough, false for access 2k"
	^false.
! !

!AccessPlatform methodsFor:'types'!

blob

	^self typeNamed: #blob ifAbsentPut: [GlorpBlobType new typeString: 'longbinary'].
!

clob

	^self typeNamed: #clob ifAbsentPut: [GlorpClobType new typeString: 'memo'].
!

longText

	^self typeNamed: #longText ifAbsentPut: [GlorpClobType new typeString: 'memo'].
!

memo

	^self typeNamed: #memo ifAbsentPut: [GlorpClobType new typeString: 'memo'].
!

serial

	^self typeNamed: #serial ifAbsentPut: [GlorpSerialType new typeString: 'autoincrement'].
!

text

	^self typeNamed: #text ifAbsentPut: [GlorpClobType new typeString: 'longtext'].
! !

!AccessPlatform class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__AccessPlatform.st,v 1.1 2006/07/25 16:49:44 boris Exp $'
! !
