"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

TypeResolver subclass:#BasicTypeResolver
	instanceVariableNames:'concreteMembers subclassDescriptorsBuilt rootDescriptor rootClass'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!BasicTypeResolver class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!BasicTypeResolver methodsFor:'accessing'!

concreteMembers
	^concreteMembers isNil 
		ifTrue: [ concreteMembers := OrderedCollection new ]
		ifFalse: [ concreteMembers]
!

rootClass
	^rootClass
!

rootClass: anObject
	rootClass := anObject
!

rootDescriptor
	^rootDescriptor isNil
		ifTrue: [ rootDescriptor := self system descriptorFor: self rootClass ]
		ifFalse: [ rootDescriptor ]
!

subclassDescriptorsBuilt
	^subclassDescriptorsBuilt isNil
		ifTrue: [ subclassDescriptorsBuilt := false ]
		ifFalse: [ subclassDescriptorsBuilt ]
! !

!BasicTypeResolver methodsFor:'other'!

rootDescriptor: anObject
	rootDescriptor := anObject
! !

!BasicTypeResolver methodsFor:'private'!

allDescribedConcreteClasses
	self subclassDescriptorsBuilt ifFalse: [self forceSubclassDescriptorLoads].
	^self concreteMembers collect: [ :each | each describedClass ]
!

forceSubclassDescriptorLoads
	self rootClass allSubclassesDo: [ :each | self system descriptorFor: each ].
	subclassDescriptorsBuilt := true
! !

!BasicTypeResolver methodsFor:'registering'!

register: aDescriptor abstract: abstract

	super register: aDescriptor abstract: abstract.
	abstract ifFalse: [ self concreteMembers add: aDescriptor ]
! !

!BasicTypeResolver methodsFor:'type resolution'!

typeMappingRootDescriptor
	^self rootDescriptor
! !

!BasicTypeResolver class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__BasicTypeResolver.st,v 1.1 2006/07/26 07:59:44 boris Exp $'
! !
