"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

ElementBuilder subclass:#DataElementBuilder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!

DataElementBuilder comment:'This builds raw data items rather than persistent objects with descriptors. Used if we do something like 
  aQuery retrieve: [:each | each address streetName].
giving us back simple data objects.
This makes building them quite simple.'
!


!DataElementBuilder class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!DataElementBuilder methodsFor:'building objects'!

buildObjectFrom: anArray
	self row: anArray.
	instance := self valueOf: expression.
!

findInstanceForRow: aRow proxyType: proxyType

	^self.
! !

!DataElementBuilder methodsFor:'selecting fields'!

fieldsForSelectStatement
	^Array with: expression.
!

fieldsFromMyPerspective
	^expression mappedFields.
! !

!DataElementBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__DataElementBuilder.st,v 1.1 2006/07/26 07:59:27 boris Exp $'
! !
