"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Object subclass:#DatabaseCommand
	instanceVariableNames:'useBinding stream sqlString platform'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpCore'
!


!DatabaseCommand class methodsFor:'instance creation'!

new
	^super new initialize.
! !

!DatabaseCommand class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!DatabaseCommand methodsFor:'accessing'!

arrayBoundFields
	self subclassResponsibility
!

bindingTypes
	self subclassResponsibility.
!

bindingTypesForEXDI
	^self bindingTypes collect: [:each | each exdiType].
!

bindings
	self subclassResponsibility.
!

blockFactor
	^5  "A reasonable default if we don't know"
!

parameterTypeSignature
	self subclassResponsibility.
!

platform
	^platform
!

platform: aDatabasePlatform
	platform := aDatabasePlatform.
!

query
	^nil.
!

signature
	^self sqlString, self parameterTypeSignature.
!

sqlString
	sqlString isNil ifTrue: [
		stream isNil ifTrue: [stream := WriteStream on: (String new: 100)].
		self printSQL.
		sqlString := stream contents.
		stream := nil].
	^sqlString.
!

useBinding
	^useBinding
!

useBinding: aBoolean
	useBinding := aBoolean
! !

!DatabaseCommand methodsFor:'executing'!

executeBoundIn: anAccessor
	^anAccessor executeCommandBound: self.
!

executeUnboundIn: anAccessor
	^anAccessor executeCommandUnbound: self.
!

printSQL
	self subclassResponsibility.
! !

!DatabaseCommand methodsFor:'initializing'!

initialize
	useBinding := true.
	stream := WriteStream on: (String new: 100).
! !

!DatabaseCommand methodsFor:'stream behaviour'!

contents
	^stream contents.
!

cr
	stream cr.
!

nextPut: aCharacter
	^stream nextPut: aCharacter.
!

nextPutAll: aString
	^stream nextPutAll: aString.
!

nextPutString: aString
	^self nextPutAll: aString.
!

print: anObject

	anObject printOn: self
!

space
	stream space.
! !

!DatabaseCommand methodsFor:'testing'!

canBind: aValue to: aType
	useBinding ifFalse: [^false].
	^self platform canBind: aValue to: aType.
!

hasMultipleRows
	^false.
!

isReadCommand
	^false.
!

needsRowCount 

	^false.
!

shouldUseGroupWriting
	^(self hasMultipleRows and: [platform supportsGroupWritingFor: self])
!

succeeded

	^self subclassResponsibility.
! !

!DatabaseCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__DatabaseCommand.st,v 1.1 2006/07/26 08:39:09 boris Exp $'
! !
