"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

GlorpDatabaseValueGenerator subclass:#DatabaseSequence
	instanceVariableNames:'reservedNumbers'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!DatabaseSequence class methodsFor:'instance creation'!

named: aString
	^self new name: aString.
!

new

	^super new initialize.
! !

!DatabaseSequence class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!DatabaseSequence methodsFor:'accessing'!

reservedNumbers
	reservedNumbers isNil ifTrue: [reservedNumbers := OrderedCollection new: 50].
	^reservedNumbers.
! !

!DatabaseSequence methodsFor:'initialize/release'!

initialize
! !

!DatabaseSequence methodsFor:'sequencing'!

creationString

	^'Creation string unspecified for this type of sequence'.
!

dropString

	^'Drop string unspecified for this type of sequence'.
!

getSequenceValueFromDatabaseFor: aField in: aRow using: aSession 
	self subclassResponsibility.
!

hasReservedNumbers
	^reservedNumbers notNil and: [reservedNumbers isEmpty not].
!

nextReservedNumber
	^reservedNumbers removeFirst.
!

postWriteAssignSequenceValueFor: aField in: aRow using: aSession

	self subclassResponsibility.
!

preWriteAssignSequenceValueFor: aField in: aRow using: anAccessor
	self hasReservedNumbers
		ifTrue: [aRow at: aField put: self nextReservedNumber]
		ifFalse:
			[self
				getSequenceValueFromDatabaseFor: aField
				in: aRow
				using: anAccessor].
! !

!DatabaseSequence methodsFor:'testing'!

isIdentityColumn
	^false.
! !

!DatabaseSequence class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__DatabaseSequence.st,v 1.1 2006/07/26 08:03:54 boris Exp $'
! !
