"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

DatabaseConverter subclass:#DelegatingDatabaseConverter
	instanceVariableNames:'host stToDbSelector dbToStSelector'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpDatabase'
!


!DelegatingDatabaseConverter class methodsFor:'instance creation'!

hostedBy: anObject fromStToDb: stDbSelector fromDbToSt: dbStSelector

	^super new
		hostedBy: anObject fromStToDb: stDbSelector fromDbToSt: dbStSelector
!

named: aSymbol hostedBy: anObject fromStToDb: stDbSelector fromDbToSt: dbStSelector
	^super new
		named: aSymbol
		hostedBy: anObject
		fromStToDb: stDbSelector
		fromDbToSt: dbStSelector.
! !

!DelegatingDatabaseConverter class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!DelegatingDatabaseConverter methodsFor:'converting'!

convert: anObject fromDatabaseRepresentationAs: aDatabaseType 
	^host perform: dbToStSelector with: anObject with: aDatabaseType
!

convert: anObject toDatabaseRepresentationAs: aDatabaseType 
	^host perform: stToDbSelector with: anObject with: aDatabaseType.
! !

!DelegatingDatabaseConverter methodsFor:'initialize-release'!

hostedBy: anObject fromStToDb: stDbSelector fromDbToSt: dbStSelector

	host := anObject.
	stToDbSelector := stDbSelector.
	dbToStSelector := dbStSelector
!

named: aSymbol hostedBy: anObject fromStToDb: stDbSelector fromDbToSt: dbStSelector

	name := aSymbol.
	host := anObject.
	stToDbSelector := stDbSelector.
	dbToStSelector := dbStSelector
! !

!DelegatingDatabaseConverter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__DelegatingDatabaseConverter.st,v 1.1 2006/07/26 08:41:20 boris Exp $'
! !
