"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

ElementBuilder subclass:#DictionaryBuilder
	instanceVariableNames:'keyBuilder valueBuilder'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpQueries'
!


!DictionaryBuilder methodsFor:'accessing'!

instanceValue
	^self instance value
!

subBuilders
	^Array with: keyBuilder with: valueBuilder.
!

withAllSubBuilders
	^Array with: self with: keyBuilder with: valueBuilder.
! !

!DictionaryBuilder methodsFor:'building objects'!

buildObjectFrom: anArray
	"We just build an association out of the sub-builders "
	| |
	self row: anArray.
!

findInstanceForRow: aRow proxyType: proxyType

	instance := Association new.
!

knitResultIn: aSimpleQuery
	"Connect up our built object with any other objects that reference it. Used if we retrieve more than one thing in the same query"

	instance key: keyBuilder instance.
	instance value: valueBuilder instance.
! !

!DictionaryBuilder methodsFor:'copying'!

postCopy
!

reconcileWithBuilders: oldCollection andCopy: newCollection
	"Fix up references to our internal sub-builders"
	| keyIndex valueIndex |
	keyIndex := oldCollection indexOf: keyBuilder.
	keyBuilder := newCollection at: keyIndex.
	valueIndex := oldCollection indexOf: valueBuilder.
	valueBuilder := newCollection at: valueIndex.
! !

!DictionaryBuilder methodsFor:'initialize-release'!

setup
	"Do any initialization once we've got our parameters"
	| base collectionType |
	base := query baseExpression.
	collectionType := expression == base ifTrue: [query collectionType] ifFalse: [expression mapping query collectionType].
	keyBuilder := ElementBuilder for: (collectionType keyExpression asGlorpExpressionOn: base) in: query.
	valueBuilder := ElementBuilder basicFor: (collectionType valueExpression asGlorpExpressionOn: base) in: query.
! !

!DictionaryBuilder methodsFor:'selecting fields'!

fieldsForSelectStatement
	^#()
!

fieldsFromMyPerspective
	^#()
! !

!DictionaryBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__DictionaryBuilder.st,v 1.1 2006/07/26 08:50:52 boris Exp $'
! !
