"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

GlorpExpression subclass:#EmptyExpression
	instanceVariableNames:'base value'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp-Expressions'
!


!EmptyExpression class methodsFor:'instance creation'!

on: aValue
	^self new value: aValue.
! !

!EmptyExpression class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!EmptyExpression methodsFor:'As yet unclassified'!

printSQLOn: aCommand withParameters: aDictionary
	^self.
! !

!EmptyExpression methodsFor:'accessing'!

base
	^base.
!

base: aBaseExpression
	base := aBaseExpression.
!

isFalse
	^value not
!

isTrue
	^value
!

value: aValue
	"a value is expected to be nil, true, or false. we treat nil as true"
	value := aValue isNil ifTrue: [true] ifFalse: [aValue].
! !

!EmptyExpression methodsFor:'api'!

AND: anExpression

	anExpression isNil ifTrue: [^self].
	^anExpression asGlorpExpression.
!

OR: anExpression

	anExpression isNil ifTrue: [^self].
	^anExpression
! !

!EmptyExpression methodsFor:'initialize'!

initialize
	super initialize.
	value := true.
! !

!EmptyExpression methodsFor:'iterating'!

do: aBlock skipping: aSet
	"Iterate over the expression tree"

	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	base do: aBlock skipping: aSet.
	aBlock value: self.
!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| copy |
	self == anExpression ifTrue: [^aBaseExpression].
	self base == ultimateBaseExpression ifTrue: [^self].
	copy := self copy.
	copy base: aBaseExpression.
	^copy.
! !

!EmptyExpression methodsFor:'navigating'!

ultimateBaseExpression

	base isNil ifTrue: [base := BaseExpression new].
	^base ultimateBaseExpression.
! !

!EmptyExpression methodsFor:'printing'!

printTreeOn: aStream 
	aStream nextPutAll: 'empty expression'.
! !

!EmptyExpression methodsFor:'testing'!

canHaveBase
	^true.
!

isEmptyExpression
	^true.
! !

!EmptyExpression class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__EmptyExpression.st,v 1.1 2006/07/26 08:29:59 boris Exp $'
! !
