"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

BasicTypeResolver subclass:#FilteredTypeResolver
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!FilteredTypeResolver class methodsFor:'instance creation'!

forRootClass: aClass
	^self new
		rootClass: aClass;
		yourself.
! !

!FilteredTypeResolver class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!FilteredTypeResolver methodsFor:'accessing'!

classesRequiringIndependentQueriesFor: aClass
	^Array with: aClass
! !

!FilteredTypeResolver methodsFor:'registering'!

register: aDescriptor abstract: aBoolean
	super register: aDescriptor abstract: aBoolean.
	aBoolean
		ifTrue:
			[| fakeTypeMapping |
			fakeTypeMapping := FilteredTypeMapping to: nil keyedBy: nil.
			fakeTypeMapping readOnly: true.
			aDescriptor typeMapping: fakeTypeMapping].
!

register: aDescriptor keyedBy: aKey field: aField
	self register: aDescriptor abstract: false.
	aDescriptor typeMapping: (FilteredTypeMapping to: aField keyedBy: aKey).
! !

!FilteredTypeResolver methodsFor:'type resolving'!

askConcreteMembersForConcreteClassFor: row withBuilder: builder
	concreteMembers do: [:each |
		each describedConcreteClassFor: row withBuilder: builder].
!

describedConcreteClassFor: row withBuilder: builder descriptor: aDescriptor
	^aDescriptor typeMapping describedConcreteClassFor: row withBuilder: builder
!

fieldsForSelectStatement
	"Return fields that are needed in a select statement - i.e. return all inherited fields that are part of the tables we are already selecting for this object, but not in the main descriptor"
	| fields rootFields |
	fields := OrderedCollection new.
	rootFields := self rootDescriptor mappedFields asSet.
	self concreteMembers do: [:each |
		each == self rootDescriptor ifFalse: [
			each mappedFields do: [:eachSubField |
				(rootFields includes: eachSubField) ifFalse: [
					fields add: eachSubField]]]].
	^fields.
!

isAbstract: aDescriptor
	^aDescriptor == self rootDescriptor
! !

!FilteredTypeResolver class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__FilteredTypeResolver.st,v 1.1 2006/07/26 08:05:27 boris Exp $'
! !
