"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Query subclass:#FilteringQuery
	instanceVariableNames:'collection filter collectBlock readsOneObject'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpQueries'
!


!FilteringQuery class methodsFor:'instance creation'!

on: aCollection filter: aBlock
	^self new
		collection: aCollection;
 		filter: aBlock.
! !

!FilteringQuery methodsFor:'accessing'!

collectBlock
	^collectBlock
!

collectBlock: aBlock
	collectBlock:= aBlock.
!

collection
	^collection
!

collection: aCollection
	aCollection class == GlorpVirtualCollection ifTrue: [collectionType := aCollection getQuery collectionType].
	collection := aCollection.
!

filter
	^filter
!

filter: aBlock
	filter := aBlock
!

readsOneObject
	readsOneObject isNil ifTrue: [^false].
	^readsOneObject.
!

readsOneObject: aBoolean
	readsOneObject := aBoolean.
!

resultClass
	collection class == GlorpVirtualCollection ifTrue: [^collection getQuery resultClass].
	^(collection detect: [:each | true] ifNone: [nil]) class
! !

!FilteringQuery methodsFor:'executing'!

collectionTypesAgree: aCollection
	^self collectionType new class == aCollection class
!

executeWithParameters: parameterArray in: aSession
	| filtered result |
	session := aSession.
	collection class == GlorpVirtualCollection
		ifTrue:
			[collection setSession: aSession.
			collection parameters: parameterArray.
			collection := collection realObjects].
	filtered := self filterResultsForParameters: parameterArray.
	result := self transformsValues
		ifTrue: [filtered collect: [:each | self valueFor: each]]
		ifFalse: [filtered].
	result := (self collectionTypesAgree: result) ifTrue: [result] ifFalse: [self resultCollectionFor: result readStream].
	^self readsOneObject
		ifTrue: [result detect: [:each | true] ifNone: [nil]]
		ifFalse: [result].
!

filterResultsForParameters: parameterArray
	| passing seen |
	seen := Dialect newIdentitySet.
	passing := collection
		select:
			[:each | 
			| passes new value |
			passes := filter value: each value: parameterArray.
			value := self valueFor: each.
			passes
				ifTrue:
					[new := (seen includes: value) not.
					new ifTrue: [seen add: value]].
			passes and: [new]].
	^passing.
!

transformsValues
	^collectBlock notNil.
!

valueFor: anObject
	collectBlock isNil ifTrue: [^anObject].
	^collectBlock value: anObject.
! !

!FilteringQuery class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__FilteringQuery.st,v 1.1 2006/07/26 08:51:26 boris Exp $'
! !
