"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Object subclass:#FixedSizeQueue
	instanceVariableNames:'maximumSize items'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpCore'
!

FixedSizeQueue comment:'This is a fixed size queue of objects. It''s intended for keeping around a fixed number of references to objects in a weak dictionary. As such its API is rather limited (one method), and it''s write-only.

Instance Variables:
	items	<OrderedCollection>	The items in the queue
	maximumSize	<Integer>	How many items we''re allowed

'
!


!FixedSizeQueue class methodsFor:'instance creation'!

maximumSize: anInteger
	^self basicNew maximumSize: anInteger.
!

new
	self error: 'must supply a size'.
!

new: anInteger
	^self maximumSize: anInteger.
! !

!FixedSizeQueue class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!FixedSizeQueue methodsFor:'accessing'!

maximumSize
	^maximumSize
!

maximumSize: anInteger
	maximumSize := anInteger.
	items := OrderedCollection new: maximumSize + 1.
! !

!FixedSizeQueue methodsFor:'api'!

add: anObject
	items add: anObject.
	items size > maximumSize ifTrue: [items removeFirst].
! !

!FixedSizeQueue methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream nextPutAll: items size printString.
	aStream nextPut: $/.
	aStream nextPutAll: maximumSize printString.
	aStream nextPutAll: ')'.
! !

!FixedSizeQueue class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__FixedSizeQueue.st,v 1.1 2006/07/26 08:39:47 boris Exp $'
! !
