"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

GlorpDatabaseType subclass:#GlorpAbstractStringType
	instanceVariableNames:'width queryType'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp-PostgreSQL'
!


!GlorpAbstractStringType class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpAbstractStringType methodsFor:'SQL'!

typeString
	typeString isNil
		ifTrue:
			[typeString := self typeName.
			width isNil
				ifFalse: [typeString := typeString , '(' , width printString , ')']].
	^typeString.
!

typeString: aString
	"If we set the typeString, we are presumably setting it to the non-parameterized name as well"
	typeString := aString.
	super typeString: aString.
! !

!GlorpAbstractStringType methodsFor:'accessing'!

queryType
	queryType isNil ifTrue: [^self].
	^queryType.
!

queryType: aType
	queryType := aType
!

width
	^width.
!

width: anInteger

	width := anInteger
! !

!GlorpAbstractStringType methodsFor:'converting'!

converterForStType: aClass
	(aClass includesBehavior: Boolean) ifTrue: [^self platform converterNamed: #booleanToStringTF].
	(aClass includesBehavior: Symbol) ifTrue: [^self platform converterNamed: #symbolToString].
	width isNil ifFalse: [
		(aClass includesBehavior: String) ifTrue: [^self platform converterNamed: #stringToString]].
	^super converterForStType: aClass.
!

impliedSmalltalkType
	^String.
! !

!GlorpAbstractStringType methodsFor:'exdi specific'!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#String.
! !

!GlorpAbstractStringType methodsFor:'private'!

typeName
	^typeString.
!

typeName: aString
	typeString := aString.
! !

!GlorpAbstractStringType methodsFor:'testing'!

hasParameters
	"Return true if this has modifiable parameters. That is, when we return one of these, should we return a copy rather than trying to save space be re-using instances"
	^true.
!

isStringType
	^true.
!

isVariableWidth
	self subclassResponsibility.
! !

!GlorpAbstractStringType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpAbstractStringType.st,v 1.1 2006/07/26 08:32:42 boris Exp $'
! !
