"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

GlorpDatabaseType subclass:#GlorpBlobType
	instanceVariableNames:'queryType'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpDatabaseTypes'
!


!GlorpBlobType methodsFor:'SQL'!

print: aValue on: aStream
	self platform printBlob: aValue on: aStream for: self.
! !

!GlorpBlobType methodsFor:'exdi specific'!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^#ByteArray.
! !

!GlorpBlobType methodsFor:'initialize'!

initialize
	super initialize.
	typeString := 'blob'
! !

!GlorpBlobType methodsFor:'types'!

converterForStType: aClass
	(aClass includesBehavior: String) ifTrue: [^self platform converterNamed: #byteArrayToString].
	self platform isPostgreSQLPlatform ifTrue: [^self platform converterNamed: #byteArrayToSQLString].
	self platform isOcelotPlatform ifTrue: [^self platform converterNamed: #blobDataToStream].
	^self platform nullConverter
!

impliedSmalltalkType
	^ByteArray.
!

queryType
	"Return the type that we can cast an argument to in order to match against this"
	queryType isNil ifTrue: [^self].
	^queryType.
!

queryType: aType
	"Set the type that we can cast an argument to in order to match against this"
	queryType := aType.
! !

!GlorpBlobType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpBlobType.st,v 1.1 2006/07/26 08:47:12 boris Exp $'
! !
