"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

GlorpDatabaseType subclass:#GlorpDateType
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp-PostgreSQL'
!


!GlorpDateType class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpDateType methodsFor:'SQL'!

print: aValue on: aStream
	aStream nextPutAll: (self platform printDate: aValue for: self).
! !

!GlorpDateType methodsFor:'converting'!

converterForStType: aClass

	^self platform converterNamed: #date.
!

impliedSmalltalkType
	^Date.
! !

!GlorpDateType methodsFor:'exdi specific'!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^self platform exdiTypeForDates.
! !

!GlorpDateType methodsFor:'initialize'!

initialize
	super initialize.
	typeString := 'date'
! !

!GlorpDateType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpDateType.st,v 1.1 2006/07/26 08:32:49 boris Exp $'
! !
