"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Error subclass:#GlorpError
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpCore'
!

GlorpError comment:'This is an abstract superclass for GLORP exceptions.
'
!


!GlorpError class methodsFor:'ANSI'!

signal
	^self new signal.
!

signal: aString
	^self new signal: aString.
! !

!GlorpError class methodsFor:'exception compatibility'!

ancestorOf: anExceptionThingy
	"VA Compatibility"
	^self exceptionalEvent handles: anExceptionThingy
!

description
	"For ObjectStudio"
	^super description.
!

exceptionalEvent
	"For VA"
	|event |
	event := super exceptionalEvent.
	event resumable: self mayResume.
	^event.
! !

!GlorpError class methodsFor:'testing'!

mayResume
	"This is a VisualWorks convention. Reimplement this here so that it will also be found in other dialects that don't have it in the superclass."
	^false
! !

!GlorpError methodsFor:'ANSI'!

signal
	"VisualWorks has non-ANSI semantics for this method. Re-implement to do the standard thing"
	^Dialect isVisualWorks ifTrue: [self raise] ifFalse: [super signal].
!

signal: aString
	"VisualWorks has non-ANSI semantics for this method. Re-implement to do the standard thing"

	^Dialect isVisualWorks
		ifTrue:
			[self messageText: aString.
			self raise]
		ifFalse: [super signal: aString].
! !

!GlorpError methodsFor:'accessing'!

databaseError
"rh 8/1/2004 21:26 for #getMessageText"

	^self class name
!

getMessageText
	"This is horribly ugly. Not only are dialects inconsistent, but behaviour between types of exceptions is inconsistent within dialects"
	|tempTag |
	Dialect isVisualWorks ifTrue: [
		"In VisualWorks, we assume that our errors are ExternalDatabaseExceptions, whose parameter is an array of ExternalDatabaseError objects. But if not, just fall back on a default message"
		self databaseError isNil ifTrue: [^messageText := self defaultMessageText].
		messageText:= [self databaseError first dbmsErrorString] on: Error do: [:ex |
			ex return: self defaultMessageText].
			^messageText].
	Dialect isVisualAge ifTrue: [
			tempTag := self basicTag.
			^tempTag isNil ifTrue: [self printString] ifFalse: [tempTag errorText]].
	Dialect isSqueak ifTrue: [^self databaseError].
	^self printString.
!

messageText
	(messageText isNil or: [messageText isEmpty]) ifTrue: [
		messageText := self getMessageText].
	^messageText.
! !

!GlorpError methodsFor:'testing'!

ancestorOf: anExceptionThingy
	"VA Compatibility"
	^self handles: anExceptionThingy
!

isResumable
	^self class mayResume.
! !

!GlorpError class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpError.st,v 1.1 2006/07/26 08:39:54 boris Exp $'
! !
