"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

GlorpDatabaseType subclass:#GlorpInMemorySequenceDatabaseType
	instanceVariableNames:'representationType'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!

GlorpInMemorySequenceDatabaseType class instanceVariableNames:'count'

"
 No other class instance variables are inherited by this class.
"
!


!GlorpInMemorySequenceDatabaseType class methodsFor:'instance creation'!

representedBy: dbType

	^super new
		representedBy: dbType
! !

!GlorpInMemorySequenceDatabaseType class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpInMemorySequenceDatabaseType class methodsFor:'accessing'!

next

	(count isNil)
	ifTrue: [count := 0].
	count := count + 1.
	^count
!

reset

	count := 0
! !

!GlorpInMemorySequenceDatabaseType methodsFor:'SQL'!

preWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor

	aDatabaseRow at: aDatabaseField put: (self class next)
!

typeString

	^representationType typeString
! !

!GlorpInMemorySequenceDatabaseType methodsFor:'converting'!

impliedSmalltalkType
	^Integer.
! !

!GlorpInMemorySequenceDatabaseType methodsFor:'exdi specific'!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"
	^representationType exdiType.
! !

!GlorpInMemorySequenceDatabaseType methodsFor:'initialize-release'!

representedBy: dbType

	representationType := dbType
! !

!GlorpInMemorySequenceDatabaseType methodsFor:'testing'!

isGenerated

	^true
! !

!GlorpInMemorySequenceDatabaseType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpInMemorySequenceDatabaseType.st,v 1.1 2006/07/26 08:05:05 boris Exp $'
! !
