"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

GlorpAbstractNumericType subclass:#GlorpNumericType
	instanceVariableNames:'precision scale'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp-PostgreSQL'
!


!GlorpNumericType class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpNumericType methodsFor:'SQL'!

typeString
	| w |
	platform supportsVariableSizedNumerics ifFalse: [^typeString].
	w := WriteStream on: String new.
	w nextPutAll: typeString.
	precision isNil 
		ifFalse: 
			[w nextPutAll: '(' , scale printString.
			scale isNil ifFalse: [w nextPutAll: ',' , precision printString].
			w nextPutAll: ')'].
	^w contents
! !

!GlorpNumericType methodsFor:'accessing'!

precision
	^precision.
!

precision: anInteger

	precision := anInteger.
!

scale
	^scale.
!

scale: anInteger

	scale := anInteger.
! !

!GlorpNumericType methodsFor:'converting'!

converterForStType: aClass
	(aClass includesBehavior: Boolean) ifTrue: [^self platform converterNamed: #booleanToInteger].
	^self platform converterNamed: #numberToNumber.
! !

!GlorpNumericType methodsFor:'exdi specific'!

exdiType
	"Return a symbol that the VisualWorks EXDI uses to indicate the database type -- this is a symbol which is often the name of a Smalltalk class, but with variations for multiple db types that correspond to the same Smalltalk symbol. It also varies by Database. This is equivalent to the values returned by methods like #odbcConversion or #oracleConversion"

	"Can we do better than this??"
	^#FixedPoint
! !

!GlorpNumericType methodsFor:'initialize'!

initialize
	super initialize.
	typeString := 'numeric'.
! !

!GlorpNumericType methodsFor:'testing'!

hasParameters
	"Return true if this has modifiable parameters. That is, when we return one of these, should we return a copy rather than trying to save space be re-using instances"
	^true.
! !

!GlorpNumericType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpNumericType.st,v 1.1 2006/07/26 08:33:46 boris Exp $'
! !
