"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpPreparedStatement
	instanceVariableNames:'signature statement busy'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpDatabase'
!


!GlorpPreparedStatement class methodsFor:'instance creation'!

new
	"Answer a newly created and initialized instance."

	^super new initialize
! !

!GlorpPreparedStatement class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpPreparedStatement methodsFor:'As yet unclassified'!

glorpNoticeOfExpiryIn: aSession
	self release.
!

release
	super release.
	statement isNil ifFalse: [
		| stmt |
		stmt := statement.
		statement := nil.
		stmt disconnect].
! !

!GlorpPreparedStatement methodsFor:'accessing'!

busy
	^busy.
!

busy: aBoolean
	busy := aBoolean.
!

signature
	^signature
!

signature: aString
	signature := aString
!

statement
	^statement
!

statement: aStatementHandle
	statement := aStatementHandle
! !

!GlorpPreparedStatement methodsFor:'initialize-release'!

initialize
	busy := false.
! !

!GlorpPreparedStatement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpPreparedStatement.st,v 1.1 2006/07/26 08:40:55 boris Exp $'
! !
