"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

GlorpAbstractIntegerType subclass:#GlorpSerialType
	instanceVariableNames:'generated sequence'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp-PostgreSQL'
!


!GlorpSerialType class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpSerialType methodsFor:'accessing'!

hasParameters
	^true.
!

isGenerated
	"answer if we should autogenerate a value for this type, i.e. if it is a database-generated primary key column"

	^generated
!

sequence
	^sequence.
!

sequence: aDatabaseSequence
	sequence := aDatabaseSequence.
! !

!GlorpSerialType methodsFor:'initialize'!

initialize
	super initialize.
	generated := true.
!

initializeForField: aDatabaseField in: aDescriptorSystem
	sequence isNil ifFalse: [^self].
	sequence := aDescriptorSystem databaseSequenceNamed: (aDatabaseField table name), '_', (aDatabaseField name), '_SEQ'.
	sequence schema: aDatabaseField table schema.
! !

!GlorpSerialType methodsFor:'sequencing'!

postWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor

	^sequence postWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor.
!

preWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor

	^sequence preWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: anAccessor.
! !

!GlorpSerialType methodsFor:'testing'!

hasSequence
	^true.
!

isIdentityColumn
	^self sequence isIdentityColumn.
!

isSerial
	"answer if this is a database-generated primary key column"

	^true
! !

!GlorpSerialType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpSerialType.st,v 1.1 2006/07/26 08:33:53 boris Exp $'
! !
