"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpThingWithLotsOfDifferentCollections
	instanceVariableNames:'id array orderedCollection set bag sortedCollection name'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpCollectionTypeModels'
!


!GlorpThingWithLotsOfDifferentCollections class methodsFor:'instance creation'!

new
	"Answer a newly created and initialized instance."

	^super new initialize
! !

!GlorpThingWithLotsOfDifferentCollections class methodsFor:'examples'!

example1
	| example array |
	example := self new.
	example name: 'fred'.
	array := Array with: (GlorpThingOne named: 'array1') with: (GlorpThingOne named: 'array2') with: (GlorpThingOne named: 'array3').
	example array: array.
	example set add: (GlorpThingOne named: 'set1').
	example set add: (GlorpThingOne named: 'set2').
	example orderedCollection add: (GlorpThingOne named: 'orderedCollection1').
	example orderedCollection add: (GlorpThingOne named: 'orderedCollection2').
	example bag add: (GlorpThingOne named: 'bag1').
	example bag add: (GlorpThingOne named: 'bag2').
	example sortedCollection add: (GlorpThingOne named: 'sorted1').
	example sortedCollection add: (GlorpThingOne named: 'sorted2').
	example sortedCollection add: (GlorpThingOne named: 'sorted3').
	example sortedCollection add: (GlorpThingOne named: 'sorted4').
	^example.
!

exampleForOrdering
	| example |
	example := self new.
	example name: 'order'.
	example orderedCollection add: (GlorpThingOne named: 'oc6').
	example orderedCollection add: (GlorpThingOne named: 'oc5').
	example orderedCollection add: (GlorpThingOne named: 'oc4').
	example orderedCollection add: (GlorpThingOne named: 'oc3').
	example orderedCollection add: (GlorpThingOne named: 'oc7').
	example orderedCollection add: (GlorpThingOne named: 'oc8').
	example array: (#('a1' 'a2' 'a3' 'a9' 'a8' 'a7') collect: [:each | GlorpThingOne named: each]).
	^example
! !

!GlorpThingWithLotsOfDifferentCollections methodsFor:'accessing'!

array
	^array
!

array: anObject
	array := anObject
!

bag
	^bag
!

bag: anObject
	bag := anObject
!

id
	^id
!

id: anObject
	id := anObject
!

name
	^name
!

name: anObject
	name := anObject
!

orderedCollection
	^orderedCollection
!

orderedCollection: anObject
	orderedCollection := anObject
!

set
	^set
!

set: anObject
	set := anObject
!

sortedCollection
	^sortedCollection
!

sortedCollection: anObject
	sortedCollection := anObject
! !

!GlorpThingWithLotsOfDifferentCollections methodsFor:'initialize-release'!

initialize
	array := #().
	orderedCollection := OrderedCollection new.
	set := Set new.
	bag := Bag new.
	sortedCollection := #() asSortedCollection.
! !

!GlorpThingWithLotsOfDifferentCollections class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__GlorpThingWithLotsOfDifferentCollections.st,v 1.1 2006/07/26 08:36:44 boris Exp $'
! !
