"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

TypeMapping subclass:#HorizontalTypeMapping
	instanceVariableNames:'mappedClass isAbstract'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpMappings'
!


!HorizontalTypeMapping class methodsFor:'instance creation'!

forClass: aClass
	^self new
		mappedClass: aClass;
		yourself
! !

!HorizontalTypeMapping class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!HorizontalTypeMapping methodsFor:'accessing'!

beAbstract
	isAbstract := true
!

isAbstract
	^isAbstract isNil ifTrue: [ isAbstract := false ] ifFalse: [ isAbstract ]
! !

!HorizontalTypeMapping methodsFor:'initializing'!

mappedClass: aClass
	mappedClass := aClass
! !

!HorizontalTypeMapping methodsFor:'mapping'!

allDescribedConcreteClasses
	| col |
	col := OrderedCollection new
		add: self describedClass;
		addAll: self describedClass glorpAllSubclasses;
		yourself.
	self needsWork: 'This belongs in someone else''s responsibility'.
	^col select: [:each |
		(self system descriptorFor: each) typeMapping isAbstract not ].
!

mapFromObject: anObject intoRowsIn: aRowMap

	"do nothing"
!

mappedFields
	^#()
!

trace: aTracing context: anExpression

	^self
! !

!HorizontalTypeMapping class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__HorizontalTypeMapping.st,v 1.1 2006/07/26 08:49:20 boris Exp $'
! !
