"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

RowBasedCommand subclass:#InsertCommand
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpCore'
!


!InsertCommand class methodsFor:'As yet unclassified'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!InsertCommand methodsFor:'accessing'!

arrayBoundFields
	"For array binding, include all the fields, except if we're inserting into a database with identity columns, where we must omit those columns"
	^platform usesIdentityColumns
		ifTrue: [row table fields reject: [:each | each type isIdentityColumn]]
		ifFalse: [row table fields].
!

basicPrintSQLFor: aRow
	| fields |
	self nextPutAll: 'INSERT INTO '.
	aRow table printSQLOn: self withParameters: #().
	fields := self shouldUseGroupWriting
		ifTrue: [self arrayBoundFields]
		ifFalse: [aRow nonGeneratedFieldsWithValues].
	self nextPutAll: ' ('.
	GlorpHelper
		do: [:each | self nextPutAll: (platform nameForColumn: each name)]
		for: fields
		separatedBy: [self nextPutAll: ','].
	self nextPutAll: ') '.
	self nextPutAll: ' VALUES ('.
	GlorpHelper
		do:
			[:each | 
			(self canBind: (aRow at: each ifAbsent: [nil]) to: each type)
				ifTrue: [self nextPut: $?]
				ifFalse: [aRow printValueOfField: each on: self]]
		for: fields
		separatedBy: [self nextPutAll: ','].
	self nextPutAll: ')'.
!

printSQL
	| iterations |
	iterations := self shouldUseGroupWriting
		ifTrue:
			[self platform usesArrayBindingRatherThanGrouping
				ifTrue: [1]
				ifFalse: [allRows size]]
		ifFalse: [1].
	GlorpHelper
		do:
			[:i | self basicPrintSQLFor: (i = 1 ifTrue: [row] ifFalse: [allRows at: i])]
		for: (1 to: iterations)
		separatedBy: [self nextPutAll: '; '].
!

singleRowBoundFields
	"Include only the fields that have values in our particular row"
	^row nonGeneratedFieldsWithValues
! !

!InsertCommand methodsFor:'testing'!

supportsGroupWriting
	^true.
! !

!InsertCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__InsertCommand.st,v 1.1 2006/07/26 08:39:17 boris Exp $'
! !
