"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

DatabaseSequence subclass:#NamedSequence
	instanceVariableNames:'name tableSelectCommand schema'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!NamedSequence class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!NamedSequence methodsFor:'SQL'!

availableReservedNumbers
	^self reservedNumbers size.
!

maximumToReserveAtOnce
		^1000.
!

reserveSequenceNumbers: anInteger in: aSession for: aTable
	| numberNeeded numberToReserve |
	numberNeeded := anInteger - self availableReservedNumbers.
	numberNeeded <= 0 ifTrue: [^self].
	self
		reserveViaTableSelect: numberNeeded
		in: aSession
		for: aTable.
	[anInteger - self availableReservedNumbers >0 ] whileTrue: [
		numberToReserve := (anInteger - self availableReservedNumbers) min: (self maximumToReserveAtOnce).
		self reserveViaBackupMechanism: numberToReserve in: aSession].
!

reserveViaTableSelect: anInteger in: aSession for: aTable
	| rows command |
	command := self
		tableSelectCommandFor: aTable
		in: aSession
		reserving: anInteger.
	command parameters: (Array with: anInteger).
	rows := aSession accessor executeCommand: command.
	rows do: [:each | self reservedNumbers add: each first].
!

tableSelectCommandFor: aTable in: aSession reserving: anObject
	self subclassResponsibility.
! !

!NamedSequence methodsFor:'accessing'!

name
	^name.
!

name: aString
	name := aString.
!

qualifiedName
	^(schema isNil or: [schema isEmpty]) ifTrue: [name] ifFalse: [schema, '.', name].
!

schema
	^schema
!

schema: aString
	schema := aString
! !

!NamedSequence methodsFor:'sequencing'!

dropString

	^'Drop sequence ', self qualifiedName.
! !

!NamedSequence class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__NamedSequence.st,v 1.1 2006/07/26 08:19:07 boris Exp $'
! !
