"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

DatabaseAccessor subclass:#ObjectStudioDatabaseAccessor
	instanceVariableNames:'inTransaction'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpDatabase'
!


!ObjectStudioDatabaseAccessor methodsFor:'accessing'!

connectionClassForLogin: aLogin
	aLogin database class == OraclePlatform
		ifTrue: [^Smalltalk at: #OracleOCIDatabase ifAbsent: [self error: 'no such driver']].
	aLogin database isODBCPlatform ifTrue: [^Smalltalk at: #ODBCDatabase].
	self error: 'Unknown database: ' , aLogin database name.
! !

!ObjectStudioDatabaseAccessor methodsFor:'executing'!

basicExecuteSQLString: aString
	| result cursor records |
	result := connection execSql: aString.
	records := result records.
	"Fix up nulls"
	records do: [:each |
		1 to: each size do: [:i |
			(each at: i) == #'(NULL)' ifTrue: [each at: i put: nil]]].
	cursor := GlorpCursoredStream on: (ReadStream on: result records) accessor: self.
	cursor statement: result.
	^cursor.
!

basicExecuteSQLString: aString bindingArray: aBindingArray
	" *** This method was defined by Glorp.DatabaseAccessor as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	self error: 'Subclass responsibility stub not reimplemented'
!

basicExecuteSQLString: aString returnResult: returnResult binding: aBindingArray doing: aBlock

	^connection execSql: aString.
!

externalDatabaseErrorSignal
	^Error.
!

isInTransaction
	^inTransaction.
!

releaseCursor: aCursor in: aPreparedStatement
!

rowCount
	^connection rowsProcessed.
! !

!ObjectStudioDatabaseAccessor methodsFor:'initialize-release'!

initialize
	inTransaction := false.
!

showDialog: aString
	" *** This method was defined by Glorp.DatabaseAccessor as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	self error: 'Subclass responsibility stub not reimplemented'
! !

!ObjectStudioDatabaseAccessor methodsFor:'login'!

isLoggedIn

	connection isNil ifTrue: [^false].
	^connection isActive
!

loginIfError: aBlock
	| |
"	connection :=self connectionClass 
		name: currentLogin connectString
		alias: currentLogin connectString
		password: currentLogin password
		drive: 'c'
		comment: currentLogin connectString
		create: false."
	connection := self connectionClass
		logOnServer: currentLogin connectString
		 user: currentLogin username
		 password: currentLogin password
		 alias: currentLogin connectString.
	(connection isKindOf: Message)
		ifTrue: [^self errorBoxMessage: connection asString].
	connection start.
!

logout
	connection class logOff.
!

rollbackTransaction
	inTransaction := false.
	^connection rollback.
! !

!ObjectStudioDatabaseAccessor methodsFor:'transactions'!

beginTransaction
	inTransaction := true.
	^connection beginTran.
!

commitTransaction
	inTransaction := false.
	^connection commit.
! !

!ObjectStudioDatabaseAccessor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__ObjectStudioDatabaseAccessor.st,v 1.1 2006/07/26 08:42:15 boris Exp $'
! !
