"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

NamedSequence subclass:#PGSequence
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!PGSequence class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!PGSequence methodsFor:'SQL'!

backupReserveCommand: anInteger in: aSession
	| stream command |
	stream := WriteStream on: (String new: 200).
	stream nextPutAll: 'select '.
	GlorpHelper
		print: [:i | 'nextval(''' , self qualifiedName , ''')']
		on: stream
		for: (1 to: anInteger)
		separatedBy: ','.
	command := SQLStringSelectCommand new.
	command setSQLString: stream contents.
	command parameters: (Array with: anInteger).
	command platform: aSession platform.
	^command.
!

getSequenceValueFromDatabaseFor: aDatabaseField in: aDatabaseRow using: anAccessor

	| statement rows pk |

	"this could be made smarter by aggregating keys to fetch into a single sql query - maybe later -tb"
	statement := 'select nextval(''',  self qualifiedName, ''')'.

	rows := anAccessor executeSQLString: statement.
	pk := rows first first.

	aDatabaseRow at: aDatabaseField put: pk.
!

postWriteAssignSequenceValueFor: aDatabaseField in: aDatabaseRow using: aSession 
	"aDatabaseRow at: aDatabaseField
		put: (aSession accessor 
				executeSQLString: 'SELECT CURRVAL(' , self qualifiedName 	, ')')."
!

reserveViaBackupMechanism: anInteger in: aSession
	"The regular mechanism didn't work, (probably because there weren't enough rows in the table), try a different technique."

	| command row |
	command := self backupReserveCommand: anInteger in: aSession.
	row := (aSession accessor executeCommand: command) first.
	self reservedNumbers addAll: row.
!

tableSelectCommandFor: aTable in: aSession reserving: anInteger
        | stream |
        (tableSelectCommand notNil and: [tableSelectCommand parameters includes: anInteger]) ifFalse:
                        [stream := WriteStream on: (String new: 200).
                        stream nextPutAll: 'select nextval('''.
                        self qualifiedName printOn: stream.
                        stream nextPutAll: ''') from ' , aTable name.
                        stream nextPutAll: ' limit '.
                        stream nextPutAll: (aSession useBinding ifTrue: ['?'] ifFalse: [anInteger printString]).
                        tableSelectCommand := SQLStringSelectCommand new.
                        tableSelectCommand parameters: (Array with: anInteger).
                        tableSelectCommand setSQLString: stream contents.
                        tableSelectCommand platform: aSession platform].
        ^tableSelectCommand.
! !

!PGSequence class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__PGSequence.st,v 1.1 2006/07/26 08:18:01 boris Exp $'
! !
