"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

SelectCommand subclass:#QuerySelectCommand
	instanceVariableNames:'query boundExpressions'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpCore'
!


!QuerySelectCommand methodsFor:'accessing'!

bindingTypes
	self useBinding ifFalse: [^#()].
	boundExpressions isNil ifTrue: [self findBoundExpressions].
	^boundExpressions collect: [:each | each bindingType].
!

bindings
	self useBinding ifFalse: [^#()].
	boundExpressions isNil ifTrue: [self findBoundExpressions].
	^boundExpressions collect: [:each | each bindingIn: self].
!

blockFactor
	blockFactor isNil ifTrue: [blockFactor := query expectedRows].
	^blockFactor.
!

boundExpressions
	^boundExpressions
!

boundExpressions: anObject
	boundExpressions := anObject
!

findBoundExpressions
	self useBinding ifFalse: [^nil].
	boundExpressions := OrderedCollection new.
	query addBoundExpressionsIn: self to: boundExpressions.
!

printSQL
	stream nextPutAll: 'SELECT '.
	query printSelectFieldsOn: self.
	self findBoundExpressions.
	query printTablesOn: self.
	query printWhereClauseOn: self.
	query printJoinsOn: self.
	query printOrderingOn: self.
	query printPostLimitOn: self.
	query printOffsetOn: self.
!

query
	^query.
!

query: aQuery
	query := aQuery.
! !

!QuerySelectCommand methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	query printOn: aStream.
	aStream nextPut: $).
! !

!QuerySelectCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__QuerySelectCommand.st,v 1.1 2006/07/26 08:39:01 boris Exp $'
! !
