"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

FunctionExpression subclass:#StandaloneFunction
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpExpressions'
!

StandaloneFunction comment:'This represents a function that takes no arguments and is complete in itself. The obvious example is COUNT(*). Making a special ''*'' pseudo-field seems even more of a hack than just hard-coding it into a function like this. It''s possible that things like nextval(sequence) might be able to fall in this category too.'
!


!StandaloneFunction class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!StandaloneFunction methodsFor:'accessing'!

type
	^self defaultType.
! !

!StandaloneFunction methodsFor:'mapping'!

mappedFields
	^Array with: self.
!

valueInBuilder: anElementBuilder
	^anElementBuilder valueOfField: self
!

valueInBuilder: anElementBuilder as: anExpression
	^anElementBuilder valueOfField: anExpression.
! !

!StandaloneFunction methodsFor:'printing'!

printSQLOn: aStream withParameters: aDictionary
	aStream nextPutAll: ' '; nextPutAll: function.
! !

!StandaloneFunction class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__StandaloneFunction.st,v 1.1 2006/07/26 08:48:04 boris Exp $'
! !
