"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

BaseExpression subclass:#SubSelectBaseExpression
	instanceVariableNames:'trueBase'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpExpressions'
!


!SubSelectBaseExpression class methodsFor:'instance creation'!

on: aBaseExpression
	^self new trueBase: aBaseExpression.
! !

!SubSelectBaseExpression methodsFor:'accessing'!

additionalExpressions
	"We effectively take over the join for the thing we're based on, because we want it to happen in the subselect, not in the main one."

	^trueBase additionalExpressionsOn: self.
!

base
	^trueBase base.
!

descriptor
	^trueBase descriptor.
!

field
	^self trueBase mapping field.
!

join
	^self trueBase join.
!

table
	^self trueBase table.
!

trueBase
	^trueBase
!

trueBase: aBaseExpression
	trueBase := aBaseExpression.
! !

!SubSelectBaseExpression methodsFor:'converting'!

convertedDbValueOf: anObject

	^self trueBase mapping convertedDbValueOf: anObject.
! !

!SubSelectBaseExpression methodsFor:'navigating'!

queryLevelBaseExpression

	^self
!

ultimateBaseExpression

	^trueBase ultimateBaseExpression
! !

!SubSelectBaseExpression methodsFor:'preparing'!

additionalExpressionsOn: anExpression
	^trueBase additionalExpressionsOn: anExpression.
!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	anExpression isNil ifTrue: [^aBaseExpression].
	anExpression == self ifTrue: [^aBaseExpression].
	trueBase := trueBase rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression.
	^self.
! !

!SubSelectBaseExpression methodsFor:'printing'!

className

	^'SubSelectBase'.
!

printSQLOn: aStream withParameters: aDictionary
	"If I'm ever going to print this directly, it's because I'm participating in a direct to-many relationship, so I do have a valid field"
	(self translateField: self field) printSQLOn: aStream withParameters: aDictionary.
! !

!SubSelectBaseExpression methodsFor:'testing'!

representsDerivedObject
	^self trueBase representsDerivedObject
! !

!SubSelectBaseExpression class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__SubSelectBaseExpression.st,v 1.1 2006/07/26 08:48:18 boris Exp $'
! !
