"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

RelationExpression subclass:#SubSelectExpression
	instanceVariableNames:'query localBase'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpExpressions'
!


!SubSelectExpression methodsFor:'accessing'!

descriptor
	^self leftChild descriptor.
!

initializeQuery
	query := Query
		returningManyOf: localBase descriptor describedClass
		where: rightChild.
	query tablePrefix: ('s', localBase ultimateBaseExpression availableSubSelectNumber printString, 't').
"	query baseExpression: localBase."
	query session: localBase descriptor session.
	localBase descriptor tables do: [:eachTable |
		eachTable primaryKeyFields do: [:each | query retrieve: [:base | base getField: each]]].
!

query
	query isNil ifTrue: [self initializeQuery].
	^query.
! !

!SubSelectExpression methodsFor:'internal'!

named: aSymbol basedOn: anExpression withArguments: anArray

	| right |
	outerJoin := false.
	relation := self operationFor: aSymbol.
	leftChild := anExpression base.

	localBase := SubSelectBaseExpression on: anExpression.
	right := anArray first.
	rightChild := right rebuildOn: localBase startingFrom: anExpression.
! !

!SubSelectExpression methodsFor:'preparing'!

addBoundExpressionsIn: aCommand to: boundExpressions
	self query prepare.
	self query addBoundExpressionsIn: aCommand to: boundExpressions.
!

condensePrimaryKeyComparison
	"Relies on this having been called after the children are condensed. If the child has had its reference to our base condensed away, then we aren't necessary, the comparison is at the same level and no longer needs a subselect"
	^leftChild queryLevelBaseExpression == rightChild queryLevelBaseExpression ifTrue: [rightChild] ifFalse: [self].
!

rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression
	| expression left |
	self == anExpression ifTrue: [^aBaseExpression].
	"We've swallowed our left child, so we have to unswallow it before rebuilding"
	left := localBase trueBase rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression.
	expression := left 
		get: relation
		withArguments:
			(Array
				with:
					(self rightChildToRebuild rebuildOn: aBaseExpression startingFrom: anExpression withOuterScopeBase: ultimateBaseExpression)).
	self isOuterJoin ifTrue: [expression beOuterJoin].
	^expression.
! !

!SubSelectExpression methodsFor:'printing SQL'!

printSQLOn: aStream withParameters: aDictionary 
	| command toPrint |
	toPrint := relation = #noneSatisfy: ifTrue: ['NOT EXISTS ('] ifFalse: [' EXISTS ('].
	aStream nextPutAll: toPrint.
	command := self query sqlWith: aDictionary.
	aStream nextPutAll: command sqlString.
	aStream nextPutAll: ')'.
! !

!SubSelectExpression class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__SubSelectExpression.st,v 1.1 2006/07/26 08:48:28 boris Exp $'
! !
