"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Proxy subclass:#TimedProxy
	instanceVariableNames:'id reaper secondsToLive timeToDie association'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpQueries'
!


!TimedProxy methodsFor:'accessing'!

class
        ^Glorp::TimedProxy.
!

doesNotUnderstand: aMessage

	self glorpTouch.
	^super doesNotUnderstand: aMessage
!

glorpAssociation
	^association
!

glorpAssociation: anAssociation
	association := anAssociation
!

glorpId
	^id
!

glorpId: uniqueInteger
	id := uniqueInteger
!

glorpReaper: aTimedProxyReaper
	reaper := aTimedProxyReaper
!

glorpSecondsToLive
	"Answer the number of seconds the receiver should live after having been instantiated or sent a message."

	^secondsToLive
!

glorpSecondsToLive: seconds

	secondsToLive := seconds.
	self updateExpiryTime.
	reaper notNil ifTrue: [self glorpTouch]
!

glorpTimeToDie
	"Answer the time at which the receiver is scheduled to die."

	^timeToDie
!

glorpTouch
	self updateExpiryTime.
	reaper isNil ifFalse: [reaper touch: self].
!

proxyInitialize
	super proxyInitialize.
	secondsToLive := 30.
	self updateExpiryTime.
!

uninstantiate

	super uninstantiate.
	association := nil.
!

updateExpiryTime
	timeToDie := Time millisecondClockValue + (secondsToLive * 1000).
! !

!TimedProxy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__TimedProxy.st,v 1.1 2006/07/26 08:51:32 boris Exp $'
! !
