"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

CachePolicy subclass:#TimedStrongCachePolicy
	instanceVariableNames:'timeout'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpCore'
!

TimedStrongCachePolicy comment:'This implements a cache that notes that an object is stale after some amount of time since it has been read.

Instance Variables:
	timeout	<Integer>	The time in seconds until we note an object as needing refreshing.

'
!


!TimedStrongCachePolicy methodsFor:'accessing'!

timeout
	^timeout
!

timeout: seconds
	timeout := seconds
!

timeoutSeconds
	^timeout
!

timeoutSeconds: anInteger
	timeout := anInteger.
! !

!TimedStrongCachePolicy methodsFor:'initialize'!

initialize

	super initialize.
	timeout := 300.
! !

!TimedStrongCachePolicy methodsFor:'utility'!

totalSeconds

	^Dialect totalSeconds.
! !

!TimedStrongCachePolicy methodsFor:'wrap/unwrap'!

cacheEntryFor: anObject

	^Array with: self totalSeconds with: anObject.
!

contentsOf: aCacheEntry

	^aCacheEntry at: 2.
!

expire: aCacheEntry

	^aCacheEntry at: 1 put: 0.
!

hasExpired: aCacheEntry

	^(self totalSeconds - (aCacheEntry at: 1)) >= timeout.
!

markEntryAsCurrent: aCacheEntry in: aCache

	aCacheEntry at: 1 put: self totalSeconds.
! !

!TimedStrongCachePolicy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__TimedStrongCachePolicy.st,v 1.1 2006/07/26 08:37:48 boris Exp $'
! !
