"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

FieldValueWrapper subclass:#TransformingFieldValueWrapper
	instanceVariableNames:'forwardTransformation inverseTransformation innerWrapper'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpUnitOfWork'
!

TransformingFieldValueWrapper comment:'This wraps another wrapper and transforms its value.

Instance Variables:
	forwardTransformation	<Block>	What to do to convert our value going out.
	innerWrapper	<FieldValueWrapper>	The wrapper that really has the value.
	inverseTransformation	<Block>	What to do to convert our value going in.

'
!


!TransformingFieldValueWrapper methodsFor:'accessing'!

allInnerWrappers
	^innerWrapper allInnerWrappers, (Array with: innerWrapper).
!

basicContents
	"Return the un-transformed contents"
	^innerWrapper contents.
!

contents

	^forwardTransformation value: innerWrapper contents.
!

contents: anObject

	innerWrapper contents: (inverseTransformation value: anObject).
!

forwardTransformation
	^forwardTransformation
!

forwardTransformation: aBlock
	forwardTransformation := aBlock
!

hasValue

	^innerWrapper hasValue.
!

innerWrapper
	^innerWrapper
!

innerWrapper: aFieldValueWrapper
	innerWrapper := aFieldValueWrapper
!

inverseTransformation
	^inverseTransformation
!

inverseTransformation: aBlock
	inverseTransformation := aBlock
!

privateSetContents: anObject
	innerWrapper privateSetContents: (inverseTransformation value: anObject).
! !

!TransformingFieldValueWrapper methodsFor:'unifying'!

containsWrapper: aFieldValueWrapper
	^self == aFieldValueWrapper or: [innerWrapper == aFieldValueWrapper
		or: [aFieldValueWrapper innerWrapper == self
			or: [aFieldValueWrapper innerWrapper == self innerWrapper]]].
!

replaceWith: aFieldValueWrapper
	innerWrapper replaceWith: aFieldValueWrapper.
! !

!TransformingFieldValueWrapper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__TransformingFieldValueWrapper.st,v 1.1 2006/07/26 08:53:33 boris Exp $'
! !
