"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Mapping subclass:#TypeMapping
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpMappings'
!


!TypeMapping class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!TypeMapping methodsFor:'accessing'!

mappedClass
	^self descriptor describedClass
! !

!TypeMapping methodsFor:'mapping'!

addTypeMappingCriteriaTo: collection in: expression
	^self
!

allDescribedConcreteClasses

	^Array with: (self describedClass)
!

describedClass
	^self descriptor describedClass
!

describedConcreteClassFor: aRow withBuilder: builder

	^self mappedClass
!

descriptorForSuperclass
	^self system descriptorFor: self mappedClass superclass
!

mapFromObject: anObject intoRowsIn: aRowMap
	"do  nothing"
!

mapObject: anObject inElementBuilder: anElementBuilder
	"do  nothing"
!

referencedIndependentObjectsFrom: anObject
	^#().
!

typeMappingRoot
	^self isTypeMappingRoot 
		ifTrue: [self mappedClass]
		ifFalse: [self descriptorForSuperclass typeMapping typeMappingRoot]
! !

!TypeMapping methodsFor:'testing'!

canBeTypeMappingParent
	^true
!

hasAttribute
	"Return true if this maps an attribute, which is normally true"
	^false.
!

isAbstract
	self subclassResponsibility
!

isRelationship

	^false.
!

isTypeMapping
	^true
!

isTypeMappingRoot
	| superClassDescriptor |
	superClassDescriptor := self descriptorForSuperclass.
	^superClassDescriptor isNil or: [ superClassDescriptor typeMapping canBeTypeMappingParent not ]
! !

!TypeMapping methodsFor:'validation'!

validateAttribute
	" TypeMapping doesn't use the attribute, validation would therefore fail. Probably should introduce AttributeMapping as sibling to TypeMapping "
! !

!TypeMapping class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__TypeMapping.st,v 1.1 2006/07/26 08:50:02 boris Exp $'
! !
