"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Object subclass:#TypeResolver
	instanceVariableNames:'members system'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!TypeResolver class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!TypeResolver methodsFor:'accessing'!

addMember: aDescriptor
	members isNil ifTrue: [ members := OrderedCollection new].
	members add: aDescriptor
!

classesRequiringIndependentQueriesFor: aClass
	self subclassResponsibility
!

describedConcreteClassFor: row withBuilder: builder descriptor: aDescriptor
	self subclassResponsibility
!

system
	^system
!

system: anObject
	system := anObject
! !

!TypeResolver methodsFor:'other'!

describedClasses
	^members collect: [:each | each describedClass ].
! !

!TypeResolver methodsFor:'registering'!

register: aDescriptor
	^self register: aDescriptor abstract: false
!

register: aDescriptor abstract: abstract

	self system: aDescriptor system.
	self addMember: aDescriptor.
	aDescriptor typeResolver: self
! !

!TypeResolver methodsFor:'type resolution'!

fieldsForSelectStatement
	"Return fields that are needed in a select statement - i.e. return all inherited fields that are part of the tables we are already selecting for this object"
	^#().
!

typeMappingRootDescriptor
	self subclassResponsibility
! !

!TypeResolver class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__TypeResolver.st,v 1.1 2006/07/26 08:15:46 boris Exp $'
! !
