"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

CachePolicy subclass:#WeakVWCachePolicy
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpCore'
!

WeakVWCachePolicy comment:'This is a cache policy that uses VisualWorks 7.x weak references (ephemerons) to store references to objects, letting them vanish if not referenced. It uses the numberOfElements inst var as an indicator of how many objects to keep hard references to, preventing objects from disappearing too quickly.

Instance Variables:
	
'
!


!WeakVWCachePolicy class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!WeakVWCachePolicy methodsFor:'accessing'!

dictionaryClass
	^Dialect smalltalkAt: #EphemeralValueDictionary ifAbsent: [Dictionary].
!

numberOfReferencesToKeepAround
	^numberOfElements.
! !

!WeakVWCachePolicy methodsFor:'expiry'!

collectionForExtraReferences

	^FixedSizeQueue maximumSize: self numberOfReferencesToKeepAround.
!

markEntryAsCurrent: item in: aCache
	aCache markEntryAsCurrent: item.
! !

!WeakVWCachePolicy methodsFor:'initialize-release'!

newItemsIn: aCache
	| items |
	items := super newItemsIn: aCache.
	items manager: aCache.
	^items.
! !

!WeakVWCachePolicy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Glorp__WeakVWCachePolicy.st,v 1.1 2006/07/26 08:38:32 boris Exp $'
! !
