"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

Object subclass:#Login
	instanceVariableNames:'database username password connectString name schema'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!Login class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!Login methodsFor:'accessing'!

= aLogin 
	^self class == aLogin class and: 
			[self name = aLogin name and: 
					[self database class = aLogin database class and: 
							[self username = aLogin username and: 
									[self password = aLogin password 
										and: [self connectString = aLogin connectString]]]]]
!

connectString
	^connectString
!

connectString: aString 
	connectString := aString
!

database
	^database
!

database: aSymbol 
	database := aSymbol
!

hash
	^self name hash + self database class hash + self username hash 
		+ self password hash + self connectString hash
!

name
	name isNil ifTrue: [^self connectString] ifFalse: [^name].
!

name: aString
	name := aString.
!

password
	^password
!

password: aString 
	password := aString
!

platform
	^self database.
!

schema
	^schema
!

schema: aString
	schema := aString.
!

username
	^username
!

username: aString 
	username := aString
! !

!Login methodsFor:'printing'!

printOn: aStream

	aStream nextPutAll: 'a Login('.
	database printOn: aStream.
	aStream nextPutAll: ', '.
	username printOn: aStream.
	aStream nextPutAll: ', '.
	password printOn: aStream.
	aStream nextPutAll: ', '.
	connectString printOn: aStream.
	aStream nextPutAll: ')'.
! !

!Login class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Login.st,v 1.1 2006/07/26 08:19:37 boris Exp $'
! !
