"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

AbstractProxy subclass:#Proxy
	instanceVariableNames:'session query parameters'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!


!Proxy class methodsFor:'instance creation'!

returningManyOf: aClass where: aBlock 
	^self new query: (Query returningManyOf: aClass where: aBlock)
!

returningManyOf: aClass where: aBlock in: aSession
	
	^self new 
		query: (Query returningManyOf: aClass where: aBlock);
		session: aSession
!

returningOneOf: aClass where: aBlock 
	^self new query: (Query returningOneOf: aClass where: aBlock)
!

returningOneOf: aClass where: aBlock in: aSession
	
	^self new 
		query: (Query returningOneOf: aClass where: aBlock);
		session: aSession.
! !

!Proxy class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!Proxy methodsFor:'accessing'!

class

        ^Glorp::Proxy
        "self isInstantiated ifTrue: [^value class].
        query isNil ifTrue: [^Proxy].
        query resultClass isNil ifTrue: [^Proxy].
        ^query resultClass."
!

isKindOf: aClass
	self isInstantiated ifTrue: [^value isKindOf: aClass].
	query isNil ifTrue: [^false].
	query resultClass isNil ifTrue: [^false].
	^query resultClass includesBehavior: aClass.
!

parameters
	^parameters
!

parameters: aDictionary
	parameters := aDictionary.
!

query
	^query
!

query: aQuery 
	query := aQuery
!

session
	^session
!

session: aSession 
	session := aSession
! !

!Proxy methodsFor:'api'!

getValue
	self isInstantiated ifTrue: [^value].
	parameters isNil ifTrue: [parameters := Dictionary new: 0].
	[value := query isNil ifTrue: [nil] ifFalse: [query executeWithParameters: parameters in: session]] 
		ensure: [isInstantiated := true].
	^value.
! !

!Proxy methodsFor:'printing'!

printOn: aStream 
	aStream nextPut: ${.
	isInstantiated 
		ifTrue: [self getValue printOn: aStream]
		ifFalse: 
			[aStream nextPutAll: 'uninstantiated '.
			query isNil
				ifTrue: [aStream nextPutAll: '???']
				ifFalse: [
					query readsOneObject ifFalse: [aStream nextPutAll: 'collection of '].
					aStream nextPutAll: query resultClass name]].
	aStream nextPut: $}
! !

!Proxy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/Proxy.st,v 1.1 2006/07/26 08:15:23 boris Exp $'
! !
