"{ Package: 'stx:goodies/glorp0_4' }"

"{ NameSpace: Glorp }"

CachePolicy subclass:#TimedExpiryCachePolicy
	instanceVariableNames:'timeout'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp'
!

TimedExpiryCachePolicy comment:'This implements a cache that notes that an object is stale after some amount of time since it has been read.

Instance Variables:
	timeout	<Integer>	The time in seconds until we note an object as needing refreshing.

'
!


!TimedExpiryCachePolicy class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!TimedExpiryCachePolicy methodsFor:'accessing'!

timeout
	^timeout
!

timeout: seconds
	timeout := seconds
!

timeoutSeconds
	^timeout
!

timeoutSeconds: anInteger
	timeout := anInteger.
! !

!TimedExpiryCachePolicy methodsFor:'initialize'!

initialize

	super initialize.
	timeout := 300.
! !

!TimedExpiryCachePolicy methodsFor:'utility'!

totalSeconds

	^Dialect totalSeconds.
! !

!TimedExpiryCachePolicy methodsFor:'wrap/unwrap'!

cacheEntryFor: anObject

	^Array with: self totalSeconds with: anObject.
!

contentsOf: aCacheEntry

	^aCacheEntry at: 2.
!

expire: aCacheEntry

	^aCacheEntry at: 1 put: 0.
!

hasExpired: aCacheEntry

	^(self totalSeconds - (aCacheEntry at: 1)) >= timeout.
!

markEntryAsCurrent: aCacheEntry in: aCache

	aCacheEntry at: 1 put: self totalSeconds.
! !

!TimedExpiryCachePolicy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/TimedExpiryCachePolicy.st,v 1.1 2006/07/26 08:16:52 boris Exp $'
! !
