"{ Package: 'stx:goodies/glorp0_4/tests' }"

Glorp::DescriptorSystem subclass:#GTEmbeddedValueExampleDescriptor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTutorial'
!


!GTEmbeddedValueExampleDescriptor methodsFor:'accessing'!

allTableNames

  ^#('GT_CURVE' 'GT_CURVEPOINT')
!

constructAllClasses

  ^(super constructAllClasses)
      add: PlanarCurve;
      add: CurvePoint;
      add: Point;
     yourself.
! !

!GTEmbeddedValueExampleDescriptor methodsFor:'class models'!

classModelForCurvePoint: aClassModel

  aClassModel
    newAttributeNamed: #id;
    newAttributeNamed: #point type: Point.
!

classModelForPlanarCurve: aClassModel

  aClassModel
    newAttributeNamed: #id;
    newAttributeNamed: #points collectionOf: CurvePoint.
!

classModelForPoint: aClassModel

  aClassModel
    newAttributeNamed: #x;
    newAttributeNamed: #y.
! !

!GTEmbeddedValueExampleDescriptor methodsFor:'mappings'!

descriptorForCurvePoint: aDescriptor

       | table |
    table := self tableNamed: 'GT_CURVEPOINT'.
    aDescriptor table: table.
    (aDescriptor newMapping: Glorp::DirectMapping) from: #id to: (table fieldNamed: 'id').

    (aDescriptor newMapping: Glorp::EmbeddedValueOneToOneMapping) attributeName: #point.
!

descriptorForPlanarCurve: aDescriptor

       | table |
    table := self tableNamed: 'GT_CURVE'.
    aDescriptor table: table.

    (aDescriptor newMapping: Glorp::DirectMapping) from: #id to: (table fieldNamed: 'id').
    (aDescriptor newMapping: Glorp::OneToManyMapping) attributeName: #points.
!

descriptorForPoint: aDescriptor

       | table |
    table := self tableNamed: 'GT_CURVEPOINT'.
    aDescriptor table: table.
    (aDescriptor newMapping: Glorp::DirectMapping) from: #x to: (table fieldNamed: 'x_coord').
    (aDescriptor newMapping: Glorp::DirectMapping) from: #y to: (table fieldNamed: 'y_coord').
! !

!GTEmbeddedValueExampleDescriptor methodsFor:'tables'!

tableForGT_CURVE: aTable

   (aTable createFieldNamed: 'id' type: platform sequence) bePrimaryKey.
!

tableForGT_CURVEPOINT: aTable
          | foreignKeyToCurve |
   (aTable createFieldNamed: 'id' type: platform sequence) bePrimaryKey.

   aTable createFieldNamed: 'x_coord' type: (platform float);
          createFieldNamed: 'y_coord' type: (platform float).

   foreignKeyToCurve := aTable createFieldNamed: 'curve_id' type: platform integer.
   aTable addForeignKeyFrom: foreignKeyToCurve
          to: ((self tableNamed: 'GT_CURVE') fieldNamed: 'id').
! !

!GTEmbeddedValueExampleDescriptor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/GTEmbeddedValueExampleDescriptor.st,v 1.1 2006/07/26 09:08:01 boris Exp $'
! !
