"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpExampleSystem subclass:#GlorpBankExampleSystem
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpBankExampleSystem class methodsFor:'instance creation'!

new

	^super new initialize
! !

!GlorpBankExampleSystem class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpBankExampleSystem methodsFor:'examples'!

exampleGlorpAddressNumber1: anAddress
	anAddress id: 12.
	anAddress street: 'Paseo Montril'.
	anAddress number: '10185'.
!

exampleGlorpBankAccountNumber1: anAccount

	anAccount id: 1.
	anAccount accountNumber: (self objectNumber: 1 ofClass: GlorpBankAccountNumber).
!

exampleGlorpBankAccountNumber2: anAccount

	anAccount id: 2.
	anAccount accountNumber: (self objectNumber: 2 ofClass: GlorpBankAccountNumber).
!

exampleGlorpBankAccountNumberNumber1: aBankAccountNumber

	aBankAccountNumber bankCode: '004'.
	aBankAccountNumber branchNumber: 0342.
	aBankAccountNumber accountNumber: '12345'.
!

exampleGlorpBankAccountNumberNumber2: aBankAccountNumber

	aBankAccountNumber bankCode: '004'.
	aBankAccountNumber branchNumber: 0342.
	aBankAccountNumber accountNumber: '01010'.
!

exampleGlorpBankTransactionNumber1: aTrans

	"Nothing to initialize"
!

exampleGlorpBankTransactionNumber2: aTrans

	"Nothing to initialize"
!

exampleGlorpCustomerNumber1: aCustomer

	aCustomer id: 1.
	aCustomer name: 'Fred Flintstone'.
	aCustomer addTransaction: (self objectNumber: 1 ofClass: GlorpBankTransaction).
	aCustomer addTransaction: (self objectNumber: 2 ofClass: GlorpBankTransaction).
	aCustomer addAccount: (self objectNumber: 1 ofClass: GlorpBankAccount).
	aCustomer addAccount: (self objectNumber: 2 ofClass: GlorpBankAccount).
!

exampleGlorpEmailAddressNumber1: anEmailAddress 
	anEmailAddress id: 2.
	anEmailAddress user: 'foo'.
	anEmailAddress host: 'bar.com'
!

exampleGlorpPersonNumber1: aPerson 
	aPerson id: 1.
	aPerson name: 'Barney Rubble'.
	aPerson address: (self objectNumber: 1 ofClass: GlorpAddress).	
	aPerson emailAddress: (self objectNumber: 1 ofClass: GlorpEmailAddress).
! !

!GlorpBankExampleSystem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/GlorpBankExampleSystem.st,v 1.1 2006/07/26 09:06:49 boris Exp $'
! !
