"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

TestResource subclass:#GlorpDemoTablePopulatorResource
	instanceVariableNames:'login'
	classVariableNames:'NeedsSetup'
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpDemoTablePopulatorResource class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpDemoTablePopulatorResource class methodsFor:'setup'!

invalidateSetup
	"GlorpDemoTablePopulatorResource invalidateSetup"

	NeedsSetup := true.
	self reset.
!

needsSetup
	NeedsSetup isNil ifTrue: [NeedsSetup := true].
	^NeedsSetup
!

needsSetup: aBoolean

	NeedsSetup := aBoolean.
!

resources

	^Array with: GlorpDatabaseLoginResource.
! !

!GlorpDemoTablePopulatorResource methodsFor:'setup'!

populateStuffTable

	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (12,''abc'')'.
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (13, ''hey nonny nonny'')'.
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (42, ''yabba dabba doo'')'.
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (9625, ''the band played on'')'.
	login accessor executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (113141, ''Smalltalk'')'.
!

setUp
	super setUp.
	login := GlorpDatabaseLoginResource current.
	self class needsSetup ifFalse: [^self].
	login platform requiresTransactionForTableOperations ifTrue: [login accessor beginTransaction].
	[GlorpTestDescriptorSystem glorpAllSubclasses do:
			[:eachSystemClass |
			self
				setUpSystem: (eachSystemClass forPlatform: login platform) setUpDefaults].
	self populateStuffTable.
	login platform requiresTransactionForTableOperations ifTrue: [login accessor commitTransaction]] ifCurtailed: [
		login platform requiresTransactionForTableOperations ifTrue: [login accessor rollbackTransaction]].
!

setUpSystem: system
	| errorBlock |
	login accessor dropTables: ((TableSorter for: system allTables) sort reversed).
	errorBlock := [:ex | Transcript show: ex description; cr. ex pass].
	system platform areSequencesExplicitlyCreated ifTrue: [
		login accessor dropSequences: system allSequences.
		system allSequences do: [:each |
			login accessor createSequence: each ifError: errorBlock]].
	system allTables do: [:each |
			login accessor createTable: each
				ifError: errorBlock].
	system allTables do: [:each |
			login accessor createTableIndexes: each ifError: errorBlock].
	system allTables do: [:each |
			login accessor createTableFKConstraints: each ifError: errorBlock].

	self class needsSetup: false
! !

!GlorpDemoTablePopulatorResource class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/GlorpDemoTablePopulatorResource.st,v 1.1 2006/07/26 09:08:44 boris Exp $'
! !
