"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpExampleSystem
	instanceVariableNames:'objects'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpExampleSystem class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpExampleSystem methodsFor:'api'!

objectNumber: aNumber ofClass: aClass

        | symbol instance simplifiedClassName idx |
        simplifiedClassName := aClass name.
        (simplifiedClassName includes: $:) ifTrue: [
           idx := simplifiedClassName indexOf: $:.
           simplifiedClassName := simplifiedClassName copyFrom: idx + 2 to: simplifiedClassName size.
        ].

        instance := self lookupObject: aNumber ofClass: aClass ifAbsentPut: [aClass new].
        symbol := ('example', simplifiedClassName, 'Number', aNumber printString, ':') asSymbol.
        self perform: symbol with: instance.
        ^instance.
! !

!GlorpExampleSystem methodsFor:'initialize'!

initialize

	objects := Dictionary new.
! !

!GlorpExampleSystem methodsFor:'misc'!

lookupObject: aNumber ofClass: aClass ifAbsentPut: absentBlock

	^(objects at: aClass ifAbsentPut: [Dictionary new]) at: aNumber ifAbsentPut: absentBlock.
! !

!GlorpExampleSystem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/GlorpExampleSystem.st,v 1.1 2006/07/26 09:11:52 boris Exp $'
! !
