"{ Package: 'stx:goodies/glorp0_4/tests' }"

Glorp::DescriptorSystem subclass:#GlorpTutorialExampleDescriptor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTutorial'
!


!GlorpTutorialExampleDescriptor methodsFor:'accessing'!

allTableNames

  ^#('GT_PERSON' 'GT_COMPANY' 'GT_OSPROJECT')
!

constructAllClasses

  ^(super constructAllClasses)
      add: GTPerson;
      add: Company;
      add: OpenSourceProject;
     yourself.
! !

!GlorpTutorialExampleDescriptor methodsFor:'class models'!

classModelForCompany: aClassModel

  aClassModel
    newAttributeNamed: #id;
    newAttributeNamed: #name;
    newAttributeNamed: #shortName;
    newAttributeNamed: #webpage.
!

classModelForGTPerson: aClassModel

  aClassModel
    newAttributeNamed: #id;
    newAttributeNamed: #name;
    newAttributeNamed: #givenName;
    newAttributeNamed: #affiliation type: Company.
!

classModelForOpenSourceProject: aClassModel

  aClassModel
    newAttributeNamed: #id;
    newAttributeNamed: #title;
    newAttributeNamed: #webpage;
    newAttributeNamed: #projectManager type: GTPerson.
! !

!GlorpTutorialExampleDescriptor methodsFor:'mappings'!

descriptorForCompany: aDescriptor

       | table |
    table := self tableNamed: 'GT_COMPANY'.
    aDescriptor table: table.
    (aDescriptor newMapping: Glorp::DirectMapping) from: #id to: (table fieldNamed: 'id').
    (aDescriptor newMapping: Glorp::DirectMapping) from: #name to: (table fieldNamed: 'name').
    (aDescriptor newMapping: Glorp::DirectMapping) from: #shortName to: (table fieldNamed: 'short_name').
    (aDescriptor newMapping: Glorp::DirectMapping) from: #webpage to: (table fieldNamed: 'webpage').
!

descriptorForGTPerson: aDescriptor

       | table |
    table := self tableNamed: 'GT_PERSON'.
    aDescriptor table: table.
    (aDescriptor newMapping: Glorp::DirectMapping) from: #id to: (table fieldNamed: 'id').
    (aDescriptor newMapping: Glorp::DirectMapping) from: #name to: (table fieldNamed: 'name').
    (aDescriptor newMapping: Glorp::DirectMapping) from: #givenName to: (table fieldNamed: 'given_name').
    (aDescriptor newMapping: Glorp::OneToOneMapping) attributeName: #affiliation.
!

descriptorForOpenSourceProject: aDescriptor

       | table |
    table := self tableNamed: 'GT_OSPROJECT'.
    aDescriptor table: table.
    (aDescriptor newMapping: Glorp::DirectMapping) from: #id to: (table fieldNamed: 'id').
    (aDescriptor newMapping: Glorp::DirectMapping) from: #title to: (table fieldNamed: 'name').
    (aDescriptor newMapping: Glorp::DirectMapping) from: #webpage to: (table fieldNamed: 'webpage').
    (aDescriptor newMapping: Glorp::OneToOneMapping) attributeName: #projectManager.
! !

!GlorpTutorialExampleDescriptor methodsFor:'queries'!

class
    "return the receivers class"

%{  /* NOCONTEXT */

    RETURN ( __Class(self) );
%}

"
*** WARNING
***
*** this method has been automatically created,
*** since all nil-subclasses should respond to some minimum required
*** protocol.
***
*** Inspection and/or debugging of instances may not be possible,
*** if you remove/change this method. 
"
! !

!GlorpTutorialExampleDescriptor methodsFor:'tables'!

tableForGT_COMPANY: aTable

   (aTable createFieldNamed: 'id' type: platform sequence) bePrimaryKey.

   aTable createFieldNamed: 'name' type: (platform varchar: 80);
          createFieldNamed: 'short_name' type: (platform varchar: 30);
          createFieldNamed: 'webpage' type: (platform varchar: 250).
!

tableForGT_OSPROJECT: aTable

     | keyToManager |
   (aTable createFieldNamed: 'id' type: platform sequence) bePrimaryKey.

   aTable createFieldNamed: 'name' type: (platform varchar: 30);
          createFieldNamed: 'webpage' type: (platform varchar: 250).
   keyToManager := aTable createFieldNamed: 'manager_id' type: platform integer.

   aTable addForeignKeyFrom: keyToManager
          to: ((self tableNamed: 'GT_PERSON') fieldNamed: 'id').
!

tableForGT_PERSON: aTable

     | keyToCompany |
   (aTable createFieldNamed: 'id' type: platform sequence) bePrimaryKey.

   aTable createFieldNamed: 'name' type: (platform varchar: 30);
          createFieldNamed: 'given_name' type: (platform varchar: 30).
   keyToCompany := aTable createFieldNamed: 'company_id' type: platform integer.

   aTable addForeignKeyFrom: keyToCompany
          to: ((self tableNamed: 'GT_COMPANY') fieldNamed: 'id').
! !

!GlorpTutorialExampleDescriptor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/GlorpTutorialExampleDescriptor.st,v 1.2 2006/07/26 09:25:41 boris Exp $'
! !
