"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpAddress
	instanceVariableNames:'id street number'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest-Domain Models'
!


!GlorpAddress class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpAddress class methodsFor:'examples'!

example1

	^self new
		id: 1;
		street: 'West 47th Ave';
		number: '2042'.
!

example1WithChangedAddress

	^self new
		id: 1;
		street: 'Garden of the Gods';
		number: '99999'.
!

example2

	^self new
		id: 2;
		street: 'Nowhere';
		number: '1000'.
! !

!GlorpAddress class methodsFor:'glorp setup'!

glorpSetupClassModel: aClassModel forSystem: aDescriptorSystem 
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #street.
	aClassModel newAttributeNamed: #number.
!

glorpSetupDescriptor: aDescriptor forSystem: aDescriptorSystem 
	| table |
	table := aDescriptorSystem tableNamed: 'GR_ADDRESS'.
	aDescriptor table: table.
	aDescriptor
		addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID'));
		addMapping: (DirectMapping from: #street to: (table fieldNamed: 'STREET'));
		addMapping: (DirectMapping from: #number to: (table fieldNamed: 'HOUSE_NUM'))
! !

!GlorpAddress methodsFor:'accessing'!

id
	"Private - Answer the value of the receiver's ''id'' instance variable."

	^id
!

id: anObject
	"Private - Set the value of the receiver's ''id'' instance variable to the argument, anObject."

	id := anObject
!

number
	"Private - Answer the value of the receiver's ''number'' instance variable."

	^number
!

number: anObject
	"Private - Set the value of the receiver's ''number'' instance variable to the argument, anObject."

	number := anObject
!

street
	"Private - Answer the value of the receiver's ''street'' instance variable."

	^street
!

street: anObject
	"Private - Set the value of the receiver's ''street'' instance variable to the argument, anObject."

	street := anObject
! !

!GlorpAddress methodsFor:'notification'!

glorpNoticeOfExpiryIn: aSession
! !

!GlorpAddress methodsFor:'printing'!

printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '(', id printString, ',', street printString, ',' , number printString, ')'.
! !

!GlorpAddress class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpAddress.st,v 1.1 2006/07/26 09:15:37 boris Exp $'
! !
