"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpBankAccount
	instanceVariableNames:'id accountNumber accountHolders eventsReceived'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest-Domain Models'
!


!GlorpBankAccount class methodsFor:'instance creation'!

new

	^super new initialize.
! !

!GlorpBankAccount class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpBankAccount class methodsFor:'examples'!

example1

	^self new 
		id: 123;
		accountNumber: GlorpBankAccountNumber example12345.
! !

!GlorpBankAccount methodsFor:'accessing'!

accountHolders
	^accountHolders.
!

accountNumber
	^accountNumber
!

accountNumber: anAccountNumber 
	accountNumber := anAccountNumber
!

basicAddHolder: aCustomer

	accountHolders add: aCustomer.
!

basicRemoveHolder: aCustomer

	accountHolders remove: aCustomer.
!

id
	^id
!

id: anObject
	id := anObject
! !

!GlorpBankAccount methodsFor:'comparing'!

< anAccount
        ^self accountNumber accountNumber < anAccount accountNumber accountNumber.
!

<= anAccount
	^self accountNumber accountNumber <= anAccount accountNumber accountNumber.
! !

!GlorpBankAccount methodsFor:'initialize'!

initialize

	accountHolders := OrderedCollection new.
! !

!GlorpBankAccount methodsFor:'printing'!

printOn: aStream

	super printOn: aStream.
	aStream 
		nextPutAll: '(id=';
		print: id;
		nextPut: $).
! !

!GlorpBankAccount class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpBankAccount.st,v 1.1 2006/07/26 09:22:33 boris Exp $'
! !
