"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpConstantMappingTest
	instanceVariableNames:'mappingToClass mappingToRow mappingToSession slot'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpConstantMappingTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpConstantMappingTest methodsFor:'support'!

setUp
	| descriptor |
	super setUp.
	mappingToClass := ConstantMapping new
		attributeName: #slot;
		constantValue: 34.
	descriptor := Descriptor new.
	descriptor classModel: (GlorpClassModel for: self class).
	descriptor addMapping: mappingToClass.
	mappingToRow := ConstantMapping new.
	mappingToSession := ConstantMapping new
! !

!GlorpConstantMappingTest methodsFor:'tests'!

testConstantInClass
	slot := nil.
	mappingToClass mapObject: self inElementBuilder: nil.
	self assert: slot = 34.
!

testConstantInClassDoesNotWriteToRow

	"Would raise an exception if it tried to write into nil"
	mappingToClass mapFromObject: self intoRowsIn: nil.
!

testGetValue

	slot := nil.
	self assert: (mappingToClass getValueFrom: self) = 34.
!

testSessionValue
	mappingToClass constantValueIsSession.
	self assert: (mappingToClass constantValueIn: 38)== 38.
! !

!GlorpConstantMappingTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpConstantMappingTest.st,v 1.1 2006/07/26 09:15:07 boris Exp $'
! !
