"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpCustomer
	instanceVariableNames:'id name transactions accounts accountsSortedById
		accountsSortedByIdDescending eventsReceived seenPostFetch
		seenPreWrite seenPostWrite seenExpiry'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest-Domain Models'
!


!GlorpCustomer class methodsFor:'instance creation'!

new

	^super new initialize.
! !

!GlorpCustomer class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpCustomer class methodsFor:'examples'!

example1

	^self new
		name: 'Fred Flintstone';
		addTransaction: GlorpBankTransaction example1;
		addTransaction: GlorpBankTransaction example2.
!

example2

	^self new
          id: 123;
		name: 'Fred Flintstone';
		addTransaction: GlorpBankTransaction example1;
		addTransaction: GlorpBankTransaction example2.
! !

!GlorpCustomer methodsFor:'As yet unclassified'!

accountsSortedById
	^accountsSortedById.
!

accountsSortedByIdDescending
	^accountsSortedByIdDescending.
! !

!GlorpCustomer methodsFor:'accessing'!

accounts

	^accounts.
!

accounts: aCollection

	accounts := aCollection.
!

addAccount: aBankAccount

	accounts add: aBankAccount.
	aBankAccount basicAddHolder: self.
!

addTransaction: aTransaction

	transactions add: aTransaction.
	aTransaction owner: self.
!

id
	"Private - Answer the value of the receiver's ''id'' instance variable."

	^id
!

id: anObject
	"Private - Set the value of the receiver's ''id'' instance variable to the argument, anObject."

	id := anObject
!

name
	"Private - Answer the value of the receiver's ''name'' instance variable."

	^name
!

name: anObject
	"Private - Set the value of the receiver's ''name'' instance variable to the argument, anObject."

	name := anObject
!

removeAccount: aBankAccount

	accounts remove: aBankAccount.
	aBankAccount basicRemoveHolder: self.
!

seenPostFetch
	^seenPostFetch
!

seenPostWrite
	^seenPostWrite
!

seenPreWrite
	^seenPreWrite
!

transactions
	"Private - Answer the value of the receiver's ''transactions'' instance variable."

	^transactions
!

transactions: anObject
	"Private - Set the value of the receiver's ''transactions'' instance variable to the argument, anObject."

	transactions := anObject
! !

!GlorpCustomer methodsFor:'glorp/events'!

glorpNoticeOfExpiryIn: aSession
	seenExpiry := true.
!

glorpPostFetch: aSession
	seenPostFetch := true
!

glorpPostWrite: aSession
	seenPostWrite := true
!

glorpPreWrite: aSession
	seenPreWrite := true
!

seenExpiry
	^seenExpiry
! !

!GlorpCustomer methodsFor:'initialize/release'!

initialize

	transactions := OrderedCollection new.
	accounts := OrderedCollection new.
	seenExpiry := false.
	seenPostFetch := false.
	seenPreWrite:= false.
	seenPostWrite := false.
! !

!GlorpCustomer methodsFor:'printing'!

printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: id;
		nextPut: $,;
		nextPutAll: (name ifNil: ['']);
		nextPutAll: ')'
! !

!GlorpCustomer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpCustomer.st,v 1.1 2006/07/26 09:19:04 boris Exp $'
! !
