"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpDatabaseLoginTest
	instanceVariableNames:'login accessor'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpDatabaseLoginTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpDatabaseLoginTest class methodsFor:'resources'!

resources

	^Array with: GlorpDatabaseLoginResource.
! !

!GlorpDatabaseLoginTest methodsFor:'accessing'!

accessor

	^accessor.
! !

!GlorpDatabaseLoginTest methodsFor:'support'!

setUp
	super setUp.
	login := GlorpDatabaseLoginResource defaultLogin.
	accessor := DatabaseAccessor forLogin: login.
! !

!GlorpDatabaseLoginTest methodsFor:'tests'!

testLogin
	self assert: self accessor isLoggedIn not.
	self accessor login.
	self assert: self accessor isLoggedIn.
	self accessor logout.
	self assert: self accessor isLoggedIn not
!

testUnsuccessfulLogin

	| anotherAccessor invalidLogin |
	"Some databases can't fail to log in."
	login database supportsAuthentication ifFalse: [^self].

	invalidLogin := GlorpDatabaseLoginResource defaultLogin copy.
	invalidLogin
		password: 'you will never ever guess this password';
		username: 'not a valid user name'.
	anotherAccessor := DatabaseAccessor forLogin: invalidLogin.

	self assert: anotherAccessor isLoggedIn not.
	anotherAccessor loginIfError: [:ex | ].
	Dialect isVisualAge ifFalse: [ "The isLoggedIn is unreliable under VA, can return false positive"
		self assert: anotherAccessor isLoggedIn not].
	anotherAccessor logout.
! !

!GlorpDatabaseLoginTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpDatabaseLoginTest.st,v 1.1 2006/07/26 09:22:06 boris Exp $'
! !
