"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpDatabaseSessionTest
	instanceVariableNames:'session'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpDatabaseSessionTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpDatabaseSessionTest class methodsFor:'resources'!

resources

	^Array with: GlorpSessionResource.
! !

!GlorpDatabaseSessionTest methodsFor:'support'!

setUp

	super setUp.
	session := GlorpSessionResource current newSession.
!

tearDown
	super tearDown.
	session reset.
	session := nil.
! !

!GlorpDatabaseSessionTest methodsFor:'tests'!

testWriteRow
	| rowToWrite fields rowReadFromDatabase |
	rowToWrite := session system examplePersonRow2.

	[session beginTransaction.
	session writeRow: rowToWrite.
	rowReadFromDatabase := (session accessor
				executeSQLString: 'SELECT * FROM ' , rowToWrite table name) first.
	fields := rowToWrite table fields.
	(1 to: fields size) with: fields
		do: [:index :field | self assert: (rowReadFromDatabase atIndex: index) = (rowToWrite at: field)]]
			ensure: [session rollbackTransaction]
! !

!GlorpDatabaseSessionTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpDatabaseSessionTest.st,v 1.1 2006/07/26 09:05:02 boris Exp $'
! !
