"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpMappingDBTest subclass:#GlorpDatabaseTableTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpDatabaseTableTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpDatabaseTableTest methodsFor:'tests'!

testFKUniqueNames

	| platform contactTable linkTable companyId personId |
	platform := GlorpDatabaseLoginResource defaultPlatform.
	contactTable := DatabaseTable new
						name: 'CONTACT';
						yourself.
	contactTable createFieldNamed: 'ID' type: platform serial.

	linkTable := DatabaseTable new
						name: 'COMPANY_PERSON_LINK';
						yourself.
	companyId := linkTable createFieldNamed: 'COMPANY_ID' type: platform int4.
	personId := linkTable createFieldNamed: 'PERSON_ID' type: platform int4.
	linkTable
		addForeignKeyFrom: companyId to: (contactTable fieldNamed: 'ID');
		addForeignKeyFrom: personId to: (contactTable fieldNamed: 'ID').
	self assert: (linkTable foreignKeyConstraints collect: [:ea | ea name asSymbol]) asSet size = linkTable foreignKeyConstraints size.
!

testIndexes

	| platform contactTable idField name1Field name2Field |
	platform := GlorpDatabaseLoginResource defaultPlatform.
	contactTable := DatabaseTable new
						name: 'CONTACT';
						yourself.
	idField := (contactTable createFieldNamed: 'ID' type: platform serial) beIndexed.
	self assert: contactTable indexes size = 1.
	self assert: (contactTable hasIndexForField: idField).
	name1Field := contactTable createFieldNamed: 'NAME1' type: platform varchar.
	name2Field := contactTable createFieldNamed: 'NAME2' type: platform varchar.
	self deny: (contactTable hasIndexForField: name1Field).
	contactTable addIndexForFields: (Array with: name1Field with: name2Field).
	self assert: contactTable indexes size = 2.
	self assert: (contactTable hasIndexForField: idField).
	self assert: (contactTable hasIndexForField: name1Field).
	self assert: (contactTable hasIndexForField: name2Field).
! !

!GlorpDatabaseTableTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpDatabaseTableTest.st,v 1.1 2006/07/26 09:09:26 boris Exp $'
! !
