"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpDatabaseTypeDBTests
	instanceVariableNames:'type stType connection session'
	classVariableNames:''
	poolDictionaries:''
	category:'Glorp-DBTests'
!


!GlorpDatabaseTypeDBTests class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpDatabaseTypeDBTests methodsFor:'accessing'!

platform
	^connection platform
! !

!GlorpDatabaseTypeDBTests methodsFor:'infrastructure tests'!

testReadTime
	self platform readTime: '18:06:22.12' for: self platform time.
! !

!GlorpDatabaseTypeDBTests methodsFor:'setup'!

setUp
	super setUp.
	session := GlorpSessionResource current newSession.
	connection := session accessor.
!

tearDown
	super tearDown.
	session reset.
	session := nil.
! !

!GlorpDatabaseTypeDBTests methodsFor:'tests'!

testSerial
	"type := PGSerialType instance.
	self assert: false.

	self assert: (type typeString = 'SERIAL')"
!

testTimeWithTimeZone

	| time |
	"
	type := PGTimeWithTimeZoneType instance.
	time := Dialect timestampNow.

	self assert: false. This needs some thought.
	self assert: (self helpTestType: type withValue: time).
	self assert: (type typeString = 'TIME WITH TIME ZONE')"
!

testTypeParametersNotAliased

	| type2 type3 |
	type := (self platform) varchar.
	self assert: type width isNil.
	self assert: (type2 := self platform varChar: 5) width = 5.
	self assert: type width isNil.
	type3 := self platform varChar: 10.
	self assert: type3 width = 10.
	self assert: type2 width = 5.
	self assert: type width isNil.
!

testVarBinary
	"Needs doing"
	self needsWork: 'write the test'.
! !

!GlorpDatabaseTypeDBTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpDatabaseTypeDBTests.st,v 1.1 2006/07/26 08:55:10 boris Exp $'
! !
