"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpDialectTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!

GlorpDialectTest comment:'Tests the portability methods in the Dialect class.'
!


!GlorpDialectTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpDialectTest methodsFor:'tests'!

testBlockArgumentCount
	self assert: (Dialect argumentCountFor: [3]) = 0.
	self assert: (Dialect argumentCountFor: [:a | 3]) = 1.
	self assert: (Dialect argumentCountFor: [:a :b | a <= b]) = 2.
!

testTimeSetMillisecond
	| time oldMs oldSec oldMin newMs |
	Dialect supportsMillisecondsInTimes ifFalse: [^self].
	time := Time now.
	oldMs := time milliseconds.
	oldSec := time seconds truncated.
	oldMin := time minutes.
	newMs := oldMs > 989 ifTrue: [3] ifFalse: [oldMs + 10].
	time millisecond: newMs.
	self assert: time milliseconds = newMs.
	self assert: time seconds truncated = oldSec.
	self assert: time minutes = oldMin.
!

testTokensBasedOn
	self assert: (Dialect tokensBasedOn: '.' in: 'abc.def.ghi') asArray = #('abc' 'def' 'ghi').
! !

!GlorpDialectTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpDialectTest.st,v 1.1 2006/07/26 09:21:07 boris Exp $'
! !
