"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpDatabaseBasedTest subclass:#GlorpDirectMappingTest
	instanceVariableNames:'mapping'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpDirectMappingTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpDirectMappingTest methodsFor:'support'!

setUp
	| descriptor |
	super setUp.
	mapping := DirectMapping from: #id to: ((system tableNamed: 'GR_CUSTOMER') fieldNamed: 'ID').
	descriptor := Descriptor new.
	descriptor classModel: (GlorpClassModel for: GlorpCustomer).
	descriptor addMapping: mapping.
! !

!GlorpDirectMappingTest methodsFor:'tests'!

testExpressionFor
	| cust exp |
	cust := GlorpCustomer new.
	cust id: 12.
	exp := mapping
		expressionFor: cust
		basedOn: BaseExpression new
		relation: #=.
	self assert: exp rightChild class == ConstantExpression.
	self assert: exp rightChild value = 12.
	self assert: exp relation = #=.
	self assert: exp leftChild class == MappingExpression.
! !

!GlorpDirectMappingTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpDirectMappingTest.st,v 1.1 2006/07/26 09:11:39 boris Exp $'
! !
