"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpExpressionBasicPropertiesTest
	instanceVariableNames:'base'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpExpressionBasicPropertiesTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpExpressionBasicPropertiesTest methodsFor:'support'!

setUp

	base := BaseExpression new descriptor: (
		(GlorpDemoDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database)
			descriptorFor: GlorpPerson)
! !

!GlorpExpressionBasicPropertiesTest methodsFor:'tests'!

testHasDescriptorForBase

	| exp |
	self assert: base hasDescriptor.
	exp := [:a | a ] asGlorpExpressionOn: base.
	self assert: exp hasDescriptor.
!

testHasDescriptorForDirect

	| exp |
	exp := [:a | a id ] asGlorpExpressionOn: base.
	self deny: exp hasDescriptor.
!

testHasDescriptorForOneToMany

	| exp |
	exp := [:a | a emailAddresses ] asGlorpExpressionOn: base.
	self assert: exp hasDescriptor.
!

testHasDescriptorForOneToOne

	| exp |
	exp := [:a | a address ] asGlorpExpressionOn: base.
	self assert: exp hasDescriptor.
!

testHasDescriptorForPrimaryKeyExpression

	| exp |
	exp := Join new.
	self deny: exp hasDescriptor.
!

testHasDescriptorForRelation

	| exp |
	exp := [:a | a = 3] asGlorpExpressionOn: base.
	self deny: exp hasDescriptor.
!

testHasDescriptorForTwoLevelDirect

	| exp |
	exp := [:a | a address street] asGlorpExpressionOn: base.
	self deny: exp hasDescriptor.
	self assert: exp base hasDescriptor.
!

testHasDescriptorForUninitializedBase

	self deny: BaseExpression new hasDescriptor.
! !

!GlorpExpressionBasicPropertiesTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpExpressionBasicPropertiesTest.st,v 1.1 2006/07/26 09:17:45 boris Exp $'
! !
