"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpExpressionRebuildingTest
	instanceVariableNames:'original newBase rebuilt'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpExpressionRebuildingTest methodsFor:'support'!

setUp
	super setUp.
	newBase := BaseExpression new.
! !

!GlorpExpressionRebuildingTest methodsFor:'tests'!

testLoneBase
	original := BaseExpression new.
	rebuilt := original rebuildOn: newBase.
	self assert: rebuilt == newBase.
!

testMapping
	original := [:each | each foo] asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	self assert: rebuilt base == newBase.
!

testRelation
	original := [:each | each foo bar = each foo bletch] asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	self assert: rebuilt ultimateBaseExpression == newBase.
	self assert: rebuilt leftChild ultimateBaseExpression == newBase.
	self assert: rebuilt rightChild ultimateBaseExpression == newBase.
	self assert: rebuilt leftChild base base == newBase.
! !

!GlorpExpressionRebuildingTest methodsFor:'tests-outer scope references'!

testRebuildDoubleInnerScopeNormallyWithExists
	original := [:each |
	each foo
		anySatisfyExists:
			[:eachFoo | eachFoo things anySatisfyExists: [:eachThing | eachThing stuff = each fooThing]]]
		asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	rebuilt do: [:each | self assert: each ultimateBaseExpression == newBase].
!

testRebuildDoubleInnerScopeNormallyWithJoins
	original := [:each |
	each foo
		anySatisfyJoin:
			[:eachFoo | eachFoo things anySatisfyJoin: [:eachThing | eachThing stuff = each fooThing]]]
		asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	rebuilt do: [:each | self assert: each ultimateBaseExpression == newBase].
!

testRebuildInnerScopeForSubquery

	| foo |
	original := [:each | each foo anySatisfyJoin: [:eachFoo | eachFoo thing = each fooThing]] asGlorpExpression.
	"Just so that it prints distinctively"
	original ultimateBaseExpression descriptor: (Descriptor new classModel: (GlorpClassModel for: Object)).
	foo := original leftChild.
	newBase := SubSelectBaseExpression on: foo.
	rebuilt := original rightChild rebuildOn: newBase startingFrom: foo.
	self assert: rebuilt leftChild base == newBase.
	self assert: rebuilt leftChild ultimateBaseExpression == original ultimateBaseExpression.
	self assert: rebuilt rightChild base == original ultimateBaseExpression.
!

testRebuildInnerScopeNormally
	original := [:each | each foo anySatisfy: [:eachFoo | eachFoo thing = each fooThing]]
		asGlorpExpression.
	rebuilt := original rebuildOn: newBase.
	rebuilt do: [:each | self assert: each ultimateBaseExpression == newBase].
!

testRebuildMappingWithStart

	original := [:each | each foo bar] asGlorpExpression.
	rebuilt := original rebuildOn: newBase startingFrom: original base.
	self assert: rebuilt base == newBase.
! !

!GlorpExpressionRebuildingTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpExpressionRebuildingTest.st,v 1.1 2006/07/26 09:05:30 boris Exp $'
! !
