"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpDemoDescriptorSystem subclass:#GlorpLinkTableAnywhereDescriptorSystem
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!

GlorpLinkTableAnywhereDescriptorSystem comment:'This is the same as the demo descriptor system, but with small modifications to use link tables in different places.

'
!


!GlorpLinkTableAnywhereDescriptorSystem methodsFor:'descriptors/bank'!

classModelForGlorpCustomer: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #transactions collectionOf: GlorpBankTransaction.
	"Note: accounts is a 1-1 in this model"
	aClassModel newAttributeNamed: #accounts type: GlorpBankAccount.
	aClassModel newAttributeNamed: #accountsSortedById collectionOf: GlorpBankAccount.
	aClassModel newAttributeNamed: #accountsSortedByIdDescending collectionOf: GlorpBankAccount.
!

descriptorForGlorpCustomer: aDescriptor

	| table |
	table := self tableNamed: 'GR_CUSTOMER'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name to: (table fieldNamed: 'NAME').
	(aDescriptor newMapping: OneToManyMapping)
			attributeName: #transactions;
			referenceClass: GlorpBankTransaction.
	(aDescriptor newMapping: OneToOneMapping)
			attributeName: #accounts;
			referenceClass: GlorpBankAccount;
			usesLinkTable: true.
! !

!GlorpLinkTableAnywhereDescriptorSystem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpLinkTableAnywhereDescriptorSystem.st,v 1.1 2006/07/26 09:07:13 boris Exp $'
! !
