"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpMessageCollectorTest
	instanceVariableNames:'collector'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpMessageCollectorTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpMessageCollectorTest methodsFor:'support'!

setUp
	super setUp.
	collector := MessageArchiver new
! !

!GlorpMessageCollectorTest methodsFor:'tests'!

dNUException
        Dialect isSmalltalkX ifTrue: [^Smalltalk at: #ResumableTestFailure].
        ^Dialect isVisualAge
                ifTrue: [(Smalltalk at: #SystemExceptions) at: 'ExAll']
                ifFalse: [MessageNotUnderstood].
!

messageCollectorDNUObjectStudio
	| caught |
	caught := false.
	[collector basicDoesNotUnderstand: #foo args: #()] on: self dNUException
		do: [:signal | caught := true. signal sunitExitWith: nil].
	self assert: caught
!

testExpressionCreation
	| exp |
	exp := collector foo asGlorpExpression.
	self assert: exp name == #foo.
	self assert: exp base class == BaseExpression
!

testMessageCollectorDNU
        | message caught |
        Dialect isObjectStudio ifTrue: [
                ^self messageCollectorDNUObjectStudio].
        message := Message selector: #foo arguments: #().
        caught := false.
        [collector basicDoesNotUnderstand: message] on: MessageNotUnderstood "self dNUException"
                do: [:signal | caught := true. signal sunitExitWith: nil].
        self assert: caught
!

testMessageIntercept

	| foo |
	foo := collector foo.
	self assert: foo privateGlorpSelector == #foo.
	self assert: foo privateGlorpReceiver == collector.
! !

!GlorpMessageCollectorTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpMessageCollectorTest.st,v 1.1 2006/07/26 09:10:33 boris Exp $'
! !
