"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpSession subclass:#GlorpMockSession
	instanceVariableNames:'rows'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpMockSession class methodsFor:'instance creation'!

new

	^super new initialize.
! !

!GlorpMockSession class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpMockSession methodsFor:'accessing'!

accessor
	^GlorpMockAccessor new.
!

rows

	^rows.
! !

!GlorpMockSession methodsFor:'initialize'!

initialize

	super initialize.
	rows := OrderedCollection new.
! !

!GlorpMockSession methodsFor:'read/write'!

writeHomogeneousRows: aCollection
	aCollection do: [:each | self writeRow: each].
	^true.
!

writeRow: aRow
	aRow shouldBeWritten ifFalse: [^true].
	aRow preWriteAssignSequencesUsing: self accessor.
	rows add: aRow.
	aRow postWriteAssignSequencesUsing: self accessor.
	^true.
! !

!GlorpMockSession methodsFor:'testing'!

useBinding
	^true.
! !

!GlorpMockSession class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpMockSession.st,v 1.1 2006/07/26 09:11:33 boris Exp $'
! !
