"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpSessionBasedTest subclass:#GlorpObjectMappedToFunctionTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpDBTests'
!


!GlorpObjectMappedToFunctionTest methodsFor:'support'!

setUp
	| accountRow3 |
	super setUp.
	session beginTransaction.
	system writeCustomer1Rows.
	accountRow3 := system exampleAccountRow3.
	session writeRow: accountRow3.
!

tearDown
	session rollbackTransaction.
	super tearDown.
!

testRelationships
	| branch accounts |
	branch := session readOneOf: GlorpBankBranch where: [:each | each branchNumber = 2].
	accounts := branch accounts yourself.
	self assert: accounts size = 1.
	self assert: accounts first id = 9874.
! !

!GlorpObjectMappedToFunctionTest methodsFor:'tests'!

testBasicRead
	| branches |
	branches := session readManyOf: GlorpBankBranch.
	self assert: branches size = 3.
	self assert: (branches collect: [:each | each branchNumber]) asSortedCollection = #(2 3 712) asSortedCollection.
!

testCache
	| branches branch2 branch3 |
	branches := session readManyOf: GlorpBankBranch.
	branch2 := session readOneOf: GlorpBankBranch where: [:each | each branchNumber = 2].
	branch3 := session readOneOf: GlorpBankBranch where: [:each | each branchNumber = 3].
	self deny: branch2 == branch3.
	self assert: (branches includes: branch2).
	self assert: (branches includes: branch3).
!

testNoWriteValidation
	| |
	(session system descriptorFor: GlorpBankBranch) mappings next readOnly: false.
	self should: [session system validate] raise: Dialect error.
!

testReadQueryingAttributes
	| branches |
	branches := session readManyOf: GlorpBankBranch where: [:each |
		each accounts anySatisfy: [:eachAccount |
			eachAccount accountNumber accountNumber in: #( '3' '4')]].
	self assert: branches size = 2.
	self assert: branches asSet size = 2.
! !

!GlorpObjectMappedToFunctionTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpObjectMappedToFunctionTest.st,v 1.1 2006/07/26 08:57:24 boris Exp $'
! !
