"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpPerson
	instanceVariableNames:'id name address emailAddresses'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest-Domain Models'
!


!GlorpPerson class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpPerson class methodsFor:'examples'!

example1

	^self new
		id: 1;
		name: 'Zaphod Beeblebrox';
		address: GlorpAddress example1.
!

example1WithChangedAddress

	^self new
		id: 1;
		name: 'Zaphod Beeblebrox';
		address: GlorpAddress example1WithChangedAddress.
!

example1WithDifferentAddress

	^self new
		id: 1;
		name: 'Zaphod Beeblebrox';
		address: GlorpAddress example2.
!

example1WithDifferentName

	^self new
		id: 1; 
		name: 'John Doe';
		address: GlorpAddress example1.
!

example1WithNoAddress

	^self new
		id: 1;
		name: 'Zaphod Beeblebrox';
		address: nil.
!

example2

	^self new
		id: 2;
		name: 'John Doe';
		address: GlorpAddress example2.
! !

!GlorpPerson methodsFor:'accessing'!

address
	"Private - Answer the value of the receiver's ''address'' instance variable."

	^address
!

address: anObject
	"Private - Set the value of the receiver's ''address'' instance variable to the argument, anObject."

	address := anObject
!

emailAddresses
	^emailAddresses
!

emailAddresses: aCollection
	emailAddresses := aCollection
!

id
	"Private - Answer the value of the receiver's ''id'' instance variable."

	^id
!

id: anObject
	"Private - Set the value of the receiver's ''id'' instance variable to the argument, anObject."

	id := anObject
!

name
	"Private - Answer the value of the receiver's ''name'' instance variable."

	^name
!

name: anObject
	"Private - Set the value of the receiver's ''name'' instance variable to the argument, anObject."

	name := anObject
! !

!GlorpPerson methodsFor:'printing'!

printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '('.
	aStream nextPutAll: id printString, ',', name printString.
	aStream nextPutAll: ')'.
! !

!GlorpPerson class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpPerson.st,v 1.1 2006/07/26 09:15:25 boris Exp $'
! !
