"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpProxyTest
	instanceVariableNames:'session proxy'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpProxyTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpProxyTest class methodsFor:'resources'!

resources

	^Array with: GlorpSessionResource.
! !

!GlorpProxyTest methodsFor:'support'!

setUp

	| stub |
	super setUp.
	session := GlorpSessionResource current newSession.
	proxy := Proxy new.
	proxy session: session.
	stub := GlorpQueryStub returningOneOf: GlorpAddress where: [:address | address id = 1].
	stub result: 42.
	proxy query: stub.
	proxy parameters: #().
! !

!GlorpProxyTest methodsFor:'tests'!

testAdHocProxy

        | p |  
        p := Glorp::AdHocProxy readBlock: ['instantiated!!'].
        self assert: p printString = '{uninstantiated AdHocProxy}'.
        self assert: p isInstantiated not.
        p yourSelf.
        self assert: p isInstantiated.
        self assert: p printString = '{''instantiated!!''}'.
        p uninstantiate.
        self deny: p isInstantiated.
!

testCreation
	| otherProxy |
	self deny: proxy isInstantiated.
	otherProxy := Proxy new.
	self deny: otherProxy isInstantiated.
!

testInstantiationFromStub

	self assert: (proxy getValue notNil).
	self assert: proxy = 42.
	self assert: proxy isInstantiated.
!

testPrintingInstantiated

	proxy getValue.
	self assert: proxy printString = ('{', proxy getValue printString, '}').
!

testPrintingUninstantiated

	self assert: proxy printString = '{uninstantiated GlorpAddress}'.
!

testPrintingUninstantiatedCollection
	proxy query readsOneObject: false.
	self assert: proxy printString = '{uninstantiated collection of GlorpAddress}'.
! !

!GlorpProxyTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpProxyTest.st,v 1.1 2006/07/26 09:12:58 boris Exp $'
! !
