"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpDatabaseBasedTest subclass:#GlorpQueryCopyingTest
	instanceVariableNames:'query expression elementBuilder session newQuery'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpQueryCopyingTest class methodsFor:'resources'!

resources
	^Array with: GlorpSessionResource.
! !

!GlorpQueryCopyingTest methodsFor:'As yet unclassified'!

tableAliasesPresentFor: aQuery
	aQuery whereClause detect: [:each | each hasTableAliases] ifNone: [^false].
	^true.
! !

!GlorpQueryCopyingTest methodsFor:'support'!

setUp
	super setUp.
	query := Query returningManyOf: GlorpCustomer.
	query whereClause: [:each | each accounts anySatisfy: [:foo | foo id = 12]].
	session := GlorpSessionResource current newSession.
	query session: session.
! !

!GlorpQueryCopyingTest methodsFor:'tests'!

testExpressionTableAliases
	query prepare.
	newQuery := query copy.
	self assert: (self tableAliasesPresentFor: query).
	self deny: (self tableAliasesPresentFor: newQuery).
!

testPreparedness
	self deny: query isPrepared.
	query prepare.
	newQuery := query copy.
	self assert: query isPrepared.
	self deny: newQuery isPrepared.
! !

!GlorpQueryCopyingTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpQueryCopyingTest.st,v 1.1 2006/07/26 09:13:11 boris Exp $'
! !
