"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpDatabaseBasedTest subclass:#GlorpQueryTableAliasingTest
	instanceVariableNames:'query expression elementBuilder session'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpQueryTableAliasingTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpQueryTableAliasingTest methodsFor:'support'!

helpTestPrintingWhereClause: anExpression
	| command |
	query
		initResultClass: GlorpCustomer
		whereClause: expression
		singleObject: true.
	query setupTracing.
	query computeFields.
	command := GlorpNullCommand useBinding: false platform: system platform.
	anExpression
		printSQLOn: command
		withParameters: Dictionary new.
	^command sqlString.
!

setUp
	super setUp.
	query := SimpleQuery new.
	expression := BaseExpression new.
	expression descriptor: (system descriptorFor: GlorpCustomer).
	elementBuilder := ObjectBuilder for: expression in: query.
	expression aliasTable: (system tableNamed: 'GR_CUSTOMER') to: 't1'.
	session := GlorpSession new.
	session system: system.
	query session: system session.
! !

!GlorpQueryTableAliasingTest methodsFor:'tests'!

testAliasWithEmbeddedMapping

	self unfinished.
!

testBuildingObject

	| customer |
	elementBuilder instance: GlorpCustomer new.
	elementBuilder requiresPopulating: true.
	elementBuilder buildObjectFrom: #(12 'Name').
	customer := elementBuilder instance.
	self assert: customer class == GlorpCustomer.
	self assert: customer id = 12.
	self assert: customer name = 'Name'.
!

testElementBuilderFields
	elementBuilder fieldsForSelectStatement
		do: [:each | self assert: each table name = 't1']
!

testExpressionTableAlias
	| fields |
	fields := expression translateFields: expression descriptor mappedFields.
	fields do: [:each | self assert: each table name = 't1']
!

testQueryPrintingFields
	| stream |
	query
		initResultClass: GlorpCustomer
		whereClause: expression
		singleObject: true.
	query limit: nil.
	query setupTracing.
	query computeFields.
	stream := String new writeStream.
	query printSelectFieldsOn: stream.
	self assert: stream contents = 't1.ID, t1.NAME'
!

testQueryPrintingSimpleWhereClause
	| string |
	string := self helpTestPrintingWhereClause: ((expression get: #name) get: #= withArguments: #('Fred')).
	self assert: string = '(t1.NAME = ''Fred'')'
!

testQueryPrintingTables
	| stream string |
	query
		initResultClass: GlorpCustomer
		whereClause: expression
		singleObject: true.
	query setupTracing.
	query computeFields.
	stream := String new writeStream.
	query printTablesOn: stream.
	string := stream contents.
	self assert: string = '
 FROM GR_CUSTOMER t1'
! !

!GlorpQueryTableAliasingTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpQueryTableAliasingTest.st,v 1.1 2006/07/26 09:18:58 boris Exp $'
! !
