"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpReadingDifferentCollectionsTest
	instanceVariableNames:'system session singleQuery allQuery singleResult allResult'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpReadingDifferentCollectionsTest methodsFor:'setup'!

setUp

	| |
	super setUp.
	session := GlorpSessionResource current newSession.
	system := session system.
	session beginTransaction.
	self writeAccountRows.
	singleQuery := Query returningManyOf: GlorpBankAccount
				where: [:passenger | passenger id = 6].
	allQuery := Query returningManyOf: GlorpBankAccount.
!

tearDown

	session rollbackTransaction.
!

writeAccountRows
	| accountRow1 accountRow2 |

	accountRow1 := session system exampleAccountRow1.
	accountRow2 := session system exampleAccountRow2.
	session writeRow: accountRow1.
	session writeRow: accountRow2.
! !

!GlorpReadingDifferentCollectionsTest methodsFor:'tests'!

check: aClass
	singleQuery collectionType: aClass.
	allQuery collectionType: aClass.
	singleResult := session execute: singleQuery.
	allResult := session execute: allQuery.
	self assert: singleResult class == aClass.
	self assert: allResult class == aClass.
	self assert: singleResult size = 1.
	self assert: allResult size = 2.
!

testArray
	self check: Array.
!

testBlank
	singleResult := session execute: singleQuery.
	allResult := session execute: allQuery.
	self assert: singleResult class == Array.
	self assert: allResult class == Array.
	self assert: singleResult size = 1.
	self assert: allResult size = 2.
!

testOrderedCollection
	self check: OrderedCollection.
!

testSet
	self check: Set.
!

testSortedCollection
	self check: SortedCollection.
! !

!GlorpReadingDifferentCollectionsTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpReadingDifferentCollectionsTest.st,v 1.1 2006/07/26 09:08:56 boris Exp $'
! !
