"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestCase subclass:#GlorpRowMapForMementosCollectionTest
	instanceVariableNames:'transaction rowMap collection newCollection copy'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTestModels'
!


!GlorpRowMapForMementosCollectionTest methodsFor:'support'!

setUp
	transaction := ObjectTransaction new.
	rowMap := nil.
! !

!GlorpRowMapForMementosCollectionTest methodsFor:'tests'!

createRowMap
	rowMap := RowMapForMementos withCorrespondenceMap: transaction undoMap.
	rowMap collectionMementos: transaction collectionMementos.
	newCollection := rowMap collectionMementoFor: collection.
!

testArray
	collection := Array with: 1 with: 2 with: 3 with: 4.
	copy := collection copy.
	transaction register: collection.
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection = copy.
!

testDictionary
	collection := Dictionary new.
	1 to: 50 do: [:i | collection at: i put: i printString].
	copy := collection copy.
	transaction register: collection.
	#( 1 2 7 43 15 9 10 17 18 19 33 23) do: [:i | collection removeKey: i].
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection size = copy size.
	self assert: newCollection keys asSortedCollection = copy keys asSortedCollection.
	self assert: newCollection values asSortedCollection = copy values asSortedCollection.
!

testIdentityDictionary
	collection := IdentityDictionary new.
	1 to: 50 do: [:i | collection at: i put: i printString].
	copy := collection copy.
	transaction register: collection.
	#( 1 2 7 43 15 9 10 17 18 19 33 23) do: [:i | collection removeKey: i].
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection size = copy size.
	self assert: newCollection keys asSortedCollection = copy keys asSortedCollection.
	self assert: newCollection values asSortedCollection = copy values asSortedCollection.
!

testOrderedCollection
	collection := (1 to: 50) asOrderedCollection.
	copy := collection copy.
	transaction register: collection.
	12 timesRepeat: [collection removeLast].
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection = copy.
!

testOrderedSet
	collection := (Dialect smalltalkAt: #OrderedSet ifAbsent: [^self]) new.
	1 to: 50 do: [:i | collection add: i].
	copy := collection copy.
	transaction register: collection.
	#( 1 2 7 43 15 9 10 17 18 19 33 23) do: [:i | collection remove: i].
	collection add: 999.
	self createRowMap.
	self assert: newCollection asSortedCollection = copy asSortedCollection.
!

testRBSmallDictionary
	collection := (Dialect smalltalkAt: #RBSmallDictionary ifAbsent: [^self]) new.
	1 to: 50 do: [:i | collection at: i put: i printString].
	copy := collection copy.
	transaction register: collection.
	#( 1 2 7 43 15 9 10 17 18 19 33 23) do: [:i | collection removeKey: i].
	collection at: 3 put: 'hello'.
	self createRowMap.
	self assert: newCollection size = copy size.
	self assert: newCollection keys asSortedCollection = copy keys asSortedCollection.
	self assert: newCollection values asSortedCollection = copy values asSortedCollection.
!

testSet
	collection := (1 to: 50) asSet.
	copy := collection copy.
	transaction register: collection.
	1 to: 12 do: [:i | collection remove: i].
	collection add: 'hello'.
	self createRowMap.
	self assert: newCollection asSortedCollection = copy asSortedCollection.
! !

!GlorpRowMapForMementosCollectionTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpRowMapForMementosCollectionTest.st,v 1.1 2006/07/26 09:10:57 boris Exp $'
! !
