"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpSessionBasedTest subclass:#GlorpSelectCommandTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTests'
!


!GlorpSelectCommandTest methodsFor:'support'!

setUp

  super setUp.
  self setUpTable.
!

setUpTable
     | acc |
  acc := session accessor.
  acc setAutocommit.
  acc
     execute:
        [ acc executeSQLStringNoResult: 'ALTER TABLE STUFF DROP CONSTRAINT STUFF_PK'.]
     ifError: [:ex | ex return: nil].

  acc
     execute:
        [ acc executeSQLStringNoResult: 'DROP TABLE STUFF'.]
     ifError: [:ex | ex return: nil].

   acc executeSQLStringNoResult: 
     'CREATE TABLE STUFF
        (ID integer NOT NULL,
         THING varchar(20) NULL,
         CONSTRAINT STUFF_PK PRIMARY KEY (ID)
         )'.
        acc executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (12,''abc'')'.
        acc executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (13, ''hey nonny nonny'')'.
        acc executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (42, ''yabba dabba doo'')'.
        acc executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (9625, ''the band played on'')'.
        acc executeSQLStringNoResult: 'INSERT INTO STUFF VALUES (113141, ''Smalltalk'')'.


  acc clearAutocommit.
! !

!GlorpSelectCommandTest methodsFor:'tests'!

testExecute
	| command dict result string |
	dict := #('abc' 'Smalltalk').
	string := session useBinding
		ifTrue: ['SELECT ID FROM STUFF WHERE THING=? OR THING = ?']
		ifFalse:
			['SELECT ID FROM STUFF WHERE THING=''abc'' OR THING = ''Smalltalk'''].
	command := SQLStringSelectCommand
		sqlString: string
		parameters: dict
		useBinding: session useBinding
		platform: session platform.
	result := session accessor executeCommand: command.
	self assert: result size = 2.
	self assert: result first first = 12.
	self assert: result last first = 113141.
! !

!GlorpSelectCommandTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpSelectCommandTest.st,v 1.1 2006/07/26 09:16:01 boris Exp $'
! !
