"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

TestResource subclass:#GlorpSessionResource
	instanceVariableNames:'session'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest'
!


!GlorpSessionResource class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpSessionResource class methodsFor:'resources'!

resources

	^Array with: GlorpDatabaseLoginResource with: GlorpDemoTablePopulatorResource.
! !

!GlorpSessionResource methodsFor:'accessing'!

newSession

	self setUp.
	^self session.
!

session

	^session.
! !

!GlorpSessionResource methodsFor:'setup'!

glorpTestsSystem
	"We want to prep the GlorpDemoTablePopulatorResource but subclasses using different systems may not;  put it here where it will be overridden."

	GlorpDemoTablePopulatorResource current.
	^GlorpDemoDescriptorSystem forPlatform: GlorpDatabaseLoginResource defaultLogin database
!

setUp
	| login |
	super setUp.
	login := GlorpDatabaseLoginResource current.
	session := GlorpSession new.
	session system: self glorpTestsSystem.
	session accessor: login accessor
! !

!GlorpSessionResource class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpSessionResource.st,v 1.1 2006/07/26 09:17:33 boris Exp $'
! !
