"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpStudentTestDescriptorSystem subclass:#GlorpStudentExampleDescriptorSystem
	instanceVariableNames:''
	classVariableNames:'Default'
	poolDictionaries:''
	category:'GlorpTest-StudentDatabase'
!

GlorpStudentExampleDescriptorSystem comment:'This class provides the description for the Student database.'
!


!GlorpStudentExampleDescriptorSystem class methodsFor:'accessing'!

default
	Default isNil ifTrue: [Default := self new].
	^Default
!

dropDefault
        "Glorp::GlorpStudentExampleDescriptorSystem dropDefault"
        Default := nil.
! !

!GlorpStudentExampleDescriptorSystem methodsFor:'class models'!

classModelForGlorpSDBCourses: aClassModel

    aClassModel
      newAttributeNamed: #courseId;
      newAttributeNamed: #courseName;
      newAttributeNamed: #department;
      newAttributeNamed: #numCredits.
!

classModelForGlorpSDBEnrolls: aClassModel

    aClassModel
      newAttributeNamed: #courseId type: GlorpSDBCourses;
      newAttributeNamed: #sectionId type: GlorpSDBSections;
      newAttributeNamed: #studentId type: GlorpSDBStudents;
      newAttributeNamed: #grade.
!

classModelForGlorpSDBSections: aClassModel

    aClassModel
      newAttributeNamed: #sectionId;
      newAttributeNamed: #teacherId type: GlorpSDBTeachers;
      newAttributeNamed: #courseId type: GlorpSDBCourses;
      newAttributeNamed: #numStudents.
!

classModelForGlorpSDBStudents: aClassModel

    aClassModel
      newAttributeNamed: #studentId;
      newAttributeNamed: #studentName;
      newAttributeNamed: #address;
      newAttributeNamed: #zip;
      newAttributeNamed: #city;
      newAttributeNamed: #state;
      newAttributeNamed: #sex.
!

classModelForGlorpSDBTeachers: aClassModel

    aClassModel
      newAttributeNamed: #teacherId;
      newAttributeNamed: #teacherName;
      newAttributeNamed: #phone;
      newAttributeNamed: #salary.
! !

!GlorpStudentExampleDescriptorSystem methodsFor:'database objects'!

allTableNames

  ^#('ENROLLS' 'TEACHERS' 'COURSES' 'SECTIONS' 'STUDENTS')
!

constructAllClasses
	^(super constructAllClasses)
	 	add: GlorpSDBCourses;
		add: GlorpSDBEnrolls;
		add: GlorpSDBSections;
		add: GlorpSDBStudents;
		add: GlorpSDBTeachers;
		yourself.
! !

!GlorpStudentExampleDescriptorSystem methodsFor:'example data'!

exampleCourseRows

  | collection courseTable row |

  collection := OrderedCollection new: 4.

  courseTable := self tableNamed: 'COURSES'.
  
  row := DatabaseRow newForTable: courseTable.
  row at: (courseTable fieldNamed: 'COURSE_ID') put: 450.
  row at: (courseTable fieldNamed: 'COURSE_NAME') put: 'Western Civilization'.
  row at: (courseTable fieldNamed: 'DEPARTMENT') put: 'History'.
  row at: (courseTable fieldNamed: 'NUM_CREDITS') put: 3.
  collection add: row.
  
 
  row := DatabaseRow newForTable: courseTable.
  row at: (courseTable fieldNamed: 'COURSE_ID') put: 730.
  row at: (courseTable fieldNamed: 'COURSE_NAME') put: 'Calculus IV'.
  row at: (courseTable fieldNamed: 'DEPARTMENT') put: 'Math'.
  row at: (courseTable fieldNamed: 'NUM_CREDITS') put: 4.
  collection add: row.

 
  row := DatabaseRow newForTable: courseTable.
  row at: (courseTable fieldNamed: 'COURSE_ID') put: 290.
  row at: (courseTable fieldNamed: 'COURSE_NAME') put: 'English Composition'.
  row at: (courseTable fieldNamed: 'DEPARTMENT') put: 'English'.
  row at: (courseTable fieldNamed: 'NUM_CREDITS') put: 3.
  collection add: row.

 
  row := DatabaseRow newForTable: courseTable.
  row at: (courseTable fieldNamed: 'COURSE_ID') put: 480.
  row at: (courseTable fieldNamed: 'COURSE_NAME') put: 'Compiler Writing'.
  row at: (courseTable fieldNamed: 'DEPARTMENT') put: 'Computer Science'.
  row at: (courseTable fieldNamed: 'NUM_CREDITS') put: 3.
  collection add: row.

  ^collection.
!

exampleEnrollRows

  | collection enrollTable row |

  collection := OrderedCollection new: 18.

  enrollTable := self tableNamed: 'ENROLLS'.
  
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 730.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 148.
  row at: (enrollTable fieldNamed: 'GRADE') put: 3.
  collection add: row.
  
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 450.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 2.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 210.
  row at: (enrollTable fieldNamed: 'GRADE') put: 3.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 730.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 210.
  row at: (enrollTable fieldNamed: 'GRADE') put: 1.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 290.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 298.
  row at: (enrollTable fieldNamed: 'GRADE') put: 3.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 480.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 2.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 298.
  row at: (enrollTable fieldNamed: 'GRADE') put: 3.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 730.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 348.
  row at: (enrollTable fieldNamed: 'GRADE') put: 2.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 290.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 349.
  row at: (enrollTable fieldNamed: 'GRADE') put: 4.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 480.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 358.
  row at: (enrollTable fieldNamed: 'GRADE') put: 4.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 480.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 410.
  row at: (enrollTable fieldNamed: 'GRADE') put: 2.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 450.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 473.
  row at: (enrollTable fieldNamed: 'GRADE') put: 2.
  collection add: row.

 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 730.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 473.
  row at: (enrollTable fieldNamed: 'GRADE') put: 3.
   collection add: row.

  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 480.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 2.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 473.
  row at: (enrollTable fieldNamed: 'GRADE') put: 0.
  collection add: row.
 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 290.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 548.
  row at: (enrollTable fieldNamed: 'GRADE') put: 2. 
  collection add: row.

  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 730.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 558.
  row at: (enrollTable fieldNamed: 'GRADE') put: 3.
  collection add: row.
 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 730.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 649.
  row at: (enrollTable fieldNamed: 'GRADE') put: 4.
  collection add: row.
 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 480.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 649.
  row at: (enrollTable fieldNamed: 'GRADE') put: 4.
  collection add: row.
 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 450.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 654.
  row at: (enrollTable fieldNamed: 'GRADE') put: 4.
  collection add: row.
 
  row := DatabaseRow newForTable: enrollTable.
  row at: (enrollTable fieldNamed: 'COURSE_ID') put: 450.
  row at: (enrollTable fieldNamed: 'SECTION_ID') put: 2.
  row at: (enrollTable fieldNamed: 'STUDENT_ID') put: 548.
 " row at: (enrollTable fieldNamed: 'GRADE') put: 'NULL'. "

  collection add: row.

  ^collection.
!

exampleSectionRows

  | collection sectionTable row |

  collection := OrderedCollection new: 6.

  sectionTable := self tableNamed: 'SECTIONS'.
  
  row := DatabaseRow newForTable: sectionTable.
  row at: (sectionTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (sectionTable fieldNamed: 'TEACHER_ID') put: 303.
  row at: (sectionTable fieldNamed: 'COURSE_ID') put: 450.
  row at: (sectionTable fieldNamed: 'NUM_STUDENTS') put: 2.
  collection add: row.
  
  row := DatabaseRow newForTable: sectionTable.
  row at: (sectionTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (sectionTable fieldNamed: 'TEACHER_ID') put: 290.
  row at: (sectionTable fieldNamed: 'COURSE_ID') put: 730.
  row at: (sectionTable fieldNamed: 'NUM_STUDENTS') put: 6.
  collection add: row.
  
   row := DatabaseRow newForTable: sectionTable.
  row at: (sectionTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (sectionTable fieldNamed: 'TEACHER_ID') put: 430.
  row at: (sectionTable fieldNamed: 'COURSE_ID') put: 290.
  row at: (sectionTable fieldNamed: 'NUM_STUDENTS') put: 3.
  collection add: row.

  row := DatabaseRow newForTable: sectionTable.
  row at: (sectionTable fieldNamed: 'SECTION_ID') put: 1.
  row at: (sectionTable fieldNamed: 'TEACHER_ID') put: 180.
  row at: (sectionTable fieldNamed: 'COURSE_ID') put: 480.
  row at: (sectionTable fieldNamed: 'NUM_STUDENTS') put: 3.
  collection add: row.
  
  row := DatabaseRow newForTable: sectionTable.
  row at: (sectionTable fieldNamed: 'SECTION_ID') put: 2.
  row at: (sectionTable fieldNamed: 'TEACHER_ID') put: 560.
  row at: (sectionTable fieldNamed: 'COURSE_ID') put: 450.
  row at: (sectionTable fieldNamed: 'NUM_STUDENTS') put: 2.
  collection add: row.
  
  row := DatabaseRow newForTable: sectionTable.
  row at: (sectionTable fieldNamed: 'SECTION_ID') put: 2.
  row at: (sectionTable fieldNamed: 'TEACHER_ID') put: 784.
  row at: (sectionTable fieldNamed: 'COURSE_ID') put: 480.
  row at: (sectionTable fieldNamed: 'NUM_STUDENTS') put: 2.
  collection add: row.
  

  

  ^collection.
!

exampleStudentRows

  | collection studentTable row |

  collection := OrderedCollection new: 12.

  studentTable := self tableNamed: 'STUDENTS'.
  
  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 148.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Susan Powell'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '534 East River Dr'.
  row at: (studentTable fieldNamed: 'ZIP') put: '19041'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Haverford'.
  row at: (studentTable fieldNamed: 'STATE') put: 'PA'.
  row at: (studentTable fieldNamed: 'SEX') put: 'F'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 210.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Bob Dawson'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '120 South Jefferson'.
  row at: (studentTable fieldNamed: 'ZIP') put: '02891'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Newport'.
  row at: (studentTable fieldNamed: 'STATE') put: 'RI'.
  row at: (studentTable fieldNamed: 'SEX') put: 'M'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 298.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Howard Mansfield'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '290 Wynkoop Drive'.
  row at: (studentTable fieldNamed: 'ZIP') put: '22180'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Vienna'.
  row at: (studentTable fieldNamed: 'STATE') put: 'VA'.
  row at: (studentTable fieldNamed: 'SEX') put: 'M'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 348.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Susan Pugh'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '534 East Hampton Dr.'.
  row at: (studentTable fieldNamed: 'ZIP') put: '06107'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Hartford'.
  row at: (studentTable fieldNamed: 'STATE') put: 'CN'.
  row at: (studentTable fieldNamed: 'SEX') put: 'F'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 349.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Joe Adams'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '473 Emmerson Street'.
  row at: (studentTable fieldNamed: 'ZIP') put: '19702'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Newark'.
  row at: (studentTable fieldNamed: 'STATE') put: 'DE'.
  row at: (studentTable fieldNamed: 'SEX') put: 'M'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 354.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Janet Ladd'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '441 10th Street'.
  row at: (studentTable fieldNamed: 'ZIP') put: '18073'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Pennsburg'.
  row at: (studentTable fieldNamed: 'STATE') put: 'PA'.
  row at: (studentTable fieldNamed: 'SEX') put: 'F'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 358.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Claire Brown'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '31 12th Street'.
  row at: (studentTable fieldNamed: 'ZIP') put: '18081'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Pennsburg'.
  row at: (studentTable fieldNamed: 'STATE') put: 'PA'.
  row at: (studentTable fieldNamed: 'SEX') put: 'F'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 410.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Bill Jones'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '120 South Harrison'.
  row at: (studentTable fieldNamed: 'ZIP') put: '92660'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Newport'.
  row at: (studentTable fieldNamed: 'STATE') put: 'CA'.
  row at: (studentTable fieldNamed: 'SEX') put: 'M'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 473.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Carol Dean'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '983 Park Avenue'.
  row at: (studentTable fieldNamed: 'ZIP') put: '02169'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Boston'.
  row at: (studentTable fieldNamed: 'STATE') put: 'MA'.
  row at: (studentTable fieldNamed: 'SEX') put: 'F'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 548.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Allen Thomas'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '238 West Ox Road'.
  row at: (studentTable fieldNamed: 'ZIP') put: '60624'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Chicago'.
  row at: (studentTable fieldNamed: 'STATE') put: 'IL'.
  row at: (studentTable fieldNamed: 'SEX') put: 'M'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 558.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Val Shipp'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '238 Westport Road'.
  row at: (studentTable fieldNamed: 'ZIP') put: '60556'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Chicago'.
  row at: (studentTable fieldNamed: 'STATE') put: 'IL'.
  row at: (studentTable fieldNamed: 'SEX') put: 'F'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 649.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'John Anderson'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '473 Emmory Street'.
  row at: (studentTable fieldNamed: 'ZIP') put: '10008'.
  row at: (studentTable fieldNamed: 'CITY') put: 'New York'.
  row at: (studentTable fieldNamed: 'STATE') put: 'NY'.
  row at: (studentTable fieldNamed: 'SEX') put: 'M'.
  collection add: row.

  row := DatabaseRow newForTable: studentTable.
  row at: (studentTable fieldNamed: 'STUDENT_ID') put: 654.
  row at: (studentTable fieldNamed: 'STUDENT_NAME') put: 'Janet Thomas'.
  row at: (studentTable fieldNamed: 'ADDRESS') put: '441 6th Street'.
  row at: (studentTable fieldNamed: 'ZIP') put: '16510'.
  row at: (studentTable fieldNamed: 'CITY') put: 'Erie'.
  row at: (studentTable fieldNamed: 'STATE') put: 'PA'.
  row at: (studentTable fieldNamed: 'SEX') put: 'F'.
  collection add: row.


  ^collection.
!

exampleTeacherRows

  | collection teacherTable row |

  collection := OrderedCollection new: 6.

  teacherTable := self tableNamed: 'TEACHERS'.
  
  row := DatabaseRow newForTable: teacherTable.
  row at: (teacherTable fieldNamed: 'TEACHER_ID') put: 303.
  row at: (teacherTable fieldNamed: 'TEACHER_NAME') put: 'Dr. Horn'.
  row at: (teacherTable fieldNamed: 'PHONE') put: '257-3049'.
  row at: (teacherTable fieldNamed: 'SALARY') put: 27540.00.
  collection add: row.
  
  row := DatabaseRow newForTable: teacherTable.
  row at: (teacherTable fieldNamed: 'TEACHER_ID') put: 290.
  row at: (teacherTable fieldNamed: 'TEACHER_NAME') put: 'Dr. Lowe'.
  row at: (teacherTable fieldNamed: 'PHONE') put: '257-2390'.
  row at: (teacherTable fieldNamed: 'SALARY') put: 31450.00.
  collection add: row.

  
  row := DatabaseRow newForTable: teacherTable.
  row at: (teacherTable fieldNamed: 'TEACHER_ID') put: 430.
  row at: (teacherTable fieldNamed: 'TEACHER_NAME') put: 'Dr. Eagle'.
  row at: (teacherTable fieldNamed: 'PHONE') put: '256-4621'.
  row at: (teacherTable fieldNamed: 'SALARY') put: 38200.00.
  collection add: row.

  
  row := DatabaseRow newForTable: teacherTable.
  row at: (teacherTable fieldNamed: 'TEACHER_ID') put: 180.
  row at: (teacherTable fieldNamed: 'TEACHER_NAME') put: 'Dr. Cooke'.
  row at: (teacherTable fieldNamed: 'PHONE') put: '257-8088'.
  row at: (teacherTable fieldNamed: 'SALARY') put: 29560.00.
  collection add: row.

  
  row := DatabaseRow newForTable: teacherTable.
  row at: (teacherTable fieldNamed: 'TEACHER_ID') put: 560.
  row at: (teacherTable fieldNamed: 'TEACHER_NAME') put: 'Dr. Olson'.
  row at: (teacherTable fieldNamed: 'PHONE') put: '257-8086'.
  row at: (teacherTable fieldNamed: 'SALARY') put: 31778.00.
  collection add: row.
  
  row := DatabaseRow newForTable: teacherTable.
  row at: (teacherTable fieldNamed: 'TEACHER_ID') put: 784.
  row at: (teacherTable fieldNamed: 'TEACHER_NAME') put: 'Dr. Scango'.
  row at: (teacherTable fieldNamed: 'PHONE') put: '257-3046'.
  row at: (teacherTable fieldNamed: 'SALARY') put: 32098.00.
  collection add: row.

  ^collection.
! !

!GlorpStudentExampleDescriptorSystem methodsFor:'mappings'!

descriptorForGlorpSDBCourses: aDescriptor
        | table |
        table := self tableNamed: 'COURSES'.
        aDescriptor table: (self tableNamed: 'COURSES').

        (aDescriptor newMapping: DirectMapping) from: #courseId to: (table fieldNamed: 'COURSE_ID').
        (aDescriptor newMapping: DirectMapping) from: #courseName to: (table fieldNamed: 'COURSE_NAME').
        (aDescriptor newMapping: DirectMapping) from: #department to: (table fieldNamed: 'DEPARTMENT').
        (aDescriptor newMapping: DirectMapping) from: #numCredits to: (table fieldNamed: 'NUM_CREDITS').
!

descriptorForGlorpSDBEnrolls: aDescriptor
        | table |
        table := self tableNamed: 'ENROLLS'.
        aDescriptor table: (self tableNamed: 'ENROLLS').

        (aDescriptor newMapping: OneToOneMapping) attributeName: #courseId.
        (aDescriptor newMapping: OneToOneMapping) attributeName: #sectionId.
        (aDescriptor newMapping: OneToOneMapping) attributeName: #studentId.
        (aDescriptor newMapping: DirectMapping) from: #grade to: (table fieldNamed: 'GRADE').
!

descriptorForGlorpSDBSections: aDescriptor
        | table |
        table := self tableNamed: 'SECTIONS'.
        aDescriptor table: (self tableNamed: 'SECTIONS').

        (aDescriptor newMapping: DirectMapping) from: #sectionId to: (table fieldNamed: 'SECTION_ID').
        (aDescriptor newMapping: DirectMapping) from: #teacherId to: (table fieldNamed: 'TEACHER_ID').
        (aDescriptor newMapping: DirectMapping) from: #courseId to: (table fieldNamed: 'COURSE_ID').
        (aDescriptor newMapping: DirectMapping) from: #numStudents to: (table fieldNamed: 'NUM_STUDENTS').
!

descriptorForGlorpSDBStudents: aDescriptor
        | table |
        table := self tableNamed: 'STUDENTS'.
        aDescriptor table: (self tableNamed: 'STUDENTS').

        (aDescriptor newMapping: DirectMapping) from: #studentId to: (table fieldNamed: 'STUDENT_ID').
        (aDescriptor newMapping: DirectMapping) from: #studentName to: (table fieldNamed: 'STUDENT_NAME').
        (aDescriptor newMapping: DirectMapping) from: #address to: (table fieldNamed: 'ADDRESS').
        (aDescriptor newMapping: DirectMapping) from: #city to: (table fieldNamed: 'CITY').
        (aDescriptor newMapping: DirectMapping) from: #state to: (table fieldNamed: 'STATE').
        (aDescriptor newMapping: DirectMapping) from: #zip to: (table fieldNamed: 'ZIP').
        (aDescriptor newMapping: DirectMapping) from: #sex to: (table fieldNamed: 'SEX').
!

descriptorForGlorpSDBTeachers: aDescriptor
        | table |
        table := self tableNamed: 'TEACHERS'.
        aDescriptor table: (self tableNamed: 'TEACHERS').

        (aDescriptor newMapping: DirectMapping) from: #teacherId to: (table fieldNamed: 'TEACHER_ID').
        (aDescriptor newMapping: DirectMapping) from: #teacherName to: (table fieldNamed: 'TEACHER_NAME').
        (aDescriptor newMapping: DirectMapping) from: #phone to: (table fieldNamed: 'PHONE').
        (aDescriptor newMapping: DirectMapping) from: #salary to: (table fieldNamed: 'SALARY').
! !

!GlorpStudentExampleDescriptorSystem methodsFor:'table descriptors'!

tableForCOURSES: aTable

	(aTable createFieldNamed: 'COURSE_ID' type: platform smallint)
		bePrimaryKey.

	aTable createFieldNamed: 'COURSE_NAME' type: (platform varChar: 20).
	aTable createFieldNamed: 'DEPARTMENT' type: (platform varChar: 16).
	aTable createFieldNamed: 'NUM_CREDITS' type: (platform smallint).
!

tableForENROLLS: aTable

          | courseId sectionId studentId |
        (courseId := aTable createFieldNamed: 'COURSE_ID' type: platform smallint) bePrimaryKey.
        (sectionId:= aTable createFieldNamed: 'SECTION_ID' type: platform smallint) bePrimaryKey.
        (studentId := aTable createFieldNamed: 'STUDENT_ID' type: platform smallint) bePrimaryKey.

        aTable createFieldNamed: 'GRADE' type: platform smallint.

        aTable addForeignKeyFrom: courseId
                to: ((self tableNamed: 'COURSES') fieldNamed: 'COURSE_ID').
        aTable addForeignKeyFrom: studentId
                to: ((self tableNamed: 'STUDENTS') fieldNamed: 'STUDENT_ID').

        aTable addForeignKeyFrom: sectionId
                to: ((self tableNamed: 'SECTIONS') fieldNamed: 'SECTION_ID')
                from: courseId
                to: ((self tableNamed: 'SECTIONS') fieldNamed: 'COURSE_ID').
!

tableForSECTIONS: aTable
	| courseId teacherId |
	(courseId := aTable createFieldNamed: 'COURSE_ID' type: platform smallint) bePrimaryKey.
	(aTable createFieldNamed: 'SECTION_ID' type: platform smallint) bePrimaryKey.

	teacherId := aTable createFieldNamed: 'TEACHER_ID' type: platform smallint.
	aTable createFieldNamed: 'NUM_STUDENTS' type: platform smallint.

	aTable addForeignKeyFrom: courseId
		to: ((self tableNamed: 'COURSES') fieldNamed: 'COURSE_ID').
	aTable addForeignKeyFrom: teacherId
		to: ((self tableNamed: 'TEACHERS') fieldNamed: 'TEACHER_ID').
!

tableForSTUDENTS: aTable

	(aTable createFieldNamed: 'STUDENT_ID' type: platform smallint)
		bePrimaryKey.

	aTable createFieldNamed: 'STUDENT_NAME' type: (platform varChar: 18).
	aTable createFieldNamed: 'ADDRESS' type: (platform varChar: 30).
	aTable createFieldNamed: 'CITY' type: (platform varChar: 20).
	aTable createFieldNamed: 'STATE' type: (platform char: 2).
	aTable createFieldNamed: 'ZIP' type: (platform char: 5).
	aTable createFieldNamed: 'SEX' type: (platform char: 1).
!

tableForTEACHERS: aTable

	(aTable createFieldNamed: 'TEACHER_ID' type: platform smallint)
		bePrimaryKey.

	aTable createFieldNamed: 'TEACHER_NAME' type: (platform varChar: 18).
	aTable createFieldNamed: 'PHONE' type: (platform varChar: 10).
	aTable createFieldNamed: 'SALARY' type: (platform float).
! !

!GlorpStudentExampleDescriptorSystem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpStudentExampleDescriptorSystem.st,v 1.1 2006/07/26 09:12:04 boris Exp $'
! !
