"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

TestResource subclass:#GlorpStudentExamplePopulatorResource
	instanceVariableNames:'login'
	classVariableNames:'NeedsSetup'
	poolDictionaries:''
	category:'GlorpTest-StudentDatabase'
!


!GlorpStudentExamplePopulatorResource class methodsFor:'setup'!

invalidateSetup
	"GlorpStudentExamplePopulatorResource invalidateSetup"

	NeedsSetup := true.
	self reset.
!

needsSetup
   "GlorpStudentExamplePopulatorResource needsSetup: true"

	NeedsSetup isNil ifTrue: [NeedsSetup := true].
	^NeedsSetup
!

needsSetup: aBoolean

	NeedsSetup := aBoolean.
!

resources

	^Array with: GlorpDatabaseLoginResource.
! !

!GlorpStudentExamplePopulatorResource methodsFor:'setup'!

setUp
        super setUp.
        login := GlorpDatabaseLoginResource current.
        self class needsSetup ifFalse: [^self].
        login platform requiresTransactionForTableOperations ifTrue: [login accessor beginTransaction].
        [GlorpStudentTestDescriptorSystem glorpAllSubclasses do: 
                        [:eachSystemClass | 
                        self 
                                setUpSystem: (eachSystemClass forPlatform: login platform) setUpDefaults].
        
        login platform requiresTransactionForTableOperations ifTrue: [login accessor commitTransaction]] ifCurtailed: [
                login platform requiresTransactionForTableOperations ifTrue: [login accessor rollbackTransaction]].
!

setUpSystem: system 
	| errorBlock |
	login accessor isLoggedIn ifFalse: [login accessor login].
	login accessor dropTables: ((TableSorter for: system allTables) sort reversed).
	errorBlock := [:ex | Transcript show: ex description; cr. ex pass].
	system platform areSequencesExplicitlyCreated ifTrue: [
		login accessor dropSequences: system allSequences.
		system allSequences do: [:each |
			login accessor createSequence: each ifError: errorBlock]].
	system allTables do: [:each | 
			login accessor createTable: each
				ifError: errorBlock].
	system allTables do: [:each |
			login accessor createTableIndexes: each ifError: errorBlock]. 
	system allTables do: [:each | 
			login accessor createTableFKConstraints: each ifError: errorBlock].

	self class needsSetup: false
! !

!GlorpStudentExamplePopulatorResource class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpStudentExamplePopulatorResource.st,v 1.1 2006/07/26 09:20:37 boris Exp $'
! !
