"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

Object subclass:#GlorpTax
	instanceVariableNames:'id name taxes supertax'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTest-Domain Models'
!


!GlorpTax class methodsFor:'glorp'!

glorpCommonSetupDescriptor: aDescriptor forSystem: aSystem
	| table |
	table := aSystem tableNamed: 'TAX'.
	aDescriptor table: table.
	aDescriptor addMapping: (DirectMapping from: #id to: (table fieldNamed: 'ID')).
	aDescriptor addMapping: (DirectMapping from: #name to: (table fieldNamed: 'NAME')).
	aDescriptor addMapping:
			((OneToManyMapping new)
				attributeName: #taxes;
				referenceClass: GlorpTax;
				join: (Join from: (table fieldNamed: 'ID') to: (table fieldNamed: 'TAX_ID'))).
	aDescriptor addMapping:
			((OneToOneMapping new)
				attributeName: #supertax;
				referenceClass: GlorpTax;
				join: (Join from: (table fieldNamed: 'TAX_ID') to: (table fieldNamed: 'ID'))).
!

glorpSetupDescriptor: aDescriptor forSystem: aSystem
	| table |
	table := aSystem tableNamed: 'TAX'.
	aDescriptor table: table.

	"(aSystem typeResolverFor: GlorpTax)
		register: aDescriptor
		keyedBy: 'XXX'
		field: (table fieldNamed: 'TYPE')."

	(aSystem typeResolverFor: GlorpTax)
		register: aDescriptor
		abstract: true
!

glorpTypeResolver
	^FilteredTypeResolver forRootClass: GlorpTax.
! !

!GlorpTax methodsFor:'accessing'!

id
	^id
!

name
	^name
!

name: anObject
	name := anObject.
!

supertax
	^supertax
!

taxes
	taxes ifNil: [taxes := IdentitySet new].
	^taxes.
! !

!GlorpTax methodsFor:'add/remove'!

addTax: aTax
	self taxes add: aTax.
	aTax supertax: self.
! !

!GlorpTax methodsFor:'private'!

id: anObject
	id := anObject.
!

supertax: anObject
	supertax := anObject.
! !

!GlorpTax class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpTax.st,v 1.1 2006/07/26 09:20:00 boris Exp $'
! !
