"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpDatabaseTypeIndividualDBTests subclass:#GlorpTimestampTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpDBTests'
!


!GlorpTimestampTest class methodsFor:'LICENSE'!

LICENSE

	^'Copyright 2000-2004 Alan Knight.
This class is part of the GLORP system (see http://www.glorp.org), licensed under the GNU Lesser General Public License, with clarifications with respect to Smalltalk library usage (LGPL(S)). This code is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE . See the package comment, or the COPYING.TXT file that should accompany this distribution, or the GNU Lesser General Public License.'
! !

!GlorpTimestampTest methodsFor:'tests'!

compareTime: read to: original
	"GNU Smalltalk seems to be quite lone in following the ANSI standard..."
	| zeroDuration max min |
	Dialect isGNU
		ifTrue: [
			zeroDuration := (Smalltalk at: #Duration) zero.
			^(read offset: zeroDuration) = (original offset: zeroDuration)].
	"MS SQL Server fails randomly because it has a resolution of 3 ms only."
	session platform class = SQLServerPlatform ifTrue: [
		max := original addMilliseconds: 3.
		min := original addMilliseconds: -3.
		^read between: min and: max].
	"Otherwise"
	^session platform supportsMillisecondsInTimes
		ifTrue: [read = original]
		ifFalse: [read = (original addMilliseconds: (-1 * original milliseconds))].
!

testTimeStamp
	"This has to be UTC because postgres has time zones and will try and compensate"

	| time |
	Dialect isVisualAge ifTrue: [Transcript cr; show: 'Avoiding timestamp test for VisualAge'. ^self].

	time := Dialect timestampNow.
	session platform supportsMillisecondsInTimes
		ifFalse: [time millisecond: 0].
	self helpTestValue: nil.
	self
		helpTestValue: time
		compareWith:
			[:read :original |
			"MS SQL Server fails randomly because it has a resolution of 3 ms only."
			"GNU Smalltalk seems to be quite lone in following the ANSI standard..."
			self compareTime: read to: original].
! !

!GlorpTimestampTest methodsFor:'types'!

defaultDatabaseType
	^self platform timestamp
! !

!GlorpTimestampTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpTimestampTest.st,v 1.1 2006/07/26 08:58:54 boris Exp $'
! !
