"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

TestCase subclass:#GlorpTransformedFieldValueWrapperTest
	instanceVariableNames:'inner outer'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTests'
!


!GlorpTransformedFieldValueWrapperTest methodsFor:'accessing'!

inner
	^inner
!

inner: aFieldValueWrapper
	inner := aFieldValueWrapper
!

outer
	^outer
!

outer: aTransformingFieldValueWrapper
	outer := aTransformingFieldValueWrapper
! !

!GlorpTransformedFieldValueWrapperTest methodsFor:'support'!

setUp
	super setUp.
	inner := FieldValueWrapper new.
	outer := TransformingFieldValueWrapper new innerWrapper: inner; forwardTransformation: [:a | a * 2]; inverseTransformation: [:a | a / 2].
! !

!GlorpTransformedFieldValueWrapperTest methodsFor:'tests'!

testPrivateSetOuter
	self deny: inner hasValue.
	self deny: outer hasValue.
	outer privateSetContents: 8.
	self assert: outer contents = 8.
	self assert: inner contents = 4.
	self assert: inner hasValue.
	self assert: outer hasValue.
!

testSetInner
	self deny: inner hasValue.
	self deny: outer hasValue.
	inner contents: 3.
	self assert: outer contents = 6.
	self assert: inner contents = 3.
	self assert: inner hasValue.
	self assert: outer hasValue.
!

testSetOuter
	self deny: inner hasValue.
	self deny: outer hasValue.
	outer contents: 8.
	self assert: outer contents = 8.
	self assert: inner contents = 4.
	self assert: inner hasValue.
	self assert: outer hasValue.
!

testSetOuterFails
	self deny: inner hasValue.
	self deny: outer hasValue.
	outer contents: 8.
	self should: [outer contents: 9] raise: Dialect error.
	self assert: outer contents = 8.
	self assert: inner contents = 4.
	self assert: inner hasValue.
	self assert: outer hasValue.
! !

!GlorpTransformedFieldValueWrapperTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpTransformedFieldValueWrapperTest.st,v 1.1 2006/07/26 09:17:09 boris Exp $'
! !
