"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestModelClass subclass:#GlorpVideoCreditStatus
	instanceVariableNames:'customer balanceOwing dateOwing comments'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTestModels'
!

GlorpVideoCreditStatus comment:'There is a possibility of one of these for each customer in a Store. If there is no credit owing or owed, then there is no record. Otherwise the record exists and records the total amount. This is pretty unlikely as a model of credit, but suits our purposes by providing a 1-1 relationship that may or may not exist.

Instance Variables:
	balanceOwing	<Number>	
	comments	<String>	
	customer	<Customer>
	dateOwing	<Date>

'
!


!GlorpVideoCreditStatus methodsFor:'As yet unclassified'!

balanceOwing
	^balanceOwing.
!

balanceOwing: aNumber
	balanceOwing := aNumber.
!

comments
	^comments.
!

comments: aString
	comments := aString.
!

customer
	^customer.
!

customer: aCustomer
	customer := aCustomer.
!

dateOwing
	^dateOwing.
!

dateOwing: aDate
	dateOwing := aDate.
! !

!GlorpVideoCreditStatus methodsFor:'testing'!

assertEqual: aCreditStatus

	self assert: customer name = aCreditStatus customer name.
	self assert: customer dateOfBirth = aCreditStatus customer dateOfBirth.
	self assert: balanceOwing = aCreditStatus balanceOwing.
	self assert: dateOwing = aCreditStatus dateOwing.
	self assert: comments = aCreditStatus comments.
! !

!GlorpVideoCreditStatus class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpVideoCreditStatus.st,v 1.1 2006/07/26 09:18:45 boris Exp $'
! !
