"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestModelClass subclass:#GlorpVideoCustomer
	instanceVariableNames:'name dateOfBirth onlinePurchases inStorePurchases inStoreRentals
		store creditStatus'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTestModels'
!


!GlorpVideoCustomer class methodsFor:'instance creation'!

new
	"Answer a newly created and initialized instance."

	^super new initialize
! !

!GlorpVideoCustomer methodsFor:'As yet unclassified'!

addInStorePurchase: aPurchase
	inStorePurchases add: aPurchase.
	aPurchase customer: self.
!

addOnlinePurchase: aPurchase
	onlinePurchases add: aPurchase.
	aPurchase customer: self.
!

addRental: aRental
	inStoreRentals add: aRental.
	aRental customer: self.
!

dateOfBirth
	^dateOfBirth.
!

dateOfBirth: aDate
	dateOfBirth := aDate.
!

name
	^name.
!

name: aString
	name := aString.
!

purchases
	^inStorePurchases, onlinePurchases.
! !

!GlorpVideoCustomer methodsFor:'accessing'!

creditStatus
	^creditStatus
!

creditStatus: aCreditStatus
	creditStatus := aCreditStatus.
	creditStatus isNil ifFalse: [creditStatus customer: self].
!

inStorePurchases
	^inStorePurchases
!

inStorePurchases: anObject
	inStorePurchases := anObject
!

inStoreRentals
	^inStoreRentals.
!

onlinePurchases
	^onlinePurchases
!

onlinePurchases: anObject
	onlinePurchases := anObject
!

store: anObject
	store := anObject
!

videoStore
	^store
! !

!GlorpVideoCustomer methodsFor:'comparing'!

< aVideoCustomer
        ^self name < aVideoCustomer name and: [self dateOfBirth < aVideoCustomer dateOfBirth].
!

<= aVideoCustomer
	^self name <= aVideoCustomer name and: [self dateOfBirth <= aVideoCustomer dateOfBirth].
! !

!GlorpVideoCustomer methodsFor:'initialize-release'!

initialize
	onlinePurchases := OrderedCollection new.
	inStorePurchases :=OrderedCollection new.
	inStoreRentals := OrderedCollection new.
! !

!GlorpVideoCustomer methodsFor:'testing'!

assertEqual: aCustomer

	onlinePurchases assertEqual: aCustomer onlinePurchases.
	inStorePurchases assertEqual: aCustomer inStorePurchases.
	inStoreRentals assertEqual: aCustomer inStoreRentals.
	creditStatus assertEqual: aCustomer creditStatus.
	self assert: store id = aCustomer videoStore id.
	self assert: name = aCustomer name.
	self assert: dateOfBirth = aCustomer dateOfBirth.
! !

!GlorpVideoCustomer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpVideoCustomer.st,v 1.1 2006/07/26 09:16:32 boris Exp $'
! !
