"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestModelClass subclass:#GlorpVideoPurchase
	instanceVariableNames:'id title price inStore customer store'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTestModels'
!


!GlorpVideoPurchase class methodsFor:'instance creation'!

new
	"Answer a newly created and initialized instance."

	^super new initialize
! !

!GlorpVideoPurchase methodsFor:'As yet unclassified'!

customer
	^customer
!

customer: aCustomer
	customer := aCustomer.
!

store: aGlorpVideoStore
	store := aGlorpVideoStore.
!

videoStore
	^store.
! !

!GlorpVideoPurchase methodsFor:'accessing'!

id
	^id
!

id: anObject
	id := anObject
!

inStore
	^inStore
!

inStore: anObject
	inStore := anObject
!

price
	^price
!

price: anObject
	price := anObject
!

title
	^title
!

title: aString
	title := aString
! !

!GlorpVideoPurchase methodsFor:'comparing'!

< aVideoPurchase
        ^self title < aVideoPurchase title.
!

<= aVideoPurchase
	^self title <= aVideoPurchase title.
! !

!GlorpVideoPurchase methodsFor:'initialize-release'!

initialize
! !

!GlorpVideoPurchase methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self title.
	aStream nextPut: $).
! !

!GlorpVideoPurchase methodsFor:'testing'!

assertEqual: aPurchase

	self assert: customer name = aPurchase customer name.
	self assert: customer dateOfBirth = aPurchase customer dateOfBirth.
	self assert: store id = aPurchase videoStore id.
	self assert: id = aPurchase id.
	self assert: title = aPurchase title.
	self assert: (price * 1000) rounded = (aPurchase price * 1000) rounded.
	self assert: inStore = aPurchase inStore.
! !

!GlorpVideoPurchase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpVideoPurchase.st,v 1.1 2006/07/26 09:09:08 boris Exp $'
! !
