"{ Package: 'stx:goodies/glorp0_4/tests' }"

"{ NameSpace: Glorp }"

GlorpTestModelClass subclass:#GlorpVideoStore
	instanceVariableNames:'id name customers purchases rentals'
	classVariableNames:''
	poolDictionaries:''
	category:'GlorpTestModels'
!


!GlorpVideoStore class methodsFor:'instance creation'!

new
	"Answer a newly created and initialized instance."

	^super new initialize
! !

!GlorpVideoStore methodsFor:'As yet unclassified'!

id
	^id.
!

id: anInteger
	id := anInteger.
!

name
	^name.
!

name: aString
	name := aString.
! !

!GlorpVideoStore methodsFor:'accessing'!

customers
	^customers
!

customers: anObject
	customers := anObject
!

purchases
	^purchases
!

purchases: aCollection
	purchases := aCollection
! !

!GlorpVideoStore methodsFor:'initialize-release'!

initialize
	customers := OrderedCollection new.
	purchases := OrderedCollection new.
! !

!GlorpVideoStore methodsFor:'private'!

computeCollections
	customers do: [:each | each store: self].
	purchases := customers inject: #() into: [:sum :each | sum, each purchases].
	purchases do: [:each | each store: self].
! !

!GlorpVideoStore methodsFor:'testing'!

assertEqual: aStore
	self assert: id = aStore id.
	self assert: name = aStore name.

	customers assertEqual: aStore customers.
	purchases assertEqual: aStore purchases.
! !

!GlorpVideoStore class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/glorp0_4/tests/Glorp__GlorpVideoStore.st,v 1.1 2006/07/26 09:05:42 boris Exp $'
! !
