"{ Package: 'stx:goodies/gofer' }"

GoferWorking subclass:#GoferCleanup
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Gofer-Core'
!

GoferCleanup comment:''
!


!GoferCleanup methodsFor:'cleaning'!

cleanup: aWorkingCopy
	self cleanupCategories: aWorkingCopy.
	self cleanupProtocols: aWorkingCopy
!

cleanupCategories: aWorkingCopy
	aWorkingCopy packageInfo systemCategories do: [ :category |
		(SystemOrganization goferClassesInCategory: category) isEmpty
			ifTrue: [ SystemOrganization removeSystemCategory: category ] ]
!

cleanupProtocols: aWorkingCopy
	aWorkingCopy packageInfo extensionClasses do: [ :class |
		(aWorkingCopy packageInfo extensionCategoriesForClass: class) do: [ :category |
			(class organization listAtCategoryNamed: category) isEmpty
				ifTrue: [ class organization removeCategory: category ] ] ].
	aWorkingCopy packageInfo classesAndMetaClasses do: [ :class |
		(aWorkingCopy packageInfo coreCategoriesForClass: class) do: [ :category |
			(class organization listAtCategoryNamed: category) isEmpty
				ifTrue: [ class organization removeCategory: category ] ] ]
! !

!GoferCleanup methodsFor:'running'!

execute
	self workingCopies
		do: [ :each | self cleanup: each ]
! !

!GoferCleanup class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferCleanup.st,v 1.1 2011/08/20 16:24:34 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferCleanup.st,v 1.1 2011/08/20 16:24:34 cg Exp $'
! !
