"{ Package: 'stx:goodies/gofer' }"

GoferOperation subclass:#GoferLoad
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Gofer-Core'
!

GoferLoad comment:''
!


!GoferLoad methodsFor:'accessing'!

versions
	^ model goferVersions
! !

!GoferLoad methodsFor:'initialization'!

initializeOn: aGofer
        super initializeOn: aGofer.
        Transcript showCR:'Resolving...'.
        aGofer resolved
                do: [ :each | 
                    Transcript show:'Loading '; show:each; showCR:'...'.
                    self addResolved: each 
                ]
                displayingProgress: 'Loading Versions'

    "Modified: / 05-09-2011 / 08:28:29 / cg"
! !

!GoferLoad methodsFor:'private'!

addResolved: aResolvedReference
	| version reference |
	version := aResolvedReference version.
	(self versions includes: version)
		ifTrue: [ ^ self ].
	self versions addLast: version.
	version dependencies do: [ :dependency |
		self addResolved: (GoferResolvedReference
			name: dependency versionInfo name
			repository: aResolvedReference repository) ]
!

defaultModel
	^ MCVersionLoader new
!

updateCategories
	"This method makes sure that the categories are ordered in load-order and as specified in the packages."

	| categories |
	categories := OrderedCollection new.
	self versions do: [ :version |
		version snapshot definitions do: [ :definition |
			definition isOrganizationDefinition ifTrue: [
				definition categories do: [ :category |
					(categories includes: category)
						ifFalse: [ categories addLast: category ] ] ] ] ].
	(MCOrganizationDefinition categories: categories)
		postloadOver: nil
!

updateRepositories
	"This code makes sure that all packages have a repository assigned, including the dependencies."

	self versions do: [ :version |
		gofer repositories do: [ :repository | 
			version workingCopy repositoryGroup
				addRepository: repository ] ]
! !

!GoferLoad methodsFor:'running'!

execute
	self model goferHasVersions
		ifTrue: [ self model load ].
	self updateRepositories.
	self updateCategories
! !

!GoferLoad class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferLoad.st,v 1.2 2011/09/05 06:38:35 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferLoad.st,v 1.2 2011/09/05 06:38:35 cg Exp $'
! !
