"{ Package: 'stx:goodies/gofer' }"

GoferWorking subclass:#GoferUnload
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Gofer-Core'
!

GoferUnload comment:''
!


!GoferUnload methodsFor:'private'!

defaultModel
	^ (Smalltalk globals at: #MCMultiPackageLoader ifAbsent: [ MCPackageLoader ]) new
! !

!GoferUnload methodsFor:'running'!

execute
	self workingCopies 
		do: [ :copy | self unload: copy ].
	self model load.
	self gofer cleanup.
	self workingCopies 
		do: [ :copy | self unregister: copy ]
! !

!GoferUnload methodsFor:'unloading'!

unload: aWorkingCopy
	self unloadClasses: aWorkingCopy.
	self unloadPackage: aWorkingCopy
!

unloadClasses: aWorkingCopy
	aWorkingCopy packageInfo methods do: [ :each |
		(each classIsMeta and: [ each methodSymbol = #unload ])
			ifTrue: [ each actualClass theNonMetaClass unload ] ]
!

unloadPackage: aWorkingCopy
	self model unloadPackage: aWorkingCopy package
! !

!GoferUnload methodsFor:'unregistering'!

unregister: aWorkingCopy
	self unregisterWorkingCopy: aWorkingCopy.
	self unregisterRepositories: aWorkingCopy.
	self unregisterPackageInfo: aWorkingCopy
!

unregisterPackageInfo: aWorkingCopy
	PackageOrganizer default
		unregisterPackage: aWorkingCopy packageInfo
!

unregisterRepositories: aWorkingCopy
	aWorkingCopy repositoryGroup repositories allButFirst do: [ :repository |
		MCWorkingCopy allManagers do: [ :copy |
			(copy repositoryGroup includes: repository)
				ifTrue: [ ^ self ] ].
		MCRepositoryGroup default
			removeRepository: repository ]
!

unregisterWorkingCopy: aWorkingCopy
	aWorkingCopy unregister
! !

!GoferUnload class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferUnload.st,v 1.1 2011/08/20 16:24:40 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferUnload.st,v 1.1 2011/08/20 16:24:40 cg Exp $'
! !
