"{ Package: 'stx:goodies/gofer' }"

GoferReference subclass:#GoferVersionReference
	instanceVariableNames:'package author branch versionNumber'
	classVariableNames:''
	poolDictionaries:''
	category:'Gofer-Core'
!

GoferVersionReference comment:'A GoferVersionReference refers to a specific version of a Monticello package.'
!


!GoferVersionReference methodsFor:'accessing'!

author
	"Answer the author of the receiver."
	
	^ author
!

branch
	"Answer the branch of the receiver."
	
	^ branch
!

packageName
	"Answer the package of the receiver."

	^ package
!

versionNumber
	"Answer the version of the receiver."

	^ versionNumber
! !

!GoferVersionReference methodsFor:'initialization'!

initializeName: aString
	super initializeName: aString.
	self parseName: aString
!

parseName: aString
	| basicName |
	basicName := aString last isDigit
		ifTrue: [ aString ]
		ifFalse: [ (aString copyUpToLast: $.) copyUpTo: $( ].
	package := basicName copyUpToLast: $-.
	(package includes: $.)
		ifFalse: [ branch := '' ]
		ifTrue: [
			branch := package copyAfter: $..
			package := package copyUpTo: $. ].
	author := (basicName copyAfterLast: $-) copyUpToLast: $..
	versionNumber := (basicName copyAfterLast: $-) copyAfterLast: $..
	(versionNumber notEmpty and: [ versionNumber allSatisfy: [ :each | each isDigit ] ])
		ifTrue: [ versionNumber := versionNumber asInteger ]
		ifFalse: [ versionNumber := 0 ]
! !

!GoferVersionReference methodsFor:'private'!

matches: aResolvedReference
	^ self name = aResolvedReference name
! !

!GoferVersionReference class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferVersionReference.st,v 1.1 2011/08/20 16:23:03 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferVersionReference.st,v 1.1 2011/08/20 16:23:03 cg Exp $'
! !
