"{ Package: 'stx:goodies/gofer' }"

GoferOperation subclass:#GoferWorking
	instanceVariableNames:'workingCopies'
	classVariableNames:''
	poolDictionaries:''
	category:'Gofer-Core'
!

GoferWorking comment:''
!


!GoferWorking methodsFor:'accessing'!

workingCopies
	"Answer the working copies to be operated on."

	^ workingCopies
! !

!GoferWorking methodsFor:'initialization'!

initialize
	super initialize.
	workingCopies := OrderedCollection new
!

initializeOn: aGofer
	super initializeOn: aGofer.
	aGofer references 
		do: [ :each | self addReference: each ]
! !

!GoferWorking methodsFor:'private'!

addReference: aReference
	| workingCopy |
	workingCopy := aReference workingCopy.
	(self workingCopies includes: workingCopy)
		ifTrue: [ ^ self ].
	self workingCopies addLast: workingCopy.
	workingCopy requiredPackages do: [ :package |
		self addReference: (GoferPackageReference
			name: package name) ]
! !

!GoferWorking class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferWorking.st,v 1.1 2011/08/20 16:22:20 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/GoferWorking.st,v 1.1 2011/08/20 16:22:20 cg Exp $'
! !
