"{ Package: 'stx:goodies/gofer' }"!

!MCDictionaryRepository methodsFor:'*gofer-core-accessing'!

goferPriority
	^ 10
! !

!MCDictionaryRepository methodsFor:'*gofer-core-accessing'!

goferReferences
	^ self allVersionInfos collect: [ :each | GoferResolvedReference name: each name repository: self ]
! !

!MCDictionaryRepository methodsFor:'*gofer-core-accessing'!

goferVersionFrom: aVersionReference
	^ self dictionary detect: [ :version | version info name = aVersionReference name ]
! !

!MCDirectoryRepository methodsFor:'*gofer-core-accessing'!

goferPriority
	^ 5
! !

!MCFileBasedRepository methodsFor:'*gofer-core-accessing'!

goferReferences
	| versionNames |
	versionNames := [ self allVersionNames ]
		on: Error
		do: [ :error | ^ GoferRepositoryError signal: error messageText repository: self ].
	^ versionNames
		collect: [ :each | GoferResolvedReference name: each repository: self ]
! !

!MCFileBasedRepository methodsFor:'*gofer-core-accessing'!

goferVersionFrom: aVersionReference
	^ self loadVersionFromFileNamed: aVersionReference name , '.mcz'
! !

!MCRepository methodsFor:'*gofer-core-accessing'!

goferPriority
	^ 0
! !

!MCRepository methodsFor:'*gofer-core-accessing'!

goferReferences
	^ #()
! !

!MCRepository methodsFor:'*gofer-core-accessing'!

goferVersionFrom: aVersionReference
	self error: 'Unable to load from ' , self printString
! !

!MCVersionLoader methodsFor:'*gofer-core-accessing'!

goferHasVersions
	^ versions isEmpty not
! !

!MCVersionLoader methodsFor:'*gofer-core-accessing'!

goferVersions
	^ versions
! !

!stx_goodies_gofer class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/extensions.st,v 1.3 2011/08/21 14:47:29 cg Exp $'
! !