"{ Package: 'stx:goodies/gofer' }"

LibraryDefinition subclass:#stx_goodies_gofer
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_gofer class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/stx_goodies_gofer.st,v 1.6 2011/09/06 18:10:21 cg Exp $'
!

monticello_version
"
Gofer-Tests-dkh.130
Gofer-Core-dkh.134
"
! !

!stx_goodies_gofer class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/monticello'    "MCWorkingCopy - referenced by GoferUnload>>unregisterRepositories: "
        #'stx:goodies/sunit'
        #'stx:libbasic'    "Exception - superclass of GoferRepositoryError "
        #'stx:libbasic2'
        #'stx:libbasic3'    "SystemOrganizer - extended "
        #'stx:libcompat'    "SystemOrganization - referenced by GoferCleanup>>cleanupCategories: "
    )
! !

!stx_goodies_gofer class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        Gofer
        GoferOperation
        GoferReference
        GoferRepositoryError
        #'stx_goodies_gofer'
        GoferLoad
        GoferPackageReference
        GoferSynchronize
        GoferVersionReference
        GoferWorking
        GoferChanges
        GoferCleanup
        GoferCommit
        GoferConstraintReference
        GoferFetch
        GoferPush
        GoferRecompile
        GoferReinitialize
        GoferResolvedReference
        GoferUnload
        GoferUpdate
        GoferLocalChanges
        GoferMerge
        GoferRemoteChanges
        GoferRevert
        GoferBrowseLocalChanges
        GoferBrowseRemoteChanges
        ConfigurationOfGofer
    )

    "Modified: / 06-09-2011 / 20:08:33 / cg"
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        SystemOrganizer goferClassesInCategory:
        MCDictionaryRepository goferPriority
        MCDictionaryRepository goferReferences
        MCDictionaryRepository goferVersionFrom:
        MCDirectoryRepository goferPriority
        MCFileBasedRepository goferReferences
        MCFileBasedRepository goferVersionFrom:
        MCRepository goferPriority
        MCRepository goferReferences
        MCRepository goferVersionFrom:
        MCVersionLoader goferHasVersions
        MCVersionLoader goferVersions
    )
! !

!stx_goodies_gofer class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_gofer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/gofer/stx_goodies_gofer.st,v 1.6 2011/09/06 18:10:21 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/stx_goodies_gofer.st,v 1.6 2011/09/06 18:10:21 cg Exp $'
! !
