"{ Package: 'stx:goodies/gofer/tests' }"

TestResource subclass:#GoferResource
	instanceVariableNames:'versionReferences monticelloRepository'
	classVariableNames:''
	poolDictionaries:''
	category:'Gofer-Tests'
!


!GoferResource methodsFor:'accessing'!

monticelloRepository
	^ monticelloRepository
!

versionReferences
	^ versionReferences
! !

!GoferResource methodsFor:'running'!

setUp
	super setUp.
	self
		setUpVersionReferences;
		setUpMonticelloRepository
!

setUpMonticelloRepository
	"This method builds a fake repository with the version references from #buildReferences."

	monticelloRepository := MCDictionaryRepository new.
	versionReferences do: [ :reference |
		monticelloRepository basicStoreVersion: (MCVersion new
			setPackage:  (MCPackage new name: reference packageName)
			info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
			snapshot: (MCSnapshot fromDefinitions: (Array
				with: (MCOrganizationDefinition categories: (Array with: reference packageName asSymbol))
				with: (MCClassDefinition name: reference packageName asSymbol superclassName: #Object category: reference packageName asSymbol instVarNames: #() comment: '')))
			dependencies: #()) ]
!

setUpVersionReferences
	"This method answers a set of Gofer references in the order they should be sorted. It includes two different packages (Gofer-Foo, Gofer-Bar), linear series of packages (Gofer-Foo-lr.1, Gofer-Foo-lr.2, Gofer-Foo-lr.4), packages with a branch (Gofer-Bar.branch-lr.1,Gofer.branch-Bar-lr.2), and packages with the same version but different authors (Gofer-Bar-jf.1, Gofer-Bar-lr.1)."

	versionReferences := OrderedCollection new.
	versionReferences
		add: (GoferVersionReference name: 'GoferBar.branch-lr.1');
		add: (GoferVersionReference name: 'GoferBar.branch-lr.2');
		add: (GoferVersionReference name: 'GoferBar-jf.1');
		add: (GoferVersionReference name: 'GoferBar-lr.1');
		add: (GoferVersionReference name: 'GoferFoo-lr.1');
		add: (GoferVersionReference name: 'GoferFoo-lr.2');
		add: (GoferVersionReference name: 'GoferFoo-lr.4')
! !

!GoferResource class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/gofer/tests/GoferResource.st,v 1.3 2011/09/06 18:03:13 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/gofer/tests/GoferResource.st,v 1.3 2011/09/06 18:03:13 cg Exp $'
! !
