"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

LineAnnotation subclass:#ArrowAnnotation
	instanceVariableNames:'length width'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Figures'
!

ArrowAnnotation comment:'ArrowAnnotation is a line annotation that displays an arrow at the end of the line.

Instance Variables:
	length  <Integer> the length of the arrow
	width   <Integer> our width

'
!


!ArrowAnnotation methodsFor:'accessing'!

length
	^length
!

length: aNumber
	length := aNumber.
	self changed
!

width
	^width
!

width: aNumber
	width := aNumber.
	self changed
! !

!ArrowAnnotation methodsFor:'initialize-release'!

initialize
	super initialize.
	width := 5.
	length := 10
! !

!ArrowAnnotation methodsFor:'private'!

graphic
	| vector u aPoint stopPoint points |
	vector := self directionVector.
	u := vector normal.
	stopPoint := self location.
	aPoint := stopPoint - (vector * length).
	points := Array
				with: aPoint + (u * width)
				with: stopPoint
				with: aPoint - (u * width).
	isFilled
		ifTrue:
			[points := points
						, (Array with: stopPoint - (vector * 0.8 * length) with: points first)].
	^Polyline vertices: points
! !

!ArrowAnnotation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__ArrowAnnotation.st,v 1.1 2006/03/13 16:54:58 cg Exp $'
! !
