"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Object subclass:#ButtonDescription
	instanceVariableNames:'icon enabled value'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Toolbar'
!

ButtonDescription comment:'ButtonDescription represents a button in the Toolbar. It contains both the icon that is displayed as well as its value.

Instance Variables:
	enabled <Boolean> are we enabled, disabled buttons can be greyed out
	icon    <Image>   our image to display
	value   <Object>  some data that we represent (can be anything, it isn''t interpreted by us)

'
!


!ButtonDescription class methodsFor:'instance creation'!

icon: anIcon value: anObject
	^(self new)
		icon: anIcon;
		enable;
		value: anObject;
		yourself
!

new
	^super new initialize
!

spacer
	^self spacer: 12 @ 12
!

spacer: extent
	^(self new)
		icon: ((VisualRegion new)
					extent: extent;
					lineWidth: 0;
					yourself);
		disable;
		yourself
! !

!ButtonDescription methodsFor:'accessing'!

disable
	^self enabled: false
!

enable
	^self enabled: true
!

enabled: aBoolean
	enabled := aBoolean.
	(icon respondsTo: #isEnabled:) ifTrue: [icon isEnabled: aBoolean]
!

icon
	^icon
!

icon: anObject
	icon := anObject
!

value
	^value
!

value: anObject
	value := anObject
! !

!ButtonDescription methodsFor:'initialize-release'!

initialize
	enabled := false
! !

!ButtonDescription methodsFor:'testing'!

isEnabled
	^enabled
! !

!ButtonDescription class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__ButtonDescription.st,v 1.1 2006/03/13 16:57:30 cg Exp $'
! !
