"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

TransitionTable subclass:#CharacterTransitionTable
	instanceVariableNames:'characterMap'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tools'
!

CharacterTransitionTable comment:'CharacterTransitionTable is a transition table for characters. It decides our next state by looking at a table of characters (or symbols for special keys -- #F1).

Instance Variables:
	characterMap    <SequenceableCollection of: (Association key: String value: EndToolState)>        a mapping for characters to the next state

'
!


!CharacterTransitionTable methodsFor:'accessing'!

forCharacters: characterCollection goto: aToolState
	characterMap add: characterCollection -> aToolState
!

goto: aState
	self
		forCharacters: ((0 to: 255) collect: [:each | Character value: each])
		goto: aState
!

nextStateForTool: aTool event: anEvent
	anEvent isKeyboard ifFalse: [^nil].
	1 to: characterMap size
		do:
			[:i |
			| each |
			each := characterMap at: i.
			(each key includes: anEvent keyValue) ifTrue: [^each value]].
	^nil
! !

!CharacterTransitionTable methodsFor:'initialize-release'!

initialize
	super initialize.
	characterMap := OrderedCollection new
! !

!CharacterTransitionTable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__CharacterTransitionTable.st,v 1.1 2006/03/13 16:53:51 cg Exp $'
! !
