"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

TransitionType subclass:#CharacterTransitionType
	instanceVariableNames:'characters'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tool Creation Models'
!


!CharacterTransitionType class methodsFor:'accessing'!

transition
	^#character
! !

!CharacterTransitionType methodsFor:'accessing'!

characters
	^characters
!

characters: aString
	characters := aString
!

priority
	^characters size
! !

!CharacterTransitionType methodsFor:'compilation'!

writeDefinitionOn: codeStream to: aString
	codeStream nextPutAll: '(CharacterTransitionTable new) '.
	self writeMessageSendOn: codeStream to: aString
!

writeMessageSendOn: codeStream to: aString
	codeStream nextPutAll: 'forCharacters: '.
	self storeCharactersOn: codeStream.
	codeStream
		nextPutAll: ' goto: ';
		nextPutAll: aString
! !

!CharacterTransitionType methodsFor:'initialize-release'!

initialize
	super initialize.
	event := #keyPress.
	characters := OrderedCollection new
! !

!CharacterTransitionType methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $/;
		cr;
		nextPutAll: 'chars'
! !

!CharacterTransitionType methodsFor:'storing'!

storeCharactersOn: aStream
	| symbols |
	symbols := characters select: [:each | each isSymbol].
	symbols isEmpty
		ifTrue: [self writeCharactersOn: aStream]
		ifFalse:
			[aStream nextPut: $(.
			symbols asArray storeOn: aStream.
			aStream nextPutAll: ' , '.
			self writeCharactersOn: aStream.
			aStream nextPut: $)]
!

storeOn: aStream
	aStream
		nextPut: $(;
		nextPutAll: self class name;
		nextPutAll: ' new event: ';
		print: event;
		nextPutAll: '; characters: '.
	self storeCharactersOn: aStream.
	aStream nextPut: $)
!

writeCharactersOn: aStream
	| chars |
	chars := characters reject: [:each | each isSymbol].
	chars isEmpty
		ifTrue:
			[aStream nextPutAll: ''''''.
			^self].
	aStream nextPutAll: '(String fromIntegerArray: '.
	(String withAll: chars) asByteArray storeOn: aStream.
	aStream nextPut: $)
! !

!CharacterTransitionType methodsFor:'verifying'!

conflictsWith: aTransitionType
	^aTransitionType characters contains: [:each | characters includes: each]
! !

!CharacterTransitionType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__CharacterTransitionType.st,v 1.1 2006/03/13 16:58:11 cg Exp $'
! !
