"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

LineAnnotation subclass:#CircleAnnotation
	instanceVariableNames:'radius'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Figures'
!

CircleAnnotation comment:'CircleAnnotation is a line annotation that displays a circle at the end of the line.

Instance Variables:
	radius  <Integer> the radius of the circle to display

'
!


!CircleAnnotation methodsFor:'accessing'!

radius
	^radius
!

radius: aNumber
	radius := aNumber.
	self changed
! !

!CircleAnnotation methodsFor:'initialize-release'!

initialize
	super initialize.
	radius := 4
! !

!CircleAnnotation methodsFor:'private'!

graphic
	| center origin |
	origin := self location.
	center := origin - (self directionVector * radius).
	^EllipticalArc
		boundingBox: (center - radius corner: center + radius + 1)
! !

!CircleAnnotation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__CircleAnnotation.st,v 1.1 2006/03/13 16:54:44 cg Exp $'
! !
