"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

ArrowAnnotation subclass:#DiamondAnnotation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Figures'
!

DiamondAnnotation comment:'DiamondAnnotation is a line annotation that displays a diamond shape at the end of line (similar to those in some case tool diagrams).'
!


!DiamondAnnotation methodsFor:'displaying'!

displayOn: aGraphicsContext
	isFilled ifTrue: [^super displayOn: aGraphicsContext].
	aGraphicsContext
		lineWidth: container lineWidth;
		paint: container fillColor.
	self graphic displayFilledOn: aGraphicsContext.
	aGraphicsContext paint: container lineColor.
	self graphic displayStrokedOn: aGraphicsContext
! !

!DiamondAnnotation methodsFor:'initialize-release'!

initialize
	super initialize.
	isFilled := false
! !

!DiamondAnnotation methodsFor:'private'!

graphic
	| vector u aPoint stopPoint points |
	vector := self directionVector.
	u := vector normal.
	stopPoint := self location.
	aPoint := stopPoint - (vector * length).
	points := (Array new: 5)
				at: 1 put: stopPoint;
				at: 2 put: aPoint - (u * width);
				at: 3 put: stopPoint - (vector * 2 * length);
				at: 4 put: aPoint + (u * width);
				at: 5 put: stopPoint;
				yourself.
	^Polyline vertices: points
! !

!DiamondAnnotation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__DiamondAnnotation.st,v 1.1 2006/03/13 16:53:06 cg Exp $'
! !
