"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Object subclass:#FigureAttributes
	instanceVariableNames:'lineWidth lineColor fillColor'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Framework'
!

FigureAttributes comment:'FigureAttributes is a record that holds some attibutes of figures. These attributes could be incorporated into the figures, but this saves space since most figures don''t specialize these attributes.

Instance Variables:
	fillColor       <ColorValue>      if our figure is filled, this is the color to use
	lineColor       <ColorValue>      our outline''s color
	lineWidth       <Integer> how wide is our outline
'
!


!FigureAttributes methodsFor:'accessing'!

fillColor
	^fillColor
!

fillColor: aColorValue
	fillColor := aColorValue
!

lineColor
	^lineColor
!

lineColor: aColorValue
	lineColor := aColorValue
!

lineWidth
	^lineWidth
!

lineWidth: anInteger
	lineWidth := anInteger
! !

!FigureAttributes class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__FigureAttributes.st,v 1.1 2006/03/13 16:55:11 cg Exp $'
! !
