"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

TransitionTable subclass:#FigureTransitionTable
	instanceVariableNames:'figureLookupStates'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tools'
!

FigureTransitionTable comment:'FigureTransitionTable is a transition table for mouse events. It checks what type of figure the mouse is over and then decides what is the next state.

Instance Variables:
	figureLookupStates      <Dictionary key: Figure class value: EndToolState>        our table, if the figure''s class is in the table, then we take it entry, otherwise we lookup its superclass

'
!


!FigureTransitionTable methodsFor:'accessing'!

goto: aState
	^self
		on: Figure
		goto: aState
!

nextStateForTool: aTool event: anEvent
	| class state |
	class := (aTool figureAtEvent: anEvent) class.

	[state := figureLookupStates at: class ifAbsent: [nil].
	state notNil or: [class isNil]]
			whileFalse: [class := class superclass].
	^state
!

on: figureClass goto: aToolState
	figureLookupStates at: figureClass put: aToolState
! !

!FigureTransitionTable methodsFor:'initialize-release'!

initialize
	super initialize.
	figureLookupStates := Dictionary new
! !

!FigureTransitionTable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__FigureTransitionTable.st,v 1.1 2006/03/13 16:55:30 cg Exp $'
! !
