"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

TransitionType subclass:#FigureTransitionType
	instanceVariableNames:'figureClasses'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tool Creation Models'
!


!FigureTransitionType class methodsFor:'accessing'!

transition
	^#figure
! !

!FigureTransitionType methodsFor:'accessing'!

figureClasses
	^figureClasses
!

figureClasses: aCollection
	figureClasses := aCollection
!

priority
	^figureClasses inject: 0
		into: [:sum :each | sum + each withAllSubclasses size]
! !

!FigureTransitionType methodsFor:'compilation'!

writeDefinitionOn: codeStream to: aString
	codeStream nextPutAll: '(FigureTransitionTable new) '.
	self writeMessageSendOn: codeStream to: aString
!

writeMessageSendOn: codeStream to: aString
	figureClasses do:
			[:each |
			codeStream
				nextPutAll: ' on: ';
				print: each;
				nextPutAll: ' goto: ';
				nextPutAll: aString]
		separatedBy: [codeStream nextPutAll: '; ']
! !

!FigureTransitionType methodsFor:'initialize-release'!

initialize
	super initialize.
	figureClasses := OrderedCollection new
! !

!FigureTransitionType methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $/;
		cr.
	figureClasses do: [:each | aStream print: each]
		separatedBy: [aStream nextPut: $,]
! !

!FigureTransitionType methodsFor:'verifying'!

conflictsWith: aTransitionType
	^aTransitionType figureClasses
		contains: [:each | figureClasses includes: each]
! !

!FigureTransitionType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__FigureTransitionType.st,v 1.1 2006/03/13 16:56:45 cg Exp $'
! !
