"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

DrawingEditor subclass:#HotPaintEditor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-HotPaint'
!

HotPaintEditor comment:'This editor is a typical HotDraw editor except that it contains tools for creating CanvasFigures and painting on them.

HotPaintEditor open'
!


!HotPaintEditor class methodsFor:'accessing'!

images
	| anArrayOfBits anArrayOfMasks |
	anArrayOfBits := #(#[3 224 7 240 12 24 24 12 48 6 96 2 68 35 192 129 129 1 194 2 83 146 72 38 103 196 48 12 14 24 3 224] #[24 24 60 60 126 126 255 255 255 255 255 255 255 255 255 255 127 254 63 252 31 248 15 248 7 240 3 224 1 192 0 128]).
	anArrayOfMasks := Array new: anArrayOfBits size.
	^(1 to: anArrayOfBits size) collect:
			[:i |
			anArrayOfMasks at: i
				put: (Image
						extent: 16 @ 16
						depth: 1
						palette: (MappedPalette with: ColorValue white with: ColorValue red)
						bits: (anArrayOfBits at: i)
						pad: 8)]
!

paintStyles
	| anArrayOfBits anArrayOfMasks |
	anArrayOfBits := #(#[0 0 0 0 0 0 0 0 0 0 4 64 0 0 1 0 0 0 4 64 0 0 0 0 0 0 0 0 0 0 0 0] #[0 0 0 0 0 0 0 0 2 128 0 0 2 72 0 16 0 192 1 0 4 136 2 160 1 0 0 0 0 0 0 0] #[0 0 0 0 0 72 24 72 4 80 1 0 0 64 48 70 30 208 0 96 2 80 0 64 4 8 8 64 16 68 32 2] #[0 64 1 0 4 8 83 16 42 196 36 129 0 72 74 156 66 201 41 0 32 73 2 164 9 16 16 40 3 68 0 0] #[0 0 5 132 43 112 20 188 107 86 89 184 62 164 75 254 30 210 115 76 93 184 54 98 37 84 58 168 77 210 0 0]).
	anArrayOfMasks := Array new: anArrayOfBits size.
	^(1 to: anArrayOfBits size) collect:
			[:i |
			anArrayOfMasks at: i
				put: (Image
						extent: 16 @ 16
						depth: 1
						palette: CoveragePalette monoMaskPalette
						bits: (anArrayOfBits at: i)
						pad: 8)]
! !

!HotPaintEditor class methodsFor:'parcel load/unload/save'!

obsolete
	[Tool reinitialize] on: Error do: [:ex | ex return: nil].
	super obsolete
!

postLoadActionFor: aParcel
	Tool reinitialize
! !

!HotPaintEditor class methodsFor:'resources'!

hotPaintCanvasIcon
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintCanvasIcon"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 2 bitsPerPixel: 2 palette: (MappedPalette withColors: ((Array new: 4) at: 1 put: ColorValue black; at: 2 put: ColorValue red; at: 3 put: ColorValue blue; at: 4 put: ColorValue white; yourself)) usingBits: #[0 0 0 0 63 255 255 252 63 255 243 252 63 255 204 252 63 255 243 252 61 247 255 252 61 87 255 252 61 87 255 232 63 95 255 168 63 255 254 172 63 255 250 188 63 255 234 252 63 255 171 252 63 255 175 252 63 255 255 252 0 0 0 0])
!

hotPaintEraseIcon
	^OpaqueImage figure: self hotPaintEraseImage
		shape: self hotPaintEraseMask
!

hotPaintEraseImage
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintEraseImage"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 3 bitsPerPixel: 4 palette: (MappedPalette withColors: ((Array new: 5) at: 1 put: ColorValue black; at: 2 put: (ColorValue red: 3/4 green: 3/4 blue: 0); at: 3 put: ColorValue yellow; at: 4 put: ColorValue white; at: 5 put: (ColorValue red: 3/4 green: 3/4 blue: 3/4); yourself)) usingBits: #[51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 48 0 0 3 51 51 51 51 3 35 35 32 51 51 51 48 50 50 50 0 51 51 51 3 35 35 32 16 51 51 48 50 50 50 1 16 51 51 3 35 35 32 17 3 51 48 50 50 50 1 16 51 51 4 68 68 64 17 3 51 51 4 68 68 64 16 51 51 51 4 68 68 64 3 51 51 51 48 0 0 0 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51 51])
!

hotPaintEraseMask
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintEraseMask"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[0 0 0 0 0 0 0 0 0 0 0 0 0 126 0 0 0 255 0 0 1 255 0 0 3 255 0 0 7 255 0 0 15 254 0 0 31 252 0 0 63 248 0 0 63 240 0 0 63 224 0 0 31 192 0 0 0 0 0 0 0 0 0 0])
!

hotPaintImageIcon
	^OpaqueImage figure: self hotPaintImageImage
		shape: self hotPaintImageMask
!

hotPaintImageImage
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintImageImage"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 1 bitsPerPixel: 1 palette: MonoMappedPalette blackWhite usingBits: #[255 255 0 0 254 63 0 0 252 31 0 0 252 31 0 0 254 63 0 0 255 127 0 0 255 127 0 0 240 7 0 0 255 127 0 0 255 127 0 0 255 127 0 0 255 127 0 0 254 191 0 0 253 223 0 0 251 239 0 0 247 247 0 0])
!

hotPaintImageMask
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintImageMask"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[0 0 0 0 1 192 0 0 3 224 0 0 3 224 0 0 1 192 0 0 0 128 0 0 0 128 0 0 15 248 0 0 0 128 0 0 0 128 0 0 0 128 0 0 0 128 0 0 1 64 0 0 2 32 0 0 4 16 0 0 8 8 0 0])
!

hotPaintMaskIcon
	^OpaqueImage figure: self hotPaintMaskImage
		shape: self hotPaintMaskMask
!

hotPaintMaskImage
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintMaskImage"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 2 bitsPerPixel: 2 palette: (MappedPalette withColors: ((Array new: 3) at: 1 put: ColorValue black; at: 2 put: ColorValue red; at: 3 put: ColorValue white; yourself)) usingBits: #[170 170 169 169 170 170 154 154 170 170 169 169 170 169 154 154 170 38 169 169 170 41 154 154 160 2 169 169 160 2 154 154 160 2 169 169 160 2 170 154 160 2 170 169 160 2 170 170 160 2 170 170 160 2 170 170 160 2 170 170 170 170 170 170])
!

hotPaintMaskMask
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintMaskMask"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[0 17 0 0 0 68 0 0 0 17 0 0 1 68 0 0 10 17 0 0 9 68 0 0 62 17 0 0 62 68 0 0 62 17 0 0 62 4 0 0 62 1 0 0 62 0 0 0 62 0 0 0 62 0 0 0 62 0 0 0 0 0 0 0])
!

hotPaintPaintbrushIcon
	^OpaqueImage figure: self hotPaintPaintbrushImage
		shape: self hotPaintPaintbrushMask
!

hotPaintPaintbrushImage
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintPaintbrushImage"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 2 bitsPerPixel: 2 palette: (MappedPalette withColors: ((Array new: 3) at: 1 put: ColorValue black; at: 2 put: ColorValue red; at: 3 put: ColorValue white; yourself)) usingBits: #[170 170 170 170 170 170 42 170 170 168 74 170 170 168 74 170 170 168 74 170 170 168 74 170 170 168 74 170 170 161 82 170 170 5 84 42 170 21 85 42 170 0 0 42 170 42 170 42 170 40 138 42 170 40 138 42 168 0 0 170 170 170 170 170])
!

hotPaintPaintbrushMask
	"UIMaskEditor new openOnClass: self andSelector: #hotPaintPaintbrushMask"

	<resource: #image>
	^CachedImage on: (Image extent: 16@16 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[0 0 0 0 0 128 0 0 1 192 0 0 1 192 0 0 1 192 0 0 1 192 0 0 1 192 0 0 3 224 0 0 15 248 0 0 15 248 0 0 15 248 0 0 15 248 0 0 15 248 0 0 15 248 0 0 31 240 0 0 0 0 0 0])
! !

!HotPaintEditor methodsFor:'drawing description'!

toolNames
	"Return the list of names for the tools."

	^super toolNames
		, #(nil 'Hot Paint Canvas Tool' 'Hot Paint Paintbrush Tool' 'Hot Paint Mask Tool' 'Hot Paint Image Tool' 'Hot Paint Erase Tool')
!

windowName
	^'Hot Paint Editor'
! !

!HotPaintEditor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__HotPaintEditor.st,v 1.1 2006/03/13 16:52:34 cg Exp $'
! !
