"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

TrackHandle subclass:#IndexedTrackHandle
	instanceVariableNames:'index'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Handles'
!

IndexedTrackHandle comment:'IndexedTrackHandle is a TrackHandle that has a menu. This menu allows the user to remove points from the line that the handle is for.

Instance Variables:
	index   <Integer> the index of the point on the line that we''re connected to

'
!


!IndexedTrackHandle class methodsFor:'instance creation'!

pointAtIndex: anIndex of: aFigure
	| handle |
	handle := super pointAtIndex: anIndex of: aFigure.
	handle index: anIndex.
	^handle
! !

!IndexedTrackHandle methodsFor:'accessing'!

menuAt: aPoint
	| menu |
	menu := super menuAt: aPoint.
	menu addItemLabel: 'Remove' value: #removePoint.
	^menu
!

removePoint
	owner removePointAtIndex: index
! !

!IndexedTrackHandle methodsFor:'initialize-release'!

index: anObject
	index := anObject
! !

!IndexedTrackHandle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__IndexedTrackHandle.st,v 1.1 2006/03/13 16:54:18 cg Exp $'
! !
