"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

RectangleFigure subclass:#MovingFigure
	instanceVariableNames:'velocity'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Moving Drawing'
!

MovingFigure comment:'A RectangleFigure with a velocity.

The only instance variable, velocity, is a point that represents the
velocity vector.'
!


!MovingFigure methodsFor:'accessing'!

force: aPoint
	"Apply a force to the object.
	The only effect now is to change the velocity."

	velocity := velocity + aPoint
!

forceOn: aBody
	| delta x y |
	self == aBody ifTrue: [^0 @ 0].
	delta := self center - aBody center.
	x := delta x = 0 ifTrue: [0] ifFalse: [200 / delta x].
	y := delta y = 0 ifTrue: [0] ifFalse: [200 / delta y].
	^delta - (x @ y)
!

handles
	^TrackHandle allCornersOf: self
!

step
	self translateBy: velocity / 100.0.
	velocity := 0 @ 0
! !

!MovingFigure methodsFor:'initialize-release'!

initialize
	"The figure is initially at rest."

	super initialize.
	velocity := 0 @ 0
! !

!MovingFigure class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__MovingFigure.st,v 1.1 2006/03/13 16:59:41 cg Exp $'
! !
