"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

CachedFigure subclass:#NetworkNode
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Network Drawing'
!


!NetworkNode class methodsFor:'instance creation'!

name: aName
	^self new name: aName
! !

!NetworkNode methodsFor:'accessing'!

name
	^name
! !

!NetworkNode methodsFor:'connection'!

connectionFigureClass
	^PolylineFigure
! !

!NetworkNode methodsFor:'displaying'!

fillCache
	| title aGC rect |
	title := name asComposedText.
	cache := Pixmap extent: title extent + (2 @ 4).
	aGC := cache graphicsContext.
	aGC medium background: LookPreferences defaultForWindows backgroundColor.
	aGC paint: ColorValue white.
	rect := 0 @ 0 extent: cache extent - (2 @ 2).
	aGC displayRectangle: rect.
	aGC paint: ColorValue black.
	title displayOn: aGC at: 0 @ 2.
	aGC displayRectangularBorder: rect.
	^cache asImage
! !

!NetworkNode methodsFor:'initialize-release'!

name: aName
	name := aName.
	self initialize
! !

!NetworkNode methodsFor:'printing'!

printOn: aStream
	aStream
		nextPutAll: name;
		nextPutAll: ' at: ';
		print: self origin
! !

!NetworkNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__NetworkNode.st,v 1.1 2006/03/13 16:54:37 cg Exp $'
! !
