"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Model subclass:#ObjectConnectionModel
	instanceVariableNames:'fromFigure offset toFigure'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Drawing Inspector'
!

ObjectConnectionModel comment:'ObjectConnectionModel contains the extra information needed for connections between lines. Instead of creating a subclass of LineFigure to hold this information, we store it as the model of the line.

Instance Variables:
	fromFigure      <ObjectFigure>    our originator
	offset  <Point>   offset in the fromFigure of our start
	toFigure        <ObjectFigure>    our destination'
!


!ObjectConnectionModel methodsFor:'accessing'!

offset
	^offset
!

start
	^fromFigure
!

stop
	^toFigure
! !

!ObjectConnectionModel methodsFor:'initialize-release'!

start: aFigure offset: anOffset stop: anotherFigure
	fromFigure := aFigure.
	offset := anOffset.
	toFigure := anotherFigure
! !

!ObjectConnectionModel class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__ObjectConnectionModel.st,v 1.1 2006/03/13 16:59:27 cg Exp $'
! !
