"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Model subclass:#ObjectHandleModel
	instanceVariableNames:'object offset'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Drawing Inspector'
!

ObjectHandleModel comment:'ObjectHandleModel contains information for the ObjectFigure''s handles. It contains the object of the figure that is to be created as well as its offset.

Instance Variables:
	object  <Object>  the object that this handle is for. An ObjectFigure will be created for this object, it the handle is clicked on.
	offset  <Point>   the offset from our owner for this handle
'
!


!ObjectHandleModel class methodsFor:'instance creation'!

for: anObject offset: aPoint
	^(self new)
		object: anObject;
		offset: aPoint;
		yourself
! !

!ObjectHandleModel methodsFor:'accessing'!

object
	^object
!

object: anObject
	object := anObject
!

offset
	^offset
!

offset: anObject
	offset := anObject
! !

!ObjectHandleModel class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__ObjectHandleModel.st,v 1.1 2006/03/13 16:54:51 cg Exp $'
! !
