"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

AnimatedDrawing subclass:#ObjectWorldDrawing
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-ObjectWorld'
!

ObjectWorldDrawing comment:'I am  a Drawing (from HotDraw) that provides a number of instance methods for ObjectWorld animation control.'
!


!ObjectWorldDrawing methodsFor:'adding'!

add: aFigure
	ObjectWorldFigureModel on: aFigure.
	aFigure model model: self model.
	^super add: aFigure
! !

!ObjectWorldDrawing methodsFor:'animating'!

pause
	"Pause the animation on all Figures in the receiving Drawing."

	self components do: [:each | each model notNil ifTrue: [each model pause]]
!

resume
	"Resume animation on all Figures in the receiving Drawing.
	(This is the opposite of pause.)"

	self components
		do: [:each | each model notNil ifTrue: [each model resume]]
!

step
	"Tell each Figure in the receiving Drawing to perform
	one step in its animation sequence (if any)."

	self components
		do: [:each | each model notNil ifTrue: [each model stepIn: self bounds]]
!

stopAll
	"Shut off animation and delete the list of animation steps for
	all Figures in the receiving Drawing."

	self components do: [:each | each model notNil ifTrue: [each model stop]]
! !

!ObjectWorldDrawing class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__ObjectWorldDrawing.st,v 1.1 2006/03/13 16:51:52 cg Exp $'
! !
