"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

ApplicationModel subclass:#PERTEventAppModel
	instanceVariableNames:'durationHolder endDateHolder nameHolder incoming outgoing'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-PERTChart'
!

PERTEventAppModel comment:'PERTEventAppModel is an ApplicationModel that represents an individual event.

Instance Variables:
	durationHolder  <ValueHolder on: Number>  how long does this event last
	endDateHolder   <ValueHolder on: Number>  when do we end
	incoming        <Collection of: PERTEventAppModel>        events that must occur before us
	nameHolder      <ValueHolder on: String>  our name
	outgoing        <Collection of: PERTEventAppModel>        events that occur after us

'
!


!PERTEventAppModel class methodsFor:'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec
		#window:
		#(#WindowSpec
			#label: 'Unlabeled Canvas'
			#min: #(#Point 40 20 )
			#bounds: #(#Rectangle 791 610 895 703 )
			#colors:
			#(#LookPreferences
				#setBackgroundColor: #(#ColorValue 7700 7700 7700 ) )
			#isEventDriven: true )
		#component:
		#(#SpecCollection
			#collection: #(
				#(#InputFieldSpec
					#layout: #(#LayoutFrame 1 0 1 0 -1 1 29 0 )
					#name: #nameHolder
					#model: #nameHolder )
				#(#LabelSpec
					#layout: #(#Point 1 30 )
					#label: 'Duration:' )
				#(#LabelSpec
					#layout: #(#Point 1 61 )
					#label: 'End date:' )
				#(#InputFieldSpec
					#layout: #(#LayoutFrame 0 0.666666 31 0 -1 1 58 0 )
					#name: #durationHolder
					#model: #durationHolder
					#alignment: #right
					#type: #number )
				#(#InputFieldSpec
					#layout: #(#LayoutFrame 0 0.666666 60 0 -1 1 89 0 )
					#name: #endDateHolder
					#model: #endDateHolder
					#alignment: #right
					#isReadOnly: true
					#type: #number ) ) ) )
! !

!PERTEventAppModel methodsFor:'accessing'!

addIncoming: aPertEventAppModel
	aPertEventAppModel addDependent: self.
	incoming add: aPertEventAppModel.
	self updateEndDate
!

connectTo: aPertEventAppModel
	outgoing add: aPertEventAppModel.
	aPertEventAppModel addIncoming: self
!

disconnectFrom: aPertEventAppModel
	outgoing remove: aPertEventAppModel ifAbsent: [].
	aPertEventAppModel removeIncoming: self
!

duration
	^self durationHolder value
!

endDate
	^self endDateHolder value
!

removeIncoming: aPertEventAppModel
	aPertEventAppModel removeDependent: self.
	incoming remove: aPertEventAppModel ifAbsent: [].
	self updateEndDate
!

startDate
	^incoming inject: 0 into: [:sum :each | sum max: each endDate]
! !

!PERTEventAppModel methodsFor:'aspects'!

durationHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^durationHolder isNil
		ifTrue:
			[durationHolder := 0 asValue]
		ifFalse:
			[durationHolder]
!

endDateHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^endDateHolder isNil
		ifTrue:
			[endDateHolder := 0 asValue]
		ifFalse:
			[endDateHolder]
!

nameHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^nameHolder isNil
		ifTrue:
			[nameHolder := String new asValue]
		ifFalse:
			[nameHolder]
! !

!PERTEventAppModel methodsFor:'changing'!

update: anAspect with: anArg from: anObject
	self updateEndDate
!

updateEndDate
	self endDateHolder value: self startDate + self duration
! !

!PERTEventAppModel methodsFor:'initialize-release'!

initialize
	super initialize.
	incoming := OrderedCollection new.
	outgoing := OrderedCollection new.
	self endDateHolder onChangeSend: #changed to: self.
	self durationHolder onChangeSend: #updateEndDate to: self
! !

!PERTEventAppModel class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__PERTEventAppModel.st,v 1.1 2006/03/13 16:55:05 cg Exp $'
! !
