"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Figure subclass:#RectangleFigure
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Figures'
!

RectangleFigure comment:'RectangleFigure is a figure that displays a rectangle.
'
!


!RectangleFigure class methodsFor:'instance creation'!

createAt: aPoint
	^self rectangle: (aPoint extent: 0 @ 0)
!

rectangle: aRectangle
	^(self new)
		rectangle: aRectangle;
		yourself
! !

!RectangleFigure methodsFor:'displaying'!

displayFigureOn: aGraphicsContext
	"Display an ellipse on aGraphicsContext. If the ellipse figure is not transparent then
	display a filled ellipse using the current fillColor."

	self isOpaque ifTrue: [self displayFilledOn: aGraphicsContext].
	self lineWidth > 0 ifTrue: [self displayOutlineOn: aGraphicsContext]
!

displayFilledOn: aGraphicsContext
	aGraphicsContext paint: self fillColor.
	self bounds displayFilledOn: aGraphicsContext
!

displayOutlineOn: aGraphicsContext
	aGraphicsContext lineWidth: self lineWidth.
	aGraphicsContext paint: self lineColor.
	self bounds displayStrokedOn: aGraphicsContext
! !

!RectangleFigure methodsFor:'initialize-release'!

rectangle: aRectangle
	bounds := aRectangle.
	self opaque
! !

!RectangleFigure class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__RectangleFigure.st,v 1.1 2006/03/13 16:59:34 cg Exp $'
! !
