"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

TransitionTable subclass:#SimpleTransitionTable
	instanceVariableNames:'nextState'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tools'
!

SimpleTransitionTable comment:'SimpleTransitionTable is a transition table that always goes to another state no matter what the event is.

Instance Variables:
	nextState       <EndToolState>    the next state to goto

'
!


!SimpleTransitionTable class methodsFor:'instance creation'!

goto: aToolState
	^(self new) nextState: aToolState;
		yourself
! !

!SimpleTransitionTable methodsFor:'accessing'!

goto: aState
	self nextState: aState
!

nextStateForTool: aTool event: anEvent
	^nextState
! !

!SimpleTransitionTable methodsFor:'initialize-release'!

nextState: anObject
	nextState := anObject
! !

!SimpleTransitionTable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__SimpleTransitionTable.st,v 1.1 2006/03/13 16:55:43 cg Exp $'
! !
