"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

PolylineFigure subclass:#SplineFigure
	instanceVariableNames:'spline'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Figures'
!

SplineFigure comment:'SplineFigure is a figure that represents a spline.

Instance Variables:
	spline  <Spline>  the geometric spline object

'
!


!SplineFigure methodsFor:'accessing'!

pointAt: anIndex put: aValue
	super pointAt: anIndex put: aValue.
	spline := nil
! !

!SplineFigure methodsFor:'copying'!

postCopy
	super postCopy.
	spline := nil
! !

!SplineFigure methodsFor:'private'!

asGeometric
	^self spline
!

computePreferredBounds
	| rect |
	rect := self spline bounds.
	^rect origin - (self lineWidth // 2)
		corner: rect corner + (self lineWidth // 2) + 1
!

computeSpline
	^Spline controlPoints: points asArray
!

spline
	^spline isNil
		ifTrue: [spline := self computeSpline]
		ifFalse: [spline]
! !

!SplineFigure methodsFor:'transforming'!

basicTranslateBy: aPoint
	super basicTranslateBy: aPoint.
	spline := spline translatedBy: aPoint
! !

!SplineFigure class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__SplineFigure.st,v 1.1 2006/03/13 16:56:38 cg Exp $'
! !
