"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

LineFigure subclass:#StateTransitionFigure
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tool Creation GUI'
!


!StateTransitionFigure class methodsFor:'instance creation'!

fromModel: aToolStateTransitionModel connecting: aFigure to: anotherFigure
	| figure |
	figure := self new.
	figure
		model: aToolStateTransitionModel;
		points: aToolStateTransitionModel points;
		recomputePreferredBounds.
	aFigure createStartConnectionConstraintFor: figure at: figure startPoint.
	anotherFigure createStopConnectionConstraintFor: figure
		at: figure stopPoint.
	aFigure addDependent: figure.
	anotherFigure addDependent: figure.
	figure addStopArrow.
	^figure
! !

!StateTransitionFigure methodsFor:'accessing'!

menuAt: aPoint
	| mb |
	mb := MenuBuilder new.
	mb add: 'Transition type...' -> #changeTransitionType.
	^mb menu
! !

!StateTransitionFigure methodsFor:'actions'!

changeTransitionType
	| editor |
	editor := TransitionEditor onType: model type.
	editor open ifFalse: [^self].
	model type: editor type
! !

!StateTransitionFigure methodsFor:'bounds accessing'!

computePreferredBounds
	^super computePreferredBounds
		merge: (self centerPoint extent: self label extent)
! !

!StateTransitionFigure methodsFor:'changing'!

changed: anAspectSymbol with: aParameter
	model points: points.
	^super changed: anAspectSymbol with: aParameter
! !

!StateTransitionFigure methodsFor:'displaying'!

centerPoint
	| middle |
	middle := points at: points size // 2 + 1.
	^points size odd
		ifTrue: [middle]
		ifFalse: [((points at: points size // 2) + middle) // 2]
!

displayFigureOn: aGraphicsContext
	super displayFigureOn: aGraphicsContext.
	self displayLabelOn: aGraphicsContext
!

displayLabelOn: aGraphicsContext
	self label displayOn: aGraphicsContext at: self centerPoint
!

label
	^self model label asComposedText
! !

!StateTransitionFigure methodsFor:'initialize-release'!

initialize
	super initialize.
	self connectable: false.
	self model: ToolStateTransitionModel new
! !

!StateTransitionFigure methodsFor:'testing'!

isConnectionFigure
	^true
! !

!StateTransitionFigure methodsFor:'updating'!

update: anAspectSymbol with: aParameter from: aSender
	aSender == model ifTrue: [^self recomputePreferredBounds].
	super
		update: anAspectSymbol
		with: aParameter
		from: aSender
! !

!StateTransitionFigure class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__StateTransitionFigure.st,v 1.1 2006/03/13 16:54:24 cg Exp $'
! !
