"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

TrackHandle subclass:#TentativePositionHandle
	instanceVariableNames:'index'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Handles'
!

TentativePositionHandle comment:'TentativePositionHandle is a special handle that allows the user to create a new point on the line. Normally it is displayed between two real points on the line.

Instance Variables:
	index   <Index>   the index of the new point

'
!


!TentativePositionHandle class methodsFor:'instance creation'!

forSegment: anIndex of: aFigure
	^(self new)
		toolState: (Tool stateFor: 'Tentative Position Handle');
		owner: aFigure;
		constrain: #center
			to: (MessageSend
					receiver: aFigure
					selector: #centerOfSegment:
					arguments: (Array with: anIndex));
		index: anIndex + 1;
		moveBlock: [:aPoint | aFigure pointAt: anIndex + 1 put: aPoint];
		yourself
! !

!TentativePositionHandle class methodsFor:'accessing'!

buildImage
	| size |
	size := 6 @ 6.
	image := CompositePart new.
	image
		add: ((GraphicsAttributesWrapper
					on: (FillingWrapper on: (0 @ 0 extent: size)))
						attributes: (GraphicsAttributes new paint: ColorValue gray));
		add: ((GraphicsAttributesWrapper
					on: (FillingWrapper on: (size // 2 - 1 extent: 2 @ 2)))
						attributes: (GraphicsAttributes new paint: ColorValue white)).
	^image
! !

!TentativePositionHandle methodsFor:'accessing'!

index
	^index
!

index: anInteger
	index := anInteger
! !

!TentativePositionHandle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__TentativePositionHandle.st,v 1.1 2006/03/13 16:53:13 cg Exp $'
! !
