"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Drawing subclass:#ToolStateMachineDrawing
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tool Creation GUI'
!


!ToolStateMachineDrawing methodsFor:'accessing'!

menuAt: aPoint
	| mb |
	mb := MenuBuilder new.
	mb
		add: 'Add state' -> [self addStateAt: aPoint];
		line;
		add: 'Verify' -> #verify;
		add: 'Compile' -> #compile;
		line;
		add: 'Inspect...' -> #inspect.
	^mb menu
! !

!ToolStateMachineDrawing methodsFor:'actions'!

addStateAt: aPoint
	self add: (ToolStateFigure createAt: aPoint)
!

compile
	| selector |
	selector := Dialog request: 'Enter a method name:' initialAnswer: ''.
	selector isEmpty ifTrue: [^self].
	model
		compileForClass: Tool class
		selector: selector asSymbol
		ifFail: [:error | ^Dialog warn: error].
	(Dialog confirm: 'Do you want to reinitialize the tools?')
		ifTrue: [Tool reinitialize]
!

verify
	model verifyIfFail: [:error | ^Dialog warn: error]
! !

!ToolStateMachineDrawing methodsFor:'adding'!

add: aFigure
	aFigure isStateFigure ifTrue: [self model addState: aFigure model].
	aFigure isConnectionFigure ifTrue: [self model addConnection: aFigure model].
	^super add: aFigure
!

addAll: aCollection
	aCollection do: [:each | self add: each].
	^aCollection
!

addLast: aFigure
	aFigure isStateFigure ifTrue: [self model addState: aFigure model].
	aFigure isConnectionFigure ifTrue: [self model addConnection: aFigure model].
	^super addLast: aFigure
! !

!ToolStateMachineDrawing methodsFor:'removing'!

remove: aFigure
	aFigure isStateFigure ifTrue: [self model removeState: aFigure model].
	aFigure isConnectionFigure
		ifTrue: [self model removeConnection: aFigure model].
	^super remove: aFigure
!

removeAll: aCollection
	aCollection do: [:each | self remove: each].
	^aCollection
! !

!ToolStateMachineDrawing class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__ToolStateMachineDrawing.st,v 1.1 2006/03/13 16:53:26 cg Exp $'
! !
