"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Model subclass:#ToolStateModel
	instanceVariableNames:'name command position isEndState isExternal'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tool Creation Models'
!


!ToolStateModel class methodsFor:'instance creation'!

new
	^super new initialize
! !

!ToolStateModel methodsFor:'accessing'!

command
	^command
!

command: aString
	command := aString asString.
	self changed: #command
!

isEndState
	^isEndState
!

isEndState: aBoolean
	isEndState := aBoolean.
	self changed: #isEndState
!

isExternal
	^isExternal
!

isExternal: aBoolean
	isExternal := aBoolean.
	self changed: #isExternal
!

name
	^name
!

name: aString
	name := aString asString.
	self changed: #name
!

position
	^position
!

position: aPoint
	position := aPoint
! !

!ToolStateModel methodsFor:'compilation'!

writeDefinitionOn: codeStream
	isExternal ifTrue: [^self].
	codeStream
		nextPutAll: '   Tool states at: ''';
		nextPutAll: name;
		nextPutAll: ''' put: (';
		nextPutAll: (isEndState ifTrue: ['EndToolState'] ifFalse: ['ToolState']);
		nextPutAll: ' name: ''';
		nextPutAll: name;
		nextPutAll: ''' command: ';
		nextPutAll: command;
		nextPutAll: ').';
		cr
! !

!ToolStateModel methodsFor:'initialize-release'!

initialize
	command := '[:tool :event | ]'.
	name := 'state'.
	position := 0 @ 0.
	isEndState := false.
	isExternal := false
! !

!ToolStateModel methodsFor:'storing'!

storeOn: aStream
	| deps |
	deps := self myDependents.
	self myDependents: nil.
	[super storeOn: aStream] valueNowOrOnUnwindDo: [self myDependents: deps]
! !

!ToolStateModel class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__ToolStateModel.st,v 1.1 2006/03/13 16:57:58 cg Exp $'
! !
