"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Model subclass:#ToolStateTransitionModel
	instanceVariableNames:'from to type points'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tool Creation Models'
!


!ToolStateTransitionModel class methodsFor:'instance creation'!

new
	^super new initialize
! !

!ToolStateTransitionModel methodsFor:'accessing'!

from
	^from
!

from: aToolStateModel
	from := aToolStateModel.
	self changed
!

label
	^type printString
!

points
	^points
!

points: aCollection
	points := aCollection
!

to
	^to
!

to: aToolStateModel
	to := aToolStateModel.
	self changed
!

type
	^type
!

type: aTransitionType
	type := aTransitionType.
	self changed
! !

!ToolStateTransitionModel methodsFor:'compilation'!

writeContinuedDefinitionOn: codeStream
	type writeContinuedDefinitionOn: codeStream to: '(Tool stateFor: ''' , to name , ''')'
!

writeDefinitionOn: codeStream
	type writeDefinitionOn: codeStream to: '(Tool stateFor: ''' , to name , ''')'
!

writeStoreStringOn: codeStream
	codeStream
		nextPutAll: ' from: (stateTable at: ''';
		nextPutAll: from name;
		nextPutAll: '''); to: (stateTable at: ''';
		nextPutAll: to name;
		nextPutAll: '''); type: '.
	type storeOn: codeStream.
	codeStream nextPutAll: '; points: '.
	points storeOn: codeStream.
	codeStream nextPutAll: '; yourself'
! !

!ToolStateTransitionModel methodsFor:'initialize-release'!

initialize
	from := to := nil.
	type := TransitionType new
! !

!ToolStateTransitionModel class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__ToolStateTransitionModel.st,v 1.1 2006/03/13 16:57:36 cg Exp $'
! !
