"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Handle subclass:#TrackHandle
	instanceVariableNames:'moveBlock'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Handles'
!

TrackHandle comment:'TrackHandle is a handle that executes a block whenever the cursor is moved. When the mouse button is release, it quits its action.

Instance Variables:
	moveBlock       <BlockClosure>    a block that is executed for each mouse position, it takes one argument (a Point object)

'
!


!TrackHandle class methodsFor:'instance creation'!

bottomLeftOf: aFigure
	^(super bottomLeftOf: aFigure)
		moveBlock: [:aPoint | aFigure bottomLeft: aPoint];
		yourself
!

bottomRightOf: aFigure
	^(super bottomRightOf: aFigure)
		moveBlock: [:aPoint | aFigure bottomRight: aPoint];
		yourself
!

new
	| handle |
	handle := super new.
	handle toolState: (Tool stateFor: 'Track Handle').
	^handle
!

pointAtIndex: anIndex of: aFigure
	| handle |
	handle := self new.
	^handle
		owner: aFigure;
		constrain: #center
			to: (MessageSend
					receiver: aFigure
					selector: #pointAt:
					arguments: (Array with: anIndex));
		moveBlock: [:aPoint | aFigure pointAt: anIndex put: aPoint];
		yourself
!

topLeftOf: aFigure
	^(super topLeftOf: aFigure)
		moveBlock: [:aPoint | aFigure topLeft: aPoint];
		yourself
!

topRightOf: aFigure
	^(super topRightOf: aFigure)
		moveBlock: [:aPoint | aFigure topRight: aPoint];
		yourself
! !

!TrackHandle methodsFor:'accessing'!

moveBlock
	^moveBlock
!

moveBlock: aBlockClosure
	moveBlock := aBlockClosure
! !

!TrackHandle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__TrackHandle.st,v 1.1 2006/03/13 16:54:05 cg Exp $'
! !
