"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Object subclass:#TransitionTable
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tools'
!

TransitionTable comment:'TransitionTable is an abstract class that represents a transition between two states. When sent the nextStateForTool:event: message, it returns the next state for that type of event. If there isn''t a next state for that event, it returns nil.

Subclasses must implement the following messages:
	accessing
		goto:   a default constructer method that makes it easier to create the transition tables independently
		nextStateForTool:event: returns the next state for the event or nil if there isn''t a next state for that event

'
!


!TransitionTable class methodsFor:'instance creation'!

new
	^super new initialize
! !

!TransitionTable methodsFor:'accessing'!

goto: aState
	^self subclassResponsibility
!

nextStateForTool: aTool event: anEvent
	^self subclassResponsibility
! !

!TransitionTable methodsFor:'initialize-release'!

initialize
! !

!TransitionTable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__TransitionTable.st,v 1.1 2006/03/13 16:54:11 cg Exp $'
! !
