"{ Package: 'stx:goodies/hotdraw' }"

"{ NameSpace: HotDraw }"

Object subclass:#TransitionType
	instanceVariableNames:'event'
	classVariableNames:''
	poolDictionaries:''
	category:'HotDraw-Tool Creation Models'
!


!TransitionType class methodsFor:'instance creation'!

new
	^super new initialize
! !

!TransitionType class methodsFor:'accessing'!

transition
	^#always
! !

!TransitionType methodsFor:'accessing'!

characters
	^#()
!

characters: aCollection
!

event
	^event
!

event: aSymbol
	event := aSymbol
!

figureClasses
	^Array with: Figure
!

figureClasses: aCollection
!

priority
	^SmallInteger maxVal
! !

!TransitionType methodsFor:'compilation'!

writeContinuedDefinitionOn: codeStream to: aString
	codeStream nextPutAll: '; '.
	self writeMessageSendOn: codeStream to: aString
!

writeDefinitionOn: codeStream to: aString
	codeStream nextPutAll: '(SimpleTransitionTable new) '.
	self writeMessageSendOn: codeStream to: aString
!

writeMessageSendOn: codeStream to: aString
	codeStream
		nextPutAll: 'goto: ';
		nextPutAll: aString
! !

!TransitionType methodsFor:'initialize-release'!

initialize
	event := #redButtonPress
! !

!TransitionType methodsFor:'printing'!

printOn: aStream
	aStream nextPutAll: event
! !

!TransitionType methodsFor:'verifying'!

conflictsWith: aTransitionType
	^self class == aTransitionType class
! !

!TransitionType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/hotdraw/HotDraw__TransitionType.st,v 1.1 2006/03/13 16:58:17 cg Exp $'
! !
