# $Header: /cvs/stx/stx/goodies/hotdraw/Make.spec,v 1.1 2006/08/18 14:33:18 cg Exp $
#
# --- Make.spec created by stmkmp at Mon Mr 13 21:17:24 MET 2006
#
# This file contains specifications which are common to all platforms.
#
# Warning: once you modify this file, do not rerun
# stmkmp again - otherwise, your changes are lost.
#
# This file contains definitions for Unix based platforms.
#




# module and directory-in-module;
# these should correspond to the directory hierarchy
# location (otherwise, ST/X will have a hard time to
# find out the packages location from its packageID)
MODULE=stx
MODULE_DIR=goodies/hotdraw


# the name of your classLibrary:
# ********** REQUIRED: CHECK the next line ***
LIBNAME=libstx_goodies_hotdraw


# the package is stored as an ID in classes and methods
# to identify code belonging to this project.
# It also specifies the position in the source repository
# and directory tree, when packages are loaded by packageID.
# ********** REQUIRED: CHECK the next line ***
PACKAGE=$(MODULE):$(MODULE_DIR)


# Argument(s) to the stc compiler.
#  -H.         : create header files locally
#                (if removed, they will be created as common
#  -Pxxx       : defines the package
#  -Zxxx       : a prefix for variables within the classLib
#  -Dxxx       : defines passed to to CC for inline C-code
#  -Ixxx       : include path passed to CC for inline C-code
#  +optspace   : optimized for space
#  +optspace2  : optimized more for space
#  +optspace3  : optimized even more for space
#  +optinline  : generate inline code for some ST constructs
#  +inlineNew  : additionally inline new
#  +inlineMath : additionally inline some floatPnt math stuff
#
# ********** OPTIONAL: MODIFY the next line(s) ***
# STCLOCALOPTIMIZATIONS=+optinline +inlineNew
# STCLOCALOPTIMIZATIONS=+optspace3
STCLOCALOPTIMIZATIONS=+optspace3


# Argument(s) to the stc compiler.
#  -warn            : no warnings
#  -warnNonStandard : no warnings about ST/X extensions
#  -warnEOLComments : no warnings about EOL comment extension
#  -warnPrivacy     : no warnings about privateClass extension
#
# ********** OPTIONAL: MODIFY the next line(s) ***
# STCWARNINGS=-warn
# STCWARNINGS=-warnNonStandard
# STCWARNINGS=-warnEOLComments
STCWARNINGS=

OBJS= \
    HotDraw__Figure.$(O) \
    HotDraw__CompositeFigure.$(O) \
    HotDraw__Drawing.$(O) \
    HotDraw__AnimatedDrawing.$(O) \
    HotDraw__ArcFigure.$(O) \
    HotDraw__ArrowAnnotation.$(O) \
    HotDraw__BezierFigure.$(O) \
    HotDraw__BoundaryConstraint.$(O) \
    HotDraw__ButtonDescription.$(O) \
    HotDraw__CachedFigure.$(O) \
    HotDraw__CanvasFigure.$(O) \
    HotDraw__CharacterTransitionTable.$(O) \
    HotDraw__CharacterTransitionType.$(O) \
    HotDraw__CircleAnnotation.$(O) \
    HotDraw__DiamondAnnotation.$(O) \
    HotDraw__DrawingController.$(O) \
    HotDraw__DrawingEditor.$(O) \
    HotDraw__EllipseFigure.$(O) \
    HotDraw__EndToolState.$(O) \
    HotDraw__FigureAttributes.$(O) \
    HotDraw__FigureTransitionTable.$(O) \
    HotDraw__FigureTransitionType.$(O) \
    HotDraw__Handle.$(O) \
    HotDraw__HotPaintEditor.$(O) \
    HotDraw__ImageFigure.$(O) \
    HotDraw__IndexedTrackHandle.$(O) \
    HotDraw__LineAnnotation.$(O) \
    HotDraw__LineFigure.$(O) \
    HotDraw__MovingDrawing.$(O) \
    HotDraw__MovingDrawingEditor.$(O) \
    HotDraw__MovingFigure.$(O) \
    HotDraw__NetworkDrawing.$(O) \
    HotDraw__NetworkEditor.$(O) \
    HotDraw__NetworkNode.$(O) \
    HotDraw__ObjectConnectionModel.$(O) \
    HotDraw__ObjectFigure.$(O) \
    HotDraw__ObjectHandleModel.$(O) \
    HotDraw__ObjectParser.$(O) \
    HotDraw__ObjectWorld.$(O) \
    HotDraw__ObjectWorldDrawing.$(O) \
    HotDraw__ObjectWorldFigureModel.$(O) \
    HotDraw__PERTChart.$(O) \
    HotDraw__PERTEventAppModel.$(O) \
    HotDraw__PERTEventFigure.$(O) \
    HotDraw__PolylineFigure.$(O) \
    HotDraw__PositionConstraint.$(O) \
    HotDraw__RectangleFigure.$(O) \
    HotDraw__RoundedRectangleFigure.$(O) \
    HotDraw__SimpleTransitionTable.$(O) \
    HotDraw__SplineFigure.$(O) \
    HotDraw__StateTransitionFigure.$(O) \
    HotDraw__TentativePositionHandle.$(O) \
    HotDraw__TextFigure.$(O) \
    HotDraw__Tool.$(O) \
    HotDraw__ToolState.$(O) \
    HotDraw__ToolStateCommandEditor.$(O) \
    HotDraw__ToolStateFigure.$(O) \
    HotDraw__ToolStateMachineDrawing.$(O) \
    HotDraw__ToolStateMachineEditor.$(O) \
    HotDraw__ToolStateModel.$(O) \
    HotDraw__ToolStateTransitionModel.$(O) \
    HotDraw__ToolbarController.$(O) \
    HotDraw__ToolbarView.$(O) \
    HotDraw__TrackHandle.$(O) \
    HotDraw__TransitionEditor.$(O) \
    HotDraw__TransitionTable.$(O) \
    HotDraw__TransitionType.$(O) \
    HotDraw__ViewAdapterFigure.$(O)
