"{ Package: 'stx:goodies/iniFile' }"

Object subclass:#INIFileSection
	instanceVariableNames:'iniFile label'
	classVariableNames:''
	poolDictionaries:''
	category:'System-Support-FileFormats'
!


!INIFileSection class methodsFor:'instance creation'!

named: nameString on: anINIFile

    ^ self basicNew initializeWithINIFile: anINIFile label: nameString
!

on: anINIFile label: labelString 

    ^ self basicNew initializeWithINIFile: anINIFile label: labelString
! !

!INIFileSection methodsFor:'accessing'!

addAll: assocCollection

    assocCollection associationsDo:
            [:assoc | self at: assoc key put: assoc value]
!

associations

    ^ Array streamContents:
            [:stream | self associationsDo: [:ea | stream nextPut: ea]]
!

associationsDo: aBlock

    self iniFile section: self label associationsDo: aBlock
!

at: keyString

    ^ self at: keyString ifAbsent: [self error: 'No value specified for key in section']
!

at: keyString ifAbsent: aBlock

    ^ self iniFile section: self label at: keyString ifAbsent: aBlock
!

at: keyString put: valueString

    ^ self iniFile section: self label at: keyString put: valueString
! !

!INIFileSection methodsFor:'initialization'!

initializeWithINIFile: anINIFile label: labelString

    iniFile := anINIFile.
    label := labelString.
! !

!INIFileSection methodsFor:'private'!

iniFile

    ^ iniFile
!

label

    ^ label
!

writeOn: aStream

    self label isNil ifTrue:[^ self].
    aStream nextPutAll: '[', self label, ']'; cr.
    self associationsDo:[:assoc | 
        assoc key notNil ifTrue:[
            aStream nextPutAll: assoc key, '=', (assoc value ifNil: ['']); cr.
        ].
    ].
! !

!INIFileSection methodsFor:'testing'!

isEmpty

    self associationsDo: [:ea | ^ false].
    
    ^ true
! !

!INIFileSection class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/iniFile/INIFileSection.st,v 1.3 2008/06/20 09:45:53 cg Exp $'
! !
