"{ Package: 'stx:goodies/iniFile' }"
!

!Object methodsFor:'@ INIFile'!

caseError
    "Report an error from an in-line or explicit case statement."

    self error: 'Case not found, and no otherwise clause'
! !

!Object methodsFor:'@ INIFile'!

caseOf: aBlockAssociationCollection
    "The elements of aBlockAssociationCollection are associations between blocks.
     Answer the evaluated value of the first association in aBlockAssociationCollection
     whose evaluated key equals the receiver.  If no match is found, report an error."

    ^ self caseOf: aBlockAssociationCollection otherwise: [self caseError]

    "| z | z := Dictionary newFrom: (Array with:([#a]->[1+1]) with: (['b' asSymbol]->[2+2]) with: ([#c]->[3+3])). #b caseOf: z"
    "| z | z := Dictionary newFrom: (Array with:([#a]->[1+1]) with: (['d' asSymbol]->[2+2]) with: ([#c]->[3+3])). #b caseOf: z"
! !

!Object methodsFor:'@ INIFile'!

caseOf: aBlockAssociationCollection otherwise: aBlock
    "The elements of aBlockAssociationCollection are associations between blocks.
     Answer the evaluated value of the first association in aBlockAssociationCollection
     whose evaluated key equals the receiver.  If no match is found, answer the result
     of evaluating aBlock."

    aBlockAssociationCollection associationsDo:
        [:assoc | (assoc key value = self) ifTrue: [^assoc value value]].
    ^ aBlock value

    "| z | z := Dictionary newFrom: (Array with:([#a]->[1+1]) with: (['b' asSymbol]->[2+2]) with: ([#c]->[3+3])). #b caseOf: z otherwise: [0]"
    "| z | z := Dictionary newFrom: (Array with:([#a]->[1+1]) with: (['d' asSymbol]->[2+2]) with: ([#c]->[3+3])). #b caseOf: z otherwise: [0]"
! !

