"{ Package: 'stx:goodies/lisp' }"

"{ NameSpace: Lisp }"

SequenceableCollection subclass:#LispList
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Lisp'
!

!LispList class methodsFor:'documentation'!

documentation
"
    Lisp
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"

! !

!LispList class methodsFor:'instance creation'!

cell
	^self subclassResponsibility
!

head: headObject 
	^self subclassResponsibility
!

head: headObject tail: tailObject 
	^self subclassResponsibility
!

list: anArray 
	"LispCons list: #(1 2 3 4)"

	| size list |
	size := anArray size.
	list := self null.
	size
		to: 1
		by: -1
		do: [:i | list := self head: (anArray at: i)
						tail: list].
	^list
!

new: anInteger 
	"LispCons new: 5"

	| newList |
	newList := self null.
	anInteger timesRepeat: [newList := self head: self null tail: newList].
	^newList
!

null
	^self subclassResponsibility
!

with: anObject 
	"LispCons with: 1"

	^self head: anObject
!

with: firstObject with: secondObject 
	"LispCons with: 1 with: 2"

	^self head: firstObject tail: (self with: secondObject)
!

with: firstObject with: secondObject with: thirdObject 
	"LispCons with: 1 with: 2 with: 3"

	^self head: firstObject tail: (self with: secondObject with: thirdObject)
!

with: firstObject with: secondObject with: thirdObject with: fourthObject 
	"LispCons with: 1 with: 2 with: 3 with: 4"

	^self head: firstObject tail: (self
			with: secondObject
			with: thirdObject
			with: fourthObject)
! !

!LispList methodsFor:'accessing'!

at: indexInteger put: anObject 
	^self subscriptOutOfBoundsError: indexInteger
!

size
	| tally |
	tally := 0.
	self do: [:each | tally := tally + 1].
	^tally
! !

!LispList methodsFor:'private'!

subscriptOutOfBoundsError: index 
	^self error: 'subscript out of bounds: ' , index printString
! !

!LispList methodsFor:'testing'!

isCons
	^self null not
!

null
	^false
! !

!LispList class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/lisp/LispList.st,v 1.6 2002/11/22 20:06:38 cg Exp $'
! !
