"{ Package: 'stx:goodies/lisp' }"

"{ NameSpace: Lisp }"

LispList subclass:#LispNil
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Lisp'
!

LispNil class instanceVariableNames:'null'

"
 No other class instance variables are inherited by this class.
"
!

!LispNil class methodsFor:'documentation'!

documentation
"
    Lisp
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"

! !

!LispNil class methodsFor:'instance creation'!

cell
	^LispCons cell
!

new
	^self null
!

null
	null isNil ifTrue: [null := super new].
	^null
! !

!LispNil class methodsFor:'class initialization'!

initialize
	"LispNil initialize."

	self null
! !

!LispNil methodsFor:'accessing'!

head
	^self
!

tail
	^self
! !

!LispNil methodsFor:'enumerating'!

do: aBlock 
	^self
! !

!LispNil methodsFor:'functions'!

append: list 
	^list
!

length
	^0
!

mapcdr: aBlock 
	^self
!

member: anObject 
	^self
!

nconc: list 
	^list
!

nth: nth 
	^self
!

reverse
	^self
! !

!LispNil methodsFor:'pretty printing'!

ppOn: aStream 
	aStream nextPutAll: 'nil'.
	aStream cr
!

ppString
	^'nil\' withCRs
! !

!LispNil methodsFor:'printing'!

printOn: aStream 
	aStream nextPutAll: 'nil'
! !

!LispNil methodsFor:'saving'!

saveOn: aStream 
	aStream nextPutAll: 'nil'
!

saveString
	^'nil'
! !

!LispNil methodsFor:'testing'!

null
	^true
! !

!LispNil class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/lisp/LispNil.st,v 1.6 2002/11/22 20:06:59 cg Exp $'
! !

LispNil initialize!
