"{ Package: 'stx:goodies/lisp' }"

"{ NameSpace: Lisp }"

Array variableSubclass:#LispScannerTable
	instanceVariableNames:''
	classVariableNames:'ScanningTable'
	poolDictionaries:''
	category:'Languages-Lisp'
!

!LispScannerTable class methodsFor:'documentation'!

documentation
"
    Lisp
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"

! !

!LispScannerTable class methodsFor:'class initialization'!

initialize
	"LispScannerTable initialize."

	| newTable |
	newTable := self new: 256 withAll: #xBinary.
	newTable atAll: #(9 10 12 13 32 ) put: #xDelimiter.
	newTable atAll: ($0 asInteger to: $9 asInteger)
		put: #xDigit.
	newTable atAll: ($A asInteger to: $Z asInteger)
		put: #xSymbol.
	newTable atAll: ($a asInteger to: $z asInteger)
		put: #xSymbol.
	128 to: 256 do: [:i | newTable at: i put: #xSymbol].
	newTable at: $' asInteger put: #quote.
	newTable at: $" asInteger put: #xDoubleQuote.
	newTable at: ${ asInteger put: #xBrace.
	newTable at: $+ asInteger put: #xSign.
	newTable at: $- asInteger put: #xSign.
	newTable at: $< asInteger put: #xSymbol.
	newTable at: $> asInteger put: #xSymbol.
	newTable at: $= asInteger put: #xSymbol.
	newTable at: $~ asInteger put: #xSymbol.
	newTable at: $* asInteger put: #xSymbol.
	newTable at: $/ asInteger put: #xSymbol.
	newTable at: $_ asInteger put: #xSymbol.
	newTable at: $: asInteger put: #xSymbol.
	newTable at: $, asInteger put: #xSymbol.
	newTable at: $\ asInteger put: #xSymbol.
	newTable at: $% asInteger put: #xComment.
	newTable at: $( asInteger put: #leftParenthesis.
	newTable at: $) asInteger put: #rightParenthesis.
	newTable at: $. asInteger put: #period.
	newTable at: $` asInteger put: #quote.
	newTable at: $!! asInteger put: #eof.
	ScanningTable := newTable
! !

!LispScannerTable class methodsFor:'table access'!

scannerTable
	^ScanningTable
! !

!LispScannerTable methodsFor:'accessing'!

at: index 
	(index isInteger and: [index between: 257 and: 65536])
		ifTrue: [(index - 1) asCharacter isLetter
				ifTrue: [^#xSymbol]
				ifFalse: [^#xBinary]]
		ifFalse: [^super at: index]
! !

!LispScannerTable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/lisp/LispScannerTable.st,v 1.6 2002/11/22 20:06:18 cg Exp $'
! !

LispScannerTable initialize!
