"{ Package: 'stx:goodies/lisp' }"

"{ NameSpace: Lisp }"

Object variableSubclass:#LispTable
	instanceVariableNames:'properties'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Lisp'
!

!LispTable class methodsFor:'documentation'!

documentation
"
    Lisp
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"

! !

!LispTable class methodsFor:'instance creation'!

new
	^super new initialize
! !

!LispTable methodsFor:'accessing'!

at: symbol 
	^self getprop: symbol key: #apval
!

at: symbol put: value 
	self intern: symbol.
	^self
		putprop: symbol
		key: #apval
		value: value
!

identifiers
	^properties keys asSortedCollection
! !

!LispTable methodsFor:'adding'!

add: symbol 
	self intern: symbol
! !

!LispTable methodsFor:'initialize-release'!

initialize
	properties := Dictionary new
! !

!LispTable methodsFor:'private'!

errorSymbolNotFound
	self error: 'symbol not found'
!

intern: symbol 
	(properties includesKey: symbol)
		ifFalse: [properties at: symbol put: Dictionary new].
	^symbol
! !

!LispTable methodsFor:'property access'!

getprop: identifier key: key 
	| property |
	property := properties at: identifier ifAbsent: [^self errorSymbolNotFound].
	^property at: key ifAbsent: [^nil]
!

putprop: identifier key: key value: value 
	| property |
	property := properties at: identifier ifAbsent: [^self errorSymbolNotFound].
	^property at: key put: value
!

remprop: identifier key: key 
	| property |
	property := properties at: identifier ifAbsent: [^self errorSymbolNotFound].
	^property removeKey: key ifAbsent: [^nil]
! !

!LispTable methodsFor:'removing'!

remove: symbol
	^properties removeKey: symbol ifAbsent: [^nil]
! !

!LispTable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/lisp/LispTable.st,v 1.6 2002/11/22 20:06:24 cg Exp $'
! !
