"
 COPYRIGHT (c) 2005-2011 by Jan Vrany & Martin Dvorak

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/loggia' }"

"{ NameSpace: Loggia }"

FileTransport subclass:#BOSSFileTransport
	instanceVariableNames:'storage autoProxy dropAttachment'
	classVariableNames:''
	poolDictionaries:''
	category:'Loggia-Transports'
!

!BOSSFileTransport class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2005-2011 by Jan Vrany & Martin Dvorak

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
! !

!BOSSFileTransport methodsFor:'accessing'!

autoProxy
    ^ autoProxy

    "Created: / 20-05-2005 / 11:13:47 / masca"
!

autoProxy: aBoolean

    autoProxy := aBoolean

    "Created: / 20-05-2005 / 11:13:47 / masca"
!

configurationUI

    ^BOSSFileTransportUI on: self

    "Created: / 20-05-2005 / 11:15:25 / masca"
!

dropAttachment
    ^ dropAttachment

    "Created: / 20-05-2005 / 11:13:47 / masca"
!

dropAttachment:aBoolean

    dropAttachment := aBoolean

    "Created: / 20-05-2005 / 11:13:47 / masca"
! !

!BOSSFileTransport methodsFor:'initialization'!

initialize

    super initialize.

    renewal := false.
    autoProxy := true.
    dropAttachment := true

    "Created: / 20-05-2005 / 11:18:18 / masca"
! !

!BOSSFileTransport methodsFor:'private'!

closeFile
    storage close.
    storage := nil.

    "Created: / 25-12-2008 / 11:59:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!BOSSFileTransport methodsFor:'processing'!

process: aLogMessage

    autoProxy ifTrue: [aLogMessage dropOriginator].
    dropAttachment ifTrue: [aLogMessage dropAttachedObject].

    mutex critical: [
        storage ifNil: [storage := BinaryObjectStorage onNew: filename asFilename writeStream].
        storage nextPut: aLogMessage
    ]

    "Created: / 20-05-2005 / 11:15:59 / masca"
    "Modified: / 23-06-2005 / 09:25:35 / masca"
! !

!BOSSFileTransport methodsFor:'testing'!

isBOSSFileTransport

    ^true

    "Modified: / 20-05-2005 / 11:46:32 / masca"
!

isSetUp

    ^filename notEmptyOrNil

    "Created: / 20-05-2005 / 11:45:36 / masca"
! !

!BOSSFileTransport methodsFor:'utilities'!

storeConfigurationOf: aString on: aStream

    super storeConfigurationOf: aString on: aStream.

    filename ifNotNil: [
        self to: aString send: 'filename:' with: filename asString storeString on: aStream].
    self to: aString send: 'renewal:' with: renewal on: aStream.

    self to: aString send: 'autoProxy:' with: autoProxy on: aStream.
    self to: aString send: 'dropAttachment:' with: dropAttachment on: aStream

    "Created: / 20-05-2005 / 12:03:18 / masca"
! !

!BOSSFileTransport class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/loggia/Loggia__BOSSFileTransport.st,v 1.1 2011/10/31 11:08:20 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/loggia/Loggia__BOSSFileTransport.st,v 1.1 2011/10/31 11:08:20 vrany Exp $'
!

version_SVN
    ^ 'Id: Loggia__BOSSFileTransport.st 20 2011-09-01 15:04:29Z vranyj1 '
! !
