"
 COPYRIGHT (c) 2005-2011 by Jan Vrany & Martin Dvorak

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:goodies/loggia' }"

"{ NameSpace: Loggia }"

Object subclass:#LogFacility
	instanceVariableNames:'levels colors'
	classVariableNames:''
	poolDictionaries:''
	category:'Loggia'
!

!LogFacility class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2005-2011 by Jan Vrany & Martin Dvorak

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
! !

!LogFacility class methodsFor:'instance creation'!

new

    ^self basicNew initialize
! !

!LogFacility methodsFor:'accessing'!

colorFor: severitySymbol

    ^colors
        at: severitySymbol
        ifAbsent: [nil]

    "Created: / 20-05-2005 / 09:37:35 / masca"
!

colors
    ^ colors

    "Created: / 30-05-2005 / 15:28:59 / masca"
!

for: severitySymbol use: aLogTransport

    levels
        at: severitySymbol
        put: aLogTransport
!

for: severitySymbol useColor: aColor

    (levels includesKey: severitySymbol)
        ifTrue: [
            aColor
                ifNil: [levels removeKey: severitySymbol]
                ifNotNil: [colors
                    at: severitySymbol
                    put: aColor]]

    "Created: / 20-05-2005 / 09:37:09 / masca"
    "Modified: / 20-05-2005 / 14:25:05 / masca"
!

levels

    ^levels
!

name

    ^Logger default facilityNameFor: self
!

registeredLevels

    ^levels
!

removeLevel: severitySymbol

    (self registeredLevels includes: severitySymbol)
        ifTrue: [self error: 'System severity level cannot be removed.'].

    levels
        removeKey: severitySymbol
        ifAbsent: [self error: 'Severity level not reistered.'].

    colors
        removeKey: severitySymbol
        ifAbsent: [nil]

    "Modified: / 20-05-2005 / 09:36:49 / masca"
! !

!LogFacility methodsFor:'accessing-presentation'!

string

    ^self name

    "Created: / 01-09-2011 / 10:35:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LogFacility methodsFor:'initialization'!

initialize

    super initialize.

    levels := Dictionary new.
    colors := Dictionary new.
    self setupSystemLevels

    "Modified: / 20-05-2005 / 09:36:22 / masca"
! !

!LogFacility methodsFor:'printing'!

displayString

    ^self name
! !

!LogFacility methodsFor:'private'!

setupSystemLevels

    | transcript |
    transcript := Logger transports.
    self systemLevels do: [:e | self for: e use: TranscriptTransport default]

    "Modified: / 05-05-2005 / 14:01:00 / masca"
!

systemLevels

    ^#(#trace #debug #info #warn #error #fatal)

    "Modified: / 01-09-2011 / 14:11:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

transportForSeverity: aSymbol

    ^levels
        at: aSymbol
        ifAbsent: [levels
            at: #warn
            ifAbsent: [self error: 'Warning log severity undefined, something goes wrong.']]
! !

!LogFacility methodsFor:'processing'!

commitSeverity: aSymbol

    (self transportForSeverity: aSymbol) commit
!

log: aLogMessage

    (self transportForSeverity: aLogMessage severity) process: aLogMessage
!

resetSeverity: aSymbol

    (self transportForSeverity: aSymbol) reset
! !

!LogFacility class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/loggia/Loggia__LogFacility.st,v 1.1 2011/10/31 11:08:49 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/loggia/Loggia__LogFacility.st,v 1.1 2011/10/31 11:08:49 vrany Exp $'
!

version_SVN
    ^ 'Id: Loggia__LogFacility.st 20 2011-09-01 15:04:29Z vranyj1 '
! !
