"{ Package: 'stx:goodies/loggia' }"

LibraryDefinition subclass:#stx_goodies_loggia
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_loggia class methodsFor:'documentation'!

documentation
"    
 Copyright (c) 2005-2010 Martin Dvorak and Jan Vrany

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!stx_goodies_loggia class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/communication'    "SMTPClient - referenced by Loggia::MailTransport>>sendMessages: "
        #'stx:libbasic'    "GenericException - superclass of Loggia::HaltingTransport::HaltingTransportException "
        #'stx:libbasic2'    "Socket - referenced by Loggia::SyslogTransport>>initialize "
        #'stx:libboss'    "BinaryObjectStorage - referenced by Loggia::InMemoryTransport>>saveMessagesTo: "
        #'stx:libtool'    "AbstractSettingsApplication - superclass of Loggia::LoggiaSettingsApplication "
        #'stx:libview'    "Color - referenced by Loggia::FacilitiesUI class>>severityColors "
        #'stx:libview2'    "ApplicationModel - superclass of Loggia::DirectoryTransportUI "
        #'stx:libwidg2'    "TabItem - referenced by Loggia::LoggiaUI class>>tabList "
    )
! !

!stx_goodies_loggia class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'Loggia::LogFacility'
        #'Loggia::LogMessage'
        #'Loggia::LogOriginatorProxy'
        #'Loggia::LogTransport'
        #'Loggia::Logger'
        #'Loggia::LoggiaSettingsApplication'
        #'Loggia::AbstractUI'
        #'stx_goodies_loggia'
        #'Loggia::BOSSFileTransportUI'
        #'Loggia::CustomBlockTransport'
        #'Loggia::CustomBlockTransportUI'
        #'Loggia::DirectoryTransport'
        #'Loggia::DirectoryTransportUI'
        #'Loggia::FacilitiesUI'
        #'Loggia::FileTransport'
        #'Loggia::HaltingTransport'
        #'Loggia::InMemoryTransport'
        #'Loggia::InMemoryTransportUI'
        #'Loggia::LogMessagesBrowserUI'
        #'Loggia::LoggiaUI'
        #'Loggia::MailTransport'
        #'Loggia::MailTransportUI'
        #'Loggia::MultiplexTransport'
        #'Loggia::MultiplexTransportUI'
        #'Loggia::NullTransport'
        #'Loggia::PlainFileTransportUI'
        #'Loggia::SMSTransport'
        #'Loggia::SyslogTransport'
        #'Loggia::SyslogTransportUI'
        #'Loggia::TranscriptTransport'
        #'Loggia::TransportsUI'
        #'Loggia::BOSSFileTransport'
        #'Loggia::PlainFileTransport'
        #'Loggia::CSVTransport'
        #'Loggia::LogFileTransport'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!stx_goodies_loggia class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eFractal s.r.o. & CVUT-FEL'

    "Modified: / 08-04-2008 / 14:54:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Logging framework for Smalltalk/X'

    "Modified: / 08-04-2008 / 14:54:49 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Martin Dvorak 2006 & Jan Vrany 2007-2008'

    "Modified: / 08-04-2008 / 14:55:43 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Logging framework for Smalltalk/X'

    "Modified: / 08-04-2008 / 14:54:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!stx_goodies_loggia class methodsFor:'description - svn'!

svnRepositoryUrlString
    "Return a SVN repository URL of myself.
     (Generated since 2011-04-08)
    "        

    ^ '$URL$'
!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"'24'"$"
! !

!stx_goodies_loggia class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/loggia/stx_goodies_loggia.st,v 1.3 2011/10/31 11:11:33 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/loggia/stx_goodies_loggia.st,v 1.3 2011/10/31 11:11:33 vrany Exp $'
!

version_SVN
    ^ 'Id: stx_goodies_loggia.st 21 2011-09-06 09:27:00Z vranyj1 '
! !
