"{ Package: 'stx:goodies/math/algebraicNumbers' }"

"{ NameSpace: Math }"

MatrixReducer subclass:#EuclideanMatrixReducer
	instanceVariableNames:'euclideanFunction'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-SqMath-Algorithms'
!

EuclideanMatrixReducer comment:'An EuclideanMatrixReducer is stored as a matrix with coefficients in an Euclidean domain and the respective euclidean function. Because I''m a subclass of MatrixReducer, I has a few methods. The creation method is for example:
        EuclideanMatrixReducer matrix: aMatrix euclideanFunction: grado.
You can play in Morphic word to see al the things I can do. 

|x|
x _ Variable name: #x.
(EuclideanMatrixReducer new matrix:(Matrix new addRow: (x*x+2,(2+x));addRow: (x+5,x);yourself) euclideanFunction: [: a| a deg]) inspect

|x|
x _ Variable name: #x.
Matrix new addRow: (x*x+2,(2+x));addRow: (x+5,x); yourself

|x|
x _ Variable name: #x.
Matrix new addRow: (x*x+2,(2+x));addRow: (x+5,x); yourself
'
!


!EuclideanMatrixReducer methodsFor:'accesing'!

matrix: aMatrix 
	self matrix: aMatrix euclideanFunction: [:x | x abs].
!

matrix: aMatrix euclideanFunction: aOneArgumentBlock
	super matrix: aMatrix.
	euclideanFunction _ aOneArgumentBlock
! !

!EuclideanMatrixReducer methodsFor:'private - procces'!

killColumn
	" private - kills a column of the matrix using the current pivot "
	| pivotRow pivotValue |
	pivotValue _ self matrix at: self pivot.
	pivotRow _ (self matrix row: self pivot y) negated.
	((1 to: self matrix colDim) asSet remove: self pivot y;	yourself)
		do: [:eachRow |
		self matrix
			row: eachRow
			add: pivotRow * ((self matrix at: self pivot x@eachRow) // pivotValue)]
!

nextPivot
	" private - Returns the next free pivot"
	| col unusedRows candidates pivotCol |
	unusedRows _ self unusedRows.
	pivotCol _ col _ self pivot isNil
						ifTrue: [1]
						ifFalse: [self pivot x].
	[col <= self matrix rowDim and: [unusedRows isEmpty not]]
		whileTrue: [
			candidates _ SortedCollection sortBlock: [:a :b | a key < b key].
			unusedRows do: [:eachRow |
				(self matrix at: col@eachRow) isNull ifFalse: [
					candidates add: (euclideanFunction value: (self matrix at: col @ eachRow)) -> eachRow]].
			candidates isEmpty ifFalse: [
				candidates _ candidates first value.
				(pivotCol = col and: [self pivots isEmpty not])
					ifTrue: [self pivots removeLast].
				^ col @ candidates].
			col _ col + 1].
	^ nil
! !

!EuclideanMatrixReducer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/algebraicNumbers/EuclideanMatrixReducer.st,v 1.1 2002/11/22 19:48:42 cg Exp $'
! !
