"{ Package: 'stx:goodies/math/algebraicNumbers' }"

"{ NameSpace: Math }"

Variable subclass:#RaisedVariable
	instanceVariableNames:'degree'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-SqMath-Algebra'
!

RaisedVariable comment:'I''m a subclass of Variable, I''m borned to be used in Monomials and Polynomials.
In addition to what a standard Variable can do, I can be #raisedToInteger:
'
!


!RaisedVariable class methodsFor:'instance creation'!

name: aSymbol deg: aNumber
	^ (super name: aSymbol) deg: aNumber
! !

!RaisedVariable methodsFor:'accessing'!

deg
	" public - answer my degree, if it was not initialized assume it's 1"
	degree ifNil: [self deg: 1].
	^ degree
!

deg: anInteger
	" public - set my degree"
	degree _ anInteger.
! !

!RaisedVariable methodsFor:'arithmetic'!

raisedToInteger: anInteger
	" public - answer myself raised to the aNumberth power"
	^ self clone deg: self deg*anInteger
!

reciprocal
	"public - my reciprocal is a copy of myself but with degree negated"
	^self clone deg: self deg negated
! !

!RaisedVariable methodsFor:'comparing'!

= aVariable
	^ super = aVariable and: [
		self deg = aVariable deg]
!

hash
	^ (super hash * self deg) hash
!

lexSmallerThan: aVariable
	^ (super lexSmallerThan: aVariable) or: [
		self deg < aVariable deg and: [
		self name = aVariable name]]
! !

!RaisedVariable methodsFor:'evaluating'!

valueAt: anObject
	"my evaluation method is:"
	^ (super valueAt: anObject) raisedToInteger: self deg
! !

!RaisedVariable methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	self deg ~= 1 ifTrue: [ aStream nextPut: $^. self deg printOn: aStream]
! !

!RaisedVariable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/algebraicNumbers/RaisedVariable.st,v 1.1 2002/11/22 19:48:37 cg Exp $'
! !
