"{ Package: 'stx:goodies/math/algebraicNumbers' }"
!

!Number methodsFor:'Tuple creation'!

, anObject
    "Answer a Tuple with the receiver as the first coordinate
    an anObject as the second."

    #AddedByLC.
    ^Tuple from: (Array with: self with: anObject)
! !

!Number methodsFor:'AlgebraicNumber support'!

adaptAlgebraicNumber: anAlgebraicNumber
	^ anAlgebraicNumber
! !

!Number methodsFor:'Polynomial support'!

adaptMonicMonomial: aMonicMonomial
	"If I am involved in arithmetic with a Monomial, I must know whether to convert it."
	^ aMonicMonomial asMonomial
! !

!Number methodsFor:'Polynomial support'!

adaptMonomial: aMonomial
	"If I am involved in arithmetic with a Monomial, I must know whether to convert it."
	^ aMonomial
! !

!Number methodsFor:'Polynomial support'!

adaptPolynomial: aPolynomial
	"If I am involved in arithmetic with a Monomial, I must know whether to convert it."
	^ aPolynomial
! !

!Number methodsFor:'AlgebraicNumber support'!

adaptToAlgebraicNumber
	^ self asAlgebraicNumber
! !

!Number methodsFor:'Polynomial support'!

adaptToMonicMonomial
	"If I am involved in arithmetic with a Float, I must know whether to be converted."
	^ self asMonomial
! !

!Number methodsFor:'Polynomial support'!

adaptToMonomial
	"If I am involved in arithmetic with a Float, I must know whether to be converted."
	^ self asMonomial
! !

!Number methodsFor:'Polynomial support'!

adaptToPolynomial
	"If I am involved in arithmetic with a Float, I must know whether to be converted."
	^ self asPolynomial
! !

!Number methodsFor:'Polynomial support'!

adaptToVariable
	"If I am involved in arithmetic with a Variable, I must know whether to be converted."
	^ self asMonomial
! !

!Number methodsFor:'Polynomial support'!

adaptVariable: aVariable
	"If I am involved in arithmetic with a Variable, I must know whether to convert it."
	^ aVariable asMonomial
! !

!Number methodsFor:'AlgebraicNumber support'!

asAlgebraicNumber
	^ (Smalltalk at: #AlgebraicNumber) fromNumber: self
! !

!Number methodsFor:'Polynomial support'!

asMonomial
        "Answer a Monomial that represents me"

        ^ Math::Monomial fromNumber: self

    "Modified: / 04-10-2006 / 15:30:35 / cg"
! !

!Number methodsFor:'Polynomial support'!

asPolynomial
        "Answer a Monomial that represents me"

        ^ Math::Polynomial fromNumber: self

    "Modified: / 04-10-2006 / 16:32:53 / cg"
! !

!Number methodsFor:'Polynomial support'!

asSimplePolynomial
	"Answer a Monomial that represents me"

	^ self
! !

!Number methodsFor:'AlgebraicNumber support'!

isAlgebraic
	^ false
! !

!Number methodsFor:'testing'!

isNull
	"Answers if I'm 0 or not"
	^ self == 0
! !

!Object methodsFor:'testing'!

isMonicMonomial
	^ false
! !

!Object methodsFor:'testing'!

isMonomial
	^ false
! !

!Object methodsFor:'testing'!

isPolynomial
	^ false
! !

!SortedCollection methodsFor:'comparing'!

< aSortedCollection
	"ari y r++ 6/25/1998 00:23
		Answer true if I'm lexicografically smaller, using my sortBlock, than aSortedCollection."
	1 to: (self size min: aSortedCollection size) do: [:eachIndex |
		(self sortBlock value: (self at: eachIndex) value: (aSortedCollection at: eachIndex))
			ifTrue: [^true].
		(self sortBlock value: (aSortedCollection at: eachIndex) value: (self at: eachIndex))
			ifTrue: [^false]].
	^ self size < aSortedCollection size
! !

