"{ Package: 'stx:goodies/math/dhbNumeric' }"

DhbSeriesTermServer subclass:#DhbIncompleteBetaFractionTermServer
	instanceVariableNames:'alpha1 alpha2'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-DHB Numerical'
!


!DhbIncompleteBetaFractionTermServer methodsFor:'information'!

initialTerm
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 15/3/99 "
	^1
!

termsAt: anInteger 
	"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 15/3/99 "

	| n n2 |
	n := anInteger // 2.
	n2 := 2 * n.
	^Array with: ( n2 < anInteger 
		ifTrue: 
			[x negated * (alpha1 + n) * (alpha1 + alpha2 + n) 
				/ ((alpha1 + n2) * (alpha1 + 1 + n2))]
		ifFalse: [x * n * (alpha2 - n) / ((alpha1 + n2) * (alpha1 - 1 + n2))])
			with: 1
! !

!DhbIncompleteBetaFractionTermServer methodsFor:'initialization'!

setParameter: aNumber1 second: aNumber2 
	"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 15/3/99 "

	alpha1 := aNumber1.
	alpha2 := aNumber2
! !

!DhbIncompleteBetaFractionTermServer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/dhbNumeric/DhbIncompleteBetaFractionTermServer.st,v 1.3 2006/10/04 13:58:15 cg Exp $'
! !
