"{ Package: 'stx:goodies/dhbNumeric' }"

Object subclass:#PointSeries
	instanceVariableNames:'points'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-DHB Numerical'
!


!PointSeries class methodsFor:'creation'!

new
	"Create a new instance and initialize it"
	^super new initialize
! !

!PointSeries methodsFor:'privateMethods'!

primitiveAdd: aPoint
	"Private - Add a point to the receiver"
	points add: aPoint.
!

primitiveRemove: aPoint
	"Private - Removes a point from the receiver"
	points remove: aPoint.
!

sortBlock
		"Private -
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 27/5/99 "
	^[ :a :b | a x < b x]
! !

!PointSeries methodsFor:'public methods'!

add: anObject
	"Add a point to the receiver"
	self primitiveAdd: anObject.
	self changed: self changedSymbol.
	^anObject
!

at: anInteger
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 18/3/99 "
	^points at: anInteger
!

changedSymbol
	"Answers the symbol of the event sent when the points of the receiver change"
	^#pointsChanged
!

collectPoints: aBlock
	^points collect: aBlock
!

do: aBlock
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 18/3/99 "
	self pointsDo: aBlock.
!

firstPoint
	"Answers the first point stored in the receiver"
	^self at: 1
!

initialize
	"Create the point collection"
	points := SortedCollection sortBlock: self sortBlock.
	^self
!

isEmpty
		"
		 (c) Copyrights Didier BESSET, 1998, all rights reserved.
		 Initial code: 28/9/98 "
	^points isEmpty
!

notEmpty
	^points notEmpty
!

pointCollection
		" Answer the collection of points.
		 (c) Copyrights Didier BESSET, 1998, all rights reserved.
		 Initial code: 28/9/98 "
	^self collectPoints: [ :each | each]
!

pointsDo: aBlock
	points do: aBlock.
!

remove: anObject
	"Add a point to the receiver"
	self primitiveRemove: anObject.
	self changed: self changedSymbol.
	^anObject
!

size
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 18/3/99 "
	^points size
!

sort
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 27/5/99 "
	points := ( points asSortedCollection: self sortBlock) asOrderedCollection.
! !

!PointSeries class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/dhbNumeric/PointSeries.st,v 1.2 2002/11/14 18:15:25 cg Exp $'
! !
