"{ Package: 'stx:goodies/math/dhbNumeric' }"

LibraryDefinition subclass:#stx_goodies_math_dhbNumeric
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects *'
!


!stx_goodies_math_dhbNumeric class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:libbasic'
    )
! !

!stx_goodies_math_dhbNumeric class methodsFor:'description - contents'!

classNamesAndAttributes
    "<className> or (<className> attributes...) in load order"

    ^ #(
        DhbAbstractDataServer
        DhbChromosomeManager
        DhbCluster
        DhbCongruentialRandomNumberGenerator
        DhbDecimalFloatingNumber
        DhbErfApproximation
        DhbFloatingPointMachine
        DhbHistogram
        DhbIncompleteBetaFunction
        DhbIncompleteGammaFunction
        DhbIterativeProcess
        DhbLUPDecomposition
        DhbLagrangeInterpolator
        DhbLanczosFormula
        DhbLinearEquationSystem
        DhbLinearRegression
        DhbMahalanobisCenter
        DhbMatrix
        DhbMinimizingPoint
        DhbMitchellMooreGenerator
        DhbPolynomial
        DhbPolynomialLeastSquareFit
        DhbProbabilityDensity
        DhbProbabilityDistributionFunction
        DhbProjectedOneVariableFunction
        DhbScaledProbabilityDensityFunction
        DhbSeriesTermServer
        DhbStatisticalMoments
        DhbVector
        DhbVectorAccumulator
        DhbWeightedPoint
        PointSeries
        #'stx_goodies_math_dhbNumeric'
        DhbAsymptoticChiSquareDistribution
        DhbBetaDistribution
        DhbCauchyDistribution
        DhbClusterFinder
        DhbCovarianceAccumulator
        DhbCovarianceCluster
        DhbEstimatedPolynomial
        DhbEuclideanCluster
        DhbExponentialDistribution
        DhbFastStatisticalMoments
        DhbFisherSnedecorDistribution
        DhbFisherTippettDistribution
        DhbFixedStatisticalMoments
        DhbFunctionalIterator
        DhbGammaDistribution
        DhbHistogrammedDistribution
        DhbIncompleteBetaFractionTermServer
        DhbIncompleteBetaFunctionFraction
        DhbIncompleteGammaFractionTermServer
        DhbIncompleteGammaSeriesTermServer
        DhbInfiniteSeries
        DhbJacobiTransformation
        DhbLaplaceDistribution
        DhbLargestEigenValueFinder
        DhbLeastSquareFit
        DhbMaximizingPoint
        DhbMemoryBasedDataServer
        DhbNevilleInterpolator
        DhbNewtonInterpolator
        DhbNormalDistribution
        DhbProbabilityDensityWithUnknownDistribution
        DhbStudentDistribution
        DhbSymmetricMatrix
        DhbTriangularDistribution
        DhbUniformDistribution
        DhbVectorChromosomeManager
        DhbVectorProjectedFunction
        DhbWeibullDistribution
        DhbBisectionZeroFinder
        DhbBulirschStoerInterpolator
        DhbChiSquareDistribution
        DhbContinuedFraction
        DhbFunctionOptimizer
        DhbLogNormalDistribution
        DhbMaximumLikekihoodHistogramFit
        DhbNewtonZeroFinder
        DhbSplineInterpolator
        DhbTrapezeIntegrator
        DhbGeneticOptimizer
        DhbHillClimbingOptimizer
        DhbMultiVariableGeneralOptimizer
        DhbOneVariableFunctionOptimizer
        DhbRombergIntegrator
        DhbSimplexOptimizer
        DhbSimpsonIntegrator
        DhbOptimizingBracketFinder
    )
!

extensionMethodNames
    ^ #(
        Collection asVector
        Integer gamma
        Integer random
        Number addPolynomial:
        Number asLimitedPrecisionReal
        Number beta:
        Number dividingPolynomial:
        Number equalsTo:
        Number errorFunction
        Number gamma
        Number logBeta:
        Number logGamma
        Number productWithMatrix:
        Number productWithVector:
        Number random
        Number relativelyEqualsTo:upTo:
        Number subtractToPolynomial:
        Number timesPolynomial:
        Point extentFromBottomLeft:
        Point extentFromBottomRight:
        Point extentFromCenter:
        Point extentFromTopLeft:
        Point extentFromTopRight:
        Rectangle positiveRectangle
        'Number class' random
    )
! !

!stx_goodies_math_dhbNumeric class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X DHBNumeric Class library'

    "Modified: / 04-10-2006 / 15:54:50 / cg"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Didier BESSET, 1999, all rights reserved'

    "Modified: / 04-10-2006 / 15:54:36 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_math_dhbNumeric class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/dhbNumeric/stx_goodies_math_dhbNumeric.st,v 1.2 2006/10/04 13:55:37 cg Exp $'
! !
