"{ Package: 'stx:goodies/math/dhbNumeric/tests' }"

TestCase subclass:#DhbTestFunctions
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-DHB Numerical SUnits'
!


!DhbTestFunctions methodsFor:'polynomial'!

testAdd
        | a b c |

        a := DhbPolynomial coefficients: #(2 1 1).
        c := a + 3.
        self assert: (c coefficients  = #(5 1 1 )).

        b := DhbPolynomial coefficients: #(1 5 ).
        c := a + b.
        self assert: (c coefficients asArray =  #(3 6 1 )).

    "Modified: / 04-10-2006 / 15:21:09 / cg"
!

testDerivative
        | a answer |
        a := DhbPolynomial coefficients: #(5 2 3).
        answer := DhbPolynomial coefficients: #(2 6).
        self assert: (a derivative  =  answer).
!

testDivide
        | a b c answer |
        a := DhbPolynomial coefficients: #(9 6 3).
        c := a / 3.
        self assert: (c coefficients  = #(3 2 1  )).

        answer := DhbPolynomial coefficients: #(3 3 ).
        b := DhbPolynomial coefficients: #(1 1 ).
        a := answer * b.
        c := a / b.
        self assert: (c   =  answer ).
!

testEqual
	| a b |

	a := DhbPolynomial coefficients: #(5 2 3).
	b := DhbPolynomial coefficients: #(5 2 3).
	self assert: a = b.
!

testIntegral
	| a b |
	a := DhbPolynomial coefficients: #(0 2 3).
	b := a derivative.
	self assert: (b integral  =  a).
!

testMultiply
        | a b c |
        a := DhbPolynomial coefficients: #(3 2 1).
        c := a * 3.
        self assert: (c coefficients  = #(9 6 3  )).

        b := DhbPolynomial coefficients: #(1 1 ).
        c := a * b.
        self assert: (c coefficients asArray =  #(3 5 3 1 )).

    "Modified: / 04-10-2006 / 15:21:19 / cg"
!

testValue
        | square |
        square := DhbPolynomial coefficients: #(2 1 1).
        self 
                assert: (square value: 1) = 4;
                assert: (square value: 3 ) = ((2) + (1*3) + (1*3*3)).

        square := DhbPolynomial coefficients: #(2 ).
        self 
                assert: (square value: 1) = 2;
                assert: (square value: 0) = 2.
! !

!DhbTestFunctions class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/dhbNumeric/tests/DhbTestFunctions.st,v 1.5 2006/10/04 14:04:07 cg Exp $'
! !
