"{ Package: 'stx:goodies/math/dhbNumeric/tests' }"

TestCase subclass:#DhbTestNumericPrecision
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-DHB Numerical SUnits'
!


!DhbTestNumericPrecision methodsFor:'decimal floating number'!

testDecimalAdd
	| a b |
	a := DhbDecimalFloatingNumber new: 1.
	b := DhbDecimalFloatingNumber new: 2.	
	self assert: (a + b) value = 3.

	a := DhbDecimalFloatingNumber new: 1.56.
	b := DhbDecimalFloatingNumber new: 2.2	.
	self assert: (a + b) value = 3.76.
!

testDecimalMultiple
	| a b result |
	a := DhbDecimalFloatingNumber new: 2.
	b := DhbDecimalFloatingNumber new: 2.	
	self assert: (a * b) value = 4.

	a := DhbDecimalFloatingNumber new: 1.5.
	b := DhbDecimalFloatingNumber new: 2.5	.
	result :=  ((a * b) value asFloat) - (1.5 * 2.5).
	self assert: result abs < 0.00001.
! !

!DhbTestNumericPrecision methodsFor:'floating point machine'!

testComputeLargestNumber
	| machine |
	machine := DhbFloatingPointMachine new .
	machine computeLargestNumber.
	self assert: machine largestNumber > 1.0e25.
!

testComputeSmallestNumber
	| machine |
	machine := DhbFloatingPointMachine new .
	machine computeSmallestNumber.
	self assert: machine smallestNumber < 1.0e-25.
!

testMachinePrecision
	| machine |
	machine := DhbFloatingPointMachine new .
	machine computeMachinePrecision.
	self assert: machine machinePrecision < 1.0e-5.
! !

!DhbTestNumericPrecision class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/dhbNumeric/tests/DhbTestNumericPrecision.st,v 1.3 2006/10/04 14:04:09 cg Exp $'
! !
