"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"

"{ Package: 'stx:goodies/math/distributions' }"

"{ NameSpace: Distributions }"

DiscreteProbability subclass:#BernoulliDistribution
	instanceVariableNames:'prob'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Distributions-Instances'
!

!BernoulliDistribution class methodsFor:'documentation'!

copyright
"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
!

documentation
"
    instances generate random numbers with a bernoulli probability distribution.
"

! !

!BernoulliDistribution class methodsFor:'instance creation'!

parameter: aNumber 
	(aNumber between: 0.0 and: 1.0)
		ifTrue: [^self new setParameter: aNumber]
		ifFalse: [^self error: 'The probability must be between 0.0 and 1.0']
! !

!BernoulliDistribution class methodsFor:'examples'!

example1
	"BernoulliDistribution example1."

	| distribution bag set value point |
	TestView openDisplayBlock: [:view :gstate | ]
		actionBlock: 
			[:view :gstate | 
			gstate clear.
			distribution := BernoulliDistribution parameter: 0.5.
			bag := Bag new.
			set := Set new.
			200
				timesRepeat: 
					[value := distribution next rounded.
					bag add: value.
					set add: value.
					set
						do: 
							[:each | 
							point := each * 100 @ (bag occurrencesOf: each).
							gstate displayLineFrom: point to: point]]]
! !

!BernoulliDistribution methodsFor:'accessing'!

mean
	^prob
!

variance
	^prob * (1.0 - prob)
! !

!BernoulliDistribution methodsFor:'private'!

inverseDistribution: x 
	x <= prob
		ifTrue: [^1]
		ifFalse: [^0]
!

setParameter: aNumber
	prob :=aNumber
! !

!BernoulliDistribution methodsFor:'probability functions'!

density: x 
	x = 1 ifTrue: [^prob].
	x = 0 ifTrue: [^1.0 - prob].
	self error: ' outcomes of a Bernoulli can only be 1 or 0'
! !

!BernoulliDistribution class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/distributions/Distributions-BernoulliDistribution.st,v 1.5 2006/10/04 13:04:46 cg Exp $'


! !
