"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"

"{ Package: 'stx:goodies/math/distributions' }"

"{ NameSpace: Distributions }"

ProbabilityDistribution subclass:#ContinuousProbability
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Distributions-Abstract'
!

!ContinuousProbability class methodsFor:'documentation'!

copyright
"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
!

documentation
"
    abstract superclass for continous probability distributions

    [see also:]
        Random DiscreteProbability
        NormalDistribution
"
! !

!ContinuousProbability methodsFor:'probability functions'!

distribution: aCollection 
	| t aStream x1 x2 y1 y2 |
	t := 0.0.
	aStream := ReadStream on: aCollection.
	x2 := aStream next.
	y2 := self density: x2.
	[x1 := x2.
	x2 := aStream next]
		whileTrue: 
			[y1 := y2.
			y2 := self density: x2.
			t := t + (x2 - x1 * (y2 + y1))].
	^t * 0.5
! !

!ContinuousProbability class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/distributions/Distributions-ContinuousProbability.st,v 1.6 2006/10/04 13:04:46 cg Exp $'
! !
