"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"

"{ Package: 'stx:goodies/math/distributions' }"

"{ NameSpace: Distributions }"

BernoulliDistribution subclass:#GeometricDistribution
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Distributions-Instances'
!

!GeometricDistribution class methodsFor:'documentation'!

copyright
"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
!

documentation
"
    instances generate random numbers with a geometric probability distribution.
"




! !

!GeometricDistribution class methodsFor:'instance creation'!

mean: m 
	^self parameter: 1 / m
! !

!GeometricDistribution class methodsFor:'examples'!

example1
        "GeometricDistribution example1."

        | distribution bag set value point |
        TestView openDisplayBlock: [:view :gstate | ]
                actionBlock: 
                        [:view :gstate | 
                        gstate clear.
                        distribution := GeometricDistribution mean: 100.
                        bag := Bag new.
                        set := Set new.
                        10000
                                timesRepeat: 
                                        [value := distribution next rounded.
                                        bag add: value.
                                        set add: value.
                                        set
                                                do: 
                                                        [:each | 
                                                        point := each @ (bag occurrencesOf: each).
                                                        gstate displayLineFrom: point to: point]]]
! !

!GeometricDistribution methodsFor:'accessing'!

mean
	^1.0 / prob
!

variance
	^1.0 - prob / prob squared
! !

!GeometricDistribution methodsFor:'private'!

inverseDistribution: x 
	^(x ln / (1.0 - prob) ln) ceiling
! !

!GeometricDistribution methodsFor:'probability functions'!

density: x 
	x > 0
		ifTrue: [^prob * (1.0 - prob raisedTo: x - 1)]
		ifFalse: [^0.0]
! !

!GeometricDistribution class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/distributions/Distributions-GeometricDistribution.st,v 1.6 2006/10/04 13:04:46 cg Exp $'


! !
