"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"

"{ Package: 'stx:goodies/math/distributions' }"

"{ NameSpace: Distributions }"

DiscreteProbability subclass:#PoissonDistribution
	instanceVariableNames:'mu'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Distributions-Instances'
!

!PoissonDistribution class methodsFor:'documentation'!

copyright
"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
!

documentation
"
    instances generate random numbers with a poisson probability distribution.
"






! !

!PoissonDistribution class methodsFor:'instance creation'!

mean: p 
	p > 0.0
		ifTrue: [^self new setMean: p]
		ifFalse: [self error: 'mean must be greater than 0.0']
! !

!PoissonDistribution class methodsFor:'examples'!

example1
        "PoissonDistribution example1."

        | distribution bag set value point |
        TestView openDisplayBlock: [:view :gstate | ]
                actionBlock: 
                        [:view :gstate | 
                        gstate clear.
                        distribution := PoissonDistribution mean: 100.
                        bag := Bag new.
                        set := Set new.
                        10000
                                timesRepeat: 
                                        [value := distribution next rounded.
                                        bag add: value.
                                        set add: value.
                                        set
                                                do: 
                                                        [:each | 
                                                        point := each @ (bag occurrencesOf: each).
                                                        gstate displayLineFrom: point to: point]]]
! !

!PoissonDistribution methodsFor:'accessing'!

mean
	^mu
!

variance
	^mu
! !

!PoissonDistribution methodsFor:'private'!

setMean: p 
	mu := p
! !

!PoissonDistribution methodsFor:'probability functions'!

density: x 
	x >= 0
		ifTrue: [^(mu raisedTo: x)
				* mu negated exp / x factorial]
		ifFalse: [^0.0]
! !

!PoissonDistribution methodsFor:'random sampling'!

next
	| p n q |
	p := mu negated exp.
	n := 0.
	q := 1.0.
	[q := q * U next.
	q >= p]
		whileTrue: [n := n + 1].
	^n
! !

!PoissonDistribution class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/distributions/Distributions-PoissonDistribution.st,v 1.6 2006/10/04 13:04:46 cg Exp $'


! !
