"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
"{ Package: 'stx:goodies/math/distributions' }"

"{ NameSpace: Distributions }"

Stream subclass:#ProbabilityDistribution
	instanceVariableNames:''
	classVariableNames:'U'
	poolDictionaries:''
	category:'Math-Distributions-Abstract'
!

!ProbabilityDistribution class methodsFor:'documentation'!

copyright
"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
!

documentation
"
    abstract superclass for probability distributions

    Instances behave like random number generators, providing
    numbers with various distributions.

    [see also:]
        Random
        ContinuousProbability DiscreteProbability
"


! !

!ProbabilityDistribution class methodsFor:'instance creation'!

new
	^self basicNew
! !

!ProbabilityDistribution class methodsFor:'class initialization'!

initialize
        "ProbabilityDistribution initialize."

        U := Random new.
        "/ U := RandomParkMiller new
        "/ U := RandomParkMillerUsingFloat new
        "/ U := RandomTT800 new.
! !

!ProbabilityDistribution methodsFor:'private'!

computeSample: m outOf: n 
	m > n ifTrue: [^0.0].
	^n factorial / (n - m) factorial
!

inverseDistribution: x 
	"self subclassResponsibility"

	^ self subclassResponsibility
! !

!ProbabilityDistribution methodsFor:'probability functions'!

density: x 
	self subclassResponsibility
!

distribution: aCollection 
	self subclassResponsibility
! !

!ProbabilityDistribution methodsFor:'random sampling'!

atEnd
	^false
!

next
	^self inverseDistribution: U next
! !

!ProbabilityDistribution class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/distributions/Distributions-ProbabilityDistribution.st,v 1.8 2008/12/16 22:33:08 cg Exp $'
! !

ProbabilityDistribution initialize!
