"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"

"{ Package: 'stx:goodies/math/distributions' }"

"{ NameSpace: Distributions }"

DiscreteProbability subclass:#SampleSpace
	instanceVariableNames:'data'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Distributions-SampleSpace'
!

!SampleSpace class methodsFor:'documentation'!

copyright
"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
! !

!SampleSpace class methodsFor:'instance creation'!

data: aCollection 
	^self new setData: aCollection
! !

!SampleSpace class methodsFor:'examples'!

example1
	"SampleSpace example1."

	| data space bag set value point |
	TestView openDisplayBlock: [:view :gstate | ]
		actionBlock: 
			[:view :gstate | 
			gstate clear.
			data := #(0 10 20 30 40 50 60 70 80 90 100 110 120 130 140 150 160 170 180 190 ).
			space := SampleSpace data: data.
			bag := Bag new.
			set := Set new.
			1000
				timesRepeat: 
					[value := space next rounded.
					bag add: value.
					set add: value.
					set
						do: 
							[:each | 
							point := each @ (bag occurrencesOf: each).
							gstate displayLineFrom: point to: point]]]
! !

!SampleSpace methodsFor:'private'!

inverseDistribution: x 
	^data at: (x * data size) truncated + 1
!

setData: aCollection 
	data := aCollection
! !

!SampleSpace methodsFor:'probability functions'!

density: x 
	(data includes: x)
		ifTrue: [^(data occurrencesOf: x)
				/ data size]
		ifFalse: [^0]
! !

!SampleSpace class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/distributions/Distributions-SampleSpace.st,v 1.5 2006/10/04 13:04:46 cg Exp $'

! !
