"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"

"{ Package: 'stx:goodies/math/distributions' }"

"{ NameSpace: Distributions }"

SampleSpaceWithReplacement subclass:#SampleSpaceWithoutReplacement
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Distributions-SampleSpace'
!

!SampleSpaceWithoutReplacement class methodsFor:'documentation'!

copyright
"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
! !

!SampleSpaceWithoutReplacement class methodsFor:'examples'!

example1
	"SampleSpaceWithoutReplacement example1."

	| data space bag set value point |
	TestView openDisplayBlock: [:view :gstate | ]
		actionBlock: 
			[:view :gstate | 
			gstate clear.
			data := 0 to: 99.
			space := SampleSpaceWithoutReplacement data: data.
			bag := Bag new.
			set := Set new.
			100
				timesRepeat: 
					[value := space next rounded.
					bag add: value.
					set add: value.
					set
						do: 
							[:each | 
							point := each @ (bag occurrencesOf: each).
							gstate displayLineFrom: point to: point]]]
! !

!SampleSpaceWithoutReplacement methodsFor:'accessing'!

next
	^data remove: super next
! !

!SampleSpaceWithoutReplacement methodsFor:'private'!

setData: aCollection 
	data := aCollection asOrderedCollection
! !

!SampleSpaceWithoutReplacement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/distributions/Distributions-SampleSpaceWithoutReplacement.st,v 1.5 2006/10/04 13:04:46 cg Exp $'

! !
