"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
"{ Package: 'stx:goodies/math/distributions' }"

"{ NameSpace: Distributions }"

ContinuousProbability subclass:#UniformDistribution
	instanceVariableNames:'startNumber stopNumber'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Distributions-Instances'
!

!UniformDistribution class methodsFor:'documentation'!

copyright
"
    Copyright (c) 1991-1994
    Atsushi Aoki (SRA Boulder),
    Katsuhiro Watanabe (SRA Tokyo),
    Taiji Matsuoka (SRA Tokyo),
    Yoshiyuki Nishinaka (SRA Tokyo) and
    Makoto Minagawa (FXIS Tokyo).
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
!

documentation
"
    instances generate random numbers with a uniform probability distribution.
"







! !

!UniformDistribution class methodsFor:'instance creation'!

from: begin to: end 
	begin > end
		ifTrue: [self error: 'illegal interval']
		ifFalse: [^self new setStart: begin toEnd: end]
! !

!UniformDistribution class methodsFor:'examples'!

example1
        "UniformDistribution example1."

        | distribution bag set value point |
        TestView 
            openDisplayBlock: [:view :gstate | ]
            actionBlock: 
                        [:view :gstate | 

                        gstate clear.
                        distribution := UniformDistribution from: 50 to: 150.
                        bag := Bag new.
                        set := Set new.
                        40000
                                timesRepeat: 
                                        [value := distribution next rounded.
                                        bag add: value.
                                        set add: value.
                                        set
                                                do: 
                                                        [:each | 
                                                        point := each @ (bag occurrencesOf: each).
                                                        gstate displayLineFrom: point to: point]]]

    "Modified: 2.4.1997 / 16:08:25 / cg"
! !

!UniformDistribution methodsFor:'accessing'!

mean
	^startNumber + stopNumber / 2
!

variance
	^(stopNumber - stopNumber) squared / 12
! !

!UniformDistribution methodsFor:'private'!

inverseDistribution: x 
	^startNumber + (x * (stopNumber - startNumber))
!

setStart: begin toEnd: end 
	startNumber := begin.
	stopNumber := end
! !

!UniformDistribution methodsFor:'probability functions'!

density: x 
	(x between: startNumber and: stopNumber)
		ifTrue: [^1.0 / (stopNumber - startNumber)]
		ifFalse: [^0]
!

distribution: aCollection 
	| t |
	t := 0.0.
	aCollection do: [:i | t := t + (self density: i)].
	^t
! !

!UniformDistribution class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/distributions/Distributions-UniformDistribution.st,v 1.8 2008/12/16 22:32:52 cg Exp $'


! !
