"{ Package: 'stx:goodies/math/fibonacci' }"

"{ NameSpace: Math }"

FibonacciCalculator subclass:#BinaryFibonacciCalculator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Algorithms'
!


!BinaryFibonacciCalculator methodsFor:'computing'!

positiveF: anIndex
	" computes nth element in Fibonacci sequence using the formula
		Fa+b=Fb+1*Fa+Fb*Fa-1

	it starts with Fn-1 and Fn for n=1.
	in each step it computes
		F2n   = (Fn)^2+2Fn*Fn-1
		F2n-1 = (Fn)^2+(Fn-1)^2

	in every step it knows Fa and Fa-1
	where a represents n modulus 2^i and i is the step."

	| n fn fn1 fi fi1 ftemp |
	fn _ self f: 1.		"Fn"
	fn1 _ self f: 0.		"Fn-1"
	fi _ fn1.			"Fa"
	fi1 _ fn.			"Fa-1"
	n _ anIndex.
	[n = 0] whileFalse: [
		n odd ifTrue: [
			ftemp _ (fi*fn)+(fi1*fn1).
			fi _ fi+fi1*fn+(fn1*fi).
			fi1 _ ftemp].
		(n _ n >> 1) = 0 ifFalse: [
			ftemp _ fn*fn.
			fn _ ftemp + (2*fn*fn1).
			fn1 _ ftemp + (fn1*fn1)]].
	^ fi
! !

!BinaryFibonacciCalculator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/fibonacci/BinaryFibonacciCalculator.st,v 1.1 2002/11/22 16:49:39 cg Exp $'
! !
