"{ Package: 'stx:goodies/math/fibonacci' }"

"{ NameSpace: Math }"

FibonacciCalculator subclass:#MatrixFibonacciCalculator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Algorithms'
!


!MatrixFibonacciCalculator methodsFor:'computing'!

positiveF: anIndex
	" computes the anIndexth term in Fibonacci sequence using the formula:

	Fn=	Matrix { 1 1 / 1 0 }^n at (1,1)

	and computing M^n by representing n in binary:

		y=Id.
		z=M.

		[n = 0] whileFalse: [
			n odd ifTrue: [y _ y * z].
			z = z * z.
			n << 1]
	"

	| m00 m01 m11 y00 y01 y11 n n00 n01 |
	m00 _ 1.		m01 _ self f: 1.		"m00 m01"
	m11 _ self f: 0.					"m01 m11"
	y00 _ 1.		y01 _ 0.						"y00 y01"
	y11 _ 1.									"y01 y11"
	n _ anIndex.
	[n = 0] whileFalse: [
		n odd ifTrue: [
			n00 _ (y00*m00)+(y01*m01).		n01 _ (y00*m01)+(y01*m11).
			y11 _ (y01*m01)+(y11*m11).
			y00 _ n00.	y01 _ n01].
		n = 1 ifFalse: [
			n00 _ (m00*m00)+(m01*m01).		n01 _ (m00*m01)+(m01*m11).
			m11 _ (m01*m01)+(m11*m11).
			m00 _ n00.	m01 _ n01].
		n _ n >> 1].
	^ y01
! !

!MatrixFibonacciCalculator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/fibonacci/MatrixFibonacciCalculator.st,v 1.1 2002/11/22 16:49:04 cg Exp $'
! !
