"{ Package: 'stx:goodies/math/fibonacci' }"

"{ NameSpace: Math }"

FibonacciCalculator subclass:#Split1FibonacciCalculator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Algorithms'
!


!Split1FibonacciCalculator methodsFor:'computing'!

positiveF: anInteger 
	"Answer the value of the anIntegerth term of the Fibonacci sequence by Andres Valloud"
	| msb storeOnCache a b answer |
	msb _ 1 << (anInteger highBit - 1).
	storeOnCache _ anInteger - msb <= 1.
	a _ storeOnCache
				ifTrue: [anInteger >> 1]
				ifFalse: [msb].
	b _ anInteger - a.
	answer _ (self f: a + 1)
				* (self f: b) + ((self f: a)
					* (self f: b - 1)).
	storeOnCache ifTrue: [self cacheAdd: anInteger @ answer].
	^ answer
! !

!Split1FibonacciCalculator methodsFor:'initialization'!

zero: zero one: one
	super zero: zero one: one.
	self
		cacheAdd: 2@(self normalize: (self f: 0)+(self f: 1));
		cacheAdd: 3@(self normalize: (self f: 1)+(self f: 2)).
! !

!Split1FibonacciCalculator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/fibonacci/Split1FibonacciCalculator.st,v 1.1 2002/11/22 16:49:47 cg Exp $'
! !
