"{ Package: 'stx:goodies/math/fibonacci' }"

"{ NameSpace: Math }"

FibonacciCalculator subclass:#Split2FibonacciCalculator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Algorithms'
!


!Split2FibonacciCalculator methodsFor:'computing'!

positiveF: n 
	"computes fibonacci sequence at index n. It uses the formula:  Fa+b = Fb+1*Fa+Fb*Fa-1
	and works spliting anIndex in n=a+b, where a is the greater power of two wich is
	smaller than anIndex, then it computes (recursively) Fa and Fb and uses the formula
	to compute Fn=Fa+b"

	| b a fa fa1 |
	b _ n - (a _ 1 << ((n - 1) highBit - 1)).
	self cacheAdd: a - 1 @ (fa1 _ self f: a - 1).
	self cacheAdd: a @ (fa _ self f: a).
	^ (self f: b + 1) * fa + (fa1 * (self f: b))
! !

!Split2FibonacciCalculator methodsFor:'initialization'!

zero: zero one: one
	super zero: zero one: one.
	self
		cacheAdd: 2@(self normalize: (self f: 0)+(self f: 1));
		cacheAdd: 3@(self normalize: (self f: 1)+(self f: 2)).
! !

!Split2FibonacciCalculator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/fibonacci/Split2FibonacciCalculator.st,v 1.1 2002/11/22 16:48:54 cg Exp $'
! !
