"{ Package: 'stx:goodies/math/fibonacci' }"

"{ NameSpace: Math }"

FibonacciCalculator subclass:#SplittingFibonacciCalculator
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Algorithms'
!


!SplittingFibonacciCalculator methodsFor:'computing'!

positiveF: n 
	"computes fibonacci sequence at index n. 
	  it uses the formula: 
	Fa+b = Fb+1*Fa+Fb*Fa-1 = (Fb-1+Fb)*Fa+Fb*Fa-1 = Fb-1*Fa+Fb*(Fa+Fa-1) 
	and works spliting anIndex in n=a+b, 
	where a is the greater power of two wich is smaller than anIndex, 
	the it computes (recursively) Fa and Fb and uses the formula to 
	compute Fn=Fa+b"
	| b a fa fa1 |
	b _ n - (a _ 1 << ((n - 1) highBit - 1)).
	self cacheAdd: a @ (fa _ self f: a).
	self cacheAdd: a - 1 @ (fa1 _ self f: a - 1).
	^ (self f: b - 1) * fa + (fa + fa1 * (self f: b))
! !

!SplittingFibonacciCalculator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/fibonacci/SplittingFibonacciCalculator.st,v 1.1 2002/11/22 16:50:17 cg Exp $'
! !
