"{ Package: 'stx:goodies/math/graph' }"

"{ NameSpace: Math }"

Object subclass:#Arrow
	instanceVariableNames:'to weight'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Graph'
!

!Arrow class methodsFor:'documentation'!

documentation
"
    This class has been ported from Squeak.
    It is provided *AS IS* without any warranty.

    Original comment:

    my instances represents arrows (to use in a Graph together with Vertex).
    an Arrow knows where it's pointing to (it't destination) and also has a value,
    this is usefull to assign a value to an arrow in a Graph.

        to create a new Arrow:
                Arrow to: aVertex value: anObject

        when you do: aVertex addArrowTo: aVertex, a new arrow is created and added
                to aVertex's adjacecy list.
"
! !

!Arrow class methodsFor:'instance creation'!

to: aVertex 
	" public - will create and answer a new Arraw pointing to aVertex with value nil"
	^ self to: aVertex weight: nil
!

to: aVertex weight: anObject
	" public - will create and answer a new Arraw pointing to aVertex with value anObject"
	^ self new
		to: aVertex;
		weight: anObject
! !

!Arrow methodsFor:'accessing'!

to
	^to
!

to: anObject
	to _ anObject
!

weight
	^weight
!

weight: anObject
	weight _ anObject
! !

!Arrow methodsFor:'comparing'!

= anArrow
	" an Arrow is identfyed by it's destination (to)"
	^ self to = anArrow to
!

hash
        ^ self to hash + 1
! !

!Arrow methodsFor:'printing'!

printOn: aStream
	" my printString is -value->to"
	aStream nextPut: $=; nextPut: $=.
	self weight printOn: aStream.
	aStream nextPutAll: '==>'.
	self to name printOn: aStream 
! !

!Arrow class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/graph/Arrow.st,v 1.2 2003/03/26 12:21:19 cg Exp $'
! !
