"{ Package: 'stx:goodies/math/graph' }"

"{ NameSpace: Math }"

Object subclass:#Edge
	instanceVariableNames:'from arrow'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Graph'
!

!Edge class methodsFor:'documentation'!

documentation
"
    This class has been ported from Squeak.
    It is provided *AS IS* without any warranty.

    Original comment:
"
! !

!Edge class methodsFor:'instance creation'!

from: aVertex arrow: anArrow
	" public - will create and answer a new Edge from aVertex with anArrow leaving it"
	^ self new
		from: aVertex;
		arrow: anArrow
!

from: aVertex to: bVertex
	" public - will create and answer a new Edge from aVertex to bVertex"
	^ self from: aVertex to: bVertex weight: nil
!

from: aVertex to: bVertex weight: anObject
	" public - will create and answer a Vertex from aVertex to bVertex with value anObject"
	^ self from: aVertex arrow: (Arrow to: bVertex weight: anObject)
! !

!Edge methodsFor:'accessing'!

arrow
	^arrow
!

arrow: anObject
	arrow _ anObject
!

from
	" public - answer my starting point"
	^ from
!

from: anObject
	from _ anObject
!

to
	" public - answer my ending point"
	^ self arrow to
!

weight
	" public - answer my value"
	^ self arrow weight
! !

!Edge methodsFor:'printing'!

printOn: aStream
	" my text representation is like an Association's representation"
	self from name printOn: aStream.
	self arrow printOn: aStream
! !

!Edge class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/graph/Edge.st,v 1.2 2003/03/26 12:21:22 cg Exp $'
! !
