"{ Package: 'stx:goodies/math/graph' }"

"{ NameSpace: Math }"

TestCase subclass:#GraphTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Graph'
!


!GraphTests methodsFor:'initialize / release'!

setUp
    "common setup - invoked before testing."

    super setUp
!

tearDown
    "common cleanup - invoked after testing."

    super tearDown
! !

!GraphTests methodsFor:'tests'!

testConstruct1
    |graph 
     stuttgart muenchen frankfurt berlin|

    graph := Graph new.

    stuttgart := Vertex name:'stuttgart'.
    muenchen := Vertex name:'muenchen'.
    frankfurt := Vertex name:'frankfurt'.
    berlin := Vertex name:'berlin'.

    graph addArrowFrom:stuttgart to:muenchen.
    graph addArrowFrom:stuttgart to:frankfurt.
    graph addArrowFrom:muenchen to:berlin.
    graph addArrowFrom:frankfurt to:berlin.


    self assert:(graph hasArrowFrom:stuttgart to:muenchen).
    self assert:(graph hasArrowFrom:stuttgart to:frankfurt).
    self assert:(graph hasArrowFrom:muenchen to:berlin).
    self assert:(graph hasArrowFrom:frankfurt to:berlin).

    self assert:(graph hasVertex:stuttgart).
    self assert:(graph hasVertex:muenchen).
    self assert:(graph hasVertex:frankfurt).
    self assert:(graph hasVertex:berlin).

    self assert:(graph hasArrowFrom:stuttgart to:berlin) not.
    self assert:(graph hasArrowFrom:muenchen to:stuttgart) not.
    self assert:(graph hasArrowFrom:muenchen to:frankfurt) not.
    self assert:(graph hasArrowFrom:frankfurt to:stuttgart) not.
    self assert:(graph hasArrowFrom:frankfurt to:muenchen) not.
    self assert:(graph hasArrowFrom:berlin to:stuttgart) not.
    self assert:(graph hasArrowFrom:berlin to:muenchen) not.
    self assert:(graph hasArrowFrom:berlin to:frankfurt) not.

    "
     self run:#testConstruct1
     self new testConstruct1
    "
!

testGraphFunctions1
    |graph 
     stuttgart muenchen frankfurt berlin|

    graph := Graph new.

    stuttgart := Vertex name:'stuttgart'.
    muenchen := Vertex name:'muenchen'.
    frankfurt := Vertex name:'frankfurt'.
    berlin := Vertex name:'berlin'.

    graph addArrowFrom:stuttgart to:muenchen weighted:250.
    graph addArrowFrom:stuttgart to:frankfurt weighted:200.
    graph addArrowFrom:muenchen to:berlin weighted:650.
    graph addArrowFrom:frankfurt to:berlin weighted:400.
    graph.   

    self assert:(graph hasLoop) not.

    graph addArrowFrom:berlin to:stuttgart.
    self assert:(graph hasLoop).

    "
     self run:#testGraphFunctions1
     self new testGraphFunctions1
    "
! !

!GraphTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/graph/GraphTests.st,v 1.1 2003/03/26 12:21:15 cg Exp $'
! !
