"{ Package: 'stx:goodies/math/graph' }"

"{ NameSpace: Math }"

Squeak::MorphicWrapper subclass:#VertexMorphicWrapper
	instanceVariableNames:'dxdy'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Graph'
!


!VertexMorphicWrapper methodsFor:'accessing'!

dxdy
	^dxdy
!

dxdy: anObject
	dxdy _ anObject
! !

!VertexMorphicWrapper methodsFor:'drawing'!

drawOn: aCanvas
	" my visual representation is an ellipse and my name"
	| scanner |
	scanner _ QuickPrint new.
	self extent: (scanner stringWidth: self object name printString) @ (scanner lineHeight).
	aCanvas fillOval: self bounds color: Color yellow.
	aCanvas text: self object name printString bounds: self bounds font: nil color: Color black
! !

!VertexMorphicWrapper methodsFor:'initialization'!

initialize
	super initialize.
	self dxdy: 0@0
!

morphicWrapperClass
	^ VertexMorphicWrapper
! !

!VertexMorphicWrapper methodsFor:'stepping'!

doMove
	" move my by dxdy, this is done becouse to move me, I have to wait till all other vertices
	are allready moved, this is done in to step: first set delta X and delta Y, then perform the
	actual move"
	self privateMoveBy: self dxdy.
	^ self dxdy r.
!

updateContents
	self changed
! !

!VertexMorphicWrapper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/graph/VertexMorphicWrapper.st,v 1.1 2002/11/22 16:46:57 cg Exp $'
! !
