"{ Package: 'stx:goodies/math/linearAlgebra' }"

"{ NameSpace: Math2 }"

Tuple subclass:#Column
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'V''Age classes'
!

!Column class methodsFor:'documentation'!

documentation
"
    My instances represent column vectors given by coordinates.

    For an example try this:

    | e1 e2 e3 |
    e1 := Column e: 1 dim: 3.
    e2 := Column e: 2 dim: 3.
    e3 := Column e: 3 dim: 3.
    (3*e1 + (5*e2) - (7*e3)) inspect
"
! !

!Column methodsFor:'ST/V methods'!

asMatrix
    "Answer a Matrix with the entries of the receiver."

    ^self transposed asMatrix transposed
!

printOn: aStream
    "Public - Append a String representation of the receiver to aStream."

    self asMatrix printOn: aStream
!

transposed

    ^Tuple from: self entries
! !

!Column class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/linearAlgebra/Column.st,v 1.1 2002/11/22 19:43:19 cg Exp $'
! !
