"{ Package: 'stx:goodies/math/stmath' }"

StMGESpMatFullPv3 subclass:#MbDGESpMatFullPvPosIC3
	instanceVariableNames:'system pivotRowLimits pivotRowLimit'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-MatrixSolver'
!


!MbDGESpMatFullPvPosIC3 methodsFor:'accessing'!

pivotRowLimits: array 
	pivotRowLimits := array
!

system: object 
	system := object
! !

!MbDGESpMatFullPvPosIC3 methodsFor:'pivoting'!

doPivoting: p 
	"Used by Gauss Elimination only."
	"Swap rows but keep columns in place."
	"The elements below the diagonal are removed column by column."

	| max pivotRow pivotCol rowi rowiValues nNonZeros count index jj aij mag redundantEqns jp aip |
	max := 0.
	pivotRow := p.
	pivotCol := p.
	p to: n do: [:j | (rowPositionsOfNonZerosInColumns at: (colOrder at: j)) setIndices].
	p > pivotRowLimit ifTrue: [pivotRowLimit := pivotRowLimits detect: [:limit | limit >= p]].
	p to: pivotRowLimit
		do: 
			[:i | 
			rowi := matrixA at: i.
			rowiValues := rowi valueArray.
			nNonZeros := rowi tally.
			count := 0.
			index := 1.
			[count < nNonZeros]
				whileTrue: 
					[jj := rowi basicAt: index.
					jj == nil
						ifFalse: 
							[count := count + 1.
							(rowPositionsOfNonZerosInColumns at: jj)
								add: i.
							aij := rowiValues at: index.
							mag := aij.
							mag < 0.0d ifTrue: [mag := 0.0d - mag].
							mag > max
								ifTrue: 
									[max := mag.
									pivotRow := i.
									pivotCol := positionsOfOriginalCols at: jj]].
					index := index + 1]].
	p == pivotRow
		ifFalse: 
			[matrixA swap: p with: pivotRow.
			rightHandSideB swap: p with: pivotRow.
			rowOrder swap: p with: pivotRow].
	p == pivotCol
		ifFalse: 
			[colOrder swap: p with: pivotCol.
			positionsOfOriginalCols at: (colOrder at: p)
				put: p.
			positionsOfOriginalCols at: (colOrder at: pivotCol)
				put: pivotCol].
	pivotValues at: p put: max.
	max < singularPivotTolerance
		ifTrue: 
			[pivotRowLimit := pivotRowLimits detect: [:limit | limit > pivotRowLimit]
						ifNone: 
							[redundantEqns := rowOrder copyFrom: p to: pivotRowLimit.
							StMSingularMatrixError signalWith: redundantEqns].
			^self doPivoting: p].
	jp := colOrder at: p.
	rowPositionsOfNonZerosInPivotColumn := rowPositionsOfNonZerosInColumns at: jp.
	pivotRowLimit + 1 to: m
		do: 
			[:i | 
			aip := matrixA at: i and: jp.
			aip == nil ifFalse: [rowPositionsOfNonZerosInPivotColumn add: i]].
	rowPositionsOfNonZerosInPivotColumn first == p ifTrue: [rowPositionsOfNonZerosInPivotColumn removeFirst].
	markowitzPivotColCount := rowPositionsOfNonZerosInPivotColumn size
! !

!MbDGESpMatFullPvPosIC3 methodsFor:'solution'!

preSolve: aMatrix with: aVector saveOriginal: saveOriginal 
	super
		preSolve: aMatrix
		with: aVector
		saveOriginal: saveOriginal.
	pivotRowLimits := system pivotRowLimits.
	pivotRowLimit := 0
! !

!MbDGESpMatFullPvPosIC3 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/MbDGESpMatFullPvPosIC3.st,v 1.6 2006/10/04 13:00:51 cg Exp $'
! !
