"{ Package: 'stx:goodies/math/stmath' }"

Array variableSubclass:#StMArray
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-Array'
!

StMArray comment:'General like Array. Elements can store anything. This class encapsulate StM methods without affecting the base class Array.'
!


!StMArray class methodsFor:'instance creation'!

newWithElements: aArray 
        | answer |
        answer := aArray shallowCopy.
        (answer isKindOf: StMArray)
                ifFalse: [answer := answer changeClassToThatOf: (self new: 0)].
        (answer at: 1) isLimitedPrecisionReal
                ifTrue: [1 to: answer size do: [:i | answer at: i put: (aArray at: i) asDouble]]
                ifFalse: [1 to: answer size do: [:i | answer at: i put: (self newWithElements: (aArray at: i))]].
        ^answer
! !

!StMArray class methodsFor:'examples'!

aaaa
	"self halt. StMArray aaaa."

	| vector copy |
"	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d)."
	vector := #($a 2.0d 'aaaa' 4.0d).
	copy := vector copy.
	copy at: 1 put: 11111.
	^copy = vector
!

example0
	"self halt. self example0."

	| n vector |
	n := 10.
	vector := StMFullColumn new: n.
	vector size = n ifFalse: [self error: 'Check this.'].
	vector nrow = n ifFalse: [self error: 'Check this.'].
	vector ncol = 1 ifFalse: [self error: 'Check this.'].
	vector numberOfElements = n ifFalse: [self error: 'Check this.'].
	1 to: n do: [:i | vector at: i put: i asDouble].
	vector maxElement = n asDouble ifFalse: [self error: 'Check this.'].
	vector minAndMaxValues = (Array with: 1 with: n) ifFalse: [self error: 'Check this.'].
	vector sumOfElements = (vector inject: 0.0d into: [:sum :element | sum + element]) ifFalse: [self error: 'Check this.'].
	vector sumOfSquares = (vector inject: 0.0d into: [:ssq :element | ssq + (element * element)]) ifFalse: [self error: 'Check this.'].
	vector sumOfSquares = (vector sumOfElementsRaisedTo: 2) ifFalse: [self error: 'Check this.'].
	vector rootMeanSquare = (vector sumOfSquares / n) sqrt ifFalse: [self error: 'Check this.'].
	vector length = (vector normL: 2) ifFalse: [self error: 'Check this.']
!

example0a
	"self halt. self example0a."

	| vector vector2 vector3 |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	vector2 := StMFullColumn new: 4.
	vector2 at: 1 put: 1.0d.
	vector2 at: 2 put: 2.0d.
	vector2 at: 3 put: 3.0d.
	vector2 at: 4 put: 4.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector3 := vector copy.
	vector2 = vector3 ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf isZero ifFalse: [self error: 'Check this.'].
	(vector3 magnifySelf: 0.0d) isZero ifFalse: [self error: 'Check this.'].
	vector2 at: 1 putFullColumn: vector.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalFullColumn: vector.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalFullColumn: vector at: 1.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 at: 1 plusFullColumn: vector.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalSelfPlusFullColumn: vector.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalSelfPlusFullColumn: vector at: 1.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 at: 1 minusFullColumn: vector.
	vector2 = vector negated ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalSelfMinusFullColumn: vector.
	vector2 = vector negated ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalSelfMinusFullColumn: vector at: 1.
	vector2 = vector negated ifFalse: [self error: 'Check this.']
!

example1
	"self halt. self example1."

	| vector vector2 vector3 |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	vector2 := StMFullColumn new: 4.
	vector2 at: 1 put: 1.0d.
	vector2 at: 2 put: 2.0d.
	vector2 at: 3 put: 3.0d.
	vector2 at: 4 put: 4.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector3 := vector copy.
	vector2 = vector3 ifFalse: [self error: 'Check this.'].
	vector2 at: 1 putFullColumn: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 at: 1 putFullColumn: vector times: 1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalFullColumn: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 equalFullColumn: vector times: 1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 at: 1 plusFullColumn: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 at: 1 plusFullColumn: vector times: 1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalSelfPlusFullColumn: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 equalSelfPlusFullColumn: vector times: 1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalSelfTimes: 1.0d plusFullVector: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 equalSelfTimes: 1.0d plusFullVector: vector times: 1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 equalSelfTimes: 2.0d plusFullVector: vector times: -1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 at: 1 minusFullColumn: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 at: 1 minusFullColumn: vector times: -1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalSelfMinusFullColumn: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 equalSelfMinusFullColumn: vector times: -1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 equalSelfTimes: 1.0d minusFullVector: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 equalSelfTimes: 1.0d minusFullVector: vector times: 1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 equalSelfTimes: 2.0d minusFullVector: vector times: -1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.']
!

example2
	"self halt. self example2."

	| vector vector2 |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	vector2 := vector timesNumber: 1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 := vector timesNumber: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 := vector2 plusFullColumn: vector.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 := vector2 plusFullColumn: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 := vector2 plusFullColumn: vector times: 1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 := vector2 times: 0.0d plusFullColumn: vector.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 := vector2 times: 1.0d plusFullColumn: vector times: -1.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 := vector2 minusFullColumn: vector.
	vector2 = vector negated ifFalse: [self error: 'Check this.'].
	vector2 zeroSelf.
	vector2 := vector2 minusFullColumn: vector times: 0.0d.
	vector2 isZero ifFalse: [self error: 'Check this.'].
	vector2 := vector2 minusFullColumn: vector times: -1.0d.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 := vector2 times: 2.0d minusFullColumn: vector.
	vector2 = vector ifFalse: [self error: 'Check this.'].
	vector2 := vector2 times: 1.0d minusFullColumn: vector times: 1.0d.
	vector2 isZero ifFalse: [self error: 'Check this.']
!

example2a
	"self halt. self example2a."
	"StMFullColumn(-5.5d -3.5d -1.5d 0.5d)"

	| fullCol fullCol2 dum |
	fullCol := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	fullCol2 := StMFullColumn newWithElements: #(4.0d 3.0d 2.0d 1.0d).
	dum := (StMFullColumn new: 4) zeroSelf.
	dum := (fullCol timesNumber: 0.5d)
				minusFullColumn: dum.
	dum := (fullCol2 timesNumber: 0.5d)
				minusFullColumn: dum.
	dum := fullCol2 negated minusFullColumn: dum.
	^dum
!

example2b
	"self halt. self example2b."
	"StMFullColumn(-5.5d -3.5d -1.5d 0.5d)"

	| fullCol fullCol2 dum |
	fullCol := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	fullCol2 := StMFullColumn newWithElements: #(4.0d 3.0d 2.0d 1.0d).
	dum := (StMFullColumn new: 4) zeroSelf.
	dum equalSelfPlusFullColumn: fullCol.
	dum equalSelfMinusFullColumn: fullCol.
	dum equalSelfPlusFullColumn: fullCol2 times: 2.0d.
	dum equalSelfMinusFullColumn: fullCol2 times: 2.0d.
	^dum
!

example3
	"self halt. self example3."
	"84.720732530713d"

	| matrix matrix2 dum |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d)).
	matrix2 := StMFullMatrix new: 3 by: 3.
	1 to: matrix2 nrow do: [:i | 1 to: matrix2 ncol do: [:j | matrix2 at: i and: j put: (matrix at: i and: j)]].
	matrix2 magnifySelf: 1.5d.
	dum := 0.0d.
	dum := matrix2 rootMeanSquare + dum.
	dum := matrix2 maxElement + dum.
	^dum
!

example4
	"self halt. self example4."
	"#(#(181.5d 198.0d 214.5d) #(346.5d 363.0d 379.5d) #(511.5d 528.0d 544.5d))"

	| matrix matrix2 dum |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d)).
	matrix2 := StMFullMatrix newWithElements: #(#(110.0d 120.0d 130.0d) #(210.0d 220.0d 230.0d) #(310.0d 320.0d 330.0d)).
	dum := StMFullMatrix newWithElements: #(#(0.0d 0.0d 0.0d) #(0.0d 0.0d 0.0d) #(0.0d 0.0d 0.0d)).
	dum := ((matrix timesNumber: 1.0d/ 2.0d) plusFullMatrix: (matrix2 timesNumber: 1.0d/ 2.0d)) plusFullMatrix: dum.
	dum := ((matrix timesNumber: 1.0d/ 2.0d) plusFullMatrix: matrix2) plusFullMatrix: dum.
	dum := ((matrix timesNumber: 1.0d/ 2.0d) plusFullMatrix: matrix2 negated) plusFullMatrix: dum.
	dum := (matrix plusFullMatrix: (matrix2 timesNumber: 1.0d/ 2.0d)) plusFullMatrix: dum.
	dum := (matrix plusFullMatrix: matrix2) plusFullMatrix: dum.
	dum := (matrix plusFullMatrix: matrix2 negated) plusFullMatrix: dum.
	dum := (matrix negated plusFullMatrix: (matrix2 timesNumber: 1.0d/ 2.0d)) plusFullMatrix: dum.
	dum := (matrix negated plusFullMatrix: matrix2) plusFullMatrix: dum.
	dum := (matrix negated plusFullMatrix: matrix2 negated) plusFullMatrix: dum.
	^dum
!

example4a
	"self halt. self example4a."
	"#(#(-148.5d -162.0d -175.5d) #(-283.5d -297.0d -310.5d) #(-418.5d -432.0d -445.5d))"

	| matrix matrix2 dum |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d)).
	matrix2 := StMFullMatrix newWithElements: #(#(110.0d 120.0d 130.0d) #(210.0d 220.0d 230.0d) #(310.0d 320.0d 330.0d)).
	dum := StMFullMatrix newWithElements: #(#(0.0d 0.0d 0.0d) #(0.0d 0.0d 0.0d) #(0.0d 0.0d 0.0d)).
	dum := ((matrix timesNumber: 1.0d/ 2.0d) minusFullMatrix: (matrix2 timesNumber: 1.0d/ 2.0d)) plusFullMatrix: dum.
	dum := ((matrix timesNumber: 1.0d/ 2.0d) minusFullMatrix: matrix2) plusFullMatrix: dum.
	dum := ((matrix timesNumber: 1.0d/ 2.0d) minusFullMatrix: matrix2 negated) plusFullMatrix: dum.
	dum := (matrix minusFullMatrix: (matrix2 timesNumber: 1.0d/ 2.0d)) plusFullMatrix: dum.
	dum := (matrix minusFullMatrix: matrix2) plusFullMatrix: dum.
	dum := (matrix minusFullMatrix: matrix2 negated) plusFullMatrix: dum.
	dum := (matrix negated minusFullMatrix: (matrix2 timesNumber: 1.0d/ 2.0d)) plusFullMatrix: dum.
	dum := (matrix negated minusFullMatrix: matrix2) plusFullMatrix: dum.
	dum := (matrix negated minusFullMatrix: matrix2 negated) plusFullMatrix: dum.
	^dum
!

example5
	"self halt. self example5."
	" StMFullMatrix(StMFullRow(227.33333333333d 254.0d 280.66666666667d) StMFullRow(428.0d 454.66666666667d 481.33333333333d) StMFullRow(628.66666666667d 655.33333333333d 682.0d))"

	| matrix matrix2 matrix3 dum |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d)).
	matrix2 := StMFullMatrix newWithElements: #(#(110.0d 120.0d 130.0d) #(210.0d 220.0d 230.0d) #(310.0d 320.0d 330.0d)).
	matrix3 := matrix transpose.
	dum := StMFullMatrix newWithElements: #(#(0.0d 0.0d 0.0d) #(0.0d 0.0d 0.0d) #(0.0d 0.0d 0.0d)).
	dum := ((matrix3 timesNumber: 1.0d / 3.0d) plusFullMatrix: (matrix2 timesNumber: 1.0d / 3.0d)) plusFullMatrix: dum.
	dum := (matrix2 plusFullMatrix: matrix3) plusFullMatrix: dum.
	dum := ((matrix3 timesNumber: 1.0d / 3.0d) minusFullMatrix: (matrix2 timesNumber: 1.0d / 3.0d)) plusFullMatrix: dum.
	dum := (matrix2 minusFullMatrix: matrix3) plusFullMatrix: dum.
	^dum
!

example6
	"self halt. self example6."

	| vector matrix answer1 |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	answer1 := matrix timesFullColumn: vector.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	matrix := StMFullMatrix newWithElements: #(#(11.0d) #(21.0d) #(31.0d) #(41.0d)).
	answer1 := matrix timesFullRow: vector transpose.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	answer1 := matrix transpose timesFullColumn: vector.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d)).
	answer1 := matrix transpose timesFullRow: vector transpose.
	^answer1
!

example7
	"self halt. self example7."

	| vector vector2 answer1 |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	vector2 := StMFullColumn newWithElements: #(1 2 3 4).
	answer1 := vector2 timesFullColumn: vector.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	vector2 := StMFullColumn newWithElements: #(1 2 3 4).
	answer1 := vector2 timesFullRow: vector transpose.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	vector2 := StMFullColumn newWithElements: #(1 2 3 4).
	answer1 := vector2 transpose timesFullColumn: vector.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	vector2 := StMFullColumn newWithElements: #(1 2 3 4).
	answer1 := vector2 transpose timesFullRow: vector transpose.
	^answer1
!

example8
	"self halt. self example8."

	| matrix matrix2 answer1 |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	matrix2 := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d)).
	answer1 := matrix timesFullMatrix: matrix2.
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	matrix2 := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	answer1 := matrix timesFullMatrix: matrix2 transpose.
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	matrix2 := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	answer1 := matrix transpose timesFullMatrix: matrix2.
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d)).
	matrix2 := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	answer1 := matrix transpose timesFullMatrix: matrix2 transpose.
	^answer1
!

example9
	"self halt. self example9."

	| vector matrix answer1 answer2 |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d)).
	answer1 := vector timesFullMatrix: matrix.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	matrix := StMFullMatrix newWithElements: #(#(11.0d) #(21.0d) #(31.0d) #(41.0d)).
	answer1 := vector timesFullMatrix: matrix transpose.
	answer2 := vector timesTransposeFullMatrix: matrix.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d) #(21.0d 22.0d 23.0d) #(31.0d 32.0d 33.0d) #(41.0d 42.0d 43.0d)).
	answer1 := vector transpose timesFullMatrix: matrix.
	answer2 := vector transposeTimesFullMatrix: matrix.
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d).
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d)).
	answer1 := vector transpose timesFullMatrix: matrix transpose.
	^answer1
! !

!StMArray class methodsFor:'examples2'!

example10
	"self halt. self example10."
	"#(0.5d 1.0d 1.5d 2.0d 1.0d 2.0d 3.0d 4.0d 5.0d)"

	| vector vector2 dum |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	vector2 := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d 5.0d).
	dum := StMFullColumn new: 9.
	dum at: 1 putFullColumn: vector.
	dum at: 5 putFullColumn: vector2.
	dum at: 1 putFullColumn: vector times: 1.0d / 2.0d.
	dum at: 5 putFullColumn: vector2.
	dum at: 1 plusFullColumn: vector times: 1.0d / 2.0d.
	dum at: 5 plusFullColumn: vector.
	dum at: 1 minusFullColumn: vector times: 1.0d / 2.0d.
	dum at: 5 minusFullColumn: vector.
	^dum
!

example11
	"self halt. self example11."
	"#(2.0d 3.0d 4.0d)"

	| vector vector2 dum |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	vector2 := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d 5.0d).
	dum := StMFullColumn new: 3.
	dum equalFullColumn: vector at: 2.
	dum equalSelfPlusFullColumn: vector2 at: 2.
	dum equalSelfMinusFullColumn: vector2 at: 2.
	^dum
!

example11b
	"self halt. self example11b."
	"#(22.0d 32.0d 42.0d)"

	| matrix dum |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d 14.0d) #(21.0d 22.0d 23.0d 24.0d) #(31.0d 32.0d 33.0d 34.0d) #(41.0d 42.0d 43.0d 44.0d)).
	dum := StMFullColumn new: 3.
	dum equalFullMatrix: matrix at: 2 and: 2.
	dum equalSelfPlusFullMatrix: matrix at: 2 and: 2.
	dum equalSelfMinusFullMatrix: matrix at: 2 and: 2.
	^dum
!

example11d
	"self halt. self example11d."
	"#(22.0d 23.0d 24.0d)"

	| matrix dum |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d 14.0d) #(21.0d 22.0d 23.0d 24.0d) #(31.0d 32.0d 33.0d 34.0d) #(41.0d 42.0d 43.0d 44.0d)).
	dum := StMFullColumn new: 3.
	dum equalFullMatrix: matrix transpose at: 2 and: 2.
	dum equalSelfPlusFullMatrix: matrix transpose at: 2 and: 2.
	dum equalSelfMinusFullMatrix: matrix transpose at: 2 and: 2.
	^dum
!

example12
	"self halt. self example12."
	"StMFullMatrix(StMFullRow(-1.0d 0.5d nil nil nil) StMFullRow(-2.0d 1.0d nil nil nil) StMFullRow(-3.0d 
	1.5d nil nil nil) StMFullRow(-4.0d 2.0d nil nil nil) StMFullRow(-1.0d -2.0d -3.0d -4.0d nil))"

	| vector dum |
	vector := StMFullColumn newWithElements: #(1.0d 2.0d 3.0d 4.0d).
	dum := StMFullMatrix new: 5 by: 5.
	dum at: 1 and: 1 putFullColumn: vector.
	dum at: 1 and: 2 putFullColumn: (vector timesNumber: 1.0d / 2.0d).
	dum at: 1 and: 1 putFullColumn: vector negated.
	dum at: 5 and: 1 putFullRow: vector transpose.
	dum at: 5 and: 1 putFullRow: (vector transpose timesNumber: 1.0d / 2.0d).
	dum at: 5 and: 1 putFullRow: vector transpose negated.
	dum at: 1 and: 1 plusFullColumn: vector.
	dum at: 1 and: 1 plusFullColumn: (vector timesNumber: 1.0d / 2.0d).
	dum at: 1 and: 1 plusFullColumn: vector negated.
	dum at: 5 and: 1 plusFullRow: vector transpose.
	dum at: 5 and: 1 plusFullRow: (vector transpose timesNumber: 1.0d / 2.0d).
	dum at: 5 and: 1 plusFullRow: vector transpose negated.
	dum at: 1 and: 1 minusFullColumn: vector.
	dum at: 1 and: 1 minusFullColumn: (vector timesNumber: 1.0d / 2.0d).
	dum at: 1 and: 1 minusFullColumn: vector negated.
	dum at: 5 and: 1 minusFullRow: vector transpose.
	dum at: 5 and: 1 minusFullRow: (vector transpose timesNumber: 1.0d / 2.0d).
	dum at: 5 and: 1 minusFullRow: vector transpose negated.
	^dum
!

example12a
	"self halt. self example12a."

	| matrix dum |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d 14.0d) #(21.0d 22.0d 23.0d 24.0d) #(31.0d 32.0d 33.0d 34.0d) #(41.0d 42.0d 43.0d 44.0d)).
	dum := StMFullMatrix new: 8 by: 8.
	dum at: 1 and: 1 putFullMatrix: matrix.
	dum at: 5 and: 5 putFullMatrix: (matrix timesNumber: 1.0d / 2.0d).
	dum at: 1 and: 1 putFullMatrix: matrix negated.
	dum at: 5 and: 1 putFullMatrix: matrix transpose.
	dum at: 5 and: 1 putFullMatrix: (matrix transpose timesNumber: 1.0d / 2.0d).
	dum at: 5 and: 1 putFullMatrix: matrix transpose negated.
	dum at: 1 and: 1 plusFullMatrix: matrix.
	dum at: 1 and: 1 plusFullMatrix: (matrix timesNumber: 1.0d / 2.0d).
	dum at: 1 and: 1 plusFullMatrix: matrix negated.
	dum at: 5 and: 1 plusFullMatrix: matrix transpose.
	dum at: 5 and: 1 plusFullMatrix: (matrix transpose timesNumber: 1.0d / 2.0d).
	dum at: 5 and: 1 plusFullMatrix: matrix transpose negated.
	dum at: 1 and: 1 minusFullMatrix: matrix.
	dum at: 1 and: 1 minusFullMatrix: (matrix timesNumber: 1.0d / 2.0d).
	dum at: 1 and: 1 minusFullMatrix: matrix negated.
	dum at: 5 and: 1 minusFullMatrix: matrix transpose.
	dum at: 5 and: 1 minusFullMatrix: (matrix transpose timesNumber: 1.0d / 2.0d).
	dum at: 5 and: 1 minusFullMatrix: matrix transpose negated.
	^dum
!

example13
	"self halt. self example13."

	| matrix dum |
	matrix := StMFullMatrix newWithElements: #(#(11.0d 12.0d 13.0d 14.0d) #(21.0d 22.0d 23.0d 24.0d) #(31.0d 32.0d 33.0d 34.0d) #(41.0d 42.0d 43.0d 44.0d)).
	dum := StMFullMatrix new: 3 by: 3.
	dum equalFullMatrix: matrix at: 1 and: 1.
	dum equalFullMatrix: (matrix timesNumber: 1.0d / 2.0d) at: 1 and: 2.
	dum equalFullMatrix: matrix negated at: 1 and: 1.
	dum equalFullMatrix: matrix transpose at: 2 and: 1.
	dum equalSelfPlusFullMatrix: matrix at: 1 and: 1.
	dum equalSelfPlusFullMatrix: (matrix timesNumber: 1.0d / 2.0d) at: 1 and: 1.
	dum equalSelfPlusFullMatrix: matrix negated at: 1 and: 1.
	dum equalSelfPlusFullMatrix: matrix transpose at: 2 and: 1.
	dum equalSelfMinusFullMatrix: matrix at: 2 and: 1.
	dum equalSelfMinusFullMatrix: (matrix timesNumber: 1.0d / 2.0d) at: 1 and: 1.
	dum equalSelfMinusFullMatrix: matrix negated at: 1 and: 1.
	dum equalSelfMinusFullMatrix: matrix transpose at: 2 and: 1.
	^dum
! !

!StMArray class methodsFor:'examples3'!

example31
	"self halt. self example31"
	"2 -1 3"

	| aA b |
	aA := StMSparseMatrix new: 3 by: 3.
	aA at: 1 and: 1 put: 2.0d.
	aA at: 1 and: 2 put: -5.0d.
	aA at: 1 and: 3 put: 1.0d.
	aA at: 2 and: 1 put: -1.0d.
	aA at: 2 and: 2 put: 3.0d.
	aA at: 2 and: 3 put: -1.0d.
	aA at: 3 and: 1 put: 3.0d.
	aA at: 3 and: 2 put: -4.0d.
	aA at: 3 and: 3 put: 2.0d.
	b := StMFullColumn new: 3.
	b at: 1 put: 12.0d.
	b at: 2 put: -8.0d.
	b at: 3 put: 16.0d
! !

!StMArray methodsFor:'accessing'!

elementClass
	"Vector and Matrix are intended to store numbers of the same class."

	^Double
!

numberClass
	"Vector and Matrix are intended to store numbers of the same class."

	^Double
!

numberOfElements
	"Answer the number of elements in the full vector or matrix."

	self subclassResponsibility
!

numberOfNonZeros
	"Answer the number of non-zeros in the full vector or matrix."

	self subclassResponsibility
!

numberOfStorageLocations
	"Answer the total number of numbers 'values' can hold."

	self subclassResponsibility
!

numberOfStoredElements
	"Answer the actual number of numbers 'values' is holding."

	self subclassResponsibility
!

numberOfStoredNonZeros
	"Vector or matrix must store all the non zeros."

	self numberOfNonZeros
!

numberOfStoredZeros
	"Answer the actual number of zeros 'values' is holding."

	self subclassResponsibility
!

numberOfZeros
	"Answer the number of zeros in the full vector or matrix."

	self subclassResponsibility
! !

!StMArray methodsFor:'basic ops'!

* aNumber 
	| n answer |
	n := self size.
	answer := self class new: n.
	1 to: n do: [:i | answer at: i put: (self at: i)
				* aNumber].
	^answer
!

+ array 
	"No checking for speed. Assumes correct dimensions and type."

	| n answer |
	n := self size.
	answer := self class new: n.
	1 to: n do: [:i | answer at: i put: (self at: i)
				+ (array at: i)].
	^answer
!

- array 
	"No checking for speed. Assumes correct dimensions and type."

	| n answer |
	n := self size.
	answer := self class new: n.
	1 to: n do: [:i | answer at: i put: (self at: i)
				- (array at: i)].
	^answer
!

/ aNumber 
	| n answer |
	n := self size.
	answer := self class new: n.
	1 to: n do: [:i | answer at: i put: (self at: i)
				/ aNumber].
	^answer
!

arrangeElementsAccordingTo: arrayOfOriginalPositions 
	| n answer elementi |
	n := self size.
	answer := self class new: n.
	1 to: n
		do: 
			[:i | 
			elementi := self at: (arrayOfOriginalPositions at: i).
			answer at: i put: elementi].
	^answer
!

conditioned
	"Answer a fresh vector with insignificant elements set to zeros."

	^self copy conditionSelf
!

conditionedWithTol: tol 
	"Answer a fresh vector with insignificant elements set to zeros."

	^self copy conditionSelfWithTol: tol
!

dot: stmArray 
        "Either receiver or argument must be a one dimensional array."
        "Assume the same first dimensions."

        | array1D array answer |
        (self at: 1) isLimitedPrecisionReal
                ifTrue: 
                        [array1D := self.
                        array := stmArray]
                ifFalse: [(stmArray at: 1) isLimitedPrecisionReal
                                ifTrue: 
                                        [array1D := stmArray.
                                        array := self]
                                ifFalse: [self error: 'Dot product requires either receiver or argument to be one dimensional.']].
        answer := (array at: 1)
                                * (array1D at: 1).
        answer isLimitedPrecisionReal
                ifTrue: [2 to: array1D size do: [:i | answer := answer + ((array at: i)
                                                                * (array1D at: i))]]
                ifFalse: [2 to: array1D size do: [:i | answer equalSelfPlus: (array at: i)
                                                * (array1D at: i)]].
        ^answer
!

elementTimesElementOf: stmArray 
	"Element by element multiplication."

	| n answer |
	n := self size.
	answer := self class new: n.
	1 to: n do: [:i | answer at: i put: (self at: i)
				* (stmArray at: i)].
	^answer
!

minus: stmArray times: aNumber 
	^self plus: stmArray times: aNumber negated
!

minusNumber: aNumber 
	"Minus aNumber from each element."

	^self plusNumber: aNumber negated
!

moveElementsToPositionsSpecifiedBy: arrayOfNewPositions 
	| n answer newi |
	n := self size.
	answer := self class new: n.
	1 to: n
		do: 
			[:i | 
			newi := arrayOfNewPositions at: i.
			answer at: newi put: (self at: i)].
	^answer
!

negated
	| n answer |
	n := self size.
	answer := self class new: n.
	1 to: n do: [:i | answer at: i put: (self at: i) negated].
	^answer
!

plus: stmArray times: aNumber 
	"No checking for speed. Assumes correct dimensions and type."

	| n answer |
	n := self size.
	answer := self class new: n.
	(self at: 1) isSequenceable
		ifTrue: [1 to: n do: [:i | answer at: i put: ((self at: i)
						plus: (stmArray at: i)
						times: aNumber)]]
		ifFalse: [1 to: n do: [:i | answer at: i put: (self at: i)
						+ ((stmArray at: i)
								* aNumber)]].
	^answer
!

plusNumber: aNumber 
	"Minus aNumber from each element."

	| n answer |
	n := self size.
	answer := self class new: n.
	(self at: 1) isSequenceable
		ifTrue: [1 to: n do: [:i | answer at: i put: ((self at: i)
						plusNumber: aNumber)]]
		ifFalse: [1 to: n do: [:i | answer at: i put: (self at: i)
						+ aNumber]].
	^answer
!

productFromDouble: aNumber 
	| n answer |
	n := self size.
	answer := self class new: n.
	1 to: n do: [:i | answer at: i put: (self at: i)
				* aNumber].
	^answer
!

times: alpha minus: stmArray 
	"a*alpha - b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| n answer |
	n := self size.
	answer := self class new: n.
	(self at: 1) isSequenceable
		ifTrue: [1 to: n do: [:i | answer at: i put: ((self at: i)
						times: alpha minus: (stmArray at: i))]]
		ifFalse: [1 to: n do: [:i | answer at: i put: (self at: i)
						* alpha - (stmArray at: i)]].
	^answer
!

times: beta minus: stmArray times: alpha 
	^self
		times: beta
		plus: stmArray
		times: alpha negated
!

times: alpha plus: stmArray 
	"a*alpha + b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	^stmArray plus: self times: alpha
!

times: beta plus: stmArray times: alpha 
	"a*alpha + b*beta = b*beta + a*alpha."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| n answer |
	n := self size.
	answer := self class new: n.
	(self at: 1) isSequenceable
		ifTrue: [1 to: n do: [:i | answer at: i put: ((self at: i)
						times: beta
						plus: (stmArray at: i)
						times: alpha)]]
		ifFalse: [1 to: n do: [:i | answer at: i put: (self at: i)
						* beta + ((stmArray at: i)
							* alpha)]].
	^answer
!

timesNumber: aNumber 
	| n answer |
	n := self size.
	answer := self class new: n.
	1 to: n do: [:i | answer at: i put: ((self at: i)
				timesNumber: aNumber)].
	^answer
!

transpose
	"Answer the transpose of self."

	self subclassResponsibility
!

zeroCopy
        ^(self at: 1) isLimitedPrecisionReal
                ifTrue: [self zeroCopyOfVector]
                ifFalse: 
                        [| answer |
                        answer := self shallowCopy.
                        1 to: answer size do: [:i | answer at: i put: (answer at: i) zeroCopy].
                        answer]
!

zeroCopyOfVector
	| answer |
	answer := self shallowCopy.
	1 to: answer size do: [:i | answer at: i put: 0.0d].
	^answer
! !

!StMArray methodsFor:'converting'!

asFullColumn
	self subclassResponsibility
!

asFullMatrix
	self subclassResponsibility
!

asSparseColumn
	self subclassResponsibility
!

asSparseMatrix
	self subclassResponsibility
!

asSparseRow
	self subclassResponsibility
! !

!StMArray methodsFor:'copying'!

postCopy
        (self at: 1) isLimitedPrecisionReal ifFalse: [1 to: self size do: [:i | self at: i put: (self at: i) copy]]
! !

!StMArray methodsFor:'norms'!

length
	"Euclidean norm."
	"Square root of the sum of squares."

	^self sumOfSquares sqrt
!

maxElement
        | selfAt1 |
        selfAt1 := self at: 1.
        ^selfAt1 isLimitedPrecisionReal
                ifTrue: [self maxElementOfVector]
                ifFalse: 
                        [| answer |
                        answer := selfAt1 maxElement.
                        2 to: self size
                                do: 
                                        [:i | 
                                        | element |
                                        element := (self at: i) maxElement.
                                        answer < element ifTrue: [answer := element]].
                        answer]
!

maxElementOfVector
	| selfAt1 answer |
	selfAt1 := self at: 1.
	selfAt1 < 0.0d ifTrue: [selfAt1 := 0.0d - selfAt1].
	answer := selfAt1.
	2 to: self size
		do: 
			[:i | 
			| selfAti |
			selfAti := self at: i.
			selfAti < 0.0d ifTrue: [selfAti := 0.0d - selfAti].
			answer < selfAti ifTrue: [answer := selfAti]].
	^answer
!

minAndMaxValues
        | selfAt1 |
        selfAt1 := self at: 1.
        ^selfAt1 isLimitedPrecisionReal
                ifTrue: [self minAndMaxValuesOfVector]
                ifFalse: 
                        [| rowMinAndMaxValues min max |
                        rowMinAndMaxValues := selfAt1 minAndMaxValues.
                        min := rowMinAndMaxValues at: 1.
                        max := rowMinAndMaxValues at: 2.
                        2 to: self size
                                do: 
                                        [:i | 
                                        | rowMin rowMax |
                                        rowMinAndMaxValues := (self at: i) minAndMaxValues.
                                        rowMin := rowMinAndMaxValues at: 1.
                                        rowMax := rowMinAndMaxValues at: 2.
                                        min < rowMin ifFalse: [min := rowMin].
                                        max > rowMax ifFalse: [max := rowMax]].
                        Array with: min with: max]
!

minAndMaxValuesOfVector
	"Answer array of min value and max value."

	| min max |
	min := self at: 1.
	max := min.
	2 to: self size
		do: 
			[:i | 
			| selfAti |
			selfAti := self at: i.
			min < selfAti ifFalse: [min := selfAti].
			max > selfAti ifFalse: [max := selfAti]].
	^Array with: min with: max
!

rootMeanSquare
	"(sumOfSquares / numberOfElements) sqrt"

	^(self sumOfSquares / self numberOfElements) sqrt
!

sumOfAbsElements
        "Sum of all element abs values."

        | selfAt1 |
        selfAt1 := self at: 1.
        ^selfAt1 isLimitedPrecisionReal
                ifTrue: [self sumOfAbsElementsOfVector]
                ifFalse: 
                        [| sum |
                        sum := selfAt1 sumOfAbsElements.
                        2 to: self size do: [:i | sum := sum + (self at: i) sumOfAbsElements].
                        sum]
!

sumOfAbsElementsOfVector
	| sum selfAt1 |
	selfAt1 := self at: 1.
	sum := selfAt1 > 0.0d
				ifTrue: [selfAt1]
				ifFalse: [0.0d - selfAt1].
	2 to: self size
		do: 
			[:i | 
			| selfAti |
			selfAti := self at: i.
			sum := selfAti > 0.0d
						ifTrue: [sum + selfAti]
						ifFalse: [sum - selfAti]].
	^sum
!

sumOfElements
        "Sum of all elements."

        | selfAt1 |
        selfAt1 := self at: 1.
        ^selfAt1 isLimitedPrecisionReal
                ifTrue: [self sumOfElementsOfVector]
                ifFalse: 
                        [| sum |
                        sum := selfAt1 sumOfElements.
                        2 to: self size do: [:i | sum := sum + (self at: i) sumOfElements].
                        sum]
!

sumOfElementsOfVector
	| sum |
	sum := self at: 1.
	2 to: self size do: [:i | sum := sum + (self at: i)].
	^sum
!

sumOfElementsOfVectorRaisedTo: number 
	"For each element abs it, raised it to the power of number."
	"Then sum them all."

	| selfAt1 sum |
	selfAt1 := self at: 1.
	selfAt1 < 0.0d ifTrue: [selfAt1 := 0.0d - selfAt1].
	sum := selfAt1 raisedTo: number.
	2 to: self size
		do: 
			[:i | 
			| selfAti |
			selfAti := self at: i.
			selfAti < 0.0d ifTrue: [selfAti := 0.0d - selfAti].
			sum := sum + (selfAti raisedTo: number)].
	^sum
!

sumOfElementsRaisedTo: number 
        "For each element abs it, raised it to the power of number."
        "Then sum them all."

        | selfAt1 |
        selfAt1 := self at: 1.
        ^selfAt1 isLimitedPrecisionReal
                ifTrue: [self sumOfElementsOfVectorRaisedTo: number]
                ifFalse: 
                        [| sum |
                        sum := selfAt1 sumOfElementsRaisedTo: number.
                        2 to: self size do: [:i | sum := sum + ((self at: i)
                                                                sumOfElementsRaisedTo: number)].
                        sum]
!

sumOfSquares
        "Sum of squares of all elements."

        | selfAt1 |
        selfAt1 := self at: 1.
        ^selfAt1 isLimitedPrecisionReal
                ifTrue: [self sumOfSquaresOfVector]
                ifFalse: 
                        [| sum |
                        sum := selfAt1 sumOfSquares.
                        2 to: self size do: [:i | sum := sum + (self at: i) sumOfSquares].
                        sum]
!

sumOfSquaresOfVector
	"Sum of squares of all elements."

	| selfAt1 sum |
	selfAt1 := self at: 1.
	sum := selfAt1 * selfAt1.
	2 to: self size
		do: 
			[:i | 
			| selfAti |
			selfAti := self at: i.
			sum := sum + (selfAti * selfAti)].
	^sum
! !

!StMArray methodsFor:'ops on self'!

at: i timesNumber: aNumber 
	self at: i put: ((self at: i)
			timesNumber: aNumber)
!

conditionSelf
	"Answer a self with insignificant elements set to zeros."

	| tol |
	tol := self maxElement * StMMachineAccuracy OfDouble.
	self conditionSelfWithTol: tol
!

conditionSelfVectorWithTol: tol 
	| element |
	1 to: self size
		do: 
			[:i | 
			element := self at: i.
			element < 0.0d ifTrue: [element := 0.0d - element].
			element < tol ifTrue: [self at: i put: 0.0d]]
!

conditionSelfWithTol: tol 
        (self at: 1) isLimitedPrecisionReal
                ifTrue: [self conditionSelfVectorWithTol: tol]
                ifFalse: [1 to: self size do: [:i | (self at: i)
                                        conditionSelfWithTol: tol]]
!

equal: stmArray 
        "Assume self and stmArray are same type and dimensions."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: [1 to: self size do: [:i | self at: i put: (stmArray at: i)]]
                ifFalse: [1 to: self size do: [:i | (self at: i)
                                        equal: (stmArray at: i)]]
!

equal: stmArray at: ii1 
        "Assume self and stmArray are same type and dimensions."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: 
                        [| iiOffset |
                        iiOffset := ii1 - 1.
                        1 to: self size do: [:i | self at: i put: (stmArray at: iiOffset + i)]]
                ifFalse: 
                        [| iiOffset |
                        iiOffset := ii1 - 1.
                        1 to: self size do: [:i | (self at: i)
                                        equal: (stmArray at: iiOffset + i)]]
!

equal: stmArray at: ii1 and: jj1 
	| iiOffset |
	iiOffset := ii1 - 1.
	1 to: self nrow do: [:i | (self at: i)
			equal: (stmArray at: iiOffset + i)
			at: jj1]
!

equal: stmArray times: number 
        "Assume self and stmArray are same type and dimensions."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: [1 to: self size do: [:i | self at: i put: (stmArray at: i)
                                                * number]]
                ifFalse: [1 to: self size do: [:i | (self at: i)
                                        equal: (stmArray at: i)
                                        times: number]]
!

equalSelfMinus: stmArray 
        "Assume self and stmArray are same type and dimensions."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: [1 to: self size do: [:i | self at: i put: (self at: i)
                                                - (stmArray at: i)]]
                ifFalse: [1 to: self size do: [:i | (self at: i)
                                        equalSelfMinus: (stmArray at: i)]]
!

equalSelfMinus: stmArray at: ii1 
        "Assume self and stmArray are same type and dimensions."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: 
                        [| iiOffset |
                        iiOffset := ii1 - 1.
                        1 to: self size do: [:i | self at: i put: (self at: i)
                                                - (stmArray at: iiOffset + i)]]
                ifFalse: 
                        [| iiOffset |
                        iiOffset := ii1 - 1.
                        1 to: self size do: [:i | (self at: i)
                                        equalSelfMinus: (stmArray at: iiOffset + i)]]
!

equalSelfMinus: stmArray at: ii1 and: jj1 
	| iiOffset |
	iiOffset := ii1 - 1.
	1 to: self nrow do: [:i | (self at: i)
			equalSelfMinus: (stmArray at: iiOffset + i)
			at: jj1]
!

equalSelfMinus: stmArray times: number 
	"Assume self and stmArray are same type and dimensions."

	self equalSelfPlus: stmArray times: number negated
!

equalSelfPlus: stmArray 
        "Assume self and stmArray are same type and dimensions."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: [1 to: self size do: [:i | self at: i put: (self at: i)
                                                + (stmArray at: i)]]
                ifFalse: [1 to: self size do: [:i | (self at: i)
                                        equalSelfPlus: (stmArray at: i)]]
!

equalSelfPlus: stmArray at: ii1 
        "Assume self and stmArray are same type and dimensions."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: 
                        [| iiOffset |
                        iiOffset := ii1 - 1.
                        1 to: self size do: [:i | self at: i put: (self at: i)
                                                + (stmArray at: iiOffset + i)]]
                ifFalse: 
                        [| iiOffset |
                        iiOffset := ii1 - 1.
                        1 to: self size do: [:i | (self at: i)
                                        equalSelfPlus: (stmArray at: iiOffset + i)]]
!

equalSelfPlus: stmArray at: ii1 and: jj1 
	| iiOffset |
	iiOffset := ii1 - 1.
	1 to: self nrow do: [:i | (self at: i)
			equalSelfPlus: (stmArray at: iiOffset + i)
			at: jj1]
!

equalSelfPlus: stmArray times: number 
        "Assume self and stmArray are same type and dimensions."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: [1 to: self size do: [:i | self at: i put: (self at: i)
                                                + ((stmArray at: i)
                                                                * number)]]
                ifFalse: [1 to: self size do: [:i | (self at: i)
                                        equalSelfPlus: (stmArray at: i)
                                        times: number]]
!

equalSelfTimes: alpha minus: stmArray times: beta 
	self
		equalSelfTimes: alpha
		plus: stmArray
		times: beta negated
!

equalSelfTimes: alpha plus: stmArray times: beta 
        "Assume self and stmArray are same type and dimensions."
        "alpha and beta are numbers."

        (self at: 1) isLimitedPrecisionReal
                ifTrue: [1 to: self size do: [:i | self at: i put: (self at: i)
                                                * alpha + ((stmArray at: i)
                                                        * beta)]]
                ifFalse: [1 to: self size do: [:i | (self at: i)
                                        equalSelfTimes: alpha
                                        plus: (stmArray at: i)
                                        times: beta]]
!

magnifySelf: aNumber 
        "Magnify every number in the receiver by aNumber."

        aNumber = 1 ifTrue: [^self].
        (self at: 1) isLimitedPrecisionReal
                ifTrue: [self magnifySelfVector: aNumber]
                ifFalse: [1 to: self size do: [:i | (self at: i)
                                        magnifySelf: aNumber]]
!

magnifySelfVector: aNumber 
	"Magnify every number in the receiver by aNumber."

	aNumber = 1 ifTrue: [^self].
	1 to: self size do: [:i | self at: i put: (self at: i)
				* aNumber]
!

negateSelf
	"Negate every number in the array."

	self magnifySelf: -1.0d
!

zeroSelf
	"Zero all stored numbers in array."

	(self at: 1) isSequenceable
		ifTrue: [1 to: self size do: [:i | (self at: i) zeroSelf]]
		ifFalse: [self zeroSelfOfVector]
!

zeroSelfOfVector
	"Zero all stored numbers in array."

	1 to: self size do: [:i | self at: i put: 0.0d]
! !

!StMArray methodsFor:'printing'!

printOn: aStream 
	"Append to the argument, aStream, the elements of the Array 
	enclosed by parentheses."

	| tooMany |
	tooMany := aStream position + self maxPrint.
	aStream print: self class.
	aStream nextPutAll: '('.
	self
		do: 
			[:element | 
			aStream position > tooMany
				ifTrue: 
					[aStream nextPutAll: '...(more)...)'.
					^self].
			element printOn: aStream]
		separatedBy: [aStream space].
	aStream nextPut: $)
! !

!StMArray methodsFor:'testing'!

isZero
	1 to: self size do: [:i | (self at: i) isZero ifFalse: [^false]].
	^true
!

positive
	1 to: self size do: [:i | (self at: i) positive ifFalse: [^false]].
	^true
! !

!StMArray class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMArray.st,v 1.7 2006/10/04 13:00:51 cg Exp $'
! !
