"{ Package: 'stx:goodies/math/stmath' }"

StMIntegrator subclass:#StMBasicIntegrator
	instanceVariableNames:'istep iTry maxTry tpast t tnew h hnew order orderNew orderMax
		opBDF continue'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-Integrator'
!


!StMBasicIntegrator methodsFor:'accessing'!

continue: boolean 
	continue := boolean
!

iStep: integer 
	istep := integer.
	opBDF iStep: integer
!

istep
	^istep
!

opBDF
	^opBDF
!

order: integer 
	order := integer.
	opBDF order: integer
!

orderMax: integer 
	integer == nil
		ifTrue: [orderMax := 5]
		ifFalse: [orderMax := integer asInteger]
!

t
	^t
!

t: double 
	t := double.
	self time: double
!

time: double 
	opBDF time: double
!

tnew: double 
	tnew := double.
	self time: double
!

tprevious
	^tpast at: 1
! !

!StMBasicIntegrator methodsFor:'initialize-release'!

initialize
	super initialize.
	tpast := OrderedCollection new.
	opBDF := StMBackwardDifference new.
	opBDF timeNodes: tpast
!

initializeLocally
	continue := true
! !

!StMBasicIntegrator methodsFor:'run'!

calcOperatorMatrix
	opBDF calcOperatorMatrix
!

incrementTime
	| istepNew |
	tpast addFirst: t.
	tpast size > (orderMax + 1) ifTrue: [tpast removeLast].
	istepNew := istep + 1.
	self iStep: istepNew.
	self order: orderNew.
	h := hnew.
	self tnew: t + h.
	self calcOperatorMatrix.
	system incrementTime: tnew
!

incrementTry
	iTry := iTry + 1
!

postFirstStep
	t := tnew.
	system postFirstStep
!

postRun
	"Do nothing."
!

postStep
	t := tnew.
	system postStep
!

preFirstStep
	system preFirstStep
!

preRun
	"Do nothing."
!

preStep
	system preStep
!

reportStats
	"Do nothing."
!

run
	self preRun.
	self initializeLocally.
	self initializeGlobally.
	self firstStep.
	self subsequentSteps.
	self finalize.
	self reportStats.
	self postRun
!

selectOrder
	"Increase order consecutively with step."

	iTry == 1 ifTrue: [orderNew := istep + 1 min: orderMax]
!

subsequentSteps
	[continue]
		whileTrue: [self nextStep]
! !

!StMBasicIntegrator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMBasicIntegrator.st,v 1.6 2006/10/04 13:00:51 cg Exp $'
! !
