"{ Package: 'stx:goodies/math/stmath' }"

StMFunctionX subclass:#StMCompositeFunctionX
	instanceVariableNames:'expression'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMCompositeFunctionX class methodsFor:'instance creation'!

with: arg expression: func 
	^super new x: arg expression: func
! !

!StMCompositeFunctionX methodsFor:'accessing'!

x: arg 
	| newx |
	newx := self conditionArgument: arg.
	x isNil
		ifFalse: 
			[x removeDependent: self.
			expression substitute: x with: newx].
	x := newx.
	self changed
! !

!StMCompositeFunctionX methodsFor:'changing'!

substitute: var1 with: var2 
	super substitute: var1 with: var2.
	expression == var1
		ifTrue: 
			[var1 removeDependent: self.
			var2 addDependent: self.
			expression := var2.
			self changed]
		ifFalse: [expression substitute: var1 with: var2]
! !

!StMCompositeFunctionX methodsFor:'evaluating'!

differentiateWRT: variable 
	| deriv |
	deriv := expression differentiateWRT: variable.
	^StMCompositeFunctionX with: x copy expression: deriv
!

partialDifferentiateWRT: variable 
	| deriv |
	deriv := expression partialDifferentiateWRT: variable.
	^StMCompositeFunctionX with: x copy expression: deriv
!

setValue
	value := expression value
!

simplified
	super simplified.
	expression := expression simplified.
	expression isZero ifTrue: [^StMConstant with: 0]
! !

!StMCompositeFunctionX methodsFor:'initialize-release'!

x: arg expression: func 
	x := self conditionArgument: arg.
	expression := self conditionArgument: func
! !

!StMCompositeFunctionX methodsFor:'message handling'!

argsPerform: aSymbol 
	super perform: aSymbol.
	expression perform: aSymbol
!

argsPerform: selector withArguments: anArray 
	super perform: selector withArguments: anArray.
	expression perform: selector withArguments: anArray
! !

!StMCompositeFunctionX class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMCompositeFunctionX.st,v 1.6 2006/10/04 13:00:51 cg Exp $'
! !
