"{ Package: 'stx:goodies/math/stmath' }"

StMFunctionXY subclass:#StMCompositeFunctionXY
	instanceVariableNames:'expression'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMCompositeFunctionXY class methodsFor:'instance creation'!

with: argx and: argy expression: func 
	^super new
		x: argx
		y: argy
		expression: func
! !

!StMCompositeFunctionXY methodsFor:'accessing'!

x: arg 
	| newx |
	newx := self conditionArgument: arg.
	x isNil
		ifFalse: 
			[x removeDependent: self.
			expression substitute: x with: newx].
	x := newx.
	self changed
!

y: arg 
	| newy |
	newy := self conditionArgument: arg.
	y isNil
		ifFalse: 
			[y removeDependent: self.
			expression substitute: y with: newy].
	y := newy.
	self changed
! !

!StMCompositeFunctionXY methodsFor:'changing'!

substitute: var1 with: var2 
	super substitute: var1 with: var2.
	expression == var1
		ifTrue: 
			[var1 removeDependent: self.
			var2 addDependent: self.
			expression := var2.
			self changed]
		ifFalse: [expression substitute: var1 with: var2]
! !

!StMCompositeFunctionXY methodsFor:'evaluating'!

differentiateWRT: variable 
	| deriv |
	deriv := expression differentiateWRT: variable.
	^StMCompositeFunctionX
		with: x copy
		and: y copy
		expression: deriv
!

partialDifferentiateWRT: variable 
	| deriv |
	deriv := expression partialDifferentiateWRT: variable.
	^StMCompositeFunctionX
		with: x copy
		and: y copy
		expression: deriv
!

setValue
	value := expression value
!

simplified
	super simplified.
	expression := expression simplified.
	expression isZero ifTrue: [^StMConstant with: 0]
! !

!StMCompositeFunctionXY methodsFor:'initialize-release'!

x: argx y: argy expression: func 
	x := self conditionArgument: argx.
	y := self conditionArgument: argy.
	expression := self conditionArgument: func
! !

!StMCompositeFunctionXY methodsFor:'message handling'!

argsPerform: aSymbol 
	super perform: aSymbol.
	expression perform: aSymbol
!

argsPerform: selector withArguments: anArray 
	super perform: selector withArguments: anArray.
	expression perform: selector withArguments: anArray
! !

!StMCompositeFunctionXY class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMCompositeFunctionXY.st,v 1.6 2006/10/04 13:00:52 cg Exp $'
! !
