"{ Package: 'stx:goodies/math/stmath' }"

StMFunction subclass:#StMConstant
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMConstant class methodsFor:'instance creation'!

with: arg 
	^self basicNew value: arg
! !

!StMConstant methodsFor:'accessing'!

addDependent: aFunction 
	"Do nothing."
!

changed
	"Do nothing."
!

removeDependency
	"Do nothing."
!

removeDependent: aFunction 
	"Do nothing."
! !

!StMConstant methodsFor:'changing'!

substitute: var1 with: var2 
	"Do nothing."
! !

!StMConstant methodsFor:'copying'!

copy
	"A Constant is immutable so it is ok to reuse."
	"Do nothing."
! !

!StMConstant methodsFor:'evaluating'!

differentiateWRT: variable 
	^StMConstant with: 0
!

partialDifferentiateWRT: variable 
	^StMConstant with: 0
!

simplified
	"Do nothing."
!

value
	^value
! !

!StMConstant methodsFor:'message handling'!

argsPerform: aSymbol 
	"Do nothing."
!

argsPerform: selector withArguments: anArray 
	"Do nothing."
! !

!StMConstant methodsFor:'printing'!

printOn: aStream 
	aStream print: value
! !

!StMConstant methodsFor:'private'!

value: arg 
        arg isInteger ifTrue:[
            value := arg.
            ^ self.
        ].
        arg isLimitedPrecisionReal ifTrue:[
            value := arg.
            ^ self.
        ].

        self error: 'Argument must be a constant.'
! !

!StMConstant methodsFor:'testing'!

isConstant
	^true
!

isOne
	^value = 1
!

isZero
	^value = 0
! !

!StMConstant class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMConstant.st,v 1.7 2006/10/04 13:00:52 cg Exp $'
! !
