"{ Package: 'stx:goodies/math/stmath' }"

StMMatrixCroutDecomposition3 subclass:#StMCroutFullMat3
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-MatrixSolver'
!


!StMCroutFullMat3 methodsFor:'back substitution'!

backSubstituteIntoU
	"U is upper triangular with ones in the diagonal."

	| rowi sum rhsZeroElement |
	answerX := rightHandSideB class new: n.
	rhsZeroElement := self rhsZeroElement.
	n
		to: 1
		by: -1
		do: 
			[:i | 
			rowi := matrixA at: i.
			sum := rhsZeroElement copy.
			i + 1 to: n do: [:j | sum := (rowi at: j)
							* (answerX at: j) + sum].
			answerX at: i put: (rightHandSideB at: i)
					- sum]
! !

!StMCroutFullMat3 methodsFor:'forward substitution'!

forwardSubstituteIntoLD
	"LD is lower triangular with nonzero and arbitrary diagonals."

	| vectorc rowi sum rhsZeroElement |
	vectorc := rightHandSideB class new: n.
	rhsZeroElement := self rhsZeroElement.
	1 to: n
		do: 
			[:i | 
			rowi := matrixA at: i.
			sum := rhsZeroElement copy.
			1 to: i - 1 do: [:j | sum := (rowi at: j)
							* (vectorc at: j) + sum].
			vectorc at: i put: (rightHandSideB at: i)
					- sum / (rowi at: i)].
	^rightHandSideB := vectorc
! !

!StMCroutFullMat3 methodsFor:'solution'!

formLij: p 
	| sum rowi |
	p to: m
		do: 
			[:i | 
			sum := 0.0d.
			rowi := matrixA at: i.
			1 to: p - 1 do: [:k | sum := (rowi at: k)
							* (matrixA at: k and: p) + sum].
			rowi at: p minusNumber: sum]
!

formUij: p 
	| rowp lpp sum upj |
	rowp := matrixA at: p.
	lpp := rowp at: p.
	p + 1 to: n
		do: 
			[:j | 
			sum := 0.0d.
			1 to: p - 1 do: [:k | sum := (rowp at: k)
							* (matrixA at: k and: j) + sum].
			upj := (rowp at: j)
						- sum / lpp.
			rowp at: j put: upj]
!

inverse: aMatrix 
	"ForAndBackSub be optimized for the identity matrix."

	| matrixAinverse |
	self decompose: aMatrix.
	rightHandSideB := StMFullColumn new: m.
	matrixAinverse := StMFullMatrix new: m by: n.
	1 to: n
		do: 
			[:j | 
			rightHandSideB zeroSelf.
			rightHandSideB at: j put: 1.0d.
			self forAndBackSubNoSave: rightHandSideB.
			matrixAinverse at: 1 and: j putFullColumn: answerX].
	^matrixAinverse
! !

!StMCroutFullMat3 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMCroutFullMat3.st,v 1.6 2006/10/04 13:00:52 cg Exp $'
! !
