"{ Package: 'stx:goodies/math/stmath' }"

StMGeneralSpline subclass:#StMDifferentiatedGeneralSpline
	instanceVariableNames:'derivativeOrder'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMDifferentiatedGeneralSpline class methodsFor:'instance creation'!

with: aStMGeneralSpline derivativeOrder: integer 
	^super new generalSpline: aStMGeneralSpline derivativeOrder: integer
! !

!StMDifferentiatedGeneralSpline methodsFor:'evaluating'!

derivative: n at: xx 
	"dydx(x) := dydxi + d2ydx2i*hi + d3ydx3i*hi^2/2!! +"
	"d2ydx2(x) := d2ydx2i + d3ydx3i*hi + d4ydx4i*hi^2/2!! +"

	| derivsi d1 sum |
	self calcIndexAndDeltaFor: xx.
	derivsi := derivs at: index.
	d1 := derivsi at: 1.
	(d1 isKindOf: Array)
		ifTrue: [sum := (d1 class new: d1 size)
						atAllPut: Double zero]
		ifFalse: [sum := d1 class zero].
	degree
		to: n + 1
		by: -1
		do: [:j | sum := sum + (derivsi at: j) * delta / (j - n) asDouble].
	^(derivsi at: n)
		+ sum
!

differentiateWRTx
	^StMDifferentiatedGeneralSpline with: self derivativeOrder: self derivativeOrder + 1
!

setValue
	value := self derivative: derivativeOrder at: x value
! !

!StMDifferentiatedGeneralSpline methodsFor:'instance creation'!

generalSpline: stmGeneralSpline derivativeOrder: integer 
	x := stmGeneralSpline x copy.
	xs := stmGeneralSpline xs.
	ys := stmGeneralSpline ys.
	derivs := stmGeneralSpline derivs.
	degree := stmGeneralSpline degree.
	derivativeOrder := integer asInteger
! !

!StMDifferentiatedGeneralSpline class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMDifferentiatedGeneralSpline.st,v 1.6 2006/10/04 13:00:52 cg Exp $'
! !
