"{ Package: 'stx:goodies/math/stmath' }"

StMDependentVariable subclass:#StMDifferentiatedVariable
	instanceVariableNames:'wrts'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!

StMDifferentiatedVariable comment:'x is the variable to be differentiated.
wrt := ''with respect to''.

Instance Variables:

wrt	<OrderedCollection>	stores the differential variables in order of differentiation use.'
!


!StMDifferentiatedVariable class methodsFor:'instance creation'!

with: var wrt: differential 
	^(super new) x: var; wrtsAdd: differential
! !

!StMDifferentiatedVariable methodsFor:'accessing'!

removeDependency
	x removeDependent: self.
	wrts do: [:wrt | wrt removeDependent: self]
!

wrtsAdd: variable 
	wrts add: variable
! !

!StMDifferentiatedVariable methodsFor:'changing'!

substitute: var1 with: var2 
	super substitute: var1 with: var2.
	wrts do: [:wrt | wrt substitute: var1 with: var2]
! !

!StMDifferentiatedVariable methodsFor:'evaluating'!

differentiateWRTx
	| xcopy answer |
	xcopy := x copy.
	answer := self class new.
	answer x: xcopy.
	wrts do: [:wrt | answer wrtsAdd: wrt].
	answer wrtsAdd: xcopy.
	^answer
! !

!StMDifferentiatedVariable methodsFor:'initialize-release'!

initialize
	super initialize.
	wrts := OrderedCollection new
! !

!StMDifferentiatedVariable methodsFor:'printing'!

printOn: aStream 
	aStream print: self class.
	aStream nextPut: $'.
	aStream print: name.
	aStream nextPut: $'.
	aStream nextPut: $(.
	aStream print: x.
	aStream nextPutAll: ' wrts '.
	aStream print: wrts.
	aStream nextPut: $)
! !

!StMDifferentiatedVariable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMDifferentiatedVariable.st,v 1.4 2006/10/04 13:00:52 cg Exp $'
! !
