"{ Package: 'stx:goodies/math/stmath' }"

StMFunction subclass:#StMFunctionManyTerms
	instanceVariableNames:'terms'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMFunctionManyTerms methodsFor:'accessing'!

removeDependency
	terms do: [:term | term removeDependent: self]
!

terms: collection 
	terms := collection.
	terms do: [:term | term addDependent: self].
	self changed
! !

!StMFunctionManyTerms methodsFor:'changing'!

substitute: var1 with1: var2 
	terms := terms collect: [:term | term == var1
					ifTrue: 
						[var1 removeDependent: self.
						var2 addDependent: self.
						self changed.
						var2]
					ifFalse: [term substitute: var1 with: var2]]
!

substitute: var1 with: var2 
	1 to: terms size
		do: 
			[:i | 
			| termi |
			termi := terms at: i.
			termi == var1
				ifTrue: 
					[var1 removeDependent: self.
					var2 addDependent: self.
					self changed.
					terms at: i put: var2]
				ifFalse: [termi substitute: var1 with: var2]]
! !

!StMFunctionManyTerms methodsFor:'copying'!

postCopy
	super postCopy.
	terms := terms
				collect: 
					[:term | 
					| newTerm |
					newTerm := term copy.
					newTerm addDependent: self.
					newTerm]
! !

!StMFunctionManyTerms methodsFor:'initialize-release'!

initialize
	super initialize.
	terms := OrderedCollection new
! !

!StMFunctionManyTerms methodsFor:'message handling'!

argsPerform: aSymbol 
	terms do: [:term | term perform: aSymbol]
!

argsPerform: selector withArguments: anArray 
	terms do: [:term | term perform: selector withArguments: anArray]
! !

!StMFunctionManyTerms methodsFor:'printing'!

printOn: aStream 
	aStream print: self class.
	aStream nextPutAll: '('.
	terms isNil ifFalse: [terms do: [:term | term printOn: aStream]
			separatedBy: [aStream space]].
	aStream nextPut: $)
! !

!StMFunctionManyTerms class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMFunctionManyTerms.st,v 1.4 2006/10/04 13:00:53 cg Exp $'
! !
