"{ Package: 'stx:goodies/math/stmath' }"

StMFunction subclass:#StMFunctionX
	instanceVariableNames:'x'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMFunctionX class methodsFor:'instance creation'!

with: arg 
	^super new x: arg
! !

!StMFunctionX methodsFor:'accessing'!

removeDependency
	x removeDependent: self
!

x: arg 
	| newx |
	newx := self conditionArgument: arg.
	x isNil ifFalse: [x removeDependent: self].
	x := newx.
	self changed
! !

!StMFunctionX methodsFor:'changing'!

substitute: var1 with: var2 
	x == var1
		ifTrue: 
			[var1 removeDependent: self.
			var2 addDependent: self.
			x := var2.
			self changed]
		ifFalse: [x substitute: var1 with: var2]
! !

!StMFunctionX methodsFor:'copying'!

postCopy
	super postCopy.
	x := x copy.
	x addDependent: self
! !

!StMFunctionX methodsFor:'evaluating'!

differentiateWRT: variable 
	| dfdx dxdvar |
	self == variable ifTrue: [^StMConstant with: 1].
	dfdx := self differentiateWRTx.
	dxdvar := x differentiateWRT: variable.
	^(StMCompositeFunctionX with: x copy expression: (dfdx times: dxdvar)) simplified
!

differentiateWRTx
	self subclassResponsibility
!

partialDifferentiateWRT: variable 
	| dfuncdx dxdvar |
	self == variable ifTrue: [^StMConstant with: 1].
	dfuncdx := self differentiateWRTx.
	dxdvar := x partialDifferentiateWRT: variable.
	^(StMProduct with: dfuncdx times: dxdvar) simplified
!

simplified
	x := x simplified
! !

!StMFunctionX methodsFor:'message handling'!

argsPerform: aSymbol 
	x perform: aSymbol
!

argsPerform: selector withArguments: anArray 
	x perform: selector withArguments: anArray
! !

!StMFunctionX methodsFor:'printing'!

printOn: aStream 
	aStream print: self class.
	aStream nextPut: $(.
	aStream print: x.
	aStream nextPut: $)
! !

!StMFunctionX class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMFunctionX.st,v 1.6 2006/10/04 13:00:53 cg Exp $'
! !
