"{ Package: 'stx:goodies/math/stmath' }"

StMFunction subclass:#StMFunctionXY
	instanceVariableNames:'x y'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMFunctionXY methodsFor:'accessing'!

removeDependency
	x removeDependent: self.
	y removeDependent: self
!

x: argx y: argy 
	x := self conditionArgument: argx.
	y := self conditionArgument: argy
! !

!StMFunctionXY methodsFor:'changing'!

substitute: var1 with: var2 
	x == var1
		ifTrue: 
			[var1 removeDependent: self.
			var2 addDependent: self.
			x := var2.
			self changed]
		ifFalse: [x substitute: var1 with: var2].
	y == var1
		ifTrue: 
			[var1 removeDependent: self.
			var2 addDependent: self.
			y := var2.
			self changed]
		ifFalse: [y substitute: var1 with: var2]
! !

!StMFunctionXY methodsFor:'copying'!

postCopy
	super postCopy.
	x := x copy.
	x addDependent: self.
	y := y copy.
	y addDependent: self
! !

!StMFunctionXY methodsFor:'evaluating'!

differentiateWRT: variable 
	| dfdx dxdvar dfdy dydvar |
	self == variable ifTrue: [^StMConstant with: 1].
	dfdx := self differentiateWRTx.
	dxdvar := x differentiateWRT: variable.
	dfdy := self differentiateWRTy.
	dydvar := y differentiateWRT: variable.
	^(StMCompositeFunctionXY
		with: x copy
		and: y copy
		expression: ((dfdx times: dxdvar)
				plus: (dfdy times: dydvar))) simplified
!

differentiateWRTx
	self subclassResponsibility
!

differentiateWRTy
	self subclassResponsibility
!

partialDifferentiateWRT: variable 
	| dfdx dxdvar dfdy dydvar |
	self == variable ifTrue: [^StMConstant with: 1].
	dfdx := self differentiateWRTx.
	dxdvar := x partialDifferentiateWRT: variable.
	dfdy := self differentiateWRTy.
	dydvar := y partialDifferentiateWRT: variable.
	^((dfdx times: dxdvar)
		plus: (dfdy times: dydvar)) simplified
!

simplified
	x := x simplified.
	y := y simplified
! !

!StMFunctionXY methodsFor:'message handling'!

argsPerform: aSymbol 
	x perform: aSymbol.
	y perform: aSymbol
!

argsPerform: selector withArguments: anArray 
	x perform: selector withArguments: anArray.
	y perform: selector withArguments: anArray
! !

!StMFunctionXY class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMFunctionXY.st,v 1.6 2006/10/04 13:00:53 cg Exp $'
! !
