"{ Package: 'stx:goodies/math/stmath' }"

StMMatrixGaussElimination3 subclass:#StMGEFullMat3
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-MatrixSolver'
!


!StMGEFullMat3 methodsFor:'back substitution'!

backSubstituteIntoDU
	"DU is upper triangular with nonzero and arbitrary diagonals."

	| rowi sum |
	answerX := rightHandSideB class new: n.
	answerX at: n put: (rightHandSideB at: m)
			/ (matrixA at: m and: n).
	n - 1
		to: 1
		by: -1
		do: 
			[:i | 
			rowi := matrixA at: i.
			sum := (answerX at: n)
						* (rowi at: n).
			i + 1 to: n - 1 do: [:j | sum := sum + ((answerX at: j)
								* (rowi at: j))].
			answerX at: i put: (rightHandSideB at: i)
					- sum / (rowi at: i)]
! !

!StMGEFullMat3 methodsFor:'forward elimination'!

forwardEliminateWithPivot: p 
	"Ignore elements below pivot. They should be zeros"
	"rightHandSideB may be multidimensional."

	| rowp app bp rowi aip factor |
	rowp := matrixA at: p.
	app := rowp at: p.
	bp := rightHandSideB at: p.
	p + 1 to: m
		do: 
			[:i | 
			rowi := matrixA at: i.
			aip := rowi at: p.
			aip = 0
				ifFalse: 
					[factor := aip / app.
					p + 1 to: n do: [:j | rowi at: j minusNumber: factor * (rowp at: j)].
					rightHandSideB at: i put: (rightHandSideB at: i)
							- (bp * factor)]]
! !

!StMGEFullMat3 methodsFor:'solution'!

postSolve
	"Do nothing."
!

preSolve: aMatrix with: aVector saveOriginal: saveOriginal 
	saveOriginal
		ifTrue: 
			[matrixA := aMatrix copy asFullMatrix.
			rightHandSideB := aVector copy]
		ifFalse: 
			[matrixA := aMatrix asFullMatrix.
			rightHandSideB := aVector].
	(m == matrixA nrow and: [n == matrixA ncol])
		ifFalse: 
			[m := matrixA nrow.
			n := matrixA ncol.
			pivotValues := StMFullColumn new: m.
			rowOrder := StMArray new: m.
			colOrder := StMArray new: n.
			singularPivotTolerance := StMMachineAccuracy OfDoubleTimesFour].
	m = n
		ifTrue: [1 to: m
				do: 
					[:i | 
					rowOrder at: i put: i.
					colOrder at: i put: i]]
		ifFalse: 
			[1 to: m do: [:i | rowOrder at: i put: i].
			1 to: n do: [:j | colOrder at: j put: j]]
! !

!StMGEFullMat3 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMGEFullMat3.st,v 1.6 2006/10/04 13:00:53 cg Exp $'
! !
