"{ Package: 'stx:goodies/math/stmath' }"

StMGEFullMat3 subclass:#StMGEFullMatFullPv3
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-MatrixSolver'
!


!StMGEFullMatFullPv3 class methodsFor:'testing'!

isAbstractClass
	^false
! !

!StMGEFullMatFullPv3 methodsFor:'pivoting'!

doPivoting: p 
	"Do full pivoting."

	| max pivotRow pivotCol rowi aij mag |
	max := 0.
	pivotRow := p.
	pivotCol := p.
	p to: m
		do: 
			[:i | 
			rowi := matrixA at: i.
			p to: n
				do: 
					[:j | 
					aij := rowi at: j.
					aij = 0
						ifFalse: 
							[mag := aij.
							mag < 0 ifTrue: [mag := 0.0d - mag].
							mag > max
								ifTrue: 
									[max := mag.
									pivotRow := i.
									pivotCol := j]]]].
	p == pivotRow
		ifFalse: 
			[matrixA swap: p with: pivotRow.
			rightHandSideB swap: p with: pivotRow.
			rowOrder swap: p with: pivotRow].
	p == pivotCol
		ifFalse: 
			[matrixA do: [:row | row swap: p with: pivotCol].
			colOrder swap: p with: pivotCol].
	pivotValues at: p put: max.
	max < singularPivotTolerance ifTrue: [StMSingularMatrixError raiseSignal]
! !

!StMGEFullMatFullPv3 methodsFor:'solution'!

applyColOrderOnAnswerX
	| answer |
	answer := answerX class new: n.
	1 to: n do: [:i | answer at: (colOrder at: i) put: (answerX at: i)].
	answerX := answer
!

postSolve
	self applyColOrderOnAnswerX.
	super postSolve
! !

!StMGEFullMatFullPv3 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMGEFullMatFullPv3.st,v 1.6 2006/10/04 13:00:53 cg Exp $'
! !
