"{ Package: 'stx:goodies/math/stmath' }"

StMGEFullMat3 subclass:#StMGEFullMatParPv3
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-MatrixSolver'
!


!StMGEFullMatParPv3 class methodsFor:'testing'!

isAbstractClass
	^false
! !

!StMGEFullMatParPv3 methodsFor:'pivoting'!

doPivoting: p 
	"Use scalings. Do row pivoting."

	| app max rowPivot aip mag |
	app := (matrixA at: p)
				at: p.
	max := app * (rowScalings at: p).
	max < 0 ifTrue: [max := 0.0d - max].
	rowPivot := p.
	p + 1 to: m
		do: 
			[:i | 
			aip := (matrixA at: i)
						at: p.
			aip = 0
				ifFalse: 
					[mag := aip * (rowScalings at: i).
					mag < 0 ifTrue: [mag := 0.0d - mag].
					mag > max
						ifTrue: 
							[max := mag.
							rowPivot := i]]].
	p == rowPivot
		ifFalse: 
			[matrixA swap: p with: rowPivot.
			rightHandSideB swap: p with: rowPivot.
			rowScalings swap: p with: rowPivot.
			rowOrder swap: p with: rowPivot].
	pivotValues at: p put: max.
	max < singularPivotTolerance ifTrue: [StMSingularMatrixError raiseSignal]
! !

!StMGEFullMatParPv3 methodsFor:'solution'!

postSolve
	"Do nothing."
!

preSolve: aMatrix with: aVector saveOriginal: saveOriginal 
	super
		preSolve: aMatrix
		with: aVector
		saveOriginal: saveOriginal.
	(rowScalings == nil or: [rowScalings size ~= m])
		ifTrue: [self findScalingsForRows: 1 to: m]
! !

!StMGEFullMatParPv3 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMGEFullMatParPv3.st,v 1.6 2006/10/04 13:00:53 cg Exp $'
! !
