"{ Package: 'stx:goodies/math/stmath' }"

StMMatrixGaussElimination3 subclass:#StMGESpMat3
	instanceVariableNames:'markowitzPivotRowCount markowitzPivotColCount
		privateIndicesOfNonZerosInPivotRow
		rowPositionsOfNonZerosInPivotColumn'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-MatrixSolver'
!

StMGESpMat3 comment:'Sparse matrix solvers.

Instance Variables:

markowitzPivotRowCount	<Integer>	number of non zeros in row minus one.
markowitzPivotColCount	<Integer>	number of non zeros in column minus one.
privateIndicesOfNonZerosInPivotRow	<OrderedCollection>	depends on implementation of IdentityDictionary.
rowPositionsOfNonZerosInPivotColumn	<OrderedCollection>	'
!


!StMGESpMat3 methodsFor:'forward elimination'!

privateIndicesOfNonZerosInPivotRow: pivotRow withoutKey: discardKey 
        "pivotRow is aStMSparseRow."

        | count index key |
        count := 0.
        index := 1.
        markowitzPivotRowCount := pivotRow tally - 1.
        privateIndicesOfNonZerosInPivotRow setIndices.
        [count < markowitzPivotRowCount]
                whileTrue: 
                        [
                        Smalltalk isSmalltalkX ifTrue:[
                            key := pivotRow keyArray basicAt: index.
                            key class == Set::EmptySlot ifTrue:[key := nil].
                        ] ifFalse:[
                            key := pivotRow basicAt: index.
                        ].
                        key == nil ifFalse: [key == discardKey
                                        ifFalse: 
                                                [count := count + 1.
                                                privateIndicesOfNonZerosInPivotRow add: index]].
                        index := index + 1]
! !

!StMGESpMat3 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMGESpMat3.st,v 1.7 2006/10/04 13:00:53 cg Exp $'
! !
