"{ Package: 'stx:goodies/math/stmath' }"

StMSpecialMatrix variableSubclass:#StMIdentityMatrix
	instanceVariableNames:'nrow'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-ArraySpecial'
!


!StMIdentityMatrix class methodsFor:'instance creation'!

new: aInteger 
	^(super basicNew: 0)
		initialize: aInteger
! !

!StMIdentityMatrix methodsFor:'accessing'!

at: i and: j 
	^i == j
		ifTrue: [self elementClass unity]
		ifFalse: [self elementClass zero]
!

ncol
	^nrow
!

nrow
	^nrow
!

numberOfElements
	"Answer the number of elements in the full vector or matrix."

	^nrow * nrow
! !

!StMIdentityMatrix methodsFor:'basic ops *'!

* anObject 
	^anObject
!

productFromTranspose: aObject 
	^aObject transpose
! !

!StMIdentityMatrix methodsFor:'converting'!

asIdentityMatrix
	^self
! !

!StMIdentityMatrix methodsFor:'initialize - release'!

initialize: aInteger 
	nrow := aInteger
! !

!StMIdentityMatrix methodsFor:'ops on self'!

startingAt: i3 and: j3 replaceElementsIn: aVector from: i1 to: i2 
	"OK to use FullMatrix version."

	^aVector
		replaceFrom: i1
		to: i2
		withFullMatrix: self
		startingAt: i3
		and: j3
!

startingAt: ii1 and: jj1 sumFromThenReplaceElementsIn: aMatrix from: i1 and: j1 to: i2 and: j2 
	"This destructively replaces elements from start to stop in the 
	collection starting at index, repStart, in the receiver. 
	Answer the collection."

	^aMatrix
		replaceFrom: i1
		and: j1
		to: i2
		and: j2
		withSelfPlusIdentityMatrix: self
		startingAt: ii1
		and: jj1
		times: self elementClass unity
!

startingAt: i3 and: j3 times: aNumber replaceElementsIn: aVector from: i1 to: i2 
	"OK to use FullMatrix version."

	^aVector
		replaceFrom: i1
		to: i2
		withFullMatrix: self
		startingAt: i3
		and: j3
		times: aNumber
!

startingAt: i3 and: j3 times: aNumber sumFromThenReplaceElementsIn: aMatrix from: i1 and: j1 to: i2 and: j2 
	"This destructively replaces elements from start to stop in the 
	collection starting at index, repStart, in the receiver. 
	Answer the collection."

	^aMatrix
		replaceFrom: i1
		and: j1
		to: i2
		and: j2
		withSelfPlusIdentityMatrix: self
		startingAt: i3
		and: j3
		times: aNumber
! !

!StMIdentityMatrix methodsFor:'testing'!

isDiagonal
	^true
!

isIdentity
	^true
! !

!StMIdentityMatrix class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMIdentityMatrix.st,v 1.6 2006/10/04 13:00:53 cg Exp $'
! !
