"{ Package: 'stx:goodies/math/stmath' }"

StMSolver subclass:#StMIntegrator
	instanceVariableNames:'system'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-Integrator'
!


!StMIntegrator class methodsFor:'class initialization'!

initSignals
        StMIntegratorError notifierString: #'StM: Integrator error'.
        "/ StMIntegratorError nameClass: self message: #integratorError.

        StMDiscontinuityError notifierString: #'StM: A discontinuity is found.'.
        "/ StMDiscontinuityError nameClass: self message: #discontinuityError.

        StMTooManyTriesError notifierString: #'StM: Number of tries exceeded.'.
        "/ StMTooManyTriesError nameClass: self message: #tooManyTriesError.

        StMTooSmallStepSizeError notifierString: #'StM: Step size is too small.'.
        "/ StMTooSmallStepSizeError nameClass: self message: #tooSmallStepSizeError
!

initialize
	"StMIntegrator initialize."

	self initSignals
! !

!StMIntegrator methodsFor:'accessing'!

system: object 
	system := object
! !

!StMIntegrator methodsFor:'output'!

logString: string 
	system logString: string
!

logString: string withArgument: string1 
	system logString: string withArgument: string1
!

logString: string withArguments: arrayOfStrings 
	system logString: string withArguments: arrayOfStrings
! !

!StMIntegrator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMIntegrator.st,v 1.5 2006/10/04 13:00:53 cg Exp $'
! !

StMIntegrator initialize!
