"{ Package: 'stx:goodies/math/stmath' }"

StMDifferenceOperator subclass:#StMLinearMultiStepMethod
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-DifferenceOperator'
!


!StMLinearMultiStepMethod methodsFor:'accessing'!

firstPastTimeNode
	^timeNodes at: 1
! !

!StMLinearMultiStepMethod methodsFor:'calc'!

derivative: n at: t present: y past: ypast presentDerivative: ydot pastDerivative: ydotpast 
        "Interpolate or extrapolate."
        "dfdt(t) = df0dt + d2f0dt2*(t - t0) + d3f0dt3*(t - t0)^2 / 2!! + ..."

        | answer dt dtpower diydti |
        answer := self
                                derivative: n
                                present: y
                                past: ypast
                                presentDerivative: ydot
                                pastDerivative: ydotpast.
        t = time
                ifFalse: 
                        [dt := t - time.
                        dtpower := 1.0d.
                        n + 1 to: self order
                                do: 
                                        [:i | 
                                        diydti := self
                                                                derivative: i
                                                                present: y
                                                                past: ypast
                                                                presentDerivative: ydot
                                                                pastDerivative: ydotpast.
                                        dtpower := dtpower * dt.
                                        answer isLimitedPrecisionReal
                                                ifTrue: [answer := answer + (diydti * dtpower * (OneOverFactorials at: i - n))]
                                                ifFalse: [answer equalSelfPlus: diydti times: dtpower * (OneOverFactorials at: i - n)]]].
        ^answer
!

derivative: n present: y past: ypast presentDerivative: ydot pastDerivative: ydotpast 
	"Answer nth derivative given present value, past values, present first derivative and past first 
	derivatives"

	self subclassResponsibility
!

valueAt: t present: y past: ypast presentDerivative: ydot pastDerivative: ydotpast 
	^self
		derivative: 0
		at: t
		present: y
		past: ypast
		presentDerivative: ydot
		pastDerivative: ydotpast
! !

!StMLinearMultiStepMethod class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMLinearMultiStepMethod.st,v 1.5 2006/10/04 13:00:54 cg Exp $'
! !
