"{ Package: 'stx:goodies/math/stmath' }"

Object variableSubclass:#StMMachineAccuracy
	instanceVariableNames:''
	classVariableNames:'DoubleOneMinus4Epsilon DoubleOnePlus4Epsilon
		FloatOneMinus4Epsilon FloatOnePlus4Epsilon OfDouble
		OfDoubleTimesFour OfFloat OfFloatTimesFour OfLargestDouble
		OfLargestFloat'
	poolDictionaries:''
	category:'StMathArraySpecial'
!

StMMachineAccuracy comment:'Make available the machine accuracy, machine precision, machine epsilon for everyone.'
!


!StMMachineAccuracy class methodsFor:'accessing'!

DoubleOneMinus4Epsilon
	^DoubleOneMinus4Epsilon
!

DoubleOnePlus4Epsilon
	^DoubleOnePlus4Epsilon
!

FloatOneMinus4Epsilon
	^FloatOneMinus4Epsilon
!

FloatOnePlus4Epsilon
	^FloatOnePlus4Epsilon
!

OfDouble
	^OfDouble
!

OfDoubleTimesFour
	^OfDoubleTimesFour
!

OfFloat
	^OfFloat
!

OfFloatTimesFour
	^OfFloatTimesFour
!

OfLargestDouble
	^OfLargestDouble
! !

!StMMachineAccuracy class methodsFor:'class initialization'!

initialize
	"To be strictly correct, this should be run everytime the image is started."
	"StMMachineAccuracy initialize."

	ObjectMemory removeDependent: self.
	ObjectMemory addDependent: self.
	self setVariables
!

setDoubleVariables
        "To be strictly correct, this should be run everytime the image is started."
        "StMMachineAccuracy initialize."

        | epsilon unity two max |
        epsilon := Double unity.
        unity := Double unity.
        two := unity + unity.
        max := Double unity.
        
        [OfDouble := epsilon.
        epsilon := epsilon / two.
        unity + epsilon > unity] whileTrue.
        OfDoubleTimesFour := two + two * OfDouble.
        DoubleOnePlus4Epsilon := unity + OfDoubleTimesFour.
        DoubleOneMinus4Epsilon := unity - OfDoubleTimesFour.
        
        [max := [two * max]
                                on: RangeError do: [:ex | ex return: nil].
        max isFinite ifFalse:[max := nil].
        max == nil ifFalse: [OfLargestDouble := max].
        max == nil] whileFalse

    "Modified: / 04-10-2006 / 16:29:54 / cg"
!

setFloatVariables
        "To be strictly correct, this should be run everytime the image is started."
        "StMMachineAccuracy initialize."

        | epsilon unity two max |
        epsilon := Float unity.
        unity := Float unity.
        two := unity + unity.
        max := Float unity.
        
        [OfFloat := epsilon.
        epsilon := epsilon / two.
        unity + epsilon > unity] whileTrue.
        OfFloatTimesFour := two + two * OfFloat.
        FloatOnePlus4Epsilon := unity + OfFloatTimesFour.
        FloatOneMinus4Epsilon := unity - OfFloatTimesFour.
        
        [max := [two * max]
                                on: RangeError do: [:ex | ex return: nil].
        max isFinite ifFalse: [max := nil].
        max == nil ifFalse: [OfLargestFloat := max].
        max == nil] whileFalse

    "Modified: / 04-10-2006 / 16:31:20 / cg"
!

setVariables
	self setDoubleVariables.
	self setFloatVariables
!

update: anAspect with: arguments from: anObject 
	"Check for return from snapshot to install."

	(anObject == ObjectMemory and: [anAspect == #earlySystemInstallation])
		ifTrue: [self setVariables]
! !

!StMMachineAccuracy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMMachineAccuracy.st,v 1.7 2006/10/04 14:32:17 cg Exp $'
! !

StMMachineAccuracy initialize!
