"{ Package: 'stx:goodies/math/stmath' }"

StMMatrixSolver3 subclass:#StMMatrixDecomposition3
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-MatrixSolver'
!


!StMMatrixDecomposition3 methodsFor:'back substitution'!

applyRowOrderOnRightHandSideB
	| answer |
	answer := rightHandSideB class new: m.
	1 to: m do: [:i | answer at: i put: (rightHandSideB at: (rowOrder at: i))].
	rightHandSideB := answer
!

backSubstituteIntoDU
	"aD is a diagonal matrix."
	"aU is upper triangular with the ones in the diagonal omitted."

	self subclassResponsibility
!

backSubstituteIntoU
	"U is upper triangular with ones in the diagonal."

	self subclassResponsibility
! !

!StMMatrixDecomposition3 methodsFor:'forward substitution'!

forwardSubstituteIntoL
	"aL is lower triangular with the ones in the diagonal omitted."

	self subclassResponsibility
!

forwardSubstituteIntoLD
	"LD is lower triangular with nonzero and arbitrary diagonals."

	self subclassResponsibility
! !

!StMMatrixDecomposition3 methodsFor:'solution'!

basicSolve: aMatrix with: aVector saveOriginal: saveOriginal 
	self decompose: aMatrix saveOriginal: saveOriginal.
	^self forAndBackSub: aVector saveOriginal: saveOriginal
!

postSolve
	"Do nothing."
!

preSolve: aMatrix saveOriginal: saveOriginal 
	matrixA := saveOriginal
				ifTrue: [aMatrix copy asFullMatrix]
				ifFalse: [aMatrix asFullMatrix].
	(m == matrixA nrow and: [n == matrixA ncol])
		ifFalse: 
			[m := matrixA nrow.
			n := matrixA ncol.
			pivotValues := StMFullColumn new: m.
			rowOrder := StMArray new: m.
			colOrder := StMArray new: n.
			singularPivotTolerance := StMMachineAccuracy OfDoubleTimesFour].
	m = n
		ifTrue: [1 to: m
				do: 
					[:i | 
					rowOrder at: i put: i.
					colOrder at: i put: i]]
		ifFalse: 
			[1 to: m do: [:i | rowOrder at: i put: i].
			1 to: n do: [:j | colOrder at: j put: j]].
	(rowScalings == nil or: [rowScalings size ~= m])
		ifTrue: [self findScalingsForRows: 1 to: m]
! !

!StMMatrixDecomposition3 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMMatrixDecomposition3.st,v 1.4 2006/10/04 13:00:54 cg Exp $'
! !
