"{ Package: 'stx:goodies/math/stmath' }"

StMBasicDAEIntegrator subclass:#StMNormalBasicDAEIntegrator
	instanceVariableNames:'opBDFhigher'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-Integrator'
!


!StMNormalBasicDAEIntegrator methodsFor:'accessing'!

correctorBDF
	^opBDF
!

iStep: integer 
	super iStep: integer.
	opBDFhigher iStep: integer
!

order: integer 
	super order: integer.
	opBDFhigher order: integer + 1
!

time: double 
	super time: double.
	opBDFhigher time: double
!

yDeriv: integer 
	^opBDF
		derivative: integer
		present: y
		past: ypast
!

yDeriv: integer at: time 
	^opBDF
		derivative: integer
		at: time
		present: y
		past: ypast
! !

!StMNormalBasicDAEIntegrator methodsFor:'initialize-release'!

initialize
	super initialize.
	opBDFhigher := StMBackwardDifference new.
	opBDFhigher timeNodes: tpast
!

initializeLocally
	"NormalBasicDAEIntegrator is not used for starting an integration."
	"Change to StartingBasicDAEIntegrator."

	super initializeLocally.
	opBDFhigher changeClassToThatOf: StMStartingBDF basicNew.
	opBDFhigher initializeLocally.
	self changeClassToThatOf: StMStartingBasicDAEIntegrator basicNew
! !

!StMNormalBasicDAEIntegrator methodsFor:'run'!

calcOperatorMatrix
	super calcOperatorMatrix.
	opBDFhigher calcOperatorMatrix
!

dyOrderPlusOnedt
	^opBDFhigher
		derivative: order + 1
		present: y
		past: ypast
!

selectOrder
	self selectOrderNormal
! !

!StMNormalBasicDAEIntegrator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMNormalBasicDAEIntegrator.st,v 1.4 2006/10/04 13:00:55 cg Exp $'
! !
