"{ Package: 'stx:goodies/math/stmath' }"

Object variableSubclass:#StMPhysicalUnits
	instanceVariableNames:''
	classVariableNames:'Kilograms Meters Newtons Seconds'
	poolDictionaries:''
	category:'Math-StMath-ArraySpecial'
!


!StMPhysicalUnits class methodsFor:'accessing'!

Kilograms
	^Kilograms
!

Meters
	^Meters
!

Newtons
	^Newtons
!

Seconds
	^Seconds
! !

!StMPhysicalUnits class methodsFor:'class initialization'!

initialize
	"StMPhysicalUnits initialize."

	Meters := IdentityDictionary new.
	Kilograms := IdentityDictionary new.
	Seconds := IdentityDictionary new.
	Newtons := IdentityDictionary new.
	self initializeLengthUnits.
	self initializeMassUnits.
	self initializeTimeUnits.
	self initializeForceUnits
!

initializeForceUnits
	Newtons at: #DYNE put: 1.0d-5.
	Newtons at: #KILOGRAMFORCE put: 9.81d.
	Newtons at: #KILONEWTON put: 1000.0d.
	Newtons at: #KILOPOUNDFORCE put: 4448.0d.
	Newtons at: #NEWTON put: 1.0d.
	Newtons at: #OUNCEFORCE put: 0.278d.
	Newtons at: #POUNDFORCE put: 4.448d.
	Newtons at: #POUNDAL put: 0.1383d
!

initializeLengthUnits
	Meters at: #CENTIMETER put: 0.01d.
	Meters at: #FOOT put: 0.3048d.
	Meters at: #KILOMETER put: 1000.0d.
	Meters at: #INCH put: 0.0254d.
	Meters at: #METER put: 1.0d.
	Meters at: #MILLIMETER put: 0.001d.
	Meters at: #MILE put: 1609.0d
!

initializeMassUnits
	Kilograms at: #GRAM put: 0.001d.
	Kilograms at: #KILOGRAM put: 1.0d.
	Kilograms at: #KILOPOUNDMASS put: 453.6d.
	Kilograms at: #OUNCEMASS put: 0.02835d.
	Kilograms at: #POUNDMASS put: 0.4536d.
	Kilograms at: #SLUG put: 14.59d
!

initializeTimeUnits
	Seconds at: #HOUR put: 3600.0d.
	Seconds at: #MILLISECOND put: 0.001d.
	Seconds at: #MINUTE put: 60.0d.
	Seconds at: #SECOND put: 1.0d
! !

!StMPhysicalUnits class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMPhysicalUnits.st,v 1.6 2006/10/04 13:00:55 cg Exp $'
! !

StMPhysicalUnits initialize!
