"{ Package: 'stx:goodies/math/stmath' }"

StMFunctionXY subclass:#StMPower
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMPower class methodsFor:'instance creation'!

with: base raisedTo: exponent 
	^super new x: base y: exponent
! !

!StMPower methodsFor:'evaluating'!

differentiateWRTx
	| ycopy |
	ycopy := y copy.
	^ycopy times: (x copy raisedTo: (ycopy plus: -1)) simplified
!

differentiateWRTy
	^(self copy times: (StMLn with: x copy)) simplified
!

setValue
	value := x value raisedTo: y value
!

simplified
	super simplified.
	x isZero
		ifTrue: 
			[self removeDependency.
			^StMConstant with: 0].
	x isOne
		ifTrue: 
			[self removeDependency.
			^StMConstant with: 1].
	y isZero
		ifTrue: 
			[self removeDependency.
			^StMConstant with: 1].
	y isOne
		ifTrue: 
			[self removeDependency.
			dependents do: [:dependent | x addDependent: dependent].
			^x]
! !

!StMPower methodsFor:'printing'!

printOn: aStream 
	aStream print: self class.
	aStream nextPut: $(.
	aStream print: x.
	aStream space.
	aStream print: y.
	aStream nextPut: $)
! !

!StMPower class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMPower.st,v 1.6 2006/10/04 13:00:55 cg Exp $'
! !
