"{ Package: 'stx:goodies/math/stmath' }"

StMPiecewiseFunction subclass:#StMSmoothAbs
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!

StMSmoothAbs comment:'SmoothAbs fits a parabola near the origin (-epsilon < x < epsilon) to avoid discontinuous first derivative.
f(x) = |x| 				x < -epsilon, x > epsilon.
f(x) = a + c*x*x.		-epsilon < x < epsilon
a + c*eps*eps = eps
2*c*eps = 1
c = 1/(2*eps)
a = eps - (eps/2) = eps/2

Instance Variables:

epsilon	<StMConstant>	f(x) = a + c*x*x.		-epsilon < x < epsilon'
!


!StMSmoothAbs class methodsFor:'instance creation'!

with: var epsilon: xx1 
	^super new x: var epsilon: xx1
! !

!StMSmoothAbs methodsFor:'initialize-release'!

x: arg epsilon: eps 
	| a b c coeffs epsilon |
	x := self conditionArgument: arg.
	epsilon := self conditionArgument: eps.
	a := epsilon times: 0.5d.
	b := StMConstant with: 0.0d.
	c := (epsilon times: 2.0d) reciprocal.
	coeffs := Array
				with: a
				with: b
				with: c.
	self changed.
	functions := Array new: 3.
	functions at: 1 put: (StMAbs with: x).
	functions at: 2 put: (StMPolynomial with: x coeffs: coeffs).
	functions at: 3 put: (StMAbs with: x).
	transitions := Array new: 2.
	transitions at: 1 put: epsilon negated.
	transitions at: 2 put: epsilon
! !

!StMSmoothAbs class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMSmoothAbs.st,v 1.6 2006/10/04 13:00:55 cg Exp $'
! !
