"{ Package: 'stx:goodies/math/stmath' }"

StMSparseVector variableSubclass:#StMSparseColumn
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-ArraySparse'
!


!StMSparseColumn methodsFor:'accessing'!

ncol
	^1
!

nrow
	"Answer the number of elements in the full vector or matrix."

	^fullsize
! !

!StMSparseColumn methodsFor:'basic ops'!

transpose
	"Return a row with the same elements."
	"This method is much faster than the obvious way."

	^self copy changeClassToThatOf: (StMSparseRow new: 0)
! !

!StMSparseColumn methodsFor:'basic ops +'!

plusSparseColumn: aSparseColumn 
	^super plusSparseVector: aSparseColumn
!

times: alpha plusSparseColumn: aSparseColumn 
	^super times: alpha plusSparseVector: aSparseColumn
! !

!StMSparseColumn methodsFor:'basic ops -'!

minusSparseColumn: aSparseColumn 
	^super minusSparseVector: aSparseColumn
!

times: alpha minusSparseColumn: aSparseColumn 
	^super times: alpha minusSparseVector: aSparseColumn
! !

!StMSparseColumn methodsFor:'ops on self'!

at: i1 putFullColumn: aFullColumn 
	super at: i1 putFullVector: aFullColumn
!

at: i1 putFullColumn: aFullColumn times: number 
	super
		at: i1
		putFullVector: aFullColumn
		times: number
! !

!StMSparseColumn methodsFor:'ops on self +'!

at: i plusFullColumn: aFullColumn 
	^super at: i plusFullVector: aFullColumn
!

at: i plusFullColumn: aFullColumn times: aNumber 
	^super
		at: i
		plusFullVector: aFullColumn
		times: aNumber
!

at: i1 plusSparseColumn: aSparseColumn 
	super at: i1 plusSparseVector: aSparseColumn
!

equalSelfPlusSparseColumn: aSparseColumn 
	super equalSelfPlusSparseVector: aSparseColumn
!

equalSelfPlusSparseColumn: aSparseColumn times: aNumber 
	super equalSelfPlusSparseVector: aSparseColumn times: aNumber
! !

!StMSparseColumn methodsFor:'ops on self -'!

at: i minusFullColumn: aFullColumn 
	^super at: i minusFullVector: aFullColumn
!

at: i minusFullColumn: aFullColumn times: aNumber 
	^super
		at: i
		minusFullVector: aFullColumn
		times: aNumber
!

at: i1 minusSparseColumn: aSparseColumn 
	super at: i1 minusSparseVector: aSparseColumn
!

equalSelfMinusSparseColumn: aSparseColumn 
	super equalSelfMinusSparseVector: aSparseColumn
!

equalSelfMinusSparseColumn: aSparseColumn times: aNumber 
	super equalSelfMinusSparseVector: aSparseColumn times: aNumber
! !

!StMSparseColumn class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMSparseColumn.st,v 1.4 2006/10/04 13:00:55 cg Exp $'
! !
