"{ Package: 'stx:goodies/math/stmath' }"

StMRowTypeMatrix variableSubclass:#StMSparseMatrix
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-Array'
!

StMSparseMatrix comment:'SparseMatrix contains StMIdentityDictionary''s.'
!


!StMSparseMatrix class methodsFor:'instance creation'!

newWithElements: a2DArray 
	^(StMFullMatrix newWithElements: a2DArray) asSparseMatrix
! !

!StMSparseMatrix methodsFor:'accessing'!

matrixSolverClass
	^StMGESpMatParPvMarko3
!

secondDimensionClass
	^StMSparseRow
! !

!StMSparseMatrix methodsFor:'basic ops'!

minusSparseMatrix: aSparseMatrix 
	"a - b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| answer |
	answer := self shallowCopy.
	1 to: answer nrow do: [:i | answer at: i put: ((answer at: i)
				minusSparseRow: (aSparseMatrix at: i))].
	^answer
!

minusSparseMatrix: aSparseMatrix times: beta 
	"a - b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| answer |
	answer := self shallowCopy.
	1 to: answer nrow do: [:i | answer at: i put: ((answer at: i)
				minusSparseRow: (aSparseMatrix at: i)
				times: beta)].
	^answer
!

plusSparseMatrix: aSparseMatrix 
	"a + b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| answer |
	answer := self shallowCopy.
	1 to: answer nrow do: [:i | answer at: i put: ((answer at: i)
				plusSparseRow: (aSparseMatrix at: i))].
	^answer
!

plusSparseMatrix: aSparseMatrix times: beta 
	"a + b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| answer |
	answer := self shallowCopy.
	1 to: answer nrow do: [:i | answer at: i put: ((answer at: i)
				plusSparseRow: (aSparseMatrix at: i)
				times: beta)].
	^answer
!

times: alpha minusSparseMatrix: aSparseMatrix 
	"a*alpha + b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| answer |
	answer := self shallowCopy.
	1 to: answer nrow do: [:i | answer at: i put: ((answer at: i)
				times: alpha minusSparseRow: (aSparseMatrix at: i))].
	^answer
!

times: alpha minusSparseMatrix: aSparseMatrix times: beta 
	"a*alpha + b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| answer |
	answer := self shallowCopy.
	1 to: answer nrow do: [:i | answer at: i put: ((answer at: i)
				times: alpha
				minusSparseRow: (aSparseMatrix at: i)
				times: beta)].
	^answer
!

times: alpha plusSparseMatrix: aSparseMatrix 
	"a*alpha + b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| answer |
	answer := self shallowCopy.
	1 to: answer nrow do: [:i | answer at: i put: ((answer at: i)
				times: alpha plusSparseRow: (aSparseMatrix at: i))].
	^answer
!

times: alpha plusSparseMatrix: aSparseMatrix times: beta 
	"a*alpha + b."
	"Assume all checking of validity of this operation has been done."
	"Just evaluate quickly."

	| answer |
	answer := self shallowCopy.
	1 to: answer nrow do: [:i | answer at: i put: ((answer at: i)
				times: alpha
				plusSparseRow: (aSparseMatrix at: i)
				times: beta)].
	^answer
!

transpose
	"Returns a new Matrix which is the transpose of self."

	| nrow answer rowi |
	nrow := self nrow.
	answer := self class new: self ncol by: nrow.
	1 to: nrow
		do: 
			[:i | 
			rowi := self at: i.
			rowi keysAndValuesDo: [:j :value | answer
					at: j
					and: i
					put: value]].
	^answer
! !

!StMSparseMatrix methodsFor:'converting'!

asFullMatrix
	| nrow answer |
	nrow := self nrow.
	answer := StMFullMatrix new: nrow.
	1 to: nrow do: [:i | answer at: i put: (self at: i) asFullRow].
	^answer
! !

!StMSparseMatrix methodsFor:'instance creation'!

by: secondSize 
	"Add second dimension to matrix. Used by new:by: only."

	| rowi |
	1 to: self nrow
		do: 
			[:i | 
			rowi := self secondDimensionClass new: (secondSize min: 7).
			rowi fullsize: secondSize.
			self at: i put: rowi]
! !

!StMSparseMatrix class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMSparseMatrix.st,v 1.4 2006/10/04 13:00:55 cg Exp $'
! !
