"{ Package: 'stx:goodies/math/stmath' }"

StMBasicDAEIntegrator subclass:#StMStartingBasicDAEIntegrator
	instanceVariableNames:'startingBDF'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-Integrator'
!


!StMStartingBasicDAEIntegrator methodsFor:'accessing'!

correctorBDF
	^startingBDF
!

iStep: integer 
	super iStep: integer.
	startingBDF iStep: integer.
	istep > orderMax
		ifTrue: 
			[startingBDF changeClassToThatOf: StMBackwardDifference basicNew.
			self changeClassToThatOf: StMNormalBasicDAEIntegrator basicNew]
!

order: integer 
	super order: integer.
	startingBDF order: integer + 1
!

time: double 
	super time: double.
	startingBDF time: double
!

yDeriv: integer 
	^startingBDF
		derivative: integer
		present: y
		past: ypast
		presentDerivative: ydot
		pastDerivative: ydotpast
!

yDeriv: integer at: time 
	^startingBDF
		derivative: integer
		at: time
		present: y
		past: ypast
		presentDerivative: ydot
		pastDerivative: ydotpast
! !

!StMStartingBasicDAEIntegrator methodsFor:'initialize-release'!

initialize
	super initialize.
	startingBDF := StMStartingBDF new.
	startingBDF timeNodes: tpast
!

initializeLocally
	super initializeLocally.
	startingBDF initializeLocally
! !

!StMStartingBasicDAEIntegrator methodsFor:'run'!

calcOperatorMatrix
	super calcOperatorMatrix.
	startingBDF calcOperatorMatrix
!

dyOrderPlusOnedt
	^startingBDF
		derivative: order + 1
		present: y
		past: ypast
		presentDerivative: ydot
		pastDerivative: ydotpast
! !

!StMStartingBasicDAEIntegrator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMStartingBasicDAEIntegrator.st,v 1.6 2006/10/04 13:00:56 cg Exp $'
! !
