"{ Package: 'stx:goodies/math/stmath' }"

StMFunctionManyTerms subclass:#StMSum
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!


!StMSum class methodsFor:'instance creation'!

with: arg1 plus: arg2 
	| instance |
	instance := self new.
	instance plus: arg1.
	instance plus: arg2.
	^instance
!

with: arg1 plus: arg2 plus: arg3 
	| instance |
	instance := self new.
	instance plus: arg1.
	instance plus: arg2.
	instance plus: arg3.
	^instance
! !

!StMSum methodsFor:'accessing'!

+ arg 
	| term |
	term := self conditionArgument: arg.
	terms add: term.
	self changed
!

plus: arg 
	| term |
	term := self conditionArgument: arg.
	terms add: term.
	self changed
! !

!StMSum methodsFor:'evaluating'!

differentiateWRT: variable 
	| derivatives answer |
	derivatives := terms collect: [:term | term differentiateWRT: variable].
	answer := self class new.
	answer terms: derivatives.
	^answer simplified
!

partialDifferentiateWRT: variable 
	| derivatives answer |
	derivatives := terms collect: [:term | term partialDifferentiateWRT: variable].
	answer := self class new.
	answer terms: derivatives.
	^answer simplified
!

setValue
	value := 0.0d.
	terms do: [:term | value := value + term value]
!

simplified
	| newTerms term newSize answer |
	newTerms := OrderedCollection new.
	1 to: terms size
		do: 
			[:i | 
			term := (terms at: i) simplified.
			term isZero
				ifTrue: [term removeDependency]
				ifFalse: [newTerms add: term]].
	newSize := newTerms size.
	newSize == 0
		ifTrue: 
			[self removeDependency.
			^StMConstant with: 0].
	newSize == 1
		ifTrue: 
			[answer := newTerms at: 1.
			self removeDependency.
			dependents do: [:dependent | answer addDependent: dependent].
			^answer].
	terms := newTerms
! !

!StMSum class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMSum.st,v 1.6 2006/10/04 13:00:56 cg Exp $'
! !
