"{ Package: 'stx:goodies/math/stmath' }"

StMFunctionX subclass:#StMVariable
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-FunctionSymbolic'
!

StMVariable comment:'Abstract class'
!


!StMVariable class methodsFor:'instance creation'!

name: symbol 
	^super new name: symbol
! !

!StMVariable methodsFor:'accessing'!

name
	^name
!

name: symbol 
	name := symbol asSymbol
! !

!StMVariable methodsFor:'changing'!

substitute: var1 with: var2 
	x isNil ifFalse: [x substitute: var1 with: var2]
! !

!StMVariable methodsFor:'copying'!

copy
	"A Variable is unique."
	"Do nothing."
! !

!StMVariable methodsFor:'evaluating'!

differentiateWRT: variable 
	| dfdx dxdvar |
	self == variable ifTrue: [^StMConstant with: 1].
	dfdx := self differentiateWRTx.
	dxdvar := x differentiateWRT: variable.
	^dxdvar isOne
		ifTrue: [dfdx]
		ifFalse: [(StMCompositeFunctionX with: x copy expression: (dfdx times: dxdvar)) simplified]
!

partialDifferentiateWRT: variable 
	^self == variable
		ifTrue: [StMConstant with: 1]
		ifFalse: [StMConstant with: 0]
!

simplified
	x == nil ifFalse: [super simplified]
! !

!StMVariable methodsFor:'printing'!

printOn: aStream 
	aStream print: self class.
	aStream nextPut: $'.
	aStream print: name.
	aStream nextPut: $'.
	aStream nextPut: $(.
	aStream print: x.
	aStream nextPut: $)
! !

!StMVariable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMVariable.st,v 1.4 2006/10/04 13:00:56 cg Exp $'
! !
