"{ Package: 'stx:goodies/math/stmath' }"

StMNewtonRaphson2 subclass:#StMVectorNewtonRaphson2
	instanceVariableNames:'matrixSolver'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-NewtonRaphson'
!


!StMVectorNewtonRaphson2 methodsFor:'accessing'!

matrixSolver: matSolver 
	matrixSolver := matSolver
!

pypx: mat 
	pypx := mat
!

x: col 
	x := col asFullColumn
!

y: col 
	y := col asFullColumn
! !

!StMVectorNewtonRaphson2 methodsFor:'initialize-release'!

initializeGlobally
	system fillVarVector: x
! !

!StMVectorNewtonRaphson2 methodsFor:'solving'!

calcdxNorm
	"Subclasses can modify calculation of dxNorm."

	dxNorm := dx rootMeanSquare
!

calcyNorm
	"Subclasses can modify calculation of yNorm."

	yNorm := 0.5d * y sumOfSquares
!

dxEqualdxTimeslam
	dx magnifySelf: lam
!

fillPyPx
	system fillJacobian: pypx
!

fillY
	system fillErrorVector: y
!

solveEquations
	dx := matrixSolver
				solve: pypx
				with: y negated
				saveOriginal: false
!

xEqualxoldPlusdx
	x := xold plusFullColumn: dx
!

xEqualxoldPlusdxTimeslam
	x := xold plusFullColumn: dx times: lam
! !

!StMVectorNewtonRaphson2 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMVectorNewtonRaphson2.st,v 1.6 2006/10/04 13:00:56 cg Exp $'
! !
