"{ Package: 'stx:goodies/math/stmath' }"

StMSpecialMatrix variableSubclass:#StMZeroMatrix
	instanceVariableNames:'nrow ncol'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-ArraySpecial'
!


!StMZeroMatrix class methodsFor:'instance creation'!

new: nrow by: ncol 
	^(super basicNew: 0)
		initialize: nrow by: ncol
! !

!StMZeroMatrix methodsFor:'accessing'!

at: i and: j 
	^self elementClass zero
!

ncol
	^ncol
!

nrow
	^nrow
!

numberOfElements
	"Answer the number of elements in the full vector or matrix."

	^nrow * ncol
! !

!StMZeroMatrix methodsFor:'basic ops *'!

timesFullColumn: aFullColumn 
	^StMZeroColumn new: self size1
!

timesFullMatrix: anObject 
	^self class new: self size1 by: anObject size2
!

timesZeroVector: aZeroVector 
	"a*b = a(i,j)b(j) sum j."

	^aZeroVector class new: self size1
! !

!StMZeroMatrix methodsFor:'initialize - release'!

initialize: nrow1 by: ncol1 
	nrow := nrow1.
	ncol := ncol1
! !

!StMZeroMatrix methodsFor:'ops on self +'!

startingAt: ii1 and: jj1 times: aNumber sumFromThenReplaceElementsIn: aMatrix from: i1 and: j1 to: i2 and: j2 
	"Do nothing."
! !

!StMZeroMatrix class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMZeroMatrix.st,v 1.6 2006/10/04 13:00:56 cg Exp $'
! !
