"{ Package: 'stx:goodies/math/stmath' }"

StMVerySparseVector variableSubclass:#StMZeroVector
	instanceVariableNames:'size'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-StMath-ArraySpecial'
!


!StMZeroVector class methodsFor:'instance creation'!

new: aInteger 
	^(super basicNew: 0)
		initialize: aInteger
! !

!StMZeroVector methodsFor:'accessing'!

at: aInteger 
	^self elementClass zero
!

size
	^size
! !

!StMZeroVector methodsFor:'basic ops *'!

productFromTranspose: aObject 
	^aObject transposeTimesZeroVector: self
!

transposeTimesDiagonalMatrix: aDiagonalMatrix 
	"aTb := a(i)b(i,j) sum i."

	^self class new: aDiagonalMatrix size2
!

transposeTimesFullMatrix: aFullMatrix 
	"aTb := a(i)b(i,j) sum i."

	^self class new: aFullMatrix ncol
!

transposeTimesZeroMatrix: aZeroMatrix 
	"aT*b = a(i)b(i,j) sum i."

	^self class new: aZeroMatrix size2
! !

!StMZeroVector methodsFor:'converting'!

asZeroVector
	^self
! !

!StMZeroVector methodsFor:'initialize - release'!

initialize: aInteger 
	size := aInteger
! !

!StMZeroVector methodsFor:'ops on self'!

magnifySelf: aNumber 
	"Do nothing."
!

replaceElementsFrom: i1 to: i2 withArray: aArray startingAt: ii1 
	| newArray |
	i2 - i1 + 1 == size
		ifTrue: [newArray := aArray copyFrom: ii1 to: ii1 + size - 1]
		ifFalse: 
			[newArray := aArray class new: size.
			newArray zeroSelf.
			newArray
				replaceFrom: i1
				to: i2
				with: aArray
				startingAt: ii1].
	self become: newArray
!

replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the 
	receiver starting at index, repStart, in the collection, replacement. 
	Answer the receiver. No range checks are performed, but 
	overlapping replacements are handled correctly."

	^replacement
		startingAt: repStart
		replaceElementsIn: self
		from: start
		to: stop
!

startingAt: i3 times: aNumber replaceElementsIn: aVector from: i1 to: i2 
	"Used for double dispatching."
	"See its sender and the message it sends."

	^aVector
		replaceFrom: i1
		to: i2
		withZeroVector: self
		startingAt: i3
		times: aNumber
!

startingAt: ii1 times: aNumber sumFromThenReplaceElementsIn: aVector from: i1 to: i2 
	"Do nothing."
!

startingAt: i3 to: i4 times: aNumber replaceElementsIn: aMatrix from: i1 and: j1 
	"Used for double dispatching."
	"See its sender and the message it sends."

	^aMatrix
		replaceFrom: i1
		and: j1
		withZeroVector: self
		startingAt: i3
		to: i4
		times: aNumber
! !

!StMZeroVector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/stmath/StMZeroVector.st,v 1.6 2006/10/04 13:00:56 cg Exp $'
! !
