"{ Package: 'stx:goodies/math/tests' }"

"{ NameSpace: Math }"

TestCase subclass:#InterpolatedFunctionTest
	instanceVariableNames:'func'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-Algorithms'
!


!InterpolatedFunctionTest methodsFor:'Running'!

setUp
"
 Dolphin:
        func := InterpolatedFunction 
                        for: #( ##(0@0) ##(1@1) ##(2@1.75) ##(3@2.25) ##(4@2.5))
                        withEndpointDerivatives: #(100000 0)
"

"
 Squeak:
        func := InterpolatedFunction 
                        for: { (0@0) . (1@1) . (2@1.75) . (3@2.25) . (4@2.5) }
                        withEndpointDerivatives: #(100000 0)
"

"
 Portable:
" 
       func := InterpolatedFunction 
                        for: (Array with:(0@0) with:(1@1) with:(2@1.75) with:(3@2.25) with:(4@2.5))
                        withEndpointDerivatives: #(100000 0)
" "
! !

!InterpolatedFunctionTest methodsFor:'documentation'!

copyright
"
    Copyright (c) 2002 Robert Jarvis

    Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
    and associated documentation files (the 'Software'), to deal in the Software without restriction, 
    including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
    and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, 
    subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all copies or 
    substantial portions of the Software.

    THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
    INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
    AND NONINFRINGEMENT. 
    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
    WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"
! !

!InterpolatedFunctionTest methodsFor:'testing'!

testEvaluation
	self should: [ (func value: 0) = 0 ].
	self should: [ (func value: 1) = 1 ].
	self should: [ (func value: 2) = 1.75 ].
	self should: [ (func value: 3) = 2.25 ].
	self should: [ (func value: 4) = 2.5 ].
! !

!InterpolatedFunctionTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/tests/InterpolatedFunctionTest.st,v 1.1 2003/10/07 21:15:17 cg Exp $'
! !
