"{ Package: 'stx:goodies/math/turingMachine' }"

"{ NameSpace: Math }"

Object subclass:#TuringCondition
	instanceVariableNames:'state value'
	classVariableNames:''
	poolDictionaries:''
	category:'Math-TuringMachine'
!

!TuringCondition class methodsFor:'documentation'!

documentation
"
    My instances are conditions for the aplication of the action in a Rule. 
    In a Turing machine a condition consists of a value and a state.
"
! !

!TuringCondition class methodsFor:'instance creation'!

state: aSymbol value: anObject
	^self new value: anObject; state: aSymbol
!

value: anObject state: aSymbol
	^self new value: anObject; state: aSymbol
! !

!TuringCondition methodsFor:'accessing'!

state
	^state
!

state: aSymbol
	state _ aSymbol
!

value
	^value
!

value: aSymbol
	value _ aSymbol
! !

!TuringCondition methodsFor:'comparing'!

= aCondition
	" public - Two conditions are the same if they match in value and state"
	^self value = aCondition value and: [self state = aCondition state]
!

hash
	^(self value hash + self state hash) hash
! !

!TuringCondition methodsFor:'evaluating'!

verifiesValue: anObject state: aSymbol
	" public - answer wether value anObject and state aSymbol satisfy me"
	^self value = anObject	and: [self state = aSymbol]
! !

!TuringCondition methodsFor:'printing'!

printOn: aStream
	" public - I will show up as '(aValue aState)'"
	aStream
		nextPut: $(;
		nextPutAll: self state printString;
		nextPutAll: ' ';
		nextPutAll: self value printString;
		nextPut: $)
! !

!TuringCondition class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/turingMachine/TuringCondition.st,v 1.1 2002/11/22 16:45:09 cg Exp $'
! !
