"{ Package: 'stx:goodies/math/turingMachine' }"

"{ NameSpace: Math }"

Squeak::SimpleMorphicWrapper subclass:#TuringMachineMorphicWrapper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Math-TuringMachine'
!

!TuringMachineMorphicWrapper class methodsFor:'documentation'!

documentation
"
    I'm the morphic representation of a TuringMachine
"
! !

!TuringMachineMorphicWrapper methodsFor:'initialization'!

initialize
	super initialize.
	self stopStepping
! !

!TuringMachineMorphicWrapper methodsFor:'menus'!

doubleClickMenu: evt
	" add 'run' and 'stop' options to my doubleClickMenu"
	^ (super doubleClickMenu: evt)
		addLine;
		add: 'run'
			target: self
			selector: #startStepping
			argumentList: #();
		add: 'stop'
			target: self
			selector: #stopStepping
			argumentList: #()
!

droppingMenu: aMorph event: evt
	" add 'run with it' option to droppingMenu"
	^ (super droppingMenu: aMorph event: evt)
		addLine;
		add: 'run with it'
			target: self
			selector: #runIt:
			argumentList: {aMorph}
!

runIt: anInputObject
	" 'run with it' droppingMenu option.
	  run my turing with anInputObject as input"
	anInputObject delete.
	self object input: anInputObject object.
	self startStepping
! !

!TuringMachineMorphicWrapper methodsFor:'stepping'!

step
	" public - 'step' option in doubleClickMenu,
	  make a single step on my assosiated TuringMachine"
	self object step.
	self updateContents.
	self object state = #halt ifTrue: [self stopStepping]
!

stepTime
	" 1 sec. - may be changed for a choice menu, but this is a faster interface"
	^ 1000
!

wantsSteps
	" don't let the world control my stepping, I will do it (and my menu)"
	^ false
! !

!TuringMachineMorphicWrapper class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/math/turingMachine/TuringMachineMorphicWrapper.st,v 1.1 2002/11/22 16:45:17 cg Exp $'
! !
