"{ Package: 'stx:goodies/measurement' }"

Unit subclass:#BaseUnit
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'Measurements'
!


!BaseUnit class methodsFor:'instance creation'!

fromString: aString 
	| num den key |
	num := 1.
	den := 1.
	(self numeratorPartIn: aString) valuesAndCountsDo: 
			[:baseUnitString :count | 
			num := num * ((UnitsByName at: baseUnitString) baseUnit key ** count)].
	(self denominatorPartIn: aString) valuesAndCountsDo: 
			[:baseUnitString :count | 
			den := den * ((UnitsByName at: baseUnitString) baseUnit key ** count)].
	key := num / den.
	^self new setName: (KeyOnlyUnit key: key) name key: key
! !

!BaseUnit class methodsFor:'class initialization'!

addUnitNamed: aString 
	UnitAllocationLock critical: [self addUnit: (self new setName: aString key: self nextPrime)]
!

installBaseUnits
        #('m' 
          's' 
          'K' 
          'kg' 
          'A' 
          'mol' 
          'cd'
        ) do: [:unitName | self addUnitNamed: unitName].
! !

!BaseUnit methodsFor:'accessing'!

baseUnit
	^self
!

conversion
	^1
!

key
	^key
!

name
	^name
! !

!BaseUnit methodsFor:'printing'!

printOn: aStream 
	aStream
		nextPutAll: 'Unit of: ';
		print: name
! !

!BaseUnit methodsFor:'private-initialize'!

setName: aString key: aPrimeInteger 
	name := aString.
	key := aPrimeInteger
! !

!BaseUnit methodsFor:'testing'!

isBaseUnit
	^true
! !

!BaseUnit class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/measurement/BaseUnit.st,v 1.4 2003/10/07 21:22:39 cg Exp $'
! !
