"{ Package: 'stx:goodies/measurement' }"

Unit subclass:#KeyOnlyUnit
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Measurements'
!


!KeyOnlyUnit class methodsFor:'initialization'!

initialize
    Unit installUnits
! !

!KeyOnlyUnit class methodsFor:'instance creation'!

fromString: aString 
	| num den |
	num := 1.
	den := 1.
	(self numeratorPartIn: aString)
		valuesAndCountsDo: [:baseUnitString :count | num := num * ((UnitsByName at: baseUnitString) key ** count)].
	(self denominatorPartIn: aString)
		valuesAndCountsDo: [:baseUnitString :count | den := den * ((UnitsByName at: baseUnitString) key ** count)].
	^self key: num / den
!

key: aKey 
	^self new setKey: aKey
! !

!KeyOnlyUnit methodsFor:'accessing'!

baseUnit
	^self canonicalUnit baseUnit
!

canonicalUnit
	^Unit byKey: key
!

convert: aMeasurement 
	^self canonicalUnit convert: aMeasurement
!

key
	^key
!

name
	^self canonicalUnit name
! !

!KeyOnlyUnit methodsFor:'private-initialize'!

setKey: aKey 
	key := aKey
! !

!KeyOnlyUnit class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/measurement/KeyOnlyUnit.st,v 1.4 2003/10/20 15:45:54 penk Exp $'
! !

KeyOnlyUnit initialize!
