"{ Package: 'stx:goodies/measurement/tests' }"

TestCase subclass:#TemperatureTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Measurements-Tests'
!


!TemperatureTest methodsFor:'running'!

testConversion
	| c f k r c2 |
	c := Temperature readFromString: '100 C'.
	f := c as: 'F'.
	k := f as: 'K'.
	r := k as: 'R'.
	c2 := r as: 'C'.
	self assert: f class == Farenheit; assert: k class == Kelvin; assert: r class == Rankine; assert: c2 class == Celsius.
	self assert: f magnitude = 212; assert: k magnitude = 373.15; assert: r magnitude = (212 + (45967 / 100)); assert: c2 magnitude = 100
!

testCreation
	| temp |
	temp := Temperature readFromString: '100 C'.
	self assert: temp class == Celsius; assert: temp magnitude = 100.
	temp := Temperature readFromString: '212 F'.
	self assert: temp class == Farenheit; assert: temp magnitude = 212.
	temp := Temperature readFromString: '273.15 K'.
	self assert: temp class == Kelvin; assert: temp magnitude = 273.15.
	temp := Temperature readFromString: '445 R'.
	self assert: temp class == Rankine; assert: temp magnitude = 445
!

testEquality
	| c k f r |
	c := Temperature readFromString: '-273.150000000000000000000 C'.
	k := Temperature readFromString: '0 K'.
	f := Temperature readFromString: '-459.67000000000000000000 F'.
	r := Temperature readFromString: '0 R'.
	self assert: c = k; assert: c = f; assert: r = f
!

testMagnitude
	| c k f r |
	c := Temperature readFromString: '40.0 C'.
	k := Temperature readFromString: '40.0 K'.
	f := Temperature readFromString: '40.0 F'.
	r := Temperature readFromString: '40.0 R'.
	self assert: r < k; assert: k < f; assert: f < c
! !

!TemperatureTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/measurement/tests/TemperatureTest.st,v 1.4 2011/02/10 17:50:37 cg Exp $'
! !
