"{ Package: 'stx:goodies/metacello' }"

TestResource subclass:#MetacelloAlternateResource
	instanceVariableNames:'versionReferences monticelloRepository'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-TestsMC-Resources'
!

MetacelloAlternateResource comment:''
!


!MetacelloAlternateResource methodsFor:'accessing'!

monticelloRepository
	^ monticelloRepository
!

versionReferences
	^ versionReferences
! !

!MetacelloAlternateResource methodsFor:'running'!

setUp
	super setUp.
	self
		setUpVersionReferences;
		setUpMonticelloRepository
!

setUpMonticelloRepository
	"This method builds a fake repository with the version references from #buildReferences."

	monticelloRepository := MCDictionaryRepository new.
	versionReferences do: [ :reference |
		monticelloRepository basicStoreVersion: (MCVersion new
			setPackage:  (MetacelloTestsMCPackage new name: reference packageName)
			info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
			snapshot: (MCSnapshot fromDefinitions: (Array
				"with: (MCOrganizationDefinition categories: (Array with: reference packageName asSymbol))"
				with: (MCClassDefinition name: reference packageName asSymbol superclassName: #Object category: reference packageName asSymbol instVarNames: #() comment: '')))
			dependencies: #()) ]
!

setUpVersionReferences
	"self reset"

	versionReferences := OrderedCollection new.
	versionReferences
		add: (GoferVersionReference name: 'GoferBar-dkh.24');
		add: (GoferVersionReference name: 'GoferBar-dkh.25');
		add: (GoferVersionReference name: 'GoferFoo-dkh.75');
		add: (GoferVersionReference name: 'GoferFoo-dkh.104')
! !

!MetacelloAlternateResource class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloAlternateResource.st,v 1.1 2011/08/20 18:07:53 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloAlternateResource.st,v 1.1 2011/08/20 18:07:53 cg Exp $'
! !
