"{ Package: 'stx:goodies/metacello' }"

TestResource subclass:#MetacelloAtomicConfigurationResource
	instanceVariableNames:'monticelloRepository'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-TestsMC-Resources'
!

MetacelloAtomicConfigurationResource comment:''
!


!MetacelloAtomicConfigurationResource class methodsFor:'accessing'!

project

	^self new project
! !

!MetacelloAtomicConfigurationResource methodsFor:'ConfigurationOfAtomicFan'!

baseline20Fan: spec 
	"self reset"
	<version: '2.0-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec blessing: #baseline.
		spec 
			package: 'GoferFan';
			yourself ].
!

baseline20MethodSourceFan

	^(self class sourceCodeAt: #baseline20Fan:) asString

!

baseline31Fan: spec 
	"self reset"
	<version: '3.1-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec postLoadDoIt: #postLoad31baseline.
		spec 
			package: 'GoferBar';
			package: 'GoferBeau' with: [ 
				spec 
					requires: 'GoferBar';
					includes: #('GoferFoo' ) ]; 
			package: 'GoferFar' with: [ spec requires: #('GoferFoo' ) ]; 
			yourself.
		spec 
			project: 'GoferFoo' with: [ "requires GoferBeau"
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '2.0';
					loads: 'GoferFoo';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

baseline31MethodSourceFan

	^(self class sourceCodeAt: #baseline31Fan:) asString

!

postLoad31baseline
	"Throw an error if GoferFar isn't loaded"

	Smalltalk at: #GoferFar ifAbsent: [ self error: 'GoferFar should be loaded' ]
!

postLoad31baselineMethodSource

	^(self class sourceCodeAt: #postLoad31baseline) asString

!

setUpConfigurationOfAtomicFan
	"self reset"
	
	| reference className definitionArray |
	reference := GoferVersionReference name: 'MetacelloTestConfigurationOfAtomicFan-dkh.1'.
	className := reference packageName asSymbol.
	definitionArray := {
					"MCOrganizationDefinition categories: (Array with: className)."
					MCClassDefinition name: className superclassName: #Object category: className instVarNames: #() comment: ''.
					MCMethodDefinition 
						className: className asString
						classIsMeta: true
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectClassMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline20Fan:'
						category: 'cat'
						timeStamp: ''
						source: self baseline20MethodSourceFan.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline31Fan:'
						category: 'cat'
						timeStamp: ''
						source: self baseline31MethodSourceFan.
					MCMethodDefinition 
						className: className asString
						selector: 'postLoad31baseline'
						category: 'cat'
						timeStamp: ''
						source: self postLoad31baselineMethodSource.
				}.
	monticelloRepository basicStoreVersion: (MCVersion new
		setPackage:  (MetacelloTestsMCPackage new name: reference packageName)
		info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
		snapshot: (MCSnapshot fromDefinitions: definitionArray)
		dependencies: #()) 
! !

!MetacelloAtomicConfigurationResource methodsFor:'ConfigurationOfAtomicFoo'!

baseline20Foo: spec 
	"self reset"
	<version: '2.0-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec blessing: #baseline.
		spec 
			package: 'GoferBar';
			package: 'GoferFoo';
			package: 'GoferBeau';
			package: 'GoferFaux';
			yourself ].
!

baseline20MethodSourceFoo

	^(self class sourceCodeAt: #baseline20Foo:) asString

!

baseline25Foo: spec 
	"self reset"
	<version: '2.5-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec blessing: #baseline.
		spec 
			package: 'GoferFoo' with: [spec requires: 'GoferFan' ];
			yourself.
		spec 
			project: 'GoferFan' with: [ "requires GoferBeau"
				spec
					className: 'MetacelloTestConfigurationOfAtomicFan';
					versionString: '2.0-baseline';
					loads: 'GoferFan';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

baseline25MethodSourceFoo

	^(self class sourceCodeAt: #baseline25Foo:) asString

!

baseline60Foo: spec 
	"self reset"
	<version: '6.0'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			package: 'GoferFoo' with:'GoferFoo-lr.4';
			package: 'GoferBar' with: 'GoferBar-lr.1';
			package: 'GoferFaux' with: 'GoferFaux-tg.34';
			package: 'GoferBeau' with: 'GoferBeau-dkh.55';
			yourself.
		spec
			group: '1' with: #('GoferFoo' 'GoferBar');
			group: '2' with: #('1' 'GoferFaux');
			yourself ].
!

baseline60MethodSourceFoo

	^(self class sourceCodeAt: #baseline60Foo:) asString

!

baseline61Foo: spec 
	"self reset"
	<version: '6.1'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			package: 'GoferFoo' with:'GoferFoo-lr.4';
			package: 'GoferBar' with: 'GoferBar-lr.1';
			package: 'GoferFaux' with: 'GoferFaux-tg.34';
			package: 'GoferBeau' with: 'GoferBeau-dkh.55';
			yourself.
		spec
			group: '1' with: #('GoferFoo' 'GoferBar');
			group: '2' with: #('GoferFoo' 'GoferBeau');
			yourself ].
!

baseline61MethodSourceFoo

	^(self class sourceCodeAt: #baseline61Foo:) asString

!

baseline62Foo: spec 
	"self reset"
	<version: '6.2'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			package: 'GoferFoo' with:'GoferFoo-lr.4';
			package: 'GoferBar' with: 'GoferBar-lr.1';
			package: 'GoferFaux' with: 'GoferFaux-tg.34';
			package: 'GoferBeau' with: 'GoferBeau-dkh.55';
			yourself.
		spec
			group: '1' with: #('GoferFoo' 'GoferBar');
			group: '2' with: #('GoferFoo' );
			yourself ].
!

baseline62MethodSourceFoo

	^(self class sourceCodeAt: #baseline62Foo:) asString

!

linearProjectMethodSource

	^(self class sourceCodeAt: #project) asString copyReplaceAll: 'atomic' with: 'linear'

!

project
	"self reset"

	| constructor project |
	"Construct Metacello project"
	constructor := MetacelloVersionConstructor on: self.
	project := constructor project.
	project loader: 
		((project loaderClass new)
			shouldDisablePackageCache: true;
			yourself).
	project loadType: #atomic.
	^project
!

projectMethodSource

	^(self class sourceCodeAt: #project) asString

!

setUpConfigurationOfAtomicFoo
	"self reset"
	
	| reference className definitionArray |
	reference := GoferVersionReference name: 'MetacelloTestConfigurationOfAtomicFoo-dkh.1'.
	className := reference packageName asSymbol.
	definitionArray := {
					"MCOrganizationDefinition categories: (Array with: className)."
					MCClassDefinition name: className superclassName: #Object category: className instVarNames: #() comment: ''.
					MCMethodDefinition 
						className: className asString
						classIsMeta: true
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectClassMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline20Foo:'
						category: 'cat'
						timeStamp: ''
						source: self baseline20MethodSourceFoo.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline25Foo:'
						category: 'cat'
						timeStamp: ''
						source: self baseline25MethodSourceFoo.
					MCMethodDefinition 
						className: className asString
						selector: 'version20Foo:'
						category: 'cat'
						timeStamp: ''
						source: self version20MethodSourceFoo.
				}.
	monticelloRepository basicStoreVersion: (MCVersion new
		setPackage:  (MetacelloTestsMCPackage new name: reference packageName)
		info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
		snapshot: (MCSnapshot fromDefinitions: definitionArray)
		dependencies: #()) 
!

setUpConfigurationOfLinearFoo
	"self reset"
	
	| reference className definitionArray |
	reference := GoferVersionReference name: 'MetacelloTestConfigurationOfLinearFoo-dkh.1'.
	className := reference packageName asSymbol.
	definitionArray := {
					"MCOrganizationDefinition categories: (Array with: className)."
					MCClassDefinition name: className superclassName: #Object category: className instVarNames: #() comment: ''.
					MCMethodDefinition 
						className: className asString
						classIsMeta: true
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectClassMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self linearProjectMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline20Foo:'
						category: 'cat'
						timeStamp: ''
						source: self baseline20MethodSourceFoo.
					MCMethodDefinition 
						className: className asString
						selector: 'version20Foo:'
						category: 'cat'
						timeStamp: ''
						source: self version20MethodSourceFoo.
					MCMethodDefinition 
						className: className asString
						selector: 'version50Foo:'
						category: 'cat'
						timeStamp: ''
						source: self version50MethodSourceFoo.
					MCMethodDefinition 
						className: className asString
						selector: 'version51Foo:'
						category: 'cat'
						timeStamp: ''
						source: self version51MethodSourceFoo.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline60Foo:'
						category: 'cat'
						timeStamp: ''
						source: self baseline60MethodSourceFoo.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline61Foo:'
						category: 'cat'
						timeStamp: ''
						source: self baseline61MethodSourceFoo.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline62Foo:'
						category: 'cat'
						timeStamp: ''
						source: self baseline62MethodSourceFoo.
				}.
	monticelloRepository basicStoreVersion: (MCVersion new
		setPackage:  (MetacelloTestsMCPackage new name: reference packageName)
		info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
		snapshot: (MCSnapshot fromDefinitions: definitionArray)
		dependencies: #()) 
!

version20Foo: spec 
	"self reset"
	<version: '2.0' imports: #('2.0-baseline')>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec blessing: #release.
		spec 
			package: 'GoferBar' with: 'GoferBar-dkh.1';
			package: 'GoferFoo' with: 'GoferFoo-dkh.4';
			package: 'GoferBeau' with: 'GoferBeau-dkh.15';
			package: 'GoferFaux' with: 'GoferFaux-tg.30';
			yourself ].
!

version20MethodSourceFoo

	^(self class sourceCodeAt: #version20Foo:) asString

!

version50Foo: spec 
	"self reset"
	<version: '5.0'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec blessing: #release.
		spec 
			package: 'GoferUmbrella' with: 'GoferUmbrella-dkh.4';
			yourself ].
!

version50MethodSourceFoo

	^(self class sourceCodeAt: #version50Foo:) asString

!

version51Foo: spec 
	"self reset"
	<version: '5.1'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec blessing: #release.
		spec 
			package: 'GoferUmbrella' with: 'GoferUmbrella-lr.5';
			yourself ].
!

version51MethodSourceFoo

	^(self class sourceCodeAt: #version51Foo:) asString

! !

!MetacelloAtomicConfigurationResource methodsFor:'ConfigurationOfFoo'!

projectClassMethodSource

	^(self class class sourceCodeAt: #project) asString

! !

!MetacelloAtomicConfigurationResource methodsFor:'ConfigurationOfUmbrella'!

setUpConfigurationOfUmbrellaA
	"self reset"
	
	| reference className definitionArray |
	reference := GoferVersionReference name: 'MetacelloTestConfigurationOfUmbrellaA-dkh.1'.
	className := reference packageName asSymbol.
	definitionArray := {
					"MCOrganizationDefinition categories: (Array with: className)."
					MCClassDefinition name: className superclassName: #Object category: className instVarNames: #() comment: ''.
					MCMethodDefinition 
						className: className asString
						classIsMeta: true
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectClassMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'version50Umbrella:'
						category: 'cat'
						timeStamp: ''
						source: self version50MethodSourceUmbrella.
				}.
	monticelloRepository basicStoreVersion: (MCVersion new
		setPackage:  (MetacelloTestsMCPackage new name: reference packageName)
		info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
		snapshot: (MCSnapshot fromDefinitions: definitionArray)
		dependencies: #()) 
!

setUpConfigurationOfUmbrellaB
	"self reset"
	
	| reference className definitionArray |
	reference := GoferVersionReference name: 'MetacelloTestConfigurationOfUmbrellaB-dkh.1'.
	className := reference packageName asSymbol.
	definitionArray := {
					"MCOrganizationDefinition categories: (Array with: className)."
					MCClassDefinition name: className superclassName: #Object category: className instVarNames: #() comment: ''.
					MCMethodDefinition 
						className: className asString
						classIsMeta: true
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectClassMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'version51Umbrella:'
						category: 'cat'
						timeStamp: ''
						source: self version51MethodSourceUmbrella.
				}.
	monticelloRepository basicStoreVersion: (MCVersion new
		setPackage:  (MetacelloTestsMCPackage new name: reference packageName)
		info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
		snapshot: (MCSnapshot fromDefinitions: definitionArray)
		dependencies: #()) 
!

version50MethodSourceUmbrella

	^(self class sourceCodeAt: #version50Umbrella:) asString

!

version50Umbrella: spec 
	"self reset"
	<version: '5.0'>
	
	spec for: #common do: [
		spec 
			project: 'Umbrella' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '5.0';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

version51MethodSourceUmbrella

	^(self class sourceCodeAt: #version51Umbrella:) asString

!

version51Umbrella: spec 
	"self reset"
	<version: '5.1'>
	
	spec for: #common do: [
		spec 
			project: 'Umbrella' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '5.1';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
! !

!MetacelloAtomicConfigurationResource methodsFor:'Issue 86'!

baseline60MethodSourceProjectIssue86

	^(self class sourceCodeAt: #baseline60ProjectIssue86:) asString

!

baseline60ProjectIssue86: spec 
	"projects and packages"
	"self reset"
	<version: '6.0'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			project: 'A' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.0';
					loads: #('1');
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			project: 'B' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.0';
					loads: #('2');
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

baseline61MethodSourceProjectIssue86

	^(self class sourceCodeAt: #baseline61ProjectIssue86:) asString

!

baseline61ProjectIssue86: spec 
	"projects and packages"
	"self reset"
	<version: '6.1'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			project: 'A' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.1';
					loads: #('1');
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			project: 'B' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.1';
					loads: #('2');
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

baseline62MethodSourceProjectIssue86

	^(self class sourceCodeAt: #baseline62ProjectIssue86:) asString

!

baseline62ProjectIssue86: spec 
	"projects and packages"
	"self reset"
	<version: '6.2'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			project: 'A' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.2';
					loads: #('1');
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			project: 'B' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.2';
					loads: #('2');
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

setUpConfigurationOfProjectIssue86
	"self reset"
	
	| reference className definitionArray |
	reference := GoferVersionReference name: 'MetacelloTestConfigurationOfProjectIssue86-dkh.1'.
	className := reference packageName asSymbol.
	definitionArray := {
					"MCOrganizationDefinition categories: (Array with: className)."
					MCClassDefinition name: className superclassName: #Object category: className instVarNames: #() comment: ''.
					MCMethodDefinition 
						className: className asString
						classIsMeta: true
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self projectClassMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'project'
						category: 'cat'
						timeStamp: ''
						source: self linearProjectMethodSource.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline60ProjectIssue86:'
						category: 'cat'
						timeStamp: ''
						source: self baseline60MethodSourceProjectIssue86.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline61ProjectIssue86:'
						category: 'cat'
						timeStamp: ''
						source: self baseline61MethodSourceProjectIssue86.
					MCMethodDefinition 
						className: className asString
						selector: 'baseline62ProjectIssue86:'
						category: 'cat'
						timeStamp: ''
						source: self baseline62MethodSourceProjectIssue86.
				}.
	monticelloRepository basicStoreVersion: (MCVersion new
		setPackage:  (MetacelloTestsMCPackage new name: reference packageName)
		info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
		snapshot: (MCSnapshot fromDefinitions: definitionArray)
		dependencies: #()) 
! !

!MetacelloAtomicConfigurationResource methodsFor:'accessing'!

monticelloRepository
	^ monticelloRepository
! !

!MetacelloAtomicConfigurationResource methodsFor:'running'!

setUp
	super setUp.
	self
		setUpMonticelloRepository;
		setUpConfigurationOfAtomicFoo;
		setUpConfigurationOfLinearFoo;
		setUpConfigurationOfAtomicFan;
		setUpConfigurationOfUmbrellaA;
		setUpConfigurationOfUmbrellaB;
		setUpConfigurationOfProjectIssue86;
		yourself
!

setUpMonticelloRepository
	"This method builds a fake repository with the version references from #buildReferences."
	"self reset"

	monticelloRepository := MCDictionaryRepository new.
! !

!MetacelloAtomicConfigurationResource class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloAtomicConfigurationResource.st,v 1.1 2011/08/20 18:13:23 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloAtomicConfigurationResource.st,v 1.1 2011/08/20 18:13:23 cg Exp $'
! !
