"{ Package: 'stx:goodies/metacello' }"

MetacelloVersionLoadDirective subclass:#MetacelloAtomicLoadDirective
	instanceVariableNames:'packageloads preloads postloads'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-MC-Directives'
!

MetacelloAtomicLoadDirective comment:''
!


!MetacelloAtomicLoadDirective methodsFor:'accessing'!

packageloads

	packageloads == nil ifTrue: [ packageloads := OrderedCollection new ].
	^ packageloads
!

packageloads: anObject
	packageloads := anObject
!

postloads

	postloads == nil ifTrue: [ postloads := OrderedCollection new ].
	^ postloads
!

preloads

	preloads == nil ifTrue: [ preloads := OrderedCollection new ].
	^ preloads
!

title

	^'atomic load'
! !

!MetacelloAtomicLoadDirective methodsFor:'actions'!

finalizeLoad: aGofer
	"load the accumulated packages (if any), reset the package list"

	| pkgLoads |
	self preloads do: [:directive | super loadPreloadDirective: directive ].
	preloads := nil.
	(pkgLoads := self packageloads) notEmpty 
		ifTrue: [
			self loader loadingSpecLoader 
				loadPackageDirectives: pkgLoads 
				gofer: aGofer.
			self packageloads: nil ].
	self postloads do: [:directive | super loadPostloadDirective: directive ].
	postloads := nil
!

loadAtomicLoadDirective: aLoaderDirective gofer: aGofer

	aLoaderDirective loadDirectives do: [:directive | directive loadUsing: self gofer: aGofer ].
!

loadLinearLoadDirective: aLoaderDirective gofer: aGofer

	self finalizeLoad: aGofer.
	super loadLinearLoadDirective: aLoaderDirective gofer: aGofer
!

loadUsing: aLoaderDirective gofer: aGofer

	self loadDirectives isEmpty ifTrue: [ ^self ].
	aLoaderDirective loadAtomicLoadDirective: self gofer: aGofer.
! !

!MetacelloAtomicLoadDirective methodsFor:'enumerating'!

directivesDo: aBlock

	aBlock value: self.
	self preloads do: [:directive | directive directivesDo: aBlock ].
	self loadDirectives do: [:directive | directive directivesDo: aBlock ].
	self postloads do: [:directive | directive directivesDo: aBlock ].
!

prepostLoadDirectivesDo: aBlock

	self preloads do: [:directive | directive prepostLoadDirectivesDo: aBlock ].
	self loadDirectives do: [:directive | directive prepostLoadDirectivesDo: aBlock ].
	self postloads do: [:directive | directive prepostLoadDirectivesDo: aBlock ].
!

prepostLoadsDo: aBlock

	self preloads do: [:directive | directive prepostLoadDo: aBlock ].
	self loadDirectives do: [:directive | directive prepostLoadDo: aBlock ].
	self postloads do: [:directive | directive prepostLoadDo: aBlock ].
	
! !

!MetacelloAtomicLoadDirective methodsFor:'loading'!

loadPackageDirective: aPackageLoadDirective gofer: aGofer
	"accumulate packages"
	
	self packageloads add: aPackageLoadDirective
!

loadPostloadDirective: aPostloadDirective
	"accumulate postloads"

	self postloads add: aPostloadDirective
!

loadPreloadDirective: aPreloadDirective 
	"accumulate preloads"

	self preloads add: aPreloadDirective
! !

!MetacelloAtomicLoadDirective class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloAtomicLoadDirective.st,v 1.1 2011/08/20 17:57:12 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloAtomicLoadDirective.st,v 1.1 2011/08/20 17:57:12 cg Exp $'
! !
