"{ Package: 'stx:goodies/metacello' }"

MetacelloDictionaryRepositoryTest subclass:#MetacelloAtomicLoadOrderTest
	instanceVariableNames:'loadType'
	classVariableNames:''
	poolDictionaries:''
	category:'* obsolete *'
!

MetacelloAtomicLoadOrderTest comment:''
!


!MetacelloAtomicLoadOrderTest methodsFor:'accessing'!

loadType

	loadType ~~ nil ifTrue: [ ^loadType ].
	^#atomic
!

monticelloRepository
	"MetacelloMonticelloResource reset"
	^ MetacelloAtomicMonticelloResource current monticelloRepository
! !

!MetacelloAtomicLoadOrderTest methodsFor:'baselines'!

baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		"using #atomic loadType means that package order isn't important ... 
			linear load order is GoferBar, GoferBeau, GoferFoo
			to test atomic load order, force an incorrect load order - which shouldn't matter for atomic loads"
		spec 
			package: 'GoferBar';
			package: 'GoferFoo' with: [ spec requires: 'GoferBar' ];
			package: 'GoferBeau' with: [ spec requires: 'GoferFoo' ];
			yourself ].
!

baseline20: spec 
	<version: '2.0-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec blessing: #baseline.
		"using #atomic loadType means that package order isn't important"
		spec 
			project: 'GoferFoo' with: [ 	"requires: 'GoferBeau'"
				spec
					className: 'MetacelloTestConfigurationOfAtomicFoo';
					versionString: '2.0-baseline';
					loads: 'GoferFoo';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself.
		spec 
			package: 'GoferBar';
			package: 'GoferFaux' with: [ spec requires: 'GoferFoo' ];
			package: 'GoferBeau'; 	"requires: 'GoferBar'"
			yourself ].
!

baseline30: spec 
	<version: '3.0-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			package: 'GoferBar';
			package: 'GoferBeau' with: [ 
				spec 
					requires: 'GoferBar';
					includes: #('GoferFoo' ) ]; 
			package: 'GoferFar' with: [ spec requires: #('GoferFoo' ) ]; 
			yourself.
		spec 
			project: 'GoferFoo' with: [ "requires GoferBeau"
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '2.0';
					loads: 'GoferFoo';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

baseline31: spec 
	<version: '3.1-baseline'>
	
	spec for: #common do: [
		spec 
			project: 'AtomicFan' with: [
				spec
					className: 'MetacelloTestConfigurationOfAtomicFan';
					versionString: '3.1-baseline';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

baseline35: spec 
	<version: '3.5-baseline'>
	"loads correctly with atomic load, gives warning if loaded linearly...the explicit load of 
	 MetacelloTestConfigurationOfAtomicFan shouldn't break the chain of the atomic load"
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			package: 'GoferBar';
			package: 'GoferBeau' with: [ 
				spec 
					requires: 'GoferBar';
					includes: #('GoferFoo' ) ]; 
			package: 'GoferFar' with: [ spec requires: #('GoferFoo' ) ]; "Far loaded after Foo, but Fan depends upon Far"
			yourself.
		spec 
			project: 'GoferFoo' with: [
				spec
					className: 'MetacelloTestConfigurationOfAtomicFoo';
					versionString: '2.5-baseline';
					loads: 'GoferFoo';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

baseline40: spec 
	<version: '4.0-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			package: 'GoferUmbrella';
			yourself ].
!

baseline50: spec 
	<version: '5.0-baseline'>
	
	spec for: #common do: [
		spec 
			project: 'UmbrellaA' with: [
				spec
					className: 'MetacelloTestConfigurationOfUmbrellaA';
					versionString: '5.0';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			project: 'UmbrellaB' with: [
				spec
					className: 'MetacelloTestConfigurationOfUmbrellaB';
					versionString: '5.1';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself ].
!

baseline60: spec 
	<version: '6.0-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			project: 'Foo' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.0';
					loads: '1';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			project: 'Issue86' with: [
				spec
					className: 'MetacelloTestConfigurationOfProjectIssue86';
					versionString: '6.0';
					loads: 'A';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself.
		spec
			package: 'GeauxFoo' with: [
				spec 
					file: 'GeauxFoo-lr.1';
					requires: #('Foo') ];
			package: 'GeauxBeau' with: [
				spec 
					file: 'GeauxBeau-dkh.55';
					requires: #('GeauxFoo' 'Issue86') ];
			yourself ].
!

baseline61: spec 
	<version: '6.1-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			project: 'Foo' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.1';
					loads: '1';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			project: 'Issue86' with: [
				spec
					className: 'MetacelloTestConfigurationOfProjectIssue86';
					versionString: '6.1';
					loads: 'A';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself.
		spec
			package: 'GeauxFoo' with: [
				spec 
					file: 'GeauxFoo-lr.1';
					requires: #('Foo') ];
			package: 'GeauxBeau' with: [
				spec 
					file: 'GeauxBeau-dkh.55';
					requires: #('GeauxFoo' 'Issue86') ];
			yourself ].
!

baseline62: spec 
	<version: '6.2-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			project: 'Foo' with: [
				spec
					className: 'MetacelloTestConfigurationOfLinearFoo';
					versionString: '6.2';
					loads: '1';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			project: 'Issue86' with: [
				spec
					className: 'MetacelloTestConfigurationOfProjectIssue86';
					versionString: '6.2';
					loads: 'A';
					repository: 'dictionary://Metacello_Configuration_Test_Repository' ];
			yourself.
		spec
			package: 'GeauxFoo' with: [
				spec 
					file: 'GeauxFoo-lr.1';
					requires: #('Foo') ];
			package: 'GeauxBeau' with: [
				spec 
					file: 'GeauxBeau-dkh.55';
					requires: #('GeauxFoo' 'Issue86') ];
			yourself ].
! !

!MetacelloAtomicLoadOrderTest methodsFor:'running'!

configurationRepository
	"MetacelloConfigurationResource reset"

	^ MetacelloAtomicConfigurationResource current monticelloRepository
!

setUp

	super setUp.
	loadType := nil.
!

tearDown

	super tearDown.
	loadType := nil.
!

tearDownPackages: aGoferInstance

	super tearDownPackages: aGoferInstance.
	(self hasPackage: 'GeauxFoo')
		ifTrue: [ aGoferInstance package: 'GeauxFoo' ].
	(self hasPackage: 'GeauxBeau')
		ifTrue: [ aGoferInstance package: 'GeauxBeau' ].
	(self hasPackage: 'GoferFar')
		ifTrue: [ aGoferInstance package: 'GoferFar' ].
	(self hasPackage: 'GoferFan')
		ifTrue: [ aGoferInstance package: 'GoferFan' ].
	(self hasPackage: 'GoferUmbrella')
		ifTrue: [ aGoferInstance package: 'GoferUmbrella' ].
	(self hasPackage: 'GoferBarDependency')
		ifTrue: [ aGoferInstance package: 'GoferBarDependency' ].
	(self hasPackage: 'GoferFooDependency')
		ifTrue: [ aGoferInstance package: 'GoferFooDependency' ].
	(self hasPackage: 'MetacelloTestConfigurationOfAtomicFoo')
		ifTrue: [ aGoferInstance package: 'MetacelloTestConfigurationOfAtomicFoo' ].
	(self hasPackage: 'MetacelloTestConfigurationOfAtomicFan')
		ifTrue: [ aGoferInstance package: 'MetacelloTestConfigurationOfAtomicFan' ].
	(self hasPackage: 'MetacelloTestConfigurationOfLinearFoo')
		ifTrue: [ aGoferInstance package: 'MetacelloTestConfigurationOfLinearFoo' ].
	(self hasPackage: 'MetacelloTestConfigurationOfUmbrellaA')
		ifTrue: [ aGoferInstance package: 'MetacelloTestConfigurationOfUmbrellaA' ].
	(self hasPackage: 'MetacelloTestConfigurationOfUmbrellaB')
		ifTrue: [ aGoferInstance package: 'MetacelloTestConfigurationOfUmbrellaB' ].
	(self hasPackage: 'MetacelloTestConfigurationOfProjectIssue86')
		ifTrue: [ aGoferInstance package: 'MetacelloTestConfigurationOfProjectIssue86' ].
		
		
	
! !

!MetacelloAtomicLoadOrderTest methodsFor:'test issues'!

testIssue66
	"http://code.google.com/p/metacello/issues/detail?id=66"
	
	| project version wc |
	project := self project.
	version := project version: '2.0'.
	self shouldnt: [ version load ] raise: Warning.
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-dkh.4').
	wc := (GoferPackageReference name: 'GoferBeau') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBeau-dkh.15').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: wc ancestry ancestors first name = 'GoferBar-dkh.1'.
	version := project version: '2.0-baseline'.
	self shouldnt: [ version load ] raise: Warning.
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-dkh.5').
	wc := (GoferPackageReference name: 'GoferBeau') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBeau-dkh.15').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: wc ancestry ancestors first name = 'GoferBar-dkh.1'
!

testIssue81A
	"http://code.google.com/p/metacello/issues/detail?id=81
	 Verify that the old version of umbrella file loads in as expected"
	
	| project version wc |
	loadType := #linear.
	project := self project.
	version := project version: '5.0-baseline'.
	version load: 'UmbrellaA'.
	wc := (GoferPackageReference name: 'GoferUmbrella') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferUmbrella-dkh.4').
	wc := (GoferPackageReference name: 'GoferBarDependency') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBarDependency-lr.30').
	wc := (GoferPackageReference name: 'GoferFooDependency') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFooDependency-lr.30').
!

testIssue81B
	"http://code.google.com/p/metacello/issues/detail?id=81
	 Note: for this bug to express itself, the dependent mcz version numbers (in this case 35) must be 
	 greater than the umbrella mcz file version number (in this case 5)"
	
	| project version wc |
	loadType := #linear.
	project := self project.
	version := project version: '5.0-baseline'.
	version load.
	wc := (GoferPackageReference name: 'GoferUmbrella') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferUmbrella-lr.5').
	wc := (GoferPackageReference name: 'GoferBarDependency') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBarDependency-lr.35').
	wc := (GoferPackageReference name: 'GoferFooDependency') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFooDependency-lr.35').
!

testIssue86A
	"Issue 86: http://code.google.com/p/metacello/issues/detail?id=86
	 	This configuration reproduces the Grease-Core vs Grease-Slime problem. "
	| project version loadDirective repo wc |
	loadType := #linear.
	project := self project.
	version := project version: '6.0-baseline'.
	repo := MetacelloAtomicConfigurationResource current monticelloRepository.
	Smalltalk at: #'Metacello_Configuration_Test_Repository' put: repo.

	repo := MetacelloMonticelloResource current monticelloRepository.
	Smalltalk at: #'Metacello_Gofer_Test_Repository' put: repo.

	loadDirective := (version load: #('GeauxBeau')) loaderPolicy loadDirective.
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-lr.4').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBar-lr.1').

	self 
		should: [ (GoferPackageReference name: 'GoferFaux') workingCopy ]
		raise: Error.
	self 
		should: [ (GoferPackageReference name: 'GoferBeau') workingCopy ]
		raise: Error.
!

testIssue86B
	""
	| project version loadDirective repo wc |
	loadType := #linear.
	project := self project.
	version := project version: '6.1-baseline'.
	repo := MetacelloAtomicConfigurationResource current monticelloRepository.
	Smalltalk at: #'Metacello_Configuration_Test_Repository' put: repo.

	repo := MetacelloMonticelloResource current monticelloRepository.
	Smalltalk at: #'Metacello_Gofer_Test_Repository' put: repo.

	loadDirective := (version load: #('GeauxBeau')) loaderPolicy loadDirective.
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-lr.4').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBar-lr.1').

	self 
		should: [ (GoferPackageReference name: 'GoferFaux') workingCopy ]
		raise: Error.
	self 
		should: [ (GoferPackageReference name: 'GoferBeau') workingCopy ]
		raise: Error.
!

testIssue86C
	""
	| project version loadDirective repo wc |
	loadType := #linear.
	project := self project.
	version := project version: '6.2-baseline'.
	repo := MetacelloAtomicConfigurationResource current monticelloRepository.
	Smalltalk at: #'Metacello_Configuration_Test_Repository' put: repo.

	repo := MetacelloMonticelloResource current monticelloRepository.
	Smalltalk at: #'Metacello_Gofer_Test_Repository' put: repo.

	loadDirective := (version load: #('GeauxBeau')) loaderPolicy loadDirective.
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-lr.4').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBar-lr.1').

	self 
		should: [ (GoferPackageReference name: 'GoferFaux') workingCopy ]
		raise: Error.
	self 
		should: [ (GoferPackageReference name: 'GoferBeau') workingCopy ]
		raise: Error.
! !

!MetacelloAtomicLoadOrderTest methodsFor:'tests'!

testBaseline10LoadAtomic

	| project version wc |
	project := self project.
	version := project version: '1.0-baseline'.
	version load.
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-dkh.5').
	wc := (GoferPackageReference name: 'GoferBeau') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBeau-dkh.15').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: wc ancestry ancestors first name = 'GoferBar-dkh.1'
!

testBaseline10LoadLinear

	| project version |
	loadType := #linear.
	project := self project.
	version := project version: '1.0-baseline'.
	self should: [ version load ] raise: Warning
!

testBaseline20LoadAtomic

	| project version wc |
	project := self project.
	version := project version: '2.0-baseline'.
	self shouldnt: [ version load ] raise: Warning.
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-dkh.5').
	wc := (GoferPackageReference name: 'GoferBeau') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBeau-dkh.15').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: wc ancestry ancestors first name = 'GoferBar-dkh.1'
!

testBaseline20LoadLinear

	| project version |
	loadType := #linear.
	project := self project.
	version := project version: '2.0-baseline'.
	self should: [ version load ] raise: Warning
!

testBaseline30LoadAtomic

	| project version wc |
	project := self project.
	version := project version: '3.0-baseline'.
	version load.
	wc := (GoferPackageReference name: 'GoferFar') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFar-dkh.4').
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-dkh.4').
	wc := (GoferPackageReference name: 'GoferBeau') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBeau-dkh.15').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: wc ancestry ancestors first name = 'GoferBar-dkh.1'
!

testBaseline30LoadLinear

	| project version wc |
	loadType := #linear.
	project := self project.
	version := project version: '3.0-baseline'.
	version load.
	wc := (GoferPackageReference name: 'GoferFar') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFar-dkh.4').
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-dkh.4').
	wc := (GoferPackageReference name: 'GoferBeau') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBeau-dkh.15').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: wc ancestry ancestors first name = 'GoferBar-dkh.1'
!

testBaseline31LoadAtomic
	"coverage for postload doits with linear load nested inside an atomic load"
	
	| project version |
	project := self project.
	version := project version: '3.1-baseline'.
	self shouldnt: [ version load ] raise: Error.
!

testBaseline35LoadAtomic

	| project version wc |
	project := self project.
	version := project version: '3.5-baseline'.
	version load.
	wc := (GoferPackageReference name: 'GoferFan') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFan-dkh.1').
	wc := (GoferPackageReference name: 'GoferFar') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFar-dkh.4').
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-dkh.5').
	wc := (GoferPackageReference name: 'GoferBeau') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBeau-dkh.15').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: wc ancestry ancestors first name = 'GoferBar-dkh.1'
!

testBaseline35LoadLinear

	| project version wc |
	loadType := #linear.
	project := self project.
	version := project version: '3.5-baseline'.
	self should: [ version load ] raise: Warning
!

testBaseline40LoadAtomic

	| project version wc |
	project := self project.
	version := project version: '4.0-baseline'.
	version load.
	wc := (GoferPackageReference name: 'GoferUmbrella') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferUmbrella-lr.5').
	wc := (GoferPackageReference name: 'GoferBarDependency') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBarDependency-lr.35').
	wc := (GoferPackageReference name: 'GoferFooDependency') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFooDependency-lr.35').
!

testBaseline40LoadLinear

	| project version wc |
	loadType := #linear.
	project := self project.
	version := project version: '4.0-baseline'.
	version load.
	wc := (GoferPackageReference name: 'GoferUmbrella') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferUmbrella-lr.5').
	wc := (GoferPackageReference name: 'GoferBarDependency') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBarDependency-lr.35').
	wc := (GoferPackageReference name: 'GoferFooDependency') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFooDependency-lr.35').
!

testVersion20LoadAtomic

	| project version wc |
	project := self project.
	version := project version: '2.0'.
	self shouldnt: [ version load ] raise: Warning.
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-dkh.4').
	wc := (GoferPackageReference name: 'GoferBeau') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBeau-dkh.15').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: wc ancestry ancestors first name = 'GoferBar-dkh.1'
! !

!MetacelloAtomicLoadOrderTest methodsFor:'versions'!

version20: spec 
	<version: '2.0' imports: #('2.0-baseline') >
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		"using #atomic loadType means that package order isn't important"
		spec 
			project: 'GoferFoo' with: '2.0';
			yourself.
		spec 
			package: 'GoferBar' with: 'GoferBar-dkh.1';
			package: 'GoferFaux' with: 'GoferFaux-tg.30';
			package: 'GoferBeau' with: 'GoferBeau-dkh.15';
			yourself ].
! !

!MetacelloAtomicLoadOrderTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloAtomicLoadOrderTest.st,v 1.1 2011/08/20 18:13:48 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloAtomicLoadOrderTest.st,v 1.1 2011/08/20 18:13:48 cg Exp $'
! !
