"{ Package: 'stx:goodies/metacello' }"

GoferResolvedReference subclass:#MetacelloCachingGoferResolvedReference
	instanceVariableNames:'cachedVersion'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-MC-Gofer'
!

MetacelloCachingGoferResolvedReference comment:''
!


!MetacelloCachingGoferResolvedReference methodsFor:'accessing'!

version
	"Answer a Monticello version of the receiver."

	cachedVersion == nil ifTrue: [ cachedVersion := super version ].
	^cachedVersion
! !

!MetacelloCachingGoferResolvedReference methodsFor:'querying'!

workingCopy
	"Answer a working copy or throw an error if not present."

	| pName |
	cachedVersion == nil ifTrue: [ ^super workingCopy ].
	pName := cachedVersion package name.
	^MCWorkingCopy allManagers
		detect: [ :each | pName = each packageName ]
		ifNone: [ self error: 'Working copy for ' , self name , ' not found' ]
! !

!MetacelloCachingGoferResolvedReference class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloCachingGoferResolvedReference.st,v 1.1 2011/08/20 18:15:14 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloCachingGoferResolvedReference.st,v 1.1 2011/08/20 18:15:14 cg Exp $'
! !
