"{ Package: 'stx:goodies/metacello' }"

TestCase subclass:#MetacelloCleanUpChangeSetsTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* obsolete *'
!

MetacelloCleanUpChangeSetsTestCase comment:''
!


!MetacelloCleanUpChangeSetsTestCase methodsFor:'tests'!

testCleanUpChangeSets
	"excess change sets can cause a noticeable slow down in monticello performance, so this test just cleans them up"
	
	| removals set|
	(ChangeSet respondsTo: #allChangeSets) ifFalse: [ ^self ].
	removals := OrderedCollection new.
	(set := ChangeSet perform: #allChangeSets) do: [:cs |
		(cs name beginsWith: 'MC')
			ifTrue: [
				cs name size >= 3
					ifTrue: [ | post |
						post := cs name copyFrom: 3 to: cs name size.
						post asInteger printString = post 
							ifTrue: [ removals add: cs ]]]].
	removals do: [:cs | set remove: cs ].
	removals := OrderedCollection new.
	(set := ChangeSet perform: #allChangeSets) do: [:cs |
		((cs name beginsWith: 'GoferBar') 
			or: [ (cs name beginsWith: 'GoferFoo')
				or: [ (cs name beginsWith: 'GoferFaux')
					or: [ (cs name beginsWith: 'GoferBeau')
						or: [ (cs name beginsWith: 'MetacelloTestConfiguration')]]]])
			ifTrue: [removals add: cs ]].
	removals do: [:cs | set remove: cs ].
! !

!MetacelloCleanUpChangeSetsTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloCleanUpChangeSetsTestCase.st,v 1.1 2011/08/20 18:17:01 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloCleanUpChangeSetsTestCase.st,v 1.1 2011/08/20 18:17:01 cg Exp $'
! !
