"{ Package: 'stx:goodies/metacello' }"

MetacelloConfigAbstractAPITestCase subclass:#MetacelloConfigAPITestCase
	instanceVariableNames:'alternatePreLoadExecuted preLoadExecuted postLoadExecuted
		preloadAnswer postloadAnswer'
	classVariableNames:''
	poolDictionaries:''
	category:'* obsolete *'
!

MetacelloConfigAPITestCase comment:''
!


!MetacelloConfigAPITestCase methodsFor:'accessing'!

projectWith: projectAttributes

	| project |
	"Construct Metacello project"
	project := MetacelloMCProject new.
	project projectAttributes: projectAttributes.
	MetacelloVersionConstructor on: self project: project.
	project loader: MetacelloNullRecordingMCSpecLoader new.
	project loader evalDoits: true.
	^project
! !

!MetacelloConfigAPITestCase methodsFor:'baselines'!

baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #testBlessing.
		spec 
			package: 'Example-Core' with: [ 
				spec 
					includes: 'Example-AddOn';
					file: 'Example-Core-anon.1';
					repository: 'http://www.example.com/or';
					preLoadDoIt: #preloadForCore;
					postLoadDoIt: #postloadForCore:package: ];
			package: 'Example-AddOn' with: [ spec requires: #('Example-Core' ) ];
			package: 'Example-Tests' with: [ spec requires: #('Example-AddOn' ) ]].
!

baseline101: spec 
	<version: '1.0.1-baseline'>
	
	spec for: #common do: [
		spec blessing: [
			spec value: #testBlessing ]].
!

baseline102: spec 
	<version: '1.0.2-baseline'>
	
	spec for: #common do: [
		spec 
			preLoadDoIt: #preloadForCore;
			postLoadDoIt: #postloadForCore:package:.
		spec 
			package: 'Example-Core' with: [ spec includes: 'Example-AddOn' ];
			package: 'Example-AddOn' with: [ spec requires: #('Example-Core' ) ];
			package: 'Example-Tests' with: [ spec requires: #('Example-AddOn' ) ]]
!

baseline103: spec 
	<version: '1.0.3-baseline' imports: #( '1.0.2-baseline' )>
	
	spec for: #common do: [
		spec 
			preLoadDoIt: #alternatePreloadForCore ]
!

baseline104: spec 
	<version: '1.0.4-baseline' imports: #( '1.0.2-baseline' )>
	
	spec for: #common do: [
		spec 
			preLoadDoIt: nil ]
!

baseline105: spec 
	<version: '1.0.5-baseline'>
	
	spec for: #common do: [
		spec 
			package: 'Example-Core' with: [ 
				spec repository: 'http://www.example.com/ob' ]].
!

baseline106: spec 
	<version: '1.0.6-baseline'>
	
	spec for: #common do: [
		spec 
			package: 'Example-Core' with: [ 
				spec repositories: [
						spec 
							repository: 'http://www.example.com/or';
							repository: 'http://www.example.com/ob' ]]].
!

baseline107: spec 
	<version: '1.0.7-baseline'>
	
	spec for: #common do: [
		spec 
			package: 'Example-Core' with: [ 
				spec 
					preLoadDoIt: #preloadForSupplyingAnswers;
					postLoadDoIt: #postloadForSupplyingAnswers;
					supplyingAnswers: #(#('preload' 'preload answer') #('postload' 'postload answer')) ];
			package: 'Example-Tests' with: [
				spec supplyingAnswers: 
					#(
						#('string' 'preload answer') 
						#('symbol' #'default')
						#('integer' 1)
						#('boolean' true)
						#('another boolean' false)
						#('character' $a)
					)]].
!

baseline108: spec 
	<version: '1.0.8-baseline'>
	
	spec for: #common do: [
		spec 
			package: 'Example-Core';
			package: 'Example-Tests' with: [ 
				spec requires: 'Example-Core' ]].
!

baseline109: spec 
	<version: '1.0.9-baseline'>
	
	spec for: #common do: [
		spec 
			package: 'Example-Core';
			package: 'Example-Tests' with: [ 
				spec includes: 'Example-Core' ]].
!

baseline110: spec 
	<version: '1.1.0-baseline'>
	
	spec for: #common do: [
		spec 
			package: 'Example-Core';
			package: 'Example-Base';
			package: 'Example-Test1' with: [ 
				spec 
					includes: 'Example-Core';
					requires: 'Example-Base' ];
			package: 'Example-Test2' with: [ 
				spec 
					includes: 'Example-Core';
					supplyingAnswers: #(#('captionMatch' 'answer')) ];
			package: 'Example-Test3' with: [ 
				spec 
					supplyingAnswers: #(#('captionMatch' 'answer'));
					requires: 'Example-Base' ];
			package: 'Example-Test4' with: [ 
				spec 
					includes: 'Example-Core';
					supplyingAnswers: #(#('captionMatch' 'answer'));
					requires: 'Example-Base' ];
			yourself].
!

baseline111: spec 
	<version: '1.1.1-baseline'>
	
	spec for: #common do: [
		spec 
			package: 'Example-Core'.
		spec for: #nested do: [
			spec
				package: 'Example-Base';
				yourself ]].
	spec for: #extra do: [
		spec
			package: 'Example-Test';
			yourself].
!

baseline112: spec 
	<version: '1.1.2-baseline'>
	
	spec for: #common do: [
		spec 
			package: 'Example-Core'.
		spec for: #nested do: [
			spec
				package: 'Example-Base';
				package: 'Example-Test-Nested';
				yourself ]].
	spec for: #extra do: [
		spec
			package: 'Example-Test';
			yourself].
!

baseline113: spec 
	<version: '1.1.3-baseline'>
	
	spec for: #outer do: [
		spec 
			package: 'Example-Core';
			package: 'Example-Test';
			yourself].
!

baseline114: spec 
	<version: '1.1.4-baseline'>
	
	spec for: #common do: [
		spec 
			project: 'Example Project' with: [
				spec
					className: 'MetacelloExampleProjectConfig';
					versionString: '1.0-baseline';
					preLoadDoIt: #preloadForProject;
					postLoadDoIt: #postloadForProject;
					repository: 'http://www.example.com/ob';
					yourself. ];
			yourself].
!

baseline115: spec 
	<version: '1.1.5-baseline' imports: #( '1.1.4-baseline' )>
	
	spec for: #common do: [
		spec 
			project: 'Example Project' with: [
				spec preLoadDoIt: #alternatePreloadForCore ]]
!

baseline116: spec 
	<version: '1.1.6-baseline' imports: #( '1.1.4-baseline' )>
	
	spec for: #common do: [
		spec 
			project: 'Example Project' with: [
				spec preLoadDoIt: #alternatePreloadForCore ]]
!

baseline117: spec 
	<version: '1.1.7-baseline' imports: #( '1.0-baseline' ) >
	
	spec for: #common do: [
		spec 
			package: 'Example-Core' overrides: [ 
				spec 
					preLoadDoIt: #alternatePreloadForCore ]].
!

baseline118: spec 
	<version: '1.1.8-baseline' imports: #( '1.0-baseline' ) >
	
	spec for: #common do: [
		spec 
			package: 'Example-Core' with: [ 
				spec 
					preLoadDoIt: #alternatePreloadForCore ]].
!

baseline119: spec 
	<version: '1.1.9-baseline' imports: #( '1.1.4-baseline' )>
	
	spec for: #common do: [
		spec 
			project: 'Example Project' overrides: [
				spec
					className: 'MetacelloExampleProjectConfig';
					versionString: '1.0-baseline';
					preLoadDoIt: #alternatePreloadForCore;
					yourself.]]
!

baseline120: spec 
	<version: '1.2.0-baseline' imports: #( '1.1.4-baseline' )>
	
	spec for: #common do: [
		spec 
			project: 'Copied Example' copyFrom: 'Example Project' with: [
				spec preLoadDoIt: #alternatePreloadForCore ]]
!

baseline121: spec 
	<version: '1.2.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #testBlessing.
		spec repository: 'http://www.example.com/vor'.
		spec 
			package: 'Example-Core' with: [ 
				spec 
					includes: 'Example-AddOn';
					file: 'Example-Core-anon.1';
					repository: 'http://www.example.com/or';
					preLoadDoIt: #preloadForCore;
					postLoadDoIt: #postloadForCore:package: ];
			package: 'Example-AddOn' with: [ spec requires: #('Example-Core' ) ];
			package: 'Example-Tests' with: [ spec requires: #('Example-AddOn' ) ]].
!

baseline122: spec 
	<version: '1.2.2-baseline'>
	
	spec for: #common do: [
		spec 
			project: 'Example Project' with: [
				spec
					className: 'MetacelloExampleProjectConfig';
					repository: 'http://www.example.com/ob';
					yourself. ];
			yourself].
!

baseline123: spec 
	<version: '1.2.3-baseline'>
	
	spec for: #common do: [
		spec 
			project: 'Example Project' with: [
				spec
					className: 'MetacelloExampleProjectConfig';
					repository: 'http://www.example.com/ob';
					repository: 'http://www.example.com/or';
					yourself. ];
			yourself].
!

baseline124: spec 
	<version: '1.2.4-baseline'>
	
	spec for: #common do: [
		spec
			blessing: #baseline;
			repository: 'http://www.example.com/aa';
			yourself.].

	spec for: #common do: [
		spec
			repository: 'http://www.example.com/ab';
			yourself.].
! !

!MetacelloConfigAPITestCase methodsFor:'doits'!

alternatePreloadForCore

	alternatePreLoadExecuted := true
!

postloadForCore: mcLoader package: pkgSpec

	postLoadExecuted := true
!

postloadForProject

	postLoadExecuted := true
!

postloadForSupplyingAnswers

	postloadAnswer := ProvideAnswerNotification signal: 'postload'
!

preloadForCore

	preLoadExecuted := true
!

preloadForProject

	preLoadExecuted := true
!

preloadForSupplyingAnswers

	preloadAnswer := ProvideAnswerNotification signal: 'preload'
! !

!MetacelloConfigAPITestCase methodsFor:'running'!

setUp

	super setUp.
	alternatePreLoadExecuted := preLoadExecuted := postLoadExecuted := false
! !

!MetacelloConfigAPITestCase methodsFor:'test directives'!

testPrePostPackageLoadsDo
	| project version loader loadDirective preloaded count pkgloaded postloaded |
	project := self project.

	version := project version: '1.0-baseline'.
	loader := version fetch.
	loadDirective := loader loadDirective.
	pkgloaded := postloaded := preloaded := false.
	loadDirective directivesDo: [:directive |
		directive preLoadDo: [:pre |
			self deny: preloaded.			 
			self deny: pkgloaded.
			self deny: postloaded.
			preloaded := true.
			self assert: (#preloadForCore == pre spec preLoadDoIt value) ].
		directive packageDo: [:pkg | 
			preloaded ifTrue: [ 
				self deny: postloaded.
				pkgloaded := true.
				pkg spec name = 'Example-Core' ]].
		directive postLoadDo: [:post | 
			self assert: preloaded.			 
			self assert: pkgloaded.
			self deny: postloaded.
			preloaded := false.
			postloaded := true.
			self assert: (#postloadForCore:package: == post spec postLoadDoIt value) ]].
	self assert: postloaded
!

testPrepostProjectLoadsDo
	| project version loader loadDirective x |
	project := self project.

	version := project version: '1.1.6-baseline'.
	loader := version fetch.
	loadDirective := loader loadDirective.
	loadDirective prepostLoadDirectivesDo: [:directive |
		directive preLoadDo: [:pre | self assert: (#alternatePreloadForCore == directive spec preLoadDoIt value) ].
		directive postLoadDo: [:post | self assert: (#postloadForProject == directive spec postLoadDoIt value) ]].
! !

!MetacelloConfigAPITestCase methodsFor:'test null loader'!

testNullLoaderLoadedRepositories

	| project version loader repositories |
	project := self project.

	version := project version: '1.2.1-baseline'.
	loader := version load.
	repositories := loader loadedRepositories.
	self assert: repositories size = 2.
	repositories do: [:repo |
		self assert: repo class == MCHttpRepository.
		self assert: (#('http://www.example.com/vor' 'http://www.example.com/or') includes: repo description) ].
! !

!MetacelloConfigAPITestCase methodsFor:'test package'!

testPackagePreloadOverride
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.1.7-baseline') spec.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self assert: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
!

testPackagePreloadPostload
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.0-baseline') spec.
	self assert: (versionSpec packages map at: 'Example-Core') preLoadDoIt value == #preloadForCore.
	self assert: (versionSpec packages map at: 'Example-Core') postLoadDoIt value == #postloadForCore:package:.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self assert: preLoadExecuted.
	self assert: postLoadExecuted.
!

testPackagePreloadWith
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.1.8-baseline') spec.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self assert: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self assert: postLoadExecuted.
!

testPackageSupplyingAnswers
	| project versionSpec version pkg string expected |
	project := self project.

	versionSpec := (version := project version: '1.0.7-baseline') spec.
	pkg := version packageNamed: 'Example-Core'.
	string := self conditionResult: pkg printString.
	expected := 'spec 
	name: ''Example-Core'';
	supplyingAnswers: #( #( ''preload'' ''preload answer'' ) #( ''postload'' ''postload answer'' ) );
	preLoadDoIt: #''preloadForSupplyingAnswers'';
	postLoadDoIt: #''postloadForSupplyingAnswers''.'.
	self assert: string = expected.
	self assert: pkg answers = #(#('preload' 'preload answer') #('postload' 'postload answer')).

	self deny: preloadAnswer = 'preload answer'.
	self deny: postloadAnswer = 'postload answer'.
	version load.
	self assert: preloadAnswer = 'preload answer'.
	self assert: postloadAnswer = 'postload answer'.

	pkg := version packageNamed: 'Example-Tests'.
	string := self conditionResult: pkg printString.
	expected := 'spec 
	name: ''Example-Tests'';
	supplyingAnswers: #( #( ''string'' ''preload answer'' ) #( ''symbol'' #''default'' ) #( ''integer'' 1 ) #( ''boolean'' true ) #( ''another boolean'' false ) #( ''character'' $a ) ).'.
	self assert: string = expected.
! !

!MetacelloConfigAPITestCase methodsFor:'test project'!

testProjectPreloadCopyFrom
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.2.0-baseline') spec.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load: 'Copied Example'.
	self assert: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self assert: postLoadExecuted.
!

testProjectPreloadCopyFromB
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.2.0-baseline') spec.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load: 'Example Project'.
	self deny: alternatePreLoadExecuted.
	self assert: preLoadExecuted.
	self assert: postLoadExecuted.
!

testProjectPreloadOverride
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.1.9-baseline') spec.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self assert: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
!

testProjectPreloadPostload
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.1.4-baseline') spec.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self assert: preLoadExecuted.
	self assert: postLoadExecuted.
!

testProjectPreloadWith
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.1.6-baseline') spec.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self assert: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self assert: postLoadExecuted.
! !

!MetacelloConfigAPITestCase methodsFor:'test version'!

testVersionPreloadOverride
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.0.3-baseline') spec.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self assert: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self assert: postLoadExecuted.
!

testVersionPreloadPostload
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.0.2-baseline') spec.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self assert: preLoadExecuted.
	self assert: postLoadExecuted.
!

testVersionPreloadRemove
	| project versionSpec version |
	project := self project.

	versionSpec := (version := project version: '1.0.4-baseline') spec.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self deny: postLoadExecuted.
	version load.
	self deny: alternatePreLoadExecuted.
	self deny: preLoadExecuted.
	self assert: postLoadExecuted.
! !

!MetacelloConfigAPITestCase methodsFor:'versions'!

version113: spec 
	<version: '1.1.3' imports: #( '1.1.3-baseline' )>
	
	spec for: #outer do: [
		spec
			package: 'Example-Core' with: 'Example-Core-dkh.1';
			package: 'Example-Test' with: 'Example-Test-dkh.1'.
		spec for: #nested do: [
			spec
				package: 'Example-Core' with: 'Example-Core-dkh.2';
				yourself ]].
	spec for: #extra do: [
		spec
			package: 'Example-Core' with: 'Example-Core-dkh.3';
			yourself].
!

version124: spec 
	<version: '1.2.4' imports: #( '1.2.4-baseline' )>
	
	spec for: #common do: [
		spec
			repository: 'http://www.example.com/ac';
			yourself.].
! !

!MetacelloConfigAPITestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloConfigAPITestCase.st,v 1.1 2011/08/20 18:10:59 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloConfigAPITestCase.st,v 1.1 2011/08/20 18:10:59 cg Exp $'
! !
