"{ Package: 'stx:goodies/metacello' }"

Object subclass:#MetacelloDirective
	instanceVariableNames:'spec loader'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-MC-Directives'
!

MetacelloDirective comment:''
!


!MetacelloDirective class methodsFor:'instance creation'!

loadPackage: aPackageSpec externalReference: externalReference loader: aLoader

	^MetacelloPackageLoadDirective new
		spec: aPackageSpec externalReference: externalReference  loader: aLoader 
!

loader: aLoader

	^self new
		loader: aLoader
!

postLoadSpec: packageOrVersionSpec loader: aLoader

	^MetacelloPostLoadDirective new
		spec: packageOrVersionSpec loader: aLoader
!

preLoadSpec: packageOrVersionSpec loader: aLoader

	^MetacelloPreLoadDirective new
		spec: packageOrVersionSpec loader: aLoader
! !

!MetacelloDirective methodsFor:'accessing'!

loader

	^loader
!

loader: aLoader

	loader := aLoader
!

spec

	^spec
!

title

	self subclassResponsibility
! !

!MetacelloDirective methodsFor:'actions'!

addTo: aLoaderDirective

	aLoaderDirective add: self
!

loadUsing: aLoaderDirective gofer: aGofer

	self subclassResponsibility
!

packageDo: aBlock
!

postLoadDo: aBlock

	
!

preLoadDo: aBlock
!

versionDo: aBlock
! !

!MetacelloDirective methodsFor:'enumerating'!

directivesDo: aBlock

	aBlock value: self
!

packageDirectivesDo: aBlock
!

prepostLoadDirectivesDo: aBlock
!

prepostLoadDo: aBlock
!

versionDirectivesDepthFirstDo: aBlock
!

versionDirectivesDo: aBlock
! !

!MetacelloDirective methodsFor:'initialize-release'!

spec: packageOrVersionSpec loader: aLoader

	spec := packageOrVersionSpec.
	loader := aLoader
! !

!MetacelloDirective methodsFor:'printing'!

label

	^self spec label
!

printOn: aStream

	self printOn: aStream indent: 0
!

printOn: aStream indent: indent

	indent timesRepeat: [ aStream tab ].
	aStream
		nextPutAll: self title;
		nextPutAll: ' : ';
		nextPutAll: self label.
!

printString
	"Explicit override of superclass implementation. When you are printing a loadDirective it is annoying to have it truncated."

	^String streamContents: [:s | self printOn: s]
! !

!MetacelloDirective class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloDirective.st,v 1.1 2011/08/20 18:13:17 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloDirective.st,v 1.1 2011/08/20 18:13:17 cg Exp $'
! !
