"{ Package: 'stx:goodies/metacello' }"

MetacelloAbstractPackageSpec subclass:#MetacelloGroupSpec
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-Core-Specs'
!

MetacelloGroupSpec comment:''
!


!MetacelloGroupSpec methodsFor:'*metacello-mc'!

loadUsing: aLoader gofer: gofer
	"noop"
!

resolveToLoadableSpec

	^nil
!

resolveToPackagesIn: aVersionSpec into: packages visited: visited

	visited 
		visit: self 
		doing: [:aSpec | | map |
			map := aVersionSpec packages map.
			aSpec includes do: [:pkgName | 
				(aVersionSpec packageNamed: pkgName forMap: map ifAbsent: [])
					projectDo: [:ignored | ] 
					packageDo: [:pkg | packages at: pkg name put: pkg ] 
					groupDo: [:grp | grp resolveToPackagesIn: aVersionSpec into: packages visited: visited ]]]
!

resolveToPackagesIn: aVersionSpec visited: visited

	| packages |
	packages := Dictionary new.
	self resolveToPackagesIn: aVersionSpec into: packages visited: visited.
	^packages values asOrderedCollection
! !

!MetacelloGroupSpec methodsFor:'accessing'!

answers: aListOfPairs

	self shouldNotImplement
!

requires: aCollection

	self shouldNotImplement
! !

!MetacelloGroupSpec methodsFor:'printing'!

configMethodCascadeOn: aStream member: aMember last: lastCascade indent: indent

	aMember methodUpdateSelector == #remove:
		ifTrue: [ aStream nextPutAll: 'removeGroup: ', self name printString. ]
		ifFalse: [
			aStream 
				nextPutAll: 'group: ', self name printString;
				space; 
				nextPutAll: aMember methodUpdateSelector asString, ' #('.
			self includes do: [:str | aStream nextPutAll: str printString, ' ' ].
			aStream nextPut: $) ].
	lastCascade
		ifTrue: [ aStream nextPut: $. ]
		ifFalse: [ aStream nextPut: $;; cr ].
!

configMethodOn: aStream indent: indent

	aStream 
		tab: indent;
		nextPutAll: 'spec '; cr;
		tab: indent + 1;
		nextPutAll: 'name: ', self name printString, ';'.
	self configMethodBodyOn: aStream hasName: true cascading: false indent: indent + 1.
	aStream nextPut: $.
! !

!MetacelloGroupSpec methodsFor:'visiting'!

projectDo: projectBlock packageDo: packageBlock groupDo: groupBlock

	groupBlock value: self
! !

!MetacelloGroupSpec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloGroupSpec.st,v 1.1 2011/08/20 17:56:47 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloGroupSpec.st,v 1.1 2011/08/20 17:56:47 cg Exp $'
! !
