"{ Package: 'stx:goodies/metacello' }"

TestCase subclass:#MetacelloHTTPRepositoryLoadTestCase
	instanceVariableNames:'gofer'
	classVariableNames:''
	poolDictionaries:''
	category:'* obsolete *'
!

MetacelloHTTPRepositoryLoadTestCase comment:''
!


!MetacelloHTTPRepositoryLoadTestCase methodsFor:'accessing'!

enabled
	"return true to actually run tests ... don't need to test loading all of the time ...
	 before enabling this, see #testAuthentication"
	
	^false
!

project

	^(MetacelloVersionConstructor on: self) project
! !

!MetacelloHTTPRepositoryLoadTestCase methodsFor:'assertions'!

assertClass: aClassSymbol
	self assert: (Smalltalk hasClassNamed: aClassSymbol)
!

assertClass: aClassSymbol selector: aMethodSymbol
	self assertClass: aClassSymbol.
	self assert: ((Smalltalk at: aClassSymbol) includesSelector: aMethodSymbol)
! !

!MetacelloHTTPRepositoryLoadTestCase methodsFor:'baselines'!

baseline: spec 
	<version: 'default'>

	spec
		for: #common
		do: [spec
				project: 'Bogus Project'
				with: [
					spec className: 'BogusConfiguration';
						 file: 'BogusConfiguration';
						 version: 'default';
						 repository: 'http://seaside.gemstone.com/ss/bogus']]
!

baselineAuthentication: spec 
	<version: 'authentication'>

	spec
		for: #common
		do: [spec
				project: 'Bogus Project'
				with: [
					spec className: 'BogusConfiguration';
						 file: 'BogusConfiguration';
						 version: 'default';
						 repository: 'http://seaside.gemstone.com/ss/authenticationRequired' username: 'foo' password: 'bar']]
! !

!MetacelloHTTPRepositoryLoadTestCase methodsFor:'running'!

setUp

	super setUp.
	gofer := Gofer new.
	gofer 
		gemsource: 'bogus'; 
		package: 'BogusConfiguration';
		package: 'Bogus';
		package: 'BogusExt'
		
!

tearDown

	super tearDown.
	[ gofer metacelloUnload ]
		on: Error
		do: [ :err | "assume it is not there" ]
! !

!MetacelloHTTPRepositoryLoadTestCase methodsFor:'tests'!

testAuthentication
	"test _should_ fail because you are not authorized to access the repository...
	 to test with your own private repository copy the package BogusConfiguration from
	 http://seaside.gemstone.com/ss/bogus to your repository and edit the #baselineAuthentication:
	 appropriately. "

	self enabled ifFalse: [ ^self ].
	(self project version: 'authentication') load.
	self assert: (self hasPackage: 'Bogus'); assertClass: #BogusA.
	self assert: (self hasPackage: 'BogusExt'); assertClass: #BogusA selector: #isFake.
!

testLoad

	self enabled ifFalse: [ ^self ].
	(self project version: 'default') load.
	self assert: (self hasPackage: 'Bogus'); assertClass: #BogusA.
	self assert: (self hasPackage: 'BogusExt'); assertClass: #BogusA selector: #isFake.
! !

!MetacelloHTTPRepositoryLoadTestCase methodsFor:'utilities'!

hasPackage: aString
	| package |
	package := MCWorkingCopy allManagers
		detect: [ :each | each packageName = aString ]
		ifNone: [ nil ].
	^ package notNil
! !

!MetacelloHTTPRepositoryLoadTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloHTTPRepositoryLoadTestCase.st,v 1.1 2011/08/20 18:17:07 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloHTTPRepositoryLoadTestCase.st,v 1.1 2011/08/20 18:17:07 cg Exp $'
! !
