"{ Package: 'stx:goodies/metacello' }"

CustomHelp subclass:#MetacelloHelp
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-Help'
!

MetacelloHelp comment:''
!


!MetacelloHelp class methodsFor:'accessing'!

bookName 
	^'Metacello'
!

key

	^'Metacello help'
!

pages
	^#(introduction features gettingStarted)
! !

!MetacelloHelp class methodsFor:'pages'!

features
	^HelpTopic 	
		title: 'Features'
		contents: 'Metacello is consistent with the following features of a package management system.
		
DECLARATIVE MODELING
A Metacello project has named versions consisting of lists of explicit Monticello package versions. Dependencies are explicitly expressed in terms of named versions of required projects. A required project is a reference to another Metacello project.

DISTRIBUTED REPOSITORIES
Metacello project metadata is represented as instance methods in a class therefore the Metacello project metadata is stored in a Monticello package. As a result, it is easy for distributed groups of developers to collaborate on ad hoc projects.

OPTIMISTIC DEVELOPMENT
With Monticello-based packages, concurrent updates to the project metadata can be easily managed. Parallel versions of the metadata can be merged just like parallel versions of the code base itself.
	

Additionally, the following three points are important considerations for Metacello:

CROSS PLATFORM OPERATION
Metacello must run on all platforms that support Monticello: currently Squeak, Pharo and GLASS.

CONDITIONAL MONTICELLO PACKAGE LOADING
For projects that are expected to run on multiple platforms, it is essential that platform-specific Monticello packages can be conditionally loaded. At the moment, conditional loading is specified based upon the following attributes:

#common - Code that is common across all platforms.
#squeakCommon - Code that is common to Squeak and Pharo.
#squeak - Code that is specific to Squeak.
#pharo - Code that is specific to Pharo.
#gemstone - Code that is specific to GemStone.

It should be possible to inject project-specific attributes, so code that is dependent upon attributes not covered by the standard list can be conditionally loaded. For example, in GLASS, different Monticello package versions are loaded based on which version of GemStone/S is running (i.e., version 2.0 versus 3.0).

COMPATIBLE WITH MC2
It must be possible to manage Metacello projects that are based on alternate Distributed Source Code Management systems like Monticello2.

MIT LICENSED
		
		
		
'
!

gettingStarted
	^HelpTopic 	
		title: 'Getting Started'
		contents: 'If you have a porject that you''d like to use Metacello with, you should start by taking the Metacello tutorial to familiar yourself with the configuration specification language. First load the tutorial code:

	ConfigurationOfMetacello project latestVersion load: #(''Tutorial'').

take the ProfStef-based toturial:

	ProfStef goOn: MetacelloConfigurationTutorialPart1.
	ProfStef goOn: MetacelloConfigurationTutorialPart2.

or take the image-based-tutorial:

	http://code.google.com/p/metacello/wiki/Tutorial

Then you should run through the Development process tutorial:

	ProfStef goOn: MetacelloDevelopmentProcess.

Other online resources:

	http://code.google.com/p/metacello/
	http://forum.world.st/Monticello-Metacello-f1460836.html
	http://groups.google.com/group/metacello
	http://code.google.com/p/metacello/wiki/APIReference
	
'
!

icon
	^HelpIcons iconNamed: #packageIcon
!

introduction
	^HelpTopic 	
		title: 'Introduction'
		contents: 'Metacello is a package management system for Monticello. A package management system is a collection of tools to automate the process of installing, upgrading, configuring, and removing software packages from a computer. Distributions of Linux and other Unix-like systems typically consist of hundreds or even thousands of distinct software packages; in the former case a package management system is nice, in the latter case it is essential.

Packages are distributions of software and metadata such as the software''s full name, description of its purpose, version number, vendor, checksum, and a list of dependencies necessary for the software to run properly. Upon installation, metadata is stored in a local package database.

A package management system provides a consistent method of installing software' 
! !

!MetacelloHelp class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloHelp.st,v 1.1 2011/08/20 17:57:57 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloHelp.st,v 1.1 2011/08/20 17:57:57 cg Exp $'
! !
