"{ Package: 'stx:goodies/metacello' }"

TestCase subclass:#MetacelloImportsTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* obsolete *'
!

MetacelloImportsTestCase comment:''
!


!MetacelloImportsTestCase methodsFor:'accessing'!

project

	| constructor project |
	"Construct Metacello project"
	constructor := MetacelloVersionConstructor on: self.
	project := constructor project.
	project loader: MetacelloNullRecordingMCSpecLoader new.
	^project
! !

!MetacelloImportsTestCase methodsFor:'baselines'!

baseline10beta0: spec 
	<version: '1.0-beta.0-baseline'>
	spec
		for: #common
		do: [
			spec
				package: 'Metacello-Core'
				with: [spec includes: #('Metacello-MC' 'Metacello-Platform' )];
				
				package: 'Metacello-MC';
				
				package: 'Metacello-Platform'
				with: [spec requires: #('Metacello-MC' )]].
!

baseline10beta3: spec 
	<version: '1.0-beta.3-baseline' imports: #('1.0-beta.0-baseline')>
	spec
		for: #common
		do: [
			spec
				package: 'Metacello-TestsCore'
				with: [spec requires: #('Metacello-Core' )];
				
				package: 'Metacello-Tutorial'
				with: [spec requires: #('Metacello-Core' )];
				
				package: 'Metacello-TutorialTests'
				with: [spec requires: #('Metacello-Tutorial' )]]
! !

!MetacelloImportsTestCase methodsFor:'tests'!

testBaseline10beta0

	| project loadedPackages version loader |
	project := self project.

	version := project version: '1.0-beta.0-baseline'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'Metacello-Core') > 0.
	self assert: (loadedPackages indexOf: 'Metacello-MC') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-Platform') >
						(loadedPackages indexOf: 'Metacello-Core').
!

testBaseline10beta3

	| project loadedPackages version loader |
	project := self project.

	version := project version: '1.0-beta.3-baseline'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 6.
	self assert: (loadedPackages indexOf: 'Metacello-Core') > 0.
	self assert: (loadedPackages indexOf: 'Metacello-MC') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-Platform') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-TestsCore') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-Tutorial') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-TutorialTests') >
						(loadedPackages indexOf: 'Metacello-Tutorial').
!

testVersion10beta3

	| project loadedPackages version loader |
	project := self project.

	version := project version: '1.0-beta.3'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 6.
	self assert: (loadedPackages indexOf: 'Metacello-Core') > 0.
	self assert: (loadedPackages indexOf: 'Metacello-MC') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-Platform') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-TestsCore') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-Tutorial') >
						(loadedPackages indexOf: 'Metacello-Core').
	self assert: (loadedPackages indexOf: 'Metacello-TutorialTests') >
						(loadedPackages indexOf: 'Metacello-Tutorial').
!

testVersion10beta3Extra

	| project loadedPackages version loader |
	project := self project.

	version := project version: '1.0-beta.3-extra'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 6.
	self assert: (loadedPackages indexOf: 'Metacello-Core-dkh.1') > 0.
	self assert: (loadedPackages indexOf: 'Metacello-MC-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Core-dkh.1').
	self assert: (loadedPackages indexOf: 'Metacello-Platform-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Core-dkh.1').
	self assert: (loadedPackages indexOf: 'Metacello-TestsCore-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Core-dkh.1').
	self assert: (loadedPackages indexOf: 'Metacello-Tutorial-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Core-dkh.1').
	self assert: (loadedPackages indexOf: 'Metacello-TutorialTests-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Tutorial-dkh.1').
!

testVersion10beta3ImportedVersions
	| project version |
	project := self project.

	version := project version: '1.0-beta.3-baseline'.
	self assert: version importedVersions size = 1.
	self assert: (version importedVersions includes: '1.0-beta.0-baseline').

	version := project version: '1.0-beta.3'.
	self assert: version importedVersions size = 1.
	self assert: (version importedVersions includes: '1.0-beta.3-baseline').
!

testVersion10beta4

	| project loadedPackages version loader |
	project := self project.

	version := project version: '1.0-beta.4'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 6.
	self assert: (loadedPackages indexOf: 'Metacello-Core-dkh.1') > 0.
	self assert: (loadedPackages indexOf: 'Metacello-MC-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Core-dkh.1').
	self assert: (loadedPackages indexOf: 'Metacello-Platform-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Core-dkh.1').
	self assert: (loadedPackages indexOf: 'Metacello-TestsCore-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Core-dkh.1').
	self assert: (loadedPackages indexOf: 'Metacello-Tutorial-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Core-dkh.1').
	self assert: (loadedPackages indexOf: 'Metacello-TutorialTests-dkh.1') >
						(loadedPackages indexOf: 'Metacello-Tutorial-dkh.1').
!

testVersion10beta4ImportedVersions

	| project loadedPackages version loader |
	project := self project.

	version := project version: '1.0-beta.4'.
	self assert: version importedVersions size = 2.
	self assert: (version importedVersions includes: '1.0-beta.3').
	self assert: (version importedVersions includes: '1.0-beta.3-extra').
! !

!MetacelloImportsTestCase methodsFor:'versions'!

version10beta3: spec 
	<version: '1.0-beta.3' imports: #('1.0-beta.3-baseline')>
	spec
		for: #common
		do: [ spec blessing: #development].
!

version10beta3Extra: spec 
	<version: '1.0-beta.3-extra' imports: #('1.0-beta.3-baseline')>
	spec
		for: #common
		do: [
			spec
				package: 'Metacello-Core' with: 'Metacello-Core-dkh.1';
				package: 'Metacello-MC' with: 'Metacello-MC-dkh.1';
				package: 'Metacello-Platform' with: 'Metacello-Platform-dkh.1';
				package: 'Metacello-TestsCore' with: 'Metacello-TestsCore-dkh.1';
				package: 'Metacello-Tutorial' with: 'Metacello-Tutorial-dkh.1';
				package: 'Metacello-TutorialTests' with: 'Metacello-TutorialTests-dkh.1' ].
!

version10beta4: spec 
	<version: '1.0-beta.4' imports: #('1.0-beta.3' '1.0-beta.3-extra' )>
	spec
		for: #common
		do: [ spec blessing: #release].
! !

!MetacelloImportsTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloImportsTestCase.st,v 1.1 2011/08/20 18:09:59 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloImportsTestCase.st,v 1.1 2011/08/20 18:09:59 cg Exp $'
! !
