"{ Package: 'stx:goodies/metacello' }"

TestResource subclass:#MetacelloIssue108Resource
	instanceVariableNames:'versionReferences monticelloRepository'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-TestsMC-Resources'
!

MetacelloIssue108Resource comment:''
!


!MetacelloIssue108Resource methodsFor:'accessing'!

monticelloRepository
	^ monticelloRepository
!

versionReferences
	^ versionReferences
! !

!MetacelloIssue108Resource methodsFor:'running'!

setUp
	super setUp.
	self
		setUpVersionReferences;
		setUpMonticelloRepository
!

setUpMonticelloRepository
	"This method builds a fake repository with the version references from #buildReferences."

	monticelloRepository := MCDictionaryRepository new.
	versionReferences do: [ :reference |
		monticelloRepository basicStoreVersion: (MCVersion new
			setPackage:  (MetacelloTestsMCPackage new name: reference packageName)
			info: (MCVersionInfo
				name: reference name
				id: UUID new
				message: 'This is a mock version'
				date: Date today
				time: Time now
				author: reference author
				ancestors: #())
			snapshot: (MCSnapshot fromDefinitions: (Array
				"with: (MCOrganizationDefinition categories: (Array with: reference packageName asSymbol))"
				with: (MCClassDefinition name: (reference packageName copyWithout: $-) asSymbol superclassName: #Object category: reference packageName asSymbol instVarNames: #() comment: '')))
			dependencies: #()) ]
!

setUpVersionReferences
	"self reset"

	versionReferences := OrderedCollection new.
	versionReferences
		add: (GoferVersionReference name: 'GoferBar.gemstone-dkh.68');
		add: (GoferVersionReference name: 'GoferBar.gemstone-dkh.69');
		add: (GoferVersionReference name: 'GoferBar.gemstone-dkh.70');
		add: (GoferVersionReference name: 'GoferBar-dkh.68');
		add: (GoferVersionReference name: 'GoferBar-dkh.69');
		add: (GoferVersionReference name: 'GoferBar-dkh.70');
		yourself
	
! !

!MetacelloIssue108Resource class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloIssue108Resource.st,v 1.1 2011/08/20 18:17:32 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloIssue108Resource.st,v 1.1 2011/08/20 18:17:32 cg Exp $'
! !
