"{ Package: 'stx:goodies/metacello' }"

MetacelloDictionaryRepositoryTest subclass:#MetacelloMCCachingLoaderTestCase
	instanceVariableNames:'platformCacheRepository'
	classVariableNames:''
	poolDictionaries:''
	category:'* obsolete *'
!

MetacelloMCCachingLoaderTestCase comment:''
!


!MetacelloMCCachingLoaderTestCase methodsFor:'baselines'!

baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec repository: 'dictionary://Metacello_Gofer_Test_Repository'.
		spec 
			package: 'GoferFoo';
			package: 'GoferBar';
			package: 'GoferFaux';
			yourself ].
! !

!MetacelloMCCachingLoaderTestCase methodsFor:'tests'!

testBaselineFetch

	| project version repo map pkgSpecs |
	project := self project.
	version := project version: '1.0-baseline'.
	repo := version loaderPolicy cacheRepository.
	self assert: repo allVersionInfos isEmpty.
	version fetch: 'default'.
	self deny: repo allVersionInfos isEmpty.
	map := Dictionary new.
	(Gofer new allResolvedIn: repo) do: [:resolvedRef | map at: resolvedRef packageName put: resolvedRef ].
	pkgSpecs := version packages.
	self assert: map size = pkgSpecs size.
	pkgSpecs do: [:pkgSpec | map at: pkgSpec name ifAbsent: [ self assert: false ]].
		
!

testBaselineLoad

	| project version wc |
	project := self project.
	version := project version: '1.0-baseline'.
	version load: #('default').
	wc := (GoferPackageReference name: 'GoferFoo') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFoo-lr.4').
	wc := (GoferPackageReference name: 'GoferBar') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferBar-lr.1').
	wc := (GoferPackageReference name: 'GoferFaux') workingCopy.
	self assert: (wc ancestry ancestors first name = 'GoferFaux-tg.35').
!

testDualFetch

	| project version repo map pkgSpecs |
	project := self project.
	version := project version: '2.0'.
	repo := version loaderPolicy cacheRepository.
	self assert: repo allVersionInfos isEmpty.
	version fetch: 'default'.
	self deny: repo allVersionInfos isEmpty.
	version := project version: '1.0-baseline'.
	version fetch: #('default').
	self deny: repo allVersionInfos isEmpty.
	map := Dictionary new.
	(Gofer new allResolvedIn: repo) do: [:resolvedRef | map at: resolvedRef packageName put: resolvedRef ].
	pkgSpecs := version packages.
	self assert: map size = pkgSpecs size.
	pkgSpecs do: [:pkgSpec | map at: pkgSpec name ifAbsent: [ self assert: false ]].
		
!

testVersion10Fetch

	| project version repo map pkgSpecs |
	project := self project.
	version := project version: '1.0'.
	repo := version loaderPolicy cacheRepository.
	self assert: repo allVersionInfos isEmpty.
	version fetch: #('default').
	self deny: repo allVersionInfos isEmpty.
	map := Dictionary new.
	(Gofer new allResolvedIn: repo) do: [:resolvedRef | map at: resolvedRef name put: resolvedRef ].
	pkgSpecs := version packages.
	self assert: map size = pkgSpecs size.
	pkgSpecs do: [:pkgSpec | map at: pkgSpec file ifAbsent: [ self assert: false ]].
		
! !

!MetacelloMCCachingLoaderTestCase methodsFor:'versions'!

version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>
	
	spec for: #common do: [
		spec 
			package: 'GoferFoo' with: 'GoferFoo-lr.1';
			package: 'GoferBar' with: 'GoferBar-jf.1';
			package: 'GoferFaux' with: 'GoferFaux-tg.32';
			yourself. ].
!

version20: spec
	<version: '2.0' imports: #('1.0-baseline' )>
	
	spec for: #common do: [
		spec 
			package: 'GoferFoo' with: 'GoferFoo-lr.4';
			package: 'GoferBar' with: 'GoferBar-lr.1';
			package: 'GoferFaux' with: 'GoferFaux-tg.35';
			yourself. ].
! !

!MetacelloMCCachingLoaderTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloMCCachingLoaderTestCase.st,v 1.1 2011/08/20 18:15:38 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloMCCachingLoaderTestCase.st,v 1.1 2011/08/20 18:15:38 cg Exp $'
! !
