"{ Package: 'stx:goodies/metacello' }"

Object subclass:#MetacelloMCVersionSpecLoader
	instanceVariableNames:'versionSpec required packages loader loaderPolicy'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-MC-Loaders'
!

MetacelloMCVersionSpecLoader comment:''
!


!MetacelloMCVersionSpecLoader class methodsFor:'instance creation'!

on: aVersionSpec

	^(self new) 
		versionSpec: aVersionSpec;
		yourself
! !

!MetacelloMCVersionSpecLoader methodsFor:'accessing'!

label

	^self versionSpec label
!

loader

	loader == nil 
		ifTrue: [
			loader := self versionSpec loader copy.
			loader spec: self.
			loaderPolicy notNil ifTrue: [ loader loaderPolicy: loaderPolicy] ].
	^loader
!

loaderPolicy
	^ loaderPolicy
!

loaderPolicy: anObject
	loaderPolicy := anObject
!

name

	^self versionSpec name
!

operator

	^self loader operator
!

packages

	^packages
!

project

	^self versionSpec project
!

required

	required == nil ifTrue: [ ^#() ].
	^ required
!

required: anObject
	required := anObject
!

versionSpec
	^ versionSpec
!

versionSpec: anObject
	versionSpec := anObject
! !

!MetacelloMCVersionSpecLoader methodsFor:'loading'!

load

	| mcLoader |
	packages := Dictionary new.
	self resolveToLoadableSpecs.
	mcLoader := self loader.
			packages values do: [:pkg | 
				pkg ensureLoadedForDevelopmentUsing: mcLoader.
				mcLoader ignoreImage ifFalse: [(pkg 
					compareCurrentVersion: self operator 
					targetVersionStatus: #(allLoadedToSpec) 
					using: mcLoader) 
						ifTrue: [ packages removeKey: pkg name ]]].
	packages notEmpty
		ifTrue: [
			mcLoader preLoad: self versionSpec.
			mcLoader load.
			mcLoader postLoad: self versionSpec ].
	^mcLoader
!

repositories

	^self repositorySpecs
!

resolvePackageNames

	packages := Dictionary new.
	self resolveToLoadableSpecs.
	^packages values collect: [:pkg | pkg name ]
! !

!MetacelloMCVersionSpecLoader methodsFor:'private'!

resolveToLoadableSpecs

	self versionSpec resolveToLoadableSpecs: required map: packages
! !

!MetacelloMCVersionSpecLoader methodsFor:'spec compatibility'!

packageSpecsInLoadOrder

	| loadOrder packageNames |
	loadOrder := self versionSpec packages ~~ nil
		ifTrue: [ self versionSpec packages packageSpecsInLoadOrder ]
		ifFalse: [ OrderedCollection new ].
	packageNames := packages values collect: [:pkg | pkg name ].
	^loadOrder select: [:pkg | packageNames includes: pkg name ]
!

repositorySpecs

	| repositoryMap |
	repositoryMap := self versionSpec repositories ~~ nil
		ifTrue: [ self versionSpec repositories map ]
		ifFalse: [ Dictionary new ].
	^repositoryMap values.
!

versionString

	^self versionSpec versionString
! !

!MetacelloMCVersionSpecLoader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloMCVersionSpecLoader.st,v 1.1 2011/08/20 18:12:01 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloMCVersionSpecLoader.st,v 1.1 2011/08/20 18:12:01 cg Exp $'
! !
