"{ Package: 'stx:goodies/metacello' }"

MetacelloFetchingMCSpecLoader subclass:#MetacelloNullRecordingMCSpecLoader
	instanceVariableNames:'afterLoads beforeLoads evalDoits'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-MC-Loaders'
!

MetacelloNullRecordingMCSpecLoader comment:''
!


!MetacelloNullRecordingMCSpecLoader methodsFor:'accessing'!

actionLabel

	^'Recording '
!

afterLoads

	afterLoads == nil ifTrue: [ afterLoads := OrderedCollection new ].
	^afterLoads
!

beforeLoads

	beforeLoads == nil ifTrue: [ beforeLoads := OrderedCollection new ].
	^beforeLoads
!

evalDoits

	evalDoits == nil ifTrue: [ evalDoits := false ].
	^evalDoits 
!

evalDoits: aBool

	evalDoits := aBool
!

loadedPackages

	| packages |
	packages := OrderedCollection new.
	self loadDirective packageDirectivesDo: [:directive | packages add: directive file ].
	^packages
!

loadedRepositories

	| repos |
	repos := OrderedCollection new.
	self repositoryMap values collect: [:coll | repos addAll: coll ].
	^repos
!

loadingSpecLoader

	^self
!

packages

	| packages |
	packages := OrderedCollection new.
	self loadDirective packageDirectivesDo: [:directive | packages add: directive spec ].
	^packages
!

recordingSpecLoader

	^self
! !

!MetacelloNullRecordingMCSpecLoader methodsFor:'actions'!

doingLoads: aBlock
	"escape mechanism for recording and null loaders to skip doing loaderlike things"
!

linearLoadPackageSpec: packageSpec gofer: gofer

	MetacelloPlatform current
		do:  [ | externalReference loadBlock answers fake |
			externalReference := self resolveRecordingPackageSpecReference: packageSpec gofer: gofer.
			loadBlock := [
					self preLoad: packageSpec.
					(MetacelloDirective 
						loadPackage: packageSpec 
						externalReference: externalReference 
						loader: self) addTo: self loadDirective.
					self postLoad: packageSpec ].
			(answers := packageSpec answers) notEmpty
				ifTrue: [ loadBlock valueSupplyingMetacelloAnswers: answers ]
				ifFalse: [ loadBlock value ].
			fake := packageSpec copy.
			fake name: fake file.
			self loadData 
				addVersion: fake
				versionInfo: fake
				resolvedReference: externalReference 
				packageSpec: packageSpec ]
		displaying: 'Recording ', packageSpec file
!

loadPackageDirective: aPackageLoadDirective gofer: aGofer
	"Noop"
!

loadPackageDirectives: pkgLoads gofer: aGofer
	"Noop"
! !

!MetacelloNullRecordingMCSpecLoader methodsFor:'doits'!

postLoad: packageOrVersionSpec

	self evalDoits ifFalse: [ ^self ].
	packageOrVersionSpec postLoadDoItBlock ~~ nil
		ifTrue: [ self afterLoads add: packageOrVersionSpec name, ' load' ].
	super postLoad: packageOrVersionSpec
!

preLoad: packageOrVersionSpec

	self evalDoits ifFalse: [ ^self ].
	packageOrVersionSpec preLoadDoItBlock ~~ nil
		ifTrue: [ self beforeLoads add: packageOrVersionSpec name, ' load' ].
	super preLoad: packageOrVersionSpec
! !

!MetacelloNullRecordingMCSpecLoader methodsFor:'private'!

resolvePackageSpecReferences: packageSpec gofer: gofer

	|  versionReference references localGofer |
	localGofer := gofer.
	self hasRepositoryOverrides not
		ifTrue: [
			packageSpec repositorySpecs notEmpty
				ifTrue: [ 
					localGofer := MetacelloGofer new.
					(self repositoriesFrom: packageSpec repositorySpecs) do: [:repo | localGofer repository: repo ]]].
	(packageSpec getFile == nil or: [ self shouldDisablePackageCache ])
		ifTrue: [ 
			"don't use package-cache when trying to get latest version"
			localGofer disablePackageCache ].
	versionReference := packageSpec goferLoaderReference.
	references := versionReference resolveAllWith: localGofer.
	localGofer enablePackageCache.
	^references
!

resolveRecordingPackageSpecReference: packageSpec gofer: gofer

	| externalPackageReference |
	externalPackageReference := packageSpec file == nil
				ifTrue: [ GoferPackageReference name: packageSpec name ]
				ifFalse: [ GoferResolvedReference name: packageSpec file repository: nil ].
	packageSpec repositorySpecs isEmpty
		ifTrue: [  self repositoryMap at: externalPackageReference packageName put: (gofer repositories reject: [:repo | repo = MCCacheRepository default ]) ]
		ifFalse: [  self repositoryMap at: externalPackageReference packageName put: (packageSpec repositorySpecs collect: [:repoSpec | repoSpec createRepository ]) ].
	^externalPackageReference
! !

!MetacelloNullRecordingMCSpecLoader methodsFor:'testing'!

ensureForDevelopment

	^false
! !

!MetacelloNullRecordingMCSpecLoader methodsFor:'versionInfo'!

currentVersionInfoFor: packageSpec

	^self loadData
		currentVersionInfoFor: packageSpec 
		ifAbsent: [ nil ]
! !

!MetacelloNullRecordingMCSpecLoader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloNullRecordingMCSpecLoader.st,v 1.1 2011/08/20 18:17:38 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloNullRecordingMCSpecLoader.st,v 1.1 2011/08/20 18:17:38 cg Exp $'
! !
