"{ Package: 'stx:goodies/metacello' }"

TestCase subclass:#MetacelloPlatformAttributesTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* obsolete *'
!

MetacelloPlatformAttributesTestCase comment:''
!


!MetacelloPlatformAttributesTestCase methodsFor:'accessing'!

project

	^self projectWith: #()
!

projectWith: projectAttributes

	| project |
	"Construct Metacello project"
	project := MetacelloMCProject new.
	project projectAttributes: projectAttributes.
	MetacelloVersionConstructor on: self project: project.
	project loader: MetacelloNullRecordingMCSpecLoader new.
	^project
! !

!MetacelloPlatformAttributesTestCase methodsFor:'baselines'!

baseline011: spec 
	<version: '0.11-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec description: 'FFI project '.
		spec repository: 'source.squeakfoundation.org/FFI'.

		spec 
			package: 'FFI-Kernel';
			package: 'FFI-Examples' with: [
				spec requires: #('FFI-Kernel' ) ];
			package: 'FFI-Tests' with: [
				spec requires: #('FFI-Examples' ) ]].
!

baseline10beta0: spec 
	<version: '1.0-beta.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec description: 'GemTools client for Pharo/Squeak'.
		spec repository: 'http://seaside.gemstone.com/ss/GLASSClient'.
		spec 
			package: 'OB-SUnitGUI' with: [
				spec repository: 'http://seaside.gemstone.com/ss/obsunit' ];
			package: 'GemTools-Client' with: [
				spec requires: #('OB-SUnitGUI' ) ];
			package: 'GemTools-Platform' with: [
				spec requires: #('GemTools-Client' ) ]].
! !

!MetacelloPlatformAttributesTestCase methodsFor:'tests'!

testBaseline011
	| project loadedPackages version loader |
	project := self project.

	version := project version: '0.11-baseline'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'FFI-Kernel') > 0.
	self assert: (loadedPackages indexOf: 'FFI-Examples') >
						(loadedPackages indexOf: 'FFI-Kernel').
	self assert: (loadedPackages indexOf: 'FFI-Tests') >
						(loadedPackages indexOf: 'FFI-Examples').
!

testBaseline011Pharo10Beta
	| project loadedPackages version loader |
	project := self projectWith: #(#'pharo1.0Beta').

	version := project version: '0.11-baseline'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'FFI-Kernel') > 0.
	self assert: (loadedPackages indexOf: 'FFI-Examples') >
						(loadedPackages indexOf: 'FFI-Kernel').
	self assert: (loadedPackages indexOf: 'FFI-Tests') >
						(loadedPackages indexOf: 'FFI-Examples').
!

testLastVersion
	| project version |
	project := self project.

	version := project lastVersion.
	self assert: version versionString = '1.0-beta.0'
!

testVersion011
	| project loadedPackages version loader |
	project := self project.

	version := project version: '0.11'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'FFI-Kernel-ar.8') > 0.
	self assert: (loadedPackages indexOf: 'FFI-Examples-ar.1') >
						(loadedPackages indexOf: 'FFI-Kernel-ar.8').
	self assert: (loadedPackages indexOf: 'FFI-Tests-ar.2') >
						(loadedPackages indexOf: 'FFI-Examples-ar.1').
!

testVersion011Pharo10Beta
	| project loadedPackages version loader |
	project := self projectWith: #(#'pharo1.0Beta').

	version := project version: '0.11'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'FFI-Kernel-ar.11') > 0.
	self assert: (loadedPackages indexOf: 'FFI-Examples-ar.1') >
						(loadedPackages indexOf: 'FFI-Kernel-ar.11').
	self assert: (loadedPackages indexOf: 'FFI-Tests-ar.3') >
						(loadedPackages indexOf: 'FFI-Examples-ar.1').
!

testVersion10beta0
	| project loadedPackages version loader |
	project := self project.

	version := project version: '1.0-beta.0'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'OB-SUnitGUI-dkh.52') >
						(loadedPackages indexOf: 'FFI-Tests-ar.3').
	self assert: (loadedPackages indexOf: 'GemTools-Client.experimental-dkh.493') >
						(loadedPackages indexOf: 'OB-SUnitGUI-dkh.52').
	self assert: (loadedPackages indexOf: 'GemTools-Platform.squeakCommon-dkh.2') >
						(loadedPackages indexOf: 'GemTools-Client.experimental-dkh.493').
!

testVersion10beta0Pharo10Beta
	| project loadedPackages version loader |
	project := self projectWith: #(#'pharo1.0Beta').

	version := project version: '1.0-beta.0'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'OB-SUnitGUI-dkh.52') >
						(loadedPackages indexOf: 'FFI-Tests-ar.3').
	self assert: (loadedPackages indexOf: 'GemTools-Client.experimental-dkh.493') >
						(loadedPackages indexOf: 'OB-SUnitGUI-dkh.52').
	self assert: (loadedPackages indexOf: 'GemTools-Platform.pharo10beta-dkh.2') >
						(loadedPackages indexOf: 'GemTools-Client.experimental-dkh.493').
! !

!MetacelloPlatformAttributesTestCase methodsFor:'versions'!

version011: spec 
	<version: '0.11' imports: #('0.11-baseline' )>
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'FFI project ... used by GemTools for Pharo 1.0beta #10440'.
		spec 
			package: 'FFI-Kernel' with: 'FFI-Kernel-ar.8';
			package: 'FFI-Examples' with: 'FFI-Examples-ar.1';
			package: 'FFI-Tests' with: 'FFI-Tests-ar.2' ].
	spec for: #'pharo1.0Beta' do: [
		spec 
			package: 'FFI-Kernel' with: 'FFI-Kernel-ar.11';
			package: 'FFI-Tests' with: 'FFI-Tests-ar.3' ].
!

version10beta0: spec 
	<version: '1.0-beta.0' imports: #('1.0-beta.0-baseline' )>
	
	spec for: #common do: [
		spec blessing: #beta.
		spec description: 'GemTools client for Pharo/Squeak'.
		spec 
			package: 'OB-SUnitGUI' with: 'OB-SUnitGUI-dkh.52';
			package: 'GemTools-Client' with: 'GemTools-Client.experimental-dkh.493';
			package: 'GemTools-Platform' with: 'GemTools-Platform.squeakCommon-dkh.2' ].
	spec for: #'pharo1.0Beta' do: [
		spec package: 'GemTools-Platform' with: 'GemTools-Platform.pharo10beta-dkh.2' ].
! !

!MetacelloPlatformAttributesTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloPlatformAttributesTestCase.st,v 1.1 2011/08/20 18:15:50 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloPlatformAttributesTestCase.st,v 1.1 2011/08/20 18:15:50 cg Exp $'
! !
