"{ Package: 'stx:goodies/metacello' }"

MetacelloSpec subclass:#MetacelloProjectSpec
	instanceVariableNames:'name className versionString operator loads preLoadDoIt
		postLoadDoIt'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-Core-Specs'
!

MetacelloProjectSpec comment:''
!


!MetacelloProjectSpec methodsFor:'accessing'!

className: aString

	className := aString
!

loads: aCollection

	aCollection setLoadsInMetacelloProject: self
!

name: aString

	name := aString
!

operator: anObject
	" #= #~= #> #< #>= #<= #~> "
	
	operator := anObject
!

postLoadDoIt: anObject

	anObject setPostLoadDoItInMetacelloSpec: self
!

preLoadDoIt: anObject

	anObject setPreLoadDoItInMetacelloSpec: self
!

setPostLoadDoIt: aSymbol

	postLoadDoIt := aSymbol
!

setPreLoadDoIt: aSymbol

	preLoadDoIt := aSymbol
!

versionString: anObject
	versionString := anObject
! !

!MetacelloProjectSpec methodsFor:'adding'!

addToMetacelloPackages: aMetacelloPackagesSpec

	| spec |
	spec := (aMetacelloPackagesSpec project projectReferenceSpec)
			name: self name;
			projectReference: self copy;
			yourself.
	aMetacelloPackagesSpec addMember: 
		(aMetacelloPackagesSpec addMember 
			name: spec name;
			spec: spec;
			yourself)
			
! !

!MetacelloProjectSpec methodsFor:'loading'!

load

	self subclassResponsibility
! !

!MetacelloProjectSpec methodsFor:'merging'!

mergeMap

	| map |
	map := super mergeMap.
	map at: #name put: name.
	map at: #className put: className.
	map at: #versionString put: versionString.
	map at: #operator put: operator.
	map at: #loads put: loads.
	map at: #preLoadDoIt put: preLoadDoIt.
	map at: #postLoadDoIt put: postLoadDoIt.
	^map
! !

!MetacelloProjectSpec methodsFor:'printing'!

configMethodBodyOn: aStream indent: indent
	| hasVersionString hasOperator hasProjectPackage hasLoads hasClassName hasPreLoadDoIt hasPostLoadDoIt |
	hasClassName := self className ~~ nil.
	hasVersionString := self versionString ~~ nil.
	hasOperator := operator ~~ nil.
	hasProjectPackage := self projectPackage ~~ nil
		and: [ self projectPackage packageRepository ~~ nil or: [ self projectPackage name ~= self className ] ].
	hasLoads := self loads ~~ nil.
	hasPreLoadDoIt := self getPreLoadDoIt ~~ nil.
	hasPostLoadDoIt := self getPostLoadDoIt ~~ nil.
	hasClassName
		ifTrue: [ 
			hasVersionString | hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'className: ' , self className printString.
			hasVersionString | hasPreLoadDoIt | hasPostLoadDoIt | hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasVersionString
		ifTrue: [ 
			| vs |
			hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			vs := self versionString.
			aStream nextPutAll: 'versionString: '.
			vs isSymbol
				ifTrue: [ aStream nextPut: $# ].
			aStream nextPutAll: vs asString printString.
			hasPreLoadDoIt | hasPostLoadDoIt | hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasPreLoadDoIt
		ifTrue: [ 
			hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPreLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'preLoadDoIt: '.
			self preLoadDoIt value isSymbol
				ifTrue: [ 
					aStream 
						nextPut: $#;
						nextPutAll: self preLoadDoIt value asString printString]
				ifFalse: [ aStream nextPutAll: self preLoadDoIt value asString ].
			hasPostLoadDoIt | hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasPostLoadDoIt
		ifTrue: [ 
			hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPostLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'postLoadDoIt: '.
			self postLoadDoIt value isSymbol
				ifTrue: [ 
					aStream 
						nextPut: $#;
						nextPutAll: self postLoadDoIt value asString printString]
				ifFalse: [ aStream nextPutAll: self postLoadDoIt value asString ].
			hasOperator | hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasOperator
		ifTrue: [ 
			hasClassName | hasVersionString | hasProjectPackage | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'operator: #' , self operator asString printString.
			hasProjectPackage | hasLoads
				ifTrue: [ aStream nextPut: $; ] ].
	hasLoads
		ifTrue: [ 
			hasClassName | hasVersionString | hasOperator | hasProjectPackage | hasPreLoadDoIt | hasPostLoadDoIt
				ifTrue: [ 
					aStream
						cr;
						tab: indent + 1 ]
				ifFalse: [ aStream space ].
			aStream nextPutAll: 'loads: #('.
			self loads do: [ :str | aStream nextPutAll: str printString , ' ' ].
			aStream nextPut: $).
			hasProjectPackage
				ifTrue: [ aStream nextPut: $; ] ].
	hasProjectPackage
		ifTrue: [ 
			| hasName hasRepo |
			hasName := self projectPackage name ~= self className.
			hasRepo := self projectPackage packageRepository ~~ nil.
			hasName
				ifTrue: [ 
					hasClassName | hasVersionString | hasOperator | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
						ifTrue: [ 
							aStream
								cr;
								tab: indent + 1 ]
						ifFalse: [ aStream space ].
					aStream nextPutAll: 'file: ' , self projectPackage name printString.
					hasRepo
						ifTrue: [ aStream nextPut: $; ] ].
			hasRepo
				ifTrue: [ 
					| repos |
					repos := self projectPackage repositories.
					repos map values size = 1
						ifTrue: [ 
							hasClassName | hasVersionString | hasOperator | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
								ifTrue: [ 
									aStream
										cr;
										tab: indent + 1 ]
								ifFalse: [ aStream space ].
							self projectPackage packageRepository configMethodCascadeOn: aStream lastCascade: true ]
						ifFalse: [ 
							aStream cr.
							self projectPackage repositories configMethodCascadeOn: aStream indent: indent ] ] ]
!

configMethodOn: aStream indent: indent

	aStream 
		tab: indent;
		nextPutAll: 'spec '; cr;
		tab: indent + 1;
		nextPutAll: 'name: ', self name printString, ';'.
	self configMethodBodyOn: aStream indent: indent.
	aStream nextPut: $.
!

configShortCutMethodOn: aStream member: aMember indent: indent
	| hasVersionString hasOperator hasProjectPackage hasLoads hasClassName hasPreLoadDoIt hasPostLoadDoIt |
	hasClassName := self className ~~ nil.
	hasVersionString := self versionString ~~ nil.
	hasOperator := operator ~~ nil.
	hasProjectPackage := self projectPackage ~~ nil
		and: [ self projectPackage name ~~ nil or: [ self projectPackage packageRepository ~~ nil ] ].
	hasLoads := self loads ~~ nil.
	hasPreLoadDoIt := self getPreLoadDoIt ~~ nil.
	hasPostLoadDoIt := self getPostLoadDoIt ~~ nil.
	hasClassName | hasOperator | hasProjectPackage | hasLoads | hasPreLoadDoIt | hasPostLoadDoIt
		ifTrue: [ 
			(aMember methodUpdateSelector == #copy: or: [ aMember methodUpdateSelector == #with: ])
				ifTrue: [ 
					aStream
						nextPutAll: 'with: [';
						cr ]
				ifFalse: [ 
					aStream
						nextPutAll: 'overrides: [';
						cr ].
			aStream
				tab: indent;
				nextPutAll: 'spec'.
			self configMethodBodyOn: aStream indent: indent.
			aStream nextPutAll: ' ]'.
			^ self ].
	hasVersionString
		ifTrue: [ 
			| vs |
			vs := self versionString.
			aStream nextPutAll: 'with: '.
			vs isSymbol
				ifTrue: [ aStream nextPut: $# ].
			aStream nextPutAll: vs asString printString ]
!

label

	^self name
! !

!MetacelloProjectSpec methodsFor:'private'!

setLoads: aCollection

	loads := aCollection
! !

!MetacelloProjectSpec methodsFor:'querying'!

className

	^className
!

getPostLoadDoIt

	^postLoadDoIt
!

getPreLoadDoIt

	^preLoadDoIt
!

loads
	^ loads
!

name

	^name
!

operator

	operator == nil ifTrue: [ ^#>= ].
	^ operator
!

postLoadDoIt

	^postLoadDoIt
!

preLoadDoIt

	^preLoadDoIt
!

projectPackage

	^nil
!

versionKey
	"suitable for using as a unique key for the receiver's version in a dictionary"

	^ self version versionKey
!

versionString
	^ versionString
! !

!MetacelloProjectSpec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloProjectSpec.st,v 1.1 2011/08/20 18:12:34 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloProjectSpec.st,v 1.1 2011/08/20 18:12:34 cg Exp $'
! !
