"{ Package: 'stx:goodies/metacello' }"

MetacelloMemberListSpec subclass:#MetacelloRepositoriesSpec
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-MC-Specs'
!

MetacelloRepositoriesSpec comment:''
!


!MetacelloRepositoriesSpec methodsFor:'actions'!

add: aStringOrSpec

	aStringOrSpec addToMetacelloRepositories: self
!

add: description type: type

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			type: type;
			yourself.
	self addMember: 
		(self addMember 
			name: spec name;
			spec: spec;
			yourself)
!

merge: aRepositorySpec

	aRepositorySpec mergeIntoMetacelloRepositories: self
!

merge: description type: type

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			type: type;
			yourself.
	self addMember: 
		(self mergeMember 
			name: spec name;
			spec: spec;
			yourself)
!

remove: aRepositorySpec

	aRepositorySpec removeFromMetacelloRepositories: self
!

repository: aStringOrSpec

	aStringOrSpec addToMetacelloRepositories: self
!

repository: description username: username password: password

	| spec |
	spec := 
		(self project repositorySpec)
			description: description;
			username: username;
			password: password;
			yourself.
	self addMember: 
		(self addMember 
			name: spec name;
			spec: spec;
			yourself)
! !

!MetacelloRepositoriesSpec methodsFor:'printing'!

configMethodCascadeOn: aStream indent: indent

	| repositorySpecs |
	repositorySpecs := self map values sort: [:a :b | a description <= b description ].
	repositorySpecs size = 1
		ifTrue: [ repositorySpecs first configMethodCascadeOn: aStream lastCascade: true ]
		ifFalse: [
			1 to: repositorySpecs size do: [:index | | repositorySpec |
				aStream tab: indent + 1.
				(repositorySpecs at: index)
					configMethodCascadeOn: aStream 
					lastCascade: index >= repositorySpecs size ]]
!

configMethodOn: aStream indent: indent

	aStream 
		tab: indent; 
		nextPutAll: 'spec';
		cr.
	self configMethodCascadeOn: aStream indent: indent
! !

!MetacelloRepositoriesSpec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloRepositoriesSpec.st,v 1.1 2011/08/20 18:17:44 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloRepositoriesSpec.st,v 1.1 2011/08/20 18:17:44 cg Exp $'
! !
