"{ Package: 'stx:goodies/metacello' }"

MetacelloSpec subclass:#MetacelloRepositorySpec
	instanceVariableNames:'description username password type'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-MC-Specs'
!

MetacelloRepositorySpec comment:''
!


!MetacelloRepositorySpec methodsFor:'accessing'!

description: aString

	description := aString
!

password: aString

	password := aString
!

type: aString

	type := aString
!

username: aString

	username := aString
! !

!MetacelloRepositorySpec methodsFor:'adding'!

addToMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec addMember 
			name: self name;
			spec: self;
			yourself)
! !

!MetacelloRepositorySpec methodsFor:'mc support'!

createRepository

	^self project createRepository: self 
! !

!MetacelloRepositorySpec methodsFor:'merging'!

mergeMap

	| map |
	map := super mergeMap.
	map at: #description put: description.
	map at: #type put: type.
	map at: #username put: username.
	map at: #password put: password.
	^map
! !

!MetacelloRepositorySpec methodsFor:'printing'!

configMethodCascadeOn: aStream lastCascade: lastCascade

	aStream nextPutAll: 'repository: ', self description printString.
	(self username isEmpty not or: [ self password isEmpty not ])
		ifTrue: [ aStream nextPutAll: ' username: ', self username printString, ' password: ', self password printString ].
	lastCascade ifFalse: [ aStream nextPut: $;; cr ].
!

configMethodOn: aStream indent: indent

	aStream 
		tab: indent; 
		nextPutAll: 'spec '.
	self configMethodCascadeOn: aStream lastCascade: true
! !

!MetacelloRepositorySpec methodsFor:'private'!

extractTypeFromDescription

	^MetacelloPlatform current extractTypeFromDescription: self description
!

mergeIntoMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec mergeMember 
			name: self name;
			spec: self;
			yourself)
!

removeFromMetacelloRepositories: aMetacelloRepositoriesSpec

	aMetacelloRepositoriesSpec addMember: 
		(aMetacelloRepositoriesSpec removeMember 
			name: self name;
			spec: self;
			yourself)
! !

!MetacelloRepositorySpec methodsFor:'querying'!

description

	^description
!

name

	^self description
!

password

	password == nil ifTrue: [ password := '' ].
	^password
!

type

	type == nil ifTrue: [ type := self extractTypeFromDescription ].
	^type
!

username

	username == nil ifTrue: [ username := '' ].
	^username
! !

!MetacelloRepositorySpec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloRepositorySpec.st,v 1.1 2011/08/20 17:56:29 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloRepositorySpec.st,v 1.1 2011/08/20 17:56:29 cg Exp $'
! !
