"{ Package: 'stx:goodies/metacello' }"

TestCase subclass:#MetacelloToolBoxAPITestCase
	instanceVariableNames:'tempRepositories'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-TestsMC'
!

MetacelloToolBoxAPITestCase comment:''
!


!MetacelloToolBoxAPITestCase methodsFor:'accessing'!

tempRepositories

	tempRepositories ifNil: [ tempRepositories := OrderedCollection new ].
	^tempRepositories
! !

!MetacelloToolBoxAPITestCase methodsFor:'private'!

alternatRepositoryName

	^#'Metacello_Dev_Cycle_Alternate_Repository'
!

baseline11SourceString

	^'baseline11: spec
	<version: ''1.1-baseline''>

	spec for: #''common'' do: [
		spec blessing: #''baseline''.
		spec repository: ''dictionary://Metacello_Dev_Cycle_Repository''.
		spec project: ''MetacelloTestConfigurationOfFoo'' with: [
				spec
					className: ''MetacelloTestConfigurationOfFoo'';
					versionString: #''bleedingEdge'';
					repository: ''cache'' ].
		spec 
			package: ''GeauxFaux'' with: [
				spec requires: #(''MetacelloTestConfigurationOfFoo'' ). ];
			package: ''GeauxBeau'' with: [
				spec requires: #(''GeauxFaux'' ). ].
		spec 
			group: ''default'' with: #(''Core'' );
			group: ''Core'' with: #(''GeauxFaux'' );
			group: ''Tests'' with: #(''GeauxBeau'' );
			group: ''Core Tests'' with: #(''Core'' ''Tests'' ). ].

	spec for: #''pharo'' do: [
		spec 
			package: ''GoferFoo'';
			package: ''GoferBar'' with: [
				spec requires: #(''GoferFoo'' ). ].
		spec group: ''UI'' with: #(''GoferBar'' ). ].
'
!

baseline12SourceString

	^'baseline12: spec
	<version: ''1.2-baseline''>

	spec for: #''common'' do: [
		spec blessing: #''baseline''.
		spec repository: ''dictionary://Metacello_Dev_Cycle_Repository''.
		spec project: ''MetacelloTestConfigurationOfFoo'' with: [
				spec
					className: ''MetacelloTestConfigurationOfFoo'';
					versionString: #''bleedingEdge'';
					repository: ''cache'' ].
		spec 
			package: ''GeauxFaux'' with: [
				spec requires: #(''MetacelloTestConfigurationOfFoo'' ). ];
			package: ''GeauxBeau'' with: [
				spec requires: #(''GeauxFaux'' ). ].
		spec 
			group: ''default'' with: #(''Core'' );
			group: ''Core'' with: #(''GeauxFaux'' );
			group: ''Tests'' with: #(''GeauxBeau'' );
			group: ''Core Tests'' with: #(''Core'' ''Tests'' ).

		spec for: #''nested'' do: [
			spec 
				package: ''GoferFoo'';
				package: ''GoferBar'' with: [
					spec requires: #(''GoferFoo'' ). ].
			spec group: ''UI'' with: #(''GoferBar'' ). ]. ].

	spec for: #''nested'' do: [
		spec 
			package: ''GoofyFoo'';
			package: ''GoofyBar'' with: [
				spec requires: #(''GoofyFoo'' ). ].
		spec group: ''UI'' with: #(''GoofyBar'' ). ].

	spec for: #''outer'' do: [
		spec 
			package: ''DaffyFoo'';
			package: ''DaffyBar'' with: [
				spec requires: #(''DaffyFoo'' ). ].
		spec group: ''UI'' with: #(''DaffyBar'' ).

		spec for: #''nested'' do: [
			spec 
				package: ''GoofyFoo'';
				package: ''GoofyBar'' with: [
					spec requires: #(''GoofyFoo'' ). ].
			spec group: ''UI'' with: #(''GoofyBar'' ). ]. ].
'
!

complexBaseline11SourceString

	^ 'baseline11: spec
	<version: ''1.1-baseline''>

	spec for: #''common'' do: [
		spec blessing: #''baseline''.
		spec repository: ''dictionary://Metacello_Dev_Cycle_Repository''.
		spec project: ''MetacelloTestConfigurationOfFoo'' with: [
				spec
					className: ''MetacelloTestConfigurationOfFoo'';
					versionString: #''bleedingEdge'';
					repository: ''cache'' ].
		spec 
			package: ''GeauxFaux'' with: [
				spec 
					requires: #(''MetacelloTestConfigurationOfFoo'' );
					includes: #(''GoferFaux'' ). ];
			package: ''GeauxBeau'' with: [
				spec requires: #(''GeauxFaux'' ). ];
			package: ''GoferBar'' with: [
				spec 
					repositories: [
						spec
							repository: ''http://example.com/repo1'';
							repository: ''http://example.com/repo2'' ];
					preLoadDoIt: #''preloadGoferBar''. ];
			package: ''GoferBeau'' with: [
				spec 
					supplyingAnswers: #( #( ''list of packages'' ''Kernel* Collection*'' ) );
					file: ''GoferBeau.pharo'';
					postLoadDoIt: #''postloadGoferBar''. ];
			package: ''GoferFaux'' with: [
				spec repository: ''http://example.com/repo2''. ].
		spec 
			group: ''default'' with: #(''Core'' );
			group: ''Core'' with: #(''GeauxFaux'' );
			group: ''Tests'' with: #(''GeauxBeau'' );
			group: ''Core Tests'' with: #(''Core'' ''Tests'' ). ].
'
!

complexBaseline11SourceString2

	^ 'baseline11: spec
	<version: ''1.1-baseline''>

	spec for: #''common'' do: [
		spec blessing: #''baseline''.
		spec repository: ''dictionary://Metacello_Dev_Cycle_Repository''.
		spec project: ''MetacelloTestConfigurationOfFoo'' with: [
				spec
					className: ''MetacelloTestConfigurationOfFoo'';
					versionString: #''bleedingEdge'';
					repository: ''cache'' ].
		spec 
			package: ''GeauxFaux'' with: [
				spec 
					requires: #(''MetacelloTestConfigurationOfFoo'' ''GoferFoo'' );
					includes: #(''GoferFaux'' ). ];
			package: ''GeauxBeau'' with: [
				spec requires: #(''GeauxFaux'' ). ];
			package: ''GoferBar'' with: [
				spec 
					repositories: [
						spec
							repository: ''http://example.com/repo1'';
							repository: ''http://example.com/repo2'' ];
					preLoadDoIt: #''preloadGoferBar''. ];
			package: ''GoferBeau'' with: [
				spec 
					supplyingAnswers: #( #( ''list of packages'' ''Kernel* Collection*'' ) );
					file: ''GoferBeau.pharo'';
					postLoadDoIt: #''postloadGoferBar''. ];
			package: ''GoferFaux'' with: [
				spec repository: ''http://example.com/repo2''. ];
			package: ''GoferFoo''.
		spec 
			group: ''default'' with: #(''Core'' );
			group: ''Core'' with: #(''GeauxFaux'' );
			group: ''Tests'' with: #(''GeauxBeau'' );
			group: ''Core Tests'' with: #(''Core'' ''Tests'' ). ].
'
!

configurationName

	^#'ConfigurationOfMetacello_Dev_Cycle'
!

hasPackage: aString
	| package |
	package := MCWorkingCopy allManagers
		detect: [ :each | each packageName = aString ]
		ifNone: [ nil ].
	^ package notNil
!

projectSourceString

	^'project
	| constructor |
	project := MetacelloMCProject new.
	project projectAttributes: MetacelloConfigurationResource projectAttributes.
	MetacelloVersionConstructor on: self project: project.
	project loadType: #linear.
	^project
'
!

repositoryName

	^#'Metacello_Dev_Cycle_Repository'
!

version10SourceString

	^'version10: spec
	<version: ''1.0'' imports: #(''1.0-baseline'' )>

	spec for: #''common'' do: [
		spec blessing: #''development''.
		spec project: ''MetacelloTestConfigurationOfFoo'' with: ''4.0''.
		spec 
			package: ''GeauxFaux'' with: ''GeauxFaux-tg.32'';
			package: ''GeauxBeau'' with: ''GeauxBeau-dkh.55''. ].
'
!

version12SourceString

	^'version12: spec
	<version: ''1.2'' imports: #(''1.2-baseline'' )>

	spec for: #''common'' do: [
		spec blessing: #''development''.
		spec project: ''MetacelloTestConfigurationOfFoo'' with: ''4.0''.
		spec 
			package: ''GeauxFaux'' with: ''GeauxFaux-tg.32'';
			package: ''GeauxBeau'' with: ''GeauxBeau-dkh.55''.

		spec for: #''nested'' do: [
			spec description: ''nested for:do: section''.
			spec 
				package: ''GoferFoo'' with: ''GoferFoo-lr.1'';
				package: ''GoferBar'' with: ''GoferBar.branch-lr.2''. ]. ].

	spec for: #''nested'' do: [
		spec 
			package: ''GoofyFoo'' with: ''GoofyFoo'';
			package: ''GoofyBar'' with: ''GoofyBar''. ].

	spec for: #''outer'' do: [
		spec 
			package: ''DaffyFoo'' with: '''';
			package: ''DaffyBar'' with: ''''.

		spec for: #''nested'' do: [
			spec 
				package: ''GoofyFoo'' with: '''';
				package: ''GoofyBar'' with: ''''. ]. ].
'
! !

!MetacelloToolBoxAPITestCase methodsFor:'running'!

runCase
	| original |
	original := MetacelloPlatform current bypassGoferLoadUpdateCategories.
	[ 
	MetacelloPlatform current bypassGoferLoadUpdateCategories: true.
	^ SystemChangeNotifier uniqueInstance doSilently: [ super runCase ] ]
		ensure: [ MetacelloPlatform current bypassGoferLoadUpdateCategories: original ]
!

setUp
	| repo gofer |
	super setUp.
	repo := MCDictionaryRepository new.
	repo description: 'dictionary://', self repositoryName asString.
	self tempRepositories add: repo.
	Smalltalk at: self repositoryName put: repo.
	repo := MCDictionaryRepository new.
	repo description: 'dictionary://', self alternatRepositoryName asString.
	self tempRepositories add: repo.
	Smalltalk at: self alternatRepositoryName put: repo.
	Smalltalk at: self configurationName ifPresent: [:cl | cl removeFromSystem ].

	repo := MetacelloConfigurationResource current monticelloRepository.
	self tempRepositories add: repo.
	Smalltalk at: #'Metacello_Configuration_Test_Repository' put: repo.
	gofer := Gofer new
		repository: repo;
		package: 'MetacelloTestConfigurationOfProjectFee'; 
		metacelloLoad.
	repo := MetacelloMonticelloResource current monticelloRepository.
	repo description: 'dictionary://Metacello_Gofer_Test_Repository'.
	self tempRepositories add: repo.
	Smalltalk at: #'Metacello_Gofer_Test_Repository' put: repo.

	(Smalltalk at: #MetacelloTestConfigurationOfProjectFee) new project load: '4.0'.
!

tearDown
	| aGofer |
	super tearDown.
	aGofer := Gofer new.
	self tearDownPackages: aGofer.
	aGofer references notEmpty ifTrue: [ aGofer metacelloUnload ].
	Smalltalk removeKey: self repositoryName ifAbsent: [  ].
	Smalltalk removeKey: self alternatRepositoryName  ifAbsent: [  ].
	Smalltalk removeKey: #'Metacello_Gofer_Test_Repository' ifAbsent: [].
	Smalltalk removeKey: #'Metacello_Configuration_Test_Repository' ifAbsent: [].
	Smalltalk at: self configurationName ifPresent: [ :cl | cl removeFromSystem ].
	self tempRepositories do: [:repo | MCRepositoryGroup default removeRepository: repo ].
	(self hasPackage: self configurationName asString)
		ifTrue: [ 
			(Gofer new)
				package: self configurationName asString;
				metacelloUnload ].
	MetacelloConfigurationResource projectAttributes: nil.
!

tearDownPackages: aGoferInstance

	(self hasPackage: 'GoferFoo')
		ifTrue: [ aGoferInstance package: 'GoferFoo' ].
	(self hasPackage: 'GoferBar')
		ifTrue: [ aGoferInstance package: 'GoferBar' ].
	(self hasPackage: 'GoferFaux')
		ifTrue: [ aGoferInstance package: 'GoferFaux' ].
	(self hasPackage: 'GoferBeau')
		ifTrue: [ aGoferInstance package: 'GoferBeau' ].
	(self hasPackage: 'GeauxFaux')
		ifTrue: [ aGoferInstance package: 'GeauxFaux' ].
	(self hasPackage: 'GeauxBeau')
		ifTrue: [ aGoferInstance package: 'GeauxBeau' ].
	(self hasPackage: 'MetacelloTestConfigurationOfFoo')
		ifTrue: [ aGoferInstance package: 'MetacelloTestConfigurationOfFoo' ].
	(self hasPackage: 'MetacelloTestConfigurationOfProjectFee')
		ifTrue: [ aGoferInstance package: 'MetacelloTestConfigurationOfProjectFee' ].
! !

!MetacelloToolBoxAPITestCase methodsFor:'tests'!

testAddNestedSection2
	"Add nested section as addition to existing version"

	| source |
	self createNested12Baseline.
	self assert: (source := ((Smalltalk at: self configurationName) sourceCodeAt: #baseline12:) asString) = self baseline12SourceString
!

testAddSection1
	"Add section as part of creating a new version"

	| toolbox |
	self create10Baseline.
	(toolbox := MetacelloToolBox configurationNamed: self configurationName asString)
		createVersionMethod: 'baseline11:' inCategory: 'baselines' forVersion: '1.1-baseline';
		addSectionsFrom: '1.0-baseline'
			forBaseline: true
			updateProjects: false
			updatePackages: false
			versionSpecsDo: [ :attribute :versionSpec | true ];
		addSection: #pharo
			repository: nil
			requiredProjects: #()
			packages: #('GoferFoo' 'GoferBar')
			dependencies: {('GoferBar' -> #('GoferFoo'))}
			groups: {('UI' -> #('GoferBar'))}
			versionSpecsDo: [ :versionSpec |  ];
		commitMethod.
	self assert: ((Smalltalk at: self configurationName) sourceCodeAt: #'baseline11:') = self baseline11SourceString
!

testAddSection2
	"Add section as addition to existing version"

	| toolbox |
	self create10Baseline.
	(toolbox := MetacelloToolBox configurationNamed: self configurationName asString)
		createVersionMethod: 'baseline11:' inCategory: 'baselines' forVersion: '1.1-baseline';
		addSectionsFrom: '1.0-baseline'
			forBaseline: true
			updateProjects: false
			updatePackages: false
			versionSpecsDo: [ :attribute :versionSpec | true ];
		commitMethod.
	toolbox
		modifyVersionMethodForVersion: '1.1-baseline';
		addSection: #pharo
			repository: nil
			requiredProjects: #()
			packages: #('GoferFoo' 'GoferBar')
			dependencies: {('GoferBar' -> #('GoferFoo'))}
			groups: {('UI' -> #('GoferBar'))}
			versionSpecsDo: [ :versionSpec |  ];
		commitMethod.
	self assert: ((Smalltalk at: self configurationName) sourceCodeAt: #'baseline11:') = self baseline11SourceString
!

testComplexCreateBaseline

	self createComplex11Baseline.
	self assert: ((Smalltalk at: self configurationName) sourceCodeAt: #baseline11:) = self complexBaseline11SourceString
!

testComplexModifyBaseline
	self createComplex11Baseline.
	MetacelloToolBox
		modifyVersion: '1.1-baseline'
		section: #common
		for: self configurationName asString
		repository: nil
		requiredProjects: #()
		packages: #('GoferFoo')
		dependencies: {'GeauxFaux' -> #('GoferFoo').}
		includes: #()
		files: #()
		repositories: #()
		preLoadDoIts: #()
		postLoadDoIts: #()
		supplyingAnswers: #()
		groups: #().
	self assert: ((Smalltalk at: self configurationName) sourceCodeAt: #baseline11:) = self complexBaseline11SourceString2
!

testComplexNullModifyBaseline
	self createComplex11Baseline.
	MetacelloToolBox
		modifyVersion: '1.1-baseline'
		section: #common
		for: self configurationName asString
		repository: nil
		requiredProjects: #()
		packages: #()
		dependencies: #()
		includes: #()
		files: #()
		repositories: #()
		preLoadDoIts: #()
		postLoadDoIts: #()
		supplyingAnswers: #()
		groups: #().
	self assert: ((Smalltalk at: self configurationName) sourceCodeAt: #baseline11:) = self complexBaseline11SourceString
!

testImportFrom1
	| toolbox |
	self create10Baseline.
	(toolbox := MetacelloToolBox configurationNamed: self configurationName asString)
		createVersionMethod: 'version10:' inCategory: 'versions' forVersion: '1.0';
		importFrom: '1.0-baseline' 
		updateProjects: true 
		updatePackages: true 
		versionSpecsDo: [ :attributeOrPath :versionSpec | 
			attributeOrPath == #common
				ifTrue: [ versionSpec blessing: #development ].
			true ];
		commitMethod.
	self assert: ((Smalltalk at: self configurationName) sourceCodeAt: #'version10:') = self version10SourceString
!

testImportFrom2
	| toolbox source |
	self createNested12Baseline.
	(toolbox := MetacelloToolBox configurationNamed: self configurationName asString)
		createVersionMethod: 'version12:' inCategory: 'versions' forVersion: '1.2';
		importFrom: '1.2-baseline' 
		updateProjects: true 
		updatePackages: true 
		versionSpecsDo: [ :attributeOrPath :versionSpec | 
			attributeOrPath == #common
				ifTrue: [ versionSpec blessing: #development ].
			attributeOrPath = #(common nested)
				ifTrue: [ versionSpec description: 'nested for:do: section' ].
			true ];
		commitMethod.
	self assert: (source := ((Smalltalk at: self configurationName) sourceCodeAt: #'version12:') asString) = self version12SourceString
!

testReasonCodes

	self assert: (MetacelloToolBox descriptionForValidationReasonCode: #noVersionSpecified) = 'no version defined for the project reference or package. The version specified in the baseline or the latest version of the project or package in the repository will be used.'.
	self assert: (MetacelloToolBox descriptionForValidationReasonCode: #duplicateNames) = 'multiple independent definitions for an entity with same name (project, package, or group).'.
! !

!MetacelloToolBoxAPITestCase methodsFor:'utility'!

create10Baseline

	MetacelloToolBox
		createBaseline: '1.0-baseline'
		for: self configurationName asString
		repository: 'dictionary://', self repositoryName asString
		requiredProjects: #('MetacelloTestConfigurationOfFoo')
		packages: #('GeauxFaux' 'GeauxBeau')
		dependencies:
			{('GeauxFaux' -> #('MetacelloTestConfigurationOfFoo')).
			('GeauxBeau' -> #('GeauxFaux'))}
		groups:
			{('default' -> #('Core')).
			('Core' -> #('GeauxFaux')).
			('Tests' -> #('GeauxBeau')).
			('Core Tests' -> #('Core' 'Tests'))}.
!

createComplex11Baseline

	MetacelloToolBox
		createBaseline: '1.1-baseline'
		for: self configurationName asString
		repository: 'dictionary://' , self repositoryName asString
		requiredProjects: #('MetacelloTestConfigurationOfFoo')
		packages: #('GeauxFaux' 'GeauxBeau' 'GoferBar' 'GoferBeau' 'GoferFaux' )
		dependencies:
			{('GeauxFaux' -> #('MetacelloTestConfigurationOfFoo')).
			('GeauxBeau' -> #('GeauxFaux'))}
		includes: {('GeauxFaux' -> #('GoferFaux'))}
		files: {('GoferBeau' -> 'GoferBeau.pharo')}
		repositories: {('GoferBar' -> #('http://example.com/repo1' 'http://example.com/repo2')). ('GoferFaux' -> #('http://example.com/repo2'))}
		preLoadDoIts: {('GoferBar' -> #preloadGoferBar)}
		postLoadDoIts: {('GoferBeau' -> #postloadGoferBar)}
		supplyingAnswers: {'GoferBeau' -> {{ 'list of packages'. 'Kernel* Collection*' }}.}
		groups:
			{('default' -> #('Core')).
			('Core' -> #('GeauxFaux')).
			('Tests' -> #('GeauxBeau')).
			('Core Tests' -> #('Core' 'Tests'))}.
!

createNested12Baseline

	MetacelloConfigurationResource projectAttributes: #( nested ).
	self create10Baseline.
	(Smalltalk at: self configurationName) compile: self projectSourceString classified: 'cat'.
	(MetacelloToolBox configurationNamed: self configurationName asString)
		createVersionMethod: 'baseline12:' inCategory: 'baselines' forVersion: '1.2-baseline';
		addSectionsFrom: '1.0-baseline'
			forBaseline: true
			updateProjects: false
			updatePackages: false
			versionSpecsDo: [ :attribute :versionSpec | true ];
		commitMethod;
		modifyVersionMethodForVersion: '1.2-baseline';
		addSection: #( common nested)
			repository: nil
			requiredProjects: #()
			packages: #('GoferFoo' 'GoferBar')
			dependencies: {('GoferBar' -> #('GoferFoo'))}
			groups: {('UI' -> #('GoferBar'))}
			versionSpecsDo: [ :versionSpec |  ];
		addSection: #nested
			repository: nil
			requiredProjects: #()
			packages: #('GoofyFoo' 'GoofyBar')
			dependencies: {('GoofyBar' -> #('GoofyFoo'))}
			groups: {('UI' -> #('GoofyBar'))}
			versionSpecsDo: [ :versionSpec |  ];
		addSection: #outer
			repository: nil
			requiredProjects: #()
			packages: #('DaffyFoo' 'DaffyBar')
			dependencies: {('DaffyBar' -> #('DaffyFoo'))}
			groups: {('UI' -> #('DaffyBar'))}
			versionSpecsDo: [ :versionSpec |  ];
		addSection: #(outer nested)
			repository: nil
			requiredProjects: #()
			packages: #('GoofyFoo' 'GoofyBar')
			dependencies: {('GoofyBar' -> #('GoofyFoo'))}
			groups: {('UI' -> #('GoofyBar'))}
			versionSpecsDo: [ :versionSpec |  ];
		commitMethod.
! !

!MetacelloToolBoxAPITestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloToolBoxAPITestCase.st,v 1.1 2011/08/20 17:58:09 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloToolBoxAPITestCase.st,v 1.1 2011/08/20 17:58:09 cg Exp $'
! !
