"{ Package: 'stx:goodies/metacello' }"

TestCase subclass:#MetacelloTutorialTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* obsolete *'
!

MetacelloTutorialTestCase comment:''
!


!MetacelloTutorialTestCase methodsFor:'private'!

project

	^MetacelloTutorialConfig project
!

projectRefProject

	^MetacelloProjectRefTutorialConfig project
! !

!MetacelloTutorialTestCase methodsFor:'tests'!

test01

	| project versionSpec |
	project := self project.

	versionSpec := (project version: '0.1') spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core-anon.8'.
	self assert: versionSpec packages map keys size = 1.
	self assert: (versionSpec packages map at: 'Example-Core') repositorySpecs first description = 'http://www.example.com/Example'
!

test02

	| project versionSpec |
	project := self project.

	versionSpec := (project version: '0.2') spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core-anon.9'.
	self assert: versionSpec packages map keys size = 1.
	self assert: (versionSpec packages map at: 'Example-Core') repositorySpecs first description = 'http://www.example.com/Example'
!

test03

	| project versionSpec |
	project := self project.

	versionSpec := (project version: '0.3') spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core-anon.10'.
	self assert: (versionSpec packages map at: 'Example-Tests') file = 'Example-Tests-anon.3'.
	self assert: versionSpec packages map keys size = 2.
	self assert: (versionSpec packages map at: 'Example-Core') repositorySpecs first description = 'http://www.example.com/Example'
!

test04

	| project versionSpec |
	project := self project.

	versionSpec := (project version: '0.4') spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core-anon.10'.
	self assert: (versionSpec packages map at: 'Example-Tests') file = 'Example-Tests-anon.3'.
	self assert: versionSpec packages map keys size = 2.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'
!

test05

	| project versionSpec |
	project := self project.

	versionSpec := (project version: '0.5') spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core-anon.11'.
	self assert: (versionSpec packages map at: 'Example-Tests') file = 'Example-Tests-anon.3'.
	self assert: (versionSpec packages map at: 'Example-AddOn') file = 'Example-AddOn-anon.1'.
	self assert: versionSpec packages map keys size = 3.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'
!

test06

	| project versionSpec loadedPackages loader |
	project := self project.

	versionSpec := (project version: '0.6') spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core-anon.12'.
	self assert: (versionSpec packages map at: 'Example-Tests') file = 'Example-Tests-anon.3'.
	self assert: (versionSpec packages map at: 'Example-AddOn') file = 'Example-AddOn-anon.1'.
	self assert: versionSpec packages map keys size = 3.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := (project version: '0.6') load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.12') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.3') >
						(loadedPackages indexOf: 'Example-Core-anon.12').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.12').
!

test07

	| project versionSpec loadedPackages version loader |
	project := self project.

	version := project version: '0.7'.
	self assert: version blessing == #baseline.
	versionSpec := version spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core-anon.12'.
	self assert: (versionSpec packages map at: 'Example-Tests') file = 'Example-Tests-anon.3'.
	self assert: (versionSpec packages map at: 'Example-AddOn') file = 'Example-AddOn-anon.1'.
	self assert: versionSpec packages map keys size = 3.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.12') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.3') >
						(loadedPackages indexOf: 'Example-Core-anon.12').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.12').
!

test07a

	| project versionSpec loadedPackages version loader |
	project := self project.

	version := project version: '0.7-baseline'.
	self assert: version blessing == #baseline.
	versionSpec := version spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core'.
	self assert: (versionSpec packages map at: 'Example-Tests') file = 'Example-Tests'.
	self assert: (versionSpec packages map at: 'Example-AddOn') file = 'Example-AddOn'.
	self assert: versionSpec packages map keys size = 3.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'Example-Core') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests') >
						(loadedPackages indexOf: 'Example-Core').
	self assert: (loadedPackages indexOf: 'Example-AddOn') >
						(loadedPackages indexOf: 'Example-Core').
!

test08

	| project versionSpec loadedPackages version loader |
	project := self project.

	version := project version: '0.8'.
	self assert: version blessing == #baseline.
	versionSpec := version spec.
	self assert: (versionSpec packages map includesKey: 'Example-Core').
	self assert: (versionSpec packages map at: 'Example-Core') file = 'Example-Core-anon.15'.
	self assert: (versionSpec packages map at: 'Example-Tests') file = 'Example-Tests-anon.6'.
	self assert: (versionSpec packages map at: 'Example-AddOn') file = 'Example-AddOn-anon.2'.
	self assert: versionSpec packages map keys size = 3.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 3.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.15') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.6') >
						(loadedPackages indexOf: 'Example-Core-anon.15').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.2') >
						(loadedPackages indexOf: 'Example-Core-anon.15').
!

test10a

	| project versionSpec loadedPackages version loader |
	project := self project.

	version := project version: '1.0'.
	self assert: version blessing == #baseline.
	versionSpec := version spec.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 2.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.14') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.3') = 0.
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') = 0.
	
!

test10b

	| project versionSpec loadedPackages version loader |
	project := self project.

	version := project version: '1.0'.
	self assert: version blessing == #baseline.
	versionSpec := version spec.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load: 'ALL'.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 4.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.14') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.3') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.3').
!

test10c

	| project versionSpec loadedPackages version loader |
	project := self project.

	version := project version: '1.0'.
	self assert: version blessing == #baseline.
	versionSpec := version spec.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load: 'Tests'.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 4.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.14') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.3') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.3').
!

test10d

	| project versionSpec loadedPackages version loader |
	project := self project.

	version := project version: '1.0'.
	self assert: version blessing == #baseline.
	versionSpec := version spec.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load: { 'Example-Tests'. 'Example-AddOnTests'. }.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 4.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.14') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.3') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.3').
!

test11

	| project versionSpec loadedPackages version loader |
	project := self project.

	version := project version: '1.1'.
	self assert: version blessing == #development.
	versionSpec := version spec.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load: 'ALL'.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 4.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.15') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.4') >
						(loadedPackages indexOf: 'Example-Core-anon.15').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.15').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.4').
!

test11Author
	| project |
	project := self project.

	self assert: ((project version: '1.1') author) = 'dkh'.
!

test11Blessing
	| project |
	project := self project.

	self assert: ((project version: '1.1') blessing) == #development.
	self assert: ((project version: '0.5') blessing) == #release.
	self assert: ((project version: '1.0-baseline') blessing) == #baseline.
	self assert: (project latestVersion: #release) versionString = '0.6'. 
!

test11Descripton
	| project |
	project := self project.

	self assert: ((project version: '1.1') description) = 'Example of a complete version specification'.
!

test11Timestamp
	| project |
	project := self project.

	self assert: ((project version: '1.1') timestamp) = '10/12/2009 09:26'.
!

test12
	| project versionSpec |
	project := self project.

	versionSpec := (project version: '1.2') spec.
	self assert: (versionSpec packages map at: 'Example-Core') preLoadDoIt value == #preloadForCore.
	self assert: (versionSpec packages map at: 'Example-Core') postLoadDoIt value == #postloadForCore:package:.

	(project version: '1.2') load "execute without error"
!

test13

	| project versionSpec loadedPackages version platformPackage loader |
	project := self project.

	version := project version: '1.3'.
	self assert: version blessing == #development.
	versionSpec := version spec.
	self assert: (versionSpec repositories map at: 'http://www.example.com/Example') description = 'http://www.example.com/Example'.

	loader := version load: 'ALL'.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 5.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.17') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.6') >
						(loadedPackages indexOf: 'Example-Core-anon.17').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.17').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.6').
	platformPackage := loadedPackages detect: [:pkgName | pkgName beginsWith: 'Example-Platform'].
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.6') >
						(loadedPackages indexOf: platformPackage).
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: platformPackage).
	self assert: (loadedPackages indexOf: platformPackage) >
						(loadedPackages indexOf: 'Example-Core-anon.17').
! !

!MetacelloTutorialTestCase methodsFor:'tests-project ref'!

testProjectRef07

	| project loadedPackages loader |
	project := self projectRefProject.

	loader := (project version: '0.7') load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 5.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.12') > 0.
	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-Core-anon.12').
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.3') >
						(loadedPackages indexOf: 'Example-Core-anon.12').
	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') >
						(loadedPackages indexOf: 'Project-Core-anon.1').
	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.3').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.12').
!

testProjectRef10

	| project loadedPackages loader |
	project := self projectRefProject.

	loader := (project version: '1.0') load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 7.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.14') > 0.
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.3') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.11').


	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-Core-anon.14').
	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-Tests-anon.3').
	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-AddOnTests-anon.1').

	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') > 
						(loadedPackages indexOf: 'Project-Core-anon.1').
!

testProjectRef11

	| project loadedPackages loader |
	project := self projectRefProject.

	loader := (project version: '1.1') load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 8.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.15') > 0.
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.15').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.4') >
						(loadedPackages indexOf: 'Example-Core-anon.15').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.4').


	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-Core-anon.15').
	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-AddOn-anon.1').

	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') > 
						(loadedPackages indexOf: 'Project-Core-anon.1').
	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.4').
	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOnTests-anon.1').
!

testProjectRef12

	| project loadedPackages loader |
	project := self projectRefProject.

	loader := (project version: '1.2') load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 8.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.16') > 0.
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.16').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.5') >
						(loadedPackages indexOf: 'Example-Core-anon.16').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.5').


	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-Core-anon.16').
	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-AddOn-anon.1').

	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') > 
						(loadedPackages indexOf: 'Project-Core-anon.1').
	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.5').
	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOnTests-anon.1').
!

testProjectRef13

	| project loadedPackages loader platformPackage |
	project := self projectRefProject.

	loader := (project version: '1.3') load.
	loadedPackages := loader loadedPackages asArray. 
	self assert: loadedPackages size = 9.
	self assert: (loadedPackages indexOf: 'Example-Core-anon.17') > 0.
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: 'Example-Core-anon.17').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOn-anon.1').
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.6') >
						(loadedPackages indexOf: 'Example-Core-anon.17').
	self assert: (loadedPackages indexOf: 'Example-AddOnTests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.6').
	platformPackage := loadedPackages detect: [:pkgName | pkgName beginsWith: 'Example-Platform'].
	self assert: (loadedPackages indexOf: 'Example-Tests-anon.6') >
						(loadedPackages indexOf: platformPackage).
	self assert: (loadedPackages indexOf: 'Example-AddOn-anon.1') >
						(loadedPackages indexOf: platformPackage).
	self assert: (loadedPackages indexOf: platformPackage) >
						(loadedPackages indexOf: 'Example-Core-anon.17').


	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-Core-anon.17').
	self assert: (loadedPackages indexOf: 'Project-Core-anon.1') > 
						(loadedPackages indexOf: 'Example-AddOn-anon.1').

	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') > 
						(loadedPackages indexOf: 'Project-Core-anon.1').
	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') >
						(loadedPackages indexOf: 'Example-Tests-anon.6').
	self assert: (loadedPackages indexOf: 'Project-Tests-anon.1') >
						(loadedPackages indexOf: 'Example-AddOnTests-anon.1').
!

testProjectRef14

	| project version string |
	project := self projectRefProject.
	version := project version: '1.4'.
	
	self shouldnt: [ version packages ] raise: Error.
	self shouldnt: [ version projects ] raise: Error.
	self shouldnt: [ version groups ] raise: Error.

	string := (version packageNamed: 'Project-Core') printString.
	self assert: string = 'spec 
	name: ''Project-Core'';
	requires: #(''Example Default'' );
	includes: #(''Project-Extra'' );
	file: ''Project-Core-anon.2''.'.

	string := (version packageNamed: 'Example Default') printString.
	self assert: string = 'spec 
	name: ''Example Default'';
	className: ''MetacelloTutorialConfig'';
	versionString: ''1.3'';
	loads: #(''default'' );
	file: ''Metacello-Tutorial'';
	repository: ''http://seaside.gemstone.com/ss/metacello''.'.

	string := (version packageNamed: 'Core') printString.
	self assert: string = 'spec 
	name: ''Core'';
	includes: #(''default'' ).'.

	self shouldnt: [ (version packageNamed: 'Project-Core') requires ] raise: Error.

	string := (version packageNamed: 'Example Default') repository printString.
	self assert: string = 'spec repository: ''http://seaside.gemstone.com/ss/metacello'''.

	self shouldnt: [ (version packageNamed: 'default') requires ] raise: Error.
	self shouldnt: [ version packagesForSpecNamed: 'Core' ] raise: Error.
	self shouldnt: [ version load: 'Core' ] raise: Error.
	self shouldnt: [ version allPackagesForSpecNamed: 'Core' ] raise: Error.
	self shouldnt: [ version load: 'Example Default' ] raise: Error.
	self shouldnt: [ version allPackagesForSpecNamed: 'Example Default' ] raise: Error.
	self shouldnt: [ (version packageNamed: 'Example Default') version ] raise: Error.
! !

!MetacelloTutorialTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloTutorialTestCase.st,v 1.1 2011/08/20 18:16:48 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloTutorialTestCase.st,v 1.1 2011/08/20 18:16:48 cg Exp $'
! !
