"{ Package: 'stx:goodies/metacello' }"

Object subclass:#MetacelloVisitedPackages
	instanceVariableNames:'groups packages projects'
	classVariableNames:''
	poolDictionaries:''
	category:'Metacello-MC-Specs'
!

MetacelloVisitedPackages comment:''
!


!MetacelloVisitedPackages methodsFor:'initialize-release'!

initialize

	groups := Set new.
	packages := Set new.
	projects := Set new.
! !

!MetacelloVisitedPackages methodsFor:'visiting'!

pushProject: aBlock

	| oldGroups oldPackages oldProjects |
	oldGroups := groups.
	oldPackages := packages.
	oldProjects := projects.
	groups := Set new.
	packages := Set new.
	^aBlock ensure: [
		groups := oldGroups.
		packages := oldPackages.
		projects := oldProjects ]
!

visit: aSpec doing: aBlock

	aSpec
		projectDo: [:spec | 
			(projects includes: spec name) ifTrue: [ ^self ].
			projects add: spec name ] 
		packageDo: [:spec | 
			(packages includes: spec name) ifTrue: [ ^self ].
			packages add: spec name ] 
		groupDo: [:spec | 
			(groups includes: spec name) ifTrue: [ ^self ].
			groups add: spec name ].
	aBlock value: aSpec
! !

!MetacelloVisitedPackages class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloVisitedPackages.st,v 1.1 2011/08/20 18:13:11 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/MetacelloVisitedPackages.st,v 1.1 2011/08/20 18:13:11 cg Exp $'
! !
