"{ Package: 'stx:goodies/metacello' }"

LibraryDefinition subclass:#stx_goodies_metacello
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_metacello class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/gofer'    "GoferCleanup - superclass of MetacelloTestsGoferCleanup "
        #'stx:goodies/monticello'    "MCPackage - superclass of MetacelloTestsMCPackage "
        #'stx:goodies/sunit'    "TestAsserter - superclass of MetacelloGoferBasedLoaderTest "
        #'stx:libbasic'    "Object - superclass of MetacelloCleanLoadAndTestsNotification "
        #'stx:libbasic2'    "UUID - referenced by MetacelloConfigurationResource>>setUpConfigurationOfProjectIssue115dkh1 "
        #'stx:libbasic3'    "ChangeSet - referenced by MetacelloCleanUpChangeSetsTestCase>>testCleanUpChangeSets "
        #'stx:libcompat'    "CustomHelp - superclass of MetacelloAPIDocumentation "
    )
! !

!stx_goodies_metacello class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        MetacelloAbstractConstructor
        (MetacelloAlternateResource autoload)
        (MetacelloAtomicConfigurationResource autoload)
        (MetacelloAtomicMonticelloResource autoload)
        MetacelloBaseConfiguration
        MetacelloCachingGoferResolvedReference
        MetacelloCannotUpdateReleasedVersionError
        MetacelloCleanNotification
        (MetacelloCleanUpChangeSetsTestCase autoload)
        MetacelloClearStackCacheNotification
        (MetacelloConfigAbstractAPITestCase autoload)
        MetacelloConfigTemplate
        MetacelloConfigurationHelp
        (MetacelloConfigurationResource autoload)
        (MetacelloDevelopmentCycleTutorialTests autoload)
        (MetacelloDictionaryRepositoryTest autoload)
        MetacelloDirective
        MetacelloGofer
        MetacelloGoferCommit
        MetacelloGoferLoad
        MetacelloGoferPackage
        (MetacelloGoferPackageTestCase autoload)
        (MetacelloHTTPRepositoryLoadTestCase autoload)
        MetacelloHelp
        (MetacelloImportsTestCase autoload)
        (MetacelloIssue108Resource autoload)
        (MetacelloIssue108TestCase autoload)
        (MetacelloIssue115TestCase autoload)
        MetacelloLoadData
        (MetacelloLoadOrderTestCase autoload)
        MetacelloLoaderPolicy
        MetacelloMCPartiallyLoadedStatus
        MetacelloMCVersionDiffReport
        MetacelloMCVersionSpecLoader
        MetacelloMethodSection
        MetacelloMethodSpec
        (MetacelloMonticelloResource autoload)
        MetacelloPlatform
        (MetacelloPlatformAttributesTestCase autoload)
        MetacelloProject
        MetacelloProjectRefTutorialConfig
        MetacelloProjectSpecLoadError
        MetacelloReferenceConfig
        (MetacelloReferenceTestCase autoload)
        MetacelloSpec
        MetacelloSpecLoader
        MetacelloStackCacheNotification
        (MetacelloStackCacheTestCase autoload)
        MetacelloTestsGoferCleanup
        MetacelloTestsGoferUnload
        MetacelloTestsMCPackage
        MetacelloTestsPackageInfo
        MetacelloToolBox
        (MetacelloToolBoxAPITestCase autoload)
        MetacelloTutorialConfig
        (MetacelloTutorialTestCase autoload)
        MetacelloValidationIssue
        MetacelloValidationNotification
        MetacelloVersion
        MetacelloVersionDoesNotExistError
        MetacelloVersionNumber
        (MetacelloVersionNumberTestCase autoload)
        (MetacelloVersionQueryTestCase autoload)
        MetacelloVisitedPackages
        #'stx_goodies_metacello'
        MetacelloAPIDocumentation
        MetacelloAbstractPackageSpec
        MetacelloAbstractVersionConstructor
        (MetacelloAtomicLoadOrderTest autoload)
        MetacelloCleanLoadAndTestsNotification
        MetacelloCleanLoadNotification
        MetacelloCommonMCSpecLoader
        (MetacelloConfigAPITestCase autoload)
        (MetacelloConfigAPIToolBoxTestCase autoload)
        (MetacelloCurrentVersionTest autoload)
        (MetacelloDetermineCurrentVersionForLoadTest autoload)
        (MetacelloGoferBasedLoaderTest autoload)
        (MetacelloGoferFunctionalTest autoload)
        (MetacelloMCCachingLoaderTestCase autoload)
        MetacelloMCProject
        (MetacelloMCSpecLoaderTest autoload)
        MetacelloMCTestsAbstractConfig
        MetacelloMCVersion
        MetacelloMemberListSpec
        MetacelloMemberSpec
        MetacelloPackageLoadDirective
        MetacelloPrePostLoadDirective
        MetacelloProjectSpec
        MetacelloProjectSpecLoadConflict
        MetacelloRepositorySpec
        MetacelloSymbolicVersionDoesNotExistError
        MetacelloSymbolicVersionMethodSpec
        MetacelloSymbolicVersionSpec
        (MetacelloSymbolicVersionTest autoload)
        (MetacelloToolBoxConstructorTestCase autoload)
        MetacelloValidationCriticalWarning
        MetacelloValidationError
        MetacelloValidationWarning
        MetacelloValueHolderSpec
        MetacelloVersionLoadDirective
        MetacelloVersionMethodSection
        MetacelloVersionMethodSpec
        MetacelloVersionSpec
        MetacelloVersionValidator
        MetacelloAddMemberSpec
        MetacelloAtomicLoadDirective
        MetacelloCopyMemberSpec
        MetacelloExampleProjectConfig
        MetacelloExplicitLoadDirective
        MetacelloFetchingMCSpecLoader
        (MetacelloGoferBasedAtomicLoaderTest autoload)
        MetacelloGroupSpec
        MetacelloLinearLoadDirective
        MetacelloLoadingMCSpecLoader
        MetacelloMCProjectSpec
        MetacelloMCVersionSpec
        MetacelloMCVersionValidator
        MetacelloMergeMemberSpec
        MetacelloPackageSpec
        MetacelloPackagesSpec
        MetacelloPostLoadDirective
        MetacelloPreLoadDirective
        MetacelloProjectReferenceSpec
        MetacelloRemoveMemberSpec
        MetacelloRepositoriesSpec
        MetacelloSymbolicVersionNotDefinedError
        MetacelloToolBoxConstructor
        MetacelloVersionConstructor
        MetacelloVersionQueryExampleConfig
        MetacelloVersionQueryLatestVersionConfig
        MetacelloVersionQueryMasterConfig
        MetacelloVersionQueryMiscConfig
        MetacelloVersionQueryProjectConfig
        MetacelloNullRecordingMCSpecLoader
        MetacelloSTXPlatform
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Block setAuthorInMetacelloConfig:
        Block setBlessingInMetacelloConfig:
        Block setDescriptionInMetacelloConfig:
        Block setPackage:withInMetacelloConfig:
        Block setProject:withInMetacelloConfig:
        Block setTimestampInMetacelloConfig:
        Block valueSupplyingMetacelloAnswers:
        Collection addToMetacelloPackages:
        Collection addToMetacelloRepositories:
        Collection fetchRequiredForMetacelloMCVersion:
        Collection loadRequiredForMetacelloMCVersion:
        Collection mergeIntoMetacelloPackages:
        Collection mergeIntoMetacelloRepositories:
        Collection recordRequiredForMetacelloMCVersion:
        Collection removeFromMetacelloPackages:
        Collection removeFromMetacelloRepositories:
        Collection resolvePackageSpecsNamedForMetacelloMCVersion:visited:ifAbsent:
        Collection setIncludesInMetacelloPackage:
        Collection setLoadsInMetacelloProject:
        Collection setRequiresInMetacelloPackage:
        Gofer metacelloCleanup
        Gofer metacelloLoad
        Gofer metacelloUnload
        GoferResolvedReference asMetacelloCachingResolvedReference
        GoferResolvedReference compare:using:
        GoferVersionReference metacelloPackageNameWithBranch
        Integer metacelloIntegerLessThanSelf:
        Integer metacelloStringLessThanSelf:
        Integer metacelloVersionComponentLessThan:
        MCDictionaryRepository asRepositorySpecFor:
        MCDictionaryRepository versionInfoFromVersionNamed:
        MCDirectoryRepository asRepositorySpecFor:
        MCFileBasedRepository versionInfoFromVersionNamed:
        MCHttpRepository asRepositorySpecFor:
        MCRepository asRepositorySpecFor:
        MCWorkingCopy metacelloPackageNameWithBranch
        Object metacelloIntegerLessThanSelf:
        Object metacelloStringLessThanSelf:
        Object metacelloVersionComponentLessThan:
        String addToMetacelloPackages:
        String addToMetacelloRepositories:
        String asMetacelloVersionNumber
        String fetchRequiredForMetacelloMCVersion:
        String loadRequiredForMetacelloMCVersion:
        String mergeIntoMetacelloPackages:
        String mergeIntoMetacelloRepositories:
        String metacelloIntegerLessThanSelf:
        String metacelloStringLessThanSelf:
        String metacelloVersionComponentLessThan:
        String packageFileSpecFor:
        String recordRequiredForMetacelloMCVersion:
        String removeFromMetacelloPackages:
        String removeFromMetacelloRepositories:
        String resolvePackageSpecsNamedForMetacelloMCVersion:visited:ifAbsent:
        String setAuthorInMetacelloConfig:
        String setAuthorInMetacelloVersion:
        String setBlessingInMetacelloConfig:
        String setBlessingInMetacelloVersion:
        String setDescriptionInMetacelloConfig:
        String setDescriptionInMetacelloVersion:
        String setIncludesInMetacelloPackage:
        String setLoadsInMetacelloProject:
        String setPackage:withInMetacelloConfig:
        String setProject:withInMetacelloConfig:
        String setRequiresInMetacelloPackage:
        String setTimestampInMetacelloConfig:
        String setTimestampInMetacelloVersion:
        Symbol setPostLoadDoItInMetacelloSpec:
        Symbol setPreLoadDoItInMetacelloSpec:
        Timestamp setTimestampInMetacelloVersion:
        UndefinedObject asMetacelloVersionNumber
        UndefinedObject setAuthorInMetacelloVersion:
        UndefinedObject setBlessingInMetacelloVersion:
        UndefinedObject setDescriptionInMetacelloVersion:
        UndefinedObject setPostLoadDoItInMetacelloSpec:
        UndefinedObject setPreLoadDoItInMetacelloSpec:
        UndefinedObject setProject:withInMetacelloConfig:
        UndefinedObject setTimestampInMetacelloVersion:
    )
! !

!stx_goodies_metacello class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_metacello class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/metacello/stx_goodies_metacello.st,v 1.3 2011/08/20 21:07:44 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/metacello/stx_goodies_metacello.st,v 1.3 2011/08/20 21:07:44 cg Exp $'
! !
