"{ Package: 'stx:goodies/moreCollections/btree' }"

BTreeNode variableSubclass:#BTreeInteriorNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-BTree'
!


!BTreeInteriorNode methodsFor:'as yet unclassified'!

childForKey: aMagnitude
	| index |
	index _ keys findIndexForKey: aMagnitude.
	index = 0 ifTrue:
		[keys at: 1 put: aMagnitude.
		^ self at: 1].
	^ self at: index
		
!

childrenDo: aBlock
	self valuesDo: aBlock
!

commonKeysWith: aNode keysAndValuesDo: aBlock flip: aBoolean
	| index |
	aNode firstKey < self firstKey ifTrue: [^ aNode commonKeysWith: self keysAndValuesDo: aBlock flip: aBoolean not].
	index _ (keys findIndexForKey: aNode firstKey) max: 1.
	index to: self size do:
		[:i |
		(self at: i) ifNotNilDo: [:c | c commonKeysWith: aNode keysAndValuesDo: aBlock flip: aBoolean]]
!

depth
	^ 1 + self firstChild depth
!

existingChildForKey: aMagnitude
       "Unlike #childForKey:, this method looks for a child, but doesn't mess with the tree if it doesn't exist."
       | index |
       index _ keys findIndexForKey: aMagnitude.
       index = 0
               ifTrue: [^ nil]
               ifFalse: [^ self at: index].
!

existingLeafForKey: aMagnitude
       "Unlike #leafForKey:, this method looks for a leaf but doesn't mess with the tree if it doesn't exist."
       | child |
       child _ self existingChildForKey: aMagnitude.
       ^ child ifNotNil: [child existingLeafForKey: aMagnitude]
!

firstChild
	self childrenDo: [:ea | ^ ea].
	self error: 'No children'.
!

insertKey: aMagnitude value: anObject at: index
	super insertKey: aMagnitude value: anObject at: index.
	anObject parent: self
!

isLeaf
	^ false
!

leafForKey: aMagnitude
	^ (self childForKey: aMagnitude) leafForKey: aMagnitude
!

leavesFrom: start to: end do: aBlock
	| startIndex endIndex |
	startIndex _ (keys findIndexForKey: start) max: 1.
	endIndex _ (keys findIndexForKey: end).
	startIndex to: endIndex do: [:i | (self at: i) leavesFrom: start to: end do: aBlock]
!

nextSiblingForChild: aNode
	| index |
	index _ keys findIndexForKey: aNode firstKey.
	^ (index = self size or: [(keys at: index+1) isNil]) 
		ifTrue: [index = 1 ifFalse: [self at: index - 1] ifTrue: [nil]]
		ifFalse: [self at: index + 1]
!

updateKey: oldMagnitude to: newMagnitude
       keys withIndexDo:
               [:key :i |
               key = oldMagnitude ifTrue:
                       [(i = 1 and: [parent notNil]) ifTrue:
                               [parent updateKey: oldMagnitude to: newMagnitude].
                       ^ keys at: i put: newMagnitude]].
       self error: 'No such key'
! !

!BTreeInteriorNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/moreCollections/btree/BTreeInteriorNode.st,v 1.1 2006/11/20 21:02:19 cg Exp $'
! !
