"{ Package: 'stx:goodies/moreCollections/btree' }"

BTreeNode variableSubclass:#BTreeLeafNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-BTree'
!


!BTreeLeafNode methodsFor:'as yet unclassified'!

childrenDo: aBlock
	"no children"
!

commonKeysWith: aNode keysAndValuesDo: aBlock flip: aBoolean
	| index key block leaf advanceKey last |
	block _ aBoolean ifTrue: [[:k :v1 :v2 | aBlock value: k value: v2 value: v1]] ifFalse: [aBlock].

	index _ 0.
	advanceKey _
		[index _ index + 1.
		index > self size ifTrue: [^ self].
		key _ keys at: index.
		key ifNil: [^ self]].
	last _ self lastKey.
	
	advanceKey value.
	[key < aNode firstKey] whileTrue: advanceKey.
		
	[leaf _ aNode existingLeafForKey: key.
	leaf lastKey < key ifTrue: advanceKey ifFalse:
		[leaf keysAndValuesDo:
			[:otherKey :otherValue |
			otherKey > last ifTrue: [^ self].
			[key < otherKey] whileTrue: advanceKey.
			key = otherKey ifTrue: [block value: key value: (self at: index) value: otherValue]].
		key > leaf lastKey ifFalse: advanceKey]] repeat
!

depth
	^ 1
!

existingLeafForKey: aMagnitude
       ^ self
!

isLeaf
	^ true
!

keys
	^ Array streamContents: [:s | self keysDo: [:ea | s nextPut: ea]]
!

lastKey
	| last |
	last _ nil.
	self keysDo: [:k | last _ k].
	^ last
!

leafForKey: aMagnitude
	^ self
!

leavesFrom: start to: end do: aBlock
	aBlock value: self
!

valueForKey: aMagnitude ifAbsent: errorBlock
	| i |
	i _ keys findIndexForKey: aMagnitude.
	^ (i > 0 and: [(keys at: i) = aMagnitude])
		ifTrue: [self at: i]
		ifFalse: [errorBlock value]
!

valueForKey: aMagnitude ifPresent: aBlock
	^ aBlock value: (self valueForKey: aMagnitude ifAbsent: [^ nil])
! !

!BTreeLeafNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/moreCollections/btree/BTreeLeafNode.st,v 1.1 2006/11/20 21:02:40 cg Exp $'
! !
