"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

StructuredHeaderField subclass:#CollectionField
	instanceVariableNames:'separator'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-MIME'
!

CollectionField comment:'CollectionField is super class for header fields wich value is collection.

Instance Variables:
	separator       <Symbol>        fields  separator

'
!

!CollectionField class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!CollectionField class methodsFor:'instance creation'!

name: nameString value: stringOrCollection
	^( self name: nameString)
		value: stringOrCollection;
		yourself
! !

!CollectionField class methodsFor:'defaults'!

defaultSeparator
	^$,
! !

!CollectionField class methodsFor:'parsing'!

fieldNames
	^#('accept-encoding' 'allow' 'accept-ranges' 'if-match' 'if-none-match' 'public' 'connection' 'content-encoding')
! !

!CollectionField methodsFor:'accessing'!

separator
	separator isNil
		ifTrue: [ separator := self class defaultSeparator].
	^separator
!

separator: aSymbol
	separator := aSymbol
!

value
	^value isNil
		ifTrue: [ value := OrderedCollection new]
		ifFalse: [value]
!

value: aStringOrCollection
	(aStringOrCollection isKindOf: String)
		ifTrue: [ self value add: aStringOrCollection]
		ifFalse: [ self value addAll: aStringOrCollection]
! !

!CollectionField methodsFor:'parsing'!

doParse: scanner
	| coll stream |
	coll := OrderedCollection new.
	stream := (String new: 32) writeStream.
	[scanner skipWhiteSpace.
	scanner nextToken.
	scanner tokenType = #doIt ]
		whileFalse:
			[ scanner token ~~ self separator
				ifTrue:
					[scanner
						printToken: scanner token
						tokenType: scanner tokenType
						on: stream].
			(scanner atEnd or: [scanner token == self separator])
				ifTrue:
					[ coll add: (self parseItem: stream contents).
					stream := (String new: 20) writeStream]].

	stream contents notEmpty ifTrue: [ coll add: (self parseItem: stream contents)].

	^coll
!

parseItem: aString
	^aString
! !

!CollectionField methodsFor:'printing'!

printValueOn: aStream
	self value
		do: [ :param |  aStream nextPutAll: param ]
		separatedBy: [aStream nextPut: self separator].
	aStream cr.
! !

!CollectionField class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__CollectionField.st,v 1.3 2009/09/29 20:08:16 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__CollectionField.st,v 1.3 2009/09/29 20:08:16 cg Exp $'
! !
