"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

ScalarField subclass:#DateField
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-MIME'
!

DateField comment:'This class represents date fields as defines in RFC822 and HTTP. Value of the field is an instance of date, not a string. See rfc822 for the exact syntax of dates

Example:
	HeaderField fromLine: ''Date : Tue, 18 Apr 89 23:29:47 +0900    ''
	HeaderField halt; fromLine: ''Date : 26 Aug 76 14:30 EDT''


'
!

!DateField class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!DateField class methodsFor:'defaults'!

default
	^self new value: Timestamp now
! !

!DateField class methodsFor:'parsing'!

fieldNames
	^#('date' 'expires' 'last-modified' 'retry-after')
! !

!DateField methodsFor:'accessing'!

asString
	^self dateString
!

dateString

	^RFC822Scanner dateStringFrom: self value
!

timestamp
	^self value
!

timestamp: aTimestamp
	self value: aTimestamp
!

value: aTimestampOrStringOrArray
	"We allow to set date from either string, timestamp or a two-element array (date, time) "

	(aTimestampOrStringOrArray isKindOf: Timestamp)
		ifTrue: [value := aTimestampOrStringOrArray]
		ifFalse: [aTimestampOrStringOrArray isString
				ifTrue: [value := self doParse: (self scannerOn: aTimestampOrStringOrArray readStream)]
				ifFalse: [value := self fromDateAndTime: aTimestampOrStringOrArray]]
! !

!DateField methodsFor:'converting'!

asDateAndTime
	^self value
!

fromDateAndTime: dateAndTime
	^Timestamp fromDate: dateAndTime first andTime: dateAndTime last.
! !

!DateField methodsFor:'parsing'!

doParse: rfc822Stream
" HeaderField fromLine: 'Date : Tue, 18 Apr 89 23:29:47 +0900   ' "
" HeaderField fromLine: 'Expires : 0' "
" HTTP/1.1 clients MUST treat other invalid date formats, especially including the value 0, as in the past (i.e., already expired). That is why the value can be a number :-("

	^[(rfc822Stream size - rfc822Stream position) < 5
		ifTrue: [ Number readFrom: rfc822Stream asStream]
		ifFalse:
			[rfc822Stream scanDate] ] on: Error do: [ :ex | ex return: nil ]
! !

!DateField methodsFor:'printing'!

printStructureOn: aStream
	aStream nextPutAll: self printValue.
	self printCommentOn: aStream
!

printValue
	| v |
	v := self value.
	^( v isKindOf: Number)
		ifTrue: [  v printString ]
		ifFalse: [ self dateString].
! !

!DateField class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__DateField.st,v 1.4 2009/09/29 20:08:39 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__DateField.st,v 1.4 2009/09/29 20:08:39 cg Exp $'
! !
