"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

IMAPState subclass:#IMAPAuthenticatedState
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!

!IMAPAuthenticatedState class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!IMAPAuthenticatedState methodsFor:'commands'!

append: message to: aMailboxName flags: flags date: dateString
    | args |
    args := OrderedCollection with: (client canonicalizeMailboxName: aMailboxName).
    flags notNil ifTrue: [args add: flags].
    dateString notNil ifTrue: [args add: #atom -> dateString].
    args add: #literalString -> message.
    ^client executeAndWait: 'append' arguments: args
!

create: aMailboxName
    ^client
	execute: 'create'
	arguments: aMailboxName
	changeStateTo: [IMAPSelectedState new]
!

delete: aMailboxName
    ^client executeAndWait: 'delete' arguments: aMailboxName
!

examine: aMailBoxName
    ^client
	execute: 'examine'
	arguments: aMailBoxName
	changeStateTo: [IMAPSelectedState new]
!

list: refName mailbox: name
    ^client executeAndWait: 'list' arguments: (Array with: refName with: name)
!

lsub: refName mailbox: name
    ^client executeAndWait: 'lsub' arguments: (Array with: refName with: name)
!

rename: oldMailBox newName: newMailBox
    ^client executeAndWait: 'rename' arguments: (Array with: oldMailBox with: newMailBox)
!

select: aMailBoxName
    ^client
	execute: 'select'
	arguments: aMailBoxName
	changeStateTo: [IMAPSelectedState new]
!

status: aMailBoxNameWithArguments

    ^client
	executeAndWait: 'status'
	arguments: aMailBoxNameWithArguments.

"        arguments: (Array with: aMailBoxNameWithArguments)"
!

subscribe: aMailBoxName
    ^client executeAndWait: 'subscribe' arguments: (Array with: aMailBoxName)
!

unsubscribe: aMailBoxName
    ^client executeAndWait: 'unsubscribe' arguments: (Array with: aMailBoxName)
! !

!IMAPAuthenticatedState methodsFor:'obsolete'!

create: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'create' arguments: aList) completedSuccessfully
	ifTrue:
	    [aClient state: IMAPSelectedState new.
	    command]
	ifFalse: [false]
!

delete: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'delete' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
!

examine: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'examine' arguments: aList) completedSuccessfully
	ifTrue:
	    [aClient state: IMAPSelectedState new.
	    command]
	ifFalse: [nil]
!

list: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'list' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
!

lsub: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'lsub' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
!

rename: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'rename' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
!

select: aClient arguments: aList
    | command |

    ^(command := aClient executeAndWait: 'select'
			    arguments: aList)
	completedSuccessfully
	    ifTrue: [  aClient state: IMAPSelectedState new. command ]
	    ifFalse: [ nil ]
!

subscribe: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'subscribe' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
!

unsubscribe: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'unsubscribe' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
! !

!IMAPAuthenticatedState methodsFor:'testing'!

isAuthenticated

    ^true
! !

!IMAPAuthenticatedState class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPAuthenticatedState.st,v 1.2 2009/09/29 20:08:37 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPAuthenticatedState.st,v 1.2 2009/09/29 20:08:37 cg Exp $'
! !
