"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

IMAPFetchedItem subclass:#IMAPBodyFetchedItem
	instanceVariableNames:'parts'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!

!IMAPBodyFetchedItem class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!IMAPBodyFetchedItem class methodsFor:'matching'!

canBe: aName

    "
    Can the reciever represent items fetched using the given name?  This is not as straightforward as it ought to be.
    IMAPv4 uses 'BODY' fetches in two very different ways, so we will have to be careful about that.
    For now, we are not making the distinction, so we will have to revisit this in the future.
    "

    ^#(
	'BODY'
	'BODY.PEEK'
   ) includes: aName
! !

!IMAPBodyFetchedItem methodsFor:'building'!

extractBodySectionContentFrom: tokenStream

    self parts
	add: (IMAPBodySectionFetchedItem new extractContentFrom: tokenStream)
!

extractContentFrom: tokenStream

    "
    For the body parts extraction case, tokens will be something like:
	$[
	'HEADER.FIELDS'
	#('FIELD1' 'FIELD2')
	$]
	'...content as described above...'

    Whereas for the body (structure) case, the tokens will be something like:
	#('TEXT' 'PLAIN' #('CHARSET' 'us-ascii') nil nil '8BIT' '763' '8')

    What a screwed up spec.
    "

"devel thought: It might would be good if the reciever could tell what had been requested, and what had been recieved."

    "First off, are we talking about a body section fetch, or a short-form body structure fetch? Bastards!!"

    (tokenStream peek = $[ )
	ifTrue: [ self extractBodySectionContentFrom: tokenStream ]
	ifFalse: [ self extractShortFormBodyStructureFrom: tokenStream ]
!

extractShortFormBodyStructureFrom: tokenStream

    "
    Whereas for the body (structure) case, the tokens will be something like:
	#('TEXT' 'PLAIN' #('CHARSET' 'us-ascii') nil nil '8BIT' '763' '8')
    "

    self parts
	add: (IMAPBodyStructureFetchedItem new extractContentFrom: tokenStream)
! !

!IMAPBodyFetchedItem methodsFor:'parts'!

parts

    ^parts notNil
	ifTrue: [ parts ]
	ifFalse: [ parts := OrderedCollection new ]
! !

!IMAPBodyFetchedItem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPBodyFetchedItem.st,v 1.2 2009/09/29 20:08:10 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPBodyFetchedItem.st,v 1.2 2009/09/29 20:08:10 cg Exp $'
! !
