"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

IMAPFetchedItem subclass:#IMAPBodySectionFetchedItem
	instanceVariableNames:'sectionSpec'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!


!IMAPBodySectionFetchedItem class methodsFor:'matching'!

canBe: aName

    "
    Can the reciever represent items fetched using the given name?  This is not as straightforward as it ought to be.
    IMAPv4 uses 'BODY' fetches in two very different ways, so we will have to be careful about that.
    For now, we are not making the distinction, so we will have to revisit this in the future.
    Also, note that we don't include 'RFC822.SIZE'.  Such a fetch does not return anything complex- it's actually just a simple metadata fetch.
    "

"    ^#(
	'BODY'
	'BODY.PEEK'
	'RFC822'
	'RFC822.HEADER'
	'RFC822.TEXT'
   ) includes: aName."

    ^false
! !

!IMAPBodySectionFetchedItem methodsFor:'accessing'!

sectionSpec

    ^sectionSpec
! !

!IMAPBodySectionFetchedItem methodsFor:'building'!

extractContentFrom: tokenStream

    "
    For the body parts extraction case, tokens will be something like:
	$[
	'HEADER.FIELDS'
	#('FIELD1' 'FIELD2')
	$]
	'...content as described above...'

    Whereas for the body (structure) case, the tokens will be something like:
	#('TEXT' 'PLAIN' #('CHARSET' 'us-ascii') nil nil '8BIT' '763' '8')

    What a screwed up spec.
    "

"devel thought: It might would be good if the reciever could tell what had been requested, and what had been recieved."

    | specTokens |

    specTokens := tokenStream
	upTo: $[ ;
	upTo: $].

    (self sectionSpecificationFrom: specTokens)
	extractContentFrom: tokenStream
!

sectionSpecificationFrom: tokens

    ^sectionSpec := IMAPFetchedItemSectionSpecification readFrom: tokens readStream
! !

!IMAPBodySectionFetchedItem methodsFor:'header fields'!

headerFieldNamed: aName ifAbsent: aBlock

"hmm... need a more compex example here."

    self halt
! !

!IMAPBodySectionFetchedItem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPBodySectionFetchedItem.st,v 1.1 2004/11/12 10:41:08 penk Exp $'
! !
