"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

Object subclass:#IMAPClientHandler
	instanceVariableNames:'existingMessages recentMessages expungedMessage mailboxFlags'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!

IMAPClientHandler comment:'IMAPClientHandles is implemented to handle unsolicited server responses. Certain server data must be recorded by the client when it is received. Such data conveys critical information which affects the interpretetion of all subsequent commands and responses.

Instance Variables:

	existingMessages        <Number>        The value of the EXISTS command
	recentMessages  <Number>        The value of the RECENT command
	expungedMessage <Number>        The value of the EXPUNGE command
	mailboxFlags    <Collection>    The value of the FLAGS command  as: #(''\Seen'' ''\Answered'' ''\Deleted'' )'
!

!IMAPClientHandler class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!IMAPClientHandler methodsFor:'accessing'!

existingMessages

	^existingMessages
!

existingMessages: aNumber

	existingMessages := aNumber
!

expungedMessage

	^expungedMessage
!

expungedMessage: aNumber

	expungedMessage := aNumber
!

mailboxFlags

	^mailboxFlags
!

mailboxFlags: aCollection

	mailboxFlags := aCollection
!

recentMessages

	^recentMessages
!

recentMessages: aNumber

	recentMessages := aNumber
! !

!IMAPClientHandler methodsFor:'handle responses'!

handle: aResponse
"       (#('EXISTS' 'RECENT' 'FLAGS' 'EXPUNGE') includes: aResponse cmdName)    "

	^[self perform: (aResponse cmdName asLowercase , ':') asSymbol with: aResponse value. true]
	on: self messageNotUnderstoodSignal
	do: [:ex | ex return: false]
!

handle: aResponse for: imapClient
	self handle: aResponse
! !

!IMAPClientHandler methodsFor:'private'!

exists: aString

	self existingMessages: aString asNumber
!

expunge: aString

	self expungedMessage: aString asNumber
!

flags: aCollection

	self mailboxFlags: aCollection
!

recent: aString

	self recentMessages: aString asNumber
! !

!IMAPClientHandler class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPClientHandler.st,v 1.2 2009/09/29 20:06:48 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPClientHandler.st,v 1.2 2009/09/29 20:06:48 cg Exp $'
! !
