"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

Object subclass:#IMAPCommandSequencer
	instanceVariableNames:'prefix value'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!

IMAPCommandSequencer comment:'IMAPCommandSequencer generates unique identifier (tag) for IMAP4rev1 command.

Instance Variables:

		prefix <String>
		value <Number> '
!


!IMAPCommandSequencer class methodsFor:'instance creation'!

new
    ^self basicNew initialize
!

newPrefix: prefix
    ^self new prefix: prefix; yourself
! !

!IMAPCommandSequencer methodsFor:'accessing'!

next

    self increment.

    ^self prefix, self value printString
!

prefix

    ^prefix
!

prefix: aValue

    prefix := aValue
!

value

    ^value
!

value: aValue

    value := aValue
! !

!IMAPCommandSequencer methodsFor:'initialization'!

initialize
    value := 0
!

reset

    self value: 0
! !

!IMAPCommandSequencer methodsFor:'private'!

increment

    self value: (self value + 1)
! !

!IMAPCommandSequencer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPCommandSequencer.st,v 1.1 2004/11/12 10:42:03 penk Exp $'
! !
