"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

IMAPResponse subclass:#IMAPErrorResponse
	instanceVariableNames:'exception'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!

IMAPErrorResponse comment:'IMAPCommand  is terminated with the IMAPErrorResponse when the exception was raised because the client was disconnected or specified timeout was expired.

Instance Variables:

	exception       <Exception>     Holds the exception'
!


!IMAPErrorResponse class methodsFor:'instance creation'!

newFor: aCommand exception: anException

	^self new
		cmdName: aCommand name;
		exception: anException;
		yourself
! !

!IMAPErrorResponse methodsFor:'accessing'!

exception
	^exception
!

exception: anException
	exception := anException
!

text
	^ self exception description
! !

!IMAPErrorResponse methodsFor:'testing'!

isOK
	^false
!

terminatesCommand: aCommand
	^true
! !

!IMAPErrorResponse class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPErrorResponse.st,v 1.1 2004/11/12 10:47:56 penk Exp $'
! !
