"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

IMAPFetchedItem subclass:#IMAPMessageEnvelopeFetchedItem
	instanceVariableNames:'envelope'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!


!IMAPMessageEnvelopeFetchedItem class methodsFor:'matching'!

canBe: aName

    "
    Can the reciever represent items fetched using the given name?
    Note that we include 'RFC822.SIZE' .
    This is just a simple metadata fetch, unlike such things as 'RFC822' or 'RFC822.HEADER' .
    "

    ^'ENVELOPE'= aName
! !

!IMAPMessageEnvelopeFetchedItem methodsFor:'accessing'!

bccLine

    ^self envelope at: 8
!

ccLine

    ^self envelope at: 7
!

dateLine

    ^self envelope at: 1
!

fromAuthor

    ^(self fromLine at: 1) at: 1
!

fromLine

    ^self envelope at: 3
!

inReplyToLine

    ^self envelope at: 9
!

replyToAuthor

    ^(self replyToLine at: 1) at: 1
!

replyToLine

    ^self envelope at: 5
!

senderAuthor

    ^(self senderLine at: 1) at: 1
!

senderLine

    ^self envelope at: 4
!

subjectLine

    ^self envelope at: 2
!

toLine

    ^self envelope at: 6
!

uniqueMessageIDLine

    ^self envelope at: 10
! !

!IMAPMessageEnvelopeFetchedItem methodsFor:'building'!

extractContentFrom: tokenStream

    "the envelope is an array of message metadata- we'll come back to this for interpretation later."

    self envelope: (tokenStream next)
! !

!IMAPMessageEnvelopeFetchedItem methodsFor:'envelope'!

envelope

    ^envelope
!

envelope: anArray

    "We have yet to interpret the contents of the given array... we shall need to get to that later."

    envelope := anArray
! !

!IMAPMessageEnvelopeFetchedItem methodsFor:'printing'!

printDevelOn: aStream indent: level

    aStream
	crtab: level ;
	    nextPutAll: 'Date: ' ;
	    nextPutAll: self dateLine ;
	crtab: level ;
	    nextPutAll: 'Subject: ' ;
	    nextPutAll: self subjectLine ;
	crtab: level ;
	    nextPutAll: 'From: ' ;
	    print: self fromAuthor ;
	crtab: level ;
	    nextPutAll: 'Sender: ' ;
	    print: self senderAuthor ;
	crtab: level ;
	    nextPutAll: 'ReplyTo: ' ;
	    print: self replyToAuthor ;
	crtab: level ;
	    nextPutAll: 'To: ' ;
	    print: self toLine ;
	crtab: level ;
	    nextPutAll: 'In Reply To: ' ;
	    print: self inReplyToLine ;
	crtab: level ;
	    nextPutAll: 'Message ID: ' ;
	    nextPutAll: self uniqueMessageIDLine ;
	crtab: level ;
	    nextPutAll: 'Bcc: ' ;
	    print: self bccLine ;
	crtab: level ;
	    nextPutAll: 'Cc: ' ;
	    print: self ccLine ;
	yourself
!

printOn: aStream

    self printDevelOn: aStream indent: 0
! !

!IMAPMessageEnvelopeFetchedItem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPMessageEnvelopeFetchedItem.st,v 1.1 2004/11/12 10:43:19 penk Exp $'
! !
