"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

IMAPFetchedItem subclass:#IMAPMessageMetadataFetchedItem
	instanceVariableNames:'value'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!


!IMAPMessageMetadataFetchedItem class methodsFor:'matching'!

canBe: aName

    "
    Can the reciever represent items fetched using the given name?
    Note that we include 'RFC822.SIZE' .
    This is just a simple metadata fetch, unlike such things as 'RFC822' or 'RFC822.HEADER' .
    "

    ^#(
	'FLAGS'
	'INTERNALDATE'
	'RFC822.SIZE'
	'UID'
   ) includes: aName
! !

!IMAPMessageMetadataFetchedItem methodsFor:'building'!

extractContentFrom: tokenStream

    self value: (tokenStream next)
! !

!IMAPMessageMetadataFetchedItem methodsFor:'value'!

value

    ^value
!

value: anObject

    value := anObject
! !

!IMAPMessageMetadataFetchedItem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPMessageMetadataFetchedItem.st,v 1.1 2004/11/12 10:45:34 penk Exp $'
! !
