"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

IMAPResponse subclass:#IMAPResponseStatus
	instanceVariableNames:'text status'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!


!IMAPResponseStatus class methodsFor:'testing'!

canParse: cmdName
	^#('OK' 'NO' 'BAD' 'BYE') includes: cmdName
! !

!IMAPResponseStatus methodsFor:'accessing'!

status
	^status
!

status: aString
	status := aString
!

text
	^text
!

text: aString
	text := aString
! !

!IMAPResponseStatus methodsFor:'parsing, general'!

parse: scanner
        | val key bracketedValue scodeScanner |
        scanner skipWhiteSpace.
        (scanner peek == $[)
                ifTrue:
                        [value := List new.  
                        bracketedValue := scanner nextToken.
                        scodeScanner := IMAPScanner on: ((IMAPScanner tokenizeBracketedGroup: bracketedValue) at: 2) readStream.
                        key := scodeScanner nextToken asUppercase.

                        (#('UIDVALIDITY' 'UNSEEN' ) includes: key) ifTrue: [ val := scodeScanner nextToken asNumber ].
                        'PERMANENTFLAGS' = key ifTrue: [ val := scodeScanner deepNextToken ].
                        'NEWNAME' = key ifTrue: [ |old new|
                                old := scodeScanner nextToken.
                                new := scodeScanner nextToken.
                                val := Array with: old with: new ].
                ].
        self text: scanner scanText.
        (#('ALERT' 'PARSE' 'TRYCREATE' 'READ-ONLY' 'READ-WRITE' ) includes: key) ifTrue: [ val := self text ].
        self value: key->val.
!

parse: scanner with: token
	self cmdName:  token.
	self status: token.
	self parse: scanner.
! !

!IMAPResponseStatus methodsFor:'testing'!

isBad

	^ self status = 'BAD'
!

isOK

	^ self status = 'OK'
! !

!IMAPResponseStatus class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPResponseStatus.st,v 1.1 2004/11/12 10:47:16 penk Exp $'
! !
