"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

IMAPAuthenticatedState subclass:#IMAPSelectedState
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!


!IMAPSelectedState methodsFor:'commands'!

check
    ^client executeAndWait: 'check'
!

close
    ^client
	execute: 'close'
	arguments: nil
	changeStateTo: [IMAPAuthenticatedState new]
!

copy
!

expunge
    ^client executeAndWait: 'expunge'
!

fetch: aCriteria
    ^client executeAndWait: 'fetch' arguments: aCriteria
!

fetch: messageNumbers retrieve: criteria
    | msgString args |
    msgString := client messageSetAsString: messageNumbers.
    args := OrderedCollection with: msgString.
    criteria notNil ifTrue: [criteria isCharacters
	    ifTrue: [args add: criteria]
	    ifFalse: [args addAll: criteria]].
    ^client executeAndWait: 'fetch' arguments: args
!

search: aCriteria
    ^client executeAndWait: 'search' arguments: aCriteria
!

store: args
    ^client executeAndWait: 'store' arguments: args
!

uid: aString
    ^client executeAndWait: 'uid' arguments: aString
! !

!IMAPSelectedState methodsFor:'obsolete'!

check: aClient
    ^client executeAndWait: 'check'
!

close: aClient
    | command |
    ^(command := aClient executeAndWait: 'close') completedSuccessfully
	ifTrue: [aClient state: IMAPAuthenticatedState new. command]
	ifFalse: [nil]
!

expunge: aClient
    | command |
    ^(command := aClient executeAndWait: 'expunge') completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
!

fetch: aClient arguments: aList
    | command   |

    ^(command := aClient executeAndWait: 'fetch' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
!

search: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'search' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
!

store: aClient arguments: aList
    | command |
    ^(command := aClient executeAndWait: 'store' arguments: aList) completedSuccessfully
	ifTrue: [command]
	ifFalse: [nil]
! !

!IMAPSelectedState methodsFor:'testing'!

isSelected

    ^true
! !

!IMAPSelectedState class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPSelectedState.st,v 1.1 2004/11/12 10:45:17 penk Exp $'
! !
