"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

Object subclass:#IMAPState
	instanceVariableNames:'client'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-IMAP'
!


!IMAPState class methodsFor:'instance creation'!

forClient: client
    ^self new client: client
! !

!IMAPState methodsFor:'accessing'!

client

    ^client
! !

!IMAPState methodsFor:'any state valid commands'!

capability
    ^client executeAndWait: 'capability'
!

logout
    | command |
    (command := client executeAndWait: 'logout') completedSuccessfully
	ifTrue: [  client state: IMAPState new].
    ^command
!

noop
    ^client executeAndWait: 'noop'
! !

!IMAPState methodsFor:'commands'!

append
    self signalError
!

check: aClient
    self signalError
!

close: aClient
    self signalError
!

copy
    self signalError
!

create: aClient arguments: aList
    self signalError
!

delete: aClient arguments: aList
    self signalError
!

examine: aClient arguments: aList
    self signalError
!

expunge: aClient
    self signalError
!

fetch: aClient arguments: aList
    self signalError
!

list: aClient arguments: aList
    self signalError
!

login: pi
    self signalError
!

lsub: aClient arguments: aLIst
    self signalError
!

rename: aClient arguments: aList
    self signalError
!

search: aClient arguments: aLIst
    self signalError
!

select: aClient arguments: aList
    self signalError
!

status
    self signalError
!

store: aClient arguments: aList
    self signalError
!

subscribe: aClient arguments: aList
    self signalError
!

uid: aClient arguments: aList
    self signalError
!

unsubscribe: aClient arguments: aList
    self signalError
! !

!IMAPState methodsFor:'errors'!

signalError

    ^self protocolError: 'wrong state'
! !

!IMAPState methodsFor:'initialize-release'!

client: aValue

    client := aValue
! !

!IMAPState methodsFor:'obsolete'!

capability: aClient
    | command |
    ^(command := aClient executeAndWait: 'capability') completedSuccessfully
	ifTrue: [command]
	ifFalse: [false]
!

logout: aClient
    | command |
    (command := aClient executeAndWait: 'logout') completedSuccessfully
	ifTrue: [  aClient state: IMAPState new].
    ^command
!

noop: client
    | command |
    ^(command := client executeAndWait: 'noop') completedSuccessfully
	ifTrue: [command]
	ifFalse: [false]
! !

!IMAPState methodsFor:'testing'!

isAuthenticated

    ^false
!

isSelected

    ^false
! !

!IMAPState class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__IMAPState.st,v 1.1 2004/11/12 10:42:44 penk Exp $'
! !
