"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

Object subclass:#LetterInTransit
	instanceVariableNames:'letterText deliveryAction uid server serverType'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-Mailbox'
!

LetterInTransit comment:'LetterInTransit is used to hold row data received from a mail server in shared queue.

Instance Variables:

	letterText      <String>        mail message text
	deliveryAction  <Block> some action performed when a message has being processed
	uid     <String>        message uid
	server  <String>        server name
	serverType      <String>        IMAP/POP3'
!


!LetterInTransit class methodsFor:'instance creation'!

letterText: aLetter onDelivery: aBlock
	^self letterText: aLetter uid: nil server: nil onDelivery: aBlock
! !

!LetterInTransit methodsFor:'accessing'!

delivered
	deliveryAction value.
	letterText := nil.
	uid := nil
!

deliveryAction
	^deliveryAction
!

deliveryAction: aBlock
	deliveryAction := aBlock
!

letterText
	^letterText
!

letterText: aString
	letterText := aString
!

server
	^server
!

server: aString
	server := aString
!

serverType

	^serverType
!

serverType: aString

	serverType := aString
!

size

	^letterText size
!

uid
	^uid
!

uid: aString

	uid := aString
! !

!LetterInTransit methodsFor:'delivery'!

sendOn: aStream
	"Write the letter to aStream"
" Old code for POP3
	(letterText size < 5
	or: [(letterText copyFrom: 1 to: 5) ~= 'From ']) ifTrue:
		[self halt: 'First line of header should be a From line.  It isn''t!!'].
"
	aStream nextPutAll: letterText
! !

!LetterInTransit methodsFor:'initialize-release'!

letterText: aString onDelivery: aBlock
	letterText := aString.
	deliveryAction := aBlock
! !

!LetterInTransit class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__LetterInTransit.st,v 1.1 2004/11/15 14:47:56 penk Exp $'
! !
