"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

SimpleScanner subclass:#MailScanner
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-MIME'
!

MailScanner comment:'This class is an abstract class for all mail-related scanners. It provides some common printing methods
for lexical types that are used by all subclasses -- atom, text, quoted text


'
!


!MailScanner class methodsFor:'printing'!

print: char on: aStream
	aStream nextPut: char
!

printAll: aString on: aStream
	aStream nextPutAll: aString
!

printQuotedText: str on: stream
	"Print word as quoted text"

	stream nextPut: $"; nextPutAll: str; nextPut: $"
!

printText: text on: stream
	stream nextPutAll: text
!

printTokenList: list on: stream
	self printTokenList: list on: stream separatedBy: [ stream space ]
!

printTokenList: list on: stream separatedBy: aBlock
	list do: [:assoc | self printToken: assoc on: stream]
		separatedBy: aBlock
! !

!MailScanner methodsFor:'printing'!

printAtom: atom on: stream
	self class printAtom: atom on: stream
!

printQuotedText: qtext on: stream
	self class printQuotedText: qtext on: stream
!

printText: qtext on: stream
	self class printText: qtext on: stream
! !

!MailScanner class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__MailScanner.st,v 1.1 2004/11/12 10:48:01 penk Exp $'
! !
