"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

MimeEntity subclass:#MimeMultipartEntity
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-MIME'
!


!MimeMultipartEntity methodsFor:'attachments'!

addFileAttachment: aFilename
	^self bot addFileAttachmentFor: self fileName: aFilename
!

attachmentAt: index
	^(self bot attachmentsFor: self) at: index
!

attachmentFiles
	^self attachments select: [:each | each fileName ~~ nil ]
!

attachmentFilesAsDictionary
	| dict |
	dict := Dictionary new.
	self attachments
		do: [:each |
			each fileName ~~ nil
				ifTrue: [ dict at: each fileName put: each value value ]].
	^dict
!

attachmentNames
	"Return a list of attachments file names  (if any)"
	| list fn  |
	list := OrderedCollection new.
	self attachments do: [:ea | (fn := ea fileName) notNil ifTrue: [ list add: fn]].
	^list
!

attachments
	^self bot attachmentsFor: self
! !

!MimeMultipartEntity methodsFor:'utility'!

saveAttachment: aMimeEntity on: aStream
	^self bot writeContentsOf: aMimeEntity  on: aStream
!

saveAttachmentAt: anInteger on: aStream
	^self saveAttachment: (self attachmentAt: anInteger)  on: aStream
! !

!MimeMultipartEntity class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__MimeMultipartEntity.st,v 1.1 2004/11/12 10:47:01 penk Exp $'
! !
