"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

Object subclass:#NetResponse
	instanceVariableNames:'status statusMessage'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-Framework'
!

NetResponse comment:'
Copyright (c) Kazuki Yasumatsu, 1995. All rights reserved.
'
!


!NetResponse class methodsFor:'instance creation'!

fromClient: aClient
    | response |
    response := self new.
    response parseResponse: aClient.
    ^response
! !

!NetResponse methodsFor:'accessing'!

status
    ^status
!

status: anInteger
    status := anInteger
!

statusArray
    | n array |
    status == nil ifTrue: [n := 0] ifFalse: [n := status].
    array := Array new: 3.
    array at: 1 put: (n // 100).
    n := n - ((n // 100) * 100).
    array at: 2 put: (n // 10).
    n := n - ((n // 10) * 10).
    array at: 3 put: n.
    ^array
!

statusMessage
    ^statusMessage
!

statusMessage: aString
    statusMessage := aString
! !

!NetResponse methodsFor:'parsing'!

parseResponse: aClient
    self parseStatusLine: aClient
! !

!NetResponse methodsFor:'printing'!

printOn: aStream
    self printStatusOn: aStream
!

printStatusOn: aStream
    status notNil
	ifTrue: [aStream print: status; space].
    statusMessage notNil
	ifTrue: [aStream nextPutAll: statusMessage].
! !

!NetResponse methodsFor:'private'!

parseStatusLine: aClient
    | stream |
    statusMessage := nil.
    [stream := aClient nextLine readStream.
    status := Integer readFrom: stream.
    stream next = $-]
	whileTrue:
		[statusMessage == nil
			ifTrue: [statusMessage := stream upToEnd]
			ifFalse:        [statusMessage := statusMessage, (String with: Character cr), stream upToEnd]].
    stream skipSeparators.
    statusMessage == nil
	ifTrue: [statusMessage := stream upToEnd]
	ifFalse:        [statusMessage := statusMessage, (String with: Character cr), stream upToEnd]
! !

!NetResponse class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__NetResponse.st,v 1.1 2004/11/12 10:46:03 penk Exp $'
! !
