"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

ScalarField subclass:#NumericField
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-MIME'
!

NumericField comment:'I represent numeric fields such as content-length. My value is a number. String representation of value can be accessed using #asString

Example:
	Content-length: 1123

Instance Variables:
'
!


!NumericField class methodsFor:'instance creation'!

contentLength: aNumber
" Answer an instance of this field representing content length"

	^(self name: 'content-length') value: aNumber
! !

!NumericField class methodsFor:'parsing'!

fieldNames
	^#('content-length' )
! !

!NumericField methodsFor:'accessing'!

asString
	^self value printString
! !

!NumericField methodsFor:'initialization'!

initialize
	super initialize.
	value := 0
! !

!NumericField methodsFor:'parsing'!

doParse: rfc822Stream
" HeaderField fromLine: 'Content-length : 1024 (This is body length in bytes)' "
	rfc822Stream skipWhiteSpace.
	^Number readFrom: rfc822Stream asStream
! !

!NumericField methodsFor:'printing'!

printStructureOn: aStream
	aStream nextPutAll: self asString.
	self printCommentOn: aStream
! !

!NumericField class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__NumericField.st,v 1.2 2008/09/03 08:58:00 cg Exp $'
! !
