"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

Reporter subclass:#PluggableReporter
	instanceVariableNames:'startTime currentTime statusBlock'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-Framework'
!

PluggableReporter comment:'
Copyright (c) Kazuki Yasumatsu, 1995. All rights reserved.
'
!


!PluggableReporter class methodsFor:'instance creation'!

statusBlock: aBlock
    ^self new statusBlock: aBlock
! !

!PluggableReporter methodsFor:'accessing'!

endTransfer
    self statusString: 'Transferring: Done.'
!

readByte: anInteger
    readByte := readByte + anInteger.
    currentTime := Time millisecondClockValue.
    self statusString: self progressStatusString.
!

startTransfer
    readByte := 0.
    startTime := currentTime := Time millisecondClockValue.
    self statusString: 'Transferring: Start.'
!

statusString: statusString
    statusBlock isNil ifTrue: [^self].
    statusBlock value: statusString.
!

totalByte: anInteger
    totalByte := anInteger
! !

!PluggableReporter methodsFor:'private'!

progressStatusString
    | stream |
    stream := WriteStream on: (String new: 128).
    stream print: readByte.
    totalByte == nil ifFalse: [stream nextPut: $/; print: totalByte].
    stream nextPutAll: ' bytes'.
    currentTime = startTime
	ifFalse:
		[stream nextPutAll: ' ('.
		(readByte / (currentTime - startTime)) asFloat printOn: stream digits: 2.
		stream nextPutAll: ' Kbytes/sec)'].
    ^stream contents
!

statusBlock: aBlock
    statusBlock := aBlock
! !

!PluggableReporter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__PluggableReporter.st,v 1.2 2004/11/15 09:01:21 penk Exp $'
! !
