"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

Stream subclass:#PrependDotStream
	instanceVariableNames:'stream atStart'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-Framework'
!

PrependDotStream comment:'A PrependDotStream removes a dot to each line starting with a dot, and
ends when its input has a lonely dot.'
!


!PrependDotStream class methodsFor:'instance creation'!

to: aStream
     ^self new initialize: aStream
! !

!PrependDotStream methodsFor:'output'!

flush
    atStart ifFalse: [ self nl ].
    stream nextPut: $.; nl
!

nextPut: aChar
    (atStart and: [ aChar == $. ])
	ifTrue: [ stream nextPut: aChar ].

    stream nextPut: aChar.
    atStart := aChar == Character nl.
! !

!PrependDotStream methodsFor:'private'!

initialize: aStream
    stream := aStream.
    atStart := true
!

species
    ^stream species
! !

!PrependDotStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__PrependDotStream.st,v 1.1 2004/11/12 10:45:10 penk Exp $'
! !
