"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

Stream subclass:#RemoveDotStream
	instanceVariableNames:'stream ch atStart'
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-Framework'
!


!RemoveDotStream class methodsFor:'instance creation'!

on: aStream
     ^self new initialize: aStream
! !

!RemoveDotStream methodsFor:'input'!

atEnd
    ch isNil ifFalse: [ ^false ].
    stream isNil ifTrue: [ ^true ].
    stream atEnd ifTrue: [ stream := nil. ^true ].

    ch := stream next.
    (atStart and: [ ch == $. ])
	ifFalse: [
	    atStart := (ch == Character cr or: [ ch == Character nl ]).
	    ^false ].

    atStart := false.

    "Found dot at start of line, discard it"
    stream atEnd ifTrue: [ stream := ch := nil. ^true ].
    ch := stream next.

    "Found lonely dot, we are at end of stream"
    (ch == Character cr or: [ ch == Character nl ])
	ifTrue: [
	    ch == Character cr ifTrue: [ stream next ].
	    stream := ch := nil.
	    ^true ].

    ^false
!

next
    | answer |
    self atEnd ifTrue: [
	self error: 'end of stream reached'
    ].
    answer := ch.
    ch := nil.
    ^answer
!

peek
    self atEnd ifTrue: [ ^nil ].
    ^ch
!

peekFor: aCharacter
    self atEnd ifTrue: [ ^false ].
    ch == aCharacter ifTrue: [ self next. ^true ].
    ^false
! !

!RemoveDotStream methodsFor:'private'!

initialize: aStream
    stream := aStream.
    atStart := true.
    self atEnd.
!

species
    ^stream species
! !

!RemoveDotStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__RemoveDotStream.st,v 1.1 2004/11/12 10:47:26 penk Exp $'
! !
