"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

StructuredHeaderField subclass:#ScalarField
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-MIME'
!

ScalarField comment:'This class is the superclass for all fields whose value represents a scalar value. Examples are date field, maibox field, version field, etc. So for the date field field''s value will be parsed date object, not a string representation of date (field''s source would still hold the string representation). Each specific field type should implement method #parse:'
!


!ScalarField class methodsFor:'instance creation'!

base64
" ScalarField base64 "

	^self contentTransferEncoding: 'base64'
!

contentTransferEncoding: encodingName
" Answer an instance of this field representing desired content transfer encoding. encodingName is one of 'base64' or 'quoted-printable' "
" ScalarField contentTransferEncoding: 'base64' "

	^(self name: 'content-transfer-encoding') value: encodingName
!

quotedPrintable
" ScalarField quotedPrintable "

	^self contentTransferEncoding: 'quoted-printable'
! !

!ScalarField class methodsFor:'parsing'!

fieldNames
	^#('message-id' 'content-id' 'content-transfer-encoding' 'transfer-encoding' 'content-encoding')
! !

!ScalarField methodsFor:'parsing'!

doParse: rfc822Stream
	^self tokenizedValueFrom: rfc822Stream
! !

!ScalarField class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__ScalarField.st,v 1.2 2008/09/03 08:57:13 cg Exp $'
! !
