"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

ValueWithParametersField subclass:#SingleValueWithParametersField
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-MIME'
!


!SingleValueWithParametersField methodsFor:'accessing'!

canMerge
	^false
!

localValue
	^self element value
!

localValue: aString
	self element value: aString
!

parameterAt: aName

	^self element paramAt: aName
!

parameterAt: aName ifAbsent: aBlock

	^self element paramAt: aName ifAbsent: [aBlock value]
!

parameterAt: aName put: aValue

	self element paramAt: aName put: aValue
!

value
	value isNil
		ifTrue: [ value := OrderedCollection with: (ValueWithParams newWithSeparators: self separators)].
	^value
! !

!SingleValueWithParametersField methodsFor:'composing'!

writeValueOn: aStream encoding: aString
" Default implementation is the same as inherited. Subclasses can override it "

	self value ~~ nil
		ifTrue:
			[self value
				do: [ :param |  param writeOn: aStream encoding: aString ]
				separatedBy: [aStream nextPut: self groupSeparator].
			aStream cr.].
! !

!SingleValueWithParametersField methodsFor:'parsing'!

parse: scanner

	value := self doParse: scanner.
	value size > 1 ifTrue: [ ^scanner notify: (#WrongParametersNumber << #net >> 'Wrong parameters number').].
! !

!SingleValueWithParametersField class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__SingleValueWithParametersField.st,v 1.1 2004/11/12 10:45:46 penk Exp $'
! !
