"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/net' }"

"{ NameSpace: Net }"

ScalarField subclass:#VersionField
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'NetClients-MIME'
!

VersionField comment:'This class represents version fields. Version is used in MIME and in HTTP.
Version field syntax for MIME messages is as follows:

     version := "MIME-Version" ":" 1*DIGIT "." 1*DIGIT

     MIME-Version: 1.0'
!

!VersionField class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2004 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!VersionField class methodsFor:'parsing'!

fieldNames
	^#('mime-version' 'http-version')
! !

!VersionField methodsFor:'accessing'!

majorVersion
	^(self parseVersion: self value) first
!

majorVersion: numberOrString
	| arr |

	arr := self parseVersion: self value.
	arr at: 1 put: numberOrString.
	self versionStringFrom: arr.
!

minorVersion
	^(self parseVersion: self value) last
!

minorVersion: numberOrString
	| arr |

	arr := self parseVersion: self value.
	arr at: 2 put: numberOrString.
	self versionStringFrom: arr.
!

version

	^self value
!

version: string
	self value: string
!

versionStringFrom: arr
	^(arr first printString), $., (arr last printString)
! !

!VersionField methodsFor:'parsing'!

parseVersion: string
	| arr |

	(string isNil or: [ string isEmpty ]) ifTrue: [ ^Array new: 2 ].

	arr := string tokensBasedOn: $..
	arr size < 2
		ifTrue: [ ^self notify: (#VersionShouldBeSpecifiedAs << #net >> 'Version should be specified as <major version>.<minor version>')].
	^arr
! !

!VersionField class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__VersionField.st,v 1.2 2009/09/29 20:05:55 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/Net__VersionField.st,v 1.2 2009/09/29 20:05:55 cg Exp $'
! !
