"{ Package: 'stx:goodies/net/ldap' }"

"{ NameSpace: LDAP }"

BERElement subclass:#BERConstruct
	instanceVariableNames:'elements'
	classVariableNames:''
	poolDictionaries:''
	category:'LDAP-BER'
!


!BERConstruct class methodsFor:'as yet unclassified'!

new
	^ self basicNew initialize
! !

!BERConstruct methodsFor:'as yet unclassified'!

addElement: anElement
	self addElement: anElement withTag: nil
!

addElement: anElement withTag: aContextTag
	| taggedElement |
	taggedElement := Association new;
		key: aContextTag value: anElement.
	elements addLast: taggedElement
!

decode: aStream
	| elementLen part |
	
	elementLen := self length.
	[elementLen > 0]
		whileTrue: [
			part := self class newFrom: aStream.
			elementLen := elementLen - part totalLength.
			self addElement: part ]
!

elements
	^ elements
!

initialize
	super initialize.
	elements := OrderedCollection new
!

writeBodyOn: aStream
        | data dataStream |
        data := String new "Array new".
        dataStream := WriteStream on: data.
        
        elements do: [:taggedElement |
                taggedElement value writeOn: dataStream withTag: (taggedElement key) ].
        
        "shouldnt we move this somewhere else?"
        data := dataStream contents.
        self writeLength: (data size) on: aStream.
        aStream nextPutAll: data
! !

!BERConstruct class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/ldap/LDAP__BERConstruct.st,v 1.1 2009/11/28 00:15:01 cg Exp $'
! !
