"{ Package: 'stx:goodies/net/ldap' }"

"{ NameSpace: LDAP }"

Object subclass:#BERElement
	instanceVariableNames:'length lengthLength value tagHeader tagLength'
	classVariableNames:''
	poolDictionaries:''
	category:'LDAP-BER'
!


!BERElement class methodsFor:'as yet unclassified'!

elementClasses
	^ {
		BERInteger. BEROctetString . BERSequence. BEREnumerated. BERBoolean. BERSet. BERNull.

		"this has to go here for now"
		LDAPAddResult. LDAPBindResult. LDAPCompareResult. LDAPDelResult. LDAPExtendedResult.
		LDAPModifyResult. LDAPModifyDNResult. LDAPSearchResultEntry. LDAPSearchResultCode.
	}.
	
!

identifyIncomingElement: firstByte
	| type |
	"so why are we doing this in a comparision here, instead of asking the class wether it handles the element?"
	type := self elementClasses detect: [ :each | each tagValue = firstByte asInteger ] ifNone: [nil].
	^ type
	
!

new
	"this is here only to easily see who is using it down the heriarchy through the browser"
	^ self basicNew initialize
!

newFrom: aStream
        | firstByte element elementClass |
        firstByte := aStream readWait; next.
        "Transcript show: '*** Next byte is: ', firstByte asString; cr."
        elementClass := self identifyIncomingElement: firstByte.
        elementClass ifNil: [
                LDAPException new messageText: 'invalid tag -- make sure class is in identifyIncomingElements'; signal ].
        element := elementClass new setTag: firstByte.
        "we should read the tag here, instead of just the first byte"
        element readLengthFrom: aStream.
        element decode: aStream.
        ^ element
!

tagValue
	self subclassResponsibility
! !

!BERElement methodsFor:'as yet unclassified'!

decode: aStream
	self subclassResponsibility
!

initialize
	tagHeader := 0
!

length
	^ length
!

lengthLength
	^ lengthLength
!

readLengthFrom: aStream
        | octets  firstOctet |
        
        firstOctet := aStream next asInteger.
        firstOctet < 128
                
                "short definite length"
                ifTrue: [ length := firstOctet. lengthLength := 1. ]
                
                "long definite length"
                ifFalse: [
                        octets := aStream next: (firstOctet bitXor: 128).
                        lengthLength := (firstOctet bitXor: 128) + 1. "the lengthlenghlength byte.. ugh."
                        length := octets inject: 0 into: [:injectedValue :each | (injectedValue bitShift: 8) + (each asInteger)]
                ].
                
        ^ length                        
!

setTag: aTag
	tagHeader := aTag.
	tagLength := 1
!

tagLength
	^ 1
!

tagSetApplication
	tagHeader := tagHeader bitOr: 16r40
!

tagSetContext
	tagHeader := tagHeader bitOr: 16r80
		
!

totalLength
	^ self length + self lengthLength + self tagLength
!

value
	^ value
!

value: aValue
	value := aValue
!

writeBodyOn: aStream
	self subclassResponsibility
!

writeLength: aLength on: aStream
        | octets octetsIndex remainderValue netOctets |
        
        octetsIndex := 1.
        aLength < 128
                
                "short definite length"
                ifTrue: [ aStream nextPut: aLength asCharacter ]
                
                "long definite length"
                ifFalse: [
                        "why were we using value in this block, instead of aLength?"
                        octets := ByteArray new: (aLength digitLength + 1).
                        remainderValue := aLength.
                        [remainderValue > 0] whileTrue: [
                                octets at: octetsIndex  put: (remainderValue bitAnd: 16rFF).
                                octetsIndex := octetsIndex + 1.
                                remainderValue := remainderValue bitShift: -8 ].
                        octets at: octetsIndex put: ((octetsIndex - 1) bitOr: 128).
                        
                        "hton"
                        netOctets := ByteArray new: octetsIndex.
                        (1 to: octetsIndex)
                                do: [:i | netOctets at: i put: (octets at: (octetsIndex + 1) - i) ].
                        
                        aStream nextPutAll: (netOctets asString).
                ].
                
        ^ octetsIndex                   
!

writeOn: aStream
        aStream nextPut: ((self class tagValue bitOr: tagHeader) asCharacter).
        self writeBodyOn: aStream
!

writeOn: aStream withTag: aTag
        | combinedTag |
        combinedTag := self class tagValue bitOr: tagHeader.

        "here we are supposing that if we are given a tag, we dont need the universal tag value
         im not really sure on wether its correct or not ."
        
        "however, we are in .25 and its proved to be correct so far"                    
        
        aTag ifNotNil: [
                combinedTag := ((combinedTag bitOr: 31)  bitXor: 31).
                combinedTag := combinedTag bitOr: aTag ].

        aStream nextPut: (combinedTag asCharacter).
        self writeBodyOn: aStream
! !

!BERElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/ldap/LDAP__BERElement.st,v 1.3 2009/11/30 20:43:57 stefan Exp $'
! !
