"{ Package: 'stx:goodies/net/ldap' }"

"{ NameSpace: LDAP }"

LDAPRequest subclass:#LDAPCompareRequest
	instanceVariableNames:'searchResult'
	classVariableNames:''
	poolDictionaries:''
	category:'LDAP-Core'
!


!LDAPCompareRequest methodsFor:'as yet unclassified'!

checkForExceptions
	"Check to see if a response caused an exception and if so, raise it"
	self isDone ifFalse:[^self error: 'LDAP timeout'].
	searchResult checkForExceptions.
!

initializeWith: anLDAPWorker dn: aDN comparing: anEqualityFilter
	self initializeWith: anLDAPWorker.
	anLDAPWorker send:
		(LDAPEncoder compareRequest: messageId dn: aDN comparing: anEqualityFilter).
!

processResponse: aMessage
	isDone := true.
	searchResult := aMessage.
	aMessage resultCode = 5 ifTrue: [ result := false ].
	aMessage resultCode = 6 ifTrue: [ result := true ].
	"we save nil for execptions"
	waitingSemaphore signal.
! !

!LDAPCompareRequest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/ldap/LDAP__LDAPCompareRequest.st,v 1.1 2009/11/28 00:17:02 cg Exp $'
! !
