"{ Package: 'stx:goodies/net/ldap' }"

"{ NameSpace: LDAP }"

Object subclass:#LDAPFilter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'LDAP-Core'
!


!LDAPFilter class methodsFor:'as yet unclassified'!

andOf: someFilters
	| set |
	set := LDAPFilterAnd new.
	someFilters do: [ :each | set add: each ].
	^ set
!

containing: aSubstring atAnywhereOf: anAttrType
	^ LDAPFilterSubstrings containing: aSubstring atAnywhereOf: anAttrType
!

containing: aSubstring atEndOf: anAttrType
	^ LDAPFilterSubstrings containing: aSubstring atEndOf: anAttrType
!

containing: aSubstring atStartOf: anAttrType
	^ LDAPFilterSubstrings containing: aSubstring atStartOf: anAttrType
!

not: aFilter
	^ LDAPFilterNot filter: aFilter
!

orOf: someFilters
	| set |
	set := LDAPFilterOr new.
	someFilters do: [ :each | set add: each ].
	^ set
!

with: anAttrType
	^ LDAPFilterPresent having: anAttrType
!

with: anAttrType equalTo: anAttrValue
	^ LDAPFilterEquality new setType: anAttrType value: anAttrValue
!

with: anAttrType greaterOrEqualThan: anAttrValue
	^ LDAPFilterGreaterOrEqual new setType: anAttrType value: anAttrValue
	
!

with: anAttrType lessOrEqualThan: anAttrValue
	^ LDAPFilterLessOrEqual new setType: anAttrType value: anAttrValue
!

with: anAttrType notEqualTo: anAttrValue
	^self not: (self with: anAttrType equalTo: anAttrValue)
! !

!LDAPFilter class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/ldap/LDAP__LDAPFilter.st,v 1.1 2009/11/28 00:18:08 cg Exp $'
! !
