"{ Package: 'stx:goodies/net/ldap' }"

"{ NameSpace: LDAP }"

LDAPMessage subclass:#LDAPResult
	instanceVariableNames:'resultCode errorMessage matchedDN referral'
	classVariableNames:''
	poolDictionaries:''
	category:'LDAP-Core'
!


!LDAPResult class methodsFor:'as yet unclassified'!

tagValue
	self subclassResponsibility
! !

!LDAPResult methodsFor:'as yet unclassified'!

checkForExceptions
    (resultCode ~= 0 and:[ resultCode ~= 5 ] and:[ resultCode ~= 6 ]) ifTrue:[
        |ex|

        ex := LDAPException newWithCode:resultCode.
        errorMessage notEmptyOrNil ifTrue:[
            ex messageText:errorMessage
        ].
        ex raise.
    ]
!

decode: aStream
	| berResultCode berErrorMessage berMatchedDN lengthRemaining |
		
	berResultCode := BERElement newFrom: aStream.
	berMatchedDN := BERElement newFrom: aStream.
	berErrorMessage := BERElement newFrom: aStream.
	
	resultCode := berResultCode value.
	errorMessage := berErrorMessage value.
	matchedDN := berMatchedDN value.

	"actually its not that its not implemented, but that berReferral value is not a string but instead a sequence of them"
	lengthRemaining := berResultCode totalLength + berMatchedDN totalLength + berErrorMessage totalLength.	
	lengthRemaining - self length ~= 0 ifTrue: [
		| berReferral |
		berReferral := BERElement newFrom: aStream.
		referral :=  berReferral value.
		self notYetImplemented. 
	  ].

"XXXX: Commented out so that we do not raise errors in the response handling of the worker but rather once the response has been passed on to the sender.	
	self checkForExceptions.
"
!

referral
	^ referral
!

referral: aReferral
	referral := aReferral
!

resultCode
	^ resultCode
! !

!LDAPResult class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/ldap/LDAP__LDAPResult.st,v 1.3 2009/12/03 13:52:31 stefan Exp $'
! !
