"{ Package: 'stx:goodies/net/ldap' }"

"{ NameSpace: LDAP }"

LDAPMessage subclass:#LDAPSearchResultEntry
	instanceVariableNames:'dn attrs'
	classVariableNames:''
	poolDictionaries:''
	category:'LDAP-Core'
!


!LDAPSearchResultEntry class methodsFor:'as yet unclassified'!

isEndMarker
	^ false
!

tagValue
	^ 16r64
! !

!LDAPSearchResultEntry methodsFor:'as yet unclassified'!

attrAt: aKey
	| selected |
	selected := attrs at: (aKey asByteArray) ifAbsent: [ ^ nil ].
	^ selected first asString.
!

attrs
	"I return a Dictionary with an entry per attr. Eeach attr is an OrderedCollection, as there may be multiple values per attr."
	^ attrs
!

decode: aStream
	| berDN berAttrs |

	berDN := BERElement newFrom: aStream.
	berAttrs := BERElement newFrom: aStream.

	attrs := Dictionary new.
	berAttrs elements do: [ :eachBerAttr | | values |
		
		values := OrderedCollection new.
		((eachBerAttr value) elements at: 2) value elements do: [ :eachBerValue |	
			values add: (eachBerValue value value) asString].
		
		attrs
			at: (((eachBerAttr value) elements at: 1) value value) asString
			put: values ].

	dn := berDN value asString.
!

dn
	^ dn
! !

!LDAPSearchResultEntry methodsFor:'printing'!

printOn:aStream
    aStream 
        nextPutAll:self class nameWithoutPrefix;
        nextPut:$(.
   dn printOn:aStream.
   aStream nextPut:$).
! !

!LDAPSearchResultEntry class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/ldap/LDAP__LDAPSearchResultEntry.st,v 1.2 2009/12/02 16:02:56 stefan Exp $'
! !
