"{ Package: 'stx:goodies/net/ldap' }"

LibraryDefinition subclass:#stx_goodies_net_ldap
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_net_ldap class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:libbasic'    "Error - superclass of LDAP::LDAPAttrProblemException "
        #'stx:libbasic2'    "Socket - referenced by LDAP::LDAPWorker>>connect "
    )
! !

!stx_goodies_net_ldap class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'LDAP::BERElement'
        #'LDAP::LDAPAttrModifier'
        #'LDAP::LDAPConnection'
        #'LDAP::LDAPEncoder'
        #'LDAP::LDAPException'
        #'LDAP::LDAPFilter'
        #'LDAP::LDAPFilterSingle'
        #'LDAP::LDAPRequest'
        #'LDAP::LDAPWorker'
        #'stx_goodies_net_ldap'
        #'LDAP::BERBoolean'
        #'LDAP::BERConstruct'
        #'LDAP::BERInteger'
        #'LDAP::BERNull'
        #'LDAP::BEROctetString'
        #'LDAP::LDAPAbandonRequest'
        #'LDAP::LDAPAddRequest'
        #'LDAP::LDAPAttrProblemException'
        #'LDAP::LDAPBindRequest'
        #'LDAP::LDAPCompareRequest'
        #'LDAP::LDAPDelRequest'
        #'LDAP::LDAPElement'
        #'LDAP::LDAPFilterWithFilter'
        #'LDAP::LDAPFilterWithSet'
        #'LDAP::LDAPFilterWithSubstring'
        #'LDAP::LDAPFilterWithType'
        #'LDAP::LDAPFilterWithValueAssertion'
        #'LDAP::LDAPMessage'
        #'LDAP::LDAPModifyDNRequest'
        #'LDAP::LDAPModifyOp'
        #'LDAP::LDAPModifyRequest'
        #'LDAP::LDAPNameProblemException'
        #'LDAP::LDAPSearchRequest'
        #'LDAP::LDAPSecurityProblemException'
        #'LDAP::LDAPServiceProblemException'
        #'LDAP::LDAPUnbindRequest'
        #'LDAP::LDAPUpdateProblemException'
        #'LDAP::BEREnumerated'
        #'LDAP::BERSequence'
        #'LDAP::BERSet'
        #'LDAP::LDAPFilterAnd'
        #'LDAP::LDAPFilterApprox'
        #'LDAP::LDAPFilterEquality'
        #'LDAP::LDAPFilterGreaterOrEqual'
        #'LDAP::LDAPFilterLessOrEqual'
        #'LDAP::LDAPFilterNot'
        #'LDAP::LDAPFilterOr'
        #'LDAP::LDAPFilterPresent'
        #'LDAP::LDAPFilterSubstrings'
        #'LDAP::LDAPModifyAddOp'
        #'LDAP::LDAPModifyDelOp'
        #'LDAP::LDAPModifyReplaceOp'
        #'LDAP::LDAPResult'
        #'LDAP::LDAPSearchResultEntry'
        #'LDAP::LDAPAddResult'
        #'LDAP::LDAPBindResult'
        #'LDAP::LDAPCompareResult'
        #'LDAP::LDAPDelResult'
        #'LDAP::LDAPExtendedResult'
        #'LDAP::LDAPModifyDNResult'
        #'LDAP::LDAPModifyResult'
        #'LDAP::LDAPSearchResultCode'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!stx_goodies_net_ldap class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X LDAP Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Dual licensed under both SqueakL and MIT. '
! !

!stx_goodies_net_ldap class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/ldap/stx_goodies_net_ldap.st,v 1.1 2009/11/28 00:38:04 cg Exp $'
! !
