"{ Package: 'stx:goodies/net' }"

LibraryDefinition subclass:#stx_goodies_net
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_net class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:libbasic'    "Error - superclass of Net::ConnectionClosedError "
        #'stx:libbasic2'    "List - referenced by Net::IMAPProtocolInterpreter class>>debugLabelsAndValues "
        #'stx:libview2'    "MIMETypes - referenced by Net::MimeTypeDescriptor class>>guessFromExtension: "
    )
! !

!stx_goodies_net class methodsFor:'description - compilation'!

additionalDefinitions_bc_dot_mak
    ^ '
# see stdHeader_bc for GOODIES_NET_BASE
LIB_BASE_LD_ARG=-b:$(GOODIES_NET_BASE)
'
! !

!stx_goodies_net class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'Net::ConnectionClosedError'
        #'Net::ConnectionFailedError'
        #'Net::CrLfStream'
        #'Net::IMAPClientHandler'
        #'Net::IMAPCommand'
        #'Net::IMAPCommandSequencer'
        #'Net::IMAPFetchedItem'
        #'Net::IMAPFetchedItemSectionSpecification'
        #'Net::IMAPProtocolInterpreter'
        #'Net::IMAPResponse'
        #'Net::IMAPState'
        (#'Net::IMAPTest' autoload)
        #'Net::LetterInTransit'
        #'Net::MailIncrementNotification'
        #'Net::Mailbox'
        #'Net::MessageDispatcher'
        #'Net::MessageElement'
        #'Net::MessageHandler'
        #'Net::MimeTypeDescriptor'
        #'Net::NetClientError'
        #'Net::NetEnvironment'
        #'Net::NetResponse'
        #'Net::NetUser'
        #'Net::PrependDotStream'
        #'Net::RemoveDotStream'
        #'Net::Reporter'
        #'Net::SimpleScanner'
        #'Net::TCP'
        #'Net::ValueWithParams'
        #'stx_goodies_net'
        #'Net::HeaderField'
        #'Net::IMAPAuthenticatedState'
        #'Net::IMAPBodyFetchedItem'
        #'Net::IMAPBodyRFC822FetchedItem'
        #'Net::IMAPBodySectionFetchedItem'
        #'Net::IMAPBodyStructureFetchedItem'
        #'Net::IMAPErrorResponse'
        #'Net::IMAPFetchedItemHeaderSectionSpecification'
        #'Net::IMAPMailbox'
        #'Net::IMAPMessageEnvelopeFetchedItem'
        #'Net::IMAPMessageMetadataFetchedItem'
        #'Net::IMAPNonAuthenticatedState'
        #'Net::IMAPResponseStatus'
        #'Net::INIScanner'
        #'Net::LoginIncorrectError'
        #'Net::MailScanner'
        #'Net::MessageBuildHandler'
        #'Net::MessageHeader'
        #'Net::MessageParser'
        #'Net::MessagePrintHandler'
        #'Net::MimeEncodedWordCoDec'
        #'Net::MimeEntity'
        #'Net::MimeEntityBot'
        #'Net::MimeMessageBody'
        #'Net::NetClient'
        #'Net::NetProtocolInterpreter'
        #'Net::NetworkEntityDescriptor'
        #'Net::PluggableReporter'
        #'Net::ProtocolError'
        #'Net::IMAPClient'
        #'Net::IMAPResponseTagged'
        #'Net::IMAPScanner'
        #'Net::IMAPSelectedState'
        #'Net::MailBuildHandler'
        #'Net::MailGroupDescriptor'
        #'Net::MailMessageBot'
        #'Net::MimeMultipartEntity'
        #'Net::MultipartBody'
        #'Net::NetworkAddressDescriptor'
        #'Net::RFC822Scanner'
        #'Net::SimpleBody'
        #'Net::StructuredHeaderField'
        #'Net::CollectionField'
        #'Net::IMAPScannerSpecial'
        #'Net::MimeScanner'
        #'Net::NetworkAddressParser'
        #'Net::RFC822Message'
        #'Net::ScalarField'
        #'Net::ValueWithParametersField'
        #'Net::DateField'
        #'Net::MailMessage'
        #'Net::MailboxListField'
        #'Net::NumericField'
        #'Net::SingleMailboxField'
        #'Net::SingleValueWithParametersField'
        #'Net::VersionField'
        #'Net::ContentDispositionField'
        #'Net::ContentTypeField'
        #'Net::Pop3StateError'
        #'Net::Pop3Client'
        #'Net::Pop3Status'
        #'Net::Pop3Mailbox'
    )
!

extensionMethodNames
    ^ #(
    )
! !

!stx_goodies_net class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Net Communication'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'

    "Modified: / 01-02-2011 / 11:52:56 / cg"
! !

!stx_goodies_net class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/net/stx_goodies_net.st,v 1.14 2011/02/01 10:58:31 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/net/stx_goodies_net.st,v 1.14 2011/02/01 10:58:31 cg Exp $'
! !
