"{ NameSpace: NN }"

Object subclass:#NeuralNetworkTrainer
	instanceVariableNames:'network'
	classVariableNames:''
	poolDictionaries:''
	category:'Neural Networks'
!

NeuralNetworkTrainer comment:'I am an abstract class. My subclasses are concrete implementations of training algorithms for neural networks.
'!


!NeuralNetworkTrainer class methodsFor:'instance creation'!

network: aNeuralNetwork
	^ self new network: aNeuralNetwork!

new
	^ super new initialize! !

!NeuralNetworkTrainer methodsFor:'accessing'!

epoch: aCollectionOfAssociations
        "Run an epoch."
        | indices index |
        indices _ (1 to: aCollectionOfAssociations size) asOrderedCollection.
        [indices isEmpty] whileFalse: [
                index _ indices atRandom.
                self sample: (aCollectionOfAssociations at: index) key
                        desired: (aCollectionOfAssociations at: index) value.
                indices remove: index]
!

epoch: aCollectionOfAssociations times: anInteger
	"Run anInteger epochs."
	anInteger timesRepeat: [self epoch: aCollectionOfAssociations]!

network
	^ network!

network: aNeuralNetwork
	network _ aNeuralNetwork!

sample: aCollection desired: anotherCollection
	self subclassResponsibility! !

!NeuralNetworkTrainer methodsFor:'initialization'!

initialize
	"do nothing; overriden by subclasses"! !

!NeuralNetworkTrainer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/neuralNetworks/NeuralNetworkTrainer.st,v 1.1 1999/07/26 14:42:33 cg Exp $'
! !
