"{ NameSpace: NN }"

NeuralNetwork subclass:#PerceptronNetwork
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Neural Networks'
!

PerceptronNetwork comment:'My instances are multiplayer-perceptron neural networks. See the comment in BackPropagationTrainer class.'!


!PerceptronNetwork methodsFor:'accessing'!

depth
	"Answer the depth of the receiver."
	| answer |
	answer _ 0.
	self outputs do: [ :each | answer _ answer max: each depth].
	^ answer!

hiddenLayers
	"Answer the ordered hidden layers of the receiver."
	^ (2 to: self depth - 1) collect: [ :each | self hidden select: [ :other | other depth = each]]!

trainer
	"Answer an appropiate trainer for the receiver."
	^ BackPropagationTrainer network: self!

valueAt: aCollection
	"Answer the output corresponding to the inputs given by the argument."
	self reset.
	1 to: aCollection size do: [ :each |
		(self inputs at: each) signal: (aCollection at: each)].
	^ self outputs collect: [ :each | each signal]! !

!PerceptronNetwork class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/neuralNetworks/PerceptronNetwork.st,v 1.1 1999/07/26 14:42:17 cg Exp $'
! !
