"{ NameSpace: NN }"

Object subclass:#SigmoidFunction
	instanceVariableNames:'slope'
	classVariableNames:''
	poolDictionaries:''
	category:'Neural Networks'
!


!SigmoidFunction class methodsFor:'instance creation'!

new
	^ super new initialize! !

!SigmoidFunction methodsFor:'accessing'!

derivativeValueAt: aNumber
	"Answer the value of the derivative of the receiver at the argument."
	| val |
	^ self slope * (val _ self valueAt: aNumber) * (1.0 - val)!

slope
	"Answer the slope of the reciver."
	^ slope!

slope: aNumber
	"Change the slope of the receiver."
	slope _ aNumber!

valueAt: aNumber
	"Answer the value of the receiver at the argument."
	^ ((aNumber * self slope negated) exp + 1.0) reciprocal! !

!SigmoidFunction methodsFor:'initialization'!

initialize
	self slope: 1.0! !

!SigmoidFunction class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/neuralNetworks/SigmoidFunction.st,v 1.1 1999/07/26 14:42:10 cg Exp $'
! !
