"{ NameSpace: NN }"

Object subclass:#TanhFunction
	instanceVariableNames:'slope'
	classVariableNames:''
	poolDictionaries:''
	category:'Neural Networks'
!


!TanhFunction class methodsFor:'instance creation'!

new
	^ super new initialize! !

!TanhFunction methodsFor:'accessing'!

derivativeValueAt: aNumber
	"Answer the value of the derivative of the receiver at the argument."
	^ 1.0 - (self valueAt: aNumber) squared * self slope * 0.5!

slope
	"Answer the slope of the receiver."
	^ slope!

slope: aNumber
	"Change the slope of the receiver."
	slope _ aNumber!

valueAt: aNumber
	"Answer the value of the receiver at the argument."
	| ex |
	^ (ex _ (aNumber * self slope negated) exp) negated + 1.0 / (ex + 1.0)! !

!TanhFunction methodsFor:'initialization'!

initialize
	self slope: 1.0! !

!TanhFunction class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/neuralNetworks/TanhFunction.st,v 1.1 1999/07/26 14:41:59 cg Exp $'
! !
