"{ Package: 'stx:goodies/oMeta2' }"

Object subclass:#OM2Stream
	instanceVariableNames:'head tail memo'
	classVariableNames:''
	poolDictionaries:''
	category:'OMeta2'
!


!OM2Stream class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!OM2Stream methodsFor:'accessing'!

basicTail
    ^ tail

    "Modified: / 30-01-2011 / 00:53:05 / cg"
!

head
    ^ head

    "Modified: / 30-01-2011 / 00:53:09 / cg"
!

inputSpecies
    ^ Array

    "Modified: / 30-01-2011 / 00:53:14 / cg"
!

memo

    ^ memo
!

pos
    ^ -1

    "Modified: / 30-01-2011 / 00:53:17 / cg"
!

tail
    ^ tail

    "Modified: / 30-01-2011 / 00:53:22 / cg"
! !

!OM2Stream methodsFor:'forgetting'!

forgetEverything
    memo := IdentityDictionary new

    "Modified: / 30-01-2011 / 00:53:07 / cg"
!

transitiveForgetEverything
    |curr|

    curr := self.
    [ curr notNil ] whileTrue:[
        curr forgetEverything.
        curr := curr basicTail
    ]

    "Modified: / 30-01-2011 / 00:53:26 / cg"
! !

!OM2Stream methodsFor:'initialize-release'!

initHead:h tail:t 
    head := h.
    tail := t

    "Modified: / 30-01-2011 / 00:53:10 / cg"
!

initialize
    memo := IdentityDictionary new

    "Modified: / 30-01-2011 / 00:53:12 / cg"
! !

!OM2Stream methodsFor:'printing & storing'!

printOn:aStream 
    |inputIsString curr|

    inputIsString := (self inputSpecies inheritsFrom:String) 
                and:[ (self inputSpecies inheritsFrom:Symbol) not ].
    curr := self.
    aStream
        nextPutAll:'an ';
        nextPutAll:self class name;
        nextPut:$(.
    [ curr notNil ] whileTrue:[
        (curr isKindOf:OM2EndOfStream) ifTrue:[
            aStream nextPut:$).
            ^ self
        ].
        inputIsString ifTrue:[
            aStream nextPut:curr head
        ] ifFalse:[
            curr head printOn:aStream.
            aStream space
        ].
        curr := curr basicTail.
    ].
    aStream nextPutAll:'...)'

    "Modified: / 30-01-2011 / 00:53:20 / cg"
! !

!OM2Stream class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/oMeta2/OM2Stream.st,v 1.2 2011/01/30 00:31:45 cg Exp $'
! !
