"{ Package: 'stx:goodies/oMeta2' }"

Object subclass:#OMeta2Base
	instanceVariableNames:'input om2streams haltingPoint'
	classVariableNames:''
	poolDictionaries:''
	category:'OMeta2'
!

!OMeta2Base class methodsFor:'others'!

compilerClass
    ^ OMeta2Compiler

    "Modified: / 30-01-2011 / 13:40:33 / cg"
!

debugMatch:anObject with:aRule 
    ^ self 
        debugMatch:anObject
        with:aRule
        withArgs:#()

    "Modified: / 30-01-2011 / 13:41:00 / cg"
!

debugMatch:anObject with:aRule withArgs:args 
    ^ self 
        debugMatchAll:{ anObject } readStream
        with:aRule
        withArgs:args

    "Modified: / 30-01-2011 / 13:41:05 / cg"
!

debugMatchAll:aSequenceableCollection with:aRule 
    ^ self 
        debugMatchAll:aSequenceableCollection
        with:aRule
        withArgs:#()

    "Modified: / 30-01-2011 / 13:41:08 / cg"
!

debugMatchAll:aSequenceableCollection with:aRule withArgs:args 
    ^ self 
        matchStream:aSequenceableCollection readStream
        with:aRule
        withArgs:args
        withPlaybackDebugging:true

    "Modified: / 30-01-2011 / 13:41:11 / cg"
!

match:anObject with:aRule 
    ^ self 
        match:anObject
        with:aRule
        withArgs:#()

    "Modified: / 30-01-2011 / 13:41:13 / cg"
!

match:anObject with:aRule withArgs:args 
    ^ self 
        matchAll:{ anObject } readStream
        with:aRule
        withArgs:args

    "Modified: / 30-01-2011 / 13:41:17 / cg"
!

matchAll:aSequenceableCollection with:aRule 
    ^ self 
        matchAll:aSequenceableCollection
        with:aRule
        withArgs:#()

    "Modified: / 30-01-2011 / 13:41:20 / cg"
!

matchAll:aSequenceableCollection with:aRule withArgs:args 
    ^ self 
        matchStream:aSequenceableCollection readStream
        with:aRule
        withArgs:args
        withPlaybackDebugging:false

    "Modified: / 30-01-2011 / 13:23:44 / cg"
!

matchStream:aReadStream with:aRule withArgs:args withPlaybackDebugging:debugging 
    |input matcher ans|

    input := OM2LazyStream for:aReadStream withPos:1.
    matcher := self new initInput:input.
    [
        matcher apply:#empty withArgs:args.
        ans := matcher apply:aRule.
        matcher apply:#end.
        ^ ans
    ] on:OM2Fail do:[:e | 
        |curr prev prevPrev|

        debugging ifFalse:[
            e signal
        ].
        curr := input.
        prev := nil.
        prevPrev := nil.
        [ curr notNil ] whileTrue:[
            prevPrev := prev.
            prev := curr.
            curr := curr basicTail
        ].
        curr := prevPrev ifNotNil:[ prevPrev ] ifNil:[ prev ].
        self inform:'will halt each time matcher reaches ' , curr printString.
        matcher
            initInput:input;
            forgetEverything.
        curr ifNil:[ self error:'you''ve found a bug -- please tell Alex' ].
        curr become:(OM2StreamDebugger for:curr copy).
        matcher haltingPoint:curr.
        matcher apply:#empty withArgs:args.
        ans := matcher apply:aRule.
        matcher apply:#end.
        ^ ans
    ]

    "Modified: / 30-01-2011 / 13:23:30 / cg"
!

matcherOn:aReadStream 
    |input matcher|

    input := OM2LazyStream for:aReadStream withPos:1.
    matcher := self new initInput:input.
    ^ matcher

    "Modified: / 30-01-2011 / 13:23:41 / cg"
!

new
    "return an initialized instance"

    ^ self basicNew initialize.
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/oMeta2/OMeta2Base.st,v 1.6 2011/01/30 12:57:15 cg Exp $'
! !

!OMeta2Base methodsFor:'others'!

? aBoolean 
    ^ self pred:aBoolean

    "Modified: / 30-01-2011 / 02:18:20 / cg"
!

anything
    |ans|

    ans := input head.
    input := input tail.
    ^ ans

    "Modified: / 30-01-2011 / 02:17:36 / cg"
!

apply
    |aRule|

    aRule := self apply:#anything.
    ^ self apply:aRule

    "Modified: / 30-01-2011 / 02:17:38 / cg"
!

apply:aRule 
    " A memoRec is an association whose key is the answer,
      and whose value is the next input. Failers pretend to
      be memoRecs, but throw a fail in response to #value"
    
    |memo memoRec|

    input == haltingPoint ifTrue:[
        self halt
    ].
    memo := input memo.
    memoRec := memo at:aRule ifAbsent:[ nil ].
    memoRec 
        isNil ifTrue:[
            |origInput failer ans|

            origInput := input.
            failer := OM2Failer new.
            memo at:aRule put:failer.
            ans := self perform:aRule.
            memoRec := ans -> input.
            memo at:aRule put:memoRec.
            failer used ifTrue:[
                |" left recursion detected "
                 sentinel keepGoing|

                sentinel := input.
                keepGoing := true.
                [ keepGoing ] whileTrue:[
                    [
                        input := origInput.
                        ans := self perform:aRule.
                        input == sentinel ifTrue:[
                            OM2Fail signal
                        ].
                        memoRec key:ans value:input.
                    ] on:OM2Fail do:[ keepGoing := false ]
                ]
            ]
        ].
    input := memoRec value.
    ^ memoRec key

    "Modified: / 30-01-2011 / 02:17:22 / cg"
!

apply:aRule withArgs:args 
    args reverseDo:[:a | input := OM2Stream new initHead:a tail:input ].
    ^ self perform:aRule

    "Modified: / 30-01-2011 / 02:17:27 / cg"
!

consumedBy:aBlock 
    |origInput i ws|

    origInput := input.
    aBlock value.
    ws := WriteStream on:origInput inputSpecies new.
    i := origInput.
    [ i == input ] whileFalse:[
        ws nextPut:i head.
        i := i tail
    ].
    ^ ws contents

    "Modified: / 30-01-2011 / 02:18:32 / cg"
!

empty
    ^ true

    "Created: / 30-01-2011 / 01:37:25 / cg"
!

firstAndRest
    |first rest|

    first := self apply:#anything.
    rest := self apply:#anything.
    ^ self 
        genericMany:[ self apply:rest ]
        into:(OrderedCollection with:(self apply:first))

    "Created: / 30-01-2011 / 01:37:44 / cg"
!

foreign
    |aGrammar aRule g ans|

    aGrammar := self apply:#anything.
    aRule := self apply:#anything.
    g := aGrammar new initInput:(OM2StreamProxy for:input).
    ans := g apply:aRule.
    input := g input target.
    ^ ans

    "Modified: / 30-01-2011 / 02:18:05 / cg"
!

forgetEverything
    input transitiveForgetEverything.
    om2streams valuesDo:[:s | s transitiveForgetEverything ]

    "Modified: / 30-01-2011 / 02:18:22 / cg"
!

form:aBlock 
    |v origInput|

    v := self apply:#anything.
    self 
        pred:(v isCollection and:[ v isSequenceable and:[ v isSymbol not ] ]).
    origInput := input.
    input := om2streams at:v
                ifAbsentPut:[ OM2LazyStream for:v readStream withPos:1 ].
    aBlock value.
    self apply:#end.
    input := origInput.
    ^ v

    "Modified: / 30-01-2011 / 02:18:09 / cg"
!

genericMany:aBlock into:anOrderedCollection 
    [
        |origInput|

        origInput := input.
        [
            anOrderedCollection addLast:aBlock value
        ] on:OM2Fail
                do:[
            input := origInput.
            ^ anOrderedCollection
        ].
        true
    ] whileTrue

    "Modified: / 30-01-2011 / 02:18:35 / cg"
!

haltingPoint:anOM2Stream 
    haltingPoint := anOM2Stream

    "Modified: / 30-01-2011 / 02:18:25 / cg"
!

indexConsumedBy:aBlock 
    |from to|

    from := self pos.
    aBlock value.
    to := self pos.
    ^ from -> to

    "Modified: / 30-01-2011 / 02:18:38 / cg"
!

initInput:i 
    input := i

    "Modified: / 30-01-2011 / 02:18:27 / cg"
!

initialize
    super initialize.
    om2streams := IdentityDictionary new

    "Modified: / 30-01-2011 / 00:53:42 / cg"
!

input
    ^ input

    "Modified: / 30-01-2011 / 02:18:11 / cg"
!

lookahead:aBlock 
    |origInput ans|

    origInput := input.
    ans := aBlock value.
    input := origInput.
    ^ ans

    "Modified: / 30-01-2011 / 02:18:40 / cg"
!

many1:aBlock 
    ^ self genericMany:aBlock into:(OrderedCollection with:aBlock value)

    "Modified: / 30-01-2011 / 02:18:42 / cg"
!

many:aBlock 
    ^ self genericMany:aBlock into:OrderedCollection new

    "Modified: / 30-01-2011 / 02:18:44 / cg"
!

not:aBlock 
    |origInput|

    origInput := input.
    [ aBlock value ] 
        on:OM2Fail
        do:[
            input := origInput.
            ^ true
        ].
    OM2Fail signal

    "Modified: / 30-01-2011 / 02:19:18 / cg"
!

ometaOr:choices 
    |origInput|

    origInput := input.
    choices do:[:choice | 
        input := origInput.
        [ ^ choice value ] on:OM2Fail do:[]
    ].
    OM2Fail signal

    "Modified: / 30-01-2011 / 02:19:32 / cg"
!

opt:aBlock 
    ^ self ometaOr:
            { [ aBlock value ].
            [ nil ] }

    "Modified: / 30-01-2011 / 02:19:35 / cg"
!

pos
    ^ input pos

    "Modified: / 30-01-2011 / 02:18:13 / cg"
!

pred: aBooleanValue

    " may want to have the compiler inline this automatically, for performance "
    aBooleanValue ifTrue: [^ true].
    OM2Fail signal

    "Modified: / 30-01-2011 / 01:50:38 / cg"
!

seq
    |xs|

    xs := self apply:#anything.
    xs do:[:x | 
        " may want to inline #apply:withArgs: below as an
             optimization, since this rule gets used a lot"
        self apply:#exactly withArgs:{ x }
    ].
    ^ xs

    "Modified: / 30-01-2011 / 02:18:15 / cg"
!

super:superclass apply:aRule withArgs:args 
    args reverseDo:[:a | input := OM2Stream new initHead:a tail:input ].
    ^ self 
        perform:aRule
        inClass:superclass
        withArguments:#()

    "Modified: / 30-01-2011 / 02:17:31 / cg"
! !

