"{ Package: 'stx:goodies/oMeta2' }"

ByteCodeCompiler subclass:#OMeta2Compiler
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'OMeta2'
!


!OMeta2Compiler methodsFor:'compiler interface'!

parserClass
    ^ self class

    "Modified: / 30-01-2011 / 00:50:38 / cg"
! !

!OMeta2Compiler methodsFor:'compiling methods'!

compile:aStringArg 
        forClass:aClass 
        inCategory:cat 
        notifying:requestor
        install:install 
        skipIfSame:skipIfSame 
        silent:silent 
        foldConstants:fold
        ifFail:failBlock

    "/ firt try OM2 syntax...
    [
        ^ self 
            compile:aStringArg
            in:aClass
            notifying:requestor
            ifFail:failBlock
    ] on:Error do:[
        ^ super
            compile:aStringArg 
            forClass:aClass 
            inCategory:cat 
            notifying:requestor
            install:install 
            skipIfSame:skipIfSame 
            silent:silent 
            foldConstants:fold
            ifFail:failBlock
    ].

    "Created: / 30-01-2011 / 03:34:34 / cg"
    "Modified: / 30-01-2011 / 12:18:29 / cg"
!

compile:origCode in:cls classified:aCategory notifying:notify ifFail:failBlock 
    ^ self 
        compile:origCode
        in:cls
        notifying:notify
        ifFail:failBlock

    "Modified: / 30-01-2011 / 00:50:20 / cg"
!

compile:origCode in:cls notifying:notify ifFail:failBlock 
    |origCodeStream parseTree structuredCode translatedCode method compiler|

    origCodeStream := origCode asString readStream.
    self from:origCodeStream class:cls context:nil notifying:notify.

    [
        parseTree := OMeta2RuleParser 
                    matchStream:origCodeStream
                    with:#rule
                    withArgs:#()
                    withPlaybackDebugging:false.
        parseTree := OMeta2Optimizer match:parseTree with:#optimizeRule.
        structuredCode := OMeta2RuleTranslator 
                    match:parseTree
                    with:#translate
                    withArgs:{ cls }.
        translatedCode := OMeta2Flattener match:structuredCode with:#flatten
    ] on:OM2Fail do:[
        "/ self notify:'<-- parse error around here -->' at:origCodeStream position.
        ^ failBlock value
    ].
    compiler := Compiler new.
    compiler parserFlags:(compiler parserFlags copy warnings:false; yourself).
    method := compiler
        compile:translatedCode "readStream"
        in:cls
        notifying:notify
        ifFail:failBlock.
    method source:origCode string.
    ^ method

    "Modified: / 30-01-2011 / 13:43:35 / cg"
! !

!OMeta2Compiler methodsFor:'parsing'!

parse:aStream class:aClass noPattern:noPattern context:ctxt notifying:req ifFail:aBlock 
    ^ [
        |parseTree structuredCode code|

        parseTree := OMeta2RuleParser matchAll:aStream contents with:#rule.
        structuredCode := OMeta2RuleTranslator 
                    match:parseTree
                    with:#translate
                    withArgs:{ aClass }.
        code := OMeta2Flattener match:structuredCode with:#flatten.
        Parser new 
            parse:code readStream
            class:aClass
            noPattern:noPattern
            context:ctxt
            notifying:req
            ifFail:aBlock
    ] on:OM2Fail do:[ aBlock value ]

    "Modified: / 30-01-2011 / 00:50:32 / cg"
! !

!OMeta2Compiler class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/oMeta2/OMeta2Compiler.st,v 1.10 2011/01/30 12:43:43 cg Exp $'
! !
