"{ Package: 'stx:goodies/oMeta2' }"

OMeta2 subclass:#OMeta2Examples
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'OMeta2-Examples'
!

!OMeta2Examples class methodsFor:'others'!

documentation
"
  Here's how to run these examples:

    OMeta2Examples match: 5 with: #fact.
    OMeta2Examples matchAll: '1234' with: #number.
    OMeta2Examples matchAll: 'abc123' with: #identifier.
    OMeta2Examples matchAll: #($a $b $c 1 2 3 #(4 5)) with: #structure.
    OMeta2Examples matchAll: 'howdy' with: #greeting.
"
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/oMeta2/OMeta2Examples.st,v 1.4 2011/01/31 13:21:19 cg Exp $'
! !

!OMeta2Examples methodsFor:'others'!

aSqueakMethod
    self inform:'hello world'

    "Modified: / 30-01-2011 / 00:50:48 / cg"
!

anotherSqueakMethod
    self inform:'good-bye world'

    "Modified: / 30-01-2011 / 00:50:55 / cg"
!

digit
    |t1|

    ^ true ifTrue:[
        t1 := self 
                    super:OMeta2
                    apply:#digit
                    withArgs:{}.
        t1 digitValue
    ]

    "Modified: / 30-01-2011 / 00:51:01 / cg"
!

fact
    |t1 t2|

    ^ self ometaOr:
            { [
            true ifTrue:[
                self apply:#exactly withArgs:{ 0 }.
                1
            ]
        ].
            [
            true ifTrue:[
                t1 := self apply:#anything.
                t2 := self apply:#fact withArgs:{ t1 - 1 }.
                t1 * t2
            ]
        ] }

    "Modified: / 30-01-2011 / 00:51:06 / cg"
!

formTest
    ^ self ometaOr:
            { [
            self 
                form:[
                    true ifTrue:[
                        self inform:input hash printString.
                        self apply:#exactly withArgs:{ #foo }.
                        self apply:#exactly withArgs:{ #bar }
                    ]
                ]
        ].
            [
            self 
                form:[
                    true ifTrue:[
                        self inform:input hash printString.
                        self apply:#exactly withArgs:{ #bar }
                    ]
                ]
        ] }

    "Modified: / 30-01-2011 / 00:51:10 / cg"
!

greeting
    ^ self 
        consumedBy:[
            true ifTrue:[
                self apply:#seq withArgs:{ 'howdy' }.
                self opt:[ self apply:#seq withArgs:{ '-ho' } ]
            ]
        ]

    "Modified: / 30-01-2011 / 00:51:13 / cg"
!

identifier
    ^ true ifTrue:[
        self apply:#spaces.
        self 
            consumedBy:[
                true ifTrue:[
                    self apply:#letter.
                    self 
                        many:[
                            self ometaOr:
                                    { [ self apply:#letter ].
                                    [ self apply:#digit ] }
                        ]
                ]
            ]
    ]

    "Modified: / 30-01-2011 / 00:51:17 / cg"
!

identifierIdx
    ^ true ifTrue:[
        self apply:#spaces.
        self 
            indexConsumedBy:[
                true ifTrue:[
                    self apply:#letter.
                    self 
                        many:[
                            self ometaOr:
                                    { [ self apply:#letter ].
                                    [ self apply:#digit ] }
                        ]
                ]
            ]
    ]

    "Modified: / 30-01-2011 / 00:51:21 / cg"
!

identifiers
    ^ self 
        many:[
            true ifTrue:[
                self inform:self pos printString.
                self apply:#identifier
            ]
        ]

    "Modified: / 30-01-2011 / 00:51:23 / cg"
!

number
    |t1 t2|

    ^ self ometaOr:
            { [
            true ifTrue:[
                t1 := self apply:#number.
                t2 := self apply:#digit.
                t1 * 10 + t2
            ]
        ].
            [ self apply:#digit ] }

    "Modified: / 30-01-2011 / 00:51:25 / cg"
!

structure
    ^ true ifTrue:[
        self apply:#exactly withArgs:{ $a }.
        self apply:#exactly withArgs:{ $b }.
        self apply:#exactly withArgs:{ $c }.
        self apply:#exactly withArgs:{ 1 }.
        self apply:#exactly withArgs:{ 2 }.
        self apply:#exactly withArgs:{ 3 }.
        self form:[ self many:[ self apply:#anything ] ]
    ]

    "Modified: / 30-01-2011 / 00:51:27 / cg"
! !

