"{ Package: 'stx:goodies/oMeta2' }"

OMeta2 subclass:#OMeta2RuleParser
	instanceVariableNames:'temps'
	classVariableNames:''
	poolDictionaries:''
	category:'OMeta2'
!


!OMeta2RuleParser class methodsFor:'as yet unclassified'!

isOMeta2Rule:aString 
    ^ [
        (self matchAll:aString with:#rule) first ~= #Squeak
    ] on:OM2Fail do:[ false ]

    "Modified: / 30-01-2011 / 03:26:25 / cg"
! !

!OMeta2RuleParser methodsFor:'initialize-release'!

initialize

      super initialize.
      temps := IdentitySet new
! !

!OMeta2RuleParser methodsFor:'rules'!

application
    |kindOfApply rule args|

    self ometaOr:
            { [
            self apply:#token withArgs:{ '^' }.
            kindOfApply := #SuperApp
        ].
            [ kindOfApply := #App ] }.
    rule := self apply:#name.
    args := self apply:#args.
    ^ (OrderedCollection with:kindOfApply)
        add:rule;
        addAll:args;
        yourself

    "Modified: / 30-01-2011 / 03:24:41 / cg"
!

args
    |ans|

    ^ self ometaOr:
            { [
            self apply:#exactly withArgs:{ $( }.
            ans := self apply:#listOf
                        withArgs:
                            { #squeakExpression.
                            '.' }.
            self apply:#token withArgs:{ ')' }.
            ans
        ].
            [
            self not:[ self apply:#exactly withArgs:{ $( } ].
            #()
        ] }

    "Modified: / 30-01-2011 / 03:24:46 / cg"
!

characterLiteral
    |c|

    self apply:#spaces.
    self apply:#exactly withArgs:{ $$ }.
    c := self apply:#char.
    ^ 
    { #App.
    #exactly.
    c storeString }

    "Modified: / 30-01-2011 / 03:24:48 / cg"
!

characters
    |xs|

    self apply:#token withArgs:{ '``' }.
    xs := self 
                many:[
                    self 
                        not:[
                            self apply:#exactly withArgs:{ $' }.
                            self apply:#exactly withArgs:{ $' }.
                        ].
                    self apply:#char
                ].
    self apply:#exactly withArgs:{ $' }.
    self apply:#exactly withArgs:{ $' }.
    ^ 
    { #App.
    #seq.
    (String withAll:xs) storeString }

    "Modified: / 30-01-2011 / 03:24:52 / cg"
!

expr
    |xs|

    xs := self apply:#listOf
                withArgs:
                    { #expr4.
                    '|' }.
    ^ (OrderedCollection with:#Or)
        addAll:xs;
        yourself

    "Modified: / 30-01-2011 / 03:24:54 / cg"
!

expr1
    |lit e|

    ^ self ometaOr:
            { [
            lit := self ometaOr:
                            { [ self apply:#keyword withArgs:{ 'true' } ].
                            [ self apply:#keyword withArgs:{ 'false' } ].
                            [ self apply:#keyword withArgs:{ 'nil' } ] }.
            
            { #App.
            #exactly.
            lit }
        ].
            [ self apply:#application ].
            [ self apply:#semanticAction ].
            [ self apply:#semanticPredicate ].
            [ self apply:#characters ].
            [ self apply:#tokenSugar ].
            [ self apply:#stringLiteral ].
            [ self apply:#symbolLiteral ].
            [ self apply:#numberLiteral ].
            [ self apply:#characterLiteral ].
            [
            self apply:#token withArgs:{ '{' }.
            e := self apply:#expr.
            self apply:#token withArgs:{ '}' }.
            
            { #Form.
            e }
        ].
            [
            self apply:#token withArgs:{ '<' }.
            e := self apply:#expr.
            self apply:#token withArgs:{ '>' }.
            
            { #ConsBy.
            e }
        ].
            [
            self apply:#token withArgs:{ '@<' }.
            e := self apply:#expr.
            self apply:#token withArgs:{ '>' }.
            
            { #IdxConsBy.
            e }
        ].
            [
            self apply:#token withArgs:{ '(' }.
            e := self apply:#expr.
            self apply:#token withArgs:{ ')' }.
            e
        ] }

    "Modified: / 30-01-2011 / 03:24:57 / cg"
!

expr2
    |x|

    ^ self ometaOr:
            { [
            self apply:#token withArgs:{ '~' }.
            x := self apply:#expr2.
            
            { #Not.
            x }
        ].
            [
            self apply:#token withArgs:{ '&' }.
            x := self apply:#expr2.
            
            { #Lookahead.
            x }
        ].
            [ self apply:#expr1 ] }

    "Modified: / 30-01-2011 / 03:24:58 / cg"
!

expr3
    |x n|

    ^ self ometaOr:
            { [
            x := self apply:#expr2.
            x := self apply:#optIter withArgs:{ x }.
            self ometaOr:
                    { [
                    self apply:#exactly withArgs:{ $: }.
                    n := self apply:#nsName.
                    temps add:n.
                    
                    { #Set.
                    n.
                    x }
                ].
                    [ x ] }
        ].
            [
            self apply:#token withArgs:{ ':' }.
            n := self apply:#nsName.
            temps add:n.
            
            { #Set.
            n.
            
            { #App.
            #anything } }
        ] }

    "Modified: / 30-01-2011 / 03:25:03 / cg"
!

expr4
    |xs|

    xs := self many:[ self apply:#expr3 ].
    ^ (OrderedCollection with:#And)
        addAll:xs;
        yourself

    "Modified: / 30-01-2011 / 03:25:06 / cg"
!

name
    self apply:#spaces.
    ^ self apply:#nsName

    "Modified: / 30-01-2011 / 03:25:35 / cg"
!

nameFirst
    ^ self apply:#letter

    "Modified: / 30-01-2011 / 03:25:38 / cg"
!

nameRest
    ^ self ometaOr:
            { [ self apply:#nameFirst ].
            [ self apply:#digit ] }

    "Modified: / 30-01-2011 / 03:25:41 / cg"
!

nsName
    |xs|

    ^ self ometaOr:
            { [
            xs := self apply:#firstAndRest
                        withArgs:
                            { #nameFirst.
                            #nameRest }.
            (String withAll:xs) asSymbol
        ].
            [
            self apply:#exactly withArgs:{ $_ }.
            ^ #anything
        ] }

    "Modified: / 30-01-2011 / 03:25:45 / cg"
!

numberLiteral
    |sign ds|

    self apply:#spaces.
    sign := self ometaOr:
                    { [
                    self apply:#exactly withArgs:{ $- }.
                    self apply:#spaces.
                    -1
                ].
                    [ 1 ] }.
    ds := self many1:[ self apply:#digit ].
    ^ 
    { #App.
    #exactly.
    (sign * (String withAll:ds) asNumber) storeString }

    "Modified: / 30-01-2011 / 03:25:49 / cg"
!

rule
    |n x xs squeakCode|

    ^ self ometaOr:
            { [
            self 
                not:[
                    self 
                        many:[
                            self 
                                super:OMeta2
                                apply:#space
                                withArgs:#()
                        ].
                    self apply:#nsName.
                    self apply:#expr4.
                    self apply:#token withArgs:{ '=' }
                ].
            squeakCode := self consumedBy:[ self many:[ self apply:#char ] ].
            
            { #Squeak.
            squeakCode }
        ].
            [
            n := self 
                        lookahead:[
                            self 
                                many:[
                                    self 
                                        super:OMeta2
                                        apply:#space
                                        withArgs:#()
                                ].
                            self apply:#nsName
                        ].
            x := self apply:#rulePart withArgs:{ n }.
            xs := self 
                        many:[
                            self apply:#token withArgs:{ ',' }.
                            self apply:#rulePart withArgs:{ n }
                        ].
            self apply:#spaces.
            self apply:#end.
            
            { #Rule.
            n.
            temps asArray.
            (OrderedCollection with:#Or with:x)
                addAll:xs;
                yourself }
        ] }

    "Modified: / 30-01-2011 / 03:25:55 / cg"
!

semanticAction
    |e|

    self ometaOr:
            { [ self apply:#token withArgs:{ '->' } ].
            [] }.
    self apply:#token withArgs:{ '[' }.
    e := self apply:#squeakExpression.
    self apply:#exactly withArgs:{ $] }.
    ^ 
    { #Act.
    e }

    "Modified: / 30-01-2011 / 03:26:02 / cg"
!

semanticPredicate
    |e|

    self apply:#token withArgs:{ '?[' }.
    e := self apply:#squeakExpression.
    self apply:#exactly withArgs:{ $] }.
    ^ 
    { #Pred.
    e }

    "Modified: / 30-01-2011 / 03:26:05 / cg"
!

space
    ^ self ometaOr:
            { [
            self 
                super:OMeta2
                apply:#space
                withArgs:#()
        ].
            [
            self apply:#fromTo
                withArgs:
                    { '/*'.
                    '*/' }
        ].
            [
            self apply:#fromTo
                withArgs:
                    { '//'.
                    String cr }
        ].
            [
            self apply:#seq withArgs:{ '//' }.
            self 
                many:[
                    self 
                        super:OMeta2
                        apply:#space
                        withArgs:#()
                ]
        ] }

    "Modified: / 30-01-2011 / 03:26:09 / cg"
!

squeakExpression
    |t1|

    ^ true ifTrue:[
        t1 := self apply:#foreign
                    withArgs:
                        { O2SqueakRecognizer.
                        #squeakExpr }.
        self apply:#spaces.
        t1
    ]

    "Modified: / 30-01-2011 / 03:26:11 / cg"
!

stringLiteral
    |xs|

    self apply:#token withArgs:{ '''' }.
    xs := self 
                many:[
                    self ometaOr:
                            { [
                            self apply:#exactly withArgs:{ $' }.
                            self apply:#exactly withArgs:{ $' }.
                            $'
                        ].
                            [
                            self not:[ self apply:#exactly withArgs:{ $' } ].
                            self apply:#char
                        ] }
                ].
    self apply:#exactly withArgs:{ $' }.
    ^ 
    { #App.
    #exactly.
    (String withAll:xs) storeString }

    "Modified: / 30-01-2011 / 03:26:13 / cg"
!

symbolLiteral
    " TODO: make this accept, e.g., #foo:bar: "
    
    |s|

    self apply:#token withArgs:{ '#' }.
    s := self apply:#nsName.
    ^ 
    { #App.
    #exactly.
    s storeString }

    "Modified: / 30-01-2011 / 03:26:16 / cg"
!

tokenSugar
    |xs|

    self apply:#token withArgs:{ '"' }.
    xs := self 
                many:[
                    self not:[ self apply:#exactly withArgs:{ $" } ].
                    self apply:#char
                ].
    self apply:#exactly withArgs:{ $" }.
    ^ 
    { #App.
    #token.
    (String withAll:xs) storeString }

    "Modified: / 30-01-2011 / 03:26:19 / cg"
! !

!OMeta2RuleParser methodsFor:'rules-meta'!

keyword
    |xs|

    xs := self apply:#anything.
    self apply:#token withArgs:{ xs }.
    self not:[ self apply:#letterOrDigit ].
    ^ xs

    "Modified: / 30-01-2011 / 03:25:32 / cg"
!

optIter
    |x|

    x := self apply:#anything.
    ^ self ometaOr:
            { [
            self apply:#token withArgs:{ '*' }.
            
            { #Many.
            x }
        ].
            [
            self apply:#token withArgs:{ '+' }.
            
            { #Many1.
            x }
        ].
            [
            self apply:#token withArgs:{ '?' }.
            self not:[ self apply:#exactly withArgs:{ $[ } ].
            
            { #Opt.
            x }
        ].
            [ x ] }

    "Modified: / 30-01-2011 / 03:25:52 / cg"
!

rulePart
    |ruleName b1 b2|

    ruleName := self apply:#anything.
    self pred:(self apply:#name) = ruleName.
    b1 := self apply:#expr4.
    ^ self ometaOr:
            { [
            self apply:#token withArgs:{ '=' }.
            b2 := self apply:#expr.
            
            { #And.
            b1.
            b2 }
        ].
            [ b1 ] }

    "Modified: / 30-01-2011 / 03:25:58 / cg"
! !

!OMeta2RuleParser class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/oMeta2/OMeta2RuleParser.st,v 1.3 2011/01/30 02:28:24 cg Exp $'
! !
