"{ Package: 'stx:goodies/oMeta2' }"

OMeta2 subclass:#OMeta2RuleTranslator
	instanceVariableNames:'grammarClass'
	classVariableNames:''
	poolDictionaries:''
	category:'OMeta2'
!


!OMeta2RuleTranslator methodsFor:'helpers'!

delim:aSequenceableCollection with:anObject 
    |first ans|

    first := true.
    ans := OrderedCollection new.
    aSequenceableCollection do:[:x | 
        first ifTrue:[
            first := false
        ] ifFalse:[
            ans add:anObject
        ].
        ans add:x
    ].
    ^ ans

    "Modified: / 30-01-2011 / 03:27:24 / cg"
! !

!OMeta2RuleTranslator methodsFor:'rules'!

act
    |x|

    x := self apply:#string.
    ^ 
    { '('.
    x.
    ')' }

    "Modified: / 30-01-2011 / 03:26:37 / cg"
!

and
    |xs|

    xs := self many:[ self apply:#trans. ].
    ^ 
    { '(true ifTrue: ['.
    self delim:xs with:'. '.
    '])' }

    "Modified: / 30-01-2011 / 03:26:39 / cg"
!

app
    |rule args|

    rule := self apply:#symbol.
    ^ self ometaOr:
            { [
            args := self many1:[ self apply:#anything ].
            args := self delim:args with:'. '.
            
            { '(self apply: '.
            rule storeString.
            ' withArgs: {'.
            args.
            '})' }
        ].
            [
            
            { '(self apply: '.
            rule storeString.
            ')' }
        ] }

    "Modified: / 30-01-2011 / 03:26:41 / cg"
!

consby
    |x|

    x := self apply:#trans.
    ^ 
    { '(self consumedBy: ['.
    x.
    '])' }

    "Modified: / 30-01-2011 / 03:26:43 / cg"
!

form
    |x|

    x := self apply:#trans.
    ^ 
    { '(self form: ['.
    x.
    '])' }

    "Modified: / 30-01-2011 / 03:26:44 / cg"
!

idxconsby
    |x|

    x := self apply:#trans.
    ^ 
    { '(self indexConsumedBy: ['.
    x.
    '])' }

    "Modified: / 30-01-2011 / 03:26:47 / cg"
!

lookahead
    |x|

    x := self apply:#trans.
    ^ 
    { '(self lookahead: ['.
    x.
    '])' }

    "Modified: / 30-01-2011 / 03:26:49 / cg"
!

many
    |x|

    x := self apply:#trans.
    ^ 
    { '(self many: ['.
    x.
    '])' }

    "Modified: / 30-01-2011 / 03:26:51 / cg"
!

many1
    |x|

    x := self apply:#trans.
    ^ 
    { '(self many1: ['.
    x.
    '])' }

    "Modified: / 30-01-2011 / 03:26:53 / cg"
!

not
    |x|

    x := self apply:#trans.
    ^ 
    { '(self not: ['.
    x.
    '])' }

    "Modified: / 30-01-2011 / 03:26:58 / cg"
!

opt
    |x|

    x := self apply:#trans.
    ^ 
    { '(self opt: ['.
    x.
    '])' }

    "Modified: / 30-01-2011 / 03:26:56 / cg"
!

or
    |xs x|

    xs := self 
                many:[
                    x := self apply:#trans.
                    
                    { '['.
                    x.
                    ']' }
                ].
    ^ 
    { '(self ometaOr: {'.
    self delim:xs with:'. '.
    '})' }

    "Modified: / 30-01-2011 / 03:27:03 / cg"
!

pred
    |x|

    x := self apply:#string.
    ^ 
    { '(self pred: ('.
    x.
    '))' }

    "Modified: / 30-01-2011 / 03:27:05 / cg"
!

rule
    |name temps body|

    name := self apply:#symbol.
    temps := self apply:#anything.
    temps := temps select:[:t | (grammarClass instVarNames includes:t) not ].
    temps := temps collect:[:t | t asString ].
    body := self apply:#trans.
    ^ 
    { name.
    ' |'.
    self delim:temps with:' '.
    ' | ^ '.
    body }

    "Modified: / 30-01-2011 / 03:27:06 / cg"
!

set
    |n v|

    n := self apply:#symbol.
    v := self apply:#trans.
    ^ 
    { '('.
    n asString.
    ' := '.
    v.
    ')' }

    "Modified: / 30-01-2011 / 03:27:08 / cg"
!

squeak
    ^ self apply:#string

    "Modified: / 30-01-2011 / 03:27:11 / cg"
!

superapp
    |rule args|

    rule := self apply:#symbol.
    args := self many:[ self apply:#anything ].
    args := self delim:args with:'. '.
    ^ 
    { '(self super: '.
    grammarClass superclass name.
    ' apply: '.
    rule storeString.
    ' withArgs: {'.
    args.
    '})' }

    "Modified: / 30-01-2011 / 03:27:15 / cg"
!

trans
    |type ans|

    self 
        form:[
            type := self apply:#symbol.
            ans := self apply:type asLowercase asSymbol
        ].
    ^ ans

    "Modified: / 30-01-2011 / 03:27:17 / cg"
!

translate
    grammarClass := self apply:#anything.
    ^ self apply:#trans

    "Modified: / 30-01-2011 / 03:27:21 / cg"
! !

!OMeta2RuleTranslator class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/oMeta2/OMeta2RuleTranslator.st,v 1.3 2011/01/30 02:28:27 cg Exp $'
! !
