"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

CCITTDecodeTreeNode subclass:#CCITTDecodeTreeLeaf
	instanceVariableNames:'entry'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!CCITTDecodeTreeLeaf methodsFor:'accessing'!

entry
	"^self
I return my entry."

	^entry
			
!

entry: anEntry 
	"^self
I record my entry."

	entry := anEntry.
	^self
			
! !

!CCITTDecodeTreeLeaf methodsFor:'adding-removing'!

add: anEntry 
	"^a CCITTTreeNode
I add anEntry to myself.  This may invlove just assigning the entry to
as my entry, or it may involve making a new branch which will become
my replacement in my parent.  I return either myself or my replacement."

	| targetNode |
	self entry isNil ifFalse: [SPDFCompressionException raiseSignal: 'Duplicate table code'].
	self code = anEntry code 
		ifTrue: 
			[self entry: anEntry.
			targetNode := self]
		ifFalse: 
			[targetNode := CCITTDecodeTreeBranch representingCode: self code.
			targetNode add: anEntry].
	^targetNode
			
! !

!CCITTDecodeTreeLeaf methodsFor:'decoding'!

nextEntryFrom: aBitStream 
	"^a CCITTCodeEntry
I return the next code entry from aBitStream  By the time I
receive this - it must be my entry.  If this is a bad code, nil
will be returned.  I won't check because this is a very busy
part of the decoding, and therefore highly time critical."

	entry isNil 
		ifTrue: 
			[InvalidCode 
				raiseSignal: 'No entry available for code: ' , self code printString].
	^entry
			
! !

!CCITTDecodeTreeLeaf class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__CCITTDecodeTreeLeaf.st,v 1.1 2006/09/07 11:18:26 sr Exp $'
! !
