"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#CCITTDecodeTreeNode
	instanceVariableNames:'code'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!CCITTDecodeTreeNode class methodsFor:'instance creation'!

representingCode: anArray 
	"^a CCITTDecodeTreeNode
I create and return an instance of myself initialized with a parent
of aParent."

	^self new representingCode: anArray
			
! !

!CCITTDecodeTreeNode methodsFor:'accessing'!

code
	"^a String
I return the array which contains my code.  An example
might be '0 1 1 0'."

	^code
			
! !

!CCITTDecodeTreeNode methodsFor:'adding-removing'!

add: anEntry 
	"^a CCITTTreeNode
I add anEntry to myself.  Branches and leaves behave quite differently.  Refer to my subclasses implementations."

	^self subclassResponsibility
			
! !

!CCITTDecodeTreeNode methodsFor:'initialize-release'!

initialize
	"^self
By default, I do nothing, but my subclasses may override this."

	^self
			
!

representingCode: anArray 
	"^self
I initialize myself as the node representing the code aString."

	code := anArray.
	self initialize.
	^self
			
! !

!CCITTDecodeTreeNode methodsFor:'testing'!

isTheCorrectPathFor: anEntry 
	"^a Boolean
I return true if anEntry should be reached via me.  So, if
my code matches the start of anEntry's code I answer true,
otherwise I answer false.  e.g.  if anEntry has a code of 0010
and my code is 00, then we do match."

	^(anEntry code copyFrom: 1 to: self code size) = self code
			
! !

!CCITTDecodeTreeNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__CCITTDecodeTreeNode.st,v 1.1 2006/09/07 11:23:12 sr Exp $'
! !
