"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#CodeReadStream
	instanceVariableNames:'bitStream'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!CodeReadStream class methodsFor:'instance creation'!

onByteStream: aByteStream 
	"^a CODEReadStream
I return a new instance of myself initialied to read codes of a particular scheme from aByteStream."


	^self new onByteStream: aByteStream
			
! !

!CodeReadStream methodsFor:'accessing'!

bitStream

	^bitStream
			
!

bitStream: aValue

	bitStream := aValue
			
! !

!CodeReadStream methodsFor:'decoding'!

decodeTo: aByteStream 
	"^self
I decode the contents of my underlying byte array to aByteStream."

	^self subclassResponsibility
			
! !

!CodeReadStream methodsFor:'initialize-release'!

onByteStream: aByteStream 
	"^a CODEReadStream
I return myself initialized to read codes of a particular scheme from aByteStream."

	self bitStream: (BitReadStream onByteStream: aByteStream).
	^self
			
!

reset
	"^self
I reset myself so that the next thing read will be the first element in my underlying collection."

	self bitStream reset.
	^self
			
! !

!CodeReadStream methodsFor:'testing'!

atEnd
	"^a Boolean
I return true if I've reached the end of the underlying collection, otherwise I return false."

	^self bitStream atEnd
			
! !

!CodeReadStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__CodeReadStream.st,v 1.1 2006/09/07 11:16:28 sr Exp $'
! !
