"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#DecodeLine
	instanceVariableNames:'client'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!DecodeLine class methodsFor:'instance creation'!

for: aClient 
	"^a DecodeLine
I return a new instance of myself initialized to be a line for a client."

	^self new for: aClient
			
! !

!DecodeLine methodsFor:'accessing'!

bitStream
	"^a BitReadStream
I return the bit read stream which is the source of the codes I'm processing."

	^self client bitStream
			
!

client

	^client
			
!

client: aClient

	client := aClient
			
! !

!DecodeLine methodsFor:'initialize-release'!

for: aClient 
	"^a DecodeLine
I return myself initialized to be a line for a client."

	self client: aClient.
	^self
			
! !

!DecodeLine methodsFor:'services'!

blackDecodeTree
	"^a CCITTDecodeTree
I return the black decode tree which is a CCITTDecodeTree
populated with the pre-defined black run-length codes."

	^CCITTDecodeTree forBlackDecoding
			
!

incrementPositionBy: anInteger 
	"^self
I'm mein notified that anInteger pels have just been decoded and written.  By default I ignore this information, though some of my subclasses are interested in this.  They will override this method."

	^self
			
!

whiteDecodeTree
	"^a CCITTDecodeTree
I return the white decode tree which is a CCITTDecodeTree
populated with the pre-defined white run-length codes."

	^CCITTDecodeTree forWhiteDecoding
			
! !

!DecodeLine class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__DecodeLine.st,v 1.1 2006/09/07 11:14:27 sr Exp $'
! !
