"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#ITUCodeEntry
	instanceVariableNames:'code'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUCodeEntry methodsFor:'accessing'!

code
	^code
			
!

code: aString 
	code := aString.
	^self
			
! !

!ITUCodeEntry methodsFor:'decoding'!

next: numberOfBits put: aBit on: outputStream for: aClient 
	"^self
I write the next numberOfBits instanced of aBit to aStream."

	outputStream next: numberOfBits put: aBit.
	aClient incrementPositionBy: numberOfBits.
	^self
			
! !

!ITUCodeEntry methodsFor:'services'!

blackDecodeTree
	"^a CCITTDecodeTree
I return the black decode tree which is a CCITTDecodeTree
populated with the pre-defined black run-length codes."

	^CCITTDecodeTree forBlackDecoding
			
!

whiteDecodeTree
	"^a CCITTDecodeTree
I return the white decode tree which is a CCITTDecodeTree
populated with the pre-defined white run-length codes."

	^CCITTDecodeTree forWhiteDecoding
			
! !

!ITUCodeEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUCodeEntry.st,v 1.1 2006/09/07 11:12:22 sr Exp $'
! !
