"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

ITUCodeEntry subclass:#ITUxT4CodeEntry
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT4CodeEntry class methodsFor:'instance creation'!

withRunlength: aRunLength color: aColor  andCode: anArray
	"^a CCITTCodeEntry
I create and return a new instance of myself which will represent the combination of a code (a binary pattern) and a run-length for a particular color."

	^self new withRunlength: aRunLength color: aColor andCode: anArray
			
! !

!ITUxT4CodeEntry methodsFor:'decoding'!

decodeTo: outputStream for: aClient
	"^self
This must be implemented by my subclasses.  The task is to
write the decoded form of myself to the output stream."

	^self subclassResponsibility
			
! !

!ITUxT4CodeEntry methodsFor:'testing'!

isEOL
	"^a Boolean
I'm probably not the EOL code, so my default behaviour is to just return false.  The real EOL will override this."

	^false
			
! !

!ITUxT4CodeEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT4CodeEntry.st,v 1.1 2006/09/07 11:08:21 sr Exp $'
! !
