"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

CodeReadStream subclass:#ITUxT4CodeReadStream
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT4CodeReadStream methodsFor:'accessing'!

next
	"^an ITUxT4Line
I return an ITUxT4Line which will handle the decoding for the next line of pels."

	^ITUxT4Line for: self
			
! !

!ITUxT4CodeReadStream methodsFor:'decoding'!

decodeTo: aByteStream 
	"^self
I decode the contents of my underlying byte array to aByteStream."

	| outputStream initialEOLEntry |
	self reset.
	outputStream := BitWriteStream onByteStream: aByteStream.
	initialEOLEntry := self whiteDecodeTree nextEntryFrom: self bitStream.
	initialEOLEntry isEOL 
		ifFalse: 
			[SPDFCompressionException raiseSignal: 'T.4 Error - First code not EOL.'].
	
	[[self atEnd] whileFalse: 
			[self next decodeTo: outputStream.
			outputStream flushByte]] 
			on: BitStreamOutOfBounds
			do: [:ex | outputStream flushByte].
	^self
			
! !

!ITUxT4CodeReadStream methodsFor:'services'!

whiteDecodeTree
	"^a CCITTDecodeTree
I return the white decode tree which is a CCITTDecodeTree
populated with the pre-defined white run-length codes."

	^CCITTDecodeTree forWhiteDecoding
			
! !

!ITUxT4CodeReadStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT4CodeReadStream.st,v 1.1 2006/09/07 11:06:09 sr Exp $'
! !
