"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

ITUxT4CodeEntry subclass:#ITUxT4EndOfLineCodeEntry
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT4EndOfLineCodeEntry class methodsFor:'instance creation'!

withCode: anArray
	"^a CCITTCodeEntry
I create and return a new instance of myself which will represent the EOL code."

	^self new withCode: anArray
			
! !

!ITUxT4EndOfLineCodeEntry methodsFor:'decoding'!

decodeTo: outputStream for: aLine 
	"^self
I'm End of Line (or EOL).  I'm the last code in the file, so decoding is finished.  I throw a notification that it's all over."

	ReachedEOL signal.
	^self
			
! !

!ITUxT4EndOfLineCodeEntry methodsFor:'initialize-release'!

withCode: anArray 
	"^a CCITTCodeEntry
I initialize myself to represent the EOL code."

	self code: anArray.
	^self
			
! !

!ITUxT4EndOfLineCodeEntry methodsFor:'testing'!

isEOL
"^a Boolean
I am the EOL code (I have the binary code 000000000001), so I return true."
	^true
			
! !

!ITUxT4EndOfLineCodeEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT4EndOfLineCodeEntry.st,v 1.1 2006/09/07 11:21:38 sr Exp $'
! !
