"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

DecodeLine subclass:#ITUxT4Line
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT4Line methodsFor:'decoding'!

decodeTo: outputStream 
	"^self
I process the encoded line I represent terminated by an EOL code.  This means decoding first a white run, followed by a black run, followed by a white until the EOLenty is found. Each run may consist of a number of codes.  Once the line is finished, I flush the current byte from the outputStream: this ensures that every line starts on a fresh, clean byte boundary."

	
	[[self bitStream atEnd] whileFalse: 
			[(self whiteDecodeTree nextEntryFrom: self bitStream) 
				decodeTo: outputStream for: self.
			(self blackDecodeTree nextEntryFrom: self bitStream) 
				decodeTo: outputStream for: self]] 
			on: ReachedEOL
			do: [:ex | outputStream flushByte].
	^self
			
! !

!ITUxT4Line class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT4Line.st,v 1.1 2006/09/07 11:19:05 sr Exp $'
! !
