"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#ITUxT6ChangingElement
	instanceVariableNames:'color offset nextLink priorLink'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT6ChangingElement class methodsFor:'instance creation'!

color: aColorCode offset: anInteger 
	"^an ITUxT6ChangingElement
I create and return an instance of myself initialized to represent a change to the color indicated by aColorCode at offset anInteger."

	^self new color: aColorCode offset: anInteger
			
! !

!ITUxT6ChangingElement methodsFor:'accessing'!

color

	^color
			
!

color: aValue

	color := aValue
			
!

offset

	^offset
			
!

offset: aValue

	offset := aValue
			
! !

!ITUxT6ChangingElement methodsFor:'initialize-release'!

color: aColorCode offset: anInteger 
	"^self
I initialize myself to represent a changing element.  Changing elelements are described in section 2.2.2 of the ITU T.6 specification."

	self color: aColorCode.
	self offset: anInteger.
	^self
			
! !

!ITUxT6ChangingElement methodsFor:'linking'!

nextLink

	^nextLink
			
!

nextLink: aLink 
	"^self
I record my next link."

	nextLink := aLink.
	aLink priorLink: self.
	^self
			
!

priorLink

	^priorLink
			
!

priorLink: aLink 
	"^self
I record my prior link."

	priorLink := aLink.
	^self
			
! !

!ITUxT6ChangingElement methodsFor:'printing'!

printOn: aStream 
	self color = 1 ifTrue: [aStream cr] ifFalse: [aStream tab].
	aStream
		nextPutAll: self color printString;
		nextPutAll: ' @ ';
		nextPutAll: self offset printString.
	^self
			
! !

!ITUxT6ChangingElement methodsFor:'services'!

oppositeColor
	"^an Integer
I return the color which is opposite to my own."

	^self color == 1 ifTrue: [0] ifFalse: [1]
			
! !

!ITUxT6ChangingElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT6ChangingElement.st,v 1.1 2006/09/07 11:10:56 sr Exp $'
! !
