"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

ITUCodeEntry subclass:#ITUxT6CodeEntry
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT6CodeEntry class methodsFor:'instance creation'!

withCode: anArray 
	"^an ITUxT6CodeEntry
I create and return a new instance of myself which will
represent the T6 mode code."

	^self new withCode: anArray
			
! !

!ITUxT6CodeEntry methodsFor:'decoding'!

decodeFrom: inputStream to: outputStream for: aITUxT6Line 
	"^self
This must be implemented by my subclasses.  The task is to
write the decoded form of myself to the output stream."

	^self subclassResponsibility
			
!

decodeTo: outputStream for: aClient 
	"^self
This must be implemented by my subclasses.  The task is to
write the decoded form of myself to the output stream."

	^self 
		decodeFrom: aClient bitStream
		to: outputStream
		for: aClient currentLine
			
! !

!ITUxT6CodeEntry methodsFor:'initialize-release'!

withCode: anArray 
	"^self
I initialize myself to represent a T6 mode code."

	^self code: anArray
			
! !

!ITUxT6CodeEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT6CodeEntry.st,v 1.1 2006/09/07 11:09:00 sr Exp $'
! !
