"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

ITUxT6CodeEntry subclass:#ITUxT6HorizontalCodeEntry
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT6HorizontalCodeEntry methodsFor:'decoding'!

decodeFrom: inputStream to: outputStream for: aClient 
	"^self
I'm a horizontal mode code.  This means that I must grab the next two T.4 codes (plus make-up codes, of course) and write the decoded form to my output stream.  I must also make sure that the changing elements are correctly updated in aLine."

	| a0 newA0 |
	a0 := aClient a0.
	self 
		writeT4RunOfColor: a0 color
		on: outputStream
		for: aClient.
	aClient addChangingElement: (ITUxT6ChangingElement color: a0 oppositeColor
				offset: aClient nextPosition).
	self 
		writeT4RunOfColor: a0 oppositeColor
		on: outputStream
		for: aClient.
	newA0 := ITUxT6ChangingElement color: a0 color offset: aClient nextPosition.
	aClient addChangingElement: newA0.
	aClient a0: newA0.
	^self
			
!

writeT4RunOfColor: aColor on: outputStream for: aClient 
	"^self
I read the next code(s) from the input stream.  I'm looking for ITU T.4 codes for aColor.  I then write out the run lengths indicated by the code(s)."

	| tree |
	tree := aColor == 1 
				ifTrue: [self whiteDecodeTree]
				ifFalse: [self blackDecodeTree].
	(tree nextEntryFrom: aClient bitStream) decodeTo: outputStream for: aClient.
	^self
			
! !

!ITUxT6HorizontalCodeEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT6HorizontalCodeEntry.st,v 1.1 2006/09/07 11:17:36 sr Exp $'
! !
