"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

ITUxT6CodeEntry subclass:#ITUxT6PassCodeEntry
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT6PassCodeEntry methodsFor:'decoding'!

decodeFrom: inputStream to: outputStream for: aLine 
	"^self
I'm a pass mode code.  This means that I pass by one change and write a runlength upto b2.  I would calculate the next changing element for aLine, but since the effect of a pass is to remove a change of color, I don't have to do that.  So a pass does not add a changing element to the current line, but it does result in a new a0."

	| numberOfBits a0 runEndOffset b2 |
	a0 := aLine a0.
	b2 := aLine b2.
	runEndOffset := b2 offset - 1.
	numberOfBits := runEndOffset - aLine position.
	self 
		next: numberOfBits
		put: a0 color
		on: outputStream
		for: aLine.
	aLine a0: (ITUxT6ChangingElement color: b2 color offset: aLine nextPosition).
	^self
			
! !

!ITUxT6PassCodeEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT6PassCodeEntry.st,v 1.1 2006/09/07 11:13:37 sr Exp $'
! !
