"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

ITUxT6CodeEntry subclass:#ITUxT6VerticalCodeEntry
	instanceVariableNames:'offsetBias'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ITUxT6VerticalCodeEntry class methodsFor:'instance creation'!

withCode: anArray andBias: anInteger 
	"^an ITUxT6CodeEntry
I create and return a new instance of myself which will represent a vertical T6 mode code with a bias of anInteger."

	^self new withCode: anArray andBias: anInteger
			
! !

!ITUxT6VerticalCodeEntry methodsFor:'accessing'!

offsetBias

	^offsetBias
			
!

offsetBias: aValue

	offsetBias := aValue
			
! !

!ITUxT6VerticalCodeEntry methodsFor:'decoding'!

decodeFrom: inputStream to: outputStream for: aLine 
	"^self
I'm a vertical mode code.  This means that I must repeat what was on the previous line (at b1), just shifted left or right by +/- 3 bits.  I calculate the next changing element for aLine.  The offset and color for the new changing element are taken from the current b1."

	| numberOfBits a0 b1 runEndOffset newA0 |
	a0 := aLine a0.
	b1 := aLine b1.
	runEndOffset := b1 offset - 1 + self offsetBias.
	numberOfBits := runEndOffset - aLine position.
	self 
		next: numberOfBits
		put: a0 color
		on: outputStream
		for: aLine.
	newA0 := ITUxT6ChangingElement color: b1 color offset: aLine nextPosition.
	aLine addChangingElement: newA0.
	aLine a0: newA0.
	^self
			
! !

!ITUxT6VerticalCodeEntry methodsFor:'initialize-release'!

withCode: anArray andBias: anInteger 
	"^an ITUxT6CodeEntry
I create and return a new instance of myself which will represent a vertical T6 mode code with a bias of anInteger."

	self withCode: anArray.
	self offsetBias: anInteger.
	^self
			
! !

!ITUxT6VerticalCodeEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ITUxT6VerticalCodeEntry.st,v 1.1 2006/09/07 11:11:28 sr Exp $'
! !
