"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

CodeReadStream subclass:#ModifiedHuffmanCodeReadStream
	instanceVariableNames:'lineLength'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!


!ModifiedHuffmanCodeReadStream class methodsFor:'instance creation'!

onByteStream: aByteStream lineLength: anInteger 
	"^a CODEReadStream
I return a new instance of myself initialied to read codes of a particular scheme from aByteStream.  For Modified Huffman encoding, I also need the length of the line."

	^self new onByteStream: aByteStream lineLength: anInteger
			
! !

!ModifiedHuffmanCodeReadStream methodsFor:'accessing'!

lineLength

	^lineLength
			
!

lineLength: aValue

	lineLength := aValue
			
!

next
	"^an ModifiedHuffmanLine
I return an ModifiedHuffmanLine which will handle the decoding for the next line of pels."

	^ModifiedHuffmanLine for: self
			
! !

!ModifiedHuffmanCodeReadStream methodsFor:'decoding'!

decodeTo: aByteStream 
	"^self
I write the decompressed form of my bytes to aByteStream."

	| outputStream lineNumber |
	self reset.
	outputStream := BitWriteStream onByteStream: aByteStream.
	lineNumber := 0.
	
	[[self bitStream atEnd] whileFalse: 
			[lineNumber := lineNumber + 1.
			self next decodeTo: outputStream.
			self bitStream skipToStartOfNextByte.
			outputStream flushByte]] 
			on: (ExceptionSet with: ReachedEOL with: BitStreamOutOfBounds)
			do: [:ex | outputStream flushByte].
	^self
			
! !

!ModifiedHuffmanCodeReadStream methodsFor:'initialize-release'!

onByteStream: aByteStream lineLength: anInteger 
	"^a CODEReadStream
I return a new instance of myself initialied to read codes of a particular scheme from aByteStream.  For Modified Huffman encoding, I also need the length of the line."

	self onByteStream: aByteStream.
	self lineLength: anInteger.
	^self
			
! !

!ModifiedHuffmanCodeReadStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__ModifiedHuffmanCodeReadStream.st,v 1.1 2006/09/07 11:20:44 sr Exp $'
! !
