"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#NativeFilename
	instanceVariableNames:'filename'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Compatibility-Base'
!


!NativeFilename class methodsFor:'instance creation'!

named: aFilenameString
        Smalltalk isSmalltalkX ifTrue:[
            ^ Filename named: aFilenameString.
        ].
        ^self new named: aFilenameString
!

on: aFilename
        Smalltalk isSmalltalkX ifTrue:[
            ^ aFilename asFilename
        ].
        ^self new on: aFilename
! !

!NativeFilename methodsFor:'accessing'!

filename
	^filename
			
! !

!NativeFilename methodsFor:'converting'!

asString
	^self filename
			
! !

!NativeFilename methodsFor:'initialize-release'!

named: aString 
	filename := aString
!

on: aFilename 
	filename := aFilename asString
! !

!NativeFilename methodsFor:'services'!

construct: aString 
	"^a Filename 
	I return a NativeFilename which represents the concatenation of the 
	name I represent, and the name in aString."

	^NativeFilename 
		on: ((FileDirectory on: self filename) fullNameFor: aString) 
			
!

readStream
	^FileStream 
		readOnlyFileNamed: self filename	
!

writeStream
	^FileStream 
		forceNewFileNamed: self filename
! !

!NativeFilename methodsFor:'testing'!

isDirectory
	^FileDirectory default
		directoryExists: self filename	
! !

!NativeFilename class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__NativeFilename.st,v 1.1 2006/09/07 11:06:00 sr Exp $'
! !
