"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFFileElement subclass:#PDFBody
	instanceVariableNames:'catalog'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFBody comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.

My instances represent the body of a PDF file.  This is the part of the PDF file which defines the contents of the PDF document, including fonts, thumbnails etc.
See the PDF Reference Manual V1.2 Section 5.3 (p. 62)'
!


!PDFBody methodsFor:'accessing'!

catalog
	"^a PDFCatalog 
	I return my catalog. If I don't have one I use lazy initialization."

	catalog isNil ifTrue: [catalog := PDFCatalog for: self].
	^catalog
			
! !

!PDFBody methodsFor:'emitting'!

predecessor
	"^a PDFElement 
	I return my predecessor if I have one. This is used to make sure that 
	the elements of the PDF file are written in the correct order. My predecessor 
	Is the PDF header."

	^self file header
			
!

writePDFSyntaxOn: aWriter 
	"^self 
	I write myself to aWriter. Because >>predecessor returns the header, I 
	know that the header will be written before me. I just get the objects inside 
	me to write themselves out."

	self catalog writeOn: aWriter.
	^self
			
! !

!PDFBody methodsFor:'services'!

body
	"^self 
	I return the PDFBody which is my untimate parent. Since 
	I am the body, I just return myself."

	^self
			
!

defaultPage
	"^a PDFPage 
	I return the default default page within the PDF structure I 
	represent."

	^self catalog defaultPage
			
!

objectIdFor: aBodyObject 
	"^a	PDFBodyObject 
	I return a PDFObjectId which has a unique number. I simply 
	delegate this to the cross reference."

	^self file crossReference objectIdFor: aBodyObject
			
! !

!PDFBody methodsFor:'writing'!

newPage
	"^a PDFPage 
	I move to a new page in the PDF document. I delegate this 
	to my PDFCatalog. I return the new page."

	^self catalog newPage
			
! !

!PDFBody class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFBody.st,v 1.1 2006/09/07 11:08:54 sr Exp $'
! !
