"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFStructureElement subclass:#PDFBodyObject
	instanceVariableNames:'id'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFBodyObject comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.

This is the abstract class of all body objects in a PDF.  Body objects are the things refered to in the cross reference which are introduced with an "n n obj" statement in a PDF.'
!


!PDFBodyObject methodsFor:'accessing'!

id
	"^a PDFObjectId 
	I return my PDFObjectId. This identity is used for direct references 
	within a PDF file. If I don't have an ID yet, I get one lazily."

	id isNil ifTrue: [id := self body objectIdFor: self].
	^id
			
! !

!PDFBodyObject methodsFor:'services'!

root
	"^a PDFCatalog 
	I return the PDFCatalog which is the root of the PDF document."

	^self body catalog
			
! !

!PDFBodyObject class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFBodyObject.st,v 1.1 2006/09/07 11:16:04 sr Exp $'
! !
