"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFBodyObject subclass:#PDFContents
	instanceVariableNames:'pageDescription'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFContents comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.

My instances represen the contents of a page within a PDF file.  There is no concept of "contents" in the PDF spec, this cass just seem to help string things together.  It may be dropped in future.'
!


!PDFContents methodsFor:'accessing'!

pageDescription
	"^a PDFPageDescription 
	I return my underlying page description. I laziliy initialize myself."

	pageDescription isNil ifTrue: [pageDescription := PDFPageDescription for: self].
	^pageDescription
			
! !

!PDFContents methodsFor:'emitting'!

writePDFSyntaxOn: aWriter 
	"^self 
	I write myself to aWriter. I'm really just a pointer to the real contents 
	which is typically a stream. Once written (after this), I am immutable. 
	NOTE: Once written, I drop my PDF Stream."

	self id writeDeclarationOn: aWriter.
	aWriter newLine.
	aWriter writeLine: '%Contents'.
	self writeStreamOn: aWriter.
	aWriter writeLine: 'endobj'.
	^self
			
!

writeStreamOn: aWriter 
	"^self 
	I write my pageDescription to aWriter."

	self pageDescription writeOn: aWriter.
	^self
			
! !

!PDFContents methodsFor:'writing'!

addTextObject: aTextObject 
	"^self 
	I add aText object to my page description."

	self pageDescription addGraphicObject: aTextObject.
	^self
			
!

addTextOperator: aTextOperator 
	"^self 
	I add aText operator to my pageDescription."

	self pageDescription addTextOperator: aTextOperator.
	^self
			
!

newLine
	"^self 
	I throw a new line in the PDF document."

	self pageDescription newLine.
	^self
			
!

write: aString 
	"^self 
	I write a string into my contents. Note, no line feed."

	self pageDescription write: aString.
	^self
			
!

writeLine: aString 
	"^self 
	I write a string into my contents and move to the next line."

	self write: aString.
	self newLine.
	^self
			
! !

!PDFContents class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFContents.st,v 1.1 2006/09/07 11:11:58 sr Exp $'
! !
