"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFExternalObjectOperator subclass:#PDFDoOperator
	instanceVariableNames:'xObject rectangle'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFDoOperator comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.'
!


!PDFDoOperator methodsFor:'accessing'!

rectangle
	"^a PDFRectangle
I return the rectangle which defines my absolute position on my page."

	rectangle isNil ifTrue: [rectangle := self page mediaBox].
	^rectangle
			
!

rectangle: aRectangle 
	"^self
I record the rectangle which defines my absolute position and size on my page."

	rectangle := aRectangle.
	^self
			
!

xObject
	^xObject
			
!

xObject: anXObject 
	xObject := anXObject.
	^self
			
! !

!PDFDoOperator methodsFor:'emitting'!

writeCMClauseOn: aWriter 
	"^self 
	I write the CM operator which places and scales the external object by
	modifying the  CTM (Current Transformation Matrix) using the 'cm' clause.
	cm looks like:  'sx b c sy tx ty cm'.  sx&sy are height and width, tx & ty are
	the bottom left of the rectangle. "

	| imageDirectory width height |
	imageDirectory := self xObject image.
	width := imageDirectory width.
	height := imageDirectory height.
	width > self rectangle width ifTrue: [width := self rectangle width].
	height > self rectangle height ifTrue: [height := self rectangle height].
	aWriter
		write: width printString;
		write: ' 0 0 ';
		write: height printString;
		space;
		write: self rectangle bottomLeft x printString;
		space;
		write: self rectangle bottomLeft y printString;
		write: '  cm'.
	^self
			
!

writePDFSyntaxOn: aWriter 
	"^self 
	I write myself to aWriter.  I write the operators to save the CTM, position
	the CTM for the Do, do the Do, and then restore the saved CTM."

	aWriter writeLine: 'q'.
	self writeCMClauseOn: aWriter.
	aWriter write: '/' , self xObject name.
	aWriter writeLine: ' Do'.
	aWriter writeLine: 'Q'.
	^self
			
! !

!PDFDoOperator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFDoOperator.st,v 1.1 2006/09/07 11:12:35 sr Exp $'
! !
