"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFElement subclass:#PDFFileElement
	instanceVariableNames:'file'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFFileElement comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.

This is the abstract class of PDF elements which are directly known to the PDF file.  They each need to be able to get to the file to handle things like PDFFile>>close() when each of these elements must make sure that the previous section is written before writing itself.'
!


!PDFFileElement class methodsFor:'instance creation'!

for: aFile 
	"^a PDFFileElement 
	I create and initialise an instance of myself."

	^self new file: aFile
			
! !

!PDFFileElement methodsFor:'accessing'!

file
	"^a PDFFile 
	I return the file of which I am a part."

	^file
			
!

file: aFile 
	"^self 
	I record the file of which I am a part."

	file := aFile.
	^self
			
! !

!PDFFileElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFFileElement.st,v 1.1 2006/09/07 11:10:50 sr Exp $'
! !
