"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFStructureElement subclass:#PDFGraphicObject
	instanceVariableNames:'operators'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFGraphicObject comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.

This is the abstract superclass of all graphic objects as described in section 8.1 (p. 209) of the PDF Referece Manual (V1.2).'
!


!PDFGraphicObject methodsFor:'accessing'!

operators
	"^an OrderedCollection 
	I return my collection of operators."

	operators isNil ifTrue: [operators := OrderedCollection new].
	^operators
			
! !

!PDFGraphicObject methodsFor:'emitting'!

writeOperatorsOn: aWriter 
	"^self 
	I write each of my operators to aWriter."

	self operators do: [:operator | operator writeOn: aWriter].
	^self
			
! !

!PDFGraphicObject methodsFor:'services'!

addOperator: anOperator 
	"^self 
	I add anOperator to my vector of operators."

	self operators add: anOperator.
	^self
			
! !

!PDFGraphicObject class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFGraphicObject.st,v 1.1 2006/09/07 11:07:57 sr Exp $'
! !
