"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFFrame subclass:#PDFGroupingFrame
	instanceVariableNames:'subFrames parent placements currentPlacement rectangle'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Reporting'
!


!PDFGroupingFrame class methodsFor:'instance creation'!

within: aParent topLeft: topLeft extent: extent 
	"^a PDFMetaFrame 
	I create and initialize a new instance of myself."

	^self new
		within: aParent
		topLeft: topLeft
		extent: extent
			
!

within: aParent topLeftOffset: anOffset extent: extent 
	"^a PDFMetaFrame 
	I create and initialize a new instance of myself which is offset from the topLeft of
      aParent by anOffset.
	e.g To create a frame with a topLeft 5 points lower and 5 points to the right x 5, y 5."

	^self new
		within: aParent 
		topLeft: (aParent absoluteRectangle topLeft plusExtent: anOffset)
		extent: extent
			
!

within: aParent x: x y: y width: width height: height 
	"^a PDFMetaFrame 
	I create and initialize a new instance of myself."

	^self new
		within: aParent
		topLeft: (PDFPoint x: x y: y)
		extent: (PDFPoint x: width y: height)
			
! !

!PDFGroupingFrame methodsFor:'accessing'!

parent
	"^a Parent 
	I return my parent."

	^parent
			
!

parent: aParent 
	"^self 
	I record my parent and tell my parent about myself."

	parent := aParent.
	parent addSubFrame: self.
	^self
			
!

placements
	placements isNil ifTrue: [placements := OrderedCollection new].
	^placements
			
!

rectangle
	"^a Rectangle 
	I return my rectangle."

	^rectangle
			
!

subFrames
	"^an OrderedCollection 
	I return my collection of subframes."

	subFrames isNil ifTrue: [subFrames := OrderedCollection new].
	^subFrames
			
! !

!PDFGroupingFrame methodsFor:'initialize-release'!

within: aParent topLeft: topLeft extent: extent 
	"^self 
	I initialize and return myself."

	self  parent: aParent.
	rectangle := (PDFRectangle topLeft: topLeft extent: extent).
	^self
			
! !

!PDFGroupingFrame methodsFor:'services'!

absoluteRectangle
	"^a PDFRectangle 
	Returns the absolute rectangle for this frame."

	^self currentPlacement absoluteRectangle
			
!

addPlacement: aPagePosition 
	self placements add: aPagePosition
			
!

addSubFrame: aFrame 
	self subFrames add: aFrame
			
!

currentPlacement
	"^a PDFReportFrameNotes 
	Returns my placement on the current page."

	^self report pages currentPagePlacementFor: self
			
!

placementFor: aReportPage 
	"^a PDFFramePagePlacement
	Returns my placement on aPage."

	^aReportPage framePlacementFor: self
			
!

report
	"^a PDFReport 
	I return the PDFReport I'm working on writing to."

	^parent report
			
! !

!PDFGroupingFrame class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFGroupingFrame.st,v 1.1 2006/09/07 11:16:16 sr Exp $'
! !
