"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFStructureElement subclass:#PDFPageDescription
	instanceVariableNames:'currentTextObject graphicObjects'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!


!PDFPageDescription methodsFor:'accessing'!

addGraphicObject: aGraphicObject 
	"^self 
	I add a path object to my contents."

	self graphicObjects add: aGraphicObject.
	^self
			
!

currentTextObject
	"^a PDFTextObject 
	I return my current text object."

	currentTextObject isNil ifTrue: [self currentTextObject: self buildNewTextObject].
	^currentTextObject
			
!

currentTextObject: aPDFTextObject 
	"^self 
	I record my current text object."

	currentTextObject := aPDFTextObject.
	^self
			
!

graphicObjects
	"^an OrderedCollection 
	I return my collection of graphic objects."

	graphicObjects isNil ifTrue: [graphicObjects := OrderedCollection new].
	^graphicObjects
			
! !

!PDFPageDescription methodsFor:'emitting'!

writePDFSyntaxOn: aWriter 
	"^self 
	I write myself to aWriter. This means collating and writing myself out 
	as a byte array. I delegate the hard work to a PDFCollatedStream."

	(PDFCollatedStream for: self)
		writePDFSyntaxOn: aWriter.
	^self
			
! !

!PDFPageDescription methodsFor:'private'!

buildNewTextObject
	"^a PDFTextObject 
	Builds a new text object and adds it to the collection of text objects 
	in this stream."

	| newTextObject |
	newTextObject := PDFTextObject for: self.
	self addGraphicObject: newTextObject.
	^newTextObject
			
! !

!PDFPageDescription methodsFor:'writing'!

addTextOperator: aTextOperator 
	"^self 
	I add aText operator to my current text object."

	self currentTextObject addOperator: aTextOperator.
	^self
			
!

newLine
	"^self 
	I throw a new line in my current text object."

	self currentTextObject newLine.
	^self
			
!

write: aString 
	"^self 
	I write aString to my current text object."

	self currentTextObject write: aString.
	^self
			
! !

!PDFPageDescription class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFPageDescription.st,v 1.1 2006/09/07 11:18:40 sr Exp $'
! !
