"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFPathOperator subclass:#PDFPathRectangle
	instanceVariableNames:'rectangle'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFPathRectangle comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.'
!


!PDFPathRectangle methodsFor:'accessing'!

rectangle
	"^a PDFRectangle 
	I return the rectangle which defines where I am to appear on 
	the page."

	^rectangle
			
!

rectangle: aPDFRectangle 
	"^self 
	I record the rectangle which defines where I am to appear on 
	the page."

	rectangle := aPDFRectangle.
	^self
			
! !

!PDFPathRectangle methodsFor:'emitting'!

writePDFSyntaxOn: aWriter 
	"^self 
	I write myself to aWriter. This means witing moving, drawing and painting 
	operators to render a rectangle."

	| path |
	path := self rectangle.
	aWriter writeLine: path left printString , ' ' , path top printString , ' m'.
	aWriter writeLine: path right printString , ' ' , path top printString , ' l'.
	aWriter writeLine: path right printString , ' ' , path bottom printString , ' l'.
	aWriter writeLine: path left printString , ' ' , path bottom printString , ' l'.
	aWriter writeLine: 's'.
	^self
			
! !

!PDFPathRectangle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFPathRectangle.st,v 1.1 2006/09/07 11:17:18 sr Exp $'
! !
