"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#PDFReportElement
	instanceVariableNames:'parent deferredFrames'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Reporting'
!


!PDFReportElement class methodsFor:'instance creation'!

for: aParent 
	"^a PDFReportPages 
	I create and initialize a new instance of myself."

	^self new for: aParent
			
! !

!PDFReportElement methodsFor:'accessing'!

deferredFrames
	"^an OrderedCollection 
	I return my collection of frames which are waiting to be written."

	deferredFrames isNil ifTrue: [deferredFrames := OrderedCollection new].
	^deferredFrames
			
!

parent
	"^a PDFReport 
	I return my parent."

	^parent
			
!

parent: aParent 
	"^self 
	I record my parent."

	parent := aParent.
	^self
			
! !

!PDFReportElement methodsFor:'initialize-release'!

for: aParent 
	"^a PDFReportPages 
	I initialize and return myself."

	self parent: aParent.
	^self
			
! !

!PDFReportElement methodsFor:'services'!

addDeferredFrame: aBlock 
	"^self 
	I add a deferred frame block to my collection of deferred frames."

	self deferredFrames add: aBlock.
	^self
			
! !

!PDFReportElement methodsFor:'writing'!

newLine
	"^self 
	Moves to a new line in the target PDF document."

	^self subclassResponsibility
			
!

write: aString 
	"^self 
	Writes aString to the current body of the PDF document. Note that there 
	is no new line or anything like that."

	^self subclassResponsibility
			
! !

!PDFReportElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFReportElement.st,v 1.1 2006/09/07 11:23:41 sr Exp $'
! !
