"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#PDFReportLine
	instanceVariableNames:'elements parent'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Reporting'
!


!PDFReportLine class methodsFor:'instance creation'!

for: aParent 
	"^a PDFReportPages 
	I create and initialize a new instance of myself."

	^self new for: aParent
			
! !

!PDFReportLine methodsFor:'accessing'!

elements
	"^an OrderedCollection 
	I recturn my collection of elements - the things that make me up."

	elements isNil ifTrue: [elements := OrderedCollection new].
	^elements
			
!

parent
	"^a PDFReport 
	I return my parent."

	^parent
			
!

parent: aParent 
	"^self 
	I record my parent."

	parent := aParent.
	^self
			
! !

!PDFReportLine methodsFor:'emitting'!

writeOn: aWriter 
	"^self 
	Writes the text of the line to aWriter."

	self elements do: [:element | aWriter write: element asString].
	^self
			
! !

!PDFReportLine methodsFor:'initialize-release'!

for: aParent 
	"^a PDFReportPages 
	I initialize and return myself."

	self parent: aParent.
	^self
			
! !

!PDFReportLine methodsFor:'write'!

write: aString 
	"^self 
	Adds aString to the vector of elements."

	self elements add: aString.
	^self
			
!

writePageNumber: aWidth 
	"^self 
	Adds aString to the vector of elements."

	self elements add: (PDFReportPageNumberToken for: self parent width: aWidth).
	^self
			
! !

!PDFReportLine class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFReportLine.st,v 1.1 2006/09/07 11:18:53 sr Exp $'
! !
