"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#PDFReportPage
	instanceVariableNames:'page framePlacements'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Reporting'
!


!PDFReportPage class methodsFor:'instance creation'!

on: aPage 
	"^aPDFReportPage 
	I create and initialize a new instance of myself."

	^self new on: aPage
			
! !

!PDFReportPage methodsFor:'accessing'!

framePlacements
	"^a Dictionary 
	I return my dictionary (actually, an IdentityDictionary) of placements 
	for any frames which have a presence on the page I represent."

	framePlacements isNil ifTrue: [framePlacements := IdentityDictionary new].
	^framePlacements
			
!

page
	"^a PDFPage 
	I return the page I wrap."

	^page
			
!

page: aPage 
	"^self 
	I record the page I wrap."

	page := aPage.
	^self
			
! !

!PDFReportPage methodsFor:'initialize-release'!

on: aPage 
	"^self 
	I initialize and return myself."

	self page: aPage.
	^self
			
! !

!PDFReportPage methodsFor:'services'!

framePlacementFor: aFrame 
	"^a PDFFramePagePlacement
	Returns the placement of aFrame. An instance of PDFFramePagePlacement 
	will be created for aFrame if none already exists."

	^self framePlacements at: aFrame
		ifAbsentPut: [PDFFramePagePlacement for: aFrame on: self]
			
! !

!PDFReportPage class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFReportPage.st,v 1.1 2006/09/07 11:16:54 sr Exp $'
! !
