"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#PDFReportPageNumberToken
	instanceVariableNames:'parent width'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Reporting'
!


!PDFReportPageNumberToken class methodsFor:'instance creation'!

for: aParent width: aWidth 
	"^a PDFReportPages 
	I create and initialize a new instance of myself."

	^self new for: aParent width: aWidth
			
! !

!PDFReportPageNumberToken methodsFor:'accessing'!

parent
	"^a PDFReport 
	I return my parent."

	^parent
			
!

parent: aParent 
	"^self 
	I record my parent."

	parent := aParent.
	^self
			
!

width
	"^a PDFReport 
	I return my width."

	^width
			
!

width: aWidth 
	"^self 
	I record my width:."

	width := aWidth.
	^self
			
! !

!PDFReportPageNumberToken methodsFor:'emitting'!

asString
	"^a String 
	Returns a string representation of the receiver based on the 
	current status of the parent PDFReport (i.e. the page we're on), 
	and also the width specified for this token. 
	Note: This method needs review. There *must* be a better way ..."

	| pageNumber paddedPageNumber numberOfPaddingCharactersNeeded |
	pageNumber := self report pages currentPageNumber printString.
	paddedPageNumber := WriteStream on: String new.
	numberOfPaddingCharactersNeeded := self width - pageNumber size.
	1 to: numberOfPaddingCharactersNeeded do: [:index | paddedPageNumber space].
	paddedPageNumber nextPutAll: pageNumber.
	^paddedPageNumber contents
			
! !

!PDFReportPageNumberToken methodsFor:'initialize-release'!

for: aParent width: aWidth 
	"^a PDFReportPages 
	I initialize and return myself."

	self parent: aParent; width: aWidth.
	^self
			
! !

!PDFReportPageNumberToken methodsFor:'services'!

report
	"^aPDFReport 
	I return my parent report. This is just a convinience method."

	^self parent report
			
! !

!PDFReportPageNumberToken class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFReportPageNumberToken.st,v 1.1 2006/09/07 11:12:48 sr Exp $'
! !
