"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFBodyObject subclass:#PDFResources
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFResources comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.'
!


!PDFResources methodsFor:'emitting'!

writeFontClauseOn: aWriter 
	"^self 
	I write out the resources /Font clause to a Writer. 
	For now I just write out a single line for the default font."

	aWriter writeLine: '/Font'.
	aWriter writeLine: '<<'.
	self parent fontPalette fontDeclarations
		do: 
			[:fontDeclaration | 
			fontDeclaration writeResourceReferenceOn: aWriter.
			aWriter newLine].
	aWriter writeLine: '>>'.
	^self
			
!

writePDFSyntaxOn: aWriter 
	"^self 
	I write myself to aWriter. Once written (after this), I am immutable."

	self id writeDeclarationOn: aWriter.
	aWriter newLine.
	aWriter writeLine: '%Resources'.
	aWriter write: '<<'.
	self writeProcSetClauseOn: aWriter.
	self writeFontClauseOn: aWriter.
	self writeXObjectClauseOn: aWriter.
	aWriter writeLine: '>>'.
	aWriter writeLine: 'endobj'.
	^self
			
!

writeProcSetClauseOn: aWriter 
	"^self 
	I write the 'ProcSet' clause to the PDF file."

	aWriter writeLine: '/ProcSet [/PDF /Text]'.
	^self
			
!

writeXObjectClauseOn: aWriter 
	"^self 
	I write out the resources /XObject clause to a Writer."

	aWriter writeLine: '/XObject'.
	aWriter writeLine: '<<'.
	self catalog xObjects
		do: 
			[:xObject | 
			xObject writeResourceReferenceOn: aWriter.
			aWriter newLine].
	aWriter writeLine: '>>'.
	^self
			
! !

!PDFResources class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFResources.st,v 1.1 2006/09/07 11:15:16 sr Exp $'
! !
