"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#PDFStream
	instanceVariableNames:'stream header footer body context font'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Stream'
!


!PDFStream class methodsFor:'instance-creation'!

new
	^super new
		initialize;
		yourself
!

on: aStream
	^self new
		on: aStream;
		yourself
! !

!PDFStream methodsFor:'accessing'!

body
	^body
!

footer
	^footer
!

header
	^header
! !

!PDFStream methodsFor:'contexts'!

body: aBlock
	context addLast: self body.
	aBlock value.
	context removeLast.
!

footer: aBlock
	context addLast: self footer.
	aBlock value.
	context removeLast.
!

header: aBlock
	context addLast: self header.
	aBlock value.
	context removeLast.
! !

!PDFStream methodsFor:'fonts'!

font: aPDFFont do: aBlock
	font addLast: aPDFFont.
	aBlock value.
	font removeLast.
! !

!PDFStream methodsFor:'initialization'!

initialize
	stream := nil.
	header := thisContext.
	footer := thisContext.
	body := thisContext.
	context := OrderedCollection new.
	font := OrderedCollection new.
! !

!PDFStream methodsFor:'pdf-properties'!

compression
	^stream file useCompression
!

compression: aBoolean
	stream file useCompression: aBoolean
! !

!PDFStream methodsFor:'private'!

on: aStream
	stream := PDFWriter 
		on: aStream
! !

!PDFStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFStream.st,v 1.1 2006/09/07 11:15:40 sr Exp $'
! !
