"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFObject subclass:#PDFString
	instanceVariableNames:'string'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFString comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.'
!


!PDFString class methodsFor:'instance creation'!

on: aString 
	"^a PDFString 
	I return a new instance of myself on aString."

	^self new on: aString
			
! !

!PDFString methodsFor:'accessing'!

string
	"^a String 
	I return my original string."

	^string
			
!

string: aString 
	"^self 
	I record my original string."

	string := aString.
	^self
			
! !

!PDFString methodsFor:'converting'!

asEscapedString
	"^a String 
	I return the string representation of my _string which conforms 
	with the PDF spec (c.f 4.4 pp44). The key activity is to escape 
	(put a '\' in front of) dangerous (e.g. \, (, ) ) characters."
	
	| source target |

	"fetch data"
	source := self string withoutTrailingBlanks.
	target := WriteStream on: String new.

	"produce output"
	target nextPut: $(.
	source do: [ :character |
		(character = $\ | (character = $() | (character = $)))
			ifTrue: [ target nextPut: $\ ].
		target nextPut: character ].
	target nextPut: $).

	"return output"
	^target contents
! !

!PDFString methodsFor:'initialize-release'!

on: aString 
	"^self 
	I initialize myself on aString."

	self string: aString.
	^self
			
! !

!PDFString class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFString.st,v 1.1 2006/09/07 11:20:38 sr Exp $'
! !
