"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFElement subclass:#PDFStructureElement
	instanceVariableNames:'parent'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFStructureElement comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.

I am abstract, but the instances of my subclasses all form a part of the structure of the PDF file.  The elements of this structure form a tree, and every element knows it''s parent.'
!


!PDFStructureElement class methodsFor:'instance creation'!

for: aParent 
	"^a PDFStructureElement 
	I create and return a new instance of myself. I set aParent 
	as the parent of the new instance."

	^self new parent: aParent
			
! !

!PDFStructureElement methodsFor:'accessing'!

parent
	"^a PDFElement 
	I return my parent. My parent will always be a PDFElement 
	of some kind."

	^parent
			
!

parent: aParent 
	"^self 
	I record my parent. My parent will always be a PDFElement 
	of some kind."

	parent := aParent.
	^self
			
! !

!PDFStructureElement methodsFor:'emitting'!

predecessor
	"^a PDFElement 
	I return my predecessor. For me, this is the PDF file header."

	^self body file header
			
! !

!PDFStructureElement methodsFor:'services'!

body
	"^a PDFBody 
	I return the PDFBody which is my ultimate parent. I need to know 
	my body for things like getting my object ID and adding my details 
	to the PDFCrossReference."

	^self parent body
			
!

catalog
	"^a PDFCatalog 
	I return the PDF catalog for the PDF file of which I am a part.."

	^self body catalog
			
!

file
	"^a PDFFile 
	I return the PDF file of which I am a part. I delegate this to my 
	body."

	^self body file
			
!

page
"^a PDFPage
I return the page upon which I'll appear."
	^self parent page
			
! !

!PDFStructureElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFStructureElement.st,v 1.1 2006/09/07 11:18:06 sr Exp $'
! !
