"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFTextOperator subclass:#PDFTextPositioning
	instanceVariableNames:'coordinate'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFTextPositioning comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.

My instances represent the text-wide parameters for a particular PDFText object.  Things like font and starting point.'
!


!PDFTextPositioning methodsFor:'accessing'!

coordinate
	"^a PDFPoint 
	I return the point at which I appear. If my coordinate is null, I just follow 
	on from that last thing to be written to the page."

	^coordinate
			
!

coordinate: aPoint 
	"^self 
	I record the point at which I appear. If my coordinate is null, I just follow 
	on from that last thing to be written to the page."

	coordinate := aPoint.
	^self
			
! !

!PDFTextPositioning methodsFor:'emitting'!

writePDFSyntaxOn: aWriter 
	"^self 
	I write myself to aWriter. This means witing out all of my positioning parameters 
	such as Td, TD, Tm etc."

	self writeTextMatrixOn: aWriter.
	^self
			
!

writeTextMatrixOn: aWriter 
	"^self 
	I write my text matrix statement which takes the form: 
	'1 0 0 1 x y Tm' 
	where x and y are the x and y coordinates respectively"

	self coordinate notNil
		ifTrue: 
			[aWriter write: '1 0 0 1 '.
			aWriter write: self coordinate x printString , ' ' , self coordinate y printString.
			aWriter writeLine: ' Tm'].
	^self
			
! !

!PDFTextPositioning methodsFor:'private'!

applyTo: aTextObject 
	"^self 
	I add myself as an operator within aTextObject by adding myself to the 
	operators vector."

	aTextObject operators add: self.
	aTextObject currentTextPositioning: self.
	^self
			
! !

!PDFTextPositioning class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFTextPositioning.st,v 1.1 2006/09/07 11:09:18 sr Exp $'
! !
