"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

PDFFileElement subclass:#PDFTrailer
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Core'
!

PDFTrailer comment:'Copyright (c) 1998 SPL WorldGroup, Inc. ("SPL WorldGroup").  All rights reserved. Protected by the copyright laws of the United States and international treaties.  This software may only be used in accordance with the terms and conditions of the "SPL WorldGroup, Inc. Software Web Site Agreement" which can be viewed on SPL WorldGroup''s web site, at www.splwg.com.'
!


!PDFTrailer methodsFor:'emitting'!

predecessor
	"^a PDFElement 
	I return my predecessor if I have one. This is used to make sure that 
	the elements of the PDF file are written in the correct order. My predecessor 
	Is the PDF cross reference."

	^self file crossReference
			
!

writePDFSyntaxOn: aWriter 
	"^self 
	I write myself to aWriter. First I must make sure that the cross 
	reference has been written out, then I can write out my stuff."

	aWriter writeLine: 'trailer'.
	aWriter writeLine: '<<'.
	self writeSizeClauseOn: aWriter.
	self writeRootClauseOn: aWriter.
	aWriter writeLine: '>>'.
	self writeStartXrefClauseOn: aWriter.
	aWriter writeLine: '%%EOF'.
	^self
			
!

writeRootClauseOn: aWriter 
	"^self 
	I write the /Root clause to aWriter. This just identifies the root object in 
	the PDF file. The root is the catalog."

	aWriter write: '/Root '.
	self file body catalog id writeReferenceOn: aWriter.
	aWriter newLine.
	^self
			
!

writeSizeClauseOn: aWriter 
	"^self 
	I write the /Size clause to aWriter. This is the number of body 
	objects present in this PDF file."

	| numberOfObjects |
	aWriter write: '/Size '.
	numberOfObjects := self file crossReference entries size + 1.
	aWriter write: numberOfObjects printString.
	aWriter newLine.
	^self
			
!

writeStartXrefClauseOn: aWriter 
	"^self 
	I write the 'startxref' clause on aWriter."

	| offsetString |
	aWriter writeLine: 'startxref'.
	offsetString := self file crossReference offset printString.
	aWriter writeLine: offsetString.
	^self
			
! !

!PDFTrailer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__PDFTrailer.st,v 1.1 2006/09/07 11:19:56 sr Exp $'
! !
