"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#SPDFSelfTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Testing'
!

SPDFSelfTest class instanceVariableNames:'testTargetDirectory'

"
 No other class instance variables are inherited by this class.
"
!


!SPDFSelfTest class methodsFor:'resource'!

resetSelfTestTargetDirectory
	"^self 
	I just set the target diretory to nil - I'll 
	prompt if / when I need one."
	"self resetSelfTestTargetDirectory"

	testTargetDirectory := nil.
	^self
			
!

selfTestTargetDirectory
        "^a Filename 
        I return the directory which will be the 
        target for all of the output files from the 
        self test. If I don't already know it, I use a 
        file dialog to get it."

        | filenameString directory |
        testTargetDirectory isNil
                ifTrue: 
                        [filenameString := NativeDialog requestFileName: 'Please specify directory for test output'.
                        filenameString isEmptyOrNil ifTrue:[AbortSignal raise].
                        directory := NativeFilename named: filenameString.
                        directory isDirectory
                                ifFalse: 
                                        [(NativeDialog confirm: 'Oops.  I need the name of an existing *directory*. Create it ?')
                                                ifTrue:[directory recursiveMakeDirectory. ^ directory].
                                        ^self selfTestTargetDirectory].
                        testTargetDirectory := directory].
        ^testTargetDirectory
!

testFileNamed: aTerminalFilename 
	"^a Filename 
	I return a Filename within the current self 
	test target directory."

	^SPDFSelfTest selfTestTargetDirectory construct: aTerminalFilename
			
! !

!SPDFSelfTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__SPDFSelfTest.st,v 1.2 2009/12/08 10:07:20 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__SPDFSelfTest.st,v 1.2 2009/12/08 10:07:20 cg Exp $'
! !
