"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

TIFFField subclass:#TIFFNewSubFileTypeField
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Images'
!

TIFFNewSubFileTypeField comment:'NewSubfileType

A general indication of the kind of data contained in this subfile.
	Tag = 254 (FE.H)
	Type = LONG
	N = 1

Replaces the old SubfileType field, due to limitations in the definition of that field. NewSubfileType is mainly useful when there are multiple subfiles in a single TIFF file.

This field is made up of a set of 32 flag bits. Unused bits are expected to be 0. Bit 0 is the low-order bit.
Currently defined values are:
Bit 0 	is 1 if the image is a reduced-resolution version of another image in this TIFF file;
		else the bit is 0.
Bit 1	is 1 if the image is a single page of a multi-page image (see the PageNumber field
		description); else the bit is 0.
Bit 2 	is 1 if the image defines a transparency mask for another image in this TIFF file.
		The PhotometricInterpretation value must be 4, designating a transparency mask.

These values are defined as bit flags because they are independent of each other.
Default is 0.'
!


!TIFFNewSubFileTypeField class methodsFor:'static information'!

tag
	^254
			
!

tagName
	^'NewSubFileType'
			
! !

!TIFFNewSubFileTypeField class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__TIFFNewSubFileTypeField.st,v 1.1 2006/09/07 11:23:20 sr Exp $'
! !
