"{ Package: 'stx:goodies/pdf' }"

"{ NameSpace: Squeak }"

Object subclass:#TestReport14
	instanceVariableNames:'targetStream report bodyFrame'
	classVariableNames:''
	poolDictionaries:''
	category:'SPDF-Testing'
!

TestReport14 comment:'Just tests frame layouts using non-complete frame rectangles for leaf meta-frames.'
!


!TestReport14 class methodsFor:'testing'!

test
	"^self
	Write myself to the test directory at pdfreporting14.pdf."

	"TestReport14 test"

	| fileStream |
	fileStream := (PDFReportingSelfTest testFileNamed: 'spdfreporting14.pdf') 
				writeStream.
	[self new writeTo: fileStream] ensure: [fileStream close].
	^self
			
! !

!TestReport14 methodsFor:'accessing'!

bodyFrame
	bodyFrame isNil 
		ifTrue: 
			[bodyFrame := PDFMetaFrame 
						within: self report mediaFrame
						x: 50
						y: 786
						width: self bodyWidth
						height: 700.
			bodyFrame setBorderOff.
			bodyFrame name: 'Body Frame'].
	^bodyFrame
			
!

bodyWidth
	"^an Integer
	The width, in points, of the body of the report."

	^485
			
!

report
	"^a PDFReport
	Initialized to be A4 portrait."

	report isNil 
		ifTrue: 
			[report := PDFReport on: targetStream.
			report mediaFrame setOrientationToPortraitA4].
	^report
			
! !

!TestReport14 methodsFor:'writing'!

writeReport
	5 timesRepeat: 
			[self
				writeLeafFrame;
				writeSpaceFrame].
	^self
			
!

writeTo: aStream 
	targetStream := aStream.
	report := self report.
	self writeReport.
	report close.
	^self
			
! !

!TestReport14 methodsFor:'writing-private'!

writeLeafFrame
	| frame |
	frame := PDFMetaFrame 
				within: self bodyFrame
				x: nil
				y: nil
				width: nil
				height: 50.
	frame setBorderOn.
	frame name: 'Leaf Frame'.
	frame close.
	self bodyFrame newLine.
	^self
			
!

writeSpaceFrame
	| frame |
	frame := PDFMetaFrame 
				within: self bodyFrame
				x: nil
				y: nil
				width: nil
				height: 50.
	frame setBorderOff.
	frame name: 'Space Frame'.
	frame close.
	self bodyFrame newLine.
	^self
			
! !

!TestReport14 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/pdf/Squeak__TestReport14.st,v 1.1 2006/09/07 11:19:43 sr Exp $'
! !
