"{ Package: 'stx:goodies/pdf' }"
!

!ByteArray class methodsFor:'*SPDF'!

decodeFrom: start from: source startingAt: index into: dest
	| from to w stop |
	to := start.
	from := index.
	stop := dest size.
	" Map groups of 4 source bytes into groups of 3 destination bytes. "
	[to <= stop]
		whileTrue:
			[w := (((source at: from) asInteger bitAnd: 63) bitShift: 18) +
				(((source at: from + 1) asInteger bitAnd: 63) bitShift: 12) +
				(((source at: from + 2) asInteger bitAnd: 63) bitShift: 6) +
				((source at: from + 3) asInteger bitAnd: 63).
			from := from + 4.
			dest at: to put: (w bitShift: -16).
			to < stop ifTrue:
				[dest at: to + 1 put: ((w bitShift: -8) bitAnd: 255).
				to + 1 < stop ifTrue:
					[dest at: to + 2 put: (w bitAnd: 255)]].
			to := to + 3]
! !

!ByteArray class methodsFor:'*SPDF'!

fromPackedString: packedString
	"Decode the receiver from a ByteArray that was a printable String."
	"ByteArray fromPackedString: '^24FS @a'"

	| size result last resultSize |
	size := packedString size.
	size = 0 ifTrue: [^self new].
	last := packedString last asInteger.
	resultSize := size // 4 * 3.
	last >= 96
		ifTrue: [ resultSize := resultSize - 3 + last - 96 ].
	result := self new: resultSize.
	self decodeFrom: 1 from: packedString startingAt: 1 into: result.
	^result
! !

!CharacterArray methodsFor:'Compatibility-Squeak'!

withoutTrailingBlanks
    "Return a copy of the receiver from which trailing blanks have been trimmed."

    ^ self withoutTrailingSeparators

    "
     '  hello    world    ' withoutTrailingBlanks
    "
! !

!Number methodsFor:'*SPDF'!

** aNumber 
	"Answer the receiver raised to the power of the argument, aNumber."

	^self raisedTo: aNumber
! !

!Stream methodsFor:'*SPDF'!

nextAvailable: anInteger into: aSequenceableCollection startingAt: startIndex
	"Store the next anInteger elements of the receiver into aSequenceableCollection
	starting at startIndex in aSequenceableCollection.  If there are not enough elements
	available, store as many as are available.  Answer the number of elements stored."

	self next: anInteger into: aSequenceableCollection startingAt: startIndex.
	^anInteger
! !

