"
 This is a Manchester Goodie.  It is distributed freely on condition
 that you observe these conditions in respect of the whole Goodie, and on
 any significant part of it which is separately transmitted or stored:
	* You must ensure that every copy includes this notice, and that
	  source and author(s) of the material are acknowledged.
	* These conditions must be imposed on anyone who receives a copy.
	* The material shall not be used for commercial gain without the prior
	  written consent of the author(s).

 For more information about the Manchester Goodies Library (from which
 this file was distributed) send e-mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: help
"

"{ Package: 'stx:goodies/postscript' }"


Object subclass:#PSFont
	instanceVariableNames:'family size'
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-Postscript'
!

PSFont comment:'PSFont describes a font family, scaled to a particular size.

Instance Variables
	family  <PSFontFamily> Encodes the family, the character widths, and the encoding of the font
	size    <Integer>      The height of an average upper case character'!

!PSFont class methodsFor:'documentation'!

copyright
"
 This is a Manchester Goodie.  It is distributed freely on condition
 that you observe these conditions in respect of the whole Goodie, and on
 any significant part of it which is separately transmitted or stored:
	* You must ensure that every copy includes this notice, and that
	  source and author(s) of the material are acknowledged.
	* These conditions must be imposed on anyone who receives a copy.
	* The material shall not be used for commercial gain without the prior
	  written consent of the author(s).

 For more information about the Manchester Goodies Library (from which
 this file was distributed) send e-mail:
	To: goodies-lib@cs.man.ac.uk
	Subject: help
"


!

documentation
"
    PSFont describes a font family, scaled to a particular size.
    This is a helper class for PSGraphicsContext.

    [Instance Variables:]

	family  <PSFontFamily>     Encodes the family, the character widths, and the encoding of the font
	size    <Integer>          The height of an average upper case character

    [see also:]
	PSGraphicsContext FontDescription Font
"
! !

!PSFont methodsFor:'accessing'!

charSize

	^size
!

encode: aCharacter
	^family encode: aCharacter
!

fullName

	^family fullName
!

underlinePosition

	^family underlinePosition * size
!

underlineThickness

	^family underlineThickness * size
!

widthOf: aCharacter

	^(family widths at: (self encode: aCharacter)
		  ifAbsent: [family widths at: #space]) * size
! !

!PSFont methodsFor:'initialize-release'!

family: fontFamily size: charSize

	family := fontFamily.
	size := charSize
! !

!PSFont class methodsFor:'documentation'!

version
   ^ '$Header: /cvs/stx/stx/goodies/postscript/PSFont.st,v 1.7 2007/11/08 14:33:41 cg Exp $'
! !
