"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologClass subclass:#Examples
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog-Examples'
!


!Examples methodsFor:'helpers'!

smalltalkMessage:aMessageString
    self information:'Message from Prolog: ', aMessageString string
!

smalltalkMessage:aMessageString with:arg
    self information:'Message from Prolog: ', aMessageString string , ' ', arg string
! !

!Examples methodsFor:'prolog-I/O'!

instanceSend :-
	send(instance, smalltalkMessage:, ["hello"]).

% instanceSend

!

instanceSend2 :-
	send(instance, smalltalkMessage:with:, [hello,world]).

% instanceSend2

!

readAndWrite :-
	readln(String),
	write(String), nl.

% readAndWrite

!

readAndWrite2 :-
	readln(String),
	writeln(String).

% readAndWrite2

!

readAndWrite3 :-
	readln(String, 'hello'),
	writeln(String).

% readAndWrite3

! !


!Examples methodsFor:'prolog-factorial'!

factorial(Number,Result) :-
	nonvar(Number),
	>(Number, 0),
	-(Number, 1, OneLess),
	factorial(OneLess, ResultOfOneLess),
	*(Number, ResultOfOneLess, Result).

factorial(0,1).

factorial(Number,Result) :-
	nonvar(Result),
	var(Number),
	factorial(Number,Result,2,2). 


%
% helpers
%
factorial(NumberVar, FactorialResult, TriedNumber, KnownFactorialOfTriedNumber) :-
	=(KnownFactorialOfTriedNumber, FactorialResult),
	=(NumberVar, TriedNumber).

factorial(NumberVar, FactorialResult, TriedNumber, KnownFactorialOfTriedNumber) :-
	<(KnownFactorialOfTriedNumber, FactorialResult),
	+(TriedNumber, 1, NextTriedNumber),
	*(KnownFactorialOfTriedNumber, NextTriedNumber, KnownFactorialOfNextTriedNumber),
	factorial(NumberVar, FactorialResult, NextTriedNumber, KnownFactorialOfNextTriedNumber).

%"
    what is the factorial of 10 (select and PrintIt):
	factorial(10, F)        
	factorial(100, F)
	factorial(1000, F)        

    reverse question:
	factorial(N, 3628800)      
	factorial(N, 93326215443944152681699238856266700490715968264381621468592963895217599993229915608941463976156518286253697920827223758251185210916864000000000000000000000000)
	factorial(N, 99)        

    testing:
	factorial(10, 3628800)         
	factorial(11, 3628800)         

    tracing:
	self new
	    trace:true;
	    query:'factorial(4, F)'

    illegal:
	factorial(N, F)         

"%
! !

!Examples class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/Examples.st,v 1.5 2002/11/26 18:31:35 cg Exp $'
! !
