"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologClass subclass:#FamilyRelations
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog-Examples'
!


!FamilyRelations methodsFor:'prolog-clauses'!

aunt(SomeOne, TheAunt) :- 
        mother(SomeOne, SomeMother), 
        sister(SomeMother, TheAunt).

aunt(SomeOne, TheAunt) :- 
        father(SomeOne, SomeFather), 
        sister(SomeFather, TheAunt).

%"
    Family new queryValue:'aunt(sofia,X).'  
"%

!

brother(SomeOne, TheBrother) :- 
        mother(SomeOne, TheMother),
        mother(TheBrother, TheMother),
        \==(SomeOne, TheBrother),
        male(TheBrother).

%"
    Family new queryValue:'brother(sofia,X).'       
    Family new queryValue:'brother(X,vincent).'  

    Family new 
        trace:true;
        query:'brotherValue(sofia,X).' 
"%

!

grandFather(SomeOne, TheGrandPa) :- 
        father(SomeOne, SomeFather), 
        father(SomeFather, TheGrandPa).

grandFather(SomeOne, TheGrandPa) :- 
        mother(SomeOne, SomeMother), 
        father(SomeMother, TheGrandPa).

%"
    % who are sofias grandPas
    Family new queryValue:'grandFather(sofia,X).'    

    % of whome is gnther the grandPa ?
    Family new queryValue:'grandFather(X,gnther).'    
"%

!

grandMother(SomeOne, TheGrandMa) :- 
        mother(SomeOne, SomeMother), 
        mother(SomeMother, TheGrandMa).

grandMother(SomeOne, TheGrandMa) :- 
        father(SomeOne, SomeFather), 
        mother(SomeFather, TheGrandMa).

%"
    Family new queryValue:'grandMother(sofia,X).'    
"%

!

sister(SomeOne, TheSister) :- 
        mother(SomeOne, TheMother),
        mother(TheSister, TheMother),
        \==(SomeOne, TheSister),
        female(TheSister).

%"
    Family new queryValue:'sister(claus,X).'  
"%

!

uncle(SomeOne, TheUncle) :- 
        mother(SomeOne, SomeMother), 
        brother(SomeMother, TheUncle).

uncle(SomeOne, TheUncle) :- 
        father(SomeOne, SomeFather), 
        brother(SomeFather, TheUncle).

%"
    Family new queryValue:'uncle(sofia,X).'  
"%

! !

!FamilyRelations methodsFor:'queries'!

brothersOf:somePerson
     ^ self
        query:'brother(',somePerson,',X).' 

     "
      Family new brothersOf:'sofia'          
     "


!

fatherOf:somePerson
     ^ self
        query:'father(',somePerson,',X).' 

     "
      Family new fatherOf:'sofia'          
     "


!

grandFathersOf:somePerson
     ^ self
        query:'grandFather(',somePerson,',X).' 

     "
      Family new grandFathersOf:'sofia'          
     "


!

grandMothersOf:somePerson
     ^ self
        query:'grandMother(',somePerson,',X).' 

     "
      Family new grandMothersOf:'sofia'          
     "


!

motherOf:somePerson
     ^ self
        query:'mother(',somePerson,',X).' 

     "
      Family new motherOf:'sofia'          
     "
!

sistersOf:somePerson
     ^ self
        query:'sister(',somePerson,',X).' 

     "
      Family new sistersOf:'vincent'          
     "


!

unclesOf:somePerson
     ^ self
        query:'uncle(',somePerson,',X).' 

     "
      Family new unclesOf:'sofia'          
     "


! !

!FamilyRelations class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/FamilyRelations.st,v 1.3 2002/11/26 18:31:11 cg Exp $'
! !
