"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologClass subclass:#LogicSimulation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog-Examples'
!


!LogicSimulation methodsFor:'prolog-clauses'!

%
% and gate with 2,3 or 4 inputs
%
and_(0,0,0).    
and_(0,1,0).
and_(1,0,0).    
and_(1,1,1).

and_(In1,In2,In3,Out) :-
    and_(In1,In2,T),
    and_(In3, T, Out).

and_(In1,In2,In3,In4,Out) :-
    and_(In1,In2,T1),
    and_(In3,In4,T2),
    and_(T1, T2, Out).

%"

   and_(0,0,0,Out) 
   and_(0,0,1,Out)  
   and_(0,1,0,Out)  
   and_(1,0,0,Out)  
   and_(1,1,0,Out)  
   and_(1,0,1,Out)  
   and_(0,1,1,Out)  
   and_(1,1,1,Out)  
"%

!

doesCompute(F, In, Out) :-
        is(Out, F(In)).

doesCompute(F, In1, In2, Out) :-
        is(Out, F(In1, In2)).

doesCompute(F, In1, In2, In3, Out) :-
        is(Out, F(In1, In2, In3)).

doesCompute(F, In1, In2, In3, Out) :-
        is(T, G(In1, In2)),
        is(Out, H(T, In3)).

doesCompute(F, [In|Out]) :-
        doesCompute(F, In, Out).

doesCompute(F, In1, [In2|Out]) :-
        doesCompute(F, In1, In2, Out).

doesCompute(F, In1, In2, [In3|Out]) :-
        doesCompute(F, In1, In2, In3, Out).


%"
    doesCompute(not_, 0, 1)    
    doesCompute(not_, 1, 0)    
    doesCompute(not_, 0, 0)    
    doesCompute(not_, 1, 1)    
    doesCompute(not_, [0|1])   
    doesCompute(not_, [0|0])   

    doesCompute(F, 0, 1)       
    doesCompute(F, 0, 0)       

    doesCompute(F, 0, 0, 1)       
    doesCompute(F, 0, 0, 0 , 1)       

"%





!

doesComputeAll(F, []).
doesComputeAll(F, [Head|Tail] ) :-
        doesCompute(F, Head),
        doesComputeAll(F, Tail).


%"
    doesComputeAll(not_, [ [0|1] , [1|0] ] )
"%
!

findCircuit2(ResultList, Gate) :- 
        nth(ResultList, 1, Out1),
        findCircuit2(0, 0, Out1, Gate),
        nth(ResultList, 2, Out2),
        findCircuit2(0, 1, Out2, Gate),
        nth(ResultList, 3, Out3),
        findCircuit2(1, 0, Out3, Gate),
        nth(ResultList, 4, Out4),
        findCircuit2(1, 1, Out4, Gate),
        !!.

findCircuit2(In1, In2, Out, Gate) :- 
        is(Out, Gate(In1, In2)).

%"

   which gate computes
        0 0 -> 0
        0 1 -> 1
        1 0 -> 1
        1 1 -> 1
     findCircuit2( [ 0, 1, 1, 1 ], Gate) 

   which gate computes
        0 0 -> 0
        0 1 -> 1
        1 0 -> 0
        1 1 -> 1
     findCircuit2( [ 0, 1, 0, 1 ], Gate) 

"%
        

!

is(Out, G(In))                  :- isGate1(G), G(In, Out).

is(Out, G(In1,In2))             :- isGate2(G), G(In1,In2,Out).

is(Out, G(not_(In1),not_(In2))) :- isGate2(G), 
                                   is(N1, not_(In1)),
                                   is(N2, not_(In2)),
                                   G(N1, N2,Out).

is(Out, G(In1,not_(In2))) :- isGate2(G), 
                             is(N2, not_(In2)),
                             G(In1, N2,Out).

is(Out, G(not_(In1),In2)) :- isGate2(G), 
                             is(N1, not_(In1)),
                             G(N1, In2,Out).

is(Out, not_(G(In1,In2))) :- isGate2(G), 
                             is(OutN, not_(Out)),
                             G(In1, In2, OutN).

%" 
    is(1 , not_(0))     
    is(Out , not_(0))    
    is(1 , not_(In))    
    is(1 , F(0))        

    is(1 , F(1,1))      
    is(0 , F(1,1))      

    is(1 , F(1,0))    
    is(0 , F(1,0))    

    is(1 , F(0,1))    
    is(0 , F(0,1))    

    is(1 , F(0,0))    
    is(0 , F(0,0))    

    is(A , F(1,0))    
trace,    is(0 , F(A,B))    
    is(0 , F(A,B,C))    

    is(0 , F(not_(A),not_(B)))    
    trace , is(1 , F(not_(A),not_(B)))    
    trace , is(1 , F(not_(A)))     

    trace , is(1 , F(A))     
    trace , is(X , F(A))     

"%
!

isGate1(not_).

!

isGate2(and_).
isGate2(or_).
isGate2(xor_).
isGate2(nand_).
isGate2(nor_).

!

%
% nand gate with 2,3 or 4 inputs
%
nand_(In1,In2,Out):-
        and_(In1,In2,N1),
        not_(N1,Out).

nand_(In1,In2,In3,Out):-
        and_(In1,In2,In3,N1),
        not_(N1,Out).

nand_(In1,In2,In3,In4,Out):-
        and_(In1,In2,In3,In4,N1),
        not_(N1,Out).

%"
   nand_(0,0,X)  
   nand_(0,1,X)  
   nand_(1,0,X)  
   nand_(1,1,X)  
"%
!

%
% nor gate with 2,3 or 4 inputs
%
nor_(Input1,Input2,Output):-
        or_(Input1,Input2,N1),
        not_(N1,Output).

nor_(In1,In2,In3,Out):-
        or_(In1,In2,In3,N1),
        not_(N1,Out).

nor_(In1,In2,In3,In4,Out):-
        or_(In1,In2,In3,In4,N1),
        not_(N1,Out).

%"
   nor_(0,0,X)  
   nor_(0,1,X)  
   nor_(1,0,X)  
   nor_(1,1,X)  
"%
!

%
% not gate
%
not_(1,0).
not_(0,1).

%"
    is(F,0,1), is(F,1,0).
"%
!

%
% or gate with 2,3 or 4 inputs
%
or_(0,0,0).     
or_(0,1,1).
or_(1,0,1).     
or_(1,1,1).

or_(In1,In2,In3,Out) :-
    or_(In1,In2,T),
    or_(In3, T, Out).

or_(In1,In2,In3,In4,Out) :-
    or_(In1,In2,T1),
    or_(In3,In4,T2),
    or_(T1, T2, Out).

%"

   or_(0,0,0,Out)
   or_(0,0,1,Out)  
   or_(0,1,0,Out)  
   or_(1,0,0,Out)  
   or_(1,1,1,Out)  
"%

!

table2(F) :-
    F(0,0,T1),
    write('0 0 -> '), write(T1), nl,
    F(0,1,T2),
    write('0 1 -> '), write(T2), nl,
    F(1,0,T3),
    write('1 0 -> '), write(T3), nl,
    F(1,1,T4),
    write('1 1 -> '), write(T4), nl.

%"

        table2(and_)
        table2(xor_)

"%
        

!

table3(F) :-
    F(0,0,0,T1),
    write('0 0 0 -> '), write(T1), nl,
    F(0,0,1,T2),
    write('0 0 1 -> '), write(T2), nl,
    F(0,1,0,T3),
    write('0 1 0 -> '), write(T3), nl,
    F(0,1,1,T4),
    write('0 1 1 -> '), write(T4), nl,
    F(1,0,0,T5),
    write('1 0 0 -> '), write(T5), nl,
    F(1,0,1,T6),
    write('1 0 1 -> '), write(T6), nl,
    F(1,1,0,T7),
    write('1 1 0 -> '), write(T7), nl,
    F(1,1,1,T8),
    write('1 1 1 -> '), write(T8), nl.

%"

        table3(testCircuit_)

"%
        

!

testCircuit(In1,In2,In3,Output) :-
    %
    %         +------+
    % IN1-----|      |
    %         |  AND |--+
    % IN2-----|      |  |  +------+
    %         +------+  +--|      |
    %                      |  OR  |--------- OUT
    % IN3------------------|      |
    %                      +------+
    %         
    %         
    and_(In1,In2,T),
    or_(T,In3,Output).

%"

   % output a logic table:
        table3(testCircuit)

   % when does the circuit output 1 ?
        testCircuit(In1,In2,In3,1)   
"%
        

!

%
% xor gate
%
xor_(0,0,0).
xor_(0,1,1).
xor_(1,0,1).
xor_(1,1,0).

%xor_(In1,In2,Out):-
%        not_(In1,NegatedIn1),
%        not_(In2,NegatedIn2),
%        and_(In1,NegatedIn2,T1),
%        and_(In2,NegatedIn1,T2),
%        or_(T1,T2,Out).


%"
   xor_(0,0,X)      
   xor_(0,1,X)   
   xor_(1,0,X)   
   xor_(1,1,X)   

   % when does an xor output 0 ?
   xor_(X,Y,0)   

"%
! !

!LogicSimulation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/LogicSimulation.st,v 1.4 2002/11/26 18:31:07 cg Exp $'
! !
