"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologClass subclass:#MasterMind
	instanceVariableNames:'tries answers infoTextHolder'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog-Examples'
!

View subclass:#MasterMindView
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	privateIn:MasterMind
!


!MasterMind class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:Prolog::MasterMind andSelector:#windowSpec
     Prolog::MasterMind new openInterface:#windowSpec
     Prolog::MasterMind open
    "

    <resource: #canvas>

    ^ 
     #(#FullSpec
        #name: #windowSpec
        #window: 
       #(#WindowSpec
          #label: 'MasterMind'
          #name: 'MasterMind'
          #min: #(#Point 300 500)
          #max: #(#Point 300 500)
          #bounds: #(#Rectangle 12 22 312 522)
          #menu: #mainMenu
        )
        #component: 
       #(#SpecCollection
          #collection: #(
           #(#ArbitraryComponentSpec
              #name: 'MasterMindView'
              #layout: #(#LayoutFrame 0 0.0 0 0.0 0 1.0 0 1.0)
              #model: #yourself
              #component: #MasterMindView
            )
           #(#LabelSpec
              #label: 'Label'
              #name: 'Label1'
              #layout: #(#LayoutFrame 2 0 -50 1 -2 1 -2 1)
              #style: #(#FontDescription #helvetica #medium #roman 10)
              #foregroundColor: #(#Color 100.0 100.0 100.0)
              #backgroundColor: #(#Color 0.0 0.0 0.0)
              #translateLabel: true
              #labelChannel: #infoTextHolder
            )
           )
         
        )
      )
! !

!MasterMind class methodsFor:'menu specs'!

mainMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:Prolog::MasterMind andSelector:#mainMenu
     (Menu new fromLiteralArrayEncoding:(Prolog::MasterMind mainMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'Game'
            #translateLabel: true
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'New Game'
                  #translateLabel: true
                  #value: #startGame
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'Exit'
                  #translateLabel: true
                  #value: #closeRequest
                )
               )
              nil
              nil
            )
          )
         #(#MenuItem
            #label: 'Help'
            #translateLabel: true
            #startGroup: #right
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'How to Play...'
                  #translateLabel: true
                  #value: #doHowToPlay
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'About...'
                  #translateLabel: true
                  #value: #doAbout
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
! !

!MasterMind methodsFor:'accessing'!

answers
    ^ answers
!

tries
    ^ tries
! !

!MasterMind methodsFor:'aspects'!

infoTextHolder
    infoTextHolder isNil ifTrue:[
        infoTextHolder := ValueHolder new.
        self showWelcomeText.
    ].
    ^ infoTextHolder
! !

!MasterMind methodsFor:'calls from prolog'!

addToAnswerListNumCows:nC andBulls:nB
    "add a users nCows/nBulls to the answer list (for the view)"

    answers isNil ifTrue:[
        answers := OrderedCollection new.
    ].
    answers add:(Array with:nC with:nB).
    self changed.
!

tryMove:aPrologList
    "prolog tries a move ...
     list consists of colors in move"

    |try|

    try := OrderedCollection new.
    aPrologList do:[:el |
        try add:el string asSymbol.
    ].
    tries isNil ifTrue:[
        tries := OrderedCollection new.
    ].
    tries add:try.
    self changed.
! !

!MasterMind methodsFor:'info'!

showBusyText
    self showInfo: 'Thinking ...'
!

showFinished
    self showInfo: 'Game finshed !!\For another one, select New-Game from the menu.'

!

showInfo:message
    self infoTextHolder value: message asString withCRs

!

showNothing
    self showInfo:  '' 

!

showWelcomeText
    self showInfo:  'Welcome !!\To start, select New-Game from the menu.'

! !

!MasterMind methodsFor:'menu actions'!

doAbout
    |box|

    box := AboutBox new.
    box label:'About MasterMind ...'.
    box title:'MasterMind (V' 
               , self class revision 
               , ' of '
               , self class revisionDateString
               , ')

an example to demonstrate how Prolog logic 
can be combined with a smalltalk application.


Have fun.
'.
    box show


!

doHowToPlay
    |box|

    box := InfoBox new.
    box label:'HowToPlay MasterMind ...'.
    box title:'How to play MasterMind (cows and bulls):

choose a secret combination of colors,
and write it down on a piece of paper.
The code cracker will try to crack that 
secret, by presenting guesses.

For each guess, you must enter the number
of bulls (the number of correct colors at
the correct position) and the number of
cows (correct color, but incorrect position).
The game is over, when I cracked your secret.

Have fun.
'.
    box show


!

startGame
    tries := answers := nil.

    self showInfo:''.
    [
        self game.
    ] valueNowOrOnUnwindDo:[
        myPrologInterpreter cleanup
    ]


! !

!MasterMind methodsFor:'prolog-clauses'!

%
% inform user about a try

answerInfo(Nc, Nb) :-
        send(instance, addToAnswerListNumCows:andBulls:, [Nc, Nb]).

!

% list valid colors.
% for a longer game, add 4 additional colors

color(red).
color(green).
color(blue).
color(yellow).
color(white).

% color(brown).
% color(orange).
% color(magenta).
% color(cyan).

%"

   color( C ) 

"%
!

%  actual countCows.
%

commonMembers(Xs, Ys, N) :- commonMembers(Xs, Ys, 0, N).

commonMembers([X|Xs], Ys, K, N) :-
        member(X,Ys), !!,
        +(K, 1, K1), 
        commonMembers(Xs, Ys, K1, N).

commonMembers([X|Xs], Ys, K, N) :-
        commonMembers(Xs, Ys, K, N).

commonMembers([], Ys, N, N).


%"
   commonMembers([ 0 , 1 , 2 , 3 , 4 ] , [ 0 , 1 , 2 , 3 , 4 ], N)      
   commonMembers([ 0 , 1 , 2 , 3 , 4 ] , [ 1 , 2 , 3 , 4,  5 ], N)               
   commonMembers([ 0 , 1 , 2 , 3 , 4 ] , [ 1 , 2 , 3 , 4,  0 ], N)               
   commonMembers([ 0 , 1 , 2 , 3 , 4 ] , [ 1 , 1 , 1 , 2,  2 ], N)               
"%
!

%  bulls are for colors at the right posiion;
%  cows are for colors at any position.
%

%
% find and count cows
%
countAllCows(X, Y, Count) :- commonMembers(X, Y, Count).


%"
   countAllCows([ 0 , 1 , 2 , 3 , 4 ] , [ 0 , 1 , 2 , 3 , 4 ], NW)     
   countAllCows([ 0 , 1 , 2 , 3 , 4 ] , [ 1 , 2 , 3 , 4,  5 ], NW)          
   countAllCows([ 0 , 1 , 2 , 3 , 4 ] , [ 1 , 2 , 3 , 4,  0 ], NW)             
   countAllCows([ 0 , 1 , 2 , 3 , 4 ] , [ 1 , 1 , 1 , 2,  2 ], NW)          
"%
!

%  bulls are for colors at the right posiion;
%

countBulls(Board, Try, NumBull) :- samePlace(Board, Try, NumBull).

%"
   trace ,
   countBulls([ 0 , 1 , 2 , 3 , 4 ],
              [ 0 , 2 , 3,  4,  5 ],
               N)         

   countBulls([ 0 , 1 , 3 , 3 , 4 ],
              [ 1 , 2 , 3,  4,  5 ],
               N)     


   countBulls([ 0 , 1 , 3 , 3 , 4 ],
              [ 0 , 1 , 3,  4,  5 ],
               N)      
"%
!

%  blacks are for colors at the right posiion;
%  whites are for colors.
%

cowsAndBulls(Board, Try, NumCows, NumBulls) :-
        countBulls(Board, Try, NumBulls),
        countAllCows(Board, Try, NumAllCows),
        -(NumAllCows, NumBulls, NumCows).

%"

   cowsAndBulls([ 0 , 1 , 2 , 3 , 4 ],
                [ 1 , 2 , 3,  4,  0 ],
                Nc, Nb)      

   cowsAndBulls([ 0 , 1 , 2 , 3 , 4 ],
                [ 0 , 2 , 3,  4,  5 ],
                Nc, Nb)      

   cowsAndBulls([ 0 , 1 , 2 , 3 , 4 ],
                [ 0 , 0 , 1,  1,  2 ],
                Nc, Nb)       

   cowsAndBulls([ 0 , 1 , 2,  1,  2 ],
                [ 0 , 1 , 2 , 3 , 4 ],
                Nc, Nb)     

   cowsAndBulls([ black , red    , green, blue,  yellow ],
                [ black , yellow , blue , red ,  white ],
                Nc, Nb)     
"%
!

%  play a game
%

game :- game( [] , [] ).

game(OldTries, OldAnswers) :-
        showInfo('Thinking....'),
        newTry(OldTries, OldAnswers, Try),
        tryInfo(Try),
        length(Try, L),
        game(OldTries, OldAnswers, Try, L),
        !!.

game(OldTries, OldAnswers, Try, L) :-
        showInfo('Enter number of correct colors\at correct position.'),
        read(Nb, 'Enter the number of bulls (correct colors at correct position):'),
        showInfo(''),
        game(OldTries, OldAnswers, Try, Nb, L).

game(OldTries, OldAnswers, Try, [], L) :-
        showInfo('Game cancelled.'),
        writeln('Cancelled !!!!!!'),
        !!.

game(OldTries, OldAnswers, Try, L, L) :-
        showInfo('Game over.'),
        answerInfo(0, L),
        writeln('Thats it !!!!!!'),
        !!.

game(OldTries, OldAnswers, Try, Nb, L) :-
        showInfo('Enter number of correct colors\at wrong position.'),
        read(Nc, 'Enter the number of cows (colors at wrong position):'),
        showInfo(''),
        game(OldTries, OldAnswers, Try, Nc, Nb, L).

game(OldTries, OldAnswers, Try, [], Nb, L) :-
        showInfo('Game cancelled.'),
        writeln('Cancelled !!!!!!'),
        !!.

game(OldTries, OldAnswers, Try, Nc, Nb, L) :-
        answerInfo(Nc, Nb),
        game([ Try | OldTries ] , [ [Nc|Nb] | OldAnswers ]).

%"

   trace , game

"%
!

% generate a try
% for a longer game, flip the comments

%genTry([ T1, T2, T3, T4 ] ) :-
%        color(T1), color(T2), color(T3), color(T4), color(T5).

genTry([ T1, T2, T3, T4, T5 ] ) :-
        color(T1), color(T2), color(T3), color(T4), color(T5).

%genTry([ T1, T2, T3, T4, T5, T6 ] ) :-
%        color(T1), color(T2), color(T3), color(T4), color(T5), color(T6).


%"

   genTry( T )

"%
!

%  generate a try, which is ok with all previous tries
%

newTry(OldTries, OldAnswers, Try) :-
        genTry(Try),
%        write('trying '),
%        writeln(Try),
        newTryIsOkFor(Try, OldTries, OldAnswers),
        !!.

newTry(OldTries, OldAnswers, Try) :-
        showInfo('Inconsistent answer.'),
        display('Your answer was not correct/consistent - I cannot find the secret code !!') ,
        !! , fail.

%"

   newTry( [] ,
           [] ,
           Try
         )    

   newTry(  
          [
                [red , red  , green , green , green ]
          ] ,
          [
                [1|1]
          ],
          Try
         )        

   newTry(
          [
                [red , red , green , green , green ]
                [green , green , blue , blue , blue ]
                [white , white , white , white , white ]
          ] ,
          [
                [1|1]
                [0|2]
                [0|0]
          ],
          Try
         )        


"%
!

%  succeed, if a new try matches a history of tries
%

newTryIsOkFor(NewTry, [], []).

newTryIsOkFor(NewTry, [OldTry | MoreOldTries], [ [OldNc | OldNb] | MoreOldAnswers]) :-
        cowsAndBulls(NewTry, OldTry, OldNc, OldNb),
        newTryIsOkFor(NewTry, MoreOldTries, MoreOldAnswers).

%"

   newTryIsOkFor( [ 0 , 1 , 2 , 3 , 4 ] ,
                  [] ,
                  [] )    

   newTryIsOkFor( [ 0 , 1 , 2 , 3 , 4 ] ,
                  [
                        [0 , 0  , 1 , 1 , 1 ]
                  ] ,
                  [
                        [1|1]
                  ] )        

   newTryIsOkFor( [ 0 , 1 , 2 , 3 , 4 ] ,
                  [
                        [0 , 0 , 1 , 1 , 1 ]
                        [1 , 1 , 2 , 2 , 2 ]
                        [5 , 5 , 5 , 5 , 5 ]
                  ] ,
                  [
                        [1|1]
                        [0|2]
                        [0|0]
                  ] )        


"%
!

%  bulls are for colors at the right posiion;
%

samePlace([], [], 0) :- !!.

samePlace([B1 | BoardRest], [B1 | TryRest], NumBull) :-
        !!,
        samePlace(BoardRest, TryRest, N1),
        +(N1, 1, NumBull).
        
samePlace([B1 | BoardRest], [T1 | TryRest], NumBull) :-
        samePlace(BoardRest, TryRest, NumBull).

%"
   trace ,
   samePlace([ 0 , 1 , 2 , 3 , 4 ],
             [ 0 , 2 , 3,  4,  5 ],
              N)     

   samePlace([ 0 , 1 , 3 , 3 , 4 ],
             [ 1 , 2 , 3,  4,  5 ],
              N)     

"%
!

%
% some information to the user 
%
showInfo(Info) :-
        send(instance, showInfo:, [Info]).

!

%
% inform user about a try

tryInfo(Try) :-
        write('my try is: '),
        writeln(Try),
        send(instance, tryMove:, [Try]).

! !

!MasterMind::MasterMindView methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    self redraw


! !

!MasterMind::MasterMindView methodsFor:'drawing'!

redraw
    |nCols tries answers x y w h spc spc2 xMax yMax|

    w := 20.
    h := 20.
    spc := 3.
    spc2 := 6.

    tries := model tries.
    answers := model answers.

    self viewBackground:Color black.
    self clear.

    tries size == 0 ifTrue:[^ self].
    nCols := tries first size.

    self paint:Color white.
    yMax := tries size * (h + spc2) - spc.
    1 to:nCols do:[:col | |xCol|
        xCol := col * (w + spc2) - spc.
        self displayLineFromX:xCol y:0 toX:xCol y:yMax.
    ].

    xMax := nCols * (w + spc2) - spc + 2.    
    1 to:answers size do:[:nr | |yRow|
        yRow := nr * (h + spc2) - spc2 + 1.
        self paint:(Color grey:50).
        self fillRectangle:((xMax @ (yRow-h-2)) 
                            corner:(width-1 @ (yRow + 1))).
    ].

    1 to:tries size do:[:line | |yRow|
        yRow := line * (h + spc2) - spc.
        self displayLineFromX:0 y:yRow toX:width y:yRow.
    ].

    y := 0.
    1 to:tries size do:[:nr |
        |try answer nC nB|

        try := tries at:nr.
        x := 0.
        try do:[:tryColorName |
            self paint:(Color perform:tryColorName asSymbol).
            self fillCircleIn:( (x@y) extent:(w@h) ).
            x := x + w + spc2.
        ].

        x := x + w.
        y := y + ((h - 10) // 2).
        answers notNil ifTrue:[
            answer := answers at:nr ifAbsent:nil.
            answer notNil ifTrue:[
                nC := answer first.
                nB := answer second.
                1 to:nB do:[:nr |
                    "/ draw bulls black
                    self paint:Color black.
                    self fillCircleIn:( (x @ y) extent:(10 @ 10) ).
                    self paint:Color white.
                    self displayCircleIn:( (x @ y) extent:(10 @ 10) ).
                    x := x + 10 + spc2.
                ].
                1 to:nC do:[:nr |
                    "/ draw cows white
                    self paint:Color white.
                    self fillCircleIn:( (x @ y) extent:(10 @ 10) ).
                    self paint:Color black.
                    self displayCircleIn:( (x @ y) extent:(10 @ 10) ).
                    x := x + 10 + spc2.
                ].
                (nB+nC+1) to:nCols do:[:nr |
                    self paint:(Color grey:50).
                    self fillCircleIn:( (x @ y) extent:(10 @ 10) ).
                    self paint:(Color white).
                    self displayCircleIn:( (x @ y) extent:(10 @ 10) ).
                    x := x + 10 + spc2.
                ].
            ]
        ].
        y := y - ((h - 10) // 2).

        y := y + h + spc2.
    ].







! !

!MasterMind class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/MasterMind.st,v 1.10 2002/11/26 18:31:19 cg Exp $'
! !
