"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologClass subclass:#MuTheoremProver
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog-Examples'
!

!MuTheoremProver class methodsFor:'documentation'!

documentation
"
    mu

    derived from Douglas R. Hofstadter, 'Godel, Escher, Bach,' pages 33-35.

    proves that miuiiu is a 'mu-math' theorem.

    invoke it with:
	MuTheoremProver new mu
"
! !

!MuTheoremProver methodsFor:'prolog-clauses'!

% generated: 9 November 1989
% option(s): 
%
%   mu
%
%   derived from Douglas R. Hofstadter, "Godel, Escher, Bach," pages 33-35.
%
%   prove "mu-math" theorem muiiu

mu :- theorem([m,u,i,i,u], 5, X), !!.

%" 

 can we make mu (in 10 moves)
	theorem([m,u], 10, X)   

 ca we make muiiu (in 5 moves)
	theorem([m,u,i,i,u], 5, X)   


MessageTally spyOn:[
self new query:'theorem([m,u], 8, X)'   
]



"% 

!

rule(1, S, R) :- rule1(S, R).
rule(2, S, R) :- rule2(S, R).
rule(3, S, R) :- rule3(S, R).
rule(4, S, R) :- rule4(S, R).



!

rule1([i], [i,u]).
rule1([H|X], [H|Y]) :-
    rule1(X, Y).


!

rule2([m|X], [m|Y]) :- 
    append(X, X, Y).

!

rule3([i,i,i|X], [u|X]).
rule3([H|X], [H|Y]) :-
    rule3(X, Y).
!

rule4([u,u|X], X).
rule4([H|X], [H|Y]) :-
    rule4(X, Y).


!

theorem([m,i], X, [[a|[m,i]]]).
theorem(R, Depth, [[N|R]|P]) :-
    >(Depth , 0),
    -(Depth , 1, D),
    theorem(S, D, P),
    rule(N, S, R).





!

xappend([], X, X).
xappend([A|B], X, [A|B1]) :-
    xappend(B, X, B1).




! !

!MuTheoremProver class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/MuTheoremProver.st,v 1.3 2002/11/26 18:31:37 cg Exp $'
! !
