"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologList subclass:#PrologBody
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologBody comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologBody class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologBody class methodsFor:'instance creation'!

fromList: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^aPrologDotPair].
	^super new fromList: aPrologDotPair
!

fromReverseList: aPrologDotPair 
	aPrologDotPair consp ifFalse: [^aPrologDotPair].
	^super new fromReverseList: aPrologDotPair
!

structure: aPrologStructure next: link 
	^super new structure: aPrologStructure next: link
! !

!PrologBody methodsFor:'printing'!

prettyPrintPrologOn: aStream 
	| list |
	list := self.
	aStream cr; tab.
	[list cdr consp]
		whileTrue: 
			[list ~~ self
				ifTrue: 
					[aStream nextPutAll: ', '.
					aStream cr; tab].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self
		ifTrue: 
			[aStream nextPutAll: ', '.
			aStream cr; tab].
	list car printPrologOn: aStream
!

printPrologOn: aStream 
	| list |
	list := self.
	[list cdr consp]
		whileTrue: 
			[list ~~ self ifTrue: [aStream nextPutAll: ', '].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self ifTrue: [aStream nextPutAll: ', '].
	list car printPrologOn: aStream
!

printPrologOn: aStream level: anInteger
	self printPrologOn: aStream
! !

!PrologBody methodsFor:'private'!

fromList: aPrologDotPair 
	^self fromReverseList: aPrologDotPair reverse
!

fromReverseList: aPrologDotPair 
	| list body mark |
	list := aPrologDotPair.
	body := nil.
	[list consp]
		whileTrue: 
			[body == nil
				ifTrue: [body := mark := self class structure: list car next: body]
				ifFalse: [body := self class structure: list car next: body].
			list := list cdr].
	mark cdr: list.
	^body
!

structure: aPrologStructure next: link 
	carPart := aPrologStructure.
	cdrPart := link
! !

!PrologBody class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologBody.st,v 1.4 2002/11/22 20:06:56 cg Exp $'
! !
