"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

Array variableSubclass:#PrologCharMap
	instanceVariableNames:''
	classVariableNames:'SymbolMap VariableMap'
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologCharMap comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologCharMap class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologCharMap class methodsFor:'class initialization'!

initialize
	"PrologCharMap initialize"

	self initializeSymbolMap.
	self initializeVariableMap
!

initializeSymbolMap
	| newMap |
	newMap := self new: 256 withAll: false.
	newMap atAll: ($0 asInteger to: $9 asInteger)
		put: true.
	newMap atAll: ($A asInteger to: $Z asInteger)
		put: true.
	newMap atAll: ($a asInteger to: $z asInteger)
		put: true.
	128 to: 256 do: [:i | newMap at: i put: true].
	#($+ $- $!! $: $* $/ $\ $> $< $= $_) do: [:each | newMap at: each asInteger put: true].
	SymbolMap := newMap
!

initializeVariableMap
	| newMap |
	newMap := self new: 256 withAll: false.
	newMap atAll: ($0 asInteger to: $9 asInteger)
		put: true.
	newMap atAll: ($A asInteger to: $Z asInteger)
		put: true.
	newMap atAll: ($a asInteger to: $z asInteger)
		put: true.
	newMap at: $~ asInteger put: true.
	VariableMap := newMap
! !

!PrologCharMap class methodsFor:'table access'!

symbolMap
	^SymbolMap
!

variableMap
	^VariableMap
! !

!PrologCharMap methodsFor:'accessing'!

at: index 
	(index isInteger and: [index between: 257 and: 65536])
		ifTrue: [(index - 1) asCharacter isLetter
				ifTrue: [^true]
				ifFalse: [^false]].
	index = 0 ifTrue: [^false].
	^super at: index
! !

!PrologCharMap class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologCharMap.st,v 1.4 2002/11/22 20:06:28 cg Exp $'
! !

PrologCharMap initialize!
