"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologList subclass:#PrologClause
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologClause comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologClause class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologClause class methodsFor:'instance creation'!

head: aPrologStructure body: aPrologBody 
	^super new head: aPrologStructure body: aPrologBody
! !

!PrologClause methodsFor:'accessing'!

body
	^cdrPart
!

body: aPrologBody 
	cdrPart := aPrologBody
!

head
	^carPart
!

head: aPrologStructure 
	carPart := aPrologStructure
! !

!PrologClause methodsFor:'printing'!

prettyPrintPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	head printPrologOn: aStream.
	body ~~ nil
		ifTrue: 
			[aStream nextPutAll: ' :- '.
			body prettyPrintPrologOn: aStream].
	aStream nextPut: $.
!

prettyPrintPrologString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self prettyPrintPrologOn: aStream.
	^aStream contents
!

printPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	aStream nextPut: $(.
	head printPrologOn: aStream.
	body == nil
		ifFalse: 
			[aStream nextPutAll: ', '.
			body printPrologOn: aStream].
	aStream nextPut: $)
!

printPrologOn: aStream level: anInteger
	self printPrologOn: aStream
!

questionPrintPrologOn: aStream 
	| head body |
	head := self head.
	body := self body.
	aStream nextPutAll: '?- '.
	head printPrologOn: aStream.
	body ~~ nil
		ifTrue: 
			[aStream nextPutAll: ', '.
			body printPrologOn: aStream].
	aStream nextPut: $.
! !

!PrologClause methodsFor:'private'!

head: aPrologStructure body: aPrologBody 
	self head: aPrologStructure.
	self body: aPrologBody
! !

!PrologClause class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologClause.st,v 1.4 2002/11/22 20:06:14 cg Exp $'
! !
