"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

Method variableSubclass:#PrologMethod
	instanceVariableNames:'isClause isFact'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog-ClassWrapper'
!


!PrologMethod class methodsFor:'initialization'!

postAutoload
    super postAutoload.

    "/ must avoid a noByteCode cycle ...
    self methodDictionary keysAndValuesDo:[:sel :mthd |
        mthd makeRealMethod
    ]


! !

!PrologMethod methodsFor:'invocation'!

noByteCode
    "arrive here, if a prolog clause is invoked as a method.
     see if there is a 0-arity clause named alike,
     and return its result if so."

    |sender inst selector args|

    sender := thisContext sender.
    selector := sender selector.

    inst := sender receiver.
    args := sender args.

    selector numArgs == 0 ifTrue:[
        ^ inst queryValue:selector.
    ].
    selector numArgs == 1 ifTrue:[
        ^ inst queryValue:(selector copyWithoutLast:1) , '(' , (args at:1) printString , ')'
    ].

    self error:'Cannot invoke clause'.
    ^ inst

"
    SendMoneyPuzzle new puzzle
    SendMoneyPuzzle new digit:0
    SendMoneyPuzzle new digit:#a
    SendMoneyPuzzle new digit:#A
"
! !

!PrologMethod methodsFor:'queries'!

isClause
    ^ isClause ? false
!

isClause:aBoolean
    isClause := aBoolean
!

isFact
    ^ isFact ? false
!

isFact:aBoolean
    isFact := aBoolean
!

isUnloaded
    ^ false
! !

!PrologMethod class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologMethod.st,v 1.9 2002/11/26 18:31:39 cg Exp $'
! !
