"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologEntity subclass:#PrologObject
	instanceVariableNames:'source object'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologObject comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologObject class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologObject class methodsFor:'instance creation'!

readFrom: aStream 
	| buffer char |
	buffer := WriteStream on: (String new: 20).
        
	[char := aStream next.
	char = $}]
		whileFalse: 
			[char == nil ifTrue: [NotifierView
					openContext: thisContext
					label: 'Syntax error near ${ unmatched $}\-- end of file --' withCRs
					proceedable: false].
			buffer nextPut: char].
	^buffer contents
!

source: aString object: anObject 
	^super new source: aString object: anObject
! !

!PrologObject methodsFor:'accessing'!

object
	^object
!

object: anObject
	object := anObject
!

source
	^source
!

source: aString
	source := aString
! !

!PrologObject methodsFor:'printing'!

printOn: aStream 
	aStream nextPutAll: self class printString.
	aStream nextPutAll: '('.
	aStream nextPutAll: self object printString.
	aStream nextPutAll: ')'
!

printPrologOn: aStream 
	aStream nextPut: ${.
	aStream nextPutAll: self source.
	aStream nextPut: $}
!

printPrologOn: aStream level: anInteger
	self printPrologOn: aStream
! !

!PrologObject methodsFor:'private'!

source: aString object: anObject 
	self source: aString.
	self object: anObject
! !

!PrologObject methodsFor:'testing'!

= anObject 
	anObject class = self class ifFalse: [^false].
	^self object = anObject object
! !

!PrologObject class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologObject.st,v 1.4 2002/11/22 20:06:40 cg Exp $'
! !
