"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

Array variableSubclass:#PrologScannerTable
	instanceVariableNames:''
	classVariableNames:'ScanningTable'
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologScannerTable comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologScannerTable class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologScannerTable class methodsFor:'class initialization'!

initialize
        "PrologScannerTable initialize."

        | newTable |
        newTable := self new: 256 withAll: #xBinary.
        newTable atAll: #(9 10 12 13 32 ) put: #xDelimiter.
        newTable atAll: ($0 asInteger to: $9 asInteger) put: #xDigit.
        newTable atAll: ($A asInteger to: $Z asInteger) put: #xVariable.
        newTable at: $~ asInteger put: #xVariable.
        newTable atAll: ($a asInteger to: $z asInteger) put: #xSymbol.
        128 to: 256 do: [:i | newTable at: i put: #xSymbol].
        #($!! $: $* $/ $\ $> $< $= $_ $^) do: [:each | newTable at: each asInteger put: #xSymbol].
"/        newTable at: $^ asInteger put: #eof.
        newTable at: $" asInteger put: #xDoubleQuote.
        newTable at: $$ asInteger put: #xDollar.
        newTable at: $' asInteger put: #xSingleQuote.
        newTable at: $( asInteger put: #leftParenthesis.
        newTable at: $) asInteger put: #rightParenthesis.
        newTable at: $. asInteger put: #period.
        newTable at: $: asInteger put: #xColon.
        newTable at: $? asInteger put: #xColon.
        newTable at: $; asInteger put: #semicolon.
        newTable at: $[ asInteger put: #leftBracket.
        newTable at: $] asInteger put: #rightBracket.
        newTable at: ${ asInteger put: #leftBrace.
        newTable at: $} asInteger put: #rightBrace.
        newTable at: $, asInteger put: #comma.
        newTable at: $| asInteger put: #verticalBar.
        newTable at: $+ asInteger put: #xSign.
        newTable at: $- asInteger put: #xSign.
        newTable at: $% asInteger put: #xComment.
        ScanningTable := newTable
! !

!PrologScannerTable class methodsFor:'table access'!

scannerTable
	^ScanningTable
! !

!PrologScannerTable methodsFor:'accessing'!

at: index 
	(index isInteger and: [index between: 257 and: 65536])
		ifTrue: [(index - 1) asCharacter isLetter
				ifTrue: [^#xSymbol]
				ifFalse: [^#xBinary]].
	index = 0 ifTrue: [^#xDelimiter].
	^super at: index
! !

!PrologScannerTable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologScannerTable.st,v 1.5 2002/11/22 20:06:12 cg Exp $'
! !

PrologScannerTable initialize!
