"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologEntity subclass:#PrologString
	instanceVariableNames:'string'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologString comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologString class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologString class methodsFor:'instance creation'!

fromString: aString 
	^super new string: aString
!

readFrom: aStream 
	| buffer char string |
	buffer := WriteStream on: (String new: 20).
	char := aStream next.
	char = $" ifTrue: [
		[char := aStream peek.
		char ~~ nil]
			whileTrue: 
				[char = $"
					ifTrue: 
						[aStream next.
						char := aStream peek.
						char = $" ifFalse: [^self fromString: buffer contents]].
				buffer nextPut: aStream next]].
	string := aStream upToEnd.
	string size > 100 ifTrue: [string := string copyFrom: 1 to: 100].
	NotifierView
		openContext: thisContext
		label: 'Syntax error near $" unmatched $"\' withCRs , (string = ''
					ifTrue: ['-- end of file --']
					ifFalse: ['--> ' , string])
		proceedable: false
! !

!PrologString methodsFor:'accessing'!

at: index
	^string at: index
!

at: index put: char
	^string at: index put: char
!

size
	^string size
!

string
	^string
!

string: aString
	string := aString
! !

!PrologString methodsFor:'comparing'!

< aPrologString 
	^self string < aPrologString string
!

<= aPrologString 
	^self string <= aPrologString string
!

> aPrologString 
	^self string > aPrologString string
!

>= aPrologString 
	^self string >= aPrologString string
!

hash
	^self asString hash
! !

!PrologString methodsFor:'converting'!

asString
	^self string
! !

!PrologString methodsFor:'enumerating'!

do: aBlock
	^self asString do: aBlock
! !

!PrologString methodsFor:'printing'!

printOn: aStream 
        aStream nextPutAll: self class name printString.
        aStream nextPutAll: '('.
        aStream nextPutAll: self asString.
        aStream nextPutAll: ')'
!

printPrologOn: aStream 
	| i length x |
	aStream nextPut: $".
	i := 0.
	length := string size.
	[(i := i + 1) <= length]
		whileTrue: 
			[aStream nextPut: (x := string at: i).
			x == $" ifTrue: [aStream nextPut: x]].
	aStream nextPut: $"
!

printPrologOn: aStream level: anInteger 
	self printPrologOn: aStream
! !

!PrologString methodsFor:'testing'!

= anObject 
        anObject class == self class ifFalse: [^false].
        ^self string = anObject string
! !

!PrologString class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologString.st,v 1.5 2002/11/22 20:06:32 cg Exp $'
! !
