"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologList subclass:#PrologStructure
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologStructure comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologStructure class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologStructure class methodsFor:'instance creation'!

functor: aPrologSymbol terms: aPrologTerms 
	^super new functor: aPrologSymbol terms: aPrologTerms
! !

!PrologStructure methodsFor:'accessing'!

arity
	^self terms length
!

functor
	^carPart
!

functor: aPrologSymbol 
	carPart := aPrologSymbol
!

nthTerm: anInteger 
	^cdrPart nth: anInteger
!

terms
	^cdrPart
!

terms: aPrologTerms 
	cdrPart := aPrologTerms
! !

!PrologStructure methodsFor:'functions'!

structureList
	"disassemble prolog structure of myself into a list."
	^(self functor) cons: self terms asPrologList
! !

!PrologStructure methodsFor:'printing'!

printPrologOn: aStream 
	| functor terms |
	functor := self functor.
	terms := self terms.
	functor printPrologOn: aStream.
	terms == nil
		ifFalse:
			[(terms consp)
				ifTrue: [terms printPrologOn: aStream]
				ifFalse:
					[aStream nextPutAll: '(|'.
					terms printPrologOn: aStream.
					aStream nextPut: $)]]
!

printPrologOn: aStream level: anInteger
	self printPrologOn: aStream
! !

!PrologStructure methodsFor:'private'!

functor: aPrologSymbol terms: aPrologTerms 
	self functor: aPrologSymbol.
	self terms: aPrologTerms
! !

!PrologStructure class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologStructure.st,v 1.4 2002/11/22 20:06:20 cg Exp $'
! !
