"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologList subclass:#PrologTerms
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologTerms comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologTerms class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologTerms class methodsFor:'instance creation'!

fromList: aPrologDotPair 
	^super new fromList: aPrologDotPair
!

fromReverseList: aPrologDotPair 
	^super new fromReverseList: aPrologDotPair
!

term: term next: link 
	^super new term: term next: link
! !

!PrologTerms methodsFor:'printing'!

printPrologOn: aStream 
	| list |
	aStream nextPut: $(.
	list := self.
	[list cdr consp]
		whileTrue: 
			[list ~~ self ifTrue: [aStream nextPut: $,].
			list car printPrologOn: aStream.
			list := list cdr].
	list ~~ self ifTrue: [aStream nextPut: $,].
	list car printPrologOn: aStream.
	list cdr isNil
		ifTrue: [aStream nextPut: $)]
		ifFalse:
			[aStream nextPut: $|.
			list cdr printPrologOn: aStream.
			aStream nextPut: $)]
!

printPrologOn: aStream level: anInteger
	self printPrologOn: aStream
! !

!PrologTerms methodsFor:'private'!

fromList: aPrologDotPair 
	^self fromReverseList: aPrologDotPair reverse
!

fromReverseList: aPrologDotPair 
	| list terms mark |
	list := aPrologDotPair.
	terms := nil.
	[list consp]
		whileTrue: 
			[terms == nil
				ifTrue: [terms := mark := self class term: list car next: terms]
				ifFalse: [terms := self class term: list car next: terms].
			list := list cdr].
	mark cdr: list.
	^terms
!

term: anObject next: link 
	carPart := anObject.
	cdrPart := link
! !

!PrologTerms class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologTerms.st,v 1.4 2002/11/22 20:06:50 cg Exp $'
! !
