"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologString subclass:#PrologVariable
	instanceVariableNames:''
	classVariableNames:'PrologVariableCounter PrologVariableTable'
	poolDictionaries:''
	category:'Languages-Prolog'
!

PrologVariable comment:'

Prolog
Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
Copyright (C) 1995-1997 AOKI Atsushi
1997/02/21

'
!

!PrologVariable class methodsFor:'documentation'!

documentation
"
    Prolog
    Goodies for VisualWorks 2.5/2.5J and VisualWave 1.0
    (and ST/X)

    Copyright (C) 1995-1997 AOKI Atsushi
    1997/02/21


    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"


! !

!PrologVariable class methodsFor:'instance creation'!

install: aString 
	| variable key |
	variable := PrologVariableTable at: aString ifAbsent: [nil].
	variable == nil
		ifTrue: 
			[key := aString.
			variable := self fromString: aString.
			PrologVariableTable at: key put: variable].
	^variable
!

readFrom: aStream 
	| map buffer char |
	map := PrologCharMap variableMap.
	buffer := WriteStream on: (String new: 20).
	char := aStream peek.
	(char ~~ nil and: [char = $~])
		ifTrue: 
			[aStream next.
			self countUp.
			^self install: '~' , PrologVariableCounter printString].
	[char ~~ nil and: [map at: char asInteger]]
		whileTrue: 
			[buffer nextPut: aStream next.
			char := aStream peek].
	^self install: buffer contents
! !

!PrologVariable class methodsFor:'class initialization'!

initialize
	"PrologVariable initialize"

	self setZero.
	PrologVariableTable := Dictionary new
! !

!PrologVariable class methodsFor:'private'!

countUp
	PrologVariableCounter := PrologVariableCounter + 1
!

setZero
	PrologVariableCounter := 0
! !

!PrologVariable methodsFor:'printing'!

printPrologOn: aStream 
	(self asString at: 1)
		= $~
		ifTrue: [aStream nextPut: $~]
		ifFalse: [aStream nextPutAll: self asString]
!

printPrologOn: aStream level: anInteger
	self printPrologOn: aStream
! !

!PrologVariable methodsFor:'testing'!

isPrologVariable
	^true
! !

!PrologVariable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/PrologVariable.st,v 1.4 2002/11/22 20:06:52 cg Exp $'
! !

PrologVariable initialize!
