"
    Copyright (C) 1995-1997 AOKI Atsushi
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"

"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

Object subclass:#Prolog_ReadMe
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'_README'
!

!Prolog_ReadMe class methodsFor:'documentation'!

copyright
"
    Copyright (C) 1995-1997 AOKI Atsushi
    Software Research Associates, Inc.
    1113 Spruce Street, Suite 502
    Boulder, Colorado 80302 the U.S.A.
    TEL: +1-303-440-3582
    FAX: +1-303-440-3930
"
!

documentation
"
    The classes in the Prolog nameSpace contain
    an (incomplete) adaption of a PD prolog interpreter to ST/X 
    (originally for VW2.5).

    The raw prolog interpreter:

    [start with:]
        Prolog::PrologInterpreter open  
        Prolog::PrologInterpreter example01  
        Prolog::PrologInterpreter example02  
        Prolog::PrologInterpreter example03
        Prolog::PrologInterpreter example04  
        Prolog::PrologInterpreter example05 
        Prolog::PrologInterpreter example06 
        Prolog::PrologInterpreter example07 


    Prolog::PrologInterpreter open 
        opens a two-pane view; the top allows entering of prolog
        statements, the bottom view is the prolog console.
        (i.e. facts as:

                likes(claus,smalltalk).
                likes(stefan,smalltalk).

                likes(pierre, objectOrientedProgramming).

                likes(X,smalltalk) :- likes(X, objectOrientedProgramming).

         We may argue about the last one ;-)
         (everyone who likes OOP should like ST)

         then select and doIt to add the facts.
         Enter a query ('who likes smalltalk') as:
                ?- likes(X, smalltalk).
         then select it and doIt.
         See the results coming on the lower view.
         (you will be asked if more answers are wanted via a confirmation
          dialog; answer yes if you are happy with the answer(s);
          answer no, if you like to see more query results.
        )

    examples:
        output their query-results onto the Transcript,
        and ask for more results via a confirmation dialog.


    These classes are NOT covered by the ST/X copyright.
    These are additional goody classes; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.


   The smalltalk integration:
        I have added a class-wrapper, which allows prolog clauses to be
        treated like regular methods (and edited/accepted as usual in the browsers).
        This allows for a neat intgration of logic into a smalltalk framework.
        A concrete example is found in the TowersOfHanoi example.

        Be aware, that the prolog interpreter is neither high-quality, nor high-performant.
        For heavy logic applications, a tuned interpreter (written in C, and adapted
        to ST's object memory manager) should be integrated and replace the one used.
"
! !

!Prolog_ReadMe class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/Prolog_ReadMe.st,v 1.6 2000/05/12 13:30:49 cg Exp $'
! !
