"{ Package: 'stx:goodies/prolog' }"

"{ NameSpace: Prolog }"

PrologClass subclass:#SendMoneyPuzzle
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Prolog-Examples'
!

!SendMoneyPuzzle class methodsFor:'documentation'!

documentation
"
    This program solves the puzzle:

          SEND
         +MORE
         -----
         MONEY

    where each letter is a distinct digit.

    to solve:
        SendMoneyPuzzle new puzzle

    or go to the puzzle clause,
    and evaluate 'puzzle'.

    Notice: takes some time to solve the puzzle.
"


! !

!SendMoneyPuzzle methodsFor:'prolog-clauses'!

digit(0).
digit(1).
digit(2).
digit(3).
digit(4).
digit(5).
digit(6).
digit(7).
digit(8).
digit(9).

!

notZero(1).
notZero(2).
notZero(3).
notZero(4).
notZero(5).
notZero(6).
notZero(7).
notZero(8).
notZero(9).

!

% Find the unique answer to:
%  SEND
% +MORE
% -----
% MONEY
% where each letter is a distinct digit.

puzzle(M,O,N,E,Y,S,D,R) :-
        digit(D), digit(E), \=(D, E),
        sumup(D, E, 0, Y, CarryDE),
        digit(N), \=(N, D), \=(N, E), \=(N, Y),
        digit(R), \=(R, N), \=(R, D), \=(R, E), \=(R, Y),
        sumup(N, R, CarryDE, E, CarryNR),
        digit(O), \=(O, N), \=(O, R), \=(O, D), \=(O, E), \=(O, Y),
        sumup(E, O, CarryNR, N, CarryEO),
        notZero(S), \=(S, O), \=(S, N), \=(S, R), \=(S, D), \=(S, E), \=(S, Y),
        notZero(M), \=(M, S), \=(M, O), \=(M, N), \=(M, R), \=(M, D), \=(M, E), \=(M, Y),
        sumup(S, M, CarryEO, O, M).

puzzle :-
        puzzle(M,O,N,E,Y,S,D,R),
        write(' '),write(S),write(E),write(N),write(D),nl,
        write('+'),write(M),write(O),write(R),write(E),nl,
        write('-----'),nl,
        write(M),write(O),write(N),write(E),write(Y),nl,nl.
        
%"
 puzzle

 puzzle(M,O,N,E,Y,S,D,R) 

 MessageTally spyOn:[
   self new puzzle   
 ]



"%
!

%
% add two digits and carryIn, to compute sum-digit and carryOut
%
sumup(In1, In2, CarryIn, Out, CarryOut) :-
        digit(In1), digit(In2), zeroOrOne(CarryIn),
        digit(Out), zeroOrOne(CarryOut),
        +(In1, In2, Sum1),
        +(Sum1, CarryIn, Sum),
        \\(Sum, 10, Out),
        //(Sum, 10, CarryOut).

%"

 sumup(1, 1, 0, O, C)  
 sumup(1, 9, 0, O, C)  
 sumup(1, 9, 1, O, C)  
 sumup(A, B, 0, 8, 1)  
 sumup(A, B, 0, 6, 1)    
 sumup(A, B, C, 6, 1)    

"%





!

zeroOrOne(0).
zeroOrOne(1).
! !

!SendMoneyPuzzle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/prolog/SendMoneyPuzzle.st,v 1.3 2002/11/26 18:31:25 cg Exp $'
! !
