"{ Package: 'stx:goodies/rST' }"

Object subclass:#RSTObjectTransporter
	instanceVariableNames:'type object resolved'
	classVariableNames:''
	poolDictionaries:''
	category:'rST-Core'
!


!RSTObjectTransporter class methodsFor:'instance creation'!

copy: anObject 
	"creates a Transporter for a copy of anObject "
	^ self new initializeObject: anObject type: #copy
!

exception: anException 
	"creates a Transporter for anException "
	^ self new initializeObject: anException type: #exception
!

reference: aRemoteObjectID 
	"creates a Transporter for a reference to aRemoteObjectID"
	^ self new initializeObject: aRemoteObjectID type: #reference
! !

!RSTObjectTransporter methodsFor:'accessing'!

resolve
	"resolve the transported object for local use"
	^ type caseOf: {
		[#reference] -> [object asLocalObject].
		[#copy] -> [object].
		[#exception] -> [object signal]}
! !

!RSTObjectTransporter methodsFor:'initialization'!

initializeObject: anObject type: aSymbol
	object := anObject.
	type := aSymbol
! !

!RSTObjectTransporter methodsFor:'printing'!

printOn: aStream 
	"super printOn: aStream."
	aStream 
		"nextPutAll: ' ';"
		nextPutAll: type asString;
		nextPutAll: ' = ''';
		nextPutAll: object asString;
		nextPut: $'
! !

!RSTObjectTransporter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/rST/RSTObjectTransporter.st,v 1.1 2011/12/28 22:58:52 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/rST/RSTObjectTransporter.st,v 1.1 2011/12/28 22:58:52 cg Exp $'
! !
