"{ Package: 'stx:goodies/rST' }"

Message subclass:#RSTRemoteMessage
	instanceVariableNames:'to'
	classVariableNames:''
	poolDictionaries:''
	category:'rST-Core'
!


!RSTRemoteMessage class methodsFor:'instance creation'!

message: aMessage to: aRemoteObjectId using: aBroker 
	"creates an remote message but first wrap all parameters in transporters"
	| transportableArguments |
	transportableArguments := aMessage arguments
				collect: [:each | aBroker transporterFor: each].
	^ (self selector: aMessage selector arguments: transportableArguments)
		initializeTo: aRemoteObjectId
! !

!RSTRemoteMessage methodsFor:'accessing'!

to
	^to
! !

!RSTRemoteMessage methodsFor:'executing'!

executeIn: aBroker 
	"execute in a Broker context"
	^ aBroker processRemoteMessage: self
! !

!RSTRemoteMessage methodsFor:'initialization'!

initializeTo: aRemoteObjectId
	to := aRemoteObjectId.
! !

!RSTRemoteMessage methodsFor:'printing'!

printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' to: ';
		 nextPutAll: to asString
! !

!RSTRemoteMessage class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/rST/RSTRemoteMessage.st,v 1.1 2011/12/28 22:59:17 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/rST/RSTRemoteMessage.st,v 1.1 2011/12/28 22:59:17 cg Exp $'
! !
