"{ Package: 'stx:goodies/rST/samples' }"

Object subclass:#RSTPersonViewController
	instanceVariableNames:'person model lastName lastEMail'
	classVariableNames:''
	poolDictionaries:''
	category:'rST-Samples'
!


!RSTPersonViewController class methodsFor:'instance creation'!

on: aPerson 
	^ self new initializeOn: aPerson 
! !

!RSTPersonViewController methodsFor:'accessing'!

model
	^ model
!

model: anObject 
	"Set my model and make me me a dependent of the given object."
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject
! !

!RSTPersonViewController methodsFor:'initialization'!

initializeOn: aPerson 
	person := aPerson.
! !

!RSTPersonViewController methodsFor:'testing'!

test
	| testName testEMail ok |
	ok := true.
	self model: person.
	""
	testName := 'Diego Gomez Deck'.
	person name: testName.
	lastName = testName
		ifFalse: [""
			Transcript show: '*** INVALID LAST NAME ***';
				 cr.
			ok := false].
	""
	testEMail := 'DiegoGomezDeck@ConsultAr.com'.
	person eMail: testEMail.
	lastEMail = testEMail
		ifFalse: [""
			Transcript show: '*** INVALID LAST EMAIL ***';
				 cr.
			ok := false].
	""
	self model: nil.
	^ ok
! !

!RSTPersonViewController methodsFor:'updating'!

update: anEvent 
	anEvent = #name
		ifTrue: [lastName := self model name].
	anEvent = #eMail
		ifTrue: [lastEMail := self model eMail]
! !

!RSTPersonViewController class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/rST/samples/RSTPersonViewController.st,v 1.1 2011/12/28 23:03:51 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/rST/samples/RSTPersonViewController.st,v 1.1 2011/12/28 23:03:51 cg Exp $'
! !
