#!/bin/sh
#
# shell script to open a smalltalk editor on a file.
# requires that ST/X is already running,
# AND that the RDoItServer process is started
# (within ST/X).
#
# copy this to a private bin directory (in the path),
# rename it to 'edit'.
# Then, open an editor with: "edit <fileName>".
# It may also be useful, to add a corresponding
# entry to your windowManagers menu-rc file. 

if [ "$1" = "" ]; then
    echo "Usage: edit fileName"
    exit 1
fi

case $1 in
    /*)
	fn=$1;
	;;

    '')
	fn='unnamed'
	;;

    *)
	fn=`pwd`/$1
	;;
esac
rdoit -w -q "(EditTextView openOn:'"$fn"') topView waitUntilClosed"
# if [ $? != 0 ]
# then
#     echo "RDoIt execution not possible."
# fi
