"{ Package: 'stx:goodies/rdoit' }"

LibraryDefinition subclass:#stx_goodies_rdoit
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_rdoit class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:libbasic'    "LibraryDefinition - superclass of stx_goodies_rdoit "
        #'stx:libbasic2'    "ActorStream - referenced by RDoItServer>>handleStxRunClient:display:on:onError: "
        #'stx:libview'    "XWorkstation - referenced by RDoItServer>>handleStxRunClient:display:on:onError: "
        #'stx:libwidg'    "OptionBox - referenced by RDoItServer class>>confirmNewHost: "
    )
! !

!stx_goodies_rdoit class methodsFor:'description - compilation'!

additionalDefinitions_bc_dot_mak
    ^ '
# see stdHeader_bc for GOODIES_RDOIT_BASE
LIB_BASE_LD_ARG=-b:$(GOODIES_RDOIT_BASE)
'
!

additionalRules_bc_dot_mak
    ^ '
stscript: rdoit.obj
        ren rdoit.obj stscript.obj
        $(CC) stscript.obj

rdoit: rdoit.exe

rdoit.exe: rdoit.obj
        $(CC) rdoit.obj

rdoit.obj: rdoit.c
        $(CC) $(CFLAGS) -DWIN32 rdoit.c

clean::
        @del rdoit.obj

clobber::
        @del rdoit.obj rdoit.exe stscript.exe
'
!

additionalRules_make_dot_proto
    ^ '
stscript: rdoit
        $(LNS) rdoit stscript

rdoit:  rdoit.o
        $(CC) $(LDFLAGS) -o rdoit rdoit.o $(OTHERLIBS)

rdoit.o: rdoit.c
        $(CC) $(CFLAGS) $(CCCONFOPT) -c rdoit.c

clean::
        @rm -f rdoit.o

clobber::
        @rm -f rdoit.o rdoit stscript
'
!

additionalTargets_make_dot_proto
    ^ 'rdoit stscript'
! !

!stx_goodies_rdoit class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        RDoItClient
        RDoItServer
        RDoitError
        #'stx_goodies_rdoit'
    )
!

extensionMethodNames
    ^ #(
    )
! !

!stx_goodies_rdoit class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X RDoit Server'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2009\nCopyright eXept Software AG 1998-2009'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_rdoit class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/rdoit/stx_goodies_rdoit.st,v 1.11 2009/09/29 17:12:44 cg Exp $'
! !
