"{ Package: 'stx:goodies/refactoryBrowser/browser' }"

SimpleDialog subclass:#BrowserDialog
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Browser'
!

BrowserDialog comment:''
!


!BrowserDialog class methodsFor:'images'!

downImage
        Smalltalk isSmalltalkX ifTrue:[
            ^ self downIcon mask:self downIconMask
        ] ifFalse:[
            ^OpaqueImageWithEnablement
                    figure: self downIcon
                    shape: self downIconMask
                    inactiveFigure: self disabledDownIcon
                    inactiveShape: self disabledDownIconMask
        ]

    "Modified: / 27-04-2010 / 15:59:40 / cg"
!

upImage
        Smalltalk isSmalltalkX ifTrue:[
            ^ self upIcon mask:self upIconMask
        ] ifFalse:[
            ^OpaqueImageWithEnablement
                figure: self upIcon
                shape: self upIconMask
                inactiveFigure: self disabledUpIcon
                inactiveShape: self disabledUpIconMask
        ]

    "Modified: / 27-04-2010 / 15:59:58 / cg"
! !

!BrowserDialog class methodsFor:'resources'!

disabledDownIcon
	"UIMaskEditor new openOnClass: self andSelector: #disabledDownIcon"

	<resource: #image>
	^CachedImage on: (Image extent: 24@13 depth: 1 bitsPerPixel: 1 palette: MonoMappedPalette blackWhite usingBits: #[0 0 0 0 0 0 1 0 128 0 3 0 192 0 7 0 224 0 15 0 240 0 31 0 248 0 63 0 252 0 127 0 254 0 255 0 255 1 255 0 255 131 255 0 255 199 255 0 255 239 255 0])
!

disabledDownIconMask
	"UIMaskEditor new openOnClass: self andSelector: #disabledDownIconMask"

	<resource: #image>
	^CachedImage on: (Image extent: 24@13 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[255 255 255 0 128 0 1 0 64 0 2 0 32 0 4 0 16 0 8 0 8 0 16 0 4 0 32 0 2 0 64 0 1 0 128 0 0 129 0 0 0 66 0 0 0 36 0 0 0 24 0 0])
!

disabledUpIcon
	"UIMaskEditor new openOnClass: self andSelector: #disabledUpIcon"

	<resource: #image>
	^CachedImage on: (Image extent: 24@13 depth: 1 bitsPerPixel: 1 palette: MonoMappedPalette whiteBlack usingBits: #[0 24 0 0 0 60 0 0 0 126 0 0 0 255 0 0 1 255 128 0 3 255 192 0 7 255 224 0 15 255 240 0 31 255 248 0 63 255 252 0 127 255 254 0 255 255 255 0 0 0 0 0])
!

disabledUpIconMask
	"UIMaskEditor new openOnClass: self andSelector: #disabledUpIconMask"

	<resource: #image>
	^CachedImage on: (Image extent: 24@13 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[0 24 0 0 0 36 0 0 0 66 0 0 0 129 0 0 1 0 128 0 2 0 64 0 4 0 32 0 8 0 16 0 16 0 8 0 32 0 4 0 64 0 2 0 128 0 1 0 255 255 255 0])
!

downIcon
	"UIMaskEditor new openOnClass: self andSelector: #downIcon"

	<resource: #image>
	^CachedImage on: (Image extent: 24@13 depth: 1 bitsPerPixel: 1 palette: MonoMappedPalette blackWhite usingBits: #[0 0 0 0 0 0 0 0 128 0 1 0 192 0 3 0 224 0 7 0 240 0 15 0 248 0 31 0 252 0 63 0 254 0 127 0 255 0 255 0 255 129 255 0 255 195 255 0 255 231 255 0])
!

downIconMask
	"UIMaskEditor new openOnClass: self andSelector: #downIconMask"

	<resource: #image>
	^CachedImage on: (Image extent: 24@13 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[255 255 255 0 255 255 255 0 127 255 254 0 63 255 252 0 31 255 248 0 15 255 240 0 7 255 224 0 3 255 192 0 1 255 128 0 0 255 0 0 0 126 0 0 0 60 0 0 0 24 0 0])
!

upIcon
	"UIMaskEditor new openOnClass: self andSelector: #upIcon"

	<resource: #image>
	^CachedImage on: (Image extent: 24@13 depth: 1 bitsPerPixel: 1 palette: MonoMappedPalette whiteBlack usingBits: #[0 24 0 0 0 60 0 0 0 126 0 0 0 255 0 0 1 255 128 0 3 255 192 0 7 255 224 0 15 255 240 0 31 255 248 0 63 255 252 0 127 255 254 0 255 255 255 0 255 255 255 0])
!

upIconMask
	"UIMaskEditor new openOnClass: self andSelector: #upIconMask"

	<resource: #image>
	^CachedImage on: (Image extent: 24@13 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[0 24 0 0 0 60 0 0 0 126 0 0 0 255 0 0 1 255 128 0 3 255 192 0 7 255 224 0 15 255 240 0 31 255 248 0 63 255 252 0 127 255 254 0 255 255 255 0 255 255 255 0])
! !

!BrowserDialog methodsFor:'widget properties'!

disable: aSymbol 
	| component |
	builder isNil ifTrue: [^self].
	component := builder componentAt: aSymbol.
	component notNil ifTrue: [component disable]
!

disableAll: aCollection
	aCollection do: [:each | self disable: each]
!

enable: aSymbol 
	| component |
	builder isNil ifTrue: [^self].
	component := builder componentAt: aSymbol.
	component notNil ifTrue: [component enable]
!

enableAll: aCollection
	aCollection do: [:each | self enable: each]
!

hide: aSymbol 
	| component |
	builder isNil ifTrue: [^self].
	component := builder componentAt: aSymbol.
	component notNil ifTrue: [component beInvisible]
!

hideAll: aCollection
	aCollection do: [:each | self hide: each]
!

show: aSymbol 
	| component |
	builder isNil ifTrue: [^self].
	component := builder componentAt: aSymbol.
	component notNil ifTrue: [component beVisible]
!

showAll: aCollection
	aCollection do: [:each | self show: each]
! !

!BrowserDialog class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/browser/BrowserDialog.st,v 1.11 2011/07/09 15:24:20 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/browser/BrowserDialog.st,v 1.11 2011/07/09 15:24:20 vrany Exp $'
!

version_SVN
    ^ 'Id'
! !
