"{ Package: 'stx:goodies/refactoryBrowser/browser' }"

BrowserEnvironmentWrapper subclass:#PackageEnvironment
	instanceVariableNames:'packageNames'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Environments'
!


!PackageEnvironment class methodsFor:'instance creation'!

onEnvironment: anEnvironment packageNames: aCollection
        ^ (self onEnvironment: anEnvironment) 
                packageNames: aCollection;
                yourself

    "Modified: / 16-03-2011 / 23:06:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!PackageEnvironment methodsFor:'accessing'!

asSelectorEnvironment
	| result |
	result := SelectorEnvironment onEnvironment: environment.
	self classesAndSelectorsDo: [ :class :selector | result addClass: class selector: selector ].
	^ result
!

classesAndSelectorsDo: aBlock

    environment classesAndSelectorsDo:
        [:cls :sel|
        (self includesSelector: sel in: cls) ifTrue:
            [aBlock value: sel value: cls]].

    "Modified: / 16-03-2011 / 23:20:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

classesDo: aBlock
        | enumerated enumerator |
        enumerated := IdentitySet new.
        enumerator := [ :each |
                (enumerated includes: each) ifFalse: [
                        (environment includesClass: each)
                                ifTrue: [ aBlock value: each ].
                        (environment includesClass: each class)         
                                ifTrue: [ aBlock value: each class ].
                        enumerated add: each ] ].
        environment classesDo:
            [:cls|
            (self includesClass: cls)
                ifTrue:[enumerator value: cls]].

    "Modified: / 16-03-2011 / 23:19:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

numberSelectors
    ^ packageNames inject:0
        into:[:result :package | result + package methods size ]

    "Modified: / 16-03-2011 / 23:06:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

packageNames
        ^ packageNames

    "Modified: / 16-03-2011 / 23:04:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

packageNames:something
    packageNames := something.
! !

!PackageEnvironment methodsFor:'copying'!

postCopy
	super postCopy.
	packageNames := packageNames copy
! !

!PackageEnvironment methodsFor:'initialize-release'!

initialize
	super initialize.
	packageNames := Set new
! !

!PackageEnvironment methodsFor:'printing'!

storeOn: aStream 
	aStream nextPut: $(; nextPutAll: self class name; nextPutAll: ' onEnvironment: '.
	environment storeOn: aStream.
	aStream nextPutAll: ' packageNames: '.
	self packageNames asArray storeOn: aStream.
	aStream nextPut: $)
! !

!PackageEnvironment methodsFor:'testing'!

definesClass: aClass
        ^ (super definesClass: aClass) and: 
                [ self packageNames includes: aClass package ]

    "Modified: / 16-03-2011 / 23:17:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

includesCategory:aCategory 
    ^ (super includesCategory:aCategory) and:
            [ self packageNames anySatisfy:
                [:package | 
                environment classes anySatisfy:
                    [:cls|cls category = aCategory]]].

    "Modified: / 16-03-2011 / 23:16:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

includesClass:aClass 
    ^ (super includesClass:aClass) and:
            [ self packageNames anySatisfy:
                    [:package | 
                    aClass package = package or:
                        [aClass methodDictionary values anySatisfy:
                            [:m|m package = package]]]].

    "Modified: / 07-10-2011 / 11:57:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

includesProtocol:aProtocol in:aClass 
    ^ (environment includesProtocol:aProtocol in:aClass) and:
            [environment classesAndSelectorsDo:
                [:cls :sel| | mthd |
                mthd := cls compiledMethodAt: sel.
                mthd category = aProtocol and:
                    [self packageNames includes: mthd package]]].

    "Modified: / 16-03-2011 / 23:13:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

includesSelector:aSelector in:aClass 
    ^ (environment includesSelector:aSelector in:aClass) and:
            [ self packageNames includes:
                (aClass compiledMethodAt: aSelector) package]

    "Modified: / 16-03-2011 / 23:33:56 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!PackageEnvironment class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/browser/PackageEnvironment.st,v 1.2 2011/10/07 12:24:02 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/browser/PackageEnvironment.st,v 1.2 2011/10/07 12:24:02 vrany Exp $'
!

version_SVN
    ^ 'Id: PackageEnvironment.st 151 2011-03-17 02:53:09Z vranyj1 '
! !
