"{ Package: 'stx:goodies/refactoryBrowser/browser' }"

BrowserEnvironmentWrapper subclass:#ProtocolEnvironment
	instanceVariableNames:'class protocols'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Environments'
!

ProtocolEnvironment comment:'ProtocolEnvironment represents a collection of protocols in a class to be browsed.

Instance Variables:
	class   <Behavior>      the class that contains the protocols
	protocols       <Collection of: Symbol> the protocols to be browsed'
!


!ProtocolEnvironment class methodsFor:'instance creation'!

onEnvironment: anEnvironment class: aClass protocols: aCollection
	^(self onEnvironment: anEnvironment)
		class: aClass protocols: aCollection; yourself
! !

!ProtocolEnvironment class methodsFor:'others'!

version_CVS
    ^ '$Id: ProtocolEnvironment.st,v 1.8 2011/07/09 15:40:35 vrany Exp $'
! !

!ProtocolEnvironment methodsFor:'accessing'!

navigatorClass
	^BrowserNavigator
! !

!ProtocolEnvironment methodsFor:'copying'!

postCopy
	protocols := protocols copy.
	^super postCopy
! !

!ProtocolEnvironment methodsFor:'initialize-release'!

class: aClass protocols: aCollection
	class := aClass.
	protocols := aCollection
! !

!ProtocolEnvironment methodsFor:'printing'!

storeOn: aStream 
	aStream nextPut: $(.
	super storeOn: aStream.
	aStream
		nextPutAll: ' class: ';
		nextPutAll: class name;
		nextPutAll: ' protocols: '.
	protocols asArray storeOn: aStream.
	aStream nextPut: $)
! !

!ProtocolEnvironment methodsFor:'private'!

defaultLabel
	| stream |
	stream := String new writeStream.
	stream nextPutAll: class name;
		nextPut: $>.
	protocols do: 
			[:each | 
			stream nextPutAll: each;
				nextPut: $ ].
	^stream contents
! !

!ProtocolEnvironment methodsFor:'testing'!

includesCategory: aCategory
	^(super includesCategory: aCategory)
		and: [(environment classNamesFor: aCategory)
				inject: false into: [:bool :each | bool
					or:
						[| aClass |
						aClass := Smalltalk at: each ifAbsent: [nil].
						aClass == class or: [aClass class == class]]]]
!

includesClass: aClass
	^aClass == class and: [super includesClass: aClass]
!

includesProtocol: aProtocol in: aClass
	^aClass == class and: [(super includesProtocol: aProtocol in: aClass)
			and: [protocols includes: aProtocol]]
!

includesSelector: aSelector in: aClass 
	^(super includesSelector: aSelector in: aClass) and: 
			[protocols 
				includes: (environment whichProtocolIncludes: aSelector in: aClass)]
!

isEmpty
	^protocols isEmpty
! !

!ProtocolEnvironment class methodsFor:'documentation'!

version
    ^ '$Id: ProtocolEnvironment.st,v 1.8 2011/07/09 15:40:35 vrany Exp $'
!

version_SVN
    ^ 'Id'
! !
