"{ Package: 'stx:goodies/refactoryBrowser/browser' }"

LibraryDefinition subclass:#stx_goodies_refactoryBrowser_browser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_refactoryBrowser_browser class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/browser/stx_goodies_refactoryBrowser_browser.st,v 1.7 2011/09/06 08:42:53 cg Exp $'
! !

!stx_goodies_refactoryBrowser_browser class methodsFor:'description'!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
	#'stx:goodies/refactoryBrowser/changes'    "RefactoryChangeManager - referenced by BrowserApplicationModel>>performChange:withMessage: "
	#'stx:goodies/refactoryBrowser/helpers'    "BrowserEnvironment - superclass of ClassEnvironment "
	#'stx:goodies/refactoryBrowser/parser'    "RBParser - referenced by BrowserNavigator>>checkProtocolMatchFor:in: "
	#'stx:goodies/refactoryBrowser/refactoring'    "CreateAccessorsForVariableRefactoring - referenced by BrowserTextTool>>createAccessorsForInstVar: "
	#'stx:libbasic'    "Autoload - superclass of OMTClassView "
	#'stx:libbasic2'    "TextStream - referenced by BrowserNavigator>>printOutClass "
	#'stx:libbasic3'    "ChangeSet - referenced by BrowserNavigator>>removeCategory: "
	#'stx:libcompat'    "CoveragePalette - referenced by BrowserDialog class>>disabledUpIconMask "
	#'stx:libview'    "Image - referenced by BrowserDialog class>>disabledDownIconMask "
	#'stx:libview2'    "Model - superclass of ClassSelectorNavigator "
	#'stx:libwidg'    "SelectionInList - referenced by BrowserNavigator>>forClasses:showVariableMenu:collect: "
	#'stx:libwidg2'    "LabelAndIcon - referenced by BrowserApplicationModel>>createSelectedVisualBlockFrom: "
    )
! !

!stx_goodies_refactoryBrowser_browser class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (BrowserApplicationModel autoload)
        (BrowserClassTool autoload)
        (BrowserCodeTool autoload)
        BrowserDialog
        BrowserEnvironmentWrapper
        (CanvasViewer autoload)
        (CategoryDialog autoload)
        (ClassCommentTool autoload)
        (ClassNavigatorTool autoload)
        (ClassSelectionDialog autoload)
        (CodeModel autoload)
        (CodeModelLockPolicy autoload)
        (CodeToolSelectionPolicy autoload)
        (CompositeRefactoryChangeInspector autoload)
        (EnvironmentEditor autoload)
        (IconViewer autoload)
        LimitedEnvironment
        (MenuViewer autoload)
        (MultiNavigator autoload)
        (NavigatorState autoload)
        (OMTClassController autoload)
        (OMTClassDiagram autoload)
        (OMTClassModel autoload)
        (OMTClassTool autoload)
        (OMTClassView autoload)
        (OrganizationEditor autoload)
        (RBMultiSelectionInList autoload)
        (RBMultiSelectionView autoload)
        (RefactoringBrowser autoload)
        (RefactoryBrowserPlatformSupport autoload)
        (RefactoryBuilderInspector autoload)
        (RefactoryTyper autoload)
        (ReferenceFinder autoload)
        (ResourceTool autoload)
        (RewriteCodeTool autoload)
        (RewriteRuleEditor autoload)
        (SourceSelectionPolicy autoload)
        (StateLockPolicy autoload)
        (SystemNavigator autoload)
        (UnreferencedVariables autoload)
        (VariableNavigator autoload)
        (VariableNavigatorState autoload)
        (VariableTypeDialog autoload)
        (WindowLockPolicy autoload)
        #'stx_goodies_refactoryBrowser_browser'
        AndEnvironment
        CategoryEnvironment
        ClassEnvironment
        (CodeTool autoload)
        MethodNameDialog
        (Navigator autoload)
        NotEnvironment
        PackageEnvironment
        ProtocolEnvironment
        RestrictedEnvironment
        ParseTreeEnvironment
        SelectorEnvironment
        VariableEnvironment
        (BrowserNavigator autoload)
        (BrowserTextTool autoload)
        (MethodNameDialogForAddParameter autoload)
        MultiEnvironment
        (ClassSelectorNavigator autoload)
    )

    "Modified: / 06-09-2011 / 10:41:23 / cg"
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
	BrowserEnvironment forPackage:
	BrowserEnvironment forPackages:
    )
! !

!stx_goodies_refactoryBrowser_browser class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2007\nCopyright eXept Software AG 1998-2007'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_refactoryBrowser_browser class methodsFor:'description - svn'!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"'exportiert'"$"
! !

!stx_goodies_refactoryBrowser_browser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/browser/stx_goodies_refactoryBrowser_browser.st,v 1.7 2011/09/06 08:42:53 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/browser/stx_goodies_refactoryBrowser_browser.st,v 1.7 2011/09/06 08:42:53 cg Exp $'
!

version_SVN
    ^ 'Id'
! !
