"{ Package: 'stx:goodies/refactoryBrowser/changes' }"

RefactoryClassChange subclass:#AddClassChange
	instanceVariableNames:'definition superclassName instanceVariableNames
		classVariableNames poolDictionaryNames category'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Change Objects'
!


!AddClassChange class methodsFor:'instance creation'!

definition: aString 
	^self new definition: aString
! !

!AddClassChange class methodsFor:'others'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/changes/AddClassChange.st,v 1.5 2011/07/04 12:45:49 cg Exp $'
! !

!AddClassChange methodsFor:'accessing'!

category
	category isNil ifTrue: [self fillOutDefinition].
	^category
!

changeClassName
	className isNil ifTrue: [self fillOutDefinition].
	^className
!

classVariableNames
	classVariableNames isNil ifTrue: [self fillOutDefinition].
	^classVariableNames
!

instanceVariableNames
	instanceVariableNames isNil ifTrue: [self fillOutDefinition].
	^instanceVariableNames
!

poolDictionaryNames
	poolDictionaryNames isNil ifTrue: [self fillOutDefinition].
	^poolDictionaryNames
!

superclassName
	className isNil ifTrue: [self fillOutDefinition].
	^superclassName
! !

!AddClassChange methodsFor:'comparing'!

= anAddClassChange 
	self class = anAddClassChange class ifFalse: [^false].
	^definition = anAddClassChange definition
!

hash
	^definition hash
! !

!AddClassChange methodsFor:'converting'!

asUndoOperation
	| class |
	class := Smalltalk at: self changeClassName ifAbsent: [nil].
	^class isBehavior 
		ifTrue: [AddClassChange definition: class definition]
		ifFalse: [RemoveClassChange removeClassName: self changeClassName]
! !

!AddClassChange methodsFor:'initialize-release'!

definition: aString 
	definition := aString
!

initialize
	super initialize.
	isMeta := false
! !

!AddClassChange methodsFor:'printing'!

changeString
        ^'Define ' , self displayClassName allBold
!

printOn: aStream 
	aStream
		nextPutAll: definition;
		nextPut: $!!
! !

!AddClassChange methodsFor:'private'!

controller
	^nil
!

definingSuperclass
	^self class
!

definition
	^definition
!

fillOutDefinition
	| parseTree |
	parseTree := RBParser parseExpression: definition
				onError: [:str :pos | ^self parseDefinitionError].
	parseTree isMessage ifFalse: [^self parseDefinitionError].
	(self isValidSubclassCreationMessage: parseTree) 
		ifFalse: [^self parseDefinitionError].
	superclassName := parseTree receiver isVariable 
				ifTrue: [parseTree receiver name asSymbol]
				ifFalse: [parseTree receiver value].
	className := parseTree arguments first value.
	instanceVariableNames := self namesIn: (parseTree arguments at: 2) value.
	classVariableNames := self namesIn: (parseTree arguments at: 3) value.
	poolDictionaryNames := self namesIn: (parseTree arguments at: 4) value.
	category := parseTree arguments size < 5 
				ifTrue: [#Unknown]
				ifFalse: [(parseTree arguments at: 5) value asSymbol]
!

namesIn: aString 
	| names stream nameStream |
	names := OrderedCollection new.
	stream := ReadStream on: aString.
	
	[stream skipSeparators.
	stream atEnd] whileFalse: 
				[nameStream := WriteStream on: (String new: 10).
				[stream atEnd or: [stream peek isSeparator]] 
					whileFalse: [nameStream nextPut: stream next].
				names add: nameStream contents].
	^names
!

parseDefinitionError
	className := #'Unknown Class'.
	instanceVariableNames := #().
	classVariableNames := #().
	poolDictionaryNames := #()
!

primitiveExecute
	^self definingSuperclass subclassDefinerClass 
		evaluate: definition
		notifying: self controller
		logged: true
! !

!AddClassChange methodsFor:'testing'!

isClassDefinitionChange

    ^true

    "Created: / 29-10-2010 / 13:35:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isValidMessageName: aMessageNode 
	^#(#subclass:instanceVariableNames:classVariableNames:poolDictionaries: #subclass:instanceVariableNames:classVariableNames:poolDictionaries:category: #variableByteSubclass:classVariableNames:poolDictionaries: #variableByteSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category: #variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries: #variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:) 
		includes: aMessageNode selector
!

isValidSubclassCreationMessage: aMessageNode 
	(aMessageNode receiver isVariable or: [aMessageNode receiver isLiteral]) 
		ifFalse: [^false].
	(self isValidMessageName: aMessageNode) ifFalse: [^false].
	^(aMessageNode arguments detect: [:each | each isLiteral not] ifNone: [nil]) 
		isNil
! !

!AddClassChange class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/changes/AddClassChange.st,v 1.5 2011/07/04 12:45:49 cg Exp $'
! !
