"{ Package: 'stx:goodies/refactoryBrowser/changes' }"

RefactoryChange subclass:#MethodRefactoryChange
	instanceVariableNames:'source selector protocol'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Support'
!

MethodRefactoryChange comment:'MethodRefactoryChange is a RefactoryChange that represents compiling a method.

Instance Variables:
	protocol	<Symbol>	the protocol for the new method
	selector	<Symbol>	the method name (generated from the source)
	source	<String>	the source to compile'
!


!MethodRefactoryChange class methodsFor:'others'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/changes/MethodRefactoryChange.st,v 1.9 2011/07/19 12:29:32 vrany Exp $'
! !

!MethodRefactoryChange methodsFor:'accessing'!

doIt
    package notNil ifTrue:[
        Class packageQuerySignal 
            answer:package
            do:[
                self theClass 
                        compile: source
                        classified: self protocol
                        notifying: nil
            ]
    ].
        self theClass 
                compile: source
                classified: self protocol
                notifying: nil

    "Modified: / 17-08-2006 / 19:17:43 / cg"
!

imageSource

    ^self methodSourceFor: selector.

    "Created: / 19-07-2011 / 13:26:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

protocol
	^protocol
!

selector
        selector isNil ifTrue: 
                        [selector := RBParser parseMethodPattern: source.
                        selector isNil ifTrue: [selector := #unknown]].
        ^selector
! !

!MethodRefactoryChange methodsFor:'initialize-release'!

class: aClass protocol: aCategory source: aString 
        package := Class packageQuerySignal query.
        class := aClass.
        protocol := aCategory.
        source := aString

    "Modified: / 17-08-2006 / 19:15:08 / cg"
!

class: aClass source: aString 
	class := aClass.
	source := aString.
	protocol := BrowserEnvironment new whichProtocolIncludes: self selector
				in: aClass.
	protocol isNil ifTrue: [protocol := #accessing]
! !

!MethodRefactoryChange methodsFor:'printing'!

displayString
	^super displayString , '>>' , self selector
!

printOn: aStream 
	aStream nextPut: $!!;
		print: class;
		nextPutAll: ' methodsFor: ''';
		nextPutAll: protocol;
		nextPutAll: '''!!';
		cr;
		cr;
		nextPutAll: source;
		nextPutAll: '!! !!'
! !

!MethodRefactoryChange class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/changes/MethodRefactoryChange.st,v 1.9 2011/07/19 12:29:32 vrany Exp $'
! !
