"{ Package: 'stx:goodies/refactoryBrowser/changes' }"

LibraryDefinition subclass:#stx_goodies_refactoryBrowser_changes
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_refactoryBrowser_changes class methodsFor:'documentation'!

documentation
"
    Build-Information for creation of the refactoring library: stx:goodies/refactoryBrowser/changes.
    This library contains classes representing changes done to the system.
"
! !

!stx_goodies_refactoryBrowser_changes class methodsFor:'description'!

extensionMethodNames
    ^ #(
    )
!

preRequisites
    ^ #(
        #'stx:goodies/refactoryBrowser/helpers'    "BrowserEnvironment - referenced by AddMethodChange>>asUndoOperation "
        #'stx:goodies/refactoryBrowser/parser'    "RBParser - referenced by AddMethodChange>>parseTree "
        #'stx:libbasic'    "LibraryDefinition - superclass of stx_goodies_refactoryBrowser_changes "
        #'stx:libbasic3'    "ChangeSet - referenced by RefactoryChangeManager>>connectToChanges "
    )
! !

!stx_goodies_refactoryBrowser_changes class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIB_RB_CHANGES_BASE
LIB_BASE=$(LIB_RB_CHANGES_BASE)
'
!

stcOptimizationOptions
    "do not inline the not operation here - it is overwritten"

    ^ '+optspace3 -inlinenot'

    "Created: / 23-08-2006 / 01:00:12 / cg"
! !

!stx_goodies_refactoryBrowser_changes class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        AddClassChange
        AddClassVariableChange
        AddInstanceVariableChange
        AddMethodChange
        AddPoolVariableChange
        ClassRefactoryChange
        CompositeRefactoryChange
        InteractiveAddClassChange
        InteractiveAddMethodChange
        MethodRefactoryChange
        RefactoryChange
        RefactoryChangeManager
        RefactoryClassCategoryChange
        RefactoryClassChange
        RefactoryClassProjectChange
        RefactoryMethodCategoryChange
        RefactoryMethodProjectChange
        RefactoryVariableChange
        RemoveClassChange
        RemoveClassVariableChange
        RemoveInstanceVariableChange
        RemoveMethodChange
        RemovePoolVariableChange
        RenameClassChange
        RenameClassVariableChange
        RenameInstanceVariableChange
        RenameVariableChange
        #'stx_goodies_refactoryBrowser_changes'
    )
! !

!stx_goodies_refactoryBrowser_changes class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Refactoring Changes'
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ 'Copyright Refactoring Inc.\nCopyright eXept Software AG 2000-2011'

    "Modified: / 01-02-2011 / 11:53:07 / cg"
! !

!stx_goodies_refactoryBrowser_changes class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/changes/stx_goodies_refactoryBrowser_changes.st,v 1.18 2011/02/01 10:58:23 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/changes/stx_goodies_refactoryBrowser_changes.st,v 1.18 2011/02/01 10:58:23 cg Exp $'
! !
