"{ Package: 'stx:goodies/refactoryBrowser/helpers' }"

LibraryDefinition subclass:#stx_goodies_refactoryBrowser_helpers
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_refactoryBrowser_helpers class methodsFor:'documentation'!

documentation
"
    Build-Information for creation of the refactoring library: stx:goodies/refactoryBrowser/helpers.
    This library contains refactoring support classes.
"
! !

!stx_goodies_refactoryBrowser_helpers class methodsFor:'description'!

excludedFromPreRequisites
    ^ #(
        #'stx:goodies/refactoryBrowser/changes'    "RenameClassChange - referenced by RBNamespace>>renameClass:to:around: "
        #'stx:goodies/refactoryBrowser/parser'    "RBParser - referenced by RBNamespace>>replaceClassNameIn:to: "
        #'stx:goodies/refactoryBrowser/refactoring'    "RBCondition - referenced by RBMethodName>>isValid "
    )
!

preRequisites
    ^ #(
        #'stx:libbasic'    "LibraryDefinition - superclass of stx_goodies_refactoryBrowser_helpers "
    )
! !

!stx_goodies_refactoryBrowser_helpers class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIB_RB_HELPERS_BASE
LIB_BASE=$(LIB_RB_HELPERS_BASE)
'
!

stcOptimizationOptions
    "do not inline the not operation here - it is overwritten"

    ^ '+optspace3 -inlinenot'

    "Created: / 23-08-2006 / 01:04:08 / cg"
! !

!stx_goodies_refactoryBrowser_helpers class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        BrowserEnvironment
        RBAbstractClass
        RBClass
        RBMetaclass
        RBMethod
        RBMethodName
        RBNamespace
        #'stx_goodies_refactoryBrowser_helpers'
    )
! !

!stx_goodies_refactoryBrowser_helpers class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Refactoring Helpers'
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ 'Copyright Refactoring Inc.\nCopyright eXept Software AG 2000-2011'

    "Modified: / 01-02-2011 / 11:53:11 / cg"
! !

!stx_goodies_refactoryBrowser_helpers class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/helpers/stx_goodies_refactoryBrowser_helpers.st,v 1.21 2011/04/21 11:05:22 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/helpers/stx_goodies_refactoryBrowser_helpers.st,v 1.21 2011/04/21 11:05:22 cg Exp $'
! !
