"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBAbstractClassRule
	instanceVariableNames:'subclassResponsibilitySymbol'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBAbstractClassRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'References an abstract class'
!

rationale
        ^ 'Checks for references to classes that have subclassResponsibility methods. 
Such references might be creating instances of the abstract class 
or more commonly being used as the argument to an "<code>isKindOf:</code>" message 
which is considered bad style.'

    "Modified: / 01-03-2012 / 12:22:33 / cg"
!

resultClass
	^ ClassEnvironment
! !

!RBAbstractClassRule methodsFor:'initialization'!

initialize
	super initialize.
	subclassResponsibilitySymbol := 'subclassResponsibility' asSymbol
! !

!RBAbstractClassRule methodsFor:'running'!

checkClass: aContext 
	(aContext selectedClass whichSelectorsReferTo: subclassResponsibilitySymbol) isEmpty ifFalse: 
		[ (aContext uses: (Smalltalk 
				associationAt: aContext selectedClass name
				ifAbsent: [ nil ])) ifTrue: [ result addClass: aContext selectedClass ] ]
! !

!RBAbstractClassRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAbstractClassRule.st,v 1.3 2012/03/01 11:48:31 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAbstractClassRule.st,v 1.3 2012/03/01 11:48:31 cg Exp $'
!

version_SVN
    ^ 'Id: RBAbstractClassRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
