"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBAddRemoveDependentsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBAddRemoveDependentsRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
        ^ 'Number of "addDependent:" messages > "removeDependent:"'

    "Modified: / 01-03-2012 / 12:10:07 / cg"
!

rationale
        ^ 'Check that the number of "<code>addDependent:</code>" message sends in a class is 
less than or equal to the number of "<code>removeDependent:</code>" messages. 
If there are more add messages that may signify that some dependents are not being released, 
which may lead to memory leaks.
<P>
Please validate the outcome of this check manually: 
control flow (conditional execution pathes) are not analyzed by this check.'

    "Modified: / 01-03-2012 / 12:12:15 / cg"
!

resultClass
	^ ClassEnvironment
! !

!RBAddRemoveDependentsRule methodsFor:'running'!

checkClass: aContext 
	| count |
	count := 0.
	((Set withAll: (aContext selectedClass whichSelectorsReferTo: #addDependent:))
		addAll: (aContext selectedClass whichSelectorsReferTo: #removeDependent:);
		yourself) do: 
		[ :sel | 
		(aContext selectedClass compiledMethodAt: sel) messagesDo: 
			[ :each | 
			each = #addDependent: ifTrue: [ count := count + 1 ].
			each = #removeDependent: ifTrue: [ count := count - 1 ] ] ].
	count > 0 ifTrue: [ result addClass: aContext selectedClass ]
! !

!RBAddRemoveDependentsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAddRemoveDependentsRule.st,v 1.3 2012/03/01 11:49:26 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAddRemoveDependentsRule.st,v 1.3 2012/03/01 11:49:26 cg Exp $'
!

version_SVN
    ^ 'Id: RBAddRemoveDependentsRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
