"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBAssignmentInBlockRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBAssignmentInBlockRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Unnecessary assignment or return in block'
!

rationale
        ^ 'Checks "<code>ensure:</code>", "<code>ifCurtailed:</code>", and "<code>showWhile:</code>" blocks for assignments 
or returns that are the last statement in the block. 
These assignments or returns can be moved outside the block since these messages return the value of the block.'

    "Modified: / 01-03-2012 / 20:36:04 / cg"
! !

!RBAssignmentInBlockRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'`@cursor showWhile: [| `@temps | `@.Statements1. `var := `@object]'
			'`@cursor showWhile: [| `@temps | `@.Statements1. ^`@object]'
			'[| `@temps | `@.Statements. `var := `@object] ensure: `@block'
			'[| `@temps | `@.Statements. ^`@object] ensure: `@block'
			'[| `@temps | `@.Statements. `var := `@object] ifCurtailed: `@block'
			'[| `@temps | `@.Statements. ^`@object] ifCurtailed: `@block' )
		do: [ :node :answer | node ]
! !

!RBAssignmentInBlockRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAssignmentInBlockRule.st,v 1.3 2012/03/01 19:39:19 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAssignmentInBlockRule.st,v 1.3 2012/03/01 19:39:19 cg Exp $'
!

version_SVN
    ^ 'Id: RBAssignmentInBlockRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
