"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBAssignmentInIfTrueRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Transformation Rules'
!


!RBAssignmentInIfTrueRule methodsFor:'accessing'!

group
        ^ 'Transformations'

    "Modified: / 01-03-2012 / 08:14:55 / cg"
!

name
        ^ 'Move variable assignment outside of single statement "ifTrue:ifFalse:" blocks'

    "Modified: / 01-03-2012 / 19:15:47 / cg"
!

rationale
        ^ 'Replace code like 
<br>&nbsp;&nbsp;&nbsp;<code>boolean ifTrue: [var := e1] ifFalse: [var := e2]</code>
<br>into
<br>&nbsp;&nbsp;&nbsp;<code>variable := boolean ifTrue: [e1] ifFalse: [e2]</code>.
<p>
Notice that after the transformation, complicated code, especially with side effects
might be harder to understand then the original style.
Consider that a matter of taste.'

    "Created: / 01-03-2012 / 19:18:42 / cg"
! !

!RBAssignmentInIfTrueRule methodsFor:'initialization'!

initialize
	super initialize.
	self rewriteRule
		replace: '``@Boolean ifTrue: [`variable := ``@true] ifFalse: [`variable := ``@false]'
		with: '`variable := ``@Boolean ifTrue: [``@true] ifFalse: [``@false]';
		replace: '``@Boolean ifFalse: [`variable := ``@true] ifTrue: [`variable := ``@false]'
		with: '`variable := ``@Boolean ifFalse: [``@true] ifTrue: [``@false]'
! !

!RBAssignmentInIfTrueRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAssignmentInIfTrueRule.st,v 1.3 2012/03/01 18:44:00 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAssignmentInIfTrueRule.st,v 1.3 2012/03/01 18:44:00 cg Exp $'
!

version_SVN
    ^ 'Id: RBAssignmentInIfTrueRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
