"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBAssignmentWithoutEffectRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBAssignmentWithoutEffectRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
        ^ 'Assignment has no effect'

    "Modified: / 01-03-2012 / 16:47:45 / cg"
!

rationale
        ^ 'A statement such as "<code>x := x</code>" has no effect.
Also, multiple assignments of a iteral to the same variable,
 as in "<code>x := 1. x := 2.</code>"  are at least questionable (probably leftover debug code).'

    "Modified: / 02-03-2012 / 01:00:03 / cg"
! !

!RBAssignmentWithoutEffectRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                                '`var := `var'
                               )
                do: [ :node :answer | node ].

        self matcher 
                matchesAnyMethodOf: #(
                        '`@MethodName: `@args 
                                | `@temps | 
                                `@.Statements1. 
                                `var := `#lit1 . `var := `#lit2.' 

                        '`@MethodName: `@args 
                                | `@temps | 
                                `var := `#lit1 . `var := `#lit2.
                                `@.Statements2.' 

                        '`@MethodName: `@args 
                                | `@temps | 
                                `@.Statements1. 
                                `var := `#lit1 . `var := `#lit2.
                                `@.Statements2.' 
                )
                do: [ :node :answer | node ]

    "Modified: / 02-03-2012 / 00:59:40 / cg"
! !

!RBAssignmentWithoutEffectRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAssignmentWithoutEffectRule.st,v 1.5 2012/03/02 00:00:39 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBAssignmentWithoutEffectRule.st,v 1.5 2012/03/02 00:00:39 cg Exp $'
!

version_SVN
    ^ 'Id: RBAssignmentWithoutEffectRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
