"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBBadIdentityComparisonRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBBadIdentityComparisonRule methodsFor:'accessing'!

group
        ^ 'Bugs'

    "Modified: / 07-03-2012 / 22:14:34 / cg"
!

name
        ^ 'Float and String instances should not be compared using == or ~~'

    "Modified: / 07-03-2012 / 22:15:12 / cg"
!

rationale
        ^ 'Floats and strings are value types and should be compared by value, not by identity.
<br>Operations on floats typically create new instances, for example
"<code>1.0 + 1.0</code>" is equal to 2.0, but not identical.
Floats and Strings are seldom identical to another instance with the equal values.
<P>
Please change the code to use "=" and "~=" instead.'

    "Modified: / 08-03-2012 / 02:40:48 / cg"
! !

!RBBadIdentityComparisonRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                        '`{ :node | |val| node isLiteral and: [ (val := node value) isFloat or:[ val isString and:[val isSymbol not]]] } == `@expr'
                        '`{ :node | |val| node isLiteral and: [ (val := node value) isFloat or:[ val isString and:[val isSymbol not]]] } ~~ `@expr'
                        '`@expr == `{ :node | |val| node isLiteral and: [ (val := node value) isFloat or:[ val isString and:[val isSymbol not]]] }'
                        '`@expr ~~ `{ :node | |val| node isLiteral and: [ (val := node value) isFloat or:[ val isString and:[val isSymbol not]]] }' )
                do: [ :node :answer | node ]

    "Modified: / 08-03-2012 / 02:29:08 / cg"
! !

!RBBadIdentityComparisonRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBBadIdentityComparisonRule.st,v 1.3 2012/03/08 01:42:23 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBBadIdentityComparisonRule.st,v 1.3 2012/03/08 01:42:23 cg Exp $'
! !
