"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBBooleanPrecedenceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBBooleanPrecedenceRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'Uses A | B = C instead of A | (B = C)'
!

rationale
        ^ 'Checks precedence ordering of "<code>&</code>" and "<code>|</code>" with equality operators. 
Since "|" and "&" have the same precedence as "=", 
there are common mistakes where parenthesis are missing around the equality operators.'

    "Modified: / 01-03-2012 / 20:36:34 / cg"
! !

!RBBooleanPrecedenceRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'`@object1 | `@object2 = `@object3'
			'`@object1 | `@object2 == `@object3'
			'`@object1 & `@object2 = `@object3'
			'`@object1 & `@object2 == `@object3'
			'`@object1 | `@object2 ~= `@object3'
			'`@object1 | `@object2 ~~ `@object3'
			'`@object1 & `@object2 ~= `@object3'
			'`@object1 & `@object2 ~~ `@object3' )
		do: [ :node :answer | node ]
! !

!RBBooleanPrecedenceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBBooleanPrecedenceRule.st,v 1.3 2012/03/01 19:39:15 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBBooleanPrecedenceRule.st,v 1.3 2012/03/01 19:39:15 cg Exp $'
!

version_SVN
    ^ 'Id: RBBooleanPrecedenceRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
