"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBCascadedNextPutAllsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Transformation Rules'
!


!RBCascadedNextPutAllsRule methodsFor:'accessing'!

group
        ^ 'Transformations'

    "Modified: / 01-03-2012 / 08:14:47 / cg"
!

name
        ^ 'Use cascaded "nextPutAll:" instead of "," in "nextPutAll:"'

    "Modified: / 01-03-2012 / 19:23:02 / cg"
!

rationale
        ^ 'When writing multiple strings to a stream,
it is more efficient to use multiple "<code>nextPutAll:</code>" messages
instead of concatenating the strings first and then sending them. 
Concatenation creates additional 
garbage objects with a non-linear time and space complexity.
<P>Rewrites:
<br>&nbsp;&nbsp;&nbsp;<code>aStream nextPutAll:(s1 , s2)</code>
<br>into
<br>&nbsp;&nbsp;&nbsp;<code>aStream nextPutAll:s1; nextPutAll:s2 </code>.
<p>
'

    "Created: / 01-03-2012 / 19:24:52 / cg"
! !

!RBCascadedNextPutAllsRule methodsFor:'initialization'!

initialize
	super initialize.
	self rewriteRule
		replace: '``@rcvr nextPutAll: ``@object1 , ``@object2' with: '``@rcvr nextPutAll: ``@object1; nextPutAll: ``@object2';
		replace: '``@rcvr show: ``@object1 , ``@object2' with: '``@rcvr show: ``@object1; show: ``@object2'
! !

!RBCascadedNextPutAllsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCascadedNextPutAllsRule.st,v 1.3 2012/03/01 18:44:02 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCascadedNextPutAllsRule.st,v 1.3 2012/03/01 18:44:02 cg Exp $'
!

version_SVN
    ^ 'Id: RBCascadedNextPutAllsRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
