"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBClassInstVarNotInitializedRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBClassInstVarNotInitializedRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Has class instance variables but no initialize method'
!

rationale
        ^ 'Checks that all classes that have class instance variables also have an initialize method. 
This makes sure that all class instance variables are initialized properly.
The reason is that on the class side, inherited initialize-methods are not invoked
(the class loaded checks explicitely for the existence of an "<code>initialize</code> method,
before calling it).
<p>
Some code uses lazy initialization for those, so validate the outcome manually.'

    "Modified: / 01-03-2012 / 21:35:06 / cg"
!

resultClass
	^ ClassEnvironment
! !

!RBClassInstVarNotInitializedRule methodsFor:'running'!

checkClass: aContext 
	| definesVar class |
	aContext selectedClass isMeta ifTrue: 
		[ class := aContext selectedClass.
		definesVar := false.
		[ definesVar or: [ class isNil or: [ class isMeta not ] ] ] whileFalse: 
			[ definesVar := class instVarNames isEmpty not.
			class := class superclass ].
		(definesVar and: [ (aContext selectedClass includesSelector: #initialize) not ]) ifTrue: [ result addClass: aContext selectedClass ] ]
! !

!RBClassInstVarNotInitializedRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBClassInstVarNotInitializedRule.st,v 1.3 2012/03/01 20:37:03 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBClassInstVarNotInitializedRule.st,v 1.3 2012/03/01 20:37:03 cg Exp $'
!

version_SVN
    ^ 'Id: RBClassInstVarNotInitializedRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
