"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBClassNameInSelectorRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBClassNameInSelectorRule methodsFor:'accessing'!

group
        ^ 'Bad and Questionable Rules'

    "Modified: / 07-03-2012 / 18:04:56 / cg"
!

name
	^ 'Redundant class name in selector'
!

rationale
        ^ 'Checks for the class name in a selector. 
This is redundant since to call the you must already refer to the class name. 
For example, "openHierarchyBrowserFrom:" is a redundant name for "HierarchyBrowser".
<P>
This is a very questionable rule, because having a class name in the selector
adds much to the readability and browseability.
For example, having a method named "addFoo:" instead of "add:" both makes it
clear what is added, and also makes browsing for implementors and senders *much*
easier.
<P>
This rule should therefore considered to be an <B>anti-rule</B>,
specified by rule-fetishists, who create arbitrary coding rules without proper foundation.'

    "Modified: / 07-03-2012 / 18:03:30 / cg"
! !

!RBClassNameInSelectorRule methodsFor:'running'!

checkMethod: aContext 
	(aContext selectedClass isMeta and: 
		[ (aContext selector 
			indexOfSubCollection: aContext selectedClass soleInstance name
			startingAt: 1) > 0 ]) ifTrue: 
		[ result 
			addClass: aContext selectedClass
			selector: aContext selector ]
! !

!RBClassNameInSelectorRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBClassNameInSelectorRule.st,v 1.5 2012/03/07 17:16:53 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBClassNameInSelectorRule.st,v 1.5 2012/03/07 17:16:53 cg Exp $'
!

version_SVN
    ^ 'Id: RBClassNameInSelectorRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
