"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBClassNotReferencedRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBClassNotReferencedRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Class not referenced'
!

rationale
        ^ 'Check if a class is referenced either directly or indirectly by a symbol. 
If a class is not referenced, it can be removed. 
However, be careful: many classes are referenced via their namespace or by enumerating subclasses.'

    "Modified: / 30-12-2011 / 12:47:53 / cg"
!

resultClass
	^ ClassEnvironment
! !

!RBClassNotReferencedRule methodsFor:'running'!

checkClass: aContext 
	(aContext selectedClass isMeta or: 
		[ aContext selectedClass subclasses isEmpty not or: [ aContext selectedClass includesBehavior: TestCase ] ]) ifFalse: 
		[ | assoc |
		assoc := Smalltalk associationAt: aContext selectedClass name.
		((aContext uses: assoc) or: [ aContext uses: aContext selectedClass name ]) ifFalse: 
			[ result
				addClass: aContext selectedClass;
				addClass: aContext selectedClass class ] ]
! !

!RBClassNotReferencedRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBClassNotReferencedRule.st,v 1.3 2011/12/30 11:48:11 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBClassNotReferencedRule.st,v 1.3 2011/12/30 11:48:11 cg Exp $'
!

version_SVN
    ^ 'Id: RBClassNotReferencedRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
