"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBCodeCruftLeftInMethodsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Squeak'
!


!RBCodeCruftLeftInMethodsRule methodsFor:'accessing'!

group
        ^ 'Bugs - Squeak'

    "Modified: / 01-03-2012 / 18:57:25 / cg"
!

name
        ^ 'Squeak debugging code left in methods'

    "Modified: / 07-04-2012 / 13:20:15 / cg"
!

rationale
	^ 'Breakpoints, logging statements, etc. should not be left in production code.'
! !

!RBCodeCruftLeftInMethodsRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                        '`@object breakPoint: `@object1'
                        '`@object breakPoint: `@object1 info: `@object2'
                        '`@object todo: `@object1'
                        '`@object todo'
                        '`@object checkHaltCountExpired'
                        '`@object clearHaltOnce'
                        '`@object decrementAndCheckHaltCount'
                        '`@object decrementHaltCount'
                        '`@object doExpiredHaltCount'
                        '`@object doExpiredHaltCount: `@object1'
                        '`@object doOnlyOnce: `@object1'
                        '`@object halt'
                        '`@object halt: `@object1 onCount: `@object2'
                        '`@object haltOnCount: `@object1'
                        '`@object haltOnce'
                        '`@object haltOnce: `@object1'
                        '`@object haltOnceEnabled'
                        '`@object hasHaltCount'
                        '`@object hatIf: `@object1'
                        '`@object inspectOnCount: `@object1'
                        '`@object inspectOnce'
                        '`@object inspectUntilCount: `@object1'
                        '`@object rearmOneShot'
                        '`@object removeHaltCount'
                        '`@object setHaltCountTo: `@object1'
                        '`@object setHaltOnce'
                        '`@object toggleHaltOnce'
                        '`@object flag: `@object1'
                        '`@object isThisEverCalled'
                        '`@object isThisEverCalled: `@object1'
                        '`@object logEntry'
                        '`@object logExecution'
                        '`@object logExit'
                        '`@object needsWork'
                        'true ifTrue: `@object1'
                        'false ifTrue: `@object1'
                        'true ifTrue: `@object1 ifFalse: `@object2'
                        'false ifTrue: `@object1 ifFalse: `@object2'
                        'true ifFalse: `@object1'
                        'false ifFalse: `@object1'
                        'true ifFalse: `@object1 ifTrue: `@object2'
                        'false ifFalse: `@object1 ifTrue: `@object2'
                        'Transcript `@message: `@object1' )
                do: [ :node :answer | node ]

    "Modified: / 07-09-2011 / 06:09:52 / cg"
! !

!RBCodeCruftLeftInMethodsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCodeCruftLeftInMethodsRule.st,v 1.6 2012/04/07 11:20:21 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCodeCruftLeftInMethodsRule.st,v 1.6 2012/04/07 11:20:21 cg Exp $'
!

version_SVN
    ^ 'Id: RBCodeCruftLeftInMethodsRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
