"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBCollectionCopyEmptyRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBCollectionCopyEmptyRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Subclass of collection that has instance variable but doesn''t define copyEmpty'
!

rationale
        ^ 'Checks that all subclasses of the Collection classes that add an instance variable 
also redefine the "<code>copyEmpty</code>" method. 
This method is used when the collection grows. 
It copies over the necessary instance variables to the new larger collection.'

    "Modified: / 01-03-2012 / 12:20:40 / cg"
!

resultClass
	^ ClassEnvironment
! !

!RBCollectionCopyEmptyRule methodsFor:'running'!

checkClass: aContext 
	(aContext selectedClass isVariable and: [ (aContext selectedClass includesSelector: #copyEmpty) not and: [ aContext selectedClass instVarNames isEmpty not and: [ aContext selectedClass inheritsFrom: Collection ] ] ])
		ifTrue: [ result addClass: aContext selectedClass ]
! !

!RBCollectionCopyEmptyRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCollectionCopyEmptyRule.st,v 1.2 2012/03/01 11:55:21 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCollectionCopyEmptyRule.st,v 1.2 2012/03/01 11:55:21 cg Exp $'
!

version_SVN
    ^ 'Id: RBCollectionCopyEmptyRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
