"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBCollectionMessagesToExternalObjectRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBCollectionMessagesToExternalObjectRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ 'Sends "add:/remove:" to external (not-owned) collection'

    "Modified: / 01-03-2012 / 15:04:42 / cg"
!

rationale
        ^ 'Checks for methods that appear to be modifying a collection that is owned by another object. 
Such modifications can cause problems, especially if other variables are to be modified when the collection is modified. 
For example, UI components must set the container of all their parts. Thus simply adding a part to the returned
component list does not suffice.'

    "Modified: / 01-03-2012 / 20:38:56 / cg"
! !

!RBCollectionMessagesToExternalObjectRule methodsFor:'initialization'!

initialize
	| queries |
	super initialize.
	queries := #( add: remove: addAll: removeAll: )
		collect: [ :each | '(`@Object `@message: `@args) <1s> `@Arg' expandMacrosWith: each ].
	self matcher 
		matchesAnyOf: queries
		do: [ :node :answer |
			answer isNil 
				ifTrue: [
					((node receiver selector copyFrom: 1 to: (node receiver selector size min: 2)) ~= 'as' 
						and: [
							| receiver |
							receiver := node receiver receiver.
							receiver isVariable not 
								or: [ ((#('self' 'super') includes: receiver name) 
								or: [ Smalltalk includesKey: receiver name asSymbol ]) not ] ]) 
							ifTrue: [ node ]
							ifFalse: [ nil ] ]
				ifFalse: [ answer ] ]
! !

!RBCollectionMessagesToExternalObjectRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCollectionMessagesToExternalObjectRule.st,v 1.4 2012/03/01 19:39:11 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCollectionMessagesToExternalObjectRule.st,v 1.4 2012/03/01 19:39:11 cg Exp $'
!

version_SVN
    ^ 'Id: RBCollectionMessagesToExternalObjectRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
