"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBCollectionProtocolRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBCollectionProtocolRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ 'Uses "do:" instead of "collect:" or "select:"'

    "Modified: / 01-03-2012 / 11:08:47 / cg"
!

rationale
        ^ 'Checks for uses of "<code>do:</code>" method instead of using the "<code>collect:</code>" or "<code>select:</code>" methods. 
The "<code>collect:</code>" and "<code>select:</code>" variants express the source code''s intentions better.'

    "Modified: / 01-03-2012 / 15:04:06 / cg"
! !

!RBCollectionProtocolRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'`@collection do: [:`each | | `@temps | `@.Statements1. `@object add: `@arg. `@.Statements2]'
			'`@collection do: [:`each | | `@temps | 
				`@.Statements1. 
				`@condition ifTrue: [| `@blockTemps | 
						`@.BlockStatements1. 
						`@object add: `each. 
						`@.BlockStatements2]. 
				`@.Statements2]'
			'`@collection do: [:`each | | `@temps | 
				`@.Statements1. 
				`@condition ifFalse: [| `@blockTemps | 
						`@.BlockStatements1. 
						`@object add: `each. 
						`@.BlockStatements2]. 
				`@.Statements2]' )
		do: [ :node :answer | node ]
! !

!RBCollectionProtocolRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCollectionProtocolRule.st,v 1.4 2012/03/01 14:04:19 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBCollectionProtocolRule.st,v 1.4 2012/03/01 14:04:19 cg Exp $'
!

version_SVN
    ^ 'Id: RBCollectionProtocolRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
