"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBContainsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBContainsRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ 'Uses "detect:ifNone:" instead of "contains:"'

    "Modified: / 01-03-2012 / 11:08:28 / cg"
!

rationale
    ^ 'Checks for the code fragment: 
<br><code>&nbsp;&nbsp;(aCollection detect: [:each | ''some condition''] ifNone: [nil]) ~= nil</code>. 
<p>"<code>contains:</code>" can simplify this code to 
<p><code>&nbsp;&nbsp;aCollection contains: [:each | ''some condition'']</code>. 
<p>Not only is the "<code>contains:</code>" variant shorter, it better signifies what the code is doing.'

    "Modified: / 01-03-2012 / 11:19:48 / cg"
! !

!RBContainsRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) isNil'
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) notNil'
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) = nil'
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) == nil'
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) ~= nil'
			'(`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [nil]) ~~ nil'
			'`@object detect: [:`each | | `@temps| `@.Statements] ifNone: [| `@temps1 | `@.Statements2. ^`@anything]' )
		do: [ :node :answer | node ]
! !

!RBContainsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBContainsRule.st,v 1.4 2012/03/01 11:57:59 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBContainsRule.st,v 1.4 2012/03/01 11:57:59 cg Exp $'
!

version_SVN
    ^ 'Id: RBContainsRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
