"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBContainsToIncludesRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Transformation Rules'
!

!RBContainsToIncludesRule class methodsFor:'documentation'!

documentation
"
    cg: search for misuse of contains:, which can be better done with includes:
"
! !

!RBContainsToIncludesRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
    ^ 'Uses "contains:" instead of "includes:"'

    "Modified: / 04-08-2011 / 21:11:32 / cg"
!

rationale
    ^ 'Checks for the code fragment: 
<br>"<code>aCollection contains:[:el | el = something]</code>". 
<br>Can simplify this to "<code>aCollection includes:something</code>", 
or "<code>includesIdentical:</code>" which are faster.'

    "Modified: / 04-08-2011 / 21:15:33 / cg"
! !

!RBContainsToIncludesRule methodsFor:'initialization'!

initialize
    super initialize.
    self matcher 
            matchesAnyOf: #(
                    '`@object contains: [:`el | `el = `@expr]'
                    '`@object contains: [:`el | `el == `@expr]')
            do: [ :node :answer | node ]

    "Modified: / 04-08-2011 / 17:51:04 / cg"
! !

!RBContainsToIncludesRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBContainsToIncludesRule.st,v 1.3 2011/08/04 19:16:40 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBContainsToIncludesRule.st,v 1.3 2011/08/04 19:16:40 cg Exp $'
! !
