"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBDebuggingCodeLeftInMethodsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!


!RBDebuggingCodeLeftInMethodsRule methodsFor:'accessing'!

group
    ^ 'Bugs - Smalltalk/X'

    "Modified: / 25-08-2010 / 14:29:18 / Jan Vrany <enter your email here>"
    "Modified: / 01-03-2012 / 18:56:44 / cg"
!

name
        ^ 'ST/X debugging code left in methods'

    "Modified: / 07-04-2012 / 13:11:12 / cg"
!

rationale
        ^ 'Breakpoints, logging statements, etc. should not be left in production code.
<BR>
Please validate the check results manually: debug code protected by a guarding if 
(which checks for some debug settings)
is perfectly ok.'

    "Modified: / 07-03-2012 / 21:40:33 / cg"
! !

!RBDebuggingCodeLeftInMethodsRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                        '`@any handle:[] do:`@anyBlock'
                        '`@any handle:[:ex | ] do:`@anyBlock'

                        '`@object checkHaltCountExpired'
                        '`@object clearHaltOnce'
                        '`@object decrementAndCheckHaltCount'
                        '`@object decrementHaltCount'
                        '`@object doExpiredHaltCount'
                        '`@object doExpiredHaltCount: `@object1'
                        '`@object doOnlyOnce: `@object1'
                        '#needsWork'
                        '#todo'
                        '#fixme'
                        '#checkme'
                        '`@object needsWork'
                        '`@object fixme'
                        '`@object halt'
                        '`@object halt: `@object1 onCount: `@object2'
                        '`@object haltOnCount: `@object1'
                        '`@object haltOnce'
                        '`@object haltOnce: `@object1'
                        '`@object haltOnceEnabled'
                        '`@object hasHaltCount'
                        '`@object breakPoint: `@id'
                        '`@object breakPoint: `@id info: `@info'
                        'true ifTrue: `@object1'
                        'false ifTrue: `@object1'
                        'true ifTrue: `@object1 ifFalse: `@object2'
                        'false ifTrue: `@object1 ifFalse: `@object2'
                        'true ifFalse: `@object1'
                        'false ifFalse: `@object1'
                        'true ifFalse: `@object1 ifTrue: `@object2'
                        'false ifFalse: `@object1 ifTrue: `@object2'
                        'Transcript `@message: `@object1' )
                do: [ :node :answer | node ]

    "Modified: / 25-08-2010 / 14:30:22 / Jan Vrany <enter your email here>"
    "Modified: / 08-08-2011 / 19:39:37 / cg"
! !

!RBDebuggingCodeLeftInMethodsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBDebuggingCodeLeftInMethodsRule.st,v 1.9 2012/04/07 11:20:47 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBDebuggingCodeLeftInMethodsRule.st,v 1.9 2012/04/07 11:20:47 cg Exp $'
!

version_SVN
    ^ 'Id: RBDebuggingCodeLeftInMethodsRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
