"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBDefinesEqualNotHashRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBDefinesEqualNotHashRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
        ^ 'Defines "=" but not "hash"'

    "Modified: / 07-04-2012 / 13:14:54 / cg"
!

rationale
        ^ 'Checks that all classes that define "=" also define "hash". 
If "hash" is not defined then the instances of the class might not be able to be used in sets since equal element must have the same hash.'

    "Modified: / 07-09-2011 / 05:08:57 / cg"
!

resultClass
	^ ClassEnvironment
! !

!RBDefinesEqualNotHashRule methodsFor:'running'!

checkClass: aContext 
	((aContext selectedClass includesSelector: #=) and: [ (aContext selectedClass includesSelector: #hash) not ]) ifTrue: [ result addClass: aContext selectedClass ]
! !

!RBDefinesEqualNotHashRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBDefinesEqualNotHashRule.st,v 1.3 2012/04/07 11:21:59 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBDefinesEqualNotHashRule.st,v 1.3 2012/04/07 11:21:59 cg Exp $'
!

version_SVN
    ^ 'Id: RBDefinesEqualNotHashRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
