"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBDetectContainsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBDetectContainsRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ 'Uses "do:" instead of "contains:" or "detect:"'

    "Modified: / 01-03-2012 / 11:08:59 / cg"
!

rationale
        ^ 'Checks for uses of the "<code>do:</code>"-method,
 instead of the "<code>contains:</code>" or "<code>detect:</code>" methods.'

    "Modified: / 01-03-2012 / 11:16:23 / cg"
! !

!RBDetectContainsRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'`@collection do: [:`each | | `@temps | 
				`@.Statements1. 
				`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^`each]. 
				`@.Statements2]'
			'`@collection do: [:`each | | `@temps | 
				`@.Statements1. 
				`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^`each]. 
				`@.Statements2]'
			'`@collection do: [:`each | | `@temps | 
				`@.Statements1. 
				`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^true]. 
				`@.Statements2]'
			'`@Collection do: [:`each | | `@temps | 
				`@.Statements1. 
				`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^true]. 
				`@.Statements2]'
			'`@collection do: [:`each | | `@temps | 
				`@.Statements1. 
				`@condition ifFalse: [| `@BlockTemps | `@.BlockStatements1. ^false]. 
				`@.Statements2]'
			'`@collection do: [:`each | | `@temps | 
				`@.Statements1. 
				`@condition ifTrue: [| `@BlockTemps | `@.BlockStatements1.  ^false]. 
				`@.Statements2]' )
		do: [ :node :answer | node ]
! !

!RBDetectContainsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBDetectContainsRule.st,v 1.3 2012/03/01 11:59:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBDetectContainsRule.st,v 1.3 2012/03/01 11:59:43 cg Exp $'
!

version_SVN
    ^ 'Id: RBDetectContainsRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
