"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBEmptyExceptionHandlerRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBEmptyExceptionHandlerRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
        ^ 'Empty exception handler'

    "Modified: / 04-08-2011 / 19:47:11 / cg"
!

rationale
    ^ 'Empty exception handler blocks hide potential bugs. 
The situation should usually be handled in a more robust way
(at least, report the error on the Transcript).'

    "Modified: / 05-05-2012 / 10:56:10 / cg"
! !

!RBEmptyExceptionHandlerRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
            matchesAnyOf: #(
                '`@block 
                    on: `{ :node |
                            | class |  
                            node isVariable 
                                    and: [ (class := Smalltalk classNamed: node name) notNil
                                    and: [ (class includesBehavior: Exception)
                                    and: [ (class includesBehavior: Notification) not ] ] ] }
                    do: [ :`@err | | `@temps | ]'
                '`{ :node |
                            | class |   
                            node isVariable 
                                    and: [ (class := Smalltalk classNamed: node name) notNil
                                    and: [ (class includesBehavior: Exception)
                                    and: [ (class includesBehavior: Notification) not ] ] ] }
                  handle:[ :`@err | | `@temps | ]
                  do:`@block'
            )
            do: [ :node :answer | node ]

    "Modified: / 04-08-2011 / 20:51:35 / cg"
! !

!RBEmptyExceptionHandlerRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEmptyExceptionHandlerRule.st,v 1.3 2012/05/05 08:56:46 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEmptyExceptionHandlerRule.st,v 1.3 2012/05/05 08:56:46 cg Exp $'
!

version_SVN
    ^ 'Id: RBEmptyExceptionHandlerRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
