"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBEmptyOrNilReplaceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!


!RBEmptyOrNilReplaceRule methodsFor:'accessing'!

group
    ^ 'Transformations - Smalltalk/X'

    "Modified: / 01-03-2012 / 18:56:50 / cg"
!

name
    ^ '"isNilOrEmptyCollection" -> "isEmptyOrNil"'

    "Modified: / 04-08-2011 / 19:25:58 / cg"
!

rationale
    ^ 'Transform "<code>isNilOrEmptyCollection</code>" to "<code>isEmptyOrNil</code>".
The later is the ST/X standard method to compare against nil and empty collection in one.
The first is mostly used in the Squeak world.
Use this transformation to help importing code from Squeak.
<br>
(the reverse operation is found in the Squeak transformations group)
'

    "Created: / 04-08-2011 / 19:24:07 / cg"
! !

!RBEmptyOrNilReplaceRule methodsFor:'initialization'!

initialize
    super initialize.
    self rewriteRule 
        replace:'``@object isNilOrEmptyCollection' with:'``@object isEmptyOrNil';
        replace:'``@object notNilOrEmptyCollection' with:'``@object notEmptyOrNil'

    "Modified: / 01-03-2012 / 19:36:11 / cg"
! !

!RBEmptyOrNilReplaceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEmptyOrNilReplaceRule.st,v 1.3 2012/03/01 18:44:10 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEmptyOrNilReplaceRule.st,v 1.3 2012/03/01 18:44:10 cg Exp $'
! !
