"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBEndTrueFalseRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBEndTrueFalseRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
        ^ 'Check for same statements at end of "ifTrue:ifFalse:" blocks'

    "Modified: / 01-03-2012 / 11:57:49 / cg"
!

rationale
        ^ 'Checks for "<code>ifTrue:ifFalse:</code>" blocks that have the same code at the beginning or end. While you might not originally write such code, as it is modified, it is easier to create such code. Instead of having the same code in two places, you should move it outside the blocks.'

    "Modified: / 01-03-2012 / 11:57:40 / cg"
! !

!RBEndTrueFalseRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher
                matchesAnyOf: #(
                        '`@object 
                                ifTrue: [| `@temps1 | `@.Statements1. `.Statement] 
                                ifFalse: [| `@temps2 | `@.Statements2. `.Statement]' 
                        '`@object 
                                ifTrue: [| `@temps1 | `.Statement. `@.Statements1] 
                                ifFalse: [| `@temps2 | `.Statement. `@.Statements2]' 
                        '`@object 
                                ifFalse: [| `@temps1 | `@.Statements1. `.Statement] 
                                ifTrue: [| `@temps2 | `@.Statements2. `.Statement]' 
                        '`@object 
                                ifFalse: [| `@temps1 | `.Statement. `@.Statements1] 
                                ifTrue: [| `@temps2 | `.Statement. `@.Statement2]') 
                do: [ :node :answer | 
                        answer isNil 
                                ifTrue: [
                                        | statement |
                                        statement := node arguments first body statements last.
                                        (statement isVariable and: [ statement = node arguments last body statements last ]) 
                                                ifFalse: [ node ]
                                                ifTrue: [ nil ] ]
                                ifFalse: [ answer ] ]

    "Modified: / 01-03-2012 / 12:00:56 / cg"
! !

!RBEndTrueFalseRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEndTrueFalseRule.st,v 1.2 2012/03/01 12:01:22 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEndTrueFalseRule.st,v 1.2 2012/03/01 12:01:22 cg Exp $'
!

version_SVN
    ^ 'Id: RBEndTrueFalseRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
