"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBEqualNilRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Transformation Rules'
!


!RBEqualNilRule methodsFor:'accessing'!

group
	^ 'Transformations'
!

name
        ^ '"= nil" -> "isNil" AND "~= nil" -> "notNil"'

    "Modified: / 01-03-2012 / 18:58:38 / cg"
!

rationale
    ^ 'Rewrite "<code>expr = nil</code>" into "<code>expr isNil</code>"
 AND 
"<code>expr ~= nil</code>" into "<code>expr notNil</code>".
<P>
There is no common consensus, if the later are actually more readable,
so this is mostly a matter of personal taste.'

    "Created: / 01-03-2012 / 19:01:04 / cg"
! !

!RBEqualNilRule methodsFor:'initialization'!

initialize
	super initialize.
	self rewriteRule
		replace: '``@object = nil' with: '``@object isNil';
		replace: '``@object == nil' with: '``@object isNil';
		replace: '``@object ~= nil' with: '``@object notNil';
		replace: '``@object ~~ nil' with: '``@object notNil'
! !

!RBEqualNilRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEqualNilRule.st,v 1.2 2012/03/01 18:15:25 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEqualNilRule.st,v 1.2 2012/03/01 18:15:25 cg Exp $'
!

version_SVN
    ^ 'Id: RBEqualNilRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
