"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBEquivalentSuperclassMethodsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBEquivalentSuperclassMethodsRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Methods equivalently defined in superclass'
!

rationale
	^ 'Check for methods that are equivalent to their superclass methods. Such methods don''t add anything to the computation and can be removed since the superclass''s method will work just fine.'
! !

!RBEquivalentSuperclassMethodsRule methodsFor:'running'!

checkMethod:aContext 
    |class superclass supertree|

    class := aContext selectedClass.
    (class superclass notNil
        and:[class isMeta not or:[(#(documentation examples copyright) includes:aContext selector) not]]
    ) ifTrue:[
        superclass := class superclass 
                    whichClassIncludesSelector:aContext selector.
        superclass notNil ifTrue:[
            supertree := superclass parseTreeFor:aContext selector.
            (supertree notNil 
                and:[
                    supertree equalTo:aContext parseTree
                        exceptForVariables:supertree allDefinedVariables
                ]) 
                    ifTrue:[
                        self 
                            addClass:aContext selectedClass
                            selector:aContext selector
                            to:result
                    ]
        ]
    ]
! !

!RBEquivalentSuperclassMethodsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEquivalentSuperclassMethodsRule.st,v 1.2 2011/08/05 20:47:56 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBEquivalentSuperclassMethodsRule.st,v 1.2 2011/08/05 20:47:56 stefan Exp $'
!

version_SVN
    ^ 'Id: RBEquivalentSuperclassMethodsRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
