"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBExcessiveArgumentsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBExcessiveArgumentsRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Excessive number of arguments'
!

rationale
        ^ 'Long argument lists can indicate that a new object should be created to wrap the numerous parameters.
<P>
Do not take this check too strict: if you need the args, you need them.
Wrapping extra objects (only to make lint happy) may make the code less readable at the end.'

    "Modified: / 07-03-2012 / 18:12:33 / cg"
! !

!RBExcessiveArgumentsRule methodsFor:'private'!

argumentsCount
	^ 5
! !

!RBExcessiveArgumentsRule methodsFor:'running'!

checkMethod:aContext 
    aContext selector numArgs >= self argumentsCount ifTrue:[
        "cg: for a simple setter, we do not complain (could be a data-structure / model)"
        aContext compiledMethod category = 'accessing' ifFalse: [
            result addClass:aContext selectedClass selector:aContext selector
        ]
    ]

    "Modified: / 05-05-2012 / 11:21:01 / cg"
! !

!RBExcessiveArgumentsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBExcessiveArgumentsRule.st,v 1.5 2012/05/05 09:21:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBExcessiveArgumentsRule.st,v 1.5 2012/05/05 09:21:43 cg Exp $'
!

version_SVN
    ^ 'Id: RBExcessiveArgumentsRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
