"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBExcessiveInheritanceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBExcessiveInheritanceRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Excessive inheritance depth'
!

rationale
	^ 'Deep inheritance is usually a sign of a design flaw. Try to break it down, and reduce the inheritance to something manageable.'
!

resultClass
	^ ClassEnvironment
! !

!RBExcessiveInheritanceRule methodsFor:'private'!

inheritanceDepth
	^ 10
! !

!RBExcessiveInheritanceRule methodsFor:'running'!

checkClass: aContext
	| count current |
	aContext selectedClass isMeta
		ifTrue: [ ^ self ].
	count := 1.
	current := aContext selectedClass.
	[ current isNil ] whileFalse: [
		self inheritanceDepth < count
			ifTrue: [ ^ result addClass: aContext selectedClass ].
		current := current superclass.
		count := count + 1 ]
! !

!RBExcessiveInheritanceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBExcessiveInheritanceRule.st,v 1.1 2011/07/09 17:01:31 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBExcessiveInheritanceRule.st,v 1.1 2011/07/09 17:01:31 vrany Exp $'
!

version_SVN
    ^ 'Id: RBExcessiveInheritanceRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
