"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBExcessiveVariablesRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBExcessiveVariablesRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Excessive number of variables'
!

rationale
        ^ 'Classes that have too many instance or class variables 
could be redesigned to have fewer fields, possibly through some nested object grouping.
SharedPools are ignored by this rule.'

    "Modified: / 07-03-2012 / 18:15:20 / cg"
!

resultClass
	^ ClassEnvironment
! !

!RBExcessiveVariablesRule methodsFor:'private'!

variablesCount
	^ 10
! !

!RBExcessiveVariablesRule methodsFor:'running'!

checkClass: aContext
    |cls|

    cls := aContext selectedClass.
    (cls instVarNames size >= self variablesCount
    or: [ (cls isSharedPool not and:[ cls classVarNames size >= self variablesCount ]) ])
        ifTrue: [ result addClass: cls ]

    "Modified: / 07-03-2012 / 18:14:24 / cg"
! !

!RBExcessiveVariablesRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBExcessiveVariablesRule.st,v 1.2 2012/03/07 17:16:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBExcessiveVariablesRule.st,v 1.2 2012/03/07 17:16:43 cg Exp $'
!

version_SVN
    ^ 'Id: RBExcessiveVariablesRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
