"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBFileBlocksRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBFileBlocksRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Assignment inside unwind blocks should be outside.'
!

rationale
	^ 'Checks assignment to a variable that is the first statement inside the value block that is also used in the unwind block.'
! !

!RBFileBlocksRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'[| `@temps | 
				`var := `@object.  
				`@.statements] 
						ensure: 
							[`var `@messages: `@args]'
			'[| `@temps | 
				`var := `@object.  
				`@.statements] 
						ifCurtailed: 
							[`var `@messages: `@args]' )
		do: [ :node :answer | node ]
! !

!RBFileBlocksRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBFileBlocksRule.st,v 1.1 2011/07/09 16:26:10 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBFileBlocksRule.st,v 1.1 2011/07/09 16:26:10 vrany Exp $'
!

version_SVN
    ^ 'Id: RBFileBlocksRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
