"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBFloatEqualityComparisonRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBFloatEqualityComparisonRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Float equality comparison'
!

rationale
        ^ 'Floating point types are imprecise. 
Using the operators = or ~= might not yield the expected result due to internal rounding differences.'

    "Modified: / 07-03-2012 / 22:13:57 / cg"
! !

!RBFloatEqualityComparisonRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'`{ :node | node isLiteral and: [ node value isFloat ] } = `@expr'
			'`{ :node | node isLiteral and: [ node value isFloat ] } ~= `@expr'
			'`@expr = `{ :node | node isLiteral and: [ node value isFloat ] }'
			'`@expr ~= `{ :node | node isLiteral and: [ node value isFloat ] }' )
		do: [ :node :answer | node ]
! !

!RBFloatEqualityComparisonRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBFloatEqualityComparisonRule.st,v 1.2 2012/03/08 00:59:20 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBFloatEqualityComparisonRule.st,v 1.2 2012/03/08 00:59:20 cg Exp $'
!

version_SVN
    ^ 'Id: RBFloatEqualityComparisonRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
