"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBFloatIdentityComparisonRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBFloatIdentityComparisonRule methodsFor:'accessing'!

group
        ^ 'Bugs'

    "Modified: / 01-03-2012 / 12:30:32 / cg"
!

name
        ^ 'Float identity comparison'

    "Modified: / 01-03-2012 / 12:30:55 / cg"
!

rationale
        ^ 'Floating point numbers should not be compared with
the identity compare operators (== and ~~), because float values
are instantiated on the fly so that two floats may have equal values, 
but are not necessarily identical (the same object).
Use the operators = or ~= instead.
<P>
Be aware, that due to rounding errors, even those operators may fail to
deliver the expected result. Better use an interval check like
"<code>var between:(v-delta) and:(v+delta)</code>".'

    "Modified: / 01-03-2012 / 12:36:40 / cg"
! !

!RBFloatIdentityComparisonRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                        '`{ :node | node isLiteral and: [ node value isFloat ] } == `@expr'
                        '`{ :node | node isLiteral and: [ node value isFloat ] } ~~ `@expr'
                        '`@expr == `{ :node | node isLiteral and: [ node value isFloat ] }'
                        '`@expr ~~ `{ :node | node isLiteral and: [ node value isFloat ] }' )
                do: [ :node :answer | node ]

    "Modified: / 01-03-2012 / 12:30:49 / cg"
! !

!RBFloatIdentityComparisonRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBFloatIdentityComparisonRule.st,v 1.1 2012/03/01 12:05:59 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBFloatIdentityComparisonRule.st,v 1.1 2012/03/01 12:05:59 cg Exp $'
! !
