"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBGuardingClauseRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBGuardingClauseRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
	^ 'Guarding clauses'
!

rationale
        ^ 'Checks for "<code>ifTrue:</code>" or "<code>ifFalse:</code>" conditions at end of methods that have two or more statements inside their blocks. Such code might better represent the true meaning of the code if they returned self instead.'

    "Modified: / 01-03-2012 / 12:42:25 / cg"
! !

!RBGuardingClauseRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyMethodOf: #(
			'`@MethodName: `@args 
				| `@temps | 
				`@.Statements. 
				`@condition ifTrue: [| `@BlockTemps | `.Statement1. `.Statement2. `@.BStatements]' 
			'`@MethodName: `@args 
				| `@temps | 
				`@.Statements. 
				`@condition ifFalse: [| `@BlockTemps | `.Statement1. `.Statement2. `@.BStatements]' )
		do: [ :node :answer | 
			answer isNil 
				ifTrue: [ node body statements last ]
				ifFalse: [ answer ] ]
! !

!RBGuardingClauseRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBGuardingClauseRule.st,v 1.2 2012/03/01 12:06:58 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBGuardingClauseRule.st,v 1.2 2012/03/01 12:06:58 cg Exp $'
!

version_SVN
    ^ 'Id: RBGuardingClauseRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
