"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBIfNilIfNotNilReplaceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!


!RBIfNilIfNotNilReplaceRule methodsFor:'accessing'!

group
    ^ 'Transformations - Smalltalk/X'

    "Modified: / 01-03-2012 / 18:56:56 / cg"
!

name
    ^ 'Use "isNil ifTrue:..." instead of "ifNil:ifNotNil:" (performance hint)'

    "Modified: / 15-09-2011 / 11:34:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-03-2012 / 19:27:54 / cg"
!

rationale
    ^ 'Due to a bug/limitation in the <i>stc</i> compiler, 
<i>stc</i> does not optimize "<code>ifNil:</code>", "<code>ifNotNil:</code>" etc. 
Use "<code>isNil ifTrue:</code>" instead, such code is optimized (inlined) by <i>stc</i> and generates much faster code.'

    "Created: / 04-08-2011 / 19:24:07 / cg"
    "Modified: / 30-01-2012 / 11:22:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-03-2012 / 19:29:01 / cg"
! !

!RBIfNilIfNotNilReplaceRule methodsFor:'initialization'!

initialize
    super initialize.
    self rewriteRule 
        replace:'``@cond ifNil:``@block' with:'``@cond isNil ifTrue:``@block';
        replace:'``@cond ifNotNil:``@block' with:'``@cond notNil ifTrue:``@block';

        replace:'``@cond ifNil:``@block1 ifNotNil:``@block2' with:'``@cond isNil ifTrue:``@block1 ifFalse: ``@block2';
        replace:'``@cond ifNotNil:``@block1 ifNil:``@block2' with:'``@cond isNil ifTrue:``@block2 ifFalse: ``@block1';

        yourself

    "Modified (format): / 04-08-2011 / 19:27:13 / cg"
    "Modified: / 30-01-2012 / 19:02:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!RBIfNilIfNotNilReplaceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBIfNilIfNotNilReplaceRule.st,v 1.5 2012/03/01 18:44:12 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBIfNilIfNotNilReplaceRule.st,v 1.5 2012/03/01 18:44:12 cg Exp $'
! !
