"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBIfTrueBlocksRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBIfTrueBlocksRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Non-blocks in special messages'
!

rationale
        ^ 'Checks for methods that don''t use blocks in the special ifXXX messages. 
Beginners who do not yet understand blocks (the difference between powerful- and powerless brackets)
sometimes write code like: "<code>aBoolean ifTrue: (self doSomething)</code>",
instead of the correct: "<code>aBoolean ifTrue: [self doSomething]</code>".
<p>
Non-block arguments will be always evaluated (care for side effects).'

    "Modified: / 06-03-2012 / 18:47:25 / cg"
! !

!RBIfTrueBlocksRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'`@condition ifTrue: `{:node | node isBlock not} ifFalse: `@block'
			'`@condition ifTrue: `@block ifFalse: `{:node | node isBlock not}'
			'`@condition ifFalse: `{:node | node isBlock not} ifTrue: `@block'
			'`@condition ifFalse: `@block ifTrue: `{:node | node isBlock not}'
			'`@condition ifTrue: `{:node | node isBlock not}'
			'`@condition ifFalse: `{:node | node isBlock not}'
			'`@condition and: `{:node | node isBlock not}'
			'`@condition or: `{:node | node isBlock not}'
			'`{:node | node isBlock not} whileTrue'
			'`{:node | node isBlock not} whileFalse'
			'`{:node | node isBlock not} whileTrue: `@block'
			'`@block whileTrue: `{:node | node isBlock not}'
			'`{:node | node isBlock not} whileFalse: `@block'
			'`@block whileFalse: `{:node | node isBlock not}'
			'`@from to: `@to do: `{:node | node isBlock not}'
			'`@from to: `@to by: `@by do: `{:node | node isBlock not}'
			'`@condition ifNil: `{:node | node isBlock not}'
			'`@condition ifNotNil: `{:node | node isBlock not}'
			'`@condition ifNil: `{:node | node isBlock not} ifNotNil: `@block'
			'`@condition ifNil: `@block ifNotNil: `{:node | node isBlock not}'
			'`@condition ifNotNil: `{:node | node isBlock not} ifNil: `@block'
			'`@condition ifNotNil: `@block ifNil: `{:node | node isBlock not}' )
		do: [ :node :answer | node ]
! !

!RBIfTrueBlocksRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBIfTrueBlocksRule.st,v 1.3 2012/03/06 17:56:53 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBIfTrueBlocksRule.st,v 1.3 2012/03/06 17:56:53 cg Exp $'
!

version_SVN
    ^ 'Id: RBIfTrueBlocksRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
