"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBIfTrueReturnsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBIfTrueReturnsRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ '"ifTrue:/ifFalse:" returns instead of "and:/or:"s'

    "Modified: / 02-03-2012 / 01:06:32 / cg"
!

rationale
        ^ 'Checks for common "<code>ifTrue:</code>" returns that could be simplified using a boolean expression.'

    "Modified: / 02-03-2012 / 01:07:45 / cg"
! !

!RBIfTrueReturnsRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'| `@temps | ``@.Statements. ``@object ifTrue: [^``@value1]. ^``@value2' 
			'| `@temps | ``@.Statements. ``@object ifFalse: [^``@value1]. ^``@value2' )
		do: [ :node :answer | 
			answer isNil 
				ifTrue: [
					| condition |
					condition := (node statements at: node statements size - 1) arguments first 
						body statements 
						last value.	"``@value1"
					((condition isLiteral 
						and: [ #(true false) includes: condition value ]) 
						or: [ 
							condition := 	node statements last value.
							condition isLiteral and: [ #(true false) includes: condition value ] ]) 
								ifTrue: [ node ]
								ifFalse: [ nil ] ]
				ifFalse: [ answer ] ]
! !

!RBIfTrueReturnsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBIfTrueReturnsRule.st,v 1.2 2012/03/02 00:08:35 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBIfTrueReturnsRule.st,v 1.2 2012/03/02 00:08:35 cg Exp $'
!

version_SVN
    ^ 'Id: RBIfTrueReturnsRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
