"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBImplementedNotSentRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBImplementedNotSentRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Methods implemented but not sent'
!

rationale
    ^ 'Check for methods that are never sent. If a method is not sent, it can be removed.
<P>
Be very careful with performs, unloaded classes, packages or customers which already use it.
Also, some methods are only called via UI or menu specifications.
If in doubt, add a breakpoint or mark it as obsolete and leave it in the system for a while
(run a synamic coverage analysis to check if the code is ever called)'

    "Modified: / 01-03-2012 / 11:56:20 / cg"
! !

!RBImplementedNotSentRule methodsFor:'running'!

checkMethod: aContext
        "Check if there are any senders. Furthermore methods with pragmas are likely to be sent through reflection, thus do not report those. Also test methods are sent through reflection, so ignore those as well."

        (aContext uses: aContext selector)
                ifTrue: [ ^ self ].
        (aContext compiledMethod annotations isEmpty)
                ifFalse: [ ^ self ].
        (aContext selectedClass isMeta not
                and: [ aContext includesBehaviorNamed: #TestCase ])
                        ifTrue: [ ^ self ].
        result 
                addClass: aContext selectedClass
                selector: aContext selector

    "Modified: / 05-08-2011 / 13:49:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!RBImplementedNotSentRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBImplementedNotSentRule.st,v 1.8 2012/03/01 10:57:01 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBImplementedNotSentRule.st,v 1.8 2012/03/01 10:57:01 cg Exp $'
!

version_SVN
    ^ 'Id: RBImplementedNotSentRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
