"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBInconsistentMethodClassificationRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBInconsistentMethodClassificationRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Inconsistent method classification'
!

rationale
	^ 'All methods should be put into a protocol (method category) that is equivalent to the one of the superclass.'
!

resultClass
	^ MultiEnvironment
! !

!RBInconsistentMethodClassificationRule methodsFor:'running'!

checkMethod: aContext 
        | selector selectedClass superClass superProtocol ownerProtocol |

        selector := aContext selector.
        selectedClass := aContext selectedClass.
        selectedClass superclass isNil ifFalse: [
            superClass := selectedClass superclass whichClassIncludesSelector: selector.
            superClass isNil ifFalse: [
                superProtocol := superClass whichCategoryIncludesSelector: selector.
                ownerProtocol := selectedClass whichCategoryIncludesSelector: selector.
                "/ cg: the '*' stuff is probably too squeak specific
                (superProtocol isEmptyOrNil or: [ superProtocol first = $* 
                    or: [ ownerProtocol isEmptyOrNil or: [ ownerProtocol first = $* ]]]
                ) ifFalse: [ 
                    superProtocol = ownerProtocol ifFalse: [
                        result 
                            addClass: superClass selector: selector into: superProtocol;
                            addClass: selectedClass selector: selector into: superProtocol ] ] ] ]

    "Modified (comment): / 01-03-2012 / 22:48:02 / cg"
! !

!RBInconsistentMethodClassificationRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBInconsistentMethodClassificationRule.st,v 1.3 2012/03/01 21:50:16 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBInconsistentMethodClassificationRule.st,v 1.3 2012/03/01 21:50:16 cg Exp $'
!

version_SVN
    ^ 'Id: RBInconsistentMethodClassificationRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
