"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBInstVarInSubclassesRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBInstVarInSubclassesRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Instance variables defined in all subclasses'
!

rationale
	^ 'Checks classes for instance variables that are defined in all subclasses. Many times you might want to pull the instance variable up into the class so that all the subclasses do not have to define it.'
!

resultClass
	^ VariableEnvironment
! !

!RBInstVarInSubclassesRule methodsFor:'running'!

checkClass: aContext 
	| subs |
	subs := aContext selectedClass subclasses.
	subs size > 1 ifTrue: 
		[ | sels |
		sels := Bag new.
		subs do: [ :each | sels addAll: each instVarNames ].
		sels asSet do: 
			[ :val | 
			| count |
			count := sels occurrencesOf: val.
			count == subs size ifTrue: 
				[ result 
					addClass: aContext selectedClass
					instanceVariable: val ] ] ]
! !

!RBInstVarInSubclassesRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBInstVarInSubclassesRule.st,v 1.1 2011/07/09 16:53:05 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBInstVarInSubclassesRule.st,v 1.1 2011/07/09 16:53:05 vrany Exp $'
!

version_SVN
    ^ 'Id: RBInstVarInSubclassesRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
