"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBJustSendsSuperRule
	instanceVariableNames:'matcher'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBJustSendsSuperRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Method just sends super message'
!

rationale
	^ 'Check for methods that just forward the message to its superclass. These methods can be removed.'
! !

!RBJustSendsSuperRule methodsFor:'initialization'!

initialize
    super initialize.
    matcher := ParseTreeSearcher justSendsSuper
! !

!RBJustSendsSuperRule methodsFor:'running'!

checkMethod: aContext 
	(aContext parseTree isPrimitive not and: 
		[ matcher 
			executeMethod: aContext parseTree
			initialAnswer: false ]) ifTrue: 
		[ result 
			addClass: aContext selectedClass
			selector: aContext selector ]
! !

!RBJustSendsSuperRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBJustSendsSuperRule.st,v 1.2 2011/08/05 11:06:34 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBJustSendsSuperRule.st,v 1.2 2011/08/05 11:06:34 vrany Exp $'
!

version_SVN
    ^ 'Id: RBJustSendsSuperRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
