"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBLiteralArrayByteValuesRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!

!RBLiteralArrayByteValuesRule class methodsFor:'documentation'!

documentation
"
    cg: checks for bytearray valued arrays
"
! !

!RBLiteralArrayByteValuesRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ 'Literal array contains only byte values integers'

    "Modified: / 04-08-2011 / 21:01:06 / cg"
!

rationale
    ^ 'Literal array contains only small byte valued integers. Could possibly be replaced by a ByteArray literal'

    "Created: / 04-08-2011 / 21:00:24 / cg"
! !

!RBLiteralArrayByteValuesRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matches: '`#literal'
                do: [ :node :answer | 
                        answer isNil 
                                ifTrue: [
                                        (node value class == Array and: [ self isArrayOfBytes: node value ]) 
                                                ifTrue: [ node ]
                                                ifFalse: [ nil ] ]
                                ifFalse: [ answer ] ]

    "Modified: / 04-08-2011 / 21:05:44 / cg"
! !

!RBLiteralArrayByteValuesRule methodsFor:'private'!

isArrayOfBytes: anArray 
    anArray isEmpty ifTrue: [^false].
    ^ anArray 
        conform:[:each | 
            each class == SmallInteger and:[each between:0 and:255]
        ].

    "Created: / 04-08-2011 / 21:02:50 / cg"
! !

!RBLiteralArrayByteValuesRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLiteralArrayByteValuesRule.st,v 1.1 2011/08/04 19:09:15 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLiteralArrayByteValuesRule.st,v 1.1 2011/08/04 19:09:15 cg Exp $'
! !
