"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBLiteralArrayCharactersRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBLiteralArrayCharactersRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
	^ 'Literal array contains only characters'
!

rationale
    ^ 'Literal array contains only characters. Could possibly be replaced by a String literal'

    "Created: / 04-08-2011 / 21:00:24 / cg"
! !

!RBLiteralArrayCharactersRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matches: '`#literal'
		do: [ :node :answer | 
			answer isNil 
				ifTrue: [
					(node value class == Array and: [ self isArrayOfCharacters: node value ]) 
						ifTrue: [ node ]
						ifFalse: [ nil ] ]
				ifFalse: [ answer ] ]
! !

!RBLiteralArrayCharactersRule methodsFor:'private'!

isArrayOfCharacters: anArray 
    anArray isEmpty ifTrue: [^false].
    ^ anArray conform:[:each | (each class == Character) and:[each codePoint <= 255]].

    "Modified: / 04-08-2011 / 21:03:57 / cg"
! !

!RBLiteralArrayCharactersRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLiteralArrayCharactersRule.st,v 1.2 2011/08/04 19:07:42 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLiteralArrayCharactersRule.st,v 1.2 2011/08/04 19:07:42 cg Exp $'
!

version_SVN
    ^ 'Id: RBLiteralArrayCharactersRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
