"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBLiteralArrayContainsCommaRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBLiteralArrayContainsCommaRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Literal array contains a #,'
!

rationale
        ^ 'A possible beginner''s (or Java/JavaScript user''s) mistake,
being used to separating elements of a literal array by "," (comma).
<br>In Smalltalk, elements are to be separated by spaces, and a comma is
treated like #'','' (the symbol, which ahappens to be the concatenation operator).'

    "Created: / 01-03-2012 / 12:28:26 / cg"
! !

!RBLiteralArrayContainsCommaRule methodsFor:'private'!

doesLiteralArrayContainComma: aLiteral 
	aLiteral class == Array ifFalse: [^false].
	(aLiteral includes: #,) ifTrue: [^true].
	^aLiteral inject: false
		into: [:sum :each | sum or: [self doesLiteralArrayContainComma: each]]
! !

!RBLiteralArrayContainsCommaRule methodsFor:'running'!

checkMethod: aContext 
	(aContext compiledMethod allLiterals anySatisfy: [ :each | self doesLiteralArrayContainComma: each ]) 
		ifTrue: [ 
			result 
				addClass: aContext selectedClass
				selector: aContext selector ]
! !

!RBLiteralArrayContainsCommaRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLiteralArrayContainsCommaRule.st,v 1.3 2012/03/01 12:09:32 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLiteralArrayContainsCommaRule.st,v 1.3 2012/03/01 12:09:32 cg Exp $'
!

version_SVN
    ^ 'Id: RBLiteralArrayContainsCommaRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
