"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBLoggingCodeReplaceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!


!RBLoggingCodeReplaceRule methodsFor:'accessing'!

group
    ^ 'Transformations - Smalltalk/X'

    "Modified: / 01-03-2012 / 18:56:58 / cg"
!

name
    ^ 'Use Logger for logging'

    "Modified: / 15-09-2011 / 11:17:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 07-04-2012 / 13:13:36 / cg"
!

rationale
    ^ 'Transform "<code>Transcript show: ''message''</code>" 
and "<code>''message'' infoPrintCR/errorPrintCR</code>" 
 statements to use the new and more flexible "<code>Logger log:</code>"'

    "Created: / 04-08-2011 / 19:24:07 / cg"
    "Modified: / 15-09-2011 / 11:22:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-03-2012 / 19:30:31 / cg"
! !

!RBLoggingCodeReplaceRule methodsFor:'initialization'!

initialize
    super initialize.
    self rewriteRule 
        replace:'``@message infoPrintCR' with:'Logger log:``@message severity: #info';
        replace:'``@message errorPrintCR' with:'Logger log:``@message severity: #error';

        replace:'``@message infoPrint' with:'Logger log:``@message severity: #info';
        replace:'``@message errorPrint' with:'Logger log:``@message severity: #error';

        replace:'Transcript  showCR:``@message' with:'Logger log:``@message severity: #debug';        
        replace:'Transcript  show:``@message' with:'Logger log:``@message severity: #debug'

    "Modified (format): / 04-08-2011 / 19:27:13 / cg"
    "Modified: / 31-01-2012 / 15:26:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!RBLoggingCodeReplaceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLoggingCodeReplaceRule.st,v 1.5 2012/04/07 11:19:54 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLoggingCodeReplaceRule.st,v 1.5 2012/04/07 11:19:54 cg Exp $'
! !
