"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBLongMethodsRule
	instanceVariableNames:'matcher'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBLongMethodsRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Long methods'
!

rationale
    ^ 'Returns all methods that have 
<A INFO="Click to browse this method"
ACTION="doit: UserPreferences current systemBrowserClass
openInClass:%1 selector:#longMethodSize">
<code>%1>>longMethodSize</code></A> 
(%2) number of statements. 
This check counts statements, not lines.
<P>
Notice: this may also complain about initializer methods, where constants are defined.
These are perfectly ok, especially in a shared pool''s initializer.' 
        bindWith:(self class name)
        with:(self longMethodSize)

    "Modified: / 07-03-2012 / 21:45:23 / cg"
! !

!RBLongMethodsRule methodsFor:'initialization'!

initialize
    super initialize.
    matcher := ParseTreeSearcher new.
    matcher matches:'`.Stmt'
        do:[:aNode :answer | 
            (aNode children inject:answer
                into:[:sum :each | matcher executeTree:each initialAnswer:sum ]) + 1
        ].
! !

!RBLongMethodsRule methodsFor:'private'!

longMethodSize
	^ 10
! !

!RBLongMethodsRule methodsFor:'running'!

checkMethod: aContext 
	(matcher executeTree: aContext parseTree initialAnswer: 0) >= self longMethodSize 
		ifTrue: [ result addClass: aContext selectedClass selector: aContext selector ]
! !

!RBLongMethodsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLongMethodsRule.st,v 1.7 2012/03/07 20:45:30 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBLongMethodsRule.st,v 1.7 2012/03/07 20:45:30 cg Exp $'
!

version_SVN
    ^ 'Id: RBLongMethodsRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
