"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBMisplacedReturnInIfTrueIfFalseWithTempsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!


!RBMisplacedReturnInIfTrueIfFalseWithTempsRule methodsFor:'accessing'!

group
    ^ 'Bugs - Smalltalk/X'

    "Modified: / 25-08-2010 / 14:29:23 / Jan Vrany <enter your email here>"
    "Modified: / 01-03-2012 / 18:57:06 / cg"
!

name
        ^ 'Misplaced ^ in ifTrue:ifFalse:'

    "Modified: / 25-08-2010 / 09:58:58 / Jan Vrany <enter your email here>"
!

rationale
        ^ '
Checks for misplaced ^ in ifTrue:ifFalse:. Code like
<pre>
^ boolean ifTrue:[ | t1 t2 | value ] ifFalse: [ | t3 t4 | other ]
</pre>

is not correctly handled by stc (and sometimes even by mcompiler)
and should be rewritten at:
<pre>
boolean ifTrue:[ | t1 t2 | ^value ] ifFalse: [ | t3 t4 | ^other ]
</pre>


'

    "Modified: / 25-08-2010 / 10:08:11 / Jan Vrany <enter your email here>"
! !

!RBMisplacedReturnInIfTrueIfFalseWithTempsRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                        '(`^ @cond 
                                ifTrue:[| `@ttemps| `@.TStatements. ^ `@tretval]
                                ifFalse:[| `@ftemps| `@.FStatements. ^ `@fretval])'
                        '(`^ @cond 
                                ifFalse:[| `@ftemps| `@.FStatements. ^ `@fretval]
                                ifTrue:[| `@ttemps| `@.TStatements. ^ `@tretval])')

                do: [ :node :answer | node ]

    "Modified: / 25-08-2010 / 10:51:02 / Jan Vrany <enter your email here>"
! !

!RBMisplacedReturnInIfTrueIfFalseWithTempsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBMisplacedReturnInIfTrueIfFalseWithTempsRule.st,v 1.4 2012/03/01 18:44:20 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBMisplacedReturnInIfTrueIfFalseWithTempsRule.st,v 1.4 2012/03/01 18:44:20 cg Exp $'
!

version_SVN
    ^ 'Id: RBMisplacedReturnInIfTrueIfFalseWithTempsRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
