"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBMissingSubclassResponsibilityRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBMissingSubclassResponsibilityRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
	^ 'Method defined in all subclasses, but not in superclass'
!

rationale
	^ 'Checks classes for methods that are defined in all subclasses, but not defined in self. Such methods should most likely be defined as subclassResponsibility methods to help document the class. Furthermore, this check helps to find similar code that might be occurring in all the subclasses that should be pulled up into the superclass.'
!

resultClass
	^ MultiEnvironment
! !

!RBMissingSubclassResponsibilityRule methodsFor:'running'!

checkClass: aContext 
	| subs |
	subs := aContext selectedClass subclasses.
	(subs size > 1 and: [ aContext selectedClass isMeta not ]) ifTrue: 
		[ | sels |
		sels := Bag new.
		subs do: [ :each | sels addAll: each selectors ].
		sels asSet do: 
			[ :each | 
			((sels occurrencesOf: each) == subs size and: [ (aContext selectedClass canUnderstand: each) not ]) ifTrue: 
				[ | envName |
				envName := aContext selectedClass name , '>>' , each.
				subs do: 
					[ :subClass | 
					result 
						addClass: subClass
						selector: each
						into: envName ] ] ] ]
! !

!RBMissingSubclassResponsibilityRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBMissingSubclassResponsibilityRule.st,v 1.1 2011/07/09 16:45:30 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBMissingSubclassResponsibilityRule.st,v 1.1 2011/07/09 16:45:30 vrany Exp $'
!

version_SVN
    ^ 'Id: RBMissingSubclassResponsibilityRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
