"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBMissingTranslationsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!


!RBMissingTranslationsRule methodsFor:'accessing'!

group
    ^ 'Bugs - Smalltalk/X'

    "Modified: / 01-03-2012 / 18:57:04 / cg"
!

name
        ^ 'Missing translations in dialogs'

    "Modified: / 07-04-2012 / 13:11:32 / cg"
!

rationale
        ^ 'Literal strings shown to users in dialogs 
(such as "<code>Dialog request:''aMessage''</code>") should be translated using
the resource mechanism. (i.e. rewrite to "<code>Dialog request:(resources string:''aMessage'')</code>").
<P>
This check covers only the most common and obvious such occurrences. 
If in doubt, check string constants. 
Lint does not replace a visual GUI inspection.'

    "Modified: / 06-03-2012 / 18:38:23 / cg"
! !

!RBMissingTranslationsRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher
                matchesAnyOf: #(
                        '`@dialog request: `#label'
                        '`@dialog request: `#label initialAnswer: `#value '
                        '`@dialog confirm: `#label'
                        '`@dialog confirm: `#label default: `#value '
                        '`@dialog confirm: `#label initialAnswer: `#value '
                        '`@dialog confirmWithCancel: `#label'
                        '`@dialog confirmWithCancel: `#label default: `#value '
                        '`@dialog confirmWithCancel: `#label initialAnswer: `#value '
                        '`@dialog information: `#label'
                        '`@dialog warn: `#label'
"/                        '`@menu add: `#label action: `#sym'
"/                        '`@menu add: `#label selector: `#sym arguments: `@stuff'
"/                        '`@menu add: `#label subMenu: `@stuff target: `@targ selector: `#sel argumentList: `@args'
"/                        '`@menu add: `#label subMenu: `@stuff'
"/                        '`@menu add: `#label target: `@targ action: `#sel'
"/                        '`@menu add: `#label target: `@targ selector `#sel argument: `@arg'
"/                        '`@menu add: `#label target: `@targ selector `#sel arguments: `@arg'
"/                        '`@menu add: `#label target: `@targ selector `#sel'
"/                        '`@menu addList: `{ :n | n isLiteral and: [ n value isArray and: [ n value anySatisfy: [ :row | (row isKindOf: Array) and: [ row first isLiteral ] ] ] ] }'
"/                        '`@menu addTitle: `#label updatingSelector: `#sel updateTarget: `@targ'
"/                        '`@menu addTitle: `#label'
"/                        '`@menu addWithLabel: `#label enablement: `#esel action: `#sel'
"/                        '`@menu addWithLabel: `#label enablementSelector: `#esel target: `@targ selector: `#sel argumentList: `@args'
"/                        '`@menu balloonTextForLastItem: `#label'
"/                        '`@menu labels: `#lit lines: `@lines selections: `@sels'
"/                        '`@menu title: `#title' 
                )
                do: [ :node :answer | node ]

    "Modified: / 01-03-2012 / 17:03:00 / cg"
! !

!RBMissingTranslationsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBMissingTranslationsRule.st,v 1.7 2012/04/07 11:20:00 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBMissingTranslationsRule.st,v 1.7 2012/04/07 11:20:00 cg Exp $'
! !
