"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBModifiesCollectionRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBModifiesCollectionRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Modifies collection while iterating over it'
!

rationale
        ^ 'Checks for "<code>remove:</code>" of elements inside of collection 
iteration methods such as "<code>do:</code>". 
These can cause the "<code>do:</code>" method to break since it will walk 
of the end of the collection. 
<p>The common fix for this problem is to copy the collection before iterating over it.'

    "Modified: / 01-03-2012 / 12:13:36 / cg"
! !

!RBModifiesCollectionRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'`@object do: [:`each | | `@temps | ``@.Statements]' 
			'`@object collect: [:`each | | `@temps | ``@.Statements]' 
			'`@object select: [:`each | | `@temps | ``@.Statements]' 
			'`@object reject: [:`each | | `@temps | ``@.Statements]' 
			'`@object inject: `@value into: [:`sum :`each | | `@temps | ``@.Statements]')
		do: [ :node :answer | 
			answer isNil 
				ifTrue: [
					(self modifiesTree: node receiver in: node arguments last) 
						ifTrue: [ node ]
						ifFalse: [ nil ] ]
				ifFalse: [ answer ] ]
! !

!RBModifiesCollectionRule methodsFor:'private'!

modifiesTree:aCollectionTree in:aParseTree 
    |notifier args|

    notifier := ParseTreeSearcher new.
    args := Array with:(RBPatternVariableNode named:'`@object').
    notifier matchesAnyTreeOf:(#( #add: #addAll: #remove: #removeAll: ) 
                collect:[:each | 
                    RBMessageNode 
                        receiver:aCollectionTree
                        selector:each
                        arguments:args
                ])
        do:[:aNode :answer | true ].
    ^ notifier executeTree:aParseTree initialAnswer:false
! !

!RBModifiesCollectionRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBModifiesCollectionRule.st,v 1.2 2012/03/01 12:16:07 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBModifiesCollectionRule.st,v 1.2 2012/03/01 12:16:07 cg Exp $'
!

version_SVN
    ^ 'Id: RBModifiesCollectionRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
