"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBNilOrEmptyCollectionReplaceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Squeak'
!


!RBNilOrEmptyCollectionReplaceRule methodsFor:'accessing'!

group
    ^ 'Transformations - Squeak'

    "Modified: / 01-03-2012 / 19:32:51 / cg"
!

name
    ^ '"isEmptyOrNil" -> "isNilOrEmptyCollection"'

    "Modified: / 01-03-2012 / 19:33:04 / cg"
!

rationale
    ^ 'Transform "<code>isEmptyOrNil</code>" to "<code>isNilOrEmptyCollection</code>".
The later is the Squeak standard method to compare against nil and empty collection in one.
The first is used in the ST/X world.
Use this transformation to help exporting code to Squeak.
<br>
(the reverse operation is found in the Smalltalk/X transformations group)
'

    "Created: / 04-08-2011 / 19:24:07 / cg"
! !

!RBNilOrEmptyCollectionReplaceRule methodsFor:'initialization'!

initialize
    super initialize.
    self rewriteRule 
        replace:'``@object isEmptyOrNil ' with:'``@object isNilOrEmptyCollection';
        replace:'``@object notEmptyOrNil ' with:'``@object notNilOrEmptyCollection'

    "Modified: / 01-03-2012 / 19:35:53 / cg"
! !

!RBNilOrEmptyCollectionReplaceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBNilOrEmptyCollectionReplaceRule.st,v 1.1 2012/03/01 18:44:38 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBNilOrEmptyCollectionReplaceRule.st,v 1.1 2012/03/01 18:44:38 cg Exp $'
! !
