"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBNotEliminationRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Transformation Rules'
!


!RBNotEliminationRule methodsFor:'accessing'!

group
	^ 'Transformations'
!

name
        ^ 'Eliminate unnecessary nots'

    "Modified: / 01-03-2012 / 19:07:31 / cg"
!

rationale
    ^ 'Eliminate unnecessary "<code>not</code>" messages. 
Also convert some "<code>ifFalse:</code>" forms into corresponding positive 
"<code>ifTrue:</code>" conditional constructs.
<p>
For example "<code>expr isEmpty ifFalse:[...]</code>" is rewritten
to "<code>expr notEmpty ifTrue:[...]</code>", which is easier to read and understand.'

    "Created: / 01-03-2012 / 19:11:22 / cg"
! !

!RBNotEliminationRule methodsFor:'initialization'!

initialize
        super initialize.
        self rewriteRule
                replace: '``@object not not' with: '``@object';
                replace: '``@object not ifTrue: ``@block' with: '``@object ifFalse: ``@block';
                replace: '``@object not ifFalse: ``@block' with: '``@object ifTrue: ``@block';
                "/ begin added by cg: - we found positive if-conditions easier to read
                replace: '``@object notNil ifFalse: ``@block' with: '``@object isNil ifTrue: ``@block';
                replace: '``@object isNil ifFalse: ``@block' with: '``@object notNil ifTrue: ``@block';
                replace: '``@object notEmpty ifFalse: ``@block' with: '``@object isEmpty ifTrue: ``@block';
                replace: '``@object isEmpty ifFalse: ``@block' with: '``@object notEmpty ifTrue: ``@block';
                replace: '``@object notEmptyOrNil ifFalse: ``@block' with: '``@object isEmptyOrNil ifTrue: ``@block';
                replace: '``@object isEmptyOrNil ifFalse: ``@block' with: '``@object notEmptyOrNil ifTrue: ``@block';
                "/ end added by cg:
                replace: '``@collection select: [:`each | | `@temps | ``@.Statements. ``@object not]'
                        with: '``@collection reject: [:`each | | `@temps | ``@.Statements. ``@object]';
                replace: '``@collection reject: [:`each | | `@temps | ``@.Statements. ``@object not]'
                        with: '``@collection select: [:`each | | `@temps | ``@.Statements. ``@object]';
                replace: '[| `@temps | ``@.Statements. ``@object not] whileTrue: ``@block'
                        with: '[| `@temps | ``@.Statements. ``@object] whileFalse: ``@block';
                replace: '[| `@temps | ``@.Statements. ``@object not] whileFalse: ``@block'
                        with: '[| `@temps | ``@.Statements. ``@object] whileTrue: ``@block';
                replace: '[| `@temps | ``@.Statements. ``@object not] whileTrue'
                        with: '[| `@temps | ``@.Statements. ``@object] whileFalse';
                replace: '[| `@temps | ``@.Statements. ``@object not] whileFalse'
                        with: '[| `@temps | ``@.Statements. ``@object] whileTrue';
                replace: '(``@a <= ``@b) not' with: '``@a > ``@b';
                replace: '(``@a < ``@b) not' with: '``@a >= ``@b';
                replace: '(``@a = ``@b) not' with: '``@a ~= ``@b';
                replace: '(``@a == ``@b) not' with: '``@a ~~ ``@b';
                replace: '(``@a ~= ``@b) not' with: '``@a = ``@b';
                replace: '(``@a ~~ ``@b) not' with: '``@a == ``@b';
                replace: '(``@a >= ``@b) not' with: '``@a < ``@b';
                replace: '(``@a > ``@b) not' with: '``@a <= ``@b'

    "Modified: / 01-03-2012 / 20:22:56 / cg"
! !

!RBNotEliminationRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBNotEliminationRule.st,v 1.4 2012/03/01 19:28:10 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBNotEliminationRule.st,v 1.4 2012/03/01 19:28:10 cg Exp $'
!

version_SVN
    ^ 'Id: RBNotEliminationRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
