"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBOnlyReadOrWrittenRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBOnlyReadOrWrittenRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Instance variables not read AND written'
!

rationale
    ^ self appendVariableNamesFromResultToRationale:
        'Checks that all variables are both read and written. 
If an instance variable is only read, you can replace all of the reads with nil, 
since it couldn''t have been assigned a value. 
<BR>
If the variable is only written, then we don''t need to store the result,
since we never use it. 
<P>
This check may not work for some data model classes which use the 
"<code>instVarAt:</code>" and "<code>instVarAt:put:</code>"
messagess to get/set instance variables by slot index.'

    "Modified: / 07-03-2012 / 18:28:20 / cg"
!

resultClass
	^ VariableEnvironment
! !

!RBOnlyReadOrWrittenRule methodsFor:'running'!

checkClass: aContext 
	| allSubclasses |
	allSubclasses := aContext selectedClass withAllSubclasses.
	aContext selectedClass instVarNames do: 
		[ :each | 
		| isRead isWritten |
		isRead := false.
		isWritten := false.
		allSubclasses 
			detect: 
				[ :class | 
				isRead ifFalse: [ isRead := (class whichSelectorsRead: each) isEmpty not ].
				isWritten ifFalse: [ isWritten := (class whichSelectorsAssign: each) isEmpty not ].
				isRead & isWritten ]
			ifNone: 
				[ result 
					addClass: aContext selectedClass
					instanceVariable: each ] ]
! !

!RBOnlyReadOrWrittenRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBOnlyReadOrWrittenRule.st,v 1.2 2012/03/07 17:29:19 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBOnlyReadOrWrittenRule.st,v 1.2 2012/03/07 17:29:19 cg Exp $'
!

version_SVN
    ^ 'Id: RBOnlyReadOrWrittenRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
