"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBOnlyReadOrWrittenTemporaryRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBOnlyReadOrWrittenTemporaryRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Temporary variables not read AND written'
!

rationale
	^ 'Checks that all temporary variables are both read and written. If an temporary variable is only read, you can replace all of the reads with nil, since it couldn''t have been assigned a value. If the variable is only written, then we don''t need to store the result since we never use it.'
!

severity
	^ #information
! !

!RBOnlyReadOrWrittenTemporaryRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher
		matches: '| `@temps | ``@.stmts'
		do: [ :sequence :answer |
			answer isNil
				ifFalse: [ answer ]
				ifTrue: [
					sequence temporaries
						detect: [ :temp |
							| isRead isWritten |
							isRead := false.
							isWritten := false.
							sequence statements do: [ :statement | 
								statement nodesDo: [ :node |
									(node isVariable and: [ node name = temp name ]) ifTrue: [
										isRead := isRead or: [ node isUsed ].
										isWritten := isWritten or: [ node isWrite ] ] ] ].
							(isRead and: [ isWritten ]) not ]
						ifNone: [ nil ] ] ]
! !

!RBOnlyReadOrWrittenTemporaryRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBOnlyReadOrWrittenTemporaryRule.st,v 1.1 2011/08/04 18:22:30 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBOnlyReadOrWrittenTemporaryRule.st,v 1.1 2011/08/04 18:22:30 vrany Exp $'
! !
