"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBOnlyReadOrWrittenVariableRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBOnlyReadOrWrittenVariableRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Instance variables not read AND written'
!

rationale
	^ 'Checks that all instance variables are both read and written. If an instance variable is only read, you can replace all of the reads with nil, since it couldn''t have been assigned a value. If the variable is only written, then we don''t need to store the result since we never use it. This check does not work for the data model classes since they use the instVarAt:put: messages to set instance variables.'
!

resultClass
	^ VariableEnvironment
!

severity
	^ #information
! !

!RBOnlyReadOrWrittenVariableRule methodsFor:'running'!

checkClass: aContext 
        | allSubclasses |
        allSubclasses := aContext selectedClass withAllSubclasses.
        aContext selectedClass instVarNames do: [ :each | 
                | isRead isWritten |
                isRead := false.
                isWritten := false.
                allSubclasses 
                        detect: [ :class | 
                                isRead ifFalse: [ isRead := (class whichSelectorsRead: each) isEmpty not ].
                                isWritten ifFalse: [ isWritten := (class whichSelectorsAssign: each) isEmpty not ].
                                isRead and: [ isWritten ] ]
                        ifNone: [
                                result 
                                        addClass: aContext selectedClass
                                        instanceVariable: each ] ]

    "Modified: / 05-08-2011 / 11:37:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!RBOnlyReadOrWrittenVariableRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBOnlyReadOrWrittenVariableRule.st,v 1.2 2011/08/05 11:11:43 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBOnlyReadOrWrittenVariableRule.st,v 1.2 2011/08/05 11:11:43 vrany Exp $'
! !
