"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBOverridesSpecialMessageRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBOverridesSpecialMessageRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'Overrides a "special" message'
!

rationale
	^ 'Checks that a class does not override a message that is essential to the base system. For example, if you override the #class method from object, you are likely to crash your image.'
! !

!RBOverridesSpecialMessageRule methodsFor:'private'!

classShouldNotOverride
	^ #( #== #~~ #class #basicAt: #basicAt:put: #basicSize #identityHash )
!

metaclassShouldNotOverride
	^ #( #basicNew #basicNew #class #comment #name )
! !

!RBOverridesSpecialMessageRule methodsFor:'running'!

checkClass:aContext 
    |selectors|

    selectors := aContext selectedClass isMeta ifTrue:[
                self metaclassShouldNotOverride
            ] ifFalse:[
                self classShouldNotOverride
            ].
    selectors do:[:each | 
        (aContext selectedClass superclass notNil 
            and:[
                (aContext selectedClass superclass canUnderstand:each) 
                    and:[ (aContext selectedClass includesSelector:each) ]
            ]) 
                ifTrue:[
                    self 
                        addClass:aContext selectedClass
                        selector:each
                        to:result
                ]
    ]
! !

!RBOverridesSpecialMessageRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBOverridesSpecialMessageRule.st,v 1.1 2011/07/09 17:19:57 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBOverridesSpecialMessageRule.st,v 1.1 2011/07/09 17:19:57 vrany Exp $'
!

version_SVN
    ^ 'Id: RBOverridesSpecialMessageRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
