"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBPlatformDependentUserInteractionRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Squeak'
!


!RBPlatformDependentUserInteractionRule methodsFor:'accessing'!

group
        ^ 'Bugs - Squeak'

    "Modified: / 01-03-2012 / 18:57:30 / cg"
!

name
	^ 'Platform dependent user interaction'
!

rationale
	^ 'The method uses platform dependent user interactions.'
! !

!RBPlatformDependentUserInteractionRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'FillInTheBlank multiLineRequest: `@object1 centerAt: `@object2 initialAnswer: `@object3 answerHeight: `@object4'
			'FillInTheBlank request: `@object1 initialAnswer: `@object2 centerAt: `@object3'
			'FillInTheBlank request: `@object1 initialAnswer: `@object2'
			'FillInTheBlank request: `@object1'
			'FillInTheBlank requestPassword: `@object1'
			'PopUpMenu confirm: `@object1 orCancel: `@object2'
			'PopUpMenu confirm: `@object1 trueChoice: `@object2 falseChoice: `@object3'
			'PopUpMenu confirm: `@object1'
			'PopUpMenu inform: `@object1'
			'PopUpMenu initialize'
			'PopUpMenu labelArray: `@object1 lines: `@object2'
			'PopUpMenu labelArray: `@object1'
			'PopUpMenu labels: `@object1 lines: `@object2'
			'PopUpMenu labels: `@object1'
			'PopUpMenu withCaption: `@object1 chooseFrom: `@object2'
			'SelectionMenu fromArray: `@object1'
			'SelectionMenu labelList: `@object1 lines: `@object2 selections: `@object3'
			'SelectionMenu labelList: `@object1 lines: `@object2'
			'SelectionMenu labelList: `@object1 selections: `@object2'
			'SelectionMenu labelList: `@object1'
			'SelectionMenu labels: `@object1 lines: `@object2 selections: `@object3'
			'SelectionMenu labels: `@object1 lines: `@object2'
			'SelectionMenu labels: `@object1 selections: `@object2'
			'SelectionMenu selections: `@object1 lines: `@object2'
			'SelectionMenu selections: `@object1' )
		do: [ :node :answer | node ]
! !

!RBPlatformDependentUserInteractionRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBPlatformDependentUserInteractionRule.st,v 1.3 2012/03/01 18:44:41 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBPlatformDependentUserInteractionRule.st,v 1.3 2012/03/01 18:44:41 cg Exp $'
!

version_SVN
    ^ 'Id: RBPlatformDependentUserInteractionRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
