"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBRefersToClassRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBRefersToClassRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Refers to class name instead of "self class"'
!

rationale
        ^ 'Checks for classes that have their class name directly in the source instead of "self class". 
The self class variant allows you to create subclasses without needing to redefine that method.
Notice, that sometimes an explicit check is ok, to detect abstract class uses.'

    "Modified: / 12-02-2012 / 09:23:48 / cg"
! !

!RBRefersToClassRule methodsFor:'running'!

checkClass:aContext 
    |sels className|

    className := aContext selectedClass theNonMetaclass name.
    sels := aContext selectedClass 
                whichSelectorsReferTo:(Smalltalk associationAt:className).
    sels do:[:each | 
        self 
            addClass:aContext selectedClass
            selector:each
            to:result
    ].
    sels isEmpty ifFalse:[
        result addSearchString:className
    ]
! !

!RBRefersToClassRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBRefersToClassRule.st,v 1.2 2012/02/12 18:03:23 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBRefersToClassRule.st,v 1.2 2012/02/12 18:03:23 cg Exp $'
!

version_SVN
    ^ 'Id: RBRefersToClassRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
