"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBReturnsIfTrueRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBReturnsIfTrueRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
        ^ 'Returns value of "ifTrue:/ifFalse:" without "ifFalse:/ifTrue:" block'

    "Modified: / 01-03-2012 / 12:21:25 / cg"
!

rationale
        ^ 'Check for methods that return the value of an "<code>ifTrue:</code>" 
or "<code>ifFalse:</code>" message. 
These statements return nil when the block is not executed,
which may not be the author''s intention.'

    "Modified: / 01-03-2012 / 12:22:05 / cg"
! !

!RBReturnsIfTrueRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'^`@condition ifTrue: [| `@temps | `@.statements]'
			'^`@condition ifFalse: [| `@temps | `@.statements]' )
		do: [ :node :answer | node ]
! !

!RBReturnsIfTrueRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBReturnsIfTrueRule.st,v 1.2 2012/03/01 12:45:51 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBReturnsIfTrueRule.st,v 1.2 2012/03/01 12:45:51 cg Exp $'
!

version_SVN
    ^ 'Id: RBReturnsIfTrueRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
