"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBSendsDeprecatedMethodToGlobalRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Squeak'
!


!RBSendsDeprecatedMethodToGlobalRule methodsFor:'accessing'!

group
        ^ 'Bugs - Squeak'

    "Modified: / 01-03-2012 / 18:57:31 / cg"
!

name
	^ 'Sends a deprecated message to a known global'
! !

!RBSendsDeprecatedMethodToGlobalRule methodsFor:'initialization'!

initialize
    |nav patterns pattern wellKnownGlobals|

    super initialize.
    patterns := OrderedCollection new.
    wellKnownGlobals := IdentityDictionary new.
    Smalltalk 
        keysAndValuesDo:[:k :v | 
            v isBehavior ifFalse:[
                (wellKnownGlobals at:v class ifAbsentPut:[ Set new ]) add:k
            ]
        ].
    "
    #( #deprecated: 'deprecated:explanation:' 'deprecated:block:' ) do:[:sym | 
        (nav allCallsOn:sym) do:[:mr | 
            mr classIsMeta ifTrue:[
                mr actualClass 
                    withAllSubclassesDo:[:cls | 
                        patterns add:(String 
                                    streamContents:[:s | 
                                        s
                                            nextPutAll:cls theNonMetaclass name;
                                            nextPutAll:(self genericPatternForSelector:mr methodSymbol)
                                    ])
                    ]
            ] ifFalse:[
                wellKnownGlobals 
                    keysAndValuesDo:[:gcls :gnames | 
                        (gcls includesBehavior:mr actualClass) ifTrue:[
                            gnames do:[:gname | 
                                pattern := String 
                                            streamContents:[:s | 
                                                s nextPutAll:gname.
                                                s nextPutAll:(self genericPatternForSelector:mr methodSymbol)
                                            ]
                            ].
                            patterns add:pattern
                        ]
                    ]
            ]
        ]
    ].
    "
    patterns
        add:'self beep: `@object1';
        add:'self beep'.
    self matcher matchesAnyOf:patterns do:[:node :answer | node ]
! !

!RBSendsDeprecatedMethodToGlobalRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSendsDeprecatedMethodToGlobalRule.st,v 1.3 2012/03/01 18:44:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSendsDeprecatedMethodToGlobalRule.st,v 1.3 2012/03/01 18:44:43 cg Exp $'
!

version_SVN
    ^ 'Id: RBSendsDeprecatedMethodToGlobalRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
