"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBSentNotImplementedRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBSentNotImplementedRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'Messages sent but not implemented'
!

rationale
	^ 'Checks for messages that are sent by a method, but no class in the system implements such a message. Further checks if messages sent to self or super exist in the hierarchy, since these can be statically typed. Reported methods will certainly cause a doesNotUnderstand: message when they are executed.'
! !

!RBSentNotImplementedRule methodsFor:'running'!

checkMethod: aContext 
	| message |
	message := aContext messages 
		detect: [ :each | (aContext implements: each) not ]
		ifNone: 
			[ aContext superMessages 
				detect: 
					[ :each | 
					aContext selectedClass superclass isNil or: [ (aContext selectedClass superclass canUnderstand: each) not ] ]
				ifNone: 
					[ aContext selfMessages 
						detect: [ :each | (aContext selectedClass canUnderstand: each) not ]
						ifNone: [ nil ] ] ].
	message notNil ifTrue: 
		[ result addSearchString: message.
		result 
			addClass: aContext selectedClass
			selector: aContext selector ]
! !

!RBSentNotImplementedRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSentNotImplementedRule.st,v 1.2 2011/08/05 11:07:58 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSentNotImplementedRule.st,v 1.2 2011/08/05 11:07:58 vrany Exp $'
!

version_SVN
    ^ 'Id: RBSentNotImplementedRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
