"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBSizeCheckRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBSizeCheckRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
	^ 'Unnecessary size check'
!

rationale
        ^ 'Check for code that checks that a collection is non-empty before sending it an iteration message 
(e.g., "<code>do:</code>", "<code>collect:</code>", etc.). 
Since the collection iteration messages work for empty collections, 
we do not need to clutter up our method with the extra size check.
(actually, due to an extra message send, it may even make the execution slightly slower)'

    "Modified: / 07-04-2012 / 13:19:15 / cg"
! !

!RBSizeCheckRule methodsFor:'initialization'!

initialize
	| patterns |
	super initialize.
	patterns := OrderedCollection new.
	patterns addAll: (self selectors
		collect: [ :each | '`@object size > 0 ifTrue: [`@object' , (self genericPatternForSelector: each) , '. `@.Statements2]' ]).
	patterns addAll: (self selectors
		collect: [ :each | '`@object isEmpty ifFalse: [`@object' , (self genericPatternForSelector: each) , '. `@.Statements2]' ]).
	patterns addAll: (self selectors
		collect: [ :each | '`@object notEmpty ifTrue: [`@object' , (self genericPatternForSelector: each) , '. `@.Statements2]' ]).
	patterns addAll: (self selectors
		collect: [ :each | '`@object size = 0 ifFalse: [`@object' , (self genericPatternForSelector: each) , '. `@.Statements2]' ]).
	self matcher
		matchesAnyOf: patterns
		do: [ :node :answer | node ]
! !

!RBSizeCheckRule methodsFor:'private'!

selectors
	^ #( collect: do: reject: select: )
! !

!RBSizeCheckRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSizeCheckRule.st,v 1.3 2012/04/07 11:19:28 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSizeCheckRule.st,v 1.3 2012/04/07 11:19:28 cg Exp $'
!

version_SVN
    ^ 'Id: RBSizeCheckRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
