"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBStringConcatenationRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBStringConcatenationRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'String concatenation instead of streams'
!

rationale
        ^ 'Check for string concatenation inside some iteration message. 
Since string concatenation is O(n^2), it is better to use a stream which has O(n) behavior,
Assuming that n is large enough. 
<p>
Be careful: for short strings and a small number of strings, the overhead of stream-creation
may easily outweight the square behavior.'

    "Modified: / 02-03-2012 / 00:52:17 / cg"
! !

!RBStringConcatenationRule methodsFor:'initialization'!

initialize
    |concatenationMatcher|

    super initialize.
    concatenationMatcher := ParseTreeSearcher new.
    concatenationMatcher matches:'`@receiver , `@argument'
        do:[:node :answer | true ].
    self matcher 
        matchesAnyOf:#( '``@collection do: [:`each | | `@temps | ``@.Statements]'
             '``@collection do: [:`each | | `@temps | ``@.Statements] separatedBy: [| `@temps1 | ``@.Statements1]'
             '``@number to: ``@endNumber do: [:`i | | `@temps | ``@.Statements]'
             '``@collection detect: [:`each | | `@temps | ``@.Statements]'
             '``@collection detect: [:`each | | `@temps | ``@.Statements] ifNone: [| `@temps1 | ``@.Statements1]'
             '``@collection select: [:`each | | `@temps | ``@.Statements]'
             '``@collection inject: ``@value into: [:`each | | `@temps | ``@.Statements]' )
        do:[:node :answer | 
            answer isNil ifTrue:[
                (node arguments 
                    detect:[:each | 
                        each isBlock 
                            and:[ concatenationMatcher executeTree:each initialAnswer:false ]
                    ]
                    ifNone:[ nil ]) notNil ifTrue:[
                    node
                ] ifFalse:[ nil ]
            ] ifFalse:[ answer ]
        ]
! !

!RBStringConcatenationRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBStringConcatenationRule.st,v 1.3 2012/03/01 23:53:15 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBStringConcatenationRule.st,v 1.3 2012/03/01 23:53:15 cg Exp $'
!

version_SVN
    ^ 'Id: RBStringConcatenationRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
