"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBSubclassResponsibilityNotDefinedRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBSubclassResponsibilityNotDefinedRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'Subclass responsibility not defined'
!

rationale
        ^ 'Checks that all subclassResponsibility methods are defined in all leaf sub-classes.'

    "Modified: / 07-03-2012 / 21:10:37 / cg"
! !

!RBSubclassResponsibilityNotDefinedRule methodsFor:'running'!

checkClass:aContext 
    |allMethodsWithSubclassResponsibility subclasses|

    subclasses := aContext selectedClass withAllSubclasses.

    allMethodsWithSubclassResponsibility := 
        aContext selectedClass methodDictionary values select:[:each | 
            (each sends:#subclassResponsibility or:#subclassResponsibility:)].

    allMethodsWithSubclassResponsibility do:[:each |
        (subclasses 
            contains:[:class | 
                class subclasses isEmpty    "so its a leaf class" 
                and:[ (class whichClassIncludesSelector:each selector) == aContext selectedClass ]
        ]) ifTrue:[
            self 
                addClass:aContext selectedClass
                selector:each selector
                to:result
        ]
    ]

    "Modified: / 07-03-2012 / 21:09:49 / cg"
! !

!RBSubclassResponsibilityNotDefinedRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSubclassResponsibilityNotDefinedRule.st,v 1.3 2012/03/07 20:10:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSubclassResponsibilityNotDefinedRule.st,v 1.3 2012/03/07 20:10:43 cg Exp $'
!

version_SVN
    ^ 'Id: RBSubclassResponsibilityNotDefinedRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
