"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBSuperSendsNewRule
	instanceVariableNames:'matcher'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Squeak'
!


!RBSuperSendsNewRule methodsFor:'accessing'!

group
        ^ 'Bugs - Squeak'

    "Modified: / 01-03-2012 / 18:57:34 / cg"
!

name
	^ 'Sends super new initialize'
!

rationale
    ^ 'Finds code which leads to double initialization (because super new already calls the initialize).'

    "Created: / 04-08-2011 / 17:21:23 / cg"
! !

!RBSuperSendsNewRule methodsFor:'initialization'!

initialize
    super initialize.
    matcher := ParseTreeSearcher new.
    matcher matchesAnyOf:#( 'super new initialize'
             '(super new: `@expr) initialize'
             'self new initialize'
             '(self new: `@expr) initialize' )
        do:[:answer :node | true ].
! !

!RBSuperSendsNewRule methodsFor:'running'!

checkMethod: aContext 
	aContext selectedClass isMeta 
		ifTrue: [ ^ self ].
	(matcher executeTree: aContext parseTree initialAnswer: false) 
		ifTrue: [ result addClass: aContext selectedClass selector: aContext selector ]
! !

!RBSuperSendsNewRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSuperSendsNewRule.st,v 1.5 2012/03/01 18:44:45 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBSuperSendsNewRule.st,v 1.5 2012/03/01 18:44:45 cg Exp $'
!

version_SVN
    ^ 'Id: RBSuperSendsNewRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
