"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBTempVarOverridesInstVarRule
	instanceVariableNames:'matcher varName vars'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBTempVarOverridesInstVarRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Instance variable overridden by temporary variable'
!

rationale
	^ 'Finds methods that have block are temporary variables that override an instance variable. This causes problems if you want to use the instance variable inside the method.'
! !

!RBTempVarOverridesInstVarRule methodsFor:'initialization'!

initialize
    super initialize.
    matcher := ParseTreeSearcher new.
    matcher matchesArgument:'`var'
        do:[:aNode :answer | 
            answer 
                or:[
                    varName := aNode name.
                    vars includes:varName
                ]
        ]
! !

!RBTempVarOverridesInstVarRule methodsFor:'running'!

checkMethod: aContext 
	vars := aContext instVarNames.
	(matcher 
		executeTree: aContext parseTree
		initialAnswer: false) ifTrue: 
		[ result 
			addClass: aContext selectedClass
			selector: aContext selector.
		result addSearchString: varName ]
! !

!RBTempVarOverridesInstVarRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBTempVarOverridesInstVarRule.st,v 1.2 2011/08/05 11:22:41 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBTempVarOverridesInstVarRule.st,v 1.2 2011/08/05 11:22:41 vrany Exp $'
!

version_SVN
    ^ 'Id: RBTempVarOverridesInstVarRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
