"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBTempsReadBeforeWrittenRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBTempsReadBeforeWrittenRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Temporaries read before written'
!

rationale
        ^ 'Checks that all temporaries are assigned before they are used. 
This can help find possible paths through the code where a variable might be unassigned when it is used.
<P>
Please validate the outcome of this check manually: 
sometimes (especially if conditional blocks are involved),
this rule barks at absolutely correct code.'

    "Modified: / 01-03-2012 / 12:20:03 / cg"
! !

!RBTempsReadBeforeWrittenRule methodsFor:'running'!

checkMethod: aContext 
	(RBReadBeforeWrittenTester variablesReadBeforeWrittenIn: aContext parseTree) do: 
		[ :each | 
		result 
			addClass: aContext selectedClass
			selector: aContext selector.
		result addSearchString: each ]
! !

!RBTempsReadBeforeWrittenRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBTempsReadBeforeWrittenRule.st,v 1.4 2012/03/01 12:46:04 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBTempsReadBeforeWrittenRule.st,v 1.4 2012/03/01 12:46:04 cg Exp $'
!

version_SVN
    ^ 'Id: RBTempsReadBeforeWrittenRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
