"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBThreeElementPointRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBThreeElementPointRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
        ^ 'Possible three element point (e.g., "x @ y + q @ r")'

    "Modified: / 01-03-2012 / 12:03:15 / cg"
!

rationale
        ^ 'Checks arithmetic statements for possible three element points 
(i.e., a point that has another point in its x or y part).'

    "Modified: / 01-03-2012 / 12:03:10 / cg"
! !

!RBThreeElementPointRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher
		matches: '``@x @ ``@y'
		do: [ :node :answer | 
			answer isNil 
				ifTrue: [
					| current |
					current := node parent.
					[ current isNil or: [ current isMessage and: [ current selector = #@ or: [ current selector isInfix not ] ] ] ] 
						whileFalse: [ current := current parent ].
					(current isNil or: [ current isMessage and: [ current selector isInfix not ] ]) 
						ifTrue: [ nil ]
						ifFalse: [ node ] ]
				ifFalse: [ answer ] ]
! !

!RBThreeElementPointRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBThreeElementPointRule.st,v 1.2 2012/03/01 12:46:09 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBThreeElementPointRule.st,v 1.2 2012/03/01 12:46:09 cg Exp $'
!

version_SVN
    ^ 'Id: RBThreeElementPointRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
