"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBToDoCollectRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBToDoCollectRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ 'Use "to:do:" instead of "collect:"'

    "Modified: / 02-03-2012 / 01:37:44 / cg"
!

rationale
        ^ 'Checks for uses of "<code>to:do:</code>" 
when a "<code>collect:</code>" should be used to construct a collection of results.'

    "Created: / 02-03-2012 / 01:38:21 / cg"
! !

!RBToDoCollectRule methodsFor:'initialization'!

initialize
        super initialize.
        self matcher 
                matchesAnyOf: #(
                        '| `@temps1 |
                        `@.Stmts1.
                        `collection := Array new: `@size.
                        `@.Stmts2.
                        1 to: `@size do: 
                                        [:`i | 
                                        | `@Btemps2 | 
                                        `@.BStmts1. 
                                        `collection at: `i put: `@obj.
                                        `@.BStmt2].
                        `@.Stmts3'

                        '| `@temps1 |
                        `@.Stmts1.
                        `collection := Array new: `@size.
                        `@.Stmts2.
                        1 to: `collection size do: 
                                        [:`i | 
                                        | `@Btemps2 | 
                                        `@.BStmts1. 
                                        `collection at: `i put: `@obj.
                                        `@.BStmt2].
                        `@.Stmts3' )
                do: [ :node :answer | node ]

    "Modified: / 02-03-2012 / 01:34:40 / cg"
! !

!RBToDoCollectRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBToDoCollectRule.st,v 1.2 2012/03/02 00:45:51 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBToDoCollectRule.st,v 1.2 2012/03/02 00:45:51 cg Exp $'
!

version_SVN
    ^ 'Id: RBToDoCollectRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
