"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBToDoRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBToDoRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ 'Uses "to:do:" instead of "do:", "with:do:" or "timesRepeat:"'

    "Modified: / 01-03-2012 / 11:27:01 / cg"
!

rationale
        ^ 'Checks for uses of "<code>to:do:</code>" 
when a "<code>do:</code>", "<code>with:do:</code>" or "<code>timesRepeat:</code>" should be used.'

    "Modified: / 01-03-2012 / 11:15:23 / cg"
! !

!RBToDoRule methodsFor:'initialization'!

initialize
    super initialize.
    self matcher 
        matches:'1 to: ``@object size do: [:`each | | `@temps | `@.Statements]'
        do:[:node :answer | 
            answer isNil ifTrue:[
                |varName variableMatcher|

                varName := node arguments last arguments first.
                variableMatcher := ParseTreeSearcher new.
                variableMatcher matchesTree:varName
                    do:[:nod :ans | ans and:[ nod parent isMessage and:[ nod parent selector = #at: ] ] ].
                (variableMatcher executeTree:node arguments last body initialAnswer:true) ifTrue:[
                    node
                ] ifFalse:[ nil ]
            ] ifFalse:[ answer ]
        ]
! !

!RBToDoRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBToDoRule.st,v 1.3 2012/03/01 12:46:12 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBToDoRule.st,v 1.3 2012/03/01 12:46:12 cg Exp $'
!

version_SVN
    ^ 'Id: RBToDoRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
