"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBLintRule subclass:#RBTransformationRule
	instanceVariableNames:'rewriteRule builder class'
	classVariableNames:'RecursiveSelfRule'
	poolDictionaries:''
	category:'Refactory-Lint'
!


!RBTransformationRule class methodsFor:'initialization'!

initialize
    "/ now done lazy
    "/    self initializeRecursiveSelfRule

    "Modified: / 14-07-2011 / 00:05:52 / cg"
!

initializeRecursiveSelfRule
        RecursiveSelfRule := ParseTreeSearcher new.
        RecursiveSelfRule 
                matchesAnyMethodOf: #(
                        '`@methodName: `@args | `@temps | self `@methodName: `@args1' 
                        '`@methodName: `@args | `@temps | ^ self `@methodName: `@args1')
                do: [ :node :answer | true ].
        ^ RecursiveSelfRule
! !

!RBTransformationRule class methodsFor:'accessing'!

recursiveSelfRule
    RecursiveSelfRule isNil ifTrue:[
        self initializeRecursiveSelfRule
    ].

    ^ RecursiveSelfRule

    "Modified: / 14-07-2011 / 00:04:51 / cg"
! !

!RBTransformationRule class methodsFor:'testing'!

isVisible
	^ self name ~= #RBTransformationRule
! !

!RBTransformationRule methodsFor:'accessing'!

changes
    ^builder notNil ifTrue:[builder changes] ifFalse:[#()]

    "Modified: / 31-01-2012 / 22:21:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

problemCount
	^ builder problemCount
!

result
	| environment |
	environment := ParseTreeEnvironment new.
	environment matcher: self rewriteRule.
	environment label: self name.
	self changes do: [ :change |
		(change isKindOf: AddMethodChange)
			ifTrue: [ environment addClass: change changeClass selector: change selector ] ].
	^ environment
!

rewriteRule
	^ rewriteRule
!

scope

    ^'method check'
! !

!RBTransformationRule methodsFor:'initialization'!

initialize
        super initialize.
        rewriteRule := ParseTreeRewriter new
! !

!RBTransformationRule methodsFor:'private'!

failedClassesInto:aStream 
    self result isNil ifFalse:[
        self result classesInto:aStream.
    ].

    "Created: / 10-01-2009 / 15:14:23 / Jiri Bazant <bazanj2@fel.cvut.cz>"
    "Modified: / 13-01-2009 / 16:53:28 / Jiri Bazant <bazanj2@fel.cvut.cz>"
!

failedMethodsInto:aStream 
    self result isNil ifFalse:[
        self result methodsInto:aStream.
    ].

    "Created: / 08-01-2009 / 09:46:48 / Jiri Bazant <bazanj2@fel.cvut.cz>"
    "Modified: / 12-01-2009 / 23:19:05 / Jiri Bazant <bazanj2@fel.cvut.cz>"
! !

!RBTransformationRule methodsFor:'running'!

checkMethod: aContext 
    (self rewriteRule canMatchMethod: aContext compiledMethod) ifFalse: [ 
        ^ self 
    ].
    class := aContext selectedClass.
    (self rewriteRule executeTree: aContext parseTree) ifTrue: [
        (self class recursiveSelfRule executeTree: rewriteRule tree initialAnswer: false) ifFalse: [ 
            builder compile: rewriteRule tree formattedCode in: class classified: aContext protocol 
        ] 
    ]

    "Modified: / 16-02-2012 / 16:39:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

resetResult
	builder := CompositeRefactoryChange named: self name
! !

!RBTransformationRule methodsFor:'testing'!

hasConflicts
	^ true
!

isEmpty
	^ builder changes isEmpty
! !

!RBTransformationRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBTransformationRule.st,v 1.5 2012/02/16 18:00:00 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBTransformationRule.st,v 1.5 2012/02/16 18:00:00 vrany Exp $'
!

version_SVN
    ^ 'Id: RBTransformationRule.st 20 2010-02-05 14:10:34Z vranyj1 '
! !

RBTransformationRule initialize!
