"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBTranslateLiteralsInDialogsReplaceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Smalltalk/X'
!


!RBTranslateLiteralsInDialogsReplaceRule methodsFor:'accessing'!

group
    ^ 'Transformations - Smalltalk/X'

    "Modified: / 01-03-2012 / 19:42:09 / cg"
!

name
    ^ 'Add translations to strings in dialogs (ST/X specific)'

    "Modified: / 01-03-2012 / 19:39:38 / cg"
!

rationale
        ^ 'Add code to perform national language translation on literal strings
passed to dialog boxes.
Literal strings shown to users in dialogs 
(such as "<code>Dialog request:''aMessage''</code>" are translated using
the resource mechanism. (i.e. rewritten to "<code>Dialog request:(resources string:''aMessage'')</code>").
<P>
This transformation covers only the most common and obvious such occurrences. 
If in doubt, check string constants.'

    "Created: / 01-03-2012 / 19:39:24 / cg"
! !

!RBTranslateLiteralsInDialogsReplaceRule methodsFor:'initialization'!

initialize
        super initialize.
        self rewriteRule
                replace: '`@dialog request: `#label'
                        with: '`@dialog request: (resources string: `#label)';
                replace: '`@dialog request: `#label initialAnswer: `#def'
                        with: '`@dialog request: (resources string: `#label) initialAnswer: `#def';
                replace: '`@dialog request: `#label default: `#def'
                        with: '`@dialog request: (resources string: `#label) default: `#def';
                replace: '`@dialog confirm: `#label '
                        with: '`@dialog confirm: (resources string: `#label) ';
                replace: '`@dialog information: `#label '
                        with: '`@dialog information: (resources string: `#label)';
                replace: '`@dialog warn: `#label '
                        with: '`@dialog warn: (resources string: `#label)'

    "Modified: / 01-03-2012 / 19:41:59 / cg"
! !

!RBTranslateLiteralsInDialogsReplaceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBTranslateLiteralsInDialogsReplaceRule.st,v 1.1 2012/03/01 19:43:44 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBTranslateLiteralsInDialogsReplaceRule.st,v 1.1 2012/03/01 19:43:44 cg Exp $'
! !
