"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBUnclassifiedMethodsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBUnclassifiedMethodsRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Unclassified methods'
!

rationale
	^ 'All methods should be put into a protocol (method category) for better readability.'
! !

!RBUnclassifiedMethodsRule methodsFor:'running'!

checkMethod: aContext 

    | category |
    category := aContext compiledMethod category.
    
    (#( 'As yet unclassified' 
        'as yet unclassified' 
        '* As yet unclassified *'
    ) includes: category) ifTrue:[
        result
            addClass: aContext selectedClass
            selector: aContext selector 
    ]

    "Modified: / 05-08-2011 / 11:17:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!RBUnclassifiedMethodsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnclassifiedMethodsRule.st,v 1.2 2011/08/05 11:27:26 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnclassifiedMethodsRule.st,v 1.2 2011/08/05 11:27:26 vrany Exp $'
!

version_SVN
    ^ 'Id: RBUnclassifiedMethodsRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
