"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBUncommonMessageSendRule
	instanceVariableNames:'literalNames'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBUncommonMessageSendRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Uncommon message send'
!

rationale
        ^ 'Sending messages with a reserved name ("self" or "super"), a common literal ("true", "false",...) or with an uppercase selector name are usually bugs, 
           introduced through missing statement separators.'

    "Modified: / 07-04-2012 / 12:59:09 / cg"
!

test
    "JV: Don't commit this, stc won't compile it then"
    "/^ self self

    "Created: / 07-04-2012 / 12:43:54 / cg"
! !

!RBUncommonMessageSendRule methodsFor:'initialization'!

initialize
        super initialize.
        literalNames := #( #self #super #thisContext #true #false #nil #here )
                asIdentitySet

    "Modified: / 07-04-2012 / 12:43:29 / cg"
! !

!RBUncommonMessageSendRule methodsFor:'running'!

checkMethod: aContext 
        aContext allMessages "messages" do: [ :each |
                (each isEmpty or: [ each first isUppercase or: [ literalNames includes: each ] ]) ifTrue: [
                        result 
                                addClass: aContext selectedClass
                                selector: aContext selector.
                        result addSearchString: each ] ]

    "Modified: / 07-04-2012 / 12:56:27 / cg"
! !

!RBUncommonMessageSendRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUncommonMessageSendRule.st,v 1.4 2012/04/09 10:29:49 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUncommonMessageSendRule.st,v 1.4 2012/04/09 10:29:49 vrany Exp $'
!

version_SVN
    ^ 'Id: RBUncommonMessageSendRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
