"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBUndeclaredReferenceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBUndeclaredReferenceRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'References an undeclared variable'
!

rationale
        ^ 'Checks for references to a variable in the Undeclared dictionary. 
If you remove a variable from a class that is accessed by a method, you will create an undeclared variable reference for those methods that accessed the variable.'

    "Modified: / 09-09-2011 / 05:07:17 / cg"
! !

!RBUndeclaredReferenceRule methodsFor:'running'!

checkMethod: aContext 
        | undeclared globals |        
        undeclared := Undeclared ? #() 
                detect: [ :each |
                        (aContext uses: each)
                        and: [ (aContext compiledMethod refersToLiteral: each)
                        and: [ globals isNil ifTrue:[
                                globals := aContext compiledMethod usedGlobals.
                               ].
                               globals includes:each  ]] ]
                ifNone: [ nil ].
        undeclared notNil ifTrue: [ 
                result addSearchString: undeclared.
                result 
                        addClass: aContext selectedClass
                        selector: aContext selector ]

    "Modified: / 05-08-2011 / 13:38:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-09-2011 / 05:12:06 / cg"
! !

!RBUndeclaredReferenceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUndeclaredReferenceRule.st,v 1.4 2011/09/09 03:13:09 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUndeclaredReferenceRule.st,v 1.4 2011/09/09 03:13:09 cg Exp $'
!

version_SVN
    ^ 'Id: RBUndeclaredReferenceRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
