"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBTransformationRule subclass:#RBUnderscoreAssignmentRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Transformation Rules'
!


!RBUnderscoreAssignmentRule methodsFor:'accessing'!

group
	^ 'Transformations'
!

name
	^ 'Underscore assignements should be avoided'
!

rationale
        ^ 'The use of the underscore character for 
assignment is a historic leftover from old ST80 times, 
when a back-arrow glyph was shown for that ascii-code.
Now, an underscore is shown, which makes assignment look ugly.
This rewrites the code to use the modern "<code>:=</code>".'

    "Created: / 01-03-2012 / 19:22:04 / cg"
! !

!RBUnderscoreAssignmentRule methodsFor:'initialization'!

initialize
	super initialize.
	self rewriteRule 
		replace: '`var := ``@object' with: '`var := ``@object'
		when: [ :node | node assignmentOperator = '_' ]
! !

!RBUnderscoreAssignmentRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnderscoreAssignmentRule.st,v 1.2 2012/03/01 18:44:58 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnderscoreAssignmentRule.st,v 1.2 2012/03/01 18:44:58 cg Exp $'
!

version_SVN
    ^ 'Id: RBUnderscoreAssignmentRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
