"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBUnnecessaryAssignmentRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBUnnecessaryAssignmentRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Unnecessary assignment to a temporary variable'
!

rationale
    |t|

    ^ (t := 'Check for unnecessary assignment to a temporary variable 
in a return expression. (i.e. "<code>^ (foo := expr)</code>"')

    "Created: / 01-03-2012 / 11:37:16 / cg"
! !

!RBUnnecessaryAssignmentRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matches: '^`{:aNode | aNode isAssignment and: [(aNode whoDefines: aNode variable name) notNil]}'
		do: [ :node :answer | node ]
! !

!RBUnnecessaryAssignmentRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnnecessaryAssignmentRule.st,v 1.2 2012/03/01 12:46:18 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnnecessaryAssignmentRule.st,v 1.2 2012/03/01 12:46:18 cg Exp $'
!

version_SVN
    ^ 'Id: RBUnnecessaryAssignmentRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
