"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBUnoptimizedAndOrRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBUnoptimizedAndOrRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Uses "(a and: [b]) and: [c]" instead of "a and: [b and: [c]]"'
!

rationale
        ^ 'Check for constructs like 
"<code>(a and: [b]) and: [c]</code>",
which is better written as: "<code>a and: [b and: [c]]</code>".'

    "Created: / 01-03-2012 / 11:33:45 / cg"
! !

!RBUnoptimizedAndOrRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'(`@a and: `@b) and: `@c'
			'(`@a or: `@b) or: `@c' )
		do: [ :node :answer | node ]
! !

!RBUnoptimizedAndOrRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnoptimizedAndOrRule.st,v 1.2 2012/03/01 12:46:21 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnoptimizedAndOrRule.st,v 1.2 2012/03/01 12:46:21 cg Exp $'
!

version_SVN
    ^ 'Id: RBUnoptimizedAndOrRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
