"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBUnoptimizedToDoRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBUnoptimizedToDoRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
        ^ 'Uses "(to:)do:" instead of "to:do:"'

    "Modified: / 01-03-2012 / 11:28:51 / cg"
!

rationale
        ^ 'Check for constructs like 
"<code>(b to:e) do:[...]</code>",
which can be replaced by: "<code>b to:e do:[...]</code>".
<br>The later does not create a temporary intervall object and is also possibly faster
in the execution.'

    "Created: / 01-03-2012 / 11:30:40 / cg"
! !

!RBUnoptimizedToDoRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matches: '(`@a to: `@b) do: `@c'
		do: [ :node :answer | node ]
! !

!RBUnoptimizedToDoRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnoptimizedToDoRule.st,v 1.2 2012/03/01 12:46:25 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnoptimizedToDoRule.st,v 1.2 2012/03/01 12:46:25 cg Exp $'
!

version_SVN
    ^ 'Id: RBUnoptimizedToDoRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
