"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBUnpackagedCodeRule
	instanceVariableNames:'packages package'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBUnpackagedCodeRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
	^ 'Unpackaged code'
!

rationale
        ^ 'Code that is not contained in a package is not versioned 
and cannot be brought easily into a different image.'

    "Modified: / 17-04-2010 / 11:46:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 01-03-2012 / 12:19:02 / cg"
! !

!RBUnpackagedCodeRule methodsFor:'private'!

packageSatisfying: aBlock
	"Answer the first package satisfying aBlock or nil. This method assumes that it is likely that the last matching package matches the given condition again and thus it tries that one first."

	(package notNil and: [ aBlock value: package ])
		ifTrue: [ ^ package ].
	packages do: [ :info |
		(aBlock value: info)
			ifTrue: [ ^ package := info ] ].
	^ nil
! !

!RBUnpackagedCodeRule methodsFor:'running'!

checkClass: aContext

    | cls |

    cls := aContext selectedClass.

    cls package == PackageId noProjectID ifTrue:
        [ self result addClass: cls].

    cls methodDictionary do:
        [:mth|
        mth package == PackageId noProjectID ifTrue:
            [self result addClass: cls selector: mth selector]].

    cls theMetaclass methodDictionary do:
        [:mth|
        mth package == PackageId noProjectID ifTrue:
            [self result addClass: cls theMetaclass selector: mth selector]].
!

checkMethod: aContext

    (aContext compiledMethod package == PackageId noProjectID)
        ifTrue: [ self result addClass: aContext selectedClass selector: aContext selector ]
! !

!RBUnpackagedCodeRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnpackagedCodeRule.st,v 1.2 2012/03/01 12:46:28 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnpackagedCodeRule.st,v 1.2 2012/03/01 12:46:28 cg Exp $'
!

version_SVN
    ^ 'Id: RBUnpackagedCodeRule.st 21 2010-04-17 09:46:57Z vranyj1 '
! !
