"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBUnreferencedVariablesRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBUnreferencedVariablesRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Variables not referenced'
!

rationale
    ^ self appendVariableNamesFromResultToRationale:
'Check for variables not referenced. 
If a variable is not used in a class, it should be moved down or deleted.
Ocasionally, it is useful to provide a variable in an abstract class for all of its subclasses.'.

    "Modified: / 17-02-2012 / 08:53:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 07-03-2012 / 18:26:36 / cg"
!

resultClass
	^ VariableEnvironment
! !

!RBUnreferencedVariablesRule methodsFor:'running'!

checkClass: aContext 
	| allSubclasses |
	allSubclasses := aContext selectedClass withAllSubclasses.
	aContext selectedClass instVarNames do: 
		[ :each | 
		allSubclasses 
			detect: [ :class | (class whichSelectorsAccess: each) isEmpty not ]
			ifNone: 
				[ result 
					addClass: aContext selectedClass
					instanceVariable: each ] ].
	aContext selectedClass isMeta ifFalse: 
		[ aContext selectedClass classPool associationsDo: 
			[ :each | 
			(aContext uses: each) ifFalse: 
				[ result 
					addClass: aContext selectedClass
					classVariable: each key ] ] ]
! !

!RBUnreferencedVariablesRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnreferencedVariablesRule.st,v 1.6 2012/03/07 17:29:27 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUnreferencedVariablesRule.st,v 1.6 2012/03/07 17:29:27 cg Exp $'
!

version_SVN
    ^ 'Id: RBUnreferencedVariablesRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
