"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBUsesAddRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBUsesAddRule methodsFor:'accessing'!

group
	^ 'Possible bugs'
!

name
        ^ 'Uses the result of an "add:" message'

    "Modified: / 01-03-2012 / 11:27:22 / cg"
!

rationale
        ^ 'Check for possible uses of the result returned by an "<code>add:</code>" or "<code>addAll:</code>" messages. 
These messages return their arguments not the receiver. 
As a result, may uses of the results are wrong.'

    "Modified: / 01-03-2012 / 12:17:42 / cg"
! !

!RBUsesAddRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matches: '`{:node | node isMessage and: [(node selector == #add: or: [node selector == #addAll:]) and: [node isDirectlyUsed]]}'
		do: [ :node :answer | node ]
! !

!RBUsesAddRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUsesAddRule.st,v 1.3 2012/03/01 12:46:31 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUsesAddRule.st,v 1.3 2012/03/01 12:46:31 cg Exp $'
!

version_SVN
    ^ 'Id: RBUsesAddRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
