"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBUsesTrueRule
	instanceVariableNames:'trueBinding falseBinding'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBUsesTrueRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'Uses True/False instead of true/false'
!

rationale
	^ 'Checks for uses of the classes True and False instead of the objects true and false.'
! !

!RBUsesTrueRule methodsFor:'initialization'!

initialize
	super initialize.
	trueBinding := Smalltalk associationAt: #True.
	falseBinding := Smalltalk associationAt: #False
! !

!RBUsesTrueRule methodsFor:'running'!

checkMethod: aContext 
	| method |
	method := aContext compiledMethod.
	((method refersToLiteral: trueBinding) or: [ method refersToLiteral: falseBinding ]) ifTrue: 
		[ result 
			addClass: aContext selectedClass
			selector: aContext selector.
		result searchStrings: #('True' 'False' ) ]
! !

!RBUsesTrueRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUsesTrueRule.st,v 1.2 2011/08/05 11:09:20 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUsesTrueRule.st,v 1.2 2011/08/05 11:09:20 vrany Exp $'
!

version_SVN
    ^ 'Id: RBUsesTrueRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
