"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBUtilityMethodsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBUtilityMethodsRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Utility methods'
!

rationale
        ^ 'List methods that have one or more arguments and do no refer to self 
or an instance variable. 
These methods might be better defined in some other class or as class methods,
to allow for better reuse.'

    "Modified: / 01-03-2012 / 11:32:17 / cg"
! !

!RBUtilityMethodsRule methodsFor:'private'!

subclassOf: aClass overrides: aSelector 
	^(aClass subclasses detect: 
			[:each | 
			(each includesSelector: aSelector)
				or: [self subclassOf: each overrides: aSelector]]
		ifNone: [nil]) notNil
!

utilityProtocols
	^ #('*utilit*')
! !

!RBUtilityMethodsRule methodsFor:'running'!

checkMethod: aContext 
	(aContext selectedClass isMeta or: 
		[ aContext selector numArgs == 0 or: 
			[ (aContext protocols 
				detect: 
					[ :each | 
					(self utilityProtocols 
						detect: [ :protocol | protocol match: each ]
						ifNone: [  ]) notNil ]
				ifNone: [  ]) notNil ] ]) ifFalse: 
		[ (self 
			subclassOf: aContext selectedClass
			overrides: aContext selector) ifFalse: 
			[ (aContext superMessages isEmpty and: [ aContext selfMessages isEmpty ]) ifTrue: 
				[ (aContext selectedClass allInstVarNames , aContext selectedClass allClassVarNames asArray , #('self' ) 
					detect: [ :each | aContext parseTree references: each ]
					ifNone: [  ]) isNil ifTrue: 
					[ result 
						addClass: aContext selectedClass
						selector: aContext selector ] ] ] ]
! !

!RBUtilityMethodsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUtilityMethodsRule.st,v 1.3 2012/03/01 12:46:33 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBUtilityMethodsRule.st,v 1.3 2012/03/01 12:46:33 cg Exp $'
!

version_SVN
    ^ 'Id: RBUtilityMethodsRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
