"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBVariableAssignedLiteralRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBVariableAssignedLiteralRule methodsFor:'accessing'!

group
	^ 'Miscellaneous'
!

name
	^ 'Variable is only assigned a single literal value'
!

rationale
	^ 'If a variable is only assigned a single literal value then that variable is either nil or that literal value. If the variable is always initialized with that literal value, then you could replace each variable reference with a message send to get the value. If the variable can also be nil, then you might want to replace that variable with another that stores true or false depending on whether the old variable had been assigned.'
!

resultClass
	^ VariableEnvironment
! !

!RBVariableAssignedLiteralRule methodsFor:'running'!

checkClass: aContext 
        | allSubclasses |
        allSubclasses := aContext selectedClass withAllSubclasses.
        aContext selectedClass instVarNames do: 
                [ :each | 
                | defClass selector |
                (allSubclasses 
                        inject: 0
                        into: 
                                [ :sum :class | 
                                | sels |
                                sels := class whichSelectorsAssign: each.
                                sels size == 1 ifTrue: 
                                        [ selector := sels asArray first.
                                        defClass := class ].
                                sum + sels size ]) == 1 ifTrue: 
                        [ | tree searcher |
                        searcher := ParseTreeSearcher new.
                        searcher 
                                matches: each , ' := ``@object'
                                do: [ :aNode :answer | answer isNil and: [ aNode value isLiteral ] ].
                        tree := defClass parseTreeFor: selector.
                        tree notNil ifTrue: 
                                [ (searcher 
                                        executeTree: tree
                                        initialAnswer: nil) == true ifTrue: 
                                        [ result 
                                                addClass: aContext selectedClass
                                                instanceVariable: each ] ] ] ]
! !

!RBVariableAssignedLiteralRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBVariableAssignedLiteralRule.st,v 1.1 2011/07/09 17:13:37 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBVariableAssignedLiteralRule.st,v 1.1 2011/07/09 17:13:37 vrany Exp $'
!

version_SVN
    ^ 'Id: RBVariableAssignedLiteralRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
