"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBVariableNotDefinedRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBVariableNotDefinedRule methodsFor:'accessing'!

group
	^ 'Bugs'
!

name
	^ 'Variable used, but not defined anywhere'
!

rationale
        ^ 'This check is similar to the "References an undeclared variable" check, 
but it looks for variables that are not defined in the class or in the undeclared dictionary. 
You probably had to work hard to get your code into this state.'

    "Modified: / 01-03-2012 / 21:37:32 / cg"
! !

!RBVariableNotDefinedRule methodsFor:'running'!

checkMethod: aContext 
	aContext compiledMethod literals do: 
		[ :literal | 
		(literal isVariableBinding and: [ literal key notNil ]) ifTrue: 
			[ ((Smalltalk globals 
				associationAt: literal key
				ifAbsent: [  ]) == literal or: 
				[ (Undeclared 
					associationAt: literal key
					ifAbsent: [  ]) == literal ]) ifFalse: 
				[ (aContext selectedClass bindingOf: literal key) == literal ifFalse: 
					[ result 
						addClass: aContext selectedClass
						selector: aContext selector.
					result addSearchString: literal key ] ] ] ]
! !

!RBVariableNotDefinedRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBVariableNotDefinedRule.st,v 1.3 2012/03/01 20:39:01 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBVariableNotDefinedRule.st,v 1.3 2012/03/01 20:39:01 cg Exp $'
!

version_SVN
    ^ 'Id: RBVariableNotDefinedRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
