"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBBlockLintRule subclass:#RBVariableReferencedOnceRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Block Rules'
!


!RBVariableReferencedOnceRule methodsFor:'accessing'!

group
	^ 'Unnecessary code'
!

name
	^ 'Variable referenced in only one method and always assigned first'
!

rationale
	^ 'Checks for instance variables that might better be defined as temporary variables. If an instance variable is only used in one method and it is always assigned before it is used, then that method could define that variable as a temporary variable of the method instead (assuming that the method is not recursive).'
! !

!RBVariableReferencedOnceRule methodsFor:'running'!

checkClass:aContext 
    |allSubclasses|

    allSubclasses := aContext selectedClass withAllSubclasses.
    aContext selectedClass instVarNames do:[:each | 
        |defClass selector|

        (allSubclasses inject:0
            into:[:sum :class | 
                |sels|

                sels := class whichSelectorsAccess:each.
                sels size == 1 ifTrue:[
                    selector := sels asArray first.
                    defClass := class
                ].
                sum + sels size
            ]) 
                == 1 
                ifTrue:[
                    |tree|

                    tree := defClass parseTreeFor:selector.
                    tree notNil ifTrue:[
                        (RBReadBeforeWrittenTester isVariable:each writtenBeforeReadIn:tree) ifTrue:[
                            self 
                                addClass:defClass
                                selector:selector
                                to:result.
                            result addSearchString:each
                        ]
                    ]
                ]
    ]
! !

!RBVariableReferencedOnceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBVariableReferencedOnceRule.st,v 1.1 2011/07/09 16:59:58 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBVariableReferencedOnceRule.st,v 1.1 2011/07/09 16:59:58 vrany Exp $'
!

version_SVN
    ^ 'Id: RBVariableReferencedOnceRule.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
