"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

RBParseTreeLintRule subclass:#RBWhileTrueRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint-Parse-tree Rules'
!


!RBWhileTrueRule methodsFor:'accessing'!

group
	^ 'Intention revealing'
!

name
        ^ 'Uses "whileTrue:" instead of "to:do:"'

    "Modified: / 01-03-2012 / 11:27:40 / cg"
!

rationale
        ^ 'Checks for uses of "<code>whileTrue:</code>" 
when the shorter "<code>to:do:</code>" would work.'

    "Modified: / 01-03-2012 / 11:28:02 / cg"
! !

!RBWhileTrueRule methodsFor:'initialization'!

initialize
	super initialize.
	self matcher 
		matchesAnyOf: #(
			'| `@temps | 
			`@.Statements1. 
			[`index <= `@stop] 
				whileTrue: 
					[| `@blockTemps | 
					`@.BlockStmts1. 
					`index := `index + 1].
			`@.Statements2'
			'| `@temps | 
			`@.Statements1. 
			[`index < `@stop] 
				whileTrue: 
					[| `@blockTemps | 
					`@.BlockStmts1. 
					`index := `index + 1].
			`@.Statements2'
			'| `@temps | 
			`@.Statements1. 
			[`index >= `@stop] 
				whileTrue: 
					[| `@blockTemps | 
					`@.BlockStmts1. 
					`index := `index - 1].
			`@.Statements2'
			'| `@temps | 
			`@.Statements1. 
			[`index > `@stop] 
				whileTrue: 
					[| `@blockTemps | 
					`@.BlockStmts1. 
					`index := `index - 1].
			`@.Statements2' )
		do: [ :node :answer | node ]
! !

!RBWhileTrueRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBWhileTrueRule.st,v 1.3 2012/03/01 12:46:36 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/RBWhileTrueRule.st,v 1.3 2012/03/01 12:46:36 cg Exp $'
!

version_SVN
    ^ 'Id: RBWhileTrueRule.st 19 2010-02-02 21:20:19Z vranyj1 '
! !
