"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

Object subclass:#SmalllintChecker
	instanceVariableNames:'rule environment context methodBlock'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint'
!


!SmalllintChecker class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.
!

newWithContext
	^(self new)
		context: SmalllintContext new;
		yourself
!

runRule: aLintRule
	(self new)
		rule: aLintRule;
		run.
	^aLintRule
!

runRule: aLintRule onEnvironment: aBrowserEnvironment 
	(self new)
		rule: aLintRule;
		environment: aBrowserEnvironment;
		run.
	^aLintRule
! !

!SmalllintChecker class methodsFor:'others'!

version_CVS
    ^'$Id: SmalllintChecker.st,v 1.3 2011/07/09 16:39:23 vrany Exp $'
! !

!SmalllintChecker methodsFor:'accessing'!

context: aSmalllintContext 
	context := aSmalllintContext
!

environment: aBrowserEnvironment 
	environment := aBrowserEnvironment
!

methodBlock: aBlock 
	methodBlock := aBlock
!

rule: aLintRule 
	rule := aLintRule
! !

!SmalllintChecker methodsFor:'actions'!

run
	rule resetResult.
	environment classesDo: 
			[:aClass | 
			self checkClass: aClass.
			self checkMethodsForClass: aClass]
! !

!SmalllintChecker methodsFor:'initialize-release'!

initialize
	methodBlock := [].
	environment := SelectorEnvironment new.
	context := SmalllintContext newNoCache
!

release
	context release.
	super release
! !

!SmalllintChecker methodsFor:'private'!

checkClass: aClass 
	context selectedClass: aClass.
	(environment definesClass: aClass) ifTrue: [rule checkClass: context]
!

checkMethodsForClass: aClass 
        ^environment selectorsForClass: aClass
                do: 
                        [:each | 
                        context selector: each.
                        rule checkMethod: context.
                        methodBlock value]

    "Modified: / 24-08-2010 / 21:32:39 / Jan Vrany <enter your email here>"
! !

!SmalllintChecker class methodsFor:'documentation'!

version
    ^'$Id: SmalllintChecker.st,v 1.3 2011/07/09 16:39:23 vrany Exp $'
!

version_SVN
    ^ 'Id: SmalllintChecker.st 24 2010-08-25 12:47:16Z vranyj1 '
! !
