"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

Context variableSubclass:#SmalllintMessageCollector
	instanceVariableNames:'selfMessages labels blockMethods superMessages messages'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint'
!

SmalllintMessageCollector comment:'This is a hacked-up version of the MessageCollector from the advanced tools. It just collects messages to self and super.'
!


!SmalllintMessageCollector class methodsFor:'instance creation'!

on: aCompiledMethod 
	^(self new) on: aCompiledMethod;
		run;
		yourself
! !

!SmalllintMessageCollector class methodsFor:'others'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/SmalllintMessageCollector.st,v 1.5 2011/07/09 16:18:11 vrany Exp $'
! !

!SmalllintMessageCollector methodsFor:'accessing'!

home
	^self shouldNotImplement
!

homeReceiver
	^self shouldNotImplement
!

mclass
	^self shouldNotImplement
!

messages
	^messages
!

run
	[method := blockMethods removeFirst.
	self method: method.
	self runMethod.
	blockMethods isEmpty]
			whileFalse
!

selfMessages
	^selfMessages
!

sourceCode
	^self shouldNotImplement
!

superMessages
	^superMessages
! !

!SmalllintMessageCollector methodsFor:'initialize-release'!

on: aCompiledMethod
	messages := Set new.
	selfMessages := Set new.
	superMessages := Set new.
	blockMethods := OrderedCollection with: aCompiledMethod
! !

!SmalllintMessageCollector methodsFor:'opcodes-control'!

jump: delta
	labels at: pc + delta put: (stack copyFrom: 1 to: stackp).
	self checkMerge
!

jump: delta if: condition 
	self send: (condition ifTrue: [#ifTrue:] ifFalse: [#ifFalse:]) numArgs: 0.
	self pop.
	labels at: pc + delta put: (stack copyFrom: 1 to: stackp)
!

makeCopyingBlock: meth count: count
	stackp := stackp - count.
	self push: nil.
	blockMethods addLast: meth
!

makeFullBlock: meth
	self push: nil.
	blockMethods addLast: meth
!

methodPrimitive: index 
	self push: nil
!

methodReturnTop: levels
	self checkMerge
!

primitiveReturn
!

returnTop
	self checkMerge
!

send: selector numArgs: na 
	| rcvr |
	stackp := stackp - na.
	rcvr := stack at: stackp.
	rcvr = 'self' ifTrue: [selfMessages add: selector].
	messages add: selector.
	stack at: stackp put: nil
!

sendSuper: selector numArgs: na 
	stackp := stackp - 1.
	stackp := stackp - na.
	stack at: stackp put: nil.
	superMessages add: selector.
	messages add: selector
! !

!SmalllintMessageCollector methodsFor:'opcodes-data movement'!

pushConstant: value
	self push: value.
	(value isMemberOf: BlockClosure) ifTrue:
		[blockMethods addLast: value method]
!

pushContext
	self push: nil
!

pushCopiedValues: count
	1 to: count do: [:i | self push: nil]
!

pushInst: index 
	self push: nil
!

pushInst: index outer: level
	self pushInst: index
!

pushInstAny: index 
	self pop;
		pushInst: index
!

pushLocal: index
	self push: nil
!

pushLocal: index outer: level
	self push: nil
!

pushReceiver
	self push: 'self'
!

pushReceiverOuter: level
	self pushReceiver
!

pushStatic: assoc 
	self push: nil
!

storeInst: index
!

storeInstAny: index
	self pop
!

storeLocal: index
!

storePopInst: index outer: level
	self pop
!

storePopLocal: index outer: level
	self pop
! !

!SmalllintMessageCollector methodsFor:'private'!

checkMerge
	| merge |
	merge := labels at: pc.
	merge notNil ifFalse: [^self].
	labels at: pc put: nil.
	stackp := merge size.
	stack replaceFrom: 1
		to: stackp
		with: merge
		startingAt: 1
!

findTemp: index do: aBlock elseDo: elseBlock 
	^self shouldNotImplement
!

merge: stk 
	| ssize |
	ssize := stk size.
	1 to: ssize
		do: 
			[:i | 
			| a b |
			a := stack at: i.
			a notNil ifTrue: 
					[b := stk at: i.
					b == a ifFalse: [stack at: i put: (a notNil ifTrue: [a] ifFalse: [b])]]].
	[stackp > ssize] whileTrue: 
			[ssize := ssize + 1.
			stack at: ssize put: nil]
!

pop: count
	stackp := stackp - count
!

push: elt
	stackp := stackp + 1.
	stack at: stackp put: elt
!

runMethod
	| fs |
	fs := method frameSize.
	fs = 0 ifTrue: 
			[fs := method numTemps + 2.
			method isBlockMethod ifTrue: [fs := fs + method numCopiedValues]].
	stack := Array new: fs.
	stackp := 0.
	labels := Array new: method endPC + 1.
	[self atEnd] whileFalse: 
			[| merge |
			merge := labels at: pc.
			merge notNil ifTrue: [self merge: merge].
			self interpretNextInstructionFor: self]
! !

!SmalllintMessageCollector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/SmalllintMessageCollector.st,v 1.5 2011/07/09 16:18:11 vrany Exp $'
! !
