"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

BrowserApplicationModel subclass:#SmalllintResultEditor
	instanceVariableNames:'label results resultsList'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Lint'
!


!SmalllintResultEditor class methodsFor:'interface opening'!

openOn: aCompositeLintRule 
	^self openOn: aCompositeLintRule label: nil
!

openOn: aCompositeLintRule label: aLabel 
	aCompositeLintRule isEmpty ifTrue: [Dialog warn: 'Nobody'].
	(self new) rule: aCompositeLintRule;
		label: aLabel;
		open
! !

!SmalllintResultEditor class methodsFor:'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Smalllint Results' 
			#min: #(#Point 40 20 ) 
			#bounds: #(#Rectangle 630 548 1203 803 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SequenceViewSpec 
					#layout: #(#LayoutFrame 2 0 2 0 -2 1 -39 1 ) 
					#name: #resultsList 
					#model: #resultsList 
					#callbacksSpec: 
					#(#UIEventCallbackSubSpec 
						#valueChangeSelector: #changedResult ) 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#ActionButtonSpec 
					#layout: #(#LayoutFrame -35 0.333333 -35 1 35 0.333333 -5 1 ) 
					#name: #openResult 
					#flags: 40 
					#model: #openResult 
					#label: 'Open...' 
					#isDefault: true ) 
				#(#ActionButtonSpec 
					#layout: #(#LayoutFrame -35 0.666666 -35 1 35 0.666666 -5 1 ) 
					#name: #remove 
					#model: #remove 
					#label: 'Remove' ) ) ) )
! !

!SmalllintResultEditor class methodsFor:'others'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/SmalllintResultEditor.st,v 1.10 2011/07/09 16:36:15 vrany Exp $'
! !

!SmalllintResultEditor methodsFor:'actions'!

openResult
	self selectedResult openEditor
!

remove
	results := self removeCurrentResultFrom: results.
	self resultsList list: results asList.
	self changedResult
! !

!SmalllintResultEditor methodsFor:'aspects'!

resultsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^resultsList isNil
		ifTrue:
			[resultsList := SelectionInList new]
		ifFalse:
			[resultsList]
! !

!SmalllintResultEditor methodsFor:'changing'!

changedResult
	(self selectedResult isNil or: [self selectedResult isComposite])
		ifTrue: [self disableAll: #(#openResult #remove)]
		ifFalse: [self enableAll: #(#openResult #remove)]
! !

!SmalllintResultEditor methodsFor:'events'!

noticeOfWindowClose: aWindow 
	self release.
	super noticeOfWindowClose: aWindow
! !

!SmalllintResultEditor methodsFor:'initialize-release'!

label: aLabel 
	label := aLabel
!

rule: aCompositeLintRule 
	results := self flattenResults: aCompositeLintRule
! !

!SmalllintResultEditor methodsFor:'interface opening'!

postBuildResultsList
        | block specWrapper |
        specWrapper := builder componentAt: #resultsList.
        specWrapper isNil ifTrue: [^self].
        block := 
                        [:view :index | 
                        | each name |
                        each := view sequence at: index.
                        name := each asString "displayName" asText.
                        "/ each isComposite ifTrue: [name := name allBold].
                        Smalltalk isSmalltalkX ifTrue:[
                            name
                        ] ifFalse:[
                            Label with: name
                                    attributes: view textStyle
                                    offset: ((self indentionLevelFor: each at: index) * 10) @ 0]].

        Smalltalk isSmalltalkX ifTrue:[
            (specWrapper widget) visualBlock: block;
                selectedVisualBlock: block
        ] ifFalse:[
            (specWrapper widget) visualBlock: (self createVisualBlockFrom: block);
                selectedVisualBlock: (self createSelectedVisualBlockFrom: block)
        ]
!

postBuildWith: aBuilder 
	super postBuildWith: aBuilder.
	self resultsList list: results asList.
	self postBuildResultsList
!

postOpenWith: aBuilder 
	super postOpenWith: aBuilder.
	label notNil ifTrue: [self setLabel: 'Smalllint Results -- ' , label].
	self changedResult
! !

!SmalllintResultEditor methodsFor:'private'!

flattenResults: aCompositeLintRule 
	| flattenedResults |
	flattenedResults := OrderedCollection new.
	aCompositeLintRule rules do: 
			[:each | 
			each isEmpty ifFalse: 
					[each isComposite
						ifTrue: 
							[flattenedResults add: each;
								addAll: (self flattenResults: each)]
						ifFalse: [flattenedResults add: each]]].
	^flattenedResults
!

indentionLevelFor: aRule at: anIndex 
	| current level |
	current := aRule.
	level := 0.
	anIndex to: 1
		by: -1
		do: 
			[:i | 
			| each |
			each := results at: i.
			(each isComposite and: [each rules includes: current]) ifTrue: 
					[current := each.
					level := level + 1]].
	^level
!

removeCurrentResultFrom: displayedResults 
	| currentResult last newList |
	currentResult := self selectedResult.
	displayedResults remove: currentResult ifAbsent: [].
	newList := displayedResults copy.
	last := nil.
	displayedResults reverseDo: 
			[:each | 
			(each isComposite and: [(each rules includes: last) not])
				ifTrue: [newList remove: each ifAbsent: []]
				ifFalse: [last := each]].
	^newList
!

selectedResult
	^self resultsList selection
! !

!SmalllintResultEditor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/SmalllintResultEditor.st,v 1.10 2011/07/09 16:36:15 vrany Exp $'
!

version_SVN
    ^ 'Id: SmalllintResultEditor.st 15 2009-10-26 15:53:16Z vranyj1 '
! !
