'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 08:05:02'                     !

"{ Package: 'stx:goodies/refactoryBrowser/lint/spelling' }"

RBSpellChecker subclass:#RBMacSpellChecker
	instanceVariableNames:''
	classVariableNames:'Utf16Converter'
	poolDictionaries:''
	category:'Refactory-Lint-Spelling'
!

RBMacSpellChecker comment:'A native spell checker of the Apple OS X platform. Source code is ripped from JMMMacSpelling.1.cs by John McIntosh <johnmci@smalltalkconsulting.com>.'
!

!RBMacSpellChecker class methodsFor:'initialization'!

initialize
	Utf16Converter := TextConverter newForEncoding: 'utf-16'
! !

!RBMacSpellChecker class methodsFor:'primitives'!

primitiveGetUniqueSpellingTag
"/        <primitive:'primitiveGetUniqueSpellingTag' module: 'SpellingPlugin'>

        ^ nil

    "Modified: / 05-09-2011 / 08:02:39 / cg"
! !

!RBMacSpellChecker class methodsFor:'testing'!

isSupported
	^ self primitiveGetUniqueSpellingTag notNil
! !

!RBMacSpellChecker methodsFor:'primitives'!

primitiveCheckSpelling: aString startingAt: anInteger
"/        <primitive:'primitiveCheckSpelling' module: 'SpellingPlugin'>
        
        self primitiveFailed

    "Modified: / 05-09-2011 / 07:58:09 / cg"
! !

!RBMacSpellChecker methodsFor:'private'!

validate: aString
	| result |
	result := self
		primitiveCheckSpelling: (aString 
			convertToWithConverter: Utf16Converter)
		startingAt: 1.
	^ (result at: 1) > (result at: 2)
! !


RBMacSpellChecker initialize!
