"{ Package: 'stx:goodies/refactoryBrowser/lint' }"

LibraryDefinition subclass:#stx_goodies_refactoryBrowser_lint
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_refactoryBrowser_lint class methodsFor:'description'!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
	#'stx:goodies/refactoryBrowser/browser'    "VariableEnvironment - referenced by RBInstVarInSubclassesRule>>resultClass "
	#'stx:goodies/refactoryBrowser/changes'    "CompositeRefactoryChange - referenced by RBTransformationRule>>resetResult "
	#'stx:goodies/refactoryBrowser/helpers'    "BrowserEnvironment - referenced by RBBasicLintRule>>filteredResult "
	#'stx:goodies/refactoryBrowser/parser'    "ParseTreeSearcher - referenced by RBTempVarOverridesInstVarRule>>initialize "
	#'stx:goodies/sunit'    "TestCase - referenced by RBClassNotReferencedRule>>checkClass: "
	#'stx:libbasic'    "Object - superclass of RBContainsRule "
	#'stx:libbasic2'    "Text - referenced by RBLintRule>>displayString "
	#'stx:libbasic3'    "ClassOrganizer - referenced by RBUnclassifiedMethodsRule>>checkMethod: "
	#'stx:libcompat'    "Preferences - referenced by RBSendsUnknownMessageToGlobalRule>>initialize "
	#'stx:libtool'
	#'stx:libview'    "Color - referenced by RBCompositeLintRule>>displayString "
	#'stx:libview2'
	#'stx:libwidg'
    )
! !

!stx_goodies_refactoryBrowser_lint class methodsFor:'description - actions'!

preLoadAction

    "Force load all BrowserEnvironment subclasses as we have
     ectension methods for them!!"

    #(BrowserEnvironment BrowserEnvironmentWrapper LimitedEnvironment VariableEnvironment CategoryEnvironment SelectorEnvironment ProtocolEnvironment NotEnvironment ClassEnvironment AndEnvironment RestrictedEnvironment MultiEnvironment ParseTreeEnvironment)
	do:
	    [:clsName| | cls |
	    cls := (Smalltalk at:clsName).
	    cls notNil ifTrue:[cls autoload]].

    "Created: / 02-02-2010 / 22:07:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_goodies_refactoryBrowser_lint class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        LintRuleIgnoreAnnotation
        RBLintRule
        RBReadBeforeWrittenTester
        (Smalllint autoload)
        SmalllintChecker
        SmalllintContext
        (SmalllintMessageCollector autoload)
        (SmalllintResultEditor autoload)
        (SmalllintTests autoload)
        (SmalllintTestsMock01 autoload)
        (SmalllintTestsMock02 autoload)
        #'stx_goodies_refactoryBrowser_lint'
        RBBasicLintRule
        RBCompositeLintRule
        RBTransformationRule
        (SmalllintTestsMock03 autoload)
        (SmalllintTestsMock04 autoload)
        RBAssignmentInIfTrueRule
        RBAtIfAbsentRule
        RBBetweenAndRule
        RBBlockLintRule
        RBCascadedNextPutAllsRule
        RBDetectIfNoneRule
        RBEqualNilRule
        RBGuardClauseRule
        RBMinMaxRule
        RBNotEliminationRule
        RBParseTreeLintRule
        RBShowWhileBlocksRule
        RBSuperSendsRule
        RBTranslateLiteralsInMenusReplaceRule
        RBUnderscoreAssignmentRule
        RBUnwindBlocksRule
        RBAbstractClassRule
        RBAddRemoveDependentsRule
        RBAsOrderedCollectionNotNeededRule
        RBAssignmentInBlockRule
        RBAssignmentWithoutEffectRule
        RBBadMessageRule
        RBBooleanPrecedenceRule
        RBClassInstVarNotInitializedRule
        RBClassNameInSelectorRule
        RBClassNotReferencedRule
        RBClassVariableCapitalizationRule
        RBCodeCruftLeftInMethodsRule
        RBCollectSelectNotUsedRule
        RBCollectionCopyEmptyRule
        RBCollectionMessagesToExternalObjectRule
        RBCollectionProtocolRule
        RBConsistencyCheckRule
        RBContainsRule
        RBDebuggingCodeLeftInMethodsRule
        RBDefinesEqualNotHashRule
        RBDetectContainsRule
        RBEmptyExceptionHandlerRule
        RBEndTrueFalseRule
        RBEqualNotUsedRule
        RBEqualsTrueRule
        RBEquivalentSuperclassMethodsRule
        RBExcessiveArgumentsRule
        RBExcessiveInheritanceRule
        RBExcessiveMethodsRule
        RBExcessiveVariablesRule
        RBExtraBlockRule
        RBFileBlocksRule
        RBFloatEqualityComparisonRule
        RBGuardingClauseRule
        RBIfTrueBlocksRule
        RBIfTrueReturnsRule
        RBImplementedNotSentRule
        RBInconsistentMethodClassificationRule
        RBInstVarInSubclassesRule
        RBInstanceVariableCapitalizationRule
        RBJustSendsSuperRule
        RBLawOfDemeterRule
        RBLiteralArrayCharactersRule
        RBLiteralArrayContainsCommaRule
        RBLiteralArrayContainsSuspiciousTrueFalseOrNilRule
        RBLongMethodsRule
        RBMisplacedReturnInIfTrueIfFalseWithTempsRule
        RBMissingSubclassResponsibilityRule
        RBMissingSuperSendsRule
        RBMissingTranslationsInMenusRule
        RBMissingYourselfRule
        RBModifiesCollectionRule
        RBOnlyReadOrWrittenRule
        RBOverridesSpecialMessageRule
        RBPlatformDependentUserInteractionRule
        RBPrecedenceRule
        RBRefersToClassRule
        RBReturnInEnsureRule
        RBReturnsBooleanAndOtherRule
        RBReturnsIfTrueRule
        RBRuleIgnoredRule
        RBSearchingLiteralRule
        RBSendsDeprecatedMethodToGlobalRule
        RBSendsDifferentSuperRule
        RBSendsUnknownMessageToGlobalRule
        RBSentNotImplementedRule
        RBSizeCheckRule
        RBStringConcatenationRule
        RBSubclassResponsibilityNotDefinedRule
        RBSuperSendsNewRule
        RBTempVarOverridesInstVarRule
        RBTemporaryVariableCapitalizationRule
        RBTempsReadBeforeWrittenRule
        RBThreeElementPointRule
        RBToDoCollectRule
        RBToDoRule
        RBToDoWithIncrementRule
        RBUnclassifiedMethodsRule
        RBUncommonMessageSendRule
        RBUnconditionalRecursionRule
        RBUndeclaredReferenceRule
        RBUnnecessaryAssignmentRule
        RBUnoptimizedAndOrRule
        RBUnoptimizedToDoRule
        RBUnpackagedCodeRule
        RBUnreferencedVariablesRule
        RBUsesAddRule
        RBUsesTrueRule
        RBUtilityMethodsRule
        RBVariableAssignedLiteralRule
        RBVariableNotDefinedRule
        RBVariableReferencedOnceRule
        RBWhileTrueRule
        RBYourselfNotUsedRule
        (BlockLintRule autoload)
        RBLiteralArrayByteValuesRule
        RBEmptyOrNilReplaceRule
        RBContainsToIncludesRule
        RBLoggingCodeReplaceRule
        RBIfNilIfNotNilReplaceRule
        RBObfuscatedLazyInitializerRule
        RBMissingTranslationsRule
        RBTranslateLiteralsInDialogsReplaceRule
        RBNilOrEmptyCollectionReplaceRule
        RBBadIdentityComparisonRule
        (SmalllintTests2 autoload)
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
	BrowserEnvironment includesMethod:
	BrowserEnvironment methodsInto:
	ClassEnvironment classesInto:
	ClassEnvironment methodsInto:
	RBAssignmentNode assignmentOperator
	RestrictedEnvironment classesInto:
	RestrictedEnvironment methodsInto:
	SelectorEnvironment classesInto:
	SelectorEnvironment methodsInto:
	VariableEnvironment classesInto:
	VariableEnvironment methodsInto:
	'Annotation class' ignore:rationale:
	'Annotation class' ignore:rationale:author:
	'Annotation class' ignoreLintRule:rationale:author:
	'Annotation class' lint:rationale:author:
    )
! !

!stx_goodies_refactoryBrowser_lint class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Refactoring Lint'

    "Modified: / 07-11-2006 / 11:39:11 / cg"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2006\nCopyright eXept Software AG 1998-2006'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_refactoryBrowser_lint class methodsFor:'description - svn'!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"'exported'"$"
! !

!stx_goodies_refactoryBrowser_lint class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/stx_goodies_refactoryBrowser_lint.st,v 1.24 2012/07/23 12:32:45 vrany Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/lint/stx_goodies_refactoryBrowser_lint.st,v 1.24 2012/07/23 12:32:45 vrany Exp $'
!

version_SVN
    ^ 'Id: stx_goodies_refactoryBrowser_lint.st 28 2011-05-06 10:16:15Z vranyj1 '
! !
