"{ Package: 'stx:goodies/refactoryBrowser/parser' }"

RBValueNode subclass:#RBArrayNode
	instanceVariableNames:'leftBrace rightBrace statements'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-AST-Nodes'
!

!RBArrayNode class methodsFor:'documentation'!

documentation
"
    I represent a squeak constructed array { expr1. expr2. ... exprN }
"
! !

!RBArrayNode class methodsFor:'instance creation'!

leftBrace: leftBrace  rightBrace: rightBrace  statements: statements
	^self new leftBrace: leftBrace  rightBrace: rightBrace  statements: statements
! !

!RBArrayNode methodsFor:'accessing'!

children
	^statements
!

leftBrace: leftBrace0
	leftBrace _ leftBrace0.
!

periods: periods
	"ignored"
!

precedence
	^0
!

rightBrace: rightBrace0
	rightBrace _ rightBrace0.
!

start
	^leftBrace
!

startWithoutParentheses
    statements isEmptyOrNil ifTrue:[^ leftBrace + 1].
    ^ statements first startWithoutParentheses
!

statements
	^statements
!

statements: statements0 
	statements ifNotNil: [self error: 'double initialization'].
	statements _ statements0.
	statements do: [:statement | statement parent: self]
!

stop
	^rightBrace
!

stopWithoutParentheses
    statements isEmptyOrNil ifTrue:[^ rightBrace - 1].
    ^ statements last stopWithoutParentheses
! !

!RBArrayNode methodsFor:'comparing'!

= anObject 
	self == anObject ifTrue: [^true].
	self class = anObject class ifFalse: [^false].
	^statements = anObject statements.
!

hash

	^statements hash.
! !

!RBArrayNode methodsFor:'copying'!

postCopy
	statements _ statements collect: [ :statement | statement copy ]
! !

!RBArrayNode methodsFor:'initialization'!

leftBrace: leftBrace0  rightBrace: rightBrace0  statements: statements0
	leftBrace _ leftBrace0.
	rightBrace _ rightBrace0.
	statements _ statements0.
! !

!RBArrayNode methodsFor:'matching'!

match: aNode inContext: aDictionary 
    aNode class == self class ifFalse: [^ false].
    ^ (self matchList: statements
                against: aNode statements
                inContext: aDictionary).

"/    1 to: statements size do: [:i | 
"/        ((statements at: i) match: (aNode statements at: i) inContext: aDictionary)
"/        ifFalse: [^ false]
"/    ].
"/    ^ true

    "Created: / 14-07-2011 / 17:00:58 / cg"
! !

!RBArrayNode methodsFor:'replacing'!

replaceNode: oldNode  withNode: newNode
	statements _ statements collect: [ :statement |
		statement == oldNode 
			ifTrue: [ newNode ]
			ifFalse: [ statement ] ]
! !

!RBArrayNode methodsFor:'testing'!

isSqueakArray
    ^ true
!

lastIsReturn
	statements isEmpty ifTrue:[ ^false ].
	^statements last lastIsReturn
! !

!RBArrayNode methodsFor:'visitor'!

acceptVisitor: aProgramNodeVisitor
	^aProgramNodeVisitor acceptArrayNode: self
! !

!RBArrayNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/parser/RBArrayNode.st,v 1.5 2011/07/14 15:22:04 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/parser/RBArrayNode.st,v 1.5 2011/07/14 15:22:04 cg Exp $'
! !
