"{ Package: 'stx:goodies/refactoryBrowser/parser' }"

RBValueToken subclass:#RBLiteralToken
	instanceVariableNames:'stopPosition'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-Scanner'
!


!RBLiteralToken class methodsFor:'instance creation'!

value: anObject 
	| literal |
	literal := anObject class == Array 
				ifTrue: [anObject collect: [:each | self value: each]]
				ifFalse: [anObject].
	^self 
		value: literal
		start: nil
		stop: nil
!

value: aString start: anInteger stop: stopInteger 
	^self new
		value: aString
		start: anInteger
		stop: stopInteger
!

value: aString start: anInteger stop: stopInteger lineNumber:lineNumber
        ^self new
                value: aString
                start: anInteger
                stop: stopInteger
                lineNumber:lineNumber
! !

!RBLiteralToken methodsFor:'accessing'!

realValue
	^value class == Array
		ifTrue: [value collect: [:each | each realValue]]
		ifFalse: [value]
!

stop: anObject 
	stopPosition := anObject
! !

!RBLiteralToken methodsFor:'initialization & release'!

value: aString start: anInteger stop: stopInteger 
        value := aString.
        sourcePointer := anInteger.
        stopPosition := stopInteger
!

value: aString start: anInteger stop: stopInteger lineNumber:lineNumberInteger
        value := aString.
        sourcePointer := anInteger.
        stopPosition := stopInteger.
        lineNumber := lineNumberInteger.
        "/ self assert:(lineNumber notNil).
! !

!RBLiteralToken methodsFor:'private'!

length
	^stopPosition - self start + 1
! !

!RBLiteralToken methodsFor:'testing'!

isLiteral
	^true
!

isLiteralArray
        ^ value class == Array
!

isLiteralByteArray
        ^ value class == ByteArray
!

isLiteralString
        ^ value class == String

    "Created: / 28-12-2011 / 16:07:12 / cg"
!

isPatternLiteral
        ^false
! !

!RBLiteralToken class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/parser/RBLiteralToken.st,v 1.13 2011/12/28 15:07:19 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/parser/RBLiteralToken.st,v 1.13 2011/12/28 15:07:19 cg Exp $'
! !
