"{ Package: 'stx:goodies/refactoryBrowser/parser' }"

RBBlockNode subclass:#RBPatternBlockNode
	instanceVariableNames:'valueBlock'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-ParseTree Matching'
!


!RBPatternBlockNode methodsFor:'accessing'!

sentMessages
	^OrderedCollection new
! !

!RBPatternBlockNode methodsFor:'matching'!

addArgumentWithNameBasedOn: aString 
	| name index vars |
	name := aString.
	vars := self allDefinedVariables.
	index := 0.
	[vars includes: name] whileTrue: 
			[index := index + 1.
			name := name , index printString].
	arguments := arguments copyWith: (RBVariableNode named: name)
!

copyInContext: aDictionary 
	^self replacingBlock value: aDictionary
!

createBlock
	| source |
	source := self formattedCode.
	^Compiler evaluate: source
!

createMatchingBlock
        |numArgs|

        (numArgs := self arguments size) > 2 
                ifTrue: 
                        [self 
                                error: 'Search blocks can only contain arguments for the node and matching dictionary'].
        numArgs == 0 
                ifTrue: [self error: 'Search blocks must contain one argument for the node'].
        numArgs = 1 
                ifTrue: [self addArgumentWithNameBasedOn: 'aDictionary'].
        ^self createBlock
!

createReplacingBlock
	self arguments size > 1 
		ifTrue: 
			[self 
				error: 'Replace blocks can only contain an argument for the matching dictionary'].
	self arguments size = 0 
		ifTrue: [self addArgumentWithNameBasedOn: 'aDictionary'].
	^self createBlock
!

match: aNode inContext: aDictionary 
	^self matchingBlock value: aNode value: aDictionary
!

matchingBlock
	^valueBlock isNil 
		ifTrue: [valueBlock := self createMatchingBlock]
		ifFalse: [valueBlock]
!

replacingBlock
	^valueBlock isNil 
		ifTrue: [valueBlock := self createReplacingBlock]
		ifFalse: [valueBlock]
! !

!RBPatternBlockNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/parser/RBPatternBlockNode.st,v 1.4 2006/02/23 19:34:28 cg Exp $'
! !
