"{ Package: 'stx:goodies/refactoryBrowser/parser' }"

LibraryDefinition subclass:#stx_goodies_refactoryBrowser_parser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_refactoryBrowser_parser class methodsFor:'documentation'!

documentation
"
    Build-Information for creation of the refactoring library: stx:goodies/refactoryBrowser/parser.
    This library contains the smalltalk parser and AST-nodes used by the refactoring tools.
"
!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/parser/stx_goodies_refactoryBrowser_parser.st,v 1.26 2012/03/06 10:33:17 cg Exp $'
! !

!stx_goodies_refactoryBrowser_parser class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:libbasic'    "ProjectDefinition - superclass of stx_goodies_refactoryBrowser_parser "
    )
! !

!stx_goodies_refactoryBrowser_parser class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIB_RB_PARSER_BASE
LIB_BASE=$(LIB_RB_PARSER_BASE)
'
!

stcOptimizationOptions
    "do not inline the not operation here - it is overwritten"

    ^ '+optspace3 -inlinenot'

    "Created: / 23-08-2006 / 01:25:34 / cg"
! !

!stx_goodies_refactoryBrowser_parser class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (ParseTreeRule autoload)
        RBProgramNodeVisitor
        ParseTreeSearcher
        ParseTreeRewriter
        ParseTreeSourceRewriter
        RBArrayNode
        RBAssignmentNode
        RBAssignmentToken
        RBBinarySelectorToken
        RBBlockNode
        RBCascadeNode
        RBComment
        RBFormatter
        RBIdentifierToken
        RBKeywordToken
        RBLiteralByteArrayToken
        RBLiteralNode
        RBLiteralNumberToken
        RBLiteralToken
        RBMessageNode
        RBMethodNode
        RBOptimizedNode
        RBOptimizedToken
        RBParser
        RBPatternBlockNode
        RBPatternBlockToken
        RBPatternMessageNode
        RBPatternMethodNode
        RBPatternVariableNode
        RBProgramNode
        RBReturnNode
        RBSTXPrimitiveCCodeNode
        RBSTXPrimitiveCodeToken
        RBSTXPrimitiveValueCCodeNode
        RBScanner
        RBSequenceNode
        RBSmallDictionary
        RBSpecialCharacterToken
        RBStatementNode
        RBToken
        RBValueNode
        RBValueToken
        RBVariableNode
        RBMetaMessageNode
        RBMetaMethodNode
        RBMetaVariableNode
        #'stx_goodies_refactoryBrowser_parser'
        RBPatternLiteralToken
        RBEndOfFileToken
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Behavior parseTreeFor:
        Method equivalentTo:
        Method parseTree
    )
! !

!stx_goodies_refactoryBrowser_parser class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Refactoring Parser'
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ 'Copyright Refactoring Inc.\nCopyright eXept Software AG 2000-2011'

    "Modified: / 01-02-2011 / 11:53:19 / cg"
! !

!stx_goodies_refactoryBrowser_parser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/parser/stx_goodies_refactoryBrowser_parser.st,v 1.26 2012/03/06 10:33:17 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/parser/stx_goodies_refactoryBrowser_parser.st,v 1.26 2012/03/06 10:33:17 cg Exp $'
! !
