"{ Package: 'stx:goodies/refactoryBrowser/refactoring' }"

Object subclass:#RBParseTreeRule
	instanceVariableNames:'searchTree owner'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-ParseTree Matching'
!


!RBParseTreeRule class methodsFor:'instance creation'!

methodSearch: aString 
	^(self new)
		methodSearchString: aString;
		yourself
!

new
	^(super new)
		initialize;
		yourself
!

search: aString 
	^(self new)
		searchString: aString;
		yourself
! !

!RBParseTreeRule methodsFor:'accessing'!

searchString
    ^ searchTree formattedCode

    "Modified: / 31-01-2012 / 15:08:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

searchTree
    ^ searchTree

    "Created: / 31-01-2012 / 15:00:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

sentMessages
	^searchTree sentMessages
! !

!RBParseTreeRule methodsFor:'copying'!

copyMatchDo: aBlock
    "Creates of copy of receiver, that evaluates given block on
     every match, passing matching node as an argument"

    ^self subclassResponsibility

    "Created: / 02-02-2012 / 22:52:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!RBParseTreeRule methodsFor:'initialize-release'!

initialize
!

methodSearchString: aString 
        searchTree := RBParser parseRewriteMethod: aString
!

owner: aParseTreeSearcher
	owner := aParseTreeSearcher
!

searchString: aString
    searchTree := RBParser parseRewriteExpression: aString

    "Modified: / 31-01-2012 / 14:56:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!RBParseTreeRule methodsFor:'matching'!

canMatch: aProgramNode 
	^true
!

foundMatchFor: aProgramNode
	^aProgramNode
!

performOn: aProgramNode 
        self context removeAll.
        ((searchTree match: aProgramNode inContext: self context) 
                and: [self canMatch: aProgramNode]) 
                        ifTrue: 
                                [owner recusivelySearchInContext.
                                ^ self foundMatchFor: aProgramNode]
                        ifFalse: [^ nil]
! !

!RBParseTreeRule methodsFor:'private'!

context
	^owner context
! !

!RBParseTreeRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/refactoring/RBParseTreeRule.st,v 1.9 2012/02/03 10:53:28 vrany Exp $'
! !
