"{ Package: 'stx:goodies/refactoryBrowser/refactoring' }"

RBParseTreeRule subclass:#RBSearchRule
	instanceVariableNames:'answerBlock'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-ParseTree Matching'
!


!RBSearchRule class methodsFor:'instance creation'!

searchFor: aString thenDo: aBlock 
	^self new searchFor: aString thenDo: aBlock
!

searchForMethod: aString thenDo: aBlock 
	^self new searchForMethod: aString thenDo: aBlock
!

searchForTree: aBRProgramNode thenDo: aBlock 
	^self new searchForTree: aBRProgramNode thenDo: aBlock
! !

!RBSearchRule methodsFor:'copying'!

copyMatchDo:aBlock
    "Creates of copy of receiver, that evaluates given block on
     every match, passing matching node as an argument"

    ^ RBSearchRule new 
            searchForTree: searchTree 
            thenDo: [:node :answer|
                | answerBlockValue |

                answerBlockValue := answerBlock value: node value: answer.
                (answerBlockValue notNil and:[answer ~~ answerBlockValue]) ifTrue:[
                    aBlock value: node
                ].
                answerBlockValue
            ]

    "Modified: / 02-02-2012 / 23:05:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!RBSearchRule methodsFor:'initialize-release'!

searchFor: aString thenDo: aBlock
        self assert:(aBlock numArgs == 2).
        self searchString: aString.
        answerBlock := aBlock

    "Modified: / 07-03-2012 / 17:29:49 / cg"
!

searchForMethod: aString thenDo: aBlock 
        self assert:(aBlock numArgs == 2).
        self methodSearchString: aString.
        answerBlock := aBlock

    "Modified: / 07-03-2012 / 17:29:53 / cg"
!

searchForTree: aBRProgramNode thenDo: aBlock 
        self assert:(aBlock numArgs == 2).
        searchTree := aBRProgramNode.
        answerBlock := aBlock

    "Modified: / 07-03-2012 / 17:29:55 / cg"
! !

!RBSearchRule methodsFor:'testing'!

canMatch: aProgramNode
        |result|

        result := (answerBlock value: aProgramNode value: owner answer).
        result isNil ifTrue:[^ false].

        owner answer: result.
        ^true

    "Modified: / 08-03-2012 / 03:06:53 / cg"
! !

!RBSearchRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/refactoring/RBSearchRule.st,v 1.9 2012/03/08 03:23:06 cg Exp $'
! !
