"{ Package: 'stx:goodies/refactoryBrowser/refactoring' }"

RBReplaceRule subclass:#RBStringReplaceRule
	instanceVariableNames:'replaceTree'
	classVariableNames:''
	poolDictionaries:''
	category:'Refactory-ParseTree Matching'
!


!RBStringReplaceRule class methodsFor:'instance creation'!

searchFor: searchString replaceWith: replaceString 
	^self new searchFor: searchString replaceWith: replaceString
!

searchFor: searchString replaceWith: replaceString when: aBlock 
	^self new 
		searchFor: searchString
		replaceWith: replaceString
		when: aBlock
!

searchForMethod: searchString replaceWith: replaceString
	^self new searchForMethod: searchString replaceWith: replaceString
!

searchForMethod: searchString replaceWith: replaceString when: aBlock 
	^self new 
		searchForMethod: searchString
		replaceWith: replaceString
		when: aBlock
!

searchForTree: searchString replaceWith: replaceString 
	^self new searchForTree: searchString replaceWith: replaceString
!

searchForTree: searchString replaceWith: replaceString when: aBlock 
	^self new 
		searchForTree: searchString
		replaceWith: replaceString
		when: aBlock
! !

!RBStringReplaceRule methodsFor:'initialize-release'!

methodReplaceString: replaceString 
        replaceTree := RBParser parseRewriteMethod: replaceString
!

replaceString: replaceString 
        replaceTree := RBParser parseRewriteExpression: replaceString.
        searchTree isSequence = replaceTree isSequence 
                ifFalse: 
                        [searchTree isSequence 
                                ifTrue: [replaceTree := RBSequenceNode statements: (Array with: replaceTree)]
                                ifFalse: [searchTree := RBSequenceNode statements: (Array with: searchTree)]]
!

searchFor: searchString replaceWith: replaceString 
	self searchString: searchString.
	self replaceString: replaceString
!

searchFor: searchString replaceWith: replaceString when: aBlock 
	self searchFor: searchString replaceWith: replaceString.
	verificationBlock := aBlock
!

searchForMethod: searchString replaceWith: replaceString 
	self methodSearchString: searchString.
	self methodReplaceString: replaceString
!

searchForMethod: searchString replaceWith: replaceString when: aBlock 
	self searchForMethod: searchString replaceWith: replaceString.
	verificationBlock := aBlock
!

searchForTree: aBRProgramNode replaceWith: replaceNode 
	searchTree := aBRProgramNode.
	replaceTree := replaceNode
!

searchForTree: aBRProgramNode replaceWith: replaceString when: aBlock 
	self searchForTree: aBRProgramNode replaceWith: replaceString.
	verificationBlock := aBlock
! !

!RBStringReplaceRule methodsFor:'matching'!

foundMatchFor: aProgramNode 
        | newTree |

        (owner notNil and:[owner isRewritingOriginalSource]) ifTrue:[
            owner addReplacement:((RBReplaceStringInOriginalSource new)
                                        oldNode:aProgramNode;
                                        newNode:replaceTree).
            ^ replaceTree
        ].
        newTree := replaceTree copyInContext: self context.
        newTree copyCommentsFrom: aProgramNode.
        ^newTree
! !

!RBStringReplaceRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/refactoring/RBStringReplaceRule.st,v 1.6 2003/09/23 10:44:00 cg Exp $'
! !
