"{ Package: 'stx:goodies/refactoryBrowser/refactoring' }"

LibraryDefinition subclass:#stx_goodies_refactoryBrowser_refactoring
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_refactoryBrowser_refactoring class methodsFor:'documentation'!

documentation
"
    Build-Information for creation of the refactoring library: stx:goodies/refactoryBrowser/refactoring.
    This library contains classes representing individual refactoring operations.
"
! !

!stx_goodies_refactoryBrowser_refactoring class methodsFor:'description'!

extensionMethodNames
    ^ #(
    )
!

preRequisites
    ^ #(
        #'stx:goodies/refactoryBrowser/changes'    "ClassRefactoryChange - referenced by RefactoryBuilder>>renameClass:to: "
        #'stx:goodies/refactoryBrowser/helpers'    "BrowserEnvironment - referenced by RemoveClassRefactoring>>preconditions "
        #'stx:goodies/refactoryBrowser/parser'    "ParseTreeSearcher - referenced by MoveMethodRefactoring>>checkAssignmentsToVariable "
        #'stx:libbasic'    "Object - superclass of RefactoryBuilder "
        #'stx:libcomp'    "Parser - referenced by Refactoring>>execute "
        #'stx:libtool'    "SystemBrowser - referenced by RemoveClassVariableRefactoring>>preconditions "
        #'stx:libview'    "Cursor - referenced by Refactoring>>allImplementorsOf: "
    )
! !

!stx_goodies_refactoryBrowser_refactoring class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIB_RB_REFACTORING_BASE
LIB_BASE=$(LIB_RB_REFACTORING_BASE)
'
!

stcOptimizationOptions
    "do not inline the not operation here - it is overwritten"

    ^ '+optspace3 -inlinenot'

    "Created: / 23-08-2006 / 01:27:22 / cg"
! !

!stx_goodies_refactoryBrowser_refactoring class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        AbstractClassVariableRefactoring
        AbstractInstanceVariableRefactoring
        AbstractVariablesRefactoring
        AddClassRefactoring
        AddClassVariableRefactoring
        AddInstanceVariableRefactoring
        AddMethodRefactoring
        AddParameterRefactoring
        ChangeMethodNameRefactoring
        ChildrenToSiblingsRefactoring
        ClassRefactoring
        CreateAccessorsForVariableRefactoring
        ExpandReferencedPoolsRefactoring
        ExtractMethodRefactoring
        ExtractMethodToComponentRefactoring
        ExtractToTemporaryRefactoring
        InlineAllSelfSendersRefactoring
        InlineMethodFromComponentRefactoring
        InlineMethodRefactoring
        InlineParameterRefactoring
        InlineTemporaryRefactoring
        MethodRefactoring
        MoveMethodRefactoring
        MoveVariableDefinitionRefactoring
        ProtectInstanceVariableRefactoring
        PullUpClassVariableRefactoring
        PullUpInstanceVariableRefactoring
        PushDownClassVariableRefactoring
        PushDownInstanceVariableRefactoring
        PushDownMethodRefactoring
        PushUpMethodRefactoring
        RBAbstractCondition
        RBAlternativeCondition
        RBBlockReplaceRule
        RBCondition
        RBConjunctiveCondition
        RBNegationCondition
        RBParseTreeRule
        RBReplaceRule
        RBReplaceStringInOriginalSource
        RBSearchRule
        RBStringReplaceRule
        Refactoring
        RefactoringError
        RefactoringManager
        RefactoringWarning
        RefactoryBuilder
        RemoveClassRefactoring
        RemoveClassVariableRefactoring
        RemoveInstanceVariableRefactoring
        RemoveMethodRefactoring
        RemoveParameterRefactoring
        RenameClassRefactoring
        RenameClassVariableRefactoring
        RenameInstanceVariableRefactoring
        RenameMethodRefactoring
        RenameTemporaryRefactoring
        RenameVariableRefactoring
        RestoringVariableRefactoring
        SplitClassRefactoring
        TemporaryToInstanceVariableRefactoring
        ValueHolderRefactoring
        VariableRefactoring
        #'stx_goodies_refactoryBrowser_refactoring'
        RenameToInstanceVariableRefactoring
        (CompositeRefactoring autoload)
    )
! !

!stx_goodies_refactoryBrowser_refactoring class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Refactorings'

    "Modified: / 14-09-2006 / 10:56:40 / cg"
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ 'Copyright Refactoring Inc.\nCopyright eXept Software AG 2000-2011'

    "Modified: / 01-02-2011 / 11:53:42 / cg"
! !

!stx_goodies_refactoryBrowser_refactoring class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/refactoring/stx_goodies_refactoryBrowser_refactoring.st,v 1.19 2011/02/01 10:58:09 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/refactoryBrowser/refactoring/stx_goodies_refactoryBrowser_refactoring.st,v 1.19 2011/02/01 10:58:09 cg Exp $'
! !
