"{ Package: 'stx:goodies/regex' }"

LibraryDefinition subclass:#stx_goodies_regex
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_regex class methodsFor:'description'!

extensionMethodNames
    ^ #(
#CharacterArray #asRegex
#CharacterArray #prefixMatchesRegexIgnoringCase:
#CharacterArray #matchesRegex:
#CharacterArray #allRegexMatches:
#CharacterArray #regex:matchesDo:
#CharacterArray #asRegexIgnoringCase
#CharacterArray #copyWithRegex:matchesTranslatedUsing:
#CharacterArray #prefixMatchesRegex:
#CharacterArray #regex:matchesCollect:
#CharacterArray #matchesRegexIgnoringCase:
#CharacterArray #copyWithRegex:matchesReplacedWith:
    )
!

preRequisites
    ^ #(
        #'stx:libbasic'    "Object - superclass of Regex::RxsCharSet "
    )
! !

!stx_goodies_regex class methodsFor:'description - compilation'!

additionalDefinitions_nt_dot_mak
    ^ '
# see stdHeader_nt for LIBREGEX_BASE
LIB_BASE_LD_ARG=-b:$(LIBREGEX_BASE)
'
!

stcOptimizationOptions
    ^ '+optinline +optinline2'
! !

!stx_goodies_regex class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        ('Regex::ReadMe' autoload)
        'Regex::RxCharSetParser'
        'Regex::RxMatchOptimizer'
        'Regex::RxMatcher'
        'Regex::RxParser'
        ('Regex::RxTests' autoload)
        'Regex::RxmBranch'
        'Regex::RxmLink'
        'Regex::RxmMarker'
        'Regex::RxmPredicate'
        'Regex::RxmSpecial'
        'Regex::RxmSubstring'
        'Regex::RxmTerminator'
        'Regex::RxsBranch'
        'Regex::RxsCharClass'
        'Regex::RxsCharSet'
        'Regex::RxsCharacter'
        'Regex::RxsContextCondition'
        'Regex::RxsEpsilon'
        'Regex::RxsMessagePredicate'
        'Regex::RxsNode'
        'Regex::RxsPiece'
        'Regex::RxsPredicate'
        'Regex::RxsRange'
        'Regex::RxsRegex'
        'Regex::RxsSpecial'
        'stx_goodies_regex'
        #'Regex::RxmRepetition'
    )
! !

!stx_goodies_regex class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Regular Expressions'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Vassili Bykov 1996,1999 \nCopyright eXept Software AG 2000-2011'

    "Modified: / 01-02-2011 / 11:53:45 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_regex class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/regex/stx_goodies_regex.st,v 1.11 2011/02/01 10:57:55 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/regex/stx_goodies_regex.st,v 1.11 2011/02/01 10:57:55 cg Exp $'
! !
