"{ Package: 'stx:goodies/roelTyper' }"

"{ NameSpace: RoelTyper }"

TypeMerger subclass:#AbstractMerger
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-Core'
!


!AbstractMerger methodsFor:'public'!

mergeInterfaceTypes: interfaceTypeCollection assignmentTypes: assignmentTypesCollection
	"interfaceTypes is a set of trees of types reconstructed by looking at the interfaces.
	assignmentTypes is a set of trees of types reconstructed by looking at the assignments.
	The receiver takes these sets as input and needs to return one set of trees of types that combines both."

	"This class does this by preferring abstract types over concrete types."

	| assignmentsToKeep chain |
	(interfaceTypeCollection isEmpty and: [assignmentTypesCollection notEmpty]) ifTrue: [^assignmentTypesCollection].
	assignmentsToKeep := assignmentTypesCollection select:
					[:assignmentType |
					chain := assignmentType withAllSuperclasses.
					(interfaceTypeCollection
						contains: [:superType | chain includes: superType]) not].
	assignmentsToKeep addAll: interfaceTypeCollection.
	^assignmentsToKeep isEmpty
		ifTrue: [OrderedCollection with: Object]
		ifFalse: [assignmentsToKeep]
! !

!AbstractMerger class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/RoelTyper__AbstractMerger.st,v 1.2 2009/10/02 14:02:47 cg Exp $'
! !
