"{ Package: 'stx:goodies/roelTyper' }"

"{ NameSpace: RoelTyper }"

Object subclass:#AbstractType
	instanceVariableNames:'ivarClass ivarName'
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-Core'
!


!AbstractType class methodsFor:'instance creation'!

forInstvar: iv inClass: aClass

	^(self basicNew) initialize
		ivarName: iv;
		ivarClass: aClass;
		yourself
!

new

	^self shouldNotImplement
! !

!AbstractType methodsFor:'accessing'!

ivarClass

	^ivarClass
!

ivarClass: aClass

	ivarClass := aClass.
	self triggerEvent: #changed
!

ivarName

	^ivarName
!

ivarName: aSymbol

	ivarName := aSymbol.
	self triggerEvent: #changed
!

types

	^self subclassResponsibility
! !

!AbstractType methodsFor:'initialize-release'!

initialize
	"Do nothing, but give subclasses the chance to override."
! !

!AbstractType methodsFor:'printing'!

printOn: aStream

	self printTypesOn: aStream
!

printTypesOn: aStream

	self types do: [:each | aStream print: each]
		separatedBy: [aStream nextPutAll: ' , ']
! !

!AbstractType methodsFor:'private'!

conflictingAssignmentsWith: anExtractedType
	| conflictingAssignments |
	conflictingAssignments := anExtractedType assignments
				select: [:assignment | (self types includes: assignment) not].
	^conflictingAssignments
!

conflictingSelectorsWith: anExtractedType
	| conflictingSelectors |
	conflictingSelectors := Dictionary new.
	anExtractedType interface do:
			[:selector |
			self types do:
					[:aType |
					(aType canUnderstand: selector)
						ifFalse:
							[(conflictingSelectors at: selector ifAbsentPut: [OrderedCollection new])
								add: aType]]].
	^conflictingSelectors
! !

!AbstractType methodsFor:'testing'!

is: aClass

	^self isSingularType and: [self types first = aClass]
!

isExtractedResult

	^self subclassResponsibility
!

isObjectType

	^self isSingularType and: [self types includes: Object]
!

isSingularType

	^self types size = 1
! !

!AbstractType class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/RoelTyper__AbstractType.st,v 1.2 2009/10/02 14:02:47 cg Exp $'
! !
