"{ Package: 'stx:goodies/roelTyper' }"

"{ NameSpace: RoelTyper }"

TypeMerger subclass:#AssignmentsFirstMerger
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-Core'
!


!AssignmentsFirstMerger methodsFor:'public'!

mergeInterfaceTypes: interfaceTypeCollection assignmentTypes: assignmentTypesCollection
	"interfaceTypes is a set of trees of types reconstructed by looking at the interfaces.
	assignmentTypes is a set of trees of types reconstructed by looking at the assignments.
	The receiver takes these sets as input and needs to return one set of trees of types that combines both."

	"This merger favors the assignment types over the interface types. It only considers the interface types when there is no assignment information, or when there is only one interface type that is not related to the assignment types."

	| interfaceType assignments |
	assignmentTypesCollection isEmpty ifTrue: [
		interfaceTypeCollection isEmpty
			ifTrue: [^OrderedCollection with: Object]
			ifFalse: [^self cleanBooleansIn: interfaceTypeCollection asOrderedCollection]].
	assignments := assignmentTypesCollection asOrderedCollection.
	(interfaceTypeCollection size == 1) ifFalse: [^self cleanBooleansIn: assignments].
	interfaceType := interfaceTypeCollection asOrderedCollection first.
	^((assignments anySatisfy: [:cl | cl includesBehavior: interfaceType]) or: [
		assignments anySatisfy: [:assignmentType | (interfaceType includesBehavior: assignmentType)]
	]) ifTrue: [self cleanBooleansIn: assignments] ifFalse: [self cleanBooleansIn: (assignments add: interfaceType; yourself)].
! !

!AssignmentsFirstMerger class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/RoelTyper__AssignmentsFirstMerger.st,v 1.2 2009/10/02 14:02:47 cg Exp $'
! !
