"{ Package: 'stx:goodies/roelTyper' }"

"{ NameSpace: RoelTyper }"

TypeMerger subclass:#ConcreteMerger
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-Core'
!


!ConcreteMerger methodsFor:'public'!

mergeInterfaceTypes: interfaceTypeCollection assignmentTypes: assignmentTypesCollection
	"interfaceTypes is a set of trees of types reconstructed by looking at the interfaces.
	assignmentTypes is a set of trees of types reconstructed by looking at the assignments.
	The receiver takes these sets as input and needs to return one set of trees of types that combines both."

	"This class does this by preferring concrete types over abstract types."

	| toKeep chain |
	toKeep := interfaceTypeCollection copy.
	assignmentTypesCollection do:
			[:assignmentType |
			chain := assignmentType withAllSuperclasses.
			(interfaceTypeCollection select: [:type | chain includes: type])
				do: [:each | toKeep remove: each ifAbsent: []]].
	toKeep addAll: assignmentTypesCollection.
	^toKeep isEmpty ifTrue: [OrderedCollection with: Object] ifFalse: [toKeep asOrderedCollection]
! !

!ConcreteMerger class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/RoelTyper__ConcreteMerger.st,v 1.2 2009/10/02 14:02:47 cg Exp $'
! !
