"{ Package: 'stx:goodies/roelTyper' }"

"{ NameSpace: RoelTyper }"

Object subclass:#TypeMerger
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-Core'
!


!TypeMerger class methodsFor:'instance creation'!

interfaceTypes: interfaceTypeCollection assignmentTypes: assignmentTypesCollection

	^self new mergeInterfaceTypes: interfaceTypeCollection assignmentTypes: assignmentTypesCollection
! !

!TypeMerger methodsFor:'private'!

cleanBooleansIn: collection
	"Remove all occurences of True, False and Boolean in the given collection. If any element was removed, add Boolean"
	"Note: removeAllSuchThat: in VisualWorks returns the elements removed, while in Squeak it returns the new set. Therefore I adopted a check on the sizes to see if any Boolean class was removed or not, instead of checking the result of removeAllSuchThat: "

	| oldSize |
	oldSize := collection size.
	collection
				removeAllSuchThat: [:type | type == True | (type == False) | (type == Boolean)].

	^oldSize == collection size
		ifFalse:
			[collection
				add: Boolean;
				yourself]
		ifTrue: [collection]
! !

!TypeMerger methodsFor:'public'!

mergeInterfaceTypes: interfaceTypeCollection assignmentTypes: assignmentTypesCollection
	"interfaceTypes is a set of trees of types reconstructed by looking at the interfaces.
	assignmentTypes is a set of trees of types reconstructed by looking at the assignments.
	The receiver takes these sets as input and needs to return one set of trees of types that combines both."

	^self subclassResponsibility
! !

!TypeMerger class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/RoelTyper__TypeMerger.st,v 1.2 2009/10/02 14:02:47 cg Exp $'
! !
