"{ Package: 'stx:goodies/roelTyper' }"

"{ NameSpace: RoelTyper }"

Object subclass:#TypingResultKeeper
	instanceVariableNames:'timeTaken typeResults'
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-Core'
!


!TypingResultKeeper class methodsFor:'instance creation'!

benchmarkImage
	"self benchmarkImage"

	| keeper |
	^Time millisecondsToRun:
			[keeper := self forImage.
			keeper withAllInstvarResultsDo: [:cl :iv :result | result types]]
!

forImage

	^self new forImage
!

forImageExpanded

	| keeper |
	keeper := self forImage.
	keeper withAllInstvarResultsDo: [:cl :iv :result | result types].
	^keeper
!

new

	^super new initialize
! !

!TypingResultKeeper methodsFor:'accessing'!

calculateTypesForClass: aClass
	^TypeCollector typeInstvarsOfClass: aClass
!

nrObjectTypes

	| nr |
	nr := 0.
	self withAllInstvarResultsDo: [:cl :ivar :typeResult |
		(typeResult is: Object) ifTrue: [nr := nr + 1]].
	^nr
!

nrUniqueTypes

	| nr |
	nr := 0.
	self withAllInstvarResultsDo: [:cl :ivar :typeResult |
		typeResult isSingularType ifTrue: [nr := nr + 1]].
	^nr
!

resetTypesForClass: aClass

	^typeResults removeKey: aClass ifAbsent: []
!

timeTaken
	^timeTaken
!

typeResults
	^typeResults
!

typesForClass: aClass
	aClass isNil ifTrue:[^ nil ].
	^typeResults at: aClass ifAbsentPut: [self calculateTypesForClass: aClass]
!

typesForClass: aClass instvar: instvar

	^(self typesForClass: aClass) at: instvar ifAbsent: [ExtractedType forInstvar: instvar inClass: aClass]
! !

!TypingResultKeeper methodsFor:'enumerating'!

withAllInstvarResultsDo: aBlock

	self typeResults keysAndValuesDo: [:cl :instvarDict |
		instvarDict keysAndValuesDo: [:ivar :typeResult |
			aBlock value: cl value: ivar value: typeResult]]
! !

!TypingResultKeeper methodsFor:'initialize-release'!

initialize

	typeResults := IdentityDictionary new
! !

!TypingResultKeeper methodsFor:'private'!

addCollectorResult: collectorResult

	collectorResult isEmpty ifTrue: [^self].
	typeResults at: collectorResult values first ivarClass put: collectorResult
!

addTypingResult: aTypeResult

	| typeResultsForClass |
	typeResultsForClass := self typeResults at: aTypeResult ivarClass
				ifAbsentPut: [Dictionary new].
	typeResultsForClass at: aTypeResult ivarName put: aTypeResult
!

resultsForClass: aClass instvar: instvar ifAbsent: absentBlock

	| ivars |
	ivars := typeResults at: aClass ifAbsent: absentBlock.
	^ivars at: instvar  ifAbsent: absentBlock
! !

!TypingResultKeeper methodsFor:'public'!

forClasses: aClassList

	| collector |
	collector := TypeCollector new.
	timeTaken := Time millisecondsToRun: [aClassList do: [:cl | cl isMeta ifFalse: [
		self addCollectorResult: ( collector typeInstvarsOfClass: cl)]]]
!

forImage

	self forClasses: Object allSubclasses
! !

!TypingResultKeeper methodsFor:'statistics'!

sameTypesAs: otherKeeper

	| result correspondingResult |
	result := OrderedCollection new.
	self withAllInstvarResultsDo: [:cl :iv :res |
		correspondingResult := otherKeeper typesForClass: cl instvar: iv.
		(res types sameElements: correspondingResult types) ifTrue: [result add: cl->iv]].
	^result
! !

!TypingResultKeeper class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/RoelTyper__TypingResultKeeper.st,v 1.2 2009/10/02 14:02:47 cg Exp $'
! !
