"{ Package: 'stx:goodies/roelTyper' }"
!

!Association methodsFor:'printing'!

typeComparerDisplayString

	^value displayString
! !

!Behavior methodsFor:'*RoelTyper-enumerating'!

nonMetaSubclassesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the receiver's immediate non-meta subclasses."

	self subclasses do: aBlock
! !

!Class methodsFor:'*RoelTyper-enumerating'!

nonMetaSubclassesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the receiver's immediate non-meta subclasses."
	"This one is here for the sake of Squeak (where it is Class and not Behavior that keeps the subclasses instance variable)."

	subclasses == nil 
		ifFalse: [subclasses do: aBlock]
! !

!ClassDescription methodsFor:'*RoelTyper-organization'!

categoryForSelector: aSelector 
	"Starting from the receiver, find the category for the given selector (if any). "
	"Works for Squeak as well,so do not use the fancy ifNil:ifNotNil: trick with arguments from VW, as Squeak does not digest it."

	| cat s |
	^(cat := self whichCategoryIncludesSelector: aSelector) ifNil: 
			[(s := self superclass) ifNil: [nil]
				ifNotNil: [s categoryForSelector: aSelector]]
		ifNotNil: [cat]
! !

!Collection methodsFor:'*RoelTyper-testing'!

sameElements: aCollection 

	^(self allSatisfy: [:each | aCollection includes: each]) 
		and: [aCollection allSatisfy: [:each | self includes: each]]
! !

!Object methodsFor:'printing'!

typeComparerDisplayString

	^self displayString
! !

!RoelTyper::InstructionStream::MethodArg methodsFor:'accessing'!

index
    ^ index
! !

!RoelTyper::InstructionStream::MethodArg methodsFor:'accessing'!

index:something
    index := something.
! !

