"{ Package: 'stx:goodies/roelTyper/stx' }"

"{ NameSpace: RoelTyper }"

Object subclass:#InstructionStream
	instanceVariableNames:'method pc stack byte client'
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-STX'
!

Object subclass:#MethodArg
	instanceVariableNames:'index'
	classVariableNames:''
	poolDictionaries:''
	privateIn:InstructionStream
!

!InstructionStream class methodsFor:'documentation'!

documentation
"
        |input method|

        method := Collection compiledMethodAt:#addAll:.

        input := InstructionStream on: method.
        [input atEnd]
                whileFalse:
                        [input interpretNextInstructionFor: self]
"
! !

!InstructionStream class methodsFor:'instance creation'!

on:aMethod
    ^ self new method:aMethod
! !

!InstructionStream methodsFor:'double dispatch'!

bytecode
"
/*
 * ST/X bytecodes
 */
#define RET_TOP         0       /* return top of stack */
#define RET_NIL         1       /* return nil */
#define RET_TRUE        2       /* return true */
#define RET_FALSE       3       /* return false */
#define RET_0           4       /* return 0 */
#define RET_SELF        5       /* return the receiver */
#define DUP_OVER        6       /* copy over i.e. push 2nd on stack */
#define HOMERET_TOP     7       /* return top from home-method */

#define LINENO          8
#define LINENO16        9

#define PUSH_NIL        10      /* push nil */
#define PUSH_TRUE       11      /* push true */
#define PUSH_FALSE      12      /* push false */
#define SEND_SELF       13      /* send a message to self */
#define PUSH_LIT        14      /* push a literal */
#define PUSH_SELF       15      /* push self */

#define PUSH_NUM        16      /* push a number -128 .. 127 */
#define PUSH_NUM16      17      /* push a number -8000 .. 7FFF */

#define DROP            18      /* pop stack */

#define SEND_MSG        19      /* send a message */
#define SUPERSEND_MSG   20      /* send a super-message */

#define SEND_MSG0       21      /* send a 0-arg message */
#define SEND_MSG1       22      /* send a 1-arg message */
#define SEND_MSG2       23      /* send a 2-arg message */
#define SEND_MSG3       24      /* send a 3-arg message */

#define SEND_DROP       25      /* send a message and forget result */
#define SEND0_DROP      26      /* send a 0-arg message and forget result */
#define SEND1_DROP      27      /* send a 1-arg message and forget result */
#define SEND2_DROP      28      /* send a 2-arg message and forget result */
#define SEND3_DROP      29      /* send a 3-arg message and forget result */

#define PUSH_MARG       30      /* push method argument */
#define PUSH_MVAR       31      /* push method variable */
#define PUSH_BARG       32      /* push block argument */
#define PUSH_BVAR       33      /* push block variable */
#define PUSH_IVAR       34      /* push instance variable */

#define PUSH_CVAR       35      /* push class variable */
#define PUSH_GLOB       36      /* push global variable */

#define STORE_MVAR      37      /* store top of stack in method variable */
#define STORE_BVAR      38      /* store top of stack in block variable */
#define STORE_IVAR      39      /* store top of stack in instance variable */

#define STORE_CVAR      40      /* store top of stack in class variable */
#define STORE_GLOB      41      /* store top of stack in global variable */

#define PUSH_OUTBARG    42      /* push arg of outer block (n levels) */
#define PUSH_OUT1BARG   43      /* push arg of outer block (1 level) */
#define PUSH_OUT2BARG   44      /* push arg of outer block (2 levels) */

#define EQEQ            45      /* push true if top 2 elements are equal */
#define NENE            46      /* push true if top 2 are not equal */
#define DUP             47      /* duplicate top of stack */
#define EQEQ0           48      /* push true if top of stack is 0 */
#define NENE0           49      /* push true if top of stack is not 0 */

#define JMP_FALSE       50      /* jump if top is false (+127 .. -128) */
#define JMP_TRUE        51      /* jump if top is true */
#define JMP_NIL         52      /* jump if top is nil */
#define JMP_NOTNIL      53      /* jump if top is notnil */
#define JMP             54      /* jump */
#define MAKE_BLOCK      55
#define JMP_ZERO        56      /* jump if top is zero */
#define JMP_NOTZERO     57      /* jump if top is not zero */
#define JMP_EQ          58      /* jump if top 2 are equal */
#define JMP_NOTEQ       59      /* jump if top 2 are not equal */

#define JMPL_FALSE      60      /* jump if false (add +128/-128 to offs) */
#define JMPL_TRUE       61
#define JMPL_NIL        62
#define JMPL_NOTNIL     63
#define JMPL            64
#define MAKE_LBLOCK     65
#define JMPL_ZERO       66
#define JMPL_NOTZERO    67
#define JMPL_EQ         68
#define JMPL_NOTEQ      69

#define JMPVL_FALSE     70      /* jump if false (add +256/-256 to offs) */
#define JMPVL_TRUE      71
#define JMPVL_NIL       72
#define JMPVL_NOTNIL    73
#define JMPVL           74
#define MAKE_VLBLOCK    75
#define JMPVL_ZERO      76
#define JMPVL_NOTZERO   77
#define JMPVL_EQ        78
#define JMPVL_NOTEQ     79

#define PUSH_MVAR1      80      /* push method variable */
#define PUSH_MVAR2      81
#define PUSH_MVAR3      82
#define PUSH_MVAR4      83
#define PUSH_MVAR5      84
#define PUSH_MVAR6      85

#define PUSH_MARG1      86      /* push method argument */
#define PUSH_MARG2      87
#define PUSH_MARG3      88
#define PUSH_MARG4      89

#define PUSH_IVAR1      90      /* push instance variable */
#define PUSH_IVAR2      91
#define PUSH_IVAR3      92
#define PUSH_IVAR4      93
#define PUSH_IVAR5      94
#define PUSH_IVAR6      95
#define PUSH_IVAR7      96
#define PUSH_IVAR8      97
#define PUSH_IVAR9      98
#define PUSH_IVAR10     99

#define STORE_MVAR1     100
#define STORE_MVAR2     101
#define STORE_MVAR3     102
#define STORE_MVAR4     103
#define STORE_MVAR5     104
#define STORE_MVAR6     105

#define PRIMITIVE       106     /* primitive by index - ignore result */
#define PRIMITIVE_P     107     /* primitive by index - push result */
#define OUTB_RETTOP     108     /* return top of stack from outer block */
#define UNUSED_109      109

#define STORE_IVAR1     110
#define STORE_IVAR2     111
#define STORE_IVAR3     112
#define STORE_IVAR4     113
#define STORE_IVAR5     114
#define STORE_IVAR6     115
#define STORE_IVAR7     116
#define STORE_IVAR8     117
#define STORE_IVAR9     118
#define STORE_IVAR10    119

#define PUSH_0          120     /* push constant 0 */
#define PUSH_1          121     /* push constant 1 */
#define PUSH_MINUS1     122     /* push constant -1 */
#define SEND_PLUS1      123     /* send + 1 */
#define SEND_MINUS1     124     /* send - 1 */
#define INC_MVAR        125     /* increment method variable */
#define DEC_MVAR        126     /* decrement method variable */
#define RET_NUM         127     /* return a number -128 .. 127 */
#define PUSH_OUTBVAR    128     /* push var of outer block (n levels) */
#define STORE_OUTBVAR   129     /* store top of stack in var of outer block (n levels) */

#define SEND_EQ         130     /* send = */
#define SEND_PLUS       131     /* send + */
#define SEND_NE         132     /* send ~= */
#define SEND_MINUS      133     /* send - */
#define SEND_CLASS      134     /* send class */
#define SEND_AT         135     /* send at:*/
#define SEND_ATPUT      136     /* send at:put: */
#define SEND_BITAND     137     /* send bitAnd: */
#define SEND_BITOR      138     /* send bitOr: */

#define PUSH_2          139     /* push constant 2 */

#define PUSH_BARG1      140     /* push block argument */
#define PUSH_BARG2      141
#define PUSH_BARG3      142
#define PUSH_BARG4      143

#define PUSH_CONTEXT    144

#define SEND_GT         145     /* send > */
#define SEND_GE         146     /* send >= */
#define SEND_LT         147     /* send < */
#define SEND_LE         148     /* send <= */

#define UNUSED_149      149     /* was: send next */
#define UNUSED_150      150     /* was: send peek */
#define SEND_VALUE      151     /* send value */
#define SEND_VALUE1     152     /* send value: */
#define SEND_SIZE       153     /* send size */
#define UNUSED_154      154
#define UNUSED_155      155

#define MK0BLOCK        156
#define MKNILBLOCK      157

#define UNUSED_158      158     /* was: send asInteger */
#define UNUSED_159      159     /* was: send rounded */

#define RET_MVAR1       160     /* return method variable */
#define RET_MVAR2       161
#define RET_MVAR3       162
#define RET_MVAR4       163
#define RET_MVAR5       164
#define RET_MVAR6       165

#define RET_IVAR1       166     /* return instance variable */
#define RET_IVAR2       167
#define RET_IVAR3       168
#define RET_IVAR4       169
#define RET_IVAR5       170
#define RET_IVAR6       171
#define RET_IVAR7       172
#define RET_IVAR8       173

#define RET_MARG1       174
#define RET_MARG2       175

#define PUSH_CIVAR      176     /* push class instance variable */
#define STORE_CIVAR     177     /* store top of stack in class instance variable */

#define SEND_VALUE2     178     /* send value:value: */
#define SEND_NOT        179

#define SEND_SELF0      180     /* send a 0-arg message to self */
#define SEND_SELF1      181     /* send a 1-arg message to self */
#define SEND_SELF2      182     /* send a 2-arg message to self */
#define SEND_SELF3      183     /* send a 3-arg message to self */

#define SEND_SELF_DROP0 184     /* send a 0-arg message to self forget result */
#define SEND_SELF_DROP1 185     /* send a 1-arg message to self forget result */
#define SEND_SELF_DROP2 186     /* send a 2-arg message to self forget result */
#define SEND_SELF_DROP3 187     /* send a 3-arg message to self forget result */

#define ISNIL           188
#define NOTNIL          189

#define JMPA_FALSE      190     /* jumps to absolute offset (2 byte hi-lo) */
#define JMPA_TRUE       191
#define JMPA_NIL        192
#define JMPA_NOTNIL     193
#define JMPA            194
#define MAKE_ABLOCK     195
#define JMPA_ZERO       196
#define JMPA_NOTZERO    197
#define JMPA_EQ         198
#define JMPA_NOTEQ      199

#define PUSH_GSPECIAL   200     /* push special global */
# define GSPECIAL_ARRAY                 0
# define GSPECIAL_STRING                1
# define GSPECIAL_FLOATARRAY            2
# define GSPECIAL_DOUBLEARRAY           3
# define GSPECIAL_POINT                 4
# define GSPECIAL_SYMBOL                5
# define GSPECIAL_SMALLTALK             6
# define GSPECIAL_PROCESSOR             7
# define GSPECIAL_SMALLINTEGER          8
# define GSPECIAL_CHARACTER             9
# define GSPECIAL_FLOAT                 10
# define GSPECIAL_PROCESS               11
# define GSPECIAL_SET                   12
# define GSPECIAL_IDENTITYSET           13
# define GSPECIAL_DICTIONARY            14
# define GSPECIAL_IDENTITYDICTIONARY    15
# define GSPECIAL_SEMAPHORE             16
# define GSPECIAL_ORDEREDCOLLECTION     17


#define PUSH_LLIT       201     /* push a literal (2-byte literal-number)*/

#define JMP_FALSE_L     202     /* jump if top is false (+127 .. -128) */
#define JMP_TRUE_L      203     /* jump if top is true */

#define VL_OP           204     /* operation with 32 bit literal index */
#define   VL_SEND_MSG       0     /* send with 32 bit literal index */
#define   VL_SUPERSEND_MSG  1     /* super send with 32 bit literal index */
#define   VL_PUSH_LIT       2     /* push a literal (4-byte literal-number)*/
#define   VL_PUSH_GLOB      3     /* push global variable (32bit index literal) */
#define   VL_STORE_GLOB     4     /* store global (32bit index literal) */

#define LSEND_MSG       205     /* send with 16 bit literal index */
#define LSUPERSEND_MSG  206     /* send with 16 bit literal index */
#define LSEND_SELF      207     /* send with 16 bit literal index */
#define PUSH_GT0        208

#define UNUSED_209      209

#define SEND_ARRAY_NEW  210     /* use for new/basicNew; top is size (0 for Array new) */
#define SEND_BASICNEW   211     /* top is class (receiver) */
#define SEND_GT0        212     /* send > 0 */
#define SEND_NEW        213     /* top is class (receiver) */
#define SEND_BASICNEWN  214     /* top is class (receiver) and arg */
#define SEND_NEWN       215     /* top is class (receiver) and arg */
#define SEND_LOGAND     216     /* send & */
#define SEND_LOGOR      217     /* send | */

#define PUSH_LGLOB      218     /* push global variable word index literal */
#define STORE_LGLOB     219     /* store global with word index literal */

#define UNUSED_220      220
#define UNUSED_221      221

#define PUSH_LIT1       222     /* push 1st literal */
#define PUSH_LIT2       223     /* push 2nd literal */
#define PUSH_LIT3       224     /* push literal 3 */
#define PUSH_LIT4       225     /* push literal 4 */
#define PUSH_LIT5       226     /* push literal 5 */
#define PUSH_LIT6       227     /* push literal 6 */
#define PUSH_LIT7       228     /* push literal 7 */
#define PUSH_LIT8       229     /* push literal 8 */

#define SEND_MUL        230     /* send * */
#define SEND_SPECIAL    231     /* special send */
# define SPECIAL_TOP    0
# define SPECIAL_BOTTOM 1
# define SPECIAL_LEFT   2
# define SPECIAL_RIGHT  3
# define SPECIAL_X      4
# define SPECIAL_Y      5
# define SPECIAL_WIDTH  6
# define SPECIAL_HEIGHT 7
# define SPECIAL_ORIGIN 8
# define SPECIAL_EXTENT 9
# define SPECIAL_ASINTEGER 10
# define SPECIAL_ROUNDED   11
# define SPECIAL_NEXT      12
# define SPECIAL_PEEK      13

#define PUSH_BVAR1      232
#define PUSH_BVAR2      233
#define PUSH_BVAR3      234

#define STORE_BVAR1     235
#define STORE_BVAR2     236
#define STORE_BVAR3     237

#define BLOCK_REF       238

#define PUSH_LVAR       239     /* push local variable 0..numArgs-1 for args; numArgs..numArgs+nLocal-1 for mVars */
#define STORE_LVAR      240     /* store local variable 0..numArgs-1 for args; numArgs..numArgs+nLocal-1 for mVars */

#define UNUSED_241      241
#define UNUSED_242      242
#define UNUSED_243      243
#define UNUSED_244      244
#define UNUSED_245      245
#define UNUSED_246      246
#define UNUSED_247      247
#define UNUSED_248      248
#define UNUSED_249      249
#define UNUSED_250      250
#define UNUSED_251      251
#define UNUSED_252      252
#define UNUSED_253      253
#define UNUSED_254      254
#define UNUSED_255      255

#ifdef ST80_SUPPORT
/*
 * st80 bytecodes (???)
 */
#endif /* ST80_SUPPORT */

#ifdef SQUEAK_SUPPORT
/*
 * Squeak bytecodes (2.4)
 */
#define SQ_PUSH_IVAR1     0      /* push instance variable */
#define SQ_PUSH_IVAR2     1
#define SQ_PUSH_IVAR3     2
#define SQ_PUSH_IVAR4     3
#define SQ_PUSH_IVAR5     4
#define SQ_PUSH_IVAR6     5
#define SQ_PUSH_IVAR7     6
#define SQ_PUSH_IVAR8     7
#define SQ_PUSH_IVAR9     8
#define SQ_PUSH_IVAR10    9
#define SQ_PUSH_IVAR11    10
#define SQ_PUSH_IVAR12    11
#define SQ_PUSH_IVAR13    12
#define SQ_PUSH_IVAR14    13
#define SQ_PUSH_IVAR15    14
#define SQ_PUSH_IVAR16    15

#define SQ_PUSH_TMP1      16
#define SQ_PUSH_TMP2      17
#define SQ_PUSH_TMP3      18
#define SQ_PUSH_TMP4      19
#define SQ_PUSH_TMP5      20
#define SQ_PUSH_TMP6      21
#define SQ_PUSH_TMP7      22
#define SQ_PUSH_TMP8      23
#define SQ_PUSH_TMP9      24
#define SQ_PUSH_TMP10     25
#define SQ_PUSH_TMP11     26
#define SQ_PUSH_TMP12     27
#define SQ_PUSH_TMP13     28
#define SQ_PUSH_TMP14     29
#define SQ_PUSH_TMP15     30
#define SQ_PUSH_TMP16     31

#define SQ_PUSH_LIT1      32
#define SQ_PUSH_LIT2      33
#define SQ_PUSH_LIT3      34
#define SQ_PUSH_LIT4      35
#define SQ_PUSH_LIT5      36
#define SQ_PUSH_LIT6      37
#define SQ_PUSH_LIT7      38
#define SQ_PUSH_LIT8      39
#define SQ_PUSH_LIT9      40
#define SQ_PUSH_LIT10     41
#define SQ_PUSH_LIT11     42
#define SQ_PUSH_LIT12     43
#define SQ_PUSH_LIT13     44
#define SQ_PUSH_LIT14     45
#define SQ_PUSH_LIT15     46
#define SQ_PUSH_LIT16     47
#define SQ_PUSH_LIT17     48
#define SQ_PUSH_LIT18     49
#define SQ_PUSH_LIT19     50
#define SQ_PUSH_LIT20     51
#define SQ_PUSH_LIT21     52
#define SQ_PUSH_LIT22     53
#define SQ_PUSH_LIT23     54
#define SQ_PUSH_LIT24     55
#define SQ_PUSH_LIT25     56
#define SQ_PUSH_LIT26     57
#define SQ_PUSH_LIT27     58
#define SQ_PUSH_LIT28     59
#define SQ_PUSH_LIT29     60
#define SQ_PUSH_LIT30     61
#define SQ_PUSH_LIT31     62
#define SQ_PUSH_LIT32     63

#define SQ_PUSH_LITV1     64
#define SQ_PUSH_LITV2     65
#define SQ_PUSH_LITV3     66
#define SQ_PUSH_LITV4     67
#define SQ_PUSH_LITV5     68
#define SQ_PUSH_LITV6     69
#define SQ_PUSH_LITV7     70
#define SQ_PUSH_LITV8     71
#define SQ_PUSH_LITV9     72
#define SQ_PUSH_LITV10    73
#define SQ_PUSH_LITV11    74
#define SQ_PUSH_LITV12    75
#define SQ_PUSH_LITV13    76
#define SQ_PUSH_LITV14    77
#define SQ_PUSH_LITV15    78
#define SQ_PUSH_LITV16    79
#define SQ_PUSH_LITV17    80
#define SQ_PUSH_LITV18    81
#define SQ_PUSH_LITV19    82
#define SQ_PUSH_LITV20    83
#define SQ_PUSH_LITV21    84
#define SQ_PUSH_LITV22    85
#define SQ_PUSH_LITV23    86
#define SQ_PUSH_LITV24    87
#define SQ_PUSH_LITV25    88
#define SQ_PUSH_LITV26    89
#define SQ_PUSH_LITV27    90
#define SQ_PUSH_LITV28    91
#define SQ_PUSH_LITV29    92
#define SQ_PUSH_LITV30    93
#define SQ_PUSH_LITV31    94
#define SQ_PUSH_LITV32    95

#define SQ_STORE_IVAR1    96
#define SQ_STORE_IVAR2    97
#define SQ_STORE_IVAR3    98
#define SQ_STORE_IVAR4    99
#define SQ_STORE_IVAR5    100
#define SQ_STORE_IVAR6    101
#define SQ_STORE_IVAR7    102
#define SQ_STORE_IVAR8    103

#define SQ_STORE_TMP1     104
#define SQ_STORE_TMP2     105
#define SQ_STORE_TMP3     106
#define SQ_STORE_TMP4     107
#define SQ_STORE_TMP5     108
#define SQ_STORE_TMP6     109
#define SQ_STORE_TMP7     110
#define SQ_STORE_TMP8     111

#define SQ_PUSH_SELF      112
#define SQ_PUSH_TRUE      113
#define SQ_PUSH_FALSE     114
#define SQ_PUSH_NIL       115
#define SQ_PUSH_MINUS1    116
#define SQ_PUSH_0         117
#define SQ_PUSH_1         118
#define SQ_PUSH_2         119

#define SQ_RET_SELF       120
#define SQ_RET_TRUE       121
#define SQ_RET_FALSE      122
#define SQ_RET_NIL        123
#define SQ_HOMERET_TOP    124
#define SQ_BRET_TOP       125

#define SQ_UNUSED126      126
#define SQ_UNUSED127      127
#define SQ_EXT_PUSH       128
#define SQ_EXT_STORE      129
#define SQ_EXT_STOREPOP   130
#define SQ_SINGLE_EXT_SEND      131
#define SQ_DBL_EXT_DOANY        132
#define SQ_SINGLE_EXT_SUPERSEND 133
#define SQ_SECOND_EXT_SEND      134

#define SQ_POP            135
#define SQ_DUP            136
#define SQ_PUSH_CONTEXT   137

#define SQ_EXPERIMENTAL1  137
#define SQ_EXPERIMENTAL2  138
#define SQ_EXPERIMENTAL3  139
#define SQ_EXPERIMENTAL4  140
#define SQ_EXPERIMENTAL5  141
#define SQ_EXPERIMENTAL6  142

#define SQ_SHORT_JMP0     144
#define SQ_SHORT_JMP1     145
#define SQ_SHORT_JMP2     146
#define SQ_SHORT_JMP3     147
#define SQ_SHORT_JMP4     148
#define SQ_SHORT_JMP5     149
#define SQ_SHORT_JMP6     150
#define SQ_SHORT_JMP7     151

#define SQ_SHORT_CCJMP0   152
#define SQ_SHORT_CCJMP1   153
#define SQ_SHORT_CCJMP2   154
#define SQ_SHORT_CCJMP3   155
#define SQ_SHORT_CCJMP4   156
#define SQ_SHORT_CCJMP5   157
#define SQ_SHORT_CCJMP6   158
#define SQ_SHORT_CCJMP7   159

#define SQ_LONG_JMP0      160
#define SQ_LONG_JMP1      161
#define SQ_LONG_JMP2      162
#define SQ_LONG_JMP3      163
#define SQ_LONG_JMP4      164
#define SQ_LONG_JMP5      165
#define SQ_LONG_JMP6      166
#define SQ_LONG_JMP7      167

#define SQ_LONG_JMP_TRUE  168
#define SQ_LONG_JMP_TRUE  169
#define SQ_LONG_JMP_TRUE  170
#define SQ_LONG_JMP_TRUE  171

#define SQ_LONG_JMP_FALSE 172
#define SQ_LONG_JMP_FALSE 173
#define SQ_LONG_JMP_FALSE 174
#define SQ_LONG_JMP_FALSE 175

#define SQ_PRIM_ADD       176
#define SQ_PRIM_SUBTRACT  177
#define SQ_PRIM_LESS      178
#define SQ_PRIM_GREATER   179
#define SQ_PRIM_LESS_EQ   180
#define SQ_PRIM_GREATER_EQ 181
#define SQ_PRIM_EQUAL      182
#define SQ_PRIM_NOT_EQUAL  183
#define SQ_PRIM_MUL       184
#define SQ_PRIM_DIV       185
#define SQ_PRIM_MOD       186
#define SQ_PRIM_MKPOINT   187
#define SQ_PRIM_BITSHIFT  188
#define SQ_PRIM_DIV       189
#define SQ_PRIM_BITAND    190
#define SQ_PRIM_BITOR     191

#define SQ_PRIM_AT        192
#define SQ_PRIM_AT_PUT    193
#define SQ_PRIM_SIZE      194
#define SQ_PRIM_NEXT      195
#define SQ_PRIM_NEXTPUT   196
#define SQ_PRIM_ATEND     197
#define SQ_PRIM_EQUIV     198
#define SQ_PRIM_CLASS     199
#define SQ_PRIM_BLOCK_COPY 200
#define SQ_PRIM_VALUE0     201
#define SQ_PRIM_VALUE1     202
#define SQ_PRIM_DO         203
#define SQ_PRIM_NEW0       204
#define SQ_PRIM_NEW1       205
#define SQ_PRIM_PNT_X      206
#define SQ_PRIM_PNT_Y      207

#define SQ_PRIM_SEND_LIT1   208
#define SQ_PRIM_SEND_LIT2   209
#define SQ_PRIM_SEND_LIT3   210
#define SQ_PRIM_SEND_LIT4   211
#define SQ_PRIM_SEND_LIT5   212
#define SQ_PRIM_SEND_LIT6   213
#define SQ_PRIM_SEND_LIT7   214
#define SQ_PRIM_SEND_LIT8   215
#define SQ_PRIM_SEND_LIT9   216
#define SQ_PRIM_SEND_LIT10  217
#define SQ_PRIM_SEND_LIT11  218
#define SQ_PRIM_SEND_LIT12  219
#define SQ_PRIM_SEND_LIT13  220
#define SQ_PRIM_SEND_LIT14  221
#define SQ_PRIM_SEND_LIT15  222
#define SQ_PRIM_SEND_LIT16  223
#define SQ_PRIM_SEND_LIT17  224
#define SQ_PRIM_SEND_LIT18  225
#define SQ_PRIM_SEND_LIT19  226
#define SQ_PRIM_SEND_LIT20  227
#define SQ_PRIM_SEND_LIT21  228
#define SQ_PRIM_SEND_LIT22  229
#define SQ_PRIM_SEND_LIT23  230
#define SQ_PRIM_SEND_LIT24  231
#define SQ_PRIM_SEND_LIT25  232
#define SQ_PRIM_SEND_LIT26  233
#define SQ_PRIM_SEND_LIT27  234
#define SQ_PRIM_SEND_LIT28  235
#define SQ_PRIM_SEND_LIT29  236
#define SQ_PRIM_SEND_LIT30  237
#define SQ_PRIM_SEND_LIT31  238
#define SQ_PRIM_SEND_LIT32  239
#define SQ_PRIM_SEND_LIT33  240
#define SQ_PRIM_SEND_LIT34  241
#define SQ_PRIM_SEND_LIT35  242
#define SQ_PRIM_SEND_LIT36  243
#define SQ_PRIM_SEND_LIT37  244
#define SQ_PRIM_SEND_LIT38  245
#define SQ_PRIM_SEND_LIT39  246
#define SQ_PRIM_SEND_LIT40  247
#define SQ_PRIM_SEND_LIT41  248
#define SQ_PRIM_SEND_LIT42  249
#define SQ_PRIM_SEND_LIT43  250
#define SQ_PRIM_SEND_LIT44  251
#define SQ_PRIM_SEND_LIT45  252
#define SQ_PRIM_SEND_LIT46  253
#define SQ_PRIM_SEND_LIT47  254
#define SQ_PRIM_SEND_LIT48  255

#endif /* SQUEAK_SUPPORT */
"
!

interpretNextInstructionFor:aClient
    |dispatchTable|

    client := aClient.
    byte := method byteCode at:pc.

 dispatchTable := #(
"00"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"10"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"20"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"30"    invalid invalid invalid invalid invalid invalid invalid makeBlock invalid invalid invalid invalid invalid invalid invalid invalid
"40"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"50"    invalid invalid invalid invalid invalid invalid pushMarg1 pushMarg2 pushMarg3 pushMarg4 invalid invalid invalid invalid invalid invalid
"60"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"70"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid

"80"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"90"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"A0"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"B0"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"C0"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"D0"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"E0"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
"F0"    invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid invalid
  ).

    self perform:(dispatchTable at:byte+1) asSymbol
!

invalidFor:aClient
    self error.
!

makeBlock
    |delta nV nA|

    pc := pc + 1.
    delta := method byteCode at:pc.
    pc := pc + 1.
    nV := method byteCode at:pc.
    pc := pc + 1.
    nA := method byteCode at:pc.

    self halt.
!

pushMarg1
    pc := pc + 1.
    client pushLocal:0.
! !

!InstructionStream methodsFor:'instance creation'!

method:aMethod
    aMethod byteCode isNil ifTrue:[
        method := aMethod asByteCodeMethod
    ] ifFalse:[
         method := aMethod
    ].
    stack := OrderedCollection new.
    pc := 1.
! !

!InstructionStream methodsFor:'queries'!

atEnd
    ^ pc > method byteCode size
! !

!InstructionStream::MethodArg methodsFor:'accessing'!

index
    ^ index
!

index:something
    index := something.
! !

!InstructionStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/stx/RoelTyper__InstructionStream.st,v 1.1 2009/10/02 00:44:05 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/stx/RoelTyper__InstructionStream.st,v 1.1 2009/10/02 00:44:05 cg Exp $'
! !
