"{ Package: 'stx:goodies/roelTyper/stx' }"

"{ NameSpace: RoelTyper }"

BrowserDefinitionTool subclass:#RBClassTyperUITool
	instanceVariableNames:'typeResults'
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-UI'
!


!RBClassTyperUITool class methodsFor:'interface specs'!

windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec
		#window:
		#(#WindowSpec
			#label: 'Unlabeled Canvas'
			#bounds: #(#Rectangle 640 512 1006 737 ) )
		#component:
		#(#SpecCollection
			#collection: #(
				#(#TextEditorSpec
					#layout: #(#LayoutFrame 0 0 0 0 0 0.75 0 1 )
					#name: #textEditor
					#model: #textHolder
					#callbacksSpec:
					#(#UIEventCallbackSubSpec
						#valueChangeSelector:
						#textAccepted: )
					#menu: #menu
					#tabRequiresControl: true )
"/                                #(#ResizingSplitterSpec
"/                                        #layout: #(#LayoutFrame -1 0.75 0 0 1 0.75 0 1 )
"/                                        #name: #ResizingSplitter1
"/                                        #horizontal: false
"/                                        #minAboveSize: 30
"/                                        #minBelowSize: 30
"/                                        #aboveWidgets: 'textEditor'
"/                                        #belowWidgets: 'typeResults' )
				#(#TreeViewSpec
					#properties: #(#PropertyListDictionary #fullLineSelect true )
					#layout: #(#LayoutFrame 1 0.75 0 0 0 1 -30 1 )
					#name: #typeResults
					#model: #typeResults
					#callbacksSpec:
					#(#{UI.UIEventCallbackSubSpec}
						#valueChangeSelector: #selectionChanged
						#doubleClickSelector: #explainSelection )
					#helpText: ''
					#menu: #typingResultsMenu
					#multipleSelections: false
					#useModifierKeys: true
					#selectionType: #highlight
					#useIcons: #none
					#useLines: false
					#rootExpander: true )
				#(#ActionButtonSpec
					#layout: #(#LayoutFrame 0 0.75 -29 1 0 1 0 1 )
					#name: #explainSelection
					#flags: 40
					#model: #explainSelection
					#helpText: 'Edit the types for the selected instance variable'
					#label: 'Explain' ) ) ) )
! !

!RBClassTyperUITool class methodsFor:'resources'!

typingResultsMenu
	"Tools.MenuEditor new openOnClass: self andSelector: #typingResultsMenu"

	<resource: #menu>
	^#(#Menu #(
			#(#MenuItem
				#rawLabel: 'Explain'
				#nameKey: #explainSelection
				#value: #explainSelection
				#helpText: 'Explain the results of the type found' ) ) #(1 ) nil ) decodeAsLiteralArray
! !

!RBClassTyperUITool methodsFor:'actions'!

explainSelection

	| selection |
	selection := self selectedTypeResult.
	selection isNil ifTrue: [^self].
	selection isExtractedResult
		ifTrue: [TypingResultExplainer openOnTypingResult: self selectedTypeResult]
		ifFalse:
			[Dialog warn: 'Type was given manually.\ Nothing to explain.' withCRs]
! !

!RBClassTyperUITool methodsFor:'aspects'!

typeResults
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^typeResults isNil
		ifTrue:
			[typeResults := SelectionInTree new]
		ifFalse:
			[typeResults]
! !

!RBClassTyperUITool methodsFor:'changing'!

selectionChanged

	(self widgetAt: #explainSelection) isEnabled: self typeResults selection notNil
! !

!RBClassTyperUITool methodsFor:'private'!

selectedTypeResult

	| selection |
	selection := self selectedTypeResultDetail.
	selection isNil ifTrue: [^nil].
	^self typeResultKeeper typesForClass: self nonMetaClass instvar: selection key
!

selectedTypeResultDetail
	"Return an Association where the key is the name of the instance variable corresponding to the selection, and the value is one of the type results for that variable. Returns nil if nothing is selected.

Note: since the treeModel is very poor I use the view sequence to find the necessary information. The alternative ouwld be to use display blocks for the tree view so that I can enrich the model, but I do not feel like it at the moment."

	| index treeModel node toReturn |
	treeModel := (self widgetAt: #typeResults) sequence.
	index := self typeResults selectionIndex.
	index = 0 ifTrue: [^nil].
	node := treeModel wrapperAt: index.
	(node levelDescription size = 0) ifTrue: [^Association key: node value value: nil].
	toReturn := Association key: nil value: node value.
	[node levelDescription size = 0] whileFalse: [
		index := index - 1.
		node := treeModel wrapperAt: index.
	].
	toReturn key: node value.
	^toReturn
!

typeResultKeeper

	^TypingResultKeeper new
!

updateTypeResults
	| typesPerVariable tree |
	typesPerVariable := self typeResultKeeper typesForClass: self nonMetaClass.
	tree := self treeFor: typesPerVariable.
	self typeResults list: tree
! !

!RBClassTyperUITool methodsFor:'tab APIs'!

isActive

	^self selectedBinding notNil
!

tabName

	^'Source+Types'
! !

!RBClassTyperUITool methodsFor:'updating'!

expansionLimit
	^4
!

treeFor: typesPerVariable
	| tree |
	tree := TreeModel
				on: typesPerVariable
				displayRoot: false
				childrenWith:
					[:each |
					(each isKindOf: Dictionary)
						ifTrue: [each keys]
						ifFalse: [(typesPerVariable at: each) types]]
				testHasChildrenWith: [:each | each isBehavior not].
	(tree childrenFor: typesPerVariable) do:
			[:each |
			(tree childrenFor: each) size > self expansionLimit
				ifFalse: [tree expand: (tree indexOf: each)]].
	^tree
!

updateContents

	super updateContents.
	self updateTypeResults
! !

!RBClassTyperUITool class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/stx/RoelTyper__RBClassTyperUITool.st,v 1.3 2009/10/02 14:03:33 cg Exp $'
! !
