"{ Package: 'stx:goodies/roelTyper/stx' }"

"{ NameSpace: RoelTyper }"

ApplicationModel subclass:#TypingResultExplainer
	instanceVariableNames:'assignmentsList interfaceList typingResult'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-UIApplications-New'
!

TypingResultExplainer comment:'I am able to explain the results of a typingresult by showing the interface (messages sent to) and the assignments to an instance variable as found by the typing algorithm.

Instance Variables:
	assignmentsList <SelectionInList>       description of assignmentsList
	interfaceList   <SelectionInList>       description of interfaceList'
!


!TypingResultExplainer class methodsFor:'instance creation'!

onTypingResult: aTypingResult

	^self new typingResult: aTypingResult
! !

!TypingResultExplainer class methodsFor:'exporting'!

appendMethodNewForPlatformTo: aFileName
	"This method is different between Squeak and VW. To not have Undeclared in Squeak fill with an entry to VWTypeCollector I decided to generate the Squeak specific method here and append it to the file. Therefore the one referencing VWTypeCollector will be replaced with this implementation, and the Monticello file that is generated from within Squeak will be correct and not cause any Undeclared''s to be added."

	| stream |
	stream := aFileName asFilename appendStream.
	[ stream atEnd.
	  stream nextPutAll:

'!!TypeCollector class methodsFor: ''instance creation'' stamp: '' 29/5/07 18:39''!!

newForPlatform
	"Return either a VWTypeCollector or a SqueakTypeCollector, depending on the platform used."
	"Generated during generation of Squeak files from within VisualWorks."

	^SqueakTypeCollector basicNew!!' ] ensure: [stream close].
!

exportToSqueak
	"self exportToSqueak"

	"Export the RoelTyper and RoelTyperTests to Squeak. Keep this method here because this class is in the RoelTyperUI package, which does not get exported (since this method would not make sense in Squeak and furthermore since it causes troubles when loading it)."

	| exportFormatToRestore |
	(#{Store.PundleAccess} bindingOrNil isNil
		or: [(Store.Registry pundleNamed: #FileOut30) isNil])
			ifTrue:
				[Dialog
					warn: 'The FileOut30 package needs to be loaded first (see Cincom Store)'.
				^self].
	exportFormatToRestore := UI.UISettings preferenceFor: #fileOutType.

	[ | roelTyperFilename |
	 roelTyperFilename := 'RoelTyper.st'.
	 UI.UISettings preferenceFor: #fileOutType
		put: #'SqueakCompatibility.SqueakChangeSetFileFormat'.
	(Store.Registry pundleNamed: #RoelTyper)
		fileOutOnFileNamed: roelTyperFilename.
	self appendMethodNewForPlatformTo: roelTyperFilename.
	(Store.Registry pundleNamed: #RoelTyperSqueak)
		fileOutOnFileNamed: 'RoelTyperSqueak.st'.
	(Store.Registry pundleNamed: #RoelTyperTests)
		fileOutOnFileNamed: 'RoelTyperTests.st']
			ensure: [UI.UISettings preferenceFor: #fileOutType put: exportFormatToRestore]
! !

!TypingResultExplainer class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:TypingResultExplainer andSelector:#windowSpec
     TypingResultExplainer new openInterface:#windowSpec
     TypingResultExplainer open
    "

    <resource: #canvas>

    ^
     #(FullSpec
	name: windowSpec
	window:
       (WindowSpec
	  label: 'Typing Result Explainer'
	  name: 'Typing Result Explainer'
	  bounds: (Rectangle 0 0 407 224)
	)
	component:
       (SpecCollection
	  collection: (
	   (VariableHorizontalPanelSpec
	      name: 'VariableHorizontalPanel1'
	      layout: (LayoutFrame 0 0 0 0 0 1 0 1)
	      component:
	     (SpecCollection
		collection: (
		 (ViewSpec
		    name: 'Box1'
		    component:
		   (SpecCollection
		      collection: (
		       (LabelSpec
			  label: 'Interface'
			  name: InterfaceLabel
			  layout: (LayoutFrame 0 0 0 0 0 1 30 0)
			)
		       (SequenceViewSpec
			  name: interfaceList
			  layout: (LayoutFrame 0 0 30 0 0 1 0 1)
			  model: interfaceList
			  hasHorizontalScrollBar: true
			  hasVerticalScrollBar: true
			  miniScrollerHorizontal: true
			  useIndex: false
			  useModifierKeys: true
			)
		       )

		    )
		  )
		 (ViewSpec
		    name: 'Box2'
		    component:
		   (SpecCollection
		      collection: (
		       (LabelSpec
			  label: 'Assignments'
			  name: assignmentsLabel
			  layout: (LayoutFrame 0 0 0 0 0 1 30 0)
			)
		       (SequenceViewSpec
			  name: assignmentsList
			  layout: (LayoutFrame 0 0 30 0 0 1 0 1)
			  model: assignmentsList
			  hasHorizontalScrollBar: true
			  hasVerticalScrollBar: true
			  miniScrollerHorizontal: true
			  useIndex: false
			  useModifierKeys: true
			)
		       )

		    )
		  )
		 )

	      )
	      handles: (Any 0.5 1.0)
	    )
	   )

	)
      )
! !

!TypingResultExplainer class methodsFor:'opening'!

openOnTypingResult: aTypingResult

	^self openOn: (self onTypingResult: aTypingResult)
! !

!TypingResultExplainer methodsFor:'accessing'!

typingResult
	^typingResult
!

typingResult: aTypingResult

	typingResult := aTypingResult.
	self interfaceList list: aTypingResult interface asList.
	self assignmentsList list: aTypingResult assignments asList
! !

!TypingResultExplainer methodsFor:'aspects'!

assignmentsList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^assignmentsList isNil
		ifTrue:
			[assignmentsList := SelectionInList new]
		ifFalse:
			[assignmentsList]
!

interfaceList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^interfaceList isNil
		ifTrue:
			[interfaceList := SelectionInList new]
		ifFalse:
			[interfaceList]
! !

!TypingResultExplainer class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/stx/RoelTyper__TypingResultExplainer.st,v 1.3 2009/10/02 14:03:33 cg Exp $'
! !
