"{ Package: 'stx:goodies/roelTyper/tests' }"

"{ NameSpace: RoelTyper }"

TypeMergerTestsRoot subclass:#ConcreteMergerTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'RoelTyper-Tests'
!


!ConcreteMergerTests methodsFor:'auxiliary'!

mergeClass

	^ConcreteMerger
! !

!ConcreteMergerTests methodsFor:'folding tests'!

test1
	"assignment type Array is subtype of interface type Collection
		-> folding keeps Array and loses Collection"


	self mergeInterfaceTypes: (OrderedCollection with: Collection) assignmentTypes: (OrderedCollection with: Array).
	self assert: mergeResult size = 1.
	self assert: mergeResult first = Array.
!

test10
	"Dictionary and Array are in unrelated hierarchies -> keep both."

	self mergeInterfaceTypes: (OrderedCollection with: Dictionary) assignmentTypes: (OrderedCollection with: Array with: Collection).
	self assert: mergeResult size = 3.
	self assert: (mergeResult includes: Dictionary).
	self assert: (mergeResult includes: Array).
	self assert: (mergeResult includes: Collection).
!

test11
	"Dictionary and Array are in unrelated hierarchies -> keep both."

	self mergeInterfaceTypes: (OrderedCollection with: Dictionary) assignmentTypes: (OrderedCollection with: Collection with: Array ).
	self assert: mergeResult size = 3.
	self assert: (mergeResult includes: Dictionary).
	self assert: (mergeResult includes: Array).
	self assert: (mergeResult includes: Collection).
!

test12
	"Dictionary and Array are in unrelated hierarchies -> keep both. Collection bites the dust because it is superclass."

	self mergeInterfaceTypes: (OrderedCollection with: Collection) assignmentTypes: (OrderedCollection with: Dictionary with: Array ).
	self assert: mergeResult size = 2.
	self assert: (mergeResult includes: Dictionary).
	self assert: (mergeResult includes: Array).
!

test13
	"Dictionary and Array are in unrelated hierarchies -> keep both. Collection bites the dust because it is superclass."

	self mergeInterfaceTypes: (OrderedCollection with: Collection) assignmentTypes: (OrderedCollection with: Array with: Dictionary).
	self assert: mergeResult size = 2.
	self assert: (mergeResult includes: Dictionary).
	self assert: (mergeResult includes: Array).
!

test14

	self mergeInterfaceTypes: (OrderedCollection with: SequenceableCollection with: Bag) assignmentTypes: (OrderedCollection with: Array).
	self assert: mergeResult size = 2.
	self assert: (mergeResult includes: Array).
	self assert: (mergeResult includes: Bag).
!

test2
	"interface type Array is subclass of assignment type Collection
		-> folding keeps Array and loses Collection"

	self mergeInterfaceTypes: (OrderedCollection with: Array) assignmentTypes: (OrderedCollection with: Collection).
	self assert: mergeResult size = 2.
	self assert: (mergeResult includes: Array).
	self assert: (mergeResult includes: Collection)
!

test3

	self mergeInterfaceTypes: (OrderedCollection new) assignmentTypes: (OrderedCollection new).
	self assert: mergeResult size = 1.
	self assert: mergeResult first = Object
!

test4

	self mergeInterfaceTypes: (OrderedCollection with: Object) assignmentTypes: OrderedCollection new.
	self assert: mergeResult size = 1.
	self assert: mergeResult first = Object
!

test5

	self mergeInterfaceTypes: OrderedCollection new assignmentTypes: (OrderedCollection with: Object).
	self assert: mergeResult size = 1.
	self assert: mergeResult first = Object
!

test6
	"Dictionary and Array are in unrelated hierarchies -> keep both"


	self mergeInterfaceTypes: (OrderedCollection with: Dictionary) assignmentTypes: (OrderedCollection with: Array).
	self assert: mergeResult size = 2.
	self assert: (mergeResult includes: Dictionary).
	self assert: (mergeResult includes: Array).
!

test7

	self mergeInterfaceTypes: OrderedCollection new assignmentTypes: (OrderedCollection with: Array).
	self assert: mergeResult size = 1.
	self assert: (mergeResult includes: Array).
!

test8
	"Dictionary and Array are in unrelated hierarchies -> keep both"


	self mergeInterfaceTypes: (OrderedCollection with: Dictionary) assignmentTypes: (OrderedCollection with: Array with: Object).
	self assert: mergeResult size = 3.
	self assert: (mergeResult includes: Dictionary).
	self assert: (mergeResult includes: Array).
	self assert: (mergeResult includes: Object).
! !

!ConcreteMergerTests class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/roelTyper/tests/RoelTyper__ConcreteMergerTests.st,v 1.2 2009/10/02 14:04:04 cg Exp $'
! !
