"{ Package: 'stx:goodies' }"

LightInTheDark subclass:#LightInTheDark2
	instanceVariableNames:'dX dY stepCount steps destX destY state'
	classVariableNames:''
	poolDictionaries:''
	category:'demos-ScreenSaver'
!

LightInTheDark2 comment:'
start with:

    LightInTheDark2 open
'!

!LightInTheDark2 class methodsFor:'documentation'!

documentation
"
    searching SpotLight screensaver ...

    a simple full-screen view example.
    Also, demonstrates arbitrary shaped views (X displays only).

    [author:]
	Claus Gittinger

    [see also:]
	ScreenSaver LightInTheDark

    [start with:]
	LightInTheDark2 open
"


! !

!LightInTheDark2 methodsFor:'initialization'!

initialize
    steps := 20.
    super initialize.
    timedBlock := [self cycle]. timedBlock2 := nil.
    state := #initial.
! !

!LightInTheDark2 methodsFor:'private'!

cycle
    "move to a random new spot, stay awhile and again"

    self perform:state
!

decideNextDestination
    destX := (random next * (device width - radius)) rounded asInteger.
    destY := (random next * (device height - radius)) rounded asInteger.
    dX := (destX - xpos) / steps.
    dY := (destY - ypos) / steps.
    stepCount := steps
!

initial
    self fillHole.
    xpos := (random next * (device width - radius)) rounded asInteger.
    ypos := (random next * (device height - radius)) rounded asInteger.
    self punchHole.
    self decideNextDestination.
    state := #move.
    Processor addTimedBlock:timedBlock afterSeconds:2
!

move
    self fillHole.
    xpos := xpos + dX.
    ypos := ypos + dY.
    self punchHole.

    stepCount := stepCount - 1.
    (stepCount == 0) ifTrue:[
	self decideNextDestination.
	Processor addTimedBlock:timedBlock afterSeconds:2.
    ] ifFalse:[
	Processor addTimedBlock:timedBlock afterSeconds:0.05
    ]
! !

!LightInTheDark2 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/screenSavers/LightInTheDark2.st,v 1.7 2000/03/02 14:14:52 cg Exp $'
! !
