"{ Package: 'stx:goodies' }"

LightInTheDark subclass:#STXInTheDark
	instanceVariableNames:'image'
	classVariableNames:''
	poolDictionaries:''
	category:'demos-ScreenSaver'
!

!STXInTheDark class methodsFor:'documentation'!

documentation
"
    another screensaver ...

    a simple full-screen view example.

    [author:]
	Claus Gittinger

    [see also:]
	ScreenSaver LightInTheDark2

    [start with:]
	STXInTheDark open
"

! !

!STXInTheDark methodsFor:'initialization'!

initialize
    "create a big bitmap, to hold the shape
     (size of the screen - from which a bitmap is stamped out)"

    super initialize.

    image := (Image fromFile:'SmalltalkX.xbm') magnifiedBy:4.

    "STXInTheDark open"

    "Modified: 17.5.1996 / 12:07:09 / cg"
! !

!STXInTheDark methodsFor:'private'!

fillHole
    "fill a rectangular area in the shape bitmap (fill hole)"

    xpos notNil ifTrue:[
	bigForm paint:(Color colorId:1).
	bigForm fillRectangleX:xpos
			     y:ypos
			 width:image width
			height:image height.
    ]

    "Created: 17.5.1996 / 11:40:21 / cg"
    "Modified: 17.5.1996 / 11:40:45 / cg"
!

punchHole
    "punch out the images bits from the shape bitmap,
     and change my view shape."

    bigForm paint:(Color colorId:0).
    bigForm displayForm:image x:xpos y:ypos.

    self borderShape:bigForm.
    self viewShape:bigForm.
    device flush.

    "Modified: 17.5.1996 / 11:37:02 / cg"
    "Created: 17.5.1996 / 11:42:28 / cg"
! !

!STXInTheDark class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/screenSavers/STXInTheDark.st,v 1.5 2000/03/02 14:15:02 cg Exp $'
! !
