'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:41'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAAttributeSearchContext
	instanceVariableNames:'key attribute cachedValues attributeHolders attributeInheritors'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Configuration'
!

WAAttributeSearchContext comment:'This class makes attribute searching more efficient by traversing the ancestry once and caching which Configurations hold the attribute. It is then passed through search functions which cache values for the attribute.'
!

!WAAttributeSearchContext class methodsFor:'instance creation'!

key: keySymbol target: targetConfiguration
	^ self basicNew
		initializeWithKey: keySymbol;
		findAttributeAndSelectAncestorsOf: targetConfiguration;
		yourself
! !

!WAAttributeSearchContext methodsFor:'accessing'!

at: aConfiguration ifPresent: aBlock
	^ self cachedValues at: aConfiguration ifPresent: aBlock
!

at: aConfiguration put: cachedObject
	^ self cachedValues at: aConfiguration put: cachedObject
!

attribute
	^ attribute
!

key
	^ key
! !

!WAAttributeSearchContext methodsFor:'initialization'!

initializeWithKey: keySymbol
	self initialize.
	key := keySymbol.
	attributeHolders := Set new.
	attributeInheritors := Set new.
	cachedValues := Dictionary new
! !

!WAAttributeSearchContext methodsFor:'private'!

cachedValues
	^ cachedValues
!

findAttributeAndSelectAncestorsOf: aConfiguration
	| found |
	(attributeHolders includes: aConfiguration) ifTrue: [ ^ true ].
			
	aConfiguration localAttributeAt: self key ifPresent: [ :attr |
		attribute := attr.
		attributeHolders add: aConfiguration.
		^ true ].
		
	found := false.
	aConfiguration parents do: [ :each |
		found := found | (self findAttributeAndSelectAncestorsOf: each) ].
	
	found ifTrue: [ attributeInheritors add: aConfiguration ].
	
	^ found
! !

!WAAttributeSearchContext methodsFor:'testing'!

isAttributeFoundOn: aConfiguration 
	^ (self isAttributeLocalOn: aConfiguration) or: [ self isAttributeInheritedOn: aConfiguration ]
!

isAttributeInheritedOn: aConfiguration 
	^ attributeInheritors includes: aConfiguration
!

isAttributeLocalOn: aConfiguration 
	^ attributeHolders includes: aConfiguration
! !

