'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:42'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WASystemConfiguration subclass:#WAAuthConfiguration
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Filter'
!

WAAuthConfiguration comment:'WAAuthConfiguration defines attributes to store a username and password for an application. It is used by WAApplication to provide a basic single-account authentication mechanism for applications like the Seaside Configuration application. It changes to mainClass for the session to WAAuthMain, which adds a Decoration to check for authentication before displaying the root component.
You can implement your own authentication mechanism without using this configuration by subclassing WAApplication and implementing #verifyPassword:forUser: to lookup account details from a database or similar. You can then manually set WAAuthMain as your main class.
'
!

!WAAuthConfiguration methodsFor:'description'!

describeOn: config
	(config string: #login)
		group: #authentication;
		comment: 'The username for this application.'.
	(config password: #passwordHash)
		group: #authentication;
		comment: 'The password for this application.';
		label: 'Password'.
! !

