'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:40'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WARequestFilter subclass:#WAAuthenticationFilter
	instanceVariableNames:'authenticator realm'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Filter'
!

WAAuthenticationFilter comment:'WAAuthenticationFilter protects a request handler with username and password using the standard HTTP basic authentication. This passes username and password in clear-text, unless used over an encripted HTTPS connection. You should set the authenticator, and object that is able to validate usernames and passwords by implementing #verifyPassword:forUser:.'
!

!WAAuthenticationFilter methodsFor:'accessing'!

authenticator
	"Answer the object used for authentication. Defaults to the owning handler."

	^ authenticator ifNil: [ self handler ]
!

authenticator: anObject
	authenticator := anObject
!

realm
	"Answer the realm to be displayed in the authentication dialog."
	
	^ realm ifNil: [ realm := 'Seaside' ]
!

realm: anObject
	realm := anObject
! !

!WAAuthenticationFilter methodsFor:'processing'!

handleFiltered: aRequestContext 
	(self verifyRequest: aRequestContext request) 
		ifTrue: [ super handleFiltered: aRequestContext ]
		ifFalse: [
			aRequestContext responseGenerator
				authenticate: self realm;
				respond ]
! !

!WAAuthenticationFilter methodsFor:'testing'!

verifyRequest: aRequest
	^ self authenticator verifyPassword: aRequest password forUser: aRequest user
! !

