'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:41'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAResponse subclass:#WABufferedResponse
	instanceVariableNames:'contentsStream'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-HTTP'
!

WABufferedResponse comment:'A WABufferedResponse is a concrete implementation of a HTTP response. Its contentsStream is used to represent the body of the message.
Instance Variables
	contentsStream:		<WriteStream> The contents of this message.'
!

!WABufferedResponse class methodsFor:'instance creation'!

new
	^ self on: GRPlatform current readWriteCharacterStream
!

on: aStream
	^ self basicNew initializeOn: aStream
! !

!WABufferedResponse methodsFor:'accessing'!

contents
	^ contentsStream contents
!

stream
	^ contentsStream
! !

!WABufferedResponse methodsFor:'initialization'!

destroy
	super destroy.
	contentsStream := nil
!

initializeOn: aStream
	super initializeOn: aStream.
	contentsStream := aStream
! !

!WABufferedResponse methodsFor:'streaming'!

binary
	"put the response stream into binary mode. For buffered response, 
	 replace the contentStream with a ByteArray based stream."
	contentsStream := GRPlatform current readWriteByteStream
! !

!WABufferedResponse methodsFor:'writing'!

writeContentOn: aStream 
	aStream nextPutAll: self contents
!

writeHeadersOn: aStream 
	self 
		headerAt: 'Content-Length'
		put: contentsStream size.
	super writeHeadersOn: aStream
! !

