'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:42'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WACallback
	instanceVariableNames:'key'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Callbacks'
!

WACallback comment:''
!

!WACallback class methodsFor:'instance creation'!

on: aBlock
	^ self new block: aBlock
! !

!WACallback methodsFor:'accessing'!

block: aBlock
!

key
	"Answer the callback key of the receiver."
	
	^ self convertKey: key
!

priority
	"Answer the priority in which the receiver is evaluated."
	
	^ 0
! !

!WACallback methodsFor:'comparing'!

<= other
	^ self priority < other priority or: [ self priority = other priority and: [ self key asNumber <= other key asNumber ] ]
! !

!WACallback methodsFor:'converting'!

convertKey: aString
	^ aString
!

valueForField: anObject
	"Answer the value that should be used when the field value in the Request
	is anObject. This allows subclasses to specify a default value other than
	nil, for example."

	^ anObject
! !

!WACallback methodsFor:'evaluation'!

evaluateWithArgument: anObject
	self subclassResponsibility
!

evaluateWithFieldValues: anOrderedCollection
	self evaluateWithArgument: (self valueForField: (anOrderedCollection at: 1 ifAbsent: [ nil ]))
! !

!WACallback methodsFor:'initialization'!

setKey: aString callbacks: aDictionary
	key := aString
! !

!WACallback methodsFor:'testing'!

isEnabledFor: aRequestContext
	^ true
! !

