'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:43'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WACallbackRegistry
	instanceVariableNames:'callbacks nextKey'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Callbacks'
!

WACallbackRegistry comment:''
!

!WACallbackRegistry class methodsFor:'deprecated'!

context: aContext 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry class>>#context:'
		details: 'Use #new. Callbacks are no longer instantiated with a context and an owning component.'.
	^ self new
!

context: aContext owner: anObject 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry class>>#context:owner:'
		details: 'Use #new. Callbacks are no longer instantiated with a context and an owning component.'.
	^ self new
! !

!WACallbackRegistry methodsFor:'accessing'!

advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key
!

increaseKey
	nextKey := nextKey + 1
!

nextKey
	^ nextKey greaseString
! !

!WACallbackRegistry methodsFor:'deprecated'!

registerActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAActionCallback on: aBlock)
!

registerCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAValueCallback on: aBlock)
!

registerCancelActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerCancelActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WACancelActionCallback on: aBlock)
!

registerDefaultActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerDefaultActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WADefaultActionCallback on: aBlock)
!

registerDispatchCallback
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerDispatchCallback'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: WADispatchCallback new
!

registerImageCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerImageCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAImageCallback on: aBlock)
!

registerMapCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerMapCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAMapCallback on: aBlock)
!

registerUploadCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerUploadCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAUploadCallback on: aBlock)
!

registerValueCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerValueCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAValueCallback on: aBlock)
! !

!WACallbackRegistry methodsFor:'initialization'!

initialize
	super initialize.
	callbacks := Dictionary new.
	nextKey := 1
! !

!WACallbackRegistry methodsFor:'processing'!

handle: aRequestContext
	| set fields |
	set := Set new.
	fields := aRequestContext request fields.
	fields keysDo: [ :key |
		callbacks at: key ifPresent: [ :callback |
			(callback isEnabledFor: aRequestContext)
				ifTrue: [ set add: callback ] ] ].
	set sorted do: [ :callback |
		callback evaluateWithFieldValues:
			(fields allAt: callback key) ]
! !

!WACallbackRegistry methodsFor:'registration'!

store: aCallback 
	| key |
	key := self advanceKey.
	callbacks 
		at: (aCallback convertKey: key)
		put: aCallback.
	aCallback 
		setKey: key
		callbacks: callbacks.
	^ key
! !

