'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:43'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAConditionalComment
	instanceVariableNames:'condition root'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Document-Elements'
!

WAConditionalComment comment:'A WAConditionalComment is an implementation of Downlevel-hidden Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
These are only visible for the IE family of browsers.
See also WAOpeningConditionalComment and WAClosingConditionalComment.'
!

!WAConditionalComment class methodsFor:'instance creation'!

root: anHtmlRoot
	^ self basicNew initializeWithRoot: anHtmlRoot
! !

!WAConditionalComment methodsFor:'features'!

ie
	self addToCondition: ' IE'
!

ie5
	self addToCondition: '5'
!

ie50
	self addToCondition: '5.0'
!

ie55
	self ie: '5.5'
!

ie6
	self ie: '6'
!

ie7
	self ie: '7'
!

ie8
	self ie: '8'
!

ie: aString
	self addToCondition: ' IE ', aString
! !

!WAConditionalComment methodsFor:'initialization'!

initializeWithRoot: anHtmlRoot
	self initialize.
	root := anHtmlRoot.
	condition := 'if'
! !

!WAConditionalComment methodsFor:'operators'!

equal
	"implicit of nothing else"
!

greaterThan
	self addToCondition: ' gt'
!

lessThan
	self addToCondition: ' lt'
!

not
	self addToCondition: ' !!'
!

orEqual
	self addToCondition: 'e'
! !

!WAConditionalComment methodsFor:'private'!

addToCondition: aString
	condition := condition , aString
!

closingConditionClass
	^ WAClosingConditionalComment
!

openingConditionClass
	^ WAOpeningConditionalComment
! !

!WAConditionalComment methodsFor:'public'!

do: aBlock
	root add: (self openingConditionClass condition: condition).
	aBlock value.
	root add: (self closingConditionClass new)
! !

