'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:43'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAConfigurationDescription
	instanceVariableNames:'attributes expressions'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Configuration'
!

WAConfigurationDescription comment:'I hold a collection of attributes and present methods to construct new methods, providing an interface a bit like WACanvs and #renderContentOn: to WASystemConfiguration>>addAttributes:.
I can use any kind of collection class and handle setting the #configuration: parameter of the attribute appropriately on addition. If my collection is a Dictionary, I will store the attributes by their keys.
'
!

!WAConfigurationDescription methodsFor:'accessing'!

attributes
	^ attributes
!

expressions
	^ expressions
! !

!WAConfigurationDescription methodsFor:'attribute creation'!

addAttribute: anAttribute
	^ self add: anAttribute to: attributes
!

boolean: aSymbol
	^ self addAttribute: (WABooleanAttribute key: aSymbol)
!

collection: aSymbol
	^ self addAttribute: (WACollectionAttribute key: aSymbol)
!

integer: aSymbol
	^ self addAttribute: (WAIntegerAttribute key: aSymbol)
!

list: aSymbol
	^ self addAttribute: (WAListAttribute key: aSymbol)
!

number: aSymbol
	^ self addAttribute: (WANumberAttribute key: aSymbol)
!

password: aSymbol
	^ self addAttribute: (WAPasswordAttribute key: aSymbol)
!

string: aSymbol
	^ self addAttribute: (WAStringAttribute key: aSymbol)
!

url: aSymbol
	^ self addAttribute: (WAUrlAttribute key: aSymbol)
! !

!WAConfigurationDescription methodsFor:'initialization'!

initialize
	super initialize.
	attributes := IdentityDictionary new.
	expressions := IdentityDictionary new.
! !

!WAConfigurationDescription methodsFor:'private'!

add: aDescriptor to: aDictionary
	^ aDictionary at: aDescriptor key put: aDescriptor
! !

!WAConfigurationDescription methodsFor:'values'!

addExpression: anExpression
	^ self add: anExpression to: expressions
!

at: aSymbol addAll: aCollection
	self at: aSymbol addAll: aCollection removeAll: #()
!

at: aSymbol addAll: additions removeAll: removals
	self addExpression: ((WAAddRemoveExpression key: aSymbol)
			additions: additions;
			removals: removals;
			yourself)
!

at: aSymbol put: anObject 
	self addExpression: ((WAValueExpression key: aSymbol)
			value: anObject;
			yourself)
! !

