'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:42'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAHtmlElement subclass:#WAContentElement
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Document-Elements'
!

WAContentElement comment:'Common superclass of all elements inside a <head> that can have content. Either between the start and end tag or a (mime) document pointed to by an URL.'
!

!WAContentElement methodsFor:'attributes'!

charset: aString
	self attributeAt: 'charset' put: aString
!

contents: aString
	self document: aString
!

resourceUrl: aString
	self url: (root absoluteUrlForResource: aString)
!

type: aMimeTypeOrString
	self attributeAt: 'type' put: aMimeTypeOrString
!

url: aString
	self subclassResponsibility
! !

!WAContentElement methodsFor:'document'!

document: aString
	self document: aString mimeType: self typeOrNil
!

document: aString fileName: fileName
	self document: aString mimeType: self typeOrNil fileName: fileName
!

document: aString mimeType: mimeType
	self document: aString mimeType: mimeType fileName: nil
!

document: aString mimeType: mimeType fileName: fileName
	self url: (root context urlForDocument: aString mimeType: mimeType fileName: fileName)
! !

!WAContentElement methodsFor:'printing'!

encodeChildrenOn: aDocument 
	children isEmptyOrNil ifTrue: [ ^ self ].
	aDocument nextPutAll: '/*<!![CDATA[*/'.
	children do: [ :each | aDocument nextPutAll: each greaseString ].
	aDocument nextPutAll: '/*]]>*/'
! !

!WAContentElement methodsFor:'private'!

typeOrNil
	^ self attributeAt: 'type' ifAbsent:  [ nil ]
! !

!WAContentElement methodsFor:'testing'!

isClosed
	^ false
! !

