'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:45'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WADocument
	instanceVariableNames:'stream root'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Document'
!

WADocument comment:'A WADocument combines an output stream and an instance of root. The root is responsible to render header and footer if necessary.'
!

!WADocument class methodsFor:'instance creation'!

new
	^ self on: GRPlatform current readWriteCharacterStream
!

on: aStream 
	^ self 
		on: aStream
		codec: GRNullCodec new
!

on: aStream codec: aCodec
	^ self basicNew initializeWithStream: aStream codec: aCodec; yourself
! !

!WADocument methodsFor:'accessing'!

scriptGenerator: aScriptGenerator
	"ignore"
!

stream
	"Answer the underlying character stream of this document."

	^ stream
! !

!WADocument methodsFor:'actions'!

close
	"Close the receiving document."

	root isNil ifFalse: [ root closeOn: self ]
!

open: aRoot
	"Open the receiving document with aRoot."

	(root := aRoot) openOn: self
! !

!WADocument methodsFor:'initialization'!

destroy
	stream := root := nil
!

initializeWithStream: aStream codec: aCodec
	self initialize.
	stream := aStream
! !

!WADocument methodsFor:'writing'!

nextPut: aCharacter
	stream nextPut: aCharacter
!

nextPutAll: aString
	stream nextPutAll: aString
! !

