'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:44'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WARequestHandler subclass:#WADocumentHandler
	instanceVariableNames:'document'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-RequestHandling'
!

WADocumentHandler comment:'WADocumentHandler handles requests for images, text documents and binary files (byte arrays). This class is not normally used directly. A number of WA*Tag classes implement document:mimeType:fileName: which use WADocumentHandler. Given a document, #document:mimeType:fileName: creates a WADocumentHandler for the document, registers the handler with a Registry, and adds the correct url in the tag for the document.
Instance Variables:
	document	<WAMimeDocument>	MIMEDocument object representing this document and mimeType, generates stream used to write document for the response.'
!

!WADocumentHandler class methodsFor:'instance creation'!

document: anObject
	^ self basicNew initializeOn: anObject seasideMimeDocument; yourself
!

document: anObject mimeType: aMimeType
	^ self document: anObject mimeType: aMimeType fileName: nil
!

document: anObject mimeType: aMimeType fileName: aString
	| document |
	document := aMimeType isNil
		ifTrue: [ anObject seasideMimeDocument ]
		ifFalse: [ anObject seasideMimeDocumentType: aMimeType ].
	aString isNil
		ifFalse: [ document fileName: aString ].
	^ self document: document
! !

!WADocumentHandler methodsFor:'accessing'!

document
	^ document
! !

!WADocumentHandler methodsFor:'comparing'!

= anObject
	^ self species = anObject species and: [ self document = anObject document ]
!

hash
	^ self document hash
! !

!WADocumentHandler methodsFor:'copying'!

postCopy
	super postCopy.
	document := document copy
! !

!WADocumentHandler methodsFor:'handling'!

handleFiltered: aRequestContext
	aRequestContext respond: [ :response |
		response
			cacheForever;
			document: self document ]
! !

!WADocumentHandler methodsFor:'initialization'!

initializeOn: aDocument
	self initialize.
	document := aDocument
! !

