'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:44'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WANotification subclass:#WADynamicVariable
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Utilities'
!

WADynamicVariable comment:'A WADynamicVariable is a variable that is visible only in the stackframes outgoing from this one.
Example:
WADynamicVariable
	use: ''Seaside''
	during: [ self compilcatedCalculation ]
	
Whenever
WADynamicVariable value
gets evaluated somewhere inside [ self compilcatedCalculation ] or a method invoked directly or indirectly by it, its value will be ''Seaside''. If no #use:during: handler is around the current stack frame, then the value will be the return value of #defaultValue.
Do not use WADynamicVariable directly, instead create a subclass for each variable you want to use.'
!

!WADynamicVariable class methodsFor:'defaults'!

defaultValue
	^ nil
! !

!WADynamicVariable class methodsFor:'evaluating'!

use: anObject during: aBlock
	"Set the dynamic value of the receiver to anObject during the evaluation of aBlock."
	
	^ aBlock on: self do: [ :notification | notification resume: anObject ]
!

value
	"Answer the dynamic value of the receiver."
	
	^ self signal
! !

!WADynamicVariable methodsFor:'defaults'!

defaultAction
	^ self class defaultValue
! !

