'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:44'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAEmailAddress
	instanceVariableNames:'username address'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-HTTP'
!

WAEmailAddress comment:''
!

!WAEmailAddress class methodsFor:'instance creation'!

address: aString
	^ self new
		address: aString;
		yourself
!

address: anAddressString username: aUsernameString
	^ self new
		address: anAddressString;
		username: aUsernameString;
		yourself
! !

!WAEmailAddress methodsFor:'accessing'!

address
	^ address
!

address: aString
	address := self sanitize: aString
!

username
	^ username
!

username: aString
	username := self sanitize: aString
! !

!WAEmailAddress methodsFor:'displaying'!

encodeOn: aDocument
	self encodeOn: aDocument xmlEncoder usingQuotes: false
!

greaseString
	^ String streamContents: 
		[ :stream | 
		self 
			encodeOn: stream
			usingQuotes: true ]
! !

!WAEmailAddress methodsFor:'printing'!

printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self greaseString.
	aStream nextPut: $)
! !

!WAEmailAddress methodsFor:'private'!

encodeOn: aStream usingQuotes: aBoolean
	username isNil ifFalse:  [
		aBoolean ifTrue: [ aStream nextPut: $" ].
		aStream nextPutAll: username.
		aBoolean ifTrue: [ aStream nextPut: $" ].
		aStream nextPutAll: ' <' ].
	aStream nextPutAll: address.
	username isNil ifFalse: [ aStream nextPut: $> ]
!

sanitize: aString
	"prevents SMTP header injection"
	| newlineIndex |
	newlineIndex := (aString indexOf: Character cr) min: (aString indexOf: Character lf).
	^ newlineIndex = 0
		ifTrue: [ aString ]
		ifFalse: [ aString copyFrom: 1 to: newlineIndex - 1  ]
! !

