'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:43'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAExceptionHandler subclass:#WAErrorHandler
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-RequestHandling'
!

WAErrorHandler comment:'WAErrorHandler catches Errors and Warnings and provides two methods for handling each type of exception:
handleError:
handleWarning:
If either method is not implemented, the default implementation will call #handleDefault:, which can be used to provide common behaviour for both exception types.'
!

!WAErrorHandler class methodsFor:'deprecated'!

handleError: anError 
	self 
		greaseDeprecatedApi: 'WAErrorHandler class>>#handleError:'
		details: 'ExceptionHandlers should be allowed to set up their own exception handling code. See WAExceptionHandler class>>handleExceptionsDuring:.'.
	^ self new handleError: anError
!

handleWarning: aWarning 
	self 
		greaseDeprecatedApi: 'WAErrorHandler class>>#handleWarning:'
		details: 'ExceptionHandlers should be allowed to set up their own exception handling code. See WAExceptionHandler class>>handleExceptionsDuring:.'.
	^ self new handleWarning: aWarning
! !

!WAErrorHandler class methodsFor:'exception handling'!

exceptionSelector
	^ super exceptionSelector, Error, Warning
! !

!WAErrorHandler methodsFor:'actions'!

handleDefault: anException
	"This method provides the default behaviour if subclasses do
	not implement one of the specific handler methods."
	^ self internalError: anException
!

handleError: anError
	^ self handleDefault: anError
!

handleException: anException
	(Error handles: anException)
		ifTrue: [ ^ self handleError: anException ].
	(Warning handles: anException)
		ifTrue: [ ^ self handleWarning: anException ].

	^ super handleException: anException
!

handleWarning: aWarning
	^ self handleDefault: aWarning
! !

