'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:41'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WARequestHandler subclass:#WAFileHandler
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Libraries'
!

WAFileHandler class instanceVariableNames:'default'

"
 No other class instance variables are inherited by this class.
"
!

WAFileHandler comment:''
!

!WAFileHandler class methodsFor:'accessing'!

default

	default isNil ifTrue: [ default := self new ].
	^ default
!

default: aFileHandler
	default := aFileHandler
!

description
	^ 'File Library'
! !

!WAFileHandler methodsFor:'accessing'!

baseUrlForLibrary
	| resourceBaseUrl |
	resourceBaseUrl := self resourceBaseUrl.
	^ resourceBaseUrl isNil
		ifTrue: [ self url ]
		ifFalse: [ resourceBaseUrl copy ]
!

libraries
	^ WAFileLibrary allSubclasses
!

libraryAt: aSymbol ifAbsent: aBlock
	^ self libraries 
		detect: [ :each | each handlesFolder: aSymbol ]
		ifNone: aBlock
! !

!WAFileHandler methodsFor:'configuration'!

defaultConfiguration
	^ super defaultConfiguration
		removeParent: WARequestHandlingConfiguration instance;
		addParent: WAFileHandlerConfiguration instance;
		yourself
!

fileHandlerListingClass
	^ self preferenceAt: #fileHandlerListingClass
!

resourceBaseUrl
	^ self preferenceAt: #resourceBaseUrl
!

useXSendfile
	^ self preferenceAt: #useXSendfile.
!

xSendfileBaseDirectory
	^ self preferenceAt: #xSendfileBaseDirectory.
! !

!WAFileHandler methodsFor:'handling'!

handleFiltered: aRequestContext
	self responseForContext: aRequestContext
! !

!WAFileHandler methodsFor:'private'!

responseForContext: aRequestContext
	| libraryClass consumer |
	consumer := aRequestContext consumer.
	consumer atEnd
		ifTrue: [ ^ (self fileHandlerListingClass on: self context: aRequestContext) responseForLibraries ].
	libraryClass := self 
		libraryAt: consumer next asSymbol
		ifAbsent: [ ^ aRequestContext responseGenerator notFound; respond ].
	consumer atEnd
		ifTrue: [
			| listingClass |
			listingClass := (self fileHandlerListingClass on: self context: aRequestContext).
			listingClass responseForLibrary: libraryClass default ]
		ifFalse: [
			libraryClass handle: aRequestContext.
			" won't be executed if a document is found "
			aRequestContext responseGenerator
				notFound;
				respond ]
! !

