'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:42'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAHtmlElement
	instanceVariableNames:'root attributes children'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Document-Elements'
!

WAHtmlElement comment:'Root class of all elements inside a <head> section.'
!

!WAHtmlElement class methodsFor:'instance creation'!

root: aRoot
	^ self basicNew initializeWithRoot: aRoot; yourself
! !

!WAHtmlElement methodsFor:'accessing'!

attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]
!

tag
	self subclassResponsibility
! !

!WAHtmlElement methodsFor:'accessing-attributes'!

attributeAt: aString
	^ self attributes at: aString
!

attributeAt: aString ifAbsent: aBlock
	^ self attributes at: aString ifAbsent: aBlock
!

attributeAt: aString put: anObject
	^ self attributes at: aString put: anObject
! !

!WAHtmlElement methodsFor:'accessing-children'!

add: anElement
	children ifNil: [ children := OrderedCollection new ].
	children add: anElement
!

childrenDo: aBlock
	children isNil
		ifFalse: [ children do: aBlock ]
! !

!WAHtmlElement methodsFor:'initialization'!

initializeWithRoot: aRoot
	self initialize.
	root := aRoot
! !

!WAHtmlElement methodsFor:'printing'!

encodeAfterOn: aDocument
	aDocument closeTag: self tag
!

encodeBeforeOn: aDocument
	aDocument openTag: self tag attributes: attributes closed: self isClosed
!

encodeChildrenOn: aDocument
	self childrenDo: [ :each | each encodeOn: aDocument ]
!

encodeOn: aDocument
	self encodeBeforeOn: aDocument.
	self isClosed ifTrue: [ ^ self ].
	self encodeChildrenOn: aDocument.
	self encodeAfterOn: aDocument
! !

!WAHtmlElement methodsFor:'public'!

with: anObject
	self add: anObject
! !

!WAHtmlElement methodsFor:'testing'!

isClosed
	^ true
! !

