'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:45'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAHttpVersion
	instanceVariableNames:'major minor'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-HTTP'
!

WAHttpVersion comment:''
!

!WAHttpVersion class methodsFor:'instance creation'!

fromString: aString
	^ self readFrom: aString readStream
!

http10
	^ self major: 1 minor: 0
!

http11
	^ self major: 1 minor: 1
!

major: majorInteger minor: minorInteger
	^ self basicNew
		initializeWithMajor: majorInteger minor: minorInteger;
		yourself
!

new
	^ self http11
!

readFrom: aStream 
	| major minor |
	[ aStream peek = Character space ] whileTrue: [ aStream next ].
	aStream peek = $H ifTrue: [ aStream skipTo: $/ ].	"Skip over 'HTTP/' "
	major := aStream upTo: $..
	minor := aStream upTo: Character space.
	^ self 
		major: major greaseInteger
		minor: minor greaseInteger
! !

!WAHttpVersion methodsFor:'accessing'!

major
	^ major
!

minor
	^ minor
! !

!WAHttpVersion methodsFor:'comparing'!

< otherVersion
	^ (major < otherVersion major) or: [
		(major = otherVersion major) and: [ minor < otherVersion minor ] ]
!

<= otherVersion
	^ (self = otherVersion) or: [ self < otherVersion ]
!

= otherVersion
	^ (major = otherVersion major) and: [ minor = otherVersion minor ]
!

> otherVersion
	^ (major > otherVersion major) or: [
		(major = otherVersion major) and: [ minor > otherVersion minor ] ]
!

>= otherVersion
	^ (self = otherVersion) or: [ self > otherVersion ]
!

hash
	^ major hash bitXor: minor hash
! !

!WAHttpVersion methodsFor:'initialization'!

initializeWithMajor: majorInteger minor: minorInteger
	self initialize.
	major := majorInteger.
	minor := minorInteger
! !

!WAHttpVersion methodsFor:'printing'!

printOn: aStream
	aStream nextPutAll: 'HTTP/'.
	major printOn: aStream.
	aStream nextPut: $..
	minor printOn: aStream
! !

!WAHttpVersion methodsFor:'testing'!

isHttp10
	^ major = 1 and: [ minor = 0 ]
!

isHttp11
	^ major = 1 and: [ minor = 1 ]
! !

