'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:41'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WACacheExpiryPolicy subclass:#WALastAccessExpiryPolicy
	instanceVariableNames:'lastAccessTable'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Cache'
!

WALastAccessExpiryPolicy comment:''
!

!WALastAccessExpiryPolicy methodsFor:'configuration'!

defaultConfiguration
	^ super defaultConfiguration
		addParent: WACacheTimeoutConfiguration instance;
		yourself
!

timeout
	^ self configuration at: #cacheTimeout
! !

!WALastAccessExpiryPolicy methodsFor:'copying'!

postCopy
	super postCopy.
	lastAccessTable := lastAccessTable copy
! !

!WALastAccessExpiryPolicy methodsFor:'initialization'!

initialize
	super initialize.
	lastAccessTable := GRPlatform current reducedConflictDictionary new
! !

!WALastAccessExpiryPolicy methodsFor:'notifications'!

removed: anObject key: aString
	lastAccessTable removeKey: aString ifAbsent: [ ]
!

retrieved: anObject key: aString
	lastAccessTable at: aString put: Time totalSeconds
!

stored: anObject key: aString
	lastAccessTable at: aString put: Time totalSeconds
! !

!WALastAccessExpiryPolicy methodsFor:'protocol'!

isExpired: anObject key: aString
	| lastAccess |
	lastAccess := lastAccessTable at: aString ifAbsent: [ Time totalSeconds ].
	^ (Time totalSeconds - lastAccess) > self timeout
! !

