'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:40'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WACacheExpiryPolicy subclass:#WALeastRecentlyUsedExpiryPolicy
	instanceVariableNames:'ageTable'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Cache'
!

WALeastRecentlyUsedExpiryPolicy comment:''
!

!WALeastRecentlyUsedExpiryPolicy methodsFor:'configuration'!

defaultConfiguration
	^ super defaultConfiguration
		addParent: WACacheCapacityConfiguration instance;
		yourself
!

maximumAge
	^ self configuration at: #cacheCapacity
! !

!WALeastRecentlyUsedExpiryPolicy methodsFor:'copying'!

postCopy
	super postCopy.
	ageTable := ageTable copy.
	ageTable keysAndValuesDo: [ :eachKey :eachValue | 
		ageTable at: eachKey put: (Array with: eachValue first) ]
! !

!WALeastRecentlyUsedExpiryPolicy methodsFor:'initialization'!

initialize
	super initialize.
	ageTable := GRPlatform current reducedConflictDictionary new
! !

!WALeastRecentlyUsedExpiryPolicy methodsFor:'notifications'!

removed: anObject key: aString
	ageTable removeKey: aString ifAbsent: [ ]
!

retrieved: anObject key: aString
	(ageTable at: aString) at: 1 put: 0
!

stored: anObject key: aString
	"Avoid #associationsDo: to maintain cross-platform portability (see Issue #312 for details)."

	ageTable do: [ :each | each at: 1 put: (each at: 1) + 1 ].
	ageTable at: aString put: (Array with: 0)
! !

!WALeastRecentlyUsedExpiryPolicy methodsFor:'protocol'!

isExpired: anObject key: aString
	^ (ageTable at: aString) first > self maximumAge
! !

