'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:44'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAAttribute subclass:#WAListAttribute
	instanceVariableNames:'optionsBlock'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Configuration'
!

WAListAttribute comment:'WAListAttribute is an attribute that is restricted to a list of values. 
Instance Variables:
	options	<Block>	A block returning a list of possible values for the attribute'
!

!WAListAttribute methodsFor:'accessing'!

options
	^ optionsBlock isNil
		ifTrue: [ #() ]
		ifFalse: [ optionsBlock value ]
!

options: aBlock
	optionsBlock := aBlock
! !

!WAListAttribute methodsFor:'converting'!

valueFromString: aString 
	self error: 'List attributes cannot be converted from Strings'
! !

!WAListAttribute methodsFor:'visiting'!

accept: aVisitor
	aVisitor visitListAttribute: self
! !

