'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:44'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAMergedRequestFields
	instanceVariableNames:'delegates'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-HTTP'
!

WAMergedRequestFields comment:'Provides a read-only view onto multiple dictionaries. Note that this can lead to to duplicated keys that can only retrieved by iterating over all the associations.'
!

!WAMergedRequestFields class methodsFor:'instance creation'!

new
	self error: self name , ' is created with #on:'
!

on: anArray
	^ self basicNew initializeOn: anArray
! !

!WAMergedRequestFields methodsFor:'accessing'!

at: aKey
	^ self at: aKey ifAbsent: [ self errorKeyNotFound ]
!

at: aKey ifAbsent: aBlock
	delegates do: [ :each |
		each
			at: aKey
			ifPresent: [ :value | ^ value ] ].
	^ aBlock value
!

at: aKey ifPresent: aBlock
	delegates do: [ :each |
		each
			at: aKey
			ifPresent: [ :value | ^ aBlock value: value ] ].
	^ nil
!

size
	^ delegates inject: 0 into: [ :result :each | result + each size ]
! !

!WAMergedRequestFields methodsFor:'enumerating'!

allAt: aKey
	^ Array streamContents: [ :stream |
		delegates do: [ :each | stream nextPutAll: (each allAt: aKey) ] ]
!

allAt: aKey ifAbsent: absentBlock
	| result |
	result := self allAt: aKey.
	^ result isEmpty
		ifTrue: [ absentBlock value ]
		ifFalse: [ result ]
!

associationsDo: aBlock
	delegates do: [ :each | each associationsDo: aBlock ]
!

do: aBlock
	delegates do: [ :each | each do: aBlock ]
!

keys
	^ Array streamContents: [ :stream |
		delegates do: [ :each | stream nextPutAll: each keys ] ]
!

keysAndValuesDo: aBlock
	delegates do: [ :each | each keysAndValuesDo: aBlock ]
!

keysDo: aBlock
	delegates do: [ :each | each keysDo: aBlock ]
!

values
	^ Array streamContents: [ :stream |
		delegates do: [ :each | stream nextPutAll: each values ] ]
! !

!WAMergedRequestFields methodsFor:'initialization'!

initializeOn: anArray
	self initialize.
	delegates := anArray
! !

!WAMergedRequestFields methodsFor:'private'!

errorKeyNotFound
	^ nil
! !

!WAMergedRequestFields methodsFor:'testing'!

includesKey: aKey
	^ delegates anySatisfy: [ :each | each includesKey: aKey ]
!

isEmpty
	^ delegates allSatisfy: [ :each | each isEmpty ]
! !

