'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:41'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAMimeDocument
	instanceVariableNames:'contents mimeType fileName'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-HTTP'
!

WAMimeDocument comment:'WAMimeDocument is the abstract base class for mime documents. It is intened as a very basic, mime documents. Implementations are free to use more advance, native implementations as long as they conform to the protocol.
Instance Variables
	contentType:		<WAMimeType>
mimeType
	- the mime type of this document
'
!

!WAMimeDocument class methodsFor:'instance creation'!

on: aCollection
	^ self on: aCollection mimeType: nil
!

on: aCollection mimeType: aMimeType
	^ self on: aCollection mimeType: aMimeType fileName: nil
!

on: aCollection mimeType: aMimeType fileName: aString
	^ self basicNew initializeOn: aCollection mimeType: aMimeType fileName: aString; yourself
! !

!WAMimeDocument methodsFor:'accessing'!

contents
	"Answer the content of the receiver as a Collection of Characters or bytes."
	
	^ contents
!

contents: aCollection
	contents := aCollection
!

fileName
	"Answer the file name of this document, or nil."
	
	^ fileName
!

fileName: aString
	fileName := aString
!

mimeType
	"Answer the file name of this document, or nil."
	
	^ mimeType
!

mimeType: aMimeType
	mimeType := aMimeType isNil
		ifFalse: [ aMimeType seasideMimeType ]
		ifTrue: [ WAMimeType applicationOctetStream ]
! !

!WAMimeDocument methodsFor:'comparing'!

= anObject
	^ (anObject isKindOf: WAMimeDocument)
		and: [ self mimeType = anObject mimeType
		and: [ self fileName = anObject fileName
		and: [ self contents = anObject contents ] ] ]
!

hash
	^ (self mimeType hash
		bitXor: self fileName hash)
		bitXor: self contents hash
! !

!WAMimeDocument methodsFor:'compatibility'!

content
	^ self contents
!

contentStream
	^ self contents readStream
!

contentType
	^ self mimeType
! !

!WAMimeDocument methodsFor:'converting'!

seasideMimeDocument
	^ self
! !

!WAMimeDocument methodsFor:'initialization'!

initializeOn: aCollection mimeType: aMimeType fileName: aString
	self initialize.
	self contents: aCollection.
	self mimeType: aMimeType.
	self fileName: aString
! !

