'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:44'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAVisitor subclass:#WAPainterVisitor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Rendering'
!

WAPainterVisitor comment:'An implementation of the Visitor pattern for Painter subclasses.'
!

!WAPainterVisitor methodsFor:'copying'!

copyForRenderContext: aRenderContext 
	"Return a copy, making sure that references to a RenderContext are replaced
	with aRenderContext."
	
	^ self copy
		postCopyForRenderContext: aRenderContext;
		yourself
!

postCopyForRenderContext: aRenderContext
	"self is a shallow copy. Subclasses should copy fields as necessary to complete
	the full copy and ensure that all references to the old RenderContext are replaced
	with aRenderContext. Note that #postCopy is also called prior to this method being called."
! !

!WAPainterVisitor methodsFor:'visiting'!

visitPainter: aPainter
! !

