'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:45'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAPathConsumer
	instanceVariableNames:'path'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-RequestHandling'
!

WAPathConsumer comment:'A WAPathConsumer keeps track of the unconsumed path elements in request handling.
Instance Variables
	path:		<Collection<String>>
path
	- the collection of unconsumed path elements
'
!

!WAPathConsumer class methodsFor:'instance creation'!

path: aCollectionOfStrings
	^ self basicNew initializeWith: aCollectionOfStrings
! !

!WAPathConsumer methodsFor:'accessing'!

atEnd
	"Answer whether there are any unconsumed path elements left."

	^ path isEmpty
!

next
	"Remove the first unconsumed path element and answer it."

	^ path removeFirst
!

nextIfPresentDo: aOneArgumentBlock
	"Evaluate the given block with #next if not #atEnd."
	self atEnd
		ifFalse: [ aOneArgumentBlock value: self next ]
!

peek
	"Answer the first unconsumed path element without removing it."

	^ path first
!

peekToEnd
	"answer the remaining elements in my path without consuming them"
	^ Array withAll: path
!

try: aString
	"See if the next element in the stream matches aString.
	If it does, consume the element and return true.
	If it does not or we are at the end of the stream, simply return false."
	
	(self atEnd or: [ (self peek = aString) not ]) ifTrue: [ ^ false ].
	
	self next.
	^ true
!

upToEnd
	"answer the remaining elements in my path"
	| elements |
	elements := path.
	path := #().
	^ elements
! !

!WAPathConsumer methodsFor:'initialization'!

initializeWith: aCollectionOfStrings
	self initialize.
	path := aCollectionOfStrings
! !

