'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:41'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WARequestFilter subclass:#WAProtectionFilter
	instanceVariableNames:'remoteAddress'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Filter'
!

WAProtectionFilter comment:'The protection filter ensures that the wrapped request handler only accepts requests from the same IP. Do add this filter to a WASession for example to avoid session hijacking, do not add it to static request handlers such as WAApplication or WADispatcher as this might restrict access to the handler if your IP changes.
Note that checking for IP addresses is not bullet proof and should never be used as the sole security measure for a web application as IP addresses can be easily spoofed.'
!

!WAProtectionFilter methodsFor:'private'!

remoteAddress
	^ remoteAddress
!

remoteAddressFromRequest: aRequest
	remoteAddress ifNil: [
		remoteAddress := aRequest
			headerAt: 'x-forwarded-for'
			ifAbsent: [ aRequest remoteAddress ]	].
	^ aRequest remoteAddress
! !

!WAProtectionFilter methodsFor:'processing'!

handleFiltered: aRequestContext 
	(self verifyRequest: aRequestContext request) 
		ifTrue: [ super handleFiltered: aRequestContext ]
		ifFalse: [ 
			aRequestContext responseGenerator
				forbidden;
				respond ]
! !

!WAProtectionFilter methodsFor:'testing'!

verifyRequest: aRequest
	^ (self remoteAddressFromRequest: aRequest) = self remoteAddress
! !

