'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:42'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAQualifiedValue
	instanceVariableNames:'value quality'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-HTTP'
!

WAQualifiedValue comment:'A WAQualifiedValue is an Object with an assigned quality value.
Instance Variables
	quality:		<Float>
	value:		<Object>
quality
	- between 0.0 and 1.0 or Float infinity if no value is given
value
	- the qualified object'
!

!WAQualifiedValue class methodsFor:'instance creation'!

fromString: aString
	^ Array streamContents: [ :stream |
		| values |
		values := aString subStrings: ','.
		values do: [ :each |
			| value quality |
			value := self valueClass fromString: (each copyUpTo: $;) trimBoth.
			quality := (each includes: $;)
				ifTrue: [
					| qualityString |
					qualityString := (each copyAfter: $;) copyAfter: $=.
					qualityString first = $. ifTrue: [
						"work around for Issue 655
						some user agents send '.2' instead of '2.0'"
						qualityString := '0', qualityString ].
					Float readFrom: qualityString readStream ]
				ifFalse: [ 1.0 ].
			stream nextPut: (self value: value quality: quality) ] ]
!

value: anObject quality: aFloat
	^ self new
		value: anObject;
		quality: aFloat;
		yourself
! !

!WAQualifiedValue class methodsFor:'private'!

valueClass
	self subclassResponsibility
! !

!WAQualifiedValue methodsFor:'accessing'!

quality
	^ quality
!

quality: aFloat
	quality := aFloat
!

value
	^ value
!

value: anObject
	value := anObject
! !

!WAQualifiedValue methodsFor:'comparing'!

<= other
	^ self quality <= other quality
! !

