'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:45'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAPainterVisitor subclass:#WARenderVisitor
	instanceVariableNames:'renderContext'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Rendering'
!

WARenderVisitor comment:'A visitor that renders Painters. It creates an instance of the #rendererClass specified by each Painter it visits and passes it to the Painter with #renderContentOn:.'
!

!WARenderVisitor class methodsFor:'instance creation'!

context: aRenderContext
	^ self basicNew
		initializeWithContext: aRenderContext;
		yourself
! !

!WARenderVisitor methodsFor:'accessing'!

renderContext
	^ renderContext
! !

!WARenderVisitor methodsFor:'copying'!

postCopyForRenderContext: aRenderContext
	super postCopyForRenderContext: aRenderContext.
	renderContext := aRenderContext
! !

!WARenderVisitor methodsFor:'initialization'!

initializeWithContext: aRenderContext
	self initialize.
	renderContext := aRenderContext
! !

!WARenderVisitor methodsFor:'visiting'!

visitPainter: aPainter 
	| renderer |
	renderer := aPainter rendererClass context: self renderContext.
	aPainter renderContentOn: renderer.
	renderer flush
! !

