'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:44'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WARenderer
	instanceVariableNames:'context lastId'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Rendering'
!

WARenderer class instanceVariableNames:'default'

"
 No other class instance variables are inherited by this class.
"
!

WARenderer comment:''
!

!WARenderer class methodsFor:'instance creation'!

builder
	^ WABuilder on: self
!

context: aRenderContext
	^ self basicNew initializeWithContext: aRenderContext; yourself
! !

!WARenderer class methodsFor:'defaults'!

default
	^ default ifNil: [ default := WARenderer ]
!

default: anObject
	default := anObject
!

resetDefault
	WARenderer default: nil
!

selectAsDefault
	WARenderer default: self
!

unselectAsDefault
	(WARenderer default = self) ifTrue: [ WARenderer resetDefault ]
! !

!WARenderer methodsFor:'accessing'!

callbacks
	"Answer the callback registry."

	^ self context callbacks
!

context
	"Answer the rendering context."

	^ context
!

document
	^ self context document
! !

!WARenderer methodsFor:'initialization'!

initializeWithContext: aRenderContext
	self initialize.
	context := aRenderContext
! !

!WARenderer methodsFor:'private'!

flush
	"Close any open elements and write any remaining data."
! !

!WARenderer methodsFor:'public'!

absoluteUrlForResource: aString
	"Answer a resource URL for aString. The URL will always be absolute (ie. it will begin
	with a / or a URL scheme like http://. If aString already looks like a URL, an instance
	of WAUrl will be returned for it. If it looks like a path, it will be appended to the
	resource base URL configured in the RenderContext if there is one."

	^ self context absoluteUrlForResource: aString
!

actionBaseUrl
	^ self context actionBaseUrl
!

actionUrl
	^ self context actionUrl
!

lastId
	"Answer the last identifier that was generated with #nextId."
	
	^ lastId
!

nextId
	"Answer an identifier string that is unique within this RenderContext."
	
	^ lastId := 'id', self callbacks advanceKey
!

render: anObject
	"Render anObject using this Renderer."
	
	anObject renderOn: self
!

text: anObject
	"Emit anObject onto the target document."

	self document print: anObject
!

urlForAction: aBlock
	"Answer an action URL that will evaluate aBlock when it is requested."

	^ self actionUrl withField: (self callbacks store: (WAActionCallback on: aBlock))
! !

