'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:43'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WASystemConfiguration subclass:#WARequestHandlingConfiguration
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-RequestHandling'
!

WARequestHandlingConfiguration comment:'This configuration class holds attributes needed by classes in the Request Handling layer.'
!

!WARequestHandlingConfiguration methodsFor:'description'!

describeOn: config 
	(config string: #charSet)
		beAdvanced;
		label: 'Character Set';
		comment: 'The character set reported to the browser. This is only used if you set the encoding in the server to ''(none)''.';
		default: 'utf-8'.
	(config list: #documentClass)
		beAdvanced;
		options: [ self documentClasses ];
		default: WAHtmlDocument.
	(config list: #scriptGeneratorClass)
		beAdvanced;
		options: [ self scriptGeneratorClasses ];
		default: WADefaultScriptGenerator.
	(config list: #responseGenerator)
		beAdvanced;
		options: [ self responseGenerators ];
		default: WAResponseGenerator.
	(config list: #serverProtocol)
		beAdvanced;
		group: #server;
		comment: 'The protocol in URLs generated by Seaside.';
		options: [ self serverProtocols ].
	(config string: #serverHostname)
		beAdvanced;
		group: #server;
		comment: 'The hostname in URLs generated by Seaside.'.
	(config integer: #serverPort)
		beAdvanced;
		group: #server;
		comment: 'The port in URLs generated by Seaside.'.
	(config string: #serverPath)
		group: #server;
		comment: 'The path in URLs generated by Seaside.'
! !

!WARequestHandlingConfiguration methodsFor:'private'!

documentClasses
	^ WADocument withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]
!

responseGenerators
	^ WAResponseGenerator withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]
!

scriptGeneratorClasses
	^ WAScriptGenerator allSubclasses asSortedCollection: [ :a :b | a name <= b name ]
!

serverProtocols
	^ #('http' 'https')
! !

