'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:45'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAScriptGenerator
	instanceVariableNames:'loadScripts'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Document'
!

WAScriptGenerator comment:''
!

!WAScriptGenerator methodsFor:'accessing'!

addLoadScript: anObject
	"Add a script anObject to the receiver. This method ensures all scripts to run in the added order when the DOM is ready. Note that the default implementation calls the scripts when the page has finished loading."
	
	^ loadScripts addLast: anObject
!

addLoadScriptFirst: anObject
	"Add a script anObject at the beginning of the load scripts."
	
	^ loadScripts addFirst: anObject
!

loadScripts
	"Answer the load scripts of the receiver. These scripts will be evaluated in order when the page has loaded."

	^ loadScripts
! !

!WAScriptGenerator methodsFor:'actions'!

close: aHtmlRoot on: aDocument
	"This method is called before the document is closed."
!

closeOn: aDocument
	"This method is called to close the document that has no root."
	
	self loadScripts isEmpty 
		ifTrue: [ ^ self ].
	self 
		writeScriptTag: [ self writeLoadScriptsOn: aDocument ]
		on: aDocument
!

open: aHtmlRoot on: aDocument
	"This method is called before the document is opened."
! !

!WAScriptGenerator methodsFor:'initialization'!

initialize
	super initialize.
	loadScripts := OrderedCollection new
! !

!WAScriptGenerator methodsFor:'private'!

writeLoadScriptsOn: aDocument
	"Utitlity method to write the receivers load scripts onto aDocument."

	self loadScripts do: [ :each |
		aDocument nextPutAll: each greaseString; nextPut: $; ]
!

writeScriptTag: aBlock on: aDocument
	"Utitlity method to properly wrap the script generation code in aBlock onto aDocument."

	| attributes |
	attributes := WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	aDocument openTag: 'script' attributes: attributes; nextPutAll: '/*<!![CDATA[*/'.
	aBlock value.
	aDocument nextPutAll: '/*]]>*/'; closeTag: 'script'
! !

!WAScriptGenerator methodsFor:'public'!

event: aString do: anObject on: aBrush
	"Attaches the Javscript anObject to the event aString of aBrush. This default implementation simply inlines the Javascript code into the brush; subclasses might override this to do something more meaningful."
	
	aBrush attributes at: 'on' , aString append: anObject separator: ';'
! !

