'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:41'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WAServerManager
	instanceVariableNames:'adaptors'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Server'
!

WAServerManager class instanceVariableNames:'default'

"
 No other class instance variables are inherited by this class.
"
!

WAServerManager comment:''
!

!WAServerManager class methodsFor:'accessing'!

default
	^ default ifNil: [ default := self new ]
! !

!WAServerManager class methodsFor:'class initialization'!

initialize
	GRPlatform current
		addToStartUpList: self;
		addToShutDownList: self
!

unload
	GRPlatform current
		removeFromStartUpList: self;
		removeFromShutDownList: self
! !

!WAServerManager class methodsFor:'system startup'!

shutDown
	self default adaptors do: [ :each | each shutDown ]
!

startUp
	self default adaptors do: [ :each | each startUp ]
! !

!WAServerManager methodsFor:'accessing'!

adaptors
	^ adaptors copy
!

register: aServerAdaptor
	^ adaptors add: aServerAdaptor
!

unregister: aServerAdaptor
	self stop: aServerAdaptor.
	adaptors remove: aServerAdaptor.
	aServerAdaptor unregistered.
	^ aServerAdaptor
! !

!WAServerManager methodsFor:'initialization'!

initialize
	super initialize.
	adaptors := OrderedCollection new
! !

!WAServerManager methodsFor:'private'!

canStart: aServerAdaptor
	"Because we can't rely on the socket refusing to listen on a port already in use, we simply check here if we know of another adaptor using this adaptor's port"
	^ aServerAdaptor isStopped 
			and: [ self adaptors noneSatisfy: [ :adaptor | 
				(adaptor = aServerAdaptor) not
					and: [ adaptor port = aServerAdaptor port
					and: [ adaptor isStopped not ] ] ] ]
!

canStop: aServerAdaptor
	^ aServerAdaptor isStopped not
! !

!WAServerManager methodsFor:'starting/stopping'!

restart: aServerAdaptor
	self stop: aServerAdaptor.
	self start: aServerAdaptor
!

restartAll
	adaptors do: [ :each | each restart ]
!

start: aServerAdaptor
	(self canStart: aServerAdaptor) ifTrue: [
		[ aServerAdaptor basicStart ]
			ifCurtailed: [ self stop: aServerAdaptor ] ]
!

startAll
	adaptors do: [ :each | each start ]
!

stop: aServerAdaptor
	(self canStop: aServerAdaptor) ifTrue: [ aServerAdaptor basicStop ]
!

stopAll
	adaptors do: [ :each | each stop ]
! !


WAServerManager initialize!
