'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:43'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAUserConfiguration subclass:#WASharedConfiguration
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Configuration'
!

WASharedConfiguration class instanceVariableNames:'instances'

"
 No other class instance variables are inherited by this class.
"
!

WASharedConfiguration comment:''
!

!WASharedConfiguration class methodsFor:'initialization'!

initialize
	instances := Set new
! !

!WASharedConfiguration class methodsFor:'instance creation'!

named: aString
	"Answer a shared configuration with the given name aString or answer a newly created one."
	
	^ instances
		detect: [ :each | each name = aString ]
		ifNone: [
			instances add: (self basicNew
				initializeWithName: aString;
				yourself) ]
!

new
	self error: 'Create or retrieve shared configurations by sending the message #named:'
!

unregister: aConfiguration
	"Removes aConfiguration from the list of known configurations."
	
	^ instances remove: aConfiguration ifAbsent: [ nil ]
! !

!WASharedConfiguration class methodsFor:'accessing'!

configurations
	^ instances copy
! !

!WASharedConfiguration methodsFor:'accessing'!

name
	^ name
! !

!WASharedConfiguration methodsFor:'actions'!

unregister
	self class unregister: self
! !

!WASharedConfiguration methodsFor:'initialization'!

initializeWithName: aString
	self initialize.
	name := aString
! !

!WASharedConfiguration methodsFor:'testing'!

isShared
	^ true
! !


WASharedConfiguration initialize!
