'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:42'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAObject subclass:#WASnapshot
	instanceVariableNames:'objects'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Backtracking'
!

WASnapshot comment:'I represent a memory snapshot of objects. Objects can be registered by sending the message #register:. All object snapshots are updated by sending #snapshot and restored by sending #restore. To have specific snpshot and restore actions for particular classes override #snapshotCopy and #restoreFromSnapshot: in your classes.'
!

!WASnapshot methodsFor:'actions'!

reset
	"Clears the snapshot dictionary."

	objects := IdentityDictionary new
!

restore
	"Restore all the backtracked states."

	objects keysAndValuesDo: [ :key :value | key restoreFromSnapshot: value ]
!

snapshot
	"Snapshot all the states that have been registered for backtracking overriding existing snapshots."

	objects associationsDo: [ :assoc | assoc value: assoc key snapshotCopy ]
! !

!WASnapshot methodsFor:'initialization'!

initialize
	super initialize.
	self reset
! !

!WASnapshot methodsFor:'registry'!

register: anObject
	"Register anObject for backtracking."

	anObject isNil
		ifFalse: [ objects at: anObject put: anObject snapshotCopy ]
! !

