'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:42'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAConfiguredRequestFilter subclass:#WAStrictTransportSecurityFilter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Filter'
!

WAStrictTransportSecurityFilter comment:'I implement strict transport security (STS) for Seaside. STS tries to prevent users from accidentially using non SSL versions of your application. 
 
http://www.imperialviolet.org/2010/01/26/sts.html
http://lists.w3.org/Archives/Public/www-archive/2009Sep/att-0051/draft-hodges-strict-transport-sec-05.plain.html'
!

!WAStrictTransportSecurityFilter methodsFor:'configuration'!

defaultConfiguration
	^ WAUserConfiguration new
		addParent: WAStrictTransportSecurityFilterConfiguration instance;
		yourself
!

includeSubDomains
	^ self configuration at: #includeSubDomains
!

maxAge
	^ self configuration at: #maxAge
! !

!WAStrictTransportSecurityFilter methodsFor:'processing'!

handleFiltered: aRequestContext
	"Adds a Secure-Transport-Security header in case the application is transmitted over HTTPS."
	
	| request |
	request := aRequestContext request.
	request isSsl
		ifTrue: [
			aRequestContext response strictTransportSecurity: self maxAge includeSubDomains: self includeSubDomains.
			super handleFiltered: aRequestContext ]
		ifFalse: [
			| safeUrl |
			safeUrl := request url copy.
			safeUrl host: request host.
			safeUrl scheme: 'https'.
			aRequestContext redirectTo: safeUrl ]
! !

