'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:44'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAConfiguration subclass:#WASystemConfiguration
	instanceVariableNames:'description'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Configuration'
!

WASystemConfiguration class instanceVariableNames:'instance'

"
 No other class instance variables are inherited by this class.
"
!

WASystemConfiguration comment:''
!

!WASystemConfiguration class methodsFor:'instance creation'!

new
	^ self error: 'SystemConfigurations are singletons. Use #instance.'
! !

!WASystemConfiguration class methodsFor:'accessing'!

instance
	^ instance ifNil: [ instance := self basicNew initialize ]
! !

!WASystemConfiguration class methodsFor:'actions'!

clearAllDescriptions
	self allSubclasses do: [ :each | each instance clearDescription ]
! !

!WASystemConfiguration class methodsFor:'class initialization'!

initialize
	"Work around for Issue 643
	http://code.google.com/p/seaside/issues/detail?id=643"
	self clearAllDescriptions
! !

!WASystemConfiguration methodsFor:'attributes'!

localAttributeAt: aSymbol ifAbsent: absentBlock
	^ self attributes at: aSymbol ifAbsent: absentBlock
!

localAttributesDo: aBlock
	self attributes do: aBlock
! !

!WASystemConfiguration methodsFor:'copying'!

copy
	^ self error: 'SystemConfigurations are singletons and should not be copied.'
! !

!WASystemConfiguration methodsFor:'description'!

buildDescription
	| d |
	d := WAConfigurationDescription new.
	self describeOn: d.
	^ description := d
!

clearDescription
	description := nil.
	self clearSearchContexts.
!

describeOn: conf
	"Should be implemented by subclasses to add attributes and value overrides to the configuration"
! !

!WASystemConfiguration methodsFor:'private'!

attributes
	^ self description attributes
!

description
	^ description isNil 
		ifFalse: [ description ]
		ifTrue: [ self buildDescription ]
! !

!WASystemConfiguration methodsFor:'values'!

expressionAt: aSymbol ifAbsent: absentBlock
	^ self description expressions at: aSymbol ifAbsent: absentBlock.
! !


WASystemConfiguration initialize!
