'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:43'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAEncoder subclass:#WAUrlEncoder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Document'
!

WAUrlEncoder comment:'I do percent-encoding of parts (e.g. path segments and arguments) of a URI.
Additionally, a Codec is given the chance to encode the characters into bytes before being percent-encoded (see http://tools.ietf.org/html/rfc3986#section-2.5). This allows extended characters to be represented in URIs in, for example, UTF-8.'
!

!WAUrlEncoder class methodsFor:'initialization'!

initialize
	self initializeTable 
! !

!WAUrlEncoder class methodsFor:'instance creation'!

on: aStream codec: aCodec
	^ aCodec url encoderFor: (self on: aStream table: table)
! !

!WAUrlEncoder class methodsFor:'private'!

encode: aCharacter on: aStream 
	| printer |
	('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: aCharacter) ifTrue: [ ^ aStream nextPut: aCharacter ].
	aStream nextPut: $%.
	printer := GRNumberPrinter new.
	printer
		base: 16;
		padding: $0;
		digits: 2;
		uppercase.
	printer 
		print: aCharacter greaseInteger
		on: aStream
!

maximumCharacterValue
	"String to byte encoding has already happened in the server."
	
	^ 16rFF
! !

!WAUrlEncoder methodsFor:'accessing'!

nextPut: aCharacter
	self nextPutAll: (String with: aCharacter)
!

nextPutAll: aString
	(GRPlatform current includesUnsafeUrlCharacter: aString)
		ifTrue: [ super nextPutAll: aString ]
		ifFalse: [ stream nextPutAll: aString ]
! !


WAUrlEncoder initialize!
