'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:42'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WADocument subclass:#WAXmlDocument
	instanceVariableNames:'urlEncoder xmlEncoder'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Document'
!

WAXmlDocument comment:'A WAXmlDocument is adds the possibility to generate XML tags and knows encoders for XML text and URLs.'
!

!WAXmlDocument methodsFor:'accessing'!

urlEncoder
	"Answer an encoder for URL data."

	^ urlEncoder
!

xmlEncoder
	"Answer an encoder for XML data."

	^ xmlEncoder
! !

!WAXmlDocument methodsFor:'initialization'!

destroy
	super destroy.
	urlEncoder := xmlEncoder := nil
!

initializeWithStream: aStream codec: aCodec
	super initializeWithStream: aStream codec: aCodec.
	xmlEncoder := WAXmlEncoder on: aStream.
	urlEncoder := WAUrlEncoder on: aStream codec: aCodec
! !

!WAXmlDocument methodsFor:'writing'!

closeTag: aString
	"Close the XML tag named aString."

	stream nextPutAll: '</'; nextPutAll: aString; nextPut: $>
!

openTag: aString
	"Open the XML tag named aString."

	self openTag: aString attributes: nil closed: false
!

openTag: aString attributes: anAttributes
	"Open the XML tag named aString with the attribute dictionary anAttributes."

	self openTag: aString attributes: anAttributes closed: false
!

openTag: aString attributes: anAttributes closed: aBoolean
	"Open the XML tag named aString with the attribute dictionary anAttributes. Immediately close the tag if aBoolean is true."
	
	stream nextPut: $<; nextPutAll: aString.
	anAttributes encodeOn: self.
	aBoolean ifTrue: [ stream nextPut: $/ ].
	stream nextPut: $>
!

print: anObject
	anObject encodeOn: self
! !

