'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 23:04:41'                     !

"{ Package: 'stx:goodies/seaside30/core' }"

WAEncoder subclass:#WAXmlEncoder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Core-Document'
!

WAXmlEncoder comment:'I encode XHTML text.'
!

!WAXmlEncoder class methodsFor:'initialization'!

initialize
	self initializeTable
! !

!WAXmlEncoder class methodsFor:'private'!

encode: aCharacter on: aStream
	aCharacter = $" ifTrue: [ ^ aStream nextPutAll: '&quot;' ].
	aCharacter = $< ifTrue: [ ^ aStream nextPutAll: '&lt;' ].
	aCharacter = $& ifTrue: [ ^ aStream nextPutAll: '&amp;' ].
	aCharacter = $> ifTrue: [ ^ aStream nextPutAll: '&gt;' ].
	aStream nextPut: aCharacter
!

maximumCharacterValue
	"Since everything bigger than the table does not need to be encoded, we can safe a few bytes here.
	'""<&>' max greaseInteger"
	^ 62
! !

!WAXmlEncoder methodsFor:'accessing'!

nextPutAll: aString
	(GRPlatform current includesUnsafeXmlCharacter: aString)
		ifFalse: [ stream nextPutAll: aString ]
		ifTrue: [
			1 to: aString size do: [ :index |
			| character value encoded |
			character := aString at: index.
			value := character greaseInteger.
			value < table size 
				ifFalse: [
					"no need to encode, unsafe characters are all ascii"
					stream nextPut: character ]
				ifTrue: [
					encoded := table at: value + 1.
					"Issue 482: use #notNil because it is faster than #isString because it is not actually sent"
					encoded notNil 
						ifTrue: [ stream nextPutAll: encoded ]
						ifFalse: [ stream nextPut: character ] ] ] ]
! !


WAXmlEncoder initialize!
