"{ Package: 'stx:goodies/seaside30/core' }"

LibraryDefinition subclass:#stx_goodies_seaside30_core
        instanceVariableNames:''
        classVariableNames:''
        poolDictionaries:''
        category:'* Projects & Packages *'
!

!stx_goodies_seaside30_core class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/core/stx_goodies_seaside30_core.st,v 1.5 2011/09/06 05:32:00 cg Exp $'
! !

!stx_goodies_seaside30_core class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/seaside30/grease'    "GRObject - superclass of WAClosingRevealedConditionalComment "
        #'stx:libbasic'    "Object - superclass of WAAuthConfigurationError "
    )
! !

!stx_goodies_seaside30_core class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        WAAccessIntervalReapingStrategyConfiguration
        WAAuthConfiguration
        WACacheCapacityConfiguration
        WACacheTimeoutConfiguration
        WAError
        WAExceptionFilterConfiguration
        WAFileHandlerConfiguration
        WAHeaderFields
        WAHtmlAttributes
        WANotification
        WAObject
        WARegistryConfiguration
        WARequestFields
        WARequestHandlingConfiguration
        WARetrievalIntervalReapingStrategyConfiguration
        WAStrictTransportSecurityFilterConfiguration
        WAUrlEncoder
        WAXmlEncoder
        #'stx_goodies_seaside30_core'
        WAAttributeSearchContext
        WAAuthConfigurationError
        WABuilder
        WACache
        WACachePlugin
        WACallback
        WACallbackRegistry
        WAClosingConditionalComment
        WAClosingRevealedConditionalComment
        WAConditionalComment
        WAConfiguration
        WAConfigurationDescription
        WAConfigurationElement
        WAConfigurationError
        WADocument
        WADynamicVariable
        WAEmailAddress
        WAExceptionHandler
        WAFile
        WAFileHandlerListing
        WAHtmlElement
        WAHttpVersion
        WAIllegalStateException
        WAInvalidHeaderValueError
        WAMergedRequestFields
        WAMimeDocument
        WAMimeType
        WAMutex
        WAOpeningConditionalComment
        WAPainter
        WAPathConsumer
        WAQualifiedValue
        WARenderContext
        WARenderNotification
        WARequest
        WARequestContext
        WARequestContextNotFound
        WARequestCookie
        WARequestFilter
        WARequestHandler
        WAResponse
        WAResponseGenerator
        WAResponseNotification
        WARoot
        WAScriptGenerator
        WAServerAdaptor
        WASnapshot
        WAUnhandledNotificationError
        WAUnregisteredHandlerError
        WAUrl
        WAValueHolder
        WAVisitor
        WAAccept
        WAAcceptCharset
        WAAcceptEncoding
        WAAcceptLanguage
        WAActionCallback
        WAAttribute
        WAAttributeExpression
        WAAttributeNotFound
        WAAttributeVisitor
        WAAuthenticationFilter
        WABaseElement
        WABufferedResponse
        WACacheExpiryPolicy
        WACacheMissStrategy
        WACacheReapingStrategy
        WACacheRemovalAction
        WAConfiguredRequestFilter
        WAContentElement
        WACookie
        WACurrentRequestContext
        WADefaultScriptGenerator
        WADispatchCallback
        WADocumentHandler
        WAErrorHandler
        WAForbiddenFileHandlerListing
        WAHtmlRoot
        WAMetaElement
        WAOpeningRevealedConditionalComment
        WAPainterVisitor
        WAProtectionFilter
        WARegistry
        WARevealedConditionalComment
        WAStreamedResponse
        WATextFileHandlerListing
        WATrailingSlashFilter
        WATransactionFilter
        WAUserConfiguration
        WAValueCallback
        WAXmlDocument
        WAXmlRoot
        WAAccessIntervalReapingStrategy
        WAAddRemoveExpression
        WABooleanAttribute
        WACancelActionCallback
        WADefaultActionCallback
        WAExceptionFilter
        WAHtmlDocument
        WAImageCallback
        WALastAccessExpiryPolicy
        WALeastRecentlyUsedExpiryPolicy
        WALinkElement
        WAListAttribute
        WAMapCallback
        WANotifyRemovalAction
        WANullReapingStrategy
        WANumberAttribute
        WAPasswordAttribute
        WARenderVisitor
        WARetrievalIntervalReapingStrategy
        WAScriptElement
        WAStrictTransportSecurityFilter
        WAStringAttribute
        WAUnescapedDocument
        WAUpdateRootVisitor
        WAUpdateUrlVisitor
        WAUploadCallback
        WAUrlAttribute
        WAValueExpression
        WAValuesCallback
        WACollectionAttribute
        WAIntegerAttribute
        WAMultipleValuesCallback
        WAEncoder
        WAFileLibrary
        WAKeyGenerator
        WALocale
        WARenderer
        WAServerManager
        WADispatcher
        WAFileHandler
        WASystemConfiguration
        WASharedConfiguration
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        ByteArray renderOn:
        ByteArray seasideMimeDocument
        ByteArray seasideMimeDocumentType:
        Collection renderOn:
        Dictionary seasideRequestFields
        Dictionary valuesCollect:
        Exception seasidePossibleCauses
        GRInvalidUtf8Error seasidePossibleCauses
        GRPlatform seasideVersion
        GRSmallDictionary seasideRequestFields
        GRUnsupportedEncodingError seasidePossibleCauses
        MessageNotUnderstood seasidePossibleCauses
        Object encodeOn:
        Object labelForSelector:
        Object renderOn:
        String asCapitalizedPhrase
        String encodeOn:
        String renderOn:
        String seasideMimeDocument
        String seasideMimeDocumentType:
        String seasideMimeType
        String seasideUrl
        UndefinedObject encodeOn:
        UndefinedObject renderOn:
        UndefinedObject seasideUrl
        WADispatcher childrenDo:
        WADispatcher defaultHandler
        WADispatcher defaultName
        WADispatcher defaultName:
        WADispatcher entryPointAt:
        WADispatcher handleDefault:
        WADispatcher handleFiltered:
        WADispatcher handleFiltered:named:
        WADispatcher handlerAt:
        WADispatcher handlerAt:ifAbsent:
        WADispatcher handlerAt:with:
        WADispatcher handlers
        WADispatcher initialize
        WADispatcher isDispatcher
        WADispatcher nameOfHandler:
        WADispatcher postCopy
        WADispatcher register:at:
        WADispatcher unregister:
        WADispatcher urlFor:
        WAEncoder initializeOn:table:
        WAEncoder nextPut:
        WAEncoder nextPutAll:
        WAFileHandler baseUrlForLibrary
        WAFileHandler defaultConfiguration
        WAFileHandler fileHandlerListingClass
        WAFileHandler handleFiltered:
        WAFileHandler libraries
        WAFileHandler libraryAt:ifAbsent:
        WAFileHandler resourceBaseUrl
        WAFileHandler responseForContext:
        WAFileHandler useXSendfile
        WAFileHandler xSendfileBaseDirectory
        WAFileLibrary addFile:
        WAFileLibrary asFilename:
        WAFileLibrary asSelector:
        WAFileLibrary cacheDuration
        WAFileLibrary compileBinary:selector:
        WAFileLibrary compileText:selector:
        WAFileLibrary deployFiles
        WAFileLibrary documentForFile:
        WAFileLibrary fileSelectors
        WAFileLibrary fileSizeOf:
        WAFileLibrary filenames
        WAFileLibrary fullPathForFileName:using:
        WAFileLibrary handle:
        WAFileLibrary isFileSelector:
        WAFileLibrary lastUpperCaseIndexIn:
        WAFileLibrary mimetypeForFile:
        WAFileLibrary name
        WAFileLibrary nonFileSelectors
        WAFileLibrary removeFile:
        WAFileLibrary renameFile:to:
        WAFileLibrary selectorsToInclude
        WAFileLibrary updateRoot:
        WAFileLibrary urlForFile:
        WAFileLibrary urlOf:
        WAFileLibrary urlOf:using:
        WAKeyGenerator generator:
        WAKeyGenerator initialize
        WAKeyGenerator keyOfLength:
        WAKeyGenerator space:
        WALocale country
        WALocale country:
        WALocale countryName
        WALocale greaseString
        WALocale language
        WALocale language:
        WALocale languageName
        WALocale printOn:
        WALocale withoutCountry
        WARenderer absoluteUrlForResource:
        WARenderer actionBaseUrl
        WARenderer actionUrl
        WARenderer callbacks
        WARenderer context
        WARenderer document
        WARenderer flush
        WARenderer initializeWithContext:
        WARenderer lastId
        WARenderer nextId
        WARenderer render:
        WARenderer text:
        WARenderer urlForAction:
        WAServerManager adaptors
        WAServerManager canStart:
        WAServerManager canStop:
        WAServerManager initialize
        WAServerManager register:
        WAServerManager restart:
        WAServerManager restartAll
        WAServerManager start:
        WAServerManager startAll
        WAServerManager stop:
        WAServerManager stopAll
        WAServerManager unregister:
        WASharedConfiguration initializeWithName:
        WASharedConfiguration isShared
        WASharedConfiguration name
        WASharedConfiguration unregister
        WASystemConfiguration attributes
        WASystemConfiguration buildDescription
        WASystemConfiguration clearDescription
        WASystemConfiguration copy
        WASystemConfiguration describeOn:
        WASystemConfiguration description
        WASystemConfiguration expressionAt:ifAbsent:
        WASystemConfiguration localAttributeAt:ifAbsent:
        WASystemConfiguration localAttributesDo:
        'GRPackage class' seasideCore
        'WADispatcher class' default
        'WADispatcher class' description
        'WADispatcher class' resetDefault
        'WAEncoder class' encode:on:
        'WAEncoder class' initializeTable
        'WAEncoder class' maximumCharacterValue
        'WAEncoder class' new
        'WAEncoder class' on:
        'WAEncoder class' on:codec:
        'WAEncoder class' on:table:
        'WAFileHandler class' default
        'WAFileHandler class' default:
        'WAFileHandler class' description
        'WAFileLibrary class' #'/'
        'WAFileLibrary class' addAllFilesIn:
        'WAFileLibrary class' addFileAt:
        'WAFileLibrary class' addFileAt:contents:
        'WAFileLibrary class' addFileNamed:contents:
        'WAFileLibrary class' adjustForVisualWorks
        'WAFileLibrary class' asSelector:
        'WAFileLibrary class' compileBinary:selector:
        'WAFileLibrary class' compileText:selector:
        'WAFileLibrary class' default
        'WAFileLibrary class' defaultMimeType
        'WAFileLibrary class' defaultMimeTypes
        'WAFileLibrary class' deployFiles
        'WAFileLibrary class' handle:
        'WAFileLibrary class' handlesFolder:
        'WAFileLibrary class' initialize
        'WAFileLibrary class' isBinary:
        'WAFileLibrary class' isBinaryAt:
        'WAFileLibrary class' methodCategory
        'WAFileLibrary class' migrateSubclassesSeaside29
        'WAFileLibrary class' migrateToSeaside29
        'WAFileLibrary class' mimetypeFor:
        'WAFileLibrary class' mimetypes
        'WAFileLibrary class' register
        'WAFileLibrary class' unregister
        'WAFileLibrary class' urlOf:
        'WAKeyGenerator class' current
        'WAKeyGenerator class' initialize
        'WALocale class' countryList
        'WALocale class' fromString:
        'WALocale class' initialize
        'WALocale class' initializeCountryList
        'WALocale class' initializeLangaugeList
        'WALocale class' iso2Countries
        'WALocale class' iso2Languages
        'WALocale class' iso3Countries
        'WALocale class' iso3Languages
        'WALocale class' language:
        'WALocale class' language:country:
        'WALocale class' languageList
        'WARenderer class' builder
        'WARenderer class' context:
        'WARenderer class' default
        'WARenderer class' default:
        'WARenderer class' resetDefault
        'WARenderer class' selectAsDefault
        'WARenderer class' unselectAsDefault
        'WAServerManager class' default
        'WAServerManager class' initialize
        'WAServerManager class' shutDown
        'WAServerManager class' startUp
        'WAServerManager class' unload
        'WASharedConfiguration class' configurations
        'WASharedConfiguration class' initialize
        'WASharedConfiguration class' named:
        'WASharedConfiguration class' new
        'WASharedConfiguration class' unregister:
        'WASystemConfiguration class' clearAllDescriptions
        'WASystemConfiguration class' initialize
        'WASystemConfiguration class' instance
        'WASystemConfiguration class' new
    )
! !

!stx_goodies_seaside30_core class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_seaside30_core class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/core/stx_goodies_seaside30_core.st,v 1.5 2011/09/06 05:32:00 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/core/stx_goodies_seaside30_core.st,v 1.5 2011/09/06 05:32:00 cg Exp $'
! !
