'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

TestCase subclass:#WAContextTest
	instanceVariableNames:'requestContext'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-RequestHandling'
!

WAContextTest comment:'I am the base class for all tests that need a WARequestContext present.
'
!

!WAContextTest class methodsFor:'testing'!

isAbstract
	^ self name = #WAContextTest
! !

!WAContextTest methodsFor:'accessing'!

requestContext
	^ requestContext
! !

!WAContextTest methodsFor:'configuration'!

createCodec
	^ GRNullCodec new
!

createHandlers
	^ #()
!

createRequest
	^ WARequest new
!

createRequestContext
	^ WARequestContext request: self createRequest response: self createResponse codec: self createCodec
!

createResponse
	^ WABufferedResponse new
! !

!WAContextTest methodsFor:'private'!

pushAll: aCollection during: aBlock
	^ aCollection isEmpty
		ifTrue: [ aBlock value ]
		ifFalse: [
			self requestContext
				push: aCollection first
				during: [ self pushAll: aCollection allButFirst during: aBlock ] ]
! !

!WAContextTest methodsFor:'running'!

performTest

	requestContext := self createRequestContext.
	WACurrentRequestContext 
		use: self requestContext
		during: [
			self
				pushAll: self createHandlers
				during: [ super performTest ] ]
! !

!WAContextTest methodsFor:'utilities'!

requestContextWithUrl: aUrlOrString
	self requestContextWithUrl: aUrlOrString cookies: Array new
!

requestContextWithUrl: aUrlOrString cookies: aCollection
	| handlers |
	handlers := self requestContext handlers.
	self requestContext
		initializeWithRequest: 
			((WARequest method: 'GET' uri: aUrlOrString)
				setCookies: aCollection asArray;
				yourself)
		response: WABufferedResponse new
		codec: self createCodec.
	self requestContext handlers addAll: handlers
!

responseAfter: aBlock
	self requestContext response initialize.
	aBlock on: WAResponseNotification do: [ :n | ].
	^ self requestContext response
! !

