'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

WAContextTest subclass:#WADocumentHandlerResponseTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-RequestHandling'
!

WADocumentHandlerResponseTest comment:''
!

!WADocumentHandlerResponseTest methodsFor:'private'!

assertHttpResponseFrom: aResponse matches: aHandler
	| expectedContents actualContents |
	self assert: aResponse status = 200.
	self assert: aResponse contentType = aHandler document mimeType.
	expectedContents := aHandler document contents.
	actualContents := aResponse contents.
	self assert: actualContents size = expectedContents size.
	self assert: actualContents species = expectedContents species.
	self assert: aResponse cookies isEmpty
!

createAndVerifyBinaryDocumentNamed: aFilename hasAttachment: aHttpHeaderValue
	self
		createAndVerifyDocumentNamed: aFilename
		content: WATestingFiles default samplePng
		mimeType: WAMimeType imagePng
		hasAttachment: aHttpHeaderValue
!

createAndVerifyDocumentNamed: aFilename content: anObject mimeType: aMimeTypeString hasAttachment: aHttpHeaderValue
	| handler response |
	handler := WADocumentHandler
		document: anObject
		mimeType: aMimeTypeString
		fileName: aFilename.
	self assert: handler document contents = anObject.
	response := self responseAfter: [ handler handle: self requestContext ].
	self assert: (self headerAt: 'Expires' forResponse: response) notNil.
	self assert: (self headerAt: 'Content-Disposition' forResponse: response) = aHttpHeaderValue.
	self assertHttpResponseFrom: response matches: handler
!

createAndVerifyTextDocumentNamed: aFilename hasAttachment: aHttpHeaderValue
	self
		createAndVerifyDocumentNamed: aFilename
		content: 'body { background-color: #ffffff }'
		mimeType: WAMimeType textCss
		hasAttachment: aHttpHeaderValue
!

headerAt: aString forResponse: aResponse
	^ aResponse headerAt: aString
! !

!WADocumentHandlerResponseTest methodsFor:'tests'!

testByteArrayWithFilename
	self
		createAndVerifyBinaryDocumentNamed: 'sample.png'
		hasAttachment: 'attachment; filename="sample.png"'
!

testByteArrayWithoutFilename
	self
		createAndVerifyBinaryDocumentNamed: nil
		hasAttachment: nil
!

testStringWithFilename
	self
		createAndVerifyTextDocumentNamed: 'toolbar.css'
		hasAttachment: 'attachment; filename="toolbar.css"'
!

testStringWithoutFilename
	self
		createAndVerifyTextDocumentNamed: nil
		hasAttachment: nil
! !

