'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

WAContextTest subclass:#WAEncoderTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-Document'
!

WAEncoderTest comment:''
!

!WAEncoderTest class methodsFor:'testing'!

shouldInheritSelectors
	^ true
! !

!WAEncoderTest methodsFor:'private'!

assert: aString encoder: aClass gives: anEncodedString
	| actual |
	actual := String streamContents: [ :stream |
		(aClass on: stream codec: self requestContext codec) nextPutAll: aString ].
	self assert: actual = anEncodedString
! !

!WAEncoderTest methodsFor:'tests'!

testEncodedUrl
	self assert: 'Seaside Aubergines' encoder: WAUrlEncoder gives: 'Seaside%20Aubergines'.
	self assert: 'www.seaside.st' encoder: WAUrlEncoder gives: 'www.seaside.st'.
	self assert: '~seaside-info_' encoder: WAUrlEncoder gives: '~seaside-info_'.
	self assert: 'http://www.seaside.st?foo=1&bar=2' encoder: WAUrlEncoder gives: 'http%3A%2F%2Fwww.seaside.st%3Ffoo%3D1%26bar%3D2'.
	self assert: 'a%' encoder: WAUrlEncoder gives: 'a%25'.
	self assert: (String with: Character cr) encoder: WAUrlEncoder gives: '%0D'
!

testEncodedXml
	self assert: 'Seaside' encoder: WAXmlEncoder gives: 'Seaside'.
	self assert: '<div id="&amp;">' encoder: WAXmlEncoder gives: '&lt;div id=&quot;&amp;amp;&quot;&gt;'
! !

