'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

WAContextTest subclass:#WAFileHandlerListingTest
	instanceVariableNames:'handler'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-Libraries'
!

WAFileHandlerListingTest comment:''
!

!WAFileHandlerListingTest class methodsFor:'testing'!

isAbstract
	^ self name = #WAFileHandlerListingTest
! !

!WAFileHandlerListingTest methodsFor:'testing'!

assertLibrariesResponse: response
	self assert: (response contents 
					indexOfSubCollection: self expectedLibrariesContents 
					startingAt: 1) > 0
!

assertLibraryResponse: response
	self assert: (response contents
					indexOfSubCollection: self expectedLibraryContents
					startingAt: 1) > 0
!

expectedLibrariesContents
	^ (handler libraries detect: [ :each | true ]) name
!

expectedLibraryContents
	^ WATestingFiles default filenames detect: [ :each | true ]
!

expectedMimeType
	self subclassResponsibility
!

expectedStatus
	^ 200
!

handlerClass
	self subclassResponsibility
!

testFileLibraries
	| response |
	handler := WAFileHandler new.
	handler preferenceAt: #fileHandlerListingClass put: self handlerClass.

	self requestContextWithUrl: '/i/dont/care/'.
	self requestContext consumer next; next; next.

	response := self responseAfter: [ handler handle: self requestContext ].

	self assert: response status = self expectedStatus.
	self assert: response contentType = self expectedMimeType.
	self assertLibrariesResponse: response.
!

testFileLibrary
	| response |
	handler := WAFileHandler new.
	handler preferenceAt: #fileHandlerListingClass put: self handlerClass.
	self requestContextWithUrl: '/i/dont/care/WATestingFiles'.
	self requestContext consumer next; next; next.

	response := self responseAfter: [ handler handle: self requestContext ].

	self assert: response status = self expectedStatus.
	self assert: response contentType = self expectedMimeType.
	self assertLibraryResponse: response.
! !

