'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

TestCase subclass:#WAFileTest
	instanceVariableNames:'file'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-HTTP'
!

WAFileTest comment:''
!

!WAFileTest methodsFor:'running'!

setUp
	file := WAFile new
! !

!WAFileTest methodsFor:'tests'!

testBorderline
	file fileName: 'C'.
	self assert: file fileName = 'C'.
	file fileName: 'C:'.
	self assert: file fileName = 'C:'.
	file fileName: 'C:\'.
	self assert: file fileName = ''
!

testContentType
	file contentType: 'text/plain'.
	self assert: file contentType = 'text/plain' seasideMimeType.
	
	file contentType: 'text/plain' seasideMimeType.
	self assert: file contentType = 'text/plain' seasideMimeType.

	file contentType: nil.
	self assert: file contentType isNil
!

testContents
	file contents: #(83 101 97 115 105 100 101) asByteArray.
	self assert: file rawContents = #(83 101 97 115 105 100 101) asByteArray.
	self assert: file contents = 'Seaside'.
	self assert: (file contentsDecodedUsing: 'ISO-8859-1') = 'Seaside'
	
	
!

testContentsDecoded
	file contents: #(83 101 97 115 105 100 101) asByteArray.
	self should: [ file contentsDecoded ] raise: WAIllegalStateException.
	file contentType: 'text/plain'.
	self should: [ file contentsDecoded ] raise: WAIllegalStateException.
	file contentType: 'text/plain; charset=iso-8859-1' seasideMimeType.
	self assert: file contentsDecoded = 'Seaside'
	
	
!

testNonLatinWindowsPath
	| koreanName |
	"If the following assertion fails, your Smalltalk dialect most probably does not support non-latin characters. This is true for Squeak 3.7. If your Smalltalk dialect does support non-latin characters adjust the test."
	self shouldnt:  [
		koreanName := (String
			with: (Character codePoint: 50976)
			with: (Character codePoint: 47532)
			with: (Character codePoint: 47484)), '.txt' ]
		raise: Error.

	file fileName: koreanName.
	self assert: file fileName = koreanName.
	file fileName: 'C:\important\', koreanName.
	self assert: file fileName = koreanName
!

testWindowsPath
	file fileName: 'C:\important\passwords.txt'.
	self assert: file fileName = 'passwords.txt'.
	file fileName: '/important/passwords.txt'.
	self assert: file fileName = '/important/passwords.txt'.
	file fileName: 'passwords.txt'.
	self assert: file fileName = 'passwords.txt'
! !

