'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

GROrderedMultiMapTest subclass:#WAHeaderFieldsTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-HTTP'
!

WAHeaderFieldsTest comment:''
!

!WAHeaderFieldsTest methodsFor:'configuration'!

collectionClass
	^ WAHeaderFields
! !

!WAHeaderFieldsTest methodsFor:'tests'!

testCrLf
	| crlf testValue |
	crlf := String with: Character cr with: Character lf.
	testValue := 'value', crlf, 'Location: www.bad.com', crlf, crlf.
	self
		should: [
			collection add: 'key' -> testValue ]
		raise: WAInvalidHeaderValueError.
	self
		should: [
			collection addAll: (Dictionary new
				add: 'key' -> testValue;
				yourself) ]
		raise: WAInvalidHeaderValueError.
	self
		should: [
			collection at: 'key' append: testValue ]
		raise: WAInvalidHeaderValueError.
	self
		should: [
			collection at: 'key' add: testValue ]
		raise: WAInvalidHeaderValueError.
	self
		should: [
			collection at: 'key' put: testValue ]
		raise: WAInvalidHeaderValueError
	
!

testDictionaryConversion
	| dict |
	dict := Dictionary new at: 1 put: 2; yourself.
	collection := dict seasideRequestFields.
	self assert: (collection isKindOf: WARequestFields).
	self assertAssociations: (Array with: 1 -> 2)
!

testSmallDictionaryConversion
	| dict |
	dict := GRSmallDictionary new at: 1 put: 2; yourself.
	collection := dict seasideRequestFields.
	self assert: (collection isKindOf: WARequestFields).
	self assertAssociations: (Array with: 1 -> 2)
! !

!WAHeaderFieldsTest methodsFor:'tests-accessing'!

testAt
	self assert: (collection removeKey: '1') isNil.
	collection add: '1' -> 'foo'.
	collection add: '1' -> 'bar'.
	self assert: (collection at: '1') =
		(self allowsDuplicateKeys ifTrue: [ 'foo' ] ifFalse: [ 'bar' ])
!

testRemoveKey
	self assert: (collection removeKey: '1') isNil.
	collection add: '1' -> 'foo'.
	collection add: '1' -> 'bar'.
	collection add: '2' -> 'baz'.
	self assert: (collection removeKey: '1') =
		(self allowsDuplicateKeys ifTrue: [ #('foo' 'bar') ] ifFalse: [ 'bar' ]).
	self assertAssociations: (Array with: '2' -> 'baz').
	self assert: (collection removeKey: '2') =
		(self allowsDuplicateKeys ifTrue: [ #('baz') ] ifFalse: [ 'baz' ]).
	self assertAssociations: #().
! !

