'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

TestCase subclass:#WALocaleTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-HTTP'
!

WALocaleTest comment:''
!

!WALocaleTest methodsFor:'tests'!

testCountryName
	| locale |
	locale := WALocale fromString: 'de-CH'.
	
	self assert: locale countryName = 'SWITZERLAND'.
	
	locale := WALocale fromString: 'en-ZA'.
	
	self assert: locale countryName = 'SOUTH AFRICA'.
	
	locale := WALocale fromString: 'eng-ZAF'.
	
	self assert: locale countryName = 'SOUTH AFRICA'
!

testIso3
	| locale |
	locale := WALocale fromString: 'gsw-CHE'.
	self assert: locale language = 'gsw'.
	self assert: locale country = 'CHE'.
	self assert: locale greaseString = 'gsw-CHE'.
	locale := WALocale fromString: 'gsw_CHE'.
	self assert: locale language = 'gsw'.
	self assert: locale country = 'CHE'.
	self assert: locale greaseString = 'gsw-CHE'
!

testLanguage
	| locale |
	locale := WALocale language: 'de'.
	self assert: locale language = 'de'.
	self assert: locale country isNil
!

testLanguageName
	| locale |
	locale := WALocale fromString: 'de'.
	
	self assert: locale languageName = 'German'.
	
	locale := WALocale fromString: 'gsw'.
	
	self assert: locale languageName = 'Swiss German; Alemannic; Alsatian'
!

testLangugeAndCountry
	| locale |
	locale := WALocale fromString: 'de-CH'.
	self assert: locale language = 'de'.
	self assert: locale country = 'CH'.
	self assert: locale greaseString = 'de-CH'.
	locale := WALocale fromString: 'de_CH'.
	self assert: locale language = 'de'.
	self assert: locale country = 'CH'.
	self assert: locale greaseString = 'de-CH'
!

testLangugeOnly
	| locale |
	locale := WALocale fromString: 'de'.
	self assert: locale language = 'de'.
	self assert: locale country isNil.
	self assert: locale greaseString = 'de'
!

testWithoutCountry
	| locale |
	locale := WALocale fromString: 'de_CH'.
	self assert: locale language = 'de'.
	self assert: locale country = 'CH'.
	locale := locale withoutCountry.
	self assert: locale language = 'de'.
	self assert: locale country isNil.
	
	locale := WALocale fromString: 'de'.
	self assert: locale language = 'de'.
	self assert: locale country isNil.
	locale := locale withoutCountry.
	self assert: locale language = 'de'.
	self assert: locale country isNil.
! !

