'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

TestCase subclass:#WARequestTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-HTTP'
!

WARequestTest comment:''
!

!WARequestTest methodsFor:'tests'!

test10
	| request |
	request := WARequest method: 'GET' uri: '/' version: WAHttpVersion http10.
	
	self assert: request isGet.
	self assert: request isHttp10.
	self deny: request isSsl
!

test11
	| request |
	request := WARequest method: 'GET' uri: '/' version: WAHttpVersion http11.
	
	self assert: request isGet.
	self assert: request isHttp11.
	self deny: request isSsl
!

testBasicAuthorisation
	| request headers |
	request := WARequest method: 'GET' uri: '/foo?bar=1'.
	headers := Dictionary new.
	headers at: 'authorization' put: 'Basic QWxhZGRpbjpvcGVuIHNlc2FtZQ=='.
	request setHeaders: headers.
	
	self assert: request authorization = 'Aladdin:open sesame'.
	self assert: request user = 'Aladdin'.
	self assert: request password = 'open sesame'
!

testIsPrefetch
	| request headers |
	request := WARequest method: 'GET' uri: '/foo'.
	self deny: request isPrefetch.
	
	headers := Dictionary new.
	headers at: 'x-moz' put: 'prefetch'.
	request setHeaders: headers.
	self assert: request isPrefetch
!

testIsSsl
	| request |
	request := WARequest
		method: 'GET'
		uri: ('/' seasideUrl
			scheme: 'https';
			yourself)
		version: WAHttpVersion http11.
	
	self assert: request isGet.
	self assert: request isHttp11.
	self assert: request isSsl
!

testPostFields
	| request headers |
	request := WARequest method: 'POST' uri: '/foo?bar=1'.
	headers := Dictionary new.
	headers at: 'content-type' put: WAMimeType formUrlencoded greaseString.
	request setHeaders: headers.
	request setBody: 'baz=2&bar=3'.
	request setPostFields: (WARequestFields new at: 'baz' put: '2'; at: 'bar' put: '3'; yourself).
	
	self assert: request postFields size = 2.
	self assert: (request postFields at: 'baz') = '2'.
	self assert: (request postFields at: 'bar') = '3'.
	self assert: request queryFields size = 1.
	self assert: (request queryFields at: 'bar') = '1'.
	self assert: request fields size = 3.
	self assert: (request fields at: 'bar') = '1'.
	self assert: (request fields at: 'baz') = '2'.
! !

