'From Smalltalk/X, Version:6.2.1 on 05-09-2011 at 22:03:41'                     !

"{ Package: 'stx:goodies/seaside30/core/tests' }"

WAResponseTest subclass:#WAStreamedResponseTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Tests-Core-HTTP'
!

WAStreamedResponseTest comment:''
!

!WAStreamedResponseTest methodsFor:'accessing'!

contents
	self response flush.
	^ self response stream contents
!

response
	^ super response ifNil: [ response := WAStreamedResponse on: (WriteStream on: String new) ]
! !

!WAStreamedResponseTest methodsFor:'private'!

assertLines: anArray
	"Streamed responses don't have content length information. They simply can't know."
	
	super assertLines: (anArray reject: [ :each | each beginsWithSubCollection: 'Content-Length' ])
! !

!WAStreamedResponseTest methodsFor:'tests'!

testIsCommitted
	super testIsCommitted.
	self assert: self response isCommitted
! !

!WAStreamedResponseTest methodsFor:'tests-flush'!

testFlushDelay
	self response forbidden.
	self response headerAt: 'X-Application-Server' put: 'Seaside'.
	self deny: self response isCommitted.
	self 
		shouldnt: [ self response committedCheck ]
		raise: WAIllegalStateException
!

testFlushNextPutAll
	self response nextPutAll: 'Hello World'. " <-- should flush "
	self assert: self response isCommitted.
	self 
		should: [ self response committedCheck ]
		raise: WAIllegalStateException.
	self assertLines: #('HTTP/1.1 200 OK' '' 'Hello World')
!

testFlushStream
	self response stream. " <-- should flush "
	self assert: self response isCommitted.
	self 
		should: [ self response committedCheck ]
		raise: WAIllegalStateException.
	self assertLines: #('HTTP/1.1 200 OK' '')
! !

!WAStreamedResponseTest methodsFor:'tests-state'!

testCookieAfterCommit
	self response flush.
	self 
		should: [ self response addCookie: WACookie new ]
		raise: WAIllegalStateException
!

testHeaderAfterCommit
	self response flush.
	self 
		should: [ self response headerAt: 'foo' put: 'bar' ]
		raise: WAIllegalStateException.
	self 
		should: [ self response headerAt: 'foo' append: 'bar' ]
		raise: WAIllegalStateException.
	self 
		should: [ self response removeHeaderAt: 'foo' ]
		raise: WAIllegalStateException
!

testStatusAfterCommit
	self response flush.
	self 
		should: [ self response forbidden ]
		raise: WAIllegalStateException.
	self 
		should: [ self response status: 404 message: 'Almost found' ]
		raise: WAIllegalStateException
! !

