"{ Package: 'stx:goodies/seaside30/core/tests' }"

LibraryDefinition subclass:#stx_goodies_seaside30_core_tests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_seaside30_core_tests class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/seaside30/core'    "WARequestHandler - superclass of WANextUnconsumedPathElementRequestHandler "
        #'stx:goodies/seaside30/grease'    "GRObject - superclass of WATestNoopSessionHandler "
        #'stx:goodies/seaside30/grease/tests'    "GROrderedMultiMapTest - superclass of WARequestFieldsTest "
        #'stx:goodies/sunit'    "TestCase - superclass of WAResponseTest "
        #'stx:libbasic'    "Object - superclass of WAPathConsumerTest "
    )
! !

!stx_goodies_seaside30_core_tests class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (WAAcceptTest autoload)
        (WABacktrackingTest autoload)
        (WACallbackTest autoload)
        (WACollectionMimeDocumentTest autoload)
        WAConfigurationMock
        (WAConfigurationTest autoload)
        (WAContextTest autoload)
        (WACookieTest autoload)
        (WACurrentRequestContextTest autoload)
        (WADynamicVariableTest autoload)
        (WAExceptionHandlerTest autoload)
        (WAFileTest autoload)
        (WAHeaderFieldsTest autoload)
        (WAHttpVersionTest autoload)
        (WAKeyGeneratorTest autoload)
        (WALocaleTest autoload)
        (WAMergedRequestFieldsTest autoload)
        (WAMimeDocumentTest autoload)
        (WAMimeTypeTest autoload)
        (WAMutexTest autoload)
        WANextUnconsumedPathElementRequestHandler
        (WAObjectTest autoload)
        (WAPathConsumerTest autoload)
        (WAPlatformTest autoload)
        (WARegistryKeyHandlingTest autoload)
        (WARenderContextTest autoload)
        (WARequestContextTest autoload)
        (WARequestFieldsTest autoload)
        (WARequestTest autoload)
        (WAResponseTest autoload)
        (WAServerManagerTest autoload)
        WATestError
        WATestNoopRequestHandler
        WATestNoopSessionHandler
        WATestServerAdaptor
        WATestingFiles
        #'stx_goodies_seaside30_core_tests'
        (WAAbstractHtmlElementTest autoload)
        (WABufferedResponseTest autoload)
        (WACacheTest autoload)
        (WADocumentHandlerResponseTest autoload)
        (WAEncoderTest autoload)
        (WAErrorHandlerTest autoload)
        (WAFileHandlerListingTest autoload)
        (WAFileLibraryTest autoload)
        (WAHtmlAttributesTest autoload)
        (WARequestHandlerTest autoload)
        (WAStreamedResponseTest autoload)
        (WAUrlTest autoload)
        (WADispatcherTest autoload)
        (WADocumentHandlerTest autoload)
        (WAFileHandlerTest autoload)
        (WAForbiddenFileHandlerListingTest autoload)
        (WAMetaElementTest autoload)
        (WARegistryTest autoload)
        (WATextFileHandlerListingTest autoload)
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        'GRPackage class' seasideTestsCore
    )
! !

!stx_goodies_seaside30_core_tests class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_seaside30_core_tests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/core/tests/stx_goodies_seaside30_core_tests.st,v 1.2 2011/09/05 20:41:18 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/core/tests/stx_goodies_seaside30_core_tests.st,v 1.2 2011/09/05 20:41:18 cg Exp $'
! !
