"{ Package: 'stx:goodies/seaside30/grease' }"

GRDelayedSendMessage subclass:#GRBoundMessage
	instanceVariableNames:'arguments'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Core-Utilities'
!

GRBoundMessage comment:'A delayed send that has some or all of the arguments defined in advance. Additionally supplied arguments will be added, if possible, to these when the object is evaluate.
Instance Variables
	arguments:		<Array>
arguments
	- the predefined arguments
'
!


!GRBoundMessage class methodsFor:'instance creation'!

selector: aSymbol
	^ self selector: aSymbol arguments: #()
!

selector: aSymbol arguments: anArray
	^ self basicNew
		initializeWithSelector: aSymbol arguments: anArray;
		yourself
! !

!GRBoundMessage methodsFor:'delegation'!

argumentCount
	^ selector numArgs - arguments size
! !

!GRBoundMessage methodsFor:'initialization'!

initializeWithSelector: aSymbol arguments: anArray
	self initializeWithSelector: aSymbol.
	arguments := anArray asArray
! !

!GRBoundMessage methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' arguments: '; print: arguments
! !

!GRBoundMessage methodsFor:'private'!

mergeArguments: anArray
	^ arguments , anArray
! !

!GRBoundMessage class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRBoundMessage.st,v 1.1 2011/09/05 17:23:14 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRBoundMessage.st,v 1.1 2011/09/05 17:23:14 cg Exp $'
! !
