"{ Package: 'stx:goodies/seaside30/grease' }"

GRCodec subclass:#GRNullCodec
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Core-Text'
!

GRNullCodec comment:'The null codec always returns the original streams. It assumes that the outside world uses the same encoding as the inside world. This is highly efficient as no transfomration is applied to the data, but has its drawbacks.'
!


!GRNullCodec class methodsFor:'accessing'!

codecName
	^ '(none)'
!

codecs
	^ Array with: self new
! !

!GRNullCodec class methodsFor:'private'!

basicForEncoding: aString
	^ self new
! !

!GRNullCodec class methodsFor:'testing'!

supportsEncoding: aString
	^ aString isNil
! !

!GRNullCodec methodsFor:'accessing'!

name
	^ GRNullCodec codecName
!

url
	"The selfish method. Let's do it with ourselves."
	
	^ self
! !

!GRNullCodec methodsFor:'convenience'!

decode: aString
	"Overridden for efficencey."

	^ aString
!

encode: aString
	"Overridden for efficencey."

	^ aString
! !

!GRNullCodec methodsFor:'conversion'!

decoderFor: aReadStream 
	"wrap to avoid String vs ByteArray issues"
	^ GRNullCodecStream on: aReadStream
!

encoderFor: aWriteStream 
	"wrap to avoid String vs ByteArray issues"
	^ GRNullCodecStream on: aWriteStream
! !

!GRNullCodec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRNullCodec.st,v 1.1 2011/09/05 17:52:49 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRNullCodec.st,v 1.1 2011/09/05 17:52:49 cg Exp $'
! !
