"{ Package: 'stx:goodies/seaside30/grease' }"

GRCodecStream subclass:#GRNullCodecStream
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Core-Text'
!

GRNullCodecStream comment:'A WANullCodecStream is a WriteStream on a String on which you can both put binary and character data without encoding happening.
Instance Variables
	stream:		<WriteStream>
stream
	- a WriteStream on a String
'
!


!GRNullCodecStream methodsFor:'streaming'!

next
	^ stream next
!

next: anInteger
	^ stream next: anInteger
!

nextPut: aCharacterOrByte
	aCharacterOrByte isCharacter
		ifTrue: [ stream nextPut: aCharacterOrByte ]
		ifFalse: [ stream nextPut: (Character codePoint: aCharacterOrByte) ]
!

nextPutAll: aStringOrByteArray
	aStringOrByteArray isString
		ifTrue: [ stream nextPutAll: aStringOrByteArray ]
		ifFalse: [
			1 to: aStringOrByteArray size do: [ :index |
				stream nextPut: (Character codePoint: (aStringOrByteArray at: index)) ] ]
! !

!GRNullCodecStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRNullCodecStream.st,v 1.1 2011/09/05 17:53:40 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRNullCodecStream.st,v 1.1 2011/09/05 17:53:40 cg Exp $'
! !
