"{ Package: 'stx:goodies/seaside30/grease' }"

GRPrinter subclass:#GRStringPrinter
	instanceVariableNames:'trim length pad character'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Core-Text'
!

GRStringPrinter comment:''
!


!GRStringPrinter methodsFor:'accessing'!

character: aCharacter
	"The character to pad the string with."
	
	character := aCharacter
!

length: anInteger
	"The maximal size of the string, or the size to pad to."

	length := anInteger
! !

!GRStringPrinter methodsFor:'initialization'!

initialize
	super initialize.
	self character: $ ; length: nil.
	self trimNone; padNone
! !

!GRStringPrinter methodsFor:'padding'!

padCenter
	"Pad to the center."
	
	pad := #pad:center:to:
!

padLeft
	"Pad to the left."
	
	pad := #pad:left:to:
!

padNone
	"Do not pad the input."
	
	pad := nil
!

padRight
	"Pad to the right."
	
	pad := #pad:right:to:
! !

!GRStringPrinter methodsFor:'printing'!

print: anObject on: aStream 
	| string |
	string := anObject greaseString.
	trim isNil
		ifFalse: [ string := string perform: trim ].
	length isNil ifFalse: [
		length < string size 
			ifTrue: [ string := string copyFrom: 1to: length ].
		(pad isNil or: [ character isNil ])
			ifFalse: [ string := self perform: pad with: string with: character with: length ] ].
	aStream nextPutAll: string
! !

!GRStringPrinter methodsFor:'trimming'!

trimBoth
	"Trim to the left and to the right."

	trim := #trimBoth
!

trimLeft
	"Trim to the left and to the right."

	trim := #trimLeft
!

trimNone
	"Do not trim the input."

	trim := nil
!

trimRight
	"Trim to the left and to the right."

	trim := #trimRight
! !

!GRStringPrinter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRStringPrinter.st,v 1.1 2011/09/05 17:46:36 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRStringPrinter.st,v 1.1 2011/09/05 17:46:36 cg Exp $'
! !
