"{ Package: 'stx:goodies/seaside30/grease' }"

GRPrinter subclass:#GRUnitPrinter
	instanceVariableNames:'integerPrinter fractionPrinter units base'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Core-Text'
!

GRUnitPrinter comment:''
!


!GRUnitPrinter class methodsFor:'instance creation'!

base: anInteger units: anArray
	^ self new 
		base: anInteger;
		units: anArray;
		yourself
! !

!GRUnitPrinter methodsFor:'accessing'!

base: anInteger
	base := anInteger
!

fractionPrinter: aPrinter
	fractionPrinter := aPrinter
!

integerPrinter: aPrinter
	integerPrinter := aPrinter
!

units: anArray
	units := anArray
! !

!GRUnitPrinter methodsFor:'initialization'!

initialize
	super initialize.
	self integerPrinter: (GRNumberPrinter new
		precision: 0;
		yourself).
	self fractionPrinter: (GRNumberPrinter new
		precision: 1;
		yourself)
! !

!GRUnitPrinter methodsFor:'printing'!

print: anObject on: aStream
	anObject = 1
		ifTrue: [ ^ self print: anObject unit: units first on: aStream ].
	units allButFirst
		inject: anObject asFloat
		into: [ :value :each |
			value < base
				ifFalse: [ value / base ]
				ifTrue: [ ^ self print: value unit: each on: aStream ] ]
!

print: aNumber unit: aString on: aStream
	(units first = aString or: [ units second = aString ])
		ifTrue: [ integerPrinter print: aNumber on: aStream ]
		ifFalse: [ fractionPrinter print: aNumber on: aStream ].
	aStream nextPut: $ ; nextPutAll: aString
! !

!GRUnitPrinter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRUnitPrinter.st,v 1.1 2011/09/05 17:51:31 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRUnitPrinter.st,v 1.1 2011/09/05 17:51:31 cg Exp $'
! !
