"{ Package: 'stx:goodies/seaside30/grease' }"

GRObject subclass:#GRVersion
	instanceVariableNames:'major minor revision stageLabel stageNumber'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Core'
!

GRVersion comment:''
!


!GRVersion class methodsFor:'instance creation'!

major: majorInteger
	^ self major: majorInteger minor: nil
!

major: majorInteger minor: minorInteger
	^ self major: majorInteger minor: minorInteger revision: nil
!

major: majorInteger minor: minorInteger revision: revisionInteger
	^ self basicNew
		initializeWithMajor: majorInteger minor: minorInteger revision: revisionInteger;
		yourself
!

new
	^ self major: 1
! !

!GRVersion methodsFor:'accessing'!

major
	^ major
!

major: anInteger
	major := anInteger
!

minor
	^ minor
!

minor: anInteger
	minor := anInteger
!

revision
	^ revision
!

revision: anInteger
	revision := anInteger
!

stage
	^ stageLabel
!

stage: aSymbol number: anInteger
	stageLabel := aSymbol.
	stageNumber := anInteger
!

stageNumber
	^ stageNumber
! !

!GRVersion methodsFor:'comparing'!

< otherVersion
	(major < otherVersion major) ifTrue: [ ^ true ].
	(otherVersion major < major) ifTrue: [ ^ false ].
	((minor ifNil: [ 0 ]) < (otherVersion minor ifNil: [ 0 ])) ifTrue: [ ^ true ].
	((otherVersion minor ifNil: [ 0 ]) < (minor ifNil: [ 0 ])) ifTrue: [ ^ false ].
	((revision ifNil: [ 0 ]) < (otherVersion revision ifNil: [ 0 ])) ifTrue: [ ^ true ].
	((otherVersion revision ifNil: [ 0 ]) < (revision ifNil: [ 0 ])) ifTrue: [ ^ false ].
	(stageLabel = otherVersion stage) ifTrue: [
		^ ((stageNumber ifNil: [ 1 ]) < (otherVersion stageNumber ifNil: [ 1 ])) ].
	stageLabel isNil ifTrue: [ ^ false ].
	otherVersion stage isNil ifTrue: [ ^ true ].
	^ stageLabel < otherVersion stage
	
	
!

<= otherVersion
	^ (self > otherVersion) not
!

= otherVersion
	^ (major = otherVersion major) and: [
		((minor ifNil: [ 0 ]) = (otherVersion minor ifNil: [ 0 ])) and: [
		((revision ifNil: [ 0 ] ) = (otherVersion revision ifNil: [ 0 ])) and: [
		(stageLabel = otherVersion stage) and: [
		(stageNumber ifNil: [ 1 ]) = (otherVersion stageNumber ifNil: [ 1 ]) ] ] ] ]
!

> otherVersion
	^ otherVersion < self
!

>= otherVersion
	^ (self < otherVersion) not
!

hash
	^ (major hash bitXor: minor hash) bitXor: revision hash
! !

!GRVersion methodsFor:'convenience'!

beAlpha
	self beAlpha: nil
!

beAlpha: anInteger
	self stage: #alpha number: anInteger
!

beBeta
	self beBeta: nil
!

beBeta: anInteger
	self stage: #beta number: anInteger
!

beFinal
	self stage: nil number: nil
!

beReleaseCandidate
	self beReleaseCandidate: nil
!

beReleaseCandidate: anInteger
	self stage: #rc number: anInteger
! !

!GRVersion methodsFor:'converting'!

greaseString
	^ String streamContents: [ :stream |
		stream nextPutAll: major greaseString.
		stream nextPut: $..
		stream nextPutAll: (minor ifNil: [0]) greaseString.
		revision isNil ifFalse: [
			stream nextPut: $..
			stream nextPutAll: revision greaseString ].
		stageLabel isNil ifFalse: [
			stream nextPutAll: stageLabel greaseString.
			stageNumber isNil ifFalse: [ stream nextPutAll: stageNumber greaseString ] ] ]
! !

!GRVersion methodsFor:'initialization'!

initializeWithMajor: majorInteger minor: minorInteger revision: revisionInteger
	self initialize.
	major := majorInteger.
	minor := minorInteger.
	revision := revisionInteger
! !

!GRVersion methodsFor:'testing'!

isAlpha
	^ stageLabel = #alpha
!

isBeta
	^ stageLabel = #beta
!

isFinal
	^ stageLabel isNil
!

isReleaseCandidate
	^ stageLabel = #rc
! !

!GRVersion class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRVersion.st,v 1.1 2011/09/05 09:07:39 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/GRVersion.st,v 1.1 2011/09/05 09:07:39 cg Exp $'
! !
