"{ Package: 'stx:goodies/seaside30/grease/slime' }"

GRSlimeTransformationRule subclass:#GRAnsiCollectionsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Slime'
!

GRAnsiCollectionsRule comment:''
!


!GRAnsiCollectionsRule methodsFor:'accessing'!

group
	^ 'ANSI Compatibility'
!

name
	^ 'Collections'
!

rationale
	^ 'Some collection methods are not ANSI compatible: #pairsDo:, #collect:thenDo:, #reject:thenDo:, #detectSum:, #valuesDo:, #keysSortedSafely, #new:withAll:, etc.'
! !

!GRAnsiCollectionsRule methodsFor:'initialization'!

initialize
	super initialize.
	self rewriteRule
		replace: '``@collection withIndexDo: [ :`each :`index |  | `@temps | ``@.body ]'
			with: '``@collection keysAndValuesDo: [ :`index :`each |  | `@temps | ``@.body ]';
		replace: '``@collection doWithIndex: [ :`each :`index |  | `@temps | ``@.body ]'
			with: '``@collection keysAndValuesDo: [ :`index :`each |  | `@temps | ``@.body ]';
		replace: '``@collection collect: ``@block1 thenDo: ``@block2'
			with: '(``@collection collect: ``@block1) do: ``@block2';
		replace: '``@collection collect: ``@block1 thenSelect: ``@block2'
			with: '(``@collection collect: ``@block1) select: ``@block2';
		replace: '``@collection pairsDo: [ :`t1 :`t2 | ``@.statements ]'
			with: '1 to: ``@collection size by: 2 do:  [ :index | | `t1 `t2 | `t1 := ``@collection at: index. `t2 := ``@collection at: index + 1. ``@.statements ]';
		replace: '``@collection reject: ``@block1 thenDo: ``@block2'
			with: '(``@collection reject: ``@block1) do: ``@block2';
		replace: '``@collection select: ``@block1 thenCollect: ``@block2'
			with: '(``@collection select: ``@block1) collect: ``@block2';
		replace: '``@collection select: ``@block1 thenDo: ``@block2'
			with: '(``@collection select: ``@block1) do: ``@block2';
		replace: '``@collection detectSum: [ :`t1 | ``@.statements. `.last ]'
			with: '``@collection inject: 0 into: [ :sum :`t1 | ``@.statements. sum + (`.last) ]';
		replace: '``@collection valuesDo: ``@block'
			with: '``@collection do: ``@block';
		replace: '``@collection reversed'
			with: '``@collection reverse';	
		replace: '``@dictionary keysSortedSafely'
			with: '``@dictionary keys asSortedCollection';
		replace: '``@collectionClass new: ``@size withAll: ``@character'
			with: '(``@collectionClass new: ``@size) atAllPut: ``@character'
! !

!GRAnsiCollectionsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRAnsiCollectionsRule.st,v 1.1 2011/09/05 18:11:06 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRAnsiCollectionsRule.st,v 1.1 2011/09/05 18:11:06 cg Exp $'
! !
