"{ Package: 'stx:goodies/seaside30/grease/slime' }"

GRSlimeTransformationRule subclass:#GRAnsiStringsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Slime'
!

GRAnsiStringsRule comment:''
!


!GRAnsiStringsRule methodsFor:'accessing'!

group
	^ 'ANSI Compatibility'
!

name
	^ 'Strings'
!

rationale
	^ '#cr, #crlf, #lf, #space, #tab, #findTokens:, ... are not part of the ANSI string protocol.'
! !

!GRAnsiStringsRule methodsFor:'initialization'!

initialize
	super initialize.
	self rewriteRule
		replace: 'String tab' with: '(String with: Character tab)';
		replace: 'String cr' with: '(String with: Character cr)';
		replace: 'String lf' with: '(String with: Character lf)';
		replace: 'String crlf' with: '(String with: Character cr with: Character lf)';
		replace: 'String space' with: '(String with: Character space)';
		replace: '``@string findTokens: ``@arg' withValueFrom: [ :node |
			| argument |
			argument := node arguments first.
			argument isLiteral ifTrue: [ 
				argument value isArray
					ifTrue: [ argument replaceWith: (RBLiteralNode value: (String withAll: argument value)) ].
				argument value isCharacter
					ifTrue: [ argument replaceWith: (RBLiteralNode value: (String with: argument value)) ] ].
			node
				selector: #subStrings:;
				yourself ]
! !

!GRAnsiStringsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRAnsiStringsRule.st,v 1.1 2011/09/05 18:21:25 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRAnsiStringsRule.st,v 1.1 2011/09/05 18:21:25 cg Exp $'
! !
