"{ Package: 'stx:goodies/seaside30/grease/slime' }"

GRSlimeBlockLintRule subclass:#GRBasicNewInitializeMissingRule
	instanceVariableNames:'matcher'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Slime'
!

GRBasicNewInitializeMissingRule comment:''
!


!GRBasicNewInitializeMissingRule methodsFor:'accessing'!

group
	^ 'Grease Portability'
!

name
	^ '#basicNew initialize is missing'
!

rationale
	^ '#initialize is not called implicitely when sending #new to an object in other Smalltalk dialects. Consider subclassing GRObject.'
! !

!GRBasicNewInitializeMissingRule methodsFor:'initialization'!

initialize
        super initialize.
        matcher := (RBParseTreeSearcher ? ParseTreeSearcher) new.
        matcher 
                matches: 'self basicNew initialize'
                do: [ :node :answer | true ]

    "Modified: / 05-09-2011 / 23:10:56 / cg"
! !

!GRBasicNewInitializeMissingRule methodsFor:'running'!

checkClass: aContext 
	(aContext selectedClass isMeta not and: 
		[ (aContext selectedClass includesSelector: #initialize) and: 
			[ (aContext selectedClass includesBehavior: GRObject) not and: 
				[ (aContext selectedClass includesBehavior: GRNotification) not and: 
					[ (aContext selectedClass includesBehavior: GRError) not and: 
						[ aContext selectedClass class methodDictionary noneSatisfy: 
							[ :each | 
							matcher 
								executeTree: each parseTree
								initialAnswer: false ] ] ] ] ] ]) ifTrue: 
		[ result 
			addClass: aContext selectedClass
			selector: #initialize ]
! !

!GRBasicNewInitializeMissingRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRBasicNewInitializeMissingRule.st,v 1.2 2011/09/05 21:16:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRBasicNewInitializeMissingRule.st,v 1.2 2011/09/05 21:16:43 cg Exp $'
! !
