"{ Package: 'stx:goodies/seaside30/grease/slime' }"

GRSlimeBlockLintRule subclass:#GRDeprecatedApiProtocolRule
	instanceVariableNames:'matcher'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Slime'
!

GRDeprecatedApiProtocolRule comment:''
!


!GRDeprecatedApiProtocolRule methodsFor:'accessing'!

group
	^ 'Grease Formatting'
!

name
	^ 'Invalid use of deprecated API protocol.'
!

rationale
	^ 'Make sure to follow the following pattern: self greaseDeprecatedApi: ''Class>>#selector'' details: ''Some description''.'
! !

!GRDeprecatedApiProtocolRule methodsFor:'initialization'!

initialize
        super initialize.
        matcher := (RBParseTreeSearcher ? ParseTreeSearcher) new.
        matcher 
                matchesAnyOf: #(
                        '``@receiver greaseDeprecatedApi: ``@arg1'
                        '``@receiver greaseDeprecatedApi: ``@arg1 details: ``@arg2' )
                do: [ :node :answer | answer add: node; yourself ]

    "Modified: / 05-09-2011 / 23:10:39 / cg"
! !

!GRDeprecatedApiProtocolRule methodsFor:'running'!

checkMethod: aContext
	| matches |
	matches := matcher
		executeTree: aContext parseTree
		initialAnswer: OrderedCollection new.
	matches do: [ :node |
		" This ensures that the description is of the form ClassName>>#selector:"
		(node arguments first isLiteral and: [ node arguments first value isString and: [ aContext selectedClass name greaseString , '>>#' , aContext selector greaseString ~= node arguments first value ] ]) ifTrue: [
			result addClass: aContext selectedClass selector: aContext selector.
			result addSearchString: node arguments first value ].
		" This ensures that the description is a string and ends with a dot."
		(node arguments size > 1 and: [ node arguments second isLiteral and: [ node arguments second value isString and: [ (node arguments second value endsWithSubCollection: '.') not ] ] ]) ifTrue: [
			result addClass: aContext selectedClass selector: aContext selector.
			result addSearchString: node arguments second value ] ]
! !

!GRDeprecatedApiProtocolRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRDeprecatedApiProtocolRule.st,v 1.3 2011/09/05 21:16:27 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRDeprecatedApiProtocolRule.st,v 1.3 2011/09/05 21:16:27 cg Exp $'
! !
