"{ Package: 'stx:goodies/seaside30/grease/slime' }"

GRSlimeBlockLintRule subclass:#GREmptyStatementsRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Slime'
!

GREmptyStatementsRule comment:''
!


!GREmptyStatementsRule methodsFor:'accessing'!

group
	^ 'Grease Portability'
!

name
	^ 'Empty Statements'
!

rationale
	^ 'Empty statements are not supported by most Smalltalk implementations.'
! !

!GREmptyStatementsRule methodsFor:'running'!

checkMethod: aContext 
	| periods position |
	aContext parseTree nodesDo: [ :node |
		node isSequence ifTrue: [
			periods := OrderedCollection withAll: node periods.
			1 to: node statements size - 1 do: [ :index |
				position := periods removeFirst.
				((node statements at: index) stop < position and: [ position < (node statements at: index + 1) start ])
					ifFalse: [ ^ result addClass: aContext selectedClass selector: aContext selector ] ].
			(periods isEmpty or: [ periods size = 1 and: [ node statements notEmpty and: [ node statements last stop < periods first ] ] ])
				ifFalse: [ ^ result addClass: aContext selectedClass selector: aContext selector ] ] ]
!

resetResult
	super resetResult.
	result addSearchString: '..'; addSearchString: '.'
! !

!GREmptyStatementsRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GREmptyStatementsRule.st,v 1.1 2011/09/05 18:14:24 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GREmptyStatementsRule.st,v 1.1 2011/09/05 18:14:24 cg Exp $'
! !
