"{ Package: 'stx:goodies/seaside30/grease/slime' }"

GRSlimeBlockLintRule subclass:#GRInvalidObjectInitializationRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Slime'
!

GRInvalidObjectInitializationRule comment:''
!


!GRInvalidObjectInitializationRule methodsFor:'accessing'!

group
	^ 'Grease Portability'
!

name
	^ 'Invalid object initialization'
!

rationale
	^ 'Initialize methods are required to call the designated initializer or its super implementation.'
! !

!GRInvalidObjectInitializationRule methodsFor:'running'!

checkMethod: aContext 
	(aContext selectedClass isMeta not 
		and: [ (aContext selector beginsWithSubCollection: #initialize) 
		and: [ aContext selector numArgs > 0
		and: [ aContext selectedClass ~= GRObject
		and: [ (aContext selectedClass includesBehavior: GRObject)
		and: [ (aContext superMessages includes: aContext selector) not 
		and: [ aContext selfMessages noneSatisfy: [ :each | each beginsWithSubCollection: #initialize ] ] ] ] ] ] ]) 
			ifTrue: [ result addClass: aContext selectedClass selector: aContext selector ]
! !

!GRInvalidObjectInitializationRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRInvalidObjectInitializationRule.st,v 1.1 2011/09/05 18:08:36 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRInvalidObjectInitializationRule.st,v 1.1 2011/09/05 18:08:36 cg Exp $'
! !
