"{ Package: 'stx:goodies/seaside30/grease/slime' }"

GRSlimeBlockLintRule subclass:#GRNonPortableSourceFormatRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Slime'
!

GRNonPortableSourceFormatRule comment:''
!


!GRNonPortableSourceFormatRule methodsFor:'accessing'!

group
	^ 'Grease Portability'
!

name
	^ 'Non portable source format'
!

rationale
	^ 'The method source is required to be a plain string, for portability reasons a wide-string is not supported.'
! !

!GRNonPortableSourceFormatRule methodsFor:'running'!

checkClass: aContext 
	| comment |
	aContext selectedClass isMeta 
		ifTrue: [ ^ self ].
	comment := aContext selectedClass organization classComment asString.
	comment isWideString ifTrue: [
		result addClass: aContext selectedClass ]
!

checkMethod: aContext
	| foundLiteral |
	foundLiteral := false.
	"check individual literals first"
	aContext compiledMethod literals do: [ :each | 
		(each isString and: [ each isWideString ]) ifTrue: [
			result 
				addClass: aContext selectedClass
				selector: aContext selector.
			result addSearchString:  each.
			foundLiteral := true ] ].
	
	"now check the whole method, could be in comments"
	foundLiteral ifFalse: [
		aContext sourceCode asString isWideString ifTrue: [
			result addClass: aContext selectedClass selector: aContext selector ] ]
! !

!GRNonPortableSourceFormatRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRNonPortableSourceFormatRule.st,v 1.2 2011/09/05 18:58:27 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRNonPortableSourceFormatRule.st,v 1.2 2011/09/05 18:58:27 cg Exp $'
! !
