"{ Package: 'stx:goodies/seaside30/grease/slime' }"

GRSlimeBlockLintRule subclass:#GRUsesNotPortableClassRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Slime'
!

GRUsesNotPortableClassRule comment:''
!


!GRUsesNotPortableClassRule methodsFor:'accessing'!

group
	^ 'Grease Portability'
!

name
	^ 'Uses not portable class'
!

rationale
	^ 'Some classes are not portable accross different Smalltalk dialects.'
! !

!GRUsesNotPortableClassRule methodsFor:'private'!

classNames
	^ #( Delay MIMEDocument Monitor Mutex MutexSet Random Semaphore TimeStamp Timestamp MessageSend )
! !

!GRUsesNotPortableClassRule methodsFor:'running'!

checkClass: aContext 
	aContext selectedClass allSuperclassesDo: [ :each |
		(self classNames includes: each name) ifTrue: [
			result addClass: aContext selectedClass.
			result addSearchString: each name ] ]
!

checkMethod: aContext 
	aContext compiledMethod literals do: [ :each | 
		((each isKindOf: Association) and: [ self classNames includes: each key ]) ifTrue: [
			result 
				addClass: aContext selectedClass
				selector: aContext selector.
			result addSearchString: each key ] ]
! !

!GRUsesNotPortableClassRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRUsesNotPortableClassRule.st,v 1.1 2011/09/05 18:41:37 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/GRUsesNotPortableClassRule.st,v 1.1 2011/09/05 18:41:37 cg Exp $'
! !
