"{ Package: 'stx:goodies/seaside30/grease/slime/tests' }"

GRCollectionTest subclass:#GRAbstractDictionaryTest
	instanceVariableNames:'associations'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Tests-Core'
!


!GRAbstractDictionaryTest class methodsFor:'testing'!

isAbstract
	^ self name = #GRAbstractDictionaryTest
! !

!GRAbstractDictionaryTest methodsFor:'configuration'!

allowsDuplicateValues
	^ true
!

arbitraryAssociations
	^ associations ifNil: [ associations := self createArbitraryAssociations ]
!

arbitraryCollection
	| dict |
	dict := self emptyCollection.
	self arbitraryAssociations do: [ :each |
		dict at: each key put: each value ].
	^ dict
!

createArbitraryAssociations
	self subclassResponsibility
!

isKey: anObject equivalentTo: anotherObject
	self subclassResponsibility
! !

!GRAbstractDictionaryTest methodsFor:'private'!

valuesOf: aCollection
	^ aCollection values
! !

!GRAbstractDictionaryTest methodsFor:'testing-ansi'!

isExtensible
	^ false
!

isInitializable
	^ false
! !

!GRAbstractDictionaryTest methodsFor:'tests'!

testAssociationsDo
	| collection assocs count |
	collection := self arbitraryCollection.
	assocs := self arbitraryAssociations copy.
	count := 0.
	collection associationsDo: [ :assoc |
		| size |
		count := count + 1.
		size := assocs size.
		assocs := assocs
			reject: [ :each |
				(self isKey: each key equivalentTo: assoc key)
					and: [ each value = assoc value ] ].
		self assert: size - 1 = assocs size ].
	self assert: assocs isEmpty.
	self assert: count = self arbitraryAssociations size
! !

!GRAbstractDictionaryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/tests/GRAbstractDictionaryTest.st,v 1.3 2011/09/06 06:18:24 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/tests/GRAbstractDictionaryTest.st,v 1.3 2011/09/06 06:18:24 cg Exp $'
! !
