"{ Package: 'stx:goodies/seaside30/grease/slime/tests' }"

TestCase subclass:#GRNullCodecStreamTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Tests-Core'
!


!GRNullCodecStreamTest methodsFor:'accessing'!

codecStreamClass
	^ GRNullCodecStream
! !

!GRNullCodecStreamTest methodsFor:'private'!

seasideByteArray
	^ #(83 101 97 115 105 100 101) "Seaside" asByteArray
! !

!GRNullCodecStreamTest methodsFor:'tests'!

testReadString
	| stream codecStream |
	stream := 'abc' readStream.
	codecStream := GRNullCodec new decoderFor: stream.
	self assert: codecStream next = $a.
	self assert: (codecStream next: 2) = 'bc'
!

testWriteString
	| stream codecStream |
	stream := WriteStream on: String new.
	codecStream := GRNullCodec new encoderFor: stream.
	codecStream
		nextPut: $A;
		nextPutAll: 'BC';
		nextPut: 68;
		nextPutAll: #(69 70 ) asByteArray.
	self assert: codecStream contents = 'ABCDEF'
! !

!GRNullCodecStreamTest methodsFor:'tests-characters'!

testCrlf
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream crlf.
	
	self assert: stream contents size = 2.
	self assert: stream contents first = Character cr.
	self assert: stream contents last = Character lf
!

testName
	| codec |
	codec := GRNullCodec new.
	
	self assert: codec name = GRNullCodec codecName
!

testSpace
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream space.
	
	self assert: stream contents size = 1.
	self assert: stream contents first = Character space
!

testTab
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream tab.
	
	self assert: stream contents size = 1.
	self assert: stream contents first = Character tab
! !

!GRNullCodecStreamTest methodsFor:'tests-protocol'!

testFlush
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream nextPutAll: 'abc'.
	self shouldnt: [ stream flush ] raise: Error.
	self assert: stream contents = 'abc'
!

testNext
	| stream |
	stream := GRNullCodec new
		encoderFor: 'Seaside' readStream.
	self assert: stream next = $S.
	self assert: (stream next: 1) = 'e'
!

testSize
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream nextPutAll: 'abc'.
	self assert: stream size = 3.
	stream nextPut: $d.
	self assert: stream size = 4
! !

!GRNullCodecStreamTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/tests/GRNullCodecStreamTest.st,v 1.3 2011/09/06 06:19:02 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/tests/GRNullCodecStreamTest.st,v 1.3 2011/09/06 06:19:02 cg Exp $'
! !
