"{ Package: 'stx:goodies/seaside30/grease/slime/tests' }"

TestCase subclass:#GRPackageTest
	instanceVariableNames:'package'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-Tests-Core'
!


!GRPackageTest methodsFor:'running'!

setUp
	super setUp.
	package := GRPackage new
! !

!GRPackageTest methodsFor:'tests'!

testDescription
	self assert: package description isNil.
	package description: 'A hopeless pacakge'.
	self assert: package description = 'A hopeless pacakge'
!

testLicense
	self assert: package license = #MIT.
	self assert: package isMIT.
	
	package license: #LGPL.
	self assert: package license = #LGPL.
	self assert: package isLGPL
!

testName
	self assert: package name isNil.
	package name: 'Gimme-Hope'.
	self assert: package name = 'Gimme-Hope'
!

testUrl
	self assert: package url isNil.
	
	package url: #seasideLGPLUrl.
	self assert: package url = GRPackage new seasideLGPLUrl. 
	
	package url: 'http://www.seaside.st/distributions'.
	self assert: package url = 'http://www.seaside.st/distributions'
! !

!GRPackageTest methodsFor:'tests-dependencies'!

testAllDependencies
	| packages |
	packages := Dictionary new.
	packages 
		at: 'Lust' put: (GRPackage new
			name: 'Lust';
			addDependency: 'Gluttony';
			addDependency: 'Greed';
			yourself);
		at: 'Gluttony' put: (GRPackage new
			name: 'Gluttony';
			addDependency: 'Greed';
			yourself);
		at: 'Greed' put: (GRPackage new
			name: 'Greed';
			yourself).
	packages values 
		do: [ :each | each resolveWith: packages ].
	
	self assert: (packages at: 'Lust') allDependencies size = 3.
	self assert: (packages at: 'Gluttony') allDependencies size = 2.
	self assert: (packages at: 'Greed') allDependencies size = 1.
!

testDependencies
	self assert: package dependencies isEmpty.
	package addDependency: 'Lust'.
	package addDependency: 'Envy'.
	self assert: package dependencies size = 2.
	self assert: package dependencies first = 'Lust'.
	self assert: package dependencies last = 'Envy'
	
! !

!GRPackageTest methodsFor:'tests-packages'!

testPackages
	| packages |
	packages := GRPackage packages.
	self assert: packages notEmpty.
	packages do: [ :each | 
		self assert: each name notEmpty.
		self assert: each license notNil.
		self assert: each url notNil ]
! !

!GRPackageTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/tests/GRPackageTest.st,v 1.3 2011/09/06 06:18:29 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/slime/tests/GRPackageTest.st,v 1.3 2011/09/06 06:18:29 cg Exp $'
! !
