"{ Package: 'stx:goodies/seaside30/grease/stx' }"

GRCodecStream subclass:#GRSTXConverterCodecStream
	instanceVariableNames:'converter'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-STX-Core'
!


!GRSTXConverterCodecStream class methodsFor:'instance creation'!

on: aStream converter: aConverter
	^ self basicNew initializeOn: aStream converter: aConverter
! !

!GRSTXConverterCodecStream methodsFor:'accessing'!

contents
	^ stream contents
!

size
	^ stream size
! !

!GRSTXConverterCodecStream methodsFor:'actions'!

flush
	stream flush
! !

!GRSTXConverterCodecStream methodsFor:'initialization'!

initializeOn: aStream converter: aConverter
	self initializeOn: aStream.
	converter := aConverter
! !

!GRSTXConverterCodecStream methodsFor:'streaming'!

greaseNext: anInteger putAll: aCollection startingAt: startIndex
	self nextPutAll: (aCollection copyFrom: startIndex to: startIndex + anInteger - 1)
!

next
	| character |
	character := converter nextFromStream: stream.
	^ character isNil
		ifFalse: [ character asCharacter ]
!

next: anInteger
	| writeStream |
	writeStream := WriteStream on: (String new: anInteger).
	anInteger timesRepeat: [
		writeStream nextPut: (self next
			ifNil: [ ^ writeStream contents ]) ].
	^ writeStream contents
!

nextPut: aCharacter
	converter nextPut: aCharacter asCharacter toStream: stream
!

nextPutAll: aString
	aString asString do: [ :each | self nextPut: each ]
! !

!GRSTXConverterCodecStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXConverterCodecStream.st,v 1.1 2011/09/05 19:02:04 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXConverterCodecStream.st,v 1.1 2011/09/05 19:02:04 cg Exp $'
! !
