"{ Package: 'stx:goodies/seaside30/grease/stx' }"

GRCodec subclass:#GRSTXGenericCodec
	instanceVariableNames:'name urlCodec'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-STX-Core'
!


!GRSTXGenericCodec class methodsFor:'accessing'!

codecs
	^ (TextConverter allEncodingNames
		select:  [ :each | 
			"exclude UFT-8 which is handeled by WAUtf8Codec"
			self supportsEncoding: each ])
		collect: [ :each |
			self basicForEncoding: each greaseString ]
! !

!GRSTXGenericCodec class methodsFor:'private'!

basicForEncoding: aString
	(self supportsEncoding: aString)
		ifFalse: [ self unsupportedEncoding: aString ].
	^ self basicNew initializeWithName: aString
!

supportedEncodingNames
	"answers the names of the encodings supported by this class"

	^ TextConverter allEncodingNames
		removeAllFoundIn: GRPharoLatin1Codec supportedEncodingNames;
		removeAllFoundIn: UTF8TextConverter encodingNames;
		yourself
! !

!GRSTXGenericCodec class methodsFor:'testing'!

supportsEncoding: aString
	"Answer whether the the given encoding name is supported."
	^ self supportedEncodingNames includes: aString
! !

!GRSTXGenericCodec methodsFor:'accessing'!

name
	^ name
!

url
	"RFC 3986: When a new URI scheme defines a component that represents textual data consisting of characters from the Universal Character Set [UCS], the data should first be encoded as octets according to the UTF-8 character encoding."

	^ urlCodec
! !

!GRSTXGenericCodec methodsFor:'conversion'!

decoderFor: aStream
	^ self encoderFor: aStream
!

encoderFor: aStream 
	^ GRPharoConverterCodecStream 
		on: aStream
		converter: self converter
! !

!GRSTXGenericCodec methodsFor:'initialization'!

initializeWithName: aString 
	self initialize.
	name := aString.
	urlCodec := (#('iso-8859-15' 'cp-1252') includes: aString) 
		ifFalse: [ GRCodec forEncoding: 'utf-8' ]
		ifTrue: [ self ]
! !

!GRSTXGenericCodec methodsFor:'private'!

converter
	^ TextConverter newForEncoding: self name
! !

!GRSTXGenericCodec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXGenericCodec.st,v 1.1 2011/09/05 19:03:15 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXGenericCodec.st,v 1.1 2011/09/05 19:03:15 cg Exp $'
! !
