"{ Package: 'stx:goodies/seaside30/grease/stx' }"

GRNullCodec subclass:#GRSTXLatin1Codec
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-STX-Core'
!


!GRSTXLatin1Codec class methodsFor:'accessing'!

codecs
	^ Array with: (self basicForEncoding: 'iso-8859-1')
! !

!GRSTXLatin1Codec class methodsFor:'private'!

basicForEncoding: aString
	(self supportsEncoding: aString)
		ifFalse: [ self unsupportedEncoding: aString ].
	^ self basicNew initializeWithName: aString
!

supportedEncodingNames
	^ #('iso-8859-1' 'ISO-8859-1' 'latin-1' 'latin1')
!

supportsEncoding: aString
	"Answer whether the the given encoding name is supported."
	^ self supportedEncodingNames includes: aString
! !

!GRSTXLatin1Codec methodsFor:'accessing'!

name
	^ name
! !

!GRSTXLatin1Codec methodsFor:'conversion'!

decode: aStringOrByteArray
	"Overridden for efficencey."

	^ aStringOrByteArray asString
!

decoderFor: aReadStream 
	"wrap to avoid String vs ByteArray issues"
	^ GRPharoLatin1CodecStream on: aReadStream
!

encoderFor: aWriteStream 
	"wrap to avoid String vs ByteArray issues"
	^ GRPharoLatin1CodecStream on: aWriteStream
! !

!GRSTXLatin1Codec methodsFor:'initialization'!

initializeWithName: aString 
	self initialize.
	name := aString.
! !

!GRSTXLatin1Codec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXLatin1Codec.st,v 1.1 2011/09/05 19:01:20 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXLatin1Codec.st,v 1.1 2011/09/05 19:01:20 cg Exp $'
! !
