"{ Package: 'stx:goodies/seaside30/grease/stx' }"

GRObject subclass:#GRSTXRandomProvider
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-STX-Core'
!

GRSTXRandomProvider class instanceVariableNames:'mutex generator'

"
 No other class instance variables are inherited by this class.
"
!


!GRSTXRandomProvider class methodsFor:'class initialization'!

startUp
	generator := self randomClass new.
	mutex := Semaphore forMutualExclusion
! !

!GRSTXRandomProvider class methodsFor:'private'!

initialize
	Smalltalk addToStartUpList: self.
	self startUp
!

randomClass
	^ Random
!

unload
	GRPlatform current removeFromStartUpList: self
! !

!GRSTXRandomProvider class methodsFor:'public'!

nextInt: anInteger
	"Answer a random integer in the interval [1, anInteger]"

	^ mutex critical: [ generator nextInt: anInteger ]
!

randomFrom: aCollection
	| random count |
	random := self nextInt: aCollection size.
	^ aCollection isSequenceable
		ifTrue: [ aCollection at: random ]
		ifFalse: [
			count := 1.
			aCollection do: [ :ea |
				count = random ifTrue: [ ^ ea ].
				count := count + 1 ] ]
! !

!GRSTXRandomProvider class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXRandomProvider.st,v 1.1 2011/09/05 19:01:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXRandomProvider.st,v 1.1 2011/09/05 19:01:43 cg Exp $'
! !

GRSTXRandomProvider initialize!
