"{ Package: 'stx:goodies/seaside30/grease/stx' }"

GRCodec subclass:#GRSTXUtf8Codec
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Grease-STX-Core'
!


!GRSTXUtf8Codec class methodsFor:'accessing'!

codecs
	^ Array with: self new
! !

!GRSTXUtf8Codec class methodsFor:'private'!

basicForEncoding: aString
	^ self new
! !

!GRSTXUtf8Codec class methodsFor:'testing'!

supportsEncoding: aString
	^ (#('utf-8' 'UTF-8') includes: aString) or: [ UTF8TextConverter encodingNames includes: aString ]
! !

!GRSTXUtf8Codec methodsFor:'accessing'!

name
	^ 'utf-8'
!

url
	^ self
! !

!GRSTXUtf8Codec methodsFor:'conversion'!

decoderFor: aStream 
	^ GRPharoUtf8CodecStream 
		on: aStream
		converter: UTF8TextConverter new
!

encoderFor: aStream 
	^ GRPharoUtf8CodecStream 
		on: aStream
		converter: UTF8TextConverter new
! !

!GRSTXUtf8Codec methodsFor:'decoding'!

decode: aString
	| readStream writeStream |
	readStream := self decoderFor: aString asByteArray readStream.
	writeStream := WriteStream on: (String new: aString size).
	[ readStream atEnd ]
		whileFalse: [ writeStream nextPutAll: (readStream next: 16rFFF) ].
	^ writeStream contents
! !

!GRSTXUtf8Codec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXUtf8Codec.st,v 1.1 2011/09/05 19:04:09 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/GRSTXUtf8Codec.st,v 1.1 2011/09/05 19:04:09 cg Exp $'
! !
