"{ Package: 'stx:goodies/seaside30/grease/stx' }"!

!Block methodsFor:'*grease-stx-core'!

fixCallbackTemps
! !

!ByteArray methodsFor:'*grease-stx-core'!

greaseString
	"ByteArrays should not automatically be converted to Strings. You should use a GRCodec for this."
	^ self printString
! !

!Character methodsFor:'*grease-stx-core'!

greaseInteger
	"Answer an unicode code point of the receiver."
	^ self charCode
! !

!Collection methodsFor:'*grease-stx-core'!

any
	^ self anyOne
! !

!GRCodecStream methodsFor:'*grease-stx-core'!

greaseNext: anInteger putAll: aCollection startingAt: startIndex
	stream greaseNext: anInteger putAll: aCollection startingAt: startIndex
! !

!GRSmallDictionary methodsFor:'*grease-stx-core'!

customizeExplorerContents
	^ true
! !

!GRSmallDictionary methodsFor:'*grease-stx-core'!

explorerContents
	| contents |	
	contents := OrderedCollection new.
	self keysAndValuesDo: [ :key :value |
		contents add: (ObjectExplorerWrapper
			with: value
			name: (key printString contractTo: 32)
			model: self) ].
	^ contents
! !

!GRSmallDictionary methodsFor:'*grease-stx-core'!

hasContentsInExplorer
	^ true
! !

!Interval methodsFor:'*grease-stx-core'!

any
	"#first (used by SequenceableCollection>>anyOne) is an accessor of
	Interval and does not error on an empty Interval."
	
	^ self at: 1
! !

!MessageSend methodsFor:'*grease-stx-core'!

fixCallbackTemps
	"for polymorphism with BlockContext >> #fixCallbackTemps"
! !

!MessageSend methodsFor:'*grease-stx-core'!

valueWithPossibleArguments: anArray
	"Evaluate the block represented by the receiver.
     If the block requires one argument, use anArg, if it requires more than one,
     fill up the rest with nils."

	^ self valueWithEnoughArguments: anArray
! !

!Object methodsFor:'*grease-stx-core'!

greaseString
	^ self asString
! !

!PositionableStream methodsFor:'*grease-stx-core'!

greaseUpToAll: aCollection 
	"Needed for Seaside ports to other dialects where #upToAll: may have
	different semantics"
	^ self upToAll: aCollection
! !

!SequenceableCollection methodsFor:'*grease-stx-core'!

beginsWithSubCollection: aSequenceableCollection
	"Some platforms implement #beginsWith: to answer true for an empty argument."
	^ self beginsWith: aSequenceableCollection
! !

!SequenceableCollection methodsFor:'*grease-stx-core'!

endsWithSubCollection: aSequenceableCollection
	"Some platforms implement #endsWith: to answer true for an empty argument."
	^ self endsWith: aSequenceableCollection
! !

!SequenceableCollection methodsFor:'*grease-stx-core'!

sorted
	^ self sorted: [ :a :b | a <= b ]
! !

!WriteStream methodsFor:'*grease-stx-core'!

greaseNext: anInteger putAll: aCollection startingAt: startIndex
	"Store the next anInteger elements from the given collection."
	^ self next: anInteger putAll: aCollection startingAt: startIndex
! !

!stx_goodies_seaside30_grease_stx class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx/extensions.st,v 1.4 2011/09/06 06:12:56 cg Exp $'
! !