"{ Package: 'stx:goodies/seaside30/grease' }"

LibraryDefinition subclass:#stx_goodies_seaside30_grease
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_seaside30_grease class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:libbasic'    "Error - superclass of GRInvalidUtf8Error "
    )
! !

!stx_goodies_seaside30_grease class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        GRError
        GRNotification
        GRObject
        #'stx_goodies_seaside30_grease'
        GRCodec
        GRCodecStream
        GRDelayedSend
        GRDelayedSendMessage
        GRDeprecatedApiNotification
        GRInflector
        GRInvalidArgumentCount
        GRInvalidUtf8Error
        GRPackage
        GRPlatform
        GRPrinter
        GRSmallDictionary
        GRUnsupportedEncodingError
        GRVersion
        GRBoundMessage
        GRMappedPrinter
        GRNullCodec
        GRNullCodecStream
        GRNumberPrinter
        GROrderedMultiMap
        GROrdinalizePrinter
        GRPluggablePrinter
        GRSequentialPrinter
        GRSignPrinter
        GRStringPrinter
        GRUnboundMessage
        GRUnitPrinter
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Character print:on:
        Integer greaseInteger
        Integer pluralize:
        Integer pluralize:with:
        Object greaseDeprecatedApi:details:
        String excerpt:
        String excerpt:radius:
        String excerpt:radius:ellipsis:
        String greaseInteger
        String pluralize
        String print:on:
        String trimBoth
        String trimBoth:
        String trimLeft
        String trimLeft:
        String trimLeft:right:
        String trimRight
        String trimRight:
        String truncate
        String truncate:
        String truncate:ellipsis:
        UndefinedObject print:on:
    )
! !

!stx_goodies_seaside30_grease class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_seaside30_grease class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx_goodies_seaside30_grease.st,v 1.1 2011/09/05 18:45:52 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/grease/stx_goodies_seaside30_grease.st,v 1.1 2011/09/05 18:45:52 cg Exp $'
! !
