"{ Package: 'stx:goodies/seaside30/javascript' }"

GRObject subclass:#JSJsonStream
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Javascript-Core-JSON'
!

JSJsonStream comment:'I am a specialization of JSStream that conforms to the JSON spec (http://www.json.org).'
!


!JSJsonStream class methodsFor:'encoding'!

encodeCollection: aCollection on: aStream
	"Writes aCollection of elements to aStream enclosed in square brakets."
	
	aStream nextPut: $[.
	aCollection
		do: [ :each | aStream json: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $]
!

encodeDictionary: aDictionary on: aStream 
	"Dictionary or hash-maps common structures in JSON to aStream."
	
	| first |
	first := true.
	aStream nextPut: ${.
	aDictionary keysAndValuesDo: [ :key :value |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aStream nextPut: $, ].
		aStream 
			json: key greaseString;
			nextPut: $:;
			json: value ].
	aStream nextPut: $}
! !

!JSJsonStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/javascript/JSJsonStream.st,v 1.1 2011/09/05 20:59:13 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/seaside30/javascript/JSJsonStream.st,v 1.1 2011/09/05 20:59:13 cg Exp $'
! !
