"{ Package: 'stx:goodies/seaside30/javascript' }"!

!Boolean methodsFor:'*javascript-core'!

jsonOn: aStream
	self javascriptOn: aStream
! !

!Character methodsFor:'*javascript-core'!

javascriptOn: aStream
	(String with: self) javascriptOn: aStream
! !

!Character methodsFor:'*javascript-core'!

jsonOn: aStream
	self javascriptOn: aStream
! !

!Collection methodsFor:'*javascript-core'!

javascriptOn: aStream
	JSStream encodeCollection: self on: aStream
! !

!Collection methodsFor:'*javascript-core'!

jsonOn: aStream 
	JSJsonStream encodeCollection: self on: aStream
! !

!Date methodsFor:'*javascript-core'!

javascriptMonthIndex
	^ self monthIndex - 1
! !

!Date methodsFor:'*javascript-core'!

javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth )
		do: [ :each | aStream javascript: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)
! !

!Dictionary methodsFor:'*javascript-core'!

javascriptOn: aStream
	JSStream encodeDictionary: self on: aStream
! !

!Dictionary methodsFor:'*javascript-core'!

jsonOn: aStream
	JSJsonStream encodeDictionary: self on: aStream
! !

!Float methodsFor:'*javascript-core'!

jsonOn: aStream
	self javascriptOn: aStream
! !

!GRPackage class methodsFor:'*javascript-core'!

javascriptCore
	^ self new
		name: 'Javascript-Core';
		description: 'Javascript integration in Seaside. Provides a basic functionality to generate Javascript from Smalltalk.';
		addDependency: 'Seaside-Core';
		addDependency: 'Seaside-Canvas';
		url: #seasideUrl;
		yourself
! !

!GRSmallDictionary methodsFor:'*javascript-core'!

javascriptOn: aStream
	JSStream encodeDictionary: self on: aStream
! !

!GRSmallDictionary methodsFor:'*javascript-core'!

jsonOn: aStream
	JSJsonStream encodeDictionary: self on: aStream
! !

!Integer methodsFor:'*javascript-core'!

jsonOn: aStream
	self javascriptOn: aStream
! !

!Object methodsFor:'*javascript-core'!

asFunction
	^ self asFunction: #()
! !

!Object methodsFor:'*javascript-core'!

asFunction: aCollection
	^ JSFunction new add: self; arguments: aCollection
! !

!Object methodsFor:'*javascript-core'!

asJavascript
	^ String streamContents: [ :stream | self javascriptOn: stream ]
! !

!Object methodsFor:'*javascript-core'!

asJson
	^ String streamContents: [ :stream | self jsonOn: stream ]
! !

!Object methodsFor:'*javascript-core'!

isJavascript
	^ false
! !

!Object methodsFor:'*javascript-core'!

javascriptOn: aStream
	self printOn: aStream
! !

!Object methodsFor:'*javascript-core'!

jsonOn: aStream
	self error: 'Override #jsonOn: to make the receiver serializeable as JSON'
! !

!Stream methodsFor:'*javascript-core'!

javascript: anObject
	anObject javascriptOn: self
! !

!Stream methodsFor:'*javascript-core'!

json: anObject
	anObject jsonOn: self
! !

!String methodsFor:'*javascript-core'!

asFunction: aCollection
	^ (JSStream on: self) asFunction: aCollection
! !

!String methodsFor:'*javascript-core'!

javascriptOn: aStream
	JSStream encodeString: self on: aStream
! !

!String methodsFor:'*javascript-core'!

jsonOn: aStream
	self javascriptOn: aStream
! !

!Timestamp methodsFor:'*javascript-core'!

javascriptMonthIndex
	^ self monthIndex - 1
! !

!Timestamp methodsFor:'*javascript-core'!

javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth hour minute second )
		do: [ :each | aStream javascript: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)
! !

!UndefinedObject methodsFor:'*javascript-core'!

javascriptOn: aStream
	aStream nextPutAll: 'null'
! !

!UndefinedObject methodsFor:'*javascript-core'!

jsonOn: aStream
	self javascriptOn: aStream
! !

