"{ Package: 'stx:goodies/smaCC/generator' }"

"{ NameSpace: SmaCC }"

BrowserApplicationModel subclass:#SmaCCParserGenerator
	instanceVariableNames:'subcanvasBuilder tabList parserClassNameHolder
		scannerClassNameHolder conflictHolder scannerHolder parserHolder
		testHolder generateDefinitionCommentsHolder
		generateSymbolCommentsHolder generateItemSetCommentsHolder
		allowUnicodeHolder ignoreCaseHolder editAcceptChannel'
	classVariableNames:'ShowPrecedenceConflicts'
	poolDictionaries:''
	category:'SmaCC-UI'
!

!SmaCCParserGenerator class methodsFor:'documentation'!

examples
"
    openSmaCC
        <menuItem: 'SmaCC Parser Generator'
        nameKey: nil
        menu: #(#menuBar #tools)
                position: 30.00>

        SmaCC.SmaCCParserGenerator open
"
! !

!SmaCCParserGenerator class methodsFor:'initialization'!

initialize
    ShowPrecedenceConflicts := false.
! !

!SmaCCParserGenerator class methodsFor:'menu specs'!

mainMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:SmaCC::SmaCCParserGenerator andSelector:#mainMenu
     (Menu new fromLiteralArrayEncoding:(SmaCC::SmaCCParserGenerator mainMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(#Menu
        #(
         #(#MenuItem
            #label: 'File'
            #translateLabel: true
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Exit'
                  #itemValue: #closeRequest
                  #translateLabel: true
                )
               )
              nil
              nil
            )
          )
         #(#MenuItem
            #label: 'Help'
            #translateLabel: true
            #startGroup: #right
            #submenu: 
           #(#Menu
              #(
               #(#MenuItem
                  #label: 'Documentation'
                  #itemValue: #openDocumentation
                  #translateLabel: true
                )
               #(#MenuItem
                  #label: '-'
                )
               #(#MenuItem
                  #label: 'About this Application'
                  #itemValue: #openAboutThisApplication
                  #translateLabel: true
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
! !

!SmaCCParserGenerator class methodsFor:'window specs'!

compileWindowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SmaCC::SmaCCParserGenerator andSelector:#compileWindowSpec
     SmaCC::SmaCCParserGenerator new openInterface:#compileWindowSpec
    "

    <resource: #canvas>

    ^ 
     #(#FullSpec
        #name: #compileWindowSpec
        #window: 
       #(#WindowSpec
          #label: 'Unlabeled Canvas'
          #name: 'Unlabeled Canvas'
          #bounds: #(#Rectangle 16 52 457 357)
        )
        #component: 
       #(#SpecCollection
          #collection: #(
           #(#LabelSpec
              #label: 'Scanner class:'
              #name: #Label2
              #layout: #(#AlignmentOrigin -5 0.4 5 0 1 0)
            )
           #(#InputFieldSpec
              #name: #scannerClassName
              #layout: #(#LayoutFrame 6 0.4 5 0 -36 1 27 0)
              #model: #scannerClassNameHolder
              #type: #string
              #acceptOnLeave: true
              #acceptOnLostFocus: true
              #acceptOnPointerLeave: true
            )
           #(#ActionButtonSpec
              #label: '...'
              #name: #findScannerClassButton
              #layout: #(#LayoutFrame -32 1 5 0 -10 1 27 0)
              #model: #findScannerClass
              #defaultable: true
            )
           #(#LabelSpec
              #label: 'Parser class:'
              #name: #Label3
              #layout: #(#AlignmentOrigin -5 0.4 32 0 1 0)
            )
           #(#InputFieldSpec
              #name: #parserClassName
              #layout: #(#LayoutFrame 6 0.4 32 0 -36 1 54 0)
              #model: #parserClassNameHolder
              #type: #string
              #acceptOnLeave: true
              #acceptOnLostFocus: true
              #acceptOnPointerLeave: true
            )
           #(#ActionButtonSpec
              #label: '...'
              #name: #findParserClassButton
              #layout: #(#LayoutFrame -32 1 32 0 -10 1 54 0)
              #model: #findParserClass
              #defaultable: true
            )
           #(#HorizontalPanelViewSpec
              #name: 'HorizontalPanel1'
              #layout: #(#LayoutFrame 0 0.0 120 0 0 1.0 146 0)
              #horizontalLayout: #spreadSpaceMax
              #verticalLayout: #center
              #horizontalSpace: 3
              #verticalSpace: 3
              #component: 
             #(#SpecCollection
                #collection: #(
                 #(#ActionButtonSpec
                    #label: 'Compile LALR(1)'
                    #name: #compileLALR1
                    #model: #compileLALR1
                    #extent: #(#Point 100 22)
                  )
                 #(#ActionButtonSpec
                    #label: 'Compile LR(1)'
                    #name: #compileLR1
                    #model: #compileLR1
                    #extent: #(#Point 100 22)
                  )
                 )
               
              )
            )
           #(#DividerSpec
              #name: #Divider1
              #layout: #(#LayoutFrame 5 0 150 0 -5 1 152 0)
            )
           #(#LabelSpec
              #label: 'Messages:'
              #name: #Label4
              #layout: #(#Point 10 155)
            )
           #(#TextEditorSpec
              #name: #conflicts
              #layout: #(#LayoutFrame 10 0 177 0 -10 1 -10 1)
              #model: #conflictHolder
              #hasHorizontalScrollBar: true
              #hasVerticalScrollBar: true
              #miniScrollerHorizontal: true
              #tabRequiresControl: true
            )
           #(#CheckBoxSpec
              #label: 'Generate definition comments'
              #name: #generateDefinitionComments
              #layout: #(#LayoutFrame 5 0.5 60 0 205 0.5 80 0)
              #model: #generateDefinitionCommentsHolder
            )
           #(#CheckBoxSpec
              #label: 'Generate symbol comments'
              #name: #generateSymbolComments
              #layout: #(#LayoutFrame 5 0.5 80 0 205 0.5 100 0)
              #model: #generateSymbolCommentsHolder
            )
           #(#CheckBoxSpec
              #label: 'Generate item set comments'
              #name: #generateItemSetComments
              #layout: #(#LayoutFrame 5 0.5 100 0 205 0.5 120 0)
              #model: #generateItemSetCommentsHolder
            )
           #(#CheckBoxSpec
              #label: 'Allow Unicode Characters'
              #name: #allowUnicode
              #layout: #(#LayoutFrame -205 0.5 80 0 -5 0.5 100 0)
              #model: #allowUnicodeHolder
            )
           #(#CheckBoxSpec
              #label: 'Ignore Case'
              #name: #ignoreCase
              #layout: #(#LayoutFrame -205 0.5 60 0 -5 0.5 80 0)
              #model: #ignoreCaseHolder
            )
           )
         
        )
      )
!

parserWindowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SmaCC::SmaCCParserGenerator andSelector:#parserWindowSpec
     SmaCC::SmaCCParserGenerator new openInterface:#parserWindowSpec
    "

    <resource: #canvas>

    ^ 
     #(#FullSpec
        #name: #parserWindowSpec
        #window: 
       #(#WindowSpec
          #label: 'Unlabeled Canvas'
          #name: 'Unlabeled Canvas'
          #bounds: #(#Rectangle 16 52 216 252)
        )
        #component: 
       #(#SpecCollection
          #collection: #(
           #(#TextEditorSpec
              #name: #text
              #layout: #(#LayoutFrame 2 0 2 0 -2 1 -2 1)
              #model: #parserHolder
              #hasHorizontalScrollBar: true
              #hasVerticalScrollBar: true
              #miniScrollerHorizontal: true
              #acceptChannel: #editAcceptChannel
              #tabRequiresControl: true
            )
           )
         
        )
      )
!

scannerWindowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SmaCC::SmaCCParserGenerator andSelector:#scannerWindowSpec
     SmaCC::SmaCCParserGenerator new openInterface:#scannerWindowSpec
    "

    <resource: #canvas>

    ^ 
     #(#FullSpec
        #name: #scannerWindowSpec
        #window: 
       #(#WindowSpec
          #label: 'Unlabeled Canvas'
          #name: 'Unlabeled Canvas'
          #bounds: #(#Rectangle 16 52 216 252)
        )
        #component: 
       #(#SpecCollection
          #collection: #(
           #(#TextEditorSpec
              #name: #text
              #layout: #(#LayoutFrame 2 0 2 0 -2 1 -2 1)
              #model: #scannerHolder
              #hasHorizontalScrollBar: true
              #hasVerticalScrollBar: true
              #miniScrollerHorizontal: true
              #acceptChannel: #editAcceptChannel
              #tabRequiresControl: true
            )
           )
         
        )
      )
!

testWindowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SmaCC::SmaCCParserGenerator andSelector:#testWindowSpec
     SmaCC::SmaCCParserGenerator new openInterface:#testWindowSpec
    "

    <resource: #canvas>

    ^ 
     #(#FullSpec
        #name: #testWindowSpec
        #window: 
       #(#WindowSpec
          #label: 'Unlabeled Canvas'
          #name: 'Unlabeled Canvas'
          #bounds: #(#Rectangle 16 52 289 252)
        )
        #component: 
       #(#SpecCollection
          #collection: #(
           #(#TextEditorSpec
              #name: #text
              #layout: #(#LayoutFrame 2 0 2 0 -2 1 -29 1)
              #model: #testHolder
              #hasHorizontalScrollBar: true
              #hasVerticalScrollBar: true
              #miniScrollerHorizontal: true
              #acceptChannel: #editAcceptChannel
              #tabRequiresControl: true
            )
           #(#HorizontalPanelViewSpec
              #name: 'HorizontalPanel1'
              #layout: #(#LayoutFrame 0 0 -30 1 0 1 0 1)
              #horizontalLayout: #leftSpaceMax
              #verticalLayout: #center
              #horizontalSpace: 3
              #verticalSpace: 3
              #component: 
             #(#SpecCollection
                #collection: #(
                 #(#ActionButtonSpec
                    #label: 'Parse'
                    #name: #parse
                    #model: #parse
                    #extent: #(#Point 125 25)
                  )
                 #(#ActionButtonSpec
                    #label: 'Parse and Inspect'
                    #name: #parseAndInspect
                    #model: #parseAndInspect
                    #extent: #(#Point 125 25)
                  )
                 )
               
              )
            )
           )
         
        )
      )
!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SmaCC::SmaCCParserGenerator andSelector:#windowSpec
     SmaCC::SmaCCParserGenerator new openInterface:#windowSpec
     SmaCC::SmaCCParserGenerator open
    "

    <resource: #canvas>

    ^ 
     #(#FullSpec
        #name: #windowSpec
        #window: 
       #(#WindowSpec
          #label: 'SmaCC Parser Generator'
          #name: 'SmaCC Parser Generator'
          #min: #(#Point 200 200)
          #bounds: #(#Rectangle 16 52 436 362)
          #menu: #mainMenu
        )
        #component: 
       #(#SpecCollection
          #collection: #(
           #(#TabControlSpec
              #name: #subcanvas
              #layout: #(#LayoutFrame 2 0 2 0 -2 1 -2 1)
              #model: #tabList
              #labels: #()
            )
           )
         
        )
      )
! !

!SmaCCParserGenerator methodsFor:'actions'!

aboutThisApplicationText
    "text for an about box for this application."

    |rev clsRev msg|

    rev := ''.

    (clsRev := self class revision) notNil ifTrue: [rev := '  (rev: ', clsRev printString, ')'].

    msg := 'SmaCC Compiler-Compiler framework.
Written by John Brant and Don Roberts.
Available for VisualWorks, Dolphin, VisualAge and Smalltalk/X.
\\' withCRs , self class name asBoldText, rev.
    ^ msg

    "Created: / 13.11.2001 / 12:28:36 / cg"
!

compileLALR1
	self compile: #LALR1
!

compileLR1
	self compile: #LR1
!

findParserClass
	| class |
	class := self choose: 'What class do you want to use?'
				from: (SmaCCParser allSubclasses asSortedCollection: [:a :b | a name < b name]).
	class isNil ifTrue: [^self].
	self parserClassNameHolder value: class fullName.
	(class class includesSelector: #parserDefinitionComment) 
		ifTrue: 
			[(self confirm: 'Do you wish to load the parser definition?') 
				ifTrue: 
					[self parserHolder value: (self 
								removeCommentedPartOf: (class class sourceCodeAt: #parserDefinitionComment))]]
!

findScannerClass
	| class |
	class := self choose: 'What class do you want to use?'
				from: (SmaCCScanner allSubclasses asSortedCollection: [:a :b | a name < b name]).
	class isNil ifTrue: [^self].
	self scannerClassNameHolder value: class fullName.
	(class class includesSelector: #scannerDefinitionComment) 
		ifTrue: 
			[(self confirm: 'Do you wish to load the scanner definition?') 
				ifTrue: 
					[self scannerHolder value: (self 
								removeCommentedPartOf: (class class sourceCodeAt: #scannerDefinitionComment))]]
!

openAboutThisAppliaction
    Dialog
        about:(resources string:self aboutThisApplicationText)
        label:(resources string:self aboutThisApplicationLabel)
        icon:self aboutImage
!

openDocumentation
    "opens the documentation file of the Parsergenerator"

    HTMLDocumentView openFullOnDocumentationFile:'../../../goodies/smaCC/documentation/Tutorial.html'
!

parse
        self editAcceptChannel value:true.
        self parseAndEvaluate: [:each | self warn: 'Parses without errors']
!

parseAndInspect
        self editAcceptChannel value:true.
        self parseAndEvaluate: [:each | each inspect]
! !

!SmaCCParserGenerator methodsFor:'aspects'!

allowUnicodeHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^allowUnicodeHolder isNil
		ifTrue:
			[allowUnicodeHolder := false asValue]
		ifFalse:
			[allowUnicodeHolder]
!

conflictHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^conflictHolder isNil
		ifTrue:
			[conflictHolder := String new asValue]
		ifFalse:
			[conflictHolder]
!

editAcceptChannel
        ^editAcceptChannel isNil
                ifTrue:
                        [editAcceptChannel := TriggerValue new]
                ifFalse:
                        [editAcceptChannel]
!

generateDefinitionCommentsHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^generateDefinitionCommentsHolder isNil
		ifTrue:
			[generateDefinitionCommentsHolder := false asValue]
		ifFalse:
			[generateDefinitionCommentsHolder]
!

generateItemSetCommentsHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^generateItemSetCommentsHolder isNil
		ifTrue:
			[generateItemSetCommentsHolder := false asValue]
		ifFalse:
			[generateItemSetCommentsHolder]
!

generateSymbolCommentsHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^generateSymbolCommentsHolder isNil
		ifTrue:
			[generateSymbolCommentsHolder := false asValue]
		ifFalse:
			[generateSymbolCommentsHolder]
!

ignoreCaseHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^ignoreCaseHolder isNil
		ifTrue:
			[ignoreCaseHolder := false asValue]
		ifFalse:
			[ignoreCaseHolder]
!

parserClassNameHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^parserClassNameHolder isNil
		ifTrue:
			[parserClassNameHolder := nil asValue]
		ifFalse:
			[parserClassNameHolder]
!

parserHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^parserHolder isNil
		ifTrue:
			[parserHolder := String new asValue]
		ifFalse:
			[parserHolder]
!

scannerClassNameHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^scannerClassNameHolder isNil
		ifTrue:
			[scannerClassNameHolder := nil asValue]
		ifFalse:
			[scannerClassNameHolder]
!

scannerHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^scannerHolder isNil
		ifTrue:
			[scannerHolder := String new asValue]
		ifFalse:
			[scannerHolder]
!

tabList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^tabList isNil
		ifTrue:
			[tabList := SelectionInList new]
		ifFalse:
			[tabList]
!

testHolder
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^testHolder isNil
		ifTrue:
			[testHolder := String new asValue]
		ifFalse:
			[testHolder]
! !

!SmaCCParserGenerator methodsFor:'changing'!

changedTab
        self editAcceptChannel value:true.
        self installSpec
! !

!SmaCCParserGenerator methodsFor:'initialize-release'!

initialize
	super initialize.
	(self tabList)
		list: #('Scanner' 'Parser' 'Compile' 'Test') asList;
		selectionIndex: 1.
	self tabList selectionIndexHolder onChangeSend: #changedTab to: self.
	self scannerClassNameHolder value: ''.
	self parserClassNameHolder value: ''.
	self scannerHolder value: ''.
	self parserHolder value: ''.
	self testHolder value: ''.
	self generateDefinitionCommentsHolder value: true
! !

!SmaCCParserGenerator methodsFor:'interface opening'!

postBuildWith: aBuilder 
	builder == aBuilder ifFalse: [subcanvasBuilder := aBuilder].
	(aBuilder componentAt: #text) 
		ifNotNil: [:each | each widget controller continuousAccept: true].
	super postBuildWith: aBuilder
!

postOpenWith: aBuilder 
	super postOpenWith: aBuilder.
	self installSpec
! !

!SmaCCParserGenerator methodsFor:'private'!

compile: aSymbol 
	| grammar stream oldIgnoreCase oldCharacterSize parserCompiler |
	(self scannerClassNameHolder value isEmpty 
		or: [self parserClassNameHolder value isEmpty]) 
			ifTrue: [^self warn: 'Both classes are not specified'].
	self showWaitCursorWhile: 
			[self verifySyntax ifFalse: [^self].
			oldIgnoreCase := SmaCCGrammar ignoreCase.
			oldCharacterSize := SmaCCGrammar maximumCharacterValue.
                        
			[SmaCCGrammar
				ignoreCase: self ignoreCaseHolder value;
				maximumCharacterValue: (self allowUnicodeHolder value 
							ifTrue: [(2 raisedTo: 16) - 1]
							ifFalse: [255]).
			parserCompiler := SmaCCGrammarCompiler new.
			parserCompiler
				buildScanner: self scannerHolder value andParser: self parserHolder value;
				scannerClass: self scannerClassNameHolder value;
				parserClass: self parserClassNameHolder value.
			grammar := parserCompiler grammar.
			grammar type: aSymbol.
			stream := WriteStream on: Text new.
                        
			[parserCompiler createChanges.
			self generateDefinitionCommentsHolder value 
				ifTrue: [parserCompiler compileDefinitionComments].
			self generateSymbolCommentsHolder value 
				ifTrue: [parserCompiler compileSymbolComment].
			self generateItemSetCommentsHolder value 
				ifTrue: [parserCompiler compileItemSetsComment].
			parserCompiler compileChanges] 
					on: SmaCCCompilationNotification
					do: 
						[:ex | 
						(ShowPrecedenceConflicts or: [('*precedence*' match: ex messageText) not]) 
							ifTrue: 
								[stream
									nextPutAll: '-------------------------\' withCRs asText 
												, ex messageText asText allBold;
									cr;
									cr;
									nextPutAll: ex parameter;
									cr].
						ex pass].
			self conflictHolder value: stream contents] 
					ensure: 
						[SmaCCGrammar
							ignoreCase: oldIgnoreCase;
							maximumCharacterValue: oldCharacterSize]]
!

displayError: aString at: position 
        |w|

        w := self textWidget.
        w notNil ifTrue:[ 
                        w takeKeyboardFocus.
                        w widget controller insertAndSelect: aString , ' ->' at: position]
!

installSpec
	subcanvasBuilder := nil.
	(builder componentAt: #subcanvas) widget client: self
		spec: self selectedSpec
!

parseAndEvaluate: aBlock 
	| class |
	class := self parserClass.
	class isNil ifTrue: [^self warn: 'No parser defined'].
	aBlock value: (class parse: self testHolder value
				onError: 
					[:aString :position | 
					self tabList selection: 'Test'.
					self displayError: aString at: position.
					^self])
!

parserClass
	^self parserClassNameHolder value asQualifiedReference value
!

removeCommentedPartOf: aString 
	| inStream outStream |
	inStream := ReadStream on: aString.
	outStream := WriteStream on: String new.
	inStream upTo: $".
	[inStream atEnd] whileFalse: 
			[(inStream peekFor: $") ifTrue: [outStream nextPut: $"].
			outStream nextPutAll: (inStream upTo: $")].
	^outStream contents
!

selectedSpec
	^(self tabList selection asLowercase , 'WindowSpec') asSymbol
!

textWidget
        Smalltalk dialectName = 'SmalltalkX' ifTrue:[
            ^ builder componentAt: #text   
        ].
        ^subcanvasBuilder componentAt: #text
!

verifyParser
	^
	[SmaCCGrammarCompiler new buildScanner: self scannerHolder value
		andParser: self parserHolder value.
	true] 
			on: SmaCCParserError
			do: 
				[:ex | 
				self tabList selection: 'Parser'.
				self displayError: ex description at: ex parameter position.
				ex return: false]
!

verifyScanner
	SmaCCScannerParser parse: self scannerHolder value
		onError: 
			[:aString :position | 
			self tabList selection: 'Scanner'.
			self displayError: aString at: position.
			^false].
	^true
!

verifySyntax
	^self verifyScanner and: [self verifyParser]
! !

!SmaCCParserGenerator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/smaCC/generator/SmaCCParserGenerator.st,v 1.5 2006/07/14 10:29:58 cg Exp $'
! !

SmaCCParserGenerator initialize!
