"{ Package: 'stx:goodies/smaCC/tests' }"

"{ NameSpace: SmaCC }"

SmaCCParser subclass:#CParser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SmaCC-Example Parsers'
!


!CParser class methodsFor:'generated-accessing'!

scannerClass
	^CScanner
! !

!CParser class methodsFor:'generated-comments'!

parserDefinitionComment

	"%id <TYPE_NAME> <IDENTIFIER> <CONSTANT> ;

translation_unit
	: external_declaration
	| translation_unit external_declaration
	;

primary_expression
	: <IDENTIFIER>
	| <CONSTANT>
	| <STRING_LITERAL>
	| ""("" expression "")""
	;

postfix_expression
	: primary_expression
	| postfix_expression <LEFT_BLOCK> expression <RIGHT_BLOCK>
	| postfix_expression ""("" "")""
	| postfix_expression ""("" argument_expression_list "")""
	| postfix_expression ""."" <IDENTIFIER>
	| postfix_expression ""->"" <IDENTIFIER>
	| postfix_expression ""++""
	| postfix_expression ""--""
	;

argument_expression_list
	: assignment_expression
	| argument_expression_list "","" assignment_expression
	;

unary_expression
	: postfix_expression
	| ""++"" unary_expression
	| ""--"" unary_expression
	| unary_operator cast_expression
	| ""sizeof"" unary_expression
	| ""sizeof"" ""("" type_name "")""
	;

unary_operator
	: ""&""
	| ""*""
	| ""+""
	| ""-""
	| ""~""
	| ""!!""
	;

cast_expression
	: unary_expression
	| ""("" type_name "")"" cast_expression
	;

multiplicative_expression
	: cast_expression
	| multiplicative_expression ""*"" cast_expression
	| multiplicative_expression ""/"" cast_expression
	| multiplicative_expression ""%"" cast_expression
	;

additive_expression
	: multiplicative_expression
	| additive_expression ""+"" multiplicative_expression
	| additive_expression ""-"" multiplicative_expression
	;

shift_expression
	: additive_expression
	| shift_expression ""<<"" additive_expression
	| shift_expression "">>"" additive_expression
	;

relational_expression
	: shift_expression
	| relational_expression ""<"" shift_expression
	| relational_expression "">"" shift_expression
	| relational_expression ""<="" shift_expression
	| relational_expression "">="" shift_expression
	;

equality_expression
	: relational_expression
	| equality_expression ""=="" relational_expression
	| equality_expression ""!!="" relational_expression
	;

and_expression
	: equality_expression
	| and_expression ""&"" equality_expression
	;

exclusive_or_expression
	: and_expression
	| exclusive_or_expression ""^"" and_expression
	;

inclusive_or_expression
	: exclusive_or_expression
	| inclusive_or_expression ""|"" exclusive_or_expression
	;

logical_and_expression
	: inclusive_or_expression
	| logical_and_expression ""&&"" inclusive_or_expression
	;

logical_or_expression
	: logical_and_expression
	| logical_or_expression ""||"" logical_and_expression
	;

conditional_expression
	: logical_or_expression
	| logical_or_expression ""?"" expression "":"" conditional_expression
	;

assignment_expression
	: conditional_expression
	| unary_expression assignment_operator assignment_expression
	;

assignment_operator
	: ""=""
	| ""*=""
	| ""/=""
	| ""%=""
	| ""+=""
	| ""-=""
	| ""<<=""
	| "">>=""
	| ""&=""
	| ""^=""
	| ""|=""
	;

expression
	: assignment_expression
	| expression "","" assignment_expression
	;

constant_expression
	: conditional_expression
	;

declaration
	: declaration_specifiers "";""
	| declaration_specifiers init_declarator_list "";""
	;

declaration_specifiers
	: storage_class_specifier
	| storage_class_specifier declaration_specifiers
	| type_specifier
	| type_specifier declaration_specifiers
	| type_qualifier
	| type_qualifier declaration_specifiers
	;

init_declarator_list
	: init_declarator
	| init_declarator_list "","" init_declarator
	;

init_declarator
	: declarator
	| declarator ""="" initializer
	;

storage_class_specifier
	: ""typedef""
	| ""extern""
	| ""static""
	| ""auto""
	| ""register""
	;

type_specifier
	: ""void""
	| ""char""
	| ""short""
	| ""int""
	| ""long""
	| ""float""
	| ""double""
	| ""signed""
	| ""unsigned""
	| struct_or_union_specifier
	| enum_specifier
	| <TYPE_NAME>
	;

struct_or_union_specifier
	: struct_or_union <IDENTIFIER> <LEFT_BRACE> struct_declaration_list <RIGHT_BRACE> {self addTypeName: '2' value. self reduceFor: nodes}
	| struct_or_union <LEFT_BRACE> struct_declaration_list <RIGHT_BRACE>
	| struct_or_union <IDENTIFIER> {self addTypeName: '2' value. self reduceFor: nodes}
	;

struct_or_union
	: ""struct""
	| ""union""
	;

struct_declaration_list
	: struct_declaration
	| struct_declaration_list struct_declaration
	;

struct_declaration
	: specifier_qualifier_list struct_declarator_list "";""
	;

specifier_qualifier_list
	: type_specifier specifier_qualifier_list
	| type_specifier
	| type_qualifier specifier_qualifier_list
	| type_qualifier
	;

struct_declarator_list
	: struct_declarator
	| struct_declarator_list "","" struct_declarator
	;

struct_declarator
	: declarator
	| "":"" constant_expression
	| declarator "":"" constant_expression
	;

enum_specifier
	: ""enum"" <LEFT_BRACE> enumerator_list <RIGHT_BRACE>
	| ""enum"" <IDENTIFIER> <LEFT_BRACE> enumerator_list <RIGHT_BRACE>  {self addTypeName: '2' value. self reduceFor: nodes}
	| ""enum"" <IDENTIFIER>  {self addTypeName: '2' value. self reduceFor: nodes}
	;

enumerator_list
	: enumerator
	| enumerator_list "","" enumerator
	;

enumerator
	: <IDENTIFIER>
	| <IDENTIFIER> ""="" constant_expression
	;

type_qualifier
	: ""const""
	| ""volatile""
	;

declarator
	: pointer direct_declarator
	| direct_declarator
	;

direct_declarator
	: <IDENTIFIER>
	| ""("" declarator "")""
	| direct_declarator <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| direct_declarator <LEFT_BLOCK> <RIGHT_BLOCK>
	| direct_declarator ""("" parameter_type_list "")""
	| direct_declarator ""("" identifier_list "")""
	| direct_declarator ""("" "")""
	;

pointer
	: ""*""
	| ""*"" type_qualifier_list
	| ""*"" pointer
	| ""*"" type_qualifier_list pointer
	;

type_qualifier_list
	: type_qualifier
	| type_qualifier_list type_qualifier
	;


parameter_type_list
	: parameter_list
	| parameter_list "","" <ELLIPSIS>
	;

parameter_list
	: parameter_declaration
	| parameter_list "","" parameter_declaration
	;

parameter_declaration
	: declaration_specifiers declarator
	| declaration_specifiers abstract_declarator
	| declaration_specifiers
	;

identifier_list
	: <IDENTIFIER>
	| identifier_list "","" <IDENTIFIER>
	;

type_name
	: specifier_qualifier_list
	| specifier_qualifier_list abstract_declarator
	;

abstract_declarator
	: pointer
	| direct_abstract_declarator
	| pointer direct_abstract_declarator
	;

direct_abstract_declarator
	: ""("" abstract_declarator "")""
	| <LEFT_BLOCK> <RIGHT_BLOCK>
	| <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| direct_abstract_declarator <LEFT_BLOCK> <RIGHT_BLOCK>
	| direct_abstract_declarator <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| ""("" "")""
	| ""("" parameter_type_list "")""
	| direct_abstract_declarator ""("" "")""
	| direct_abstract_declarator ""("" parameter_type_list "")""
	;

initializer
	: assignment_expression
	| <LEFT_BRACE> initializer_list <RIGHT_BRACE>
	| <LEFT_BRACE> initializer_list "","" <RIGHT_BRACE>
	;

initializer_list
	: initializer
	| initializer_list "","" initializer
	;

statement
	: labeled_statement
	| compound_statement
	| expression_statement
	| selection_statement
	| iteration_statement
	| jump_statement
	;

labeled_statement
	: <IDENTIFIER> "":"" statement
	| ""case"" constant_expression "":"" statement
	| ""default"" "":"" statement
	;

compound_statement
	: <LEFT_BRACE> <RIGHT_BRACE>
	| <LEFT_BRACE> statement_list <RIGHT_BRACE>
	| <LEFT_BRACE> declaration_list <RIGHT_BRACE>
	| <LEFT_BRACE> declaration_list statement_list <RIGHT_BRACE>
	;

declaration_list
	: declaration
	| declaration_list declaration
	;

statement_list
	: statement
	| statement_list statement
	;

expression_statement
	: "";""
	| expression "";""
	;

selection_statement
	: ""if"" ""("" expression "")"" statement
	| ""if"" ""("" expression "")"" statement ""else"" statement
	| ""switch"" ""("" expression "")"" statement
	;

iteration_statement
	: ""while"" ""("" expression "")"" statement
	| ""do"" statement ""while"" ""("" expression "")"" "";""
	| ""for"" ""("" expression_statement expression_statement "")"" statement
	| ""for"" ""("" expression_statement expression_statement expression "")"" statement
	;

jump_statement
	: ""goto"" <IDENTIFIER> "";""
	| ""continue"" "";""
	| ""break"" "";""
	| ""return"" "";""
	| ""return"" expression "";""
	;

external_declaration
	: function_definition
	| declaration
	;

function_definition
	: declaration_specifiers declarator declaration_list compound_statement
	| declaration_specifiers declarator compound_statement
	| declarator declaration_list compound_statement
	| declarator compound_statement
	;

"
! !

!CParser class methodsFor:'generated-starting states'!

startingStateFortranslation_unit
	^1
! !

!CParser methodsFor:'accessing'!

parserDefinitionComment

        "%id <TYPE_NAME> <IDENTIFIER> <CONSTANT> ;

translation_unit
        : external_declaration
        | translation_unit external_declaration
        ;

primary_expression
        : <IDENTIFIER>
        | <CONSTANT>
        | <STRING_LITERAL>
        | ""("" expression "")""
        ;

postfix_expression
        : primary_expression
        | postfix_expression <LEFT_BLOCK> expression <RIGHT_BLOCK>
        | postfix_expression ""("" "")""
        | postfix_expression ""("" argument_expression_list "")""
        | postfix_expression ""."" <IDENTIFIER>
        | postfix_expression ""->"" <IDENTIFIER>
        | postfix_expression ""++""
        | postfix_expression ""--""
        ;

argument_expression_list
        : assignment_expression
        | argument_expression_list "","" assignment_expression
        ;

unary_expression
        : postfix_expression
        | ""++"" unary_expression
        | ""--"" unary_expression
        | unary_operator cast_expression
        | ""sizeof"" unary_expression
        | ""sizeof"" ""("" type_name "")""
        ;

unary_operator
        : ""&""
        | ""*""
        | ""+""
        | ""-""
        | ""~""
        | ""!!!!""
        ;

cast_expression
        : unary_expression
        | ""("" type_name "")"" cast_expression
        ;

multiplicative_expression
        : cast_expression
        | multiplicative_expression ""*"" cast_expression
        | multiplicative_expression ""/"" cast_expression
        | multiplicative_expression ""%"" cast_expression
        ;

additive_expression
        : multiplicative_expression
        | additive_expression ""+"" multiplicative_expression
        | additive_expression ""-"" multiplicative_expression
        ;

shift_expression
        : additive_expression
        | shift_expression ""<<"" additive_expression
        | shift_expression "">>"" additive_expression
        ;

relational_expression
        : shift_expression
        | relational_expression ""<"" shift_expression
        | relational_expression "">"" shift_expression
        | relational_expression ""<="" shift_expression
        | relational_expression "">="" shift_expression
        ;

equality_expression
        : relational_expression
        | equality_expression ""=="" relational_expression
        | equality_expression ""!!!!="" relational_expression
        ;

and_expression
        : equality_expression
        | and_expression ""&"" equality_expression
        ;

exclusive_or_expression
        : and_expression
        | exclusive_or_expression ""^"" and_expression
        ;

inclusive_or_expression
        : exclusive_or_expression
        | inclusive_or_expression ""|"" exclusive_or_expression
        ;

logical_and_expression
        : inclusive_or_expression
        | logical_and_expression ""&&"" inclusive_or_expression
        ;

logical_or_expression
        : logical_and_expression
        | logical_or_expression ""||"" logical_and_expression
        ;

conditional_expression
        : logical_or_expression
        | logical_or_expression ""?"" expression "":"" conditional_expression
        ;

assignment_expression
        : conditional_expression
        | unary_expression assignment_operator assignment_expression
        ;

assignment_operator
        : ""=""
        | ""*=""
        | ""/=""
        | ""%=""
        | ""+=""
        | ""-=""
        | ""<<=""
        | "">>=""
        | ""&=""
        | ""^=""
        | ""|=""
        ;

expression
        : assignment_expression
        | expression "","" assignment_expression
        ;

constant_expression
        : conditional_expression
        ;

declaration
        : declaration_specifiers "";""
        | declaration_specifiers init_declarator_list "";""
        ;

declaration_specifiers
        : storage_class_specifier
        | storage_class_specifier declaration_specifiers
        | type_specifier
        | type_specifier declaration_specifiers
        | type_qualifier
        | type_qualifier declaration_specifiers
        ;

init_declarator_list
        : init_declarator
        | init_declarator_list "","" init_declarator
        ;

init_declarator
        : declarator
        | declarator ""="" initializer
        ;

storage_class_specifier
        : ""typedef""
        | ""extern""
        | ""static""
        | ""auto""
        | ""register""
        ;

type_specifier
        : ""void""
        | ""char""
        | ""short""
        | ""int""
        | ""long""
        | ""float""
        | ""double""
        | ""signed""
        | ""unsigned""
        | struct_or_union_specifier
        | enum_specifier
        | <TYPE_NAME>
        ;

struct_or_union_specifier
        : struct_or_union <IDENTIFIER> <LEFT_BRACE> struct_declaration_list <RIGHT_BRACE> {self addTypeName: '2' value. self reduceFor: nodes}
        | struct_or_union <LEFT_BRACE> struct_declaration_list <RIGHT_BRACE>
        | struct_or_union <IDENTIFIER> {self addTypeName: '2' value. self reduceFor: nodes}
        ;

struct_or_union
        : ""struct""
        | ""union""
        ;

struct_declaration_list
        : struct_declaration
        | struct_declaration_list struct_declaration
        ;

struct_declaration
        : specifier_qualifier_list struct_declarator_list "";""
        ;

specifier_qualifier_list
        : type_specifier specifier_qualifier_list
        | type_specifier
        | type_qualifier specifier_qualifier_list
        | type_qualifier
        ;

struct_declarator_list
        : struct_declarator
        | struct_declarator_list "","" struct_declarator
        ;

struct_declarator
        : declarator
        | "":"" constant_expression
        | declarator "":"" constant_expression
        ;

enum_specifier
        : ""enum"" <LEFT_BRACE> enumerator_list <RIGHT_BRACE>
        | ""enum"" <IDENTIFIER> <LEFT_BRACE> enumerator_list <RIGHT_BRACE>  {self addTypeName: '2' value. self reduceFor: nodes}
        | ""enum"" <IDENTIFIER>  {self addTypeName: '2' value. self reduceFor: nodes}
        ;

enumerator_list
        : enumerator
        | enumerator_list "","" enumerator
        ;

enumerator
        : <IDENTIFIER>
        | <IDENTIFIER> ""="" constant_expression
        ;

type_qualifier
        : ""const""
        | ""volatile""
        ;

declarator
        : pointer direct_declarator
        | direct_declarator
        ;

direct_declarator
        : <IDENTIFIER>
        | ""("" declarator "")""
        | direct_declarator <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
        | direct_declarator <LEFT_BLOCK> <RIGHT_BLOCK>
        | direct_declarator ""("" parameter_type_list "")""
        | direct_declarator ""("" identifier_list "")""
        | direct_declarator ""("" "")""
        ;

pointer
        : ""*""
        | ""*"" type_qualifier_list
        | ""*"" pointer
        | ""*"" type_qualifier_list pointer
        ;

type_qualifier_list
        : type_qualifier
        | type_qualifier_list type_qualifier
        ;


parameter_type_list
        : parameter_list
        | parameter_list "","" <ELLIPSIS>
        ;

parameter_list
        : parameter_declaration
        | parameter_list "","" parameter_declaration
        ;

parameter_declaration
        : declaration_specifiers declarator
        | declaration_specifiers abstract_declarator
        | declaration_specifiers
        ;

identifier_list
        : <IDENTIFIER>
        | identifier_list "","" <IDENTIFIER>
        ;

type_name
        : specifier_qualifier_list
        | specifier_qualifier_list abstract_declarator
        ;

abstract_declarator
        : pointer
        | direct_abstract_declarator
        | pointer direct_abstract_declarator
        ;

direct_abstract_declarator
        : ""("" abstract_declarator "")""
        | <LEFT_BLOCK> <RIGHT_BLOCK>
        | <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
        | direct_abstract_declarator <LEFT_BLOCK> <RIGHT_BLOCK>
        | direct_abstract_declarator <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
        | ""("" "")""
        | ""("" parameter_type_list "")""
        | direct_abstract_declarator ""("" "")""
        | direct_abstract_declarator ""("" parameter_type_list "")""
        ;

initializer
        : assignment_expression
        | <LEFT_BRACE> initializer_list <RIGHT_BRACE>
        | <LEFT_BRACE> initializer_list "","" <RIGHT_BRACE>
        ;

initializer_list
        : initializer
        | initializer_list "","" initializer
        ;

statement
        : labeled_statement
        | compound_statement
        | expression_statement
        | selection_statement
        | iteration_statement
        | jump_statement
        ;

labeled_statement
        : <IDENTIFIER> "":"" statement
        | ""case"" constant_expression "":"" statement
        | ""default"" "":"" statement
        ;

compound_statement
        : <LEFT_BRACE> <RIGHT_BRACE>
        | <LEFT_BRACE> statement_list <RIGHT_BRACE>
        | <LEFT_BRACE> declaration_list <RIGHT_BRACE>
        | <LEFT_BRACE> declaration_list statement_list <RIGHT_BRACE>
        ;

declaration_list
        : declaration
        | declaration_list declaration
        ;

statement_list
        : statement
        | statement_list statement
        ;

expression_statement
        : "";""
        | expression "";""
        ;

selection_statement
        : ""if"" ""("" expression "")"" statement
        | ""if"" ""("" expression "")"" statement ""else"" statement
        | ""switch"" ""("" expression "")"" statement
        ;

iteration_statement
        : ""while"" ""("" expression "")"" statement
        | ""do"" statement ""while"" ""("" expression "")"" "";""
        | ""for"" ""("" expression_statement expression_statement "")"" statement
        | ""for"" ""("" expression_statement expression_statement expression "")"" statement
        ;

jump_statement
        : ""goto"" <IDENTIFIER> "";""
        | ""continue"" "";""
        | ""break"" "";""
        | ""return"" "";""
        | ""return"" expression "";""
        ;

external_declaration
        : function_definition
        | declaration
        ;

function_definition
        : declaration_specifiers declarator declaration_list compound_statement
        | declaration_specifiers declarator compound_statement
        | declarator declaration_list compound_statement
        | declarator compound_statement
        ;

"
! !

!CParser methodsFor:'generated-reduction actions'!

reduceActionForenum_specifier2: nodes
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes
!

reduceActionForenum_specifier3: nodes
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes
!

reduceActionForstruct_or_union_specifier1: nodes
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes
!

reduceActionForstruct_or_union_specifier3: nodes
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes
! !

!CParser methodsFor:'generated-tables'!

reduceTable
	^#(
#(84 1 #reduceFor:)
#(84 4 #reduceFor:)
#(85 1 #reduceFor:)
#(85 2 #reduceFor:)
#(85 2 #reduceFor:)
#(85 2 #reduceFor:)
#(85 2 #reduceFor:)
#(85 4 #reduceFor:)
#(86 1 #reduceFor:)
#(86 3 #reduceFor:)
#(87 1 #reduceFor:)
#(87 3 #reduceFor:)
#(88 1 #reduceFor:)
#(88 1 #reduceFor:)
#(88 1 #reduceFor:)
#(88 3 #reduceFor:)
#(89 1 #reduceFor:)
#(89 2 #reduceFor:)
#(90 1 #reduceFor:)
#(90 3 #reduceFor:)
#(90 3 #reduceFor:)
#(90 3 #reduceFor:)
#(91 1 #reduceFor:)
#(91 3 #reduceFor:)
#(91 3 #reduceFor:)
#(92 1 #reduceFor:)
#(92 3 #reduceFor:)
#(92 3 #reduceFor:)
#(93 1 #reduceFor:)
#(93 1 #reduceFor:)
#(93 1 #reduceFor:)
#(93 1 #reduceFor:)
#(93 1 #reduceFor:)
#(93 1 #reduceFor:)
#(94 1 #reduceFor:)
#(94 3 #reduceFor:)
#(94 3 #reduceFor:)
#(95 1 #reduceFor:)
#(95 3 #reduceFor:)
#(96 1 #reduceFor:)
#(96 4 #reduceFor:)
#(96 3 #reduceFor:)
#(96 4 #reduceFor:)
#(96 3 #reduceFor:)
#(96 3 #reduceFor:)
#(96 2 #reduceFor:)
#(96 2 #reduceFor:)
#(97 1 #reduceFor:)
#(97 3 #reduceFor:)
#(98 1 #reduceFor:)
#(98 3 #reduceFor:)
#(99 1 #reduceFor:)
#(99 3 #reduceFor:)
#(100 1 #reduceFor:)
#(100 5 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(101 1 #reduceFor:)
#(102 1 #reduceFor:)
#(103 1 #reduceFor:)
#(103 2 #reduceFor:)
#(103 1 #reduceFor:)
#(103 2 #reduceFor:)
#(103 1 #reduceFor:)
#(103 2 #reduceFor:)
#(104 1 #reduceFor:)
#(104 3 #reduceFor:)
#(105 2 #reduceFor:)
#(105 3 #reduceFor:)
#(106 1 #reduceFor:)
#(106 1 #reduceFor:)
#(106 1 #reduceFor:)
#(106 1 #reduceFor:)
#(106 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(107 1 #reduceFor:)
#(108 1 #reduceFor:)
#(108 1 #reduceFor:)
#(109 1 #reduceFor:)
#(109 3 #reduceFor:)
#(110 2 #reduceFor:)
#(110 1 #reduceFor:)
#(111 1 #reduceFor:)
#(111 3 #reduceFor:)
#(111 3 #reduceFor:)
#(111 3 #reduceFor:)
#(111 3 #reduceFor:)
#(112 5 #reduceActionForstruct_or_union_specifier1:)
#(112 4 #reduceFor:)
#(112 2 #reduceActionForstruct_or_union_specifier3:)
#(113 1 #reduceFor:)
#(114 4 #reduceFor:)
#(114 5 #reduceActionForenum_specifier2:)
#(114 2 #reduceActionForenum_specifier3:)
#(115 1 #reduceFor:)
#(115 1 #reduceFor:)
#(116 1 #reduceFor:)
#(116 3 #reduceFor:)
#(117 1 #reduceFor:)
#(117 2 #reduceFor:)
#(118 1 #reduceFor:)
#(118 3 #reduceFor:)
#(119 3 #reduceFor:)
#(120 2 #reduceFor:)
#(120 1 #reduceFor:)
#(120 2 #reduceFor:)
#(120 1 #reduceFor:)
#(121 1 #reduceFor:)
#(121 3 #reduceFor:)
#(122 1 #reduceFor:)
#(122 2 #reduceFor:)
#(122 3 #reduceFor:)
#(123 1 #reduceFor:)
#(123 3 #reduceFor:)
#(124 1 #reduceFor:)
#(124 3 #reduceFor:)
#(125 1 #reduceFor:)
#(125 2 #reduceFor:)
#(125 2 #reduceFor:)
#(125 3 #reduceFor:)
#(126 1 #reduceFor:)
#(126 3 #reduceFor:)
#(126 4 #reduceFor:)
#(126 3 #reduceFor:)
#(126 4 #reduceFor:)
#(126 4 #reduceFor:)
#(126 3 #reduceFor:)
#(127 1 #reduceFor:)
#(127 3 #reduceFor:)
#(128 1 #reduceFor:)
#(128 3 #reduceFor:)
#(129 1 #reduceFor:)
#(129 2 #reduceFor:)
#(130 1 #reduceFor:)
#(130 3 #reduceFor:)
#(132 2 #reduceFor:)
#(132 2 #reduceFor:)
#(132 1 #reduceFor:)
#(133 1 #reduceFor:)
#(133 1 #reduceFor:)
#(133 2 #reduceFor:)
#(134 3 #reduceFor:)
#(134 2 #reduceFor:)
#(134 3 #reduceFor:)
#(134 3 #reduceFor:)
#(134 4 #reduceFor:)
#(134 2 #reduceFor:)
#(134 3 #reduceFor:)
#(134 3 #reduceFor:)
#(134 4 #reduceFor:)
#(135 1 #reduceFor:)
#(135 3 #reduceFor:)
#(136 3 #reduceFor:)
#(136 4 #reduceFor:)
#(136 3 #reduceFor:)
#(137 2 #reduceFor:)
#(137 3 #reduceFor:)
#(137 3 #reduceFor:)
#(137 4 #reduceFor:)
#(138 1 #reduceFor:)
#(138 2 #reduceFor:)
#(139 5 #reduceFor:)
#(139 7 #reduceFor:)
#(139 5 #reduceFor:)
#(140 5 #reduceFor:)
#(140 7 #reduceFor:)
#(140 6 #reduceFor:)
#(140 7 #reduceFor:)
#(141 3 #reduceFor:)
#(141 2 #reduceFor:)
#(141 2 #reduceFor:)
#(141 2 #reduceFor:)
#(141 3 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(142 1 #reduceFor:)
#(143 1 #reduceFor:)
#(143 2 #reduceFor:)
#(144 1 #reduceFor:)
#(144 2 #reduceFor:)
#(145 4 #reduceFor:)
#(145 3 #reduceFor:)
#(145 3 #reduceFor:)
#(145 2 #reduceFor:)
#(148 1 #reduceFor:)
#(148 1 #reduceFor:)
#(149 1 #reduceFor:)
#(149 3 #reduceFor:)
#(149 4 #reduceFor:)
#(150 1 #reduceFor:)
#(150 2 #reduceFor:)
)
!

transitionTable
	^#(
#[1 0 9 0 25 0 13 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 0 97 0 103 0 101 0 105 0 105 0 106 0 109 0 107 0 113 0 108 0 117 0 110 0 121 0 112 0 125 0 114 0 129 0 115 0 133 0 125 0 137 0 126 0 141 0 131 0 145 0 145 0 149 0 148 0 153 0 150]
#[1 0 9 0 25 0 13 0 35 0 93 0 76 0 157 0 110 0 133 0 125 0 137 0 126]
#[1 2 30 0 20 2 30 0 22 2 30 0 25 0 13 0 35 0 17 0 38 0 25 0 40 2 30 0 76 2 30 0 79 0 161 0 108 0 165 0 125 0 169 0 129]
#[0 1 126 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 202 0 76 0 81]
#[0 1 130 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[1 0 173 0 76 0 177 0 81]
#[0 1 198 0 76 0 81]
#[0 1 106 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 102 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 110 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 62 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 70 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 58 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 86 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 82 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 94 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 90 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 66 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 98 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 78 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 74 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 2 46 0 11 0 14 0 20 0 22 0 25 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 131]
#[1 0 9 0 25 0 13 0 35 0 181 0 59 0 93 0 76 0 185 0 104 0 189 0 109 0 193 0 110 0 133 0 125 0 137 0 126]
#[0 3 62 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 131 0 146]
#[1 1 18 0 20 1 18 0 22 1 18 0 25 1 18 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 1 18 0 59 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 18 0 76 1 18 0 79 0 197 0 103 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 0 141 0 131]
#[1 1 26 0 20 1 26 0 22 1 26 0 25 1 26 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 1 26 0 59 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 26 0 76 1 26 0 79 0 201 0 103 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 0 141 0 131]
#[1 1 34 0 20 1 34 0 22 1 34 0 25 1 34 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 1 34 0 59 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 34 0 76 1 34 0 79 0 205 0 103 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 0 141 0 131]
#[1 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 209 0 81 0 213 0 103 0 217 0 105 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 0 141 0 131 0 221 0 137 0 225 0 144]
#[0 1 114 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 118 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[1 0 229 0 76 0 233 0 81]
#[1 0 9 0 25 0 93 0 76 0 237 0 126]
#[1 1 146 0 11 1 146 0 14 1 146 0 20 1 146 0 22 0 241 0 25 1 146 0 38 1 146 0 39 1 146 0 40 1 146 0 42 1 146 0 44 1 146 0 46 1 146 0 52 1 146 0 55 1 146 0 59 1 146 0 60 1 146 0 62 1 146 0 64 1 146 0 66 1 146 0 67 1 146 0 68 1 146 0 69 1 146 0 70 1 146 0 71 1 146 0 72 1 146 0 73 0 245 0 79 1 146 0 81 1 146 0 131]
#[0 1 122 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 3 58 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 131 0 146]
#[0 3 78 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 131 0 146]
#[1 0 9 0 25 0 13 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 0 97 0 103 0 101 0 105 0 105 0 106 0 109 0 107 0 113 0 108 0 117 0 110 0 121 0 112 0 125 0 114 0 129 0 115 0 133 0 125 0 137 0 126 0 141 0 131 0 145 0 145 0 0 0 146 0 249 0 148]
#[0 0 253 0 20]
#[0 2 90 0 20 0 22 0 25 0 35 0 38 0 40 0 76 0 79]
#[0 2 38 0 20 0 22 0 25 0 76 0 79]
#[1 2 34 0 20 2 34 0 22 2 34 0 25 0 13 0 35 0 17 0 38 0 25 0 40 2 34 0 76 2 34 0 79 1 1 0 108 1 5 0 125]
#[1 1 194 0 11 1 194 0 20 1 194 0 22 1 194 0 25 1 194 0 35 1 194 0 38 1 194 0 39 1 194 0 40 1 194 0 42 1 194 0 44 1 194 0 46 1 194 0 52 1 194 0 55 1 194 0 59 1 194 0 60 1 194 0 62 1 194 0 64 1 194 0 66 1 194 0 67 1 194 0 68 1 194 0 69 1 194 0 70 1 194 0 71 1 194 0 72 1 194 0 73 1 194 0 76 1 194 0 79 1 9 0 81 1 194 0 131]
#[1 1 13 0 76 1 17 0 123 1 21 0 124]
#[0 1 50 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 59 0 60 0 62 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 131 0 146]
#[1 1 25 0 22 1 29 0 59]
#[0 1 42 0 22 0 59]
#[1 1 33 0 14 1 134 0 22 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 1 134 0 59 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 209 0 81 0 213 0 103 0 217 0 105 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 0 141 0 131 1 37 0 137 1 41 0 144]
#[0 1 22 0 20 0 22 0 25 0 35 0 59 0 76 0 79]
#[0 1 30 0 20 0 22 0 25 0 35 0 59 0 76 0 79]
#[0 1 38 0 20 0 22 0 25 0 35 0 59 0 76 0 79]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 0 17 0 38 0 21 0 39 0 25 0 40 1 89 0 41 0 29 0 42 0 33 0 44 1 93 0 45 0 37 0 46 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 0 41 0 52 1 117 0 53 1 121 0 54 0 45 0 55 1 125 0 59 0 49 0 60 0 53 0 62 0 57 0 64 1 129 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 145 0 82 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 0 213 0 103 0 217 0 105 0 105 0 106 0 109 0 107 0 113 0 108 1 209 0 111 0 121 0 112 0 125 0 114 0 129 0 115 1 213 0 116 1 217 0 118 0 141 0 131 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 1 245 0 142 1 249 0 143 1 253 0 144]
#[1 0 9 0 25 0 13 0 35 0 181 0 59 0 93 0 76 0 185 0 104 0 189 0 109 2 1 0 110 0 133 0 125 0 137 0 126]
#[0 3 34 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 59 0 60 0 62 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 131]
#[0 3 54 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 131 0 146]
#[1 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 209 0 81 0 213 0 103 2 5 0 105 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 0 141 0 131 2 9 0 137]
#[1 1 178 0 11 1 178 0 20 1 178 0 22 1 178 0 25 1 178 0 35 1 178 0 38 1 178 0 39 1 178 0 40 1 178 0 42 1 178 0 44 1 178 0 46 1 178 0 52 1 178 0 55 1 178 0 59 1 178 0 60 1 178 0 62 1 178 0 64 1 178 0 66 1 178 0 67 1 178 0 68 1 178 0 69 1 178 0 70 1 178 0 71 1 178 0 72 1 178 0 73 1 178 0 76 1 178 0 79 2 13 0 81 1 178 0 131]
#[1 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 81 0 71 0 85 0 72 2 17 0 107 2 21 0 108 0 121 0 112 0 125 0 114 0 129 0 115 2 25 0 117 2 29 0 119 2 33 0 120 0 141 0 131]
#[1 1 142 0 11 1 142 0 14 1 142 0 20 1 142 0 22 0 241 0 25 1 142 0 38 1 142 0 39 1 142 0 40 1 142 0 42 1 142 0 44 1 142 0 46 1 142 0 52 1 142 0 55 1 142 0 59 1 142 0 60 1 142 0 62 1 142 0 64 1 142 0 66 1 142 0 67 1 142 0 68 1 142 0 69 1 142 0 70 1 142 0 71 1 142 0 72 1 142 0 73 0 245 0 79 1 142 0 81 1 142 0 131]
#[1 2 37 0 20 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 2 41 0 76 2 45 0 103 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 2 49 0 127 2 53 0 128 2 57 0 130 0 141 0 131 2 61 0 132]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 2 69 0 80 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 2 77 0 100 2 81 0 102 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 3 82 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 131 0 146]
#[0 2 50 0 11 0 14 0 20 0 22 0 25 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 131]
#[0 2 94 0 20 0 22 0 25 0 35 0 38 0 40 0 76 0 79]
#[0 2 42 0 20 0 22 0 25 0 76 0 79]
#[1 1 13 0 76 2 85 0 123 1 21 0 124]
#[1 2 89 0 14 2 22 0 22 2 22 0 82]
#[1 2 93 0 22 2 97 0 82]
#[0 2 14 0 22 0 82]
#[1 0 9 0 25 0 13 0 35 0 93 0 76 2 101 0 109 2 1 0 110 0 133 0 125 0 137 0 126]
#[0 1 54 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 59 0 60 0 62 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 131 0 146]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 2 105 0 81 1 149 0 84 1 153 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 2 109 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 2 113 0 149]
#[0 3 46 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 131 0 146]
#[1 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 209 0 81 0 213 0 103 2 5 0 105 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 0 141 0 131 2 117 0 137]
#[1 1 45 0 21 1 49 0 24 2 121 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 2 125 0 85 1 161 0 88 1 177 0 93 1 189 0 96]
#[0 0 118 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 81 0 71 0 85 0 72 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 129 0 86 1 161 0 88 2 133 0 89 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 2 17 0 107 2 21 0 108 1 209 0 111 0 121 0 112 0 125 0 114 0 129 0 115 1 213 0 116 1 217 0 118 2 137 0 120 0 141 0 131]
#[1 1 45 0 21 1 49 0 24 2 121 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 2 141 0 85 1 161 0 88 1 177 0 93 1 189 0 96]
#[0 0 134 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 130 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 138 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[1 1 45 0 21 1 49 0 24 2 145 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 2 149 0 85 1 161 0 88 1 177 0 93 1 189 0 96]
#[0 0 126 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 122 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 2 153 0 59]
#[0 2 157 0 11]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 2 77 0 100 2 161 0 102 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 2 165 0 25]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 2 169 0 142]
#[0 2 173 0 59]
#[0 2 177 0 76]
#[0 2 181 0 25]
#[0 2 185 0 25]
#[0 2 189 0 25]
#[0 2 202 0 20 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 193 0 59 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 197 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 0 54 0 1 0 54 0 2 0 54 0 3 0 54 0 4 0 54 0 5 0 54 0 6 0 54 0 7 0 54 0 8 0 54 0 9 0 54 0 10 2 201 0 11 0 54 0 12 0 54 0 13 0 54 0 14 0 54 0 15 0 54 0 16 0 54 0 17 0 54 0 18 0 54 0 19 0 54 0 21 0 54 0 22 0 54 0 23 0 54 0 24 0 54 0 25 0 54 0 26 0 54 0 27 0 54 0 29 0 54 0 30 0 54 0 33 0 54 0 34 0 54 0 35 0 54 0 36 0 54 0 56 0 54 0 57 0 54 0 58 0 54 0 59 0 54 0 61 0 54 0 63 0 54 0 79]
#[0 0 58 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[0 0 62 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[0 2 186 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 59 0 60 0 62 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 131 0 146]
#[0 0 78 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 11 0 13 0 15 0 16 0 17 0 20 0 22 0 24 0 27 0 29 0 30 0 34 0 35 0 59 0 80 0 82]
#[1 0 6 0 1 0 6 0 2 0 6 0 3 0 6 0 4 0 6 0 5 0 6 0 6 0 6 0 7 0 6 0 8 0 6 0 9 2 205 0 10 0 6 0 11 2 209 0 12 0 6 0 13 2 213 0 14 0 6 0 15 0 6 0 16 0 6 0 17 2 217 0 18 0 6 0 20 0 6 0 22 0 6 0 24 0 6 0 27 0 6 0 29 0 6 0 30 2 221 0 33 0 6 0 34 0 6 0 35 2 225 0 36 2 229 0 56 2 233 0 57 2 237 0 58 0 6 0 59 2 241 0 61 2 245 0 63 0 6 0 80 0 6 0 82 2 249 0 101]
#[1 2 253 0 22 3 1 0 59]
#[0 0 162 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[1 0 94 0 1 0 94 0 2 0 94 0 3 0 94 0 4 0 94 0 5 0 94 0 6 0 94 0 7 0 94 0 8 0 94 0 9 0 94 0 11 3 5 0 13 0 94 0 15 0 94 0 16 0 94 0 17 0 94 0 20 0 94 0 22 0 94 0 24 0 94 0 27 0 94 0 29 3 9 0 30 0 94 0 34 3 13 0 35 0 94 0 59 0 94 0 80 0 94 0 82]
#[1 0 106 0 1 0 106 0 2 0 106 0 3 0 106 0 4 0 106 0 5 0 106 0 6 0 106 0 7 0 106 0 8 0 106 0 9 0 106 0 11 0 106 0 15 0 106 0 16 0 106 0 17 0 106 0 20 0 106 0 22 0 106 0 24 0 106 0 27 3 17 0 29 3 21 0 34 0 106 0 59 0 106 0 80 0 106 0 82]
#[1 1 150 0 1 1 150 0 2 1 150 0 3 1 150 0 4 1 150 0 5 1 150 0 6 1 150 0 7 1 150 0 8 3 25 0 9 1 150 0 11 1 150 0 15 1 150 0 16 1 150 0 17 1 150 0 20 1 150 0 22 1 150 0 24 3 29 0 27 1 150 0 59 1 150 0 80 1 150 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 3 33 0 84 2 73 0 85 1 161 0 88 1 177 0 93 1 189 0 96]
#[1 3 37 0 1 3 41 0 3 1 206 0 4 1 206 0 6 1 206 0 8 1 206 0 11 1 206 0 15 1 206 0 16 1 206 0 20 1 206 0 22 1 206 0 24 1 206 0 59 1 206 0 80 1 206 0 82]
#[0 0 38 0 11 0 20 0 22 0 59 0 80]
#[1 0 14 0 1 0 14 0 2 0 14 0 3 0 14 0 4 0 14 0 5 0 14 0 6 0 14 0 7 0 14 0 8 0 14 0 9 0 14 0 10 0 14 0 11 0 14 0 12 0 14 0 13 0 14 0 14 0 14 0 15 0 14 0 16 0 14 0 17 0 14 0 18 3 45 0 19 0 14 0 20 3 49 0 21 0 14 0 22 3 53 0 23 0 14 0 24 3 57 0 25 3 61 0 26 0 14 0 27 0 14 0 29 0 14 0 30 0 14 0 33 0 14 0 34 0 14 0 35 0 14 0 36 0 14 0 56 0 14 0 57 0 14 0 58 0 14 0 59 0 14 0 61 0 14 0 63 3 65 0 79 0 14 0 80 0 14 0 82]
#[1 3 69 0 4 0 202 0 6 0 202 0 11 0 202 0 15 0 202 0 16 0 202 0 20 0 202 0 22 0 202 0 59 0 202 0 80 0 202 0 82]
#[1 3 73 0 6 0 210 0 11 0 210 0 15 0 210 0 16 0 210 0 20 0 210 0 22 0 210 0 59 0 210 0 80 0 210 0 82]
#[1 0 218 0 11 3 77 0 15 3 81 0 16 0 218 0 20 0 218 0 22 0 218 0 59 0 218 0 80 0 218 0 82]
#[0 0 154 0 11 0 20 0 22 0 59 0 80 0 82]
#[1 0 142 0 1 3 85 0 2 0 142 0 3 0 142 0 4 3 89 0 5 0 142 0 6 3 93 0 7 0 142 0 8 0 142 0 11 0 142 0 15 0 142 0 16 3 97 0 17 0 142 0 20 0 142 0 22 0 142 0 24 0 142 0 59 0 142 0 80 0 142 0 82]
#[1 1 222 0 4 1 222 0 6 1 222 0 8 1 222 0 11 1 222 0 15 1 222 0 16 1 222 0 20 1 222 0 22 3 101 0 24 1 222 0 59 1 222 0 80 1 222 0 82]
#[1 0 194 0 4 0 194 0 6 3 105 0 8 0 194 0 11 0 194 0 15 0 194 0 16 0 194 0 20 0 194 0 22 0 194 0 59 0 194 0 80 0 194 0 82]
#[0 3 2 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 3 6 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 3 10 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 3 14 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 3 18 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 3 22 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 3 26 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 3 109 0 82 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 3 113 0 142]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 0 17 0 38 0 21 0 39 0 25 0 40 1 89 0 41 0 29 0 42 0 33 0 44 1 93 0 45 0 37 0 46 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 0 41 0 52 1 117 0 53 1 121 0 54 0 45 0 55 1 125 0 59 0 49 0 60 0 53 0 62 0 57 0 64 1 129 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 3 117 0 82 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 0 213 0 103 2 5 0 105 0 105 0 106 0 109 0 107 0 113 0 108 1 209 0 111 0 121 0 112 0 125 0 114 0 129 0 115 1 213 0 116 1 217 0 118 0 141 0 131 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 1 245 0 142 3 121 0 143]
#[1 1 33 0 14 1 134 0 22 1 134 0 59]
#[0 3 38 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 59 0 60 0 62 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 131]
#[0 3 50 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 131 0 146]
#[1 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 81 0 71 0 85 0 72 2 17 0 107 2 21 0 108 0 121 0 112 0 125 0 114 0 129 0 115 3 125 0 117 2 29 0 119 2 33 0 120 0 141 0 131]
#[1 1 238 0 11 1 238 0 20 1 238 0 25 1 238 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 81 0 71 0 85 0 72 1 238 0 76 1 238 0 79 2 17 0 107 2 21 0 108 0 121 0 112 0 125 0 114 0 129 0 115 3 129 0 120 0 141 0 131]
#[1 1 246 0 11 1 246 0 20 1 246 0 25 1 246 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 81 0 71 0 85 0 72 1 246 0 76 1 246 0 79 2 17 0 107 2 21 0 108 0 121 0 112 0 125 0 114 0 129 0 115 3 133 0 120 0 141 0 131]
#[1 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 81 0 71 0 85 0 72 3 137 0 82 2 17 0 107 2 21 0 108 0 121 0 112 0 125 0 114 0 129 0 115 3 141 0 119 2 33 0 120 0 141 0 131]
#[0 1 214 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 66 0 67 0 68 0 69 0 71 0 72 0 82 0 131]
#[1 3 145 0 11 0 9 0 25 0 13 0 35 0 93 0 76 3 149 0 110 3 153 0 121 3 157 0 122 0 133 0 125 0 137 0 126]
#[0 2 70 0 11 0 14 0 20 0 22 0 25 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 131]
#[0 2 82 0 20 0 22]
#[1 2 114 0 20 2 114 0 22 3 161 0 25 0 13 0 35 0 93 0 76 3 165 0 79 3 169 0 110 3 173 0 125 0 137 0 126 3 177 0 133 3 181 0 134]
#[0 3 185 0 20]
#[1 3 189 0 20 3 193 0 22]
#[1 2 74 0 20 3 197 0 22]
#[0 2 98 0 20 0 22]
#[0 0 54 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[0 2 58 0 11 0 14 0 20 0 22 0 25 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 131]
#[0 0 6 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 80 0 82]
#[0 1 14 0 11 0 22 0 59 0 80 0 82]
#[0 3 201 0 80]
#[1 2 93 0 22 3 205 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 2 77 0 100 3 209 0 102 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 13 0 76 3 213 0 124]
#[0 1 186 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 46 0 22 0 59]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 2 105 0 81 1 149 0 84 1 153 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 2 109 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 3 217 0 135 3 221 0 149]
#[0 3 66 0 22 0 59 0 82]
#[0 1 138 0 22 0 59]
#[0 3 42 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 131 0 146]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 129 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 0 18 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 80 0 82]
#[1 3 225 0 20 2 253 0 22]
#[0 3 229 0 20]
#[1 0 70 0 20 3 233 0 25 0 13 0 35 3 165 0 79 3 237 0 125 3 241 0 133 3 181 0 134]
#[0 0 22 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 80 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 81 0 71 0 85 0 72 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 2 129 0 86 1 161 0 88 3 245 0 89 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 2 17 0 107 2 21 0 108 1 209 0 111 0 121 0 112 0 125 0 114 0 129 0 115 1 213 0 116 1 217 0 118 2 137 0 120 0 141 0 131]
#[0 0 30 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 80 0 82]
#[0 2 246 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 3 249 0 142]
#[0 3 253 0 11]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 125 0 59 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 4 1 0 138]
#[0 4 5 0 53]
#[0 2 242 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 4 9 0 59]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 13 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 17 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 21 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 2 250 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 2 253 0 22 4 25 0 59]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 4 29 0 142]
#[0 0 230 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 234 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 226 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 242 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 250 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 238 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 246 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 1 10 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 1 2 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 1 6 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[0 0 254 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 76 0 77 0 78]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 4 33 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 4 37 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 2 206 0 20 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 4 41 0 84 2 73 0 85 1 161 0 88 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 4 45 0 84 2 73 0 85 1 161 0 88 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 4 49 0 84 2 73 0 85 1 161 0 88 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 4 53 0 90 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 4 57 0 90 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 4 61 0 91 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 4 65 0 91 1 177 0 93 1 189 0 96]
#[0 0 26 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 80 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 189 0 96 4 69 0 111]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 189 0 96 4 73 0 111]
#[0 4 77 0 76]
#[0 0 186 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[0 4 81 0 76]
#[1 4 85 0 20 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 89 0 87 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 4 93 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 0 190 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 97 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 209 0 111 1 213 0 116 4 101 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 4 105 0 97 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 4 109 0 98 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 4 113 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 4 117 0 92 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 4 121 0 92 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 4 125 0 92 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 4 129 0 92 1 177 0 93 1 189 0 96]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 4 133 0 94 1 189 0 96 1 209 0 111]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 209 0 111 4 137 0 116]
#[0 2 190 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 59 0 60 0 62 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 131 0 146]
#[0 3 30 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 2 194 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 59 0 60 0 62 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 131 0 146]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 4 141 0 82 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 3 113 0 142]
#[1 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 81 0 71 0 85 0 72 4 145 0 82 2 17 0 107 2 21 0 108 0 121 0 112 0 125 0 114 0 129 0 115 3 141 0 119 2 33 0 120 0 141 0 131]
#[0 1 234 0 11 0 20 0 25 0 35 0 76 0 79]
#[0 1 242 0 11 0 20 0 25 0 35 0 76 0 79]
#[0 1 174 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 1 218 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 66 0 67 0 68 0 69 0 71 0 72 0 82 0 131]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 2 77 0 100 4 149 0 102 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 4 153 0 11 2 2 0 22 2 2 0 59]
#[1 4 157 0 22 4 161 0 59]
#[0 1 250 0 22 0 59]
#[1 4 165 0 20 3 161 0 25 0 13 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 3 165 0 79 2 45 0 103 0 105 0 106 0 109 0 107 0 113 0 108 0 157 0 110 0 121 0 112 0 125 0 114 0 129 0 115 3 173 0 125 0 137 0 126 4 169 0 127 2 57 0 130 0 141 0 131 2 61 0 132 4 173 0 133 3 181 0 134]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 4 177 0 80 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 2 77 0 100 4 181 0 102 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 2 106 0 20 0 22]
#[1 2 118 0 20 2 118 0 22 3 161 0 25 0 93 0 76 3 165 0 79 0 237 0 126 4 185 0 134]
#[0 2 110 0 20 0 22]
#[1 2 122 0 20 2 122 0 22 4 189 0 25 4 193 0 79]
#[0 2 62 0 11 0 14 0 20 0 22 0 25 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 131]
#[0 2 66 0 11 0 14 0 20 0 22 0 25 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 131]
#[0 4 197 0 76]
#[1 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 4 201 0 74 2 45 0 103 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 0 141 0 131 4 205 0 132]
#[0 2 54 0 11 0 14 0 20 0 22 0 25 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 131]
#[0 1 190 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 2 26 0 22 0 82]
#[0 2 18 0 22 0 82]
#[1 4 209 0 22 4 213 0 82]
#[0 2 166 0 22 0 82]
#[0 0 66 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 4 217 0 84 2 73 0 85 1 161 0 88 1 177 0 93 1 189 0 96]
#[1 4 165 0 20 3 233 0 25 0 13 0 35 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 3 165 0 79 2 45 0 103 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 3 237 0 125 4 169 0 127 2 57 0 130 0 141 0 131 2 61 0 132 4 173 0 133 3 181 0 134]
#[1 2 118 0 20 3 233 0 25 3 165 0 79 4 185 0 134]
#[0 0 74 0 20]
#[0 4 221 0 20]
#[0 2 182 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 4 225 0 142]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 125 0 59 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 4 229 0 138]
#[0 4 233 0 25]
#[0 2 238 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 4 237 0 20 2 253 0 22]
#[1 4 241 0 20 2 253 0 22]
#[1 4 245 0 20 2 253 0 22]
#[0 2 254 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 2 174 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 0 158 0 11 0 20 0 22 0 59 0 80 0 82]
#[0 0 42 0 11 0 20 0 22 0 59 0 80]
#[0 0 90 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 11 0 13 0 15 0 16 0 17 0 20 0 22 0 24 0 27 0 29 0 30 0 34 0 35 0 59 0 80 0 82]
#[0 0 86 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 11 0 13 0 15 0 16 0 17 0 20 0 22 0 24 0 27 0 29 0 30 0 34 0 35 0 59 0 80 0 82]
#[0 0 82 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 11 0 13 0 15 0 16 0 17 0 20 0 22 0 24 0 27 0 29 0 30 0 34 0 35 0 59 0 80 0 82]
#[1 0 102 0 1 0 102 0 2 0 102 0 3 0 102 0 4 0 102 0 5 0 102 0 6 0 102 0 7 0 102 0 8 0 102 0 9 0 102 0 11 3 5 0 13 0 102 0 15 0 102 0 16 0 102 0 17 0 102 0 20 0 102 0 22 0 102 0 24 0 102 0 27 0 102 0 29 3 9 0 30 0 102 0 34 3 13 0 35 0 102 0 59 0 102 0 80 0 102 0 82]
#[1 0 98 0 1 0 98 0 2 0 98 0 3 0 98 0 4 0 98 0 5 0 98 0 6 0 98 0 7 0 98 0 8 0 98 0 9 0 98 0 11 3 5 0 13 0 98 0 15 0 98 0 16 0 98 0 17 0 98 0 20 0 98 0 22 0 98 0 24 0 98 0 27 0 98 0 29 3 9 0 30 0 98 0 34 3 13 0 35 0 98 0 59 0 98 0 80 0 98 0 82]
#[1 0 114 0 1 0 114 0 2 0 114 0 3 0 114 0 4 0 114 0 5 0 114 0 6 0 114 0 7 0 114 0 8 0 114 0 9 0 114 0 11 0 114 0 15 0 114 0 16 0 114 0 17 0 114 0 20 0 114 0 22 0 114 0 24 0 114 0 27 3 17 0 29 3 21 0 34 0 114 0 59 0 114 0 80 0 114 0 82]
#[1 0 110 0 1 0 110 0 2 0 110 0 3 0 110 0 4 0 110 0 5 0 110 0 6 0 110 0 7 0 110 0 8 0 110 0 9 0 110 0 11 0 110 0 15 0 110 0 16 0 110 0 17 0 110 0 20 0 110 0 22 0 110 0 24 0 110 0 27 3 17 0 29 3 21 0 34 0 110 0 59 0 110 0 80 0 110 0 82]
#[1 0 146 0 1 3 85 0 2 0 146 0 3 0 146 0 4 3 89 0 5 0 146 0 6 3 93 0 7 0 146 0 8 0 146 0 11 0 146 0 15 0 146 0 16 3 97 0 17 0 146 0 20 0 146 0 22 0 146 0 24 0 146 0 59 0 146 0 80 0 146 0 82]
#[1 0 150 0 1 3 85 0 2 0 150 0 3 0 150 0 4 3 89 0 5 0 150 0 6 3 93 0 7 0 150 0 8 0 150 0 11 0 150 0 15 0 150 0 16 3 97 0 17 0 150 0 20 0 150 0 22 0 150 0 24 0 150 0 59 0 150 0 80 0 150 0 82]
#[0 0 182 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[0 0 178 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[0 0 170 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[1 4 249 0 20 4 253 0 22]
#[0 0 46 0 20 0 22]
#[1 2 253 0 22 5 1 0 80]
#[1 0 198 0 4 0 198 0 6 3 105 0 8 0 198 0 11 0 198 0 15 0 198 0 16 0 198 0 20 0 198 0 22 0 198 0 59 0 198 0 80 0 198 0 82]
#[1 3 69 0 4 0 206 0 6 0 206 0 11 0 206 0 15 0 206 0 16 0 206 0 20 0 206 0 22 0 206 0 59 0 206 0 80 0 206 0 82]
#[1 3 73 0 6 0 214 0 11 0 214 0 15 0 214 0 16 0 214 0 20 0 214 0 22 0 214 0 59 0 214 0 80 0 214 0 82]
#[1 5 5 0 11 2 253 0 22]
#[1 1 162 0 1 1 162 0 2 1 162 0 3 1 162 0 4 1 162 0 5 1 162 0 6 1 162 0 7 1 162 0 8 3 25 0 9 1 162 0 11 1 162 0 15 1 162 0 16 1 162 0 17 1 162 0 20 1 162 0 22 1 162 0 24 3 29 0 27 1 162 0 59 1 162 0 80 1 162 0 82]
#[1 1 166 0 1 1 166 0 2 1 166 0 3 1 166 0 4 1 166 0 5 1 166 0 6 1 166 0 7 1 166 0 8 3 25 0 9 1 166 0 11 1 166 0 15 1 166 0 16 1 166 0 17 1 166 0 20 1 166 0 22 1 166 0 24 3 29 0 27 1 166 0 59 1 166 0 80 1 166 0 82]
#[1 1 158 0 1 1 158 0 2 1 158 0 3 1 158 0 4 1 158 0 5 1 158 0 6 1 158 0 7 1 158 0 8 3 25 0 9 1 158 0 11 1 158 0 15 1 158 0 16 1 158 0 17 1 158 0 20 1 158 0 22 1 158 0 24 3 29 0 27 1 158 0 59 1 158 0 80 1 158 0 82]
#[1 1 154 0 1 1 154 0 2 1 154 0 3 1 154 0 4 1 154 0 5 1 154 0 6 1 154 0 7 1 154 0 8 3 25 0 9 1 154 0 11 1 154 0 15 1 154 0 16 1 154 0 17 1 154 0 20 1 154 0 22 1 154 0 24 3 29 0 27 1 154 0 59 1 154 0 80 1 154 0 82]
#[1 3 37 0 1 3 41 0 3 1 210 0 4 1 210 0 6 1 210 0 8 1 210 0 11 1 210 0 15 1 210 0 16 1 210 0 20 1 210 0 22 1 210 0 24 1 210 0 59 1 210 0 80 1 210 0 82]
#[1 1 226 0 4 1 226 0 6 1 226 0 8 1 226 0 11 1 226 0 15 1 226 0 16 1 226 0 20 1 226 0 22 3 101 0 24 1 226 0 59 1 226 0 80 1 226 0 82]
#[0 2 198 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 59 0 60 0 62 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 131 0 146]
#[0 1 170 0 11 0 20 0 22 0 25 0 35 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 59 0 60 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 131]
#[0 2 6 0 22 0 59]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 2 77 0 100 5 9 0 102 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 3 145 0 11 0 9 0 25 0 13 0 35 0 93 0 76 3 149 0 110 5 13 0 122 0 133 0 125 0 137 0 126]
#[0 1 230 0 38 0 39 0 40 0 42 0 44 0 46 0 52 0 55 0 66 0 67 0 68 0 69 0 71 0 72 0 82 0 131]
#[0 2 150 0 20 0 22 0 25 0 79]
#[0 5 17 0 20]
#[0 5 21 0 20]
#[0 2 134 0 20 0 22 0 25 0 79]
#[0 5 25 0 80]
#[1 2 126 0 20 2 126 0 22 4 189 0 25 4 193 0 79]
#[1 5 29 0 20 0 17 0 38 0 21 0 39 0 25 0 40 0 29 0 42 0 33 0 44 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 60 0 53 0 62 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 2 45 0 103 0 105 0 106 0 109 0 107 0 113 0 108 0 121 0 112 0 125 0 114 0 129 0 115 5 33 0 127 2 57 0 130 0 141 0 131 2 61 0 132]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 5 37 0 80 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 2 77 0 100 5 41 0 102 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 2 86 0 20 0 22]
#[0 2 78 0 20]
#[0 2 102 0 20 0 22]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 2 105 0 81 5 45 0 82 1 149 0 84 1 153 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 2 109 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 5 49 0 149]
#[0 3 70 0 22 0 59 0 82]
#[0 0 10 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 80 0 82]
#[0 0 34 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 80 0 82]
#[0 2 178 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 5 53 0 20 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 5 57 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 5 61 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 5 65 0 142]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 5 69 0 142]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 5 73 0 142]
#[0 0 174 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 1 153 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 5 77 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 0 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 57 0 58 0 59 0 61 0 63 0 79 0 80 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 2 65 0 76 1 137 0 77 1 141 0 78 1 149 0 84 2 73 0 85 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 5 81 0 100 1 209 0 111 1 213 0 116 1 217 0 118]
#[0 2 10 0 22 0 59]
#[0 1 254 0 22 0 59]
#[0 2 154 0 20 0 22 0 25 0 79]
#[0 2 130 0 20 0 22 0 25 0 79]
#[0 2 138 0 20 0 22 0 25 0 79]
#[0 2 158 0 20 0 22 0 25 0 79]
#[0 5 85 0 20]
#[0 2 142 0 20 0 22 0 25 0 79]
#[0 5 89 0 80]
#[0 3 74 0 22 0 59 0 82]
#[0 2 170 0 22 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 5 93 0 142]
#[1 5 97 0 20 2 253 0 22]
#[1 5 101 0 20 2 253 0 22]
#[1 2 210 0 21 2 210 0 24 2 210 0 25 2 210 0 26 2 210 0 28 2 210 0 29 2 210 0 31 2 210 0 32 2 210 0 34 2 210 0 35 2 210 0 37 2 210 0 41 5 105 0 43 2 210 0 45 2 210 0 47 2 210 0 48 2 210 0 49 2 210 0 50 2 210 0 51 2 210 0 53 2 210 0 54 2 210 0 59 2 210 0 65 2 210 0 76 2 210 0 77 2 210 0 78 2 210 0 81 2 210 0 82]
#[0 2 222 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 2 218 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 0 50 0 20 0 22]
#[0 0 222 0 11 0 20 0 22 0 59 0 80 0 82]
#[0 2 162 0 20 0 22 0 25 0 79]
#[0 2 146 0 20 0 22 0 25 0 79]
#[0 2 230 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 5 109 0 142]
#[0 5 113 0 59]
#[1 1 45 0 21 1 49 0 24 1 53 0 25 1 57 0 26 1 61 0 28 1 65 0 29 1 69 0 31 1 73 0 32 1 77 0 34 1 81 0 35 1 85 0 37 1 89 0 41 1 93 0 45 1 97 0 47 1 101 0 48 1 105 0 49 1 109 0 50 1 113 0 51 1 117 0 53 1 121 0 54 1 125 0 59 1 129 0 65 1 133 0 76 1 137 0 77 1 141 0 78 0 209 0 81 1 149 0 84 1 153 0 85 1 157 0 86 1 161 0 88 1 165 0 90 1 169 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 99 1 205 0 100 1 209 0 111 1 213 0 116 1 217 0 118 1 221 0 136 1 225 0 137 1 229 0 138 1 233 0 139 1 237 0 140 1 241 0 141 5 117 0 142]
#[0 2 234 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 2 226 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
#[0 2 214 0 21 0 24 0 25 0 26 0 28 0 29 0 31 0 32 0 34 0 35 0 37 0 41 0 43 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 59 0 65 0 76 0 77 0 78 0 81 0 82]
)
! !

!CParser methodsFor:'public'!

addTypeName: aString 
	scanner addTypeName: aString
! !

!CParser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/smaCC/tests/CParser.st,v 1.5 2006/07/14 09:57:20 cg Exp $'
! !
