"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapService subclass:#SoapDocService
	instanceVariableNames:'resultTagName'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Server'
!


!SoapDocService methodsFor:'accessing'!

resultTagName
    ^ resultTagName
!

resultTagName:something
    resultTagName := something.
! !

!SoapDocService methodsFor:'envelope generation'!

wrapResult:aResultObject serviceHandler:aServiceHandler 
    |methodElem nsPref nsURI resultMethodElem encoder prefs|

    methodElem := aServiceHandler envelope body bodyEntries first.
    nsPref := methodElem prefixName.

    nsPref isNil ifTrue:[
        prefs := methodElem declaredNamespacePrefixes asArray.
        prefs isEmpty ifTrue:[self error:'missing declaredNamespacePrefix'].
        nsPref := prefs first.
    ].
    
    nsURI := methodElem declaredNamespaceURIFor:nsPref.

    encoder := aServiceHandler context encodingStyleURIs isEmpty ifFalse:[
                SoapEncoderFactory createFrom:aServiceHandler context encodingStyleURIs
            ] ifTrue:[
                SoapEncoderFactory createFrom:methodElem encodingStyleURIs
            ].
"/    aResultObject keysAndValuesDo:[:eachKey :eachValue|
"/        respElem := encoder 
"/                    encodeSoapVariable:(SoapVariable name:eachKey
"/                            value:eachValue).
"/        resultMethodElem addChild:respElem.
"/    ].

    resultMethodElem := encoder encodeSoapVariable:(SoapVariable name:(nsPref, ':', resultTagName) value:aResultObject).
    resultMethodElem declareNamespace:nsPref uri:nsURI.

    aServiceHandler envelope body clearBodyEntries.
    aServiceHandler envelope body addBodyEntry:resultMethodElem.
    ^ aServiceHandler envelope
! !

!SoapDocService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SOAP__SoapDocService.st,v 1.3 2007/09/11 16:50:32 stefan Exp $'
! !
