"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoExoboxXMLParserAdapter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-SoXML-ParserAdapter'
!


!SoExoboxXMLParserAdapter class methodsFor:'actions'!

attribDictFrom: aParsedXMLElement
	aParsedXMLElement isText ifTrue:[^Dictionary new].
	^aParsedXMLElement attributes
!

elementNameFrom: aParsedXMLElement
	"assuming Exobox"
	^aParsedXMLElement tag.
	
!

elementShortNameFrom: aParsedXMLElement
	^(SoXmlUtil prefixAndLocalNameFrom: (aParsedXMLElement tag)) last.
	
!

elementValueFrom: aParsedXMLElement
	| cData |
	cData := aParsedXMLElement charactersData.
	^cData isEmpty ifTrue: [nil] ifFalse: [cData]
	
	
!

elementsFrom: aParsedXMLElement
	
	^aParsedXMLElement contents.
!

elementsWithoutBlankTextsFrom: aParsedXMLElement
	aParsedXMLElement isText ifTrue:[^#()].
	^aParsedXMLElement contents reject: [:e | e isText and:[ SoPortableUtil isBlank: e text]].
!

elementsWithoutTextsFrom: aParsedXMLElement
	
	^aParsedXMLElement contents select: [:e | e isText not].
!

isTextElement: aParsedXMLElement
	^aParsedXMLElement isText
!

parseXml: xmlString
	"assuming Exobox"
	^(XMLReader fromString: xmlString) root
	
! !

!SoExoboxXMLParserAdapter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoExoboxXMLParserAdapter.st,v 1.3 2002/12/06 12:34:44 cg Exp $'
! !
