"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoPortableUtil
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-SoXML-Base'
!

SoPortableUtil comment:'An utility for providing adapter interfaces for various Smalltalk implementations. 

Currently I support Squeak only.

If you would like to use other Smalltalks, you should subclass me.


---
mu 5/3/2001 19:23'
!


!SoPortableUtil class methodsFor:'actions'!

isBlank: aString 
	"##ANSI ST specific##"
	^(aString allSatisfy: [:i | i isSeparator])
!

relativeURIFrom: aString 
	"Does this really work?"
	"##Squeak specific##"
	| uriStr colonIdx schemeName slashIdx |
	aString isEmpty ifTrue: [^aString].
	uriStr := aString last = $/
				ifTrue: [aString copyFrom: 1 to: aString size - 1]
				ifFalse: [aString].
	colonIdx := uriStr
				indexOf: $:
				ifAbsent: [^ uriStr].
	schemeName := aString copyFrom: 1 to: colonIdx - 1.
	(schemeName
			allSatisfy: [:each | each isLetter])
		ifTrue: [uriStr := uriStr copyFrom: colonIdx + 1 to: uriStr size].
	((uriStr at: 1)
				= $/
			and: [(uriStr at: 2)
					= $/])
		ifTrue: [uriStr := uriStr copyFrom: 2 to: uriStr size].
	slashIdx := uriStr findString: '/' startingAt: 2.
	slashIdx = 0
		ifFalse: [uriStr := uriStr copyFrom: slashIdx to: uriStr size].
	^ uriStr
!

stackTraceFrom:anError 
    |ctx s maxCount|

    maxCount := 300.

    ctx := anError suspendedContext.
    ctx isNil ifTrue:[
        ^ ''
    ].
    s := '' writeStream writeLimit:1000000.
    Error 
        handle:[:ex | 
            s reset.
            s nextPutAll:'error while writing context chain'
        ]
        do:[
            |c count|

            c := ctx.
            count := 0.
            [c notNil and:[ count <= maxCount]] whileTrue: [
                c printOn:s. s cr.
                c := c sender.
                count := count + 1.
            ].

"/            WriteError 
"/                handle:[:ex | 
"/                    s reset.
"/                    ctx printAllOn:s.
"/                ]
"/                do:[ ctx fullPrintAllOn:s. ].
        ].
    ^ s contents

    "Modified: / 08-08-2011 / 12:14:49 / sr"
!

substringsFrom: aString 
        "ToDo: Support other Smalltalks"
        "##Squeak specific##"
        aString isNil ifTrue: [^#()].
        ^ aString asCollectionOfWords
"/        ^ aString substrings
! !

!SoPortableUtil class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoPortableUtil.st,v 1.7 2011/08/08 10:16:05 sr Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoPortableUtil.st,v 1.7 2011/08/08 10:16:05 sr Exp $'
! !
