"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoConstants subclass:#SoXmlConstants
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-SoXML-Base'
!

SoXmlConstants comment:'XML Constants provider.

(I hate to use Pool)
---
mu 5/3/2001 19:22'
!


!SoXmlConstants class methodsFor:'URIs'!

xmldsigURI
    ^ self at: #xmldsigURI ifAbsentPutValue: 'http://www.w3.org/2000/09/xmldsig#'

    "
     self xmldsigURI
    "
!

xmldsigURI: aString
        ^self constDict at: #xmldsigURI put: aString
!

xmlnsURI
	^self at: #xmlnsURI ifAbsentPutValue: 'http://www.w3.org/2000/xmlns/'
!

xmlnsURI: aString
	^self constDict at: #xmlnsURI put: aString
!

xsdURI
	^self at: #xsdURI ifAbsentPutValue: 'http://www.w3.org/2001/XMLSchema'
!

xsdURI: aString 
	^self constDict at: #xsdURI put: aString
!

xsiURI
	^self at: #xsiURI ifAbsentPutValue: 'http://www.w3.org/2001/XMLSchema-instance'
!

xsiURI: aString
	^self constDict at: #xsiURI put: aString
! !

!SoXmlConstants class methodsFor:'attributes'!

xsiType
	"shortcut for performance"
	^self at: #xsiType ifAbsentPutValue: (self xsiPrefixColon, 'type')
! !

!SoXmlConstants class methodsFor:'canonicalizations'!

canonicalizationURL
    ^ self 
        at: #canonicalizationURL ifAbsentPutValue:'http://www.w3.org/TR/2000/CR-xml-c14n-20001026'

    "
     self constDict removeKey:#canonicalizationURL
     self canonicalizationURL
    "
!

canonicalizationWithCommentsURL
    ^ self 
        at: #canonicalizationWithCommentsURL ifAbsentPutValue:'http://www.w3.org/TR/2000/CR-xml-c14n-20001026#WithComments'.

    "
     self constDict removeKey:#canonicalizationWithCommentsURL
     self canonicalizationWithCommentsURL                     
    "
!

minimalCanonicalizationURL
    ^ self 
        at: #minimalCanonicalizationURL ifAbsentPutValue:'http://www.w3.org/2000/09/xmldsig#minimal'

    "
     self constDict removeKey:#minimalCanonicalizationURL
     self minimalCanonicalizationURL
    "
!

minimalCanonicalizationURL:aString
        ^self constDict at: #minimalCanonicalizationURL put: aString
! !

!SoXmlConstants class methodsFor:'prefixes'!

xmlnsPrefix
	^self at: #xmlnsPrefix ifAbsentPutValue: 'xmlns'
!

xmlnsPrefixColon
	^self withColon: self xmlnsPrefix
!

xsdPrefix
	^self at: #xsdPrefix ifAbsentPutValue: 'xsd'
!

xsdPrefixColon
	^self withColon: self xsdPrefix
!

xsiPrefix
	^self at: #xsiPrefix ifAbsentPutValue: 'xsi'
!

xsiPrefixColon
	^self withColon: self xsiPrefix
! !

!SoXmlConstants class methodsFor:'utility'!

withColon: aString
	| wStr |
	wStr := WriteStream on: (String new: aString size).
	wStr nextPutAll: aString.
	wStr nextPut: $:.
	^wStr contents.
! !

!SoXmlConstants class methodsFor:'xsd types'!

anyType
	^self at: #anyType ifAbsentPutValue: 'anyType'
!

base64
	^self at: #base64 ifAbsentPutValue: 'base64'
!

base64Binary
	^self at: #base64Binary ifAbsentPutValue: 'base64Binary'
!

float
	^self at: #float ifAbsentPutValue: 'float'
!

integer
	^self at: #integer ifAbsentPutValue: 'integer'
!

string
	^self at: #string ifAbsentPutValue: 'string'
!

time
	^self at: #time ifAbsentPutValue: 'time'
!

xsdAnyType
	^self at: #xsdAnyType ifAbsentPutValue: (self xsdPrefixColon, 'anyType')
!

xsdBase64BinaryType
	^self at: #xsdBase64Binary ifAbsentPutValue: (self xsdPrefixColon, 'base64Binary')
!

xsdFloatType
	^self at: #xsdFloatType ifAbsentPutValue: (self xsdPrefixColon, 'float')
!

xsdIntegerType
	^self at: #xsdIntegerType ifAbsentPutValue: (self xsdPrefixColon, 'integer')
!

xsdStringType
	^self at: #xsdStringType ifAbsentPutValue: (self xsdPrefixColon, 'string')
!

xsdTimeType
	^self at: #xsdTime ifAbsentPutValue: (self xsdPrefixColon, 'time')
! !

!SoXmlConstants class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoXmlConstants.st,v 1.4 2003/01/15 21:35:45 cg Exp $'
! !
