"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoYaxXMLParserAdapter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-SoXML-ParserAdapter'
!


!SoYaxXMLParserAdapter class methodsFor:'actions'!

attribDictFrom: aParsedXMLElement
	aParsedXMLElement isText ifTrue:[^Dictionary new].
	^aParsedXMLElement attributes
!

elementNameFrom: aParsedXMLElement
	"assuming Yax"
	^aParsedXMLElement tag.
	
!

elementShortNameFrom: aParsedXMLElement
	"assuming Yax"
	^(SoXmlUtil prefixAndLocalNameFrom: (aParsedXMLElement tag)) last.
	
!

elementValueFrom: aParsedXMLElement
	"assuming Yax"
	| cData |
	cData := aParsedXMLElement characterData.
	^cData isEmpty ifTrue: [nil] ifFalse: [cData]
	
	
!

elementsFrom: aParsedXMLElement 
	"assuming Yax"
	^ (aParsedXMLElement entities
		collect: [:assoc | assoc value])
		, aParsedXMLElement contents
!

elementsWithoutBlankTextsFrom: aParsedXMLElement 
	"assuming Yax"
	^aParsedXMLElement entities notEmpty
		ifTrue: [aParsedXMLElement entities
				collect: [:assoc | assoc value]]
		ifFalse: [aParsedXMLElement contents notEmpty
				ifTrue: [aParsedXMLElement contents
						reject: [:each | SoPortableUtil isBlank: each characterData]] ifFalse:[#()]].
	
!

elementsWithoutTextsFrom: aParsedXMLElement
	"assuming Yax"
	^ aParsedXMLElement entities notEmpty
		ifTrue: [aParsedXMLElement entities
				collect: [:assoc | assoc value]]
		ifFalse: [aParsedXMLElement contents notEmpty
				ifTrue: [aParsedXMLElement contents] ifFalse:[#()]] 
!

isTextElement: aParsedXMLElement 
	"assuming Yax"
	^ aParsedXMLElement isText
!

parseXml: xmlString
        "assuming Yax"
        ^(YAXO::XMLDOMParser parseDocumentFrom: (ReadStream on: xmlString)) topElement
! !

!SoYaxXMLParserAdapter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoYaxXMLParserAdapter.st,v 1.4 2003/01/13 10:57:03 cg Exp $'
! !
