"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapAbstractConnector
	instanceVariableNames:'envelopeBuilder'
	classVariableNames:'ShowLog'
	poolDictionaries:''
	category:'SOAP-Transport'
!

SoapAbstractConnector class instanceVariableNames:'connectorMap'

"
 No other class instance variables are inherited by this class.
"
!


!SoapAbstractConnector class methodsFor:'class initialization'!

initialize
        "SoapAbstractConnector initialize"
        ShowLog := false.

        self initializeAfterLoad
!

initializeAfterLoad
        self == SoapAbstractConnector
        "self name == #SoapAbstractConnector"
                ifFalse: [SoapTransportMap connectorAt: self transportName asSymbol put: self]
!

initializeAll
        "SoapAbstractConnector initializeAll"

        self subclassesDo: [:each | each initialize]
!

obsolete
        self == SoapAbstractConnector
        "self name == #SoapAbstractConnector"
                ifFalse: [SoapTransportMap removeConnectorAt: self transportName asSymbol].
        super obsolete
! !

!SoapAbstractConnector class methodsFor:'constants'!

transportName
        ^#noName
! !

!SoapAbstractConnector class methodsFor:'setting'!

showLog
	^ShowLog
!

showLog: aBoolean
	ShowLog := aBoolean
! !

!SoapAbstractConnector methodsFor:'accessing'!

envelopeBuilder
        envelopeBuilder isNil ifTrue: [envelopeBuilder := SoapEnvelopeBuilder new].
        ^envelopeBuilder
!

envelopeBuilder: aSoapEnvelopeBuilder
        envelopeBuilder := aSoapEnvelopeBuilder
! !

!SoapAbstractConnector methodsFor:'actions'!

debugReturn: aSoapMessage 

        self class showLog
                ifTrue: [
                        | envelope context |
                        envelope := aSoapMessage envelope.
                        context := aSoapMessage context.
                        Transcript cr; cr; show: '##'; show: super printString;
                                                show: ' Client:Return:{'; cr; show: envelope printString; cr; show: '}'.
                        Transcript cr; show: '-> with ->'.
                        Transcript cr; show: context printString]
!

debugSend: aSoapEnvelope to: anSoapLocatorObject with: aSoapContext
	
	self class showLog 
		ifTrue: [Transcript cr; show: '##', super printString, ' Client:Request:{'.
			Transcript cr; show: aSoapEnvelope printString.
			Transcript cr; show: '} to ->'.
			Transcript cr; show: anSoapLocatorObject printString.
			Transcript cr; show: '-> with ->'.
			Transcript cr; show: aSoapContext printString].
!

send: aSoapEnvelope to: anSoapLocatorObject with: aSoapContext
	"1. add an addittinal protocolSpecific header to aSoapEnvelope"
	"2. send a SoapMessage to a remote server"
	"3. get the result and unmarshall it"
	"4. return aSoapMessage or nil"
	
	^self subclassResponsibility
! !

!SoapAbstractConnector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapAbstractConnector.st,v 1.4 2003/01/10 13:57:25 cg Exp $'
! !

SoapAbstractConnector initialize!
