"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapDataBinder subclass:#SoapAbstractDecoder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Decoding'
!


!SoapAbstractDecoder class methodsFor:'class initialization'!

initTypeDict
        "Apparently this mapping is not so sophisticted. "
        "##TODO: Implement more serious mapping method "
        | pref |
        typeDict := super initTypeDict.
        pref := SoapConstants xsdPrefixColon.
        #(
        #(#any #String)
        #(#anyType #String)
        #(#time #String)
        #(#boolean #Boolean)
        #(#float #Float)
        #(#double #Double)
        #(#integer #Integer)
        #(#int #Integer)
        #(#string #String)
        #(#arrayType #Array)
        ) do:[:each | typeDict at: (pref, each first) asSymbol put: each last].
        Smalltalk isSmalltalkX ifTrue:[
            typeDict at: (pref, #positiveInteger) asSymbol put: #LargeInteger.
            typeDict at: (pref, #negativeInteger) asSymbol put: #LargeInteger.
        ] ifFalse:[
            typeDict at: (pref, #positiveInteger) asSymbol put: #LargePositiveInteger.
            typeDict at: (pref, #negativeInteger) asSymbol put: #LargeNegativeInteger.
        ].
        ^typeDict

        "
         self initTypeDict
        "

    "Modified: / 02-08-2007 / 16:25:43 / cg"
!

initialize
	self initTypeDict

	"self initialize"
! !

!SoapAbstractDecoder methodsFor:'actions'!

decodeXmlElement: aSoapWrapElement
	self subclassResponsibility
! !

!SoapAbstractDecoder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapAbstractDecoder.st,v 1.5 2007/08/18 14:53:47 cg Exp $'
! !

SoapAbstractDecoder initialize!
