"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapDataBinder subclass:#SoapAbstractEncoder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Encoding'
!


!SoapAbstractEncoder class methodsFor:'class initialization'!

initTypeDict
        "Apparently this mapping is not so sophisticted. "
        "##TODO: Implement more serious mapping method "
        | pref |
        typeDict := super initTypeDict.
        pref := SoapConstants xsdPrefixColon.
        #(
            #(#Boolean #boolean)
            #(#Float #float)
            #(#Double #double)
            #(#Integer #integer)
            #(#SmallInteger #integer)
            #(#LargePositiveInteger #positiveInteger)
            #(#LargeNegativeInteger #negativeInteger)
            #(#String #string)
        ) do:[:each | typeDict at: each first put: (pref, each last)].

        Smalltalk isSmalltalkX ifTrue:[
            #(
                #(#LargeInteger #integer)
            ) do:[:each | typeDict at: each first put: (pref, each last)].
        ] ifFalse:[
            #(
                #(#LargePositiveInteger #positiveInteger)
                #(#LargeNegativeInteger #negativeInteger)
            ) do:[:each | typeDict at: each first put: (pref, each last)].
        ].
        ^typeDict
!

initialize
	super initialize

	"self initialize"
! !

!SoapAbstractEncoder methodsFor:'actions'!

encodeSoapVariable: aSoapVariable
	self subclassResponsibility
! !

!SoapAbstractEncoder methodsFor:'factory'!

xmlElementClass
	^SoapWrapElement
! !

!SoapAbstractEncoder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapAbstractEncoder.st,v 1.4 2010/03/15 22:46:53 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapAbstractEncoder.st,v 1.4 2010/03/15 22:46:53 cg Exp $'
! !

SoapAbstractEncoder initialize!
