"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapElement subclass:#SoapBody
	instanceVariableNames:'fault bodyEntries'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Elements'
!

SoapBody comment:'SOAP Body element.


---
mu 5/21/2001 22:24'
!


!SoapBody class methodsFor:'instance creation'!

fromXmlElement: anXmlWrapElement 
        | inst faultElem |
        inst := self named: anXmlWrapElement name.
        self addAttributesOf: anXmlWrapElement to: inst.
        faultElem := anXmlWrapElement findChildLocalNamed: SoapFault localName.
        faultElem isNil
                ifTrue: [anXmlWrapElement children
                                do: [:each | inst addBodyEntry: each]]
                ifFalse: [inst
                                fault: (SoapFault fromXmlElement: faultElem)].
        ^ inst
! !

!SoapBody class methodsFor:'constants'!

localName
	^'Body'
! !

!SoapBody methodsFor:'actions'!

addBodyEntry: anXmlElement
	"anXmlElement mustUnderstand:
		#printXmlOn:aStream
		#parent: anXmlElement"
	anXmlElement parent: self.
	^self bodyEntries add: anXmlElement.
!

addFault
	| fa |
	fa := SoapFault new.
	fa parent: self.
	self fault: fa.
	^fa
!

clearBodyEntries
	self bodyEntries
		do: [:each | each parent: nil].
	self bodyEntries: nil
!

findBodyEntriesNamed: anElemName
	^self bodyEntries select: [:each | each name = anElemName]
!

findBodyEntryNamed: anElemName
	^self bodyEntries detect: [:each | each name = anElemName] ifNone:[]
!

isMustUnderstandEnabled
	self parent isNil
		ifTrue: [^ true].
	^ self parent hasHeader
		ifTrue: [self parent header isMustUnderstandEnabled]
		ifFalse: [true]
! !

!SoapBody methodsFor:'elements'!

bodyEntries
	bodyEntries isNil ifTrue: [bodyEntries := OrderedCollection new].
	^bodyEntries
!

bodyEntries: aCollectionOfXmlElement
	bodyEntries := aCollectionOfXmlElement
!

fault
	^ fault
!

fault: aSoapFault
	fault := aSoapFault.
	aSoapFault parent: self
! !

!SoapBody methodsFor:'private-printing'!

privPrintCanonicalChildrenOn: aStream 
        fault isNil
                ifFalse: [self fault printCanonicalXmlOn: aStream].
        bodyEntries isNil
                ifFalse: [self bodyEntries
                                do: [:each | each printCanonicalXmlOn: aStream]].
        super privPrintCanonicalChildrenOn: aStream 
!

privPrintChildrenOn: aStream indent: level 
	fault isNil
		ifFalse: [self fault printXmlOn: aStream indent: level].
	bodyEntries isNil
		ifFalse: [self bodyEntries
				do: [:each | each printXmlOn: aStream indent: level]].
	super privPrintChildrenOn: aStream indent: level
! !

!SoapBody methodsFor:'testing'!

hasFault
	^self fault notNil
!

isBody
	^false
! !

!SoapBody class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapBody.st,v 1.5 2003/01/21 18:03:40 cg Exp $'
! !
