"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapCallEntry
	instanceVariableNames:'locator'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-RPC'
!

SoapCallEntry class instanceVariableNames:'defaultSendingPort defaultLocalSendingPort'

"
 No other class instance variables are inherited by this class.
"
!

SoapCallEntry comment:'I represent a SOAP RPC access point.

---
MU 5/12/2002 00:47'
!


!SoapCallEntry class methodsFor:'instance creation'!

local
        ^self tcpHost: 'localhost' port: self defaultLocalSendingPort
!

local: portNumberInteger
        ^ self new
                locator: (SoapTcpLocator host: 'localhost' port: portNumberInteger)
!

tcpHost: hostnameString
        ^self tcpHost: hostnameString port: self defaultSendingPort "8823"
!

tcpHost: hostnameString port: portNumberInteger
	"In many cases, these values are used for setting router server URI" 
	^ self new
		locator: (SoapTcpLocator host: hostnameString port: portNumberInteger)
! !

!SoapCallEntry class methodsFor:'accessing'!

defaultLocalSendingPort
        ^defaultLocalSendingPort ? SoapHttpSetup "HTTPServer" defaultPort
!

defaultLocalSendingPort: portNumber
        defaultLocalSendingPort := portNumber
!

defaultSendingPort
        ^defaultSendingPort ? 8823
!

defaultSendingPort: portNumber
        defaultSendingPort := portNumber
! !

!SoapCallEntry class methodsFor:'class initialization'!

initialize
        "/ defaultLocalSendingPort := HTTPServer defaultPort.
        defaultSendingPort := 8823.
        "/ defaultSendingPort := 8080.

        "
         defaultLocalSendingPort := nil.

         SoapCallEntry initialize
        "
! !

!SoapCallEntry methodsFor:'accessing'!

locator

	^locator
!

locator: aValue

	locator := aValue
! !

!SoapCallEntry methodsFor:'actions'!

newCall
	^SoapCall locator: (self locator)
!

newSignedCall
        ^SoapSignedCall locator: (self locator)
! !

!SoapCallEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapCallEntry.st,v 1.8 2003/09/19 16:15:13 cg Exp $'
! !

SoapCallEntry initialize!
