"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoXmlConstants subclass:#SoapConstants
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Base'
!

SoapConstants comment:'SOAP Constants provider.

(I hate to use Pool)
---
mu 5/3/2001 19:32'
!


!SoapConstants class methodsFor:'URIs'!

canonicalizationMethodURI
    ^self at: #canonicalizationMethodURI ifAbsentPutValue:'http://www.w3.org/TR/2000/CR-xml-c14n-20001026' 
!

soapActorNextURI
	^self at: #soapActorNextURI ifAbsentPutValue:'http://schemas.xmlsoap.org/soap/actor/next' 
!

soapDsigURI
        ^self at: #soapDsigURI ifAbsentPutValue:'http://www.w3.org/2000/09/xmldsig#' 
!

soapEncURI

        "this is for soap version 1.2 working draft"
"/        ^ self at: #soapEncURI ifAbsentPutValue:'http://www.w3.org/2001/12/soap-encoding'.

        "This is soap version for 1.1:"
        ^ self at: #soapEncURI ifAbsentPutValue:'http://schemas.xmlsoap.org/soap/encoding/'.

"
        self constDict at: #soapEncURI put:'http://schemas.xmlsoap.org/soap/encoding/' 
"
!

soapEnvURI
	^self at: #soapEnvURI ifAbsentPutValue:'http://schemas.xmlsoap.org/soap/envelope/' 
!

soapSTXEncURI
        "non standard ST/X specific encoding - CG"
        ^ self at: #soapSTXEncURI ifAbsentPutValue: 'http://www.exept.de/SmalltalkX/encoding/'
!

soapSecURI
        ^self at: #soapSecURI ifAbsentPutValue:'http://schemas.xmlsoap.org/soap/security/2000-12' 
!

soapSixxEncURI
        "sixx encoding - MU"
        ^ self at: #soapSixxEncURI ifAbsentPutValue: 'http://www.mars.dti.ne.jp/~umejava/smalltalk/sixx/encoding/'
!

soapSqEncURI
	"non standard squeak specific encoding - MU"
	^ self at: #soapSqEncURI ifAbsentPutValue: 'http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/encoding/'
!

soapSrpEncURI
        "non standard squeak specific encoding - MU"
        ^ self at: #soapSrpEncURI ifAbsentPutValue: 'http://wiki.cs.uiuc.edu/CampSmalltalk/SRP/encoding/'
! !

!SoapConstants class methodsFor:'attributes'!

actor
	^self at: #actor ifAbsentPutValue:'actor' 
  
!

arrayType
	
	^self at: #arrayType ifAbsentPutValue: (self soapEncPrefixColon, 'arrayType')
!

encodingStyle
	^self at: #encodingStyle ifAbsentPutValue:'encodingStyle' 
  
!

xsiNil
	"shortcut for performance"
	"xsi:null is Soap1.1"
	"xsi:nil is Soap1.2"
	^self at: #xsiNil ifAbsentPutValue: (self xsiPrefixColon, 'nil')
!

xsiNull
        "shortcut for performance"
        "xsi:null is Soap1.1"
        "xsi:nil is Soap1.2"
        ^self at: #xsiNull ifAbsentPutValue: (self xsiPrefixColon, 'null')
! !

!SoapConstants class methodsFor:'class initialization'!

postAutoload
    self projectDefinitionClass loadExtensions

    "
     self postAutoload
    "
! !

!SoapConstants class methodsFor:'fault codes'!

client
	^self at: #client ifAbsentPutValue:'Client' 
!

mustUnderstand
	^self at: #mustUnderstand ifAbsentPutValue:'MustUnderstand' 

!

mustUnderstandAttribute
        ^self at: #mustUnderstandAttribute ifAbsentPutValue:'mustUnderstand' 
!

server
	^self at: #server ifAbsentPutValue:'Server' 
!

versionMismatch
	^self at: #versionMismatch ifAbsentPutValue:'VersionMismatch' 
! !

!SoapConstants class methodsFor:'prefixes'!

soapDsPrefix
        ^self at: #soapDsPrefix ifAbsentPutValue:'ds' 
!

soapEncPrefix
	^self at: #soapEncPrefix ifAbsentPutValue:'enc' 
!

soapEncPrefixColon
	^self withColon: self soapEncPrefix
!

soapEnvPrefix
	^self at: #soapEnvPrefix ifAbsentPutValue:'env' 
!

soapEnvPrefixColon
	^self withColon: self soapEnvPrefix
!

soapSecPrefix
        ^self at: #soapSecPrefix ifAbsentPutValue:'sec' 
!

soapSecPrefixColon
        ^self withColon: self soapSecPrefix
!

sqEncPrefix
	^self at: #sqEncPrefix ifAbsentPutValue:'Squeak-ENC' 
!

sqEncPrefixColon
	^self withColon: self sqEncPrefix
!

stxEncPrefix
        ^self at: #stxEncPrefix ifAbsentPutValue:'SmalltalkX-ENC' 
!

stxEncPrefixColon
        ^self withColon: self stxEncPrefix
! !

!SoapConstants class methodsFor:'rpc'!

returnValueAccessor
	^self at: #returnValueAccessor ifAbsentPutValue:'result' 
! !

!SoapConstants class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapConstants.st,v 1.14 2010/12/22 13:15:55 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapConstants.st,v 1.14 2010/12/22 13:15:55 stefan Exp $'
! !
