"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapContext
	instanceVariableNames:'propDict'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-RPC'
!


!SoapContext methodsFor:'accessing'!

propDict
	propDict isNil ifTrue: [propDict := IdentityDictionary new].
	^propDict
!

propDict: aValue

	propDict := aValue
! !

!SoapContext methodsFor:'actions'!

encodingStyleURIs
	^self at: #encodingStyleURIs ifAbsent:[#()]
!

encodingStyleURIs: anArrayOfEncodingStyleURI
	self at: #encodingStyleURIs put: anArrayOfEncodingStyleURI
!

httpRequest
        ^ self at: #httpRequest
!

httpRequest: aHttpRequest
        self at: #httpRequest put: aHttpRequest.
!

keyInfo
        ^self at: #keyInfo ifAbsent:nil
!

keyInfo: aKeyInfo
        self at: #keyInfo put: aKeyInfo
!

soapAction
	^self at: #soapAction ifAbsent:[SoapAction intentByRequestURI]
!

soapAction: aSoapAction
	self at: #soapAction put: aSoapAction
!

targetObjectURI
	^self at: #targetObjectURI ifAbsent:['']
!

targetObjectURI: aString
	self at: #targetObjectURI put: (SoPortableUtil relativeURIFrom: aString).
! !

!SoapContext methodsFor:'actions-basic'!

at: aSymbol
	^self propDict at: aSymbol
!

at: aSymbol ifAbsent: aBlock
	^self propDict at: aSymbol ifAbsent: aBlock
!

at: aSymbol put: anObject
	^self propDict at: aSymbol put: anObject
! !

!SoapContext methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPut: ${.
	self propDict keysAndValuesDo:[:k :v | aStream print: k; nextPutAll: '->'; print: v; space].
	aStream nextPut: $}.
! !

!SoapContext class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapContext.st,v 1.4 2006/08/15 11:29:55 stefan Exp $'
! !
