"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapDataBindingFactory
	instanceVariableNames:''
	classVariableNames:'DataBindingDict'
	poolDictionaries:''
	category:'SOAP-DataBinding'
!

SoapDataBindingFactory class instanceVariableNames:'dataBindingDict'

"
 No other class instance variables are inherited by this class.
"
!


!SoapDataBindingFactory class methodsFor:'accessing'!

dataBindingDict
	dataBindingDict isNil
		ifTrue: [dataBindingDict := Dictionary new.
			self initDataBindingDict].
	^ dataBindingDict
!

uriEncoderDict
	^UriEncoderDict
! !

!SoapDataBindingFactory class methodsFor:'accessing-error'!

noSuchDataBinder
	^SoapNoSuchDataBinder
	
! !

!SoapDataBindingFactory class methodsFor:'actions'!

createFrom: anArrayOfEncodingStyleURI 
	| uriArr key |
	anArrayOfEncodingStyleURI size > 1
		ifTrue: [self noSuchDataBinder signal: 'Currently multi encodingStyleURI is not supported'].
	uriArr := (anArrayOfEncodingStyleURI isNil
					or: [anArrayOfEncodingStyleURI isEmpty])
				ifTrue: [self defaultEncodingStyleURIs.]
				ifFalse: [anArrayOfEncodingStyleURI].
	key := uriArr first.	"##TODO: to support multi encoders"
	^ (self dataBindingDict
		at: key
		ifAbsent: [self noSuchDataBinder signal: key]) new
! !

!SoapDataBindingFactory class methodsFor:'class initialization'!

initialize
	"SoapDataBindingFactory initialize"
	dataBindingDict := nil
!

initializeAll
	"SoapDataBindingFactory initializeAll"
	self allSubclassesDo:[:each | each initialize]
! !

!SoapDataBindingFactory class methodsFor:'default values'!

defaultEncodingStyleURIs
	^Array with: SoapConstants soapEncURI
!

initDataBindingDict
	"Default do nothing"
	
! !

!SoapDataBindingFactory class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapDataBindingFactory.st,v 1.2 2002/11/08 09:30:21 cg Exp $'
! !

SoapDataBindingFactory initialize!
