"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapWrapElement subclass:#SoapEncArray
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Encoding'
!


!SoapEncArray class methodsFor:'instance creation'!

fromArray: anArray
    <resource: #obsolete>
	^self fromArray: anArray named: 'Array'
	
!

fromArray: anArray named: elemName
    <resource: #obsolete>
	^self fromArray: anArray named: elemName elementType: (SoapConstants xsdAnyType)
	
!

fromArray: anArray named: elemName elementType: anXSDType
    <resource: #obsolete>
 
        | inst encPrefix lastValidElementIndex|

        "/ no longer use this - yout loose the encoders (caller) type if you do
        "/ code has been moved into the caller, so receiver specific redefinitions
        "/ are not lost
        self obsoleteMethodWarning.  

        encPrefix := SoapConstants soapEncPrefix.
        inst := self named: elemName.
        inst declareNamespace: encPrefix uri: SoapConstants soapEncURI.
        inst declareXsdNamespace.
        inst declareXsiNamespace.
        inst putAttributeNamed: SoapConstants arrayType value: anXSDType , '[' , anArray size printString , ']'.

        #isSmalltalkX.
        lastValidElementIndex := anArray findLast:[:el |el notNil].
        anArray keysAndValuesDo:[:idx :each | 
            | child |
            idx <= lastValidElementIndex ifTrue:[
                "/ CG: this is wrong; nil elements must be transmitted,
                "/ except for the trailing ones...
                "/ (each isNil or: [each == #nil]) ifFalse: [
                    child := (SoapVariable name: 'item' value: each) asXmlElement.
                    inst addChild: child.
                "/ ]
            ]
        ].
        ^ inst
! !

!SoapEncArray methodsFor:'actions'!

trimForNested
	self beShortName.
	self undeclareNamespaces.
	self trimElementTypeAttributePrefix
! !

!SoapEncArray methodsFor:'private'!

trimElementTypeAttributePrefix
	self attributesHolder trimAttributePrefixNamed: SoapConstants arrayType
! !

!SoapEncArray methodsFor:'testing'!

isArrayType
	"for performance"
	^true
	
! !

!SoapEncArray class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapEncArray.st,v 1.3 2007/10/25 15:09:13 mb Exp $'
! !
