"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapEncodable
	instanceVariableNames:'encodingStyleURIs encoder parent'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-RPC'
!


!SoapEncodable methodsFor:'accessing'!

encoder
	encoder isNil
		ifTrue: [encoder := parent isNil
						ifTrue: [SoapEncoderFactory createFrom: self encodingStyleURIs]
						ifFalse: [parent encoder]].
	^ encoder
!

encoder: aValue

	encoder := aValue
!

encodingStyleURIs
	encodingStyleURIs isNil ifTrue:[ encodingStyleURIs := Array with: SoapConstants soapEncURI].
	^encodingStyleURIs
!

encodingStyleURIs: aValue

	encodingStyleURIs := aValue
!

parent

	^parent
!

parent: aValue

	parent := aValue
! !

!SoapEncodable methodsFor:'actions'!

encoding: aSymbol
	self encodingStyleURI: (SoapEncodingStyleURIMap at: aSymbol).
	self encoder: (SoapEncoderFactory createFrom: self encodingStyleURIs).  
!

encodingStyleURI: aURIString
	self encodingStyleURIs: (Array with: aURIString)
!

encodingStyleURIString
        | uris wStr |
        uris := self encodingStyleURIs.
        uris size = 1 ifTrue: [^ uris first].

        wStr := WriteStream
                                on: (String new: 64).
        uris do: [:each | wStr 
                            nextPutAll: each;
                            nextPut: Character space].
        ^ wStr contents
!

encodingStyleURIString: anEncodingStyleURI 
	self
		encodingStyleURIs: (SoPortableUtil substringsFrom: anEncodingStyleURI)
! !

!SoapEncodable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapEncodable.st,v 1.3 2003/01/15 21:34:20 cg Exp $'
! !
