"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapEnvelopeBuilder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Base'
!


!SoapEnvelopeBuilder methodsFor:'actions'!

buildClientSoapFaultEnvelope: anError 
        | env fault builder |
        env := SoapEnvelope new.
        fault := env addBody addFault beClient "client".
        builder := SoapFaultDetailBuilder new.
        builder buildSoapFaultDetailOn: fault from: anError.
        ^ env
!

buildServerSoapFaultEnvelope: anError 
        | env fault builder |
        env := SoapEnvelope new.
        fault := env addBody addFault beServer "server".
        builder := SoapFaultDetailBuilder new.
        builder buildSoapFaultDetailOn: fault from: anError.
        ^ env
!

buildSoapEnvelopeFromXmlString: anXmlString 
        [| elem envelope | 
        elem := SoapWrapElement fromXml: anXmlString.
        envelope :=  SoapEnvelope fromXmlElement: elem.
        envelope declareTypicalNamespaces.
        ^envelope]
                on: Error
                do: [:ex |
                    UserPreferences current soapErrorDebugging ifTrue:[ex reject].
                    self breakPoint:#cg info:('envelope-exception:' , ex description). 
                    ^ self buildServerSoapFaultEnvelope: ex]

    "Modified: / 12-07-2011 / 17:44:40 / cg"
! !

!SoapEnvelopeBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapEnvelopeBuilder.st,v 1.8 2011/07/12 16:22:55 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapEnvelopeBuilder.st,v 1.8 2011/07/12 16:22:55 cg Exp $'
! !
