"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Error subclass:#SoapError
	instanceVariableNames:'faultcode faultstring detail'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Base'
!

SoapError comment:'SOAP Abstract Error class
---
mu 5/21/2001 22:30'
!


!SoapError class methodsFor:'instance creation'!

faultcode: aFaultCodeSymbol
	^self new faultcode: aFaultCodeSymbol
!

fromSoapFault: aSoapFault
	| inst |
	inst := self faultcode: aSoapFault faultcode.
	inst faultstring: aSoapFault faultstring.
	inst detail: aSoapFault detail.
	^inst 
! !

!SoapError class methodsFor:'defaults'!

client
	^self faultcode: #Client
!

mustUnderstand
	^self faultcode: #MustUnderstand
!

server
	^self faultcode: #Server
!

versionMismatch
	^self faultcode: #VersionMismatch
! !

!SoapError methodsFor:'accessing'!

detail
	^detail
!

detail: aValue
	detail :=  aValue
!

faultCode
self halt.
	"/ ^faultCode
!

faultCode: aValue
self halt.
	"/ faultCode := aValue
!

faultcode
	^faultcode
!

faultcode: aValue
	faultcode := aValue
!

faultstring
	^faultstring
!

faultstring: aValue
	faultstring := aValue
! !

!SoapError methodsFor:'exceptionDescription'!

description
	| desc |
	desc := super description.
	self faultcode isNil ifFalse: [desc := desc, ':', self faultcode].
	self faultstring isNil ifFalse: [desc := desc, '#', self faultstring].
	^desc
!

isResumable
        
	^ true
! !

!SoapError class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapError.st,v 1.4 2003/01/20 18:05:26 cg Exp $'
! !
