"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapExceptionBuilder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-RPC'
!


!SoapExceptionBuilder methodsFor:'actions'!

buildExceptionFrom: aSoapFault 
        | exceptionClass exception exceptionDetail 
          errorClassTag exceptionClassName exceptionClassNameSymbol messageTextPrefix messageText | 

        aSoapFault detail isNil
                ifTrue: [exception := SoapError fromSoapFault: aSoapFault]
                ifFalse: [
                        exceptionDetail := aSoapFault detail subElements first.
                        errorClassTag := exceptionDetail findChildNamed: 'ErrorClass'.
                        exceptionClassName := errorClassTag isNil
                                                ifTrue: ['Error']
                                                ifFalse: [errorClassTag value].

                        exceptionClassNameSymbol := exceptionClassName asSymbol.
                        exceptionClass := Smalltalk at:exceptionClassNameSymbol ifAbsent: nil.
                        exceptionClass isNil ifTrue:[
                            Smalltalk isSmalltalkX ifTrue:[
                                exceptionClass := SOAP at:exceptionClassNameSymbol ifAbsent: nil.
                                exceptionClass isNil ifTrue:[
                                    exceptionClass := XML at:exceptionClassNameSymbol ifAbsent: nil.
                                ]
                            ]
                        ].
                        messageTextPrefix := ''.

                        exceptionClass isNil ifTrue:[
                            Smalltalk isSmalltalkX ifTrue:[
                                exception := SoapNoSuchExceptionClass new.
                                messageTextPrefix := exceptionClassName, ': ' .
                            ] ifFalse:[
                                exception := SoapNoSuchExceptionClass signal:exceptionClassName.
                            ].
                        ] ifFalse:[
                            exception := exceptionClass new
                        ].
                        messageText := exceptionDetail findChildNamed: 'messageText'.
                        messageText := messageText isNil 
                                            ifTrue:[messageText := aSoapFault faultstring]
                                            ifFalse: [messageText value].
                        exception messageText: (messageTextPrefix , messageText).
                        Smalltalk isSmalltalkX ifTrue:[
                            #cg. "/  easier to debug & catch
                            ^ SoapRemoteError new 
                                parameter:exception;
                                messageText:(exception messageText).
                        ]
                ].
"/        exception tag: '<<signaled in server>>'.
        "Should I use tag?"
        ^ exception

    "Modified: / 23-07-2007 / 17:11:43 / cg"
! !

!SoapExceptionBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapExceptionBuilder.st,v 1.6 2007/07/23 16:06:41 cg Exp $'
! !
