"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapFaultDetailBuilder
	instanceVariableNames:''
	classVariableNames:'DefaultNamespace DefaultPrefix'
	poolDictionaries:''
	category:'SOAP-Base'
!


!SoapFaultDetailBuilder class methodsFor:'accessing'!

defaultNamespace
	DefaultNamespace isNil
		ifTrue: [DefaultNamespace := 'http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/error/'].
	^ DefaultNamespace
!

defaultNamespace: aString
	DefaultNamespace := aString
!

defaultPrefix
	DefaultPrefix isNil
		ifTrue: [DefaultPrefix := 'e'].
	^ DefaultPrefix
!

defaultPrefix: aString
	DefaultPrefix := aString
! !

!SoapFaultDetailBuilder class methodsFor:'class initialization'!

initialize
	"SoapFaultDetailBuilder initialize"
	DefaultPrefix := DefaultNamespace := nil
! !

!SoapFaultDetailBuilder methodsFor:'actions'!

buildSoapFaultDetailOn: aSoapFault from: anError 
        | errorPrefix details stErrorClass isResumable messageText stack detail |
        aSoapFault faultstring: anError description.
        errorPrefix := self class defaultPrefix.
        details := SoapWrapElement named: 'details' withPrefix: errorPrefix.
        details declareNamespace: errorPrefix uri: self class defaultNamespace.
        stErrorClass := details createChildNamed: 'ErrorClass'.
        Smalltalk isSmalltalkX ifTrue:[
            ((Array with:SOAP with:XML) includes:anError class nameSpace) ifTrue:[
                stErrorClass value: anError class nameWithoutPrefix.  "/ cg: is this correct ?
            ] ifFalse:[
                stErrorClass value: anError class name.
            ].
        ] ifFalse:[
            stErrorClass value: anError class name.
        ].
        isResumable := details createChildNamed: 'isResumable'.
        isResumable value: anError isResumable printString.
        anError messageText isNil
                ifFalse: [messageText := details createChildNamed: 'messageText'.
                        messageText value: anError messageText].
        stack := details createChildNamed: 'stack'.
        stack value: (SoPortableUtil stackTraceFrom: anError).

        detail := aSoapFault addDetail.
        detail addSubElement: details.
        ^ detail
! !

!SoapFaultDetailBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapFaultDetailBuilder.st,v 1.4 2003/01/21 18:04:10 cg Exp $'
! !

SoapFaultDetailBuilder initialize!
