"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapElement subclass:#SoapHeader
	instanceVariableNames:'headerEntries'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Elements'
!

SoapHeader comment:'SOAP Header element.


---
mu 5/21/2001 22:24'
!


!SoapHeader class methodsFor:'constants'!

localName
	^'Header'
! !

!SoapHeader methodsFor:'actions'!

addHeaderEntry: anXmlElement
	"anXmlElement mustUnderstand:
		#printXmlOn:aStream
		#parent: anXmlElement"
	anXmlElement parent: self.
	^self headerEntries add: anXmlElement.
!

disableMustUnderstand
        self putAttributeNamed: SoapConstants soapEnvPrefixColon, SoapConstants mustUnderstandAttribute value: '0'
!

enableMustUnderstand
        self putAttributeNamed: SoapConstants soapEnvPrefixColon, SoapConstants mustUnderstandAttribute value: '1'
!

isMustUnderstandEnabled
        ^(self getAttributeNamed: SoapConstants soapEnvPrefixColon, SoapConstants mustUnderstandAttribute ) = '1'
! !

!SoapHeader methodsFor:'elements'!

headerEntries
	headerEntries isNil ifTrue: [headerEntries := OrderedCollection new].
	^headerEntries
!

headerEntries: aCollectionOfXmlElement
	headerEntries := aCollectionOfXmlElement
!

signatures
    subElements isNil ifTrue:[^ nil].
    ^ subElements select:[:eachElement | |prefix ns|

                                         eachElement localName = 'Signature'
                                         and:[ (prefix := eachElement prefixName) notNil
                                         and:[ (ns := eachElement declaredNamespaceURIFor:prefix) notNil
                                         and:[ ns = SoapConstants soapSecURI ]]]].
! !

!SoapHeader methodsFor:'testing'!

isHeader
	^true
! !

!SoapHeader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapHeader.st,v 1.5 2003/01/20 22:21:53 cg Exp $'
! !
