"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapAbstractConnector subclass:#SoapHttpConnector
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Http'
!


!SoapHttpConnector methodsFor:'actions'!

send: aSoapEnvelope to: aSoapTcpLocator with: aSoapContext 
        "return aSoapMessage or nil"
        | page soapClient envBuilder rawString returnEnvelope |
        self
                debugSend: aSoapEnvelope
                to: aSoapTcpLocator
                with: aSoapContext. 
        page := aSoapContext targetObjectURI.
        soapClient := SoapHttpClient
                                host: aSoapTcpLocator host
                                port: aSoapTcpLocator port
                                page: page.
        envBuilder := self envelopeBuilder.
        [
            rawString := soapClient send: aSoapEnvelope printXmlString action: aSoapContext soapAction.
            rawString isNil ifTrue:[
                SOAP::SoapRemoteError raiseErrorString:'No (nil) response from soapClient'    
            ].
            returnEnvelope := envBuilder buildSoapEnvelopeFromXmlString: rawString.
        ]
                on: (SoapCannotResolveServer , SoapCannotConnectToServer)
                do: [:ex | 
                        UserPreferences current soapErrorDebugging ifTrue:[ex reject].
                        self breakPoint:#cg info:('debugHalt: ' , ex description). 
                        returnEnvelope := envBuilder buildClientSoapFaultEnvelope: ex
                    ].
        ^ SoapMessage envelope: returnEnvelope

    "Modified: / 12-07-2011 / 17:44:36 / cg"
! !

!SoapHttpConnector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapHttpConnector.st,v 1.12 2011/07/12 16:21:10 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapHttpConnector.st,v 1.12 2011/07/12 16:21:10 cg Exp $'
! !
