"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapHttpModule
	instanceVariableNames:'envelopeBuilder serviceHandler'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Http-Comanche'
!

SoapHttpModule class instanceVariableNames:'showLog useTestServiceHandler'

"
 No other class instance variables are inherited by this class.
"
!


!SoapHttpModule class methodsFor:'class initialization'!

initialize
        "SoapHttpModule initialize"
        "/ debugMode := false
! !

!SoapHttpModule class methodsFor:'setting'!

showLog
	showLog isNil ifTrue:[showLog := false].
	^showLog
!

showLog: aBoolean
	showLog := aBoolean
!

useTestServiceHandler
	useTestServiceHandler isNil ifTrue:[useTestServiceHandler := false].
	^useTestServiceHandler
!

useTestServiceHandler: aBoolean
	useTestServiceHandler := aBoolean
! !

!SoapHttpModule methodsFor:'accessing'!

envelopeBuilder
	envelopeBuilder isNil ifTrue: [envelopeBuilder := SoapEnvelopeBuilder new].
	^envelopeBuilder
!

envelopeBuilder: aValue

	envelopeBuilder := aValue
!

serviceHandler
    ^ serviceHandler
!

serviceHandler:something
    serviceHandler := something.
! !

!SoapHttpModule methodsFor:'processing'!

process: request
        | rawXml soapContext soapEnvelope handlerName returnEnvelope returnXml handler|

        Smalltalk isSmalltalkX ifTrue:[
            request contentType = 'text/xml' ifFalse:[
                Transcript showCR:'##Content type is not text/xml: ',  request contentType printString. 
                ^ nil
            ].
            rawXml := request data. "body"
            self class showLog ifTrue:[
                Transcript showCR:'##' , super printString ,' Server:Request:{ ', rawXml printString, '} '. 
            ].
        ] ifFalse:[
            (request contentType = MIMEDocument contentTypeXml)
                    ifFalse:[Transcript cr; show: '##Content type is not text/xml: ',  request contentType printString. ^nil].
            rawXml := request stream next: request contentLength. "body"

            self class showLog ifTrue: [Transcript cr; show: '##' , super printString ,' Server:Request:{ ', rawXml printString, '} '. ].
        ].

        soapContext := SoapContext new.
        soapContext targetObjectURI: request url. "maybe method namespace"
        soapContext httpRequest:request.

        soapContext soapAction: (SoapAction intent: (request soapAction)).
        soapEnvelope := self envelopeBuilder buildSoapEnvelopeFromXmlString: rawXml.
        handler := serviceHandler.
        handler isNil ifTrue:[
            handlerName := self class useTestServiceHandler ifTrue: [#test] ifFalse: [#default].
            handler := (SoapServiceHandler named: handlerName).
        ].

        returnEnvelope := soapEnvelope hasFault 
                ifTrue: [ soapEnvelope ] 
                ifFalse: [ handler dispatch: soapEnvelope with: soapContext.].

        returnXml := SoXmlUtil contentsWithXmlDeclaration: returnEnvelope printXmlString.
        
        self class showLog ifTrue: [Transcript cr; show: '##' , super printString ,' Server:Return:{ ', returnXml printString, '} '. ].
        
        Smalltalk isSmalltalkX ifTrue:[
            ^ HTTPInterface::HTTPResponse new
                    contentType:'text/xml';
                    data:returnXml
        ] ifFalse:[
            ^HttpResponse fromMIMEDocument: 
                    (MIMEDocument contentType: 'text/xml' content: returnXml)
        ]
! !

!SoapHttpModule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapHttpModule.st,v 1.10 2006/08/15 11:30:42 stefan Exp $'
! !

SoapHttpModule initialize!
