"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapTransportSetup subclass:#SoapHttpSetup
	instanceVariableNames:''
	classVariableNames:'DefaultPort'
	poolDictionaries:''
	category:'SOAP-Http'
!


!SoapHttpSetup class methodsFor:'actions'!

startOn: port
	Smalltalk isSmalltalkX ifTrue:[
	    self startUpOnPort:port.
	    ^ self.
	].

	self stop.

	ComancheNetService notNil ifTrue:[
	    SoapHttpService notNil ifTrue:[
		handler := (SoapHttpService named:  self commancheServiceName onPort: port).
		self handler start
	    ]
	]
!

stop
	"SoapHttpSetup stop"
	handler isNil
		ifFalse: [self handler unregister].
	handler := nil
! !

!SoapHttpSetup class methodsFor:'constants'!

commancheServiceName
	^'SOAP'
!

transportName
	^#http
! !

!SoapHttpSetup class methodsFor:'defaults'!

defaultHandler
    SOAP::SoapHttpService isNil ifTrue:[^ nil].
    ^ SOAP::SoapHttpService named: self commancheServiceName onPort: self defaultPort
!

defaultPort
"/     ^ DefaultPort ifNil:[ HTTPServer defaultPort ]
	defaultPort isNil ifTrue: [defaultPort := 8823].
	^defaultPort

    "
     defaultPort := 80
     defaultPort := 8080

     self defaultPort
    "
! !

!SoapHttpSetup class methodsFor:'setup'!

startUp
    self startUpOnPort:(self defaultPort) confirm:true

    "Modified: / 23-10-2007 / 13:18:43 / cg"
!

startUpOnPort:aPortNr
    self startUpOnPort:aPortNr confirm:true

    "Modified: / 23-10-2007 / 13:18:24 / cg"
!

startUpOnPort:aPortNr confirm:doConfirmByUser
    |answer server|

    server := HTTPServer runningServerOnPort:aPortNr.
    server isNil ifTrue:[
        (doConfirmByUser and:[Smalltalk isStandAloneApp not]) ifTrue:[
            answer := Dialog confirmWithCancel:('OK to start HTTPServer on port %1 ?' bindWith:aPortNr).
            answer isNil ifTrue:[ AbortSignal raise. ].
            answer ifFalse:[^ self].
        ].
        server := HTTPServer startServerOnPort:aPortNr.
        Delay waitForSeconds:1.
    ].
    server soapEnabled ifFalse:[
        (doConfirmByUser and:[Smalltalk isStandAloneApp not]) ifTrue:[
            answer := Dialog confirm:('OK to enable SOAP in the HTTPServer (port %1) ?' bindWith:(server port asString)).
            answer isNil ifTrue:[ AbortSignal raise. ].
            answer ifFalse:[^ self].
        ].
        server setupSoap
    ].
    handler := server soapServiceHandler.
    ^ self

    "Created: / 23-10-2007 / 13:18:04 / cg"
! !

!SoapHttpSetup class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapHttpSetup.st,v 1.19 2007/10/23 11:17:49 cg Exp $'
! !
