"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapAbstractDecoder subclass:#SoapSTXDecoder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-DataBinding-STX'
!


!SoapSTXDecoder class methodsFor:'class initialization'!

initialize
        self initTypeDict

        "self initialize"

    "Created: / 02-08-2007 / 16:48:36 / cg"
! !

!SoapSTXDecoder methodsFor:'actions'!

decodeXmlElement: aSoapWrapElement
        | xsiType stClsName stClass val |
        xsiType := aSoapWrapElement xsiType.
        (xsiType isNil or:[xsiType = (SoapConstants xsdPrefixColon, 'string')]) ifTrue: [^aSoapWrapElement value].

        xsiType = (SoapConstants stxEncPrefixColon, self defaultObjectDecoderClass nameWithoutPrefix) ifTrue: [^self decodeObjectXmlElement: aSoapWrapElement].
        stClsName := self typeDict 
                        at: xsiType asSymbol 
                        ifAbsent:[ SoapDecodingError signal: xsiType, '''s decoding is not supported by ', self class printString].
        stClass := Smalltalk "self class environment" at: stClsName.
        val := stClass readFrom: (ReadStream on: aSoapWrapElement value).
        ^val

    "Modified: / 02-08-2007 / 16:56:00 / cg"
! !

!SoapSTXDecoder methodsFor:'defaults'!

defaultObjectDecoderClass
        ^ BinaryObjectStorage 
! !

!SoapSTXDecoder methodsFor:'private'!

decodeObjectXmlElement: aSoapWrapElement
	^self objectFromString: aSoapWrapElement value.
        
!

objectFromString: aString
        | byteStr bytes |

        byteStr := Base64Coder on:(ReadStream on: aString).
        bytes := byteStr upToEnd.
        byteStr := bytes readStream.
        ^ Object readBinaryFrom:byteStr.
! !

!SoapSTXDecoder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapSTXDecoder.st,v 1.5 2007/08/18 14:54:15 cg Exp $'
! !

SoapSTXDecoder initialize!
