"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapServiceHome
	instanceVariableNames:'objectDict'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Server'
!


!SoapServiceHome class methodsFor:'instance creation'!

new
        ^self basicNew initialize
! !

!SoapServiceHome methodsFor:'actions'!

at: key
        key isNil ifTrue:[^nil].
        ^ objectDict at: key ifAbsent:[SoapNoSuchService signal: key]
!

at: key ifAbsent: aBlock
	key isNil ifTrue:[^nil].
	^ objectDict at: key ifAbsent: aBlock
!

at: key ifAbsentPut: aBlock
	key isNil ifTrue:[^nil].
	^ objectDict at: key ifAbsentPut: aBlock
!

at: key put: anObject 
	key isNil ifTrue:[^nil].
	^ objectDict at: key put: anObject
!

removeKey: key 
	key isNil ifTrue:[^nil].
	^ objectDict removeKey: key 
!

removeKey: key ifAbsent: aBlock
	key isNil ifTrue:[^nil].
	^ objectDict removeKey: key ifAbsent: aBlock
! !

!SoapServiceHome methodsFor:'factory'!

defaultDictionary
	^Dictionary new
! !

!SoapServiceHome methodsFor:'initialize-release'!

initialize
	objectDict := self defaultDictionary.
	
! !

!SoapServiceHome methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' { '.
	objectDict keysAndValuesDo:[:key :value |
		 aStream print: key; nextPutAll: '->'; print: value; space].
	aStream nextPutAll: ' } '.
! !

!SoapServiceHome class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapServiceHome.st,v 1.4 2010/06/14 10:55:01 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapServiceHome.st,v 1.4 2010/06/14 10:55:01 cg Exp $'
! !
