"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapServiceSignature
	instanceVariableNames:'name paramNames paramValues'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Server'
!


!SoapServiceSignature class methodsFor:'instance creation'!

name: aServiceName 
	^ self new name: aServiceName;
		 paramNames: #()
!

name: aServiceName paramNames: anArrayOfParamNames 
	^ self new name: aServiceName;
		 paramNames: anArrayOfParamNames
! !

!SoapServiceSignature methodsFor:'accessing'!

name

	^name
!

name: aValue

	name := aValue
!

paramNames

	^paramNames
!

paramNames: aValue

	paramNames := aValue
!

paramValues
	paramValues isNil ifTrue: [paramValues := IdentityDictionary new].
	^paramValues
!

paramValues: aValue

	paramValues := aValue
! !

!SoapServiceSignature methodsFor:'actions'!

nameExists: aParamName
	^self paramNames includes: aParamName
!

valueAt: aParamName
	^self paramValues at: aParamName ifAbsent: [SoapInvalidParamName signal: aParamName]
!

valueAt: aParamName ifAbsent: aBlock
	^self paramValues at: aParamName ifAbsent: aBlock
!

valueAt: aParamName put: aParamValue 
	(self paramNames includes: aParamName)
		ifTrue: [self paramValues at: aParamName put: aParamValue]
		ifFalse: [SoapInvalidParamName signal: aParamName]
!

verify: aSoapServiceSignature
	aSoapServiceSignature paramNames do: [:each | (self nameExists: each) ifFalse:[SoapInvalidParamName signal: each]].
	^true
! !

!SoapServiceSignature methodsFor:'printing'!

printOn: aStream 
	aStream print: self name.
	aStream nextPutAll: ' ( '.
	aStream print: self paramNames.
	aStream nextPutAll: ' ) '.
	self paramValues isEmpty
		ifFalse: [aStream nextPutAll: ' < '.
			aStream print: self paramValues.
			aStream nextPutAll: ' > ']
! !

!SoapServiceSignature class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapServiceSignature.st,v 1.2 2002/11/08 09:36:03 cg Exp $'
! !
