"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapSetting
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Base'
!

SoapSetting class instanceVariableNames:'debugMode defaultTransport'

"
 No other class instance variables are inherited by this class.
"
!

SoapSetting comment:'Facade for setting Soap related parameters

---
mu 1/4/2002 22:51'
!


!SoapSetting class methodsFor:'class initialization'!

initialize
        "SoapSetting initialize"
        debugMode := false.
        defaultTransport := #http
! !

!SoapSetting class methodsFor:'encoding setting'!

useSchemaDatatypes1999
        SoapConstants xsdURI: 'http://www.w3.org/1999/XMLSchema'.
        SoapConstants xsiURI: 'http://www.w3.org/1999/XMLSchema-instance'.
!

useSchemaDatatypes2001
        SoapConstants xsdURI: 'http://www.w3.org/2001/XMLSchema'.
        SoapConstants xsiURI: 'http://www.w3.org/2001/XMLSchema-instance'.
! !

!SoapSetting class methodsFor:'error handling'!

passErrors
    "/ ^ false.
    ^ true.

    "Created: / 12-07-2011 / 17:41:34 / cg"
! !

!SoapSetting class methodsFor:'log setting'!

defaultPortAt: tranportName
        "SoapSetting defaultPortAt: #http"
tranportName ~~ #http ifTrue:[self halt].
        ^SoapTransportSetup defaultPortAt: tranportName
!

defaultPortAt: tranportName put: portNumber
        "SoapSetting defaultPortAt: #http put: 8824"
tranportName ~~ #http ifTrue:[self halt].
        ^SoapTransportSetup defaultPortAt: tranportName put: portNumber
!

defaultSendingPort
        "SoapSetting defaultSendingPort"
        ^SoapCallEntry defaultSendingPort
!

defaultSendingPort: portNumber
        "SoapSetting defaultSendingPort: 8823"
        ^SoapCallEntry defaultSendingPort: portNumber
!

defaultTransport
        defaultTransport isNil ifTrue: [defaultTransport _ #http].
        ^defaultTransport
!

defaultTransport: aSymbol 
        defaultTransport _ aSymbol
!

resolveTimeout: timeout
        "SoapSetting resolveTimeout: 20"
        SoapAbstractSocketClient resolveTimeout: timeout
!

restart
        SoapTransportSetup startAll
!

showClientLog: aBoolean
	"SoapSetting showClientLog: true"
	"SoapSetting showClientLog: false"
	SoapAbstractConnector showLog: aBoolean.
	
!

showServerLog: aBoolean 
        "SoapSetting showServerLog: true"
        "SoapSetting showServerLog: false"
        Smalltalk at: #SoapHttpModule ifPresent: [:cls | cls showLog: aBoolean].
        Smalltalk at: #SoapSqtpHandler ifPresent: [:cls | cls showLog: aBoolean].
!

showingServerLog
        "SoapSetting showingServerLog"
        | results |
        results := OrderedCollection new.
        results add: (Smalltalk at: #SoapHttpModule ifPresent: [:cls | cls showLog]). 
        results add: (Smalltalk at: #SoapSqtpHandler ifPresent: [:cls | cls showLog]).
        ^results includesAnyOf: (Array with: true with: nil)
! !

!SoapSetting class methodsFor:'others'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapSetting.st,v 1.5 2011/07/12 16:23:00 cg Exp $'
! !

!SoapSetting class methodsFor:'server setting'!

defaultPort
        "SoapSetting defaultPort"
        ^SoapHttpSetup defaultPort
        "/ ^SoapTransportSetup defaultPortAt: (self defaultTransport)
!

defaultPort: anInteger
        ^SoapHttpSetup defaultPort: anInteger.
        "/ SoapTransportSetup defaultPortAt: self defaultTransport put: anInteger.
        "Should I restart here?"
        self restart
!

resolveTimeout
        ^SoapAbstractSocketClient resolveTimeout
!

useHostAddressCache
        ^SoapAbstractSocketClient useHostAddressCache
! !

!SoapSetting class methodsFor:'transport setting'!

showClientLogHttpLevel: aBoolean
        "SoapSetting showClientLogHttpLevel: true"
        "SoapSetting showClientLogHttpLevel: false"
        SoapHttpClient showLog: aBoolean.
! !

!SoapSetting class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapSetting.st,v 1.5 2011/07/12 16:23:00 cg Exp $'
! !

SoapSetting initialize!
