"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapService subclass:#SoapSignedService
	instanceVariableNames:'signatureHandler'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Server'
!


!SoapSignedService methodsFor:'accessing'!

signatureHandler
    "return the value of the instance variable 'signatureHandler' (automatically generated)"

    ^ signatureHandler
!

signatureHandler:something
    "set the value of the instance variable 'signatureHandler' (automatically generated)"

    signatureHandler := something.
! !

!SoapSignedService methodsFor:'validation'!

validateSignature:aSoapEnvelope serviceHandler:aServiceHandler
    |header signatures signature|

    header := aSoapEnvelope header.
    header notNil ifTrue:[
        signatures := header signatures.
    ].
    signatures isEmptyOrNil ifTrue:[
        SoapMissingSignature raiseErrorString:'missing header/signature'.
        ^ self
    ].
    signatures size ~~ 1 ifTrue:[
        SoapUnsupportedSignature raiseErrorString:'header must have exacty 1 signature'.
        ^ self
    ].
    signature := signatures first.

    signatureHandler validateSignature:signature inEnvelope:aSoapEnvelope serviceHandler:aServiceHandler.
! !

!SoapSignedService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapSignedService.st,v 1.2 2003/01/17 20:24:36 cg Exp $'
! !
