"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapAbstractDecoder subclass:#SoapSqDecoder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-DataBinding-Squeak'
!


!SoapSqDecoder methodsFor:'actions'!

decodeXmlElement: aSoapWrapElement
	| xsiType stClsName stClass val |
	xsiType := aSoapWrapElement xsiType.
	(xsiType isNil or:[xsiType = (SoapConstants xsdPrefixColon, 'string')]) ifTrue: [^aSoapWrapElement value].
	xsiType = (SoapConstants sqEncPrefixColon, self defaultObjectDecoderClass name) ifTrue: [^self decodeObjectXmlElement: aSoapWrapElement].
	stClsName := self typeDict at: xsiType asSymbol ifAbsent:[ SoapDecodingError signal: xsiType, '''s decoding is not supported by ', self class printString].
	stClass := self class environment at: stClsName.
	val := stClass readFrom: (ReadStream on: aSoapWrapElement value).
	^val
! !

!SoapSqDecoder methodsFor:'defaults'!

defaultObjectDecoderClass
	^ReferenceStream
! !

!SoapSqDecoder methodsFor:'private'!

decodeObjectXmlElement: aSoapWrapElement
	^self objectFromString: aSoapWrapElement value.
	
!

objectFromString: aString
	| byteStr oStr |
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: aString)).
	oStr := self defaultObjectDecoderClass on: byteStr.
	^oStr next
! !

!SoapSqDecoder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapSqDecoder.st,v 1.3 2002/11/20 10:42:22 cg Exp $'
! !
