"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapAbstractEncoder subclass:#SoapSqEncoder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-DataBinding-Squeak'
!


!SoapSqEncoder methodsFor:'actions'!

encodeSoapVariable: aSoapVariable
        | val type xsiTypeAttVal elem |
        val := aSoapVariable value.
        val isNil ifTrue:[^self encodeNilSoapVariable: aSoapVariable ].
        type := aSoapVariable type.
        Smalltalk isSmalltalkX ifTrue:[
            type isNil ifTrue:[type := val class nameWithoutPrefix].
        ] ifFalse:[
            type isNil ifTrue:[type := val class name].
        ].
        xsiTypeAttVal := self typeDict at: type ifAbsent:[ ^self encodeObjectSoapVariable: aSoapVariable].
        elem := self xmlElementClass named: aSoapVariable name.
        elem putAttributeNamed: (SoapConstants xsiType) value: xsiTypeAttVal.
        elem value: aSoapVariable value.
        ^elem
! !

!SoapSqEncoder methodsFor:'defaults'!

defaultObjectEncoderClass
    Smalltalk isSmalltalkX ifTrue:[
        ^ BinaryObjectStorage
    ].
        ^ReferenceStream
! !

!SoapSqEncoder methodsFor:'private'!

encodeNilSoapVariable: aSoapVariable 
        | elem |
        elem := self xmlElementClass emptyNamed: aSoapVariable name.
        elem putAttributeNamed: SoapConstants xsiNull value: 1.
        ^elem
!

encodeObjectSoapVariable: aSoapVariable
        | val  valStr elem |
        val := aSoapVariable value.
        valStr := self stringFromObject: val.
        elem := self xmlElementClass named: aSoapVariable name.
        Smalltalk isSmalltalkX ifTrue:[
            elem putAttributeNamed: (SoapConstants xsiType) value: (SoapConstants sqEncPrefixColon, self defaultObjectEncoderClass nameWithoutPrefix).
        ] ifFalse:[
            elem putAttributeNamed: (SoapConstants xsiType) value: (SoapConstants sqEncPrefixColon, self defaultObjectEncoderClass name).
        ].
        elem value: valStr.
        ^elem
!

stringFromObject: anObject
        | file con s|

        ((Smalltalk respondsTo:#isSmalltalkX) and:[Smalltalk isSmalltalkX]) ifTrue:[
            s := #[] writeStream.
            anObject storeBinaryOn:s.
            ^ Base64Coder encode:s contents.
        ].

        file := RWBinaryOrTextStream
                                on: (ByteArray new: 5000).
        file binary.
        (self defaultObjectEncoderClass on: file)
                nextPut: anObject.
        con := Base64MimeConverter mimeEncode: file reset.
        file close.
        ^ con contents
! !

!SoapSqEncoder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapSqEncoder.st,v 1.6 2007/10/25 15:09:32 mb Exp $'
! !
