"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapAbstractSocketClient subclass:#SoapSqtpClient
	instanceVariableNames:'messageArray reqURI socket host port serverAddress'
	classVariableNames:'showLog'
	poolDictionaries:''
	category:'SOAP-Sqtp'
!


!SoapSqtpClient class methodsFor:'instance creation'!

host: hostnameString port: portNumberInteger page: pageString 
	| reqURI |
	reqURI := (pageString isNil
					or: [pageString isEmpty])
				ifTrue: ['/']
				ifFalse: [pageString].
	^ self new
		host: hostnameString
		port: portNumberInteger
		page: reqURI
! !

!SoapSqtpClient class methodsFor:'class initialization'!

initialize
	"SoapSqtpClient initialize"
	showLog := false.

	
! !

!SoapSqtpClient methodsFor:'actions'!

send: soapEnvelope
	| cont |
	messageArray := Array with: reqURI with: soapEnvelope.
	self initializeNetwork.
	self resolveServerAddress.
	self sendBySocket.
	cont := self getResponseContents.
	self class showLog
		ifTrue: [Transcript cr; show: '##' , super printString , ' Client:Return:{'.
			Transcript show: cont printString, '}'].
	^ cont
! !

!SoapSqtpClient methodsFor:'private'!

getResponseContents

	|  object |
	object _ SoapSqtpProtocol getObjectFrom: socket.
	socket destroy.
	^ object
		
!

host: hostnameString port: portNumberInteger page: pageString 
	host := hostnameString.
	port := portNumberInteger.
	reqURI := pageString.
!

sendBySocket
	socket := Socket new.
	socket connectTo: serverAddress port: port.
	socket waitForConnectionUntil: Socket standardDeadline.
	socket isConnected
		ifFalse: [SoapCannnotConnectToServer signal: 'Server does not respond - ''host: ' , host , ' port: ' , port printString].
        
	SoapSqtpProtocol sendRequestObject: messageArray by: socket
! !

!SoapSqtpClient class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapSqtpClient.st,v 1.2 2006/09/15 10:02:17 stefan Exp $'
! !

SoapSqtpClient initialize!
