"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

Object subclass:#SoapTransportMap
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Transport'
!

SoapTransportMap class instanceVariableNames:'transportDict connectorDict setupDict'

"
 No other class instance variables are inherited by this class.
"
!


!SoapTransportMap class methodsFor:'accessing'!

connectorDict
        connectorDict isNil ifTrue: [connectorDict _ IdentityDictionary new].
        ^connectorDict
!

setupDict
        setupDict isNil ifTrue: [setupDict _ IdentityDictionary new].
        ^setupDict
!

transportDict
	^transportDict
! !

!SoapTransportMap class methodsFor:'actions'!

at: aSymbol
	| cls |
	cls := self transportDict at: aSymbol ifAbsent:[].
	^cls isNil ifTrue:[SoapNoSuchConnector signal: aSymbol] ifFalse:[cls new]
!

connectorAt: aSymbol
        | cls |
        cls := self connectorDict at: aSymbol ifAbsent:[].
        ^cls isNil ifTrue:[SoapNoSuchConnector signal: aSymbol] ifFalse:[cls new]
!

connectorAt: aSymbol put: realClass
        self connectorDict at: aSymbol put: realClass
!

removeConnectorAt: aSymbol
        ^self connectorDict removeKey: aSymbol ifAbsent:[]
!

removeSetupAt: aSymbol
        ^self setupDict removeKey: aSymbol ifAbsent:[]
!

setupAt: aSymbol
        ^self setupDict at: aSymbol ifAbsent:[SoapNoSuchTransport signal: aSymbol printString].
!

setupAt: aSymbol put: realClass 
        self setupDict at: aSymbol put: realClass
! !

!SoapTransportMap class methodsFor:'class initialization'!

initConnectorDict
        connectorDict _ nil.
!

initSetupDict
        setupDict _ nil
!

initTransportDict
	self transportDict at: #localRpc put: SoapLocalRpcConnector.
	self transportDict at: #http put: SoapHttpConnector 
!

initialize
        "SoapTransportMap initialize"
        transportDict := IdentityDictionary new.
        self initTransportDict.

        self initConnectorDict.
        self initSetupDict.

        SoapAbstractConnector initializeAll.
        SoapTransportSetup notNil ifTrue:[ SoapTransportSetup initializeAll ].
! !

!SoapTransportMap class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapTransportMap.st,v 1.4 2005/12/21 21:46:44 cg Exp $'
! !

SoapTransportMap initialize!
