"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoapEncodable subclass:#SoapVariable
	instanceVariableNames:'name type value xsdType'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-RPC'
!

SoapVariable comment:'I represent a SOAP RPC variable. Used as parameter and return value.

---
MU 5/12/2002 00:47'
!


!SoapVariable class methodsFor:'instance creation'!

name: aNameSymbol
	^ self name: aNameSymbol value: nil type: nil
!

name: aNameSymbol type: aSmalltalkTypeSymbol
	^ self new name: aNameSymbol;
		 type: aSmalltalkTypeSymbol
!

name: aNameSymbol value: anObject
	^ self new name: aNameSymbol;
		value: anObject
!

name: aNameSymbol value: anObject type: aSmalltalkTypeSymbol
	^ self new name: aNameSymbol;
		value: anObject;
		 type: aSmalltalkTypeSymbol
!

name: aNameSymbol value: anObject xsdType: anXsdTypeSymbol
	^ self new name: aNameSymbol;
		value: anObject;
		 xsdType: anXsdTypeSymbol
!

name: aNameSymbol xsdType: anXsdTypeSymbol
	^ self new name: aNameSymbol;
		 xsdType: anXsdTypeSymbol
! !

!SoapVariable methodsFor:'accessing'!

name

	^name
!

name: aValue

	name := aValue
!

type

	^type
!

type: aValue

	type := aValue
!

value

	^value
!

value: aValue

	value := aValue
!

xsdType

	^xsdType
!

xsdType: aValue

	xsdType := aValue
! !

!SoapVariable methodsFor:'converting'!

asXmlElement
	| elem |
	elem := self encoder encodeSoapVariable: self.
	(self parent isNil or:[ self parent encoder class ~= self encoder class])
		ifTrue: [elem declareEncodingIn: SoapConstants soapEnvPrefix uri: self encodingStyleURIString].
	^elem
! !

!SoapVariable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapVariable.st,v 1.2 2002/11/08 09:33:33 cg Exp $'
! !
