"{ Package: 'stx:goodies/soap' }"

"{ NameSpace: SOAP }"

SoXmlWrapElement subclass:#SoapWrapElement
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Base'
!

SoapWrapElement comment:'Convenient XML Element which is contained in SoapElement

---
mu 1/4/2002 22:54'
!


!SoapWrapElement class methodsFor:'constants'!

arrayTypeMatchString
	^'*arrayType'.
	
! !

!SoapWrapElement methodsFor:'accessing'!

attributesHolder
	attributesHolder isNil ifTrue:[ attributesHolder := SoapAttributesHolder new].
	^attributesHolder
! !

!SoapWrapElement methodsFor:'actions'!

arrayItemType
        | arrType |
        arrType := self arrayType.
        ^arrType isNil
                ifTrue: [(SoapConstants xsdAnyType)]
                ifFalse: [| end | 
                        end := arrType findString: '[' startingAt: 1.
                        (arrType copyFrom: 1 to: end - 1) ]
!

arrayType
	^self getAttributeLike: self class arrayTypeMatchString.
	
!

declareEncodingIn: nameSpacePrefix  uri: uriString
	self putAttributeNamed: nameSpacePrefix, ':', SoapConstants encodingStyle value: uriString.
!

declareSoapEncNamespace
	self declareNamespace: SoapConstants soapEncPrefix  uri: SoapConstants soapEncURI.
	
!

declareTypicalEncoding
	self declareEncodingIn: SoapConstants soapEnvPrefix uri: SoapConstants soapEncURI.
!

declareTypicalNamespaces
	self declareSoapEncNamespace.
	self declareXsdNamespace.
	self declareXsiNamespace
!

declareXsdNamespace
        self declareNamespace: SoapConstants xsdPrefix  uri: SoapConstants xsdURI.
!

declareXsiNamespace
	self declareNamespace: SoapConstants xsiPrefix  uri: SoapConstants xsiURI.
	
!

encodingStyleURIs
        "ToDo: take a more serious approach...Namespace conscious"
        | encs |
        encs := self attributesHolder encodingStyle.
        (encs isEmptyOrNil and: [self parent notNil])
                ifTrue: [^ self parent encodingStyleURIs].
        ^ SoPortableUtil substringsFrom: encs
!

size
        | arrType |
        arrType := self arrayType.
        ^arrType isNil
                ifTrue: [self children size]
                ifFalse: [| start | 
                        start := arrType findString: '[' startingAt: 1.
                        (arrType copyFrom: start + 1 to: arrType size - 1) asNumber]
!

xsiType
	^self getAttributeNamed: SoapConstants xsiType
!

xsiType: aString
	^self putAttributeNamed: SoapConstants xsiType value: aString
! !

!SoapWrapElement methodsFor:'testing'!

isArrayType
    false ifTrue:[
        "/ sr & cg - why did we do that ??
       ^ (self attributesHolder otherDict at:'xsi:type' ifAbsent:nil) = 'xsd:arrayType'   
    ].

    ^ self hasAttributeLike: self class arrayTypeMatchString

    "Modified: / 20-08-2007 / 16:01:53 / cg"
! !

!SoapWrapElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/SoapWrapElement.st,v 1.9 2007/08/20 14:02:10 cg Exp $'
! !
