"{ Package: 'stx:goodies/soap/examples' }"

"{ NameSpace: SOAP }"

SoapLiteClient subclass:#BabelFishClient
	instanceVariableNames:'licenseKey doGetCachedPage doSpellingSuggestion doGoogleSearch'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-ExampleClients'
!

BabelFishClient class instanceVariableNames:'licenseKey'

"
 No other class instance variables are inherited by this class.
"
!

!BabelFishClient class methodsFor:'documentation'!

documentation
"
    Web based Text translation service

    [author:]
        Claus Gittinger (cg@alan)
"
!

examples
"
        SOAP::BabelFishClient new translate:'Hello world' fromLanguage:'en' toLanguage:'de' 
        SOAP::BabelFishClient new translate:'Hello world' fromLanguage:'en' toLanguage:'fr' 
        SOAP::BabelFishClient new translate:'Hello world' fromLanguage:'en' toLanguage:'it' 
        SOAP::BabelFishClient new translate:'Hello world' fromLanguage:'en' toLanguage:'pt' 
        SOAP::BabelFishClient new translate:'Hello world' fromLanguage:'en' toLanguage:'es' 
"
!

howTo_babelFish
"
 see: http://www.xmethods.net/ve2/ViewListing.po?serviceid=14

 BabelFish
     WSDL            http://www.xmethods.net/sd/2001/BabelFishService.wsdl     
     SOAP Binding    BabelFishBinding 
     Key             uuid:E00104D5-2AC8-9DEA-EF4C-8BD920E1B4DD
     Owner:          xmethods.net
     For more Info:  http://babelfish.altavista.com
     Description:    Interface for AltaVista's Babelfish service.
     Endpoint:       http://services.xmethods.net:80/perl/soaplite.cgi


 Detailed Description
     Interface for AltaVista's Babelfish service.

     Translates text of up to 150 words in length. For more information 
     about the service, see the babelfish homepage.

     TERMS OF SERVICE NOTE: You may *NOT* use this service to do bulk 
     conversions (like crawling a dictionary). Thank you.


 Usage Notes
     METHOD: BabelFish
           INPUT : 
               translationmode(xsd:string)
               sourcedata (xsd:string)

           OUTPUT
               return (xsd:string)

     translationmodes are listed below.
     sourcedata is the text to be translated.
     result is the translated data.

     Translation                 translationmode
     -----------                 ----------------
     English -> French           'en_fr'
     English -> German           'en_de'
     English -> Italian          'en_it'
     English -> Portugese        'en_pt'
     English -> Spanish          'en_es'

     French -> English           'fr_en'
     German -> English           'de_en'
     Italian -> English          'it_en'
     Portugese -> English        'pt_en'
     Spanish -> English          'es_en'

     Russian -> English          'ru_en'

  BUGS
     Currently, the service has trouble with some special
     characters, such as those with umlauts, for the input
     string. This bug also will affect the parsing of
     return strings.
"
!

wsdl
    "not yet used - for reference only"

^ '
<?xml version="1.0"?>
<definitions 
    name="BabelFishService" 
    xmlns:tns="http://www.xmethods.net/sd/BabelFishService.wsdl" 
    targetNamespace="http://www.xmethods.net/sd/BabelFishService.wsdl" 
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"    
    xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" 
    xmlns="http://schemas.xmlsoap.org/wsdl/">
        <message name="BabelFishRequest">
                <part name="translationmode" type="xsd:string"/>
                <part name="sourcedata" type="xsd:string"/>
        </message>
        <message name="BabelFishResponse">
                <part name="return" type="xsd:string"/>
        </message>
        <portType name="BabelFishPortType">
                <operation name="BabelFish">
                        <input message="tns:BabelFishRequest" />
                        <output message="tns:BabelFishResponse" />
                </operation>
        </portType>
        <binding name="BabelFishBinding" type="tns:BabelFishPortType">
                <soap:binding style="rpc" transport="http://schemas.xmlsoap.org/soap/http"/>
                <operation name="BabelFish">
                        <soap:operation soapAction="urn:xmethodsBabelFish#BabelFish"/>
                        <input>
                                <soap:body use="encoded" namespace="urn:xmethodsBabelFish" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
                        </input>
                        <output>
                                <soap:body use="encoded" namespace="urn:xmethodsBabelFish" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
                        </output>
                </operation>
        </binding>
        <service name="BabelFishService">
                <documentation>Translates text of up to 5k in length, between a variety of languages.</documentation>
                <port name="BabelFishPort" binding="tns:BabelFishBinding">
                        <soap:address location="http://services.xmethods.net:80/perl/soaplite.cgi"/>
                </port>
        </service>
</definitions>
'
! !

!BabelFishClient class methodsFor:'accessing'!

host
        ^ 'services.xmethods.net'
!

namespace
        ^ 'urn:xmethodsBabelFish'.
!

port
        ^ 80
!

supportedLanguageCombinations
    ^ #(
     'en' 'fr'
     'en' 'de'
     'en' 'it'
     'en' 'pt'
     'en' 'es'

     'fr' 'en'
     'de' 'en'
     'it' 'en'
     'pt' 'en'
     'es' 'en'

     'ru' 'en'
    ) pairWiseCollect:[:from :to | from -> to ]

    "
     SOAP::BabelFishClient supportedLanguageCombinations
    "
!

supportedLanguageShortcuts
    ^ #(
        ('en'    'English'   )
        ('de'    'German'    )
        ('fr'    'French'    )
        ('es'    'Spanish'   )
        ('pt'    'Portuguese')
        ('ru'    'Russian'   )
        ('it'    'Italian'   )
      )

    "
     SOAP::BabelFishClient supportedLanguageShortcuts
    "
!

supportedModes
    ^ #()
!

targetObjectURI
        ^ 'http://services.xmethods.net/perl/soaplite.cgi'
! !

!BabelFishClient methodsFor:'actions'!

translate:sourceString fromLanguage:fromLanguage toLanguage:toLanguage
        |fromToModeString|

        fromToModeString := fromLanguage , '_' , toLanguage.
        ^ self translate:sourceString mode:fromToModeString

        "
         self new translate:'Hello world' fromLanguage:'en' toLanguage:'de' 
         self new translate:'Hello world' fromLanguage:'en' toLanguage:'fr' 
         self new translate:'Hello world' fromLanguage:'en' toLanguage:'it' 
         self new translate:'Hello world' fromLanguage:'en' toLanguage:'pt' 
         self new translate:'Hello world' fromLanguage:'en' toLanguage:'es' 
        "
!

translate:sourceString mode:fromToModeString
        |answer|

        answer := self 
            callMethod:'BabelFish' 
            withParameter:('translationmode' -> fromToModeString)
            withParameter:('sourcedata' -> sourceString).
        (answer size > 0) ifTrue:[answer := answer withoutTrailingSeparators].
        ^ answer

        "
         self new translate:'Hello world' mode:'en_de' 
         self new translate:'Hello world' mode:'en_fr' 
         self new translate:'Hello world' mode:'en_it' 
         self new translate:'Hello world' mode:'en_pt' 
         self new translate:'Hello world' mode:'en_es' 
        "
! !

!BabelFishClient class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/examples/BabelFishClient.st,v 1.12 2005/12/01 15:24:20 cg Exp $'
! !
