"{ Package: 'stx:goodies/soap/examples' }"

"{ NameSpace: SOAP }"

SoapLiteClient subclass:#BookPriceClient
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-ExampleClients'
!

!BookPriceClient class methodsFor:'documentation'!

documentation
"
    A BookPrice (by ISBN-Nr) client

        No warranty: the code here is to be taken as a coding example and
        was created by transcribing a similar example program found elsewhere.
        It is not proven to be correct.
        We do not recommend using that code for real, critical business applications;
        actually, you are not allowed to use it for non private purposes, as stated in the
        service providers web pages.
        We are not responsible for misuse or loss of money ...
    

    Detailed Description (from http://www.xmethods.net/ve2/ViewListing.po?serviceid=192)

        Sales Rank and Price for online bookstores.
        Get Amazon.com and/or BarnesAndNobel.com Sales Rank and/or Price for any book, 
        given the ISBN number.


    Usage Notes
        All methods take ISBN as a string input parameter and return sales rank and/or price string(s). 
        Note that this Web Service posts data directly to Amazon and BarnesAndNoble Web sites. 
        This Web Service is intended only for non-commercial, personal use. 
        We'll be soon posting a very useful Windows application which uses this Web service. 
        Please send any suggestions/questions/comments to darshan@PerfectXML.com

    [author:]
        Claus Gittinger; Jan 2003
"
!

examples
"
    Usage (inspect or print it)
         SOAP::BookPriceClient new bookPriceForISBN:'0596000278'    
"
! !

!BookPriceClient class methodsFor:'accessing'!

host
	^ 'services.xmethods.net'
!

namespace
	^ 'urn:xmethods-BNPriceCheck'
!

port
        ^ 80
!

targetObjectURI
	^ 'http://services.xmethods.net/soap/servlet/rpcrouter'
! !

!BookPriceClient methodsFor:'actions'!

bookPriceForISBN: isbnString
	"/ returns negative if book price is not available

	^ self callMethod:'getPrice' withParameter:('isbn' -> isbnString).

	"
	 self new bookPriceForISBN:'0596000278'   - expect USD 39.96
	 ( Programming Perl, 3rd Edition )

	 self new bookPriceForISBN:'0201113716' 
	 ( Smalltalk-80 - the blue book )

	 self new bookPriceForISBN:'1578701503'   - expect USD 45
	 ( DCE/RPC over SMB ;-)  )
	"
! !

!BookPriceClient class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/examples/BookPriceClient.st,v 1.5 2005/12/01 15:24:13 cg Exp $'
! !
