"{ Package: 'stx:goodies/soap/examples' }"

"{ NameSpace: SOAP }"

SoapLiteClient subclass:#CurrencyExchangeClient
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-ExampleClients'
!

!CurrencyExchangeClient class methodsFor:'documentation'!

documentation
"
    No warranty: the code here is to be taken as a coding example and
    was created by transcribing a similar example program found elsewhere.
    It is not proven to be correct.
    We do not recommend using that code for real, critical business 
    applications. 
    We are not responsible for loss of money ...

    [author:]
        Claus Gittinger; Jan 2003
"
!

examples
"
        Usage (inspect or print it)
         SOAP::CurrencyExchangeClient new exchangeRateFrom:'England' to:'Japan'   
         SOAP::CurrencyExchangeClient new exchangeRateFrom:'USA' to:'Euro'     
         SOAP::CurrencyExchangeClient new exchangeRateFrom:'Euro' to:'USA'    

         SOAP::CurrencyExchangeClient new exchangeRateFrom:'USA' to:'Germany'    
         SOAP::CurrencyExchangeClient new exchangeRateFrom:'USA' to:'France'     
         SOAP::CurrencyExchangeClient new exchangeRateFrom:'Germany' to:'France'   
         SOAP::CurrencyExchangeClient new exchangeRateFrom:'Germany' to:'Germany'   
         SOAP::CurrencyExchangeClient new exchangeRateFrom:'Germany' to:'Euro'   
"
!

howTo_use
"
 Exchange rate between any two currencies.

 Takes in country1 and country2, and returns the exchange rate between currencies 
 (Returns value of 1 unit of country1's currency converted into country2's unit currency).  

 The following country names are valid:
     afghanistan
     albania
     algeria
     andorra
     andorra
     angola
     argentina
     aruba
     australia
     austria
     bahrain
     bangladesh
     barbados
     belgium
     belize
     bermuda
     bhutan
     bolivian
     botswana
     brazil
     england
     united kingdom
     uk
     great britain
     brunei
     burundi
     cambodia
     canada
     cape verde
     cayman islands
     chile
     china
     colombia
     comoros
     costa rica
     croatia
     cuba
     cyprus
     czech republic
     denmark
     dijibouti
     dominican republic
     netherlands
     east caribbean
     ecuador
     egypt
     el salvador
     estonia
     ethiopia
     euro
     falkland islands
     fiji
     finland
     france
     gambia
     germany
     ghana
     gibraltar
     greece
     guatemala
     guinea
     guyana
     haiti
     honduras
     hong kong
     hungary
     iceland
     india
     indonesia
     iraq
     ireland
     israel
     italy
     jamaica
     japan
     jordan
     kazakhstan
     kenya
     korea
     kuwait
     laos
     latvia
     lebanon
     lesotho
     liberia
     libya
     lithuania
     luxembourg
     macau
     macedonia
     malaga
     malawi kwacha
     malaysia
     maldives
     malta
     mauritania
     mauritius
     mexico
     moldova
     mongolia
     morocco
     mozambique
     myanmar
     namibia
     nepal
     new Zealand
     nicaragua
     nigeria
     north korea
     norway
     oman
     pakistan
     panama
     papua new guinea
     paraguay
     peru
     philippines
     poland
     portugal
     qatar
     romania
     russia
     samoa
     sao tome
     saudi arabia
     seychelles
     sierra leone
     singapore
     slovakia
     slovenia
     solomon islands
     somalia
     south africa
     spain
     sri lanka
     st helena
     sudan
     suriname
     swaziland
     sweden
     switzerland
     syria
     taiwan
     tanzania
     thailand
     tonga
     trinidad
     tunisia
     turkey
     united states
     us
     usa
     uae
     united arib emirates
     uganda
     ukraine
     uzbekistan
     vanuatu
     venezuela
     vietnam
     yemen
     yugoslavua
     zambia
     zimbabwe

 Usage Notes

 Request Parameter Schema:
     <element name=""country1"" type=""string"" />
     <element name=""country2"" type=""string"" />

 Response Parameter Schema:
     <element name=""return"" type=""float"" />

 Encoding Style for both request and response:
     http://schemas.xmlsoap.org/soap/encoding

 ----------------------------------------------------------
 For XMethods Server implementation, use port 9090 instead of port 80.
 ----------------------------------------------------------
"
! !

!CurrencyExchangeClient class methodsFor:'accessing'!

host
	^ 'services.xmethods.net'
!

namespace
	^ 'urn:xmethods-CurrencyExchange'
!

port
        ^ 80 
!

targetObjectURI
	^ 'http://services.xmethods.net/soap'
! !

!CurrencyExchangeClient methodsFor:'actions'!

exchangeRateFrom:country1 to:country2
	^ self callMethod:'getRate' 
	    withParameter:('country1' -> country1) 
	    withParameter:('country2' -> country2).

	"
	 self new exchangeRateFrom:'England' to:'Japan'   
	 self new exchangeRateFrom:'USA' to:'Euro'     
	 self new exchangeRateFrom:'Euro' to:'USA'    

	 self new exchangeRateFrom:'USA' to:'Germany'    
	 self new exchangeRateFrom:'USA' to:'France'     
	 self new exchangeRateFrom:'Germany' to:'France'   
	 self new exchangeRateFrom:'Germany' to:'Germany'   
	 self new exchangeRateFrom:'Germany' to:'Euro'   
	"
! !

!CurrencyExchangeClient class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/examples/CurrencyExchangeClient.st,v 1.4 2005/12/01 15:24:17 cg Exp $'
! !
