"{ Package: 'stx:goodies/soap/examples' }"

"{ NameSpace: SOAP }"

ApplicationModel subclass:#TextToImageApp
	instanceVariableNames:'client imageFile styleHolder formatHolder backgroundColorHolder
		formatList styleList forgroundColorHolder fontList fontHolder
		textHolder imageHolder fontSize acceptChannel fontSizeHolder'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-ExampleClients'
!

!TextToImageApp class methodsFor:'documentation'!

documentation
"
    This demonstrates how a SOAP webservice may be used using the Spray package.
    It is a client to the xara (http://www.xara.com) text to 3D-graphics
    conversion webservice.

    [author:]
        Stefan Vogel (stefan@zwerg)

    [see also:]
"
! !

!TextToImageApp class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SOAP::TextToImageApp andSelector:#windowSpec
     SOAP::TextToImageApp new openInterface:#windowSpec
     SOAP::TextToImageApp open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'SOAP::TextToImageApp'
          name: 'SOAP::TextToImageApp'
          min: (Point 10 10)
          max: (Point 1024 768)
          bounds: (Rectangle 0 0 508 700)
          menu: mainMenu
        )
        component: 
       (SpecCollection
          collection: (
           (VariableVerticalPanelSpec
              name: 'VariableVerticalPanel1'
              layout: (LayoutFrame 0 0.0 0 0.0 0 1.0 -199 1)
              component: 
             (SpecCollection
                collection: (
                 (FramedBoxSpec
                    label: 'Input Text'
                    name: 'FramedBox1'
                    labelPosition: topLeft
                    translateLabel: true
                    component: 
                   (SpecCollection
                      collection: (
                       (TextEditorSpec
                          name: 'TextEditor1'
                          layout: (LayoutFrame 0 0.0 0 0.0 0 1.0 0 1.0)
                          model: textHolder
                          hasHorizontalScrollBar: true
                          hasVerticalScrollBar: true
                          acceptChannel: acceptChannel
                        )
                       )
                     
                    )
                  )
                 (FramedBoxSpec
                    label: 'Image'
                    name: 'FramedBox2'
                    labelPosition: topLeft
                    translateLabel: true
                    component: 
                   (SpecCollection
                      collection: (
                       (ArbitraryComponentSpec
                          name: 'ArbitraryComponent1'
                          layout: (LayoutFrame 0 0.0 0 0.0 0 1.0 0 1.0)
                          model: imageHolder
                          hasHorizontalScrollBar: true
                          hasVerticalScrollBar: true
                          miniScrollerHorizontal: true
                          miniScrollerVertical: true
                          hasBorder: false
                          component: ImageView
                        )
                       )
                     
                    )
                  )
                 )
               
              )
              handles: (Any 0.5 1.0)
            )
           (ViewSpec
              name: 'Box1'
              layout: (LayoutFrame 4 0.0 -197 1 4 1.0 0 1.0)
              component: 
             (SpecCollection
                collection: (
                 (LabelSpec
                    label: 'Style:'
                    name: ''
                    layout: (LayoutFrame 18 0 12 0 65 0 34 0)
                    translateLabel: true
                    adjust: right
                  )
                 (ComboListSpec
                    name: 'ComboList1'
                    layout: (LayoutFrame 80 0 12 0 174 0 34 0)
                    model: styleHolder
                    comboList: styleList
                    useIndex: false
                    hidePullDownMenuButton: false
                  )
                 (LabelSpec
                    label: 'Image Format:'
                    name: 'Format'
                    layout: (LayoutFrame 193 0 12 0 284 0 34 0)
                    translateLabel: true
                    adjust: right
                  )
                 (ComboListSpec
                    name: 'ComboList2'
                    layout: (LayoutFrame 289 0 12 0 383 0 34 0)
                    model: formatHolder
                    comboList: formatList
                    useIndex: false
                    hidePullDownMenuButton: false
                  )
                 (LabelSpec
                    label: 'Forground:'
                    name: 'FG'
                    layout: (LayoutFrame 30 0 82 0 132 0 110 0)
                    translateLabel: true
                    adjust: right
                  )
                 (ColorMenuSpec
                    name: 'ColorMenu2'
                    layout: (LayoutFrame 146 0 82 0 445 0 110 0)
                    model: forgroundColorHolder
                    labelsAreColored: true
                  )
                 (LabelSpec
                    label: 'Background:'
                    name: 'BG'
                    layout: (LayoutFrame 30 0 112 0 132 0 140 0)
                    translateLabel: true
                    adjust: right
                  )
                 (ColorMenuSpec
                    name: 'ColorMenu1'
                    layout: (LayoutFrame 146 0 112 0 445 0 140 0)
                    model: backgroundColorHolder
                    labelsAreColored: true
                  )
                 (LabelSpec
                    label: 'Font:'
                    name: 'Label1'
                    layout: (LayoutFrame 0 0 44 0 74 0 66 0)
                    translateLabel: true
                    adjust: right
                  )
                 (ComboListSpec
                    name: 'ComboList3'
                    layout: (LayoutFrame 82 0 46 0 176 0 68 0)
                    model: fontHolder
                    comboList: fontList
                    useIndex: false
                    hidePullDownMenuButton: false
                  )
                 (ActionButtonSpec
                    label: 'Convert Text'
                    name: 'Button1'
                    layout: (LayoutFrame 190 0 160 0 326 0 186 0)
                    translateLabel: true
                    model: doAccept
                  )
                 (LabelSpec
                    label: 'Font Size:'
                    name: 'Label2'
                    layout: (LayoutFrame 207 0 42 0 281 0 64 0)
                    translateLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'EntryField1'
                    layout: (LayoutFrame 290 0 42 0 383 0 64 0)
                    model: fontSizeHolder
                    type: numberInRange
                    acceptOnReturn: true
                    acceptOnTab: true
                    acceptOnLostFocus: true
                    minValue: 5
                    maxValue: 5000
                    acceptOnPointerLeave: false
                  )
                 )
               
              )
            )
           )
         
        )
      )
! !

!TextToImageApp class methodsFor:'menu specs'!

mainMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:SOAP::TextToImageApp andSelector:#mainMenu
     (Menu new fromLiteralArrayEncoding:(SOAP::TextToImageApp mainMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(Menu
        (
         (MenuItem
            label: 'File'
            translateLabel: true
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'Save As...'
                  itemValue: menuSaveAs
                  translateLabel: true
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Exit'
                  itemValue: closeRequest
                  translateLabel: true
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
! !

!TextToImageApp methodsFor:'aspects'!

acceptChannel
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    acceptChannel isNil ifTrue:[
        acceptChannel := TriggerValue new.
    ].
    ^ acceptChannel.
!

backgroundColorHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    backgroundColorHolder isNil ifTrue:[
        backgroundColorHolder := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       backgroundColorHolder addDependent:self.
"/       backgroundColorHolder onChangeSend:#backgroundColorHolderChanged to:self.
    ].
    ^ backgroundColorHolder.
!

fontHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    fontHolder isNil ifTrue:[
        fontHolder := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       fontHolder addDependent:self.
"/       fontHolder onChangeSend:#fontHolderChanged to:self.
    ].
    ^ fontHolder.
!

fontList
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    fontList isNil ifTrue:[
        fontList := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       fontList addDependent:self.
"/       fontList onChangeSend:#fontListChanged to:self.
    ].
    ^ fontList.
!

fontSizeHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    fontSizeHolder isNil ifTrue:[
        fontSizeHolder := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       fontSizeHolder addDependent:self.
"/       fontSizeHolder onChangeSend:#fontSizeHolderChanged to:self.
    ].
    ^ fontSizeHolder.
!

forgroundColorHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    forgroundColorHolder isNil ifTrue:[
        forgroundColorHolder := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       forgroundColorHolder addDependent:self.
"/       forgroundColorHolder onChangeSend:#forgroundColorHolderChanged to:self.
    ].
    ^ forgroundColorHolder.
!

formatHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    formatHolder isNil ifTrue:[
        formatHolder := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       formatHolder addDependent:self.
"/       formatHolder onChangeSend:#formatHolderChanged to:self.
    ].
    ^ formatHolder.
!

formatList
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    formatList isNil ifTrue:[
        formatList := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       formatList addDependent:self.
"/       formatList onChangeSend:#formatListChanged to:self.
    ].
    ^ formatList.
!

imageHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    imageHolder isNil ifTrue:[
        imageHolder := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       imageHolder addDependent:self.
"/       imageHolder onChangeSend:#imageHolderChanged to:self.
    ].
    ^ imageHolder.
!

styleHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    styleHolder isNil ifTrue:[
        styleHolder := ValueHolder new.
    ].
    ^ styleHolder.
!

styleList
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    styleList isNil ifTrue:[
        styleList := ValueHolder new.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       styleList addDependent:self.
"/       styleList onChangeSend:#styleListChanged to:self.
    ].
    ^ styleList.
!

textHolder
    "automatically generated by UIPainter ..."

    "*** the code below creates a default model when invoked."
    "*** (which may not be the one you wanted)"
    "*** Please change as required and accept it in the browser."
    "*** (and replace this comment by something more useful ;-)"

    textHolder isNil ifTrue:[
        textHolder := '' asValue.
"/ if your app needs to be notified of changes, uncomment one of the lines below:
"/       textHolder addDependent:self.
"/       textHolder onChangeSend:#textHolderChanged to:self.
    ].
    ^ textHolder.
! !

!TextToImageApp methodsFor:'initialization & release'!

postBuildWith:aBuilder
    "This is a hook method generated by the Browser.
     It will be invoked during the initialization of your app/dialog,
     after all of the visual components have been built, 
     but BEFORE the top window is made visible.
     Add any app-specific actions here (reading files, setting up values etc.)
     See also #postOpenWith:, which is invoked after opening."

    |service|

    service := SprayWSDLService onUrl: 'http://ws.xara.com/graphicrender/render3d.wsdl'.
    client := service createClient.

    self styleList value:(client send:'GetTemplates') value.
    self formatList value:(client send:'GetExportTypes') value.
    self fontList value:(client send:'GetFonts') value.

    self styleHolder value:self styleList value first.
    self formatHolder value:self formatList value first.
    self fontHolder value:self fontList value first.
    self fontSizeHolder value:50.

    ^ super postBuildWith:aBuilder
! !

!TextToImageApp methodsFor:'menu actions'!

menuSaveAs
    |fileName|

    imageFile isNil ifTrue:[
        self warn:'No Image'.
        ^ self.
    ].

    fileName := Dialog requestFileName:'Enter Filename for Image' pattern:('*.', formatHolder value).
    fileName asFilename writeStream binary; nextPutAll:imageFile.
! !

!TextToImageApp methodsFor:'web service invocation'!

doAccept

    |imageUri arguments|

    self withWaitCursorDo:[

"/self imageHolder value:(GIFReader fromFile:'/tmp/exp1.gif').
"/^self.

        self acceptChannel value:true.

        arguments := OrderedCollection new 
                           add:self styleHolder value;
"/                           add:(self textHolder value copyReplaceAll:Character nl with:Character cr);
                           add:self textHolder value asUnicodeString;
                           add:(self forgroundColorHolder value ? Color red) hex;
                           add:(self backgroundColorHolder value ? Color white) hex;
                           add:self fontHolder value;
                           add:self fontSizeHolder value;
                           add:self formatHolder value;
                           yourself.

        [   
            |reader|

            imageUri := client send: 'RenderURL' withArguments:arguments.

            imageUri value asURI readStreamDo:[:stream :headerInfo | 
                imageFile := stream contents.
                reader := MIMETypes imageReaderForType:(headerInfo at:'content-type').
            ].
            reader isNil ifTrue:[self error:'unknown image type'].
            self imageHolder value:(reader fromStream:imageFile readStream).
        ] on:SOAP::SoapFault do:[:ex|
            self warn:'Soap fault:', ex parameter faultString.
        ]
        
    ].
! !

!TextToImageApp class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/examples/SOAP__TextToImageApp.st,v 1.2 2005/02/01 12:42:48 stefan Exp $'
! !
