"{ Package: 'stx:goodies/soap/examples' }"

"{ NameSpace: SOAP }"

Object subclass:#SprayInteropTestClient
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-ExampleClients'
!

!SprayInteropTestClient class methodsFor:'documentation'!

documentation
"
    The spray-interop test server is:
	Spray Endpoint
	This is the Endpoint for the Service: SoapOperaInteropService

	This service is described in the WSDL file (see wsdl-method).

	Operations:
	    # reverseString
	    # returnComplexDictionary
	    # timeNow
	    # browseClassDefinition
	    # transcriptShow
	    # reverseArray
	    # helloWorld    
"
!

wsdl
^'
<?xml version="1.0"?>
<definitions 
    name="SoapOperaInteropService" 
    targetNamespace="urn:SoapOperaInteropService" 
    xmlns="http://schemas.xmlsoap.org/wsdl/" 
    xmlns:tns="urn:SoapOperaInteropService" 
    xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
    xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
    xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" 
    xmlns:soapE="http://tempuri.org/schemas" 
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
    xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">

    <types>
	<xsd:schema targetNamespace="http://tempuri.org/schemas" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
	    <xsd:import namespace="http://schemas.xmlsoap.org/wsdl/"/>
	    <xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/"/>
	    <xsd:complexType name="ArrayOfanyType">
		<xsd:complexContent>
		    <xsd:restriction base="SOAP-ENC:Array">
			<xsd:attribute wsdl:arrayType="xsd:anyType[]" ref="SOAP-ENC:arrayType"/>
		    </xsd:restriction>
		</xsd:complexContent>
	    </xsd:complexType>
	</xsd:schema>

    </types>

    <message name="browseClassDefinitionOutput">
	<part name="Result" type="xsd:base64Binary"/>
    </message>

    <message name="transcriptShowInput">
	<part name="aString" type="xsd:string"/>
    </message>

    <message name="reverseArrayOutput">
	<part name="Result" type="soapE:ArrayOfanyType"/>
    </message>

    <message name="timeNowInput"/>
    <message name="transcriptShowOutput">
	<part name="Result" type="xsd:boolean"/>
    </message>

    <message name="reverseStringOutput">
	<part name="Result" type="xsd:string"/>
    </message>

    <message name="helloWorldOutput">
	<part name="Result" type="xsd:string"/>
    </message>

    <message name="helloWorldInput"/>
    <message name="browseClassDefinitionInput">
	<part name="className" type="xsd:string"/>
    </message>

    <message name="reverseArrayInput">
	<part name="anArray" type="soapE:ArrayOfanyType"/>
    </message>

    <message name="returnComplexDictionaryInput">
	<part name="aDictionary" type="xsd:anyType"/>
    </message>

    <message name="reverseStringInput">
	<part name="aString" type="xsd:string"/>
    </message>

    <message name="timeNowOutput">
	<part name="Result" type="xsd:anyType"/>
    </message>

    <message name="returnComplexDictionaryOutput">
	<part name="Result" type="xsd:anyType"/>
    </message>

    <portType name="SoapOperaInteropPortType">
	<operation name="reverseString">
	    <input message="tns:reverseStringInput"/>
	    <output message="tns:reverseStringOutput"/>
	</operation>

	<operation name="returnComplexDictionary">
	    <input message="tns:returnComplexDictionaryInput"/>
	    <output message="tns:returnComplexDictionaryOutput"/>
	</operation>

	<operation name="timeNow">
	    <input message="tns:timeNowInput"/>
	    <output message="tns:timeNowOutput"/>
	</operation>

	<operation name="browseClassDefinition">
	    <input message="tns:browseClassDefinitionInput"/>
	    <output message="tns:browseClassDefinitionOutput"/>
	</operation>

	<operation name="transcriptShow">
	    <input message="tns:transcriptShowInput"/>
	    <output message="tns:transcriptShowOutput"/>
	</operation>

	<operation name="reverseArray">
	    <input message="tns:reverseArrayInput"/>
	    <output message="tns:reverseArrayOutput"/>
	</operation>

	<operation name="helloWorld">
	    <input message="tns:helloWorldInput"/>
	    <output message="tns:helloWorldOutput"/>
	</operation>

    </portType>

    <binding name="SoapOperaInteropBinding" type="tns:SoapOperaInteropPortType">
	<soap:binding transport="http://schemas.xmlsoap.org/soap/http"/>
	<operation name="reverseString">
	    <soap:operation style="rpc" soapAction=""/>
	    <input>
		<soap:body 
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
		    use="encoded" 
		    namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </input>
	    <output>
		<soap:body 
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
		    use="encoded" 
		    namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </output>
	</operation>

	<operation name="returnComplexDictionary">
	    <soap:operation style="rpc" soapAction=""/>
	    <input>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </input>
	    <output>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </output>
	</operation>

	<operation name="timeNow">
	    <soap:operation style="rpc" soapAction=""/>
	    <input>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </input>
	    <output>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </output>
	</operation>

	<operation name="browseClassDefinition">
	    <soap:operation style="rpc" soapAction=""/>
	    <input>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </input>
	    <output>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </output>
	</operation>

	<operation name="transcriptShow">
	    <soap:operation style="rpc" soapAction=""/>
	    <input>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </input>
	    <output>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </output>
	</operation>

	<operation name="reverseArray">
	    <soap:operation style="rpc" soapAction=""/>
	    <input>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </input>
	    <output>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </output>
	</operation>

	<operation name="helloWorld">
	    <soap:operation style="rpc" soapAction=""/>
	    <input>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </input>
	    <output>
		<soap:body encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" use="encoded" namespace="http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/rpc/"/>
	    </output>
	</operation>
    </binding>

    <service name="SoapOperaInteropService">
	<port name="SoapOperaInterop" binding="tns:SoapOperaInteropBinding">
	    <soap:address location="http://www.dolphinharbor.org/services/soapOperaInterop"/>
	</port>
    </service>
</definitions>
'
! !

!SprayInteropTestClient class methodsFor:'examples'!

browseClassDefinition
    | call resp |

    call := (SoapCallEntry tcpHost: 'www.dolphinharbor.org' port: 80) newCall.
    call targetObjectURI: '/services/soapOperaInterop'.
    call methodName: 'browseClassDefinition'.
    call addParameter: (SoapVariable name: #className value: 'SoapOperaInterop').
    resp := call invoke.
    ^resp isFault ifTrue: [resp raiseException] ifFalse: [resp returnValue asString]

    "
     self invoke.
    "
!

reverseString
    | call resp |

    call := (SoapCallEntry tcpHost: 'www.dolphinharbor.org' port: 80) newCall.
    call targetObjectURI: '/services/soapOperaInterop'.
    call methodName: 'reverseString'.
    call addParameter: (SoapVariable name: #aString value: 'Hello from Smalltalk/X').
    resp := call invoke.
    ^resp isFault ifTrue: [resp raiseException] ifFalse: [resp returnValue asString]

    "
     self reverseString.    
    "
!

transcriptShow:what
    | call resp |

    call := (SoapCallEntry tcpHost: 'www.dolphinharbor.org' port: 80) newCall.
    call targetObjectURI: '/services/soapOperaInterop'.
    call methodName: 'transcriptShow'.
    call addParameter: (SoapVariable name: #aString value:what).
    resp := call invoke.
    ^resp isFault ifTrue: [resp raiseException] ifFalse: [resp returnValue asString]

    "
     self transcriptShow:'Hi from Smalltalk/X (I wonder who reads this...)'.    
    "
! !

!SprayInteropTestClient class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/examples/SprayInteropTestClient.st,v 1.2 2003/01/20 18:50:53 cg Exp $'
! !
