"{ Package: 'stx:goodies/soap/opera' }"

"{ NameSpace: SOAP }"

Object subclass:#OperaAbstractConnector
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Opera-Connector'
!


!OperaAbstractConnector methodsFor:'actions'!

send: anOperaRemoteMessage to: host port: port 
	| ret |
	ret := nil.
	self processArguments: anOperaRemoteMessage arguments.
	[ret := OperaPortableUtil
				soapSend: anOperaRemoteMessage
				host: host
				port: port
				transport: self transport]
		on: Error
		do: [:ex | 
			ex name = #SocketError
				ifTrue: [OperaError cannotConnect tag: 'cannot connect to server > host: ' , host , 'port: ' , port printString;
						 signal].
			ex name = #SocketTimeout
				ifTrue: [OperaError responceTimeout tag: 'from > host: ' , host , 'port: ' , port printString;
						 signal].
			ex pass].
	^ self processReturn: ret
! !

!OperaAbstractConnector methodsFor:'protected'!

processArguments: aCollectionOfArguments
	"##needs more work##"
	"currently obj ref argument is always registerd in root ooa"
	aCollectionOfArguments do:[:each |
		(OperaObjectReference hasInstance: each)
			ifTrue:[ OperaORB root registerObjectImplFor: each.
					"passing obj ref to server, so impl should be nil"
					each impl: nil.
			]
	].
	^aCollectionOfArguments
!

processReturn: anObject
	| obj |
	obj := anObject.
	obj class name == #OperaObjectReference ifTrue: [obj := obj asRemoteObject].
	"sort of obj ref support"
	^ obj
!

transport
	^self subclassResponsibility
! !

!OperaAbstractConnector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/opera/OperaAbstractConnector.st,v 1.3 2002/11/26 18:39:51 cg Exp $'
! !
