"{ Package: 'stx:goodies/soap/opera' }"

"{ NameSpace: SOAP }"

OperaAbstractConnector subclass:#OperaConnector
	instanceVariableNames:'delegate'
	classVariableNames:'ConnectorDict'
	poolDictionaries:''
	category:'SOAP-Opera-Connector'
!

OperaConnector class instanceVariableNames:'default useColocation'

"
 No other class instance variables are inherited by this class.
"
!


!OperaConnector class methodsFor:'accessing'!

default
	^default
! !

!OperaConnector class methodsFor:'actions'!

named: aSymbol
	^ConnectorDict at: aSymbol
!

register: anOperaConnector named: aSymbol
        ^ConnectorDict at: aSymbol asSymbol put: anOperaConnector
!

unregsiterNamed: aSymbol
	^ConnectorDict removeKey: aSymbol asSymbol 
! !

!OperaConnector class methodsFor:'class initialization'!

initialize
	"OperaConnector initialize"
	default := self new.
	self installConnectors
!

installConnectors
        "OperaConnector installConnectors"
        ConnectorDict := IdentityDictionary new.
        self register: OperaHttpConnector new named: #http.
        self register: OperaSqtpConnector new named: #sqtp.
        self register: OperaColocationConnector new named: #local.
! !

!OperaConnector class methodsFor:'setting'!

useColocation
	useColocation isNil ifTrue: [useColocation := false].
	^useColocation
!

useColocation: aBoolean
	"OperaConnector useColocation: true"
	useColocation := aBoolean
! !

!OperaConnector methodsFor:'accessing'!

delegate
	^delegate
! !

!OperaConnector methodsFor:'actions'!

send: anOperaRemoteMessage to: host port: port 
	delegate := (self useColocation
					and: [self isLocal: host port: port])
				ifTrue: [self connectorNamed: #local]
				ifFalse: [self connectorNamed: (OperaSetting defaultTransport)].
	^ delegate
		send: anOperaRemoteMessage
		to: host
		port: port
! !

!OperaConnector methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '[ ', self delegate printString, ' ]'.
! !

!OperaConnector methodsFor:'private'!

connectorNamed: aSymbol
	^self class named: aSymbol
!

isLocal: host port: port 
	^ OperaPortableUtil isLocal: host port: port 
! !

!OperaConnector methodsFor:'setting'!

useColocation
	^self class useColocation
! !

!OperaConnector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/opera/OperaConnector.st,v 1.3 2002/11/26 22:39:06 cg Exp $'
! !

OperaConnector initialize!
