"{ Package: 'stx:goodies/soap/opera' }"

"{ NameSpace: SOAP }"

Object subclass:#OperaNamedObjectHome
	instanceVariableNames:'objectDict tempObjectCounter'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Opera-Server'
!


!OperaNamedObjectHome class methodsFor:'instance creation'!

new
	^super new initialize
! !

!OperaNamedObjectHome methodsFor:'actions'!

at: aSymbol
	
	^ objectDict at: aSymbol ifAbsent:[OperaError noImplement signal: aSymbol]
!

at: aSymbol ifAbsent: aBlock
	^ objectDict at: aSymbol ifAbsent: aBlock
!

at: aSymbol ifAbsentPut: aBlock
	self checkCleanTempObjects.
	^ objectDict at: aSymbol ifAbsentPut: aBlock
!

at: aSymbol put: anObject 
	self checkCleanTempObjects.
	^ objectDict at: aSymbol put: anObject
!

removeKey: aSymbol
	^ objectDict removeKey: aSymbol 
!

removeKey: aSymbol ifAbsent: aBlock
	^ objectDict removeKey: aSymbol ifAbsent: aBlock
! !

!OperaNamedObjectHome methodsFor:'factory'!

defaultDictionary
	^IdentityDictionary new
! !

!OperaNamedObjectHome methodsFor:'initialize-release'!

initialize
	objectDict := IdentityDictionary new.
	tempObjectCounter := 0.
! !

!OperaNamedObjectHome methodsFor:'printing'!

printOn: aStream
	aStream nextPutAll:'objectHome:'.
	aStream cr. 
	objectDict printOn: aStream
! !

!OperaNamedObjectHome methodsFor:'private'!

checkCleanTempObjects
	tempObjectCounter := tempObjectCounter + 1.
	tempObjectCounter > 999999
		ifTrue: 
			[[objectDict keysAndValuesRemove: [:key :value | key beginsWith: #temp:]] valueUninterruptably.
			tempObjectCounter := 0]
! !

!OperaNamedObjectHome class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/opera/OperaNamedObjectHome.st,v 1.3 2002/11/26 18:40:01 cg Exp $'
! !
