"{ Package: 'stx:goodies/soap/opera' }"

"{ NameSpace: SOAP }"

Object subclass:#OperaObjectReference
	instanceVariableNames:'name host port impl'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Opera-Base'
!


!OperaObjectReference class methodsFor:'instance creation'!

new
	^super new initialize
!

on: anObject
	^self new impl: anObject
! !

!OperaObjectReference class methodsFor:'comparing'!

hasInstance: anObject
	"performance conscious comparison"
	^anObject class name == self name
! !

!OperaObjectReference methodsFor:'accessing'!

host
	
	^host
!

host: aValue

	host := aValue
!

impl
	
	^impl
!

impl: aValue

	impl := aValue
!

name

	^name
!

name: aValue

	name := aValue
!

port
	
	^port
!

port: aValue

	port := aValue
! !

!OperaObjectReference methodsFor:'comparing'!

= anOperaObjectReference 
	self name = anOperaObjectReference name ifFalse: [^ false].
	self host = anOperaObjectReference host ifFalse: [^ false].
	self port = anOperaObjectReference port ifFalse: [^ false].
	^ true
!

hash
	^ self name hash
! !

!OperaObjectReference methodsFor:'converting'!

asRemoteObject
	^OperaRemoteObject name: (self name) host: (self host) port: (self port) 
! !

!OperaObjectReference methodsFor:'initialize-release'!

initialize
	host := OperaPortableUtil localAddress.
	port := OperaSetting defaultPort.
!

release
	self releaseFrom: OperaORB root
!

releaseFrom: anObjectAdapter 
	anObjectAdapter removeKey: self name ifAbsent: [].
	name := host := port := impl := nil.
! !

!OperaObjectReference methodsFor:'object from disk'!

readDataFrom: aDataStream size: varsOnDisk 
	| cntInstVars |
	cntInstVars := varsOnDisk.
	"OK if fewer than now"
	aDataStream beginReference: self.
	1 to: cntInstVars do: [:i | self instVarAt: i put: aDataStream next]
!

storeDataOn: aDataStream 
	| cntInstVars |
	cntInstVars := self class instSize - 1.
	"remove impl"
	aDataStream beginInstance: self class size: cntInstVars.
	1 to: cntInstVars do: [:i | aDataStream nextPut: (self instVarAt: i)]
! !

!OperaObjectReference class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/opera/OperaObjectReference.st,v 1.3 2002/11/26 18:39:34 cg Exp $'
! !
