"{ Package: 'stx:goodies/soap/opera' }"

"{ NameSpace: SOAP }"

Object subclass:#OperaPerson
	instanceVariableNames:'name age height eyeColor'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Opera-Example'
!


!OperaPerson class methodsFor:'instance creation'!

named: aName
	^self new name: aName
!

new
	^super new initialize
! !

!OperaPerson methodsFor:'accessing'!

age
	^age
!

age: anObject
	age := anObject
!

eyeColor
	^eyeColor
!

eyeColor: anObject
	eyeColor := anObject
!

height
	^height
!

height: anObject
	height := anObject
!

name
	^name
!

name: anObject
	name := anObject
! !

!OperaPerson methodsFor:'actions'!

doBadly: something
	
	"Example3: This causes server error."
	
	self doSomething: something.

	Transcript add: #aaa. 
	
	^#done
!

doSomething: something
	

	Transcript cr; show: 'I ', '(', self name, ')', ' DO ', something printString.

	
	
!

doSomethingAndArgDoSomething: something
	
	"Example8: receive an obj ref and send it a message (callback)"

	Transcript cr; show: 'I ', '(', self name, ')', ' received!!!!'.
	Transcript cr; show: 'And forward back to -- ', something name printString. 
	something doSomething: #Smalltalk
!

doSomethingAndReturnComplex: something

	"Example2: Return complex data"
	| dict |
	self doSomething: something.

	dict :=  Dictionary new.
	dict at: #a put: 'some data'.
	dict at: #b put: 20.
	dict at: #c put: #(1 2 3 'we love smalltalk' 3.4 ).
	^dict
	
!

doSomethingAndReturnObjRef: something
	
	"Example6: Return by reference"
	self doSomething: something.

	^OperaObjectReference on: (OperaPerson named: 'Paul')
!

doSomethingAndReturnObjValue: something
	
	"Example7: Return by value"
	self doSomething: something.

	^(OperaPerson named: 'Paul')
!

doSomethingAndReturnSelf: something
	
	"Example5: self is implicitly returned by reference)"
	self doSomething: something.

	^self
!

doSomethingAndReturnSelfCopy: something
	
	"Example4: Return by value)"
	self doSomething: something.

	^self copy
!

doSomethingAndReturnSimple: something
	
	"Example1: Return simple data"
	self doSomething: something.

	^#done
	
	
! !

!OperaPerson methodsFor:'initialize-release'!

initialize
	name := 'john'.
	age := '25'.
	height := 180.
	eyeColor := #Blue
! !

!OperaPerson class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/opera/OperaPerson.st,v 1.3 2002/11/26 18:39:55 cg Exp $'
! !
