"{ Package: 'stx:goodies/soap/opera' }"

"{ NameSpace: SOAP }"

ProtoObject subclass:#OperaRemoteObject
	instanceVariableNames:'name host port'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Opera-Base'
!

OperaRemoteObject class instanceVariableNames:'showLog'

"
 No other class instance variables are inherited by this class.
"
!


!OperaRemoteObject class methodsFor:'instance creation'!

name: aSymbol host: aHost 
	^self name: aSymbol host: aHost port: nil
!

name: aSymbol host: aHost port: aPort 
	| inst |
	inst := self new.
	inst oprName: aSymbol.
	inst oprHost: aHost.
	inst oprPort: aPort.
	^inst
!

named: aSymbol
	^self name: aSymbol host: nil
! !

!OperaRemoteObject class methodsFor:'setting'!

showLog
	showLog isNil ifTrue: [showLog := false].
	^showLog
!

showLog: aBoolean
	showLog := aBoolean
! !

!OperaRemoteObject methodsFor:'accessing'!

oprHost
	host isNil ifTrue:[host := OperaSetting defaultHost].
	^host
!

oprHost: aValue

	host := aValue
!

oprName
	name isNil ifTrue:[name := 'server'].
	^name
!

oprName: aValue

	name := aValue
!

oprPort
	port isNil ifTrue:[port := OperaSetting defaultPort].
	^port	
!

oprPort: aValue

	port := aValue
!

oprShowLog
	^self class showLog
! !

!OperaRemoteObject methodsFor:'queries'!

class
    "return the receivers class"

%{  /* NOCONTEXT */

    RETURN ( __Class(self) );
%}

"
*** WARNING
***
*** this method has been automatically created,
*** since all nil-subclasses should respond to some minimum required
*** protocol.
***
*** Inspection and/or debugging of instances may not be possible,
*** if you remove/change this method. 
"
! !

!OperaRemoteObject methodsFor:'special'!

= anOperaObjectReference 
	self oprName = anOperaObjectReference oprName ifFalse: [^ false].
	self oprHost = anOperaObjectReference oprHost ifFalse: [^ false].
	self oprPort = anOperaObjectReference oprPort ifFalse: [^ false].
	^ true
!

halt
	"useful for debug"

	Halt signal
!

hash
	^ self oprPrintString hash
!

inspect
	"useful for debug"
	| dic |
	dic := IdentityDictionary new.
	dic at: #ClassName put: #RemoteObject.
	dic at: #name put: self oprName.
	dic at: #host put: self oprHost.
	dic at: #port put: self oprPort.
	Inspector openOn:  dic withEvalPane: true withLabel: ('a RemoteObject: ', (self oprName)) asSymbol
!

isRemote
	^true
!

oprEqueals: anOperaObjectReference 
	
	^self doesNotUnderstand: (Message selector: #= argument: anOperaObjectReference )
!

oprPrintString
	| aStream |
	"useful for debug"
	aStream := (String new: 64) writeStream.
	aStream nextPutAll:  'a RemoteObject( ';
		nextPutAll: self oprName, ' ) ';
		nextPutAll: 'host: ', self oprHost;
		nextPutAll: 'port: ', self oprPort printString.
	^aStream contents
	
!

printOn: aStream
	"useful for debug"
	aStream nextPutAll:  'a RemoteObject( ';
		nextPutAll: self oprName, ' ) ';
		nextPutAll: 'host: ', self oprHost;
		nextPutAll: 'port: ', self oprPort printString.
	
!

printString
	| stream |
	stream := WriteStream on: String new.
	self printOn: stream.
	^ stream contents
!

yourself
	"for optimization"

	^self
! !

!OperaRemoteObject methodsFor:'system callback'!

doesNotUnderstand: aMessage 
	| remoteMsg | 
	remoteMsg := OperaRemoteMessage
				receiverName: self oprName
				selector: aMessage selector
				arguments: aMessage arguments.
	self oprShowLog
		ifTrue: [Transcript cr; show: '++> ' , remoteMsg receiverName.
			Transcript space; show: remoteMsg selector.
			Transcript space; show: remoteMsg arguments].
	^ OperaConnector default
		send: remoteMsg
		to: self oprHost
		port: self oprPort
! !

!OperaRemoteObject class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/opera/OperaRemoteObject.st,v 1.3 2002/11/26 18:39:59 cg Exp $'
! !
