"{ Package: 'stx:goodies/soap/splash' }"

"{ NameSpace: SOAP }"

SplashRequest subclass:#SplashDOCRequest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Splash'
!

SplashDOCRequest comment:'I am a document request soap envelope.

See showHelp for examples.
'
!


!SplashDOCRequest class methodsFor:'spray examples'!

exampleAddDoc
	| request |
	request := SplashDOCRequest new.
	request addDocElement: 'foo' object: 'bar'.
	^request xmlFormatted
!

exampleAddQualified
	| request |
	request := SplashDOCRequest new.
	request addPrefix: 'b' namespace: #'urn:blah'.
	request addPrefix: 'c' namespace: #'urn:clah'.
	request addDocElement: 'foo' object: 'bar1'.
	request addDocElement: 'b:foo' object: 'bar2'.
	request addDocElement: (XePName prefix: 'c' local: 'foo') object: 'bar3'.
	request addDocElement: ('foo' ns: #'urn:notBlah') object: 'bar4'.
	^request xmlFormatted
! !

!SplashDOCRequest methodsFor:'adding'!

addDocElement: aXeQName object: anObject
	| childNode |
	childNode := bodyNode addElementNamed: (self qualify: aXeQName) rootDeclare: false.
	anObject putSplashOn: childNode context: self.
	^childNode
!

addDocElement: aXeQName xml: xmlString
	| childNode |
	childNode := bodyNode addElementNamed: (self qualify: aXeQName) rootDeclare: false.
	childNode addInsert: xmlString.
	^childNode
!

addNETMessage: anOpName ns: aNSSymbol parameters: anArrayOfAssocs
	| qName struct |
	qName := XeQName local: anOpName ns: aNSSymbol.
	struct := XeQStruct new.
	anArrayOfAssocs 
		do: [:each | struct at: (XeQName local: each key ns: aNSSymbol) put: each value].
	^self addDocElement: qName object: struct
! !

!SplashDOCRequest methodsFor:'encoding-helpers'!

useReferenceOf: anObject on: aXeNode
	^false
!

useReferenceOf: anObject on: aXeNode special: aBool
	"Answer true if the writeMap was able to encode object as a multireference."

	^false
! !

!SplashDOCRequest methodsFor:'initializing-private'!

initialize
        super initialize.
        self createEnvelope.
        prefixMap := Dolphin::LookupTable new.
        self beSchema2001
! !

!SplashDOCRequest methodsFor:'testing'!

isIDHref
	^false
!

isSoapEnc
	^false
! !

!SplashDOCRequest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/splash/SplashDOCRequest.st,v 1.5 2008/09/05 17:48:29 cg Exp $'
! !
