"
    Copyright (c) Steve Waring, 2001-2002.
    Contact: <swaring@ozemail.com.au>, <http://www.dolphinharbor.org>
"
"{ Package: 'stx:goodies/soap/splash' }"

"{ NameSpace: SOAP }"

Object subclass:#SplashREADME
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Splash'
!

!SplashREADME class methodsFor:'documentation'!

copyright
"
    Copyright (c) Steve Waring, 2001-2002.
    Contact: <swaring@ozemail.com.au>, <http://www.dolphinharbor.org>
"
!

documentation
"
    brought to ST/X, but untested. Try it or leave it.

    TestCases green except for the IXXMLDocument based ones, which depend upon
    an underlying dolphin class hierarchy.
    maybe someone ports the stuff.

    cg, fall 2009
"
!

examples
"
    Examples
            Browse the 'spray examples' method category (esp. SplashRPCRequest)
"
!

introduction
"
    Introduction
    by Ted Bracht
    http://www.tedbracht.co.uk/
    12 January 2001

    Splash is a lightweight Soap-client, based on Spray. This sentence alone gives enough feed for a page-long article. 
    What is Soap, what is Spray, what can I do with it, what does it mean and why would I want a lightweight version of it?

    Let''s start with a short description of Soap. Note, we''re not going to give a definition of Soap, 
    we''re giving a description of it. If you want definitions, start with W3C and from there have a look at 
    MSDN (see Links).

    In short, Soap [1] is an agreed way to let computers use each others services. 
    For example, you have an application that does market predictions based on the daily quantity of shares traded. 
    Your application has all kinds of complicated calculations, but requires the base data. 
    Of course you could just enter that data or ''scrape'' it off web sites. 
    Alternatively you could get expensive subscriptions which would send you the data daily in a format 
    defined by the publisher. 
    This is one of the areas where Soap offers an alternative. Instead of sending subscribers large amounts of data, 
    the publisher makes services available where the subscribers can collect exactly that amount of data that they want. 

    To extend their service, the publisher could add a service where they calculate your theoretical profit if 
    you''d bought a certain quantity of shares on a certain date.

    Nothing shocking so far, these kinds of services have been around for quite a while as well. 
    However, so far every supplier of these kinds of services offered them in their own way, each had their own API. 
    Some required dial-in facilities, others used different means. 
    With SOAP this whole area is standardised through a W3C ''note'' 
    (see W3C for the difference between notes, recommendations and the like). 
    All Soap communications use XML Information Sets and takes place in ''envelopes''. 

    Having a basic understanding of what SOAP is about, we can move on to Spray. 
    Spray is a toolbox that allows you to develop SOAP clients and servers in Dolphin Smalltalk. 
    Following the example above, with Spray you could develop the interface that requests the share trade information and 
    then build your Dolphin Smalltalk application that uses that information. 

    However, as Spray is a toolbox with which you can develop the client and the server, 
    you could also develop the application that provides these services with Spray. 
    This is where the difference lie between Spray and Splash. Splash only provides support for the SOAP service request side, 
    it doesn''t support the development of SOAP services themselves.

    As both Spray and Splash are toolboxes for Dolphin Smalltalk, 
    their main task is to convert between Soap envelopes and Smalltalk, 
    so that the developer can think and write Smalltalk; basically sending messages to objects. 
    In this case the objects are the SOAP requests or SOAP responses. 
    But they look like and work like Smalltalk objects!!

    Ted Bracht
    http://www.tedbracht.co.uk/
    12 January 2001


    --------------------------------------------------------------------------------
    [1] Soap used to stand for Simple Object Access Protocol, however, starting with the SOAP1.2 spec, 
    SOAP is no longer defined as an acronym. 
    The 'S' is no longer true, and the 'O' is also not true. 
    Soap is 'service' based, (using SOAP1.2 terminology) soap messages are sent from one soap node to another. 
    These soap nodes are more like singletons (or even class factories) than objects. 
"
!

readme
"
    Splash is a tool to;
        -Construct Soap Envelope Requests. 
        -Send them via HTTP. 
        -Decode Soap Envelope Responses

    Features
        -Soap1.1 encoding and RPC. 
        -Code size is an order of magnitude smaller than a full Spray install. 
        -This version of Splash is designed for RPC/Encoded services, but can be used for certain Doc/Literal services. 

    Splash does not have any knowledge of the interface of a Service. 
    It does not know about WSDL, and has only limited Schema knowledge.

    ToGo''s deployed using Splash are around 100kb smaller than the same app deployed using a Spray based model.
"
! !

!SplashREADME class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/splash/SplashREADME.st,v 1.3 2009/11/03 19:42:31 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/splash/SplashREADME.st,v 1.3 2009/11/03 19:42:31 cg Exp $'
! !
