"{ Package: 'stx:goodies/soap/splash' }"

"{ NameSpace: SOAP }"

Object subclass:#SplashTextDecoder
	instanceVariableNames:'otherTypes'
	classVariableNames:'Base Soap'
	poolDictionaries:''
	category:'SOAP-Splash'
!

SplashTextDecoder comment:'I am part of Splash. I can be asked for a <XeTextConverter> that can convert text/objects for a XMLSchema dataType'
!


!SplashTextDecoder class methodsFor:'instance creation'!

new
	^self basicNew initialize
! !

!SplashTextDecoder class methodsFor:'initializing'!

initialize
	"
	self initialize
	"

	self initializeBase.
	self initializeSoap
! !

!SplashTextDecoder class methodsFor:'initializing-private'!

initializeBase
        | integerC doubleC dateTimeC |
        integerC := XeTextConverter integer.
        doubleC := XeTextConverter double.
        dateTimeC := XeTextConverter dateTime.
        Base := Dolphin::LookupTable new.
        #('integer' 'int' 'long' 'short'  'nonPositiveInteger' 'nonNegativeInteger' 'positiveInteger' 'negativeInteger'
'byte' 'unsignedByte' 'unsignedInt' 'unsignedLong' 'unsignedShort') do: [ :each |
                Base at: each put: integerC].
        Base
                at: 'float' put: doubleC;
                at: 'double' put: doubleC;
                at: 'dateTime' put: dateTimeC;
                at: 'timeInstant' put: dateTimeC;
                at: 'number' put: XeTextConverter number;
                at: 'boolean' put: XeTextConverter boolean;
                at: 'decimal' put: XeTextConverter decimal;
                at: 'date' put: XeTextConverter date;
                at: 'time' put: XeTextConverter time;
                at: 'hexBinary' put: XeTextConverter hexBinary;
                at: 'base64Binary' put: XeTextConverter base64Binary.
!

initializeSoap
        Soap := Dolphin::LookupTable new.
        Soap 
                at: 'base64' put: XeTextConverter base64Binary.
!

uninitialize
	Base := Soap := nil.
! !

!SplashTextDecoder methodsFor:'accessing-private'!

atTypeName: aTypeQName put: aConverter
	otherTypes at: aTypeQName put: aConverter
!

convert: aString typeName: aTypeQName
	| converter |
	(converter := self converterFor: aTypeQName) isNil ifTrue: [^aString].
	^converter fromString: aString
!

converterFor: aTypeQName
	otherTypes at: aTypeQName ifPresent: [:value | ^value].
	(self isXSDTypeName: aTypeQName) ifTrue: [^Base at: aTypeQName localName ifAbsent: []].
	(self isSoapTypeName: aTypeQName) ifTrue: [^Soap at: aTypeQName localName ifAbsent: []].
	^nil
! !

!SplashTextDecoder methodsFor:'initializing-private'!

initialize
        super initialize.
        otherTypes := Dolphin::LookupTable new
! !

!SplashTextDecoder methodsFor:'testing-private'!

isSoapTypeName: aXeQName 
	^aXeQName namespace == XeNamespace soapEnc
!

isXSDTypeName: aXeQName 
	^XeNamespace isSchemaNS: aXeQName namespace
! !

!SplashTextDecoder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/splash/SplashTextDecoder.st,v 1.3 2002/11/20 10:31:27 cg Exp $'
! !

SplashTextDecoder initialize!
