"{ Package: 'stx:goodies/soap/splash' }"
!

!ByteArray methodsFor:'splash'!

putSplashOn: aXeNode context: aSplashContext
        "Note: for interoperability reasons it is necessary to add the inline type attribute.
        -Any soap encoder has to have alot of special case handling for base64 ... you have to
          handle the soap-enc definition as well as the xsd definition, and it also
          has the id/href 'special case inline rule'"

        (aSplashContext useReferenceOf: self on: aXeNode special: true) ifFalse: [
                self putSplashTypeOn: aXeNode context: aSplashContext.
                Smalltalk isSmalltalkX ifTrue:[
                    aXeNode addTextNode: (Base64Coder encode:self)
                ] ifFalse:[
                    aXeNode addTextNode: (Base64Encoder convert: self)
                ].
        ]

! !

!Object methodsFor:'splash'!

putSplashContentOn: aXeNode context: aSplashContext

	aXeNode addTextNode: self schemaDisplayString
	
! !

!Object methodsFor:'splash'!

putSplashOn: aXeNode context: aSplashContext

	(aSplashContext useReferenceOf: self on: aXeNode) ifFalse: [
		self putSplashContentOn: aXeNode context: aSplashContext]

	
! !

!Object methodsFor:'splash'!

putSplashTypeOn: aXeNode context: aSplashContext
	aSplashContext putXSIType: self splashTypeName on: aXeNode

	
! !

!Object methodsFor:'splash'!

splashTypeName
	^self sprayTypeName

	
! !

!SequenceableCollection methodsFor:'splash'!

putSplashArrayTypeOn: aXeNode context: aSplashContext
	aXeNode 
		setQAttribute: (XeQName soapEnc: 'arrayType')
		qName: (aSplashContext qualify: ('xsd:anyType[%1]' formatWith: self size displayString))
! !

!SequenceableCollection methodsFor:'splash'!

putSplashContentOn: aXeNode context: aSplashContext
	aSplashContext isSoapEnc 
		ifFalse: 
			[self error: 'Splash can not encode arrays in LiteralEnc'
			"The way an array encodes in soap-enc is very different to LiteralEnc. 
		If you need to do this, use an aXeQStruct . You can add multiple elements with the same name to it,
		and you should have no problems with .NET seeing it as an Array (ie a complexType with an unbounded element)"].
	self putSplashArrayTypeOn: aXeNode context: aSplashContext.
	self do: 
			[:each | 
			| itemNode |
			each putSplashOn: (itemNode := aXeNode addElement: 'item') context: aSplashContext.
			each putSplashTypeOn: (aSplashContext valueNodeFor: itemNode) context: aSplashContext]
! !

!String methodsFor:'splash'!

putSplashOn: aXeNode context: aSplashContext

	(aSplashContext useReferenceOf: self on: aXeNode special: true) ifFalse: [
		"self putSplashTypeOn: aXeNode context: aSplashContext."
		aXeNode addTextNode: self]

! !

!UndefinedObject methodsFor:'splash'!

putSplashContentOn: aXeNode context: aSplashContext

	aSplashContext putXSINilOn: aXeNode
	
! !

!UndefinedObject methodsFor:'splash'!

putSplashOn: aXeNode context: aSplashContext

	self putSplashContentOn: aXeNode context: aSplashContext

	
! !

!UndefinedObject methodsFor:'splash'!

putSplashTypeOn: aXeNode context: aSplashContext
	

	
! !

