"{ Package: 'stx:goodies/soap/splash' }"

LibraryDefinition subclass:#stx_goodies_soap_splash
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_soap_splash class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/soap/xe'    "SOAP::XeNodeDecodingAbstract - superclass of SOAP::SplashNodeDecoding "
        #'stx:goodies/soap/spray'    "SOAP::SpwSoapOutEnvelope - superclass of SOAP::SplashDOCRequest "
        #'stx:libbasic'    "Object - superclass of SOAP::SplashRequest "
        #'stx:libbasic2'    "Base64Coder - referenced by ByteArray>>putSplashOn:context: "
        #'stx:libcompat'    "Dolphin::LookupTable - referenced by SOAP::SplashRPCRequest>>initialize "
        #'stx:libview2'    "Model - superclass of SOAP::SplashModelAbstract "
    )
! !

!stx_goodies_soap_splash class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'SOAP::SplashModelAbstract'
        #'SOAP::SplashNodeDecoding'
        #'SOAP::SplashNodeReader'
        #'SOAP::SplashREADME'
        #'SOAP::SplashRequest'
        #'SOAP::SplashResponse'
        #'SOAP::SplashTextDecoder'
        #'stx_goodies_soap_splash'
        #'SOAP::SplashDOCRequest'
        #'SOAP::SplashRPCRequest'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        ByteArray putSplashOn:context:
        Object putSplashContentOn:context:
        Object putSplashOn:context:
        Object putSplashTypeOn:context:
        Object splashTypeName
        SequenceableCollection putSplashArrayTypeOn:context:
        SequenceableCollection putSplashContentOn:context:
        String putSplashOn:context:
        UndefinedObject putSplashContentOn:context:
        UndefinedObject putSplashOn:context:
        UndefinedObject putSplashTypeOn:context:
    )
! !

!stx_goodies_soap_splash class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2009\nCopyright eXept Software AG 1998-2009'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_soap_splash class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/splash/stx_goodies_soap_splash.st,v 1.2 2009/12/08 09:37:57 stefan Exp $'
! !
