"{ Package: 'stx:goodies/soap/splash/tests' }"

"{ NameSpace: SOAP }"

SplashRequestTests subclass:#SplashDOCRequestTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Splash-TestCases'
!


!SplashDOCRequestTest methodsFor:'asserting'!

assertRequestBodyXML: aString 
	self assertXML: request xml isSameAs: (
'<?xml version="1.0"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>%1</SOAP-ENV:Body>
</SOAP-ENV:Envelope>' formatWith: aString)


! !

!SplashDOCRequestTest methodsFor:'set up'!

setUp
	super setUp.
	request := SplashDOCRequest new
! !

!SplashDOCRequestTest methodsFor:'tests'!

testAddArrayException
	self should: [request addDocElement: 'foo' object: #(1 2 3)] raise: Error

!

testAddDocMultipleWiki
	request addPrefix: 'b' namespace: #'urn:blah'.
	request addDocElement: 'foo' object: 'bar1'.
	request addDocElement: 'b:foo' object: 'bar2'.
	request addDocElement: ('foo' ns: #'urn:notBlah') object: 'bar3'.
	self 
		assertRequestBodyXML: '<foo>bar1</foo>
<b:foo xmlns:b="urn:blah">bar2</b:foo>
<ns1:foo xmlns:ns1="urn:notBlah">bar3</ns1:foo>'
!

testAddDocPName
	request addPrefix: 'ns1' namespace: #'urn:blah'.
	request addDocElement: 'ns1:foo' object: 'bar'.
	self assertRequestBodyXML: 
'<ns1:foo xmlns:ns1="urn:blah">bar</ns1:foo>'


!

testAddDocUQ
	request addDocElement: 'foo' object: 'bar'.
	self assertRequestBodyXML: '<foo>bar</foo>'


!

testAddDocXmlComplex
	request addDocElement: 'foo' xml: '<abc>bar</abc>'.
	self assertRequestBodyXML: '<foo><abc>bar</abc></foo>'


!

testAddDocXmlSimple
	request addDocElement: 'foo' xml: 'bar'.
	self assertRequestBodyXML: '<foo>bar</foo>'


! !

!SplashDOCRequestTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/splash/tests/SplashDOCRequestTest.st,v 1.3 2003/01/20 19:02:15 cg Exp $'
! !
