"{ Package: 'stx:goodies/soap/splash/tests' }"

"{ NameSpace: SOAP }"

SplashTests subclass:#SplashRequestTests
	instanceVariableNames:'request'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Splash-TestCases'
!


!SplashRequestTests methodsFor:'tests'!

testAddPrefix
	self should: [request namespacePrefixed: 'blahP'] raise: Error.
	request addPrefix: 'blahP' namespace: #'urn:blah'.
	self assert: (request namespacePrefixed: 'blahP') = #'urn:blah'
	"self should: [request addPrefix: 'blahP' namespace: #urn:blah] raise: Error. "
!

testBeSchema2001
	request beSchema2001.
	self assert: request qNameXSIType = ('type' ns: XeNamespace schema2001i).
	self assertRequestBodyXML: ''
!

testExchangeTo
	| exchange |
	exchange := request exchangeTo: 'http://www.foo.com' soapAction: 'FOOAction'.
	self assert: (exchange isKindOf: SptRequestingExchange).
	self assert: (exchange immediateDestination =  'http://www.foo.com').
	self assert: (exchange soapAction =  'FOOAction').
        

!

testPutXSINilOn1999
	| node |
	request beSchema1999.
	node := self newNode: 'root'.
	request putXSINilOn: node. 
	self assertXML: node xml
		isSameAs: 
'<root xsi:null="1" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"/>'.

        

!

testPutXSINilOn2001
	| node |
	request beSchema2001.
	node := self newNode: 'root'.
	request putXSINilOn: node. 
	self assertXML: node xml
		isSameAs: 
'<root xsi:nil="true" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"/>'.

        

!

testPutXSITypeOn1999
	| node |
	request beSchema1999.
	node := self newNode: 'root'.
	request putXSIType: 'xsd:string' on: node. 
	self assertXML: node xml
	isSameAs: 
'<root xsi:type="xsd:string" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema"/>'.

        

!

testPutXSITypeOn2001
	| node |
	request beSchema2001.
	node := self newNode: 'root'.
	request putXSIType: 'xsd:string' on: node. 
	self assertXML: node xml
	isSameAs: 
'<root xsi:type="xsd:string" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"/>'.

        

! !

!SplashRequestTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/splash/tests/SplashRequestTests.st,v 1.3 2003/01/20 19:02:15 cg Exp $'
! !
