"{ Package: 'stx:goodies/soap/splash/tests' }"

"{ NameSpace: SOAP }"

SplashTests subclass:#SplashTextDecoderTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Splash-TestCases'
!


!SplashTextDecoderTest methodsFor:'accessing'!

getBaseXSDTypes
	^(OrderedCollection new)
		add: #('abc' 'string' 'abc');
		add: #('127' 'byte' 127);
		add: #('3.14' 'float' 3.14);
		add: #('a b' 'ID' 'a b');
		add: #('a b' 'IDREF' 'a b');
		add: #('a b' 'name' 'a b');
		add: #('a b' 'NCName' 'a b');
		add: #('abc' 'NMTOKEN' 'abc');
		add: #('abc' 'normalizedString' 'abc');
		add: #('abc' 'token' 'abc');
		add: #('2147483647' 'int' 2147483647);
		add: #('2147483647' 'long' 2147483647);
		add: #('-123' 'negativeInteger' -123);
		add: #('123' 'nonNegativeInteger' 123);
		add: #('-123' 'nonPositiveInteger' -123);
		add: #('123' 'positiveInteger' 123);
		add: #('123' 'short' 123);
		add: #('123' 'unsignedByte' 123);
		add: #('123' 'unsignedInt' 123);
		add: #('123' 'unsignedLong' 123);
		add: #('123' 'unsignedShort' 123);
		add: #('123' 'number' 123);
		add: #('123' 'integer' 123);
		add: #('123' 'int' 123);
		add: #('3.14' 'double' 3.14);
		add: #('abc' 'anyURI' 'abc');
		add: #('1' 'boolean' true);
		add: (Array 
					with: '3.145'
					with: 'decimal'
					with: '3.145s' asNumber);
		add: (Array 
					with: '00'
					with: 'hexBinary'
					with: #[0]);
		add: (Array 
					with: '1999-05-31Z'
					with: 'date'
					with: (XeXsdDate fromString: '1999-05-31Z'));
		add: (Array 
					with: '13:20:00Z'
					with: 'time'
					with: (XeXsdTime fromString: '13:20:00Z'));
		add: (Array 
					with: '1999-05-31T13:20:00Z'
					with: 'dateTime'
					with: (XeXsdDateTime fromString: '1999-05-31T13:20:00Z'));
		add: (Array 
					with: '1999-05-31T13:20:00Z'
					with: 'timeInstant'
					with: (XeXsdDateTime fromString: '1999-05-31T13:20:00Z'));
		add: (Array 
					with: 'MTIzNDU2YWJjLC48PiQ='
					with: 'base64Binary'
					with: '123456abc,.<>$' asByteArray);
		yourself
! !

!SplashTextDecoderTest methodsFor:'tests'!

testOther
	| textC typeName |
	typeName := 'boolean' ns: XeNamespace schema2001.
	textC := SplashTextDecoder new.
	textC atTypeName: typeName put: XeTextConverter string.
	self assert: (textC convert: 'true' typeName: typeName) = 'true'
!

testSoap
	| textC |
	textC := SplashTextDecoder new.
	self 
		assert: (textC convert: 'MTIzNDU2YWJjLC48PiQ=' typeName: ('base64' ns: XeNamespace soapEnc)) 
				= '123456abc,.<>$' asByteArray
!

testXSD
	| textC |
	textC := SplashTextDecoder new.
	self getBaseXSDTypes do: [ :each | 
		self assert: (textC 
			convert: each first 
			typeName: (XeQName local: each second ns: XeNamespace schema2001)) = each third. 
		self assert: (textC 
			convert: each first 
			typeName: (XeQName local: each second ns: XeNamespace schema1999)) = each third]. 
! !

!SplashTextDecoderTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/splash/tests/SplashTextDecoderTest.st,v 1.3 2003/01/20 19:02:15 cg Exp $'
! !
