"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/soap/spray' }"

HTTPService subclass:#HTTPSoapSprayService
	instanceVariableNames:'service'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTTP-Services'
!

!HTTPSoapSprayService class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!HTTPSoapSprayService methodsFor:'private'!

getSoapActionFrom:aString 
    |trimmed|

    (aString isNil or:[ (trimmed := aString trimBlanks) size <= 2 ]) ifTrue:[
        ^ ''
    ].
    ^ trimmed first = $" 
        ifTrue:[ trimmed copyFrom:2 to:trimmed size - 1 ]
        ifFalse:[ trimmed ]
!

processExchange:exchange 
    self soapNode process:exchange
!

responseFor:answer 
    ^ answer isFault 
        ifTrue:[ self faultResponse:answer ]
        ifFalse:[ self okResponse:answer ]
!

xsiNS
    ^ service xsiNamespace
! !

!HTTPSoapSprayService methodsFor:'processing'!

process:aHttpRequest

    | answer exchange xmlString|

self halt.

    [
        xmlString := aHttpRequest body.
        exchange := SOAP::SptRespondingExchange onXmlString: xmlString xsiNS: self xsiNS
    ] on: Error do: [:ex | 
        aHttpRequest reportException:ex
        "/ not reached
    ].
    exchange
            atQP: #'action:SOAPActionURI'
                    put: (self getSoapActionFrom: (aHttpRequest fieldValueFor:#SOAPAction));
            atQP: #'transport:peer' put: aHttpRequest peer;
            atQP: #'transport:ImmediateSource' put: aHttpRequest peer.
    exchange isContinueState ifTrue: [self processExchange: exchange].
    ^self responseFor: exchange out.

    [
        answer := service process:self.
    ] on:Error do:[:ex| 
        aHttpRequest reportException:ex
        "/ not reached
    ].

    answer isNil ifTrue:[
        aHttpRequest reportServiceUnavailable:'SOAP Service not available'.
        "/ not reached
    ].
    aHttpRequest reply:answer data.
    aHttpRequest sendResponseWithType:answer contentType.
    ^ self.
! !

!HTTPSoapSprayService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/HTTPSoapSprayService.st,v 1.2 2005/12/28 12:32:48 cg Exp $'
! !
