"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpAuthDigestAuthorizer subclass:#SpDigestAuthRFC2617
	instanceVariableNames:'privateNonceKey'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Auth'
!


!SpDigestAuthRFC2617 methodsFor:'accessing'!

privateNonceKey
	privateNonceKey isNil ifTrue: [privateNonceKey := 'dolphin'].
	^privateNonceKey
!

privateNonceKey: aString
	privateNonceKey := aString
! !

!SpDigestAuthRFC2617 methodsFor:'operations'!

generateNonce
	"RFC2617 3.2.1 recommendation"

	^self generateNonceFor: XeXsdDateTime current
!

generateNonceFor: aTimeStamp
        "Private - RFC2617 3.2.1 recommendation"

        | tss |
        tss := aTimeStamp schemaDisplayString.
        ^(tss , (SOAP::SpAuthDigestAuthorizer MD5_hMessage: "MD5 hMessage:" (tss , ':' , self etag ,':' , self privateNonceKey))) asByteArray printSchemaHexString
! !

!SpDigestAuthRFC2617 methodsFor:'testing'!

isExpiredNonce: aString 
	^false
! !

!SpDigestAuthRFC2617 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SOAP__SpDigestAuthRFC2617.st,v 1.2 2008/09/07 16:18:16 cg Exp $'
! !
