"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpDigestAuthRFC2617 subclass:#SpDigestAuthRFC2617Timed
	instanceVariableNames:'expireSeconds'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Auth'
!


!SpDigestAuthRFC2617Timed methodsFor:'accessing'!

expireSeconds
        expireSeconds isNil ifTrue: [expireSeconds := (2 * 60)].
        ^expireSeconds
!

expireSeconds: anInteger
	expireSeconds := anInteger
! !

!SpDigestAuthRFC2617Timed methodsFor:'helpers'!

extractNonceTimeStamp: aString
	"'1999-05-31T13:20:00Z............"

	^XeXsdDateTime 
		fromString: ((ByteArray fromHexString: aString) asString copyFrom: 1 to: 20)
!

isExpiredNonce: aString for: currentTS 
	| ts expired valid |
	[ts := self extractNonceTimeStamp: aString.
	expired := self isExtracted: ts expired: currentTS.
	valid := (self generateNonceFor: ts) = aString] 
			on: Error
			do: [:e | ^true].
	^expired | valid not
!

isExtracted: ts expired: currentTS 
	^currentTS asNative asSeconds - ts asNative asSeconds > self expireSeconds
! !

!SpDigestAuthRFC2617Timed methodsFor:'testing'!

isExpiredNonce: aString 
	^self isExpiredNonce: aString for: XeXsdDateTime current
! !

!SpDigestAuthRFC2617Timed class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SOAP__SpDigestAuthRFC2617Timed.st,v 1.1 2008/09/07 16:09:22 cg Exp $'
! !
