"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

Object subclass:#SpdSelectorItem
	instanceVariableNames:'selector generator generate'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Development'
!

SpdSelectorItem comment:'I am used by a SpdMetaDataGenerator during source analysis. I *was* used a part of a UI.

I represent a method of the source class, and I control whether a <SpmdOperation> is created for my method.

Instance Variables:
	selector		<Symbol>
	generator		<SpdMetaDataGenerator>
	generate		<Boolean>'
!


!SpdSelectorItem methodsFor:'accessing'!

existingImageIndex
	^self hasExistingOperation icon imageIndex
!

generate
	^generate
!

generate: aBoolean
	generate := aBoolean
!

generateImageIndex
	^self generate icon imageIndex
!

generator
	^generator
!

generator: anObject
	generator := anObject
!

hasExistingOperation
	^self generator includesOperationFor: self selector
!

method 
	^self generator methodFor: self selector
!

methodImageIndex
	^self method icon imageIndex
!

selector
	^selector
!

selector: aSelectorSymbol
	selector := aSelectorSymbol
! !

!SpdSelectorItem methodsFor:'modes'!

doGenerate
	generate := true
!

dontGenerate
	generate := false
!

toggleGenerate
	generate := generate not
! !

!SpdSelectorItem methodsFor:'testing'!

shouldGenerate
	^self generate 
		and: [self hasExistingOperation not 
		or: [self generator replaceExisting]]
! !

!SpdSelectorItem class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SOAP__SpdSelectorItem.st,v 1.1 2008/09/07 16:35:39 cg Exp $'
! !
