"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpmdOperation subclass:#SpmdDOCOperation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Meta'
!


!SpmdDOCOperation class methodsFor:'instance creation'!

createEnc: aString namespace: aSymbol selector: aSymbol2 inputParts: anArray outputParts: anArray2
	| instance inputMessage outputMessage |
	instance := self named: aString.
	inputMessage := SpmdMessage onParts: anArray.
	outputMessage := SpmdMessage onParts: anArray2.
	instance
		inputBody: (SpmdSoapBody soapEncMessage: inputMessage ns: aSymbol) beDOCHandler;
		outputBody: (SpmdSoapBody soapEncMessage: outputMessage ns: aSymbol) beDOCHandler;
		renameMessages.
	instance inputBody docSelector: aSymbol2.
	^instance
!

createLit: aString selector: aSymbol inputPart: aSpmdElementPart outputPart: aSpmdElementPart2 
	"Common in doc/literal to have single part messages"

	^self 
		createLit: aString 
		selector: aSymbol 
		inputParts: (Array with: aSpmdElementPart)
		outputParts: (Array with: aSpmdElementPart2)
!

createLit: aString selector: aSymbol2 inputParts: anArray outputParts: anArray2
	| instance |
	instance := self named: aString.
	instance
		inputBody: (SpmdSoapBody literalMessage: (SpmdMessage onParts: anArray)) beDOCHandler;
		outputBody: (SpmdSoapBody literalMessage: (SpmdMessage onParts: anArray2)) beDOCHandler.
	anArray first selector: aSymbol2.
	instance renameMessages.
	^instance
! !

!SpmdDOCOperation methodsFor:'accessing'!

selectors
	"Answer a collection of selectors (document style theoretically could have multiple selectors)"

	^inputBody docSelectors
!

style
	^'document'
! !

!SpmdDOCOperation methodsFor:'accessing-private'!

inEnvelopeClass
	^SpwInDocument
!

outEnvelopeClass
	^SpwOutDocument
! !

!SpmdDOCOperation methodsFor:'testing'!

isDOC
	^true
! !

!SpmdDOCOperation methodsFor:'wire creation-coder-private'!

bodyInputCodersIn: aXeTypespace
	"Create and answer a collection of <SpwSoapBCoder>s from the receivers description of the soap:Body
	Note: in rpc style, (and typically in document style) there is only 1 	<SpwSoapBCoder>.
	The <SpwSoapBCoder> is used by both clients and servers to encode/decode objects/xml"

	^inputBody docCodersIn: aXeTypespace
!

bodyOutputCodersIn: aXeTypespace
	"Create and answer a collection of <SpwSoapBCoder>s from the receivers description of the soap:Body
	Note: in rpc style, (and typically in document style) there is only 1 <SpwSoapBCoder>
	The <SpwSoapBCoder> is used by both clients and servers to encode/decode objects/xml"

	^outputBody docCodersIn: aXeTypespace
! !

!SpmdDOCOperation methodsFor:'wire creation-handler-private'!

bodyHandlersIn: aXeTypespace
	"Create and answer all the <SpwSoapBHandler>s from the receiver's description of the soap:Body
	Notes: 
		-Handlers are used by servers.
		-In rpc style, (and typically in document style) there is 1 body handler for each operation., which is
			constructed from the  combined information in  the input and output <SpmdSoapBody>s"

	| handlers outputCoders |
	handlers := (inputBody docHandlersIn: aXeTypespace) 
				do: [:each | each soapAction: self soapAction].
	outputCoders := outputBody docCodersIn: aXeTypespace.
	outputCoders size = handlers size 
		ifFalse: 
			[self 
				error: 'For Document style operations, number of input and output parts must be equal'].
	handlers with: outputCoders
		do: [:eachHandler :eachCoder | eachHandler outputEncoder: eachCoder].
	^handlers
! !

!SpmdDOCOperation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpmdDOCOperation.st,v 1.1 2002/11/18 19:34:36 cg Exp $'
! !
