"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpmdPart subclass:#SpmdElementPart
	instanceVariableNames:'elementName'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Meta'
!

SpmdElementPart comment:'I am a part that uses a ''name attribute'' to refer to a declaration in a XMLSchema'
!


!SpmdElementPart class methodsFor:'instance creation'!

fromWSDLElementPart: aXeNode
	^self partName: (self nameFromPartNode: aXeNode)
		elementName: (aXeNode qValueFor: 'element')
!

partName: aString elementName: aXeQName
	aXeQName isNullNamespace ifTrue: [self error: 'Part element is not qualified'].
	^self new partName: aString elementName: aXeQName
! !

!SpmdElementPart methodsFor:'accessing'!

docSpecQualifyingIn: aNSSymbolOrNil
	"Answer a <XeElementSpec>"

	^elementName
!

partName: aString elementName: aXeQName 
	partName := aString.
	elementName := aXeQName
!

rpcSpec
	self error: 'Spray does not support rpc/literal'
! !

!SpmdElementPart methodsFor:'accessing-private'!

elementName
	^elementName
! !

!SpmdElementPart methodsFor:'printing'!

putSpraySignatureOn: aWriteStream
	"Put a readable description string on the stream for documentation purposes"

	aWriteStream
		display: $(;
		display: partName;
		space;
		nextPutAll: elementName qString;
		display: ')'
! !

!SpmdElementPart methodsFor:'wsdl-private'!

definePart: aWSDLMessageNode 
	(aWSDLMessageNode addElement: 'part')
		setAttribute: 'name' value: partName;
		setAttribute: 'element' qName: elementName
!

definePart: aWSDLMessageNode in: typespace 
	self definePart: aWSDLMessageNode 
! !

!SpmdElementPart class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpmdElementPart.st,v 1.1 2002/11/18 19:42:03 cg Exp $'
! !
