"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

Object subclass:#SpmdPart
	instanceVariableNames:'partName selector unused1'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Meta'
!

SpmdPart comment:'I am a web service operation''s part. I am the metadata that describes a parameter of a soap message that my port will accept and process

Instance Variables
	partName		<String>
	selector 		<selector>

Note: the selector instance variable is only used when the part is owned by a document style operation. (a "part" in document style describes a soapBlock, while a "part" in rpc describes a parameter)'
!


!SpmdPart class methodsFor:'instance creation'!

fromWSDLPart: aXeNode
	^(aXeNode getAttribute: 'element') isNil 
		ifTrue: [SpmdTypePart fromWSDLTypedPart: aXeNode]
		ifFalse: [SpmdElementPart fromWSDLElementPart: aXeNode]
! !

!SpmdPart class methodsFor:'constants'!

icon
	^SpmdPort icon
! !

!SpmdPart class methodsFor:'helpers'!

nameFromPartNode: aXeNode
	| pName |
	self assert: [aXeNode localName = 'part'].
	pName := aXeNode getAttribute: 'name'.
	(pName isNil or: [pName isEmpty]) ifTrue: [self error: 'Part name not valid'].
	^pName
! !

!SpmdPart methodsFor:'accessing'!

docSpecQualifyingIn: aNSSymbol
	"Answer a <XeElementSpec>"

	^self subclassResponsibility
!

rpcSpec
	^self subclassResponsibility
! !

!SpmdPart methodsFor:'accessing-private'!

partName
	^partName
!

selector
	^selector
!

selector: aSymbol 
	"This is only used for Parts in Document style operations. It is necessary, if the semantics of the Soap1.2 spec are to be followed, whereby each 'soapBlock' .For Document style, each part will become the handler for a soapBlock"

	selector := aSymbol 
! !

!SpmdPart methodsFor:'printing & storing'!

printOn: aStream
    super printOn:aStream.
    aStream nextPut:$(.
    partName printOn:aStream.
    aStream nextPut:$).
! !

!SpmdPart class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpmdPart.st,v 1.2 2005/02/09 12:55:05 stefan Exp $'
! !
