"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpmdOperation subclass:#SpmdRPCOperation
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Meta'
!


!SpmdRPCOperation class methodsFor:'instance creation'!

createEnc: aString namespace: aSymbol selector: aSymbol2 inputParts: anArray outputParts: anArray2
	| instance inputMessage outputMessage |
	instance := self named: aString.
	inputMessage := SpmdMessage onParts: anArray.
	outputMessage := SpmdMessage onParts: anArray2.
	instance
		inputBody: (SpmdSoapBody soapEncMessage: inputMessage ns: aSymbol);
		outputBody: (SpmdSoapBody soapEncMessage: outputMessage ns: aSymbol).
	instance inputBody selector: aSymbol2.
	instance renameMessages.
	^instance
!

createLit: aString selector: aSymbol2 inputPart: aPart1 outputPart: aPart2
	^self 
		createLit: aString 
		selector: aSymbol2 
		inputParts: (Array with: aPart1)
		outputParts: (Array with: aPart2)
!

createLit: aString selector: aSymbol2 inputParts: anArray outputParts: anArray2
	| instance |
	instance := self named: aString.
	instance
		inputBody: (SpmdSoapBody literalMessage: (SpmdMessage onParts: anArray));
		outputBody: (SpmdSoapBody literalMessage: (SpmdMessage onParts: anArray2)).
	instance inputBody selector: aSymbol2.
	instance renameMessages.
	^instance
! !

!SpmdRPCOperation methodsFor:'accessing'!

selectors
	"Answer a collection of selectors (document style theoretically could have multiple selectors)"

	^Array with: inputBody selector
!

style
	^'rpc'
! !

!SpmdRPCOperation methodsFor:'accessing-private'!

inEnvelopeClass
	^SpwRPCReturn
!

outEnvelopeClass
	^SpwRPC
! !

!SpmdRPCOperation methodsFor:'testing'!

isRPC
	^true
! !

!SpmdRPCOperation methodsFor:'wire creation-coder-private'!

bodyInputCodersIn: aXeTypespace
	"Create and answer a collection of <SpwSoapBCoder>s from the receivers description of the soap:Body
	Note: in rpc style, (and typically in document style) there is only 1 	<SpwSoapBCoder>.
	The <SpwSoapBCoder> is used by both clients and servers to encode/decode objects/xml"

	^Array with: (inputBody rpcInputCoderIn: aXeTypespace)
!

bodyOutputCodersIn: aXeTypespace
	"Create and answer a collection of <SpwSoapBCoder>s from the receivers description of the soap:Body
	Note: in rpc style, (and typically in document style) there is only 1 <SpwSoapBCoder>
	The <SpwSoapBCoder> is used by both clients and servers to encode/decode objects/xml"

	^Array with: (outputBody rpcOutputCoderIn: aXeTypespace)
! !

!SpmdRPCOperation methodsFor:'wire creation-handler-private'!

bodyHandlersIn: aXeTypespace
	"Create and answer all the <SpwSoapBHandler>s from the receiver's description of the soap:Body
	Notes: 
		-Handlers are used by servers.
		-In rpc style, (and typically in document style) there is 1 body handler for each operation., which is
			constructed from the  combined information in  the input and output <SpmdSoapBody>s"

	^Array with: (self rpcBodyHandlerIn: aXeTypespace)
!

rpcBodyHandlerIn: aXeTypespace
	"Create and answer the <SpwSoapBHandler> from the receiver's description of the soap:Body
	Notes: 
		-Handlers are used by servers.
		-In rpc style, (and typically in document style) there is 1 body handler for each operation, which is
			constructed from the  combined information in  the input and output <SpmdSoapBody>s"

	| handler |
	handler := inputBody rpcHandlerIn: aXeTypespace.
	handler soapAction: self soapAction.
	handler outputEncoder: (outputBody rpcOutputCoderIn: aXeTypespace).
	^handler
! !

!SpmdRPCOperation class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpmdRPCOperation.st,v 1.1 2002/11/18 19:40:26 cg Exp $'
! !
