"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpmdPart subclass:#SpmdTypePart
	instanceVariableNames:'typeName'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Meta'
!

SpmdTypePart comment:'I am a part that uses a ''type'' attribute to refer to a definition in a XMLSchema'
!


!SpmdTypePart class methodsFor:'instance creation'!

fromWSDLTypedPart: aXeNode
	| typeName |
	typeName := aXeNode qValueForType.
	typeName isNullNamespace ifTrue: [self error: 'Part type is not qualified'].
	^self partName: (self nameFromPartNode: aXeNode) typeName: typeName
!

partName: aString typeName: aXeName 
	^self new partName: aString typeName: aXeName asXeName
! !

!SpmdTypePart methodsFor:'accessing'!

docSpecQualifyingIn: aNSSymbol
	"Answer a <XeElementSpec>"

	^XeElementSpec named: (XeQName local: partName ns: aNSSymbol) typeName: typeName
!

rpcSpec
	"Answer a <XeElementSpec>"

	^XeElementSpec named: partName typeName: typeName
!

sourceFormat
	^Array with: partName with: typeName qString
! !

!SpmdTypePart methodsFor:'accessing-private'!

partName: aString typeName: aXeQName
	partName := aString.
	typeName := aXeQName
!

typeName
	^typeName
! !

!SpmdTypePart methodsFor:'printing'!

putSpraySignatureOn: aWriteStream
	"Put a readable description string on the stream for documentation purposes"

	aWriteStream
		display: $(;
		display: partName;
		space;
		nextPutAll: typeName qString;
		display: ')'
! !

!SpmdTypePart methodsFor:'wsdl-private'!

definePart: aWSDLMessageNode in: typespace 
	(aWSDLMessageNode addElement: 'part')
		setAttribute: 'name' value: partName;
		setAttribute: 'type' qName: (typespace qualify: typeName)
! !

!SpmdTypePart class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpmdTypePart.st,v 1.1 2002/11/18 19:39:41 cg Exp $'
! !
