"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SprayLocalService subclass:#SprayAdminServiceAbstract
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Service'
!

SprayAdminServiceAbstract comment:'Deprecated'
!


!SprayAdminServiceAbstract methodsFor:'accessing-receiving objects-private'!

authenticatorBlockReceiver
	^SpwSoapBReceiver receiveFor: SpraySimpleAuthorizer new
		at: #'http://www.dolphinharbor.org/spray/harborAuthentication'
!

guardedBlockReceiver
	^(SpwSoapBReceiver receiveFor: self operationModel
		at: self operationModelClass sprayPortNamespace)
		addGuard: self receiverGuard;
		yourself
!

receiverGuard
	^SpwPlugableGuard new guardBlock: 
			[:exchange | 
			exchange atQP: #'user:authenticated'
				ifAbsent: [SoapServerFault beClient signal: 'Not Authenticated']]
!

soapBReceivers
	^OrderedCollection with: self authenticatorBlockReceiver with: self guardedBlockReceiver
! !

!SprayAdminServiceAbstract methodsFor:'constants-private'!

schemaImport
	^'<schema 
xmlns="http://www.w3.org/2001/XMLSchema" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
targetNamespace="http://www.dolphinharbor.org/spray/harborAuthentication"
xmlns:tns="http://www.dolphinharbor.org/spray/harborAuthentication"
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" 
elementFormDefault="qualified">
<complexType name="HarborAuthenticationType">
<all>
	<element name="username" type="xsd:string"/>
	<element name="password" type="xsd:string"/>
</all>
</complexType>
<element name="harborAuthentication" type="tns:HarborAuthenticationType"/>
</schema>'
! !

!SprayAdminServiceAbstract methodsFor:'event handling-private'!

onTypespaceCreated
	"Private - Modify the default typespace"

	super onTypespaceCreated.
	"This modifies the typespace by including the XMLSchema created from the xml string, at it's targetNamespace in the typespace. 
	-The definitions and declarations can then be used in the service (ie in the operationModelClasses methods, or as part of other definitions)"
	typespace addSchemaString: self schemaImport
! !

!SprayAdminServiceAbstract methodsFor:'port generation-private'!

onPortGenerated: port
	"Handle the onPortGenerated event. See superclass #onPortGenerated: comment."

	| header headerName |
	super onPortGenerated: port.
	headerName := 'harborAuthentication' 
				ns: #'http://www.dolphinharbor.org/spray/harborAuthentication'.
	header := (SpmdSoapHeader literalDeclared: headerName) beNotOwned.
	port operations do: [:each | each addInputHeader: header]
! !

!SprayAdminServiceAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SprayAdminServiceAbstract.st,v 1.1 2002/11/18 19:37:03 cg Exp $'
! !
