"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SprayService subclass:#SprayCachedService
	instanceVariableNames:'service'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Service'
!

SprayCachedService comment:'I am the interface of a web service that is created from a locally cached WSDL.

This trades off the benefit of not needing to download the WSDL with the cost of storing the WSDL''s xml in the image.

Instance Variables:
	service 	<SprayWSDLService> the service created from the WSDL''s xml

=========
Implementation:
I wrap a SprayWSDLService and can modify it to suit. For example a number of the samples modify the typespace so that instances of specified classes can be encoded and decoded (instead of the XMLSchema default instances of XeQStruct)'
!


!SprayCachedService class methodsFor:'constants'!

externalWSDL
	self subclassResponsibility
!

externalWSDLPortName
	^nil
! !

!SprayCachedService methodsFor:'accessing-port-private'!

operationPort
	"Answer a SpmdPort"

	^self service operationPort
! !

!SprayCachedService methodsFor:'accessing-private'!

externalWSDL
	^self class externalWSDL
!

externalWSDLPortName
	^self class externalWSDLPortName
!

service
	service isNil 
		ifTrue: 
			[service := SprayWSDLService onExternalWSDL: self externalWSDL
						portName: self externalWSDLPortName].
	^service
!

service: anObject
	service := anObject
! !

!SprayCachedService methodsFor:'accessing-service'!

destinationUrl
	"Answer a default destinationUrl <String> that will be used by clients created from this service"

	^self service destinationUrl
! !

!SprayCachedService methodsFor:'typespace creation-private'!

createTypespace
	"Answer the typespace from the wsdlServiceImport. 
	-This typespace is a defaultSoapEnc typespace with the schemas from
	the WSDL <types> section imported"

	^self service typespace

! !

!SprayCachedService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SprayCachedService.st,v 1.1 2002/11/18 19:34:04 cg Exp $'
! !
