"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

Object subclass:#SprayExchangeFactory
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Client'
!


!SprayExchangeFactory class methodsFor:'constants'!

icon
    "/ dolphin only
    Smalltalk isSmalltalkX ifTrue:[
        ^ nil
    ] ifFalse:[
        ^Dolphin::SWEnvironment spIconNamed: 'client.ico'
    ]
! !

!SprayExchangeFactory methodsFor:'operations'!

send: opNameString with: anObject
	"Answer a <SpwRequestingExchange> which can be used to invoke the operation opNameString.
	The argument is encoded as a parameter. (the parameter name is found the operation's RPCWrapper <XeElement>)
	Note: this does not  actually 'send' anything, but answers an <SpwRequestingExchange> that  can be processed to transport the soap messages"

	^self send: opNameString withArguments: (Array with: anObject)
!

send: opNameString with: anObject1 with: anObject2
	"See #send:with: comment"

	^self send: opNameString withArguments: (Array with: anObject1 with: anObject2)
!

send: opNameString with: anObject1 with: anObject2 with: anObject3
	"See #send:with: comment"

	^self send: opNameString
		withArguments: (Array 
				with: anObject1
				with: anObject2
				with: anObject3)
!

send: opNameString with: anObject1 with: anObject2 with: anObject3 with: anObject4
	"See #send:with: comment"

	^self send: opNameString
		withArguments: (Array 
				with: anObject1
				with: anObject2
				with: anObject3
				with: anObject4)
!

send: opNameString with: anObject1 with: anObject2 with: anObject3 with: anObject4 with: anObject5
	"See #send:with: comment"

	^self send: opNameString
		withArguments: (Array 
				with: anObject1
				with: anObject2
				with: anObject3
				with: anObject4
				with: anObject5)
!

send: opNameString withArguments: aCollection 
	^self subclassResponsibility
! !

!SprayExchangeFactory methodsFor:'printing'!

displayString
    Smalltalk isSmalltalkX ifTrue:[
        ^ String streamContents:[:s | self displayOn:s]
    ].
    ^ super displayString
! !

!SprayExchangeFactory class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SprayExchangeFactory.st,v 1.4 2010/02/26 12:02:14 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SprayExchangeFactory.st,v 1.4 2010/02/26 12:02:14 cg Exp $'
! !
