"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SprayLocalService subclass:#SprayExternalWSDLServiceAbstract
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Service'
!

SprayExternalWSDLServiceAbstract comment:'This class is a superclass for services that are implemented by using a 3rd party WSDL, and attaching selectors to the operations. This is an easy way to quickly implement services without having to do source analysis etc'
!


!SprayExternalWSDLServiceAbstract methodsFor:'accessing-private'!

wsdlServiceImport
	^SprayWSDLService onExternalWSDL: self externalWSDL portName: nil
! !

!SprayExternalWSDLServiceAbstract methodsFor:'constants-private'!

externalWSDL
	^self subclassResponsibility
! !

!SprayExternalWSDLServiceAbstract methodsFor:'event handling-private'!

onTypespaceCreated
	"Private - Modify the default typespace"

	| wsdlDefs |
	super onTypespaceCreated.
	"This modifies the typespace by extracting the schema's from the external WSDL, and adding them to the tyepspace.
	-The definitions and declarations can then be used in the service (ie in the OperationModels methods, or as part of other definitions)"
	wsdlDefs := WSDLDefinitions onDocument: (XeEnvironment rootNodeFor: self externalWSDL)
				transport: nil.
	wsdlDefs extractSchemas do: [:each | typespace addSchemaNode: each]
! !

!SprayExternalWSDLServiceAbstract methodsFor:'port generation-private'!

generateOperationPort
	"Generate and answer a <SpmdPort>. 
	Use the External WSDL method of generating the <SpmdPort>"

	^self subclassResponsibility
! !

!SprayExternalWSDLServiceAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SprayExternalWSDLServiceAbstract.st,v 1.1 2002/11/18 19:38:04 cg Exp $'
! !
