"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SprayExchangeFactory subclass:#SprayMessage
	instanceVariableNames:'operationName arguments'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Client'
!

SprayMessage comment:'I am the information that is used to construct an exchange to a soap server. 

This is a new class needed for async messaging (see the TerraClient sample) 

(SW: I may refactor other classes to make use of this class, however this (async messaging) was my first need for this class)

'
!


!SprayMessage methodsFor:'accessing'!

arguments
	^arguments
!

exchangeFrom: aSprayClient 
	^aSprayClient send: operationName withArguments: arguments
!

operationName
	^operationName
!

send: opNameString withArguments: aCollection 
	operationName := opNameString.
	arguments := aCollection
! !

!SprayMessage methodsFor:'comparing'!

= aSprayMessage
	^self species == aSprayMessage species
		and: [operationName = aSprayMessage operationName 
		and: [arguments = aSprayMessage arguments ]]
!

hash
	^operationName hash bitXor: arguments hash 

! !

!SprayMessage methodsFor:'displaying'!

displayOn: aWriteStream 
	aWriteStream 
		display: operationName;
		space;
		display: arguments
! !

!SprayMessage class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SprayMessage.st,v 1.1 2002/11/18 19:38:37 cg Exp $'
! !
