"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

Model subclass:#SprayModelAbstract
	instanceVariableNames:'sprayClient'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Service'
!

SprayModelAbstract comment:'I am an abstract model for SprayClients that are used to send a single soap message at a time.

I wrap the Spray client, and trigger status events as the exchange is processed.

Instance Variables:
	sprayClient 	<SprayClient>'
!


!SprayModelAbstract methodsFor:'accessing-private'!

serviceClass
	"Answer the <SprayService> for this model"

	^self subclassResponsibility
!

sprayClient
	"Private - Answer the value of the receiver's ''sprayClient'' instance variable."

	^sprayClient
!

sprayClient: aSprayClient
	sprayClient := aSprayClient
! !

!SprayModelAbstract methodsFor:'event handling'!

onStateChanged: aStateString
	self trigger: #stateChanged: with: aStateString


	
! !

!SprayModelAbstract methodsFor:'initializing'!

initialize
	super initialize.
	sprayClient := self serviceClass new createClient
! !

!SprayModelAbstract methodsFor:'operations'!

valueFor: anExchange
	anExchange when: #stateChanged: send: #onStateChanged: to: self.
	anExchange processUsingDefault.
	anExchange decode.
	^anExchange extractReturn

! !

!SprayModelAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SprayModelAbstract.st,v 1.1 2002/11/18 19:37:36 cg Exp $'
! !
