"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

Object subclass:#SprayServerEndPointHTML
	instanceVariableNames:'server'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Service'
!

SprayServerEndPointHTML comment:'I am the html that is answered when a SprayServer is asked about itself.
The SpSwazooBinding responds with this html when a user GET''s its url.

If you want to customize the html, your class must have a class method #forServer: and answer to #endPointEntity.
Then in your LocalService class, override the method #endPointEntityClass'
!


!SprayServerEndPointHTML class methodsFor:'instance creation'!

forServer: aSprayServer
	^self new server: aSprayServer
! !

!SprayServerEndPointHTML methodsFor:'accessing'!

endPointEntity
	| stream |
	stream := String writeStream.
	stream 
		nextPutAll: 
'<html><head><title>Spray Endpoint - ';
		nextPutAll: self serviceName;
		nextPutAll: 
'</title></head><body>
<h3>Spray Endpoint</h3>
This is the Endpoint for the Service: ';
		nextPutAll: self serviceName;
		nextPutAll:  '<p>This service is described in the <a href="';
		nextPutAll: self wsdlAddressLocation;
		nextPutAll: '"> WSDL file </a> </p>
<h4>Operations:</h4>'.

	self operationNames do: [ :each | stream nextPutAll: '<li>' , each , '</li>'].
	stream nextPutAll: '</ul></body></html>'.
	^stream contents
! !

!SprayServerEndPointHTML methodsFor:'accessing-private'!

operationNames 
	^server operationNames 
!

server
	^server
!

server: anObject
	"Private - Set the value of the receiver's ''server'' instance variable to the argument, anObject."

	server := anObject
!

serviceName
	^server serviceName
!

wsdlAddressLocation
	^server wsdlAddressLocation
! !

!SprayServerEndPointHTML class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SprayServerEndPointHTML.st,v 1.1 2002/11/18 19:35:08 cg Exp $'
! !
