"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SprayOperationModel subclass:#SpraySimpleAuthorizer
	instanceVariableNames:'passwords passwordPath'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Service'
!

SpraySimpleAuthorizer comment:'Deprecated'
!


!SpraySimpleAuthorizer methodsFor:'accessing'!

beDemo

	passwords := IdentityDictionary new.
	passwords
		at: #demo put: 'dolphin';
		at: #user put: 'dolphin'
!

beHarbor
	self passwordPath: self harborPasswordPath.
	self loadPasswords.
! !

!SpraySimpleAuthorizer methodsFor:'accessing-private'!

harborPasswordPath

	^'Harbor\conf\hssppwds.txt'
!

loadPasswords
	| fs |
	passwords := IdentityDictionary new.
	fs := [FileStream read: (FileLocator default localFileSpecFor: self passwordPath) text: true] on: Error do: [:e | ^self beDemo].
	[fs contents lines do: [ :each | | stream un|
		stream := each readStream.
		un := (stream upTo: $,) trimBlanks asSymbol.
		passwords at: un put: stream upToEnd trimBlanks]] ensure: [fs close]
	
!

passwordPath
	^passwordPath
!

passwordPath: anObject
	passwordPath := anObject
!

passwords
	passwords isNil ifTrue: [self beHarbor].
	^passwords
!

passwords: aCollection
	passwords := aCollection
! !

!SpraySimpleAuthorizer methodsFor:'exceptions'!

errorNotAuthorized
	SoapServerFault new beClient; beHeader; signal: 'You are not authorized to use this port'
! !

!SpraySimpleAuthorizer methodsFor:'must not strip'!

harborAuthentication: aXeQStruct exchange: aSpEnvelopeExchange
	(self checkPass: aXeQStruct) 
		ifTrue: [aSpEnvelopeExchange atQP: #'user:authenticated' put: true]
! !

!SpraySimpleAuthorizer methodsFor:'operations-private'!

checkPass: aXeQStruct
	| un pw |
	
	[un := (aXeQStruct atLocalName: #username) asSymbol.
	pw := aXeQStruct atLocalName: #password] 
			on: Error
			do: [:e | self errorNotAuthorized].
	(self passwords at: un ifAbsent: [self errorNotAuthorized]) = pw 
		ifFalse: [self errorNotAuthorized].
	^true
! !

!SpraySimpleAuthorizer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpraySimpleAuthorizer.st,v 1.1 2002/11/18 19:35:25 cg Exp $'
! !
