"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SptHTTPBindingAbstract subclass:#SptHTTPBinding
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SoapCore'
!

SptHTTPBinding comment:'This class is the default SOAP HTTP binding. It uses SptHTTPRequest which uses the Dolphin sockets package'
!


!SptHTTPBinding methodsFor:'accessing-private'!

httpHeaders
	^self atScopedQP: (self class sprayHttpQ: 'httpSoapHeaders')
		ifAbsent: 
			[Array 
				with: 'Content-Type' -> 'text/xml; charset=UTF-8'
				with: 'SOAPAction' -> self soapAction
				with: 'Connection' -> 'close'
				with: 'Accept-Language' -> '*']
!

inEnvelope
        |body startIdx|

        self ifLoggingWire: ['responseHeaders: ' , request responseHeaders printString].
        self ifLoggingWire: ['received: ' , request responseBody].
        "/ cg: some responses seem to include some html before the actual reply
        "/ I doubt this is legal, but they do it anyway...
        "/ snip off the first part.
        body := request responseBody.
        startIdx := body indexOfSubCollection:'<?xml '.
        startIdx > 1 ifTrue:[
            body := body copyFrom:startIdx.
        ].
        ^SpwSoapInEnvelope fromRequest: body
!

proxySettings
	^self atScopedQP: (self class sprayHttpQ: 'proxySettings') ifAbsent: [nil]
! !

!SptHTTPBinding methodsFor:'operations-private'!

createRequest
	request := SptHTTPRequest new.
	request proxySettings: self proxySettings.
	
!

forkMainIfNecessary
        Smalltalk isSmalltalkX ifFalse:[
            Processor forkMainIfMain
        ]
!

setTimeouts
	"See SptHTTPRequest class comment"

	request timeout: self timeoutReceive
!

waitOnRequest
	"Block the process waiting for the response"

	[request waitOnReady] ensure: [request close]
! !

!SptHTTPBinding class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptHTTPBinding.st,v 1.3 2010/03/08 17:47:12 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptHTTPBinding.st,v 1.3 2010/03/08 17:47:12 cg Exp $'
! !
