"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SptHTTPClientAbstract subclass:#SptHTTPClient
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SoapCore'
!

SptHTTPClient comment:'This class is the default HTTPClient. It uses SptHTTPRequest which uses the Dolphin sockets package'
!


!SptHTTPClient methodsFor:'accessing'!

proxySettings
	^self atScopedQP: (self class sprayHttpQ: 'proxySettings') ifAbsent: [nil]
! !

!SptHTTPClient methodsFor:'operations'!

getXeDocAt: aURL 
        Smalltalk isSmalltalkX ifFalse:[
            Processor forkMainIfMain.
        ].
        self createRequest.
        self setTimeouts.
        request openGetTo: aURL trimBlanks.
        request setRequestHeader: 'Accept' bstrValue: 'text/xml, */*'.
        request send.
        request waitOnReady.

        request status >= 400 
                ifTrue: 
                        [SoapTransportError signal: ('HTTP Transport error %1 %2' formatWith: request status displayString
                                                with: request statusText)].
        ^XeEnvironment docNodeFor: request responseBody
! !

!SptHTTPClient methodsFor:'operations-private'!

createRequest
	request := SptHTTPRequest new.
	request proxySettings: self proxySettings.
	
!

setTimeouts
	request
		timeout: 10000
! !

!SptHTTPClient class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptHTTPClient.st,v 1.3 2010/03/08 22:48:51 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptHTTPClient.st,v 1.3 2010/03/08 22:48:51 cg Exp $'
! !
