"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SptSoapBindingAbstract subclass:#SptHTTPLocalTransport
	instanceVariableNames:'envResponse status headers localDocuments server'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Service'
!

SptHTTPLocalTransport comment:'I am used for testing purposes.

I acts like a Binding, but am used for communicating with a Server running in the same image'
!


!SptHTTPLocalTransport class methodsFor:'operations'!

processExchange: aSpwRequestingExchange
	self error: 'Class is not a valid binding, must use an instance'
! !

!SptHTTPLocalTransport class methodsFor:'others'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptHTTPLocalTransport.st,v 1.2 2011/07/12 16:21:00 cg Exp $'
! !

!SptHTTPLocalTransport methodsFor:'accessing'!

getXeDocAt: aURL 
	^XeEnvironment docNodeFor: (self localDocuments at: aURL)
! !

!SptHTTPLocalTransport methodsFor:'accessing-private'!

defaultHeaders
	^''
!

defaultStatusCode
	^200
!

envResponse
	^envResponse
!

envResponse: anObject
	envResponse := anObject
!

headers
	headers isNil ifTrue: [headers := self defaultHeaders].
	^headers
!

headers: anObject
	headers := anObject
!

localDocuments
	localDocuments isNil ifTrue: [localDocuments := LookupTable new].
	^localDocuments
!

localDocuments: anObject
	localDocuments := anObject
!

peer
	^'127.0.0.1'
!

server
	^server
!

server: aSprayServer
	server := aSprayServer
!

status
	status isNil ifTrue: [status := self defaultStatusCode].
	^status
!

status: anObject
	status := anObject
! !

!SptHTTPLocalTransport methodsFor:'operations'!

processExchange: aSpMEC 
        "Used mainly for testing. Post the envelope. Either a canned response has been set, and will be returned, or a local server has been attached which will process the envelope"

        | env inEnv |
        
        [aSpMEC beWaitingState.
        inEnv := SpwSoapInEnvelope fromXmlString: aSpMEC outXml.
        aSpMEC beReceivingState.
        env := SpwSoapInEnvelope fromXmlString: (self responseToRequestEnv: inEnv).
        aSpMEC in: env.
        aSpMEC beSuccessState] 
                        on: Error
                        do: [:e | 
                            UserPreferences current soapErrorDebugging ifTrue:[e reject].
                            self handleException: e
                        ]

    "Modified: / 12-07-2011 / 17:45:37 / cg"
!

responseToRequestEnv: inEnv 
	(server notNil and: [envResponse notNil]) ifTrue: [self error: 'Use either service or envResponse'].
	^server notNil 
		ifTrue: 
			[| ex |
			ex := (self class environment at: #SptRespondingExchange) 
				onXmlString: inEnv xml xsiNS: server xsiNamespace.
			ex atQP: #'transport:peer' put: '127.0.0.1'.
			server soapNode process: ex.
			ex out xml]
		ifFalse: [envResponse]
! !

!SptHTTPLocalTransport class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptHTTPLocalTransport.st,v 1.2 2011/07/12 16:21:00 cg Exp $'
! !
