"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

Object subclass:#SptReceiveBinding
	instanceVariableNames:'server addressLocation'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Server'
!

SptReceiveBinding comment:'I extract the soap message from the POST''s entity, create a <SptRespondingExchange> for the message, and ask my server''s SpwSoapResponder to process it.

I contain a SprayServer (rather than directly contain the  SpwSoapResponder) because I can also be asked to provide the service''s WSDL and an html description of it (endPointEntity) 

I am multiple process safe because I do not change state once created.

Instance Variables:
	server		<SprayServer>
	addressLocation	<String>'
!


!SptReceiveBinding class methodsFor:'constants'!

icon
    "/ dolphin only
    Smalltalk isSmalltalkX ifTrue:[
        ^ nil
    ] ifFalse:[
        ^Dolphin::SWEnvironment spIconNamed: 'connRec.ico'
    ]
! !

!SptReceiveBinding methodsFor:'accessing'!

endPointEntity
	"Answer a string of html that can be returned to a client if they 'GET' the endPoint url"

	^server endPointEntity
!

server
	^server
!

server: aSprayServer
	server := aSprayServer
!

soapNode
	^server soapNode
! !

!SptReceiveBinding class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptReceiveBinding.st,v 1.3 2010/02/26 12:02:12 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptReceiveBinding.st,v 1.3 2010/02/26 12:02:12 cg Exp $'
! !
