"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SptPropertyScope subclass:#SptSoapBindingAbstract
	instanceVariableNames:'exchange'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SoapCore'
!

SptSoapBindingAbstract comment:'This class is a SOAP binding. The class is asked to process an exchange which it does depending on the underlying protocol (ie SMTP for mail bindings, POST for http bindings) 

==========
Scope
1/ The exchange that is being processed
2/ Myself
3/ The environment'
!


!SptSoapBindingAbstract class methodsFor:'constants'!

icon
    "/ dolphin only
    Smalltalk isSmalltalkX ifTrue:[
        ^ nil
    ] ifFalse:[
        ^Dolphin::SWEnvironment spIconNamed: 'connSend.ico'
    ]
! !

!SptSoapBindingAbstract class methodsFor:'operations'!

processExchange: aSpwRequestingExchange 
	self subclassResponsibility
! !

!SptSoapBindingAbstract methodsFor:'accessing-private'!

atScopedQP: aName ifAbsent: operation
	^exchange 
		atQP: aName 
		ifAbsent: [self 
			atQP: aName
			ifAbsent: [self sprayEnvironment 
				atQP: aName 
				ifAbsent: operation]]
!

exchange
	^exchange
!

exchange: aSpwExchange 
	exchange := aSpwExchange
! !

!SptSoapBindingAbstract methodsFor:'exceptions-private'!

handleException: e 
	"Private - self halt."
	exchange beFailState.
	exchange atQP: (self class sprayTransQ: 'exceptionMessage') put: e description.
	self ifLoggingWarn: [e description].
! !

!SptSoapBindingAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptSoapBindingAbstract.st,v 1.3 2010/02/26 12:02:10 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SptSoapBindingAbstract.st,v 1.3 2010/02/26 12:02:10 cg Exp $'
! !
