"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

Object subclass:#SpwCodedObject
	instanceVariableNames:'coder object'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Client'
!

SpwCodedObject comment:'I contain an <Object> and the <XeElement> used to encode/decode it.

	I am used by clients.
	I am not multiple process safe.
	I am contained by a <SpwOutEnvelope>

The SpwOutEnvelope class comments also apply to this class.'
!


!SpwCodedObject class methodsFor:'instance creation'!

onCoder: aSpCoder
	^self new coder: aSpCoder
!

onElement: aXeElement
	^self onCoder: (SpwSoapBCoder onElement: aXeElement)
! !

!SpwCodedObject methodsFor:'accessing'!

element
	^coder element
!

namespace
	^self element namespace
!

object
	^object
!

object: anObject
	object := anObject
!

setRPCParameters: anArray
	object := coder parametersFrom: anArray
! !

!SpwCodedObject methodsFor:'accessing-private'!

coder
	^coder
!

coder: aSpwSoapBCoder
	coder := aSpwSoapBCoder
! !

!SpwCodedObject methodsFor:'encoding'!

encodeInto: aNode
	coder encodeObject: object into: aNode
! !

!SpwCodedObject methodsFor:'encoding controls-header'!

actor: aNamespace
	coder setControlAttribute: ('actor' ns: XeNamespace soapEnv) value: aNamespace
!

beMustUnderstand
	"Make the header at anIndex mustUnderstand. 
		-If the destination soap receiver node does not understand the header, it must return a Fault to us"

	self understand: 1
!

beNext
	"Mark the header at anIndex 'next'.
	-this means that the destination soap receiver node knows that the header is targeted at it.
		-this has the same effect as a missing actor attribute"

	self actor: #'http://schemas.xmlsoap.org/soap/actor/next'
!

beNotMustUnderstand
	"Make the header at anIndex *not* mustUnderstand. 
		-If the destination soap receiver node does not understand the header, they are free to ignore it"

	self understand: 0
!

understand: anInteger
	coder setControlAttribute: ('mustUnderstand' ns: XeNamespace soapEnv) value: anInteger
! !

!SpwCodedObject methodsFor:'testing'!

isNamed: aQName
	^coder elementQName = aQName
!

isObjectNil
	^object isNil
! !

!SpwCodedObject class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpwCodedObject.st,v 1.1 2002/11/18 19:37:19 cg Exp $'
! !
