"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

Object subclass:#SpwEnvelope
	instanceVariableNames:'typespace'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Client'
!

SpwEnvelope comment:'I am an Envelope of objects and schema components. 
I am used by Clients.
I am not multiple process safe.

==========
Use:
-Object instances are added to SpwOutEnvelopes and then it is asked to encode into an xml soap envelope.
-SpwInEnvelopes can be asked to decode an xml soap envelope which adds the objects to itself.




'
!


!SpwEnvelope class methodsFor:'instance creation'!

newIn: aXeTypespace 
	^self new initializeIn: aXeTypespace
! !

!SpwEnvelope class methodsFor:'constants'!

icon
	^Icon fromId: 167 in: ShellLibrary default


! !

!SpwEnvelope methodsFor:'accessing-private'!

typespace
	^typespace
! !

!SpwEnvelope methodsFor:'initializing-private'!

initializeIn: aXeTypespace
	typespace := aXeTypespace.
	self initialize.
! !

!SpwEnvelope methodsFor:'operations'!

reset
	^self resetObjects
! !

!SpwEnvelope class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpwEnvelope.st,v 1.1 2002/11/18 19:38:26 cg Exp $'
! !
