"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpwSoapBHandler subclass:#SpwRPCHandlerAbstract
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Server'
!


!SpwRPCHandlerAbstract methodsFor:'accessing'!

returnName
	"Private - Answer a string. This can be nil if void ... either 
		-no return parts, 
		-or the operation has multiple out parts, but has no return part. The only way we can know this is through the WSDL parameter order attribute "

	| firstAccessor |
	Notification deprecated.
	self halt.
	(firstAccessor := self outputContent firstAccessorKeyOrNil) isNil ifTrue: [^nil].
	^firstAccessor asString
! !

!SpwRPCHandlerAbstract methodsFor:'operations'!

encodeAnswer: answer into: aSptRespondingExchange
	"Encode the answer object, into the soap:Body's <XeNode>, using the <SpwSoapBCoder>"

	self isBodyHandler ifFalse: [self error: 'A Header Handler can not be RPC'].
	outputEncoder encodeRPCAnswer: answer into: aSptRespondingExchange outBodyNode
! !

!SpwRPCHandlerAbstract methodsFor:'operations-private'!

decodeInputSoapB: aXeNode
	"Private - Answer an <Object> that is decoded from aXeNode using the interface of the <SpwSoapBCoder>"

	^inputDecoder decodeRPCSoapB: aXeNode
! !

!SpwRPCHandlerAbstract methodsFor:'testing'!

isDecodeOnly 
	^false
! !

!SpwRPCHandlerAbstract methodsFor:'testing-private'!

isVoidReturn
	^self outputContent isVoid
! !

!SpwRPCHandlerAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpwRPCHandlerAbstract.st,v 1.1 2002/11/18 19:35:41 cg Exp $'
! !
