"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpwInEnvelope subclass:#SpwRPCReturn
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Client'
!


!SpwRPCReturn methodsFor:'accessing-body'!

extractReturn
	"-Soap Sec7.1 Each parameter accessor has a name corresponding to the name of the parameter and type corresponding to the type of the parameter. The name of the return value accessor is not significant. Likewise, the name of the struct is not significant. However, a convention is to name it after the method name with the string Response appended.
	-The first bodyObject is the 'Wrapper Element'.
	--The first object of the 'Wrapper Element' is the 'return value'"

	bodyObjects first isEmpty ifTrue: [^nil].
	^bodyObjects first first
!

outParameters
	"Answer a keyed collection of all out parameters received. (convention is to answer first as the 'return')"

	^self bodyCoders first parametersFrom: self bodyObjects first 
! !

!SpwRPCReturn methodsFor:'operations-private'!

processBodies: aSoapInEnvelope
	| bodyBlock |
	(bodyBlock := aSoapInEnvelope firstBodyBlock) isNil 
		ifTrue: [self error: 'Expected a Body child soapBlock'].
	bodyObjects at: 1 put: (bodyCoders first decodeRPCSoapB: bodyBlock)
! !

!SpwRPCReturn class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpwRPCReturn.st,v 1.1 2002/11/18 19:38:49 cg Exp $'
! !
