"{ Package: 'stx:goodies/soap/spray' }"

"{ NameSpace: SOAP }"

SpwSoapBProcessorAbstract subclass:#SpwSoapBProcessor
	instanceVariableNames:'blockNode exchange handler receiver'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Core-Server'
!

SpwSoapBProcessor comment:'I am a helper object used by a <SpwSoapResponder>. I am created and exist for each SpwRespondingExchange the SpwSoapResponder processes.'
!


!SpwSoapBProcessor class methodsFor:'instance creation'!

onHandler: aSpwSoapBHandler receiver: aSpwSoapBReceiver 
	^self new handler: aSpwSoapBHandler receiver: aSpwSoapBReceiver 
! !

!SpwSoapBProcessor methodsFor:'accessing-private'!

handler: aSpwSoapBHandler receiver: aSpwSoapBReceiver
	handler := aSpwSoapBHandler .
	receiver := aSpwSoapBReceiver.
! !

!SpwSoapBProcessor methodsFor:'operations'!

processSoapB: aXeNode exchange: anEnvExchange
	blockNode := aXeNode.
	exchange := anEnvExchange.
	self process
! !

!SpwSoapBProcessor methodsFor:'operations-private'!

process
	| message answer |
	message := handler messageFor: blockNode exchange: exchange.
	answer := receiver sendMessage: message exchange: exchange.
	(exchange isContinueState and: [handler isDecodeOnly not]) 
		ifTrue: [handler encodeAnswer: answer into: exchange]
! !

!SpwSoapBProcessor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/SpwSoapBProcessor.st,v 1.1 2002/11/18 19:41:37 cg Exp $'
! !
