"{ Package: 'stx:goodies/soap/spray/auth' }"

"{ NameSpace: SOAP }"

SprayOperationModel subclass:#SpAuthOpAuthorizer
	instanceVariableNames:'authorizer challengeCoder nextChallengeCoder'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Auth'
!


!SpAuthOpAuthorizer class methodsFor:'instance creation'!

new

        ^self basicNew initialize
!

usingAuthorizer: aSpDigestAuthorizer
	^self new authorizer: aSpDigestAuthorizer
! !

!SpAuthOpAuthorizer class methodsFor:'constants'!

icon
	^SWEnvironment spIconNamed: 'lock16.ico'
! !

!SpAuthOpAuthorizer methodsFor:'accessing'!

answerCoderFor: aSpAuthClientAuth 
	^aSpAuthClientAuth isFail
		ifTrue: [challengeCoder]
		ifFalse: [nextChallengeCoder]
!

authorizer
	^authorizer
!

realm
	^authorizer realm
!

realm: aString 
	authorizer realm: aString 
! !

!SpAuthOpAuthorizer methodsFor:'accessing-private'!

authorizer: anObject
	authorizer := anObject
!

challengeCoder
	^challengeCoder
!

challengeCoder: aSpCoder
	challengeCoder := aSpCoder
!

nextChallengeCoder
	^nextChallengeCoder
!

nextChallengeCoder: aSpCoder
	nextChallengeCoder := aSpCoder
! !

!SpAuthOpAuthorizer methodsFor:'adding'!

addUid: aString pwd: aString2 
	authorizer addUid: aString pwd: aString2 
! !

!SpAuthOpAuthorizer methodsFor:'initializing'!

loadSecretsFromFile: aString 
	authorizer loadSecretsFromFile: aString 
! !

!SpAuthOpAuthorizer methodsFor:'must not strip'!

clientAuth: aSpAuthClientAuth exchange: aSpEnvelopeExchange 
	aSpAuthClientAuth authorizer: authorizer.
	aSpAuthClientAuth authorize.
	self encodeAnswerStruct: aSpAuthClientAuth into: aSpEnvelopeExchange outHeaderNode.
	aSpAuthClientAuth isFail
		ifTrue: [self fail: aSpEnvelopeExchange]
		ifFalse: [self pass: aSpEnvelopeExchange]
 
		
! !

!SpAuthOpAuthorizer methodsFor:'operations'!

encodeAnswerStruct: aSpAuthClientAuth into: aNode
	(self answerCoderFor: aSpAuthClientAuth) encodeObject: aSpAuthClientAuth answerStruct
		into: aNode
!

fail: aSpEnvelopeExchange 
	aSpEnvelopeExchange atQP: #'user:authenticated' put: false.
	"aSpEnvelopeExchange dontContinue."
	aSpEnvelopeExchange beOutFaultCode: 'Client' string: 'Authentication failed: missing, malformed, or invalid credentials'
  
!

missingExchange: aSpEnvelopeExchange 
	| clientAuth |
	clientAuth := SpAuthClientAuth new authorizer: authorizer.
	clientAuth beAnswerMissing.
	self encodeAnswerStruct: clientAuth into: aSpEnvelopeExchange outHeaderNode.
	self fail: aSpEnvelopeExchange
!

pass: aSpEnvelopeExchange 
	aSpEnvelopeExchange atQP: #'user:authenticated' put: true 
!

removeAllSecrets
	^authorizer removeAllSecrets
! !

!SpAuthOpAuthorizer class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/auth/SOAP__SpAuthOpAuthorizer.st,v 1.3 2010/06/14 10:55:27 cg Exp $'
! !
