"{ Package: 'stx:goodies/soap/spray/auth' }"

"{ NameSpace: SOAP }"

SpAuthDigestAuthorizer subclass:#SpDigestAuthRFC2617
	instanceVariableNames:'privateNonceKey'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Auth'
!


!SpDigestAuthRFC2617 methodsFor:'accessing-private'!

privateNonceKey
	privateNonceKey isNil ifTrue: [privateNonceKey := 'dolphin'].
	^privateNonceKey
!

privateNonceKey: aString
	privateNonceKey := aString
! !

!SpDigestAuthRFC2617 methodsFor:'operations'!

generateNonce
	"RFC2617 3.2.1 recommendation"

	^self generateNonceFor: XeXsdDateTime current
! !

!SpDigestAuthRFC2617 methodsFor:'operations-private'!

generateNonceFor: aTimeStamp
	"Private - RFC2617 3.2.1 recommendation"

	| tss |
	tss := aTimeStamp schemaDisplayString.
	^(tss , (MD5 hMessage: (tss , ':' , self etag ,':' , self privateNonceKey))) asByteArray printSchemaHexString
! !

!SpDigestAuthRFC2617 methodsFor:'testing'!

isExpiredNonce: aString 
	^false
! !

!SpDigestAuthRFC2617 class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/auth/SOAP__SpDigestAuthRFC2617.st,v 1.2 2009/10/04 17:38:32 cg Exp $'
! !
