"{ Package: 'stx:goodies/soap/spray/services' }"

"{ NameSpace: SOAP }"

SprayOperationModel subclass:#SoapInteropAbstract
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2'
!

SoapInteropAbstract comment:'SoapBuilders Round2 models

Most operations echo the value received after checking we decoded an instance of a class that we were expecting'
!


!SoapInteropAbstract class methodsFor:'spray namespaces'!

sprayPortNamespace
	^#'http://soapinterop.org/'
! !

!SoapInteropAbstract methodsFor:'asserting'!

assert: anObject kindOf: aClass 
	(anObject isKindOf: aClass) ifFalse: [self errorValue: anObject notKindOf: aClass]
!

assert: anObject kindOfOrNil: aClass 
	(anObject isNil or: [anObject isKindOf: aClass]) 
		ifFalse: [self errorValue: anObject notKindOf: aClass]
!

assertIsCollection: anObject 
	self assert: anObject kindOf: Collection
!

assertIsCollectionOrNil: anObject 
	anObject isNil
		ifFalse: [self assert: anObject kindOf: Collection]
!

assertIsFloat: aFloat 
	"If the port is resuming type conversion errors, aFloat may be an instance of XMLAnyValue. If so check it, and return it"

	(aFloat isKindOf: XeAnyValue) 
		ifTrue: 
			[(#('NaN' 'INF' '-INF') includes: aFloat text) ifFalse: [self error: 'Unrecognised float'].
			^aFloat].
	(aFloat isKindOf: Number) 
		ifFalse: [self error: 'Expected a Float, received: ' , aFloat printString].
	^aFloat asFloat
!

assertIsFloatOrNil: aFloat 
	^aFloat isNil or: [self assertIsFloat: aFloat]

! !

!SoapInteropAbstract methodsFor:'exceptions'!

errorValue: anObject notKindOf: aClass
	self error: ('Expected: %1 received: %2' 
			formatWith: aClass name asString
			with: anObject displayString)
! !

!SoapInteropAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/SOAP__SoapInteropAbstract.st,v 1.1 2008/09/07 18:44:49 cg Exp $'
! !
