"{ Package: 'stx:goodies/soap/spray/services' }"

"{ NameSpace: SOAP }"

SoapInteropAbstract subclass:#SoapInteropGroupB
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2'
!

SoapInteropGroupB comment:'My service (can/does) use SourceAnalysis (ie #storeOperationPort) to generate an interface for me. '
!


!SoapInteropGroupB class methodsFor:'spray namespaces'!

sprayPortName
	^'soapinteropB'
! !

!SoapInteropGroupB methodsFor:'operations'!

echoNestedArray: aStruct 
	"SpdOperationCreator new
		in: #((inputStruct nsi:SOAPArrayStruct));
		out: #((return nsi:SOAPArrayStruct))"

	self assert: aStruct kindOf: XeQStruct.
	(aStruct includesKey: #varArray) ifFalse: [self error: 'Expected a varArray accessor'].
	self assertIsCollectionOrNil: (aStruct at: #varArray).
	^aStruct
!

echoNestedStruct: aStruct 
	"SpdOperationCreator new
		in: #((inputStruct nsi:SOAPStructStruct));
		out: #((return nsi:SOAPStructStruct))"

	self assert: aStruct kindOf: XeQStruct.
	(aStruct includesKey: #varStruct) ifFalse: [self error: 'Expected aStruct accessor'].
	self assert: (aStruct at: #varStruct) kindOfOrNil: XeQStruct.
	^aStruct
!

echoSimpleTypesAsStruct: aString integer: anInt float: aFloat 
	"SpdOperationCreator new
		in: #((inputString xsd:string) (inputInteger xsd:int) (inputFloat xsd:float));
		out: #((return nsi:SOAPStruct))"

	| struct |
	self assert: aString kindOfOrNil: String.
	self assert: anInt kindOfOrNil: Integer.
	self assertIsFloatOrNil: aFloat.
	struct := XeQStruct new.
	struct
		at: #varString put: aString;
		at: #varInt put: anInt;
		at: #varFloat put: aFloat.
	^struct
!

echoStructAsSimpleTypes: aStruct 
	"SpdOperationCreator new
		in: #((inputStruct nsi:SOAPStruct));
		out: #((outputString xsd:string) (outputInteger xsd:int) (outputFloat xsd:float))"

	| aString anInt aFloat |
	aString := aStruct at: #varString.
	anInt := aStruct at: #varInt.
	aFloat := aStruct at: #varFloat.
	self assert: aString kindOfOrNil: String.
	self assert: anInt kindOfOrNil: Integer.
	self assertIsFloatOrNil: aFloat.
	^Array 
		with: aString
		with: anInt
		with: aFloat
! !

!SoapInteropGroupB methodsFor:'spray generate'!

echo2DStringArray: aLookupTable 
	"SpdOperationCreator new
		in: #((input2DStringArray nsi:ArrayOfString2D));
		out: #((return nsi:ArrayOfString2D))"

	aLookupTable keys do: 
			[:each | 
			(each isKindOf: Point) 
				ifFalse: [self error: 'Not a valid Spray 2D Array key ' , each displayString]].
	aLookupTable values do: [:each | self assert: each kindOfOrNil: String].
	^aLookupTable
! !

!SoapInteropGroupB class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/SOAP__SoapInteropGroupB.st,v 1.1 2008/09/07 18:45:31 cg Exp $'
! !
