"{ Package: 'stx:goodies/soap/spray/services' }"

"{ NameSpace: SOAP }"

SprayLocalService subclass:#SoapInteropServiceAbstract
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2'
!

SoapInteropServiceAbstract comment:'Subclasses implement various services from the SoapBuilders Round 2 interop testing'
!


!SoapInteropServiceAbstract methodsFor:'accessing-namespace'!

namespace
	"Answer the namespace of the service.
	This will be the targetNamespace of the service WSDL"

	^#'http://soapinterop.org/'
! !

!SoapInteropServiceAbstract methodsFor:'constants'!

schemaImportApacheMap
^'<schema 
xmlns="http://www.w3.org/2001/XMLSchema" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
targetNamespace="http://xml.apache.org/xml-soap"
xmlns:tns="http://xml.apache.org/xml-soap"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" >
<complexType name="Map">
<sequence>
<element name="item" minOccurs="0" maxOccurs="unbounded" type="tns:item"/>
</sequence>
</complexType>
<complexType name="item">
<sequence>
<element name="key" />
<element name="value" />
</sequence>
</complexType>
<complexType name="ArrayOfMap">
<complexContent>
	<restriction base="SOAP-ENC:Array">
		<sequence>
			<element name="item" type="tns:Map" maxOccurs="unbounded"/>
		</sequence>
		<attribute ref="SOAP-ENC:arrayType" wsdl:arrayType="tns:Map[]"/>
	</restriction>
</complexContent>
</complexType>

</schema>'
! !

!SoapInteropServiceAbstract methodsFor:'port generation'!

onPortGenerated: port
	"Handle the onPortGenerated event. See superclass #onPortGenerated: comment.
	-Each operation will use a constant SOAPAction (an HTTP header sent with a request)"

	super onPortGenerated: port.
	port soapAction: 'http://soapinterop.org/'
! !

!SoapInteropServiceAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/SOAP__SoapInteropServiceAbstract.st,v 1.1 2008/09/07 18:46:47 cg Exp $'
! !
