"{ Package: 'stx:goodies/soap/spray/services/tests' }"

"{ NameSpace: SOAP }"

SoapInteropFTs subclass:#R1ExtFT
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2-TestCases'
!


!R1ExtFT methodsFor:'accessing'!

getReturnPartName

	^'return'
!

getService
	^SoapInteropRound1Service new
!

qualifyLocal: aString 
	^XeQName local: aString ns: #'http://soapinterop.org/'
! !

!R1ExtFT methodsFor:'tests'!

testEchoBase64
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsd2="http://www.w3.org/2000/10/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsi2="http://www.w3.org/2000/10/XMLSchema-instance"><ns0:echoBase64 xmlns:ns0="http://soapinterop.org/"><ns0:inputBase64 xmlns:SOAPENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2000/10/XMLSchema-instance" xsi:type="SOAPENC:base64">AAECAwQFBgcICQ==</ns0:inputBase64></ns0:echoBase64></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self assertFaultResponse.
	"self assert: self responseReturnBlockName = (self qualifyLocal: 'echoBase64Response').
	self assert: self getReturnNode text = 'AAECAwQFBgcICQ=='"
!

testEchoDate
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsd2="http://www.w3.org/2000/10/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsi2="http://www.w3.org/2000/10/XMLSchema-instance"><ns0:echoDate xmlns:ns0="http://soapinterop.org/"><inputDate xsi2:type="xsd:timeInstant" xsi:type="xsd:timeInstant">2001-04-25T09:31:41-07:00</inputDate></ns0:echoDate></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoDateResponse').
	self assert: (XeXsdDateTime fromString: self getReturnNode text) 
				= (XeXsdDateTime fromString: '2001-04-25T09:31:41-07:00')
!

testEchoFloat
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<SOAP-ENV:Body><mns:echoFloat xmlns:mns="http://soapinterop.org/"><inputFloat xsi:type="xsd:float">2.5</inputFloat></mns:echoFloat></SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoFloatResponse')
!

testEchoFloatArray
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoFloatArray xmlns:namesp1="http://soapinterop.org/">
<inputFloatArray SOAP-ENC:arrayType="xsd:float[4]" xsi:type="SOAP-ENC:Array">
<c-gensym5 xsi:type="xsd:float">NaN</c-gensym5>
<c-gensym5 xsi:type="xsd:float">0.0</c-gensym5>
<c-gensym5 xsi:type="xsd:float">INF</c-gensym5>
<c-gensym5 xsi:type="xsd:float">-INF</c-gensym5>

</inputFloatArray>
</namesp1:echoFloatArray>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: (self responseNodesByTagName: 'item') size = 4.
	self assert: (self responseNodesByTagName: 'item') first qValueForXSIType namespace 
				= #'http://www.w3.org/1999/XMLSchema'.
	self assert: ('*SOAP-ENC:arrayType=*' match: responseXML)
!

testEchoFloatNaN
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<SOAP-ENV:Body><mns:echoFloat xmlns:mns="http://soapinterop.org/"><inputFloat xsi:type="xsd:float">NaN</inputFloat></mns:echoFloat></SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoFloatResponse').
	self assert: self getReturnNode text = 'NaN'
!

testEchoInteger
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoInteger xmlns:namesp1="http://soapinterop.org/">
<inputInteger xsi:type="xsd:int">5</inputInteger>
</namesp1:echoInteger>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoIntegerResponse').
	self assert: self getReturnNode text = '5'
!

testEchoIntegerArray
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoIntegerArray xmlns:namesp1="http://soapinterop.org/">
<inputIntegerArray SOAP-ENC:arrayType="xsd:int[7]" xsi:type="SOAP-ENC:Array">
<c-gensym5 xsi:type="xsd:int">-1</c-gensym5>
<c-gensym5 xsi:type="xsd:int">0</c-gensym5>
<c-gensym5 xsi:type="xsd:int">1</c-gensym5>
<c-gensym5 xsi:type="xsd:int">2</c-gensym5>
<c-gensym5 xsi:type="xsd:int">3</c-gensym5>
<c-gensym5 xsi:type="xsd:int">4</c-gensym5>
<c-gensym5 xsi:type="xsd:int">5</c-gensym5>
</inputIntegerArray>
</namesp1:echoIntegerArray>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: (self responseNodesByTagName: 'item') size = 7.
	self assert: ('*SOAP-ENC:arrayType=*' match: responseXML)
!

testEchoIntegerArrayEmpty
	self 
		makeRequest: 
'<S:Envelope xmlns:S="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
S:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema"
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance">
<S:Body>
<m:echoIntegerArray xmlns:m="http://soapinterop.org/"></m:echoIntegerArray>
</S:Body>
</S:Envelope>'.

	"Personally I think this should be a fault"
	"self assertFaultResponse."
	"self assert: ('*SOAP-ENC:arrayType='xsd:int[0]'*' match: responseXML)"
!

testEchoIntegerArrayEmpty2
	self 
		makeRequest: 
'<S:Envelope xmlns:S="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
S:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema"
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance">
<S:Body>
<m:echoIntegerArray xmlns:m="http://soapinterop.org/">
<inputIntegerArray SOAP-ENC:arrayType="xsd:int[0]" xsi:type="SOAP-ENC:Array" />
</m:echoIntegerArray>
</S:Body>
</S:Envelope>'.
	self denyFaultResponse.
	self assert: ('*<return SOAP-ENC:arrayType="xsd:int[0]"/>*' match: responseXML)
!

testEchoIntegerMax
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsd2="http://www.w3.org/2000/10/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsi2="http://www.w3.org/2000/10/XMLSchema-instance"><ns0:echoInteger xmlns:ns0="http://soapinterop.org/"><inputInteger xsi2:type="xsd:int" xsi:type="xsd:int">2147483647</inputInteger></ns0:echoInteger></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoIntegerResponse').
	self assert: self getReturnNode text = '2147483647'
!

testEchoIntegerMin
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsd2="http://www.w3.org/2000/10/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsi2="http://www.w3.org/2000/10/XMLSchema-instance"><ns0:echoInteger xmlns:ns0="http://soapinterop.org/"><inputInteger xsi2:type="xsd:int" xsi:type="xsd:int">-2147483648</inputInteger></ns0:echoInteger></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoIntegerResponse').
	self assert: self getReturnNode text = '-2147483648'
!

testEchoString
	self 
		makeRequest: 
'<?xml version="1.0" ?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoString xmlns:namesp1="http://soapinterop.org/">
<inputString xsi:type="xsd:string">hello</inputString>
</namesp1:echoString>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoStringResponse').
	self assert: self getReturnNode text = 'hello'
!

testEchoString2
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsd2="http://www.w3.org/2000/10/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsi2="http://www.w3.org/2000/10/XMLSchema-instance"><ns0:echoString xmlns:ns0="http://soapinterop.org/"><inputString xsi2:type="xsd:string" xsi:type="xsd:string">asdsad&gt;&lt;&lt;&gt;&lt;&gt;&lt;&gt;&lt;#$$@#&amp;abs;</inputString></ns0:echoString></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoStringResponse').
	self assert: self getReturnNode text = 'asdsad><<><><><#$$@#&abs;'
!

testEchoStringArray
	self 
		makeRequest: 
'<?xml version="1.0" ?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoStringArray xmlns:namesp1="http://soapinterop.org/">
<inputStringArray SOAP-ENC:arrayType="xsd:string[2]" xsi:type="SOAP-ENC:Array">
<c-gensym5 xsi:type="xsd:string">hello</c-gensym5>
<c-gensym5 xsi:type="xsd:string">goodbye</c-gensym5>
</inputStringArray>
</namesp1:echoStringArray>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: ('*SOAP-ENC:arrayType="xsd:string[2]"*' match: responseXML)
!

testEchoStringArray2
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:i2="http://soapinterop.org/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance">
    <SOAP-ENV:Body>
        <i2:echoStringArray id="ref-1">
            <inputStringArray href="#ref-3"/>
        </i2:echoStringArray>
        <SOAP-ENC:Array SOAP-ENC:arrayType="xsd:string[4]" id="ref-3">
            <item id="ref-4">first one</item>
            <item id="ref-5">second one</item>
            <item id="ref-6">third one</item>
            <item id="ref-7">fourth one</item>
        </SOAP-ENC:Array>
    </SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoStringArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"><return SOAP-ENC:arrayType="xsd:string[4]"><item xsi:type="xsd:string">first one</item><item xsi:type="xsd:string">second one</item><item xsi:type="xsd:string">third one</item><item xsi:type="xsd:string">fourth one</item></return></m:echoStringArrayResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testEchoStringIDFirst
	self 
		makeRequest: 
'<S:Envelope xmlns:S="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
S:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/1999/XMLSchema"
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance">
<S:Body>
<SOAP-ENC:string id="bar">hello world!!</SOAP-ENC:string>
<m:echoString xmlns:m="http://soapinterop.org/">
<inputString href="#bar" />
</m:echoString>
</S:Body></S:Envelope>'.
	self assertFaultResponse

	"The error message is not correct; it should note that
there are multiple child nodes, and no way to determine which is the method node."
!

testEchoStringNonASCII
	self 
		makeRequest: 
'<S:Envelope xmlns:S=''http://schemas.xmlsoap.org/soap/envelope/''
xmlns:SOAP-ENC=''http://schemas.xmlsoap.org/soap/encoding/''
S:encodingStyle=''http://schemas.xmlsoap.org/soap/encoding/'' xmlns:xsd=''http://www.w3.org/1999/XMLSchema''
xmlns:xsi=''http://www.w3.org/1999/XMLSchema-instance''>
<S:Body>
<m:echoString xmlns:m=''http://soapinterop.org/''><inputString xsi:type=''xsd:string''>Some ASCII string and some non ASCII characters ЁЂЃЄ and some more ASCII here</inputString></m:echoString>
</S:Body></S:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoStringResponse').
	self assert: self getReturnNode parentNode localName = 'echoStringResponse'.
	self 
		assert: ('*Some ASCII string and some non ASCII characters ЁЂЃЄ and some more ASCII here*' 
				match: responseXML)
!

testEchoStringSpace
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?><SOAP-ENV:Envelope
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp23:echoString xmlns:namesp23="http://soapinterop.org/">
<inputString
xsi:type="xsd:string"> </inputString></namesp23:echoString></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoStringResponse').
	self assert: self getReturnNode extractChildASCIIText = ' '
!

testEchoStringWhitespace
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?><SOAP-ENV:Envelope
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp23:echoString xmlns:namesp23="http://soapinterop.org/">
<inputString
xsi:type="xsd:string">
</inputString></namesp23:echoString></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self assert: self responseReturnBlockName = (self qualifyLocal: 'echoStringResponse').
	self assert: (#(1 2) includes: self getReturnNode text size).
	self assert: (#(10 13) includes: self getReturnNode text first codePoint)
!

testEchoStruct
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:namesp1="http://soapinterop.org/xsd">
<SOAP-ENV:Body>
<namesp2:echoStruct xmlns:namesp2="http://soapinterop.org/">
<inputStruct xsi:type="namesp1:SOAPStruct">
<varFloat xsi:type="xsd:float">6.2</varFloat>
<varString xsi:type="xsd:string">test string</varString>
<varInt xsi:type="xsd:int">5</varInt>
</inputStruct>
</namesp2:echoStruct>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: ('*<varFloat xsi:type="xsd:float">6.2</varFloat>*' match: responseXML)
!

testEchoStructArray
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:namesp1="http://soapinterop.org/xsd">
<SOAP-ENV:Body>
<namesp2:echoStructArray xmlns:namesp2="http://soapinterop.org/">
<inputStructArray SOAP-ENC:arrayType="namesp1:SOAPStruct[2]" xsi:type="SOAP-ENC:Array">
<c-gensym5 xsi:type="namesp1:SOAPStruct">
<varFloat xsi:type="xsd:float">6.2</varFloat>
<varString xsi:type="xsd:string">test string</varString>
<varInt xsi:type="xsd:int">5</varInt>
</c-gensym5>
<c-gensym5 xsi:type="namesp1:SOAPStruct">
<varFloat xsi:type="xsd:float">12.4</varFloat>
<varString xsi:type="xsd:string">another test</varString>
<varInt xsi:type="xsd:int">10</varInt>
</c-gensym5>
</inputStructArray>
</namesp2:echoStructArray>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: ('*<varString xsi:type="xsd:string">*' match: responseXML).
	self assert: ('*<varFloat xsi:type="xsd:float">*' match: responseXML).
	self assert: (self responseNodesByTagName: 'varFloat') first text = '6.2'.
	self assert: (self responseNodesByTagName: 'varFloat') second text = '12.4'
!

testEchoStructArray2
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:typens="http://soapinterop.org/xsd"><SOAP-ENV:Body><mns:echoStructArray xmlns:mns="http://soapinterop.org/"> <inputStructArray xsi:type="SOAP-ENC:Array" SOAP-ENC:arrayType="typens:SOAPStructStruct [2]">
<Item xsi:type="typens:SOAPStruct">
<varInt xsi:type="xsd:int">1234</varInt>
<varFloat xsi:type="xsd:float">43.44</varFloat>
<varString xsi:type="xsd:string">SQLData</varString>
</Item>
<Item xsi:type="typens:SOAPStruct">
<varInt xsi:type="xsd:int">342</varInt>
<varFloat xsi:type="xsd:float">43.8</varFloat>
<varString xsi:type="xsd:string">soapclient</varString>
</Item>
</inputStructArray></mns:echoStructArray></SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self assert: ('*<varString xsi:type="xsd:string">*' match: responseXML).
	self assert: ('*<varFloat xsi:type="xsd:float">*' match: responseXML).
	self assert: (self responseNodesByTagName: 'varFloat') first text = '43.44'.
	self assert: (self responseNodesByTagName: 'varFloat') second text = '43.8'
!

testEchoStructArray3
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:i2="http://soapinterop.org/" xmlns:i3="http://soapinterop.org/xsd" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance">
    <SOAP-ENV:Body>
        <i2:echoStructArray id="ref-1">
            <inputStructArray href="#ref-4"/>
        </i2:echoStructArray>
        <SOAP-ENC:Array SOAP-ENC:arrayType="i3:SOAPStruct[2]" id="ref-4">
            <item href="#ref-5"/>
            <item href="#ref-6"/>
        </SOAP-ENC:Array>
        <i3:SOAPStruct id="ref-5">
            <varString id="ref-7">one string</varString>
            <varInt>10</varInt>
            <varFloat>11.11</varFloat>
        </i3:SOAPStruct>
        <i3:SOAPStruct id="ref-6">
            <varString id="ref-8">another string</varString>
            <varInt>-10</varInt>
            <varFloat>99.99</varFloat>
        </i3:SOAPStruct>
    </SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: ('*<varString xsi:type="xsd:string">*' match: responseXML).
	self assert: ('*<varFloat xsi:type="xsd:float">*' match: responseXML).
	self assert: (self responseNodesByTagName: 'varFloat') first text = '11.11'.
	self assert: (self responseNodesByTagName: 'varFloat') second text = '99.99'
!

testEchoStructArrayEmpty
	self 
		makeRequest: 
'<V:Envelope
        xmlns:V="http://schemas.xmlsoap.org/soap/envelope/"
        xmlns:C="http://schemas.xmlsoap.org/soap/encoding/"
        xmlns:i="http://www.w3.org/1999/XMLSchema-instance"
        xmlns:d="http://www.w3.org/1999/XMLSchema"
        V:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<V:Body>
<m:echoStructArray
        xmlns:m="http://soapinterop.org/">
<inputStructArray
        i:type="C:Array"
        C:arrayType="ns3:SOAPStruct[0]"
        xmlns:ns3="http://soapinterop.org/xsd"/>
</m:echoStructArray>
</V:Body>
</V:Envelope>'.

	"ans ownerDocument browserView"
	self assert: self getReturnNode childNodes isEmpty.
	self assert: ('*SOAPStruct[0]*' match: responseXML)
!

testEchoVoid
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance">
<SOAP-ENV:Body>
<echoVoid xmlns="http://soapinterop.org/"></echoVoid>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assert: self getRPCWrapperNode childNodes isEmpty
! !

!R1ExtFT class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/tests/SOAP__R1ExtFT.st,v 1.1 2008/09/07 18:51:21 cg Exp $'
! !
