"{ Package: 'stx:goodies/soap/spray/services/tests' }"

"{ NameSpace: SOAP }"

SoapInteropFTs subclass:#R2BaseExtFT
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2-TestCases'
!


!R2BaseExtFT methodsFor:'accessing'!

getReturnPartName
	^'return'
!

getService
	^SoapInteropBaseService new
!

namespace
	^#'http://soapinterop.org/'.
! !

!R2BaseExtFT methodsFor:'asserting'!

assertResponseWrapperNamed: aString 
	self assert: self getRPCWrapperNode localName = aString.
	self assert: self getRPCWrapperNode qName = (XeQName local: aString ns: self namespace)
! !

!R2BaseExtFT methodsFor:'tests'!

testArrayNamespace
	| type |
	server typespace options beXSITypeArrays.
	self 
		makeRequest: '<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoFloatArray xmlns:namesp1="http://soapinterop.org/">
<inputFloatArray SOAP-ENC:arrayType="xsd:float[2]" xsi:type="SOAP-ENC:Array">
<item xsi:type="xsd:float">1.1</item>
<item xsi:type="xsd:float">2.2</item>
</inputFloatArray></namesp1:echoFloatArray></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoFloatArrayResponse'.
	type := self getReturnNode qValueForXSIType.
	self assert: type = ('ArrayOffloat' ns: #'http://soapinterop.org/xsd')
!

testArrayNamespace1999
	| type |
	server typespace options beXSITypeArrays.
	self 
		makeRequest: '<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoFloatArray xmlns:namesp1="http://soapinterop.org/">
<inputFloatArray SOAP-ENC:arrayType="xsd:float[2]" xsi:type="SOAP-ENC:Array">
<item xsi:type="xsd:float">1.1</item>
<item xsi:type="xsd:float">2.2</item>
</inputFloatArray></namesp1:echoFloatArray></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoFloatArrayResponse'.
	type := self getReturnNode qValueForXSIType.
	self assert: type = ('ArrayOffloat' ns: #'http://soapinterop.org/xsd')
!

testArrayNamespaceDontType
	| type |
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoFloatArray xmlns:namesp1="http://soapinterop.org/">
<inputFloatArray SOAP-ENC:arrayType="xsd:float[2]" xsi:type="SOAP-ENC:Array">
<item xsi:type="xsd:float">1.1</item>
<item xsi:type="xsd:float">2.2</item>
</inputFloatArray></namesp1:echoFloatArray></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoFloatArrayResponse'.
	type := self getReturnNode qValueForXSIType.
	self assert: type isNil
!

testArrayNoASize

	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoFloatArray xmlns:namesp1="http://soapinterop.org/">
<inputFloatArray SOAP-ENC:arrayType="xsd:float[]">
<item xsi:type="xsd:float">1.1</item>
<item xsi:type="xsd:float">2.2</item>
</inputFloatArray>
</namesp1:echoFloatArray></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoFloatArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"><return SOAP-ENC:arrayType="xsd:float[2]"><item xsi:type="xsd:float">1.1</item><item xsi:type="xsd:float">2.2</item></return></m:echoFloatArrayResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'

!

testArraySparse
	self 
		makeRequest: 
'<SOAP-ENV:Envelope
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
    xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
    xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
    xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
    xmlns:xsd="http://www.w3.org/1999/XMLSchema" >
  <SOAP-ENV:Body>
    <ns0:echoStructArray xmlns:ns0="http://soapinterop.org/" >
      <inputStructArray SOAP-ENC:arrayType="ns1:SOAPStruct[6]"
xmlns:ns1="http://soapinterop.org/xsd" >
        <arg xsi:type="ns1:SOAPStruct" SOAP-ENC:position="[2]">
          <varString xsi:type="ns2:string"
xmlns:ns2="http://www.w3.org/2001/XMLSchema" >STRING</varString>
          <varInt xsi:type="ns3:int"
xmlns:ns3="http://www.w3.org/2001/XMLSchema" >1</varInt>
          <varFloat xsi:type="ns4:float"
xmlns:ns4="http://www.w3.org/2001/XMLSchema" >1</varFloat>
        </arg>
        <arg xsi:type="ns1:SOAPStruct" SOAP-ENC:position="[4]">
          <varString xsi:type="ns5:string"
xmlns:ns5="http://www.w3.org/2001/XMLSchema" >STRING</varString>
          <varInt xsi:type="ns6:int"
xmlns:ns6="http://www.w3.org/2001/XMLSchema" >2</varInt>
          <varFloat xsi:type="ns7:float"
xmlns:ns7="http://www.w3.org/2001/XMLSchema" >2</varFloat>
        </arg>
      </inputStructArray>
    </ns0:echoStructArray>
  </SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoStructArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"><return SOAP-ENC:arrayType="ns1:SOAPStruct[6]"><item SOAP-ENC:position="[2]" xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:string">STRING</varString><varInt xsi:type="xsd:int">1</varInt><varFloat xsi:type="xsd:float">1.0</varFloat></item><item SOAP-ENC:position="[4]" xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:string">STRING</varString><varInt xsi:type="xsd:int">2</varInt><varFloat xsi:type="xsd:float">2.0</varFloat></item></return></m:echoStructArrayResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testArraySparse2
	self 
		makeRequest: 
'<?xml version="1.0" encoding="utf-8" ?>
 <SOAP-ENV:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:n1="http://soapinterop.org/"><SOAP-ENV:Body><n1:echoIntegerArray SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><inputIntegerArray xmlns:n2="http://schemas.xmlsoap.org/soap/encoding/" xsi:type="n2:Array" n2:arrayType="xsd:int[7]"><intAry n2:position="[1]">1</intAry><intAry n2:position="[3]">2</intAry><intAry n2:position="[5]">3</intAry></inputIntegerArray></n1:echoIntegerArray></SOAP-ENV:Body></SOAP-ENV:Envelope> '.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoIntegerArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"><return SOAP-ENC:arrayType="xsd:int[7]"><item SOAP-ENC:position="[1]" xsi:type="xsd:int">1</item><item SOAP-ENC:position="[3]" xsi:type="xsd:int">2</item><item SOAP-ENC:position="[5]" xsi:type="xsd:int">3</item></return></m:echoIntegerArrayResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testArraySparseFloat
	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:n1="http://soapinterop.org/"><SOAP-ENV:Body><n1:echoFloatArray SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><inputFloatArray xmlns:n2="http://schemas.xmlsoap.org/soap/encoding/" xsi:type="n2:Array" n2:arrayType="xsd:float[7]"><floatAry n2:position="[2]">0.0001</floatAry><floatAry n2:position="[3]">1000.0</floatAry><floatAry n2:position="[4]">0.0</floatAry></inputFloatArray></n1:echoFloatArray></SOAP-ENV:Body></SOAP-ENV:Envelope>'
.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoFloatArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"><return SOAP-ENC:arrayType="xsd:float[7]"><item SOAP-ENC:position="[2]" xsi:type="xsd:float">1.0e-004</item><item SOAP-ENC:position="[3]" xsi:type="xsd:float">1000.0</item><item SOAP-ENC:position="[4]" xsi:type="xsd:float">0.0</item></return></m:echoFloatArrayResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testArrayStructNamespace
	| type itemType |
	server typespace options beXSITypeArrays.
	self 
		makeRequest: '<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:typens="http://soapinterop.org/xsd">
<SOAP-ENV:Body>
<namesp1:echoStructArray xmlns:namesp1="http://soapinterop.org/">
<inputStructArray SOAP-ENC:arrayType="typens:SOAPStruct[1]" xsi:type="SOAP-ENC:Array">
<Item xsi:type="typens:SOAPStruct">
<varInt xsi:type="xsd:int">1234</varInt>
<varFloat xsi:type="xsd:float">43.44</varFloat>
<varString xsi:type="xsd:string">SQLData</varString>
</Item>
</inputStructArray></namesp1:echoStructArray></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoStructArrayResponse'.
	type := self getReturnNode qValueForXSIType.
	self assert: type = ('ArrayOfSOAPStruct' ns: #'http://soapinterop.org/xsd').
	itemType := self getReturnNode childNodes first qValueForXSIType.
	self assert: itemType = ('SOAPStruct' ns: #'http://soapinterop.org/xsd')
!

testArrayStructNamespace1999
	| type itemType |
	server typespace options beXSITypeArrays.
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:xsd="http://www.w3.org/1999/XMLSchema"
xmlns:typens="http://soapinterop.org/xsd">
<SOAP-ENV:Body>
<namesp1:echoStructArray xmlns:namesp1="http://soapinterop.org/">
<inputStructArray SOAP-ENC:arrayType="typens:SOAPStruct[1]" xsi:type="SOAP-ENC:Array">
<Item xsi:type="typens:SOAPStruct">
<varInt xsi:type="xsd:int">1234</varInt>
<varFloat xsi:type="xsd:float">43.44</varFloat>
<varString xsi:type="xsd:string">SQLData</varString>
</Item>
</inputStructArray></namesp1:echoStructArray></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoStructArrayResponse'.
	type := self getReturnNode qValueForXSIType.
	self assert: type = (XeQName local: 'ArrayOfSOAPStruct' ns: #'http://soapinterop.org/xsd').
	itemType := self getReturnNode childNodes first qValueForXSIType.
	self assert: itemType = (XeQName local: 'SOAPStruct' ns: #'http://soapinterop.org/xsd')
!

testEchoBase64200106
	self 
		makeRequest: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://www.w3.org/2001/06/soap-encoding" SOAP-ENV:encodingStyle="http://www.w3.org/2001/06/soap-encoding" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><SOAP-ENV:Body><ns:echoBase64 xmlns:ns="http://soapinterop.org/"><inputBase64 xsi:type="SOAP-ENC:base64">YUdWc2JHOGdkMjl5YkdRPQ==</inputBase64></ns:echoBase64></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoBase64Response'.
	self assert: ('*xsi:type="xsd:base64Binary">YUdWc2JHOGdkMjl5YkdRPQ==*' match: responseXML).
	self assert: ('*xmlns:xsd="http://www.w3.org/2001/XMLSchema"*' match: responseXML)
!

testEchoBase64Binary
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:n1="http://soapinterop.org/">
<SOAP-ENV:Body>
<n1:echoBase64><inputBase64 xsi:type="xsd:base64Binary">YUdWc2JHOGdkMjl5YkdRPQ==</inputBase64>
</n1:echoBase64>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoBase64Response'.
	self assert: ('*xsi:type="xsd:base64Binary">YUdWc2JHOGdkMjl5YkdRPQ==*' match: responseXML).
	self assert: ('*xmlns:xsd="http://www.w3.org/2001/XMLSchema"*' match: responseXML)
!

testEchoBase64JSoap
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?><SOAP-ENV:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><SOAP-ENV:Body><ns1:echoBase64 xmlns:ns1="http://soapinterop.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><inputBase64 xsi:type="ns2:base64Binary" xmlns:ns2="http://schemas.xmlsoap.org/soap/encoding/">VGhpcyBpcyBhIHRlc3Q=</inputBase64></ns1:echoBase64></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoBase64Response'.
	self assert: ('*xsi:type="xsd:base64Binary">VGhpcyBpcyBhIHRlc3Q=*' match: responseXML).
	self assert: ('*xmlns:xsd="http://www.w3.org/2001/XMLSchema"*' match: responseXML)
!

testEchoBoolean
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:n1="http://soapinterop.org/">
<SOAP-ENV:Body>
<n1:echoBoolean><inputBoolean xsi:type="xsd:boolean">true</inputBoolean>
</n1:echoBoolean>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assertResponseWrapperNamed: 'echoBooleanResponse'.
	self assert: ('*xsi:type="xsd:boolean">true<*' match: responseXML)
!

testEchoDate
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:n1="http://soapinterop.org/">
<SOAP-ENV:Body>
<n1:echoDate><inputDate xsi:type="xsd:dateTime">2001-06-29T01:21:40</inputDate>
</n1:echoDate>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoDateResponse'.
	self assert: (XeXsdDateTime fromString: self getReturnNode text) 
				= (XeXsdDateTime fromString: '2001-06-29T01:21:40')
!

testEchoFloatIONANeg
	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"> <SOAP-ENV:Body> <m:echoFloat xmlns:m="http://soapinterop.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <inputFloat xsi:type="xsd:float">-1.4E-45</inputFloat> </m:echoFloat> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self denyFaultResponse
!

testEchoFloatIONAPos
	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"> <SOAP-ENV:Body> <m:echoFloat xmlns:m="http://soapinterop.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <inputFloat xsi:type="xsd:float">1.4E-45</inputFloat> </m:echoFloat> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self denyFaultResponse
!

testEchoFloatOverflow
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:n1="http://soapinterop.org/">
<SOAP-ENV:Body> 
<n1:echoFloat>
<inputFloat xsi:type="xsd:float">1.0e+150</inputFloat>
</n1:echoFloat>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assertFaultResponse
!

testEchoHexBinary
	self 
		makeRequest: 
'<?xml version="1.0" encoding="utf-8" ?> <SOAP-ENV:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:n1="http://soapinterop.org/"><SOAP-ENV:Body><n1:echoHexBinary SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><inputHexBinary xsi:type="xsd:hexBinary">48656C6C6F2028C6FCCBDCB8EC4A6170616E6573652920A4B3A4F3A4CBA4C1A4CF</inputHexBinary></n1:echoHexBinary></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoHexBinaryResponse'.
	self 
		assert: ('*>48656C6C6F2028C6FCCBDCB8EC4A6170616E6573652920A4B3A4F3A4CBA4C1A4CF<*' match: responseXML)
!

testEchoInt1999
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<namesp1:echoInteger xmlns:namesp1="http://soapinterop.org/">
<inputInteger xsi:type="xsd:int">5</inputInteger>
</namesp1:echoInteger>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoIntegerResponse'.
	self assert: ('*xsi:type="xsd:int">5<*' match: responseXML).
	self assert: ('*xmlns:xsd="http://www.w3.org/2001/XMLSchema"*' match: responseXML)
!

testEchoMap
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?><SOAP-ENV:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><SOAP-ENV:Body><ns1:echoMap xmlns:ns1="http://soapinterop.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<inputMap xsi:type="ns2:Map" xmlns:ns2="http://xml.apache.org/xml-soap">
<item><key xsi:type="xsd:string">abc</key><value xsi:type="xsd:float">4.32</value></item>
<item><key xsi:type="xsd:int">123</key><value xsi:type="xsd:boolean">true</value></item>
</inputMap>
</ns1:echoMap>
</SOAP-ENV:Body></SOAP-ENV:Envelope>'.

	self 
		assertAnswerXMLSameAs: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://xml.apache.org/xml-soap" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body>
<m:echoMapResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/">
<return xsi:type="ns1:Map">
<item xsi:type="ns1:item"><key xsi:type="xsd:string">abc</key><value xsi:type="xsd:double">4.32</value></item>
<item xsi:type="ns1:item"><key xsi:type="xsd:integer">123</key><value xsi:type="xsd:boolean">true</value></item>
</return>
</m:echoMapResponse>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'

	
!

testEchoMap2
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
 <SOAP-ENV:Body>
  <ns1:echoMap xmlns:ns1="http://soapinterop.org/">
   <inputMap href="#id0"/>
  </ns1:echoMap>
  <multiRef id="id0" SOAP-ENC:root="0" xsi:type="ns2:Map" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:ns2="http://xml.apache.org/xml-soap">
   <item>
    <key xsi:type="xsd:dateTime">2001-12-13T20:35:50.559Z</key>
    <value xsi:type="xsd:string">string value</value>
   </item>
   <item>
    <key xsi:type="xsd:string">stringKey</key>
    <value xsi:type="xsd:int">5</value>
   </item>
  </multiRef>
 </SOAP-ENV:Body>
</SOAP-ENV:Envelope>
 '.

	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://xml.apache.org/xml-soap" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoMapResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"><return xsi:type="ns1:Map">
<item xsi:type="ns1:item"><key xsi:type="xsd:dateTime">2001-12-13T20:35:50Z</key><value xsi:type="xsd:string">string value</value></item>
<item xsi:type="ns1:item"><key xsi:type="xsd:string">stringKey</key><value xsi:type="xsd:integer">5</value></item>
</return>
</m:echoMapResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'

	
!

testEchoMap3
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:ns="http://soapinterop.org/" xmlns:s="http://soapinterop.org/xsd" xmlns:a="http://xml.apache.org/xml-soap" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><SOAP-ENV:Body>
<ns:echoMap><inputMap xsi:type="a:Map"><item xsi:type="a:item"><key xsi:type="xsd:string">hello</key>
<value xsi:type="xsd:string">world</value>
</item>
<item xsi:type="a:item"><key xsi:type="xsd:int">2</key>
<value xsi:type="xsd:boolean">true</value>
</item>
</inputMap>
</ns:echoMap>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.

	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://xml.apache.org/xml-soap" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:echoMapResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/">
<return xsi:type="ns1:Map">
<item xsi:type="ns1:item"><key xsi:type="xsd:string">hello</key><value xsi:type="xsd:string">world</value></item>
<item xsi:type="ns1:item"><key xsi:type="xsd:integer">2</key><value xsi:type="xsd:boolean">true</value></item>
</return>
</m:echoMapResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'


	
!

testEchoMapArray
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?><SOAP-ENV:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><SOAP-ENV:Body><ns1:echoMapArray xmlns:ns1="http://soapinterop.org/" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><inputMapArray ns3:arrayType="ns4:Map[3]" xsi:type="ns3:Array" xmlns:ns4="http://xml.apache.org/xml-soap" xmlns:ns3="http://schemas.xmlsoap.org/soap/encoding/" xmlns:ns2="http://www.w3.org/2001/XMLSchema">
<item xsi:type="ns4:Map">
 <item><key xsi:type="xsd:string">abc</key><value xsi:type="xsd:float">4.32</value></item>
 <item><key xsi:type="xsd:int">123</key><value xsi:type="xsd:boolean">true</value></item>
</item>
<item xsi:type="ns4:Map">
  <item><key xsi:type="xsd:string">abc</key><value xsi:type="xsd:float">4.32</value></item>
  <item><key xsi:type="xsd:int">123</key><value xsi:type="xsd:boolean">true</value></item>
</item>
<item xsi:type="ns4:Map">
  <item><key xsi:type="xsd:string">abc</key><value xsi:type="xsd:float">4.32</value></item>
  <item><key xsi:type="xsd:int">123</key><value xsi:type="xsd:boolean">true</value></item>
</item>
</inputMapArray></ns1:echoMapArray></SOAP-ENV:Body></SOAP-ENV:Envelope>'.

	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://xml.apache.org/xml-soap" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:echoMapArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/">
<return SOAP-ENC:arrayType="ns1:Map[3]">
<item xsi:type="ns1:Map">
 <item xsi:type="ns1:item"><key xsi:type="xsd:string">abc</key><value xsi:type="xsd:double">4.32</value></item>
 <item xsi:type="ns1:item"><key xsi:type="xsd:integer">123</key><value xsi:type="xsd:boolean">true</value></item>
</item>
<item xsi:type="ns1:Map">
 <item xsi:type="ns1:item"><key xsi:type="xsd:string">abc</key><value xsi:type="xsd:double">4.32</value></item>
 <item xsi:type="ns1:item"><key xsi:type="xsd:integer">123</key><value xsi:type="xsd:boolean">true</value></item>
</item>
<item xsi:type="ns1:Map">
 <item xsi:type="ns1:item"><key xsi:type="xsd:string">abc</key><value xsi:type="xsd:double">4.32</value></item>
 <item xsi:type="ns1:item"><key xsi:type="xsd:integer">123</key><value xsi:type="xsd:boolean">true</value></item>
</item>
</return></m:echoMapArrayResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'

	
!

testEchoMapArray2
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
 <SOAP-ENV:Body>
  <ns1:echoMapArray xmlns:ns1="http://soapinterop.org/">
   <inputMapArray href="#id0"/>
  </ns1:echoMapArray>
  <multiRef id="id0" SOAP-ENC:root="0" xsi:type="SOAP-ENC:Array" SOAP-ENC:arrayType="ns2:Map[2]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:ns2="http://xml.apache.org/xml-soap">
   <item href="#id1"/>
   <item href="#id2"/>
  </multiRef>
  <multiRef id="id1" SOAP-ENC:root="0" xsi:type="ns3:Map" xmlns:ns3="http://xml.apache.org/xml-soap" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
   <item>
    <key xsi:type="xsd:dateTime">2001-12-13T20:35:50.559Z</key>
    <value xsi:type="xsd:string">string value</value>
   </item>
   <item>
    <key xsi:type="xsd:string">stringKey</key>
    <value xsi:type="xsd:int">5</value>
   </item>
  </multiRef>
  <multiRef id="id2" SOAP-ENC:root="0" xsi:type="ns4:Map" xmlns:ns4="http://xml.apache.org/xml-soap" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
   <item>
    <key xsi:type="xsd:string">this is the second map</key>
    <value xsi:type="xsd:boolean">true</value>
   </item>
   <item>
    <key xsi:type="xsd:string">test</key>
    <value xsi:type="xsd:float">411.0</value>
   </item>
  </multiRef>
 </SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.

	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://xml.apache.org/xml-soap" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:echoMapArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/">
<return SOAP-ENC:arrayType="ns1:Map[2]">
<item xsi:type="ns1:Map">
  <item xsi:type="ns1:item"><key xsi:type="xsd:dateTime">2001-12-13T20:35:50Z</key><value xsi:type="xsd:string">string value</value></item>
  <item xsi:type="ns1:item"><key xsi:type="xsd:string">stringKey</key><value xsi:type="xsd:integer">5</value></item>
</item>
<item xsi:type="ns1:Map">
  <item xsi:type="ns1:item"><key xsi:type="xsd:string">this is the second map</key><value xsi:type="xsd:boolean">true</value></item>
  <item xsi:type="ns1:item"><key xsi:type="xsd:string">test</key><value xsi:type="xsd:double">411.0</value></item>
</item>
</return>
</m:echoMapArrayResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testEchoMapArray3
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:ns="http://soapinterop.org/" xmlns:s="http://soapinterop.org/xsd" xmlns:a="http://xml.apache.org/xml-soap" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><SOAP-ENV:Body>
<ns:echoMapArray><inputMapArray xsi:type="SOAP-ENC:Array" SOAP-ENC:arrayType="a:Map[2]"><item xsi:type="a:Map"><item xsi:type="a:item"><key href="#4"/>
<value href="#6"/>
</item>
<item xsi:type="a:item"><key href="#8"/>
<value href="#9"/>
</item>
</item>
<item xsi:type="a:Map"><item xsi:type="a:item"><key href="#4"/>
<value href="#6"/>
</item>
<item xsi:type="a:item"><key href="#8"/>
<value href="#9"/>
</item>
</item>
</inputMapArray>
</ns:echoMapArray>
<id id="4" xsi:type="xsd:string">hello</id>
<id id="6" xsi:type="xsd:string">world</id>
<id id="8" xsi:type="xsd:int">2</id>
<id id="9" xsi:type="xsd:boolean">true</id>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.

	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://xml.apache.org/xml-soap" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoMapArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/">
<return SOAP-ENC:arrayType="ns1:Map[2]">
 <item xsi:type="ns1:Map">
  <item xsi:type="ns1:item"><key id="id1" xsi:type="xsd:string">hello</key><value id="id2" xsi:type="xsd:string">world</value></item>
  <item xsi:type="ns1:item"><key xsi:type="xsd:integer">2</key><value xsi:type="xsd:boolean">true</value></item>
 </item>
 <item xsi:type="ns1:Map">
  <item xsi:type="ns1:item"><key href="#id1"/><value href="#id2"/></item>
  <item xsi:type="ns1:item"><key xsi:type="xsd:integer">2</key><value xsi:type="xsd:boolean">true</value></item>
 </item>
</return>
</m:echoMapArrayResponse>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'

!

testEchoScaledDecimal
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:n1="http://soapinterop.org/">
<SOAP-ENV:Body>
<n1:echoDecimal><inputDecimal xsi:type="xsd:decimal">123.456</inputDecimal>
</n1:echoDecimal>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assertResponseWrapperNamed: 'echoDecimalResponse'.
	self assert: ('*xsi:type="xsd:decimal">123.456*' match: responseXML)
!

testEchoSoapBase64
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/1999/XMLSchema"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:n1="http://soapinterop.org/">
<SOAP-ENV:Body>
<n1:echoBase64><inputBase64 xsi:type="SOAP-ENC:base64">YUdWc2JHOGdkMjl5YkdRPQ==</inputBase64>
</n1:echoBase64>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoBase64Response'.
	self assert: ('*xsi:type="xsd:base64Binary">YUdWc2JHOGdkMjl5YkdRPQ==*' match: responseXML).
	self assert: ('*xmlns:xsd="http://www.w3.org/2001/XMLSchema"*' match: responseXML)
!

testEchoStructEntities
	self class isSkipAckFailures ifTrue: [^nil].
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:m="http://soapinterop.org/" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:echoStruct>
<inputStruct>
<varString xsi:type="xsd:string">pocketSOAP
rocks!!&amp;lt;g</varString>
<varInt xsi:type="xsd:int">1073741824</varInt>
</inputStruct>
</m:echoStruct>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assert: self getReturnNode childNodes first text = 
'pocketSOAP
rocks!!<g'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoStructResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"><return xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:string">pocketSOAP
rocks!!&amp;lt;g</varString><varInt xsi:type="xsd:int">1073741824</varInt><varFloat xsi:nil="true"/></return></m:echoStructResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testEchoStructSimpleIDs
	self 
		makeRequest: 
'<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:ns="http://soapinterop.org/" xmlns:s="http://soapinterop.org/xsd" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"><SOAP-ENV:Body>
<ns:echoStructArray><inputStructArray xsi:type="SOAP-ENC:Array" SOAP-ENC:arrayType="s:SOAPStruct[3]"><s:SOAPStruct xsi:type="s:SOAPStruct"><varString xsi:type="xsd:string">Hello</varString>
<varInt href="#4"/>
<varFloat href="#5"/>
</s:SOAPStruct>
<s:SOAPStruct xsi:type="s:SOAPStruct"><varString xsi:type="xsd:string">World</varString>
<varInt href="#4"/>
<varFloat href="#5"/>
</s:SOAPStruct>
<s:SOAPStruct xsi:type="s:SOAPStruct"><varString xsi:type="xsd:string">!!</varString>
<varInt href="#4"/>
<varFloat href="#5"/>
</s:SOAPStruct>
</inputStructArray>
</ns:echoStructArray>
<xsd:float id="5" xsi:type="xsd:float">654.321</xsd:float>
<xsd:int id="4" xsi:type="xsd:int">987654321</xsd:int>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:echoStructArrayResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/">
<return SOAP-ENC:arrayType="ns1:SOAPStruct[3]">
<item xsi:type="ns1:SOAPStruct">
<varString xsi:type="xsd:string">Hello</varString>
<varInt xsi:type="xsd:int">987654321</varInt>
<varFloat xsi:type="xsd:float">654.321</varFloat>
</item>
<item xsi:type="ns1:SOAPStruct">
<varString xsi:type="xsd:string">World</varString>
<varInt xsi:type="xsd:int">987654321</varInt>
<varFloat xsi:type="xsd:float">654.321</varFloat>
</item>
<item xsi:type="ns1:SOAPStruct">
<varString xsi:type="xsd:string">!!</varString>
<varInt xsi:type="xsd:int">987654321</varInt>
<varFloat xsi:type="xsd:float">654.321</varFloat>
</item>
</return></m:echoStructArrayResponse></SOAP-ENV:Body></SOAP-ENV:Envelope>'


	
!

testEchoTimeInstant1999
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/1999/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:n1="http://soapinterop.org/">
<SOAP-ENV:Body>
<n1:echoDate><inputDate xsi:type="xsd:timeInstant">2001-06-29T01:21:40</inputDate>
</n1:echoDate>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self denyFaultResponse.
	self assertResponseWrapperNamed: 'echoDateResponse'.
	self assert: (XeXsdDateTime fromString: self getReturnNode text) 
				= (XeXsdDateTime fromString: '2001-06-29T01:21:40').
	self assert: ('*xsi:type="xsd:dateTime">2001-06-29T01:21:40Z*' match: responseXML).
	self assert: ('*xmlns:xsd="http://www.w3.org/2001/XMLSchema"*' match: responseXML)
!

testPhalanxBase64
	self 
		makeRequest: 
'<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoBase64 xmlns:m="http://soapinterop.org/"><inputBase64 xsi:type="xsd:base64Binary">Ty4rY6=</inputBase64></m:echoBase64></SOAP-ENV:Body></SOAP-ENV:Envelope>'

	"should this be a fault??"
! !

!R2BaseExtFT class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/tests/SOAP__R2BaseExtFT.st,v 1.1 2008/09/07 18:52:39 cg Exp $'
! !
