"{ Package: 'stx:goodies/soap/spray/services/tests' }"

"{ NameSpace: SOAP }"

SoapInteropFTs subclass:#R2BaseNegFT
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2-TestCases'
!


!R2BaseNegFT methodsFor:'accessing'!

getService
	^SoapInteropBaseService new
! !

!R2BaseNegFT methodsFor:'tests'!

testEmbeddedMultiref
	self 
		makeRequest: 
'<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/X" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><SOAP-ENV:Body>
<m:echoInteger xmlns:m="http://soapinterop.org/">
<inputInteger href="#a1"/>
<multiref id="a1" xsi:type="xsd:int">13</multiref>
</m:echoInteger>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>   '.
	self assertFaultResponse
!

testInvalidHREF
	"SW: I dont believe this test necessarily is correct. The value element is the correct location for the type attribute, and I believe it is OK to ignore the accessor type attribute"

	self class isSkipAckFailures ifTrue: [^nil].
	self 
		makeRequest: 
'<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ns1="http://soapinterop.org/xsd" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><SOAP-ENV:Body>
<ns:echoStructArray xmlns:ns="http://soapinterop.org/">
<inputStructArray SOAP-ENC:arrayType="ns1:SOAPStruct[3]" xsi:type="SOAP-ENC:Array">
<item href="#2" xsi:type="ns1:SOAPStruct">invalid value</item>
<item xsi:type="ns1:SOAPStruct">
  <varFloat xsi:type="xsd:float">21.02</varFloat>
  <varString xsi:type="xsd:string">c</varString>
  <varInt xsi:type="xsd:int">3</varInt>
</item>
<item href="#1" xsi:type="ns1:SOAPStruct"/>

</inputStructArray></ns:echoStructArray>
<mrA id="1" xsi:type="ns1:SOAPStruct">
<varInt xsi:type="xsd:int">-33</varInt>
<varFloat xsi:type="xsd:float">33.33</varFloat>
<varString xsi:type="xsd:string">test 1</varString>
</mrA>
<mrB id="2" xsi:type="ns1:SOAPStruct">
<varFloat xsi:type="xsd:float">11.11</varFloat>
<varString xsi:type="xsd:string">test 2</varString>
<varInt xsi:type="xsd:int">-11</varInt>
</mrB>
</SOAP-ENV:Body></SOAP-ENV:Envelope> '.
	self assertFaultResponse
!

testInvalidTypeForArray
	self 
		makeRequest: 
'<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Body>
<m:echoStringArray xmlns:m="http://soapinterop.org/">
<inputStringArray SOAP-ENC:arrayType="xsd:string[4]" xsi:type="xsd:roastbeef">
<item xsi:type="xsd:string">this</item><item xsi:type="xsd:string">is</item><item xsi:type="xsd:string">a</item><item xsi:type="xsd:string">test</item>
</inputStringArray></m:echoStringArray></SOAP-ENV:Body></SOAP-ENV:Envelope> '.
	self assertFaultResponse
!

testInvalidTypeForStruct
	self 
		makeRequest: 
'<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Body>
<m:echoStruct xmlns:m="http://soapinterop.org/">
<inputStruct xsi:type="ns1:roastbeef">
<varString xsi:type="xsd:string">easy test</varString>
<varInt xsi:type="xsd:int">11</varInt>
<varFloat xsi:type="xsd:float">22.33</varFloat>
</inputStruct></m:echoStruct></SOAP-ENV:Body></SOAP-ENV:Envelope> '.
	self assertFaultResponse
!

testInvalidTypeInStruct
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://soapinterop.org/xsd"
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Body><m:echoStruct xmlns:m="http://soapinterop.org/"><inputStruct xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:roastbeef">easy test</varString><varInt xsi:type="xsd:int">11</varInt><varFloat xsi:type="xsd:float">22.33</varFloat></inputStruct></m:echoStruct></SOAP-ENV:Body></SOAP-ENV:Envelope>'.
	self assertFaultResponse
!

testInvalidURIForArrayType
	self 
		makeRequest: 
'<SOAP-ENV:Envelope
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/X"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Body><m:echoIntegerArray xmlns:m="http://soapinterop.org/"><inputIntegerArray SOAP-ENC:arrayType="xsd:int[5]" xsi:type="SOAP-ENC:Array"><item xsi:type="xsd:int">-2</item><item xsi:type="xsd:int">-1</item><item xsi:type="xsd:int">0</item><item xsi:type="xsd:int">1</item><item xsi:type="xsd:int">2</item></inputIntegerArray></m:echoIntegerArray></SOAP-ENV:Body></SOAP-ENV:Envelope>   '.
	self assertFaultResponse
!

testInvalidURIForStruct
	self 
		makeRequest: 
'<SOAP-ENV:Envelope
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://soapinterop.org/xsdX"
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<SOAP-ENV:Body><m:echoStruct xmlns:m="http://soapinterop.org/"><inputStruct xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:string">easy test</varString><varInt xsi:type="xsd:int">11</varInt><varFloat xsi:type="xsd:float">22.33</varFloat></inputStruct></m:echoStruct></SOAP-ENV:Body></SOAP-ENV:Envelope>  '.
	self assertFaultResponse
!

testInvalidURIInStruct
	self 
		makeRequest: 
'<SOAP-ENV:Envelope
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://soapinterop.org/xsd"
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchemaX">
<SOAP-ENV:Body><m:echoStruct xmlns:m="http://soapinterop.org/"><inputStruct xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:string">easy test</varString><varInt xsi:type="xsd:int">11</varInt><varFloat xsi:type="xsd:float">22.33</varFloat></inputStruct></m:echoStruct></SOAP-ENV:Body></SOAP-ENV:Envelope> '.
	self assertFaultResponse
!

testJunkBoolean
	self 
		makeRequest: 
'<E:Envelope
	xmlns:E="http://schemas.xmlsoap.org/soap/envelope/"
	xmlns:A="http://schemas.xmlsoap.org/soap/encoding/"
	xmlns:s="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:y="http://www.w3.org/2001/XMLSchema"
	E:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<E:Body>
<m:echoBoolean
	xmlns:m="http://soapinterop.org/">
<inputBoolean
	s:type="y:boolean">junk</inputBoolean>
</m:echoBoolean>
</E:Body>
</E:Envelope> '.
	self assertFaultResponse
!

testJunkFloat
	self 
		makeRequest: 
'<E:Envelope
	xmlns:E="http://schemas.xmlsoap.org/soap/envelope/"
	xmlns:A="http://schemas.xmlsoap.org/soap/encoding/"
	xmlns:s="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:y="http://www.w3.org/2001/XMLSchema"
	E:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<E:Body>
<m:echoFloat
	xmlns:m="http://soapinterop.org/">
<inputFloat
	s:type="y:float">1234junk</inputFloat>
</m:echoFloat>
</E:Body>
</E:Envelope>

 '.
	self assertFaultResponse
!

testJunkFloat2
	self 
		makeRequest: 
'<E:Envelope
	xmlns:E="http://schemas.xmlsoap.org/soap/envelope/"
	xmlns:A="http://schemas.xmlsoap.org/soap/encoding/"
	xmlns:s="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:y="http://www.w3.org/2001/XMLSchema"
	E:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<E:Body>
<m:echoFloat
	xmlns:m="http://soapinterop.org/">
<inputFloat
	s:type="y:float">any</inputFloat>
</m:echoFloat>
</E:Body>
</E:Envelope>

 '.
	self assertFaultResponse
!

testJunkInteger
	self 
		makeRequest: 
'<E:Envelope
	xmlns:E="http://schemas.xmlsoap.org/soap/envelope/"
	xmlns:A="http://schemas.xmlsoap.org/soap/encoding/"
	xmlns:s="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:y="http://www.w3.org/2001/XMLSchema"
	E:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<E:Body>
<m:echoInteger
	xmlns:m="http://soapinterop.org/">
<inputInteger
	s:type="y:int">1234junk</inputInteger>
</m:echoInteger>
</E:Body>
</E:Envelope> '.
	self assertFaultResponse
!

testUndeclaredNS
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body><m:echoFloat xmlns:m="http://soapinterop.org/"><inputFloat xsi:type="xsd1:float">2.345</inputFloat></m:echoFloat></SOAP-ENV:Body></SOAP-ENV:Envelope> '.
	self assertFaultResponse
!

testUnresolvableQName
	self class isSkipAckFailures ifTrue: [^nil].
	self 
		makeRequest: 
'<SOAP-ENV:Envelope
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:echoFloat xmlns:m="http://soapinterop.org/">
<inputFloat xsi:type="xsd:float" SOAP-ENC:type="x:y">2.345</inputFloat>
</m:echoFloat>
</SOAP-ENV:Body></SOAP-ENV:Envelope> '.
	self assertFaultResponse
!

testWrongMethodNS
	self 
		makeRequest: 
'<SOAP-ENV:Envelope
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body><m:echoFloat xmlns:m="http://soapinterop.orgs/"><inputFloat xsi:type="xsd:float">2.345</inputFloat></m:echoFloat></SOAP-ENV:Body></SOAP-ENV:Envelope> '.
	self assertFaultResponse
!

testWrongParamName
	self 
		makeRequest: 
'<SOAP-ENV:Envelope 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" 
xmlns:n1="http://soapinterop.org/">
<SOAP-ENV:Body>
<n1:echoDate>
<NOTinputDate xsi:type="xsd:dateTime">2001-06-29T01:21:40</NOTinputDate>
</n1:echoDate>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'.
	self assertFaultResponse.
! !

!R2BaseNegFT class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/tests/SOAP__R2BaseNegFT.st,v 1.1 2008/09/07 18:52:47 cg Exp $'
! !
