"{ Package: 'stx:goodies/soap/spray/services/tests' }"

"{ NameSpace: SOAP }"

SoapInteropFTs subclass:#R2CExtFT
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2-TestCases'
!


!R2CExtFT methodsFor:'accessing'!

getService
	^SoapInteropGroupCService new
! !

!R2CExtFT methodsFor:'tests'!

testStringMU0NotTarget
	"Example 2: mustUnderstand='0', *not* targeted at the recipient, header entry is ignored."

	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <SOAP-ENV:Header> <h:echoMeStringRequest xmlns:h="http://soapinterop.org/echoheader/" SOAP-ENV:actor="http://some/other/actor">hello world</h:echoMeStringRequest> </SOAP-ENV:Header> <SOAP-ENV:Body> <m:echoVoid xmlns:m="http://soapinterop.org/"> </m:echoVoid> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><m:echoVoidResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"/></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testStringMU0Target
	"Example 1: mustUnderstand='0', targeted at the recipient, processed with result that header entry is returned to client."

	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <SOAP-ENV:Header> <h:echoMeStringRequest xmlns:h="http://soapinterop.org/echoheader/" SOAP-ENV:actor="http://schemas.xmlsoap.org/soap/actor/next">hello world</h:echoMeStringRequest> </SOAP-ENV:Header> <SOAP-ENV:Body> <m:echoVoid xmlns:m="http://soapinterop.org/"> </m:echoVoid> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Header>
<ns1:echoMeStringResponse
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
  xsi:type="xsd:string" 
  xmlns:ns1="http://soapinterop.org/echoheader/">hello world</ns1:echoMeStringResponse>
</SOAP-ENV:Header>
<SOAP-ENV:Body>
<m:echoVoidResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"/></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testStructMU1NotTarget
	"Example 2: mustUnderstand='1', *not* targeted at recipient, is simply ignored. PLEASE NOTE: Although included for completeness, this scenario is excluded from the scope of interop testing because this interpretation of the SOAP 1.1 spec remains controversial."

	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <SOAP-ENV:Header> <h:echoMeStructRequest xmlns:h="http://soapinterop.org/echoheader/" SOAP-ENV:actor="http://some/other/actor" SOAP-ENV:mustUnderstand="1"> <varInt>33</varInt> <varFloat>99.625</varFloat> <varString>hello world</varString> </h:echoMeStructRequest> </SOAP-ENV:Header> <SOAP-ENV:Body> <m:echoVoid xmlns:m="http://soapinterop.org/"> </m:echoVoid> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'

	"??? (we ignore it)"
!

testStructMU1Target
	"Example 1: mustUnderstand='1, targeted at the recipient, processed with result that header entry is returned to client."

	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <SOAP-ENV:Header> <h:echoMeStructRequest xmlns:h="http://soapinterop.org/echoheader/" SOAP-ENV:actor="http://schemas.xmlsoap.org/soap/actor/next" SOAP-ENV:mustUnderstand="1"> <varInt>42</varInt> <varFloat>99.005</varFloat> <varString>hello world</varString> </h:echoMeStructRequest> </SOAP-ENV:Header> <SOAP-ENV:Body> <m:echoVoid xmlns:m="http://soapinterop.org/"> </m:echoVoid> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:ns2="http://soapinterop.org/xsd">
<SOAP-ENV:Header>
<ns1:echoMeStructResponse 
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xsi:type="ns2:SOAPStruct"
  xmlns:ns1="http://soapinterop.org/echoheader/">
    <varString xsi:type="xsd:string">hello world</varString>
    <varInt xsi:type="xsd:int">42</varInt>
    <varFloat xsi:type="xsd:float">99.005</varFloat>
</ns1:echoMeStructResponse>
</SOAP-ENV:Header><SOAP-ENV:Body><m:echoVoidResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"/></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testUnknownMU0NotTarget
	"Example 3: An unknown header entry with mustUnderstand=0, *not* targeted at the recipient, is simply ignored."

	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <SOAP-ENV:Header> <h:echoMeUnknown xmlns:h="http://unknown/" SOAP-ENV:actor="http://some/other/actor">nobody understands me!!</h:echoMeUnknown> </SOAP-ENV:Header> <SOAP-ENV:Body> <m:echoVoid xmlns:m="http://soapinterop.org/"> </m:echoVoid> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:echoVoidResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"/>
</SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testUnknownMU0Target
	"Example 1: An unknown header entry with mustUnderstand=0, targeted at the recipient, is simply ignored.."

	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <SOAP-ENV:Header> <h:echoMeUnknown xmlns:h="http://unknown/" SOAP-ENV:actor="http://schemas.xmlsoap.org/soap/actor/next">nobody understands me!!</h:echoMeUnknown> </SOAP-ENV:Header> <SOAP-ENV:Body> <m:echoVoid xmlns:m="http://soapinterop.org/"> </m:echoVoid> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body><m:echoVoidResponse SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://soapinterop.org/"/></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

testUnknownMU1NotTarget
	"Example 4: An unknown header entry with mustUnderstand='1', *not* targeted at the recipient, is simply ignored. PLEASE NOTE: Although included for completeness, this scenario is excluded from the scope of interop testing because this interpretation of the SOAP 1.1 spec remains controversial."

	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <SOAP-ENV:Header> <h:echoMeUnknown xmlns:h="http://unknown/" SOAP-ENV:actor="http://some/other/actor" SOAP-ENV:mustUnderstand="1"></h:echoMeUnknown> </SOAP-ENV:Header> <SOAP-ENV:Body> <m:echoVoid xmlns:m="http://soapinterop.org/"> </m:echoVoid> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'


	"??? ignored"
!

testUnknownMU1Target
	"Example 2: An unknown header entry with mustUnderstand=1, targeted at the recipient, results in a Fault message"

	self 
		makeRequest: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"> <SOAP-ENV:Header> <h:echoMeUnknown xmlns:h="http://unknown/" SOAP-ENV:actor="http://schemas.xmlsoap.org/soap/actor/next" SOAP-ENV:mustUnderstand="1">nobody understands me!!</h:echoMeUnknown> </SOAP-ENV:Header> <SOAP-ENV:Body> <m:echoVoid xmlns:m="http://soapinterop.org/"> </m:echoVoid> </SOAP-ENV:Body> </SOAP-ENV:Envelope>'.
	self 
		assertAnswerXMLSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<SOAP-ENV:Fault>
<faultcode>SOAP-ENV:MustUnderstand</faultcode>
<faultstring>One or more mandatory headers not understood</faultstring>
</SOAP-ENV:Fault></SOAP-ENV:Body></SOAP-ENV:Envelope>
'
! !

!R2CExtFT class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/tests/SOAP__R2CExtFT.st,v 1.1 2008/09/07 18:52:55 cg Exp $'
! !
