"{ Package: 'stx:goodies/soap/spray/services/tests' }"

"{ NameSpace: SOAP }"

R2FTs subclass:#R2DocFTs
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2-TestCases'
!


!R2DocFTs methodsFor:'accessing'!

getCDoc1
	| ss ns |
	ns := #'http://soapinterop.org/'.
	ss := XeQStruct new.
	ss attributes at: #AnAttribute put: 'hello'.
	ss
		at: ('simpleDoc' ns: ns)
			put: (Array with: (XeSimpleValue new value: 'from')
					with: (XeSimpleValue new value: 'Spray'));
		at: ('child' ns: ns)
			put: (XeQStruct param: ('childSimpleDoc' ns: ns)
					value: (Array 
							with: (XeSimpleValue new value: 'bye')
							with: (XeSimpleValue new value: 'from')
							with: (XeSimpleValue new value: 'Spray'))).
	^ss
!

getCDoc1EmptyArrayItems
	| ss ns |
	ns := #'http://soapinterop.org/'.
	ss := XeQStruct new.
	ss attributes at: #AnAttribute put: 'hello'.
	ss
		at: ('simpleDoc' ns: ns)
			put: (Array with: (XeSimpleValue new value: '') with: (XeSimpleValue new value: 'Spray'));
		at: ('child' ns: ns)
			put: (XeQStruct param: ('childSimpleDoc' ns: ns)
					value: (Array 
							with: (XeSimpleValue new value: '')
							with: (XeSimpleValue new value: 'from')
							with: (XeSimpleValue new value: ''))).
	^ss
!

getCDoc1MissingAttEnv

^'<SOAP-ENV:Envelope
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<ns1:ComplexDocument xmlns:ns1="http://soapinterop.org/">
<ns1:ComplexDocument>
<ns1:simpleDoc>
<ns1:SimpleDocument>from</ns1:SimpleDocument>
<ns1:SimpleDocument>Spray</ns1:SimpleDocument>
</ns1:simpleDoc>
<ns1:child>
<ns1:childSimpleDoc>
<ns1:SimpleDocument>bye</ns1:SimpleDocument>
<ns1:SimpleDocument>from</ns1:SimpleDocument>
<ns1:SimpleDocument>Spray</ns1:SimpleDocument>
</ns1:childSimpleDoc>
</ns1:child>
</ns1:ComplexDocument>
</ns1:ComplexDocument>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'

!

getCDocChildEmpty
	| cd ns |
	cd := self getCDoc1.
	ns := #'http://soapinterop.org/'.
	cd atUnique: ('child' ns: ns) put: (XeQStruct param: ('childSimpleDoc' ns: ns) value: #()).
	self assert: cd size = 2.
	^cd
!

getCDocChildEmptyEmpty
	| cd |
	cd := self getCDoc1.
	cd atUnique: ('child' ns: #'http://soapinterop.org/') put: nil.
	self assert: cd size = 2.
	^cd
!

getCDocSimpleDocEmpty
	| cd ns |
	cd := self getCDoc1.
	ns := #'http://soapinterop.org/'.
	cd atUnique: ('simpleDoc' ns: ns) put: nil.
	self assert: cd size = 2.
	^cd
!

getService
	^SoapInteropDocService new
!

getSingleTagStruct
	^(XeQStruct param: #SingleTag value: nil) asElementQualifiedIn: #'http://soapinterop.org/'
! !

!R2DocFTs methodsFor:'tests'!

testCD
	soapSend := client 
		send: 'ComplexDocument' 
		with: self getCDoc1.
	answer := soapSend value.
	self assert: (answer = self getCDoc1)
!

testCDAttributeNil
	| cd |
	cd := self getCDoc1.
	cd attributes at: #AnAttribute put: nil.
	soapSend := client 
		send: 'ComplexDocument' 
		with: cd.
	answer := soapSend value.
	self assert: (answer = cd)
!

testEnvCD
	| cd |
	cd := self getCDoc1.
	soapSend := client send: 'ComplexDocument' with: cd.
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<ns1:ComplexDocument xmlns:ns1="http://soapinterop.org/">
<ns1:ComplexDocument AnAttribute="hello">
<ns1:simpleDoc>
<ns1:SimpleDocument>from</ns1:SimpleDocument>
<ns1:SimpleDocument>Spray</ns1:SimpleDocument>
</ns1:simpleDoc>
<ns1:child>
<ns1:childSimpleDoc>
<ns1:SimpleDocument>bye</ns1:SimpleDocument>
<ns1:SimpleDocument>from</ns1:SimpleDocument>
<ns1:SimpleDocument>Spray</ns1:SimpleDocument>
</ns1:childSimpleDoc>
</ns1:child>
</ns1:ComplexDocument>
</ns1:ComplexDocument>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'

!

testEnvCDAttributeMissing
	| cd |
	cd := self getCDoc1.
	cd attributes removeKey: #AnAttribute.
	soapSend := client send: 'ComplexDocument' with: cd.
	
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: self getCDoc1MissingAttEnv
!

testEnvCDAttributeNil
	| cd |
	cd := self getCDoc1.
	cd attributes at: #AnAttribute put: nil.
	soapSend := client send: 'ComplexDocument' with: cd.
	
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: self getCDoc1MissingAttEnv
!

testEnvCDChildEmpty
	| cd |
	cd := self getCDocChildEmpty.
	soapSend := client send: 'ComplexDocument' with: cd.
	
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<ns1:ComplexDocument xmlns:ns1="http://soapinterop.org/">
<ns1:ComplexDocument AnAttribute="hello">
<ns1:simpleDoc>
<ns1:SimpleDocument>from</ns1:SimpleDocument><ns1:SimpleDocument>Spray</ns1:SimpleDocument>
</ns1:simpleDoc>
<ns1:child>
<ns1:childSimpleDoc/>
</ns1:child>
</ns1:ComplexDocument>
</ns1:ComplexDocument>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'



!

testEnvCDChildEmptyEmpty
	| cd |
	cd := self getCDocChildEmptyEmpty.
	soapSend := client send: 'ComplexDocument' with: cd.
	
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<ns1:ComplexDocument xmlns:ns1="http://soapinterop.org/">
<ns1:ComplexDocument AnAttribute="hello">
<ns1:simpleDoc>
<ns1:SimpleDocument>from</ns1:SimpleDocument>
<ns1:SimpleDocument>Spray</ns1:SimpleDocument>
</ns1:simpleDoc>
</ns1:ComplexDocument>
</ns1:ComplexDocument>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'




!

testEnvCDEmptyArrayItems
	| cd |
	cd := self getCDoc1EmptyArrayItems.
	soapSend := client send: 'ComplexDocument' with: cd.
	
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<ns1:ComplexDocument xmlns:ns1="http://soapinterop.org/">
<ns1:ComplexDocument AnAttribute="hello">
<ns1:simpleDoc>
<ns1:SimpleDocument></ns1:SimpleDocument>
<ns1:SimpleDocument>Spray</ns1:SimpleDocument>
</ns1:simpleDoc>
<ns1:child>
<ns1:childSimpleDoc>
<ns1:SimpleDocument></ns1:SimpleDocument>
<ns1:SimpleDocument>from</ns1:SimpleDocument>
<ns1:SimpleDocument></ns1:SimpleDocument>
</ns1:childSimpleDoc>
</ns1:child>
</ns1:ComplexDocument>
</ns1:ComplexDocument></SOAP-ENV:Body></SOAP-ENV:Envelope>'


!

testEnvCDSimpleDocEmpty
	| cd |
	cd := self getCDocSimpleDocEmpty.
	soapSend := client send: 'ComplexDocument' with: cd.
	
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Body><ns1:ComplexDocument xmlns:ns1="http://soapinterop.org/">
<ns1:ComplexDocument AnAttribute="hello">
<ns1:child>
<ns1:childSimpleDoc>
<ns1:SimpleDocument>bye</ns1:SimpleDocument>
<ns1:SimpleDocument>from</ns1:SimpleDocument>
<ns1:SimpleDocument>Spray</ns1:SimpleDocument>
</ns1:childSimpleDoc>
</ns1:child>
</ns1:ComplexDocument>
</ns1:ComplexDocument>
</SOAP-ENV:Body></SOAP-ENV:Envelope>'



!

testEnvSimpleDocumentNil
	soapSend := client send: 'SimpleDocument' with: nil.
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<ns1:SimpleDocument xmlns:ns1="http://soapinterop.org/"/>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'

!

testEnvSingleTagNil
	soapSend := client 
		send: 'SingleTag' 
		with: nil.
	self 
		assertXML: soapSend soapOutEnvelope xml
		isSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<ns1:SingleTag xmlns:ns1="http://soapinterop.org/"/>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'

!

testExtComplexDocumentMS
	self makeRequest:
'<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
  <soap:Body>
    <ComplexDocument xmlns="http://soapinterop.org/">
      <ComplexDocument AnAttribute="string">
        <simpleDoc>
          <SimpleDocument />
          <SimpleDocument />
        </simpleDoc>
        <child>
          <childSimpleDoc>
            <SimpleDocument xsi:nil="true" />
            <SimpleDocument xsi:nil="true" />
          </childSimpleDoc>
        </child>
      </ComplexDocument>
    </ComplexDocument>
  </soap:Body>
</soap:Envelope>'.
	self denyFaultResponse
!

testExtSimpleDocumentMS
	self makeRequest:
'<?xml version="1.0" encoding="utf-8"?>
<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
  <soap:Body>
    <SimpleDocument xmlns="http://soapinterop.org/">
      <SimpleDocument />
    </SimpleDocument>
  </soap:Body>
</soap:Envelope>'.
	self denyFaultResponse
!

testExtSingleTagMS
	self makeRequest:
'<?xml version="1.0" encoding="utf-8"?> <soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"> <soap:Body> <SingleTag xmlns="http://soapinterop.org/"> <SingleTag /> </SingleTag> </soap:Body> </soap:Envelope>'.
	self denyFaultResponse
!

testSimpleDocument
	soapSend := client 
		send: 'SimpleDocument' 
		with: (XeSimpleValue new value: 'abc').
	answer := soapSend value.
	self assert: (answer = (XeSimpleValue new value: 'abc'))
!

testSingleTag
	soapSend := client send: 'SingleTag' with: XeQStruct new.
	answer := soapSend value.
	self assert: answer = XeQStruct new
!

testSingleTagDocSend
	soapSend := client sendDoc: 'SingleTag' with: (XeQStruct param: #SingleTag value: XeQStruct new).
	answer := soapSend value.
	self assert: (answer first atLocalName: #SingleTag) = XeQStruct new
!

testSoapAction
	soapSend := client send: 'SingleTag'.
	self assert: soapSend soapAction = 'http://soapinterop.org/SingleTag'.
	soapSend := client send: 'ComplexDocument'.
	self assert: soapSend soapAction = 'http://soapinterop.org/ComplexDocument'.
	soapSend := client send: 'SimpleDocument'.
	self assert: soapSend soapAction = 'http://soapinterop.org/SimpleDocument'.

! !

!R2DocFTs class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/tests/SOAP__R2DocFTs.st,v 1.1 2008/09/07 18:53:03 cg Exp $'
! !
