"{ Package: 'stx:goodies/soap/spray/services/tests' }"

"{ NameSpace: SOAP }"

SoapInteropFTs subclass:#R2GroupBFT
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Interop-R2-TestCases'
!


!R2GroupBFT methodsFor:'accessing'!

getService
	^SoapInteropGroupBService new
! !

!R2GroupBFT methodsFor:'tests'!

test2DStringArray
	soapSend := client send: 'echo2DStringArray' with: self get2DArray.
	answer := soapSend value.
	self assert: answer size = self get2DArray size.
	self get2DArray keysAndValuesDo: [:k :v | self assert: (answer at: k) = v]
!

testEchoStructAsSimpleTypes
	soapSend := client send: 'echoStructAsSimpleTypes' with: self getStruct.
	answer := soapSend value.
	self assert: (soapSend outParameters at: #outputString) = 'abc'.
	self assert: (soapSend outParameters at: #outputInteger) = 123.
	self assert: (soapSend outParameters at: #outputFloat) = 6.2
!

testEchoStructAsSimpleTypesReordered
	soapSend := client send: 'echoStructAsSimpleTypes' with: self getStructReordered.
	answer := soapSend value.
	self assert: (soapSend outParameters at: #outputString) = 'abc'.
	self assert: (soapSend outParameters at: #outputInteger) = 123.
	self assert: (soapSend outParameters at: #outputFloat) = 6.2
!

testNestedArray
	soapSend := client send: 'echoNestedArray' with: self getSoapArrayStruct.
	answer := soapSend value.
	self assert: (answer at: #varString) = 'abc'.
	self assert: (answer at: #varInt) = 123.
	self assert: (answer at: #varFloat) = 6.2.
	self assert: (answer at: #varArray) = #('def' 'fgh')
!

testSimpleTypesAsStruct
	soapSend := client send: 'echoSimpleTypesAsStruct' withArguments: #('abc' -234 2.3e-002).
	answer := soapSend value.
	self assert: (answer at: #varString) = 'abc'.
	self assert: (answer at: #varInt) = -234.
	self assert: (answer at: #varFloat) = 2.3e-002
! !

!R2GroupBFT class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/services/tests/SOAP__R2GroupBFT.st,v 1.1 2008/09/07 18:54:05 cg Exp $'
! !
