"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayAuthTests subclass:#SpDigestAuthRFC2617TimedTest
	instanceVariableNames:'authorizer nonce dateTime'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Auth-TestCases'
!


!SpDigestAuthRFC2617TimedTest methodsFor:'set up'!

setUp
        super setUp.
        authorizer := SpDigestAuthRFC2617Timed new realm: 'TestRealm'.
        dateTime := XeXsdDateTime fromString: '1999-05-31T13:20:00Z'.
        nonce := authorizer generateNonceFor: dateTime
! !

!SpDigestAuthRFC2617TimedTest methodsFor:'tests'!

testExceptionNonce
        self assert: (authorizer isExpiredNonce: '' for: (XeXsdDateTime fromString: '1999-05-31T13:20:00Z')) .
        self assert: (authorizer isExpiredNonce: 'a' for: (XeXsdDateTime fromString: '1999-05-31T13:20:50Z')) .
!

testExtractNonce
        | dt2 |
        dt2 := authorizer extractNonceTimeStamp: nonce.
        self assert: dateTime asNative = dt2 asNative
!

testGenerateNonce
        self assert: (nonce beginsWith: '1999-05-31T13:20:00Z' asByteArray printSchemaHexString)
!

testIsExpiredNonce
        self assert: (authorizer isExpiredNonce: nonce for: (XeXsdDateTime fromString: '1999-05-31T13:20:00Z')) not.
        authorizer expireSeconds: 60.
        self assert: (authorizer isExpiredNonce: nonce for: (XeXsdDateTime fromString: '1999-05-31T13:20:50Z')) not.
        self assert: (authorizer isExpiredNonce: nonce for: (XeXsdDateTime fromString: '1999-05-31T13:21:01Z')).
!

testIsInvalidNonce
        self deny: (authorizer isExpiredNonce: nonce for: (XeXsdDateTime fromString: '1999-05-31T13:20:00Z')).
        authorizer privateNonceKey: 'somethingelse'.
        self assert: (authorizer isExpiredNonce: nonce for: (XeXsdDateTime fromString: '1999-05-31T13:20:50Z')).
! !

!SpDigestAuthRFC2617TimedTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpDigestAuthRFC2617TimedTest.st,v 1.3 2009/10/04 17:40:11 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpDigestAuthRFC2617TimedTest.st,v 1.3 2009/10/04 17:40:11 cg Exp $'
! !
