"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayAuthTests subclass:#SpDigestAuthorizerTest
	instanceVariableNames:'authorizer'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-Auth-TestCases'
!


!SpDigestAuthorizerTest methodsFor:'accessing'!

addUidPwd1
        authorizer addUid: 'user' pwd: 'dolphin'
!

addUidPwd2
        authorizer addUid: 'user2' pwd: 'dolphin2'
! !

!SpDigestAuthorizerTest methodsFor:'set up'!

setUp
        super setUp.
        authorizer := SpDigestAuthConstantNonce new realm: 'TestRealm'
! !

!SpDigestAuthorizerTest methodsFor:'tests'!

testAuthOfServerAndClient
        | ans |
        self addUidPwd1.
        ans := authorizer
                authOf: 'user' 
                sn: '123456' 
                cn: '654321'.
        self assert: ans printSchemaHexString = '98B38B4F9CB0F48286871ED5BD4743CC'.
        self assert: ans = (MD5 hMessage: 'AE2E7768FD38720D8B7169E36B803950:123456:654321')
!

testAuthOfServerOnly
        | ans |
        self addUidPwd1.
        ans := authorizer
                authOf: 'user' 
                sn: '123456' 
                cn: nil.
        self assert: ans printSchemaHexString = '6073F76D168AE58D323F4EB2D86B71C9'.
        self assert: ans = (MD5 hMessage: 'AE2E7768FD38720D8B7169E36B803950:123456')
!

testGenerateNonce
        authorizer nonce: 'hello'.
        self assert: authorizer generateNonce = 'hello'.
        self deny: (authorizer isExpiredNonce: authorizer generateNonce).
!

testRemoveAllSecrets
        self addUidPwd1.
        self addUidPwd2.
        self assert: (authorizer secretOf: 'user' ifAbsent: []) notNil.
        authorizer removeAllSecrets.
        self assert: (authorizer secretOf: 'user' ifAbsent: []) isNil.  
        self assert: authorizer numberOfUsers = 0.
!

testSecret
        | ans|
        ans := authorizer secret: 'user' pwd: 'dolphin'.
        self assert: ans = 'AE2E7768FD38720D8B7169E36B803950'
!

testSecretOf
        | ans |
        self addUidPwd1.
        self addUidPwd2.
        ans := authorizer secretOf: 'user'.
        self assert: ans = 'AE2E7768FD38720D8B7169E36B803950'
! !

!SpDigestAuthorizerTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpDigestAuthorizerTest.st,v 1.3 2009/10/04 17:39:53 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpDigestAuthorizerTest.st,v 1.3 2009/10/04 17:39:53 cg Exp $'
! !
