"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

TestObjectsSpray subclass:#SpSprayTestWireObjects
	instanceVariableNames:'typespace'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpSprayTestWireObjects class methodsFor:'instance creation'!

newIn: aXeTypespace
	^self new typespace: aXeTypespace
! !

!SpSprayTestWireObjects methodsFor:'accessing'!

typespace
	^typespace
!

typespace: anObject
	typespace := anObject
! !

!SpSprayTestWireObjects methodsFor:'coders'!

docEncS
	| message specs elements |
	message := SpmdMessage onPart: (SpmdTypePart partName: 'param1' typeName: 'xsd:string').
	specs := message docSpecs: nil namespace: #'urn:blah'.
	elements := typespace soapEncStyle docElementsSpeced: specs.
	^SpwSoapBCoder onElement: elements first
!

docLitC1
	| specs elements message |
	message := SpmdMessage forSingleElement: (XeQName sprayClass: SWXMLTestObject).
	specs := message docSpecs: nil namespace: #'urn:blah'.
	elements := typespace literalStyle docElementsSpeced: specs.
	^SpwSoapBCoder onElement: elements first
!

rpcEnc1
	^self soapEncCoderFor: (SpmdMessage 
				onPart: (SpmdTypePart partName: 'param1' typeName: 'xsd:string'))
!

rpcEnc2
	^self soapEncCoderFor: (SpmdMessage 
				onParts: (Array with: (SpmdTypePart partName: 'param1' typeName: 'xsd:string')
						with: (SpmdTypePart partName: 'param2' typeName: 'xsd:int')))
!

soapEncCoderFor: aSpmdMessage
	| specs element |
	specs := aSpmdMessage rpcSpecs: nil.
	element := typespace soapEncStyle rpcWrapperNamed: self qMyOperation elementSpecs: specs.
	^SpwSoapBCoder onElement: element
! !

!SpSprayTestWireObjects methodsFor:'envelopes'!

envXmlDocLitC1
	^self envXmlDocLitC1WithHeader: ''


!

envXmlDocLitC1WithHeader: aString
^'<?xml version="1.0"?>
<SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
%1
<SOAP-ENV:Body>
<d:SWXMLTestObject xmlns:d="http://www.dolphinharbor.org/spray/class"><x>5</x><y>hello</y></d:SWXMLTestObject>
</SOAP-ENV:Body></SOAP-ENV:Envelope>' formatWith: aString


!

envXmlRpcEnc2
^'<SOAP-ENV:Envelope 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
<SOAP-ENV:Body >
<m:myOperation xmlns:m="urn:blah" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<param1>abc</param1>
<param2>123</param2>
</m:myOperation>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope> '
! !

!SpSprayTestWireObjects methodsFor:'handlers'!

handlerDOC
	^self handlerDOCFor: SpwDOCHandler selector: #myDocSelector1:


!

handlerDOCArgs
	^self handlerDOCFor: SpwDOCArgsEnvHandler selector: #myDocSelector1:ex:



!

handlerDOCFor: aClass selector: aSelector
	| handler |
	handler := aClass new.
	handler selector: aSelector.
	handler soapAction: 'myAction'.
	handler inputDecoder: self docEncS.
	handler outputEncoder: self docEncS.
	handler beBody.
	^handler
!

handlerRPC
	^self handlerRPCFor: SpwRPCHandler

!

handlerRPCArgs
	^self handlerRPCFor: SpwRPCArgsEnvHandler

!

handlerRPCFor: aClass
	| handler |
	handler := aClass new.
	handler selector: #mySelector:with:.
	handler soapAction: 'myAction'.
	handler inputDecoder: self rpcEnc2.
	handler outputEncoder: self rpcEnc1.
	handler beBody.
	^handler
!

rpcEncV
	^self soapEncCoderFor: (SpmdMessage onParts: Array new)
! !

!SpSprayTestWireObjects methodsFor:'qNames'!

qMyOperation
	^XeQName local: 'myOperation' ns: #'urn:blah'
! !

!SpSprayTestWireObjects class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpSprayTestWireObjects.st,v 1.1 2008/09/07 15:49:02 cg Exp $'
! !
