"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayDevelopmentTests subclass:#SpdMetaGeneratorTest
	instanceVariableNames:'generator'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpdMetaGeneratorTest methodsFor:'set up'!

setUp
	super setUp.
	generator := SpdMetaDataGenerator new initialize
! !

!SpdMetaGeneratorTest methodsFor:'tests'!

testIncludeMethodsIn
        generator setForGlobal: SoapTestMetaGenerator.
        generator includeMethodsIn: 'testing' "(MethodCategory name: 'testing')".
        self assert: (generator selectorItems select: [:each | each shouldGenerate]) size = 1.
        Smalltalk isSmalltalkX ifTrue:[
            generator includeMethodsIn: 'tests' "MethodCategory public".
            self assert: (generator selectorItems select: [:each | each shouldGenerate]) size > 1.
        ] ifFalse:[
            generator includeMethodsIn: 'public' "MethodCategory public".
            self assert: (generator selectorItems select: [:each | each shouldGenerate]) size > 1.
        ].
        generator includeMethodsIn: 'notACategory' "(MethodCategory name: 'notACategory')".
        self assert: (generator selectorItems select: [:each | each shouldGenerate]) isEmpty









!

testIncludesOperationFor
	generator setForGlobal: SoapTestMetaGenerator.
	self deny: (generator includesOperationFor: #mySelector:with:).
	generator port operations add: SpSprayTestSpmdObjects new getOperationEncRPCTypedXSD.
	self assert: (generator includesOperationFor: #mySelector:with:)
!

testPortAccessing
	generator setForGlobal: SoapTestMetaGenerator.
	generator portName: 'aNewName'.
	self assert: generator port name = 'aNewName'
!

testSuggestOperationName
	generator setForGlobal: SoapTestMetaGenerator.
	self assert: (generator suggestOperationNameFor: 'myOperation') = 'myOperation'.
	generator port operations add: (SpSprayTestSpmdObjects new getOperationEncRPCTypedXSD).
	self assert: (generator suggestOperationNameFor: 'myOperation') = 'myOperation1'
! !

!SpdMetaGeneratorTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpdMetaGeneratorTest.st,v 1.2 2008/09/07 17:27:21 cg Exp $'
! !
