"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SpmdTests subclass:#SpmdGenerateScriptTest
	instanceVariableNames:'script'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpmdGenerateScriptTest methodsFor:'set up'!

setUp
	super setUp.
	script := SpmdMetaDataScript newFor: SprayTestObject
! !

!SpmdGenerateScriptTest methodsFor:'tests'!

testConstructGenerator
	| gen|
	gen := script constructGenerator.
	self assert: gen global = SprayTestObject .
	self assert: gen portName = 'SprayTestPort'.
	self assert: gen portNamespace = #'urn:SprayTesting123'.
!

testCreatePort
	self assert: (script createPort isKindOf: SpmdPort)
!

testInvalidPortName
	script portName: nil.
	self should: [script assertValidPortNames] raise: Error.
	script portName: ''.
	self should: [script assertValidPortNames] raise: Error.
!

testInvalidPortNamespace
	script portNamespace: nil.
	self should: [script assertValidPortNames] raise: Error.
	script portNamespace: ''.
	self should: [script assertValidPortNames] raise: Error.
"empty symbol MUST by valid"
	script portNamespace: #''.
	script assertValidPortNames.

!

testSoapAction
	script soapAction: 'blah'.
	script createPort operations do: [ :each |
		self assert: each soapAction = 'blah']
! !

!SpmdGenerateScriptTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpmdGenerateScriptTest.st,v 1.1 2008/09/07 15:49:37 cg Exp $'
! !
