"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayServiceTests subclass:#SprayDispatchClientTest
	instanceVariableNames:'client dispatchClient'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SprayDispatchClientTest methodsFor:'set up'!

setUp
	| service |
	super setUp.
	service := SprayTestRpcService new.
	client := service createClientTo: 'http://foo'.
	dispatchClient := SprayDispatchClient onClient: client
! !

!SprayDispatchClientTest methodsFor:'tests'!

testConstruction
	self assert: dispatchClient sprayClient == client
!

testConvertToSoapMultiple
	| soapSend |
	dispatchClient convertToSoap: (Message selector: #testMethod1: arguments: #(1)).
	soapSend := dispatchClient soapSend.
	self assert: (soapSend isKindOf: SpraySoapSend).
	self assert: soapSend soapAction = 'testMethod1'.
	self assert: soapSend outEnvelope bodies first element localName = 'testMethod1'.
	self assert: soapSend outEnvelope bodyObjects first size = 1.
	self assert: soapSend outEnvelope bodyObjects first first = 1
!

testConvertToSoapUnary
	| soapSend |
	dispatchClient convertToSoap: (Message selector: #echoVoid).
	soapSend := dispatchClient soapSend.
	self assert: (soapSend isKindOf: SpraySoapSend).
	self assert: soapSend soapAction = 'echoVoid'.
	self assert: soapSend outEnvelope bodies first element localName = 'echoVoid'.
	self assert: soapSend outEnvelope bodyObjects first isEmpty
!

testHasOperationFor
	self assert: (dispatchClient hasOperationFor: (Message selector: #echoVoid)).
	self deny: (dispatchClient hasOperationFor: (Message selector: #EchoVoid)).
	self assert: (dispatchClient hasOperationFor: (Message selector: #echoVoid: argument: 1)).
	self deny: (dispatchClient hasOperationFor: (Message selector: #notEchoVoid)).
!

testWrongNumArgs
	self 
		should: [dispatchClient convertToSoap: (Message selector: #echoVoid: arguments: #(1))]
		raise: Error
! !

!SprayDispatchClientTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SprayDispatchClientTest.st,v 1.1 2008/09/07 15:51:13 cg Exp $'
! !
