"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayServiceTests subclass:#SprayServerTest
	instanceVariableNames:'server answer'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SprayServerTest methodsFor:'set up'!

setUp
	server := SprayTestRpcService new createServer
! !

!SprayServerTest methodsFor:'tests'!

testCreateServer
	| service |
	service := SprayTestHeadersService new.
	server := service createServer.
	self assert: server soapNode numberOfReceivers = 2
!

testEndPointEntity
	server := SprayTestRpcService new createServer.
	self assert: (server endPointEntity isKindOf: String)
!

testOperationNames
	server := SprayTestRpcService new createServer.
	self assert: server operationNames notEmpty.
	server operationNames do: [:each | self assert: (each isKindOf: String)]
!

testServiceName
	server := SprayTestRpcService new createServer.
	self assert: server serviceName = server service name
!

testServiceNamespace
	server := SprayTestRpcService new createServer.
	self assert: server serviceNamespace = server service namespace
!

testSoapNodeConstruction
	server := SprayTestRpcService new createServer.
	self assert: (server soapNode isKindOf: SpwSoapResponder)
!

testWsdl
	server := SprayTestRpcService new createServer.
	self assert: (server wsdl xml isKindOf: String).
	"self assert:server wsdl xml = server wsdlXmlString"
!

testWsdlAddressLocation
	server := SprayTestRpcService new createServer.
	self assert: server wsdlAddressLocation = 'http://localhost/service.wsdl'.
	server binding addressLocation: 'http://localhost/s'.
	self assert: server wsdlAddressLocation = 'http://localhost/s/service.wsdl'.
	server binding addressLocation: 'http://localhost/s/'.
	self assert: server wsdlAddressLocation = 'http://localhost/s/service.wsdl'
!

testXSINamespace
	server := SprayTestRpcService new createServer.
	self assert: server xsiNamespace == server typespace xsiNamespace
! !

!SprayServerTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SprayServerTest.st,v 1.1 2008/09/07 15:51:42 cg Exp $'
! !
