"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayServiceTests subclass:#SprayTest1ServiceTest
	instanceVariableNames:'service'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SprayTest1ServiceTest methodsFor:'set up'!

setUp
	super setUp.
	service := SprayTestRpcService new
! !

!SprayTest1ServiceTest methodsFor:'tests'!

testCreateServer
	self assert: (service createServer isKindOf: SprayServer).
	self assert: service createServer typespace == service typespace
!

testCreateSprayClient
	| client |
	client := service createClientTo: 'http://foo'.
	self assert: (client operationPort isKindOf: SpmdPort).
	self assert: (client typespace isKindOf: XeTypespace)


	
!

testCreateSprayClientTo
	| client |
	client := service createClientTo: 'http://foo'.
	self assert: ((client send: 'echoVoid') immediateDestination = 'http://foo').



	
!

testCreateTypespaceSchema
	self assert: (service createTypespace isKindOf: XeTypespace).


	
!

testCreateWSDL
	| ans defNode wsdlService |
	ans := service createWSDL: SptLocalServerBinding new.
	defNode := ans documentElement asParserNode.
	self assert: (defNode getAttribute: 'targetNamespace') = 'urn:SprayTest1Service'.
	self assert:(defNode namespaceFor: 'tns') = #'urn:SprayTest1Service'.
	self assert: (defNode getAttribute: 'name') = 'SprayTest1Service'.
	wsdlService := SprayWSDLService definitionNode: defNode portName: nil.
	self assert: wsdlService destinationUrl = 'http://localhost/'
!

testLocalWSDL
	self assert: (service localWSDL isKindOf: String).


	
!

testNameX
        self assert: service name = 'SprayTest1Service'
!

testNamespace
	self assert: service namespace = #'urn:SprayTest1Service' 
!

testOperationObjectInstance
	self assert: (service operationModel isKindOf: SprayTestObject)
!

testOperationPortID
	self assert: (service operationPortID port isKindOf: SpmdPort).


	
!

testSoapBlockReceivers
	| blockRs |
	blockRs := service soapBReceivers.
	self assert: blockRs size = 1.
	self assert: blockRs first namespace = #'urn:SprayTesting123'.
	self assert: (blockRs first object isKindOf: SprayTestObject)
!

testTypespace
	| ts |
	ts := service typespace.
	self assert: (ts isKindOf: XeTypespace).
	self assert: ts == service typespace


	
! !

!SprayTest1ServiceTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SprayTest1ServiceTest.st,v 1.2 2008/09/07 18:29:36 cg Exp $'
! !
