"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayClientTests subclass:#SpwCodedObjectTest
	instanceVariableNames:'node codedObject'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpwCodedObjectTest methodsFor:'asserting'!

assertEncoded: aString 
	self assertXML: node xml isSameAs: aString
!

assertParam1: aString
	self assertEncoded: 
('<blah xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">%1</blah>' formatWith: aString)

! !

!SpwCodedObjectTest methodsFor:'set up'!

setUp
	super setUp.
	node := self new2001Node: 'blah'.
	codedObject := SpwCodedObject onCoder: self wireObjects docEncS.
	codedObject object: 'abc'
! !

!SpwCodedObjectTest methodsFor:'tests'!

testActor
	codedObject actor: #'urn:anActor'.
	codedObject encodeInto: node.
	self assertParam1: 
'<ns1:param1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:actor="urn:anActor" xsi:type="xsd:string" xmlns:ns1="urn:blah">abc</ns1:param1>'

!

testBeMustUnderstand
	codedObject beMustUnderstand.
	codedObject encodeInto: node.
	self assertParam1: 
'<ns1:param1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:mustUnderstand="1" xsi:type="xsd:string" xmlns:ns1="urn:blah">abc</ns1:param1>'

!

testBeNext
	codedObject beNext.
	codedObject encodeInto: node.
	self assertParam1: 
'<ns1:param1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:actor="http://schemas.xmlsoap.org/soap/actor/next" xsi:type="xsd:string" xmlns:ns1="urn:blah">abc</ns1:param1>'

!

testBeNextBeMustUnderstand
	codedObject beMustUnderstand.
	codedObject beNext.
	codedObject encodeInto: node.
	self assertParam1: 
'<ns1:param1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:actor="http://schemas.xmlsoap.org/soap/actor/next" SOAP-ENV:mustUnderstand="1" xsi:type="xsd:string" xmlns:ns1="urn:blah">abc</ns1:param1>'

!

testBeNotMustUnderstand
	codedObject beNotMustUnderstand.
	codedObject encodeInto: node.
	self assertParam1: 
'<ns1:param1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENV:mustUnderstand="0" xsi:type="xsd:string" xmlns:ns1="urn:blah">abc</ns1:param1>'

!

testIsObjectNil
	self deny: codedObject isObjectNil.
	codedObject object: nil.
	self assert: codedObject isObjectNil.
! !

!SpwCodedObjectTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpwCodedObjectTest.st,v 1.1 2008/09/07 15:52:52 cg Exp $'
! !
