"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SpwInEnvelopeTests subclass:#SpwDocumentInTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpwDocumentInTest methodsFor:'accessing'!

beDocLitC1
	envelope := SpwInDocument newIn: typespace.
	envelope 
		bodyCoders: (Array with: self wireObjects docLitC1)
		headerCoders: #()
!

setSoapIn
	soapInEnv := SpwSoapInEnvelope fromXmlString: self wireObjects envXmlDocLitC1
!

setSoapInDocLitC1
	soapInEnv := SpwSoapInEnvelope fromXmlString: self wireObjects envXmlDocLitC1
!

setSoapInDocLitC1With: aString 
	soapInEnv := SpwSoapInEnvelope fromXmlString: (self wireObjects envXmlDocLitC1WithHeader: aString)
! !

!SpwDocumentInTest methodsFor:'set up'!

setUp
	super setUp.
	envelope := SpwInDocument newIn: typespace.
	envelope 
		bodyCoders: (Array with: self wireObjects docLitC1)
		headerCoders: #()
! !

!SpwDocumentInTest methodsFor:'tests'!

testAccessing
	self beDocLitC1.
	self setSoapInDocLitC1.
	self decodeSoapIn.
	self assert: (envelope bodyObjects = (Array with: SWXMLTestObject example1)).
	self assert: (envelope extractReturn = (Array with: SWXMLTestObject example1)).	
!

testUnexpectedHeader
	self beDocLitC1.
	self setSoapInDocLitC1With: '<SOAP-ENV:Header><ns:param1 xmlns:ns="urn:blah">abc</ns:param1></SOAP-ENV:Header>'.
	self decodeSoapIn.
	self assert: (envelope bodyObjects = (Array with: SWXMLTestObject example1)).

! !

!SpwDocumentInTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpwDocumentInTest.st,v 1.1 2008/09/07 15:53:25 cg Exp $'
! !
