"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayServerTests subclass:#SpwFaultEnvelopeTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpwFaultEnvelopeTest methodsFor:'tests'!

testFaultPayLoadHeader
	| ans node env |
	ans := SpwFaultEnvelope 
				code: 'MustUnderstand'
				string: 'Blah'
				details: 'abc'
				isBody: false.
	self assert: ans isFault.
	self assert: ('*<faultcode>SOAP-ENV:MustUnderstand</faultcode>*' match: ans xml).
	self assert: ('*<faultstring>Blah</faultstring>*' match: ans xml).
	self deny: ('*<detail*' match: ans xml).


	"does it parse?"
	node := self rootNodeFor: ans xml.
	env := SpwSoapInEnvelope fromXmlString: ans xml.
	self assert: env isFault.
	self assert: env faultcode = 'SOAP-ENV:MustUnderstand'.
	self assert: env faultstring = 'Blah'.
	self assert: env faultDetail = ''
!

testFaultPayLoadNotHeader
	| ans node env |
	ans := SpwFaultEnvelope 
				code: 'Server'
				string: 'Blah'
				details: 'abc'
				isBody: true.
	self assert: ans isFault.
	self assert: ('*<faultcode>SOAP-ENV:Server</faultcode>*' match: ans xml).
	self assert: ('*<faultstring>Blah</faultstring>*' match: ans xml).
	self assert: ('*<detail*' match: ans xml).


	"does it parse?"
	node := self rootNodeFor: ans xml.
	env := SpwSoapInEnvelope fromXmlString: ans xml.
	self assert: env isFault.
	self assert: env faultcode = 'SOAP-ENV:Server'.
	self assert: env faultstring = 'Blah'.
	self 
		assert: env faultDetail = '<detail><e:stackdump xmlns:e="urn:stackdump">abc</e:stackdump></detail>'
!

testMisunderstandFault
	| ans xml |
	ans := SpwFaultEnvelope misunderstand: (Array with: self qFoo).
	self assert: ans isFault.
	self assertXML: (xml := ans xml)
		isSameAs: 
'<?xml version="1.0"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<SOAP-ENV:Fault>
<faultcode>SOAP-ENV:MustUnderstand</faultcode>
<faultstring>One or more mandatory headers not understood</faultstring>
</SOAP-ENV:Fault>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>
'
! !

!SpwFaultEnvelopeTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpwFaultEnvelopeTest.st,v 1.1 2008/09/07 15:53:39 cg Exp $'
! !
