"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SpwEnvelopeTests subclass:#SpwOutEnvelopeTests
	instanceVariableNames:'soapOutEnv'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpwOutEnvelopeTests methodsFor:'accessing'!

addDocEncSHeader
	envelope addHeader: (SpwCodedObject onCoder: self wireObjects docEncS)
!

encodeSoapOut
	soapOutEnv := envelope soapOutEnvelope.
	self assert: (soapOutEnv isKindOf: SpwSoapOutEnvelope)
!

qTest
	^self blahQ: 'test'
! !

!SpwOutEnvelopeTests methodsFor:'tests'!

testAddAnySoapEncHeader
	| codedObject |
	envelope addAnySoapEncHeaderNamed: self qTest.
	self assert: ((codedObject := envelope headerNamed: self qTest) isKindOf: SpwCodedObject).
	self assert: codedObject coder element encodingStyle isSoapEnc
!

testFirstHeaderObject
	| header1 header2 |
	header1 := envelope addAnySoapEncHeaderNamed: self qTest.
	header2 := envelope addAnySoapEncHeaderNamed: self qFoo.
	envelope firstHeaderObject: 'abc'.
	self assert: header1 object = 'abc'.
	self assert: header2 object isNil.
!

testHeaderNamed
	| header1 header2 |
	header1 := envelope addAnySoapEncHeaderNamed: self qTest.
	header2 := envelope addAnySoapEncHeaderNamed: self qFoo.
	self assert: (envelope headerNamed: self qTest) == header1.
	self assert: (envelope headerNamed: self qFoo) == header2.
!

testNoHeaderNamed
	self should: [envelope headerNamed: self qTest] raise: Error.
! !

!SpwOutEnvelopeTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpwOutEnvelopeTests.st,v 1.1 2008/09/07 15:54:16 cg Exp $'
! !
