"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SpwHandlerTests subclass:#SpwRPCHandlerAbstractTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpwRPCHandlerAbstractTests methodsFor:'accessing'!

getHandlerEnvString
	^self wireObjects envXmlRpcEnc2
! !

!SpwRPCHandlerAbstractTests methodsFor:'tests'!

testRPCConstruction
	self assert: handler isBodyHandler.
	self deny: handler isVoidReturn.
	self assert: handler identificationQName = (self blahQ: 'myOperation').
	self assert: handler soapAction = 'myAction'.
	self assert: handler selector = self handlerSelector.
	self assert: (handler outputContent isKindOf: XeSoapRPCContent).
	self assert: (handler isKindOf: self handlerClass)
!

testValidSelector
	handler selector: #abc.
	self should: [handler assertValidSelector] raise: Error.
	handler selector: #abc:.
	self should: [handler assertValidSelector] raise: Error.
	handler selector: #abc:def:hij:.
	self should: [handler assertValidSelector] raise: Error.
	handler selector: #abc:def:.
	handler assertValidSelector.


! !

!SpwRPCHandlerAbstractTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpwRPCHandlerAbstractTests.st,v 1.1 2008/09/07 15:54:29 cg Exp $'
! !
