"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SprayServerTests subclass:#SpwSoapResponderTest2
	instanceVariableNames:'soapNode answer exchange'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpwSoapResponderTest2 methodsFor:'accessing'!

getEnvStringWithBody: aString
	^(
'<SOAP-ENV:Envelope
	xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
	SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
	<SOAP-ENV:Body>
	%1
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>') formatWith: aString
!

getNoHandlerNSRequest
	^self getEnvStringWithBody:
'<m:testMethod1 xmlns:m="urn:NOTSprayTestPort">
<someString>abc</someString>
</m:testMethod1>'
!

getNoHandlerRequest
	^self getEnvStringWithBody:
'<m:NOTtestMethod1 xmlns:m="urn:SprayTestPort">
<someString>abc</someString>
</m:NOTtestMethod1>'
!

getOKRequest
	^self getEnvStringWithBody:
'<m:testMethod1 xmlns:m="urn:SprayTesting123">
<someString>abc</someString>
</m:testMethod1>'
!

getWrongEnvRequest
	^'<SOAP-ENV:Envelope
	xmlns:SOAP-ENV="NOThttp://schemas.xmlsoap.org/soap/envelope/"
	SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
	<SOAP-ENV:Body>
		<m:NOTtestMethod1 xmlns:m="urn:SprayTestPort">
			<someString>abc</someString>
		</m:NOTtestMethod1>
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'
!

setAnswerForRequest: aString 
	soapNode process: (exchange := SptRespondingExchange onXmlString: aString).
	answer := exchange out
! !

!SpwSoapResponderTest2 methodsFor:'asserting'!

assertAnswerFault
	self assert: answer isFault
! !

!SpwSoapResponderTest2 methodsFor:'set up'!

setUp
	| server |
	server := SprayTestRpcService new createServer.
	soapNode := server soapNode
! !

!SpwSoapResponderTest2 methodsFor:'tests'!

testNoHandlerLocal
	self setAnswerForRequest:  self getNoHandlerRequest.
	self assertAnswerFault.
!

testNoHandlerNamespace
	self setAnswerForRequest:  self getNoHandlerNSRequest.
	self assertAnswerFault.
!

testNoReceiver
	soapNode receiverTable removeKey: #'urn:SprayTesting123'.
	self setAnswerForRequest: self getOKRequest.
	self assertAnswerFault.
!

testOK
	self setAnswerForRequest: self getOKRequest.
	self deny: answer isFault
!

testWrongEnvNS
	self should: [self setAnswerForRequest: self getWrongEnvRequest] raise: Error
	"self assertAnswerFault."
! !

!SpwSoapResponderTest2 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__SpwSoapResponderTest2.st,v 1.1 2008/09/07 15:55:08 cg Exp $'
! !
