"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

XeXMLTests subclass:#XeInfoComparerTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SWT XE Utility Tests'
!


!XeInfoComparerTest methodsFor:'Dolphin methods'!

testAttributeValueNSUndeclared
	self should: 
			[XeXMLInfoComparer new 
				compare: '<blah1 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah xsi:type="xsd:string">abc</blah></blah1>'
				to: '<blah1 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><blah xsi:type="xsd:string">abc</blah></blah1>']
		raise: Error
!

testDifBaseName
	self denyXML: '<foo/>' isSameAs: '<food/>'.
	self denyXML: '<bar><foo/></bar>' isSameAs: '<bar><food/></bar>'
!

testDifNumberOfChildren
	self denyXML: '<bar><foo/></bar>' isSameAs: '<bar><foo/><foo2/></bar>'.
	self denyXML: '<bar><foo/><foo2/></bar>' isSameAs: '<bar><foo/></bar>'
!

testNCAttributes
	self assertXML: '<bar this="urn:bar" that="urn:foo"/>'
		isSameAs: '<bar this="urn:bar" that="urn:foo"/>'.
	self assertXML: '<bar that="urn:foo" this="urn:bar" />'
		isSameAs: '<bar this="urn:bar" that="urn:foo"/>'.
	self assertXML: '<bar that="urn:foo" this="urn:bar" />'
		isSameAs: '<bar this="urn:bar" that="urn:foo"/>'.

	"test with qualify"
	self assertXML: '<bar  xmlns:urn="theSame"  this="urn:bar" that="urn:foo"/>'
		isSameAs: '<bar  xmlns:urn="theSame"  this="urn:bar" that="urn:foo"/>'.
	self denyXML: '<bar  xmlns:urn="NOTtheSame"  this="urn:bar" that="urn:foo"/>'
		isSameAs: '<bar  xmlns:urn="theSame"  this="urn:bar" that="urn:foo"/>'
!

testSameAttributeKeyNamespace
	self assertXML: '<bar xmlns:urn="theSame" xmlns:soap="urn:soap" soap:abc="urn:blah"/>'
		isSameAs: '<bar xmlns:urn="theSame" xmlns:soap-enc="urn:soap" soap-enc:abc="urn:blah"/>'.
	self denyXML: '<bar xmlns:urn="theSame" xmlns:soap="urn:soap" soap:abc="urn:blah"/>'
		isSameAs: '<bar xmlns:urn="theSame" xmlns:soap-enc="urn:NOTsoap" soap-enc:abc="urn:blah"/>'.
	self denyXML: '<bar xmlns:urn="theSame" xmlns:soap="urn:soap" soap:abc="urn:blah"/>'
		isSameAs: '<bar xmlns:urn="theSame" xmlns:soap-enc="urn:soap" soap-enc:abc="urn:NOTblah"/>'.
	self denyXML: '<bar xmlns:urn="theSame" xmlns:soap="urn:soap" soap:abc="urn:blah"/>'
		isSameAs: '<bar xmlns:urn="theSame" xmlns:soap-enc="urn:soap" soap-enc:NOTabc="urn:blah"/>'
!

testSameAttributeValueNamespace
	self assertXML: '<bar xmlns:urn="theSame" this="a:boo" xmlns:a="urn:blah"/>'
		isSameAs: '<bar xmlns:urn="theSame" this="b:boo" xmlns:b="urn:blah"/>'.
	self denyXML: '<bar xmlns:urn="theSame" this="a:boo" xmlns:a="urn:blah"/>'
		isSameAs: '<bar xmlns:urn="theSame" this="a:boo" xmlns:a="urn:notblah"/>'.
	self denyXML: '<bar xmlns:urn="theSame" this="a:boo" xmlns:a="urn:blah"/>'
		isSameAs: '<bar xmlns:urn="theSame" this="b:boo" xmlns:b="urn:notblah"/>'
!

testSameAttributesReordered
	self assertXML: '<foo a="b" c="d"/>' isSameAs: '<foo  c="d" a="b"/>'.
	self assertXML: '<bar><foo a="b" c="d"/></bar>' isSameAs: '<bar><foo  c="d" a="b"/></bar>'.
	self denyXML: '<bar><foo a="b" c="d"/></bar>' isSameAs: '<bar><foo  a="b" c="d" e="f"/></bar>'.
	self denyXML: '<bar><foo a="b" c="d"/></bar>' isSameAs: '<bar><foo  a="b" c="e" /></bar>'.
	self denyXML: '<bar><foo a="b" c="d"/></bar>' isSameAs: '<bar><foo  c="d" /></bar>'.
	self denyXML: '<bar><foo a="b" c="d"/></bar>' isSameAs: '<bar><foo a="b" d="c" /></bar>'
!

testSameNamespace
	self assertXML: '<a:bar xmlns:a="urn:blah"/>' isSameAs: '<b:bar xmlns:b="urn:blah"/>'.
	self denyXML: '<a:bar xmlns:a="urn:blah"/>' isSameAs: '<b:bar xmlns:b="urn:notblah"/>'
! !

!XeInfoComparerTest methodsFor:'public'!

assertXML: aString isSameAs: aString2
	self assert: (XeXMLInfoComparer new compare: aString to: aString2) 
!

denyXML: aString isSameAs: aString2 
	self deny: (XeXMLInfoComparer new compare: aString to: aString2)
! !

!XeInfoComparerTest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SOAP__XeInfoComparerTest.st,v 1.1 2009/10/02 19:36:36 cg Exp $'
! !
