"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

TestObjectsSpray subclass:#SpSprayTestEnvelopes
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SoapCore-TestCases'
!


!SpSprayTestEnvelopes methodsFor:'accessing'!

getEnvWithHeaderString: xmlString
	^SpwSoapInEnvelope 
		fromXmlString: ('<SOAP:Envelope
xmlns:SOAP="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
%1
<SOAP:Body>
<is:deleteItem xmlns:is="http://schemas.pge.com/ItemService">
<path>a/b</path>
</is:deleteItem>
</SOAP:Body>
</SOAP:Envelope>' 
				formatWith: xmlString)
!

getEnvelopeSpec1
	^SpwSoapInEnvelope 
		fromXmlString: 
'<env:Envelope 
xmlns:env="http://schemas.xmlsoap.org/soap/envelope/" >
<env:Body>
<m:GetLastTradePrice 
  env:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:m="http://example.org/quotes">
<symbol>DIS</symbol>
</m:GetLastTradePrice>
</env:Body>
</env:Envelope>
'
!

getEnvelopeWith2MustHeaders
	^self getEnvWithHeaderString: 
'<SOAP:Header>
<t:first xmlns:t="some-URI" SOAP-ENV:mustUnderstand="1">4</t:first>
<t:Transaction xmlns:t="some-URI" SOAP-ENV:mustUnderstand="1">5 </t:Transaction>
</SOAP:Header>'
!

getEnvelopeWithActorNext
	^self getEnvWithHeaderString: 
'<SOAP:Header SOAP-ENV:actor="http://schemas.xmlsoap.org/soap/actor/next">
<t:Transaction
xmlns:t="some-URI" SOAP-ENV:mustUnderstand="1">5</t:Transaction>
</SOAP:Header>'
!

getEnvelopeWithActorNotNext
	^self getEnvWithHeaderString: 
'<SOAP:Header SOAP-ENV:actor="urn:blah">
<t:Transaction
xmlns:t="some-URI" SOAP-ENV:mustUnderstand="1">5</t:Transaction>
</SOAP:Header>'
!

getEnvelopeWithHeader
	^self getEnvWithHeaderString: 
'<SOAP:Header>
<is:traceDetail xmlns:is="http://schemas.pge.com/ItemService">All</is:traceDetail>
</SOAP:Header>'
!

getEnvelopeWithMustHeader
	^self getEnvWithHeaderString: 
'<SOAP:Header>
<t:Transaction xmlns:t="some-URI" SOAP-ENV:mustUnderstand="1">5</t:Transaction>
</SOAP:Header>'
!

getEnvelopeWithMustHeader2
	^self getEnvWithHeaderString: 
'<SOAP:Header>
<t:first xmlns:t="some-URI" >4</t:first>
<t:Transaction xmlns:t="some-URI" SOAP-ENV:mustUnderstand="1">5</t:Transaction>
</SOAP:Header>'
!

getEnvelopeWithMustHeaderFalse
	^self getEnvWithHeaderString: 
'<SOAP:Header>
<t:Transaction xmlns:t="some-URI" SOAP-ENV:mustUnderstand="0">5</t:Transaction>
</SOAP:Header>'
!

getEnvelopeWithMustHeaderNQ
	^self getEnvWithHeaderString: 
'<SOAP:Header>
<t:Transaction xmlns:t="some-URI" mustUnderstand="1">5</t:Transaction>
</SOAP:Header>'
!

getEnvelopeWithRootAttribute
	^SpwSoapInEnvelope 
		fromXmlString: 
'<SOAP-ENV:Envelope
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
<SOAP-ENV:Body xmlns:m="urn:blah">
<m:Address id="a1" SOAP-ENC:root="0">
<street>17 Cherry Tree Lane</street>
<city>London</city>
<country>England</country>
</m:Address>
<m:PurchaseOrder>
<shipTo href="#a1"/>
<billTo href="#a1"/>
</m:PurchaseOrder>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'
!

getEnvelopeWithoutBody
	^SpwSoapInEnvelope 
		fromXmlString: 
'<SOAP:Envelope
xmlns:SOAP="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP:Header>
<is:traceDetail xmlns:is="http://schemas.pge.com/ItemService">
All
</is:traceDetail>
</SOAP:Header>
</SOAP:Envelope>'
!

getEnvelopeWrongNS
	^SpwSoapInEnvelope 
		fromXmlString: 
'<env:Envelope 
xmlns:env="http://NOTschemas.xmlsoap.org/soap/envelope/" >
<env:Body>
<m:GetLastTradePrice 
  env:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:m="http://example.org/quotes">
<symbol>DIS</symbol>
</m:GetLastTradePrice>
</env:Body>
</env:Envelope>
'
!

getFaultEnvelope
	^SpwSoapInEnvelope 
		fromXmlString: 
'<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
<soap:Body>
<soap:Fault>
<faultcode>soap:Client</faultcode>
<faultstring>Server did not recognize the value of HTTP Header SOAPAction: ''''.</faultstring>
<faultactor>http://131.107.72.13/test/simple.asmx</faultactor>
<detail/>
</soap:Fault>
</soap:Body>
</soap:Envelope>'
!

getFaultEnvelopeSpec10
	^SpwSoapInEnvelope 
		fromXmlString: 
'<SOAP-ENV:Envelope
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<SOAP-ENV:Fault>
<faultcode>SOAP-ENV:Server</faultcode>
<faultstring>Server Error</faultstring>
<detail>
<e:myfaultdetails xmlns:e="Some-URI">
<message>
My application didnt work
</message>
<errorcode>
1001
</errorcode>
</e:myfaultdetails>
</detail>
</SOAP-ENV:Fault>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'
!

getFaultEnvelopeSpec9
	^SpwSoapInEnvelope 
		fromXmlString: 
'<SOAP-ENV:Envelope
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<SOAP-ENV:Fault>
<faultcode>SOAP-ENV:MustUnderstand</faultcode>
<faultstring>SOAP Must Understand Error</faultstring>
</SOAP-ENV:Fault>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>
'
!

getQFaultEnvelope
	^SpwSoapInEnvelope 
		fromXmlString: 
'<SOAP:Envelope SOAP:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:SOAP="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"><SOAP:Body><SOAP:Fault><SOAP:faultcode>SOAP:Client.NoMethod</SOAP:faultcode><SOAP:faultstring>The message did not contain any recognized methods.</SOAP:faultstring></SOAP:Fault></SOAP:Body></SOAP:Envelope>'
!

getSoapLiteEnvelope
	^SpwSoapInEnvelope 
		fromXmlString: 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<SOAP-ENV:Body>
<ns1:echoStruct xmlns:ns1="urn:xmethodsInterop" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<echo xsi:type="ns1:SOAPStruct">
<varInt xsi:type="xsd:int">3</varInt>
<varFloat xsi:type="xsd:float">1.2</varFloat>
<varString xsi:type="xsd:string">Hello</varString>
</echo>
</ns1:echoStruct>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'
! !

!SpSprayTestEnvelopes class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SpSprayTestEnvelopes.st,v 1.2 2003/01/20 19:02:15 cg Exp $'
! !
