"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SptQueueTests subclass:#SptAsyncSendQueueTest
	instanceVariableNames:'arg1 arg2 arg3'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SoapCore-TestCases'
!


!SptAsyncSendQueueTest methodsFor:'accessing'!

foo: object1
	arg1 := object1.

!

foo: object1 bar: object2
	arg1 := object1.
	arg2 := object2
!

foo: object1 bar: object2 baz: object3
	arg1 := object1.
	arg2 := object2.
	arg3 := object3.
!

new0ArgWith: anObject 
	| exchange |
	exchange := self newExWith: anObject.
	queue 
		prepareExchange: exchange
		selector: #foo:
		receiver: self
		arguments: #()
		cookie: 123.
	^exchange
!

new1ArgWith: anObject 
	| exchange |
	exchange := self newExWith: anObject.
	queue 
		prepareExchange: exchange
		selector: #foo:bar:
		receiver: self
		arguments: (Array with: 1)
		cookie: 123.
	^exchange
!

new2ArgWith: anObject 
	| exchange |
	exchange := self newExWith: anObject.
	queue 
		prepareExchange: exchange
		selector: #foo:bar:baz:
		receiver: self
		arguments: (Array with: 1 with: 2)
		cookie: 123.
	^exchange
!

queueClass
	^SptAsyncSendQueue
! !

!SptAsyncSendQueueTest methodsFor:'tests'!

testArgNumEx
	| exchange |
	self setWithWaiting: 0.
	exchange := self newExWith: 1.
	self should: [queue prepareExchange: exchange 
		selector: #foo:
		receiver: self
		arguments: (Array with: 1)
		cookie: 2] raise: Error.
	self should: [queue prepareExchange: exchange 
		selector: #foo:bar:
		receiver: self
		arguments: #()
		cookie: 2] raise: Error.



!

testPending
	| exchange |
	self setWithWaiting: 0.
	exchange := self new1ArgWith: 1.
	queue queueLast: exchange.
	self assert: (queue pending includes: 123).
	queue queueLast: (self new1ArgWith: 1).
	self assert: queue pending size = 1.
	self assert: queue queue size = 1.
	queue queueLast: exchange.
	self assert: queue pending size = 1.
	self assert: queue queue size = 1
!

testPrepare
	| exchange |
	self setWithWaiting: 0.
	exchange := self new1ArgWith: 1.
	self assert: (exchange atQP: SptAsyncSendQueue qNameReceiver) == self.
	self assert: (exchange atQP: SptAsyncSendQueue qNameCookie) = 123.
	self assert: (exchange atQP: SptAsyncSendQueue qNameArguments) = (Array with: 1).
	self assert: (exchange atQP: SptAsyncSendQueue qNameSelector) = #foo:bar:
!

testTriggerExchange
	| exchange |
	self setWithWaiting: 0.
	exchange := self new1ArgWith: 1.
	queue triggerExchange: exchange.
	self assert: arg1 == exchange.
	self assert: arg2 = 1
!

testTriggerExchange0Arg
	| exchange |
	self setWithWaiting: 0.
	exchange := self new0ArgWith: 1.
	queue triggerExchange: exchange.
	self assert: arg1 == exchange.
	self assert: arg2 isNil
!

testTriggerExchange1Arg
	| exchange |
	self setWithWaiting: 0.
	exchange := self new1ArgWith: 1.
	queue triggerExchange: exchange.
	self assert: arg1 == exchange.
	self assert: arg2 = 1
!

testTriggerExchange2Arg
	| exchange |
	self setWithWaiting: 0.
	exchange := self new2ArgWith: 1.
	queue triggerExchange: exchange.
	self assert: arg1 == exchange.
	self assert: arg2 = 1.
	self assert: arg3 = 2
! !

!SptAsyncSendQueueTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SptAsyncSendQueueTest.st,v 1.2 2003/01/20 19:02:15 cg Exp $'
! !
