"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SoapCoreTests subclass:#SptPropertyScopeTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SoapCore-TestCases'
!


!SptPropertyScopeTests methodsFor:'accessing'!

getTestEnv
	| testEnv |
	testEnv := SptEnvironment new.
	testEnv sprayEnvironment: testEnv.
	^testEnv
!

scope
	self subclassResponsibility
! !

!SptPropertyScopeTests methodsFor:'tests'!

testAtQP
	self assert: (self scope atQP: 'sprayTrans:test' ifAbsent: []) isNil.
	self scope atQP: 'sprayTrans:test' put: 1.
	self assert: (self scope atQP: 'sprayTrans:test') = 1.
	self scope atQP: 'sprayTrans:test' put: 2.
	self assert: (self scope atQP: 'sprayTrans:test') = 2.

        
!

testAtScopedQP
	self assert: (self scope atScopedQP: 'sprayTrans:test' ifAbsent: []) isNil.
	self scope atQP: 'sprayTrans:test' put: 1.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 1.
	self scope atQP: 'sprayTrans:test' put: 2.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 2.

        
!

testLogStreamDefault
	self scope logStream class name = #TranscriptShell
!

testScopingEnvChange
	self assert: (self scope atScopedQP: 'sprayTrans:test' ifAbsent: []) isNil.
	self scope sprayEnvironment atQP: 'sprayTrans:test' put: 1.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 1.

	self scope sprayEnvironment: self getTestEnv.
	self assert: (self scope atScopedQP: 'sprayTrans:test' ifAbsent: []) isNil.
	self scope sprayEnvironment atQP: 'sprayTrans:test' put: 2.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 2.
!

testScopingToEnv
	self assert: (self scope atScopedQP: 'sprayTrans:test' ifAbsent: []) isNil.
	self scope sprayEnvironment atQP: 'sprayTrans:test' put: 1.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 1.
	self scope sprayEnvironment atQP: 'sprayTrans:test' put: 2.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 2.
	self scope atQP: 'sprayTrans:test' put: 3.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 3.
	self assert: (self scope sprayEnvironment atScopedQP: 'sprayTrans:test') = 2
! !

!SptPropertyScopeTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SptPropertyScopeTests.st,v 1.2 2003/01/20 19:02:15 cg Exp $'
! !
