"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SoapCoreTests subclass:#SptQueueTests
	instanceVariableNames:'queue'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SoapCore-TestCases'
!


!SptQueueTests methodsFor:'accessing'!

newExWith: anObject
	^(SptPropertyScope new)
		atQP: 'user:test' put: anObject;
		yourself
        
! !

!SptQueueTests methodsFor:'asserting'!

assertIsEx: aPropertyScope with: anObject
	self assert: ( aPropertyScope  atQP: 'user:test' ) = anObject

! !

!SptQueueTests methodsFor:'set up'!

setUp
	super setUp.
	queue := self queueClass new
!

setWithWaiting: anInteger 
	queue notNil ifTrue: [queue close].
	queue := self queueClass newProcessing: anInteger
!

tearDown
	super tearDown.
	queue notNil ifTrue: [queue close]
! !

!SptQueueTests methodsFor:'tests'!

testJumpQueue
	self setWithWaiting: 0.
	queue queueLast: (self newExWith: 1).
	queue queueFirst: (self newExWith: 2).
	self assertIsEx: queue queue next with: 2
!

testSizes
	self setWithWaiting: 0.
	self assert: queue queueSize = 0.
	self assert: queue totalSize = 0.
	self assert: queue processingSize = 0.
	queue queueLast: SptPropertyScope new.
	self assert: queue queueSize = 1.
	self assert: queue totalSize = 1.
	self assert: queue processingSize = 0.
	queue queueLast: SptPropertyScope new.
	self assert: queue queueSize = 2.
	self assert: queue totalSize = 2.
	self assert: queue processingSize = 0
! !

!SptQueueTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SptQueueTests.st,v 1.2 2003/01/20 19:02:15 cg Exp $'
! !
