"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SptPropertyScopeTests subclass:#SptSoapBindingTest
	instanceVariableNames:'bindingScope'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-SoapCore-TestCases'
!


!SptSoapBindingTest methodsFor:'accessing'!

scope
	^bindingScope
! !

!SptSoapBindingTest methodsFor:'set up'!

setUp
	| env |
	super setUp.
	bindingScope := SptSoapBindingAbstract new.
	bindingScope sprayEnvironment: (env := self getTestEnv).
	bindingScope exchange: (SptMEContext new sprayEnvironment: env)
! !

!SptSoapBindingTest methodsFor:'tests'!

testExchangeScoping
	self assert: (self scope atScopedQP: 'sprayTrans:test' ifAbsent: []) isNil.
	self scope exchange atQP: 'sprayTrans:test' put: 1.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 1.
!

testExchangeScopingFirst
	self assert: (self scope atScopedQP: 'sprayTrans:test' ifAbsent: []) isNil.
	self scope exchange atQP: 'sprayTrans:test' put: 1.
	self scope atQP: 'sprayTrans:test' put: 2.
	self assert: (self scope atScopedQP: 'sprayTrans:test') = 1.
	self assert: (self scope exchange atQP: 'sprayTrans:test') = 1.
	self assert: (self scope atQP: 'sprayTrans:test') = 2.

! !

!SptSoapBindingTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/spray/tests/SptSoapBindingTest.st,v 1.2 2003/01/20 19:02:15 cg Exp $'
! !
