"{ Package: 'stx:goodies/soap' }"

LibraryDefinition subclass:#stx_goodies_soap
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_soap class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/stx_goodies_soap.st,v 1.19 2010/12/22 09:58:54 stefan Exp $'
! !

!stx_goodies_soap class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
        #'stx:goodies/webServer'    "HTTPServer - referenced by SOAP::SoapHttpSetup class>>startUpOnPort:confirm: "
        #'stx:goodies/webServer/comanche'    "ComancheNetService - referenced by SOAP::SoapHttpSetup class>>startOn: "
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/communication'    "HTTPInterface - referenced by SOAP::SoapHttpModule>>process: "
        #'stx:goodies/webServer'    "HTTPServer - referenced by SOAP::SoapHttpSetup class>>startUpOnPort:confirm: "
        #'stx:goodies/webServer/comanche'    "ComancheNetService - referenced by SOAP::SoapHttpSetup class>>startOn: "
        #'stx:goodies/webServer/htmlTree'
        #'stx:goodies/webServer/ui'
        #'stx:goodies/xml/vw'    "XML::XMLParser - referenced by SOAP::SoVWXMLParserAdapter class>>parseXml: "
        #'stx:goodies/xml/yaxo'    "YAXO::XMLDOMParser - referenced by SOAP::SoYaxXMLParserAdapter class>>parseXml: "
        #'stx:libbasic'    "Exception - superclass of SOAP::SoapNoSuchTransport "
        #'stx:libbasic2'    "Socket - referenced by SOAP::SoapSqtpHandler>>start "
        #'stx:libboss'    "BinaryObjectStorage - referenced by SOAP::SoapSTXDecoder>>defaultObjectDecoderClass "
    )
! !

!stx_goodies_soap class methodsFor:'description - compilation'!

additionalDefinitions_bc_dot_mak
    ^ '
# see stdHeader_bc for LIBSOAP_BASE
LIB_BASE_LD_ARG=-b:$(LIBSOAP_BASE)
'                    
! !

!stx_goodies_soap class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (#'SOAP::STXSoapTests' autoload)
        (#'SOAP::STXSoapWSDLTests' autoload)
        #'SOAP::SoConstants'
        #'SOAP::SoExoboxXMLParserAdapter'
        #'SOAP::SoPortableTestUtil'
        #'SOAP::SoPortableUtil'
        #'SOAP::SoVWXMLParserAdapter'
        #'SOAP::SoXmlAttributesHolder'
        #'SOAP::SoXmlUtil'
        #'SOAP::SoXmlWrapElement'
        #'SOAP::SoYaxXMLParserAdapter'
        #'SOAP::SoapAbstractConnector'
        #'SOAP::SoapAbstractSocketClient'
        #'SOAP::SoapAction'
        #'SOAP::SoapCallEntry'
        #'SOAP::SoapConnectTimeoutQuery'
        #'SOAP::SoapConnectorFactory'
        #'SOAP::SoapContext'
        #'SOAP::SoapDataBinder'
        #'SOAP::SoapDataBindingFactory'
        #'SOAP::SoapElement'
        #'SOAP::SoapEncStruct'
        #'SOAP::SoapEncodable'
        #'SOAP::SoapEncodingStyleURIMap'
        #'SOAP::SoapEnvelopeBuilder'
        #'SOAP::SoapError'
        #'SOAP::SoapErrorLog'
        #'SOAP::SoapExceptionBuilder'
        #'SOAP::SoapFaultDetailBuilder'
        #'SOAP::SoapHttpClient'
        #'SOAP::SoapHttpModule'
        #'SOAP::SoapImplError'
        #'SOAP::SoapLiteServer'
        #'SOAP::SoapMessage'
        #'SOAP::SoapSTXDataBindingInstaller'
        #'SOAP::SoapService'
        #'SOAP::SoapServiceHandler'
        #'SOAP::SoapServiceHandlerQuery'
        #'SOAP::SoapServiceHome'
        #'SOAP::SoapServiceSignature'
        #'SOAP::SoapSetting'
        #'SOAP::SoapSixxDataBindingInstaller'
        #'SOAP::SoapSqDataBindingInstaller'
        #'SOAP::SoapSqtpHandler'
        #'SOAP::SoapSqtpProtocol'
        #'SOAP::SoapSrpDataBindingInstaller'
        #'SOAP::SoapTcpLocator'
        #'SOAP::SoapTransmitTimeoutQuery'
        #'SOAP::SoapTransportError'
        #'SOAP::SoapTransportMap'
        #'SOAP::SoapTransportSetup'
        #'stx_goodies_soap'
        #'SOAP::SoXmlConstants'
        #'SOAP::SoapAbstractDecoder'
        #'SOAP::SoapAbstractEncoder'
        #'SOAP::SoapAttributesHolder'
        #'SOAP::SoapBody'
        #'SOAP::SoapCannotConnectToServer'
        #'SOAP::SoapCannotResolveServer'
        #'SOAP::SoapDatabindingError'
        #'SOAP::SoapDecoderFactory'
        #'SOAP::SoapDocService'
        #'SOAP::SoapEncoderFactory'
        #'SOAP::SoapEnvelope'
        #'SOAP::SoapFault'
        #'SOAP::SoapFaultDetail'
        #'SOAP::SoapHeader'
        #'SOAP::SoapHttpConnector'
        #'SOAP::SoapHttpSetup'
        #'SOAP::SoapInvalidParamName'
        #'SOAP::SoapLocalRpcConnector'
        #'SOAP::SoapNoNamespacePrefix'
        #'SOAP::SoapNoSuchClass'
        #'SOAP::SoapNoSuchDataBinder'
        #'SOAP::SoapNoSuchEncodingArias'
        #'SOAP::SoapNoSuchService'
        #'SOAP::SoapNoSuchType'
        #'SOAP::SoapPRCElement'
        #'SOAP::SoapRemoteError'
        #'SOAP::SoapServiceInvocationFailed'
        #'SOAP::SoapSignedService'
        #'SOAP::SoapSqtpClient'
        #'SOAP::SoapSqtpConnector'
        #'SOAP::SoapSqtpSetup'
        #'SOAP::SoapVariable'
        #'SOAP::SoapWrapElement'
        #'SOAP::SoapWrongTagName'
        #'SOAP::SoapCall'
        #'SOAP::SoapConstants'
        #'SOAP::SoapDecoder'
        #'SOAP::SoapDecodingError'
        #'SOAP::SoapEncArray'
        #'SOAP::SoapEncoder'
        #'SOAP::SoapEncodingError'
        #'SOAP::SoapNoSuchConnector'
        #'SOAP::SoapNoSuchDecoder'
        #'SOAP::SoapNoSuchEncoder'
        #'SOAP::SoapNoSuchExceptionClass'
        #'SOAP::SoapNoSuchTransport'
        #'SOAP::SoapResponse'
        #'SOAP::SoapSTXDecoder'
        #'SOAP::SoapSTXEncoder'
        #'SOAP::SoapSendFault'
        #'SOAP::SoapServerFault'
        #'SOAP::SoapSixxDecoder'
        #'SOAP::SoapSixxEncoder'
        #'SOAP::SoapSqDecoder'
        #'SOAP::SoapSqEncoder'
        #'SOAP::SoapSrpDecoder'
        #'SOAP::SoapSrpEncoder'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Collection asSOAPEncodableObject
        Filename asSOAPEncodableObject
        Object asSOAPEncodableObject
        String browserView:
    )
! !

!stx_goodies_soap class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X SOAP'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ nil

    "Modified: / 08-11-2007 / 16:57:14 / cg"
! !

!stx_goodies_soap class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/stx_goodies_soap.st,v 1.19 2010/12/22 09:58:54 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/stx_goodies_soap.st,v 1.19 2010/12/22 09:58:54 stefan Exp $'
! !
