"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#STXSoapTests
	instanceVariableNames:'serviceHandler'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!STXSoapTests methodsFor:'initialize / release'!

portNr
    ^ 9999
!

setupSOAP
    "common setup - invoked before testing."

    |portNr server|

    portNr := self portNr.

    server := HTTPServer serverOnPort:portNr.
    server verbose:true.
    server waitUntilServing.

    SoapHttpSetup startUpOnPort:portNr.

    serviceHandler := server soapServiceHandler.
    serviceHandler isNil ifTrue:[
	self error:'SOAP is not enabled in HTTPServer port ' , portNr printString.
    ].

    "
     self new
	setupSOAP;
	inspect
    "
!

tearDownSOAP
    "common cleanup - invoked after testing."

    |portNr server|

    portNr := self portNr.

    server := HTTPServer runningServerOnPort:portNr.
    server notNil ifTrue:[
	server stop.
	server waitUntilStopped.
    ].
! !

!STXSoapTests methodsFor:'tests'!

test01_Setup
    "assume server is started"

    self setupSOAP.

    self assert:(serviceHandler notNil).

    self tearDownSOAP.

    "
     self new test01_Setup
    "
!

test02_SimpleCall
    self setupSOAP.
    self tearDownSOAP.


    "
     self new test02_SimpleCall
    "
! !

!STXSoapTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/STXSoapTests.st,v 1.4 2008/09/05 16:07:26 cg Exp $'
! !
