"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoSoapFaultDetailBuilderTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoSoapFaultDetailBuilderTestCase methodsFor:'for workspace'!

doItInWorkspace
	"SoSoapFaultDetailBuilderTestCase new doItInWorkspace"
	| soapFaultDetail res1 res2 res3 details res4 res5 res6 results |
	soapFaultDetail := [1 / 0]
				on: Error
				do: [:ex | 
					| build de |       self halt:'debugHalt'.
					build := SoapFaultDetailBuilder new.
					de := build buildSoapFaultDetailOn: SoapFault server from: ex.
					de].
	res1 := soapFaultDetail parent name= 'SOAP-ENV:Fault'.
	res2 := soapFaultDetail parent faultstring =  'ZeroDivide'.
	res3 := soapFaultDetail name = 'detail'.
	details := soapFaultDetail subElements first.
	res4 := details shortName = 'details'.
	res5 := (details declaredNamespaceURIFor: SoapFaultDetailBuilder defaultPrefix)
				= SoapFaultDetailBuilder defaultNamespace.
        
	res6 := (details findChildNamed: 'ErrorClass') value =  'ZeroDivide'.
        
	results := OrderedCollection new.
	results add: res1.
	results add: res2.
	results add: res3.
	results add: res4.
	results add: res5.
	results add: res6.
	results inspect
! !

!SoSoapFaultDetailBuilderTestCase methodsFor:'testing'!

testBuildSoapFaultDetailWithZeroDivide
	"###COULD NOT RUN - BECAUSE OF SUNIT ERROR###"
	"DO it in workspace instead"
	"| soapFaultDetail  details |
	soapFaultDetail := [1 / 0]
				on: ZeroDivide
				do: [:ex | 
					| build de | 
					build := SoapFaultDetailBuilder new.
					de := build buildSoapFaultDetailOn: SoapFault server from: ex.
					de].
	self should: [soapFaultDetail parent name = 'SOAP-ENV:Fault'].
	self should: [soapFaultDetail parent faultstring =  'ZeroDivide'].
	self should: [soapFaultDetail name = 'detail'].
	details := soapFaultDetail subElements first.
	self should: [details shortName = 'details'].
	self should: [(details declaredNamespaceURIFor: SoapFaultDetailBuilder defaultPrefix)
				= SoapFaultDetailBuilder defaultNamespace].
        
	self should:[ (details findChildNamed: 'ErrorClass') value =  'ZeroDivide']."
        
! !

!SoSoapFaultDetailBuilderTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoSoapFaultDetailBuilderTestCase.st,v 1.4 2003/01/20 19:02:15 cg Exp $'
! !
