"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoXmlAttributesHolderTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoXmlAttributesHolderTestCase methodsFor:'testing'!

testAsDictionary
	| attribsHolder dict |
	attribsHolder := SoXmlAttributesHolder new.
	attribsHolder putAttribute: #('key1' 'val1').
	attribsHolder putAttribute: #('key2' 'val2').
	dict := attribsHolder asDictionary.
	self should: [ ( dict at: 'key1' ) = 'val1'].
	self should: [ ( dict at: 'key2' ) = 'val2'].
        
        
!

testDeclareNamespaceURIs
	| attribsHolder |
	attribsHolder := SoXmlAttributesHolder new.
	attribsHolder declareNamespace: 'Foo1' uri: 'http://www.bar.org'.
	attribsHolder declareNamespace: 'Foo2' uri: 'http://www.baz.org'.
        
	self should: [(attribsHolder declaredNamespaceURIFor: 'Foo1') = 'http://www.bar.org'].
	self should: [(attribsHolder declaredNamespaceURIFor: 'Foo2') = 'http://www.baz.org'].
        
!

testDeclareNamespaces
	| attribsHolder |
	attribsHolder := SoXmlAttributesHolder new.
	attribsHolder declareNamespace: 'Foo1' uri: 'http://www.bar.org'.
	attribsHolder declareNamespace: 'Foo2' uri: 'http://www.baz.org'.
	self should: [attribsHolder declaredNamespacePrefixes asSortedCollection asArray = #('Foo1' 'Foo2')].
        
!

testDeclareNamespacesAndPutAttributes
	| attribsHolder ansStr |
	attribsHolder := SoXmlAttributesHolder new.
	attribsHolder declareNamespace: 'Foo1' uri: 'http://www.bar.org'.
	attribsHolder putAttribute: #('key1' 'val1').
	ansStr := ' xmlns:Foo1="http://www.bar.org" key1="val1"'.
	self should: [ansStr = attribsHolder printString]
        
        
!

testPutAttributes
	| attribsHolder |
	attribsHolder := SoXmlAttributesHolder new.
	attribsHolder putAttribute: #('key1' 'val1').
	self should: ['val1' = (attribsHolder getAttributeNamed: 'key1')].
	attribsHolder putAttribute: #('key1' 'val2').
	self shouldnt: ['val1' = (attribsHolder getAttributeNamed: 'key1')].
	self should: ['val2' = (attribsHolder getAttributeNamed: 'key1')].
        
        
! !

!SoXmlAttributesHolderTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoXmlAttributesHolderTestCase.st,v 1.4 2003/01/20 19:02:15 cg Exp $'
! !
