"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoXmlWrapElementTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoXmlWrapElementTestCase methodsFor:'testing'!

testElemPrint1
	| fixString wStr xmlElem  |
	fixString := '<Foo>bar</Foo>
'.
	wStr := WriteStream on: (String new: 16).
	xmlElem := SoXmlWrapElement new.
	xmlElem name: 'Foo'.
	xmlElem value: 'bar'.
	xmlElem printXmlOn: wStr.
	self should: [wStr contents = fixString]
!

testElemPrint2
	| fixString wStr xmlElem  child |
	fixString :=  '<SMIX>
 <interchangeUnit>
  <classDefinition className="Customer">
   <instVarNames>name address tel</instVarNames>
  </classDefinition>
 </interchangeUnit>
</SMIX>
'.
	wStr := WriteStream on: (String new: 16).
	xmlElem := SoXmlWrapElement new.
	xmlElem name: 'SMIX'.
	child := xmlElem createChildNamed: 'interchangeUnit'.
	child := child createChildNamed: 'classDefinition'.
	child putAttribute: #(className Customer).
	child := child createChildNamed: 'instVarNames'.
	child value: 'name address tel'.
	xmlElem printXmlOn: wStr.
        
	self should:[wStr contents = fixString].
! !

!SoXmlWrapElementTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoXmlWrapElementTestCase.st,v 1.3 2003/01/20 19:02:15 cg Exp $'
! !
