"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapBodyTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapBodyTestCase methodsFor:'testing'!

testAddBodyEntries
	| body ent1 ent2 |
	body := SoapBody new.
	ent1 := SoapWrapElement named: 'request1' withPrefix: 'm1'.
	ent1 declareNamespace: 'm1' uri: 'urn:request:1'.
	body addBodyEntry: ent1.
	ent2 := SoapWrapElement named: 'request1' withPrefix: 'm2'.
	ent2 declareNamespace: 'm2' uri: 'urn:request:2'.
	body addBodyEntry: ent2.
        
	self should:[ent1 parent =  body].
	self should:[ent2 parent =  body].
        
	self should:[(body bodyEntries at: 1 ) = ent1].
	self should:[(body bodyEntries at: 2 ) = ent2].
        
        
        
!

testIsMustUnderstandEnabled
	| body |
	body := SoapBody new.
	self should:[body isMustUnderstandEnabled].
!

testOverrideEncodingStyle
	| env body ent1 |
	env := SoapEnvelope new.
	env declareSoapEncEncoding.
	self should: [ (env getAttributeNamed: (SoapConstants soapEnvPrefix,':', SoapConstants encodingStyle) ) 
			= SoapConstants soapEncURI].
	self should: [env encodingStyleURIs = (Array with: (SoapConstants soapEncURI))].
        
	body := env addBody.
	body declareNamespace: 'b' uri: 'urn:body:1'.
	body declareEncodingIn: 'b' uri: 'urn:encoding:1'.
	self shouldnt: [body encodingStyleURIs = (Array with: (SoapConstants soapEncURI))].
	self should:[body encodingStyleURIs = (Array with: ('urn:encoding:1'))].
        
	ent1 := SoapWrapElement named: 'request1' withPrefix: 'm1'.
	ent1 declareNamespace: 'm1' uri: 'urn:request:1'.
	body declareEncodingIn: 'm1' uri: 'urn:encoding:2'.
	body addBodyEntry: ent1.
	self should:[ent1 encodingStyleURIs = (Array with: ('urn:encoding:2'))].
        
        
        
        
        
        
! !

!SoapBodyTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapBodyTestCase.st,v 1.3 2003/01/20 19:02:15 cg Exp $'
! !
