"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapCallTestCaseForSrp
	instanceVariableNames:'originalTransports'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapCallTestCaseForSrp methodsFor:'fixtures'!

simpleAddService
	| ord serv |
	ord := OrderedCollection new.
	serv := SoapService implementor: ord selector: #add:.
	serv signature: (SoapServiceSignature name: 'add' paramNames: #(newElem)).
	^serv
! !

!SoapCallTestCaseForSrp methodsFor:'running'!

setUp
"/        originalTransports := SoapTransportSetup runningTransportNames.
!

tearDown
"/        SoapTransportSetup startOnly: originalTransports
! !

!SoapCallTestCaseForSrp methodsFor:'testing'!

testComplexSrpEncoding
	| call pa1 pa2 env methodElem arg1 arg2 |
	self should:[Smalltalk includesKey: #SrpObjectStream].
	call := SoapCall new.
	call transport: #localRpc.
	call targetObjectURI: 'urn:auauObject'.
	call encoding: #soapSrpEncoding.
	call methodName: 'auau'.
	pa1 := (SoapVariable name: #arg1 value: 1).
	pa2 := (SoapVariable name: #arg2 value: #two) encoding: #soapSrpEncoding.
	call addParameter: pa1.
	call addParameter: pa2.
	env := call buildEnvelope.

	self should: [env name = 'env:Envelope'].
	self should: [env body name = 'env:Body'].
	self should: [(env getAttributeNamed: 'env:encodingStyle') = SoapConstants soapSrpEncURI]. 
	methodElem := env body bodyEntries first.
	self should: [ methodElem name = 'm:auau'].
	arg1 := methodElem children at: 1.
	self should:[ arg1 name = 'arg1']. 
	self should:[ (arg1 getAttributeNamed: 'xsi:type') = 'SRP:Object']. 
	self should:[ (arg1 encodingStyleURIs first) = SoapConstants soapSrpEncURI]. 
	self should:[ (SrpObjectStream loadObjectFromText: (arg1 value)) = 1]. 
	arg2 := methodElem children at: 2.
	self should:[ arg2 name = 'arg2']. 
	self should:[ (arg2 getAttributeNamed: 'xsi:type') =  'SRP:Object']. 
!

testSimpleSrpCall

	| call resp |
"/        SoapTransportSetup startOnly: #(http). 

	self should:[Smalltalk includesKey: #SrpObjectStream].
	SoapServiceHandler default  add: self simpleAddService.
	"/ call := (SoapCallEntry local: (SoapTransportSetup defaultPortAt: #http)) newCall.
	call := SoapCallEntry local newCall.
	call transport: #localRpc.
	call encoding: #soapSrpEncoding.
	call methodName: 'add'.
	call addParameter: (SoapVariable name: #newElem value: 1).

	resp := call invoke.

	self shouldnt:[resp isFault].
	self should:[resp returnValue = 1].

	SoapServiceHandler default remove: self simpleAddService.
! !

!SoapCallTestCaseForSrp class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapCallTestCaseForSrp.st,v 1.3 2003/01/20 19:02:15 cg Exp $'
! !
