"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapEncArrayTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapEncArrayTestCase methodsFor:'testing'!

testArrayItemType
	| elem1 elem2 |
	elem1 := ((SoapVariable name: 'arr' value: #(1 2 3) ) asXmlElement).
	self should:[elem1 arrayItemType = (SoapConstants xsdPrefixColon, 'integer')].
        
	elem2 := ((SoapVariable name: 'arr' value: #(1 'two' 3) ) asXmlElement).
	self should:[elem2 arrayItemType = (SoapConstants xsdPrefixColon, 'anyType')].
        
!

testArraySize
	| elem1 elem2 |
	elem1 := ((SoapVariable name: 'arr' value: #(1 nil 3) ) asXmlElement).
	self should:[elem1 size = 3].
        
	elem2 := ((SoapVariable name: 'arr' value: #() ) asXmlElement).
	self should:[elem2 size = 0].
        
!

testIsArrayType
	| elem1 elem2 |
	elem1 := ((SoapVariable name: 'arr' value: #(1 2 3) ) asXmlElement).
	self should:[elem1 isArrayType].
        
	elem2 := ((SoapVariable name: 'prim' value: 1 ) asXmlElement).
	self shouldnt:[elem2 isArrayType]
        
! !

!SoapEncArrayTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapEncArrayTestCase.st,v 1.3 2003/01/20 19:02:15 cg Exp $'
! !
