"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapEnvelopeBuilderTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapEnvelopeBuilderTestCase methodsFor:'fixtures'!

echoBoolean
	"From ROUND 2 SOAP Interoperability Tests Specification"
	"http://www.whitemesa.com/interop/proposal2.html#echoInteger"

	^'<?xml version="1.0" encoding="UTF-8"?>

<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<SOAP-ENV:Body>
<m:echoBoolean xmlns:m="http://soapinterop.org/">
<inputBoolean>1</inputBoolean>
</m:echoBoolean>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'
!

echoInteger
        
	"From ROUND 2 SOAP Interoperability Tests Specification"
	"http://www.whitemesa.com/interop/proposal2.html#echoInteger"

	^'<?xml version="1.0" encoding="UTF-8"?>

<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<SOAP-ENV:Body>
<m:echoInteger xmlns:m="http://soapinterop.org/">
<inputInteger>42</inputInteger>
</m:echoInteger>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'
! !

!SoapEnvelopeBuilderTestCase methodsFor:'testing'!

testBuildClientSoapFaultEnvelope
	| builder env body fault |
	builder := SoapEnvelopeBuilder new.
	env := builder
				buildClientSoapFaultEnvelope: (ZeroDivide new messageText: 'test zero divide').
	body := env body.
	self should: [body name = 'env:Body'].
	self should: [body hasFault].
	fault := body fault.
	self should: [fault name = 'env:Fault'].
	self should: [fault faultcode = 'env:Client'].
        
        
!

testBuildEnvelope
	| builder env body methodElem argElem |
	builder := SoapEnvelopeBuilder new.
	env := builder buildSoapEnvelopeFromXmlString: (self echoInteger).

	self should: [env name = 'SOAP-ENV:Envelope'].
	self should:[ (env getAttributeNamed: 'SOAP-ENV:encodingStyle') = 'http://schemas.xmlsoap.org/soap/encoding/'].
	self should:[ (env getAttributeNamed: 'xmlns:SOAP-ENC') = 'http://schemas.xmlsoap.org/soap/encoding/'].
	self should:[ (env getAttributeNamed: 'xmlns:SOAP-ENV') = 'http://schemas.xmlsoap.org/soap/envelope/'].
	self should:[ (env getAttributeNamed: 'xmlns:xsd') = 'http://www.w3.org/2001/XMLSchema'].
	self should:[ (env getAttributeNamed: 'xmlns:xsi') = 'http://www.w3.org/2001/XMLSchema-instance'].
        
	body := env body.
	self should: [body name = 'SOAP-ENV:Body'].
        
	methodElem := body findBodyEntryNamed: 'm:echoInteger'.
	self should: [methodElem notNil].
	self should: [methodElem name = 'm:echoInteger'].
	self should: [(methodElem getAttributeNamed: 'xmlns:m') = 'http://soapinterop.org/'].
        
	argElem := methodElem children first.
	self should: [argElem name =  'inputInteger'].
	self should: [argElem value = '42'].
        
        
        
        
        
!

testInheritedEnvelopeEncoding
	| builder env body methodElem argElem |
	builder := SoapEnvelopeBuilder new.
	env := builder buildSoapEnvelopeFromXmlString: (self echoBoolean).

	self should: [env name = 'SOAP-ENV:Envelope'].
	self should:[env encodingStyleURIs =  #('http://schemas.xmlsoap.org/soap/encoding/')].  

	body := env body.
	self should: [body name = 'SOAP-ENV:Body'].
        
	methodElem := body findBodyEntryNamed: 'm:echoBoolean'.
	self should: [methodElem notNil].
	self should: [methodElem name = 'm:echoBoolean'].
	self should: [(methodElem getAttributeNamed: 'xmlns:m') = 'http://soapinterop.org/'].   
        
	argElem := methodElem children first.
	self should:[argElem encodingStyleURIs =  #('http://schemas.xmlsoap.org/soap/encoding/')].
	self should: [argElem name =  'inputBoolean'].
	self should: [argElem value = '1'].
        
        
        
        
        
! !

!SoapEnvelopeBuilderTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapEnvelopeBuilderTestCase.st,v 1.3 2003/01/20 19:02:15 cg Exp $'
! !
