"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapExceptionBuilderTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapExceptionBuilderTestCase methodsFor:'fixtures'!

fooBarBazFault
	| soapFault  details stErrorClass messageText detail | 
	soapFault := SoapFault new.
	details := SoapWrapElement named: 'details' withPrefix: 'e'.
	stErrorClass := details createChildNamed: 'ErrorClass'.
	stErrorClass value: 'FooBarBaz'.
	messageText := details createChildNamed: 'messageText'.
	messageText value: 'invalid not existing class'.
	detail := soapFault addDetail.
	detail addSubElement: details.
	^soapFault
!

messageNotUnderstoodFault
        ^ [nil add: 1 ]
                on: MessageNotUnderstood
                do: [:ex | 
                        | soapFault soapFaultDetailBuilder | 
self breakPoint:('debugHalt:' , ex description).
                        soapFault := SoapFault new.
                        soapFaultDetailBuilder := SoapFaultDetailBuilder new.
                        soapFaultDetailBuilder buildSoapFaultDetailOn: soapFault from: ex.
                        ex return: soapFault]
!

zeroDivideFault
	^ [1 / 0]
		on: ZeroDivide
		do: [:ex | 
			| soapFault soapFaultDetailBuilder |  
			soapFault := SoapFault new.
			soapFaultDetailBuilder := SoapFaultDetailBuilder new.
			soapFaultDetailBuilder buildSoapFaultDetailOn: soapFault from: ex.
			ex return: soapFault]
! !

!SoapExceptionBuilderTestCase methodsFor:'testing'!

testMessageNotUnderstoodSignal
        
	| fault builder exception |
	fault := self messageNotUnderstoodFault.
	builder := SoapExceptionBuilder new.
	exception := builder buildExceptionFrom: fault.
"/        self should: [exception tag = '<<signaled in server>>'].
"/        self should: [exception messageText = 'add:'].
	self should:[exception raise] raise: MessageNotUnderstood.
        
        
        
!

testNotExistErrorClassSignal
        
	| fault builder |
	fault := self fooBarBazFault.
	builder := SoapExceptionBuilder new.
        
	self should:[builder buildExceptionFrom: fault] raise: SoapNoSuchExceptionClass.
        
        
        
!

testZeroDivideSignal
        
	| fault builder exception |
	fault := self zeroDivideFault.
	builder := SoapExceptionBuilder new.
	exception := builder buildExceptionFrom: fault.
	self should:[exception raise] raise: ZeroDivide.
        
! !

!SoapExceptionBuilderTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapExceptionBuilderTestCase.st,v 1.7 2003/01/20 22:22:17 cg Exp $'
! !
