"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapFaultTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapFaultTestCase methodsFor:'testing'!

testBasicFault
        
	| fault detail |

	"/ fault := SoapFault client faultstring: 'Client Error!!'.
	fault := SoapFault beClient faultstring: 'Client Error!!'.
	self should: [fault faultcode = (SoapConstants soapEnvPrefixColon, SoapConstants client)].
	self should: [fault faultstring = 'Client Error!!'].
        
	detail := fault addDetail.
	self should: [detail  name = 'detail'].
        
        
        
        
        
!

testDetailedFault
	| fault detail myErrors myErrors2 message errorcode |
	"/ fault := SoapFault client faultstring: 'Client Error!!'.
	fault := SoapFault beClient faultstring: 'Client Error!!'.
	detail := fault addDetail.
	myErrors := detail addSubElement: (SoapWrapElement named: 'myErrors' withPrefix: 'e').
	myErrors declareNamespace: 'e' uri: 'http://www.mars.dti.ne.jp/~umejava/smalltalk/SoapOpera/errors'.
	(myErrors createChildNamed: 'message') value: 'My application didn''t work'.
	(myErrors createChildNamed: 'errorcode') value: '1001'.
        
	myErrors2 := (fault detail findSubElementNamed: 'e:myErrors'). "##Apparently more work needed##"
	message := myErrors2 children at: 1.
	errorcode := myErrors2 children at: 2.
        
	self should:[message value = 'My application didn''t work'].
	self should:[errorcode value = '1001'].
        
        
        
        
        
!

testMinorFaultCodes
	| fault |
	"##OBSOLETE## hierarchical notation is no longer used in SOAP1.2"

	"/ fault := SoapFault client faultstring: 'Client Error!!'.
	fault := SoapFault beClient faultstring: 'Client Error!!'.
	fault attachMinorFaultCodes: #('Authentication' 'Password' 'Expired').
                
	self should:[fault faultcode = (SoapConstants soapEnvPrefixColon, 'Client.Authentication.Password.Expired')].
        
        
        
        
        
        
! !

!SoapFaultTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapFaultTestCase.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
