"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapSTXEncoderTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapSTXEncoderTestCase methodsFor:'testing'!

testEncodingInteger
	| enc ret |
	Smalltalk isSmalltalkX ifFalse:[^ self].

	enc := SoapSTXEncoder new.

	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: 1).
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'xsd:integer'].
	self should: [ ret value = '1'].
        
	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: 10000000000 type: #Integer).
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'xsd:integer'].
	self should: [ ret value = '10000000000'].
!

testEncodingNil
	| enc ret |
	Smalltalk isSmalltalkX ifFalse:[^ self].

	enc := SoapSTXEncoder new.
        
	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: nil).
	self should: [ ret name = 'auau'].
	self should: [ (ret getAttributeNamed: 'xsi:null') = 1].
	self should: [ ret isEmptyBody].
!

testEncodingObject
        
	| enc obj ret byteStr oStr bytes val |

	Smalltalk isSmalltalkX ifFalse:[^ self].

	enc := SoapSTXEncoder new.
	obj := #(1 2 #(#hello 'Smalltalk') 3).
	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: obj).
	self should: [ ret name = 'auau'].
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'SmalltalkX-ENC:BinaryObjectStorage'].

	byteStr := Base64Coder on:(ReadStream on: ret value).
	bytes := byteStr upToEnd.
	byteStr := bytes readStream.
	val := Object readBinaryFrom:byteStr.
        
	self should: [ obj = val].
!

testEncodingString
	| enc ret |
	Smalltalk isSmalltalkX ifFalse:[^ self].

	enc := SoapSTXEncoder new.

	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: 'smalltalk').
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'xsd:string'].
	self should: [ ret value = 'smalltalk'].
        
	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: 'ruby' type: #String).
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'xsd:string'].
	self should: [ ret value = 'ruby'].
! !

!SoapSTXEncoderTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapSTXEncoderTestCase.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
