"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapServiceTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapServiceTestCase methodsFor:'testing'!

testInvole
        
	| ord serv |
	ord := OrderedCollection new.
	serv := SoapService  implementor: ord selector: #add:.
	serv signature: (SoapServiceSignature name: 'add' paramNames: #(newObject)).
	serv invoke: ((SoapServiceSignature name: 'add' paramNames: #(newObject)) valueAt: #newObject put: #bar).
	self should: [ord size = 1].
	self should:[ord first = #bar]
        
        
         
!

testInvoleFail
	| ord serv |
	ord := OrderedCollection new.
	serv := SoapService implementor: ord selector: #add:.
	serv
		signature: (SoapServiceSignature name: 'add' paramNames: #(#newObject )).
	self
		should: [serv
				invoke: ((SoapServiceSignature name: 'auau' paramNames: #(#newObject ))
						valueAt: #newObject
						put: #bar)]
		raise: SoapNoSuchService
!

testInvoleInvalidParamName
	| ord serv |
	ord := OrderedCollection new.
	serv := SoapService implementor: ord selector: #add:.
	serv
		signature: (SoapServiceSignature name: 'add' paramNames: #(#newObject )).
	self
		should: [serv
				invoke: ((SoapServiceSignature name: 'add' paramNames: #(#newObject ))
						valueAt: #auauObject
						put: #bar)]
		raise: SoapInvalidParamName
!

testInvoleTwoArgs

	| dict serv regSig perSig |
	dict := Dictionary new.
	serv := SoapService implementor: dict selector: #at:put:.
	regSig := SoapServiceSignature name: 'at put'  paramNames: #(index value).
	serv signature: regSig.
        
	perSig := SoapServiceSignature name: 'at put' paramNames: #(index value).
	perSig valueAt: #index put: 1.
	perSig valueAt: #value put: #bar.
	serv invoke: perSig.
        
	self should: [dict includesKey: 1].
	self should:[(dict at: 1 ) = #bar]
        
        
         
! !

!SoapServiceTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapServiceTestCase.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
