"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapSqDecoderTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapSqDecoderTestCase methodsFor:'testing'!

testDecodeBoolean
	| dec ret |

	Smalltalk isSqueak ifFalse:[^ self].

	dec := SoapSqDecoder new.
	ret := dec decodeXmlElement: ((SoapVariable
					name: 'arg1'
					value: 'true'
					type: #Boolean) encoding: #soapSqEncoding;
					 asXmlElement).
	self
		should: [ret = true]
!

testDecodeInteger
	| dec ret |

	Smalltalk isSqueak ifFalse:[^ self].

	dec := SoapSqDecoder new.
	ret := dec decodeXmlElement: ((SoapVariable
					name: 'arg1'
					value: '1234567'
					type: #Integer) encoding: #soapSqEncoding;
					 asXmlElement).
	self
		should: [ret = 1234567]
!

testDecodeObject
	| dec ret dict |

	Smalltalk isSqueak ifFalse:[^ self].

	dec := SoapSqDecoder new.
	dict := Dictionary new.
	dict at: #Smalltalk put: #Cool.
	dict at: #Java put: #Plain.
	ret := dec decodeXmlElement: ((SoapVariable name: 'arg1' value: dict) encoding: #soapSqEncoding;
					 asXmlElement).
	self
		should: [ret = dict]
!

testDecodeString
	| dec ret |

	Smalltalk isSqueak ifFalse:[^ self].

	dec := SoapSqDecoder new.
	ret := dec decodeXmlElement: ((SoapVariable
					name: 'arg1'
					value: 'Smalltalk'
					type: #String) encoding: #soapSqEncoding;
					 asXmlElement).
	self
		should: [ret = 'Smalltalk']
! !

!SoapSqDecoderTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapSqDecoderTestCase.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
