"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapSqEncoderTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapSqEncoderTestCase methodsFor:'testing'!

testEncodingInteger
	| enc ret |
	Smalltalk isSqueak ifFalse:[^ self].

	enc := SoapSqEncoder new.

	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: 1).
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'xsd:integer'].
	self should: [ ret value = '1'].
        
	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: 10000000000 type: #Integer).
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'xsd:integer'].
	self should: [ ret value = '10000000000'].
!

testEncodingNil
	| enc ret |
	Smalltalk isSqueak ifFalse:[^ self].

	enc := SoapSqEncoder new.
        
	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: nil).
	self should: [ ret name = 'auau'].
	self should: [ (ret getAttributeNamed: 'xsi:null') = 1].
	self should: [ ret isEmptyBody].
!

testEncodingObject
        
	| enc obj ret byteStr oStr val |
	Smalltalk isSqueak ifFalse:[^ self].

	enc := SoapSqEncoder new.
	obj := #(1 2 #(#hello 'Smalltalk') 3).
	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: obj).
	self should: [ ret name = 'auau'].
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'Squeak-ENC:ReferenceStream'].
        
	byteStr := (Base64MimeConverter mimeDecodeToBytes: (ReadStream on: ret value)).
	oStr := SmartRefStream on: byteStr.
	val := oStr next.

	self should: [ obj = val].
!

testEncodingString
	| enc ret |
	Smalltalk isSqueak ifFalse:[^ self].

	enc := SoapSqEncoder new.

	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: 'smalltalk').
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'xsd:string'].
	self should: [ ret value = 'smalltalk'].
        
	ret := enc encodeSoapVariable: (SoapVariable name: 'auau' value: 'ruby' type: #String).
	self should: [ (ret getAttributeNamed: 'xsi:type') = 'xsd:string'].
	self should: [ ret value = 'ruby'].
! !

!SoapSqEncoderTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapSqEncoderTestCase.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
