"{ Package: 'stx:goodies/soap/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#SoapWrapElementTestCase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-TestCases'
!


!SoapWrapElementTestCase methodsFor:'fixtures'!

echoString
	"From ROUND 2 SOAP Interoperability Tests Specification"
	"http://www.whitemesa.com/interop/proposal2.html#echoString"
	^ '<?xml version="1.0" encoding="UTF-8"?>

<SOAP-ENV:Envelope SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<SOAP-ENV:Body>
<m:echoString xmlns:m="http://soapinterop.org/">
<inputString>hello world</inputString>
</m:echoString>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>
'
! !

!SoapWrapElementTestCase methodsFor:'testing'!

testFromXmlElement
        
	| sdom elem body callElem argElem |
	sdom := SoXmlUtil parseXml: self echoString.
	elem := SoapWrapElement fromXmlElement: sdom.
	self should: [elem name = 'SOAP-ENV:Envelope'].
	self should: [(elem getAttributeNamed: 'SOAP-ENV:encodingStyle' ) = 'http://schemas.xmlsoap.org/soap/encoding/'].
	self should: [(elem getAttributeNamed: 'xmlns:SOAP-ENC' ) = 'http://schemas.xmlsoap.org/soap/encoding/'].
	self should: [(elem getAttributeNamed: 'xmlns:SOAP-ENV' ) = 'http://schemas.xmlsoap.org/soap/envelope/'].
	self should: [(elem getAttributeNamed: 'xmlns:xsd' ) = 'http://www.w3.org/2001/XMLSchema'].
	self should: [(elem getAttributeNamed: 'xmlns:xsi' ) = 'http://www.w3.org/2001/XMLSchema-instance'].
        
	body := elem children first.
	self should: [body name = 'SOAP-ENV:Body'].
        
	callElem := body children first.
	self should: [callElem name = 'm:echoString'].
	self should: [(callElem getAttributeNamed: 'xmlns:m' ) = 'http://soapinterop.org/'].
        
	argElem := callElem children first.
	self should: [argElem name = 'inputString'].
	self should: [argElem value = 'hello world'].
	"elem inspect."
        
        
! !

!SoapWrapElementTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/tests/SoapWrapElementTestCase.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
