"
 COPYRIGHT (c) 2008 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/soap/wsdl' }"

"{ NameSpace: SOAP }"

Object subclass:#WsdlClient
	instanceVariableNames:'url operations service client'
	classVariableNames:'KeepWSDLFiles CachedRecentWSDLDocuments'
	poolDictionaries:''
	category:'SOAP-WSDL'
!

!WsdlClient class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2008 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

"
!

documentation
"
    unfinished - will be a simple wsdl interface with VW compatible protocol
    Uses the Spray opem SOAP implementation (originally for Dolphin)
"
!

examples
"
                                                                        [exBegin]
    (WsdlClient url: 'http://api.google.com/GoogleSearch.wsdl') operations.
                                                                        [exEnd]


                                                                        [exBegin]
    |wsdlClient|

    wsdlClient := WsdlClient url: 'http://api.google.com/GoogleSearch.wsdl'.
    ^ wsdlClient 
        executeSelector: #doGoogleSearch
        args: #('mykey provided bu google' 
                'Smalltalk Consultant' 
                0 10 
                true 
                ' '
                false 
                ' ' 
                ' ' 
                ' '). 
                                                                        [exEnd]
"
! !

!WsdlClient class methodsFor:'instance creation'!

url:aURL
    ^ self new url:aURL
! !

!WsdlClient methodsFor:'accessing'!

operations
    operations isNil ifTrue:[
        operations := self getOperations
    ].
    ^ operations
!

url
    ^ url
!

url:something
    url := something.
! !

!WsdlClient methodsFor:'operation'!

executeSelector:opName args:argumentCollection 
    |sendOp|

    operations isNil ifTrue:[
        self getOperations.
    ].
    sendOp := client send:opName withArguments:argumentCollection.
    ^ sendOp value


!

getOperations
    |wdslDocument|

    wdslDocument := self wdslDocument.
    service := SprayWSDLService onXmlString:wdslDocument.
    client := service createClient.

    ^ client operationPort operations

    "
     (WsdlClient url: 'http://api.google.com/GoogleSearch.wsdl') operations.
    "

"/        ^(exchange := client send: 'getQuote' with: 'YHOO') value
!

wdslDocument
    "cached in the wdslcache, or else fetched via the url"

    |reply doc|

    doc := self wdslDocumentFromCache.
    doc notNil ifTrue:[^ doc].

    reply := HTTPInterface get:url.
    reply isErrorResponse ifTrue:[
        self error:'cannot fetch the wsdl document'.
    ].
    reply isMovedResponse ifTrue:[
        self error:'unexpected moved response'.
    ].
    doc := reply data.
    doc notEmptyOrNil ifTrue:[
        CachedRecentWSDLDocuments isNil ifTrue:[
            CachedRecentWSDLDocuments := Dictionary new.
        ].
        CachedRecentWSDLDocuments at:url put:doc.
    ].
    ^ doc

    "
     (WsdlClient url: 'http://api.google.com/GoogleSearch.wsdl') getOperations.
    "
!

wdslDocumentFromCache
    "for now: nothing"

    |doc|

    CachedRecentWSDLDocuments notNil ifTrue:[
        doc := CachedRecentWSDLDocuments at:url ifAbsent:nil.
        doc notNil ifTrue:[^ doc].
    ].

    "/ try the wsdl-file cache
    ^ doc

    "
     (WsdlClient url: 'http://api.google.com/GoogleSearch.wsdl') getOperations.
    "
! !

!WsdlClient class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/SOAP__WsdlClient.st,v 1.2 2008/09/02 18:39:53 cg Exp $'
! !
