"{ Package: 'stx:goodies/soap/wsdl' }"

"{ NameSpace: SOAP }"

Object subclass:#WSDLMessage
	instanceVariableNames:'definitions qName node partNodes'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-WSDL'
!

WSDLMessage comment:'Parses the information from;
http://www.w3.org/TR/wsdl.html#_messages

<definitions .... >
    <message name="nmtoken"> *
        <part name="nmtoken" element="qname"? type="qname"?/> *
    </message>
</definitions>

'
!


!WSDLMessage methodsFor:'accessing'!

messageName
	^node getAttribute: 'name'
! !

!WSDLMessage methodsFor:'accessing-private'!

partNodes
	partNodes isNil ifTrue: [partNodes := node childNodes].
	^partNodes
!

partNodes: aCollection
	partNodes := aCollection
!

qName
	^qName
!

setDefinitions: wsdlDefinitions name: aQName
	definitions := wsdlDefinitions.
	qName := aQName.
	node := definitions messageNamed: qName.
! !

!WSDLMessage methodsFor:'spray creation'!

createParts
        ^self partNodes select: [:each | each localName = 'part']
                thenCollect: [:each | SOAP::SpmdPart fromWSDLPart: each]
! !

!WSDLMessage methodsFor:'spray creation-private'!

createMessage
        ^SOAP::SpmdMessage fromWSDLMessage: self 
! !

!WSDLMessage methodsFor:'testing'!

hasNoReturnPartWith: parameterList
	"See WSDL1.1 Sec 2.4.6.
	This is an optional attribute, but if we can use it to determine that there is no return part, we can use this information to extract response accessors more accurately. (ie we dont have to ignore the first accessor name (See SoapRPCStructType))"

	self partNodes isEmpty ifTrue: [^false].
	"The parameterList can not contain the return part "
	^self partNodes allSatisfy: [:each | parameterList includes: (each getAttribute: 'name')]
! !

!WSDLMessage class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/WSDLMessage.st,v 1.3 2009/11/18 16:10:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/WSDLMessage.st,v 1.3 2009/11/18 16:10:43 cg Exp $'
! !
