"{ Package: 'stx:goodies/soap/wsdl' }"

"{ NameSpace: SOAP }"

Object subclass:#WSDLParseReport
	instanceVariableNames:'warnings information'
	classVariableNames:'WarnInvalid WarnQName WarnSoapNS'
	poolDictionaries:''
	category:'SOAP-WSDL'
!


!WSDLParseReport class methodsFor:'initialization'!

initialize
	"
	self initialize
	"

	WarnQName := 1.
	WarnSoapNS := 2.
	WarnInvalid := 4
! !

!WSDLParseReport class methodsFor:'instance creation'!

new
	^super new initialize
! !

!WSDLParseReport methodsFor:'accessing'!

atInfo: aString put: aString2 
	information at: aString put: aString2 
!

infoElements
        Smalltalk isSmalltalkX ifTrue:[
            ^information associations collect: [ :each | Array with: each key with: each value printString]
        ].
        ^information associations collect: [ :each | Array with: each key with: each value displayString]
!

isFullyParsed
	^self hasWarnings not
!

warnInvalid
	warnings := warnings mask: WarnInvalid set: true
!

warnQName
	warnings := warnings mask: WarnQName set: true
!

warnSoapNS
	warnings := self warnings mask: WarnSoapNS set: true
!

warnings
	^warnings
! !

!WSDLParseReport methodsFor:'accessing-private'!

information
	^information
!

information: anObject
	information := anObject
! !

!WSDLParseReport methodsFor:'initializing-private'!

initialize
        super initialize.
        warnings := 0.
        "/ cg:  changed to Dolphin::LookupTable
        "/ information := LookupTable new
        information := Dolphin::LookupTable new
! !

!WSDLParseReport methodsFor:'printing'!

hasWarnings
	^warnings ~= 0
!

printInformationOn: aStream
	self information keys asSortedCollection do: 
			[:each | 
			aStream
				nextPutAll: each;
				nextPutAll: ': ';
				nextPutAll: (self information at: each) displayString;
				cr]
!

printInformationString
	| stream |
	stream := String writeStream.
	self printInformationOn: stream.
	^stream contents
! !

!WSDLParseReport class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/WSDLParseReport.st,v 1.5 2009/11/18 16:10:40 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/WSDLParseReport.st,v 1.5 2009/11/18 16:10:40 cg Exp $'
! !

WSDLParseReport initialize!
