"{ Package: 'stx:goodies/soap/wsdl' }"

"{ NameSpace: SOAP }"

Object subclass:#WSDLUrl
	instanceVariableNames:'url base'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-WSDL'
!

WSDLUrl comment:'I am a url'
!


!WSDLUrl class methodsFor:'instance creation'!

url: aString base: aString2 
	^self new url: aString base: aString2 
! !

!WSDLUrl methodsFor:'accessing'!

absoluteUrl
	^self isUrlAbsolute ifTrue: [url] ifFalse: [self makeAbsoluteUrl]
!

rootBaseUrl
	| stream |
	stream := base readStream.
	self assert: [(stream next: 7) = 'http://'].
	^'http://' , (stream upTo: $/)
! !

!WSDLUrl methodsFor:'accessing-private'!

localBaseUrl
	^base copyFrom: 1 to: (base findLast: [ :each | each = $/])
!

url: aString 
	url := aString 
!

url: aString base: aString2 
	url := aString.
	base := aString2 
! !

!WSDLUrl methodsFor:'operations'!

makeAbsoluteUrl
	^self isUrlLocal ifTrue: [self makeLocalAbsoluteUrl] ifFalse: [self makeRootAbsoluteUrl]
! !

!WSDLUrl methodsFor:'operations-private'!

makeLocalAbsoluteUrl
	^self localBaseUrl , url
!

makeRootAbsoluteUrl
	^self rootBaseUrl , url
! !

!WSDLUrl methodsFor:'testing-private'!

isUrlAbsolute
	^url beginsWith: 'http'
!

isUrlLocal
	^url first ~= $/
! !

!WSDLUrl class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/WSDLUrl.st,v 1.1 2002/11/14 22:20:27 cg Exp $'
! !
