"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

TestObjectsSpray subclass:#SpSprayTestAuthObjects
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!SpSprayTestAuthObjects methodsFor:'public'!

clientAuthIn: aTypespace for: aSelector
	| element instance |
	element := (XeElementSpec named: 'AuthCS' class: SpAuthClientAuth) 
				xeParticleWith: aTypespace defaultEncodingStyle.
	instance := (XeSoapXMLReader read: (self rootNodeFor: (self perform: aSelector))
				element: element) nodeObject.
	^instance
!

getIncorrectXmlString
	^'<h:AuthCS xmlns:h="http://soap-authentication.org/digest/2001/08/">
<Nonce>950C60A74BAA9BB7EDAC95F02EEC497C</Nonce>
<Auth>0000002A5828F7958838BD2F08E04B0E</Auth>
<UserID>user</UserID>
<Realm>TestRealm</Realm>
</h:AuthCS>'
!

getInvalidRealmXmlString
	^'<h:AuthCS xmlns:h="http://soap-authentication.org/digest/2001/08/">
<Nonce>950C60A74BAA9BB7EDAC95F02EEC497C</Nonce>
<Auth>0F31632A5828F7958838BD2F08E04B0E</Auth>
<UserID>user</UserID>
<Realm>NotTestRealm</Realm>
</h:AuthCS>'
!

getInvalidXmlString
	^'<h:AuthCS xmlns:h="http://soap-authentication.org/digest/2001/08/">
<Nonce>950C60A74BAA9BB7EDAC95F02EEC497C</Nonce>
<Auth>0F31632A5828F7958838BD2F08E04B0E</Auth>
<UserID>notAUser</UserID>
<Realm>TestRealm</Realm>
</h:AuthCS>'
!

getSuccessNoChallengeXmlString
	^'<h:AuthCS xmlns:h="http://soap-authentication.org/digest/2001/08/">
<Nonce>950C60A74BAA9BB7EDAC95F02EEC497C</Nonce>
<Auth>0F31632A5828F7958838BD2F08E04B0E</Auth>
<UserID>user</UserID>
<Realm>TestRealm</Realm>
</h:AuthCS>'
!

getSuccessWithChallengeXmlString
	^'<h:AuthCS xmlns:h="http://soap-authentication.org/digest/2001/08/">
<Nonce>950C60A74BAA9BB7EDAC95F02EEC497C</Nonce>
<Auth>A5B0050FD38EFE4D0B6CDBE49090E5BB</Auth>
<UserID>user</UserID>
<Realm>TestRealm</Realm>
<CNonce>CEA8A3DB3C06C7970A61B92AE9560A08</CNonce>
</h:AuthCS>'
!

rootNodeFor: aString 
	^XeEnvironment rootNodeFor: aString
! !

!SpSprayTestAuthObjects class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__SpSprayTestAuthObjects.st,v 1.1 2009/10/02 19:44:20 cg Exp $'
! !
