"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

TestObjectsSpray subclass:#SpSprayTestSpmdObjects
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!SpSprayTestSpmdObjects methodsFor:'public'!

getMessage2TypedXSD
	^SpmdMessage 
		onParts: (Array with: (SpmdTypePart partName: 'param1' typeName: 'xsd:string')
				with: (SpmdTypePart partName: 'param2' typeName: 'xsd:int'))
!

getMessageElementComplex
	^SpmdMessage onPart: (SpmdElementPart partName: 'part1'
						elementName: (XeQName sprayClass: SWXMLTestObject))




!

getMessageElementComplex2Children
	^SpmdMessage onParts: (Array 
				with: (SpmdElementPart partName: 'body' elementName: (XeQName sprayClass: SWXMLTestObject))
				with: (SpmdElementPart partName: 'other'
						elementName: (XeQName sprayClass: SWXMLTestComposite)))
!

getMixedPort
	| port |
	port := SpmdPort new.
	port
		name: 'samplePort';
		addOperation: self getOperationEncDOCTypedXSD;
		addOperation: self getOperationEncRPCTypedXSD.
	"	namespace: 'urn:samplePort';"
	^port
!

getOperationEncDOCTypedXSD
	| op |
	op := SpmdDOCOperation named: 'myDOCOperation'.
	op
		soapAction: 'myAction';
		inputBody: self getSoapBodyEncTypedXSD;
		outputBody: self getSoapBodyEncTypedXSD.
	op inputBody message parts first selector: #myDocSelector1:.
	op inputBody message parts second selector: #myDocSelector2:.
	op inputBody beDOCHandler.
	op renameMessages.
	^op
!

getOperationEncRPCTypedXSD
	| op |
	op := SpmdRPCOperation named: 'myOperation'.
	op
		soapAction: 'myAction';
		inputBody: self getSoapBodyEncTypedXSD;
		outputBody: self getSoapBodyEncTypedXSD.
	op inputBody selector: #mySelector:with:.
	op renameMessages.
	^op
!

getOperationLiteralDOCElement
	| op ns |
	ns := #'http://example.com/stockquote.xsd'.
	op := SpmdDOCOperation named: 'GetLastTradePrice'.
	op
		inputBody: (SpmdSoapBody 
					literalMessage: (SpmdMessage forSingleElement: ('TradePriceRequest' ns: ns)));
		outputBody: (SpmdSoapBody 
					literalMessage: (SpmdMessage forSingleElement: ('TradePrice' ns: ns))).
	op inputBody message parts first selector: #myLiteralDocSelector1:.
	op inputBody beDOCHandler.
	op renameMessages.
	^op
!

getOperationWithInputHeaders
	| op |
	op := self getOperationEncRPCTypedXSD.
	op inputHeaders: (Array with: self getSoapHeaderLiteral).
	op inputHeaders first selector: #myHeaderSelector1:ex:.
	op renameMessages.
	^op
!

getOperationWithLinkedHeaders
	| op |
	op := self getOperationEncRPCTypedXSD.
	op 
		linkHeader: self getSoapHeaderLiteral
		to: self getSoapHeaderLiteral
		selector: #myHeaderSelector1:ex:.
	^op
!

getOperationWithMultipleHeaders
	| op |
	op := self getOperationEncRPCTypedXSD.
	op
		inputHeaders: (Array with: self getSoapHeaderLiteral with: self getSoapHeaderLiteral);
		outputHeaders: (Array with: self getSoapHeaderLiteral).
	op inputHeaders first selector: #myHeaderSelector1:ex:.
	op inputHeaders second selector: #myHeaderSelector2:ex:.
	^op
!

getSoapBodyEncTypedXSD
	^SpmdSoapBody soapEncMessage: (self getMessage2TypedXSD name: 'myOperationInput')
		ns: #'urn:blah'
!

getSoapHeaderLiteral
	^SpmdSoapHeader 
		onOwnLiteralMessage: self getMessageElementComplex
		
		
!

getWSDLSpecTypespace
	| ts |
	ts := XeTypespace defaultSoapEnc2001.
	ts 
		addSchemaString: '<schema targetNamespace="http://example.com/stockquote.xsd" 
xmlns="http://www.w3.org/2001/XMLSchema">
<element name="TradePriceRequest">
  <complexType>
    <all>
      <element name="tickerSymbol" type="string"/>
    </all>
  </complexType>
</element>
<element name="TradePrice">
  <complexType>
    <all>
      <element name="price" type="float"/>
    </all>
  </complexType>
</element> </schema>'.
	^ts
! !

!SpSprayTestSpmdObjects class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__SpSprayTestSpmdObjects.st,v 1.1 2009/10/02 19:42:44 cg Exp $'
! !
