"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

SprayDevelopmentTests subclass:#SpdMetaGeneratorTest
	instanceVariableNames:'generator'
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!SpdMetaGeneratorTest methodsFor:'set up'!

setUp
	super setUp.
	generator := SpdMetaDataGenerator new initialize
! !

!SpdMetaGeneratorTest methodsFor:'tests'!

testIncludeMethodsIn
	generator setForGlobal: SoapTestMetaGenerator.
	generator includeMethodsIn: (MethodCategory name: 'testing').
	self assert: (generator selectorItems select: [:each | each shouldGenerate]) size = 1.
	generator includeMethodsIn: MethodCategory public.
	self assert: (generator selectorItems select: [:each | each shouldGenerate]) size > 1.
	generator includeMethodsIn: (MethodCategory name: 'notACategory').
	self assert: (generator selectorItems select: [:each | each shouldGenerate]) isEmpty
!

testIncludesOperationFor
	generator setForGlobal: SoapTestMetaGenerator.
	self deny: (generator includesOperationFor: #mySelector:with:).
	generator port operations add: SpSprayTestSpmdObjects new getOperationEncRPCTypedXSD.
	self assert: (generator includesOperationFor: #mySelector:with:)
!

testPortAccessing
	generator setForGlobal: SoapTestMetaGenerator.
	generator portName: 'aNewName'.
	self assert: generator port name = 'aNewName'
!

testSuggestOperationName
	generator setForGlobal: SoapTestMetaGenerator.
	self assert: (generator suggestOperationNameFor: 'myOperation') = 'myOperation'.
	generator port operations add: (SpSprayTestSpmdObjects new getOperationEncRPCTypedXSD).
	self assert: (generator suggestOperationNameFor: 'myOperation') = 'myOperation1'
! !

!SpdMetaGeneratorTest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__SpdMetaGeneratorTest.st,v 1.1 2009/10/02 19:39:57 cg Exp $'
! !
