"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

SpmdTests subclass:#SpmdWSDLBuilderTest
	instanceVariableNames:'server builder'
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!SpmdWSDLBuilderTest methodsFor:'set up'!

setUp
	super setUp.
	server := SprayTestRpcService new createServer.
	builder := server wsdlBuilder
! !

!SpmdWSDLBuilderTest methodsFor:'tests'!

test1AddTypesIn
	| ans |
	ans := builder typesIn: XeNamespace sprayClass.
	self assert: (ans anySatisfy: [:each | each localName = 'SWXMLTestComposite']).
	


	
!

test1ServiceDefinitions
	| domNode |
	domNode := (builder defineService: builder newDefinitionsNode ) asParserNode.
	self assert: (domNode getAttribute: 'name') = 'SprayTest1Service'.
	self assert: domNode childNodes size = 2.
	self assert: domNode childNodes first localName = 'documentation'.
	self assert: (domNode childNodes first text) = 'TestDocumentation'.

	self assert: domNode childNodes second localName = 'port'.
	self assert: (domNode childNodes second getAttribute: 'name') = 'SprayTestPort'
!

test1TypeDefinitions
	| node typesNode schema |
	node := builder newDefinitionsNode.
	builder defineTypes: node.
	typesNode := node asParserNode firstChild.
	self assert: typesNode localName = 'types'.
	self assert: typesNode childNodes size = 1.
	schema := XeXSDSchema schemaNode: typesNode childNodes first.
	self assert: schema targetNamespace = XeNamespace sprayClass
!

test1TypeTargetNamespaces
	| ans |
	ans := builder xeContentNamespaces.
	self assert: (ans includes: XeNamespace sprayClass).
	self assert: (ans includes: XeNamespace schema2001)
! !

!SpmdWSDLBuilderTest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__SpmdWSDLBuilderTest.st,v 1.1 2009/10/02 19:41:47 cg Exp $'
! !
