"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

SprayLocalService subclass:#SprayTestHeadersService
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!

SprayTestHeadersService comment:'UnitTesting only'
!


!SprayTestHeadersService methodsFor:'private'!

onPortGenerated: port
	"Handle the onPortGenerated event. See superclass #onPortGenerated: comment."

	| headerName |
	super onPortGenerated: port.
	headerName := 'harborAuthentication' 
				ns: #'http://www.dolphinharbor.org/spray/harborAuthentication'.
	port operations do: 
			[:each | 
			each
				addInputHeaderDeclared: headerName;
				addOutputHeaderDeclared: headerName]
!

onTypespaceCreated
	"Private - Modify the default typespace"

	super onTypespaceCreated.
	"This modifies the typespace by including the XMLSchema created from the xml string, at it's targetNamespace in the typespace. 
	-The definitions and declarations can then be used in the service (ie in the operationModelClasses methods, or as part of other definitions)"
	typespace addSchemaString: self schemaImport
!

operationModelClass
	^SprayTestObject
!

schemaImport
	^
'<schema 
xmlns="http://www.w3.org/2001/XMLSchema" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
targetNamespace="http://www.dolphinharbor.org/spray/harborAuthentication"
xmlns:tns="http://www.dolphinharbor.org/spray/harborAuthentication"
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
elementFormDefault="qualified" >
<complexType name="HarborAuthenticationType">
<all>
	<element name="username" type="xsd:string"/>
	<element name="password" type="xsd:string"/>
</all>
</complexType>
<element name="harborAuthentication" type="tns:HarborAuthenticationType"/>
</schema>'
!

soapBReceivers
	^(super soapBReceivers)
		add: (SpwSoapBReceiver receiveFor: SpraySimpleAuthorizer new beDemo
					at: #'http://www.dolphinharbor.org/spray/harborAuthentication');
		yourself
! !

!SprayTestHeadersService class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__SprayTestHeadersService.st,v 1.1 2009/10/02 19:42:32 cg Exp $'
! !
