"{ Package: 'stx:goodies/soap/spray/tests' }"

"{ NameSpace: SOAP }"

SpwHandlerTests subclass:#SpwDOCHandlerAbstractTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-TestCases'
!


!SpwDOCHandlerAbstractTests methodsFor:'accessing'!

getExchange
	"^SpwRespondingExchange received: (SpwSoapInEnvelope fromXMLString: self getHandlerEnvString)
		in: typespace"

	^SptRespondingExchange onXmlString: self getHandlerEnvString
!

getHandlerEnvString
^'<SOAP-ENV:Envelope 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
<SOAP-ENV:Body 
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">
<param1 xmlns="urn:blah">abc</param1>
</SOAP-ENV:Body>
</SOAP-ENV:Envelope>'
! !

!SpwDOCHandlerAbstractTests methodsFor:'asserting'!

assertDocConstruction
	self deny: handler isDecodeOnly.
	self assert: handler identificationQName = self qParam1.
	self assert: handler soapAction = 'myAction'.
	self assert: (handler outputContent isKindOf: XeSimpleContent)
! !

!SpwDOCHandlerAbstractTests methodsFor:'tests'!

testEncodeBodyNode
	handler isBodyHandler: true.
	self assert: (handler encodeNodeFrom: self getExchange) localName = 'Body'
!

testEncodeHeaderNode
	handler isBodyHandler: false.
	self assert: (handler encodeNodeFrom:  self getExchange) localName = 'Header'
! !

!SpwDOCHandlerAbstractTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__SpwDOCHandlerAbstractTests.st,v 1.2 2010/03/08 21:18:37 cg Exp $'
! !
