"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

SpwOutEnvelopeTests subclass:#SpwOutDocumentTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!SpwOutDocumentTest methodsFor:'public'!

setEmptyBody
	super setUp.
	envelope := SpwOutDocument newIn: typespace.
	envelope 
		bodyCoders: #()
		headerCoders: #()
! !

!SpwOutDocumentTest methodsFor:'set up'!

setUp
	super setUp.
	envelope := SpwOutDocument newIn: typespace.
	envelope 
		bodyCoders: (Array with: self wireObjects docLitC1)
		headerCoders: #()
! !

!SpwOutDocumentTest methodsFor:'tests'!

testAddAnyLiteralHeader
	| codedObject |
	self setEmptyBody.
	envelope addAnyLiteralHeaderNamed: self qTest.
	self assert: ((codedObject := envelope headerNamed: self qTest) isKindOf: SpwCodedObject).
	codedObject object: 1.
	self assert: codedObject coder element encodingStyle isLiteralStyle.
	self assertXML: envelope soapOutEnvelope xml isSameAs: 
'<?xml version="1.0"?><SOAP-ENV:Envelope xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><SOAP-ENV:Header><ns1:test xmlns:ns1="urn:blah">1</ns1:test></SOAP-ENV:Header><SOAP-ENV:Body/></SOAP-ENV:Envelope>'
!

testDOCArguments
	envelope arguments: (Array with: SWXMLTestObject example1).
	self assert: envelope bodyObjects first =SWXMLTestObject example1
!

testSoapOutEnvelopeDOC
	envelope arguments: (Array with: SWXMLTestObject example1).
	self encodeSoapOut.
	self assertXML: soapOutEnv xml
		isSameAs: self wireObjects envXmlDocLitC1
! !

!SpwOutDocumentTest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__SpwOutDocumentTest.st,v 1.1 2009/10/02 19:43:55 cg Exp $'
! !
