"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

SprayClientTests subclass:#SpwSoapReceiverHeadersTest
	instanceVariableNames:'server service env exchange answer'
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!SpwSoapReceiverHeadersTest methodsFor:'public'!

includesAuthenticated
	^exchange includesQP: #'user:authenticated'
!

process
	server soapNode process: exchange
!

setBodyNotFound
	exchange := SptRespondingExchange 
				onXmlString: 
'<SOAP:Envelope
xmlns:SOAP="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
  <SOAP:Header>
    <harborAuthentication xmlns="http://www.dolphinharbor.org/spray/harborAuthentication">
      <username>user</username>
      <password>dolphin</password>
    </harborAuthentication>
  </SOAP:Header>
  <SOAP:Body>
    <m:NOTtestMethod1 xmlns:m="urn:SprayTesting123">
      <someString>abc</someString>
    </m:NOTtestMethod1>
   </SOAP:Body>
</SOAP:Envelope>'
!

setExchangeWithHeaderString: aString 
	exchange := SptRespondingExchange 
				onXmlString: (
'<SOAP:Envelope
xmlns:SOAP="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
  %1
  <SOAP:Body>
    <m:testMethod1 xmlns:m="urn:SprayTesting123">
      <someString>abc</someString>
    </m:testMethod1>
   </SOAP:Body>
</SOAP:Envelope>' 
						formatWith: aString)
!

setHeaderMU
	self 
		setExchangeWithHeaderString: 
'<SOAP:Header>
<harborAuthentication xmlns="http://www.dolphinharbor.org/spray/harborAuthentication" SOAP:mustUnderstand="1">
<username>user</username>
<password>dolphin</password>
</harborAuthentication>
</SOAP:Header>'
!

setHeaderMUNotFound
	self 
		setExchangeWithHeaderString: 
'<SOAP:Header>
<NOTharborAuthentication xmlns="http://www.dolphinharbor.org/spray/harborAuthentication" SOAP:mustUnderstand="1">
<username>user</username>
<password>dolphin</password>
</NOTharborAuthentication>
</SOAP:Header>'
!

setHeaderNextActor
	self 
		setExchangeWithHeaderString: 
'<SOAP:Header>
<harborAuthentication xmlns="http://www.dolphinharbor.org/spray/harborAuthentication"
SOAP:actor="http://schemas.xmlsoap.org/soap/actor/next">
<username>user</username>
<password>dolphin</password>
</harborAuthentication>
</SOAP:Header>'
!

setHeaderNotActor
	self 
		setExchangeWithHeaderString: 
'<SOAP:Header>
<harborAuthentication xmlns="http://www.dolphinharbor.org/spray/harborAuthentication"
SOAP:actor="notme">
<username>user</username>
<password>dolphin</password>
</harborAuthentication>
</SOAP:Header>'
!

setHeaderNotFound
	self 
		setExchangeWithHeaderString: 
'<SOAP:Header>
<foo xmlns="urn:blah">
<bar>only if you are interested</bar>
</foo>
</SOAP:Header>'
!

setWithHeaderUnderstandable
	self 
		setExchangeWithHeaderString: 
'<SOAP:Header>
<harborAuthentication xmlns="http://www.dolphinharbor.org/spray/harborAuthentication">
<username>user</username>
<password>dolphin</password>
</harborAuthentication>
</SOAP:Header>'
! !

!SpwSoapReceiverHeadersTest methodsFor:'set up'!

setUp
	super setUp.
	service := SprayTestHeadersService new.
	server := service createServer.

! !

!SpwSoapReceiverHeadersTest methodsFor:'tests'!

testHeaderNotProcessedNotActor
	self setHeaderNotActor.
	self process.
	self deny: self includesAuthenticated
!

testHeaderProcessed
	self setWithHeaderUnderstandable.
	self process.
	self assert: self includesAuthenticated
!

testHeaderProcessedNextActor
	self setHeaderNextActor.
	self process.
	self assert: self includesAuthenticated
!

testProcessBodyNotFound2
	self setBodyNotFound.
	self process.
	self assert: exchange out isFault.
	self assert: ('*detail*' match: exchange out xml)
!

testProcessHeaderFound
	self setWithHeaderUnderstandable.
	self process.
	self deny: exchange out isFault
!

testProcessHeaderNotFound
	self setHeaderNotFound.
	self process.
	self deny: exchange out isFault
!

testProcessMUHeader
	self setHeaderMU.
	self process.
	self deny: exchange out isFault
!

testProcessMUHeaderNotFound
	self setHeaderMUNotFound.
	self process.
	self assert: exchange out isFault.
	self deny: ('*detail*' match: exchange out xml)
! !

!SpwSoapReceiverHeadersTest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__SpwSoapReceiverHeadersTest.st,v 1.1 2009/10/02 19:44:24 cg Exp $'
! !
