"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

WSDLTests subclass:#WSDLMessageTest
	instanceVariableNames:'message'
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!WSDLMessageTest methodsFor:'public'!

setMessageFrom: aString 
	| node |
	node := self rootNodeFor: aString.
	message := WSDLMessage new.
	message partNodes: node childNodes
! !

!WSDLMessageTest methodsFor:'tests'!

testCreateElementParts
	| parts |
	self setMessageFrom:
'<message 
xmlns:s="urn:blah"
name="RequestForQuoteSoapIn">
    <part name="ProductName" element="s:thing1" />
    <part name="Quantity" element="s:thing2" />
 </message>'.
	parts := message createParts.
	self assert: parts size = 2.
	self assert: parts first partName = 'ProductName'.
	self assert: parts first elementName = (self blahQ: 'thing1').
	self assert: parts second partName = 'Quantity'.
	self assert: parts second elementName = (self blahQ: 'thing2')
!

testCreateTypedParts
	| parts |
	self setMessageFrom: 
'<message 
xmlns:s="http://www.w3.org/2001/XMLSchema"
name="RequestForQuoteSoapIn">
    <part name="ProductName" type="s:string" />
    <part name="Quantity" type="s:int" />
 </message>'.
	parts := message createParts.
	self assert: parts size = 2.
	self assert: parts first partName = 'ProductName'.
	self assert: parts first typeName = (XeQName xsd2001: 'string').
	self assert: parts second partName = 'Quantity'.
	self assert: parts second typeName = (XeQName xsd2001: 'int')
! !

!WSDLMessageTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__WSDLMessageTest.st,v 1.2 2009/10/02 19:41:23 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__WSDLMessageTest.st,v 1.2 2009/10/02 19:41:23 cg Exp $'
! !
