"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

WSDLTests subclass:#WSDLOperationTest
	instanceVariableNames:'wsdlPort wsdlOperation'
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!WSDLOperationTest methodsFor:'tests'!

testHeaders
	| op definitions |
	definitions := WSDLDefinitions onDocument: (self rootNodeFor: self getSampleWSDLHeaders) ownerDocument transport: nil.
	wsdlPort := WSDLPortData onDefinitions: definitions portName: nil.


	wsdlOperation := wsdlPort wsdlOperationNamed: 'echoVoid'.
	self assert: wsdlOperation inputHeaders size = 2.
	self assert: wsdlOperation outputHeaders size = 2.
	self assert: wsdlOperation inputHeaders first namespace = #'http://soapinterop.org/echoheader/'.
	self 
		assert: wsdlOperation inputHeaders first wsdlMessage qName localName = 'echoHeaderString_Request'.
	self 
		assert: wsdlOperation outputHeaders second wsdlMessage qName localName = 'echoHeaderStruct_Response'.
	self assert: wsdlOperation inputHeaders second partAttribute = 'echoMeStructRequest'.
	self assert: wsdlOperation outputHeaders first partAttribute = 'echoMeStringResponse'.
	op := wsdlOperation createSpmdOperation.
	self assert: op inputHeaders size = 2.
	self assert: op outputHeaders size = 2.
	self assert: op inputHeaders first isEncoded.
	self assert: op inputHeaders first namespace = #'http://soapinterop.org/echoheader/'.
	self assert: op inputHeaders first partNames = #('echoMeStringRequest')

	"<soap:header use='encoded' message='tns:echoHeaderString_Request' part='echoMeStringRequest' namespace='http://soapinterop.org/echoheader/' encodingStyle='http://schemas.xmlsoap.org/soap/encoding/'/>"
!

testNamedBindingOpNodes
	| op definitions |
	definitions := WSDLDefinitions onDocument: (self rootNodeFor: self getSampleWSDLNamedOpNodes) ownerDocument transport: nil.
	wsdlPort := WSDLPortData onDefinitions: definitions portName: nil.
	wsdlOperation := wsdlPort wsdlOperationNamed: 'echoString'.
	op := wsdlOperation createSpmdOperation

	"self assert: (op inputName = 'echoString').
	self assert: (op outputName = 'echoStringResult')"
!

testRPCEncoded
	wsdlPort := WSDLPortData onDefinitions: self getApacheDefs portName: nil.
	wsdlOperation := wsdlPort wsdlOperationNamed: 'SimpleBuy'.
	self assert: wsdlOperation isRPC.
	self assert: wsdlOperation soapAction = 'http://www.soapinterop.org/SimpleBuy'.
	self assert: wsdlOperation name = 'SimpleBuy'.
	self assert: wsdlOperation createSpmdOperation isRPC.
	self assert: wsdlOperation createSpmdOperation soapAction = 'http://www.soapinterop.org/SimpleBuy'.
	self assert: wsdlOperation createSpmdOperation name = 'SimpleBuy'

	"<operation name='SimpleBuy'>
      <soap:operation soapAction='http://www.soapinterop.org/SimpleBuy' style='rpc' />
      <input>
        <soap:body use='encoded' namespace='http://www.soapinterop.org/Bid' encodingStyle='http://schemas.xmlsoap.org/soap/encoding/' />
      </input>
      <output>
        <soap:body use='encoded' namespace='http://www.soapinterop.org/Bid' encodingStyle='http://schemas.xmlsoap.org/soap/encoding/' />
      </output>
    </operation>"
! !

!WSDLOperationTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__WSDLOperationTest.st,v 1.2 2009/10/02 19:40:15 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__WSDLOperationTest.st,v 1.2 2009/10/02 19:40:15 cg Exp $'
! !
