"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

WSDLTests subclass:#WSDLPortDataTest
	instanceVariableNames:'wsdlPort'
	classVariableNames:''
	poolDictionaries:''
	category:'Unclassified'
!


!WSDLPortDataTest methodsFor:'tests'!

testCreatePort
	| port |
	wsdlPort := WSDLPortData onDefinitions: self getApacheDefs portName: nil.
	port := wsdlPort createPort.
	self assert: port name = 'BidBuySoap'.
	self assert: port documentation isEmpty.
	self assert: port operations size = 4
!

testDefaultPortQName
	| ans |
	wsdlPort := WSDLPortData new.
	wsdlPort definitions: self getApacheDefs.
	ans := wsdlPort defaultPortQName.
	self assert: ans localName = 'BidBuySoap'.
	self assert: ans namespace = #'http://www.soapinterop.org/Bid'
!

testMultipleSchemas
	| defs |
	defs := self getSample1Defs.
	wsdlPort := WSDLPortData onDefinitions: defs portName: nil.
	self assert: wsdlPort definitions extractSchemas size = 2
!

testSetDefinitionNodes
	| qName |
	wsdlPort := WSDLPortData new.
	wsdlPort definitions: self getApacheDefs.
	qName := 'BidBuySoap' ns: #'http://www.soapinterop.org/Bid'.
	wsdlPort portQName: qName.
	wsdlPort setDefinitionNodes.
	self assert: wsdlPort bindingNode localName = 'binding'.
	self assert: wsdlPort portNode localName = 'port'.
	self assert: wsdlPort portTypeNode localName = 'portType'
! !

!WSDLPortDataTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__WSDLPortDataTest.st,v 1.2 2009/10/02 19:42:40 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/SOAP__WSDLPortDataTest.st,v 1.2 2009/10/02 19:42:40 cg Exp $'
! !
