"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

WSDLReadFuncTests subclass:#WSDLIonaInteropTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-WSDL-TestCases'
!


!WSDLIonaInteropTest methodsFor:'accessing'!

assertWSDLClientValid: client 
	| ms xml |
	ms := client send: 'echoString' with: 'abc'.
	"self assert: ms objectInEnvelope bodyCoders first element localName = 'echoString' ."
	self assertXML: (xml := ms soapOutEnvelope xml)
		isSameAs: '<?xml version="1.0"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:echoString 
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"   
  xmlns:m="http://soapinterop.org/">
    <inputString xsi:type="xsd:string">abc</inputString>
</m:echoString></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

numberOfPorts

	^1
!

numberOfSupportedPorts

	^1
!

supportedPortBaseNames 

	^#('InteropTestPort')
!

wsdlAddressLocation

	^'http://duckbill.boston.amer.iona.com:7002/xmlbus/container/InteropTest/InteropTestService/InteropTestPort/'
!

wsdlString

	"This WSDL names the input and output nodes"

	^'<?xml version="1.0" encoding="UTF-8"?>
<definitions name="InteropTestService"
    targetNamespace="http://soapinterop.org/"
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
    xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
    xmlns:tns="http://soapinterop.org/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:xsd1="http://soapinterop.org/xsd" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
    <types>
	<schema targetNamespace="http://soapinterop.org/xsd"
	    xmlns="http://www.w3.org/2001/XMLSchema" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
	    <complexType name="SOAPStruct">
		<all>
		    <element name="varFloat" type="xsd:float"/>
		    <element name="varInt" type="xsd:int"/>
		    <element name="varString" type="xsd:string"/>
		</all>
	    </complexType>
	    <complexType name="ArrayOffloat">
		<complexContent>
		    <restriction base="SOAP-ENC:Array">
			<attribute ref="SOAP-ENC:arrayType" wsdl:arrayType="xsd:float[]"/>
		    </restriction>
		</complexContent>
	    </complexType>
	    <complexType name="ArrayOfstring">
		<complexContent>
		    <restriction base="SOAP-ENC:Array">
			<attribute ref="SOAP-ENC:arrayType" wsdl:arrayType="xsd:string[]"/>
		    </restriction>
		</complexContent>
	    </complexType>
	    <complexType name="ArrayOfint">
		<complexContent>
		    <restriction base="SOAP-ENC:Array">
			<attribute ref="SOAP-ENC:arrayType" wsdl:arrayType="xsd:int[]"/>
		    </restriction>
		</complexContent>
	    </complexType>
	    <complexType name="ArrayOfSOAPStruct">
		<complexContent>
		    <restriction base="SOAP-ENC:Array">
			<attribute ref="SOAP-ENC:arrayType" wsdl:arrayType="xsd1:SOAPStruct[]"/>
		    </restriction>
		</complexContent>
	    </complexType>
	</schema>
    </types>
    <message name="echoStructRequest">
	<part name="inputStruct" type="xsd1:SOAPStruct"/>
    </message>
    <message name="echoStructResult">
	<part name="return" type="xsd1:SOAPStruct"/>
    </message>
    <message name="echoBooleanRequest">
	<part name="inputBoolean" type="xsd:boolean"/>
    </message>
    <message name="echoBooleanResult">
	<part name="return" type="xsd:boolean"/>
    </message>
    <message name="echoDateRequest">
	<part name="inputDate" type="xsd:dateTime"/>
    </message>
    <message name="echoDateResult">
	<part name="return" type="xsd:dateTime"/>
    </message>
    <message name="echoFloatArrayRequest">
	<part name="inputArray" type="xsd1:ArrayOffloat"/>
    </message>
    <message name="echoFloatArrayResult">
	<part name="return" type="xsd1:ArrayOffloat"/>
    </message>
    <message name="echoFloatRequest">
	<part name="inputFloat" type="xsd:float"/>
    </message>
    <message name="echoFloatResult">
	<part name="return" type="xsd:float"/>
    </message>
    <message name="echoStringArrayRequest">
	<part name="inputArray" type="xsd1:ArrayOfstring"/>
    </message>
    <message name="echoStringArrayResult">
	<part name="return" type="xsd1:ArrayOfstring"/>
    </message>
    <message name="echoIntegerArrayRequest">
	<part name="inputArray" type="xsd1:ArrayOfint"/>
    </message>
    <message name="echoIntegerArrayResult">
	<part name="return" type="xsd1:ArrayOfint"/>
    </message>
    <message name="echoStructArrayRequest">
	<part name="inputArray" type="xsd1:ArrayOfSOAPStruct"/>
    </message>
    <message name="echoStructArrayResult">
	<part name="return" type="xsd1:ArrayOfSOAPStruct"/>
    </message>
    <message name="echoDecimalRequest">
	<part name="inputDecimal" type="xsd:decimal"/>
    </message>
    <message name="echoDecimalResult">
	<part name="return" type="xsd:decimal"/>
    </message>
    <message name="echoVoidRequest"/>
    <message name="echoVoidResult"/>
    <message name="echoStringRequest">
	<part name="inputString" type="xsd:string"/>
    </message>
    <message name="echoStringResult">
	<part name="return" type="xsd:string"/>
    </message>
    <message name="echoIntegerRequest">
	<part name="inputInteger" type="xsd:int"/>
    </message>
    <message name="echoIntegerResult">
	<part name="return" type="xsd:int"/>
    </message>
    <message name="echoBase64Request">
	<part name="inputData" type="xsd:base64Binary"/>
    </message>
    <message name="echoBase64Result">
	<part name="return" type="xsd:base64Binary"/>
    </message>
    <portType name="InteropTestPortType">
	<operation name="echoStruct">
	    <input message="tns:echoStructRequest" name="echoStruct"/>
	    <output message="tns:echoStructResult" name="echoStructResult"/>
	</operation>
	<operation name="echoBoolean">
	    <input message="tns:echoBooleanRequest" name="echoBoolean"/>
	    <output message="tns:echoBooleanResult" name="echoBooleanResult"/>
	</operation>
	<operation name="echoDate">
	    <input message="tns:echoDateRequest" name="echoDate"/>
	    <output message="tns:echoDateResult" name="echoDateResult"/>
	</operation>
	<operation name="echoFloatArray">
	    <input message="tns:echoFloatArrayRequest" name="echoFloatArray"/>
	    <output message="tns:echoFloatArrayResult" name="echoFloatArrayResult"/>
	</operation>
	<operation name="echoFloat">
	    <input message="tns:echoFloatRequest" name="echoFloat"/>
	    <output message="tns:echoFloatResult" name="echoFloatResult"/>
	</operation>
	<operation name="echoStringArray">
	    <input message="tns:echoStringArrayRequest" name="echoStringArray"/>
	    <output message="tns:echoStringArrayResult" name="echoStringArrayResult"/>
	</operation>
	<operation name="echoIntegerArray">
	    <input message="tns:echoIntegerArrayRequest" name="echoIntegerArray"/>
	    <output message="tns:echoIntegerArrayResult" name="echoIntegerArrayResult"/>
	</operation>
	<operation name="echoStructArray">
	    <input message="tns:echoStructArrayRequest" name="echoStructArray"/>
	    <output message="tns:echoStructArrayResult" name="echoStructArrayResult"/>
	</operation>
	<operation name="echoDecimal">
	    <input message="tns:echoDecimalRequest" name="echoDecimal"/>
	    <output message="tns:echoDecimalResult" name="echoDecimalResult"/>
	</operation>
	<operation name="echoVoid">
	    <input message="tns:echoVoidRequest" name="echoVoid"/>
	    <output message="tns:echoVoidResult" name="echoVoidResult"/>
	</operation>
	<operation name="echoString">
	    <input message="tns:echoStringRequest" name="echoString"/>
	    <output message="tns:echoStringResult" name="echoStringResult"/>
	</operation>
	<operation name="echoInteger">
	    <input message="tns:echoIntegerRequest" name="echoInteger"/>
	    <output message="tns:echoIntegerResult" name="echoIntegerResult"/>
	</operation>
	<operation name="echoBase64">
	    <input message="tns:echoBase64Request" name="echoBase64"/>
	    <output message="tns:echoBase64Result" name="echoBase64Result"/>
	</operation>
    </portType>
    <binding name="InteropTestBinding" type="tns:InteropTestPortType">
	<soap:binding style="rpc" transport="http://schemas.xmlsoap.org/soap/http"/>
	<operation name="echoStruct">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoStruct">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoStructResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoBoolean">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoBoolean">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoBooleanResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoDate">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoDate">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoDateResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoFloatArray">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoFloatArray">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoFloatArrayResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoFloat">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoFloat">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoFloatResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoStringArray">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoStringArray">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoStringArrayResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoIntegerArray">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoIntegerArray">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoIntegerArrayResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoStructArray">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoStructArray">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoStructArrayResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoDecimal">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoDecimal">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoDecimalResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoVoid">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoVoid">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoVoidResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoString">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoString">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoStringResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoInteger">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoInteger">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoIntegerResult">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
	<operation name="echoBase64">
	    <soap:operation soapAction="urn:soapinterop" style="rpc"/>
	    <input name="echoBase64">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </input>
	    <output name="echoBase64Result">
		<soap:body
		    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
		    namespace="http://soapinterop.org/" use="encoded"/>
	    </output>
	</operation>
    </binding>
    <service name="InteropTestService">
	<port binding="tns:InteropTestBinding" name="InteropTestPort">
	    <soap:address location="http://duckbill.boston.amer.iona.com:7002/xmlbus/container/InteropTest/InteropTestService/InteropTestPort/"/>
	</port>
    </service>
</definitions>'
! !

!WSDLIonaInteropTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/WSDLIonaInteropTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
