"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

WSDLReadFuncTests subclass:#WSDLMSExplainedSimpleTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-WSDL-TestCases'
!

WSDLMSExplainedSimpleTest comment:'http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dnwebsrv/html/wsdlexplained.asp'
!


!WSDLMSExplainedSimpleTest methodsFor:'accessing'!

numberOfPorts

	^1
!

numberOfSupportedPorts

	^1
!

supportedPortBaseNames 

	^#('SimplePort')
!

wsdlAddressLocation

	^'http://carlos:8080/FooSample/FooSample.asp'
!

wsdlString

"An example of a WSDL that has a shell types node"

^'<?xml version="1.0" encoding="UTF-8" ?>
<definitions name="FooSample"
targetNamespace="http://tempuri.org/wsdl/"
xmlns:wsdlns="http://tempuri.org/wsdl/"
xmlns:typens="http://tempuri.org/xsd"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
xmlns:stk="http://schemas.microsoft.com/soap-toolkit/wsdl-extension"
xmlns="http://schemas.xmlsoap.org/wsdl/">

<types>
<schema targetNamespace="http://tempuri.org/xsd"   
xmlns="http://www.w3.org/2001/XMLSchema" 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
elementFormDefault="qualified" >
</schema>
</types>

<message name="Simple.foo">
<part name="arg" type="xsd:int"/>
</message>

<message name="Simple.fooResponse">
<part name="result" type="xsd:int"/>
</message>

<portType name="SimplePortType">
<operation name="foo" parameterOrder="arg" >
<input message="wsdlns:Simple.foo"/>
<output message="wsdlns:Simple.fooResponse"/>
</operation>
</portType>

<binding name="SimpleBinding" type="wsdlns:SimplePortType">
<stk:binding preferredEncoding="UTF-8" />
<soap:binding style="rpc" 
	 transport="http://schemas.xmlsoap.org/soap/http"/>
<operation name="foo">
<soap:operation
soapAction="http://tempuri.org/action/Simple.foo"/>
<input>
<soap:body use="encoded" namespace="http://tempuri.org/message/" 
encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
</input>
<output>
<soap:body use="encoded" namespace="http://tempuri.org/message/" 
encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
</output>
</operation>
</binding>

<service name="FOOSAMPLEService">
<port name="SimplePort" binding="wsdlns:SimpleBinding">
<soap:address location="http://carlos:8080/FooSample/FooSample.asp"/>
</port>
</service>
</definitions>'
! !

!WSDLMSExplainedSimpleTest methodsFor:'asserting'!

assertWSDLClientValid: client 
	"See http://msdn.microsoft.com/library/en-us/dnwebsrv/html/wsdlexplained.asp?frame=true#wsdlexplained_topic05"

	| ms xml |
	ms := client send: 'foo' with: 5131953.
	self assertXML: (xml := ms soapOutEnvelope xml)
		isSameAs: '<?xml version="1.0"?>
<SOAP-ENV:Envelope 
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:foo 
    SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" 
    xmlns:m="http://tempuri.org/message/">
<arg xsi:type="xsd:int">5131953</arg>
</m:foo></SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

assertWSDLServiceValid: service 
	"Check the typespace contains the schema"

	| typespace schema foo|
	super assertWSDLServiceValid: service.

	typespace := service typespace.
	schema := typespace schemaTargeting: #'http://tempuri.org/xsd'.
	self assert: service operationPort operations size = 1.

	"checkFooOperation" 
	foo := service operationPort operationNamed: 'foo'.     

	self assert: foo isRPC.
	self assert: foo inputBody isEncoded.
	self assert: foo outputBody isEncoded.  
	self assert: foo soapAction = 'http://tempuri.org/action/Simple.foo'
! !

!WSDLMSExplainedSimpleTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/WSDLMSExplainedSimpleTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
