"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

WSDLMSInteropASMXTests subclass:#WSDLMSInteropRPC
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-WSDL-TestCases'
!


!WSDLMSInteropRPC methodsFor:'accessing'!

checkAddOperation: client
	| ms xml |
	ms := client
				send: 'Add'
				with: 3
				with: 4.
	self assertXML: (xml := ms soapOutEnvelope xml)
		isSameAs: '<?xml version="1.0"?>
<SOAP-ENV:Envelope
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:s="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<SOAP-ENV:Body>
<m:Add
  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:m="http://soapinterop.org">
<a xsi:type="s:int">3</a>
<b xsi:type="s:int">4</b>
</m:Add>
</SOAP-ENV:Body></SOAP-ENV:Envelope>'
!

numberOfPorts

	^1
!

numberOfSupportedPorts

	^1
!

supportedPortBaseNames

	^#('TestSoap')
!

wsdlString

	"MS interop port from;
http://mssoapinterop.org/asmx/Rpc.asmx?WSDL"

^'<?xml version="1.0" encoding="utf-8"?>
<definitions xmlns:s="http://www.w3.org/2001/XMLSchema" xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" xmlns:tm="http://microsoft.com/wsdl/mime/textMatching/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:tns="http://soapinterop.org" targetNamespace="http://soapinterop.org" xmlns="http://schemas.xmlsoap.org/wsdl/">
  <types />
  <message name="AddSoapIn">
    <part name="a" type="s:int" />
    <part name="b" type="s:int" />
  </message>
  <message name="AddSoapOut">
    <part name="AddResult" type="s:int" />
  </message>
  <portType name="TestSoap">
    <operation name="Add">
      <input message="tns:AddSoapIn" />
      <output message="tns:AddSoapOut" />
    </operation>
  </portType>
  <binding name="TestSoap" type="tns:TestSoap">
    <soap:binding transport="http://schemas.xmlsoap.org/soap/http" style="rpc" />
    <operation name="Add">
      <soap:operation soapAction="http://soapinterop.org/Add" style="rpc" />
      <input>
	<soap:body use="encoded" namespace="http://soapinterop.org" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
	<soap:body use="encoded" namespace="http://soapinterop.org" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
  </binding>
  <service name="Test">
    <port name="TestSoap" binding="tns:TestSoap">
      <soap:address location="http://mssoapinterop.org/asmx/Rpc.asmx" />
    </port>
  </service>
</definitions>'
! !

!WSDLMSInteropRPC methodsFor:'asserting'!

assertWSDLClientValid: client

	self checkAddOperation: client
! !

!WSDLMSInteropRPC class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/WSDLMSInteropRPC.st,v 1.3 2008/09/05 16:59:38 cg Exp $'
! !
