"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

SprayTests subclass:#WSDLReadFuncTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-WSDL-TestCases'
!


!WSDLReadFuncTests methodsFor:'accessing'!

getClient
	^self getWSDLPort sprayClient
!

getWSDLDefinitions
	^WSDLDefinitions onDocument: (self rootNodeFor: self wsdlString) transport: nil
!

getWSDLPort
	| node definitions  |
	node := self rootNodeFor: self wsdlString.
	definitions := WSDLDefinitions onDocument: node ownerDocument transport: nil.
	^WSDLPortData onDefinitions: definitions portName: self portName


        
!

isRPC

	^true
!

portName

	^nil
! !

!WSDLReadFuncTests methodsFor:'asserting'!

assertWSDLClientValid: client 
        
!

assertWSDLPortValid: port 
        
!

assertWSDLServiceValid: service 
        
	(self respondsTo: #wsdlAddressLocation)
		ifTrue: [self assert: service destinationUrl  = self wsdlAddressLocation]
! !

!WSDLReadFuncTests methodsFor:'tests'!

testCreatePort
	| wsdlPort port |
	wsdlPort := self getWSDLPort.
	port := wsdlPort createPort.
	self assertWSDLPortValid: port
!

testInfoReportElements
	| wsdlPort ans |
	wsdlPort := self getWSDLPort.
	ans := wsdlPort report.
	self assert: (ans isKindOf: WSDLParseReport).
	self assert: ans information notEmpty
!

testSprayWSDLService
	"create a service"

	| service client |
	service := SprayWSDLService onXmlString: self wsdlString portName: self portName.
	self assertWSDLServiceValid: service.

	"use the service to create a client"
	client := service createClient.
	self assertWSDLClientValid: client
!

testSupportedPortNames
	| defs |
	defs := self getWSDLDefinitions.
	self assert: defs supportedPortQNames size = self numberOfSupportedPorts.
	self assert: defs allPorts size = self numberOfPorts.
	defs supportedPortQNames 
		allSatisfy: [:each | self supportedPortBaseNames includes: each localName]
! !

!WSDLReadFuncTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/WSDLReadFuncTests.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
