"{ Package: 'stx:goodies/soap/wsdl/tests' }"

"{ NameSpace: SOAP }"

SprayTests subclass:#WSDLTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-WSDL-TestCases'
!


!WSDLTests methodsFor:'accessing'!

getApacheDefs
	^WSDLDefinitions onDocument: (self rootNodeFor: self getApacheWSDLString) transport: nil
!

getApacheWSDLString

	^'<?xml version="1.0" ?>
<definitions xmlns:s="http://www.w3.org/2001/XMLSchema" xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" xmlns:tm="http://microsoft.com/wsdl/mime/textMatching/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s0="http://www.soapinterop.org/Bid" targetNamespace="http://www.soapinterop.org/Bid" xmlns="http://schemas.xmlsoap.org/wsdl/">
  <types>
    <s:schema targetNamespace="http://www.soapinterop.org/Bid">
      <s:complexType name="PurchaseOrder">
        <s:sequence>
          <s:element minOccurs="1" maxOccurs="1" name="poID" type="s:string" />
          <s:element minOccurs="1" maxOccurs="1" name="createDate" type="s:dateTime" />
          <s:element minOccurs="1" maxOccurs="1" name="shipTo" type="s0:Address" />
          <s:element minOccurs="1" maxOccurs="1" name="billTo" type="s0:Address" />
          <s:element minOccurs="1" maxOccurs="1" name="items" type="s0:ArrayOfLineItem" />
        </s:sequence>
      </s:complexType>
      <s:complexType name="Address">
        <s:sequence>
          <s:element minOccurs="1" maxOccurs="1" name="name" type="s:string" />
          <s:element minOccurs="1" maxOccurs="1" name="address" type="s:string" />
          <s:element minOccurs="1" maxOccurs="1" name="city" type="s:string" />
          <s:element minOccurs="1" maxOccurs="1" name="state" type="s:string" />
          <s:element minOccurs="1" maxOccurs="1" name="zipCode" type="s:string" />
        </s:sequence>
      </s:complexType>
      <s:complexType name="LineItem">
        <s:sequence>
          <s:element minOccurs="1" maxOccurs="1" name="name" type="s:string" />
          <s:element minOccurs="1" maxOccurs="1" name="quantity" type="s:int" />
          <s:element minOccurs="1" maxOccurs="1" name="price" type="s:decimal" />
        </s:sequence>
      </s:complexType>
      <s:complexType name="ArrayOfLineItem">
        <s:complexContent mixed="false">
          <s:restriction base="soapenc:Array">
            <s:attribute n1:arrayType="s0:LineItem[]" ref="soapenc:arrayType" xmlns:n1="http://schemas.xmlsoap.org/wsdl/" />
          </s:restriction>
        </s:complexContent>
      </s:complexType>
      <s:element name="double" type="s:double" />
      <s:element name="string" nillable="true" type="s:string" />
    </s:schema>
  </types>
  <message name="RequestForQuoteSoapIn">
    <part name="ProductName" type="s:string" />
    <part name="Quantity" type="s:int" />
  </message>
  <message name="RequestForQuoteSoapOut">
    <part name="RequestForQuoteResult" type="s:double" />
  </message>
  <message name="SimpleBuySoapIn">
    <part name="Address" type="s:string" />
    <part name="ProductName" type="s:string" />
    <part name="Quantity" type="s:int" />
  </message>
  <message name="SimpleBuySoapOut">
    <part name="SimpleBuyResult" type="s:string" />
  </message>
  <message name="BuySoapIn">
    <part name="PO" type="s0:PurchaseOrder" />
  </message>
  <message name="BuySoapOut">
    <part name="BuyResult" type="s:string" />
  </message>
  <message name="PingSoapIn" />
  <message name="PingSoapOut" />
  <message name="RequestForQuoteHttpGetIn">
    <part name="ProductName" type="s:string" />
    <part name="Quantity" type="s:string" />
  </message>
  <message name="RequestForQuoteHttpGetOut">
    <part name="Body" element="s0:double" />
  </message>
  <message name="SimpleBuyHttpGetIn">
    <part name="Address" type="s:string" />
    <part name="ProductName" type="s:string" />
    <part name="Quantity" type="s:string" />
  </message>
  <message name="SimpleBuyHttpGetOut">
    <part name="Body" element="s0:string" />
  </message>
  <message name="PingHttpGetIn" />
  <message name="PingHttpGetOut" />
  <message name="RequestForQuoteHttpPostIn">
    <part name="ProductName" type="s:string" />
    <part name="Quantity" type="s:string" />
  </message>
  <message name="RequestForQuoteHttpPostOut">
    <part name="Body" element="s0:double" />
  </message>
  <message name="SimpleBuyHttpPostIn">
    <part name="Address" type="s:string" />
    <part name="ProductName" type="s:string" />
    <part name="Quantity" type="s:string" />
  </message>
  <message name="SimpleBuyHttpPostOut">
    <part name="Body" element="s0:string" />
  </message>
  <message name="PingHttpPostIn" />
  <message name="PingHttpPostOut" />
  <portType name="BidBuySoap">
    <operation name="RequestForQuote">
      <input message="s0:RequestForQuoteSoapIn" />
      <output message="s0:RequestForQuoteSoapOut" />
    </operation>
    <operation name="SimpleBuy">
      <input message="s0:SimpleBuySoapIn" />
      <output message="s0:SimpleBuySoapOut" />
    </operation>
    <operation name="Buy">
      <input message="s0:BuySoapIn" />
      <output message="s0:BuySoapOut" />
    </operation>
    <operation name="Ping">
      <input message="s0:PingSoapIn" />
      <output message="s0:PingSoapOut" />
    </operation>
  </portType>
  <portType name="BidBuyHttpGet">
    <operation name="RequestForQuote">
      <input message="s0:RequestForQuoteHttpGetIn" />
      <output message="s0:RequestForQuoteHttpGetOut" />
    </operation>
    <operation name="SimpleBuy">
      <input message="s0:SimpleBuyHttpGetIn" />
      <output message="s0:SimpleBuyHttpGetOut" />
    </operation>
    <operation name="Ping">
      <input message="s0:PingHttpGetIn" />
      <output message="s0:PingHttpGetOut" />
    </operation>
  </portType>
  <portType name="BidBuyHttpPost">
    <operation name="RequestForQuote">
      <input message="s0:RequestForQuoteHttpPostIn" />
      <output message="s0:RequestForQuoteHttpPostOut" />
    </operation>
    <operation name="SimpleBuy">
      <input message="s0:SimpleBuyHttpPostIn" />
      <output message="s0:SimpleBuyHttpPostOut" />
    </operation>
    <operation name="Ping">
      <input message="s0:PingHttpPostIn" />
      <output message="s0:PingHttpPostOut" />
    </operation>
  </portType>
  <binding name="BidBuySoap" type="s0:BidBuySoap">
    <soap:binding transport="http://schemas.xmlsoap.org/soap/http" style="rpc" />
    <operation name="RequestForQuote">
      <soap:operation soapAction="http://www.soapinterop.org/RequestForQuote" style="rpc" />
      <input>
        <soap:body use="encoded" namespace="http://www.soapinterop.org/Bid" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded" namespace="http://www.soapinterop.org/Bid" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="SimpleBuy">
      <soap:operation soapAction="http://www.soapinterop.org/SimpleBuy" style="rpc" />
      <input>
        <soap:body use="encoded" namespace="http://www.soapinterop.org/Bid" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded" namespace="http://www.soapinterop.org/Bid" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="Buy">
      <soap:operation soapAction="http://www.soapinterop.org/Buy" style="rpc" />
      <input>
        <soap:body use="encoded" namespace="http://www.soapinterop.org/Bid" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded" namespace="http://www.soapinterop.org/Bid" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
    <operation name="Ping">
      <soap:operation soapAction="http://www.soapinterop.org/Ping" style="rpc" />
      <input>
        <soap:body use="encoded" namespace="http://www.soapinterop.org/Bid" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </input>
      <output>
        <soap:body use="encoded" namespace="http://www.soapinterop.org/Bid" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" />
      </output>
    </operation>
  </binding>
  <binding name="BidBuyHttpGet" type="s0:BidBuyHttpGet">
    <http:binding verb="GET" />
    <operation name="RequestForQuote">
      <http:operation location="/RequestForQuote" />
      <input>
        <http:urlEncoded />
      </input>
      <output>
        <mime:mimeXml part="Body" />
      </output>
    </operation>
    <operation name="SimpleBuy">
      <http:operation location="/SimpleBuy" />
      <input>
        <http:urlEncoded />
      </input>
      <output>
        <mime:mimeXml part="Body" />
      </output>
    </operation>
    <operation name="Ping">
      <http:operation location="/Ping" />
      <input>
        <http:urlEncoded />
      </input>
      <output />
    </operation>
  </binding>
  <binding name="BidBuyHttpPost" type="s0:BidBuyHttpPost">
    <http:binding verb="POST" />
    <operation name="RequestForQuote">
      <http:operation location="/RequestForQuote" />
      <input>
        <mime:content type="application/x-www-form-urlencoded" />
      </input>
      <output>
        <mime:mimeXml part="Body" />
      </output>
    </operation>
    <operation name="SimpleBuy">
      <http:operation location="/SimpleBuy" />
      <input>
        <mime:content type="application/x-www-form-urlencoded" />
      </input>
      <output>
        <mime:mimeXml part="Body" />
      </output>
    </operation>
    <operation name="Ping">
      <http:operation location="/Ping" />
      <input>
        <mime:content type="application/x-www-form-urlencoded" />
      </input>
      <output />
    </operation>
  </binding>
  <service name="BidBuy">
    <port name="BidBuySoap" binding="s0:BidBuySoap">
      <soap:address location="http://131.107.72.13/test/bidbuy/bidbuy.asmx" />
    </port>
    <port name="BidBuyHttpGet" binding="s0:BidBuyHttpGet">
      <http:address location="http://131.107.72.13/test/bidbuy/bidbuy.asmx" />
    </port>
    <port name="BidBuyHttpPost" binding="s0:BidBuyHttpPost">
      <http:address location="http://131.107.72.13/test/bidbuy/bidbuy.asmx" />
    </port>
  </service>
</definitions>'

	
	
!

getSample1Defs
	^WSDLDefinitions onDocument: (self rootNodeFor: self getSampleWSDL1) transport: nil
!

getSampleWSDL1
	^self getSampleWSDLFormat formatWith: 
'<types>
<schema targetNamespace="urn:blah1" xmlns="http://www.w3.org/1999/XMLSchema">
  <complexType name="phoneStruct">
    <sequence>
      <element name="areaCode" type="xsd:int"/>
      <element name="exchange" type="xsd:string"/>
      <element name="number" type="xsd:string"/>
    </sequence>
  </complexType>
</schema>
<schema targetNamespace="urn:blah2" xmlns="http://www.w3.org/1999/XMLSchema">
 <complexType name="addressStruct">
    <sequence>
      <element name="streetNum" type="xsd:int"/>
      <element name="streetName" type="xsd:string"/>
      <element name="city" type="xsd:string"/>
      <element name="state" type="xsd:string"/>
      <element name="zip" type="xsd:int"/>
      <element name="phoneNumber" type="ns1:phoneStruct"/>
    </sequence>
  </complexType>
</schema>
</types>'

!

getSampleWSDLFormat
^'<?xml version="1.0"?>
<definitions name="demoService"
			targetNamespace="urn:thisService"
			xmlns="http://schemas.xmlsoap.org/wsdl/"
			xmlns:xsd="http://www.w3.org/1999/XMLSchema"
			xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
			xmlns:tns="urn:thisService"
			xmlns:ns1="urn:blah1"
			xmlns:ns2="urn:blah2">

%1

<message name="myMessageRequest">
  <part name="aName" type="ns2:addressStruct"/>
</message>
<message name="myMessageResponse">
  <part name="aName" type="xsd:boolean"/>
</message>

<message name="myPartNamesMIn">
  <part name="part1" type="xsd:string"/>
  <part name="part2" type="xsd:string"/>
  <part name="part3" type="xsd:string"/>
  <part name="part4" type="xsd:string"/>
</message>
<message name="myPartNamesMOut">
  <part name="part1" type="xsd:string"/>
  <part name="part2" type="xsd:string"/>
  <part name="part3" type="xsd:string"/>
  <part name="part4" type="xsd:string"/>
</message>

<portType name="myPortType">
  <operation name="myOperation1">
    <input  message="tns:myMessageRequest" name="myMessage"/>
    <output message="tns:myMessageResponse" name="myMessageResponse"/>
  </operation>

  <operation name="myPartNamesOperation">
    <input  message="tns:myPartNamesMIn" />
    <output message="tns:myPartNamesMOut" />
  </operation>

 </portType>

<binding name="myBinding" type="tns:myPortType">
  <soap:binding style="rpc" transport="http://schemas.xmlsoap.org/soap/http"/>
  <operation name="myOperation1">
    <soap:operation soapAction="urn:demoService#myMessage"/>
    <input><soap:body use="encoded" namespace="urn:myPortNamespace"     
                 encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/></input>
    <output><soap:body use="encoded" namespace="urn:myPortNamespace" 
                 encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/></output>
  </operation>

  <operation name="myPartNamesOperation">
    <soap:operation soapAction="urn:demoService#myMessage"/>
    <input><soap:body parts="part1 part2" use="encoded" namespace="urn:myPortNamespace"     
                 encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/></input>
    <output><soap:body parts="part1 part2 part3 part4" use="encoded" namespace="urn:myPortNamespace" 
                 encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/></output>
  </operation>

</binding>

<service name="demoService">
  <port name="myPort" binding="tns:myBinding">
    <soap:address location="http://www.dolphinharbor.org/service"/>
  </port>
</service>
</definitions>'.

	

!

getSampleWSDLHeaders
^'<?xml version="1.0"?>
<definitions name="InteropTest" targetNamespace="http://soapinterop.org/" xmlns="http://schemas.xmlsoap.org/wsdl/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:tns="http://soapinterop.org/" xmlns:s="http://soapinterop.org/xsd" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">

	<message name="echoHeaderString_Request">
		<part name="echoMeStringRequest" type="xsd:string"/>
	</message>
	<message name="echoHeaderString_Response">
		<part name="echoMeStringResponse" type="xsd:string"/>
	</message>
	<message name="echoHeaderStruct_Request">
		<part name="echoMeStructRequest" type="s:SOAPStruct"/>
	</message>
	<message name="echoHeaderStruct_Response">
		<part name="echoMeStructResponse" type="s:SOAPStruct"/>
	</message>

	<message name="echoVoidRequest"/>
	<message name="echoVoidResponse"/>

	<portType name="InteropTestPortType">
		<operation name="echoVoid">
			<input message="tns:echoVoidRequest"/>
			<output message="tns:echoVoidResponse"/>
		</operation>
	</portType>


	<binding name="InteropEchoHeaderBinding" type="tns:InteropTestPortType">
		<soap:binding style="rpc" transport="http://schemas.xmlsoap.org/soap/http"/>
		<operation name="echoVoid">
			<soap:operation soapAction="http://soapinterop.org/"/>
			<input>
				<soap:body use="encoded" namespace="http://soapinterop.org/" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
				<soap:header use="encoded" message="tns:echoHeaderString_Request" part="echoMeStringRequest" namespace="http://soapinterop.org/echoheader/" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
				<soap:header use="encoded" message="tns:echoHeaderStruct_Request" part="echoMeStructRequest" namespace="http://soapinterop.org/echoheader/" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
			</input>
			<output>
				<soap:body use="encoded" namespace="http://soapinterop.org/" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
				<soap:header use="encoded" message="tns:echoHeaderString_Response" part="echoMeStringResponse" namespace="http://soapinterop.org/echoheader/" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
				<soap:header use="encoded" message="tns:echoHeaderStruct_Response" part="echoMeStructResponse" namespace="http://soapinterop.org/echoheader/" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
			</output>
		</operation>
	</binding>
<service name="interopLabEchoHeader">

  		<port name="interopPortEchoHdr" binding="tns:InteropEchoHeaderBinding">
    			<soap:address location="http://www.whitemesa.net/interop/std/echohdr"/>
  		</port>

	</service>

</definitions>'.

	

!

getSampleWSDLNamedOpNodes
^'<?xml version="1.0" encoding="UTF-8"?>
<definitions name="InteropTestService"
    targetNamespace="http://soapinterop.org/"
    xmlns="http://schemas.xmlsoap.org/wsdl/"
    xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
    xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
    xmlns:tns="http://soapinterop.org/"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:xsd1="http://soapinterop.org/xsd" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
    <types>
    </types>
    <message name="echoStringRequest">
        <part name="inputString" type="xsd:string"/>
    </message>
    <message name="echoStringResult">
        <part name="return" type="xsd:string"/>
    </message>

    <portType name="InteropTestPortType">
        <operation name="echoString">
            <input message="tns:echoStringRequest" name="echoString"/>
            <output message="tns:echoStringResult" name="echoStringResult"/>
        </operation>
    </portType>

    <binding name="InteropTestBinding" type="tns:InteropTestPortType">
        <soap:binding style="rpc" transport="http://schemas.xmlsoap.org/soap/http"/>
        <operation name="echoString">
            <soap:operation soapAction="urn:soapinterop" style="rpc"/>
            <input name="echoString">
                <soap:body
                    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
                    namespace="http://soapinterop.org/" use="encoded"/>
            </input>
            <output name="echoStringResult">
                <soap:body
                    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"
                    namespace="http://soapinterop.org/" use="encoded"/>
            </output>
        </operation>
    </binding>

    <service name="InteropTestService">
        <port binding="tns:InteropTestBinding" name="InteropTestPort">
            <soap:address location="http://duckbill.boston.amer.iona.com:7002/xmlbus/container/InteropTest/InteropTestService/InteropTestPort/"/>
        </port>
    </service>
</definitions>
'.

	

!

getSampleWSDLNoTypes
	^self getSampleWSDLFormat formatWith: ''
!

getSampleWSDLNonSchemaTypes
	^self getSampleWSDLFormat formatWith: 
'<types>
<myOwnTypes/>
</types>'

!

getStockQuoteDefs
	^WSDLDefinitions onUrl: 'http://example.com/stockquote/stockquoteservice.wsdl'
		transport: self getStockQuoteLocalTransport
!

getStockQuoteLocalTransport
	"changed    <port name='StockQuotePort' binding='tns:StockQuoteBinding'>
to  <port name='StockQuotePort' binding='tns:StockQuoteSoapBinding'>"

	| transport |
	transport := SptHTTPLocalTransport new.
	transport localDocuments at: 'http://example.com/stockquote/stockquoteservice.wsdl'
		put: 
'<?xml version="1.0"?>
<definitions name="StockQuote"
targetNamespace="http://example.com/stockquote/service"
          xmlns:tns="http://example.com/stockquote/service"
          xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
          xmlns:defs="http://example.com/stockquote/definitions"
          xmlns="http://schemas.xmlsoap.org/wsdl/">
   <import namespace="http://example.com/stockquote/definitions"
           location="http://example.com/stockquote/stockquote.wsdl"/>
    <binding name="StockQuoteSoapBinding" type="defs:StockQuotePortType">
        <soap:binding style="document" transport="http://schemas.xmlsoap.org/soap/http"/>
        <operation name="GetLastTradePrice">
           <soap:operation soapAction="http://example.com/GetLastTradePrice"/>
           <input>
               <soap:body use="literal"/>
           </input>
           <output>
               <soap:body use="literal"/>
           </output>
        </operation>
    </binding>
    <service name="StockQuoteService">
        <documentation>My first service</documentation>
        <port name="StockQuotePort" binding="tns:StockQuoteSoapBinding">
           <soap:address location="http://example.com/stockquote"/>
        </port>
    </service>
</definitions>'.
	transport localDocuments at: 'http://example.com/stockquote/stockquote.wsdl'
		put: 
'<?xml version="1.0"?>
<definitions name="StockQuote"

targetNamespace="http://example.com/stockquote/definitions"
          xmlns:tns="http://example.com/stockquote/definitions"
          xmlns:xsd1="http://example.com/stockquote/schemas"
          xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
          xmlns="http://schemas.xmlsoap.org/wsdl/">

   <import namespace="http://example.com/stockquote/schemas"
           location="http://example.com/stockquote/stockquote.xsd"/>

    <message name="GetLastTradePriceInput">
        <part name="body" element="xsd1:TradePriceRequest"/>
    </message>

    <message name="GetLastTradePriceOutput">
        <part name="body" element="xsd1:TradePrice"/>
    </message>

    <portType name="StockQuotePortType">
        <operation name="GetLastTradePrice">
           <input message="tns:GetLastTradePriceInput"/>
           <output message="tns:GetLastTradePriceOutput"/>
        </operation>
    </portType>
</definitions>'.
	transport localDocuments at: 'http://example.com/stockquote/stockquote.xsd'
		put: 
'<?xml version="1.0"?>
<schema targetNamespace="http://example.com/stockquote/schemas"
       xmlns="http://www.w3.org/2000/10/XMLSchema">
       
    <element name="TradePriceRequest">
        <complexType>
            <all>
                <element name="tickerSymbol" type="string"/>
            </all>
        </complexType>
    </element>
    <element name="TradePrice">
        <complexType>
            <all>
                <element name="price" type="float"/>
            </all>
        </complexType>
    </element>
</schema>'.
	^transport
! !

!WSDLTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/wsdl/tests/WSDLTests.st,v 1.4 2008/09/07 15:57:47 cg Exp $'
! !
