"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeClassWriter subclass:#XeClassBuilder
	instanceVariableNames:'generatedClass'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

!XeClassBuilder class methodsFor:'documentation'!

documentation
"
    generates a class directly (without intermediate code)
"
! !

!XeClassBuilder class methodsFor:'initialization'!

initialize
	"
	self initialize
	"

	ChunkTerminator := $!!
! !

!XeClassBuilder class methodsFor:'instance creation'!

generateClassFor: aXeContent
	^self generateClassFor: aXeContent on: String writeStream
!

generateClassFor: aXeContent on: aWriteStream 
	| instance |
	(instance := self new )
		stream: aWriteStream; 
		yourself.
	instance generateClassFor: aXeContent.
	^instance
! !

!XeClassBuilder methodsFor:'accessing'!

chunkContents
        self shouldNeverBeSent
!

generatedClass
        ^ generatedClass
! !

!XeClassBuilder methodsFor:'initializing-private'!

initializeStream
    "/ intentionally left blank
! !

!XeClassBuilder methodsFor:'writing-private'!

beginChunk
        "/ intentionally left blank
!

emitClassDefinition
    |superClass|

    superClass := Smalltalk classNamed:self genSuperclassName.

    generatedClass := superClass 
        subclass: (self genClassName asSymbol)
        instanceVariableNames: (self instanceVariableNameString)
        classVariableNames: ''
        poolDictionaries: ''
        category:'uncategorized'
!

emitGetterFor: aString
        generatedClass compile:(self codeForGetterFor: aString)
!

emitGetterFor: aString returnTypeName: argName
        generatedClass compile:(self codeForGetterFor: aString returnTypeName: argName)

    "Created: / 19-03-2012 / 19:26:42 / cg"
!

emitSetterFor: aString
        generatedClass compile:(self codeForSetterFor: aString)
!

emitSetterFor: aString argumentName: argName
        generatedClass compile:(self codeForSetterFor: aString argumentName: argName)

    "Created: / 19-03-2012 / 17:52:07 / cg"
!

emitSprayElementsMethod
        generatedClass class compile:(self codeForSprayElementsMethod)
!

newLine
        "/ intentionally left blank
!

nextChunkPut: aString 

	self emitString: aString.
	self beginChunk.
	^aString
!

startMethodsFor:category
        "/ intentionally left blank
! !

!XeClassBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/SOAP__XeClassBuilder.st,v 1.5 2012/03/19 20:11:39 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/SOAP__XeClassBuilder.st,v 1.5 2012/03/19 20:11:39 cg Exp $'
! !

XeClassBuilder initialize!
