"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeCompositeParticle subclass:#XeAny
	instanceVariableNames:'anyTypeElement'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeAny methodsFor:'accessing'!

accessContent
	^anyTypeElement accessContent
! !

!XeAny methodsFor:'accessing-private'!

xeChildren
	^Array with: anyTypeElement
! !

!XeAny methodsFor:'initializing'!

createWithEncodingStyle: anEncodingStyle 
	anyTypeElement := (anEncodingStyle anyElementNamed: 'any') beWild
! !

!XeAny methodsFor:'matching'!

selectElementForNode: aXeNode
	| newAnyType |
	(newAnyType := anyTypeElement copy) isFormQualified 
		ifTrue: [newAnyType qName: aXeNode qName]
		ifFalse: [newAnyType qName: (XeQName null: aXeNode localName)].
	^newAnyType
!

selectMatchingNodeFrom: aComplexNodeTable
	aComplexNodeTable nodeTable size ~= 1 
		ifTrue: [self error: 'Can not resolve the any wildcard'].
	^aComplexNodeTable firstNode
! !

!XeAny methodsFor:'testing'!

isWild
	"Answer if the receiver matches all nodes"

	^true
! !

!XeAny methodsFor:'visitor'!

decode: aXeSoapXMLReader
	"Answer the <Object> decoded from the aXeSoapXMLReader "

	^aXeSoapXMLReader decodeChoiceElement: self
! !

!XeAny class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeAny.st,v 1.5 2010/06/14 10:56:31 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeAny.st,v 1.5 2010/06/14 10:56:31 cg Exp $'
! !
