"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeParticleAbstract subclass:#XeAnyAttribute
	instanceVariableNames:'encodingStyle'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeAnyAttribute methodsFor:'accessing-private'!

encodingStyle
	"Answer the XeEncodingStyle the receiver was created in"

	^encodingStyle
!

encodingStyle: aXeEncodingStyle
	encodingStyle := aXeEncodingStyle
! !

!XeAnyAttribute methodsFor:'modes'!

beAttributesKeyedAccessor
! !

!XeAnyAttribute methodsFor:'operations'!

createWithEncodingStyle: anEncodingStyle 
	encodingStyle := anEncodingStyle
	
! !

!XeAnyAttribute methodsFor:'testing'!

isFixed
	^false
! !

!XeAnyAttribute methodsFor:'visitor'!

declareLocallyUsing: aXeSchemaWriter
	"Tell the <XeSchemaWriter> to add a local anyAttribute declaration for the receiver"

	aXeSchemaWriter declareAnyAttribute: self
!

decode: aXeSoapXMLReader
	"Answer the <Object> decoded from the aXeSoapXMLReader "

	^aXeSoapXMLReader decodeAnyAttribute: self
!

encodeChildValueFrom: aXeQStruct writer: aXeSoapXMLWriter
	#todo.  "this will only encode <XeQStruct>s (should it work with the SprayClassFactory?)
		-might need to store objectAccessor
		-see XeSoapXMLReader>>decodeAnyAttribute for reverse problem"
	aXeQStruct attributes 
		associationsDo: [:each | aXeSoapXMLWriter encode: each inAnyAttribute: self]
! !

!XeAnyAttribute class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeAnyAttribute.st,v 1.4 2003/10/08 17:46:12 cg Exp $'
! !
