"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeContentAbstract subclass:#XeAnyContent
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeAnyContent comment:'I am a content component that uses reflection to encode. I belong to a XeAnyElement. My type is xsd:anyType
'
!


!XeAnyContent methodsFor:'accessing'!

typeName
	typeName isNil ifTrue: [typeName := self defaultTypeName].
	^typeName
! !

!XeAnyContent methodsFor:'accessing-private'!

defaultTypeName
	^self typespace anyTypeName
!

elementClass
	^XeAnyTypeElement
! !

!XeAnyContent methodsFor:'operations'!

convertToObject: text
	^text
!

convertValue: anObject
	"Create a <XeContent> for anObject and use it to convert anObject into text"

	^(anObject sprayTypeName xeContentWith: self encodingStyle) convertValue: anObject
! !

!XeAnyContent methodsFor:'testing'!

isAnyContent
	^true
! !

!XeAnyContent methodsFor:'visitor'!

acceptVisitor: aContentVisitor
	^aContentVisitor acceptAny: self
! !

!XeAnyContent class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeAnyContent.st,v 1.4 2003/10/08 17:45:01 cg Exp $'
! !
