"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeValueAbstract subclass:#XeAnyValue
	instanceVariableNames:'text'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Core'
!

XeAnyValue comment:'I can be used to encode any text, and I am answered if a XeValueRangeError exception is resumed'
!


!XeAnyValue class methodsFor:'instance creation'!

text: aString typeName: aXeQName 
	^self new
		text: aString;
		typeName: aXeQName;
		yourself
! !

!XeAnyValue class methodsFor:'must strip'!

example
        <resource: #example>

        | typespace node |
        node := XeEnvironment 
                                rootNodeFor: '<float xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema" xsi:type="xsd:double">NaN</float>'.
        typespace := (self class environment at: #XeTypespace) defaultSoapEnc2001.
        "Setting this option will enable resuming XeValueRangeError exceptions"
        typespace options beConvertAllValues.
        ^typespace soapEncStyle decodeInstanceNode: node
! !

!XeAnyValue methodsFor:'accessing'!

text
	^text
!

text: aString
	text := aString
! !

!XeAnyValue methodsFor:'comparing'!

= aXeAnyValue
	^self species == aXeAnyValue species 
		and: [text = aXeAnyValue text
		and: [typeName = aXeAnyValue typeName]]
!

hash
	^text hash bitXor: typeName hash
! !

!XeAnyValue methodsFor:'displaying'!

displayOn: aStream
        aStream 
                nextPutAll: 'Value= ';
                nextPutAll: self text printString "displayString";
                nextPutAll: ' Type= ';
                nextPutAll: self typeName printString "displayString".
! !

!XeAnyValue methodsFor:'splash'!

putSplashOn: aXeNode context: aSplashContext
	self putSplashContentOn: aXeNode context: aSplashContext.
	self typeName notNil ifTrue: [
		self putSplashTypeOn: aXeNode context: aSplashContext]
	
! !

!XeAnyValue methodsFor:'spray'!

schemaDisplayString
	"Default to the displayString"
	#swAdded.
	^self text
!

xmlEncodeUsing: aNodeEncoding 
	aNodeEncoding currentNode addTextNode: self text.
	(self typeName notNil and: [aNodeEncoding currentElement isTyped]) 
		ifTrue: [aNodeEncoding currentNode setAttribute: 'xsi:type' qName: self typeName].
	^true
! !

!XeAnyValue class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeAnyValue.st,v 1.6 2008/09/07 18:29:02 cg Exp $'
! !
