"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeContentAbstract subclass:#XeArrayContent
	instanceVariableNames:'childElement'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeArrayContent comment:'I am a content component that can encode multiple nodes using the same element component. '
!


!XeArrayContent methodsFor:'accessing'!

childElement
	"Answer the single <XeElements> the receiver uses for all its child nodes/objects"

	^childElement
!

childElement: aXeElement
	childElement := aXeElement
!

childElements
	"Answer a collection of <XeElements>"

	^Array with: self childElement
! !

!XeArrayContent methodsFor:'accessing-private'!

childTypeName
	"Answer a <XeQName>"

	^self childElement content typeName
! !

!XeArrayContent methodsFor:'operations'!

complexExtensionNamed: aXeQName with: aColl1 with: aColl2
	self error: 'Complex extension of a type that is mapped to Array not supported'
! !

!XeArrayContent methodsFor:'testing'!

isArrayContent
    ^ true
! !

!XeArrayContent methodsFor:'visitor'!

acceptVisitor: aContentVisitor
	^aContentVisitor acceptArray: self
! !

!XeArrayContent class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeArrayContent.st,v 1.5 2010/03/15 22:47:46 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeArrayContent.st,v 1.5 2010/03/15 22:47:46 cg Exp $'
! !
