"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeSpecification subclass:#XeAttributeSpec
	instanceVariableNames:'use fixed default'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeAttributeSpec comment:'I model the information of a XMLSchema attribute declaration. 

I describe and can create a <XeAttribute>. 

==========
Implementation Note

Attributes are not used in soap-enc. Spray''s support for attributes is limited.

==========
Instance Variables:
	use     <String>        (optional | prohibited | required) 
	fixed   <String>
	default <String>
'
!


!XeAttributeSpec methodsFor:'accessing'!

attributeClass
	^self isFixed
		ifTrue: [XeFixedAttribute]
		ifFalse: [XeAttribute]
!

attributeName
	^qName
!

default
	^default
!

default: anObject
	default := anObject
!

fixed
	^fixed
!

fixed: aString
	fixed := aString
!

use
	^use
!

use: aString
	use := aString
! !

!XeAttributeSpec methodsFor:'attribute creation'!

attributeWith: anEncodingStyle 
	^anEncodingStyle attributeSpeced: self
! !

!XeAttributeSpec methodsFor:'testing'!

isFixed
	^fixed notNil
! !

!XeAttributeSpec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeAttributeSpec.st,v 1.4 2003/10/08 17:44:00 cg Exp $'
! !
