"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeObjectAccessor subclass:#XeAttributesKeyedAccessor
	instanceVariableNames:'selector keyedAccessor'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeAttributesKeyedAccessor comment:'I am used by a XeNamedParticle to access child values from a parent object.

I am specialized for accessing attributes from a XeQStruct instance'
!


!XeAttributesKeyedAccessor methodsFor:'accessing-private'!

keyedAccessor
	keyedAccessor isNil ifTrue: [keyedAccessor := XeKeyedAccessor new component: component].
	^keyedAccessor
!

selector
	selector isNil ifTrue: [selector := #attributes].
	^selector
!

selector: aSymbol
	selector := aSymbol
! !

!XeAttributesKeyedAccessor methodsFor:'operations'!

getValueFrom: anObject
	^self keyedAccessor getValueFrom: (self parentFrom: anObject)
!

setValue: aString into: anObject
	self keyedAccessor setValue: aString into: (self parentFrom: anObject)
! !

!XeAttributesKeyedAccessor methodsFor:'operations-private'!

parentFrom: anObject
	^anObject perform: self selector
! !

!XeAttributesKeyedAccessor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeAttributesKeyedAccessor.st,v 1.4 2003/10/08 17:43:46 cg Exp $'
! !
