"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: YAXO }"

XeXMLNodeAbstract subclass:#XeBAttributes
	instanceVariableNames:'table node'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-YAXO-Nodes'
!

XeBAttributes comment:'I am the attributes of a  XeBNode.'
!


!XeBAttributes class methodsFor:'instance creation-private'!

for: aXeNode
	^self new setNode: aXeNode
! !

!XeBAttributes methodsFor:'accessing-private'!

getAttribute: aString 
	"Private - Semantics of MSXML getAttribute"

	^self table at: aString ifAbsent: []
!

getAttribute: aString in: aNSSymbol ifNone: aBlockClosure 
	self assert: [aNSSymbol class == Symbol].

	self table keysAndValuesDo: [ :k :v | | split |
		split := k xmlSplit.
		(split second = aString 
			and: [split first notNil
			and: [(node namespaceFor: split first) = aNSSymbol ]])
				ifTrue: [^v]].
	^aBlockClosure value
!

keys
	^table keys
!

setAttribute: aString value: aString2 
	"Private - Semantics of MSXML setAttribute:value:"
	
	self assert: [aString class == String].
	self assert: [aString2 isKindOf: String].
	self table at: aString put: aString2 asString
!

setNode: anElementNode
	node := anElementNode
!

table
        table isNil ifTrue: [
            "/ cg: changed from LookupTable
            "/ table := LookupTable new
            table := Dictionary new
        ].
        ^table
! !

!XeBAttributes methodsFor:'converting-private'!

asQualifiedCollection
        | coll |
        coll := OrderedCollection new.
        self table keysAndValuesDo: [ :k :v | 
                coll add: ((k includes: $:)
                        ifTrue: [node makeQName: k]
                        ifFalse: [SOAP::XeQName null: k]) -> v].
        ^coll
! !

!XeBAttributes methodsFor:'copying-private'!

postCopy
	super postCopy.
	table := table copy.
! !

!XeBAttributes methodsFor:'enumerating-private'!

keysAndValuesDo: aBlockClosure
	^self table keysAndValuesDo: aBlockClosure
! !

!XeBAttributes methodsFor:'printing-private'!

printXMLOn: aStream cr: anObject
	self table keysAndValuesDo: 
			[:k :v | 
			aStream
				space;
				display: k;
				nextPut: $=;
				nextPut: $";
				display: v;
				nextPut: $"]
! !

!XeBAttributes methodsFor:'removing-private'!

removeAttribute: aString 
	

	self table removeKey: aString
! !

!XeBAttributes methodsFor:'testing-private'!

includesKey: aString
	^self table includesKey: aString
! !

!XeBAttributes class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeBAttributes.st,v 1.6 2010/02/26 10:58:19 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeBAttributes.st,v 1.6 2010/02/26 10:58:19 cg Exp $'
! !
