"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: YAXO }"

XeXMLNodeAbstract subclass:#XeBText
	instanceVariableNames:'parentNode text'
	classVariableNames:'EscapeTable'
	poolDictionaries:''
	category:'XML-YAXO-Nodes'
!

XeBText comment:'I am CharacterData of a XeNode'
!


!XeBText class methodsFor:'initialization'!

initialize
	"
	self initialize
	"

	EscapeTable := IdentityDictionary new.
	EscapeTable
		at: $& put: '&amp;';
		at: $< put: '&lt;';
		at: $> put: '&gt;'
! !

!XeBText class methodsFor:'instance creation'!

insert: aString 
	^self new text: aString 
!

string: aString
	^self new string: aString
!

text: aString 
	^self new setText: aString
! !

!XeBText class methodsFor:'helpers'!

escape: aString
	^aString copyExpanding: EscapeTable
! !

!XeBText class methodsFor:'initializing-private'!

uninitialize
	EscapeTable := nil
! !

!XeBText methodsFor:'accessing-private'!

asASCII
	#todo. "Check the documents encoding, and if UTF-8 do a conversion"
	^text
!

asUTF8
	#todo. "Check the documents encoding, and if ascii do a conversion"
	^text
!

parentNode
	^parentNode
!

parentNode: aXeNode
	parentNode := aXeNode
!

setText: aString
        text := (aString includesAnyOf: '<>&') ifTrue: [self escape: aString] ifFalse: [aString].

"/text = '''abc''' ifTrue:[self halt].
"/text = '' ifTrue:[self halt].
!

string: aString
        text := aString.
"/text = '''abc''' ifTrue:[self halt].
"/text = '' ifTrue:[self halt].
!

text
	^text
!

text: aString
        text := aString.
"/text = '''abc''' ifTrue:[self halt].
"/text = '' ifTrue:[self halt].
! !

!XeBText methodsFor:'helpers-private'!

escape: aString
	^self class escape: aString
! !

!XeBText methodsFor:'printing-private'!

printXMLOn: aWriteStream cr: anObject
	aWriteStream nextPutAll: self text
! !

!XeBText methodsFor:'testing-private'!

isTextNode
	

	^true
! !

!XeBText class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeBText.st,v 1.6 2008/09/03 08:53:55 cg Exp $'
! !

XeBText initialize!
