"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

Object subclass:#XeClassWriter
	instanceVariableNames:'classNameSpace currentContent chunkStream'
	classVariableNames:'ChunkTerminator'
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeClassWriter comment:'Experimental, incomplete and not tested'
!

!XeClassWriter class methodsFor:'documentation'!

documentation
"
    generates code for a class
"
! !

!XeClassWriter class methodsFor:'initialization'!

initialize
	"
	self initialize
	"

	ChunkTerminator := $!!
! !

!XeClassWriter class methodsFor:'instance creation'!

generateClassFor: aXeContent
	^self generateClassFor: aXeContent on: String writeStream
!

generateClassFor: aXeContent on: aWriteStream 
	| instance |
	(instance := self new )
		stream: aWriteStream; 
		yourself.
	instance generateClassFor: aXeContent.
	^instance
!

new
        ^self basicNew initialize
! !

!XeClassWriter methodsFor:'accessing'!

chunkContents
	^chunkStream contents
!

classNameSpace:something
    "generate the target class into that namespace"

    classNameSpace := something.
! !

!XeClassWriter methodsFor:'accessing-private'!

classDefinitionString
        ^
'%1 subclass: #''%2''
        instanceVariableNames: ''%3''
        classVariableNames: ''''
        poolDictionaries: ''''
        classInstanceVariableNames: ''''' 
    formatWith: self genSuperclassName 
    with: self genClassName 
    with: self instanceVariableNameString
!

currentContent
	^currentContent
!

currentContent: anObject
	currentContent := anObject
!

elementNames
	^currentContent childElements collect: [ :each | each localName]
!

genClassName
        |nsPrefix|

        nsPrefix := ''.
        classNameSpace notNil ifTrue:[
            Smalltalk isSmalltalkX ifTrue:[
                nsPrefix := classNameSpace,'::'.
            ] ifFalse:[
                self halt
            ]
        ].
        ^ nsPrefix,(currentContent localName capitalized)
!

genSuperclassName
    ^ (currentContent isArrayContent) 
                    ifTrue:[ 'Array' ]
                    ifFalse:[ 'Object' ].
!

instanceVariableNameString
	| stream |
	stream := String writeStream.
	self elementNames do: [ :each | stream display: each uncapitalized] separatedBy: [stream space].
	^stream contents
!

stream
	^chunkStream
!

stream: anObject
	chunkStream := anObject
! !

!XeClassWriter methodsFor:'initializing-private'!

initialize
        self initializeStream
!

initializeStream
        chunkStream := String writeStream.
! !

!XeClassWriter methodsFor:'operations'!

generateClass
	self emitClassDefinition.
	self emitMethods.
	self emitClassMethods
!

generateClassFor: aXeContent 
	self currentContent: aXeContent.
	self generateClass
! !

!XeClassWriter methodsFor:'writing-private'!

beginChunk
	chunkStream nextPut: ChunkTerminator
!

codeForGetterFor: aString
        ^ String streamContents:[:s |
            s
                display: aString; cr;
                display: '    "Answer the child element value"'; cr;
                cr;
                display: '    ^' , aString uncapitalized]
!

codeForGetterFor: aString returnTypeName: typeName
        ^ String streamContents:[:s |
            s
                display: aString; cr;
                display: ('    "Answer the child element value as ',typeName,'"'); cr;
                cr;
                display: '    ^' , aString uncapitalized]

    "Created: / 19-03-2012 / 19:27:17 / cg"
!

codeForSetterFor: aString
        ^ String streamContents:[:s |
            s
                display: aString , ': anObject'; cr;
                display: '    "Set the child element value"'; cr;
                cr;
                display: '    '; display: aString uncapitalized , ' := anObject']
!

codeForSetterFor: aString argumentName: argName
        ^ String streamContents:[:s |
            s
                display: (aString,': ',argName); cr;
                display: '    "Set the child element value"'; cr;
                cr;
                display: '    '; display: aString uncapitalized , ' := ',argName]

    "Created: / 19-03-2012 / 17:48:50 / cg"
!

codeForSprayChildElement: anElement
        |nsPrefix|

        Smalltalk isSmalltalkX ifTrue:[
            nsPrefix := self class nameSpace name , '::'.
        ] ifFalse:[
            nsPrefix := ''.
        ].

        ^ String streamContents:[:s |
            s
                nextPutAll:'        ';
                display: 'add: (',nsPrefix,'XeElementSpec named: #';
                display: anElement localName.

            (XeNamespace isSchemaNS: anElement content namespace) 
                ifTrue:[
                    s
                        display: ' xsdTyped: ''';
                        print: anElement content localName;
                        display: ''' );'.
                ] ifFalse:[
                    s
                        display: ' typed: ''';
                        print: anElement content localName;
                        display: ''' ns: ''';
                        print: anElement content namespace;
                        display: ''' );'
                ]
        ]
!

codeForSprayElementsMethod
        ^ String streamContents:[:s |
            s
                display: 'sprayElements'; cr;
                display: '    "Public - Answer a collection of elements which are used by a SprayClassFactory to create an XeContent object to encode/decode instances of this class"';
                cr; cr;
                display: '    ^(OrderedCollection new)'.

            self currentContent childElements do: [ :each | 
                s cr.
                s nextPutAll:(self codeForSprayChildElement: each).
            ].
            s cr.
            s display: '        yourself']
!

emitClassDefinition
	self nextChunkPut: self classDefinitionString.
	chunkStream cr;cr.
!

emitClassMethods
        self beginChunk.
        self startMethodsFor:'xml'.
        self newLine.
        self emitSprayElementsMethod.
        self beginChunk.
        self newLine.
!

emitGetterFor: aString
        chunkStream
            nextPutAll:(self codeForGetterFor: aString).
        self beginChunk.
!

emitGetterFor: aString returnTypeName: argName
        chunkStream
            nextPutAll:(self codeForGetterFor: aString returnTypeName: argName).
        self beginChunk.

    "Created: / 19-03-2012 / 19:27:10 / cg"
!

emitMethods
        self beginChunk.
        self startMethodsFor:'accessing'.

        currentContent childElements do: [:eachElement |
            |name typeName argName|

            name := eachElement localName.
            typeName := eachElement content localName asUppercaseFirst.
            argName := 'anObject'.
            argName := typeName article,typeName.

            self newLine.
            self emitGetterFor: name uncapitalized returnTypeName: typeName.
            self newLine.
            self newLine.
            self emitSetterFor: name uncapitalized argumentName: argName.
        ] separatedBy:[
            self newLine.
        ].
        self beginChunk.
        self newLine; newLine.

    "Modified: / 19-03-2012 / 21:08:34 / cg"
!

emitSetterFor: aString
        chunkStream
                nextPutAll:(self codeForSetterFor: aString).
        self beginChunk.
!

emitSetterFor: aString argumentName: argName
        chunkStream
                nextPutAll:(self codeForSetterFor: aString argumentName: argName).
        self beginChunk.

    "Created: / 19-03-2012 / 17:47:05 / cg"
!

emitSprayChildElement: anElement
        chunkStream nextPutAll:(self codeForSprayChildElement: anElement).
!

emitSprayElementsMethod
        chunkStream nextPutAll:(self codeForSprayElementsMethod).
        self beginChunk
!

emitString: aString 
	(aString identityIncludes: ChunkTerminator) 
		ifTrue: 
			[aString do: 
					[:character | 
					chunkStream nextPut: character.
					character == ChunkTerminator ifTrue: [self beginChunk]]]
		ifFalse: [chunkStream nextPutAll: aString].
	^aString
!

newLine
        chunkStream cr.
!

nextChunkPut: aString 

	self emitString: aString.
	self beginChunk.
	^aString
!

startMethodsFor:category
        Smalltalk isSmalltalkX ifTrue:[
            self nextChunkPut: self genClassName , ' class methodsFor:''',category,''''.
        ] ifFalse:[
            self nextChunkPut: self genClassName , ' class methodsFor'.
        ].
        chunkStream cr.
! !

!XeClassWriter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeClassWriter.st,v 1.10 2012/03/19 20:10:45 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeClassWriter.st,v 1.10 2012/03/19 20:10:45 cg Exp $'
! !

XeClassWriter initialize!
