"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeParticleAbstract subclass:#XeCompositeParticle
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeCompositeParticle comment:'This class is a superclass for particles that are implemented as composites.'
!


!XeCompositeParticle methodsFor:'accessing'!

allContent
	| coll |
	coll := OrderedCollection new.
	self xeChildrenDo: [:each | coll addAll: each allContent].
	^coll
!

allObjectAccessors
	| coll |
	coll := OrderedCollection new.
	self xeChildrenDo: [:each | coll addAll: each allObjectAccessors].
	^coll
!

allQNames
	| coll |
	coll := OrderedCollection new.
	self xeChildrenDo: [:each | coll addAll: each allQNames].
	^coll
! !

!XeCompositeParticle methodsFor:'accessing-private'!

xeChildren
	^self subclassResponsibility
! !

!XeCompositeParticle methodsFor:'matching'!

selectElementForNode: aXeNode
	^self subclassResponsibility
!

selectMatchingNodeFrom: aComplexNodeTable
	^self subclassResponsibility
! !

!XeCompositeParticle methodsFor:'modes'!

beAllNotTyped
	"Turn off inline typing for the receiver and all it's children."

	self xeChildrenDo: [:each | each beAllNotTyped]
!

beAllTyped
	"Turn on inline typing for the receiver and all it's children."

	self xeChildrenDo: [:each | each beAllTyped]
!

beEncodeBelow
	"Set the receiver to create a new child node for itself to encode into"

	self xeChildrenDo: [:each | each beEncodeBelow]
!

beFormQualified
	"Set the receiver to be form='qualified' (default is 'unqualified')
	-this controls whether local (to type definitions) elements/attributes should be qualified."

	self xeChildrenDo: [:each | each beFormQualified]
!

beFormUnqualified
	"Set the receiver to be form='unqualified' (default is 'unqualified')
	-this controls whether local (to type definitions) elements/attributes should be qualified."

	self xeChildrenDo: [:each | each beFormUnqualified]
!

beKeyedAccessor
	"Set the receiver to use a <XeKeyedAccessor> to access  values from a parent object"

	self xeChildrenDo: [:each | each beKeyedAccessor]
!

beRootDeclare
	self xeChildrenDo: [:each | each beRootDeclare]
!

beSoapRoot
	self xeChildrenDo: [:each | each beSoapRoot]
!

beTyped
	"Turn on inline typing for the receiver"

	self xeChildrenDo: [:each | each beTyped]
! !

!XeCompositeParticle methodsFor:'modes-private'!

xeChildrenDo: operation
	self xeChildren do: operation
! !

!XeCompositeParticle methodsFor:'operations'!

doXeContents: aBlockClosure
	"Evaluate the block for the receivers XeContent (and all descendant <XeContent>)"

	self xeChildren do: [:each | each doXeContents: aBlockClosure]
! !

!XeCompositeParticle methodsFor:'testing'!

isMultipleOccurs
	^false
! !

!XeCompositeParticle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeCompositeParticle.st,v 1.4 2003/10/08 17:45:48 cg Exp $'
! !
