"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

Object subclass:#XeContentFactory
	instanceVariableNames:'schema'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeContentFactory comment:'I am a factory which creates  XeComponent instances for a qName/encodingStyle. I am wrapped by an instance of XeSchema and located in a XeTypespace by my targetNamespace.

The XeComponent instances that I create model XMLSchema components (ie definitions and declarations). They are used to encode objects,decode xml, and can write their own XMLSchema description.

-I am multiple process safe because I do not change state once created. (Note: certain subclasses do change state, but they are protected by mutex''s)'
!


!XeContentFactory class methodsFor:'constants'!

defaultTargetNamespace
	self subclassResponsibility
!

preferedPrefix

	^''
! !

!XeContentFactory class methodsFor:'helpers'!

qualifyLocal: aBaseString 
        ^SOAP::XeQName 
                prefix: self preferedPrefix
                local: aBaseString
                ns: self defaultTargetNamespace
! !

!XeContentFactory methodsFor:'accessing-private'!

schema
	^schema
!

schema: aXeSchema
	schema := aXeSchema
!

targetNS
	^schema targetNS
!

typespace
	^schema typespace
! !

!XeContentFactory methodsFor:'configuration'!

declare: aLocalElementName ownType: aLocalTypename
	self error: 'Can not add declarations to this schema factory' 
!

mapTypeName: aTypeQName to: aClass
	self error: 'This factory does not support name mapping'
! !

!XeContentFactory methodsFor:'content creation'!

xeContentOf: aTypeQName encStyle: anEncodingStyle
	"Answer a <XeContent>"

	^self subclassResponsibility
! !

!XeContentFactory methodsFor:'exceptions-private'!

errorNotSupported: aTypeQName
	^self error: 'Unsupported type: ' , aTypeQName displayString
! !

!XeContentFactory methodsFor:'helpers'!

qualifyLocal: aString
	^self schema qualifyLocal: aString
!

xsdQualify: aXeName
	^self typespace xsdSchema qualifyLocal: aXeName localName
! !

!XeContentFactory methodsFor:'particle creation'!

xeAttributeDeclared: aXeQName encStyle: anEncodingStyle
	"Answer a <XeAttribute>"

	self error: 'Could not locate attribute declaration for: ' , aXeQName displayString
! !

!XeContentFactory methodsFor:'particle creation-private'!

xeElementDeclared: aXeQName encStyle: anEncodingStyle
	self error: 'Can not create element declaration: ' , aXeQName displayString
! !

!XeContentFactory class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeContentFactory.st,v 1.5 2009/12/08 09:51:33 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeContentFactory.st,v 1.5 2009/12/08 09:51:33 stefan Exp $'
! !
