"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeElementAbstract subclass:#XeElement
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeElement comment:'I am an element component, I model the information in a XMLSchema element declaration



'
!


!XeElement methodsFor:'accessing'!

childElements
	"Answer a collection of <XeElements>
	(This is the childElements of the receivers content)"

	^self content childElements
!

decodedObjectOf: aXeNode
	"Test helper method"

	^(XeSoapXMLReader read: aXeNode element: self) nodeObject
! !

!XeElement methodsFor:'operations'!

putInlineTypeIfNeededOn: node 
	self isTyped ifTrue: [self putXSITypeAttributeOn: node].
	^node
!

putXSITypeAttributeOn: aXeNode
	^self content putXSITypeAttributeOn: aXeNode
! !

!XeElement methodsFor:'testing'!

isAnonymous
	^content isNamed not
! !

!XeElement methodsFor:'visitor'!

decode: aXeSoapXMLReader
	"Answer the <Object> decoded from the aXeSoapXMLReader "

	^aXeSoapXMLReader decodeElement: self
!

encode: anObject writer: aXeSoapXMLWriter
	"Encode anObject into the aXeSoapXMLWriter"

	^aXeSoapXMLWriter encode: anObject inElement: self
! !

!XeElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeElement.st,v 1.4 2003/10/08 17:43:42 cg Exp $'
! !
