"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeObjectAccessor subclass:#XeKeyedAccessor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeKeyedAccessor comment:'I am used by an XeNamedParticle to access child values from a parent object.

I do this by sending #at:/#at:put: with the XeNamedParticle''s qualified name. If absent, I will try the localName as a symbol'
!


!XeKeyedAccessor methodsFor:'accessing-private'!

key
	^self qName
! !

!XeKeyedAccessor methodsFor:'operations'!

getValueFrom: aKeyedObject
        "Answer the value of my key in aKeyedObject. (as a backup try the localName as a symbol so that <Dictionaries> can be encoded)"

    |myName myNameLC|

    myName := self localName asSymbol.
    (aKeyedObject respondsTo:myName) ifTrue:[
        ^ aKeyedObject perform:myName
    ].
    myNameLC := myName asLowercaseFirst asSymbol.
    (aKeyedObject respondsTo:myNameLC) ifTrue:[
        ^ aKeyedObject perform:myNameLC
    ].
    ^aKeyedObject at: self key ifAbsent: [
        aKeyedObject at: myName ifAbsent: [
            aKeyedObject at: myNameLC ifAbsent: []
        ]
    ]

    "Modified: / 20-03-2012 / 18:12:31 / cg"
!

setValue: aChildObject into: aKeyedObject 
        (aKeyedObject respondsTo:(self localName,':') asSymbol) ifTrue:[
            ^ aKeyedObject perform:(self localName,':') asSymbol with:aChildObject
        ].
        aKeyedObject at: self key put: aChildObject
! !

!XeKeyedAccessor methodsFor:'testing-private'!

canAccessParent: anObject
	^anObject includesKey: self key
! !

!XeKeyedAccessor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeKeyedAccessor.st,v 1.7 2012/03/20 18:31:48 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeKeyedAccessor.st,v 1.7 2012/03/20 18:31:48 cg Exp $'
! !
