"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeContentFactory subclass:#XeLocalFactoryAbstract
	instanceVariableNames:'declarations'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeLocalFactoryAbstract comment:'I create XeComponents for objects. Subclasses differ as to how they access the object for its definition.

For convienience, I automatically create a global element declaration for each of my definitions. This is equivalent to the XMLSchema:
	<element name="MyClass" type="MyClass"/>

The #declare:ownType: method can be used to add a global element declaration with a different name to the typeName. (For an example of this see the R3Class1Service class in the "SW Interop R3D" package"

Instance Variables:
	declarations    <Table>'
!


!XeLocalFactoryAbstract methodsFor:'configuration'!

declare: aString ownType: aString2
	"This adds an element declaration for the typeName.
	(by default an element will be declared with the same name as the typeName ... this is useful when implementing dotnet defined services)"

	self declarations at: (self qualifyLocal: aString) put: (self qualifyLocal: aString2)
! !

!XeLocalFactoryAbstract methodsFor:'particle creation'!

xeElementDeclared: aXeQName encStyle: anEncodingStyle
	"Answer a <XeElement>. 
	-This factory automatically declares an element for each type."

	^(XeElementSpec named: aXeQName typeName: (self typeNameFor: aXeQName)) 
		xeParticleWith: anEncodingStyle
! !

!XeLocalFactoryAbstract methodsFor:'particle creation-private'!

declarations
        "/ cg: changed from LookupTable
        declarations isNil ifTrue: [declarations := Dictionary new].
        ^declarations   
!

typeNameFor: aXeQName
	"Answer the <XeQName> typeQName for the element declared with the name aXeQName"

	^(declarations notNil and: [declarations includesKey: aXeQName]) 
		ifTrue: [declarations at: aXeQName]
		ifFalse: [aXeQName]
! !

!XeLocalFactoryAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeLocalFactoryAbstract.st,v 1.6 2010/02/26 10:58:09 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeLocalFactoryAbstract.st,v 1.6 2010/02/26 10:58:09 cg Exp $'
! !
