"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

Object subclass:#XeNodeReadMap
	instanceVariableNames:'topNode table'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Core'
!

XeNodeReadMap comment:'I am a table of nodes and their decoded objects. I am necessary to preserve object identity encoded using soap-enc id/href attributes 

-I am not multiple process safe. I must be used in a single process

Instance Variables:
	topNode	<XeNode>
	table	<Table>'
!


!XeNodeReadMap class methodsFor:'instance creation'!

new
        ^self basicNew initialize
!

on: aNode 
	^self new setTopNode: aNode ownerDocument documentElement
! !

!XeNodeReadMap methodsFor:'accessing'!

atHRef: aString ifAbsent: operation
	^table at: aString ifAbsent: operation

!

atHRef: aString put: operation
	^table at: aString put: operation

!

nodeAt: idString
	"Answer an an XeNode. Search the tree for a node with the id idString"

	^topNode nodeAtId: idString
! !

!XeNodeReadMap methodsFor:'accessing-private'!

setTopNode: aXeNode
	topNode := aXeNode
!

topNode
	^topNode
! !

!XeNodeReadMap methodsFor:'initializing-private'!

initialize
        super initialize.
        "/ cg: changed from LookupTable
        table := Dictionary new
! !

!XeNodeReadMap methodsFor:'operations'!

dereferenceNode: aXeNode
	"Extract the href attribute, and locate the node with the corresponding id attribute"

	| href derefNode |
	href := aXeNode getAttribute: 'href'.
	(derefNode := self nodeAt: (href copyFrom: 2 to: href size)) isNil 
		ifTrue: [self error: 'Could not resolve the href ' , href displayString].
	^derefNode
! !

!XeNodeReadMap class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeNodeReadMap.st,v 1.7 2010/06/14 10:57:53 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeNodeReadMap.st,v 1.7 2010/06/14 10:57:53 cg Exp $'
! !
