"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeComponent subclass:#XeParticleAbstract
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeParticleAbstract comment:'I am a particle component, I model the information for a XMLSchema particle 

==========
Definition
From Section 2.2 at http://www.w3.org/TR/xmlschema-1/ 

"2.2.3.2 A particle is a term in the grammar for element content, consisting of either an element declaration, a wildcard or a model group, together with occurrence constraints" 


'
!


!XeParticleAbstract methodsFor:'accessing'!

allObjectAccessors
	^self subclassResponsibility
!

childElements
	^self error: 'Can not determine childElements'
!

encodingStyle
	"Answer the XeEncodingStyle the particle's XeContent was created in"

	^self accessContent encodingStyle
!

xsiNamespace
	^self typespace xsiNamespace
! !

!XeParticleAbstract methodsFor:'accessing-private'!

accessContent
	^self subclassResponsibility
! !

!XeParticleAbstract methodsFor:'modes'!

beFormQualified
	"Set the receiver to be form='qualified' (default is 'unqualified')
	-this controls whether local (to type definitions) elements/attributes should be qualified."

	^self subclassResponsibility
!

beFormUnqualified
	"Set the receiver to be form='unqualified' (default is 'unqualified')
	-this controls whether local (to type definitions) elements/attributes should be qualified."

	^self subclassResponsibility
!

beKeyedAccessor
	"Set the receiver to use a <XeKeyedAccessor> to access  values from a parent object"

	^self subclassResponsibility
! !

!XeParticleAbstract methodsFor:'operations'!

addNewChildNodeTo: aXeNode
	self error: 'Invalid encoding element'
!

putInlineTypeIfNeededOn: node 
	self error: 'Invalid content encoding element'
!

putXSITypeAttributeOn: aXeNode
	self error: 'Invalid content encoding element'
! !

!XeParticleAbstract methodsFor:'testing'!

isIDHref
	"Answer if the receiver's encodingStyle allows identical objects to be encoded using soap-enc multireferences"

	^self encodingStyle isIDHref
!

isUnnamed
	"Answer if the receiver does not have a name"

	^true
!

isWild
	"Answer if the receiver matches all nodes"

	^false
! !

!XeParticleAbstract methodsFor:'visitor'!

decode: aXeSoapXMLReader
	"Answer the <Object> decoded from the aXeSoapXMLReader "

	^self subclassResponsibility
!

encode: anObject writer: aXeSoapXMLWriter
	"Encode anObject into the aXeSoapXMLWriter"

	^self subclassResponsibility
! !

!XeParticleAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeParticleAbstract.st,v 1.4 2003/10/08 17:42:53 cg Exp $'
! !
