"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

Object subclass:#XeSchemaRestriction
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeSchemaRestriction class methodsFor:'must strip'!

example
        <resource: #example>

        "In this example if you replace the node contents 'abc' with a string that is either too small or large, Spray will signal an (resumable) error."

        | reader typespace |
        typespace := XeTypespace defaultSoapEnc2001.
        typespace 
                addSchemaString: '<schema 
xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
xmlns="http://www.w3.org/2001/XMLSchema" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
targetNamespace="urn:myNS">
<simpleType name="LimitedLenString">
<restriction base="xsd:string">
<maxLength value="50"/>
<minLength value="2"/>
</restriction>
</simpleType>
</schema>'.
        reader := XeSoapXMLReader read: (XeEnvironment 
                                                rootNodeFor: '<a 
xmlns:ns1="urn:myNS" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xsi:type="ns1:LimitedLenString"
>abc</a>')
                                in: typespace.
        ^reader nodeObject
! !

!XeSchemaRestriction methodsFor:'operations'!

validate: anObject 
	self subclassResponsibility
	
! !

!XeSchemaRestriction class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSchemaRestriction.st,v 1.5 2008/09/05 17:45:00 cg Exp $'
! !
