"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeObjectAccessor subclass:#XeSelectorAccessor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeSelectorAccessor comment:'I am used by an XeNamedParticle to access child values from a parent object.

I do this by converting the XeNamedParticle''s localName to a getter and setter. If the localName starts with a capital letter, I will also see if the parent object responds to it uncapitalized'
!


!XeSelectorAccessor methodsFor:'accessing-private'!

alternateGetter
	^self localName uncapitalized asSymbol
!

alternateSetter
	^(self localName uncapitalized , ':') asSymbol
!

getter
	^self localName asSymbol
!

setter
	^(self localName , ':') asSymbol
! !

!XeSelectorAccessor methodsFor:'operations'!

getValueFrom: anObject
	| getter |
	(anObject respondsTo: (getter := self getter))
		ifTrue: [^anObject perform: getter]
		ifFalse: [^anObject perform: self alternateGetter]
!

setValue: aChildObject into: aParentObject
	| setter |
	(aParentObject  respondsTo: (setter :=  self setter))
		ifTrue: [^aParentObject perform: self setter with: aChildObject]
		ifFalse: [^aParentObject perform: self alternateSetter with: aChildObject]


! !

!XeSelectorAccessor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSelectorAccessor.st,v 1.5 2005/04/05 20:59:14 cg Exp $'
! !
