"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeValueAbstract subclass:#XeSimpleValue
	instanceVariableNames:'object attributes'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeSimpleValue class methodsFor:'instance creation'!

new
        ^self basicNew initialize
!

sprayInstanceWith: aContent
	^self new
! !

!XeSimpleValue methodsFor:'accessing'!

attributes
	"Private - Answer the value of the receiver's ''attributes'' instance variable."

	^attributes
!

attributes: aCollection
	attributes := aCollection
!

object
	"Private - Answer the value of the receiver's ''object'' instance variable."

	^object
!

value
	^object
!

value: anObject
	object := anObject
! !

!XeSimpleValue methodsFor:'comparing'!

= aSimpleValue
	^self species == aSimpleValue species
		and: [object = aSimpleValue value
		and: [attributes equals: aSimpleValue attributes]]

!

hash
	^object hash bitXor: attributes hash

! !

!XeSimpleValue methodsFor:'initializing'!

initialize
        super initialize.
        "/ cg: changed from LookupTable
        attributes := Dictionary new.
! !

!XeSimpleValue methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream
		display: '(';
		display: self schemaDisplayString;
		display: ' ';
		display: attributes;
		display: ')'
! !

!XeSimpleValue methodsFor:'spray'!

schemaDisplayString
	^object schemaDisplayString
! !

!XeSimpleValue class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSimpleValue.st,v 1.7 2010/06/14 10:59:39 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSimpleValue.st,v 1.7 2010/06/14 10:59:39 cg Exp $'
! !
