"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeArrayContent subclass:#XeSoapArrayContentAbstract
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeSoapArrayContentAbstract comment:'I am a content component that can encode/decode soap-enc arrays '
!


!XeSoapArrayContentAbstract class methodsFor:'instance creation'!

typeName: aTypeQName childElement: anElement encodingStyle: anEncodingStyle 
	^(self new)
		typeName: aTypeQName;
		childElement: anElement beEncodeBelow;
		encodingStyle: anEncodingStyle;
		yourself
! !

!XeSoapArrayContentAbstract class methodsFor:'accessing'!

soapArrayTypeName
	^XeQName prefix: 'SOAP-ENC'
		local: 'Array'
		ns: XeNamespace soapEnc
! !

!XeSoapArrayContentAbstract methodsFor:'accessing'!

arrayTypeNameFor: aKey 
	| extTypeName |
	extTypeName := self childTypeName.
	^XeQName 
		prefix: extTypeName prefix
		local: extTypeName localName , (self aSizeStringFor: aKey)
		ns: extTypeName namespace
!

baseTypeName
	baseTypeName isNil ifTrue: [baseTypeName := self class soapArrayTypeName].
	^baseTypeName
!

readerClass
	self subclassResponsibility
!

typeName
	typeName isNil ifTrue: [typeName := self class soapArrayTypeName].
	^typeName
! !

!XeSoapArrayContentAbstract methodsFor:'asserting'!

assertAllowKeyedArrays
	self allowKeyedArrays 
		ifFalse: [self error: 'Sparse and Partial arrays are not allowed'].
! !

!XeSoapArrayContentAbstract methodsFor:'constants'!

arrayTypeAttribute
	^XeQName prefix: 'SOAP-ENC'
		local: 'arrayType'
		ns: XeNamespace soapEnc
!

commonAttributeAttribute
	^XeQName prefix: 'SOAP-ENC'
		local: 'commonAttributes'
		ns: XeNamespace soapEnc
!

offsetAttribute
	^XeQName prefix: 'SOAP-ENC'
		local: 'offset'
		ns: XeNamespace soapEnc
!

oneKey
	^self subclassResponsibility
!

positionAttribute
	^XeQName prefix: 'SOAP-ENC'
		local: 'position'
		ns: XeNamespace soapEnc
!

wsdlArrayType
	^self childTypeName copyWithLocalName: self childTypeName localName , self aSizeFormString
!

wsdlArrayTypeAttribute
	^XeQName prefix: 'wsdl'
		local: 'arrayType'
		ns: XeNamespace wsdl
!

zeroKey
	^self subclassResponsibility
! !

!XeSoapArrayContentAbstract methodsFor:'constants-private'!

aSizeFormString
	^self subclassResponsibility
! !

!XeSoapArrayContentAbstract methodsFor:'helpers'!

aSizeStringFor: aNumber
	^self subclassResponsibility
! !

!XeSoapArrayContentAbstract methodsFor:'operations'!

putArrayTypeSize: aNumber on: node 
	node setQAttribute: self arrayTypeAttribute qName: (self arrayTypeNameFor: aNumber)
!

putXSITypeAttributeOn: aXeNode
	self typespaceOptions isXSITypeArrays ifTrue: [super putXSITypeAttributeOn: aXeNode].
	^aXeNode
! !

!XeSoapArrayContentAbstract methodsFor:'testing'!

allowKeyedArrays
	"Answer if the typespace allows use to read soap:Arrays that decode 
	to <KeyedCollection> instances. (see class comment)"

	^self typespaceOptions allowKeyedArrays
! !

!XeSoapArrayContentAbstract class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSoapArrayContentAbstract.st,v 1.4 2003/10/08 17:44:57 cg Exp $'
! !
