"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeContentFactory subclass:#XeSoapEncExtFactory
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeSoapEncExtFactory comment:'I create XeComponents for arrays of the base schema dataTypes.

Notes;
Handles soap definitions extended by the WSDL 1.1 spec 
"WSDL Spec1.1: Array types should extend the Array type defined in the SOAP v1.1 encoding schema (<http://schemas.xmlsoap.org/soap/encoding/>) (regardless of whether the resulting form actually uses the encoding specified in Section 5 of the SOAP v1.1 document). Use the name ArrayOfXXX for array types (where XXX is the type of the items in the array). The type of the items in the array and the array dimensions are specified by using a default value for the soapenc:arrayType attribute. At the time of this writing, the XSD specification does not have a mechanism for specifying the default value of an attribute which contains a QName value. To overcome this limitation, WSDL introduces the arrayType attribute (from namespace http://schemas.xmlsoap.org/wsdl/) which has the semantic of providing the default value. If XSD is revised to support this functionality, the revised mechanism SHOULD be used in favor of the arrayType attribute defined by WSDL. "
'
!


!XeSoapEncExtFactory class methodsFor:'must strip'!

example
        <resource: #example>

        | typespace |
        typespace := XeTypespace defaultSoapEnc2001.

        "Content "
        ^'soapE:ArrayOfstring' asXeName xeContentWith: typespace soapEncStyle
! !

!XeSoapEncExtFactory methodsFor:'content creation'!

xeContentOf: aTypeQName encStyle: anEncodingStyle
	"Answer a <XeContent>
	This is used to create <XeArrayContent> for the XMLSchema base dataTypes "

	^anEncodingStyle arrayWsdl: aTypeQName
! !

!XeSoapEncExtFactory class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSoapEncExtFactory.st,v 1.5 2008/09/05 17:45:29 cg Exp $'
! !
