"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeSoapArrayNodeAbstract subclass:#XeSoapMultiDimArrayNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Core'
!

XeSoapMultiDimArrayNode comment:'I am a soap:Array multidimensional node. Only two dimensions are supported at this stage.'
!


!XeSoapMultiDimArrayNode methodsFor:'asserting-private'!

assertValidSizeString: aString
	(aString isNil or: 
			[aString isEmpty or: 
					[aString first ~= $[ 
						or: [aString last ~= $] or: [((aString select: [:each | each = $,]) size = 1) not]]]]) 
		ifTrue: [self errorAttributeForm]
! !

!XeSoapMultiDimArrayNode methodsFor:'constants'!

oneKey

	^1@1
!

zeroKey
	^0@0
! !

!XeSoapMultiDimArrayNode methodsFor:'exceptions-private'!

errorAttributeForm
	self error: 'Expecting attribute value of the form [,]'
! !

!XeSoapMultiDimArrayNode methodsFor:'helpers'!

extractSize: aString 
	| stream x y |
	self assertValidSizeString: aString.
	stream := aString readStream.
	stream next.
	x := stream upTo: $,.
	y := stream upTo: $].
	^x asNumber @ y asNumber
! !

!XeSoapMultiDimArrayNode methodsFor:'testing'!

isMultiDim
	^true
! !

!XeSoapMultiDimArrayNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSoapMultiDimArrayNode.st,v 1.4 2003/10/08 17:31:42 cg Exp $'
! !
