"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeComplexContent subclass:#XeSoapRPCContent
	instanceVariableNames:'isNoReturnPart'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeSoapRPCContent comment:'I am a content component that can encode/decode complex types that are soap-enc RPCWrappers'
!


!XeSoapRPCContent methodsFor:'accessing'!

firstAccessorKey
	"Answer a <XeQName>"

	^self firstChildElement objectAccessor key
!

firstAccessorKeyOrNil
	"Answer a <XeQName> or nil"

	(self isNoReturnPart or: [self isVoid]) ifTrue: [^nil].
	^self firstAccessorKey
!

isNoReturnPart
	"This can only be determined to be true from  WSDL parameterOrder."

	isNoReturnPart isNil ifTrue: [isNoReturnPart := false].
	^isNoReturnPart
!

isNoReturnPart: aBoolean
	isNoReturnPart := aBoolean
!

readerClass
	^self isNoReturnPart ifTrue: [XeComplexNodeTable] ifFalse: [XeRPCNodeTable]
! !

!XeSoapRPCContent methodsFor:'testing'!

isMultipleAccessors
	^self childElements size > 1
!

isVoid
	^self childElements isEmpty
! !

!XeSoapRPCContent methodsFor:'visitor'!

acceptVisitor: aContentVisitor
	^aContentVisitor acceptSoapComplexRPC: self
! !

!XeSoapRPCContent class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSoapRPCContent.st,v 1.4 2003/10/08 17:43:19 cg Exp $'
! !
