"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeComplexClassAbstract subclass:#XeSprayReadClassFactory
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!

XeSprayReadClassFactory comment:'I am similar to a XeSprayClassFactory except that if I am asked to provide a definition for a class that does not implement #sprayElements, instead of signalling an error, I provide an element which encodes the objects displayString. (which is why I am read-only!!!!)'
!


!XeSprayReadClassFactory class methodsFor:'constants'!

defaultTargetNamespace
	^XeNamespace sprayClass
!

preferedPrefix

	^'d'
! !

!XeSprayReadClassFactory class methodsFor:'others'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSprayReadClassFactory.st,v 1.5 2011/07/12 16:20:30 cg Exp $'
! !

!XeSprayReadClassFactory methodsFor:'helpers-private'!

attributesDefinedFor: actualClass
	"Answer the collection of <XeAttributeSpecs> defined by the class"

	^actualClass sprayAttributes
!

elementsDefinedFor: actualClass
        "Answer the collection of <XeElementSpecs> defined by the class"

        ^[actualClass sprayElements] on: Error
                do: [:e | 
                    UserPreferences current soapErrorDebugging ifTrue:[ e reject ].
                    OrderedCollection with: (XeElementSpec named: #displayString xsd: 'string')
                ]

    "Modified: / 12-07-2011 / 17:54:35 / cg"
! !

!XeSprayReadClassFactory class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeSprayReadClassFactory.st,v 1.5 2011/07/12 16:20:30 cg Exp $'
! !
