"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeXSDDeclaration subclass:#XeXSDAttribute
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeXSDAttribute class methodsFor:'accessing'!

nodeName
	^'attribute'
! !

!XeXSDAttribute methodsFor:'accessing'!

xsdAttributes
	^Array with: self
!

xsdParticles
	^#()
! !

!XeXSDAttribute methodsFor:'accessing-private'!

attributeName
	^self isFormQualified ifTrue: [self nameTQAttribute] ifFalse: [XeQName null: self nameAttribute]
!

defaultAttributeWith: anEncodingStyle 
	^self attributeTyped: self typespace anyTypeName with: anEncodingStyle 
	
!

form
	^node getAttribute: 'form' ifNone: [self xsdSchema attributeFormDefault]
!

refAttributeWith: anEncodingStyle
	^self typespace xeAttributeDeclared: self refQAttribute encStyle: anEncodingStyle
!

typedAttributeWith: anEncodingStyle 
	^self attributeTyped: self node qValueForType with: anEncodingStyle
! !

!XeXSDAttribute methodsFor:'asserting'!

canIgnoreInSoapEnc
	^self isID 
		or: [self isHref
		or: [self  canIgnoreInSoapEncRef]]
	
!

canIgnoreInSoapEncRef
	^self isRef and: [
		(OrderedCollection
			with: (XeQName local: 'actor' ns: XeNamespace soapEnv )
			with: (XeQName local: 'mustUnderstand' ns: XeNamespace soapEnv )) includes: self refQAttribute]
	
! !

!XeXSDAttribute methodsFor:'attribute creation'!

attributeWith: anEncodingStyle
	self isTyped ifTrue: [^self typedAttributeWith: anEncodingStyle].
	self isRef ifTrue: [^self refAttributeWith: anEncodingStyle].
	^self defaultAttributeWith: anEncodingStyle

! !

!XeXSDAttribute methodsFor:'operations-private'!

attributeTyped: aTypeQName with: anEncodingStyle
	| spec |
	spec := XeAttributeSpec named: self attributeName typeName: aTypeQName.
	self setOccurrenceConstraintsInto: spec.
	self setFormInto: spec.
	^spec attributeWith: anEncodingStyle
!

setOccurrenceConstraintsInto: aXeAttributeSpec 
	aXeAttributeSpec use: (self node getAttribute: 'use' ifNone: ['optional']).
	aXeAttributeSpec fixed: (self node getAttribute: 'fixed').
	aXeAttributeSpec default: (self node getAttribute: 'default').
! !

!XeXSDAttribute methodsFor:'testing'!

isHref
	^self nameAttribute = 'href'
!

isID
	^self nameAttribute = 'id'
! !

!XeXSDAttribute class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeXSDAttribute.st,v 1.4 2003/10/08 17:44:16 cg Exp $'
! !
