"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeXSDBaseFactory subclass:#XeXSDBase1999
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeXSDBase1999 class methodsFor:'initialization'!

initialize
	"
	self initialize
	"

	textConverters := self commonTextConverters.
	textConverters at: 'timeInstant' put: XeTextConverter dateTime.
	derivationData := self commonDerivationData
! !

!XeXSDBase1999 class methodsFor:'constants'!

defaultTargetNamespace
	^XeNamespace schema1999
! !

!XeXSDBase1999 class methodsFor:'initializing-private'!

uninitialize
	self clear
! !

!XeXSDBase1999 methodsFor:'accessing'!

anyTypeName
	^self class qualifyLocal: 'ur-type'
! !

!XeXSDBase1999 methodsFor:'content creation'!

xeContentOf: aTypeQName encStyle: anEncodingStyle
	"Answer a <XeContent>
	I am now concentrating on working only with the 2001 schema, but the soap spec uses the 1999 schema.
	This method downgrades typeNames from 2001 names to 1999 names. This is complicated by base64, which
	needs to be shifted to the soap-enc schema"

	| downTypeName |
	downTypeName := self downgradeTypeName: aTypeQName.
	^downTypeName namespace ~~ self targetNS 
		ifTrue: [downTypeName xeContentWith: anEncodingStyle]
		ifFalse: [super xeContentOf: downTypeName encStyle: anEncodingStyle]
! !

!XeXSDBase1999 methodsFor:'helpers-private'!

downgradeTypeName: aTypeQName
	aTypeQName localName = 'dateTime' ifTrue: [^aTypeQName copyWithLocalName: 'timeInstant'].
	aTypeQName localName = 'anyType' ifTrue: [^aTypeQName copyWithLocalName: 'ur-type'].
	aTypeQName localName = 'base64Binary' 
		ifTrue: 
			[^XeQName 
				prefix: 'soap'
				local: 'base64'
				ns: XeNamespace soapEnc].
	^aTypeQName
! !

!XeXSDBase1999 methodsFor:'testing-private'!

isAnyTypeName: aTypeQName
	^aTypeQName localName = 'ur-type'
! !

!XeXSDBase1999 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeXSDBase1999.st,v 1.5 2008/09/03 08:53:07 cg Exp $'
! !

XeXSDBase1999 initialize!
