"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeXSDBaseFactory subclass:#XeXSDBase2001
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeXSDBase2001 class methodsFor:'initialization'!

initialize
	"
	self initialize
	"

	textConverters := self commonTextConverters.
	textConverters
		at: 'base64Binary' put: XeTextConverter base64Binary;
		at: 'dateTime' put: XeTextConverter dateTime.
	derivationData := self commonDerivationData
! !

!XeXSDBase2001 class methodsFor:'constants'!

defaultTargetNamespace
	^XeNamespace schema2001
! !

!XeXSDBase2001 class methodsFor:'initializing-private'!

uninitialize
	self clear
! !

!XeXSDBase2001 class methodsFor:'must strip'!

example
        <resource: #example>

        | typespace |
        typespace := XeTypespace defaultSoapEnc2001.

        "Content from Base Factory"
        ^(XeQName xsd2001: 'string') xeContentWith: typespace soapEncStyle.

        "Same as"
        ^'xsd:string' asXeName xeContentWith: typespace soapEncStyle
! !

!XeXSDBase2001 methodsFor:'accessing'!

anyTypeName
	^self class qualifyLocal: 'anyType'
! !

!XeXSDBase2001 methodsFor:'testing-private'!

isAnyTypeName: aTypeQName
	^aTypeQName localName = 'anyType'
! !

!XeXSDBase2001 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeXSDBase2001.st,v 1.6 2008/09/05 17:45:26 cg Exp $'
! !

XeXSDBase2001 initialize!
