"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeXSDContentModel subclass:#XeXSDComplexContent
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeXSDComplexContent class methodsFor:'instance creation'!

emptyContentFrom: aXMLXSDComplexType 
	^(XeXSDEmptyComplexContent new)
		xsdDefinition: aXMLXSDComplexType;
		setAnyBaseTypeName;
		yourself
! !

!XeXSDComplexContent class methodsFor:'helpers'!

classFor: aXeXSDComplexType
	| derivationNode contentNode |
	self 
		assert: [(contentNode := aXeXSDComplexType contentNode) localName = 'complexContent'].
	derivationNode := contentNode firstChild.
	derivationNode localName = 'restriction' ifTrue: [^XeXSDRestrictionComplexContent].
	derivationNode localName = 'extension' ifTrue: [^XeXSDExtensionComplexContent].
	self error: 'Can not find content derivation node'
! !

!XeXSDComplexContent methodsFor:'accessing-private'!

xsdParticles
	| xsdElements |
	xsdElements := OrderedCollection new.
	self xsdContent do: [:each | xsdElements addAll: each xsdParticles].
	^xsdElements
! !

!XeXSDComplexContent methodsFor:'asserting'!

assertValidSoapEncStruct
	| attributes |
	attributes := self xsdAttributes.
	attributes notEmpty 
		ifTrue: 
			[(attributes anySatisfy: [:each | each canIgnoreInSoapEnc not]) 
				ifTrue: [self error: 'Spray can not use types with declared attributes in soap-enc']]
! !

!XeXSDComplexContent methodsFor:'helpers'!

wsdlArrayAttributeNode
	^self contentNodes detect: 
			[:each | 
			each localName = 'attribute' 
				and: [(each 
						getAttribute: 'arrayType'
						in: XeNamespace wsdl
						ifNone: []) notNil]]
		ifNone: []
! !

!XeXSDComplexContent methodsFor:'operations'!

elementsWith: anEncodingStyle
	^self xsdParticles collect: [:each | each xeParticleWith: anEncodingStyle]
! !

!XeXSDComplexContent class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeXSDComplexContent.st,v 1.4 2003/10/08 17:45:42 cg Exp $'
! !
