"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeXSDDefinitionAbstract subclass:#XeXSDSimpleType
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Schema'
!


!XeXSDSimpleType class methodsFor:'accessing'!

nodeName
	^'simpleType'
! !

!XeXSDSimpleType methodsFor:'accessing'!

restrictions
	| coll |
	coll := OrderedCollection new.
	self addFacetsTo: coll.
	self addEnumerationsTo: coll.
	^coll
! !

!XeXSDSimpleType methodsFor:'accessing-private'!

allChildNodes
	"Private - Children and Children's children etc
	rename?"

	| coll |
	coll := OrderedCollection new.
	self node preOrderElementDo: [ :each |
		coll add: each].
	^coll
! !

!XeXSDSimpleType methodsFor:'asserting-private'!

assertSupported
	(self allChildNodes anySatisfy: [:each | #('union' 'list') includes: each localName]) 
		ifTrue: [self error: 'Unsupported simple type: ' , self nameTQAttribute displayString]
! !

!XeXSDSimpleType methodsFor:'content creation'!

xeContentWith: anEncodingStyle
	"Answer a <XeContent> for the receiver"

	^anEncodingStyle 
		simple: self nameTQAttribute
		restricting: self baseTypeQName
		with: self restrictions
! !

!XeXSDSimpleType methodsFor:'operations-private'!

addEnumerationsTo: anOrderedCollection 
	| nodes |
	nodes := OrderedCollection new.
	self node preOrderElementDo: [:each | each localName = 'enumeration' ifTrue: [nodes add: each]].
	nodes notEmpty ifTrue: [anOrderedCollection add: (XeSchemaEnumeration fromNodes: nodes)]
!

addFacetsTo: anOrderedCollection 
	| rn |
	(rn := self restrictionNode) isNil ifTrue: [^nil].
	^rn childNodes 
		do: [:each | each localName = 'enumeration' ifFalse: [anOrderedCollection add: (XeSchemaFacet fromNode: each)]]
! !

!XeXSDSimpleType class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeXSDSimpleType.st,v 1.4 2003/10/08 17:43:26 cg Exp $'
! !
