"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeXsdDateTimeAbstract subclass:#XeXsdDate
	instanceVariableNames:'date'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Core'
!


!XeXsdDate class methodsFor:'instance creation'!

fromString: aString
        | stream date offset|
        stream := aString readStream.
        date := self readDateSchemaFrom:stream. "/ Date readSchemaFrom: stream.
        offset := self offsetArrayFrom: stream.
        ^self   new
                date: date;
                offset: offset second;
                isPositiveOffset: offset first;
                yourself
! !

!XeXsdDate class methodsFor:'spray'!

sprayTypeName
        ^SOAP::XePName xsd: 'date'
! !

!XeXsdDate methodsFor:'accessing-private'!

date
	^date
!

date: aDate
	date := aDate
! !

!XeXsdDate methodsFor:'converting'!

asNative
	"Note: these classes are a stub. I am hoping that Dolphin5 will contain date/time/timestamp classes that would retain timezone info"

	^self date
! !

!XeXsdDate methodsFor:'printing-private'!

displayOffsetOn: stream 
        "This assumes that the timestamp is UTC"
        #cg.

        self date printUnboundedSchemaStringOn: stream. 
        self isPositiveOffset
                ifTrue: [stream nextPutAll: '+']
                ifFalse: [stream nextPutAll: '-'].

        Smalltalk isSmalltalkX ifTrue:[
            self offset printOn: stream format: '%h:%m'.
        ] ifFalse:[
            self offset printOn: stream format: 'HH:mm'.
        ].
!

displayUTCOn: stream 
	"This assumes that the timestamp is UTC"

	self date printUnboundedSchemaStringOn: stream. 
	stream nextPutAll: 'Z'.

	
! !

!XeXsdDate class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeXsdDate.st,v 1.6 2003/10/08 17:31:34 cg Exp $'
! !
