"{ Package: 'stx:goodies/soap/xe' }"

"{ NameSpace: SOAP }"

XeXsdDateTimeAbstract subclass:#XeXsdTime
	instanceVariableNames:'time'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-Spray-XeEncoding-Core'
!


!XeXsdTime class methodsFor:'instance creation'!

fromString: aString
        | stream time offset|
        stream := aString readStream.
        time := self readTimeSchemaFrom:stream. "/ Time readSchemaFrom: stream.
        offset := self offsetArrayFrom: stream.
        ^self   new
                time: time;
                offset: offset second;
                isPositiveOffset: offset first;
                yourself
! !

!XeXsdTime class methodsFor:'spray'!

sprayTypeName
        ^SOAP::XePName xsd: 'time'
! !

!XeXsdTime methodsFor:'accessing-private'!

time
	^time
!

time: aTime
	time := aTime
! !

!XeXsdTime methodsFor:'converting'!

asNative
	^self time
! !

!XeXsdTime methodsFor:'printing-private'!

displayOffsetOn: stream 
        "This assumes that the timestamp is UTC"

        #cg.

        Smalltalk isSmalltalkX ifTrue:[
            self time printOn: stream format: '%h:%m:%s'.
        ] ifFalse:[
            self time printOn: stream format: 'HH:mm:ss'.
        ].
        self isPositiveOffset
                ifTrue: [stream nextPutAll: '+']
                ifFalse: [stream nextPutAll: '-'].
        Smalltalk isSmalltalkX ifTrue:[
            self offset printOn: stream format: '%h:%m'.
        ] ifFalse:[
            self offset printOn: stream format: 'HH:mm'.
        ]
!

displayUTCOn: stream 
        "This assumes that the timestamp is UTC"

        #cg.

        Smalltalk isSmalltalkX ifTrue:[
            self time printOn: stream format: '%h:%m:%s'.
        ] ifFalse:[
            self time printOn: stream format: 'HH:mm:ss'.
        ].
        stream nextPutAll: 'Z'.
! !

!XeXsdTime class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/XeXsdTime.st,v 1.6 2003/10/08 17:31:46 cg Exp $'
! !
