"{ Package: 'stx:goodies/soap/xe' }"

LibraryDefinition subclass:#stx_goodies_soap_xe
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_soap_xe class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/stx_goodies_soap_xe.st,v 1.10 2011/02/01 10:59:05 cg Exp $'
! !

!stx_goodies_soap_xe class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/soap'
        #'stx:goodies/xml/yaxo'    "YAXO::SAXHandler - superclass of YAXO::XeYAXOParser "
        #'stx:libbasic'    "Object - superclass of SOAP::XeAttribute "
        #'stx:libbasic2'    "Base64Coder - referenced by SOAP::XeTextConverter class>>base64Binary "
        #'stx:libcompat'    "Dolphin::SWEnvironment - referenced by SOAP::XeName class>>icon "
    )
! !

!stx_goodies_soap_xe class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'SOAP::IXMLDOMNamedNodeMap'
        #'SOAP::XeClassWriter'
        #'SOAP::XeComplexNodeTable'
        #'SOAP::XeComponent'
        #'SOAP::XeComponentVisitor'
        #'SOAP::XeContentFactory'
        #'SOAP::XeContentSpec'
        #'SOAP::XeEncodingStyle'
        #'SOAP::XeEnvironment'
        #'SOAP::XeName'
        #'SOAP::XeNamespace'
        #'SOAP::XeNodeDecodingAbstract'
        #'SOAP::XeNodeReadMap'
        #'SOAP::XeNodeWriteMap'
        #'SOAP::XeObjectAccessor'
        #'SOAP::XeQProperties'
        #'SOAP::XeQStruct'
        #'SOAP::XeSchema'
        #'SOAP::XeSchemaNotFound'
        #'SOAP::XeSchemaRestriction'
        #'SOAP::XeSoapArrayNodeAbstract'
        #'SOAP::XeSpecification'
        #'SOAP::XeStrictError'
        #'SOAP::XeTextConverter'
        #'SOAP::XeTypeMismatch'
        #'SOAP::XeTypeMismatchPolicy'
        #'SOAP::XeTypespace'
        #'SOAP::XeTypespaceOptions'
        #'SOAP::XeValueAbstract'
        #'SOAP::XeValueMismatch'
        #'SOAP::XeValueRangeError'
        #'SOAP::XeXSDContentModel'
        #'SOAP::XeXSDNode'
        #'SOAP::XeXsdDateTimeAbstract'
        #'YAXO::XeXMLNodeAbstract'
        #'YAXO::XeYAXOParser'
        #'stx_goodies_soap_xe'
        #'SOAP::XeAnyValue'
        #'SOAP::XeAttributeSpec'
        #'SOAP::XeAttributesKeyedAccessor'
        #'SOAP::XeContentAbstract'
        #'SOAP::XeElementSpec'
        #'SOAP::XeGuessFactory'
        #'SOAP::XeKeyedAccessor'
        #'SOAP::XeLiteralStyle'
        #'SOAP::XeLocalFactoryAbstract'
        #'SOAP::XeNodeDecoding'
        #'SOAP::XePName'
        #'SOAP::XeParticleAbstract'
        #'SOAP::XeQName'
        #'SOAP::XeRPCNodeTable'
        #'SOAP::XeSchemaEnumeration'
        #'SOAP::XeSchemaFacet'
        #'SOAP::XeSchemaWriter'
        #'SOAP::XeSelectorAccessor'
        #'SOAP::XeSimpleValue'
        #'SOAP::XeSoapArrayNode'
        #'SOAP::XeSoapEncExtFactory'
        #'SOAP::XeSoapEncFactory'
        #'SOAP::XeSoapEncodingStyle'
        #'SOAP::XeSoapMultiDimArrayNode'
        #'SOAP::XeSoapTypeMismatchPolicy'
        #'SOAP::XeSoapXMLReader'
        #'SOAP::XeSoapXMLWriter'
        #'SOAP::XeXSDBaseFactory'
        #'SOAP::XeXSDComplexContent'
        #'SOAP::XeXSDContentAbstract'
        #'SOAP::XeXSDDefinitionAbstract'
        #'SOAP::XeXSDSchema'
        #'SOAP::XeXSDSimpleContent'
        #'SOAP::XeXsdDate'
        #'SOAP::XeXsdDateTime'
        #'SOAP::XeXsdTime'
        #'YAXO::XeBAttributes'
        #'YAXO::XeBText'
        #'YAXO::XeCompositeNode'
        #'SOAP::XeAnyAttribute'
        #'SOAP::XeAnyContent'
        #'SOAP::XeArrayContent'
        #'SOAP::XeComplexContent'
        #'SOAP::XeComplexFactoryAbstract'
        #'SOAP::XeCompositeParticle'
        #'SOAP::XeGuessContent'
        #'SOAP::XeNamedParticle'
        #'SOAP::XeNodeContent'
        #'SOAP::XeSimpleContent'
        #'SOAP::XeSimpleExtendedContent'
        #'SOAP::XeSimpleFactoryAbstract'
        #'SOAP::XeSimpleRestrictedContent'
        #'SOAP::XeSoapEncodingNoRefStyle'
        #'SOAP::XeXSDAny'
        #'SOAP::XeXSDAnyAttribute'
        #'SOAP::XeXSDBase1999'
        #'SOAP::XeXSDBase2001'
        #'SOAP::XeXSDComplexType'
        #'SOAP::XeXSDDeclaration'
        #'SOAP::XeXSDEmptyComplexContent'
        #'SOAP::XeXSDExtensionComplexContent'
        #'SOAP::XeXSDExtensionSimpleContent'
        #'SOAP::XeXSDGroupAbstract'
        #'SOAP::XeXSDRestrictionComplexContent'
        #'SOAP::XeXSDSimpleType'
        #'YAXO::XeDoc'
        #'YAXO::XeNode'
        #'SOAP::XeAny'
        #'SOAP::XeAttributeAbstract'
        #'SOAP::XeChoiceElement'
        #'SOAP::XeComplexClassAbstract'
        #'SOAP::XeElementAbstract'
        #'SOAP::XeSimpleClassFactory'
        #'SOAP::XeSoapArrayContentAbstract'
        #'SOAP::XeSoapRPCContent'
        #'SOAP::XeSpraySimpleFactory'
        #'SOAP::XeXSDAll'
        #'SOAP::XeXSDAttribute'
        #'SOAP::XeXSDAttributeGroup'
        #'SOAP::XeXSDChoice'
        #'SOAP::XeXSDElement'
        #'SOAP::XeXSDGroup'
        #'SOAP::XeXSDSequence'
        #'SOAP::XeAnyTypeElement'
        #'SOAP::XeAttribute'
        #'SOAP::XeElement'
        #'SOAP::XeFixedAttribute'
        #'SOAP::XeSoapArrayContent'
        #'SOAP::XeSoapMultiDimContent'
        #'SOAP::XeSprayClassFactory'
        #'SOAP::XeSprayReadClassFactory'
        #'SOAP::XeClassBuilder'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        ByteArray printSchemaHexString
        Date asNative
        Date printUnboundedSchemaStringOn:
        Date schemaDisplayString
        FixedPoint schemaDisplayString
        Float isSoapEncSameAs:
        Float schemaDisplayString
        IdentityDictionary xeContentWith:
        Object isSoapEncSameAs:
        Object schemaDisplayString
        Object sprayTypeName
        Object xeContentWith:
        Object xmlDecodeFixupWith:
        Object xmlEncodeUsing:
        SequenceableCollection isSoapEncSameAs:
        String uncapitalized
        String xmlBase
        String xmlPrefix
        String xmlSplit
        Time asNative
        Time schemaDisplayString
        Timestamp asNative
        Timestamp schemaDisplayString
        Unicode16String asUTF8String
        'Boolean class' fromSchemaString:
        'Boolean class' sprayTypeName
        'ByteArray class' sprayTypeName
        'Date class' sprayTypeName
        'FixedPoint class' fromSchemaString:
        'FixedPoint class' sprayTypeName
        'Float class' fromSchemaString:
        'Float class' sprayTypeName
        'Integer class' fromSchemaString:
        'Integer class' sprayTypeName
        'Number class' sprayTypeName
        'Object class' sprayAttributes
        'Object class' sprayElements
        'Object class' sprayInstanceWith:
        'Object class' sprayTypeName
        'Object class' sprayValueTypeName
        'SequenceableCollection class' sprayTypeName
        'String class' sprayTypeName
        'Time class' sprayTypeName
        'Timestamp class' sprayTypeName
    )
! !

!stx_goodies_soap_xe class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X SOAP XML Element library'

    "Modified: / 23-11-2010 / 17:40:41 / cg"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ nil

    "Modified: / 01-02-2011 / 11:54:18 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_soap_xe class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/stx_goodies_soap_xe.st,v 1.10 2011/02/01 10:59:05 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/stx_goodies_soap_xe.st,v 1.10 2011/02/01 10:59:05 cg Exp $'
! !
