"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

TestObjectsXe subclass:#SWXMLTestComposite
	instanceVariableNames:'object1 object2 number'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!

SWXMLTestComposite comment:'For UnitTests'
!


!SWXMLTestComposite class methodsFor:'spray factory'!

sprayElements
	^(OrderedCollection new)
		add: (XeElementSpec named: #object1 class: SWXMLTestObject);
		add: (XeElementSpec named: #object2 class: SWXMLTestObject);
		add: (XeElementSpec named: #number xsd: 'integer');
		yourself
! !

!SWXMLTestComposite class methodsFor:'test example'!

example1

	^self new
		object1: SWXMLTestObject example1;
		object2: SWXMLTestObject example2;
		number: 3;
		yourself.
! !

!SWXMLTestComposite methodsFor:'accessing'!

numberChoices
	^(1 to: number * 2) asArray
! !

!SWXMLTestComposite methodsFor:'accessing-private'!

number
	^number
!

number: anObject
	number := anObject
!

object1
	^object1
!

object1: anObject
	object1 := anObject
!

object2
	^object2
!

object2: anObject
	object2 := anObject
! !

!SWXMLTestComposite methodsFor:'comparing'!

= anTestObject
	^self species == anTestObject species
		and: [object1 = anTestObject object1
		and: [object2 = anTestObject object2
		and: [number = anTestObject number]]]
!

hash
	^(object1 hash bitXor: object2 hash) bitXor: number hash
! !

!SWXMLTestComposite methodsFor:'helpers'!

sprayPageBecome: anInstance

	(self class == anInstance) ifTrue: [self error: 'Class mismatch'].

	self class sprayElements do: [ :each |
		self perform: each setSelector with: (anInstance perform: each getSelector)]
! !

!SWXMLTestComposite class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/SWXMLTestComposite.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
