"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

TestObjectsXe subclass:#SWXMLTestObject
	instanceVariableNames:'x y'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!

SWXMLTestObject comment:'For UnitTests'
!


!SWXMLTestObject class methodsFor:'spray factory'!

sprayElements
	^(OrderedCollection new)
		add: (XeElementSpec named: #x xsd: 'integer');
		add: (XeElementSpec named: #y xsd: 'string');
		yourself
! !

!SWXMLTestObject class methodsFor:'test example'!

example1

	^self new 
		x: 5; 
		y: 'hello' copy;
		yourself
!

example2

	^self new 
		x: 6; 
		y: 'goodbye' copy;
		yourself
! !

!SWXMLTestObject methodsFor:'accessing'!

xChoices
	^(1 to: y size) asArray
! !

!SWXMLTestObject methodsFor:'accessing-private'!

x
	^x
!

x: anObject
	x := anObject
!

y
	^y
!

y: anObject
	y := anObject
! !

!SWXMLTestObject methodsFor:'comparing'!

= anTestObject
	^self species == anTestObject species
		and: [x = anTestObject x
		and: [y = anTestObject y]]
!

hash
	^x hash bitXor: y hash

! !

!SWXMLTestObject methodsFor:'displaying'!

displayOn: aStream

	super displayOn: aStream.
	aStream 
		display: ' x= ';
		display: x;
		display: ' y= ';
		display: y
! !

!SWXMLTestObject methodsFor:'operations'!

isSmall
	^x < 10
!

sprayPageBecome: anInstance

	(self class == anInstance) ifTrue: [self error: 'Class mismatch'].

	self class sprayElements do: [ :each |
		self perform: each setSelector with: (anInstance perform: each getSelector)]
! !

!SWXMLTestObject class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/SWXMLTestObject.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
