"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

TestObjectsXe subclass:#SWXMLTestSimpleObject
	instanceVariableNames:'a b value'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!

SWXMLTestSimpleObject comment:'For UnitTests'
!


!SWXMLTestSimpleObject class methodsFor:'constants'!

sprayValueTypeName
	"Answer the XMLSchema type <XeName> that the receivers instances extend. 
	-Used by a <XeSimpleClassFactory> to create XMLSchema simple content definitions.
	-If the receiver implements this method, it also needs to define #sprayAttributes"

	^XePName xsd: 'float'
! !

!SWXMLTestSimpleObject class methodsFor:'spray factory'!

sprayAttributes
	^(OrderedCollection new)
		add: (XeAttributeSpec named: #a xsd: 'float');
		add: (XeAttributeSpec named: #b xsd: 'string');
		yourself
! !

!SWXMLTestSimpleObject class methodsFor:'test example'!

example1
	^self new 
		value: 1.23;
		a: 3.14;
		b: 'bValue';
		yourself
! !

!SWXMLTestSimpleObject methodsFor:'accessing-private'!

a
	"Private - Answer the value of the receiver's ''a'' instance variable."

	^a
!

a: anObject
	a := anObject
!

b
	"Private - Answer the value of the receiver's ''b'' instance variable."

	^b
!

b: anObject
	b := anObject
!

value
	"Private - Answer the value of the receiver's ''value'' instance variable."

	^value
!

value: anObject
	"Private - Set the value of the receiver's ''value'' instance variable to the argument, anObject."

	value := anObject
! !

!SWXMLTestSimpleObject methodsFor:'comparing'!

= anTestObject
	^self species == anTestObject species 
		and: [a = anTestObject a
		and: [b = anTestObject b
		and: [value = anTestObject value]]]
!

hash
	^(value hash bitXor: a hash) bitXor: b hash

! !

!SWXMLTestSimpleObject class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/SWXMLTestSimpleObject.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
