"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeATests subclass:#XeAnyValueTest
	instanceVariableNames:'anyValue'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeAnyValueTest methodsFor:'accessing'!

set1999Float
	self be1999Typespace.
	anyValue := XeAnyValue new.
	anyValue text: 'a float?'.
	anyValue typeName: (XeQName xsd1999: 'float').


! !

!XeAnyValueTest methodsFor:'tests'!

testDisplayString
	anyValue := XeAnyValue new.
	anyValue displayString.
	anyValue text: nil.
	anyValue displayString.
	anyValue text: 'blah'.
	anyValue displayString.
	anyValue typeName: (XeQName 
				prefix: 'abc'
				local: 'blah'
				ns: nil).
	anyValue displayString.
	anyValue typeName: (XeQName 
				prefix: 'abc'
				local: 'blah'
				ns: #'').
	anyValue displayString
!

testEncodeOverrideDifferent
	| writer |
	self set1999Float.
	writer := XeSoapXMLWriter write: anyValue
				element: ((XeElementSpec named: 'blah' xsd: 'int') xeParticleWith: self encodingStyle) 
						beSoapRoot.
	self assertXML: writer xml
		isSameAs: '<root xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:ns1="http://www.w3.org/1999/XMLSchema"><blah xsi:type="ns1:float">a float?</blah></root>'
!

testEncodeOverrideSame
	| writer |
	self set1999Float.
	writer := XeSoapXMLWriter write: anyValue
				element: ((XeElementSpec named: 'blah' xsd: 'float') xeParticleWith: self encodingStyle) 
						beSoapRoot.
	self assertXML: writer xml
		isSameAs: '<root xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:ns1="http://www.w3.org/1999/XMLSchema"><blah xsi:type="ns1:float">a float?</blah></root>'
! !

!XeAnyValueTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeAnyValueTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
