"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeContentTests subclass:#XeArrayContentTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeArrayContentTest methodsFor:'accessing'!

rootWrap: aString 
	^self 
		rootNodeFor: ('<root xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">%1</root>' 
				formatWith: aString)
! !

!XeArrayContentTest methodsFor:'set up'!

setUp
	super setUp.
	self be2001Typespace.
	content := self encodingStyle 
				array: nil
				class: XeSoapArrayContent
				elementSpeced: (XeElementSpec named: 'item' xsd: 'string')
! !

!XeArrayContentTest methodsFor:'tests'!

testAssertAllowKeyedArrays
	self typespaceOptions beAllowKeyedArrays.
	content assertAllowKeyedArrays.
	self typespaceOptions beDisallowKeyedArrays.
	self should: [content assertAllowKeyedArrays] raise: Error
!

testChildElements
	self assert: content childElements size = 1.
	self assert: content childElements first == content childElement
!

testDefaultTypeName
	self assert: content localName = 'Array'.
	self assert: content namespace = XeNamespace soapEnc.
	"========"
	content := self encodingStyle 
				array: 'ArrayOfint' asQName
				class: XeSoapArrayContent
				elementSpeced: (XeElementSpec named: 'item' xsd: 'int').
	self assert: content localName = 'ArrayOfint'.
	self assert: content typeName isNullNamespace
!

testPutArrayTypeSizeOn
	| node |
	node := self new2001Node: 'blah'.
	content putArrayTypeSize: #(1 2 3) size on: node.
	self assert: (node isPrefixDeclared: 'SOAP-ENC').
	self assert: (node isPrefixDeclared: 'xsd').
	self assert: (node attributes includesKey: 'SOAP-ENC:arrayType').
	self assert: (node attributes getAttribute: 'SOAP-ENC:arrayType') = 'xsd:string[3]'.

	"reuse prefix?"
	node := self new2001Node: 'blah'.
	node addNSPrefix: 'soap' to: XeNamespace soapEnc asString.
	content putArrayTypeSize: #(1 2 3) size on: node.
	self deny: (node nsMap includesKey: 'SOAP-ENC').
	self assert: (node isPrefixDeclared: 'xsd').
	self assert: (node attributes includesKey: 'soap:arrayType').
	self assert: (node attributes getAttribute: 'soap:arrayType') = 'xsd:string[3]'
!

testWSDLArrayType
	| at |
	self be1999Typespace.
	at := ('soapE:ArrayOfstring' asXeName xeContentWith: self encodingStyle) wsdlArrayType.
	self assert: at localName = 'string[]'.
	self assert: at namespace == XeNamespace schema1999
! !

!XeArrayContentTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeArrayContentTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
