"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeXMLBuilderTests subclass:#XeBDocTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Core'
!


!XeBDocTest methodsFor:'tests'!

testChildNodes
	self assert: doc childNodes isEmpty.
	self assert: doc childNodes class == Array.
	doc addElement: 'blah'.
	self assert: doc childNodes size = 1.
	self assert: doc childNodes class == Array.
!

testComments
	doc addElement: 'blah'.
	doc addComment: 'aComment'.
	self assertDocXML: '<?xml version="1.0"?><!!--aComment--><blah/>'.
	doc addComment: 'aComment2'.
	self assertDocXML: '<?xml version="1.0"?><!!--aComment--><!!--aComment2--><blah/>'
!

testConstruction
	| node |
	node := doc addElement: 'blah'.
	self assert: node parentNode == doc
!

testOnlyOneRootException
	doc addElement: 'blah'.
	self should: [doc addElement: 'blah'] raise: Error
!

testOwnerDocument
	| node |
	node := doc addElement: 'blah'.
	self assert: (node ownerDocument documentElement == node ).
	self assert: (node ownerDocument ownerDocument documentElement == node ).
	self assert: (node ownerDocument documentElement documentElement  == node ).
!

testSiblings
	self assert: doc nextSibling isNil.
	self assert: doc previousSibling isNil.
	doc addElement: 'blah'.
	self assert: doc nextSibling isNil.
	self assert: doc previousSibling isNil.
!

testhasDocumentElement
	self deny: doc hasDocumentElement.
	doc addElement: 'blah'.
	self assert: doc hasDocumentElement.
! !

!XeBDocTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeBDocTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
