"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeComponentVisitorTests subclass:#XeClassWriterTest
	instanceVariableNames:'writer'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeClassWriterTest methodsFor:'accessing'!

setForSoapStruct
	self importSoapStructSchema.
	writer := XeClassWriter new 
				currentContent: (typespace xeContentOf: (self nsiQ: 'SOAPStruct')
						encStyle: self encodingStyle)
!

setForSoapStructC
	self importSchemaString:
'<schema 
xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
targetNamespace="urn:blah">
<complexType name="SOAPStruct">
<all>
  <element name="VarString" type="xsd:string"/>
  <element name="VarInt" type="xsd:int"/>
  <element name="VarFloat" type="xsd:float"/>
</all>
</complexType>
</schema>'.

	writer := XeClassWriter new currentContent: self getSoapStructContent
! !

!XeClassWriterTest methodsFor:'set up'!

setUp
	super setUp.
	self be2001Typespace.
	writer := XeClassWriter new.
! !

!XeClassWriterTest methodsFor:'tests'!

testClassBuilder
        |builder|

        self importSoapStructSchema.
        builder := XeClassBuilder new 
                                currentContent: (typespace xeContentOf: (self nsiQ: 'SOAPStruct')
                                                encStyle: self encodingStyle).
        builder generateClass.
        builder generatedClass inspect.
!

testElementName
	self setForSoapStruct.
	self assert: writer elementNames asArray = #('varString' 'varInt' 'varFloat').
	self assert: writer instanceVariableNameString = 'varString varInt varFloat'.
!

testSoapStruct
        self setForSoapStruct.
        writer generateClass.
        writer chunkContents.
        Transcript showCR:writer chunkContents.
        "Notepad showOn: writer chunkContents
        self halt."
! !

!XeClassWriterTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeClassWriterTest.st,v 1.4 2010/03/10 19:14:55 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeClassWriterTest.st,v 1.4 2010/03/10 19:14:55 cg Exp $'
! !
