"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeATests subclass:#XeComponentTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeComponentTests methodsFor:'accessing'!

getSimpleChoiceElement
	^XeChoiceElement onElements: (Array 
				with: ((XeElementSpec named: #blah xsd: 'float') xeParticleWith: self encodingStyle)
				with: ((XeElementSpec named: #x xsd: 'integer') xeParticleWith: self encodingStyle))
!

getSimpleContentSTB
	^(XeQName local: 'stb' ns: XeSpraySimpleFactory defaultTargetNamespace) 
		xeContentWith: self encodingStyle
!

getSoapArrayOfArrayContent
	| array1 |
	array1 := self encodingStyle 
				array: nil
				class: XeSoapArrayContent
				element: ((XeElementSpec named: 'item' xsd: 'string') xeParticleWith: self encodingStyle).
	^self encodingStyle 
		array: nil
		class: XeSoapArrayContent
		element: (self getAnonElement: 'item' content: array1)
!

getSoapMDArrayContent
	^self encodingStyle 
		array: nil
		class: XeSoapMultiDimContent
		elementSpeced: (XeElementSpec named: 'item' xsd: 'string')
!

getSoapMDArrayObjectContent
	^self encodingStyle
		array: nil
		class: XeSoapMultiDimContent 
		elementSpeced: (XeElementSpec named: 'item' class: SWXMLTestObject)


!

getSoapStruct
	^(XeQStruct new)
		at: #varString put: 'abc';
		at: #varInt put: 123;
		at: #varFloat put: 3.14;
		yourself
!

getSoapStructContent
	| specs |
	specs := OrderedCollection new.
	specs
		add: (XeElementSpec named: 'varString' xsd: 'string');
		add: (XeElementSpec named: 'varInt' xsd: 'int');
		add: (XeElementSpec named: 'varFloat' xsd: 'float').
	^self getComplex: nil specs: specs
!

getSoapStructWithChoiceContent
	| choice elements |
	choice := XeChoiceElement onElements: (Array 
						with: ((XeElementSpec named: 'varFloat' xsd: 'float') xeParticleWith: self encodingStyle)
						with: ((XeElementSpec named: 'varNotFloat' xsd: 'string') 
								xeParticleWith: self encodingStyle)).
	elements := OrderedCollection new.
	elements
		add: ((XeElementSpec named: 'varString' xsd: 'string') xeParticleWith: self encodingStyle);
		add: ((XeElementSpec named: 'varInt' xsd: 'int') xeParticleWith: self encodingStyle);
		add: choice.
	^self encodingStyle complex: nil elements: elements
!

importEnumerationSchema
	typespace addSchemaString: XeTestSchemaImports new simpleDefEnum prefix: 'enumns'
!

importFacetSchema
	typespace addSchemaString: XeTestSchemaImports new simpleDefEnum2 prefix: 'f'
!

importSoapStructSchema
	self schemaImport: ((XeTestSchemaImport for: #complexSOAPStruct) target: #'http://soapinterop.org/xsd') 
! !

!XeComponentTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeComponentTests.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
