"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSoapEncElementFromTests subclass:#XeElementFromObjectTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeElementFromObjectTest methodsFor:'accessing'!

content
	^element content 





! !

!XeElementFromObjectTest methodsFor:'asserting'!

assertSimpleValue: value localName: local

	element := self encodingStyle elementForObject: value.
	self assert: (element content isKindOf: XeSimpleContent).
	self assert: (element content localName = local).





! !

!XeElementFromObjectTest methodsFor:'tests'!

testArray
	self be2001Typespace.
	instance := #(1 2 3).
	element := self encodingStyle elementForObject: instance.




!

testArrayOfArrays
	self be2001Typespace.
	instance := #(#(1 2) #(3 4)).
	element := self encodingStyle elementForObject: instance.




!

testByteArray
	self be2001Typespace.
	instance := #[65 65].
	self assertSimpleValue: instance localName: 'base64Binary'




!

testClass
	self be2001Typespace.
	instance := SWXMLTestComposite2 example1.
	element := self encodingStyle elementForObject: instance.
	self assert: (self content isKindOf: XeComplexContent).
	self assert: self content convertClass == SWXMLTestComposite2.
	self assert: self content childElements size = 3.
	self assert: self content firstChildElement  localName = 'object1'.
	self assert: (self content firstChildContent isKindOf: XeComplexContent).
	self assert: self content childElements last localName = 'number'.
	self assert: (self content childElements last content isKindOf: XeSimpleContent)





!

testSimple
	self be2001Typespace.
	#(false 3.14 5 'abc') 
	with: #('boolean' 'double' 'integer' 'string')
	do: [ :value :local |
		self assertSimpleValue: value localName: local]



!

testSoapStruct
	self be2001Typespace.
	instance := XeQStruct new.
	instance at: #param1 put: 'abc'.
	instance at: #param2 put: 3.14.
	element := self encodingStyle elementForObject: instance
!

testSoapStructWithNil
	self be2001Typespace.
	instance := XeQStruct new.
	instance at: #param1 put: 'abc'.
	instance at: #param2 put: nil.
	element := self encodingStyle elementForObject: instance.
	self assert: (self content isKindOf: XeComplexContent).
	self assert: ((self content childLocallyNamed: 'param2') isKindOf: XeAnyTypeElement)
! !

!XeElementFromObjectTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeElementFromObjectTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
