"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeATests subclass:#XeElementSpecTest
	instanceVariableNames:'elementSpec'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeElementSpecTest methodsFor:'asserting'!

assertElementsCreate
	self assert: ((elementSpec xeParticleWith: self encodingStyle) isKindOf: XeElement).
	self assert: ((elementSpec qualifiedTypeNameIn: typespace) isKindOf: XeQName)
!

assertNames
	self assert: (elementSpec elementName isKindOf: XeQName).
	self assert: (elementSpec typeName isKindOf: XeName)
! !

!XeElementSpecTest methodsFor:'tests'!

testArrayOfClassConstruction
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' arrayOfClass: SWXMLTestObject.
	self assert: (elementSpec qualifiedTypeNameIn: typespace) namespace == XeNamespace sprayClass.
	self assert: (elementSpec qualifiedTypeNameIn: typespace) localName = 'ArrayOfSWXMLTestObject'.
	self assertNames.
	self assertElementsCreate.


        
!

testArrayOfClassElementWith
	| element |
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' arrayOfClass: SWXMLTestObject.
	element := elementSpec xeParticleWith: self encodingStyle.
	self assert: (element content isKindOf: XeSoapArrayContent).
	self assert: element content localName = 'ArrayOfSWXMLTestObject'.
	self assert: element content childElement content localName = 'SWXMLTestObject'
!

testClassConstruction
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' class: SWXMLTestObject.
	self assertNames.
	self assertElementsCreate.
	self assert: (elementSpec qualifiedTypeNameIn: typespace) namespace == XeNamespace sprayClass.
	Smalltalk isSmalltalkX ifTrue:[
	    self assert: (elementSpec qualifiedTypeNameIn: typespace) localName = SWXMLTestObject nameWithoutPrefix
	] ifFalse:[
	    self assert: (elementSpec qualifiedTypeNameIn: typespace) localName = SWXMLTestObject name
	].
!

testClassElementWith
	| element |
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' class: SWXMLTestObject.
	element := elementSpec xeParticleWith: self encodingStyle.
	self assert: (element content isKindOf: XeComplexContent).
	self assert: element content localName = 'SWXMLTestObject'
!

testElementWith
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' typeName: 'xsd:string'.
	self assertNames.
	self assertElementsCreate
!

testNCNameConstruction
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' xsd: 'string'.
	self assert: elementSpec elementName localName = 'foo'.
	self assertNames.
	self assertElementsCreate
!

testPrefixedTypeConstruction
	elementSpec := XeElementSpec named: 'foo' typeName: 'bar:blah'.
	self assert: (elementSpec typeName isKindOf: XePName).
	self assert: elementSpec typeName prefix = 'bar'.
	self assert: elementSpec typeName localName = 'blah'
!

testQNameConstruction
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' asQName xsd: 'string'.
	self assert: elementSpec elementName localName = 'foo'.
	self assertNames.
	self assertElementsCreate
!

testSelectors
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' xsd: 'string'
	"self assert: elementSpec getSelector == #foo.
	self assert: elementSpec setSelector == #foo:"
!

testSymbolNameConstruction
	self be2001Typespace.
	elementSpec := XeElementSpec named: #foo xsd: 'string'.
	self assert: elementSpec elementName localName = 'foo'.
	self assertNames.
	self assertElementsCreate
!

testXSDConstruction
	elementSpec := XeElementSpec named: 'foo' xsd: 'string'.
	self be2001Typespace.
	self 
		assert: (elementSpec qualifiedTypeNameIn: typespace) namespace == XeNamespace schema2001.
	self assertNames.
	self assertElementsCreate.
	self be1999Typespace.
	self 
		assert: (elementSpec qualifiedTypeNameIn: typespace) namespace == XeNamespace schema1999.
	self assertNames.
	self assertElementsCreate
!

testXSDElementWith
	| element |
	self be2001Typespace.
	elementSpec := XeElementSpec named: 'foo' typeName: 'xsd:string'.
	element := elementSpec xeParticleWith: self encodingStyle.
	self assert: (element content isKindOf: XeSimpleContent).
	self assert: element content localName = 'string'
! !

!XeElementSpecTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeElementSpecTest.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
