"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeElementAbstractTests subclass:#XeElementTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeElementTest methodsFor:'accessing'!

setNewNode
	node := typespace newNode: 'root'.
! !

!XeElementTest methodsFor:'set up'!

setUp
	super setUp.
	self setElementSimple.
	self setNewNode
! !

!XeElementTest methodsFor:'tests'!

testBeAllTypedComplex
	self setElementComplex.
	element isTyped: false.
	element childElements do: [:each | each isTyped: false].
	self deny: element isTyped.
	self assert: (element childElements allSatisfy: [:each | each isTyped not]).
	element beAllTyped.
	self assert: element isTyped.
	self assert: (element childElements allSatisfy: [:each | each isTyped])
!

testBeFormQualified
	element beFormQualified.
	self assert: element isFormQualified.
	element beFormUnqualified.
	self deny: element isFormQualified.


!

testChildElements
	self assert: (element childElements = #())
!

testChildElementsComplex
	self setElementComplex.
	self assert: element childElements size = 3.
	element childElements do: [ :each |
		self assert: (each isKindOf: XeElement)].
!

testChildElementsSimple
	self assert: (element childElements = #())
!

testModes
	self setElementComplex.
	self assertModes.
	self setElementSimple.
	self assertModes.



!

testNames
	self setElementComplex.
	self assertNames.
	self setElementSimple.
	self assertNames.

!

testPutTypeAttributeOn
	element putXSITypeAttributeOn: node.
	self assertNodeXML:
'<root xsi:type="xsd:float" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"/>'.
	element putXSITypeAttributeOn: node.
	self assertNodeXML:
'<root xsi:type="xsd:float" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"/>'.


! !

!XeElementTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeElementTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
