"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeObjectAccessorTests subclass:#XeKeyedAccessorTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeKeyedAccessorTest methodsFor:'accessing'!

sampleDict
        | dict |
        dict := Dolphin::LookupTable new.
        dict at: (XeQName null:#foo) put: 123.
        dict at: self qFoo put: 456.
        ^dict
! !

!XeKeyedAccessorTest methodsFor:'asserting'!

assertGetIsEx: anInstance
	| ex |
	component beFormQualified.
	[accessor getValueFrom: anInstance] on: Error do: [ :e | ex := e].
	self assert: ex notNil.
	self assert: ('*key*' match: ex description)
!

assertGetIsNotEx: anInstance
	component beFormQualified.
	accessor getValueFrom: anInstance
! !

!XeKeyedAccessorTest methodsFor:'set up'!

setUp
	super setUp.
	accessor := XeKeyedAccessor new component: component
! !

!XeKeyedAccessorTest methodsFor:'tests'!

testGetNotEx
	self assertGetIsNotEx: self sampleDict.
	self assertGetIsNotEx: (XeQStruct param: (self blahQ: 'foo') value: 1)
!

testGetValueFrom
	| dict |
	dict := self sampleDict.
	component beFormQualified.
	self assert: (accessor getValueFrom: dict) = 456.
	component beFormUnqualified.
	self assert: (accessor getValueFrom: dict) = 123
!

testKey
	component beFormQualified.
	self assert: accessor key = self qFoo.
	component beFormUnqualified.
	self assert: accessor key = (XeQName null: 'foo')
!

testSetValueInto
	| dict |
	dict := Dolphin::LookupTable new.
	component beFormQualified.
	accessor setValue: 456 into: dict.
	component beFormUnqualified.
	accessor setValue: 123 into: dict.
	self assert: (dict equals: self sampleDict)
        

! !

!XeKeyedAccessorTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeKeyedAccessorTest.st,v 1.5 2004/07/13 07:40:12 stefan Exp $'
! !
