"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeEncodingStyleTests subclass:#XeLiteralEncodingTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeLiteralEncodingTest methodsFor:'accessing'!

be2001LiteralTypespace
	| typespace |
	typespace := self get2001Typespace.
	typespace makeLiteralDefaultStyle.
	encodingStyle := typespace defaultEncodingStyle
! !

!XeLiteralEncodingTest methodsFor:'set up'!

setUp
	super setUp.
	self be2001LiteralTypespace
! !

!XeLiteralEncodingTest methodsFor:'tests'!

testAttributeSpeced
	| attSpec |
	attSpec := XeAttributeSpec named: self qFoo typeName: (XeQName xsd2001: 'string').
	self assert: ((encodingStyle attributeSpeced: (attSpec fixed: 'abc')) 
				isKindOf: XeFixedAttribute).
	self assert: (encodingStyle attributeSpeced: (attSpec fixed: 'abc')) isOptional.
	attSpec := XeAttributeSpec named: self qFoo typeName: (XeQName xsd2001: 'string').
	self assert: ((encodingStyle attributeSpeced: attSpec) isKindOf: XeAttribute).
	self assert: (encodingStyle attributeSpeced: (attSpec use: 'required')) isOptional not.
	self assert: (encodingStyle attributeSpeced: (attSpec use: 'optional')) isOptional.
	self 
		assert: (encodingStyle attributeSpeced: (attSpec use: 'optional')) isFormQualified not
!

testConfigureComplexAttributes
	| content |
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute).
	content := self qPurchaseOrderType xeContentWith: encodingStyle.
	content attributes do: 
			[:each | 
			self deny: each isFormQualified.
			self assert: each qName isNullNamespace].
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute) beEFDUq.
	content := self qPurchaseOrderType xeContentWith: encodingStyle.
	content childElements do: 
			[:each | 
			self deny: each isFormQualified.
			self assert: each qName isNullNamespace].
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute) beEFDQ.
	content := self qPurchaseOrderType xeContentWith: encodingStyle.
	content childElements do: 
			[:each | 
			self assert: each isFormQualified.
			self assert: each namespace = #'urn:blah']
!

testConfigureComplexElement
	| content |
	self schemaImport: (XeTestSchemaImport for: #complexSOAPStruct).
	content := self qSOAPStruct xeContentWith: encodingStyle.
	content childElements do: 
			[:each | 
			self deny: each isFormQualified.
			self assert: each qName isNullNamespace].
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexSOAPStruct) beEFDUq.
	content := self qSOAPStruct xeContentWith: encodingStyle.
	content childElements do: 
			[:each | 
			self deny: each isFormQualified.
			self assert: each qName isNullNamespace].
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexSOAPStruct) beEFDQ.
	content := self qSOAPStruct xeContentWith: encodingStyle.
	content childElements do: 
			[:each | 
			self assert: each isFormQualified.
			self assert: each namespace = #'urn:blah']
! !

!XeLiteralEncodingTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeLiteralEncodingTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
