"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSchemaDefReadTests subclass:#XeLiteralSchemaDefReadTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeLiteralSchemaDefReadTest methodsFor:'accessing'!

acessorQKeys2001ComplexType
	^Array 
		with: ('varInt' ns: #'urn:mySample')
		with: ('varFloat' ns: #'urn:mySample')
		with: ('varString' ns: #'urn:mySample')
!

setTypespace
	self be2001LiteralTypespace
! !

!XeLiteralSchemaDefReadTest methodsFor:'tests'!

test2001ComplexTypeEFDQ
	self importSchemaString: XeTestSchemaImports new complexDefSSEFDQ.
	self setContentFromSchema: 'MySoapStruct'.
	self assertContent: 
			[| childContent |
			self assert: (content isKindOf: XeComplexContent).
			self assert: (self symmetricDifferenceOf:content accessorKeys and: self acessorQKeys2001ComplexType) isEmpty.
			childContent := (content childLocallyNamed: 'varFloat') content.
			self assert: childContent typeName = (XeQName xsd2001: 'float')]
!

test2001ComplexTypeWithRef
	self importSchemaString: XeTestSchemaImports new complexDefWithRef.
	self setContentFromSchema: 'MySoapStruct'.
	self assertContent: 
			[| childContent |
			self assert: (content isKindOf: XeComplexContent).
			self assert: (content accessorKeys includes: (XeQName null: 'varInt')).
			self assert: (content accessorKeys includes: (XeQName null: 'varFloat')).
			self assert: (content accessorKeys includes: ('varString' ns: #'urn:mySample')).
			childContent := (content childLocallyNamed: 'varFloat') content.
			self assert: childContent typeName = (XeQName xsd2001: 'float')]
!

test2001RefElement
	self importSchemaString: XeTestSchemaImports new complexDefWithRef2.
	self setContentFromSchema: 'AnAddressType'.
	self assertContent: 
			[| commentContent |
			self assert: (content isKindOf: XeComplexContent).
			self assert: (content accessorKeys includes: (self blahQ: 'comment')).
			commentContent := (content childLocallyNamed: 'comment') content.
			self assert: commentContent typeName = (XeQName xsd2001: 'string')]
!

test2001SimpleContent
	self importSchemaString: XeTestSchemaImports new complexDefSimple2.
	self setContentFromSchema: 'USAddress'.
	self assertContent: 
			[self assert: (content isKindOf: XeSimpleExtendedContent).
			self assert: content baseContent typeName = (XeQName xsd2001: 'decimal').
			self assert: content attributes size = 1.
			self assert: (content attributes first isKindOf: XeAttribute).
			self assert: (content attributes first localName = 'currency').
			self assert: (content attributes first content typeName = (XeQName xsd2001: 'string')).]
! !

!XeLiteralSchemaDefReadTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeLiteralSchemaDefReadTest.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
