"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeWriteReadTests subclass:#XeLiteralWriteReadTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeLiteralWriteReadTest methodsFor:'accessing'!

getPOSpec
	^XeElementSpec named: 'blah' typeName: ('PurchaseOrderType' ns: #'urn:blah')
!

getSoapStructSpec
	^XeElementSpec named: 'blah' typeName: ('SOAPStruct' ns: #'http://soapinterop.org/xsd')
!

withOptions: anArray assertContentXML: aString 
	"Set the options
	-encode the object using supplied element
	--assert the xml is the same as supplied
	-decode that xml using supplied element
	--assert the decoded object is the = to the original"
        
	self setUp.
	anArray do: [:each | self perform: each].
	self encode.
	self assertContentXML: aString.
	self setDecodeObjectFromElement.
	self assertDecodeToSame.
        
! !

!XeLiteralWriteReadTest methodsFor:'set up'!

setUp
	super setUp.
	writer isIDHref: false
! !

!XeLiteralWriteReadTest methodsFor:'tests'!

test2001ClassBase
	self be2001LiteralTypespace.
	instance := SWXMLTestObject example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.dolphinharbor.org/spray/class">
  <blah><x>5</x><y>hello</y></blah></root>'.
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root xsi:type="d:SWXMLTestObject" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></root>'
!

test2001ClassBaseEFDQ
	self be2001FQLiteralTypespace.
	instance := SWXMLTestObject example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.dolphinharbor.org/spray/class">
  <blah>
    <ns1:x>5</ns1:x>
    <ns1:y>hello</ns1:y>
  </blah>
</root>'.
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root xsi:type="d:SWXMLTestObject" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><d:x xsi:type="xsd:integer">5</d:x><d:y xsi:type="xsd:string">hello</d:y></root>'
!

test2001ClassComposite
	self be2001LiteralTypespace.
	instance := SWXMLTestComposite example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestComposite) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.dolphinharbor.org/spray/class"><blah><object1><x>5</x><y>hello</y></object1><object2><x>6</x><y>goodbye</y></object2><number>3</number></blah></root>'.
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root xsi:type="d:SWXMLTestComposite" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><object1 xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></object1><object2 xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">6</x><y xsi:type="xsd:string">goodbye</y></object2><number xsi:type="xsd:integer">3</number></root>'
!

test2001ClassCompositeEFDQ
	self be2001FQLiteralTypespace.
	instance := SWXMLTestComposite example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestComposite) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.dolphinharbor.org/spray/class"><blah><ns1:object1><ns1:x>5</ns1:x><ns1:y>hello</ns1:y></ns1:object1><ns1:object2><ns1:x>6</ns1:x><ns1:y>goodbye</ns1:y></ns1:object2><ns1:number>3</ns1:number></blah></root>'.
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root xsi:type="d:SWXMLTestComposite" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><d:object1 xsi:type="d:SWXMLTestObject"><d:x xsi:type="xsd:integer">5</d:x><d:y xsi:type="xsd:string">hello</d:y></d:object1><d:object2 xsi:type="d:SWXMLTestObject"><d:x xsi:type="xsd:integer">6</d:x><d:y xsi:type="xsd:string">goodbye</d:y></d:object2><d:number xsi:type="xsd:integer">3</d:number></root>'
!

test2001ClassWithAttribute
	self be2001LiteralTypespace.
	instance := SWXMLTestExtObject example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestExtObject) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<blah a="3.14" b="bValue">
<x>5</x>
<y>hello</y>
</blah>
</root>'.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:d="http://www.dolphinharbor.org/spray/class"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<blah xsi:type="d:SWXMLTestExtObject" a="3.14" b="bValue">
<x xsi:type="xsd:integer">5</x>
<y xsi:type="xsd:string">hello</y>
</blah></root>'
!

test2001ClassWithAttributeNil
	self be2001LiteralTypespace.
	instance := SWXMLTestExtObject example1.
	instance b: nil.
	element := (XeElementSpec named: 'blah' class: SWXMLTestExtObject) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<blah a="3.14">
<x>5</x>
<y>hello</y>
</blah>
</root>'.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:d="http://www.dolphinharbor.org/spray/class"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<blah xsi:type="d:SWXMLTestExtObject" a="3.14">
<x xsi:type="xsd:integer">5</x>
<y xsi:type="xsd:string">hello</y>
</blah></root>'
!

test2001ClassWithNil
	self be2001LiteralTypespace.
	instance := SWXMLTestObject example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle.
	instance x: nil.
	element childElements do: [:each | each beNillable].
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.dolphinharbor.org/spray/class">
  <blah><x xsi:nil="true"/><y>hello</y></blah></root>'.
	element childElements do: [:each | each beNotNillable].
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode) encodeRaise: Error
!

test2001ImportedSimpleExt
        self be2001LiteralTypespace.
        self importSchemaString: XeTestSchemaImports new complexDefSimple.
        instance := XeSimpleValue new.

        instance value: '99.99s' asNumber.
        instance attributes at: (XeQName null:#currency) put: 'AU'.
        element := (XeElementSpec named: 'blah' typeName: ('InternationalPrice' ns: #'urn:blah')) 
                                xeParticleWith: self encodingStyle.
        self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
                assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="urn:blah"><blah currency="AU" xsi:type="ns1:InternationalPrice">99.99</blah></root>'
!

test2001SimpleClass
	self be2001LiteralTypespace.
	instance := SWXMLTestSimpleObject example1.
	element := (XeElementSpec named: 'blah'
				typeName: (#SWXMLTestSimpleObject ns: XeNamespace spraySimpleClass)) 
					xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah a="3.14" b="bValue">1.23</blah></root>'.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.dolphinharbor.org/spray/simpleClass"><blah xsi:type="ns1:SWXMLTestSimpleObject" a="3.14" b="bValue">1.23</blah></root>'.
	self withOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" a="3.14" b="bValue">1.23</root>'
!

test2001SimpleClassWithNil
	self be2001LiteralTypespace.
	instance := SWXMLTestSimpleObject example1.
	instance a: nil.
	element := (XeElementSpec named: 'blah'
				typeName: (#SWXMLTestSimpleObject ns: XeNamespace spraySimpleClass)) 
					xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah b="bValue">1.23</blah></root>'
!

test2001SoapStruct
	self be2001LiteralTypespace.
	self importSoapStructSchema.
	instance := self getSoapStruct asElementQualifiedIn: #''.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root 
  xsi:type="ns1:SOAPStruct"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://soapinterop.org/xsd">
  <varString xsi:type="xsd:string">abc</varString>
  <varInt xsi:type="xsd:int">123</varInt>
  <varFloat xsi:type="xsd:float">3.14</varFloat>
</root>'
!

test2001SoapStructEFDQ
	self be2001LiteralTypespace.
	self schemaImport: ((XeTestSchemaImport for: #complexSOAPStruct)
				beEFDQ;
				target: #'http://soapinterop.org/xsd').
	instance := self getSoapStruct asElementQualifiedIn: #'http://soapinterop.org/xsd'.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root xsi:type="ns1:SOAPStruct" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd"><ns1:varString xsi:type="xsd:string">abc</ns1:varString><ns1:varInt xsi:type="xsd:int">123</ns1:varInt><ns1:varFloat xsi:type="xsd:float">3.14</ns1:varFloat></root>'
!

test2001SoapStructNillable
	self be2001LiteralTypespace.
	self importSoapStructSchema.
	instance := self getSoapStruct.
	instance atUnique: #varString put: nil.
	instance := instance asElementQualifiedIn: #''.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	element childElements do: [:each | each beNillable].
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root 
  xsi:type="ns1:SOAPStruct"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://soapinterop.org/xsd">
  <varString xsi:nil="true"/>
  <varInt xsi:type="xsd:int">123</varInt>
  <varFloat xsi:type="xsd:float">3.14</varFloat>
</root>'
!

test2001SoapStructNotNillable
	self be2001LiteralTypespace.
	self importSoapStructSchema.
	instance := self getSoapStruct.
	instance atUnique: #varString put: nil.
	instance := instance asElementQualifiedIn: #''.
	self assert: instance size = 3.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode) encodeRaise: Error
!

test2001SoapStructNotOmitable
	self be2001LiteralTypespace.
	self importSoapStructSchema.
	instance := self getSoapStruct.
	instance removeKey: #varString.
	instance := instance asElementQualifiedIn: #''.
	self assert: instance size = 2.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode) encodeRaise: Error
!

test2001SoapStructNotTyped
	self be2001LiteralTypespace.
	self importSoapStructSchema.
	instance := self getSoapStruct asElementQualifiedIn: #''.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <varString>abc</varString>
  <varInt>123</varInt>
  <varFloat>3.14</varFloat>
</root>'
!

test2001SoapStructOmitable
	self be2001LiteralTypespace.
	self importSoapStructSchema.
	instance := self getSoapStruct.
	instance removeKey: #varString.
	instance := instance asElementQualifiedIn: #''.
	self assert: instance size = 2.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	element childElements do: [:each | each beOmitable].
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root 
  xsi:type="ns1:SOAPStruct"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://soapinterop.org/xsd">
  <varInt xsi:type="xsd:int">123</varInt>
  <varFloat xsi:type="xsd:float">3.14</varFloat>
</root>'
!

test2001SoapStructOmitableAndNillable1
	self be2001LiteralTypespace.
	self importSoapStructSchema.
	instance := self getSoapStruct.
	instance removeKey: #varString.
	instance := instance asElementQualifiedIn: #''.
	self assert: instance size = 2.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	element childElements do: 
			[:each | 
			each
				beOmitable;
				beNillable].
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root 
  xsi:type="ns1:SOAPStruct"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://soapinterop.org/xsd">
  <varInt xsi:type="xsd:int">123</varInt>
  <varFloat xsi:type="xsd:float">3.14</varFloat>
</root>'
!

test2001SoapStructOmitableAndNillable2
	self be2001LiteralTypespace.
	self importSoapStructSchema.
	instance := self getSoapStruct.
	instance atUnique: #varString put: nil.
	instance := instance asElementQualifiedIn: #''.
	self assert: instance size = 3.
	element := self getSoapStructSpec xeParticleWith: self encodingStyle.
	element childElements do: 
			[:each | 
			each
				beOmitable;
				beNillable].
	self withOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		assertContentXML: '<root 
  xsi:type="ns1:SOAPStruct"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://soapinterop.org/xsd">
  <varInt xsi:type="xsd:int">123</varInt>
  <varFloat xsi:type="xsd:float">3.14</varFloat>
</root>'
!

testComplexMultiple
	self be2001LiteralTypespace.
	self importSchemaString: XeTestSchemaImports new complexDefUnboundedElement.
	instance := #('abc' 'def').
	element := (XeElementSpec named: 'blah' typeName: ('LiteralArrayOfString' ns: #'urn:blah')) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah xsi:type="ns1:LiteralArrayOfString">
    <string xsi:type="xsd:string">abc</string>
    <string xsi:type="xsd:string">def</string>
</blah></root>'
!

testComplexWithAnyAttribute
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAnyAttribute).
	instance := XeQStruct new.
	instance at: (XeQName null: #shipTo) put: 'me'.
	instance at: (XeQName null: #number) put: 10.
	instance attributes at: #orderFloat put: 3.14.
	element := self getPOSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah orderFloat="3.14" xsi:type="ns1:PurchaseOrderType">
    <shipTo xsi:type="xsd:string">me</shipTo>
    <number xsi:type="xsd:int">10</number>
</blah></root>'
!

testComplexWithAnyAttributeQ
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAnyAttribute) beEFDQ.
	instance := XeQStruct new.
	instance at: (self blahQ: #shipTo) put: 'me'.
	instance at: (self blahQ: #number) put: 10.
	instance attributes at: (self blahQ: #orderFloat) put: 3.14.
	element := self getPOSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah ns1:orderFloat="3.14" xsi:type="ns1:PurchaseOrderType">
    <ns1:shipTo xsi:type="xsd:string">me</ns1:shipTo>
    <ns1:number xsi:type="xsd:int">10</ns1:number>
</blah></root>'
!

testComplexWithAttribute
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute).
	instance := XeQStruct new.
	instance at: (XeQName null: #shipTo) put: 'me'.
	instance at: (XeQName null: #number) put: 10.
	instance attributes at: #orderFloat put: 3.14.
	element := self getPOSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah orderFloat="3.14" xsi:type="ns1:PurchaseOrderType">
    <shipTo xsi:type="xsd:string">me</shipTo>
    <number xsi:type="xsd:int">10</number>
</blah></root>'
!

testComplexWithAttributeDefault
	self be2001LiteralTypespace.
	self importSchemaString: XeTestSchemaImports new complexDefAttributeDefault.
	instance := XeQStruct new.
	instance at: (XeQName null: #shipTo) put: 'me'.
	instance at: (XeQName null: #number) put: 10.
	instance attributes at: #orderFloat put: '3.14'.
	element := self getPOSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah orderFloat="3.14" xsi:type="ns1:PurchaseOrderType">
    <shipTo xsi:type="xsd:string">me</shipTo>
    <number xsi:type="xsd:int">10</number>
</blah></root>'
!

testComplexWithAttributeEFDQ
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute) beEFDQ.
	instance := XeQStruct new.
	instance at: (self blahQ: #shipTo) put: 'me'.
	instance at: (self blahQ: #number) put: 10.
	instance attributes at: #orderFloat put: 3.14.
	element := self getPOSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah orderFloat="3.14" xsi:type="ns1:PurchaseOrderType">
    <ns1:shipTo xsi:type="xsd:string">me</ns1:shipTo>
    <ns1:number xsi:type="xsd:int">10</ns1:number>
</blah></root>'
!

testComplexWithAttributeEFDQAFDQ
	self be2001LiteralTypespace.
	self schemaImport: ((XeTestSchemaImport for: #complexWithAttribute)
				beEFDQ;
				beAFDQ).
	instance := XeQStruct new.
	instance at: (self blahQ: #shipTo) put: 'me'.
	instance at: (self blahQ: #number) put: 10.
	instance attributes at: (self blahQ: #orderFloat) put: 3.14.
	element := self getPOSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah ns1:orderFloat="3.14" xsi:type="ns1:PurchaseOrderType">
    <ns1:shipTo xsi:type="xsd:string">me</ns1:shipTo>
    <ns1:number xsi:type="xsd:int">10</ns1:number>
</blah></root>'
!

testComplexWithAttributeFixed
	self be2001LiteralTypespace.
	self importSchemaString: XeTestSchemaImports new complexDefAttributeFixed.
	instance := XeQStruct new.
	instance at: (XeQName null: #shipTo) put: 'me'.
	instance at: (XeQName null: #number) put: 10.
	element := self getPOSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah orderFloat="1.0" xsi:type="ns1:PurchaseOrderType">
    <shipTo xsi:type="xsd:string">me</shipTo>
    <number xsi:type="xsd:int">10</number>
</blah></root>'
!

testComplexWithAttributeNil
	self be2001LiteralTypespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute).
	instance := XeQStruct new.
	instance at: (XeQName null: #shipTo) put: 'me'.
	instance at: (XeQName null: #number) put: 10.
	instance attributes at: #orderFloat put: nil.
	element := self getPOSpec xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="urn:blah">
  <blah xsi:type="ns1:PurchaseOrderType">
    <shipTo xsi:type="xsd:string">me</shipTo>
    <number xsi:type="xsd:int">10</number>
</blah></root>'
! !

!XeLiteralWriteReadTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeLiteralWriteReadTest.st,v 1.5 2004/07/13 07:40:14 stefan Exp $'
! !
