"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeATests subclass:#XeNodeDecodingTest
	instanceVariableNames:'decoding'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeNodeDecodingTest methodsFor:'accessing'!

setOnXmlString: aString 
	| reader node |
	node := self rootNodeFor: aString.
	reader := XeSoapXMLReader new initializeOn: node.
	decoding := reader currentDecoding
!

setStringElement
	self be2001Typespace.
	decoding 
		element: ((XeElementSpec named: #blah xsd: 'string') xeParticleWith: self encodingStyle)
! !

!XeNodeDecodingTest methodsFor:'tests'!

testAssertNotNilNode
	decoding := XeNodeDecoding node: nil reader: nil. 
	self setStringElement.
	self should: [decoding assertNotNilNode] raise: Error.
	self setOnXmlString: '<root/>'.
	self setStringElement.
	decoding assertNotNilNode
        
!

testHrefAttribute
	self setOnXmlString: '<root href="id1"/>'.
	self assert: decoding hRefAttribute = 'id1'
        
!

testIdAttribute
	self setOnXmlString: '<root id="#id1"/>'.
	self assert: decoding idAttribute = '#id1'
        
!

testReadNode
	self setOnXmlString: '<root>def</root>'.
	self setStringElement.
	decoding readNode.
	self assert: decoding object = 'def'
!

testReadNodeWithID
	self setOnXmlString: '<root id="a">def</root>'.
	self setStringElement.
	decoding readNode.
	self assert: decoding object = 'def'.
	self assert: (decoding map atHRef: '#a' ifAbsent: []) = 'def'
!

testReadReferenceNotFound
	self setOnXmlString: '<root id="id1">def</root>'.
	self setStringElement.
	self should: [decoding readHRef: '#Notid1'] raise: Error.
!

testReadReferenceNotRead
	self setOnXmlString: '<root id="id1">def</root>'.
	self setStringElement.
	decoding readHRef: '#id1'.
	self assert: decoding object = 'def'
!

testReadReferenceRead
	self setOnXmlString: '<root href="id1"/>'.
	decoding map atHRef: 'id1' put: 'def'.
	decoding readReference: 'id1'.
	self assert: decoding object = 'def'
! !

!XeNodeDecodingTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeNodeDecodingTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
