"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeEncodingTests subclass:#XeNodeReadMapTest
	instanceVariableNames:'readMap'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeNodeReadMapTest methodsFor:'accessing'!

setOnXmlString: aString 
	readMap := XeNodeReadMap on: (self rootNodeFor: aString)
!

setSample
	self 
		setOnXmlString: 
'<root>
  <blah>
      <aid3 id="id3"/>
  </blah>
  <aid1 id="id1"/>
  <aid2 id="id2"/>
</root>'
! !

!XeNodeReadMapTest methodsFor:'asserting'!

assertNullNode: xmlString 
	self assert: (self rootNodeFor: xmlString) firstChild isXSINil
!

denyNullNode: xmlString 
	self deny: (self rootNodeFor: xmlString) firstChild isXSINil
! !

!XeNodeReadMapTest methodsFor:'tests'!

testDereferenceNode
	self setSample.
	self assert: (readMap dereferenceNode: (self rootNodeFor: '<a href="#id2" />')) localName = 'aid2'.
	self should: [readMap dereferenceNode: (self rootNodeFor: '<a href="#Notid2" />')] raise: Error
!

testIsNullNode
	self assertNullNode: 
'<blah xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<whatever xsi:null="1"/>
</blah>'.
	self assertNullNode: 
'<blah xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<whatever xsi:nil="true"/>
</blah>'.
	self denyNullNode: 
'<blah xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<whatever xsi:null="0"/>
</blah>'.
	self denyNullNode: 
'<blah xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<whatever />
</blah>'.
	self assertNullNode: 
'<blah xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<whatever xsi:nil="1"/>
</blah>'.
        
	self denyNullNode: 
'<blah xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<whatever xsi:nil="0"/>
</blah>'.
!

testNodeAt
	self setSample.
	self assert: (readMap nodeAt: 'id3') localName = 'aid3'.
	self assert: (readMap nodeAt: 'id2') localName = 'aid2'.
	self assert: (readMap nodeAt: 'Notid2') isNil
! !

!XeNodeReadMapTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeNodeReadMapTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
