"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeNameTests subclass:#XePNameTest
	instanceVariableNames:'pName'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Core'
!


!XePNameTest methodsFor:'set up'!

setUp
	super setUp.
	pName := XePName prefix: 'xsd' local: 'string'.
        
! !

!XePNameTest methodsFor:'tests'!

testAsXeName
	self assert: (pName asXeName) == pName
!

testAsXeNameString
	pName := 'xsd:blah' asXeName.
	self assert: pName prefix = 'xsd'.
	self assert: pName localName = 'blah'.
	self should: ['xsd:blah:blah' asXeName] raise: Error
!

testAsXeNameSymbol
	pName := #'xsd:blah' asXeName.
	self assert: pName prefix = 'xsd'.
	self assert: pName localName = 'blah'.
	self should: [#'xsd:blah:blah' asXeName] raise: Error
!

testQTypedConstruction
	pName := XePName fromString: 'xsd:blah'.
	self assert: pName prefix = 'xsd'.
	self assert: pName localName = 'blah'.
	self should: [XePName fromString: 'xsd:blah:blah2'] raise: Error.
	self should: [XePName fromString: 'blah2'] raise: Error.
	self should: ['xsd:blah:blah2' asXeName] raise: Error
! !

!XePNameTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XePNameTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
