"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeNameTests subclass:#XeQNameTest
	instanceVariableNames:'qName'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Core'
!


!XeQNameTest methodsFor:'set up'!

setUp
	super setUp.
	qName := XeQName prefix: 'xsd'
				local: 'string'
				ns: XeNamespace schema2001. 
! !

!XeQNameTest methodsFor:'tests'!

testAsQName
	self assert: (qName asQName) == qName
!

testAsQNameString
	qName := 'abc' asQName.
	self assert: qName isNullNamespace.
	self assert: qName localName = 'abc'.
	self should: ['abc:def' asQName] raise: Error
!

testAsQNameSymbol
	qName := #'abc' asQName.
	self assert: qName isNullNamespace.
	self assert: qName localName = 'abc'.
	self should: [#'abc:def' asQName] raise: Error
!

testAsXeName
	self assert: (qName asXeName) == qName
!

testAsXeNameString
	qName := 'abc' asXeName.
	self assert: qName isNullNamespace.
	self assert: qName localName = 'abc'.
!

testAsXeNameSymbol
	qName := #'abc' asXeName.
	self assert: qName isNullNamespace.
	self assert: qName localName = 'abc'.
!

testComparison
	self assert: qName = (XeQName local: 'string' ns: XeNamespace schema2001).
	self assert: qName = (XeQName prefix: '' local: 'string' ns: XeNamespace schema2001).
	self assert: qName = (XeQName prefix: 'anything' local: 'string' ns: XeNamespace schema2001).
	self assert: qName = (XeQName prefix: nil local: 'string' ns: XeNamespace schema2001).
	self deny: qName = (XeQName local: 'notstring' ns: XeNamespace schema2001).
	self deny: qName = (XeQName local: 'string' ns: XeNamespace schema1999).
	self deny: qName = (XeQName local: 'string' ns: nil).
	self deny: qName = (XeQName local: 'string' ns: #'').
	self deny: qName = (XeQName null: 'string' ).
	self deny: qName = (XePName prefix: 'xsd' local: 'string').
!

testConstruction
	qName := XeQName prefix: 'd'
				local: 'SWXMLTestObject'
				ns: XeNamespace sprayClass.
	self assert: qName prefix = 'd'.
	self assert: qName localName = 'SWXMLTestObject'.
	self assert: qName namespace = XeNamespace sprayClass
!

testHasPrifix
	self assert: (XeQName prefix: 'anything' local: 'string' ns: XeNamespace schema2001) hasPrefix.
	self deny: (XeQName local: 'string' ns: XeNamespace schema2001) hasPrefix.
	self deny: (XeQName prefix: '' local: 'string' ns: XeNamespace schema2001) hasPrefix.
	self deny: (XeQName prefix: nil local: 'string' ns: XeNamespace schema2001) hasPrefix.

!

testIsNullNamespace
        self deny: (XeQName prefix: 'anything' local: 'string' ns: XeNamespace schema2001) isNullNamespace.
        self assert: (XeQName local: 'string' ns: #'') isNullNamespace.
        self assert: (XeQName local: 'string' ns: nil) isNullNamespace.
        self assert: (XeQName null: 'string' ) isNullNamespace.
        self should: [XeQName local: 'string' ns: ''] raise: Error

        "self new testIsNullNamespace"
! !

!XeQNameTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeQNameTest.st,v 1.4 2010/03/10 19:56:11 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeQNameTest.st,v 1.4 2010/03/10 19:56:11 cg Exp $'
! !
