"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeEncodingCoreTests subclass:#XeQPropertiesTest
	instanceVariableNames:'qProperties'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Core'
!


!XeQPropertiesTest methodsFor:'accessing'!

addSamples
	qProperties
		at: 'b:test1' put: 1;
		at: (XePName prefix: 'b' local: 'test2') put: 2;
		at: 'test3' put: 3;
		at: ('test4' ns: #'urn:blah') put: 4
!

qTest
	^self blahQ: 'test'
        
        
! !

!XeQPropertiesTest methodsFor:'set up'!

setUp
	super setUp.
	qProperties := XeQProperties new.
	qProperties addPrefix: 'f' namespace: #'urn:foo'.
	qProperties addPrefix: 'b' namespace: #'urn:blah'.
        
! !

!XeQPropertiesTest methodsFor:'tests'!

testAt
	self addSamples.
	self assert: (qProperties at: (self blahQ: 'test1')) = 1.
	self assert: (qProperties at: 'b:test1') = 1.
	self assert: (qProperties at: #'b:test1') = 1.
	self assert: (qProperties at:  (XePName prefix: 'b' local: 'test1')) = 1.
        
!

testAtPut
	self addSamples.
	qProperties keysDo: [ :each | self assert: (each isKindOf: XeQName)].
	self assert: qProperties size = 4
!

testQualifyKey
	self assert: (qProperties qualifyKey: 'b:test') = self qTest.
	self assert: (qProperties qualifyKey: #'b:test') = self qTest.
	self assert: (qProperties qualifyKey: self qTest) = self qTest.
	self assert: (qProperties qualifyKey: 'b:test' asXeName) = self qTest
!

testSelect
	| newQP |
	self addSamples.
	newQP := qProperties select: [ :each | each = 2].
	self assert: newQP size = 1.
	self deny: newQP prefixMap == qProperties prefixMap.
	"self assert: newQP prefixMap size = 2."


        
! !

!XeQPropertiesTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeQPropertiesTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
