"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeATests subclass:#XeSchemaTest
	instanceVariableNames:'schema'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSchemaTest methodsFor:'accessing'!

setBase2001
	schema := XeSchema onFactory: XeXSDBase2001
!

setSprayClassSchema
	schema := typespace schemaTargeting: XeNamespace sprayClass.
        
! !

!XeSchemaTest methodsFor:'tests'!

testClassFor
	| tn |
	self be2001Typespace.
	self setSprayClassSchema.
	tn := XeQName prefix: 'd' local: 'testObject' ns: XeNamespace sprayClass .
	self should: [schema factory classFor: tn] raise: Error.
	typespace mapTypeName: ('testObject' ns: XeNamespace sprayClass) to: SWXMLTestObject.
	"(XeClassMap 
		map: 'testObject'
		to: SWXMLTestObject
		in: XeNamespace sprayClass) createIn: typespace."
	self assert: (schema factory classFor: tn) == SWXMLTestObject.
!

testConstructionFactory
	self setBase2001.
	self assert: schema targetNS = XeNamespace schema2001.
	self assert: (schema factory isKindOf: XeXSDBase2001)
!

testConstructionImport
	| xmlString node |
	xmlString := 
'<schema 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
targetNamespace = "http://soapinterop.org/xsd">
<complexType name="SOAPStruct">
<all>
<element name="varString" type="xsd:string" />
<element name="varInt" type="xsd:int" /> 
<element name="varFloat" type="xsd:float" /> 
</all>
</complexType>
</schema>'.
	node := self rootNodeFor: xmlString.
	schema := (XeSchema forNode: node) typespace: XeTypespace new.
	self assert: schema targetNS = #'http://soapinterop.org/xsd'.
	self assert: (schema factory isKindOf: XeXSDSchema).
        
!

testDefinitionMap
	self setBase2001.
	schema overrideMaps at: 'string' put: nil.
	self assert: (schema factoryFor: (XeXSDBase2001 qualifyLocal: 'string')) isNil.
	self 
		assert: ((schema factoryFor: (XeXSDBase2001 qualifyLocal: 'integer')) isKindOf: XeXSDBaseFactory)
!

testImportExceptions
	"no target namespace"

	| node |
	node := self rootNodeFor: 
'<schema>
<complexType name= "noTargetNamespaceType"/>
 </schema>'.
	self should: [XeSchema forNode: node] raise: Error.
	"not a schema"
	node := self 
				rootNodeFor: 
'<notschema targetNamespace="urn:this">
<complexType name= "noTargetNamespaceType"/>
 </notschema>'.
	self should: [XeSchema forNode: node] raise: Error
!

testQualify
	self be2001Typespace.
	self setSprayClassSchema.
	self assert: (schema qualifyLocal: 'blah') localName = 'blah'.
	self assert: (schema qualifyLocal: 'blah') namespace == XeNamespace sprayClass
! !

!XeSchemaTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSchemaTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
