"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSchemaWriterTests subclass:#XeSchemaWriterDefTest
	instanceVariableNames:'content recon'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSchemaWriterDefTest methodsFor:'accessing'!

getArrayMultiDimString1
	^
'<xsd:schema
  targetNamespace="urn:blah"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
<xsd:import namespace="http://schemas.xmlsoap.org/wsdl/"/>
<xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/"/>
<xsd:complexType name="myType">
<xsd:complexContent>
<xsd:restriction base="SOAP-ENC:Array">
<xsd:sequence>
<xsd:element name="item" maxOccurs="unbounded" type="xsd:string" nillable="true" minOccurs="0"/></xsd:sequence>
<xsd:attribute wsdl:arrayType="xsd:string[,]" ref="SOAP-ENC:arrayType"/>
<xsd:attribute ref="SOAP-ENC:offset"/>
<xsd:attributeGroup ref="SOAP-ENC:commonAttributes"/>
</xsd:restriction>
</xsd:complexContent>
</xsd:complexType>
</xsd:schema>'
!

getArrayMultiDimString2
	^
'<xsd:schema
  targetNamespace="urn:blah"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
<xsd:import namespace="http://schemas.xmlsoap.org/wsdl/"/>
<xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/"/>
<xsd:complexType name="myType">
<xsd:complexContent>
<xsd:restriction base="SOAP-ENC:Array">
<xsd:attribute wsdl:arrayType="xsd:string[,]" ref="SOAP-ENC:arrayType"/>
</xsd:restriction>
</xsd:complexContent>
</xsd:complexType>
</xsd:schema>'
!

getArrayOfClassString1
	^
'<xsd:schema 
targetNamespace="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:ns1="http://www.dolphinharbor.org/spray/class"
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
<xsd:import namespace="http://schemas.xmlsoap.org/wsdl/"/>
<xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/"/>

<xsd:complexType name="ArrayOfSWXMLTestObject">
<xsd:complexContent>
<xsd:restriction base="SOAP-ENC:Array">
<xsd:sequence>
<xsd:element name="item" maxOccurs="unbounded" type="ns1:SWXMLTestObject" nillable="true" minOccurs="0"/>
</xsd:sequence>
<xsd:attribute wsdl:arrayType="ns1:SWXMLTestObject[]" ref="SOAP-ENC:arrayType"/>
<xsd:attribute ref="SOAP-ENC:offset"/>
<xsd:attributeGroup ref="SOAP-ENC:commonAttributes"/>
</xsd:restriction>
</xsd:complexContent>
</xsd:complexType>
<xsd:complexType name="SWXMLTestObject">
<xsd:sequence>
<xsd:element name="x" type="xsd:integer" nillable="true" minOccurs="0"/>
<xsd:element name="y" type="xsd:string" nillable="true" minOccurs="0"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'
!

getArrayOfClassString2
	^
'<xsd:schema 
targetNamespace="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:ns1="http://www.dolphinharbor.org/spray/class"
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
<xsd:import namespace="http://schemas.xmlsoap.org/wsdl/"/>
<xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/"/>

<xsd:complexType name="ArrayOfSWXMLTestObject">
<xsd:complexContent>
<xsd:restriction base="SOAP-ENC:Array">
<xsd:attribute wsdl:arrayType="ns1:SWXMLTestObject[]" ref="SOAP-ENC:arrayType"/>
</xsd:restriction>
</xsd:complexContent>
</xsd:complexType>
<xsd:complexType name="SWXMLTestObject">
<xsd:sequence>
<xsd:element name="x" type="xsd:integer" nillable="true" minOccurs="0"/>
<xsd:element name="y" type="xsd:string" nillable="true" minOccurs="0"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'
!

qInternationalPrice
	^self blahQ: 'InternationalPrice'
!

qMyType
	^self blahQ: 'myType'
!

qPurchaseOrderType
	^self blahQ: 'PurchaseOrderType'
! !

!XeSchemaWriterDefTest methodsFor:'asserting'!

assertSameComplex
	self assert: content childElements size = recon childElements size.
	self assert: content attributes size = recon attributes size.
	content childElements with: recon childElements do: [ :cE :rE |
		self assert: cE isFormQualified = rE isFormQualified.
		self assert: cE qName = rE qName].
	content attributes with: recon attributes do: [ :cA :rA |
		self assert: cA isFormQualified = rA isFormQualified.
		self assert: cA qName = rA qName]


!

assertSchema: aString
	| xml schema |
	schemaWriter define: content.
	self assertXML: (xml := schemaWriter xml) isSameAs: aString.
	"replace the schema"
	schema := (XeSchema forNode: schemaWriter schemaNode asParserNode) typespace: typespace.
	typespace schemaDict at: schema targetNS put: schema.
	recon := content typeName xeContentWith: self encodingStyle.
	self assert: ((recon isKindOf: content class) or: [content isKindOf: recon class]).
	self assert: content childElements size = recon childElements size
! !

!XeSchemaWriterDefTest methodsFor:'tests'!

testDefine2001ArrayOfClass
	self be2001Typespace.
	self setTargetNamespace: XeNamespace sprayClass.
	content := self getArrayOfClassContent.
	self assertSchema: self getArrayOfClassString2
!

testDefine2001LiteralClassWithAttribute
	self be2001LiteralTypespace.
	self setTargetNamespace: XeNamespace sprayClass.
	content := (XeQName sprayClass: SWXMLTestExtObject) xeContentWith: self encodingStyle.
	self 
		assertSchema: '<xsd:schema
  targetNamespace="http://www.dolphinharbor.org/spray/class"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="SWXMLTestExtObject">
<xsd:sequence>
<xsd:element name="x" type="xsd:integer"/>
<xsd:element name="y" type="xsd:string"/>
</xsd:sequence>
<xsd:attribute name="a" type="xsd:float"/>
<xsd:attribute name="b" type="xsd:string"/>
</xsd:complexType>
</xsd:schema>'
!

testDefine2001LiteralSimple
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self schemaImport: (XeTestSchemaImport for: #complexSimpleContent).
	content := self qInternationalPrice xeContentWith: self encodingStyle.
	self 
		assertSchema: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">

<xsd:complexType name="InternationalPrice">
<xsd:simpleContent>
<xsd:extension base="xsd:decimal">
<xsd:attribute name="currency" type="xsd:string"/>
</xsd:extension>
</xsd:simpleContent>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefine2001LiteralSoapStruct
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	content := self getSoapStructContent typeName: self qMyType.
	self 
		assertSchema: 
'<xsd:schema   targetNamespace="urn:blah"
xmlns:xsd="http://www.w3.org/2001/XMLSchema">

<xsd:complexType name="myType">
<xsd:sequence>
<xsd:element name="varString" type="xsd:string"/>
<xsd:element name="varInt" type="xsd:int"/>
<xsd:element name="varFloat" type="xsd:float"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefine2001LiteralSoapStructNillable
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	content := self getSoapStructContent typeName: self qMyType.
	content childElements first beNillable.
	self 
		assertSchema: 
'<xsd:schema   targetNamespace="urn:blah"
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="myType">
<xsd:sequence>
<xsd:element name="varString" type="xsd:string" nillable="true" minOccurs="0"/>
<xsd:element name="varInt" type="xsd:int"/>
<xsd:element name="varFloat" type="xsd:float"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefine2001LiteralSoapStructQ
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	content := self getSoapStructContent typeName: self qMyType.
	content childElements first beFormQualifiedNS: #'urn:blah'.
	self 
		assertSchema: 
'<xsd:schema  targetNamespace="urn:blah"
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="myType">
<xsd:sequence>
<xsd:element name="varString" type="xsd:string" form="qualified"/>
<xsd:element name="varInt" type="xsd:int"/>
<xsd:element name="varFloat" type="xsd:float"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefine2001LiteralWithAttribute
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute).
	content := self qPurchaseOrderType xeContentWith: self encodingStyle.
	self 
		assertSchema: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">

<xsd:complexType name="PurchaseOrderType">
<xsd:sequence>
<xsd:element name="shipTo" type="xsd:string"/>
<xsd:element name="number" type="xsd:int"/>
</xsd:sequence>
<xsd:attribute name="orderFloat" type="xsd:float"/>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefine2001LiteralWithAttributeAny
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self importSchemaString: XeTestSchemaImports new complexDefAttributeAny.
	content := self qPurchaseOrderType xeContentWith: self encodingStyle.
	self 
		assertSchema: '<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
targetNamespace="urn:blah">

<xsd:complexType name="PurchaseOrderType">
<xsd:sequence>
<xsd:element name="shipTo" type="xsd:string"/>
<xsd:element name="number" type="xsd:int"/>
</xsd:sequence>
<xsd:anyAttribute/>
</xsd:complexType>
</xsd:schema> '
	"self assertSameComplex"
!

testDefine2001LiteralWithAttributeDefault
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self importSchemaString: XeTestSchemaImports new complexDefAttributeDefault.
	content := self qPurchaseOrderType xeContentWith: self encodingStyle.
	self 
		assertSchema: '<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
targetNamespace="urn:blah">

<xsd:complexType name="PurchaseOrderType">
<xsd:sequence>
<xsd:element name="shipTo" type="xsd:string"/>
<xsd:element name="number" type="xsd:int"/>
</xsd:sequence>
<xsd:attribute name="orderFloat" type="xsd:anyType"/>
</xsd:complexType>
</xsd:schema> '.
	self assertSameComplex
!

testDefine2001LiteralWithAttributeFixed
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self importSchemaString: XeTestSchemaImports new complexDefAttributeFixed.
	content := self qPurchaseOrderType xeContentWith: self encodingStyle.
	self 
		assertSchema: '<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
targetNamespace="urn:blah">

<xsd:complexType name="PurchaseOrderType">
<xsd:sequence>
<xsd:element name="shipTo" type="xsd:string"/>
<xsd:element name="number" type="xsd:int"/>
</xsd:sequence>
<xsd:attribute name="orderFloat" type="xsd:float" fixed="1.0"/>
</xsd:complexType>
</xsd:schema> '.
	self assertSameComplex
!

testDefine2001MultiDim
	self be2001Typespace.
	self setBlahTargetNamespace.
	content := self getSoapMDArrayContent.
	content typeName: self qMyType.
	self assertSchema: self getArrayMultiDimString2
!

testDefine2001SoapStruct
	self be2001Typespace.
	self setBlahTargetNamespace.
	content := self getSoapStructContent typeName: self qMyType.
	self 
		assertSchema: 
'<xsd:schema targetNamespace="urn:blah"
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="myType">
<xsd:sequence>
<xsd:element name="varString" type="xsd:string" nillable="true" minOccurs="0"/>
<xsd:element name="varInt" type="xsd:int" nillable="true" minOccurs="0"/>
<xsd:element name="varFloat" type="xsd:float" nillable="true" minOccurs="0"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineEFDLiteralClassEFDQ
	self be2001FQLiteralTypespace.
	self setTargetNamespace: XeNamespace sprayClass.
	content := ((XeElementSpec named: #blah class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle) content.
	self 
		assertSchema: '<xsd:schema
  targetNamespace="http://www.dolphinharbor.org/spray/class"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">

<xsd:complexType name="SWXMLTestObject">
<xsd:sequence>
<xsd:element form="qualified" name="x" type="xsd:integer" />
<xsd:element form="qualified" name="y" type="xsd:string" />
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineEFDLiteralSimpleEFDQ
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self schemaImport: (XeTestSchemaImport for: #complexSimpleContent) beAFDQ.
	content := self qInternationalPrice xeContentWith: self encodingStyle.
	self 
		assertSchema: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="InternationalPrice">
<xsd:simpleContent>
<xsd:extension base="xsd:decimal">
<xsd:attribute form="qualified" name="currency" type="xsd:string"/>
</xsd:extension>
</xsd:simpleContent>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineEFDLiteralWithAttributeEFDQ
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute) beAFDQ.
	content := self qPurchaseOrderType xeContentWith: self encodingStyle.
	self 
		assertSchema: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="PurchaseOrderType">
<xsd:sequence>
<xsd:element name="shipTo" type="xsd:string"/>
<xsd:element name="number" type="xsd:int"/>
</xsd:sequence>
<xsd:attribute form="qualified" name="orderFloat" type="xsd:float"/>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineEFDNQLiteralSoapStructQ
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	content := self getSoapStructContent typeName: self qMyType.
	content childElements first beFormQualifiedNS: #'urn:blah'.
	schemaWriter beElementFormQualified.
	self 
		assertSchema: 
'<xsd:schema 
  elementFormDefault="qualified"
  targetNamespace="urn:blah"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="myType">
<xsd:sequence>
<xsd:element name="varString" type="xsd:string"/>
<xsd:element form="unqualified" name="varInt" type="xsd:int"/>
<xsd:element form="unqualified" name="varFloat" type="xsd:float"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineEFDQLiteralClassEFDQ
	self be2001FQLiteralTypespace.
	self setTargetNamespace: XeNamespace sprayClass.
	content := ((XeElementSpec named: #blah class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle) content.
	schemaWriter beElementFormQualified.
	self 
		assertSchema: '<xsd:schema
 elementFormDefault="qualified"
  targetNamespace="http://www.dolphinharbor.org/spray/class"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="SWXMLTestObject">
<xsd:sequence>
<xsd:element name="x" type="xsd:integer"/>
<xsd:element name="y" type="xsd:string"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineEFDQLiteralSimpleEFDQ
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self schemaImport: (XeTestSchemaImport for: #complexSimpleContent) beAFDQ.
	content := self qInternationalPrice xeContentWith: self encodingStyle.
	schemaWriter beAttributeFormQualified.
	self 
		assertSchema: '<xsd:schema targetNamespace="urn:blah" 
attributeFormDefault="qualified"
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="InternationalPrice">
<xsd:simpleContent>
<xsd:extension base="xsd:decimal">
<xsd:attribute name="currency" type="xsd:string"/>
</xsd:extension>
</xsd:simpleContent>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineEFDQLiteralSoapStruct
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	content := self getSoapStructContent typeName: self qMyType.
	schemaWriter beElementFormQualified.
	self 
		assertSchema: 
'<xsd:schema 
  elementFormDefault="qualified"
  targetNamespace="urn:blah"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="myType">
<xsd:sequence>
<xsd:element form="unqualified" name="varString" type="xsd:string"/>
<xsd:element form="unqualified" name="varInt" type="xsd:int"/>
<xsd:element form="unqualified" name="varFloat" type="xsd:float"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineEFDQLiteralWithAttributeEFDQ
	self be2001LiteralTypespace.
	self setBlahTargetNamespace.
	self schemaImport: (XeTestSchemaImport for: #complexWithAttribute) beAFDQ.
	content := self qPurchaseOrderType xeContentWith: self encodingStyle.
	schemaWriter beAttributeFormQualified.
	self 
		assertSchema: '<xsd:schema targetNamespace="urn:blah" 
attributeFormDefault="qualified"
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:complexType name="PurchaseOrderType">
<xsd:sequence>
<xsd:element name="shipTo" type="xsd:string"/>
<xsd:element name="number" type="xsd:int"/>
</xsd:sequence>
<xsd:attribute name="orderFloat" type="xsd:float"/>
</xsd:complexType>
</xsd:schema>'.
	self assertSameComplex
!

testDefineRestriction
	self be2001Typespace.
	self setBlahTargetNamespace.
	content := self getRestrictionOfString.
	self 
		assertSchema: 
'<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:simpleType name="foo">
<xsd:restriction base="xsd:string">
<xsd:maxLength value="10"/>
</xsd:restriction>
</xsd:simpleType>
</xsd:schema>'
!

testDefineRestriction2
	self be2001Typespace.
	self setBlahTargetNamespace.
	content := self getRestrictionOfString2.
	self 
		assertSchema: 
'<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">

<xsd:simpleType name="foo">
<xsd:restriction base="xsd:string">
<xsd:maxLength value="10"/>
<xsd:minLength value="5"/>
</xsd:restriction>
</xsd:simpleType>
</xsd:schema>'
!

testDefineSimple
	self be2001Typespace.
	self setTargetNamespace: XeSpraySimpleFactory defaultTargetNamespace.
	content := self getSimpleContentSTB.
	schemaWriter define: content.
	self assertXML: schemaWriter xml isSameAs: 

'<xsd:schema targetNamespace="http://www.dolphinharbor.org/spray/simple" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/"/><xsd:simpleType name="stb"><xsd:restriction base="SOAP-ENC:base64"/></xsd:simpleType></xsd:schema>'
! !

!XeSchemaWriterDefTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSchemaWriterDefTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
