"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSchemaWriterTests subclass:#XeSchemaWriterTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSchemaWriterTest methodsFor:'accessing'!

getArrayOnlyString1
	^
'<xsd:schema 
targetNamespace="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:ns1="urn:blah"
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
<xsd:import namespace="http://schemas.xmlsoap.org/wsdl/"/>
<xsd:import namespace="urn:blah"/>
<xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/"/>
<xsd:complexType name="ArrayOfSWXMLTestObject">
<xsd:complexContent>
<xsd:restriction base="SOAP-ENC:Array">
<xsd:sequence>
<xsd:element name="item" maxOccurs="unbounded" type="ns1:SWXMLTestObject" nillable="true" minOccurs="0"/>
</xsd:sequence>
<xsd:attribute wsdl:arrayType="ns1:SWXMLTestObject[]" ref="SOAP-ENC:arrayType"/>
<xsd:attribute ref="SOAP-ENC:offset"/>
<xsd:attributeGroup ref="SOAP-ENC:commonAttributes"/>
</xsd:restriction>
</xsd:complexContent>
</xsd:complexType>
</xsd:schema>'
!

getArrayOnlyString2
	^
'<xsd:schema 
targetNamespace="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:ns1="urn:blah"
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
<xsd:import namespace="urn:blah"/>
<xsd:import namespace="http://schemas.xmlsoap.org/wsdl/"/>
<xsd:import namespace="http://schemas.xmlsoap.org/soap/encoding/"/>
<xsd:complexType name="ArrayOfSWXMLTestObject">
<xsd:complexContent>
<xsd:restriction base="SOAP-ENC:Array">
<xsd:attribute wsdl:arrayType="ns1:SWXMLTestObject[]" ref="SOAP-ENC:arrayType"/>
</xsd:restriction>
</xsd:complexContent>
</xsd:complexType>
</xsd:schema>'
!

qAbc
	^self blahQ: 'abc'
! !

!XeSchemaWriterTest methodsFor:'tests'!

testDeclare1999Any
	self be1999Typespace.
	self setBlahTargetNamespace.
	schemaWriter 
		declareGlobally: ((XeElementSpec anyNamed: self qAbc) xeParticleWith: self encodingStyle).
	self 
		assertSchemaXML: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/1999/XMLSchema">
<xsd:element name="abc" type="xsd:ur-type"/>
</xsd:schema>'
!

testDeclare2001Any
	self be2001Typespace.
	self setBlahTargetNamespace.
	schemaWriter 
		declareGlobally: ((XeElementSpec anyNamed: self qAbc) xeParticleWith: self encodingStyle).
	self 
		assertSchemaXML: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:element name="abc" type="xsd:anyType" />
</xsd:schema>'
!

testDeclare2001Base
	self be2001Typespace.
	self setBlahTargetNamespace.
	schemaWriter declareGlobally: ((XeElementSpec named: self qAbc xsd: 'string') 
				xeParticleWith: self encodingStyle).
	self 
		assertSchemaXML: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:element name="abc" type="xsd:string" />
</xsd:schema>'
!

testDeclare2001Class
	self be2001Typespace.
	self setBlahTargetNamespace.
	schemaWriter declareGlobally: ((XeElementSpec named: self qAbc class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle).
	self 
		assertSchemaXML: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:d="http://www.dolphinharbor.org/spray/class">
<xsd:import namespace="http://www.dolphinharbor.org/spray/class"/>
<xsd:element name="abc" type="d:SWXMLTestObject"/>
</xsd:schema>'
!

testDeclare2001ClassTwice
	self be2001Typespace.
	self setBlahTargetNamespace.
	schemaWriter declareGlobally: ((XeElementSpec named: self qAbc class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle).
	schemaWriter declareGlobally: ((XeElementSpec named: self qAbc class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle).
	self 
		assertSchemaXML: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:d="http://www.dolphinharbor.org/spray/class">
<xsd:import namespace="http://www.dolphinharbor.org/spray/class"/>
<xsd:element name="abc" type="d:SWXMLTestObject"/>
</xsd:schema>'
!

testDeclare2001SimpleClassTwice
	| element |
	self be2001LiteralTypespace.
	XeNamespace.
	self setBlahTargetNamespace.
	element := (XeElementSpec named: self qAbc
				typeName: (#SWXMLTestSimpleObject ns: XeNamespace spraySimpleClass)) 
					xeParticleWith: self encodingStyle.
	schemaWriter declareGlobally: element.
	schemaWriter declareGlobally: element.
	self 
		assertSchemaXML: '<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:ns1="http://www.dolphinharbor.org/spray/simpleClass">
<xsd:import namespace="http://www.dolphinharbor.org/spray/simpleClass"/>
<xsd:element name="abc" type="ns1:SWXMLTestSimpleObject"/>
</xsd:schema>'
!

testDeclareInline2001Class
	| element |
	self be2001Typespace.
	self setBlahTargetNamespace.
	element := (XeElementSpec named: self qAbc class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle.
	element content typeName: nil.
	schemaWriter declareGlobally: element.
	self 
		assertSchemaXML: '<xsd:schema targetNamespace="urn:blah" 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:element name="abc">
<xsd:complexType>
<xsd:sequence>
<xsd:element name="x" type="xsd:integer" nillable="true" minOccurs="0"/>
<xsd:element name="y" type="xsd:string" nillable="true" minOccurs="0"/>
</xsd:sequence>
</xsd:complexType>
</xsd:element>
</xsd:schema>'
!

testDeclareInline2001ClassComp
	| element |
	self be2001Typespace.
	self setBlahTargetNamespace.
	element := (XeElementSpec named: self qAbc class: SWXMLTestComposite) 
				xeParticleWith: self encodingStyle.
	element content typeName: nil.
	schemaWriter declareGlobally: element.
	self 
		assertSchemaXML: '<xsd:schema
 targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
 xmlns:d="http://www.dolphinharbor.org/spray/class">
<xsd:import namespace="http://www.dolphinharbor.org/spray/class"/>
<xsd:element name="abc">
<xsd:complexType>
<xsd:sequence>
<xsd:element name="object1" type="d:SWXMLTestObject" nillable="true" minOccurs="0"/>
<xsd:element name="object2" type="d:SWXMLTestObject" nillable="true" minOccurs="0"/>
<xsd:element name="number" type="xsd:integer" nillable="true" minOccurs="0"/>
</xsd:sequence>
</xsd:complexType>
</xsd:element>
</xsd:schema>'
!

testDefine2001ArrayExtOnly
	| content |
	self be2001Typespace.
	self setTargetNamespace: XeNamespace sprayClass.
	content := self getArrayOfClassContent.
	content typeName namespace: #'urn:blah'.
	schemaWriter define: content.
	self 
		assertSchemaXML: 
'<xsd:schema 
targetNamespace="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:ns1="urn:blah"
xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
<xsd:complexType name="SWXMLTestObject">
<xsd:sequence>
<xsd:element name="x" type="xsd:integer" nillable="true" minOccurs="0"/>
<xsd:element name="y" type="xsd:string" nillable="true" minOccurs="0"/>
</xsd:sequence>
</xsd:complexType>
</xsd:schema>'
!

testDefine2001ArrayOnly
	| content |
	self be2001Typespace.
	self setTargetNamespace: XeNamespace sprayClass.
	content := self getArrayOfClassContent.
	content childTypeName namespace: #'urn:blah'.
	schemaWriter define: content.
	self assertSchemaXML: self getArrayOnlyString2
!

testDefineSimpleTwice
	| content |
	self be2001Typespace.
	self setBlahTargetNamespace.
	content := self getRestrictionOfString.
	schemaWriter define: content.
	schemaWriter define: content.
	self 
		assertSchemaXML: 
'<xsd:schema targetNamespace="urn:blah" 
xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<xsd:simpleType name="foo">
<xsd:restriction base="xsd:string">
<xsd:maxLength value="10"/>
</xsd:restriction>
</xsd:simpleType>
</xsd:schema>'
! !

!XeSchemaWriterTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSchemaWriterTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
