"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSchemaFactoriesTests subclass:#XeSimpleClassFactoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSimpleClassFactoryTest methodsFor:'accessing'!

setFactory
	factory := (typespace schemaTargeting: XeNamespace spraySimpleClass) factory
! !

!XeSimpleClassFactoryTest methodsFor:'asserting'!

assertTestSimpleContent
	self assert: (content isKindOf: XeSimpleExtendedContent).
	self assert: content baseContent typeName = (XeQName xsd2001: 'float').
	self assert: content attributes size = 2.
	self assert: content convertClass = SWXMLTestSimpleObject.
	content attributes do: 
			[:each | 
			self assert: (each isKindOf: XeAttribute).
			self deny: each isFixed.
			self assert: each isOptional.].
	self assert: content attributes first localName = 'a'.
	self assert: content attributes first content typeName = (XeQName xsd2001: 'float').
	self assert: content attributes second localName = 'b'.
	self assert: content attributes second content typeName = (XeQName xsd2001: 'string')
! !

!XeSimpleClassFactoryTest methodsFor:'set up'!

setUp
	super setUp.
	self be2001LiteralTypespace.
	self setFactory
! !

!XeSimpleClassFactoryTest methodsFor:'tests'!

testFormQualified
	self schema factory isAttributeFormQualified: true.
	content := self schema defaultEncContent: 'SWXMLTestSimpleObject'.
	self assertTestSimpleContent.
	content attributes do: [:each | self assert: each isFormQualified].
!

testMapped
	"(XeClassMap 
		map: 'mySimple'
		to: SWXMLTestSimpleObject
		in: XeNamespace spraySimpleClass) createIn: typespace."
	typespace mapTypeName: ('mySimple' ns: XeNamespace spraySimpleClass) to: SWXMLTestSimpleObject.
	content := self schema defaultEncContent: 'mySimple'.
	self assert: content typeName = ('mySimple' ns: XeNamespace spraySimpleClass).
	self assertTestSimpleContent.
	content attributes do: [:each | self deny: each isFormQualified]
!

testSimple
	content := self schema defaultEncContent: 'SWXMLTestSimpleObject'.
	self assertTestSimpleContent.
	content attributes do: [:each | self deny: each isFormQualified].
! !

!XeSimpleClassFactoryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSimpleClassFactoryTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
