"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeContentTests subclass:#XeSimpleRestrictedContentTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSimpleRestrictedContentTest methodsFor:'tests'!

testBaseContent
	self be2001Typespace.
	content := (XePName xsd: 'float') xeContentWith: self encodingStyle.
	self assert: content baseTypeName = (XeQName xsd2001: 'double').
	self assert: content baseContent typeName = (XeQName xsd2001: 'double')
!

testChildElement
	self be2001Typespace.
	content := (XePName xsd: 'float') xeContentWith: self encodingStyle.
	self assert: content childElements isEmpty
!

testShouldntValidate
	self be2001Typespace.
	content := (XePName xsd: 'float') xeContentWith: self encodingStyle.
	self assert: (content shouldntValidate: nil).
	self assert: (content shouldntValidate: XeAnyValue new).
	self deny: (content shouldntValidate: '123')
!

testValidate
	self be2001Typespace.
	self importEnumerationSchema.
	content := 'enumns:EyeColor' asXeName xeContentWith: self encodingStyle.
	content validate: 'Green'.
	content validate: 'Blue'.
	self should: [content validate: 'Black'] raise: XeValueMismatch
! !

!XeSimpleRestrictedContentTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSimpleRestrictedContentTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
