"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSchemaFactoriesTests subclass:#XeSoapEncFactoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSoapEncFactoryTest methodsFor:'set up'!

setUp
	super setUp.
	self be2001Typespace.
	factory := (typespace schemaTargeting: XeNamespace soapEnc) factory
! !

!XeSoapEncFactoryTest methodsFor:'tests'!

testArray
	content := self schema defaultEncContent: 'Array'.
	self assert: (content isKindOf: XeSoapArrayContent).
	self assert: content localName = 'Array'.
	self assert: content namespace = XeNamespace soapEnc.
	self assert: content typespace notNil.
	self assert: content childElement content typeName = (XeQName xsd2001: 'anyType')
!

testArray1999
	self be1999Typespace.
	factory := (typespace schemaTargeting: XeNamespace soapEnc) factory.
	content := self schema defaultEncContent: 'Array'.
	self assert: content childElement content localName = 'ur-type'.
	self assert: content childElement content namespace = XeNamespace schema1999
!

testArrayDeclared
	| name element |
	name := XeQName 
				prefix: 'soap'
				local: 'Array'
				ns: XeNamespace soapEnc.
	element := self schema xeElementDeclared: name encStyle: self encodingStyle.
	self assert: (element content isKindOf: XeSoapArrayContent).
	self assert: element content localName = 'Array'.
	self assert: element content namespace = XeNamespace soapEnc.
	self assert: element content typespace notNil
!

testBase64
	content := self schema defaultEncContent: 'base64'.
	self assert: (content isKindOf: XeSimpleContent).
	self assert: content localName = 'base64'.
	self assert: content namespace = XeNamespace soapEnc
!

testXSDDeclared
	| name element |
	name := XeQName 
				prefix: 'soap'
				local: 'integer'
				ns: #'http://schemas.xmlsoap.org/soap/encoding/'.
	element := self schema xeElementDeclared: name encStyle: self encodingStyle.
	self assert: element content typeName = (XeQName xsd2001: 'integer')
! !

!XeSoapEncFactoryTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSoapEncFactoryTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
