"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSchemaDefReadTests subclass:#XeSoapEncSchemaDefReadTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSoapEncSchemaDefReadTest methodsFor:'accessing'!

setTypespace
	self be2001Typespace
        
! !

!XeSoapEncSchemaDefReadTest methodsFor:'tests'!

test1999BaseAttributeCompatibility
	self importSchemaString: XeTestSchemaImports new complexDef1999Array.
	self setContentFromSchema: 'ArrayOfPersonStruct'.
	self assertContent: 
			[self assert: (content isKindOf: XeSoapArrayContent).
			self assert: (content childElement isKindOf: XeElement).
			self assert: content firstChildContent typeName localName = 'PersonStruct'.
			self assert: content firstChildContent firstChildElement qName localName = 'fName']
!

test1999BaseAttributeCompatibility2
	self importSchemaString: XeTestSchemaImports new complexDef1999ArrayOfBase.
	self setContentFromSchema: 'ArrayOfint'.
	self assertContent: 
			[self assert: self localName = 'ArrayOfint'.
			self assert: (content isKindOf: XeSoapArrayContent).
			self assert: (content childElement isKindOf: XeElement).
			self assert: content childElement qName localName = 'item'.
			self assert: content childTypeName localName = 'int'.
			self assert: content childTypeName namespace = #'http://www.w3.org/1999/XMLSchema']
!

test1999WSDL11Arrays
	self importSchemaString: XeTestSchemaImports new arrayWSDL11.
	self setContentFromSchema: 'ArrayOffloat'.
	self assertContent: 
			[self assert: (content isKindOf: XeSoapArrayContent).
			self assert: (content childElement isKindOf: XeElement).
			self assert: content childElement qName localName = 'item'.
			self assert: content childTypeName localName = 'float'.
			self assert: content childTypeName namespace = #'http://www.w3.org/2001/XMLSchema']
!

test200010ArrayOfComplex
	self importSchemaString: XeTestSchemaImports new complexDef200010ArrayOfComp.
	self setContentFromSchema: 'ArrayOfData'.
	self assertContent: 
			[| eContent |
			self assert: (content isKindOf: XeSoapArrayContent).
			self assert: (content childElement isKindOf: XeElement).
			eContent := content childElement content.
			self assert: eContent localName = 'Data'.
			self assert: eContent firstChildElement qName localName = 'varInt'.
			self assert: eContent firstChildContent namespace = #'http://www.w3.org/2000/10/XMLSchema'.
			self assert: content childTypeName localName = 'Data'.
			self assert: content childTypeName namespace = #'http://soapinterop.org/rpc']
!

test200010ArrayOfSimple
	self importSchemaString: XeTestSchemaImports new complexDef200010ArrayOfSimple.
	self setContentFromSchema: 'ArrayOffloat'.
	self assertContent: 
			[self assert: (content isKindOf: XeSoapArrayContent).
			self assert: (content childElement isKindOf: XeElement).
			self assert: content childTypeName localName = 'float'.
			self assert: content childTypeName namespace = #'http://www.w3.org/2000/10/XMLSchema']
!

test2001ArrayOfSimple
	self importSchemaString: XeTestSchemaImports new arraySimple.
	self setContentFromSchema: 'ArrayOfint'.
	self assertContent: 
			[self assert: content localName = 'ArrayOfint'.
			self assert: (content isKindOf: XeSoapArrayContent).
			self assert: (content childElement isKindOf: XeElement).
			self assert: content childElement qName localName = 'item'.
			self assert: content childElement content localName = 'int'.
			self assert: content childElement content namespace = XeNamespace schema2001]
!

test2001ComplexTypeEFDQ
	self importSchemaString: XeTestSchemaImports new complexDefSSEFDQ.
	self setContentFromSchema: 'MySoapStruct'.
	self assertContent: 
			[| childContent |
			self assert: (content isKindOf: XeComplexContent).
			self assert: (self symmetricDifferenceOf:content accessorKeys and: self acessorKeys2001ComplexType) isEmpty.
			childContent := (content childLocallyNamed: 'varFloat') content.
			self assert: childContent typeName = (XeQName xsd2001: 'float')]
!

test2001ComplexTypeWithRef
	self importSchemaString: XeTestSchemaImports new complexDefWithRef.
	self setContentFromSchema: 'MySoapStruct'.
	self assertContent: 
			[| childContent |
			self assert: (content isKindOf: XeComplexContent).
			self assert: (content accessorKeys includes: (XeQName null: 'varInt')).
			self assert: (content accessorKeys includes: (XeQName null: 'varFloat')).
			self assert: (content accessorKeys includes: (XeQName null: 'varString')).
			childContent := (content childLocallyNamed: 'varFloat') content.
			self assert: childContent typeName = (XeQName xsd2001: 'float')]
!

test2001List
	"self halt."

	self importSchemaString: XeTestSchemaImports new complexDefList.
	self setContentFromSchema: 'List'.
	self class isSkipAckFailures ifTrue: [^nil].
	self assertContent: 
			[| childContent |
			self assert: (content isKindOf: XeComplexContent).
			childContent := (content childLocallyNamed: 'child') content.
			self assert: childContent typeName = ('List' ns: #'urn:mySample')]
!

test2001RefElement
	self importSchemaString: XeTestSchemaImports new complexDefWithRef2.
	self setContentFromSchema: 'AnAddressType'.
	self assertContent: 
			[| commentContent |
			self assert: (content isKindOf: XeComplexContent).
			self assert: (self symmetricDifferenceOf:content accessorKeys and: self acessorKeysRefElement) isEmpty.
			commentContent := (content childLocallyNamed: 'comment') content.
			self assert: commentContent typeName = (XeQName xsd2001: 'string')]
!

test2001RestrictionArrayOfSimple
	self importSchemaString: XeTestSchemaImports new arrayRestrictionSimple.
	self setContentFromSchema: 'ArrayOfstring'.
	self assertContent: 
			[self assert: (content isKindOf: XeSoapArrayContent).
			self assert: (content childElement isKindOf: XeElement).
			self assert: content childElement qName localName = 'item'.
			self assert: content childTypeName localName = 'string'.
			self assert: content childTypeName namespace = #'http://www.w3.org/2001/XMLSchema']
!

test2001SimpleContent
	self importSchemaString: XeTestSchemaImports new complexDefSimple2.

	"Not yet implemented"
	self should: [schema defaultEncContent: 'USAddress'] raise: Error
!

test2001WSDL11ArrayOfSimple
	self importSchemaString: XeTestSchemaImports new arrayWSDL11.
	self setContentFromSchema: 'ArrayOffloat'.
	self assertContent: 
			[self assert: (content isKindOf: XeSoapArrayContent).
			self assert: (content childElement isKindOf: XeElement).
			self assert: content childElement qName localName = 'item'.
			self assert: content childTypeName localName = 'float'.
			self assert: content childTypeName namespace = #'http://www.w3.org/2001/XMLSchema']
!

test2001WSDL11Arrays2D
	self importSchemaString: XeTestSchemaImports new arrayWSDL112D.
	self setContentFromSchema: 'ArrayOfString2D'.
	self assertContent: 
			[self assert: (content isKindOf: XeSoapMultiDimContent).
			self assert: (content childElement isKindOf: XeElement).
			self assert: content childElement qName localName = 'item'.
			self assert: content childTypeName localName = 'string'.
			self assert: content childTypeName namespace = #'http://www.w3.org/2001/XMLSchema']
!

testUSAddress
	"Cant understand attribute declarations"

self importSchemaString: XeTestSchemaImports new complexDefUSAddress.

	self should: [schema defaultEncContent: 'USAddress'] raise: Error
! !

!XeSoapEncSchemaDefReadTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSoapEncSchemaDefReadTest.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
