"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeWriteReadTests subclass:#XeSoapEncWriteReadTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSoapEncWriteReadTests methodsFor:'accessing'!

beFormQualified
	element beFormQualified
!

beFormUnqualified
	element beFormUnqualified
!

beNoRef
	writer isIDHref: false
!

beSoapEncRef
		writer isIDHref: true
!

beXSITypeArrays
	^self typespaceOptions beXSITypeArrays
!

setMultiDimString23
	instance := Dolphin::LookupTable new.
	instance 
		at: (1@1) put:  'r1c1';
		at: (1@2) put: 'r1c2';
		at: (1@3) put: 'r1c3';
		at: (2@1) put: 'r2c1';
		at: (2@2) put: 'r2c2';
		at: (2@3) put: 'r2c3'.

!

withOptions: anArray assertContentXML: aString 
	"Set the options
	-encode the object using supplied element
	--assert the xml is the same as supplied
	-decode that xml using supplied element
	--assert the decoded object is the = to the original
	-decode that xml again, constructing an element from it
	--If typed, check the decoded object is = to the original
	--If not typed, we have no chance, but it still should decode (guessing) without error"

	self setUp.
	anArray do: [:each | self perform: each].
	self encode.
	self assertContentXML: aString.
	self setDecodeObjectFromElement.
	self assertDecodeToSame.
	self setDecodeObjectFromNode.
	element isTyped ifTrue: [
		self assertDecodeToSame].
! !

!XeSoapEncWriteReadTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSoapEncWriteReadTests.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
