"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeContentTests subclass:#XeSoapRPCContentTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSoapRPCContentTest methodsFor:'accessing'!

getEmptyRPCContent
	self be1999Typespace.
	^(XeSoapRPCContent new)
		typeName: (XeQName fromString: 'blah');
		childElements: OrderedCollection new;
		encodingStyle: self encodingStyle;
		convertClass: XeQStruct;
		yourself
!

getMultipleRPCContent
	| specs |
	self be2001Typespace.
	specs := OrderedCollection new.
	specs
		add: (XeElementSpec named: 'x' xsd: 'integer');
		add: (XeElementSpec named: 'y' xsd: 'string').
	^self encodingStyle complexRPC: (XeQName fromString: 'blah') specs: specs
	"^XeSoapRPCContent 
				typeName: (XeQName fromString: 'blah')
				childSpecs: specs
				encodingStyle: self encodingStyle."
!

getSingleRPCContent
	self be2001Typespace.
	^self encodingStyle complexRPC: (XeQName fromString: 'blah')
		specs: (Array with: (XeElementSpec named: 'x' xsd: 'integer'))

	"^XeSoapRPCContent 
				typeName: (XeQName fromString: 'blah')
				childSpecs: (Array with: (XeElementSpec named: 'x' xsdTyped: 'integer'))
				encodingStyle: self encodingStyle."
! !

!XeSoapRPCContentTest methodsFor:'tests'!

testAccessorSymbols
	"empty"

	self assert: self getEmptyRPCContent accessorKeys isEmpty.
	self assert: self getEmptyRPCContent firstAccessorKeyOrNil isNil.
	"single"
	self assert: self getSingleRPCContent accessorKeys size = 1.
	self assert: self getSingleRPCContent accessorKeys first localName = 'x'.
	self assert: self getSingleRPCContent firstAccessorKey localName = 'x'.
	self assert: self getSingleRPCContent firstAccessorKeyOrNil localName = 'x'.
	"multiple"
	self assert: self getMultipleRPCContent accessorKeys size = 2.
	self assert: self getMultipleRPCContent accessorKeys first localName = 'x'.
	self assert: self getMultipleRPCContent firstAccessorKey localName = 'x'.
	self assert: self getMultipleRPCContent firstAccessorKeyOrNil localName = 'x'
!

testChildElements
	self assert: self getEmptyRPCContent childElements isEmpty.
	self assert: self getSingleRPCContent childElements size = 1.
	self assert: self getMultipleRPCContent childElements size = 2
! !

!XeSoapRPCContentTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSoapRPCContentTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
