"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeATests subclass:#XeSoapTypeMismatchPolicyTest
	instanceVariableNames:'type'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSoapTypeMismatchPolicyTest methodsFor:'asserting'!

assertMatches: aCollection 
	aCollection do: [:each | self assert: (XeSoapTypeMismatchPolicy new isContent: type matched: each)]
!

denyMatches: aCollection 
	aCollection do: [:each | self deny: (XeSoapTypeMismatchPolicy new isContent: type matched: each)]
! !

!XeSoapTypeMismatchPolicyTest methodsFor:'tests'!

testArrayNamed
	self be2001Typespace.
	type := 'soapE:ArrayOfstring' asXeName xeContentWith: self encodingStyle.
	self assertMatches: (Array with: (XeQName soapEnc: 'Array')).
	self denyMatches: (Array with: (XeQName soapEnc: 'NotArray'))
!

testArrayNamedAnyNS
	self be2001Typespace.
	type := 'soapE:ArrayOfstring' asXeName xeContentWith: self encodingStyle.
	type typeName: (self blahQ: 'ArrayOfstring').
	self assertMatches: (Array with: (XeQName soapEnc: 'Array')).
	self denyMatches: (Array with: (XeQName soapEnc: 'NotArray'))
!

testArrayNotNamed
	self be2001Typespace.
	type := 'soapE:ArrayOfstring' asXeName xeContentWith: self encodingStyle.
	self assertMatches: (Array with: (XeQName soapEnc: 'Array')).
	self denyMatches: (Array with: (XeQName soapEnc: 'NotArray'))
!

testBase64
	self be2001Typespace.
	type := 'xsd:base64Binary' asXeName xeContentWith: self encodingStyle.
	self assertMatches: (Array 
				with: (XeQName xsd2001: 'base64Binary')
				with: (XeQName soapEnc: 'base64')
				with: (self blahQ: 'base64')).
	self denyMatches: (Array with: (XeQName soapEnc: 'Array'))
!

testBase64Strict
	self be2001Typespace.
	type := 'xsd:base64Binary' asXeName xeContentWith: self encodingStyle.
	self class isSkipAckFailures ifTrue: [^nil].
	self denyMatches: (Array with: (self blahQ: 'base64'))
!

testSame
	self be2001Typespace.
	type := (XePName xsd: 'integer') xeContentWith: self encodingStyle.
	self assertMatches: (Array with: (XeQName xsd1999: 'integer')).
	self denyMatches: (Array with: (XeQName xsd1999: 'float') with: (self blahQ: 'integer'))
!

testTimeInstant
	self be2001Typespace.
	type := (XeQName xsd2001: 'dateTime') xeContentWith: self encodingStyle.
	self assertMatches: (Array with: (XeQName xsd2001: 'dateTime')
				with: (XeQName xsd1999: 'timeInstant')).
	self 
		denyMatches: (Array with: (self blahQ: 'timeInstant') with: (XeQName xsd1999: 'float'))
!

testXSDRestrictedSchemaMismatch
	self be1999Typespace.
	type := 'xsd:int' asXeName xeContentWith: self encodingStyle.
	self 
		assertMatches: (Array with: (XeQName xsd1999: 'int') with: (XeQName xsd2001: 'integer'))
!

testXSDSchemaMismatch
	self be1999Typespace.
	type := (XePName xsd: 'integer') xeContentWith: self encodingStyle.
	self 
		assertMatches: (Array with: (XeQName xsd2001: 'integer') with: (XeQName xsd1999: 'integer')).
	self 
		denyMatches: (Array with: (XeQName xsd2001: 'float') with: (XeQName xsd1999: 'float'))
! !

!XeSoapTypeMismatchPolicyTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSoapTypeMismatchPolicyTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
