"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeComponentVisitorTests subclass:#XeSoapXMLReaderTest
	instanceVariableNames:'reader element node'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSoapXMLReaderTest methodsFor:'accessing'!

setWith1999Element
	self be1999Typespace.
	reader := XeSoapXMLReader read: node
				element: ((XeElementSpec named: 'blah' xsd: 'float') xeParticleWith: self encodingStyle)
!

setWith2001Typespace
	self be2001Typespace.
	reader := XeSoapXMLReader read: node in: typespace
!

setWithSoapEncDefault
	self be2001Typespace.
	reader := XeSoapXMLReader 
		readNode: node
! !

!XeSoapXMLReaderTest methodsFor:'asserting'!

assertTopNodeIdentity
	"self assert: (reader readMap topNode == node)."
	self assert: (reader topNode == node).
        
! !

!XeSoapXMLReaderTest methodsFor:'set up'!

setUp
	super setUp.
	node := self rootNodeFor: '<root>3.14</root>'
! !

!XeSoapXMLReaderTest methodsFor:'tests'!

testConstruction1999Element
	self setWith1999Element.
	self assertTopNodeIdentity
        
!

testConstruction2001Typespace
	self setWith2001Typespace.
	self assertTopNodeIdentity
        
!

testConstructionSoapEncDefault
	self setWithSoapEncDefault.
	self assertTopNodeIdentity
        
! !

!XeSoapXMLReaderTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSoapXMLReaderTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
