"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeComponentVisitorTests subclass:#XeSoapXMLWriterTest
	instanceVariableNames:'writer'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeSoapXMLWriterTest methodsFor:'set up'!

setUp
	super setUp.
	self be2001Typespace.
	writer := XeSoapXMLWriter onTopNode:  (typespace newNode: 'root')
! !

!XeSoapXMLWriterTest methodsFor:'tests'!

testBranchWith
	| branch |
	writer isIDHref: true.
	writer
		nodeObject: 1
		element: 2
		node: 3.
	branch := writer
		branchWithNodeObject: 4 
		element: 5
		node: 6.

	self assert: writer writeMap == branch writeMap.
	self assert: writer topNode == branch topNode.
	self assert: writer isIDHref = branch isIDHref = true.
	self assert: writer nodeObject = 1.
	self assert: writer currentElement = 2.
	self assert: writer currentNode = 3.
	self assert: branch nodeObject = 4.
	self assert: branch currentElement = 5.
	self assert: branch currentNode = 6.

!

testLazyCurrentNode
	writer
		nodeObject: nil
		element: nil
		node: nil.
	self assert: writer currentNode == writer topNode 
!

testWriteMap
	self assert: writer writeMap topNode == writer topNode
! !

!XeSoapXMLWriterTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeSoapXMLWriterTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
