"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

TestObjectsXe subclass:#XeTestSchemaImport
	instanceVariableNames:'selector isElementFormQualified isAttributeFormQualified target
		addDefaultNS'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeTestSchemaImport class methodsFor:'instance creation'!

for: aSelector
	^self new selector: aSelector
!

new
	^super new initialize
! !

!XeTestSchemaImport methodsFor:'accessing'!

schemaString
	^(self perform: selector) formatWith: target asString with: self schemaAttributes
!

target: aNSSymbol 
	target := aNSSymbol 
! !

!XeTestSchemaImport methodsFor:'accessing-private'!

attributeFormQualified
	isAttributeFormQualified isNil ifTrue: [^''].
	^isAttributeFormQualified
		ifTrue: ['attributeFormDefault="qualified"']
		ifFalse: ['attributeFormDefault="unqualified"']         


        
!

elementFormQualified
	isElementFormQualified isNil ifTrue: [^''].
	^isElementFormQualified
		ifTrue: ['elementFormDefault="qualified"']
		ifFalse: ['elementFormDefault="unqualified"']           


        
!

schemaAttributes
	| stream |
	stream := String writeStream.
	(stream
		nextPutAll: self elementFormQualified;
		space) nextPutAll: self attributeFormQualified.
	addDefaultNS ifTrue: [stream nextPutAll: 'xmlns="http://www.w3.org/2001/XMLSchema"'].
	^stream contents
!

selector
	^selector
!

selector: anObject
	selector := anObject
! !

!XeTestSchemaImport methodsFor:'initializing'!

initialize
	super initialize.
	addDefaultNS := false.
	target := #'urn:blah'
! !

!XeTestSchemaImport methodsFor:'modes'!

beAFDQ
	isAttributeFormQualified := true
!

beEFDQ
	isElementFormQualified := true
!

beEFDUq
	isElementFormQualified := false
! !

!XeTestSchemaImport methodsFor:'schema'!

complexSOAPStruct
^'<schema 
xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
targetNamespace="%1"
%2 >
<complexType name="SOAPStruct">
<all>
  <element name="varString" type="xsd:string"/>
  <element name="varInt" type="xsd:int"/>
  <element name="varFloat" type="xsd:float"/>
</all>
</complexType>
</schema>'
!

complexSimpleContent

^'<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
targetNamespace="%1" 
%2>
  <xsd:complexType name="InternationalPrice">
   <xsd:simpleContent>
    <xsd:extension base="xsd:decimal">
     <xsd:attribute name="currency" type="xsd:string"/>
    </xsd:extension>
   </xsd:simpleContent>
  </xsd:complexType>
</xsd:schema>'
!

complexWithAnyAttribute

^'<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
targetNamespace="%1"
%2 >
 <xsd:complexType name="PurchaseOrderType">
<xsd:sequence>
<xsd:element name="shipTo" type="xsd:string"/>
<xsd:element name="number" type="xsd:int"/>
</xsd:sequence>
<xsd:anyAttribute/>
</xsd:complexType> 
</xsd:schema>'
!

complexWithAttribute

^'<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
targetNamespace="%1"
%2 >
 <xsd:complexType name="PurchaseOrderType">
<xsd:sequence>
<xsd:element name="shipTo" type="xsd:string"/>
<xsd:element name="number" type="xsd:int"/>
</xsd:sequence>
<xsd:attribute name="orderFloat" type="xsd:float"/>
</xsd:complexType> 
</xsd:schema>'
!

complexWithForm
^'<schema 
  xmlns="http://www.w3.org/2001/XMLSchema"
  targetNamespace="%1" %2>
 <complexType name="MyType">
  <element name="comment1" type="string"/>
  <element name="comment2" type="string" form="qualified"/>
  <element name="comment3" type="string" form="unqualified"/>
</complexType>
</schema>'
! !

!XeTestSchemaImport class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeTestSchemaImport.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
