"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeFuncTests subclass:#XeValueTests
	instanceVariableNames:'element'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeValueTests methodsFor:'accessing'!

decodeStringFor: aValueString
	^'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">%1</root>' formatWith: aValueString


        
!

setFor: aTypename
	element := (XeElementSpec named: #root typeName: aTypename) 
				xeParticleWith: self encodingStyle
!

setForXSDTyped: aString
	element := (XeElementSpec named: #root xsd: aString) xeParticleWith: self encodingStyle
! !

!XeValueTests methodsFor:'asserting'!

assertDecodeString: aString raise: aClass 
	| xmlString |
	xmlString := self decodeStringFor: aString.
	self should: [element decodedObjectOf: (self rootNodeFor: xmlString)] raise: aClass
!

assertDecodeStrings: anArray raise: aClass 
	anArray do: [ :each |
		self assertDecodeString: each raise: aClass ]
!

assertValue: anObject raise: aClass 
	self should: [self assertValueEncodeAndDecode: anObject] raise: aClass 
!

assertValueEncodeAndDecode: anObject 
	| cw |
	cw := XeSoapXMLWriter write: anObject element: element beEncodeWithin.
	self assert: (element decodedObjectOf: (self rootNodeFor: cw xml)) = anObject
!

assertValues: anArray raise: aClass 
	anArray do: [ :each |
		self assertValue: each raise: aClass ]
!

assertValuesAndDisplayStrings: anArray raise: aClass 
	self assertValues: anArray raise: aClass.
	self assertDecodeStrings: (anArray collect: [ :each | each schemaDisplayString]) raise: aClass
        
!

assertValuesEncodeAndDecode: anArray 
	anArray do: [ :each |
		self assertValueEncodeAndDecode: each]
! !

!XeValueTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeValueTests.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
