"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSoapEncWriteReadTests subclass:#XeWriteReadCircularTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeWriteReadCircularTest methodsFor:'accessing'!

getPMDLL
	| s1 s2 s3 string |
	string := 'abc'.
	s1 := XeQStruct new.
	s2 := XeQStruct new.
	s3 := XeQStruct new.
	s1
		at: #varA put: s3;
		at: #varB put: string;
		at: #varC put: s2.
	s2
		at: #varA put: s1;
		at: #varB put: string;
		at: #varC put: s3.
	s3
		at: #varA put: s2;
		at: #varB put: string;
		at: #varC put: s1.
	^s1
! !

!XeWriteReadCircularTest methodsFor:'asserting'!

assertDecodeToSame
! !

!XeWriteReadCircularTest methodsFor:'tests'!

testCircularC
	self be2001Typespace.
	instance := SWXMLTestCircC example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestCircC) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode #beSoapEncRef)
		assertContentXML: '<root 
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:d="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
  <blah href="#id1"/>
    <id1 id="id1" xsi:type="d:SWXMLTestCircC"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
      <circ xsi:type="d:SWXMLTestCircB">
	 <circ xsi:type="d:SWXMLTestCircA">
	   <circ href="#id1"/>
	 </circ>
      </circ>
   </id1>
</root>'.
	self assert: decodeInstance == decodeInstance circ circ circ
!

testCircularCircCirc
	self be2001Typespace.
	instance := SWXMLTestCircCirc example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestCircCirc) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode #beSoapEncRef)
		assertContentXML: '<root
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:d="http://www.dolphinharbor.org/spray/class"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
  <blah xsi:type="d:SWXMLTestCircCirc">
    <other xsi:type="xsd:integer">1234</other>
    <circ1 href="#id1"/>
    <circ2 href="#id2"/>
  </blah>
  <id1 id="id1" xsi:type="d:SWXMLTestCircSelf"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
    <other xsi:type="xsd:integer">123</other>
    <circ href="#id1"/>
  </id1>
  <id2 id="id2" xsi:type="d:SWXMLTestCircA"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
    <circ xsi:type="d:SWXMLTestCircC">
      <circ xsi:type="d:SWXMLTestCircB">
	<circ href="#id2"/>
      </circ>
    </circ>
  </id2>
</root>'
!

testCircularDLL
	self be2001Typespace.
	instance := self getPMDLL.
	element := (XeElementSpec anyNamed: 'blah') xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode #beSoapEncRef)
		assertContentXML: '<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<blah href="#id1"/>

<id1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" id="id1" SOAP-ENC:root="0">
<varA href="#id2"/>
<varB href="#id3"/>
<varC href="#id4"/>
</id1>
<id2 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" id="id2" SOAP-ENC:root="0">
<varA href="#id4"/>
<varB href="#id3"/>
<varC href="#id1"/>
</id2>
<id4 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" id="id4" SOAP-ENC:root="0">
<varA href="#id1"/>
<varB id="id3">abc</varB>
<varC href="#id2"/>
</id4>
</root>'.
	self assert: (((decodeInstance at: #varC) at: #varC) at: #varC) == decodeInstance.
	self assert: (((decodeInstance at: #varA) at: #varA) at: #varA) == decodeInstance
!

testCircularSelf
	self be2001Typespace.
	instance := SWXMLTestCircSelf example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestCircSelf) 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode #beSoapEncRef)
		assertContentXML: '<root 
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:d="http://www.dolphinharbor.org/spray/class"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
  <blah href="#id1"/>
  <id1 id="id1" xsi:type="d:SWXMLTestCircSelf"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
    <other xsi:type="xsd:integer">123</other>
    <circ href="#id1"/>
  </id1>
</root>'.
	self assert: decodeInstance == decodeInstance circ
! !

!XeWriteReadCircularTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeWriteReadCircularTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
