"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSoapEncWriteReadTests subclass:#XeWriteReadIDTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeWriteReadIDTest methodsFor:'accessing'!

makeChildElementsTyped
	|typeName |
	typeName := (XeQName local: 'SOAPStruct' ns: #'http://soapinterop.org/xsd').
	element childElements do: [ :each | each content typeName: typeName].
!

setDoubleStringElement
	| elementSpecs content |
	elementSpecs := Array with: (XeElementSpec named: 'x' xsd: 'string')
				with: (XeElementSpec named: 'y' xsd: 'string').
	content := self getComplex: nil specs: elementSpecs.
	element := self getAnonElement: 'myStruct' content: content
!

setDoubleStringEmptyIdentValue
	| string |
	string := ''.
	instance := XeQStruct new.
	instance
		at: #x put: string;
		at: #y put: string
!

setDoubleStringIdentValue
	| string |
	string := 'abc'.
	instance := XeQStruct new.
	instance
		at: #x put: string;
		at: #y put: string
!

setDoubleStructAnyTypeElement
	| elements content |
	elements := Array with: (self encodingStyle anyElementNamed: 'struct1')
				with: (self encodingStyle anyElementNamed: 'struct2').
	content := self encodingStyle complex: nil elements: elements.
	element := self getAnonElement: 'myStruct' content: content
!

setDoubleStructElement
	| elements content |
	elements := Array with: (XeElement name: 'struct1' content: self getSoapStructContent)
				with: (XeElement name: 'struct2' content: self getSoapStructContent).
	content := self encodingStyle 
		complex: nil 
		elements: elements .

	element := self getAnonElement: 'myStruct' content: content 
!

setDoubleStructIdentValue
	| innerStruct |
	innerStruct := self getSoapStruct.
	instance := XeQStruct new.
	instance
		at: #struct1 put: innerStruct;
		at: #struct2 put: innerStruct
!

setDoubleStructIdentValueTyped
	| innerStruct |
	innerStruct := self getSoapStruct.
	innerStruct typeName: (self blahQ: 'myType').
	instance := XeQStruct new.
	instance
		at: #struct1 put: innerStruct;
		at: #struct2 put: innerStruct
!

setDoubleStructNilValue
	| innerStruct |
	innerStruct := self getSoapStruct.
	instance := XeQStruct new.
	instance
		at: #struct1 put: nil;
		at: #struct2 put: nil
!

setDoubleStructSTBElement
	| elements content |
	elements := Array with: (self getAnonElement: 'struct1' content: self getSimpleContentSTB)
				with: (self getAnonElement: 'struct2' content: self getSimpleContentSTB).
	content := self encodingStyle 
		complex: nil 
		elements: elements .
	element := self getAnonElement: 'myStruct' content: content
! !

!XeWriteReadIDTest methodsFor:'tests'!

testDoubleString
	self be2001Typespace.
	self setDoubleStringIdentValue.
	self setDoubleStringElement.
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode beNoRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><x xsi:type="xsd:string">abc</x><y xsi:type="xsd:string">abc</y></myStruct></root>'.
	self deny: ((decodeInstance at: #x) == (decodeInstance at: #y)).
	self assert: (decodeInstance at: #x) = (decodeInstance at: #y).
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode  beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><x id="id1" xsi:type="xsd:string">abc</x><y href="#id1"/></myStruct></root>'.
	self assert: ((decodeInstance at: #x) == (decodeInstance at: #y)).
	self 
		withOptions: #(beAllNotTyped beEncodeBelow set2001TopNode  beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><myStruct><x id="id1">abc</x><y href="#id1"/></myStruct></root>'.
	self assert: ((decodeInstance at: #x) == (decodeInstance at: #y)).

!

testDoubleStringEmpty
	self be2001Typespace.
	self setDoubleStringEmptyIdentValue.
	self setDoubleStringElement.
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode beNoRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><x xsi:type="xsd:string"></x><y xsi:type="xsd:string"></y></myStruct></root>'.
	self deny: ((decodeInstance at: #x) == (decodeInstance at: #y)).
	self assert: (decodeInstance at: #x) = (decodeInstance at: #y).
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode  beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><x id="id1" xsi:type="xsd:string"></x><y href="#id1"/></myStruct></root>'.
	self assert: ((decodeInstance at: #x) == (decodeInstance at: #y)).
	self 
		withOptions: #(beAllNotTyped beEncodeBelow set2001TopNode  beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><myStruct><x id="id1"></x><y href="#id1"/></myStruct></root>'.
	self assert: ((decodeInstance at: #x) == (decodeInstance at: #y)).

!

testDoubleStruct
	self be2001Typespace.
	self setDoubleStructIdentValue.
	self setDoubleStructElement.
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode beNoRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><struct1><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></struct1><struct2><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></struct2></myStruct></root>'.
	self deny: ((decodeInstance at: #struct1) == (decodeInstance at: #struct2)).
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode  beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" ><myStruct><struct1 href="#id1"/><struct2 href="#id1"/></myStruct><id1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" id="id1" SOAP-ENC:root="0"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></id1></root>'
.
	self assert: ((decodeInstance at: #struct1) == (decodeInstance at: #struct2)).
!

testDoubleStructAnyType
	self be2001Typespace.
	self setDoubleStructIdentValue.
	self setDoubleStructAnyTypeElement.
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode #beNoRef)
		assertContentXML: 
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><struct1><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:integer">123</varInt><varFloat xsi:type="xsd:double">3.14</varFloat></struct1><struct2><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:integer">123</varInt><varFloat xsi:type="xsd:double">3.14</varFloat></struct2></myStruct></root>'.
	self deny: (decodeInstance at: #struct1) == (decodeInstance at: #struct2).
	self withOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode #beSoapEncRef)
		assertContentXML: 
'<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"><myStruct><struct1 href="#id1"/><struct2 href="#id1"/></myStruct><id1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" id="id1" SOAP-ENC:root="0"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:integer">123</varInt><varFloat xsi:type="xsd:double">3.14</varFloat></id1></root>'.
	self assert: (decodeInstance at: #struct1) == (decodeInstance at: #struct2)
!

testDoubleStructNil
	self be2001Typespace.
	self setDoubleStructNilValue.
	self setDoubleStructElement.
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode beNoRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><myStruct><struct1 xsi:nil="true"/><struct2 xsi:nil="true"/></myStruct></root>'.
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode  beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><myStruct><struct1 xsi:nil="true"/><struct2 xsi:nil="true"/></myStruct></root>'.
!

testDoubleStructSTB
	self be2001Typespace.
	self setDoubleStructIdentValue.
	self setDoubleStructSTBElement.
	self setUp.
	#(beAllTyped beEncodeBelow set2001TopNode beNoRef) do: [:each | self perform: each].
	self encode.
	self setDecodeObjectFromElement.
	self assertDecodeToSame.
	self setDecodeObjectFromNode.
	element isTyped ifTrue: [
		self assertDecodeToSame].
	self deny: ((decodeInstance at: #struct1) == (decodeInstance at: #struct2)).


	self setUp.
	#(beAllTyped beEncodeBelow set2001TopNode  beSoapEncRef) do: [:each | self perform: each].
	self encode.
	self setDecodeObjectFromElement.
	self assertDecodeToSame.
	self setDecodeObjectFromNode.
	element isTyped ifTrue: [
		self assertDecodeToSame].
	self assert: ((decodeInstance at: #struct1) == (decodeInstance at: #struct2)).
!

testDoubleStructTyped
	self be2001Typespace.
	self importSoapStructSchema.
	self setDoubleStructIdentValue.
	self setDoubleStructElement.
	self makeChildElementsTyped.
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode beNoRef)
		assertContentXML:
'<root xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd"><myStruct><struct1 xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></struct1><struct2 xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></struct2></myStruct></root>'
.
	self deny: ((decodeInstance at: #struct1) == (decodeInstance at: #struct2)).
	self 
		withOptions: #(beAllTyped beEncodeBelow set2001TopNode  beSoapEncRef)
		assertContentXML:
'<root xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">
<myStruct>
<struct1 href="#id1"/>
<struct2 href="#id1"/>
</myStruct>
<id1 SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" id="id1" SOAP-ENC:root="0" xsi:type="ns1:SOAPStruct"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></id1></root>'.
	self assert: ((decodeInstance at: #struct1) == (decodeInstance at: #struct2)).
! !

!XeWriteReadIDTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeWriteReadIDTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
