"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSoapEncWriteReadTests subclass:#XeWriteReadTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeWriteReadTest methodsFor:'accessing'!

makeChildElementsQualified
	element childElements do: [:each | each qName namespace: #'urn:qualifed'].
	element childElements do: [:each | each beFormUnqualified]
! !

!XeWriteReadTest methodsFor:'tests'!

test1999Base64Binary
	self be1999Typespace.
	instance := '1234567abc' asByteArray.
	element := (XeElementSpec named: 'blah' xsd: 'base64Binary') 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeWithin #beNoRef #set1999TopNode)
		assertContentXML: '<root xsi:type="soap:base64" xmlns:soap="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance">MTIzNDU2N2FiYw==</root>'
!

test1999SoapBase64
	self be1999Typespace.
	instance := '1234567abc' asByteArray.
	element := (XeElementSpec named: 'blah' typeName: 'soap:base64') 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeWithin #beNoRef #set1999TopNode)
		assertContentXML: '<root xsi:type="soap:base64" xmlns:soap="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance">MTIzNDU2N2FiYw==</root>'.
	self withOptions: #(#beAllTyped #beEncodeBelow #beNoRef #set1999TopNode)
		assertContentXML: '<root xmlns:soap="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"><blah xsi:type="soap:base64">MTIzNDU2N2FiYw==</blah></root>'
!

test1999SoapStruct
	self be1999Typespace.
	instance := self getSoapStruct.
	element := self getAnonElement: 'myStruct' content: self getSoapStructContent.
	self withOptions: #(#beAllTyped #beEncodeWithin #beNoRef #set1999TopNode)
		assertContentXML: 
'<root xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></root>'.
	self withOptions: #(#beAllTyped #beEncodeBelow #beNoRef #set1999TopNode)
		assertContentXML: 
'<root xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance" xmlns:xsd="http://www.w3.org/1999/XMLSchema"><myStruct><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></myStruct></root>'.
	self withOptions: #(#beAllNotTyped #beEncodeWithin #beNoRef #set1999TopNode)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"><varString>abc</varString><varInt>123</varInt><varFloat>3.14</varFloat></root>'
!

test2001AnyTypeArray
	self be2001Typespace.
	element := self encodingStyle anyElementNamed: 'blah'.
	instance := #(1 'abc' 3).
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: 
'<root SOAP-ENC:arrayType="xsd:anyType[3]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><item xsi:type="xsd:integer">1</item><item xsi:type="xsd:string">abc</item><item xsi:type="xsd:integer">3</item></root>'
!

test2001AnyTypeArrayWithNil
	self be2001Typespace.
	element := self encodingStyle anyElementNamed: 'blah'.
	instance := #(1 'abc' nil).
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: 
'<root SOAP-ENC:arrayType="xsd:anyType[3]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><item xsi:type="xsd:integer">1</item><item xsi:type="xsd:string">abc</item><item xsi:nil="true"/></root>'
!

test2001AnyTypeSimple
	self be2001Typespace.
	element := self encodingStyle anyElementNamed: 'blah'.
	instance := 'abc'.
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="xsd:string" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">abc</root>'.
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><blah xsi:type="xsd:string">abc</blah></root>'
!

test2001ArrayAnyTypeArrays
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soap:Array') 
				xeParticleWith: self encodingStyle.
	instance := #(#(1 2) #(3 4)).
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <blah SOAP-ENC:arrayType="xsd:anyType[2]">
    <item SOAP-ENC:arrayType="xsd:anyType[2]">
      <item xsi:type="xsd:integer">1</item>
      <item xsi:type="xsd:integer">2</item>
    </item>
    <item SOAP-ENC:arrayType="xsd:anyType[2]">
      <item xsi:type="xsd:integer">3</item>
      <item xsi:type="xsd:integer">4</item>
    </item>
  </blah>
</root>'
!

test2001ArrayAnyTypeArraysIdentical
	| iInstance |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soap:Array') 
				xeParticleWith: self encodingStyle.
	iInstance := #(1 2).
	instance := Array with: iInstance with: iInstance.
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef)
		assertContentXML: '<root
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <blah SOAP-ENC:arrayType="xsd:anyType[2]">
    <item SOAP-ENC:arrayType="xsd:anyType[2]">
      <item xsi:type="xsd:integer">1</item>
      <item xsi:type="xsd:integer">2</item>
    </item>
    <item SOAP-ENC:arrayType="xsd:anyType[2]">
      <item xsi:type="xsd:integer">1</item>
      <item xsi:type="xsd:integer">2</item>
    </item>
  </blah>
</root>'.
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
  <blah SOAP-ENC:arrayType="xsd:anyType[2]">
    <item href="#id1"/>
    <item href="#id1"/>
  </blah>
  <id1 id="id1" SOAP-ENC:arrayType="xsd:anyType[2]"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
    <item xsi:type="xsd:integer">1</item>
    <item xsi:type="xsd:integer">2</item>
  </id1>
</root>'
!

test2001ArrayAnyTypeArraysIdentical2
	| iInstance1 iInstance2 |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soap:Array') 
				xeParticleWith: self encodingStyle.
	iInstance1 := #(1 2).
	iInstance2 := #(3 4).
	instance := Array 
				with: iInstance1
				with: iInstance2
				with: iInstance1
				with: iInstance2.
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root 
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
  <blah
    SOAP-ENC:arrayType="xsd:anyType[4]">
      <item href="#id1"/>
      <item href="#id2"/>
      <item href="#id1"/>
      <item href="#id2"/>
  </blah>
  <id1 id="id1" SOAP-ENC:arrayType="xsd:anyType[2]"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0"><item xsi:type="xsd:integer">1</item><item xsi:type="xsd:integer">2</item></id1>
  <id2 id="id2" SOAP-ENC:arrayType="xsd:anyType[2]"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0"><item xsi:type="xsd:integer">3</item><item xsi:type="xsd:integer">4</item></id2>
</root>'
!

test2001ArrayAnyTypeArraysIdentical3
	| iInstance1 iInstance2 iInstance3 |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soap:Array') 
				xeParticleWith: self encodingStyle.
	iInstance3 := '2'.
	iInstance1 := Array with: '1' with: iInstance3.
	iInstance2 := Array with: iInstance3 with: '3'.
	instance := Array 
				with: iInstance1
				with: iInstance2
				with: iInstance1
				with: iInstance2.
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
  <blah SOAP-ENC:arrayType="xsd:anyType[4]">
    <item href="#id2"/>
    <item href="#id3"/>
    <item href="#id2"/>
    <item href="#id3"/>
  </blah>
  <id2 id="id2" SOAP-ENC:arrayType="xsd:anyType[2]"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
    <item xsi:type="xsd:string">1</item>
    <item id="id1" xsi:type="xsd:string">2</item>
  </id2>
  <id3 id="id3" SOAP-ENC:arrayType="xsd:anyType[2]"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
    <item href="#id1"/>
    <item xsi:type="xsd:string">3</item>
  </id3>
</root>'
!

test2001ArrayAnyTypeMixed
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soap:Array') 
				xeParticleWith: self encodingStyle.
	instance := Array 
				with: 1
				with: #(1 2)
				with: self getSoapStruct.
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root 
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <blah SOAP-ENC:arrayType="xsd:anyType[3]">
    <item xsi:type="xsd:integer">1</item>
    <item SOAP-ENC:arrayType="xsd:anyType[2]">
      <item xsi:type="xsd:integer">1</item>
      <item xsi:type="xsd:integer">2</item>
    </item>
    <item>
       <varString xsi:type="xsd:string">abc</varString>
       <varInt xsi:type="xsd:integer">123</varInt>
       <varFloat xsi:type="xsd:double">3.14</varFloat>
    </item>
  </blah>
</root>'
!

test2001ArrayAnyTypeMixedIdenticalString
	| iInstance |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soap:Array') 
				xeParticleWith: self encodingStyle.
	iInstance := '1'.
	instance := Array 
				with: iInstance
				with: (Array with: iInstance with: '2')
				with: ((XeQStruct new)
						at: #p1 put: iInstance;
						at: #p2 put: '3';
						yourself).
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root 
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <blah SOAP-ENC:arrayType="xsd:anyType[3]">
    <item id="id1" xsi:type="xsd:string">1</item>
    <item SOAP-ENC:arrayType="xsd:anyType[2]">
      <item href="#id1"/>
      <item xsi:type="xsd:string">2</item>
    </item>
    <item>
      <p1 href="#id1"/>
      <p2 xsi:type="xsd:string">3</p2>
    </item>
  </blah>
</root>'
!

test2001ArrayAnyTypeMixedIdenticalString2
	| iInstance1 iInstance2 |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soap:Array') 
				xeParticleWith: self encodingStyle.
	iInstance1 := '1'.
	iInstance2 := '2'.
	instance := Array 
				with: iInstance1
				with: iInstance2
				with: (Array with: iInstance1 with: iInstance2)
				with: ((XeQStruct new)
						at: #p1 put: iInstance1;
						at: #p2 put: iInstance2;
						yourself).
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeBelow #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <blah SOAP-ENC:arrayType="xsd:anyType[4]">
    <item id="id1" xsi:type="xsd:string">1</item>
    <item id="id2" xsi:type="xsd:string">2</item>
    <item SOAP-ENC:arrayType="xsd:anyType[2]">
      <item href="#id1"/>
      <item href="#id2"/>
    </item>
    <item>
      <p1 href="#id1"/>
      <p2 href="#id2"/>
    </item>
</blah>
</root>'
!

test2001ArrayEmpty
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soapE:ArrayOfinteger') 
				xeParticleWith: self encodingStyle.
	instance := #().
	self 
		andOptions: #(#beAllTyped #beNoRef #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef #beAllNotTyped)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:integer[0]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"></root>'
!

test2001ArrayKeyedOfBase
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soapE:ArrayOfstring') 
				xeParticleWith: self encodingStyle.
	instance := (IdentityDictionary new)
				at: 2 put: 'second';
				at: 4 put: 'fourth';
				yourself.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:string[4]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.w3.org/2001/XMLSchema">
  <item SOAP-ENC:position="[1]" xsi:type="ns1:string">second</item>
  <item SOAP-ENC:position="[3]" xsi:type="ns1:string">fourth</item>
</root>'.
	self 
		andOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root 
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.w3.org/2001/XMLSchema">
  <blah SOAP-ENC:arrayType="ns1:string[4]">
    <item SOAP-ENC:position="[1]">second</item>
    <item SOAP-ENC:position="[3]">fourth</item>
</blah></root>'
!

test2001ArrayKeyedWithIdenticalObjects
	| iInstance |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' arrayOfClass: SWXMLTestObject) 
				xeParticleWith: self encodingStyle.
	iInstance := SWXMLTestObject example1.
	instance := (IdentityDictionary new)
				at: 2 put: iInstance;
				at: 4 put: SWXMLTestObject example1;
				at: 5 put: iInstance;
				yourself.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:SWXMLTestObject[5]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.dolphinharbor.org/spray/class">
<item SOAP-ENC:position="[1]" xsi:type="ns1:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
<item SOAP-ENC:position="[3]" xsi:type="ns1:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
<item SOAP-ENC:position="[4]" xsi:type="ns1:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root 
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
  <blah SOAP-ENC:arrayType="ns1:SWXMLTestObject[5]">
    <item href="#id1" SOAP-ENC:position="[1]"/>
    <item SOAP-ENC:position="[3]" xsi:type="ns1:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
    <item SOAP-ENC:position="[4]" href="#id1"/>
  </blah>
  <id1 id="id1" xsi:type="ns1:SWXMLTestObject"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></id1></root>'
!

test2001ArrayKeyedWithIdenticalString
	| iInstance |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soapE:ArrayOfstring') 
				xeParticleWith: self encodingStyle.
	iInstance := 'sameString'.
	instance := (IdentityDictionary new)
				at: 2 put: 'second';
				at: 4 put: 'fourth';
				at: 5 put: iInstance;
				at: 10 put: iInstance;
				yourself.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:string[10]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.w3.org/2001/XMLSchema">
  <item SOAP-ENC:position="[1]">second</item>
  <item SOAP-ENC:position="[3]">fourth</item>
  <item SOAP-ENC:position="[4]" id="id1">sameString</item>
  <item SOAP-ENC:position="[9]" href="#id1"/>
</root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:string[10]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><item SOAP-ENC:position="[1]" xsi:type="ns1:string">second</item><item SOAP-ENC:position="[3]" xsi:type="ns1:string">fourth</item><item SOAP-ENC:position="[4]" id="id1" xsi:type="ns1:string">sameString</item><item SOAP-ENC:position="[9]" href="#id1"/></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:string[10]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><item SOAP-ENC:position="[1]" xsi:type="ns1:string">second</item><item SOAP-ENC:position="[3]" xsi:type="ns1:string">fourth</item><item SOAP-ENC:position="[4]" xsi:type="ns1:string">sameString</item><item SOAP-ENC:position="[9]" xsi:type="ns1:string">sameString</item></root>'
!

test2001ArrayKeyedWithLast
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soapE:ArrayOfstring') 
				xeParticleWith: self encodingStyle.
	instance := (IdentityDictionary new)
				at: 2 put: 'second';
				at: 4 put: 'fourth';
				at: 10 put: nil;
				yourself.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:string[10]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.w3.org/2001/XMLSchema">
  <item SOAP-ENC:position="[1]" xsi:type="ns1:string">second</item>
  <item SOAP-ENC:position="[3]" xsi:type="ns1:string">fourth</item>
</root>'
!

test2001ArrayOfArrayOfBase
	self be2001Typespace.
	element := self getAnonElement: 'blah' content: self getSoapArrayOfArrayContent.
	instance := #(#('1' '2') #('3' '4')).

	self 
		andOptions: #(beAllTyped beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root 
  SOAP-ENC:arrayType="SOAP-ENC:Array[2]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <item SOAP-ENC:arrayType="xsd:string[2]">
    <item xsi:type="xsd:string">1</item>
    <item xsi:type="xsd:string">2</item>
  </item>
  <item SOAP-ENC:arrayType="xsd:string[2]">
    <item xsi:type="xsd:string">3</item>
    <item xsi:type="xsd:string">4</item>
  </item>
  </root>'
        


!

test2001ArrayOfArrayWithIdentical
	| iInstance |
	self be2001Typespace.
	element := self getAnonElement: 'blah' content: self getSoapArrayOfArrayContent.
	iInstance := #('1' '2').
	instance := Array with: (Array with: '1' copy with: '2' copy) with: iInstance with: nil with: iInstance.

	self 
		andOptions: #(beAllTyped beEncodeBelow set2001TopNode)
		orOptions: #( beSoapEncRef)
		assertContentXML: 
'<root
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
  <blah SOAP-ENC:arrayType="SOAP-ENC:Array[4]">
    <item SOAP-ENC:arrayType="xsd:string[2]">
      <item xsi:type="xsd:string">1</item>
      <item xsi:type="xsd:string">2</item>
    </item>
    <item href="#id1"/>
    <item xsi:nil="true"/>
    <item href="#id1"/>
  </blah>
  <id1 id="id1" SOAP-ENC:arrayType="xsd:string[2]"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
    <item xsi:type="xsd:string">1</item>
    <item xsi:type="xsd:string">2</item>
  </id1>
</root>'.
	self 
		andOptions: #(beAllTyped beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef)
		assertContentXML:
'<root 
  SOAP-ENC:arrayType="SOAP-ENC:Array[4]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <item SOAP-ENC:arrayType="xsd:string[2]">
    <item xsi:type="xsd:string">1</item>
    <item xsi:type="xsd:string">2</item>
  </item>
  <item SOAP-ENC:arrayType="xsd:string[2]">
    <item xsi:type="xsd:string">1</item>
    <item xsi:type="xsd:string">2</item>
  </item>
  <item xsi:nil="true"/>
  <item SOAP-ENC:arrayType="xsd:string[2]">
    <item xsi:type="xsd:string">1</item>
    <item xsi:type="xsd:string">2</item>
  </item>
</root>'
        


!

test2001ArrayOfArrayWithNil
	self be2001Typespace.
	element := self getAnonElement: 'blah' content: self getSoapArrayOfArrayContent .
	instance := #(#('1' '2') nil #('3' '4')).

	self 
		andOptions: #(beAllTyped beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root 
  SOAP-ENC:arrayType="SOAP-ENC:Array[3]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <item SOAP-ENC:arrayType="xsd:string[2]">
    <item xsi:type="xsd:string">1</item>
    <item xsi:type="xsd:string">2</item>
  </item>
  <item xsi:nil="true"/>
  <item SOAP-ENC:arrayType="xsd:string[2]">
    <item xsi:type="xsd:string">3</item>
    <item xsi:type="xsd:string">4</item>
  </item>
  </root>'
        


!

test2001ArrayOfBase
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soapE:ArrayOfinteger') 
				xeParticleWith: self encodingStyle.
	instance := #(1 2 3).
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:integer[3]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><item xsi:type="ns1:integer">1</item><item xsi:type="ns1:integer">2</item><item xsi:type="ns1:integer">3</item></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><blah SOAP-ENC:arrayType="ns1:integer[3]"><item xsi:type="ns1:integer">1</item><item xsi:type="ns1:integer">2</item><item xsi:type="ns1:integer">3</item></blah></root>'.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:integer[3]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><item>1</item><item>2</item><item>3</item></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode #beXSITypeArrays)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:soapE="http://tempuri.org/schemas" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><blah SOAP-ENC:arrayType="ns1:integer[3]" xsi:type="soapE:ArrayOfinteger"><item xsi:type="ns1:integer">1</item><item xsi:type="ns1:integer">2</item><item xsi:type="ns1:integer">3</item></blah></root>'
!

test2001ArrayOfClass
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'd:ArrayOfSWXMLTestObject') 
				xeParticleWith: self encodingStyle.
	instance := Array with: SWXMLTestObject example1 with: SWXMLTestObject example2.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xmlns:xsd="http://www.w3.org/2001/XMLSchema"
xmlns:d="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
SOAP-ENC:arrayType="d:SWXMLTestObject[2]" >
<item xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
<item xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">6</x><y xsi:type="xsd:string">goodbye</y></item>
</root>'
!

test2001ArrayWithIdenticalObjects
	| iInstance |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' arrayOfClass: SWXMLTestObject) 
				xeParticleWith: self encodingStyle.
	iInstance := SWXMLTestObject example1.
	instance := Array 
				with: iInstance
				with: iInstance
				with: SWXMLTestObject example1.
	instance third y: instance second y.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef)
		assertContentXML: '<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.dolphinharbor.org/spray/class"><blah SOAP-ENC:arrayType="ns1:SWXMLTestObject[3]">
<item xsi:type="ns1:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
<item xsi:type="ns1:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
<item xsi:type="ns1:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
</blah></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.dolphinharbor.org/spray/class"
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<blah SOAP-ENC:arrayType="ns1:SWXMLTestObject[3]">
<item href="#id1"/>
<item href="#id1"/>
<item xsi:type="ns1:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y href="#id2"/></item>
</blah>
<id1 id="id1" xsi:type="ns1:SWXMLTestObject"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0">
  <x xsi:type="xsd:integer">5</x>
  <y id="id2" xsi:type="xsd:string">hello</y>
</id1>
</root>'
!

test2001ArrayWithIdenticalString
	| aString |
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soapE:ArrayOfstring') 
				xeParticleWith: self encodingStyle.
	aString := 'abc'.
	instance := Array 
				with: aString
				with: aString
				with: 'def'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef)
		assertContentXML: '<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><blah SOAP-ENC:arrayType="ns1:string[3]"><item xsi:type="ns1:string">abc</item><item xsi:type="ns1:string">abc</item><item xsi:type="ns1:string">def</item></blah></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beSoapEncRef)
		assertContentXML: '<root 
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xmlns:ns1="http://www.w3.org/2001/XMLSchema">
  <blah SOAP-ENC:arrayType="ns1:string[3]">
    <item id="id1" xsi:type="ns1:string">abc</item>
    <item href="#id1"/>
    <item xsi:type="ns1:string">def</item>
  </blah>
</root>'
!

test2001ArrayWithNil
	self be2001Typespace.
	element := (XeElementSpec named: 'blah' typeName: 'soapE:ArrayOfinteger') 
				xeParticleWith: self encodingStyle.
	instance := #(1 nil 3).
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:integer[3]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><item xsi:type="ns1:integer">1</item><item xsi:nil="true"/><item xsi:type="ns1:integer">3</item></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><blah SOAP-ENC:arrayType="ns1:integer[3]"><item xsi:type="ns1:integer">1</item><item xsi:nil="true"/><item xsi:type="ns1:integer">3</item></blah></root>'.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root SOAP-ENC:arrayType="ns1:integer[3]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><item>1</item><item xsi:nil="true"/><item>3</item></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode #beXSITypeArrays)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:soapE="http://tempuri.org/schemas" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://www.w3.org/2001/XMLSchema"><blah SOAP-ENC:arrayType="ns1:integer[3]" xsi:type="soapE:ArrayOfinteger"><item xsi:type="ns1:integer">1</item><item xsi:nil="true"/><item xsi:type="ns1:integer">3</item></blah></root>'
!

test2001Base64Binary
	self be2001Typespace.
	instance := '1234567abc' asByteArray.
	element := (XeElementSpec named: 'blah' xsd: 'base64Binary') 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeWithin #beNoRef #set2001TopNode)
		assertContentXML: '<root xsi:type="xsd:base64Binary" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">MTIzNDU2N2FiYw==</root>'.
	self withOptions: #(#beAllNotTyped #beEncodeBelow #beNoRef #set2001TopNode)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah>MTIzNDU2N2FiYw==</blah></root>'
!

test2001ClassBase
	self be2001Typespace.
	instance := SWXMLTestObject example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle.
	self 
		andOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah><x>5</x><y>hello</y></blah></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="d:SWXMLTestObject" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></root>'
!

test2001ClassComposite
	self be2001Typespace.
	instance := SWXMLTestComposite example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestComposite) 
				xeParticleWith: self encodingStyle.
	self 
		andOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah><object1><x>5</x><y>hello</y></object1><object2><x>6</x><y>goodbye</y></object2><number>3</number></blah></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="d:SWXMLTestComposite" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><object1 xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></object1><object2 xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">6</x><y xsi:type="xsd:string">goodbye</y></object2><number xsi:type="xsd:integer">3</number></root>'
!

test2001ClassWithNil
	self be2001Typespace.
	instance := SWXMLTestObject example1.
	element := (XeElementSpec named: 'blah' class: SWXMLTestObject) 
				xeParticleWith: self encodingStyle.
	instance x: nil.
	self 
		andOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah><x xsi:nil="true"/><y>hello</y></blah></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="d:SWXMLTestObject" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><x xsi:nil="true"/><y xsi:type="xsd:string">hello</y></root>'
!

test2001MultiDim
	self be2001Typespace.
	element := self getAnonElement: #blah content: self getSoapMDArrayContent.
	self setMultiDimString23.

	self 
		andOptions: #(beAllTyped beNoRef beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root 
  SOAP-ENC:arrayType="xsd:string[2,3]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <item SOAP-ENC:position="[0,0]" xsi:type="xsd:string">r1c1</item>
  <item SOAP-ENC:position="[0,1]" xsi:type="xsd:string">r1c2</item>
  <item SOAP-ENC:position="[0,2]" xsi:type="xsd:string">r1c3</item>
  <item SOAP-ENC:position="[1,0]" xsi:type="xsd:string">r2c1</item>
  <item SOAP-ENC:position="[1,1]" xsi:type="xsd:string">r2c2</item>
  <item SOAP-ENC:position="[1,2]" xsi:type="xsd:string">r2c3</item>
</root>'.

!

test2001MultiDimEmpty
	self be2001Typespace.
	element := self getAnonElement: #blah content: self getSoapMDArrayContent.
	instance := Dolphin::LookupTable new.

	self 
		andOptions: #(beAllTyped beNoRef beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root SOAP-ENC:arrayType="xsd:string[0,0]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"/>'
.

!

test2001MultiDimPosSkip
	self be2001Typespace.
	element := self getAnonElement: #blah content: self getSoapMDArrayContent.
	self setMultiDimString23.
	instance removeKey: (1 @ 3).

	self 
		andOptions: #(beAllTyped beNoRef beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root 
  SOAP-ENC:arrayType="xsd:string[2,3]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <item SOAP-ENC:position="[0,0]" xsi:type="xsd:string">r1c1</item>
  <item SOAP-ENC:position="[0,1]" xsi:type="xsd:string">r1c2</item>
  <item SOAP-ENC:position="[1,0]" xsi:type="xsd:string">r2c1</item>
  <item SOAP-ENC:position="[1,1]" xsi:type="xsd:string">r2c2</item>
  <item SOAP-ENC:position="[1,2]" xsi:type="xsd:string">r2c3</item>
</root>'.

!

test2001MultiDimWithIdenticalObject
	| iInstance |
	self be2001Typespace.
	element := self getAnonElement: #blah content: self getSoapMDArrayObjectContent.
	iInstance := SWXMLTestObject example1.
	instance := Dolphin::LookupTable new.
	instance
		at: (1@1) put: iInstance;
		at: (1@2) put: SWXMLTestObject example1;
		at: (2@3) put: iInstance.

	self 
		andOptions: #(beAllTyped beEncodeBelow set2001TopNode)
		orOptions: #(beNoRef )
		assertContentXML:
'<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<blah SOAP-ENC:arrayType="d:SWXMLTestObject[2,3]">
<item SOAP-ENC:position="[0,0]" xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
<item SOAP-ENC:position="[0,1]" xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
<item SOAP-ENC:position="[1,2]" xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item></blah></root>'.

	self 
		andOptions: #(beAllTyped beEncodeBelow set2001TopNode)
		orOptions: #(beSoapEncRef )
		assertContentXML: 
'<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" 
xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
xmlns:d="http://www.dolphinharbor.org/spray/class" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<blah SOAP-ENC:arrayType="d:SWXMLTestObject[2,3]">
<item href="#id1" SOAP-ENC:position="[0,0]"/>
<item SOAP-ENC:position="[0,1]" xsi:type="d:SWXMLTestObject"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></item>
<item SOAP-ENC:position="[1,2]" href="#id1"/>
</blah>
<id1 id="id1" xsi:type="d:SWXMLTestObject"
SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" SOAP-ENC:root="0"><x xsi:type="xsd:integer">5</x><y xsi:type="xsd:string">hello</y></id1></root>'

!

test2001MultiDimWithIdenticalString
	| iInstance |
	self be2001Typespace.
	element := self getAnonElement: #blah content: self getSoapMDArrayContent.
	self setMultiDimString23.
	iInstance := 'sameString'.
	instance 
		at: (1@1) put: iInstance;
		at: (1@2) put: iInstance;
		at: (1@3) put: iInstance.

	self 
		andOptions: #(beAllTyped beNoRef beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef )
		assertContentXML:
'<root SOAP-ENC:arrayType="xsd:string[2,3]" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<item SOAP-ENC:position="[0,0]" xsi:type="xsd:string">sameString</item>
<item SOAP-ENC:position="[0,1]" xsi:type="xsd:string">sameString</item>
<item SOAP-ENC:position="[0,2]" xsi:type="xsd:string">sameString</item>
<item SOAP-ENC:position="[1,0]" xsi:type="xsd:string">r2c1</item>
<item SOAP-ENC:position="[1,1]" xsi:type="xsd:string">r2c2</item>
<item SOAP-ENC:position="[1,2]" xsi:type="xsd:string">r2c3</item>
</root>'.

	self 
		andOptions: #(beAllTyped beEncodeBelow set2001TopNode)
		orOptions: #(beSoapEncRef )
		assertContentXML: 
'<root xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<blah SOAP-ENC:arrayType="xsd:string[2,3]">
<item SOAP-ENC:position="[0,0]" id="id1" xsi:type="xsd:string">sameString</item>
<item SOAP-ENC:position="[0,1]" href="#id1"/>
<item SOAP-ENC:position="[0,2]" href="#id1"/>
<item SOAP-ENC:position="[1,0]" xsi:type="xsd:string">r2c1</item>
<item SOAP-ENC:position="[1,1]" xsi:type="xsd:string">r2c2</item>
<item SOAP-ENC:position="[1,2]" xsi:type="xsd:string">r2c3</item>
</blah></root>'

!

test2001MultiDimWithLast
	self be2001Typespace.
	element := self getAnonElement: #blah content: self getSoapMDArrayContent.
	self setMultiDimString23.
	instance 
		at: (3@1) put: nil;
		at: (3@2) put: nil;
		at: (3@3) put: nil.
	self 
		andOptions: #(beAllTyped beNoRef beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root 
  SOAP-ENC:arrayType="xsd:string[3,3]"
  xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <item SOAP-ENC:position="[0,0]" xsi:type="xsd:string">r1c1</item>
  <item SOAP-ENC:position="[0,1]" xsi:type="xsd:string">r1c2</item>
  <item SOAP-ENC:position="[0,2]" xsi:type="xsd:string">r1c3</item>
  <item SOAP-ENC:position="[1,0]" xsi:type="xsd:string">r2c1</item>
  <item SOAP-ENC:position="[1,1]" xsi:type="xsd:string">r2c2</item>
  <item SOAP-ENC:position="[1,2]" xsi:type="xsd:string">r2c3</item>
</root>'.

!

test2001Restriction
	self be2001Typespace.
	self importFacetSchema.
	instance := 50000.
	element := (XeElementSpec named: #blah typeName: 'f:myInteger') 
				xeParticleWith: self encodingStyle.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">50000</root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="f:myInteger" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:f="urn:blah">50000</root>'
!

test2001SimpleBool
	self be2001Typespace.
	instance := true.
	element := (XeElementSpec named: 'blah' xsd: 'boolean') 
				xeParticleWith: self encodingStyle.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">true</root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="xsd:boolean" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">true</root>'
!

test2001SimpleDeclareWithNonNull
	self be2001Typespace.
	instance := 3.14.
	element := (XeElementSpec named: 'float' xsd: 'float') xeParticleWith: self encodingStyle.
	element qName namespace: XeNamespace soapEnc.
	self 
		andOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode #beNoRef #beFormQualified)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><ns:float xmlns:ns="http://schemas.xmlsoap.org/soap/encoding/">3.14</ns:float></root>'
!

test2001SimpleDeclareWithNull
	self be2001Typespace.
	instance := 3.14.
	element := (XeElementSpec named: 'blah' xsd: 'float') xeParticleWith: self encodingStyle.
	element qName namespace: #''.
	self 
		andOptions: #(#beAllNotTyped #beEncodeBelow #set2001TopNode #beNoRef)
		orOptions: #(#beNoRef #beSoapEncRef #beFormQualified #beFormUnqualified)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah>3.14</blah></root>'
!

test2001SimpleFloat
	self be2001Typespace.
	instance := 3.14.
	element := (XeElementSpec named: 'blah' xsd: 'float') xeParticleWith: self encodingStyle.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">3.14</root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="xsd:float" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">3.14</root>'
!

test2001SimpleInteger
	self be2001Typespace.
	instance := 2.
	element := (XeElementSpec named: 'blah' xsd: 'integer') 
				xeParticleWith: self encodingStyle.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">2</root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="xsd:integer" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">2</root>'
!

test2001SimpleString
	self be2001Typespace.
	instance := 'abc'.
	element := (XeElementSpec named: 'blah' xsd: 'string') xeParticleWith: self encodingStyle.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">abc</root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xsi:type="xsd:string" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">abc</root>'
!

test2001SoapBase64
	self be2001Typespace.
	instance := '1234567abc' asByteArray.
	element := (XeElementSpec named: 'blah' typeName: 'soap:base64') 
				xeParticleWith: self encodingStyle.
	self withOptions: #(#beAllTyped #beEncodeWithin #beNoRef #set2001TopNode)
		assertContentXML: '<root xsi:type="soap:base64" xmlns:soap="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">MTIzNDU2N2FiYw==</root>'.
	self withOptions: #(#beAllTyped #beEncodeBelow #beNoRef #set2001TopNode)
		assertContentXML: '<root xmlns:soap="http://schemas.xmlsoap.org/soap/encoding/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><blah xsi:type="soap:base64">MTIzNDU2N2FiYw==</blah></root>'
!

test2001SoapStruct
	self be2001Typespace.
	instance := self getSoapStruct.
	element := self getAnonElement: 'myStruct' content: self getSoapStructContent.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode #beNoRef)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: 
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode #beNoRef)
		orOptions: #(#beNoRef #beSoapEncRef )
		assertContentXML: 
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></myStruct></root>'.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><varString>abc</varString><varInt>123</varInt><varFloat>3.14</varFloat></root>'
!

test2001SoapStructImported
	self be2001Typespace.
	self importSoapStructSchema.
	instance := self getSoapStruct.
	element := (XeElementSpec named: 'blah'
				typeName: ('SOAPStruct' ns: #'http://soapinterop.org/xsd')) 
					xeParticleWith: self encodingStyle.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode #beNoRef)
		orOptions: #(#beNoRef #beSoapEncRef #makeChildElementsQualified)
		assertContentXML: '<root xsi:type="ns1:SOAPStruct" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></root>'.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode #beNoRef)
		orOptions: #(#beNoRef #beSoapEncRef #makeChildElementsQualified)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><varString>abc</varString><varInt>123</varInt><varFloat>3.14</varFloat></root>'
!

test2001SoapStructTyped
	self be2001Typespace.
	self importSoapStructSchema.
	instance := self getSoapStruct.
	element := self getAnonElement: 'myStruct' content: self getSoapStructContent.
	element content typeName: ('SOAPStruct' ns: #'http://soapinterop.org/xsd').
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode #beNoRef)
		orOptions: #(#beNoRef #beSoapEncRef #makeChildElementsQualified)
		assertContentXML: '<root xsi:type="ns1:SOAPStruct" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ns1="http://soapinterop.org/xsd"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></root>'.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode #beNoRef)
		orOptions: #(#beNoRef #beSoapEncRef #makeChildElementsQualified)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><varString>abc</varString><varInt>123</varInt><varFloat>3.14</varFloat></root>'
!

test2001SoapStructWithNil
	self be2001Typespace.
	instance := self getSoapStruct.
	instance atUnique: #varFloat put: nil.
	element := self getAnonElement: 'myStruct' content: self getSoapStructContent.
	self 
		andOptions: #(#beAllTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: 
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:nil="true"/></root>'.
	self 
		andOptions: #(#beAllTyped #beEncodeBelow #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: 
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:nil="true"/></myStruct></root>'.
	self 
		andOptions: #(#beAllNotTyped #beEncodeWithin #set2001TopNode)
		orOptions: #(#beNoRef #beSoapEncRef)
		assertContentXML: '<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><varString>abc</varString><varInt>123</varInt><varFloat xsi:nil="true"/></root>'
!

test2001StructWithChoice
	self be2001Typespace.
	instance := self getSoapStruct.
	element := self getAnonElement: 'myStruct' content: self getSoapStructWithChoiceContent.
	self 
		andOptions: #(beAllTyped beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></root>'.
	self 
		andOptions: #(beAllTyped beEncodeBelow set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varFloat xsi:type="xsd:float">3.14</varFloat></myStruct></root>'.
	self 
		andOptions: #(beAllNotTyped beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><varString>abc</varString><varInt>123</varInt><varFloat>3.14</varFloat></root>'.

!

test2001StructWithChoiceOther
	self be2001Typespace.
	instance := self getSoapStruct.
	instance removeKey: #varFloat.
	instance at: #varNotFloat put: 'test'.
	element := self getAnonElement: 'myStruct' content: self getSoapStructWithChoiceContent. 
	self 
		andOptions: #(beAllTyped beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varNotFloat xsi:type="xsd:string">test</varNotFloat></root>'.
	self 
		andOptions: #(beAllTyped beEncodeBelow set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"><myStruct><varString xsi:type="xsd:string">abc</varString><varInt xsi:type="xsd:int">123</varInt><varNotFloat xsi:type="xsd:string">test</varNotFloat></myStruct></root>'.
	self 
		andOptions: #(beAllNotTyped beEncodeWithin set2001TopNode)
		orOptions: #(beNoRef beSoapEncRef)
		assertContentXML:
'<root xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"><varString>abc</varString><varInt>123</varInt><varNotFloat>test</varNotFloat></root>'.

! !

!XeWriteReadTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeWriteReadTest.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
