"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeFuncTests subclass:#XeWriteReadTests
	instanceVariableNames:'decodeInstance element instance isEncodeBelow writer'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeWriteReadTests methodsFor:'accessing'!

andOptions: anArray orOptions: anArray2 assertContentXML: aString 
	anArray2 do: [ :each |
		self withOptions: 
			((OrderedCollection withAll: anArray) 
				add: each;
				yourself)
			assertContentXML: aString ]
!

beAllNotTyped
	^element beAllNotTyped
!

beAllTyped
	element beAllTyped
!

beEncodeBelow
	isEncodeBelow := true.
	^element beEncodeBelow
!

beEncodeWithin
	isEncodeBelow := false.
	element beEncodeWithin
!

encode
	element encode: instance writer: writer
!

set1999TopNode
	writer initializeOnTopNode: (self new1999Node: 'root')
!

set2001TopNode
	writer initializeOnTopNode: (self new2001Node: 'root')
!

setDecodeObjectFromElement
	| node reader |
	node := self rootNodeFor: writer xml.
	isEncodeBelow ifTrue: [node := node firstChild].
	reader := XeSoapXMLReader read: node element: element.
	decodeInstance := reader nodeObject
!

setDecodeObjectFromNode
	| node reader |
	node := self rootNodeFor: writer xml.
	isEncodeBelow ifTrue: [node := node firstChild].
	reader := XeSoapXMLReader read: node in: typespace.
	decodeInstance := reader nodeObject
!

setUp
	super setUp.
	writer := XeSoapXMLWriter new
!

withOptions: anArray encodeRaise: aClass 
	self setUp.
	anArray do: [:each | self perform: each].
	self should: [self encode] raise: aClass
        
! !

!XeWriteReadTests methodsFor:'asserting'!

assertContentXML: aString 
	| xml |
	self assertXML: (xml := writer xml) isSameAs: aString
!

assertDecodeToSame
	self assertSameDecodedInstance: decodeInstance.
        
!

assertSameDecodedInstance: anObject
    (anObject isKindOf: Dictionary) ifTrue: [
        Smalltalk isSmalltalkX ifTrue:[
            self assert: (anObject associations = instance associations)
        ] ifFalse:[
            self assert: (anObject equals: instance)
        ].
        ^ self.
    ].   
    (anObject isKindOf: Set) ifTrue: [
        Smalltalk isSmalltalkX ifTrue:[
            self assert: (anObject = instance)
        ] ifFalse:[
            self assert: (anObject equals: instance)
        ].
        ^ self.
    ].   

    self assert: (anObject isSoapEncSameAs: instance).
! !

!XeWriteReadTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeWriteReadTests.st,v 1.5 2010/03/10 19:56:19 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeWriteReadTests.st,v 1.5 2010/03/10 19:56:19 cg Exp $'
! !
