"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

Object subclass:#XeXMLInfoComparer
	instanceVariableNames:'xmlString1 xmlString2 doc1 doc2'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Utility'
!

XeXMLInfoComparer comment:'I compare two strings of xml. I am for Unit testing purposes only. I am *not* a general purposes xml infoset comparer, and I should not be used for any other purpose than comparing xml generated by Spray/XeEncoding'
!


!XeXMLInfoComparer methodsFor:'comparing'!

compare: aString to: aString2 
	xmlString1 := aString.
	xmlString2 := aString2.
	self createDocuments.
	^self compare
! !

!XeXMLInfoComparer methodsFor:'comparing-private'!

compare
	(doc1 xml = doc2 xml) ifTrue: [^true].
	^(XeEnvironment isYAXOParser)
		ifTrue: [self compareSAXNode: doc1 documentElement to: doc2 documentElement ]
		ifFalse: [self compareNode: doc1 documentElement to: doc2 documentElement ]
!

compareAttributes: node1 to: node2 
	^(node1 hasSameAttributeInformation: node2) and: [
		node2 hasSameAttributeInformation: node1]

        
!

compareNode: aNode1 to: aNode2 
	"This is sufficient for my needs, I have no interest in building a compliant infoset comparison class"

	"aNode1 xml = aNode2 xml ifTrue: [^true]."

	aNode1 domNode class = aNode2 domNode class ifFalse: [^false].
	aNode1 childNodes isEmpty ifTrue: [aNode1 domNode text = aNode2 domNode text ifFalse: [^false]].
	aNode1 domNode baseName = aNode2 domNode baseName ifFalse: [^false].
	aNode1 domNode namespaceURI = aNode2 domNode namespaceURI ifFalse: [^false].
	aNode1 childNodes size = aNode2 childNodes size ifFalse: [^false].
	"aNode1 domNode childNodes size = aNode2 domNode childNodes size ifFalse: [^false]."
	(self compareAttributes: aNode1 to: aNode2) ifFalse: [^false].
	aNode1 childNodes with: aNode2 childNodes
		do: [:c1 :c2 | (self compareNode: c1 to: c2) ifFalse: [^false]].
	^true
!

compareSAXNode: aNode1 to: aNode2 
	"This is sufficient for my needs, I have no interest in building a compliant infoset comparison class"

	"aNode1 xml = aNode2 xml ifTrue: [^true]."

	"aNode1 domNode class = aNode2 domNode class ifFalse: [^false]."
	aNode1 childNodes isEmpty ifTrue: [aNode1 text = aNode2 text ifFalse: [^false]].
	aNode1 localName = aNode2 localName  ifFalse: [^false].
	aNode1 namespace= aNode2 namespace ifFalse: [^false].
	aNode1 childNodes size = aNode2 childNodes size ifFalse: [^false].
	"aNode1 content size = aNode2 content size ifFalse: [^false]."
	(self compareAttributes: aNode1 to: aNode2) ifFalse: [^false].
	aNode1 childNodes with: aNode2 childNodes
		do: [:c1 :c2 | (self compareSAXNode: c1 to: c2) ifFalse: [^false]].
	^true
! !

!XeXMLInfoComparer methodsFor:'initializing-private'!

createDocuments
	doc1 := XeEnvironment docNodeFor:  xmlString1.
	doc2 := XeEnvironment docNodeFor:  xmlString2
	"doc1 := XeWDocMSXML3c basicNewEmpty loadBytes: xmlString1.
	doc2 := XeWDocMSXML3c basicNewEmpty loadBytes: xmlString2"
! !

!XeXMLInfoComparer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeXMLInfoComparer.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
