"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

TestCase subclass:#XeXMLTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Utility'
!


!XeXMLTests class methodsFor:'testing'!

isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self name asString last = $s
!

isSkipAckFailures
	^true
! !

!XeXMLTests methodsFor:'accessing'!

nsiNS
	^#'http://soapinterop.org/xsd'
!

nsiQ: aLocalName
	^XeQName local:aLocalName  ns: self nsiNS
!

qFoo
	^self blahQ: 'foo'
! !

!XeXMLTests methodsFor:'asserting'!

assertXML: aString isSameAs: aString2 
	self assert: (XeXMLInfoComparer new compare: aString to: aString2)
! !

!XeXMLTests methodsFor:'helpers'!

blahQ: aString
	^XeQName local: aString ns: #'urn:blah'
!

new2001Node: aString 
	| node |
	node := self newDoc addElement: aString.
	node addNSPrefix: 'xsi' to: XeNamespace schema2001i.
	^node
!

newDoc
	#cg.

	^YAXO::XeDoc new
!

newNode: aString
	^self newDoc addElement: aString
!

rootNodeFor: aString 
	^XeEnvironment rootNodeFor: aString
!

symmetricDifferenceOf:coll1 and:coll2
    coll1 = coll2 ifTrue:[
	^ #()
    ].

    ^ coll1 symmetricDifference:coll2
! !

!XeXMLTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeXMLTests.st,v 1.5 2003/01/20 19:02:16 cg Exp $'
! !
