"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeXSDBaseFactoryTests subclass:#XeXSDBase1999Test
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeXSDBase1999Test methodsFor:'accessing'!

schemaNamespace
	^XeNamespace schema1999
! !

!XeXSDBase1999Test methodsFor:'set up'!

setUp
	super setUp.
	self be1999Typespace.
	factory := (typespace schemaTargeting: XeNamespace schema1999) factory
! !

!XeXSDBase1999Test methodsFor:'tests'!

testAnyType
	| typeName |
	typeName := self schema qualifyLocal: 'anyType'.
	content := self schema xeContentOf: typeName encStyle: self encodingStyle.
	self assert: (content isKindOf: XeAnyContent).
	self assert: content localName = 'ur-type'.
	self assert: content namespace = XeNamespace schema1999
!

testDowngrade
	content := self schema defaultEncContent: 'dateTime'.
	self assert: (self schema defaultEncContent: 'dateTime') typeName 
				= (self schema qualifyLocal: 'timeInstant').
	self assert: (self schema defaultEncContent: 'base64Binary') typeName = (XeQName soapEnc: 'base64')
!

testURType
	| typeName |
	typeName := self schema qualifyLocal: 'ur-type'.
	content := self schema xeContentOf: typeName encStyle: self encodingStyle.
	self assert: (content isKindOf: XeAnyContent).
	self assert: content localName = 'ur-type'.
	self assert: content namespace = XeNamespace schema1999
! !

!XeXSDBase1999Test class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeXSDBase1999Test.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
