"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeSchemaFactoriesTests subclass:#XeXSDBaseFactoryTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Schema'
!


!XeXSDBaseFactoryTests methodsFor:'tests'!

testDerivedType
	content := self schema xeContentOf: (self schema qualifyLocal: 'int')
				encStyle: self encodingStyle.
	self assert: content typeName = (self schema qualifyLocal: 'int').
	self assert: content namespace = self schemaNamespace.
	self assert: content localName = 'int'.
	self assert: (content baseContent converter isKindOf: XeTextConverter).
	self assert: (content isKindOf: XeSimpleRestrictedContent).
	self assert: content baseContent localName = 'integer'
!

testImplemented
	#('string' 'number' 'integer' 'double' 'boolean' 'decimal' 'date' 'time' 'dateTime') 
		do: [:each | self assert: ((self schema defaultEncContent: each) isKindOf: XeSimpleContent)]
!

testNotFound
	self should: 
			[self schema xeContentOf: (self schema qualifyLocal: 'blah') encStyle: self encodingStyle]
		raise: Error
!

testPrimativeType
	content := self schema xeContentOf: (self schema qualifyLocal: 'integer')
				encStyle: self encodingStyle.
	self assert: content typeName = (self schema qualifyLocal: 'integer').
	self assert: (content converter isKindOf: XeTextConverter).
	self assert: (content isKindOf: XeSimpleContent)
! !

!XeXSDBaseFactoryTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeXSDBaseFactoryTests.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
