"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeXSDDateTimeTests subclass:#XeXSDDateTest
	instanceVariableNames:'xsdDate'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Core'
!


!XeXSDDateTest methodsFor:'accessing'!

date 
	^xsdDate date
! !

!XeXSDDateTest methodsFor:'tests'!

testDate
	self assert: (Date today schemaDisplayString last = $Z)
!

testFromOffsetString
	xsdDate := XeXsdDate fromString: '1999-05-31-05:00'.
	self assert: self is19990531.
	self assert: xsdDate offset hours = 5.
	self assert: xsdDate offset minutes = 0.
	self deny: xsdDate isPositiveOffset.
	self deny: xsdDate isNormal.
	self assert: xsdDate displayString = '1999-05-31-05:00'
!

testFromStringNoTimeZone
	xsdDate := XeXsdDate fromString: '1999-05-31'.
	self assert: self is19990531.
	self assert: xsdDate isNormal.
	self assert: xsdDate displayString = '1999-05-31Z'
!

testFromUTCString
	xsdDate := XeXsdDate fromString: '1999-05-31Z'.
	self assert: self is19990531.
	self assert: xsdDate isNormal.
	self assert: xsdDate displayString = '1999-05-31Z'
!

testNegative
	xsdDate := XeXsdDate fromString: '-10-01-01Z'.
	self assert: xsdDate displayString = '-10-01-01Z'
! !

!XeXSDDateTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeXSDDateTest.st,v 1.3 2003/01/20 19:02:16 cg Exp $'
! !
