"{ Package: 'stx:goodies/soap/xe/tests' }"

"{ NameSpace: SOAP }"

XeXSDDateTimeTests subclass:#XeXSDTimeTest
	instanceVariableNames:'xsdTime'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-XeEncoding-TestCases-Core'
!


!XeXSDTimeTest methodsFor:'accessing'!

time
	^xsdTime time
! !

!XeXSDTimeTest methodsFor:'tests'!

testFromOffsetString
	xsdTime := XeXsdTime fromString: '13:20:00-05:00'.
	self assert: self is1320.
	self assert: xsdTime offset hours = 5.
	self assert: xsdTime offset minutes = 0.
	self deny: xsdTime isPositiveOffset.
	self deny: xsdTime isNormal.
	self assert: xsdTime displayString = '13:20:00-05:00'
!

testFromStringNoTimeZone
	xsdTime := XeXsdTime fromString: '13:20:00'.
	self assert: self is1320.
	self assert: xsdTime isNormal.
	self assert: xsdTime displayString = '13:20:00Z'
!

testFromUTCString
	xsdTime := XeXsdTime fromString: '13:20:00Z'.
	self assert: self is1320.
	self assert: xsdTime isNormal.
	self assert: xsdTime displayString = '13:20:00Z'
!

testPrecisionMSecs
	xsdTime := XeXsdTime fromString: '18:13:40.012Z'.
	self class isSkipAckFailures ifTrue: [^nil].
	self assert: xsdTime displayString = '18:13:40.012Z'
!

testTime
	self assert: (Time readFrom: "fromString:" '13:20:00') schemaDisplayString  = '13:20:00Z'
! !

!XeXSDTimeTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xe/tests/XeXSDTimeTest.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
