"{ Package: 'stx:goodies/soap/xmlsig' }"

"{ NameSpace: SOAP }"

SoapElement subclass:#SoapDsKeyInfo
	instanceVariableNames:'keyName'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-SEC-Algorithms'
!


!SoapDsKeyInfo class methodsFor:'accessing'!

localName
	|nm|

	Smalltalk isSmalltalkX ifTrue:[
	    nm := self nameWithoutPrefix copy.
	    (nm startsWith:'SoapDs') ifTrue:[
		nm := nm copyFrom:6+1.
	    ].
	    ^ nm
	].
	^self name copyReplaceAll: 'SoapDs' with: ''
! !

!SoapDsKeyInfo methodsFor:'accessing'!

addSubElement:anElement
    anElement localName = 'KeyName' ifTrue:[
	self keyName:anElement.
	^ self
    ].
    super addSubElement:anElement.
!

isEmpty
    ^ keyName isNil
"/      and:[keyValue isNil]
"/      and:[retrievalMethod isNil]
"/      and:[x509Data isNil]
"/      and:[pgpData isNil]
"/      and:[spkiData isNil]
!

keyName
    ^ keyName
!

keyName:anXMLElement
    keyName := anXMLElement.
!

keyNameValue
    "extract a keyName string ...or nil"

    keyName notNil ifTrue:[
	^ keyName value.
    ].

    ^ keyName
!

keyNameValue:aString
    "set a keyName subElement for aString..."

    keyName := SoapWrapElement new.
    keyName name:(self prefixName , ':KeyName').
    keyName value:aString.
    keyName parent:self.
!

prefixName
    ^ SoapConstants soapDsPrefix
! !

!SoapDsKeyInfo methodsFor:'private-printing'!

privPrintCanonicalChildrenOn: aStream 
	keyName notNil ifTrue:[
	    keyName printCanonicalXmlOn: aStream
	].
"/        keyValue notNil ifTrue:[
"/            keyValue printCanonicalXmlOn: aStream
"/        ].
"/        retrievalMethod notNil ifTrue:[
"/            retrievalMethod printCanonicalXmlOn: aStream
"/        ].
"/        x509Data notNil ifTrue:[
"/            x509Data printCanonicalXmlOn: aStream
"/        ].
"/        pgpData notNil ifTrue:[
"/            pgpData printCanonicalXmlOn: aStream
"/        ].
"/        spkiData notNil ifTrue:[
"/            spkiData printCanonicalXmlOn: aStream
"/        ].
	super privPrintCanonicalChildrenOn: aStream 
!

privPrintChildrenOn: aStream indent: level 
	keyName notNil ifTrue:[
	    keyName printXmlOn: aStream indent: level
	].
"/        keyValue notNil ifTrue:[
"/            keyValue printXmlOn: aStream
"/        ].
"/        retrievalMethod notNil ifTrue:[
"/            retrievalMethod printXmlOn: aStream
"/        ].
"/        x509Data notNil ifTrue:[
"/            x509Data printXmlOn: aStream
"/        ].
"/        pgpData notNil ifTrue:[
"/            pgpData printXmlOn: aStream
"/        ].
"/        spkiData notNil ifTrue:[
"/            spkiData printXmlOn: aStream
"/        ].
	super privPrintChildrenOn: aStream indent: level 
! !

!SoapDsKeyInfo class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xmlsig/SoapDsKeyInfo.st,v 1.4 2003/01/20 19:02:16 cg Exp $'
! !
