"{ Package: 'stx:goodies/soap/xmlsig' }"

"{ NameSpace: SOAP }"

SoapCall subclass:#SoapSignedCall
	instanceVariableNames:'signatureHandler'
	classVariableNames:''
	poolDictionaries:''
	category:'SOAP-SEC-RPC'
!


!SoapSignedCall class methodsFor:'defaults'!

defaultSignatureAlgorithm
    "default value for the 'signatureAlgorithm' instance variable (automatically generated)"

    ^ SoapDigest_DSA_SHA1
! !

!SoapSignedCall methodsFor:'accessing'!

signatureHandler
    ^ signatureHandler
!

signatureHandler:something
    signatureHandler := something.
! !

!SoapSignedCall methodsFor:'building envelope'!

buildEnvelope
	|env|

	env := super buildEnvelope.
	env body declareSoapSecNamespace.
	env header isNil ifTrue:[
	    self buildSoapHeader: env addHeader
	].
	^ env.
!

buildSoapHeader: aSoapHeader
    |env|

    env := aSoapHeader parent.
    self signatureHandler generateSignatureInEnvelope:env.
    ^ aSoapHeader
! !

!SoapSignedCall class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/soap/xmlsig/SoapSignedCall.st,v 1.7 2003/01/20 19:02:16 cg Exp $'
! !
