"
 COPYRIGHT (c) 1999 by eXept Software AG 
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/stxInExternalWindow' }"

"{ NameSpace: Demos }"

Object subclass:#PlayInAlienWindow
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'demos-ExternalWindows'
!

!PlayInAlienWindow class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1999 by eXept Software AG 
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Demo class to show how ST/X applications can play their game in an
    external window (i.e. a window provided by another application).
    This allows motif, toolkit or Xlib applications to provide
    a window in which an ST/X widget or topView runs.

    Experimental.

    [Author:]
        Claus Gittinger

    [see also:]
        ExternalTopView
"
!

examples
"
    Do the following:
        - compile & link the demo programs (little Xlib-C-programs)
          found in goodies/stxInExternalWindow.

        - fileIn the PlayInExternalWindow class.

        - enable RDoits

    Execute the clockInExternalWindow or workspaceInExternalWindow program.
    These programs open an X-window, and let ST/X open a smalltalk view in it.

    If you need ST/X to play in some of your C-applications, use the code found
    there as a guide.
"
! !

!PlayInAlienWindow class methodsFor:'examples'!

start:class inExternalWindowID:windowID scrollable:scrollable
    "invoked via rdoit from alien window.
     Must pass the windowId of the external window in which the application should be opened."

    |applicationOrView appView scrollView alienTopView|

    self assert:(windowID isKindOf:ExternalAddress).
    alienTopView := ExternalTopView newWithID:windowID.

    applicationOrView := class new.
    applicationOrView isView ifTrue:[
        appView := applicationOrView.
        scrollable ifTrue:[
            scrollView := HVScrollableView new.
            scrollView scrolledView:appView.
            appView := scrollView.
        ].
    ] ifFalse:[
        applicationOrView allButOpen.
        appView := applicationOrView window.
    ].

    alienTopView becomeParentOf:appView.

    ^ applicationOrView

    "
     |v|

     v := View new.
     v openAndWait.
     self start:Workspace inExternalWindowID:v id scrollable:true
    "

    "
     |v|

     v := View new.
     v openAndWait.
     self startWorkspaceInWindowID:v id address
    "
!

startClockInWindowID:numericWindowID
    "invoked via rdoit from alien window.
     Must pass the windowId of the external window in which a clock should be opened."

    |wID|

    wID := ExternalAddress newAddress:numericWindowID.
    self start:ClockView inExternalWindowID:wID scrollable:false
!

startWorkspaceApplicationInWindowID:numericWindowID
    "invoked via rdoit from alien window.
     Must pass the windowId of the external window in which a workspace should be opened."

    |wID workspaceApp workspace|

    wID := ExternalAddress newAddress:numericWindowID.
    workspaceApp := self start:WorkspaceApplication inExternalWindowID:wID scrollable:true.

    workspace := workspaceApp selectedWorkspace.
    workspace contents:'This is an ST/X workspace
inside an alien view !!

You can select an expression and evaluate 
it with the Right-Button-Menu.
'.
    workspace cursorToEnd.
!

startWorkspaceInWindowID:numericWindowID
    "invoked via rdoit from alien window.
     Must pass the windowId of the external window in which a workspace should be opened."

    |wID workspace|

    wID := ExternalAddress newAddress:numericWindowID.
    workspace := self start:Workspace inExternalWindowID:wID scrollable:true.
    workspace contents:'This is an ST/X workspace
inside an alien view !!

You can select an expression and evaluate 
it with the Right-Button-Menu.
'.
    workspace cursorToEnd.
! !

!PlayInAlienWindow class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/stxInExternalWindow/PlayInAlienWindow.st,v 1.9 2005/12/15 19:12:18 cg Exp $'
! !
