"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

FSAState subclass:#BidirectionalEdgeLabeledDigraphNode
	instanceVariableNames:'predecessorLabelMap'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Collections-Graph Nodes'
!

BidirectionalEdgeLabeledDigraphNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I represent a node in an edge-labeled digraph.  I maintain edges in both directions, i.e. I can follow edges forwards or backwards.

Instance Variables:

	predecessorLabelMap             <SetDictionary from: labels to: predecessors>'
!


!BidirectionalEdgeLabeledDigraphNode methodsFor:'accessing'!

predecessors

	^self predecessorLabelMap elements
! !

!BidirectionalEdgeLabeledDigraphNode methodsFor:'enumerating'!

predecessorsDo: aBlock 

	self predecessors do: aBlock
!

predecessorsExceptSelfDo: aBlock 

	(self predecessors reject: [:pred | pred = self])
		do: aBlock
! !

!BidirectionalEdgeLabeledDigraphNode methodsFor:'initialization'!

init

	super init.
	self predecessorLabelMap: SetDictionary new
! !

!BidirectionalEdgeLabeledDigraphNode methodsFor:'modifying'!

addPredecessor: node withEdgeLabeled: label 

	self predecessorLabelMap at: label add: node
! !

!BidirectionalEdgeLabeledDigraphNode methodsFor:'state accessing'!

predecessorLabelMap

	^predecessorLabelMap
!

predecessorLabelMap: argument 

	predecessorLabelMap := argument
! !

!BidirectionalEdgeLabeledDigraphNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/BidirectionalEdgeLabeledDigraphNode.st,v 1.6 2002/11/20 13:48:50 cg Exp $'
! !
