"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

RegularExpressionNode subclass:#BinaryRegExprNode
	instanceVariableNames:'leftChild rightChild'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

BinaryRegExprNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am a binary regular expression.

Instance Variables:

	leftChild       <RegExprNode>
	rightChild      <RegExprNode>'
!


!BinaryRegExprNode class methodsFor:'instance creation'!

leftChild: arg1 rightChild: arg2 

	| newMe |
	newMe := self new.
	newMe leftChild: arg1.
	newMe rightChild: arg2.
	^newMe
! !

!BinaryRegExprNode methodsFor:'building parse trees'!

addChildrenFirst: anOrderedCollection 

	anOrderedCollection size = 1
		ifTrue: [self leftChild: anOrderedCollection removeFirst]
		ifFalse: [self error: 'wrong  number of children']
!

addChildrenInitial: anOrderedCollection 

	anOrderedCollection size = 2
		ifTrue: 
			[self leftChild: anOrderedCollection removeFirst.
			self rightChild: anOrderedCollection removeFirst]
		ifFalse: [anOrderedCollection size = 1
				ifTrue: [self rightChild: anOrderedCollection removeFirst]
				ifFalse: [self error: ' wrong  number of children']]
! !

!BinaryRegExprNode methodsFor:'state accessing'!

leftChild

	^leftChild
!

leftChild: argument 

	leftChild := argument
!

rightChild

	^rightChild
!

rightChild: argument 

	rightChild := argument
! !

!BinaryRegExprNode methodsFor:'traversing'!

childrenDo: aBlock 
	"Evaluate aBlock for each of my children."

	aBlock value: self leftChild.
	aBlock value: self rightChild
!

updateChildrenUsing: aBlock 
	"Replace my children according to the value of aBlock."

	self leftChild: (aBlock value: self leftChild).
	self rightChild: (aBlock value: self rightChild)
! !

!BinaryRegExprNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/BinaryRegExprNode.st,v 1.5 2002/11/20 13:50:32 cg Exp $'
! !
