"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

RegularExpressionNode subclass:#CharRangeNode
	instanceVariableNames:'firstChar lastChar'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

CharRangeNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I represent the alternations of each atomic character in a range.  I.e. ''firstChar-lastChar'' = ''firstChar | ... | lastChar''.  I may only appear as a child of a AlternationRangeNode or a ComplementedAlternationRangeNode.

Instance Variables:
	firstChar       <CharacterNode>
	lastChar        <CharacterNode>'
!


!CharRangeNode methodsFor:'building parse trees'!

addChildrenInitial: anOrderedCollection 

	anOrderedCollection size = 2
		ifTrue: 
			[self firstChar: anOrderedCollection removeFirst.
			self lastChar: anOrderedCollection removeFirst]
		ifFalse: [self error: 'wrong number of children']
! !

!CharRangeNode methodsFor:'converting'!

addCharsTo: aCollection 
	"Add each character in my range to aCollection."

	self firstChar asInteger to: self lastChar asInteger do: [:ascii | aCollection add: (Character value: ascii)]
!

addPureCharNodesTo: childNodes 
	"Add CharacterNodes for each character in my range to childNodes."

	self firstChar asInteger to: self lastChar asInteger do: [:ascii | childNodes add: (self makeCharNodeFor: (Character value: ascii))]
! !

!CharRangeNode methodsFor:'printing'!

printOn: aStream 

	self firstChar printOn: aStream.
	aStream nextPut: $-.
	self lastChar printOn: aStream
! !

!CharRangeNode methodsFor:'private'!

makeCharNodeFor: aChar 
	"Answer a new CharacterNode for aChar."

	^self characterNodeClass charSpec: (String with: aChar)
! !

!CharRangeNode methodsFor:'state accessing'!

firstChar

	^firstChar
!

firstChar: argument 

	firstChar := argument
!

lastChar

	^lastChar
!

lastChar: argument 

	lastChar := argument
! !

!CharRangeNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/CharRangeNode.st,v 1.5 2002/11/20 13:48:39 cg Exp $'
! !
