"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

RegularExpressionNode subclass:#CharacterNode
	instanceVariableNames:'charSpec'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

CharacterNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am a atomic character of a regular expression.

Instance Variables:
	charSpec        <String> - contains the character atom specification for this node (different types of specifications are represented by subclasses).'
!


!CharacterNode class methodsFor:'instance creation'!

charSpec: arg1 

	| newMe |
	newMe := self new.
	newMe charSpec: arg1.
	^newMe
! !

!CharacterNode methodsFor:'accessing'!

asInteger

	^self myChar asInteger
!

myChar
	"Answer the Character represented by the receiver."

	self charSpec size = 1
		ifTrue: [^self charSpec first]
		ifFalse: [self error: 'Only single character regular expressions atoms are currently supported.']
! !

!CharacterNode methodsFor:'building parse trees'!

setAttribute: value 

	self charSpec: value
! !

!CharacterNode methodsFor:'converting'!

addCharsTo: aCollection 
	"Add each character in my range to aCollection."

	aCollection add: self myChar
!

addPureCharNodesTo: childNodes 

	childNodes add: self
!

asFSAStartingAt: startState endingAt: finalState 

	startState goto: finalState on: self myChar
! !

!CharacterNode methodsFor:'printing'!

printOn: aStream 

	self charSpec printOn: aStream
! !

!CharacterNode methodsFor:'state accessing'!

charSpec

	^charSpec
!

charSpec: argument 

	charSpec := argument
! !

!CharacterNode methodsFor:'traversing'!

addNonemptyLeavesTo: aSet 

	aSet add: self myChar
! !

!CharacterNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/CharacterNode.st,v 1.5 2002/11/20 13:46:38 cg Exp $'
! !
