"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

AlternationRangeNode subclass:#ComplementedAlternationRangeNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

ComplementedAlternationRangeNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I represent the alternation of two or more atomic regular expressions (specified as the complement of an alternation range).  I take the complement of the universe of printable characters only, e.g. ~[aeiou] (all non-vowel printable characters).'
!


!ComplementedAlternationRangeNode methodsFor:'accessing'!

characterUniverse
	"Answer a collection of printable characters."

	^((32 to: 126)
		collect: [:ea | Character value: ea]) asSet
!

characters
        "Answer the Set of Characters I represent."

        |chars unwanted|
        unwanted := super characters.
        chars := self characterUniverse reject:[:c| unwanted includes:c].
        ^chars

    "Modified: 18.2.1997 / 10:22:34 / stefan"
! !

!ComplementedAlternationRangeNode methodsFor:'printing'!

printOn: aStream 

	aStream nextPut: $~.
	super printOn: aStream
! !

!ComplementedAlternationRangeNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/ComplementedAlternationRangeNode.st,v 1.6 2002/11/20 13:47:25 cg Exp $'
! !
