"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

CharacterNode subclass:#DecimalCharNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

DecimalCharNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am a atomic character of a regular expression.  I am specified by a String of the form ''\ddd'' where each d is a decimal digit and ddd is my corresponding ASCII value.

'
!


!DecimalCharNode methodsFor:'accessing'!

myChar
	"Answer the Character represented by the receiver. 
	The spec is of the form '\ddd'."

	| spec |
	spec := self charSpec.
	(spec size = 4 and: [spec first = $\])
		ifTrue: [^Character value: (spec copyFrom: 2 to: 4) asNumber]
		ifFalse: [self error: 'Decimal character specifications must be of the form ''\ddd''.']
! !

!DecimalCharNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/DecimalCharNode.st,v 1.5 2002/11/20 13:47:44 cg Exp $'
! !
