"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

ParseTreeBuilder subclass:#DerivationTreeBuilder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Parse Trees'
!

DerivationTreeBuilder comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

This concrete class is used for building derivation trees for a parse.  It uses homogeneous DerivationTreeNodes for all nodes and a specialized production processor.'
!


!DerivationTreeBuilder methodsFor:'tree building'!

epsilon
	"Answer an object used to represent the empty string (epsilon)."

	^'<epsilon>'
!

processProduction: grammarProd forParser: parser 
	"This is simple and straightforward to implement, so do it all here."

	| parent child |
	parent := DerivationTreeNode symbol: grammarProd leftHandSide.
	grammarProd rightHandSide isEmpty
		ifTrue: 
			[child := DerivationTreeNode symbol: self epsilon.
			parent addChild: child]
		ifFalse: [parser performsLeftmostDerivation
				ifTrue: [grammarProd rightHandSide do: 
						[:sym | 
						child := sym isTerminal
									ifTrue: [DerivationTreeNode symbol: sym]
									ifFalse: [self popStack].
						parent addChild: child]]
				ifFalse: [grammarProd rightHandSide
						reverseDo: 
							[:sym | 
							child := sym isTerminal
										ifTrue: [DerivationTreeNode symbol: sym]
										ifFalse: [self popStack].
							parent addFirstChild: child]]].
	self pushStack: parent
! !

!DerivationTreeBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/DerivationTreeBuilder.st,v 1.5 2002/11/20 13:47:10 cg Exp $'
! !
