"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

GraphNode subclass:#DirectedGraphNode
	instanceVariableNames:'predecessors'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Collections-Graph Nodes'
!

DirectedGraphNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I maintain a collection of my predecessor nodes.

Instance Variables:
	predecessors            <OrderedCollection of: DirectedGraphNode>'
!


!DirectedGraphNode class methodsFor:'instance creation'!

new

	^super new init
! !

!DirectedGraphNode methodsFor:'enumerating'!

predecessorsDo: aBlock 
	"Evaluate aBlock with each of my predecessors."

	self predecessors do: aBlock
! !

!DirectedGraphNode methodsFor:'initialization'!

init

	self predecessors: OrderedCollection new
! !

!DirectedGraphNode methodsFor:'modifying'!

addPredecessor: node 

	self predecessors add: node
!

removePredecessor: node 

	self predecessors remove: node ifAbsent: [self error: 'precedessor not found']
!

removePredecessor: node ifAbsent: aBlock 

	self predecessors remove: node ifAbsent: [^aBlock value]
! !

!DirectedGraphNode methodsFor:'state accessing'!

predecessors

	^predecessors
!

predecessors: argument 

	predecessors := argument
! !

!DirectedGraphNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/DirectedGraphNode.st,v 1.6 2002/11/20 13:48:42 cg Exp $'
! !
