"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

RegularExpressionNode subclass:#EnnaryRegExprNode
	instanceVariableNames:'children'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

EnnaryRegExprNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I represent an n-ary regular expression.'
!


!EnnaryRegExprNode class methodsFor:'instance creation'!

children: arg1 

	| newMe |
	newMe := super new.
	newMe children: arg1.
	^newMe
!

new

	^super new init
! !

!EnnaryRegExprNode methodsFor:'building parse trees'!

addChildrenFirst: anOrderedCollection 

	self children addAllFirst: anOrderedCollection
!

addChildrenInitial: anOrderedCollection 

	self children addAll: anOrderedCollection
! !

!EnnaryRegExprNode methodsFor:'converting'!

asPureRegExpr
	"Answer a new version of the receiver consisting of only characters, 
	concatenations, alternations, and (star) closures. Also, eliminate single 
	child alternations and concatenations."

	| newKids |
	self children size = 1 ifTrue: [^self children first asPureRegExpr].
	newKids := OrderedChildren new.
	self childrenDo: [:child | newKids add: child asPureRegExpr].
	^self species children: newKids
! !

!EnnaryRegExprNode methodsFor:'initialization'!

init

	self children: OrderedCollection new
! !

!EnnaryRegExprNode methodsFor:'state accessing'!

children

	^children
!

children: argument 

	children := argument
! !

!EnnaryRegExprNode methodsFor:'traversing'!

childrenDo: aBlock 
	"Evaluate aBlock for each of my children."

	self children do: aBlock
!

updateChildrenUsing: aBlock 
	"Replace my children according to the value of aBlock."

	self children: (self children collect: aBlock)
! !

!EnnaryRegExprNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/EnnaryRegExprNode.st,v 1.5 2002/11/20 13:48:34 cg Exp $'
! !
