"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

RegularExpressionNode subclass:#EpsilonNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

EpsilonNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I represent the empty regular expression.'
!


!EpsilonNode class methodsFor:'constants'!

epsilon
	"Answer an object used to represent the empty string."

	^Character endOfInput
! !

!EpsilonNode methodsFor:'building parse trees'!

concatenateWith: node

	^node
!

concatenateWithCatNode: node

	^node
!

concatenateWithNonCatNode: node

	^node
! !

!EpsilonNode methodsFor:'collecting'!

collectSymbol

	^OrderedCollection new
! !

!EpsilonNode methodsFor:'converting'!

asFSAStartingAt: startState endingAt: finalState 

	startState goto: finalState on: self epsilon
! !

!EpsilonNode methodsFor:'printing'!

printOn: aStream 

	aStream nextPutAll: '<epsilon>'
! !

!EpsilonNode methodsFor:'testing'!

isEpsilonNode

	^true
! !

!EpsilonNode methodsFor:'transforming'!

transformUsing: lhsNames withLHS: lhsNode alpha: alphaNodes gamma: gammaNodes
	"Productions of the form 'A -> <epsilon>' do not need transforming.
	Signal this by answering an empty collection."

	^OrderedCollection new
! !

!EpsilonNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/EpsilonNode.st,v 1.5 2002/11/20 13:49:16 cg Exp $'
! !
