"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

FSABasedScanner subclass:#FSABasedLookaheadScanner
	instanceVariableNames:'savePosition'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Compilers-Scanners'
!

FSABasedLookaheadScanner comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

This is an abstract class for scanners with lookahead.

Instance Variables:
	savePosition <Integer> - pointer into input source for error notification.'
!


!FSABasedLookaheadScanner methodsFor:'accessing'!

errorPosition
	"Answer the source position of the last acceptable character."

	^self savePosition max: 1
! !

!FSABasedLookaheadScanner methodsFor:'initialization'!

reset
	"Reset the initial state of the scanner before scanning a new source."

	super reset.
	self savePosition: 0
! !

!FSABasedLookaheadScanner methodsFor:'state accessing'!

savePosition

	^savePosition
!

savePosition: argument 

	savePosition := argument
! !

!FSABasedLookaheadScanner class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/FSABasedLookaheadScanner.st,v 1.6 2002/11/20 13:47:28 cg Exp $'
! !
