"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

FSABasedLookaheadScanner subclass:#FSABasedScannerWithOneTokenLookahead
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Compilers-Scanners'
!

FSABasedScannerWithOneTokenLookahead comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

This class provides a scanner with simple one-token lookahead.  '
!


!FSABasedScannerWithOneTokenLookahead methodsFor:'scanner generation'!

defaultOptimizedScannerClass

	^OptimizedScannerWithOneTokenLookahead
! !

!FSABasedScannerWithOneTokenLookahead methodsFor:'scanning'!

scanToken
	"Scan the next token and compute its token type."

	| nextState tok typeAction stateStack saveChar saveState |
	stateStack := Stack new.
	self atEnd
		ifTrue: [self signalEndOfInput]
		ifFalse: 
			[stateStack push: self startState.
			[(nextState := stateStack top transitionFor: self nextChar ifNone: [nil]) isNil]
				whileFalse: 
					[stateStack push: nextState.
					self getNextChar].
			"save the current position for error notification"
			self savePosition: self position + (self atEnd ifTrue: [1] ifFalse: [0]).
			stateStack top isFSAFinalState
				ifFalse: 
					[saveChar := self nextChar.
					saveState := stateStack top.
					"backup to the previous final state or to the start state"
					[stateStack size = 1 or: [stateStack top isFSAFinalState]]
						whileFalse: 
							[stateStack pop.
							self putBackChar].
					stateStack size = 1 ifTrue: 
						["backed up to the start state so signal an error"
						saveState transitionFor: saveChar]].
			"answer the newly scanned token"
			tok := self buffer contents.
			typeAction := stateStack top tokenTypeAndActionFor: tok.
			self tokenType: typeAction type.
			self token: tok.
			self buffer reset.
			typeAction action notNil ifTrue: [self perform: typeAction action]]
! !

!FSABasedScannerWithOneTokenLookahead class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/FSABasedScannerWithOneTokenLookahead.st,v 1.6 2002/11/20 13:46:41 cg Exp $'
! !
