"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

LabeledDigraph subclass:#FirstFollowGraph
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Support'
!

FirstFollowGraph comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am a graph consisting of FirstFollowGraphNodes used in the computation of first and follow sets.  I serve as the public interface to my nodes.'
!


!FirstFollowGraph class methodsFor:'instance creation'!

preferredNodeClass

	^FirstFollowGraphNode
! !

!FirstFollowGraph methodsFor:'accessing'!

nodeSetMap
	"Answer a map from node names (nonterminals) to sets of terminals, representing 
	either the first or follow sets."

	| map |
	map := SetDictionary new.
	self nodesDo: [:node | map add: node asAssociation].
	^map
! !

!FirstFollowGraph methodsFor:'first/follow sets'!

propagateSetUnions
	"For each of my nodes, replace its node set with the union of its old node set 
	and the node sets along all incoming edges. Repeat until no more changes."

	| changes |
	changes := true.
	[changes]
		whileTrue: [changes := self inject: false into: [:chngs :node | chngs | node unionWithPredecessorsChangesMe]]
! !

!FirstFollowGraph methodsFor:'modifying'!

addTerminal: term toNodeLabeled: label 

	(self detect: [:node | node label = label])
		addTerminal: term
! !

!FirstFollowGraph class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/FirstFollowGraph.st,v 1.5 2002/11/20 13:48:08 cg Exp $'
! !
