"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

NodeLabeledDigraphNode subclass:#FirstFollowGraphNode
	instanceVariableNames:'terminals'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Support'
!

FirstFollowGraphNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I represent a nonterminal of a grammar for the purpose of first and follow set computation.

Instance Variables:
	terminals       <Set of: Symbols> - the first or follow set of my nonterminal.'
!


!FirstFollowGraphNode methodsFor:'adding'!

addTerminal: term 

	self terminals add: term
! !

!FirstFollowGraphNode methodsFor:'converting'!

asAssociation

	^Association key: self label value: self terminals
! !

!FirstFollowGraphNode methodsFor:'first/follow sets'!

unionWithPredecessorsChangesMe
	"Answer true if adding the terminals of my predecessors changes my terminals 
	and false otherwise."

	| myTerms initialSize |
	myTerms := self terminals.
	initialSize := myTerms size.
	self predecessorsDo: [:pred | myTerms addAll: pred terminals].
	^initialSize ~= myTerms size
! !

!FirstFollowGraphNode methodsFor:'initialization'!

init

	super init.
	self terminals: Set new
! !

!FirstFollowGraphNode methodsFor:'state accessing'!

terminals

	^terminals
!

terminals: argument 

	terminals := argument
! !

!FirstFollowGraphNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/FirstFollowGraphNode.st,v 1.5 2002/11/20 13:46:33 cg Exp $'
! !
