"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

GrammarParseTreeNode subclass:#GrammarLeafNode
	instanceVariableNames:'symbol'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Grammar Nodes'
!

GrammarLeafNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am an abstract class for grammar tree leaf nodes.

Instance Variables:

	symbol  <Symbol + String>       - a terminal, nonterminal, or transduction symbol.'
!


!GrammarLeafNode class methodsFor:'instance creation'!

symbol: aSymbol

	| newNode |
	newNode := self new.
	newNode symbol: aSymbol.
	^newNode
! !

!GrammarLeafNode methodsFor:'building parse trees'!

setAttribute: value 

	self symbol: value
! !

!GrammarLeafNode methodsFor:'printing'!

printOn: aStream

	aStream nextPutAll: self symbol
! !

!GrammarLeafNode methodsFor:'state accessing'!

symbol

	^symbol
!

symbol: argument 

	symbol := argument
! !

!GrammarLeafNode methodsFor:'transforming'!

needsTransforming

	^false
!

transformUsing: lhsNames withLHS: lhsNode alpha: alphaNodes gamma: gammaNodes
	"Productions of the form 'A -> leaf' do not need transforming.
	Signal this by answering an empty collection."

	^OrderedCollection new
! !

!GrammarLeafNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/GrammarLeafNode.st,v 1.5 2002/11/20 13:49:35 cg Exp $'
! !
