"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

ParseTreeNode subclass:#GrammarParseTreeNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Grammar Nodes'
!

GrammarParseTreeNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

This class is an abstract class for grammar parse tree nodes.'
!


!GrammarParseTreeNode methodsFor:'building parse trees'!

alternateWith: node

	^node alternateWithNonAltNode: self
!

alternateWithAltNode: node

	node children addLast: self.
	^node
!

alternateWithNonAltNode: node

	^self alternationNodeClass children: (OrderedCollection with: node with: self)
!

concatenateWith: node

	^node concatenateWithNonCatNode: self
!

concatenateWithCatNode: node

	node children addLast: self.
	^node
!

concatenateWithNonCatNode: node

	^self concatenationNodeClass children: (OrderedCollection with: node with: self)
! !

!GrammarParseTreeNode methodsFor:'private'!

alternationNodeClass

	^AlternationNode
!

concatenationNodeClass

	^ConcatenationNode
! !

!GrammarParseTreeNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/GrammarParseTreeNode.st,v 1.5 2002/11/20 13:50:25 cg Exp $'
! !
