"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

OptimizedLR1Parser subclass:#GrammarSpecParser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Interface'
!

GrammarSpecParser comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Object tgenCopyright."
=================================================

I am a parser for T-gen grammar specifications.'
!


!GrammarSpecParser class methodsFor:'class initialization'!

initialize
	"GrammarSpecParser initialize"
	"       gram            : rule gram                                     {liftRightChild} ; 
	gram            :                                                       {GrammarNode} ; 
	rule            : nonterm ':' rightParts ';'    {RRPGProductionNode} ; 
	nonterm : <id>                                          {NonterminalNode} ; 
	rightParts      : regExpr '|' rightParts                {alternate:with:} ; 
	rightParts      : regExpr                                       ; 
	regExpr         : listExpr trans                                {RRPGRightHandSideNode} ; 
	listExpr                : listExpr '^' catExpr          {ListNode} ;
	listExpr                : catExpr                                       ;
	catExpr         : expr catExpr                          {concatenate:with:} ; 
	catExpr         :                                                       {EpsilonNode} ; 
	expr            : baseExpr '*'                          {StarClosureNode} ; 
	expr            : baseExpr '+'                          {PlusClosureNode} ; 
	expr            : baseExpr '?'                          {OptionalNode} ; 
	expr            : baseExpr                                      ; 
	baseExpr        : term                                          ; 
	baseExpr        : nonterm                                       ; 
	baseExpr        : '(' subExpr ')'                               ; 
	subExpr : listExpr '|' subExpr                  {alternate:with:} ;
	subExpr : listExpr                                      ; 
	trans           : '{' transSym '}'                              ; 
	trans           :                                                       {nil} ; 
	transSym        : <id>                                          {TranslationNode} ;
	transSym        : <keyword>                             {TranslationNode} ; 
	term            : <tokenClass>                          {TerminalNode } ; 
	term            : <literal>                                     {TerminalNode} ; 
"

	| table prodTable |
	prodTable := #( #expr $ '<id>' ')' #trans #listExpr '(' #regExpr ';' ':' #rightParts #transSym #term #gram '}' #baseExpr '|' '^' #nonterm #subExpr '<tokenClass>' '{' #catExpr '?' '+' '<keyword>' '<literal>' #rule '*' 'liftRightChild' 'StarClosureNode' 'OptionalNode' 'RRPGRightHandSideNode' 'RRPGProductionNode' 'nil' 'alternate:with:' 'TranslationNode' 'GrammarNode' 'concatenate:with:' 'PlusClosureNode' 'NonterminalNode' 'ListNode' 'TerminalNode' 'EpsilonNode' ).
	self tokenTypeTable:  (prodTable copyFrom: 1 to:  29).
	table := #( #( nil #(14 #()38)  14 nil nil nil nil nil nil nil nil nil nil 2 nil nil nil nil 6 nil nil nil nil nil nil nil nil 4 nil ) #( nil 3 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil #(14 #()38)  14 nil nil nil nil nil nil nil nil nil nil 5 nil nil nil nil 6 nil nil nil nil nil nil nil nil 4 nil ) #( nil #(14 #(28 14 )30)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil 7 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( 8 nil 14 #(23 #()44)  nil 31 12 28 #(23 #()44)  nil 38 nil 9 nil nil 17 #(23 #()44)  #(23 #()44)  10 nil 13 #(23 #()44)  24 nil nil nil 11 nil nil ) #( 8 nil 14 #(23 #()44)  nil nil 12 nil #(23 #()44)  nil nil nil 9 nil nil 17 #(23 #()44)  #(23 #()44)  10 nil 13 #(23 #()44)  27 nil nil nil 11 nil nil ) #( nil nil #(16 #(13 ))  #(16 #(13 ))  nil nil #(16 #(13 ))  nil #(16 #(13 ))  nil nil nil nil nil nil nil #(16 #(13 ))  #(16 #(13 ))  nil nil #(16 #(13 ))  #(16 #(13 ))  nil #(16 #(13 ))  #(16 #(13 ))  nil #(16 #(13 ))  nil #(16 #(13 ))  ) #( nil nil #(16 #(19 ))  #(16 #(19 ))  nil nil #(16 #(19 ))  nil #(16 #(19 ))  nil nil nil nil nil nil nil #(16 #(19 ))  #(16 #(19 ))  nil nil #(16 #(19 ))  #(16 #(19 ))  nil #(16 #(19 ))  #(16 #(19 ))  nil #(16 #(19 ))  nil #(16 #(19 ))  ) #( nil nil #(13 #(27 )43)  #(13 #(27 )43)  nil nil #(13 #(27 )43)  nil #(13 #(27 )43)  nil nil nil nil nil nil nil #(13 #(27 )43)  #(13 #(27 )43)  nil nil #(13 #(27 )43)  #(13 #(27 )43)  nil #(13 #(27 )43)  #(13 #(27 )43)  nil #(13 #(27 )43)  nil #(13 #(27 )43)  ) #( 8 nil 14 #(23 #()44)  nil 15 12 nil #(23 #()44)  nil nil nil 9 nil nil 17 #(23 #()44)  #(23 #()44)  10 25 13 #(23 #()44)  24 nil nil nil 11 nil nil ) #( nil nil #(13 #(21 )43)  #(13 #(21 )43)  nil nil #(13 #(21 )43)  nil #(13 #(21 )43)  nil nil nil nil nil nil nil #(13 #(21 )43)  #(13 #(21 )43)  nil nil #(13 #(21 )43)  #(13 #(21 )43)  nil #(13 #(21 )43)  #(13 #(21 )43)  nil #(13 #(21 )43)  nil #(13 #(21 )43)  ) #( nil nil #(19 #(3 )41)  #(19 #(3 )41)  nil nil #(19 #(3 )41)  nil #(19 #(3 )41)  #(19 #(3 )41)  nil nil nil nil nil nil #(19 #(3 )41)  #(19 #(3 )41)  nil nil #(19 #(3 )41)  #(19 #(3 )41)  nil #(19 #(3 )41)  #(19 #(3 )41)  nil #(19 #(3 )41)  nil #(19 #(3 )41)  ) #( nil nil nil #(20 #(6 ))  nil nil nil nil nil nil nil nil nil nil nil nil 22 16 nil nil nil nil nil nil nil nil nil nil nil ) #( 8 nil 14 #(23 #()44)  nil nil 12 nil #(23 #()44)  nil nil nil 9 nil nil 17 #(23 #()44)  #(23 #()44)  10 nil 13 #(23 #()44)  21 nil nil nil 11 nil nil ) #( nil nil #(1 #(16 ))  #(1 #(16 ))  nil nil #(1 #(16 ))  nil #(1 #(16 ))  nil nil nil nil nil nil nil #(1 #(16 ))  #(1 #(16 ))  nil nil #(1 #(16 ))  #(1 #(16 ))  nil 19 20 nil #(1 #(16 ))  nil 18 ) #( nil nil #(1 #(16 29 )31)  #(1 #(16 29 )31)  nil nil #(1 #(16 29 )31)  nil #(1 #(16 29 )31)  nil nil nil nil nil nil nil #(1 #(16 29 )31)  #(1 #(16 29 )31)  nil nil #(1 #(16 29 )31)  #(1 #(16 29 )31)  nil nil nil nil #(1 #(16 29 )31)  nil nil ) #( nil nil #(1 #(16 24 )32)  #(1 #(16 24 )32)  nil nil #(1 #(16 24 )32)  nil #(1 #(16 24 )32)  nil nil nil nil nil nil nil #(1 #(16 24 )32)  #(1 #(16 24 )32)  nil nil #(1 #(16 24 )32)  #(1 #(16 24 )32)  nil nil nil nil #(1 #(16 24 )32)  nil nil ) #( nil nil #(1 #(16 25 )40)  #(1 #(16 25 )40)  nil nil #(1 #(16 25 )40)  nil #(1 #(16 25 )40)  nil nil nil nil nil nil nil #(1 #(16 25 )40)  #(1 #(16 25 )40)  nil nil #(1 #(16 25 )40)  #(1 #(16 25 )40)  nil nil nil nil #(1 #(16 25 )40)  nil nil ) #( nil nil nil #(6 #(6 18 23 )42)  nil nil nil nil #(6 #(6 18 23 )42)  nil nil nil nil nil nil nil #(6 #(6 18 23 )42)  #(6 #(6 18 23 )42)  nil nil nil #(6 #(6 18 23 )42)  nil nil nil nil nil nil nil ) #( 8 nil 14 #(23 #()44)  nil 15 12 nil #(23 #()44)  nil nil nil 9 nil nil 17 #(23 #()44)  #(23 #()44)  10 23 13 #(23 #()44)  24 nil nil nil 11 nil nil ) #( nil nil nil #(20 #(6 17 20 )36)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil #(6 #(23 ))  nil nil nil nil #(6 #(23 ))  nil nil nil nil nil nil nil #(6 #(23 ))  #(6 #(23 ))  nil nil nil #(6 #(23 ))  nil nil nil nil nil nil nil ) #( nil nil nil 26 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil #(16 #(7 20 4 ))  #(16 #(7 20 4 ))  nil nil #(16 #(7 20 4 ))  nil #(16 #(7 20 4 ))  nil nil nil nil nil nil nil #(16 #(7 20 4 ))  #(16 #(7 20 4 ))  nil nil #(16 #(7 20 4 ))  #(16 #(7 20 4 ))  nil #(16 #(7 20 4 ))  #(16 #(7 20 4 ))  nil #(16 #(7 20 4 ))  nil #(16 #(7 20 4 ))  ) #( nil nil nil #(23 #(1 23 )39)  nil nil nil nil #(23 #(1 23 )39)  nil nil nil nil nil nil nil #(23 #(1 23 )39)  #(23 #(1 23 )39)  nil nil nil #(23 #(1 23 )39)  nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil #(11 #(8 ))  nil nil nil nil nil nil nil 29 nil nil nil nil nil nil nil nil nil nil nil nil ) #( 8 nil 14 #(23 #()44)  nil 31 12 28 #(23 #()44)  nil 30 nil 9 nil nil 17 #(23 #()44)  #(23 #()44)  10 nil 13 #(23 #()44)  24 nil nil nil 11 nil nil ) #( nil nil nil nil nil nil nil nil #(11 #(8 17 11 )36)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil 37 nil nil nil #(5 #()35)  nil nil nil nil nil nil nil #(5 #()35)  16 nil nil nil 32 nil nil nil nil nil nil nil ) #( nil nil 36 nil nil nil nil nil nil nil nil 34 nil nil nil nil nil nil nil nil nil nil nil nil nil 33 nil nil nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil nil nil #(12 #(26 )37)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil nil nil 35 nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil #(5 #(22 12 15 ))  nil nil nil nil nil nil nil #(5 #(22 12 15 ))  nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil nil nil #(12 #(3 )37)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil #(8 #(6 5 )33)  nil nil nil nil nil nil nil #(8 #(6 5 )33)  nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil 39 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil #(28 #(19 10 11 9 )34)  #(28 #(19 10 11 9 )34)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) ).
	self constructParseTable: table  with: prodTable.
	self finalState: 3
! !

!GrammarSpecParser methodsFor:'private'!

scannerClass
	^GrammarSpecScanner
!

treeBuilderClass
	^GrammarTreeBuilder
! !

!GrammarSpecParser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/GrammarSpecParser.st,v 1.4 2002/11/20 13:48:14 cg Exp $'
! !

GrammarSpecParser initialize!
