"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

CharacterNode subclass:#HexadecimalCharNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

HexadecimalCharNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am a atomic character of a regular expression.  I am specified by a String of the form ''\xHH'' where each H is a hexadecimal digit (0-9, a-f or A-F) and HH is my corresponding ASCII value.

'
!


!HexadecimalCharNode methodsFor:'accessing'!

myChar
	"Answer the Character represented by the receiver. 
	The spec is of the form '\xHH'."

	| spec |
	spec := self charSpec.
	(spec size = 4 and: [spec first = $\ and: [(spec at: 2)
				= $x]])
		ifTrue: [^Character value: ('16r' , (spec copyFrom: 3 to: 4)) asNumber]
		ifFalse: [self error: 'Hexadecimal character specifications must be of the form ''\xHH''.']
! !

!HexadecimalCharNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/HexadecimalCharNode.st,v 1.5 2002/11/20 13:49:11 cg Exp $'
! !
