"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

Set subclass:#ItemSet
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Support'
!

ItemSet comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

ItemSets are equal if they contain equal elements.'
!


!ItemSet methodsFor:'comparing'!

= anItemSet 

    ^anItemSet isItemSet
        and:[self size = anItemSet size 
        and:[self do:[:item|
                          (anItemSet includes:item) ifFalse:[^false]
                     ]. true
        ]].

    "Modified: 17.2.1997 / 01:08:49 / stefan"
!

hash
	"Make sure equal sets hash equally."
	"A good and fast hashing function will require some more thought. I used to use 
	'self size bitXor: self first hash' but there is no guarantee that the first's of 
	equal sets will be the same element (even if their basicSizes are the same, due 
	to the temporal ordering of hash collisions). If simply 'size' doesn't give 
	reasonable performance, then try 'self inject: 0 into: [:max :each 
	| max max: each hash]'."

	^self isEmpty
		ifTrue: [151515]
		ifFalse: [self size]
! !

!ItemSet methodsFor:'testing'!

isItemSet

	^true
! !

!ItemSet class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/ItemSet.st,v 1.6 2002/11/20 13:47:06 cg Exp $'
! !
