"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

DirectedGraph subclass:#LabeledDigraph
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Collections-Graphs'
!

LabeledDigraph comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

This class represents a directed graph whose edges are labeled.'
!


!LabeledDigraph class methodsFor:'instance creation'!

preferredNodeClass

	^NodeLabeledDigraphNode
! !

!LabeledDigraph methodsFor:'modifying'!

addEdgeFromNodeLabeled: label1 toNodeLabeled: label2 

	| node1 node2 |
	label1 ~= label2
		ifTrue: 
			["self edges are implicit and not represented"
			node1 := self detect: [:node | node label = label1].
			node2 := self detect: [:node | node label = label2].
			self addEdgeFrom: node1 to: node2]
! !

!LabeledDigraph class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/LabeledDigraph.st,v 1.6 2002/11/20 13:47:04 cg Exp $'
! !
