"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

BinaryRegExprNode subclass:#ListNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

ListNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am an instance of the regular expression ''a list b'' which is equivalent to a(ba)*.'
!


!ListNode methodsFor:'printing'!

printOn: aStream 
	aStream nextPut: $(.
	self leftChild printOn: aStream.
	aStream nextPutAll: ' ^ '.
	self rightChild printOn: aStream.
	aStream nextPut: $)
! !

!ListNode methodsFor:'transforming'!

needsTransforming

	^true
!

transformUsing: lhsNames withLHS: lhsNode alpha: alphaNodes gamma: gammaNodes 
	"Transform productions of the form 'A -> alpha beta1 list beta2 gamma' 
	into 'A -> alpha B', 'B -> beta1 gamma', and 'B -> beta1 beta2 B'."

	| newProds newLHS |
	newProds := OrderedCollection new.
	newLHS := self newNonterminalFrom: lhsNode excluding: lhsNames.
	newProds add: (self createNewProductionWithLHS: lhsNode andRHS: (alphaNodes addLast: newLHS; yourself)).
	newProds add: (self createNewProductionWithLHS: newLHS andRHS: (gammaNodes addFirst: self leftChild copy; yourself)).
	newProds add: (self createNewProductionWithLHS: newLHS andRHS: (OrderedCollection
					with: self leftChild copy
					with: self rightChild copy
					with: newLHS)).
	^newProds
! !

!ListNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/ListNode.st,v 1.5 2002/11/20 13:46:02 cg Exp $'
! !
