"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

CharacterNode subclass:#OctalCharNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

OctalCharNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am a atomic character of a regular expression.  I am specified by a String of the form ''\oOOO'' where each O is a octal digit (0-7) and OOO is my corresponding ASCII value.

'
!


!OctalCharNode methodsFor:'accessing'!

myChar
	"Answer the Character represented by the receiver. 
	The spec is of the form '\oOOO'."

	| spec |
	spec := self charSpec.
	(spec size = 5 and: [spec first = $\ and: [(spec at: 2)
				= $o]])
		ifTrue: [^Character value: ('8r' , (spec copyFrom: 3 to: 5)) asNumber]
		ifFalse: [self error: 'Octal character specifications must be of the form ''\oOOO''.']
! !

!OctalCharNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/OctalCharNode.st,v 1.5 2002/11/20 13:50:35 cg Exp $'
! !
