"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

OptimizedScanner subclass:#OptimizedLookaheadScanner
	instanceVariableNames:'savePosition'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Compilers-Scanners'
!

OptimizedLookaheadScanner comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

This is an abstract class for table-based optimized scanners with lookahead.

Instance Variables:
	savePosition <Integer> - pointer into input source for error notification.'
!


!OptimizedLookaheadScanner methodsFor:'accessing'!

errorPosition
	"Answer the source position of the last acceptable character."

	^self savePosition max: 1
! !

!OptimizedLookaheadScanner methodsFor:'initialization'!

reset
	"Reset the initial state of the scanner before scanning a new source."

	super reset.
	self savePosition: 0
! !

!OptimizedLookaheadScanner methodsFor:'state accessing'!

savePosition

	^savePosition
!

savePosition: argument 

	savePosition := argument
! !

!OptimizedLookaheadScanner methodsFor:'testing'!

isFSAFinalState: aState
    "Answer true if aState is a final state, false otherwise."

    ^(self finalStateTable at: aState) notNil
! !

!OptimizedLookaheadScanner class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/OptimizedLookaheadScanner.st,v 1.6 2002/11/20 13:49:50 cg Exp $'
! !
