"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

OptimizedLookaheadScanner subclass:#OptimizedScannerWithOneTokenLookahead
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Compilers-Scanners'
!

OptimizedScannerWithOneTokenLookahead comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

This class provides a table-based optimized scanner with simple one-token lookahead.  '
!


!OptimizedScannerWithOneTokenLookahead methodsFor:'scanning'!

scanToken
	"Scan the next token and compute its token type."

	| nextState tok typeAction stateStack saveChar saveState |
	stateStack := Stack new.
	self atEnd
		ifTrue: [self signalEndOfInput]
		ifFalse:
			[stateStack push: self startState.
			[(nextState := (fsa at: stateStack top) at: self nextChar asInteger) isNil]
				whileFalse:
					[stateStack push: nextState.
					self getNextChar].
			"save the current position for error notification"
			self savePosition: self position + (self atEnd ifTrue: [1] ifFalse: [0]).
			(self isFSAFinalState: stateStack top)
				ifFalse:
					["save the current position for error notification"
					saveChar := self nextChar.
					saveState := stateStack top.
					"backup to the previous final state or to the start state"
					[stateStack size = 1 or: [self isFSAFinalState: stateStack top]]
						whileFalse:
							[stateStack pop.
							self putBackChar].
					stateStack size = 1
						ifTrue:
						["backed up to the start state so signal an error"
						self at: saveState transitionFor: saveChar]].
		"answer the newly scanned token"
		tok := self buffer contents.
		typeAction := self at: stateStack top tokenTypeAndActionFor: tok.
		self tokenType: typeAction type.
		self token: tok.
		self buffer reset.
		typeAction action notNil ifTrue: [self perform: typeAction action]]
! !

!OptimizedScannerWithOneTokenLookahead class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/OptimizedScannerWithOneTokenLookahead.st,v 1.6 2002/11/20 13:48:59 cg Exp $'
! !
