"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

TreeNode subclass:#ParseTreeNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Parse Trees'
!

ParseTreeNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am an abstract class that provides the framework for parse tree nodes, basically just a reminder that the following messages may need to be implemented by concrete subclasses:

	addChildrenFirst:
	addChildrenInitial:
	addChildrenLast:
	setAttribute:'
!


!ParseTreeNode methodsFor:'building parse trees'!

addChildrenFirst: anOrderedCollection 
	"Subclasses should implement this message."

	self shouldNotImplement
!

addChildrenInitial: anOrderedCollection 
	"Subclasses should implement this message."

	self shouldNotImplement
!

addChildrenLast: anOrderedCollection 
	"Subclasses should implement this message."

	self shouldNotImplement
!

setAttribute: value 
	"Subclasses should implement this message."

	self shouldNotImplement
! !

!ParseTreeNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/ParseTreeNode.st,v 1.5 2002/11/20 13:45:49 cg Exp $'
! !
