"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

GrammarParseTreeNode subclass:#ProductionNode
	instanceVariableNames:'leftHandSide rightHandSides'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Grammar Nodes'
!

ProductionNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am a grammar production.

Instance Variables:

	leftHandSide    <NonterminalNode>
	rightHandSides  <OrderedCollection>     - rhs''s for productions of the form A -> x | y | z.'
!


!ProductionNode class methodsFor:'instance creation'!

leftHandSide: lhs rightHandSides: rhs

	| newNode |
	newNode := self new.
	newNode leftHandSide: lhs.
	newNode rightHandSides: rhs.
	^newNode
! !

!ProductionNode methodsFor:'building parse trees'!

addChildrenInitial: anOrderedCollection 

	self leftHandSide: anOrderedCollection removeFirst.
	self rightHandSides: anOrderedCollection removeFirst
! !

!ProductionNode methodsFor:'printing'!

printOn: aStream 

	self leftHandSide printOn: aStream.
	aStream nextPutAll: ' : '.
	self rightHandSides do: 
		[:rhs | 
		rhs printOn: aStream.
		aStream
			 cr;
			 tab;
			 nextPut: $|.
		aStream cr]
! !

!ProductionNode methodsFor:'state accessing'!

leftHandSide

	^leftHandSide
!

leftHandSide: argument 

	leftHandSide := argument
!

rightHandSides

	^rightHandSides
!

rightHandSides: argument 

	rightHandSides := argument
! !

!ProductionNode methodsFor:'traversing'!

childrenDo: aBlock 
	"Evaluate aBlock for each of my children."

	aBlock value: self leftHandSide.
	self rightHandSides do: aBlock
!

updateChildrenUsing: aBlock 
	"Replace my children according to the value of aBlock."

	self leftHandSide: (aBlock value: self leftHandSide).
	self rightHandSides: (self rightHandSides collect: aBlock)
! !

!ProductionNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/ProductionNode.st,v 1.5 2002/11/20 13:50:48 cg Exp $'
! !
