"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

ProductionNode subclass:#RRPGProductionNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Grammar Nodes'
!

RRPGProductionNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am an RRPG production.'
!


!RRPGProductionNode methodsFor:'converting'!

convertToCFGUsing: lhsNames 
	"Remove all RRPG grammar operators from my rhs and answer a 
	collection of CFG RRPGProductionNodes. This method recursively 
	decomposes productions into more primitive forms until no more 
	decomposition is possible (designated by an empty result from 
	transformUsing:)"

	| prods resultProds |
	resultProds := OrderedCollection new.
	(prods := self transformUsing: lhsNames) isEmpty
		ifTrue: [resultProds add: self]
		ifFalse: [prods do: [:p | resultProds addAll: (p convertToCFGUsing: lhsNames)]].
	^resultProds
! !

!RRPGProductionNode methodsFor:'printing'!

printOn: aStream 

	self leftHandSide printOn: aStream.
	aStream nextPutAll: ' : '.
	self rightHandSides printOn: aStream.
	aStream nextPutAll: ' ; '; cr
! !

!RRPGProductionNode methodsFor:'transforming'!

transformUsing: lhsNames 
	"At this point there are two main cases to handle: a top-level 
	AlternationNode or an RRPGRightHandSideNode. AlternationNodes 
	are simply broken up into several RRPGProductionNodes. 
	RRPGRightHandSideNodes are transformed, if necessary. Pass along 
	my lhs so whole productions can be created by the rhs nodes."

	^self rightHandSides transformUsing: lhsNames withLHS: self leftHandSide
! !

!RRPGProductionNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/RRPGProductionNode.st,v 1.5 2002/11/20 13:50:58 cg Exp $'
! !
