"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

RightHandSideNode subclass:#RRPGRightHandSideNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Grammar Nodes'
!

RRPGRightHandSideNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

This class represents the right hand side of an RRPG grammar production.

Instance Variables:

	regexpr <RegularExpressionNode> - the rhs of an RRPG grammar production is a regular expression of grammar symbols.'
!


!RRPGRightHandSideNode methodsFor:'converting'!

convertSymbols

	^self symbols collectSymbol
! !

!RRPGRightHandSideNode methodsFor:'printing'!

printSymbolsOn: aStream 

	self symbols printOn: aStream
! !

!RRPGRightHandSideNode methodsFor:'transforming'!

transformUsing: lhsNames withLHS: lhsNode 

	^self symbols
		transformUsing: lhsNames
		withLHS: lhsNode
		alpha: OrderedCollection new
		gamma: OrderedCollection new
! !

!RRPGRightHandSideNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/RRPGRightHandSideNode.st,v 1.5 2002/11/20 13:48:12 cg Exp $'
! !
