"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

Object subclass:#TokenClassification
	instanceVariableNames:'tokenType action'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Scanning/Parsing'
!

TokenClassification comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I represent a class of tokens. 

Instance Variables:
	tokenType       <String> - name of this token class.
	action          <Symbol + UndefinedObject> - a message selector that will be sent to the scanner (via #perform:) when a token with this type is recognized.'
!


!TokenClassification class methodsFor:'instance creation'!

tokenType: arg1 action: arg2 

	| newMe |
	newMe := self new.
	newMe tokenType: arg1.
	newMe action: arg2.
	^newMe
! !

!TokenClassification methodsFor:'printing'!

printOn: aStream

	aStream nextPutAll: self tokenType.
	aStream nextPutAll: ' : {'.
	aStream nextPutAll: (self action isNil ifTrue: ['nil'] ifFalse: [self action]).
	aStream nextPutAll: '} ;'
! !

!TokenClassification methodsFor:'reconstructing'!

reconstructOn: aStream 
	"Emit #( tokenType  action ) on aStream"

	aStream poundSign; leftParenthesis.
	self tokenType reconstructOn: aStream.
	aStream space.
	self action reconstructOn: aStream.
	aStream rightParenthesis
! !

!TokenClassification methodsFor:'state accessing'!

action

	^action
!

action: argument 

	action := argument
!

tokenType

	^tokenType
!

tokenType: argument 

	tokenType := argument
! !

!TokenClassification methodsFor:'testing'!

isTokenClassification

	^true
! !

!TokenClassification class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/TokenClassification.st,v 1.5 2002/11/20 13:48:56 cg Exp $'
! !
