"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

TokenSpecParseNode subclass:#TokenSpecNode
	instanceVariableNames:'specRules'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Token Specification Nodes'
!

TokenSpecNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am the root of a token specification.

Instance Variables:

	specRules       <OrderedCollection>     - the rules for this spec.'
!


!TokenSpecNode class methodsFor:'instance creation'!

new

	^super new init
! !

!TokenSpecNode methodsFor:'building parse trees'!

addChildrenFirst: anOrderedCollection 

	self specRules addAllFirst: anOrderedCollection
!

addChildrenInitial: anOrderedCollection 

	self specRules addAll: anOrderedCollection
! !

!TokenSpecNode methodsFor:'converting'!

asSpecRuleList
	"Answer the collection of specification rules I represent."

	| rules |
	rules := OrderedCollection new.
	self specRules do: [:rule | rules add: rule asSpecRule].
	^rules
! !

!TokenSpecNode methodsFor:'initialization'!

init

	self specRules: OrderedCollection new
! !

!TokenSpecNode methodsFor:'printing'!

printOn: aStream 

	self specRules do: 
		[:rule | 
		rule printOn: aStream.
		aStream cr]
! !

!TokenSpecNode methodsFor:'state accessing'!

specRules

	^specRules
!

specRules: argument 

	specRules := argument
! !

!TokenSpecNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/TokenSpecNode.st,v 1.5 2002/11/20 13:46:22 cg Exp $'
! !
