"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

OptimizedLR1Parser subclass:#TokenSpecParser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Interface'
!

TokenSpecParser comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Object tgenCopyright."
=================================================

I am a parser for T-gen token specifications.'
!


!TokenSpecParser class methodsFor:'class initialization'!

initialize
	"TokenSpecParser initialize"
	"       spec            : rule spec                                             {liftRightChild} ;
	spec            :                                                               {TokenSpecNode} ; 
	rule            : type ':' regExpr directive ';'                {TokenSpecRuleNode} ; 
	type            : <tokenClass>                                  {TokenClassNode} ; 
	directive       : <directive>                                   {DirectiveNode} ;                                       directive       :                                                               {nil} ; 
	regExpr         : catExpr '|' regExpr                           {liftRightChild} ;
	regExpr         : catExpr                                               {AlternationNode} ; 
	catExpr         : expr catExpr                                  {liftRightChild} ;
	catExpr         : expr                                                  {ConcatenationNode} ; 
	expr            : baseExpr '*'                                  {StarClosureNode} ;
	expr            : baseExpr '+'                                  {PlusClosureNode} ;
	expr            : baseExpr '?'                                  {OptionalNode} ; 
	expr            : baseExpr                                              ; 
	baseExpr        : atom                                                  ;
	baseExpr        : '(' regExpr ')'                                       ;
	baseExpr        : '[' atomList ']'                                      {AlternationRangeNode} ; 
	baseExpr        : '~' '[' atomList ']'                  {ComplementedAlternationRangeNode} ; 
	atomList        : listElmt atomList                             {liftRightChild} ;
	atomList        : listElmt                                              {OrderedChildren} ; 
	listElmt                : atom                                                  ;
	listElmt                : atom '-' atom                                 {CharRangeNode} ; 
	atom            : <dchar>                                               {DecimalCharNode} ;
	atom            : <ochar>                                               {OctalCharNode} ;
	atom            : <hchar>                                               {HexadecimalCharNode} ; 
	atom            : <eschar>                                              {EscapedCharNode} ; 
	atom            : <char>                                                {CharacterNode} ; 
"

	| table prodTable |
	prodTable := #( #expr #listElmt '[' $ #atomList ')' '<eschar>' '(' #regExpr ';' #atom #directive ':' '<char>' '~' #type #baseExpr '|' '-' '<directive>' '<tokenClass>' ']' '<dchar>' '<ochar>' '+' '?' '<hchar>' #catExpr #spec #rule '*' 'liftRightChild' 'HexadecimalCharNode' 'EscapedCharNode' 'StarClosureNode' 'ConcatenationNode' 'TokenSpecNode' 'OptionalNode' 'OrderedChildren' 'ComplementedAlternationRangeNode' 'nil' 'TokenClassNode' 'AlternationRangeNode' 'CharacterNode' 'CharRangeNode' 'PlusClosureNode' 'TokenSpecRuleNode' 'DecimalCharNode' 'DirectiveNode' 'AlternationNode' 'OctalCharNode' ).
	self tokenTypeTable:  (prodTable copyFrom: 1 to:  31).
	table := #( #( nil nil nil #(29 #()37)  nil nil nil nil nil nil nil nil nil nil nil 2 nil nil nil nil 39 nil nil nil nil nil nil nil 41 38 nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil 3 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( 29 nil 4 nil nil nil 13 22 17 nil 21 nil nil 7 30 nil 25 nil nil nil nil nil 9 12 nil nil 8 35 nil nil nil ) #( nil 10 nil nil 5 nil 13 nil nil nil 14 nil nil 7 nil nil nil nil nil nil nil nil 9 12 nil nil 8 nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil 6 nil nil nil nil nil nil nil nil nil ) #( nil nil #(17 #(3 5 22 )43)  nil nil #(17 #(3 5 22 )43)  #(17 #(3 5 22 )43)  #(17 #(3 5 22 )43)  nil #(17 #(3 5 22 )43)  nil nil nil #(17 #(3 5 22 )43)  #(17 #(3 5 22 )43)  nil nil #(17 #(3 5 22 )43)  nil #(17 #(3 5 22 )43)  nil nil #(17 #(3 5 22 )43)  #(17 #(3 5 22 )43)  #(17 #(3 5 22 )43)  #(17 #(3 5 22 )43)  #(17 #(3 5 22 )43)  nil nil nil #(17 #(3 5 22 )43)  ) #( nil nil #(11 #(14 )44)  nil nil #(11 #(14 )44)  #(11 #(14 )44)  #(11 #(14 )44)  nil #(11 #(14 )44)  nil nil nil #(11 #(14 )44)  #(11 #(14 )44)  nil nil #(11 #(14 )44)  #(11 #(14 )44)  #(11 #(14 )44)  nil #(11 #(14 )44)  #(11 #(14 )44)  #(11 #(14 )44)  #(11 #(14 )44)  #(11 #(14 )44)  #(11 #(14 )44)  nil nil nil #(11 #(14 )44)  ) #( nil nil #(11 #(27 )33)  nil nil #(11 #(27 )33)  #(11 #(27 )33)  #(11 #(27 )33)  nil #(11 #(27 )33)  nil nil nil #(11 #(27 )33)  #(11 #(27 )33)  nil nil #(11 #(27 )33)  #(11 #(27 )33)  #(11 #(27 )33)  nil #(11 #(27 )33)  #(11 #(27 )33)  #(11 #(27 )33)  #(11 #(27 )33)  #(11 #(27 )33)  #(11 #(27 )33)  nil nil nil #(11 #(27 )33)  ) #( nil nil #(11 #(23 )48)  nil nil #(11 #(23 )48)  #(11 #(23 )48)  #(11 #(23 )48)  nil #(11 #(23 )48)  nil nil nil #(11 #(23 )48)  #(11 #(23 )48)  nil nil #(11 #(23 )48)  #(11 #(23 )48)  #(11 #(23 )48)  nil #(11 #(23 )48)  #(11 #(23 )48)  #(11 #(23 )48)  #(11 #(23 )48)  #(11 #(23 )48)  #(11 #(23 )48)  nil nil nil #(11 #(23 )48)  ) #( nil 10 nil nil 11 nil 13 nil nil nil 14 nil nil 7 nil nil nil nil nil nil nil #(5 #(2 )39)  9 12 nil nil 8 nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil #(5 #(2 5 )32)  nil nil nil nil nil nil nil nil nil ) #( nil nil #(11 #(24 )51)  nil nil #(11 #(24 )51)  #(11 #(24 )51)  #(11 #(24 )51)  nil #(11 #(24 )51)  nil nil nil #(11 #(24 )51)  #(11 #(24 )51)  nil nil #(11 #(24 )51)  #(11 #(24 )51)  #(11 #(24 )51)  nil #(11 #(24 )51)  #(11 #(24 )51)  #(11 #(24 )51)  #(11 #(24 )51)  #(11 #(24 )51)  #(11 #(24 )51)  nil nil nil #(11 #(24 )51)  ) #( nil nil #(11 #(7 )34)  nil nil #(11 #(7 )34)  #(11 #(7 )34)  #(11 #(7 )34)  nil #(11 #(7 )34)  nil nil nil #(11 #(7 )34)  #(11 #(7 )34)  nil nil #(11 #(7 )34)  #(11 #(7 )34)  #(11 #(7 )34)  nil #(11 #(7 )34)  #(11 #(7 )34)  #(11 #(7 )34)  #(11 #(7 )34)  #(11 #(7 )34)  #(11 #(7 )34)  nil nil nil #(11 #(7 )34)  ) #( nil nil nil nil nil nil #(2 #(11 ))  nil nil nil nil nil nil #(2 #(11 ))  nil nil nil nil 15 nil nil #(2 #(11 ))  #(2 #(11 ))  #(2 #(11 ))  nil nil #(2 #(11 ))  nil nil nil nil ) #( nil nil nil nil nil nil 13 nil nil nil 16 nil nil 7 nil nil nil nil nil nil nil nil 9 12 nil nil 8 nil nil nil nil ) #( nil nil nil nil nil nil #(2 #(11 19 11 )45)  nil nil nil nil nil nil #(2 #(11 19 11 )45)  nil nil nil nil nil nil nil #(2 #(11 19 11 )45)  #(2 #(11 19 11 )45)  #(2 #(11 19 11 )45)  nil nil #(2 #(11 19 11 )45)  nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil #(12 #()41)  nil 19 nil nil nil nil nil nil nil 18 nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil #(12 #(20 )49)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil 20 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil #(30 #(16 13 9 12 10 )47)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil #(30 #(16 13 9 12 10 )47)  nil nil nil nil nil nil nil nil nil nil ) #( nil nil #(17 #(11 ))  nil nil #(17 #(11 ))  #(17 #(11 ))  #(17 #(11 ))  nil #(17 #(11 ))  nil nil nil #(17 #(11 ))  #(17 #(11 ))  nil nil #(17 #(11 ))  nil #(17 #(11 ))  nil nil #(17 #(11 ))  #(17 #(11 ))  #(17 #(11 ))  #(17 #(11 ))  #(17 #(11 ))  nil nil nil #(17 #(11 ))  ) #( 29 nil 4 nil nil nil 13 22 23 nil 21 nil nil 7 30 nil 25 nil nil nil nil nil 9 12 nil nil 8 35 nil nil nil ) #( nil nil nil nil nil 24 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil #(17 #(8 9 6 ))  nil nil #(17 #(8 9 6 ))  #(17 #(8 9 6 ))  #(17 #(8 9 6 ))  nil #(17 #(8 9 6 ))  nil nil nil #(17 #(8 9 6 ))  #(17 #(8 9 6 ))  nil nil #(17 #(8 9 6 ))  nil #(17 #(8 9 6 ))  nil nil #(17 #(8 9 6 ))  #(17 #(8 9 6 ))  #(17 #(8 9 6 ))  #(17 #(8 9 6 ))  #(17 #(8 9 6 ))  nil nil nil #(17 #(8 9 6 ))  ) #( nil nil #(1 #(17 ))  nil nil #(1 #(17 ))  #(1 #(17 ))  #(1 #(17 ))  nil #(1 #(17 ))  nil nil nil #(1 #(17 ))  #(1 #(17 ))  nil nil #(1 #(17 ))  nil #(1 #(17 ))  nil nil #(1 #(17 ))  #(1 #(17 ))  28 27 #(1 #(17 ))  nil nil nil 26 ) #( nil nil #(1 #(17 31 )35)  nil nil #(1 #(17 31 )35)  #(1 #(17 31 )35)  #(1 #(17 31 )35)  nil #(1 #(17 31 )35)  nil nil nil #(1 #(17 31 )35)  #(1 #(17 31 )35)  nil nil #(1 #(17 31 )35)  nil #(1 #(17 31 )35)  nil nil #(1 #(17 31 )35)  #(1 #(17 31 )35)  nil nil #(1 #(17 31 )35)  nil nil nil nil ) #( nil nil #(1 #(17 26 )38)  nil nil #(1 #(17 26 )38)  #(1 #(17 26 )38)  #(1 #(17 26 )38)  nil #(1 #(17 26 )38)  nil nil nil #(1 #(17 26 )38)  #(1 #(17 26 )38)  nil nil #(1 #(17 26 )38)  nil #(1 #(17 26 )38)  nil nil #(1 #(17 26 )38)  #(1 #(17 26 )38)  nil nil #(1 #(17 26 )38)  nil nil nil nil ) #( nil nil #(1 #(17 25 )46)  nil nil #(1 #(17 25 )46)  #(1 #(17 25 )46)  #(1 #(17 25 )46)  nil #(1 #(17 25 )46)  nil nil nil #(1 #(17 25 )46)  #(1 #(17 25 )46)  nil nil #(1 #(17 25 )46)  nil #(1 #(17 25 )46)  nil nil #(1 #(17 25 )46)  #(1 #(17 25 )46)  nil nil #(1 #(17 25 )46)  nil nil nil nil ) #( 29 nil 4 nil nil #(28 #(1 )36)  13 22 nil #(28 #(1 )36)  21 nil nil 7 30 nil 25 #(28 #(1 )36)  nil #(28 #(1 )36)  nil nil 9 12 nil nil 8 34 nil nil nil ) #( nil nil 31 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil 10 nil nil 32 nil 13 nil nil nil 14 nil nil 7 nil nil nil nil nil nil nil nil 9 12 nil nil 8 nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil 33 nil nil nil nil nil nil nil nil nil ) #( nil nil #(17 #(15 3 5 22 )40)  nil nil #(17 #(15 3 5 22 )40)  #(17 #(15 3 5 22 )40)  #(17 #(15 3 5 22 )40)  nil #(17 #(15 3 5 22 )40)  nil nil nil #(17 #(15 3 5 22 )40)  #(17 #(15 3 5 22 )40)  nil nil #(17 #(15 3 5 22 )40)  nil #(17 #(15 3 5 22 )40)  nil nil #(17 #(15 3 5 22 )40)  #(17 #(15 3 5 22 )40)  #(17 #(15 3 5 22 )40)  #(17 #(15 3 5 22 )40)  #(17 #(15 3 5 22 )40)  nil nil nil #(17 #(15 3 5 22 )40)  ) #( nil nil nil nil nil #(28 #(1 28 )32)  nil nil nil #(28 #(1 28 )32)  nil nil nil nil nil nil nil #(28 #(1 28 )32)  nil #(28 #(1 28 )32)  nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil #(9 #(28 )50)  nil nil nil #(9 #(28 )50)  nil nil nil nil nil nil nil 36 nil #(9 #(28 )50)  nil nil nil nil nil nil nil nil nil nil nil ) #( 29 nil 4 nil nil nil 13 22 37 nil 21 nil nil 7 30 nil 25 nil nil nil nil nil 9 12 nil nil 8 35 nil nil nil ) #( nil nil nil nil nil #(9 #(28 18 9 )32)  nil nil nil #(9 #(28 18 9 )32)  nil nil nil nil nil nil nil nil nil #(9 #(28 18 9 )32)  nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil #(29 #()37)  nil nil nil nil nil nil nil nil nil nil nil 2 nil nil nil nil 39 nil nil nil nil nil nil nil 40 38 nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil #(16 #(21 )42)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil #(29 #(30 29 )32)  nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil 42 nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) #( nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil ) ).
	self constructParseTable: table  with: prodTable.
	self finalState: 42
! !

!TokenSpecParser methodsFor:'private'!

scannerClass
	^TokenSpecScanner
! !

!TokenSpecParser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/TokenSpecParser.st,v 1.4 2002/11/20 13:48:25 cg Exp $'
! !

TokenSpecParser initialize!
