"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

Object subclass:#TokenSpecificationRule
	instanceVariableNames:'tokenClass regExpr directive'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Token Specification Nodes'
!

TokenSpecificationRule comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

Instance Variables:
	tokenClass      <String> - the name of the token class.
	regExpr         <RegularExpressionNode> (actually, any one of its concrete subclasses) - the (pure) regular expression tree representing the specification of the token class.
	directive               <String + UndefinedObject> - the optional scanner directive.'
!


!TokenSpecificationRule class methodsFor:'instance creation'!

tokenClass: arg1 regExpr: arg2 directive: arg3 

	| newMe |
	newMe := self new.
	newMe tokenClass: arg1.
	newMe regExpr: arg2.
	newMe directive: arg3.
	^newMe
! !

!TokenSpecificationRule methodsFor:'state accessing'!

directive

	^directive
!

directive: argument 

	directive := argument
!

regExpr

	^regExpr
!

regExpr: argument 

	regExpr := argument
!

tokenClass

	^tokenClass
!

tokenClass: argument 

	tokenClass := argument
! !

!TokenSpecificationRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/TokenSpecificationRule.st,v 1.5 2002/11/20 13:46:30 cg Exp $'
! !
