"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

Object subclass:#TokenTypeActionHolder
	instanceVariableNames:'type action'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Scanning/Parsing'
!

TokenTypeActionHolder comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Tgen::ReadMe tgenCopyright."
=================================================

I am used to package token type and actions together for transport between FSAFinalStates and the scanner.

Instance Variables:
	type            <String> - token type.
	action          <Symbol + UndefinedObject> - a message selector that will be sent to the scanner (via #perform:) when a token with this type is recognized.'
!


!TokenTypeActionHolder class methodsFor:'instance creation'!

type: arg1 action: arg2 

	| newMe |
	newMe := self new.
	newMe type: arg1.
	newMe action: arg2.
	^newMe
! !

!TokenTypeActionHolder methodsFor:'printing'!

printOn: aStream

	aStream nextPutAll: self type.
	aStream nextPutAll: ' : {'.
	aStream nextPutAll: self action.
	aStream nextPutAll: '} ;'
! !

!TokenTypeActionHolder methodsFor:'state accessing'!

action

	^action
!

action: argument 

	action := argument
!

type

	^type
!

type: argument 

	type := argument
! !

!TokenTypeActionHolder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/TokenTypeActionHolder.st,v 1.5 2002/11/20 13:51:12 cg Exp $'
! !
