"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

RegularExpressionNode subclass:#UnaryRegExprNode
	instanceVariableNames:'onlyChild'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Regular Expression Nodes'
!

UnaryRegExprNode comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Object tgenCopyright."
=================================================

I am a unary regular expression.'
!


!UnaryRegExprNode class methodsFor:'instance creation'!

onlyChild: arg1 

	| newMe |
	newMe := self new.
	newMe onlyChild: arg1.
	^newMe
! !

!UnaryRegExprNode methodsFor:'building parse trees'!

addChildrenInitial: anOrderedCollection 

	anOrderedCollection size = 1
		ifTrue: [self onlyChild: anOrderedCollection removeFirst]
		ifFalse: [self error: 'wrong number of children']
! !

!UnaryRegExprNode methodsFor:'state accessing'!

onlyChild

	^onlyChild
!

onlyChild: argument 

	onlyChild := argument
! !

!UnaryRegExprNode methodsFor:'transforming'!

needsTransforming

	^true
! !

!UnaryRegExprNode methodsFor:'traversing'!

childrenDo: aBlock 
	"Evaluate aBlock for each of my children."

	aBlock value: self onlyChild
!

updateChildrenUsing: aBlock 
	"Replace my children according to the value of aBlock."

	self onlyChild: (aBlock value: self onlyChild)
! !

!UnaryRegExprNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/UnaryRegExprNode.st,v 1.4 2002/11/20 13:48:45 cg Exp $'
! !
