"{ Package: 'stx:goodies/tgen' }"

"{ NameSpace: Tgen }"

EditTextView subclass:#UpdateRequestTextView
	instanceVariableNames:'updatePrompt'
	classVariableNames:''
	poolDictionaries:''
	category:'Tgen-Interface-Text'
!

UpdateRequestTextView comment:'=================================================
    Copyright (c) 1992 by Justin O. Graver.
    All rights reserved (with exceptions).
    For complete information evaluate "Object tgenCopyright."
=================================================

This class allows users to specify the confirmation message used when a "May one of your dependents change?" update request is received.

Instance Variables

	updatePrompt    <String> - prompt text used when update request is received.'
!


!UpdateRequestTextView class methodsFor:'instance creation'!

on: anObject aspect: aspectMsg change: changeMsg menu: menuMsg updatePrompt: aString 

	| aView |
	aView := self new.
	aView
		on: anObject
		aspect: aspectMsg
		change: changeMsg
		menu: menuMsg.
	aView updatePrompt: aString.
	^aView
! !

!UpdateRequestTextView methodsFor:'state accessing'!

updatePrompt

	^updatePrompt
!

updatePrompt: argument 

	updatePrompt := argument
! !

!UpdateRequestTextView methodsFor:'updating'!

updateRequest
	"Answer regarding whether the receiver may change."

	^self controller updateRequest
		ifTrue: [true]
		ifFalse: [DialogView confirm: self updatePrompt]
! !

!UpdateRequestTextView class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tgen/UpdateRequestTextView.st,v 1.4 2002/11/20 13:45:59 cg Exp $'
! !
