"{ Package: 'stx:goodies/tools' }"

Object subclass:#GembirdPowerManager
	instanceVariableNames:'hostName port password'
	classVariableNames:'DefaultHostName DefaultPort DefaultPassword'
	poolDictionaries:''
	category:'Tools'
!

!GembirdPowerManager class methodsFor:'documentation'!

documentation
"
    controls the energenie (gembird) http-controlled power plug (via its web interface)

    [author:]
        cg
"
!

examples
"
    |pm|

    pm := self new.
    pm hostName:'193.141.12.28' port:80 password:'1'.
    pm login.

    pm allOff.
    Delay waitForSeconds:1.
    pm setPlug:1 to:true.
    Delay waitForSeconds:1.
    pm setPlug:2 to:true.
    Delay waitForSeconds:1.
    pm setPlug:3 to:true.
    Delay waitForSeconds:1.
    Delay waitForSeconds:1.
    pm setPlug:1 to:false.
    Delay waitForSeconds:1.
    pm setPlug:2 to:false.
    Delay waitForSeconds:1.
    pm setPlug:3 to:false.
    Delay waitForSeconds:1.
"
! !

!GembirdPowerManager class methodsFor:'accessing'!

defaultHostName
    ^ DefaultHostName ? 'powerManager'

    "Modified: / 07-11-2011 / 12:24:08 / cg"
!

defaultHostName:something
    DefaultHostName := something.
!

defaultPassword
    ^ DefaultPassword ? '1'

    "Modified: / 07-11-2011 / 12:24:14 / cg"
!

defaultPassword:something
    DefaultPassword := something.
!

defaultPort
    ^ DefaultPort ? 80

    "Modified: / 07-11-2011 / 12:24:19 / cg"
!

defaultPort:something
    DefaultPort := something.
! !

!GembirdPowerManager methodsFor:'accessing'!

hostName
    ^ hostName

    "Modified: / 07-11-2011 / 12:25:00 / cg"
!

hostName:something
    hostName := something.
!

hostName:hostNameArg port:portArg password:passwordArg 
    hostName := hostNameArg.
    port := portArg.
    password := passwordArg.
!

password
    ^ password
!

password:something
    password := something.
!

port
    ^ port
!

port:something
    port := something.
! !

!GembirdPowerManager methodsFor:'http actions'!

allOff
    |response|

    response := HTTPInterface   
                    post:'/'
                    host:(hostName ? self class defaultHostName)
                    port:(port ? self class defaultPort)
                    with:('cte1=0&cte2=0&cte3=0&cte4=0').

    "
     self new
        hostName:'193.141.12.28' port:80 password:'1';
        login;
        allOff;
        logout
    "

    "Created: / 07-11-2011 / 12:44:47 / cg"
!

login
    |response|

    response := HTTPInterface   
                    post:'/login.html'
                    host:(hostName ? self class defaultHostName)
                    port:(port ? self class defaultPort)
                    with:('pw=',(password ? self class defaultPassword)).

    "
     self new
        hostName:'193.141.12.28' port:80 password:'1';
        login
    "

    "Created: / 07-11-2011 / 12:32:18 / cg"
!

logout
    |response|

    response := HTTPInterface   
                    get:'/login.html'
                    fromHost:(hostName ? self class defaultHostName)
                    port:(port ? self class defaultPort)

    "
     self new
        hostName:'193.141.12.28' port:80 password:'1';
        login;
        logout
    "

    "Created: / 07-11-2011 / 21:45:27 / cg"
!

setPlug:nr to:onOffBoolean
    |response|

    response := HTTPInterface   
                    post:'/'
                    host:(hostName ? self class defaultHostName)
                    port:(port ? self class defaultPort)
                    with:('cte%1=%2' bindWith:nr with:(onOffBoolean ifTrue:'1' ifFalse:'0')).

    "
     self new
        hostName:'193.141.12.28' port:80 password:'1';
        login;
        setPlug:1 to:true;
        logout
    "

    "Created: / 07-11-2011 / 12:43:43 / cg"
! !

!GembirdPowerManager class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tools/GembirdPowerManager.st,v 1.2 2011/11/07 20:46:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/tools/GembirdPowerManager.st,v 1.2 2011/11/07 20:46:43 cg Exp $'
! !
