"{ Package: 'stx:goodies/tools/mail/celeste' }"

"{ NameSpace: Tools }"

MailComposition subclass:#CelesteComposition
	instanceVariableNames:'celeste'
	classVariableNames:''
	poolDictionaries:''
	category:'Network-Mail Reader'
!

CelesteComposition comment:'a message being composed.  When finished, it will be submitted via a Celeste.'
!


!CelesteComposition class methodsFor:'instance creation'!

celeste: aCeleste  initialText: initialText
	"create an instance for the given mail reader, editting the given text"
	^self new celeste: aCeleste  initialText: initialText
!

openForCeleste: aCeleste  initialText: initialText
	"open a composition window for the given mail reader, editting the given text"
	(self celeste: aCeleste  initialText: initialText) open
! !

!CelesteComposition class methodsFor:'as yet unclassified'!

initialize
	super initialize.
	MailSender registerMailSender: self.
!

sendMailMessage: aMailMessage
	self openForCeleste: Celeste current initialText: aMailMessage text
!

unload

	MailSender unregisterMailSender: self 
! !

!CelesteComposition methodsFor:'access'!

submit
	| message msgID |
	"submit the message"
	textEditor
		ifNotNil: [self hasUnacceptedEdits ifTrue: [textEditor accept]].
	message := MailMessage from: messageText asString.
	self breakLinesInMessage: message.
	msgID _ (celeste isActive ifTrue: [celeste] ifFalse: [Celeste current])
				queueMessageWithText: message text.
	msgID ifNil: [^self].		"There was an error, so do not close"

	morphicWindow ifNotNil: [morphicWindow delete].
	mvcWindow ifNotNil: [mvcWindow controller close]
! !

!CelesteComposition methodsFor:'initialization'!

celeste: aCeleste  initialText: aText
	celeste _ aCeleste.
	messageText _ aText.
! !

!CelesteComposition class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tools/mail/celeste/CelesteComposition.st,v 1.1 2003/05/09 21:41:18 cg Exp $'
! !

CelesteComposition initialize!
