"{ Package: 'stx:goodies/tools/mail/celeste' }"

"{ NameSpace: Tools }"

Object subclass:#MailNotifier
	instanceVariableNames:'socket messageCount lastConnectTime password'
	classVariableNames:''
	poolDictionaries:''
	category:'Network-Mail Reader'
!

MailNotifier comment:'This is a basic example of connecting to a mail server, using POP3, to check how many messages are waiting.  It does everything at one time, which may make it too slow to use as is.'
!


!MailNotifier methodsFor:'accessing'!

messageCount
	"if no socket, try to connect in background, when done, remove socket."
	socket
		ifNil: 
			[socket _ POPSocket new.
			
			[socket serverName: Celeste popServer.
			socket userName: Celeste popUserName.
			socket password: self password.
			"socket addProgressObserver: Transcript."
			([socket connectToPOP]
				on: Error do: 
				[Transcript show: 'Couldn''t connect to POP.';
				 cr. (Delay forSeconds: 180) wait.
				false])
				ifTrue: 
					[messageCount _ socket numMessages.
					socket disconnectFromPOP.
					lastConnectTime _ Time now].
			socket _ nil]
				forkAt: Processor userBackgroundPriority].
	^ messageCount
! !

!MailNotifier class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/tools/mail/celeste/MailNotifier.st,v 1.1 2003/05/09 21:40:39 cg Exp $'
! !
