"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

ApplicationModel subclass:#ImageTestApp
	instanceVariableNames:'backgroundAspect pathAspect fileAspect fileIndex filenames image'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-UIApplications-New'
!


!ImageTestApp class methodsFor:'interface specs'!

imageSpec
	"Tools.UIPainter new openOnClass: self andSelector: #imageSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#{Graphics.Rectangle} 517 324 956 752 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 0 0 0 1 0 1 ) 
					#name: #imageView 
					#flags: 3 
					#component: #imageView ) ) ) )
!

windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Image Tester' 
			#bounds: #(#{Graphics.Rectangle} 640 512 1079 940 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 5 5 ) 
					#name: #Label1 
					#label: 'Path:' ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.LayoutFrame} 50 0 5 0 -90 1 28 0 ) 
					#name: #InputField1 
					#model: #pathAspect 
					#callbacksSpec: 
					#(#{UI.UIEventCallbackSubSpec} 
						#valueChangeSelector: #changedPath ) ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} -80 1 5 0 -5 1 28 0 ) 
					#name: #ActionButton1 
					#model: #choosePath 
					#label: 'Choose...' 
					#defaultable: true ) 
				#(#{UI.SubCanvasSpec} 
					#layout: #(#{Graphics.LayoutFrame} 5 0 70 0 -5 1 -40 1 ) 
					#name: #imageCanvas ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{UI.AlignmentOrigin} 5 0 -20 1 0 0.5 ) 
					#name: #Label2 
					#label: 'Background' ) 
				#(#{UI.RadioButtonSpec} 
					#layout: #(#{UI.AlignmentOrigin} 80 0 -20 1 0 0.5 ) 
					#name: #RadioButton1 
					#model: #backgroundAspect 
					#label: 'Opaque' 
					#select: #backgroundOpaque ) 
				#(#{UI.RadioButtonSpec} 
					#layout: #(#{UI.AlignmentOrigin} 152 0 -20 1 0 0.5 ) 
					#name: #RadioButton2 
					#model: #backgroundAspect 
					#label: 'Black' 
					#select: #backgroundBlack ) 
				#(#{UI.RadioButtonSpec} 
					#layout: #(#{UI.AlignmentOrigin} 215 0 -20 1 0 0.5 ) 
					#name: #RadioButton3 
					#model: #backgroundAspect 
					#label: 'White' 
					#select: #backgroundWhite ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 5 36 ) 
					#name: #Label3 
					#label: 'File:' ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.LayoutFrame} 50 0 36 0 -180 1 59 0 ) 
					#name: #InputField2 
					#model: #fileAspect 
					#callbacksSpec: 
					#(#{UI.UIEventCallbackSubSpec} 
						#valueChangeSelector: #changedFile ) ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} -165 1 36 0 -130 1 59 0 ) 
					#name: #ActionButton2 
					#model: #previousFile 
					#label: '<<' 
					#defaultable: true ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} -125 1 36 0 -90 1 59 0 ) 
					#name: #ActionButton3 
					#model: #nextFile 
					#label: '>>' 
					#defaultable: true ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} -80 1 35 0 -5 1 58 0 ) 
					#name: #ActionButton4 
					#model: #chooseFile 
					#label: 'Choose...' 
					#defaultable: true ) ) ) )
! !

!ImageTestApp methodsFor:'actions'!

chooseFile

	| fn file |
	fn := Dialog requestFileName: 'Image file'.
	fn notEmpty ifTrue: [
		file := fn asFilename.
		self fileAspect value: file tail.
		self path: file directory asString.
	].
!

choosePath

	| path |
	path := Dialog requestDirectoryName: 'Image directory' default: self pathAspect value.
	path notEmpty ifTrue: [
		self pathAspect value: path.
		self changedPath.
	].
!

nextFile

	(fileIndex >= filenames size) ifTrue: [ ^ self ].
	self chooseFileAt: fileIndex + 1.
!

previousFile

	fileIndex <= 1 ifTrue: [ ^ self ].
	self chooseFileAt: fileIndex - 1.
! !

!ImageTestApp methodsFor:'aspects'!

backgroundAspect

	^ backgroundAspect isNil
		ifTrue:
			[
				backgroundAspect := #backgroundOpaque asValue.
				backgroundAspect onChangeSend: #changedBackground to: self.
				backgroundAspect
			]
		ifFalse:
			[backgroundAspect]
!

fileAspect
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^fileAspect isNil
		ifTrue:
			[fileAspect := String new asValue]
		ifFalse:
			[fileAspect]
!

pathAspect
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^pathAspect isNil
		ifTrue:
			[pathAspect := String new asValue]
		ifFalse:
			[pathAspect]
! !

!ImageTestApp methodsFor:'initialize-release'!

initialize

	super initialize.
	filenames := OrderedCollection new.
	fileIndex := 1.
! !

!ImageTestApp methodsFor:'notification'!

changedBackground
!

changedPath

	self updateFilenames
! !

!ImageTestApp methodsFor:'private'!

chooseFileAt: i

	| fn |
	fileIndex := i.
	fn := fileIndex <= filenames size
		ifTrue: [ filenames at: i ]
		ifFalse: [ '' ].
	self fileAspect value: fn.
	self updateImage.
!

currentDirectory

	| s dir |
	^ ((s := self pathAspect value) notEmpty and: [ (dir := s asFilename) exists ])
		ifTrue: [ dir ]
		ifFalse: [ nil ]
!

currentFilename

	| dir fn file |
	(dir := self currentDirectory) isNil ifTrue: [ ^ nil ].
	^ fileIndex <= filenames size
		ifTrue: [ dir construct: (filenames at: fileIndex) ]
		ifFalse: [ 
			((fn := self fileAspect value) notEmpty and: [ (file := fn asFilename) exists ])
				ifTrue: [file ]
				ifFalse: [ nil ]
		].
!

imageView

	^ image
!

path: aString

	self pathAspect value: aString.
	self updateFilenames.
!

updateFilenames

	| dir |
	(dir := self currentDirectory) isNil ifTrue: [ ^ self ].
	filenames := dir directoryContents asSortedCollection.
	fileIndex := filenames indexOf: self fileAspect value ifAbsent: [ 1 ].
	self chooseFileAt: fileIndex.
!

updateImage

	| file |
	(file := self currentFilename) isNil ifTrue: [ ^ self ].
	image := CachedImage on: (ImageReader fromFile: file) image.
	(self builder componentAt: #imageCanvas) widget
		client: self spec: #imageSpec builder: self builder newSubBuilder.
! !

!ImageTestApp class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__ImageTestApp.st,v 1.1 2009/10/01 23:42:54 cg Exp $'
! !
