"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfElement subclass:#TfAbstractColumnElement
	instanceVariableNames:'widthLayout spannedColumns columnIndex'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfAbstractColumnElement class methodsFor:'accessing'!

allowsPCData
	
	^ false
!

supportedAttributes

	^ #('width' 'span')
! !

!TfAbstractColumnElement methodsFor:'accessing'!

addedToDocument: aTfDocument

	| table |
	super addedToDocument: aTfDocument.
	(table := self tfTableElement) notNil
		ifTrue: [ columnIndex := table addColumnElement: self ].
!

lastColumnIndex

	^ columnIndex + spannedColumns - 1
!

spannedColumns

	^ spannedColumns
!

tfIsColElement

	^ true
!

widthLayout

	^ widthLayout
! !

!TfAbstractColumnElement methodsFor:'parsing'!

parseValues

	super parseValues.
	self valueOfAttribute: 'width' do: [ :val |
		widthLayout := self valueReader parseTableWidth: val ].
	spannedColumns := self integerValueOfAttribute: 'span'.
	spannedColumns isNil
		ifTrue: [
			spannedColumns := widthLayout notNil
				ifTrue: [ 1 ]
				ifFalse: [ 0 ]
		].
! !

!TfAbstractColumnElement methodsFor:'styles'!

applyColumnsStyleTo: aTfStyle

	| tableStyle |
	widthLayout notNil
		ifTrue: [
			tableStyle := aTfStyle tableStyle.
			columnIndex to: columnIndex + spannedColumns - 1 do: [ :j |
				tableStyle columnWidthLayoutsAt: j put: widthLayout.
			]
		].
!

modifyStyle: aTfStyle

	super modifyStyle: aTfStyle.
	self applyColumnsStyleTo: aTfStyle.
! !

!TfAbstractColumnElement methodsFor:'views'!

tfViewClass

	^ nil
! !

!TfAbstractColumnElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfAbstractColumnElement.st,v 1.1 2009/10/01 18:24:56 cg Exp $'
! !
