"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfTranslatingCompositeElementView subclass:#TfAbstractListView
	instanceVariableNames:'listWidth listLevel'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfAbstractListView methodsFor:'accessing'!

listContainer

	^ self
!

listWidth

	^ listWidth
! !

!TfAbstractListView methodsFor:'initialize-release'!

initialize

	super initialize.
	listWidth := 0.
	listLevel  := 0.
! !

!TfAbstractListView methodsFor:'private'!

componentsTranslation

	| tr |
	tr := (self style listStyle indent@0).
	listLevel > 0
		ifTrue: [ tr := tr + (listWidth@0) ].
	^ tr
! !

!TfAbstractListView methodsFor:'rendering'!

computeListWidthFor: renderContext

	listWidth := 16.
!

finishParagraph: renderContext

	renderContext layoutContext 
		applyPendingLayouts;
		decreaseListLevel.
	super finishParagraph: renderContext.
!

measureOwnExtentFor: renderContext

	self updateListFor: renderContext.
	super measureOwnExtentFor: renderContext
!

startOwnRendering: renderContext

	super startOwnRendering: renderContext.
	self updateListFor: renderContext
!

startParagraph: renderContext

	listLevel >= 1
		ifTrue: [ 
			" do not add paragraphs for indented lists "
			self style paragraphStyle spacingBefore: 0; spacingAfter: 0
		].
	super startParagraph: renderContext.
	renderContext layoutContext 
		increaseListLevel;
		listWidth: listWidth.
!

updateListFor: renderContext

	listLevel := renderContext layoutContext listLevel.
	self computeListWidthFor: renderContext.
! !

!TfAbstractListView class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfAbstractListView.st,v 1.1 2009/10/01 19:32:47 cg Exp $'
! !
