"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfElement subclass:#TfAbstractTableElement
	instanceVariableNames:'color borderColor borderWidth'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfAbstractTableElement class methodsFor:'accessing'!

supportedAttributes

	^ #('valign' 'align' 'bgcolor' )
! !

!TfAbstractTableElement methodsFor:'parsing'!

parseBackground

	self valueOfAttribute: 'bgcolor' do: [ :val |
		color := self valueReader parseColor: val ].
	self valueOfAttribute: 'bordercolor' do: [ :val |
		borderColor := self valueReader parseColor: val ].
!

parseValues

	super parseValues.
	self parseBackground.
! !

!TfAbstractTableElement methodsFor:'styles'!

applyBackgroundStyleTo: aTfStyle

	| bs |
	bs := aTfStyle backgroundStyle.
	color notNil
		ifTrue: [ bs color: color ].
	borderColor notNil
		ifTrue: [ bs borderColor: borderColor ].
	borderWidth notNil
		ifTrue: [ bs borderWidth: borderWidth ].
!

modifyStyle: aTfStyle
	" modify the style according to the local style definitions "

	super modifyStyle: aTfStyle.
	self applyBackgroundStyleTo: aTfStyle.
	self applyAlignmentStyleTo: aTfStyle
! !

!TfAbstractTableElement methodsFor:'testing'!

tfIsTableElement

	^ true
! !

!TfAbstractTableElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfAbstractTableElement.st,v 1.1 2009/10/01 18:25:39 cg Exp $'
! !
