"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfElement subclass:#TfAnchorElement
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfAnchorElement class methodsFor:'accessing'!

supportedAttributes

	^ #('href')
!

tagNames 

 	^ #('a')
! !

!TfAnchorElement class methodsFor:'resources'!

defaultBrowserMenu
        "Tools.MenuEditor new openOnClass: self andSelector: #defaultBrowserMenu"

        <resource: #menu>
        ^#(#Menu #(
                        #(#MenuItem 
                                #rawLabel: 'Copy link' 
                                #value: #copyLinkToClipboard 
                                #labelImage: #(#ResourceRetriever #ToolbarIconLibrary #copy ) ) 
                        #(#MenuItem 
                                #rawLabel: 'Open in new tab' 
                                #value: #openInNewTab ) 
                        #(#MenuItem 
                                #rawLabel: 'Save link target' 
                                #value: #saveLinkTarget 
                                #labelImage: #(#ResourceRetriever #ToolbarIconLibrary #fileSave ) ) ) #(3 ) nil ) decodeAsLiteralArray
!

widgetBrowserMenu
        "MenuEditor new openOnClass: self andSelector: #widgetBrowserMenu"

        <resource: #menu>
        ^#(#Menu #(
                        #(#MenuItem 
                                #rawLabel: 'Copy link' 
                                #value: #copyLinkToClipboard ) ) #(1 ) nil ) decodeAsLiteralArray
! !

!TfAnchorElement methodsFor:'accessing'!

anchorName

	^ self valueOfAttribute: 'name'.
!

resolvedURL

	| s |
	^ (s := self urlString) notNil
		ifTrue: [ self documentModel resolveURL: s ]
		ifFalse: [ nil ]
!

target

	^ self valueOfAttribute: 'target'.
!

urlString

	^ self valueOfAttribute: 'href'.
! !

!TfAnchorElement methodsFor:'bookmarks'!

tfAddToBookmarks: aTfBookmarkContainer emit: aBoolean
 
	| descriptor |
	(aBoolean and: [ self urlString isEmpty not and: [self characterData isEmpty not]]) 
		ifTrue: [
			descriptor := TfURLDescriptor url: self urlString description: self characterData.
			aTfBookmarkContainer addBookmark: descriptor
		].
	^aTfBookmarkContainer
! !

!TfAnchorElement methodsFor:'menu actions'!

copyLinkToClipboard

	| url |
	(url := self resolvedURL) notNil
		ifTrue: [ Screen default putExternalSelection: url asString ]
!

openInNewTab

	self documentModel navigateTo: self urlString openMode: #embeddedWindow
!

saveLinkTarget

	self documentModel navigateTo: self urlString openMode: #download
! !

!TfAnchorElement methodsFor:'styles'!

applyStyleSheet: aTfStyleSheet to: aTfStyle

	self urlString notNil
		ifTrue: [ super applyStyleSheet: aTfStyleSheet to: aTfStyle ].
! !

!TfAnchorElement methodsFor:'views'!

tfViewClass

	^ self urlString notNil
		ifTrue: [ TfAnchorView ]
		ifFalse: [ 
			self anchorName notNil
				ifTrue: [ TfLinkTargetView ]
				ifFalse: [ super tfViewClass ]
		].
!

windowMode
	" one of: #(nil #sameWindow #embeddedWindow #newWindow) "

	^ self target = '_blank'
		ifTrue: [ #embeddedWindow ]
		ifFalse: [ nil ]
! !

!TfAnchorElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfAnchorElement.st,v 1.1 2009/10/01 18:25:59 cg Exp $'
! !
