"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfApplicationRegistry
	instanceVariableNames:'actionBlocks'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!

TfApplicationRegistry class instanceVariableNames:'singleton'

"
 No other class instance variables are inherited by this class.
"
!


!TfApplicationRegistry class methodsFor:'instance creation'!

singleton

	singleton isNil
		ifTrue: [ singleton := self new initialize ].
	^ singleton
! !

!TfApplicationRegistry class methodsFor:'accessing'!

flush

	singleton := nil
!

obsolete

	self flush.
	super obsolete.
! !

!TfApplicationRegistry methodsFor:'accessing'!

actionBlockFor: urlDesciptor

	" first come, first serve "
	actionBlocks
		do: [ : a | 
			(a key value: urlDesciptor)
				ifTrue: [ ^ a value ]
		].
	^ nil
!

descriptorMatch: matchBlock evaluate: urlHandlerBlock
	" the handler block will be evaluated when opening a matching url,
	instead of opening it with the browser/widget "

	" TfApplicationRegistry singleton 
			descriptorMatch: [ : descriptor | descriptor url asString match: 'http://* ]
			evaluate: [ : descriptor | Dialog warn: descriptor url asString ] "

	(actionBlocks contains: [ : assoc | assoc key= matchBlock ])
		ifFalse: [ actionBlocks add: matchBlock -> urlHandlerBlock ]
! !

!TfApplicationRegistry methodsFor:'initialize-release'!

initialize

	actionBlocks := OrderedCollection new
! !

!TfApplicationRegistry class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfApplicationRegistry.st,v 1.1 2009/10/01 18:26:06 cg Exp $'
! !
