"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfStylePart subclass:#TfBackgroundStyle
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Styles'
!


!TfBackgroundStyle methodsFor:'accessing'!

borderColor

	^ self propertyValueAt: #borderColor
!

borderColor: aColorValue

	self propertyAt: #borderColor putValue: aColorValue
!

borderWidth

	^ self propertyValueAt: #borderWidth ifAbsent: [ 0 ]
!

borderWidth: anInteger

	self propertyAt: #borderWidth putLocalValue: anInteger
!

color

	^ self propertyValueAt: #color
!

color: aColorValue

	self propertyAt: #color putValue: aColorValue
!

modifyStylePart: aTfStylePart isInherited: isInherited

	| w |
	super modifyStylePart: aTfStylePart isInherited: isInherited.
	((w := self propertyValueAt: #borderWidth) notNil and: [ w > 0 ])
		ifTrue: [ aTfStylePart borderWidth: 1 ].
! !

!TfBackgroundStyle methodsFor:'properties'!

propertyAt: aSymbol put: aProperty

	aProperty addInheritanceStops: #('table' 'body').
	^ super propertyAt: aSymbol put: aProperty
! !

!TfBackgroundStyle methodsFor:'views'!

createDecorator
	
	(self borderWidth > 0 and: [ self borderColor notNil ])
		ifTrue: [ ^ TfBorderedBackgroundDecorator backgroundStyle: self ].
	self color notNil
		ifTrue: [ ^ TfBackgroundDecorator backgroundStyle: self ].
	^ nil
! !

!TfBackgroundStyle class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfBackgroundStyle.st,v 1.1 2009/10/01 19:29:07 cg Exp $'
! !
