"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfElement subclass:#TfBodyElement
	instanceVariableNames:'color backgroundColor'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfBodyElement class methodsFor:'accessing'!

supportedAttributes

	^ #('color' 'bgcolor')
!

tagNames 

 	^ #('body')
! !

!TfBodyElement methodsFor:'accessing'!

isHTMLBodyElement

	^ true
! !

!TfBodyElement methodsFor:'parsing'!

parseColors

	self valueOfAttribute: 'color' do: [ :val |
		color := self valueReader parseColor: val ].
	self valueOfAttribute: 'bgcolor' do: [ :val |
		backgroundColor := self valueReader parseColor: val ].
!

parseValues

	super parseValues.
	self parseColors.
! !

!TfBodyElement methodsFor:'styles'!

applyColorsTo: aTfStyle

	color notNil
		ifTrue: [ aTfStyle fontStyle color: color ].
	backgroundColor notNil
		ifTrue: [ aTfStyle backgroundStyle color: backgroundColor ].
!

modifyStyle: aTfStyle
	" modify the style according to the local style definitions "

	super modifyStyle: aTfStyle.
	self applyColorsTo: aTfStyle.
! !

!TfBodyElement methodsFor:'views'!

tfViewClass

	^ TfBodyView
! !

!TfBodyElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfBodyElement.st,v 1.1 2009/10/01 18:26:23 cg Exp $'
! !
