"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfURLHolder subclass:#TfBookmarkContainer
	instanceVariableNames:'urlHolders'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Base'
!


!TfBookmarkContainer methodsFor:'accessing'!

addBookmark: aTfURLHolder

	self urlHolders add: aTfURLHolder.
	aTfURLHolder container == self
		ifFalse: [ aTfURLHolder container: self ].
!

addToMenu: aMenu for: anObject

	| item |
	(item := self createMenuItemFor: anObject) notNil
		ifTrue: [ aMenu addItem: item ].
!

addURLsToMenu: aMenu for: anObject

	self urlHolders do: [ :urlHolder |
		urlHolder addToMenu: aMenu for: anObject.
	].
!

bookmarkContainer

	^ self
!

createMenuItemFor: anObject

	| menuItem submenu |
	^ self urlHolders isEmpty
		ifTrue: [ nil ]
		ifFalse: [
			menuItem := MenuItem labeled: self description.
			submenu := Menu new.
			self addURLsToMenu: submenu for: anObject.
			menuItem submenu: submenu.
			menuItem
		].
!

removeBookmark: aTfURLHolder

	self urlHolders remove: aTfURLHolder ifAbsent: []
!

treeChildren

	^ self urlHolders select: [ : u | u showInTree ]
!

treeIcon

	^ UI.TreeView closedFolder
!

treeSelectedIcon

	^ UI.TreeView openedFolderImage
!

urlHolders

	urlHolders isNil
		ifTrue: [ urlHolders := OrderedCollection new ].
	^ urlHolders
! !

!TfBookmarkContainer methodsFor:'import/export'!

exportNetscapeBookmarksTo: aStream

	| d |
	d := self depth.
	self container notNil
		ifTrue: [
			d timesRepeat: [ aStream tab ].
			aStream 
				nextPutAll: '<DT><H3>';
				nextPutAll: description;
				nextPutAll: '</H3>';cr.
		].
	d  timesRepeat: [ aStream tab ].
	aStream 
		nextPutAll: '<DL><p>';cr.
	self urlHolders do: [ : urlHolder |
		urlHolder exportNetscapeBookmarksTo: aStream
	].
	d  timesRepeat: [ aStream tab ].
	aStream 
		nextPutAll: '</DL><p>';cr.
!

exportOperaBookmarksTo: aStream

	self container notNil
		ifTrue: [
			aStream nextPutAll: '#FOLDER';cr.
			aStream 
				tab; nextPutAll: 'NAME='; nextPutAll: self description;cr.
			aStream nextPutAll: '	CREATED=0
	VISITED=0
	PERSONALBAR_POS=-1
	DESCRIPTION=
	SHORT NAME=

'.
		].
	self urlHolders do: [ : urlHolder |
		urlHolder exportOperaBookmarksTo: aStream
	].
	self container notNil
		ifTrue: [ aStream nextPutAll: '-';cr ].
! !

!TfBookmarkContainer methodsFor:'printing'!

printOn: aStream

	aStream nextPut: $[.
	super printOn: aStream.
	aStream nextPut: $].
! !

!TfBookmarkContainer class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfBookmarkContainer.st,v 1.1 2009/10/01 18:04:10 cg Exp $'
! !
