"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfDialog subclass:#TfBookmarksDialog
	instanceVariableNames:'fileFormatAspect locationAspect'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-UIApplications-New'
!


!TfBookmarksDialog class methodsFor:'interface specs'!

windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Bookmarks' 
			#bounds: #(#{Graphics.Rectangle} 640 512 887 730 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 5 5 ) 
					#name: #Label1 
					#label: 'Bookmarks file format:' ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Graphics.LayoutOrigin} 5 0 -90 1 ) 
					#name: #Label2 
					#label: 'Location:' ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.LayoutFrame} 5 0 -65 1 -40 1 -40 1 ) 
					#name: #InputField1 
					#model: #locationAspect ) 
				#(#{UI.SequenceViewSpec} 
					#layout: #(#{Graphics.LayoutFrame} 5 0 30 0 -5 1 -90 1 ) 
					#name: #List1 
					#model: #fileFormatAspect 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} -35 1 -65 1 -5 1 -40 1 ) 
					#name: #ActionButton1 
					#model: #chooseLocation 
					#label: '...' 
					#defaultable: true ) 
				#(#{UI.ActionButtonSpec} 
					#properties: #(#{UI.PropertyListDictionary} #labelFromApplication true ) 
					#layout: #(#{Graphics.LayoutFrame} -160 1 -30 1 -85 1 -5 1 ) 
					#name: #ActionButton3 
					#model: #tfOk 
					#label: #actionLabel 
					#defaultable: true ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} -80 1 -30 1 -5 1 -5 1 ) 
					#name: #ActionButton2 
					#model: #tfCancel 
					#label: 'Cancel' 
					#defaultable: true ) ) ) )
! !

!TfBookmarksDialog methodsFor:'accessing'!

location

	| location |
	^ (location := self locationAspect value) notNil
		ifTrue: [ [ location asFilename ] on: Error do: [ : ex | nil ] ]
		ifFalse: [ nil ].
!

readerWriterClass

	| sel |
	^ (sel := self fileFormatAspect selection) notNil
		ifTrue: [ sel value ]
		ifFalse: [ nil ]
! !

!TfBookmarksDialog methodsFor:'actions'!

cancelDialog

	self cancel value: true.
	self closeRequest.
!

chooseLocation

	| default cl nm |
	default := (cl := self readerWriterClass) notNil
		ifTrue: [ cl defaultLocation ]
		ifFalse: [ '*' ].
	nm := Dialog requestFileName: 'Bookmarks location' default: default version: self fileVersion for: nil.
	(nm notNil and: [ nm isEmpty not ])
		ifTrue: [ self locationAspect value: nm ].
!

doAction

	self canAccept ifFalse: [ ^ self ].
	self accept value: true.
	self closeRequest.
! !

!TfBookmarksDialog methodsFor:'aspects'!

fileFormatAspect

	| list |
	fileFormatAspect isNil
		ifTrue: [
			list := (((TfBookmarksReaderWriter allSubclasses reject: [ : cl | cl isAbstract ])
					collect: [ : cl | cl description -> cl ])
					asSortedCollection: [ : a : b  | a key <= b key ])
					asList.
			fileFormatAspect := SelectionInList with: list.
			fileFormatAspect selectionIndexHolder onChangeSend: #changedFormat to: self.
			fileFormatAspect selectionIndex: 1.
		].
	^ fileFormatAspect
!

locationAspect

	^locationAspect isNil
		ifTrue:
			[locationAspect := self defaultLocation asValue]
		ifFalse:
			[locationAspect]
! !

!TfBookmarksDialog methodsFor:'private'!

canAccept

	^ self location notNil 
		and: [ self readerWriterClass notNil
		 and: [ self isValidLocation ]]
!

changedFormat

	| cl |
	(cl := self readerWriterClass) notNil 
		ifTrue: [ self locationAspect value: cl defaultLocation copy ]
!

defaultLocation

	^ '.' copy
!

fileVersion

	^ #any
!

isValidLocation

	self subclassResponsibility
! !

!TfBookmarksDialog class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfBookmarksDialog.st,v 1.1 2009/10/01 23:42:19 cg Exp $'
! !
