"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfSidebarPanel subclass:#TfBookmarksPanel
	instanceVariableNames:'treeAspect lastSelectionIndex'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-UIApplications-New'
!


!TfBookmarksPanel class methodsFor:'accessing'!

description

	^ 'Bookmarks'
!

sortOrder

	^ 1
! !

!TfBookmarksPanel class methodsFor:'interface specs'!

windowSpec
        "Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 'Bookmarks' 
                        #bounds: #(#Rectangle 640 480 840 680 ) ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#ActionButtonSpec 
                                        #layout: #(#LayoutFrame 48 0 -28 1 100 0 -3 1 ) 
                                        #name: #removeBookmarkID 
                                        #model: #removeBookmark 
                                        #label: 'Remove' 
                                        #defaultable: true ) 
                                #(#ActionButtonSpec 
                                        #layout: #(#LayoutFrame 3 0 -28 1 45 0 -3 1 ) 
                                        #name: #addBookmarkID 
                                        #model: #addBookmark 
                                        #label: 'Add' 
                                        #defaultable: true ) 
                                #(#ActionButtonSpec 
                                        #layout: #(#LayoutFrame 103 0 -28 1 150 0 -3 1 ) 
                                        #name: #ActionButton1 
                                        #model: #editBookmark 
                                        #label: 'Edit' 
                                        #defaultable: true ) 
                                #(#{UI.TreeViewSpec} 
                                        #layout: #(#LayoutFrame 0 0 0 0 0 1 -30 1 ) 
                                        #name: #treeID 
                                        #model: #treeAspect 
                                        #callbacksSpec: 
                                        #(#UIEventCallbackSubSpec 
                                                #valueChangeSelector: #changedSelection 
                                                #doubleClickSelector: #doubleClickedSelection ) 
                                        #useModifierKeys: true 
                                        #selectionType: #highlight 
                                        #displayStringSelector: #treeDisplayString 
                                        #useIcons: #other 
                                        #iconSelectors: #(#treeIcon ) ) ) ) )
! !

!TfBookmarksPanel methodsFor:'actions'!

addBookmark

	| urlDescr bwm newBookmark c |
	urlDescr := (bwm := self browserModel activeBrowserWindowModel) notNil
		ifTrue: [ bwm urlDescriptor ]
		ifFalse: [ nil ].
	newBookmark := TfNewBookmarkDialog openOnBookmark: urlDescr.
	newBookmark notNil
		ifTrue: [ 
			c := self selectedBookmarkContainer.
			c addBookmark: newBookmark.
			self updateBookmarksOf: c.
		].
!

editBookmark

	| bookmark |
	(bookmark := self selectedBookmark) notNil
		ifTrue: [ 
			bookmark openBookmarkEditor notNil
				ifTrue: [ self updateBookmarksOf: bookmark container ] 
		].
!

removeBookmark

	| bookmark c |
	(bookmark := self selectedBookmark) notNil
		ifTrue: [ 
			(Dialog confirm: 'Remove ' asText, bookmark description asText allBold, '?')
				ifTrue: [
					c := bookmark container.
					bookmark removeFromBookmarks.
					self updateBookmarksOf: c.
				].
		].
! !

!TfBookmarksPanel methodsFor:'aspects'!

treeAspect

	treeAspect isNil
		ifTrue:[
			treeAspect := SelectionInTree new.
			self buildBookmarks.
		].
	^ treeAspect
! !

!TfBookmarksPanel methodsFor:'initialize-release'!

startUp

	super startUp.
	self browserModel settings onBookmarksChangeSend: #buildBookmarks to: self.
! !

!TfBookmarksPanel methodsFor:'interface opening'!

postBuildWith: aBuilder

	| tree |
	super postBuildWith: aBuilder.
	(tree := aBuilder componentAt: #treeID) notNil
		ifTrue: [ 
			tree widget
				useImage: #treeIcon selectedImage: #treeSelectedIcon;
				useLines: false.
		].
! !

!TfBookmarksPanel methodsFor:'notification'!

changedSelection

	| i urlHolder |
	i := self treeAspect selectionIndex.
	i = 0 
		ifTrue: [ i := lastSelectionIndex ]
		ifFalse: [ lastSelectionIndex := i ].
	urlHolder := self treeAspect selection.
	(urlHolder notNil and: [ urlHolder isURLBookmark ])
		ifFalse: [ self treeAspect tree toggleExpand: i ]
!

doubleClickedSelection

	| urlHolder |
	urlHolder := self treeAspect selection.
	(urlHolder notNil and: [ urlHolder isURLBookmark ])
		ifTrue: [ self goto: urlHolder ]
! !

!TfBookmarksPanel methodsFor:'private'!

buildBookmarks

	treeAspect list: (TreeModel
		on: self browserModel bookmarks
		displayRoot: false
		childrenWith: [ :cl | cl treeChildren ]).
!

goto: aTfURLDescriptor

	| bwm |
	(bwm := self browserModel activeBrowserWindowModel) notNil
		ifTrue: [
			Cursor wait showWhile: [
				bwm navigationModel goto: aTfURLDescriptor
			].
		].
!

selectedBookmark

	^ self treeAspect selection
!

selectedBookmarkContainer 

	| entry |
	^ (entry := self treeAspect selection) notNil
		ifTrue: [ entry bookmarkContainer ]
		ifFalse: [ self browserModel bookmarks ]
!

updateBookmarksOf: bookmarkContainer

	" trigger update "
	self browserModel bookmarks: self browserModel bookmarks
! !

!TfBookmarksPanel class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfBookmarksPanel.st,v 1.1 2009/10/01 23:43:27 cg Exp $'
! !
