"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfBookmarksReaderWriter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Base'
!


!TfBookmarksReaderWriter class methodsFor:'accessing'!

defaultLocation

	^ '*'
!

description

	^ nil
!

isAbstract

	^ self description isNil
! !

!TfBookmarksReaderWriter class methodsFor:'import/export'!

canExportToFile: aFilename

	^ aFilename exists not or: [ aFilename isDirectory not and: [ aFilename directory exists ]]
!

canImportFromFile: aFilename

	^ aFilename exists and: [ aFilename isDirectory not ]
!

export: aBookmarkContainer toFile: aFilename

	^ self new
		export: aBookmarkContainer toFile: aFilename
!

importFromFile: aFilename

	^ self new
		importFromFile: aFilename
! !

!TfBookmarksReaderWriter class methodsFor:'private'!

errorSignal

	^ TfError
! !

!TfBookmarksReaderWriter methodsFor:'import/export'!

encoding

	^ #'UTF-8'
!

export: aBookmarkContainer to: aStream

	self subclassResponsibility
!

export: aBookmarkContainer toFile: aFilename

	| str file |
	file := aFilename asFilename.
	self encoding notNil ifTrue: [ file := file withEncoding: self encoding ].
	str := file writeStream text.
	[ 
		self export: aBookmarkContainer to: str
	] ensure: [
		str close
	].
!

importFrom: aStream

	self subclassResponsibility
!

importFromFile: aFilename

	| str file |
	file := aFilename asFilename.
	self encoding notNil ifTrue: [ file := file withEncoding: self encoding ].
	str := file readStream.
	^ [ 
		self importFrom: str
	] ensure: [
		str close
	].
! !

!TfBookmarksReaderWriter class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfBookmarksReaderWriter.st,v 1.1 2009/10/01 18:04:16 cg Exp $'
! !
