"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfElementLayout subclass:#TfBoxElementLayout
	instanceVariableNames:'height width align origin'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfBoxElementLayout class methodsFor:'instance creation'!

for: aTfView bounds: aRectangle 

	^ (self for: aTfView extent: aRectangle extent)
		origin: aRectangle origin;
		yourself.
!

for: aTfView extent: extent

	^ (self for: aTfView height: extent y)
		width: extent x;
		yourself.
!

for: aTfView height: anInteger

	^ (self for: aTfView)
		height: anInteger;
		yourself.
! !

!TfBoxElementLayout methodsFor:'accessing'!

ascent

	^ 0
!

bounds

	^ (self origin notNil and: [ self width notNil and: [ self height notNil ]])
		ifTrue: [ self origin extent: self width@self height ]
		ifFalse: [ nil ]
!

bounds: aRectangle

	self extent: aRectangle extent.
	self origin: aRectangle origin.
!

descent

	^ 0
!

extent: aPoint

	self width: aPoint x.
	self height: aPoint y.
!

height
	" height of the box "

	^ height ifNil: [ 0 ].
!

height: anInteger
	" height of the box "

	height := anInteger
!

lineHeight
	" don't affect the current line if the line is flowing around the box "

	^ self align isNil
		ifTrue: [ self height]
		ifFalse: [ 0 ].
!

origin

	^ origin ifNil: [ 0@0 ]
!

origin: aPoint

	origin := aPoint
!

protectedBox

	^ self align notNil
		ifTrue: [ self bounds ]
		ifFalse: [ nil ]
!

translateBy: aPoint

	self origin: self origin + aPoint
!

width

	^ width notNil
		ifTrue: [ width ]
		ifFalse: [ 1 ]
!

width: anInteger

	width := anInteger
! !

!TfBoxElementLayout methodsFor:'layout'!

adaptToAscent: maxAscent descent: maxDescent height: maxHeight remainingWidth: remainingWidth for: layoutContext 

	| deltaY deltaX delta |
	deltaY := (maxHeight - self height) max: 0.
	deltaX := self alignmentDeltaFor: remainingWidth.
	delta := deltaX@deltaY.
	delta ~= (0@0)
		ifTrue: [ self parentView tfLocalTranslateBy: delta ]
!

applyToParagraphPosition: aPoint
	" we are at the beginning of a new paragraph. return the modified paragraph start position "

	^ self align = #right
		ifTrue: [ aPoint ]
		ifFalse: [ super applyToParagraphPosition: aPoint ]
! !

!TfBoxElementLayout methodsFor:'layout - private'!

applyAlignTo: aTfLayoutContext

"	| left |
	(self align = #right and: [ self origin notNil and: [ self width notNil ]])
		ifTrue: [
			left := aTfLayoutContext rightIndentBy: self width.
			origin := left@origin y.
			self parentView tfLocalTranslation: origin.
		].
"
!

applyLineHeightTo: aTfLayoutContext

	self align isNil
		ifTrue: [ aTfLayoutContext currentLineHeightMax: self height ].
!

applyPositionTo: aTfLayoutContext

	self align = #right
		ifFalse: [ super applyPositionTo: aTfLayoutContext ]
!

applyToLayoutContext: aTfLayoutContext

	super applyToLayoutContext: aTfLayoutContext.
	self applyAlignTo: aTfLayoutContext.
! !

!TfBoxElementLayout class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfBoxElementLayout.st,v 1.1 2009/10/01 19:35:30 cg Exp $'
! !
