"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Model subclass:#TfBrowserWindowModel
	instanceVariableNames:'browserModel creationTimestamp'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Base'
!

TfBrowserWindowModel comment:'Model of a window of the browser

Instance Variables:
	application	&lt;Object&gt;	Application model of the window
	browserModel	&lt;TfBrowserModel&gt;	Model of the browser
	creationTimestamp	&lt;Timestamp&gt;	Timestamp of the creation of the window'
!


!TfBrowserWindowModel class methodsFor:'instance creation'!

new

	^ super new initialize
! !

!TfBrowserWindowModel methodsFor:'accessing'!

browserModel

	browserModel isNil
		ifTrue: [ 
			browserModel := TfBrowserModel new.
			browserModel addWindowModel: self.
		].
	^ browserModel
!

browserModel: aTfBrowserModel

	browserModel := aTfBrowserModel.
!

canNavigate

	^ false
!

creationTimestamp

	^ creationTimestamp
!

isEmbedded
	" true if the window is embedded into the browser, false if it is shown in a separate window "

	self subclassResponsibility
!

isResourceWindowModel

	^ false
!

resourceModel

	^ nil
!

title
	" title of the window "

	self subclassResponsibility
!

urlDescriptor

	^ nil
!

windowIndex

	^ self browserModel indexOfWindow: self
! !

!TfBrowserWindowModel methodsFor:'initialize-release'!

initialize

	creationTimestamp := Timestamp now.
!

shutDown
	" sent before the browser is closed "
! !

!TfBrowserWindowModel methodsFor:'loading'!

reload
	" reload the contents (if needed/valid) "
! !

!TfBrowserWindowModel methodsFor:'notification'!

defaultStyleChanged
	" the default stylesheet has changed "

	" ignored by default "
! !

!TfBrowserWindowModel methodsFor:'private'!

resourceManager

	^ self browserModel resourceManager
! !

!TfBrowserWindowModel methodsFor:'views'!

createApplication
	" create an application model for the window "

	^ nil
! !

!TfBrowserWindowModel class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfBrowserWindowModel.st,v 1.1 2009/10/01 18:04:28 cg Exp $'
! !
