"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

CompositionScanner subclass:#TfCompositionScanner
	instanceVariableNames:'lastLineIndex maxWordWidth lastWordWidth'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Graphics-Text Scanning'
!


!TfCompositionScanner methodsFor:'accessing'!

availableWidth

	^ rightMargin notNil
		ifTrue: [ rightMargin - leftMargin ]
		ifFalse: [ nil ].
!

lastLineIndex

	^ lastLineIndex
!

maxWordWidth

	^ maxWordWidth notNil
		ifTrue: [ maxWordWidth  + self italicBonusWidth ]
		ifFalse: [ destX notNil
			ifTrue: [ destX - leftMargin  + self italicBonusWidth ]
			ifFalse: [ 0 ]]
!

width

	^ destX - leftMargin + self italicBonusWidth
! !

!TfCompositionScanner methodsFor:'private'!

italicBonusWidth

	| fd |
	" quick hack "
	^ [ 
		((fd := font fontDescription) notNil and: [ fd italic ])
			ifTrue: [ 
				" can't ask the font for its 'italiceness', so just guess "
				(font ascent // 8) max: 1
			]
			ifFalse:[ 0 ]
	] on: Error do: [ : ex | 
		0
	].
! !

!TfCompositionScanner methodsFor:'scanning'!

composeLine: lineIndex fromCharacterIndex: startIndex leftMargin: aLeft rightMargin: aRight
	"Compute line information for the given arguments."

	lastLineIndex := lineIndex.
	super composeLine: lineIndex fromCharacterIndex: startIndex leftMargin: aLeft rightMargin: aRight.
!

composeLine: lineIndex fromCharacterIndex: startIndex wrap: wrap leftMargin: left rightMargin: right

	wrap
		ifTrue: [
			self
				composeLine: lineIndex
				fromCharacterIndex: startIndex
				leftMargin: left
				rightMargin: right ]
		ifFalse: [
			self
				noWrapComposeLine: lineIndex
				fromCharacterIndex: startIndex
				leftMargin: left ].
!

noWrapComposeLine: lineIndex fromCharacterIndex: startIndex leftMargin: aLeft 
	"Compute line information for the given arguments."

	lastLineIndex := lineIndex.
	super noWrapComposeLine: lineIndex fromCharacterIndex: startIndex leftMargin: aLeft
!

noWrapComposeLine: lineIndex fromCharacterIndex: startIndex rightMargin: aRight
	"Compute line information for the given arguments."

	lastLineIndex := lineIndex.
	super noWrapComposeLine: lineIndex fromCharacterIndex: startIndex rightMargin: aRight
! !

!TfCompositionScanner methodsFor:'stop conditions'!

crossedX
	" if there is no space that allows wrapping and this is the first line,
	then leave the line empty "

	^ (spaceCount = 0 and: [ self lastLineIndex = 1 ])
		ifTrue: [
			lastIndex := 0.
			true 
		] ifFalse: [ super crossedX ].
!

space

	lastWordWidth := destX - spaceX + spaceWidth.
	maxWordWidth := maxWordWidth notNil
		ifTrue: [ maxWordWidth max: lastWordWidth ]
		ifFalse: [ lastWordWidth ].
	^ super space
! !

!TfCompositionScanner class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfCompositionScanner.st,v 1.1 2009/10/02 00:04:37 cg Exp $'
! !
