"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfImageReader subclass:#TfDefaultImageReader
	instanceVariableNames:'readerClasses'
	classVariableNames:''
	poolDictionaries:''
	category:'TwoflowerBrowserModel'
!


!TfDefaultImageReader methodsFor:'accessing'!

handledMimeTypes
	" patterns of all mime types that are handled by this class "

	^ readerClasses keys
!

readImageFrom: aStream mimeType: mimeType
	" returns an image read from the stream "

	| readerClass |
	readerClass := readerClasses at: mimeType ifAbsent: [ ^ nil ].
	^ readerClass new from: aStream; image
! !

!TfDefaultImageReader methodsFor:'initialize-release'!

initialize

	super initialize.
	self initializeReaderClasses.
!

initializeReaderClasses

	readerClasses := Dictionary new.
	#{Graphics.GIFImageReader}
		ifDefinedDo: [ :irc | readerClasses at: 'image/gif' put: irc ]
		elseDo: [
			#{Graphics.ArborGIFImageReader}
				ifDefinedDo: [ :irc | readerClasses at: 'image/gif' put: irc ]
		].
	#{Graphics.BMPImageReader}
		ifDefinedDo: [ :irc | readerClasses at: 'image/bmp' put: irc ].
	#{Graphics.JPEGImageReader}
		ifDefinedDo: [ :irc | 
			readerClasses at: 'image/jpg' put: irc.
			readerClasses at: 'image/jpeg' put: irc.
		].
	#{Graphics.PNGImageReader}
		ifDefinedDo: [ :irc | readerClasses  at: 'image/png' put: irc ].
	#{Graphics.XBMImageReader}
		ifDefinedDo: [ :irc | readerClasses  at: 'image/xbm' put: irc ].
! !

!TfDefaultImageReader class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfDefaultImageReader.st,v 1.1 2009/10/01 19:53:37 cg Exp $'
! !
