"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

XML::Document subclass:#TfDocument
	instanceVariableNames:'title metaInfos dependents documentModel'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfDocument methodsFor:'CSS'!

modifyStyle: aTfStyle
	" modify the style according to the local style definitions "
	" there are no local definitions, so do nothing "
! !

!TfDocument methodsFor:'accessing'!

addMetaInfo: aMetaInfo

	metaInfos add: aMetaInfo
!

addNode: aNode

	| newRoot |
	nodes add: aNode.
	aNode parent: self.
	aNode isElement
		ifTrue: [
			root == nil
				ifTrue: [root := aNode]
				ifFalse: [ 
					(root isKindOf: TfHTMLElement)
						ifFalse: [
							newRoot := TfHTMLElement tag: 'html' attributes: #() elements: #().
							newRoot addNode: root.
							root := newRoot.
						].
					root addNode: aNode.
				]
		].
!

documentModel

	^ documentModel
!

documentModel: aTfDocumentModel

	documentModel := aTfDocumentModel
!

isInTable

	^ false
!

listElement

	^ nil
!

metaInfos

	^ metaInfos
!

tagName

	^ nil
!

tfDocument

	^ self
!

tfFixNodes

	self elements copy do: [ : n | n tfFixNodes ].
!

tfFormElement

	^ nil
!

tfPreviousElementNamed: elementName ifAbsent: aBlock
	" find the previous element (left neighbor/parent) with the given name "

	^ aBlock value
!

tfTableElement

	^ nil
!

title

	^ title
!

title: aString

	title := aString
! !

!TfDocument methodsFor:'copying'!

postCopy
	"Do not copy the dependents list."

	super postCopy.
	self breakDependents
! !

!TfDocument methodsFor:'initialize'!

initialize

	super initialize.
	metaInfos := OrderedCollection new.
!

parsingFinished

	self nodesDo: [ : node |
		node isElement
			ifTrue: [ 	node  parsingFinished ].
	].
	self nodesDo: [ : node |
		node isElement
			ifTrue: [ 	node addedToDocument: self ].
	].
! !

!TfDocument methodsFor:'inspecting'!

inspectorClasses

	^ super inspectorClasses
		copyWith: TfHTMLInspector
! !

!TfDocument methodsFor:'menu actions'!

copyTextToClipboard

	self documentModel copyTextToClipboard
! !

!TfDocument methodsFor:'printing'!

printOn: aStream

	self tfPrintOn: aStream emphasicDictionary: Dictionary new
!

tfTreeDisplayString

	^ 'Document' asText emphasizeAllWith: #color -> (ColorValue red: 0 green: 0.3 blue: 0).
! !

!TfDocument methodsFor:'private'!

myDependents
	"Answer the receiver's dependents or nil."

	^dependents
!

myDependents: dependentsOrNil
	"Set the receivers dependents."

	dependents := dependentsOrNil
! !

!TfDocument methodsFor:'resources'!

defaultBrowserMenu

	^ Menu new
!

widgetBrowserMenu

	^ Menu new
! !

!TfDocument methodsFor:'views'!

tfComponents

	^ Array with: self root
!

tfViewClass
	" returns the default composite view class for this element "

	^ TfDocumentView
! !

!TfDocument class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfDocument.st,v 1.1 2009/10/01 18:29:34 cg Exp $'
! !
