"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfDialog subclass:#TfEditBookmarkDialog
	instanceVariableNames:'nameAspect urlAspect bookmark'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower'
!


!TfEditBookmarkDialog class methodsFor:'instance creation'!

openOnBookmark: aTfURLDescriptor

	| dialog |
	dialog := self new.
	aTfURLDescriptor notNil
		ifTrue: [ dialog initializeFrom: aTfURLDescriptor ].
	dialog open.
	^ dialog accept value
		ifTrue: [ dialog editedBookmark ]
		ifFalse: [ nil ]
! !

!TfEditBookmarkDialog class methodsFor:'interface specs'!

bookmarkSpec
	"Tools.UIPainter new openOnClass: self andSelector: #bookmarkSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 
			#(#{Kernel.UserMessage} 
				#key: #UnlabeledCanvas 
				#defaultString: 'Edit bookmark' 
				#catalogID: #labels ) 
			#min: #(#{Core.Point} 20 20 ) 
			#max: #(#{Core.Point} 1280 1024 ) 
			#bounds: #(#{Graphics.Rectangle} 640 512 1030 628 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 5 6 ) 
					#name: #Label1 
					#label: 'URL:' ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.LayoutFrame} 50 0 5 0 -5 1 30 0 ) 
					#name: #InputField1 
					#model: #urlAspect ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 5 35 ) 
					#name: #Label2 
					#label: 'Name:' ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.LayoutFrame} 50 0 34 0 -5 1 59 0 ) 
					#name: #InputField2 
					#model: #nameAspect ) ) ) )
!

windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 
			#(#{Kernel.UserMessage} 
				#key: #UnlabeledCanvas 
				#defaultString: 'Edit bookmark' 
				#catalogID: #labels ) 
			#min: #(#{Core.Point} 20 20 ) 
			#max: #(#{Core.Point} 1280 1024 ) 
			#bounds: #(#{Graphics.Rectangle} 640 512 1030 628 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} -168 1 -30 1 -88 1 -5 1 ) 
					#name: #ActionButton2 
					#model: #tfOk 
					#label: 'OK' 
					#defaultable: true ) 
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.LayoutFrame} -85 1 -30 1 -5 1 -5 1 ) 
					#name: #ActionButton1 
					#model: #tfCancel 
					#label: 'Cancel' 
					#defaultable: true ) 
				#(#{UI.SubCanvasSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 0 0 0 1 -30 1 ) 
					#name: #Subcanvas1 
					#flags: 0 
					#minorKey: #bookmarkSpec ) ) ) )
! !

!TfEditBookmarkDialog methodsFor:'accessing'!

bookmark

	^ bookmark
!

canAccept

	^ self urlAspect value notEmpty and: [ self nameAspect value notEmpty ].
!

editedBookmark

	bookmark url: self urlAspect value.
	bookmark description: self nameAspect value.
	^ bookmark
!

initializeFrom: aTfURLDescriptor

	| s |
	bookmark := aTfURLDescriptor.
	self urlAspect value: aTfURLDescriptor url asString.
	(s := aTfURLDescriptor description) isNil
		ifTrue: [ s := self urlAspect value  ].
	self nameAspect value: s
! !

!TfEditBookmarkDialog methodsFor:'aspects'!

nameAspect
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^nameAspect isNil
		ifTrue:
			[nameAspect := String new asValue]
		ifFalse:
			[nameAspect]
!

urlAspect
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^urlAspect isNil
		ifTrue:
			[urlAspect := String new asValue]
		ifFalse:
			[urlAspect]
! !

!TfEditBookmarkDialog class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfEditBookmarkDialog.st,v 1.1 2009/10/01 18:01:38 cg Exp $'
! !
