"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfElementLayout
	instanceVariableNames:'parentView globalTranslation'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfElementLayout class methodsFor:'instance creation'!

for: aTfView

	^ self new
		parentView: aTfView;
		yourself.
! !

!TfElementLayout methodsFor:'accessing'!

align

	" oh dear "
	^ self parentView styleContext style paragraphStyle alignment
!

alignFactor

	" oh dear "
	^ self parentView styleContext style paragraphStyle alignFactor
!

ascent
	" ascent of the layout element. if the element is not a text, then
	this is usually the height of the element "

	^ self height
!

bounds

	self subclassResponsibility
!

descent
	" descent of the layout element. if the element is not a text, then
	this is usuallay zero "

	^ 0
!

globalProtectedBox

	| p |
	^ (p := self protectedBox) notNil
		ifTrue: [ p translatedBy: self globalTranslation ]
		ifFalse: [ nil ]
!

globalTranslation

	^ globalTranslation
!

globalTranslation: aPoint

	globalTranslation := aPoint
!

height

	^ self ascent + self descent
!

ignoreParagraphStart

	^ self isInvisibleElement
!

isInvisibleElement

	^ false
!

lineHeight

	^ self height
!

parentView
	" view that uses this layout "

	^ parentView
!

parentView: aView
	" view that uses this layout "

	parentView := aView
!

protectedBox

	^ nil
!

translateBy: aPoint
!

width

	^ nil
! !

!TfElementLayout methodsFor:'layout'!

adaptToAscent: maxAscent descent: maxDescent height: maxHeight remainingWidth: remainingWidth for: layoutContext 
	" the entire line has been layouted. give the elements a chance to adapt
	to the line layout. "

	self subclassResponsibility
!

addToLayoutContext: aTfLayoutContext

	aTfLayoutContext addElementLayout: self.
	self applyToLayoutContext: aTfLayoutContext.
!

applyToParagraphPosition: aPoint
	" we are at the beginning of a new paragraph. return the modified paragraph start position "

	| box |
	box := self protectedBox.
	^ box notNil
		ifTrue: [ aPoint x@(aPoint y max: box bottom) ]
		ifFalse: [ aPoint ]
! !

!TfElementLayout methodsFor:'layout - private'!

alignmentDeltaFor: remainingWidth

	^ (remainingWidth * self alignFactor) rounded
!

applyBoxTo: aTfLayoutContext

	self protectedBox notNil
		ifTrue: [ aTfLayoutContext addProtectedBox: self ].
!

applyLineHeightTo: aTfLayoutContext

	aTfLayoutContext currentLineHeightMax: self height.
!

applyPositionTo: aTfLayoutContext

	(self width notNil and: [ self width > 0 ])
		ifTrue: [ aTfLayoutContext moveBy: self width@0 ].
!

applyToLayoutContext: aTfLayoutContext

	self applyLineHeightTo: aTfLayoutContext.
	self applyPositionTo: aTfLayoutContext.
	self applyBoxTo: aTfLayoutContext.
! !

!TfElementLayout class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfElementLayout.st,v 1.1 2009/10/01 19:38:34 cg Exp $'
! !
