"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfEmbeddedBrowserApp subclass:#TfEmbeddedDownloadApp
	instanceVariableNames:'tableAspect urlAspect filenameAspect statusAspect resourceManager
		downloadSizeAspect speedAspect'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower'
!


!TfEmbeddedDownloadApp class methodsFor:'instance creation'!

resourceManager: aTfResourceManager

	^ self new
		resourceManager: aTfResourceManager;
		yourself
! !

!TfEmbeddedDownloadApp class methodsFor:'interface specs'!

windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Twoflower' 
			#bounds: #(#{Graphics.Rectangle} 716 476 1243 983 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ActionButtonSpec} 
					#layout: #(#{Graphics.Rectangle} 3 3 83 27 ) 
					#name: #ActionButton1 
					#model: #cancelDownload 
					#label: 'Cancel' 
					#defaultable: true ) 
				#(#{UI.DataSetSpec} 
					#properties: #(#{UI.PropertyListDictionary} #allowColumnReordering false #allowSorting false #allowColumnResizing true ) 
					#layout: #(#{Graphics.LayoutFrame} 3 0 30 0 -3 1 -3 1 ) 
					#name: #tableID 
					#flags: 13 
					#model: #tableAspect 
					#columns: #(
						#(#{UI.DataSetColumnSpec} 
							#properties: #(#{UI.PropertyListDictionary} #allowSorting true ) 
							#model: #filenameAspect 
							#label: 'Filename' 
							#labelIsImage: false 
							#width: 120 
							#rendererType: #Text 
							#editorType: #None 
							#noScroll: false ) 
						#(#{UI.DataSetColumnSpec} 
							#properties: #(#{UI.PropertyListDictionary} #allowSorting true ) 
							#model: #urlAspect 
							#label: 'URL' 
							#labelIsImage: false 
							#width: 150 
							#rendererType: #Text 
							#editorType: #None 
							#noScroll: false ) 
						#(#{UI.DataSetColumnSpec} 
							#properties: #(#{UI.PropertyListDictionary} #allowSorting true ) 
							#model: #statusAspect 
							#label: 'Status' 
							#labelIsImage: false 
							#width: 120 
							#rendererType: #Text 
							#editorType: #None 
							#alignment: #left 
							#noScroll: false ) 
						#(#{UI.DataSetColumnSpec} 
							#properties: #(#{UI.PropertyListDictionary} #allowSorting true ) 
							#model: #speedAspect 
							#label: 'Speed' 
							#labelIsImage: false 
							#width: 120 
							#rendererType: #Text 
							#editorType: #None 
							#noScroll: false ) 
						#(#{UI.DataSetColumnSpec} 
							#properties: #(#{UI.PropertyListDictionary} #allowSorting true ) 
							#model: #downloadSizeAspect 
							#label: 'Size' 
							#labelIsImage: false 
							#width: 80 
							#rendererType: #Text 
							#editorType: #None 
							#noScroll: false ) ) 
					#multipleSelections: true 
					#labelsAsButtons: true ) ) ) )
! !

!TfEmbeddedDownloadApp methodsFor:'accessing'!

resourceManager

	^ resourceManager
!

resourceManager: aTfResourceManager

	resourceManager := aTfResourceManager.
	self resourceManager onDownloadSend: #addedDownload: to: self.
	self resourceManager downloads do: [ : dm | self addedDownload: dm ].
! !

!TfEmbeddedDownloadApp methodsFor:'actions'!

cancelDownload

	| activeDownloads num ok |
	activeDownloads := self selectedDownloads select: [ :d | d isActive ].
	(num := activeDownloads size) > 0
		ifTrue: [
			ok := Dialog confirm: ('Cancel <1s> download(s)?' expandMacrosWith: num printString).
			ok 
				ifTrue: [ activeDownloads do: [ :d | d cancel ]].
		].
! !

!TfEmbeddedDownloadApp methodsFor:'aspects'!

downloadSizeAspect

	downloadSizeAspect isNil
		ifTrue: [
			downloadSizeAspect := TfBlockAdaptor accessBlock: [ : download | download sizeString ].
		].
	^ downloadSizeAspect
!

filenameAspect

	filenameAspect isNil
		ifTrue: [
			filenameAspect := TfBlockAdaptor accessBlock: [ : download | download filename tail ].
		].
	^ filenameAspect
!

speedAspect

	speedAspect isNil
		ifTrue: [
			speedAspect := TfBlockAdaptor accessBlock: [ : download | download speedString ].
		].
	^ speedAspect
!

statusAspect

	statusAspect isNil
		ifTrue: [
			statusAspect := TfBlockAdaptor accessBlock: [ : download | | s |
								s := download statusString.
								download isActive
									ifTrue: [ s asText allBold ]
									ifFalse: [ s ] ].
		].
	^ statusAspect
!

tableAspect

	tableAspect isNil
		ifTrue: [ 
			tableAspect := MultiSelectionInList with: self resourceManager downloads
		].
	^ tableAspect
!

urlAspect

	urlAspect isNil
		ifTrue: [
			urlAspect := TfBlockAdaptor accessBlock: [ : download | download urlDescriptor url asString ].
		].
	^ urlAspect
! !

!TfEmbeddedDownloadApp methodsFor:'interface opening'!

hookInto: canvas builder: aBuilder

	super hookInto: canvas builder: aBuilder.
	self resizeLayout.
! !

!TfEmbeddedDownloadApp methodsFor:'notification'!

addedDownload: aTfDownloadModel

	aTfDownloadModel
		onProgressSend: #changedDownload to: self;
		onStatusChangeSend: #changedDownload to: self.
!

changedDownload

	self tableView invalidate.
	self builder window sensor noteEvent
!

windowEvent: anEvent from: anApplicationWindow

	super windowEvent: anEvent from: anApplicationWindow.
	(anEvent key == #resize or: [anEvent key == #open])
		ifTrue: [self resizeLayout ]
! !

!TfEmbeddedDownloadApp methodsFor:'private'!

downloads

	^ self tableAspect list
!

resizeLayout

"	[	| scale table width columnsWidth |
		table := self tableView.
		width := table bounds width.
		columnsWidth := table columnDescriptors inject: 0 into: [ : sum : desc | sum + desc width value ].
		scale := width / columnsWidth.
		table columnDescriptors do: [ : desc | desc width: (desc width * scale) truncated ].
		table invalidate.
	] on: Error do: [ : ex |
		Log logError: 'Could not update column widths: ', ex description
	]
"
!

selectedDownloads

	^ self tableAspect selections
!

tableView

	^ (self builder componentAt: #tableID) widget.
! !

!TfEmbeddedDownloadApp class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfEmbeddedDownloadApp.st,v 1.1 2009/10/01 18:01:50 cg Exp $'
! !
