"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfAbstractStyleElement subclass:#TfFontElement
	instanceVariableNames:'color pixelSizeLayout family'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfFontElement class methodsFor:'accessing'!

supportedAttributes

	^ #('color' 'face' 'size')
!

tagNames

	^ #('font')
! !

!TfFontElement methodsFor:'accessing'!

color

	^ color
!

family

	^ family
!

pixelSizeLayout

	^ pixelSizeLayout
! !

!TfFontElement methodsFor:'parsing'!

parseValues

	super parseValues.
	self valueOfAttribute: 'color' do: [ :col | color := self valueReader parseColor: col ].
	self valueOfAttribute: 'face' do: [ :face | family := self valueReader parseFontNames: face ].
	self valueOfAttribute: 'size' do: [ :fontSize |
		pixelSizeLayout := self valueReader parseFontSize: fontSize.
	].
! !

!TfFontElement methodsFor:'styles'!

applyFontStyleTo: aTfStyle

	| fontStyle |
	fontStyle := aTfStyle fontStyle.
	self color notNil
		ifTrue: [ fontStyle color: self color ].
	self family notNil
		ifTrue: [ fontStyle family: self family ].
	self pixelSizeLayout notNil
		ifTrue: [ fontStyle pixelSizeLayout: self pixelSizeLayout ].
!

modifyStyle: aTfStyle
	" modify the style according to the local style definitions "

	super modifyStyle: aTfStyle.
	self applyFontStyleTo: aTfStyle.
! !

!TfFontElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfFontElement.st,v 1.1 2009/10/01 18:31:17 cg Exp $'
! !
