"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfFixedSizeLayout subclass:#TfFontSizeDictionaryLayout
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!

TfFontSizeDictionaryLayout class instanceVariableNames:'sizeFactorDictionary cssNameDictionary'

"
 No other class instance variables are inherited by this class.
"
!


!TfFontSizeDictionaryLayout class methodsFor:'instance creation'!

cssName: cssName

	| sizeFactor |
	sizeFactor := self cssNameDictionary at: cssName asLowercase ifAbsent: [ 1 ].
	^ self pixelSize: sizeFactor * self fontBaseSize
!

fontBaseSize

	^ TfHTMLValueReader singleton fontBaseSize
!

fontSize: fontSize

	| sizeFactor fs |
	fs := (fontSize max: self minFontSize) min: self maxFontSize.
	sizeFactor := self sizeFactorDictionary at: fs ifAbsent: [ nil ].
	^ self pixelSize: sizeFactor * self fontBaseSize
! !

!TfFontSizeDictionaryLayout class methodsFor:'acessing'!

maxFontSize

	^ 7
!

minFontSize

	^ 1
! !

!TfFontSizeDictionaryLayout class methodsFor:'private'!

cssNameDictionary
	"cssNameDictionary := nil"

	cssNameDictionary isNil
		ifTrue: [
			cssNameDictionary := Dictionary new.
			cssNameDictionary
				at: 'xx-small' put: (self sizeFactorDictionary at: 1);
				at: 'x-small' put: (self sizeFactorDictionary at: 1);
				at: 'small' put: (self sizeFactorDictionary at: 2);
				at: 'medium' put: (self sizeFactorDictionary at: 3);
				at: 'large' put: (self sizeFactorDictionary at: 4);
				at: 'x-large' put: (self sizeFactorDictionary at: 5);
				at: 'xx-large' put: (self sizeFactorDictionary at: 6);
				at: 'smaller' put: (self sizeFactorDictionary at: 2);
				at: 'larger' put: (self sizeFactorDictionary at: 4).
		].
	^ cssNameDictionary
!

sizeFactorDictionary
	"sizeFactorDictionary := nil"

	sizeFactorDictionary isNil
		ifTrue: [
			sizeFactorDictionary := Dictionary new.
			sizeFactorDictionary
				at: 1 put: 0.75;
				at: 2 put: 0.875;
				at: 3 put: 1;
				at: 4 put: 1.25;
				at: 5 put: 1.5;
				at: 6 put: 2;
				at: 7 put: 3.
		].
	^ sizeFactorDictionary
! !

!TfFontSizeDictionaryLayout methodsFor:'layout'!

preferredWidth

	^ nil
! !

!TfFontSizeDictionaryLayout class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfFontSizeDictionaryLayout.st,v 1.1 2009/10/01 18:31:24 cg Exp $'
! !
