"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfForm
	instanceVariableNames:'valueDictionary url actionURL encoding method handler
		documentModel submitted'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfForm methodsFor:'accessing'!

actionURL
	" submit URL (without query parameters) "

	^ actionURL
!

actionURL: anUrlOrString
	" submit URL (without query parameters) "

	actionURL := anUrlOrString
!

documentModel

	^ documentModel
!

documentModel: aTfDocumentModel

	documentModel := aTfDocumentModel
!

encodedData

	| str |
		str := (String new: 64) writeStream.	
		self  valueDictionary associations 
		do: [ : assoc |
			Net.URL tfEncode: assoc key on: str.
			str nextPut: $=.
			Net.URL tfEncode: assoc value value on: str ]
		separatedBy: [
			str nextPut: $&
		].
	^str
!

encoding

	^ encoding
!

encoding: aString

	encoding := aString
!

handler: anObject

	handler := anObject
!

method

	^ method notNil
		ifTrue: [ method ]
		ifFalse: [ #get ]
!

method: aSymbol

	method := aSymbol
!

submitted

	submitted isNil
		ifTrue: [ submitted := false ].
	^ submitted
!

submitted: aBoolean

	submitted := aBoolean
!

url
	" full URL (resolved, with query parameters) "

	^ url
!

valueAt: name put: aString

	(self valueHolderNeededAt: name) value: aString
!

valueHolderNeededAt: name

	^ self valueDictionary at: name ifAbsentPut: [ ValueHolder with: String new ]
! !

!TfForm methodsFor:'comparing'!

= anotherForm

	| vd |
	self class = anotherForm class
		ifFalse: [ ^ false ].
	self url = anotherForm url
		ifFalse: [ ^ false ].
	self method = anotherForm method
		ifFalse: [ ^ false ].
	self valueDictionary size = (vd := anotherForm valueDictionary) size
		ifFalse: [ ^ false ].
	self valueDictionary keysAndValuesDo: [ : k : vh | | vh2 |
		vh2 := vd at: k ifAbsent: [ ^ false ].
		vh2 value = vh value
			ifFalse: [ ^ false ].
	].
	^ true
!

hash

	^ self url hash bitXor: self valueDictionary size
! !

!TfForm methodsFor:'genetic stuff'!

beClone

	| oldDict |
	oldDict := valueDictionary.
	oldDict notNil
		ifTrue: [
			valueDictionary := Dictionary new.
			oldDict keysAndValuesDo: [ : k : v |
				valueDictionary at: k put: v
			].
		].
!

clone

	^ self copy beClone
! !

!TfForm methodsFor:'private'!

submitRequest

	self submitted: true.
	url := self documentModel resolveURL: self actionURL.
	self documentModel browserWindowModel navigationModel submit: self
!

valueDictionary

	valueDictionary isNil
		ifTrue: [ valueDictionary := Dictionary new ].
	^ valueDictionary
! !

!TfForm methodsFor:'submit'!

submit

	self method = #get
		ifTrue: [ ^ self submitRequest ].
	self method = #post
		ifTrue: [ ^ self submitRequest ].
	Log logWarning: 'Cannot submit form, method ', self method printString, ' not supported'.
! !

!TfForm class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfForm.st,v 1.1 2009/10/01 18:32:19 cg Exp $'
! !
