"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfURLDescriptor subclass:#TfFormDescriptor
	instanceVariableNames:'form'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Base'
!


!TfFormDescriptor class methodsFor:'instance creation'!

form: aTfForm

	^ (self url: aTfForm url)
		form: aTfForm;
		yourself
! !

!TfFormDescriptor methodsFor:'accessing'!

form

	^ form
!

form: aTfForm

	form := aTfForm
! !

!TfFormDescriptor methodsFor:'comparing'!

= anotherDescriptor

	^ super = anotherDescriptor
		and: [ self form = anotherDescriptor form ]
! !

!TfFormDescriptor methodsFor:'printing'!

printOn: aStream

	self form notNil
		ifTrue: [
			aStream nextPutAll: self form method printString.
			aStream nextPut: Character space.
		].
	self url printOn: aStream.
! !

!TfFormDescriptor methodsFor:'resources'!

loadResourceFor: aTfResourceManager

	^ aTfResourceManager
		loadResourceFromMimeEntity: (self tfMimeEntityFor:  aTfResourceManager)
		descriptor: self
!

tfMimeEntityFor: aTfResourceManager

        | queryData |
        self url: self form url.        
        queryData := self form encodedData contents.
        ^ self form method = #get
                ifTrue: [
                        self url query: queryData.
                        (self url tfNewClientFor: aTfResourceManager) getDescriptor: self
                ]
                ifFalse: [
                        self form method = #post
                                ifTrue: [
                                        (self url tfNewClientFor: aTfResourceManager) postDescriptor: self contents: queryData.
                                ]
                ]
! !

!TfFormDescriptor class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfFormDescriptor.st,v 1.1 2009/10/01 18:05:03 cg Exp $'
! !
