"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfElement subclass:#TfFormElement
	instanceVariableNames:'form'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfFormElement class methodsFor:'accessing'!

elementsToCloseClasses
	" returns the classes of all elements that must be closed before
	opening elements of me "
	
	^ Array with: self
!

tagNames

	^ #('form')
! !

!TfFormElement methodsFor:'accessing'!

actionURL

	^ self valueOfAttribute: 'action'
!

addedToDocument: aTfDocument

	| visibleTextInputs |
	self form documentModel: aTfDocument documentModel.
	visibleTextInputs := self formParts select: [ : p | p isTextInputElement ].
	visibleTextInputs size = 1
		ifTrue: [ visibleTextInputs do: [ : el | el autoSubmit: true ]].
!

charsets

	| s |
	s := self valueOfAttribute: 'accept-charset'.
	^ s notNil
		ifTrue: [ 	s tfAsStringsSeperatedByAll: ', ' ]
		ifFalse: [ nil ]
!

encoding

	^ self valueOfAttribute: 'enctype'
!

form

	form isNil
		ifTrue: [ 
			form := TfForm new.
			form 
				encoding: self encoding;
				actionURL: self actionURL;
				method: self method.
		].
	^ form
!

formParts

	| formParts |
	formParts := OrderedCollection new.
	self nodesDo: [ : n |
		n tfIsFormPart
			ifTrue: [ formParts add: n ].	
	].
	^ formParts
!

method

	^ self symbolValueOfAttribute: 'method' ifAbsent: [ #get ]
!

targetFrame

	^ self valueOfAttribute: 'target'
!

tfFormElement
	" me!! me!! me!! "

	^ self
! !

!TfFormElement methodsFor:'views'!

tfViewClass
	" returns the default composite view class for this element "

	^ TfFormView
! !

!TfFormElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfFormElement.st,v 1.1 2009/10/01 18:32:33 cg Exp $'
! !
