"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfFormWidgetElement subclass:#TfFormInputElement
	instanceVariableNames:'autoSubmit'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfFormInputElement class methodsFor:'accessing'!

allowedChildElements
	" poor man's DTD. return all allowed child elements, or nil if any element is allowed "
	
	^ #()
!

allowsPCData
	
	^ false
!

tagNames 

 	^ #('input')
! !

!TfFormInputElement methodsFor:'accessing'!

addToForm: aTfForm

	(self name notNil and: [ self value notNil ])
		ifTrue: [ aTfForm valueAt: self name put: self value ].
!

autoSubmit
	" true if the form should be submitted after entering data "

	^ autoSubmit == true
!

autoSubmit: aBoolean
	" true if the form should be submitted after entering data "

	autoSubmit := aBoolean
!

textMaxLength

	^ self integerValueOfAttribute: 'maxlength'
!

textSize

	^ self integerValueOfAttribute: 'size'
!

type

	^ self symbolValueOfAttribute: 'type'
!

value

	^ self valueOfAttribute: 'value'
! !

!TfFormInputElement methodsFor:'private'!

addInitialValueToForm: aTfForm 

	(self isTextInputElement or: [ self type = #hidden or: [ self type = #radio and: [ self isAttributeSet: 'checked' ]]])
		ifTrue: [ self addToForm: aTfForm ].
! !

!TfFormInputElement methodsFor:'testing'!

isTextInputElement

	^ self type isNil or: [ self type = #text ]
! !

!TfFormInputElement methodsFor:'views'!

canvasClass

	self isTextInputElement
		ifTrue: [ ^ TfFormInputFieldApp ].
	(#(button submit) includes: self type)
		ifTrue: [ ^ TfFormButtonApp ].
	self type = #radio
		ifTrue: [ ^ TfFormRadioButtonApp ].
	^ nil
! !

!TfFormInputElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfFormInputElement.st,v 1.1 2009/10/01 18:33:39 cg Exp $'
! !
