"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfFormWidgetApp subclass:#TfFormInputFieldApp
	instanceVariableNames:'inputAspect initialValue enableSubmit'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfFormInputFieldApp class methodsFor:'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#{Graphics.Rectangle} 640 480 1043 680 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 0 0 0 1 0 1 ) 
					#name: #inputID 
					#model: #inputAspect 
					#callbacksSpec: 
					#(#{UI.UIEventCallbackSubSpec} 
						#valueChangeSelector: #inputChanged ) ) ) ) )
! !

!TfFormInputFieldApp methodsFor:'accessing'!

preferredExtentFor: renderContext

	| charExtent width textSize |
	charExtent := self defaultCharExtentFor: renderContext.
	textSize := self xmlElement textSize.
	width := textSize notNil
		ifTrue: [ charExtent x * textSize ]
		ifFalse: [ renderContext layoutContext extent x ].
	^ width@self defaultHeight  + self additionalExtent
! !

!TfFormInputFieldApp methodsFor:'aspects'!

inputAspect

	inputAspect isNil
		ifTrue: [
			inputAspect := self formValueHolder.
			initialValue := inputAspect value.
		].
	^ inputAspect
! !

!TfFormInputFieldApp methodsFor:'interface-opening'!

postBuildWith: aBuilder

	| wr |
	super postBuildWith: aBuilder.
	(wr := aBuilder componentAt: #inputID) notNil
		ifTrue: [
			wr widget controller dispatcher 
				requestFocusIn: [ enableSubmit := true. true ];
				requestFocusOut: [ enableSubmit := false. true ]
		].
! !

!TfFormInputFieldApp methodsFor:'notification'!

inputChanged

	(self enableSubmit and: [ initialValue ~= self inputAspect value and: [ self xmlElement autoSubmit ]])
		ifTrue: [ self submit ].
! !

!TfFormInputFieldApp methodsFor:'private'!

defaultCharExtentFor: renderContext

	| font height width |
	font := renderContext fontForTextAttributes: self textAttributes.
	height := font ascent + font descent.
	width := (font widthOf: $w).
	^ width@height
!

enableSubmit

	^ enableSubmit == true
!

textAttributes
	" Text style of the widget "

	^ TextAttributes default
! !

!TfFormInputFieldApp class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfFormInputFieldApp.st,v 1.1 2009/10/01 19:40:37 cg Exp $'
! !
