"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfFormWidgetApp subclass:#TfFormSelectionListApp
	instanceVariableNames:'listAspect options selections'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfFormSelectionListApp class methodsFor:'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#{Graphics.Rectangle} 640 480 1043 680 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.SequenceViewSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 0 0 0 1 0 1 ) 
					#name: #listID 
					#model: #listAspect 
					#useModifierKeys: true 
					#selectionType: #highlight ) ) ) )
! !

!TfFormSelectionListApp methodsFor:'accessing'!

preferredExtentFor: renderContext

	| lineGrid tstyle width |
	tstyle := self styleContext textStyle.
	lineGrid := tstyle lineGrid.
	width := self options inject: 0 into: [ : w : string | w max: (Label with: string attributes: tstyle) width ].
	^ width@(self xmlElement listSize * lineGrid) + self additionalExtent
! !

!TfFormSelectionListApp methodsFor:'aspects'!

listAspect

	listAspect isNil
		ifTrue:[ self initializeListAspect ].
	^ listAspect
! !

!TfFormSelectionListApp methodsFor:'notification'!

inputChanged

	| sel |
	(sel := self listAspect selection) notNil
		ifTrue: [ self form valueAt: self xmlElement name put: sel ].
! !

!TfFormSelectionListApp methodsFor:'private'!

initializeListAspect
	
	listAspect := SelectionInList new.
	listAspect selectionIndexHolder onChangeSend: #inputChanged to: self.
	listAspect list: self options.
	self setSelections: self selections.
	^  listAspect
!

initializeOptions
	
	options := List new.
	selections := Set new.
	self xmlElement optionElements do: [ : option | | val |
		options add: (val := option optionString).
		option isSelected ifTrue: [ selections add: val ].
	].
!

options

	options isNil
		ifTrue: [ self initializeOptions ].
	^ options
!

selections

	selections isNil
		ifTrue: [ self initializeOptions ].
	^ selections
!

setSelections: someSelections

	someSelections
		detect: [ : sel |
			listAspect selection: sel.
			true ]
		ifNone: [ nil ].
! !

!TfFormSelectionListApp class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfFormSelectionListApp.st,v 1.1 2009/10/01 19:41:26 cg Exp $'
! !
