"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfFormWidgetElement subclass:#TfFormTextAreaElement
	instanceVariableNames:'initialValue'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfFormTextAreaElement class methodsFor:'accessing'!

allowsPCData
	
	^ true
!

tagNames 

 	^ #('textarea')
! !

!TfFormTextAreaElement methodsFor:'accessing'!

addInitialValueToForm: aTfForm 

	self addToForm: aTfForm
!

addToForm: aTfForm

	| t |
	(self name notNil and: [ (t := self initialValue) notNil ])
		ifTrue: [ aTfForm valueAt: self name put: t ].
!

canvasClass

	^ TfFormTextAreaApp
!

initialValue

	| str |
	initialValue isNil
		ifTrue: [
			str := (String new: 64) writeStream.
			self elements do: [ : el |
				el printNoIndentOn: str endSpacing: [:node :list | ] spacing: [:node :list | ]
			].
			initialValue := str contents tfTrimSpace.
			" ouch!! "
			initialValue := initialValue copyReplaceAll: '&amp;' with: '&'.
			initialValue := initialValue copyReplaceAll: '&lt;' with: '<'.
			initialValue := initialValue copyReplaceAll: '&gt;' with: '>'.
		].
	^ initialValue
!

numberOfColumns

	^ self integerValueOfAttribute: 'cols'
!

numberOfRows

	^ self integerValueOfAttribute: 'rows'
!

readOnly

	^ self isAttributeSet: 'readonly'
!

tfComponents

	^ #()
! !

!TfFormTextAreaElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfFormTextAreaElement.st,v 1.1 2009/10/01 18:34:09 cg Exp $'
! !
