"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

InspectorView subclass:#TfHTMLParserInspector
	instanceVariableNames:'textAspect sizeAspect'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Tools-Trippy'
!


!TfHTMLParserInspector class methodsFor:'accessing'!

tabLabel

	^'&Stream'
! !

!TfHTMLParserInspector class methodsFor:'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'DOM' 
			#bounds: #(#{Graphics.Rectangle} 640 480 1108 765 ) 
			#isEventDriven: true ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.TextEditorSpec} 
					#layout: #(#{Graphics.LayoutFrame} 3 0 3 0 -25 1 -3 1 ) 
					#name: #TextEditor1 
					#model: #textAspect 
					#tabRequiresControl: true ) 
				#(#{UI.SliderSpec} 
					#layout: #(#{Graphics.LayoutFrame} -25 1 3 0 -3 1 -3 1 ) 
					#name: #Slider1 
					#model: #sizeAspect 
					#orientation: #vertical 
					#start: 50 
					#stop: 500 
					#step: 5 ) ) ) )
! !

!TfHTMLParserInspector methodsFor:'aspects'!

sizeAspect

	sizeAspect isNil
		ifTrue: [
			sizeAspect := 50 asValue.
			sizeAspect onChangeSend: #updateText to: self
		].
	^ sizeAspect
!

textAspect

	textAspect isNil
		ifTrue:[
				textAspect := Core.Text new asValue.
				self updateText.
		].
	^ textAspect
! !

!TfHTMLParserInspector methodsFor:'private'!

refresh

	self updateText.
!

updateText

	| t |
	t := self object sourceWrapper stream tfDebugStringOfSize: self sizeAspect value.
	self textAspect value: t.
! !

!TfHTMLParserInspector class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfHTMLParserInspector.st,v 1.1 2009/10/01 23:52:31 cg Exp $'
! !
