"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfHTMLValueReader
	instanceVariableNames:'colorDictionary'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!

TfHTMLValueReader class instanceVariableNames:'singleton'

"
 No other class instance variables are inherited by this class.
"
!


!TfHTMLValueReader class methodsFor:'singleton'!

flushSingleton

	singleton := nil.
!

obsolete

	self flushSingleton.
	super obsolete.
!

singleton

	singleton isNil
		ifTrue: [ singleton := self new ].
	^ singleton
! !

!TfHTMLValueReader methodsFor:'accessing'!

fontBaseSize

	^ 18
! !

!TfHTMLValueReader methodsFor:'colors'!

initializeDefaultColors

	| predefinedColors |
	predefinedColors := self predefinedColors.
	1 to: predefinedColors size -1 by: 2 do: [ :i |
		colorDictionary
			at: (predefinedColors at: i)
			put: (ColorValue tfFromHTMLHex: (predefinedColors at: i + 1))
	].
!

predefinedColors

	^ 
" HTML 3.2"
#('black' '#000000' 'gray' '#808080' 'maroon' '#800000' 'red' '#FF0000' 'green' '#008000' 'lime' '#00FF00' 'olive' '#808000' 'yellow' '#FFFF00' 'navy' '#000080' 'blue' '#0000FF' 'purple' '#800080' 'fuchsia' '#FF00FF' 'teal' '#008080' 'aqua' '#00FFFF' 'silver' '#C0C0C0' 'white' '#FFFFFF' 
" Netscape "
'aliceblue' '#F0F8FF' 'antiquewhite' '#FAEBD7' 'aquamarine' '#7FFFD4' 'azure' '#F0FFFF' 'beige' '#F5F5DC' 'blueviolet' '#8A2BE2' 'brown' '#A52A2A' 'burlywood' '#DEB887' 'cadetblue' '#5F9EA0' 'chartreuse' '#7FFF00' 'chocolate' '#D2691E' 'coral' '#FF7F50' 'cornflowerblue' '#6495ED' 'cornsilk' '#FFF8DC' 'crimson' '#DC143C' 'darkblue' '#00008B' 'darkcyan' '#008B8B' 'darkgoldenrod' '#B8860B' 'darkgray' '#A9A9A9' 'darkgreen' '#006400' 'darkkhaki' '#BDB76B' 'darkmagenta' '#8B008B' 'darkolivegreen' '#556B2F' 'darkorange' '#FF8C00' 'darkorchid' '#9932CC' 'darkred' '#8B0000' 'darksalmon' '#E9967A' 'darkseagreen' '#8FBC8F' 'darkslateblue' '#483D8B' 'darkslategray' '#2F4F4F' 'darkturquoise' '#00CED1' 'darkviolet' '#9400D3' 'deeppink' '#FF1493' 'deepskyblue' '#00BFFF' 'dimgray' '#696969' 'dodgerblue' '#1E90FF' 'firebrick' '#B22222' 'floralwhite' '#FFFAF0' 'forestgreen' '#228B22' 'gainsboro' '#DCDCDC' 'ghostwhite' '#F8F8FF' 'gold' '#FFD700' 'goldenrod' '#DAA520' 'greenyellow' '#ADFF2F' 'honeydew' '#F0FFF0' 'hotpink' '#FF69B4' 'indianred' '#CD5C5C' 'indigo' '#4B0082' 'ivory' '#FFFFF0' 'khaki' '#F0E68C' 'lavender' '#E6E6FA' 'lavenderblush' '#FFF0F5' 'lawngreen' '#7CFC00' 'lemonchiffon' '#FFFACD' 'lightblue' '#ADD8E6' 'lightcoral' '#F08080' 'lightcyan' '#E0FFFF' 'lightgoldenrodyellow' '#FAFAD2' 'lightgreen' '#90EE90' 'lightgrey' '#D3D3D3' 'lightpink' '#FFB6C1' 'lightsalmon' '#FFA07A' 'lightseagreen' '#20B2AA' 'lightskyblue' '#87CEFA' 'lightslategray' '#778899' 'lightsteelblue' '#B0C4DE' 'lightyellow' '#FFFFE0' 'limegreen' '#32CD32' 'linen' '#FAF0E6' 'mediumaquamarine' '#66CDAA' 'mediumblue' '#0000CD' 'mediumorchid' '#BA55D3' 'mediumpurple' '#9370DB' 'mediumseagreen' '#3CB371' 'mediumslateblue' '#7B68EE' 'mediumspringgreen' '#00FA9A' 'mediumturquoise' '#48D1CC' 'mediumvioletred' '#C71585' 'midnightblue' '#191970' 'mintcream' '#F5FFFA' 'mistyrose' '#FFE4E1' 'moccasin' '#FFE4B5' 'navajowhite' '#FFDEAD' 'oldlace' '#FDF5E6' 'olivedrab' '#6B8E23' 'orange' '#FFA500' 'orangered' '#FF4500' 'orchid' '#DA70D6' 'palegoldenrod' '#EEE8AA' 'palegreen' '#98FB98' 'paleturquoise' '#AFEEEE' 'palevioletred' '#DB7093' 'papayawhip' '#FFEFD5' 'peachpuff' '#FFDAB9' 'peru' '#CD853F' 'pink' '#FFC0CB' 'plum' '#DDA0DD' 'powderblue' '#B0E0E6' 'rosybrown' '#BC8F8F' 'royalblue' '#4169E1' 'saddlebrown' '#8B4513' 'salmon' '#FA8072' 'sandybrown' '#F4A460' 'seagreen' '#2E8B57' 'seashell' '#FFF5EE' 'sienna' '#A0522D' 'skyblue' '#87CEEB' 'slateblue' '#6A5ACD' 'slategray' '#708090' 'snow' '#FFFAFA' 'springgreen' '#00FF7F' 'steelblue' '#4682B4' 'tan' '#D2B48C' 'thistle' '#D8BFD8' 'tomato' '#FF6347' 'turquoise' '#40E0D0' 'violet' '#EE82EE' 'wheat' '#F5DEB3' 'whitesmoke' '#F5F5F5' 'yellowgreen')
! !

!TfHTMLValueReader methodsFor:'parsing'!

parseCSSFontSize: attributeValue
	" numerical value with unit (e.g. 12pt) or name (e.g. 'small') "

	| val str numValue unit int |
	val := attributeValue trimBlanks.
	str := val readStream.
	numValue := Float readFrom: str.
	^ numValue > 0
		ifTrue: [ 
			unit := str upToEnd.
			self createFontSizeLayout: numValue unit: unit
		] ifFalse: [ 
			int := numValue rounded.
			int <= TfFontSizeDictionaryLayout maxFontSize
				ifTrue: [ 	TfFontSizeDictionaryLayout fontSize: int ]
				ifFalse: [ TfFixedSizeLayout pixelSize: int ]
		].
!

parseColor: attributeValue
	" HexValue (e.g. #FFDD00) "

	| color colValue |
	colValue := attributeValue trimBlanks.
	colValue isEmpty
		ifTrue: [ ^ nil ].
	colValue first = $# 
		ifTrue: [ ^ ColorValue tfFromHTMLHex: colValue ].
	(color := self colorDictionary at: colValue asLowercase ifAbsent: [nil]) notNil
		ifTrue: [ ^ color ].
	colValue size = 6
		ifTrue: [ ^ ColorValue tfFromHTMLHex: colValue ].
	^ nil.
!

parseFontNames: attributeValue
	" attributeValue: comma separated font names "

	| fontNames str |
	fontNames := OrderedCollection new.
	str := attributeValue readStream.
	[ str atEnd ] whileFalse: [
		fontNames add: (str upTo: $,) trimBlanks
	].
	^ fontNames
!

parseFontSize: attributeValue
	" absolute (e.g. 5) or delta (e.g. +2) "

	| val int |
	val := attributeValue trimBlanks.
	int := self parseInteger: val.
	^ ((val first = $+) or: [ val first = $- ])
		ifTrue: [
			TfDeltaSizeLayout delta: int * 4.
		] ifFalse:[
			TfFontSizeDictionaryLayout fontSize: int
		].
!

parseInteger: attributeValue

	| str ch |
	str := (attributeValue copyWithout: Character space) readStream.
	ch := str peek.
	ch = $+
		ifTrue: [ str next ].
	^  Integer readFrom: str.
!

parseTableWidth: attributeValue 
	" absolute (e.g. 100) or relative (e.g. 60%) "

	| str width ch |
	str := attributeValue trimBlanks readStream.
	width := Integer readFrom: str.
	width := width max: 0.
	ch := str next.
	^ ch = $%
		ifTrue: [
			width := width min: 100.
			TfScaledSizeLayout sizeFactor: width / 100 ]
		ifFalse: [
			ch = $*
				ifTrue: [ TfFactorScaledSizeLayout sizeFactor: width ]
				ifFalse: [ TfFixedSizeLayout pixelSize: width ]]
!

parseValuePairs: aString separatedBy: sepChar
	" aString is a simicolon-separated list of value pairs.
	Keys and values are separated by sepChar.
	returns a set of associations "

	| str assocs |
	str := aString readStream.
	assocs := Set new.
	[ str atEnd ] whileFalse: [ | valuePair |
		valuePair := (str upTo: $;) trimBlanks.
		assocs add: (valuePair tfAsAssociation: sepChar).
	].
	^ assocs
! !

!TfHTMLValueReader methodsFor:'private'!

colorDictionary

	colorDictionary isNil
		ifTrue: [
			colorDictionary := Dictionary new.
			self initializeDefaultColors.
		].
	^ colorDictionary
!

createFontSizeLayout: numValue unit: unitName

	^ TfFixedSizeLayout pixelSize: numValue
!

skipSpacesIn: readStream

	[ readStream peek = Character space ] whileTrue: [ readStream next ].
! !

!TfHTMLValueReader class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfHTMLValueReader.st,v 1.1 2009/10/01 18:39:34 cg Exp $'
! !
