"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfView subclass:#TfHrView
	instanceVariableNames:'rectangle'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfHrView methodsFor:'displaying'!

displayElementOn: aGraphicsContext

	self rectangle notNil
		ifTrue: [
			aGraphicsContext paint: ColorValue gray.
			self rectangle displayStrokedOn: aGraphicsContext
		].
! !

!TfHrView methodsFor:'private'!

lineHeight

	^ 2
!

lineInset

	^ 3
!

lineSpacing

	^ 10
!

preferredHeight

	^ self lineHeight + (2 * self lineSpacing)
!

rectangle

	^ rectangle
! !

!TfHrView methodsFor:'rendering'!

setupRendering: renderContext
	" prepare the view for rendering "

	| box |
	" compute bounds and border rectangle "
	super setupRendering: renderContext.
	renderContext layoutContext nextLine.
	self tfLocalTranslation: renderContext layoutContext position.
	box := renderContext layoutContext bounds.
	preferredBounds := 0@0 corner: box right@self preferredHeight.
	preferredBounds := preferredBounds insetBy: self lineInset@0.
	renderContext layoutContext translatePositionBy: 0@preferredBounds bottom.
	rectangle := preferredBounds insetBy: 0@self lineSpacing.
! !

!TfHrView class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfHrView.st,v 1.1 2009/10/01 19:41:58 cg Exp $'
! !
