"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Net::HttpBuildHandler subclass:#TfHttpBuildHandler
	instanceVariableNames:'resourceManager urlDescriptor download'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Resources'
!


!TfHttpBuildHandler methodsFor:'action callbacks'!

endBody: aBody

	^ download notNil
		ifTrue: [
			download completed.
			true
		] ifFalse: [
			super endBody: aBody
		].
!

startBody: aMessageBody
	" check if the entity should be downloaded "

	| ok |
	ok := super startBody: aMessageBody.
	(ok and: [ self resourceManager notNil and: [ aMessageBody isSimple and: [self useSourceStream not]]]) 
		ifTrue: [
			download := self resourceManager 
								downloadEntityIfNeeded: self entity 
								from: urlDescriptor.
			download notNil
				ifTrue:[ aMessageBody source: download stream ].
		].
	^ ok
! !

!TfHttpBuildHandler methodsFor:'private'!

resourceManager

	^ resourceManager
! !

!TfHttpBuildHandler methodsFor:'tasks'!

parse: aMimeEntity from: rfc822Scanner for: aTfHttpClient

	resourceManager := aTfHttpClient resourceManager.
	urlDescriptor := aTfHttpClient urlDescriptor.
	self context at: #resourceManager put: aTfHttpClient resourceManager.
	^ self parse: aMimeEntity from: rfc822Scanner
! !

!TfHttpBuildHandler class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfHttpBuildHandler.st,v 1.1 2009/10/01 23:55:33 cg Exp $'
! !
