"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Net::HttpClient subclass:#TfHttpClient
	instanceVariableNames:'resourceManager urlDescriptor'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower'
!


!TfHttpClient methodsFor:'accessing'!

finalURL
	" the request may have been redirected "

	^ request url
!

getDescriptor: aTfURLDescriptor

	urlDescriptor := aTfURLDescriptor.
	^ self get: aTfURLDescriptor url
!

postDescriptor: aTfURLDescriptor contents: aString

	urlDescriptor := aTfURLDescriptor.
	^ self post: aTfURLDescriptor url contents: aString
!

resourceManager

	^ resourceManager
!

resourceManager: aTfResourceManager

	resourceManager := aTfResourceManager
!

urlDescriptor

	^ urlDescriptor
!

urlDescriptor: aTfURLDescriptor

	urlDescriptor := aTfURLDescriptor
! !

!TfHttpClient methodsFor:'private'!

getResponse: aConnection

	| resp stream |
	^[stream := self getResponseStream.  
	resp := request headerOnly
		ifTrue: [TfHttpResponse readHeaderFrom: stream ]
		ifFalse: 	[TfHttpResponse 
					readFrom: stream 
					url: request requestLine url
					urlDescriptor: urlDescriptor
					resourceManager: self resourceManager ].
	resp log. 
	(resp connection notNil and: [resp isConnectionClose ]) 
		ifTrue: [ self close]. 
	 HttpException handleResponse: resp
	] on: HttpException
	 do:  [ :ex | 
		(resp := self handleResponseException: ex ) isNil 
			ifTrue: [ ex pass]
			ifFalse: [ resp ]].
!

safelyExecuteBlock: aBlock

	^[	| stream result |
		Log logDebug: ['Waiting for connection: ', request url asString].
		stream := self getConnectionStream.
		Log logDebug: ['Performing request: ', request url asString].
		result := aBlock value: stream.
		Log logDebug: ['Done request: ', request url asString].
		result
	] ensure: [
		self keepAlive ifFalse: [ self disconnect ]
	]
! !

!TfHttpClient class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfHttpClient.st,v 1.1 2009/10/01 18:00:13 cg Exp $'
! !
