"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfSidebarPanel subclass:#TfInspectorPanel
	instanceVariableNames:'inspector'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-UIApplications-New'
!


!TfInspectorPanel class methodsFor:'accessing'!

description

	^ 'Inspector'
! !

!TfInspectorPanel class methodsFor:'interface specs'!

windowSpec
        "Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 'Inspector' 
                        #bounds: #(#Rectangle 640 512 840 712 ) ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#SubCanvasSpec 
                                        #layout: #(#LayoutFrame 0 0 0 0 0 1 0 1 ) 
                                        #name: #inspectorID ) ) ) )
! !

!TfInspectorPanel methodsFor:'initialize-release'!

startUp

	super startUp.
	self browserModel when: #activeBrowserWindowModel send: #changedBrowserWindowModel: to: self.
! !

!TfInspectorPanel methodsFor:'interface opening'!

postBuildWith: aBuilder

	super postBuildWith: aBuilder.
	self changedBrowserWindowModel: self browserModel activeBrowserWindowModel.
! !

!TfInspectorPanel methodsFor:'notification'!

changedBrowserWindowModel: aBrowserWindowModel

	aBrowserWindowModel when: #resourceModelChanged send: #updateInspector to: self.
	self updateInspector.
! !

!TfInspectorPanel methodsFor:'private'!

updateInspector

	| bwm rm |
	(bwm := self browserModel activeBrowserWindowModel) isNil ifTrue: [^ self ].
	(rm := bwm resourceModel) isNil ifTrue: [^ self ].
	(inspector := rm sidebarInspector) isNil ifTrue: [^ self ].

	(self builder componentAt: #inspectorID) widget
		client: inspector key 
		spec: inspector value
		builder: self builder newSubBuilder.
! !

!TfInspectorPanel class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfInspectorPanel.st,v 1.1 2009/10/01 23:43:33 cg Exp $'
! !
