"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

URLwithPath subclass:#TfInternalURL
	instanceVariableNames:'hostClass methodSelector arguments'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Base'
!


!TfInternalURL class methodsFor:'accessing'!

protocol

	^'twoflower'
! !

!TfInternalURL methodsFor:'accesing'!

arguments

	arguments isNil
		ifTrue: [	
			arguments := (self path isEmpty not and: [ self path last isEmpty ])
				ifTrue: [ self path copyFrom: 1 to: self path size - 1  ]
				ifFalse: [ self path ].
			arguments := arguments asArray
		]. 
	^ arguments
!

asString

	| str host |
	str := (String new: 64) writeStream.
	str nextPutAll: self class protocol, '://'.
	host := (self hostClass isNil or: [ self hostClass = TfResources ])
		ifTrue: [ 'twoflower' ]
		ifFalse: [ self hostClass fullName ].
	str nextPutAll: host.
	self methodSelector notNil
		ifTrue: [
			str nextPut: $~.
			str nextPutAll: self methodSelector asString.
			str nextPut: $/.
			self path
				do: [ :p | str nextPutAll: p ]
				separatedBy: [ str nextPut: $/ ].
		].
	^ str contents
!

execute

	^ self hostClass perform: self methodSelector withArguments: self arguments
!

hostClass

	^ hostClass
!

loadResourceFor: aTfResourceManager descriptor: urlDescriptor

	^ self tfDirectResource
!

methodSelector

	^ methodSelector
!

tfDirectResource

	| res |
	res := self execute.
	^ res notNil
		ifTrue: [ res tfAsResourceModel ]
		ifFalse: [ nil ]
!

tfMimeEntityFor: aTfResourceManager

	^ nil
! !

!TfInternalURL methodsFor:'initialize'!

parseHost: aHostSpecification

	| str className methodName |
	str := aHostSpecification readStream.
	className := str upTo: $~ .
	className asLowercase = 'twoflower'
		ifTrue: [ hostClass := TfResources ]
		ifFalse: [
			(QualifiedName pathString: className)
				ifDefinedDo: [ :cl | 
					hostClass := cl.
		]].
	methodName := str upToEnd.
	methodName isEmpty
		ifFalse: [ methodSelector := methodName asSymbol ]
! !

!TfInternalURL methodsFor:'stream creation'!

readStream

	| string |
	string := [
		 self execute
	] on: Error do: [ :ex |
		TfResources internalError: ex internalURL: self
	].
	^ string readStream
! !

!TfInternalURL class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfInternalURL.st,v 1.1 2009/10/01 18:05:29 cg Exp $'
! !
