"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfLinkedContext
	instanceVariableNames:'parentContext renderContext'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfLinkedContext class methodsFor:'instance creation'!

new

	^ super new initialize
! !

!TfLinkedContext methodsFor:'accessing'!

parentContext

	^ parentContext
!

parentContext: aTfLinkedContext

	parentContext := aTfLinkedContext
!

renderContext

	^ renderContext
!

renderContext: aTfRenderContext

	renderContext := aTfRenderContext
!

rootContext

	^ self parentContext notNil
		ifTrue: [ self parentContext rootContext ]
		ifFalse: [ self ].
!

selfOrInherited: aBlock

	| val |
	val := aBlock value: self.
	^ val notNil
		ifTrue: [ val ]
		ifFalse: [
			self parentContext notNil
				ifTrue: [ self parentContext selfOrInherited: aBlock ]
				ifFalse: [ nil ]
		]
! !

!TfLinkedContext methodsFor:'genetic stuff'!

beClone
!

clone

	^ self copy beClone
!

cloneChild

	| clone |
	clone := self copy beClone.
	clone parentContext: self.
	^ clone
!

createChildContext

	| childContext |
	childContext := self species new.
	childContext
		renderContext: self renderContext;
		parentContext: self.
	^ childContext
! !

!TfLinkedContext methodsFor:'initialize-release'!

initialize
! !

!TfLinkedContext class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfLinkedContext.st,v 1.1 2009/10/01 18:43:58 cg Exp $'
! !
