"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfListItemView subclass:#TfListItemBulletView
	instanceVariableNames:'bulletImage'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfListItemBulletView methodsFor:'accessing'!

bulletAscent

	^ self bulletImage extent y
!

bulletDescent

	^ 0
!

bulletImage

	^ bulletImage
! !

!TfListItemBulletView methodsFor:'displaying'!

displayDecoratorOn: aGraphicsContext

	| color |
	(color := self style fontStyle color) notNil
		ifTrue: [ aGraphicsContext paint: color ].
	self bulletImage displayOn: aGraphicsContext at: self bulletOffset.
! !

!TfListItemBulletView methodsFor:'private'!

bulletType

	| bulletType lc |
	bulletType := self style listStyle bulletType.
	bulletType isNil
		ifTrue: [
			lc := self listContainer.
			bulletType := lc notNil
				ifTrue: [	lc style listStyle bulletType ]
				ifFalse: [ self defaultBulletType ].
		].
	^ bulletType
!

defaultBulletType

	^ #circle
! !

!TfListItemBulletView methodsFor:'rendering'!

adaptTo: aRectangle ascent: maxAscent descent: maxDescent

	bulletOffset := self bulletOffset + (0@(maxAscent - self bulletAscent))
!

setupBulletFor: renderContext

	| bulletType imageSelector |
	bulletType := self bulletType.
	imageSelector := renderContext layoutContext listLevel > 1
		ifTrue: [ 
			bulletType = #square
				ifTrue: [ #bulletStrokedSquare ]
				ifFalse: [ #bulletStrokedCircle ].
		] ifFalse: [ 
			bulletType = #square
				ifTrue: [ #bulletFilledSquare ]
				ifFalse: [ #bulletFilledCircle ].
		].
	bulletImage := TfIconLibrary visualFor: imageSelector
! !

!TfListItemBulletView class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfListItemBulletView.st,v 1.1 2009/10/01 19:42:37 cg Exp $'
! !
