"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfElement subclass:#TfListItemElement
	instanceVariableNames:'bulletType itemIndex'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfListItemElement class methodsFor:'As yet unclassified'!

elementsToCloseStopClasses
	
	^ TfAbstractListElement allSubclasses
! !

!TfListItemElement class methodsFor:'accessing'!

elementsToCloseClasses
	
	^ Array
		with: self
!

remarks

	^ '<i>type</i> only supports <i>square</i> and <i>circle</i>'
!

supportedAttributes

	^ #('type')
!

tagNames

	^ #('li')
! !

!TfListItemElement methodsFor:'accessing'!

itemIndex
	" index of this item within the parent list "

	^ itemIndex
!

tfEnumerateListItem: index of: listElement

	itemIndex := index.
	^ index + 1
! !

!TfListItemElement methodsFor:'parsing'!

parseValues

	super parseValues.
	bulletType := self symbolValueOfAttribute: 'type'.
! !

!TfListItemElement methodsFor:'styles'!

applyListStyleTo: aTfStyle

	bulletType notNil
		ifTrue: [ aTfStyle listStyle bulletType: bulletType]
!

modifyStyle: aTfStyle
	" modify the style according to the local style definitions "

	super modifyStyle: aTfStyle.
	self applyListStyleTo: aTfStyle.
! !

!TfListItemElement methodsFor:'views'!

tfViewClass

	| list |
	^ ((list := self listElement) notNil and: [ list isNumbered ])
		ifTrue: [ TfListItemNumberView ]
		ifFalse: [ TfListItemBulletView ]
! !

!TfListItemElement class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfListItemElement.st,v 1.1 2009/10/01 18:44:11 cg Exp $'
! !
