"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfCompositeElementView subclass:#TfListItemView
	instanceVariableNames:'bulletOffset bulletExtent font origin'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfListItemView methodsFor:'accessing'!

bulletAscent

	self subclassResponsibility
!

bulletDescent

	self subclassResponsibility
!

bulletOffset

	^ bulletOffset
!

preferredBulletHeight

	^ self bulletAscent + self bulletDescent
! !

!TfListItemView methodsFor:'bounds accessing'!

computePreferredBounds

	super computePreferredBounds.
	preferredBounds origin: origin.
	^ preferredBounds
! !

!TfListItemView methodsFor:'private'!

setupBulletFor: renderContext

	self subclassResponsibility
! !

!TfListItemView methodsFor:'rendering'!

finishParagraph: renderContext

	renderContext popBoxContext
		applyPositionToParent.
	super finishParagraph: renderContext.
!

startOwnRendering: renderContext

	| listWidth list |
	super startOwnRendering: renderContext.
	font := renderContext fontFor: self styleContext.
	self setupBulletFor: renderContext.
	listWidth := (list := self listContainer) notNil
		ifTrue: [ list listWidth ]
		ifFalse: [ renderContext layoutContext listWidth ].
	bulletExtent := listWidth@self preferredBulletHeight.
!

startParagraph: renderContext

	| bulletLayout |
	super startParagraph: renderContext.
	renderContext layoutContext forceNextLine.
	bulletOffset := renderContext boxContext position.
	origin := bulletOffset.
	bulletLayout := TfBulletLineLayout 
						for: self 
						bounds: (bulletOffset extent: bulletExtent)
						ascent: self bulletAscent
						descent: self bulletDescent.
	bulletLayout addToLayoutContext: renderContext layoutContext.
	renderContext pushBoxContext
		insetBy: (bulletExtent x@0 corner: 0@0);
		resetLine
! !

!TfListItemView class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfListItemView.st,v 1.1 2009/10/01 19:43:28 cg Exp $'
! !
