"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfMetaInfo
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfMetaInfo class methodsFor:'accessing'!

httpEquiv
	" returns the value of the http-equiv attribute mapped to this meta data class "

	^ nil
!

metaInfoFor: httpEquivValue element: metaElement

	| metaInfoClass |
	metaInfoClass := self metaInfoClassFor: httpEquivValue.
	^ metaInfoClass notNil
		ifTrue: [ metaInfoClass new readFromElement: metaElement ]
		ifFalse: [ nil ]
! !

!TfMetaInfo class methodsFor:'private'!

metaInfoClassFor: httpEquivValue

	| val |
	val := httpEquivValue asLowercase.
	^ self allSubclasses
		detect: [ :cl | cl httpEquiv asLowercase = val ]
		ifNone: [ nil ]
! !

!TfMetaInfo methodsFor:'accessing'!

httpEquiv

	^ self class httpEquiv
! !

!TfMetaInfo methodsFor:'parsing'!

readFromContent: aString
	" initialize this object using the content string "
!

readFromElement: aTfMetaElement
	" initialize this object using the meta data element "

	| content |
	content := aTfMetaElement attributeNamed: 'content'.
	content notNil
		ifTrue: [ self readFromContent: content value ].
! !

!TfMetaInfo class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfMetaInfo.st,v 1.1 2009/10/01 18:44:49 cg Exp $'
! !
