"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfMetaInfo subclass:#TfMetaRefresh
	instanceVariableNames:'timestamp urlString seconds'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfMetaRefresh class methodsFor:'accessing'!

httpEquiv

	^ 'refresh'
! !

!TfMetaRefresh methodsFor:'accessing'!

timestamp

	^ timestamp
!

url

	^ urlString notNil
		ifTrue: [ Net.URL tfFromString: urlString ]
		ifFalse: [ nil ].
!

urlString

	^ urlString
! !

!TfMetaRefresh methodsFor:'parsing'!

readFromContent: aString
	" initialize this object using the content string "

	| str |
	str := aString readStream.
	self readTimestampFrom: str.
	self timestamp notNil
		ifTrue: [ self readURL: str ].
!

readTimestampFrom: aStream

	| s secs |
	s := aStream upTo: $;.
	s isEmpty
		ifFalse: [
			seconds := Integer readFrom: s readStream.
			seconds printString = s
				ifTrue: [ 
					secs := Timestamp now asSeconds + seconds.
					timestamp := Timestamp fromSeconds: secs
				].
		].
	timestamp isNil
		ifTrue: [ Log logDebug: [self class fullName, ': Could not read timestamp'] ].
!

readURL: aStream

	| s |
	s := aStream upToEnd trimBlanks.
	urlString := s tfValueAtKey: 'url'.
	urlString isNil
		ifTrue: [ Log logDebug: [self class fullName, ': Could not read URL' ]].
! !

!TfMetaRefresh methodsFor:'private'!

seconds

	^ seconds
! !

!TfMetaRefresh class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfMetaRefresh.st,v 1.1 2009/10/01 18:45:02 cg Exp $'
! !
