"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfEditBookmarkDialog subclass:#TfNewBookmarkDialog
	instanceVariableNames:'typeAspect folderNameAspect'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower'
!


!TfNewBookmarkDialog class methodsFor:'interface specs'!

windowSpec
    "Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

    <resource: #canvas>
    ^#(#FullSpec 
        #window: 
        #(#WindowSpec 
            #label: 
            #(#UserMessage 
                #key: #UnlabeledCanvas 
                #defaultString: 'New bookmark' 
                #catalogID: #labels ) 
            #min: #(#Point 20 20 ) 
            #max: #(#Point 1280 1024 ) 
            #bounds: #(#Rectangle 640 512 1030 740 ) ) 
        #component: 
        #(#SpecCollection 
            #collection: #(
                #(#RadioButtonSpec 
                    #layout: #(#Point 5 5 ) 
                    #name: #RadioButton1 
                    #model: #typeAspect 
                    #label: 'Bookmark:' 
                    #select: #bookmark ) 
                #(#SubCanvasSpec 
                    #layout: #(#LayoutFrame 30 0 30 0 0 1 100 0 ) 
                    #name: #Subcanvas1 
                    #flags: 0 
                    #minorKey: #bookmarkSpec ) 
                #(#RadioButtonSpec 
                    #layout: #(#Point 5 100 ) 
                    #name: #RadioButton2 
                    #model: #typeAspect 
                    #label: 'Folder:' 
                    #select: #folder ) 
                #(#InputFieldSpec 
                    #layout: #(#LayoutFrame 80 0 135 0 -5 1 160 0 ) 
                    #name: #InputField3 
                    #model: #folderNameAspect ) 
                #(#RadioButtonSpec 
                    #layout: #(#Point 5 175 ) 
                    #name: #RadioButton3 
                    #model: #typeAspect 
                    #label: 'Separator' 
                    #select: #separator ) 
                #(#ActionButtonSpec 
                    #layout: #(#LayoutFrame -85 1 -30 1 -5 1 -5 1 ) 
                    #name: #ActionButton1 
                    #model: #tfCancel 
                    #label: 'Cancel' 
                    #defaultable: true ) 
                #(#LabelSpec 
                    #layout: #(#Point 30 136 ) 
                    #name: #Label3 
                    #label: 'Name:' ) 
                #(#ActionButtonSpec 
                    #layout: #(#LayoutFrame -168 1 -30 1 -88 1 -5 1 ) 
                    #name: #ActionButton2 
                    #model: #tfOk 
                    #label: 'OK' 
                    #isDefault: true 
                    #defaultable: true ) ) ) )
! !

!TfNewBookmarkDialog methodsFor:'accessing'!

bookmark

	| type |
	type := self typeAspect value.
	type = #separator
		ifTrue: [ ^ TfURLSeparator new ].
	type = #folder
		ifTrue: [ ^ TfBookmarkContainer description: self folderNameAspect value ].
	^ TfURLDescriptor
		url: self urlAspect value
		description: self nameAspect value
!

canAccept

	| type |
	type := self typeAspect value.
	type = #folder
		ifTrue: [ ^ self folderNameAspect value notEmpty ].
	type = #separator
		ifTrue: [ ^ true ].
	^ super canAccept
!

editedBookmark

	| type |
	type := self typeAspect value.
	type = #separator
		ifTrue: [ ^ TfURLSeparator new ].
	type = #folder
		ifTrue: [ ^ TfBookmarkContainer description: self folderNameAspect value ].
	^ TfURLDescriptor
		url: self urlAspect value
		description: self nameAspect value
! !

!TfNewBookmarkDialog methodsFor:'aspects'!

folderNameAspect

	^folderNameAspect isNil
		ifTrue:
			[folderNameAspect := String new asValue]
		ifFalse:
			[folderNameAspect]
!

typeAspect

	^typeAspect isNil
		ifTrue:
			[typeAspect := #bookmark asValue]
		ifFalse:
			[typeAspect]
! !

!TfNewBookmarkDialog class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfNewBookmarkDialog.st,v 1.3 2009/11/07 04:03:40 cg Exp $'
! !
