"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfBookmarksReaderWriter subclass:#TfOperaBookmarksReaderWriter
	instanceVariableNames:'containerStack isInURL'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Base'
!


!TfOperaBookmarksReaderWriter class methodsFor:'accessing'!

defaultLocation

	^ 'opera6.adr'
!

description

	^ 'Opera 6'
! !

!TfOperaBookmarksReaderWriter methodsFor:'import/export'!

export: aBookmarkContainer to: aStream

	self exportHeaderFor: aBookmarkContainer to: aStream.
	aBookmarkContainer exportOperaBookmarksTo: aStream.
!

importFrom: aStream

	| bookmarks |
	containerStack := OrderedCollection new.
	bookmarks := TfBookmarkContainer description: 'Bookmarks'.
	containerStack add: bookmarks.
	isInURL := false.
	[ aStream atEnd ] whileFalse: [
		| line |
		line := aStream tfNextLine tfTrimWhitespaces.
		self processLine: line.
	].
	^ bookmarks
! !

!TfOperaBookmarksReaderWriter methodsFor:'private'!

exportHeaderFor: aBookmarkContainer to: aStream

	aStream nextPutAll: 'Opera Hotlist version 2.0
Options:encoding=utf8,version=3

'
!

finishFolder

	self finishURL.
	containerStack removeLast.
!

finishURL

	isInURL
		ifTrue: [ containerStack removeLast ].
	isInURL := false.
!

processLine: aString

	| i key value |
	aString = '-'
		ifTrue: [ ^ self finishFolder ].
	aString = '#FOLDER'
		ifTrue: [ ^ self startFolder ].
	aString = '#URL'
		ifTrue: [ ^ self startURL ].
	i := aString indexOf: $= ifAbsent: [ 0].
	(i > 1 and: [ i < aString size ])
		ifTrue: [
			key := aString copyFrom: 1 to: i - 1.
			value := aString copyFrom: i+1 to: aString size.
			containerStack last importOperaKey: key value: value
		].
!

pushURLHolder: aTfURLHolder

	| folder |
	self finishURL.
	folder := containerStack last.
	folder addBookmark: aTfURLHolder.
	containerStack add: aTfURLHolder.
!

startFolder

	self pushURLHolder: TfBookmarkContainer new.
!

startURL

	self pushURLHolder: TfURLDescriptor new.
	isInURL := true.
! !

!TfOperaBookmarksReaderWriter class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfOperaBookmarksReaderWriter.st,v 1.1 2009/10/01 18:05:46 cg Exp $'
! !
