"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfStylePart subclass:#TfParagraphStyle
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfParagraphStyle methodsFor:'accessing'!

alignFactor

	| align |
	align := self alignment.
	align = #right
		ifTrue: [ ^ 1 ].
	align = #center
		ifTrue: [ ^ 0.5 ].
	^ 0
!

alignment

	^ self propertyValueAt: #alignment
!

alignment: aSymbol
	" one of: #(#left #right #justify #center) "

	self propertyAt: #alignment putValue: aSymbol stopAt: #('table' 'body')
!

applyPendingLayouts

	^ self propertyValueAt: #applyPendingLayouts ifAbsent: [ false ]
!

applyPendingLayouts: aBoolean

	self propertyAt: #applyPendingLayouts putLocalValue: aBoolean
!

breakAfter

	^ self propertyValueAt: #breakAfter ifAbsent: [ false ]
!

breakAfter: aBoolean

	self propertyAt: #breakAfter putLocalValue: aBoolean
!

breakBefore

	^ self propertyValueAt: #breakBefore ifAbsent: [ false ]
!

breakBefore: aBoolean

	self propertyAt: #breakBefore putLocalValue: aBoolean
!

convertWhitespaces
	" true if whitespace sequences should be replaced by a single space "

	^ self propertyValueAt: #convertWhitespaces ifAbsent: [ true ]
!

convertWhitespaces: aBoolean
	" true if whitespace sequences should be replaced by a single space "

	self propertyAt: #convertWhitespaces putValue: aBoolean
!

flowAroundBoxes

	^ self propertyValueAt: #flowAroundBoxes ifAbsent: [ true ]
!

flowAroundBoxes: aBoolean

	self propertyAt: #flowAroundBoxes putLocalValue: aBoolean
!

isBox

	^ self propertyValueAt: #isBox ifAbsent: [ false ]
!

isBox: aBoolean

	self propertyAt: #isBox putLocalValue: aBoolean
!

isPreformatted

	^ self propertyValueAt: #isPreformatted ifAbsent: [ false ]
!

isPreformatted: aBoolean

	self propertyAt: #isPreformatted putValue: aBoolean
!

spacingAfter
	" Spacing between the bottom of the current paragraph
	and the top of the next paragraph "
	" ^ Integer "

	^ self propertyValueAt: #spacingAfter ifAbsent: [ 0 ]
!

spacingAfter: anInteger
	" Spacing between the bottom of the current paragraph
	and the top of the next paragraph "

	self propertyAt: #spacingAfter putLocalValue: anInteger
!

spacingBefore
	" Spacing between the bottom of the previouse paragraph
	and the top of the current paragraph "
	" ^ Integer "

	^ self propertyValueAt: #spacingBefore ifAbsent: [ 0 ]
!

spacingBefore: anInteger
	" Spacing between the bottom of the previouse paragraph
	and the top of the current paragraph "

	self propertyAt: #spacingBefore putLocalValue: anInteger
!

wrapText

	^ self propertyValueAt: #wrapText ifAbsent: [ true ]
!

wrapText: aBoolean

	self propertyAt: #wrapText putValue: aBoolean
! !

!TfParagraphStyle methodsFor:'layout'!

finishLayoutContext: aTfLayoutContext

	aTfLayoutContext isFirstParagraph: false.
	self breakAfter
		ifTrue: [
			aTfLayoutContext 
				addParagraph: self spacingAfter 
				flowAroundBoxes: self flowAroundBoxes
		].
!

finishMeasureContext: aTfLayoutContext

	(self breakAfter or: [ self isBox ])
		ifTrue: [ aTfLayoutContext measureNextLine ].
!

startLayoutContext: aTfLayoutContext

	self applyPendingLayouts
		ifTrue: [ aTfLayoutContext applyPendingLayouts ].
	self breakBefore
		ifTrue: [
			aTfLayoutContext 
				addParagraph: self spacingBefore
				flowAroundBoxes: self flowAroundBoxes
		].
!

startMeasureContext: aTfLayoutContext

	self breakBefore
		ifTrue: [ aTfLayoutContext measureNextLine ].
! !

!TfParagraphStyle class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfParagraphStyle.st,v 1.1 2009/10/01 18:46:36 cg Exp $'
! !
