"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfRenderContext
	instanceVariableNames:'layoutContextStack boxContextStack formContextStack styleContext
		documentModel textSelection graphicsDevice'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfRenderContext class methodsFor:'instance creation'!

new

	^ super new initialize
!

styleSheet: aTfStyleSheet

	^ self new
		styleSheet: aTfStyleSheet;
		yourself
! !

!TfRenderContext methodsFor:'accessing'!

boxContext

	^ self boxContextStack topOrNil
!

documentModel

	^ documentModel
!

documentModel: aTfDocumentModel

	documentModel := aTfDocumentModel
!

fontFor: aTfStyleContext
	" utility method "

	^ self fontForTextAttributes: aTfStyleContext textStyle
!

fontForTextAttributes: aTextAttributes
	" utility method "

	| fontPolicy font |
	fontPolicy := self graphicsDevice defaultFontPolicy.
	font := fontPolicy findFont: aTextAttributes defaultFont.
	^ font
!

formContext

	^ self formContextStack topOrNil
!

graphicsDevice

	graphicsDevice isNil
		ifTrue: [ graphicsDevice := Screen default ].
	^ graphicsDevice
!

graphicsDevice: aGraphicsDevice

	graphicsDevice := aGraphicsDevice
!

isForMeasuring

	^ self layoutContext isForMeasuring
!

layoutContext

	^ self layoutContextStack topOrNil
!

popBoxContext

	^ self boxContextStack pop
!

popFormContext

	^ self formContextStack pop
!

popLayoutContext

self popBoxContext.

	^ self layoutContextStack pop
!

pushBoxContext
	" ^ TfBoxContext "

	| clone |
	clone := self boxContext clone.
	self pushBoxContext: clone.
	^ clone
!

pushFormContext
	" ^ TfFormContext "

	| clone |
	clone := self formContext clone.
	self pushFormContext: clone.
	^ clone
!

pushLayoutContext
	" ^ TfLayoutContext "

	| clone |
	clone := self layoutContext clone.
	self pushLayoutContext: clone.
self pushBoxContext.
	^ clone
!

styleContext

	^ styleContext
!

styleContext: aTfStyleContext

	styleContext := aTfStyleContext
!

textSelection

	^ textSelection
!

textSelection: aTfTextSelection

	textSelection := aTfTextSelection
! !

!TfRenderContext methodsFor:'copying'!

beClone

	layoutContextStack := layoutContextStack collect: [ :context | context clone ].
	styleContext notNil ifTrue: [ styleContext := styleContext clone ].
!

clone

	^ self copy beClone
! !

!TfRenderContext methodsFor:'initialize-release'!

initialize

	self pushLayoutContext: TfLayoutContext new.
	self pushBoxContext: TfBoxContext new.
	self pushFormContext: TfFormContext new.
	self styleContext: TfStyleContext new.
	self styleContext renderContext: self.
! !

!TfRenderContext methodsFor:'private'!

boxContextStack

	boxContextStack isNil
		ifTrue: [ boxContextStack := TfStack new ].
	^ boxContextStack
!

formContextStack

	formContextStack isNil
		ifTrue: [ formContextStack := TfStack new ].
	^ formContextStack
!

layoutContextStack

	layoutContextStack isNil
		ifTrue: [ layoutContextStack := TfStack new ].
	^ layoutContextStack
!

pushBoxContext: aTfBoxContext

	aTfBoxContext
		parentContext: self boxContext;
		renderContext: self.
	^ self boxContextStack push: aTfBoxContext
!

pushFormContext: aTfFormContext

	aTfFormContext
		parentContext: self formContext;
		renderContext: self.
	^ self formContextStack push: aTfFormContext
!

pushLayoutContext: aTfLayoutContext

	aTfLayoutContext
		parentContext: self layoutContext;
		renderContext: self.
	^ self layoutContextStack push: aTfLayoutContext
! !

!TfRenderContext class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfRenderContext.st,v 1.1 2009/10/01 18:47:03 cg Exp $'
! !
