"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Model subclass:#TfResourceRequest
	instanceVariableNames:'urlDescriptor resource resourceBlocks resourceManager process
		processSemaphore finished'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Base'
!


!TfResourceRequest class methodsFor:'instance creation'!

new

	^ super new initialize
!

urlDescriptor: aTfURLDescriptor resourceManager: aTfResourceManager

	^ self new
		urlDescriptor: aTfURLDescriptor;
		resourceManager: aTfResourceManager;
		yourself
! !

!TfResourceRequest methodsFor:'accessing'!

addResourceBlock: aBlock
	" block with one argument (the resource manager) that fetches the resource "

	resourceBlocks add: aBlock
!

resource

	^ resource
!

resourceManager

	^ resourceManager
!

resourceManager: aTfResourceManager

	resourceManager := aTfResourceManager
!

startProcess

	processSemaphore critical: [
		process isNil
			ifTrue: [ 
				process := [ 
						self getResource.
						processSemaphore critical: [ process := nil ].
				] forkAt: Processor userBackgroundPriority
			].
	].
!

stopProcess

	processSemaphore critical: [
		process notNil
			ifTrue: [ 
				process terminate.
				process := nil.
			]
	].
!

urlDescriptor

	^ urlDescriptor
!

urlDescriptor: aTfURLDescriptor

	urlDescriptor := aTfURLDescriptor.
! !

!TfResourceRequest methodsFor:'initialize-release'!

initialize

	processSemaphore := Semaphore forMutualExclusion.
	resourceBlocks := OrderedCollection new.
	finished := false.
! !

!TfResourceRequest methodsFor:'private'!

finishRequest

	finished := true.
	self resourceManager finishedRequest: self.
!

getResource

	resource := self resourceManager resourceFromDescriptor: self urlDescriptor.
	finished
		ifFalse: [
			self finishRequest.
			resource notNil
				ifTrue: [ 
					resourceBlocks do: [ : resourceBlock | resourceBlock value: resource ]
				].
		].
! !

!TfResourceRequest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfResourceRequest.st,v 1.1 2009/10/01 18:06:04 cg Exp $'
! !
