"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfResources
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Kernel-Objects'
!


!TfResources class methodsFor:'accessing'!

logo

	^ OpaqueImage figure: self logoImage tfAsCachedImage shape: self logoMask tfAsCachedImage
!

logoIcon
        ^ self logoImage copy mask:self logoMask
        "/ ^ Icon figure: self logoImage shape: self logoMask.
!

versionString

        | parcel |
        parcel := Parcel parcelNamed:'TwoflowerBrowser'.
        parcel notNil
                ifTrue: [ ^ parcel version ].
        #{Store.Registry} ifDefinedDo: [ : reg | | pkg di |
                pkg := reg packageNamed: 'TwoflowerBrowser'.
                (pkg notNil and: [ (di := pkg databaseInfomation) notNil ])
                        ifTrue: [ ^  (di versionString readStream) skipThrough: $(; upTo: $, ]
        ].
        ^ '0.4'.
! !

!TfResources class methodsFor:'documents'!

about

^ '<html>
<head>
<title>Twoflower</title>
</head>
<body>', self twoflowerBar, 
'<h2>Twoflower ', self version, '</h2>
A simple web browser for VisualWorks 7i
<h2>License</h2>
Twoflower is distributed under the <a href="http://www.gnu.org/licenses/lgpl.html">GNU Lesser General Public License Version 2.1</a> <p>
<h2>Contact</h2>
e-mail to Holger.Kleinsorgen@t-online.de
<h2>Acknowledgements</h2>
Thanks to Dave Murphy and James Robertson for fixing bugs
<h2>Links</h2>
<ul>
<li><a href="twoflower://twoflower~features">Features</a> supported by Twoflower</li>
<li>In case you&apos;re wondering why this package is called Twoflower, have a look at <a href="http://www.ufbs.co.uk/dwm/whoswho_twoflower.html">Discworld Monthly</a></li>
<li>Twoflower''s <a href="http://wiki.cs.uiuc.edu/VisualWorks/Twoflower">Wiki page</a> at UIUC
</ul>

</body>
</html>'
!

aboutURL

	^ 'twoflower://twoflower~about'
!

colGroupTable1HTML

^ '<html>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<colgroup>
	<col width="200" span="2">
	<col width="150">
</colgroup>
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>Berlin</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Milj&ouml;h</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Buletten</td>
</tr>
</table>'
!

colGroupTable2HTML

^ '<html>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<colgroup span="3" width="150"/>
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>Berlin</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Milj&ouml;h</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Buletten</td>
</tr>
</table>'
!

doubleNestedTablesHTML

^ '<html>
<body>
<table id="outer">
<tr>
<td>
<table id="inner1" border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>Berlin</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Milj&ouml;h</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Buletten</td>
</tr>
</table>
<table id="inner2" border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>Berlin</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Milj&ouml;h</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Buletten</td>
</tr>
</table>
</td>
</tr>
<table>
'
!

doubleTableHTML

^ '<html>
<body>
<table id="inner1" border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>Berlin</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Milj&ouml;h</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Buletten</td>
</tr>
</table>
<table id="inner2" border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>Berlin</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Milj&ouml;h</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Buletten</td>
</tr>
</table>'
!

features
	"self features"

	| str |
	str := (String new: 256) writeStream.
	str nextPutAll: '<html><head><title>Features</title></head><body>'.
	str nextPutAll: self twoflowerBar.
	self writeTfepDemoOn: str.
	str nextPutAll: '<p/>'.
	self writeRegistryDemoOn: str.
	str nextPutAll: '<p/>'.
	self writeImageReadersOn: str.
	str nextPutAll: '<p/>'.
	self writeElementsOn: str.
	str nextPutAll: '</body></html>'.
	^ str contents
!

fixedColumnWidthsTableHTML

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<tr>
<td width="100">Berlin</td>
<td width="200">Hamburg</td>
<td width="150">M&uuml;nchen</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>'
!

fixedWidthTableHTML

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table width="400" border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>M&uuml;nchen</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>'
!

fontSizesHTML

^ '<html>
<body>
<span id="1">Testing 1-2-3</span><br>
<font size="+1" id="2">Testing 1-2-3</font><br>
<font size="-1" id="3">Testing 1-2-3</font><br>
<font size="4" id="4">Testing 1-2-3</font><br>
<font size="2" id="5">Testing 1-2-3</font><br>
<font style="font-size:36pt" id="6">Testing 1-2-3</font><br>
<font style="font-size:12pt" id="7">Testing 1-2-3</font><br>
</body>
</table>'
!

internalError: exception internalURL: url

	^ 
'<html><head><title>', exception description, '</title></head><body>Internal error while executing <a href="', url asString,
'">', url asString, '</a>:<p/>', exception description, '</body></body>'
!

mixedColumnWidthsTableHTML

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<tr>
<td width="100">Berlin</td>
<td width="50%">Hamburg</td>
<td >M&uuml;nchen</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>'
!

mixedFontSizesHTML

^ '<html>
<body>
<span id="1">Small</span><font size="+3" id="2">Large</font>
</body>
</table>'
!

nestedTablesHTML

^ '<html>
<head>
<title>Twoflower</title>
</head>
<body>
<h1>Nested tables</h1>
<table width="100%" border="1"  cellspacing="0" cellpadding="0">
<tr>
<td>Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 Cell 1 </td>
<td>
	<table width="200">
	<tr>
	<td>Cell A</td>
	<td>Cell B</td>
	</tr>
	<tr>
	<td>Cell C</td>
	<td>Cell D</td>
	</tr>
	</table>
</td>
</tr>
<tr>
<td>Cell 3</td>
<td>Cell 4</td>
</tr>
</table>
</body>
</html>'
!

paragraphHTML

^ '<html>
<body>
<p id="1">First</p>
<p id="2">Second</p>
<p><p><p id="3">Third<p>
<p id="4">Fourth</p>
</body>
</table>'
!

relativeColumnWidthsTable2HTML

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td width="30%">Hamburg</td>
<td>Berlin</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Milj&ouml;h</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Buletten</td>
</tr>
</table>'
!

relativeColumnWidthsTableHTML

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<tr>
<td >Berlin</td>
<td width="30%">Hamburg</td>
<td width="50%">M&uuml;nchen</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>'
!

rowSpanHTML

^ '<html>
<body>
<table width="200" border="0" cellSpacing="0" cellPadding="0">
<tr id="1">
<td rowspan="3">Die Berliner Kulturlandschaft trägt durch Umfang, Vielfalt, Lebendigkeit und Ausstrahlungskraft zum unverwechselbaren Profil der Stadt entscheidend bei. Allein die siebzehn staatlichen Museen der Stiftung Preußischer Kulturbesitz bilden den größten Museumskomplex des Kontinents.  Berlin ist die bedeutendste deutsche Theaterstadt. Zur Zeit besitzt Berlin drei Opernhäuser, über 150 Theater und Bühnen sowie 800 Chöre, rund 170 Museen und Sammlungen, ferner etwa 300 kommunale und private Galerien, mehr als 250 öffentliche Bibliotheken, 265 Kinos und zahlreiche weitere kulturelle Einrichtungen.</td>
<td>Hamburg</td>
<td>M&uuml;nchen</td>
</tr><tr id="2">
<td>Kiez</td>
<td >Bierdampf</td>
</tr><tr id="3">
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<tr id="ref"><td>Referenz</td></tr>
</table>
'
!

rowSpawnHTML

^ '<html>
<body>
<table width="200" border="0" cellSpacing="0" cellPadding="0">
<tr id="1">
<td rowspan="3">Die Berliner Kulturlandschaft trägt durch Umfang, Vielfalt, Lebendigkeit und Ausstrahlungskraft zum unverwechselbaren Profil der Stadt entscheidend bei. Allein die siebzehn staatlichen Museen der Stiftung Preußischer Kulturbesitz bilden den größten Museumskomplex des Kontinents.  Berlin ist die bedeutendste deutsche Theaterstadt. Zur Zeit besitzt Berlin drei Opernhäuser, über 150 Theater und Bühnen sowie 800 Chöre, rund 170 Museen und Sammlungen, ferner etwa 300 kommunale und private Galerien, mehr als 250 öffentliche Bibliotheken, 265 Kinos und zahlreiche weitere kulturelle Einrichtungen.</td>
<td>Hamburg</td>
<td>M&uuml;nchen</td>
</tr><tr id="2">
<td>Kiez</td>
<td >Bierdampf</td>
</tr><tr id="3">
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<tr id="ref"><td>Referenz</td></tr>
</table>
'
!

tableHTML
	" test values from www.selfhtml.net ;-) "

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table border="1" cellSpacing="1" cellPadding="1">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>M&uuml;nchen</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>'
!

tableRightAlignHTML

^ '<html>
<head>
<title>Twoflower</title>
</head>
<body>
<h1>Right align</h1>
<table align="right" border="1"><tr><td>cell1</td><td>cell2</td></tr><tr><td>cell3</td><td>cell4</td></tr></table>
Table right align Table right align Table right align Table right align Table right align Table right align 
Table right align Table right align Table right align Table right align Table right align Table right align
Table right align Table right align Table right align Table right align Table right align Table right align 
Table right align Table right align Table right align Table right align Table right align Table right align 
Table right align Table right align Table right align Table right align Table right align Table right align 
Table right align Table right align Table right align Table right align Table right align Table right align 
</body>
</html>'
!

tableSpanGalore1HTML

^ '<html>
<body>
<table border="1" cellPadding="1" cellSpacing="1" width="200">
<tr id="1">
<td rowspan="2">Berlin</td>
<td>Hamburg<br>Hamburg</br></td>
<td>München</td>
</tr><tr id="2">
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr id="3">
<td colspan="2">Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>
</body></html>
'
!

tableSpanGalore2HTML

^ '<html>
<body>
<table border="1" cellPadding="1" cellSpacing="1" width="200">
<tr id="1">
<td rowspan="2">Berlin<br/>Berlin<br/>Berlin<br/>Berlin<br/>Berlin<br/>Berlin<br/></td>
<td>Hamburg<br>Hamburg</br></td>
<td>München</td>
</tr><tr id="2">
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr id="3">
<td colspan="2">Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>
</body></html>
'
!

tableSpanGalore3HTML

^ '<html>
<body>
<table border="1" cellPadding="1" cellSpacing="1" width="200">
<tr id="1">
<td rowspan="2">Berlin</td>
<td>Hamburg<br>Hamburg</br></td>
<td>München</td>
</tr><tr id="2">
<td>Kiez</td>
<td rowspan="2">Bierdampf<br>Bierdampf<br>Bierdampf<br>Bierdampf<br>Bierdampf</td>
</tr><tr id="3">
<td colspan="2">Frikadellen</td>
</tr>
</table>
</body></html>
'
!

tableSpanGalore4HTML

^ '<html>
<body>
<table border="1" cellPadding="1" cellSpacing="1" width="200">
<tr id="1">
<td rowspan="2">Berlin<br>Berlin<br>Berlin<br>Berlin<br>Berlin<br>Berlin<br>Berlin<br>Berlin</td>
<td>Hamburg<br>Hamburg</br></td>
<td>München</td>
</tr><tr id="2">
<td>Kiez</td>
<td rowspan="2">Bierdampf<br>Bierdampf<br>Bierdampf<br>Bierdampf<br>Bierdampf</td>
</tr><tr id="3">
<td colspan="2">Frikadellen</td>
</tr>
</table>
</body></html>
'
!

tableWithImagesHTML

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td><img width="20" height="20"/>M&uuml;nchen</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td><img width="20" height="20"/><img width="20" height="20"/><img width="20" height="20"/>Kiez</td>
<td>Bierdampf</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>'
!

unconstrainedTableHTML
	" test values from www.selfhtml.net ;-) "

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>M&uuml;nchen</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>'
!

variableWidthTableHTML

^ '<html>
<head>
<title>Text des Titels</title>
</head>
<body>
<table width="50%" border="0" cellSpacing="0" cellPadding="0">
<tr>
<td>Berlin</td>
<td>Hamburg</td>
<td>M&uuml;nchen</td>
</tr><tr>
<td>Milj&ouml;h</td>
<td>Kiez</td>
<td>Bierdampf</td>
</tr><tr>
<td>Buletten</td>
<td>Frikadellen</td>
<td>Fleischpflanzerl</td>
</tr>
</table>'
! !

!TfResources class methodsFor:'hack'!

browseClass: aString

	(QualifiedName pathString: aString)
		ifDefinedDo: [ :cl | SmalltalkWorkbench browseClass: cl ].
! !

!TfResources class methodsFor:'private'!

twoflowerBar

^ '
<table width="100%" cellpadding="2">
<tr bgcolor="#000066" border="0" cellpadding="3" cellspacing="0">
<td width="100%">
	<font color="#FFFFFF" size="+2" face="Helv,Helvetica,Arial">
	Twoflower
	</font>
</td>
</tr></table>
'
!

writeCanvasDemoOn: str

	str nextPutAll: '
<h2>Smalltalk Canvas integration</h2>
<canvas class="Tools.Workspace" width="500" height="500"/>
Not yet finished
'
!

writeElementsOn: str

	| tagClasses sortedTags s |
	str nextPutAll: '
<h2>Supported elements and attributes</h2>
Note that some elements (e.g. <i>&lt;p&gt;</i>) are supported using a <a href="tfep://twoflower~browseClass:/Twoflower.TfDefaultStyleSheet">generic stylesheet</a>, these elements are not listed here.<p>
<table border="1" cellspacing="1" cellpadding="3"><tr bgcolor="DDDDFF">
<th>Element</th><th>Supported attributes</th><th>Class</th><th>Remarks</th>'.
	tagClasses := Dictionary new.
	TfElement allSubclasses do: [ :cl | cl tagNames do: [ :tn | tagClasses at: tn put: cl ]].
	sortedTags := tagClasses keys asSortedCollection: [ :t1 :t2 | t1 <= t2 ].
	sortedTags do: [ :tn | | tagClass |
		str nextPutAll: '<tr valign="top"><td  bgcolor="#DDFFDD">'.
		str nextPutAll: tn.
		tagClass := tagClasses at: tn.
		str nextPutAll: '</td><td>'.
		tagClass supportedAttributes notEmpty
			ifTrue: [ 
				tagClass supportedAttributes 
					do: [ :attrName | str nextPutAll: attrName ]
					separatedBy: [ str nextPutAll: ', ' ].
			] ifFalse: [
				str nextPutAll:  '&nbsp;' 
			].
		str	
			nextPutAll: '</td><td><a href="tfep://twoflower~browseClass:/';
			nextPutAll: ((s := tagClass fullName) notEmpty ifTrue: [ s ] ifFalse: [ '&nbsp;' ]);
			nextPutAll: '">';
			nextPutAll: ((s := tagClass name asString) notEmpty ifTrue: [ s ] ifFalse: [ '&nbsp;' ]);
			nextPutAll: '</a></td><td>';
			nextPutAll:  ((s := tagClass remarks) notEmpty ifTrue: [ s ] ifFalse: [ '&nbsp;' ]);
			nextPutAll: '</td></tr>'.
	].
	str nextPutAll: '</table>'.
!

writeImageReadersOn: str

	str nextPutAll: '
<h2>Image readers</h2>
Currently, the following image readers are used<p>
<table border="1" cellspacing="1" cellpadding="3"><tr bgcolor="DDDDFF"><th>MIME type</th><th>Reader class</th>'.
	TfImageModel imageReaders do: [ : reader |
		reader handledMimeTypes do: [ : mimeType |
			str 
				nextPutAll: '<tr><td bgcolor="#DDFFDD">'; 
				nextPutAll: mimeType;
				nextPutAll: '</td><td><a href="tfep://twoflower~browseClass:/';
				nextPutAll: reader class fullName;
				nextPutAll: '">';
				nextPutAll: reader class fullName;
				nextPutAll: '</a></td></tr>'.
		].
	].	
	str nextPutAll: '</table>'
!

writeRegistryDemoOn: str

	str nextPutAll: '
<h2>URL handlers</h2>
Applications utilizing Twoflower can register blocks that are evaluated when opening specific URLs instead of loading the resource from the URL.<p>
Example: <a href="hello://world">this one</a> (&lt;a href="hello://world"&gt;this one &lt;/a&gt;)<p>
<pre><code>TfApplicationRegistry singleton 
			descriptorMatch: [ : descriptor | descriptor url asString match: &#39;http://*&#39; ]
			evaluate: [ : descriptor | Dialog warn: descriptor url asString ]</code></pre> '
!

writeTfepDemoOn: str

	str nextPutAll: '
<h2>Performing Smalltalk methods</h2>
Open a <a href="tfep://FileBrowser~open">file browser</a>. The source code for this link looks like this:<blockquote><code>&lt;a href="tfep://FileBrowser~open"&gt;file browser&lt;/a&gt;</code></blockquote><p>
Currently, only links to class methods with string arguments can be performed.'
! !

!TfResources class methodsFor:'resources'!

logoImage
        "UIMaskEditor new openOnClass: self andSelector: #logoImage"

        <resource: #image>

        ^((Image extent: 16@16 depth: 4 bitsPerPixel: 4 palette: (MappedPalette withColors: ((Array new: 16) at: 1 put: ColorValue black; at: 2 put: (ColorValue scaledRed: 7034 scaledGreen: 6745 scaledBlue: 5685); at: 3 put: (ColorValue scaledRed: 7548 scaledGreen: 6167 scaledBlue: 1606); at: 4 put: (ColorValue scaledRed: 4593 scaledGreen: 4047 scaledBlue: 5460); at: 5 put: (ColorValue scaledRed: 6874 scaledGreen: 5814 scaledBlue: 2376); at: 6 put: (ColorValue scaledRed: 7709 scaledGreen: 6231 scaledBlue: 867); at: 7 put: (ColorValue scaledRed: 4304 scaledGreen: 4015 scaledBlue: 6970); at: 8 put: (ColorValue scaledRed: 2666 scaledGreen: 2409 scaledBlue: 5814); at: 9 put: (ColorValue scaledRed: 2152 scaledGreen: 1863 scaledBlue: 6360); at: 10 put: (ColorValue scaledRed: 2409 scaledGreen: 2120 scaledBlue: 6327); at: 11 put: (ColorValue scaledRed: 7677 scaledGreen: 6360 scaledBlue: 2409); at: 12 put: (ColorValue scaledRed: 7323 scaledGreen: 6584 scaledBlue: 3726); at: 13 put: (ColorValue scaledRed: 2473 scaledGreen: 2055 scaledBlue: 7002); at: 14 put: (ColorValue scaledRed: 2120 scaledGreen: 1670 scaledBlue: 7002); at: 15 put: (ColorValue scaledRed: 1188 scaledGreen: 674 scaledBlue: 7420); at: 16 put: (ColorValue scaledRed: 2826 scaledGreen: 2569 scaledBlue: 7034); yourself)) usingBits: #[0 0 4 36 0 0 0 0 0 0 161 161 64 0 0 0 0 64 161 161 32 0 0 0 11 27 91 42 43 18 0 0 34 43 162 42 186 42 64 0 65 26 81 26 43 26 64 0 2 37 43 18 34 34 0 0 0 43 34 85 186 67 102 208 0 27 171 43 33 163 253 248 0 178 26 81 186 35 97 104 0 42 162 50 178 41 220 208 0 4 67 99 51 118 249 0 0 0 6 29 110 109 31 0 0 0 15 246 109 102 252 0 0 0 0 207 199 159 205 0 0 0 0 0 0 0 112 0])) 
!

logoMask
	"UIMaskEditor new openOnClass: self andSelector: #logoMask"

	<resource: #image>

	^(Image extent: 16@16 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[7 0 0 0 15 128 0 0 47 128 0 0 127 240 0 0 255 248 0 0 255 248 0 0 127 240 0 0 63 254 0 0 63 255 0 0 63 255 0 0 63 254 0 0 31 252 0 0 7 252 0 0 7 252 0 0 3 252 0 0 0 8 0 0])
! !

!TfResources class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfResources.st,v 1.1 2009/10/02 00:17:40 cg Exp $'
! !
