"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

XML::SAXBuilderDriver subclass:#TfSAXDriver
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfSAXDriver methodsFor:'content handler'!

characters: aString

	elementStack isEmpty
		ifFalse: [ super characters: aString ]
!

ignorableWhitespace: aString
!

ignorableWhitespace: aString from: start to: stop
!

lastElement

	^ elementStack isEmpty
		ifTrue:[ document elements last ]
		ifFalse: [ elementStack last nodes last ].
!

scanForCharset: contentString

	| str charset |
	str := contentString readStream.
	str skipThroughAll: 'charset'.
	str atEnd ifTrue: [ ^ self ].
	str skipThrough: $=.
	charset := (str upTo: $;) trimBlanks.
	charset isEmpty
		ifTrue: [ ^ self ].
	TfEncodingWarning raiseRequestWith: charset asLowercase asSymbol
!

startDocument

        self builder: TfNodeBuilder new.
        document := TfDocument new.
        document dtd: XML::DocumentType new.
        elementStack := OrderedCollection new.
!

startElement: namespaceURI localName: localName qName: name attributes: attributes

        | nm attr |
        document == nil ifTrue: [self startDocument].
" modification: html tag + charset >> "
        " sneak peek to look for charset "
        (localName asLowercase = 'meta' and: [ (attr := attributes detect: [ : a | a tag isLike: 'content' ] ifNone: [nil]) notNil ])
                ifTrue: [ self scanForCharset: attr value ].
        nm := TfNodeTag new
                qualifier: ((name includes: $:)
                                ifTrue: [name copyUpTo: $:]
                                ifFalse: [''])
                ns: namespaceURI
                type: localName.
" << modification >> "
        elementStack addLast: (XML::SAXElementContext new tag: nm).
        elementStack last
                attributes: (attributes collect: [:att | att copy]);
                nodes: OrderedCollection new;
                namespaces: newNamespaces.
        newNamespaces := nil.
        builder pushTag: nm.
! !

!TfSAXDriver methodsFor:'error handler'!

warning: anException

	Log logDebug: [anException description]
! !

!TfSAXDriver class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfSAXDriver.st,v 1.3 2009/11/07 03:21:28 cg Exp $'
! !
