"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

XML::SAXWriter subclass:#TfSAXWriter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-SAX'
!


!TfSAXWriter methodsFor:'content handler'!

comment: data from: start to: stop

	output emphasis: (Array with: #italic with: #color -> ColorValue gray).
	super comment: data from: start to: stop.
	output emphasis: nil
!

startElement: namespaceURI localName: localName qName: name attributes: attributes

	| val emph |
	notations == nil ifFalse: [self emitDTD: name].
	self closeOpenTag.
	output nextPutAll: '<'.
	output nextPutAll: name.
	emph := output emphasis.
	(self sort: attributes) do: [:att |
		output emphasis: #color -> ColorValue darkRed.
		output space.
		output nextPutAll: att tag asString.
		output emphasis: #color -> ColorValue black.
		output nextPutAll: '='.
		output emphasis: #color -> ColorValue darkRed.
		output nextPutAll: '"'.
		1 to: att value size do: [:i || ch mapped |
			ch := att value at: i.
			mapped := attrMap at: ch ifAbsent: [nil].
			mapped == nil
				ifTrue: [output nextPut: ch]
				ifFalse: [output nextPutAll: mapped]].
		output nextPutAll: '"'].
	output emphasis: emph.
	newNamespaces == nil
		ifFalse: [newNamespaces keys asSortedCollection do: [:key |
				output space.
				output nextPutAll: (key isEmpty ifTrue: ['xmlns'] ifFalse: ['xmlns:', key]).
				output nextPutAll: '="'.
				val := newNamespaces at: key.
				1 to: val size do: [:i || ch mapped |
					ch := val at: i.
					mapped := attrMap at: ch ifAbsent: [nil].
					mapped == nil
						ifTrue: [output nextPut: ch]
						ifFalse: [output nextPutAll: mapped]].
				output nextPutAll: '"']].
	newNamespaces := nil.
	hasOpenTag := true
! !

!TfSAXWriter class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfSAXWriter.st,v 1.1 2009/10/01 23:54:18 cg Exp $'
! !
