"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfSizeLayout subclass:#TfScaledSizeLayout
	instanceVariableNames:'sizeFactor'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfScaledSizeLayout class methodsFor:'instance creation'!

sizeFactor: aNumber

	^ self new
		sizeFactor: aNumber
! !

!TfScaledSizeLayout methodsFor:'accessing'!

proportionMaxValue

	^ 1
!

sizeFactor 

	^ sizeFactor
!

sizeFactor: aNumber

	sizeFactor  := aNumber
! !

!TfScaledSizeLayout methodsFor:'layout'!

factorForMinFactor: minFactor factorSum: factorSum

	^ (self sizeFactor max: minFactor) min: 1
!

requiredSizeFor: preferredSize minFactor: minFactor factorSum: factorSum

	^ preferredSize / (self factorForMinFactor: minFactor factorSum: factorSum)
!

sizeRelativeTo: pixelSize

	^ (pixelSize * self sizeFactor) rounded
!

sizeRelativeTo: pixelSize minFactor: minFactor factorSum: factorSum

	^ pixelSize * (self factorForMinFactor: minFactor factorSum: factorSum)
! !

!TfScaledSizeLayout methodsFor:'printing'!

printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '[*'.
	sizeFactor printOn: aStream.
	aStream nextPut: $].
! !

!TfScaledSizeLayout methodsFor:'private'!

basicDividedBy: anInteger

	^ self species sizeFactor: self sizeFactor / anInteger
! !

!TfScaledSizeLayout class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfScaledSizeLayout.st,v 1.1 2009/10/01 18:47:30 cg Exp $'
! !
