"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

CharacterBlockScanner subclass:#TfSelectionScanner
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Graphics-Text Scanning'
!


!TfSelectionScanner methodsFor:'private'!

buildCharacterBlockIn: aRectangle
 
	| runLength lineStop stopCondition |
	destY := aRectangle top.
	destX := leftMargin := 0.
	rightMargin := aRectangle right.
	nextLeftMargin := 0.
	lastIndex := self lineFirst.
	self setStopConditions.	"also sets font"
	runLength := text runLengthFor: self lineFirst.
	characterIndex notNil 
		ifTrue: "scanning for index"
			[lineStop := characterIndex]
		ifFalse: 
			[lineStop := self lineLast].
	(runStopIndex := lastIndex + (runLength - 1)) > lineStop ifTrue: [runStopIndex := lineStop].
	lastCharacterExtent := 0 @ self lineGrid.
	spaceCount := 0.
	
	[| code |
	code := self
				scanCharactersFrom: lastIndex
				to: runStopIndex
				in: string
				rightX: characterPoint x
				stopConditions: characterMap.
	stopCondition := self stopConditionFor: code.	"see setStopConditions for stopping conditions for character block 
		operations."
	lastCharacterExtent x: (font widthOf: (text at: lastIndex)).
	(self perform: stopCondition)
		ifTrue: [^CharacterBlock
				stringIndex: lastIndex
				character: lastCharacter
				topLeft: characterPoint
				extent: lastCharacterExtent]] repeat
!

setStopConditions

	super setStopConditions.
	self stopConditions: NoStopConditions
! !

!TfSelectionScanner methodsFor:'scanning'!

characterBlockAtPoint: aPoint text: aString in: aRectangle

	characterIndex := nil.
	characterPoint := aPoint.
	self text: aString.
	self lineFirst: 1 lineLast: aString size.
	^ self buildCharacterBlockIn: aRectangle.
!

characterBlockForIndex: targetIndex text: aString in: aRectangle

	characterIndex := targetIndex.
	characterPoint := aRectangle corner.
	self text: aString.
	self lineFirst: 1 lineLast: aString size.
	^ self buildCharacterBlockIn: aRectangle.
! !

!TfSelectionScanner class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfSelectionScanner.st,v 1.1 2009/10/02 00:04:45 cg Exp $'
! !
