"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

ApplicationModel subclass:#TfSidebarApp
	instanceVariableNames:'tabsAspect tabs browser activePanel'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-UIApplications-New'
!


!TfSidebarApp class methodsFor:'instance creation'!

on: aTwoflowerBrowser

	^ self new
		browser: aTwoflowerBrowser;
		yourself.
! !

!TfSidebarApp class methodsFor:'interface specs'!

windowSpec
        "Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 
                        #(#UserMessage 
                                #key: #UnlabeledCanvas 
                                #defaultString: 'Sidebar' 
                                #catalogID: #labels ) 
                        #bounds: #(#Rectangle 640 512 840 712 ) ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#TabControlSpec 
                                        #layout: #(#LayoutFrame 0 0 0 0 0 1 0 1 ) 
                                        #name: #tabsID 
                                        #model: #tabsAspect 
                                        #labels: #() ) ) ) )
! !

!TfSidebarApp methodsFor:'accessing'!

browser

	^ browser
!

browser: aTwoflowerBrowser

	browser := aTwoflowerBrowser
! !

!TfSidebarApp methodsFor:'aspects'!

tabsAspect

	tabsAspect isNil
		ifTrue: [
			tabsAspect := SelectionInList new.
			tabsAspect
				list: (self tabs collect: [ : tab | tab key ]);
				selectionIndex: 1.
			self tabsAspect selectionHolder onChangeSend: #tabChanged to: self.
		].
	^ tabsAspect
! !

!TfSidebarApp methodsFor:'initialize-release'!

release

	^ super release
!

shutDown

	activePanel notNil 
		ifTrue: [ activePanel shutDown ].
! !

!TfSidebarApp methodsFor:'interface opening'!

postBuildWith: aBuilder

	super postBuildWith: aBuilder.
	aBuilder == self builder
		ifTrue: [
			self tabChanged
		].
! !

!TfSidebarApp methodsFor:'notification'!

tabChanged

	| canvas panelClass |
	activePanel notNil
		ifTrue: [ 
			activePanel shutDown.
			activePanel := nil.
		].
	canvas := self builder componentAt: #tabsID.
	canvas isNil ifTrue: [ ^ self ].
	panelClass := (self tabs at: self tabsAspect selectionIndex) value.
	panelClass isNil ifTrue: [ ^ self ].
	activePanel := panelClass browserModel: self browser browserModel.
	canvas widget
		client: activePanel
		spec: #windowSpec
		builder: self builder newSubBuilder.
! !

!TfSidebarApp methodsFor:'private'!

tabs

	tabs isNil
		ifTrue: [
			tabs := ((TfSidebarPanel allSubclasses reject: [ : cl | cl isAbstract ])
						collect: [ : cl | cl description -> cl ])
						asSortedCollection: [ : a : b | a value sortOrder <= b value sortOrder ]
		].
	^ tabs
! !

!TfSidebarApp class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfSidebarApp.st,v 1.1 2009/10/01 23:42:05 cg Exp $'
! !
