"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfSizeLayout
	instanceVariableNames:'minSize maxSize'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfSizeLayout methodsFor:'accessing'!

dividedBy: anInteger
	" evil hack that is used for computing layout for tables with column spanning:
	assume that this layout is used for anInteger number of elements (cells).
	Return a layout for one of the elements (cell) so that, when all layouts of all
	elements are added, they have the same size like me "

	^ anInteger <= 1
		ifTrue: [ self ]
		ifFalse: [ self basicDividedBy: anInteger ]
!

isFixedLayout

	^ false
!

isSoftLayout

	^ false
!

maxSize
	" max. pixel size "

	^ maxSize
!

maxSize: anInteger
	" max. pixel size "

	maxSize := anInteger
!

minSize
	" min. pixel size "

	^ minSize
!

minSize: anInteger
	" min. pixel size "

	minSize := anInteger
!

pixelSize

	^ 0
!

proportionMaxValue

	^ 0
! !

!TfSizeLayout methodsFor:'layout'!

boundedSizeRelativeTo: pixelSize

	| newPixelSize |
	newPixelSize := self sizeRelativeTo: pixelSize.
	self maxSize notNil
		ifTrue: [ newPixelSize := newPixelSize min: self maxSize ].
	self minSize notNil
		ifTrue: [ newPixelSize := newPixelSize max: self minSize ].
	^ newPixelSize
!

factorForMinFactor: minFactor factorSum: factorSum

	^ 0
!

preferredWidth

	^ nil
!

requiredSizeFor: preferredSize minFactor: minFactor factorSum: factorSum

	^ self sizeRelativeTo: preferredSize
!

sizeFactor

	^ 0
!

sizeRelativeTo: pixelSize

	self subclassResponsibility
!

sizeRelativeTo: pixelSize minFactor: minFactor factorSum: factorSum

	^ self sizeRelativeTo: pixelSize
! !

!TfSizeLayout methodsFor:'private'!

basicDividedBy: anInteger

	self subclassResponsibility
! !

!TfSizeLayout class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfSizeLayout.st,v 1.1 2009/10/01 18:47:44 cg Exp $'
! !
