"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfStyle
	instanceVariableNames:'tagName parentStyle fontStyle paragraphStyle backgroundStyle
		styleSheet tableStyle tableCellStyle listStyle'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfStyle class methodsFor:'instance creation'!

new

	^super new initialize
! !

!TfStyle methodsFor:'accessing'!

backgroundStyle

	backgroundStyle isNil
		ifTrue: [ backgroundStyle := TfBackgroundStyle forStyle: self ].
	^ backgroundStyle
!

backgroundStyle: aTfBackgroundStyle

	backgroundStyle := aTfBackgroundStyle
!

fontStyle

	fontStyle isNil
		ifTrue: [ fontStyle := TfFontStyle forStyle: self ].
	^ fontStyle
!

fontStyle: aTfFontStyle

	fontStyle := aTfFontStyle
!

listStyle

	listStyle isNil
		ifTrue: [ listStyle := TfListStyle forStyle: self ].
	^ listStyle
!

listStyle: aTfListStyle

	listStyle := aTfListStyle
!

paragraphStyle

	paragraphStyle isNil
		ifTrue: [ paragraphStyle := TfParagraphStyle forStyle: self ].
	^ paragraphStyle
!

paragraphStyle: aTfParagraphStyle

	paragraphStyle := aTfParagraphStyle
!

parentStyle
	" parent style from which I inherit properties "

	^ parentStyle
!

parentStyle: aTfStyle
	" parent style from which I inherit properties "

	parentStyle := aTfStyle
!

styleSheet

	^ styleSheet
!

styleSheet: aTfStyleSheet

	styleSheet := aTfStyleSheet
!

tableCellStyle

	tableCellStyle isNil
		ifTrue: [ tableCellStyle := TfTableCellStyle forStyle: self ].
	^ tableCellStyle
!

tableCellStyle: aTfTableCellStyle

	tableCellStyle := aTfTableCellStyle
!

tableStyle

	tableStyle isNil
		ifTrue: [ tableStyle := TfTableStyle forStyle: self ].
	^ tableStyle
!

tableStyle: aTfTableStyle

	tableStyle := aTfTableStyle
!

tagName
	" name of the tag associated with this style" 
	" (optional) "
	" ^ String "

	^ tagName
!

tagName: aString
	" name of the tag associated with this style" 
	" (optional) "

	tagName := aString
! !

!TfStyle methodsFor:'copying'!

beClone

	backgroundStyle notNil ifTrue: [ backgroundStyle := backgroundStyle clone ].
	paragraphStyle notNil ifTrue: [ paragraphStyle := paragraphStyle clone ].
	fontStyle notNil ifTrue: [ fontStyle := fontStyle clone ].
	tableStyle notNil ifTrue: [ tableStyle := tableStyle clone ].
	tableCellStyle notNil ifTrue: [ tableCellStyle := tableCellStyle clone ].
	listStyle notNil ifTrue: [ listStyle := listStyle clone ].
!

clone
	" ^ TfStyle "

	^ self copy beClone
! !

!TfStyle methodsFor:'initalize-release'!

initialize
!

setupStyleFrom: aTfStyle inherited: isInherited

	self backgroundStyle:
		(self backgroundStyle mergedWith: aTfStyle backgroundStyle isInherited: isInherited).
	self fontStyle:
		(self fontStyle mergedWith: aTfStyle fontStyle isInherited: isInherited).
	self tableStyle:
		(self tableStyle mergedWith: aTfStyle tableStyle isInherited: isInherited).
	self tableCellStyle:
		(self tableCellStyle mergedWith: aTfStyle tableCellStyle isInherited: isInherited).
	self listStyle:
		(self listStyle mergedWith: aTfStyle listStyle isInherited: isInherited).
	self paragraphStyle:
		(self paragraphStyle mergedWith: aTfStyle paragraphStyle isInherited: isInherited).
! !

!TfStyle class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfStyle.st,v 1.1 2009/10/01 18:48:10 cg Exp $'
! !
