"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfLinkedContext subclass:#TfStyleContext
	instanceVariableNames:'style styleSheet cachedTextStyle globalStyle'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfStyleContext class methodsFor:'instance creation'!

styleSheet: aTfStyleSheet

	^ self new
		styleSheet: aTfStyleSheet;
		yourself
! !

!TfStyleContext methodsFor:'accessing'!

globalStyle

	globalStyle isNil
		ifTrue: [ 	
			globalStyle := self parentContext isNil
				ifTrue: [	self styleSheet defaultStyle clone ]
				ifFalse: [ self parentContext globalStyle ].
		].
	^ globalStyle
!

globalStyle: aTfStyle

	globalStyle := aTfStyle.
	self flushGlobalStyleCaches.
!

style
	" the active style "
	" ^ TfStyle "

	style isNil
		ifTrue: [ style := self styleSheet defaultStyle ].
	^ style
!

style: aTfStyle
	" the active style "

	style := aTfStyle.
	self flushStyleCaches.
!

styleSheet
	" the active stylesheet "
	" ^ TfStyleSheet "

	^ styleSheet
!

styleSheet: aTfStyleSheet
	" the active stylesheet "
	" ^ TfStyleSheet "

	styleSheet := aTfStyleSheet.
	self flushStyleCaches.
! !

!TfStyleContext methodsFor:'cached values'!

flushGlobalStyleCaches

	self flushStyleCaches.
	self parentContext notNil
		ifTrue: [ self parentContext flushGlobalStyleCaches ].
!

flushStyleCaches

	cachedTextStyle := nil.
!

textStyle
	" ^ TextAttributes "

	cachedTextStyle isNil
		ifTrue: [	cachedTextStyle := self style fontStyle createTextStyleFor: self renderContext graphicsDevice defaultFontPolicy ].
	^ cachedTextStyle
! !

!TfStyleContext methodsFor:'genetic stuff'!

beClone

	super beClone.
	globalStyle notNil ifTrue: [ globalStyle := globalStyle clone ].
!

createChildContext

	| childContext |
	childContext := super createChildContext.
	childContext styleSheet: self styleSheet.
	^ childContext
! !

!TfStyleContext methodsFor:'private'!

setupStyleFor: aTfElement
	" initializes the style for the element.
	this may be a mix of document and user style sheets and local style definitions "
	" ^ TfStyle "

	| newStyle inheritedStyle |
	inheritedStyle := self parentContext style.
	newStyle := TfStyle new.
	newStyle styleSheet: self styleSheet.
	newStyle tagName: aTfElement tagName.
	newStyle setupStyleFrom: inheritedStyle inherited: true.
	aTfElement modifyStyle: newStyle using: self styleSheet.
	self style: newStyle.
	^ newStyle
! !

!TfStyleContext class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfStyleContext.st,v 1.1 2009/10/01 18:48:28 cg Exp $'
! !
