"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfStylePart
	instanceVariableNames:'properties style'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfStylePart class methodsFor:'instance creation'!

forStyle: aTfStyle

	^ self new
		style: aTfStyle;
		yourself
!

new

	^ super new initialize
! !

!TfStylePart methodsFor:'accessing'!

mergedWith: anotherStylePart isInherited: isInherited

	anotherStylePart modifyStylePart: self isInherited: isInherited.
	^ self
!

modifyStylePart: aTfStylePart isInherited: isInherited

	self properties do: [ :property |
		property applyTo: aTfStylePart isInherited: isInherited
	].
!

style
	" style of which I'm a part of
	^ TfStyle "

	^ style
!

style: aTfStyle
	" style of which I'm a part of "

	style := aTfStyle
! !

!TfStylePart methodsFor:'copying'!

beClone

	| newProperties |
	newProperties := Dictionary new.
	self properties keysAndValuesDo: [ :key :prop |
		newProperties at: key put: prop clone
	].
	properties := newProperties.
!

clone

	^ self copy beClone
! !

!TfStylePart methodsFor:'initialize-release'!

initialize

	properties := Dictionary new.
! !

!TfStylePart methodsFor:'properties'!

properties
	" Returns a name->property dictionary "

	^ properties
!

propertyAt: aSymbol
	" returns the property associated with the name aSymbol, or nil
	^ TfProperty | nil "

	^ self propertyAt: aSymbol ifAbsent: [ nil ]
!

propertyAt: aSymbol ifAbsent: aBlock
	" returns the property associated with the name aSymbol, or the block's value
	^ TfProperty "

	^ self properties at: aSymbol ifAbsent: aBlock value
!

propertyAt: aSymbol put: aProperty
	" sets the property associated with the name aSymbol
	^ TfProperty "

	aProperty key: aSymbol.
	^ self properties at: aSymbol put: aProperty
!

propertyAt: aSymbol putDefaultValue: aPropertyValue

	| property |
	property := self properties at: aSymbol ifAbsentPut: [ TfDefaultStyleProperty key: aSymbol ].
	property value: aPropertyValue.
	^ property
!

propertyAt: aSymbol putLocalValue: aPropertyValue

	| property |
	property := self properties at: aSymbol ifAbsentPut: [ TfLocalStyleProperty key: aSymbol ].
	property value: aPropertyValue.
	^ property
!

propertyAt: aSymbol putValue: aPropertyValue

	| property |
	property := self properties at: aSymbol ifAbsentPut: [ TfStyleProperty key: aSymbol ].
	property value: aPropertyValue.
	^ property
!

propertyAt: aSymbol putValue: aPropertyValue stopAt: inheritanceStops

	| property |
	property := self propertyAt: aSymbol putValue: aPropertyValue.
	property addInheritanceStops: inheritanceStops.
	^ property
!

propertyValueAt: aSymbol
	" returns the value of the property associated with the name aSymbol, or nil "

	^ self propertyValueAt: aSymbol ifAbsent: [ nil ]
!

propertyValueAt: aSymbol ifAbsent: aBlock
	" returns the value of the property associated with the name aSymbol, or the block's value "

	| p |
	p := self propertyAt: aSymbol ifAbsent: [ nil ].
	^p notNil
		ifTrue: [ p value ]
		ifFalse: [ aBlock value ]
! !

!TfStylePart class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfStylePart.st,v 1.1 2009/10/01 19:21:47 cg Exp $'
! !
