"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfStyleProperty
	instanceVariableNames:'value key inheritanceStops'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Styles'
!


!TfStyleProperty class methodsFor:'instance creation'!

key: aSymbol

	^ self new
		key: aSymbol;
		yourself
!

key: aSymbol value: anObject

	^ self new
		key: aSymbol;
		value: anObject;
		yourself
!

value: anObject

	^ self new
		value: anObject;
		yourself
! !

!TfStyleProperty methodsFor:'accessing'!

addInheritanceStops: tagNames
	"  inheritance stops at these tags "

	self inheritanceStops addAll: tagNames
!

applyTo: aTfStylePart isInherited: isInherited
	" apply this property to the style part "

	(inheritanceStops isNil or: [ (inheritanceStops includes: aTfStylePart style tagName) not ])
		ifTrue: [ aTfStylePart propertyAt: self key put: self clone ].
!

inheritanceStops
	" set of tag names. inheritance stops at these tags 
	(e.g. nested tables do not inherit from their paren table) "

	inheritanceStops isNil
		ifTrue: [ inheritanceStops := Set new ].
	^ inheritanceStops
!

key

	^ key
!

key: aSymbol

	key := aSymbol
!

value
	" returns the value of the property "

	^ value
!

value: anObject
	" sets the value of the property "

	value := anObject
! !

!TfStyleProperty methodsFor:'copying'!

beClone

	value notNil
		ifTrue: [ value := value copy ].
!

clone

	^ self copy beClone
! !

!TfStyleProperty methodsFor:'printing'!

printOn: aStream

	super printOn: aStream.
	aStream nextPut: $[.
	key printOn: aStream.
	aStream nextPutAll: '->'.
	value printOn: aStream.
	aStream nextPut: $].
! !

!TfStyleProperty class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfStyleProperty.st,v 1.1 2009/10/01 19:29:51 cg Exp $'
! !
