"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Model subclass:#TfStyleSheet
	instanceVariableNames:'styles defaultStyle parentStyleSheet fontScaleFactor'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfStyleSheet class methodsFor:'instance creation'!

new

	^ super new initialize
! !

!TfStyleSheet methodsFor:'accessing'!

defaultStyle
	" ^ TfStyle | nil "

	^ defaultStyle
!

defaultStyle: aTfStyle

	defaultStyle := aTfStyle
!

parentStyleSheet
	" parent style sheet from which I inherit styles "
	" ^ TfStyleSheet | nil "

	^ parentStyleSheet
!

parentStyleSheet: aTfStyleSheet
	" parent style sheet from which I inherit styles "

	parentStyleSheet := aTfStyleSheet
!

styleAt: tagName
	" Returns the best matching style for the tag "
	" ^ TfStyle | nil "

	^ self styleAt: tagName ifAbsent: [ nil ]
!

styleAt: tagName ifAbsent: aBlock
	" Returns the best matching style for the tag "
	" ^ TfStyle | nil "

	| style |
	style := self styles at: tagName ifAbsent: [nil].
	^ (style notNil or: [ self parentStyleSheet isNil ])
		ifTrue: [ style ]
		ifFalse: [ self parentStyleSheet styleAt: tagName ifAbsent: aBlock ]
!

styleOrDefaultAt: tagName
	" Returns the best matching style for the tag "
	" ^ TfStyle "

	^ self styleAt: tagName ifAbsent: [ self defaultStyle ]
! !

!TfStyleSheet methodsFor:'initialize-release'!

initialize
! !

!TfStyleSheet methodsFor:'instance creation'!

newChildStyleSheet
	" ^ TfStyleSheet "

	| styleSheet |
	styleSheet := self species new.
	styleSheet parentStyleSheet: self.
	^ styleSheet
! !

!TfStyleSheet methodsFor:'notification'!

onStyleChangeSend: methodSelector to: anObject

	self when: #styleChanged send: methodSelector to: anObject
! !

!TfStyleSheet methodsFor:'private'!

addStyle: aTfStyle

	self styleAt: aTfStyle tagName put: aTfStyle
!

changedStyle

	self triggerEvent: #styleChanged.
!

styleAt: tagName put: aTfStyle

	self styles at: tagName put: aTfStyle.
	aTfStyle styleSheet: self.
!

styles
	" ^ Dictionary "

	styles isNil
		ifTrue: [ styles := Dictionary new ].
	^ styles
! !

!TfStyleSheet class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfStyleSheet.st,v 1.1 2009/10/01 18:49:29 cg Exp $'
! !
