"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfBoxElementLayout subclass:#TfTableCellLayout
	instanceVariableNames:'spannedRows isStartRow columnInterval bottom'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfTableCellLayout class methodsFor:'instance creation'!

for: aTfView bounds: aRectangle columnInterval: anInterval spannedRows: spannedRows

	^ (self for: aTfView bounds: aRectangle)
		columnInterval: anInterval;
		spannedRows: spannedRows;
		yourself.
! !

!TfTableCellLayout methodsFor:'accessing'!

align
	" the cell itself is not aligned, only its contents "

	^ nil
!

alignFactor
	" the cell itself is not aligned, only its contents "

	^ 0
!

columnInterval

	^ columnInterval
!

columnInterval: anInterval

	columnInterval := anInterval.
!

spannedRows

	^ spannedRows
!

spannedRows: anInteger

	spannedRows := anInteger.
	isStartRow := true.
! !

!TfTableCellLayout methodsFor:'layout'!

adaptToAscent: maxAscent descent: maxDescent height: maxHeight remainingWidth: remainingWidth for: layoutContext 

	height := maxHeight.
	self parentView height: height
!

applyRowSpan: aColumnInterval to: layoutContext cellSpacing: cellSpacing

	isStartRow ifTrue: [ ^ self ].
	(self columnInterval first >= aColumnInterval first and: [ self columnInterval last <= aColumnInterval last ])
		ifTrue: [
			self applyToLayoutContext: layoutContext.
			layoutContext moveBy: cellSpacing@0.
		].
!

finishRowFor: layoutContext

	spannedRows := spannedRows - 1.
	isStartRow := false.
	^ self spannedRows >= 1
! !

!TfTableCellLayout methodsFor:'layout - private'!

applyToLayoutContext: aTfLayoutContext

	super applyToLayoutContext: aTfLayoutContext.
	(isStartRow and: [ self spannedRows > 1 ])
		ifTrue: [ aTfLayoutContext addRowSpanLayout: self ].
! !

!TfTableCellLayout class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfTableCellLayout.st,v 1.1 2009/10/01 19:44:32 cg Exp $'
! !
