"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfAbstractTableView subclass:#TfTableRowView
	instanceVariableNames:'cells'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfTableRowView methodsFor:'accessing'!

cells

	cells isNil
		ifTrue: [ cells := self components select: [ :component | component isTableCell ]].
	^ cells
!

rowIndex

	^ self xmlNode rowIndex
! !

!TfTableRowView methodsFor:'private'!

cellInset

	^ self cellPadding + self borderWidth
!

decorator

	^ nil
!

height: anInteger

	preferredBounds height: anInteger.
! !

!TfTableRowView methodsFor:'rendering'!

computeExtentFor: renderContext extentBlock: extentBlock

	| prefExt |
	prefExt := 0@0.
	self cells do: [ :component | | ext |
		ext := extentBlock value: component value: renderContext.
		prefExt x: prefExt x + ext x.
		prefExt y: (prefExt y max: ext y).
	].
	^ prefExt
!

finishOwnRendering: renderContext

	| lineLayout |
	super finishOwnRendering: renderContext.
	lineLayout := TfTableRowLayout 
					for: self 
					bounds: preferredBounds tfDeepCopy.
	lineLayout addToLayoutContext: renderContext layoutContext.
	renderContext layoutContext nextLine.
!

setupComponentRendering: renderContext

	| cellSpacing layoutContext width |
	cellSpacing := self style tableStyle cellSpacing.
	layoutContext := renderContext pushLayoutContext.
	width := layoutContext bounds width.
	layoutContext 
		alignToZero;
		reset;
		startRow.
	self cells 
		do: [ : component | self setupComponentRendering: component for: renderContext ]
		separatedBy: [ layoutContext moveBy: (cellSpacing@0) ].
	preferredBounds := 0@0 extent: width@layoutContext currentLineHeight.
	layoutContext finishRow.
	renderContext popLayoutContext.
!

updateBoundsFor: renderContext in: aRectangle
	" table rendering is finished. now update the bounds of me "

	| height singleRowHeight |
	self tfLocalTranslation: renderContext layoutContext position.
	height := 0.
	self cells do: [ : wrappedCell | 
		wrappedCell tfWrappedComponent updateBoundsFor: renderContext in: aRectangle.
		height := height max: wrappedCell preferredBounds height.
	].
	preferredBounds height: height.
	singleRowHeight := renderContext layoutContext tableLayout singleSpanRowHeightAt: self xmlNode rowIndex.
	renderContext layoutContext
		currentLineHeight: height;
		moveBy: 0@(singleRowHeight + (2*self cellInset))
! !

!TfTableRowView methodsFor:'testing'!

isTableRow

	^ true
! !

!TfTableRowView class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfTableRowView.st,v 1.1 2009/10/01 19:44:57 cg Exp $'
! !
