"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TwoflowerBrowser subclass:#TfTestApp
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-UIApplications-New'
!


!TfTestApp class methodsFor:'resources'!

debugMenu
        "MenuEditor new openOnClass: self andSelector: #debugMenu"

        <resource: #menu>
        ^#(#Menu #(
                        #(#MenuItem 
                                #rawLabel: 'Debug' 
                                #submenu: #(#Menu #(
                                                #(#MenuItem 
                                                        #rawLabel: 'Inspect document' 
                                                        #value: #inspectDocument 
                                                        #labelImage: #(#ResourceRetriever #ToolbarIconLibrary #inspectIt ) ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Inspect view' 
                                                        #value: #inspectDocumentView ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Time profile' 
                                                        #value: #timeProfile ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Allocation profile' 
                                                        #value: #allocProfile ) ) #(2 2 ) nil ) ) ) #(1 ) nil ) decodeAsLiteralArray
!

menubar

	| m |
	m := super menubar.
	m addItemGroup: self debugMenu menuItems.
	^ m
!

sourceSpec
        "UIPainter new openOnClass: self andSelector: #sourceSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 'Twoflower' 
                        #bounds: #(#Rectangle 490 282 1017 789 ) ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#TextEditorSpec 
                                        #layout: #(#LayoutFrame 3 0 3 0 -3 1 -3 1 ) 
                                        #name: #sourceID 
                                        #colors: 
                                        #(#LookPreferences 
                                                #setBackgroundColor: #(#ColorValue 7700 7700 7700 ) ) 
                                        #model: #sourceAspect 
                                        #callbacksSpec: 
                                        #(#UIEventCallbackSubSpec 
                                                #valueChangeSelector: #changedSource ) 
                                        #tabRequiresControl: true ) ) ) )
! !

!TfTestApp methodsFor:'actions'!

allocProfile

	#{Tools.AllocationProfiler}
		ifDefinedDo: [ : cl |
			Cursor wait showWhile: [ cl profile: [ 50 timesRepeat: [ self activeEmbeddedApplication render ]]]
		] elseDo: [ 
			Dialog warn: 'AllocationProfiler not installed'
		].
!

inspectDocument

	self activeBrowserWindowModel resourceModel inspectResource
!

inspectDocumentView

	self activeEmbeddedApplication inspectView
!

timeProfile

	#{Tools.TimeProfiler}
		ifDefinedDo: [ : cl |
			Cursor wait showWhile: [ cl new howOften: 1; profile: [ 100 timesRepeat: [ self activeEmbeddedApplication render ]]]
		] elseDo: [ 
			Dialog warn: 'TimeProfiler not installed'
		].
! !

!TfTestApp class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfTestApp.st,v 1.1 2009/10/01 23:41:58 cg Exp $'
! !
