"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

XML::Text subclass:#TfText
	instanceVariableNames:'dependents textWithoutWhitespace'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-HTML'
!


!TfText methodsFor:'CSS'!

modifyStyle: aTfStyle
	" modify the style according to the local style definitions "
	" there are no local definitions, so do nothing "
! !

!TfText methodsFor:'accessing'!

documentModel

	^ self parent documentModel
!

parsingFinished
!

remove

	self parent removeNode: self.
	self changed: #removed
!

textWithoutWhitespace

	textWithoutWhitespace isNil
		ifTrue: [ textWithoutWhitespace := self text tfWithoutWhitespaces ].
	^ textWithoutWhitespace
! !

!TfText methodsFor:'copying'!

postCopy
	"Do not copy the dependents list."

	super postCopy.
	self breakDependents
! !

!TfText methodsFor:'menu actions'!

exportTableOn: aStream columns: numberOfColumns emit: aBoolean

	aBoolean
		ifTrue: [ 
			" to do: check stream encoding instead of hardcoded byte check "
			self text do: [ : ch |
				ch asInteger < 256
					ifTrue: [ aStream nextPut: ch ]
			].
		].
! !

!TfText methodsFor:'printing'!

tfTreeDisplayString

	| i s |
	(text isNil or: [ text isEmpty ])
		ifTrue: [ ^ '(Empty text)' asText emphasizeAllWith: #color -> ColorValue lightGray ].
	text tfIsWhitespaceOnly
		ifTrue: [ ^ '(Whitespace)' asText emphasizeAllWith: #color -> ColorValue lightGray ].
	s := text copyWithout: Character cr.
	i := s size min: 20.
	s := s copyFrom: 1 to: i.
	i < text size
		ifTrue: [ s := s, '...' ].
	^ s
! !

!TfText methodsFor:'private'!

myDependents
	"Answer the receiver's dependents or nil."

	^dependents
!

myDependents: dependentsOrNil
	"Set the receivers dependents."

	dependents := dependentsOrNil
! !

!TfText methodsFor:'testing'!

isDiscarded

	^ super isDiscarded or: [ self text isEmpty ]
! !

!TfText methodsFor:'views'!

tfComponents

	^ #()
!

tfViewClass

	^ TfTextView
! !

!TfText class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfText.st,v 1.1 2009/10/01 18:54:13 cg Exp $'
! !
