"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Rectangle subclass:#TfTextSelection
	instanceVariableNames:'startView stopView textStream pendingTextStream selectionMode'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfTextSelection class methodsFor:'instance creation'!

view: aVisualPart at: aPoint

	^ (self origin: aPoint corner: aPoint)
		startView: aVisualPart
!

view: aVisualPart at: aPoint extent: extent

	^ (self origin: aPoint extent: extent)
		startView: aVisualPart
! !

!TfTextSelection methodsFor:'accessing'!

pendingTextStream

	^ pendingTextStream
!

releaseTextStream

	textStream := nil
!

selectionMode
	" one of #(nil #word) "

	^ selectionMode
!

selectionMode: aSymbolOrNil
	" one of #(nil #word) "

	selectionMode := aSymbolOrNil
!

startTextStream

	textStream := TextStream on: (String new: 64).
	pendingTextStream := (String new: 64) writeStream.
!

startView

	^startView
!

startView: aVisualPart

	startView := aVisualPart
!

stopView

	^stopView
!

stopView: aVisualPart

	stopView := aVisualPart
!

text

	^ textStream contents
!

textStream

	^ textStream
!

textStreamAppendDo: aBlock

	textStream notNil
		ifTrue: [ 
			 pendingTextStream position > 0 
				ifTrue: [ 
					textStream position > 0
						ifTrue: [ 	textStream nextPutAll: pendingTextStream contents ].
					pendingTextStream := (String new: 64) writeStream
				].
			aBlock value: textStream
		]
!

textStreamPendingDo: aBlock

	textStream notNil
		ifTrue: [ aBlock value: pendingTextStream ]
!

tfMerge: aRectangle

	origin := origin min: aRectangle origin.
	corner := corner max: aRectangle corner.
! !

!TfTextSelection methodsFor:'printing'!

printOn: aStream 

	super printOn: aStream.
"	aStream nextPutAll: ' {'.
	startView printOn: aStream.
	aStream nextPutAll: ', '.
	stopView printOn: aStream.
	aStream nextPutAll: '}'."
! !

!TfTextSelection class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfTextSelection.st,v 1.1 2009/10/01 19:45:14 cg Exp $'
! !
