"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

ScrollingTracker subclass:#TfTextSelectionTracker
	instanceVariableNames:'topDocumentView textSelection translation'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Interface-Events-Trackers'
!


!TfTextSelectionTracker methodsFor:'private'!

cursorPointFor: aMouseEvent

	^ (super cursorPointFor: aMouseEvent) + self translation
!

finishSelectionFor: aPoint

	topDocumentView isOpen
		ifTrue: [ 	
			textSelection extent abs < (3@3)
				ifTrue: [ topDocumentView clearTextSelection ]
				ifFalse: [ topDocumentView finalizeTextSelection ].
		]
		ifFalse: [ 
			self shutdownBecauseOfError 
		].
	super finishSelectionFor: aPoint.
!

mousePointFor: aMouseEvent

	^ (super mousePointFor: aMouseEvent) + self translation
!

setUpFor: aMouseButtonEvent

	super setUpFor: aMouseButtonEvent.
	topDocumentView := self view tfTopDocumentView.
	textSelection := TfTextSelection view: self view at: (self mousePointFor: aMouseButtonEvent).
	topDocumentView textSelection: textSelection.
	topDocumentView invalidate.
!

trackSelectionFor: aPoint 

	textSelection corner: aPoint.
	topDocumentView isOpen
		ifTrue: [ 	topDocumentView updateTextSelectionAt: aPoint ]
		ifFalse: [ self shutdownBecauseOfError ].
!

translation

	translation isNil
		ifTrue: [ translation := self view documentOffset ].
	^ translation
! !

!TfTextSelectionTracker class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfTextSelectionTracker.st,v 1.1 2009/10/02 00:06:35 cg Exp $'
! !
