"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfElementLayout subclass:#TfTextViewLine
	instanceVariableNames:'startIndex stopIndex lineIndex bounds ascent descent
		isWhitespaceOnly selectionStartIndex selectionStopIndex
		selectionBounds translation'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfTextViewLine methodsFor:'accessing'!

ascent

	^ ascent
!

ascent: anInteger

	ascent := anInteger
!

bounds

	^ bounds
!

bounds: aRectangle

	bounds := aRectangle
!

descent

	^ descent
!

descent: anInteger

	descent := anInteger
!

deselect

	selectionStartIndex := nil.
	selectionStopIndex := nil.
	selectionBounds := nil.
!

indexInterval

	^ self startIndex to: stopIndex
!

isInvisibleElement

	^ self isWhitespaceOnly
!

isWhitespaceOnly

	isWhitespaceOnly isNil
		ifTrue: [ isWhitespaceOnly := false ].
	^ isWhitespaceOnly
!

isWhitespaceOnly: aBoolean

	isWhitespaceOnly := aBoolean
!

lineIndex

	^ lineIndex
!

lineIndex: anInteger

	lineIndex := anInteger
!

localBounds

	^ self bounds translatedBy: self translation negated
!

selectionBounds

	^ selectionBounds
!

selectionBounds: aRectangle

	selectionBounds := aRectangle
!

selectionInterval

	^ selectionStartIndex notNil
		ifTrue: [  selectionStartIndex to: selectionStopIndex ]
		ifFalse: [ nil ]
!

selectionStartIndex

	^ selectionStartIndex
!

selectionStartIndex: anInteger

	selectionStartIndex := anInteger
!

selectionStopIndex

	^ selectionStopIndex
!

selectionStopIndex: anInteger

	selectionStopIndex := anInteger
!

startIndex

	^ startIndex
!

startIndex: anInteger

	startIndex := anInteger
!

stopIndex

	^ stopIndex
!

stopIndex: anInteger

	stopIndex := anInteger
!

tfLocalTranslateBy: aPoint

	bounds := bounds translatedBy: aPoint
!

translateBy: aPoint

	self bounds: (self bounds translatedBy: aPoint)
!

translation
	" local translation "
	^ translation
!

translation: aPoint
	" local translation "

	translation := aPoint
! !

!TfTextViewLine methodsFor:'layout'!

adaptToAscent: maxAscent descent: maxDescent height: maxHeight remainingWidth: remainingWidth for: layoutContext 

	| delta deltaY deltaX |
	deltaY := ((maxAscent - self ascent) max: (maxHeight - maxDescent - self ascent)) max: 0.
	deltaX := self alignmentDeltaFor: remainingWidth.
	delta := deltaX@deltaY.
	delta ~= (0@0)
		ifTrue: [ self parentView translateLineAt: self lineIndex by: delta ]
! !

!TfTextViewLine methodsFor:'layout - private'!

applyPositionTo: aTfLayoutContext

	aTfLayoutContext position: self bounds topRight
! !

!TfTextViewLine class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfTextViewLine.st,v 1.1 2009/10/01 19:45:42 cg Exp $'
! !
