"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TranslatingWrapper subclass:#TfTranslatingWrapper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfTranslatingWrapper methodsFor:'accessing'!

layer

	^ self component layer
!

listContainer

	^ self container listContainer
!

removeComponent: aVisualComponent

	aVisualComponent = self component
		ifTrue: [ self container removeComponent: self ].
!

tfTranslatingWrapper

	^ self
!

translateBy: aPoint

	self translation: self translation + aPoint
!

translation: aPoint

	self translation ~= aPoint
		ifTrue: [ self setOrigin: aPoint ].
! !

!TfTranslatingWrapper methodsFor:'printing'!

printOn: aStream
	"Print the receiver and the receiver's component on aStream."

	aStream nextPutAll: self class printString.
	aStream 
		nextPutAll:'['; 
		nextPutAll: self translation printString;
		nextPutAll: '] on: '.
	self component printOn: aStream
! !

!TfTranslatingWrapper methodsFor:'rendering'!

flushRenderingCaches: needsMeasuring
	" prepare the view for rendering "

	self component flushRenderingCaches: needsMeasuring
!

measureExtentFor: renderContext

	self component measureExtentFor: renderContext.
!

minimalExtentFor: renderContext

	^ self component minimalExtentFor: renderContext
!

preferredExtentFor: renderContext

	^ self component preferredExtentFor: renderContext
!

setupRendering: renderContext
	" prepare the view for rendering "

	self translation: 0@0.
	self component setupRendering: renderContext.
!

styleContext

	^ self container styleContext
! !

!TfTranslatingWrapper methodsFor:'testing'!

canBeDiscarded

	^ self component canBeDiscarded
!

isTableCell

	^ self component isTableCell
!

isTableRow

	^ self component isTableRow
! !

!TfTranslatingWrapper class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfTranslatingWrapper.st,v 1.1 2009/10/01 19:46:03 cg Exp $'
! !
