"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Object subclass:#TfURLHolder
	instanceVariableNames:'description container'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Base'
!


!TfURLHolder class methodsFor:'instance creation'!

description: aString

	^ self new
		description: aString;
		yourself
! !

!TfURLHolder methodsFor:'accessing'!

bookmarkContainer

	^ self container
!

container

	^ container
!

container: aTfURLContainer

	container := aTfURLContainer
!

description

	^ description
!

description: aString

	description := aString
!

openBookmarkEditor

	" cannot edit "
	^ nil
!

removeFromBookmarks

	| c |
	(c := self container) notNil
		ifTrue: [ c removeBookmark: self ].
!

showInTree

	^ true
!

treeChildren

	^ #()
!

treeIcon

	^ TfIconLibrary visualFor: #bookmarkURLIcon
!

treeSelectedIcon

	^ self treeIcon
!

url

	^ nil
! !

!TfURLHolder methodsFor:'import/export'!

exportNetscapeBookmarksTo: aStream
!

exportOperaBookmarksTo: aStream
!

importOperaKey: key value: value

	key = 'NAME'
		ifTrue: [ ^ self description: value ].
!

isURLBookmark

	^ false
! !

!TfURLHolder methodsFor:'printing'!

displayString

	^ self description notNil
		ifTrue: [ self description ]
		ifFalse: [ super displayString ]
!

printOn: aStream

	^ self description notNil
		ifTrue: [ aStream nextPutAll: self description ]
		ifFalse: [ super printOn: aStream ]
!

treeDisplayString

	^ self description notNil
		ifTrue: [ self description ]
		ifFalse: [ String new ]
! !

!TfURLHolder methodsFor:'private'!

depth

	^ self container notNil
		ifTrue: [ self container depth + 1 ]
		ifFalse: [ 0 ]
! !

!TfURLHolder class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfURLHolder.st,v 1.1 2009/10/01 18:06:44 cg Exp $'
! !
