"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfResourceWindowModel subclass:#TfWidgetModel
	instanceVariableNames:'clientDictionary menuSelector'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Widget'
!

TfWidgetModel comment:'Model of an HTML widget'
!


!TfWidgetModel methodsFor:'accessing'!

changeHTMLString: aString

	| m |
	m := TfDocumentModel changeHTMLString: aString.
	self resourceModel: m.
!

changeHTMLString: aString baseURL: anURL

	| m |
	m := TfDocumentModel changeHTMLString: aString.
	anURL notNil
		ifTrue: [ m urlDescriptor: anURL tfAsURLDescriptor ].
	self resourceModel: m.
!

clientDictionary
	" dictionary that can be used by classes utilizing Twoflower "

	clientDictionary isNil
		ifTrue: [ clientDictionary := Dictionary new ].
	^ clientDictionary
!

htmlDocument: doc

	| m |
	m := TfDocumentModel new.
	m document: doc.
	self resourceModel: m.
!

htmlString

	^ self resourceModel htmlString
!

htmlString: aString

	| m |
	m := TfDocumentModel htmlString: aString.
	self resourceModel: m.
!

htmlString: aString baseURL: anURL

	| m |
	m := TfDocumentModel htmlString: aString.
	anURL notNil
		ifTrue: [ m urlDescriptor: anURL tfAsURLDescriptor ].
	self resourceModel: m.
!

menuFor: aTfElement

	^ aTfElement perform: self menuSelector
!

menuSelector

	menuSelector isNil
		ifTrue: [ menuSelector := #widgetBrowserMenu ].
	^ menuSelector
!

menuSelector: methodSelector

	menuSelector := methodSelector
! !

!TfWidgetModel methodsFor:'comfy'!

defaultPixelSize: anInteger

	^self browserModel settings defaultPixelSize: anInteger
! !

!TfWidgetModel class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfWidgetModel.st,v 1.1 2009/10/01 19:52:58 cg Exp $'
! !
