"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

TfDocumentWrapper subclass:#TfWidgetWrapper
	instanceVariableNames:'state keepScrollPosition margin'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfWidgetWrapper methodsFor:'accessing'!

keepScrollPosition: aBoolean
	" keep scroll position when updating the view? "

	keepScrollPosition := aBoolean
!

widgetState

	^state
!

widgetState: aWidgetState

	state := aWidgetState
! !

!TfWidgetWrapper methodsFor:'initialize-release'!

initialize

	super initialize.
	state := WidgetState new.
	keepScrollPosition := false.
! !

!TfWidgetWrapper methodsFor:'private'!

composeAndInvalidate

	| oldPos |
	self isOpen
		ifTrue: [
			oldPos := (keepScrollPosition and: [ self scrollOffsetHolder notNil ])
				ifTrue: [ 	self scrollOffsetHolder value ]
				ifFalse: [ 0@0 ].
			self bounds: self bounds.
			self scrollOffsetHolder notNil
				ifTrue: [ self scrollOffsetHolder valueWithoutDisplaying: oldPos ].
			self invalidate
		]
!

margin

	^ margin notNil
		 ifTrue: [ margin ] 
		ifFalse: [ super margin ]
!

margin: aRectangle

	margin := aRectangle
!

resourceWindowModel: aTfResourceWindowModel

	super resourceWindowModel: aTfResourceWindowModel.
	aTfResourceWindowModel onResourceChangeSend: #updateComponent to: self.
	self updateComponent.
!

updateComponent

	| res view kbd window |
	(self component notNil and: [ self isOpen not ]) ifTrue: [ ^ self ].
	res := self resourceWindowModel resourceModel.
	res notNil
		ifTrue: [ 
			window := self topComponent.
			kbd := window notNil ifTrue: [ window keyboardProcessor ] ifFalse: [ nil ].
			view := res createViewWithKeyboard: kbd.
			self component release.
			self component: view.
		]
! !

!TfWidgetWrapper class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfWidgetWrapper.st,v 1.1 2009/10/01 19:49:26 cg Exp $'
! !
