"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

Wrapper subclass:#TfWrapper
	instanceVariableNames:'model'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-Views'
!


!TfWrapper class methodsFor:'instance creation'!

model: aModel
	"Create a new instance of the receiver with model aModel."

	^self new model: aModel
! !

!TfWrapper methodsFor:'accessing'!

alignment

	^ self component alignment
!

removeComponent: aVisualComponent

	aVisualComponent = self component
		ifTrue: [ self container removeComponent: self ].
! !

!TfWrapper methodsFor:'initialize-release'!

release
	"Remove the receiver as a dependent of its model."

	model removeDependent: self.
	super release
! !

!TfWrapper methodsFor:'model stuff'!

model
	"Answer the receiver's model."

	^model
!

model: aModel 
	"Set the receiver's model to aModel."

	self setModel: aModel
! !

!TfWrapper methodsFor:'private'!

setModel: aModel
	"Set the receiver's model to be aModel."

	( model == aModel )
		ifFalse:	[ model isNil
					ifFalse: [ model removeDependent: self ].
				(model := aModel) isNil
					ifFalse: [ model addDependent: self ] ].
! !

!TfWrapper methodsFor:'rendering'!

flushRenderingCaches: needsMeasuring
	" prepare the view for rendering "
!

layer
	" layer of this view. Twoflower views sometimes overlap other views, so layers are required
	for correctly dispatching events "

	^ 0
!

measureExtentFor: renderContext
!

setupRendering: renderContext
	" prepare the view for rendering "

	self component setupRendering: renderContext
!

styleContext

	^ self container styleContext
! !

!TfWrapper methodsFor:'testing'!

canBeDiscarded

	^ false
!

isTableCell

	^ false
!

isTableRow

	^ self component isTableRow
! !

!TfWrapper class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TfWrapper.st,v 1.1 2009/10/01 19:52:10 cg Exp $'
! !
