"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

ApplicationModel subclass:#TwoflowerBrowser
	instanceVariableNames:'urlAspect browserModel progressAspect statusAspect tabsAspect
		tabModels animationProcess animationImage sidebarApp styleSheet'
	classVariableNames:'ShowSidebar'
	poolDictionaries:''
	category:'Twoflower'
!


!TwoflowerBrowser class methodsFor:'initialize-release'!

initializeSystem

	TfElement flushRegisteredElements.
	TfCSSStyleReader flushSingleton.
	TfHTMLValueReader flushSingleton.
	TfImageModel flushReaders.
	TfIconLibrary flush.
! !

!TwoflowerBrowser class methodsFor:'interface specs'!

embeddedSpec
        "Tools.UIPainter new openOnClass: self andSelector: #embeddedSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 'Twoflower' 
                        #min: #(#Point 300 250 ) 
                        #max: #(#Point 2000 2000 ) 
                        #bounds: #(#Rectangle 656 451 1206 951 ) ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#TabControlSpec 
                                        #layout: #(#LayoutFrame 0 0 0 0 0 1 0 1 ) 
                                        #name: #embeddedAppID 
                                        #model: #tabsAspect 
                                        #labels: #() ) ) ) )
!

fullEmbeddedSpec
        "Tools.UIPainter new openOnClass: self andSelector: #fullEmbeddedSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 'Twoflower' 
                        #min: #(#Point 300 250 ) 
                        #max: #(#Point 2000 2000 ) 
                        #bounds: #(#Rectangle 640 407 1190 907 ) ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#SubCanvasSpec 
                                        #layout: #(#LayoutFrame 0 0 0 0 157 0 0 1 ) 
                                        #name: #sidebarID 
                                        #flags: 0 ) 
                                #(#SubCanvasSpec 
                                        #layout: #(#LayoutFrame 163 0 0 0 0 1 0 1 ) 
                                        #name: #rightID 
                                        #flags: 0 
                                        #minorKey: #embeddedSpec ) 
                                #(#{UI.ResizingSplitterSpec} 
                                        #layout: #(#LayoutFrame 157 0 0 0 163 0 0 1 ) 
                                        #name: #ResizingSplitter1 
                                        #horizontal: false 
                                        #minAboveSize: 30 
                                        #minBelowSize: 30 
                                        #aboveWidgets: 'sidebarID' 
                                        #belowWidgets: 'rightID' ) ) ) )
!

statusSpec
        "UIPainter new openOnClass: self andSelector: #statusSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 'Twoflower' 
                        #bounds: #(#Rectangle 631 343 1158 850 ) ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#InputFieldSpec 
                                        #layout: #(#LayoutFrame 1 0 -25 1 -100 1 -1 1 ) 
                                        #name: #statusID 
                                        #model: #statusAspect 
                                        #isReadOnly: true ) 
                                #(#ProgressWidgetSpec 
                                        #layout: #(#LayoutFrame -95 1 -25 1 -1 1 -1 1 ) 
                                        #name: #progressID 
                                        #isOpaque: true 
                                        #model: #progressAspect 
                                        #direction: #horizontal 
                                        #position: #topLeft 
                                        #area: true 
                                        #reverse: false ) ) ) )
!

urlSpec
        "Tools.UIPainter new openOnClass: self andSelector: #urlSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 'Twoflower' 
                        #bounds: #(#Rectangle 640 512 1167 1019 ) ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#LabelSpec 
                                        #layout: #(#Point 3 3 ) 
                                        #name: #Label1 
                                        #label: 'URL:' ) 
                                #(#ArbitraryComponentSpec 
                                        #layout: #(#LayoutFrame -20 1 7 0 -3 1 28 0 ) 
                                        #name: #animationID 
                                        #flags: 0 
                                        #component: #animationWrapper ) 
                                #(#InputFieldSpec 
                                        #layout: #(#LayoutFrame 40 0 3 0 -25 1 28 0 ) 
                                        #name: #InputField1 
                                        #model: #urlAspect 
                                        #callbacksSpec: 
                                        #(#UIEventCallbackSubSpec 
                                                #valueChangeSelector: #openURL ) ) ) ) )
!

windowSpec
        "Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

        <resource: #canvas>
        ^#(#FullSpec 
                #window: 
                #(#WindowSpec 
                        #label: 'Twoflower' 
                        #min: #(#Point 300 250 ) 
                        #max: #(#Point 2000 2000 ) 
                        #bounds: #(#Rectangle 640 512 1190 1012 ) 
                        #flags: 4 
                        #menu: #menubar 
                        #toolBar: #toolbar ) 
                #component: 
                #(#SpecCollection 
                        #collection: #(
                                #(#SubCanvasSpec 
                                        #layout: #(#LayoutFrame 2 0 -27 1 -2 1 0 1 ) 
                                        #name: #Subcanvas1 
                                        #flags: 0 
                                        #minorKey: #statusSpec ) 
                                #(#SubCanvasSpec 
                                        #layout: #(#LayoutFrame 0 0 0 0 0 1 32 0 ) 
                                        #name: #Subcanvas2 
                                        #flags: 0 
                                        #minorKey: #urlSpec ) 
                                #(#SubCanvasSpec 
                                        #layout: #(#LayoutFrame 0 0 30 0 0 1 -30 1 ) 
                                        #name: #embeddedCanvasID 
                                        #flags: 0 ) ) ) )
! !

!TwoflowerBrowser class methodsFor:'resources'!

bookmarksMenu
        "Tools.MenuEditor new openOnClass: self andSelector: #bookmarksMenu"

        <resource: #menu>
        ^#(#Menu #(
                        #(#MenuItem 
                                #rawLabel: 'Import bookmarks...' 
                                #value: #importBookmarks 
                                #helpText: 'Import bookmarks' ) 
                        #(#MenuItem 
                                #rawLabel: 'Export bookmarks...' 
                                #value: #exportBookmarks ) ) #(2 ) nil ) decodeAsLiteralArray
!

menubar
        "Tools.MenuEditor new openOnClass: self andSelector: #menubar"

        <resource: #menu>
        ^#(#Menu #(
                        #(#MenuItem 
                                #rawLabel: 'File' 
                                #submenu: #(#Menu #(
                                                #(#MenuItem 
                                                        #rawLabel: 'Open file...' 
                                                        #value: #openFile 
                                                        #shortcutKeyCharacter: $O 
                                                        #shortcutModifiers: 2 
                                                        #labelImage: #(#ResourceRetriever #TwoflowerBrowser #fileOpen ) 
                                                        #helpText: 'Open HTML file' ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Print' 
                                                        #value: #print 
                                                        #shortcutKeyCharacter: $P 
                                                        #shortcutModifiers: 2 
                                                        #labelImage: #(#ResourceRetriever #TwoflowerBrowser #printIt ) 
                                                        #helpText: 'Print' ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Exit' 
                                                        #value: #closeRequest 
                                                        #shortcutKeyCharacter: $Q 
                                                        #shortcutModifiers: 2 
                                                        #helpText: 'Exit' ) ) #(2 1 ) nil ) ) 
                        #(#MenuItem 
                                #rawLabel: 'Edit' 
                                #submenu: #(#Menu #(
                                                #(#MenuItem 
                                                        #rawLabel: 'Select all' 
                                                        #value: #selectAll 
                                                        #shortcutKeyCharacter: $A 
                                                        #shortcutModifiers: 2 ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Copy' 
                                                        #value: #copyTextToClipboard 
                                                        #shortcutKeyCharacter: $c 
                                                        #shortcutModifiers: 2 ) ) #(2 ) nil ) ) 
                        #(#MenuItem 
                                #rawLabel: 'Navigation' 
                                #submenu: #(#Menu #(
                                                #(#MenuItem 
                                                        #rawLabel: 'Back' 
                                                        #value: #goBack 
                                                        #enablementSelector: #canNavigate 
                                                        #shortcutKeyCharacter: #Left 
                                                        #shortcutModifiers: 8 
                                                        #labelImage: #(#ResourceRetriever #TwoflowerBrowser #previous ) 
                                                        #helpText: 'Go back' ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Forward' 
                                                        #value: #goForward 
                                                        #enablementSelector: #canNavigate 
                                                        #shortcutKeyCharacter: #Right 
                                                        #shortcutModifiers: 8 
                                                        #labelImage: #(#ResourceRetriever #TwoflowerBrowser #next ) 
                                                        #helpText: 'Go forward' ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Reload' 
                                                        #value: #reload 
                                                        #shortcutKeyCharacter: $R 
                                                        #shortcutModifiers: 2 
                                                        #labelImage: #(#ResourceRetriever #TwoflowerBrowser #undo ) 
                                                        #helpText: 'Reload' ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Stop loading' 
                                                        #value: #stopLoadingPage 
                                                        #labelImage: #(#ResourceRetriever #ToolbarIconLibrary #deleteIcon ) ) ) #(4 ) nil ) ) 
                        #(#MenuItem 
                                #rawLabel: 'Bookmarks' 
                                #nameKey: #bookmarksMenuID 
                                #submenu: #(#Menu #(
                                                #(#MenuItem 
                                                        #rawLabel: '-' 
                                                        #helpText: 'Import bookmarks' ) ) #(1 ) nil ) ) 
                        #(#MenuItem 
                                #rawLabel: 'View' 
                                #submenu: #(#Menu #(
                                                #(#MenuItem 
                                                        #rawLabel: 'Create new tab' 
                                                        #value: #createBrowserWindowModel 
                                                        #shortcutKeyCharacter: $T 
                                                        #shortcutModifiers: 2 ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Close active tab' 
                                                        #value: #closeActiveWindowModel 
                                                        #enablementSelector: #canCloseTab 
                                                        #shortcutKeyCharacter: $W 
                                                        #shortcutModifiers: 2 ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Show source' 
                                                        #value: #showSource 
                                                        #enablementSelector: #canShowSource ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Sidebar' 
                                                        #value: #toggleSidebar 
                                                        #indication: true 
                                                        #indicationSelector: #isSidebarEnabled ) 
                                                #(#MenuItem 
                                                        #rawLabel: 'Load images' 
                                                        #value: #toggleLoadImages 
                                                        #indication: true 
                                                        #indicationSelector: #loadImages ) ) #(3 2 ) nil ) ) 
                        #(#MenuItem 
                                #rawLabel: 'Help' 
                                #submenu: #(#Menu #(
                                                #(#MenuItem 
                                                        #rawLabel: 'About' 
                                                        #value: #gotoAbout 
                                                        #labelImage: #(#ResourceRetriever #TwoflowerBrowser #help ) ) ) #(1 ) nil ) ) ) #(6 ) nil ) decodeAsLiteralArray
!

toolbar
        "MenuEditor new openOnClass: self andSelector: #toolbar"

        <resource: #menu>
        ^#(#Menu #(
                        #(#MenuItem 
                                #rawLabel: 'Back' 
                                #value: #goBack 
                                #shortcutKeyCharacter: #Left 
                                #shortcutModifiers: 8 
                                #labelImage: #(#ResourceRetriever #TwoflowerBrowser #previous ) 
                                #helpText: 'Go back' ) 
                        #(#MenuItem 
                                #rawLabel: 'Forward' 
                                #value: #goForward 
                                #shortcutKeyCharacter: #Right 
                                #shortcutModifiers: 8 
                                #labelImage: #(#ResourceRetriever #TwoflowerBrowser #next ) 
                                #helpText: 'Go forward' ) 
                        #(#MenuItem 
                                #rawLabel: 'Reload' 
                                #value: #reload 
                                #shortcutKeyCharacter: $R 
                                #shortcutModifiers: 2 
                                #labelImage: #(#ResourceRetriever #TwoflowerBrowser #undo ) 
                                #helpText: 'Reload' ) 
                        #(#MenuItem 
                                #rawLabel: 'Stop loading' 
                                #value: #stopLoadingPage 
                                #labelImage: #(#ResourceRetriever #ToolbarIconLibrary #deleteIcon ) 
                                #helpText: 'Stop loading' ) ) #(4 ) nil ) decodeAsLiteralArray
!

visualFor: aSelector

	^ [
		ToolbarIconLibrary visualFor: aSelector
	] on: Error do: [ :ex |
		nil
	].
! !

!TwoflowerBrowser methodsFor:'actions'!

closeActiveWindowModel

	| bwm |
	self canCloseTab ifFalse: [ ^ self ].
	bwm := self activeBrowserWindowModel.
	bwm shutDown.
	self browserModel removeWindowModel: bwm
!

copyTextToClipboard

	| app |
	(app := self activeEmbeddedApplication) notNil
		ifTrue: [
			app copyTextToClipboard
		].
!

createBrowserWindowModel

	| bwm |
	bwm := TfResourceWindowModel new.
	bwm
		onNavigationSend: #navigateTo:browserWindowModel: to: self;
		onNavigationInPageSend: #changedNavigationInPage:browserWindowModel: to: self;
		onResourceChangeSend: #changedResource:browserWindowModel: to: self.
	bwm formBuilder: self builder newSubBuilder.
	self browserModel addWindowModel: bwm.
	^ bwm
!

exportBookmarks

	| dialog bm |
	(bm := self browserModel bookmarks) isNil
		ifTrue: [ ^ self ].
	dialog := TfBookmarksSaveDialog new.
	dialog open.
	dialog accept value
		ifFalse: [ ^ self ].
	self actionDo: [
		[
			dialog readerWriterClass export: bm toFile: dialog location.
		] on: Error do: [ : ex |
			Dialog warn: 'Unable to save bookmarks (', ex description, ')'.
		].
	].
!

goBack

	| bwm |
	(bwm := self activeBrowserWindowModel) canNavigate
		ifFalse: [ ^ self ].
	self actionDo: [
		bwm navigationModel goBack
	].
!

goForward

	| bwm |
	(bwm := self activeBrowserWindowModel) canNavigate
		ifFalse: [ ^ self ].
	self actionDo: [
		bwm navigationModel goForward
	].
!

goto: url

	self actionDo: [
		 self resourceWindowModelNeeded navigationModel goto: url
	].
!

gotoAbout

	self goto: TfResources aboutURL
!

importBookmarks

	| dialog bm |
	dialog := TfBookmarksLoadDialog new.
	dialog open.
	dialog accept value
		ifFalse: [ ^ self ].
	self actionDo: [
		[
			bm := dialog readerWriterClass importFromFile: dialog location.
			self browserModel bookmarks: bm.
		] on: Error do: [ : ex |
			Dialog warn: 'Unable to load bookmarks (', ex description, ')'
		].
	].
!

openFile

	| filename |
	filename := Dialog requestFileName: 'Open HTML file' default: '*.html' for: nil.
	filename isEmpty
		ifFalse:[ self goto: filename asFilename asURI ].
!

openURL

	| urlString url file |
	urlString := self urlAspect value.
	(Net.URL tfLooksLikeURL: urlString asString)
		ifTrue: [
			url := [ 
					urlString tfAsURL
				] on: Error do: [ : ex |
					Log log: 'Could not parse URL (', ex description, ')'.
					nil
				].
		].
	url isNil
		ifTrue: [ 
			[ 
				((file := urlString asFilename) exists and: [ file isAbsolute ])
					ifTrue: [ url := file asURI ].
			] on: Error do: [ : ex | ].
			url isNil
				ifTrue: [
					Log log: 'Using Google'.
					url := self googleSearchURLFor: urlString
				].
		].
	self goto: url
!

print

	| printJob docView margins bounds gc mockMedium |
	self actionDo: [
		printJob := self printerClass default startPrintJobNamed: 'Twoflower'.
		margins := 30@30.
		docView := self activeBrowserWindowModel resourceModel createViewWithKeyboard: nil.
		docView notNil
			ifTrue: [
				mockMedium := TfMockMedium 
									on: docView
									in: (16@16 extent: printJob extent - (16@16))
									for: printJob.
				bounds := ((0@0 extent: printJob extent) insetBy: margins) rounded.
				docView bounds: bounds.
				gc := printJob graphicsContext.
				gc scale: (72/96) asFloat asPoint.
				mockMedium display.
				printJob print.
			].
	].
!

reload

	| bwm |
	(bwm := self activeBrowserWindowModel) notNil
		ifTrue: [ self actionDo: [ bwm reload ]].
!

selectAll

	| app |
	(app := self activeEmbeddedApplication) notNil
		ifTrue: [
			app selectAll
		].
!

showSource

	| sourceBwm sourceModel rm |
	self canShowSource ifFalse: [^ nil ].
	rm := self activeBrowserWindowModel resourceModel.
	sourceBwm := self createBrowserWindowModel.
	sourceModel := TfSourceCodeModel new.
	sourceModel 
		text: rm sourceText;
		title: 'Source of ', rm title.
	sourceBwm resourceModel: sourceModel.
	^ sourceModel
!

stopLoadingPage

	self actionDo: [
		self resourceManager cancelAllRequests
	].
!

toggleSidebar

	self settings showSidebar: self settings showSidebar not.
	sidebarApp notNil
		ifTrue: [ 
			sidebarApp shutDown.
			sidebarApp := nil.
		].
	self showEmbeddedSpec.
	self showSidebar.
	self tabChanged.
! !

!TwoflowerBrowser methodsFor:'aspects'!

animationWrapper

	^ BoundedWrapper on: self emptyAnimationView
!

progressAspect
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^progressAspect isNil
		ifTrue:
			[progressAspect := 0 asValue]
		ifFalse:
			[progressAspect]
!

sidebarApp

	sidebarApp isNil
		ifTrue: [
			sidebarApp := Twoflower.TfSidebarApp on: self.
			sidebarApp addDependent: self.
		].
	^ sidebarApp
!

statusAspect
        "This method was generated by UIDefiner.  Any edits made here
        may be lost whenever methods are automatically defined.  The
        initialization provided below may have been preempted by an
        initialize method."

        ^statusAspect isNil
                ifTrue:
                        [statusAspect := Text new asValue]
                ifFalse:
                        [statusAspect]
!

tabsAspect

	tabsAspect isNil
		ifTrue: [
			tabsAspect := SelectionInList new.
			tabsAspect list: List new.
			self tabsAspect selectionHolder onChangeSend: #tabChanged to: self.
		].
	^ tabsAspect
!

urlAspect

	urlAspect isNil
		ifTrue: [
			urlAspect := String new asValue.
		].
	^ urlAspect
! !

!TwoflowerBrowser methodsFor:'interface opening'!

noticeOfWindowClose: aWindow 

	self shutDown.
	super noticeOfWindowClose: aWindow .
!

postBuildWith: aBuilder

        super postBuildWith: aBuilder.
        aBuilder == self builder ifFalse: [ ^ self ].
        aBuilder window 
"/                damageRepairPolicy: DoubleBufferingWindowDisplayPolicy new;
                sendWindowEvents: #(#resize #open);
                application: self.
        aBuilder window icon: TfResources logoIcon.
!

postOpenWith: aBuilder

	super postOpenWith: aBuilder.
	self showEmbeddedSpec.
	self updateBookmarks.
	self showSidebar.
	self startUp.
!

shutDown

	self stopAnimationProcess.
	self settings retractAllInterestsFor: self.
	self browserModel shutDown.
	TfLog singleton removeDependent: self.
!

startUp

	self initializeSystem.
	TfLog singleton 
		when: #log send: #log: to: self;
		when: #warning send: #logWarning: to: self;
		when: #error send: #logError: to: self.
	self gotoAbout.
! !

!TwoflowerBrowser methodsFor:'notification'!

changedDownloads

	| dw |
	dw := self browserModel windowModelOfClass: TfDownloadWindowModel.
	dw isNil
		ifTrue: [ 	self createDownloadWindowModel ].
!

changedNavigationInPage: navigationEntry browserWindowModel: aTfBrowserWindowModel

	aTfBrowserWindowModel navigationModel visitedEntry: navigationEntry.
	self urlAspect value: navigationEntry url asString
!

changedRequests: requestsArray 
	| num max widget prog |
	num := requestsArray at: 1.
	max := requestsArray at: 2.
	widget := self builder componentAt: #progressID.
	(max > 0 and: [(prog := (max - num) / max) < 1]) 
		ifTrue: 
			[self startAnimationProcess.
			widget beVisible.
			self progressAspect value: prog]
		ifFalse: 
			[self stopAnimationProcess.
			widget beInvisible]
!

changedResource: resourceModel browserWindowModel: aTfBrowserWindowModel

	| redirect url |
	(redirect := resourceModel redirection) notNil
		ifTrue: [ 
			Log logDebug: ['Redirection from: ', resourceModel url asString, ' to: ', redirect url asString].
			self goto: redirect url
		]
		ifFalse: [ 
			self browserModel addWindowModel: aTfBrowserWindowModel.
			url := resourceModel url.
			url notNil
				ifTrue: [ self urlAspect value: resourceModel baseURL asString ].
		]
!

changedStyleSettings

	self styleSheet changedStyle
!

navigateTo: navigationEntry browserWindowModel: aTfBrowserWindowModel

	| bwm |
	navigationEntry allowDownload: true.
	navigationEntry openMode = #download
		ifTrue: [
			^ self resourceManager
				resourceNeeded: navigationEntry
				resourceDo: [ : resourceModel | ]
		].
	navigationEntry openMode = #sameWindow
		ifTrue: [ bwm := aTfBrowserWindowModel ]
		ifFalse: [ 
			aTfBrowserWindowModel navigationModel cancelGotoNewEntry.
			bwm := self createBrowserWindowModel
		].
	self status: 'Opening ' asText allBold, navigationEntry url asString.
	InputState default shiftDown
		ifTrue: [ self resourceManager invalidateCacheAt: navigationEntry ].
	Cursor wait showWhile: [
		self resourceManager
			open: navigationEntry
			resourceDo: [ : resourceModel | 
				bwm navigationModel visitedEntry: navigationEntry.
				bwm resourceModel: resourceModel.
				self updateTitleOf: bwm.
				self clearStatus.
			].
	].
!

sidebarChanged: anAspect with: param
!

tabChanged

	| app bwm canvas |
	self clearStatus.
	bwm := self selectedBrowserWindowModel.
	bwm isNil ifTrue: [ ^ self ].
	canvas := self builder componentAt: #embeddedAppID.
	canvas isNil ifTrue: [ ^ self ].
	self browserModel activeBrowserWindowModel: bwm.
	app := bwm createApplication.
	app isNil
		ifTrue: [ " todo: error message " ^ self ].
	app 
		hookInto: canvas widget
		builder: self builder newSubBuilder.
	self windowTitle: bwm title.
!

update: anAspect with: param from: sender

	sender == sidebarApp
		ifTrue: [ ^ self sidebarChanged: anAspect with: param ].
	^ super update: anAspect with: param from: sender
!

updateBookmarks

        | bookmarks oldMenu newMenu bookmarksItem bookmarksMenu |
        (bookmarks := self browserModel bookmarks) isNil        
                ifTrue: [ ^ self ].
        oldMenu := self builder menuAt: #menubar.
        newMenu := self class menubar.
        bookmarksItem := newMenu atNameKey: #bookmarksMenuID.
        bookmarksMenu := self class bookmarksMenu.
        bookmarksMenu addLine.
        bookmarks addURLsToMenu: bookmarksMenu for: self.
        bookmarksItem submenu: bookmarksMenu.
        "/ self rebuildMenu: oldMenu with: newMenu augmentTo: self class.
!

windowEvent: anEvent from: anApplicationWindow

	| app |
	super windowEvent: anEvent from: anApplicationWindow.
	(app := self activeEmbeddedApplication) notNil
		ifTrue: [ app windowEvent: anEvent from: anApplicationWindow ].
! !

!TwoflowerBrowser methodsFor:'private'!

actionDo: aBlock

	self clearStatus.
	Cursor wait showWhile: aBlock
!

activeEmbeddedApplication

	| canvas |
	canvas := self builder componentAt: #embeddedAppID.
	^ canvas notNil
		ifTrue: [ canvas widget tfApplication ]
		ifFalse: [ nil ].
!

canNavigate

	^ self activeBrowserWindowModel canNavigate
!

clearStatus

	self status: String new.
!

createTabLabelFor: aString

	| title |
	title := aString.
	aString size > 20
		ifTrue: [ title := (title copyFrom: 1 to: 17), '...' ].
	^ title
!

currentURL

	| bwm |
	^ (bwm := self activeBrowserWindowModel) notNil
		ifTrue: [ bwm url ]
		ifFalse: [ nil ]
!

googleSearchURLFor: aString

	| str |
	str := (String new: 128) writeStream.
	str nextPutAll: 'http://www.google.com/search?ie=ISO%2D8859%2D1&hl=en&q='.
	Net.URL tfEncode: aString on: str.
	^ str contents tfAsURL
!

gotoURLDescriptor: anURLDescriptor

	self goto: anURLDescriptor url.
!

initializeSystem

	[self loadSettings]
		on: Error
		do: [:ex | ex return].
	self styleSheet initializeInternationalStyle.
!

log: aString

	self status: aString
!

log: aString aspect: aSymbol

	| t |
	t := aSymbol = #log
		ifTrue: [ aString ]
		ifFalse: [ aSymbol asText allBold, ': ', aString ].
	self status: t.
!

logError: aString

	self status: ('Error ' asText allBold, ': ', aString).
!

logWarning: aString

	self status: ('Warning: ' asText allBold, ': ', aString).
!

printerClass
	ExternalInterface currentPlatform first == #win32
		ifTrue: [^HostPrinter]
		ifFalse: [^PostScriptPrinter]
!

resourceWindowModelNeeded

	| bwm |
	((bwm := self activeBrowserWindowModel) isNil or: [ bwm isResourceWindowModel not ])
		ifTrue: [ bwm := self createBrowserWindowModel ].
	^ bwm
!

status: aString

	self statusAspect value: aString
!

styleSheet

	^ self browserModel styleSheet
!

tabModels

	tabModels isNil
		ifTrue: [ tabModels := OrderedCollection new ].
	^ tabModels
!

toggleLoadImages

	self settings loadImages: self settings loadImages not.
	self reload.
!

windowTitle: aString

	| str |
	str := String new writeStream.
	aString do: [ : ch | | i |
		i := ch asInteger. 
		(i > 13 and: [  i < 254 ])
			ifTrue: [ str nextPut: ch ]
	].
	str nextPutAll: ' - Twoflower'.
	self builder window label: str contents.
! !

!TwoflowerBrowser methodsFor:'private - animation'!

animationImage

	animationImage isNil
		ifTrue: [ 
			animationImage := (ListIconLibrary visualFor: #signal) tfAsCachedImage.
		].
	^ animationImage
!

animationView: aVisualPart

	(self builder componentAt: #animationID) widget 
		component: aVisualPart;
		invalidate.
	self builder window sensor noteEvent.
!

doAnimationStep

	self animationView: self animationImage.
	(Delay forMilliseconds: 500) wait.
	self animationView: self emptyAnimationView.
	(Delay forMilliseconds: 500) wait.
!

emptyAnimationView

	^ CompositePart new
!

startAnimationProcess

	self stopAnimationProcess.
	animationProcess := 
		[
			[ self doAnimationStep ] repeat
		] forkAt: Processor userBackgroundPriority - 5.
!

stopAnimationProcess

	animationProcess notNil
		ifTrue: [ 
			animationProcess terminate.
			self animationView: self emptyAnimationView.
			animationProcess := nil.
		].
! !

!TwoflowerBrowser methodsFor:'private - interface'!

showEmbeddedSpec

	| spec |
	spec := self isSidebarEnabled
		ifTrue: [ #fullEmbeddedSpec ]
		ifFalse: [ #embeddedSpec ].
	(self builder componentAt: #embeddedCanvasID) widget
		client: self
		spec: spec
		builder: self builder.
!

showSidebar

	self isSidebarEnabled
		ifFalse: [ ^ self ].
	(self builder componentAt: #sidebarID) widget
		client: self sidebarApp
		spec: #windowSpec
		builder: self builder newSubBuilder.
! !

!TwoflowerBrowser methodsFor:'private - models'!

activeBrowserWindowModel

	^ self browserModel activeBrowserWindowModel
!

addBrowserWindowModel: aTfBrowserWindowModel

	| i tabs title |
	tabs := self tabsAspect list.
	title := self createTabLabelFor: aTfBrowserWindowModel title.
	i := self tabModels indexOf: aTfBrowserWindowModel ifAbsent: [ nil ].
	i notNil
		ifTrue: [ 
			" already added "
			self tabModels at: i put: aTfBrowserWindowModel.
			tabs at: i put: title.
			self tabChanged.
		]
		ifFalse: [
			self tabModels add: aTfBrowserWindowModel.
			tabs add: title.
			self tabsAspect selectionIndex: tabs size
		]
!

browserModel

	browserModel isNil
		ifTrue: [ self createBrowserModel ].
	^ browserModel
!

createBrowserModel

	browserModel := TfBrowserModel new.
	browserModel 
		onAddedWindowSend: #addBrowserWindowModel: to: self;
		onChangedWindowSend: #addBrowserWindowModel: to: self;
		onRemovedWindowSend: #removeBrowserWindowModel: to: self.
	browserModel resourceManager 
		onDownloadSend: #changedDownloads to: self;
		onRequestsChangeSend: #changedRequests: to: self.
	^ self createBrowserWindowModel.
!

createDownloadWindowModel

	| dwm |
	dwm := TfDownloadWindowModel new.
	self browserModel addWindowModel: dwm.
!

loadSettings

	| settings |
	settings := self settings.
	settings onBookmarksChangeSend: #updateBookmarks to: self.
	settings onStyleChangeSend: #changedStyleSettings to: self.
!

removeBrowserWindowModel: aTfBrowserWindowModel

	| i |
	i := self tabModels indexOf: aTfBrowserWindowModel ifAbsent: [ nil ].
	i notNil
		ifTrue: [ 
			self tabModels removeAtIndex: i.
			self tabsAspect list removeAtIndex: i.
			self tabChanged.
		].
!

resourceManager

	^ self browserModel resourceManager
!

selectedBrowserWindowModel

	| i |
	^ ((i := self tabsAspect selectionIndex) > 0 and: [ self tabModels isEmpty not ])
		ifTrue: [ self tabModels at: (i min: self tabModels size) ]
		ifFalse: [ nil ].
!

settings

	^ self browserModel settings
!

updateTitleOf: aTfBrowserWindowModel

	| i title |
	i := self tabModels indexOf: aTfBrowserWindowModel ifAbsent: [ nil ].
	i notNil
		ifTrue: [ 
			title := self createTabLabelFor: aTfBrowserWindowModel title.
			self tabsAspect list at: i put: title.
		]
! !

!TwoflowerBrowser methodsFor:'testing'!

canCloseTab

	^ self browserModel browserWindowModels size > 1
		and: [ self activeBrowserWindowModel notNil ]
!

canShowSource

	| bwm |
	^ ((bwm := self activeBrowserWindowModel) notNil
		and: [ bwm resourceModel sourceText notNil ])
!

isSidebarEnabled

	^ self settings showSidebar
!

loadImages

	^ self settings loadImages
! !

!TwoflowerBrowser class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__TwoflowerBrowser.st,v 1.3 2009/10/02 00:50:40 cg Exp $'
! !
