"{ Package: 'stx:goodies/twoflower' }"

"{ NameSpace: Twoflower }"

ApplicationModel subclass:#WidgetTestApp
	instanceVariableNames:'htmlAspect widgetModel defaultPixelSizeChoices
		defaultPixelSizeAspect'
	classVariableNames:''
	poolDictionaries:''
	category:'Twoflower-UIApplications-New'
!


!WidgetTestApp class methodsFor:'interface specs'!

windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#properties: #(#{UI.PropertyListDictionary} #labelFromApplication false ) 
			#label: 'Widget Test' 
			#min: #(#{Core.Point} 20 20 ) 
			#max: #(#{Core.Point} 1280 1024 ) 
			#bounds: #(#{Graphics.Rectangle} 640 512 1108 878 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Graphics.LayoutOrigin} 3 0.5 3 0 ) 
					#name: #Label1 
					#label: 'Widget:' ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 5 5 ) 
					#name: #Label2 
					#label: 'HTML:' ) 
				#(#{UI.TextEditorSpec} 
					#layout: #(#{Graphics.LayoutFrame} 3 0 30 0 -5 0.5 -30 1 ) 
					#name: #htmlAspect 
					#model: #htmlAspect 
					#tabRequiresControl: true ) 
				#(#{UI.TwoflowerHTMLWidgetSpec} 
					#layout: #(#{Graphics.LayoutFrame} 5 0.5 30 0 -3 1 -3 1 ) 
					#name: #widgetModel 
					#flags: 3 
					#model: #widgetModel 
					#openURLs: true 
					#keepScrollPosition: false 
					#margin: 0 ) 
				#(#{UI.ResizingSplitterSpec} 
					#layout: #(#{Graphics.LayoutFrame} -3 0.5 30 0 1 0.5 -3 1 ) 
					#name: #ResizingSplitter1 
					#flags: 8 
					#horizontal: false 
					#minAboveSize: 30 
					#minBelowSize: 30 
					#aboveWidgets: 'htmlAspect' 
					#belowWidgets: 'widgetModel' ) 
				#(#{UI.ComboBoxSpec} 
					#layout: #(#{Graphics.LayoutFrame} 80 0 -28 1 -3 0.5 -3 1 ) 
					#name: #ComboBox1 
					#model: #defaultPixelSizeAspect 
					#callbacksSpec: 
					#(#{UI.UIEventCallbackSubSpec} 
						#valueChangeSelector: #defaultPixelSizeChanged ) 
					#type: #number 
					#comboList: #defaultPixelSizeChoices ) 
				#(#{UI.LabelSpec} 
					#layout: #(#{UI.AlignmentOrigin} 3 0 -5 1 0 1 ) 
					#name: #Label3 
					#label: 'Font size:' ) ) ) )
! !

!WidgetTestApp methodsFor:'aspects'!

defaultPixelSizeAspect
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^defaultPixelSizeAspect isNil
		ifTrue:
			[defaultPixelSizeAspect := 18 asValue]
		ifFalse:
			[defaultPixelSizeAspect]
!

defaultPixelSizeChoices

	^defaultPixelSizeChoices isNil
		ifTrue:
			[defaultPixelSizeChoices := #(12 15 18 24) asList asValue]
		ifFalse:
			[defaultPixelSizeChoices]
!

htmlAspect

	htmlAspect isNil
		ifTrue: [
			htmlAspect := (PluggableAdaptor on: self widgetModel)
				getBlock: [:m | m htmlString ]
				putBlock: [:m :v | m htmlString: v ]
				updateBlock: [:m :a :p | true ].
			htmlAspect value: self defaultWidgetHTML.
		].
	^ htmlAspect
!

widgetModel

	widgetModel isNil
		ifTrue: [ 
			widgetModel := TfWidgetModel new.
		].
	^ widgetModel
! !

!WidgetTestApp methodsFor:'notification'!

defaultPixelSizeChanged

	self widgetModel browserModel settings defaultPixelSize: self defaultPixelSizeAspect value
! !

!WidgetTestApp methodsFor:'private'!

defaultWidgetHTML

	^ '<html>
<body>
<h1>Hello World</h1>
This is the embedded Twoflower widget
</body>
</html>'
! !

!WidgetTestApp class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/Twoflower__WidgetTestApp.st,v 1.1 2009/10/01 23:44:35 cg Exp $'
! !
