"{ Package: 'stx:goodies/twoflower/compat' }"

URL subclass:#URLwithPath
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-Support'
!


!URLwithPath methodsFor:'Twoflower'!

tfEncode

	super tfEncode.
	path notNil ifTrue: [ path := path collect: [ : s | self class encode: s allowed: self class pathAllowedChars ]].
	query notNil ifTrue: [ query := self class encode: query ].
!

tfLastComponent

	^ path isEmpty
		ifTrue: [ nil ]
		ifFalse: [ path last ]
!

tfRemoveLastComponent

	path isEmpty
		ifFalse: [ self removeLastComponent ]
!

tfResolveRelativeURL: anURIOrString
	" create an absolute URL from the given relative URL "

	| s newURL c |
	s := anURIOrString asString trimBlanks.
	('//*' match: s)
		ifTrue: [ ^ Net.URL tfFromString: self protocol, ':', s ].
	newURL := self copy.
	s isEmpty
		ifTrue: [ ^ newURL ].
	newURL fragment: nil.
	s first = $#
		ifTrue: [ 
			newURL fragment: (s copyFrom: 2 to: s size).
			^ newURL 
		].
	('/*' match: s)
		ifTrue: [ newURL path: OrderedCollection new ].
	newURL query notNil
		ifTrue: [
			newURL query: nil.
			newURL tfRemoveLastComponent
		].
	((c := newURL tfLastComponent) notNil and: [ c includes: $. ])
		ifTrue: [ newURL tfRemoveLastComponent ].
	((c := newURL tfLastComponent) notNil and: [ c isEmpty not and: [ s first ~~ $/ ]])
		ifTrue: [ newURL addComponent: '' ].
	(newURL tfLastComponent isNil and: [ s first = $/ ])
		ifTrue: [ s := s copyFrom: 2 to: s size ].
	^ URL tfFromString: newURL asString, s.
!

tfResolveSymbols
	" resolve symbolic components like '..' "

	| newPath |
	newPath := OrderedCollection new.
	path do: [ : c |
		c = '.'
			ifFalse: [
				c = '..'
					ifTrue: [
						newPath isEmpty
							ifFalse: [ newPath removeLast ].
					]
					ifFalse: [ newPath add: c ]
			].
	].
	path := newPath
! !

!URLwithPath methodsFor:'accessing'!

tfDownloadFilename

	^ (self path isEmpty or: [ self path last isEmpty ])
		ifTrue: [ super tfDownloadFilename ]
		ifFalse: [ self path last asFilename ]
!

tfFragment

	^ self fragment
!

tfURLWithoutFragment

	^ self copy fragment: nil; yourself
! !

!URLwithPath class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/compat/URLwithPath.st,v 1.1 2009/10/02 00:52:30 cg Exp $'
! !
