"{ Package: 'stx:goodies/twoflower' }"

LibraryDefinition subclass:#stx_goodies_twoflower
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_twoflower class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/xml/vw'    "XML::NodeBuilder - superclass of Twoflower::TfNodeBuilder "
        #'stx:libbasic'    "Autoload - superclass of Twoflower::TfDefaultStyleProperty "
        #'stx:libbasic2'    "TextStream - referenced by PositionableStream>>tfDebugStringOfSize: "
        #'stx:libcompat'    "CachedImage - referenced by Image>>tfAsCachedImage "
        #'stx:libhtml'    "URL - referenced by URL>>tfResolveURL: "
        #'stx:libview2'    "ColorValue - referenced by Twoflower::TfElement>>tfPrintOn:depth:emphasicDictionary: "
    )
! !

!stx_goodies_twoflower class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (#'Twoflower::ImageTestApp' autoload)
        (#'Twoflower::TfAbstractCanvasElement' autoload)
        (#'Twoflower::TfAbstractColumnElement' autoload)
        (#'Twoflower::TfAbstractListElement' autoload)
        (#'Twoflower::TfAbstractListView' autoload)
        (#'Twoflower::TfAbstractParagraphElement' autoload)
        (#'Twoflower::TfAbstractStyleElement' autoload)
        (#'Twoflower::TfAbstractTableElement' autoload)
        (#'Twoflower::TfAbstractTableView' autoload)
        (#'Twoflower::TfAnchorController' autoload)
        (#'Twoflower::TfAnchorElement' autoload)
        (#'Twoflower::TfAnchorView' autoload)
        (#'Twoflower::TfApplicationRegistry' autoload)
        (#'Twoflower::TfBackgroundDecorator' autoload)
        (#'Twoflower::TfBackgroundStyle' autoload)
        (#'Twoflower::TfBaseFontElement' autoload)
        (#'Twoflower::TfBaseFontView' autoload)
        (#'Twoflower::TfBlockAdaptor' autoload)
        (#'Twoflower::TfBodyElement' autoload)
        (#'Twoflower::TfBodyView' autoload)
        (#'Twoflower::TfBoldElement' autoload)
        (#'Twoflower::TfBookmarkContainer' autoload)
        (#'Twoflower::TfBookmarksDialog' autoload)
        (#'Twoflower::TfBookmarksLoadDialog' autoload)
        (#'Twoflower::TfBookmarksPanel' autoload)
        (#'Twoflower::TfBookmarksReaderWriter' autoload)
        (#'Twoflower::TfBookmarksSaveDialog' autoload)
        (#'Twoflower::TfBorderedBackgroundDecorator' autoload)
        (#'Twoflower::TfBoundingWrapper' autoload)
        (#'Twoflower::TfBoxContext' autoload)
        (#'Twoflower::TfBoxElementLayout' autoload)
        (#'Twoflower::TfBrElement' autoload)
        (#'Twoflower::TfBrowserModel' autoload)
        (#'Twoflower::TfBrowserWindowModel' autoload)
        (#'Twoflower::TfBrowserWrapper' autoload)
        (#'Twoflower::TfBulletLineLayout' autoload)
        (#'Twoflower::TfCSSStyleReader' autoload)
        (#'Twoflower::TfCSSTests' autoload)
        (#'Twoflower::TfCacheEntry' autoload)
        (#'Twoflower::TfCanvasApp' autoload)
        (#'Twoflower::TfCanvasElement' autoload)
        (#'Twoflower::TfCanvasWrapper' autoload)
        (#'Twoflower::TfCenterElement' autoload)
        (#'Twoflower::TfCodeElement' autoload)
        (#'Twoflower::TfColElement' autoload)
        (#'Twoflower::TfColGroupElement' autoload)
        (#'Twoflower::TfCompositeCanvasView' autoload)
        (#'Twoflower::TfCompositeElementView' autoload)
        (#'Twoflower::TfCompositeFormView' autoload)
        (#'Twoflower::TfCompositeView' autoload)
        (#'Twoflower::TfCompositionScanner' autoload)
        (#'Twoflower::TfController' autoload)
        (#'Twoflower::TfDOMDriver' autoload)
        (#'Twoflower::TfDecorator' autoload)
        (#'Twoflower::TfDefaultImageReader' autoload)
        (#'Twoflower::TfDefaultListItemElement' autoload)
        (#'Twoflower::TfDefaultListItemView' autoload)
        (#'Twoflower::TfDefaultStyleProperty' autoload)
        (#'Twoflower::TfDefaultStyleSheet' autoload)
        (#'Twoflower::TfDefinitionListElement' autoload)
        (#'Twoflower::TfDefinitionTermElement' autoload)
        (#'Twoflower::TfDefinitionTermView' autoload)
        (#'Twoflower::TfDeltaSizeLayout' autoload)
        (#'Twoflower::TfDialog' autoload)
        (#'Twoflower::TfDivElement' autoload)
        #'Twoflower::TfDocument'
        (#'Twoflower::TfDocumentController' autoload)
        (#'Twoflower::TfDocumentLayout' autoload)
        (#'Twoflower::TfDocumentModel' autoload)
        (#'Twoflower::TfDocumentModelTests' autoload)
        (#'Twoflower::TfDocumentView' autoload)
        (#'Twoflower::TfDocumentWrapper' autoload)
        (#'Twoflower::TfDownloadModel' autoload)
        (#'Twoflower::TfDownloadWindowModel' autoload)
        (#'Twoflower::TfEditBookmarkDialog' autoload)
        #'Twoflower::TfElement'
        (#'Twoflower::TfElementLayout' autoload)
        (#'Twoflower::TfEmbeddedBrowserApp' autoload)
        (#'Twoflower::TfEmbeddedDownloadApp' autoload)
        (#'Twoflower::TfEmbeddedEmptyApp' autoload)
        (#'Twoflower::TfEmbeddedHTMLApp' autoload)
        (#'Twoflower::TfEmbeddedImageApp' autoload)
        (#'Twoflower::TfEmbeddedResourceBrowserApp' autoload)
        (#'Twoflower::TfEmbeddedTextApp' autoload)
        (#'Twoflower::TfEncodingWarning' autoload)
        (#'Twoflower::TfError' autoload)
        (#'Twoflower::TfFactorScaledSizeLayout' autoload)
        (#'Twoflower::TfFixedSizeLayout' autoload)
        (#'Twoflower::TfFontElement' autoload)
        (#'Twoflower::TfFontSettingsApp' autoload)
        (#'Twoflower::TfFontSizeDictionaryLayout' autoload)
        (#'Twoflower::TfFontStyle' autoload)
        (#'Twoflower::TfForm' autoload)
        (#'Twoflower::TfFormButtonApp' autoload)
        (#'Twoflower::TfFormCanvasWrapper' autoload)
        (#'Twoflower::TfFormContext' autoload)
        (#'Twoflower::TfFormDescriptor' autoload)
        (#'Twoflower::TfFormDropDownListApp' autoload)
        (#'Twoflower::TfFormElement' autoload)
        (#'Twoflower::TfFormInputElement' autoload)
        (#'Twoflower::TfFormInputFieldApp' autoload)
        (#'Twoflower::TfFormLayout' autoload)
        (#'Twoflower::TfFormRadioButtonApp' autoload)
        (#'Twoflower::TfFormSelectionElement' autoload)
        (#'Twoflower::TfFormSelectionListApp' autoload)
        (#'Twoflower::TfFormTextAreaApp' autoload)
        (#'Twoflower::TfFormTextAreaElement' autoload)
        (#'Twoflower::TfFormView' autoload)
        (#'Twoflower::TfFormWidgetApp' autoload)
        (#'Twoflower::TfFormWidgetElement' autoload)
        (#'Twoflower::TfFrameElement' autoload)
        (#'Twoflower::TfFrameSetElement' autoload)
        (#'Twoflower::TfGDIImageReader' autoload)
        (#'Twoflower::TfHTMLElement' autoload)
        (#'Twoflower::TfHTMLInspector' autoload)
        #'Twoflower::TfHTMLParser'
        (#'Twoflower::TfHTMLParserInspector' autoload)
        #'Twoflower::TfHTMLReviser'
        (#'Twoflower::TfHTMLTests' autoload)
        (#'Twoflower::TfHTMLValueReader' autoload)
        (#'Twoflower::TfHeadElement' autoload)
        (#'Twoflower::TfHeadingElement' autoload)
        (#'Twoflower::TfHrElement' autoload)
        (#'Twoflower::TfHrView' autoload)
        (#'Twoflower::TfHttpBuildHandler' autoload)
        (#'Twoflower::TfHttpClient' autoload)
        (#'Twoflower::TfHttpResponse' autoload)
        (#'Twoflower::TfIconLibrary' autoload)
        (#'Twoflower::TfImageElement' autoload)
        (#'Twoflower::TfImageModel' autoload)
        (#'Twoflower::TfImageReader' autoload)
        (#'Twoflower::TfImageView' autoload)
        (#'Twoflower::TfInspectorPanel' autoload)
        (#'Twoflower::TfInternalExecutionURL' autoload)
        (#'Twoflower::TfInternalURL' autoload)
        (#'Twoflower::TfItalicElement' autoload)
        (#'Twoflower::TfLayoutContext' autoload)
        (#'Twoflower::TfLinkTargetView' autoload)
        (#'Twoflower::TfLinkedContext' autoload)
        (#'Twoflower::TfListItemBulletView' autoload)
        (#'Twoflower::TfListItemElement' autoload)
        (#'Twoflower::TfListItemNumberView' autoload)
        (#'Twoflower::TfListItemView' autoload)
        (#'Twoflower::TfListStyle' autoload)
        (#'Twoflower::TfLocalStyleProperty' autoload)
        (#'Twoflower::TfLog' autoload)
        (#'Twoflower::TfMasterCompositeView' autoload)
        (#'Twoflower::TfMetaElement' autoload)
        (#'Twoflower::TfMetaInfo' autoload)
        (#'Twoflower::TfMetaRefresh' autoload)
        (#'Twoflower::TfMockMedium' autoload)
        (#'Twoflower::TfMozillaBookmarksReaderWriter' autoload)
        (#'Twoflower::TfNavigationModel' autoload)
        (#'Twoflower::TfNewBookmarkDialog' autoload)
        (#'Twoflower::TfNoFramesElement' autoload)
        #'Twoflower::TfNodeBuilder'
        #'Twoflower::TfNodeTag'
        (#'Twoflower::TfOperaBookmarksReaderWriter' autoload)
        (#'Twoflower::TfOptionElement' autoload)
        (#'Twoflower::TfOrderedListElement' autoload)
        (#'Twoflower::TfOrderedListView' autoload)
        (#'Twoflower::TfParagraphElement' autoload)
        (#'Twoflower::TfParagraphStyle' autoload)
        (#'Twoflower::TfPreferredColumnWidthLayout' autoload)
        (#'Twoflower::TfRenderContext' autoload)
        (#'Twoflower::TfResourceManager' autoload)
        (#'Twoflower::TfResourceModel' autoload)
        (#'Twoflower::TfResourceRequest' autoload)
        (#'Twoflower::TfResourceWindowModel' autoload)
        (#'Twoflower::TfResources' autoload)
        (#'Twoflower::TfRowSpanContext' autoload)
        #'Twoflower::TfSAXDriver'
        (#'Twoflower::TfSAXWriter' autoload)
        (#'Twoflower::TfScaledSizeLayout' autoload)
        (#'Twoflower::TfSelectionScanner' autoload)
        (#'Twoflower::TfSettings' autoload)
        (#'Twoflower::TfSidebarApp' autoload)
        (#'Twoflower::TfSidebarPanel' autoload)
        (#'Twoflower::TfSizeLayout' autoload)
        (#'Twoflower::TfSourceCodeModel' autoload)
        (#'Twoflower::TfStack' autoload)
        (#'Twoflower::TfStyle' autoload)
        (#'Twoflower::TfStyleContext' autoload)
        (#'Twoflower::TfStylePart' autoload)
        (#'Twoflower::TfStyleProperty' autoload)
        (#'Twoflower::TfStyleSheet' autoload)
        (#'Twoflower::TfSubCanvas' autoload)
        (#'Twoflower::TfTableBodyElement' autoload)
        (#'Twoflower::TfTableBoundingWrapper' autoload)
        (#'Twoflower::TfTableCellContentsView' autoload)
        (#'Twoflower::TfTableCellElement' autoload)
        (#'Twoflower::TfTableCellLayout' autoload)
        (#'Twoflower::TfTableCellStyle' autoload)
        (#'Twoflower::TfTableCellView' autoload)
        (#'Twoflower::TfTableElement' autoload)
        (#'Twoflower::TfTableEnumerator' autoload)
        (#'Twoflower::TfTableFootElement' autoload)
        (#'Twoflower::TfTableHeadElement' autoload)
        (#'Twoflower::TfTableHeaderCellElement' autoload)
        (#'Twoflower::TfTableLayout' autoload)
        (#'Twoflower::TfTablePartElement' autoload)
        (#'Twoflower::TfTableRowElement' autoload)
        (#'Twoflower::TfTableRowLayout' autoload)
        (#'Twoflower::TfTableRowView' autoload)
        (#'Twoflower::TfTableStyle' autoload)
        (#'Twoflower::TfTableView' autoload)
        (#'Twoflower::TfTestApp' autoload)
        (#'Twoflower::TfTestCase' autoload)
        #'Twoflower::TfText'
        (#'Twoflower::TfTextController' autoload)
        (#'Twoflower::TfTextDocumentModel' autoload)
        (#'Twoflower::TfTextSelection' autoload)
        (#'Twoflower::TfTextSelectionTracker' autoload)
        (#'Twoflower::TfTextView' autoload)
        (#'Twoflower::TfTextViewLine' autoload)
        (#'Twoflower::TfTitleElement' autoload)
        (#'Twoflower::TfTranslatingCompositeElementView' autoload)
        (#'Twoflower::TfTranslatingWrapper' autoload)
        (#'Twoflower::TfURLDescriptor' autoload)
        (#'Twoflower::TfURLHolder' autoload)
        (#'Twoflower::TfURLMenuItem' autoload)
        (#'Twoflower::TfURLSeparator' autoload)
        (#'Twoflower::TfURLTests' autoload)
        (#'Twoflower::TfUnderlineElement' autoload)
        (#'Twoflower::TfUnknownElement' autoload)
        (#'Twoflower::TfUnorderedListElement' autoload)
        (#'Twoflower::TfUnorderedListView' autoload)
        (#'Twoflower::TfUserCanceledError' autoload)
        (#'Twoflower::TfView' autoload)
        (#'Twoflower::TfViewTests' autoload)
        (#'Twoflower::TfWidgetModel' autoload)
        (#'Twoflower::TfWidgetWrapper' autoload)
        (#'Twoflower::TfWrapper' autoload)
        (#'Twoflower::TfXMLDocumentModel' autoload)
        (#'Twoflower::TwoflowerBrowser' autoload)
        (#'Twoflower::WidgetTestApp' autoload)
        (TwoflowerHTMLWidgetSpec autoload)
        #'stx_goodies_twoflower'
        #'Twoflower::TfDefaultElement'
        #'Twoflower::TfHTMLCloseTagReviser'
        #'Twoflower::TfHTMLFixDOMReviser'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        CachedImage tfAsCachedImage
        CachedImage tfConvertForGraphicsDevice:
        CachedImage tfShrunkenBy:
        CharacterArray tfAsAssociation:
        CharacterArray tfAsResourceModel
        CharacterArray tfAsStringsSeperatedByAll:
        CharacterArray tfAsURL
        CharacterArray tfAsURLDescriptor
        CharacterArray tfIsWhitespaceOnly
        CharacterArray tfTrimLeadingSpace
        CharacterArray tfTrimSpace
        CharacterArray tfTrimTrailingSpace
        CharacterArray tfTrimWhitespaces
        CharacterArray tfValueAtKey:
        CharacterArray tfValueAtKey:separator:
        CharacterArray tfWhitespaceCharacters
        CharacterArray tfWhitespaceValues
        CharacterArray tfWithoutWhitespaces
        CharacterAttributes tfAsScreenFontStyle
        CharacterAttributes tfSetDefaultAttributes
        Collection tfSortedBy:
        CompositePart tfSetupComponents
        Delay tfValueWithTimeout:
        EncodedStream tfCoreStream
        FontDescription tfAsFontStyle
        GraphicsContext tfClientDataAt:put:
        HostGraphicsDevice defaultFontPolicy
        Image tfAsCachedImage
        Image tfAsResourceModel
        Image tfConvertForGraphicsDevice:
        Image tfShrunkenBy:
        Integer tfAsTranslation
        #'Net::HttpURL' tfMimeEntityFor:descriptor:
        #'Net::HttpURL' tfNewClientFor:
        #'Net::MessageElement' tfURL
        #'Net::MessageElement' tfUnencodedValue
        #'Net::MimeEntity' tfUnencodedValue
        #'Net::SimpleBody' tfUnencodedValue
        Number tfSizePrintString
        OpaqueImage tfAsCachedImage
        OpaqueImage tfAsResourceModel
        OpaqueImage tfConvertForGraphicsDevice:
        OpaqueImage tfShrunkenBy:
        Point tfAsTranslation
        PositionableStream tfDebugString
        PositionableStream tfDebugStringOfSize:
        Rectangle tfAsTranslation
        Rectangle tfDeepCopy
        Rectangle tfNormalize
        Rectangle tfNormalized
        Stream tfCoreStream
        Stream tfLineEndCollection
        Stream tfNextLine
        SubCanvas tfApplication
        SubCanvas tfApplication:
        TabControlComposite tfApplication
        TabControlComposite tfApplication:
        URL loadResourceFor:descriptor:
        URL tfAsURL
        URL tfAsURLDescriptor
        URL tfDirectResource
        URL tfDownloadFilename
        URL tfEncode
        URL tfFragment
        URL tfMimeEntityFor:descriptor:
        URL tfRememberVisit
        URL tfResolveRelativeURL:
        URL tfResolveSymbols
        URL tfResolveURL:
        URL tfURLWithoutFragment
        VisualComponent tfComposesComponents
        VisualComponent tfLocalTranslateBy:
        VisualComponent tfWrapped
        VisualPart tfNonWrappingContainer
        VisualPart tfSetupComponents
        VisualPart tfTopDocumentView
        VisualPart tfTranslatingWrapper
        VisualPart tfWrappedComponent
        Wrapper tfAllViewsDo:
        Wrapper tfComposesComponents
        Wrapper tfNonWrappingContainer
        Wrapper tfRenderingFinished
        Wrapper tfSetupComponents
        Wrapper tfWrappedComponent
        #'XML::Comment' tfPrintOn:depth:emphasicDictionary:
        #'XML::Document' tfPrintOn:emphasicDictionary:
        #'XML::Node' tfAdaptToTable:
        #'XML::Node' tfAddNodesMatching:upTo:to:
        #'XML::Node' tfAddToBookmarks:emit:
        #'XML::Node' tfComponents
        #'XML::Node' tfDebugString
        #'XML::Node' tfDocument
        #'XML::Node' tfEnumerateListItem:of:
        #'XML::Node' tfEnumerateTable:
        #'XML::Node' tfFixNodes
        #'XML::Node' tfFormElement
        #'XML::Node' tfIsColElement
        #'XML::Node' tfIsFormPart
        #'XML::Node' tfIsListOption
        #'XML::Node' tfIsTable
        #'XML::Node' tfIsTableCell
        #'XML::Node' tfIsTableElement
        #'XML::Node' tfIsTableRow
        #'XML::Node' tfIsVisibleInBody
        #'XML::Node' tfNodesMatching:upTo:
        #'XML::Node' tfPreviousElementNamed:
        #'XML::Node' tfPreviousElementNamed:ifAbsent:
        #'XML::Node' tfPrintOn:depth:emphasicDictionary:
        #'XML::Node' tfPrintOn:emphasicDictionary:
        #'XML::Node' tfPrintString
        #'XML::Node' tfSelfOrPreviousElementNamed:ifAbsent:
        #'XML::Node' tfTableElement
        #'XML::Node' tfTreeDisplayString
        #'XML::Node' tfViewClass
        #'XML::StreamWrapper' tfEncoder:
        'ApplicationModel class' tfForObject:
        'ColorValue class' tfFromHTMLHex:
        'Cursor class' tfFingerPointer
        'Net::MimeEntity class' tfFileName:
        'Net::SimpleBody class' fromLine:
        'ScreenFont class' tfEncodings
        'Twoflower class' #'version_CVS'
        'URL class' tfEncode:on:
        'URL class' tfFromString:
        'URL class' tfLooksLikeURL:
    )
! !

!stx_goodies_twoflower class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2009\nCopyright eXept Software AG 1998-2009'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_twoflower class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/twoflower/stx_goodies_twoflower.st,v 1.1 2009/11/07 10:50:39 cg Exp $'
! !
