"{ Package: 'stx:goodies/webServer' }"

"{ NameSpace: Demos }"

HTTPService subclass:#GeneratedStringImageDemoService
	instanceVariableNames:'lastString'
	classVariableNames:''
	poolDictionaries:''
	category:'demos-WebApplications'
!

!GeneratedStringImageDemoService class methodsFor:'documentation'!

documentation
"
    A simple human-readable-image generator test
"
! !

!GeneratedStringImageDemoService class methodsFor:'defaults'!

linkName
    "return the default linkName path (with slash)"

    ^ '/TestImage'
! !

!GeneratedStringImageDemoService methodsFor:'actions'!

process:aRequest 
    "process an incoming HTTP request"

    |generator enteredString|

    aRequest url = (self linkName,'/theImage.gif') ifTrue:[
        generator := HumanReadableImageGenerator new.
        generator string:lastString.
        aRequest sendImage:(generator generateImage).
        ^ self.
    ].

    aRequest isPOST ifTrue:[
        aRequest url = (self linkName,'/doPost') ifTrue:[
            enteredString := aRequest postDataFieldAt:'confirmationString'.
            enteredString = lastString ifTrue:[
                aRequest response 
                    reply:'OK - you are human !!'
            ] ifFalse:[
                aRequest response 
                    reply:'Mhmhmh - are you a Robot ?'
            ].
            aRequest response 
                reply:'<p>';
                reply:'<hr>'
        ]
    ].

    generator := HumanReadableImageGenerator new.
    lastString := generator string.

    aRequest response 
        reply:'Image for String:';
        reply:'<br>';
        reply:lastString;
        reply:'<br>';
        reply:'<img src="',self linkName,'/theImage.gif">';
        reply:'<p>';
        reply:'<form action="',self linkName,'/doPost" method="POST">';
        reply:'<input type="submit" value="Send">';
        reply:'<input type="edit" name="confirmationString">';
        reply:'</form>'.
! !

!GeneratedStringImageDemoService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/Demos__GeneratedStringImageDemoService.st,v 1.2 2008/05/09 15:42:47 sr Exp $'
! !
