"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

ReplyPresenter subclass:#ExeptReplyPresenter
	instanceVariableNames:''
	classVariableNames:'PresenterStyle'
	poolDictionaries:''
	category:'Net-Communication-HTML-ReplyPresenter'
!

!ExeptReplyPresenter class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    See my superclass's doc for what a replyPresenter does.

    This is an example of a wrapper for exept-colors and an
    extra set of framing divs, including a site-search.
"
! !

!ExeptReplyPresenter methodsFor:'accessing'!

presenterStyleSheet
    ^ PresenterStyle
!

presenterStyleSheet:something
    PresenterStyle := something.
! !

!ExeptReplyPresenter methodsFor:'initialization & release'!

initialize
    super initialize.
    title := 'Smalltalk/X Webserver'.
    parameters at:#bodyColor put:'#f6feff'.
    parameters at:#topLeftColor put:'#00464A'.    "/ exept-color
    parameters at:#topTextColor put:'#00464A'.
    parameters at:#bottomTextColor put:'#00464A'.
    parameters at:#textColor put:'#000000'.
    parameters at:#topRightColor put:'#e4f5fe'.
    parameters at:#bottomRightColor put:'#e4f5fe'.
    parameters at:#leftBarColor put:'#b6d2da'.
    parameters at:#linkColor put:'#0000cc'.
    parameters at:#visitedLinkColor put:'#551a8b'.
    parameters at:#activeLinkColor put:'#ff0000'.
    parameters at:#firstHeadLine put:title.
    parameters at:#secondHeadLine put:''.
    parameters at:#favIconLink put:'/files/favicon.ico'.
    parameters at:#afterButtons put:''.
    parameters at:#beforeTitle put:''.
    parameters at:#homeLink put:'/'.
!

release
    super release.
    "/ reset parameters for next request
    parameters at:#secondHeadLine put:''.
    parameters at:#favIconLink put:'/files/favicon.ico'.
    parameters at:#afterButtons put:''.
    parameters at:#beforeTitle put:''.
    parameters at:#homeLink put:'/'.
    ^ self
! !

!ExeptReplyPresenter methodsFor:'required-protocol'!

present:aResponse on:aStream 
    self tableDivideDocumentFor:aResponse on:aStream.
! !

!ExeptReplyPresenter methodsFor:'response-div divide'!

divStyleSheet

    |props bodyHtmlStyle topLeftStyle topRightStyle middleLeftStyle middleRightStyle bottomLeftStyle bottomRightStyle styleSheetElements|

    styleSheetElements := OrderedCollection new.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'100%').
    props add:(HTML::CSS_Height with:'100%').
    props add:(HTML::CSS_Margin with:'0px').
    props add:(HTML::CSS_BackgroundColor with:'#f6feff').
    bodyHtmlStyle := HTML::CSS_StyleElement selectors:#('HTML' 'BODY') properties:props.
    styleSheetElements add:bodyHtmlStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'150px').
    props add:(HTML::CSS_Height with:'110px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#topLeftColor)).
    topLeftStyle := HTML::CSS_StyleElement selectors:#('.topLeftStyle') properties:props.
    styleSheetElements add:topLeftStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'100%').
    props add:(HTML::CSS_Height with:'110px').
    props add:(HTML::CSS_TopPadding with:'10px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#topRightColor)).
    props add:(HTML::CSS_Color with:(self parametersAt:#topTextColor)).
    topRightStyle := HTML::CSS_StyleElement selectors:#('.topRightStyle') properties:props.
    styleSheetElements add:topRightStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'150px').
    props add:(HTML::CSS_Height with:'100%').
    props add:(HTML::CSS_TopPadding with:'10px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#leftBarColor)).
    middleLeftStyle := HTML::CSS_StyleElement selectors:#('.middleLeftStyle') properties:props.
    styleSheetElements add:middleLeftStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'100%').
    props add:(HTML::CSS_Height with:'100%').
    props add:(HTML::CSS_TopPadding with:'10px').
    props add:(HTML::CSS_LeftPadding with:'10px').
    props add:(HTML::CSS_RightPadding with:'10px').
    props add:(HTML::CSS_BottomPadding with:'10px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#bodyColor)).
    middleRightStyle := HTML::CSS_StyleElement selectors:#('.middleRightStyle') properties:props.
    styleSheetElements add:middleRightStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'150px').
    props add:(HTML::CSS_Height with:'40px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor newWhite).
    bottomLeftStyle := HTML::CSS_StyleElement selectors:#('.bottomLeftStyle') properties:props.
    styleSheetElements add:bottomLeftStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'100%').
    props add:(HTML::CSS_Height with:'40px').
    props add:(HTML::CSS_VerticalAlignment newMiddle).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#bottomRightColor)).
    bottomRightStyle := HTML::CSS_StyleElement selectors:#('.bottomRightStyle') properties:props.
    styleSheetElements add:bottomRightStyle.
    ^ styleSheetElements
!

divStyleSheetOn:aStream
    self putStyleSheet:self divStyleSheet on:aStream
! !

!ExeptReplyPresenter methodsFor:'response-parts contents'!

bottomLeftContents
    ^ HTML::Break new.
!

bottomRightContentsFor:aResponse
    |div|

    div := HTML::Div with:(HTML::Address with:aResponse stxPoweredByString).
    div style:'text-align: center; font-size: small;'.
    ^ div.
!

middleLeftContentsFor:aResponse
    |image homeLink afterButtons contents form div1 sepDiv div2 inputGoogle|

    contents := OrderedCollection new.

    div1 := HTML::Div new.
    div1 style:'vertical-align: top; height: 80%'.

    homeLink := (self parametersAt:#homeLink).
    image := HTML::Image new.
    image alternative:'Home'.
    image border:0.
    image style:'width: 130px; border: 0px;'.

    (aResponse request url ~= homeLink) ifTrue:[
        image source:'/files/top_mask.gif'.
        div1 add:(HTML::Anchor href:homeLink with:image).
    ] ifFalse:[
        image source:'/files/topie_mask.gif'.
        div1 add:image.
    ].

    (afterButtons := (self parametersAt:#afterButtons)) notNil ifTrue:[
        div1 add:afterButtons.
    ].

    div2 := HTML::Div new.
    div2 style:'margin-left: 10px; margin-right: 10px; vertical-align: bottom'.

    form := HTML::Form method:'GET' action:'http://www.google.com/custom'.
    form add:((HTML::Input type:'submit' name:'sa' value:'Search') 
                style:('border:solid; border-width: 1px; width: 100%; background-color: ' , (parameters at:#topLeftColor) , '; color: ', (parameters at:#topRightColor)); yourself).
    form add:(HTML::Input type:'hidden' name:'domains' value:'www.exept.de').
    form add:(HTML::Break).
    form add:(HTML::Input type:'radio' name:'sitesearch' value:'').
    form add:'everywhere'.
    form add:(HTML::Break).
    form add:(HTML::Input type:'radio' name:'sitesearch' value:'www.exept.de').
    form add:'www.exept.de'.
    form add:(HTML::Break).
    form add:'for:'.
    inputGoogle := (HTML::Input type:'text' name:'q' value:'smalltalk/x') maxlength:255; "size:15;" 
                style:('border: solid; border-width: 1px; width: 100%'); yourself.
    
    form add:(HTML::Small with:inputGoogle).
    div2 add:form.

    "/ sepDiv := HTML::Div new.
    "/ sepDiv style:'height: 200px'.

    div2 := HTML::Div with:div2.
    div2 style:'vertical-align: bottom; height:20%'.

    contents add:div1.
    "/ contents add:sepDiv.
    contents add:div2.
    ^ contents.

    "Modified: / 19-11-2010 / 12:42:22 / cg"
!

middleRightContentsFor:aResponse
    ^ aResponse replyPresenterDataStream contents.
!

topLeftContents
    ^ HTML::Image source:'/files/exeptLogo.gif' alternative:'eXept Software AG Logo' border:0.
!

topRightContents
    |div|

    div := HTML::Div new.
    div style:'margin-left: 30px'.
    div addChild:(HTML::Heading2 with:((self parametersAt:#firstHeadLine)?'')).
    div addChild:(HTML::Heading4 with:((self parametersAt:#secondHeadLine)?'')).
    ^ div
! !

!ExeptReplyPresenter methodsFor:'response-table divide'!

tableDivideDocumentFor:aResponse on:aStream
    |document head body topLeftCell table favIconLink topRow topRightCell middleRow 
     middleLeftCell middleRightCell bottomRow bottomLeftCell bottomRightCell style|

    document := HTML::Document newTransitional.
    head := document getHead.
    head addElement:(self parametersAt:#beforeTitle ifAbsent:'').
    head title:title.

    head addMetaHttpEquivalent:'content-type' content:'text/html; charset=ISO-8859-1'.
    head addMetaName:'Author' content:'eXept Software AG'.
    "/ solution by set a temporary link at the server
"/    head addLinkHref:(self getStylePathFor:aResponse styleString:self tableStyleSheetString) rel:'stylesheet' type:'text/css'.
    style := HTML::Style with:(self tableStyleSheet).   
    style type:'text/css'.
    
    head addElement:style.
    favIconLink := self parametersAt:#favIconLink.
    favIconLink notNil ifTrue:[
        head addLinkHref:favIconLink rel:'SHORTCUT ICON' type:'image/ico'.
    ].
    body := document getBody.
    table := HTML::Table new.
    table border:0.
    table cellSpacing:0.
    table cellPadding:0.
    table style:'text-align: left; width: 100%; height: 100%'.
    topRow := table addRow.
    topLeftCell := topRow addCell:self topLeftContents.
    topLeftCell class:'topLeftStyle'.
    topRightCell := topRow addCell:self topRightContents.
    topRightCell class:'topRightStyle'. 
    middleRow := table addRow.
    middleLeftCell := middleRow addCell.
    (self middleLeftContentsFor:aResponse) do:[:el | 
        middleLeftCell addChild:el.
    ].
    middleLeftCell class:'middleLeftStyle'.
    middleRightCell := middleRow addCell:(self middleRightContentsFor:aResponse).
    middleRightCell class:'middleRightStyle'.
    bottomRow := table addRow.
    bottomLeftCell := bottomRow addCell:self bottomLeftContents.
    bottomLeftCell class:'bottomLeftStyle'.
    bottomRightCell := bottomRow addCell:(self bottomRightContentsFor:aResponse).
    bottomRightCell class:'bottomRightStyle'.
    body addTable:table.

    document printHtmlOn:aStream.

    "Modified: / 02-02-2007 / 12:31:07 / cg"
!

tableStyleSheet

    |props bodyHtmlStyle topLeftStyle topRightStyle middleLeftStyle middleRightStyle bottomLeftStyle bottomRightStyle styleSheetElements|

    styleSheetElements := OrderedCollection new.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'100%').
    props add:(HTML::CSS_Height with:'100%').
    props add:(HTML::CSS_Margin with:'0px').
    props add:(HTML::CSS_BackgroundColor with:'#f6feff').
    bodyHtmlStyle := HTML::CSS_StyleElement selectors:#('HTML' 'BODY') properties:props.
    styleSheetElements add:bodyHtmlStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'150px').
    props add:(HTML::CSS_Height with:'110px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#topLeftColor)).
    topLeftStyle := HTML::CSS_StyleElement selectors:#('.topLeftStyle') properties:props.
    styleSheetElements add:topLeftStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'100%').
    props add:(HTML::CSS_Height with:'110px').
    props add:(HTML::CSS_TopPadding with:'10px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#topRightColor)).
    props add:(HTML::CSS_Color with:(self parametersAt:#topTextColor)).
    topRightStyle := HTML::CSS_StyleElement selectors:#('.topRightStyle') properties:props.
    styleSheetElements add:topRightStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'150px').
    props add:(HTML::CSS_Height with:'100%').
    props add:(HTML::CSS_TopPadding with:'10px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#leftBarColor)).
    middleLeftStyle := HTML::CSS_StyleElement selectors:#('.middleLeftStyle') properties:props.
    styleSheetElements add:middleLeftStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'100%').
    props add:(HTML::CSS_Height with:'100%').
    props add:(HTML::CSS_TopPadding with:'10px').
    props add:(HTML::CSS_LeftPadding with:'10px').
    props add:(HTML::CSS_RightPadding with:'10px').
    props add:(HTML::CSS_BottomPadding with:'10px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#bodyColor)).
    middleRightStyle := HTML::CSS_StyleElement selectors:#('.middleRightStyle') properties:props.
    styleSheetElements add:middleRightStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'150px').
    props add:(HTML::CSS_Height with:'40px').
    props add:(HTML::CSS_VerticalAlignment newTop).
    props add:(HTML::CSS_BackgroundColor newWhite).
    bottomLeftStyle := HTML::CSS_StyleElement selectors:#('.bottomLeftStyle') properties:props.
    styleSheetElements add:bottomLeftStyle.
    props := OrderedCollection new.
    props add:(HTML::CSS_Width with:'100%').
    props add:(HTML::CSS_Height with:'40px').
    props add:(HTML::CSS_VerticalAlignment newMiddle).
    props add:(HTML::CSS_BackgroundColor with:(self parametersAt:#bottomRightColor)).
    bottomRightStyle := HTML::CSS_StyleElement selectors:#('.bottomRightStyle') properties:props.
    styleSheetElements add:bottomRightStyle.
    ^ styleSheetElements
!

tableStyleSheetOn:aStream
    self putStyleSheet:self tableStyleSheet on:aStream
! !

!ExeptReplyPresenter methodsFor:'style sheet handling'!

generateStyleSheetFor:aServer styleString:aString timeout:seconds 
    |temporaryUrl|

    temporaryUrl := aServer 
                temporaryLinkPathFor:aString
                type:'text/css'
                expirationTimeDelta:seconds.
    ^ PresenterStyleSheet 
        styleSheetString:aString
        temporaryUrl:temporaryUrl
!

getStylePathFor:aResponse styleString:aStyleSheetString
    ^ (self getStyleSheetFor:aResponse styleString:aStyleSheetString) temporaryUrl
!

getStyleSheetFor:aResponse styleString:aString

    ^ self getStyleSheetFor:aResponse styleString:aString timeout:(20000 * 60 * 60).
!

getStyleSheetFor:aResponse styleString:aString timeout:seconds 
    |server|

    server := aResponse request server.
    self presenterStyleSheet isNil ifTrue:[
        self presenterStyleSheet:(self generateStyleSheetFor:server styleString:aString timeout:seconds).
    ] ifFalse:[
        (self styleSheetLinkIsValidFor:aResponse request styleString:aString) ifFalse:[
            server removeTemporaryLinkInfoForUrlPath:self presenterStyleSheet temporaryUrl.
            self presenterStyleSheet:(self generateStyleSheetFor:server styleString:aString timeout:seconds).
        ].
    ].
    ^ self presenterStyleSheet
!

putStyleSheet:styleElements on:aStream
    styleElements do:[:styleElement |
        styleElement printHtmlOn:aStream.
        aStream cr.
    ].
!

styleSheetLinkIsValidFor:aRequest
    <resource: #obsolete>

    self obsoleteMethodWarning.
    ^ (aRequest server hasExpiredForUrlPath:self presenterStyleSheet temporaryUrl
                        time:aRequest startReadRequestTime) not.
!

styleSheetLinkIsValidFor:aRequest styleString:aString
    ^ (aRequest server hasExpiredForLinkObject:self presenterStyleSheet styleSheetString
                        time:aRequest startReadRequestTime) not.
! !

!ExeptReplyPresenter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/ExeptReplyPresenter.st,v 1.33 2010/11/19 11:42:39 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/ExeptReplyPresenter.st,v 1.33 2010/11/19 11:42:39 cg Exp $'
! !
