"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer' }"

HTTPConnection subclass:#FCGIConnection
	instanceVariableNames:'pendingRequests writeLock'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-FCGI-Server'
!

!FCGIConnection class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!FCGIConnection methodsFor:'initialization'!

initializeFor:aHTTPServer socket:aSocket
    pendingRequests := Dictionary new.
    writeLock := RecursionLock new.

    aSocket signalAtEnd:true.

    ^ super initializeFor:aHTTPServer socket:aSocket.
! !

!FCGIConnection methodsFor:'serving'!

setKeepConnectionForRequest:request
    "set weather the connection should be closed.
     FastCgi tells this for each request in BeginRequestRecord."

    closeConnection := request wantsKeepConnection not.
!

waitForAndFetchRecord
    "Read the request and return an HTTPRequest instance,
     when the request is complte.
     Return nil, if there is complete request yet.

     FastCGI may multiplex several requests onton the same connection.
     Demultiplexing is done here."

    |fcgiRecord requestId request|

    socket readWait.
    fcgiRecord := FCGI::FCGIRecord readFromStream:socket.
    requestId := fcgiRecord requestId.

    fcgiRecord isBeginRequest ifTrue:[
        request := FCGIRequest server:httpServer connection:self.
        request requestId:requestId.
        pendingRequests at:requestId put:request.
    ] ifFalse:[
        request := pendingRequests at:requestId ifAbsent:[
            "ignore unknown request"
            ^ nil.
        ].
    ].
    fcgiRecord processChannel:request.
    request isComplete ifTrue:[
        ^ request.
    ].
    ^ nil.
!

waitForAndFetchRequest
    "fetch the next complete request from the connection.
     FastCgi may multiplex more than one request (as several records)
     onto one connetion. #waitAndFetchRecord demultiplexes."

    |request|

    [
        request := self waitForAndFetchRecord.
        request isNil.
    ] whileTrue.

    ^ request
!

writeRecord:aFcgiRecord
    "write a FastCgiRecord (part of the response) to the socket"

    writeLock critical:[
        aFcgiRecord writeToStream:socket
    ].
! !

!FCGIConnection class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/FCGIConnection.st,v 1.5 2006/08/14 15:23:53 stefan Exp $'
! !
