"
 COPYRIGHT (c) 2005 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer' }"

HTTPRequest subclass:#FCGIRequest
	instanceVariableNames:'requestId params isComplete role wantsKeepConnection stdin'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-FCGI-Server'
!

!FCGIRequest class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2005 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!FCGIRequest methodsFor:'accessing'!

data
    "answer the request's data (POST data)"

    stdin isNil ifTrue:[
	"no data yet"
	^ ''.
    ].
    ^ stdin contents
!

isComplete
    "answer true, if all the parts of this request have been collected"

    ^ isComplete
!

isComplete:aBoolean
    isComplete := aBoolean
!

params
    "get the fcgi parameters"

    params isNil ifTrue:[
	params := Dictionary new:32.
    ].
    ^ params
!

requestId
    ^ requestId
!

requestId:something
    requestId := something.
!

role
    ^ role
!

role:aRoleSymbol
    role := aRoleSymbol
!

stdin
    "answer a stream that receives the request's data (POST data)"
    stdin isNil ifTrue:[
	stdin := (String new:1024) writeStream.
    ].

    ^ stdin
!

wantsKeepConnection
    ^ wantsKeepConnection
!

wantsKeepConnection:aBoolean
    wantsKeepConnection := aBoolean
! !

!FCGIRequest methodsFor:'headerParser emulation'!

fieldValueFor:aFieldKey
    "return the value for an lowercase header field key or nil if absent"

    |fieldKey|

    fieldKey := 'HTTP_', (aFieldKey asUppercase replaceAll:$- with:$_).
    ^ params at:fieldKey ifAbsent:nil.
!

fieldValues
    |dict|

    params := self params.
    dict := Dictionary new:params size.

    self params keysAndValuesDo:[:eachKey : eachValue|
	(eachKey startsWith:'HTTP_') ifTrue:[
	    dict at:((eachKey copyFrom:6) replaceAll:$_ with:$-) put:eachValue.
	].
    ].

    ^ dict
!

startLine
    "used for logging - return empty for now"

    ^ ''
! !

!FCGIRequest methodsFor:'misc'!

environmentValueFor:aFieldKey
    "return the value of an fcgi environment value"

    ^ params at:aFieldKey ifAbsent:nil.
! !

!FCGIRequest methodsFor:'processing'!

generateReply

    self parseHeader.
    ^ super generateReply.
!

parseHeader
    headerParser := self.               "dummy, so that params are called"

    peer := IPSocketAddress addressString:(params at:#REMOTE_ADDR).
    peer port:(Integer readFrom:(params at:#REMOTE_PORT)).

    method := params at:#REQUEST_METHOD.
    rawUrl := url := params at:#REQUEST_URI.
! !

!FCGIRequest methodsFor:'queries'!

isSecure
    "answer true, if this request was issued over an secure channel (SSL/TLS)"

    ^ self environmentValueFor:#HTTPS = #on
! !

!FCGIRequest methodsFor:'setup'!

initializeForServer:serverArg connection:connectionArg
    server := serverArg.
    connection := connectionArg.
    response := FCGIResponse request:self.
    isComplete := false.
! !

!FCGIRequest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/FCGIRequest.st,v 1.8 2007/02/07 10:18:26 ca Exp $'
! !
