"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

"{ NameSpace: FCGI }"

Object subclass:#FCGIHeader
	instanceVariableNames:'type requestId contentLength paddingLength'
	classVariableNames:'TypeClasses'
	poolDictionaries:''
	category:'Net-Communication-FCGI-Protocol'
!

!FCGIHeader class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!FCGIHeader class methodsFor:'instance creation'!

readFromStream: aStream
    |version|

    version := aStream nextByte.
    version == self fcgiVersion1 ifTrue:[
        ^ self new readFromStream: aStream
    ] ifFalse:[
        self error:'unknown FCGI version: ', version printString.
        ^ nil.
    ].
! !

!FCGIHeader class methodsFor:'accessing'!

typeClasses
	TypeClasses isNil ifTrue: [self typeClasses: self typeClassesValue].
	^ TypeClasses
!

typeClasses: aDictionary
	TypeClasses _ aDictionary
! !

!FCGIHeader class methodsFor:'constants'!

fcgiVersion1
	^ 1
!

typeClassesValue
        | d |

        FCGI allClassesDo:[:eachFcgiClass|
            eachFcgiClass autoload
        ].
        
        d := Dictionary new.
        FCGIRecord allSubclassesDo: [:aCl | d at: aCl fcgiType put: aCl].
        ^ d
! !

!FCGIHeader class methodsFor:'initialization & release'!

initialize
        "self initialize"
        self typeClasses: nil.
! !

!FCGIHeader methodsFor:'accessing'!

contentLength
	^ contentLength
!

contentLength: aLength 
	contentLength _ aLength
!

paddingLength
	^ paddingLength
!

paddingLength: aLength 
	paddingLength _ aLength
!

requestId
	^ requestId
!

requestId: aRequestId 
	requestId _ aRequestId
!

type
	^ type
!

type: aType 
	type _ aType
!

typeClass
	^ self class typeClasses
		at: self type
		ifAbsent: [self error: 'Not yet implemented. Type: ' , self type asString]
! !

!FCGIHeader methodsFor:'reading/writing'!

readFromStream: aStream 
        self type: aStream nextByte.
        self requestId: (aStream nextUnsignedShortMSB: true).
        self contentLength: (aStream nextUnsignedShortMSB: true).
        self paddingLength: aStream nextByte.
        aStream next "reserved"
!

writeToStream: aStream 
        aStream nextPutByte: self class fcgiVersion1.
        aStream nextPutByte: self type.
        aStream nextPutShort: self requestId MSB: true.
        aStream nextPutShort: self contentLength MSB: true.
        aStream nextPutByte: 0.
        aStream nextPutByte: 0
! !

!FCGIHeader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/FCGI__FCGIHeader.st,v 1.6 2008/09/03 08:50:06 cg Exp $'
! !

FCGIHeader initialize!
