"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer' }"

"{ NameSpace: FCGI }"

Object subclass:#FCGIRecord
	instanceVariableNames:'header data'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-FCGI-Protocol'
!

!FCGIRecord class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!FCGIRecord class methodsFor:'instance creation'!

newHeader: aHeader 
	^ aHeader typeClass new header: aHeader
!

readFromStream: aStream 
        "SW: 
        Cant handle, not sent by Apache? 
        -5.4 FCGI_ABORT_REQUEST 
        -4.1 FCGI_GET_VALUES, FCGI_GET_VALUES_RESULT"
        | instance |
        instance := self newHeader: (FCGI::FCGIHeader readFromStream: aStream).
        instance readDataFrom: aStream.
        instance assertValid.
        ^ instance
! !

!FCGIRecord methodsFor:'accessing'!

data
	^data
!

data: aData 
	data := aData
!

dataLength
	^self data size
!

dataNotNil
	| t |
	^(t := self data) isNil
		ifTrue: [ByteArray new]
		ifFalse: [t]
!

header
	^header
!

header: aHeader 
	header := aHeader
!

headerContentLength
	^self header contentLength
!

headerPaddingLength
	^self header paddingLength
!

headerType
	^self header type
!

requestId
	^self header requestId
! !

!FCGIRecord methodsFor:'error handling'!

assertValid
        self data isNil ifTrue: [self error: 'Malformed Record']
! !

!FCGIRecord methodsFor:'reading/writing'!

readDataFrom: aStream 
	self readValuesFrom: aStream.
	self headerPaddingLength > 0
		ifTrue: [aStream next: self headerPaddingLength]
!

readValuesFrom: aStream 
	self data: (aStream next: self headerContentLength)
!

writeBodyToStream: aStream 
        aStream nextPutBytes:self data size from:self data startingAt:1
!

writeToStream: aStream 
	self header writeToStream: aStream.
	self writeBodyToStream: aStream
! !

!FCGIRecord methodsFor:'testing'!

isBeginRequest
	^false
! !

!FCGIRecord class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/FCGI__FCGIRecord.st,v 1.3 2005/12/28 12:34:08 cg Exp $'
! !
