"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer' }"

"{ NameSpace: FCGI }"

FCGIRecord subclass:#FCGIRecordBeginRequest
	instanceVariableNames:'role flags'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-FCGI-Protocol'
!

!FCGIRecordBeginRequest class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!FCGIRecordBeginRequest class methodsFor:'constants'!

fcgiKeepConn
	^ 1
!

fcgiType
	^ 1
!

roles
        ^ #(#responder #authorizer #filter)
! !

!FCGIRecordBeginRequest methodsFor:'accessing'!

flags
	^flags
!

flags: theFlags 
	flags := theFlags
!

role
	^role
!

role: aRole 
	role := aRole
!

roleSymbol
	^ self class roles at: self role
! !

!FCGIRecordBeginRequest methodsFor:'error handling'!

assertValid
        super assertValid.
        self headerContentLength = 8
                ifFalse: [self error: 'Malformed BeginRequest packet received with content length: ' , self headerContentLength asString]

! !

!FCGIRecordBeginRequest methodsFor:'processing'!

processChannel: aChannel
	aChannel role: self roleSymbol.
	aChannel wantsKeepConnection: self wantsKeepConnection
! !

!FCGIRecordBeginRequest methodsFor:'reading/writing'!

readValuesFrom: aStream 
        super readValuesFrom: aStream.
        self role: ((self data byteAt: 1) * 256 + (self data byteAt: 2)). "aStream next2."
        self flags: (self data byteAt: 3). "aStream next."
        "aStream next: 5"
! !

!FCGIRecordBeginRequest methodsFor:'testing'!

isBeginRequest
	^true
!

wantsKeepConnection
	"SW 5.1 flags & FCGI_KEEP_CONN: If zero, the application closes the 
	connection after responding to this request. If not zero, the application 
	does not close the connection after responding to this request; the Webb 
	server retains responsibility for the connection"
	^ (self flags bitAnd: self class fcgiKeepConn)
		~= 0
! !

!FCGIRecordBeginRequest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/FCGI__FCGIRecordBeginRequest.st,v 1.2 2005/12/28 12:34:03 cg Exp $'
! !
