"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

Object subclass:#HTTPCookie
	instanceVariableNames:'name rawValue value path expiration secure maxAge httpOnly'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTTP-Server'
!

!HTTPCookie class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    [author:]
        Christian Penk
"
! !

!HTTPCookie methodsFor:'accessing'!

expiration
    "return the value of the instance variable 'expiration' (automatically generated)"

    ^ expiration
!

expiration:something
    "set the value of the instance variable 'expiration' (automatically generated)"

    expiration := something.
!

httpOnly
    ^ httpOnly
!

httpOnly:something
    httpOnly := something.
!

maxAge
    ^ maxAge
!

maxAge:something
    maxAge := something.
!

name
    ^ name

    "Modified: / 08-07-2009 / 11:29:43 / Administrator"
!

name:something
    name := something.

    "Modified: / 08-07-2009 / 11:29:40 / Administrator"
!

name:nameArg value:valueArg path:pathArg expiration:expirationArg 
    "set instance variables (automatically generated)"

    name := nameArg.
    value := valueArg.
    path := pathArg.
    expiration := expirationArg.
!

path
    "/ if I am still raw, cook me
    (path isNil and:[rawValue notNil]) ifTrue:[
        self extractValueAndPathFromRawValue
    ].
    ^ path

    "Modified: / 08-07-2009 / 11:44:26 / Administrator"
!

path:something
    path := something.

    "Modified: / 08-07-2009 / 11:29:25 / Administrator"
!

rawValue
    ^ rawValue
!

rawValue:something
    rawValue := something.
!

secure
    ^ secure
!

secure:something
    secure := something.
!

value
    "/ if I am still raw, cook me
    (value isNil and:[rawValue notNil]) ifTrue:[
        self extractValueAndPathFromRawValue
    ].
    ^ value

    "Modified: / 08-07-2009 / 11:44:16 / Administrator"
!

value:something
    value := something.

    "Modified: / 08-07-2009 / 11:29:18 / Administrator"
! !

!HTTPCookie methodsFor:'encoding / decoding'!

extractValueAndPathFromRawValue
    |decodedValue|

    decodedValue := self extractValueFrom:rawValue.
    value := decodedValue first.
    path := decodedValue second.

    "Created: / 08-07-2009 / 11:39:01 / Administrator"
!

extractValueFrom:aBase64EncodedString
    ^ Object readFrom:(Base64Coder decode:aBase64EncodedString) asString

    "
     |c s|

     c := HTTPCookie new.
     c value:#('aaa' 1234 '97e44aa0-c51c-11dd-8dc8-0018f3c28c0d' '/foo/bar/baz').
     s := c htmlString.
     c extractValueFrom:(s copyFrom:(s indexOf:$=)+1 to:(s indexOf:$;)-1).
    "
!

htmlString
    |s|

    s := '' writeStream.
    s nextPutAll:(name ? 'someCookie').
    value notNil ifTrue:[
        s nextPut:$=.
        s nextPutAll:(Base64Coder new lineLimit:nil; encodingOf:value storeString).
    ].
    s nextPutAll:'; Version=1'.      
    path notNil ifTrue:[
        s nextPutAll:'; Path='; nextPutAll:path.
    ].
    maxAge notNil ifTrue:[
        s nextPutAll:'; Max-Age='.
        maxAge printOn:s.
    ].
    expiration notNil ifTrue:[
        s nextPutAll:'; Expires='.
        expiration printOn:s format:'%(DayName), %(day)-%(ShortMonthName)-%(year) %h:%m:%s GMT'.
    ].
    secure == true ifTrue:[
        s nextPutAll:'; Secure'.
    ].
    httpOnly == true ifTrue:[
        s nextPutAll:'; HttpOnly'.
    ].
    ^ s contents

    "
     self new htmlString      

     (Timestamp
        day:1 month:1 year:2010
        hour:1 minutes:0 seconds:0) 
            printStringFormat:'%(DayName), %(day)-%(ShortMonthName)-%(year) %h:%m:%s GMT'  
  "
! !

!HTTPCookie methodsFor:'printing'!

printOn:aStream
    self class name printOn:aStream.
    aStream nextPut:$(.
    name printOn:aStream.
    aStream nextPut:$).
! !

!HTTPCookie class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/HTTPCookie.st,v 1.12 2010/07/23 19:53:47 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/HTTPCookie.st,v 1.12 2010/07/23 19:53:47 stefan Exp $'
! !
