"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

HTTPService subclass:#HTTPFileService
	instanceVariableNames:'fileRoot defaultFileName cachingSema fileCache
		numBytesInFileCache maxCacheSize maxMemoryUsedForCache
		maxCacheDocumentSize fileCacheExpirationDelta expirationTime
		directoryListingsAllowed notFoundRedirection checkReferrer
		allowRemoveFile showWorldReadableOnly'
	classVariableNames:'CommonImages MimeTypeImages CachedMimeTypes CachedMimeTypesSize
		DirectoryContentsCache DirectoryContentsCacheTime
		DirectoryContentsCacheSize'
	poolDictionaries:''
	category:'Net-Communication-HTTP-Services'
!

Object subclass:#CachedFileInfo
	instanceVariableNames:'expirationTime modificationTime data'
	classVariableNames:''
	poolDictionaries:''
	privateIn:HTTPFileService
!

!HTTPFileService class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    This service provides regular HTTP-file access.
    All requests below the services linkName are translated
    to a file-access below the services fileRoot.
    An empty URL (relative to the linkName) is translated to the defaultFileName.

    The ReplyPresenter is only used to decorate the files when showing the directory contents.

    Service parameters:

    directoryListingsAllowed
            users are allowed to browse the contents of directories.

    showWorldReadableOnly
            only show the contents of files and directories, if their access rights
            allow access to everyone.

    maxCacheSize
            the number of file documents that will be cached
            in memory for fast access.
            The default is 20.

    maxCacheDocumentSize
            the maximum size of a file document for caching.
            Files larger are not cached.
            The default is 4K (i.e. quite small)

    Take care of memory usage when increasing those values.

    [author:]
        Christian Penk
"
! !

!HTTPFileService class methodsFor:'defaults'!

defaultExpirationTime
    "a documents expiration time in seconds (returned to browser for its cache)"

    ^  24 * 60 * 60 "/ seconds
!

fileCacheExpirationDelta
    "a cached files expiration time (seconds)"

    ^  30 "/ seconds
!

linkName
    "return the default path (with slash)"

    ^ '/files'
!

maxCacheDocumentSize
    "files larger are not cached"

    ^ 8192
!

maxCacheSize
    "max nr of files to cache"

    ^ 30 
!

maxDirectoryCacheSize
    "max nr of directory contents to cache"

    ^ DirectoryContentsCacheSize ? 10 
!

maxDirectoryCacheTimedelta
    "max nr of seconds for directory contents to cache"

    ^ DirectoryContentsCacheTime ? 60 
!

maxMemoryUsedForCache
    "max overall memory used for cache"

    ^ 512*1024 
! !

!HTTPFileService class methodsFor:'directory list images'!

backImage
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self backImage inspect
     ImageEditor openOnClass:self andSelector:#backImage
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:#'HTTPFileService class backImage'
        ifAbsentPut:[(Depth8Image new) width: 20; height: 22; photometric:(#palette); bitsPerSample:(#(8)); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
FA XFA XFA XFA XFA XFA XFA XFA XFA XF@LXA@PXFA XFA XFA XFA XFA X@ PDA@PDAA XFA XFA XFA XFA CF@PDA@PDA@PXFA XFA XFA XF@HD
A@PDA@PDA@PXFA XFA XFA X@1 DA@PDA@PDA@PXFA XFA XFA BA@PDA@PDA@PDA@PXFA XFA XF@LXA@PDA@PDA@PXAQ XFA XFA XFA DA@PDA@PXF@TE
FA XFA XFA XFA XAA X@ PEAPTXFA XF@TXFA XFA BA@TEAPTEAQ XFA EAQ XF@HDAPTEAPTEAPTEFA XAPTEAPTEAPTEAPTEAPTEAPTXF@TEAPTEAPTE
APTEAPTEAPTEAA EAPTEAPTEAPTEAPTEAPTEAPTBAPTEAPTEAPTEAPTEAPTEAPTE@1 XAPTEAPTEAPTEAPTEAPTEA@HXFA XAPTEAPTEAPTEAPTD@!! XFA X
FA XAPTEAPTEA@HXFA XFA XFA XFA XAPTXFA XFA XFA XFA XFA XFA XAQ XFA XFA XFA XFA XFA XFA XFA XFA XFA XFA XFA b') ; colorMapFromArray:#[255 255 255 204 255 255 153 153 153 102 102 102 51 51 51 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]; mask:((ImageMask new) width: 20; height: 22; photometric:(#blackIs0); bitsPerSample:(#(1)); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@K@@@O8@@K>@@O?@@K? @O?0@K?P@C<0@@''0A@?0CG?0G??0O??0_??0??? _??@O?8@G>@@C@@@A@@@@@@@') ; yourself); yourself]
!

blankImage
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self blankImage inspect
     ImageEditor openOnClass:self andSelector:#blankImage
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:#'HTTPFileService class blankImage'
        ifAbsentPut:[(Depth8Image new) width: 20; height: 22; photometric:(#palette); bitsPerSample:(#(8)); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
F@@@@@@@@@@@@@@@@@@@@@@@@@@X@A XFA @@@@@@@@@FA XFA X@A @FA XF@@@@@@@@@@@@@@XFA @F@@XFA X@A @@@@@@@@@@@@X@@@X@A XFA @F@@@
@@@@@@@@@@@@@A @FA XF@@X@@@@@@@@@@@@@@@@F@@XFA X@@@@@@@@@@@@@@@@@@@X@A XFA @@@@X@@@@@@@@@@@@@A @FA @FA X@A @@@@@@@@@@@@@
F@@XF@@XFA @F@@@@@@@@@@@@@@X@A @@@@@F@@X@@@@@@@@@@@@@A @F@@@@@@@@@@@@@@@@@@@@@@@F@@@@@@@@@@@@@@@@@@@@@@@@@@X@@@@@@@@@@@@
@@@@@@@@@@@@@A @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@X@@@@@@@@@@@@@@@@@@@@@@@@@A @@@@@@@@@@@@@@@@@@@@X@@@@
F@@X@@@@@@@@@@@@@@@@FA XF@@X@A X@@@@@@@@@A XFA XFA X@A @@@@@@@@@@@@@@@@@@@@@@@@@FA XFA XFA XFA XFA XFA XFA b') ; colorMapFromArray:#[255 255 255 204 255 255 153 153 153 102 102 102 51 51 51 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]; mask:((ImageMask new) width: 20; height: 22; photometric:(#blackIs0); bitsPerSample:(#(1)); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@') ; yourself); yourself]
!

commonImageDataFor:aImageName
    ^ self commonImages at:aImageName ifAbsent:nil.
!

commonImagePath
    ^ '7d064860-0eec-11e1-9eba-001fc6d99920/'.
!

commonImages
    CommonImages isNil ifTrue:[
        CommonImages := Dictionary new.
        self imageList pairWiseDo:[:filename :selector|
            CommonImages at:filename put:(HTTPServer gifImageDataForImage:(self perform:selector)).
        ].
    ].
    ^ CommonImages


"
    DirectoryListingImages := nil.
    self directoryListingImages
"
!

folderImage
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self folderImage inspect
     ImageEditor openOnClass:self andSelector:#folderImage
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:#'HTTPFileService class folderImage'
        ifAbsentPut:[(Depth8Image new) width: 19; height: 21; photometric:(#palette); bitsPerSample:(#(8)); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@PDA@PDA@@@@@@@@@@@@@@@@@P@@@@@@@@D@@@@@@@@@@@@@@@@A@PDA@PD@@DC@0LC
@0LC@0@@A@PDA@PDA@P@@@@@@@@@@@@@@@PDA@PDA@PD@PLC@0LC@0LC@@@A@PDA@PDA@PLC@0LC@0LC@0@@@0LC@0LC@0LC@0LC@0LC@0L@@@LC@0LC@0LC
@0LC@0LC@0LC@@@C@0LC@0LC@0LC@0LC@0LC@0@@@0LC@0LC@0LC@0LC@0LC@0L@@@LC@0LC@0LC@0LC@0LC@0LC@@@C@0LC@0LC@0LC@0LC@0LC@0@@@0LC
@0LC@0LC@0LC@0LC@0L@@@LC@0LC@0LC@0LC@0LC@0LC@@@C@0LC@0LC@0LC@0LC@0LC@0@@@0LC@0LC@0LC@0LC@0LC@0L@@@LC@0LC@0LC@0LC@0LC@0LC
@@@C@0LC@0LC@0LC@0LC@0LC@0@@@@@@@@@@@@@@@@@@@@@@@@@@') ; colorMapFromArray:#[0 0 0 255 255 255 0 0 0 192 192 0 128 128 0]; mask:((Depth1Image new) width: 19; height: 21; photometric:(#blackIs0); bitsPerSample:(#(1)); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@@@@@@@@@@@@O0@@_8@@??? ??? ??? ??? ??? ??? ??? ??? ??? ??? ??? ??? ??? ??? ??? ??? ') ; yourself); yourself]
!

imageList

    ^ #(
        'unknown.gif'  #unknownImage
        'back.gif'     #backImage
        'blank.gif'    #blankImage
        'folder.gif'   #folderImage
      )
!

linkForImage:anImageKey 

    ^ self commonImagePath, anImageKey
!

linkForMimeType:aMimeType 

    ^ self mimeTypeImagePath, aMimeType
!

mimeTypeImageDataFor:aMimeTypeOrKey
    |imgData img|

    MimeTypeImages isNil ifTrue:[
        MimeTypeImages := Dictionary new.
    ].
    imgData := MimeTypeImages at:aMimeTypeOrKey ifAbsent:nil.
    imgData == #notAvailable ifTrue:[
        ^ nil
    ].
    img := MIMETypeIconLibrary iconForKeyMatching:aMimeTypeOrKey.
    img isNil ifTrue:[
        MimeTypeImages at:aMimeTypeOrKey put:#notAvailable.
        ^ nil
    ].
    imgData := HTTPServer gifImageDataForImage:img.
    MimeTypeImages at:aMimeTypeOrKey put:imgData.
    ^ imgData
!

mimeTypeImagePath
    ^ 'daa98900-0eec-11e1-9eba-001fc6d99920/'.
!

unknownImage
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self unknownImage inspect
     ImageEditor openOnClass:self andSelector:#unknownImage
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:#'HTTPFileService class unknownImage'
        ifAbsentPut:[(Depth8Image new) width: 19; height: 21; photometric:(#palette); bitsPerSample:(#(8)); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@DA@PDA@PD@@@@@@@@@@@@@@@@A@PDA@PDA@@D@@@@@@@@@@@@@@PDA@PDA@P@A@P@@@@@@@@@@@@DA@PDA@PD@@PDA
@@@@@@@@@@@A@PDA@PDA@@DA@PD@@@@@@@@@@PDA@PDA@P@A@PDA@P@@@@@@@@DA@PDA@PD@@@@@@@@@@@@@@@@A@PDA@PDA@P@A@@D@@PH@@@@@@PDA@PDA
@PDA@@D@@P@B@@@@@@DA@PDA@PDA@PDA@PDA@ @@@@@A@PDA@PDA@PDA@PDA@PH@@@@@@PDA@PDA@PDA@PDA@PDB@@@@@@DA@PDA@PDA@PDA@PDA@ @@@@@A
@PDA@PDA@PDA@PDA@PH@@@@@@PDA@PDA@PDA@PDA@PDB@@@@@@DA@PDA@PDA@PDA@PDA@ @@@@@A@PDA@PDA@PDA@PDA@PH@@@@@@PDA@PDA@PDA@PDA@PDB
@@@@@ DA@PDA@PDA@PDA@PDA@ @@@@H@@@@@@@@@@@@@@@@@@@H@') ; colorMapFromArray:#[0 0 0 255 255 255 0 0 0]; mask:((Depth1Image new) width: 19; height: 21; photometric:(#blackIs0); bitsPerSample:(#(1)); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'O>@@O?@@O? @O?0@O?8@O?<@O?>@O?>@O??@O??@O??@O??@O??@O??@O??@O??@O??@O??@O??@O??@O??@') ; yourself); yourself]
! !

!HTTPFileService class methodsFor:'queries-service'!

isThreadSafe
    ^ true
!

settingsApplicationClass
    "my application in the settings dialog"

    ^ HTTPFileServiceSettingsApp
! !

!HTTPFileService methodsFor:'accessing'!

allowRemoveFile
    ^ allowRemoveFile ? false
!

allowRemoveFile:something
    allowRemoveFile := something.
!

checkReferrer
    "when true, the documents referrer must be a page from me
     (i.e. do not allow cross-site links to my documents).
     The onlz exception to this are the services' defaulFileName and root."

    ^ checkReferrer ? false
!

checkReferrer:aBoolean
    checkReferrer := aBoolean
!

directoryListingsAllowed
    ^ directoryListingsAllowed ? false
!

directoryListingsAllowed:aBoolean
    directoryListingsAllowed := aBoolean.
!

expirationTime
    "a documents expiration time in seconds (returned to browser for its cache)"

    expirationTime isNil ifTrue:[
        ^ self class defaultExpirationTime.
    ].
    ^ expirationTime
!

expirationTime:seconds
    "a documents expiration time in seconds (returned to browser for its cache).
     An expirationTime of 0 disables the browsers caching.
     Caveat: should be named maxAge:"

    expirationTime := seconds.
!

reportForbiddenDirectoryListing
    "return true, if a request to list a directory should be
     reported as forbidden (403) or as not found (404).
     If true, users could learn (and try) the directory structure.
     The default is true.
     Should probably be settable in the SettingsDialog"

    "what is better - (i.e. should we let the user know about the existence of a directory) ?"

    "/ ^ false.
    ^ true
!

showWorldReadableOnly
    "answer true, if a file or directory must be readable by the whole world in order to be shown"

    ^ showWorldReadableOnly ? true
!

showWorldReadableOnly:something
    showWorldReadableOnly := something.
! !

!HTTPFileService methodsFor:'caching'!

cacheData:data forFile:aFileName
    "the contents of small files is cached here"

    |maxCacheSize newEntry oldEntry|

    maxCacheSize := self maxCacheSize.
    maxCacheSize == 0 ifTrue:[
        ^ self "/ do not cache
    ].

    newEntry := CachedFileInfo new.
    newEntry
        data:data
        expirationTime:(Timestamp now addSeconds:self fileCacheExpirationDelta)
        modificationTime:(aFileName modificationTime).

    cachingSema critical:[
        fileCache isNil ifTrue:[
            fileCache := OrderedDictionary new.
            numBytesInFileCache := 0.
        ].

        "/ Transcript showCR:'new cache for ', aFileName name.
        (maxCacheSize notNil and:[fileCache size >= maxCacheSize]) ifTrue:[
            oldEntry := fileCache removeFirst.
            numBytesInFileCache := numBytesInFileCache - oldEntry dataSize.
        ].
        fileCache addLast:(aFileName name -> newEntry).
        numBytesInFileCache := numBytesInFileCache + data size.
    ]
!

cachedDataForFile:aFileName fileInfo:fileInfo
    "small files are cached - look in the cache.
     Returns the files data or nil"

    |entry pathName now |

    fileCache notNil ifTrue:[
        pathName := aFileName name.

        cachingSema critical:[
            fileCache notNil ifTrue:[
                entry := fileCache at:pathName ifAbsent:nil.
                entry notNil ifTrue:[
                    now := Timestamp now.
                    entry expirationTime < now ifTrue:[
                        fileInfo modificationTime > entry modificationTime ifTrue:[
"/                            Transcript showCR:'cache for ', pathName , ' no longer valid'.
                            "/ cache no longer valid
                            fileCache removeKey:pathName.
                            ^ nil
                        ].
                        "/ the folowing re-caches the file for another n-seconds 
"/                        Transcript showCR:'recache for ', pathName.
                        entry expirationTime:(now addSeconds:self fileCacheExpirationDelta).
                    ].

                    "/ bring that item to the end of the access list (for LRU behavior).
                    fileCache at:pathName put:entry.
"/                    Transcript showCR:'hit cache for ', pathName.

                    ^ entry data
                ].
            ].
        ].
    ].
    ^ nil
!

fillCacheWithData:data forPseudoFile:aFileNameString
    "can be used to fill the cache with nonexisting, pseudo files.
     These will not expire and there is no limit."

    |newEntry|

    newEntry := CachedFileInfo new.
    newEntry
        data:data
        expirationTime:(Timestamp now addSeconds:self fileCacheExpirationDelta)
        modificationTime:(Timestamp now).

    cachingSema critical:[
        fileCache isNil ifTrue:[
            fileCache := OrderedDictionary new.
            numBytesInFileCache := 0.
        ].

        fileCache addLast:(aFileNameString -> newEntry).
        numBytesInFileCache := numBytesInFileCache + data size.
    ]

    "Created: / 12-04-2011 / 17:32:20 / cg"
!

flushCache
    "flush the servers file cache"

    fileCache := nil.
    numBytesInFileCache := 0.
! !

!HTTPFileService methodsFor:'initialization'!

initialize
    super initialize.
    allowRemoveFile := false.
    cachingSema := Semaphore forMutualExclusion.
! !

!HTTPFileService methodsFor:'maintenance html presentation'!

specificChangeFromRequest:aRequest
    "extracts parameter from an html-maintenance post-request"

    |tmp expirationTimeValue|

    tmp := aRequest urlParameterAt:'DefaultFilename'.
    tmp notNil ifTrue:[
        self defaultFileName:tmp.
    ].
    tmp := aRequest urlParameterAt:'ServiceRootDirectory'.
    tmp notNil ifTrue:[
        self fileRoot:tmp asFilename.
    ].
    tmp := aRequest urlParameterAt:'MaxCacheSize'.
    tmp notNil ifTrue:[
        self maxCacheSize:(Integer readFrom:tmp onError:self maxCacheSize).
    ].
    tmp := aRequest urlParameterAt:'MaxCacheDocumentSize'.
    tmp notNil ifTrue:[
        self maxCacheDocumentSize:(Integer readFrom:tmp onError:self maxCacheDocumentSize).
    ].
    tmp := aRequest urlParameterAt:'FileCacheExpirationDelta'.
    tmp notNil ifTrue:[
        self fileCacheExpirationDelta:(Integer readFrom:tmp onError:self fileCacheExpirationDelta).
    ].
    tmp := aRequest urlParameterAt:'ExpirationTime'.
    tmp notNil ifTrue:[
        expirationTimeValue := Integer readFrom:tmp onError:nil.
        expirationTimeValue notNil ifTrue:[
            expirationTimeValue := expirationTimeValue * 60 * 60.
        ].
        self expirationTime:expirationTimeValue.
    ].
    tmp := aRequest urlParameterAt:'DirectoryListingsAllowed'.
    self directoryListingsAllowed:(tmp = 'ON').

    tmp := aRequest urlParameterAt:'showWorldReadableOnly'.
    self showWorldReadableOnly:(tmp = 'ON').
!

specificInputFieldsForRequest:aRequest 
    "generates the html-fragment for the maintenance form"

    |defaultFilename|

    aRequest
        inputFieldFor:'ServiceRootDirectory'
            type:nil
            size:'50'
            label:('Service Root Directory:<BR><BLOCKQUOTE>')
            initialValue:self fileRoot asString;
        nextPutLine:'</BLOCKQUOTE><BR>'.
    defaultFilename := self defaultFileName isNil ifTrue:[
                ''
            ] ifFalse:[
                self defaultFileName asString
            ].
    aRequest
        inputFieldFor:'DefaultFilename'
            type:nil
            size:'50'
            label:('Default Filename:<BR><BLOCKQUOTE>')
            initialValue:defaultFilename;
        nextPutLine:'</BLOCKQUOTE><BR>';

        inputFieldFor:'ExpirationTime'
            type:nil
            size:'50'
            label:('Expiration Time (Hours):<BR><BLOCKQUOTE>')
            initialValue:(self expirationTime / 60 / 60) asFloat asString;
        nextPutLine:'</BLOCKQUOTE><BR>';

        nextPutLine:'<TABLE><TR><TD>Max. # of Cached Files:</TD><TD>';
        inputFieldFor:'MaxCacheSize'
            size:6
            label:nil
            initialValue:self maxCacheSize printString;
        nextPutLine:'</TD></TR>';

        nextPutLine:'<TR><TD>Max. Size of Cached Files:</TD><TD>';
        inputFieldFor:'MaxCacheDocumentSize'
            size:6
            label:nil
            initialValue:self maxCacheDocumentSize printString;
        nextPutLine:'</TD></TR>';

        nextPutLine:'<TR><TD>File Cache Expiration Delta (Seconds):</TD><TD>';
        inputFieldFor:'FileCacheExpirationDelta'
            size:6
            label:nil
            initialValue:self fileCacheExpirationDelta printString;
        nextPutLine:'</TD></TR>';

        nextPutLine:'<TR><TD>';
        inputFieldFor:'DirectoryListingsAllowed' 
            type:'checkbox' 
            size:nil 
            label:('Directory Listings Allowed:</TD><TD>') 
            initialValue:'ON'
            append:(self directoryListingsAllowed ifTrue:['checked'] ifFalse:['']);
        nextPutLine:'</TD></TR>';

        nextPutLine:'<TR><TD>';
        inputFieldFor:'showWorldReadableOnly' 
            type:'checkbox' 
            size:nil 
            label:('Allow Access to World Readable Files Only:</TD><TD>') 
            initialValue:'ON'
            append:(self showWorldReadableOnly ifTrue:['checked'] ifFalse:['']);
        nextPutLine:'</TD></TR></TABLE>'.
! !

!HTTPFileService methodsFor:'queries-service'!

isAllowedInMaintenanceMode
    "return true, if this service is also allowed while the server is in maintenance mode"

    ^ true
!

isCGIService
    ^ false
!

isFileService

    ^ true
! !

!HTTPFileService methodsFor:'response generation'!

commonImageLinkStringFor:aRequest image:anImageKey alt:altString
    |stream|

    stream := WriteStream on:''.

    stream
        nextPutAll:'<img src="';
        nextPutAll:(aRequest linkIdFor:self);
        nextPut:$/;
        nextPutAll:(self class linkForImage:anImageKey);
        nextPutAll:'" ALT="[';
        nextPutAll:(altString ? '   ');
        nextPutAll:']">'.

    ^ stream contents.
!

directoryListingImageLinkStringFor:aRequest image:aMimeType alt:altString 
    ^ HTML::Image 
        source:((aRequest linkIdFor:self) , '/' , (self class linkForMimeType:aMimeType))
        alternative:altString
        border:0.
!

process:aRequest 
    |suffix data logicalFilename physicalFilename type dataSize dataStream response fileInfo referrer referringHost referringHostsAddresses sameHost ifModifiedSince|

    self directoryListingsAllowed ifTrue:[
        (self processDirectoryImageFor:aRequest) ifTrue:[
            ^ self
        ].
    ].

    response := aRequest response.

    logicalFilename := aRequest pathRelativeToService.
    logicalFilename isEmpty ifTrue:[
        defaultFileName notEmptyOrNil ifTrue:[
            logicalFilename := defaultFileName.
            " have to redirect here because default file may contain relative links
              which are expanded by the browser from the current url "
            aRequest redirectTo:((aRequest linkIdFor:self) , '/' , defaultFileName).
            ^ self
        ].
        self directoryListingsAllowed ifFalse:[
            (self redirectFor:aRequest) ifTrue:[^ self].
            self reportForbiddenDirectoryListing ifTrue:[
                aRequest reportForbidden:'Directory listing denied'.
            ] ifFalse:[
                aRequest reportNotFound:(aRequest fullPath).
            ].
            "/ not reached
            ^ self
        ].
    ].

    "/ does not really make sense, because some (many ?) browsers do not
    "/ provide a referrer for gif-image and css-file accesses.
    self checkReferrer ifTrue:[
        "/ referrer must be this host, except for home/default file.
        referrer := aRequest referrer.
        sameHost := false.
        referrer notNil ifTrue:[
            "increment count only if refered from a real page"
            referringHost := (URL fromString:referrer) host.
            [
                referringHostsAddresses := SocketAddress allForHostName:referringHost.
                "/ I will only count my own pages - ignore if linked from another host
                sameHost := (referringHostsAddresses contains:[:eachRefererAddress|
                    eachRefererAddress hostAddress = aRequest socketAddress hostAddress
                ]).
            ] on:NameLookupError do:[:ex| ].
        ].
        sameHost ifFalse:[
"/ Transcript showCR:('- ' , logicalFilename , ' ref:',referrer printString,' refHost: ',referringHostsAddress printString).
            logicalFilename ~= self defaultFileName ifTrue:[
                aRequest reportForbidden:'No Cross Links Allowed'.
                "/ not reached.
                ^ self.
            ].
        ].
    ].

    physicalFilename := self fileRoot asFilename construct:logicalFilename.

    "the file must be world readable, in order to be presented to the world"

    fileInfo := physicalFilename info.
    fileInfo notNil ifTrue:[
        (self showWorldReadableOnly and:[fileInfo isWorldReadable not]) ifTrue:[
            aRequest reportForbidden:'no read access to file'.
            "not reached"
        ].
    ].

    type := aRequest urlParameterAt:'contentTypeOverride'.
    type isNil ifTrue:[
        suffix := physicalFilename suffix.
        suffix notEmptyOrNil ifTrue:[
            "try fast"
            type := MIMETypes mimeTypeForSuffix:suffix.
        ].
        type isNil ifTrue:[
            fileInfo notNil ifTrue:[
                "try harder, the last resort is an octet-stream, which can at least be downloaded"
                type := physicalFilename mimeTypeOfContents ? 'application/octet-stream'.
            ].
        ].
    ].

    (aRequest checkAcceptableType:type) ifFalse:[
        aRequest reportNotAcceptable:type.
        "/ not reached
        ^ self
    ].

    ifModifiedSince := aRequest ifModifiedSince.
    (ifModifiedSince notNil and:[fileInfo notNil and:[fileInfo isDirectory not]]) ifTrue:[
        ifModifiedSince := UtcTimestamp readRFC1123FormatFrom:ifModifiedSince onError:[Timestamp epoch].
        fileInfo modificationTime <= ifModifiedSince  ifTrue:[
            "the file has not been changed since it has been cached by the client.
             Answer 'Not Modified'"
            response 
                responseCode:304;   "Not Modified"
                maxAge:self expirationTime;
                lastModified:fileInfo modificationTime.
            ^ self.
        ].
    ].

    data := self cachedDataForFile:physicalFilename fileInfo:fileInfo.
    data notNil ifTrue:[
        dataSize := data size.
        response data:data.
    ] ifFalse:[
        fileInfo isNil ifTrue:[
            data := self cachedDataForFile:logicalFilename asFilename fileInfo:nil.
            data isNil ifTrue:[
                (self redirectFor:aRequest) ifFalse:[
                    aRequest reportNotFound:'Not found: ' , (aRequest fullPath).
                    "/ not reached
                ].
                ^ self
            ].
            dataSize := data size.
            response data:data.
        ] ifFalse:[
            [
                fileInfo isDirectory ifTrue:[
                    self processDirectory:physicalFilename for:aRequest.
                    ^ self.
                ].
                dataSize := fileInfo fileSize.
                (self maxCacheSize isNil or:[dataSize > self maxCacheDocumentSize]) ifTrue:[
                    dataStream := physicalFilename readStream.
                    dataStream binary.
                    response dataStream:dataStream.
                ] ifFalse:[
                    data := physicalFilename binaryContentsOfEntireFile.
                    self cacheData:data forFile:physicalFilename.
                    response data:data.
                ].
            ] on:OpenError do:[:ex|
                aRequest reportForbidden:'access denied'.
                "not reached"
            ].
        ].
    ].

    aRequest server verbose ifTrue:[
        Transcript showCR:'HTTPFileService: size is ' , dataSize printString
    ].
    response 
        contentType:type;
        contentLength:dataSize;
        maxAge:self expirationTime.
    fileInfo notNil ifTrue:[
        response lastModified:fileInfo modificationTime.
    ].

    "Modified: / 12-04-2011 / 18:12:13 / cg"
!

processDirectory:dirFileName for:aRequest
    "generate a HTML table showing the files in the directory."

    |files response nameLength sizeLength sortBy sN sM sS sD relativePath table rel iconLink 
     fileLink sorter rowOffset altString big iconLinkReference fileLinkReference fileReference 
     replyPresenter headCellStyle removeFile fn generatedContents dirInfo|

    response := aRequest response.
    replyPresenter := response replyPresenter.
    replyPresenter 
        title:'Index of ' , aRequest url;
        firstHeadLine:'Index of ' , aRequest url.

    "if there is no reply presenter - set the title"
    response title:'Index of ' , aRequest url.

    relativePath := aRequest pathRelativeToService.
"/    now := Timestamp now.

"/ must care for sort order etc...
"/    DirectoryContentsCache notNil ifTrue:[
"/        entry := DirectoryContentsCache at:aRequest url ifAbsent:nil.
"/        entry notNil ifTrue:[
"/            cachedContents := entry second.
"/            timeStamp := entry first.
"/            dirFileName modificationTime < timeStamp ifTrue:[
"/                (now secondDeltaFrom:timeStamp) > self class maxDirectoryCacheTimedelta ifFalse:[
"/                    response nextPutAll:cachedContents.
"/                    ^ self.    
"/                ].                
"/            ].
"/            DirectoryContentsCache removeKey:aRequest url
"/        ].
"/    ].

    nameLength := 30.
    sizeLength := 10.

    dirInfo := dirFileName info.

    (self directoryListingsAllowed not
     or:[self showWorldReadableOnly and:[dirInfo isWorldReadable not]]
    ) ifTrue:[
        self reportForbiddenDirectoryListing ifTrue:[
            aRequest reportForbidden:'Directory listing denied'.
        ] ifFalse:[
            aRequest reportNotFound:(aRequest fullPath).
        ].
        "/ not reached
    ].

    self allowRemoveFile ifTrue:[
        removeFile := aRequest urlParameterAt:'Remove' ifAbsent:nil.
        removeFile notNil ifTrue:[
            fn := self fileRoot asFilename construct:removeFile.
            fn exists ifTrue:[
                fn remove.
            ].
        ].
    ].

    files := dirFileName directoryContentsAsFilenames.
        
    sorter := FileSorter new
                directoriesBeforeFiles:true;
                sortCaseless:true.

    sortBy := (aRequest urlParameterAt:'S' ifAbsent:'N') first.
    sortBy asUppercase = $M ifTrue:[
        sorter selector:#modificationTime.
        sM := sortBy isUppercase ifTrue:[$m] ifFalse:[$M].
    ] ifFalse:[
        sortBy asUppercase = $S ifTrue:[
            sorter selector:#fileSize.
            sS := sortBy isUppercase ifTrue:[$s] ifFalse:[$S].
        ] ifFalse:[
            sortBy asUppercase = $D ifTrue:[
                sorter selector:#mimeTypeFromName.
                sD := sortBy isUppercase ifTrue:[$d] ifFalse:[$D].
            ] ifFalse:[
                sorter selector:#baseName.
                sN := sortBy isUppercase ifTrue:[$n] ifFalse:[$N].
            ]
        ]
    ].
    sorter sortReverse:sortBy isLowercase.
    files := sorter sortItemList:files.

"/    headCellStyle := 'border-bottom-width: 1px; border-top-width: 0px; border-left-width: 0px; border-right-width: 0px; border-style: solid;'.
    headCellStyle := ''.

    table := HTML::Table new.
    table 
        width:'100%';
        cellPadding:'0px';
        cellSpacing:'0px'.
    big := HTML::Big with:((HTML::Anchor href:'?S=',(sN ? 'N') with:'Name') title:'Sort by Name').
    table 
        headCellAt:1 put:HTML::Break new;
        headCellAt:2 put:big.
    big := HTML::Big with:((HTML::Anchor href:'?S=',(sM ? 'M') with:'Last modified') title:'Sort by Modification Time').
    table headCellAt:3 put:big.
    big := HTML::Big with:((HTML::Anchor href:'?S=',(sS ? 'S') with:'Size') title:'Sort by Size').
    table headCellAt:4 put:big.
    (table headCellAt:4) alignRight.
    table headCellAt:5 put:'&nbsp;'.
    big := HTML::Big with:((HTML::Anchor href:'?S=',(sD ? 'D') with:'Description') title:'Sort by Mime Type').
    table headCellAt:6 put:big.
    1 to:6 do:[:idx|
        | headCellStyleIdx |
        idx == 4 ifTrue:[
            headCellStyleIdx := 'text-align: right; ', headCellStyle.
        ] ifFalse:[
            headCellStyleIdx := 'text-align: left; ', headCellStyle.
        ].
        (table headCellAt:idx) style:headCellStyleIdx.
    ].
    table head alignLeft.
    rowOffset := 0.
    relativePath ~= '' ifTrue:[
        iconLink := self directoryListingImageLinkStringFor:aRequest image:'directoryOpen' alt:'Dir Up'.
        fileLink := aRequest serviceLinkName , ((UnixFilename named:('/', relativePath)) directoryName).
        iconLinkReference := HTML::Anchor href:fileLink with:iconLink.
        fileReference := HTML::Anchor href:(HTMLUtilities escape:fileLink) with:'Parent Directory'.

        table 
            rowAt:1 cellAt:1 put:iconLinkReference;
            rowAt:1 cellAt:2 put:fileReference;
            rowAt:1 cellAt:3 put:(dirFileName modificationTime printStringRFC1123Format);
            rowAt:1 cellAt:4 put:'';
            rowAt:1 cellAt:6 put:''.
        rowOffset := 1.
    ].
    files doWithIndex:[:eachFn :idx|
        |s1 s2 sizeString description modificationTime rowIndex eachInfo|

        eachInfo := eachFn info.    "this follows symlinks and returns nil, if it is a broken symlink - ignore it"

        "do not show directory entries, that are not readable by everyone"
        (eachInfo notNil and:[self showWorldReadableOnly not or:[eachInfo isWorldReadable]]) ifTrue:[
            modificationTime := eachInfo modificationTime.
            rowIndex := idx + rowOffset.
            s1 := eachFn baseName contractTo:nameLength.
            s2 := String new:((nameLength-s1 size) max:0).
            eachInfo isDirectory ifTrue:[
                altString := 'DIR'.
                sizeString := '-'.
                description := 'directory'.      
            ] ifFalse:[
                altString := 'File'.
                sizeString := eachInfo fileSize printString.

                description := eachFn mimeTypeFromName.
                description isNil ifTrue:[
                    |path|

                    path := eachFn pathName.
                    CachedMimeTypes notNil ifTrue:[
                        description := CachedMimeTypes at:path ifAbsent:nil.
                    ].
                    description isNil ifTrue:[
                        "try harder"
                        description := eachFn mimeTypeOfContents ? ''.
                        CachedMimeTypes isNil ifTrue:[
                            CachedMimeTypes := OrderedDictionary new.
                        ].
                        CachedMimeTypes 
                            removeFromOrder:path;
                            at:path put:description.
                        CachedMimeTypes size > (CachedMimeTypesSize ? 100) ifTrue:[
                            CachedMimeTypes removeFirst
                        ].
                    ].
                ].
            ].
            rel := (UnixFilename named:('/', relativePath)) name.
            (rel = '/') ifTrue:[rel := ''].
            fileLink := aRequest serviceLinkName, rel, '/' , eachFn baseName.
            iconLink := self directoryListingImageLinkStringFor:aRequest image:((MIMETypeIconLibrary iconKeyForFile:eachFn) printString) alt:altString.
            iconLinkReference := HTML::Anchor href:(HTMLUtilities escape:fileLink) with:iconLink.
            fileLinkReference := HTML::Anchor href:(HTMLUtilities escape:fileLink) with:eachFn baseName. 
            table
                rowAt:rowIndex cellAt:1 put:iconLinkReference;
                rowAt:rowIndex cellAt:2 put:fileLinkReference;
                rowAt:rowIndex cellAt:3 put:modificationTime printStringRFC1123Format;
                rowAt:rowIndex cellAt:4 put:sizeString.
            (table rowAt:rowIndex cellAt:4) alignRight.
            table rowAt:rowIndex cellAt:6 put:description.
            self allowRemoveFile ifTrue:[
                table rowAt:rowIndex cellAt:7 put:(HTML::Anchor href:('?Remove=',eachFn baseName) with:'Remove File').
            ].
            (table rowAt:rowIndex) alignLeft.
        ].
    ].

    generatedContents := table htmlString.

"/    self class maxDirectoryCacheSize ~~ 0 ifTrue:[
"/        DirectoryContentsCache isNil ifTrue:[
"/            DirectoryContentsCache := OrderedDictionary new.
"/        ].
"/        DirectoryContentsCache size > self class maxDirectoryCacheSize ifTrue:[
"/            DirectoryContentsCache removeFirst
"/        ].
"/        DirectoryContentsCache removeFromOrder:aRequest url.
"/        DirectoryContentsCache at:aRequest url put:(Array with:now with:generatedContents).
"/    ].
"/
    response
        maxAge:2;
        lastModified:dirInfo modificationTime;
        nextPutAll:generatedContents;
        nextPutLine:'<p>';
        nextPutLine:'Service Powered by <a href="http://www.smalltalk-x.de">Smalltalk/X</a>'.

    "Modified: / 24-03-2012 / 21:27:18 / cg"
!

processDirectoryImageFor:aRequest 
    "if the request is for a directory bitmap-image, handle it and retrn true.
     Otherwise, return false."

    |response relativePath commonImagePath mimeTypeImagePath imageData baseNm|

    relativePath := aRequest pathRelativeToService.
    commonImagePath := self class commonImagePath.
    mimeTypeImagePath := self class mimeTypeImagePath.

    (relativePath startsWith:commonImagePath) ifTrue:[
        baseNm := relativePath copyFrom:(commonImagePath size + 1).   "strip commonImagePath + /"
        imageData := (self class commonImageDataFor:baseNm) ? ''.
    ] ifFalse:[(relativePath startsWith:mimeTypeImagePath) ifTrue:[
        baseNm := relativePath copyFrom:(mimeTypeImagePath size + 1). "strip mimeTypeImagePath + /"
        imageData := (self class mimeTypeImageDataFor:baseNm) ? ''.
    ]].
    imageData notNil ifTrue:[
        response := aRequest response.
        response 
            data:imageData;
            contentType:'image/gif';
            maxAge:100 days.

        response cacheControl setPublic.

        ^ true
    ].

    ^ false.
!

redirectFor: aRequest
    "a notFoundRedirection dictionary may hold a redirection url for the notFound url"

    |nUrl|

    nUrl := self notFoundRedirection at:aRequest url ifAbsent:[^ false].
    aRequest redirectTo:nUrl.
    ^ true
! !

!HTTPFileService methodsFor:'server cache control'!

fileCacheExpirationDelta
    "a cached files contents expiration time (seconds) - thats the servers caching time"

    fileCacheExpirationDelta isNil ifTrue:[
        fileCacheExpirationDelta := self class fileCacheExpirationDelta.
    ].
    ^ fileCacheExpirationDelta    
!

fileCacheExpirationDelta:seconds
    "a cached files contents expiration time (seconds) - thats the servers caching time"

    fileCacheExpirationDelta := seconds.
!

maxCacheDocumentSize
    "the max. size of a memory-cached document"

    maxCacheDocumentSize isNil ifTrue:[
        maxCacheDocumentSize := self class maxCacheDocumentSize.
    ].
    ^ maxCacheDocumentSize
!

maxCacheDocumentSize:numBytes
    "the max. size of a memory-cached document"

    maxCacheDocumentSize := numBytes.
!

maxCacheSize
    "the max. number of cached documents"

    maxCacheSize isNil ifTrue:[
        maxCacheSize := self class maxCacheSize.
    ].
    ^ maxCacheSize
!

maxCacheSize:maxNumCached
    "the max. number of cached documents"

    maxCacheSize := maxNumCached.
!

maxMemoryUsedForCache
    "the max. amount of memory used for the cache.
     Currently dummy - the amount is not (yet) checked for in the cache handling code"

    maxMemoryUsedForCache isNil ifTrue:[
        maxMemoryUsedForCache := self class maxMemoryUsedForCache.
    ].
    ^ maxMemoryUsedForCache
!

maxMemoryUsedForCache:numBytes
    "the max. amount of memory used for the cache.
     Currently dummy - the amount is not (yet) checked for in the cache handling code"

    maxMemoryUsedForCache := numBytes
! !

!HTTPFileService methodsFor:'service-parameter'!

defaultFileName
    ^ defaultFileName
!

defaultFileName:something
    defaultFileName := something.
!

fileRoot
    fileRoot isNil ifTrue:[
        fileRoot := Filename currentDirectory.
    ].
    ^ fileRoot
!

fileRoot:something
    fileRoot := something asFilename.
!

notFoundRedirection
    "a dictionary which redirects not found urls (keys) to a new url (value) "
    
    notFoundRedirection isNil ifTrue:[
        notFoundRedirection := Dictionary new.
    ].
    ^ notFoundRedirection
!

notFoundRedirection:something 
    "a dictionary which redirects not found urls (keys) to a new url (value) "
    
    notFoundRedirection := something.
! !

!HTTPFileService methodsFor:'settings persistency'!

settingSelectors
    "answer the selectors that are used to configure a service - i.e. those which are
     saved in the webServer-settings file."

    "/ cg: changed to use a positive list, instead of an exclusion algorithm.
    "/ because it makes always trouble when an instvar is added.

    ^ super settingSelectors ,
      #(fileRoot defaultFileName maxCacheSize maxMemoryUsedForCache maxCacheDocumentSize
        fileCacheExpirationDelta expirationTime directoryListingsAllowed notFoundRedirection
        checkReferrer allowRemoveFile showWorldReadableOnly).

    "
     HTTPService new settingSelectors
     self new settingSelectors
    "
! !

!HTTPFileService::CachedFileInfo methodsFor:'accessing'!

data
    ^ data
!

data:something
    "set the value of the instance variable 'data' (automatically generated)"

    data := something.
!

data:dataArg expirationTime:expirationTimeArg modificationTime:modificationTimeArg 
    expirationTime := expirationTimeArg.
    modificationTime := modificationTimeArg.
    data := dataArg.
!

dataSize
    ^ data size
!

expirationTime
    ^ expirationTime
!

expirationTime:something
    expirationTime := something.
!

modificationTime
    ^ modificationTime
! !

!HTTPFileService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/HTTPFileService.st,v 1.115 2012/03/24 20:28:40 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/HTTPFileService.st,v 1.115 2012/03/24 20:28:40 cg Exp $'
! !
