"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer' }"

HTTPFileAccessLogger subclass:#HTTPFullAccessLogger
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTTP-Server'
!

!HTTPFullAccessLogger class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    [author:]
        Christian Penk (penk@bierfix)
"
! !

!HTTPFullAccessLogger methodsFor:'actions'!

logAccessFrom:aRequest to:aStreamOrFilename 
    "log a HTTP access. If aStreamOrFilename is not nil log to it,
     otherwise log to logFile "
    
    |user|

    aStreamOrFilename isEmptyOrNil ifTrue:[
        logFile isNil ifTrue:[
            self error:'can not log without a log file'.
            ^ self
        ] 
    ] ifFalse:[
        aStreamOrFilename ~~ logStream ifTrue:[
            aStreamOrFilename isStream ifTrue:[
                self logStream:aStreamOrFilename.
            ] ifFalse:[
                self logFile:aStreamOrFilename asFilename.
            ].
        ].
    ].
    user := aRequest authenticatedUsername.
    user isNil ifTrue:[
        user := 'nil'.
    ].

    logStream
        nextPutAll: (Timestamp now printStringPaddedTo:24);
        nextPutAll: (aRequest peer printStringPaddedTo:15);
        nextPutAll: ' USER:'; nextPutAll: user;
        nextPutAll: aRequest rawHeader;
        cr.
! !

!HTTPFullAccessLogger methodsFor:'html presentation'!

changeFromRequest:aRequest 
    "Superclass says that I am responsible to implement this method"

    ^ self
!

inputFieldsForRequest:aRequest 
    "Superclass says that I am responsible to implement this method"
    ^ nil
! !

!HTTPFullAccessLogger class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/HTTPFullAccessLogger.st,v 1.7 2006/06/14 10:33:01 stefan Exp $'
! !
