"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer' }"

Object subclass:#HTTPHeaderParser
	instanceVariableNames:'headerString headerStringSize startLine headerStringIndex
		headerLines'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTTP-Server'
!

!HTTPHeaderParser class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!HTTPHeaderParser class methodsFor:'instance creation'!

headerString:aHeaderString
    | instance |
    instance := self basicNew.
    instance headerString:aHeaderString.
    instance initialize.
    ^ instance
! !

!HTTPHeaderParser methodsFor:'accessing'!

headerString
    ^ headerString
!

headerString:something
    headerString := something.
    headerStringIndex := 1.
    headerStringSize := headerString size.
! !

!HTTPHeaderParser methodsFor:'header line accessing'!

fieldValueFor:aFieldKey
    " return the value for an lowercase header field key or nil if absent "

    |fieldValue fieldKey|

    fieldKey := aFieldKey "asLowercase".
    fieldValue := headerLines at:fieldKey ifAbsent:nil.
    fieldValue notNil ifTrue:[ ^ fieldValue].
    ^ (self parseHeaderForFieldKey:aFieldKey).
!

fieldValues
    "return all field values as a dictionary, indexed by key"

    self parseHeaderForFieldKey:nil.
    ^ headerLines
!

startLine
    ^ startLine
! !

!HTTPHeaderParser methodsFor:'initialization'!

initialize

    headerStringIndex := 1.
    headerLines := Dictionary new.
    startLine := self nextLine.
! !

!HTTPHeaderParser methodsFor:'private actions'!

parseHeaderForFieldKey:aFieldKey 
    |line idx key value|

    [ self atEnd ] whileFalse:[
        line := self nextLine.
        idx := line indexOf:$:.
        idx == 0 ifTrue:[ 
            HTTPHeaderParseError raiseErrorString:('no ":" token found in line: ' , line).
        ].
        key := (line copyTo:idx-1) asLowercase.
        value := (line copyFrom:idx+1) withoutSeparators.
        headerLines at:key put:value.
        key = aFieldKey ifTrue:[
            ^ value
        ].
    ].
    ^ nil
! !

!HTTPHeaderParser methodsFor:'queries'!

atEnd

    ^ headerStringSize - 8 "CRLF CRLF" <= headerStringIndex
!

nextLine

    |newIndex line|

    newIndex := headerString indexOf:(Character cr) startingAt:headerStringIndex.
    newIndex == 0 ifTrue:[
        HTTPHeaderParseError raiseErrorString:('can not parse line ', (headerString copyFrom:headerStringIndex)).
    ].
    line := headerString copyFrom:headerStringIndex to:newIndex - 2.
    headerStringIndex := newIndex + 1.
    ^ line

! !

!HTTPHeaderParser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/HTTPHeaderParser.st,v 1.5 2005/02/28 15:43:14 stefan Exp $'
! !
