"
 COPYRIGHT (c) 2008 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

HTTPService subclass:#HTTPPluggableActionService
	instanceVariableNames:'actions'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTTP-Services'
!

!HTTPPluggableActionService class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2008 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    A service which associates page-URLS with a blocks evaluation.
    Can be used for quick ad-hoq and Expecco-driven webservices.
    The registered block (-> register:as:) is evaluated with the httpRequest object
    as argument.

    [author:]
        Claus Gittinger
"
! !

!HTTPPluggableActionService methodsFor:'action'!

process:aRequest
    |selectorAndArguments selector arguments actionBlock|

    selectorAndArguments := (aRequest pathRelativeToService asCollectionOfSubstringsSeparatedByAny:'/\,').
    selectorAndArguments isEmpty ifTrue:[
        aRequest reportNotFound:'Illegal (empty) selector for service ', self className.
        "/ not reached
        ^ self.
    ].
    selector := selectorAndArguments at:1.
    arguments := selectorAndArguments copyFrom:2.

    actionBlock := actions at:selector ifAbsent:nil.
    actionBlock isNil ifTrue:[
        actions keysAndValuesDo:[:pattern :block |
                            (pattern match:selector) ifTrue:[
                                actionBlock := block
                            ]
                ].
    ].
    actionBlock isNil ifTrue:[
        aRequest reportNotFound:'Service ', self className, ' received illegal message ' , selector asString.
        "/ not reached
        ^ self.
    ].

    aRequest selector:selector arguments:arguments.

    actionBlock value:aRequest
! !

!HTTPPluggableActionService methodsFor:'registration'!

register:aBlock as:aPageName
    actions isNil ifTrue:[
        actions := Dictionary new.
    ].
    actions at:aPageName put:aBlock
! !

!HTTPPluggableActionService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/HTTPPluggableActionService.st,v 1.3 2008/02/14 20:51:56 cg Exp $'
! !
