"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer' }"

HTTPFileService subclass:#MacroExpandingCSSFileService
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTTP-Services'
!

!MacroExpandingCSSFileService class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    This is a file service, which finds and expands text-macros in the files
    before serving them.
    This is especially useful for css-files.

    [author:]
        Claus Gitinger
"
! !

!MacroExpandingCSSFileService class methodsFor:'defaults'!

linkName
    "return the default path (with slash)"

    ^ '/css'
! !

!MacroExpandingCSSFileService class methodsFor:'registration'!

addToWellKnownClasses
    ^ false
! !

!MacroExpandingCSSFileService methodsFor:'processing'!

expandMacrosInResponseData:aResponse
    |data inStream outStream chunk|

^ self.
    data := aResponse data asString.
    inStream := data readStream.
    outStream := WriteStream on:(String new:data size).
    [inStream atEnd] whileFalse:[
        chunk := inStream nextUpTo:$$.
        outStream nextPutAll:chunk.
        outStream nextPut:$$.
    ].
"/    outStream contents = data.
"/    self halt.
!

process:aRequest 
    |suffix relativePath fn|

    relativePath := aRequest relativePath copyFrom:2.
    relativePath isEmptyOrNil ifTrue:[ 
        super process:aRequest.
        ^ self
    ].
    suffix := relativePath asFilename suffix asLowercase.
    suffix = 'css' ifFalse:[ 
        super process:aRequest.
        ^ self
    ].

    fn := self fileRoot asFilename construct:relativePath.
    fn exists ifFalse:[
        aRequest reportNotFound:'Not found: ' , (aRequest fullPath).
        "/ not reached
    ].

    super process:aRequest.

    self expandMacrosInResponseData:aRequest response.
! !

!MacroExpandingCSSFileService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/MacroExpandingCSSFileService.st,v 1.2 2005/08/03 19:07:44 cg Exp $'
! !
