"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

Object subclass:#ReplyPresenter
	instanceVariableNames:'parameters dataStream title'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTML-ReplyPresenter'
!

!ReplyPresenter class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    A replyPresenter instance is used by the httpserver to (possibly) wrap up the responses
    of the service-generated pages into a common look.
    Typically, by providing css and/or an extra div or frame around the generated page,
    to impose a common corporate identity look on the pages.
    By default, a PlainReplyRepresenter is set when an http-server is launched.
    Take a look at the exept-replyPresenter as an example of a wrapper for exept-colors and an
    extra set of framing divs, including a site-search.
"
! !

!ReplyPresenter class methodsFor:'initialization'!

postAutoload
    "load my subclasses"

    PlainReplyPresenter autoload.
    ExeptReplyPresenter autoload.
    EmptyDocumentReplyPresenter autoload.

    "
        self postAutoload
    "
! !

!ReplyPresenter class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.
! !

!ReplyPresenter class methodsFor:'presenterClasses'!

presenterClasses
    ^ self allSubclasses
! !

!ReplyPresenter methodsFor:'accessing'!

beforeTitle:aString
    self parametersAt:#beforeTitle put:aString

    "Created: / 02-02-2007 / 12:24:04 / cg"
!

firstHeadLine:aString
    self parametersAt:#firstHeadLine put:aString

    "Created: / 02-02-2007 / 12:21:02 / cg"
!

parameters
    ^ parameters
!

parameters:something
    parameters := something.
!

parametersAt:aKey
    ^ parameters at:aKey ifAbsent:nil
!

parametersAt:aKey ifAbsent:aBlock
    ^ parameters at:aKey ifAbsent:aBlock
!

parametersAt:aKey put:aValue
    ^ parameters at:aKey put:aValue
!

secondHeadLine:aString
    self parametersAt:#secondHeadLine put:aString

    "Created: / 02-02-2007 / 12:19:39 / cg"
!

title
    ^ title
!

title:something
    title := something.

    "Modified: / 05-12-2006 / 14:02:08 / cg"
! !

!ReplyPresenter methodsFor:'initialization & release'!

initialize
    parameters := Dictionary new.
    title := ''.
!

release
    "will be invoked after the request has been sent"

    ^ self
! !

!ReplyPresenter methodsFor:'required-protocol'!

present:aRequest on:aStream 
    ^ self subclassResponsibility
! !

!ReplyPresenter methodsFor:'settings persistency'!

elementDescriptorFor:anAspect
    "support for persistency:
     answer the elements to be made persistent with an ObjectCoder"

    anAspect ~~ #settings ifTrue:[
        ^ super elementDescriptorFor:anAspect
    ].
    ^ self settingSelectors collect:[:eachVarName | eachVarName -> (self perform:eachVarName asSymbol)]
            thenSelect:[:pairs | pairs value notNil]
!

settingSelectors
    |slots|

    slots := self class allInstVarNames copy.
    slots removeAllFoundIn:(ReplyPresenter allInstVarNames).
    slots addAll:#(parameters title).

    ^ slots 
! !

!ReplyPresenter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/ReplyPresenter.st,v 1.21 2010/11/19 11:42:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/ReplyPresenter.st,v 1.21 2010/11/19 11:42:43 cg Exp $'
! !
