"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

HTTPSelectorService subclass:#ServerMaintenanceService
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTTP-Services'
!

!ServerMaintenanceService class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    a service which provides maintenance access to configure
    the server and services.
    Provides roughly the same functionality as the Launcher-Settings-WebServerSettings,
    but via the HTTP interface.
    Must be protected by a realm - if not, only access from the local host is allowed.

    [author:]
        Claus Gittinger
        Christian Penk

    [access with:]
        http:<host>:<port>/Maintenance
"
! !

!ServerMaintenanceService class methodsFor:'class access'!

defaultReplyPresenterClass
    ^ ExeptReplyPresenter
! !

!ServerMaintenanceService class methodsFor:'defaults'!

defaultAllowRobots
    ^ false
!

linkName
    "return the default linkName path (with slash)"

    ^ '/Maintenance'
!

noRealmBehavior
    "allow access ONLY from localHost, if no realm was specified for this service"

    ^ HTTPService::NoRealmBehavior localHostOnly  
! !

!ServerMaintenanceService class methodsFor:'queries-service'!

settingsApplicationClass
    "a SettingsApplication class - or nil (used in the settings dialog if non-nil)"

    ^ nil
! !

!ServerMaintenanceService methodsFor:'defaults'!

defaultReplyPresenterClass
    ^ ExeptReplyPresenter
! !

!ServerMaintenanceService methodsFor:'queries-service'!

defaultMessage
    ^ #control
!

isAllowedInMaintenanceMode
    "return true, if this service is also allowed while the server is in maintenance mode"

    ^ true
!

isMessageAllowed:aSelector
    "the message is only allowed if this class implements aSelector and
     the method belongs to one of the categories 'requuests-reply'."

    |method|

    method := self class compiledMethodAt:aSelector ifAbsent:[^ false].
    ^ method category startsWith:#'requests-reply'.


    "
        self new isMessageAllowed:#foo.
        self new isMessageAllowed:#defaultMessage.
        self new isMessageAllowed:#control:.
    "
! !

!ServerMaintenanceService methodsFor:'registration'!

addRequiredForeignServicesTo:aServer 
    "I need a file service for the bitmaps and icons"

    "SR:    
     no i don't realy need a files service,
     the problem is: if a files service is already present on the link, 
     i would overwrite the source folder, 
     the default source folder in:#addStandardFileServicesTo
     doesn't work at all in an standalone environment "

"/    self addStandardFileServicesTo:aServer.
! !

!ServerMaintenanceService methodsFor:'requests-reply'!

addChangeService:aRequest 
    |server service changeService changeServiceLinkNames replyPresenter|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.
    aRequest urlParameters notNil ifTrue:[
"/        aRequest urlParameters keysAndValuesDo:[:key :value|
"/            Transcript showCR:key asString, '->', value asString.
"/        ].
        (aRequest urlParameterAt:'AddService') notNil ifTrue:[
            service := self createNewServiceFromRequest:aRequest.
            service isNil ifTrue:[
                replyPresenter title:('Service ', service className, ' can not create service').
                replyPresenter secondHeadLine:'Service ', service className, ' can not create service'.
                replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'addRemoveChangeServices:' time:2).

                aRequest 
                    nextPutLine: '<H2>Service ', service className, ' can not create service</H2>';
                    nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'addRemoveChangeServices:').
                ^ self.
            ].
            service registerServiceOn:server.
            replyPresenter title:('Service ', service className, ' added').
            replyPresenter secondHeadLine:'Service ', service className, ' added'.
            replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'addRemoveChangeServices:' time:2).
            aRequest 
                nextPutLine: '<H2>Service ', service className, ' added</H2>';
                nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'addRemoveChangeServices:').
            ^ self.
        ].
        (aRequest urlParameterAt:'ChangeService') notNil ifTrue:[
            changeService := self serviceFromRequest:aRequest.
            changeService isNil ifTrue:[
                self responseError:'Service not found'
                        title:'Change Service' 
                        request:aRequest 
                        backSelector:'addRemoveChangeServices:'.
                ^ self.
            ].
            changeServiceLinkNames := changeService linkNames copy sort.
            self changeService:changeService fromRequest:aRequest.
            replyPresenter title:('Service ', changeService className, ' changed').
            replyPresenter secondHeadLine:('Service ', changeService className, ' changed').
            replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'addRemoveChangeServices:' time:2).

            aRequest 
                nextPutLine: '<H2>Service ', changeService className, ' changed</H2>';
                nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'addRemoveChangeServices:').
        ].
    ].

    "Modified: / 02-02-2007 / 12:25:56 / cg"
!

addRemoveChangeServices:aRequest 
    |server replyPresenter headLine|

    server := aRequest server.
    headLine := 'Change Services'.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:headLine.
    replyPresenter secondHeadLine:headLine.
    aRequest 
        nextPutLine: '<P>';
        nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'applyAddService:'),'" >';
        nextPutLine:'<SELECT NAME="AddServiceSel" SIZE=11>'.

    HTTPService availableServiceClassNames do:[:aServiceClassName |  
        aRequest nextPutLine:'<OPTION>', aServiceClassName, '</OPTION>'.
    ].
    
    aRequest 
        nextPutLine:'</SELECT>';
        "/ nextPutLine:'&nbsp;&nbsp;&nbsp;';
        nextPutLine:'<P>';
        formSubmitButtonForString:'Add Service' name:'addservice';
        formEnd;
        nextPutLine: '<P>';
        nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'applyRemoveChangeService:' ),'" >';
        nextPutLine:'<SELECT NAME="LinkName" SIZE=11>'.
    server serviceList copy do:[:aService |
        aRequest nextPutLine:'<OPTION value="',aService linkName, '">', aService printString, '</OPTION>'.
    ].
    aRequest 
        nextPutLine:'</SELECT>';
        "/ nextPutLine:'&nbsp;&nbsp;&nbsp;';
        nextPutLine:'<P>';
        formSubmitButtonForString:'Change Service' name:'ChangeService';
        formSubmitButtonForString:'Remove Service' name:'RemoveService';
        formEnd;
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:21:36 / cg"
!

applyAddService:aRequest 
    |server addServiceSel serviceClass service headLine replyPresenter|

    server := aRequest server.

    headLine := 'Add Service'.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:headLine.
    replyPresenter secondHeadLine:headLine.
    aRequest urlParameters notNil ifTrue:[
        addServiceSel := aRequest urlParameterAt:'AddServiceSel'.
        addServiceSel notNil ifTrue:[   
            serviceClass := Smalltalk at:addServiceSel asSymbol.
            service := serviceClass new initialize.
            aRequest 
                nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'addChangeService:'),'">'.
            self serviceInputFieldsFor:service request:aRequest change:false.
            aRequest 
                formSubmitButtonForString:'Add Service' name:'AddService';
                formEnd;
                nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'addRemoveChangeServices:').
        ].
    ].

    "Modified: / 02-02-2007 / 12:21:40 / cg"
!

applyChangeService:aRequest 
    |server service headLine replyPresenter|

    server := aRequest server.

    service := self serviceFromRequest:aRequest.
    service isNil ifTrue:[
        self responseError:'Service not found'
                title:'Change Service' 
                request:aRequest 
                backSelector:'addRemoveChangeServices:'.
        ^ self.
    ].
    headLine := 'Change Service'.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:headLine.
    replyPresenter secondHeadLine:headLine.
    aRequest 
        nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'addChangeService:'),'" >'.

    self serviceInputFieldsFor:service request:aRequest change:true.

    aRequest 
        nextPutLine: '<P>';
        formSubmitButtonForString:'Apply' name:'ChangeService';
        formEnd;
        nextPutLine: '<P><HR><P>', (aRequest webLinkForText:'Back' service:self selector:#'addRemoveChangeServices:').

    "Modified: / 02-02-2007 / 12:21:43 / cg"
!

applyRemoveChangeService:aRequest 
    |server|

    server := aRequest server.

    aRequest urlParameters notNil ifTrue:[
        (aRequest urlParameterAt:'RemoveService') notNil ifTrue:[
            self applyRemoveService:aRequest.
        ].
        (aRequest urlParameterAt:'ChangeService') notNil ifTrue:[
            self applyChangeService:aRequest.
        ].
        ^ self
    ].
!

applyRemoveService:aRequest 
    |server service headLine replyPresenter|

    server := aRequest server.

    service := self serviceFromRequest:aRequest.
    service isNil ifTrue:[
        self responseError:'Service not found'
                title:'Remove Service' 
                request:aRequest 
                backSelector:'addRemoveChangeServices:'.
        ^ self.

    ].
    service unRegisterServiceOn:server.
    headLine := 'Service ', service className, ' removed'.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:headLine.
    replyPresenter secondHeadLine:headLine.
    replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'addRemoveChangeServices:' time:2).
    aRequest 
        nextPutLine: '<H2>Service ', service className, ' removed</H2>';
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'addRemoveChangeServices:').

    "Modified: / 02-02-2007 / 12:25:45 / cg"
!

changeDebugging:aRequest
    |server verbose verboseErrors verboseData debug replyPresenter|

    server := aRequest server.

    aRequest isPOST ifTrue:[
"/            fields keysAndValuesDo:[:key :value|
"/                Transcript showCR:key asString, '->', value asString.
"/            ].
        verbose := aRequest postDataFieldAt:'Verbose'.
        server verbose:(verbose = 'ON').
        verboseErrors := aRequest postDataFieldAt:'VerboseErrors'.
        server verboseErrors:(verboseErrors = 'ON').
        verboseData := aRequest postDataFieldAt:'VerboseData'.
        server verboseData:(verboseData = 'ON').
        debug := aRequest postDataFieldAt:'DebugErrors'.
        server debugErrors:(debug = 'ON').
    ].
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Change Debugging'.
    replyPresenter secondHeadLine:'Change Debugging'.
    aRequest 
        nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'changeDebugging:'),'" method=post>';
        inputFieldFor:'Verbose' 
            type:'checkbox' 
            size:nil 
            label:('Verbose') 
            initialValue:'ON'
            append:(server verbose ifTrue:['checked'] ifFalse:['']);
        nextPutLine:'&nbsp;&nbsp;&nbsp;';
        inputFieldFor:'VerboseErrors' 
            type:'checkbox' 
            size:nil 
            label:('Verbose Errors') 
            initialValue:'ON'
            append:(server verboseErrors ifTrue:['checked'] ifFalse:['']);
        nextPutLine:'&nbsp;&nbsp;&nbsp;';
        inputFieldFor:'VerboseData' 
            type:'checkbox' 
            size:nil 
            label:('Verbose Data') 
            initialValue:'ON'
            append:(server verboseData ifTrue:['checked'] ifFalse:['']);
        nextPutLine:'&nbsp;&nbsp;&nbsp;';
        inputFieldFor:'DebugErrors' 
            type:'checkbox' 
            size:nil 
            label:('Debug Errors') 
            initialValue:'ON'
            append:(server debugErrors ifTrue:['checked'] ifFalse:['']);
        nextPutLine:'<BR>';
        formSubmitButton;
        formEnd;
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:22:13 / cg"
!

changeHomeURL:aRequest
    |server replyPresenter|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.
    aRequest isPOST ifTrue:[
        server homeURL:( aRequest postDataFieldAt:'HomeURL' ifAbsent:nil).
        replyPresenter title:'HomeURL Settings'.
        replyPresenter secondHeadLine:'HomeURL Changed'.
        replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:2).
        aRequest 
            nextPutLine: '<H2>HomeURL changed to ''' , (server homeURL ? '') , '''</H2>'.
    ] ifFalse:[
        replyPresenter title:'Change HomeURL'.
        replyPresenter secondHeadLine:'Change HomeURL'.
        aRequest 
            nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'changeHomeURL:'),'" method=post>';
            inputFieldFor:'HomeURL' size:40 label:'HomeURL' initialValue:server homeURL;
            nextPutLine:'<BR>';
            formSubmitButton;
            formEnd.
    ].
    aRequest 
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:25:32 / cg"
!

changeLogging:aRequest 
    |server accessLogger newSelectedAcessLoggerClass newSelectedAcessLoggerClassName 
     accessLoggerClass accessLoggerSettingsString replyPresenter
     logFile logToFile|

    server := aRequest server.
    accessLogger := server accessLogger.
    aRequest isPOST ifTrue:[
        logFile := aRequest postDataFieldAt:'LogFile'.
        logFile notNil ifTrue:[
            server logFile:logFile.
        ].
        logToFile := aRequest postDataFieldAt:'LogToFile'.
        logToFile notNil ifTrue:[
            server logEnabled:(logToFile = 'ON').
        ].
        newSelectedAcessLoggerClassName := aRequest postDataFieldAt:'accessLogger'.
        newSelectedAcessLoggerClassName notNil ifTrue:[
            newSelectedAcessLoggerClassName ~~ accessLogger className ifTrue:[
                newSelectedAcessLoggerClass := Smalltalk at:(newSelectedAcessLoggerClassName asSymbol).
                accessLogger := newSelectedAcessLoggerClass new.
                server accessLogger:accessLogger.
            ].
        ].
        accessLogger changeFromRequest:aRequest.
    ].
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Change Logging'.
    replyPresenter secondHeadLine:'Change Logging'.
    aRequest 
        nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'changeLogging:'),'" method=post>';
        nextPutLine:'<BR>';
        inputFieldFor:'LogToFile' 
            type:'checkbox' 
            size:nil 
            label:('Log to File') 
            initialValue:'ON'
            append:(server logEnabled ifTrue:['checked'] ifFalse:['']);
        nextPutLine:'<BR><BLOCKQUOTE>';
        inputFieldFor:'LogFile' size:40 label:'Log File' initialValue:(server logFile asString);
        nextPutLine:'</BLOCKQUOTE><BR>';
        nextPutLine: 'Access Logger Class:&nbsp;&nbsp;';
        nextPutLine: '<SELECT NAME=accessLogger SIZE=1> '.
    HTTPAccessLogger accessLoggerList do:[:eachAcessLoggerClassName |  
        accessLoggerClass := Smalltalk at:eachAcessLoggerClassName.
        aRequest nextPutAll: '<OPTION'.
        accessLoggerClass == accessLogger ifTrue:[
        aRequest nextPutAll: ' SELECTED'.
        ].
        aRequest nextPutLine: '> ', eachAcessLoggerClassName asString,'</OPTION>'.
    ].
    aRequest
        nextPutLine: '</SELECT><p>';
        formSubmitButton;
        formEnd.
    accessLoggerSettingsString := accessLogger inputFieldsForRequest:aRequest.
    accessLoggerSettingsString notNil ifTrue:[
        aRequest nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'changeLogging:'),'" method=post>'.
        aRequest nextPutLine:accessLoggerSettingsString.
        aRequest nextPutLine: '<P>'.
        aRequest
            formSubmitButton;
            formEnd.
    ].        
    aRequest nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:22:22 / cg"
!

changeNotFoundURL:aRequest
    |server notFoundURL replyPresenter|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.
    aRequest isPOST ifTrue:[
        notFoundURL := (aRequest postDataFieldAt:'NotFoundURL').
        notFoundURL isEmptyOrNil ifTrue:[ notFoundURL := nil].
        server notFoundURL:notFoundURL.
        replyPresenter title:'NotFoundURL Settings'.
        replyPresenter secondHeadLine:'NotFoundURL Changed'.
        replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:2).
        aRequest 
            nextPutLine: '<H2>Changed NotFoundURL to ''' , (server notFoundURL asString) , '''</H2>'.
    ] ifFalse:[
        replyPresenter title:'Change Not Found URL'.
        replyPresenter secondHeadLine:'Change Not Found URL'.
        aRequest 
            nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'changeNotFoundURL:'), '" method=post>';
            inputFieldFor:'NotFoundURL' size:40 label:'NotFoundURL' initialValue:server notFoundURL;
            nextPutLine:'<BR>';
            formSubmitButton;
            formEnd.
    ].
    aRequest 
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:25:25 / cg"
!

changeOtherSettings:aRequest 
    |server maxNumberOfKeepAliveConnections temporaryLinkExpirationTime inactiveConnectionTimeout replyPresenter|

    server := aRequest server.
    aRequest isPOST ifTrue:[
        maxNumberOfKeepAliveConnections := aRequest 
                    postDataFieldAt:'maxNumberOfKeepAliveConnections'
                    ifAbsent:nil.
        maxNumberOfKeepAliveConnections notNil ifTrue:[
            maxNumberOfKeepAliveConnections := Number readFromString:maxNumberOfKeepAliveConnections onError:[nil].
            maxNumberOfKeepAliveConnections notNil ifTrue:[
                server maxNumberOfKeepAliveConnections:maxNumberOfKeepAliveConnections.
            ].
        ].
        temporaryLinkExpirationTime := aRequest 
                    postDataFieldAt:'temporaryLinkExpirationTime'
                    ifAbsent:nil.
        temporaryLinkExpirationTime notNil ifTrue:[
            temporaryLinkExpirationTime := Number readFromString:temporaryLinkExpirationTime onError:[nil].
            temporaryLinkExpirationTime notNil ifTrue:[
                server temporaryLinkExpirationTime:temporaryLinkExpirationTime.
            ].
        ].
        inactiveConnectionTimeout := aRequest 
                    postDataFieldAt:'inactiveConnectionTimeout'
                    ifAbsent:nil.
        inactiveConnectionTimeout notNil ifTrue:[
            inactiveConnectionTimeout := Number readFromString:inactiveConnectionTimeout onError:[nil].
            inactiveConnectionTimeout notNil ifTrue:[
                server inactiveConnectionTimeout:inactiveConnectionTimeout.
            ].
        ].
    ].
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Change Other Settings'.
    replyPresenter secondHeadLine:'Change Other Settings'.
    aRequest
        nextPutLine:'<FORM action="' 
                    , (aRequest linkIdFor:self selector:#changeOtherSettings:) 
                        , '" method=post>';
        nextPutLine:'<table><tr><td>';
        inputFieldFor:'maxNumberOfKeepAliveConnections'
            size:20
            label:'Max Keep Alive Connections:</td><td>'
            initialValue:(server maxNumberOfKeepAliveConnections asString);
        nextPutLine:'</td></tr><td>';
        inputFieldFor:'temporaryLinkExpirationTime'
            size:20
            label:'Temporary Link Expiration Time (Seconds):</td><td>'
            initialValue:(server temporaryLinkExpirationTime asString);
        nextPutLine:'</td></tr><td>';
        inputFieldFor:'inactiveConnectionTimeout'
            size:20
            label:'Inactive Connection Timeout (Seconds):</td><td>'
            initialValue:(server inactiveConnectionTimeout asString);
        nextPutLine:'</td></tr></table>';
        nextPutLine:'<P>';
        formSubmitButton;
        formEnd.
    aRequest
        nextPutLine:'<P>' , (aRequest 
                            webLinkForText:'Back'
                            service:self
                            selector:#control:).

    "Modified: / 02-02-2007 / 12:22:30 / cg"
!

collectGarbage:aRequest 
    |replyPresenter|

    ObjectMemory tenure.
    ObjectMemory verboseGarbageCollect.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Garbage Collect'.
    replyPresenter secondHeadLine:'Garbage Collect'.
    replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:5).
    aRequest 
        nextPutLine: '<H2>Garbage has been collected. </H2>Memory usage now reduced to ' , 
                    (ObjectMemory oldSpaceSize // 1024) printString , ' Kb.'.

    "Modified: / 02-02-2007 / 12:25:19 / cg"
!

control:aRequest
    "Perform 'Maintenance:control:xxx' functions - this method provides all
     functionality required for remote server administration (via the web)."

    |server response darkColor lightColor1 lightColor2 replyPresenter info|

    darkColor := '"#B6D2DA"'. 
    lightColor1 := '"#E4F5FE"'. 
    lightColor2 := '"#E4F5FE"'.

    server := aRequest server.
    response := aRequest response.

    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Server Maintenance'.
    replyPresenter secondHeadLine:'ST/X HTTPServer maintenance on: ' , OperatingSystem getHostName , ':', server port printString.
    response nextPutLine:'<P>'.
    response nextPutLine:'<P>'.

    response nextPutLine:'<TABLE WIDTH="100%" BORDER="1">'.
    response nextPutLine:'<TR>'.
    response nextPutLine:'<TH BGCOLOR=',darkColor,'>Server</TH>'.
    response nextPutLine:'</TR>'.

    response nextPutLine:'<TR BGCOLOR=',lightColor1,'>'.
    response nextPutLine:'<TD>'.
    server inMaintenanceMode ifTrue:[
        response nextPutLine:
            (aRequest webLinkForText:'Bring Server Back to Serving Mode' service:self selector:#exitMaintenanceMode:)
    ] ifFalse:[
        response nextPutLine:
            (aRequest webLinkForText:'Bring Server into Maintenance Mode' service:self selector:#enterMaintenanceMode:)
    ].

    response
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Restart Http-Server' service:self selector:#restartServer:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Stop Http-Server' service:self selector:#stopServer:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Terminate Smalltalk' service:self selector:#exitSmalltalk:).

    response nextPutLine:'<P>'.

    response
        nextPutLine:(aRequest webLinkForText:'Home URL' service:self selector:#changeHomeURL:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Default (Not Found) URL' service:self selector:#changeNotFoundURL:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Debugging' service:self selector:#changeDebugging:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Logging' service:self selector:#changeLogging:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Authorization' service:self selector:#changeAuthorization:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Other Settings' service:self selector:#changeOtherSettings:).

    response nextPutLine:'</TD>'.
    response nextPutLine:'</TR>'.
    response nextPutLine:'</TABLE>'.


    response nextPutLine:'<TABLE WIDTH="100%" BORDER="1">'.
    response nextPutLine:'<TH BGCOLOR=',darkColor,'>Services</TH>'.
    response nextPutLine:'</TR>'.

    response nextPutLine:'<TR BGCOLOR=',lightColor1,'>'.
    response nextPutLine:'<TD>'.
    response
        nextPutLine:(aRequest webLinkForText:'Configure Services' service:self selector:#addRemoveChangeServices:);
        nextPutLine:'<BR>'.

    (server hasSoapEnabled) ifTrue:[
        response nextPutLine:
            (aRequest webLinkForText:'Disable Soap' service:self selector:#disableSoap:).
    ] ifFalse:[
        response nextPutLine:
            (aRequest webLinkForText:'Enable Soap' service:self selector:#enableSoap:).
    ].
    response nextPutLine:'<P>'.

    response nextPutLine:'</TD>'.
    response nextPutLine:'</TR>'.
    response nextPutLine:'</TABLE>'.



    response nextPutLine:'<TABLE WIDTH="100%" BORDER="1">'.
    response nextPutLine:'<TH BGCOLOR=',darkColor,'>Settings</TH>'.
    response nextPutLine:'</TR>'.

    response nextPutLine:'<TR BGCOLOR=',lightColor1,'>'.
    response nextPutLine:'<TD>'.
    response
        nextPutLine:'<P>';
        nextPutLine:(aRequest webLinkForText:'Print Settings' service:self selector:#printSettings:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Load Settings' service:self selector:#loadSettings:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Save Settings' service:self selector:#saveSettings:).

    response nextPutLine:'</TD>'.
    response nextPutLine:'</TR>'.
    response nextPutLine:'</TABLE>'.



    response nextPutLine:'<TABLE WIDTH="100%" BORDER="1">'.
    response nextPutLine:'<TR>'.
    response nextPutLine:'<TH BGCOLOR=',darkColor,'>System</TH>'.
    response nextPutLine:'</TR>'.

    response nextPutLine:'<TR BGCOLOR=',lightColor1,'>'.
    response nextPutLine:'<TD>'.
    response
        nextPutLine:(aRequest webLinkForText:'Create Snapshot' service:self selector:#snapshot:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Collect Garbage' service:self selector:#collectGarbage:);
        nextPutLine:'<P>';
        nextPutLine:(aRequest webLinkForText:'Upload Patch' service:self selector:#uploadPatch:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Load Library' service:self selector:#loadLibrary:);
        nextPutLine:'<BR>';
        nextPutLine:(aRequest webLinkForText:'Start Launcher' service:self selector:#openLauncher:);
        nextPutLine:'<P>'.

    response nextPutLine:'</TD>'.
    response nextPutLine:'</TR>'.
    response nextPutLine:'</TABLE>'.

    response nextPutLine:'<P>'.

    response nextPutLine:'<TABLE WIDTH="100%" BORDER="1">'.
    response nextPutLine:'<TR>'.
    response nextPutLine:'<TH COLSPAN=2 WIDTH="100%" BGCOLOR=',darkColor,'>Info</TH>'.
    response nextPutLine:'</TR>'.

    info := OrderedCollection new.
    info add:( 'Server time' 
                -> Timestamp now printStringRFC1123Format).
    info add:( 'Server up since' 
                -> ((server startupTime printStringRFC1123Format),
                    ' (',
                    (Timestamp now deltaFrom: server startupTime) printStringForApproximation,
                    ')' )).
    info add:( 'OldSpace Memory'
                -> ((UnitConverter fileSizeStringFor:(ObjectMemory oldSpaceUsed)),
                    'b (', 
                    (UnitConverter fileSizeStringFor:(ObjectMemory oldSpaceUsed - ObjectMemory freeListSpace)),
                    'b used)' )).

    info do:[:entry |
        response nextPutLine:'<TR BGCOLOR=',lightColor2,'>'.
        response nextPutLine:'<TD WIDTH="40%">'.
        response nextPutAll:entry key.
        response nextPutLine:'</TD>'.
        response nextPutLine:'<TD WIDTH="60%">'.
        response nextPutLine:entry value.
        response nextPutLine:'</TD>'.
        response nextPutLine:'</TR>'.
    ].

    response nextPutLine:'</TABLE>'.

    response
        nextPutLine: '<P>';
        nextPutLine:(aRequest homeWebLinkForText:'Back To Top');
        nextPutLine: '<P>'.

    "Modified: / 02-02-2007 / 12:22:45 / cg"
!

disableSoap:aRequest

    self enableDisableSoap:aRequest yesNo:false
!

enableDisableSoap:aRequest yesNo:yesNo
    |server replyPresenter|

    server := aRequest server.

    yesNo ifTrue:[
        server setupSoap.
    ] ifFalse:[
        server disableSoap.
    ].

    replyPresenter := aRequest replyPresenter.
    replyPresenter title:(yesNo ifTrue:'SOAP Processing enabled' ifFalse:'SOAP Processing disabled').
    replyPresenter secondHeadLine:(yesNo ifTrue:'SOAP Processing enabled' ifFalse:'SOAP Processing disabled').
    replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:1).
    aRequest 
        nextPutLine: (yesNo ifTrue:'<H2>SOAP Processing enabled</H2>' ifFalse:'<H2>SOAP Processing disabled</H2>').

    "Modified: / 02-02-2007 / 12:25:15 / cg"
!

enableSoap:aRequest

    self enableDisableSoap:aRequest yesNo:true
!

enterMaintenanceMode:aRequest
    |server replyPresenter|

    server := aRequest server.

    server maintenanceMode:true. 
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Maintenance mode entered'.
    replyPresenter secondHeadLine:'Maintenance'.
    replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:2).
    aRequest 
        nextPutLine: '<H2>Server is now in maintenance mode - only control requests are answered</H2>';
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:25:11 / cg"
!

exitMaintenanceMode:aRequest
    |server replyPresenter|

    server := aRequest server.

    server maintenanceMode:false. 
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Maintenance left'.
    replyPresenter secondHeadLine:'Maintenance'.
    replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:2).
    aRequest 
        nextPutLine: '<H2>Server is back in serving mode - all requests are answered</H2>';
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:25:08 / cg"
!

exitSmalltalk:aRequest
    |server replyPresenter|

    server := aRequest server.

    server changeServerStatusToQuit. 
    aRequest connection keepConnection:false.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Shutting down Smalltalk...'.
    replyPresenter secondHeadLine:'HTTP Server control'.
    aRequest 
        nextPutLine: '<H2>Smalltalk will shut down now - end of communication</H2>'.
    
    aRequest sendResponse.

    'Smalltalk shut down via HTTP MaintenanceService' errorPrintCR.

    Delay waitForSeconds:1.
    Smalltalk exit.

    "Modified: / 02-02-2007 / 12:23:01 / cg"
!

fileInPatch:aRequest
    |server replyPresenter patchDir|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.

    patchDir := 'stxPatches' asFilename.
    patchDir exists ifFalse:[
        self error:'missing patch directory'.
    ].

    aRequest isPOST ifTrue:[
        aRequest arguments do:[:eachFileToRemove |
            (patchDir construct:eachFileToRemove) fileIn.
        ].
    ].
    aRequest method:'GET'.
    self uploadPatch:aRequest.
!

loadLibrary:aRequest 
    |response server success msg loadSettings replyPresenter defaultPath|

    server := aRequest server.
    response := aRequest response.
    defaultPath := Filename defaultDirectory pathName.

    replyPresenter := aRequest replyPresenter.
    aRequest isPOST ifTrue:[
        |libraryFile file|

        loadSettings := aRequest postDataFieldAt:'LoadLibrary'.
        loadSettings notNil ifTrue:[
            libraryFile := aRequest postDataFieldAt:'LibraryFile'.
            libraryFile notNil ifTrue:[
                defaultPath := libraryFile.
                file := libraryFile asFilename.
                file isDirectory ifTrue:[
                    "show the directory contents"

                    response nextPutLine:'Files in directory: ';
                             nextPutLine:libraryFile;
                             nextPutLine:'<p>'; cr.

                    file directoryContents sort do:[:eachFile|
                        response nextPutLine:eachFile;
                                 nextPutLine:'<br>';
                                 cr.
                    ].
                ] ifFalse:[
                    file isReadable ifTrue:[
                        success := Smalltalk fileIn:file.
                        success ifTrue:[
                            msg := 'Library has been loaded'.
                            replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:2).
                        ] ifFalse:[
                            msg := 'Library load failed!!'.
                        ].
                        replyPresenter title:'Load Library'.
                        replyPresenter secondHeadLine:'Load Library'.
                    ] ifFalse:[
                        msg := 'Cannot find library "', libraryFile, '" !!'.
                        replyPresenter title:'Library Load Failed'.
                        replyPresenter secondHeadLine:'Load Library Failed'.
                    ].
                    response nextPutLine: '<H2>', msg, '</H2>'.
                    ^ self.
                ].
            ].
        ].
    ].
    replyPresenter title:'Load Library'.
    replyPresenter secondHeadLine:'Load Library from Server'.
    response
        nextPutLine:'<FORM action="', (aRequest linkIdFor:self selector:#loadLibrary:),'" method="post">';
        nextPutLine:'<BR>';
        inputFieldFor:'LibraryFile' size:40 label:'Load Library from: ' initialValue:defaultPath;
        formSubmitButtonForString:'Load' name:'LoadLibrary';
        formEnd;
        nextPutLine:'<BR><P>', (aRequest webLinkForText:'Back' service:self selector:#control:).

    "Modified: / 02-02-2007 / 12:25:04 / cg"
!

loadSettings:aRequest 
    |server success msg loadSettings replyPresenter|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.
    aRequest isPOST ifTrue:[
        | settingsFile file|
        loadSettings := aRequest postDataFieldAt:'LoadSettings'.
        loadSettings notNil ifTrue:[
            settingsFile := aRequest postDataFieldAt:'SettingsFile'.
            settingsFile notNil ifTrue:[
                file := settingsFile asFilename.
                file isReadable ifTrue:[
                    success := server readSettingsFromFile:file.
                    success ifTrue:[
                        msg := 'Settings have been loaded'.
                        replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:2).
                    ] ifFalse:[
                        msg := 'Load settings failed!!'.
                    ].
                    replyPresenter title:'Load Settings'.
                    replyPresenter secondHeadLine:'Load Settings'.
                ] ifFalse:[
                    msg := 'Cannot read settings file "', settingsFile, '" !!'.
                    replyPresenter title:'Load Settings Failed'.
                    replyPresenter secondHeadLine:'Load Settings Failed'.
                ].
                aRequest nextPutLine: '<H2>', msg, '</H2>'.
                ^ self.
            ].
        ].
    ].
    replyPresenter title:'Load Settings from File'.
    replyPresenter secondHeadLine:'Load Settings from File'.
    aRequest 
        nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'loadSettings:'),'" method=post>';
        nextPutLine:'<BR>';
        inputFieldFor:'SettingsFile' size:40 label:'Load Settings from: ' initialValue:(server settingsFilename asString);
        formSubmitButtonForString:'Load' name:'LoadSettings';
        formEnd;
        nextPutLine: '<BR><P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:24:52 / cg"
!

openLauncher:aRequest
    "ask user for Display,
     open a display connection and a Laucher"

    |server replyPresenter displayName resultString|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.
    aRequest isPOST ifTrue:[
        displayName := aRequest postDataFieldAt:'DisplayName' ifAbsent:nil.
        Error handle:[:ex |
            resultString := ex description
        ] do:[
            NewLauncher openLauncherOnInitializedDisplayNamed:displayName.
            resultString :='opened'.
        ].
        replyPresenter title:'Opening ST/X Launcher'.
        replyPresenter secondHeadLine:'Opening ST/X Launcher'.
        replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:10).
        aRequest 
            nextPutLine: '<H2>Opening Launcher on: ''' , displayName printString , '''</H2>';
            nextPutLine: '<p>Result: ', resultString, '</p>'.
    ] ifFalse:[
        replyPresenter title:'Open ST/X Launcher'.
        replyPresenter secondHeadLine:'Open ST/X Launcher'.
        aRequest 
            nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#openLauncher:),'" method=post>';
            inputFieldFor:'DisplayName' size:40 label:'Display Name: ' initialValue:'localhost:0';
            nextPutLine:'<BR>';
            formSubmitButton;
            formEnd.
    ].
    aRequest 
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:24:56 / cg"
    "Modified: / 01-06-2010 / 11:26:11 / sr"
!

printSettings:aRequest
    |server replyPresenter|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Settings Printout'.
    replyPresenter secondHeadLine:'Settings Printout'.
    server parametersPrintStrings do:[:aString|
        aRequest nextPutLine:(aString replChar:(Character space) withString:'&nbsp;'), '<br>'.
    ].
    aRequest nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:23:26 / cg"
!

removePatch:aRequest
    |server replyPresenter patchDir|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.

    patchDir := 'stxPatches' asFilename.
    patchDir exists ifFalse:[
        self error:'missing patch directory'.
    ].

    aRequest isPOST ifTrue:[
        aRequest arguments do:[:eachFileToRemove |
            (patchDir construct:eachFileToRemove) remove.
        ].
    ].
    aRequest method:'GET'.
    self uploadPatch:aRequest.
!

restartServer:aRequest
    |server replyPresenter|

    server := aRequest server.
    server changeServerStatusToRestartServer. 
    aRequest connection keepConnection:false.

    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Server restart'.
    replyPresenter secondHeadLine:'HTTP Server control'.
    replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:5).
    aRequest 
        nextPutLine: '<H2>Server is now restarting<BR>please wait a few seconds; I''ll be right back ...</H2>'.
    aRequest sendResponse.

    "this is special (and different to HTTPServer>>#restartServer):
     The serverProcess will not terminate"

    server serverProcess interruptWith:[server class terminationRequest raiseRequest].

    "Modified: / 02-02-2007 / 12:24:37 / cg"
!

saveSettings:aRequest 
    |server saveSettings replyPresenter|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.
    aRequest isPOST ifTrue:[
        |settingsFile file|

        saveSettings := aRequest postDataFieldAt:'SaveSettings'.
        saveSettings notNil ifTrue:[
            settingsFile := aRequest postDataFieldAt:'SettingsFile'.
            settingsFile notNil ifTrue:[
                file := settingsFile asFilename.
                file isWritable ifFalse:[
                    replyPresenter title:'Save Settings Failed'.
                    replyPresenter secondHeadLine:'Save Settings Failed'.
                    aRequest nextPutLine: '<H2>Settings file does not exist or is not writable: "', settingsFile, '"</H2>'.
                    ^ self.
                ].
                server saveSettingsToFile:file.
                replyPresenter title:'Save Settings'.
                replyPresenter secondHeadLine:'Save Settings...'.
                replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:2).
                aRequest nextPutLine: '<H2>Settings were written</H2>'.
            ] ifFalse:[
                replyPresenter title:'Save Settings Failed'.
                replyPresenter secondHeadLine:'Save Settings Failed'.
                aRequest nextPutLine: '<H2>You did not provide a file name for the settings file</H2>'.
            ].
            ^ self.
        ].
    ].
    replyPresenter title:'Save Settings to File'.
    replyPresenter secondHeadLine:'Save Settings to File'.
    aRequest 
        nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'saveSettings:'),'" method=post>';
        nextPutLine:'<BR>';
        inputFieldFor:'SettingsFile' size:40 label:'Save Settings as: ' initialValue:(server settingsFilename asString);
        formSubmitButtonForString:'Save' name:'SaveSettings';
        formEnd;
        nextPutLine: '<BR><P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:24:32 / cg"
!

snapshot:aRequest 
    |server replyPresenter|

    server := aRequest server.

    server changeServerStatusToSnapshot. 
    aRequest connection keepConnection:false.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Taking snapshot...'.
    replyPresenter secondHeadLine:'Taking snapshot...'.
    replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'control:' time:3).
    aRequest 
        nextPutLine: '<H2>Snapshot has been written</H2>';
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').
    aRequest sendResponse.
    server serverProcess interruptWith:[server class terminationRequest raiseRequest].

    "Modified: / 02-02-2007 / 12:24:17 / cg"
!

stopServer:aRequest
    |server replyPresenter|

    server := aRequest server.
    server changeServerStatusToRestartServer. 
    aRequest connection keepConnection:false.

    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Server stop'.
    replyPresenter secondHeadLine:'HTTP Server control'.
    aRequest 
        nextPutLine: '<H2>Server is now stopping - end of comminication</H2>'.
    aRequest sendResponse.

    ('HTTPServer port <1p> stopped via HTTP MaintenanceService' expandMacrosWith:server port) errorPrintCR.
    server stop.

    "Modified: / 02-02-2007 / 12:23:48 / cg"
!

uploadPatch:aRequest
    |server replyPresenter patchDir chunk patchData patchFileName s|

    server := aRequest server.

    replyPresenter := aRequest replyPresenter.

    aRequest isPOST ifTrue:[
        chunk := aRequest multiPartChunks at:'PatchFile'.
        patchData := chunk data.
        patchFileName := (chunk contentDispositionElements at:#filename) asFilename baseName asString.      
        patchFileName := patchFileName asFilename baseName asString.
        

        patchDir := 'stxPatches' asFilename.
        patchDir exists ifFalse:[
            patchDir makeDirectory.
        ].
        patchDir isDirectory ifFalse:[
            self error:'cannot create patch directory'.
        ].
        s := (patchDir construct:patchFileName) writeStream.
        s nextPutAll:patchData.
        s close.
    ] ifFalse:[
        replyPresenter title:'Upload Patch'.
        replyPresenter secondHeadLine:'Upload Patch'.
        aRequest 
            nextPutLine: '<FORM action="', (aRequest linkIdFor:self selector:#'uploadPatch:'),'" method="post" enctype="multipart/form-data">';
            inputFieldFor:'PatchFile' type:'"file"' size:40 label:'Patch File: ' initialValue:'';
            nextPutLine:'<BR>';
            formSubmitButtonForString:'Upload' name:'Upload';
            formEnd.
        aRequest
            nextPutLine:'<P>';
            nextPutLine:'<HR>';
            nextPutLine:'<P>';
            nextPutLine:'Existing Patches:';
            nextPutLine:'<TABLE border width="100%">';
            nextPutLine:'<TR>';
            nextPutLine:'<TH>File';
            nextPutLine:'</TH>';
            nextPutLine:'<TH>Size';
            nextPutLine:'</TH>';
            nextPutLine:'<TH>Modified/Uploaded';
            nextPutLine:'</TH>';
            nextPutLine:'<TH colspan="2">';
            nextPutLine:'</TH>';
            nextPutLine:'</TR>'.

        patchDir := 'stxPatches' asFilename.
        patchDir exists ifTrue:[
            patchDir isDirectory ifTrue:[
                patchDir directoryContentsAsFilenamesDo:[:patchFile |
                    aRequest
                        nextPutLine:
                                '<TR>',
                                '<TD>',patchFile baseName,'</TD>',
                                '<TD>',patchFile fileSize printString,'</TD>',
                                '<TD>',patchFile modificationTime printString,'</TD>',
                                '<TD valign="middle">',
                                '<FORM action="', (aRequest linkIdFor:self selector:#'removePatch:' argument:patchFile baseName),'" method="post">',
                                (aRequest formSubmitButtonStringForString:'Remove' name:'Remove'),
                                '</FORM>',
                                '</TD>',
                                '<TD valign="middle">',
                                '<FORM action="', (aRequest linkIdFor:self selector:#'fileInPatch:' argument:patchFile baseName),'" method="post">',
                                (aRequest formSubmitButtonStringForString:'FileIn' name:'FileIn'),
                                '</FORM>',
                                '</TD>',
                                '</TR>'.
                ].
            ].
        ].
        aRequest
            nextPutLine:'</TABLE>'.
    ].
    aRequest 
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:#'control:').

    "Modified: / 02-02-2007 / 12:23:52 / cg"
! !

!ServerMaintenanceService methodsFor:'requests-reply-authorization'!

changeAuthorization:aRequest
    |server msg title removeRealm removeRealmSubmit addRealmSubmit addRealm replyPresenter|

    server := aRequest server.

    aRequest isPOST ifTrue:[
        title := ''.
        addRealmSubmit := aRequest postDataFieldAt:'AddRealmSubmit'.
        addRealmSubmit notNil ifTrue:[
            addRealm := aRequest postDataFieldAt:'AddRealm'.
            addRealm notNil ifTrue:[
                (server realmUsersMap keys includes:addRealm) ifTrue:[
                    msg := 'Can not add realm ', addRealm, ' - realm already exists'.
                    title := addRealm, ' not added'.
                ] ifFalse:[
                    server addRealm:addRealm.
                    msg := 'Add Realm ', addRealm, ' to Server'.
                    title := 'Add Realm ', addRealm, ' to Server'.
                ].
            ].
        ].
        removeRealmSubmit := aRequest postDataFieldAt:'RemoveRealmSubmit'.
        removeRealmSubmit notNil ifTrue:[
            removeRealm := aRequest postDataFieldAt:'removeRealm'.
            self realm = removeRealm ifTrue:[
                msg := 'Remove my realm ', removeRealm, ' not allowed'.
                title := removeRealm, ' not removed'.
            ] ifFalse:[
                server removeRealm:removeRealm.
                msg := 'Remove Realm ', removeRealm, ' from Server'.
                title := 'Remove Realm ', removeRealm, ' from Server'.
            ].
        ].
        (self removeChangeUsersFor:aRequest) ifTrue:[
            ^ self
        ].

        (aRequest postDataFieldAt:'ChangeMethodsSubmit') notNil ifTrue:[
            self changeAuthorizationMethods:aRequest.
            ^ self
        ].
        replyPresenter := aRequest replyPresenter.
        replyPresenter title:title.
        replyPresenter secondHeadLine:'Change Authorization'.
        replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'changeAuthorization:'  time:2).
        aRequest 
            nextPutLine: ('<H2>', msg, '</H2>');
            nextPutLine:'<P>', (aRequest webLinkForText:'Back' service:self selector:#'changeAuthorization:').
        ^ self
    ].
    self changeAuthorizationPageFor:aRequest.

    "Modified: / 02-02-2007 / 12:25:41 / cg"
!

changeAuthorizationMethods:aRequest 
    |server colOfAllowedMethods title msg replyPresenter|

    server := aRequest server.
    aRequest isPOST ifFalse:[
        self changeAuthorization:aRequest.
        ^ self.
    ].
    colOfAllowedMethods := OrderedCollection new.
    server class availableAuthenticationMethods do:[:method | 
        |value|

        value := aRequest postDataFieldAt:('Allow' , method) ifAbsent:''.
        value = 'ON' ifTrue:[
            colOfAllowedMethods add:method
        ]
    ].
    colOfAllowedMethods isEmpty ifTrue:[
        title := 'Authorization Methods not changed'.
        msg := 'Maintenance would not available if all authorization methods removed'.
    ] ifFalse:[
        title := msg := 'Authorization Methods changed'.
        server allowedAuthMethods:colOfAllowedMethods.
    ].
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:title.
    replyPresenter secondHeadLine:'Change Authorization'.
    replyPresenter 
        beforeTitle:(aRequest 
                refreshStringFor:self
                selector:#changeAuthorization:
                time:2).
    aRequest
        nextPutLine:('<H2>' , msg , '</H2>');
        nextPutLine:'<P>' , (aRequest 
                            webLinkForText:'Back'
                            service:self
                            selector:#changeAuthorization:).

    "Modified: / 02-02-2007 / 12:25:37 / cg"
!

changeAuthorizationPageFor:aRequest 
    |server replyPresenter|

    server := aRequest server.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:'Change Authorization'.
    replyPresenter secondHeadLine:'Change Authorization'.
    aRequest nextPutLine:'<H2>Current realms and users</H2>'.
    aRequest 
        nextPutLine:'<TABLE border="1" style="text-align: left; width: 100%;">'.
    aRequest 
        nextPutLine:'<TH style="vertical-align: top; width: 400px;">Realm</TH><TH ALIGN=left>Users</TH>'.
    server realmUsersMap 
        keysAndValuesDo:[:aRealm :users | 
            aRequest nextPutLine:'<TR><TD>' , aRealm , '</TD><TD>'.
            users keys do:[:aKey | 
                aRequest nextPutLine:aKey , '<BR>'.
            ].
            aRequest nextPutLine:'</TD>'.
        ].
    aRequest nextPutLine:'</TABLE>'.
    aRequest
        nextPutLine:'<H2>Add a Realm:</H2>';
        nextPutLine:'<FORM action="' 
                    , (aRequest linkIdFor:self selector:#changeAuthorization:) 
                        , '" method=post>';
        inputFieldFor:'AddRealm'
            size:50
            label:'AddRealm:&nbsp;&nbsp;&nbsp;'
            initialValue:'';
        nextPutAll:'<P>';
        formSubmitButtonForString:'Add Realm' name:'AddRealmSubmit';
        formEnd;
        nextPutAll:'<BR>'.
    aRequest
        nextPutLine:'<H2>Remove a Realm:</H2>';
        nextPutLine:'<FORM action="' 
                    , (aRequest linkIdFor:self selector:#changeAuthorization:) 
                        , '" method=post>'.
    aRequest
        nextPutLine:'<TABLE>';
        nextPutLine:'<TR><TD>Realms:</TD><TD>';
        nextPutLine:'&nbsp;&nbsp;&nbsp;';
        nextPutLine:'<SELECT NAME=removeRealm SIZE=1> '.
    server realmUsersMap keys do:[:aKey | 
        aRequest nextPutLine:'<OPTION> ' , aKey asString , '</OPTION>'.
    ].
    aRequest
        nextPutLine:'</SELECT> ';
        nextPutLine:'</TD></TR></Table><br>';
        formSubmitButtonForString:'Remove Realm' name:'RemoveRealmSubmit';
        formEnd.
    aRequest
        nextPutLine:'<H2>Add/Remove a user to/from a realm:</H2>';
        nextPutLine:'<FORM action="' 
                    , (aRequest linkIdFor:self selector:#changeAuthorization:) 
                        , '" method=post>';
        nextPutLine:'(leave password empty to remove user from realm)<P>'.
    aRequest
        nextPutLine:'<TABLE>';
        nextPutLine:'<TR><TD>Realms:</TD><TD>';
        nextPutLine:'<SELECT NAME=Realm SIZE=1> '.
    server realmUsersMap keys do:[:aKey | 
        aRequest nextPutLine:'<OPTION> ' , aKey asString , '</OPTION>'.
    ].
    aRequest
        nextPutLine:'</SELECT> ';
        nextPutLine:'</TD></TR>';
        nextPutLine:'<TR><TD>User:</TD><TD>'.
    aRequest
        inputFieldFor:'User'
            size:30
            label:nil
            initialValue:'';
        nextPutLine:'</TD></TR>';
        nextPutLine:'<TR><TD>Password:</TD><TD>';
        inputFieldFor:'Password'
            type:'password'
            size:30
            label:nil
            initialValue:'';
        nextPutLine:'</TD></TR>';
        nextPutLine:'<TR><TD>Retype Password:</TD><TD>';
        inputFieldFor:'RetypePassword'
            type:'password'
            size:30
            label:nil
            initialValue:'';
        nextPutLine:'</TD></TR>';
        nextPutLine:'</TABLE>';
        nextPutLine:'<BR>'.
    aRequest
        nextPutLine:'<BR>';
        formSubmitButtonForString:'Add / Change' name:'AddChangeUser';
        nextPutLine:'&nbsp;&nbsp;&nbsp;';
        formSubmitButtonForString:'Remove' name:'RemoveUser';
        formEnd.
    aRequest
        nextPutLine:'<FORM action="' 
                    , (aRequest linkIdFor:self selector:#changeAuthorization:) 
                        , '" method=post>';
        nextPutLine:'<H2>Allowed authentification methods</H2>'.
    server class availableAuthenticationMethods do:[:method | 
        |checked|

        checked := server allowedAuthMethods includes:(method asSymbol).
        aRequest
            inputFieldFor:('Allow' , method)
                type:'checkbox'
                size:nil
                label:('Allow ' , method , ':')
                initialValue:'ON'
                append:(checked ifTrue:[ 'checked' ] ifFalse:[ '' ]);
            nextPutLine:'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
    ].
    aRequest
        nextPutLine:'<BR>';
        nextPutLine:'<BR>';
        formSubmitButtonForString:'OK' name:'ChangeMethodsSubmit';
        formEnd;
        nextPutLine:'<P>' , (aRequest 
                            webLinkForText:'Back'
                            service:self
                            selector:#control:).

    "Modified: / 02-02-2007 / 12:22:09 / cg"
!

removeChangeUsersFor:aRequest

    |user password retypePassword authRealm server msg title addChangeUser removeUser replyPresenter|

    server := aRequest server.
    addChangeUser := aRequest postDataFieldAt:'AddChangeUser' ifAbsent:nil.
    removeUser := aRequest postDataFieldAt:'RemoveUser' ifAbsent:nil.
    (addChangeUser notNil or:[removeUser notNil]) ifTrue:[
        user := aRequest postDataFieldAt:'User' ifAbsent:''.
        password := (aRequest postDataFieldAt:'Password' ifAbsent:'') ? ''.
        retypePassword := (aRequest postDataFieldAt:'RetypePassword' ifAbsent:'') ? ''.
        authRealm := aRequest postDataFieldAt:'Realm' ifAbsent:''.
        (server realmUsersMap at:authRealm ifAbsent:nil) isNil ifTrue:[
            msg := 'Remove of User:', user, ' from Realm:', authRealm, 'not possible - realm does not exist'.
            title := user, ' User not removed from Realm:', authRealm.
        ] ifFalse:[
            removeUser notNil ifTrue:[
                ((authRealm = self realm) and:[authRealm notNil and:[(server usersForRealm:authRealm) size = 1]]) ifTrue:[
                    msg := 'Remove of the last maintenance user disallowed any acces to maintenance'.
                    title := user, ' User not removed from Realm:', authRealm.
                ] ifFalse:[
                    (server hasUser:user forRealm:authRealm) ifFalse:[
                        msg := 'User not exists'.
                        title := user, ' User not removed from Realm:', authRealm.
                    ] ifTrue:[
                        server removeUser:user fromRealm:authRealm.
                        title := 'User:', user, ' removed'.
                        msg := 'User:', user, ' removed for Realm:', authRealm.
                    ].
                ].
            ] ifFalse:[
                (server hasUser:user forRealm:authRealm) ifTrue:[
                    msg := 'Change user ', user.
                    title := user, ' Changed'.
                ] ifFalse:[
                    title := 'Create user ', user.
                    msg := 'Create user:', user, ' for Realm:', authRealm.
                ].
                password ~= retypePassword ifTrue:[
                    msg := title := 'password and retyped password does not match'.
                ] ifFalse:[
                    server addUser:user password:password toRealm:authRealm overWrite:true.
                ].
            ].
        ].
        replyPresenter := aRequest replyPresenter.
        replyPresenter title:title.
        replyPresenter secondHeadLine:'Change Authorization'.
        replyPresenter beforeTitle:(aRequest refreshStringFor:self selector:#'changeAuthorization:'  time:2).
        aRequest 
            nextPutLine: ('<H2>', msg, '</H2>');
            nextPutLine:'<P>', (aRequest webLinkForText:'Back' service:self selector:#'changeAuthorization:').
        ^ true
    ].
    ^ false

    "Modified: / 02-02-2007 / 12:24:40 / cg"
! !

!ServerMaintenanceService methodsFor:'service-helpers'!

changeService:aService fromRequest:aRequest 
    aService commonChangeFromRequest:aRequest.
    aService specificChangeFromRequest:aRequest.
!

createNewServiceFromFields:fields request:aRequest

    |serviceClassName serviceClass service|

    serviceClassName := fields at:'ServiceClass' ifAbsent:nil.
    serviceClassName notNil ifTrue:[   
        serviceClass := Smalltalk at:(serviceClassName asSymbol).
        service := serviceClass new initialize.
        service httpServer:aRequest server.
        self changeService:service fromRequest:aRequest.
    ].
    ^ service
!

createNewServiceFromRequest:aRequest

    |serviceClassName serviceClass service|

    serviceClassName := aRequest urlParameterAt:'ServiceClass'.
    serviceClassName notNil ifTrue:[   
        serviceClass := Smalltalk at:(serviceClassName asSymbol).
        service := serviceClass new initialize.
        service httpServer:aRequest server.
        self changeService:service fromRequest:aRequest.
    ].
    ^ service
!

responseError:aErrorString title:aTitle request:aRequest backSelector:backSel

    |replyPresenter|

    replyPresenter := aRequest replyPresenter.
    replyPresenter title:aTitle.
    replyPresenter secondHeadLine:aTitle.
    aRequest 
        nextPutLine: '<P>', aErrorString;
        nextPutLine: '<P>', (aRequest webLinkForText:'Back' service:self selector:backSel ).
    ^ self.

    "Modified: / 02-02-2007 / 12:23:34 / cg"
!

serviceFromRequest:request

    |servicelinkName service indexInServiceList|

    indexInServiceList := request urlParameterAt:'IndexInServiceList'.
    indexInServiceList notNil ifTrue:[
        service := request server serviceList asOrderedCollection at:(indexInServiceList asNumber) ifAbsent:nil.
        ^ service
    ].
    servicelinkName := request urlParameterAt:'LinkName'.
    servicelinkName notNil ifTrue:[
        service := request server serviceForLink:servicelinkName.
    ].
    ^ service
!

serviceInputFieldsFor:service request:aRequest change:change

    service commonInputFieldsForRequest:aRequest change:change.
    aRequest nextPutLine:'<hr style="width: 100%; height: 2px;">'.
    service specificInputFieldsForRequest:aRequest.
    aRequest nextPutLine:'<hr style="width: 100%; height: 2px;">'.
! !

!ServerMaintenanceService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/ServerMaintenanceService.st,v 1.100 2010/06/01 09:28:36 sr Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/ServerMaintenanceService.st,v 1.100 2010/06/01 09:28:36 sr Exp $'
! !
