"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

"{ NameSpace: Demos }"

HTTPSelectorService subclass:#WebHomePageForSTX
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'demos-WebApplications'
!

!WebHomePageForSTX class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!WebHomePageForSTX class methodsFor:'defaults'!

defaultReplyPresenterClass
    ^ ExeptReplyPresenter
!

isThreadSafe
    ^ true
!

linkName
    "return the default linkName path (with slash)"

    ^ '/Home'
! !

!WebHomePageForSTX class methodsFor:'queries-service'!

settingsApplicationClass
    "a SettingsApplication class - or nil (used in the settings dialog if non-nil)"

    ^ nil
! !

!WebHomePageForSTX methodsFor:'defaults'!

allowedMessages
    ^ #(homePage:)
!

defaultMessage
    ^ #homePage
! !

!WebHomePageForSTX methodsFor:'queries'!

visibleServicesFor:aServiceClass server:aServer 
    ^ (aServer servicesForServiceClass:aServiceClass) 
        select:[:s | s visibleInHomePage ].
! !

!WebHomePageForSTX methodsFor:'registration'!

addRequiredForeignServicesTo:aServer 
    "I need a file service for the bitmaps and icons"

    self addStandardFileServicesTo:aServer.
! !

!WebHomePageForSTX methodsFor:'requests-helpers'!

additionalHeadTextForSTX
    ^ '<link rel="icon" type="image/ico" href="files/favicon.ico">'
!

serviceLinksFor:aServiceClassList commonHeaderLine:aCommonHeaderLine headerLines:aHeaderLineStringList linkNames:aLinkNameStringOrBlockList request:aRequest

    |server noOfServices aHeaderLineString aLinkNameStringOrBlock serviceLists foundAnyService htmlElements list anchorName|

    server := aRequest server.
    htmlElements := OrderedCollection new.
    serviceLists := OrderedCollection new.
    aServiceClassList do:[:aServiceClass|
        serviceLists add:(self visibleServicesFor:aServiceClass server:server)
    ].
    foundAnyService := (serviceLists detect:[:aServiceList| aServiceList notEmpty] ifNone:[nil]) notNil.
    foundAnyService ifTrue:[
        aCommonHeaderLine notEmptyOrNil ifTrue:[
            htmlElements add:(HTML::Heading4 with:aCommonHeaderLine).
        ].
        list := HTML::UnorderedList new.
        htmlElements add:list.
        serviceLists doWithIndex:[:services :index|
            services notEmpty ifTrue:[ 
                aHeaderLineStringList notEmptyOrNil ifTrue:[
                    (aHeaderLineString := aHeaderLineStringList at:index ifAbsent:nil) notEmptyOrNil ifTrue:[
                        htmlElements add:(HTML::Heading4 with:aHeaderLineString).
                    ].
                ].
                noOfServices := services size.
                services do:[:aService|
                    anchorName := OrderedCollection new.
                    aLinkNameStringOrBlock := aLinkNameStringOrBlockList at:index ifAbsent:nil.
                    aLinkNameStringOrBlock notNil ifTrue:[
                        aLinkNameStringOrBlock isBlock ifTrue:[
                            anchorName add:(aLinkNameStringOrBlock value:aService).
                        ] ifFalse:[
                            anchorName add:aLinkNameStringOrBlock.
                        ].
                    ].
                    noOfServices > 1 ifTrue:[
                        anchorName add:' [', aService linkName, ']'.
                    ].
                    list addListItem:(HTML::Anchor href:aService linkName with:anchorName).
                ].
            ]
        ].
    ].
    ^ htmlElements
!

welcomeHomePageString
    |elements p|

    elements := OrderedCollection new.
    p := elements add:HTML::Paragraph new.
    p addChild:'This is the demo (default-) home page of the '.
    p addChild:(HTML::Anchor href:'http://www.smalltalk-x.de' with:'Smalltalk/X').
    p addChild:' HTTPServer, which is provided to demonstrate some of the server''s functionality'.
    p addChild:HTML::Break new.
    p addChild:'To change this page, either edit the '.
    p addChild:(HTML::Bold with:(self className, ' homePage')).
    p addChild:' method or create your own homePage service, and change the '.
    p addChild:(HTML::Bold with:'homeURL').
    p addChild:' setting of the HTTPServer to something different.'.
    p := elements add:HTML::Paragraph new.
    p addChild:'And please have a look at the HTTPServer''s class documentation and/or the parameters in the HTTPServer-Settings application.'.
    ^ elements
! !

!WebHomePageForSTX methodsFor:'requests-helpers-paragraphs'!

comancheSTTFor:aRequest
    ^ self serviceLinksFor:(Array with:ComancheSTTService)
            commonHeaderLine:'Smalltalk Templates (aka. Active Server Pages)' 
            headerLines:nil
            linkNames:(Array with:'STT (SmallTalk Templates) demo page') 
            request:aRequest
!

comancheSwikiFor:aRequest
    |swikiModule server comSwikiServices noOfServices bookPrefixPath htmlElements list index|

    server := aRequest server.
    comSwikiServices := self visibleServicesFor:ComancheSwikiService server:server.
    comSwikiServices isEmpty ifTrue:[ ^ #()].
    htmlElements := OrderedCollection new.
    noOfServices := comSwikiServices size.
    index := 1.
    comSwikiServices do:[:aComSwikiService|
        noOfServices == 1 ifTrue:[
            htmlElements add:(HTML::Heading2 with:'Swiki Books').
        ] ifFalse:[
            htmlElements add:(HTML::Heading2 with:('Swiki Books ', index asString)).
            index := index + 1.
        ].
        list := HTML::UnorderedList new.
        htmlElements add:list.
        swikiModule := aComSwikiService module.
        swikiModule notNil ifTrue:[
            bookPrefixPath := swikiModule shelf settingsAt:'bookPrefixPath' ifAbsent:'/'.
            swikiModule shelf books do:[:aSwikiBook | 
                | linkName aSwikiBookName aSwikiBookDescr |

                aSwikiBookName := aSwikiBook name.
                linkName := bookPrefixPath , aSwikiBookName.
                aSwikiBookName = 'refs' ifTrue:[
                    aSwikiBookDescr := 'Squeak Sample'.
                ] ifFalse:[
                    aSwikiBookDescr := aSwikiBookName asUppercaseFirst.
                ].
                (aSwikiBook setup at: 'visible' ifAbsent:true) ifTrue:[
                    |type|

                    (swikiModule isMemberOf:Comanche::SwikiModule) ifTrue:[
                        type := ''
                    ] ifFalse:[
                        type := swikiModule class nameWithoutPrefix.
                        (type endsWith:'Module') ifTrue:[ type := type copyWithoutLast:6].
                        type := ' [<small>' , type , '</small>]'
                    ].
                    list addListItem:(HTML::Anchor href:linkName with:(aSwikiBookDescr, type)).
                ].
            ].
            list addListItem:(HTML::Anchor href:(bookPrefixPath, 'admin') with:'Administrate Swiki').
        ].
    ].
    ^ htmlElements
!

demoApplicationFor:aRequest 
    ^ self serviceLinksFor:(Array with:WebDemoApp1)
            commonHeaderLine:'Demonstration Dynamic WebPages' 
            headerLines:nil
            linkNames:(Array with:'Dynamic Web Pages') 
            request:aRequest
!

demoShopFor:aRequest
    ^ self serviceLinksFor:(Array with:WebDemoShop)
            commonHeaderLine:'Smalltalk Demo Shop' 
            headerLines:nil
            linkNames:(Array with:'Demo Shop Page') 
            request:aRequest
!

maintenanceFor:aRequest 
    ^ self serviceLinksFor:(Array with:ServerMaintenanceService)
            commonHeaderLine:'Server Control (Authorized persons and local access only)' 
            headerLines:nil
            linkNames:(Array with:'Maintenance') 
            request:aRequest

    "Modified: / 01-02-2007 / 21:25:01 / cg"
!

onlineDocumentationFor:aRequest
    |classDocumentationServices docServer elements list|

    classDocumentationServices := self visibleServicesFor:HTTPClassDocService server:aRequest server.
    classDocumentationServices isEmpty ifTrue:[^ #()].

    elements := OrderedCollection new.
    elements add:(HTML::Heading2 with:'Smalltalk/X Documentation Links:').

    classDocumentationServices do:[:aClassDocService|
        list := HTML::UnorderedList new.
        elements add:list.

        "/ to refer to the st/x server, use:
        docServer := aClassDocService rootDirectory asFilename baseName , '/online'.

        list addListItem:(HTML::Anchor href:(docServer , '/english/TOP.html') with:'Online Documentation [english]').
        list addListItem:(HTML::Anchor href:(classDocumentationServices first linkName) with:'Class Documentation').
    ].
    ^ elements
!

otherServicesFor:aRequest
    |otherServices|

    otherServices := HTTPService allSubclasses
                        select:[:serviceClass |
                            (Error catch:[serviceClass linkName]) not
                        ].
    otherServices sort:[:a :b | a linkName < b linkName].

    ^ self serviceLinksFor:otherServices
            commonHeaderLine:'Other Services' 
            headerLines:nil
            linkNames:(otherServices collect:[:each | each linkName]) 
            request:aRequest

    "Created: / 26-11-2006 / 14:10:48 / cg"
!

pageCounterFor:aRequest
    |referer refererAddresses refererHost doCount htmlElements p image|

    (self visibleServicesFor:HTTPUtilityService server:aRequest server) isEmptyOrNil ifTrue:[
        ^ #()
    ].

    doCount := true.

    "if the referrer is one of my page, the visitor is not a new one.
     Then we do not count up."
    referer := aRequest referer.
    referer notNil ifTrue:[
        "increment count only if refered from a real page"
        refererHost := (URL fromString:referer) host.
        [
            refererAddresses := SocketAddress allForHostName:refererHost.
            "/ I will only count my own pages - ignore if linked from another host
            doCount := (refererAddresses contains:[:eachRefererAddress|
                eachRefererAddress isLocal 
                or:[eachRefererAddress hostAddress = aRequest socketAddress hostAddress]
            ]).
        ] on:NameLookupError do:[:ex| ].
    ].
    
    htmlElements := OrderedCollection new.
    htmlElements add:HTML::Paragraph new.
    htmlElements add:(HTML::Heading2 with:'Experimental Counter:').
    p := htmlElements add:HTML::Paragraph new.
    image := HTML::Image new.
    image alternative:'counter image'.
    image border:0.
    image alignCenter.
    doCount ifTrue:[
        image source:'/Utilities/accessCounter'.
    ] ifFalse:[
        image source:'/Utilities/accessCounterUncounted'.
    ].
    p addChild:image.
    p addChild:'distinct visits to this page (since server start).'.
    htmlElements add:HTML::Paragraph new.
    ^ htmlElements
!

resourceManagerFor:aRequest
    ^ self serviceLinksFor:(Array with:WebResourceManager)
            commonHeaderLine:'Smalltalk Resource Manager' 
            headerLines:nil
            linkNames:(Array with:'Resource Manager') 
            request:aRequest
!

slideShowServiceLinksFor:aRequest
    ^ self serviceLinksFor:(Array with:Demos::WebSlideShow)
            commonHeaderLine:'Slide Shows' 
            headerLines:nil
            linkNames:(Array with:'SlideShow') 
            request:aRequest
!

smalltalkSourceAccessFor:aRequest
    ^ self serviceLinksFor:(Array with:HTTPSourceCodeAccessService)
            commonHeaderLine:'Source Code Access' 
            headerLines:nil
            linkNames:(Array with:'SourceCode') 
            request:aRequest
!

smalltalkWebBrowserFor:aRequest
    ^ self serviceLinksFor:(Array with:WebSmalltalkBrowser)
            commonHeaderLine:'Smalltalk Browser' 
            headerLines:nil
            linkNames:(Array with:'Browse the running Smalltalk') 
            request:aRequest
!

talkToLiveSystemEmbeddedFor:aRequest

    |linkNameBlock|

    linkNameBlock := [:aEmbedService|
        HTML::Anchor href:((aRequest linkIdFor:aEmbedService) , '/' , #'registeredApplicationList:')  with:'List of registered applications'
    ].
    ^ self serviceLinksFor:(Array with:HTTPEmbeddedApplicationService)
            commonHeaderLine:'Talk to a live System (embedded smalltalk applications)' 
            headerLines:nil
            linkNames:(Array with:linkNameBlock) 
            request:aRequest
!

talkToLiveSystemPureHtmlFor:aRequest

    ^ self serviceLinksFor:(Array with:Demos::WebProcessList with:Demos::WebScreenImageService)
            commonHeaderLine:'Talk to a live System (pure html)' 
            headerLines:nil
            linkNames:(Array with:'See running Processes' with:'Screen image') 
            request:aRequest
! !

!WebHomePageForSTX methodsFor:'requests-homePage'!

homePage: aRequest
    "The server's homePage."

    |pageString replyPresenter container|

    pageString := 'Welcome to ST/X'.
    replyPresenter := aRequest replyPresenter.
    replyPresenter title:pageString.
    replyPresenter secondHeadLine:pageString.

    "/ uses the html-tree building objects the old-way (not using a treeBuilder)
    container := HTML::Div new.
    container addElements:self welcomeHomePageString.
    container addElements:(self onlineDocumentationFor:aRequest).
    container addElements:(self smalltalkSourceAccessFor:aRequest).

    container addElements:(self talkToLiveSystemPureHtmlFor:aRequest).
    container addElements:(self smalltalkWebBrowserFor:aRequest).
    container addElements:(self talkToLiveSystemEmbeddedFor:aRequest).

    container addElements:(self slideShowServiceLinksFor:aRequest).

    container addElements:(self demoApplicationFor:aRequest).
    container addElements:(self comancheSTTFor:aRequest).
    container addElements:(self comancheSwikiFor:aRequest).
    container addElements:(self demoShopFor:aRequest).
"/    container addElements:(self otherServicesFor:aRequest).
    container addElements:(self resourceManagerFor:aRequest).
    container addElements:(self maintenanceFor:aRequest).
    container addElements:(self pageCounterFor:aRequest).

    aRequest
        reply:container htmlString.

    "Modified: / 19-11-2010 / 12:14:40 / cg"
! !

!WebHomePageForSTX class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/WebHomePageForSTX.st,v 1.75 2010/11/19 11:32:53 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/WebHomePageForSTX.st,v 1.75 2010/11/19 11:32:53 cg Exp $'
! !
