"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer' }"

"{ NameSpace: Demos }"

HTTPSelectorService subclass:#WebScreenImageService
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'demos-WebApplications'
!

!WebScreenImageService class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!WebScreenImageService class methodsFor:'defaults'!

defaultAllowRobots
    ^ false
!

defaultReplyPresenterClass
    ^ ExeptReplyPresenter
!

isThreadSafe
    ^ true
!

linkName
    "return the default linkName path (with slash)"

    ^ '/ScreenImage'
! !

!WebScreenImageService class methodsFor:'queries-service'!

settingsApplicationClass
    "a SettingsApplication class - or nil (used in the settings dialog if non-nil)"

    ^ nil
! !

!WebScreenImageService methodsFor:'defaults'!

allowedMessages
    ^ #(screenImage:)
!

defaultMessage
    ^ #screenImage
! !

!WebScreenImageService methodsFor:'registration'!

addRequiredForeignServicesTo:aServer 
    "I need a file service for the bitmaps and icons"

    self addStandardFileServicesTo:aServer.
! !

!WebScreenImageService methodsFor:'requests-server'!

screenImage:aRequest
    "send a live image"

    |display img usedColors ditherColors replyPresenter|

    replyPresenter := aRequest replyPresenter.
    (Screen isNil
    or:[ (display := Screen current) isNil ])
    ifTrue:[
        "/ no Screen configured ...
        replyPresenter title:'No screen'.
        replyPresenter parametersAt:#secondHeadLine put:'Sorry, there is no screen (headless ST/X running)'.
        aRequest
            reply:'<P>';
            reply:aRequest homeWebLinkForText:'[home]';
            reply:'<P>'.
        ^ self 
    ].

    img := Image 
                fromScreen:(0@0 corner:(display width @ display height))
                on:display
                grab:false.

    img depth > 8 ifTrue:[
        "coloredImage" "true" false ifTrue:[
            "/ must convert - GIF only supports Depth8.
            usedColors := img usedColorsMax:512.
            (usedColors isNil or:[usedColors size > 240]) ifTrue:[
                ditherColors := Color colorCubeWithRed:8 green:8 blue:4.
            ] ifFalse:[
                ditherColors := usedColors.
            ].
            img := img asDitheredImageUsing:ditherColors depth:8.
        ] ifFalse:[
            img := img asGrayImageDepth:8
        ].
    ] ifFalse:[
        img := Depth8Image fromImage:img
    ].

    "/ BUG - currently, I can only send the image if the display
    "/ has depth 8. This must be fixed (in Depth8Image fromImage:)

    replyPresenter title:'Live, actual screenImage'.
    replyPresenter parametersAt:#secondHeadLine put:'Screen on ' , display displayName.
    aRequest
        imageFor:img;
        reply:'<P>';
        reply: (aRequest webLinkForText:'[update]' service:self selector:#'screenImage:');
        reply:'<A HREF="/">[home]</A>';
        reply:'<P>'.

    "Modified: / 30.7.1999 / 21:32:39 / cg"
! !

!WebScreenImageService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/WebScreenImageService.st,v 1.23 2003/12/09 13:17:14 penk Exp $'
! !
