"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer' }"

"{ NameSpace: Demos }"

HTTPSelectorService subclass:#WebSmalltalkBrowser
	instanceVariableNames:'nameSpaceList classCategoryList'
	classVariableNames:''
	poolDictionaries:''
	category:'demos-WebApplications'
!

Object subclass:#Arguments
	instanceVariableNames:'classCategorySelection classSelection methodCategorySelection
		methodSelection showClass'
	classVariableNames:''
	poolDictionaries:''
	privateIn:WebSmalltalkBrowser
!

!WebSmalltalkBrowser class methodsFor:'documentation'!

copyright 
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    A first, brute force attempt to a SmalltalkBrowser for the Net.

    [author:]
	Claus Gittinger (cg@exept)

    [see also:]
	HTTPServer PWS
"
! !

!WebSmalltalkBrowser class methodsFor:'defaults'!

canChangeReplyPresenter
    ^ false
!

isThreadSafe

    ^ true
!

linkName
    "return the default linkName path (with slash)"

    ^ '/Browser'
! !

!WebSmalltalkBrowser class methodsFor:'queries-service'!

settingsApplicationClass
    "a SettingsApplication class - or nil (used in the settings dialog if non-nil)"

    ^ nil
! !

!WebSmalltalkBrowser methodsFor:'aspects'!

classCategoryList

    classCategoryList isNil ifTrue:[
        classCategoryList := Set new.
        Smalltalk allClassesDo:[:aClass |
            aClass category notNil ifTrue:[
                classCategoryList add:aClass category.
            ]
        ].
        classCategoryList := classCategoryList asArray sort asList.
    ].
    ^ classCategoryList
!

nameSpaceList
    |allNamespaces|

    nameSpaceList isNil ifTrue:[
        allNamespaces := NameSpace allNamespaces.
        allNamespaces := allNamespaces select:[:ns |
                                                |nm|

                                                nm := ns name.
                                                (nm includes:$:) not
                                              ].
        nameSpaceList := (allNamespaces collect:[:ns | ns name])
                            asArray sort asList.
        nameSpaceList addFirst:'* all *'.
    ].
    ^ nameSpaceList
! !

!WebSmalltalkBrowser methodsFor:'frames'!

classCategoryListFrame:aRequest
    |link arguments classCategorySelection|

    arguments := Arguments createFromArgumentsFor:aRequest.
    classCategorySelection := arguments classCategorySelection.
    aRequest 
        reply:'<html>
<head><title>Categories</title></head>
<body LINK="black" VLINK="black">
'.

    self classCategoryList do:[:cc |
        cc = classCategorySelection ifTrue:[
            aRequest
                reply:'<nobr><a NAME="' , cc , '"><b>' , cc , '</b></a></nobr><br>';
                reply:Character cr asString
        ] ifFalse:[
            arguments classCategorySelection:cc.
            link := aRequest linkIdFor:self selector:'classCatSelChanged:' argument:(arguments argumentString).
            
            aRequest
                reply:'<nobr><a NAME="' , cc , '" HREF="' , link , '" TARGET="AllPanels">'; 
                reply: cc;
                reply: '</a></nobr><br>';
                reply:Character cr asString
        ].
    ].
    aRequest pageFinish.
!

classInstToggleFrame:aRequest
    |instLink classLink boldIfClassSelected boldEndIfClassSelected boldIfInstSelected boldEndIfInstSelected arguments|

    boldIfClassSelected := boldEndIfClassSelected := boldIfInstSelected := boldEndIfInstSelected := ''.
    arguments := Arguments createFromArgumentsFor:aRequest.

    (arguments showClass = 'true') ifTrue:[
        boldIfClassSelected := '<b>'.
        boldEndIfClassSelected := '</b>'.
    ] ifFalse:[
        boldIfInstSelected := '<b>'.
        boldEndIfInstSelected := '</b>'.
    ].
    arguments showClass:'false'.
    instLink := aRequest linkIdFor:self selector:'classInstToggle:' argument:arguments argumentString.
    arguments showClass:'true'.
    classLink := aRequest linkIdFor:self selector:'classInstToggle:' argument:arguments argumentString.

    aRequest
        reply:'<html>
<head><title>Untitled</title></head>
<body LINK="black" VLINK="black">
<table BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="100%" NOBORDER>
<tr>
<td VALIGN="center" WIDTH="50%">
<a HREF="' , classLink , '" TARGET="AllPanels">
' , boldIfClassSelected , 'Class' , boldEndIfClassSelected ,'
</a>
</td>

<td VALIGN="center" WIDTH="50%">
<a HREF="' , instLink , '" TARGET="AllPanels">
' , boldIfInstSelected , 'Instance' , boldEndIfInstSelected ,'
</a>
</td>

</tr>
</table>
'.
    aRequest pageFinish.
!

classListFrame:aRequest
    |link classSelection arguments classListForCategory|

    arguments := Arguments createFromArgumentsFor:aRequest.
    classSelection := arguments classSelection.
    classListForCategory := arguments classListForCategory.
    classSelection ~= 'nil' ifTrue:[
        (classListForCategory includes:classSelection) ifFalse:[
            arguments methodSelection:'nil'.
            arguments methodCategorySelection:'nil'.
            arguments classSelection:'nil'.
        ].
"/        self allPanelsFor:aRequest arguments:arguments.
    ].
    aRequest
        reply:'<html>
<head><title>Classes</title></head>
<body LINK="black" VLINK="black">
'.

    classListForCategory do:[:className |
        className = classSelection ifTrue:[
            aRequest
                reply:'<nobr><a NAME="' , className , '"><b>'; 
                reply: className;
                reply: '</b></a></nobr><br>'
        ] ifFalse:[
            arguments classSelection:className.
            link := aRequest linkIdFor:self selector:'classSelChanged:' argument:arguments argumentString.

            aRequest
                reply:'<nobr><a NAME="' , className , '" HREF="' , link , '" TARGET="AllPanels">'; 
                reply: className;
                reply: '</a></nobr><br>'
        ].
    ].
    aRequest pageFinish.
!

codeFrame:aRequest
    |code arguments currentClass|

    arguments := Arguments createFromArgumentsFor:aRequest.
    code := ''.

    arguments methodSelection ~= 'nil' ifTrue:[
        code := arguments methodSource
    ] ifFalse:[
        currentClass := arguments currentClass.
        currentClass notNil ifTrue:[
            code := currentClass definition.
        ]
    ].

    aRequest
        reply:'<html>
<head><title>Code</title></head>
<body BGCOLOR="white" LINK="black" VLINK="black">';
        unformattedCodeTextStart;
        replyEscaped:code; 
        unformattedCodeTextEnd;
        pageFinish.
!

emptyFrame:aRequest
    aRequest
        reply:'<html>
<head><title>Blank</title></head>
<body>
</body>
</html>
'
!

infoFrame:aRequest

    | arguments currentClass currentMethod |
    arguments := Arguments createFromArgumentsFor:aRequest.
    aRequest
        reply:'<html>
<head><title>Info</title></head>
<body>
<table BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="100%" NOBORDER>
<tr>
'.
    arguments classSelection ~= 'nil' ifTrue:[
        currentClass := arguments currentClass.
        ((currentMethod := arguments methodSelection) = 'nil') ifTrue:[
            "/ class revision and package
            aRequest
                reply: '<td VALIGN="center" WIDTH="50%">';
                reply: 'Vsn: ' , currentClass revision printString;
                reply: '</td><td VALIGN="center" WIDTH="50%">';
                reply: currentClass package printString;
                reply: '</td>'.
        ] ifFalse:[
            currentMethod := arguments currentMethod.
            currentMethod notNil ifTrue:[
                aRequest
                    reply: '<td VALIGN="center" WIDTH="50%">';
                    reply: currentMethod package printString;
                    reply: '</td>'.
            ]
        ]
    ].

    aRequest
        reply:'
</tr>
</table>
'.
    aRequest pageFinish.
!

methodCategoryListFrame:aRequest
    |link methodCategorySelection arguments |

    arguments := Arguments createFromArgumentsFor:aRequest.
    methodCategorySelection := arguments methodCategorySelection.
    aRequest
        reply:'<html>
<head><title>Method Categories</title></head>
<body LINK="black" VLINK="black">
'.

    arguments methodCategoryList do:[:mc |
        mc = methodCategorySelection ifTrue:[
            aRequest
                reply:'<nobr>'; 
                reply:'<a NAME="' , mc , '"><b>';
                reply: mc;
                reply: '</b></a>';
                reply: '</nobr><br>'
        ] ifFalse:[
            arguments methodCategorySelection:mc.
            link := aRequest linkIdFor:self selector:'methodCatSelChanged:' argument:arguments argumentString.
            aRequest
                reply:'<nobr>'; 
                reply:'<a NAME="' , mc , '" HREF="' , link , '" TARGET="AllPanels">'; 
                reply: mc;
                reply: '</a>';
                reply: '</nobr><br>'
        ].
    ].
    aRequest pageFinish.
!

methodListFrame:aRequest
    |link arguments methodCategorySelection methodSelection|

    arguments := Arguments createFromArgumentsFor:aRequest.
    methodSelection := arguments methodSelection.
    methodCategorySelection := arguments methodCategorySelection.
    aRequest
        reply:'<html>
<head><title>Methods</title></head>
<body LINK="black" VLINK="black">
'.

    methodCategorySelection ~= 'nil' ifTrue:[
        arguments methodNameList do:[:methodName |
            methodName = methodSelection  ifTrue:[
                aRequest
                    reply:'<nobr><a NAME="' , methodName , '"><B>';
                    reply: methodName;
                    reply: '</b></a></nobr><br>'
            ] ifFalse:[
                arguments methodSelection:methodName.
                link := aRequest linkIdFor:self selector:'methodSelChanged:' argument:arguments argumentString.
                aRequest
                    reply:'<nobr><a NAME="' , methodName , '" HREF="' , link , '" TARGET="AllPanels">'; 
                    reply: methodName;
                    reply: '</a></nobr><br>'
            ].
        ].
    ].
    aRequest pageFinish.
!

namespaceFrame:aRequest

    |arguments classSelection|

    arguments := Arguments createFromArgumentsFor:aRequest.
    classSelection := arguments classSelection.
    aRequest
        reply:'<html>
<head><title>Untitled</title></head>
<body>
<table BORDER="0" CELLSPACING="0" CELLPADDING="0" WIDTH="100%" NOBORDER>
<tr>
<td VALIGN="center" WIDTH="100%">
* all *
'.
"/    classSelection ~= 'nil' ifTrue:[
"/        | nameSpace nameSpaceString |
"/        nameSpace := arguments currentClass nameSpace name asString.
"/        nameSpaceString := '*all*'.
"/        (nameSpace = 'Smalltalk') ifFalse:[
"/            nameSpaceString := nameSpace.
"/        ].
"/        aRequest reply:nameSpaceString.
"/    ].
"/    aRequest
"/        reply:'<!!--
"/<form><select NAME="NameSpace">
"/'.
"/    self nameSpaceList do:[:ns |
"/        aRequest reply:'<option> ' , ns , Character cr
"/    ].
"/    aRequest reply:'</select>
"/</form>
"/-->'.
    aRequest
        reply:'
</td>
</tr>
</table>'.
    aRequest pageFinish.
! !

!WebSmalltalkBrowser methodsFor:'queries-service'!

allowedMessages
    "should not be invoked, because isMessageAllowed is redefined"
!

defaultMessage
    ^ #openAsWebPage 
!

isMessageAllowed:aMessage
    ^ self respondsTo:aMessage
! !

!WebSmalltalkBrowser methodsFor:'selection-change'!

classCatSelChanged:aRequest

    |arguments classListForCategory classSelection|

    arguments := Arguments createFromArgumentsFor:aRequest.
    classSelection := arguments classSelection.
    classListForCategory := arguments classListForCategory.
    classSelection ~= 'nil' ifTrue:[
        (classListForCategory includes:classSelection) ifFalse:[
            arguments methodSelection:'nil'.
            arguments methodCategorySelection:'nil'.
            arguments classSelection:'nil'.
        ].
    ].
    self allPanels:aRequest arguments:arguments.
!

classInstToggle:aRequest

    |methodSelection arguments methodCategorySelection|

    arguments := Arguments createFromArgumentsFor:aRequest.
    methodSelection := arguments methodSelection.
    methodCategorySelection := arguments methodCategorySelection.
    methodCategorySelection ~= 'nil' ifTrue:[
        (arguments methodCategoryList includes:methodCategorySelection) ifTrue:[
            methodSelection ~= 'nil' ifTrue:[
                (arguments methodNameList includes:methodSelection) ifFalse:[
                    arguments methodSelection:'nil'.
                ].
            ].
        ] ifFalse:[
            arguments methodSelection:'nil'.
            arguments methodCategorySelection:'nil'.
        ]

    ].
    self allPanels:aRequest arguments:arguments.
!

classSelChanged:aRequest
    |arguments classListForCategory classSelection|

    arguments := Arguments createFromArgumentsFor:aRequest.
    classSelection := arguments classSelection.
    classListForCategory := arguments classListForCategory.
    classSelection ~= 'nil' ifTrue:[
        (classListForCategory includes:classSelection) ifFalse:[
            arguments methodSelection:'nil'.
            arguments methodCategorySelection:'nil'.
            arguments classSelection:'nil'.
        ].
    ].
    self allPanels:aRequest arguments:arguments.
!

methodCatSelChanged:aRequest

    |arguments methodSelection|

    arguments := Arguments createFromArgumentsFor:aRequest.
    methodSelection := arguments methodSelection.
    methodSelection ~= 'nil' ifTrue:[
        (arguments methodNameList includes:methodSelection) ifFalse:[
            arguments methodSelection:'nil'.
        ].
    ].
    self allPanels:aRequest arguments:arguments.
!

methodSelChanged:aRequest

    |arguments |

    arguments := Arguments createFromArgumentsFor:aRequest.
    self allPanels:aRequest arguments:arguments.
! !

!WebSmalltalkBrowser methodsFor:'settings persistency'!

settingSelectors
    |slots|

    slots := super settingSelectors.
    slots removeAllFoundIn:#(nameSpaceList classCategoryList).
    ^ slots 
! !

!WebSmalltalkBrowser methodsFor:'web startup'!

allPanels:aRequest
    |arguments|

    arguments := Arguments createFromArgumentsFor:aRequest.
    self allPanels:aRequest arguments:arguments
!

allPanels:aRequest arguments:arguments

    aRequest
        reply:'<html>
<head><title>WebBrowser</title>

<frameset ROWS="30%,40,70%">
  <frameset COLS="25%,25%,25%,25%">
    <frame NAME="ClassCategoryListFrame"  SRC="' , (aRequest linkIdFor:self selector:'classCategoryListFrame:'     argument:arguments argumentString), '" SCROLLING="yes">
    <frame NAME="ClassListFrame"          SRC="' , (aRequest linkIdFor:self selector:'classListFrame:'             argument:arguments argumentString), '" SCROLLING="yes">
    <frame NAME="MethodCategoryListFrame" SRC="' , (aRequest linkIdFor:self selector:'methodCategoryListFrame:'    argument:arguments argumentString), '" SCROLLING="yes">
    <frame NAME="MethodListFrame"         SRC="' , (aRequest linkIdFor:self selector:'methodListFrame:'            argument:arguments argumentString), '" SCROLLING="yes">
  </frameset>
  <frameset COLS="25%,25%,50%">
    <frame NAME="NamespaceFrame"          SRC="' , (aRequest linkIdFor:self selector:'namespaceFrame:' argument:arguments argumentString) , '" SCROLLING="no">
    <frame NAME="ClassInstToggleFrame"    SRC="' , (aRequest linkIdFor:self selector:'classInstToggleFrame:' argument:arguments argumentString) , '" SCROLLING="no">
    <frame NAME="InfoFrame"               SRC="' , (aRequest linkIdFor:self selector:'infoFrame:' argument:arguments argumentString) , '" SCROLLING="no">
  </frameset>
  <frame NAME="CodeFrame"                 SRC="' , (aRequest linkIdFor:self selector:'codeFrame:' argument:arguments argumentString) , '" SCROLLING="yes">
</frameset>

</head>
<body>
</body>
</html>
'
!

openAsWebPage:aRequest
    |arguments|

    arguments := Arguments defaultArguments.
    aRequest
        reply:'<html>
<head><title>WebBrowser</title>
</head>

<frameset ROWS="100%,1">
  <frame NAME="AllPanels"  SRC="' , (aRequest linkIdFor:self selector:'allPanels' argument:arguments argumentString) ,'" SCROLLING="no">
  <frame NAME="Dummy"      SRC="' , (aRequest linkIdFor:self selector:'emptyFrame') ,'" SCROLLING="no">
</frameset>

<noframes>
This page requires a browser which supports frames.
</noframes>

<body>
</body>
</head>
'
! !

!WebSmalltalkBrowser::Arguments class methodsFor:'instance creation'!

createFromArgumentsFor:aRequest

    | instance arguments|

    arguments := (aRequest arguments collect:[:eachPart | HTMLUtilities unEscape:eachPart]).
    instance := self new.
    instance classCategorySelection:(arguments at:1).
    instance classSelection:(arguments at:2).
    instance methodCategorySelection:(arguments at:3).
    instance methodSelection:(arguments at:4).
    instance showClass:(arguments at:5).
    ^ instance
!

defaultArguments
    | instance|

    instance := self new.
    instance classCategorySelection:'nil'.
    instance classSelection:'nil'.
    instance methodCategorySelection:'nil'.
    instance methodSelection:'nil'.
    instance showClass:'false'.
    ^ instance
! !

!WebSmalltalkBrowser::Arguments methodsFor:'accessing'!

classCategorySelection
    "return the value of the instance variable 'classCategorySelection' (automatically generated)"

    ^ classCategorySelection
!

classCategorySelection:something
    "set the value of the instance variable 'classCategorySelection' (automatically generated)"

    classCategorySelection := something.
!

classSelection
    "return the value of the instance variable 'classSelection' (automatically generated)"

    ^ classSelection
!

classSelection:something
    "set the value of the instance variable 'classSelection' (automatically generated)"

    classSelection := something.
!

methodCategorySelection
    "return the value of the instance variable 'methodCategorySelection' (automatically generated)"

    ^ methodCategorySelection
!

methodCategorySelection:something
    "set the value of the instance variable 'methodCategorySelection' (automatically generated)"

    methodCategorySelection := something.
!

methodSelection
    "return the value of the instance variable 'methodSelection' (automatically generated)"

    ^ methodSelection
!

methodSelection:something
    "set the value of the instance variable 'methodSelection' (automatically generated)"

    methodSelection := something.
!

showClass
    "return the value of the instance variable 'showClass' (automatically generated)"

    ^ showClass
!

showClass:something
    "set the value of the instance variable 'showClass' (automatically generated)"

    showClass := something.
! !

!WebSmalltalkBrowser::Arguments methodsFor:'queries'!

actualClass

    (self showClass = 'true') ifTrue:[
        ^ self currentClass class
    ].
    ^ self currentClass
!

argumentString

    | stream |

    stream := WriteStream on:''.
    stream nextPutAll:self classCategorySelection.
    stream nextPutAll:','.
    stream nextPutAll:self classSelection.
    stream nextPutAll:','.
    stream nextPutAll:self methodCategorySelection.
    stream nextPutAll:','.
    stream nextPutAll:self methodSelection.
    stream nextPutAll:','.
    stream nextPutAll:self showClass.
    ^ stream contents
!

classListForCategory

    |classList classCategorySelection|
    classCategorySelection := self classCategorySelection.
    classList := Set new.
    Smalltalk allClassesDo:[:aClass |
        aClass category = classCategorySelection ifTrue:[
            classList add:aClass name.
        ]
    ].
    classList := classList asArray sort asList.
    ^ classList
!

currentClass

    (self classSelection = 'nil') ifTrue:[^ nil].
    ^ Smalltalk at:(self classSelection asSymbol).
!

currentMethod

    | methodDict |

    methodDict := self methodDictionary.
    methodDict keysAndValuesDo:[:aMethodName :aMethod|
        aMethodName = self methodSelection ifTrue:[
            ^ aMethod.
        ].
    ].
    ^ nil
!

methodCategoryList
    | methodCategoryList|

    self currentClass isNil ifTrue:[
        ^ #()
    ].

    methodCategoryList := Set new.
    self actualClass methodDictionary keysAndValuesDo:[:methodName :aMethod |
        methodCategoryList add:aMethod category.
    ].
    methodCategoryList := methodCategoryList asArray sort asList.
    ^ methodCategoryList
!

methodDictionary

    | methodDictionary |
    self currentClass isNil ifTrue:[
        ^ #()
    ].
    methodDictionary := Dictionary new.
    (self actualClass) methodDictionary keysAndValuesDo:[:methodName :aMethod |
        aMethod category = self methodCategorySelection ifTrue:[
            methodDictionary at:methodName put:aMethod.
        ].
    ].
    ^ methodDictionary
!

methodNameList

    | methodDict|
    methodDict := self methodDictionary.
    ^ methodDict keys asArray sort asList.
!

methodSource

    | method |

    method := self currentMethod.
    method notNil ifTrue:[
        ^ method source.
    ].
    ^ ''
! !

!WebSmalltalkBrowser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/WebSmalltalkBrowser.st,v 1.35 2010/03/11 13:31:34 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/WebSmalltalkBrowser.st,v 1.35 2010/03/11 13:31:34 stefan Exp $'
! !
