"{ Package: 'stx:goodies/webServer/comanche' }"

"{ NameSpace: Comanche }"

Object subclass:#SimulatedSqueakFileStream
	instanceVariableNames:'realStream'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-STX-Support'
!


!SimulatedSqueakFileStream class methodsFor:'instance creation'!

for:aRealStream
    ^ self new realStream:aRealStream
! !

!SimulatedSqueakFileStream methodsFor:'accessing'!

contents

    ^ realStream contents
!

contentsOfEntireFile
    |s|

    s := realStream contentsOfEntireFile "asString".
    realStream close.
    ^ s
!

position

    ^ realStream position0Based
!

realStream:something
    "set the value of the instance variable 'realStream' (automatically generated)"

    realStream := something.
! !

!SimulatedSqueakFileStream methodsFor:'stream operations'!

atEnd
    ^ realStream atEnd
!

binary

    ^ realStream binary
!

bufferSize
        ^5000
!

close
    realStream close
!

copyFrom: pos1 to: pos2
        self position: pos1 - 1.
        ^self next: pos2 - pos1 + 1
!

findString: subString startingAt: start
        | buffer pos return |
        pos _ start - 1.
        [self atEnd] whileFalse: [
                self position: pos.
                buffer _ self next: self bufferSize.
                return _ buffer findString: subString startingAt: 1.
                (return = 0) ifFalse: [
                        self position:0.
                        ^ pos + return.
                        ].
                pos _ pos + buffer size - subString size].
        ^0 
!

next
    ^ realStream next
!

next:nChars
    ^ realStream nextAvailable:nChars
!

nextByte
    ^ realStream nextByte
!

nextBytes:numBytes 

    ^ realStream nextBytes:numBytes 
!

nextBytes:numBytes into:aCollection startingAt:initialIndex

    ^ realStream nextBytes:numBytes into:aCollection startingAt:initialIndex
!

nextBytes:numBytes into:aCollection startingAt:initialIndex blockSize:blockSize

    ^ realStream nextBytes:numBytes into:aCollection startingAt:initialIndex blockSize:blockSize
!

nextInto:aByteArrayOrString

    ^ realStream nextInto:aByteArrayOrString
!

nextPut:anObject
    ^ realStream nextPut:anObject
!

nextPutAll:aCollection
    ^ realStream nextPutAll:aCollection
!

nextPutAll:aCollection startingAt:start to:stop
    ^ realStream nextPutAll:aCollection startingAt:start to:stop
!

nextShortMSB:msbFlag

    ^ realStream nextShortMSB:msbFlag
!

position:a0BasedPosition
    realStream position0Based:a0BasedPosition
!

setToEnd

    ^ realStream setToEnd
!

size

    ^ realStream size
! !

!SimulatedSqueakFileStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/SimulatedSqueakFileStream.st,v 1.12 2010/03/12 18:23:17 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/SimulatedSqueakFileStream.st,v 1.12 2010/03/12 18:23:17 stefan Exp $'
! !
