"{ Package: 'stx:goodies/webServer/comanche' }"

"{ NameSpace: Comanche }"

Object subclass:#SimulatedSqueakSocketStream
	instanceVariableNames:'status readStream writeStream request'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-STX-Support'
!


!SimulatedSqueakSocketStream class methodsFor:'instance creation'!

new
    ^ self basicNew initialize.
! !

!SimulatedSqueakSocketStream methodsFor:'accessing'!

initialize

    status := Dictionary new.
!

readStream
    "return the value of the instance variable 'readStream' (automatically generated)"

    ^ readStream
!

readStream:something
    "set the value of the instance variable 'readStream' (automatically generated)"

    readStream := something.
!

request:aHttpRequest
    "set the value of the instance variable 'server' (automatically generated)"

    request := aHttpRequest.
    status at: #remoteAddress put:(request peer hostAddress).
!

status
        ^status    
!

writeStream
    "return the value of the instance variable 'writeStream' (automatically generated)"

    ^ writeStream
!

writeStream:something
    "set the value of the instance variable 'writeStream' (automatically generated)"

    writeStream := something.
! !

!SimulatedSqueakSocketStream methodsFor:'queries'!

inBytes 
    "actual number of bytes read by the app"
    ^readStream position
!

remoteAddress

    ^ status at: #remoteAddress
! !

!SimulatedSqueakSocketStream methodsFor:'reading'!

match: aString
        "position past the next occurrence of aString"
        "bolot 12/13/2000 00:49 - must begin with it"
        "answer if aString is found"

        | position compareString size|

        readStream size < aString size
                ifTrue: [self error: #todo. "should try to read in more, unless #atEnd"
                        "but since atEnd is somewhat broken, don't use it yet"
                        ^false].

        (Smalltalk dialectName = 'SmalltalkX') ifTrue:[
            position := readStream position.
            size := aString size.
            size > 0 ifTrue:[
                compareString := readStream next:size.
                compareString = aString ifTrue:[
                    ^ true
                ].
                readStream position:(position - size).
            ]
        ] ifFalse:[
            (readStream contents beginsWith: aString)
                    ifTrue: [readStream next: aString size.
                            ^true].
        ].
        ^false
!

next:count

    ^ readStream next:count
!

nextChunk

    ^ readStream upToEnd.
!

upToAll:aCollection

    ^ readStream upToAll:aCollection
! !

!SimulatedSqueakSocketStream methodsFor:'writing'!

putDataBack:aCollection

    readStream := ReadStream on:aCollection.
! !

!SimulatedSqueakSocketStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/SimulatedSqueakSocketStream.st,v 1.14 2006/10/12 08:43:34 cg Exp $'
! !
