"{ Package: 'stx:goodies/webServer/comanche/chieftain' }"

"{ NameSpace: Comanche }"

Object subclass:#ComancheServer
	instanceVariableNames:'connectionHandler serviceProvider'
	classVariableNames:'Servers'
	poolDictionaries:''
	category:'Kom-kernel'
!

ComancheServer comment:'Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:44

ComancheServer
'
!


!ComancheServer class methodsFor:'initialization'!

initialize
	" ComancheServer initialize "

	Servers _ Dictionary new
! !

!ComancheServer class methodsFor:'instance creation'!

onPort: aNumber priority: pNum serviceProvider: sp
	^super new initializeOnPort: aNumber priority: pNum serviceProvider: sp
! !

!ComancheServer class methodsFor:'accessing'!

serverOnPort: portNumber ifAbsent: absentBlock 
	^self servers at: portNumber ifAbsent: absentBlock
! !

!ComancheServer class methodsFor:'registration'!

portTaken: portNumber
	self servers at: portNumber ifAbsent: [ ^false ].
	^true
!

register: aComancheServer
	self servers at: aComancheServer portNumber ifAbsent: [
		^self servers at: aComancheServer portNumber put: aComancheServer.
	].
	self error: ('A server is already registered on port ', aComancheServer portNumber)
!

servers
	^Servers
!

unregister: aComancheServer
	self servers removeKey: 
		(self servers keyAtIdentityValue: aComancheServer ifAbsent: [ ^self ])
! !

!ComancheServer methodsFor:'accessing'!

connectionHandler
	^connectionHandler
!

portNumber
	self connectionHandler
		ifNotNil: [^self connectionHandler portNumber]
		ifNil: [^nil]
!

priority
	^self connectionHandler priority
!

priority: priorityLevel

	self connectionHandler priority: priorityLevel
!

serviceProvider
	^serviceProvider
! !

!ComancheServer methodsFor:'initialize-release'!

initializeOnPort: aNumber priority: pNum serviceProvider: sp
	connectionHandler ifNotNil: [ connectionHandler stop ].
	connectionHandler _ ConnectionHandler
		onPort: aNumber
		handler: self
		priority: pNum.
	serviceProvider _ sp
! !

!ComancheServer methodsFor:'printing'!

printOn: aStream
	aStream nextPutAll: ('ComancheServer port: ', self portNumber asString).
	self isRunning ifTrue: [
		aStream nextPutAll: ' [running]'
	] ifFalse:[
		aStream nextPutAll: ' [stopped]'
	]
! !

!ComancheServer methodsFor:'private'!

register
	(self class portTaken: self portNumber) ifFalse: [
		self class register: self.
		^self
	].
	self error: ('There is already an active server on port ', self portNumber asString)
!

unregister
	self class unregister: self
!

value: aSocket
	[ self serviceProvider serve: aSocket ] fork
! !

!ComancheServer methodsFor:'queries'!

isRunning
	self connectionHandler
		ifNotNil: [^self connectionHandler isRunning]
		ifNil: [^false]
! !

!ComancheServer methodsFor:'starting and stopping'!

start
	self register.
	Socket initializeNetwork.
	self connectionHandler start
!

stop
	self connectionHandler stop.
	self unregister.
	connectionHandler _ serviceProvider _ nil
! !

!ComancheServer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/chieftain/ComancheServer.st,v 1.1 2003/05/19 19:23:52 cg Exp $'
! !

ComancheServer initialize!
