"{ Package: 'stx:goodies/webServer/comanche/chieftain' }"

"{ NameSpace: Comanche }"

Object subclass:#HtmlComancheForm
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Kom-demo'
!

HtmlComancheForm comment:'bolot 10/18/2001 13:53

- convert a form spec into a form
- convert form input into variables

Example
#(  (search String ''Keyword: '')  (submit SubmitButton ''Search'')
-->
<form action="<%self url%>" method="get">
Keyword: <input type="search">
<input type="submit" name="submit" value="Search">
</form>
'
!


!HtmlComancheForm class methodsFor:'as yet unclassified'!

formElementFromSpec: spec
	"spec is (formFieldName type [label])"

	| type fieldName label |
	type _ spec at: 2.
	fieldName _ spec at: 1.
	label _ spec at: 3 ifAbsent: [fieldName asString].

	type == #Integer
		ifTrue: [^'<input type="text" name="', fieldName asString, '">'].

	type == #SubmitButton
		ifTrue: [^'<input type="submit" name="', label, '" value="', label, '">'].

	^'<input type="hidden" name="', label, '">'
!

formFieldNamed: fieldName specMatrix: specMatrix request: request
	"spec is (formFieldName type [label]), specMatrix is an Array of specs"

	| type label spec |
	spec _ specMatrix detect: [:elem | elem first = fieldName asString] ifNone: [^nil].
	type _ spec at: 2.
	label _ spec at: 3 ifAbsent: [fieldName asString].

	type == #Integer
		ifTrue: [^(request getFields at: fieldName asString) asInteger].

	type == #SubmitButton
		ifTrue: [^request getFields includesKey: fieldName asString].

	^nil
! !

!HtmlComancheForm class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/chieftain/HtmlComancheForm.st,v 1.1 2003/05/19 19:10:51 cg Exp $'
! !
