"{ Package: 'stx:goodies/webServer/comanche/chieftain' }"

"{ NameSpace: Comanche }"

Object subclass:#HttpSession
	instanceVariableNames:'id attributes timestamp'
	classVariableNames:'LastSessionID'
	poolDictionaries:''
	category:'Kom-protocol HTTP'
!

HttpSession comment:'kom/4.12 (Comanche/4.12)

I''m a Session in  a Http connection.'
!


!HttpSession class methodsFor:'instance creation'!

new
^ super new initialize
! !

!HttpSession class methodsFor:'class initialization'!

initialize
	LastSessionID _ Time totalSeconds.
! !

!HttpSession class methodsFor:'session id'!

nextSessionID
	self flag: #TODO.
	"more robust unique number"
	LastSessionID _ LastSessionID + 1.
	^ (65535 atRandom hex allButFirst: 3)
		, (LastSessionID hex allButFirst: 3)
		, (65535 atRandom hex allButFirst: 3)
! !

!HttpSession methodsFor:'accessing'!

attributes
"answer the attributes stored in Session"
	^ attributes
!

id
^id
!

timestamp:aNumber
timestamp _ aNumber
! !

!HttpSession methodsFor:'asking'!

usedSince: deadLineNumber 
	^ timestamp  < deadLineNumber
! !

!HttpSession methodsFor:'initialization'!

initialize
	attributes _ Dictionary new.
id _ self class nextSessionID
! !

!HttpSession methodsFor:'printing'!

printOn: aStream 
	aStream nextPutAll: self class name;
nextPutAll: ' id:';
		 nextPutAll: id asString;
nextPutAll: ' attributes:';
		 nextPutAll: attributes asString;
nextPutAll: ' timestamp:';
		 nextPutAll: timestamp asString
! !

!HttpSession methodsFor:'user authentication'!

userObject
	^self attributes at: 'userObject' ifAbsent: []
!

userObject: anObject
	^self attributes at: 'userObject' put: anObject
!

username
	^self attributes at: 'username' ifAbsent: []
!

username: aName
	^self attributes at: 'username' put: aName
! !

!HttpSession class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/chieftain/HttpSession.st,v 1.1 2003/05/19 19:13:07 cg Exp $'
! !

HttpSession initialize!
