"{ Package: 'stx:goodies/webServer/comanche/chieftain' }"

"{ NameSpace: Comanche }"

ComancheServer subclass:#LTDComancheServer
	instanceVariableNames:'maxThreads ltdSema'
	classVariableNames:''
	poolDictionaries:''
	category:'Kom-kernel'
!

LTDComancheServer comment:'Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:45

LTDComancheServer
- based on Lex Spoon''s limitConnections change set
-- except that it creates a subclass of ComancheServer
-- ... and renames inst vars
- maxThreads - how many connections to handle simultaneously
- ltdSema - semaphore that only allows maxThreads connections

Inst Vars:
	maxThreads		#(Integer SmallInteger)
	ltdSema			#(Semaphore)
'
!


!LTDComancheServer methodsFor:'initialize-release'!

limitConnectionsTo: anInteger
	"limit to anInteger number of connections"
	maxThreads := anInteger
! !

!LTDComancheServer methodsFor:'private'!

value: aSocket
	"handle a new connection"
	ltdSema wait.
	[
		[ self serviceProvider serve: aSocket  ]
			ensure:
		[ ltdSema signal ].
	] fork
! !

!LTDComancheServer methodsFor:'starting and stopping'!

start
	self register.
	Socket initializeNetwork.
	maxThreads ifNotNil: [ 
		ltdSema := Semaphore new.
		maxThreads timesRepeat: [ ltdSema signal ] ].
	self connectionHandler start
! !

!LTDComancheServer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/chieftain/LTDComancheServer.st,v 1.1 2003/05/19 19:09:30 cg Exp $'
! !
