"{ Package: 'stx:goodies/webServer/comanche/chieftain' }"

"{ NameSpace: Comanche }"

Object subclass:#ObjectUrlMap
	instanceVariableNames:''
	classVariableNames:'Index Map'
	poolDictionaries:''
	category:'Kom-demo'
!


!ObjectUrlMap class methodsFor:'as yet unclassified'!

at: url
	^self map at: url
!

at: url ifAbsent: aBlock
	^self map at: url ifAbsent: aBlock
!

autoMap: obj
	| url |
	url _ '/comanche/objects/', self nextObjectID asString.
	self map: obj toUrl: url.
	^url
!

map
	^Map ifNil: [Map _ Dictionary new]
!

map: obj toUrl: url
	self map at: url put: obj
!

nextObjectID
	Index ifNil: [Index _ 0].
	^Index _ Index + 1
!

objList
	^String streamContents: [:strm |
		strm nextPutAll: '<html><head><title>Object URL Map List</title></head><body><table border="1">'.
		self map keysAndValuesDo: [:url :obj |
			strm nextPutAll: '<tr><td>', (url copyFrom: 19 to: url size), '</td><td><a href="',
				url asString, '">', obj asString, '</a></td></tr>', String crlf].
		strm nextPutAll: '</table></body></html>'.
	]
!

process: request
	| obj |
	obj _ self at: request url ifAbsent: [nil].
	request url = '/comanche/objects/list'
		ifTrue: [^self objList].
	^(obj respondsTo: #process:)
		ifTrue: [obj process: request]
		ifFalse: [obj]
!

urlForObject: obj
	^self map keyAtValue: obj
!

urlForObject: obj ifAbsent: aBlock
	^self map keyAtValue: obj ifAbsent: aBlock
! !

!ObjectUrlMap class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/chieftain/ObjectUrlMap.st,v 1.1 2003/05/19 19:09:21 cg Exp $'
! !
