"{ Package: 'stx:goodies/webServer/comanche/chieftain' }"

"{ NameSpace: Comanche }"

ComancheServer subclass:#PWSComancheServer
	instanceVariableNames:'portNumber serverProcess priority'
	classVariableNames:''
	poolDictionaries:''
	category:'Kom-kernel'
!

PWSComancheServer comment:'Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:46

PWSComancheServer
- a version of ComancheServer that works like PWS
-- i.e., using ConnectionQueue
'
!


!PWSComancheServer methodsFor:'accessing'!

portNumber
	^portNumber
!

priority
	^priority
!

priority: aNum
	"do nothing"
! !

!PWSComancheServer methodsFor:'initialize-release'!

initializeOnPort: aNumber priority: pNum serviceProvider: sp
	connectionHandler ifNotNil: [ connectionHandler destroy ].
	portNumber _ aNumber.
	priority _ pNum.
	serviceProvider _ sp
!

serverLoop
	"see PWS class>>loopOnPort:loggingTo:"

	| socket |
	[true] whileTrue: [
		socket _ connectionHandler getConnectionOrNil.
		socket notNil
			ifTrue: [self value: socket]
			ifFalse: [(Delay forMilliseconds: 100) wait]
	]
! !

!PWSComancheServer methodsFor:'queries'!

isRunning
	^self connectionHandler notNil
! !

!PWSComancheServer methodsFor:'starting and stopping'!

start
	self register.
	Socket initializeNetwork.
	connectionHandler _ ConnectionQueue portNumber: portNumber queueLength: 6.
	serverProcess _ [self serverLoop] newProcess.
	serverProcess priority: Processor lowIOPriority.
	serverProcess resume.
!

stop
	self connectionHandler ifNotNil: [self connectionHandler destroy].
	serverProcess ifNotNil: [serverProcess terminate].
	self unregister.
	connectionHandler _ serviceProvider _ nil
! !

!PWSComancheServer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/chieftain/PWSComancheServer.st,v 1.1 2003/05/19 19:07:52 cg Exp $'
! !
