"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

Object subclass:#HVHtmlElement
	instanceVariableNames:'prefix suffix'
	classVariableNames:''
	poolDictionaries:''
	category:'HV-base'
!

HVHtmlElement comment:'Base class for all elements, nothing much yet.'
!


!HVHtmlElement methodsFor:'accessing'!

prefix: aString
	prefix _ aString
!

suffix: aString
	suffix _ aString
! !

!HVHtmlElement methodsFor:'decorations'!

error: aString
	"Add <aString> formatted as an error in bold red as suffix."

	suffix _ '&nbsp;<b><font color="red">', aString, '</font></b>'
!

success: aString
	"Add <aString> formatted as a message in bold green as suffix."

	suffix _ '&nbsp;<b><font color="green">', aString, '</font></b>'
! !

!HVHtmlElement methodsFor:'rendering'!

renderFullOn: aStream
	"Any prefix/suffix is added if they are not nil."

	prefix ifNotNil: [aStream nextPutAll: prefix].
	self renderOn: aStream.
	suffix ifNotNil: [aStream nextPutAll: suffix]
! !

!HVHtmlElement methodsFor:'testing'!

isForm
	^false
! !

!HVHtmlElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVHtmlElement.st,v 1.1 2003/05/19 18:48:00 cg Exp $'
! !
