"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

HVHtmlElement subclass:#HVHtmlForm
	instanceVariableNames:'name action enctype method elements id'
	classVariableNames:''
	poolDictionaries:''
	category:'HV-base'
!

HVHtmlForm comment:'A Form. Currently this object has a method for rendering and it keeps track of the ids of the fields in the form.'
!


!HVHtmlForm class methodsFor:'instance creation'!

getAction: action

	^self new action: action method: 'get' name: nil
!

postAction: action

	^self new action: action method: 'post' name: nil
!

postAction: action enctype: type

	^self new action: action method: 'post' name: nil; enctype: type
! !

!HVHtmlForm methodsFor:'accessing'!

enctype
	^enctype
!

enctype: type
	enctype _ type
!

id
	^id
!

id: anId
	id _ anId
! !

!HVHtmlForm methodsFor:'elements'!

add: anHtmlElement
	^elements add: anHtmlElement
!

nextVarName
	"We take our own numeric id and tack on a numeric id
	for our elements."

	^(id fullPrintString, '-',  (elements size + 1) fullPrintString) asSymbol
! !

!HVHtmlForm methodsFor:'initialize-release'!

action: anAction method: aMethod name: aName

	action _ anAction.
	method _ aMethod.
	name _ aName.
	elements _ OrderedCollection new
! !

!HVHtmlForm methodsFor:'rendering'!

renderEndOn: stream

	stream nextPutAll: '</form>'
!

renderOn: stream

	stream
		nextPutAll: '<form action="';
		nextPutAll: action;
		nextPutAll: '" method="', method, '"'.
	enctype ifNotNil: [stream nextPutAll: ' enctype="', enctype, '"'].
	stream nextPut: $>
! !

!HVHtmlForm methodsFor:'testing'!

ifSubmit: aBlock
	0 halt.
!

isForm
	^true
! !

!HVHtmlForm class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVHtmlForm.st,v 1.1 2003/05/19 18:47:32 cg Exp $'
! !
