"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

HVHtmlVariable subclass:#HVHtmlSelect
	instanceVariableNames:'size objects values labels nilLabel labelSelector'
	classVariableNames:''
	poolDictionaries:''
	category:'HV-base'
!

HVHtmlSelect comment:'A drop down menu.'
!


!HVHtmlSelect class methodsFor:'instance creation'!

name: aName objects: objects values: values size: size nilLabel: label selector: sel value: aValue 
	^super new name: aName value: aValue;
		objects: objects values: values size: size nilLabel: label selector: sel; yourself
! !

!HVHtmlSelect methodsFor:'accessing'!

multiple
	^value isCollection
!

objects
	^objects
!

objects: objs values: vals size: s nilLabel: label selector: sel
	objects _ objs.
	values _ vals.
	size _ s.
	nilLabel _ label.
	sel ifNil: [labelSelector _ #name] ifNotNil: [labelSelector _ sel].
	labels _ objects
				collect: [:obj | obj
						ifNil: [nilLabel]
						ifNotNil: [
							(obj isKindOf: String)
								ifTrue:[obj]
								ifFalse:[obj perform: labelSelector]]]
!

renderOn: stream
	"Render the select as HTML."

	| current multiple |
	multiple _ self multiple.
	stream nextPutAll: '<select name="', name, '" size="', size printString , (multiple ifTrue: ['" multiple>'] ifFalse: ['">']).
	1 to: objects size do: [:n |
		current _ values ifNil: [objects at: n] ifNotNil: [values at: n].
		(multiple ifTrue: [value includes: current] ifFalse: [current = value])
			ifTrue: [stream nextPutAll: '<option selected']
			ifFalse: [stream nextPutAll: '<option' ].
		stream nextPutAll: ' value="'.
		values ifNil: [n printOn: stream] ifNotNil: [stream nextPutAll: (values at: n) asString].
		stream nextPutAll: ' ">'.
		stream nextPutAll: (labels at: n).
		stream nextPutAll: '</option>'.
	].
	stream nextPutAll: '</select>'
!

size
	^size
!

size: aSize
	size _ aSize
! !

!HVHtmlSelect class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVHtmlSelect.st,v 1.1 2003/05/19 18:49:31 cg Exp $'
! !
