"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

HVHtmlElement subclass:#HVHtmlVariable
	instanceVariableNames:'value name'
	classVariableNames:''
	poolDictionaries:''
	category:'HV-base'
!

HVHtmlVariable comment:'An abstract base class for elements that has a name and carry a value.

Can be used to embed dynamic values in HTML pages (subclass HVSimpleVariable) but it is also the base class for all Form elements like input fields etc.'
!


!HVHtmlVariable class methodsFor:'instance creation'!

name: aName value: aValue
	^super new name: aName value: aValue; yourself
! !

!HVHtmlVariable methodsFor:'accessing'!

name
	^name
!

name: aName
	name _ aName
!

value
	^value
!

value: aVal
	value _ aVal
! !

!HVHtmlVariable methodsFor:'initialize-release'!

initialize
	
! !

!HVHtmlVariable methodsFor:'private'!

name: aName value: aValue
	name _ aName.
	value _ aValue
! !

!HVHtmlVariable methodsFor:'rendering'!

renderOn: stream
	"My subclasses should implement this."

	self subclassResponsibility 
! !

!HVHtmlVariable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVHtmlVariable.st,v 1.1 2003/05/19 18:48:55 cg Exp $'
! !
