"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

Object subclass:#HVModule
	instanceVariableNames:'model prefix'
	classVariableNames:''
	poolDictionaries:''
	category:'HV-base'
!

HVModule comment:'This is the Comanche module for the HttpView framework. It holds onto the top domain object
for the webapplication in the instvar ''model''.

Use these doits to start and stop an application (example from SqueakDot):

"Create the top domain object for your application once and for all"
Smalltalk at: #SqueakDot put: SDServer new

"Start up the service"
| service smodule |
service := ComancheNetService named: ''SqueakDot'' onPort: 8080.
service module: (smodule _ HttpSessionModule module: (SDModule on: SqueakDot prefix: ''/squeakdot'')).
SqueakDot module: smodule. "this is a hack to that the SDServer can get access to the sessions"
service start

"And to stop it"
(ComancheNetService serviceNamed: ''SqueakDot'') unregister

"Check which services are alive"
ComancheNetService services'
!


!HVModule class methodsFor:'instance creation'!

on: aModel prefix: prefix
	^self new model: aModel; prefix: prefix; yourself
! !

!HVModule methodsFor:'comanche'!

model: aModel
	"Set the top domain object for the web application."

	model _ aModel
!

parent
	"Sorry, we don't have one."

	^nil
!

prefix
	"Get the prefix that must match on the url for this module to handle the request."

	^prefix
!

prefix: aPrefix
	"Set the prefix that must match on the url for this module to handle the request."

	prefix _ aPrefix
!

process: request
	"Process the request. This is the method that is called by Comanche.
	We instantiate a view for our model and simply
	sticks the request into him and let him take over."

	| url view |
	url _ request url.
	(prefix isEmpty or: [url beginsWith: prefix]) ifFalse: [^nil].
	(url findString: 'tms') = 0 ifFalse:[ request propertyAt: #startTime put: Time millisecondClockValue ].
	view _ model viewFor: self.
	view request: request. "normally not needed when using #viewFor: but here it is"
	^view dispatch
!

request
	"Sorry, we don't have one."

	^nil
!

sessionTimedOut: session
	(model respondsTo: #sessionTimedOut:) ifTrue:[ model sessionTimedOut: session ]
! !

!HVModule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVModule.st,v 1.1 2003/05/19 18:49:22 cg Exp $'
! !
