"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

HVSimpleVariable subclass:#HVTableOfContents
	instanceVariableNames:'topEntries builder baseUrl openImageUrl closedImageUrl
		leafImageUrl'
	classVariableNames:''
	poolDictionaries:''
	category:'HV-base'
!


!HVTableOfContents class methodsFor:'instance creation'!

name: aName value: aValue builder: aBuilder
	^super new name: aName value: aValue builder: aBuilder; yourself
! !

!HVTableOfContents methodsFor:'accessing'!

baseUrl: url
	baseUrl _ url
!

name: aName label: aLabel
	"Add a new top level entry in the TOC.
	Return the entry."

	^topEntries add: (HVTableOfContentsEntry name: aName label: aLabel parent: self)
! !

!HVTableOfContents methodsFor:'initialize-release'!

name: aName value: aValue builder: aBuilder
	topEntries _ OrderedCollection new.
	builder _ aBuilder.
	name _ aName.
	value _ aValue.
	openImageUrl _ '/static/open.gif'.
	closedImageUrl _ '/static/closed.gif'.
	leafImageUrl _ '/static/leaf.gif'
!

open: oUrl closed: cUrl leaf: lUrl
	openImageUrl _ oUrl.
	closedImageUrl _ cUrl.
	leafImageUrl _ lUrl
! !

!HVTableOfContents methodsFor:'rendering'!

closedImageUrl
	^closedImageUrl
!

expanded
	"Return all names that should be expanded.
	We retrieve the cookie and convert it to a Set of Symbols."

	| attrs toc tocSym |
	tocSym _ builder view tocSymbol.
	attrs _ builder request session attributes.
	toc _ attrs at: tocSym ifAbsent:[attrs at: tocSym put: ''].
	^((toc findTokens: $,) collect: [:s | s asSymbol]) asSet
!

fullName
	^baseUrl
!

leafImageUrl
	^leafImageUrl
!

openImageUrl
	^openImageUrl
!

renderOn: stream
	"Render the TOC. If we are empty we act as a simple
	variable instead."

	| expanded |
	topEntries isEmpty ifTrue:[^super renderOn: stream]. "no items to render, take the value instead"
	expanded _ self expanded.
	topEntries do: [:entry |
		entry renderOn: stream expanded: expanded level: 0 builder: builder]
! !

!HVTableOfContents class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVTableOfContents.st,v 1.1 2003/05/19 18:49:13 cg Exp $'
! !
