"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

Object subclass:#HVTableOfContentsEntry
	instanceVariableNames:'name label parent children'
	classVariableNames:''
	poolDictionaries:''
	category:'HV-base'
!


!HVTableOfContentsEntry class methodsFor:'instance creation'!

name: aSymbol label: aString parent: aToc
	^self new name: aSymbol label: aString parent: aToc
! !

!HVTableOfContentsEntry methodsFor:'entries'!

name: aName label: aLabel
	"Add a new top level entry in the TOC.
	Return the entry."

	children ifNil: [children _ OrderedCollection new].
	^children add: (HVTableOfContentsEntry name: aName label: aLabel parent: self)
! !

!HVTableOfContentsEntry methodsFor:'initialize-release'!

name: aSymbol label: aString parent: aToc
	name _ aSymbol.
	parent _ aToc.
	label _ aString
! !

!HVTableOfContentsEntry methodsFor:'rendering'!

closedImageUrl
	^parent closedImageUrl
!

fullName
	| str |
	str _ parent fullName.
	^(str isEmpty or: [str last = $/]) ifTrue: [str, name] ifFalse: [str, '/', name]
!

leafImageUrl
	^parent leafImageUrl
!

openImageUrl
	^parent openImageUrl
!

renderOn: stream expanded: expanded level: aLevel builder: aBuilder
	"Render entry."

	| url view |
	view _ aBuilder view.
	aLevel timesRepeat: [stream nextPutAll: '&nbsp;&nbsp;&nbsp;'].
	url _ self fullName.
	children isEmptyOrNil 
		ifTrue:[stream
				nextPutAll: (aBuilder getLink: url text: (aBuilder getImage: self leafImageUrl));
				nextPutAll: '&nbsp;';
				nextPutAll: (aBuilder getLink: url text: label);
				nextPutAll: '<br />']
		ifFalse:[
			(expanded includes: name)
				ifTrue:[
					stream
						nextPutAll: (view linklocal: '/collapsetoc?entry=', name text: (aBuilder getImage: self openImageUrl));
						nextPutAll: '&nbsp;';
						nextPutAll: (aBuilder getLink: url text: label);
						nextPutAll: '<br />'.
					children do: [:child |
						child renderOn: stream expanded: expanded level: aLevel + 1 builder: aBuilder]]
				ifFalse:[
					stream
						nextPutAll: (view linklocal: '/expandtoc?entry=', name text: (aBuilder getImage: self closedImageUrl));
						nextPutAll: '&nbsp;';
						nextPutAll: (aBuilder getLink: url text: label);
						nextPutAll: '<br />']].
	
! !

!HVTableOfContentsEntry class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVTableOfContentsEntry.st,v 1.1 2003/05/19 18:49:04 cg Exp $'
! !
