"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

HVModule subclass:#HVTodoListModule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HV-sample'
!

HVTodoListModule comment:'This is the Comanche module for the todolist application.
It holds onto the HVTodoList in the instvar ''model'' and implements a single method for view creation.

Use these doits to start and stop the application:

"Create the top domain object for your application once and for all"
Smalltalk at: #TodoList put: HVTodoList new

"Start up the service"
(ComancheNetService named: ''TodoList'' onPort: 8888) module: (HVTodoListModule on: TodoList prefix: ''/todo''); start

"And to stop it"
(ComancheNetService serviceNamed: ''TodoList'') unregister

"Check which services are alive"
ComancheNetService services'
!


!HVTodoListModule methodsFor:'views'!

todoListViewOn: aTodoList
	"Wrap it in a view.
	NOTE: We have no request to set here - it will be inserted
	in #process:. Since we are being called in multiple Processes we can't hold onto
	th request in an instvar."

	^HVTodoListView on: aTodoList parent: self
! !

!HVTodoListModule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVTodoListModule.st,v 1.1 2003/05/19 18:50:16 cg Exp $'
! !
