"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

HVHttpView subclass:#HVTodoListView
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HV-sample'
!

HVTodoListView comment:'This is the view on the HVTodoList. 

It implements a trivial initialize method in order to set the prefix. It then implements two urls:

- The default page which shows the todolist and has a form for adding items and links for removing items.
- The removeitem page which is the method called when a remove link is clicked. It redirects back to the default page.'
!


!HVTodoListView methodsFor:'initialize-release'!

default
	"This is the default method that is run in an HVHttpView
	when no other method has been named in the url.
	It can also be reached by it's name 'default'."

	| b item count |
	b _ self builder.
	b start; h1: 'Todo list'.
	count _ 1.
	b ol: model items do: [:i |
		b linkLocal: '/removeitem?id=', count fullPrintString text: 'R'.
		b html: ' ', i.
		count _ count + 1].
	item _ b postForm; html: 'Add item: '; inputTextSize: 40.
	b submit; endForm; hr; srcLink; end.
	b ifSubmit: [
		model addItem: item value.
		"^self redirectToDefault"
	].
	^b
!

initialize
	"We set the title of the view - it will show up as the page title.
	We also set the prefix of this view - in this case it is empty."

	title _ 'Todo'.
	prefix _ ''
!

removeitem
	"Remove an item in the todolist. We pick out
	the index from the url."

	| id removeItem |
	id _ (req getFields at: 'id') asNumber.
	removeItem _ model items at: id.
	model removeItem: removeItem.
	^self redirectToDefault
! !

!HVTodoListView class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HVTodoListView.st,v 1.1 2003/05/19 18:48:37 cg Exp $'
! !
