"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

HVTransientView subclass:#HVHelloWorld
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'HV-sample'
!

!HVHelloWorld class methodsFor:'documentation'!

documentation
"
    This is the minimal web app in HttpView consisting of a single class
    inheriting from HVTransientView with a single method called #default.

    Well, I added a second variation in method #hello too. :)

    You can start the app by simply sending messages to the class:

        HVHelloWorld start
    or
        HVHelloWorld startDebug

    ...and stop it:

        HVHelloWorld stop

    When it is running, surf in at http://localhost:8080 or http://localhost:8080/hello to see it in action!!

    Notes:
    - The port 8080 is the defaultPort, if you want another port just override that class side method or use startOn:.
    - As you can see the path in the url maps automatically to the method name. Just add another method!!
    - #startDebug is better than #start when doing development, any bugs will open up the debugger.
    - You can stop all apps using #stopAll. 
"
! !

!HVHelloWorld methodsFor:'urls'!

default
    "The shortest Hello World.
    This is the default method that is run in an HVHttpView
    when no other method has been named in the url.
    It can also be reached by it's name 'default'.
    String implements #asHttpResponseTo: so
    it will be converted to a proper HttpResponse just before being
    handed back to Comanche."

    ^'Hello world!!'

    "Created: / 23-11-2006 / 11:31:53 / cg"
!

hello
    "A slightly longer version using HVHtmlBuilder.
    This is how you normally build HTML pages:
        - Get the builder
        - Feed it with messages to create HTML
        - Return it to Comanche, it will then render the page."

    | builder |
    builder := self builder.
    builder 
        start; 
          h1: 'Hello world!!';
          p: 'It is a brand new day.';
          hr; 
          srcLink; 
        end.
    ^builder

    "Created: / 23-11-2006 / 11:32:13 / cg"
! !

!HVHelloWorld class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HV__HVHelloWorld.st,v 1.1 2006/11/24 11:05:39 cg Exp $'
! !
