"{ Package: 'stx:goodies/webServer/comanche/htmlview' }"

"{ NameSpace: HV }"

Object subclass:#HVUrlStream
	instanceVariableNames:'url stream'
	classVariableNames:''
	poolDictionaries:''
	category:'HV-base'
!


!HVUrlStream class methodsFor:'instance creation'!

on: aUrl
    "Return a stream on the url."

    ^self new url: aUrl

    "Created: / 24-11-2006 / 00:14:28 / cg"
!

onString: aUrlString
    "Return a stream on the url."

    ^self new url: (URL fromString:aUrlString "Url absoluteFromText: aUrlString")

    "Created: / 24-11-2006 / 00:14:19 / cg"
! !

!HVUrlStream methodsFor:'accessing'!

url: aUrl

    url := aUrl.
    Smalltalk isSmalltalkX ifTrue:[
        "/ skip "/" and first (link) component; thats a copyFrom:3
        stream := ReadStream on: (((UnixFilename components:aUrl path) copyFrom:2) copyWith: nil).
    ] ifFalse:[
        stream := ReadStream on: (aUrl path copyWith: nil)
    ]

    "Modified: / 24-11-2006 / 00:57:47 / cg"
! !

!HVUrlStream methodsFor:'private'!

decode: aString
    |unescapedString|

    unescapedString := Smalltalk isSmalltalkX 
            ifTrue:[HTTPRequest unEscape:aString]
            ifFalse:[aString unescapePercents utf8ToIso isoToSqueak].

    ^aString ifNotNil: [unescapedString]

    "Created: / 24-11-2006 / 00:38:43 / cg"
! !

!HVUrlStream methodsFor:'streaming'!

next
    "Return the next path part.
    nil is used as a last element marker."

    ^self decode: stream next

    "Created: / 24-11-2006 / 00:38:26 / cg"
!

position

    ^stream position

    "Created: / 24-11-2006 / 00:16:16 / cg"
! !

!HVUrlStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/htmlview/HV__HVUrlStream.st,v 1.1 2006/11/24 11:04:30 cg Exp $'
! !
