"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

Object subclass:#SeasidePlatformSupport
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Platform'
!


!SeasidePlatformSupport class methodsFor:'as yet unclassified'!

base64Decode: aString
	^ (Base64MimeConverter mimeDecodeToChars: aString readStream) contents
		
!

deliverMailFrom: fromAddress to: recipientList text: messageText
	SMTPClient
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: self smtpServer
!

ensureAuthorInitials: aBlock
	Utilities authorInitialsPerSe isEmpty
		ifTrue: [Utilities setAuthorInitials: aBlock value].
!

mimeDocumentClass
	^ MIMEDocument 
!

profileSendsDuring: aBlock
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.	
	^ String streamContents: 
			[:stream | 
			(MessageTally new)
				spyEvery: 1
				on: [aBlock value. Smalltalk garbageCollectMost];
				report: stream]
!

readWriteStream
        Smalltalk isSmalltalkX ifTrue:[
            ^ WriteStream on: String new
        ].

        ^ RWBinaryOrTextStream on: String new
!

smtpServer
	^ MailSender smtpServer
!

vmStatisticsReportString
	^ Utilities vmStatisticsReportString 
!

weakDictionaryOfSize: aNumber
        | dict |

        Smalltalk isSmalltalkX ifTrue:[
            ^ WeakIdentityDictionary new: aNumber.
        ].

        dict _ WeakIdentityKeyDictionary new: aNumber.
        WeakArray addWeakDependent: dict.
        ^ dict
! !

!SeasidePlatformSupport class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/SeasidePlatformSupport.st,v 1.3 2004/09/22 00:26:03 cg Exp $'
! !
