"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WARegistry subclass:#WAApplication
	instanceVariableNames:'configuration libraries sessionClass'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Session'
!


!WAApplication class methodsFor:'as yet unclassified'!

description
	^ 'Seaside Application'
!

path: pathString
	^ self new basePath: pathString
! !

!WAApplication methodsFor:'accessing'!

baseUrl
	^ super baseUrl
		port: (self preferenceAt: #serverPort);
		hostname: (self preferenceAt: #serverHostname);
		scheme: (self preferenceAt: #serverProtocol);
		yourself
!

configurationComponent
	^ WAApplicationEditor new application: self
!

defaultLibraries
	^ Array with: WAStandardScripts with: WAStandardStyles
!

libraries
	^ libraries ifNil: [libraries _ OrderedCollection withAll: self defaultLibraries]
!

name
	| segments |
	segments _ basePath findTokens: '/'.
	^ segments isEmpty
		ifTrue: ['']
		ifFalse: [segments last ]
! !

!WAApplication methodsFor:'basic configuration'!

sessionClass
	^ configuration valueAt: #sessionClass
! !

!WAApplication methodsFor:'preferences'!

configuration
	^ configuration ifNil: [configuration _ WAUserConfiguration new addAncestor: self defaultAncestor]
!

defaultAncestor
	"yes, breaking layering"
	^ WARenderLoopConfiguration localConfiguration
!

preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol
!

preferenceAt: aSymbol put: anObject
	^ self configuration valueAt: aSymbol put: anObject
! !

!WAApplication methodsFor:'request handling'!

handleDefaultRequest: aRequest
	|session|
	session _ self sessionClass application: self.
	^ session handleRequest: aRequest
!

updateRoot: anHtmlRoot
	anHtmlRoot title = '' ifTrue: [anHtmlRoot title: self basePath].
	self libraries do: [:ea | ea updateRoot: anHtmlRoot]
! !

!WAApplication class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAApplication.st,v 1.1 2004/09/21 22:45:35 cg Exp $'
! !
