"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAConfigurationEditor subclass:#WAApplicationEditor
	instanceVariableNames:'application library'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Tools'
!


!WAApplicationEditor methodsFor:'accessing'!

application: anApplication
	application _ anApplication.
	configuration _ application configuration.
! !

!WAApplicationEditor methodsFor:'actions'!

select: aConfiguration
	self call: (WAConfigurationBrowser new
				pool: (WASystemConfigurationPool default);
				select: aConfiguration;
				yourself)
! !

!WAApplicationEditor methodsFor:'rendering'!

addLibrary
	application libraries add: library
!

allLibraries
	^ WAStyleLibrary subclasses, WAScriptLibrary subclasses
!

libraryOptions
	^ self allLibraries difference: application libraries
!

renderContentOn: html
	html heading: 'Application: ', application name.

	super renderContentOn: html.
!

renderFormOn: html
		html text: 'Base Path: '.
		html textInputOn: #basePath of: application.
		
		html heading: 'Libraries' level: 2.
		self libraryOptions isEmpty ifFalse:
			[html text: 'Add Library: '.
			html
				selectFromList: self libraryOptions
				selected: nil
				callback: [:v | library _ v].
			html space.
			html submitButtonWithAction: [self addLibrary] text: 'Add'.].
		html list: application libraries do:
			[:ea |
			html text: ea.
			html space.
			html anchorWithAction: [application libraries remove: ea] text: '(remove)'].
		
		super renderFormOn: html
! !

!WAApplicationEditor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAApplicationEditor.st,v 1.2 2009/08/15 07:35:23 cg Exp $'
! !
