"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

Object subclass:#WACookie
	instanceVariableNames:'key value path expiry'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-HTTP'
!


!WACookie class methodsFor:'as yet unclassified'!

key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself
! !

!WACookie methodsFor:'as yet unclassified'!

expireIn: aDuration
	self expiry: DateAndTime now + aDuration
!

expiry
	^ expiry
!

expiry: aDateTime
	expiry _ aDateTime asUTC
!

expiryString
	^ String streamContents:
		[:s |
		s
			nextPutAll: (expiry dayOfWeekName first: 3);
			nextPutAll: ', ';
			nextPutAll: expiry dayOfMonth asString;
			nextPut: $-;
			nextPutAll: expiry monthName;
			nextPut: $-;
			nextPutAll: expiry year asString;
			space;
			nextPutAll: expiry hour24 asString;
			nextPut: $:;
			nextPutAll: expiry minute asString; 
			nextPut: $:;
			nextPutAll: expiry second asString;
			nextPutAll: ' GMT']
!

key
	^ key
!

key: aString
	key _ aString
!

path
	^ path ifNil: ['/']
!

path: aString
	path _ aString
!

value
	^ value
!

value: aString
	value _ aString
!

valueWithExpiry
	^ expiry
		ifNil: [self value]
		ifNotNil: [self value, '; expires=', self expiryString]
! !

!WACookie class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WACookie.st,v 1.1 2004/09/21 22:49:16 cg Exp $'
! !
