"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAEntryPoint subclass:#WADispatcher
	instanceVariableNames:'entryPoints'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-RequestHandler'
!

WADispatcher class instanceVariableNames:'default'

"
 No other class instance variables are inherited by this class.
"
!


!WADispatcher class methodsFor:'as yet unclassified'!

default
        default isNil ifTrue: [default := self new].
        default basePath isNil ifTrue: [default basePath: '/seaside'].

        ^ default
!

description
	^ 'Subdirectory'
!

new
	^ super new initialize
! !

!WADispatcher methodsFor:'private'!

handlerForRequest: aRequest
        | path name |
        path _ aRequest url.
        (path beginsWith: basePath) ifTrue: [
            name _ ((path allButFirst: basePath size) findTokens: '/') at: 1 ifAbsent: [].
            entryPoints at: name ifPresent: [:n | ^ n]
        ].
        ^ WANotFoundHandler new
!

initialize
	entryPoints _ Dictionary new
! !

!WADispatcher methodsFor:'public'!

basePath: newPath
	| base |
	basePath _ newPath.
	base _ (newPath isEmpty or: [newPath last ~= $/])
				ifTrue: [newPath, '/']
				ifFalse: [newPath].
	entryPoints keysAndValuesDo: [:key :component | component basePath: base, key]
!

configurationComponent
	^ WADispatcherEditor new dispatcher: self
!

entryPoints
	^ entryPoints
!

handleRequest: aRequest
	^ (self handlerForRequest: aRequest) handleRequest: aRequest
!

registerEntryPoint: entryPoint at: aString
	| path |
	entryPoints at: aString put: entryPoint.
	path _ basePath last = $/
		ifTrue: [basePath, aString]
		ifFalse: [basePath, '/', aString].
	entryPoint basePath: path
!

removeEntryPoint: anObject
	entryPoints removeKey: (entryPoints keyAtValue: anObject)
! !

!WADispatcher class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WADispatcher.st,v 1.6 2009/08/15 07:22:07 cg Exp $'
! !
