"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAComponent subclass:#WADispatcherEditor
	instanceVariableNames:'path dispatcher type'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Tools'
!


!WADispatcherEditor class methodsFor:'as yet unclassified'!

canBeRoot 
	^ true
!

initialize
	self registerAsAuthenticatedApplication: 'config'
! !

!WADispatcherEditor methodsFor:'accessing'!

dispatcher: aDispatcher
	dispatcher _ aDispatcher
! !

!WADispatcherEditor methodsFor:'actions'!

addEntryPoint
	| entryPoint |
	path isEmpty ifTrue: [^ self inform: 'You must enter a path.'].
	entryPoint _ type new.
	dispatcher registerEntryPoint: entryPoint at: path.
	self configure: entryPoint
!

clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect
!

configure: anEntryPoint
	anEntryPoint configurationComponent ifNotNilDo: [:c | self call: c]
!

remove: anEntryPoint
	dispatcher removeEntryPoint: anEntryPoint
!

verifyPassword: pass forUser: user
	^ user = 'fooz' and: [pass = 'bar']
! !

!WADispatcherEditor methodsFor:'as yet unclassified'!

entryPointClasses
	^ WAEntryPoint concreteSubclasses
! !

!WADispatcherEditor methodsFor:'initialization'!

initialize
	dispatcher _ WADispatcher default.
	type _ WAApplication.
	path _ ''.
! !

!WADispatcherEditor methodsFor:'rendering'!

renderContentOn: html
	html heading: 'Squeak Enterprise Aubergines Server'.
	
	html bold: dispatcher basePath.
	html form: [
		html table: [
			dispatcher entryPoints keysSortedSafely do:
				[:name |
				self
					renderRowForEntryPoint: (dispatcher entryPoints at: name)
					named: name
					on: html].
		]
	].
	html paragraph.
	
	html bold: 'add entry point: '.
	html form: [
		html table: [
			html tableRowWithLabel: 'Path:' column: [html textInputWithValue: '' callback: [:n | path _ n]].
			html tableRowWithLabel: 'Type:' column:
				[html selectFromList: self entryPointClasses selected: type callback: [:c | type _ c] labels: [:ea | ea description].
				html space.
				html submitButtonWithAction: [self addEntryPoint] text: 'Add']
		]
	].

	html anchorWithAction: [self call: (WAConfigurationBrowser new pool: WASystemConfigurationPool default)] text: 'Edit Configurations'.

	html preformatted: SeasidePlatformSupport vmStatisticsReportString.
	html anchorWithAction: [self clearCaches] text: 'Clear Caches'.
	
!

renderRowForEntryPoint: anEntryPoint named: aString on: html
	html
		tableRowWith: [html anchorWithUrl: anEntryPoint basePath do: aString]
		with: [
			html anchorWithAction: [self configure: anEntryPoint] text: 'configure'.
			html space; anchorWithAction: [self remove: anEntryPoint] text: 'remove'.
		].
! !

!WADispatcherEditor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WADispatcherEditor.st,v 1.1 2004/09/21 22:34:23 cg Exp $'
! !

WADispatcherEditor initialize!
