"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WARequestHandler subclass:#WADocumentHandler
	instanceVariableNames:'document mimeDocument mimeType fileName'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-RequestHandler'
!


!WADocumentHandler class methodsFor:'as yet unclassified'!

document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString
! !

!WADocumentHandler methodsFor:'as yet unclassified'!

= other
	^ (other species = self species
		and: [other document = self document])
		and: [other mimeType = self mimeType]
!

document
	^ document
!

handleRequest: aRequest
	^ self response
!

hash
	^ self document hash bitXor: self mimeType hash
!

initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document _ anObject.
	mimeType _ mimeString.
	fileName _ fileString.
!

isActive
	^ true
!

mimeDocument
	^ mimeDocument ifNil: [mimeDocument _ document asMIMEDocument ]
!

mimeType
	^ mimeType
!

response
	| response |
	response _ WAResponse new.
	response contents: self mimeDocument contentStream text.
	response contentType: (mimeType ifNil: [self mimeDocument contentType]).
	response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
	fileName ifNotNil: 
		[response headerAt: 'Content-Disposition' put: 'attachment; filename=' , fileName].
	^ response
! !

!WADocumentHandler class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WADocumentHandler.st,v 1.1 2004/09/21 22:40:44 cg Exp $'
! !
