"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAComponent subclass:#WAHalo
	instanceVariableNames:'target mode'
	classVariableNames:'Halos'
	poolDictionaries:''
	category:'Seaside-Components-Tools'
!


!WAHalo class methodsFor:'as yet unclassified'!

for: aComponent
	Halos ifNil: [Halos _ SeasidePlatformSupport weakDictionaryOfSize: 20].
	^ Halos at: aComponent ifAbsentPut: [self new target: aComponent]
! !

!WAHalo methodsFor:'as yet unclassified'!

findStyles
	| context |
	context _ WARenderingContext new
				document: WAStyleCollector new;
				actionUrl: WAUrl new;
				request: self session currentRequest.
	target renderWithContext: context.
	^ String streamContents:
		[:s |
		context document styles do: [:ea | s nextPutAll: ea; space]]
!

initialize
	mode _ WAStateHolder new contents: #render:
!

render: html
	target renderContentOn: html
!

renderContentOn: html
	| haloHtml |
	haloHtml := self rendererClass 
					context: html context 
					callbacks: html callbacks. 
	haloHtml divClass: 'halo' with: [
		haloHtml divClass: 'halo-header' with: [
			haloHtml divClass: 'halo-icons' with: [
			haloHtml divClass: 'halo-mode' with: [
			haloHtml text: '['.
			haloHtml anchorWithAction: [self renderMode] text: 'R'.
			haloHtml text: ' | '.
			haloHtml anchorWithAction: [self sourceMode] text: 'S'.
			haloHtml text: ']'].
			haloHtml text: target class name.
			haloHtml space.
			self
				renderHalo: 'Halo-Debug'
				withWindow: [WABrowser fullOnClass: target class]
				titled: 'System Browser'
				on: haloHtml.
			self
				renderHalo: 'Halo-View'
				withWindow: [WAInspector on: target]
				titled: 'Inspector'
				on: haloHtml.
			self renderHalo: 'Halo-Paint'
				withWindow: [WAViewer on: target]
				titled: 'Style Editor'
				on: haloHtml.
			].
		].
		haloHtml divClass: 'halo-contents' with: [self perform: mode contents with: html].
	].
	haloHtml close.
	html close.

!

renderHalo: iconKey withAction: aBlock on: html
	html
		anchorWithAction: aBlock
		text:  [html imageWithForm: (ScriptingSystem formAtKey: iconKey)].
!

renderHalo: iconKey withWindow: componentBlock titled: aString on: html
	self
		renderHalo: iconKey
		withAction: [WARenderLoop new call: (componentBlock value
												addDecoration: (WAWindowDecoration new title: aString);
												yourself)]
		on: html
!

renderMode
	mode contents: #render:
!

source: html
	| context haloHtml | 
	haloHtml := self rendererClass
					context: html context
					callbacks: html callbacks. 
	context := haloHtml context copy.	
	context clearMode.
	context document: (WAPrettyPrintedDocument renderer: haloHtml).
	haloHtml divClass: 'halo-source' with: [target renderWithContext: context]. 
	haloHtml close. 
!

sourceMode
	mode contents: #source:
!

target: aComponent
	target _ aComponent
! !

!WAHalo class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAHalo.st,v 1.1 2004/09/21 22:33:46 cg Exp $'
! !
