"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

Object subclass:#WAHtmlAttributes
	instanceVariableNames:'associations'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Document'
!


!WAHtmlAttributes methodsFor:'accessing'!

at: keyString ifAbsentPut: errBlock
	^ self associations
		detect: [:ea | ea key = keyString]
		ifNone: [self associations add: keyString -> errBlock value]
!

at: keyString put: valueString
	self associations add: keyString -> valueString.
! !

!WAHtmlAttributes methodsFor:'convenience'!

addClass: aString
	| assoc |
	assoc _
		 self associations
			detect: [:ea | ea key = 'class']
			ifNone: [self associations add: 'class' -> aString. ^ self].
	assoc value: (assoc value, ' ', aString)
!

alignBottom
	self at: 'valign' put: 'bottom'
!

alignCenter
	self at: 'align' put: 'center'
! !

!WAHtmlAttributes methodsFor:'dnu'!

doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self at: aMessage selector put: true].
	argCount = 1 ifTrue: [^ self at: aMessage selector allButLast put: aMessage argument].
	^ super doesNotUnderstand: aMessage
! !

!WAHtmlAttributes methodsFor:'javascript'!

submitOnChange
	self at: 'onChange' put: 'submit()'
!

submitOnClick
	self at: 'onClick' put: 'submit()'
! !

!WAHtmlAttributes methodsFor:'printing'!

writeAttribute: assoc on: aStream
	assoc value = false ifFalse:
		[aStream nextPut: $ .
		aStream nextPutAll: assoc key asLowercase.
		aStream nextPutAll: '="'.
		assoc value = true
			ifFalse: [aStream nextPutAll: (WAAbstractHtmlBuilder encode: assoc value asString)]
			ifTrue: [aStream nextPutAll: assoc key asLowercase].
		aStream nextPut: $"]
!

writeOn: aStream
	associations ifNotNil:
		[associations do:
			[:assoc |
			self writeAttribute: assoc on: aStream]].
! !

!WAHtmlAttributes methodsFor:'private'!

associations
	^ associations ifNil: [associations _ OrderedCollection new]
! !

!WAHtmlAttributes class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAHtmlAttributes.st,v 1.1 2004/09/21 22:51:30 cg Exp $'
! !
