"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

Object subclass:#WAHtmlRoot
	instanceVariableNames:'docType title htmlAttrs headAttrs bodyAttrs headElements scripts
		styles'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Document'
!


!WAHtmlRoot class methodsFor:'as yet unclassified'!

new
	^ self basicNew initialize
! !

!WAHtmlRoot methodsFor:'as yet unclassified'!

addHeadElement: anHtmlElement
	headElements add: anHtmlElement
!

addScript: aString
	(scripts includes: aString) ifFalse: [scripts add: aString]
!

addStyle: aString
	(styles includes: aString) ifFalse: [styles add: aString]
!

bodyAttributes
	^ bodyAttrs
!

docType
	^ docType
!

docType: aString
	docType _ aString
!

headAttributes
	^ headAttrs
!

htmlAttributes
	^ htmlAttrs
!

initialize
	htmlAttrs _ WAHtmlAttributes new.
	headAttrs _ WAHtmlAttributes new.
	bodyAttrs _ WAHtmlAttributes new.
	headElements _ OrderedCollection new.
	scripts _ OrderedCollection new.
	styles _ OrderedCollection new.
	docType _ '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	title _ ''.
!

title
	^ title
!

title: aString
	title _ aString
!

writeHeadOn: aStream
	aStream nextPutAll: '<title>', title, '</title>'.
	styles do: [:ea | self writeStyle: ea on: aStream].
	scripts do: [:ea | self writeScript: ea on: aStream].
	headElements do: [:ea | ea writeOn: aStream]
!

writeOn: aStream
	aStream nextPutAll: docType.
	aStream nextPutAll: '<html'.
	htmlAttrs writeOn: aStream.
	aStream nextPutAll: '><head'.
	headAttrs writeOn: aStream.
	aStream nextPutAll: '>'.
	self writeHeadOn: aStream. 
	aStream nextPutAll: '</head><body'.
	bodyAttrs writeOn: aStream.
	aStream nextPutAll: '>'.
!

writeScript: aString on: aStream
	aStream
		nextPutAll: '<script>';
		nextPutAll: aString;
		nextPutAll: '</script>'
!

writeStyle: aString on: aStream
	aStream
		nextPutAll: '<style>';
		nextPutAll: aString;
		nextPutAll: '</style>'
! !

!WAHtmlRoot class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAHtmlRoot.st,v 1.1 2004/09/21 22:40:30 cg Exp $'
! !
