"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAHtmlDocument subclass:#WAHtmlTreeDocument
	instanceVariableNames:'head stack body'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Document'
!


!WAHtmlTreeDocument class methodsFor:'as yet unclassified'!

new
	^ super new initialize
! !

!WAHtmlTreeDocument methodsFor:'accessing'!

initializeWithRoot: anHtmlRoot
	super initializeWithRoot: anHtmlRoot.
	body _ WAHtmlElement named: 'body'.
	stack _ OrderedCollection with: body
! !

!WAHtmlTreeDocument methodsFor:'as yet unclassified'!

writeBodyOn: aStream
	body childrenDo: [:ea | ea writeOn: aStream]
!

writeOn: aStream
	root writeOn: aStream.
	self writeBodyOn: aStream.
	aStream nextPutAll: '</body></html>'
! !

!WAHtmlTreeDocument methodsFor:'markup'!

closeTag: aString
	self popElement name = aString ifFalse: [self error: 'Mismatched tags']
!

openTag: aString attributes: anAttributes
	| element |
	element _ WAHtmlElement named: aString attributes: anAttributes.
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [element beClosed]
		ifFalse: [element notClosed].
	self pushElement: element
!

text: aString
	self addElement: aString
! !

!WAHtmlTreeDocument methodsFor:'stack operations'!

addElement: anObject
	stack last add: anObject
!

popElement
	^ stack removeLast
!

pushElement: anObject
	self addElement: anObject.
	stack add: anObject.
!

withElement: anElement do: aBlock
	self pushElement: anElement.
	aBlock value.
	self popElement.
! !

!WAHtmlTreeDocument class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAHtmlTreeDocument.st,v 1.1 2004/09/21 22:41:12 cg Exp $'
! !
