"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAComponent subclass:#WAInspector
	instanceVariableNames:'path'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Tools'
!


!WAInspector class methodsFor:'as yet unclassified'!

on: anObject
	^ self new object: anObject
! !

!WAInspector methodsFor:'as yet unclassified'!

canInspect: anObject
	^ anObject isNumber or: [(Array with: nil with: true with: false) includes: anObject]
!

children
	^ Array with: path
!

chooseObject: anObject named: aString
	path pushSegment: anObject name: aString
!

initialize
	path _ WAPath new
!

renderContentOn: html 
	html render: path.
	html heading: (self object printStringLimitedTo: 50).
	html text: 'Identity Hash: ', self object identityHash asString; break; break.
	self renderMembersOn: html.
!

renderMembersOn: html 
	| members |
	members := self object inspectorFields.
	members isEmpty ifTrue: [^self].
	html bold: 'Members: '.
	html attributeAt: 'border' put: 1.
	html table: 
			[members associationsDo: 
					[:assoc | 
					self 
						renderRowForObject: assoc value
						named: assoc key
						on: html]]
!

renderRowForObject: anObject named: aString on: html
	html tableRow: [
		html tableData: [ 
			(self canInspect: anObject)
				ifTrue: [html text: aString]
				ifFalse: [html anchorWithAction: [self chooseObject: anObject named: aString] text: aString ]
		].
		html tableData: [ html text: (anObject printStringLimitedTo: 100) ]
	]
	
! !

!WAInspector methodsFor:'state variables'!

object
	^ path currentSegment
!

object: anObject 
	path pushSegment: anObject name: anObject printString
! !

!WAInspector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAInspector.st,v 1.1 2004/09/21 23:51:53 cg Exp $'
! !
