"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

Object subclass:#WALRUCache
	instanceVariableNames:'table ageTable max'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Utilities'
!


!WALRUCache class methodsFor:'as yet unclassified'!

new
	^ super new initialize
!

new: max
	^ self new capacity: max
! !

!WALRUCache methodsFor:'as yet unclassified'!

at: key
	^ self at: key ifAbsent: [self error: 'No entry for ', key]
!

at: key ifAbsent: errorBlock
	|val|
	val _ table at: key ifAbsent: [^ errorBlock value].
	ageTable at: val put: 0.
	^ val.
!

at: key put: val
	|removals|
	table at: key put: val.
	ageTable at: val put: 0.
	removals _ OrderedCollection new.
	ageTable associationsDo:
		[:assoc |
		assoc value > max ifTrue: [removals add: assoc key].
		assoc value: assoc value + 1].
	removals do: [:ea | self remove: ea].
	
!

capacity: aNumber
	max _ aNumber
!

initialize
	max _ 20.
	table _ Dictionary new.
	ageTable _ Dictionary new.
!

isEmpty
	^ table isEmpty
!

nextKey
	|key|
	[table includesKey: (key _ WAExternalID new asString)] whileTrue.
	^ key
!

remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)
!

store: anObject
	|key|
	key _ self nextKey.
	self at: key put: anObject.
	^ key
! !

!WALRUCache class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WALRUCache.st,v 1.1 2004/09/21 22:43:04 cg Exp $'
! !
