"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAFormDialog subclass:#WALabelledFormDialog
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Dialogs'
!


!WALabelledFormDialog methodsFor:'as yet unclassified'!

renderDefaultFieldForSelector: aSymbol on: html
	html textInputOn: aSymbol of: self model
!

renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
!

renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector _ self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]
!

renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)
!

renderRowForSelector: aSymbol on: html
	html cssClass: 'dialog-row'.
	html divNamed: aSymbol with: 
		[html spanClass: 'dialog-form-label' with: [self renderLabelForSelector: aSymbol on: html].
		html spanClass: 'dialog-form-field' with: [self renderFieldForSelector: aSymbol on: html]].
!

renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
!

renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol
!

rows
	^ #()
!

style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'
! !

!WALabelledFormDialog class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WALabelledFormDialog.st,v 1.1 2004/09/21 22:31:30 cg Exp $'
! !
