"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

Object subclass:#WAModelProxy
	instanceVariableNames:'cache model'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Utilities'
!


!WAModelProxy class methodsFor:'as yet unclassified'!

on: anObject
	^ self new setModel: anObject
! !

!WAModelProxy methodsFor:'accessing'!

model
	^ model
! !

!WAModelProxy methodsFor:'forwarding'!

commit
	cache keysAndValuesDo:
		[:key :value |
		self performRealWrite: key with: value].

	cache _ Dictionary new.
!

doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [self performRead: aMessage selector]
		ifFalse:
			[(aMessage selector isKeyword and: [aMessage arguments size = 1])
				ifTrue: [self performWrite: aMessage selector allButLast with: aMessage argument]
				ifFalse: [super doesNotUnderstand: aMessage]]
!

name
	^ model name
!

performRead: aSymbol
	^ cache at: aSymbol ifAbsent: [model perform: aSymbol]
!

performRealWrite: aSymbol with: anObject
	model perform: (aSymbol,':') asSymbol with: anObject
!

performWrite: aSymbol with: anObject
	cache at: aSymbol put: anObject
!

value
	^ model value
! !

!WAModelProxy methodsFor:'initializing'!

setModel: anObject
	model _ anObject.
	cache _ Dictionary new.
! !

!WAModelProxy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAModelProxy.st,v 1.1 2004/09/21 22:51:23 cg Exp $'
! !
