"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

Object subclass:#WAPresenter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Component'
!


!WAPresenter class methodsFor:'as yet unclassified'!

new
	^ self basicNew initialize
! !

!WAPresenter methodsFor:'convenience'!

session
	^ WACurrentSession value
! !

!WAPresenter methodsFor:'decoration'!

isDecoration
	^ false
! !

!WAPresenter methodsFor:'initialization'!

initialize
! !

!WAPresenter methodsFor:'path'!

updateRoot: anHtmlRoot
	self script ifNotNilDo: [:script | anHtmlRoot addScript: script].
	self style ifNotNilDo: [:style | anHtmlRoot addStyle: style].
	
!

updateUrl: aUrl
! !

!WAPresenter methodsFor:'rendering'!

renderContentOn: aRenderer
	self nextPresentersDo: [:ea | ea renderWithContext: aRenderer context]
!

renderWithContext: aRenderingContext
	| html callbacks |
	callbacks _ aRenderingContext callbacksFor: self.
	html _ self rendererClass context: aRenderingContext callbacks: callbacks.
	(self showHalo and: [aRenderingContext isDebugMode])
		ifTrue: [(WAHalo for: self) renderContentOn: html]
		ifFalse: [self renderContentOn: html].
	html close.
!

rendererClass
	^ WAHtmlRenderer
!

script
	^ nil
!

showHalo
	^ true
!

style
	^ nil
! !

!WAPresenter methodsFor:'request processing'!

processCallbackStream: aCallbackStream
	aCallbackStream processCallbacksWithOwner: self.
	self processChildCallbacks: aCallbackStream.
	aCallbackStream processCallbacksWithOwner: self.
!

processChildCallbacks: aStream
	self nextPresentersDo: [:ea | ea processCallbackStream: aStream]
! !

!WAPresenter methodsFor:'tree'!

nextPresentersDo: aBlock
	self subclassResponsibility 
!

withNextPresentersDo: aBlock
	aBlock value: self.
	self nextPresentersDo: [:ea | ea withNextPresentersDo: aBlock]
! !

!WAPresenter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAPresenter.st,v 1.2 2004/09/21 23:31:07 cg Exp $'
! !
