"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

Object subclass:#WARenderingContext
	instanceVariableNames:'actionUrl count callbacks document mode request response'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Rendering'
!


!WARenderingContext class methodsFor:'as yet unclassified'!

new
	^ self basicNew initialize
! !

!WARenderingContext methodsFor:'accessing'!

actionUrl
	"Answer the value of actionUrl"

	^ actionUrl
!

actionUrl: anObject
	"Set the value of actionUrl"

	actionUrl _ anObject
!

document
	"Answer the value of document"

	^ document
!

document: anObject
	"Set the value of document"

	document _ anObject
!

request
	^ request
!

request: aRequest
	request _ aRequest
!

response
	^ response
!

response: aResponse
	response _ aResponse
! !

!WARenderingContext methodsFor:'callbacks'!

advanceKey
	| key |
	key _ self nextKey.
	self increaseKey.
	^ key
!

callbackAt: aString
	^ callbacks at: aString
!

callbackStreamForRequest: aRequest
	^ WACallbackStream callbacks: callbacks request: aRequest
!

callbacksFor: anObject
	^ WACallbackRegistry context: self owner: anObject
!

increaseKey
	count _ count + 1
!

nextKey
	^ count asString
!

storeCallback: aCallback	
	| key |
	key _ self advanceKey.
	callbacks at: (aCallback convertKey: key) put: aCallback.
	^ key
! !

!WARenderingContext methodsFor:'documents'!

registry
	^ WACurrentSession value application
!

urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil
!

urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil
!

urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ (self registry urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)) asString
! !

!WARenderingContext methodsFor:'initialize-release'!

initialize
	count _ 1.
	callbacks _ Dictionary new
! !

!WARenderingContext methodsFor:'modes'!

clearMode
	mode _ nil
!

debugMode
	mode _ #debug
!

isDebugMode
	^ mode = #debug
! !

!WARenderingContext class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WARenderingContext.st,v 1.1 2004/09/21 22:42:48 cg Exp $'
! !
