"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WADecoration subclass:#WASessionProtector
	instanceVariableNames:'remoteAddress'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Decorations'
!


!WASessionProtector methodsFor:'accessing'!

remoteAddressFromRequest: aRequest
	^aRequest 
		headerAt: 'x-forwarded-for'
		ifAbsent: [ aRequest nativeRequest remoteAddress ]
!

storedRemoteAddress
	remoteAddress isNil
		ifTrue: [ remoteAddress _ self remoteAddressFromRequest: self session currentRequest ].
	^remoteAddress
! !

!WASessionProtector methodsFor:'forwarding'!

processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self respondNotVerified ]
!

renderContentOn: html
	(self verifyRequest: html request)
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self respondNotVerified ]
!

respondNotVerified
	self session redirectTo: self session application basePath.
! !

!WASessionProtector methodsFor:'testing'!

isGlobal
	^true
!

verifyRequest: aRequest
	^(self remoteAddressFromRequest: aRequest) = self storedRemoteAddress
! !

!WASessionProtector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WASessionProtector.st,v 1.1 2004/09/21 23:31:05 cg Exp $'
! !
