"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAReport subclass:#WATableReport
	instanceVariableNames:'sortColumn isReversed columns rowPeriod rowColors'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Widgets'
!


!WATableReport methodsFor:'accessing'!

columns: anArray
	columns _ anArray
!

initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3
!

rowColors: colorArray
	rowColors _ colorArray
!

rowPeriod: aNumber
	rowPeriod _ aNumber
! !

!WATableReport methodsFor:'as yet unclassified'!

chooseRow: aRow column: aColumn	
	aColumn chooseRow: aRow
!

colorForRowNumber: aNumber
	^ rowColors at: ((aNumber-1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']
!

isReversed
	^ isReversed
!

rows
	| r |
	self sortColumn ifNil: [^ rows].
	r _ self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]
! !

!WATableReport methodsFor:'rendering'!

renderColumn: aColumn row: aRow on: html
	|text|
	text _ aColumn textForRow: aRow.
	text isEmpty ifTrue: [text _ ' '].
	html tableData: [
		aColumn canChoose
			ifFalse: [html text: text]
			ifTrue: [html anchorWithAction: [self chooseRow: aRow column: aColumn] text: text]
	]
!

renderContentOn: html
	html attributeAt: 'cellspacing' put: 0; attributeAt: 'cellpadding' put: 5.
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html.
	]
!

renderFooterForColumn: aColumn on: html
	html tableHeading: [ html text: (aColumn totalForRows: rows)]
!

renderHeaderForColumn: aColumn on: html
	html tableHeading: [
		aColumn canSort
			ifTrue: [
				html anchorWithAction: [self sortColumn: aColumn] text: aColumn title]
			ifFalse: [
				html text: aColumn title]
	]
!

renderRowNumber: index item: row on: html
	html attributeAt: 'bgcolor' put: (self colorForRowNumber: index).
	html tableRow: [ columns do: [:ea | self renderColumn: ea row: row on: html] ]
!

renderRowsOn: html
	self rows withIndexDo: [:row :i | self renderRowNumber: i item: row on: html ]
!

renderTableFooterOn: html
	html tableRow: [ columns do: [ :ea | self renderFooterForColumn: ea on: html] ]
!

renderTableHeaderOn: html
	html tableRow: [ columns do: [ :ea | self renderHeaderForColumn: ea on: html] ]
! !

!WATableReport methodsFor:'state variables'!

sortColumn
	^ sortColumn contents
!

sortColumn: anObject 
	anObject = self sortColumn
		ifTrue: [isReversed _ isReversed not]
		ifFalse: [isReversed _ false].
	sortColumn contents: anObject
! !

!WATableReport class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WATableReport.st,v 1.1 2004/09/21 22:32:19 cg Exp $'
! !
