"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAFrameComponent subclass:#WAToolFrame
	instanceVariableNames:'showHalos'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Tools'
!


!WAToolFrame class methodsFor:'as yet unclassified'!

on: aComponent
	^ self new contents: aComponent
! !

!WAToolFrame methodsFor:'as yet unclassified'!

actions
	^ #(configure toggleHalos)
!

configure
	self call: (WAApplicationEditor new application: self session application)
!

initialize
	showHalos _ WAStateHolder new contents: false
!

openTool: aToolClass
	self call: (aToolClass new
				root: contents;
				addDecoration: (WAWindowDecoration new title: aToolClass title);
				yourself)
!

renderChildOn: html
	showHalos contents ifTrue: [html context debugMode].
	html render: contents.
	html context clearMode.
!

renderContentOn: html 
	html divNamed: 'frameContent' with: [self renderChildOn: html].
	self renderToolbarOn: html.
!

renderToolbarOn: html
   html paragraph.
   html
       divNamed: 'toolbar'
       with:
           [html anchorWithUrl: self session application baseUrl do: [html text: 'New Session']; space.
           self actions do:
               [:ea |
               html anchorOn: ea of: self; space].
           self tools do:
               [:ea |
               html anchorWithAction: [self openTool: ea] text: ea linkText; space].

           html anchorWithUrl: 'http://validator.w3.org/check/referer' do: 'XHTML'.
	]
!

style
^'
	#toolbar {position: fixed; bottom: 0; left: 0; right: 0; margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	#toolbar-profile {margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	.halo {border-style: solid; border-width: 1px; margin: 4px; border-color: #aaaaaa}
	.halo-header {font-size: 10pt; background-color: #cccccc; margin-bottom: 4px}
	.halo-mode {float: right}
	.halo-icons: {float: left}
	.halo-contents: {clear: both} 
'
!

toggleHalos
	showHalos contents: showHalos contents not
!

tools
	^ WATool allSubclasses
! !

!WAToolFrame class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAToolFrame.st,v 1.1 2004/09/21 23:51:30 cg Exp $'
! !
