"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAComponent subclass:#WAVersionUploader
	instanceVariableNames:'file url'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Tools-Squeak'
!


!WAVersionUploader class methodsFor:'as yet unclassified'!

canBeRoot
	^ true
! !

!WAVersionUploader methodsFor:'as yet unclassified'!

loadFile
	| reader version |
	reader _ MCVersionReader readerClassForFileNamed: file fileName.
	reader ifNil: [self inform: file fileName, ' is not in a known format'].
	version _ reader versionFromStream: file contents asByteArray readStream.
	version load.
!

loadURL
	| stream version |
	stream _ url asUrl retrieveContents content asByteArray readStream .
	version _ (MCVersionReader readerClassForFileNamed: url) versionFromStream: stream.
	version load.
!

renderContentOn: html
	html bold: 'Loaded versions:'.
	html list: MCWorkingCopy allManagers do: [:ea | html text: ea description].
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html bold: 'Load version from file: '; break.
		html fileUploadWithCallback: [:f | file _ f].
		html space.
		html submitButtonWithAction: [self loadFile] text: 'Load'.
	].
	html form: [
		html bold: 'Load version from URL: '; break.
		html attributes size: 60.
		html textInputWithValue: 'http://' callback: [:u | url _ u].
		html space.
		html submitButtonWithAction: [self loadURL] text: 'Load'.
	].
	html anchorWithAction: [self saveImage] text: 'Save Image'. 
!

saveImage
	Smalltalk snapshot: true andQuit: false
! !

!WAVersionUploader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAVersionUploader.st,v 1.1 2004/09/21 22:34:29 cg Exp $'
! !
