"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4' }"

WAComponent subclass:#WAWalkback
	instanceVariableNames:'exception'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Components-Tools'
!


!WAWalkback methodsFor:'as yet unclassified'!

debug
	self answer
!

exception: anException
	exception _ anException
!

renderContentOn: html
	html anchorWithAction: [self debug] text: 'Debug'.
	self renderWalkbackOn: html.
!

renderObject: anObject labelled: aString on: html
	| objectString |
	[objectString _ anObject printStringLimitedTo: 100]
		on: Error
		do: [:err | objectString _ '<font color="FF0000">&lt;error in printStringLimitedTo:&gt;</font>'].
	html tableRowWithLabel: aString column: objectString.
!

renderStackFrame: aContext on: html
        | receiver |
        html listItem: [
                html text: aContext fullPrintString.
                html blockquote: [ html table: [|tempNames|
                        receiver := aContext receiver.
                        self renderObject: receiver labelled: 'self' on: html.
                        html tableRowWith: [html bold: 'temps'] span: 2.
                        tempNames := aContext tempNames.
                        tempNames withIndexDo:
                            [:name :index |
                            self renderObject: (aContext tempAt: index) labelled: name on: html].
                        receiver isNil ifFalse: [
                                receiver class instSize > 0 ifTrue:
                                        [html tableRowWith: [html bold: 'inst vars'] span: 2.
                                        receiver class allInstVarNames withIndexDo:
                                        [:name :index |
                                        self renderObject: (receiver instVarAt: index) labelled: name on: html]]].
                ]]
        ]
!

renderWalkbackOn: html
	|context|
	html heading: exception description.
	html unorderedList: [
		context _ thisContext. 
		[context receiver isKindOf: Exception] whileFalse: [context _ context sender].
		[context receiver isKindOf: Exception] whileTrue: [context _ context sender].
		[context notNil] whileTrue: [
			self renderStackFrame: context on: html.
			context _ context sender].
	]
! !

!WAWalkback class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/WAWalkback.st,v 1.2 2004/09/22 09:55:34 cg Exp $'
! !
