"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4/examples' }"

WAComponent subclass:#WAStore
	instanceVariableNames:'task'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Examples-Store'
!

WAStore comment:'This component is the entry point for the store example.  It provides the main stylesheet in its #style method, renders a simple banner at the top, and then embeds an instance of WAStoreTask, which is where the real action happens.'
!


!WAStore class methodsFor:'as yet unclassified'!

canBeRoot
	^ true
!

initialize
	self registerAsApplication: 'store'
! !

!WAStore methodsFor:'as yet unclassified'!

children
	^ Array with: task
!

initialize
	task _ WAStoreTask new.
!

renderContentOn: html
	html cssId: 'banner'.
	html table: [
		html tableRowWith: [
			html divNamed: 'title' with: self title.
			html divNamed: 'subtitle' with: self subtitle.
		]
	].
	html divNamed: 'body' with: task
!

style
	^ '
	body {margin: 0px; font-family: sans-serif}
	#banner {width: 100%}	
	#banner tr {background-color: lightblue; text-align: right; padding: 10px; vertical-align: bottom}
	#title {font-size: 18pt; font-weight: bold}
	#subtitle {font-size: 9pt; font-style: italic}
	#body {padding: 5px}
	.validation-error {color: red; font-size: 9pt; padding: 5px}
	'
!

subtitle
	^ 'fresh, raw fish delivered to your door'
!

title
	^ 'sushiNet'
! !

!WAStore class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/examples/WAStore.st,v 1.2 2004/09/22 12:04:19 cg Exp $'
! !

WAStore initialize!
