"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4/examples' }"

Object subclass:#WAStoreCart
	instanceVariableNames:'items'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Examples-Store-Model'
!

WAStoreCart comment:'A shopping cart.  This is essentially a specialized Bag: you can #add: or #remove: WAStoreItems to it, and calculate their #totalPrice.  You can also use #countsAndItems to get a collection of associations between the items and the number of times they appear in the cart, useful for summary displays.'
!


!WAStoreCart methodsFor:'as yet unclassified'!

add: anObject
	items ifNil: [items _ Bag new].
	items add: anObject
!

countsAndItems
	^ items sortedCounts
!

hasItems
	^ items notNil and: [items isEmpty not]
!

items
	^ items
!

remove: anObject
	items remove: anObject ifAbsent: []
!

totalPrice
	^ items detectSum: [:ea | ea price]
! !

!WAStoreCart class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/examples/WAStoreCart.st,v 1.2 2004/09/22 12:04:19 cg Exp $'
! !
