"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4/examples' }"

Object subclass:#WAStoreCreditCard
	instanceVariableNames:'name number expiry'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Examples-Store-Model'
!

WAStoreCreditCard comment:'Models credit card information - it has accessors for #name and #number (both strings), and #expiry date.  #validate throws an error if anything is missing, or if the expiry date is in the past.

This is intended to be an abstract class - the subclasses WAStoreMasterCard and WAStoreVisaCard provide further validation.'
!


!WAStoreCreditCard methodsFor:'as yet unclassified'!

expiry
	
!

expiry: aDate
	expiry _ aDate
!

name
	^ name
!

name: aString
	name _ aString
!

number
	^ number
!

number: aString
	number _ aString
!

validate
	name ifNil: [self error: 'You must provide the name of the credit card owner.'].
	number ifNil: [self error: 'You must provide a credit card number.'].
	expiry ifNil: [self error: 'You must provide an expiry date.'].
	expiry < Date today ifTrue: [self error: 'The expiry date must not be in the past'].
	
! !

!WAStoreCreditCard class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/examples/WAStoreCreditCard.st,v 1.2 2004/09/22 12:04:19 cg Exp $'
! !
