"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4/examples' }"

WAComponent subclass:#WAStoreItemView
	instanceVariableNames:'item cart'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Examples-Store'
!

WAStoreItemView comment:'A component for viewing an individual WAStoreItem.  The caller must provide #item: and also the current #cart:.  Shows the description and price info for the item, and presents two buttons: "Add to Cart", which will add the item to the cart, once, and "Done", which will answer back to the caller.  Used by WAStoreFillCart>>displayItem: and displayItems:.'
!


!WAStoreItemView methodsFor:'as yet unclassified'!

addToCart
	cart add: item
!

cart: aCart
	cart _ aCart
!

item: anItem
	item _ anItem
!

renderContentOn: html
	html heading: item title.
	html heading: item subtitle level: 3.
	html paragraph: item description.
	html italic: item price printStringAsCents.
	html form: [
		html submitButtonWithAction: [self addToCart] text: 'Add To Cart'.
		html space.
		html submitButtonWithAction: [self answer] text: 'Done'.
	]
!

updateUrl: aUrl
	aUrl addToPath: item name
! !

!WAStoreItemView class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/examples/WAStoreItemView.st,v 1.2 2004/09/22 12:06:54 cg Exp $'
! !
