"{ Package: 'stx:goodies/webServer/comanche/seaside2_5b4/test' }"

WAComponent subclass:#WAHtmlTest
	instanceVariableNames:'booleanList message number'
	classVariableNames:''
	poolDictionaries:''
	category:'Seaside-Examples-Test'
!


!WAHtmlTest methodsFor:'as yet unclassified'!

allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		remove: #renderContentOn:;
		yourself
!

initialize
	message _ 'Hello world!!'.
	booleanList _ #(a b c d) collect: [:k | k -> ((Array with: true with: false) atRandom)].
	number _ 10 atRandom.
!

renderCheckboxesOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc |
			html text: assoc key; space.
			html checkboxWithValue: assoc value callback: [:b | assoc value: b].
			html break].
		html submitButton]
!

renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		html divClass: 'row' with: [
			html divClass: 'left' with: [self perform: selA with: html].
			html divClass: 'left' with: [self perform: selB with: html]
		]]
!

renderRadioButtonsOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc | |group|
			group _ html radioGroup.
			html text: assoc key; space.
			html radioButtonInGroup: group selected: assoc value callback: [assoc value: true].
			html radioButtonInGroup: group selected: assoc value not callback: [assoc value: false].
			html break].
		html submitButton]
!

renderSelectsOn: html
		html text: number.
		html paragraph.
		html form: [
			html selectFromList: (1 to: 10) selected: number callback: [:i | number _ i].
			html submitButton.
		]
!

renderSubmitButtonsOn: html
		html text: number.
		html paragraph.
		html form: [
			(1 to: 10) do:
				[:i |
				html submitButtonWithAction: [number _ i] text: i.
				html space]
		]
!

renderTextAreaOn: html
		html form: [
			html text: message.
			html paragraph.
			html textAreaWithValue: message callback: [:v | message _ v].
			html break; submitButton.
		]
!

renderTextInputOn: html
		html form: [
			html text: message.
			html paragraph.
			html textInputWithValue: message callback: [:v | message _ v].
			html submitButton.
		]
!

renderZ: html
	html space
!

style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
'
! !

!WAHtmlTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/seaside2_5b4/test/WAHtmlTest.st,v 1.2 2004/09/22 11:58:47 cg Exp $'
! !
