"{ Package: 'stx:goodies/webServer/comanche/stt' }"

"{ NameSpace: Comanche }"

Object subclass:#STTComancheModel
	instanceVariableNames:'applicationModel service request response sttFilePath'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-STT'
!

!STTComancheModel class methodsFor:'documentation'!

documentation
"
    STT (Smalltalk Templates) support. 
    Enables embedding Smalltalk code in HTML and other documents too.

    [Date:]
        7 July 2002

    [Author:]
        Federico Gregorio Stilman
"
! !

!STTComancheModel class methodsFor:'instance creation'!

newOn: aModel
	"Creates an instance of the receiver on aModel"
	^ super new initializeOn: aModel.
! !

!STTComancheModel methodsFor:'accessing'!

model
	"Returns the receiver's application model.
	NOTE: we choose the shortcut selector #model instead of #applicationModel
	considering that references to 'self model' are very common on STT templates,
	and to avoid long names on scripting"

	^ applicationModel
!

request
	"Returns the receiver's request"
	^ request
!

request: aRequest
        "Sets the receiver's request to be aRequest"

        request _ aRequest.
        response _ aRequest response.
!

service
        "Returns the receiver's service.
        Thats the instance of ComancheSTTService, which forwards the requests to STT.
        (it can, for example, be asked for its link)"

        ^ service
!

service: aService
        "Sets the receiver's service to be aService"

        service := aService
!

sttFilePath
    ^ sttFilePath
!

sttFilePath:something
    sttFilePath := something.
! !

!STTComancheModel methodsFor:'initializing'!

initializeOn: aModel
	"Initialize and sets the receiver's application model to aModel"

	applicationModel _ aModel
	
! !

!STTComancheModel methodsFor:'printing'!

printOn:aStream
    super printOn:aStream.
    aStream nextPut:$(.
    sttFilePath printOn:aStream.
    aStream nextPut:$).
! !

!STTComancheModel class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/stt/STTComancheModel.st,v 1.15 2005/12/05 00:35:02 stefan Exp $'
! !
