"{ Package: 'stx:goodies/webServer/comanche' }"

LibraryDefinition subclass:#stx_goodies_webServer_comanche
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_goodies_webServer_comanche class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/stx_goodies_webServer_comanche.st,v 1.13 2011/09/13 12:06:36 stefan Exp $'
! !

!stx_goodies_webServer_comanche class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/webServer'    "HTTPService - superclass of ComancheNetService "
        #'stx:libbasic'    "Object - superclass of Comanche::SimulatedSqueakSocketStream "
        #'stx:libcomp'    "Structure - referenced by Comanche::SimulatedSqueakFileDirectory>>entryAt: "
        #'stx:libview2'    "MIMETypes - referenced by Comanche::SimulatedSqueakFileDirectory>>fileNamed: "
        #'stx:libcompat'   "Object caseOf:"
    )
! !

!stx_goodies_webServer_comanche class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'Comanche::Compiler'
        #'Comanche::SimulatedSqueakBlock'
        #'Comanche::SimulatedSqueakFileDirectory'
        #'Comanche::SimulatedSqueakFileStream'
        #'Comanche::SimulatedSqueakMethod'
        #'Comanche::SimulatedSqueakSocketStream'
        ComancheService
        #'stx_goodies_webServer_comanche'
        ComancheNetService
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Date asTimeStamp
        Date yyyymmdd
        Dictionary hasKeyStartingWith:
        Form asHtmlElementIn:
        Form asHttpResponseTo:
        Form asWebImage
        Object asHtmlDocumentForRequest:
        Object asHtmlElement
        Object asHtmlElementIn:
        Object asHttpResponseTo:
        Object comancheUrl
        Object makeAvailableInComanche
        Object mimeType
        String asHttpResponseTo:
        String asSwikiLink
        String skipDelimiters:startingAt:
        String squeakAsInteger
        String translateWith:
        String trimNullAndStar
        String unescapePercents
        Text asHtmlDocumentForRequest:
        UndefinedObject asSwikiLink
    )
! !

!stx_goodies_webServer_comanche class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Comanche Webserver Compatibility'

    "Modified: / 23-11-2010 / 17:39:59 / cg"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011'

    "Modified: / 01-02-2011 / 11:54:57 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_webServer_comanche class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/stx_goodies_webServer_comanche.st,v 1.13 2011/09/13 12:06:36 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/stx_goodies_webServer_comanche.st,v 1.13 2011/09/13 12:06:36 stefan Exp $'
! !
