"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

TextFormatter subclass:#BookTemplateFormatter
	instanceVariableNames:''
	classVariableNames:'SwikiFormatter'
	poolDictionaries:''
	category:'Comanche-Swiki-Formatting'
!

BookTemplateFormatter comment:'BookTemplateFormatter

This specialty TextFormatter is created for a SwikiBook to use in processing templates. It takes elements between ''<?'' and ''?>'' and executes the actions associated with the text inbetween.'
!


!BookTemplateFormatter class methodsFor:'accessing'!

swikiFormatter
	^SwikiFormatter
! !

!BookTemplateFormatter class methodsFor:'initialize-release'!

initialize
        SwikiFormatter _ self new.
        SwikiFormatter
                initialize;
                addAction: #swikiAction from: '<?' to: '?>'

"
    self initialize
"
! !

!BookTemplateFormatter methodsFor:'private'!

action: action value: value text: text
        "Overwrites parent class to add swiki action"
        ^(value size = 5)
                ifTrue: ["Page Request"
                        (value at: 4) formatPageAction: text with: value]
                ifFalse: ["Book Request"
                        (value at: 4) formatBookAction: text with: value]
! !

!BookTemplateFormatter methodsFor:'processing'!

format: template request: request response: response shelf: shelf book: book
	"Formatting used for a book request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array with: request with: response with: shelf with: book.
	self format: template actionValue: value onTo: stream.
	^stream contents
!

format: template request: request response: response shelf: shelf book: book page: page
        "Formatting used for a page request"
        | value stream |

        stream _ WriteStream on: (String new: template size).
        value _ Array with: request with: response with: shelf with: book with: page.
        self format: template actionValue: value onTo: stream.
        ^stream contents
! !

!BookTemplateFormatter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/BookTemplateFormatter.st,v 1.7 2003/08/29 17:04:57 cg Exp $'
! !

BookTemplateFormatter initialize!
