"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

Stream subclass:#BufferStream
	instanceVariableNames:'buffer startPos endPos'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Kom-Kernel'
!

BufferStream comment:'Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:43

BufferStream

Comment in Com46:
- is-a ReadWriteStream on a String
- like a queue
  removeNext:/nextPutAll: protocol'
!


!BufferStream class methodsFor:'instance creation'!

on: aString
	^self basicNew on: aString
! !

!BufferStream methodsFor:'accessing'!

contents
	"return contents, non-destructive"
	^buffer copyFrom: startPos to: endPos
!

match: aString
	self size < aString size
		ifTrue: [^false].
	(self next: aString size) = aString
		ifTrue: [^true]
		ifFalse: [self on: aString, self upToEnd].
	^false
!

next
	"return the next character"
	"consume it"
	^buffer at: (startPos _ startPos + 1) - 1
!

next: anInteger
        "return next anInteger characters"
        "consumes them"

        |pos1 pos2|

        pos1 := startPos.
        pos2 := startPos + anInteger - 1.
        startPos := startPos + anInteger.
        ^buffer copyFrom: pos1 to: pos2
!

nextPutAll: aString
	buffer _ (buffer copyFrom: startPos to: endPos), aString.
	startPos _ 1.
	endPos _ buffer size
!

peek
	"return the next character without consuming it"
	"consume it"
	^buffer at: startPos
!

size
	^endPos - startPos + 1
!

upTo: aChar
	"return String up to aChar, but not including"
	"consumes the returned string"
	| i |
	i _ buffer indexOf: aChar startingAt: startPos.
	(i <= 0 or: [i > endPos])
		ifTrue: [^self upToEnd].
	^self next: (i-startPos)
!

upToAll: aString
	"return a string before the occurence of aString, if any"
	"consume it"
	| i |
	i _ buffer findString: aString startingAt: startPos.
	(i <= 0 or: [i > endPos])
		ifTrue: [^self upToEnd].
	^self next: (i-startPos)
!

upToEnd
	"return buffer contents,
	consume all my buffer"
	| string |
	string _ self contents.
	self reset.
	^string
! !

!BufferStream methodsFor:'initialize-release'!

on: aString
	buffer _ aString.
	startPos _ 1.
	endPos _ buffer size
!

reset
	"hack"
	self on: ''
! !

!BufferStream methodsFor:'printing'!

printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self size asString, ')'
! !

!BufferStream methodsFor:'testing'!

includes: aChar
	"answer whether buffer includes aChar within bounds"
	| tmp |
	tmp _ buffer indexOf: aChar startingAt: startPos.
	^(tmp >= startPos) and: [tmp <= endPos]
!

includesAll: aString
	"answer whether the buffer contains aString"
	| tmp |
	tmp _ buffer findString: aString startingAt: startPos.
	^(tmp >= startPos) and: [tmp <= endPos]
!

isEmpty
	^self size <= 0
! !

!BufferStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/BufferStream.st,v 1.22 2003/08/29 17:04:23 cg Exp $'
! !
