"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

ComancheService subclass:#ComancheSwikiService
	instanceVariableNames:'comancheSwikiRoot swikiModuleClassName'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-STX-Support'
!

!ComancheSwikiService class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    I am the glue between the HTTPServers services (on the calling side)
    and SwikiModules on the other side.
    Instances of me are registered in the HTTPServer (under the link-name)
    and I will be invoked via the #process: method for incoming
    requests.

    To set up your new Swiki, you need a copy of the comanche swiki data files.
    There is one provided in 
        goodies/webServer/data/sampleServerDir/comancheSwiki

    Notice, that the one in sampleServerDir has been adapted to ST/X
    while you may have to adjust things when using the Squeak files.

    Open the new settings dialog. Add this service to the server and apply.
    Select the service Settings Application for the Comanche Swiki and select
    to a valid directory for the comanche Swiki files.

    [Author:]
        Christian Penk
"
! !

!ComancheSwikiService class methodsFor:'configuring - setup'!

loadPackage
    |comSwikiPackage|

    ((Comanche isNil) 
    or:[Comanche::SwikiBook isNil
    or:[Comanche::SwikiBook isLoaded not]]) ifTrue:[
        comSwikiPackage := self package.
        (Smalltalk loadPackage:comSwikiPackage) ifFalse:[
            ^ false.
        ].
        
    ].
    ^ true

"
    self loadPackage
"

"
    self loadPackage
"
!

new
    self loadPackage.
    ^ super new.
!

postAutoload
    "/ self loadPackage
! !

!ComancheSwikiService class methodsFor:'defaults'!

canChangeReplyPresenter
    ^ false
!

linkName
    "return the default linkName (with slash)"

    ^ '/ComancheSwiki'
! !

!ComancheSwikiService class methodsFor:'queries-service'!

availableModuleClassNames
    ^ Comanche::SwikiModule withAllSubclasses collect:[:aClass| aClass name].
!

comancheSwikiRoot
    | dir |

    dir isNil ifTrue:[
        #(  
            '../../goodies/webServer/data/comancheSwiki'
            './webServerData/comancheSwiki'
            '~/webServerData/comancheSwiki'
            './examples/webServer/comancheSwiki'
            '/pub/webServer/comancheSwiki'
        ) do:[:aFilename |
            (aFilename asFilename isDirectory) ifTrue:[
                dir := aFilename
            ]
        ].
        dir isNil ifTrue:[
            dir := '../../goodies/webServer/data/comancheSwiki'.
"/            dir := './webServer/data/comancheSwiki'
        ].
    ].
    ^ dir
"
self comancheSwikiRoot 
UserPreferences current httpServerComancheSwikiServerDirectory:nil
"
!

comancheSwikiXPRoot
    ^ '../../goodies/webServer/data/xpSwiki'
"
self comancheSwikiXPRoot 
"
!

isThreadSafe
    ^ true
!

settingsApplicationClass
    "my application in the settings dialog"

    ^ ComancheSwikiSettingsApplication
! !

!ComancheSwikiService methodsFor:'accessing'!

comancheSwikiRoot

    comancheSwikiRoot isNil ifTrue:[
        comancheSwikiRoot := self class comancheSwikiRoot
    ].
    ^ comancheSwikiRoot
!

comancheSwikiRoot:aDirectory 
    |server|

    (module isNil or:[self comancheSwikiRoot ~= aDirectory]) ifTrue:[
        server := self httpServer.
        server notNil ifTrue:[
            self unRegisterServiceOn:server.
        ].
        module := nil.
        comancheSwikiRoot := aDirectory.
        server notNil ifTrue:[
            self registerServiceOn:server
        ].
    ].
!

servicePath:something
    "blocked"

    self error:'I have no servicePath'
!

swikiModuleClass
    ^ Smalltalk at:self swikiModuleClassName.
!

swikiModuleClassName
    ^ swikiModuleClassName ? Comanche::SwikiModule name
!

swikiModuleClassName:aClassName
    |server|

    (module isNil or:[self swikiModuleClassName ~= aClassName]) ifTrue:[
        server := self httpServer.
        server notNil ifTrue:[
            self unRegisterServiceOn:server.
        ].
        module := nil.
        swikiModuleClassName := aClassName.
        server notNil ifTrue:[
            self registerServiceOn:server
        ].
    ].
! !

!ComancheSwikiService methodsFor:'initialize'!

browseWithSwikiBrowser
    Comanche::SwikiBrowser asMVCOnShelf:(self module shelf).

    "
     ComancheSwikiService allInstances first browseWithSwikiBrowser
    "
!

initialize
    super initialize.
    autoStart := false.
!

setupModule

    |swikiDir|

    self class loadPackage ifFalse:[
        self error:'load of comanche swiki classes failed'.
    ].
    swikiDir := self comancheSwikiRoot.
    swikiDir notNil ifTrue:[
        swikiDir asFilename exists ifFalse:[
            self error:'Comanche Swiki server directory ' , swikiDir asString, ' does not exist - cannot create action link'
                 mayProceed:true.
            ^ self.
        ].
        module := self swikiModuleClass swikiWebServerFromDir:swikiDir.
        module isNil ifTrue:[
            self error:'Comanche Swiki can''t create a Swiki Module for' , swikiDir asString.
        ].
        self comancheSwikiBookNames notEmpty ifTrue:[
            self linkNamesChanged.
        ].
    ].
!

setupModuleForComancheSwikiRoot:comancheSwikiRootFilename swikiModuleClassName:swikiModuleClassNameVar 
    |oldModule|

    swikiModuleClassName := swikiModuleClassNameVar.
    comancheSwikiRoot := comancheSwikiRootFilename.
    oldModule := module.
    module := nil.
    self setupModule.
    module isNil ifTrue:[
        module := oldModule.
    ].
! !

!ComancheSwikiService methodsFor:'maintenance html presentation'!

specificChangeFromRequest:aRequest
    "extracts parameter from an html-maintenance post-request"

    |tmp|

    tmp := aRequest urlParameterAt:'ServiceRootDirectory'.
    tmp notNil ifTrue:[
        self comancheSwikiRoot:tmp.
    ].
    tmp := aRequest urlParameterAt:'swikiModuleClassName'.
    tmp notNil ifTrue:[
        self swikiModuleClassName:tmp asSymbol.
    ].
!

specificInputFieldsForRequest:aRequest 
    "generates the html-fragment for the maintenance form"

    |swikiModuleClassNames selected|

    aRequest 
        inputFieldFor:'ServiceRootDirectory' 
            type:nil 
            size:'50' 
            label:('Service Root Directory:<BR><BLOCKQUOTE>') 
            initialValue:self comancheSwikiRoot;
        nextPutLine:'</BLOCKQUOTE><BR>'.
    aRequest 
        nextPutLine: 'Service Realm:&nbsp&nbsp';
        nextPutLine: '<SELECT NAME="swikiModuleClassName" SIZE="1"> '.
    swikiModuleClassNames := self class availableModuleClassNames.
    swikiModuleClassNames do:[:aKey |
         | mySwikiModuleClassName |
        mySwikiModuleClassName := self swikiModuleClassName ? ''.
        aKey = mySwikiModuleClassName ifTrue:[
            selected := ' SELECTED'.
        ] ifFalse:[
            selected := ''.
        ].
        aRequest
            nextPutLine: '<OPTION ', selected,'>', aKey asString,'</OPTION>'.
    ].
    aRequest
        nextPutLine: '</SELECT>'.
! !

!ComancheSwikiService methodsFor:'queries'!

allowRobotsPaths
    " return the disallowed paths for robots "

    ^ #( '/admin')
!

comancheSwikiBookNames

    |swikiModule|

    swikiModule := self module.

    swikiModule isNil ifTrue:[ ^ #()].
    ^ swikiModule shelf books collect:[:aSwikiBook | aSwikiBook name].
! !

!ComancheSwikiService methodsFor:'queries-service'!

linkNames:aLinkNameCollection

    super linkNames:aLinkNameCollection.
    self linkNamesChanged.
!

linkNamesChanged

    |newBookPrefix swikiModule shelf|

    swikiModule := self module.

    swikiModule notNil ifTrue:[
        newBookPrefix := self linkName.
        (newBookPrefix endsWith:$/) ifFalse:[
            newBookPrefix := newBookPrefix , '/'
        ].
        shelf := swikiModule shelf.
        shelf settingsAt:'bookPrefixPath' put: newBookPrefix.
        shelf books do:[:aBook|
            aBook formatPrivAddress: 'initUploadServer' request: nil response: nil shelf: module shelf
        ].
    ].
! !

!ComancheSwikiService methodsFor:'registration'!

addRequiredForeignServicesTo:aServer 
    "I need a file service for the bitmaps and icons"

    |swikiDir linkName swikiDirFileServiceFile|

    swikiDir := self comancheSwikiRoot.
    (swikiDir notNil and:[swikiDir asFilename exists]) ifTrue:[
        swikiDirFileServiceFile := (swikiDir asFilename construct:'default') 
                    construct:'files'.
        linkName := self module shelf settingsAt:'fileServerPath'.
        linkName = '/' ifTrue:[self error:'linkName shouldn''t be /'.].
        (aServer serviceForLink:linkName ifAbsent:nil) isNil ifTrue:[
            aServer 
                addFileServiceWithRootLinkName:linkName
                rootDirectory:swikiDirFileServiceFile pathName
                defaultFileName:nil.
        ].
    ].
!

registerServiceOn:aServer
    "register myself as comanche swiki service on a single HTTPServer."

    self module notNil ifTrue:[
        super registerServiceOn:aServer.
    ].
!

removeRequiredForeignServicesFrom:aServer
    |linkName fileServices|

    module notNil ifTrue:[
        linkName := module shelf settingsAt:'fileServerPath'.
        fileServices := aServer fileServices select:[:aFileService| (aFileService linkName startsWith:linkName)].
        fileServices do:[:aFileService| 
            aFileService unRegisterServiceOn:aServer
        ].
    ].
! !

!ComancheSwikiService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/ComancheSwikiService.st,v 1.83 2006/07/28 20:18:23 stefan Exp $'
! !
