"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

Object subclass:#HttpParser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Kom-Protocol-HTTP'
!

!HttpParser class methodsFor:'documentation'!

documentation
"
    kom/4.12 (Comanche/4.12)

    HttpParser (kom/4.10; bolot 6/22/2001 11:59)
        - everything is on class side
        - all parsing utilities (form fields, forms, headers, etc.)
        -- moved out of other Http$$ classes

    what's new in kom/4.10
        - case-sensitive form fields (case is preserved)
        - multiple values for fields
        -- through using HttpFormDictionary
"
! !

!HttpParser class methodsFor:'utilities'!

addKey: key value: value toForm: dict multipleValues: boolean
	boolean
		ifTrue: [dict at: key put: value]
		ifFalse: [(dict includesKey: key)
			ifFalse: [dict at: key put: value]
			ifTrue: [dict at: key modify: [:oldValue | oldValue, value]]]
!

decodeUrlEncodedForm: string
	^self decodeUrlEncodedForm: string multipleValues: false
!

decodeUrlEncodedForm: string multipleValues: boolean
        | dict key value start end eqSignPos more |
        dict _ boolean ifTrue: [HttpFormDictionary new] ifFalse: [Dictionary new].
        string isEmptyOrNil ifTrue: [^dict].
        more _ true.
        start _ 1.
        [end _ string indexOf: $& startingAt: start.
        end == 0
                ifTrue: [end _ string size. more _ false]
                ifFalse: [end _ end - 1].
        eqSignPos _ string indexOf: $= startingAt: start.
        (eqSignPos > end or: [eqSignPos == 0])
                ifTrue: [key _ (key _ string copyFrom: start to: end).
                        value _ '']
                ifFalse: [key _ (key _ string copyFrom: start to: eqSignPos-1).
                        value _ (value _ string copyFrom: eqSignPos+1 to: end)].

        key := key unescapePercents.
        value := value unescapePercents.

        self addKey: key value: value toForm: dict multipleValues: boolean.
        start _ end + 2.
        more] whileTrue.

        ^dict
!

parseHttpHeader: string
        | dict key value start end more colonPos fieldDelims lastKey keyValueDelim |
        dict _ Dictionary new.
        string isEmptyOrNil ifTrue: [^dict].
        (Smalltalk dialectName = 'SmalltalkX') ifTrue:[ 
            fieldDelims _ String crlf.
        ] ifFalse:[
            fieldDelims _ String crlf asCharacterSet.
        ].
        keyValueDelim _ $:.
        more _ true.
        start _ end _ 1.
        lastKey _ ''.
        [end _ string indexOfAnyOf: fieldDelims startingAt: start.
        end == 0
                ifTrue: [end _ string size. more _ false]
                ifFalse: [end _ end - 1].
        (end >= start and: [start < string size])
                ifTrue: [
                        (string at: start) isSeparator
                                ifTrue:
                                        [dict
                                                at: lastKey
                                                modify: [:item | item, (string copyFrom: start to: end)]]
                                ifFalse:
                                        [colonPos _ string indexOf: keyValueDelim startingAt: start.
                                        (colonPos > end or: [colonPos == 0])
                                                ifTrue:
                                                        [key _ (string copyFrom: start to: end) asLowercase.
                                                        value _ '']
                                                ifFalse:
                                                        [key _ (string copyFrom: start to: colonPos-1) asLowercase.
                                                        value _ (string copyFrom: colonPos+1 to: end) withBlanksTrimmed]].
                        key isEmpty
                                ifFalse: [dict at: key put: value.
                                        lastKey _ key.
                                        key _ ''].
                        start _ string skipDelimiters: String crlf startingAt: end+1].
        more] whileTrue.

        ^dict
! !

!HttpParser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/HttpParser.st,v 1.14 2003/12/03 22:57:07 cg Exp $'
! !
