"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

Object subclass:#IdFormatter
	instanceVariableNames:'idBlock startBlock transitionBlock endBlock formatter settings'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-Formatting'
!


!IdFormatter class methodsFor:'instance creation'!

anchor
	| instance |

	instance _ self new.
	instance idBlock: [:text | '@'].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page | '<a name="', (PageFormatter toSafeLocation: text), '"></a>', String cr].
	^instance
!

append
	| instance |

	instance _ self new.
	instance idBlock: [:text | '+'].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	"- means appends show up without an append area"
	instance formatter: [:text :request :response :shelf :book :page | book formatPageTemplate: ((text includes: $-) ifTrue: ['appendSansArea'] ifFalse: ['append']) request: request response: response shelf: shelf page: page].
	^instance
!

appendRender
	| instance |

	instance _ self new.
	instance idBlock: [:text | '+'].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page | ''].
	^instance
!

break
        | instance |

        instance _ self new.
        instance idBlock: [:text | '_'].
        instance startBlock: [:id | ''].
        instance endBlock: [:id | ''].
        instance transitionBlock: [:idOld :idNew | ''].
        instance formatter: [:text :request :response :shelf :book :page | (book formatBookAction: 'bar' request: request response: response shelf: shelf), String cr].
        ^instance
!

heading: formatter
        | instance |

        instance _ self new.
        instance idBlock: [:text | (text beginsWith: '!!!!')
                ifTrue: [(text beginsWith: '!!!!!!')
                        ifTrue: ['!!!!!!']
                        ifFalse: ['!!!!']]
                ifFalse: ['!!']].
        instance startBlock: [:id | '<h', (4 - id size) asString, '>'].
        instance endBlock: [:id | '</h', (4 - id size) asString, '>', String cr].
        instance transitionBlock: [:idOld :idNew | '</h', (4 - idOld size) asString, '>', String cr, '<h', (4 - idNew size) asString, '>'].
        instance formatter: [:text :request :response :shelf :book :page | formatter format: text request: request response: response shelf: shelf book: book page: page].
        ^instance
!

leaveAlone
        | instance |

        instance _ self new.
        instance idBlock: [:text | ''].
        instance startBlock: [:id | ''].
        instance endBlock: [:id | ''].
        instance transitionBlock: [:idOld :idNew | ''].
        instance formatter: [:text :request :response :shelf :book :page | text, String cr].
        ^instance
!

list: formatter
        | instance match return |

        instance _ self new.
        instance idBlock: [:text | return _ 1.
                [(text size >= return) and: [((text at: return) = $-) or: [(text at: return) = $#]]]
                        whileTrue: [return _ return + 1].
                text copyFrom: 1 to: (return-1)].
        instance startBlock: [:id | return _ ''.
                id do: [:char | (char = $-)
                        ifTrue: [return _ return, '<ul>', String cr]
                        ifFalse: [return _ return, '<ol>', String cr]].
                return].
        instance endBlock: [:id | return _ ''.
                id do: [:char | (char = $-)
                        ifTrue: [return _ '</ul>', String cr, return]
                        ifFalse: [return _ '</ol>', String cr, return]].
                return].
        instance transitionBlock: [:idOld :idNew | return _ ''.
                match _ 1.
                [((idOld size >= match) and: [idNew size >= match]) and: [(idOld at: match) = (idNew at: match)]] whileTrue: [match _ match + 1].
                (idOld size > (match - 1)) ifTrue: [(idOld copyFrom: match to: idOld size) do: [:char | (char = $-) ifTrue: [return _ '</ul>', String cr, return] ifFalse: [return _ '</ol>', String cr, return]]].
                (idNew size > (match - 1)) ifTrue: [(idNew copyFrom: match to: idNew size) do: [:char | (char = $-) ifTrue: [return _ return, '<ul>', String cr] ifFalse: [return _ return, '<ol>', String cr]]].
                return].
        instance formatter: [:text :request :response :shelf :book :page | '<li>', (formatter format: text request: request response: response shelf: shelf book: book page: page), String cr].
        ^instance
!

preformatted: formatter
        | instance |

        instance _ self new.
        instance idBlock: [:text | '='].
        instance startBlock: [:id | '<pre>'].
        instance endBlock: [:id | '</pre>', String cr].
        instance transitionBlock: [:idOld :idNew | String cr].
        instance formatter: [:text :request :response :shelf :book :page | formatter format: text request: request response: response shelf: shelf book: book page: page].
        ^instance
!

saveAppend
        | instance |

        instance _ self new.
        instance idBlock: [:text | ''].
        instance startBlock: [:id | ''].
        instance endBlock: [:id | ''].
        instance transitionBlock: [:idOld :idNew | ''].
        instance formatter: [:text :request :response :shelf :book :page |
                "Add appendId setting"
                (request settingsIncludes: 'appendId')
                        ifTrue: [request settingsAt: 'appendId' put: 1 + (request settingsAt: 'appendId')]
                        ifFalse: [request settingsAt: 'appendId' put: 1].
                ((request settingsAt: 'appendId') = (request fieldsAsNumberKey: 'appendId'))
                        ifTrue: [(request settingsIncludes: 'formId')
                                ifTrue: [((request settingsAt: 'formId') = (request fieldsKey: 'formId'))
                                        ifTrue: [
                                                request settingsAt: 'appendSuccess' put: true.
                                                self appendFormat: text request: request response: response shelf: shelf book: book page: page]
                                        ifFalse: [text, String cr]]
                                ifFalse: [
                                        request settingsAt: 'appendSuccess' put: true.
                                        self appendFormat: text request: request response: response shelf: shelf book: book page: page]]
                        ifFalse: [text, String cr]].
        ^instance
!

table: formatter
        | instance return |

        instance _ self new.
        instance idBlock: [:text | '|'].
        instance startBlock: [:id | '<table border=1 cellspacing=0 cellpadding=5>', String cr, '<tr>'].
        instance endBlock: [:id | '</tr>', String cr, '</table>', String cr].
        instance transitionBlock: [:idOld :idNew | '</tr>', String cr, '<tr>'].
        instance formatter: [:text :request :response :shelf :book :page | return _ ''.
                (text findTokens: '|') do: [:token | return _ return, '<td>', (formatter format: token request: request response: response shelf: shelf book: book page: page), '</td>'].
                return].
        ^instance
!

text: formatter
        | instance |

        instance _ self new.
        instance idBlock: [:text | ''].
        instance startBlock: [:id | ''].
        instance endBlock: [:id | ''].
        instance transitionBlock: [:idOld :idNew | ''].
        instance formatter: [:text :request :response :shelf :book :page | (formatter format: text request: request response: response shelf: shelf book: book page: page), '<br>', String cr].
        ^instance
! !

!IdFormatter class methodsFor:'utility'!

appendFormat: text request: request response: response shelf: shelf book: book page: page
	| append content today |
	content _ String streamContents: [:stream |
		(text includes: $_) ifTrue: [
			"_ means appends are seperated by lines"
			stream
				nextPutAll: '_';
				nextPutAll: String cr].
		(text includes: $@) ifTrue: [
			"@ means appends include timestamps"
			today _ Date today.
			stream
				nextPutAll: '<tt><em>';
				nextPutAll: today weekday;
				nextPutAll: ', ';
				nextPutAll: today dayOfMonth asString;
				nextPutAll: ' ';
				nextPutAll: today monthName;
				nextPutAll: ' ';
				nextPutAll: today year asString;
				nextPutAll: ', '.
			Time now printOn: stream.
			stream
				nextPutAll: '</em></tt>';
				nextPutAll: String cr].
		stream
			nextPutAll: ((book settingsAt: 'saveFormatter') format: (request fieldsKey: 'append') request: request response: response shelf: shelf book: book page: page);
			nextPutAll: String cr].
	"+ means appends are self replicating
	^ means append areas stay at top and appends go down"
	append _ text, String cr.
	^((text occurrencesOf: $+) > 1)
		ifTrue: [append, content, append]
		ifFalse: [(text includes: $^)
			ifTrue: [append, content]
			ifFalse: [content, append]]
! !

!IdFormatter methodsFor:'accessing'!

endBlock: aBlock
        (Smalltalk dialectName = 'SmalltalkX') ifTrue:[
            endBlock := (SimulatedSqueakBlock wrapIfBlock:aBlock).
            ^ self.
        ].
        endBlock _ aBlock
!

formatter: aBlock
        (Smalltalk dialectName = 'SmalltalkX') ifTrue:[
            formatter := (SimulatedSqueakBlock wrapIfBlock:aBlock).
            ^ self.
        ].
        formatter _ aBlock
!

idBlock: aBlock
        (Smalltalk dialectName = 'SmalltalkX') ifTrue:[
            idBlock := (SimulatedSqueakBlock wrapIfBlock:aBlock).
            ^ self.
        ].
        idBlock _ aBlock
!

settingsAt: key put: value
	settings ifNil: [settings _ Dictionary new].
	settings at: key put: value.
!

startBlock: aBlock
        (Smalltalk dialectName = 'SmalltalkX') ifTrue:[
            startBlock := (SimulatedSqueakBlock wrapIfBlock:aBlock).
            ^ self.
        ].
        startBlock _ aBlock
!

transitionBlock: aBlock
        (Smalltalk dialectName = 'SmalltalkX') ifTrue:[
            transitionBlock := (SimulatedSqueakBlock wrapIfBlock:aBlock).
            ^ self.
        ].
        transitionBlock _ aBlock
! !

!IdFormatter methodsFor:'private'!

id: text
	^(idBlock copy fixTemps) value: text
! !

!IdFormatter methodsFor:'processing'!

endAfter: oldId on: stream text: text request: request response: response shelf: shelf book: book page: page
	| id strippedText |

	id _ self id: text.
	((text size) > (id size))
		ifTrue: [strippedText _ text copyFrom: (id size + 1) to: text size]
		ifFalse: [strippedText _ ''].
	stream nextPutAll: ((transitionBlock copy fixTemps) value: oldId value: id).
	stream nextPutAll: ((formatter copy fixTemps) valueWithArguments: (Array with: strippedText with: request with: response with: shelf with: book with: page)).
	stream nextPutAll: ((endBlock copy fixTemps) value: id).
	^id
!

singleOn: stream text: text request: request response: response shelf: shelf book: book page: page
	| id strippedText |

	id _ self id: text.
	((text size) > (id size))
		ifTrue: [strippedText _ text copyFrom: (id size + 1) to: text size]
		ifFalse: [strippedText _ ''].
	stream nextPutAll: ((startBlock copy fixTemps) value: id).
	stream nextPutAll: ((formatter copy fixTemps) valueWithArguments: (Array with: strippedText with: request with: response with: shelf with: book with: page)).
	stream nextPutAll: ((endBlock copy fixTemps) value: id).
	^id
!

startOn: stream text: text request: request response: response shelf: shelf book: book page: page
	| id strippedText |

	id _ self id: text.
	((text size) > (id size))
		ifTrue: [strippedText _ text copyFrom: (id size + 1) to: text size]
		ifFalse: [strippedText _ ''].
	stream nextPutAll: ((startBlock copy fixTemps) value: id).
	stream nextPutAll: ((formatter copy fixTemps) valueWithArguments: (Array with: strippedText with: request with: response with: shelf with: book with: page)).
	^id
!

transitionAfter: oldId on: stream text: text request: request response: response shelf: shelf book: book page: page
        | id strippedText |

        id _ self id: text.
        ((text size) > (id size))
                ifTrue: [strippedText _ text copyFrom: (id size + 1) to: text size]
                ifFalse: [strippedText _ ''].
        stream nextPutAll: ((transitionBlock copy fixTemps) value: oldId value: id).
        stream nextPutAll: ((formatter copy fixTemps) valueWithArguments: (Array with: strippedText with: request with: response with: shelf with: book with: page)).
        ^id
! !

!IdFormatter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/IdFormatter.st,v 1.8 2003/08/29 17:05:43 cg Exp $'
! !
