"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

Object subclass:#MultipartChunk
	instanceVariableNames:'header properties multipartBoundary request'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Kom-Protocol-HTTP'
!

MultipartChunk comment:'kom/4.12 (Comanche/4.12)

MultipartChunkHeader (kom/4.8; bolot 4/2/2001 18:52)
- in kom49 (or kom50) this will be used only for internal purposes
-- applications will access multipart form fields through regular fieldAt: technique

Comment from kom46:
- this is a hack (bolot 10/25/2000 17:17)
- store a part''s (from a multipart message) header information:
-- header (raw)
-- properties (extracted and converted info, such as file-name, content-length, etc.)'
!


!MultipartChunk class methodsFor:'instance creation'!

from: aDictionary
	aDictionary isEmptyOrNil
		ifTrue: [^nil].
	^self new initializeFrom: aDictionary
! !

!MultipartChunk methodsFor:'accessing'!

contentType
	^properties at: #contentType
!

fieldName
	^properties at: #fieldName
!

fileName
	^properties at: #fileName
!

fileName: aString
	properties at: #fileName put: aString
!

multipartBoundary
	^multipartBoundary
!

saveToStream: outStream
	"Save this chunk's body in outStream"
	"the caller is responsible for closing outStream (if applicable)"
	| body origFileName idx str crlfBoundary |

	self setSavedFlag.

	origFileName _ self fileName.
	crlfBoundary _ String crlf , multipartBoundary.

	body _ request stream nextChunk.
	"IE4 for Mac appends 128 bytes of Mac file system info - must remove"
	"this fix assumes that body size >= 128"
	((body at: 1) asciiValue = 0
			and: [(body at: 2) asciiValue = origFileName size
				and: [(body copyFrom: 3 to: origFileName size + 2) = origFileName]])
		ifTrue: [body _ body copyFrom: 129 to: body size].
	[(idx _ body findString: crlfBoundary) = 0]
		whileTrue:
			[idx _ body size - crlfBoundary size + 1 max: 1.
			str _ request stream nextChunk.
			outStream nextPutAll: (body copyFrom: 1 to: idx - 1).
			body _ (body copyFrom: idx to: body size) , str].
	" save the last chunk in the file "
	outStream nextPutAll: (body copyFrom: 1 to: idx-1).
"Transcript show: 'last few bytes: ', (body copyFrom: idx+2 to: body size); cr."
	request stream putDataBack: (body copyFrom: idx+2 to: body size). "idx+2 to skip CRLF"
!

setSavedFlag
	properties at: #isSaved put: true
! !

!MultipartChunk methodsFor:'initialize-release'!

initializeFrom: aDictionary
        | str fileName fieldName idx contentType |
        "PRE: all keys in aDictionary are low-case"
        header _ aDictionary.
        properties _ Dictionary new.
        Smalltalk isSmalltalkX ifFalse:[
            self flag: #todo.
        ].
        "parse the header, pick out: filename, etc."

        str _ (header at: 'content-disposition' ifAbsent: ['']).
        fileName _ fieldName _ ''.

        idx _ str findString: 'filename='.
        idx > 0 ifTrue:
                [fileName _ str copyFrom: idx + 10 to: (str indexOf: $" startingAt: idx+10) - 1].
        properties at: #fileName put: fileName.

        idx _ str findString: 'name='.
        idx > 0 ifTrue:
                [fieldName _ str copyFrom: idx + 6 to: (str indexOf: $" startingAt: idx+6) - 1].
        properties at: #fieldName put: fieldName.

        contentType _ header at: 'content-type' ifAbsent: [MIMEDocument defaultContentType].
        properties at: #contentType put: contentType.

"Transcript show: 'field=', fieldName; cr; show: 'file=', fileName; cr;
        show: 'content-type=', contentType; cr."
!

multipartBoundary: aString
	multipartBoundary _ aString
!

request: aRequest
	request _ aRequest
! !

!MultipartChunk methodsFor:'testing'!

isSaved
	^(properties at: #isSaved ifAbsent: [false]) == true
! !

!MultipartChunk class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/MultipartChunk.st,v 1.11 2003/08/29 17:04:21 cg Exp $'
! !
