"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

Object subclass:#NetNameResolver
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-Squeak-Network-Kernel'
!


!NetNameResolver class methodsFor:'lookups'!

addressForName: aString
	^self addressForName: aString timeout: 60
!

addressForName: hostName timeout: secs
        "Look up the given host name and return its address. Return nil if the address is not found in the given number of seconds."

    ^ Socket ipAddressOfHost:hostName
!

nameForAddress: hostAddress timeout: secs
        "Look up the given host address and return its name. Return nil if the lookup fails or is not completed in the given number of seconds. Depends on the given host address being known to the gateway, which may not be the case for dynamically allocated addresses."

        ^ Socket hostWithIpAddress:hostAddress
!

stringFromAddress: addr
        "Return a string representing the given host address as four decimal bytes delimited with decimal points."
        "NetNameResolver stringFromAddress: NetNameResolver localHostAddress"

        | s |
        s _ WriteStream on: ''.
        1 to: 3 do: [ :i | (addr at: i) printOn: s. s nextPut: $.].
        (addr at: 4) printOn: s.
        ^ s contents
! !

!NetNameResolver class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/NetNameResolver.st,v 1.9 2003/08/29 17:04:27 cg Exp $'
! !
