"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

Object subclass:#NetworkRequest
	instanceVariableNames:'properties session'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Kom-Protocol-Abstract'
!

!NetworkRequest class methodsFor:'documentation'!

documentation
"
    Kom48 (Comanche beta 4.8)
    bolot 4/2/2001 18:53

    NetworkRequest
    - a generic request object
    - properties are some ad-hoc properties
    - session is not currently used

    Note about Kom46:
    - this class contained more methods
    -- some methods have been depricated since
"
! !

!NetworkRequest class methodsFor:'instance creation'!

new

	^super new initialize
! !

!NetworkRequest methodsFor:'accessing'!

method

	self subclassResponsibility
!

session
	^ session
!

session: aSession
session _ aSession
!

url

	self subclassResponsibility
! !

!NetworkRequest methodsFor:'initialize-release'!

initialize

	properties _ IdentityDictionary new.
! !

!NetworkRequest methodsFor:'properties'!

propertyAt: aSymbol

	^properties at: aSymbol
!

propertyAt: aSymbol ifAbsent: absentBlock

	^properties at: aSymbol ifAbsent: absentBlock
!

propertyAt: aSymbol ifAbsentPut: absentBlock

	^properties at: aSymbol ifAbsentPut: absentBlock
!

propertyAt: aSymbol put: anObject

	properties at: aSymbol put: anObject
!

removePropertyAt: aSymbol

	properties removeKey: aSymbol
!

removePropertyAt: aSymbol ifAbsent: aBlock

	^properties removeKey: aSymbol ifAbsent: aBlock
! !

!NetworkRequest methodsFor:'testing'!

isGetRequest

	self subclassResponsibility
!

isHeaderRequest

	self subclassResponsibility
!

isPostRequest

	self subclassResponsibility
! !

!NetworkRequest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/NetworkRequest.st,v 1.10 2003/09/11 12:48:12 cg Exp $'
! !
