"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

TextFormatter subclass:#ShelfTemplateFormatter
	instanceVariableNames:''
	classVariableNames:'SwikiFormatter'
	poolDictionaries:''
	category:'Comanche-Swiki-Formatting'
!


!ShelfTemplateFormatter class methodsFor:'accessing'!

swikiFormatter
	^SwikiFormatter
! !

!ShelfTemplateFormatter class methodsFor:'initialize-release'!

initialize
	SwikiFormatter _ self new.
	SwikiFormatter
		initialize;
		addAction: #swikiAction from: '<?' to: '?>'
! !

!ShelfTemplateFormatter methodsFor:'private'!

action: action value: value text: text
	"Overwrites parent class to add swiki action"
	^(value size = 4)
		ifTrue: ["Page Request"
			(value at: 3) formatBookAction: text with: value]
		ifFalse: ["Book Request"
			(value at: 3) formatShelfAction: text with: value]
! !

!ShelfTemplateFormatter methodsFor:'processing'!

format: template request: request response: response shelf: shelf
	"Formatting used for a shelf request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array with: request with: response with: shelf.
	self format: template actionValue: value onTo: stream.
	^stream contents
!

format: template request: request response: response shelf: shelf book: book
	"Formatting used for a book request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array with: request with: response with: shelf with: book.
	self format: template actionValue: value onTo: stream.
	^stream contents
! !

!ShelfTemplateFormatter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/ShelfTemplateFormatter.st,v 1.6 2003/08/29 17:08:44 cg Exp $'
! !

ShelfTemplateFormatter initialize!
