"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

OrderedCollection subclass:#SwikiFileVersions
	instanceVariableNames:'name mimeType'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-FileServer'
!

SwikiFileVersions comment:'SwikiFileVersions

is a subclass of OrderedCollection that holds all versions of a Swiki file.

INSTANCE VARIABLES:
name = the full name of the file (this may be an alias for the actual file name)
mimeType = the mimeType for the files'
!


!SwikiFileVersions class methodsFor:'instance creation'!

named: aString
	^self new name: aString; mimeType: (MIMEDocument guessTypeFromName: aString)
! !

!SwikiFileVersions methodsFor:'accessing'!

addEntry: aSwikiEntry
	| version size |
	aSwikiEntry versions: self.
	version _ aSwikiEntry version.
	size _ self size.
	"Pad collection, so that entries can be added in incorrect order"
	(size = version) ifTrue: [^self add: aSwikiEntry].
	(size > version) ifTrue: [^self at: (version + 1) put: aSwikiEntry].
	[self size = version] whileFalse: [self add: nil].
	self add: aSwikiEntry
!

httpName
	^TextFormatter encodeToHttp: name
!

mimeType
	^mimeType
!

mimeType: mime
        mimeType _ mime
!

name
	^name
!

name: aString
	name _ aString
!

nextVersionName
	| tokens return |
	tokens _ self first rootName findTokens: '.'.
	return _ WriteStream on: String new.
	return
		nextPutAll: (tokens at: 1);
		nextPut: $.;
		nextPutAll: (self size asString).
	(tokens size = 1) ifFalse: [2 to: tokens size do: [:i | return
		nextPut: $.;
		nextPutAll: (tokens at: i)]].
	^return contents
!

strictXmlName
	^TextFormatter encodeToStrictXmlCrlf: name
!

xmlName
	^TextFormatter encodeToXmlCrlf: name
! !

!SwikiFileVersions methodsFor:'testing'!

isAnImage
	^self last isAnImage
! !

!SwikiFileVersions class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/SwikiFileVersions.st,v 1.7 2003/08/29 17:04:18 cg Exp $'
! !
