"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

Object subclass:#SwikiSchemeReadWriter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-Modules'
!


!SwikiSchemeReadWriter class methodsFor:'utility'!

schemesToXml: schemes
	| return |
	return _ WriteStream on: String new.
	return
		nextPutAll: '<?xml version="1.0"?>
<schemes>
'.
	schemes do: [:scheme |
		return
			nextPutAll: '<scheme name="';
			nextPutAll: (TextFormatter encodeToStrictXmlCr: (scheme at: 1));
			nextPutAll: '" next="';
			nextPutAll: (TextFormatter encodeToStrictXmlCr: (scheme at: 4));
			nextPutAll: '">';
			nextPutAll: String cr.
		"Text Forms"
		(scheme at: 2) do: [:form | return
			nextPutAll: '<form name="';
			nextPutAll: (TextFormatter encodeToStrictXmlCr: form);
			nextPutAll: '" type="text" />';
			nextPutAll: String cr].
		"Project Forms"
		(scheme at: 3) do: [:form | return
			nextPutAll: '<form name="';
			nextPutAll: (TextFormatter encodeToStrictXmlCr: form);
			nextPutAll: '" type="project" />';
			nextPutAll: String cr].
		return
			nextPutAll: '</scheme>';
			nextPutAll: String cr].
	^return
		nextPutAll: '</schemes>';
		contents
!

xmlToSchemes: xml
	| pos1 pos2 pos3 pos4 return scheme formsXml textForms projectForms |
	return _ OrderedCollection new.
	pos2 _ xml findString: '<schemes>'.
	[0 = (pos1 _ xml findString: '<scheme name="' startingAt: pos2)] whileFalse: [
		scheme _ Array new: 4.
		pos2 _ xml findString: '" next="' startingAt: pos1.
		scheme at: 1 put: (TextFormatter decodeFromXmlCr: (xml
			copyFrom: (pos1 + 14) to: (pos2 - 1))).
		pos1 _ xml findString: '">' startingAt: pos2.
		scheme at: 4 put: (TextFormatter decodeFromXmlCr: (xml
			copyFrom: (pos2 + 8) to: (pos1 -1))).
		pos2 _ xml findString: '</scheme>' startingAt: pos1.
		formsXml _ xml copyFrom: (pos1 + 2) to: (pos2 - 1).
		textForms _ OrderedCollection new.
		projectForms _ OrderedCollection new.
		pos4 _ 1.
		[0 = (pos3 _ formsXml findString:  '<form name="' startingAt: pos4)] whileFalse: [
			pos4 _ formsXml findString: '" type="' startingAt: pos3.
			(((formsXml at: (pos4 + 8)) =  $t) ifTrue: [textForms] ifFalse: [projectForms])
				add: (TextFormatter decodeFromXmlCr: (formsXml
				copyFrom: (pos3 + 12) to: (pos4 - 1)))].
		scheme
			at: 2 put: textForms;
			at: 3 put: projectForms.
		return add: scheme].
	^return
! !

!SwikiSchemeReadWriter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/SwikiSchemeReadWriter.st,v 1.6 2003/08/29 17:04:14 cg Exp $'
! !
