"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

Object subclass:#SwikiStructure
	instanceVariableNames:'name storage settings modules sema'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-Structure'
!


!SwikiStructure class methodsFor:'instance creation'!

new
	^super new
		initialize;
		yourself
! !

!SwikiStructure methodsFor:'accessing'!

name
	^name
!

name: aString
	name _ aString
! !

!SwikiStructure methodsFor:'initialization'!

initialize
	modules _ Dictionary new.
	settings _ Dictionary new.
	sema _ Semaphore forMutualExclusion
! !

!SwikiStructure methodsFor:'modules'!

modules
	^modules
!

modules: anObject
	modules _ anObject
!

modulesAt: key
	^modules at: key
!

modulesAt: key ifAbsent: block
	^modules at: key ifAbsent: block
!

modulesAt: key put: value
        modules at: key put: value
!

modulesIncludes: key
	^modules includesKey: key
!

modulesRemove: key
	^modules removeKey: key ifAbsent: []
! !

!SwikiStructure methodsFor:'settings'!

settings
	^settings
!

settings: anObject
	settings _ anObject
!

settingsAt: key
	^settings at: key
!

settingsAt: key ifAbsent: block
	^settings at: key ifAbsent: block
!

settingsAt: key put: value
	^settings at: key put: value
!

settingsIncludes: key
	^settings includesKey: key
!

settingsRemove: key
	^settings removeKey: key ifAbsent: []
! !

!SwikiStructure methodsFor:'storage'!

forbidWriting
	sema wait
!

permitWriting
	sema signal
!

storage
	^storage
!

storage: aSwikiStorage
	storage _ aSwikiStorage
! !

!SwikiStructure methodsFor:'utility'!

asExplorerString
	^super asExplorerString, '--', name
!

defaultLabelForInspector
	^super defaultLabelForInspector, ': ', name
! !

!SwikiStructure class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/SwikiStructure.st,v 1.7 2003/08/29 17:05:10 cg Exp $'
! !
