"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

SwikiBook subclass:#SwikiSubBook
	instanceVariableNames:'parent'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-Structure'
!

SwikiSubBook comment:'SwikiSubBook

this is a SwikiBook that inherits its properties from another SwikiBook.

INSTANCE VARIABLES:
parent = the SwikiBook that the swiki inherits from'
!


!SwikiSubBook methodsFor:'inheritance'!

hasParent
	^true
!

hasSuper: aBook
	^(parent = aBook)
		ifTrue: [true]
		ifFalse: [parent hasSuper: aBook]
!

parent
	^parent
!

parent: aBook
	parent _ aBook
! !

!SwikiSubBook methodsFor:'modules'!

modules
	^(parent modules) addAll: modules
!

modulesAt: key
	^modules at: key ifAbsent: [parent modulesAt: key]
!

modulesAt: key ifAbsent: block
	^modules at: key ifAbsent: [parent modulesAt: key ifAbsent: block]
!

modulesIncludes: key
	^(modules includesKey: key)
		ifTrue: [true]
		ifFalse: [parent modulesIncludes: key]
!

modulesRemove: key
	modules removeKey: key ifAbsent: [^self error: 'Parent modules must be removed from parent']
! !

!SwikiSubBook methodsFor:'private'!

bookActionNamed: actionName
	^bookActions at: actionName ifAbsent: [parent bookActionNamed: actionName]
!

bookAddressNamed: addressName
	^bookAddresses at: addressName ifAbsent: [parent bookAddressNamed: addressName]
!

bookTemplateNamed: templateName
	^bookTemplates at: templateName ifAbsent: [parent bookTemplateNamed: templateName]
!

pageActionNamed: actionName
	^pageActions at: actionName ifAbsent: [parent pageActionNamed: actionName]
!

pageAddressNamed: addressName
	^pageAddresses at: addressName ifAbsent: [parent pageAddressNamed: addressName]
!

pageTemplateNamed: templateName
	^pageTemplates at: templateName ifAbsent: [parent pageTemplateNamed: templateName]
!

privAddressNamed: addressName
	^privAddresses at: addressName ifAbsent: [parent privAddressNamed: addressName]
! !

!SwikiSubBook methodsFor:'settings'!

settings
	^(parent settings) addAll: settings
!

settingsAt: key
	^settings at: key ifAbsent: [parent settingsAt: key]
!

settingsAt: key ifAbsent: block
	^settings at: key ifAbsent: [parent settingsAt: key ifAbsent: block]
!

settingsIncludes: key
	^(settings includesKey: key)
		ifTrue: [true]
		ifFalse: [parent settingsIncludes: key]
!

settingsRemove: key
	settings removeKey: key ifAbsent: [self error: 'Parent settings must be removed from parent']
! !

!SwikiSubBook methodsFor:'storage'!

loadPages
	| kind |
	kind _ setup at: 'pageStorage' ifAbsent: [XmlSwikiStorage].
	pages _ (storage dir directoryExists: 'pages')
		ifTrue: [(kind fromDir: (storage dir directoryNamed: 'pages')) loadPages]
		ifFalse: [parent pages]
! !

!SwikiSubBook methodsFor:'testing'!

hasBookAddress: addressName
	^(bookAddresses includesKey: addressName)
		ifTrue: [true]
		ifFalse: [parent hasBookAddress: addressName]
!

hasBookTemplate: templateName
	^(bookTemplates includesKey: templateName)
		ifTrue: [true]
		ifFalse: [parent hasBookTemplate: templateName]
!

hasPageAddress: addressName
	^(pageAddresses includesKey: addressName)
		ifTrue: [true]
		ifFalse: [parent hasPageAddress: addressName]
!

hasPageTemplate: templateName
	^(pageTemplates includesKey: templateName)
		ifTrue: [true]
		ifFalse: [parent hasPageTemplate: templateName]
!

hasPrivAddress: addressName
	^(privAddresses includesKey: addressName)
		ifTrue: [true]
		ifFalse: [parent hasPrivAddress: addressName]
! !

!SwikiSubBook class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/SwikiSubBook.st,v 1.6 2003/08/29 17:04:16 cg Exp $'
! !
