"{ Package: 'stx:goodies/webServer/comanche/swiki' }"

"{ NameSpace: Comanche }"

SwikiDirectory subclass:#SwikiSubDirectory
	instanceVariableNames:'containingDirectory'
	classVariableNames:''
	poolDictionaries:''
	category:'Comanche-Swiki-FileServer'
!

SwikiSubDirectory comment:'SwikiSubDirectory

is a sub-directory. Thus, it has all the features of a SwikiDirectory, but it also has a containingDirectory.

INSTANCE VARIABLES:
containingDirectory = the SwikiDirectory which contains this instance (may be nil)'
!


!SwikiSubDirectory class methodsFor:'instance creation'!

fromArray: arr onDir: dir containingDirectory: aSwikiDirectory
	| instance |
	instance _ self fromArray: arr.
	instance dir: dir.
	instance containingDirectory: aSwikiDirectory.
	instance initialize.
	^instance
! !

!SwikiSubDirectory methodsFor:'accessing'!

containingDirectory
	^containingDirectory
!

containingDirectory: aSwikiDirectory
	containingDirectory _ aSwikiDirectory
!

httpPath
	^(containingDirectory httpPath), (self localHttpPath)
!

localHttpPath
	^self httpName, '/'
! !

!SwikiSubDirectory methodsFor:'cacheing'!

addToDirServeCache: aSubSwikiDir at: key
	super addToDirServeCache: aSubSwikiDir at: key.
	"Recurse Upward in Hierarchy"
	containingDirectory addToDirServeCache: aSubSwikiDir at: (self localHttpPath, key)
! !

!SwikiSubDirectory methodsFor:'initialization'!

initializeDirectories
	super initializeDirectories.
	"dirServeCache"
	containingDirectory addToDirServeCache: self at: self localHttpPath
! !

!SwikiSubDirectory methodsFor:'testing'!

isASubDirectory
	^true
! !

!SwikiSubDirectory class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/SwikiSubDirectory.st,v 1.6 2003/08/29 17:08:50 cg Exp $'
! !
