"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

XPSwikiPage subclass:#AcceptanceTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Pages'
!


!AcceptanceTest methodsFor:'accessing'!

description
	^ self textKey: 'description'
!

passed
	^ (self textKey: 'passed') = 'true'
!

status
	^ (self passed = true) 	ifTrue:['Passed'] 
							ifFalse:['NotPassed']
!

userStory
        | textUserStory idStory |

        textUserStory := self textKey: 'userStory'. 
        " *2* became 2"
        Smalltalk isSmalltalkX ifTrue:[
            idStory := textUserStory squeakAsInteger.
        ] ifFalse:[
            idStory := textUserStory asInteger.
        ].
        ^ (idStory isNil) ifTrue:[nil] ifFalse:[book pages at: idStory].
!

userStory: userStoryName
"da refactorare evitando una scrittura doppia della stessa chiave userStory"	
	| newText element oldText story userStoryId |
	(userStoryName = '') 
			ifTrue: [ userStoryId _ '']
			ifFalse: [
				story:= book pageNamed: userStoryName.
				userStoryId _ story id asString asSwikiLink].

	newText _ Dictionary new.
     oldText _ self text.
	oldText keysAndValuesDo: [:key :value |
		element _ value.
		(key = 'userStory')
			ifTrue: [element _ userStoryId].
		newText at: key put: element].
	newText at: 'userStory' put: userStoryId.
	^self text: newText
! !

!AcceptanceTest methodsFor:'presentation'!

editLocked
"Override me if you want a different template for editing your locked page"
 
^ 'editLockedXP'
!

editUnlocked
"Override me if you want a different template for editing your locked page"
 
^ 'editUnlockedXP'
! !

!AcceptanceTest methodsFor:'testing'!

ifPassed: aBlock ifNotPassed: anotherBlock 
	^ self passed ifTrue: aBlock ifFalse: anotherBlock
! !

!AcceptanceTest methodsFor:'utility'!

addToCatalog
	
	self isDeleted ifFalse: [self catalog addAcceptanceTest: self]
!

catalog
^ self book pages at:7
!

removeFromCatalog
	self catalog removeAcceptanceTest: self
! !

!AcceptanceTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__AcceptanceTest.st,v 1.3 2004/03/18 08:28:05 penk Exp $'
! !
