"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

TestCase subclass:#AcceptanceTestsCatalogTest
	instanceVariableNames:'launcher module shelf request response book catalog'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Tests'
!


!AcceptanceTestsCatalogTest methodsFor:'tests'!

setUp
	launcher _ XPSwikiLauncher package: #swikiWebServer.
	launcher port: 8080.
	module _ launcher startServer.
	shelf _ module shelf.
	request _ MockSwikiRequest new.
	request address: 'newTest'.
	response _ Dictionary new.
	book _ shelf bookNamed: 'testing'.
	catalog _ book pages at: 7
!

tearDown
	launcher stopServer
!

testAcceptanceTests
	self assert: (book acceptanceTestsCatalog acceptanceTests isKindOf: Collection)
!

testNewTest
	request fieldsAt: 'name' put: 'Test'.
	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: catalog.
	self
		assert: ((book pages at: book pages size)
				isKindOf: AcceptanceTest).
	self assert: (response at: 'headerStatus')
			= #tempMoved
!

testNewTestExistingName
	request fieldsAt: 'name' put: 'Test1'.
	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: catalog.
	self
		should: [(response at: 'headerStatus')
				= #notFound]
!

testNewTestNoName
	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: catalog.
	self
		should: [(response at: 'headerStatus')
				= #notFound]
! !

!AcceptanceTestsCatalogTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__AcceptanceTestsCatalogTest.st,v 1.1 2004/03/16 17:52:35 cg Exp $'
! !
