"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

HttpSwikiRequest subclass:#HttpXPSwikiRequest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Comanche'
!


!HttpXPSwikiRequest methodsFor:'accessing'!

getFields
	^ raw getFields
!

postFields
	^ raw postFields
! !

!HttpXPSwikiRequest methodsFor:'as yet unclassified'!

referenceShelfSpike: shelf book: theBook address: theAddress
	^'/', theBook name, '/',  '6.', theAddress 
! !

!HttpXPSwikiRequest methodsFor:'fields'!

fieldsHasKeyStartingWith: aString 
	^ self postFields
		ifNil: [self getFields
				ifNil: [false]
				ifNotNil: [self getFields hasKeyStartingWith: aString]]
		ifNotNil: [(self postFields hasKeyStartingWith: aString)
				or: [self getFields ifNil: [false] ifNotNil: [self getFields hasKeyStartingWith: aString]]]
!

getFieldsStartingWith: aString 
	| result |
	result _ Dictionary new.
	self getFields
		keysAndValuesDo: [:key : value | (key beginsWith: aString)
				ifTrue: [| newKey | 
					newKey _ key copyFrom: 5 to: key size.
					newKey at: 1 put: (newKey at: 1) asLowercase.
					result
						at: newKey
						put: (self fieldsKey: key)]].
	^ result
!

postFieldsStartingWith: aString 
	| result |
	result _ Dictionary new.
	self postFields
		keysAndValuesDo: [:key :value | (key beginsWith: aString)
				ifTrue: [| newKey | 
					newKey _ key copyFrom: 5 to: key size.
					newKey at: 1 put: (newKey at: 1) asLowercase.
					result
						at: newKey
						put: (self fieldsKey: key)]].
	^ result
! !

!HttpXPSwikiRequest methodsFor:'utility'!

formText
	| prefix |
	prefix _ 'text'.
	self postFields
		ifNil: [self getFields
				ifNil: [^ Dictionary new]
				ifNotNil: [^ self getFieldsStartingWith: prefix]]
		ifNotNil: [self postFields isEmpty
				ifTrue: [^ self getFieldsStartingWith: prefix]
				ifFalse: [^ self postFieldsStartingWith: prefix]].
! !

!HttpXPSwikiRequest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__HttpXPSwikiRequest.st,v 1.1 2004/03/16 17:53:45 cg Exp $'
! !
