"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

TestCase subclass:#HttpXPSwikiRequestTest
	instanceVariableNames:'request rawRequest'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Tests'
!


!HttpXPSwikiRequestTest methodsFor:'tests'!

setUp
rawRequest _ (MockHttpRequest url: 'http://localhost:8080/test/test.txt').
	request _ HttpXPSwikiRequest fromHttpRequest: rawRequest
!

testFieldsHasKeyStartingWithEmptyFields
	self
		shouldnt: (request fieldsHasKeyStartingWith: 'test')
!

testFieldsHasKeyStartingWithGetField
	rawRequest postFields: nil.
	rawRequest getFieldsAt: 'test' put: 'test'.
	self
		should: (request fieldsHasKeyStartingWith: 'test').
	rawRequest postFields: Dictionary new.
		self
		should: (request fieldsHasKeyStartingWith: 'test')
!

testFieldsHasKeyStartingWithNoFields
	rawRequest getFields: nil; postFields: nil.
	self
		shouldnt: (request fieldsHasKeyStartingWith: 'test')
!

testFieldsHasKeyStartingWithPostField
	rawRequest postFieldsAt: 'test' put: 'test'.
	self
		should: (request fieldsHasKeyStartingWith: 'test').
	rawRequest getFields: nil; postFields: Dictionary new.
	self
		shouldnt: (request fieldsHasKeyStartingWith: 'test')
!

testFormTextFromGetFields
	| result |
	rawRequest getFields at: 'textA' put: 'a';
		 at: 'textB' put: 'b';
		 at: 'dummy' put: 1.
	rawRequest postFields: nil.
	self
		assert: (request formText isKindOf: Dictionary).
	self assert: request formText size = 2.
	result _ Dictionary new.
	result at: 'a' put: 'a';
		 at: 'b' put: 'b'.
	self assert: request formText = result.
	rawRequest getFields: nil.
	self
		assert: (request formText isKindOf: Dictionary).
	self assert: request formText size = 0
!

testFormTextFromPostFields
	| result |
	rawRequest postFields at: 'textA' put: 'a';
		 at: 'textB' put: 'b';
		 at: 'dummy' put: 1.
	self
		assert: (request formText isKindOf: Dictionary).
	self assert: request formText size = 2.
	result _ Dictionary new.
	result at: 'a' put: 'a';
		 at: 'b' put: 'b'.
	self assert: request formText = result.
	rawRequest postFields: nil.
	self
		assert: (request formText isKindOf: Dictionary).
	self assert: request formText size = 0.
!

testGetFields
	rawRequest getFieldsAt: 'test' put: 'test'.
	self assert: (request getFields at: 'test')
			= 'test'
!

testPostFields
	rawRequest postFieldsAt: 'test' put: 'test'.
	self assert: (request postFields at: 'test')
			= 'test'
!

testTextNoTextField
	rawRequest getFieldsAt: 'text1' put: 'test'.
	self
		assert: (request text isKindOf: Dictionary).
	self assert: (request text
			at: '1'
			ifAbsent: [''])
			= 'test'
!

testTextWithTextField
	rawRequest getFieldsAt: 'text' put: 'test'.
	self
		should: [request text = 'test']
! !

!HttpXPSwikiRequestTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__HttpXPSwikiRequestTest.st,v 1.1 2004/03/16 17:54:35 cg Exp $'
! !
