"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

XPSwikiPage subclass:#Iteration
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Pages'
!


!Iteration methodsFor:'accessing'!

capacity
        |capacityPoints|
        capacityPoints := [(self textKey: 'capacity') asNumber] ifError:[nil].
        ^ (capacityPoints isNil) ifTrue:[0] ifFalse:[capacityPoints]
!

endDate
"date is nil if self textKey: 'endDate' is empty or if an error occur in the date format"

	| endDate |
	endDate _ self textKey: 'endDate'.
	endDate isEmpty
					ifTrue: [^ nil]
					ifFalse: [[endDate _ (endDate asDate)] ifError: [^ nil]].

	^ endDate.
!

release
        |textRelease idRelease|

        textRelease := self textKey: 'release'. 
        " *2* became 2"
        Smalltalk isSmalltalkX ifTrue:[
            idRelease := textRelease squeakAsInteger.
        ] ifFalse:[
            idRelease := textRelease asInteger.
        ].
        ^ (idRelease isNil) ifTrue:[nil] ifFalse:[book pages at: idRelease].
!

release: releaseName
"da refactorare evitando una scrittura doppia della stessa chiave iteration"	
	| newText element oldText release releaseId |
	(releaseName = '') 
			ifTrue: [ releaseId _ '']
			ifFalse: [
				release:= book pageNamed: releaseName.
				releaseId _ release id asString asSwikiLink].

	newText _ Dictionary new.
     oldText _ self text.
	oldText keysAndValuesDo: [:key :value |
		element _ value.
		(key = 'release')
			ifTrue: [element _ releaseId].
		newText at: key put: element].
	newText at: 'release' put: releaseId.
	^self text: newText
!

startDate
	"date is nil if self textKey: 'startDate' is '' or if an error occur in the date format"

	| startDate |
	startDate _ self textKey: 'startDate'.
	startDate isEmpty
					ifTrue: [^ nil]
					ifFalse: [[startDate _ (startDate asDate)] ifError: [^ nil]].

	
	^ startDate.
! !

!Iteration methodsFor:'history'!

capacityHistory
	| history versions |
	versions _ self versions.
	history _ Dictionary new.
	versions
		do: [:version | history at: version date put: version capacity].
	^ history
!

capacityInDate: aDate
	| keys history |
	history _ self capacityHistory.
	keys _ history keys asSortedCollection
				select: [:aKey | aKey <= aDate].
	^ keys isEmpty
		ifTrue: [0]
		ifFalse: [history at: keys last]
!

datesHistory
	|stories dates versions |
	stories _ self userStories.
	dates _ Set new.
	versions _ self versions.
	versions
		do: [:version | dates add: version date].
	stories do: [:aStory| 
					 aStory datesHistory do:[:aDate| 
											dates add: aDate]].
	^ dates asSortedCollection
!

loadFromTasksInDate: aDate 
	^ self userStories
		inject: 0
		into: [:sum :story | sum
				+ (story pointsEstimatedFromTasksInDate: aDate)]
!

loadInDate: aDate 
	^ self userStories
		inject: 0
		into: [:sum :story | sum
				+ (story pointsEstimatedInDate: aDate)]
!

pointsDoneInDate: aDate 
	^ self userStories
		inject: 0
		into: [:sum :story | sum
				+ (story pointsDoneInDate: aDate)]
!

pointsLeftFromTasksInDate: aDate 
	^ self userStories
		inject: 0
		into: [:sum :story | sum
				+ (story pointsLeftFromTasksInDate: aDate)]
!

pointsLeftInDate: aDate 
	^ self userStories
		inject: 0
		into: [:sum :story | sum
				+ (story pointsLeftInDate: aDate)]
! !

!Iteration methodsFor:'presentation'!

editLocked
"Override me if you want a different template for editing your locked page"
 
^ 'editLockedXP'
!

editUnlocked
"Override me if you want a different template for editing your locked page"
 
^ 'editUnlockedXP'
! !

!Iteration methodsFor:'querying'!

load
	^ self userStories inject: 0 into: [:sum :story | sum + story pointsEstimated]
!

loadFromTasks
	^ self userStories inject: 0 into: [:sum :story | sum + story pointsEstimatedFromTasks]
!

pointsDone
	^ self userStories inject: 0 into: [:sum :story | sum + story pointsDone]
!

pointsLeft
	^ self userStories inject: 0 into: [:sum :story | sum + story pointsLeft]
!

pointsLeftFromTasks
	^ self userStories inject: 0 into: [:sum :story | sum + story pointsLeftFromTasks]
!

pointsTotalOLD
	^ self pointsDone + self pointsLeft
!

userStories
	^ self book userStoriesCatalog stories select: [:aStory | aStory iteration = self]
! !

!Iteration methodsFor:'utility'!

addToCatalog
	self isDeleted ifFalse: [self catalog addIteration: self]
!

catalog
^ self book pages at: 4
!

removeFromCatalog
	self catalog removeIteration: self
! !

!Iteration class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__Iteration.st,v 1.3 2004/03/18 08:28:00 penk Exp $'
! !
