"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

Object subclass:#MockSwikiRequest
	instanceVariableNames:'fields settings address text'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Mocks'
!


!MockSwikiRequest class methodsFor:'instance creation'!

new
	^ super new initialize
! !

!MockSwikiRequest methodsFor:'accessing'!

address
	^ address
!

address: aString
 address _ aString
!

text
	^ text
!

text: anObject 
	text _ anObject
! !

!MockSwikiRequest methodsFor:'fields'!

fieldsAsBooleanKey: key 
	^ (fields
		at: key
		ifAbsent: [false])
		= 'true'
!

fieldsAsNumberKey: key ifAbsent: aBlock 
	^ (fields at: key ifAbsent: aBlock) asNumber
!

fieldsAt: key put: value 
	^ fields at: key put: value
!

fieldsHasKey: aKey 
	^ fields includesKey: aKey
!

fieldsHasKeyStartingWith: aString
	 fields keysDo: [:key | (key beginsWith: aString) ifTrue: [^ true]]. 
^false
!

fieldsKey: aKey 
	^ fields
		at: aKey
		ifAbsent: ['']
!

fieldsKey: key ifAbsent: aBlock 
	^ fields at: key ifAbsent: aBlock
!

fieldsRemoveKey: key 
	^ fields
		removeKey: key
		ifAbsent: []
! !

!MockSwikiRequest methodsFor:'initialize-release'!

initialize
	fields _ Dictionary new.
	settings _ Dictionary new
! !

!MockSwikiRequest methodsFor:'references'!

referenceShelf: shelf address: theAddress 
	^ '/' , theAddress
!

referenceShelf: shelf book: theBook 
	^ '/' , theBook name
!

referenceShelf: shelf book: theBook address: theAddress 
	^ '/' , theBook name , '/' , theAddress
!

referenceShelf: shelf book: theBook page: thePage 
	^ '/' , theBook name , '/' , thePage id asString
!

referenceShelf: shelf book: theBook page: thePage address: theAddress 
	^ '/' , theBook name , '/' , thePage id asString , '.' , theAddress
! !

!MockSwikiRequest methodsFor:'settings'!

settingsAt: key 
	^ settings at: key ifAbsent: []
!

settingsAt: key ifAbsent: aBlock
	^ settings at: key ifAbsent: aBlock
!

settingsAt: key put: value
	^ settings at: key put: value
! !

!MockSwikiRequest methodsFor:'utility'!

user
	^ NetNameResolver addressFromString: '127.0.0.1'
! !

!MockSwikiRequest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__MockSwikiRequest.st,v 1.1 2004/03/16 17:53:35 cg Exp $'
! !
