"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

XPSwikiPage subclass:#Release
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Pages'
!


!Release methodsFor:'accessing'!

capacity
        |capacityPoints|
        capacityPoints := [(self textKey: 'capacity') asNumber] ifError:[nil].
        ^ (capacityPoints isNil) ifTrue:[0] ifFalse:[capacityPoints]
!

endDate
"date is nil if self textKey: 'endDate' is empty or if an error occur in the date format"

	| endDate |
	endDate _ self textKey: 'endDate'.
	endDate isEmpty
					ifTrue: [^ nil]
					ifFalse: [[endDate _ (endDate asDate)] ifError: [^ nil]].

	^ endDate.
!

startDate
	"date is nil if self textKey: 'startDate' is '' or if an error occur in the date format"

	| startDate |
	startDate _ self textKey: 'startDate'.
	startDate isEmpty
					ifTrue: [^ nil]
					ifFalse: [[startDate _ (startDate asDate)] ifError: [^ nil]].

	
	^ startDate.
! !

!Release methodsFor:'history'!

capacityHistory
	| history versions |
	versions _ self versions.
	history _ Dictionary new.
	versions
		do: [:version | history at: version date put: version capacity].
	^ history
!

capacityInDate: aDate
	| keys history |
	history _ self capacityHistory.
	keys _ history keys asSortedCollection
				select: [:aKey | aKey <= aDate].
	^ keys isEmpty
		ifTrue: [0]
		ifFalse: [history at: keys last]
!

dateSpan
	| start end span |
	span _ OrderedCollection new.
	start _ self startDate.
	end _ self endDate.
	start
		ifNil: [^ span].
	end
		ifNil: [end _ Date today].
	[start <= end]
		whileTrue: [span add: start.
			start _ start next].
	^ span
!

datesHistory
	|iterations dates versions |
	iterations _ self iterations.
	dates _ Set new.
	versions _ self versions.
	versions
		do: [:version | dates add: version date].
	iterations do: [:aIteration| 
					 aIteration datesHistory do:[:aDate| 
											dates add: aDate]].
	^ dates asSortedCollection
!

loadFromTasksInDate: aDate 
	^ self iterations
		inject: 0
		into: [:sum :iteration | sum
				+ (iteration loadFromTasksInDate: aDate)]
!

loadInDate: aDate 
	^ self iterations
		inject: 0
		into: [:sum :iteration | sum
				+ (iteration loadInDate: aDate)]
!

pointsDoneInDate: aDate 
	^ self iterations
		inject: 0
		into: [:sum :iteration | sum
				+ (iteration pointsDoneInDate: aDate)]
!

pointsLeftFromTasksInDate: aDate 
	^ self iterations
		inject: 0
		into: [:sum :iteration | sum
				+ (iteration pointsLeftFromTasksInDate: aDate)]
!

pointsLeftInDate: aDate 
	^ self iterations
		inject: 0
		into: [:sum :iteration | sum
				+ (iteration pointsLeftInDate: aDate)]
! !

!Release methodsFor:'presentation'!

editLocked
"Override me if you want a different template for editing your locked page"
 
^ 'editLockedXP'
!

editUnlocked
"Override me if you want a different template for editing your locked page"
 
^ 'editUnlockedXP'
! !

!Release methodsFor:'querying'!

iterations
	^ self book iterationsCatalog iterations select: [:aIteration | aIteration release = self]
!

load
	^ self iterations inject: 0 into: [:sum :iteration | sum + iteration load]
!

loadFromTasks
	^ self iterations inject: 0 into: [:sum :iteration | sum + iteration loadFromTasks]
!

pointsDone
	^ self iterations inject: 0 into: [:sum :iteration | sum + iteration pointsDone]
!

pointsLeft
	^ self iterations inject: 0 into: [:sum :iteration | sum + iteration pointsLeft]
!

pointsLeftFromTasks
	^ self iterations inject: 0 into: [:sum :iteration | sum + iteration pointsLeftFromTasks]
!

pointsTotal
	^ self pointsDone + self pointsLeft
! !

!Release methodsFor:'utility'!

addToCatalog
	self isDeleted ifFalse: [self catalog addRelease: self]
!

catalog
^ self book pages at: 3
!

removeFromCatalog
	self catalog removeRelease: self
! !

!Release class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__Release.st,v 1.2 2004/03/18 08:27:54 penk Exp $'
! !
