"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

XPSwikiPage subclass:#Task
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Pages'
!


!Task methodsFor:'accessing'!

description
	^ self textKey: 'description'
!

developer
        
        |textDeveloper idDeveloper |

        textDeveloper := self textKey: 'developer'. 
        " *8* became 8"
        Smalltalk isSmalltalkX ifTrue:[
            idDeveloper := textDeveloper squeakAsInteger.
        ] ifFalse:[
            idDeveloper := textDeveloper asInteger.
        ].
        ^ (idDeveloper isNil) ifTrue:[nil] ifFalse:[book pages at: idDeveloper].
!

developer: developerName
"da refactorare evitando una scrittura doppia della stessa chiave developer"	
	| newText element oldText developer developerId |
	(developerName = '') 
			ifTrue: [ developerId _ '']
			ifFalse: [
				developer:= book pageNamed: developerName.
				developerId _ developer id asString asSwikiLink].

	newText _ Dictionary new.
     oldText _ self text.
	oldText keysAndValuesDo: [:key :value |
		element _ value.
		(key = 'developer')
			ifTrue: [element _ developerId].
		newText at: key put: element].
	newText at: 'developer' put: developerId.
	^self text: newText
!

endDate
"date is nil if self textKey: 'endDate' is empty or if an error occur in the date format"

	| endDate |
	endDate _ self textKey: 'endDate'.
	endDate isEmpty
					ifTrue: [^ nil]
					ifFalse: [[endDate _ (endDate asDate)] ifError: [^ nil]].

	^ endDate.
!

pointsDone
        
        | pointsDone |
        Smalltalk isSmalltalkX ifTrue:[
            pointsDone :=  Error handle:[:ex| ex return:0] do:[(self textKey: 'pointsDone') asNumber].
        ] ifFalse:[
            pointsDone := (self textKey: 'pointsDone') asNumber.
        ].
        ^ (pointsDone isNil) ifTrue:[0] ifFalse:[ pointsDone]
!

pointsEstimated
        | pointsEstimated |
        
        Smalltalk isSmalltalkX ifTrue:[
            pointsEstimated :=  Error handle:[:ex| ex return:0] do:[(self textKey: 'pointsEstimated') asNumber].
        ] ifFalse:[
            pointsEstimated := (self textKey: 'pointsEstimated') asNumber.
        ].
        ^ (pointsEstimated isNil) ifTrue:[0] ifFalse:[pointsEstimated]
!

pointsLeft
	
	(self pointsEstimated > 0)
				ifTrue:[^ self pointsEstimated - self pointsDone]
				ifFalse:[^ 0]
	
!

pointsLeftOLD
	| pointsLeft |
	pointsLeft := (self textKey: 'pointsLeft') asInteger.
	^ (pointsLeft isNil) ifTrue:[0] ifFalse:[pointsLeft]
!

startDate
"date is nil if self textKey: 'startDate' is '' or if an error occur in the date format"

	| startDate |
	startDate _ self textKey: 'startDate'.
	startDate isEmpty
					ifTrue: [^ nil]
					ifFalse: [[startDate _ (startDate asDate)] ifError: [^ nil]].

	
	^ startDate.
!

status
"TODO, InProgress, Done"
 
|startDate endDate status|



startDate _ self startDate.
endDate _ self endDate.

status _ 'ToDo'.
(startDate notNil) ifTrue: [ ((startDate < Date today) | (startDate = Date today) | (self pointsDone > 0)) 
																				ifTrue:[status _ 'InProgress']].

(endDate notNil) ifTrue:[ ((endDate < Date today) | (endDate = Date today))
									ifTrue:[status _ 'Done']].

 
 ^ status
!

userStory
        
        | textUserStory idStory |

        textUserStory := self textKey: 'userStory'. 
        " *2* become 2"
        Smalltalk isSmalltalkX ifTrue:[
            idStory := textUserStory squeakAsInteger.
        ] ifFalse:[
            idStory := textUserStory asInteger.
        ].
        ^ (idStory isNil) ifTrue:[nil] ifFalse:[book pages at: idStory].
!

userStory: userStoryName
"da refactorare evitando una scrittura doppia della stessa chiave userStory"	
	| newText element oldText story userStoryId |
	(userStoryName = '') 
			ifTrue: [ userStoryId _ '']
			ifFalse: [
				story:= book pageNamed: userStoryName.
				userStoryId _ story id asString asSwikiLink].

	newText _ Dictionary new.
     oldText _ self text.
	oldText keysAndValuesDo: [:key :value |
		element _ value.
		(key = 'userStory')
			ifTrue: [element _ userStoryId].
		newText at: key put: element].
	newText at: 'userStory' put: userStoryId.
	^self text: newText
! !

!Task methodsFor:'history'!

datesHistory
	| versions dates|
	dates _ Set new.
	versions _ self versions.
	versions
		do: [:version | dates add: version date].
	
	^ dates asSortedCollection
!

pointsDoneHistory
	| history versions |
	versions _ self versions.
	history _ Dictionary new.
	versions
		do: [:version | history at: version date put: version pointsDone].
	^ history
!

pointsDoneInDate: aDate 
	| keys history |
	history _ self pointsDoneHistory.
	keys _ history keys asSortedCollection
				select: [:aKey | aKey <= aDate].
	^ keys isEmpty
		ifTrue: [0]
		ifFalse: [history at: keys last]
!

pointsEstimatedHistory
	| history versions |
	versions _ self versions.
	history _ Dictionary new.
	versions
		do: [:version | history at: version date put: version pointsEstimated].
	^ history
!

pointsEstimatedInDate: aDate 
	| keys history |
	history _ self pointsEstimatedHistory.
	keys _ history keys asSortedCollection
				select: [:aKey | aKey <= aDate].
	^ keys isEmpty
		ifTrue: [0]
		ifFalse: [history at: keys last]
!

pointsLeftHistory
	| history versions |
	versions _ self versions.
	history _ Dictionary new.
	versions
		do: [:version | history at: version date put: version pointsLeft].
	^ history
!

pointsLeftInDate: aDate 
	| keys history |
	history _ self pointsLeftHistory.
	keys _ history keys asSortedCollection
				select: [:aKey | aKey <= aDate].
	^ keys isEmpty
		ifTrue: [0]
		ifFalse: [history at: keys last]
! !

!Task methodsFor:'presentation'!

editLocked
"I override editLocked of XPSwikiPage because I need to edit title page inside the task card"

^ 'editLockedXP'
!

editUnlocked
"I override editUnlocked of XPSwikiPage because I need to edit title page inside the task card"

^ 'editUnlockedXP'
! !

!Task methodsFor:'utility'!

addToCatalog
	self isDeleted ifFalse: [self catalog addTask: self]
!

catalog
^ self book pages at: 6
!

removeFromCatalog
	self catalog removeTask: self
! !

!Task class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__Task.st,v 1.2 2004/03/17 18:34:23 penk Exp $'
! !
