"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

TestCase subclass:#TaskTest
	instanceVariableNames:'launcher module shelf request response book testTask emptyTask'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Tests'
!


!TaskTest methodsFor:'tests'!

setUp
	launcher _ XPSwikiLauncher package: #swikiWebServer.
	launcher port: 80.
	module _ launcher startServerGUI.
	shelf _ module shelf.
	request _ MockSwikiRequest new.
	request address: 'save'.
	request fieldsAt: 'name' put: 'Test1'.
	response _ Dictionary new.
	book _ shelf bookNamed: 'testing'.
	testTask _ book pages at: 9.
	emptyTask _ book pages at: 10
!

tearDown
	launcher stopServerGUI.
	 (Delay forSeconds: 1) wait.
!

testDescription
	self assert: testTask description = 'Task Description'.
	self assert: emptyTask description = ''
!

testDeveloper
	self assert: testTask developer = 'Giovanni'
. self assert: emptyTask developer = ''
!

testEndDate
	| date |
	date _ '05 Aug 2003' asDate.
	self assert: testTask endDate = date.
	self assert: emptyTask endDate isNil
!

testPointsDone
	self assert: testTask pointsDone = 0.
	self assert: emptyTask pointsDone isNil
!

testPointsLeft
	self assert: testTask pointsLeft = 1.
	self assert: emptyTask pointsLeft isNil
!

testStartDate
	| date |
	date _ '04 Aug 2003' asDate.
	self assert: testTask startDate = date.
	self assert: emptyTask startDate isNil
!

testUserStory
self assert: testTask userStory = 'Task'. self assert: emptyTask userStory = ''
! !

!TaskTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__TaskTest.st,v 1.1 2004/03/16 17:53:15 cg Exp $'
! !
