"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

TestCase subclass:#TasksCatalogTest
	instanceVariableNames:'launcher module shelf request response book catalog'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Tests'
!


!TasksCatalogTest methodsFor:'tests'!

setUp
	launcher _ XPSwikiLauncher package: #swikiWebServer.
	launcher port: 8080.
	module _ launcher startServer.
	shelf _ module shelf.
	request _ MockSwikiRequest new.
	request address: 'newTask'.
	request fieldsAt: 'name' put: 'Test'.
	response _ Dictionary new.
	book _ shelf bookNamed: 'testing'.
	catalog _ book pages at: 6
!

tearDown
	| dir |
	dir _ shelf storage dir directoryNamed: 'testing/pages'.
	launcher stopServer.
	dir deleteFileNamed: '13.xml'
!

testNewTask

	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: catalog.
	self
		assert: ((book pages at: book pages size)
				isKindOf: Task).
	self assert: (response at: 'headerStatus')
			= #tempMoved
!

testNewTaskExistingName
	request fieldsAt: 'name' put: 'Test1'.
	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: catalog.
	self
		should: [(response at: 'headerStatus')
				= #notFound]
!

testNewTaskNoName
	request fieldsRemoveKey: 'name'.
	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: catalog.
	self
		should: [(response at: 'headerStatus')
				= #notFound]
!

testNewTaskWithTemplate
	| page |

	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: catalog.
	self assert: (response at: 'headerStatus')
			= #tempMoved.
	page _ book pages last.
	self assert: (page
			settingsAt: 'template'
			ifAbsent: [])
			= 'task'
!

testTasks
	self
		assert: (book tasksCatalog tasks isKindOf: Collection).
	self
		shouldnt: [book tasksCatalog tasks isEmpty].
	self assert: (book tasksCatalog tasks
			reject: [:each | each isKindOf: Task]) isEmpty
! !

!TasksCatalogTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__TasksCatalogTest.st,v 1.1 2004/03/16 17:52:40 cg Exp $'
! !
