"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

XPSwikiPage subclass:#UserStory
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Pages'
!


!UserStory methodsFor:'accessing'!

acceptanceTests
	^ self book acceptanceTestsCatalog acceptanceTests
		select: [:acceptanceTest | acceptanceTest userStory = self]

!

description
	^ self textKey: 'description'
!

developer
        
        |textDeveloper idDeveloper |

        textDeveloper := self textKey: 'developer'. 
        " *8* became 8"
        Smalltalk isSmalltalkX ifTrue:[
            idDeveloper := textDeveloper squeakAsInteger.
        ] ifFalse:[
            idDeveloper := textDeveloper asInteger.
        ].
        ^ (idDeveloper isNil) ifTrue:[nil] ifFalse:[book pages at: idDeveloper].
!

developer: developerName
"da refactorare evitando una scrittura doppia della stessa chiave developer"	
	| newText element oldText developer developerId |
	(developerName = '') 
			ifTrue: [ developerId _ '']
			ifFalse: [
				developer:= book pageNamed: developerName.
				developerId _ developer id asString asSwikiLink].

	newText _ Dictionary new.
     oldText _ self text.
	oldText keysAndValuesDo: [:key :value |
		element _ value.
		(key = 'developer')
			ifTrue: [element _ developerId].
		newText at: key put: element].
	newText at: 'developer' put: developerId.
	^self text: newText
!

endDate
"date is nil if self textKey: 'endDate' is empty or if an error occur in the date format"

	| endDate |
	endDate _ self textKey: 'endDate'.
	endDate isEmpty
					ifTrue: [^ nil]
					ifFalse: [[endDate _ (endDate asDate)] ifError: [^ nil]].

	^ endDate.
!

iteration
        |textIteration idIteration|

        textIteration := self textKey: 'iteration'. 
        " *2* became 2"
        Smalltalk isSmalltalkX ifTrue:[
            idIteration := textIteration squeakAsInteger.
        ] ifFalse:[
            idIteration := textIteration asInteger.
        ].
        ^ (idIteration isNil) ifTrue:[nil] ifFalse:[book pages at: idIteration].
!

iteration: iterationName
"da refactorare evitando una scrittura doppia della stessa chiave iteration"	
	| newText element oldText iteration iterationId |
	(iterationName = '') 
			ifTrue: [ iterationId _ '']
			ifFalse: [
				iteration:= book pageNamed: iterationName.
				iterationId _ iteration id asString asSwikiLink].

	newText _ Dictionary new.
     oldText _ self text.
	oldText keysAndValuesDo: [:key :value |
		element _ value.
		(key = 'iteration')
			ifTrue: [element _ iterationId].
		newText at: key put: element].
	newText at: 'iteration' put: iterationId.
	^self text: newText
!

pointsDone
	^ self tasks inject: 0 into: [:sum :task | sum + task pointsDone]
!

pointsEstimated
        |pointsEstimated|
        Smalltalk isSmalltalkX ifTrue:[
            pointsEstimated :=  Error handle:[:ex| ex return:0] do:[(self textKey: 'pointsEstimated') asNumber].
        ] ifFalse:[
            pointsEstimated := (self textKey: 'pointsEstimated') asNumber.
        ].
        ^ (pointsEstimated isNil) ifTrue:[0] ifFalse:[pointsEstimated]
!

pointsEstimatedFromTasks
	^ self tasks inject: 0 into: [:sum :task | sum + task pointsEstimated]
!

pointsLeft
	(self pointsEstimated > 0) 
						ifTrue:[^ self pointsEstimated - self pointsDone]
						ifFalse:[^ 0]
!

pointsLeftFromTasks
	^ self tasks
		inject: 0
		into: [:sum :task | sum + task pointsLeft]
!

pointsTotal
	^ self pointsDone + self pointsLeft
!

priority
	^ self textKey: 'priority'
!

risk
	^ self textKey: 'risk'
!

startDate
	"date is nil if self textKey: 'startDate' is '' or if an error occur in the date format"

	| startDate |
	startDate _ self textKey: 'startDate'.
	startDate isEmpty
					ifTrue: [^ nil]
					ifFalse: [[startDate _ (startDate asDate)] ifError: [^ nil]].

	
	^ startDate.
!

tasks
	^ self book tasksCatalog tasks select: [:task | task userStory = self]
! !

!UserStory methodsFor:'history'!

dateSpan
	| start end span |
	span _ OrderedCollection new.
	start _ self startDate.
	end _ self endDate.
	start
		ifNil: [^ span].
	end
		ifNil: [end _ Date today].
	[start <= end]
		whileTrue: [span add: start.
			start _ start next].
	^ span
!

datesHistory
	|tasks dates versions |
	tasks _ self tasks.
	dates _ Set new.
	versions _ self versions.
	versions
		do: [:version | dates add: version date].
	tasks do: [:aTask| 
					 aTask datesHistory do:[:aDate| 
											dates add: aDate]].
	^ dates asSortedCollection
	
	
!

pointsDoneHistoryOLD
	
	| history versions |
	versions _ self versions.
	history _ Dictionary new.
	versions
		do: [:version | history at: (version date) put: (version pointsDoneInDate: version date)].
	^ history
!

pointsDoneInDate: aDate 
	^ self tasks
		inject: 0
		into: [:sum :task | sum
				+ (task pointsDoneInDate: aDate)]
!

pointsEstimatedFromTasksHistoryOLD
	| history versions |
	
	versions _ self versions.
	history _ Dictionary new.
	versions
		do: [:version | history at: (version date) put: (version pointsEstimatedFromTasksInDate: version date)].

	^ history
!

pointsEstimatedFromTasksInDate: aDate 
	^ self tasks
		inject: 0
		into: [:sum :task | sum
				+ (task pointsEstimatedInDate: aDate)]
!

pointsEstimatedHistory
	| history versions |
	versions _ self versions. 
	history _ Dictionary new.
	versions
		do: [:version | history at: version date put: version pointsEstimated].
	^ history
!

pointsEstimatedInDate: aDate 
	| keys history |
	history _ self pointsEstimatedHistory.
	keys _ history keys asSortedCollection
				select: [:aKey | aKey <= aDate].
	^ keys isEmpty
		ifTrue: [0]
		ifFalse: [history at: keys last]
!

pointsLeftFromTasksHistoryOLD
	| history versions |

	versions _ self versions. 
	history _ Dictionary new.
	versions
		do: [:version | history at: (version date) put: (version pointsLeftFromTasksInDate: version date)].

	^ history
!

pointsLeftFromTasksInDate: aDate 
	^ self tasks
		inject: 0
		into: [:sum :task | sum
				+ (task pointsLeftInDate: aDate)]
!

pointsLeftHistoryOLD
	| history versions |
	versions _ self versions. 
	history _ Dictionary new.
	versions
		do: [:version | history at: version date put: version pointsLeft].
	^ history
!

pointsLeftInDate: aDate 
	
	^ (self pointsEstimatedInDate: aDate) - (self pointsDoneInDate: aDate).
!

pointsLeftInDateOLD: aDate 
	| keys history |
	history _ self pointsLeftHistory.
	keys _ history keys asSortedCollection
				select: [:aKey | aKey <= aDate].
	^ keys isEmpty
		ifTrue: [0]
		ifFalse: [history at: keys last]
!

pointsTotalHistory
	| history |
	history _ Dictionary new.
	self dateSpan
		do: [:aDate | history
				at: aDate
				put: (self pointsTotalInDate: aDate)].
	^ history
!

pointsTotalInDate: aDate 
	^ self tasks
		inject: 0
		into: [:sum :task | sum
				+ (task pointsTotalInDate: aDate)]
! !

!UserStory methodsFor:'presentation'!

editLocked
"I override editLocked of XPSwikiPage because I need to edit title page inside the task card"

^ 'editLockedXP'
!

editUnlocked
"I override editLocked of XPSwikiPage because I need to edit title page inside the task card"

^ 'editUnlockedXP'
! !

!UserStory methodsFor:'utility'!

addToCatalog
	self isDeleted ifFalse: [self catalog addUserStory: self]
!

catalog
^ self book pages at: 5
!

hasTasks

	^(self tasks notNil) & (self tasks notEmpty)
!

hasTests

	^(self acceptanceTests notNil) & (self acceptanceTests notEmpty)
!

removeFromCatalog
	self catalog removeUserStory: self
!

status
	"modified by S&M - 2 feb 04"
| return |

	return _ 'notDone'.
	
"(self hasTasks not) & (self hasTests not)	ifTrue: 	[
		(self startDate notNil) ifTrue: [(((self startDate) < (Date today)) | ((self startDate) = (Date today))) ifTrue:[ return:='InProgress']].
		(self endDate notNil) ifTrue: [(((self endDate) < (Date today)) | ((self endDate) = (Date today))) ifTrue:[ return:='Done']]].
"
	
	((self tasksStatus = 'Done') & (self testsStatus = 'Passed') & (self endDate notNil)) ifTrue: [return:='Done'].
	(return = 'notDone')	ifTrue: [
		((self tasksStatus = 'InProgress') | (self startDate notNil)) ifTrue: [return:='InProgress']].
	(return = 'notDone')	ifTrue: [return:= 'ToDo'].

	^ return
!

statusOLD
	"modified by Marco - 28 nov 03"
| testsStatus tasksStatus return |

testsStatus := true.
tasksStatus := true.
return _ 'ToDo'.


self hasTasks 		
	ifTrue: [self tasks do: [:aTask | (aTask status = 'ToDo') ifFalse: [return:= 'InProgress']]].

(self startDate notNil) ifTrue: [(((self startDate) < (Date today)) | ((self startDate) = (Date today))) ifTrue:[ return:='InProgress']].

self hasTests
	ifTrue: [self acceptanceTests do: [:aTest | aTest passed ifFalse: [testsStatus:= false]]]
	ifFalse: [testsStatus:= false].

self hasTasks		
	ifFalse: [tasksStatus:= false.] 
	ifTrue: [self tasks do: [:aTask | (aTask status = 'Done') ifFalse: [tasksStatus:= false]]].

(testsStatus & tasksStatus) 
		ifTrue: [return _ 'Done'].

^ return

!

tasksStatus

	"I'm 
	-'ToDo' if each task status is 'ToDo'. 
	-'InProgress' if at least one task status is 'InProgress'.	 
	-'Done' if and only if each task status is 'Done' or if there aren't associated tasks"

	| return |

	
	return := 'Done'.
	self hasTasks ifTrue: [
		self tasks do: [:aTask | (aTask status = 'Done') ifFalse: [return:= 'notDone']].	

	(return = 'notDone') ifTrue: [ return:='ToDo'.
		self tasks do: [:aTask | (aTask status = 'ToDo') ifFalse: [return:= 'InProgress']]]].



	

^ return
!

testsStatus

	"I'm 
	-'Passed' if each test status is 'Passed' or if there aren't associated tests. 
	-'NotPassed' if at least one test status is 'NotPassed'.	" 

	| return |


	return := 'Passed'.
	self hasTests ifTrue: [
	self acceptanceTests do: [:aTest | (aTest status = 'NotPassed') ifTrue: [return:= 'NotPassed']]].	

^ return
! !

!UserStory class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__UserStory.st,v 1.2 2004/03/17 18:33:03 penk Exp $'
! !
