"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

TestCase subclass:#XPSwikiBookTest
	instanceVariableNames:'launcher module shelf request response'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Tests'
!


!XPSwikiBookTest methodsFor:'tests'!

setUp
	launcher _ XPSwikiLauncher package: #swikiWebServer.
	launcher port: 8080.
	module _ launcher startServer.
	shelf _ module shelf.
	request _ MockSwikiRequest new.
	request address: 'createNew'.
	response _ Dictionary new.
	request fieldsAt: 'name' put: 'test'.
	request fieldsAt: 'bookStorage' put: 'MockSwikiStorage'.
	request fieldsAt: 'pageStorage' put: 'MockSwikiStorage'
!

tearDown
	| dir |
	dir _ shelf storage dir directoryNamed: 'test'.
	launcher stopServer.
	dir exists
		ifTrue: [dir recursiveDelete]
!

testAcceptanceTestsCatalog
	self
		assert: ((shelf bookNamed: 'testing') acceptanceTestsCatalog isKindOf: AcceptanceTestsCatalog)
!

testAddNewPageOfClass
	| book page id |
	book _ shelf bookNamed: 'testing'.
	id _ book pages size + 1.
	page _ book addNewPageFromClass: MockSwikiPage.
	self
		assert: (page isKindOf: MockSwikiPage).
	self assert: page id = id.
	self assert: page versionId = 0.
	self assert: page storage == (book pages at: 1) storage.
	self assert: page book = book.
	self assert: book pages size = id.
	self assert: (book pages at: page id)
			== page
!

testHasItselfPageTemplate
	self
		assert: ((shelf bookNamed: 'template')
				hasItselfPageTemplate: 'taskCatalog-show').
	self
		assert: ((shelf bookNamed: 'testing')
				hasItselfPageTemplate: 'taskCatalog-show') not
!

testLoadPages
	| book result |
	book _ shelf bookNamed: 'testing'.
	result _ book pages detect: [:page |book ~= book] ifNone: [nil].
	self assert: result isNil
!

testNewBookPages
	| parent |
	parent _ shelf bookNamed: 'template'.
	shelf
		formatBookAction: request address
		request: request
		response: response
		book: parent.
	self assert: (shelf bookNamed: 'test') pages size = parent pages size
!

testNewBookTitle
	| parent page |
	parent _ shelf bookNamed: 'template'.
	shelf
		formatBookAction: request address
		request: request
		response: response
		book: parent.
	page _ (shelf bookNamed: 'test') pages at: 1.
	self assert: page name = 'test'
!

testTasksCatalog
	self
		assert: ((shelf bookNamed: 'testing') tasksCatalog isKindOf: TasksCatalog)
! !

!XPSwikiBookTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__XPSwikiBookTest.st,v 1.1 2004/03/16 17:52:55 cg Exp $'
! !
