"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

TestCase subclass:#XPSwikiLauncherTest
	instanceVariableNames:'window'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Tests'
!


!XPSwikiLauncherTest methodsFor:'tests'!

tearDown
	window
		ifNotNil: [window model isOn ifTrue: [window model stopServer].
			window delete]
!

testLaunchNoGUI
	| launcher |
	launcher _ XPSwikiLauncher package: #swikiWebServer.
	launcher port: 8080.
	launcher startServer.
	launcher stopServer.
	self assert: (ComancheNetService serviceNamed: 'swikiWebServer-8080') isNil
!

testOpenAsMorph
	| before after |
	Smalltalk garbageCollect.
	before _ SystemWindow allInstances.
	window _ XPSwikiLauncher openAsMorph.
	self assert: window model port notNil.
	after _ SystemWindow allInstances.
	self assert: after size = (before size + 1).
	self assert: window = after last.
	self assert: after last externalName = 'XPSwiki Launcher'
!

testOpenSwikiBrowser
	| launcher browser |
	window _ XPSwikiLauncher openAsMorph.
	launcher _ window model.
	launcher portGUI: 8080.
	launcher startServer.
	browser _ launcher openSwikiBrowser.
	self assert: browser notNil.
	self assert: launcher browsers size = 1.
	self assert: launcher browsers last = browser.
	browser delete
!

testPortGUI
	| launcher |
	window _ XPSwikiLauncher openAsMorph.
	launcher _ window model.
	launcher portGUI: 8080.
	self assert: launcher portButton label = 'port: 8080'
!

testStartServer
	| launcher module |
	window _ XPSwikiLauncher openAsMorph.
	launcher _ window model.
	module _ launcher startServer.
	self should: launcher isOn.
	self
		assert: (module isKindOf: XPSwikiModule)
!

testStopServer
	| launcher |
	window _ XPSwikiLauncher openAsMorph.
	launcher _ window model.
	launcher portGUI: 8080.
	self assert: launcher browsers size = 0.
	launcher startServer.
	launcher openSwikiBrowser.
	self assert: launcher browsers size = 1.
	launcher stopServer.
	self assert: launcher browsers size = 0
!

testToggleState
	| launcher |
	window _ XPSwikiLauncher openAsMorph.
	launcher _ window model.
	launcher portGUI: 8080.
	self shouldnt: launcher isOn.
	launcher toggleState.
	self should: launcher isOn.
	self should: launcher startStopButton label = 'stop server'.
	launcher toggleState.
	self shouldnt: launcher isOn.
	self should: launcher startStopButton label = 'start server'
! !

!XPSwikiLauncherTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__XPSwikiLauncherTest.st,v 1.1 2004/03/16 17:54:57 cg Exp $'
! !
