"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

NuSwikiPage subclass:#XPSwikiPage
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Structure'
!


!XPSwikiPage methodsFor:'accessing'!

book
	^ book
!

book: aSwikiBook
	book _ aSwikiBook
!

endDate

	date _ [(self textKey: 'endDate') asDate] ifError: [nil].

	^ date
! !

!XPSwikiPage methodsFor:'append / remove'!

appendToContainerFormat: oldText request: request response: response shelf: shelf book: aBook
		
| newText element appendText formId|
"see addresses(page) > append / remove > appendToContainer or appendToTasksCatalog"	
	newText _ Dictionary new.
	formId _ request fieldsKey: 'formId' ifAbsent: [''].
	appendText _ (request fieldsKey: 'append').
	(self book hasPageNamed: appendText) ifTrue:[ appendText _ (self book pageNamed: appendText) id asString asSwikiLink]
										   ifFalse:[appendText _ appendText asSwikiLink].
	oldText keysAndValuesDo: [:key :value |
		request settingsRemove: 'appendId'.
		element _ value.
		(key = formId) ifTrue: [
				element _ appendText, String cr, value .
				"delete extra cr formed from appendFormatter"
				(element endsWith: String cr) ifTrue: 
									[(element size > 1) ifTrue: [element _ element copyFrom: 1 to: (element size - 1)]].].
		request settingsAt: 'appendSuccess' put:true.
		newText at: key put: element].
	^self text: newText
!

delete
	"See XPSwikiPage > removeFromContainerFormat: oldText request: request response: response shelf: shelf book: aBook"
	storage deletePage: self
!

removeFromContainerFormat: oldText request: request response: response shelf: shelf book: aBook
		
| newText element appendText formId pageToDelet lenght index before after |
"see addresses(page) > append / remove > deletePage"	
	newText _ Dictionary new.
	formId _ request fieldsKey: 'formId' ifAbsent: [''].
	appendText _ (request fieldsKey: 'append').
	pageToDelet := self book pageNamed: appendText.
	pageToDelet isNil ifTrue:[request settingsAt: 'appendSuccess' put:false. ^ self text: oldText].
	appendText _ pageToDelet id asString asSwikiLink. "remove text such as *3*"
	oldText keysAndValuesDo: [:key :value |
		request settingsRemove: 'appendId'.
		element _ value.
		(key = formId) ifTrue: [
				lenght _ appendText size.
				index _ element findString: appendText.
				[index = 0] whileFalse: [ 
							before _ element copyFrom: 1 to: index -1.
							(before endsWith: String cr) ifTrue: 
									[(before size > 1) ifTrue: [before _ before copyFrom: 1 to: (before size - 1)]].
							after _ element copyFrom: index + lenght to: element size.
							element _ before , after.
							index := (element findString: appendText ) ].
				(element endsWith: String cr) ifTrue: 
									[(element size > 1) ifTrue: [element _ element copyFrom: 1 to: (element size - 1)]].].
		request settingsAt: 'appendSuccess' put:true.
		newText at: key put: element].
		
	^self text: newText
!

removeFromContainerFormatOLD: oldText request: request response: response shelf: shelf book: aBook
		
| newText element appendText formId pageToRemove lenght index before after |
"see addresses(page) > append / remove > removePage"	
	newText _ Dictionary new.
	formId _ request fieldsKey: 'formId' ifAbsent: [''].
	appendText _ (request fieldsKey: 'append').
	pageToRemove := self book pageNamed: appendText.
	pageToRemove isNil ifTrue:[request settingsAt: 'appendSuccess' put:false. ^ self text: oldText].
	appendText _ pageToRemove id asString asSwikiLink. "remove text such as *3*"
	oldText keysAndValuesDo: [:key :value |
		request settingsRemove: 'appendId'.
		element _ value.
		(key = formId) ifTrue: [
				lenght _ appendText size.
				index _ element findString: appendText.
				[index = 0] whileFalse: [
							before _ element copyFrom: 1 to: index -1.
							after _ element copyFrom: index + lenght to: element size.
							element _ before , after.
							index := (element findString: appendText ) ].
				(element endsWith: String cr) ifTrue: 
									[(element size > 1) ifTrue: [element _ element copyFrom: 1 to: (element size - 1)]].].
		request settingsAt: 'appendSuccess' put:true.
		newText at: key put: element].
	"Now delete pageToRemove"
	pageToRemove
			forbidWriting.
	[pageToRemove
			user: (shelf formatPrivAddress: 'getIPName' request: request response: response);
			backup;
			delete;
			permitWriting;
			sendAlerts: request response: response shelf: shelf book: book] fork.
		
	^self text: newText
!

removeSwikiLink: aSwikiLink fromTextKey: aTextKey
"swikiLink is a string like '*23*'"
"aTextKey is the text key from wich swikiLink will be removed"
"see addresses(page) > append / remove > deletePage"	
		
|newText element lenght index before after oldText|

	oldText _ self text.
	newText _ Dictionary new.
	oldText keysAndValuesDo: [:key :value |
		element _ value.
		(key = aTextKey) ifTrue: [
				lenght _ aSwikiLink size.
				index _ element findString: aSwikiLink.
				[index = 0] whileFalse: [
							before _ element copyFrom: 1 to: index -1.
							(before endsWith: String cr) ifTrue: 
									[(before size > 1) ifTrue: [before _ before copyFrom: 1 to: (before size - 1)]].
							after _ element copyFrom: index + lenght to: element size.
							element _ before , after.
							index := (element findString: aSwikiLink ) ].
				(element endsWith: String cr) ifTrue: 
									[(element size > 1) ifTrue: [element _ element copyFrom: 1 to: (element size - 1)]].].
		newText at: key put: element].
		
	^self text: newText
! !

!XPSwikiPage methodsFor:'history'!

version: vid 
	"Returns the XmlSwikiPage version.  
	If the version does not exist, return nil."
	| version |
	
	vid > 0
		ifFalse: [^ nil].
	version _ self class new id: id;
				 versionId: vid;
				 storage: storage;
				 book: book.
	"loadPage: vid don't work properly here. I need to call loadPage: vid defined in the superclass"
	(storage loadPageSuper: version) 
		ifNil: [^ nil].
	^ version
! !

!XPSwikiPage methodsFor:'presentation'!

appendKey
"Where I append files. Default: description. Override me if your page hasn't description form or if you choose to append in another field"

^ 'description'
!

editLocked
"Override me if you want a different template for editing your locked page"
 
^ 'editLocked'
!

editUnlocked
"Override me if you want a different template for editing your locked page"
 
^ 'editUnlocked'
!

newKindFor: formId request: request shelf: shelf 
"see actions (page) > toNew"	


^ '<form action="', (request referenceShelf: shelf book: (self book) page: self address: 'new'), '">'
!

view
"Override me if you want a different template for your page"
 
^ 'view'
! !

!XPSwikiPage methodsFor:'utility'!

isDeleted
	"If the page has been just created than name is nil and isDeleted = true"
	(self name isNil) ifTrue:[^ false].
	"If the page name has -deleted- subString the page is considered deleted"
	^ (self name includesSubString: '-deleted-') 
										
! !

!XPSwikiPage class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__XPSwikiPage.st,v 1.1 2004/03/16 17:54:30 cg Exp $'
! !
