"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

TestCase subclass:#XPSwikiPageTest
	instanceVariableNames:'launcher module shelf request response book page'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Tests'
!


!XPSwikiPageTest methodsFor:'tests'!

setUp
	launcher _ XPSwikiLauncher package: #swikiWebServer.
	launcher port: 8080.
	module _ launcher startServer.
	shelf _ module shelf.
	request _ MockSwikiRequest new.
	request address: 'save'.
	request fieldsAt: 'name' put: 'Test1'.
	response _ Dictionary new.
	book _ shelf bookNamed: 'testing'.	page _ book pages at: 8.
!

tearDown
	| dir |
	dir _ shelf storage dir directoryNamed: 'testing/pages'.
	launcher stopServer.
	dir deleteFileNamed: '8.old'.
!

testSaveNoTextFields

	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: page.
	self
		should: [(response at: 'headerStatus')
				= #notFound]
!

testSaveWithGenericField
	request fieldsAt: 'textDescription' put: 'Test!!'.
	request text: 'Test!!'.
	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: page.
	self
		should: [(response at: 'headerStatus')
				= #tempMoved]
!

testSaveWithTextField
	request fieldsAt: 'text' put: 'Test!!'.
	request text: 'Test!!'.

	book
		formatPageAddress: request address
		request: request
		response: response
		shelf: shelf
		page: page.
	self
		should: [(response at: 'headerStatus')
				= #tempMoved]
! !

!XPSwikiPageTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__XPSwikiPageTest.st,v 1.1 2004/03/16 17:54:25 cg Exp $'
! !
