"{ Package: 'stx:goodies/webServer/comanche/swiki/xpSwiki' }"

"{ NameSpace: Comanche }"

TestCase subclass:#XPSwikiStorageTest
	instanceVariableNames:'dir'
	classVariableNames:''
	poolDictionaries:''
	category:'XPSwiki-Tests'
!


!XPSwikiStorageTest methodsFor:'tests'!

setUp
        dir _ (SimulatedSqueakFileDirectory  on: ((Filename defaultDirectory construct:'../../goodies/webServer/data/xpSwiki') pathName))
!

tearDown
	dir deleteFileNamed: 'test.xml'; deleteFileNamed: 'test.old'
!

testLoadPagesForBook
        | storage pages book |
        storage _ XPSwikiStorage
                                fromDir: (SimulatedSqueakFileDirectory  on: ((Filename defaultDirectory construct:'../../goodies/webServer/data/xpSwiki/template/pages') pathName)).
        book _ MockXPSwikiBook new.
        pages _ storage loadPagesForBook: book.
        pages _ pages
                                detect: [:page | page book ~= book] ifNone: [nil].
        self should: pages isNil
!

testLoadPagesOfDifferentClasses
        | storage pages |
        storage _ XPSwikiStorage
                                fromDir: (SimulatedSqueakFileDirectory  on: ((Filename defaultDirectory construct:'../../goodies/webServer/data/xpSwiki/template/pages') pathName)).
        pages _ storage loadPagesForBook: MockXPSwikiBook new.
        self should: (pages
                        reject: [:page | page isKindOf: XPSwikiPage]) isEmpty.
        self
                should: ((pages at: 6)
                                isKindOf: TasksCatalog)
!

testLoadVersion
        | storage page versions |
        storage _ XPSwikiStorage
                                fromDir: (SimulatedSqueakFileDirectory  on: ((Filename defaultDirectory construct:'../../goodies/webServer/data/xpSwiki/template/pages') pathName)).
        page _ (storage loadPagesForBook: (MockXPSwikiBook new)) at: 1.
        storage backupPage: page.
        versions _ page versions.
        self assert: versions size = 1.
        self
                assert: ((versions at: 1)
                                isKindOf: XPSwikiPage).
        storage dir deleteFileNamed: '1.old'
!

testSetupBooks
        | storage books |
        storage _ XPSwikiStorage
                                fromDir: (SimulatedSqueakFileDirectory  on: ((Filename defaultDirectory construct:'../../goodies/webServer/data/xpSwiki') pathName)).
        books _ storage setupBooks.
        books _ books
                                reject: [:book | book isKindOf: XPSwikiBook].
        self assert: books size = 1.
        self assert: (books at: 1) name = 'refs'
!

testWritePage
        | storage page fileContents |
        storage _ XPSwikiStorage fromDir: dir.
        page _ Task new.
        page id: 'test';
                 versionId: 0;
                 storage: storage;
                 date: Date today;
                 user: 'testUser';
                 name: 'test'.
        page write.
        fileContents _ ((dir fullPathFor:'') asFilename construct:'test.xml') contents.

        self
                assert: (fileContents includes: ('<class>' , 'Comanche::Task' , '</class>'))
! !

!XPSwikiStorageTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/comanche/swiki/xpSwiki/Comanche__XPSwikiStorageTest.st,v 1.2 2004/03/17 18:34:41 penk Exp $'
! !
