"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#AbstractFormElement
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Form'
!

!AbstractFormElement class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!AbstractFormElement class methodsFor:'queries'!

isAbstract
    ^ self == AbstractFormElement.
! !

!AbstractFormElement methodsFor:'interface-attributes'!

beDisabled
    "Set this element to be disabled."

    self getAttributes at:#disabled put:#disabled.

    "
     |button|
     button := HTML::Button new.
     button beDisabled.
     button htmlString.

     |button|
     button := HTML::Button new.
     button beEnabled.
     button htmlString.
    "
!

beEnabled
    "Set this element to be enabled."

    self removeAttribute:#disabled.
!

disabled:aBoolean
    aBoolean ifTrue:[
        self beDisabled.
    ] ifFalse:[
        self beEnabled
    ].
!

isDisabled
    "Return if disable is set or not."

    ^ (self attributeAt:#disabled) notNil
!

onBlur
    "Return the on-blur-attribute of this element."

    ^ self attributeAt:#onblur.
!

onBlur:aScript
    "Set the on-blur-attribute of this element."

    self on:#onblur script:aScript.

    "Modified: / 19-07-2010 / 15:04:15 / cg"
!

onChange
    "Return the on-change-attribute of this element."

    ^ self attributeAt:#onchange.
!

onFocus
    "Return the on-Focus-attribute of this element."

    ^ self attributeAt:#onfocus.
!

onFocus:aScript
    "Set the on-focus-attribute of this element."

    self on:#onfocus script:aScript.

    "Modified: / 19-07-2010 / 15:04:22 / cg"
!

onKeyPress
    "Return the on-KeyPress-attribute of this element."

    ^ self attributeAt:#onkeypress.
!

onSelect
    "Return the on-select-attribute of this element."

    ^ self attributeAt:#onselect.
!

onSelect:aScript
    "Set the on-select-attribute of this element."

    self on:#onselect script:aScript.

    "Modified: / 19-07-2010 / 15:04:27 / cg"
!

tabindex:anInteger
    "Set the tab index of the element, 0 if not tabbed.
     Valid for <input> <button> <select> <textarea> <a>"

    self attributeAt:#tabindex put:anInteger.
! !

!AbstractFormElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__AbstractFormElement.st,v 1.11 2010/07/19 13:05:50 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__AbstractFormElement.st,v 1.11 2010/07/19 13:05:50 cg Exp $'
! !
