"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#AbstractList
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Lists'
!

!AbstractList class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!AbstractList class methodsFor:'testing'!

isAbstract
    "Return if this class is an abstract class.
     Return true for this class but false for all subclasses.
     To have an abstract subclass implement this method there again."

    ^ self == AbstractList.
! !

!AbstractList methodsFor:'interface-accessing-attributes'!

addListItem:rawData
    "Add a list item from raw data.
     Raw data can be:
         - A ready build list item.
         - A simple string, it will be wrapped in a list item.
         - A smalltalk object that will get printString to display itself.
         - A collection of objects of the above."

    |item|

    item := self buildElement: rawData 
                 ofType:       ListItem. 

    item isCollection ifTrue:[
        item isString ifFalse:[
            item do:[:each |
                self addChild:each.
            ].
            ^ self.
        ]
    ].
    ^ self addChild:item.
!

addListItems:aRawData
    "Add a list item from raw data.
     Raw data can be:
         - A ready build list item.
         - A simple string, it will be wrapped in a list item.
         - A smalltalk object that will get printString to display itself.
         - A collection of objects of the above."

    aRawData do:[:sublistitem|
        self addListItem:sublistitem.
    ].
! !

!AbstractList methodsFor:'queries'!

canHaveChild:anElement
    anElement isListItem ifTrue:[^ true].
self halt:'tell me more'.
    ^ false
! !

!AbstractList class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__AbstractList.st,v 1.2 2008/10/20 15:09:10 cg Exp $'
! !
