"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#AbstractTableRow
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Table'
!

!AbstractTableRow class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!AbstractTableRow class methodsFor:'queries'!

isAbstract
    "Return if this class is an abstract class.
     Return true for this class but false for all subclasses.
     To have an abstract subclass implement this method there again."

    ^ self == AbstractTableRow.

    "
     AbstractTableRow isAbstract.
     Table isAbstract.
    "
! !

!AbstractTableRow class methodsFor:'required protocol'!

cellClass
    "Return the cell class for the row element."

    ^ self subclassResponsibility.
! !

!AbstractTableRow methodsFor:'interface-accessing-elements'!

addCell
    "Add an empty data cell to the table row."
    
    ^ self addCell:nil.
!

addCell:aCellOrString 
    "Add a data cell to the table row."
    
    |cell|

    cell := self buildCell:aCellOrString.

    ^ self addChild:cell.
!

addFirstCell:aCellOrString 
    "Add a data cell to the table row."
    
    |cell|

    cell := self buildCell:aCellOrString.

    ^ self addFirstChild:cell.
!

cellAt:anIndex 
    "Add a data cell to the table row."
    
    ^ self children at:anIndex ifAbsent:nil.
!

cellAt:anIndex put:aCellOrString 
    "Put a data cell at a given index."

    |cell|

    cell := self buildCell:aCellOrString.

    children size < anIndex ifFalse:[
        self childAt:anIndex put:cell.
        ^ self.
    ].

    (anIndex - children size - 1) timesRepeat:[
        self addCell.
    ].

    self addChild:cell.
! !

!AbstractTableRow methodsFor:'private-building'!

buildCell:aCellOrString 
    "Build and return a new data cell."
    
    ^ self buildElement:aCellOrString ofType:self class cellClass.
! !

!AbstractTableRow class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__AbstractTableRow.st,v 1.16 2007/03/12 20:55:22 cg Exp $'
! !
