"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

Object subclass:#AbstractTreeBuilder
	instanceVariableNames:'root currentElement attributableElement optionalResources
		ignoreComments'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-Utilities'
!

!AbstractTreeBuilder class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    HTML tree builder - makes it easier to construct valid HTML-trees.
    This class is abstract; it is intended as the common superclass of different sgml-like
    trees (such as HTML, VML etc.).

    See concrete subclass(es)
"
! !

!AbstractTreeBuilder methodsFor:'accessing'!

currentElement
    ^ currentElement
!

rootElement
    ^ root
! !

!AbstractTreeBuilder methodsFor:'attributes'!

id:idString
    attributableElement id:idString
!

name:name
    attributableElement name:name
! !

!AbstractTreeBuilder methodsFor:'attributes-basic'!

addAttribute:attrName
    attributableElement addAttribute:attrName
!

attribute:attrName is:attrValue
    attrValue isNil ifTrue:[
        attributableElement addAttribute:attrName
    ] ifFalse:[
        attributableElement attributeAt:attrName put:attrValue
    ]
! !

!AbstractTreeBuilder methodsFor:'building'!

comment:aComment
    ignoreComments == true ifFalse:[
        currentElement add:('<!!-- %1 -->' bindWith:aComment printString).
    ].

    attributableElement := nil.

    "Modified: / 11-05-2011 / 12:46:40 / cg"
    "Modified: / 12-01-2012 / 13:14:22 / sr"
!

nlsText:nlsText
    "text which is a national-language-translated-string, as text element"

    nlsText isNil ifTrue:[^ self].
    self text:(self nlsTranslated:nlsText).

    "Modified: / 03-07-2010 / 10:10:16 / cg"
!

nlsText:nlsText with:aParameter
    "text which is a national-language-translated-string, as text element"

    self text:(self nlsTranslated:nlsText with:aParameter).

    "Modified: / 03-07-2010 / 10:10:28 / cg"
!

nlsText:nlsText with:parameter1 with:parameter2
    "text which is a national-language-translated-string, as text element"

    "/ Transcript show:nlsText storeString; show:'->'; showCR:(self nlsTranslated:nlsText).
    self text:(self nlsTranslated:nlsText with:parameter1 with:parameter2).

    "Modified: / 03-07-2010 / 10:10:34 / cg"
    "Modified: / 16-08-2010 / 17:06:32 / sr"
!

nlsText:nlsText with:parameter1 with:parameter2 with:parameter3
    "text which is a national-language-translated-string"

    self text:(self nlsTranslated:nlsText with:parameter1 with:parameter2 with:parameter3).

    "Modified: / 10-08-2007 / 14:57:43 / cg"
!

nlsText:nlsText withArgs:parameters
    "text which is a national-language-translated-string"

    self text:(self nlsTranslated:nlsText withArgs:parameters).

    "Modified: / 10-08-2007 / 14:57:45 / cg"
!

nlsTitle:nlsTitle
    "fly-by-title which is a national-language-translated-string"

    nlsTitle isNil ifTrue:[^ self].
    self title:(self nlsTranslated:nlsTitle).

    "Created: / 10-08-2007 / 14:54:02 / cg"
!

nlsTitle:nlsText with:aParameter
    "fly-by-title which is a national-language-translated-string"

    self title:(self nlsTranslated:nlsText with:aParameter).

    "Created: / 10-08-2007 / 14:57:18 / cg"
!

nlsTranslated:nlsText
    "national-language-translated-string"

    optionalResources notNil ifTrue:[
        ^ optionalResources stringWithCRs:nlsText
    ].
    ^ nlsText

    "Created: / 10-08-2007 / 14:54:37 / cg"
    "Modified: / 21-07-2010 / 20:47:38 / cg"
!

nlsTranslated:nlsText with:aParameter
    "national-language-translated-string"

    optionalResources notNil ifTrue:[
        ^ optionalResources string:nlsText with:aParameter
    ].
    ^ nlsText bindWith:aParameter

    "Created: / 10-08-2007 / 14:56:04 / cg"
    "Modified: / 21-07-2010 / 20:48:02 / cg"
!

nlsTranslated:nlsText with:parameter1 with:parameter2
    "national-language-translated-string"

    optionalResources notNil ifTrue:[
        ^ optionalResources string:nlsText with:parameter1 with:parameter2
    ].
    ^ nlsText bindWith:parameter1 with:parameter2

    "Created: / 10-08-2007 / 14:56:35 / cg"
    "Modified: / 21-07-2010 / 20:48:25 / cg"
!

nlsTranslated:nlsText with:parameter1 with:parameter2 with:parameter3
    "national-language-translated-string"

    optionalResources notNil ifTrue:[
        ^ optionalResources string:nlsText with:parameter1 with:parameter2 with:parameter3
    ].
    ^ nlsText bindWith:parameter1 with:parameter2 with:parameter3

    "Created: / 10-08-2007 / 14:56:35 / cg"
    "Modified: / 21-07-2010 / 20:48:38 / cg"
!

nlsTranslated:nlsText withArgs:parameters
    "national-language-translated-string"

    optionalResources notNil ifTrue:[
        ^ optionalResources string:nlsText withArgs:parameters
    ].
    ^ optionalResources bindWithArguments:parameters

    "Created: / 10-08-2007 / 14:56:54 / cg"
    "Modified: / 21-07-2010 / 20:49:15 / cg"
!

rawText:someText
    root isNil ifTrue:[
        root := someText.
    ] ifFalse:[
        currentElement add:someText.
    ].

    "Modified: / 02-07-2009 / 18:14:24 / sr"
!

text:someText
    self rawText:(HTMLUtilities escapeCharacterEntities:someText ? '')
"/    self rawText:(HTTPServer withSpecialHTMLCharactersEscaped:someText)

    "Modified: / 13-04-2011 / 23:09:44 / cg"
    "Modified: / 10-01-2012 / 15:22:05 / sr"
! !

!AbstractTreeBuilder methodsFor:'instance release'!

release
    root := currentElement := attributableElement := optionalResources := nil.
! !

!AbstractTreeBuilder methodsFor:'private'!

textOrBlock:textOrBlock
    textOrBlock isBlock ifTrue:[
        textOrBlock value.
    ] ifFalse:[
        self text:textOrBlock
    ]
! !

!AbstractTreeBuilder methodsFor:'setup'!

addElement:element
    currentElement add:element.

    "Created: / 20-07-2007 / 12:45:56 / cg"
!

beginWith:anElement
    root := currentElement := attributableElement := anElement.

    "
     |b|

     b := self new beginWith:(Table new).
     b table.
     b tr.
     b td.
     b tdEnd.
     b td.
     b tdEnd.
     b trEnd.
     b tableEnd.
     b
    "
!

endElement
    currentElement := currentElement parent.
    attributableElement := nil.
!

endElementButKeepForAttribute
    currentElement := currentElement parent.
!

ignoreComments
    ^ ignoreComments ? false

    "Created: / 11-05-2011 / 12:46:19 / cg"
!

ignoreComments:aBoolean
    ignoreComments := aBoolean

    "Created: / 11-05-2011 / 12:46:11 / cg"
!

resources:anNLSResourceCollection
    "for nlsText and nlsInfo"

    optionalResources := anNLSResourceCollection

    "Modified: / 11-05-2011 / 12:48:57 / cg"
!

setCurrentElement:element
    currentElement := attributableElement := element.
!

startElement:element
    root isNil ifTrue:[
        root := element.
    ] ifFalse:[
        currentElement add:element.
    ].
    currentElement := attributableElement := element.
! !

!AbstractTreeBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__AbstractTreeBuilder.st,v 1.18 2012/01/12 12:14:28 sr Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__AbstractTreeBuilder.st,v 1.18 2012/01/12 12:14:28 sr Exp $'
! !
