"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Anchor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Inline'
!

!Anchor class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!Anchor class methodsFor:'required protocol'!

href:anUrlString
    "Build and return a new anchor 
     with the given url string."

    ^ self href:anUrlString with:nil.
!

href:anURLString with:aElementOrString
    "Build and return a new anchor 
     with the given url string."

    |instance|

    instance := self with:aElementOrString.
    instance href:anURLString.

    ^ instance.
!

tagName
    ^ 'a'.
! !

!Anchor methodsFor:'interface-attributes'!

href
    "Return the hypertext reference of the anchor."

    ^ self attributeAt:#href.
!

href:aHref
    self attributeAt:#href put:aHref.
!

tabindex:anInteger
    "Set the tab index of the element, 0 if not tabbed.
     Valid for <input> <button> <select> <textarea> <a>"

    self attributeAt:#tabindex put:anInteger.
!

target:aTarget
    "Set the target of the link."

    self attributeAt:#target put:aTarget.
! !

!Anchor methodsFor:'queries'!

canHaveChild:anotherElement
    anotherElement isAnchor ifTrue:[^ false].    
    ^ true
!

isAnchor
    ^ true
!

isInlineElement
    ^ true

    "Created: / 06-02-2007 / 17:33:20 / cg"
! !

!Anchor methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitAnchor:self.

    "Modified: / 05-11-2007 / 22:04:59 / cg"
! !

!Anchor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Anchor.st,v 1.20 2008/11/01 18:33:24 stefan Exp $'
! !
