"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Body
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-TopLevel'
!

!Body class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!Body class methodsFor:'required protocol'!

tagName
    ^ 'body'.
! !

!Body methodsFor:'interface-accessing-elements'!

addDiv:anObject
    "Build, add and return a new div-element.

     Div is used to position elements in a page.
     Originally it was only allowing to align
     text left, right and center. Via style-sheet
     it is possible to do more things. Div is used
     as some kind of dummy to hold the class doing
     all this."

    |div|

    div :=  Div with:anObject. 

    ^ self addElement:div.
!

addDiv:anObject class:aHtmlClass
    "Build, add and return a new div-element.
     Use a html-class as attribute in the div.

     Div is used to position elements in a page.
     Originally it was only allowing to align
     text left, right and center. Via style-sheet
     it is possible to do more things. Div is used
     as some kind of dummy to hold the class doing
     all this."

    |div|

    div :=  Div with:anObject class:aHtmlClass. 

    ^ self addElement:div.
!

addDivClass:aHtmlClass
    "Build, add and return a new div-element.
     Use a html-class as attribute in the div.

     Div is used to position elements in a page.
     Originally it was only allowing to align
     text left, right and center. Via style-sheet
     it is possible to do more things. Div is used
     as some kind of dummy to hold the class doing
     all this."

    |div|

    div :=  Div with:nil class:aHtmlClass. 

    ^ self addElement:div.
!

addHeading1:aHeading1OrString
    "Build and add a level one heading to the children.
     The heading will be added as last in the body."

    |heading|

    heading := self buildElement:aHeading1OrString ofType:Heading1. 

    ^ self addChild:heading.
!

addHeading2:aHeading2OrString
    "Build and add a level two heading to the children.
     The heading will be added as last in the body."

    |heading|

    heading := self buildElement:aHeading2OrString ofType:Heading2. 

    ^ self addChild:heading.
!

addHeading3:aHeading3OrString
    "Build and add a level three heading to the children.
     The heading will be added as last in the body."

    |heading|

    heading := self buildElement:aHeading3OrString ofType:Heading3. 

    ^ self addChild:heading.
!

addHeading4:aHeading4OrString
    "Build and add a level four heading to the children.
     The heading will be added as last in the body."

    |heading|

    heading := self buildElement:aHeading4OrString ofType:Heading4. 

    ^ self addChild:heading.
!

addHeading5:aHeading5OrString
    "Build and add a level five heading to the children.
     The heading will be added as last in the body."

    |heading|

    heading := self buildElement:aHeading5OrString ofType:Heading5. 

    ^ self addChild:heading.
!

addHeading6:aHeading6OrString
    "Build and add a level six heading to the children.
     The heading will be added as last in the body."

    |heading|

    heading := self buildElement:aHeading6OrString ofType:Heading6. 

    ^ self addChild:heading.
!

addHorizontalRule
    "Build and add a level one heading to the children.
     The heading will be added as last in the body."

    ^ self addElement:HorizontalRule.
!

addOnLoad:aString
    <resource: #obsolete>
    self obsoleteMethodWarning:'use #onLoad:'.
    self onLoad:aString.
!

addParagraph:aParagraphOrString
    "Build and add a level six heading to the children.
     The paragraph will be added as last in the body."

    |paragraph|

    paragraph := self buildElement:aParagraphOrString ofType:Paragraph. 

    ^ self addChild:paragraph.
!

addTable
    "Build and add a table to the children.
     The table will be added as last in the body."

    ^ self addTable:nil.
!

addTable:aTableOrString
    "Build and add a table to the children.
     The table will be added as last in the body."

    |table|

    table := self buildElement:aTableOrString ofType:Table. 

    ^ self addChild:table.
!

onLoad:aScript
    self on:'onLoad' script:aScript

    "Modified: / 19-07-2010 / 15:03:44 / cg"
! !

!Body methodsFor:'queries'!

canHaveChild:anotherElement
    "return true, if anotherElement is allowed as my child"

    anotherElement isHead ifTrue:[^ false].
    anotherElement isBody ifTrue:[^ false].
    ^ true.
! !

!Body methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitBody:self.

    "Modified: / 05-11-2007 / 22:05:08 / cg"
! !

!Body methodsFor:'testing'!

isBody
    ^ true
! !

!Body class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Body.st,v 1.22 2010/07/19 13:05:36 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Body.st,v 1.22 2010/07/19 13:05:36 cg Exp $'
! !
