"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

CSS_AbstractStyleProperty subclass:#CSS_AbstractStylePropertyBox
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-StyleSheet'
!

!CSS_AbstractStylePropertyBox class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!CSS_AbstractStylePropertyBox class methodsFor:'instance creation'!

bottom:aValue
    "Create a new box where only the bottom value is set.
     Perhaps you could use also a more concrete subclass
     (CSS_BottomMargin, CSS_BottomPadding) to do this."

    |instance|

    instance := self newAuto.
    instance bottom:aValue.
    ^ instance.

    "
    |margin|
    margin := CSS_Margin bottom:'2%'.
    margin printHtmlString.
    "
!

left:aValue
    "Create a new box where only the left value is set.
     Perhaps you could use also a more concrete subclass
     (CSS_BottomMargin, CSS_BottomPadding) to do this."

    |instance|

    instance := self newAuto.
    instance left:aValue.
    ^ instance.

    "
    |margin|
    margin := CSS_Margin left:'2%'.
    margin printHtmlString.
    "
!

right:aValue
    "Create a new box where only the right value is set.
     Perhaps you could use also a more concrete subclass
     (CSS_BottomMargin, CSS_BottomPadding) to do this."

    |instance|

    instance := self newAuto.
    instance right:aValue.
    ^ instance.

    "
    |margin|
    margin := CSS_Margin right:'2%'.
    margin printHtmlString.
    "
!

top:aValue
    "Create a new box where only the top value is set.
     Perhaps you could use also a more concrete subclass
     (CSS_BottomMargin, CSS_BottomPadding) to do this."

    |instance|

    instance := self newAuto.
    instance top:aValue.
    ^ instance.

    "
    |margin|
    margin := CSS_Margin top:'2%'.
    margin printHtmlString.
    "
!

top:aTopValue right:aRightValue
    "Create a new box with two values.
     The values represent the left and 
     right value and the top and bottom
     value. If the values are equal 
     there will be reduce to one value."

    ^ self top:    aTopValue 
           right:  aRightValue 
           bottom: aTopValue 
           left:   aRightValue.

    "
    |margin|
    margin := CSS_Margin 
                  top:   '1%'
                  right: '2%'.

    margin printHtmlString.
    "

    "
    |margin|
    margin := CSS_Margin 
                  top:   '1%'
                  right: '1%'.

    margin printHtmlString.
    "
!

top:aTopValue right:aRightValue bottom:aBottomValue left:aLeftValue
    "Create a new box with all four values.
     If values are identical they will be 
     reduced to a shorter description."

    |instance|

    instance := self newAuto.
    instance top:    aTopValue 
             right:  aRightValue 
             bottom: aBottomValue 
             left:   aLeftValue.

    ^ instance.

    "
    |margin|
    margin := CSS_Margin 
                  top:    '1%'
                  right:  '2%'
                  bottom: '3%'
                  left:   '4%'.

    margin printHtmlString.
    "

    "
    |margin|
    margin := CSS_Margin 
                  top:    '1%'
                  right:  '2%'
                  bottom: '1%'
                  left:   '2%'.

    margin printHtmlString.
    "

    "
    |margin|
    margin := CSS_Margin 
                  top:    '4px'
                  right:  '4px'
                  bottom: '4px'
                  left:   '4px'.

    margin printHtmlString.
    "
! !

!CSS_AbstractStylePropertyBox class methodsFor:'required protocol'!

isAbstract
    "Return if this class is an abstract class.
     Return true for this class but false for all subclasses.
     To have an abstract subclass implement this method there again."

    ^ self = CSS_AbstractStylePropertyBox.

    "
    CSS_AbstractStylePropertyBox isAbstract.
    CSS_Color isAbstract.
    "
! !

!CSS_AbstractStylePropertyBox methodsFor:'interface-accessing'!

beAuto
    "Set the margin to auto."

    self value:#auto.

    "
    CSS_Margin newAuto printHtmlString.
    "
!

bottom
    "Return the bottom margin."

    |value|
    value := self value.

    value isOrderedCollection ifTrue:[
        ^ value at:self bottomIndex ifAbsent:[self top].
    ].

    ^ value.

    "
    |margin|
    margin := CSS_Margin with:'5px'.
    margin bottom.
    "
!

bottom:aValue
    "Set the bottom side of the margin."

    |value|

    self bottom = aValue ifTrue:[^ self].

    value := self expandTo4

    value at:self bottomIndex put:aValue.

    self reduce.

    "
    |margin|
    margin := CSS_Margin newAuto.
    margin bottom:'5px'.
    margin printHtmlString.
    "
!

left

    |value|
    value := self value.

    value isOrderedCollection ifTrue:[
        ^ value at:self leftIndex ifAbsent:[self rightValue].
    ].

    ^ value.

    "
    |margin|
    margin := CSS_Margin with:'5px'.
    margin left.
    "
!

left:aValue
    "Set the left side of the margin."

    |value|

    self left = aValue ifTrue:[^ self].

    value := self expandTo4

    value at:self leftIndex put:aValue.

    self reduce.

    "
    |margin|
    margin := CSS_Margin newAuto.
    margin left:'5px'.
    margin printHtmlString.
    "
!

right

    |value|
    value := self value.

    value isOrderedCollection ifTrue:[
        ^ value at:self rightIndex ifAbsent:[self top].
    ].

    ^ value.

    "
    |margin|
    margin := CSS_Margin with:'5px'.
    margin right.
    "
!

right:aValue
    "Set the right side of the margin."

    |value|

    self right = aValue ifTrue:[^ self].

    value := self expandTo4

    value at:self rightIndex put:aValue.

    self reduce.

    "
    |margin|
    margin := CSS_Margin newAuto.
    margin right:'5px'.
    margin printHtmlString.
    "
!

top

    |value|
    value := self value.

    value isOrderedCollection ifTrue:[
        ^ value at:self topIndex ifAbsent:[''].
    ].

    ^ value.

    "
    |margin|
    margin := CSS_Margin with:'5px'.
    margin top.
    "
!

top:aValue
    "Set the top side of the margin."

    |value|

    self top = aValue ifTrue:[^ self].

    value := self expandTo4

    value at:self topIndex put:aValue.

    self reduce.

    "
    |margin|
    margin := CSS_Margin newAuto.
    margin top:'5px'.
    margin printHtmlString.
    "
!

top:aTopValue right:aRightValue bottom:aBottomValue left:aLeftValue
    "Set all four sides of the margin in one."

    self value:(OrderedCollection
                   with: aTopValue
                   with: aRightValue
                   with: aBottomValue
                   with: aLeftValue).

    self reduce.


    "
    |margin|
    margin := CSS_Margin 
                  top:    '1%'
                  right:  '2%'
                  bottom: '3%'
                  left:   '4%'.

    margin printHtmlString.
    "

    "
    |margin|
    margin := CSS_Margin 
                  top:    '1%'
                  right:  '2%'
                  bottom: '1%'
                  left:   '2%'.

    margin printHtmlString.
    "

    "
    |margin|
    margin := CSS_Margin 
                  top:    '4px'
                  right:  '4px'
                  bottom: '4px'
                  left:   '4px'.

    margin printHtmlString.
    "
! !

!CSS_AbstractStylePropertyBox methodsFor:'private-accessing'!

bottomIndex
    "Return the index of the bottom-value in the value-collection."

    ^ 3.
!

leftIndex
    "Return the index of the left-value in the value-collection."

    ^ 4.
!

rightIndex
    "Return the index of the right-value in the value-collection."

    ^ 2.
!

topIndex
    "Return the index of the top-value in the value-collection."

    ^ 1.
! !

!CSS_AbstractStylePropertyBox methodsFor:'private-action'!

expandTo4
    "One side of the box is about to change.
     The box was having equal sides before 
     with one value, now it is necessary 
     to have four values for each side one."

    |value|

    value := self value.

    (value isCollection and:[value isString not]) ifTrue:[
        |size|
        size := value size.
        size >= 4 ifTrue:[
            ^ value
        ].

        size == 3 ifTrue:[
            value add:value second.
            ^ value
        ].

        size == 2 ifTrue:[
            value add:value first.
            value add:value second.
            ^ value.
        ].

        3 timesRepeat:[
            value add:value first.
        ].

        ^ value.
    ].

    value := OrderedCollection new:4 withAll:value.

    self value:value.

    ^ value.

    "
    |values margin|
    values := OrderedCollection with:'1em' with:'2em' with:'3em'.
    margin := CSS_AbstractStylePropertyBox with:values.
    margin expandTo4 value.
    "

    "
    |values margin|
    values := OrderedCollection with:'1em' with:'2em'.
    margin := CSS_AbstractStylePropertyBox with:values.
    margin expandTo4 value.
    "

    "
    |values margin|
    values := OrderedCollection with:'1em'.
    margin := CSS_AbstractStylePropertyBox with:values.
    margin expandTo4 value.
    "
!

reduce
    "Try to remove the duplicate values by reducing 
     to one value if all elements are equal or to
     two values if top-bottom(1-3) or left right(2-4)
     are equal."

    |value first|
    value := self value.
    value isOrderedCollection ifFalse:[^ self].

    first := value first.
    (value conform:[:subvalue|subvalue = first]) ifTrue:[
        self value: first.
        ^ value.
    ].

    value size == 4 ifTrue:[
        (value second = value fourth) ifTrue:[
            value removeLast.
        ].
    ].

    value size == 3 ifTrue:[
        (value first = value third) ifTrue:[
            value removeLast.
        ].
    ].

    ^ value.

    "
    |values margin|
    values := OrderedCollection with:'1em' with:'2em' with:'3em' with:'1em'.
    margin := CSS_AbstractStylePropertyBox with:values.
    margin reduce value.
    "

    "
    |values margin|
    values := OrderedCollection with:'1em' with:'2em' with:'1em' with:'2em'.
    margin := CSS_AbstractStylePropertyBox with:values.
    margin reduce value.
    "

    "
    |values margin|
    values := OrderedCollection with:'1em' with:'1em' with:'1em' with:'1em'.
    margin := CSS_AbstractStylePropertyBox with:values.
    margin reduce value.
    "
! !

!CSS_AbstractStylePropertyBox class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__CSS_AbstractStylePropertyBox.st,v 1.7 2007/03/12 12:30:11 cg Exp $'
! !
