"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

CSS_AbstractStyleProperty subclass:#CSS_BackgroundRepeat
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-StyleSheet-Color and Background'
!

!CSS_BackgroundRepeat class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"
[exBegin]
    |repeat|
    repeat := BackgroundRepeat new.
    repeat printHtmlString.
[exEnd]


[exBegin]
    |repeat|
    repeat := BackgroundRepeat newRepeat.
    repeat printHtmlString.
[exEnd]


[exBegin]
    |repeat|
    repeat := BackgroundRepeat newNoRepeat.
    repeat printHtmlString.
[exEnd]


[exBegin]
    |repeat|
    repeat := BackgroundRepeat newRepeatX.
    repeat printHtmlString.
[exEnd]


[exBegin]
    |repeat|
    repeat := BackgroundRepeat newRepeatY.
    repeat printHtmlString.
[exEnd]
"
! !

!CSS_BackgroundRepeat class methodsFor:'instance creation'!

newNoRepeat
    "Return a background repeat set to no repeat."

    |instance|

    instance := self new.
    instance beNoRepeat.

    ^ instance.

    "
    CSS_BackgroundRepeat newNoRepeat printHtmlString.
    "
!

newRepeat
    "Return a background repeat set to repeat."

    |instance|

    instance := self new.
    instance beRepeat.

    ^ instance.

    "
    CSS_BackgroundRepeat newRepeat printHtmlString.
    "
!

newRepeatX
    "Return a background repeat set to repeat-x."

    |instance|

    instance := self new.
    instance beRepeatX.

    ^ instance.

    "
    CSS_BackgroundRepeat newRepeatX printHtmlString.
    "
!

newRepeatY
    "Return a background repeat set to repeat-y."

    |instance|

    instance := self new.
    instance beRepeatY.

    ^ instance.

    "
    CSS_BackgroundRepeat newRepeatY printHtmlString.
    "
! !

!CSS_BackgroundRepeat class methodsFor:'required protocol'!

keyName
    "Return a key name for background-repeat."

    ^ 'background-repeat'.
! !

!CSS_BackgroundRepeat methodsFor:'interface-accessing'!

beNoRepeat
    "Set the background to not repeat."

    self value:'no-repeat'.
!

beRepeat
    "Set the background to repeat horizontally and vertically."

    self value:#repeat.
!

beRepeatX
    "Set the background to repeat horizontally."

    self value:'repeat-x'.
!

beRepeatY
    "Set the background to repeat vertically."

    self value:'repeat-y'.
! !

!CSS_BackgroundRepeat methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitBackgroundRepeat:self.

    "Modified: / 05-11-2007 / 22:05:31 / cg"
! !

!CSS_BackgroundRepeat class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__CSS_BackgroundRepeat.st,v 1.9 2008/09/03 09:55:13 cg Exp $'
! !
