"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

CSS_AbstractStylePropertyBox subclass:#CSS_BorderStyle
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-StyleSheet-Box-Border'
!

!CSS_BorderStyle class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"
Create an empty border-style:
[exBegin]
    |style|
    style := CSS_BorderStyle newAuto.
    style printHtmlString.
[exEnd]


Create a border-style for all sides:
[exBegin]
    |style|
    style := CSS_BorderStyle 
                 top:    #dashed 
                 right:  #dotted
                 bottom: #solid
                 left:   #double.

    style printHtmlString.
[exEnd]


Create a border-style with top-left identical values:
(This one will reduce to top-left)
[exBegin]
    |style|
    style := CSS_BorderStyle 
                 top:    #dashed
                 right:  #dotted
                 bottom: #dashed
                 left:   #dotted.

    style printHtmlString.
[exBegin]


Create a border-style with identical values:
(This one will reduce to onme value)
[exBegin]
    |style|
    |style|
    style := CSS_BorderStyle 
                 top:    #double
                 right:  #double
                 bottom: #double
                 left:   #double.

    style printHtmlString.
[exBegin]


Create a dashed border:
[exBegin]
    CSS_BorderStyle newDashed printHtmlString.
[exBegin]


Create a dashed border:
[exBegin]
    CSS_BorderStyle newDotted printHtmlString.
[exBegin]


Create a double border:
[exBegin]
    CSS_BorderStyle newDouble printHtmlString.
[exBegin]


Create a groove border:
[exBegin]
    CSS_BorderStyle newGroove printHtmlString.
[exBegin]


Create a inset border:
[exBegin]
    CSS_BorderStyle newInset printHtmlString.
[exBegin]


Create a none border:
[exBegin]
    CSS_BorderStyle newNone printHtmlString.
[exBegin]


Create a outset border:
[exBegin]
    CSS_BorderStyle newOutset printHtmlString.
[exBegin]


Create a ridge border:
[exBegin]
    CSS_BorderStyle newRidge printHtmlString.
[exBegin]


Create a solid border:
[exBegin]
    CSS_BorderStyle newSolid printHtmlString.
[exBegin]
"
! !

!CSS_BorderStyle class methodsFor:'instance creation'!

newDashed
    "Create a new border-style initialy set to dashed."

    ^ self new beDashed.

    "
    CSS_BorderStyle newDashed printHtmlString.
    "
!

newDotted
    "Create a new border-style initialy set to dotted."

    ^ self new beDotted.

    "
    CSS_BorderStyle newDotted printHtmlString.
    "
!

newDouble
    "Create a new border-style initialy set to double."

    ^ self new beDouble.

    "
    CSS_BorderStyle newDouble printHtmlString.
    "
!

newGroove
    "Create a new border-style initialy set to groove."

    ^ self new beGroove.

    "
    CSS_BorderStyle newGroove printHtmlString.
    "
!

newInset
    "Create a new border-style initialy set to inset."

    ^ self new beInset.

    "
    CSS_BorderStyle newInset printHtmlString.
    "
!

newOutset
    "Create a new border-style initialy set to outset."

    ^ self new beOutset.

    "
    CSS_BorderStyle newOutset printHtmlString.
    "
!

newRidge
    "Create a new border-style initialy set to ridge."

    ^ self new beRidge.

    "
    CSS_BorderStyle newRidge printHtmlString.
    "
!

newSolid
    "Create a new border-style initialy set to solid."

    ^ self new beSolid.

    "
    CSS_BorderStyle newSolid printHtmlString.
    "
! !

!CSS_BorderStyle class methodsFor:'required protocol'!

keyName
    "Return a key name for border-style."

    ^ 'border-style'.
! !

!CSS_BorderStyle methodsFor:'interface-accessing'!

beDashed
    "Set the border-style to dashed."

    self value:#dashed.

    "
    CSS_BorderStyle newDashed printHtmlString.
    "
!

beDotted
    "Set the border-style to dotted."

    self value:#dotted.

    "
    CSS_BorderStyle newDotted printHtmlString.
    "
!

beDouble
    "Set the border-style to double."

    self value:#double.

    "
    CSS_BorderStyle newDouble printHtmlString.
    "
!

beGroove
    "Set the border-style to groove."

    self value:#groove.

    "
    CSS_BorderStyle newGroove printHtmlString.
    "
!

beInset
    "Set the border-style to inset."

    self value:#inset.

    "
    CSS_BorderStyle newInset printHtmlString.
    "
!

beOutset
    "Set the border-style to outset."

    self value:#outset.

    "
    CSS_BorderStyle newOutset printHtmlString.
    "
!

beRidge
    "Set the border-style to ridge."

    self value:#ridge.

    "
    CSS_BorderStyle newRidge printHtmlString.
    "
!

beSolid
    "Set the border-style to solid."

    self value:#solid.

    "
    CSS_BorderStyle newSolid printHtmlString.
    "
! !

!CSS_BorderStyle methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitBorderStyle:self.

    "Modified: / 05-11-2007 / 22:05:37 / cg"
! !

!CSS_BorderStyle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__CSS_BorderStyle.st,v 1.9 2008/09/03 09:54:49 cg Exp $'
! !
