"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

CSS_AbstractStylePropertyBox subclass:#CSS_Padding
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-StyleSheet-Box-MarginAndPadding'
!

!CSS_Padding class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"
Create an empty padding:
[exBegin]
    |padding|
    padding := CSS_Padding newAuto.
    padding printHtmlString.
[exEnd]


Create a padding for all sides:
[exBegin]
    |padding|
    padding := CSS_Padding with:'1 cm'.

    padding printHtmlString.
[exEnd]


Create a padding for different sides:
[exBegin]
    |padding|
    padding := CSS_Padding 
                  top:    '1%' 
                  right:  '2%'
                  bottom: '3%'
                  left:   '4%'.

    padding printHtmlString.
[exEnd]


Create a padding with top-left identical values:
(This one will reduce to top-left)
[exBegin]
    |padding|
    padding := CSS_Padding 
                  top:    '1%'
                  right:  '2%'
                  bottom: '1%'
                  left:   '2%'.

    padding printHtmlString.
[exBegin]


Create a padding with identical values:
(This one will reduce to onme value)
[exBegin]
    |padding|
    padding := CSS_Padding 
                  top:    '4px'
                  right:  '4px'
                  bottom: '4px'
                  left:   '4px'.

    padding printHtmlString.
[exBegin]

"
! !

!CSS_Padding class methodsFor:'required protocol'!

keyName
    "Return a key name for padding."

    ^ 'padding'.
! !

!CSS_Padding methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitPadding:self.

    "Modified: / 05-11-2007 / 22:06:30 / cg"
! !

!CSS_Padding class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__CSS_Padding.st,v 1.9 2007/11/05 21:10:36 cg Exp $'
! !
