"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

CSS_AbstractStyleObject subclass:#CSS_StyleElement
	instanceVariableNames:'selectors properties'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-StyleSheet'
!

!CSS_StyleElement class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"
Create an empty style element with one selector:
[exBegin]
    |element|
    element := StyleElement selectors:#H1.
    element printHtmlString.
[exEnd]



Create an empty style element with a list of selectors:
[exBegin]
    |element|
    element := StyleElement selectors:#('H1' 'H2' 'H3').
    element printHtmlString.
[exEnd]



Create an empty style and add some properties
[exBegin]
    |element|
    element := StyleElement selectors:#H1.
    element color:#red.
    element backgroundColor:#black.
    element printHtmlString.
[exEnd]



Create a style element from predefined properties:
[exBegin]
    |properties element|
    properties := Array with: (CSS_Color       with:#red)
                        with: (BackgroundColor with:#black).

    element := StyleElement 
                   selectors: #H1 
                   properties:properties.

    element printHtmlString.
[exEnd]
"
! !

!CSS_StyleElement class methodsFor:'instance creation'!

selectors:aSelectorCollection
    "Create a new style element with its selectors.

     The properties keep empty here. Though an empty
     style elment is not useful, we allow to build it,
     because properties can be added via interface easily.

     A style element can have one or a list of selectors.
     See instance method: '#selectors:properties:'."

    ^ self selectors:aSelectorCollection properties:nil.
!

selectors:aSelectorCollection properties:aPropertyCollection
    "Create a new style element with its selectors and properties.

     The selectors are the names under which the style will be 
     accessible. There must be minimum one selector.

     The properties are the definitions forming the style.
     A property collection may be nil here to define an empty style.
     Though an empty style elment is not useful, we allow to build 
     it, because properties can be added via interface easily.

     The properties have to be ready build properties."

    |instance properties|
    instance := self new.

    properties := aPropertyCollection isNil 
                      ifTrue: [OrderedCollection new]
                      ifFalse:[aPropertyCollection].

    instance selectors: aSelectorCollection 
             properties:properties.

    ^ instance.
! !

!CSS_StyleElement methodsFor:'accessing'!

properties
    "Return the properties.
     The properties are the definitions 
     of the show the style looks like."

    ^ properties.
!

selectors
    "Return the Selectors.
     The selectors are the names under 
     which the style is accessible."

    ^ selectors.
! !

!CSS_StyleElement methodsFor:'interface-accessing'!

backgroudColorAqua
     "Set backgroudColor in properties to be aqua."

     self addProperty:CSS_BackgroundColor newAqua.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorAqua.
     element printHtmlString.
     "
!

backgroudColorBlack
     "Set backgroudColor in properties to be black."

     self addProperty:CSS_BackgroundColor newBlack.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorBlack.
     element printHtmlString.
     "
!

backgroudColorBlue
     "Set backgroudColor in properties to be blue."

     self addProperty:CSS_BackgroundColor newBlue.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorBlue.
     element printHtmlString.
     "
!

backgroudColorFuchsia
     "Set color in properties to be fuchsia."

     self addProperty:CSS_BackgroundColor newFuchsia.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorFuchsia.
     element printHtmlString.
     "
!

backgroudColorGray
     "Set color in properties to be gray."

     self addProperty:CSS_BackgroundColor newGray.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorGray.
     element printHtmlString.
     "
!

backgroudColorGreen
     "Set color in properties to be green."

     self addProperty:CSS_BackgroundColor newGreen.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorGreen.
     element printHtmlString.
     "
!

backgroudColorLime
     "Set color in properties to be lime."

     self addProperty:CSS_BackgroundColor newLime.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorLime.
     element printHtmlString.
     "
!

backgroudColorMaroon
     "Set color in properties to be maroon."

     self addProperty:CSS_BackgroundColor newMaroon.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorMaroon.
     element printHtmlString.
     "
!

backgroudColorNavy
     "Set color in properties to be navy."

     self addProperty:CSS_BackgroundColor newNavy.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorNavy.
     element printHtmlString.
     "
!

backgroudColorOlive
     "Set color in properties to be olive."

     self addProperty:CSS_BackgroundColor newOlive.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorOlive.
     element printHtmlString.
     "
!

backgroudColorPurple
     "Set color in properties to be purple."

     self addProperty:CSS_BackgroundColor newPurple.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorPurple.
     element printHtmlString.
     "
!

backgroudColorRed
     "Set color in properties to be red."

     self addProperty:CSS_BackgroundColor newRed.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorRed.
     element printHtmlString.
     "
!

backgroudColorSilver
     "Set color in properties to be silver."

     self addProperty:CSS_BackgroundColor newSilver.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorSilver.
     element printHtmlString.
     "
!

backgroudColorTeal
     "Set color in properties to be teal."

     self addProperty:CSS_BackgroundColor newTeal.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorTeal.
     element printHtmlString.
     "
!

backgroudColorWhite
     "Set color in properties to be white."

     self addProperty:CSS_BackgroundColor newWhite.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorWhite.
     element printHtmlString.
     "
!

backgroudColorYellow
     "Set color in properties to be white."

     self addProperty:CSS_BackgroundColor newYellow.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element backgroudColorYellow.
     element printHtmlString.
     "
!

backgroundAttachment:aValue
     "Add a background-attachment to the properties."

     self addProperty:CSS_BackgroundAttachment value:aValue.
!

backgroundColor:aValue
     "Add a background-color to the properties."

     self addProperty:CSS_BackgroundColor value:aValue.
!

backgroundImage:aValue
     "Add a background-image to the properties."

     self addProperty:CSS_BackgroundImage value:aValue.
!

backgroundPosition:aValue
     "Add a background-position to the properties."

     self addProperty:CSS_BackgroundPosition value:aValue.
!

backgroundRepeat:aValue
     "Add a background-repeat to the properties."

     self addProperty:CSS_BackgroundRepeat value:aValue.
!

color:aValue
     "Add a color to the properties."

     self addProperty:CSS_Color value:aValue.
!

colorAqua
     "Set color in properties to be aqua."

     self addProperty:CSS_Color newAqua.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorAqua.
     element printHtmlString.
     "
!

colorBlack
     "Set color in properties to be black."

     self addProperty:CSS_Color newBlack.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorBlack.
     element printHtmlString.
     "
!

colorBlue
     "Set color in properties to be blue."

     self addProperty:CSS_Color newBlue.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorBlue.
     element printHtmlString.
     "
!

colorFuchsia
     "Set color in properties to be fuchsia."

     self addProperty:CSS_Color newFuchsia.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorFuchsia.
     element printHtmlString.
     "
!

colorGray
     "Set color in properties to be gray."

     self addProperty:CSS_Color newGray.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorGray.
     element printHtmlString.
     "
!

colorGreen
     "Set color in properties to be green."

     self addProperty:CSS_Color newGreen.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorGreen.
     element printHtmlString.
     "
!

colorLime
     "Set color in properties to be lime."

     self addProperty:CSS_Color newLime.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorLime.
     element printHtmlString.
     "
!

colorMaroon
     "Set color in properties to be maroon."

     self addProperty:CSS_Color newMaroon.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorMaroon.
     element printHtmlString.
     "
!

colorNavy
     "Set color in properties to be navy."

     self addProperty:CSS_Color newNavy.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorNavy.
     element printHtmlString.
     "
!

colorOlive
     "Set color in properties to be olive."

     self addProperty:CSS_Color newOlive.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorOlive.
     element printHtmlString.
     "
!

colorPurple
     "Set color in properties to be purple."

     self addProperty:CSS_Color newPurple.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorPurple.
     element printHtmlString.
     "
!

colorRed
     "Set color in properties to be red."

     self addProperty:CSS_Color newRed.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorRed.
     element printHtmlString.
     "
!

colorSilver
     "Set color in properties to be silver."

     self addProperty:CSS_Color newSilver.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorSilver.
     element printHtmlString.
     "
!

colorTeal
     "Set color in properties to be teal."

     self addProperty:CSS_Color newTeal.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorTeal.
     element printHtmlString.
     "
!

colorWhite
     "Set color in properties to be white."

     self addProperty:CSS_Color newWhite.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorWhite.
     element printHtmlString.
     "
!

colorYellow
     "Set color in properties to be yellow."

     self addProperty:CSS_Color newYellow.

     "
     |element|
     element := CSS_StyleElement selectors:#H1.
     element colorYellow.
     element printHtmlString.
     "
! !

!CSS_StyleElement methodsFor:'private-accessing'!

buildSelectors:aRawSelectors
    "Build the selectors from a raw object with the selector information.
     This could be a string for one selector or a collection of selectors."

    (aRawSelectors isString not and:[aRawSelectors isCollection]) ifTrue:[
        ^ aRawSelectors.
    ].

    ^ OrderedCollection with:aRawSelectors.
!

selectors:aSelectorCollection properties:aPropertyCollection
    "Set selectors and properties.
     Private - Use only for instance creation."

    selectors := self buildSelectors:aSelectorCollection.

    properties := aPropertyCollection.
! !

!CSS_StyleElement methodsFor:'private-building'!

addProperty:aProperty
    "Add a new property of a class."

    ^ properties add:aProperty.
!

addProperty:aClass value:aValue
    "Build and add a new property of a class."

    |property|

    property := aClass with:aValue.

    ^ self addProperty:property.
! !

!CSS_StyleElement methodsFor:'visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitStyleElement:self.

    "Modified: / 05-11-2007 / 22:06:43 / cg"
! !

!CSS_StyleElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__CSS_StyleElement.st,v 1.7 2007/11/05 21:10:50 cg Exp $'
! !
