"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Center
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-BlockLevel'
!

!Center class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Alignment html element..

    [author:]
        Martin Walser

    [instance variables:]
        -

    [class variables:]
        -

    [see also:]
        Div
"
!

examples
"
A centered text:
[exBegin]
    |center|
    center := Center with:'This is a generated centered Text'.
    center printHtmlString.
[exEnd]


A centered paragraph:
[exBegin]
    |paragraph center|
    paragraph := Paragraph with: 'This is a generated centered Text.'.
    center    := Center with: paragraph.
    center printHtmlString.
[exEnd]
"
! !

!Center class methodsFor:'required protocol'!

tagName
    "Return a tag name for a center."

    ^ 'center'.
! !

!Center methodsFor:'queries'!

canHaveChild:aChild
    ^ aChild isInlineElement or:[ aChild isBlockElement ]

    "Created: / 02-11-2007 / 15:44:51 / cg"
!

printInlineWithSimpleElements
    ^ true

    "Created: / 02-11-2007 / 15:44:51 / cg"
! !

!Center methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitCenter:self.

    "Modified: / 05-11-2007 / 22:07:13 / cg"
! !

!Center methodsFor:'testing'!

isBlockElement
    ^ true

    "Created: / 06-02-2007 / 17:30:17 / cg"
!

isCenter
    ^ true

    "Created: / 06-02-2007 / 17:30:17 / cg"
! !

!Center class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Center.st,v 1.15 2008/01/11 09:03:15 cg Exp $'
! !
