"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#DefinitionList
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Lists'
!

!DefinitionList class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"
A definition list:
[exBegin]
    |list|

    list := DefinitionList new.

    list addDefinition:'Smalltalk' -> 'Object oriented programming language.'.

    list addLineBreak.

    list addDefinitionTerm:'Java'.
    list addDefinitionDescription:'Clever marketing strategie based on old stuff..'.

    list printHtmlString.
[exEnd]
"
! !

!DefinitionList class methodsFor:'required protocol'!

tagName
    ^ 'dl'.
! !

!DefinitionList methodsFor:'queries'!

canHaveChild:anotherElement
    "return true, if anotherElement is allowed as my child"

    ^ anotherElement isDefinitionTerm or:[anotherElement isDefinitionDescription ]
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:04:20 / cg"
! !

!DefinitionList methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitDefinitionList:self.

    "Modified: / 05-11-2007 / 22:07:23 / cg"
!

addDefinition:anAssociation
    "Add a defintion description to the definition list.

     The definition description can be either the html-object
     or a simple string."

    |term description|

    term        := self addDefinitionTerm:        anAssociation key.
    description := self addDefinitionDescription: anAssociation value.

    ^ term -> description.
!

addDefinitionDescription:aDefinitionDescriptionOrString
    "Add a defintion description to the definition list.

     The definition description can be either the html-object
     or a simple string."

    |description|

    description := self buildElement: aDefinitionDescriptionOrString 
                        ofType:       DefinitionDescription. 

    ^ self addChild:description.
!

addDefinitionTerm:aDefinitionTermOrString
    "Add a defintion term to the definition list.

     The definition term can be either the html-object
     or a simple string."

    |term|

    term := self buildElement: aDefinitionTermOrString 
                 ofType:       DefinitionTerm. 

    ^ self addChild:term.
! !

!DefinitionList methodsFor:'testing'!

isBlockElement
    ^ true

    "Created: / 06-02-2007 / 17:30:44 / cg"
! !

!DefinitionList class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__DefinitionList.st,v 1.15 2007/11/05 21:11:29 cg Exp $'
! !
