"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Element
	instanceVariableNames:'tagName'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree'
!

!Element class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"

  more examples to be added:
                                                                [exBegin]
    ... add code fragment for 
    ... executable example here ...
                                                                [exEnd]
"
! !

!Element class methodsFor:'queries'!

isGeneric
    "Return true here.
     This is the only generic element."

    ^ true.
! !

!Element methodsFor:'accessing'!

tagName
    "Return the tag name."

    ^ tagName.
!

tagName:aTagName
    "Set the tag name.
     Despite all other tag names
     here it is settable."

    tagName := aTagName.
! !

!Element methodsFor:'queries'!

canHaveChild:anElement
    (tagName sameAs: 'area') ifTrue:[^ false].
    (tagName sameAs: 'basefont') ifTrue:[^ false].
    (tagName sameAs: 'isindex') ifTrue:[^ false].
    (tagName sameAs: 'option') ifTrue:[^ false].
    (tagName sameAs: 'param') ifTrue:[^ false].
    (tagName sameAs: 'textarea') ifTrue:[^ false].
    (tagName sameAs: 'kbd') ifTrue:[
        ^ anElement isInlineElement
    ].
    (tagName sameAs: 'tt') ifTrue:[
        ^ anElement isInlineElement
    ].
    (tagName sameAs: 'map') ifTrue:[
        (anElement tagName sameAs:'area') ifTrue:[^ true]. 
        #'todo'. "more here ?"
    ].
    (tagName sameAs: 'object') ifTrue:[
        (anElement tagName sameAs:'param') ifTrue:[^ true]. 
        #'todo'. "more here ?"
    ].
    #'todo'. "more here ?"
    ^ true

    "Created: / 06-02-2007 / 17:44:27 / cg"
    "Modified: / 02-11-2007 / 15:46:00 / cg"
!

canHaveText
    tagName isNil ifTrue:[^ true]. "/ a dummy element
    (tagName sameAs: 'area') ifTrue:[^ false].
    (tagName sameAs: 'basefont') ifTrue:[^ false].
    (tagName sameAs: 'dir') ifTrue:[^ false].
    (tagName sameAs: 'isindex') ifTrue:[^ false].
    (tagName sameAs: 'menu') ifTrue:[^ false].
    (tagName sameAs: 'optgroup') ifTrue:[^ false].
    (tagName sameAs: 'param') ifTrue:[^ false].

    ^ true

    "Created: / 06-02-2007 / 19:57:41 / cg"
!

mustBeClosed
    (tagName sameAs: 'param') ifTrue:[^ false].

    ^ super mustBeClosed

    "Created: / 02-11-2007 / 15:47:38 / cg"
! !

!Element methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitElement:self.

    "Modified: / 05-11-2007 / 22:04:45 / cg"
! !

!Element methodsFor:'testing'!

isBlockElement
    "return true, if I am a block-element; false otherwise"

    ^ #(
        'dir'
        'fieldset'
        'isindex'
        'menu'
    ) includes:(tagName asLowercase)

    "Created: / 06-02-2007 / 17:41:39 / cg"
    "Modified: / 05-11-2007 / 22:04:11 / cg"
!

isInlineElement
    "return true, if I am an inline-element; false otherwise"

    tagName isNil ifTrue:[^ false].

    ^ #(
        'abbr' 
        'acronym'
        'applet'
        'b'
        'basefont'
        'bdo'
        'big'
        'br'
        'button'
        'cite'
        'code'
        'dfn'
        'em'
        'font'
        'i'
        'img'
        'input'
        'iframe'
        'kbd'
        'label'
        'map'
        'object'
        'q'
        'samp'
        'script'
        'select'
        'small'
        'span'
        'strong'
        'sub'
        'sup'
        'textarea'
        'tt'
        'var'
    ) includes:(tagName asLowercase)

    "Created: / 06-02-2007 / 17:34:12 / cg"
    "Modified: / 05-11-2007 / 22:04:20 / cg"
! !

!Element class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Element.st,v 1.29 2008/01/11 09:38:10 cg Exp $'
! !
