"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Form
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Form'
!

!Form class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"

  more examples to be added:
                                                                [exBegin]
    ... add code fragment for 
    ... executable example here ...
                                                                [exEnd]
"
! !

!Form class methodsFor:'instance creation'!

method:arg1 action:arg2
    ^ self new method:arg1 action:arg2
! !

!Form class methodsFor:'required protocol'!

tagName
    ^ 'form'.
! !

!Form methodsFor:'interface-attributes'!

acceptCharset
    "Return the accept-charset-attribute of this form."

    ^ self attributeAt:#acceptCharset.
!

acceptCharset:aCharSet
    "Set the accept-charset-attribute of this form."

    self attributeAt:#acceptCharset put:aCharSet.
!

action
    "Return the action of this form."

    ^ self attributeAt:#action.
!

action:anAction
    "Set the action of this form."

    self attributeAt:#action put:anAction.
!

addCheckBoxNamed:aName value:aValue
    
    ^ self addCheckBoxNamed:aName value:aValue isChecked:false 
!

addCheckBoxNamed:aName value:aValue isChecked:aBoolean 
    | aCheckBox |
    aCheckBox := HTML::Input newCheckBoxNamed:aName value:aValue.
    aBoolean == true ifTrue:[
        aCheckBox beChecked
    ].
    ^ self add:aCheckBox.
!

addHiddenFieldNamed:aName value:aValue
    
    ^ self add:(HTML::Input newHiddenFieldNamed:aName value:aValue).
!

encType
    "Return the encoding type of this form."

    ^ self attributeAt:#encType.
!

encType:anEncType
    "Set the encoding type of this form."

    self attributeAt:#encType put:anEncType.
!

enctype:enctypeString
    self attributeAt:#enctype put:enctypeString.
!

method
    "Return the method of this form."

    ^ self attributeAt:#method.
!

method:methodString
    "Set the method of this form."

    self assert:(#('post' 'get') includes:methodString asLowercase).
    self attributeAt:#method put:methodString.
!

method:methodString action:actionString
    "Set both method and action of this form."

    self assert:(#('post' 'get') includes:methodString asLowercase).
    self attributeAt:#method put:methodString.
    self attributeAt:#action put:actionString.
!

onReset
    "Return the on-reset-attribute of this form."

    ^ self attributeAt:#onReset.
!

onReset:aScript
    "Set the on-reset-attribute of this form."

    self on:#onReset script:aScript.

    "Modified: / 19-07-2010 / 15:04:36 / cg"
!

onSubmit
    "Return the on-submit-attribute of this form."

    ^ self attributeAt:#onSubmit.
!

onSubmit:aScript
    self on:#onSubmit script:aScript.

    "Modified: / 19-07-2010 / 15:04:50 / cg"
!

target
    "Return the target of this form."

    ^ self attributeAt:#target.
!

target:aTarget
    "Set the target of this form."

    self attributeAt:#target put:aTarget.
! !

!Form methodsFor:'queries'!

canHaveChild:aChild
    aChild isFormWidgetElement ifTrue:[^ true].
    aChild isBlockElement ifTrue:[^ true].
self halt.
    ^ false.
! !

!Form methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitForm:self.

    "Modified: / 05-11-2007 / 22:07:33 / cg"
! !

!Form methodsFor:'testing'!

isBlockElement
    ^ true

    "Created: / 06-02-2007 / 17:31:05 / cg"
!

isForm
    ^ true
! !

!Form class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Form.st,v 1.21 2010/07/19 13:05:30 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Form.st,v 1.21 2010/07/19 13:05:30 cg Exp $'
! !
