"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Head
	instanceVariableNames:'title'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-TopLevel'
!

!Head class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"

  more examples to be added:
                                                                [exBegin]
    ... add code fragment for 
    ... executable example here ...
                                                                [exEnd]
"
! !

!Head class methodsFor:'required protocol'!

tagName
    ^ 'head'.
! !

!Head methodsFor:'interface-accessing-elements'!

addLinkHref:aHref rel:aRel type:aType
    "Add a link to this haed."

    |link|

    link := Link href:aHref rel:aRel type:aType.

    ^ self addElement:link.
!

addMetaHttpEquivalent:anEquivalent content:aContent
    "Add a meta to this haed."

    |meta|

    meta := Meta httpEquivalent:anEquivalent content:aContent.

    ^ self addElement:meta.
!

addMetaName:aName content:aContent
    "Add a meta to this haed."

    |meta|

    meta := Meta name:aName content:aContent.

    ^ self addElement:meta.
!

addScriptLanguage:language 
    "Add a link to this haed."

    |script|

    script := Script new language:language.

    ^ self addElement:script.
!

addScriptLanguage:language src:source type:aType
    "Add a link to this haed."

    |script|

    script := Script language:language src:source type:aType.

    ^ self addElement:script.
!

addScriptType:language code:theCode 
    "Add a link to this haed."

    |script|

    script := Script new type:language.
    script add:theCode.

    ^ self addElement:script.
!

addStyle:aStyle
    "Add a style element to this haed."

    |style|

    style := Style with:aStyle.

    ^ self addElement:style.
!

title
    "Return the title of the head."

    ^ title
!

title:aTitleOrString
    "Set a title of this head.

     A title can be a html title-object or a simple string."

    title := self buildElement:aTitleOrString ofType:HTML::Title.

    title parent:self.

    "Modified: / 05-12-2006 / 13:41:06 / cg"
! !

!Head methodsFor:'queries'!

canHaveChild:anotherElement
    "return true, if anotherElement is allowed as my child"

    anotherElement isMeta ifTrue:[^ true].
    anotherElement isTitle ifTrue:[^ true].
    (
        #(
            'base' 
            'isindex' 
            'link'
            'object' 
            'script' 
            'style')
        includes:anotherElement tagName asLowercase) ifTrue:[^ true].
self halt:'tell me more'.
    ^ false.

    "Modified: / 17-04-2007 / 14:06:58 / cg"
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:04:46 / cg"
! !

!Head methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitHead:self.

    "Modified: / 05-11-2007 / 22:07:39 / cg"
!

subelementsDo:aOneArgumentBlock
    "Execute a one argument block additionally for the title"

    title notNil ifTrue:[aOneArgumentBlock value:title].

    super subelementsDo:aOneArgumentBlock.
! !

!Head methodsFor:'testing'!

isHead
    ^ true
! !

!Head class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Head.st,v 1.26 2008/10/20 15:08:57 cg Exp $'
! !
