"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#HorizontalRule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-BlockLevel'
!

!HorizontalRule class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"
Create a horizontal rule in document:
[exBeginn]
    |document|

    document := Document new.
    document addHorizontalRule.

    document printHtmlString.
[exEnd]


Create a horizontal rule:
[exBegin]
    |rule|

    rule := HorizontalRule new.

    rule printHtmlString.
[exEnd]


Horizontal rule with some attribute settings:
[exBegin]
    |rule|

    rule := HTML::HorizontalRule new.
    rule ruleSize:5.
    rule width:120.
    rule alignRight.
    rule beNoshade.

    rule printHtmlString.
[exEnd]

"
! !

!HorizontalRule class methodsFor:'required protocol'!

tagName
    ^ 'hr'.
! !

!HorizontalRule methodsFor:'interface-attributes'!

beNoshade
    self getAttributes at:#noshade put:nil.
!

beShade
    self removeAttribute:#noshade.
!

isShade
    "Return if shade is set or not."

    ^ (self attributeAt:#noshade) notNil
!

noshade
    self beNoshade
!

ruleSize
    "Return the vertical size of the rule in pixels."

    ^ self attributeAt:#size.
!

ruleSize:aSize
    "Set the vertical size of the rule in pixels."

    self getAttributes at:#size put:aSize.
!

size:aNumber
    "Set the vertical size of the rule in pixels."

    self attributeAt:#size put:aNumber
!

width
    "Return the horizontal width."

    ^ self attributeAt:#width.
!

width:aNumberOrPercentString
    "Set the horizontal width."

    self attributeAt:#width put:aNumberOrPercentString.
! !

!HorizontalRule methodsFor:'queries'!

canHaveChild:anElement
    ^ false

    "Created: / 06-02-2007 / 17:45:22 / cg"
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 19:55:46 / cg"
!

mustBeClosed
    ^ false
! !

!HorizontalRule methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitHorizontalRule:self.

    "Modified: / 05-11-2007 / 22:07:42 / cg"
! !

!HorizontalRule methodsFor:'testing'!

isBlockElement
    ^ true

    "Created: / 06-02-2007 / 17:31:29 / cg"
!

isHorizontalRule
    ^ true
! !

!HorizontalRule class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__HorizontalRule.st,v 1.20 2007/11/05 21:11:51 cg Exp $'
! !
