"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Image
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Inline'
!

!Image class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    An html image element

    [author:]
        Martin Walser

    [instance variables:]
        -

    [class variables:]
        -

    [see also:]

"
!

examples
"
[exBegin]
    |image|
    image := Image new.
    image alternative:'eXept Software AG Logo'.
    image border:0.
    image source:'http://www.exept.de/sites/exept/images/startup.gif'.
    image printHtmlString.
[exEnd]
"
! !

!Image class methodsFor:'instance creation'!

source:aSourceString alternative:aAltString border:anInteger

    |image|
    image := Image new.
    image source:aSourceString.
    image alternative:aAltString.
    image border:anInteger.
    ^ image
! !

!Image class methodsFor:'required protocol'!

tagName
    ^ 'img'.
! !

!Image methodsFor:'interface-attributes'!

alt
    "Return the alternative for displaying this image."

    ^ self attributeAt:#alt.
!

alt:anAlternative
    "Set the alternative for displaying this image."

    self attributeAt:#alt put:anAlternative.
!

alternative
    "Return the alternative for displaying this image."

    ^ self alt.
!

alternative:anAlternative
    "Set the alternative for displaying this image."

    self alt:anAlternative.
!

source
    "Return the source of the image."

    ^ self src.
!

source:aSource
    "Set the source of the image."

    self src:aSource.
!

src
    "Return the source of the image."

    ^ self attributeAt:#src.
!

src:aSource
    "Set the source of the image."

    self attributeAt:#src put:aSource.
! !

!Image methodsFor:'queries'!

canHaveChild:anElement
    ^ false

    "Created: / 06-02-2007 / 17:45:58 / cg"
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:04:56 / cg"
!

mustBeClosed
    ^ false

    "Created: / 06-02-2007 / 20:04:56 / cg"
! !

!Image methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitImage:self.

    "Modified: / 05-11-2007 / 22:07:46 / cg"
! !

!Image methodsFor:'testing'!

isImg
    ^ true
!

isInlineElement
    ^ true

    "Created: / 06-02-2007 / 17:38:20 / cg"
! !

!Image class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Image.st,v 1.19 2007/11/05 21:11:55 cg Exp $'
! !
