"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractFormElement subclass:#Input
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Form'
!

!Input class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!Input class methodsFor:'instance creation'!

newCheckBoxNamed:aName value:aValue
    ^ self type:'checkbox' name:aName value:aValue.
!

newHiddenFieldNamed:aName value:aValue
    ^ self type:'hidden' name:aName value:aValue
!

newInputFieldNamed:aName value:aValue maxLength:maxLength size:aSize
    | instance |
    instance := self type:'text' name:aName value:aValue.
    instance maxlength:maxLength.
    instance size:aSize.
    ^ instance
!

newRadioButtonNamed:aName value:aValue
    ^ self type:'radio' name:aName value:aValue.
!

newSubmitButtonNamed:aName value:aValue
    ^ self type:'submit' name:aName value:aValue.
!

type:arg1 name:arg2 value:arg3
    ^ self new type:arg1 name:arg2 value:arg3
! !

!Input class methodsFor:'required protocol'!

tagName
    ^ 'input'.
! !

!Input methodsFor:'interface-attributes'!

accept
    "Return the accept of this input."

    ^ self attributeAt:#accept.
!

accept:anAccept
    "Set the accept of this input."

    self attributeAt:#accept put:anAccept.
!

accessKey
    "Return the access-key-attribute of this input."

    ^ self attributeAt:#accesskey.
!

accesskey:aKey
    "Set the access-key of this input."

    self attributeAt:#accesskey put:aKey.
!

alternativ:anAlternativ
    "Set the alternate text for image of this input."

    self attributeAt:#alt put:anAlternativ.
!

alternative
    "Return the alternate text for image of this input."

    ^ self attributeAt:#alt.
!

autocomplete:onOffString
    "if onOffSTring = 'off' give the browser an hint to not store input.
     NOTE: this is not W3C standard!!"

    self attributeAt:#autocomplete put:onOffString.
!

beChecked
    "Set this input to be checked."

    self getAttributes at:#checked put:#checked.
!

beEditable
    "Set this input to be editable(not readonly)."

    self removeAttribute:#readonly.
!

beEnabled
    "Set this input to be enabled."

    self removeAttribute:#disabled.
!

beReadonly
    "Set this input to be readonly."

    self getAttributes at:#readonly put:#readonly.

    "
     |input|
     input := HTML::Input new.
     input beReadonly.
     input printHtmlString.
    "
!

beUnchecked
    "Set this input to be unchecked."

    self removeAttribute:#checked.
!

checked:aBoolean
    aBoolean ifTrue:[
        self beChecked
    ] ifFalse:[
        self beUnchecked
    ].
!

isChecked
    "Return if checked is set or not."

    ^ self attributes includesKey:#checked
!

isDisabled
    "Return if disable is set or not."

    ^ self attributes includesKey:#disabled
!

isReadonly
    "Return if readonly-attribute is set or not."

    ^ (self attributeAt:#readonly) notNil
!

maxLength
    "Return the maxlength of this input."

    ^ self maxlength.
!

maxLength:aNumber
    "Set the maxlength of this input."

    self maxlength:aNumber.
!

maxlength
    "Return the maxlength of this input."

    ^ self attributeAt:#maxlength.
!

maxlength:aNumber
    "Set the maxlength of this input."

    self attributeAt:#maxlength put:aNumber.
!

onChange:aScript
    "Set the on-change-attribute of this element."

    |type|

    type := self attributes at:#type ifAbsent:nil.

    type isNil ifTrue:[
        Transcript showCR:'HTML::Input [warning] input type undefined when setting up onChange'.
        "/ self error:'define the input type before you set up the on change action' mayProceed:true.
        super onChange:aScript.

        ^ self
    ].

    type = 'checkbox' ifTrue:[
"/        self error:'onChange for select is not supported by Internet Explorer - use onClick instead' mayProceed:true.
        self breakPoint:#sr info:'onChange for select is not supported by Internet Explorer - use onClick instead'.
        self onClick:aScript.

        ^ self
    ].

    super onChange:aScript.
!

size
    "Return the size of this input."

    ^ self attributeAt:#size.
!

size:aNumber
    "Set the size of this input."

    self attributeAt:#size put:aNumber.
!

source
    "Return the source of this input."

    ^ self src.
!

source:anURI
    "Set the source of this input."

    self src:anURI.
!

src
    "Return the source of this input."

    ^ self attributeAt:#src.
!

src:anURI
    "Set the source of this input."

    self attributeAt:#src put:anURI.
!

tabindex
    "Return the tab-index-attribute of this input."

    ^ self attributeAt:#tabindex.
!

type
    "Return the type of this input."

    ^ self attributeAt:#type.
!

type:aString
    "Set the type of this input.
     text | password | checkbox | radio | submit | reset | file | hidden | image | button "

    self attributeAt:#type put:aString.
!

type:typeString name:nameString value:valueString
    self type:typeString.
    self name:nameString.
    self value:valueString.
!

usemap
    "Return the usemap of this input."

    ^ self attributeAt:#usemap.
!

usemap:usemap
    "Set the source of this input."

    self attributeAt:#usemap put:usemap.
!

value
    "Return the value of this input."

    ^ self attributeAt:#value.
!

value:aValue
    "Set the value of this input."

    self attributeAt:#value put:aValue.
! !

!Input methodsFor:'queries'!

canHaveChild:anElement
    ^ false

    "Created: / 06-02-2007 / 17:46:07 / cg"
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:05:01 / cg"
!

mustBeClosed
    ^ false
! !

!Input methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitInput:self.

    "Modified: / 05-11-2007 / 22:07:48 / cg"
! !

!Input methodsFor:'testing'!

isFormWidgetElement
    ^ true
!

isInlineElement
    ^ true

    "Created: / 06-02-2007 / 17:38:38 / cg"
!

isInput
    ^ true
! !

!Input class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Input.st,v 1.31 2011/03/23 10:24:16 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Input.st,v 1.31 2011/03/23 10:24:16 cg Exp $'
! !
