"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Link
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Head'
!

!Link class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!Link class methodsFor:'instance creation'!

href:aHref rel:aRel type:aType
    "Create a new link with the necessary attributes."

    |instance|

    instance := self rel:aRel href:aHref.
    instance type: aType.

    ^ instance.
!

rel:aRel href:aHref
    "Create a new link with the necessary attributes."

    |instance|

    instance := self new.
    instance href: aHref.
    instance rel:  aRel.

    ^ instance.
!

rel:aRel href:aHref title:aString
    "Create a new link with the necessary attributes."

    |instance|

    instance := self rel:aRel href:aHref.
    instance title: aString.

    ^ instance.
!

rel:aRel href:aHref type:aType
    "Create a new link with the necessary attributes."

    |instance|

    instance := self rel:aRel href:aHref.
    instance type: aType.

    ^ instance.
! !

!Link class methodsFor:'required protocol'!

tagName
    ^ 'link'.
! !

!Link methodsFor:'interface-attributes'!

href
    "Return the href of the link."

    ^ self attributeAt:#href.
!

href:aHref
    "Set the href of the link."

    self attributeAt:#href put:aHref.
!

media:mediaString
    self attributeAt:#media put:mediaString.
!

rel
    "Return the rel-attribute of the link.
     This is a relationship to a link."

    ^ self attributeAt:#rel.
!

rel:aRel
    "Set the rel-attribute of the link.
     This is a relationship to a link."

    self attributeAt:#rel put:aRel.
!

rev
    "Return the rev-attribute of the link.
     This is a relationship from a link."

    ^ self attributeAt:#rel.
!

rev:aRev
    "Set the rev-attribute of the link.
     This is a relationship to a link."

    self attributeAt:#rev put:aRev.
!

target
    "Return the target of the link."

    ^ self attributeAt:#target.
!

target:aTarget
    "Set the target of the link."

    self attributeAt:#target put:aTarget.
!

title
    "Return the title of the link."

    ^ self attributeAt:#title.
!

type
    "Return the type of the link."

    ^ self attributeAt:#type.
!

type:aType
    "Set the type of the link."

    self attributeAt:#type put:aType.
! !

!Link methodsFor:'queries'!

canHaveChild:anElement
    ^ false

    "Created: / 06-02-2007 / 17:47:17 / cg"
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:05:13 / cg"
!

mustBeClosed
    ^ false

    "Created: / 17-03-2007 / 16:33:49 / cg"
! !

!Link methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitLink:self.

    "Modified: / 05-11-2007 / 22:07:53 / cg"
! !

!Link methodsFor:'testing'!

isLink
    ^ true
! !

!Link class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Link.st,v 1.18 2007/11/05 21:12:03 cg Exp $'
! !
