"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Meta
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Head'
!

!Meta class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!Meta class methodsFor:'instance creation'!

httpEquivalent:anEquivalent content:aContent
    "Create a meta element from a name and a content."

    |instance|

    instance := self new.

    instance httpEquivalent: anEquivalent.
    instance content:        aContent.

    ^ instance.
!

name:aName content:aContent
    "Create a meta element from a name and a content."

    |instance|

    instance := self new.

    instance name:    aName.
    instance content: aContent.

    ^ instance.
! !

!Meta class methodsFor:'required protocol'!

tagName
    ^ 'meta'.
! !

!Meta methodsFor:'interface-attributes'!

content
    "Return the content of the meta."

    ^ self attributeAt:#content.
!

content:aContent
    "Set the content of the meta."

    self attributeAt:#content put:aContent.
!

httpEquivalent
    "Return the http-equivalent of the meta."

    ^ self attributeAt:#'http-equiv'.
!

httpEquivalent:aHttpEquivalent
    "Set the http-equivalent of the meta."

    self attributeAt:#'http-equiv' put:aHttpEquivalent.
!

scheme
    "Return the scheme of the meta."

    ^ self attributeAt:#scheme.
!

scheme:aScheme
    "Set the scheme of the meta."

    self attributeAt:#scheme put:aScheme.
! !

!Meta methodsFor:'queries'!

canHaveChild:anotherElement
    ^ false

    "Created: / 06-02-2007 / 13:52:42 / cg"
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:05:20 / cg"
!

mustBeClosed
    ^ false

    "Created: / 17-03-2007 / 16:33:16 / cg"
! !

!Meta methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitMeta:self.

    "Modified: / 05-11-2007 / 22:07:56 / cg"
! !

!Meta methodsFor:'testing'!

isMeta
    ^ true
! !

!Meta class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Meta.st,v 1.16 2008/01/17 09:52:12 cg Exp $'
! !
