"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractList subclass:#OrderedList
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Lists'
!

!OrderedList class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    HTML ordered list.

    [author:]
        Martin Walser

    [instance variables:]
        -

    [class variables:]
        -

    [see also:]
        ListItem
        UnorderedList
"
!

examples
"
An ordered list:
[exBegin]
    |list|
    list := OrderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list printHtmlString
[exEnd]


With decimal enumeration:
[exBegin]
    |list|
    list := OrderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list enumerateDecimal.
    list printHtmlString
[exEnd]


With lowercase roman enumeration:
[exBegin]
    |list|
    list := OrderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list enumerateLowercaseRoman.
    list printHtmlString
[exEnd]


With uppercase roman enumeration:
[exBegin]
    |list|
    list := OrderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list enumerateUppercaseRoman.
    list printHtmlString
[exEnd]


With lowercase alphabetical enumeration:
[exBegin]
    |list|
    list := OrderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list enumerateLowercaseAlphabetic.
    list printHtmlString
[exEnd]


With uppercase alphabetical enumeration:
[exBegin]
    |list|
    list := OrderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list enumerateUppercaseAlphabetic.
    list printHtmlString
[exEnd]
"
! !

!OrderedList class methodsFor:'required protocol'!

tagName
    ^ 'ol'
! !

!OrderedList methodsFor:'interface-accessing-attributes'!

enumerateDecimal
    "Set to use decimal enumeration."

    self type:1.
!

enumerateLowercaseAlphabetic
    "Set to use decimal enumeration."

    self type:#a.
!

enumerateLowercaseRoman
    "Set to use decimal enumeration."

    self type:#i.
!

enumerateUppercaseAlphabetic
    "Set to use decimal enumeration."

    self type:#A.
!

enumerateUppercaseRoman
    "Set to use decimal enumeration."

    self type:#I.
!

type
    "Return a type for the numbering of the list.
     Possible types are #1, #i, #I, #a, #A"

    ^ self attributeAt:#type.
!

type:aType
    "Set a type for the numbering of the list.
     Possible types are #1, #i, #I, #a, #A"

    |type|

    type := aType isString 
                ifTrue: [type]
                ifFalse:[type printString].

    self attributeAt:#type put:aType.
! !

!OrderedList methodsFor:'queries'!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:05:25 / cg"
! !

!OrderedList methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitOrderedList:self.

    "Modified: / 05-11-2007 / 22:08:04 / cg"
! !

!OrderedList methodsFor:'testing'!

isBlockElement
    ^ true

    "Created: / 06-02-2007 / 17:32:01 / cg"
!

isOrderedList
    ^ true
! !

!OrderedList class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__OrderedList.st,v 1.17 2008/10/18 17:05:42 cg Exp $'
! !
