"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Pre
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-BlockLevel'
!

!Pre class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"
Create preformat in document:
[exBeginn]
    |document|
    document := Document new.
    document addElement: (Pre with: 'This
is a
Test').
    document printHtmlString.
[exEnd]

[exBeginn]
    |document|
    document := Document new.
    document addElement: (Pre with: '/tmp/foo' asFilename contents asString).
    document printHtmlString.
[exEnd]


"
! !

!Pre class methodsFor:'required protocol'!

tagName
    ^ 'pre'.
! !

!Pre methodsFor:'queries'!

canHaveChild:anElement
    ^
        #(
            'a'
            'abbr'
            'acronym'
            'applet'
            'b'
            'bdo'
            'br'
            'button'
            'cite'
            'code'
            'dfn'
            'em'
            'i'
            'input'
            'iframe'
            'kbd'
            'label'
            'map'
            'q'
            'samp'
            'script'
            'select'
            'span'
            'strong'
            'textarea'
            'tt'
            'var')
        includes:anElement tagName asLowercase
! !

!Pre methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitPre:self.

    "Modified: / 05-11-2007 / 22:08:07 / cg"
! !

!Pre methodsFor:'testing'!

canBeReformatted
   "answer true, if the text may be reformatted by the browser,
    and added white space does not matter.
    Pre will not be reformatted."

   ^ false     
!

isBlockElement
    ^ true

    "Created: / 06-02-2007 / 17:32:07 / cg"
!

isPre
    ^ true
! !

!Pre class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Pre.st,v 1.9 2009/11/30 10:46:32 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Pre.st,v 1.9 2009/11/30 10:46:32 stefan Exp $'
! !
