"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#Script
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Head'
!

!Script class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!Script class methodsFor:'instance creation'!

language:language src:src type:type 
    "Create a new link with the necessary attributes."

    |instance|

    instance := self new.
    instance language: language.
    instance src:  src.
    instance type: type.

    ^ instance.
! !

!Script class methodsFor:'required protocol'!

tagName
    ^ 'script'.
! !

!Script methodsFor:'accessing'!

script:aScriptText
    self addChild:aScriptText.
!

scriptText:aScriptText
    self addChild:aScriptText.
! !

!Script methodsFor:'interface-attributes'!

language
    "Return the href of the script."

    ^ self attributeAt:#language.
!

language:language
    "Set the language of the Script."

    self attributeAt:#language put:language.
!

src
    "Return the src of the script."

    ^ self attributeAt:#src.
!

src:aSource
    "Set the src of the script."

    aSource notNil ifTrue:[
        self attributeAt:#src put:aSource.
    ].
!

type
    "Return the type of the script."

    ^ self attributeAt:#type.
!

type:aType
    "Set the type of the script."

    self attributeAt:#type put:aType.
! !

!Script methodsFor:'queries'!

canHaveChild:anElement
    ^ false

    "Created: / 06-02-2007 / 17:49:31 / cg"
! !

!Script methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitScript:self.

    "Modified: / 05-11-2007 / 22:08:10 / cg"
! !

!Script methodsFor:'testing'!

isInlineElement
    ^ true

    "Created: / 06-02-2007 / 17:39:19 / cg"
!

isScript
    ^ true

    "Created: / 06-02-2007 / 19:00:46 / cg"
! !

!Script class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Script.st,v 1.10 2009/03/23 17:18:21 cg Exp $'
! !
