"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractFormElement subclass:#Select
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Form'
!

!Select class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!Select class methodsFor:'instance creation'!

newSelectWithName:aName options:aCollectionOfStrings values:aCollectionOfValues selectedIndex:selectedIndex
    |inst option|

    inst := self new.
    inst name:aName.    
    aCollectionOfStrings doWithIndex:[:aString :optionIndex|
        option := HTML::Option new.
        option addChild:aString printString.
        aCollectionOfValues notNil ifTrue:[
            option value:(aCollectionOfValues at:optionIndex ifAbsent:nil).
        ].
        optionIndex = selectedIndex ifTrue:[
            option beSelected.
        ].
        inst addChild:option
    ].
    ^ inst

"
    self newSelectWithName:'Example' options:#(one two three four five) values:#(1 2 3 nil 5) selectedIndex:3  
"
! !

!Select class methodsFor:'required protocol'!

tagName
    ^ 'select'.
! !

!Select methodsFor:'interface-attributes'!

beMultiple
    "Set this select to be multiple."

    self getAttributes at:#multiple put:#multiple.

    "
     |select|
     select := HTML::Select new.
     select beMultiple.
     select printHtmlString.
    "
!

beNotMultiple
    "Set this select to be multiple."

    self removeAttribute:#multiple.
!

isMultiple
    "Return if multiple is set or not."

    ^ (self attributeAt:#multiple) notNil
!

multiple:aBoolean
    aBoolean == true ifTrue:[
        self beMultiple.
        ^ self
    ].
    self beNotMultiple.
!

size
    "Return the size of this select."

    ^ self attributeAt:#size.
!

size:aNumber
    "Set the size of this select."

    self attributeAt:#size put:aNumber.
!

tabindex
    "Return the tab-index-attribute of this select."

    ^ self attributeAt:#tabindex.
! !

!Select methodsFor:'queries'!

canHaveChild:anElement
    (anElement tagName sameAs:'option') ifTrue:[^ true]. 
    ^ false

    "Created: / 18-03-2011 / 17:49:51 / az"
! !

!Select methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitSelect:self.

    "Modified: / 05-11-2007 / 22:08:12 / cg"
! !

!Select methodsFor:'testing'!

isInlineElement
    ^ true

    "Created: / 06-02-2007 / 17:39:41 / cg"
!

isSelect
    ^ true
! !

!Select class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Select.st,v 1.16 2011/03/18 16:51:08 az Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Select.st,v 1.16 2011/03/18 16:51:08 az Exp $'
! !
