"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

Object subclass:#StyleVisitor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-Utilities'
!

!StyleVisitor class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!StyleVisitor methodsFor:'interface-visiting-Box'!

visitBorder:aBorder
    "A border gets visited."

    self visitStyleProperty:aBorder.
!

visitBorderColor:aBorderColor
    "A border-color gets visited."

    self visitStyleProperty:aBorderColor.
!

visitBorderStyle:aBorderStyle
    "A border-style gets visited."

    self visitStyleProperty:aBorderStyle.
!

visitBorderWidth:aBorderWidth
    "A border-width gets visited."

    self visitStyleProperty:aBorderWidth.
!

visitBottomBorder:aBottomBorder
    "A bottom-border gets visited."

    self visitStyleProperty:aBottomBorder.
!

visitBottomBorderWidth:aBottomBorderWidth
    "A bottom-border-width gets visited."

    self visitStyleProperty:aBottomBorderWidth.
!

visitBottomMargin:aBottomMargin
    "A bottom-margin gets visited."

    self visitStyleProperty:aBottomMargin.
!

visitBottomPadding:aBottomPadding
    "A bottom-padding gets visited."

    self visitStyleProperty:aBottomPadding.
!

visitClear:aClear
    "A clear gets visited."

    self visitStyleProperty:aClear.
!

visitFLoat:aFLoat
    "A float gets visited."

    self visitStyleProperty:aFLoat.
!

visitFloat:aFloat
    "A float gets visited."

    self visitStyleProperty:aFloat.
!

visitHeight:aHeight
    "A height gets visited."

    self visitStyleProperty:aHeight.
!

visitLeftBorder:aLeftBorder
    "A left-border gets visited."

    self visitStyleProperty:aLeftBorder.
!

visitLeftBorderWidth:aLeftBorderWidth
    "A left-border-width gets visited."

    self visitStyleProperty:aLeftBorderWidth.
!

visitLeftMargin:aLeftMargin
    "A left-margin gets visited."

    self visitStyleProperty:aLeftMargin.
!

visitLeftPadding:aLeftPadding
    "A left-padding gets visited."

    self visitStyleProperty:aLeftPadding.
!

visitMargin:aMargin
    "A margin gets visited."

    self visitStyleProperty:aMargin.
!

visitPadding:aPadding
    "A padding gets visited."

    self visitStyleProperty:aPadding.
!

visitRightBorder:aRightBorder
    "A right-border gets visited."

    self visitStyleProperty:aRightBorder.
!

visitRightBorderWidth:aRightBorderWidth
    "A right-border-width gets visited."

    self visitStyleProperty:aRightBorderWidth.
!

visitRightMargin:aRightMargin
    "A right-margin gets visited."

    self visitStyleProperty:aRightMargin.
!

visitRightPadding:aRightPadding
    "A right-padding gets visited."

    self visitStyleProperty:aRightPadding.
!

visitTopBorder:aTopBorder
    "A top-border gets visited."

    self visitStyleProperty:aTopBorder.
!

visitTopBorderWidth:aTopBorderWidth
    "A top-border-width gets visited."

    self visitStyleProperty:aTopBorderWidth.
!

visitTopMargin:aTopMargin
    "A top-margin gets visited."

    self visitStyleProperty:aTopMargin.
!

visitTopPadding:aTopPadding
    "A top-padding gets visited."

    self visitStyleProperty:aTopPadding.
!

visitWidth:aWidth
    "A width gets visited."

    self visitStyleProperty:aWidth.
! !

!StyleVisitor methodsFor:'interface-visiting-Color and Background'!

visitBackground:background
    "A background gets visited."

    background value isNil ifTrue:[
        | url repeat |
        (url := background url) notNil ifTrue:[
            background value:'url(', url,')'.
        ].
        (repeat := background repeat) notNil ifTrue:[
            background value:( background value, ' ', repeat).
        ].
    ].
    self visitStyleProperty:background.
!

visitBackgroundAttachment:aColor
    "A background-attachment gets visited."

    self visitStyleProperty:aColor.
!

visitBackgroundColor:aColor
    "A background-color gets visited."

    self visitStyleProperty:aColor.
!

visitBackgroundImage:aBackgroundImage
    "A background-image gets visited."

    self visitStyleProperty:aBackgroundImage.
!

visitBackgroundPosition:aColor
    "A background-position gets visited."

    self visitStyleProperty:aColor.
!

visitBackgroundRepeat:aColor
    "A background-repeat gets visited."

    self visitStyleProperty:aColor.
!

visitColor:aColor
    "A color gets visited."

    self visitStyleProperty:aColor.
!

visitDisplay:display
    "A display gets visited."

    self visitStyleProperty:display.
! !

!StyleVisitor methodsFor:'interface-visiting-Font'!

visitFont:aFont
    "A font gets visited."

    self visitStyleProperty:aFont.
!

visitFontFamily:aFontFamily
    "A font-family gets visited."

    self visitStyleProperty:aFontFamily.
!

visitFontSize:aFontSize
    "A font-size gets visited."

    self visitStyleProperty:aFontSize.
!

visitFontStyle:aFontStyle
    "A font-style gets visited."

    self visitStyleProperty:aFontStyle.
!

visitFontVariant:aFontVariant
    "A font-variant gets visited."

    self visitStyleProperty:aFontVariant.
!

visitFontWeight:aFontWEight
    "A font-weight gets visited."

    self visitStyleProperty:aFontWEight.
! !

!StyleVisitor methodsFor:'interface-visiting-Text'!

visitLetterSpacing:aLetterSpacing
    "A letter-spacing gets visited."

    self visitStyleProperty:aLetterSpacing.
!

visitLineHeight:aLineHeight
    "A line-height gets visited."

    self visitStyleProperty:aLineHeight.
!

visitMinHeight:aMinHeight
    self visitStyleProperty:aMinHeight.
!

visitTextAlignment:aTextAlignment
    "A text-alignement gets visited."

    self visitStyleProperty:aTextAlignment.
!

visitTextDecoration:aTextDecoration
    "A text-decoration gets visited."

    self visitStyleProperty:aTextDecoration.
!

visitTextIndentation:aTextIndentation
    "A text-indentation gets visited."

    self visitStyleProperty:aTextIndentation.
!

visitTextTransformation:aTextTransformation
    "A text-transformation gets visited."

    self visitStyleProperty:aTextTransformation.
!

visitVerticalAlignment:aVerticalAlignment
    "A vertical-alignment gets visited."

    self visitStyleProperty:aVerticalAlignment.
!

visitWordSpacing:aWordSpacing
    "A word-spacing gets visited."

    self visitStyleProperty:aWordSpacing.
! !

!StyleVisitor methodsFor:'interface-visiting-positioning'!

visitBottom:aBottom
    "A bottom gets visited."

    self visitStyleProperty:aBottom.
!

visitLeft:aLeft
    "A left gets visited."

    self visitStyleProperty:aLeft.
!

visitPosition:aPosition
    "A position gets visited."

    self visitStyleProperty:aPosition.
!

visitRight:aRight
    "A right gets visited."

    self visitStyleProperty:aRight.
!

visitTop:aTop
    "A top gets visited."

    self visitStyleProperty:aTop.
! !

!StyleVisitor methodsFor:'required-visiting'!

visitString:aString 
    "Default method for all html text pieces.
     To be defined in subclasses."

    ^ self subclassResponsibility
!

visitStyleElement:aStyleElement
    "A style element gets visited"

    self subclassResponsibility.
!

visitStyleProperty:aProperty
    "A style element gets visited"

    self subclassResponsibility.
! !

!StyleVisitor methodsFor:'visiting'!

visit:anObject
    "Visit an object."

    anObject isNil ifTrue:[^ self].

    anObject isString ifTrue:[
        ^ self visitString:anObject
    ].

    anObject acceptHTMLVisitor:self.
! !

!StyleVisitor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__StyleVisitor.st,v 1.18 2007/03/26 14:17:57 cg Exp $'
! !
