"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractHTMLElement subclass:#TableBody
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Table'
!

!TableBody class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!TableBody class methodsFor:'required protocol'!

tagName
    ^ 'tbody'.
! !

!TableBody methodsFor:'interface-accessing-elements'!

addRow
    "Add an empty table row to the children of this table body.
     The passed table row can be a ready built table row,
     a simple string to be wrapped in a row, or a collection 
     of data cells. These data cells can be either ready built
     data cells or simple strings too."

    |row|

    row := self buildRow: nil. 

    ^ self addChild:row.
!

addRow:aRowOrString
    "Add a table row to the children of this table body.
     The passed table row can be a ready built table row,
     a simple string to be wrapped in a row, or a collection 
     of data cells. These data cells can be either ready built
     data cells or simple strings too."

    |row|

    row := self buildRow: aRowOrString. 

    ^ self addChild:row.
!

rowAt:anIndex
    "Return the row at an index or nil."

    ^ self childAt:anIndex ifAbsent:nil.
!

rowAt:aRowIndex cellAt:aCellIndex
    "Put a cell at the given indices."

    |row|

    row := self rowAt:aRowIndex.
    row isNil ifTrue:[^ nil].

    ^ row cellAt:aCellIndex.
!

rowAt:aRowIndex cellAt:aCellIndex put:aCellOrString
    "Put a cell at the given indices."

    |row|

    row := self getRowAt:aRowIndex.

    row cellAt:aCellIndex
        put:   aCellOrString.
!

rowAt:anIndex put:aRowOrString
    "Return the row at an index or nil."

    |row|

    row := self buildRow: aRowOrString. 

    children size < anIndex ifFalse:[
        self childAt:anIndex put:row.
        ^ self.
    ].

    "Grow the row up to the given index if necessary."
    (anIndex - children size - 1) timesRepeat:[
        self addRow.
    ].
    self addChild:row.
!

rowsDo:aBlock
    children isNil ifTrue:[
        ^ self
    ].
    children do:aBlock
! !

!TableBody methodsFor:'private-accessing'!

getRowAt:aRowIndex
    "Return a row at the given index.
     If not exists build one."

    ^ self childAt:aRowIndex 
           ifAbsent:[self addElement:TableRow at:aRowIndex].
! !

!TableBody methodsFor:'private-building'!

buildRow:aTableRow 
    "Build and return a table row.
     The passed table row can be a ready built table row,
     a simple string to be wrapped in a row, or a collection 
     of data cells. These data cells can be either ready built
     data cells or simple strings too."
    
    ^ self 
        buildElement:aTableRow
        ofType:TableRow
        onCollectionDo:[:row :rawData | row addCell:rawData ].
! !

!TableBody methodsFor:'queries'!

canHaveChild:anElement
    anElement isTableRow ifTrue:[^ true].
    ^ false

    "Created: / 06-02-2007 / 20:06:00 / cg"
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:05:49 / cg"
! !

!TableBody methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitTableBody:self.

    "Modified: / 05-11-2007 / 22:08:27 / cg"
! !

!TableBody methodsFor:'testing'!

isTableBody
    ^ true
! !

!TableBody class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__TableBody.st,v 1.22 2007/11/05 21:12:39 cg Exp $'
! !
