"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractTableRow subclass:#TableHead
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Table'
!

!TableHead class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!TableHead class methodsFor:'required protocol'!

cellClass
    "Return the cell class for the row element."

    ^ TableHeaderCell.
!

tagName
    ^ 'thead'.
! !

!TableHead methodsFor:'interface-accessing-elements'!

addRow
    "Add an empty table row to the children of this table body.
     The passed table row can be a ready built table row,
     a simple string to be wrapped in a row, or a collection 
     of data cells. These data cells can be either ready built
     data cells or simple strings too."

    |row|

    row := self buildRow: nil. 

    ^ self addChild:row.
!

addRow:aRowOrString
    "Add a table row to the children of this table body.
     The passed table row can be a ready built table row,
     a simple string to be wrapped in a row, or a collection 
     of data cells. These data cells can be either ready built
     data cells or simple strings too."

    |row|

    row := self buildRow: aRowOrString. 
    ^ self addChild:row.
! !

!TableHead methodsFor:'private-building'!

buildRow:aTableRow 
    "Build and return a table row.
     The passed table row can be a ready built table row,
     a simple string to be wrapped in a row, or a collection 
     of data cells. These data cells can be either ready built
     data cells or simple strings too."
    
    ^ self 
        buildElement:aTableRow
        ofType:TableRow
        onCollectionDo:[:row :rawData | row addCell:rawData ].
! !

!TableHead methodsFor:'queries'!

canHaveChild:anElement
    anElement isTableRow ifTrue:[^ true].
    ^ false

    "Created: / 06-02-2007 / 20:06:00 / cg"
!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:06:00 / cg"
! !

!TableHead methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitTableHead:self.

    "Modified: / 05-11-2007 / 22:08:34 / cg"
! !

!TableHead methodsFor:'testing'!

isTableHead
    ^ true
! !

!TableHead class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__TableHead.st,v 1.16 2007/11/05 21:12:44 cg Exp $'
! !
