"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractFormElement subclass:#TextArea
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Form'
!

!TextArea class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!TextArea class methodsFor:'processing'!

name:aName cols:cols rows:rows content:aContent
    | instance |
    instance := self basicNew.
    instance name:aName.
    instance cols:cols.
    instance rows:rows.
    instance add:aContent.
    ^ instance
! !

!TextArea class methodsFor:'required protocol'!

tagName
    ^ 'textarea'.
! !

!TextArea methodsFor:'interface-attributes'!

accessKey
    "Return the access-key-attribute of this textarea."

    ^ self attributeAt:#accesskey.
!

accesskey:aKey
    "Set the access-key of this textarea."

    self attributeAt:#accesskey put:aKey.
!

beEditable
    "Set this textarea to be editable(not readonly)."

    self removeAttribute:#readonly.
!

beReadonly
    "Set this textarea to be readonly."

    self getAttributes at:#readonly put:#readonly.

    "
     |textarea|
     textarea := HTML::Textarea new.
     textarea beReadonly.
     textarea printHtmlString.
    "
!

cols
    "Get the cols attribute of this textarea."

    self attributeAt:#cols
!

cols:aNumber
    "Set the cols attribute of this textarea."

    self attributeAt:#cols put:aNumber.
!

isReadonly
    "Return if readonly-attribute is set or not."

    ^ (self attributeAt:#readonly) notNil
!

rows
    "get the rows attribute of this textarea."

    self attributeAt:#rows
!

rows:aNumber
    "Set the rows attribute of this textarea."

    self attributeAt:#rows put:aNumber.
!

tabindex
    "Return the tab-index-attribute of this textarea."

    ^ self attributeAt:#tabindex.
! !

!TextArea methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitTextArea:self.

    "Modified: / 05-11-2007 / 22:08:40 / cg"
! !

!TextArea methodsFor:'testing'!

isInlineElement
    ^ true

    "Created: / 06-02-2007 / 17:40:15 / cg"
!

isTextArea
    ^ true
! !

!TextArea class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__TextArea.st,v 1.17 2008/11/01 18:33:20 stefan Exp $'
! !
