"
 COPYRIGHT (c) 2007 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

Visitor subclass:#TextExtractor
	instanceVariableNames:'text'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-Utilities'
!

!TextExtractor class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2007 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    a tool to extract the raw text of some html 
    (either a constructed tree, or from a parser)
    can be used to extract strings for searching, or for
    conversion to raw-ascii, for example.

    CAVEAT:
        I am not sure if this implementation is generic enough for
        other uses in its current state 
        (maybe we have to look for specialities like PRE.../PRE or     
        text within form-elements to make this really correct)

    [author:]
        Claus Gittinger
"
!

examples
"
                                                                                [exBegin]
     |b document x|

     b := HTML::TreeBuilder new beginWith:(document := Document new).
     b 
        head;
        headEnd;
        body;
          table;
            tr;
              td; text:'aaa'; tdEnd;
              td; text:'bbb'; tdEnd;
            trEnd;
          tableEnd;
        bodyEnd.

     document htmlString inspect.
     x := HTML::TextExtractor new.
     x visit:document.
     x text inspect.
                                                                                [exEnd]


                                                                                [exBegin]
     |document|

     document := HTML::HTMLParser parseText:'<h1>Hello <b>World</b></h1>'.
     (HTML::TextExtractor extractTextFromDocument:document) inspect.
                                                                                [exEnd]
    
                                                                                [exBegin]
     (HTML::TextExtractor extractTextFromHtmlString:'<h1>Hello <b>World</b></h1>') inspect.
                                                                                [exEnd]
"
! !

!TextExtractor class methodsFor:'extraction'!

extractTextFromDocument:domTree
    ^ (self new visit:domTree) text

    "Created: / 26-04-2010 / 13:28:29 / sr"
!

extractTextFromHtmlString:htmlString
    ^ self extractTextFromDocument:(HTMLParser parseText:htmlString)

    "Created: / 26-04-2010 / 13:29:22 / sr"
! !

!TextExtractor methodsFor:'accessing'!

text
    ^ text
! !

!TextExtractor methodsFor:'ignored visiting'!

visitElement:anElement 
    "Default method for all html elements."

    self visitSubelementsOf:anElement
!

visitString:aString
    |s|

    s := aString withoutSeparators.
    text isEmptyOrNil ifTrue:[
        text := s
    ] ifFalse:[
        s isEmpty ifFalse:[
            text := text , ' ', s
        ]
    ].
! !

!TextExtractor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__TextExtractor.st,v 1.2 2010/04/26 11:28:47 sr Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__TextExtractor.st,v 1.2 2010/04/26 11:28:47 sr Exp $'
! !
