"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

AbstractList subclass:#UnorderedList
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-ModelTree-Lists'
!

!UnorderedList class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    HTML unnumbered list (bullet-list).

    [author:]
        Martin Walser

    [instance variables:]
        -

    [class variables:]
        -

    [see also:]
        ListItem
        OrderedList
"
!

examples
"
[exBegin]
    |list|
    list := UnorderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list useDiscBullets.
    list printHtmlString.
[exEnd]


[exBegin]
    |list|
    list := UnorderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list useSquareBullets.
    list printHtmlString.
[exEnd]


[exBegin]
    |list|
    list := UnorderedList new.
    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.
    list useCircleBullets.
    list printHtmlString.
[exEnd]
"
! !

!UnorderedList class methodsFor:'required protocol'!

tagName
    ^ 'ul'
! !

!UnorderedList methodsFor:'adding'!

addListItemWith:aOneArgBlock

    ^ ListItem withNew:[: item |
        self add:item.
        aOneArgBlock value:item
    ].
!

addListItemWithId:anId class:aClass with:aOneArgBlock

    ^ ListItem withNew:[: item |
        self add:item.
        anId notNil ifTrue:[
            item id:anId.
        ].
        aClass notNil ifTrue:[
            item class:aClass.
        ].
        aOneArgBlock value:item
    ].
! !

!UnorderedList methodsFor:'interface-accessing-attributes'!

type
    "Return a type for the numbering of the list.
     Possible types are #disc, #square, #circle"

    ^ self attributeAt:#type.
!

type:aType
    "Set a type for the numbering of the list.
     Possible types are #disc, #square, #circle"

    |type|

    type := aType isString 
                ifTrue: [type]
                ifFalse:[type printString].

    self attributeAt:#type put:aType.
!

useCircleBullets
    "Set to use circle-bullets."

    self type:#circle.
!

useDiscBullets
    "Set to use disc-bullets."

    self type:#disc.
!

useSquareBullets
    "Set to use square-bullets."

    self type:#square.
! !

!UnorderedList methodsFor:'queries'!

canHaveText
    ^ false

    "Created: / 06-02-2007 / 20:06:22 / cg"
! !

!UnorderedList methodsFor:'required-visiting'!

acceptHTMLVisitor:aVisitor
    "visitor pattern: dispatch me to the visitor"

    aVisitor visitUnorderedList:self.

    "Modified: / 05-11-2007 / 22:08:45 / cg"
! !

!UnorderedList methodsFor:'testing'!

isBlockElement
    ^ true

    "Created: / 06-02-2007 / 17:32:33 / cg"
!

isUnorderedList
    ^true
! !

!UnorderedList class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__UnorderedList.st,v 1.21 2009/04/22 16:12:33 fm Exp $'
! !
