"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree' }"

"{ NameSpace: HTML }"

Object subclass:#Visitor
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-Utilities'
!

!Visitor class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

examples
"
  ElementTypes := nil.
  HTMLParser initializeElementTypes
                                                                        [exBegin]
    |p in document visitorClass visitor|

    p := HTML::HTMLParser new. 
    in := '../../../exept/expecco/projects/not_delivered/buggyWebShopDemo/selenium_tests/buggyWebshop_bestellung'
                 asFilename readStream.
    document := p parseText:in.
    in close.

    Smalltalk withoutUpdatingChangesDo:[
        visitorClass := HTML::Visitor 
                                subclass:#TestVisitor
                                instanceVariableNames:''
                                classVariableNames:''
                                poolDictionaries:''
                                category:''.

        visitorClass compile:'visitElement:anElement self visitSubelementsOf:anElement'.
        visitorClass compile:'visitString:aString'.
        visitorClass compile:'visitTableRow:aTR 
    aTR children size > 1 ifTrue:[
        |cmdTD argTDs cmd args|

        cmdTD := aTR children first.
        argTDs := aTR children copyFrom:2.

        cmd := cmdTD children first.
        args := argTDs collect:[:td | td children firstIfEmpty:nil].
        args := args copyTo:(args findLast:[:arg | arg notNil]).
        Transcript show:cmd; show:'' ''; showCR:args.
    ]
'.
    ].
    visitor := visitorClass new.
    visitor visit:document.
                                                                        [exEnd]
"
! !

!Visitor methodsFor:'interface-visiting-BlockLevel'!

visitAddress:anAddress
    "An address gets visited."

    self visitElement:anAddress
!

visitArea:anArea
    self visitElement:anArea
!

visitBlockQuote:aBlockQuote
    "A blockQuote gets visited."

    self visitElement:aBlockQuote.

    "Created: / 06-02-2007 / 17:02:59 / cg"
!

visitCenter:aParagraph
    "A 'center' gets visited."

    self visitElement:aParagraph.
!

visitDiv:aDiv
    "A div gets visited."

    self visitElement:aDiv.
!

visitEmbed:anEmbeddedDocument
    self visitElement:anEmbeddedDocument
!

visitHeading1:aHeading1
    "A heading level one gets visited."

    self visitElement:aHeading1.
!

visitHeading2:aHeading2
    "A heading level two gets visited."

    self visitElement:aHeading2.
!

visitHeading3:aHeading3
    "A heading level three gets visited."

    self visitElement:aHeading3.
!

visitHeading4:aHeading4
    "A heading level four gets visited."

    self visitElement:aHeading4.
!

visitHeading5:aHeading5
    "A heading level five gets visited."

    self visitElement:aHeading5.
!

visitHeading6:aHeading6
    "A heading level six gets visited."

    self visitElement:aHeading6.
!

visitHeading:aHeading
    "A heading gets visited."

    self visitElement:aHeading.
!

visitHorizontalRule:aHorizontalRule 
    "A horizontal rule gets visited."

    self visitElement:aHorizontalRule.
!

visitParagraph:aParagraph
    "A paragraph gets visited."

    self visitElement:aParagraph.
!

visitPre:aPre
    "A pre gets visited."

    self visitElement:aPre.
! !

!Visitor methodsFor:'interface-visiting-FontStyle'!

visitBig:aBig
    "A 'big' gets visited."

    self visitStyleElement:aBig.
!

visitBold:aBold
    "A 'bold' gets visited."

    self visitStyleElement:aBold.
!

visitItalic:anItalic
    "An italic gets visited."

    self visitStyleElement:anItalic.
!

visitSmall:aSmall
    "A 'small' gets visited."

    self visitStyleElement:aSmall.
!

visitStrong:anElement
    self visitStyleElement:anElement.
!

visitStyleElement:anElement
    self visitElement:anElement.
!

visitUnderlined:aSmall
    "An underlined gets visited."

    self visitStyleElement:aSmall.
! !

!Visitor methodsFor:'interface-visiting-Form'!

visitButton:aButton
    "A button gets visited."

    self visitFormElement:aButton
!

visitForm:aForm
    "A form gets visited."

    self visitElement:aForm
!

visitFormElement:anElement
    self visitElement:anElement
!

visitInput:anInput
    "An input gets visited."

    self visitFormElement:anInput
!

visitLabel:anInput
    "A label gets visited."

    self visitFormElement:anInput
!

visitOption:anOption
    "An option gets visited."

    self visitElement:anOption
!

visitSelect:anSelect
    "A select gets visited."

    self visitFormElement:anSelect
!

visitTextArea:anInput
    "A textarea gets visited."

    self visitFormElement:anInput
! !

!Visitor methodsFor:'interface-visiting-Frame'!

visitFrame:aFrame
    "A frame gets visited."

    self visitElement:aFrame
!

visitFrameset:aFrameset
    "A frameset gets visited."

    self visitElement:aFrameset
!

visitIFrame:anIFrame
    self visitElement:anIFrame.
!

visitNoFrames:aNoFramesElement
    "A noframes element gets visited."

    self visitElement:aNoFramesElement
!

visitNoScript:aNoScriptElement
    self visitElement:aNoScriptElement
! !

!Visitor methodsFor:'interface-visiting-Head'!

visitBase:aBase
    self visitElement:aBase.
!

visitLink:aLink
    "A link gets visited."

    self visitElement:aLink.
!

visitMeta:aMeta
    "A meta element gets visited."

    self visitElement:aMeta.
!

visitScript:aScript
    "A script gets visited."

    self visitElement:aScript.
!

visitStyle:aStyle
    "A style element gets visited."

    self visitElement:aStyle.
!

visitTitle:aTitle
    "A title gets visited."

    self visitElement:aTitle.
! !

!Visitor methodsFor:'interface-visiting-Inline'!

visitAnchor:anAnchor
    "An anchor gets visited."

    self visitElement:anAnchor.
!

visitBreak:aLineBreak
    "A line break gets visited."

    self visitElement:aLineBreak.
!

visitCode:anImage
    "A code gets visited."

    self visitElement:anImage.
!

visitImage:anImage
    "An image gets visited."

    self visitElement:anImage.
!

visitNoBr:anImage
    "A noBr gets visited."

    self visitElement:anImage.

    "Created: / 29-11-2011 / 12:18:34 / sr"
!

visitSpan:anImage
    "A span gets visited."

    self visitElement:anImage.
! !

!Visitor methodsFor:'interface-visiting-List'!

visitComment:anItem
    "A comment gets visited."

    self visitElement:anItem.

    "Created: / 17-04-2007 / 13:36:42 / cg"
!

visitListItem:aListItem
    "A list item gets visited."

    self visitElement:aListItem.
!

visitOrderedList:anOrderedList
    "An ordered list gets visited."

    self visitElement:anOrderedList.
!

visitProcessingInstruction:anItem
    "A processing instruction gets visited."

    self visitElement:anItem.

    "Created: / 17-04-2007 / 13:39:58 / cg"
!

visitUnorderedList:anUnorderedList
    "An unordered list gets visited."

    self visitElement:anUnorderedList.
! !

!Visitor methodsFor:'interface-visiting-ListDefinition'!

visitDefinitionDescription:aDefinitionDescription
    "A definition description gets visited."

    self visitElement:aDefinitionDescription.
!

visitDefinitionList:aList
    "A definition list gets visited."

    self visitElement:aList.
!

visitDefinitionTerm:aTerm
    "A definition term gets visited."

    self visitElement:aTerm.
! !

!Visitor methodsFor:'interface-visiting-Special'!

visitDocumentType:aDocumentType
    "A document type gets visited.
     The document type is no real html element.
     It only holds the version string.
     Do nothing here."
! !

!Visitor methodsFor:'interface-visiting-Table'!

visitCaption:aCaption
    "A table caption gets visited."

    self visitElement:aCaption.
!

visitCol:aCol
    "A col gets visited."

    self visitElement:aCol.
!

visitColgroup:aColgroup
    "A colgroup gets visited."

    self visitElement:aColgroup.
!

visitTable:aTable 
    "A table gets visited."

    self visitElement:aTable.
!

visitTableBody:aTableBody
    "A table body gets visited."

    self visitElement:aTableBody.
!

visitTableDataCell:aTableDataCell 
    "A table data cell gets visited."

    self visitElement:aTableDataCell.
!

visitTableFoot:aTableFoot
    "A table foot gets visited."

    self visitElement:aTableFoot.
!

visitTableHead:aTableHead
    "A table head gets visited."

    self visitElement:aTableHead.
!

visitTableHeaderCell:aTableHeaderCell 
    "A table header cell gets visited."

    self visitElement:aTableHeaderCell.
!

visitTableRow:aTableRow 
    "A table row gets visited."

    self visitElement:aTableRow.
! !

!Visitor methodsFor:'interface-visiting-TopLevel'!

visitBody:aBody
    "A body gets visited."

    self visitElement:aBody.
!

visitDocument:aDocument
    "A document gets visited."

    self visitElement:aDocument.
!

visitDummyContainer:aContainer
    "The container has no tag; however, its children are treated as usual"

    self visitElement:aContainer.

    "Modified: / 03-07-2009 / 15:07:54 / sr"
!

visitHead:aHead
    "A head gets visited."

    self visitElement:aHead.
! !

!Visitor methodsFor:'required-visiting'!

visitElement:anElement 
    "Default method for all html elements.
     To be defined in subclasses."

    ^ self subclassResponsibility
!

visitString:aString 
    "Default method for all html text pieces.
     To be defined in subclasses."

    ^ self subclassResponsibility
! !

!Visitor methodsFor:'visiting'!

visit:anObject
    "Visit an object."

    anObject isNil ifTrue:[^ self].

    anObject isString ifTrue:[
        ^ self visitString:anObject
    ].

    anObject acceptHTMLVisitor:self.
!

visitSubelement:aSubElement 
    "Visit a subelement.
     Hook for redefinition.
     Some subclasses may want to have a hook 
     here to do something special before or 
     after visitng a subelement.
     See Encoder for example."

    self visit:aSubElement.
!

visitSubelementsOf:anElement
    "Visit the subelements of an element."

    anElement subelementsDo:[:subelement| 
        self visitSubelement:subelement
    ].
! !

!Visitor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/HTML__Visitor.st,v 1.37 2011/11/29 11:22:10 sr Exp $'
! !
