"{ Package: 'stx:goodies/webServer/htmlTree' }"

LibraryDefinition subclass:#stx_goodies_webServer_htmlTree
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_webServer_htmlTree class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:goodies/webServer'    "HTTPServer - referenced by HTML::AbstractTreeBuilder>>text: "
        #'stx:libbasic'    "Object - superclass of HTML::Table "
        #'stx:libhtml'    "HTMLScriptEnvironment - referenced by HTML::HTMLParser>>parseSmalltalkScriptFrom: "
        #'stx:libjavascript'    "JavaScriptParser - referenced by HTML::HTMLParser>>parseJavaScriptFrom: "
    )
! !

!stx_goodies_webServer_htmlTree class methodsFor:'description - compilation'!

additionalDefinitions_bc_dot_mak
    ^ '
# see stdHeader_bc for LIBHTMLTREE_BASE
LIB_BASE_LD_ARG=-b:$(LIBHTMLTREE_BASE)
'                    
! !

!stx_goodies_webServer_htmlTree class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'HTML::AbstractElement'
        #'HTML::AbstractTreeBuilder'
        #'HTML::CSS_AbstractStyleObject'
        #'HTML::HTMLParseError'
        #'HTML::HTMLParser'
        #'HTML::HTMLStructureError'
        #'HTML::StyleVisitor'
        #'HTML::Visitor'
        #'stx_goodies_webServer_htmlTree'
        #'HTML::AbstractHTMLElement'
        #'HTML::AbstractProcessingElement'
        #'HTML::CSS_AbstractStyleProperty'
        #'HTML::CSS_StyleElement'
        #'HTML::Embed'
        #'HTML::Encoder'
        #'HTML::StyleEncoder'
        #'HTML::TextExtractor'
        #'HTML::TreeBuilder'
        #'HTML::AbstractFormElement'
        #'HTML::AbstractList'
        #'HTML::AbstractTableCell'
        #'HTML::AbstractTableRow'
        #'HTML::Address'
        #'HTML::Anchor'
        #'HTML::Area'
        #'HTML::Base'
        #'HTML::Big'
        #'HTML::BlockQuote'
        #'HTML::Body'
        #'HTML::Bold'
        #'HTML::Break'
        #'HTML::CSS_AbstractStylePropertyBox'
        #'HTML::CSS_Background'
        #'HTML::CSS_BackgroundAttachment'
        #'HTML::CSS_BackgroundColor'
        #'HTML::CSS_BackgroundImage'
        #'HTML::CSS_BackgroundPosition'
        #'HTML::CSS_BackgroundRepeat'
        #'HTML::CSS_Border'
        #'HTML::CSS_Bottom'
        #'HTML::CSS_BottomBorder'
        #'HTML::CSS_BottomBorderWidth'
        #'HTML::CSS_BottomMargin'
        #'HTML::CSS_BottomPadding'
        #'HTML::CSS_Clear'
        #'HTML::CSS_Color'
        #'HTML::CSS_Display'
        #'HTML::CSS_Float'
        #'HTML::CSS_Font'
        #'HTML::CSS_FontFamily'
        #'HTML::CSS_FontSize'
        #'HTML::CSS_FontStyle'
        #'HTML::CSS_FontVariant'
        #'HTML::CSS_FontWeight'
        #'HTML::CSS_Height'
        #'HTML::CSS_Left'
        #'HTML::CSS_LeftBorder'
        #'HTML::CSS_LeftBorderWidth'
        #'HTML::CSS_LeftMargin'
        #'HTML::CSS_LeftPadding'
        #'HTML::CSS_LetterSpacing'
        #'HTML::CSS_LineHeight'
        #'HTML::CSS_MinHeight'
        #'HTML::CSS_Position'
        #'HTML::CSS_Right'
        #'HTML::CSS_RightBorder'
        #'HTML::CSS_RightBorderWidth'
        #'HTML::CSS_RightMargin'
        #'HTML::CSS_RightPadding'
        #'HTML::CSS_TextAlignment'
        #'HTML::CSS_TextDecoration'
        #'HTML::CSS_TextIndentation'
        #'HTML::CSS_TextTransformation'
        #'HTML::CSS_Top'
        #'HTML::CSS_TopBorder'
        #'HTML::CSS_TopBorderWidth'
        #'HTML::CSS_TopMargin'
        #'HTML::CSS_TopPadding'
        #'HTML::CSS_VerticalAlignment'
        #'HTML::CSS_Width'
        #'HTML::CSS_WordSpacing'
        #'HTML::Caption'
        #'HTML::Center'
        #'HTML::Code'
        #'HTML::Col'
        #'HTML::Colgroup'
        #'HTML::Comment'
        #'HTML::DefinitionDescription'
        #'HTML::DefinitionList'
        #'HTML::DefinitionTerm'
        #'HTML::Div'
        #'HTML::Document'
        #'HTML::DummyContainerElement'
        #'HTML::Element'
        #'HTML::Form'
        #'HTML::Frame'
        #'HTML::Frameset'
        #'HTML::Head'
        #'HTML::Heading'
        #'HTML::HorizontalRule'
        #'HTML::IFrame'
        #'HTML::Image'
        #'HTML::Italic'
        #'HTML::Label'
        #'HTML::Link'
        #'HTML::ListItem'
        #'HTML::Meta'
        #'HTML::NoFrames'
        #'HTML::NoScript'
        #'HTML::Paragraph'
        #'HTML::Pre'
        #'HTML::ProcessingInstruction'
        #'HTML::Script'
        #'HTML::Small'
        #'HTML::Span'
        #'HTML::Strong'
        #'HTML::Style'
        #'HTML::Table'
        #'HTML::TableBody'
        #'HTML::Title'
        #'HTML::Underlined'
        #'HTML::Button'
        #'HTML::CSS_BorderColor'
        #'HTML::CSS_BorderStyle'
        #'HTML::CSS_BorderWidth'
        #'HTML::CSS_Margin'
        #'HTML::CSS_Padding'
        #'HTML::Heading1'
        #'HTML::Heading2'
        #'HTML::Heading3'
        #'HTML::Heading4'
        #'HTML::Heading5'
        #'HTML::Heading6'
        #'HTML::Input'
        #'HTML::Option'
        #'HTML::OrderedList'
        #'HTML::Select'
        #'HTML::TableDataCell'
        #'HTML::TableFoot'
        #'HTML::TableHead'
        #'HTML::TableHeaderCell'
        #'HTML::TableRow'
        #'HTML::TextArea'
        #'HTML::UnorderedList'
        #'HTML::XHTMLEncoder'
        #'HTML::NoBr'
    )
!

extensionMethodNames
    ^ #(
    )
! !

!stx_goodies_webServer_htmlTree class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X HTML-Tree'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright eXept Software AG 1998-2011'

    "Modified: / 01-02-2011 / 11:55:00 / cg"
! !

!stx_goodies_webServer_htmlTree class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/stx_goodies_webServer_htmlTree.st,v 1.28 2011/11/29 11:23:42 sr Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/stx_goodies_webServer_htmlTree.st,v 1.28 2011/11/29 11:23:42 sr Exp $'
! !
