"
 COPYRIGHT (c) 2007 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree/svg' }"

"{ NameSpace: HTML }"

AbstractElement subclass:#SVGAbstractElement
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-SVG'
!

!SVGAbstractElement class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2007 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!SVGAbstractElement methodsFor:'attributes'!

cx:aNumberOrString
    self attributeAt:#cx put:aNumberOrString.
!

cy:aNumberOrString
    self attributeAt:#cy put:aNumberOrString.
!

d:aString
    self attributeAt:#d put:aString.
!

fill:fillStyleString
    self attributeAt:#fill put:fillStyleString.
!

fillOpacity:aNumber
    self attributeAt:'fill-opacity' put:(aNumber asFloat).
!

fontSize:aNumberOrString
    self attributeAt:'font-size' put:aNumberOrString.
!

height:aNumberOrString
    self attributeAt:#height put:aNumberOrString.
!

points:aStringOrArray
    aStringOrArray isString ifFalse:[
        ^ self points:
            (String streamContents:[:s |
                aStringOrArray do:[:eachPointOrPair |
                    |x y|

                    eachPointOrPair isPoint ifTrue:[
                        x := eachPointOrPair x.
                        y := eachPointOrPair y.
                    ] ifFalse:[
                        x := eachPointOrPair first.
                        y := eachPointOrPair second.
                    ].
                    x printOn:s.
                    s nextPut:$,.
                    y printOn:s.
                ] separatedBy:[
                    s nextPutAll:' '
                ].
            ])
    ].

    self attributeAt:'points' put:aStringOrArray.
!

r:aNumberOrString
    self attributeAt:#r put:aNumberOrString.
!

rotate:aString
    self attributeAt:'rotate' put:aString.
!

rx:aNumberOrString
    self attributeAt:#rx put:aNumberOrString.
!

ry:aNumberOrString
    self attributeAt:#ry put:aNumberOrString.
!

stroke:strokeStyleString
    self attributeAt:#stroke put:strokeStyleString.
!

strokeWidth:aNumberOrString
    self attributeAt:'stroke-width' put:aNumberOrString.
!

textAnchor:aString
    self attributeAt:'text-anchor' put:aString.
!

transform:aString
    self attributeAt:'transform' put:aString.
!

width:aNumberOrString
    self attributeAt:#width put:aNumberOrString.
!

x1:aNumberOrString
    self attributeAt:#x1 put:aNumberOrString.
!

x2:aNumberOrString
    self attributeAt:#x2 put:aNumberOrString.
!

x:aNumberOrString
    self attributeAt:#x put:aNumberOrString.
!

y1:aNumberOrString
    self attributeAt:#y1 put:aNumberOrString.
!

y2:aNumberOrString
    self attributeAt:#y2 put:aNumberOrString.
!

y:aNumberOrString
    self attributeAt:#y put:aNumberOrString.
! !

!SVGAbstractElement methodsFor:'printing'!

htmlString
    "Print yourself as html string.
     See class Encoder and Visitor."

    |encoder |

    encoder := SVGEncoder new. 
    encoder visit:self.
    ^ encoder htmlString.
!

printAttribute:anAssociation on:stream
    |value|

    stream nextPutAll:' '.
    stream nextPutAll:anAssociation key printString.

    value := anAssociation value.
    value isNil ifTrue:[^ self].

    stream nextPutAll:'="'.
    self printAttributeValue:value on:stream.
    stream nextPutAll:'"'.
!

printAttributeValue:aRawObject on:stream
    aRawObject isCollection ifTrue:[
        aRawObject isString ifTrue:[
            stream nextPutAll:(aRawObject copyWithout:$").
        ] ifFalse:[
            aRawObject do:[:subRawObject|
                self printAttributeValue:subRawObject on:stream.
            ].
        ].
        ^ self.
    ].

    (aRawObject class askFor:#isCSS) ifTrue:[
        stream nextPutAll:aRawObject htmlString.
        ^ self.
    ].

    "Whatever you are, try to display yourself."
    aRawObject printOn:stream.
!

printAttributesOn:stream
    |attributes|

    attributes := self attributes.
    attributes isNil ifTrue:[^ self].

    attributes associationsDo:[:association|
        self printAttribute:association on:stream.
    ].
!

printXMLOn:stream
    self printXMLOn:stream indent:0
!

printXMLOn:stream indent:i
    |tag|

    tag := self tagName.
    tag isNil ifTrue:[
        self error.
        ^ self
    ].

    stream spaces:i.    
    stream nextPut:$<; nextPutAll:tag.
    self printAttributesOn:stream.
    stream nextPut:$>.

    children notEmptyOrNil ifTrue:[
        children do:[:each | 
            each isString ifTrue:[
                stream nextPutAll:each
            ] ifFalse:[
                stream cr. 
                each printXMLOn:stream indent:i+2
            ]
        ].
        stream cr; spaces:i.    
    ].

    stream nextPutAll:'</'; nextPutAll:tag; nextPut:$>.
!

xmlString
    "Print yourself as xml string."

    ^ String streamContents:[:s |
        self printXMLOn:s
    ].
! !

!SVGAbstractElement methodsFor:'testing'!

isSVGCircle
    ^ false
!

isSVGDocument
    ^ false
!

isSVGEllipse
    ^ false
!

isSVGGroup
    ^ false
!

isSVGLine
    ^ false
!

isSVGPath
    ^ false
!

isSVGPolyLine
    ^ false
!

isSVGPolygon
    ^ false
!

isSVGRect
    ^ false
!

isSVGTSpan
    ^ false
!

isText
    ^ false
! !

!SVGAbstractElement class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/svg/HTML__SVGAbstractElement.st,v 1.6 2008/05/09 12:14:39 cg Exp $'
! !
