"
 COPYRIGHT (c) 2007 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree/svg' }"

"{ NameSpace: HTML }"

AbstractTreeBuilder subclass:#SVGTreeBuilder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-SVG'
!

!SVGTreeBuilder class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2007 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    unfinished - will make it easier to construct valid HTML-trees eventually
"
!

examples
"
                                                                                [exBegin]
    |builder|

    builder := HTML::SVGTreeBuilder new.
    builder
       svg; 
         viewbox:(0@0 corner:270@400);
         width:'100%';
         height:'100%';
         g; id:'mainlayer';
           rect; fill:'red'; stroke:'black'; x:15; y:15; width:100; height:50; rectEnd;
           rect; fill:'blue'; stroke:'black'; x:150; y:15; width:100; height:50; rx:12; ry:18; rectEnd;
         gEnd;
       svgEnd.
    builder xmlString inspect.

                                                                                [exEnd]

                                                                                [exBegin]
                                                                                [exEnd]

                                                                                [exBegin]
                                                                                [exEnd]
"
! !

!SVGTreeBuilder methodsFor:'accessing'!

xmlString
    "xml of the generated tree so far"

    ^ self rootElement xmlString

    "Created: / 24-11-2006 / 17:13:13 / cg"
! !

!SVGTreeBuilder methodsFor:'attributes'!

cx:aNumberOrString
    attributableElement cx:aNumberOrString    
!

cy:aNumberOrString
    attributableElement cy:aNumberOrString    
!

d:aString
    attributableElement d:aString    
!

fill:fillString
    attributableElement fill:fillString.
!

fillOpacity:aNumber
    attributableElement fillOpacity:aNumber    
!

fontSize:aNumberOrString
    attributableElement fontSize:aNumberOrString    
!

height:aNumberOrPercentString
    attributableElement height:aNumberOrPercentString    
!

points:aString
    attributableElement points:aString    
!

r:aNumberOrString
    attributableElement r:aNumberOrString    
!

rotate:aString
    attributableElement rotate:aString    
!

rx:aNumberOrString
    attributableElement rx:aNumberOrString    
!

ry:aNumberOrString
    attributableElement ry:aNumberOrString    
!

stroke:strokeString
    attributableElement stroke:strokeString.
!

strokeWidth:aNumberOrString
    attributableElement strokeWidth:aNumberOrString    
!

textAnchor:aString
    attributableElement textAnchor:aString    
!

transform:aString
    attributableElement transform:aString    
!

type:typeString
    attributableElement type:typeString.
!

viewBox:aRectangleOrArrayOrString
    aRectangleOrArrayOrString isArray ifTrue:[
        ^ attributableElement viewBox:('%1 %2 %3 %4' 
                                bindWith:(aRectangleOrArrayOrString first)
                                with:(aRectangleOrArrayOrString second)
                                with:(aRectangleOrArrayOrString third)
                                with:(aRectangleOrArrayOrString fourth)).
    ].
    aRectangleOrArrayOrString isRectangle ifTrue:[
        ^ attributableElement viewBox:('%1 %2 %3 %4' 
                                bindWith:(aRectangleOrArrayOrString left)
                                with:(aRectangleOrArrayOrString top)
                                with:(aRectangleOrArrayOrString width)
                                with:(aRectangleOrArrayOrString height)).
    ].
    self assert:aRectangleOrArrayOrString isString.
    attributableElement viewBox:aRectangleOrArrayOrString
!

width:aNumberOrPercentString
    aNumberOrPercentString isNil ifTrue:[^ self].
    attributableElement width:aNumberOrPercentString
!

x1:aNumberOrString
    attributableElement x1:aNumberOrString    
!

x2:aNumberOrString
    attributableElement x2:aNumberOrString    
!

x:aNumberOrString
    attributableElement x:aNumberOrString    
!

y1:aNumberOrString
    attributableElement y1:aNumberOrString    
!

y2:aNumberOrString
    attributableElement y2:aNumberOrString    
!

y:aNumberOrString
    attributableElement y:aNumberOrString    
! !

!SVGTreeBuilder methodsFor:'building'!

circle
    self startElement:(SVGCircle new).
!

circleEnd
    self assert:(currentElement isSVGCircle).
    self endElement
!

ellipse
    self startElement:(SVGEllipse new).
!

ellipseEnd
    self assert:(currentElement isSVGEllipse).
    self endElement
!

g
    self startElement:(SVGGroup new).
!

gEnd
    self assert:(currentElement isSVGGroup).
    self endElement
!

line
    self startElement:(SVGLine new).
!

lineEnd
    self assert:(currentElement isSVGLine).
    self endElement
!

path
    self startElement:(SVGPath new).
!

pathEnd
    self assert:(currentElement isSVGPath).
    self endElement
!

polygon
    self startElement:(SVGPolygon new).
!

polygonEnd
    self assert:(currentElement isSVGPolygon).
    self endElement
!

polyline
    self startElement:(SVGPolyLine new).
!

polylineEnd
    self assert:(currentElement isSVGPolyLine).
    self endElement
!

rect
    self startElement:(SVGRect new).
!

rectEnd
    self assert:(currentElement isSVGRect).
    self endElement
!

svg
    self startElement:(SVGDocument new).
!

svgEnd
    self assert:(currentElement isSVGDocument).
    self endElement
!

text
    self startElement:(SVGText new).
!

textEnd
    self assert:(currentElement isText).
    self endElement
!

tspan
    self startElement:(SVGTSpan new).
!

tspanEnd
    self assert:(currentElement isSVGTSpan).
    self endElement
! !

!SVGTreeBuilder methodsFor:'setup'!

beginDocument
    self beginWith:(SVGDocument new).
! !

!SVGTreeBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/svg/HTML__SVGTreeBuilder.st,v 1.4 2008/05/09 12:15:09 cg Exp $'
! !
