"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer/htmlTree/tests' }"

"{ NameSpace: HTML }"

HTTPSelectorService subclass:#TestService
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-TestService'
!

!TestService class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
This service add all methods selectors under the category test to the default site so you can test your code by browser
"
! !

!TestService class methodsFor:'defaults'!

linkName
    "return the default linkName path (with slash)"

    ^ '/HtmlTests'
!

shownInSettingsDialog
    ^ false
! !

!TestService class methodsFor:'queries-service'!

addToWellKnownClasses
    ^ false
!

settingsApplicationClass
    "a SettingsApplication class - or nil (used in the settings dialog if non-nil)"

    ^ nil
! !

!TestService methodsFor:'actions'!

process:aRequest
    "process an incoming HTTP request"

    aRequest
	response
	    reply:'Hello World'.
! !

!TestService methodsFor:'queries-service'!

allowedMessages
    "return a collection of messages, that this service processes,
such as
#(foo bar baz)"

    self shouldImplement
!

defaultMessage

    ^ #'default:'
!

isMessageAllowed:aSelector

    ^ self testMethodNames includes:aSelector.
!

testMethodNames

    |testMessages|

    testMessages := OrderedCollection new.
    self class methodDictionary keysAndValuesDo:[:aMethodName :aMethod|
	(aMethod category = #tests) ifTrue:[
	    testMessages add:aMethodName.
	].
    ].
    ^ testMessages.
! !

!TestService methodsFor:'tests'!

default:aRequest

    |methodNames|

    methodNames := self testMethodNames.
    methodNames remove:#default:.
    methodNames isEmpty ifTrue:[
	aRequest nextPutLine:'<H2>No Test Methods available</H2>'.
    ].

    methodNames := methodNames asSortedCollection.

    methodNames do:[:aName|
	aRequest nextPutLine:(aRequest webLinkForText:('Perform ', aName printString) service:self selector:aName).
	aRequest nextPutLine:'<br>'.
    ].
!

test000_SimpleString:aRequest

    aRequest nextPutLine:'See this output'.
!

test010_Document:aRequest
    "Return a full page with all necessary components.
     Taken from examples of www.htmlhelp.com."

    aRequest nextPutLine:'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN""http://www.w3.org/TR/REC-html40/strict.dtd">
			  <HTML>
			      <HEAD>
				  <TITLE>The document title</TITLE>
			      </HEAD>
			      <BODY>
				  <H1>Main heading</H1>
				  <P>A paragraph.</P>
				  <P>Another paragraph.</P>
				  <UL>
				  <LI>A list item.</LI>
				  <LI>Another list item.</LI>
				  </UL>
			      </BODY>
			   </HTML>'.
!

test023_DefinitionList:aRequest
    "Return a full page with all necessary components.
     Taken from examples of www.htmlhelp.com."

    aRequest nextPutLine:'<DL>
			    <DT>Block-level elements</DT>
			    <DD>
			    <P>
			      In HTML, block-level elements may generally contain
			      inline elements and other block-level elements. They are
			      usually formatted differently than inline elements,
			      typically on a new line in visual browsers.
			    </P>
			    </DD>
			    <DT>Inline elements</DT>
			    <DT>Text-level elements</DT>
			    <DD>
			    <P>
			      Inline (or text-level) elements generally only contain
			      character data and other inline elements.
			    </P>
			    </DD>
			 </DL>'.
!

test040_Table:aRequest
    "Return a frameset example, yet a bit buggy!!"


    aRequest nextPutLine:'<TABLE SUMMARY="This table lists SI (International System) units of
			    measure, giving the name of the unit, its symbol, and
			    the quantity that it measures.">
			    <CAPTION>SI Units</CAPTION>
			    <THEAD>
			      <TR>
				<TH SCOPE=col>Name</TH>
				<TH SCOPE=col>Symbol</TH>
				<TH SCOPE=col>Quantity</TH>
			      </TR>
			    </THEAD>
			    <TBODY CLASS=base>
			      <TR>
				<TD SCOPE=row>meter</TD>
				<TD>m</TD>
				<TD>length</TD>
			      </TR>
			      <TR>
				<TD SCOPE=row>kilogram</TD>
				<TD>kg</TD>
				<TD>mass</TD>
			      </TR>
			    </TBODY>
			    <TBODY CLASS=derived>
			      <TR>
				<TD SCOPE=row>hertz</TD>
				<TD>Hz</TD>
				<TD>frequency</TD>
			      </TR>
			      <TR>
				<TD SCOPE=row>pascal</TD>
				<TD>Pa</TD>
				<TD>pressure</TD>
			      </TR>
			    </TBODY>
			    <TBODY CLASS=supplementary>
			      <TR>
				<TD SCOPE=row>radian</TD>
				<TD>rad</TD>
				<TD>plane angle</TD>
			      </TR>
			    </TBODY>
			  </TABLE>'.
!

test041_TableFoot:aRequest
    "Return a frameset example, yet a bit buggy!!"

    aRequest nextPutLine:'<TABLE SUMMARY="This table lists program available at the university
			    based on the discipline and type of degree.">
			     <CAPTION>Programs Available</CAPTION>
			     <COLGROUP CLASS="program-discipline">
			     <COLGROUP CLASS="program-type" SPAN=5>
			     <THEAD>
			       <TR>
				 <TH SCOPE=col>Program</TH>
				 <TH SCOPE=col>Honors Co-op</TH>
				 <TH SCOPE=col>Honors Regular</TH>
				 <TH SCOPE=col>General Regular</TH>
				 <TH SCOPE=col>*Preprofessional or Professional</TH>
			       </TR>
			     </THEAD>
			     <TFOOT CLASS=footnote>
			       <TR>
				 <TD COLSPAN=5>
				     Many disciplines are also available as Minors and Joint
				     Honors programs.
				 </TD>
			       </TR>
			       <TR>
				 <TD COLSPAN=5>
				   * Preprofessional programs normally fulfull the academic
				     requirements for registration in the related professions.
				 </TD>
			       </TR>
			     </TFOOT>
			     <TBODY>
			       <TR>
				 <TD SCOPE=row>Computer Science</TD>
				 <TD>yes</TD>
				 <TD>yes</TD>
				 <TD>no</TD>
				 <TD>no</TD>
			       </TR>
			     </TBODY>
			   </TABLE>'.
!

test050_Columns:aRequest
    "Return a frameset example, yet a bit buggy!!"

    aRequest nextPutLine:'<TABLE SUMMARY="This table gives the character entity reference,
					  decimal character reference, and hexadecimal character
					  reference for 8-bit Latin-1 characters, as well as the
					  rendering of each in your browser.">
			    <COLGROUP CLASS="character-description">
			    <COLGROUP>
			      <COL CLASS=entity>
			      <COL SPAN=2 CLASS=numeric>
			    <COLGROUP>
			      <COL CLASS="entity-rendering">
			      <COL CLASS="decimal-rendering">
			      <COL CLASS="hex-rendering">
			    <THEAD>
			      <TR>
				<TH SCOPE=col ROWSPAN=2>Character</TH>
				<TH SCOPE=col ROWSPAN=2>Entity</TH>
				<TH SCOPE=col ROWSPAN=2>Decimal</TH>
				<TH SCOPE=col ROWSPAN=2>Hex</TH>
				<TH SCOPE=colgroup COLSPAN=3>Rendering in Your Browser</TH>
			      </TR>
			      <TR>
				<TH SCOPE=col>Entity</TH>
				<TH SCOPE=col>Decimal</TH>
				<TH SCOPE=col>Hex</TH>
			      </TR>
			    </THEAD>
			    <TBODY>
			      <TR>
				<TD SCOPE=row>non-breaking space</TD>
				<TD>&amp;nbsp;</TD>
				<TD>&amp;#160;</TD>
				<TD>&amp;#xA0;</TD>
				<TD>&nbsp;</TD>
				<TD>&#160;</TD>
				<TD>&#xA0;</TD>
			      </TR>
			    </TBODY>
			  </TABLE>.'
!

test090_Frames:aRequest

    aRequest nextPutLine:'<html>
			    <head>
			      <title>welcome.html - SubNavigation</title>
			      <meta name="CONTENT-INFO" content="">
			   </head>

			    <frameset cols="130,*"
				      frameborder="no"
				      border="0"
				      framespacing="0"
				      rows="*">
			      <frame name="Navigation"
				     scrolling="auto"
				     noresize
				     src="http://www.exept.de/sites/exept/deutsch/Home/navigation.html">
			      <frameset rows="80,*"
					frameborder="no"
					border="0"
					framespacing="0"
					col="*">
				<frame name="SubNavigation"
				       scrolling="no"
				       noresize
				       src="http://www.exept.de/sites/exept/deutsch/Home/sp_welcome.html">

				<frame name="Contents"
				       src="http://www.exept.de/sites/exept/deutsch/Home/welcome.html">
			      </frameset>
			    </frameset>

			    <noframes>
			      <body bgcolor="#FFFFFF">
				<p>
				  Diese Seite verwendet Frames. Frames werden von Ihrem Browser aber
				  nicht untersttzt.
				</p>
				<p>

				  These sites uses Frames. Frames are not supported from your Browser.
				</p>
			      </body>
			    </noframes>
			  </html>'
!

test091_Frames:aRequest

    aRequest nextPutLine:'<frameset cols="130,*" frameborder="no" border="0" framespacing="0" rows="*">
			    <frame name="Navigation" scrolling="auto" noresize src="http://www.exept.de/sites/exept/deutsch/Home/navigation.html">
			    <frameset rows="80,*" frameborder="no" border="0" framespacing="0" col="*">
			      <frame name="SubNavigation" scrolling="no" noresize src="http://www.exept.de/sites/exept/deutsch/Home/sp_welcome.html">
			      <frame name="Contents" src="http://www.exept.de/sites/exept/deutsch/Home/welcome.html">
			    </frameset>
			  </frameset>

			  <noframes>
			    <body bgcolor="#FFFFFF">
			      <p>
				Diese Seite verwendet Frames. Frames werden von Ihrem Browser aber
				nicht untersttzt.
			      </p>
			      <p>
				These sites uses Frames. Frames are not supported from your Browser.
			      </p>
			    </body>
			  </noframes>'
!

test092_Frames:aRequest

    aRequest nextPutLine:'<frameset cols="130,*" rows="*">
			    <frame name="Navigation" src="http://www.exept.de/sites/exept/deutsch/Home/navigation.html">
			    <frameset rows="80,*" col="*">
			      <frame name="SubNavigation" src="http://www.exept.de/sites/exept/deutsch/Home/sp_welcome.html">
			      <frame name="Contents" src="http://www.exept.de/sites/exept/deutsch/Home/welcome.html">
			    </frameset>
			  </frameset>

			  <noframes>
			    <body>Some text here</body>
			  </noframes>'
!

test100_KaiWasserbaechStyle:aRequest

    aRequest nextPutLine:'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html><head>
    <title>Kais Web Page Example - KaisWebApp1</title><meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
    <meta name="author" content="Kai Wasserbaech">
    <link rel="icon" type="image/ico" href="/files/favicon">
    <link rel="stylesheet" type="text/css" href="/files/css.css"></head>


  <body>
    <div class="titleRowPict">
      <br><img src="/files/exeptLogo.gif" alt="Exept Logo">
    </div>
    <div class="titleRowTxt">
      Kais Web Page Example - KaisWebApp1
    </div>
    <div class="navBarSpace">
      
    </div>
    <div class="navBarMain">
    </div>
    <div class="mainReturn">
      <div class="asB">PLEASE NOTE THAT THIS APPLICATION IS IN THE DEVELOPMENT STADIUM "ALPHA"!!</div>
<!!--      <br><br><form action="KaisWebApp1/formRtn" method="POST" enctype="text/plain">
      Bitte geben Sie Ihren Namen ein: <input class="inputSpecial" type="text" name="usrName" size="25">
 <input class="inputSpecial" type="submit" name="submit" value="&Uuml;bermitteln">
      </form> -->
      <br><div class="asH1">Please Select</div><br>
      <a href="http://exept:8082/KaisWebApp1/listMembers">Membership list</a><br><br>
      <a href="http://exept:8082/KaisWebApp1/addMember">Add member</a><br><br>
      <a href="http://exept:8082/KaisWebApp1/delMember">Delete member(s)</a>
      <br><br><br><div class="asB">No tables were used for formatting, only CSS!!</div>
     </div>
    <div class="footLeft"></div>
    <div class="footRight"><br><address>
ST/X 4.1.7 Server 1.277 at exept:8082  8-Mai-2003 / 12:34:12
</address></div>
  </body></html>
'
!

test101_eXeptStyle:aRequest

    aRequest nextPutLine:'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
			  <html>
			      <head>
				  <title>Web Page Example mit style sheet - Uses CSS</title>
				  <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
				  <meta name="author" content="Martin Walser">
				  <link rel="icon" type="image/ico" href="/files/favicon">
				  <link rel="stylesheet" type="text/css" href="/files/css.css">
			      </head>

			      <body>
				  <div class="titleRowPict">
				      <img src="/files/exeptLogo.gif" alt="Exept Logo">
				  </div>

				  <div class="titleRowTxt">
				      eXept Software AG
				  </div>


				  <div class="navBarMain">
				  </div>

				  <div class="mainReturn">
				      Hier kommt der Inhalt
				  </div>

				  <div class="footLeft">
				  </div>

				  <div class="footRight">
				      <br>
				      <address>ST/X 4.1.7 Server 1.277 at exept:8082  8-Mai-2003 / 12:34:12</address>
				  </div>
			      </body>
			  </html>'
!

test200_Visitor:aRequest
    "The encoding is done through a visitor."

    |encoder table|

    encoder := Encoder new.


    table := Table new.
    table caption: 'This is the title of a generated table'.

    table head:    #('Hans' 'Otto' 'Karl' 'Kurt' 'Gerd' 'John').

    table addRow:  #(373 937 363 836 217 832).
    table addRow:  #(945 123 534 345 563 343).


    table visit:encoder.

    aRequest nextPutLine:encoder htmlString.
!

test210_Document:aRequest
    "The encoding is done through a visitor."

    |document|

    document := Document new.

    document title:        'This is a generated title'.

    document addHeading1:  'This is a generated level one heading'.
    document addHeading2:  'This is a generated level two heading'.
    document addHeading3:  'This is a generated level three heading'.
    document addHeading4:  'This is a generated level four heading'.
    document addHeading5:  'This is a generated level five heading'.
    document addHeading6:  'This is a generated level six heading'.

    document addParagraph: 'This is a generated paragraph
			It contains text and text and text.'.

    document addParagraph: 'This is a another generated paragraph.'.

    document addHorizontalRule.


    aRequest nextPutLine:document htmlString.
!

test221_OrderedList:aRequest
    "The encoding is done through a visitor."

    |list|

    list := OrderedList new.

    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.


    list enumerateDecimal.
    aRequest nextPutLine:list htmlString.

    list enumerateLowercaseRoman.
    aRequest nextPutLine:list htmlString.

    list enumerateUppercaseRoman.
    aRequest nextPutLine:list htmlString.

    list enumerateLowercaseAlphabetic.
    aRequest nextPutLine:list htmlString.

    list enumerateUppercaseAlphabetic.
    aRequest nextPutLine:list htmlString.
!

test222_UnorderedList:aRequest
    "The encoding is done through a visitor."

    |list|

    list := UnorderedList new.

    list addListItem:'First generated list item'.
    list addListItem:'Second generated list item'.
    list addListItem:'Third generated list item'.

    list useDiscBullets.
    aRequest nextPutLine:list htmlString.

    list useSquareBullets.
    aRequest nextPutLine:list htmlString.

    list useCircleBullets.
    aRequest nextPutLine:list htmlString.
!

test223_DefinitionList:aRequest
    "The encoding is done through a visitor."

    |list|

    list := DefinitionList new.

    list addDefinition:'Smalltalk' -> 'A pure object oriented programming language.'.

    list addLineBreak.

    list addDefinitionTerm:'Java'.
    list addDefinitionDescription:'A clever marketing strategie.'.

    aRequest nextPutLine:list htmlString.
!

test224_OrderedList:aRequest
    "The encoding is done through a visitor."

    |list|

    list := OrderedList new.

    list addListItem:#( 'First generated list item'
			'Second generated list item'
			'Third generated list item').

    list enumerateDecimal.
    aRequest nextPutLine:list htmlString.

    list enumerateLowercaseRoman.
    aRequest nextPutLine:list htmlString.

    list enumerateUppercaseRoman.
    aRequest nextPutLine:list htmlString.

    list enumerateLowercaseAlphabetic.
    aRequest nextPutLine:list htmlString.

    list enumerateUppercaseAlphabetic.
    aRequest nextPutLine:list htmlString.
!

test225_OrderedList:aRequest
    "The encoding is done through a visitor."

    |list|

    list := OrderedList new.

    list addListItem:#( 3425234523
			2345324534
			9681324643).

    list enumerateDecimal.
    aRequest nextPutLine:list htmlString.

    list enumerateLowercaseRoman.
    aRequest nextPutLine:list htmlString.

    list enumerateUppercaseRoman.
    aRequest nextPutLine:list htmlString.

    list enumerateLowercaseAlphabetic.
    aRequest nextPutLine:list htmlString.

    list enumerateUppercaseAlphabetic.
    aRequest nextPutLine:list htmlString.
!

test230_Rules:aRequest
    "Show horizontal rules with various settings."

    |rule|

    rule := HTML::HorizontalRule new.

    aRequest nextPutLine:rule htmlString.

    rule ruleSize:5.
    rule beNoshade.
    aRequest nextPutLine:rule htmlString.

    rule beShade.
    aRequest nextPutLine:rule htmlString.

    rule width:120.
    aRequest nextPutLine:rule htmlString.

    rule alignLeft.
    aRequest nextPutLine:rule htmlString.

    rule alignRight.
    aRequest nextPutLine:rule htmlString.
!

test231_Center:aRequest
    "Show the centering of a paragraph
     with the center element."

    |paragraph center|

    paragraph := Paragraph with: 'This is a centered Text.'.
    center    := Center    with: paragraph.

    aRequest nextPutLine:center htmlString.
!

test232_Div:aRequest
    "Show the centering of a paragraph
     with the center element."

    |div|

    div := Div with: 'This is a aligned Text.'.

    div alignLeft.
    aRequest nextPutLine:div htmlString.

    div alignCenter.
    aRequest nextPutLine:div htmlString.

    div alignRight.
    aRequest nextPutLine:div htmlString.
!

test241_Table:aRequest
    "Show a simple table with caption head and rows."

    |table|

    table := Table new.
    table border:  1.
    table caption: 'This is the caption of a generated table'.
    table head:    #('Hans' 'Otto' 'Karl' 'Kurt' 'Gerd' 'John' 'Bert').
    table addRow:  #(373 937 363 836 217 832 234).
    table addRow:  #(945 123 534 345 563 343 342).

    aRequest nextPutLine:table htmlString.
!

test242_TableBody:aRequest
    "Create and show a table body
     instead of singel rows."

    |table|

    table := Table new.
    table border:  1.
    table caption: 'This is the title of a generated table'.
    table caption alignRight.

    table head:    #('Hans' 'Otto' 'Karl' 'Kurt' 'Gerd' 'John' 'Bert').

    table addBody: #( #(373 937 363 836 217 832 234)
		      #(945 123 534 345 563 343 764)).

    table foot:    #(111 222 333 444 555 666 777).

    aRequest nextPutLine:table htmlString.
!

test243_TableFraming:aRequest
    "Show all possible framing settings."

    |table break|

    break := Break new.

    table := Table new.
    table caption: 'This is the title of the table'.
    table head:    #('Hans' 'Kurt' 'Karl' 'Otto' 'Gerd').
    table addRow:  #(678 212 131 200 344).
    table addRow:  #(312 567 112 678 120).
    table addRow:  #(177 314 234 189 789).

    aRequest nextPutLine:table htmlString.
    aRequest nextPutLine:break htmlString.

    table frameAbove.
    aRequest nextPutLine:table htmlString.
    aRequest nextPutLine:break htmlString.

    table frameBelow.
    aRequest nextPutLine:table htmlString.
    aRequest nextPutLine:break htmlString.

    table frameBorder.
    aRequest nextPutLine:table htmlString.
    aRequest nextPutLine:break htmlString.

    table frameBox.
    aRequest nextPutLine:table htmlString.
    aRequest nextPutLine:break htmlString.

    table frameHorizontalSides.
    aRequest nextPutLine:table htmlString.
    aRequest nextPutLine:break htmlString.

    table frameLeftHorizontalSide.
    aRequest nextPutLine:table htmlString.
    aRequest nextPutLine:break htmlString.

    table frameRightHorizontalSide.
    aRequest nextPutLine:table htmlString.
    aRequest nextPutLine:break htmlString.

    table frameVerticalSides.
    aRequest nextPutLine:table htmlString.
!

test244_TableRules:aRequest
    "Show all possible rules in a table."

    |table break|

    break := Break new.

    table := Table new.
    table caption: 'This is the title of the table'.
    table head:    #('Hans' 'Kurt' 'Karl' 'Otto' 'Gerd').
    table addRow:  #(678 212 131 200 344).
    table addRow:  #(312 567 112 678 120).
    table addRow:  #(177 314 234 189 789).

    aRequest nextPutLine:break htmlString.
    aRequest nextPutLine:table htmlString.

    table beRulesAll.
    aRequest nextPutLine:break htmlString.
    aRequest nextPutLine:table htmlString.

    table beRulesColumns.
    aRequest nextPutLine:break htmlString.
    aRequest nextPutLine:table htmlString.

    table beRulesGroups.
    aRequest nextPutLine:break htmlString.
    aRequest nextPutLine:table htmlString.

    table beRulesNone.
    aRequest nextPutLine:break htmlString.
    aRequest nextPutLine:table htmlString.


    table beRulesRows.
    aRequest nextPutLine:break htmlString.
    aRequest nextPutLine:table htmlString.
!

test245_TableAccessToCell:aRequest
    "Show all possible rules in a table."

    |table cell|

    table := HTML::Table new.
    table addBody:  #( #(678 212 131 200 344)
		       #(312 567 112 678 120)
		       #(177 314 234 189 789)).

    cell := table cellAt:3@2.
    cell bgColor:Color red.

    aRequest nextPutLine:table htmlString.
!

test246_AddOffsetCell:aRequest
    "Show all possible rules in a table."

    |table|

    table := HTML::Table new.
    table border:1.

    table rowAt:4 cellAt:3 put:'Fritz'.
"
    table cellAt:3@4 put:'Fritz'.
    table bodyAt:2 rowAt:4 cellAt:3 put:'Fritz'.
"

    aRequest nextPutLine:table htmlString.
!

test247_TableHead:aRequest
    "Create and show a table body
     instead of singel rows."

    |table head|

    table := Table new.

    table caption: 'This is the title of a generated table'.
    table caption alignRight.

    head :=  table headCellAt:16 put:'bla bla bla'.

    table addBody: #( #(373 937 363 836 217 832)
		      #(945 123 534 345 563 343)).

    table foot:    #(111 222 333 444 555 666).

    aRequest nextPutLine:table htmlString.
!

test248_CellAccess:aRequest
    "Set a background color, use a smalltalk color object."

    |table cell|

    table := Table new.
    table border:1.
    table bgColor:Color pink.

    table addBody: #( #(373 937 363 836 217 832 234)
		      #(945 123 534 345 563 343 764)
		      #(945 123 534 345 563 343 764)).

    cell := table cellAt:4@3.
    cell addElement:'Hugo'.

    cell := table cellAt:7@3.
    cell childAt:1 put:'Karl'.

    aRequest nextPutLine:table htmlString.
!

test260_Anchor:aRequest
    ""

    |anchor|

    anchor := Anchor href:'http://www.exept.de' with:'Go to exept'.

    aRequest nextPutLine:anchor htmlString.
!

test261_AnchorIncluded:aRequest
    ""

    |center|

    center := Center new.
    center addAnchorHRef:'"http://www.exept.de"' with:'Go to exept'.

    aRequest nextPutLine:center htmlString.
!

test262_AnchorStyled:aRequest
    ""

    |anchor|

    anchor := Anchor href:'http://www.exept.de'.
    anchor addItalic:     'Otto '.
    anchor addUnderlined: 'Karl ' .
    anchor addBold:       'Kurt '.
    anchor addSmall:      'Bert '.
    anchor addBig:        'John '.

    aRequest nextPutLine:anchor htmlString.
!

test270_Color:aRequest
    "Set a background color, use a smalltalk color object."

    |table cell|

    table := Table new.

    table addBody: #( #(373 937 363 836 217 832 234)
		      #(945 123 534 345 563 343 764)
		      #(945 123 534 345 563 343 764)).

    cell := table cellAt:4@3.

    cell bgColor:Color red.

    aRequest nextPutLine:table htmlString.
!

test271_ColorMatrix:aRequest
    "Set a background color, use a smalltalk color object."

    |matrix table|

    matrix  := #( #(373 937 363 836 217 832 234)
		  #(945 123 534 345 563 343 764)
		  #(456 836 267 234 128 235 962)).

    table   := Table new.

    table addBody: matrix.

    matrix doWithIndex:[
	:line :y|
	line doWithIndex:[
	    :value :x|
	    |cell color|
	    cell  := table cellAt:x@y.

	    "Get any color for the matrix value."
	    color := Color rgbValue:((value * (Color scalingValue)) / 1000) asInteger.

	    "Goal is to give a real smalltalk color here."
	    cell bgColor:color.
	].
    ].

    aRequest nextPutLine:table htmlString.
!

test280_Image:aRequest
    "Set a background color, use a smalltalk color object."

    |image|

    image := Image new.
    image alternative:'eXept Software AG Logo'.
    "image border:1."
    image source:'http://www.exept.de/sites/exept/images/startup.gif'.

    aRequest nextPutLine:image htmlString.
!

test281_ImageAsLink:aRequest
    "Set a background color, use a smalltalk color object."

    |image anchor|

    image := Image new.
    image alternative:'eXept Software AG Logo'.
    image source:'http://www.exept.de/sites/exept/images/startup.gif'.
    image border:0.

    anchor := Anchor href:'http://www.exept.de' with:image.

    aRequest nextPutLine:anchor htmlString.
!

test290_Frames:aRequest
    "Set a background color, use a smalltalk color object."

    |outer inner navigation subnavigation contents|

    outer := Frameset new.
    outer rows:'*'.
    outer columns:#(130 '*').
    outer border:0.

    inner := Frameset new.
    inner rows:#(80 '*').
    inner columns:'*'.
    inner border:0.

    navigation := Frame new.
    navigation name:'Navigation'.
    navigation source:'http://www.exept.de/sites/exept/deutsch/Home/navigation.html'.

    subnavigation := Frame new.
    subnavigation name:'Subnavigation'.
    subnavigation source:'http://www.exept.de/sites/exept/deutsch/Home/sp_welcome.html'.

    contents := Frame new.
    contents name:'Contents'.
    contents source:'http://www.exept.de/sites/exept/deutsch/Home/welcome.html'.

    inner addFrame:subnavigation.
    inner addFrame:contents.

    outer addFrame:navigation.
    outer addFrameset:inner.

    aRequest nextPutLine:outer htmlString.
!

test300_Generic:aRequest
    "Set a background color, use a smalltalk color object."

    |element child|

    element := Element newTag:'hugo'.
    child   := Element newTag:'Center'.

    child   addElement:'See the source for an exotic element.'.
    element addElement:child.


    aRequest nextPutLine:element htmlString.
!

test400_eXeptStyle:aRequest
    "Example with style-sheet.
     Uses a file exept.css as style."

    |document head body image address|

    document := Document newStrict.

    head := document getHead.

    head title:'Web Page Example mit style sheet - Uses CSS'.
    head addMetaHttpEquivalent:'content-type' content:'text/html; charset=ISO-8859-1'.
    head addMetaName:'Author' content:'Martin Walser'.
    head addLinkHref:'/files/exept.css' rel:'stylesheet' type:'text/css'.


    body := document getBody.

    image := Image source:'/files/exeptLogo.gif' alternative:'eXept Software AG Logo' border:0.
    body addDiv:(Array with:Break new with:image) class:'titleRowPict'.
    body addDiv:(Array with:Break new with:'eXept Software AG') class:'titleRowTxt'.
    body addDivClass:'navBarSpace'.
    body addDivClass:'navBarMain'.
    body addDiv:(Anchor href:'www.exept.de' with:'to exept') class:'mainReturn'.
    body addDivClass:'footLeft'.
    address := Address with:'ST/X 4.1.7 Server 1.277 at exept:8082  8-Mai-2003 / 12:34:12'.
    body addDiv:(Array with:Break new with:address) class:'footRight'.


    aRequest nextPutLine:document htmlString.
!

test401_StyleAsAttribute:aRequest
    "Example with setting style as attribute."

    |document heading|

    document := Document newStrict.

    heading  := document addHeading2:'Heading2 colored with css-style as attribute.'.
    heading style:CSS_Color newRed.

    heading  := document addHeading3:'Heading3 colored with css-Style as attribute.'.
    heading style:CSS_Color newBlue.

    aRequest nextPutLine:document htmlString.
!

test402_StyleAsElement:aRequest
    "Example with setting style as html-element."

    |document head h2 h3|

    document := Document newStrict.

    head     := document getHead.

    h2       := CSS_StyleElement
		    selectors: #h2
		    properties:(OrderedCollection with:CSS_Color newRed).

    h3       := CSS_StyleElement
		    selectors: #h3
		    properties:(OrderedCollection with:CSS_Color newBlue).

    head addStyle:(Array with:h2 with:h3).

    document addHeading2:'Heading2 colored with css-style as html-element.'.
    document addHeading3:'Heading3 colored with css-style as html-element.'.


    aRequest nextPutLine:document htmlString.
!

test403_StyleAsString:aRequest
    "Example with setting style as css-string to be in an html-style-element."

    |document head stream|

    document := Document newStrict.

    head     := document getHead.

    stream   := WriteStream on:String new.
    stream nextPutLine: 'h2{color: red;}'.
    stream nextPutLine: 'h3{color: blue;}'.

    head addStyle:stream contents.

    document addHeading2:'Heading2 colored with css-style as text.'.
    document addHeading3:'Heading3 colored with css-style as text.'.


    aRequest nextPutLine:document htmlString.
!

test421_Style_Color:aRequest
    "Example for setting different colors via style-sheet(CSS)."

    |document table row cell colors|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    colors   := OrderedCollection new.
    colors add:CSS_Color newAqua.
    colors add:CSS_Color newBlack.
    colors add:CSS_Color newBlue.
    colors add:CSS_Color newFuchsia.
    colors add:CSS_Color newGray.
    colors add:CSS_Color newGreen.
    colors add:CSS_Color newLime.
    colors add:CSS_Color newMaroon.
    colors add:CSS_Color newNavy.
    colors add:CSS_Color newOlive.
    colors add:CSS_Color newPurple.
    colors add:CSS_Color newRed.
    colors add:CSS_Color newSilver.
    colors add:CSS_Color newTeal.
    colors add:CSS_Color newWhite.
    colors add:CSS_Color newYellow.

    colors do:[
	:color|
	cell  := row addCell:color value printString.
	cell style:color.
    ].

    aRequest nextPutLine:document htmlString.
!

test422_Style_BackgroundColor:aRequest
    "Example for setting different background-colors via style-sheet(CSS)."

    |document table row cell colors|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    colors   := OrderedCollection new.
    colors add:CSS_BackgroundColor newAqua.
    colors add:CSS_BackgroundColor newBlack.
    colors add:CSS_BackgroundColor newBlue.
    colors add:CSS_BackgroundColor newFuchsia.
    colors add:CSS_BackgroundColor newGray.
    colors add:CSS_BackgroundColor newGreen.
    colors add:CSS_BackgroundColor newLime.
    colors add:CSS_BackgroundColor newMaroon.
    colors add:CSS_BackgroundColor newNavy.
    colors add:CSS_BackgroundColor newOlive.
    colors add:CSS_BackgroundColor newPurple.
    colors add:CSS_BackgroundColor newRed.
    colors add:CSS_BackgroundColor newSilver.
    colors add:CSS_BackgroundColor newTeal.
    colors add:CSS_BackgroundColor newWhite.
    colors add:CSS_BackgroundColor newYellow.

    colors do:[
	:color|
	cell := row addCell:color value.
	cell style:color.
    ].

    aRequest nextPutLine:document htmlString.
!

test423_Style_BackgroundImage:aRequest
    "Example with style."

    |document image|

    document := Document newStrict.
    image    := CSS_BackgroundImage with:'url(/files/smiley_laugh.gif)'.

    document style:image.

    aRequest nextPutLine:document htmlString.
!

test424_Style_BackgroundAttachment:aRequest
    "Example with repeating background image."

    |document image attach style|

    document := Document newStrict.
    image    := CSS_BackgroundImage with:'url(/files/smiley_laugh.gif)'.
    attach   := CSS_BackgroundAttachment newScroll.

    style := OrderedCollection with:image with:attach.

    document style:style.

    aRequest nextPutLine:document htmlString.
!

test425_Style_BackgroundNoRepeat:aRequest
    "Example with non-repeating background image."

    |document image repeat style|

    document := Document newStrict.
    image    := CSS_BackgroundImage with:'url(/files/smiley_laugh.gif)'.
    repeat   := CSS_BackgroundRepeat newNoRepeat.

    style := OrderedCollection with:image with:repeat.

    document style:style.

    aRequest nextPutLine:document htmlString.
!

test426_Style_BackgroundXRepeat:aRequest
    "Example with horizontal repeating background image."

    |document image repeat style|

    document := Document newStrict.
    image    := CSS_BackgroundImage with:'url(/files/smiley_laugh.gif)'.
    repeat   := CSS_BackgroundRepeat newRepeatX.

    style := OrderedCollection with:image with:repeat.

    document style:style.

    aRequest nextPutLine:document htmlString.
!

test427_Style_BackgroundYRepeat:aRequest
    "Example with vertical repeating background image."

    |document image repeat style|

    document := Document newStrict.
    image    := CSS_BackgroundImage with:'url(/files/smiley_laugh.gif)'.
    repeat   := CSS_BackgroundRepeat newRepeatY.

    style := OrderedCollection with:image with:repeat.

    document style:style.

    aRequest nextPutLine:document htmlString.
!

test428_Style_BackgroundCenter:aRequest
    "Example for setting a background image centered."

    |document image repeat style center|

    document := Document newStrict.
    image    := CSS_BackgroundImage with:'url(/files/smiley_laugh.gif)'.
    repeat   := CSS_BackgroundRepeat newNoRepeat.
    center   := CSS_BackgroundPosition newCenter.

    style := OrderedCollection with:image with:repeat with:center.

    document style:style.

    aRequest nextPutLine:document htmlString.
!

test433_Style_FontFamily:aRequest
    "Example with font-families set via style-sheet(CSS)."

    |document table row cell families|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    families := OrderedCollection
		    with:CSS_FontFamily newCursive
		    with:CSS_FontFamily newFantasy
		    with:CSS_FontFamily newMonospace
		    with:CSS_FontFamily newSansSerif
		    with:CSS_FontFamily newSerif.

    families do:[
	:family|
	cell  := row addCell:family value printString.
	cell style:family.
    ].

    aRequest nextPutLine:document htmlString.
!

test434_Style_FontSize:aRequest
    "Example with font-sizes set via style-sheet(CSS)."

    |document table row cell sizes|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    sizes    := OrderedCollection
		    with:CSS_FontSize newXLarge
		    with:CSS_FontSize newLarge
		    with:CSS_FontSize newMedium
		    with:CSS_FontSize newSmall
		    with:CSS_FontSize newXSmall
		    with:CSS_FontSize newXXSmall.

    sizes do:[
	:size|
	cell  := row addCell:size value printString.
	cell style:size.
    ].

    aRequest nextPutLine:document htmlString.
!

test435_Style_FontStyle:aRequest
    "Example with font-styles set via style-sheet(CSS)."

    |document table row cell styles|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    styles   := OrderedCollection
		    with:CSS_FontStyle newNormal
		    with:CSS_FontStyle newItalic
		    with:CSS_FontStyle newOblique.

    styles do:[
	:style|
	cell := row addCell:style value printString.
	cell style:style.
    ].

    aRequest nextPutLine:document htmlString.
!

test436_Style_FontVariant:aRequest
    "Example with font-variants set via style-sheet(CSS)."

    |document table row cell variants|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    variants := OrderedCollection
		    with:CSS_FontVariant newNormal
		    with:CSS_FontVariant newSmallCaps.

    variants do:[
	:style|
	cell := row addCell:style value printString.
	cell style:style.
    ].

    aRequest nextPutLine:document htmlString.
!

test437_Style_FontWeight:aRequest
    "Example with font-weights set via style-sheet(CSS)."

    |document table row cell weights|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    weights := OrderedCollection new.
    weights add:CSS_FontWeight newNormal.
    weights add:CSS_FontWeight newBold.
    weights add:CSS_FontWeight newBolder.
    weights add:CSS_FontWeight newLighter.
    weights add:CSS_FontWeight new100.
    weights add:CSS_FontWeight new200.
    weights add:CSS_FontWeight new300.
    weights add:CSS_FontWeight new400.
    weights add:CSS_FontWeight new500.
    weights add:CSS_FontWeight new600.
    weights add:CSS_FontWeight new700.
    weights add:CSS_FontWeight new800.
    weights add:CSS_FontWeight new900.

    weights do:[
	:weight|
	cell := row addCell:weight value printString.
	cell style:weight.
    ].

    aRequest nextPutLine:document htmlString.
!

test441_Style_TextWordSpacing:aRequest
    "Example with font-weights set via style-sheet (css)."

    |document spacings|

    document := Document newStrict.

    spacings := OrderedCollection
		    with:CSS_WordSpacing newNormal
		    with:(CSS_WordSpacing with:'3px')
		    with:(CSS_WordSpacing with:'.4em').

    spacings do:[
	:spacing|
	|paragraph|
	paragraph := document addParagraph:'This is a text with word-spacing: ', spacing value printString, '.'.
	paragraph style:spacing.
    ].

    aRequest nextPutLine:document htmlString.
!

test442_Style_TextLetterSpacing:aRequest
    "Example for text spacing done via style-sheet(CSS)."

    |document spacings|

    document := Document newStrict.

    spacings := OrderedCollection
		    with:CSS_LetterSpacing newNormal
		    with:(CSS_LetterSpacing with:'3px')
		    with:(CSS_LetterSpacing with:'.4em').

    spacings do:[
	:spacing|
	|paragraph|
	paragraph := document addParagraph:'This text is with spacing: ', spacing value printString, '. '.
	paragraph style:spacing.
    ].

    aRequest nextPutLine:document htmlString.
!

test443_Style_TextLineHeight:aRequest
    "Example setting the line height via style-sheet(CSS).
     To make the lines visible a border is added."

    |document border heights|

    document := Document newStrict.

    heights := OrderedCollection
		   with:CSS_LineHeight newNormal
		   with:(CSS_LineHeight with:2)
		   with:(CSS_LineHeight with:'220%').

    border := CSS_Border with:'1px dotted gray'.

    heights do:[
	:height|
	|paragraph|
	paragraph := document addParagraph:'This is line height: ', height value printString, '.'.
	paragraph style:(Array with:height with: border).
    ].

    aRequest nextPutLine:document htmlString.
!

test444_Style_TextAlignment:aRequest
    "Example for text-alignment done via style-sheet(CSS)."

    |text document weights|

    text := 'This is a real Paragraph!! '.
    4 timesRepeat:[text := text, text].

    document := Document newStrict.

    weights  := OrderedCollection
		    with:CSS_TextAlignment newLeft
		    with:CSS_TextAlignment newRight
		    with:CSS_TextAlignment newCenter
		    with:CSS_TextAlignment newJustify.

    weights do:[
	:weight|
	|paragraph|
	paragraph := document addParagraph:text.
	paragraph style:weight.
    ].

    aRequest nextPutLine:document htmlString.
!

test445_Style_TextDecoration:aRequest
    "Example for text-decoration set via style-sheet(CSS)."

    |document table row decorations|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    decorations := OrderedCollection
		       with: CSS_TextDecoration newNone
		       with: CSS_TextDecoration newUnderline
		       with: CSS_TextDecoration newOverline
		       with: CSS_TextDecoration newLinethrough
		       with: CSS_TextDecoration newBlink.

    decorations do:[
	:decoration|
	|cell|
	cell := row addCell:decoration value printString.
	cell style:decoration.
    ].

    aRequest nextPutLine:document htmlString.
!

test446_Style_TextIndentation:aRequest
    "Example for idententation done via style-sheet(CSS).
     AN ident is possible to set via percentage, pixel or metric length."

    |text document indents|

    text     := 'This is an indented Paragraph!! '.

    document := Document newStrict.

    indents := OrderedCollection
		   with:(CSS_TextIndentation with:'10%')
		   with:(CSS_TextIndentation with:'120px')
		   with:(CSS_TextIndentation with:'5cm').

    indents do:[
	:indent|
	|paragraph|
	paragraph := document addParagraph:text.
	paragraph style:indent.
    ].

    aRequest nextPutLine:document htmlString.
!

test447_Style_TextTransformation:aRequest
    "Example for text-transformation set via style-sheet(CSS)."

    |document table row transformations|

    document := Document newStrict.
    table    := document addTable.
    row      := table    addRow.

    transformations := OrderedCollection
			   with:CSS_TextTransformation newNone
			   with:CSS_TextTransformation newCapitalize
			   with:CSS_TextTransformation newUppercase
			   with:CSS_TextTransformation newLowercase.

    transformations do:[
	:transformation|
	|cell|
	cell := row addCell:transformation value printString.
	cell style:transformation.
    ].

    aRequest nextPutLine:document htmlString.
!

test448_Style_TextVerticalAlignment:aRequest
    "Example for vertical alignment of text set via style-sheet(CSS)."

    |document aligns|

    document := Document newStrict.

    aligns := OrderedCollection
		  with: CSS_VerticalAlignment newBaseline
		  with: CSS_VerticalAlignment newBottom
		  with: CSS_VerticalAlignment newMiddle
		  with: CSS_VerticalAlignment newSub
		  with: CSS_VerticalAlignment newSuper
		  with: CSS_VerticalAlignment newTextBottom
		  with: CSS_VerticalAlignment newTextTop
		  with: CSS_VerticalAlignment newTop.

    aligns do:[
	:align|
	|span|
	span := document addSpan:align value printString.
	span style:align.
    ].

    aRequest nextPutLine:document htmlString.
!

test451_Style_BoxFloat:aRequest
    "Example with text floating around boxes, done via style-sheet(CSS).
     To make the boxes visible we set solid and have margin and padding."

    |text document color border margin padding style floats|

    "Just generate some long long example text."
    text := 'This is some text floating around abox!! '.
    4 timesRepeat:[text := text, text].

    document := Document newStrict.

    margin  := CSS_Margin  with:'10px'.
    padding := CSS_Padding with:'5px'.
    color   := CSS_Color newBlue.
    border  := CSS_Border with:'1px solid black'.

    floats  := OrderedCollection
		   with:CSS_Float newLeft
		   with:CSS_Float newRight
		   with:CSS_Float newNone.

    floats do:[
	:float|
	|div|
	div   := document addDiv:float value printString.
	style := OrderedCollection
		     with:margin
		     with:padding
		     with:float
		     with:color
		     with:border.

	div style:style.

	div := document addDiv:text.
	div style:CSS_TextAlignment newJustify.
    ].


    aRequest nextPutLine:document htmlString.
!

test452_Style_BorderColor:aRequest
    "Example with setting different border-widths via style-sheet(CSS).
     To show the border it is necessary to set the border solid.
     It is also useful to set margin and padding to have distance
     inbetween the lines and to keep text readable."

    |document colors border margin padding |
    document := Document newStrict.
    border   := CSS_BorderStyle newSolid.
    margin   := CSS_Margin      with:'5px'.
    padding  := CSS_Padding     with:'2px'.

    colors   := OrderedCollection new.
    colors add:CSS_BorderColor newAqua.
    colors add:CSS_BorderColor newBlack.
    colors add:CSS_BorderColor newBlue.
    colors add:CSS_BorderColor newFuchsia.
    colors add:CSS_BorderColor newGray.
    colors add:CSS_BorderColor newGreen.
    colors add:CSS_BorderColor newLime.
    colors add:CSS_BorderColor newMaroon.
    colors add:CSS_BorderColor newNavy.
    colors add:CSS_BorderColor newOlive.
    colors add:CSS_BorderColor newPurple.
    colors add:CSS_BorderColor newRed.
    colors add:CSS_BorderColor newSilver.
    colors add:CSS_BorderColor newTeal.
    colors add:CSS_BorderColor newWhite.
    colors add:CSS_BorderColor newYellow.

    colors do:[
	:color|
	|div style|
	div := document addDiv:color value printString.

	style := Array
		     with:color
		     with:border
		     with:margin
		     with:padding.

	div style:style.
    ].


    aRequest nextPutLine:document htmlString.
!

test453_Style_BorderColorMixed:aRequest
    "Example with setting different border-colors via style-sheet(CSS).
     To show the border it is necessary to set the border solid.
     It is also useful to set margin and padding to have distance
     inbetween the lines and to keep text readable."

    |document border color div style|
    document := Document newStrict.
    border   := CSS_BorderStyle newSolid.

    color    := CSS_BorderColor
		    top:    #red
		    right:  #green
		    bottom: #blue
		    left:   #aqua.

    div      := document addDiv:(color value asStringWith:$ ).

    style    := Array
		    with:   color
		    with:   border.

    div style:style.


    aRequest nextPutLine:document htmlString.
!

test454_Style_BorderColorMixed2:aRequest
    "Example with setting different border-colors via style-sheet(CSS).
     To show the border it is necessary to set the border solid.
     It is also useful to set margin and padding to have distance
     inbetween the lines and to keep text readable."

    |document border margin padding width div style|
    document := Document newStrict.
    border   := CSS_BorderStyle newSolid.
    margin   := CSS_Margin      with:'5px'.
    padding  := CSS_Padding     with:'2px'.

    div      := document addDiv:width value printString.

    width    := CSS_BorderColor
		    top:    #red
		    right:  #blue.


    style    := Array
		    with:   width
		    with:   border
		    with:   margin
		    with:   padding.

    div style:style.


    aRequest nextPutLine:document htmlString.
!

test456_Style_BorderWidth:aRequest
    "Example with setting different border-widths via style-sheet(CSS).
     To show the border it is necessary to set the border solid.
     It is also useful to set margin and padding to have distance
     inbetween the lines and to keep text readable."

    |document widths border margin padding |
    document := Document newStrict.
    border   := CSS_BorderStyle newSolid.
    margin   := CSS_Margin      with:'5px'.
    padding  := CSS_Padding     with:'2px'.

    widths   := OrderedCollection
		    with:CSS_BorderWidth newThick
		    with:CSS_BorderWidth newMedium
		    with:CSS_BorderWidth newThin.

    widths do:[
	:width|
	|div style|
	div := document addDiv:width value printString.

	style := Array
		     with:width
		     with:border
		     with:margin
		     with:padding.

	div style:style.
    ].


    aRequest nextPutLine:document htmlString.
!

test457_Style_BorderWidthMixed:aRequest
    "Example with setting different border-widths via style-sheet(CSS).
     To show the border it is necessary to set the border solid.
     It is also useful to set margin and padding to have distance
     inbetween the lines and to keep text readable."

    |document border margin padding width div style|
    document := Document newStrict.
    border   := CSS_BorderStyle newSolid.
    margin   := CSS_Margin      with:'5px'.
    padding  := CSS_Padding     with:'2px'.

    width    := CSS_BorderWidth
		    top:    '1px'
		    right:  '2px'
		    bottom: '3px'
		    left:   '4px'.

    div      := document addDiv:(width value asStringWith:$ ).

    style    := Array
		    with:   width
		    with:   border
		    with:   margin
		    with:   padding.

    div style:style.


    aRequest nextPutLine:document htmlString.
!

test458_Style_BorderStyle:aRequest
    "Example with setting different border-styles via style-sheet(CSS)."

    |document styles|
    document := Document newStrict.

    styles := OrderedCollection new.
    styles add:CSS_BorderStyle newDashed.
    styles add:CSS_BorderStyle newDotted.
    styles add:CSS_BorderStyle newDouble.
    styles add:CSS_BorderStyle newGroove.
    styles add:CSS_BorderStyle newInset.
    styles add:CSS_BorderStyle newNone.
    styles add:CSS_BorderStyle newOutset.
    styles add:CSS_BorderStyle newRidge.
    styles add:CSS_BorderStyle newSolid.


    styles do:[
	:style| |div|

	document addLineBreak.

	div := document addDiv:style value printString.

	div style:style.
    ].


    aRequest nextPutLine:document htmlString.
!

test459_Style_BorderStyleMixed:aRequest
    "Example with setting different border-styles via style-sheet(CSS).
     To show the border it is necessary to set the border solid."

    |document border width div style|
    document := Document newStrict.
    border   := CSS_BorderStyle newSolid.

    style    := CSS_BorderStyle
		    top:    #double
		    right:  #dotted
		    bottom: #dashed
		    left:   #solid.

    div      := document addDiv:(style value asStringWith:$ ).

    style    := Array
		    with:   width
		    with:   border.

    div style:style.


    aRequest nextPutLine:document htmlString.
!

test471_Style_SingleMargins:aRequest
    "Example with setting different single-side-margins via style-sheet(CSS).
     To show the border it is necessary to set the border solid.
     The outside box is shown by a second gray contour."

    |document margins border width|
    document := Document newStrict.
    border   := CSS_BorderStyle newSolid.
    width    := CSS_BorderWidth newThin.

    margins  := OrderedCollection
		    with:CSS_TopMargin     newAuto
		    with:(CSS_TopMargin    with:'10px')
		    with:(CSS_BottomMargin with:'5mm')
		    with:(CSS_BottomMargin with:'10%')
		    with:(CSS_LeftMargin   with:'2%')
		    with:(CSS_LeftMargin   with:'20pc')
		    with:(CSS_RightMargin  with:'5%')
		    with:(CSS_RightMargin  with:'10em').

    margins do:[
	:margin|
	|box div style|
	document addLineBreak.
	box := document addDiv.
	box style:'border-style:dotted;border-width:thin;color:gray'.

	div := box addDiv:margin value printString.

	style := Array with:margin
		       with:border
		       with:width
		       with:'color:black'.

	div style:style.
    ].


    aRequest nextPutLine:document htmlString.
!

test472_Style_SinglePaddings:aRequest
    "Example with setting different single-side-paddings via style-sheet(CSS).
     To show the border it is necessary to set the border solid"

    |document paddings border width|
    document := Document newStrict.
    border   := CSS_BorderStyle newSolid.
    width    := CSS_BorderWidth newThin.

    paddings := OrderedCollection
		    with:CSS_TopPadding     newAuto
		    with:(CSS_TopPadding    with:'10px')
		    with:(CSS_BottomPadding with:'5mm')
		    with:(CSS_BottomPadding with:'10%')
		    with:(CSS_LeftPadding   with:'2%')
		    with:(CSS_LeftPadding   with:'20pc')
		    with:(CSS_RightPadding  with:'5%')
		    with:(CSS_RightPadding  with:'10em').

    paddings do:[
	:padding|
	|div style|

	document addLineBreak.

	div := document addDiv:padding value printString.

	style := Array with:padding
		       with:border
		       with:width.

	div style:style.
    ].


    aRequest nextPutLine:document htmlString.
!

test481_Style_Positioning:aRequest
    "Example from 'http://selfhtml.teamone.de/css/eigenschaften/positionierung.htm'.
     Positiononing various elements."

    |document boxes head body backgrounds colors|
    document    := Document new.
    backgrounds := #(#red #blue #yellow #gold #lime #red).
    colors      := #(#blue #white #red #green #navy #blue).

    boxes := (1 to:6) collect:[
		 :index|
		 |top left width height properties|

		 top      := CSS_Top    with:((index * 30) printString, 'px').
		 left     := CSS_Left   with:((index * 30) printString, 'px').
		 width    := CSS_Width  with:(120 printString, 'px').
		 height   := CSS_Height with:(100 printString, 'px').

		 properties := OrderedCollection
				   with:CSS_Position newAbsolute
				   with:top
				   with:left
				   with:width
				   with:height.

		 CSS_StyleElement
		     selectors:  ('#box', index printString)
		     properties: properties
	     ].

    head  := document getHead.
    head addStyle:boxes.

    body := document getBody.

    boxes doWithIndex:[
	:box :index|
	|name div background border|
	name := 'box', index printString.
	div  := body addDiv:name.

	background := CSS_BackgroundColor with:(backgrounds at:index).

	border     := CSS_Border
			  with:#solid
			  with:'2px'
			  with:(colors at:index).

	div id:name.

	div style:  (Array with:border
			   with:background).
    ].

    aRequest nextPutLine:document htmlString.
!

test511_Direkt_Positioning:aRequest
    "Position a paragraph directly, without using a css-object
     by talking to html-object directly, that will build the
     necessary css-objects implicitely"

    |document paragraph|
    document := Document new.

    paragraph := document addParagraph:'This is a directly positioned Text.'.

    paragraph atPosition:50@30.


    aRequest nextPutLine:document htmlString.
!

test512_Direkt_Positioning:aRequest
    "Position a paragraph directly, without using a css-object
     by talking to html-object directly, that will build the
     necessary css-objects implicitely"

    |document paragraph|
    document := Document new.

    paragraph := document addParagraph:'This is a directly positioned Text.'.

    paragraph bounds:(50@30 extent:100@40).


    aRequest nextPutLine:document htmlString.
!

test513_Direkt_Border:aRequest
    "Set border attributes directly to the html-object
     without using any css-object. The css-object will
     be generated implicitely."

    |document paragraph|
    document := Document new.

    paragraph := document addParagraph:'This is a directly bordered Text.'.

    paragraph borderColor:Color red.
    paragraph borderWidth:2.
    paragraph borderStyle:#solid.

    aRequest nextPutLine:document htmlString.
!

test514_Direkt_PaddingMargin:aRequest
    "Set border attributes directly to the html-object
     without using any css-object. The css-object will
     be generated implicitely."

    |document paragraph|
    document := Document new.

    paragraph := document addParagraph:'This is a directly bordered Text with padding and margin.'.

    paragraph borderColor:Color red.
    paragraph borderWidth:2.
    paragraph borderStyleSolid.
    paragraph padding:'1cm'.
    paragraph margin:'1cm'.

    aRequest nextPutLine:document htmlString.
!

test515_Direkt_Special:aRequest
    "Set border attributes directly to the html-object
     without using any css-object. The css-object will
     be generated implicitely."

    |document bounds offset extent width slim slimColor div|
    document  := Document new.
    offset    := 60@60.
    extent    := 200@200.
    bounds    := offset extent:extent.
    width     := 16.
    slim      := 2.
    slimColor := Color yellow.

    div       := document addDiv.
    div borderStyleSolid.
    div borderColor:Color red.
    div borderWidth:width.
    div bounds:bounds.

    div := document addDiv.
    div borderStyleDotted.
    div borderColor:Color black.
    div borderWidth:width.
    div bounds:bounds.

    div := document addDiv.
    div borderStyleDotted.
    div borderColor:slimColor.
    div borderWidth:2.
    div bounds:((offset + (0.5 * width asPoint) - (0.5 * slim asPoint)) extent:(extent + width asPoint - (slim asPoint))).

    div := document addDiv.
    div borderStyleDotted.
    div borderColor:slimColor.
    div borderWidth:2.
    div bounds:((offset + (0.25 * width asPoint) - (0.5 * slim asPoint)) extent:(extent + (1.5 * width asPoint) - (slim asPoint))).

    div := document addDiv.
    div borderStyleDotted.
    div borderColor:slimColor.
    div borderWidth:2.
    div bounds:((offset + (0.75 * width asPoint) - (0.5 * slim asPoint)) extent:(extent + (0.5 * width asPoint) - (slim asPoint))).

    aRequest nextPutLine:document htmlString.
!

test516_Direkt_Special:aRequest
    "Set border attributes directly to the html-object
     without using any css-object. The css-object will
     be generated implicitely."

    |document bounds offset extent width div|
    document := Document new.
    offset   := 50@50.
    extent   := 40@40.
    bounds   := offset extent:extent.
    width    := 12.

    div       := document addDiv.
    div borderStyleDouble.
    div borderColorTeal.
    div borderWidth:width.
    div bounds:bounds.

    div := document addDiv.
    div borderStyleGroove.
    div borderColorAqua.
    div borderWidth:width.
    div bounds:bounds.


    aRequest nextPutLine:document htmlString.
!

test517_Direkt_Special:aRequest
    "Set border attributes directly to the html-object
     without using any css-object. The css-object will
     be generated implicitely."

    |document bounds width background div|
    document   := Document new.
    background := document addDiv.
    background backgroundColor:Color lightGray.
    background atPosition:0@0.
    background width:'100%'.
    background height:'100%'.

    bounds   := 50@50 extent:160@40.
    width    := 2.

    div := background addDiv:'This looks like a button.'.
    div padding:'10px'.
    div borderStyleOutset.
    div borderColorGray.
    div borderWidth:width.
    div bounds:bounds.

    bounds := 50@160 extent:160@40.

    div := background addDiv:'The same pressed.'.
    div padding:'10px'.
    div borderStyleInset.
    div borderColorGray.
    div borderWidth:width.
    div bounds:bounds.


    aRequest nextPutLine:document htmlString.
! !

!TestService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/tests/HTML_TestService.st,v 1.47 2007/03/13 14:31:49 cg Exp $'
! !
