"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/webServer/htmlTree/tests' }"

"{ NameSpace: HTML }"

TestCase subclass:#Testcase_ModelTree
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-Testcase'
!

!Testcase_ModelTree class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
     documentation to be added.

    [author:]
	Martin Walser

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!Testcase_ModelTree methodsFor:'tests'!

test001AbstractElementDeliversAllElements
    "Check the methods to deliver at last
     the element implementing classes."

    self assert:(AbstractHTMLElement allSubclasses notEmptyOrNil).
    self assert:(AbstractHTMLElement allConcreteSubclasses notEmptyOrNil).
    self assert:(AbstractHTMLElement allElementImplementingClasses notEmptyOrNil).


    "
    self new test001AbstractElementDeliversAllElements.
    self run:#test001AbstractElementDeliversAllElements
    "
!

test011AllElementsHaveTagName
    "Check all elements to have a tag name."

    AbstractHTMLElement allElementImplementingClasses do:[
	:class|
	|tagName|

	"It shall be implemented in each classe,
	 inheritance from upper class does not interest!!"
	self assert:(class class implements:#tagName).

	"Calling it to see it working."
	tagName := class tagName.

	self assert:tagName isString.
	self assert:tagName notEmpty.
    ].

    "
    self new test011AllElementsHaveTagName.
    self run:#test011AllElementsHaveTagName
    "
!

test012AllElementsHaveVisitMethod
    "Check all elements to have a '#visit:' method."

    AbstractHTMLElement allConcreteSubclasses do:[
	:class|

	self assert:(class whichClassIncludesSelector:#visit:) notNil.
	self assert:(class whichClassIncludesSelector:#visit:) ~~ AbstractElement.
    ].

    "
    self new test012AllElementsHaveVisitMethod.
    self run:#test012AllElementsHaveVisitMethod.
    "
!

test020CanAddChildFromClass
    "Check for all elements to be
     able to add a new element
     by giving a target-class."

    "/ cg: this ''test'' is pure garbage - it is definitely NOT allowed
    "/ to add the same type of element to every type of element
    "/ (for example: a head may not contain another head or a body...)

"/    AbstractHTMLElement allSubclasses do:[
"/        :class|
"/        |parent child|
"/
"/        parent := class new.
"/        parent addElement:class.
"/
"/        child := parent children first.
"/
"/        self assert:child isClass not.
"/        self assert:child class == class.
"/    ].

    |parent child|

    parent := Div new.
    parent addElement:Div.

    child := parent children first.

    self assert:child isClass not.
    self assert:child class == Div.

    "
     self new test020CanAddChildFromClass.
     self run:#test020CanAddChildFromClass
    "
!

test021CheckingForParent
    "Check all types of elments to hold the parent."

    "/ cg: this ''test'' is pure garbage - it is definitely NOT allowed
    "/ to add the same type of element to every type of element
    "/ (for example: a head may not contain another head or a body...)

"/    AbstractHTMLElement allSubclasses do:[
"/        :class|
"/        |parent child|
"/
"/        parent := class new.
"/
"/        "Add a child of the same type."
"/        child := parent addElement:class.
"/
"/        self assert:(parent == child parent).
"/        self assert:(parent children includes:child)
"/    ].

    |parent child|

    parent := Div new.

    "Add a child of the same type."
    child := parent addElement:Div.

    self assert:(parent == child parent).
    self assert:(parent children includes:child)

    "
    self new test020CanAddChildFromClass.
    self run:#test020CanAddChildFromClass
    "
!

test030BuildingNewElement
    "Check for all elements to be
     able to build a new element with:
	nil, string, html-element."

    AbstractElement allSubclasses do:[
	:class|
	|element|

	"Raw data is nil."
	element := class new buildElement:nil ofType:class.
	self assert: element class == class.

	"Raw data class is fitting."
	element := class new buildElement:class new ofType:class.
	self assert: element class == class.

	"Raw data is string."
	element := class new buildElement:'test' ofType:class.
	self assert: element class == class.
	self assert: element children first = 'test'.

    ].

    "
    self new test030BuildingNewElement.
    self run:#test030BuildingNewElement
    "
!

test040AlienElement
    "Check if alien elements can be added"

    |element|

    element := Document new.

    element addChild:(Structure with:(#foo->'foo')).
    "/ element inspect

    "
    self new test040AlienElement.
    self run:#test040AlienElement
    "
! !

!Testcase_ModelTree class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/tests/HTML_Testcase_ModelTree.st,v 1.10 2007/03/13 15:14:30 cg Exp $'
! !
