"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer/htmlTree/tests' }"

"{ NameSpace: HTML }"

TestCase subclass:#Testcase_Style
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-Testcase'
!

!Testcase_Style class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    documentation to be added.

    [author:]
	Martin Walser

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!Testcase_Style methodsFor:'tests'!

test001AbstractStylePropertyDeliversAllConcreteElements
    "Check the methods to deliver at last
     the element implementing classes."

    self assert:(CSS_AbstractStyleProperty allSubclasses notEmptyOrNil).
    self assert:(CSS_AbstractStyleProperty allConcreteSubclasses notEmptyOrNil).


    "
    self new test001AbstractStylePropertyDeliversAllConcreteElements.
    self run:#test001AbstractStylePropertyDeliversAllConcreteElements

    "
!

test011AllElementsHaveKeyName
    "Check all elements to have a tag name."

    CSS_AbstractStyleProperty allConcreteSubclasses do:[
	:class|
	|keyName|

	"It shall be implemented in each classe,
	 inheritance from upper class does not interest!!"
	self assert:(class class implements:#keyName).

	"Calling it to see it working."
	keyName := class keyName.

	self assert:keyName isString.
	self assert:keyName notEmpty.
    ].

    "
    self new test011AllElementsHaveKeyName.
    self run:#test011AllElementsHaveKeyName
    "
!

test012AllElementsHaveVisitMethod
    "Check all elements to have a '#visit:' method."

    CSS_AbstractStyleProperty allConcreteSubclasses do:[
	:class|

	"It shall be implemented in each classe,
	 inheritance from upper class does not interest!!"
	self assert:(class implements:#visit:).
    ].

    "
    self new test012AllElementsHaveVisitMethod.
    self run:#test012AllElementsHaveVisitMethod.
    "
!

test013EncoderHasVisitingMethodForAllElements
    "Check if the encoder has a correct named
     visiting method for all elements."

    |encoder|

    encoder := StyleEncoder new.

    CSS_AbstractStyleProperty allConcreteSubclasses do:[
	:class|

	"This '#visit:' will call the concrete
	 '#visit...'-method in the encoder."
	class new visit: encoder.
    ].

    "
    self new test013EncoderHasVisitingMethodForAllElements.
    self run:#test013EncoderHasVisitingMethodForAllElements
    "
!

test014VisitorsVisitingNameConformsClassName
    "Check if the encoder for visitors has a
     correct visiting method for all elements."


    CSS_AbstractStyleProperty allConcreteSubclasses do:[
	:class|
	|className methodName|

	className  := class nameWithoutPrefix, ':'.

	self assert:(className beginsWith:'CSS_').

	methodName := 'visit', (className copyFrom:5). "Remove CSS_"

	self assert:(StyleVisitor implements:methodName asSymbol).
    ].

    "
    self new test014VisitorsVisitingNameConformsClassName.
    self run:#test014VisitorsVisitingNameConformsClassName
    "
!

test021StyleGeneratedAsAttribute
    ""

    |document heading attributes style|

    document := Document newStrict.

    heading  := document addHeading2:'text'.
    heading style:CSS_Color newRed.

    attributes := heading attributes.
    self assert:(attributes notNil).
    self assert:(attributes notEmpty).

    style := attributes at:#style.
    self assert:(style notNil).
    self assert:(style class == CSS_Color).
    self assert:(style value == #red).

    self assert:(style htmlString = 'color: red;').

    self assert:(heading htmlString beginsWith:'<h2 style=').


    "
    self new test021StyleGeneratedAsAttribute.
    self run:#test021StyleGeneratedAsAttribute
    "
!

test022StyleGeneratedAsElement
    ""

    |document head heading children style property|

    document := Document newStrict.

    head     := document getHead.

    heading   := CSS_StyleElement
		    selectors: #h2
		    properties:(OrderedCollection with:CSS_Color newRed).

    head addStyle:(Array with:heading).

    self assert:(head notNil).
    self assert:(head class == Head).

    children := head children.
    self assert:(children notNil).
    self assert:(children notEmpty).
    style := children first.
    self assert:(style notNil).
    self assert:(style class == Style).

    children := style children.
    self assert:(children notNil).
    self assert:(children notEmpty).
    style := children first.
    self assert:(style notNil).
    self assert:(style class == CSS_StyleElement).
    style htmlString beginsWith:'h2{'.
    style htmlString endsWith:'}'.

    children := style properties.
    self assert:(children notNil).
    self assert:(children notEmpty).
    property := children first.
    self assert:(property notNil).
    self assert:(property class == CSS_Color).
    self assert:(property value == #red).

    self assert:(property htmlString withoutSpaces = 'color: red;'withoutSpaces).

    "
    self new test022StyleGeneratedAsElement.
    self run:#test022StyleGeneratedAsElement
    "
!

test023StyleGeneratedAsString
    ""

    |document head string1 string2 string stream children style|

    string1  := 'h2{color: red;}'.
    string2  := 'h3{color: blue;}'.

    document := Document newStrict.
    head     := document getHead.

    stream   := WriteStream on:String new.
    stream nextPutLine:string1.
    stream nextPutLine:string2.

    string := stream contents.

    head addStyle:string.

    self assert:(head notNil).
    self assert:(head class == Head).

    children := head children.
    self assert:(children notNil).
    self assert:(children notEmpty).
    style := children first.
    self assert:(style notNil).
    self assert:(style class == Style).

    children := style children.
    self assert:(children notNil).
    self assert:(children notEmpty).
    style := children first.
    self assert:(style = string).



    "
    self new test023StyleGeneratedAsString.
    self run:#test023StyleGeneratedAsString
    "
! !

!Testcase_Style class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/tests/HTML_Testcase_Style.st,v 1.6 2007/03/13 14:29:06 cg Exp $'
! !
