"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer/htmlTree/tests' }"

"{ NameSpace: HTML }"

TestCase subclass:#Testcase_Style_MultiValues
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Documents-Testcase'
!

!Testcase_Style_MultiValues class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    documentation to be added.

    [author:]
	Martin Walser

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!Testcase_Style_MultiValues methodsFor:'tests'!

test011ValueExpansion
    "Test with given three sides to fulfill fourth side with second side."

    |first second third start margin result|

    first  := '1em'.
    second := '2em'.
    third  := '3em'.
    start  := OrderedCollection with:first with:second with:third.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin expandTo4.

    result := margin value.
    self assert:(result size == 4).
    self assert:(result second == result fourth).
    self assert:(result first  == first).
    self assert:(result second == second).
    self assert:(result third  == third).


    "
    self new test011ValueExpansion.
    self run:#test011ValueExpansion
    "
!

test012ValueExpansion
    "Test with two sides to fulfill 1 -> 3 and 2 -> 4."

    |first second start margin result|

    first  := '1em'.
    second := '2em'.
    start  := OrderedCollection with:first with:second.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin expandTo4.

    result := margin value.
    self assert:(result size == 4).
    self assert:(result first  == result third).
    self assert:(result second == result fourth).
    self assert:(result first  == first).
    self assert:(result second == second).


    "
    self new test012ValueExpansion.
    self run:#test012ValueExpansion
    "
!

test013ValueExpansion
    "Test with one side, fill all sides with first value."

    |first start margin result|

    first  := '1em'.
    start  := OrderedCollection with:first.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin expandTo4.

    result := margin value.
    self assert:(result size == 4).
    self assert:(first == result first).
    self assert:(first == result second).
    self assert:(first == result third ).
    self assert:(first == result fourth).

    "
    self new test013ValueExpansion.
    self run:#test013ValueExpansion
    "
!

test014ValueExpansion
    "Test with one side, fill all sides with value."

    |start margin result|

    start := '1em'.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin expandTo4.

    result := margin value.
    self assert:(result size == 4).
    self assert:(start == result first).
    self assert:(start == result second).
    self assert:(start == result third ).
    self assert:(start == result fourth).

    "
    self new test014ValueExpansion.
    self run:#test014ValueExpansion
    "
!

test021ValueNoExpansion
    "Test with given three sides to fulfill fourth side with second side."

    |first second third fourth start margin result|

    first  := '1em'.
    second := '2em'.
    third  := '3em'.
    fourth := '4em'.
    start  := OrderedCollection with:first with:second with:third with:fourth.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin expandTo4.

    result := margin value.
    self assert:(result size == 4).
    self assert:(result first  == first).
    self assert:(result second == second).
    self assert:(result third  == third).
    self assert:(result fourth == fourth).


    "
    self new test021ValueNoExpansion.
    self run:#test021ValueNoExpansion
    "
!

test051ValueReduction
    "Two equal value shall reduce to one."

    |first second start margin result|

    first  := '1em'.
    second := '1em'.
    start  := OrderedCollection with:first with:second.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result isString or:[result isOrderedCollection not]).
    self assert:(result = first).
    self assert:(result = second).


    "
    self new test051ValueReduction.
    self run:#test051ValueReduction
    "
!

test052ValueReduction
    "Three equal value shall reduce to one."

    |first second third start margin result|

    first  := '1em'.
    second := '1em'.
    third  := '1em'.
    start  := OrderedCollection with:first with:second with:third.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result isString or:[result isOrderedCollection not]).
    self assert:(result = first).
    self assert:(result = second).
    self assert:(result = third).


    "
    self new test052ValueReduction.
    self run:#test052ValueReduction
    "
!

test053ValueReduction
    "Four equal value shall reduce to one."

    |first second third fourth start margin result|

    first  := '1em'.
    second := '1em'.
    third  := '1em'.
    fourth := '1em'.
    start  := OrderedCollection with:first with:second with:third with:fourth.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result isString or:[result isOrderedCollection not]).
    self assert:(result = first).
    self assert:(result = second).
    self assert:(result = third).
    self assert:(result = fourth).


    "
    self new test053ValueReduction.
    self run:#test053ValueReduction
    "
!

test054ValueReduction
    "Two equal value shall reduce to one."

    |first second start margin result|

    first  := 1.
    second := 1.
    start  := OrderedCollection with:first with:second.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result isString or:[result isOrderedCollection not]).
    self assert:(result = first).
    self assert:(result = second).


    "
    self new test051ValueReduction.
    self run:#test051ValueReduction
    "
!

test055ValueReduction
    "Three equal value shall reduce to one."

    |first second third start margin result|

    first  := 1.
    second := 1.
    third  := 1.
    start  := OrderedCollection with:first with:second with:third.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result isString or:[result isOrderedCollection not]).
    self assert:(result = first).
    self assert:(result = second).
    self assert:(result = third).


    "
    self new test052ValueReduction.
    self run:#test052ValueReduction
    "
!

test056ValueReduction
    "Four equal value shall reduce to one."

    |first second third fourth start margin result|

    first  := 1.
    second := 1.
    third  := 1.
    fourth := 1.
    start  := OrderedCollection with:first with:second with:third with:fourth.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result isString or:[result isOrderedCollection not]).
    self assert:(result = first).
    self assert:(result = second).
    self assert:(result = third).
    self assert:(result = fourth).


    "
    self new test053ValueReduction.
    self run:#test053ValueReduction
    "
!

test057ValueReduction
    "Three equal value shall reduce to one."

    |first second third fourth start margin result|

    first  := '1em'.
    second := '2em'.
    third  := '1em'.
    fourth := '2em'.
    start  := OrderedCollection with:first with:second with:third with:fourth.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 2).
    self assert:(result first  = first).
    self assert:(result second = second).


    "
    self new test057ValueReduction.
    self run:#test057ValueReduction
    "
!

test058ValueReduction
    "Three equal value shall reduce to one."

    |first second third fourth start margin result|

    first  := '1em'.
    second := '2em'.
    third  := '3em'.
    fourth := '2em'.
    start  := OrderedCollection with:first with:second with:third with:fourth.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 3).
    self assert:(result first  = first).
    self assert:(result second = second).
    self assert:(result third  = third).


    "
    self new test057ValueReduction.
    self run:#test057ValueReduction
    "
!

test059ValueReduction
    "Three equal value shall reduce to one."

    |first second third start margin result|

    first  := '1em'.
    second := '2em'.
    third  := '1em'.
    start  := OrderedCollection with:first with:second with:third .
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 2).
    self assert:(result first  = first).
    self assert:(result second = second).


    "
    self new test059ValueReduction.
    self run:#test059ValueReduction
    "
!

test061ValueNoReduction
    "Two equal value shall reduce to one."

    |first second start margin result|

    first  := '1em'.
    second := '2em'.
    start  := OrderedCollection with:first with:second.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 2).
    self assert:(first  = result first).
    self assert:(second = result second).


    "
    self new test061ValueReduction.
    self run:#test061ValueReduction
    "
!

test062ValueNoReduction
    "Three equal value shall reduce to one."

    |first second third start margin result|

    first  := '1em'.
    second := '2em'.
    third  := '3em'.
    start  := OrderedCollection with:first with:second with:third.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 3).
    self assert:(first  = result first).
    self assert:(second = result second).
    self assert:(third  = result third).


    "
    self new test062ValueNoReduction.
    self run:#test062ValueNoReduction
    "
!

test063ValueNoReduction
    "Four equal value shall reduce to one."

    |first second third fourth start margin result|

    first  := '1em'.
    second := '2em'.
    third  := '3em'.
    fourth := '4em'.
    start  := OrderedCollection with:first with:second with:third with:fourth.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 4).
    self assert:(result first  = first).
    self assert:(result second = second).
    self assert:(result third  = third).
    self assert:(result fourth = fourth).


    "
    self new test063ValueNoReduction.
    self run:#test063ValueNoReduction
    "
!

test064ValueNoReduction
    "Two equal value shall reduce to one."

    |first second start margin result|

    first  := 1.
    second := 2.
    start  := OrderedCollection with:first with:second.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 2).
    self assert:(first  = result first).
    self assert:(second = result second).


    "
    self new test061ValueReduction.
    self run:#test061ValueReduction
    "
!

test065ValueNoReduction
    "Three equal value shall reduce to one."

    |first second third start margin result|

    first  := 1.
    second := 2.
    third  := 3.
    start  := OrderedCollection with:first with:second with:third.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 3).
    self assert:(first  = result first).
    self assert:(second = result second).
    self assert:(third  = result third).


    "
    self new test062ValueNoReduction.
    self run:#test062ValueNoReduction
    "
!

test066ValueNoReduction
    "Four equal value shall reduce to one."

    |first second third fourth start margin result|

    first  := 1.
    second := 2.
    third  := 3.
    fourth := 4.
    start  := OrderedCollection with:first with:second with:third with:fourth.
    margin := CSS_AbstractStylePropertyBox with:start.

    margin reduce.

    result := margin value.
    self assert:(result size == 4).
    self assert:(result first  = first).
    self assert:(result second = second).
    self assert:(result third  = third).
    self assert:(result fourth = fourth).


    "
    self new test063ValueNoReduction.
    self run:#test063ValueNoReduction
    "
! !

!Testcase_Style_MultiValues class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/htmlTree/tests/HTML_Testcase_Style_MultiValues.st,v 1.5 2007/03/13 14:29:06 cg Exp $'
! !
