"{ Package: 'stx:goodies/webServer/pwsSwiki' }"

"{ NameSpace: PWS }"

SwikiAction subclass:#ActiveSwikiAction
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PWS-Swiki'
!


!ActiveSwikiAction methodsFor:'URL processing'!

browse: pageRef from: request
	"Just reply with a page in HTML format"

    | formattedPage liveText|

    liveText _ HTMLformatter 
		   evalEmbedded: (pageRef text)
		   with: request 
		   unlessContains: (self dangerSet).

    formattedPage _ pageRef copy.
    "Make a copy, then format the text."
    formattedPage 
	formatted: (formatter 
			swikify: liveText
			linkhandler: [:link | urlmap
				    linkFor: link
				    from: request peerName
				    storingTo: OrderedCollection new
				    page: formattedPage]).
    request reply: ((self formatterFor: 'page') format: formattedPage).
!

inputFrom: request
    "Take user's input and respond with a searchresult or store the edit"

    | coreRef page theText |

    coreRef _ request message size < 2
	    ifTrue: ['1']
	    ifFalse: [request message at: 2].

    coreRef = 'searchresult' ifTrue: [
	"If contains search string, do search"
	request 
	    reply: HTTPServer crlf;
	    reply: (HTMLformatter 
			evalEmbedded: (self fileContents:source, 'results.html')
			with: (urlmap searchFor: (request fields at: 'searchFor' ifAbsent: ['nothing']))).
	^ #return
    ].

    (theText _ request fields at: 'text' ifAbsent: [nil]) ifNotNil: [
	"It's a response from an edit, so store the page"
	page _ urlmap atID: coreRef.
	page user: request peerName.  "Address is machine, user only if logged in"
	page pageStatus = #new ifTrue: [page pageStatus: #standard].
	page _ urlmap
		storeID: coreRef
		text: (self class withSqueakLineEndings:theText) 
		from: request peerName.
	^ self        "return self means do serve the edited page afterwards"
    ].

    request fields keys do: [:aTag |
	(aTag startsWith: 'text-') ifTrue: [
	    urlmap
		storeID: coreRef
		text: (self class withSqueakLineEndings:(request fields at: aTag))
		insertAt: (aTag copyFrom: 6 to: aTag size).
	    "string"
	    ^ self
	]
    ].
    "oops, a new kind!! -- but don't complain!! Could be for ActivePage!!"
"       
    Transcript show: 'Unknown data from client. '; show: request fields printString; cr.
"

! !

!ActiveSwikiAction methodsFor:'as yet unclassified'!

dangerSet
    ^ #(
	'Smalltalk' 
	'view' 
	'open' 
	'perform:' 
	'FileStream' 
	'FileDirectory' 
	'fileIn' 
	'Compiler' 
	'halt'
	'PWS' 
	'Swiki'
       )
! !

!ActiveSwikiAction class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/pwsSwiki/ActiveSwikiAction.st,v 1.7 2003/03/26 10:30:03 stefan Exp $'
! !
