"{ Package: 'stx:goodies/webServer/pwsSwiki' }"

"{ NameSpace: PWS }"

EmbeddedServerAction subclass:#AuthorizedServerAction
	instanceVariableNames:'authorizer'
	classVariableNames:''
	poolDictionaries:''
	category:'PWS-Swiki'
!

AuthorizedServerAction comment:'An EmbeddedServerAction that also has an Authorizer to verify username and password.'
!


!AuthorizedServerAction methodsFor:'URL processing'!

authorizer
	^authorizer
!

authorizer: anAuthorizer
	authorizer _ anAuthorizer
!

checkAuthorization: request
	^ authorizer user:request userID request:request.

    "Modified: / 30.7.1999 / 13:44:04 / cg"
!

mapName: nameString password: pwdString to: aPerson
	"Insert/remove the username:password combination into/from the users Dictionary.  *** Use this method to add or delete users!!  If you ask for the authorizer and talk to it, the change will not be recorded on the disk!! ***   We use encoding per RFC1421."

	authorizer mapName: nameString password: pwdString to: aPerson.
	self authorizer: authorizer.    "force it to be written to the disk"
		"*** Authorizer not saved to disk yet for this class ***"
! !

!AuthorizedServerAction class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/pwsSwiki/AuthorizedServerAction.st,v 1.6 2003/03/26 10:27:16 stefan Exp $'
! !
