"{ Package: 'stx:goodies/webServer/pwsSwiki' }"

"{ NameSpace: PWS }"

AuthorizedSwikiAction subclass:#AuthorizedWriteSwiki
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PWS-Swiki'
!

AuthorizedWriteSwiki comment:'Allows anyone to read the pages of this Swiki, but only authorized users can edit or change pages.  Can have multiple users, each with a different password.  Each can modify the whole Swiki area.

To restart an existing Authorized Swiki:

	AuthorizedWriteSwiki new restore: ''SWSecure''.

The front page URL is:  http://serverMachine:80/SWSecure.1

To make a completely new one:
	| a s |
	a := Authorizer new.
	a realm: ''SwikiArea''.
	a mapName: ''viki'' password: ''hard2guess'' to: ''viki''.
	AuthorizedWriteSwiki setUp: ''SWSecure''.
	s := AuthorizedWriteSwiki new restore: ''SWSecure''.
	s authorizer: a.
'
!


!AuthorizedWriteSwiki methodsFor:'URL processing'!

process: request
    "Only demand authorization of name and password when requesting the edit page, 
     requesting the append page, receiving an edit, or receiving an append."

    | command coreRef |

    "Are there input fields?"
    request fields ifNotNil: [
	coreRef _ request message size < 2
		ifTrue: ['1']
		ifFalse: [request message at: 2].
	coreRef = 'searchresult' ifFalse: [
	    "Must be text for an edit!!"
	    self checkAuthorization: request
	]
    ].
    request message size > 2 ifTrue:[
	"SearchResult, All, Versions, or Edit"
	command _ request message at: 3.
	(command = 'edit'
	or:[command = 'insert']) ifTrue:[
	    self checkAuthorization: request
	]
    ].

    ^ (self processSpecial: request). "all the way up to SwikiAction"

    "Modified: / 30.7.1999 / 15:55:30 / cg"
! !

!AuthorizedWriteSwiki class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/pwsSwiki/AuthorizedWriteSwiki.st,v 1.9 2003/03/26 10:29:11 stefan Exp $'
! !
