"{ Package: 'stx:goodies/webServer/pwsSwiki' }"

"{ NameSpace: PWS }"

ServerAction subclass:#ChatPage
	instanceVariableNames:'current'
	classVariableNames:''
	poolDictionaries:''
	category:'PWS-Swiki'
!

ChatPage comment:'Simple ServerAction that allows a primitive chat session shown as a web page.  It maintains a list of the 20 most recent submissions.  There is a form on the page for typing your contribution to the session. 

The default Swiki has a chat page enabled.

Get to the page by this URL:
machine:80/chat'
!


!ChatPage methodsFor:'URL processing'!

process: request 
    | author note |

    request fields isNil ifTrue:[
	current isNil ifTrue: [current _ OrderedCollection new].
	request reply: (HTMLformatter 
			    evalEmbedded: (self fileContents: 'chat.html')
			    with: current)
    ] ifFalse:[
	author _ request fields at: 'author'.
	note _ request fields at: 'note'.
	self add: '<b>' , author , '</b> 
	<i>' , Time now printString , '-' , Date today printString , '</i><p>' , note , '<p>'.
	request fields at: 'current' put: current.
	request reply: (HTMLformatter 
			    evalEmbedded: (self fileContents: 'chat.html')
			    with: request)]
! !

!ChatPage methodsFor:'chat processing'!

add: aMessage 
	current isNil ifTrue: [current _ OrderedCollection new].
	current add: aMessage.
	(current size > 20) 
		ifTrue: [current _ current copyFrom: (current size - 20) to: (current size)]
!

current
	^current
! !

!ChatPage class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/pwsSwiki/ChatPage.st,v 1.6 2003/03/26 10:31:05 stefan Exp $'
! !
