"{ Package: 'stx:goodies/webServer/pwsSwiki' }"

"{ NameSpace: PWS }"

Object subclass:#Discussion
	instanceVariableNames:'notes title description relatedURL'
	classVariableNames:''
	poolDictionaries:''
	category:'PWS-Swiki'
!

Discussion comment:'A Discussion has some header information and a collection of related notes.'
!


!Discussion methodsFor:'access'!

addNote: aNote
	notes isNil ifTrue: [notes _ OrderedCollection new.].
	notes add: aNote.
	^notes size
!

at: aKey
	^notes at: aKey
!

at: aKey addNote: aNote
	notes isNil ifTrue: [notes _ Dictionary new.].
	notes at: aKey put: aNote.
!

author
	^self description
!

children
	^#()
!

description
	^description
!

description: aString
	description _ aString
!

notes
	^notes
!

relatedURL
	^relatedURL
!

relatedURL: aString
	relatedURL _ aString
!

status
	| reply |
	reply _ WriteStream on: String new.
	reply nextPutAll: 'Number of notes: ', (notes size printString).
	notes size > 0
		ifTrue: [reply nextPutAll: '. Last note: ',(notes last timestamp).].
	^reply contents
!

timestamp
	^String new:0
!

title
	^title
!

title: aString
	title _ aString
!

url
	"fake the url as the title"
	^'Comment.', self title
! !

!Discussion class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/pwsSwiki/Discussion.st,v 1.5 2003/03/26 10:29:41 stefan Exp $'
! !
