"{ Package: 'stx:goodies/webServer/pwsSwiki' }"

"{ NameSpace: PWS }"

ServerAction subclass:#EmbeddedServerAction
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PWS-Swiki'
!

EmbeddedServerAction comment:'EmbeddedServerAction works like a normal ServerAction, except that it interprets any embedded Smalltalk code (within <? ?> tags, stolen from Microsoft''s notation for a similar capability) and replaces the embedded code with the value returned from the execution of the code.
'
!


!EmbeddedServerAction methodsFor:'URL processing'!

replyTo: pieces from: request
    | theLast |

    (pieces asFilename isReadable
    and:[pieces asFilename isDirectory not]) ifTrue:[
	theLast _ request message last asLowercase.
	theLast = 'gif'  ifTrue: [^ self process: request MIMEtype: 'image/gif'].
	theLast = 'jpeg' ifTrue: [^ self process: request MIMEtype: 'image/jpeg'].
	theLast = 'jpg'  ifTrue: [^ self process: request MIMEtype: 'image/jpeg'].
	theLast = 'jpe'  ifTrue: [^ self process: request MIMEtype: 'image/jpeg'].
	request 
	    replyHeader: HTTPServer success;
	    replyHeader: HTTPServer contentHTML;
	    reply: (HTMLformatter evalEmbedded: 
			(FileStream fileNamed: pieces) contentsOfEntireFile 
			with: request)
    ] ifFalse: [
	request reportNotFound:nil
    ]
! !

!EmbeddedServerAction class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/pwsSwiki/EmbeddedServerAction.st,v 1.8 2003/03/26 10:30:23 stefan Exp $'
! !
