"{ Package: 'stx:goodies/webServer/pwsSwiki' }"

"{ NameSpace: PWS }"

SwikiPage subclass:#PSwikiPage
	instanceVariableNames:'username password privs'
	classVariableNames:''
	poolDictionaries:''
	category:'PWS-Swiki'
!


!PSwikiPage methodsFor:'accessing'!

password
	^password
!

password: aString
	password _ aString
!

privs
	^privs
!

privs: aString
	"Privilege string should contain 'read' or 'write' for what's protected"
	privs _ aString
!

username
	^username
!

username: aName
	username _ aName.
! !

!PSwikiPage methodsFor:'as yet unclassified'!

fromFileNamed: filePath action: aSwikiAction
    "Fill in all parts of this page from the info in its file"

    | theFile |

    map _ aSwikiAction urlmap.
    file _ filePath.
    theFile _ FileStream oldFileNamed: file.
    coreID _ theFile localName.
    url _ aSwikiAction name, '.', coreID.
    username _ ''. password _ ''. privs _ ''.
    self scanFrom: theFile.         "name, date"
    (username size > 1) ifTrue: [
	"Set up the authorization"
	aSwikiAction auth 
	    mapName: username 
	    password: password
	    to: coreID.
    ].
    address _ ''.  "should be page that points at it, but how get that?"
!

name: pageName date: dateString time: timeString by: who authName: aName authPW: thePass privs: thePrivs text: theString back: bytes
    "Record the name of this page during startup.  
     When reading the page in order to serve it, this is NOT executed.  
     The text is read from the file explicitly."
    
    name _ pageName.
    date _ dateString asDate.
    username _ aName.
    password _ thePass.
    privs _ thePrivs.
!

outputFormat
    | formatCollection textBlock |

    "Ah, yes, my first experience with class vars. I need to think about this
     scheme a bit, but it's only a placeholder anyway. BJP"

    formatCollection _ OrderedCollection newFrom: super outputFormat.
    textBlock _ formatCollection last.
    ^ formatCollection
	    add: [:thePage | 'authName: ', thePage username printString, '; ']
	    before: textBlock;

	    add: [:thePage | 'authPW: ', thePage password printString, '; ']
	    before: textBlock;

	    add: [:thePage | 'privs: ', thePage privs printString, '; '] 
	    before: textBlock.
! !

!PSwikiPage class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/pwsSwiki/PSwikiPage.st,v 1.6 2003/03/26 10:27:45 stefan Exp $'
! !
