"{ Package: 'stx:goodies/webServer/pwsSwiki' }"

"{ NameSpace: PWS }"

URLmap subclass:#PURLmap
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'PWS-Swiki'
!


!PURLmap methodsFor:'as yet unclassified'!

allPagesFrom: pageRef for: request
    | formattedPage refPages allPages peer |

    (request isKindOf: HTTPServer) ifTrue: [
	peer _ request peerName
    ] ifFalse:[
	peer _ ''
    ].
    formattedPage _ pageRef copy.  "Make a copy, then format the text."
    refPages _ OrderedCollection new.
    formattedPage 
	formatted: (action formatter 
			swikify: (pageRef text)
			linkhandler: [:link | self linkFor: link
					   from: peer
					   storingTo: refPages]).

    refPages _ refPages reject: [:page | page pageStatus = #new].

    "Now, put all referenced pages into the page"
    allPages _ WriteStream on: String new.
    allPages nextPutAll: '<h2>',(pageRef name),'</h2>', formattedPage formatted.
    refPages do: [:page |
	(page privs includesSubString: 'read') ifTrue:
		[(action auth user: request userID) = page coreID
		ifFalse: [self error: (HTTPServer unauthorizedFor: (page name))]].
	allPages nextPutAll: '<h2>',(page name),'</h2>'.
	allPages nextPutAll:(HTMLformatter 
				swikify: (page text)
				linkhandler: [:link | self linkFor: link
							   from: peer
							   storingTo:(OrderedCollection new)]).
    ].
    formattedPage formatted: allPages contents. "Put all the pages into THE page"
    ^formattedPage
!

newpage:label from:peer
    | newpage newfile |

    newpage _ PSwikiPage new.
    self at: label put: newpage.
    newfile _ pages size printString.
    newpage address: peer.
    newpage date: (Date today).
    newpage coreID: newfile.
    newpage name: label.
    newpage username: ''.
    newpage password: ''.
    newpage privs: ''.
    newpage pageStatus: #new.
    newpage file: ((ServerAction serverDirectory),
	    directory, (ServerAction pathSeparator), newfile).
    newpage text: 'Describe ',label,' here'.
    newpage map: self.
    newpage url: (action name),'.',newfile.
    ^newpage
!

recent
    | response sortedPages currentDate |

    sortedPages _ pages reject: [:page | page pageStatus = #new].
    sortedPages _ sortedPages 
		    asSortedCollection: [:a :b | (a date = b date) 
						    ifTrue: [a time > b time]
						    ifFalse: [a date > b date]].
    response _ WriteStream on: String new.
    response nextPutAll: '<h2>Recent Changes</h2><ul>'.
    currentDate _ Date new.
    sortedPages do: [:page |
	(currentDate ~= page date)
	ifTrue: [
	    currentDate _ page date.
	    response nextPutAll: '</ul><p><b>',(currentDate printString),'</b><p><ul>'.
	].
	response nextPutAll: '<li>',(self pageURL: page),'...',(page address).
	(page privs includesSubString: 'read') ifTrue:[
	    response nextPutAll: '  <b>Read protected</b>'.
	].
	(page privs includesSubString: 'write') ifTrue:[
	    response nextPutAll: '  <b>Write protected</b>'.
	].
    ].
    response nextPutAll: '</ul>'.
    ^response contents
!

storeID: id  username: theUsername password: thePassword privs: thePrivs
text: text from: peer
	| page |
	page _ self atID: id.
	page date: (Date today).
	page address: peer.
	(theUsername size > 1) ifTrue: [
		page username: theUsername.
		page password: thePassword.
		page privs: thePrivs.
		"Set up the authorization"
		action auth mapName: theUsername password: thePassword
			to: id.].
	page text: text.
	^ page
! !

!PURLmap class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/pwsSwiki/PURLmap.st,v 1.8 2003/03/26 10:27:06 stefan Exp $'
! !
