"{ Package: 'stx:goodies/webServer/services/demo' }"

"{ NameSpace: Demos }"

HTTPService subclass:#AjaxDemoService1
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'demos-WebApplications'
!

!AjaxDemoService1 class methodsFor:'documentation'!

documentation
"
    The simplest possible WEB2.0 service (hand-coded without using any framework)
"
! !

!AjaxDemoService1 class methodsFor:'defaults'!

linkName
    "return the default linkName path (with slash)"

    ^ '/AjaxDemo1'
! !

!AjaxDemoService1 methodsFor:'actions'!

process:aRequest 
    "process an incoming HTTP request"

    (aRequest url endsWith:'/update.xml') ifTrue:[
        aRequest 
            response
                expirationTime:(Timestamp now subtractSeconds:1);
                contentType:'text/xml';
                reply:'<?xml version="1.0" encoding="ISO-8859-1"?>
<update>
  <datum id="nClasses">'; replyEscaped:'<b>',Smalltalk allClasses size printString,'</b>'; reply:'</datum>
  <datum id="time">'; replyEscaped:(Time now printString); reply:'</datum>
  <datum id="mem">'; replyEscaped:(ObjectMemory newSpaceUsed printString); reply:'</datum>
</update>
'.
        ^ self.
    ].


    aRequest 
        response 
            contentType:'text/html';
            reply:'
<head>
<script>

function updateElement(id, html){
  var el = document.getElementById(id);
  if (el) {
    el.innerHTML = html;
  }
}

function getUpdates() {
  var req = new XMLHttpRequest();

  req.onreadystatechange = function() {
        if (req.readyState == 4 && req.status == 200) {
          var text = req.responseText;
          var xml = req.responseXML;

          if (xml) {
            var element = xml.documentElement;
            var children = element.childNodes;

            for (i=0; i<children.length; i++) {
              var child = children[i];

              if (child.nodeName !!= "#text") {
                var id = child.getAttribute("id");
                var html = child.firstChild.data;
                updateElement(id, html);
              }
            }
          }
        }
      }
  req.open("GET", "',aRequest url,'/update.xml", true);
  req.send( null );
}

function __startUpdater() {
  if (document.getElementById){
    setInterval("getUpdates()", 1000);
  }
}

</script>
</head>
<body onLoad="__startUpdater();">
<h1>AJAX Self-Update Example</h1>
The following values are flickerless updated once a second via the XMLHttpRequest object:
<p>
Number of Classes in Server: <span id="nClasses">?</span>
<br>Server Time: <span id="time">??:??:??</span>
<br>Server Memory: <span id="mem">?</span>
</body>
'.
! !

!AjaxDemoService1 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/services/demo/Demos__AjaxDemoService1.st,v 1.2 2007/03/13 21:41:23 cg Exp $'
! !
