"{ Package: 'stx:goodies/webServer/services/demo' }"

"{ NameSpace: Demos }"

HTTPService subclass:#AjaxDemoService2
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'demos-WebApplications'
!

!AjaxDemoService2 class methodsFor:'documentation'!

documentation
"
    Another simple WEB2.0 service (hand-coded without using any framework)
"
! !

!AjaxDemoService2 class methodsFor:'defaults'!

linkName
    "return the default linkName path (with slash)"

    ^ '/AjaxDemo2'
! !

!AjaxDemoService2 methodsFor:'actions'!

process:aRequest 
    "process an incoming HTTP request"

    |list listCode|

    list := ProcessorScheduler knownProcesses asOrderedCollection.
    list := list select:[:p | p notNil and:[p id notNil]].
    list sort:[:p1 :p2 |
                     |id1 id2|

                     (p1 isNil or:[(id1 := p1 id) isNil])
                         ifTrue:[true]
                         ifFalse:[
                             (p2 isNil or:[(id2 := p2 id) isNil])
                                 ifTrue:[false]
                                 ifFalse:[id1 < id2]
                     ]
                 ].
    list := list collect:[:p |
        Array 
            with:p id
            with:p name
            with:p state
            with:p priority
        ].

    listCode := String 
        streamContents:[:s |
            s nextPutLine:'<table border>'.
            s nextPutLine:'<tr>'.
            s nextPutLine:' <th>ID</th>'.
            s nextPutLine:' <th>Name</th>'.
            s nextPutLine:' <th>State</th>'.
            s nextPutLine:' <th>Prio</th>'.
            s nextPutLine:'</tr>'.
            list do:[:row |
                s nextPutLine:'<tr>'.
                row do:[:col |
                    s nextPutLine:'  <td>'.
                    s nextPutLine:col printString.
                    s nextPutLine:'  </td>'.
                ].
                s nextPutLine:'</tr>'.
            ].
            s nextPutLine:'</table>'.
        ].

    (aRequest url endsWith:'/update.xml') ifTrue:[
        aRequest 
            response
                expirationTime:(Timestamp now subtractSeconds:1);
                contentType:'text/xml';
                reply:'<?xml version="1.0" encoding="ISO-8859-1"?>
<update>
  <datum id="list">'; replyEscaped:listCode; reply:'</datum>
</update>
'.
        ^ self.
    ].


    aRequest 
        response 
            contentType:'text/html';
            reply:'
<head>
<script>

function updateElement(id, html){
  var el = document.getElementById(id);
  if (el) {
    el.innerHTML = html;
  }
}

function getUpdates() {
  var req = new XMLHttpRequest();

  req.onreadystatechange = function() {
        if (req.readyState == 4 && req.status == 200) {
          var text = req.responseText;
          var xml = req.responseXML;

          if (xml) {
            var element = xml.documentElement;
            var children = element.childNodes;

            for (i=0; i<children.length; i++) {
              var child = children[i];

              if (child.nodeName !!= "#text") {
                var id = child.getAttribute("id");
                var html = child.firstChild.data;
                updateElement(id, html);
              }
            }
          }
        }
      }
  req.open("GET", "',aRequest url,'/update.xml", true);
  req.send( null );
}

function __startUpdater() {
  if (document.getElementById){
    setInterval("getUpdates()", 1000);
  }
}

</script>
</head>
<body onLoad="__startUpdater();">
<h1>AJAX Self-Update Example</h1>
The following process list is flickerless updated once a second via the XMLHttpRequest object:
<p>
<div id="list">
?
</div>
</body>
'.
! !

!AjaxDemoService2 class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/services/demo/Demos__AjaxDemoService2.st,v 1.2 2007/03/13 21:42:06 cg Exp $'
! !
