"{ Package: 'stx:goodies/webServer/services/demo' }"

"{ NameSpace: Demos }"

HTTPService subclass:#SVGDemoService
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'demos-WebApplications'
!

!SVGDemoService class methodsFor:'documentation'!

documentation
"
    Demonstrates an SVG document
"
! !

!SVGDemoService class methodsFor:'defaults'!

linkName
    "return the default linkName path (with slash)"

    ^ '/SVGDemo1'
! !

!SVGDemoService methodsFor:'actions'!

answerMainPage:aRequest 
    |builder|

    builder := HTML::TreeBuilder new beginWith:(HTML::Document new).
    builder
       head;
       headEnd;
       body;
         text:'An embedded SVG graphic:'; br;
         embed; 
           width:222; height:300; src:(self linkName , '/foo.svg');
           name:'printable_map'; type:'image/svg+xml';
       bodyEnd.

    aRequest 
        response 
            contentType:'text/html';
            reply:(builder htmlString).
!

answerSVG:aRequest 
    |builder|

    builder := HTML::SVGTreeBuilder new.
    builder
       svg; 
         viewBox:(0@0 corner:270@400);
         width:'100%';
         height:'100%';
         g; id:'mainlayer';
           rect; fill:'red'; stroke:'black'; x:15; y:15; width:100; height:50; rectEnd;
           rect; fill:'blue'; stroke:'black'; x:150; y:15; width:100; height:50; rx:12; ry:18; rectEnd;
           circle; fill:'yellow'; stroke:'black'; cx:62; cy:135; r:20; circleEnd;
           ellipse; fill:'green'; stroke:'black'; cx:200; cy:135; rx:50; ry:20; ellipseEnd;
           polyline; fill:'none'; stroke:'red'; strokeWidth:2; points:'160,200 180,230 200,210 234,220'; polylineEnd;
           "/ polygon; fill:'yellow'; stroke:'black'; strokeWidth:1; points:'49,272 57,297 114,282 63,314 71,339 49,324 27,339 35,314 13,297 40,297'; polygonEnd;
           "/ polygon; fill:'yellow'; stroke:'black'; strokeWidth:1; points:#((49 272) (57 297) (114 282) (63 314) (71 339) (49 324) (27 339) (35 314) (13 297) (40 297)); polygonEnd;
           polygon; fill:'yellow'; stroke:'black'; strokeWidth:1; points:{ (49@272). (57@297). (114@282). (63@314). (71@339). (49@324). (27@339). (35@314). (13@297). (40@297) }; polygonEnd;
           path; fill:'none'; stroke:'black'; strokeWidth:3; d:'M150 280l19,10 -22,33 40,3c12,43 44,-83 83,20'; pathEnd;
           g; fill:'none'; stroke:'green'; 
             line; x1:15; y1:240; x2:30; y2:200; strokeWidth:2; lineEnd;
             line; x1:30; y1:240; x2:45; y2:200; strokeWidth:4; lineEnd;
             line; x1:45; y1:240; x2:60; y2:200; strokeWidth:8; lineEnd;
             line; x1:60; y1:240; x2:75; y2:200; strokeWidth:10; lineEnd;
             line; x1:75; y1:240; x2:90; y2:200; strokeWidth:12; lineEnd;
           gEnd;
           g; fontSize:'20px';
             text; x:44; y:88; text:'rect'; textEnd;
             text; x:140; y:88; text:'rect (rounded)'; textEnd;
             text; x:36; y:180; text:'circle'; textEnd;
             text; x:170; y:180; text:'ellipse'; textEnd;
             text; x:36; y:263; text:'line'; textEnd;
             text; x:156; y:255; text:'polyline'; textEnd;
             text; x:16; y:363; text:'polygon'; textEnd;
             text; x:140; y:363; 
               text:'path:'; 
               tspan; x:140; y:383; text:'simple + bezier'; tspanEnd;
             textEnd;
           gEnd;
         gEnd;
       svgEnd.

    aRequest 
        response 
            contentType:'image/svg+xml';
            reply:(builder xmlString).
    ^ self.

'<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>
<!!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.0//EN" "http://www.w3.org/TR/SVG/DTD/svg10.dtd">
<svg viewBox="0 0 270 400" width="100%" height="100%" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
    <g id="mainlayer">
        <rect fill="red" stroke="black" x="15" y="15" width="100" height="50"/>
        <rect fill="blue" stroke="black" x="150" y="15" width="100" height="50" rx="12" ry="18"/>
        <circle fill="yellow" stroke="black" cx="62" cy="135" r="20"/>
        <ellipse fill="green" stroke="black" cx="200" cy="135" rx="50" ry="20"/>
        <polyline fill="none" stroke="red" stroke-width="2" points="160,200 180,230 200,210 234,220"/>
        <polygon fill="yellow" stroke="black" stroke-width="1" points="49,272 57,297 114,282 63,314 71,339 49,324 27,339 35,314 13,297 40,297"/>

        <path stroke="black" fill="none" stroke-width="3" d="M150 280l19,10 -22,33 40,3c12,43 44,-83 83,20"/>
        <g stroke="green" fill="none">
            <line x1="15" y1="240" x2="30" y2="200" stroke-width="2"/>
            <line x1="30" y1="240" x2="45" y2="200" stroke-width="4"/>
            <line x1="45" y1="240" x2="60" y2="200" stroke-width="8"/>
            <line x1="60" y1="240" x2="75" y2="200" stroke-width="10"/>
            <line x1="75" y1="240" x2="90" y2="200" stroke-width="12"/>
        </g>
        <g font-size="20px">
            <text x="44" y="88">rect</text>
            <text x="140" y="88">rect (rounded)</text>
            <text x="36" y="180">circle</text>
            <text x="170" y="180">ellipse</text>
            <text x="36" y="263">line</text>
            <text x="156" y="255">polyline</text>
            <text x="16" y="363">polygon</text>
            <text x="140" y="363">path:<tspan x="140" y="383">simple + bezier</tspan></text>
        </g>
    </g>
</svg>
'.
!

process:aRequest 
    "process an incoming HTTP request"

    aRequest url = (self linkName, '/foo.svg') ifTrue:[
        self answerSVG:aRequest.
        ^ self.
    ].

    self answerMainPage:aRequest.
! !

!SVGDemoService class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/services/demo/Demos__SVGDemoService.st,v 1.3 2007/03/13 14:51:30 cg Exp $'
! !
