"{ Package: 'stx:goodies/webServer' }"

LibraryDefinition subclass:#stx_goodies_webServer
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_webServer class methodsFor:'description'!

excludedFromPreRequisites
    "list packages which are to be explicitely excluded from the automatic constructed
     prerequisites list. If empty, everything that is found along the inheritance of any of
     my classes is considered to be a prerequisite package."

    ^ #(
        #'stx:goodies/soap'    "SOAP::SoapServiceHandler - referenced by HTTPServer>>setupSoap "
        #'stx:goodies/sunit'
        #'stx:goodies/webServer/comanche/seaside2_5b4'    "WADispatcher - referenced by SeasideService class>>defaultEntryPoint "
    )
!

preRequisites
    ^ #(
        #'stx:goodies/authentication'    "Authentication::Authenticator - referenced by HTTPServer>>allowedAuthenticationClasses "
        #'stx:goodies/xml/stx'    "XMLStandardDecoder - referenced by Demos::WebDemoShopSessions::Article class>>fromXMLStream: "
        #'stx:libbasic'    "Object - superclass of HTTPService "
        #'stx:libbasic2'    "NameLookupError - referenced by HTTPFileService>>process: "
        #'stx:libbasic3'    "HTMLDocGenerator - referenced by HTTPClassDocService>>classDocOf: "
        #'stx:libhtml'    "URL - referenced by Demos::WebHomePageForSTX>>pageCounterFor: "
        #'stx:libtool'    "NewLauncher - referenced by HTTPServer class>>removeFromLauncher "
        #'stx:libview'    "ImageMask - referenced by Demos::WebDemoShopSessions class>>removeFromCartInImage "
        #'stx:libview2'    "Icon - referenced by Demos::WebDemoShop class>>addToCartInImage "
    )
! !

!stx_goodies_webServer class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIBWEBSERVER_BASE
LIB_BASE=$(LIBWEBSERVER_BASE)
'
! !

!stx_goodies_webServer class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'FCGI::FCGIHeader'
        #'FCGI::FCGIKeyValuePairs'
        #'FCGI::FCGIReadStream'
        #'FCGI::FCGIRecord'
        HTTPAccessDeniedError
        HTTPAccessLogger
        HTTPConnection
        HTTPCookie
        HTTPHeaderParseError
        HTTPHeaderParser
        HTTPRequest
        HTTPResponse
        HTTPResponseHeader
        HTTPServer
        (HTTPServerTests autoload)
        HTTPService
        HTTPServiceRequestContext
        HTTPSession
        HtmlSanitizer
        PresenterStyleSheet
        ReplyPresenter
        (TestHtmlSanitizer autoload)
        #'stx_goodies_webServer'
        #'Demos::HelloWorldService'
        #'Demos::WebSlideShow'
        EmptyDocumentReplyPresenter
        ExeptReplyPresenter
        #'FCGI::FCGIKeyValuePair'
        #'FCGI::FCGIRecordBeginRequest'
        #'FCGI::FCGIRecordEndRequest'
        #'FCGI::FCGIRecordParams'
        #'FCGI::FCGIRecordStdin'
        #'FCGI::FCGIRecordStdout'
        FCGIConnection
        FCGIRequest
        FCGIResponse
        FCGIServer
        (HTTPActionService autoload)
        HTTPFileAccessLogger
        HTTPFileService
        HTTPSelectorService
        HTTPTentativeObjectService
        PlainReplyPresenter
        SeasideService
        #'Demos::WebDemoApp1'
        #'Demos::WebDemoShop'
        #'Demos::WebDemoShopSessions'
        #'Demos::WebHomePageForSTX'
        #'Demos::WebProcessList'
        #'Demos::WebScreenImageService'
        #'Demos::WebSmalltalkBrowser'
        HTTPApacheFormatAccessLogger
        HTTPCGIService
        HTTPClassDocService
        HTTPEmbeddedApplicationService
        HTTPFullAccessLogger
        HTTPSourceCodeAccessService
        HTTPUtilityService
        MacroExpandingCSSFileService
        ServerMaintenanceService
        HTTPPluggableActionService
        HumanReadableImageGenerator
    )
!

extensionMethodNames
    ^ #(
    )
! !

!stx_goodies_webServer class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X HTTP Server'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright eXept Software AG 1998-2011'

    "Modified: / 01-02-2011 / 11:54:51 / cg"
! !

!stx_goodies_webServer class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/stx_goodies_webServer.st,v 1.20 2011/02/01 10:58:11 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/stx_goodies_webServer.st,v 1.20 2011/02/01 10:58:11 cg Exp $'
! !
