"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

"{ Package: 'stx:goodies/webServer/test' }"

TestCase subclass:#HTTPServerTests
	instanceVariableNames:'connections'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-HTTP-Server'
!

!HTTPServerTests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2003 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    documentation to be added.

    [author:]
	Christian Penk (penk@bierfix)

    [instance variables:]

    [class variables:]

    [see also:]

"
!

history
    "Created: / 20.6.2003 / 11:10:48 / penk"
! !

!HTTPServerTests methodsFor:'httperf'!

apacheServerPort
    ^ 80.
!

callsPerCase
    ^ 5.
!

httperfCommand
    ^ 'httperf --hog --client=0/1 --server=localhost --port=%1 --uri="%2" --num-conns=%3 --num-calls=%4'.
!

httperfResultFor:aPort url:url numConnections:numConnections calls:calls
    ^ self httperfCommand
		bindWith:aPort asString
		with:url
		with:numConnections
		with:calls asString.
!

httperfShortFileTest
    |calls serverPorts callsPerCase numConnections caseCommandString result|

    callsPerCase := 10.
    calls := 100.
    serverPorts := self serverPorts.
    numConnections := 1.
    caseCommandString := self httperfResultFor:'8080'
				    url:'/tests/10.txt'
				    numConnections:numConnections asString
				    calls:(calls asString).
    result := self resultFromCommandString:caseCommandString calls:callsPerCase.
    ^ result

"
    self new httperfShortFileTest

    results on 800 Mhz Pentium
    without validateRequest =  '1879'
    withParseHeader = '1514'
    before extractUrlParameters = '1442'
    before extractServiceAndLinkNameFromPath = '1297'
    befor service process = '1106'
    before mimeType = '1022'
    before checkAcceptableType '984'
    after checkAcceptableType '888'
    after cacheDataForFile '847'
    after service process = '727'
    on start of HTTPResponse send = '725'
    in HTTPResponse send before create buffer = '725'
    in HTTPResponse send before generateResponseOn:responseStream = '735'
    in HTTPResponse send after generateResponseOn:responseStream = '580'
    all without logging = '585'
    all with logging = '433'
"
!

httperfTests
    |calls url serverPorts testOutPutFilename
     testOutPutFile testOutPutFileStream numConnections stxResults apacheResult callsPerCase|

    callsPerCase := 5.
    calls := 100.
    serverPorts := self serverPorts.
    numConnections := 1.


    testOutPutFilename := 'performance_' , Timestamp now printString.
    testOutPutFile := ((Filename homeDirectory
		construct:'httperf') construct:testOutPutFilename).
    testOutPutFileStream := testOutPutFile writeStream.
    [
	self writeHeaderLineTo:testOutPutFileStream.

	self testFiles do:[:aFilename |
	    url := self testUrlDirectoryLinkName , '/' , aFilename.
	    serverPorts do:[:aPort |
		| caseCommandString |
		caseCommandString := self httperfResultFor:aPort asString
						url:url
						numConnections:numConnections
						calls:calls asString.
		aPort == self stxServerPort ifTrue:[
		    stxResults := OrderedCollection new.
		    self stxCacheSizes do:[:aCacheSize|
			self setServiceCacheSizeTo:aCacheSize.
			stxResults add:(aCacheSize->(self resultFromCommandString:caseCommandString calls:callsPerCase)).
		    ].
		] ifFalse:[
		    apacheResult := self resultFromCommandString:caseCommandString calls:callsPerCase.
		].
	    ].
	    stxResults do:[:aCacheResult|
		testOutPutFileStream nextPutAll:(aFilename padded:#right to:10 with:(Character space)).
		testOutPutFileStream nextPutAll:(numConnections asString padded:#right to:10 with:(Character space)).
		testOutPutFileStream nextPutAll:(calls asString padded:#right to:10 with:(Character space)).
		testOutPutFileStream nextPutAll:(aCacheResult key asString padded:#right to:10 with:(Character space)).
		testOutPutFileStream nextPutAll:(aCacheResult value asString padded:#right to:10 with:(Character space)).
		testOutPutFileStream nextPutAll:(apacheResult asString padded:#right to:10 with:(Character space)).
		testOutPutFileStream nextPut:(Character cr).
	    ].
	    testOutPutFileStream nextPut:(Character cr).
	    testOutPutFileStream flush.
	].
    ] ensure:[
	testOutPutFileStream close.
	self setServiceCacheSizeToDefault.
    ].

"
    self new httperfTests
"
!

resultFromCommandString:aCommandString calls:callsPerCase

    |output resultCollection requestRateLine requestRateLineStartString requestRateLineReadStream resultAverage tempResultFilename command time1 resultBest|

    requestRateLineStartString := 'Request rate:'.
    resultCollection := OrderedCollection new.
    tempResultFilename := Filename tempDirectory construct:'httperfoutput.tmp'.
    command := aCommandString , ' > ', tempResultFilename asString.
    1 to:callsPerCase do:[:callIndex|
	Transcript showCR:command.
	Delay waitForSeconds:1.
	time1 := Timestamp now.
	(OperatingSystem executeCommand:command) ifTrue:[
	    Transcript showCR:(Timestamp now millisecondDeltaFrom:time1).
	    output := tempResultFilename contents.
	    requestRateLine := output detect:[:aLine| aLine startsWith:requestRateLineStartString] ifNone:[nil].
	    requestRateLine notNil ifTrue:[
		requestRateLineReadStream := (requestRateLine copyFrom:(requestRateLineStartString size)) readStream.
		resultCollection add:(requestRateLineReadStream nextWord asNumber).
	    ].
	]
    ].
    resultCollection isEmpty ifTrue:[
	^ 0
    ].
    resultAverage := ((resultCollection inject:0 into:[:accu :element | accu + element]) / resultCollection size) rounded asString.
    resultBest := resultCollection max asString.
"/    ^ resultAverage.
    ^ resultBest.
!

serverPorts
    ^ Array with:self stxServerPort with:self apacheServerPort.
!

setServiceCacheSizeTo:aCacheSize
    |httpServer  stxFileService|

    httpServer := HTTPServer defaultServer.
    httpServer notNil ifTrue:[
	stxFileService := httpServer serviceForLink:self testUrlDirectoryLinkName.
	stxFileService maxCacheDocumentSize:aCacheSize.
    ].
!

setServiceCacheSizeToDefault
    |httpServer  stxFileService|

    httpServer := HTTPServer defaultServer.
    stxFileService := httpServer serviceForLink:self testUrlDirectoryLinkName.
    stxFileService maxCacheDocumentSize:stxFileService class maxCacheDocumentSize.
!

stxCacheSizes

    ^ #( 0 64000).
!

stxServerPort
    ^ 8080.
!

testFiles
    ^ #(
	    '10.txt'
	    '1000.txt'
	    '4000.txt'
	    '8181.txt'
	    '8183.txt'
	    '10000.txt'
	    '16000.txt'
	    '24000.txt'
	    '32000.txt'
	    '34000.txt'
	    '64000.txt'
	).
!

testUrlDirectoryLinkName
    ^ '/tests'.
!

writeHeaderLineTo:aFileStream

    |testOutPutHeaderLines|

    testOutPutHeaderLines := #(
				'file'
				'numCon'
				'numCall'
				'cache'
				).
    testOutPutHeaderLines := testOutPutHeaderLines collect:[:aLine| aLine padded:#right to:10 with:(Character space)].
    testOutPutHeaderLines do:[:aHeaderLine|
	aFileStream nextPutAll:aHeaderLine .
    ].
    self serverPorts do:[:aPortNr|
	aFileStream nextPutAll:(aPortNr asString padded:#right to:10 with:(Character space)).
    ].
    aFileStream nextPut:(Character cr).
! !

!HTTPServerTests methodsFor:'initialize / release'!

setUp
    "common setup - invoked before testing."

    super setUp
!

tearDown
    "common cleanup - invoked after testing."

    super tearDown
! !

!HTTPServerTests methodsFor:'tests'!

performanceTestHeaderParsing
    |header request|

    header := 'GET /Shop HTTP/1.1', String crlf,
	      'User-Agent: Opera/6.03 (Linux 2.4.19-4GB i686; U)  [en]', String crlf,
	      'Host: bierfix:8080', String crlf,
	      'Accept: text/html, image/png, image/jpeg, image/gif, image/x-xbitmap, */*', String crlf,
	      'Accept-Charset: iso-8859-1;q=1.0, utf-8;q=1.0, utf-16;q=1.0, iso-8859-1;q=0.6, *;q=0.1', String crlf,
	      'Accept-Encoding: deflate, gzip, x-gzip, identity, *;q=0', String crlf,
	      'Connection: Keep-Alive', String crlf, String crlf.

    MessageTally spyDetailedOn:[
	10000 timesRepeat:[
	    request := HTTPRequest new.
	    request rawRequestString:header rawHeader:header data:nil.
	].
    ].

"
    self new performanceTestHeaderParsing
"
!

testBadRequestMethod

    | sock  serverHost serverPort rply|

    serverHost := OperatingSystem getHostName.
    serverPort := HTTPServer defaultPort.
    sock := Socket newTCPclientToHost:'bierfix' port:8080.
    rply := HTTPInterface
		request:'CONNECT'
		url:'/'
		fromHost:serverHost port:serverPort
		accept:#('*/*')
		fromDocument:nil
		userName:nil password:nil.


    self should:((rply rawHeader detect:[:aHeaderField|
	aHeaderField asLowercase startsWith:'allow:'
    ] ifNone:[nil]) notNil).

    "
     self run:#testBadRequestMethod
     self new testBadRequestMethod
    "
!

testParsingHeader
    |header request|

    header := 'GET /Shop HTTP/1.1', String crlf,
	      'User-Agent: Opera/6.03 (Linux 2.4.19-4GB i686; U)  [en]', String crlf,
	      'Host: bierfix:8080', String crlf,
	      'Accept: text/html, image/png, image/jpeg, image/gif, image/x-xbitmap, */*', String crlf,
	      'Accept-Charset: iso-8859-1;q=1.0, utf-8;q=1.0, utf-16;q=1.0, iso-8859-1;q=0.6, *;q=0.1', String crlf,
	      'Accept-Encoding: deflate, gzip, x-gzip, identity, *;q=0', String crlf,
	      'Connection: Keep-Alive', String crlf, String crlf.

    request := HTTPRequest new.
    request rawRequestString:header rawHeader:header data:nil.
    request connectionAttributes.
    self should:(request headerParser atEnd).

"
    self new headerParsingTest
"
!

testPerformanceFile1600

    self testPerformanceForUrl:'/tests/top.gif' cycles:100

"
    self new testPerformanceFile1600
"
!

testPerformanceFile16000

    self testPerformanceForUrl:'/tests/xxx.16000.txt' cycles:100

"
    self new testPerformanceFile16000
"
!

testPerformanceFile24000

    self testPerformanceForUrl:'/tests/xxx.24000.txt' cycles:100

"
    self new testPerformanceFile24000
"
!

testPerformanceFile31999

    self testPerformanceForUrl:'/tests/xxx.31999.txt' cycles:100

"
    self new testPerformanceFile31999
"
!

testPerformanceFile32000

    self testPerformanceForUrl:'/tests/xxx.32000.txt' cycles:100

"
    self new testPerformanceFile32000
"
!

testPerformanceFile8181

    self testPerformanceForUrl:'/tests/xxx.8181.txt' cycles:100
"
    self new testPerformanceFile8181
"
!

testPerformanceFile8183

    self testPerformanceForUrl:'/tests/xxx.8183.txt' cycles:100
"
    self new testPerformanceFile8183
"
!

testPerformanceForUrl:anUrl cycles:cycles

    | remoteHostApache remoteHostStx apachePort stxPort apacheTime stxTime minTime maxTime t  bag apacheRps stxRps|

    remoteHostApache := 'bierfix.exept.de'.
    remoteHostStx := remoteHostApache.
"/    bag := OrderedCollection new:cycles.
    apachePort := 80.
    stxPort := 8080.

    apacheTime := Time millisecondsToRun:[
	cycles timesRepeat:[
	    HTTPInterface get:anUrl fromHost:remoteHostApache port:apachePort
	].
    ].
    stxTime := Time millisecondsToRun:[
	cycles timesRepeat:[
"/            t := Time millisecondsToRun:[
		HTTPInterface get:anUrl fromHost:remoteHostStx port:stxPort
"/            ].
"/            bag add:t.
	].
    ].
    Transcript showCR:'Result for get of ', anUrl asFilename baseName.
    apacheRps := (cycles / (apacheTime / 1000)) rounded.
    stxRps := (cycles / (stxTime / 1000))rounded.
    Transcript showCR:'STX WebServer perform ', stxRps printString,' requests / sec'.
"/    Transcript show:'min: '; show:bag min; show:' max: '; show:bag max; cr.
"/    bag doWithIndex:[:aTime :index|
"/        Transcript showCR:'STX WebServer perform time on cycle:', index printString,' ', aTime printString.
"/    ].
    Transcript showCR:'Apache WebServer perform ', apacheRps printString,' requests / sec'.
    Transcript showCR:'Apache WebServer / STX WebServer  ', ((apacheRps / stxRps) asFixedPoint:2) printString.

"
    self new testPerformanceFile1600.
    self new testPerformanceFile8181.
    self new testPerformanceFile8183.
    self new testPerformanceFile16000.
    self new testPerformanceFile24000.
    self new testPerformanceFile31999.
    self new testPerformanceFile32000.
"
!

testPipelining

    |rply serverHost serverPort|

    serverHost := OperatingSystem getHostName.
    serverPort := HTTPServer defaultPort.
    #(
	'/exept'
	'/schemes/exept2/scripts.js'
	'/schemes/exept2/view.png'
	'/schemes/exept2/viewact.png'
	'/schemes/exept2/editact.png'
	'/schemes/exept2/edit.png'
	'/schemes/exept2/editlock.png'
	'/schemes/exept2/editlockact.png'
	'/schemes/exept2/upload.png'
	'/schemes/exept2/uploadact.png'
	'/schemes/exept2/history.png'
	'/schemes/exept2/historyact.png'
	'/schemes/exept2/top.png'
	'/schemes/exept2/topact.png'
	'/schemes/exept2/recent.png'
	'/schemes/exept2/recentact.png'
	'/schemes/exept2/search.png'
	'/schemes/exept2/searchact.png'
	'/schemes/exept2/help.png'
	'/schemes/exept2/exeptLogo.gif'
	'/schemes/exept2/viewie.gif'
	'/schemes/exept2/edit.gif'
	'/schemes/exept2/upload.gif'
	'/schemes/exept2/history.gif'
	'/schemes/exept2/topie.gif'
	'/schemes/exept2/recent.gif'
	'/schemes/exept2/search.gif'
	'/schemes/exept2/help.gif'
	'/refs/uploads/1/exeptLogo.gif'
    ) do:[:path|
	rply := HTTPInterface get:'/exept' fromHost:serverHost port:serverPort.
    ].

    "
     self run:#pipeliningTest
     self new pipeliningTest
    "
!

testToLongHeader

    | sock|

    sock := Socket newTCPclientToHost:'localhost' port:8080.
    self should:[
	1 to:(1024 * 512) do:[:index|
	    sock nextPutAll:'x'
	].
    ] raise:Error.

    "
     self run:#testToLongHeader
     self new testToLongHeader
    "
! !

!HTTPServerTests class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/test/HTTPServerTests.st,v 1.20 2008/07/11 09:59:44 sr Exp $'
! !
