"{ Package: 'stx:goodies/webServer/ui' }"

LibraryDefinition subclass:#stx_goodies_webServer_ui
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_webServer_ui class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/authentication'    "Authentication::User - referenced by HTTPServerSettingsAppl::AuthorizationSettingsAppl>>addUserToRealm "
        #'stx:goodies/webServer'    "HTTPApacheFormatAccessLogger - referenced by ApacheFormatAccessLoggerSettingsApp>>setToCLFFormat "
        #'stx:libbasic'    "Object - superclass of HTTPServerSettingsAppl::AuthorizationSettingsAppl "
        #'stx:libbasic2'    "List - referenced by HTTPServerSettingsAppl::AuthorizationSettingsAppl>>usersList "
        #'stx:libtool'    "AbstractSettingsApplication - superclass of AbstractServerSettingsApplication "
        #'stx:libview'    "Image - referenced by Demos::WebSlideShowSettingsApplication>>updatePreviewImage "
        #'stx:libview2'    "Model - superclass of AbstractLoggerSettingsApplication "
        #'stx:libwidg'
        #'stx:libwidg2'    "LabelAndIcon - referenced by HTTPServerSettingsAppl::PluggableServicesSettingsAppl>>downLabel "
    )
! !

!stx_goodies_webServer_ui class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        AbstractLoggerSettingsApplication
        AbstractServerSettingsApplication
        #'stx_goodies_webServer_ui'
        ApacheFormatAccessLoggerSettingsApp
        HTTPServerSettingsAppl
        HTTPServiceSettingsApplication
        SoapSettingsApplication
        #'Demos::WebSlideShowSettingsApplication'
        HTTPClassDocServiceSettingsApp
        HTTPFileServiceSettingsApp
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!stx_goodies_webServer_ui class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X HTTP Server UI'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright eXept Software AG 1998-2011'

    "Modified: / 01-02-2011 / 11:55:04 / cg"
! !

!stx_goodies_webServer_ui class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/webServer/ui/stx_goodies_webServer_ui.st,v 1.11 2011/02/01 10:58:39 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/webServer/ui/stx_goodies_webServer_ui.st,v 1.11 2011/02/01 10:58:39 cg Exp $'
! !
