"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

Object subclass:#IdDOMConstants
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdDOMSmalltalk'
!


!IdDOMConstants class methodsFor:'class comment'!

classComment
	"This is a static class which implements class methods 
	containing DOM Node constants. In Java, these methods
	are implemented by the DOM Node Interface. As a result,
	there is no need to include this class within a Java application.

	The constants in this class are node types which are integers 
	stored within StringNode instances to identify the purpose of 
	the instance (ie. Attribute, Comment, Text, etc.). Note that an 
	additional node type for unknown instances (-1) is defined 
	in a static method of NodeImpl."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdDOMConstants class methodsFor:'node types'!

ATTRIBUTE_NODE
	"Return the integer which represents the
	ATTRIBUTE_NODE node type."

	^2
!

CDATA_SECTION_NODE
	"Return the integer which represents the
	CDATA_SECTION_NODE node type."

	^4
!

COMMENT_NODE
	"Return the integer which represents the
	COMMENT_NODE node type."

	^8
!

DOCUMENT_FRAGMENT_NODE
	"Return the integer which represents the
	DOCUMENT_FRAGMENT_NODE node type."

	^11
!

DOCUMENT_NODE
	"Return the integer which represents the
	DOCUMENT_NODE node type."

	^9
!

DOCUMENT_TYPE_NODE
	"Return the integer which represents the
	DOCUMENT_TYPE_NODE node type."

	^10
!

ELEMENT_NODE
	"Return the integer which represents the
	ELEMENT_NODE node type."

	^1
!

ENTITY_NODE
	"Return the integer which represents the
	ENTITY_NODE node type."

	^6
!

ENTITY_REFERENCE_NODE
	"Return the integer which represents the
	ENTITY_REFERENCE_NODE node type."

	^5
!

NOTATION_NODE
	"Return the integer which represents the
	NOTATION_NODE node type."

	^12
!

PROCESSING_INSTRUCTION_NODE
	"Return the integer which represents the
	PROCESSING_INSTRUCTION_NODE node type."

	^7
!

TEXT_NODE
	"Return the integer which represents the
	TEXT_NODE node type."

	^3
! !

!IdDOMConstants class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdDOMConstants.st,v 1.5 2003/04/23 08:44:16 cg Exp $'
! !
