"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

IdException subclass:#IdDOMException
	instanceVariableNames:'code message'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdDOMSmalltalk'
!


!IdDOMException class methodsFor:'class comment'!

classComment
	"This class implements the DOMException interface. Only exceptions
	defined by DOM are currently implemented. Instances of this class
	store an integer exception code to identify the reason for which it
	was created. All codes are stored in class methods of this class.

	Comment from the DOM specification:

	DOM operations only raise exceptions in 'exceptional' circumstances, 
	i.e., when an operation is impossible to perform (either for logical reasons, 
	because data is lost, or because the implementation has become unstable). 
	In general, DOM methods return specific error values in ordinary processing 
	situation, such as out-of-bound errors when using NodeList."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdDOMException class methodsFor:'exception codes'!

DOMSTRING_SIZE_ERR
	^2
!

HIERARCHY_REQUEST_ERR
	^3
!

INDEX_SIZE_ERR
	^1
!

INUSE_ATTRIBUTE_ERR
	^10
!

INVALID_CHARACTER_ERR
	^5
!

NOT_FOUND_ERR
	^8
!

NOT_SUPPORTED_ERR
	^9
!

NO_DATA_ALLOWED_ERR
	^6
!

NO_MODIFICATION_ALLOWED_ERR
	^7
!

WRONG_DOCUMENT_ERR
	^4
! !

!IdDOMException methodsFor:'accessing'!

code
	"Return the exception code. The exception code is an
	integer which matches one of the standard error types.
	These types are defined in class methods of this class
	and match the naming standard of DOM."

	^code
!

code: anInteger
	"Set the exception code to anInteger. See getter
	method comment for more."

	code := anInteger
!

getMessage
	^message
!

setMessage: aString
	message := aString
! !

!IdDOMException class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdDOMException.st,v 1.5 2003/04/23 08:44:16 cg Exp $'
! !
