"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

IdNodeListImpl subclass:#IdNamedNodeList
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdDOM'
!


!IdNamedNodeList class methodsFor:'class comment'!

classComment
	"This class implements the NamedNodeMap interface in DOM.

	Comment from the DOM specification:

	Objects implementing the NamedNodeMap interface are used to represent 
	collections of nodes that can be accessed by name. Note that NamedNodeMap 
	does not inherit from NodeList; NamedNodeMaps are not maintained in any
	particular order. Objects contained in an object implementing NamedNodeMap 
	may also be accessed by an ordinal index, but this is simply to allow convenient 
	enumeration of the contents of a NamedNodeMap, and does not imply that the 
	DOM specifies an order to these Nodes."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdNamedNodeList methodsFor:'services'!

cloneSelfAndNodes: deep
	"Return a copy of the receiver which includes copies
	of all the contained nodes. Use a deep clone on the nodes
	only if deep is true."

	| answer aNode |
	answer := IdNamedNodeList new.
	answer prepChildNodes: self getLength.
	0 to: self getLength - 1 do: [ :i |
		aNode := self item: i.
		answer setNamedItem: ( aNode cloneNode: deep ) ].
	^answer
!

getNamedItem: aName
	"Return a Node (of any type) with the specified name, 
	or nil if aName did not identify any node in the receiver."

	| aNode |
	1 to: self getLength do: [ :i |
		aNode := self internalNodes ideAtIndex: i.
		( aNode getNodeName ideStringTest: aName ) ifTrue: [ ^aNode ] ].
	^nil
!

prepChildNodes: anInteger
	"Initialize the child nodes collections to a new
	collection anInteger in size. This method lets you
	ensure that the receiver has enough space for
	adding all planned nodes without growing the
	child nodes collection."

	self initNodes: ( OrderedCollection new: anInteger )
!

removeNamedItem: aName
	"Remove the node stored under the specified name.
	Return the removed node if successful, or nil if aName 
	did not identify any node in the receiver."

	| aNode |
	1 to: self getLength do: [ :i |
		aNode := self internalNodes ideAtIndex: i.
		( aNode getNodeName ideStringTest: aName ) ifTrue: [ 
			self internalNodes remove: aNode.
			^aNode ] ].
	^nil
!

setNamedItem: aNode
	"Store aNode in the receiver at its node name.
	This will replace any existing node at the same name,
	although its position in nodes would likely change.
	If the new Node replaces an existing node with the 
	same name the previously existing Node is returned, 
	otherwise nil is returned."

	| old |
	old := self removeNamedItem: aNode getNodeName.
	self internalNodes add: aNode.
	^old
! !

!IdNamedNodeList class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdNamedNodeList.st,v 1.5 2003/04/23 08:44:16 cg Exp $'
! !
