"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

Object subclass:#IdNodeListImpl
	instanceVariableNames:'nodes'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdDOM'
!


!IdNodeListImpl class methodsFor:'class comment'!

classComment
	"This class implements the NodeList interface in DOM.

	Comment from the DOM specification:

	The NodeList interface provides the abstraction of an ordered 
	collection of nodes, without defining or constraining how this 
	collection is implemented.

	The items in the NodeList are accessible via an integral index, 
	starting from 0."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdNodeListImpl class methodsFor:'constructors'!

forNodes: aCollection

	| answer |
	answer := IdNodeListImpl new.
	answer initNodes: aCollection.
	^answer
! !

!IdNodeListImpl methodsFor:'creation'!

initNodes: aCollection

	nodes := aCollection
! !

!IdNodeListImpl methodsFor:'internal'!

internalNodes
	"Return the nodes collection. This method should
	only be called by members of this class, a subclass,
	or members of the same package. In Java it is 
	marked as protected to enforce this."

	nodes == nil ifTrue: [ 
		nodes := OrderedCollection new ].  "should allow tuning of size"
	^nodes
! !

!IdNodeListImpl methodsFor:'services'!

getLength
	"Return the number of nodes stored within the receiver."

	nodes == nil ifTrue: [ ^0 ].
	^nodes size
!

item: anInteger
	"Return the node stored at the (zero-based) index anInteger.
	Valid indexes are in the range 0 through n-1 where n is the
	size of the node list. If anInteger is invalid return nil."

	anInteger >= self getLength ifTrue: [ ^nil ].
	^nodes ideAtIndex: anInteger + 1
!

itemImpl: anInteger
	"Return the node stored at the (zero-based) index anInteger.
	Valid indexes are in the range 0 through n-1 where n is the
	size of the node list. If anInteger is invalid return nil.

	This method works exactly the same as item() except that
	it returns the NodeImpl type instead of the org.w3c.dom.Node  
	which prevents unnecessary type casting in Java."

	anInteger >= self getLength ifTrue: [ ^nil ].
	^nodes ideAtIndex: anInteger + 1
! !

!IdNodeListImpl class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdNodeListImpl.st,v 1.5 2003/04/23 08:44:16 cg Exp $'
! !
