"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

IdStringNode subclass:#IdPINode
	instanceVariableNames:'target'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdDOM'
!


!IdPINode class methodsFor:'class comment'!

classComment
	"This subclass supports PI nodes by storing a target
	instance variable."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdPINode class methodsFor:'constructors'!

forTarget: aTarget data: aString
	"Return a new instance formatted to represent
	aString as a processing instruction for aTarget."

	| newNode |
	newNode := IdPINode new.
	newNode initTarget: aTarget data: aString.
	^newNode
! !

!IdPINode methodsFor:'accessing'!

getNodeName
	"Return the node name used for all instances:
	processing-instruction."

	^'processing-instruction'
!

getNodeType
	"Return an integer representing the receiver's
	node type. All instances share the same node
	type: PROCESSING_INSTRUCTION_NODE."

	^IdDOMConstants PROCESSING_INSTRUCTION_NODE
!

getTarget
	"Return the target of the receiver."

	^target
!

setTarget: aString
	"Set the target of the receiver to aString."

	target := aString
! !

!IdPINode methodsFor:'cloning'!

clone: deep
	"Return a duplicate of the receiver. The argument deep 
	is only relevent to Element nodes and will cause the 
	entire subtree under the receiver to be copied if true. The 
	node returned by this method will not have a parent node."

	^IdPINode forTarget: self getTarget data: self getData
! !

!IdPINode methodsFor:'creation'!

initTarget: aTarget data: aString
	"Initialize the receiver to represent aString as 
	a aNodeType (as defined by class variables in the 
	Node class)."

	target := aTarget.
	self setData: aString
! !

!IdPINode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdPINode.st,v 1.5 2003/04/23 08:44:16 cg Exp $'
! !
