"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

Object subclass:#IdStxpDTD
	instanceVariableNames:'entities defaultAttributes'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdStxp'
!


!IdStxpDTD class methodsFor:'instance creation'!

new
	^super new initialize
! !

!IdStxpDTD class methodsFor:'class comment'!

classComment
	"This class provides a minimal representation of DTD's
	as they are parsed by a non-validating parser."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdStxpDTD methodsFor:'accessing'!

addDefaultAttribute: aName value: aValue for: tagName

	| attList uniqueName |
	uniqueName := tagName asSymbol.
	attList := defaultAttributes at: uniqueName ifAbsent: [
		defaultAttributes at: uniqueName put: OrderedCollection new ].
	attList add: (
		Association new
			key: aName;
			value: aValue;
			yourself )
!

addEntityName: aName value: aValue
	entities at: aName put: aValue
!

getEntityValueAt: aString
	"Return the String value stored as an entity at
	a name equal to aString, or nil if none is found."

	^entities at: aString ifAbsent: [nil]
!

processDefaultAtts: anEvent
	"Add copies of all default attributes to anEvent for
	the element type represented."

	| attList |
	attList := defaultAttributes at: anEvent getTagName asSymbol ifAbsent: [ ^self ].
	attList do: [ :each |
		anEvent attributeAtName: each key put: each value ]
! !

!IdStxpDTD methodsFor:'initialize-release'!

addXMLCharRefs
	"Add the 5 standard XML character entities."

	self
		addEntityName: 'quot' value: $" asSymbol;
		addEntityName: 'amp' value: $& asSymbol;
		addEntityName: 'apos' value: $' asSymbol;
		addEntityName: 'lt' value: $< asSymbol;
		addEntityName: 'gt' value: $> asSymbol;
		yourself
!

initialize
	"Initialize the receiver and add the standard XML
	character entities."

	defaultAttributes := IdentityDictionary new.
	entities := Dictionary new.
	self addXMLCharRefs
! !

!IdStxpDTD methodsFor:'queries'!

isHTMLAware
	^false
! !

!IdStxpDTD class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdStxpDTD.st,v 1.6 2003/04/23 08:44:16 cg Exp $'
! !
