"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

IdStxpDTD subclass:#IdStxpHTMLDTD
	instanceVariableNames:'emptyTypes optEndTags'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdStxp'
!


!IdStxpHTMLDTD class methodsFor:'class comment'!

classComment
	"An extension of the DTD class which handles some
	HTML specific variations. It has not been well tested
	and has limited functionality. It is provided primarily
	for experimentation purposes."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdStxpHTMLDTD methodsFor:'accessing'!

allowOptionalEndTag: aTagName preceding: nextTagName
	| list |
	list := optEndTags at: aTagName asSymbol ifAbsent: [
		optEndTags at: aTagName asSymbol put: OrderedCollection new ].
	list add: nextTagName asSymbol
!

elementTypeIsEmpty: aTagName
	"Return true if elements of aTagName are always
	considered empty, else return false. Note that an 
	IdentityDictionary is used for faster lookup."

	^( emptyTypes at: aTagName asSymbol ifAbsent: [nil] ) ~~ nil
!

setElementTypeToEmpty: aTagName
	emptyTypes at: aTagName asSymbol put: true
!

typeHasOptEndTag: aTagName preceding: nextType
	^( optEndTags at: aTagName asSymbol ifAbsent: [#()] ) 
		includes: nextType asSymbol
! !

!IdStxpHTMLDTD methodsFor:'initialize-release'!

addHTMLCharRefs
	| htmlEntities |
	htmlEntities := #(
		('nbsp'         ' ')                    " no break (required) space "
		('excl'         '!!')                   " exclamation mark "
		('quot'         '"')                    " quotation mark "
		('num'          '#')                    " number sign "
		('dollar'               '$')                    " dollar sign "
		('percent'      '%')                    " percent sign "
		('amp'          '&')                    " ampersand "
		('apos'         '''')                   " apostrophe "
		('lpar'         '(')                    " left parenthesis "
		('rpar'         ')')                    " right parenthesis "
		('ast'          '*')                    " asterisk "
		('plus'         '+')                    " plus sign "
		('comma'        ',')                    " comma "
		('hyphen'       '-')                    " hyphen "
		('shy'          '-')                    " soft hyphen "
		('period'               '.')                    " full stop, period "
		('sol'          '/')                    " solidus "
		('colon'                ':')                    " colon "
		('semi'         ';')                    " semicolon "
		('lt'                   '<')                    " less-than sign "
		('equals'               '=')                    " equals sign "
		('gt'                   '>')                    " greater than "
		('quest'                '?')                    " question mark "
		('commat'       '@')                    " commercial at "
		('lsqb'         '[')                    " left square bracket "
		('bsol'         '\')                    " backslash "
		('rsqb'         ']')                    " right square bracket "
		('lowbar'               '_')                    " sollow lineidus "
		('lsquo'                '`')                    " single quotation mark "
		('lcub'         '{')                    " left curly bracket "
		('verbar'               '|')                    " vertical bar "
		('rcub'         '}')                    " right curly bracket "

		('iexcl'                '&#161;')       " inverted exclamation mark "
		('cent'         '&#162;')       " cent sign "
		('pound'                '&#163;')       " pound sign "
		('curren'               '&#164;')       " general currency sign "
		('yen'          '&#165;')       " yen sign "
		('brvbar'               '&#166;')       " broken (vertical) bar "
		('sect'         '&#167;')       " section sign "
		('copy'         '&#169;')       " copyright sign "
		('ordf'         '&#170;')       " ordinal indicator, feminine "
		('laquo'                '&#171;')       " angle quotation mark, left "
		('reg'          '&#174;')       " registered sign "
		('deg'          '&#176;')       " degree sign "
		('plusmn'       '&#177;')       " plus-or-minus sign "
		('sup2'         '&#178;')       " superscript two "
		('sup3'         '&#179;')       " superscript three "
		('micro'                '&#181;')       " micro sign "
		('para'         '&#182;')       " pilcrow (paragraph sign) "
		('middot'               '&#183;')       " middle dot "
		('sup1'         '&#185;')       " superscript one "
		('ordm'         '&#186;')       " ordinal indicator, masculine "
		('raquo'                '&#187;')       " angle quotation mark, right "
		('frac14'               '&#188;')       " fraction one-quarter "
		('frac12'               '&#189;')       " fraction one-half "
		('half'         '&#189;')       " fraction one-half "
		('frac34'               '&#190;')       " fraction three-quarters "
		('iquest'               '&#191;')       " inverted question mark "

		('Agrave'       '&#192;')       " capital A, grave accent "
		('Aacute'       '&#193;')       " capital A, acute accent "
		('Acirc'                '&#194;')       " capital A, circumflex accent "
		('Atilde'               '&#195;')       " capital A, tilde "
		('Auml'         '&#196;')       " capital A, dieresis or umlaut mark "
		('Aring'                '&#197;')       " capital A, ring "
		('AElig'                '&#198;')       " capital AE diphthong (ligature) "
		('Ccedil'               '&#199;')       " capital C, cedilla "
		('Egrave'       '&#200;')       " capital E, grave accent "
		('Eacute'       '&#201;')       " capital E, acute accent "
		('Ecirc'                '&#202;')       " capital E, circumflex accent "
		('Euml'         '&#203;')       " capital E, dieresis or umlaut mark "
		('Igrave'               '&#204;')       " capital I, grave accent "
		('Iacute'               '&#205;')       " capital I, acute accent "
		('Icirc'                '&#206;')       " capital I, circumflex accent "
		('Iuml'         '&#207;')       " capital I, dieresis or umlaut mark "
		('ETH'          '&#208;')       " capital Eth, Icelandic "
		('Ntilde'               '&#209;')       " capital N, tilde "
		('Ograve'       '&#210;')       " capital O, grave accent "
		('Oacute'       '&#211;')       " capital O, acute accent "
		('Ocirc'                '&#212;')       " capital O, circumflex accent "
		('Otilde'               '&#213;')       " capital O, tilde "
		('Ouml'         '&#214;')       " capital O, dieresis or umlaut mark "
		('times'                '&#215;')       " multiply sign "
		('Oslash'       '&#216;')       " capital O, slash "
		('Ugrave'       '&#217;')       " capital U, grave accent "
		('Uacute'       '&#218;')       " capital U, acute accent "
		('Ucirc'                '&#219;')       " capital U, circumflex accent "
		('Uuml'         '&#220;')       " capital U, dieresis or umlaut mark "
		('Yacute'       '&#221;')       " capital Y, acute accent "
		('THORN'        '&#222;')       " capital THORN, Icelandic "
		('szlig'                '&#223;')       " small sharp s, German (sz ligature) "
		('agrave'       '&#224;')       " small a, grave accent "
		('aacute'       '&#225;')       " small a, acute accent "
		('acirc'                '&#226;')       " small a, circumflex accent "
		('atilde'               '&#227;')       " small a, tilde "
		('auml'         '&#228;')       " small a, dieresis or umlaut mark "
		('aring'                '&#229;')       " small a, ring "
		('aelig'                '&#230;')       " small ae diphthong (ligature) "
		('ccedil'               '&#231;')       " small c, cedilla "
		('egrave'       '&#232;')       " small e, grave accent "
		('eacute'       '&#233;')       " small e, acute accent "
		('ecirc'                '&#234;')       " small e, circumflex accent "
		('euml'         '&#235;')       " small e, dieresis or umlaut mark "
		('igrave'               '&#236;')       " small i, grave accent "
		('iacute'               '&#237;')       " small i, acute accent "
		('icirc'                '&#238;')       " small i, circumflex accent "
		('iuml'         '&#239;')       " small i, dieresis or umlaut mark "
		('eth'          '&#240;')       " small eth, Icelandic "
		('ntilde'               '&#241;')       " small n, tilde "
		('ograve'       '&#242;')       " small o, grave accent "
		('oacute'       '&#243;')       " small o, acute accent "
		('ocirc'                '&#244;')       " small o, circumflex accent "
		('otilde'               '&#245;')       " small o, tilde "
		('ouml'         '&#246;')       " small o, dieresis or umlaut mark "
		('divide'               '&#247;')       " divide sign "
		('oslash'               '&#248;')       " small o, slash "
		('ugrave'       '&#249;')       " small u, grave accent "
		('uacute'       '&#250;')       " small u, acute accent "
		('ucirc'                '&#251;')       " small u, circumflex accent "
		('uuml'         '&#252;')       " small u, dieresis or umlaut mark "
		('yacute'       '&#253;')       " small y, acute accent "
		('thorn'                '&#254;')       " small thorn, Icelandic "
		('yuml'         '&#255;')       " small y, dieresis or umlaut mark "
	).
	htmlEntities do: [:e |
		self addEntityName: (e at: 1) value: (e at: 2) ]
!

addHTMLEmptyTypes
	| allTypes |
	allTypes := OrderedCollection new: 25.
	allTypes add: #A.
	allTypes add: #BR.
	allTypes add: #TAB.
	allTypes add: #IMG.
	allTypes add: #HR.
	allTypes add: #SPOT.
	allTypes add: #INPUT.
	allTypes add: #OVERLAY.
	allTypes add: #OVER.
	allTypes add: #ATOP.
	allTypes add: #CHOOSE.
	allTypes add: #LEFT.
	allTypes add: #RIGHT.
	allTypes add: #LINK.
	allTypes add: #RANGE.
	allTypes add: #ISINDEX.
	allTypes add: #BASE.
	allTypes add: #NEXTID.
	allTypes add: #META.
	allTypes do: [ :type |
		self setElementTypeToEmpty: type ]
!

addHTMLOptionalEndTags

	self 
		allowOptionalEndTag: #P preceding: #P;
		allowOptionalEndTag: #P preceding: #BODY;
		yourself
!

initialize
	"Initialize the receiver and add the standard HTML
	character entities."

	super initialize.
	optEndTags := IdentityDictionary new.
	emptyTypes := IdentityDictionary new.
	self 
		addHTMLCharRefs;
		addHTMLOptionalEndTags;
		addHTMLEmptyTypes
! !

!IdStxpHTMLDTD methodsFor:'queries'!

isHTMLAware
	^true
! !

!IdStxpHTMLDTD class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdStxpHTMLDTD.st,v 1.6 2003/04/23 08:44:16 cg Exp $'
! !
