"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

IdStxpParser subclass:#IdStxpHTMLParser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdStxp'
!

!IdStxpHTMLParser class methodsFor:'documentation'!

classComment
	"An extension of the parser class which handles some
	HTML specific variations."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdStxpHTMLParser methodsFor:'internal'!

processEmptyTag: aTagName event: anEvent
	"Process an HTML empty tag if aTagName has been
	specified as EMPTY and return true, else return false."

	( self getDtd elementTypeIsEmpty: aTagName ) ifFalse: [ ^false ].
	self processEmptyTagEvent: anEvent.
	^true
!

syncCoreParserVariables: docParser

	super syncCoreParserVariables: docParser.
	self getDtd isHTMLAware ifTrue: [ ^self ].
	self setDtd: IdStxpHTMLDTD new
! !

!IdStxpHTMLParser methodsFor:'parsing'!

parseStartTag: aTagName
	"Recognize and process optional end tags."

	( self getDtd typeHasOptEndTag: currentTag preceding: aTagName ) ifTrue: [
		self endTagCloseAction: currentTag ].
	super parseStartTag: aTagName
! !

!IdStxpHTMLParser methodsFor:'services'!

parseHTMLMarkup: docParser tag: tagName stream: aStream
	"Should give entityResolver a chance to change input."

	self syncCoreParserVariables: docParser.
	stream := aStream.
	currentTag := tagName.
	lastChar := aStream contents at: aStream position.
	self runBasicParseLoop
! !

!IdStxpHTMLParser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdStxpHTMLParser.st,v 1.7 2003/04/23 08:44:16 cg Exp $'
! !
