"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

Object subclass:#IdStxpHandlerBase
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdStxp'
!


!IdStxpHandlerBase class methodsFor:'class comment'!

classComment
	"This class implements HandlerBase in SAX."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdStxpHandlerBase methodsFor:'doc handler api'!

characters: aString
	"Receive notification of character data in the format
	of a String. Note that the parser shipped with this class
	will call this method rather than the standard #characters
	method defined in SAX (which passes a character array).

	The Parser will call this method to report each chunk of 
	character data. SAX parsers may return all contiguous character 
	data in a single chunk, or they may split it into several chunks; 
	however, all of the characters in any single event must come
	from the same external entity, so that the Locator provides 
	useful information.

	The application must not attempt to read from the array
	outside of the specified range.

	Note that some parsers will report whitespace using the 
	ignorableWhitespace() method rather than this one (validating 
	parsers must do so)."
!

endDocument
	"Receive notification of the end of a document.
	The SAX parser will invoke this method only once, and 
	it will be the last method invoked during the parse."
!

endElement: name
	"Receive notification of the end of an element.
	The Parser will invoke this method at the end of every 
	element in the XML document; there will be a corresponding 
	startElement() event for every endElement() event (even when 
	the element is empty)."
!

processingInstruction: target data: data
	"Receive notification of a processing instruction. 

	The Parser will invoke this method once for each processing
	instruction found: note that processing instructions may occur 
	before or after the main document element.

	A SAX parser should never report an XML declaration or a text 
	declaration using this method."
!

startDocument
	"Receive notification of the beginning of a document. 
	The SAX parser will invoke this method only once, before 
	any other methods in this interface or in
	DTDHandler (except for setDocumentLocator)."
!

startElement: name atts: atts
	"Receive notification of the beginning of an element.
	The Parser will invoke this method at the beginning of every 
	element in the XML document; there will be a corresponding 
	endElement() event for every startElement() event (even when 
	the element is empty). All of the element's content will be reported, 
	in order, before the corresponding endElement() event.

	If the element name has a namespace prefix, the prefix will 
	still be attached. Note that the attribute list provided will contain 
	only attributes with explicit values (specified or defaulted): 
	#IMPLIED attributes will be omitted."
! !

!IdStxpHandlerBase methodsFor:'entity resolver api'!

resolveEntity: publicId system: systemId
	"Allow the application to resolve external entities.

	The Parser will call this method before opening any external 
	entity except the top-level document entity (including the external 
	DTD subset, external entities referenced within the DTD, and 
	external entities referenced within the document element): the 
	application may request that the parser resolve the entity itself, 
	that it use an alternative URI, or that it use an entirely different 
	input source.

	Application writers can use this method to redirect external system 
	identifiers to secure and/or local URIs, to look up public identifiers 
	in a catalogue, or to read an entity from a database or other input 
	source (including, for example, a dialog box).

	If the system identifier is a URL, the SAX parser must resolve it fully 
	before reporting it to the application.

	Return an InputSource object describing the new input source, or nil 
	to request that the parser open a regular URI connection to the system 
	identifier. Default is return nil. Register a different entity resolver with
	the parser using the #setEntityResolver: method."

	^nil
! !

!IdStxpHandlerBase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdStxpHandlerBase.st,v 1.6 2003/04/23 08:44:16 cg Exp $'
! !
