"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

IdStxpException subclass:#IdStxpParseException
	instanceVariableNames:'publicId systemId lineNumber columnNumber'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-Indelv-IdStxp'
!


!IdStxpParseException class methodsFor:'class comment'!

classComment
	"This class simulates the SAXParseException class in Java.
	It stores additional information about a parsing error. Note that
	in this implementation all parse exceptions are raised using 
	this class, even those unrelated to SAX.
	The line and column numbers return -1 to indicate that they are 
	not supported (as defined in SAX). If anyone can find an efficient
	and accurate mechanism to calculate these send it in. For
	now no attempt is made to calculate them properly."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdStxpParseException class methodsFor:'constructors'!

forException: message pub: aPublicId sys: aSystemId line: aLine col: aColumn
	"This approximates the SAXParseException constructor
	used in Java."

	| answer |
	answer := IdStxpParseException new.
	answer initException: message pub: aPublicId sys: aSystemId line: aLine col: aColumn.
	^answer
! !

!IdStxpParseException methodsFor:'accessing'!

getColumnNumber
	^columnNumber
!

getLineNumber
	^lineNumber
!

getPublicId
	^publicId
!

getSystemId
	^systemId
! !

!IdStxpParseException methodsFor:'creation'!

initException: message pub: aPublicId sys: aSystemId line: aLine col: aColumn

	self setMessage: message.
	publicId := aPublicId.
	systemId := aSystemId.
	lineNumber := aLine.
	columnNumber := aColumn
! !

!IdStxpParseException class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdStxpParseException.st,v 1.6 2003/04/23 08:44:16 cg Exp $'
! !
