"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"


"{ Package: 'stx:goodies/xml/indelv' }"

Object subclass:#IdXMLReader
	instanceVariableNames:'currentElement document'
	classVariableNames:'Cr Lf Space Tab'
	poolDictionaries:''
	category:'XML-Indelv-IdDOMUtils'
!


!IdXMLReader class methodsFor:'class comment'!

classComment
	"This is a utility class used to parse an XML encoding and
	create a new Document instance to represent it. It utilizes
	the SAX XML parsing interface which means it can be used
	with any SAX compliant XML parser.

	The easiest way to use it is by invoking one of the class methods
	parseDocumentAtURI() or parseDocument() which accept a
	URI/URL path or a SAX InputSource respectively as parameters.
	The InputSource class provides several options for pointing
	the parser at XML resources including alternate public URIs
	and a wrapped character read stream. Note that you do not have
	to invoke these class methods to use this class, however you
	will have to properly initialize a SAX parser yourself.

	Standard normalization of the XML input is handled. This 
	includes replacing multiple separator characters (including line
	feeds) with a single space and stripping out ignorable whitespace."
!

copyright
"
    InDelv Open Source
    DOM Kernel
    Beta 1.01
    VisualWorks
    December 21, 1998


    The contents of this file are subject to the MOZILLA PUBLIC LICENSE
    Version 1.0 (the 'MPL'); you may not use this file except in
    compliance with the MPL.  A copy of the MPL has been provided
    with this file. If that copy can not be found, you can obtain another 
    on the Internet at http://www.mozilla.org/NPL/.

    Software distributed under the MPL is distributed on an 'AS IS' basis,
    WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
    for the specific language governing rights and limitations under the
    MPL.

    The Initial Developer of this code under the MPL is InDelv, Inc.
    Portions created by InDelv are
    Copyright (C) 1998 InDelv, Inc.  All Rights Reserved.
"

! !

!IdXMLReader class methodsFor:'class initialization'!

initialize
        "Initialize class variables after loading the class."

        Cr := Character value: 13.
        Lf := Character value: 10.
        Space := Character value: 32.
        Tab := Character value: 9
!

initializeAfterLoad
        "Initialize class variables after loading the class."

        self initialize
! !

!IdXMLReader class methodsFor:'examples'!

runNodeListExample
        "Return a NodeList which contains all elements in the
        common example document which have a tag name of 'Title'.
        Refer to the DOM spec for more information on how to
        traverse, query and modify a document instance."
"
        IdXMLReader runNodeListExample inspect
"
        ^IdXMLReader runSimpleXMLExample getElementsByTagName: 'Title'
!

runSimpleHTMLExample
        "Return a DOM document parsed from a simple HTML String."
"
        IdXMLReader runSimpleHTMLExample inspect
"
        ^self parseDocumentInString:
'<HTML>
<BODY bgcolor="ffffff" LINK="CC0033" VLINK="333399" ALINK="ff0000">
<A name="top">
<A HREF="http://www.zdnet.com/test.htm">
<P><B>Opera is a lightweight and efficient browser</B>

<P>Sick of the browser battle between Microsoft and Netscape? Tired of waiting for Navigator to load? Living in fear that Internet Explorer is going to take over your desktop? Then look no further. Opera Software has given all of us a snappy alternative to the browser behemoths.</P><P>Opera 3.2 is a small, lightweight browser that Jon von Tetzchner and his coworkers at Telenor--a Norwegian telecom company--created in 1994. After obtaining permission from Telenor to spin off from it, Tetzchner went on to become president of Opera Software.</P><P>Opera has a very small footprint and runs even on older machines, like a 386SX with 4MB to 8MB of RAM. Unlike the two major browsers, which require a 10MB download or more, the Opera file is under 1MB and fits on one floppy disk with room to spare. The only problem is price. Whereas IE and Navigator are free, Opera Software charges $35 (list) for its browser. But the program&apos;s ease of use and small file size more than make up for the price discrepancy.</P><P>Installing the software took us less than a minute. We found the interface to be no-frills but highly customizable. Opera automatically imported our bookmarks, and later we easily imported additional ones from other browsers.</P><P>Opera comes with a very simple e-mail client. Don&apos;t expect an advanced client with lots of options; this one lets you send mail and not much more. It is useful for hitting mailto: links on Web pages but is no substitute for a full-blown mail client.</P><P>Opera also comes with a solid news reader that has all of the basic functionality for subscribing to, reading, and replying to newsgroups. You can view threads and change message group
ngs by author, date, or subject. The news reader also lets you print messages, view messages in separate windows, and reply via e-mail. One feature that we miss, though, is the ability to mark message bodies for download as well as with headers. That minor point aside, Opera&apos;s news reader offers solid functionality for newsgroup junkies.</P><P>One of Opera&apos;s strengths is that it loads pages quickly--significantly faster than IE and Netscape in most cases. In our testing we found this a refreshing change, particularly when we just wanted to hop onto a Web site, grab a piece of information, and get out.</P><P>Opera also has a few features that the other browsers lack, including a zoom-in/zoom-out feature and support for full keyboard navigation of Web pages. We had the most fun with the zoom-in/zoom-out feature. This option lets you zoom in on and out of a Web page on the fly, making it gigantic (albeit a bit pixelated) or tiny. This is a very useful feature for those with vision disabilities. And Opera&apos;s keyboard-navigation support makes it a godsend for those of us who hate having to use a mouse.</P><P>Opera has a few drawbacks. Currently it does not support Java, although it does support JavaScript. It is available for all Windows versions but is not yet available for BeOS, Mac, OS/2, and Unix. But Opera Software is negotiating for the development of a Mac version, and an OS/2 version is in the works. BeOS and Unix versions are on Opera Software&apos;s radar but are not yet underway. Opera 4.0 (due this summer) should support Java.</P><P>Opera is definitely worth a download, especially since you can grab a fully functional 90-day trial version from Opera Softwar
&apos;s Web site. Once you&apos;ve seen Opera in action, you&apos;ll probably want to keep it on your machine for the times when you truly feel the need for speed.</P><P><B>Opera 3.2.</B> <I>List price: $35. Requires: Microsoft Windows 3.1, 95, or NT 3.51 or higher; 4MB RAM; 3MB hard disk space. Opera Software, Kjeller, Norway; +47 63 84 86 34; <A href="http://www.operasoftware.com">www.operasoftware.com.</A></I></P>

</BODY>
</HTML>'
!

runSimpleXMLExample
        "Return a DOM document parsed from a simple XML String."
"
        IdXMLReader runSimpleXMLExample inspect
"
        ^self parseDocumentInString:
'<Customers>
        <Customer>
                <Name>
                        <First>Bradley</First>
                        <Last>Bismark</Last>
                </Name>
                <Order>
                        <Number>16273</Number>
                        <Date><Day>11</Day><Month>6</Month><Year>1997</Year></Date>
                        <Item>
                                <Title>Number, the Language of Science</Title>
                                <Author>Danzig</Author>
                                <Price>5.95</Price>
                        </Item>
                        <Item>
                                <Title>Tales of Grandpa Cat</Title>
                                <Author>Wardlaw, Lee</Author>
                                <Price>6.58</Price>
                        </Item>
                </Order>
        </Customer>
        <Customer>
                <Name>
                        <Last>Higginbottom</Last>
                        <First>Amy</First>
                </Name>
                <Credit-Limit>5000</Credit-Limit>
                <Order>
                        <Number>16182</Number>
                        <Date><Month>6</Month><Day>15</Day><Year>1997</Year></Date>
                        <Item>
                                <Title>Evolution of Complexity in Animal Culture</Title>
                                <Publisher>Associated Press</Publisher>
                                <Author>Bonner</Author>
                                <Price>5.95</Price>
                        </Item>
                        <Item>
                                <Title>When We Were Very Young</Title>
                                <Author>Milne, A. A.</Author>
                                <Price>12.50</Price>
                        </Item>
                </Order>
                <Order>
                        <Number>19182</Number>
                        <Date><Year>1997</Year><Month>7</Month><Day>17</Day></Date>
                        <Item>
                                <Title>Learn Java Now</Title>
                                <Author>Stephen R. Davis</Author>
                                <Publisher>Microsoft Corporation</Publisher>
                                <Price>9.95</Price>
                        </Item>
                </Order>
        </Customer>
</Customers>'
!

runXMLDiskExample
	"Return an XML document parsed from an XML file on disk. 
	This method does not execute, however you can modify the 
	path name shown below to refer to an XML file on your network 
	and execute the code fragment in a workspace. If nil is returned, 
	the path name may be incorrect."
"
	IdXMLReader parseDocumentAtURI: 'file:/c:/xmldocs/Customers.xml'
"
! !

!IdXMLReader class methodsFor:'services'!

parseDocument: anInputSource
	"Parse the XML document described by anInputSource
	and return the result. Return nil if a SAX compliant parser
	can not be found or if anInputSource can not be resolved
	to a valid XML character stream."

	| parser builder parseError |
	parser := IdPlatformUtilities getNewSAXParser.
	parser == nil ifTrue: [ ^nil ].
	builder := IdXMLReader new.
	parser setDocumentHandler: builder.
	parseError := false.
	[ parser parse: anInputSource ] 
		ideOnException: IdException
		do: [ :ex |
			parseError := true.
			ex ideExitGracefully ].
	parseError ifTrue: [ ^nil ].
	^builder getDocument
!

parseDocumentAtURI: aSystemId
	"Parse and return the XML document stored at aSystemId 
	(which must observe the URI/URL syntax ie. 'file:/d:/dir/mydoc.xml').
	Return nil if a SAX compliant parser can not be found or if 
	aSystemId can not be located."

	| inputSource |
	inputSource := IdPlatformUtilities getNewInputSource.
	inputSource == nil ifTrue: [ ^nil ].
	inputSource setSystemId: aSystemId.
	^IdXMLReader parseDocument: inputSource
!

parseDocumentInHttpDir: directoryPath file: fileName
	"Attempt to parse and return the XML document named
	fileName stored within directoryPath. Assume that directoryPath
	is in http format. Similar methods for local file access are
	provided in the PlatformUtilities class. Return nil if the 
	document can not be found."

	^IdXMLReader parseDocumentAtURI: (
		IdPlatformUtilities combineIntoUri: directoryPath filename: fileName )
!

parseDocumentInString: aString
	"Parse and return the XML document encoded within aString.
	Return nil if the required classes can not be found."

	| inputSource |
	inputSource := IdPlatformUtilities getNewInputSource.
	inputSource == nil ifTrue: [ ^nil ].
	inputSource setCharacterStream: ( ReadStream on: aString ).
	^IdXMLReader parseDocument: inputSource
! !

!IdXMLReader methodsFor:'accessing'!

getCurrentElement
	^currentElement
!

getDocument
	^document
! !

!IdXMLReader methodsFor:'doc handler api'!

characters: aString
	"Receive notification of character data in the format
	of a String. This is a minor deviation from SAX required for
	Smalltalk implementations.

	The Parser will call this method to report each chunk of 
	character data. SAX parsers may return all contiguous character 
	data in a single chunk, or they may split it into several chunks; 
	however, all of the characters in any single event must come
	from the same external entity.

	Convert the raw characters to a valid internal format and add 
	a text node to the current element as required."

	| trueString |
	trueString := self convertRawChar: aString fromZero: 0 length: aString ideLength.
	trueString == nil ifTrue: [ ^self ].
	self addNodeToCurrent: (
		self getDocument createTextNode: trueString )
!

characters: charArray start: start length: length
	"Receive notification of character data in the standard Java
	format defined by SAX.

	The Parser will call this method to report each chunk of 
	character data. SAX parsers may return all contiguous character 
	data in a single chunk, or they may split it into several chunks; 
	however, all of the characters in any single event must come
	from the same external entity, so that the Locator provides 
	useful information.

	The application must not attempt to read from the array
	outside of the specified range.

	Convert the raw characters to a valid internal format and add 
	a text node to the current element as required."

	| trueString |
	trueString := self convertRawChar: charArray fromZero: start length: length.
	trueString == nil ifTrue: [ ^self ].
	self addNodeToCurrent: (
		self getDocument createTextNodeImpl: trueString )
!

endDocument
	"Receive notification of the end of a document.
	The SAX parser will invoke this method only once, and 
	it will be the last method invoked during the parse.

	No action is required for the receiver."
!

endElement: name
	"Receive notification of the end of an element.
	The Parser will invoke this method at the end of every 
	element in the XML document; there will be a corresponding 
	startElement() event for every endElement() event (even when 
	the element is empty).

	Reset the currentElement to the current parent node."

	self internalEndElement
!

ignorableWhitespace: charArray start: start length: length
	"Receive notification of ignorable whitespace in element content.

	Validating Parsers must use this method to report each chunk of 
	ignorable whitespace (see the W3C XML 1.0 recommendation, 
	section 2.10): non-validating parsers may also use this method if 
	they are capable of parsing and using content models.

	SAX parsers may return all contiguous whitespace in a single chunk, 
	or they may split it into several chunks; however, all of the characters 
	in any single event must come from the same external entity, so that 
	the Locator provides useful information.

	The application must not attempt to read from the array outside of 
	the specified range.

	Default is do nothing."
!

processingInstruction: target data: data
	"Receive notification of a processing instruction. 

	The Parser will invoke this method once for each processing
	instruction found: note that processing instructions may occur 
	before or after the main document element.

	A SAX parser should never report an XML declaration or a text 
	declaration using this method.

	Add a PI node to the current element."

	self addNodeToCurrent: (
		self getDocument createPIImpl: target data: data )
!

setDocumentLocator: locator
	"Receive an object for locating the origin of SAX document events.

	SAX parsers are strongly encouraged (though not absolutely required) 
	to supply a locator: if it does so, it must supply the locator to the 
	application by invoking this method before invoking any of the other 
	methods in the DocumentHandler interface.

	The locator allows the application to determine the end position of 
	any document-related event, even if the parser is not reporting an error. 
	Typically, the application will use this information for reporting its own 
	errors (such as character content that does not match an application's 
	business rules).  The information returned by the locator is probably not 
	sufficient for use with a search engine.

	Note that the locator will return correct information only during the 
	invocation of the events in this interface.  The application should not 
	attempt to use it at any other time.

	Not currently implemented. Default is do nothing."
!

startDocument
	"Receive notification of the beginning of a document. 
	The SAX parser will invoke this method only once, before 
	any other methods in this interface or in
	DTDHandler (except for setDocumentLocator).

	Create a new document and store in the receiver."

	document := IdDOMImpl createNewXmlDocument
!

startElement: name atts: atts
	"Receive notification of the beginning of an element.
	The Parser will invoke this method at the beginning of every 
	element in the XML document; there will be a corresponding 
	endElement() event for every startElement() event (even when 
	the element is empty). All of the element's content will be reported, 
	in order, before the corresponding endElement() event.

	If the element name has a namespace prefix, the prefix will 
	still be attached. Note that the attribute list provided will contain 
	only attributes with explicit values (specified or defaulted): 
	#IMPLIED attributes will be omitted.

	Create a new composite element and store in the 
	currentElement variable. Store it in the document
	if it is the root element, otherwise add it to the
	currentElement."

	| newElement |
	newElement := document createComposite: name.
	self addAttributes: atts to: newElement.
	self internalStartElement: newElement
! !

!IdXMLReader methodsFor:'internal'!

addAttributes: saxList to: anElement
	"Add attributes for all of saxList to anElement."

	| size |
	size := saxList getLength.
	size == 0 ifTrue: [ ^self ].
	0 to: size - 1 do: [ :i |
		anElement setAttribute: ( saxList getName: i ) 
			value: ( saxList getValue: i ) ]
!

addNodeToCurrent: aNode
	"Add aNode to the currentElement. If none is stored
	do nothing as the node was encountered outside of
	the XML document boundaries."

	currentElement == nil ifTrue: [ ^self ].
	currentElement appendNodeImpl: aNode
!

charIsSeparator: aChar
	"Return true if lastChar is a Space, Lf or Tab. Note
	that Cr is also tested for in case a parser is used which
	is not fully XML compliant."

	( aChar == Space 
		or: [ aChar == Lf
		or: [ aChar == Tab 
		or: [ aChar == Cr ]]] ) ifTrue: [ ^true ].
	^false
!

convertRawChar: charArray fromZero: start length: length
	"Convert a series of characters received in a parse event to
	the correct internal format. Multiple separator characters are
	replaced by a single space. If the entire string is separators
	and whitespace is not being preserved for the current element,
	return nil. Return the finished String when done."

	| addSpace buffer aChar |
	length == 0 ifTrue: [ ^nil ].
	addSpace := false.
	buffer := IdStringBuffer new: length.
	start + 1 to: start + length do: [ :i |
		aChar := charArray at: i.
		( self charIsSeparator: aChar ) 
			ifTrue: [ addSpace := true ]
			ifFalse: [
				addSpace ifTrue: [
					addSpace := false.
					buffer appendChar: Space ].
				buffer appendChar: aChar ] ].
	buffer length == 0 ifTrue: [
		"check preserve whitespace attribute stack"
		^nil ].
	addSpace ifTrue: [
		buffer appendChar: Space ].
	^buffer convertToString
!

internalEndElement
	currentElement := currentElement getParent
!

internalStartElement: anElement

	currentElement == nil ifTrue: [ 
			document == nil ifTrue: [ ^self ].
			document setRootElement: anElement ]
		ifFalse: [ self addNodeToCurrent: anElement ].
	currentElement := anElement
! !

!IdXMLReader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/indelv/IdXMLReader.st,v 1.8 2003/04/23 08:44:16 cg Exp $'
! !

IdXMLReader initialize!
