"{ Package: 'stx:goodies/xml/sixx' }"

Object subclass:#SixxConstants
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SIXX-Core'
!

SixxConstants class instanceVariableNames:'xmlVersion xmlEncoding sixxVersion sixxStartTag xmlDeclaration'

"
 No other class instance variables are inherited by this class.
"
!


!SixxConstants class methodsFor:'accessing'!

sixxVersion
	sixxVersion isNil ifTrue: [sixxVersion := '1.0'].
	^sixxVersion
!

sixxVersion: versionString 
	sixxStartTag := nil.
	sixxVersion := versionString
!

xmlEncoding
	xmlEncoding isNil ifTrue: [xmlEncoding := 'utf-8'].
	^ xmlEncoding
!

xmlEncoding: encodingString 
	xmlDeclaration := nil.
	xmlEncoding := encodingString
!

xmlVersion
	xmlVersion isNil ifTrue: [xmlVersion := '1.0'].
	^ xmlVersion
!

xmlVersion: versionString 
	xmlDeclaration := nil.
	xmlVersion := versionString
! !

!SixxConstants class methodsFor:'class initialization'!

initialize
	xmlVersion := nil.
	xmlEncoding := nil.
	sixxVersion := nil.
	sixxStartTag := nil.
	xmlDeclaration := nil
! !

!SixxConstants class methodsFor:'constants'!

sixxEndTag
	^ '</sixx>' copy
!

sixxStartTag
	sixxStartTag isNil ifTrue: [sixxStartTag := '<sixx sixx.version="' , self sixxVersion , '">'].
	^sixxStartTag
		
!

xmlDeclaration
	xmlDeclaration isNil ifTrue: [xmlDeclaration := '<?xml version="', self xmlVersion, '" encoding="', self xmlEncoding, '"?>'].
	^xmlDeclaration
	
! !

!SixxConstants class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/sixx/SixxConstants.st,v 1.1 2003/09/29 08:13:11 cg Exp $'
! !

SixxConstants initialize!
