"{ Package: 'stx:goodies/xml/sixx' }"

Object subclass:#SixxPortableUtil
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SIXX-Squeak'
!

SixxPortableUtil class instanceVariableNames:'setting'

"
 No other class instance variables are inherited by this class.
"
!


!SixxPortableUtil class methodsFor:'accessing'!

setting
	setting isNil
		ifTrue: [setting := Smalltalk
						at: #SixxSetting
						ifAbsent: [self error: 'SixxSetting is needed to run SIXX']].
	^ setting
! !

!SixxPortableUtil class methodsFor:'actions'!

classAt: localClassName in: environmentQualifier 
	"#Squeak Specific#"
	| foundClass classNameSymbol |
	foundClass := nil.
	classNameSymbol := localClassName asSymbol.
	foundClass := self setting useEnvironment
				ifTrue: [| env | 
					env := environmentQualifier isNil
								ifTrue: [Smalltalk]
								ifFalse: ["Currently Squeak does not support  
									namespace, so just ignore"
									Smalltalk].
					env
						at: classNameSymbol
						ifAbsent: []]
				ifFalse: [Smalltalk
						at: classNameSymbol
						ifAbsent: []].
	^ foundClass
!

environmentQualifierOf: aClass
	"#Squeak Specific#"
	"Currently Squeak does not support namespace, so just ignore"
	^'Smalltalk'
!

readFileStreamNamed: aFilename
        "#Squeak Specific#"
        Smalltalk isSmalltalkX ifTrue:[
            ^ (FileStream readOnlyFileNamed: aFilename) "lineEndCRLF"
        ].
        ^CrLfFileStream readOnlyFileNamed: aFilename.
!

signalException: anException
    Smalltalk isSmalltalkX ifTrue:[
        "#ST/X and VisualWorks Specific#"

        ^ anException raiseSignal
    ].

    "#Squeak Specific#"

    ^anException signal
!

writeFileStreamNamed: aFilename
        "#Squeak Specific#"
        Smalltalk isSmalltalkX ifTrue:[
            ^ (FileStream newFileNamed: aFilename) "lineEndCRLF"
        ].
        ^CrLfFileStream newFileNamed: aFilename.
! !

!SixxPortableUtil class methodsFor:'class initialization'!

initialize
	setting := nil
!

obsolete
	self initialize
! !

!SixxPortableUtil class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/sixx/SixxPortableUtil.st,v 1.4 2003/10/08 09:34:55 cg Exp $'
! !

SixxPortableUtil initialize!
