"{ Package: 'stx:goodies/xml/sixx' }"

Object subclass:#SixxWriteStream
	instanceVariableNames:'stream contextDictionary isStartTagPut isEndTagPut'
	classVariableNames:''
	poolDictionaries:''
	category:'SIXX-Core'
!


!SixxWriteStream class methodsFor:'instance creation'!

new
	^super new initialize
!

newFileNamed: fileName 
	^ self new newFileNamed: fileName
!

on: writeStream 
	^ self new on: writeStream
!

onWithDeclaration: writeStream 
	^ (self on: writeStream) xmlDeclaration
! !

!SixxWriteStream methodsFor:'accessing'!

contextDictionary

	^contextDictionary
!

contextDictionary: aValue

	contextDictionary := aValue
!

isEndTagPut

	^isEndTagPut
!

isEndTagPut: aValue

	isEndTagPut := aValue
!

isStartTagPut

	^isStartTagPut
!

isStartTagPut: aValue

	isStartTagPut := aValue
!

stream

	^stream
!

stream: aValue

	stream := aValue
! !

!SixxWriteStream methodsFor:'actions'!

rawContents
	^self stream contents
! !

!SixxWriteStream methodsFor:'file open/close'!

close
	self endTag.
	self stream close
! !

!SixxWriteStream methodsFor:'initializing'!

initialize
	contextDictionary := IdentityDictionary new.
	isStartTagPut := false.
	isEndTagPut := false. 
	
!

newFileNamed: fileName 
	stream := SixxPortableUtil writeFileStreamNamed: fileName.
	self initialize
!

on: aStream
	stream := aStream.
	
! !

!SixxWriteStream methodsFor:'writing'!

cr
	self stream cr
!

endTag
	(self isStartTagPut and: [ self isEndTagPut not] )
		ifTrue: [self stream nextPutAll: SixxConstants sixxEndTag.
			self isEndTagPut: true]
!

nextPut: anObject 
	self startTag.
	anObject
		sixxOn: self stream
		indent: 1
		context: self contextDictionary
!

nextPutAll: aCollection 
	aCollection
		do: [:obj | self nextPut: obj]
!

startTag
	self isStartTagPut
		ifFalse: [self stream nextPutAll: SixxConstants sixxStartTag.
			self isStartTagPut: true.
			self cr]
!

xmlDeclaration
	self stream nextPutAll: SixxConstants xmlDeclaration; cr
! !

!SixxWriteStream class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/sixx/SixxWriteStream.st,v 1.1 2003/09/29 08:13:48 cg Exp $'
! !
