"{ Package: 'stx:goodies/xml/sixx/examples' }"

Object subclass:#SixxCustomStoreLoadExample
	instanceVariableNames:'id cachedData'
	classVariableNames:''
	poolDictionaries:''
	category:'SIXX-Examples'
!

SixxCustomStoreLoadExample class instanceVariableNames:'instances cachedData'

"
 No other class instance variables are inherited by this class.
"
!


!SixxCustomStoreLoadExample class methodsFor:'instance creation'!

id: anInteger
	| inst |
	inst := self new id: anInteger; cachedData: thisContext; yourself.
	self instances add: inst.
	^inst
!

random
	^self id: Random new next
! !

!SixxCustomStoreLoadExample class methodsFor:'accessing'!

instances
	instances isNil ifTrue: [instances := OrderedCollection new].
	^instances
!

instances: aValue
	instances := aValue
! !

!SixxCustomStoreLoadExample class methodsFor:'class initialization'!

initialize
	"SixxCustomStoreLoadExampleClass initialize"
	instances := OrderedCollection new.
	cachedData := thisContext. "some unstorable cache data"
! !

!SixxCustomStoreLoadExample class methodsFor:'examples'!

example1
	"SixxCustomStoreLoadExample example1"
	"Writing custom serialization object"
	| inst xml |
	inst := SixxCustomStoreLoadExample random.
	xml := inst sixxString.
	Transcript cr; show: self name, ' instance sixx is...'; cr; show: xml.
	^xml

!

example2
	"SixxCustomStoreLoadExample example2"
	"Reading custom serialization object"
	|  xml inst |
	xml := self example1.
	inst := Object readSixxFrom: xml.
	Transcript cr; show: self name, ' instance is load from XML...'; cr; show: inst.
	^inst

!

example3
	"SixxCustomStoreLoadExample example3"
	"Writing custom serialization class object"
	| cls xml |
	cls := SixxCustomStoreLoadExample.
	xml := cls sixxString.
	Transcript cr; show: self name, ' class instance sixx is...'; cr; show: xml.
	^xml

!

example4
	"SixxCustomStoreLoadExample example4"
	"Reading custom serialization object"
	| xml cls |
	xml := self example3.
	self instances: nil. "class instances variable is set to nil"
	cls := self readSixxFrom: xml.
	Transcript cr; show: self name, ' cls instance is load from XML...'; cr; show: cls.
	^self instances inspect. "now class instances variable has been set"

! !

!SixxCustomStoreLoadExample class methodsFor:'sixx writing/reading'!

sixxContentOn: aStream indent: level context: dictionary 
	"override if you like"
	aStream cr.
	self instances
		sixxOn: aStream
		name: 'instances'
		indent: level + 1
		context: dictionary.
	aStream tab: level
!

sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	instVarName asString = 'instances' ifTrue: [self instances: aValue]
! !

!SixxCustomStoreLoadExample methodsFor:'accessing'!

cachedData
	^cachedData
!

cachedData: aValue
	cachedData := aValue
!

id
	^id
!

id: anInteger
	id := anInteger
! !

!SixxCustomStoreLoadExample methodsFor:'sixx writing/reading'!

sixxContentOn: aStream indent: level context: dictionary 
	"override if you like"
	aStream cr.
	self id
		sixxOn: aStream
		name: 'id'
		indent: level + 1
		context: dictionary.
	aStream tab: level
!

sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	instVarName asString = 'id' ifTrue: [self id: aValue]
! !

!SixxCustomStoreLoadExample class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/sixx/examples/SixxCustomStoreLoadExample.st,v 1.1 2003/09/29 08:14:27 cg Exp $'
! !

SixxCustomStoreLoadExample initialize!
