"{ Package: 'stx:goodies/xml/sixx/tests' }"

SixxAbstractTestCase subclass:#SixxConstantsTestCase
	instanceVariableNames:'oldSixxConstants'
	classVariableNames:''
	poolDictionaries:''
	category:'SIXX-Test'
!


!SixxConstantsTestCase methodsFor:'accessing'!

oldSixxConstants
	^ oldSixxConstants
!

oldSixxConstants: aSixxConstants
	oldSixxConstants := aSixxConstants
! !

!SixxConstantsTestCase methodsFor:'running'!

setUp
	^ self oldSixxConstants: SixxConstants
!

tearDown
	SixxConstants initialize.
	SixxConstants xmlVersion: self oldSixxConstants xmlVersion.
	SixxConstants xmlEncoding: self oldSixxConstants xmlEncoding.
	SixxConstants sixxVersion: self oldSixxConstants sixxVersion
! !

!SixxConstantsTestCase methodsFor:'tests'!

testInitialize
	SixxConstants initialize.
	self
		should: [SixxConstants xmlVersion = '1.0'].
	self
		should: [SixxConstants xmlEncoding = 'utf-8'].
	self
		should: [SixxConstants sixxVersion = '1.0']
!

testSixxStartTag
	SixxConstants initialize.
	self
		should: [SixxConstants sixxStartTag = '<sixx sixx.version="1.0">'].
	SixxConstants sixxVersion: '2.0'.
	self
		should: [SixxConstants sixxStartTag = '<sixx sixx.version="2.0">']
!

testXmlDeclaration
	SixxConstants initialize.
	self
		should: [SixxConstants xmlDeclaration = '<?xml version="1.0" encoding="utf-8"?>'].
	SixxConstants xmlVersion: '3.0'.
	SixxConstants xmlEncoding: 'sjis'.
	self
		should: [SixxConstants xmlDeclaration = '<?xml version="3.0" encoding="sjis"?>']
! !

!SixxConstantsTestCase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/sixx/tests/SixxConstantsTestCase.st,v 1.1 2003/09/29 08:29:00 cg Exp $'
! !
