"{ Package: 'stx:goodies/xml/vw' }"

"{ NameSpace: XML }"

SAXDriver subclass:#OXSAXTestDriver
	instanceVariableNames:'document'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-VW-Testing'
!

OXSAXTestDriver comment:'Author: Roger Whitney whitney@cs.sdsu.edu
Version: 1.0  
Date: 4/2/2000
License: Camp Smalltalk 

OXSAXTestDriver is used to test the OXSAXBuilder.

Instance Variables:
	document        <Stream>        Used to accumulate the text of an XML document

'
!


!OXSAXTestDriver class methodsFor:'instance creation'!

new
	^super new initialize
! !

!OXSAXTestDriver methodsFor:'accessing'!

document
	^document
! !

!OXSAXTestDriver methodsFor:'content handler'!

characters: aString

	document nextPutAll: aString.
!

endDocument
	document 
		nextPutAll: 'End document';
		cr.
!

endElement: localName namespace: nameSpace prefix: nameSpacePrefix
	document 
		nextPutAll: '</';
		nextPutAll: localName asString;
		nextPutAll: '>';
		cr.
!

ignorableWhitespace: aString
!

processingInstruction: target data: data

	document
		nextPutAll: '<? '; 
		nextPutAll: target;
		nextPutAll: ' ';
		nextPutAll: data;
		nextPutAll: '?>';
		cr
!

startDocument
	document 
		nextPutAll: 'Start document';
		cr.
!

startElement: localName namespace: nameSpace prefix: nameSpacePrefix attributes: atts 
	document
		nextPutAll: '<';
		nextPutAll: nameSpace , ':';
		nextPutAll: localName asString.
	atts notNil 
		ifTrue: 
			[document nextPutAll: ' '.
			atts do: 
					[:each | 
					document
						nextPutAll: each tag namespace;
						nextPut: $:;
						nextPutAll: each tag type;
						nextPut: $=;
						nextPutAll: each value]
				separatedBy: [document nextPutAll: ' ']].
	document
		nextPutAll: '>';
		cr
! !

!OXSAXTestDriver methodsFor:'initialize'!

initialize
	document := WriteStream on: (String new: 50)
! !

!OXSAXTestDriver class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/vw/OXSAXTestDriver.st,v 1.3 2003/04/23 08:44:17 cg Exp $'
! !
