"{ Package: 'stx:goodies/xml/vw' }"

LibraryDefinition subclass:#stx_goodies_xml_vw
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_xml_vw class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:libbasic'    "Character - referenced by XML::IDREFS_AT>>validateValueOf:for: "
        #'stx:libbasic2'    "IntegerArray - referenced by XML::Document>>treePositionOf: "
        #'stx:libbasic3'    "ClassDefinitionChange - referenced by XML::SourceScannerNodeBuilder>>scan_class: "
    )
! !

!stx_goodies_xml_vw class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIBXMLVW_BASE
LIB_BASE=$(LIBXMLVW_BASE)
'
! !

!stx_goodies_xml_vw class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'XML::AnyPattern'
        #'XML::Attribute'
        #'XML::AttributeDef'
        #'XML::AttributeType'
        #'XML::CDATA_AT'
        #'XML::ChoicePattern'
        #'XML::Comment'
        #'XML::ComplexPattern'
        #'XML::ConcretePattern'
        #'XML::DOM_SAXDriver'
        #'XML::DiscardingNodeBuilder'
        #'XML::Document'
        #'XML::DocumentFragment'
        #'XML::DocumentType'
        #'XML::ENTITIES_AT'
        #'XML::ENTITY_AT'
        #'XML::Element'
        #'XML::ElementContext'
        #'XML::EmptyPattern'
        #'XML::Entity'
        #'XML::Enumeration_AT'
        #'XML::GeneralEntity'
        #'XML::IDREFS_AT'
        #'XML::IDREF_AT'
        #'XML::ID_AT'
        #'XML::InitialPattern'
        #'XML::InvalidSignal'
        #'XML::MalformedSignal'
        #'XML::MixedPattern'
        #'XML::ModifiedPattern'
        #'XML::NMTOKENS_AT'
        #'XML::NMTOKEN_AT'
        #'XML::NOTATION_AT'
        #'XML::NamePattern'
        #'XML::Node'
        #'XML::NodeBuilder'
        #'XML::NodeTag'
        #'XML::Notation'
        #'XML::OXSAXTestDriver'
        (#'XML::OXSAXTests' autoload)
        #'XML::PCDATAPattern'
        #'XML::PI'
        #'XML::ParameterEntity'
        #'XML::Pattern'
        (#'XML::PseudoCharacterTable' autoload)
        #'XML::SAXBuilder'
        #'XML::SAXDriver'
        (#'XML::SAXIndenter' autoload)
        #'XML::SAXLocator'
        #'XML::SAXWriter'
        #'XML::SequencePattern'
        #'XML::SourceNodeBuilder'
        #'XML::SourceScannerNodeBuilder'
        #'XML::StreamWrapper'
        #'XML::TerminalPattern'
        (#'XML::TestXMLParser' autoload)
        #'XML::Text'
        #'XML::URIResolver'
        #'XML::XMLNodeBuilder'
        #'XML::XMLParser'
        #'XML::XMLParserStX'
        (#'XML::XMLParserTests' autoload)
        #'XML::XMLSignal'
        #'stx_goodies_xml_vw'
        #'XML::NodeSet'
    )
!

extensionMethodNames
    ^ #(
    )
! !

!stx_goodies_xml_vw class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X XML Framework (VW)'
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ nil
! !

!stx_goodies_xml_vw class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/vw/stx_goodies_xml_vw.st,v 1.15 2009/11/03 14:22:09 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/vw/stx_goodies_xml_vw.st,v 1.15 2009/11/03 14:22:09 cg Exp $'
! !
