"{ Package: 'stx:goodies/xml/xmlrpc' }"

"{ NameSpace: XMLRPC }"

XMLRPCException subclass:#XMLRPCFaultException
	instanceVariableNames:'faultCode faultMessage'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Errors'
!

XMLRPCFaultException comment:'Exception thrown to indicate an XML-RPC fault.'
!


!XMLRPCFaultException class methodsFor:'signaling'!

signal:faultCode withMessage:faultMessage 
    "Signal an XMLRPC fault with the given fault code and message."

    |message|

    message := faultMessage ? ('Error: ',faultCode printString).
    (XMLRPCFaultException new)
        faultCode:faultCode;
        faultMessage:faultMessage;
        "signal: faultMessage"
        errorString: message;
        raise

    "Modified: / 13-05-2010 / 18:10:05 / cg"
! !

!XMLRPCFaultException methodsFor:'accessing'!

faultCode
    "Get the fault code."
    
    ^ faultCode
!

faultCode:to 
    "Set the fault code to the given value."
    
    faultCode := to
!

faultMessage
    "Get the fault message."
    
    ^ faultMessage
!

faultMessage:to 
    "Set the fault message to the given value."
    
    faultMessage := to
! !

!XMLRPCFaultException class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/XMLRPCFaultException.st,v 1.6 2010/05/14 22:56:03 cg Exp $'
! !
