"
 COPYRIGHT (c) 2010 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/xml/xmlrpc/examples' }"

"{ NameSpace: XMLRPC }"

XMLRPCProxy subclass:#XMLRPC_ExpeccoNETClient
	instanceVariableNames:'sessionKey'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Client'
!

!XMLRPC_ExpeccoNETClient class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2010 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Demonstrates how to communicate with ExpeccoNET via the XML-RPC interface.

	|eNet|

	eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
	eNet invokeMethod:'system.listMethods'.
	eNet invokeMethod:'system.methodSignature' with:'expeccoNET1.getUsers'.
	eNet invokeMethod:'system.methodHelp' with:'expeccoNET1.getUsers'.
	eNet invokeMethod:'system.versionInfo'.

    fetch list of users
	|eNet users|

	eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
	eNet login:'admin' password:'admin'.
	users := eNet getUsers.
	eNet logout.
	users

    fetch list of users and info for each
	|eNet users|

	eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
	eNet login:'admin' password:'admin'.
	users := eNet getUsers.
	users := users collect:[:u | eNet getUser:(u at:'loginName')].
	eNet logout.
	users

    fetch list of projects and info for each
	|eNet projects|

	eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
	eNet login:'cg' password:'cg'.
	projects := eNet getProjects.
	projects := projects collect:[:u | eNet getProject:(u at:'projectName')].
	eNet logout.
	projects
"
! !

!XMLRPC_ExpeccoNETClient methodsFor:'requests'!

addComment:comment toArtefact:artefactUUID
    "add a comment to an artefact"

    ^ self invokeMethod:'expeccoNET1.addComment' with:sessionKey with:artefactUUID printString with:comment.

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     ret := eNet addComment:'automatic comment' toArtefact:'12345'.
     eNet logout.
     ret
    "
!

createDefect:defectData
    "add a new defect.
     defectData is a dictionary consisting of (* = required):
	summary (*)
	project
	projectID
	defectType
	severity

     returns the new defect's ID as string
    "

    ^ self invokeMethod:'expeccoNET1.createDefect' with:sessionKey with:defectData.

    "
     |eNet defectData ret|

     defectData := Dictionary new.
     defectData at:'summary' put:'This is a new defect for mb'.
     defectData at:'project' put:'stx'.
     defectData at:'defectType' put:'functionalDefect'.
     defectData at:'severity' put:'normal'.

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'admin' password:'admin'.
     ret := eNet createDefect:defectData.
     eNet logout.
     ret
    "
!

createProject:projectData
    "add a new project.
     projectData is a dictionary consisting of (* = required):
	projectName (*)
	summary

     returns the new project's ID as string
    "

    ^ self invokeMethod:'expeccoNET1.createProject' with:sessionKey with:projectData.

    "
     |eNet projectData ret|

     projectData := Dictionary new.
     projectData at:'projectName' put:'stx'.
     projectData at:'summary' put:'This is a new project'.

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'admin' password:'admin'.
     ret := eNet createProject:projectData.
     eNet logout.
     ret
    "
!

createUser:userData
    "add a new user.
     userData is a dictionary consisting of (* = required):
	loginName (*)
	firstName
	lastName
	password
	email
	xmpp
	description

     returns the new user's ID as string
    "

    ^ self invokeMethod:'expeccoNET1.createUser' with:sessionKey with:userData.

    "
     |eNet userData ret|

     userData := Dictionary new.
     userData at:'loginName' put:'ff88'.
     userData at:'firstName' put:'Fabian'.
     userData at:'lastName' put:'Fidibus'.

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'admin' password:'admin'.
     ret := eNet createUser:userData.
     eNet logout.
     ret
    "
!

createUserWithLoginName:loginName firstName:firstName lastName:lastName
    "add a new user"

    |userData|

    userData := Dictionary new
		    at:'loginName' put:loginName;
		    at:'firstName' put:firstName;
		    at:'lastName' put:lastName;
		    yourself.
    ^ self createUser:userData

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     ret := eNet createUserWithLoginName:'ff' firstName:'Florian' lastName:'Fidibus'.
     eNet logout.
     ret
    "
!

getArtefact:artefactUUID
    "get any artefact's full info, give its uuid (string)"

    ^ self invokeMethod:'expeccoNET1.getArtefact' with:sessionKey with:artefactUUID printString.

    "
     |eNet u ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     u := eNet getUser:'cg'.
     ret := eNet getArtefact:(u at:'id').
     eNet logout.
     ret
    "

    "
     |eNet p ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     p := eNet getProject:'p1'.
     ret := eNet getArtefact:(p at:'id').
     eNet logout.
     ret
    "

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     ret := eNet getArtefact:'8909f0f0-e7b1-11dc-a474-00030d1fe8cf'.
     eNet logout.
     ret
    "

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'admin' password:'admin'.
     ret := eNet getArtefact:'419f4910-35cd-11df-84bc-00ff7b08316c'.
     eNet logout.
     ret
    "
!

getOpenDefects
    "get a list of open defects"

    ^ self invokeMethod:'expeccoNET1.getOpenDefects' with:sessionKey

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     ret := eNet getOpenDefects.
     eNet logout.
     ret
    "
!

getProject:aProjectName
    "get a particular project's info"

    ^ self invokeMethod:'expeccoNET1.getProject' with:sessionKey with:aProjectName.

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'admin' password:'admin'.
     ret := eNet getProject:'stx'.
     eNet logout.
     ret
    "
!

getProjects
    "get a list of projects"

    ^ self invokeMethod:'expeccoNET1.getProjects' with:sessionKey.

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'admin' password:'admin'.
     ret := eNet getProjects.
     eNet logout.
     ret
    "
!

getServerInfo
    "get statistic and version info"

    ^ self invokeMethod:'expeccoNET1.getServerInfo' with:sessionKey.

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     ret := eNet getServerInfo.
     eNet logout.
     ret
    "
!

getUser:aUsername
    "get a particular user's info"

    ^ self invokeMethod:'expeccoNET1.getUser' with:sessionKey with:aUsername.

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     ret := eNet getUser:'cg'.
     eNet logout.
     ret
    "
!

getUsers
    "get a list of users"

    ^ self invokeMethod:'expeccoNET1.getUsers' with:sessionKey

    "
     |eNet ret|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     ret := eNet getUsers.
     eNet logout.
     ret
    "
!

login:userName password:password
    "start an xml-rpc session"

    sessionKey := self invokeMethod:'expeccoNET1.login' with:userName with:password.

    "
     |eNet|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     eNet logout.
    "
!

logout
    "end an xml-rpc session"

    self invokeMethod:'expeccoNET1.logout' with:sessionKey.
    sessionKey := nil.

    "
     |eNet|

     eNet := self withUrl:'http://localhost:8082/rpc/xmlrpc'.
     eNet login:'cg' password:'cg'.
     eNet logout
    "
! !

!XMLRPC_ExpeccoNETClient class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/examples/XMLRPC_ExpeccoNETClient.st,v 1.9 2010/05/13 12:26:41 cg Exp $'
! !
