"
 COPYRIGHT (c) 2010 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:goodies/xml/xmlrpc/examples' }"

"{ NameSpace: XMLRPC }"

XMLRPCProxy subclass:#JIRAClient
	instanceVariableNames:'sessionKey'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Client'
!

!JIRAClient class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2010 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Demonstrates how to communicate with JIRA via the XML-RPC interface.

                                                                        [exBegin]
    |jira|

    jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
    jira login:'cg' password:'cg'.
    jira logout
                                                                        [exEnd]

"
! !

!JIRAClient methodsFor:'requests'!

addComment:comment toIssue:issueKey
    ^ self invokeMethod:'jira1.addComment' with:sessionKey with:issueKey with:comment.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira addComment:'automatic comment' toIssue:'STX-127'.   
     jira logout. 
     ret
    "
!

createIssue:issueData
    ^ self invokeMethod:'jira1.createIssue' with:sessionKey with:issueData.

    "
     |jira issue ret|

     issue := Dictionary new.
     issue at:'project' put:'STX'.
     issue at:'type' put:1.
     issue at:'summary' put:'Issue created via XMLRPC'.
     issue at:'assignee' put:'cg'.
     issue at:'description' put:'Created with an ST/X client'.

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira createIssue:issue.   
     jira logout.
     ret 
    "
!

getComponentsForProjectWithKey:projectKey  
    ^ self invokeMethod:'jira1.getComponents' with:sessionKey with:projectKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getComponentsForProjectWithKey:'STX'.   
     jira logout.
     ret
->
    Dictionary(
        subTask->false 
        description->A problem which impairs or prevents the functions of the product. 
        icon->http://localhost:8081/images/icons/bug.gif 
        name->Bug 
        id->1)
    Dictionary(
        subTask->false 
        description->A new feature of the product, which has yet to be developed. 
        icon->http://localhost:8081/images/icons/newfeature.gif 
        name->New Feature 
        id->2)
    Dictionary(
        subTask->false 
        description->A task that needs to be done. 
        icon->http://localhost:8081/images/icons/task.gif 
        name->Task 
        id->3)
    Dictionary(
        subTask->false 
        description->An improvement or enhancement to an existing feature or task. 
        icon->http://localhost:8081/images/icons/improvement.gif 
        name->Improvement 
        id->4)



    "
!

getIssue:issueKey
    ^ self invokeMethod:'jira1.getIssue' with:sessionKey with:issueKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getIssue:'STX-127'.   
     jira logout.
     ret
->
            affectsVersions .. : #()
            assignee ......... : 'cg'
            components ....... : #()
            created .......... : '2010-03-20 20:23:28.78'
            customFieldValues  : #()
            description ...... : 'Created with an ST/X client'
            fixVersions ...... : #()
            id ............... : '10130'
            key .............. : 'STX-127'
            priority ......... : '3'
            project .......... : 'STX'
            reporter ......... : 'cg'
            status ........... : '1'
            summary .......... : 'Issue created via XMLRPC'
            type ............. : '1'
            updated .......... : '2010-03-20 20:30:21.767'
            votes ............ : '0'
    "
!

getIssueTypes
    ^ self invokeMethod:'jira1.getIssueTypes' with:sessionKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'foo' password:'bar'.
     ret := jira getIssueTypes.
     jira logout.
     ret
->
        Dictionary(
            description->The issue is open and ready for the assignee to start work on it. 
            icon->http://localhost:8081/images/icons/status_open.gif    
            name->Open 
            id->1)
        Dictionary(
            description->This issue is being actively worked on at the moment by the assignee. 
            icon->http://localhost:8081/images/icons/status_inprogress.gif 
            name->In Progress 
            id->3)
        Dictionary(
            description->This issue was once resolved, but the resolution was deemed incorrect. From here issues are either marked assigned or resolved. 
            icon->http://localhost:8081/images/icons/status_reopened.gif 
            name->Reopened 
            id->4)
        Dictionary(
            description->A resolution has been taken, and it is awaiting verification by reporter. From here issues are either reopened, or are closed. 
            icon->http://localhost:8081/images/icons/status_resolved.gif 
            name->Resolved 
            id->5)
        Dictionary(
            description->The issue is considered finished, the resolution is correct. Issues which are closed can be reopened. 
            icon->http://localhost:8081/images/icons/status_closed.gif 
            name->Closed 
            id->6)
    "

    "Created: / 11-07-2011 / 16:01:08 / cg"
!

getIssueTypesForProject:projectID   
    ^ self invokeMethod:'jira1.getIssueTypesForProject' with:sessionKey with:projectID printString.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getIssueTypesForProject:10000.   
     jira logout.
     ret
->
    Dictionary(
        subTask->false 
        description->A problem which impairs or prevents the functions of the product. 
        icon->http://localhost:8081/images/icons/bug.gif 
        name->Bug 
        id->1)
    Dictionary(
        subTask->false 
        description->A new feature of the product, which has yet to be developed. 
        icon->http://localhost:8081/images/icons/newfeature.gif 
        name->New Feature 
        id->2)
    Dictionary(
        subTask->false 
        description->A task that needs to be done. 
        icon->http://localhost:8081/images/icons/task.gif 
        name->Task 
        id->3)
    Dictionary(
        subTask->false 
        description->An improvement or enhancement to an existing feature or task. 
        icon->http://localhost:8081/images/icons/improvement.gif 
        name->Improvement 
        id->4)



    "
!

getIssuesFromFilter:filterId
    ^ self 
        invokeMethod:'jira1.getIssuesFromFilter' 
        withArgs:(Array with:sessionKey with:filterId printString).

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getIssuesFromFilter:0.   
     jira logout.
     ret                    
->
    Dictionary(
        subTask->false 
        description->A problem which impairs or prevents the functions of the product. 
        icon->http://localhost:8081/images/icons/bug.gif 
        name->Bug 
        id->1)
    Dictionary(
        subTask->false 
        description->A new feature of the product, which has yet to be developed. 
        icon->http://localhost:8081/images/icons/newfeature.gif 
        name->New Feature 
        id->2)
    Dictionary(
        subTask->false 
        description->A task that needs to be done. 
        icon->http://localhost:8081/images/icons/task.gif 
        name->Task 
        id->3)
    Dictionary(
        subTask->false 
        description->An improvement or enhancement to an existing feature or task. 
        icon->http://localhost:8081/images/icons/improvement.gif 
        name->Improvement 
        id->4)



    "
!

getIssuesFromJqlSearch:jqlSearch maxNumberOfResults:maxNumResults
    "/ sigh - not supported
    ^ self 
        invokeMethod:'jira1.getIssuesFromJqlSearch' 
        withArgs:(Array with:sessionKey with:jqlSearch with:maxNumResults).

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getIssuesFromJqlSearch:'project = STX' maxNumberOfResults:10.   
     jira logout.
     ret                    
->
    "
!

getIssuesFromTextSearch:searchTerm
    "/ sigh - seems to not work
    ^ self 
        invokeMethod:'jira1.getIssuesFromTextSearch' 
        withArgs:(Array with:sessionKey with:searchTerm).

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getIssuesFromTextSearch:'my'.   
     jira logout.
     ret                    
->
    Dictionary(
        subTask->false 
        description->A problem which impairs or prevents the functions of the product. 
        icon->http://localhost:8081/images/icons/bug.gif 
        name->Bug 
        id->1)
    Dictionary(
        subTask->false 
        description->A new feature of the product, which has yet to be developed. 
        icon->http://localhost:8081/images/icons/newfeature.gif 
        name->New Feature 
        id->2)
    Dictionary(
        subTask->false 
        description->A task that needs to be done. 
        icon->http://localhost:8081/images/icons/task.gif 
        name->Task 
        id->3)
    Dictionary(
        subTask->false 
        description->An improvement or enhancement to an existing feature or task. 
        icon->http://localhost:8081/images/icons/improvement.gif 
        name->Improvement 
        id->4)



    "
!

getIssuesFromTextSearchWithProject:projectName searchTerm:searchTerm maxHits:maxHits   
    ^ self 
        invokeMethod:'jira1.getIssuesFromTextSearchWithProject' 
        withArgs:(Array with:sessionKey with:(Array with:projectName) with:searchTerm with:maxHits).

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getIssuesFromTextSearchWithProject:'STX' searchTerm:'- 0 1 2 3 4 5 6 7 8 9' maxHits:100.   
     jira logout.
     ret                    

     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getIssuesFromTextSearchWithProject:'STX' searchTerm:'' maxHits:100.   
     jira logout.
     ret                    
->
    "
!

getProject:aProjectKey
    ^ self invokeMethod:'jira1.getProject' with:sessionKey with:aProjectKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getProject:'STX'.   
     jira logout. 
     ret     

-->

        Array(Dictionary('name'->'stx' 
                         'description'->'Dies ist ein Demo Projekt.' 
                         'key'->'STX' 
                         'projectUrl'->'' 
                         'url'->'http://localhost:8081/browse/STX' 
                         'id'->'10000' 
                         'lead'->'cg'))
    "
!

getProjects
    ^ self invokeMethod:'jira1.getProjectsNoSchemes' with:sessionKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getProjects.   
     jira logout. 
     ret     

-->

        Array(Dictionary('name'->'stx' 
                         'description'->'Dies ist ein Demo Projekt.' 
                         'key'->'STX' 
                         'projectUrl'->'' 
                         'url'->'http://localhost:8081/browse/STX' 
                         'id'->'10000' 
                         'lead'->'cg'))
    "
!

getResolutions
    ^ self 
        invokeMethod:'jira1.getResolutions' 
        with:sessionKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getResolutions.   
     jira logout.
     ret                    
->
     Array(
        Dictionary(
            'description'->'A fix for this issue is checked into the tree and tested.' 
            'name'->'Fixed' 
            'id'->'1') 
        Dictionary(
            'description'->'The problem described is an issue which will never be fixed.' 
            'name'->'Won''t Fix' 
            'id'->'2') 
        Dictionary(
            'description'->'The problem is a duplicate of an existing issue.' 
            'name'->'Duplicate' 
            'id'->'3') 
        Dictionary(
            'description'->'The problem is not completely described.' 
            'name'->'Incomplete' 
            'id'->'4') 
        Dictionary(
            'description'->'All attempts at reproducing this issue failed, or not enough information was available to reproduce the issue. Reading the code produces no clues as to why this behavior would occur. If more information appears later, please reopen the issue.' 
            'name'->'Cannot Reproduce' 
            'id'->'5'))
    "
!

getServerInfo
    ^ self invokeMethod:'jira1.getServerInfo' with:sessionKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getServerInfo.
     jira logout.
     ret
->
        baseUrl .... : 'http://localhost:8081'
        buildDate .. : 'Sun Feb 14 00:00:00 CET 2010'
        buildNumber  : '472'
        edition .... : 'Enterprise'
        serverTime . : 'com.atlassian.jira.rpc.soap.beans.RemoteTimeInfo@5b5f7e'
        version .... : '4.0.2'

    "
!

getStatuses
    ^ self invokeMethod:'jira1.getStatuses' with:sessionKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getStatuses.
     jira logout.
     ret
->
        Dictionary(
            description->The issue is open and ready for the assignee to start work on it. 
            icon->http://localhost:8081/images/icons/status_open.gif    
            name->Open 
            id->1)
        Dictionary(
            description->This issue is being actively worked on at the moment by the assignee. 
            icon->http://localhost:8081/images/icons/status_inprogress.gif 
            name->In Progress 
            id->3)
        Dictionary(
            description->This issue was once resolved, but the resolution was deemed incorrect. From here issues are either marked assigned or resolved. 
            icon->http://localhost:8081/images/icons/status_reopened.gif 
            name->Reopened 
            id->4)
        Dictionary(
            description->A resolution has been taken, and it is awaiting verification by reporter. From here issues are either reopened, or are closed. 
            icon->http://localhost:8081/images/icons/status_resolved.gif 
            name->Resolved 
            id->5)
        Dictionary(
            description->The issue is considered finished, the resolution is correct. Issues which are closed can be reopened. 
            icon->http://localhost:8081/images/icons/status_closed.gif 
            name->Closed 
            id->6)
    "
!

getUser:userName
    ^ self invokeMethod:'jira1.getUser' with:sessionKey with:userName.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getUser:'cg'.   
     jira logout.
     ret
    "
!

getVersions:aProjectKey
    ^ self invokeMethod:'jira1.getVersions' with:sessionKey with:aProjectKey.

    "
     |jira ret|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira getVersions:'STX'.   
     jira logout. 
     ret     

-->
    "
!

login:userName password:password
    sessionKey := self invokeMethod:'jira1.login' with:userName with:password.

    "
     |jira|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     jira logout.
    "
!

logout
    self invokeMethod:'jira1.logout' with:sessionKey.
    sessionKey := nil.

    "
     |jira|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     jira logout
    "
!

updateIssue:issueKey fields:fieldDict
    "WARNING: the updateIssue interface is brainDamaged: it req's vector elements !!"

    ^ self invokeMethod:'jira1.updateIssue' with:sessionKey with:issueKey with:fieldDict.

    "
     |jira ret fields|

     fields := Dictionary new.
     fields at:'priority' put:#( '4' ).                 '<- brainDamaged Array here'.
     fields at:'summary'  put:#( 'Changed Summary' ).   '<- brainDamaged Array here'.

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira login:'cg' password:'cg'.
     ret := jira updateIssue:'STX-127' fields:fields.   
     jira logout.
     ret      
->
            affectsVersions .. : #()
            assignee ......... : 'cg'
            components ....... : #()
            created .......... : '2010-03-20 20:23:28.78'
            customFieldValues  : #()
            description ...... : 'Created with an ST/X client'
            fixVersions ...... : #()
            id ............... : '10130'
            key .............. : 'STX-127'
            priority ......... : '4'
            project .......... : 'STX'
            reporter ......... : 'cg'
            status ........... : '1'
            summary .......... : 'Issue created via XMLRPC'
            type ............. : '1'
            updated .......... : '2010-03-20 20:54:28.984'
            votes ............ : '0'
    "
!

validateLogin:userName password:password
    ^ self invokeMethod:'jira1.validateLogin' with:userName with:password.

    "
     |jira|

     jira := self withUrl:'http://localhost:8081/rpc/xmlrpc'.
     jira validateLogin:'cg' password:'cg'
    "
! !

!JIRAClient class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/examples/XMLRPC_JIRAClient.st,v 1.11 2011/07/11 16:01:13 cg Exp $'
! !
