"{ Package: 'stx:goodies/xml/xmlrpc/server' }"

"{ NameSpace: XMLRPC }"

XML_or_JSON_RPCServerRequest subclass:#JSON_RPCServerRequest
	instanceVariableNames:'id needsResponse'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Server'
!

!JSON_RPCServerRequest class methodsFor:'documentation'!

documentation
"
    keeps a request's data
"
! !

!JSON_RPCServerRequest class methodsFor:'instance creation'!

fromRequest:xmlStringOrStream 
    |data r method parameters id|

    r := self new.
    parameters := OrderedCollection new.

    data := JSONReader fromJSON:xmlStringOrStream.
    (data at:'jsonrpc' ifAbsent:nil) = '2.0' ifTrue:[
        method := data at:'method'.
        parameters := data at:'params'.
        id := data at:'id' ifAbsent:nil.
        r needsResponse:(id notNil).
    ] ifFalse:[
        self halt
    ].
    r id:id methodCall:method params:parameters.
    ^ r
! !

!JSON_RPCServerRequest methodsFor:'accessing'!

id
    ^ id
!

id:something
    id := something.
!

id:idArg methodCall:methodCallArg params:paramsArg 
    methodCall := methodCallArg.
    params := paramsArg.
    id := idArg.
!

needsResponse
    ^ needsResponse
!

needsResponse:something
    needsResponse := something.
! !

!JSON_RPCServerRequest methodsFor:'encoding'!

encodeResponse:resultValue
    |stream|

    stream := WriteStream on:(String new:100).
self halt.
"/    stream nextPutAll:'<?xml version="1.0"?><methodResponse><params><param>'.
"/    [
"/        stream nextPutAll:(XMLRPCEncoder new encode:resultValue) "/ret asXMLRPCString
"/    ] on:Error do:[
"/        XMLRPCReturnError raiseErrorString:('Could not encode returned value "' , resultValue printString , '"')
"/    ].
"/    stream nextPutAll:'</param></params></methodResponse>'.
    ^ stream contents
! !

!JSON_RPCServerRequest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/server/JSON_RPCServerRequest.st,v 1.4 2010/03/26 10:47:03 cg Exp $'
! !
