"{ Package: 'stx:goodies/xml/xmlrpc/server' }"

Object subclass:#XMLRPCErrorHandler
	instanceVariableNames:'error'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Server'
!

XMLRPCErrorHandler comment:'This is the error handler for XMLRPC errors'
!


!XMLRPCErrorHandler methodsFor:'accessing'!

error
	"Answer the receiver's 'error'."

	^error
!

error: anObject
	"Set the receiver's instance variable 'error' to be anObject."

	error := anObject
!

errorMessage
    |str errorDict|

    errorDict := Dictionary new.
    (error class canUnderstand:#faultCode) ifTrue:[
        errorDict at:#faultCode put:error faultCode
    ] ifFalse:[
        errorDict at:#faultCode put:"10" -32400 "---> system error"
    ].
    errorDict at:#faultString put:error messageText.
    str := WriteStream on:(String new:1000).
    str
        nextPutAll:'<?xml version="1.0"?><methodResponse><fault>';
        nextPutAll:errorDict asXMLRPCString;
        nextPutAll:'</fault></methodResponse>'.
    ^ str contents
! !

!XMLRPCErrorHandler class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/server/XMLRPCErrorHandler.st,v 1.3 2010/03/20 17:49:44 cg Exp $'
! !
