"{ Package: 'stx:goodies/xml/xmlrpc/server' }"

Object subclass:#XMLRPCHttpModule
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Server'
!

XMLRPCHttpModule class instanceVariableNames:'port service'

"
 No other class instance variables are inherited by this class.
"
!

XMLRPCHttpModule comment:'This comanche module handles incoming requests for a XMLRPC server'
!

!XMLRPCHttpModule class methodsFor:'documentation'!

documentation
"
    not used/needed for ST/X
"
! !

!XMLRPCHttpModule class methodsFor:'as yet unclassified'!

createServiceOnPort:aPort 
    |serv xs ma|

    Smalltalk at:#HttpService
        ifPresent:[:hs | 
            xs := XMLRPCHttpModule new.
            ma := ModuleAssembly core.
            ma alias:'/xmlrpc' to:[ ma addPlug:[:request | xs process:request ] ].
            serv := HttpService on:aPort named:'xmlrpcd'.
            serv plug:ma rootModule.
            ^ serv
        ].

    Smalltalk at:#ComancheNetService
        ifPresent:[:cns | 
            xs := XMLRPCHttpModule new.
            serv := (ComancheNetService named:'xmlrpc' onPort:port) module:xs.
            ^ serv
        ]
!

initialize
    Smalltalk isSmalltalkX ifFalse:[
        Smalltalk addToStartUpList: self after: AutoStart.
        Smalltalk addToShutDownList: self
    ].
!

pause
    service 
        ifNotNil:[
            service unregister.
            service := nil
        ]
!

serviceOn:aPort 
    ^ ComancheNetService named:'XMLRPC' onPort:aPort
!

setDebugMode
        service setDebugMode.
!

setDeploymentMode
     service setDeploymentMode.
!

setVerboseMode
   service setVerboseMode.
!

shutDown
	self stop
!

shutdown
    self pause
!

start
    ^ self startOn: 8082

    "
     self start
    "
!

startKom61
     ^ self start
!

startOn:aPort 
    self stop.
    port := aPort.
    service := self createServiceOnPort:aPort.
    service start
!

startUp
       port ifNotNil: [self startOn: port]
!

stop
    self pause.
    port := nil.
! !

!XMLRPCHttpModule methodsFor:'as yet unclassified'!

process:request 
    |xrReq|

    [
        xrReq := XMLRPCServerRequest 
                    fromRequest:(request stream next:request contentLength).
        xrReq targetURI:request url.
        ^ HttpResponse fromMIMEDocument:(MIMEDocument contentType:'text/xml'
                    content:xrReq methodResponse)
    ] on:Error do:[:e | 
        ^ HttpResponse 
                fromMIMEDocument:(MIMEDocument contentType:'text/xml'
                content:(XMLRPCErrorHandler new error:e) errorMessage)
    ]
! !

!XMLRPCHttpModule class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/server/XMLRPCHttpModule.st,v 1.3 2010/03/20 14:04:17 cg Exp $'
! !

XMLRPCHttpModule initialize!
