"{ Package: 'stx:goodies/xml/xmlrpc/server' }"

"{ NameSpace: XMLRPC }"

XML_or_JSON_RPCServerRequest subclass:#XML_RPCServerRequest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Server'
!

XML_RPCServerRequest comment:'This class holds all information about a XMLRPC request an coordinates the computation of a XMLRPC methodcall'
!

!XML_RPCServerRequest class methodsFor:'documentation'!

documentation
"
    keeps a request's data
"
! !

!XML_RPCServerRequest class methodsFor:'instance creation'!

fromRequest:xmlStringOrStream
    "parse method and parameters from xml"

    |xmldoc topElement r parameters|

    r := self new.

    xmldoc := YAXO::XMLDOMParser parseDocumentFrom:xmlStringOrStream readStream.
    topElement := xmldoc topElement.

    r methodCall:(topElement elementAt:#methodName) contentString.
    [
        parameters := OrderedCollection new.
        (topElement elementAt:#params) elements do:[:each | 
            parameters add:(XMLRPCDecoder new decode:each)
        ]
    ] on:Error do:[ 
        XMLRPCRequestError raiseErrorString:'Could not decode request' 
    ].
    r params:parameters.
    ^ r
! !

!XML_RPCServerRequest methodsFor:'encoding'!

encodeResponse:resultValue
    |stream|

    stream := WriteStream on:(String new:100).
    stream nextPutAll:'<?xml version="1.0"?><methodResponse><params><param>'.
    [
        stream nextPutAll:(XMLRPCEncoder new encode:resultValue) "/ret asXMLRPCString
    ] on:Error do:[
        XMLRPCReturnError raiseErrorString:('Could not encode returned value "' , resultValue printString , '"')
    ].
    stream nextPutAll:'</param></params></methodResponse>'.
    ^ stream contents
! !

!XML_RPCServerRequest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/server/XMLRPCServerRequest.st,v 1.6 2010/03/26 10:46:57 cg Exp $'
! !
