"{ Package: 'stx:goodies/xml/xmlrpc/server' }"

LibraryDefinition subclass:#stx_goodies_xml_xmlrpc_server
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_xml_xmlrpc_server class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/webServer/comanche'    "ComancheNetService - referenced by XMLRPCHttpModule class>>serviceOn: "
        #'stx:goodies/xml/xmlrpc'    "XMLRPCMethodError - referenced by XMLRPCServerRequest>>methodResponse "
        #'stx:libbasic'    "Object - superclass of XMLRPCHttpModule "
    )
! !

!stx_goodies_xml_xmlrpc_server class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'stx_goodies_xml_xmlrpc_server'
        #'XMLRPC::XML_or_JSON_RPCServerRequest'
        #'XMLRPC::XMLRPCService'
        #'XMLRPC::XML_RPCServerRequest'
        #'XMLRPC::JSON_RPCServerRequest'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!stx_goodies_xml_xmlrpc_server class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X XML-RPC Server'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 2010-2011\nCopyright eXept Software AG 2010-2011'

    "Modified: / 01-02-2011 / 11:55:26 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_xml_xmlrpc_server class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/server/stx_goodies_xml_xmlrpc_server.st,v 1.8 2011/02/01 10:58:33 cg Exp $'
! !
