"{ Package: 'stx:goodies/xml/xmlrpc' }"

LibraryDefinition subclass:#stx_goodies_xml_xmlrpc
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_xml_xmlrpc class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/communication'    "HTTPInterface - referenced by XMLRPCProxy>>sendXmlRpc: "
        #'stx:goodies/xml/yaxo'    "YAXO::XMLDOMParser - referenced by XMLRPCProxy>>processResponse: "
        #'stx:libbasic'    "Object - superclass of XMLRPCProxy "
        #'stx:libbasic2'    "OrderedDictionary - referenced by XMLRPCEncoder>>encode: "
    )
! !

!stx_goodies_xml_xmlrpc class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'XMLRPC::XMLRPCDateTime'
        #'XMLRPC::XMLRPCDecoder'
        #'XMLRPC::XMLRPCEncoder'
        #'XMLRPC::XMLRPCError'
        #'XMLRPC::XMLRPCException'
        #'XMLRPC::XMLRPCProxy'
        #'stx_goodies_xml_xmlrpc'
        #'XMLRPC::XMLRPCClassNotFoundError'
        #'XMLRPC::XMLRPCFaultException'
        #'XMLRPC::XMLRPCMethodError'
        #'XMLRPC::XMLRPCRequestError'
        #'XMLRPC::XMLRPCReturnError'
    )
! !

!stx_goodies_xml_xmlrpc class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X XML-RPC Client'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 2010-2011\nCopyright eXept Software AG 2010-2011'

    "Modified: / 01-02-2011 / 11:55:21 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_xml_xmlrpc class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/stx_goodies_xml_xmlrpc.st,v 1.10 2011/02/01 10:57:57 cg Exp $'
! !
