"{ Package: 'stx:goodies/xml/xmlrpc/tests' }"

"{ NameSpace: XMLRPC }"

XMLRPCSpyTest subclass:#XMLRPCEncoderTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Data-Test'
!

XMLRPCEncoderTest comment:'Test the XMLRPC Encoder.
XMLRPCEncoderTest new testEncoder'
!


!XMLRPCEncoderTest methodsFor:'Testing'!

suite
    ^ (TestSuite named:'XMLRPCEncoderTests') 
        addTest:(XMLRPCEncoderTest selector:#testEncoder)
!

testEncoder
    "Run all the encoder tests."
    
    |e d|

    e := XMLRPCEncoder new.
     "Transcript show: 'Running encoder test.'; cr."
    self 
        assertEquals:'<value><i4>17</i4></value>'
        to:(e encode:17)
        msg:'Encoding int.'.
    self 
        assertEquals:'<value><double>3.14159265358979</double></value>'
        to:(e encode:3.14159265358979)
        msg:'Encoding float.'.
"/ cg: I use the more compact encoding below
"/    self 
"/        assertEquals:'<value><string>pi</string></value>'
"/        to:(e encode:'pi')
"/        msg:'Encoding string.'.
    self 
        assertEquals:'<value>pi</value>'
        to:(e encode:'pi')
        msg:'Encoding string.'.
    self 
        assertEquals:'<value><boolean>1</boolean></value>'
        to:(e encode:True)
        msg:'Encoding True'.
    self 
        assertEquals:'<value><boolean>0</boolean></value>'
        to:(e encode:False)
        msg:'Encoding False'.
    self 
        assertEquals:'<value><array><data><value><i4>1</i4></value><value><i4>2</i4></value></data></array></value>'
        to:(e encode:#( 1 2 ))
        msg:'Encoding array.'.
    "/ cg: the following test was rubbish - the order of elements in a Dictionary is not quaranteed
    d := Dictionary new.
    d := OrderedDictionary new.
    d at:'a' put:'A'.
    d at:'b' put:'B'.
    self 
"/ cg: I use the more compact encoding below
        "/ assertEquals:'<value><struct><member><name>a</name><value><string>A</string></value></member><member><name>b</name><value><string>B</string></value></member></struct></value>'
        assertEquals:'<value><struct><member><name>a</name><value>A</value></member><member><name>b</name><value>B</value></member></struct></value>'
        to:(e encode:d)
        msg:'Encoding struct.'
!

testEncoder_V3
    "test V3 extensions:
        <nil>
    "
    
    |e|

    e := XMLRPCEncoder new.
     "Transcript show: 'Running encoder test.'; cr."
    self 
        assertEquals:'<nil />'
        to:(e encode:nil)
        msg:'Encoding nil.'.
    self 
        assertEquals:'<value><i8>4294967296</i8></value>'
        to:(e encode:16r100000000)
        msg:'Encoding 64bit integer.'.

    "Created: / 14-07-2011 / 22:24:10 / cg"
! !

!XMLRPCEncoderTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/tests/XMLRPCEncoderTest.st,v 1.6 2011/07/14 20:32:02 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/tests/XMLRPCEncoderTest.st,v 1.6 2011/07/14 20:32:02 cg Exp $'
! !
