"{ Package: 'stx:goodies/xml/xmlrpc/tests' }"

"{ NameSpace: XMLRPC }"

TestCase subclass:#XMLRPCSpyTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-XMLRPC-Data-Test'
!

XMLRPCSpyTest comment:'Unit test framework.'
!


!XMLRPCSpyTest methodsFor:'debugging'!

assertEquals:ob to:other msg:msg 
    "Make sure the two objects are equal."
    
    ob = other ifFalse:[
        self 
            signalFailure:msg , ' (expected ' , ob printString , ', got ' 
                    , other printString , ')'
    ]
!

assertNil:ob withMessage:msg 
    "Verify the provided object is nil."
    
    ob ifNotNil:[ self signalFailure:msg , ' (expected nil, wasn''t)' ]
!

assertNotNil:ob withMessage:msg 
    "Verify the provided objects is not nil."
    
    ob ifNil:[ self signalFailure:msg , ' (expected not nil, was)' ]
!

assertSame:ob to:otherOb withMessage:msg 
    "Verify the two objects represent the same instance."
    
    ob == otherOb ifFalse:[
        self 
            signalFailure:msg , ' (expected ' , ob asString , ', got ' 
                    , otherOb asString , ')'
    ]
! !

!XMLRPCSpyTest class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xmlrpc/tests/XMLRPCSpyTest.st,v 1.4 2010/03/26 01:04:26 cg Exp $'
! !
