"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

XPathStep subclass:#XPathAttributeNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathAttributeNode class methodsFor:'private'!

axisNames
    ^#('attribute')
! !

!XPathAttributeNode methodsFor:'matching'!

baseValueIn: aNodeContext
    | nd nc |
    nd := aNodeContext node.
    nc := aNodeContext copy documentOrder.
    nd isElement
    	ifFalse: [^nc].
    nd attributes do: [:childNode |
    	(baseTest match: childNode)
    		ifTrue: [nc add: childNode]].
    ^nc
!

simpleMatchFor: anXmlNode isComplex: complex do: aBlock
    | hasCP set |
    anXmlNode isAttribute ifFalse: [^false].
    (baseTest match: anXmlNode) ifFalse: [^false].
    (hasCP := self hasComplexPredicate)
    	ifFalse:
    		[set := XPathNodeContext new add: anXmlNode.
    		1 to: predicates size do: [:i |
    			set := set select: (predicates at: i)].
    		set size = 0 ifTrue: [^false halt]].
    parent == nil ifTrue: [^aBlock value: anXmlNode parent value: complex | hasCP].
    ^parent simpleMatchFor: anXmlNode parent
    	isComplex: complex | hasCP
    	do: aBlock
! !

!XPathAttributeNode methodsFor:'printing'!

printTestOn: aStream
    axisName == nil
    	ifTrue: [aStream nextPutAll: '@'; print: baseTest]
    	ifFalse: [super printTestOn: aStream]
! !

!XPathAttributeNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathAttributeNode.st,v 1.1 2003/05/27 12:12:32 james Exp $'
! !
