"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

XPathStep subclass:#XPathChildNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathChildNode class methodsFor:'private'!

axisNames
    ^#('child')
! !

!XPathChildNode methodsFor:'matching'!

baseValueIn: aNodeContext
    | nd nc |
    nd := aNodeContext node.
    nc := aNodeContext copy documentOrder.
    (nd isElement or: [nd isDocument])
    	ifFalse: [^nc].
    aNodeContext node children do: [:childNode |
    	(baseTest match: childNode)
    		ifTrue: [nc add: childNode]].
    ^nc
!

simpleMatchFor: anXmlNode isComplex: complex do: aBlock
    | hasCP set |
    anXmlNode isAttribute ifTrue: [^false].
    (baseTest match: anXmlNode) ifFalse: [^false].
    (hasCP := self hasComplexPredicate)
    	ifFalse:
    		[set := XPathNodeContext new add: anXmlNode.
    		1 to: predicates size do: [:i |
    			set := set select: (predicates at: i)].
    		set size = 0 ifTrue: [^false]].
    parent == nil ifTrue: [^aBlock value: anXmlNode parent value: complex | hasCP].
    ^parent simpleMatchFor: anXmlNode parent
    	isComplex: complex | hasCP
    	do: aBlock
! !

!XPathChildNode methodsFor:'printing'!

printTestOn: aStream
    axisName == nil
    	ifTrue: [baseTest printOn: aStream]
    	ifFalse: [super printTestOn: aStream]
! !

!XPathChildNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathChildNode.st,v 1.1 2003/05/27 12:11:51 james Exp $'
! !
