"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

XPathStep subclass:#XPathCurrentNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathCurrentNode class methodsFor:'private'!

axisNames
    ^#('self')
! !

!XPathCurrentNode methodsFor:'accessing'!

axisName
    axisName == nil
    	ifTrue: [^'self']
    	ifFalse: [^axisName]
! !

!XPathCurrentNode methodsFor:'initialize'!

initialize
    super initialize.
    baseTest := XPathTypedNodeTest new type: #node
! !

!XPathCurrentNode methodsFor:'matching'!

baseValueIn: aNodeContext
    (baseTest match: aNodeContext node)
    	ifTrue: [^ aNodeContext copy documentOrder; add: aNodeContext node]
    	ifFalse: [^ aNodeContext copy documentOrder]
!

simpleMatchFor: anXmlNode isComplex: complex do: aBlock
    | hasCP set |
    (baseTest match: anXmlNode) ifFalse: [^false].
    (hasCP := self hasComplexPredicate)
    	ifFalse:
    		[set := XPathNodeContext new add: anXmlNode.
    		1 to: predicates size do: [:i |
    			set := set select: (predicates at: i)].
    		set size = 0 ifTrue: [^false halt]].
    parent == nil ifTrue: [^aBlock value: anXmlNode value: complex | hasCP].
    ^parent simpleMatchFor: anXmlNode
    	isComplex: complex | hasCP
    	do: aBlock
! !

!XPathCurrentNode methodsFor:'printing'!

completePrintOn: aStream
    (baseTest isTrivial
    		and: [predicates isEmpty])
    	ifTrue: [self child isTerminator
    		ifTrue: [aStream nextPutAll: '.']
    		ifFalse:
    			[aStream nextPutAll: './'.
    			self child completeChildPrintOn: aStream]]
    	ifFalse: [super completePrintOn: aStream]
! !

!XPathCurrentNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathCurrentNode.st,v 1.3 2004/08/15 17:20:59 stefan Exp $'
! !
