"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

XPathStep subclass:#XPathDescendantNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathDescendantNode class methodsFor:'private'!

axisNames
    ^#('descendant' 'descendant-or-self')
! !

!XPathDescendantNode methodsFor:'matching'!

baseValueIn: aNodeContext
    | nd nc queue nextNode |
    nd := aNodeContext node.
    nc := aNodeContext copy documentOrder.
    queue := OrderedCollection new.
    self axisName = 'descendant-or-self'
    	ifTrue: [queue add: nd]
    	ifFalse: [nd isElement
    		ifTrue: [queue addAll: nd children]].
    nd isDocument
    	ifTrue: [queue add: nd root].
    [queue isEmpty]
    	whileFalse:
    		[nextNode := queue removeFirst.
    		(baseTest match: nextNode)
    			ifTrue: [nc add: nextNode].
    		nextNode isElement
    			ifTrue: [queue addAll: nextNode children]].
    ^nc
!

simpleMatchFor: anXmlNode isComplex: complex do: aBlock
    | startNode hasCP set |
    anXmlNode isAttribute ifTrue: [^false].
    (baseTest match: anXmlNode) ifFalse: [^false].
    (hasCP := self hasComplexPredicate)
    	ifFalse:
    		[set := XPathNodeContext new add: anXmlNode.
    		1 to: predicates size do: [:i |
    			set := set select: (predicates at: i)].
    		set size = 0 ifTrue: [^false halt]].
    startNode := self axisName = 'descendant'
    	ifTrue: [anXmlNode parent]
    	ifFalse: [anXmlNode].
    [parent == nil
    	ifTrue: [aBlock value: anXmlNode value: complex | hasCP]
    	ifFalse: [parent simpleMatchFor: startNode
    			isComplex: complex | hasCP
    			do: aBlock]]
    	whileFalse:
    		[startNode := startNode parent.
    		startNode == nil ifTrue: [^false]].
    ^true
! !

!XPathDescendantNode methodsFor:'printing'!

completeChildPrintOn: aStream
    (baseTest isTrivial
    		and: [predicates isEmpty
    		and: [axisName = 'descendant-or-self']])
    	ifFalse: [^super completePrintOn: aStream].
    aStream nextPut: $/.
    self child completeChildPrintOn: aStream.
! !

!XPathDescendantNode methodsFor:'testing'!

axisName
    ^axisName == nil
    	ifTrue: ['descendant-or-self']
    	ifFalse: [axisName]
! !

!XPathDescendantNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathDescendantNode.st,v 1.1 2003/05/27 12:13:40 james Exp $'
! !
