"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

XPathStep subclass:#XPathFollowingNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathFollowingNode class methodsFor:'private'!

axisNames
    ^#('following')
! !

!XPathFollowingNode methodsFor:'matching'!

baseValueIn: aNodeContext
    | nd nc |
    nd := aNodeContext node.
    nc := aNodeContext copy documentOrder.
    self from: nd do: [:nd1 |
    	(baseTest match: nd1)
    		ifTrue: [nc add: nd1]].
    ^nc
!

from: aNode do: aBlock
    | current stack idx followChildren |
    current := aNode.
    stack := OrderedCollection new.
    current isDocument ifFalse:
    	[[current parent isDocument not] whileTrue:
    		[stack addFirst: current parent -> (current parent children indexOf: current).
    		current := current parent]].
    current := aNode.
    "By setting followChildren to false the first time only, we ignore
    all descendents of aNode."
    followChildren := false.
    [(followChildren and: [(current isElement or: [current isDocument]) and: [current children size > 0]])
    	ifTrue: [stack add: current->1. current := current children at: 1.]
    	ifFalse:
    		[[stack isEmpty ifTrue: [^self].
    		stack last key children size > stack last value]
    			whileFalse:
    				[current := stack removeLast key].
    		stack last value: (idx := stack last value + 1).
    		current := stack last key children at: idx].
    followChildren := true.
    aBlock value: current.] repeat
! !

!XPathFollowingNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathFollowingNode.st,v 1.1 2003/05/27 12:14:43 james Exp $'
! !
