"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

XPathStep subclass:#XPathPrecedingNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathPrecedingNode class methodsFor:'private'!

axisNames
    ^#('preceding')
! !

!XPathPrecedingNode methodsFor:'matching'!

baseValueIn: aNodeContext
    | nd nc |
    nd := aNodeContext node.
    nc := aNodeContext copy inverseDocumentOrder.
    self from: nd do: [:nd1 |
    	(baseTest match: nd1)
    		ifTrue: [nc add: nd1]].
    ^nc
!

from: aNode do: aBlock
    | current stack ignoreAll |
    ignoreAll := IdentitySet new.
    stack := OrderedCollection new.
    current := aNode.
    [ignoreAll add: current.
    current isDocument not] whileTrue:
    	[stack addFirst: current parent -> (current parent children indexOf: current).
    	current := current parent].
    current := aNode.
    [current isDocument
    	ifTrue: [^self]
    	ifFalse: [stack last value = 1
    		ifTrue: [current := stack removeLast key]
    		ifFalse:
    			[stack last value: stack last value - 1.
    			current := stack last key children at: stack last value.
    			[current isElement and: [current children isEmpty not]]
    				whileTrue:
    					[stack add: current -> current children size.
    					current := current children last]]].
    (ignoreAll includes: current) ifFalse: [aBlock value: current]] repeat
! !

!XPathPrecedingNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathPrecedingNode.st,v 1.1 2003/05/27 12:13:26 james Exp $'
! !
