"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

Array variableSubclass:#XPathSortingVector
	instanceVariableNames:'value'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathSortingVector class methodsFor:'instance creation'!

fromXmlNode: aNode
    |list node newInstance listSize|

    list := OrderedCollection new.
    node := aNode.
    [node isDocument] whileFalse:[ |parent|
        parent := node parent.
        list add:(parent children identityIndexOf:node ifAbsent:[0]).
        node := parent.
    ].

    listSize := list size.
    newInstance := self new:listSize.
    newInstance value:aNode.
    1 to:listSize do:[:index|
        newInstance at:index put:(list at:(listSize-index+1)).
    ].
    ^ newInstance
! !

!XPathSortingVector methodsFor:'accessing'!

value
    ^value
!

value: aNode
    value := aNode
! !

!XPathSortingVector methodsFor:'sorting'!

le: aVector
    |size vectorSize min "{ Class:SmallInteger }" |

    size := self size.
    vectorSize := aVector size.
    size <= vectorSize ifTrue:[
        min := size
    ] ifFalse:[
        min := vectorSize
    ].

    1 to: min do: [:i| |v1 v2|
        v1 := self at: i.
        v2 := aVector at: i.
        v1 == v2 ifFalse:[^ v1 <= v2]
    ].
    ^ size <= vectorSize
! !

!XPathSortingVector class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathSortingVector.st,v 1.3 2003/08/05 10:30:11 stefan Exp $'
! !
