"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

XPathNodeTest subclass:#XPathTypedNodeTest
	instanceVariableNames:'typeName value'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathTypedNodeTest methodsFor:'accessing'!

type: aString
    typeName := aString asSymbol.
    (#(comment text node #'processing-instruction') includes: typeName)
        ifFalse: [self error: 'A node test must be one of comment, text, node, or propcessing-instruction'].
!

value: aString
    value := aString
! !

!XPathTypedNodeTest methodsFor:'matching'!

match: anXmlNode
    anXmlNode isDiscarded ifTrue:[^ false].
    typeName == #node ifTrue: [^true].
    typeName == #text ifTrue: [^anXmlNode isText].
    typeName == #comment ifTrue: [^anXmlNode isComment].
    typeName == #'processing-instruction'
        ifTrue: [^anXmlNode isProcessingInstruction
                                and: [value == nil
                                or: [value = anXmlNode name]]].
    self shouldImplement.
    ^ false
! !

!XPathTypedNodeTest methodsFor:'printing'!

printOn: aStream
    aStream nextPutAll: typeName, '('.
    value == nil ifFalse: [aStream nextPutAll: value].
    aStream nextPutAll: ')'.
! !

!XPathTypedNodeTest methodsFor:'testing'!

isTrivial
    ^typeName = 'node'
! !

!XPathTypedNodeTest class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathTypedNodeTest.st,v 1.3 2004/08/15 17:18:58 stefan Exp $'
! !
