"{ Package: 'stx:goodies/xml/xpath' }"

"{ NameSpace: XML }"

XPathExpression subclass:#XPathUnion
	instanceVariableNames:'arguments'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-XPath'
!


!XPathUnion methodsFor:'accessing'!

add: aNode
    arguments := arguments copyWith: aNode
!

arguments
    ^arguments
!

asUnion
    ^self
!

enumerate: aBlock
    super enumerate: aBlock.
    arguments do: [:a | a enumerate: aBlock].
! !

!XPathUnion methodsFor:'initialize'!

initialize
    super initialize.
    arguments := #()
! !

!XPathUnion methodsFor:'matching'!

baseValueIn: aNodeContext
    | nc |
    nc := aNodeContext copy documentOrder.
    1 to: arguments size do: [:a |
    	nc addNodeSet: ((arguments at: a) xpathEvalIn: aNodeContext)].
    ^nc
!

match: aNodeContext
    1 to: arguments size do: [:a |
    	((arguments at: a) match: aNodeContext) ifTrue: [^true]].
    ^false
! !

!XPathUnion methodsFor:'printing'!

printTestOn: aStream
    arguments do: [:a | aStream print: a] separatedBy: [aStream nextPutAll: '|'].
! !

!XPathUnion class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xpath/XPathUnion.st,v 1.1 2003/05/27 12:15:47 james Exp $'
! !
