"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#ApplyTemplatesCommand
	instanceVariableNames:'selectPattern sortList mode'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes-Control'
!


!ApplyTemplatesCommand class methodsFor:'accessing'!

tag
    ^'apply-templates'
! !

!ApplyTemplatesCommand methodsFor:'accessing'!

addSortBlock: aSortCommand
    sortList == nil ifTrue: [sortList := #()].
    sortList := sortList copyWith: aSortCommand
!

mode
    self testPatternInitialized.
    ^mode
!

selectPattern
    self testPatternInitialized.
    ^selectPattern
!

sortList
    ^sortList
! !

!ApplyTemplatesCommand methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    selectPattern := self readSelectPattern: 'select' default: [nil].
    mode := self readAttribute: 'mode' default: [nil]
! !

!ApplyTemplatesCommand methodsFor:'processing'!

process: aNodeContext into: aProxy
    | list rule arguments argList listCopy |
    self selectPattern == nil
    	ifTrue: [list := self xslNodesFrom: aNodeContext]
    	ifFalse: [list := self selectAll: aNodeContext withPattern: self selectPattern].
    self sortList == nil
    	ifTrue: [list documentOrder; ensureSorted]
    	ifFalse:
    		[listCopy := list shallowCopy.
    		list sort: [:n1 :n2 | self collate: n1 to: n2 within: listCopy]].
    arguments := Dictionary new.
    argList := self xslElements.
    1 to: argList size do: [:i |
    	(argList at: i) process: aNodeContext intoArgs: arguments].
    list reset.
    [list atEnd]
    	whileFalse:
    		[list variables: list variables clone.
    		rule := list db ruleMatching: list next mode: self mode.
    		rule == nil ifFalse: [rule process: list into: aProxy arguments: arguments]]
! !

!ApplyTemplatesCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/ApplyTemplatesCommand.st,v 1.1 2003/05/28 10:55:50 james Exp $'
! !
