"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#AttributeCommand
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes'
!


!AttributeCommand class methodsFor:'accessing'!

tag
    ^'attribute'
! !

!AttributeCommand methodsFor:'accessing'!

name
    self testPatternInitialized.
    ^name
! !

!AttributeCommand methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    name := self readTag: 'name'
! !

!AttributeCommand methodsFor:'processing'!

generateFrom: aNode into: aProxy
    | oc computedValue nm |
    oc := aProxy childProxy.
    self xslElements do: [:elm |
        elm process: aNode into: oc].
    oc attributes isEmpty ifFalse: [self error: 'Attributes cannot have attributes'].
    computedValue := (String new: 32) writeStream.
    oc children do: [:elm |
        elm isText ifFalse: [self error: 'Attribute values can only contain text data'].
        computedValue nextPutAll: elm characterData].
    nm := self processAttributeValue: self name for: aNode.
    nm := self resolveComputedTag: nm.
    ^XML.Attribute new name: nm value: computedValue contents
!

process: aNode into: aProxy
    | oc computedValue nm |
    aProxy children size = 0
        ifFalse: [self error: 'Attributes must all be added before content'].
    oc := aProxy childProxy.
    self xslElements do: [:elm |
        elm process: aNode into: oc].
    oc attributes isEmpty ifFalse: [self error: 'Attributes cannot have attributes'].
    computedValue := (String new: 32) writeStream.
    oc children do: [:elm |
        elm isText ifFalse: [self error: 'Attribute values can only contain text data'].
        computedValue nextPutAll: elm characterData].
    nm := self processAttributeValue: self name for: aNode.
    nm := self resolveComputedTag: nm.
    aProxy addAttribute: (XML::Attribute new name: nm value: computedValue contents)
! !

!AttributeCommand methodsFor:'testing'!

generatesAttributes
    ^true
! !

!AttributeCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/AttributeCommand.st,v 1.2 2009/11/03 13:54:28 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/AttributeCommand.st,v 1.2 2009/11/03 13:54:28 cg Exp $'
! !
