"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLDefinition subclass:#AttributeSet
	instanceVariableNames:'name useAttrs'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes-Top Level'
!


!AttributeSet class methodsFor:'accessing'!

tag
    ^'attribute-set'
! !

!AttributeSet methodsFor:'accessing'!

allAttributesFrom: aDB
    | all |
    all := Dictionary new.
    useAttrs do: [:setName |
    	(aDB attributesForSet: setName)
    		do: [:attr | all at: attr name put: attr]].
    self xslElements do: [:attr |
    	attr class == AttributeCommand ifFalse: [self error: 'Attribute sets only contain attributes'].
    	all at: attr name put: attr].
    ^all asOrderedCollection
!

name
    self testPatternInitialized.
    ^name
! !

!AttributeSet methodsFor:'initialize'!

purgeUnimportant
    elements := self children reject: [:i | i isBlankText].
    elements do: [:elm |
    	elm generatesAttributes
    		ifFalse: [self error: 'xsl:attribute-set can contain only xsl:attribute and xsl:use']]
!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    name := self readAttribute: 'name'.
    useAttrs := self readTagList: 'use-attribute-sets' default: [#()].
! !

!AttributeSet methodsFor:'loading'!

addToRuleDB: aDB
    "This is only understood by a small subset of commands."

    aDB addAttributeSet: self
! !

!AttributeSet methodsFor:'processing'!

process: aNodeContext into: aProxy
    | list |
    list := self xslElements.
    1 to: list size do: [:i || elm |
    	elm := list at: i.
    	elm process: aNodeContext into: aProxy].
! !

!AttributeSet class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/AttributeSet.st,v 1.1 2003/05/28 10:55:41 james Exp $'
! !
