"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#CallTemplateCommand
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes-Control'
!


!CallTemplateCommand class methodsFor:'accessing'!

tag
    ^'call-template'
! !

!CallTemplateCommand methodsFor:'accessing'!

name
    self testPatternInitialized.
    ^name
! !

!CallTemplateCommand methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    name := self readAttribute: 'name' default: [nil]
! !

!CallTemplateCommand methodsFor:'processing'!

process: aNodeContext into: aProxy
    | rule arguments list vars |
    rule := aNodeContext db ruleNamed: self name.
    arguments := Dictionary new.
    list := self xslElements.
    1 to: list size do: [:i |
    	(list at: i) process: aNodeContext intoArgs: arguments].
    rule == nil
    	ifTrue: [self error: 'Named template not found']
    	ifFalse:
    		[vars := aNodeContext variables.
    		aNodeContext variables: vars clone.
    		rule process: aNodeContext into: aProxy arguments: arguments.
    		aNodeContext variables: vars]
! !

!CallTemplateCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/CallTemplateCommand.st,v 1.1 2003/05/28 10:55:03 james Exp $'
! !
