"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#ChooseCommand
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes-Control'
!


!ChooseCommand class methodsFor:'accessing'!

tag
    ^'choose'
! !

!ChooseCommand methodsFor:'private'!

elements: aList
    | newList hasOtherwise |
    newList := aList select: [:i | i isContent and: [i isBlankText not]].
    hasOtherwise := false.
    newList do: [:elm |
    	elm class = ChooseOtherwiseCommand
    		ifTrue:
    			[hasOtherwise ifTrue: [self error: 'xsl:choose with multiple xsl:otherwise commands'].
    			hasOtherwise := true]
    		ifFalse: [elm class = ChooseWhenCommand
    			ifFalse: [self error: 'xsl:choose can only contain xsl:when and xsl:otherwise']]].
    super elements: newList
! !

!ChooseCommand methodsFor:'processing'!

process: aNodeContext into: aProxy
    | alt match list |
    alt := match := nil.
    elements do: [:elm |
    	elm class == ChooseOtherwiseCommand
    		ifTrue: [alt := elm]
    		ifFalse: [(match == nil and: [(elm testPattern xpathValueIn: aNodeContext) xpathAsBoolean])
    			ifTrue: [match := elm]]].
    match == nil ifTrue: [match := alt].
    match notNil
    	ifTrue:
    		[list := match xslElements.
    		1 to: list size do: [:i || elm |
    			elm := list at: i.
    			elm process: aNodeContext into: aProxy]]
! !

!ChooseCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/ChooseCommand.st,v 1.1 2003/05/28 10:56:05 james Exp $'
! !
