"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#CopyCommand
	instanceVariableNames:'useAttrs'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes'
!


!CopyCommand class methodsFor:'accessing'!

tag
    ^'copy'
! !

!CopyCommand methodsFor:'accessing'!

useAttrs
    self testPatternInitialized.
    ^useAttrs
! !

!CopyCommand methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    useAttrs := self readTagList: 'use-attribute-sets' default: [#()].
! !

!CopyCommand methodsFor:'processing'!

process: aNodeContext into: aProxy
    aNodeContext node isAttribute
    	ifTrue:
    		[self useAttrs isEmpty ifFalse: [self error: '<xsl:copy> is attempting to add attributes to an Attribute'].
    		^self processAttribute: aNodeContext into: aProxy].
    aNodeContext node isElement
    	ifTrue: [^self processElement: aNodeContext into: aProxy].
    (aNodeContext node isComment or: [aNodeContext node isText])
    	ifTrue:
    		[self useAttrs isEmpty ifFalse: [self error: '<xsl:copy> is attempting to add attributes to a non-Element'].
    		^aProxy add: aNodeContext node copy].
    ^self error: 'Copying of this node type is not yet implemented'
!

processAttribute: aNodeContext into: aProxy
    aProxy addAttribute: (XML::Attribute new name: aNodeContext node tag value: aNodeContext node value)
!

processElement: aNodeContext into: aProxy
    | oc list |
    oc := aProxy childProxy.
    self processAttributeSets: aNodeContext into: oc.
    list := self xslElements.
    1 to: list size do: [:i || elm |
        elm := list at: i.
        elm process: aNodeContext into: oc].
    aProxy addNode: (XML::Element tag: aNodeContext node tag attributes: oc attributes elements: oc children)
! !

!CopyCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/CopyCommand.st,v 1.2 2009/11/03 13:55:43 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/CopyCommand.st,v 1.2 2009/11/03 13:55:43 cg Exp $'
! !
