"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#CopyOfCommand
	instanceVariableNames:'expression'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes'
!


!CopyOfCommand class methodsFor:'accessing'!

tag
    ^'copy-of'
! !

!CopyOfCommand methodsFor:'accessing'!

expression
    self testPatternInitialized.
    ^expression
! !

!CopyOfCommand methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    expression := self readSelectPattern: 'select'
! !

!CopyOfCommand methodsFor:'processing'!

copyNode: n to: aContainer
    | new |
    n isDocument
    	ifTrue: [^self copyNode: n root to: aContainer].
    n isAttribute
    	ifTrue: [^aContainer addAttribute: n copy].
    n isElement
    	ifFalse: [^aContainer addNode: n copy].
    new := n class tag: n tag attributes: (n attributes collect: [:a | a copy]) elements: nil.
    n children do: [:c | self copyNode: c to: new].
    aContainer addNode: new.
!

copyNodes: sortedNodes into: aProxy
    sortedNodes do: [:n | self copyNode: n to: aProxy].
!

process: aNodeContext into: aProxy
    | elm |
    elm := self expression xpathValueIn: aNodeContext.
    elm xpathIsNodeSet
        ifTrue: [self copyNodes: elm sortedNodes into: aProxy]
        ifFalse: [(elm isKindOf: ElementProxy)
                ifTrue: [self copyNodes: elm children into: aProxy]
                ifFalse: [aProxy add: (XML::Text new text: elm xpathAsString value)]]
! !

!CopyOfCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/CopyOfCommand.st,v 1.2 2009/11/03 14:01:12 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/CopyOfCommand.st,v 1.2 2009/11/03 14:01:12 cg Exp $'
! !
