"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#ElementCommand
	instanceVariableNames:'name useAttrs'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes'
!


!ElementCommand class methodsFor:'accessing'!

tag
    ^'element'
! !

!ElementCommand methodsFor:'accessing'!

name
    self testPatternInitialized.
    ^name
!

useAttrs
    self testPatternInitialized.
    ^useAttrs
! !

!ElementCommand methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    name := self readTag: 'name'.
    useAttrs := self readTagList: 'use-attribute-sets' default: [#()].
! !

!ElementCommand methodsFor:'processing'!

process: aNodeContext into: aProxy
    | oc nm list |
    oc := aProxy childProxy.
    self processAttributeSets: aNodeContext into: oc.
    list := self xslElements.
    1 to: list size do: [:i || elm |
	elm := list at: i.
	elm process: aNodeContext into: oc].
    nm := self processAttributeValue: self name for: aNodeContext.
    nm := self resolveComputedTag: nm.
    aProxy addNode: (XML::Element tag: nm attributes: oc attributes elements: oc children)
! !

!ElementCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/ElementCommand.st,v 1.2 2009/11/03 14:30:03 cg Exp $'
! !
