"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

GeneralCountingProxy subclass:#ElementProxy
	instanceVariableNames:'contents attributes'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Support'
!


!ElementProxy methodsFor:'accessing'!

attributes
    attributes == nil
    	ifTrue: [attributes := #()].
    ^attributes
!

attributes: list
    attributes := list
!

children
    contents == nil
    	ifTrue: [contents := #()].
    ^contents
!

children: list
    contents := list
! !

!ElementProxy methodsFor:'building'!

addAttribute: attribute
    self attributes: (self attributes copyWith: attribute)
!

addNode: element
    self children: (self children copyWith: element)
! !

!ElementProxy methodsFor:'coercing'!

xpathAsBoolean
    ^self xpathAsString xpathAsBoolean
!

xpathAsNumber
    ^self xpathAsString xpathAsNumber
!

xpathAsString
    | result |
    self children isEmpty ifTrue: [^''].
    self children size = 1 ifTrue: [^self children first xpathStringData].
    result := (String new: 40) writeStream.
    1 to: self children size do: [:i |
    	result nextPutAll: (self children at: i) xpathStringData].
    ^result contents
! !

!ElementProxy methodsFor:'enumerating'!

addToXPathHolder: anAssociation for: aNodeContext
    anAssociation value == nil
    	ifTrue: [^anAssociation value: self].
    anAssociation value xpathIsNodeSet
    	ifTrue: [^self error: 'An XPath expression is answering a combination of Nodes and non-Nodes'].
    self error: 'An XPath expression is answering more than one non-Node value'
! !

!ElementProxy class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/ElementProxy.st,v 1.1 2003/05/28 10:54:07 james Exp $'
! !
