"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#ForEachCommand
	instanceVariableNames:'selectPattern sortList variables'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes-Control'
!


!ForEachCommand class methodsFor:'accessing'!

tag
    ^'for-each'
! !

!ForEachCommand methodsFor:'accessing'!

addSortBlock: aSortCommand
    sortList == nil ifTrue: [sortList := #()].
    sortList := sortList copyWith: aSortCommand
!

defineVariable: aVariable
    variables add: aVariable.
    self parent defineVariable: aVariable
!

selectPattern
    self testPatternInitialized.
    ^selectPattern
!

sortList
    ^sortList
! !

!ForEachCommand methodsFor:'initialize'!

initialize
    super initialize.
    elements := nil.
    variables := OrderedCollection new: 0.
!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    selectPattern := self readSelectPattern: 'select'
! !

!ForEachCommand methodsFor:'processing'!

process: aNodeContext into: aProxy
    | list elms listCopy |
    elms := self xslElements.
    list := self selectAll: aNodeContext withPattern: self selectPattern.
    self sortList == nil
    	ifTrue: [list documentOrder; ensureSorted]
    	ifFalse:
    		[listCopy := list shallowCopy.
    		list sort: [:n1 :n2 | self collate: n1 to: n2 within: listCopy]].
    list reset.
    [list atEnd]
    	whileFalse:
    		[list next.
    		1 to: elms size do: [:i || elm |
    			elm := elms at: i.
    			elm process: list into: aProxy]]
! !

!ForEachCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/ForEachCommand.st,v 1.1 2003/05/28 10:56:36 james Exp $'
! !
