"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLDefinition subclass:#Import
	instanceVariableNames:'href'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes-Top Level'
!


!Import class methodsFor:'accessing'!

tag
    ^'import'
! !

!Import methodsFor:'accessing'!

href
    self testPatternInitialized.
    ^href
!

purgeUnimportant
    | idx |
    elements == nil ifFalse: [self error: 'Imports should not have contents.'].
    (self parent isKindOf: RuleSet)
    	ifFalse: [self error: self tag asString, ' can only be used at the top level'].
    idx := self parent children indexOf: self.
    (idx = 1 or: [(self parent children at: idx - 1) class == self class])
    	ifFalse: [self error: 'All imports must come first in the stylesheet'].
! !

!Import methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    href := self readAttribute: 'href'.
! !

!Import methodsFor:'loading'!

addToRuleDB: aDB
    "This is only understood by a small subset of commands."

    | uri |
    uri := aDB uriStack last resolveRelativePath: self href.
    aDB uriStack addLast: uri.
    aDB readStream: uri resource topLevel: false.
    aDB uriStack removeLast.
    aDB raiseImportance
! !

!Import class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/Import.st,v 1.1 2003/05/28 10:57:18 james Exp $'
! !
