"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLDefinition subclass:#Include
	instanceVariableNames:'href'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes-Top Level'
!


!Include class methodsFor:'accessing'!

tag
    ^'include'
! !

!Include methodsFor:'accessing'!

href
    self testPatternInitialized.
    ^href
!

purgeUnimportant
    elements == nil ifFalse: [self error: 'Includes should not have contents.'].
    (self parent isKindOf: RuleSet)
    	ifFalse: [self error: self tag asString, ' can only be used at the top level'].
! !

!Include methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    href := self readAttribute: 'href'.
! !

!Include methodsFor:'loading'!

addToRuleDB: aDB
    "This is only understood by a small subset of commands."

    | uri save |
    save := aDB importance.
    aDB importance: save copy.
    uri := aDB uriStack last resolveRelativePath: self href.
    aDB uriStack addLast: uri.
    aDB readStream: uri resource topLevel: false.
    aDB uriStack removeLast.
    aDB replaceImportance: save
! !

!Include class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/Include.st,v 1.1 2003/05/28 10:55:22 james Exp $'
! !
