"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLDefinition subclass:#ParamDefinition
	instanceVariableNames:'name expression'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes'
!


!ParamDefinition class methodsFor:'accessing'!

tag
    ^'param'
! !

!ParamDefinition methodsFor:'accessing'!

expression
    self testPatternInitialized.
    ^expression
!

name
    self testPatternInitialized.
    ^name
!

purgeUnimportant
    ^self
! !

!ParamDefinition methodsFor:'initialize'!

normalize
    super normalize.
    self parent defineParameter: self
!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    name := self readAttribute: 'name'.
    expression := self readSelectPattern: 'select' default: [].
    (expression notNil and: [self children isEmpty not])
    	ifTrue: [self error: 'A parameter cannot have both content and a select attribute'].
! !

!ParamDefinition methodsFor:'loading'!

addToRuleDB: aDB
    "This is only understood by a small subset of commands."

    aDB addVariable: self
! !

!ParamDefinition methodsFor:'processing'!

process: aNodeContext into: aProxy
    self shouldNotImplement
!

process: aNodeContext into: aProxy takeArgumentsFrom: arguments
    | val |
    val := arguments at: self name ifAbsent: [].
    val == nil
    	ifTrue: [val := self valueAsVariableIn: aNodeContext].
    aNodeContext variables at: self name put: val.
! !

!ParamDefinition methodsFor:'testing'!

isStylesheetEntry
    ^true
! !

!ParamDefinition class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/ParamDefinition.st,v 1.1 2003/05/28 10:56:51 james Exp $'
! !
