"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

Array variableSubclass:#Rank
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Support'
!


!Rank methodsFor:'comparing'!

rankAgainst: aRank
    "Assume two Ranks, of sizes M and N, where M >= N.
    If they have the same elements in the first N elements, the
    	shorter Rank has higher priority.
    If there is a difference in the first N elements, assume
    	that the first difference occurs at slot S. The Rank
    	whose value at S is greater has higher priority."

    | min r ranks |
    ranks := #(#higher #same #lower).
    min := self size min: aRank size.
    1 to: min do: [:i |
    	r := ((aRank at: i) - (self at: i)) sign.
    	r = 0 ifFalse: [^ranks at: r + 2]].
    ^ranks at: (self size - aRank size) sign + 2
! !

!Rank class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/Rank.st,v 1.1 2003/05/28 10:56:28 james Exp $'
! !
