"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

Object subclass:#RuleDatabase
	instanceVariableNames:'rules variables normalized namedTemplates attributeSets
		currentImportance uriStack output'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Support'
!

RuleDatabase class instanceVariableNames:'xsl_uri'

"
 No other class instance variables are inherited by this class.
"
!


!RuleDatabase class methodsFor:'instance creation'!

new
    ^super new initialize
! !

!RuleDatabase class methodsFor:'XML for examples'!

constructXML
    "RuleDatabase constructXML"

    ^'<doc a="1" b="2">
    <title c="3" d="4">An example</title>
    <p k="xyz">This is a test.</p>
    <p>This is <emph>another</emph> test.</p>
    </doc>'
!

constructXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			indent-result="yes">
    	<xsl:variable name="tag" select="$tag2"/>
    	<xsl:variable name="tag2" select="''new''"/>

    	<xsl:template match="*">
    		<xsl:element name="{$tag}-{name(.)}">
    			<xsl:for-each select="@*">
    				<xsl:attribute name="{name(.)}-copy">
    					..<xsl:value-of select="."/>..
    				</xsl:attribute>
    			</xsl:for-each>
    			<xsl:apply-templates/>
    		</xsl:element>
    	</xsl:template>

    	<xsl:template match="p" priority="1">
    		<xsl:copy>
    			<xsl:apply-templates select="@*|*|text()"/>
    		</xsl:copy>
    	</xsl:template>

    	<xsl:template match="p/@*">
    		<xsl:copy>
    			<xsl:apply-templates select="text()"/>
    		</xsl:copy>
    	</xsl:template>
    </xsl:stylesheet>'
!

macroXML
    ^'<?xml version="1.0"?>

    <doc>
    	<p>a paragraph</p>
    	<p>another paragraph</p>
    	<warning>the warning</warning>
    	<p>closing paragraph</p>
    	<warning>warning 2</warning>
    	<warning>warning 3</warning>
    	<list>
    		<item><surname>Smith</surname><name>Joe</name><MI>G.</MI></item>
    		<item><surname>Jones</surname><name>John</name><MI>P.</MI></item>
    		<item><surname>Smith</surname><name>Bill</name><MI>M.</MI></item>
    		<item><surname>Bell</surname><name>Alexander</name><MI>G.</MI></item>
    		<item><surname>Smith</surname><name>Bill</name><MI>A.</MI></item>
    	</list>
    </doc>'
!

macroXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                        indent-result="yes">
        <xsl:template name="warning-para">
                <xsl:param name="format" select="''1. ''"/>
                <xsl:param name="content"/>
                <box font-color="red">
                        <xsl:number format="{$format}"/>
                        <xsl:text>Warning!! </xsl:text>
                        <xsl:copy-of select="$content"/>
                </box>
        </xsl:template>

        <xsl:template match=''p|doc''>
                <xsl:copy><xsl:apply-templates/></xsl:copy>
        </xsl:template>

        <xsl:template match=''warning''>
                <xsl:call-template name="warning-para">
                        <xsl:with-param name="format" select="''A. ''"/>
                        <xsl:with-param name="content">
                                <xsl:apply-templates/>
                                <xsl:text> (see appendix)</xsl:text>
                        </xsl:with-param>
                </xsl:call-template>
        </xsl:template>

        <xsl:template match=''list''>
                <list>
                        <xsl:apply-templates select="item">
                                <xsl:sort select="surname" order="ascending"/>
                                <xsl:sort select="name" order="descending"/>
                        </xsl:apply-templates>
                </list>
        </xsl:template>

        <xsl:template match=''item''>
                <name>
                        <xsl:value-of select="name"/>
                        <xsl:text> </xsl:text>
                        <xsl:value-of select="MI"/>
                        <xsl:text> </xsl:text>
                        <xsl:value-of select="surname"/>
                </name>
        </xsl:template>

    </xsl:stylesheet>'
!

numberedSourceData
    ^'1. Overview
2. Tree Construction
    2.1 Overview
    2.2 Stylesheet Structure
    2.3 Processing Model
    2.4 Data Model
    	2.4.1 Root Node
    	2.4.2 Element Nodes
    	2.4.3 Attribute Nodes
    	2.4.4 Character Data
    	2.4.5 Whitespace Stripping
    2.5 Template Rules
    	2.5.1 Conflict Resolution for Template Rules
    	2.5.2 Built-in Template Rule
    2.6 Patterns
    	2.6.1 Alternative Patterns
    	2.6.2 Matching on Element Ancestry
    	2.6.3 Anchors
    	2.6.4 Matching the Root Node
    	2.6.5 Matching on Element Types
    	2.6.6 Qualifiers
    	2.6.7 Matching on Children
    	2.6.8 Matching on Attributes
    	2.6.9 Matching on Position
    	2.6.10 Whitespace in Patterns
    	2.6.11 Specificity
    2.7 Templates
    	2.7.1 Overview
    	2.7.2 Literal Result Elements
    	2.7.3 Named Attribute Sets
    	2.7.4 Literal Text in Templates
    	2.7.5 Processing with xsl:process-children
    	2.7.6 Processing with xsl:process
    	2.7.7 Direct Processing
    	2.7.8 Numbering in the Source Tree
    	2.7.9 Number to String Conversion Attributes
    	2.7.10 Conditionals within a Template
    	2.7.11 Computing Generated Text
    	2.7.12 String Constants
    	2.7.13 Macros
    2.8 Style Rules
    2.9 Combining Stylesheets
    	2.9.1 Stylesheet Import
    	2.9.2 Stylesheet Inclusion
    	2.9.3 Embedding Stylesheets
    2.10 Extensibility
3. Formatting Objects
    3.1 Introduction
    3.2 Notations Used in this Section
    3.3 Formatting Objects and Their Properties
    3.4 Formatting Objects to be Defined in Subsequent Drafts
    3.5 Page-sequence Layout Object
    	3.5.1 Purpose
    	3.5.2 Formatting Object Summary
    	3.5.3 Formatting Object''s Formal Specification
    	3.5.4 To Resolve
    3.6 Simple-page-master Layout Object
    	3.6.1 Purpose
    	3.6.2 Formatting Object Summary
    	3.6.3 Formatting Object''s Formal Specification
    	3.6.4 To Resolve
A. DTD for XSL Stylesheets
B. References
    B.1 Normative References
    B.2 Other References
C. Examples (Non-Normative)
D. Design Principles (Non-Normative)
E. Acknowledgements (Non-Normative)
'
!

numberedXML
    "RuleDatabase numberedXML"

    | src stack str depth parent title tag |
    stack := OrderedCollection new.
    stack add: (XML::Element tag: 'doc').
    src := self numberedSourceData readStream.
    [src atEnd] whileFalse:
        [str := src upTo: Character nl.
        depth := str occurrencesOf: Character tab.
        str := str copyFrom: depth + 1 to: str size.
        tag := depth = 0
                ifTrue: [str first isDigit
                        ifTrue: ['chapter']
                        ifFalse: ['appendix']]
                ifFalse: [#('section' 'subsection') at: depth].
        str := str copyFrom: (str indexOf: $ )+1 to: str size.
        [depth + 1 = stack size] whileFalse: [stack removeLast].
        parent := stack last.
        title := XML::Text text: str.
        title := XML::Element tag: 'title' elements: (Array with: title).
        title := XML::Element tag: tag elements: (Array with: title).
        stack addLast: title.
        parent elements: (parent children copyWith: title)].
    ^stack first printString
!

numberedXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			xmlns:fo="http://www.w3.org/1999/XSL/Transform/FO"
    			result-ns="fo"
    			indent-result="yes">
    	<xsl:template match="doc">
    		<html>
    		<body>
    			<xsl:apply-templates/>
    		</body>
    		</html>
    	</xsl:template>

    	<xsl:template match="*" priority="-10">
    		<UL>
    			<xsl:apply-templates/>
    		</UL>
    	</xsl:template>

    	<xsl:template match="title">
    		<LI>
    			<xsl:number level="multi"
    					count="chapter|section|subsection"
    					format="1. "/>
    			<xsl:apply-templates/>
    		</LI>
    	</xsl:template>

    	<xsl:template match="appendix//title" priority="1">
    		<LI>
    			<xsl:number level="multi"
    					count="appendix|section|subsection"
    					format="I.a. "/>
    			<xsl:apply-templates/>
    		</LI>
    	</xsl:template>
    </xsl:stylesheet>'
!

numberedXSL1
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			xmlns:fo="http://www.w3.org/1999/XSL/Transform/FO"
    			result-ns="fo"
    			indent-result="yes">
    	<xsl:template match="doc">
    		<html>
    		<body>
    			<xsl:apply-templates/>
    		</body>
    		</html>
    	</xsl:template>

    	<xsl:template match="*" priority="-10">
    		<UL>
    			<xsl:apply-templates/>
    		</UL>
    	</xsl:template>

    	<xsl:template match="title">
    		<LI>
    			<xsl:number level="single"
    					count="chapter|section|subsection"
    					format="1. "/>
    			<xsl:apply-templates/>
    		</LI>
    	</xsl:template>

    	<xsl:template match="appendix//title" priority="1">
    		<LI>
    			<xsl:number level="single"
    					count="appendix|section|subsection"
    					format="I. "/>
    			<xsl:apply-templates/>
    		</LI>
    	</xsl:template>
    </xsl:stylesheet>'
!

numberedXSL2
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			xmlns:fo="http://www.w3.org/1999/XSL/Transform/FO"
    			result-ns="fo"
    			indent-result="yes">
    	<xsl:template match="doc">
    		<html>
    		<body>
    			<xsl:apply-templates/>
    		</body>
    		</html>
    	</xsl:template>

    	<xsl:template match="H3">
    		<fo:block>
    			<xsl:number level="any" count="H1"/>
    			<xsl:text>.</xsl:text>
    			<xsl:number level="any" from="H1" count="H2"/>
    			<xsl:text>.</xsl:text>
    			<xsl:number level="any" from="H2" count="H3"/>
    			<xsl:text> </xsl:text>
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    	<xsl:template match="H2">
    		<fo:block>
    			<xsl:number level="any" count="H1"/>
    			<xsl:text>.</xsl:text>
    			<xsl:number level="any" from="H1" count="H2"/>
    			<xsl:text> </xsl:text>
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    	<xsl:template match="H1">
    		<fo:block>
    			<xsl:number level="any" count="H1"/>
    			<xsl:text> </xsl:text>
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    </xsl:stylesheet>'
!

patternsXML
    ^'<?xml version="1.0"?>

    <!!DOCTYPE a [
        <!!ELEMENT a (a | b | c)*>
        <!!ELEMENT b (#PCDATA | c)*>
        <!!ELEMENT c (#PCDATA)>
        <!!ATTLIST a
                x ID #IMPLIED
                y CDATA #IMPLIED>
    ]>

    <a x="top">
        <a x="c1" y="tester">
                <b><c>title</c>
                body of chapter1</b>
                <b><c>subsection</c>
                more of chapter 1</b>
        </a>
        <a x="c2">
                <b><c>title2</c>
                body of chapter 2</b>
        </a>
    </a>'
!

patternsXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                        indent-result="yes">
        <xsl:template match=''/''>
                <xsl:comment>--------------------</xsl:comment>
                <xsl:apply-templates/>
                <xsl:pi name="vwst">arg1="class" arg2="Array"</xsl:pi>
        </xsl:template>

        <xsl:template match=''a''>
                <div><xsl:apply-templates/></div>
        </xsl:template>

        <xsl:template match=''b''>
                <span><xsl:apply-templates/></span>
        </xsl:template>

        <xsl:template match=''c''>
                <H1><xsl:apply-templates/></H1>
        </xsl:template>

        <xsl:template match=''a[@y="tester"]//c'' priority="1">
                <H1 attr="test"><xsl:apply-templates/></H1>
                <H2 attr="test"><xsl:value-of select=''id("c2")/b/c''/></H2>
        </xsl:template>

    </xsl:stylesheet>'
!

sampleXML
    ^'<doc>
    <title>An example</title>
    <p>This is a test.</p>
    <p>This is <emph>another</emph> test.</p>
    </doc>'
!

sampleXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			xmlns:fo="http://www.w3.org/1999/XSL/Transform/FO"
    			result-ns="fo"
    			indent-result="yes">
    	<xsl:template match=''/''>
    		<fo:page-sequence font-family="serif">
    			<fo:simple-page-master name=''scrolling''/>
    			<fo:queue queue-name=''body''>
    				<xsl:apply-templates/>
    			</fo:queue>
    		</fo:page-sequence>
    	</xsl:template>

    	<xsl:template match="title">
    		<fo:block font-weight="bold">
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    	<xsl:template match="p">
    		<fo:block>
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    	<xsl:template match="emph">
    		<fo:sequence font-style="italic">
    			<xsl:apply-templates/>
    		</fo:sequence>
    	</xsl:template>

    </xsl:stylesheet>'
!

xmlTestData1
    "RuleDatabase numberedXML"

    ^ '<catalog>

<cd>
<title>Empire Burlesque</title>
<artist>Bob Dylan</artist>
<country>USA</country>
<company>Columbia</company>
<price>10.90</price>
<year>1985</year>
</cd>

<cd>
<title>Hide your heart</title>
<artist>Bonnie Tyler</artist>
<country>UK</country>
<company>CBS Records</company>
<price>9.90</price>
<year>1988</year>
</cd>

<cd>
<title>Greatest Hits</title>
<artist>Dolly Parton</artist>
<country>USA</country>
<company>RCA</company>
<price>9.90</price>
<year>1982</year>
</cd>

<cd>
<title>Still got the blues</title>
<artist>Gary Moore</artist>
<country>UK</country>
<company>Virgin records</company>
<price>10.20</price>
<year>1990</year>
</cd>

<cd>
<title>Eros</title>
<artist>Eros Ramazzotti</artist>
<country>EU</country>
<company>BMG</company>
<price>9.90</price>
<year>1997</year>
</cd>

<cd>
<title>One night only</title>
<artist>Bee Gees</artist>
<country>UK</country>
<company>Polydor</company>
<price>10.90</price>
<year>1998</year>
</cd>

<cd>
<title>Sylvias Mother</title>
<artist>Dr.Hook</artist>
<country>UK</country>
<company>CBS</company>
<price>8.10</price>
<year>1973</year>
</cd>

<cd>
<title>Maggie May</title>
<artist>Rod Stewart</artist>
<country>UK</country>
<company>Pickwick</company>
<price>8.50</price>
<year>1990</year>
</cd>

<cd>
<title>Romanza</title>
<artist>Andrea Bocelli</artist>
<country>EU</country>
<company>Polydor</company>
<price>10.80</price>
<year>1996</year>
</cd>

<cd>
<title>When a man loves a woman</title>
<artist>Percy Sledge</artist>
<country>USA</country>
<company>Atlantic</company>
<price>8.70</price>
<year>1987</year>
</cd>

<cd>
<title>Black angel</title>
<artist>Savage Rose</artist>
<country>EU</country>
<company>Mega</company>
<price>10.90</price>
<year>1995</year>
</cd>

<cd>
<title>1999 Grammy Nominees</title>
<artist>Many</artist>
<country>USA</country>
<company>Grammy</company>
<price>10.20</price>
<year>1999</year>
</cd>

<cd>
<title>For the good times</title>
<artist>Kenny Rogers</artist>
<country>UK</country>
<company>Mucik Master</company>
<price>8.70</price>
<year>1995</year>
</cd>

<cd>
<title>Big Willie style</title>
<artist>Will Smith</artist>
<country>USA</country>
<company>Columbia</company>
<price>9.90</price>
<year>1997</year>
</cd>

<cd>
<title>Tupelo Honey</title>
<artist>Van Morrison</artist>
<country>UK</country>
<company>Polydor</company>
<price>8.20</price>
<year>1971</year>
</cd>

<cd>
<title>Soulsville</title>
<artist>Jorn Hoel</artist>
<country>Norway</country>
<company>WEA</company>
<price>7.90</price>
<year>1996</year>
</cd>

<cd>
<title>The very best of</title>
<artist>Cat Stevens</artist>
<country>UK</country>
<company>Island</company>
<price>8.90</price>
<year>1990</year>
</cd>

<cd>
<title>Stop</title>
<artist>Sam Brown</artist>
<country>UK</country>
<company>A and M</company>
<price>8.90</price>
<year>1988</year>
</cd>

<cd>
<title>Bridge of Spies</title>
<artist>T`Pau</artist>
<country>UK</country>
<company>Siren</company>
<price>7.90</price>
<year>1987</year>
</cd>

<cd>
<title>Private Dancer</title>
<artist>Tina Turner</artist>
<country>UK</country>
<company>Capitol</company>
<price>8.90</price>
<year>1983</year>
</cd>

<cd>
<title>Midt om natten</title>
<artist>Kim Larsen</artist>
<country>EU</country>
<company>Medley</company>
<price>7.80</price>
<year>1983</year>
</cd>

<cd>
<title>Pavarotti Gala Concert</title>
<artist>Luciano Pavarotti</artist>
<country>UK</country>
<company>DECCA</company>
<price>9.90</price>
<year>1991</year>
</cd>

<cd>
<title>The dock of the bay</title>
<artist>Otis Redding</artist>
<country>USA</country>
<company>Atlantic</company>
<price>7.90</price>
<year>1987</year>
</cd>

<cd>
<title>Picture book</title>
<artist>Simply Red</artist>
<country>EU</country>
<company>Elektra</company>
<price>7.20</price>
<year>1985</year>
</cd>

<cd>
<title>Red</title>
<artist>The Communards</artist>
<country>UK</country>
<company>London</company>
<price>7.80</price>
<year>1987</year>
</cd>

</catalog>'
!

xslTestData1
    "RuleDatabase numberedXML"

    ^ '<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
  <html>
  <body>
    <h2>My CD Collection</h2>
    <table border="1">
    <tr bgcolor="#9acd32">
      <th align="left">Title</th>
      <th align="left">Artist</th>
    </tr>
    <xsl:for-each select="catalog/cd">
    <tr>
      <td><xsl:value-of select="title"/></td>
      <td><xsl:value-of select="artist"/></td>
    </tr>
    </xsl:for-each>
    </table>
  </body>
  </html>
</xsl:template>

</xsl:stylesheet>'
! !

!RuleDatabase class methodsFor:'accessing'!

xsl_uri
    "return the value of the classInstVar variable 'xsl_uri' (automatically generated)"
    xsl_uri == nil ifTrue:[
        xsl_uri := 'http://www.w3.org/1999/XSL/Transform'
    ].
    ^ xsl_uri
!

xsl_uri:something
    "set the value of the classInstVar variable 'xsl_uri' (automatically generated)"

    xsl_uri := something.
! !

!RuleDatabase class methodsFor:'examples'!

allTest
    "XSL.RuleDatabase allTest"

    | sel |
    sel := self class selectors select: [:s | 'test*' match: s].
    sel asSortedCollection do:
    	[:s |
    	self perform: s].
!

examplesDirectory
    ^Directory append: 'xml' to: Directory image
!

myTest1
    "RuleDatabase myTest1"

    | test doc |
    test := self new.  self halt.
    test readString: self xslTestData1.
    doc := XML.XMLParser
                processDocumentString: self xmlTestData1
                beforeScanDo: [:parser | parser validate: false].
    self halt.
    ^test process: doc
!

numberedXML2
    "RuleDatabase numberedXML2"

    | src stack str depth title tag |
    stack := OrderedCollection new.
    stack add: (XML::Element tag: 'doc').
    src := self numberedSourceData readStream.
    [src atEnd] whileFalse:
        [str := src upTo: Character nl.
        depth := str occurrencesOf: Character tab.
        str := str copyFrom: depth + 1 to: str size.
        tag := depth = 0
                ifTrue: ['H1']
                ifFalse: [#('H2' 'H3' 'H4') at: depth].
        str := str copyFrom: (str indexOf: $ )+1 to: str size.
        title := XML::Text text: str.
        title := XML::Element tag: tag elements: (Array with: title).
        stack last elements: (stack last children copyWith: title)].
    ^stack first printString
!

store: document on: filename
    (FileStream open: filename mode: FileStream write)
    	print: document;
    	close
!

test
    "RuleDatabase test"

    | test doc |
    test := self new.
    test readString: self sampleXSL.
    doc := XML.XMLParser
                processDocumentString: self sampleXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test2
    "DOES NOT WORK AS HAVE NO FILES!!!!!!"
    "RuleDatabase test2"

    | test doc default result |
    default := self examplesDirectory.
    test := self new.
    test readFileNamed: (default construct: 'activityinfo.xsl').
    doc := XML.XMLParser
                processDocumentInFilename: (default construct: 'activityinfo.xml')
                beforeScanDo: [:parser | parser validate: false].
    result := test process: doc.
    self store: result on: 'activityinfo.html'
!

test2a
    "DOES NOT WORK AS HAVE NO FILES!!!!!!"
    "RuleDatabase test2a"

    | test doc default result |
    default := self examplesDirectory.
    test := self new.
    test readFileNamed: (default construct: 'activityinfo2.xsl').
    doc := XML.XMLParser
                processDocumentInFilename: (default construct: 'activityinfo.xml')
                beforeScanDo: [:parser | parser validate: false].
    result := test process: doc.
    self store: result on: 'activityinfo2.html'.
!

test2b
    "DOES NOT WORK AS HAVE NO FILES!!!!!!"
    "RuleDatabase test2b"

    | test doc default result |
    default := self examplesDirectory.
    test := self new.
    test readFileNamed: (default construct: 'activityinfo3.xsl').
    doc := XML.XMLParser
                processDocumentInFilename: (default construct: 'activityinfo.xml')
                beforeScanDo: [:parser | parser validate: false].
    result := test process: doc.
    self store: result on: 'activityinfo3.html'.
!

test3
    "DOES NOT WORK AS HAVE NO FILES!!!!!!"
    "RuleDatabase test3"

    | test doc default result |
    default := self examplesDirectory.
    test := self new.
    test readFileNamed: (default construct: 'listgen.xsl').
    doc := XML.XMLParser
                processDocumentInFilename: (default construct: 'listgen.xml')
                beforeScanDo: [:parser | parser validate: false].
    result := test process: doc.
    self store: result on: 'listgen.html'.
!

test4
    "RuleDatabase test4"

    | test doc |
    test := self new.
    test readString: self numberedXSL.
    doc := XML.XMLParser
                processDocumentString: self numberedXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test4a
    "RuleDatabase test4a"

    | test doc |
    test := self new.
    test readString: self numberedXSL1.
    doc := XML.XMLParser
                processDocumentString: self numberedXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test4b
    "RuleDatabase test4b"

    | test doc |
    test := self new.
    test readString: self numberedXSL2.
    doc := XML.XMLParser
                processDocumentString: self numberedXML2
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test5
    "RuleDatabase test5"

    | test doc |
    test := self new.
    test readString: self constructXSL.
    doc := XML.XMLParser
                processDocumentString: self constructXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test6
    "RuleDatabase test6"

    | test doc |
    test := self new. self halt.
    test readString: self patternsXSL.
    doc := XML.XMLParser
                processDocumentString: self patternsXML.
    ^test process: doc
!

test7
    "RuleDatabase test7"

    | test doc |
    test := self new.
    test readString: self macroXSL.
    doc := XML.XMLParser
                processDocumentString: self macroXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
! !

!RuleDatabase methodsFor:'accessing'!

output
    output == nil ifTrue: [output := OutputCommand new].
    ^output
!

outputMethodFor: aDocument
    | rt |
    self output method = #auto ifFalse: [^self output method].
    rt := aDocument root.
    (rt notNil and: [rt tag namespace isEmpty and: [rt tag type asLowercase = 'html']])
    	ifTrue: [^'html'].
    ^'xml'
! !

!RuleDatabase methodsFor:'importance'!

importance
    ^currentImportance
!

importance: aValueHolder
    currentImportance := aValueHolder
!

raiseImportance
    currentImportance := (currentImportance value + 1) asValue
!

replaceImportance: oldValue
    variables do: [:clist |
    	clist do: [:c |
    		c replaceImportance: oldValue with: currentImportance]].
    namedTemplates do: [:mlist |
    	mlist do: [:m |
    		m replaceImportance: oldValue with: currentImportance]].
    rules do: [:r |
    	r replaceImportance: oldValue with: currentImportance]
! !

!RuleDatabase methodsFor:'initialize'!

initURI: aProtocol name: aName
    uriStack == nil
    	ifTrue: [uriStack := OrderedCollection with: aProtocol->(aName copy asString replaceAll: Directory pathSeparator with: $/)].
!

initialize
    | baseRule action builtinImportance |
    normalized := false.
    rules := OrderedCollection new.
    variables := Dictionary new.
    namedTemplates := Dictionary new.
    attributeSets := Dictionary new.
    currentImportance := 1 asValue.
    builtinImportance := 0 asValue.

    action := ApplyTemplatesCommand new.
    baseRule := Rule new.
    baseRule mode: #any.
    baseRule attributes: (Array with: (XML::Attribute name: 'match' value: '*|/')).
    baseRule elements: (Array with: action).
    baseRule importanceHolder: builtinImportance.
    rules add: baseRule.

    action := ValueOfCommand new.
    action attributes: (Array with: (XML::Attribute name: 'select' value: '.')).
    baseRule := Rule new.
    baseRule mode: #any.
    baseRule attributes: (Array with: (XML::Attribute name: 'match' value: 'text()')).
    baseRule elements: (Array with: action).
    baseRule importanceHolder: builtinImportance.
    rules add: baseRule
! !

!RuleDatabase methodsFor:'loading'!

addAttributeSet: anAttributeSet
    | all |
    anAttributeSet importanceHolder: currentImportance.
    all := attributeSets at: anAttributeSet name
    		ifAbsentPut: [OrderedCollection new].
    all add: anAttributeSet
!

addNamedTemplate: aRule
    | all |
    aRule importanceHolder: currentImportance.
    all := namedTemplates at: aRule name
    		ifAbsentPut: [OrderedCollection new].
    (all contains: [:c | c importance = currentImportance value])
    	ifTrue: [self error: ('There are two named templates named %1 with the same importance' bindWith: aRule name)].
    all add: aRule
!

addRule: aRule
    aRule importanceHolder: currentImportance.
    rules add: aRule
!

addRuleSet: anXSLCommand topLevel: isTopLevel
    anXSLCommand purgeUnimportant.
    isTopLevel
    	ifTrue: [anXSLCommand topLevelAddToRuleDB: self]
    	ifFalse: [anXSLCommand addToRuleDB: self].
!

addVariable: aVariable
    | all |
    aVariable importanceHolder: currentImportance.
    all := variables at: aVariable name
    		ifAbsentPut: [OrderedCollection new].
    (all contains: [:c | c importance = currentImportance value])
    	ifTrue: [self error: ('There are two variables named %1 with the same importance' bindWith: aVariable name)].
    all add: aVariable
!

attributesForSet: setName
    | list map |
    list := attributeSets at: setName
    	ifAbsent: [self error: ('No attribute set named "%1".' bindWith: setName asString)].
    map := Dictionary new.
    list do: [:as |
    	(as allAttributesFrom: self) do: [:attr |
    		(map at: attr name ifAbsentPut: [SortedCollection sortBlock: [:a1 :a2 | a1 key > a2 key]])
    			add: as importance->attr]].
    list := OrderedCollection new.
    map do: [:singleList |
    	(singleList size > 1 and: [(singleList at: 1) key = (singleList at: 2) key])
    		ifTrue: [self error: ('Attribute set "%1" includes more than one definition of the attribute "%2".'
    					bindWith: setName asString
    					with: singleList first name asString)].
    	list add: singleList first value].
    ^list
!

bindVariableValues: aNodeContext arguments: argDictionary
    variables do: [:var |
    	var process: aNodeContext into: nil takeArgumentsFrom: argDictionary]
!

normalizeRules
    normalized ifTrue: [^self].
    normalized := true.
    self normalizeVariables.
    namedTemplates keys do: [:nm || clist |
    	clist := namedTemplates at: nm.
    	(clist collect: [:c | c importance]) asSet size = clist size
    		ifFalse: [self error: 'Named template named "',nm,'" has more than one definition with the same importance'].
    	namedTemplates at: nm put: (clist asSortedCollection: [:c1 :c2 | c1 importance < c2 importance]) last].
    namedTemplates do: [:m | m normalize].
    rules do: [:r | r normalize].
!

normalizeVariables
    | unsorted sorted lastSize list |
    variables class == Dictionary ifFalse: [^self].
    variables keys do: [:nm || clist |
    	clist := variables at: nm.
    	(clist collect: [:c | c importance]) asSet size = clist size
    		ifFalse: [self error: 'Variable named "',nm,'" has more than one definition with the same importance'].
    	variables at: nm put: (clist asSortedCollection: [:c1 :c2 | c1 importance < c2 importance]) last].
    variables do: [:c | c normalize].
    unsorted := variables asOrderedCollection.
    sorted := OrderedCollection new.
    lastSize := -1.
    [sorted size = lastSize] whileFalse:
    	[lastSize := sorted size.
    	unsorted copy do: [:var |
    		list := var expression usedVarNames.
    		list := list reject: [:nm | sorted includes: nm].
    		list isEmpty
    			ifTrue:
    				[sorted add: var name.
    				unsorted remove: var]]].
    unsorted isEmpty ifFalse: [self error: 'There is a cycle of reference between the variables'].
    variables := sorted collect: [:v | variables at: v].
!

readFileNamed: aFilename
    | doc |
    self initURI: 'file' name: aFilename asString.
    doc := XML.XMLParser
        processDocumentInFilename: aFilename
        beforeScanDo:
                [:parser |
                parser builder: XSLNodeBuilder new.
                parser validate: false].
    self addRuleSet: doc root topLevel: true
!

readStream: aStream
    self readStream: aStream topLevel: true
!

readStream: aStream topLevel: isTopLevel
    | doc parser |
    parser := XML.XMLParser on: aStream.
    parser builder: XSLNodeBuilder new.
    parser validate: false.
    doc := parser scanDocument.
    self addRuleSet: doc root topLevel: isTopLevel
!

readString: aString
    | doc |

    self initURI: 'file' name: (Directory append: 'xxx' to: Directory working).
    doc := XML.XMLParser  
        processDocumentString: aString
        beforeScanDo:
                [:parser |
                parser builder: XSLNodeBuilder new.
                parser validate: false].
    self addRuleSet: doc root topLevel: true
!

resolveAttributesForSet: setName
    | list |
    list := attributeSets at: setName
    	ifAbsent: [self error: ('No attribute set named "%1".' bindWith: setName asString)].
!

setOutput: anOutputCommand
    output := anOutputCommand
!

uriStack
    ^uriStack
! !

!RuleDatabase methodsFor:'processing'!

chooseBestRule: ruleList for: aNodeContext
    | best |
    ruleList size = 1 ifTrue: [^ruleList first].
    best := ruleList asSortedCollection:
    				[:r1 :r2 | r1 importance >= r2 importance].
    best := best asOrderedCollection select: [:r1 | r1 importance = best first importance].
    best size = 1 ifTrue: [^best first].
    best := best collect: [:r1 | r1 priority -> r1].
    best := best asSortedCollection: [:a1 :a2 | a1 > a2].
    best := best asOrderedCollection select: [:a1 | a1 key = best first key].
    best := best collect: [:a | a value].
    best size = 1 ifTrue: [^best first].
    best size = 0 ifFalse:
    	[self halt: 'Conflicting rules for ', aNodeContext node simpleDescription, ', use priority to rank the rules.'.
    	^best last].
    ^nil
!

process: aDocument
    ^self process: aDocument arguments: Dictionary new
!

process: aDocument arguments: passedArguments
    | doc baseDoc baseVars |
    self normalizeRules.
    doc := XML.DocumentFragment new.
    baseVars := Dictionary new.
    baseDoc := XSLNodeContext new
                add: aDocument;
                index: 1;
                variables: baseVars;
                db: self.
    self bindVariableValues: baseDoc arguments: passedArguments.
    baseDoc variables: (ChainedDictionary new parent: baseVars).
    (self process: baseDoc into: ElementProxy new mode: nil) children do: [:elm |
        doc addNode: elm].
    doc addNamespaceDefinitions.
    ^doc
!

process: aNodeContext into: aProxy mode: mode
    | rule list |
    list := rules select: [:r | r match: aNodeContext].
    list := list select: [:r | r modeIsLike: mode].
    rule := self chooseBestRule: list for: aNodeContext.
    rule == nil ifFalse: [rule process: aNodeContext into: aProxy arguments: #()].
    ^aProxy
!

ruleMatching: aNodeContext mode: mode
    | rule list |
    list := OrderedCollection new: 5.
    1 to: rules size do: [:i |
        rule := rules at: i.
        ((rule modeIsLike: mode) and: [rule match: aNodeContext])
                ifTrue: [list add: rule]].
    list := rules select: [:r | r match: aNodeContext].
    list := list select: [:r | r modeIsLike: mode].
    rule := self chooseBestRule: list for: aNodeContext.
    ^rule
!

ruleNamed: aName
    ^namedTemplates at: aName ifAbsent: []
! !

!RuleDatabase class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/RuleDatabase.st,v 1.7 2009/11/03 13:38:04 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/RuleDatabase.st,v 1.7 2009/11/03 13:38:04 cg Exp $'
! !
