"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XML::SAXWriter subclass:#SAXHtmlWriter
	instanceVariableNames:'htmlSpecialEmptyTags'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Output'
!


!SAXHtmlWriter methodsFor:'accessing'!

htmlSpecialEmptyTags
    htmlSpecialEmptyTags == nil
    	ifTrue: [htmlSpecialEmptyTags := #('area' 'base' 'basefont' 'br' 'col' 'frame' 'hr' 'img' 'input' 'isindex' 'link' 'meta' 'param')].
    ^htmlSpecialEmptyTags
!

htmlSpecialEmptyTags: aList
    htmlSpecialEmptyTags := aList
! !

!SAXHtmlWriter methodsFor:'content handler'!

endElement: namespaceURI localName: localName qName: name
    namespaceURI isEmpty
    	ifFalse: [^super endElement: namespaceURI
    			localName: localName
    			qName: name].
    hasOpenTag
    	ifTrue: [(self htmlSpecialEmptyTags includes: name asLowercase)
    		ifTrue: [output nextPutAll: '>']
    		ifFalse: [output nextPutAll: '/>']]
    	ifFalse: [output nextPutAll: '</', name asLowercase, '>'].
    hasOpenTag := false.
!

startElement: namespaceURI localName: localName qName: name attributes: attributes
    namespaceURI isEmpty
        ifFalse: [^super startElement: namespaceURI
                        localName: localName
                        qName: name
                        attributes: attributes].
    self closeOpenTag.
    output nextPutAll: '<'.
    output nextPutAll: name asLowercase.
    (self sort: attributes) do: [:att |
        output space.
        output nextPutAll: att tag asString asLowercase.
        (self isBoolean: att in: name)
                ifFalse:
                        [output nextPutAll: '="'.
                        1 to: att value size do: [:i || ch mapped |
                                ch := att value at: i.
                                mapped := attrMap at: ch ifAbsent: [nil].
                                mapped == nil
                                        ifTrue: [output nextPut: ch]
                                        ifFalse: [output nextPutAll: mapped]]].
        output nextPutAll: '"'].
    hasOpenTag := true.
    name asLowercase = 'head'
        ifTrue:
                [| atts |
                atts := OrderedCollection new.
                atts add: (XML::Attribute new
                        tag: (XML::NodeTag new qualifier: '' ns: '' type: 'http-equiv');
                        value: 'Content-Type').
                atts add: (XML::Attribute new
                        tag: (XML::NodeTag new qualifier: '' ns: '' type: 'content');
                        value: 'text/html; charset=utf-8').
                atts := atts asArray.
                self startElement: '' localName: 'meta' qName: 'meta' attributes: atts.
                self endElement: '' localName: 'meta' qName: 'meta'].
! !

!SAXHtmlWriter methodsFor:'testing'!

isBoolean: attribute in: elementTag
    ^false
! !

!SAXHtmlWriter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/SAXHtmlWriter.st,v 1.2 2009/11/03 13:38:57 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/SAXHtmlWriter.st,v 1.2 2009/11/03 13:38:57 cg Exp $'
! !
