"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#SortCommand
	instanceVariableNames:'selectPattern order lang dataType caseOrder'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes-Control'
!


!SortCommand class methodsFor:'accessing'!

tag
    ^'sort'
! !

!SortCommand methodsFor:'accessing'!

caseOrder
    self testPatternInitialized.
    ^caseOrder
!

dataType
    self testPatternInitialized.
    ^dataType
!

lang
    self testPatternInitialized.
    ^lang
!

order
    self testPatternInitialized.
    ^order
!

selectPattern
    self testPatternInitialized.
    ^selectPattern
! !

!SortCommand methodsFor:'initialize'!

normalize
    super normalize.
    (self parent respondsTo: #addSortBlock:)
    	ifFalse: [self error: self tag asString, ' can''t be a child element of ', self parent tag asString].
    self parent addSortBlock: self
!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    selectPattern := self readSelectPattern: 'select' default: ['.'].
    order := self readAttribute: 'order' default: ['ascending'].
    lang := self readAttribute: 'lang' default: [nil].
    dataType := self readAttribute: 'data-type' default: ['text'].
    caseOrder := self readAttribute: 'case-order' default: ['upper-first'].
! !

!SortCommand methodsFor:'processing'!

collate: node1 to: node2 within: aNodeContext
    | v1 v2 result collate |
    collate := aNodeContext.
    collate indexForNode: node1.
    v1 := self selectPattern xpathValueIn: collate.
    collate indexForNode: node2.
    v2 := self selectPattern xpathValueIn: collate.
    dataType = 'number'
    	ifTrue: [result := (v1 xpathAsNumber - v2 xpathAsNumber) sign]
    	ifFalse: [result := v1 xpathAsString < v2 xpathAsString].
    order = 'descending' ifTrue: [result := result negated].
    ^result
!

process: aNodeContext into: aProxy
    "Do nothing. I am only present as a modifier on for-each or apply-templates"
    ^self
!

process: aNodeContext intoArgs: aDictionary
    "Do nothing. I am only present as a modifier on for-each or apply-templates.
    For compatibility with <with-parm>"
    ^self
! !

!SortCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/SortCommand.st,v 1.1 2003/05/28 10:55:15 james Exp $'
! !
