"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLDefinition subclass:#VariableDefinition
	instanceVariableNames:'name expression'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes'
!


!VariableDefinition class methodsFor:'accessing'!

tag
    ^'variable'
! !

!VariableDefinition methodsFor:'accessing'!

expression
    self testPatternInitialized.
    ^expression
!

name
    self testPatternInitialized.
    ^name
!

purgeUnimportant
    ^self
! !

!VariableDefinition methodsFor:'initialize'!

normalize
    super normalize.
    self parent defineVariable: self
!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    name := self readAttribute: 'name'.   
    expression := self readSelectPattern: 'select' default: [].
    (expression notNil and: [self children isEmpty not])
        ifTrue: [self error: 'A parameter cannot have both content and a select attribute'].
! !

!VariableDefinition methodsFor:'loading'!

addToRuleDB: aDB
    "This is only understood by a small subset of commands."

    aDB addVariable: self
! !

!VariableDefinition methodsFor:'processing'!

process: aNodeContext into: aProxy
    | val |
    val := self valueAsVariableIn: aNodeContext.
    aNodeContext variables at: name put: val
! !

!VariableDefinition methodsFor:'testing'!

isStylesheetEntry
    ^true
! !

!VariableDefinition class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/VariableDefinition.st,v 1.1 2003/05/28 10:54:11 james Exp $'
! !
