"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XSLCommand subclass:#WithParamCommand
	instanceVariableNames:'name expression'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Nodes'
!


!WithParamCommand class methodsFor:'accessing'!

tag
    ^'with-param'
! !

!WithParamCommand methodsFor:'accessing'!

expression
    self testPatternInitialized.
    ^expression
!

name
    self testPatternInitialized.
    ^name
! !

!WithParamCommand methodsFor:'initialize'!

testPatternInitialized
    userData ifTrue: [^self].
    userData := true.
    name := self readAttribute: 'name'.
    expression := self readSelectPattern: 'select' default: [].
    (expression notNil and: [self children isEmpty not])
    	ifTrue: [self error: 'A parameter cannot have both content and a select attribute'].
! !

!WithParamCommand methodsFor:'processing'!

process: aNodeContext into: aProxy
    self shouldNotImplement
!

process: aNodeContext intoArgs: aDictionary
    | val |
    val := self valueAsVariableIn: aNodeContext.
    aDictionary at: self name put: val.
! !

!WithParamCommand class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/WithParamCommand.st,v 1.1 2003/05/28 10:57:22 james Exp $'
! !
