"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

XML::NodeBuilder subclass:#XSLNodeBuilder
	instanceVariableNames:'nodeNameMap'
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-Support'
!


!XSLNodeBuilder methodsFor:'building'!

makeText: text
    ^TextTemplate text: text
!

pi: nm text: text
    ^XSL_PI new name: nm text: text
!

tag: tag attributes: attributes elements: elements position: p stream: stream
    | elementClass transformUri|

    Smalltalk isSmalltalkX ifTrue:[
        transformUri := RuleDatabase xsl_uri. 
    ] ifFalse:[
        transformUri := XSL_URI
    ].

    tag namespace = transformUri ifTrue: [elementClass := self nodeNameMap
                                     at: tag type
                                     ifAbsent: [self error: 'The action ', tag asString, ' is not yet implemented']
    ] ifFalse: [elementClass := Template
    ].
    ^elementClass tag: tag attributes: attributes elements: elements
! !

!XSLNodeBuilder methodsFor:'private'!

nodeNameMap
    nodeNameMap == nil
    	ifTrue:
    		[nodeNameMap := Dictionary new.
    		XSLCommand withAllSubclasses do: [:beh |
    			beh tag == nil ifFalse: [nodeNameMap at: beh tag put: beh]]].
    ^nodeNameMap
! !

!XSLNodeBuilder class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/XSLNodeBuilder.st,v 1.3 2003/07/17 09:33:38 mb Exp $'
! !
