"{ Package: 'stx:goodies/xml/xsl' }"

"{ NameSpace: XSL }"

TestCase subclass:#XSLTestCases
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XSL-XSL-TestCases'
!

!XSLTestCases class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
         (james@miraculix)

    [instance variables:]

    [class variables:]

    [see also:]

"
!

history
    "Created: / 28.5.2003 / 12:36:20 / james"
! !

!XSLTestCases methodsFor:'XML for examples'!

constructXML
    "RuleDatabase constructXML"

    ^'<doc a="1" b="2">
    <title c="3" d="4">An example</title>
    <p k="xyz">This is a test.</p>
    <p>This is <emph>another</emph> test.</p>
    </doc>'
!

constructXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			indent-result="yes">
    	<xsl:variable name="tag" select="$tag2"/>
    	<xsl:variable name="tag2" select="''new''"/>

    	<xsl:template match="*">
    		<xsl:element name="{$tag}-{name(.)}">
    			<xsl:for-each select="@*">
    				<xsl:attribute name="{name(.)}-copy">
    					..<xsl:value-of select="."/>..
    				</xsl:attribute>
    			</xsl:for-each>
    			<xsl:apply-templates/>
    		</xsl:element>
    	</xsl:template>

    	<xsl:template match="p" priority="1">
    		<xsl:copy>
    			<xsl:apply-templates select="@*|*|text()"/>
    		</xsl:copy>
    	</xsl:template>

    	<xsl:template match="p/@*">
    		<xsl:copy>
    			<xsl:apply-templates select="text()"/>
    		</xsl:copy>
    	</xsl:template>
    </xsl:stylesheet>'
!

macroXML
    ^'<?xml version="1.0"?>

    <doc>
    	<p>a paragraph</p>
    	<p>another paragraph</p>
    	<warning>the warning</warning>
    	<p>closing paragraph</p>
    	<warning>warning 2</warning>
    	<warning>warning 3</warning>
    	<list>
    		<item><surname>Smith</surname><name>Joe</name><MI>G.</MI></item>
    		<item><surname>Jones</surname><name>John</name><MI>P.</MI></item>
    		<item><surname>Smith</surname><name>Bill</name><MI>M.</MI></item>
    		<item><surname>Bell</surname><name>Alexander</name><MI>G.</MI></item>
    		<item><surname>Smith</surname><name>Bill</name><MI>A.</MI></item>
    	</list>
    </doc>'
!

macroXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                        indent-result="yes">
        <xsl:template name="warning-para">
                <xsl:param name="format" select="''1. ''"/>
                <xsl:param name="content"/>
                <box font-color="red">
                        <xsl:number format="{$format}"/>
                        <xsl:text>Warning!! </xsl:text>
                        <xsl:copy-of select="$content"/>
                </box>
        </xsl:template>

        <xsl:template match=''p|doc''>
                <xsl:copy><xsl:apply-templates/></xsl:copy>
        </xsl:template>

        <xsl:template match=''warning''>
                <xsl:call-template name="warning-para">
                        <xsl:with-param name="format" select="''A. ''"/>
                        <xsl:with-param name="content">
                                <xsl:apply-templates/>
                                <xsl:text> (see appendix)</xsl:text>
                        </xsl:with-param>
                </xsl:call-template>
        </xsl:template>

        <xsl:template match=''list''>
                <list>
                        <xsl:apply-templates select="item">
                                <xsl:sort select="surname" order="ascending"/>
                                <xsl:sort select="name" order="descending"/>
                        </xsl:apply-templates>
                </list>
        </xsl:template>

        <xsl:template match=''item''>
                <name>
                        <xsl:value-of select="name"/>
                        <xsl:text> </xsl:text>
                        <xsl:value-of select="MI"/>
                        <xsl:text> </xsl:text>
                        <xsl:value-of select="surname"/>
                </name>
        </xsl:template>

    </xsl:stylesheet>'
!

numberedSourceData
    ^'1. Overview
2. Tree Construction
    2.1 Overview
    2.2 Stylesheet Structure
    2.3 Processing Model
    2.4 Data Model
    	2.4.1 Root Node
    	2.4.2 Element Nodes
    	2.4.3 Attribute Nodes
    	2.4.4 Character Data
    	2.4.5 Whitespace Stripping
    2.5 Template Rules
    	2.5.1 Conflict Resolution for Template Rules
    	2.5.2 Built-in Template Rule
    2.6 Patterns
    	2.6.1 Alternative Patterns
    	2.6.2 Matching on Element Ancestry
    	2.6.3 Anchors
    	2.6.4 Matching the Root Node
    	2.6.5 Matching on Element Types
    	2.6.6 Qualifiers
    	2.6.7 Matching on Children
    	2.6.8 Matching on Attributes
    	2.6.9 Matching on Position
    	2.6.10 Whitespace in Patterns
    	2.6.11 Specificity
    2.7 Templates
    	2.7.1 Overview
    	2.7.2 Literal Result Elements
    	2.7.3 Named Attribute Sets
    	2.7.4 Literal Text in Templates
    	2.7.5 Processing with xsl:process-children
    	2.7.6 Processing with xsl:process
    	2.7.7 Direct Processing
    	2.7.8 Numbering in the Source Tree
    	2.7.9 Number to String Conversion Attributes
    	2.7.10 Conditionals within a Template
    	2.7.11 Computing Generated Text
    	2.7.12 String Constants
    	2.7.13 Macros
    2.8 Style Rules
    2.9 Combining Stylesheets
    	2.9.1 Stylesheet Import
    	2.9.2 Stylesheet Inclusion
    	2.9.3 Embedding Stylesheets
    2.10 Extensibility
3. Formatting Objects
    3.1 Introduction
    3.2 Notations Used in this Section
    3.3 Formatting Objects and Their Properties
    3.4 Formatting Objects to be Defined in Subsequent Drafts
    3.5 Page-sequence Layout Object
    	3.5.1 Purpose
    	3.5.2 Formatting Object Summary
    	3.5.3 Formatting Object''s Formal Specification
    	3.5.4 To Resolve
    3.6 Simple-page-master Layout Object
    	3.6.1 Purpose
    	3.6.2 Formatting Object Summary
    	3.6.3 Formatting Object''s Formal Specification
    	3.6.4 To Resolve
A. DTD for XSL Stylesheets
B. References
    B.1 Normative References
    B.2 Other References
C. Examples (Non-Normative)
D. Design Principles (Non-Normative)
E. Acknowledgements (Non-Normative)
'
!

numberedXML
    "RuleDatabase numberedXML"

    | src stack str depth parent title tag |
    stack := OrderedCollection new.
    stack add: (XML::Element tag: 'doc').
    src := self numberedSourceData readStream.
    [src atEnd] whileFalse:
        [str := src upTo: Character nl.
        depth := str occurrencesOf: Character tab.
        str := str copyFrom: depth + 1 to: str size.
        tag := depth = 0
                ifTrue: [str first isDigit
                        ifTrue: ['chapter']
                        ifFalse: ['appendix']]
                ifFalse: [#('section' 'subsection') at: depth].
        str := str copyFrom: (str indexOf: $ )+1 to: str size.
        [depth + 1 = stack size] whileFalse: [stack removeLast].
        parent := stack last.
        title := XML::Text text: str.
        title := XML::Element tag: 'title' elements: (Array with: title).
        title := XML::Element tag: tag elements: (Array with: title).
        stack addLast: title.
        parent elements: (parent children copyWith: title)].
    ^stack first printString
!

numberedXML2
    "RuleDatabase numberedXML2"

    | src stack str depth title tag |
    stack := OrderedCollection new.
    stack add: (XML::Element tag: 'doc').
    src := self numberedSourceData readStream.
    [src atEnd] whileFalse:
        [str := src upTo: Character nl.
        depth := str occurrencesOf: Character tab.
        str := str copyFrom: depth + 1 to: str size.
        tag := depth = 0
                ifTrue: ['H1']
                ifFalse: [#('H2' 'H3' 'H4') at: depth].
        str := str copyFrom: (str indexOf: $ )+1 to: str size.
        title := XML::Text text: str.
        title := XML::Element tag: tag elements: (Array with: title).
        stack last elements: (stack last children copyWith: title)].
    ^stack first printString
!

numberedXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			xmlns:fo="http://www.w3.org/1999/XSL/Transform/FO"
    			result-ns="fo"
    			indent-result="yes">
    	<xsl:template match="doc">
    		<html>
    		<body>
    			<xsl:apply-templates/>
    		</body>
    		</html>
    	</xsl:template>

    	<xsl:template match="*" priority="-10">
    		<UL>
    			<xsl:apply-templates/>
    		</UL>
    	</xsl:template>

    	<xsl:template match="title">
    		<LI>
    			<xsl:number level="multi"
    					count="chapter|section|subsection"
    					format="1. "/>
    			<xsl:apply-templates/>
    		</LI>
    	</xsl:template>

    	<xsl:template match="appendix//title" priority="1">
    		<LI>
    			<xsl:number level="multi"
    					count="appendix|section|subsection"
    					format="I.a. "/>
    			<xsl:apply-templates/>
    		</LI>
    	</xsl:template>
    </xsl:stylesheet>'
!

numberedXSL1
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			xmlns:fo="http://www.w3.org/1999/XSL/Transform/FO"
    			result-ns="fo"
    			indent-result="yes">
    	<xsl:template match="doc">
    		<html>
    		<body>
    			<xsl:apply-templates/>
    		</body>
    		</html>
    	</xsl:template>

    	<xsl:template match="*" priority="-10">
    		<UL>
    			<xsl:apply-templates/>
    		</UL>
    	</xsl:template>

    	<xsl:template match="title">
    		<LI>
    			<xsl:number level="single"
    					count="chapter|section|subsection"
    					format="1. "/>
    			<xsl:apply-templates/>
    		</LI>
    	</xsl:template>

    	<xsl:template match="appendix//title" priority="1">
    		<LI>
    			<xsl:number level="single"
    					count="appendix|section|subsection"
    					format="I. "/>
    			<xsl:apply-templates/>
    		</LI>
    	</xsl:template>
    </xsl:stylesheet>'
!

numberedXSL2
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			xmlns:fo="http://www.w3.org/1999/XSL/Transform/FO"
    			result-ns="fo"
    			indent-result="yes">
    	<xsl:template match="doc">
    		<html>
    		<body>
    			<xsl:apply-templates/>
    		</body>
    		</html>
    	</xsl:template>

    	<xsl:template match="H3">
    		<fo:block>
    			<xsl:number level="any" count="H1"/>
    			<xsl:text>.</xsl:text>
    			<xsl:number level="any" from="H1" count="H2"/>
    			<xsl:text>.</xsl:text>
    			<xsl:number level="any" from="H2" count="H3"/>
    			<xsl:text> </xsl:text>
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    	<xsl:template match="H2">
    		<fo:block>
    			<xsl:number level="any" count="H1"/>
    			<xsl:text>.</xsl:text>
    			<xsl:number level="any" from="H1" count="H2"/>
    			<xsl:text> </xsl:text>
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    	<xsl:template match="H1">
    		<fo:block>
    			<xsl:number level="any" count="H1"/>
    			<xsl:text> </xsl:text>
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    </xsl:stylesheet>'
!

patternsXML
    ^'<?xml version="1.0"?>

    <!!DOCTYPE a [
        <!!ELEMENT a (a | b | c)*>
        <!!ELEMENT b (#PCDATA | c)*>
        <!!ELEMENT c (#PCDATA)>
        <!!ATTLIST a
                x ID #IMPLIED
                y CDATA #IMPLIED>
    ]>

    <a x="top">
        <a x="c1" y="tester">
                <b><c>title</c>
                body of chapter1</b>
                <b><c>subsection</c>
                more of chapter 1</b>
        </a>
        <a x="c2">
                <b><c>title2</c>
                body of chapter 2</b>
        </a>
    </a>'
!

patternsXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                        indent-result="yes">
        <xsl:template match=''/''>
                <xsl:comment>--------------------</xsl:comment>
                <xsl:apply-templates/>
                <xsl:pi name="vwst">arg1="class" arg2="Array"</xsl:pi>
        </xsl:template>

        <xsl:template match=''a''>
                <div><xsl:apply-templates/></div>
        </xsl:template>

        <xsl:template match=''b''>
                <span><xsl:apply-templates/></span>
        </xsl:template>

        <xsl:template match=''c''>
                <H1><xsl:apply-templates/></H1>
        </xsl:template>

        <xsl:template match=''a[@y="tester"]//c'' priority="1">
                <H1 attr="test"><xsl:apply-templates/></H1>
                <H2 attr="test"><xsl:value-of select=''id("c2")/b/c''/></H2>
        </xsl:template>

    </xsl:stylesheet>'
!

sampleXML
    ^'<doc>
    <title>An example</title>
    <p>This is a test.</p>
    <p>This is <emph>another</emph> test.</p>
    </doc>'
!

sampleXSL
    ^'<?xml version=''1.0''?>
    <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    			xmlns:fo="http://www.w3.org/1999/XSL/Transform/FO"
    			result-ns="fo"
    			indent-result="yes">
    	<xsl:template match=''/''>
    		<fo:page-sequence font-family="serif">
    			<fo:simple-page-master name=''scrolling''/>
    			<fo:queue queue-name=''body''>
    				<xsl:apply-templates/>
    			</fo:queue>
    		</fo:page-sequence>
    	</xsl:template>

    	<xsl:template match="title">
    		<fo:block font-weight="bold">
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    	<xsl:template match="p">
    		<fo:block>
    			<xsl:apply-templates/>
    		</fo:block>
    	</xsl:template>

    	<xsl:template match="emph">
    		<fo:sequence font-style="italic">
    			<xsl:apply-templates/>
    		</fo:sequence>
    	</xsl:template>

    </xsl:stylesheet>'
! !

!XSLTestCases methodsFor:'examples'!

allTest
    "XSL.RuleDatabase allTest"

    | sel |
    sel := self class selectors select: [:s | 'test*' match: s].
    sel asSortedCollection do:
    	[:s |
    	self perform: s].
!

examplesDirectory
    ^Directory append: 'xml' to: Directory image
!

store: document on: filename
    (FileStream open: filename mode: FileStream write)
    	print: document;
    	close
! !

!XSLTestCases methodsFor:'initialize / release'!

setUp
    "common setup - invoked before testing."

    super setUp
!

tearDown
    "common cleanup - invoked after testing."

    super tearDown
! !

!XSLTestCases methodsFor:'tests'!

test
    "RuleDatabase test"

    | test doc |
    test := RuleDatabase new.
    test readString: self sampleXSL.
    doc := XML.XMLParser
                processDocumentString: self sampleXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test1
    "This is a demonstration testCase - it is meant to be removed eventually.
     This testCase will PASS.
     Double click on the TestCase class or open a TestRunner to see me checking...
     - please add more methods like this..."

    |o|

    o := Array new:2.
    self assert: ( o size == 2 ).
    self should: [ o at:0 ] raise:Error.
    self shouldnt: [ o at:1 ] raise:Error.

    "
     self run:#test1
     self new test1
    "
!

test2
    "DOES NOT WORK AS HAVE NO FILES!!!!!!"
    "RuleDatabase test2"

"/    | test doc default result |
"/    default := self examplesDirectory.
"/    test := RuleDatabase new.
"/    test readFileNamed: (default construct: 'activityinfo.xsl').
"/    doc := XML.XMLParser
"/                processDocumentInFilename: (default construct: 'activityinfo.xml')
"/                beforeScanDo: [:parser | parser validate: false].
"/    result := test process: doc.
"/    self store: result on: 'activityinfo.html'
!

test2a
    "DOES NOT WORK AS HAVE NO FILES!!!!!!"
    "RuleDatabase test2a"

"/    | test doc default result |
"/    default := self examplesDirectory.
"/    test := RuleDatabase new.
"/    test readFileNamed: (default construct: 'activityinfo2.xsl').
"/    doc := XML.XMLParser
"/                processDocumentInFilename: (default construct: 'activityinfo.xml')
"/                beforeScanDo: [:parser | parser validate: false].
"/    result := test process: doc.
"/    self store: result on: 'activityinfo2.html'.
"/
!

test2b
    "DOES NOT WORK AS HAVE NO FILES!!!!!!"
    "RuleDatabase test2b"

"/    | test doc default result |
"/    default := self examplesDirectory.
"/    test := RuleDatabase new.
"/    test readFileNamed: (default construct: 'activityinfo3.xsl').
"/    doc := XML.XMLParser
"/                processDocumentInFilename: (default construct: 'activityinfo.xml')
"/                beforeScanDo: [:parser | parser validate: false].
"/    result := test process: doc.
"/    self store: result on: 'activityinfo3.html'.
!

test3
    "DOES NOT WORK AS HAVE NO FILES!!!!!!"
    "RuleDatabase test3"

"/    | test doc default result |
"/    default := self examplesDirectory.
"/    test := RuleDatabase new.
"/    test readFileNamed: (default construct: 'listgen.xsl').
"/    doc := XML.XMLParser
"/                processDocumentInFilename: (default construct: 'listgen.xml')
"/                beforeScanDo: [:parser | parser validate: false].
"/    result := test process: doc.
"/    self store: result on: 'listgen.html'.
!

test4
    "RuleDatabase test4"

    | test doc |
    test := RuleDatabase new.
    test readString: self numberedXSL.
    doc := XML.XMLParser
                processDocumentString: self numberedXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test4a
    "RuleDatabase test4a"

    | test doc |
    test := RuleDatabase new.
    test readString: self numberedXSL1.
    doc := XML.XMLParser
                processDocumentString: self numberedXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test4b
    "RuleDatabase test4b"

    | test doc |
    test := RuleDatabase new.
    test readString: self numberedXSL2.
    doc := XML.XMLParser
                processDocumentString: self numberedXML2
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test5
    "RuleDatabase test5"

    | test doc |
    test := RuleDatabase new.
    test readString: self constructXSL.
    doc := XML.XMLParser
                processDocumentString: self constructXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
!

test6
    "RuleDatabase test6"

    | test doc |
    test := RuleDatabase new.
    test readString: self patternsXSL.
    doc := XML.XMLParser
                processDocumentString: self patternsXML.
    ^test process: doc
!

test7
    "RuleDatabase test7"

    | test doc |
    test := RuleDatabase new.
    test readString: self macroXSL.
    doc := XML.XMLParser
                processDocumentString: self macroXML
                beforeScanDo: [:parser | parser validate: false].
    ^test process: doc
! !

!XSLTestCases class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/XSLTestCases.st,v 1.2 2009/11/03 13:12:07 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/XSLTestCases.st,v 1.2 2009/11/03 13:12:07 cg Exp $'
! !
