"{ Package: 'stx:goodies/xml/xsl' }"

LibraryDefinition subclass:#stx_goodies_xml_xsl
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_xml_xsl class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/xml/vw'    "XML::Element - superclass of XSL::AttributeCommand "
        #'stx:goodies/xml/xpath'    "XML::XPathNodeContext - superclass of XSL::XSLNodeContext "
        #'stx:libbasic'    "Object - superclass of XSL::CounterCommand "
    )
! !

!stx_goodies_xml_xsl class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'XSL::ChainedDictionary'
        #'XSL::DenormalizedText'
        #'XSL::Directory'
        #'XSL::GeneralCountingProxy'
        #'XSL::NodeIterator'
        #'XSL::NumberFormat'
        #'XSL::Rank'
        #'XSL::RuleDatabase'
        #'XSL::SAXHtmlWriter'
        #'XSL::SAXTextWriter'
        #'XSL::TextTemplate'
        #'XSL::XSLCommand'
        #'XSL::XSLNodeBuilder'
        #'XSL::XSLNodeContext'
        (#'XSL::XSLTestCases' autoload)
        #'XSL::XSL_PI'
        #'stx_goodies_xml_xsl'
        #'XSL::ApplyTemplatesCommand'
        #'XSL::AttributeCommand'
        #'XSL::CallTemplateCommand'
        #'XSL::ChooseCommand'
        #'XSL::ChooseOtherwiseCommand'
        #'XSL::ChooseWhenCommand'
        #'XSL::CommentCommand'
        #'XSL::CopyCommand'
        #'XSL::CopyOfCommand'
        #'XSL::CounterIncrementCommand'
        #'XSL::CounterResetCommand'
        #'XSL::CounterScopeCommand'
        #'XSL::CountingCommand'
        #'XSL::CountingProxy'
        #'XSL::ElementCommand'
        #'XSL::ElementProxy'
        #'XSL::ForEachCommand'
        #'XSL::IfCommand'
        #'XSL::PICommand'
        #'XSL::RuleSet'
        #'XSL::SortCommand'
        #'XSL::Template'
        #'XSL::TextCommand'
        #'XSL::ValueOfCommand'
        #'XSL::WithParamCommand'
        #'XSL::XSLDefinition'
        #'XSL::AttributeSet'
        #'XSL::CounterCommand'
        #'XSL::CountersCommand'
        #'XSL::DecimalFormat'
        #'XSL::Import'
        #'XSL::Include'
        #'XSL::NumberCommand'
        #'XSL::OutputCommand'
        #'XSL::ParamDefinition'
        #'XSL::Rule'
        #'XSL::VariableDefinition'
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!stx_goodies_xml_xsl class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2009\nCopyright eXept Software AG 1998-2009'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_xml_xsl class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/xsl/stx_goodies_xml_xsl.st,v 1.2 2009/11/03 14:17:59 cg Exp $'
! !
