"{ Package: 'stx:goodies/xml/yaxo' }"

"{ NameSpace: YAXO }"

Object subclass:#DTDEntityDeclaration
	instanceVariableNames:'name value ndata'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-YAXO-Parser'
!

DTDEntityDeclaration class instanceVariableNames:'contextBehavior'

"
 No other class instance variables are inherited by this class.
"
!


!DTDEntityDeclaration class methodsFor:'instance creation'!

name: aString value: aValueString
	^(self new)
		name: aString;
		value: aValueString;
		yourself
! !

!DTDEntityDeclaration class methodsFor:'accessing'!

behaviorForContext: aContext
	^self contextBehavior at: aContext
!

contextBehavior
	^contextBehavior
!

leadIn
	^'&'
! !

!DTDEntityDeclaration class methodsFor:'class initialization'!

initialize
	"
	DTDEntityDeclaration initialize
	"

	contextBehavior := Dictionary new.
	contextBehavior
		at: #content put: #include;
		at: #attributeValueContent put: #includedInLiteral;
		at: #attributeValue put: #forbidden;
		at: #entityValue put: #bypass;
		at: #dtd put: #forbidden
! !

!DTDEntityDeclaration methodsFor:'accessing'!

name
	^name
!

name: aString
	name := aString asSymbol
!

ndata
	^ndata
!

ndata: aString
	ndata := aString
!

value
	^value
!

value: aString
	#swYAXO. "Add recursive check"
	aString = self reference ifTrue: [SAXMalformedException signal: 'A parsed entity must not contain a recursive reference to itself'].

	value := aString
! !

!DTDEntityDeclaration methodsFor:'behaviors'!

bypass
	"Return my reference as is."
	^self reference
!

forbidden
	self error: 'Forbidden reference usage'
!

include
	"Return my expanded value."
	^value ifNil: [SAXWarning signal: 'XML undefined entity ' , name printString]
!

includedInLiteral
	"Return my expanded value."
	^self include
!

reference
	"Return my reference as is."
	^self class leadIn , self name , ';'
! !

!DTDEntityDeclaration methodsFor:'invocation'!

registerIn: aParser
	#swYAXO. "sw added #asString"
	aParser entity: self name asString put: self
!

valueForContext: aContext
	^self perform: (self class behaviorForContext: aContext)
! !

!DTDEntityDeclaration class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/yaxo/DTDEntityDeclaration.st,v 1.3 2003/04/23 08:44:17 cg Exp $'
! !

DTDEntityDeclaration initialize!
