"{ Package: 'stx:goodies/xml/yaxo' }"

"{ NameSpace: YAXO }"

XMLNodeWithEntities subclass:#XMLDocument
	instanceVariableNames:'dtd version encoding requiredMarkup namespace uri'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-YAXO-Parser'
!

!XMLDocument class methodsFor:'documentation'!

documentation
"
    cg: I duplicated the namespace and uri instvars instead of moving them
    to the superclass in order to save space for huge documents which have
    no namespace elements.
"
! !

!XMLDocument methodsFor:'accessing'!

dtd
	^dtd
!

dtd: aDTD
	dtd := aDTD
!

encoding        
	^encoding
!

encoding: aString       
	encoding := aString
!

namespace
    ^ namespace
!

namespace:ns uri:u 
    namespace := ns.
    uri := u
!

namespaceURI
    ^ uri
!

requiredMarkup  
	^requiredMarkup
!

requiredMarkup: aString 
	requiredMarkup := aString
!

version 
	^version
!

version: aString        
	version := aString
! !

!XMLDocument methodsFor:'printing'!

printCanonicalOn: aStream

	| writer |
	writer := XMLWriter on: aStream.
	writer canonical: true.
	self printXMLOn: writer
!

printXMLOn: writer
	#swYAXO.
	version notNil ifTrue: 
			[
			writer xmlDeclaration: self version].
	super printXMLOn: writer
! !

!XMLDocument methodsFor:'testing'!

hasDocumentElement
	#swYAXO.
	self entitiesDo: [ :k :v | v isTag ifTrue: [^true]].
	^false
        
!

isDocument
	#swYAXO.
	^true
! !

!XMLDocument class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/yaxo/XMLDocument.st,v 1.4 2009/10/14 18:48:15 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/yaxo/XMLDocument.st,v 1.4 2009/10/14 18:48:15 cg Exp $'
! !
