"{ Package: 'stx:goodies/xml/yaxo' }"

"{ NameSpace: YAXO }"

XMLNode subclass:#XMLNodeWithEntities
	instanceVariableNames:'entities'
	classVariableNames:''
	poolDictionaries:''
	category:'XML-YAXO-Parser'
!


!XMLNodeWithEntities methodsFor:'accessing'!

addEntity: entity
	self addEntity: entity name value: entity
!

addEntity: entityName value: entityValue
	self entities add: entityName->entityValue
!

basicElements
        ^self entities collect: [:each | each value]
!

elementAt:entityName
        ^self entityAt: entityName ifAbsent: [nil]
!

elements
        ^self basicElements
!

entities
	entities ifNil: [entities := OrderedCollection new].
	^entities
!

entityAt: entityName
	^self entityAt: entityName ifAbsent: [nil]
!

entityAt: entityName ifAbsent: aBlock
    entities notNil ifTrue:[
        entities do:[:eachAssoc |
            |entity|

            entity := eachAssoc value.
            eachAssoc key = entityName ifTrue:[ ^ entity].
            entity name = entityName ifTrue:[ ^ entity].
            entity localName = entityName ifTrue:[^ entity].
        ].
    ].
    ^ aBlock value.

    "/ ^ entities detect: [:each | each key = entityName] ifNone: [^aBlock value]) value

    "Modified: / 28-06-2010 / 20:01:04 / cg"
!

namespace
    ^ nil
!

namespaceURI
    ^ nil
!

tagElements
    "all the non-cdata elements"

    ^ entities 
        select:[:e | e value isTag] 
        thenCollect:[:e | e value].

    "Created: / 14-07-2011 / 22:02:01 / cg"
!

topElement
	^self entities first value
! !

!XMLNodeWithEntities methodsFor:'enumerating'!

entitiesDo: aBlock
	#swYAXO.
	entities notNil ifTrue: 
			[
			self entities do: [:each | aBlock value: each key value: each value]]
! !

!XMLNodeWithEntities methodsFor:'printing'!

printXMLOn: writer
	self entitiesDo: [:eName :eValue | eValue printXMLOn: writer]
! !

!XMLNodeWithEntities class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/yaxo/XMLNodeWithEntities.st,v 1.10 2011/07/14 20:04:24 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/yaxo/XMLNodeWithEntities.st,v 1.10 2011/07/14 20:04:24 cg Exp $'
! !
