"{ Package: 'stx:goodies/xml/yaxo' }"

"{ NameSpace: YAXO }"

XMLTokenizer subclass:#XMLParser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'XML-YAXO-Parser'
!


!XMLParser methodsFor:'callbacks'!

attribute:aSymbol value:aString 
    "This method is called for each attribute/value pair in a start tag"
    
    ^ self subclassResponsibility
!

beginStartTag:aSymbol asPI:aBoolean 
    "This method is called for at the beginning of a start tag.
     The asPI parameter defines whether or not the tag is a 'processing
     instruction' rather than a 'normal' tag."
    
    ^ self subclassResponsibility
!

endStartTag:aSymbol 
    "This method is called at the end of the start tag after all of the
     attributes have been processed"
    
    ^ self subclassResponsibility
!

endTag:aSymbol 
    "This method is called when the parser encounters either an
     end tag or the end of a unary tag"
    
    ^ self subclassResponsibility
!

text:aString 
    "This method is called for the blocks of text between tags.
     It preserves whitespace, but has all of the enclosed entities expanded"
    
    ^ self subclassResponsibility
! !

!XMLParser methodsFor:'handling tokens'!

handleCData:aString 
    self text:aString
!

handleEndTag:aString 
    self endTag:aString
!

handlePCData:aString 
    self text:aString
!

handleStartTag:tagName attributes:attributes 
    self beginStartTag:tagName asPI:false.
    attributes 
        keysAndValuesDo:[:key :value | self attribute:key value:value ].
    self endStartTag:tagName
! !

!XMLParser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/xml/yaxo/XMLParser.st,v 1.4 2009/10/14 19:27:51 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/xml/yaxo/XMLParser.st,v 1.4 2009/10/14 19:27:51 cg Exp $'
! !
