/*
 * COPYRIGHT (c) 2003 by eXept Software AG
 *              All Rights Reserved
 *
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 * $Header: /cvs/stx/stx/stc/stxOSDefs.h,v 1.39 2011/10/07 12:42:04 cg Exp $
 *
 * These used to be located in UnixOperatingSystem.st as primitive definitions;
 * now, they are included, as most of it is to be shared with other OS's.
 */

#ifndef __STX_OSDEFS_H
# define __STX_OSDEFS_H

# ifdef LINUX
#  define BUGGY_STDIO_LIB
#  include <linux/version.h>

#  ifndef KERNEL_VERSION
#   define KERNEL_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))
#  endif
# endif /* LINUX */

# define UNIX_LIKE

# if defined(WIN32) || defined(__VMS__) || defined(transputer)
#  undef UNIX_LIKE
# endif

/*
 * Socket support
 */
# if defined(transputer)
#  ifndef NO_SOCKET
#   define NO_SOCKET
#  endif
# endif

# ifdef __VMS__
#  define WANT__AF_INET
#  define WANT__AF_DECnet
# endif

# ifdef WIN32
#  define WANT__AF_INET
# endif

# ifdef UNIX_LIKE
#  define WANT__AF_INET
#  define WANT__AF_UNIX
#  define WANT__NETDB_DOT_H
# endif

# ifdef LINUX
#  ifndef LINUX_VERSION_CODE
   /* PRE 2.0 Linux kernel. */
#  else
#   if LINUX_VERSION_CODE < KERNEL_VERSION(2,0,0)
   /* PRE 2.0 Linux kernel. */
#   else
#    define WANT__TCP_DOT_H
#    if LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,0)
#     define WANT__AF_APPLETALK
#     define xxWANT__AF_X25
#     define xxWANT__AF_AX25
#     define xxWANT__AF_IPX
#     define WANT__AF_INET6 */
#     if LINUX_VERSION_CODE >= KERNEL_VERSION(2,2,0)
#      define xxWANT__AF_IRDA */
#     endif /* >= 2.2.0 */
#    endif /* >= 2.1.0 */
#   endif /* pre 2.0.0 */
#  endif /* pre 2.0.0 */
# endif /* LINIX */

# ifdef solaris2_0
#  include <unistd.h>
#  include <sys/socket.h>
#  include <sys/sockio.h>
#  include <net/if.h>
# endif

# ifdef hpux
#  include <unistd.h>
#  include <sys/time.h>
#  include <sys/socket.h>
#  include <net/if.h>
# endif


# ifndef _FCNTL_H_INCLUDED_
#  include <fcntl.h>
#  define _FCNTL_H_INCLUDED_
# endif
# ifndef _SYS_TYPES_H_INCLUDED_
#  include <sys/types.h>
#  define _SYS_TYPES_H_INCLUDED_
# endif

# ifdef NEED_SYS_TIME_H
#  ifndef _SYS_TIME_H_INCLUDED_
#   include <sys/time.h>
#   define _SYS_TIME_H_INCLUDED_
#  endif
# endif
# ifdef NEED_TIME_H
#  ifndef _TIME_H_INCLUDED_
#   include <time.h>
#   define _TIME_H_INCLUDED_
#  endif
# endif

# if defined(IRIS) && !defined(IRIX5)
   /* no socket.h on 4.0.5h ?!?!? */
# else
#  ifdef WIN32

#   undef INT
#   undef UINT
#   undef Array
#   undef Number
#   undef Method
#   undef Point
#   undef Rectangle
#   undef Block
#   undef String
#   undef Message
#   undef Object
#   undef Context
#   undef Time
#   undef Date
#   undef Set
#   undef Signal
#   undef Delay
#   undef NameSpace
#   undef Process
#   undef Processor

#   if !defined(__BORLANDC__)
#    ifndef MAXFILELEN
#     define MAXFILELEN 256
#    endif
#   endif

#  ifdef __BORLANDC__
#   define NO_GDI
#   include <windows.h>
#   include <WINSOCK.H>
#  else
#   define _WIN32_DCOM
#   define NO_GDI
#   include <windows.h>
//#   include <WINSOCK2.H>
#   include <WINSOCK.H>
#  endif

#   ifdef __DEF_Array
#    define Array __DEF_Array
#   endif
#   ifdef __DEF_Number
#    define Number __DEF_Number
#   endif
#   ifdef __DEF_Method
#    define Method __DEF_Method
#   endif
#   ifdef __DEF_Point
#    define Point __DEF_Point
#   endif
#   ifdef __DEF_Block
#    define Block __DEF_Block
#   endif
#   ifdef __DEF_String
#    define String __DEF_String
#   endif
#   ifdef __DEF_Message
#    define Message __DEF_Message
#   endif
#   ifdef __DEF_Object
#    define Object __DEF_Object
#   endif
#   ifdef __DEF_Context
#    define Context __DEF_Context
#   endif
#   ifdef __DEF_Date
#    define Date __DEF_Date
#   endif
#   ifdef __DEF_Time
#    define Time __DEF_Time
#   endif
#   ifdef __DEF_Set
#    define Set __DEF_Set
#   endif
#   ifdef __DEF_Signal
#    define Signal __DEF_Signal
#   endif
#   ifdef __DEF_Delay
#    define Delay __DEF_Delay
#   endif
#   ifdef __DEF_NameSpace
#    define NameSpace __DEF_NameSpace
#   endif
#   ifdef __DEF_Process
#    define Process __DEF_Process
#   endif
#   ifdef __DEF_Processor
#    define Processor __DEF_Processor
#   endif

#   define INT int
#   define UINT unsigned int

#  else /* not WIN32 */
#   include <sys/socket.h>
#  endif
# endif

# ifdef NEXT3
#  include <netinet/in_systm.h>
# endif

# ifdef WANT__AF_UNIX
/* no socket.h on IRIS 4.0.5h ?!?!? */
#  ifndef AF_UNIX
#   define AF_UNIX 1
#  endif
# endif
# ifdef WANT__AF_INET
#  ifndef AF_INET
#   define AF_INET 2
#  endif
# endif

# ifndef SOCK_STREAM
#  define SOCK_STREAM 1
# endif
# ifndef SOCK_DGRAM
#  define SOCK_DGRAM  2
# endif
# ifndef SOCK_RAW
#  define SOCK_RAW    3
# endif

# ifndef WANT__AF_UNIX
#  undef AF_UNIX
# endif

# ifndef WANT__AF_INET
#  undef AF_INET
# endif

# ifndef WANT__AF_INET6
#  undef AF_INET6
# endif

# ifndef WANT__AF_DECnet
#  undef AF_DECnet
# endif

# ifndef WANT__AF_APPLETALK
#  undef AF_APPLETALK
# endif

# ifndef WANT__AF_X25     /* X.25 */
#  undef AF_X25
# endif

# ifndef WANT__AF_NS      /* Xerox XNS */
#  undef AF_NS
# endif

# ifndef WANT__AF_SNA     /* IBM SNA */
#  undef AF_SNA
# endif

# ifndef WANT__AF_RAW     /* RAW packets */
#  undef AF_RAW
# endif

# ifndef WANT__AF_ISO     /* ? */
#  undef AF_ISO
# endif

# ifndef WANT__AF_NETBIOS /* NETBIOS */
#  undef AF_NETBIOS
# endif

# ifndef WANT__AF_CCITT /* ? */
#  undef AF_CCITT
# endif

# ifndef WANT__AF_IPX /* Novell IPX */
#  undef AF_IPX
# endif

# ifndef WANT__AF_AX25 /* Amateur Radio AX.25 */
#  undef AF_AX25
# endif

# ifndef WANT__AF_NETROM /* Amateur Radio NET/ROM */
#  undef AF_NETROM
# endif

# ifndef WANT__AF_BRIDGE /* multiprotocol bridge */
#  undef AF_BRIDGE
# endif

# ifndef WANT__AF_BSC /* BISYNC 2780/3780 */
#  undef AF_BSC
# endif

# ifndef WANT__AF_ROSE /* Amateur Radio X.25 PLP */
#  undef AF_ROSE
# endif

# ifndef WANT__AF_ATM /* ATM Services */
#  undef AF_ATM
# endif

# ifndef WANT__AF_ATMPVC /* ATM Services */
#  undef AF_ATMPVC
# endif

# ifndef WANT__AF_ATMSVC /* ATM Services */
#  undef AF_ATMSVC
# endif

# ifndef WANT__AF_BAN /* BAN / VINES IP Services */
#  undef AF_BAN
# endif

# ifndef WANT__AF_VOICEVIEW /* VoiceView Services W95 only */
#  undef AF_VOICEVIEW
# endif

# ifndef WANT__AF_IRDA /* infrared */
#  undef AF_IRDA
# endif

# ifndef WANT__AF_NETBEUI
#  undef AF_NETBEUI
# endif

# ifndef WANT__AF_NETLINK
#  undef AF_NETLINK
# endif

# ifndef WANT__AF_PACKET
#  undef AF_PACKET
# endif

# ifndef WANT__AF_ASH
#  undef AF_ASH
# endif

# ifndef WANT__AF_ECONET
#  undef AF_ECONET
# endif

# ifndef WANT__AF_IMPLINK
#  undef AF_IMPLINK
# endif

# ifndef WANT__AF_CHAOS
#  undef AF_CHAOS
# endif

# ifndef WANT__AF_DLI
#  undef AF_DLI
# endif

# ifndef WANT__AF_LAT
#  undef AF_LAT
# endif

# ifndef WANT__AF_HYLINK
#  undef AF_HYLINK
# endif

# ifndef WANT__AF_FIREFOX
#  undef AF_FIREFOX
# endif

# ifndef WANT__AF_CLUSTER
#  undef AF_CLUSTER
# endif

# ifndef WANT__AF_12844
#  undef AF_12844
# endif

# ifndef WANT__AF_NETDES
#  undef AF_NETDES
# endif

/*
 * include what is needed
 */
# ifdef AF_UNIX
#  ifdef UNIX_LIKE
#   include <sys/un.h>
#  endif
# endif

# ifdef AF_INET
#  ifdef UNIX_LIKE
#   include <netinet/in.h>
#  endif
# endif

# ifdef AF_INET6
#  if defined(LINUX)
#   include <netinet/in.h>
#  else
#   ifdef UNIX_LIKE
#    include <netinet/in6.h>
#   endif
#  endif
# endif

# ifdef AF_APPLETALK
#  ifdef LINUX
#   include <asm/types.h>
#   include <linux/atalk.h>
#  else
#   ifdef UNIX_LIKE
#    include <netinet/atalk.h>
#   endif
#  endif
# endif

# ifdef AF_DECNET
#  ifdef solaris2_0
#   include <X11/dni8.h>
#  endif
# endif

# ifdef AF_X25
#  ifdef LINUX
#   include <linux/x25.h>
#  endif
# endif

# ifdef AF_AX25
#  ifdef LINUX
#   include <linux/ax25.h>
#  endif
# endif

# ifdef AF_IPX
#  ifdef LINUX
#   include <linux/ipx.h>
#  else
#   ifdef WIN32
#    include <wsipx.h>
#   endif
#  endif
# endif

# ifdef AF_NETBIOS
#  ifdef WIN32
#   include <wsnetbs.h>
#  endif
# endif

# ifdef AF_ATM
#  ifdef WIN32
#   include <ws2atm.h>
#  endif
# endif

# if defined(AF_ATMPVC) || defined(AF_ATMSVC)
#  ifdef LINUX
#   include <linux/atm.h>
#  endif
# endif

# ifdef AF_BAN
#  ifdef WIN32
#   include <wsvns.h>
#  endif
# endif

# ifdef AF_VOICEVIEW
#  ifdef WIN32
#   include <wsvv.h>
#  endif
# endif

# ifdef AF_IRDA
#  ifdef LINUX
#   include <linux/irda.h>
#  endif
# endif

/*
 * see what is leftOver
 */
union sockaddr_u {
# ifdef AF_UNIX
	struct sockaddr_un un;
# endif
# ifdef AF_INET
	struct sockaddr_in in;
# endif
# ifdef AF_INET6
	struct sockaddr_in6 in6;
# endif
# ifdef AF_APPLETALK
	struct sockaddr_at at;
# endif
# ifdef AF_DECNET
	struct sockaddr_dn dn;
# endif
# ifdef AF_X25
	struct sockaddr_x25 x25;
# endif
# ifdef AF_AX25
	struct sockaddr_ax25 ax25;
# endif
# ifdef AF_IPX
	struct sockaddr_ipx ipx;
# endif
# ifdef AF_NETBIOS
	struct sockaddr_nb nb;
# endif
# ifdef AF_ATM
	struct sockaddr_atm atm;
# endif
# ifdef AF_BAN
	struct sockaddr_vns vns;
# endif
# ifdef AF_VOICEVIEW
	struct sockaddr_vv vv;
# endif
# ifdef AF_IRDA
	struct sockaddr_irda irda;
# endif

# ifdef AF_NETBEUI
	add definition here
# endif
# ifdef AF_NETLINK
	add definition here
# endif
# ifdef AF_PACKET
	add definition here
# endif
# ifdef AF_ASH
	add definition here
# endif
# ifdef AF_ECONET
	add definition here
# endif
# ifdef AF_IMPLINK
	add definition here
# endif
# ifdef AF_CHAOS
	add definition here
# endif
# ifdef AF_DLI
	add definition here
# endif
# ifdef AF_LAT
	add definition here
# endif
# ifdef AF_HYLINK
	add definition here
# endif
# ifdef AF_FIREFOX
	add definition here
# endif
# ifdef AF_CLUSTER
	add definition here
# endif
# ifdef AF_12844
	add definition here
# endif
# ifdef AF_NETDES
	add definition here
# endif
};

# ifdef LINUX
#  ifdef KLUDGE_FOR_GCC_WITHOUT_OPTIMIZER
/*
 * fstat is only defined as inline function in sys/stat.h - however,
 * inlined functions are not inlined with -g option in effect;
 * ought to use #define instead of inline functions there.
 */
#   define fstat(__fd__,__statbuf__) __fxstat(_STAT_VER,__fd__,__statbuf__)
#   define stat(__path__,__statbuf__) __xstat(_STAT_VER,__path__,__statbuf__)
#   define lstat(__path__,__statbuf__) __lxstat(_STAT_VER,__path__,__statbuf__)
#  endif
# endif /* LINUX */

# ifdef DO_WRAP_CALLS

#  define STX_C_CALL0(__nm__, __f__)                                                                    __STX_C_CALL0(__nm__,(void*)__f__)
#  define STX_C_CALL1(__nm__, __f__, __a1__)                                                            __STX_C_CALL1(__nm__,(void*)__f__, (void*)(__a1__))
#  define STX_C_CALL2(__nm__, __f__, __a1__, __a2__)                                                    __STX_C_CALL2(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__))
#  define STX_C_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                            __STX_C_CALL3(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__))
#  define STX_C_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                                    __STX_C_CALL4(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a3__))
#  define STX_C_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                            __STX_C_CALL5(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__))
#  define STX_C_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)                    __STX_C_CALL6(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__))
#  define STX_C_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)            __STX_C_CALL7(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__), (void*)(__a7__))
#  define STX_C_CALL8(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__,__a8__)            __STX_C_CALL8(__nm__,__f__, (__a1__), (__a2__),(__a3__),(__a4__),(__a5__),(__a6__),(__a7__),(__a8__))
#  define STX_C_CALL9(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__,__a8__,__a9__)            __STX_C_CALL9(__nm__,__f__, (__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__),(__a8__),(__a9__))
#  define STX_C_CALL10(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__,__a8__,__a9__,__a10__)            __STX_C_CALL10(__nm__,__f__, (__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__),(__a8__),(__a9__),(__a10__))
#  define STX_C_CALL11(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__,__a8__,__a9__,__a10__,__a11__)            __STX_C_CALL11(__nm__,__f__, (__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__),(__a8__),(__a9__),(__a10__),(__a11__))
#  define STX_C_CALL12(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__,__a8__,__a9__,__a10__,__a11__,__a12__)            __STX_C_CALL12(__nm__,__f__, (__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__),(__a8__),(__a9__),(__a10__,(__a11__),(__a12__)))
#  define STX_C_CALL13(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__,__a8__,__a9__,__a10__,__a11__,__a12__,__a13__)            __STX_C_CALL13(__nm__,__f__, (__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__),(__a8__),(__a9__),(__a10__),(__a11__),(__a12__),(__a13__))
#  define STX_C_CALL14(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__,__a8__,__a9__,__a10__,__a11__,__a12__,__a13__,__a14__)            __STX_C_CALL14(__nm__,__f__, (__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__),(__a8__),(__a9__),(__a10__),(__a11__),(__a12__),(__a13__),(__a14__))
#  define STX_C_CALL15(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__,__a8__,__a9__,__a10__,__a11__,__a12__,__a13__,__a14__,__a15__)            __STX_C_CALL15(__nm__,__f__, (__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__),(__a8__),(__a9__),(__a10__),(__a11__),(__a12__),(__a13__),(__a14__),(__a15__))

#  define STX_C_NOINT_CALL0(__nm__, __f__)                                                              __STX_C_NOINT_CALL0(__nm__,(void*)__f__)
#  define STX_C_NOINT_CALL1(__nm__, __f__, __a1__)                                                      __STX_C_NOINT_CALL1(__nm__,(void*)__f__, (void*)(__a1__))
#  define STX_C_NOINT_CALL2(__nm__, __f__, __a1__, __a2__)                                              __STX_C_NOINT_CALL2(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__))
#  define STX_C_NOINT_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                      __STX_C_NOINT_CALL3(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__))
#  define STX_C_NOINT_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                              __STX_C_NOINT_CALL4(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a3__))
#  define STX_C_NOINT_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                      __STX_C_NOINT_CALL5(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__))
#  define STX_C_NOINT_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)              __STX_C_NOINT_CALL6(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__))
#  define STX_C_NOINT_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)      __STX_C_NOINT_CALL7(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__), (void*)(__a7__))
#  define STX_C_NOINT_CALL8   __STX_C_NOINT_CALL8
#  define STX_C_NOINT_CALL9   __STX_C_NOINT_CALL9
#  define STX_C_NOINT_CALL10  __STX_C_NOINT_CALL10
#  define STX_C_NOINT_CALL11  __STX_C_NOINT_CALL11
#  define STX_C_NOINT_CALL12  __STX_C_NOINT_CALL12
#  define STX_C_NOINT_CALL13  __STX_C_NOINT_CALL13
#  define STX_C_NOINT_CALL14  __STX_C_NOINT_CALL14
#  define STX_C_NOINT_CALL15  __STX_C_NOINT_CALL15

#  define STX_API_CALL0(__nm__, __f__)                                                                  __STX_API_CALL0(__nm__,(void*)__f__)
#  define STX_API_CALL1(__nm__, __f__, __a1__)                                                          __STX_API_CALL1(__nm__,(void*)__f__, (void*)(__a1__))
#  define STX_API_CALL2(__nm__, __f__, __a1__, __a2__)                                                  __STX_API_CALL2(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__))
#  define STX_API_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                          __STX_API_CALL3(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__))
#  define STX_API_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                                  __STX_API_CALL4(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__))
#  define STX_API_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                          __STX_API_CALL5(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__))
#  define STX_API_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)                  __STX_API_CALL6(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__))
#  define STX_API_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)          __STX_API_CALL7(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__), (void*)(__a7__))
#  define STX_API_CALL8   __STX_API_CALL8
#  define STX_API_CALL9   __STX_API_CALL9
#  define STX_API_CALL10  __STX_API_CALL10
#  define STX_API_CALL11  __STX_API_CALL11
#  define STX_API_CALL12  __STX_API_CALL12
#  define STX_API_CALL13  __STX_API_CALL13
#  define STX_API_CALL14  __STX_API_CALL14
#  define STX_API_CALL15  __STX_API_CALL15

#  define STX_API_NOINT_CALL0(__nm__, __f__)                                                            __STX_API_NOINT_CALL0(__nm__,(void*)__f__)
#  define STX_API_NOINT_CALL1(__nm__, __f__, __a1__)                                                    __STX_API_NOINT_CALL1(__nm__,(void*)__f__, (void*)(__a1__))
#  define STX_API_NOINT_CALL2(__nm__, __f__, __a1__, __a2__)                                            __STX_API_NOINT_CALL2(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__))
#  define STX_API_NOINT_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                    __STX_API_NOINT_CALL3(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__))
#  define STX_API_NOINT_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                            __STX_API_NOINT_CALL4(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__))
#  define STX_API_NOINT_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                    __STX_API_NOINT_CALL5(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__))
#  define STX_API_NOINT_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)            __STX_API_NOINT_CALL6(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__))
#  define STX_API_NOINT_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)    __STX_API_NOINT_CALL7(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__), (void*)(__a7__))
#  define STX_API_NOINT_CALL8   __STX_API_NOINT_CALL8
#  define STX_API_NOINT_CALL9   __STX_API_NOINT_CALL9
#  define STX_API_NOINT_CALL10  __STX_API_NOINT_CALL10
#  define STX_API_NOINT_CALL11  __STX_API_NOINT_CALL11
#  define STX_API_NOINT_CALL12  __STX_API_NOINT_CALL12
#  define STX_API_NOINT_CALL13  __STX_API_NOINT_CALL13
#  define STX_API_NOINT_CALL14  __STX_API_NOINT_CALL14
#  define STX_API_NOINT_CALL15  __STX_API_NOINT_CALL15

#  define STX_WSA_CALL0(__nm__, __f__)                                                                  __STX_WSA_CALL0(__nm__,(void*)__f__)
#  define STX_WSA_CALL1(__nm__, __f__, __a1__)                                                          __STX_WSA_CALL1(__nm__,(void*)__f__, (void*)(__a1__))
#  define STX_WSA_CALL2(__nm__, __f__, __a1__, __a2__)                                                  __STX_WSA_CALL2(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__))
#  define STX_WSA_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                          __STX_WSA_CALL3(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__))
#  define STX_WSA_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                                  __STX_WSA_CALL4(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__))
#  define STX_WSA_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                          __STX_WSA_CALL5(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__))
#  define STX_WSA_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)                  __STX_WSA_CALL6(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__))
#  define STX_WSA_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)          __STX_WSA_CALL7(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__), (void*)(__a7__))

#  define STX_WSA_NOINT_CALL0(__nm__, __f__)                                                            __STX_WSA_NOINT_CALL0(__nm__,(void*)__f__)
#  define STX_WSA_NOINT_CALL1(__nm__, __f__, __a1__)                                                    __STX_WSA_NOINT_CALL1(__nm__,(void*)__f__, (void*)(__a1__))
#  define STX_WSA_NOINT_CALL2(__nm__, __f__, __a1__, __a2__)                                            __STX_WSA_NOINT_CALL2(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__))
#  define STX_WSA_NOINT_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                    __STX_WSA_NOINT_CALL3(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__))
#  define STX_WSA_NOINT_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                            __STX_WSA_NOINT_CALL4(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__))
#  define STX_WSA_NOINT_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                    __STX_WSA_NOINT_CALL5(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__))
#  define STX_WSA_NOINT_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)            __STX_WSA_NOINT_CALL6(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__))
#  define STX_WSA_NOINT_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)    __STX_WSA_NOINT_CALL7(__nm__,(void*)__f__, (void*)(__a1__), (void*)(__a2__), (void*)(__a3__), (void*)(__a4__), (void*)(__a5__), (void*)(__a6__), (void*)(__a7__))

# else /* no DO_WRAP_CALLS */

#  define STX_C_CALL0(__nm__, __f__)                                                                    __f__()
#  define STX_C_CALL1(__nm__, __f__, __a1__)                                                            __f__((__a1__))
#  define STX_C_CALL2(__nm__, __f__, __a1__, __a2__)                                                    __f__((__a1__), (__a2__))
#  define STX_C_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                            __f__((__a1__), (__a2__), (__a3__))
#  define STX_C_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                                    __f__((__a1__), (__a2__), (__a3__), (__a4__))
#  define STX_C_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                            __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__))
#  define STX_C_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)                    __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__))
#  define STX_C_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)            __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__))
#  define STX_C_CALL8   __STX_C_CALL8
#  define STX_C_CALL9   __STX_C_CALL9
#  define STX_C_CALL10  __STX_C_CALL10
#  define STX_C_CALL11  __STX_C_CALL11
#  define STX_C_CALL12  __STX_C_CALL12
#  define STX_C_CALL13  __STX_C_CALL13
#  define STX_C_CALL14  __STX_C_CALL14
#  define STX_C_CALL15  __STX_C_CALL15

#  define STX_C_NOINT_CALL0(__nm__, __f__)                                                              __f__()
#  define STX_C_NOINT_CALL1(__nm__, __f__, __a1__)                                                      __f__((__a1__))
#  define STX_C_NOINT_CALL2(__nm__, __f__, __a1__, __a2__)                                              __f__((__a1__), (__a2__))
#  define STX_C_NOINT_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                      __f__((__a1__), (__a2__), (__a3__))
#  define STX_C_NOINT_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                              __f__((__a1__), (__a2__), (__a3__), (__a4__))
#  define STX_C_NOINT_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                      __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__))
#  define STX_C_NOINT_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)              __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__))
#  define STX_C_NOINT_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)      __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__))
#  define STX_C_NOINT_CALL8   __STX_C_NOINT_CALL8
#  define STX_C_NOINT_CALL9   __STX_C_NOINT_CALL9
#  define STX_C_NOINT_CALL10  __STX_C_NOINT_CALL10
#  define STX_C_NOINT_CALL11  __STX_C_NOINT_CALL11
#  define STX_C_NOINT_CALL12  __STX_C_NOINT_CALL12
#  define STX_C_NOINT_CALL13  __STX_C_NOINT_CALL13
#  define STX_C_NOINT_CALL14  __STX_C_NOINT_CALL14
#  define STX_C_NOINT_CALL15  __STX_C_NOINT_CALL15

#  define STX_API_CALL0(__nm__, __f__)                                                                  __f__((__a1__))
#  define STX_API_CALL1(__nm__, __f__, __a1__)                                                          __f__((__a1__))
#  define STX_API_CALL2(__nm__, __f__, __a1__, __a2__)                                                  __f__((__a1__), (__a2__))
#  define STX_API_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                          __f__((__a1__), (__a2__), (__a3__))
#  define STX_API_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                                  __f__((__a1__), (__a2__), (__a3__), (__a4__))
#  define STX_API_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                          __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__))
#  define STX_API_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)                  __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__))
#  define STX_API_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)          __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__))
#  define STX_API_CALL8   __STX_API_CALL8
#  define STX_API_CALL9   __STX_API_CALL9
#  define STX_API_CALL10  __STX_API_CALL10
#  define STX_API_CALL11  __STX_API_CALL11
#  define STX_API_CALL12  __STX_API_CALL12
#  define STX_API_CALL13  __STX_API_CALL13
#  define STX_API_CALL14  __STX_API_CALL14
#  define STX_API_CALL15  __STX_API_CALL15

#  define STX_API_NOINT_CALL0(__nm__, __f__)                                                            __f__((__a1__))
#  define STX_API_NOINT_CALL1(__nm__, __f__, __a1__)                                                    __f__((__a1__))
#  define STX_API_NOINT_CALL2(__nm__, __f__, __a1__, __a2__)                                            __f__((__a1__), (__a2__))
#  define STX_API_NOINT_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                    __f__((__a1__), (__a2__), (__a3__))
#  define STX_API_NOINT_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                            __f__((__a1__), (__a2__), (__a3__), (__a4__))
#  define STX_API_NOINT_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                    __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__))
#  define STX_API_NOINT_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)            __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__))
#  define STX_API_NOINT_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)    __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__))
#  define STX_API_NOINT_CALL8   __STX_API_NOINT_CALL8
#  define STX_API_NOINT_CALL9   __STX_API_NOINT_CALL9
#  define STX_API_NOINT_CALL10  __STX_API_NOINT_CALL10
#  define STX_API_NOINT_CALL11  __STX_API_NOINT_CALL11
#  define STX_API_NOINT_CALL12  __STX_API_NOINT_CALL12
#  define STX_API_NOINT_CALL13  __STX_API_NOINT_CALL13
#  define STX_API_NOINT_CALL14  __STX_API_NOINT_CALL14
#  define STX_API_NOINT_CALL15  __STX_API_NOINT_CALL15

#  define STX_WSA_CALL0(__nm__, __f__)                                                                  __f__((__a1__))
#  define STX_WSA_CALL1(__nm__, __f__, __a1__)                                                          __f__((__a1__))
#  define STX_WSA_CALL2(__nm__, __f__, __a1__, __a2__)                                                  __f__((__a1__), (__a2__))
#  define STX_WSA_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                          __f__((__a1__), (__a2__), (__a3__))
#  define STX_WSA_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                                  __f__((__a1__), (__a2__), (__a3__), (__a4__))
#  define STX_WSA_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                          __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__))
#  define STX_WSA_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)                  __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__))
#  define STX_WSA_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)          __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__))

#  define STX_WSA_NOINT_CALL0(__nm__, __f__)                                                            __f__((__a1__))
#  define STX_WSA_NOINT_CALL1(__nm__, __f__, __a1__)                                                    __f__((__a1__))
#  define STX_WSA_NOINT_CALL2(__nm__, __f__, __a1__, __a2__)                                            __f__((__a1__), (__a2__))
#  define STX_WSA_NOINT_CALL3(__nm__, __f__, __a1__, __a2__, __a3__)                                    __f__((__a1__), (__a2__), (__a3__))
#  define STX_WSA_NOINT_CALL4(__nm__, __f__, __a1__, __a2__, __a3__, __a4__)                            __f__((__a1__), (__a2__), (__a3__), (__a4__))
#  define STX_WSA_NOINT_CALL5(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__)                    __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__))
#  define STX_WSA_NOINT_CALL6(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__)            __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__))
#  define STX_WSA_NOINT_CALL7(__nm__, __f__, __a1__, __a2__, __a3__, __a4__, __a5__, __a6__, __a7__)    __f__((__a1__), (__a2__), (__a3__), (__a4__), (__a5__), (__a6__), (__a7__))

# endif /* no DO_WRAP_CALLS */

/*
 * posix systems should define these ...
 * but on some (older) systems, they are not.
 */
# ifndef S_IXUSR
#  ifdef S_IEXEC
#   define S_IXUSR S_IEXEC
#   define S_IXGRP (S_IEXEC>>3)
#   define S_IXOTH (S_IEXEC>>6)
#  endif
# endif

# ifndef S_IXUSR
#  define S_IXUSR 0100
#  define S_IXGRP 0010
#  define S_IXOTH 0001
# endif

# ifndef S_IRUSR
#  define S_IRUSR 0400
#  define S_IRGRP 0040
#  define S_IROTH 0004
# endif

# ifndef S_IWUSR
#  define S_IWUSR 0200
#  define S_IWGRP 0020
#  define S_IWOTH 0002
# endif

# ifndef MAXPATHLEN
#  ifdef WIN32
#   define xxxMAXPATHLEN MAXPATH
#   define MAXPATHLEN 1024
#  endif
# endif

#endif /* __STX_OSDEFS_H */
