"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libboss' }"

LibraryDefinition subclass:#stx_libboss
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libboss class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Build-Information for creation of the st/x standard library: stx_libboss.
    This library contains binary object storage reader and writers.
"
!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/libboss/stx_libboss.st,v 1.40 2012/07/18 17:12:50 cg Exp $'
! !

!stx_libboss class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:libbasic'    "Set - superclass of BinaryOutputManager::ObjectDictionary "
    )
! !

!stx_libboss class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIBBOSS_BASE
LIB_BASE=$(LIBBOSS_BASE)
'
!

stcOptimizationOptions
    ^ '+optinline'

    "Created: / 23-08-2006 / 11:27:43 / cg"
! !

!stx_libboss class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        BinaryIOManager
        BinaryInputManager
        BinaryObjectStorage
        BinaryOutputManager
        ObsoleteObject
        #'stx_libboss'
    )
!

extensionMethodNames
    ^ #(
        Float storeBinaryDefinitionOn:manager:
        Object storeBinaryOn:
        'String class' binaryDefinitionFrom:manager:
        Color storeBinaryDefinitionBodyOn:manager:
        Object readBinaryContentsFrom:manager:
        Font readBinaryContentsFrom:manager:
        Class storeBinaryDefinitionOn:manager:
        Behavior storeBinaryDefinitionOn:manager:
        Image storeBinaryDefinitionOn:manager:
        Class addGlobalsForBinaryStorageTo:
        'MethodDictionary class' binaryFullDefinitionFrom:manager:
        'Float class' binaryDefinitionFrom:manager:
        Object hasSpecialBinaryRepresentation
        ExecutableFunction readBinaryContentsFrom:manager:
        Symbol storeBinaryDefinitionOn:manager:
        'ByteArray class' binaryDefinitionFrom:manager:
        Method readBinaryContentsFrom:manager:
        Class storeBinaryDefinitionOf:on:manager:
        False storeBinaryOn:manager:
        String storeBinaryDefinitionOn:manager:
        'Method class' binaryDefinitionFrom:manager:
        Image readBinaryContentsFrom:manager:
        Character hasSpecialBinaryRepresentation
        Behavior fromBinaryStoreBytes:
        UndefinedObject storeBinaryOn:manager:
        ByteArray storeBinaryDefinitionOn:manager:
        Behavior readBinaryFrom:
        Form readBinaryContentsFrom:manager:
        Object binaryStoreBytes
        MethodDictionary storeFullBinaryDefinitionOn:manager:
        'Smalltalk class' addGlobalsForBinaryStorageTo:
        Color readBinaryContentsFrom:manager:
        Object storeBinaryDefinitionBodyOn:manager:
        Boolean hasSpecialBinaryRepresentation
        Unicode16String storeBinaryElementsOn:
        Object storeBinaryDefinitionOn:manager:
        Object storeBinaryOn:manager:
        Character storeBinaryOn:manager:
        Behavior readBinaryFrom:onError:
        Method storeFullBinaryDefinitionOn:manager:
        True storeBinaryOn:manager:
        Set readBinaryContentsFrom:manager:
        Object representBinaryOn:
        'Smalltalk class' storeBinaryDefinitionOf:on:manager:
        Unicode32String storeBinaryElementsOn:
        Class binaryClassDefinitionFrom:manager:
        Block storeBinaryDefinitionOn:manager:
        'Method class' binaryFullDefinitionFrom:manager:
        Behavior binaryDefinitionFrom:manager:
        ByteArray storeBinaryElementsOn:
        Form storeBinaryDefinitionOn:manager:
        Method storeBinaryDefinitionOn:manager:
        'Symbol class' binaryDefinitionFrom:manager:
        Class storeBinaryClassOn:manager:
        DisplaySurface readBinaryContentsFrom:manager:
        Object readBinaryContentsFromData:manager:
        Character identityHashForBinaryStore
        SmallInteger identityHashForBinaryStore
        Symbol identityHashForBinaryStore
        UndefinedObject identityHashForBinaryStore
    )
! !

!stx_libboss class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Binary Object Storage'
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2012\nCopyright eXept Software AG 1998-2012'

    "Modified: / 18-07-2012 / 19:11:30 / cg"
! !

!stx_libboss class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libboss/stx_libboss.st,v 1.40 2012/07/18 17:12:50 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libboss/stx_libboss.st,v 1.40 2012/07/18 17:12:50 cg Exp $'
! !
