"{ Package: 'stx:libcompat' }"

"{ NameSpace: Dolphin }"

ClassCategoryReader subclass:#MethodCategoriesReader
	instanceVariableNames:'methodSelector'
	classVariableNames:''
	poolDictionaries:''
	category:'Compatibility-Dolphin'
!


!MethodCategoriesReader class methodsFor:'instance creation'!

class:aClass selector:aSelector
    "return a new MethodCategoriesReader to read categories for 
     aClasses method named aSelector"

    ^ self new class:aClass selector:aSelector
! !

!MethodCategoriesReader methodsFor:'fileIn'!

fileInFrom:aStream notifying:requestor passChunk:passChunk single:oneChunkOnly silent:beSilent
    "read method category-chunks from the input stream, aStream.
     Since ST/X only supports one category, only the first category is stored."

    |aString isFirst m|

    isFirst := true.
    [true] whileTrue:[
        aStream atEnd ifTrue:[^self].
        aString := aStream nextChunk.
        aStream skipSeparators.
        aString size == 0 ifTrue:[^self].

        isFirst ifTrue:[
            m := myClass compiledMethodAt:methodSelector.
            m isNil ifTrue:[
                Transcript showCR:'no method: ' , myClass name , '>>' , methodSelector.
            ] ifFalse:[
                m category:aString asSymbol.
            ].
            isFirst := false.
        ].
    ]
! !

!MethodCategoriesReader methodsFor:'private'!

class:aClass selector:aSymbol
    myClass := aClass.
    methodSelector := aSymbol.
! !

!MethodCategoriesReader class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libcompat/Dolphin_MethodCategoriesReader.st,v 1.4 2002/11/04 14:46:03 cg Exp $'
! !
