"{ Package: 'stx:libcompat' }"

"{ NameSpace: Dolphin }"

Object subclass:#SharedSet
	instanceVariableNames:'mutex set'
	classVariableNames:''
	poolDictionaries:''
	category:'Compatibility-Dolphin'
!


!SharedSet class methodsFor:'instance creation'!

new
    ^ self basicNew initialize
! !

!SharedSet methodsFor:'adding & removing'!

add:anObject
    |rslt|

    mutex critical:[
        rslt := set add:anObject
    ].
    ^ rslt.
!

remove:anObject
    |rslt|

    mutex critical:[
        rslt := set remove:anObject
    ].
    ^ rslt.
! !

!SharedSet methodsFor:'enumeration'!

do:aBlock
    |rslt|

    mutex critical:[
        rslt := set do:aBlock
    ].
    ^ rslt
! !

!SharedSet methodsFor:'queries'!

includes:anObject
    |rslt|

    mutex critical:[
        rslt := set includes:anObject
    ].
    ^ rslt.
!

size
    ^ set size.
! !

!SharedSet methodsFor:'setup'!

initialize
    mutex := Semaphore forMutualExclusion.
    set := Set new.
! !

!SharedSet class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libcompat/Dolphin_SharedSet.st,v 1.2 2009/10/04 16:23:23 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libcompat/Dolphin_SharedSet.st,v 1.2 2009/10/04 16:23:23 cg Exp $'
! !
