"{ Package: 'stx:libcompat' }"

Object subclass:#Utilities
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Compatibility-Squeak'
!


!Utilities class methodsFor:'misc'!

bringFlapsToFront

    self currentWorld bringFlapTabsToFront
!

currentWorld
   |topView|

   topView := WindowGroup activeGroup mainView.
   topView withAllSubViewsDo:[:v |
        v class == MorphWorldView ifTrue:[^ v model].
   ].
   ^ nil
!

informUser:someMessage during:aBlock
    |v result|

    [   |l|

        v := PopUpView onDevice:Screen current.
        v addSubView:(l := Label origin:(0.0@0.0) extent:(1.0@1.0) label:someMessage).
        v extent:l preferredExtent + 5.
        v showAt:Screen current center.
    ] fork.
    Processor yield.
    result := aBlock valueNowOrOnUnwindDo:[
        v hide.
        v destroy
    ].

    "
     Utilities informUser:'wait two seconds' during:[Delay waitForSeconds:2]
    "
!

keyLike: aString satisfying: aBlock
    "Return a key like aString that satisfies aBlock.  The block should provide a test for acceptability -- typically the test is about whether the key is already in use.  aBlock should return a boolean.  8/11/96 sw"

    | stemAndSuffix suffix stem newKey |

    (aBlock value: aString) ifTrue: [^ aString].
    stemAndSuffix := aString stemAndNumericSuffix.
    suffix := stemAndSuffix last + 1.
    stem := stemAndSuffix first.
    [aBlock value: (newKey := stem, suffix printString)]
            whileFalse:
                    [suffix := suffix + 1].
    ^ newKey


! !

!Utilities class methodsFor:'miscellaneous'!

getterSelectorFor: aName
	"Utilities getterSelectorFor: #elvis"
	^ ('get', (aName asString capitalized)) asSymbol
! !

!Utilities class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libcompat/Utilities.st,v 1.7 2011/09/29 11:19:56 cg Exp $'
!

version_SVN
    ^ 'Id: Utilities.st,v 1.6 2011/07/05 18:08:47 cg Exp '
! !
