"{ Package: 'stx:libcompat' }"

LibraryDefinition subclass:#stx_libcompat
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libcompat class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/libcompat/stx_libcompat.st,v 1.28 2012/07/18 17:12:52 cg Exp $'
! !

!stx_libcompat class methodsFor:'description'!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
	#'stx:libbasic'    "PeekableStream - superclass of DataStream "
	#'stx:libbasic2'    "Polygon - superclass of Polyline "
	#'stx:libbasic3'    "ChangeSet - referenced by MczInstaller>>useNewChangeSetDuring: "
	#'stx:libcomp'    "Parser - referenced by Application class>>initializeAfterLoad "
	#'stx:libtool'    "Tools::ClassCategoryList - referenced by SystemOrganization class>>addCategory: "
	#'stx:libview'    "Colormap - superclass of CoveragePalette "
	#'stx:libview2'    "ApplicationModel - superclass of Dolphin::Shell "
	#'stx:libwidg'    "Label - superclass of LabeledBooleanView "
	#'stx:libwidg2'    "Slider - superclass of FractionalWidgetView "
    )
! !

!stx_libcompat class methodsFor:'description - compilation'!

additionalDefinitions_nt_dot_mak
    ^ '
# see stdHeader_nt for LIBCOMPAT_BASE
LIB_BASE_LD_ARG=-b:$(LIBCOMPAT_BASE)
'
! !

!stx_libcompat class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
	"<className> or (<className> attributes...) in load order"
	ActionButton
	ActionButtonView
	ActionMenu
	Author
	BindingReference
	BorderDecorator
	CEnvironment
	CachedImage
	CharacterAttributes
	CharacterBlockScanner
	CodeController
	ColorPreferencesCollection
	ComposedText
	ComposedTextView
	CompositeView
	CompositionScanner
	CoveragePalette
	#'VAST::CwDataInterchangeConverter'
	#'VAST::CwGlobalMemoryTransferMechanism'
	#'VAST::CwMainWindow'
	#'VAST::CwPrimitive'
	#'VAST::CwTransferMechanism'
	#'VAST::CwWidget'
	DialogCompositeController
	DisplayScanner
	#'Dolphin::ClassCategoriesReader'
	(#'Dolphin::Dolphin__IXMLDOMDocument' autoload)
	(#'Dolphin::Dolphin__IXMLDOMNamedNodeMap' autoload)
	(#'Dolphin::Dolphin__SWEnvironment' autoload)
	#'Dolphin::Error'
	#'Dolphin::File'
	#'Dolphin::FileDialog'
	#'Dolphin::IXMLDOMDocument'
	#'Dolphin::IXMLDOMNamedNodeMap'
	#'Dolphin::ListPrompter'
	#'Dolphin::LookupTable'
	#'Dolphin::MessageBox'
	#'Dolphin::MethodCategoriesReader'
	#'Dolphin::Mutex'
	#'Dolphin::Notification'
	#'Dolphin::Prompter'
	#'Dolphin::SWEnvironment'
	#'Dolphin::SearchPolicy'
	#'Dolphin::SessionManager'
	#'Dolphin::SharedSet'
	#'Dolphin::Shell'
	DragDropManager
	DragDropManagerTracker
	ErrorDiffusion
	ExternalReadStream
	ExternalWriteStream
	FractionalWidgetView
	GapString
	IOAccessor
	ISO8859L1String
	InputState
	InstructionClient
	InstructionStream
	LabeledBooleanView
	ListItemWrapper
	#'VAST::LookupTable'
	MczInstaller
	MemoryPolicy
	MenuBuilder
	MockMedium
	MouseMenuController
	MultiSelectionSequenceView
	NameSpaceOrganizer
	NonInteractiveCompilerErrorHandler
	#'VAST::OSComposite'
	#'VAST::OSDialogBox'
	OpaqueImage
	OrderedDither
	PackageInfo
	ParagraphEditor
	PassivityWrapper
	Pixmap
	PluggableListView
	PluggableTextView
	Polyline
	Preferences
	RWBinaryOrTextStream
	RasterOp
	#'ReadMe::ST80_ReadMe'
	ScannerTable
	ScheduledControllers
	ScrollValueHolder
	ScrollWrapper
	SelectionInListController
	SelectionMenu
	SelectionTracker
	SourceCodeStream
	#'Squeak::ClassCommentReader'
	#'Squeak::TextAnchor'
	#'Squeak::TextColor'
	#'Squeak::TextEmphasis'
	#'Squeak::TextFontChange'
	#'Squeak::TextURL'
	StrikeFont
	StringCollationPolicy
	StringHolder
	SystemDictionary
	SystemOrganization
	SystemUtils
	SystemWindow
	TextAttributes
	TextController
	TextLines
	TextList
	TextStyle
	TriggerButtonController
	TwoByteSymbol
	UILookPolicy
	UISettings
	UnixProcess
	Utilities
	#'V::ApplicationCoordinator'
	#'V::Dynalink32'
	#'V::GDIDLL'
	#'V::GraphPane'
	#'V::OLEControlSitePane'
	#'V::OLEStructure'
	#'V::ViewManager'
	VW5PackageExporter
	WidgetWrapper
	Win32Shell
	#'stx_libcompat'
	DataStream
	#'Dolphin::FileOpenDialog'
	#'Dolphin::FileSaveDialog'
	#'Dolphin::PluggableLookupTable'
	LookPreferences
	MacLookPolicy
	#'VAST::SubApplication'
	#'VAST::Application'
	#'VAST::Kernel'
	Win3LookPolicy
	ReferenceStream
	CustomHelp
	ProvideAnswerNotification
	Alien
	#'Dolphin::SharedIdentitySet'
	#'Dolphin::DeafObject'
	#'Dolphin::SharedLookupTable'
	#'VAST::System'
    )

    "Modified: / 18-10-2011 / 20:47:47 / cg"
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Behavior kindOfSubclass
        Behavior setTraitComposition:
        CharacterArray unescapePercents
        CharacterArray unescapePercentsWithTextEncoding:
        Class objectForDataStream:
        Class storeDataOn:
        ClassBuilder name:inEnvironment:subclassOf:type:instanceVariableNames:classVariableNames:poolDictionaries:category:
        ClassDescription compile:classified:withStamp:
        ClassDescription compileSilently:classified:
        ClassOrganizer commentStamp
        Collection do:displayingProgress:
        Collection ifEmpty:
        FileDirectory fileNamesMatching:
        GenericException signal:
        Metaclass isTrait
        Method numTemps
        Method revisionInfo
        Method timeStamp
        Object assert:description:
        Object comeFullyUpOnReload:
        Object objectForDataStream:
        Object readDataFrom:size:
        Object storeDataOn:
        PositionableStream nextInt32
        PositionableStream nextInt32Put:
        PositionableStream nextLittleEndianNumber:
        PositionableStream nextLittleEndianNumber:put:
        PositionableStream nextString
        PositionableStream nextStringOld
        PositionableStream nextStringPut:
        PositionableStream nextWord
        PositionableStream nextWordPut:
        ReadStream next:into:startingAt:
        ReadStream nextInto:
        SequenceableCollection asTraitComposition
        ZipArchive contentsOf:
        'ChangeSet class' uniqueNameLike:
        'Smalltalk class' allTraits
        'Smalltalk class' globals
        'Smalltalk class' logChange:
        CharacterArray translated
        Class bindingOf:
        Collection flatCollectAsSet:
        Object caseError
        Object caseOf:
        Object caseOf:otherwise:
    )

    "Modified: / 19-10-2011 / 18:25:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libcompat class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X Compatibility'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2012\nCopyright eXept Software AG 1998-2012'

    "Modified: / 18-07-2012 / 19:11:39 / cg"
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_libcompat class methodsFor:'description - svn'!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"'exported'"$"
! !

!stx_libcompat class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libcompat/stx_libcompat.st,v 1.28 2012/07/18 17:12:52 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libcompat/stx_libcompat.st,v 1.28 2012/07/18 17:12:52 cg Exp $'
!

version_SVN
    ^ 'Id: stx_libcompat.st,v 1.13 2011/07/05 18:08:48 cg Exp '
! !
