"
 COPYRIGHT (c) 1996 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libhtml' }"

HTMLMarkup variableSubclass:#HTMLAnchor
	instanceVariableNames:'bounds anchorText color'
	classVariableNames:''
	poolDictionaries:''
	category:'System-Documentation'
!

!HTMLAnchor class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

!

documentation
"
    an anchor element.
    No new features added; however, provides convenient access for
    some heavily used values (attributes).

    [author:]
        Claus Gittinger

    [see also:]
        HTMLParser
        HTMLDocumentPainter
"

! !

!HTMLAnchor methodsFor:'accessing'!

anchorText
    ^ anchorText

    "Created: 20.5.1996 / 16:19:07 / cg"
!

anchorText:aString
    anchorText := aString

    "Created: 20.5.1996 / 16:19:16 / cg"
!

bounds
    ^ bounds

    "Created: 17.5.1996 / 17:42:09 / cg"
!

bounds:aRectangle
    bounds := aRectangle

    "Created: 17.5.1996 / 17:42:20 / cg"
!

color
    ^ color

    "Created: 21.5.1996 / 23:04:10 / cg"
!

color:something
    color := something.

    "Created: 21.5.1996 / 23:04:10 / cg"
!

hrefString
    ^ self parameterFor:#'HREF'

    "Created: 17.5.1996 / 18:29:50 / cg"
    "Modified: 18.6.1996 / 20:58:24 / cg"
!

hrefString:aString
    self parameterFor:#'HREF' put:aString
!

srcString
    ^ self parameterFor:#'SRC'

    "Created: 17.5.1996 / 16:52:08 / cg"
    "Modified: 18.6.1996 / 20:58:34 / cg"
!

srcString:aString
    self parameterFor:#'SRC' put:aString
! !

!HTMLAnchor methodsFor:'printing & storing'!

displayOn:aGCOrStream
    "put a printed representation of the receiver for displaying onto aGCOrStream"

    "/ what a kludge - Dolphin and Squeak mean: printOn: a stream;
    "/ ST/X (and some old ST80's) mean: draw-yourself on a GC.
    (aGCOrStream isStream or:[aGCOrStream == Transcript]) ifTrue:[
        aGCOrStream 
            nextPutAll:self classNameWithArticle;
            nextPutAll:'(<'.
        type printOn:aGCOrStream.
        aGCOrStream space.
        self hrefString printOn:aGCOrStream.
        aGCOrStream nextPutAll:'>)'.
        ^ self.
    ].

    ^ super displayOn:aGCOrStream


    "Created: / 17.5.1996 / 14:20:51 / cg"
    "Modified: / 27.4.1998 / 20:25:43 / cg"
! !

!HTMLAnchor methodsFor:'queries'!

boundsTop
    bounds isNil ifTrue:[^ nil].
    bounds size == 0 ifTrue:[^ nil].
    ^ bounds first top

    "Modified: 21.5.1996 / 10:16:12 / cg"
    "Created: 21.5.1996 / 11:15:57 / cg"
!

isCopyableExample
    |t|

    t := self typeString.
    ^ t notNil and:[t asLowercase = 'copyexample']
!

isExample
    |t|

    t := self typeString.
    ^ t notNil and:[t asLowercase = 'example']

    "Modified: 17.5.1996 / 16:55:41 / cg"
    "Created: 17.5.1996 / 18:30:25 / cg"
! !

!HTMLAnchor methodsFor:'testing'!

isAnchor
    ^ true

    "Modified: 17.5.1996 / 16:55:41 / cg"
    "Created: 17.5.1996 / 18:30:25 / cg"
! !

!HTMLAnchor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libhtml/HTMLAnchor.st,v 1.15 2010/09/21 06:57:27 stefan Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libhtml/HTMLAnchor.st,v 1.15 2010/09/21 06:57:27 stefan Exp $'
! !
