"
 COPYRIGHT (c) 1997 by eXept Software AG 
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libhtml' }"

Object subclass:#URL
	instanceVariableNames:'method host path port anchor rest otherPart flag authority'
	classVariableNames:''
	poolDictionaries:''
	category:'Net-Communication-Support'
!

!URL class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by eXept Software AG 
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

!

documentation
"
    (for now) only a holder for the parse URL info.
    Will takeover more functionality in the near future.

    Late note: is going to be obsoleted by URI.

    [author:]
        Claus Gittinger
"
! !

!URL class methodsFor:'instance creation'!

classForScheme:  schemeString   
    |httpsClass|

    schemeString = 'https' ifTrue:[

        (httpsClass := Smalltalk at:#'SSL::HttpsUrl') notNil ifTrue:[
            ^ httpsClass 
       ].
    ].
    ^ self.
!

fromString: aString
    | otherPart otherPartKind index urlString url |

    otherPart := nil.
    otherPartKind := 0.
    "check fragment and search part"
    (index := aString indexOf: $#) ~= 0
            ifTrue: [otherPartKind := 1]
            ifFalse: [(index := aString indexOf: $?) ~= 0
                    ifTrue: [otherPartKind := 2]
                    ifFalse: [urlString := aString]].
    otherPartKind > 0
            ifTrue:
                    [urlString := aString copyFrom: 1 to: index - 1.
                    index < aString size
                            ifTrue: [otherPart := aString copyFrom: index + 1 to: aString size]].
    url := self fromURLString: urlString.
    otherPart notNil
            ifTrue:
                    [otherPartKind = 1
                            ifTrue: [url fragmentPart: otherPart]
                            ifFalse:[url searchPart: otherPart]].
    ^url

    "
     URL fromString: 'http://www'.
     URL fromString: 'http://www/dir/file.html'.
     URL fromString: 'http://www:10080/dir/file.html'.
     URL fromString: 'http://www:10080/dir/file.html?x=100'.
     URL fromString: 'http://www:10080/dir/file.html#section'.
     URL fromString: 'ftp://ftp/pub/smalltalk'.
     URL fromString: 'ftp://ftp:21/pub/smalltalk'.
     URL fromString: 'ftp://user@ftp:21/pub/smalltalk'.
     URL fromString: 'ftp://user@ftp/pub/smalltalk'.
     URL fromString: 'ftp://user:passwd@ftp:21/pub/smalltalk'.
     URL fromString: 'news:fj.lang.smalltalk'.
     URL fromString: '/dir/file.html'.
     URL fromString: 'file.html'.
    "
!

fromURLString:aStringIn
"
self oldFromURLString:'checkout.stt'.   
self fromURLString:'checkout.stt'.      

"
    |aString defPath read write ch scheme host port path pos try|

    aString := aStringIn.

    "/ hack for MSDOS-type files, with a volume
    OperatingSystem isMSDOSlike ifTrue:[
        aString size > 1 ifTrue:[
            ((aString at:2) = $:) ifTrue:[
                ^ self scheme:nil host:nil port:nil path:aString
            ]
        ]
    ].


    defPath := nil.
    read := aString readStream.
    write := WriteStream on: (String new: aString size).

    "parse scheme"
    [read atEnd or:
    [(ch := read next) isLetterOrDigit not]]
            whileFalse: [write nextPut: ch].


    (write isEmpty or: [ch ~= $:])
            ifTrue: "no scheme"
                    [read reset.
                    scheme := nil.

                    "aString isEmpty
                            ifTrue: [path := defPath]
                            ifFalse:        [path := aString]."
                    "It's may be a file name."
                    "^self scheme: nil path: path"]
            ifFalse:
                    [scheme := write contents].

    write reset.
    pos := read position.
    (read nextAvailable: 2) = '//'
            ifFalse:[ "no host and port"
                ch ~= $: ifTrue:[
                    read position: pos.
                    path := read upToEnd.
                    path isEmpty ifTrue: [path := defPath].
                    ^ self scheme: scheme path: path
                ].
                read position: pos-1.
                host := scheme.
                scheme := nil.
            ].

    "parse host and port (and user and password)."

    try := true.
    [try] whileTrue:
            [[read atEnd or:
            [(ch := read next) = $/ or: [ch = $: or: [ch = $@]]]]
                    whileFalse:
                            [write nextPut: ch].
            write notEmpty
                    ifTrue: [host := write contents].
            write reset.
            ch = $:
                    ifTrue: "parse port or passwd"
                            [[read atEnd or:
                            [(ch := read next) = $/ or: [ch = $@]]]
                                    whileFalse:
                                            [write nextPut: ch].
                            write notEmpty
                                    ifTrue: [port := write contents].
                            write reset].

            ch = $@
                    ifFalse: [try := false]
                    ifTrue: "re-parse host"
                            [host notNil
                                    ifTrue: [write nextPutAll: host. host := nil].
                            port notNil
                                    ifTrue: [write nextPut: $:; nextPutAll: port. port := nil].
                            write nextPut: $@]].

    port notNil
            ifTrue: [port := Number readFrom: port readStream].

    read atEnd
            ifTrue: [path := defPath]
            ifFalse:
                    [write nextPut: ch; nextPutAll: (read upToEnd).
                    path := write contents].

    ^ self scheme: scheme host: host port: port path: path

    "URL fromString: 'http://www/dir/file.html'."
    "URL fromString: 'http://www:10080/dir/file.html'."
    "URL fromString: 'ftp://ftp/pub/smalltalk'."
    "URL fromString: 'ftp://ftp:21/pub/smalltalk'."
    "URL fromString: 'ftp://user@ftp:21/pub/smalltalk'."
    "URL fromString: 'ftp://user@ftp/pub/smalltalk'."
    "URL fromString: 'ftp://user:passwd@ftp:21/pub/smalltalk'."
    "URL fromString: 'news:fj.lang.smalltalk'."
    "URL fromString: '/dir/file.html'."
    "URL fromString: '//host/dir/file.html'."
    "URL fromString: 'file.html'."

    "Modified: / 25.9.1999 / 22:00:43 / cg"
!

method: methodString host: hostString port: portNumber path: pathString
    ^ self new
            method: methodString;
            host: hostString;
            port: portNumber;
            path: pathString

!

method: methodString path: pathString
        ^self
                method: methodString
                host: nil
                port: nil
                path: pathString

!

new
    ^ self basicNew initialize
!

scheme: schemeString host: hostString port: portNumber path: pathString
    ^ (self classForScheme: schemeString) new
            scheme: schemeString;
            host: hostString;
            port: portNumber;
            path: pathString
!

scheme: schemeString path: pathString
        ^self
                scheme: schemeString
                host: nil
                port: nil
                path: pathString

    "
     self scheme:'http' path:'foo/bar/baz'   
     self scheme:'http' host:'www.exept.de' port:80 path:'foo/bar/baz' 
     self fromString:'http://www.exept.de/foo/bar/baz&foo=1&bar=2' 
    "

    "Modified (comment): / 05-10-2011 / 18:07:41 / cg"
! !

!URL class methodsFor:'Compatibility-Squeak'!

schemeNameForString:urlString
    |idx|

    idx := urlString indexOf:$:.
    (idx ~~ 0) ifTrue:[
        ^ (urlString copyTo:(idx - 1)) asLowercase.
    ].
    ^ nil

    "
     self schemeNameForString:'https://www.cacert.org'
    "

    "Modified (comment): / 05-10-2011 / 18:05:42 / cg"
! !

!URL class methodsFor:'utilities'!

constructPath:path1 with:path2 
    |sep dirStack read p write|

    sep := $/.
    dirStack := OrderedCollection new.
    (path2 notEmpty and:[ path2 first = sep ]) ifFalse:[
        read := path1 readStream.
        [ read atEnd ] whileFalse:[
            p := read upTo:sep.
            (p isEmpty or:[ p = '.' ]) ifFalse:[
                p = '..' ifTrue:[
                    dirStack notEmpty ifTrue:[
                        dirStack removeLast
                    ]
                ] ifFalse:[
                    dirStack addLast:p
                ]
            ]
        ].
        (path1 notEmpty and:[ path1 last = sep ]) ifFalse:[
            "trim path tail (file name)."
            dirStack notEmpty ifTrue:[
                dirStack removeLast
            ]
        ]
    ].
    read := path2 readStream.
    [ read atEnd ] whileFalse:[
        p := read upTo:sep.
        (p isEmpty or:[ p = '.' ]) ifFalse:[
            p = '..' ifTrue:[
                dirStack notEmpty ifTrue:[
                    dirStack removeLast
                ]
            ] ifFalse:[
                dirStack addLast:p
            ]
        ]
    ].
    dirStack isEmpty ifTrue:[
        ^ String with:sep
    ].
    write := WriteStream on:(String new:path1 size + path2 size).
    [ dirStack isEmpty ] whileFalse:[
        write
            nextPut:sep;
            nextPutAll:dirStack removeFirst
    ].
    (path2 notEmpty and:[ path2 last = sep ]) ifTrue:[
        write nextPut:sep
    ].
    ^ write contents
! !

!URL methodsFor:'Compatibility-Squeak'!

authority
    ^ authority ? host ? ''.

    "Modified: / 21-09-2010 / 23:52:36 / cg"
!

fullPath
    ^ self path ? '/'
!

retrieveContents
    "squeak compatibility"

    ^ self retrieveContentsArgs: nil
!

retrieveContentsAccept: mimeType
    "squeak compatibility"

    ^ self retrieveContentsArgs: nil accept: mimeType
!

retrieveContentsArgs: args
    "squeak compatibility"

    ^self retrieveContentsArgs: args accept: '*/*; q=1'
!

retrieveContentsArgs: args accept: mimeType
    "squeak compatibility"

    self subclassResponsibility
!

withoutFragment
    "what does it do ?"

    ^ self
! !

!URL methodsFor:'accessing'!

anchor
    "return the value of the instance variable 'anchor' (automatically generated)"

    ^ self fragmentPart

    "Created: / 23.1.1998 / 12:09:03 / cg"
!

anchor:something
    "set the value of the instance variable 'anchor' (automatically generated)"

    self fragmentPart: something.

    "Created: / 23.1.1998 / 12:09:03 / cg"
!

file
    "return the value of the instance variable 'file' (automatically generated)"

    ^ path

    "Created: / 23.1.1998 / 12:05:59 / cg"
!

file:something
    "set the value of the instance variable 'file' (automatically generated)"

    path := something.

    "Created: / 23.1.1998 / 12:05:59 / cg"
!

fragmentPart
    self hasFragmentPart ifTrue: [^ otherPart].
    ^ nil


!

fragmentPart: aString
    otherPart := aString.
    flag := 0.
    self hasFragmentPart:true


!

host
    "return the value of the instance variable 'host' (automatically generated)"

    ^ host

    "Created: / 23.1.1998 / 12:05:58 / cg"
!

host:something
    "set the value of the instance variable 'host' (automatically generated)"

    host := something.

    "Created: / 23.1.1998 / 12:05:58 / cg"
!

method
    "return the value of the instance variable 'method' (automatically generated)"

    ^ method

    "Created: / 23.1.1998 / 12:05:58 / cg"
!

method:something
    "set the value of the instance variable 'method' (automatically generated)"

    method := something.

    "Created: / 23.1.1998 / 12:05:58 / cg"
!

otherPart
        ^otherPart


!

path
    "return the value of the instance variable 'path' (automatically generated)"

    ^ path

    "Created: / 23.1.1998 / 12:05:59 / cg"
!

path:something
    "set the value of the instance variable 'path' (automatically generated)"

    path := something.

    "Created: / 23.1.1998 / 12:05:59 / cg"
!

port
    "return the value of the instance variable 'port' (automatically generated)"

    ^ port

    "Created: / 23.1.1998 / 12:05:59 / cg"
!

port:something
    "set the value of the instance variable 'port' (automatically generated)"

    port := something.

    "Created: / 23.1.1998 / 12:05:59 / cg"
!

rest
    "return the value of the instance variable 'rest' (automatically generated)"

    ^ '' "/ self fragmentPart

    "Created: / 23.1.1998 / 12:09:03 / cg"
!

rest:something
    "set the value of the instance variable 'rest' (automatically generated)"

    self fragmentPart:something.

    "Created: / 23.1.1998 / 12:09:03 / cg"
!

scheme
    ^ method


!

scheme:aString
    method := aString


! !

!URL methodsFor:'comparing'!

= anURL
    ^ self species = anURL species and:
            [method = anURL method and:
            [host = anURL host and:
            [port = anURL port and:
            [path = anURL path and:
            [otherPart = anURL otherPart and:
            [flag = anURL flag]]]]]]
!

copyWithoutFragmentPart
    ^ self copy clearFragmentPart.

!

copyWithoutOtherPart
    ^ self copy clearOtherPart.

!

hash
    ^ ((((path hash bitShift: 2)
            bitXor: host hash) bitShift: 1)
            bitXor: method hash + port hash + otherPart hash + flag hash)

!

postCopy
    super postCopy.
    method := method copy.
    host := host copy.
    port := port copy. 
    path := path copy.
    otherPart := otherPart copy.
    flag := flag copy.

! !

!URL methodsFor:'conversion'!

asURL
    "return an URL-object from myself - thats me."

    ^ self

    "
     'http://www.exept.de:80/index.html' asURL host    
     'http://www.exept.de:80/index.html' asURL port    
     'http://www.exept.de:80/index.html' asURL method    
     'http://www.exept.de:80/index.html' asURL path    
    "
! !

!URL methodsFor:'parsing'!

parseFromString:urlString
    "parse URL contained in a string and set my inst vars"

    |i i2 idx found|

    method := 'file'.
    method := nil.

    rest := urlString.
    idx := urlString indexOf:$:.
    (idx ~~ 0) ifTrue:[
        i := urlString indexOf:$#.
        ((i == 0) or:[i > idx]) ifTrue:[
            method := (urlString copyTo:(idx - 1)) asLowercase.
            rest := urlString copyFrom:(idx + 1).

            "/ special for VMS & MSDOS
            OperatingSystem isUNIXlike ifFalse:[
                (self isValidMethod:method) ifFalse:[
                    method := 'file'.
                    method := nil.
                    rest := urlString copy.
                ]
            ].
        ] ifFalse:[
            idx := 0.
        ]
    ].

    "/
    "/ rest is everything after initial <method>:
    "/ search for #
    "/
    idx := rest indexOf:$# startingAt:idx + 1.
    found := false.
    [found or:[idx == 0]] whileFalse:[
        idx < (rest size) ifTrue:[
            (rest at:idx+1) ~~ $# ifTrue:[
                found := true.
            ] ifFalse:[
                idx := rest indexOf:$# startingAt:idx+2
            ]
        ] ifFalse:[
            idx := 0.
            (rest endsWith:$#) ifTrue:[
                rest := rest copyWithoutLast:1
            ]
        ]
    ].

    idx ~~ 0 ifTrue:[
        path := rest copyTo:(idx - 1).
        path isEmpty ifTrue:[
            path := nil
        ].

        anchor := rest copyFrom:(idx + 1).
        anchor isEmpty ifTrue:[
            anchor := nil
        ].
    ] ifFalse:[
        path := rest
    ].

    path notNil ifTrue:[
        "/ msdos support

        (path startsWith:'\\') ifTrue:[
            "/ network drive ...
            path asFilename exists ifTrue:[
                ^ self
            ]
        ].

        path := path copyReplaceAll:$\ with:$/.

        (path startsWith:'//') ifTrue:[
            idx := path indexOf:$/ startingAt:3.

            idx ~~ 0 ifTrue:[
                host := path copyFrom:3 to:idx-1.
                path := path copyFrom:idx
            ] ifFalse:[
                "/ hostname only
                host := path copyFrom:3.
                path := '/'
            ].

            idx := host indexOf:$:.
            (idx ~~ 0) ifTrue:[
                port := Number readFromString:(host copyFrom:idx+1) onError:nil.
                host := host copyTo:idx-1.
            ].
        ]
    ].

    "Created: / 23.1.1998 / 12:11:52 / cg"
    "Modified: / 9.9.1998 / 20:50:37 / cg"
! !

!URL methodsFor:'printing & storing'!

displayString
    ^ 'URL( method=' , method displayString
      , ' host=' , host displayString
      , ' port=' , port displayString
      , ' file=' , path displayString
      , ' otherPart=' , otherPart displayString
      , ')'

    "Created: / 23.1.1998 / 12:14:59 / cg"
!

printOn: aStream
    method notNil ifTrue: [
        aStream nextPutAll: method; nextPut: $:
    ].
    aStream nextPutAll: '//'.
    host notNil ifTrue: [
        aStream nextPutAll: host
    ].
    port notNil ifTrue: [
        aStream nextPut: $:; nextPutAll: port printString
    ].
    path notNil ifTrue: [
        aStream nextPutAll: path
    ].
    (otherPart notNil and: [self hasPostData not]) ifTrue:[
        self hasFragmentPart ifTrue: [
            aStream nextPut: $#
        ] ifFalse:[
            aStream nextPut: $?
        ].
        aStream nextPutAll: otherPart
    ].
!

urlPrintString
    "the printString of the full url (incl. method, host and port)"

    ^ self printString.

"/    |s|
"/
"/    s := (method ? 'file') , '://'  
"/      , (host ? OperatingSystem getHostName).
"/
"/    port notNil ifTrue:[
"/        s := s , ':' , port printString
"/    ].
"/    s := s , (path ? '/').
"/    ^ s.
! !

!URL methodsFor:'private'!

clearFragmentPart
        self hasFragmentPart ifFalse: [^self].
        self clearOtherPart.


!

clearOtherPart
        flag := 0.
        otherPart := nil.


!

flag
        ^flag


!

hasFragmentPartBitMask
        ^1


!

hasPostDataBitMask
        ^4


!

hasSearchPartBitMask
        ^2


!

initialize
        self clearOtherPart.


!

setOtherPart: aString flag: anInteger
        otherPart := aString.
        flag := anInteger.


! !

!URL methodsFor:'queries'!

canCache
    ^ self isFileScheme not and:[flag = 0 and: [otherPart isNil]]


!

fullRequestString
    | stream |

    stream := WriteStream on: (String new: 256).
    method notNil ifTrue: [
        stream nextPutAll: method; nextPut: $:
    ].
    host notNil ifTrue: [
        method notNil ifTrue: [stream nextPutAll: '//'].
        stream nextPutAll: host
    ].
    port notNil ifTrue: [
        stream nextPut: $:; nextPutAll: port printString
    ].
    path isNil ifTrue: [
        stream nextPut: $/
    ] ifFalse: [
        stream nextPutAll: path
    ].
    (otherPart notNil and: [self hasSearchPart]) ifTrue: [
        stream nextPut: $?; nextPutAll: otherPart
    ].
    ^ stream contents


!

hasFragmentPart
    ^ flag allMask: self hasFragmentPartBitMask


!

hasFragmentPart: aBoolean
    aBoolean
        ifTrue: [flag := flag maskSet: self hasFragmentPartBitMask]
        ifFalse: [flag := flag maskClear: self hasFragmentPartBitMask]


!

hasPostData
    ^ flag allMask: self hasPostDataBitMask


!

hasPostData: aBoolean
    aBoolean
        ifTrue: [flag := flag maskSet: self hasPostDataBitMask]
        ifFalse: [flag := flag maskClear: self hasPostDataBitMask]


!

hasSearchPart
    ^flag allMask: self hasSearchPartBitMask


!

hasSearchPart: aBoolean
    aBoolean
        ifTrue: [flag := flag maskSet: self hasSearchPartBitMask]
        ifFalse: [flag := flag maskClear: self hasSearchPartBitMask]


!

isFileScheme
    ^ method == nil or: [method = 'file']


!

isFragmentOnly
    ^ self fragmentPart ~~ nil and:
            [method == nil and:
            [host == nil and:
            [port == nil and:
            [path == nil]]]]


!

isHostRelativePath
    ^ self fragmentPart ~~ nil and:
            [method == nil and:
            [host == nil and:
            [port == nil]]]
!

isRelativePath
    ^ self fragmentPart ~~ nil and:
            [method == nil and:
            [host == nil and:
            [port == nil and:
            [((path ? '') startsWith:'/') not]]]]
!

isValidMethod:aMethod
    "mhmh - is this a good idea (isn't it the task of a url-user to decide, which
     methods it supports. The URL does not really know..."
    
    aMethod = 'http' ifTrue:[^ true].
    aMethod = 'file' ifTrue:[^ true].
    aMethod = 'ftp' ifTrue:[^ true].
    aMethod = 'gopher' ifTrue:[^ true].
    ^ false

    "Created: / 27.7.1998 / 19:40:14 / cg"
!

newsGroup
    "If the receiver is an nntp url, return the news group."

    ^ (method = 'nntp' and: [path notNil]) ifTrue:[
        path copyFrom:2 to:(path nextIndexOf:$/ from:2 to:path size) - 1]

!

postData
    self hasPostData ifTrue: [^ otherPart].
    ^ nil


!

postData: aString
    otherPart := aString.
    flag := 0.
    self hasPostData:true


!

requestString
    "everything but the host & scheme (i.e. path+options alone, as in an HTTP requests header line)"

    | stream |

    stream := WriteStream on: (String new: 128).
    path isNil ifTrue: [
        stream nextPut: $/
    ] ifFalse: [
        stream nextPutAll: path
    ].
    (otherPart notNil and: [self hasSearchPart]) ifTrue: [
        stream nextPut: $?; nextPutAll: otherPart
    ].
    ^ stream contents

    "Modified (comment): / 05-10-2011 / 17:43:07 / cg"
!

searchPart
    self hasSearchPart ifTrue: [^otherPart].
    ^nil


!

searchPart: aString
    otherPart := aString.
    flag := 0.
    self hasSearchPart: true


! !

!URL methodsFor:'utilities'!

/ aString
    "answer a new instance with aString concatenated to my path.
     We simply append aString to the end of the path.
     Look at construct for a more enhanced "

    |newPath|

    path isEmptyOrNil ifTrue:[
        newPath := '/', aString.
    ] ifFalse:[    
        path last = $/ ifTrue:[
            newPath := path , aString.
        ] ifFalse:[
            newPath := path , '/', aString.
        ].
    ].
        
    ^ self copy path:newPath.

    "
      'http://www.exept.de/start' asURL / 'bla'
      'http://www.exept.de/start/' asURL / 'bla'
      'http://www.exept.de' asURL / 'bla'
    "

    "Created: / 13-04-2008 / 21:29:15 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

construct:anUrlOrString 
    |newURL anURL|

    anUrlOrString isString ifTrue:[
        anURL := URL fromString:anUrlOrString.
    ] ifFalse:[
        anURL := anUrlOrString.
    ].

    anURL scheme notNil ifTrue:[
        method ~= anURL method ifTrue:[
            ^ anURL
        ].
        anURL host notNil ifTrue:[
            ^ anURL
        ].
         "(anURL host notNil and: [host ~= anURL host]) ifTrue: [^anURL].
         (anURL port notNil and: [port ~= anURL port]) ifTrue: [^anURL]"
    ].
    newURL := self copyWithoutOtherPart.
    anURL path notNil ifTrue:[
        self isFileScheme ifTrue:[
            (path isNil or:[ anURL path notEmpty and:[ anURL path first = $/ ] ]) ifTrue:[
                newURL path:anURL path
            ] ifFalse:[
                (path notEmpty and:[ path first = $/ ]) ifTrue:[
                    newURL path:(self class constructPath:path with:anURL path)
                ] ifFalse:[
                    newURL path:(path asFilename directory constructString:anURL path)
                ]
            ]
        ] ifFalse:[
            path isNil ifTrue:[
                newURL path:(self class constructPath:'/' with:anURL path)
            ] ifFalse:[
                newURL path:(self class constructPath:path with:anURL path)
            ]
        ]
    ].
    newURL setOtherPart:anURL otherPart flag:anURL flag.
    ^ newURL

    "
       (URL fromString: 'http://www/dir/file.html') construct: (URL fromString: 'subdir/image.gif').
       (URL fromString: 'http://www/dir1/file.html') construct: (URL fromString: '/dir2/image.gif').
       (URL fromString: 'http://www/dir1/file.html') construct: (URL fromString: '~kyasu/').
       (URL fromString: 'http://www/dir/file.html') construct: (URL fromString: '#introduction').
       (URL fromString: 'http://www/dir/file.html') construct: (URL fromString: '/cgi-bin/perl.pl&dest=/other').
       (URL fromString: 'http://www/dir/file.html') construct: (URL fromString: 'http:/cgi-bin/perl.pl&dest=/other').
       (URL fromString: 'http://www-s2.rsl.crl.fujixerox.co.jp/~kyasu/') construct: (URL fromString: 'http://arrow').
       (URL fromString: 'gopher://www.com') construct: (URL fromString: '//www.com:70/ParcBenchMain').
       (URL fromString: 'http://www/some.html') construct: (URL fromString: 'http://www/').
       (URL fromString: '../tmp/table.html') construct: (URL fromString: 'kyasu.gif').
    "
!

pathSuffix
    "answer the suffix of may path.
     for '/part1/part2/part3.suffix' this is '.suffix'"

    | tail index |

    path isNil ifTrue: [^ ''].
    tail := path asFilename tail.
    index := tail lastIndexOf: $..
    index = 0 ifTrue: [^ ''].
    ^ tail copyFrom: index + 1 to: tail size
! !

!URL class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libhtml/URL.st,v 1.42 2011/10/05 16:07:49 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libhtml/URL.st,v 1.42 2011/10/05 16:07:49 cg Exp $'
! !
