"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libhtml' }"

LibraryDefinition subclass:#stx_libhtml
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libhtml class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Build-Information for creation of the st/x standard library: stx_libhtml.
    This library contains a simple HTML viewer (browser) used for the online doc.
"
! !

!stx_libhtml class methodsFor:'description'!

excludedFromPreRequisites
    ^ #(
        #'stx:goodies/communication'    "FTPClient - referenced by HTMLDocumentFrame>>imageFor:now: "
        #'stx:goodies/postscript'    "PSGraphicsContext - referenced by HTMLDocumentPainter>>aEnd "
        #'stx:libbasic2'    "SharedQueue - referenced by HTMLDocumentPainter>>img "
        #'stx:libbasic3'    "HTMLDocGenerator - referenced by HTMLDocumentFrame>>pseudoDocumentStreamForManPageFile: "
        #'stx:libboss'    "BinaryObjectStorage - referenced by HTMLDocumentFrame>>appletClass:fromURL:archive: "
        #'stx:libcomp'    "Parser - referenced by HTMLDocumentFrame>>submitDoitMethod:form: "
        #'stx:libjava'    "JavaClassReader - referenced by HTMLDocumentView>>menu_settings "
        #'stx:libjavascript'    "JavaScriptParser - referenced by HTMLParser>>script_javascript: "
        #'stx:libtool'    "WorkspaceApplication - referenced by HTMLDocumentFrame>>workspaceOnExampleText "
        #'stx:libview2'    "GIFReader - referenced by HTMLDocumentFrame>>imageFor:now: "
        #'stx:libwidg2'    "CheckBox - referenced by HTMLDocumentView>>menu_settings "
    )
!

extensionMethodNames
    ^ #(
    )
!

preRequisites
    ^ #(
        #'stx:libbasic'    "Array - superclass of HTMLElement "
        #'stx:libview'    "GraphicsMedium - superclass of HTMLView "
        #'stx:libwidg'    "ScrollableView - superclass of HTMLView "
    )
! !

!stx_libhtml class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIBHTML_BASE
LIB_BASE=$(LIBHTML_BASE)
'
! !

!stx_libhtml class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        (Applet autoload)
        HTMLAnchor
        HTMLApplet
        HTMLBullet
        HTMLCRMarkupText
        HTMLDocument
        HTMLDocumentFrame
        HTMLDocumentInterpreter
        HTMLDocumentPainter
        (HTMLDocumentPrinter autoload)
        HTMLDocumentView
        HTMLElement
        (HTMLFilterStream autoload)
        HTMLFontStyle
        HTMLForm
        HTMLImage
        HTMLList
        HTMLMarkup
        HTMLMarkupText
        HTMLPageStyle
        HTMLParser
        HTMLScript
        HTMLScriptEnvironment
        HTMLStyle
        HTMLTable
        HTMLTableCol
        HTMLTableRow
        HTMLText
        HTMLView
        HTMLWidget
        (HTMLWriteStream autoload)
        URL
        #'stx_libhtml'
        DidYouKnowTipViewer
    )
! !

!stx_libhtml class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X HTML Browser'
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2012\nCopyright eXept Software AG 1998-2012'

    "Modified: / 18-07-2012 / 19:11:42 / cg"
! !

!stx_libhtml class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libhtml/stx_libhtml.st,v 1.23 2012/07/18 17:12:54 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libhtml/stx_libhtml.st,v 1.23 2012/07/18 17:12:54 cg Exp $'
! !
