"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libjavascript' }"

JavaScriptFunctionNode subclass:#JavaScriptInnerFunctionNode
	instanceVariableNames:'indexOfFirstTemp'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-JavaScript-Compiling & Parsing'
!

!JavaScriptInnerFunctionNode class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2005 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!JavaScriptInnerFunctionNode methodsFor:'accessing'!

blockArgAccessed:aBoolean
!

home:anEnvironment
    environment := anEnvironment
!

indexOfFirstTemp
    ^ indexOfFirstTemp
!

indexOfFirstTemp:index
    indexOfFirstTemp := index
!

isInnerFunction
    ^ true
! !

!JavaScriptInnerFunctionNode methodsFor:'code generation'!

codeOn:aStream inBlock:b for:aCompiler
    "this generates a block for the inner function;
     Difference from block:
        return is a local return;
        if return is missing, retval is nil"

    |pos thisStatement nextStatement lastStatement code
     maxNumTemp|

    maxNumTemp := 10.

    pos := aStream position1Based.

    aStream nextPut:#makeBlock.                                 "+0"
    aStream nextPut:0.                                          "+1"
    aStream nextPut:(locals size + maxNumTemp).                 "+2"
    aStream nextPut:(arguments size).                           "+3"

    statements isEmptyOrNil ifTrue:[
        aStream nextPut:#retNil.
    ] ifFalse:[
        lastStatement := nil.                                                                "+4"
        thisStatement := statements.
        [thisStatement notNil] whileTrue:[
            nextStatement := thisStatement nextStatement.
            thisStatement codeForSideEffectOn:aStream inBlock:self for:aCompiler.
            lastStatement := thisStatement.     
            thisStatement := nextStatement
        ].

        lastStatement isReturnNode ifFalse:[
            aStream nextPut:#retNil.
        ].
"/
"/        lastStatement 
"/                codeForSimpleReturnOn:aStream
"/                inBlock:self 
"/                lineNumber:lastStatement lineNumber 
"/                for:aCompiler.
    ].

    code := (aStream contents).
    "/ sigh - during coding, inlined subBlocks may have added more
    "/ tempVars; patch the nvar byte ...

    code at:pos+2 put:(locals size + maxNumTemp).

    "set the end of the block's code"
    code at:pos+1 put:(aStream position1Based)
!

rememberOuterBlockVarAccess:aVariableNode
"/    accessedOuterBlockVars isNil ifTrue:[
"/        accessedOuterBlockVars := OrderedCollection new.
"/    ].
"/    accessedOuterBlockVars add:aVariableNode
! !

!JavaScriptInnerFunctionNode methodsFor:'evaluation'!

evaluateIn:anEnvironment
    ^ self
! !

!JavaScriptInnerFunctionNode methodsFor:'queries'!

home
    ^ environment
!

isInlineBlock
    ^ false
!

isJavaScriptBlock
    ^ true
! !

!JavaScriptInnerFunctionNode class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libjavascript/JavaScriptInnerFunctionNode.st,v 1.5 2010/06/14 11:26:40 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjavascript/JavaScriptInnerFunctionNode.st,v 1.5 2010/06/14 11:26:40 cg Exp $'
! !
