"
 COPYRIGHT (c) 2000 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libjavascript' }"

Metaclass subclass:#JavaScriptMetaclass
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-JavaScript-Framework'
!

!JavaScriptMetaclass class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2000 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!JavaScriptMetaclass class methodsFor:'class creation'!

classTemplateFor:aSuperClass in:categoryString asNamespace:asNameSpace private:isPrivateWanted    
    ^ String streamContents:[:s |
        isPrivateWanted ifTrue:[
            s nextPutAll:'private '.
        ] ifFalse:[
            s nextPutAll:'public '.
        ].
        s nextPutLine:'class NewClass '.
        s nextPutAll:'extends '.
        s nextPutLine:aSuperClass name.

        s nextPutAll:'{'.
        s cr.

        s tab; nextPutLine:'static var static1, static2;'.
        s tab; nextPutLine:'var var1, var2;'.
        s tab; nextPutLine:'var var3;'.

        s nextPutAll:'}'.
        s cr.
     ]

    "Modified: / 30-01-2011 / 17:21:51 / cg"
! !

!JavaScriptMetaclass methodsFor:'compiler interface'!

programmingLanguage
    self = JavaScriptClass ifTrue:[
        "/ me myself, I am written in Smalltalk !!
        ^ super programmingLanguage
    ].
    ^ STXJavaScriptLanguage instance
!

realSubclassDefinerClass
    ^ JavaScriptCompiler
!

subclassDefinerClass
    self == JavaScriptMetaclass ifTrue:[
        ^ super subclassDefinerClass
    ].
    ^ JavaScriptCompiler
! !

!JavaScriptMetaclass methodsFor:'fileOut'!

basicFileOutDefinitionOf:aClass on:aStream withNameSpace:forceNameSpace withPackage:showPackage 
    "append an expression on aStream, which defines myself."

"/    self == JavaScriptClass ifTrue:[
"/        ^ super basicFileOutDefinitionOn:aStream withNameSpace:forceNameSpace withPackage:showPackage
"/    ].

"/    aStream nextPutLine:'// '.
"/    aStream nextPutLine:'// @category ' , aClass category.
"/    aStream nextPutLine:'// '.
    aStream nextPutAll:'public class '.
    aStream nextPutAll:aClass name.
    aStream nextPutAll:' extends '.
    aStream nextPutAll:aClass superclass name.
    aStream cr.

    aStream nextPutLine:'{'.

    aClass classVarNames do:[:eachVarName |
        |val|

        aStream 
            tab; 
            nextPutAll:'static var '; nextPutAll:eachVarName.
        (val := aClass classVarAt:eachVarName) notNil ifTrue:[
            aStream nextPutAll:' = '.
            "number or string!!"
            val isString ifTrue:[
                aStream nextPutAll: ('"',(val withCEscapes),'"')
            ] ifFalse: [
                aStream nextPutAll:(val storeString)
            ].
        ].
        aStream 
            nextPutLine:';'.
    ].
    aClass instVarNames do:[:eachVarName |
        aStream tab; nextPutAll:'var '; nextPutAll:eachVarName; nextPutLine:';'.
    ].
    aStream nextPutLine:'}'.

    "Modified: / 16-07-2012 / 20:40:22 / cg"
!

fileOutAllDefinitionsOn:aStream
    "append expressions on aStream, which defines myself and all of my private classes."

    myClass fileOutDefinitionOn:aStream.
    aStream cr; cr.

    "/
    "/ optional classInstanceVariables
    "/
    self instanceVariableString isBlank ifFalse:[
        myClass fileOutClassInstVarDefinitionOn:aStream.
        aStream cr; cr
    ].

    "/ here, the full nameSpace prefixes are output,
    "/ to avoid confusing stc 
    "/ (which otherwise could not find the correct superclass)
    "/
    Class fileOutNameSpaceQuerySignal answer:false do:[
        Class forceNoNameSpaceQuerySignal answer:true do:[
            myClass privateClassesSorted do:[:aClass |
                 myClass class fileOutAllDefinitionsOn:aStream
            ]
        ]
    ].

    "Created: / 15-10-1996 / 11:15:19 / cg"
    "Modified: / 19-05-2010 / 16:05:38 / cg"
!

fileOutClassInstVarDefinitionOn:aStream withNameSpace:withNameSpace
!

fileOutOn:outStreamArg withTimeStamp:stampIt withInitialize:initIt withDefinition:withDefinition methodFilter:methodFilter encoder:encoderOrNil
    "file out my definition and all methods onto aStream.
     If stampIt is true, a timeStamp comment is prepended.
     If initIt is true, and the class implements a class-initialize method,
     append a corresponding doIt expression for initialization.
     The order by which the fileOut is done is used to put the version string at the end.
     Thus, if the version string is expanded (by CVS), the characterPositions of methods should not move"

    JavaScriptSourceFileWriter new
        fileOut:self on:outStreamArg 
        withTimeStamp:stampIt withInitialize:initIt withDefinition:withDefinition 
        methodFilter:methodFilter encoder:encoderOrNil
! !

!JavaScriptMetaclass methodsFor:'queries'!

isJavaScriptMetaclass
        ^ true
!

nameInBrowser
    "return a nameString as shown in browsers"

    |nm|

    nm := self name ? '_'.
    ^ nm,'(',')'
! !

!JavaScriptMetaclass methodsFor:'source management'!

sourceFileSuffix
    ^ 'js'
! !

!JavaScriptMetaclass class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libjavascript/JavaScriptMetaclass.st,v 1.17 2012/07/16 19:14:50 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjavascript/JavaScriptMetaclass.st,v 1.17 2012/07/16 19:14:50 cg Exp $'
! !
