"
 COPYRIGHT (c) 2009 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libjavascript' }"

ProgrammingLanguage subclass:#STXJavaScriptLanguage
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Kernel-Languages'
!

!STXJavaScriptLanguage class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2009 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    provide info about which tools are to be used for the
    embedded JavaScript-like language in Smalltalk (not a real JavaScript,
    that's why it's called STXJavaScript)
"
! !

!STXJavaScriptLanguage methodsFor:'accessing'!

name
    "Answers a human-readable name of myself:
     'Smalltalk' for SmalltalkLanguage,
     'Ruby' for RubyLanguage..."

    ^ 'JavaScript'
!

sourceFileSuffix
    "Answers a default suffix for source files, i.e.
     'st' for Smalltalk, 'js' for JavaScript or 'rb' for Ruby'"

    ^ 'js'
! !

!STXJavaScriptLanguage methodsFor:'accessing - classes'!

codeGeneratorClass
    "Answers a class that can generate smalltalk code"

    ^ JavaScriptCodeGeneratorTool

    "Created: / 30-01-2011 / 15:19:48 / cg"
!

compilerClass
    "Answer a class suitable for compiling a source code in 'my' language"

    ^ Smalltalk::JavaScriptCompiler
!

evaluatorClass
    "Answer a class suitable for doit evaluation in 'my' language"

    ^Smalltalk::JavaScriptParser
!

explainerClass
    "Answers a class used by browser and debugger to
     show some hints about the code. It is OK to return
     nil, which means that there is no explainer for given
     language.
    "

    "return nil by default"
    ^Explainer

    "Created: / 21-08-2009 / 08:49:29 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

metaClass
    "will be used for new classes (in the class wizard)"

    ^ JavaScriptMetaclass

    "Modified: / 30-01-2011 / 10:06:16 / cg"
!

parserClass
    "Answer a class suitable for parsing a source code in 'my' language"

    ^Smalltalk::JavaScriptParser
!

sourceFileReaderClass
    "Answers a class that can be used for
     reading & compiling source files"

    ^ JavaScriptSourceReader
!

sourceFileWriterClass
    "Answers a class is used for source file writing (i.e. file-out)"

    ^ JavaScriptSourceFileWriter
!

syntaxHighlighterClass
    "return the class to use for syntaxHighlighting (prettyPrinting) this class -
     this can be redefined in special classes, to highlight classes with
     Lisp, Prolog, ASN1, Basic :-) or whatever syntax."

    ^ Smalltalk::JavaScriptSyntaxHighlighter
! !

!STXJavaScriptLanguage methodsFor:'testing'!

isSTXJavaScript
    "true iff this is the ST/X-javascript language"

    ^ true
! !

!STXJavaScriptLanguage methodsFor:'utilities - source code'!

methodTemplate
    |s|

    s := TextStream on:''.

    s emphasis:(UserPreferences current commentEmphasisAndColor).
    s nextPutAll:
'//
// comment stating purpose of this method
//'.
    s emphasis:nil.
    s nextPutAll:
'
function name ( arg1 , ... )
{
    var temp1, ...  ;

    statement;
    statement;
}
'.

    s cr.
    s emphasis:(UserPreferences current commentEmphasisAndColor).
    s nextPutAll:
'// change the above template into real code;
// remove this comment.
// Then `accept'' either via the menu
// or via the keyboard (usually CMD-A).

// You do not need this template; you can also
// select any existing methods code, change it,
// and finally `accept''. The method will then be
// installed under the selector as defined in the
// actual text - no matter which method is selected
// in the browser, or where the original text came from.

// Or clear this text, type in the method from scratch
// and install it with `accept''.
'.

    ^ s contents
! !

!STXJavaScriptLanguage class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjavascript/STXJavaScriptLanguage.st,v 1.6 2011/01/30 14:20:30 cg Exp $'
! !
