"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libjavascript' }"

LibraryDefinition subclass:#stx_libjavascript
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libjavascript class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Build-Information for creation of the st/x standard library: stx_libjavascript.
    This library contains a JavaSript Parser/Compiler, generating smalltalk bytecode.
"
!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/libjavascript/stx_libjavascript.st,v 1.22 2012/07/18 17:12:48 cg Exp $'
! !

!stx_libjavascript class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
        #'stx:libbasic2'    "Random - referenced by Math class>>randomInteger:_: "
        #'stx:libview'    "Color - referenced by JavaScriptSyntaxHighlighter>>markSelector:from:to:receiverNode:numArgs: "
    )

    "Modified: / 19-05-2010 / 14:34:59 / cg"
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:libbasic'    "Object - superclass of JavaScriptParser::WhileStatementNode "
        #'stx:libbasic3'    "HTMLDocGenerator - superclass of HTMLDocGeneratorForJavaScript "
        #'stx:libcomp'    "PrimaryNode - superclass of JavaScriptVariableNode "
    )
! !

!stx_libjavascript class methodsFor:'description - compilation'!

additionalDefinitions_nt_dot_mak
    ^ '
# see stdHeader_nt for LIBJAVASCRIPT_BASE
LIB_BASE_LD_ARG=-b:$(LIBJAVASCRIPT_BASE)
'
! !

!stx_libjavascript class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        HTMLDocGeneratorForJavaScript
        JavaScriptClass
        JavaScriptClassNode
        JavaScriptEnvironment
        JavaScriptFunction
        JavaScriptFunctionNode
        JavaScriptMetaclass
        JavaScriptObject
        JavaScriptScanner
        JavaScriptSourceFileWriter
        JavaScriptSourceReader
        JavaScriptVariable
        JavaScriptVariableNode
        Math
        STXJavaScriptLanguage
        #'stx_libjavascript'
        JavaScriptInnerFunctionNode
        JavaScriptParser
        JavaScriptCompiler
        JavaScriptSyntaxHighlighter
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        AbstractTime getDate
        AbstractTime getDay
        AbstractTime getFullYear
        AbstractTime getHours
        AbstractTime getMinutes
        AbstractTime getMonth
        AbstractTime #'js_getMilliseconds'
        AbstractTime #'js_getSeconds'
        AbstractTime #'js_add:'
        ArithmeticValue #'js_add:'
        Behavior #'js_new'
        Behavior #'js_new:'
        Block typeof
        Boolean typeof
        CharacterArray charAt0:
        CharacterArray charAt1:
        CharacterArray charCodeAt0:
        CharacterArray charCodeAt1:
        CharacterArray indexOf0:
        CharacterArray indexOf1:
        CharacterArray lastIndexOf0:
        CharacterArray lastIndexOf1:
        CharacterArray quote
        CharacterArray split:
        CharacterArray #'substr0:_:'
        CharacterArray #'substr1:_:'
        CharacterArray substring0:
        CharacterArray #'substring0:_:'
        CharacterArray substring1:
        CharacterArray #'substring1:_:'
        CharacterArray toLowerCase
        CharacterArray toUpperCase
        CharacterArray trim
        CharacterArray trimLeft
        CharacterArray trimRight
        CharacterArray typeof
        Collection length
        Number toExponential:
        Number #'toExponential:_:'
        Number toFixed:
        Number typeof
        Object typeof
        SequenceableCollection concat:
        SequenceableCollection every:
        SequenceableCollection filter:
        SequenceableCollection forEach:
        SequenceableCollection indexOf0:
        SequenceableCollection indexOf1:
        SequenceableCollection join:
        SequenceableCollection #'js_add:'
        SequenceableCollection #'js_map:'
        SequenceableCollection lastIndexOf0:
        SequenceableCollection lastIndexOf1:
        SequenceableCollection pop
        SequenceableCollection push:
        SequenceableCollection reduce0:
        SequenceableCollection #'reduce0:_:'
        SequenceableCollection reduce1:
        SequenceableCollection #'reduce1:_:'
        SequenceableCollection shift
        SequenceableCollection #'slice0:_:'
        SequenceableCollection #'slice1:_:'
        SequenceableCollection some:
        SequenceableCollection unshift:
        SortedCollection indexForInserting:
        Stream #'show:_:'
        Stream #'show:_:_:'
        Stream #'show:_:_:_:'
        Stream #'show:_:_:_:_:'
        Stream #'show:_:_:_:_:_:'
        Stream #'showCR:_:'
        Stream #'showCR:_:_:'
        Stream #'showCR:_:_:_:'
        Stream #'showCR:_:_:_:_:'
        Stream #'showCR:_:_:_:_:_:'
        UndefinedObject typeof
        'Collection class' #'with:_:'
        'Collection class' #'with:_:_:'
        'Collection class' #'with:_:_:_:'
        'Collection class' #'with:_:_:_:_:'
        'Collection class' #'with:_:_:_:_:_:'
        'Collection class' #'with:_:_:_:_:_:_:'
        'Collection class' #'with:_:_:_:_:_:_:_:'
        'Date class' #'js_new:'
        'Date class' now
        'Number class' #'MAX_VALUE'
        'Number class' #'MIN_VALUE'
        'Number class' #'NEGATIVE_INFINITY'
        'Number class' NaN
        'Number class' #'POSITIVE_INFINITY'
        'Number class' #'js_new:'
        'SortedCollection class' binarySearch:for:
        'SortedCollection class' binarySearch:forIndexOf:
        'SortedCollection class' binarySearch:from:to:forIndexOf:usingSortBlock:
        'String class' fromCharCode:
        ArithmeticValue #'js_addFromNumber:'
        ArithmeticValue #'js_addFromTime:'
        CharacterArray #'js_add:'
        CharacterArray #'js_addFromNumber:'
        CharacterArray #'js_addFromString:'
        CharacterArray #'js_addFromTime:'
        Object #'js_addFromString:'
    )
! !

!stx_libjavascript class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X JavaScript Compiler'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2012\nCopyright eXept Software AG 1998-2012'

    "Modified: / 18-07-2012 / 19:11:45 / cg"
! !

!stx_libjavascript class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libjavascript/stx_libjavascript.st,v 1.22 2012/07/18 17:12:48 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libjavascript/stx_libjavascript.st,v 1.22 2012/07/18 17:12:48 cg Exp $'
! !
