"{ Package: 'stx:liboracle8' }"

Object subclass:#OCI8BindDescriptor
	instanceVariableNames:'duplicate handle indicator name position'
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Oracle8-Utilities'
!

!OCI8BindDescriptor class methodsFor:'documentation'!

documentation
"
    For describing a variable in the statement text, an array of OCI8BindDescriptor instances
    is created via OCI8Lib>>ociStmtGetBindInfo:errorOCIHandle:.
    Every entry in the array describes one variable in the statement text.

    [author:]
         Pierre Schwarz

    [see also:]

    [instance variables:]

        duplicate <Boolean>
            Is true if the variable appears more than one time in
            the statement text

        handle <ExternalAddress|nil>
            Holds a bind handle for the variable if the statement is binded
            (a bind handle must exist for the position of the variable).

        indicator <String>
            Holdes the indicator variable names

        name <Symbol>
            Holds the name of the variable for the position in the statement text.

        position <Integer>
            Holds the position of the variable in the statement text.

    [class variables:]
        none
"
!

history
    "Created: / 25.8.2000 / 09:36:04 / ps"
! !

!OCI8BindDescriptor methodsFor:'accessing'!

duplicate
"
returns if the variable appears more than one time in the statement text

<return: Boolean>
"
    ^ duplicate
!

duplicate:aBoolean
"
sets if the variable in the statement test appears more than one time

<return: self>
"

    duplicate := aBoolean.
!

handle
"
returns a bind handle for the variable if the statement is binded
(a bind handle must exist for the position of the variable)

<return: ExternalAddress|nil>
"

    ^ handle
!

handle:anExternalAddressOrNil
"
sets a bind handle for the variable if the statement is binded
(a bind handle must exist for the position of the variable)

<return: self>
"

    handle := anExternalAddressOrNil.
!

indicator
"
returns the indicator variable names

<return: String>
"

    ^ indicator
!

indicator:aString
"
sets the indicator variable names

<return: self>
"

    indicator := aString.
!

name
"
returns the name of the variable for the position in the statement text.

<return: Symbol>
"

    ^ name
!

name:aSymbol
"
sets the name of the variable for the position in the statement text.

<return: self>
"
    name := aSymbol.
!

position
"
returns position of the variable in the statement text.

<return: Integer>
"

    ^ position
!

position:anInteger
"
sets position of the variable in the statement text.

<return: self>
"

    position := anInteger.
! !

!OCI8BindDescriptor class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/liboracle8/OCI8BindDescriptor.st,v 1.4 2000/08/25 13:44:05 ps Exp $'
! !
