"{ Package: 'stx:liboracle8' }"

OCI8Converter subclass:#OCI8ByteArrayConverter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Oracle8-Converter'
!

!OCI8ByteArrayConverter class methodsFor:'documentation'!

documentation
"
    This class is used to convert bytes from ExternalBytes to a ByteArray.

    [author:]
	Pierre Schwarz

    [see also:]
	OCI8DateConverter
	OCI8FixedPointConverter
	OCI8FloatConverter
	OCI8IntegerConverter
	OCI8LongConverter
	OCI8StringConverter

    [instance variables:]
	none

    [class variables:]
	none
"
!

history
    "Created: / 22.8.2000 / 10:04:50 / ps"
! !

!OCI8ByteArrayConverter methodsFor:'accessing'!

basicElementSize
"
returns the maximum size of the external bytes buffer. 
Only used by returning variables.

<return: Integer>
"

    ^ 2000





!

dataSizeForColumnDescriptor:anOCI8ColumnDescriptor
"
returns the maximum size of the external bytes buffer. 
Only used by define variables.

<return: Integer>
"
    ^ anOCI8ColumnDescriptor size





!

externalCType
"
returns the symbol needed for the bind operation of an OCI8Variable.

<return: Symbol>
"
    ^ self cTypeLongRaw
!

maxSizeForCType
"
returns the maximum possible size of the external bytes buffer. 
Only used by dynamic define variables.

<return: Integer>
"
    "2^31-1 Bytes"
    ^2147483647





! !

!OCI8ByteArrayConverter methodsFor:'buffer accessing'!

convertToCTypeValue:aValue
"
returns a byte array because the external c type of the receiver
is long raw.

<return: ByteArray>
"
    ^ aValue asByteArray
!

getDataFromBuffer:anExternalByte size:size
"
returns a byte array representent by the external bytes anExternalByte.

<return: ByteArray>
"
    ^ anExternalByte copyFrom:1 to:size
! !

!OCI8ByteArrayConverter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/liboracle8/OCI8ByteArrayConverter.st,v 1.3 2002/03/26 08:42:53 stefan Exp $'
! !
