"{ Package: 'stx:liboracle8' }"

Object subclass:#OCI8Converter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Oracle8-Converter'
!

!OCI8Converter class methodsFor:'documentation'!

documentation
"
    The subclasses of this abstract class are used to convert the bytes from
    an ExternalByte object to a smalltalk value. The type into which the bytes are
    converted is determined by the concrete class of a converter.

    [author:]
        Pierre Schwarz

    [see also:]
        OCI8ByteArrayConverter
        OCI8DateConverter
        OCI8FixedPointConverter
        OCI8FloatConverter
        OCI8IntegerConverter
        OCI8LongConverter
        OCI8StringConverter

    [instance variables:]
        none

    [class variables:]
        none
"
!

history
    "Created: / 22.8.2000 / 10:00:16 / ps"
! !

!OCI8Converter methodsFor:'constants C Type'!

cTypeDate
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_DATE'
!

cTypeFloat
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_FLOAT'




!

cTypeInteger
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_INTEGER'


!

cTypeLong
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_LONG'


!

cTypeLongRaw
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_LONG_RAW'


!

cTypeNumber
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_NUMBER'
!

cTypeRaw
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_RAW'


!

cTypeString
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_STRING'


!

cTypeVarchar2
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_VARCHAR2'
!

cTypeVarnum
"
returns a symbol for the c type used for the oci bind or define
functions.

<return: Symbol>
"

    ^#'C_TYPE_VARNUM'


! !

!OCI8Converter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/liboracle8/OCI8Converter.st,v 1.6 2002/03/28 12:26:35 stefan Exp $'
! !
