"{ Package: 'stx:liboracle8' }"

OCI8DefineVariable subclass:#OCI8DefaultDefineVariable
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Oracle8-Variables'
!

!OCI8DefaultDefineVariable class methodsFor:'documentation'!

documentation
"
    This class is used to return data from a query statement when no piecewise
    fetch is necessary for the column represented by the define variable.

    [author:]
        Pierre Schwarz

    [see also:]
        OCI8DefineVariable
        OCI8DynamicDefineVariable
        OCI8Variable

    [instance variables:]
        none

    [class variables:]
        none
"
!

history
    "Created: / 30.8.2000 / 12:08:15 / ps"
! !

!OCI8DefaultDefineVariable methodsFor:'setup'!

setupFor:anOCI8Statement
    "setup the external bytes, the converter etc. and define the receiver.
     <return: self>"

    |dataSize|

    self computeConverter.

    indicatorArray isNil ifTrue:[
        indicatorArray := OCI8Lib bufferForSize:OCI8Lib sb2Size.
        elementLengthArray := OCI8Lib bufferForSize:OCI8Lib ub2Size.
    ].
    dataSize := converter dataSizeForColumnDescriptor:columnDescriptor.
    dataBuffer notNil ifTrue:[dataBuffer free].
    dataBuffer := OCI8Lib bufferForSize:dataSize.
    self reRegisterForFinalization.

    anOCI8Statement ociLib ociDefineByPos:anOCI8Statement handle 
             defineHandle:self handle
                    cType:self externalCType 
                   buffer:dataBuffer
               bufferSize:dataSize
                 position:position 
       nullValueIndicator:indicatorArray
       elementLengthArray:elementLengthArray 
          returnCodeArray:nil 
                     mode:#'OCI_DEFAULT'
           errorOCIHandle:anOCI8Statement errorHandle.
! !

!OCI8DefaultDefineVariable class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/liboracle8/OCI8DefaultDefineVariable.st,v 1.14 2004/11/09 08:32:12 stefan Exp $'
! !
