"{ Package: 'stx:liboracle8' }"

OCI8Converter subclass:#OCI8FloatConverter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Oracle8-Converter'
!

!OCI8FloatConverter class methodsFor:'documentation'!

documentation
"
    This class is used to convert bytes from ExternalBytes to a Float.

    [author:]
	Pierre Schwarz

    [see also:]
	OCI8ByteArrayConverter
	OCI8DateConverter
	OCI8FixedPointConverter
	OCI8IntegerConverter
	OCI8LongConverter
	OCI8StringConverter

    [instance variables:]
	none

    [class variables:]
	none
"
!

history
    "Created: / 22.8.2000 / 10:08:53 / ps"
! !

!OCI8FloatConverter methodsFor:'accessing'!

basicElementSize
"
returns the maximum size of the external bytes buffer. 
Only used by returning variables.

<return: Integer>
"

    ^ 256





!

dataSizeForColumnDescriptor:anOCI8ColumnDescriptor
"
returns the maximum size of the external bytes buffer. 
Only used by define variables.

<return: Integer>
"
    ^ 256








!

externalCType
"
returns the symbol needed for the bind operation of an OCI8Variable.

<return: Symbol>
"
    ^ self cTypeVarchar2
!

maxSizeForCType
"
returns the maximum possible size of the external bytes buffer. 
Only used by dynamic define variables.

<return: Integer>
"
    ^4000







! !

!OCI8FloatConverter methodsFor:'buffer accessing'!

convertToCTypeValue:aValue
"
returns a string because the external c type of the receiver
is a string.

<return: String>
"
    ^aValue printString







!

getDataFromBuffer:anExternalByte size:size
"
returns a float. The number is representent by a string
in the external bytes anExternalByte.

<return: Float>
"
    ^ (anExternalByte stringAt:1 size:size) asFloat
! !

!OCI8FloatConverter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/liboracle8/OCI8FloatConverter.st,v 1.4 2002/03/26 08:42:15 stefan Exp $'
! !
