"{ Package: 'stx:liboracle8' }"

OCI8Converter subclass:#OCI8LongConverter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Oracle8-Converter'
!

!OCI8LongConverter class methodsFor:'documentation'!

documentation
"
    This class is used to convert bytes from ExternalBytes (representing a c type long)
    to a String.

    [author:]
	Pierre Schwarz

    [see also:]
	OCI8ByteArrayConverter
	OCI8DateConverter
	OCI8FixedPointConverter
	OCI8FloatConverter
	OCI8IntegerConverter
	OCI8StringConverter

    [instance variables:]
	none

    [class variables:]
	none
"
!

history
    "Created: / 22.8.2000 / 12:30:53 / ps"
! !

!OCI8LongConverter methodsFor:'accessing'!

basicElementSize
"
returns the maximum size of the external bytes buffer. 
Only used by returning variables.

<return: Integer>
"
    ^2000
!

dataSizeForColumnDescriptor:anOCI8ColumnDescriptor
"
returns the maximum size of the external bytes buffer. 
Only used by define variables.

<return: Integer>
"
    ^ anOCI8ColumnDescriptor size + 1







!

externalCType
"
returns the symbol needed for the bind operation of an OCI8Variable.

<return: Symbol>
"
    ^ self cTypeLong
!

maxSizeForCType
"
returns the maximum possible size of the external bytes buffer. 
Only used by dynamic define variables.

<return: Integer>
"
    "2^31-1 Bytes"
    ^2147483647








! !

!OCI8LongConverter methodsFor:'buffer accessing'!

convertToCTypeValue:aValue
"
returns a string because the external c type of the receiver
is a string.

<return: String>
"
    ^aValue printString










!

getDataFromBuffer:anExternalByte size:size
"
returns a string representent by the external bytes anExternalByte.

<return: String>
"
    ^ anExternalByte stringAt:1 size:size
! !

!OCI8LongConverter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/liboracle8/OCI8LongConverter.st,v 1.4 2002/03/26 08:42:05 stefan Exp $'
! !
