"{ Package: 'stx:liboracle8' }"

OCI8Converter subclass:#OCI8StringConverter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'DataBase-Oracle8-Converter'
!

!OCI8StringConverter class methodsFor:'documentation'!

documentation
"
    This class is used to convert bytes from ExternalBytes to a String.

    [author:]
	Pierre Schwarz

    [see also:]
	OCI8ByteArrayConverter
	OCI8DateConverter
	OCI8FixedPointConverter
	OCI8FloatConverter
	OCI8IntegerConverter
	OCI8LongConverter

    [instance variables:]
	none

    [class variables:]
	none
"
!

history
    "Created: / 22.8.2000 / 10:09:19 / ps"
! !

!OCI8StringConverter methodsFor:'accessing'!

basicElementSize
"
returns the maximum size of the external bytes buffer. 
Only used by returning variables.

<return: Integer>
"

    ^ 2000





!

dataSizeForColumnDescriptor:anOCI8ColumnDescriptor
"
returns the maximum size of the external bytes buffer. 
Only used by define variables.

<return: Integer>
"
    ^ anOCI8ColumnDescriptor size + 1






!

externalCType
"
returns the symbol needed for the bind operation of an OCI8Variable.

<return: Symbol>
"
    ^ self cTypeVarchar2
!

maxSizeForCType
"
returns the maximum possible size of the external bytes buffer. 
Only used by dynamic define variables.

<return: Integer>
"
    ^4000






! !

!OCI8StringConverter methodsFor:'buffer accessing'!

convertToCTypeValue:aValue
"
returns a string because the external c type of the receiver
is a string.

<return: String>
"
    ^aValue printString









!

getDataFromBuffer:anExternalByte size:size
"
returns a string representent by the external bytes anExternalByte.

<return: String>
"
    ^ anExternalByte stringAt:1 size:size
! !

!OCI8StringConverter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/liboracle8/OCI8StringConverter.st,v 1.4 2002/03/26 08:41:55 stefan Exp $'
! !
