char __apithreads__rcsid__[] = "$Header: /cvs/stx/stx/librun/apithreads.c,v 1.24 2011/12/09 22:04:17 cg Exp $";

#define FOR_IDENT_ONLY /* to get the rcsid's of the header files compiled-in */
#include "apithreads.h"
#undef FOR_IDENT_ONLY

/*
 * COPYRIGHT (c) 1992-1995 by Claus Gittinger
 *              All Rights Reserved
 *
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/* #define DEBUG_WRAPCALLS /* */
/* # ifdef SYNCHRONOUS_API_CALLS /* for debugging only: makes ALL calls synchronous (non threaded) */

#ifdef WIN32
# define  _RWSTD_EXCEPTIONS
# include <windows.h>
# include <excpt.h>
#endif

#include <stdio.h>
#define __IN_VM__
#include "stc.h"
#include <malloc.h>
#include <errno.h>
#include "runtime.h"
#include "process.h"
#include "apithreads.h"

#ifdef APIWRAPTHREADS

# define xxHIGH_PRIO_API_THREAD           /* API thread runs high-prio */
# define HIGH_PRIO_API_THREAD_INTERFACE /* API thread runs high prio only for message exchange */

# ifdef WIN32
#  ifdef USE_DISCONNECT_EX
#   ifdef OLD_WINSOCK
#    include <winsock.h>
#   else
#    include <winsock2.h>
#   endif
#   ifndef TF_REUSE_SOCKET
#    define TF_REUSE_SOCKET       0x02
#    endif
#  endif
# endif

static int __debugSockAPI = 0;
static int __debugWinAPI = 0;
static int __debugCAPI = 0;

void __setWrapCallDebugging(int what, int onOff) {
   switch (what)
   {
   case 1: __debugSockAPI = ((onOff != 0) ? 1 : 0); break;
   case 2: __debugWinAPI  = ((onOff != 0) ? 1 : 0); break;
   case 3: __debugCAPI    = ((onOff != 0) ? 1 : 0); break;
   default: break;
   }
}

/* #define DEBUG_SOCKAPI /* */
/* #define DEBUG_WINAPI /* */
/* #define DEBUG_CAPI /* */

/* #define DEBUG_FCLOSE /* */
/* #define DEBUG_GETFILEATTRIBUTES /* */
/* #define DEBUG_ASYNCRONOUS_WRAPCALLS /* */
/* #define DEBUG_SYNCRONOUS_WRAPCALLS /* */
/* #define DEBUG_CONNECT           /* */
/* #define DEBUG_SEND              /* */
/* #define DEBUG_RTL_WRITE         /* */
/* #define DEBUG_WRITE_BUFFER      /* */
/* #define DEBUG_WRITE_BUFFER2     /* */
/* #define DEBUG_SQL /* */

#define xxxCHECK_EARLY_FOR_INTERRUPTS   /* no leads to ever-running "already interrupted" messages */
/* #define CACHE_GETFILEATTRIBUTES    /* */
#define FAST_FINDFIRSTFILE         /* */
#define FAST_FINDNEXTFILE          /* */
#define FAST_GETFILEATTRIBUTES     /* */
#define FAST_GETFULLPATHNAME       /* */
#define FAST_GETLONGPATHNAME       /* */
#define FAST_FOPEN  /* */
#define FAST_CREATEFILE  /* */

/* #define SYNCHRONOUS_API_CALLS /* */
/* #define SYNCHRONOUS_GETFILEATTRIBUTES /* */
/* #define SYNCHRONOUS_GETFULLPATHNAME /* */
/* #define SYNCHRONOUS_GETLONGPATHNAME /* */
/* #define SYNCHRONOUS_FINDFIRSTFILE /* */
/* #define SYNCHRONOUS_FINDNEXTFILE /* */
/* #define SYNCHRONOUS_FOPEN  /* */
/* #define SYNCHRONOUS_CREATEFILE  /* */

void __apiwrap_start__() {}

# ifdef USE_PTHREADS
#  define Sleep(dummy) pthread_yield()
# endif

#ifdef SUPERDEBUG
# define PRINTF(x)      {printf x;fflush(stdout);}
#else
# define PRINTF(x)      /* nothing */
#endif

#ifdef WRAPDEBUG
# define WPRINTF(x)      {printf x;fflush(stdout);}
#else
# define WPRINTF(x)      /* nothing */
#endif

#ifdef WRAPDEBUG1
# define W1PRINTF(x)      {printf x;fflush(stdout);}
#else
# define W1PRINTF(x)      /* nothing */
#endif

#if 1
# define WRAP_DPRINTF(w, x)      if ((w)->debug) { printf("VM-API(%s): ", (w)->wrapFunctionName); printf x; };
#else
# define WRAP_DPRINTF(w, x)      /* nothing */
#endif

#if 1
# define WRAP_DPRINTF2(w, x)      if ((w)->debug) { printf("VM-API(%s): ", (w)->wrapFunctionName); printf x; };
#else
# define WRAP_DPRINTF2(w, x)      /* nothing */
#endif

#if 0
# define WRAP_DPRINTF3(w, x)      if (1 /*(w)->debug*/) { printf("VM-API(%s): ", (w)->wrapFunctionName); printf x; };
#else
# define WRAP_DPRINTF3(w, x)      /* nothing */
#endif

#ifdef SUPERDEBUG
# define SDPRINTF(x)    {printf x;fflush(stdout);}
#else
# define SDPRINTF(x)    /* nothing */
#endif



# define WRAPCHUNKSIZE   8
static struct wrapCall *freeWrapCallList = (struct wrapCall *)0;
static struct wrapCall *cachedFreeWrapCall = (struct wrapCall *)0;
static CRITICAL_SECTION wrapSection;
static CRITICAL_SECTION wrapFreeListSection;
static CRITICAL_SECTION wrapThreadFreeListSection;
static CRITICAL_SECTION wrapCallCritical;

char *WrapState_Names[] = {
    "WrapState_Wait",
    "WrapState_Active",
    "WrapState_Idle",
};


void wrapProc();
static enum E_WrapUndoID wrapCall_getUndoId( );
#ifdef NATIVETHREADS
extern struct process *__schedulerProcess;
#endif

IN_INIT_SECTION(void, __initProcess)
void
__initApiThreads()
{
	InitializeShortCriticalSection(&wrapSection);
	InitializeShortCriticalSection(&wrapFreeListSection);
	InitializeShortCriticalSection(&wrapThreadFreeListSection);
	InitializeShortCriticalSection(&wrapCallCritical);
}

void
__stxWrapApiEnterCritical()
{
    EnterShortCriticalSection(&wrapCallCritical);
}

void
__stxWrapApiLeaveCritical()
{
    LeaveShortCriticalSection(&wrapCallCritical);
}


/*
 * must be called in wrapFreeListSection
 */
static void
getWrapCallChunk() {
    REGISTER struct wrapCall *chunk;
    REGISTER int i;

    chunk = (struct wrapCall *) malloc(sizeof(struct wrapCall) * WRAPCHUNKSIZE);
    MALLOCPRINTF(("malloc %d wrapCall structures -> %x\n",
		    sizeof(struct wrapCall) * WRAPCHUNKSIZE,
		    chunk));
    if (! chunk) {
	PRINTF(("VM [error]: no memory to allocate wrapCall structures\n"));
    } else {
	for (i=0; i<WRAPCHUNKSIZE; i++) {
	    chunk->next      = freeWrapCallList;
	    freeWrapCallList = chunk;
# ifdef USE_WIN32THREADS
	    chunk->wrapWakeupEvent  = (EVENT_T)0;
	    chunk->wrapTid.ntHandle = INVALID_HANDLE_VALUE;
	    chunk->wrapTid.ntId     = 0;
# else  /* !USE_WIN32THREADS */
#  ifdef USE_PTHREADS
	    chunk->wrapTid.pId = INVALID_PID_VALUE;
#  else
#           error "missing code here"
#  endif
# endif
	    chunk->wrapActiveId = 0;
	    chunk->wrapState    = WrapState_Idle;
	    chunk->wrapUndoID   = WrapUndoID_none;

	    chunk->wrapFunctionName = "<NONE YET>";

	    chunk++;
	}
    }
}

#ifdef WIN32
static
SECURITY_ATTRIBUTES saDefault = {
    sizeof(SECURITY_ATTRIBUTES),    // size of strukture
    0,                              // no security descriptor
    TRUE,                           // threadHandle inheritable
};
#endif

#ifdef WIN32

#define WrapCall_Suspend( w )     SuspendThread( w->wrapTid.ntHandle )
#define WrapCall_Resume( w )      ResumeThread ( w->wrapTid.ntHandle )
#define WrapCall_SignalEvent( w ) SetEvent( w->wrapWakeupEvent )

static void
WrapCall_Terminate( struct wrapCall * w )
{
    HANDLE  h;
    EVENT_T e;

    WRAP_DPRINTF(w, ("wrapcall terminate\n"));

    h = w->wrapTid.ntHandle;
    if (h != INVALID_HANDLE_VALUE) {
	TerminateThread( h, 0 );
	w->wrapTid.ntHandle = INVALID_HANDLE_VALUE;
	CloseHandle( h );
    }

    e = w->wrapWakeupEvent;
    if (e) {
	w->wrapWakeupEvent = (EVENT_T)0;
	CloseHandle( e );
    }
    w->wrapState = WrapState_Idle;
}

/*
 * wrap-abort is done by letting the wrap thread execute the raiseSignalInterrupt code below,
 * which raises an exception, which is cought somewhere else in the wrap-threads loop.
 */
# define WRAP_EXCEPTION_SIGINT                  123  // EXCEPTION_NONCONTINUABLE_EXCEPTION
static void
raiseThreadSignalInterrupt()
{
    RaiseException( WRAP_EXCEPTION_SIGINT, EXCEPTION_NONCONTINUABLE, 0, 0 );
}

static void
WrapCall_Abort( struct wrapCall * w )
{
    DWORD   code;
    HANDLE  h = w->wrapTid.ntHandle;

    if (h == INVALID_HANDLE_VALUE) {
	return;
    }
    WRAP_DPRINTF(w, ("WrapCall_Abort\n"));

    if (GetExitCodeThread(h, & code) && (code == STILL_ACTIVE)) {
	CONTEXT context;

	WRAP_DPRINTF(w, ("WrapCall_Abort: STILL_ACTIVE\n"));
	if (w->wrapState == WrapState_Active) {
	    if (wrapCall_needsTerminateToAbort(w)) {
		WRAP_DPRINTF(w, ("WrapCall_Abort: terminate\n"));
		WrapCall_Terminate(w);
	    } else {
		WRAP_DPRINTF(w, ("WrapCall_Abort: Suspend wrapThread\n"));
		SuspendThread( h );

		if (w->wrapState == WrapState_Active) {
		    /* let the thread generate its own exception, change pc */
		    WRAP_DPRINTF(w, ("WrapCall_Abort: WrapState_Active\n"));
		    memset( & context, 0, sizeof(CONTEXT) );
		    context.ContextFlags = CONTEXT_FULL;

		    GetThreadContext( h, & context );

		    context.Eip = (DWORD) raiseThreadSignalInterrupt;

		    WRAP_DPRINTF(w, ("WrapCall_Abort: raise signal interrupt in %d\n", w->wrapTid.ntId));

		    w->wrapState = WrapState_Idle;
		    SetThreadContext( h, & context );
		}
		WRAP_DPRINTF(w, ("WrapCall_Abort: Resume wrapThread\n"));
		ResumeThread( h );
	    }
	}
    } else {
	/* thread not alive; force terminatation of the thread
	*/
	fprintf( stderr, "VM [warning]: oops - cannot abort wrapCall[%d]\n", w->wrapTid.ntId );
	fprintf( stderr, "VM [info]: Terminate [%d]\n", w->wrapTid.ntId );
	WrapCall_Terminate(w);
    }
}

#else

# ifdef USE_PTHREADS
static void
WrapCall_Terminate( struct wrapCall *w )
 {
    /* must not release mutex and condition; done in the cleanup routine of the thread
     */
    pthread_t h = w->wrapTid.pHandle;

    if ( h != INVALID_PID_VALUE ) {
	int err;

	w->wrapTid.pHandle = INVALID_PID_VALUE;

	printf( "WrapCall_Terminate\n" );
	err = pthread_cancel( h );
	pthread_join (h, NULL);
    }
}
#  define WrapCall_SignalEvent(w)         (pthread_cond_signal(& w->wrapWakeupEvent.cond) ? 0 : 1)
#  define WrapCall_Abort(w)               WrapCall_Terminate(w)

# else /* ! USE_PTHREADS */

#  define WrapCall_SignalEvent( w )       #error "missing code here"
#  define WrapCall_Terminate( w )         #error "missing_code_here"
#  define WrapCall_Abort( w )             WrapCall_Terminate( w )

# endif /* !USE_PTHREADS */
#endif

void
__freeWrapCall( struct wrapCall *w, int doTerminate, int callerLine )
{
    enum E_WrapUndoID wrapUndoID;
    int wrapActiveId = w->wrapActiveId;

    /* test whether wrapCall already freed; could happen caused by scheduling */
    if (w == (struct wrapCall *) 0) {
	return;
    }

    if (wrapActiveId == 0) {
	fprintf(stderr, "VM [warning]: oops - wrapactiveId is 0 in freeWrapCall (%s) [%d]\n", w->wrapFunctionName, callerLine);
	// goto putOnFreeListAndReturn;
	return;
    }

    WRAP_DPRINTF(w, ("freeWrapCall: doTerminate:%d [%d]\n", doTerminate, callerLine));

    if ( ! IS_VALID_THREAD (w->wrapTid)) {
	fprintf(stderr, "VM [warning]: not a valid thread in freeWrapCall (%s) [%d]\n", w->wrapFunctionName, callerLine);
	goto putOnFreeListAndReturn;
    }

    switch (doTerminate) {
	case FREEWRAP_DO_NOT_TERMINATE:
	    w->wrapActiveId = 0;
	    w->process = 0;
	    w->wrapUndoID = WrapUndoID_none;
	    if (w->wrapState != WrapState_Active) {
		break;
	    }
	    /* not terminated but thread state is active
	     * let the thread finish its work and than make the undo operation if neccassary
	     */
	    fprintf(stderr, "VM [warning]: FREEWRAP_DO_NOT_TERMINATE and wrap still active (%s) [%d]\n", w->wrapFunctionName, callerLine);

	    /* fall into */
	case FREEWRAP_DO_TERMINATE:
	    w->wrapActiveId = 0;
	    w->process = 0;
	    wrapUndoID = wrapCall_getUndoId( w );
	    if (wrapUndoID == WrapUndoID_none) {
		/* no undo operation required, thus we can abort the thread */
		WrapCall_Abort(w);
		break;
	    }
#ifdef WIN32
	    /* soft termination; try to reuse the thread */
//            WRAP_DPRINTF(w, ("suspend wrapThread\n") );
//            WrapCall_Suspend(w);
	    w->wrapUndoID = wrapUndoID;
//            WRAP_DPRINTF(w, ("resume wrapThread\n") );
//            WrapCall_Resume(w);

	    /* set signal to run undo operation after thread has finished
	     * the current operation;
	     * after the undo, the wrap places itself to the free list.
	     */
	    if (WrapCall_SignalEvent(w)) {
		int i;

		WRAP_DPRINTF(w, ("signalEvent ok; wrapState=%s\n", WrapStateName(w->wrapState)));
		for (i = 3000; i ; --i) {
		    if (w->wrapState == WrapState_Idle) {
			WRAP_DPRINTF(w, ("idle after undo\n"));
			break;
		    }
		    Sleep(0);
		}
		WRAP_DPRINTF(w, ("wrapState=%s\n", WrapStateName(w->wrapState)));
		return;
	    }

	    /* signalEvent error: must terminate the thread and release the event */
	    WRAP_DPRINTF(w, ("signalEvent failed - terminate\n"));
#endif /* WIN32 */
	    WrapCall_Terminate( w );
	    break;

	case FREEWRAP_DELAY_TERMINATE_FOR_RECALL:
	    /* let the wrap finish its API call - expect immediate recalling due to
	     * ST-primitive code looping on EINTR
	     * The wrap will be eventually freed, when another API call is performed by
	     * that thread (or the thread dies)
	     */
	    WRAP_DPRINTF(w, ("DELAY_TERMINATE_FOR_RECALL\n"));
	    return;
    }

  putOnFreeListAndReturn: ;
    w->ret  = (void *) -1;

    EnterShortCriticalSection(&wrapFreeListSection);
	if (cachedFreeWrapCall == 0) {
	    cachedFreeWrapCall = w;
	} else {
	    w->next = freeWrapCallList;
	    freeWrapCallList = w;
	}
    LeaveShortCriticalSection(&wrapFreeListSection);
}

/*
 * Allcate a wrap call structure, create an wrap thread
 * and an wait event.
 *
 * Answer the wrap call structure.
 *
 * ATTENTION: the code below only works if there is only one smalltalk-thread active at any time
 * otherwise, if multithreading is ever brought to smalltalk threads, the cachedFreeWrapCall stuff must be
 * removed
 */
static struct wrapCall *
newWrapCall(int debug)
{
    static unsigned int s_wrapActiveId = 0;
    REGISTER struct wrapCall *w;

    w = cachedFreeWrapCall;
    if (w) {
	cachedFreeWrapCall = 0;
    } else {
	EnterShortCriticalSection (&wrapFreeListSection);

	if (! freeWrapCallList) {
	    getWrapCallChunk();

	    if (! freeWrapCallList) {
		LeaveShortCriticalSection (&wrapFreeListSection);
		return (0);
	    }
	}
	w = freeWrapCallList;
	freeWrapCallList = w->next;

	LeaveShortCriticalSection (&wrapFreeListSection);
    }

    if ( ++s_wrapActiveId == 0 ) {    /* add a 'unique' wrap identifier */
	s_wrapActiveId = 1;
    }

    w->wrapActiveId = s_wrapActiveId;
    w->next         = NULL;
    w->process      = NULL;
    w->ret          = (void *) -1;

    if (! IS_VALID_THREAD(w->wrapTid)) {
	w->wrapState = WrapState_Wait;
	w->debug = debug;

#ifdef USE_WIN32THREADS
	{
	/* first create the synchronization event; can be reused if the
	   thread creation failed and thread is started in running mode
	*/
	if (w->wrapWakeupEvent == (EVENT_T) 0) {
	    w->wrapWakeupEvent = CreateEvent(&saDefault, FALSE, FALSE, 0);;

	    if (! w->wrapWakeupEvent) {
		fprintf( stderr, "VM [error]: CreateEvent error %d [%s %d]\n", GetLastError(), __FILE__, __LINE__ );
		__freeWrapCall( w, FREEWRAP_DO_NOT_TERMINATE, __LINE__ );
		return  0;
	    }
	}

	w->wrapTid.ntHandle = CreateThread(&saDefault,
					   WRAPSTACKSIZE,
					   (LPTHREAD_START_ROUTINE)wrapProc,
					   (void *) w,
					   0,
					   &(w->wrapTid.ntId));

	if (w->wrapTid.ntHandle == INVALID_HANDLE_VALUE) {
	    fprintf(stderr, "VM [error]: wrapThreadNTCreate fails with %d\n", GetLastError());
	    __freeWrapCall( w, FREEWRAP_DO_NOT_TERMINATE, __LINE__ );
	    return 0;
	}
# ifdef HIGH_PRIO_API_THREAD
	SetThreadPriority( w->wrapTid.ntHandle, THREAD_PRIORITY_TIME_CRITICAL );
# endif
	}
#else /* !USE_WIN32THREADS */

# ifdef USE_PTHREADS
	if (pthread_mutex_init (& w->wrapWakeupEvent.mutex, NULL)) {
	    fprintf(stderr, "VM [error]: pthread_mutex_init fails with %d\n", GetLastError());
	    return( 0 );
	}
	if (pthread_cond_init(& w->wrapWakeupEvent.cond, NULL)) {
	    fprintf(stderr, "VM [error]: pthread_cond_init fails with %d\n", GetLastError());
	    pthread_mutex_destroy (& w->wrapWakeupEvent.mutex);
	    return( 0 );
	}
	/* claus
	setupSignalHandler();
	*/
	if (pthread_create (& w->wrapTid.pHandle, NULL, (void *) wrapProc, (void *) w)) {
	    fprintf(stderr, "VM [error]: pthread_create fails with %d\n", errno);
	    pthread_cond_destroy  (& w->wrapWakeupEvent.cond);
	    pthread_mutex_destroy (& w->wrapWakeupEvent.mutex);
	    return( 0 );
	}
	w->wrapTid.pId = (int) w->wrapTid.pHandle;
# else  /* ! USE_PTHREADS */
#       error "missing code here"
# endif /* ! USE_PTHREADS */
#endif  /* ! USE_WIN32THREADS */

	/* give wrap thread a chance to start;
	 * set the wrapState to WrapState_Wait before creating the thread.
	 * The thread will set it to WrapState_Idle when ready.
	 */
	if (w->wrapState != WrapState_Idle) {
	    int maxRepeat;

	    for ( maxRepeat = 3000; maxRepeat > 0; maxRepeat--) {
		if (w->wrapState == WrapState_Idle) {
		    break;
		}
		Sleep(0);
	    }
	    if (w->wrapState != WrapState_Idle) {
		fprintf(stderr, "VM [error]: wrapThread did not enter Wait state\n");
	    }
	}
    }
    return w;
}

/*
 * returns true(1) if the wrapCall must be performed within a global critical region.
 * This protects global data structures (such as non-thread-safe stdio buffers).
 */
static int
wrapCall_isCritical ( struct wrapCall * w )
{
    char *fname = w->wrapFunctionName;

    if (! fname)
	return (0);

    switch (w->callType) {
#ifdef WRAP_WINAPI
	case WRAP_WINAPI:
	    break;
#endif /* __WRAP_WINAPI */

#ifdef WRAP_SOCKAPI
	case WRAP_SOCKAPI:
	    break;
#endif /* WRAP_SOCKAPI */

	case WRAP_CAPI:
	default:
	    if (strcmp(fname, "fopen") == 0) return (1);
	    if (strcmp(fname, "wfopen") == 0) return (1);
	    if (strcmp(fname, "fdopen") == 0) return (1);
	    if (strcmp(fname, "fclose") == 0) return (1);
	    if (strcmp(fname, "fseek") == 0) return (1);
	    break;
    }
    return (0);
}

/*
 * returns true(1) if the wrapCall must be terminated instead of longjumped in order to
 * abort the operation.
 */
static int
wrapCall_needsTerminateToAbort ( struct wrapCall * w )
{
    char *fname = w->wrapFunctionName;

    if (! fname)
	return (0);

    switch (w->callType) {
#ifdef WRAP_WINAPI
	case WRAP_WINAPI:
	    if (strcmp(fname, "GetOpenFileName") == 0) return (1);
	    if (strcmp(fname, "GetSaveFileName") == 0) return (1);
	    break;
#endif /* __WRAP_WINAPI */

#ifdef WRAP_SOCKAPI
	case WRAP_SOCKAPI:
	    break;
#endif /* WRAP_SOCKAPI */

	case WRAP_CAPI:
	default:
	    break;
    }
    return (0);
}

/*
 * returns an identifier for the undo operation.
 * If no undo operation is required, e_WrapUndoID_none is returned.
 */
static enum E_WrapUndoID
wrapCall_getUndoId( struct wrapCall * w )
{
#ifndef NO_WRAP_UNDO
    char *fname = w->wrapFunctionName;

    if (! fname)
	return (WrapUndoID_none);

    switch (w->callType) {
# ifdef WRAP_WINAPI
	case WRAP_WINAPI:
	    if (strncmp(fname, "FindFirstFile", sizeof("FindFirstFile")) == 0)
		return (WrapUndoID_FindClose);
	    if (strncmp(fname, "CreateFile", sizeof("CreateFile")) == 0)
		return (WrapUndoID_CloseHandle);

	    break;
# endif /* WRAP_WINAPI */

# ifdef WRAP_SOCKAPI
	case WRAP_SOCKAPI:
	    if (strcmp(fname, "socket") == 0)
		return (WrapUndoID_closesocket);
#  ifdef USE_DISCONNECT_EX
	    if (strcmp(fname, "connect") == 0)
		return (WrapUndoID_disconnect /* WrapUndoID_shutdown */);
#  endif /* USE_DISCONNECT_EX */
	    break;
# endif /* WRAP_SOCKAPI */

	default:
	    if (strcmp(fname, "fopen") == 0) return (WrapUndoID_fclose);
	    if (strcmp(fname, "wfopen") == 0) return (WrapUndoID_fclose);
	    if (strcmp(fname, "fdopen") == 0) return (WrapUndoID_fclose);
	    break;
    }
#endif /* ! NO_WRAP_UNDO */
    return (WrapUndoID_none);
}

/*
 * perform the undo operation; the critical region is setup
 * within an exception handler.
 */
static void
wrapCall_doUndoProc( struct wrapCall * w, enum E_WrapUndoID wrapUndoID )
{
    void *ret = w->ret;
    int retVal;

    switch (wrapUndoID) {
	case WrapUndoID_fclose:
	    if ((INT)ret <= 0) {
		WRAP_DPRINTF(w, ("wrapUndo fclose(%d) suppressed (previous ret <= 0)\n", ret));
		break;
	    }
	    WRAP_DPRINTF(w, ("wrapUndo fclose(%d)\n", ret));
	    retVal = fclose (ret);
	    WPRINTF(( "VM [info]: UNDO <fclose> wrap:%x stream:%x -> %d\n", w, ret, retVal ));
	    break;

#ifdef WIN32
	case WrapUndoID_CloseHandle:
	    if (ret == INVALID_HANDLE_VALUE) {
		WRAP_DPRINTF(w, ("wrapUndo CloseHandle(%d) suppressed (previous ret == INVALID_HANDLE_VALUE)\n", ret));
		break;
	    }
	    WRAP_DPRINTF(w, ("wrapUndo CloseHandle(%d)\n", ret));
	    retVal = CloseHandle (ret);
	    WPRINTF(( "VM [info]: UNDO <CloseHandle> wrap:%x handle:%x -> %d\n", w, ret, retVal ));
	    break;

	case WrapUndoID_closesocket:
	    if ((INT)ret <= 0) {
		WRAP_DPRINTF(w, ("wrapUndo closesocket(%d) suppressed (previous ret <= 0)\n", ret));
		break;
	    }
	    WRAP_DPRINTF(w, ("wrapUndo closesocket(%d)\n", ret));
	    retVal = closesocket((SOCKET) ret);
	    WPRINTF(( "VM [info]: UNDO <closesocket> wrap:%x stream:%x -> %d\n", w, ret, retVal ));
	    break;

	case WrapUndoID_FindClose:
	    if ((INT)ret <= 0) {
		WRAP_DPRINTF(w, ("wrapUndo FindClose(%d) suppressed (previous ret <= 0)\n", ret));
		break;
	    }
	    WRAP_DPRINTF(w, ("wrapUndo FindClose(%d)\n", ret));
	    retVal = FindClose ((HANDLE) ret);
	    WPRINTF(( "VM [info]: UNDO <FindClose> wrap:%x handle:%x -> %d\n", w, ret, retVal ));
	    break;

	case WrapUndoID_shutdown:
	    if ((INT)ret < 0) {
		WRAP_DPRINTF(w, ("wrapUndo shutdown(%d) suppressed (previous connect ret < 0)\n", w->arg[0]));
		break;
	    }
	    WRAP_DPRINTF(w, ("wrapUndo shutdown(%d)\n", w->arg[0]));
	    retVal = shutdown ((SOCKET) w->arg[0], 2);
	    WPRINTF(( "VM [info]: UNDO <shutdown> wrap:%x handle:%x -> %d\n", w, w->arg[0], retVal ));
	    break;

# ifdef USE_DISCONNECT_EX
	case WrapUndoID_disconnect:
	    if ((INT)ret < 0) {
		WRAP_DPRINTF(w, ("wrapUndo disconnect(%d) suppressed (previous connect ret < 0)\n", w->arg[0]));
		break;
	    }
	    WRAP_DPRINTF(w, ("wrapUndo disconnect(%d)\n", w->arg[0]));
	    retVal = DisconnectEx ((SOCKET) w->arg[0], (LPOVERLAPPED)0, TF_REUSE_SOCKET, 0);
	    WPRINTF(( "VM [info]: UNDO <disconnect> wrap:%x handle:%x -> %d\n", w, w->arg[0], retVal ));
	    break;
# endif /* USE_DISCONNECT_EX */

#endif /* WIN32 */
    }
}

# ifdef USE_PTHREADS

static void
pthread_cleanUp( w )
    struct wrapCall * w;
{
    /*
     * setup cleanup-routine for a thread; release mutex and condition
     */
    WPRINTF(( "VM [info]: pthread_cleanUp[%d]: release mutex & condition\n", w->wrapTid.pHandle ));

    pthread_mutex_destroy (& w->wrapWakeupEvent.mutex);
    pthread_cond_destroy  (& w->wrapWakeupEvent.cond);

    w->wrapTid.pHandle = INVALID_PID_VALUE;
    w->wrapState = WrapState_Idle;
}
# endif /* USE_PTHREADS */



#ifdef WIN32

static int
__wrapExceptionFilter(struct wrapCall *w, EXCEPTION_POINTERS *xp)
{
    /* exception handling used by the wrapCall; tests for signal abort...
       always returns EXCEPTION_EXECUTE_HANDLER!!!
    */
    if (w == NULL) {
	fprintf( stderr, "VM [warning]: wrapExptionFilter with NULL wrapStruct\n");
	return (EXCEPTION_EXECUTE_HANDLER);
    }

    WRAP_DPRINTF(w, ("wrapExptionFilter\n"));

    if (w->wrapState == WrapState_Idle) {
	if (w->wrapActiveId) {
	    fprintf( stderr, "VM [warning]: wrapCall %s interrupted but finished (ret := %d)\n"
			   , w->wrapFunctionName, w->ret );
	}
	/* keep state... might be used by the undoOperation
	*/
	return (EXCEPTION_EXECUTE_HANDLER);
    }
    w->wrapState = WrapState_Idle;
    w->ret       = (void *) -1;
    w->wrapErrno = EINTR;

    /* test whether signal is raised due to a wrap interrupt
    */
    if (w->wrapActiveId) {
	/* test whether signal is raised due to a wrap interrupt
	*/
	if (xp->ExceptionRecord->ExceptionCode != WRAP_EXCEPTION_SIGINT) {
	    w->wrapErrno = __WIN32_ERR( GetLastError() );

	    if (w->wrapActiveId) {
		__printExceptionInfo(1, xp);
	    }
	}
    }
    return (EXCEPTION_EXECUTE_HANDLER);
}

/*
 * Perform a API/C/Socket call as defined in the wrapCall w.
 * May be called both synchronously by a smalltalk thread and
 * asynchronously by a wrap thread.
 */

static void
doWrapProc( struct wrapCall *w, void **argPtrOrNull )
{
    /* if the arg pointer not nil, we are using those arguments,
     * so we don't have to copy the argument list for the scheduler
     * into the wrap
     */
    void *  ret = (void *) -1;
    void ** arg = argPtrOrNull ? argPtrOrNull : w->arg;

    w->ret       = ret;
    w->wrapErrno = 0;

    WRAP_DPRINTF(w, ("doWrapProc: calling\n"));

    switch (w->callType) {
# ifdef WIN32
	case WRAP_SOCKAPI:
	    if (! WSAInitialized) {
		WSADATA wsaData;

		WSAInitialized = 1;
		WSAStartup( MAKEWORD( 1, 1 ), &wsaData );
	    }
	    /* fall into */

	case WRAP_WINAPI:
	    /*
	     * WINAPI calling
	     */
	    switch(w->argc) {
		case 0 : ret = ((_wrapWINAPI0) w->wrapFunction)(); break;
		case 1 : ret = ((_wrapWINAPI1) w->wrapFunction)(arg[0]); break;
		case 2 : ret = ((_wrapWINAPI2) w->wrapFunction)(arg[0],arg[1]); break;
		case 3 : ret = ((_wrapWINAPI3) w->wrapFunction)(arg[0],arg[1],arg[2]); break;
		case 4 : ret = ((_wrapWINAPI4) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3]); break;
		case 5 : ret = ((_wrapWINAPI5) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4]); break;
		case 6 : ret = ((_wrapWINAPI6) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5]); break;
		case 7 : ret = ((_wrapWINAPI7) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6]); break;
		case 8 : ret = ((_wrapWINAPI8) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7]); break;
		case 9 : ret = ((_wrapWINAPI9) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8]); break;
		case 10: ret = ((_wrapWINAPI10)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9]); break;
		case 11: ret = ((_wrapWINAPI11)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10]); break;
		case 12: ret = ((_wrapWINAPI12)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11]); break;
		case 13: ret = ((_wrapWINAPI13)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11],arg[12]); break;
		case 14: ret = ((_wrapWINAPI14)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11],arg[12],arg[13]); break;

		default:
		    fprintf(stderr, "VM [error]: wrapCall %s too many args: %d\n"
				  , w->wrapFunctionName, w->argc);
		    w->ret = (void *)-1;
		    w->wrapErrno = EINVAL;
		    return;
	    }
	    if (ret < 0) {
		switch (w->callType) {
		    case WRAP_SOCKAPI:
			w->wrapErrno = __WIN32_ERR(WSAGetLastError());
			break;

		    default:
			w->wrapErrno = __WIN32_ERR(GetLastError());
			break;
		}
	    }
	    break;
# endif /* WIN32 */

	default:
	    /*
	     * C calling
	     */
	    errno = 0;

	    switch(w->argc) {
		case  0: ret = ((_wrap0) w->wrapFunction)(); break;
		case  1: ret = ((_wrap1) w->wrapFunction)(arg[0]); break;
		case  2: ret = ((_wrap2) w->wrapFunction)(arg[0],arg[1]); break;
		case  3: ret = ((_wrap3) w->wrapFunction)(arg[0],arg[1],arg[2]); break;
		case  4: ret = ((_wrap4) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3]); break;
		case  5: ret = ((_wrap5) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4]); break;
		case  6: ret = ((_wrap6) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5]); break;
		case  7: ret = ((_wrap7) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6]); break;
		case  8: ret = ((_wrap8) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7]); break;
		case  9: ret = ((_wrap9) w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8]); break;
		case 10: ret = ((_wrap10)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9]); break;
		case 11: ret = ((_wrap11)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10]); break;
		case 12: ret = ((_wrap12)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11]); break;
		case 13: ret = ((_wrap13)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11],arg[12]); break;
		case 14: ret = ((_wrap14)w->wrapFunction)(arg[0],arg[1],arg[2],arg[3],arg[4],arg[5],arg[6],arg[7],arg[8],arg[9],arg[10],arg[11],arg[12],arg[13]); break;

		default:
		    fprintf(stderr, "VM [error]: wrapCall %s too many args: %d\n"
				  , w->wrapFunctionName, w->argc);
		    w->ret = (void *)-1;
		    w->wrapErrno = EINVAL;
		    return;
	    }
	    w->wrapErrno = errno;
	    break;
    }
    WRAP_DPRINTF(w, ("doWrapProc: -> %d (0x%x) errno=%d\n",
			ret, ret, w->wrapErrno));
    w->ret = ret;
}



# ifdef __BORLANDC__
#  pragma option push -x /* enable exception handling */
# endif

/*
 * The start procedure called in a wrap thread.
 * Wait for the wrap synchronization event, and perform the call API/C/Socket call
 * as defined in the wrapCall structure.
 *
 * non-static in order to show the start procedure
 * as a symbol in process explorer
 */
void
wrapProc( struct wrapCall * w )
{
    struct process * p;
    unsigned int   activeId   = 0;
    int            hasRunUndo = 0;
    int            inCritical = 0;
    int            ntId;

#ifdef WIN32
    ntId = w->wrapTid.ntId;

restartWrapProc:
    __try {

#else /* !WIN32 */
# ifdef USE_PTHREADS
	ntId = w->wrapTid.pId;

	pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
	pthread_setcanceltype (PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
	pthread_cleanup_push  ( pthread_cleanUp, (void *) w );
# else  /* !USE_PTHREADS */
#   error "missing_code_here"
# endif /* !USE_PTHREADS */
#endif  /* !WIN32 */

	WPRINTF(( "VM [info]: wrapThread[%d] started stack: %08x\n", ntId, & w ));

	w->wrapState = WrapState_Idle;

	while (1) {
	    int waitFailed = 0;

	    if (inCritical) {
		inCritical = 0;
		LeaveShortCriticalSection(&wrapCallCritical);
	    }

	    if (hasRunUndo) {
		hasRunUndo = 0;

		/* free the wrapCall after the undo
		*/
		WRAP_DPRINTF(w, ("freeing wrapStruct for undone wrap\n"));
		w->debug         = 0;
		w->wrapUndoID    = WrapUndoID_none;
		w->wrapState     = WrapState_Idle;
		w->ret           = (void *) -1;

		EnterShortCriticalSection(&wrapFreeListSection);
		    w->next          = freeWrapCallList;
		    freeWrapCallList = w;
		LeaveShortCriticalSection(&wrapFreeListSection);
	    } else {
		if (activeId && (activeId == w->wrapActiveId) ) {
		    WRAP_DPRINTF3(w, ("activeId: %d\n", activeId));
		    EnterShortCriticalSection(&wrapSection);

		    p = w->process;
		    if (p) {
			p->mustBeResumedAfterWrap = 1;

#ifdef NATIVETHREADS
			if (__schedulerProcess) {
			    __schedulerProcess->anyProcessMustBeResumedAfterWrap = 1;
			}
#endif
		    }
		    LeaveShortCriticalSection(&wrapSection);
		} else {
		    WRAP_DPRINTF(w, ("activeID:%d w->wrapActiveId:%d w->process:%x\n",
				 activeId, w->wrapActiveId, w->process));
		}
	    }

	    /* wait for the syncronization event.
	     * If this failes, the wrap thread is terminated.
	     *  the smalltalk thread can read now the result during waiting !!
	     */
#ifdef WIN32
	    if (WAIT_FAILED == WaitForSingleObject (w->wrapWakeupEvent, INFINITE)) {
		fprintf( stderr, "VM [error]: wrapWaitEvent error %d\n", GetLastError() );
		waitFailed = 1;
	    }
#else /* !WIN32 */
# ifdef USE_PTHREADS
	    if (pthread_cond_wait ( & w->wrapWakeupEvent.cond, & w->wrapWakeupEvent.mutex)) {
		fprintf(stderr, "VM [error]: pthread_cond_wait error %d\n", errno);
		waitFailed = 1;
	    }
# else
#           error "missing code here"
# endif
#endif /* !WIN32 */

	    if (waitFailed) {
		/*
		 * close event and terminate thread; simulate an EINTR signal
		 */
		w->ret       = (void *) -1;
		w->wrapErrno = EINTR;
		w->wrapState = WrapState_Idle;
#ifdef WIN32
		{
		    EVENT_T e;
		    HANDLE  h;

		    e = w->wrapWakeupEvent;
		    if (e) {
			w->wrapWakeupEvent = (EVENT_T)0;
			CloseHandle (e);
		    }

		    h = w->wrapTid.ntHandle;
		    if (h != INVALID_HANDLE_VALUE) {
			w->wrapTid.ntHandle = INVALID_HANDLE_VALUE;
			CloseHandle (h);
		    }
		}
		SDPRINTF(("ExitThread [%d]\n", __LINE__));
		ExitThread( -1 );
#else /* ! WIN32 */
# ifdef USE_PTHREADS
		/* release resources is done in the pthread_cleanUp() routine
		*/
		w->wrapTid.pHandle = INVALID_PID_VALUE;
		w->wrapTid.pId     = INVALID_PID_VALUE;
		pthread_exit(0);
# else /* !USE_PTHREADS */
#               error "missing code here"
# endif /* !USE_PTHREADS */
#endif /* ! WIN32 */
		/* never reached; thread has terminated itself */
	    }

	    /*
	     * If we come here, we have got a wrap call request
	     */

	    if (w->wrapUndoID == WrapUndoID_none) {
		w->ret       = (void *) -1;
		w->wrapErrno = EINTR;
		activeId     = w->wrapActiveId;

		if (activeId) {
		    if (wrapCall_isCritical (w)) {
			EnterShortCriticalSection(&wrapCallCritical);
			inCritical = 1;
		    }

		    /*
		     * test whether wrap still is active after waiting for the lock
		     */
		    if (activeId == w->wrapActiveId) {
			w->wrapState = WrapState_Active;
#  ifdef HIGH_PRIO_API_THREAD_INTERFACE
			SetThreadPriority( w->wrapTid.ntHandle, THREAD_PRIORITY_NORMAL );
#  endif
			doWrapProc(w, 0);
		    }
		} else {
		    WRAP_DPRINTF(w, ("wrapCall[%d] cancelled before started\n", ntId) );
		}
	    } else {
		/*
		 * An undo-operation has been requested.
		 * Perform the undo operation always within a critical region
		 */
		WRAP_DPRINTF(w, ("undoID is %d; ret is %d\n", w->wrapUndoID, w->ret));

		hasRunUndo = 1;
		activeId   = w->wrapActiveId = 0;

		/* test result before undo, if the result < 0 we do not need to
		 * perform the undo operation and do not need the lock
		 */
		if (w->ret >= (void *) 0) {
		    EnterShortCriticalSection(&wrapCallCritical);
		    inCritical = 1;
		    wrapCall_doUndoProc( w, w->wrapUndoID );
		} else {
		    WRAP_DPRINTF(w, ("no undo (ret < 0)un\n"));
		}
	    }
	    w->wrapState = WrapState_Idle;
	}

#ifdef WIN32
    }
    __except( __wrapExceptionFilter (w, GetExceptionInformation()) )
    {
	w->wrapState = WrapState_Idle;

	if (activeId && (activeId == w->wrapActiveId)) {
	    /* wrap call has been aborted */

	    fprintf(stderr, "VM [Exception]:in wrapCall[%d] f=%s (%s%x)\n"
		, ntId, w->wrapFunctionName
		, w->callType ? "WAPI-":"C-"
		, w->wrapFunction
		);
	} else {
	    activeId = 0;
	    WRAP_DPRINTF(w, ("wrapCall interrupted\n"));
	}
    }
    goto restartWrapProc;
#else /* ! WIN32 */
# ifdef USE_PTHREADS
    /* never called but used because of pthread_cleanup_push() */
    pthread_cleanup_pop( 0 );
# else /* ! USE_PTHREADS */
#   error "missing_code_here"
# endif  /* ! USE_PTHREADS */
#endif  /* ! WIN32 */
}

#ifdef __BORLANDC__
# pragma option pop   /* no exception handling after this line */
#endif

# endif /* WIN32 */


enum E_WrapHow {
    e_StartWrap,
    e_ResumeWrap
};

/*
 * perform the wrapCall w for the smalltalk process p
 */

static int
__wrapCall(struct process *p, struct wrapCall *w, enum E_WrapHow how)
{
    int i, retVal;
    unsigned int wrapActiveId;
    char *wrapFunctionName = w->wrapFunctionName;
    int debug = w->debug;

    if (how == e_StartWrap) {
	WRAP_DPRINTF(w, ("start wrapCall in process %d\n", p->id));

	p->_wrapCall = w;

	w->process   = 0;
	w->wrapErrno = 0;

	/* set state to WrapState_Wait; wrapThread will
	   change from active (executing) to idle (finished)
	*/
	w->wrapState = WrapState_Wait;

#  ifdef HIGH_PRIO_API_THREAD_INTERFACE
	SetThreadPriority( w->wrapTid.ntHandle, THREAD_PRIORITY_TIME_CRITICAL );
#  endif
	/*
	 * Tell the wrap thread that it should start to work
	 */
	if (WrapCall_SignalEvent(w) == 0) {
	    /*
	     * somebody else terminated the wrap thread.
	     * Cleanup and signal an error.
	     */
	    fprintf(stderr, "VM [error]: wrap SetEvent error\n");

	    WrapCall_Terminate(w);

	    p->_wrapCall  = NULL;

	    if (p->_freeWrapCall == NULL) {
		p->_freeWrapCall = w;
	    } else {
		__freeWrapCall( w, FREEWRAP_DO_NOT_TERMINATE, __LINE__ );
	    }
	    __threadErrno = EINTR;
	    return -1;
	}
    }

# if defined(HIGH_PRIO_API_THREAD) || defined(HIGH_PRIO_API_THREAD_INTERFACE)
    /*
     * already finished ?
     * checking this only makes sense for multi-cpu machines
     * or High-prio API threads;
     * Otherwise, chances are *very* small, that the api thread ever
     * had a chance here to execute already.
     */
    for (i = 10; i ; --i) {
	if (w->wrapState == WrapState_Idle) {
	    WRAP_DPRINTF3(w, ("already idle\n"));
	    goto wrapCallDone;
	}
	Sleep(0);
    }
# endif /* HIGH_PRIO_API_THREAD */

    /* lock the wrapCall to wakeup the smalltalk process to be finished;
     * if w->process is set, the process might be informed but we will
     * free the operation due to the execution done (WrapState_Idle).
     */
    EnterShortCriticalSection(&wrapSection);

    if (w->wrapState == WrapState_Idle) {
	LeaveShortCriticalSection(&wrapSection);
	goto wrapCallDone;
    }

    /*
     * Apparantly the wrap thread needs some time to perform the wrap call.
     * Put the smalltalk process to sleep until the wrap thread has finished its task.
     */

    p->suspended = SUSP_2;
    w->process   = p;
    wrapActiveId = w->wrapActiveId;

    LeaveShortCriticalSection(&wrapSection);
#if 0
    if (! __thisContext) {
	fprintf(stderr, "VM [warning]: no context at wrap time\n");
    } else {
	__PATCHUPCONTEXTS(__thisContext);
	/* how about: SET_stackValid(p) ? */
    }
#endif
    /*
     * wait for the wrap to finish ..., switch to scheduler
     */
    WRAP_DPRINTF(w, ("threadSwitch from %d\n", p->id));

    (void) ____threadSwitch(__thisContext, THREADSWITCH_SUSPEND_CURRENT, THREADSWITCH_NO_SINGLE_STEP, __LINE__, debug);

    WRAP_DPRINTF(w, ("back after threadSwitch\n"));

    /*
     * ...some time passed (and some other process was running).
     * Arrive here, when either the wrap call finished,
     * or the wrap-call has been interrupted.
     */
    if ((w == p->_wrapCall) && (w->wrapActiveId == wrapActiveId)) {
	if (w->wrapState == WrapState_Idle) {
	    /* the wrap call has been finished */
	    if (p->suspended != NOT_SUSPENDED) {
		fprintf(stderr, "VM [warning]: suspended-flag(%d) is not NOT_SUSPENDED after completed wrapCall.\n", p->suspended);
	    }
wrapCallDone:
	    retVal        = (int) w->ret;
	    w->ret        = (void *) -1;
	    __threadErrno = w->wrapErrno;
	    p->_wrapCall  = NULL;

	    if (p->_freeWrapCall == NULL) {
		p->_freeWrapCall = w;
	    } else {
		__freeWrapCall( w, FREEWRAP_DO_NOT_TERMINATE, __LINE__ );
	    }
	    return (retVal);
	}
	/*
	 * state of wrap call is not idle, so the smalltalk process must have been interrupted
	 * Terminate the wrap thread, if the call may be interrupted.
	 */
	if (w->interruptable) {
	    fprintf( stderr, "VM [info]: wrap still in API(C)-call after wrap-resume\n" );
	    __freeWrapCall( w, FREEWRAP_DO_TERMINATE, __LINE__ );
	}
    } else {
	/*
	 * Yes - we can arrive here, if we have been interrupted and another wrap call
	 * has been performed during the interrupt.
	 */
	if (w != p->_wrapCall) {
	    fprintf( stderr, "VM [info]: wrapCall change (%s)\n", wrapFunctionName);
	} else {
	    fprintf( stderr, "VM [info]: activeID change (%s)\n", wrapFunctionName);
	}
    }

    WRAP_DPRINTF(w, ("-> EINTR\n"));
    __threadErrno = EINTR;
    return -1;
}

# ifdef WIN32
/*
 * stored information to test whether a wrapCall must run
 * within a thread or can be executed immediately
 */
static HANDLE noWrap_findFileHandle     = (HANDLE)0;
static char   noWrap_fileVolumn         = (char)0;
static int    noWrap_fileCurrentIsFast  = (int)0;

static int
fileIsKnownToBeOnANonBlockingDrive(char *path)
{
#if 1
    /* 2010-02-22 / SV: Try to avoid problems with interrupted threads.
     * Hanging on a remote disk is better than corrupted kernel state :-(
     */
    return 1;
#else
    if (path != NULL) {
	char c0 = path[0];

	if (c0) {
	    char c1 = path[1];

	    if (c1 == ':') {
		if (c0 == noWrap_fileVolumn) {
		    return 1;
		}
		if (c0 == 'c' || c0 == 'C') {
		    return 1;
		}
	    } else if (noWrap_fileCurrentIsFast) {
		if (! ((c0 == '\\') && (c1 == '\\'))) {
		    return 1;
		}
	    }
	}
    }
    return 0;
#endif
}

static void
rememberPathAsNonBlocking(char *path)
{
    if (path) {
	char c0 = path[0];

	if (c0) {
	    char c1 = path[1];

	    if (c1 == ':') {
		noWrap_fileVolumn = c0;
	    } else if (! ((c0 == '\\') && (c1 == '\\'))) {
		noWrap_fileCurrentIsFast = 1;
	    }
	}
    }
}
# endif /* WIN32 */

enum E_KnownFunction {
      e_unknown = 0,
# ifdef WIN32
      e_isCreateFile,
      e_isGetFileAttributes,
      e_isFindFirstFile,
      e_isFindNextFile,
      e_isGetFullPathName,
      e_isGetLongPathName,
# endif /* WIN32 */
      e_isFopen,
      e_isFdopen,
};

/*
 * This is performed by a stx process to invoke a possibly wrapped API/C/Socket function.
 * Macros are wrapped to this function.
 */

static int
doWrapCallN(int callTypeAndFlags, char *nm, wrapFunction_t f, int nArgs, void **argPtr)
{
# ifdef WIN32
#  ifdef CACHE_GETFILEATTRIBUTES
    static char   cashed_fileAttributesName[1024] = { 0 };
    static DWORD  cashed_fileAttributes;
#  endif
    enum E_KnownFunction knownFunction = e_unknown;
# endif /* WIN32 */

    REGISTER struct process *p = __currentProcess;
    struct wrapCall * w;
    struct wrapCall   ws;

    int debug = 0;
    int ret = -1;
    int i;
# ifdef SYNCHRONOUS_API_CALLS
    int doWithoutThread = 1;
# else
    int doWithoutThread = 0;
# endif
    int callType = callTypeAndFlags & WRAP_API_MASK;
    int flags = callTypeAndFlags & ~WRAP_API_MASK;
    void *arg0 = NULL;
# ifdef DEBUG_WRITE_BUFFER
    char savedData[1024];
# endif

# ifdef SUPERDEBUG
    if (! p) {
	fprintf(stderr, "VM [warning]: wrapCall failed: no currentProcess\n");
	__threadErrno = ECHILD;
	return -1;
    }
# endif

    if ((w = p->_wrapCall) != NULL) {
	WRAP_DPRINTF(w, ("leftover old wrap thread state=%s\n", WrapStateName(w->wrapState)));

	if (! w->interruptable) {
	    if ((w->argc == nArgs)
	     && (w->callType == callType)
	     && (w->wrapFunction == f)
	     && (flags & WRAP_NO_INTERRUPT) ) {
		WRAP_DPRINTF(w, ("same old wrap again\n"));
		/* the same wrapCall again (obviously after EINTR) */
		ret = __wrapCall(p, w, e_ResumeWrap);
		return ( ret );
	    }
	}
	WRAP_DPRINTF(w, ("terminate leftover old wrap thread\n"));
	p->_wrapCall = NULL;
	__freeWrapCall(w, FREEWRAP_DO_TERMINATE, __LINE__);
    }

    if (p->id == 0) {
	doWithoutThread = 1;
    } else {
# ifdef WIN32
	if (nArgs > 0) {
	    arg0 = (void *) argPtr[0];
	}

	switch (callType) {
	    case WRAP_WINAPI:
		if (nArgs <= 0) break;
		if (arg0 == NULL) break;

		if (strncmp (nm, "CreateFile", sizeof("CreateFile")-1) == 0) {
		    knownFunction = e_isCreateFile;
#  ifdef SYNCHRONOUS_CREATEFILE
		    doWithoutThread = 1;
#  endif
#  ifdef FAST_CREATEFILE
		    doWithoutThread = fileIsKnownToBeOnANonBlockingDrive(arg0);
#  endif
		    break;
		}
		if (strncmp (nm, "GetFileAttributes", sizeof("GetFileAttributes")-1) == 0) {
		    knownFunction = e_isGetFileAttributes;
#  ifdef CACHE_GETFILEATTRIBUTES
		    /*
		     * the following caches the result of the GetFileAttributes
		     * API call in case of two consecutive such calls (for the same file).
		     */
		    if (strcmp (cashed_fileAttributesName, (char *)arg0) == 0) {
			W1PRINTF(("GetFileAttributesA - hit\n"));
			__threadErrno = 0;
			return ( cashed_fileAttributes );
		    }
#  endif
#  ifdef SYNCHRONOUS_GETFILEATTRIBUTES
		    doWithoutThread = 1;
#  endif
#  ifdef FAST_GETFILEATTRIBUTES
		    doWithoutThread = fileIsKnownToBeOnANonBlockingDrive(arg0);
#  endif
		    break;
		}
		if (strncmp (nm, "FindFirstFile", sizeof("FindFirstFile")-1) == 0) {
		    knownFunction = e_isFindFirstFile;
#  ifdef SYNCHRONOUS_FINDFIRSTFILE
		    doWithoutThread = 1;
#  endif
#  ifdef FAST_FINDFIRSTFILE
		    doWithoutThread = fileIsKnownToBeOnANonBlockingDrive(arg0);
#  endif
		    break;
		}
		if (strncmp (nm, "FindNextFile", sizeof("FindNextFile")-1) == 0) {
		    knownFunction = e_isFindNextFile;
#  ifdef SYNCHRONOUS_FINDNEXTFILE
		    doWithoutThread = 1;
#  endif
#  ifdef FAST_FINDNEXTFILE
		    if (noWrap_findFileHandle == (HANDLE)arg0) {
			doWithoutThread = 1;
		    } else {
			doWithoutThread = fileIsKnownToBeOnANonBlockingDrive(arg0);
		    }
#  endif
		    break;
		}
		if (strncmp (nm, "GetFullPathName", sizeof("GetFullPathName")-1) == 0) {
		    knownFunction = e_isGetFullPathName;
#  ifdef SYNCHRONOUS_GETFULLPATHNAME
		    doWithoutThread = 1;
#  endif
#  ifdef FAST_GETFULLPATHNAME
		    doWithoutThread = fileIsKnownToBeOnANonBlockingDrive(arg0);
#  endif
		    break;
		}
		if (strncmp (nm, "GetLongPathName", sizeof("GetLongPathName")-1) == 0) {
		    knownFunction = e_isGetLongPathName;
#  ifdef SYNCHRONOUS_GETLONGPATHNAME
		    doWithoutThread = 1;
#  endif
#  ifdef FAST_GETLONGPATHNAME
		    doWithoutThread = fileIsKnownToBeOnANonBlockingDrive(arg0);
#  endif
		    break;
		}
		break;

	    case WRAP_SOCKAPI:
		break;

	    case WRAP_CAPI:
		if (strcmp (nm, "fopen") == 0 || strcmp (nm, "wfopen") == 0 ) {
		    knownFunction = e_isFopen;
#  ifdef SYNCHRONOUS_FOPEN
		    doWithoutThread = 1;
#  endif
#  ifdef FAST_FOPEN
		    doWithoutThread = fileIsKnownToBeOnANonBlockingDrive(arg0);
#  endif
		    break;
		}
		if (strcmp (nm, "fdopen") == 0) {
		    knownFunction = e_isFdopen;
#  ifdef SYNCHRONOUS_FDOPEN
		    doWithoutThread = 1;
#  endif
		    break;
		}
		break;
	}
#  ifdef CACHE_GETFILEATTRIBUTES
	/* flush file attributes for any other api-call */
	cashed_fileAttributesName[0] = 0;
#  endif/
# endif  /* WIN32 */
    }

    if (__debugSockAPI) {
	if (callType == WRAP_SOCKAPI) debug = 1;
    }
    if (__debugWinAPI) {
	if (callType == WRAP_WINAPI) debug = 1;
    }
    if (__debugCAPI) {
       if (callType == WRAP_CAPI) debug = 1;
    }
# ifdef DEBUG_WRAPCALLS
    debug = 1;
# endif

# ifdef DEBUG_CONNECT
    if (strcmp(nm, "connect") == 0) debug = 1;
# endif
# ifdef DEBUG_SEND
    if (strcmp(nm, "send") == 0) debug = 1;
# endif
# ifdef DEBUG_FCLOSE
    if (strcmp(nm, "fclose") == 0) debug = 1;
# endif
# ifdef DEBUG_RTL_WRITE
    if (strcmp(nm, "_rtl_write") == 0) debug = 1;
# endif
# ifdef DEBUG_GETFILEATTRIBUTES
    if (strcmp(nm, "GetFileAttributes", sizeof("GetFileAttributes")-1) == 0) debug = 1;
# endif
# ifdef DEBUG_SQL
    if (strncmp(nm, "SQL", 3) == 0) {
	debug = 1;
	fprintf(stderr, "VM %s...\n", nm);
    }
# endif

# ifdef DEBUG_WRITE_BUFFER
    if (strcmp(nm, "send") == 0) {
	char *buf = (char *)argPtr[1];
	int n = (int)argPtr[2];

	bcopy( buf, savedData, (n>sizeof(savedData))?sizeof(savedData):n);

#  ifdef DEBUG_WRITE_BUFFER2
	savedData[sizeof(savedData)-1] = 0;
	if (n < sizeof(savedData)) savedData[n] = 0;
	fprintf(stderr, "%08x >>>>>>>>>: %s\n", arg0, savedData);
	bcopy( buf, savedData, (n>sizeof(savedData))?sizeof(savedData):n);
#  endif
    }
# endif

# ifdef CHECK_EARLY_FOR_INTERRUPTS /* must test if it does not go into an endless loop */
    if (IS_interrupted(p)) {
	fprintf(stderr, "VM [warning]: already interrupted when entering wrap for %s [%d]\n", nm, __LINE__);
	__schedulerInterrupt();
	__threadErrno = EINTR;
	return -1;
    }
# endif

    if (doWithoutThread) {
# ifdef DEBUG_SYNCRONOUS_WRAPCALLS
	debug = 1;
# endif
	ws.argc             = nArgs;
	for (i=0; i<nArgs; i++) {
	    ws.arg[i] = argPtr[i];
	}
	ws.callType         = callType;
	ws.wrapFunction     = f;
	ws.wrapFunctionName = nm;
	ws.debug            = debug;
	ws.interruptable    = 0;

	p->_wrapCall = NULL;

	doWrapProc(&ws, argPtr);
	ret = (int) ws.ret;
	__threadErrno = ws.wrapErrno;
    } else {
# ifdef DEBUG_ASYNCRONOUS_WRAPCALLS
	debug = 1;
# endif
	w = p->_freeWrapCall;
	if (w != NULL) {
	    p->_freeWrapCall = NULL;
	} else {
	    w = newWrapCall(debug);
	    if (w == NULL) {
		fprintf(stderr, "VM [warning]: wrapCall failed: no more wrapCalls\n");
		__threadErrno = ECHILD;
		return -1;
	    }
	}

	w->argc             = nArgs;
	w->callType         = callType;
	w->wrapFunction     = f;
	w->wrapFunctionName = nm;
	w->debug            = debug;
	w->interruptable    = (flags & WRAP_NO_INTERRUPT) ? 0 : 1;

	for (i=0; i<nArgs; i++) {
	    w->arg[i] = argPtr[i];
	}

# ifdef CHECK_EARLY_FOR_INTERRUPTS /* must test if it does not go into an endless loop */
	if (IS_interrupted(p)) {
	    fprintf(stderr, "VM [warning]: already interrupted when entering wrap for %s [%d]\n", nm, __LINE__);
	    __schedulerInterrupt();
	    __threadErrno = EINTR;
	    return -1;
	}
# endif
	ret = __wrapCall(p, w, e_StartWrap);
    }

    /* cache some results */
# ifdef WIN32
    switch (knownFunction) {
#  ifdef CACHE_GETFILEATTRIBUTES
	case e_isGetFileAttributes:
	    if ((ret >= 0) && (nArgs > 0) && (arg0 != NULL)) {
		cashed_fileAttributes = (DWORD) ret;
		strncpy( cashed_fileAttributesName, arg0, sizeof(cashed_fileAttributesName) );
		cashed_fileAttributesName[sizeof(cashed_fileAttributesName)-1] = 0;
		/* why should this path be non-blocking? */
		rememberPathAsNonBlocking((char *)arg0);
	    }
	    break;
#  endif  /* CACHE_GETFILEATTRIBUTES */

#  ifdef FAST_FINDNEXTFILE
	case e_isFindFirstFile:
	    if ((ret > 0) && (nArgs > 0) && (arg0 != NULL)) {
		noWrap_findFileHandle = (HANDLE) ret;
	    }
	    break;

	case e_isFindNextFile:
	    if ((ret > 0) && (nArgs > 0) && (arg0 != NULL)) {
		noWrap_findFileHandle = (HANDLE) arg0;
	    }
	    break;
#  endif
    }
# endif  /* WIN32 */

# ifdef DEBUG_WRITE_BUFFER
    if (strcmp(nm, "send") == 0) {
	char *buf = (char *)argPtr[1];
	int n = (int)argPtr[2];
	int i;
	int anyChange = 0;

	for (i=0; i<n; i++) {
	    if (buf[i] != savedData[i]) {
		fprintf(stderr, "!!!!!!!!!!!!!!!! data changed[i] (0x%02x -> 0x%02x)\n", savedData[i], buf[i]);
		anyChange = 1;
		break;
	    }
	}
	if (anyChange) {
	    savedData[sizeof(savedData)-1] = 0;
	    if (n < sizeof(savedData)) savedData[n] = 0;
	    fprintf(stderr, "%08x original: %s\n", arg0, savedData);

	    bcopy( buf, savedData, (n>sizeof(savedData))?sizeof(savedData):n);
	    if (n < sizeof(savedData)) savedData[n] = 0;
	    fprintf(stderr, "%08x changed: %s\n", arg0, savedData);
	}
    }
# endif

    return ( ret );
}

int
__doWrapCall(int callType, char *nm, wrapFunction_t f)
{
    return doWrapCallN(callType, nm, f, 0, NULL);
}

int
__doWrapCall0(callType, nm, f)
    int callType;
    char *nm;
    wrapFunction_t f;
{
    return doWrapCallN(callType, nm, f, 0, NULL);
}

int
__doWrapCall1(callType, nm, f, ARGLIST_1)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1;
{
    return doWrapCallN(callType, nm, f, 1, &a1);
}

int
__doWrapCall2(callType, nm, f, ARGLIST_2)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2;
{
    return doWrapCallN(callType, nm, f, 2, &a1);
}

int
__doWrapCall3(callType, nm, f, ARGLIST_3)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3;
{
    return doWrapCallN(callType, nm, f, 3, &a1);
}

int
__doWrapCall4(callType, nm, f, ARGLIST_4)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4;
{
    return doWrapCallN(callType, nm, f, 4, &a1);
}

int
__doWrapCall5(callType, nm, f, ARGLIST_5)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5;
{
    return doWrapCallN(callType, nm, f, 5, &a1);
}

int
__doWrapCall6(callType, nm, f, ARGLIST_6)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6;
{
    return doWrapCallN(callType, nm, f, 6, &a1);
}

int
__doWrapCall7(callType, nm, f, ARGLIST_7)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6, *a7;
{
    return doWrapCallN(callType, nm, f, 7, &a1);
}

int
__doWrapCall8(callType, nm, f, ARGLIST_8)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6, *a7, *a8;
{
    return doWrapCallN(callType, nm, f, 8, &a1);
}

int
__doWrapCall9(callType, nm, f, ARGLIST_9)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6, *a7, *a8, *a9;
{
    return doWrapCallN(callType, nm, f, 9, &a1);
}

int
__doWrapCall10(callType, nm, f, ARGLIST_10)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6, *a7, *a8, *a9, *a10;
{
    return doWrapCallN(callType, nm, f, 10, &a1);
}

int
__doWrapCall11(callType, nm, f, ARGLIST_11)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6, *a7, *a8, *a9, *a10, *a11;
{
    return doWrapCallN(callType, nm, f, 11, &a1);
}

int
__doWrapCall12(callType, nm, f, ARGLIST_12)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6, *a7, *a8, *a9, *a10, *a11, *a12;
{
    return doWrapCallN(callType, nm, f, 12, &a1);
}

int
__doWrapCall13(callType, nm, f, ARGLIST_13)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6, *a7, *a8, *a9, *a10, *a11, *a12, *a13;
{
    return doWrapCallN(callType, nm, f, 13, &a1);
}

int
__doWrapCall14(callType, nm, f, ARGLIST_14)
    int callType;
    char *nm;
    wrapFunction_t f;
    void *a1, *a2, *a3, *a4, *a5, *a6, *a7, *a8, *a9, *a10, *a11, *a12, *a13, *a14;
{
    return doWrapCallN(callType, nm, f, 14, &a1);
}






void __apiwrap_end__() {}

#ifdef FUNC_INFO
struct funcInfo __process_funcInfo__[] = {
	{ (VOIDFUNC) __apiwrap_start__ , "__apiwrap_start__" },
	{ (VOIDFUNC) __apiwrap_end__ ,   "__apiwrap_end__" },
	{ 0 , NULL },
};
#endif /* FUNC_INFO */

#endif APIWRAPTHREADS
