# $Header: /cvs/stx/stx/librun/bc.mak,v 1.95 2012/03/26 10:26:12 cg Exp $
#
# makefile for borland-c (actually: also for visual-c, if USEVC is defined)
#
#############################################################################

# a binary-only distribution, if any
STXBIN=..\..\stxbin

!ifdef USEBC
error error error error
!endif

!ifdef USEVC
! undef USEBC
!endif

TOP=..

!INCLUDE $(TOP)\rules\stdHeader_bc

!ifdef USEBC
  LIBRUN_BASE_LD_ARG=-b:$(LIBRUN_BASE)
!endif
!ifdef USEVC
  LIBRUN_BASE_LD_ARG=-/BASE:$(LIBRUN_BASE)
!endif

USERINITFUNCS=

LIBNAME=librun

!ifdef USEBC
LIBDIR=..\libbc
OBJDIR=objbc
MAKER=bmake
!else
! ifdef USEVC
LIBDIR=..\libvc
OBJDIR=objvc
MAKER=vcmake
! else
error error error
! endif
!endif

INCDIR=..\include

vm:     librun buildDate.h

librun: $(OBJDIR) ffi librun_dll $(LIBDIR)
	copy $(OBJDIR)\librun.lib $(LIBDIR)\*.*

$(OBJDIR):
	@-if not exist $(OBJDIR)\nul mkdir $(OBJDIR)

$(LIBDIR):
	@if not exist $(LIBDIR)\nul mkdir $(LIBDIR)

ffi:
	pushd libffi\build_win32 & call $(MAKER)
	copy libffi\build_win32\include\*.h $(INCDIR)

removeMain:
	del $(OBJDIR)\main.obj

plugin:
	pushd plugin\mozilla & $(MAKE)


!ifdef USEBC

$(LIBDIR)\$(RT_LIB):
	copy ..\support\win32\borland\$(RT_LIB) $(LIBDIR)\$(RT_LIB)

!else

$(LIBDIR)\$(RT_LIB):
	echo "no runtime files to copy"

!endif


!ifdef USEBC

INCL=-I..\include -I$(BCB)\include -I$(INCDIR)
DEFS=-D_NO_VCL;WIN32;HAVE_CONFIG_H;DEBUG;_CONSOLE;_RTLDLL

CC_FLAGS = $(INCL) -O2 -WD -w- -x- -d -k -y -v -lv -vi -c -tWDR \
		$(DEFS) \
		-xd- -R -RT -Tkh30000 -5

RFLAGS = -D_NO_VCL;WIN32;HAVE_CONFIG_H;DEBUG;_CONSOLE;_RTLDLL \
		-i.;$(BCB)\include;$(INCDIR)

AS_FLAGS = /i. /i$(BCB)\include /i$(INCDIR) /d_NO_VCL /dWIN32 /dHAVE_CONFIG_H \
		/dDEBUG /d_CONSOLE /d_RTLDLL /mx /w2 /zi

LFLAGS = -L..\libbc;$(BCB)\lib $(LIBRUN_BASE_LD_ARG) \
		-ap -Tpd -s -Gn -Gi -w-dup -v -m -s

#CC_FLAGS= $(INCL) -O2 -5 -WD -w- -x- -r- -k -y -v -vi- -c -tWD \
#                 -RT- -Tkh30000 -D_NO_VCL;WIN32;DEBUG

LINK32  = ilink32.exe
AS      = tasm32.exe
RCC     = brcc32.exe

.c.obj:
	$(CC) $(CC_FLAGS) -n$(@D) $<

!else
! ifdef USEVC
INCL=-I. -I..\include -I$(INCDIR)
SYS_INCL=-I"$(VCINSTALLDIR)\include" -I"$(SDK)\Include" -I..\librun
DEFS=-D__VISUALC__ -DNO_VCL -DWIN32 -DHAVE_CONFIG_H -DDEBUG -D_CONSOLE -D_RTLDLL
# COPTFLAGS=/Ox /Gd
# COPTFLAGS=/ZI /Zi
COPTFLAGS=/Gd
CC_FLAGS = /nologo $(INCL) $(COPTFLAGS) $(DEFS) $(SYS_INCL)

.c.obj:
	$(CC) -c /Fo"$@" $(CC_FLAGS) $<
! else
error error error
! endif
!endif

.autodepend
PATHCPP = .
.PATH.CPP = $(PATHCPP)
.PATH.C   = $(PATHCPP)
.PATH.ASM = $(PATHCPP)

.c.I:
	cpp32 $(INCL) $(DEFS) $<

.asm.obj:
	$(AS) $(AS_FLAGS) $<, $@

!ifdef USEBC
.rc.res:
	$(RCC) $(RFLAGS) -fo$@ $<
!endif

$(OBJDIR)\librun.res: librun.res
	copy librun.res $(OBJDIR)\librun.res
	del librun.res

LIBFFI_OBJFILES = \
	libffi\build_win32\$(OBJDIR)\debug.obj \
	libffi\build_win32\$(OBJDIR)\java_raw_api.obj \
	libffi\build_win32\$(OBJDIR)\prep_cif.obj \
	libffi\build_win32\$(OBJDIR)\raw_api.obj \
	libffi\build_win32\$(OBJDIR)\types.obj \
	libffi\build_win32\$(OBJDIR)\ffi.obj \
	libffi\build_win32\$(OBJDIR)\win32.obj

!ifdef USEBC
ASMHELP_OBJ=$(OBJDIR)\ntasmhelp.obj
!endif

!ifdef USEVC
ASMHELP_OBJ=$(OBJDIR)\vcasmhelp.obj
!endif

LIBRUN_OBJFILES = \
	$(OBJDIR)\win32.obj $(OBJDIR)\char.obj $(OBJDIR)\classes.obj \
	$(OBJDIR)\errhandler.obj $(OBJDIR)\float.obj $(OBJDIR)\globals.obj $(OBJDIR)\init.obj \
	$(OBJDIR)\interpret.obj $(OBJDIR)\interrupt.obj $(OBJDIR)\jinterpret.obj $(OBJDIR)\lookup.obj \
	$(OBJDIR)\mcompiler.obj $(OBJDIR)\md5.obj $(OBJDIR)\memory.obj $(OBJDIR)\malloc.obj $(OBJDIR)\new.obj \
	$(OBJDIR)\process.obj $(OBJDIR)\stack.obj $(OBJDIR)\send.obj $(OBJDIR)\snapshot.obj \
	$(OBJDIR)\statistic.obj $(OBJDIR)\string.obj $(OBJDIR)\stxmain.obj $(OBJDIR)\symbol.obj \
	$(OBJDIR)\symlist.obj $(OBJDIR)\util.obj $(OBJDIR)\apithreads.obj \
	$(OBJDIR)\backtrace.obj $(OBJDIR)\plugin.obj $(ASMHELP_OBJ)

!ifdef USEBC

# $(LIBFFI_OBJFILES): libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
#         pushd libffi\build_win32 & call $(MAKER) objs

libffi\build_win32\$(OBJDIR)\debug.obj: libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
	@pushd libffi\build_win32 & call $(MAKER) debug.obj

libffi\build_win32\$(OBJDIR)\java_raw_api.obj: libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
	@pushd libffi\build_win32 & call $(MAKER) java_raw_api.obj

libffi\build_win32\$(OBJDIR)\prep_cif.obj: libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
	@pushd libffi\build_win32 & call $(MAKER) prep_cif.obj

libffi\build_win32\$(OBJDIR)\raw_api.obj: libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
	@pushd libffi\build_win32 & call $(MAKER) raw_api.obj

libffi\build_win32\$(OBJDIR)\types.obj: libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
	@pushd libffi\build_win32 & call $(MAKER) types.obj

libffi\build_win32\$(OBJDIR)\ffi.obj: libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
	@pushd libffi\build_win32 & call $(MAKER) ffi.obj

libffi\build_win32\$(OBJDIR)\win32.obj: libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
	@pushd libffi\build_win32 & call $(MAKER) win32.obj

!else
! ifdef USEVC

libffi_objs: libffi\build_win32\include\ffi.h libffi\build_win32\include\fficonfig.h
	pushd libffi\build_win32 & call $(MAKER)

! endif
!endif

librun_dll:
	if exist process.h call $(MAKER) compile_librun
	if not exist process.h call $(MAKER) noSource_librun

#
# for binary only distributions
#
noSource_librun:
	@if exist $(STXBIN)\librun\librun.dll copy $(STXBIN)\librun\librun.dll *.*
	@if exist $(STXBIN)\librun\librun.lib copy $(STXBIN)\librun\librun.lib *.*


!ifdef USEBC

compile_librun: $(LIBRUN_OBJFILES) $(LIBFFI_OBJFILES) $(LIBDIR)\$(RT_LIB) bc.def $(OBJDIR)\librun.res
    $(LINK32) @&&!
	$(LFLAGS) +
	c0d32.obj $(LIBRUN_OBJFILES) $(LIBFFI_OBJFILES), +
	$(OBJDIR)\librun.dll,, +
	import32.lib $(RT_LIB), +
	bc.def, +
	$(OBJDIR)\librun.res
!

!else
! ifdef USEVC

xKERNEL_LIBS="$(SYSLIBDIR)kernel32.lib" "$(SYSLIBDIR)user32.lib" "$(SYSLIBDIR)gdi32.lib" "$(SYSLIBDIR)wsock32.lib" "$(SYSLIBDIR)winmm.lib" "$(SYSLIBDIR)advapi32.lib"
KERNEL_LIBS=kernel32.lib user32.lib gdi32.lib wsock32.lib winmm.lib advapi32.lib
LFLAGS=/NOLOGO /DLL /SUBSYSTEM:console

compile_librun: $(LIBRUN_OBJFILES) libffi_objs $(LIBDIR)\$(RT_LIB) bc.def $(OBJDIR)\librun.res
    @echo lflags: "$(LFLAGS)"
    $(LINK32) @<<
    $(LFLAGS) /OUT:"$(OBJDIR)\librun.dll" /DEF:"vc.def" $(LIBRUN_OBJFILES) $(LIBFFI_OBJFILES) $(KERNEL_LIBS)
<<
!

! endif
!endif

HEADERS=\
	..\include\stc.h \
	..\include\stcIntern.h \
	..\include\stxNames.h \
	..\include\ntIntern.h

$(OBJDIR)\main.obj: main.c modules.c $(HEADERS) buildDate.h
	$(CC) /DCONFIGURATION_STRING="\"win32/standard:standard\"" \
	      /DUSERINITFUNCS=$(USERINITFUNCS) \
	      $(CC_FLAGS) -n$(OBJDIR) main.c
	@if exist modules.c del modules.c

genDate.exe:
	@if exist genDate.c call $(MAKER) compile_genDate
	@if exist $(STXBIN)\librun\genDate.exe $(MAKER) copy_genDate

compile_genDate: genDate.c
	$(CC) -DWIN32 -I$(BCB)\include -L$(BCB)\lib genDate.c

copy_genDate: $(STXBIN)\librun\genDate.exe
	copy $(STXBIN)\librun\genDate.exe *.*

buildDate.h: genDate.exe
	genDate

$(LIBRUN_OBJFILES): process.h $(HEADERS)

clean::
	del *.obj *.res
	del objbc\*.obj objbc\*.res
	del objvc\*.obj objvc\*.res
	del *.$$$
	del *.@@@

clobber:: clean
	del *.dll objbc\*.dll objvc\*.dll
	del *.lib objbc\*.lib objvc\*.lib

modules.c: modules.templ
	copy modules.templ modules.c

supportFiles:
