	.586P
; /* -----------------------------------------------------------------------
;    win32.asm (borland) - from win32.S:
;    win32.S - Copyright (c) 1996, 1998, 2001, 2002  Red Hat, Inc.
;              Copyright (c) 2001  John Beniton
;              Copyright (c) 2002  Ranjit Mathew
;
;
;    X86 Foreign Function Interface
;
;    Permission is hereby granted, free of charge, to any person obtaining
;    a copy of this software and associated documentation files (the
;    ``Software''), to deal in the Software without restriction, including
;    without limitation the rights to use, copy, modify, merge, publish,
;    distribute, sublicense, and/or sell copies of the Software, and to
;    permit persons to whom the Software is furnished to do so, subject to
;    the following conditions:
;
;    The above copyright notice and this permission notice shall be included
;    in all copies or substantial portions of the Software.
;
;    THE SOFTWARE IS PROVIDED ``AS IS'', WITHOUT WARRANTY OF ANY KIND, EXPRESS
;    OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;    IN NO EVENT SHALL CYGNUS SOLUTIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR
;    OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
;    ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
;    OTHER DEALINGS IN THE SOFTWARE.
;    ----------------------------------------------------------------------- */
.model FLAT

PUBLIC  _ffi_call_SYSV
_TEXT   SEGMENT

_ffi_call_SYSV   PROC NEAR
	push ebp
	mov  ebp, esp

;        # Make room for all of the new args.
	mov  ecx, DWORD PTR 16[ebp]
	sub  esp, ecx

	mov  eax, esp

;        # Place all of the ffi_prep_args in position
	push DWORD PTR 12[ebp]
	push eax
	call  DWORD PTR 8[ebp] ; *8(%ebp)

;        # Return stack to previous state and call the function
	add  esp, 8

;        # FIXME: Align the stack to a 128-bit boundary to avoid
;        # potential performance hits.

	call  DWORD PTR 28[ebp] ; *28(%ebp)

;        # Remove the space we pushed for the args
	mov  ecx, DWORD PTR 16[ebp]
	add esp, ecx

;        # Load %ecx with the return type code
	mov  ecx, DWORD PTR 20[ebp]

;        # If the return value pointer is NULL, assume no return value.
	cmp  DWORD PTR 24[ebp], 0
	jne   retint

;        # Even if there is no space for the return value, we are
;        # obliged to handle floating-point values.
	cmp  ecx, 2 ; $FFI_TYPE_FLOAT
	jne   noretval
	fstp  st(0)

	jmp   epilogue

retint:
	cmp   ecx, 1 ; $FFI_TYPE_INT,%ecx
	jne   retfloat
;        # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	mov  DWORD PTR 0[ecx], eax
	jmp   epilogue

retfloat:
	cmp  ecx, 2 ; $FFI_TYPE_FLOAT,%ecx
	jne   retdouble
;         # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	fstp REAL4 PTR [ecx]
	jmp   epilogue

retdouble:
	cmp  ecx, 3 ; $FFI_TYPE_DOUBLE,%ecx
	jne   retlongdouble
;        # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	fstp REAL8 PTR [ecx]
	jmp   epilogue

retlongdouble:
	cmp  ecx, 4 ; $FFI_TYPE_LONGDOUBLE,%ecx
	jne   retint64
;        # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	fstp REAL10 PTR [ecx]
	jmp   epilogue

retint64:
	cmp  ecx, 12 ; $FFI_TYPE_SINT64,%ecx
	jne   retstruct
;        # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	mov  DWORD PTR 0[ecx], eax
	mov  DWORD PTR 4[ecx], edx

retstruct:
;        # Nothing to do!

noretval:
epilogue:
	mov esp, ebp
	pop ebp
	ret
_ffi_call_SYSV ENDP
_TEXT ENDS


PUBLIC  _ffi_call_STDCALL
_TEXT   SEGMENT

_ffi_call_STDCALL   PROC NEAR
	push ebp
	mov  ebp, esp

;        # Make room for all of the new args.
	mov  ecx, DWORD PTR 16[ebp]
	sub  esp, ecx

	mov  eax, esp

;        # Place all of the ffi_prep_args in position
	push DWORD PTR 12[ebp]
	push eax
	call  DWORD PTR 8[ebp] ; *8(%ebp)

;        # Return stack to previous state and call the function
	add  esp, 8

;        # FIXME: Align the stack to a 128-bit boundary to avoid
;        # potential performance hits.

	call  DWORD PTR 28[ebp] ; *28(%ebp)

;        # stdcall functions pop arguments off the stack themselves

;        # Load %ecx with the return type code
	mov  ecx, DWORD PTR 20[ebp]

;        # If the return value pointer is NULL, assume no return value.
	cmp  DWORD PTR 24[ebp], 0
	jne   sc_retint

;        # Even if there is no space for the return value, we are
;        # obliged to handle floating-point values.
	cmp  ecx, 2 ; $FFI_TYPE_FLOAT,%ecx
	jne   sc_noretval
	fstp  st(0)

	jmp   sc_epilogue

sc_retint:
	cmp  ecx, 1 ; $FFI_TYPE_INT,%ecx
	jne   sc_retfloat
;        # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	mov  DWORD PTR 0[ecx], eax
	jmp   sc_epilogue

sc_retfloat:
	cmp  ecx, 2 ; $FFI_TYPE_FLOAT,%ecx
	jne   sc_retdouble
;         # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	fstp REAL4 PTR [ecx]
	jmp   sc_epilogue

sc_retdouble:
	cmp  ecx, 3 ; $FFI_TYPE_DOUBLE,%ecx
	jne   sc_retlongdouble
;        # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	fstp REAL8 PTR [ecx]
	jmp   sc_epilogue

sc_retlongdouble:
	cmp  ecx, 4 ; $FFI_TYPE_LONGDOUBLE,%ecx
	jne   sc_retint64
;        # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	fstp REAL10 PTR [ecx]
	jmp   sc_epilogue

sc_retint64:
	cmp  ecx, 12 ; $FFI_TYPE_SINT64,%ecx
	jne   sc_retstruct
;        # Load %ecx with the pointer to storage for the return value
	mov  ecx, DWORD PTR 24[ebp]
	mov  DWORD PTR 0[ecx], eax
	mov  DWORD PTR 4[ecx], edx

sc_retstruct:
;        # Nothing to do!

sc_noretval:
sc_epilogue:
	mov esp, ebp
	pop ebp
	ret

_ffi_call_STDCALL ENDP
_TEXT ENDS
END
