/****************************************************************************
* $Header: /cvs/stx/stx/librun/plugin/win32Common/stxWin32Plugin.h,v 1.3 2005/12/23 15:01:12 cg Exp $
*
* st/x plugin for WIndows.
*
* Based upon sqWin32Plugin (thanks to Andreas Raab)
*
* Comment in original File:
*   PROJECT: Squeak port for Win32 (NT / Win95)
*   FILE:    sqWin32Plugin.h
*   CONTENT: Generic Squeak Plugin Header
*
*   AUTHOR:  Andreas Raab (ar)
*   ADDRESS: University of Magdeburg, Germany
*   EMAIL:   raab@isg.cs.uni-magdeburg.de
*   RCSID:   $Id: stxWin32Plugin.h,v 1.3 2005/12/23 15:01:12 cg Exp $
*
*   NOTES:
*
*****************************************************************************/
#ifndef STX_WIN32_PLUGIN_H
#define STX_WIN32_PLUGIN_H

#define MAX_STREAMS 128

typedef struct stxStreamRequest {
  char *url;
  char *localName;
  int id;
  int state;
} stxStreamRequest;

typedef struct StxPlugin {
  PROCESS_INFORMATION processInfo;
  HWND hWnd;
  WNDPROC prevWindowProc;
  void *cbData;

  HANDLE hParentReadEnd;
  HANDLE hParentWriteEnd;

  HANDLE hClientPipe;

  char vmName[MAX_PATH];
  char imageName[MAX_PATH];
  char binDir[MAX_PATH];
  char libDir[MAX_PATH];
  char *vmParams;
  char *params;
  int paramSize;
  int memory;

  /* stream requests */
  stxStreamRequest requests[MAX_STREAMS];
  int maxStreams;
} StxPlugin;

#ifdef __cplusplus
extern "C" {
#endif

  void StxPluginInitialize(void);
  StxPlugin *StxPluginNew(HANDLE hPluginModule, void *cbData);
  int StxPluginDestroy(StxPlugin *stx);
  int StxPluginActive(StxPlugin *stx);
  int StxPluginRun(StxPlugin *stx, HWND hWnd, int terminateOld);
  int StxPluginResize(StxPlugin *stx, HWND hWnd);

  void StxPluginSetVM(StxPlugin *stx, char *vmName);
  void StxPluginSetVMParams(StxPlugin *stx, char *params);
  void StxPluginSetImage(StxPlugin *stx, char *imageName);
  void StxPluginSetMemory(StxPlugin *stx, char *memoryString);
  void StxPluginAddParam(StxPlugin *stx, char *name, char *value);

  void StxPluginRequestStream(void *cbData, char *url, char *target, int id);
  void StxPluginPostData(void *instance, char *url, char *target, char *data, int id);
  void StxPluginStreamFile(StxPlugin *stx, char *url, char *localName);
  void StxPluginNotify(StxPlugin *stx, int id, char *url, int ok);
  void StxPluginStreamState(StxPlugin *stx, char *url, int ok);

  void StxPluginSetIEMode();

#ifdef __cplusplus
}
#endif

#endif
