"{ Package: 'stx:libsnmp' }"

LibraryDefinition subclass:#stx_libsnmp
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_libsnmp class methodsFor:'description'!

preRequisites
    ^ #(
        #'stx:libbasic'    "Object - superclass of stx_libsnmp "
        #'stx:libbasic2'    "IPSocketAddress - referenced by SNMPSession class>>netWalk "
        #'stx:libview'    "StandardSystemView - referenced by SNMPSession class>>monitor "
        #'stx:libwidg'    "DialogBox - referenced by SNMPSession class>>mibDump "
    )
! !

!stx_libsnmp class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        SNMPOID
        SNMPSession
        #'stx_libsnmp'
    )
!

extensionMethodNames
    ^ #(
    )
! !

!stx_libsnmp class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2007\nCopyright eXept Software AG 1998-2007'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_libsnmp class methodsFor:'description-compilation'!

additionalDefinitions_make_dot_proto
    ^ '
SNMPDIR=cmu-snmp
SNMPLIB=$(SNMPDIR)/snmplib/libsnmp.a
'
!

additionalLinkLibraries_make_dot_proto
    ^ '$(SNMPLIB)'
!

additionalRules_make_dot_proto
    ^ '
snmplib:
        @-if [ -d cmu-snmp ]; then \
            if [ !! -f $(SNMPDIR)/Makefile ]; then \
                $(MAKE) Makefiles; \
            fi; \
            echo ; \
            echo "compiling snmp library ..." ; \
            echo ; \
            ( cd $(SNMPDIR)/snmplib ; make "CC=$(CC)" "FLAGS=$(OS) $(SNMP_CC_OPT)") ; \
        else \
            echo "**** oops - need cmu-snmp subdirectory"; \
            echo "     (get that stuff from your nearest ftp server.)" ; \
        fi
'
!

additionalTargets_make_dot_proto
    ^ 'snmplib'
!

localIncludes
    ^ '-I$(SNMPDIR)/snmplib'
! !

!stx_libsnmp class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libsnmp/stx_libsnmp.st,v 1.3 2007/03/19 23:00:29 stefan Exp $'
! !
