"
 COPYRIGHT (c) 1996 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libui' }"

ViewWithScrollerSpec subclass:#SubCanvasSpec
	instanceVariableNames:'majorKey minorKey clientKey selector argument specHolder
		clientHolder subAspectHolders createNewApplication
		createNewBuilder'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Support-UI-Specs'
!

!SubCanvasSpec class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"



!

documentation
"
    Not normally used by applications.

    Notice: 
        this class was implemented using protocol information
        from alpha testers, literature and by read public domain code
        - it may not be complete or compatible to
        the corresponding ST-80 class. 
        If you encounter any incompatibilities, please forward a note 
        describing the incompatibility verbal (i.e. no code) to the ST/X team.

    [author:]
        Claus Atzkern

    [see also:]
        UIBuilder
        UIPainter
"

! !

!SubCanvasSpec class methodsFor:'interface specs'!

basicsEditSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SubCanvasSpec andSelector:#basicsEditSpec
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: basicsEditSpec
        window: 
       (WindowSpec
          label: 'SubCanvas Basics'
          name: 'SubCanvas Basics'
          min: (Point 10 10)
          max: (Point 1160 870)
          bounds: (Rectangle 0 0 421 317)
        )
        component: 
       (SpecCollection
          collection: (
           (FramedBoxSpec
              label: 'Basic Attributes'
              name: 'FramedBox'
              layout: (LayoutFrame 0 0.0 6 0 0 1.0 173 0)
              labelPosition: topLeft
              translateLabel: true
              component: 
             (SpecCollection
                collection: (
                 (LabelSpec
                    label: 'ID:'
                    name: 'nameLabel'
                    layout: (AlignmentOrigin 148 0 24 0 1 0.5)
                    activeHelpKey: id
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'nameField'
                    layout: (LayoutFrame 152 0 13 0 3 1.0 35 0)
                    activeHelpKey: id
                    tabable: true
                    model: name
                    group: inputGroup
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    acceptOnPointerLeave: false
                  )
                 (LabelSpec
                    label: 'Class (Maj.Key):'
                    name: 'majorKeyLabel'
                    layout: (AlignmentOrigin 148 0 49 0 1 0.5)
                    activeHelpKey: majorKey
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'majorKeyField'
                    layout: (LayoutFrame 152 0 38 0 3 1 60 0)
                    activeHelpKey: majorKey
                    tabable: true
                    model: majorKey
                    group: inputGroup
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    acceptOnPointerLeave: false
                  )
                 (LabelSpec
                    label: 'Selector (Min.Key):'
                    name: 'minorKeyLabel'
                    layout: (AlignmentOrigin 148 0 74 0 1 0.5)
                    activeHelpKey: minorKey
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'minorKeyField'
                    layout: (LayoutFrame 152 0 63 0 3 1 85 0)
                    activeHelpKey: minorKey
                    tabable: true
                    model: minorKey
                    group: inputGroup
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    acceptOnPointerLeave: false
                  )
                 (LabelSpec
                    label: 'Client (Key):'
                    name: 'clientKeyLabel'
                    layout: (AlignmentOrigin 148 0 99 0 1 0.5)
                    activeHelpKey: clientKey
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'clientKeyField'
                    layout: (LayoutFrame 152 0 88 0 3 1 110 0)
                    activeHelpKey: clientKey
                    tabable: true
                    model: clientKey
                    group: inputGroup
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    acceptOnPointerLeave: false
                  )
                 (LabelSpec
                    label: 'Create New:'
                    name: 'createNewLabel'
                    layout: (AlignmentOrigin 148 0 124 0 1 0.5)
                    translateLabel: true
                    adjust: right
                  )
                 (LabelSpec
                    label: 'Application:'
                    name: 'applicationLabel'
                    layout: (AlignmentOrigin 249 0 124 0 1 0.5)
                    activeHelpKey: createNewApplication
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (CheckToggleSpec
                    name: 'createNewApplicationCheckToggle'
                    layout: (AlignmentOrigin 251 0 124 0 0 0.5)
                    activeHelpKey: createNewApplication
                    tabable: true
                    model: createNewApplication
                    enableChannel: createNewApplicationEnabled
                    isTriggerOnDown: true
                    showLamp: false
                    lampColor: (Color 100.0 100.0 0.0)
                  )
                 (LabelSpec
                    label: 'Builder:'
                    name: 'builderLabel'
                    layout: (AlignmentOrigin 345 0 124 0 1 0.5)
                    activeHelpKey: createNewBuilder
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (CheckToggleSpec
                    name: 'createNewBuilderCheckToggle'
                    layout: (AlignmentOrigin 347 0 124 0 0 0.5)
                    activeHelpKey: createNewBuilder
                    tabable: true
                    model: createNewBuilder
                    enableChannel: createNewBuilderEnabled
                    isTriggerOnDown: true
                    showLamp: false
                    lampColor: (Color 100.0 100.0 0.0)
                  )
                 )
               
              )
            )
           (UISubSpecification
              name: 'scrollerSubSpec'
              layout: (LayoutFrame 0 0.0 175 0 0 1.0 273 0)
              majorKey: UISpecification
              minorKey: scrollerSubSpec
            )
           )
         
        )
      )
!

channelsEditSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SubCanvasSpec andSelector:#channelsEditSpec
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: channelsEditSpec
        window: 
       (WindowSpec
          label: 'SubCanvas Channels'
          name: 'SubCanvas Channels'
          min: (Point 10 10)
          max: (Point 1160 870)
          bounds: (Rectangle 0 0 413 290)
        )
        component: 
       (SpecCollection
          collection: (
           (FramedBoxSpec
              label: 'Channels'
              name: 'FramedBox1'
              layout: (LayoutFrame 0 0.0 6 0.0 0 1.0 112 0)
              labelPosition: topLeft
              translateLabel: true
              component: 
             (SpecCollection
                collection: (
                 (UISubSpecification
                    name: 'SubSpecification2'
                    layout: (LayoutFrame 0 0.0 2 0.0 4 1.0 27 0)
                    majorKey: UISpecification
                    minorKey: subSpecForVisibilityChannel
                  )
                 (LabelSpec
                    label: 'Application:'
                    name: 'applicationLabel'
                    layout: (AlignmentOrigin 87 0 39 0 1 0.5)
                    activeHelpKey: clientHolder
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'applicationChannel'
                    layout: (LayoutFrame 90 0 28 0 4 1 50 0)
                    activeHelpKey: clientHolder
                    tabable: true
                    model: clientHolder
                    group: inputGroup
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    acceptOnPointerLeave: false
                  )
                 (LabelSpec
                    label: 'Spec.:'
                    name: 'specificationLabel'
                    layout: (AlignmentOrigin 86 0 64 0 1 0.5)
                    activeHelpKey: specHolder
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'specificationChannel'
                    layout: (LayoutFrame 90 0 53 0 4 1 75 0)
                    activeHelpKey: specHolder
                    tabable: true
                    model: specHolder
                    group: inputGroup
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    acceptOnPointerLeave: false
                  )
                 )
               
              )
            )
           (FramedBoxSpec
              label: 'CallBacks'
              name: 'FramedBox3'
              layout: (LayoutFrame 0 0.0 113 0 0 1.0 193 0)
              labelPosition: topLeft
              translateLabel: true
              component: 
             (SpecCollection
                collection: (
                 (UISubSpecification
                    name: 'SubSpecification1'
                    layout: (LayoutFrame 0 0.0 0 0.0 4 1.0 28 0)
                    majorKey: UISpecification
                    minorKey: subSpecForPostBuildCallBack
                  )
                 (UISubSpecification
                    name: 'SubSpecification3'
                    layout: (LayoutFrame 0 0.0 25 0.0 4 1.0 53 0)
                    majorKey: SubCanvasSpec
                    minorKey: subSpecForPostCreateApplicationCallBack
                  )
                 )
               
              )
            )
           (FramedBoxSpec
              label: 'CallBacks - Open'
              name: 'FramedBox2'
              layout: (LayoutFrame 0 0.0 193 0.0 0 1.0 279 0)
              labelPosition: topLeft
              translateLabel: true
              component: 
             (SpecCollection
                collection: (
                 (LabelSpec
                    label: 'Selector:'
                    name: 'selectorLabel'
                    layout: (AlignmentOrigin 87 0 16 0 1 0.5)
                    activeHelpKey: canvasSelector
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'selectorField'
                    layout: (LayoutFrame 90 0 5 0 4 1 27 0)
                    activeHelpKey: canvasSelector
                    tabable: true
                    model: selector
                    group: inputGroup
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    acceptOnPointerLeave: false
                  )
                 (LabelSpec
                    label: 'Argument:'
                    name: 'argumentLabel'
                    layout: (AlignmentOrigin 87 0 42 0 1 0.5)
                    activeHelpKey: canvasArgument
                    translateLabel: true
                    resizeForLabel: true
                    adjust: right
                  )
                 (InputFieldSpec
                    name: 'argumentField'
                    layout: (LayoutFrame 90 0 31 0 4 1 53 0)
                    activeHelpKey: canvasArgument
                    tabable: true
                    model: argument
                    group: inputGroup
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    acceptOnPointerLeave: false
                  )
                 )
               
              )
            )
           )
         
        )
      )

    "Modified: / 26-07-2010 / 14:24:11 / cg"
!

detailsEditSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:SubCanvasSpec andSelector:#detailsEditSpec
     SubCanvasSpec new openInterface:#detailsEditSpec
    "

    <resource: #canvas>

    ^
     
       #(#FullSpec
          #window: 
           #(#WindowSpec
              #name: 'SubCanvas Details'
              #layout: #(#LayoutFrame 131 0 107 0 530 0 253 0)
              #label: 'SubCanvas Details'
              #min: #(#Point 10 10)
              #max: #(#Point 1152 900)
              #bounds: #(#Rectangle 131 107 531 254)
              #usePreferredExtent: false
          )
          #component: 
           #(#SpecCollection
              #collection: 
               #(
                 #(#UISubSpecification
                    #name: 'detailsEditSpec'
                    #layout: #(#LayoutFrame 0 0.0 0 0 0 1.0 70 0)
                    #majorKey: #UISubSpecification
                    #minorKey: #detailsEditSpec
                )
                 #(#UISubSpecification
                    #name: 'detailsInitSubSpec'
                    #layout: #(#LayoutFrame 0 0.0 74 0 0 1.0 139 0)
                    #majorKey: #UISpecification
                    #minorKey: #detailsInitSubSpec
                )
              )
          )
      )
!

subSpecForPostCreateApplicationCallBack
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:UISpecification andSelector:#subSpecForPostBuildCallBack
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: subSpecForPostCreateApplicationCallBack
        window: 
       (WindowSpec
          label: 'Application CallBacks'
          name: 'Application CallBacks'
          min: (Point 10 10)
          bounds: (Rectangle 0 0 400 31)
        )
        component: 
       (SpecCollection
          collection: (
           (LabelSpec
              label: 'PostCreate App:'
              name: 'postCreateApplicationCallbackLabel'
              layout: (AlignmentOrigin 88 0 12 0 1 0.5)
              activeHelpKey: postCreateApplicationChannel
              translateLabel: true
              resizeForLabel: true
            )
"/           (InputFieldSpec
"/              name: 'postBuildCallbackInputField'
"/              layout: (LayoutFrame 90 0 1 0 -20 1.0 23 0)
"/              activeHelpKey: postBuildChannel
"/              tabable: true
"/              model: postBuildCallback
"/              group: inputGroup
"/              type: string
"/              acceptChannel: acceptChannel
"/              modifiedChannel: modifiedChannel
"/              acceptOnPointerLeave: false
"/            )
                 (ComboBoxSpec
                    name: 'postCreateApplicationCallbackInputField'
                    layout: (LayoutFrame 90 0 1 0 -20 1.0 23 0)
                    activeHelpKey: postCreateApplicationChannel
                    tabable: true
                    model: posCreateApplicationCallback
                    acceptChannel: acceptChannel
                    modifiedChannel: modifiedChannel
                    comboList: listOfCallbacks
              enableChannel: isNotEditingSpecOnly
                  )
           (ActionButtonSpec
              label: 'browseActionImage'
              name: 'Button1'
              layout: (LayoutFrame -20 1 1 0 0 1 23 0)
              activeHelpKey: browseAction
              hasCharacterOrientedLabel: false
              translateLabel: true
              model: doBrowseActionMethod:
              actionValue: postCreateApplicationCallback
              enableChannel: isNotEditingSpecOnly
            )
           )

        )
      )

    "Created: / 26-07-2010 / 14:23:18 / cg"
! !

!SubCanvasSpec class methodsFor:'interface-painter'!

addBindingsTo:env for:inst channel:aChannel 
    "add bindings as required to allow the GUI Painter to operate on an instance of me"

    |subCanvasAspects bv|

    super addBindingsTo:env for:inst channel:aChannel.

    self 
        adaptApects:
                    #(  
                        majorKey
                        minorKey
                        clientKey
                        selector
                        argument
                        clientHolder
                        specHolder
                     )
        to:env 
        for:inst 
        channel:aChannel
        converter:#symbolOrNil.

    self 
        adaptApects:
                    #(  
                        subAspectHolderDataList
                        createNewApplication
                        createNewBuilder
                     )
        to:env 
        for:inst 
        channel:aChannel.

    bv := BlockValue 
            with:[:maj :clKey :clHolder | 
                    maj notEmptyOrNil
                    and:[true "clKey notEmptyOrNil"
                    and:[clHolder isEmptyOrNil]]]
            arguments:(Array
                        with:(env at:#majorKey)
                        with:(env at:#clientKey)
                        with:(env at:#clientHolder)).

    env at:#createNewApplicationEnabled put:bv.

    bv := BlockValue 
            with:[:ena :creat |
                    ena value == true
                    and:[creat value == true]]
            arguments:(Array
                        with:(env at:#createNewApplicationEnabled)
                        with:(env at:#createNewApplication)).

    env at:#createNewBuilderEnabled put:bv.

    "Modified: / 08-03-2007 / 23:00:10 / cg"
!

slices
    "return the slices for the attribute sections in the GUI Painter"

    ^ #(
            (Basics   basicsEditSpec)
            (Details  detailsEditSpec)
            (Channels channelsEditSpec)
            (SubChannels subChannelsEditSpec)
       )

    "Modified: / 29.1.2000 / 22:46:20 / cg"
! !

!SubCanvasSpec class methodsFor:'queries'!

supportsSubComponents
    "answer whether instances of the spec class support sub components"

    ^ false


! !

!SubCanvasSpec methodsFor:'accessing'!

argument
    "return the open-callBack argument"

    ^ argument
!

argument:something
    "set the open-callBack argument"

    argument := something.
!

clientHolder
    "return the value of the instance variable 'clientHolder' (automatically generated)"

    ^ clientHolder
!

clientHolder:something
    "set the value of the instance variable 'clientHolder' (automatically generated)"

    clientHolder := something.
!

clientKey
    "get the key used when requesting the client from a UIBuilder''s source'
    "
  ^ clientKey
!

clientKey:something
    "set the key used when requesting the client from a UIBuilder''s source'; the model
    "
    clientKey := something
!

createNewApplication
    "return the value of the instance variable 'createNewApplication' (automatically generated)"

    ^ createNewApplication
!

createNewApplication:aBoolean
    "set the value of the instance variable 'createNewApplication' (automatically generated)"

    createNewApplication := aBoolean.
!

createNewBuilder
    ^ createNewBuilder ? false
!

createNewBuilder:aBoolean
    "set the value of the instance variable 'createNewBuilder' (automatically generated)"

    createNewBuilder := aBoolean.
!

majorKey
    "get the class name for the spec producing method
    "
  ^ majorKey
!

majorKey:something
    "set the class name for the spec producing method
    "
    majorKey := something
!

minorKey
    "get the selector to access the specification from class derived from majorKey
    "
  ^ minorKey
!

minorKey:something
    "set the selector to access the specification from class derived from majorKey
    "
    minorKey := something
!

postCreateApplicationCallback
    "very special - allow application to hook on sub-application creation"

    otherAttributes isNil ifTrue:[^ nil].
    ^ (self otherAttributeAt:#postCreateApplicationCallback).

    "Created: / 26-07-2010 / 14:27:23 / cg"
!

postCreateApplicationCallback:anActionSelector
    "very special - allow application to hook on sub-application creation"

    self otherAttributeAt:#postCreateApplicationCallback put:anActionSelector

    "Created: / 26-07-2010 / 14:27:40 / cg"
!

selector
    "return the open-callBack selector"

    ^ selector
!

selector:something
    "set the open-callBack selector"

    selector := something.
!

specHolder
    "return the value of the instance variable 'specHolder' (automatically generated)"

    ^ specHolder
!

specHolder:something
    "set the value of the instance variable 'specHolder' (automatically generated)"

    specHolder := something.
!

subAspectHolderDataList
    subAspectHolders := self class
                            updatedAspectHolderDataList:subAspectHolders 
                            forClassNamed:majorKey.
    ^ subAspectHolders.
!

subAspectHolders
    ^ subAspectHolders

    "Modified: / 30.1.2000 / 20:44:07 / cg"
    "Created: / 30.1.2000 / 20:46:00 / cg"
!

subAspectHolders:aCollection
    subAspectHolders := aCollection

    "Modified: / 30.1.2000 / 20:44:10 / cg"
    "Created: / 30.1.2000 / 20:46:13 / cg"
! !

!SubCanvasSpec methodsFor:'building'!

connectSubAspectsIn:subAppl withBuilder:aBuilder
        subAspectHolders do:[:infoEntry | 
            |subAspect aspect holder callBack type|

            subAspect := infoEntry subAspect.
            aspect := infoEntry aspect.
            callBack := infoEntry callBack.
            type := infoEntry type.

            (aspect notNil or:[callBack notNil]) ifTrue:[
                aspect notNil ifTrue:[
                    "/ store a mainApps aspect into the subCanvas subAspect slot
                    holder := self getBindingIn:aBuilder binding:aspect asSymbol.
                    holder notNil ifTrue:[
                        "/ TODO: must use the general setBinding here (subAspect could be in a binding directory)...
                        subAppl perform:(subAspect , ':') asSymbol with:holder.
                    ]
                ] ifFalse:[
                    "/ arrange for getting informed, when subAspect changes
                    "/ TODO: must use the general getBinding here (subAspect could be in a binding directory)...
                    holder := subAppl perform:subAspect asSymbol
                ].
                callBack notNil ifTrue:[
                    holder isNil ifTrue:[
                        "/ how about an error here ?
                    ] ifFalse:[
                        holder onChangeSend:(callBack asSymbol) to:aBuilder application
                    ]
                ]
            ]
        ]
!

setAttributesIn:aView with:aBuilder
    "set my attributes to aView"

    |builder spec appNs applClassName applClass appl applHolder scrollable buildersApp
     createCallBackSelector|

    "/ cg to ca: this method is ugly and should be cleaned up.
    "/ I dont understand it !!
    super setAttributesIn:aView with:aBuilder.

    aBuilder isEditing ifTrue:[
        ^ self
    ].

    buildersApp := aBuilder application.

    scrollable := self hasHorizontalScrollBar or:[self hasVerticalScrollBar].
    aView makeClientViewScrollable:scrollable.
    scrollable ifFalse:[
        level isNil ifTrue:[aView level:0]
    ].

    majorKey notNil ifTrue:[
        applClassName := majorKey asSymbol
    ].

    (applClassName notNil or:[minorKey notNil or:[clientKey notNil]]) ifTrue:[
        spec := aBuilder subCanvasAt:applClassName at:minorKey.

        spec isNil ifTrue:[
            minorKey isArray ifTrue:[
                self halt:'obsolete minorKey usage'.
                spec := minorKey
            ].
        ].
        clientKey isNil ifTrue:[
            (clientHolder isNil
            and:[applClassName notNil
            and:[createNewApplication == true]]) ifTrue:[
                "/ create an application and a new builder
                appNs := buildersApp class nameSpace.
                appNs isNameSpace ifTrue:[
                    applClass := appNs at:applClassName.
                ] ifFalse:[
                    applClass := appNs privateClassesAt:applClassName.
                ].
                (applClass isNil and:[appNs ~~ Smalltalk]) ifTrue:[
                    applClass := Smalltalk at:applClassName.
                    applClass isNil ifTrue:[
                        (applClassName startsWith:'Smalltalk::') ifTrue:[
                            applClass := Smalltalk at:(applClassName copyFrom:'Smalltalk::' size+1) asSymbol.
                        ]
                    ].
                ].
                appl := applClass new.
                appl masterApplication:(buildersApp).

                (createCallBackSelector := self postCreateApplicationCallback) notNil ifTrue:[
                    aBuilder application
                        perform:createCallBackSelector
                        withOptionalArgument:appl 
                        and:spec 
                        and:self.
                ].

                createNewBuilder == true ifTrue:[
                    appl createBuilder.
                    builder := appl builder.
                ] ifFalse:[
                    builder := aBuilder.
                ]
            ] ifFalse:[
                appl := buildersApp.

                "/ only use the applications builder, if there is no
                "/ specHolder. If there is, assume that the spec will change,
                "/ and components will therefore be deleted and rebuilt.
                "/ to avoid keeping references to old widgets, we force a private
                "/ builder for the subcanvas in that case.
                specHolder isNil ifTrue:[
                    builder := aBuilder.
                ]
            ].
        ] ifFalse:[
            appl := aBuilder aspectFor:clientKey.
            applClassName isNil ifTrue:[
                appl isNil ifTrue:[
                    appl := aView application.

                    [(appl isNil or:[appl respondsTo:clientKey])] whileFalse:[
                        appl := appl masterApplication
                    ].

                    appl notNil ifTrue:[
                        appl := appl perform:clientKey
                    ]
                ] ifFalse:[
                    builder := appl builder.

                    builder notNil ifTrue:[
                        spec := builder subCanvasAt:nil at:minorKey.
                    ] ifFalse:[
                        minorKey notNil ifTrue:[
                            spec := appl specificationFor:minorKey.
                        ].
                    ].
                    spec isNil ifTrue:[
                        appl notNil ifTrue:[
                            "/ assume the normal #windowSpec will be used
                        ] ifFalse:[
                            "/ should we raise an error here ?
                            'SubCanvasSpec [warning]: invalid minor key: ' errorPrint.
                            minorKey errorPrintCR.
                        ]
                    ]
                ]
            ]
        ].

        applClassName isNil ifTrue:[
            appl isNil ifTrue:[
                appl    := buildersApp.
                builder := aBuilder newSubBuilder.
            ] ifFalse:[
                builder := appl builder.

             "/ set the application if not done yet (some done in SubCanvas)
                appl masterApplication isNil ifTrue:[
                    appl == buildersApp ifFalse:[
                        appl masterApplication:(buildersApp)
                    ]
                ].
"/                appl masterApplication:(buildersApp).
            ].
        ].

        spec isNil ifTrue:[
            minorKey isNil ifTrue:[
                appl == buildersApp ifTrue:[
                    'SubCanvasSpec [warning]: possibly recursive embedding' errorPrint.
                ] ifFalse:[
                    spec := #windowSpec
                ]
            ]
        ].

        (appl notNil and:[subAspectHolders notNil]) ifTrue:[
            self connectSubAspectsIn:appl withBuilder:aBuilder.
        ].

        aView client:appl spec:spec builder:builder.

        "/ open-callback
        (appl notNil 
        and:[selector notNil
        and:[appl respondsTo:selector]]) ifTrue:[
            argument notNil ifTrue:[
                appl perform:selector with:(aBuilder aspectAt:argument)
            ] ifFalse:[
                appl perform:selector
            ]
        ]
    ].

    clientHolder notNil ifTrue:[
        applHolder := self getBindingIn:aBuilder binding:clientHolder.
        specHolder notNil ifTrue:[    
            aView 
                specHolder:(self getBindingIn:aBuilder binding:specHolder)
                clientHolder:applHolder
        ] ifFalse:[
            aView clientHolder:applHolder.
            minorKey notNil ifTrue:[
                appl := applHolder value.
                (appl notNil) ifTrue:[
                    spec := appl specificationFor:minorKey.
                    aView spec:minorKey
                ].
            ].
        ].
        subAspectHolders notNil ifTrue:[
            appl := applHolder value.
            (appl notNil) ifTrue:[
                self connectSubAspectsIn:appl withBuilder:aBuilder.
            ].
            "/ PROBLEM: subAspects must also be connected, if the client is dynamicly changed later 
            applHolder onChangeEvaluate:[
                        appl := applHolder value.
                        (appl notNil) ifTrue:[
                            self connectSubAspectsIn:appl withBuilder:aBuilder.
                        ].
            ].
        ].
    ] ifFalse:[
        appl isNil ifTrue:[
            appl := buildersApp
        ].
        aView setClient:appl.

        specHolder notNil ifTrue:[
            aView specHolder:(self getBindingIn:aBuilder binding:specHolder)
        ].
    ].

    "Modified: / 15-11-2010 / 09:19:28 / cg"
! !

!SubCanvasSpec methodsFor:'converting'!

fromLiteralArrayEncoding:aSpecArray
    "read my attributes from aSpecArray"

    super fromLiteralArrayEncoding:aSpecArray.

    subAspectHolders notNil ifTrue:[
        "/ temporary - convert backward compatible array to a SubChannelInfoSpec
        subAspectHolders := subAspectHolders collect:[:el |
                                el isArray ifTrue:[
                                    (el first == #SubChannelInfoSpec) ifTrue:[
                                        el decodeAsLiteralArray
                                    ] ifFalse:[
                                        SubChannelInfoSpec new
                                            subAspect:(el at:1 ifAbsent:nil); 
                                            aspect:(el at:2 ifAbsent:nil); 
                                            callBack:(el at:3 ifAbsent:nil)
                                    ]
                                ] ifFalse:[
                                    el
                                ]
                            ].

        subAspectHolders := subAspectHolders select:[:el | el notNil and:[el ~~ #Array]].

        "/ later, we will do:
        "/ subAspectHolders := subAspectHolders decodeAsLiteralArray.
    ].

!

skippedInLiteralEncoding
    "define the inst-slots which are skipped when generating a literalArrayEncoding;
     (to skip the ones with default values.)"

    |l nonEmptySubAspectHolders|

    l := super skippedInLiteralEncoding asOrderedCollection.

    clientKey    isNil ifTrue:[l add:#clientKey].
    majorKey     isNil ifTrue:[l add:#majorKey].
    minorKey     isNil ifTrue:[l add:#minorKey].
    selector     isNil ifTrue:[l add:#selector].
    argument     isNil ifTrue:[l add:#argument].
    clientHolder isNil ifTrue:[l add:#clientHolder].
    specHolder   isNil ifTrue:[l add:#specHolder].
    createNewApplication ~~ true ifTrue:[l add:#createNewApplication].
    subAspectHolders notNil ifTrue:[
        subAspectHolders do:[:el | |sym|
                                (sym := (el subAspect)) size == 0 ifTrue:[
                                    sym := nil
                                ] ifFalse:[
                                    sym := sym string asSymbol
                                ].
                                el subAspect:sym.

                                (sym := (el aspect)) size == 0 ifTrue:[
                                    sym := nil
                                ] ifFalse:[
                                    sym := sym string asSymbol
                                ].
                                el aspect:sym.

                                (sym := (el callBack)) size == 0 ifTrue:[
                                    sym := nil
                                ] ifFalse:[
                                    sym := sym string asSymbol
                                ].
                                el callBack:sym.
                             ].
        subAspectHolders := subAspectHolders select:[:el | 
                                            (el aspect) notNil
                                            or:[(el callBack) notNil]
                                         ].
        subAspectHolders := subAspectHolders asArray
    ].
    subAspectHolders size == 0 ifTrue:[l add:#subAspectHolders].

    ^l

    "Modified: / 10.2.2000 / 01:42:07 / cg"
! !

!SubCanvasSpec methodsFor:'copying'!

postCopy
    subAspectHolders notNil ifTrue:[
        subAspectHolders := subAspectHolders deepCopy
    ].
    super postCopy
! !

!SubCanvasSpec methodsFor:'queries'!

viewClass
    "return the corresponding view class of the spec"

    ^ SubCanvas
! !

!SubCanvasSpec methodsFor:'queries-UIDefiner'!

actionSelectors
    "add more action selectors (these generate callBack stub methods in the definer)"

    |more|

    more := super actionSelectors.
    clientKey notNil ifTrue:[more add:clientKey].

    subAspectHolders notNil ifTrue:[
        subAspectHolders do:[:infoEntry | 
            |callBack|

            (callBack := infoEntry callBack) notNil ifTrue:[more add:callBack].
        ]
    ].

    ^ more

    "Modified: / 10.2.2000 / 01:37:03 / cg"
!

aspectSelectors
    "add more aspect selectors (these generate aspect methods in the definer)"

    |more|

    more := super aspectSelectors.

    specHolder   notNil ifTrue:[more add:specHolder].
    clientHolder notNil ifTrue:[more add:clientHolder].

    subAspectHolders notNil ifTrue:[
        subAspectHolders do:[:infoEntry | 
            |aspect|

            (aspect := infoEntry aspect) notNil ifTrue:[more add:aspect].
        ]
    ].

    ^ more

    "Modified: / 10.2.2000 / 01:36:08 / cg"
! !

!SubCanvasSpec methodsFor:'visiting'!

acceptUISpecVisitor:aVisitor 
    "Double dispatch back to the visitor, passing my type encoded in
     the selector (visitor pattern)"

    ^ aVisitor visitSubCanvasSpec:self
! !

!SubCanvasSpec class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libui/SubCanvasSpec.st,v 1.96 2011/05/07 06:59:19 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libui/SubCanvasSpec.st,v 1.96 2011/05/07 06:59:19 cg Exp $'
! !
