"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libui' }"

LibraryDefinition subclass:#stx_libui
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libui class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Build-Information for creation of the st/x standard library: stx_libui.
    This library contains UI interface spec classes used with the UI-Builder framework.
"
! !

!stx_libui class methodsFor:'description'!

excludedFromPreRequisites
    "avoid preRequisite cycles"

    ^ #(
        #'stx:libbasic2'    "Text - referenced by SelectionInListModelViewSpec>>setAttributesIn:with: "
        #'stx:libcompat'    "TextAttributes - referenced by UISpecification>>setStyle:in:with: "
        #'stx:libtool2'    "ResourceSelectionBrowser - referenced by SelectionInListModelViewSpec>>setAttributesIn:with: "
        #'stx:libwidg'    "SelectionInList - referenced by SequenceViewSpec>>defaultModelClassFor: "
        #'stx:libwidg2'
    )
!

extensionMethodNames
    ^ #(
    )
!

preRequisites
    ^ #(
        #'stx:libbasic'    "Object - superclass of SelectionInListModelViewSpec::Item "
        #'stx:libview'    "Depth4Image - referenced by HTMLViewSpec class>>icon "
        #'stx:libview2'    "Icon - referenced by ScrollerSpec class>>icon_horizontal "
    )
! !

!stx_libui class methodsFor:'description - compilation'!

additionalBaseAddressDefinition_bc_dot_mak
    "this is an optional definition, which (if present) may speed up the dll-loading a little
     on win32 systems."

    ^ '
# see stdHeader_bc for LIBUI_BASE
LIB_BASE=$(LIBUI_BASE)
'
! !

!stx_libui class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        DataSetColumnSpec
        SubChannelInfoSpec
        UIPalette
        UISpecVisitor
        UISpecification
        #'stx_libui'
        ComponentSpec
        DividerSpec
        NoteBookSpec
        RegionSpec
        UIEventCallbackSubSpec
        UnknownSpec
        CompositeSpec
        CompositeSpecCollection
        NamedSpec
        SeparatorSpec
        SpecCollection
        TabControlSpec
        UISubSpecification
        ViewWithLabelSpec
        ViewWithSubcomponentsSpec
        WindowSpec
        ColorMenuSpec
        FontMenuSpec
        FullSpec
        LabelSpec
        MenuComponentSpec
        ProgressIndicatorSpec
        ScrollableViewSpec
        ScrollerSpec
        ViewSpec
        ViewWithLabelAndModelSpec
        WidgetSpec
        ActionButtonSpec
        CheckBoxSpec
        ComboListSpec
        ExtendedComboBoxSpec
        FramedBoxSpec
        InputFieldSpec
        MenuPanelSpec
        PanelViewSpec
        PopUpListSpec
        RoundProgressIndicatorSpec
        ScrollBarSpec
        SliderSpec
        TabViewSpec
        TableViewSpec
        TransparentBoxSpec
        UpDownButtonSpec
        VariablePanelSpec
        ViewWithScrollerSpec
        ArbitraryComponentSpec
        ArrowButtonSpec
        ButtonSpec
        ComboBoxSpec
        DataSetSpec
        FilenameInputFieldSpec
        GridBagLayoutViewSpec
        GroupBoxSpec
        HTMLViewSpec
        HorizontalPanelViewSpec
        LinkButtonSpec
        ListModelViewSpec
        MenuButtonSpec
        MultiColumnPanelViewSpec
        NoteBookViewSpec
        SelectionInTreeViewSpec
        SequenceViewSpec
        SteppingSliderSpec
        SubCanvasSpec
        TextEditorSpec
        ThumbWheelSpec
        ToggleSpec
        VariableHorizontalPanelSpec
        VariableVerticalPanelSpec
        VerticalPanelViewSpec
        CheckToggleSpec
        FileSelectionTreeSpec
        NonScrollableArbitraryComponentSpec
        RadioButtonSpec
        SelectionInListModelViewSpec
        TextCollectorSpec
        UIGalleryViewSpec
        WorkspaceSpec
        CodeViewSpec
        HierarchicalListViewSpec
        AssistantPageSpec
    )
! !

!stx_libui class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X UI Specifications'
!

legalCopyright
    "Return copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2012\nCopyright eXept Software AG 1998-2012'

    "Modified: / 18-07-2012 / 19:11:59 / cg"
! !

!stx_libui class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libui/stx_libui.st,v 1.31 2012/07/18 17:12:56 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/libui/stx_libui.st,v 1.31 2012/07/18 17:12:56 cg Exp $'
! !
