"
 COPYRIGHT (c) 1998 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libwidg3' }"

ImageView subclass:#ColorBulletIndicator
	instanceVariableNames:'images'
	classVariableNames:'RedStateImage YellowStateImage GreenStateImage'
	poolDictionaries:''
	category:'Views-Misc'
!

!ColorBulletIndicator class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1998 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

!

documentation
"
    documentation to be added.

    [author:]
        Claus Gittinger (ps@joshua)

    [see also:]

    [instance variables:]

    [class variables:]
"
!

examples
"
                                                                [exBegin]
    |top aV model|

    model := #red asValue.

    top := StandardSystemView new.
    top extent:100@100.
    aV := ColorBulletIndicator origin:0@0 in:top.
    aV model:model.

    top open.
    Delay waitForSeconds:5.
    model value:#yellow.
    Delay waitForSeconds:5.
    model value:#green.
                                                                [exEnd]
"

! !

!ColorBulletIndicator class methodsFor:'class initialization'!

initializeSharedImages
    RedStateImage := Smalltalk imageFromFileNamed:'gifImages/red-ball.gif' forClass:self.
    YellowStateImage := Smalltalk imageFromFileNamed:'gifImages/yellow-ball.gif' forClass:self.
    GreenStateImage := Smalltalk imageFromFileNamed:'gifImages/green-ball.gif' forClass:self.

    "
     self initializeSharedImages
    "

    "Modified: / 11.2.2000 / 00:31:50 / cg"
! !

!ColorBulletIndicator methodsFor:'accessing'!

model:aModel
    "set the model, which is supposed to provide the boxes value.
     If a listMessage was defined, it is also responsible for providing
     the list"

    super model:aModel.
    self getStateFromModel.

! !

!ColorBulletIndicator methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    changedObject == model ifTrue:[
        self getStateFromModel
    ].
! !

!ColorBulletIndicator methodsFor:'initialization'!

fetchDeviceResources
    "fetch device colors, to avoid reallocation at redraw time"

    super fetchDeviceResources.

    images at:#red    put:((images at:#red) onDevice:device).
    images at:#yellow put:((images at:#yellow) onDevice:device).
    images at:#green  put:((images at:#green) onDevice:device).
!

initialize
    super initialize.

    images isNil ifTrue:[
        images := IdentityDictionary new.
    ].

    RedStateImage isNil ifTrue:[
        self class initializeSharedImages
    ].

    images at:#red    put:RedStateImage.
    images at:#yellow put:YellowStateImage.
    images at:#green  put:GreenStateImage.
! !

!ColorBulletIndicator methodsFor:'private'!

getStateFromModel
    |img|

    img := images at:(model value) ifAbsent:nil.
    super image:img
! !

!ColorBulletIndicator methodsFor:'queries'!

preferredExtent
    preferredExtent notNil ifTrue:[^ preferredExtent].

    preferredExtent := (images at:#red) extent.
    ^ preferredExtent

! !

!ColorBulletIndicator class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libwidg3/ColorBulletIndicator.st,v 1.5 2009/08/07 11:00:32 cg Exp $'
! !
