"{ Package: 'stx:libwidg3' }"

View subclass:#RedLamp
	instanceVariableNames:'offImage onImage'
	classVariableNames:''
	poolDictionaries:''
	category:'Views-Misc'
!

!RedLamp class methodsFor:'documentation'!

examples
"
 Notice that everything between [exBegin] and [exEnd] is extracted by the html-doc generator
 to create nicely formatted and clickable executable examples in the generated html-doc.
 (see the browsers class-documentation menu items for more)

 trying the widget as standAlone view:
                                                        [exBegin]
    RedLamp new open
                                                        [exEnd]

 embedded in another view:
                                                        [exBegin]
    |blinker top l1 l2 l3 l4|

    blinker := true asValue.
    [
        10 timesRepeat:[    
            Delay waitForSeconds:1.
            blinker value:(blinker value not)
        ]
    ] fork.

    top := StandardSystemView new.
    top extent:100@100.
    top viewBackground:(Color grey:20).

    l1 := RedLamp new.
    l1 origin:10@10.
    l1 viewBackground:(top viewBackground).
    top add:l1.
    l1 model:blinker.

    l2 := RedLamp origin:30@10 in:top.
    l2 viewBackground:(top viewBackground).
    l3 := RedLamp origin:50@10 in:top.
    l3 viewBackground:(top viewBackground).
    l4 := RedLamp origin:70@10 in:top.
    l4 viewBackground:(top viewBackground).
    top open
                                                        [exEnd]
"
! !

!RedLamp class methodsFor:'image specs'!

offImage
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self offImage inspect
     ImageEditor openOnClass:self andSelector:#offImage
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:'RedLamp class offImage'
        ifAbsentPut:[(Depth8Image new) width: 25; height: 25; photometric:(#palette); bitsPerSample:(#[8]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
CP4MCP4@S@QNV!!5ZGE(DGQ0G@P@MCP4MCP4MCPAZAD8\MCP4MCP]MCP\GQP\A0@MCP4MCP@+GQ5LS" DMA4]GE(4GSP\GT0G@@4MCP@DGQ4]DCPESQ44ME(4
QA4\GSPDGA0@CP5ZSQ0]ME$*R0LCL3LC@4,4DTP^GP\TC04@P%,]DE(RMQ< WT!!HWR@ M%$4MB%NAE(@MCP\GE QM5A]WU5]WU5]WTMQS5!!XGU(QA@T4GA5M
M!!=]WU4:N%H,KB1PW$=XVE!!DNPPESU PS3 ,N#(.N$UEN#(:N%87ME!!XQC$DSQ1XMED"N!!X WRI^W"H"HB9]NCQXGA1DGR!!XMD=^XC4.BS@XL#HNCC@<T%8R
ME \Q@\4VE!!OH#)_UD)J@BP$U%YJIP-^D!!D]DE)LSSQMD%9 OFEUT4\;KTTSHUT.H!!UMVE ''V X(MD5QKC1!!LS0<K"8:N#)SN%8UGU!!XV \4GE!!XTU8<FR8.
K"8.N#(:K#(8SR$?J@UNMB ?VE$8B30.K"8:N#)]WT!!PD#QAVE(EGT5LF4EM@2A UEP<OC0.K%<"P1IXF5!!DS10DMA,[GCY\P0 <OD%IOB8:D#X4V@=XV$4]
AD8\SA04JE%CTE@"K2I^P44\MCP4V POA0@]V!!0\V@IXU0<(M#YYGC<PGQ0\MA1XJ0@MEE)ZSD0]MCQZV#QZGQ44GQ0\GPQZI% MCPAZGE)LGA04MCP]V!!5L
GSPODA@+A@P@CP4@@E(AV!!5L@T0\J@D4GD0\M@P]GA0@CP4MCP4@C40OS@P4JA04MA4DGP<PG@D@CP4MCP4MCP4@GP<\C2 \J@<4GD0>F @MCP4MCP@a') ; colorMapFromArray:#[112 64 80 31 31 31 47 48 47 48 32 31 64 64 64 64 63 63 47 32 47 79 79 80 96 31 16 96 63 63 95 95 95 96 32 47 128 96 96 0 0 0 144 112 127 32 47 47 48 63 63 63 48 48 63 47 47 80 31 16 80 80 80 63 32 48 95 16 16 95 95 96 128 111 96 112 16 31 31 32 31 32 47 48 47 47 48 48 48 63 48 47 63 64 31 31 79 31 31 95 31 16 80 32 47 79 64 80 111 64 64 112 32 47 16 16 16 48 63 48 47 47 47 47 48 63 64 48 48 63 64 64 80 32 31 80 16 15 96 31 31 80 31 47 112 80 80 111 16 31 144 127 127 48 31 16 48 48 48 63 32 31 48 32 47 64 47 47 64 32 47 79 63 64 95 31 31 95 16 15 111 31 31 111 32 47 15 16 16 32 48 48 63 79 64 47 63 63 79 79 64 64 32 31 63 48 63 80 16 16 80 80 95 96 16 15 95 31 47 112 31 31 127 64 80 48 47 31 32 32 47 48 47 48 63 63 64 63 47 48 79 32 31 63 32 47 95 32 31 96 16 16 111 32 31 111 16 16 127 79 80 32 48 47 47 48 48 48 47 47 63 63 63 64 63 64 63 31 31 80 31 31 79 32 47 96 32 31 95 32 47 112 16 16]; mask:((Depth1Image new) width: 25; height: 25; photometric:(#blackIs0); bitsPerSample:(#[1]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@?? _0??>G<_??1?O??>_7???7=???=??????????????????????????????????????????????????????????????????????7???7=???=?O??>_1??
?G<O??!!?@?? _0@a') ; yourself); yourself]
!

onImage
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self onImage inspect
     ImageEditor openOnClass:self andSelector:#onImage
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:'RedLamp class onImage'
        ifAbsentPut:[(Depth8Image new) width: 25; height: 25; photometric:(#palette); bitsPerSample:(#[8]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
F1,[F1,@M2YNS&A ''6A H9>PB0@[F1,[F1,[F0@QDVT#H807C)>_HC^LXIB_$@@[F1,[F0@&S&T7YY=N''48#''2XN''9<7X#^P@A,[F0@&S"N_X"L#R8)KH8*_
"&V_''3]N#I<@F1-OWP9;N(^\L''TV[6<ZX7HFXFY2#ZH)J1,@I%(TY''H=SG!!SZ TEAYQR%#,7R08 S1D@"$:%BR]5NB=VU%YVU%YVU''>ARP%K]D,>I#T>XJTN
@V1BB@ HB@ HB@"W ''6DI9=FY2X$I0<!!RI%\U%YV%9^W%5YVAU17(GV_CBL&IF@RR64^&%!!V%0 HB@"W%5XEWCR]''7.HX(- J''J#WI\E%9^W%9^W%9)VAU1Q
RD-(''YB"H2(.W51T%0TEU!!$YU%XE%9^W^*AK^6@7#&I@QGX0UEX\A9\EVEXDAI\EU&2EY$B]S(-"Y)4U\I!!VV8NU B1+&F8EU) W^VQ&''YBKYVJLQ3NWFPTH
B@UWVP HU%ZX\:HOXFDQS#8R''6EC\@UVU%ZW%9^W%5XEQP@IHZU9X%8''X()#G1][AEYVU)]VU THBG\_R!!J%]Y<&S)<#H0(B$0VWU%YVAP"WM%A>&7-$OD-"
J2XI(&V_C&$1L3BW%0!!\WJFQ!!Y4(YVI"X A%GRL*X"NFB*P"UTD9KRV"&0$#H4-"CP@[$BYNH2L#H5:JR99KR59KXFI"''48Q\Y<[F0AN''49"C$8#""L#X()2
X$9 S&HQX(<@F1,[@BLKX$8#''9="S)="''2L#XAE"''9<@F1,[F1,@I)=N''49%XI>_H6U%H6I"''0,@F1,[F1,[F1,@X"Y%X(1%X"- X#^IM0@[F1,[F0@a') ; colorMapFromArray:#[96 47 31 15 64 16 112 47 31 95 80 95 255 32 16 255 16 16 16 63 47 255 47 47 255 16 31 32 63 48 32 48 31 31 31 31 31 47 47 48 79 64 47 47 47 32 48 63 31 31 47 63 63 64 47 48 63 32 16 47 79 47 48 95 47 31 96 47 47 208 16 31 95 95 95 255 31 15 111 32 47 0 0 0 255 47 48 31 79 48 239 15 47 48 63 31 32 32 31 32 63 63 159 16 16 48 48 48 64 63 48 79 48 16 64 64 64 63 47 48 64 47 48 79 80 80 64 47 63 79 64 80 255 95 64 112 32 16 0 64 47 223 16 47 240 31 47 224 16 48 16 48 48 239 16 47 144 32 47 48 79 63 255 15 48 32 32 47 64 64 47 191 31 16 48 48 64 63 31 31 48 32 48 64 32 47 64 48 63 80 80 95 64 32 63 224 16 16 240 31 31 128 47 31 16 64 48 240 16 31 16 48 47 47 63 31 47 48 31 48 47 31 32 48 48 47 48 48 63 47 31 63 79 64 63 63 63 64 63 63 176 32 47 191 32 48 208 31 31 223 31 31 240 31 16 223 16 16 255 31 16 240 15 16 255 16 15 255 15 16 31 79 63 255 32 47 255 16 47 47 63 48 48 63 48 160 16 31 48 47 48 47 48 47 48 48 63 63 47 47 48 47 63 63 48 63 63 47 63 79 48 63 79 32 48 96 31 31 240 16 16 255 64 48 239 15 31 32 63 31 255 15 15 128 32 47 255 15 31 16 31 31 32 47 48 160 32 31 31 32 47 48 47 47 160 31 47 191 31 31 192 31 31 63 48 47 191 32 47 63 32 48 64 64 80 111 47 31 96 48 47 223 31 47 255 96 80 127 31 31 239 31 47 255 63 63 31 48 31 32 63 47 31 63 48 32 64 64 31 48 47 16 16 31 48 63 63 63 63 48 47 32 47 48 32 47 63 64 63 64 79 80 79 79 80 79 47 47 80 63 80 208 31 47 224 16 31 255 80 64 112 32 47 255 31 31 255 32 31 143 32 31 255 31 47 31 63 47 32 64 63 32 48 47 32 47 47 47 47 48 64 47 31 159 16 47 63 48 48 79 48 31 80 32 16 64 32 48]; mask:((Depth1Image new) width: 25; height: 25; photometric:(#blackIs0); bitsPerSample:(#[1]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'@?? _0??>G<_??1?O??>_7???7=???=??????????????????????????????????????????????????????????????????????7???7=???=?O??>_1??
?G<O??!!?@?? _0@a') ; yourself); yourself]
!

switch
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self switch inspect
     ImageEditor openOnClass:self andSelector:#switch
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:'RedLamp class switch'
        ifAbsentPut:[(Depth24Image new) width: 43; height: 70; photometric:(#rgb); bitsPerSample:(#[8 8 8]); samplesPerPixel:(3); bits:(ByteArray fromPackedString:'
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@Y&](XVQ_Y&Y''VU9 WVI$@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@T5)VU5!!Z!!X:K''9>#"9^[[&=4ST9P@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@W6A"RD-H):^(
5]?#9NC&3][Z,KR;Z&-,QDUG@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@M#(<_G=8</K3>???;^/18^G%2MK^%I. QTYI@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@]'']<WVM''PDUF+Z6-????<_[64=3+3-K!!0,_X
%ZZ2VU)[@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@Z&-+!!H*K#Y.$X6Q$):^''>O/;5-3_/\CP.,CO/KZ< 9FYS5AQZ''M5#X6N\7M4@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@YVY''&I2^*J*&$Y.#W6A ^G!!93-OV,K*>(:N'')*Z*''9&]W&Q&M3 ;T5%\]GU6
#H2M#H.NYVM(@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@[650*::2,[7A
'':J^(*J#YFU&Q$)K_W:D!!8"I](FE (JHZ6%.OC4?K"<3T5QVR41NY&%*-+R8$IVWYFU&@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@Y6Y)-+R92L;S X&M++F85]#Y]W.AK#P6QTYHS5ERTEYXS5ERQTYHHRH%NC$=):^+''9>#PT%K_8BA3]GN%9^Y
WE)\@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@UUYW'')>#7.G$#9NT$)BS7.W''7._0ZW]?NC$=
N#0?OS9APDIDOS9ANC$=G"D#MSX:/,SM>_''?&Y: UEUW*KF,4=_X^7I7W6A!!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@ZFQ''_W9>6M;!!(ZJ#]''-=5=SY=/O5.K?OZV9/P4QGOS9AN#0?PDIDN#0?NC$=F2D#N30>$I>)8^G!!;/G2&Y>"[WA40<''I.[Z8U5!!Z[F1-@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@W5)^-;.=1L+TX69'')*",=/''<3<+N,+Z8&Y"[TEERNC$=OS9APDIDOS9A
MSX:G"D#TUUW%JJ,(ZF"6-?_9N?4!!8JG_7=?4M3^_7>@VU)[@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ZVY$X6Q%
1-CO!!)R\](FH9N''/4=/!!*;F43=[[&IZ[NC$<N#0?NC$=OS9AN#0?LSH5HRX(Q$1N''JR3'')6 &Y*Z;^7.0,KCWE)\'';B9-+Z<W5= [F1-@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@[6U""X&J*[B)[''Q6/L[Y<_O6*[B1/<?W-KF9N39@JR,/OS9AMSX:NC$=N#0>L3P7K#D3H2P(W5%^
-KF6"X>T-KR6:^//^WM7X&)34MC\Z6-,VU)[@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@W5)^):^+!!HRE"H"I8^O12L7T
):.+1\7TY&E''N#9AODEBL3L8L3P7NC$=L3P7L3X9JR80MCT9I"@#_W9>''J.3!!HRE9N''.*;F3OS 9*:.,\7M4VU)[@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@]7]8TEIS%IRZ!!X&L-;^99N31*Z*'',+";''I*\RD)L''Y._[''M5H2X*L3X9NC$=MSX:JR80JR$.U%]YN#,=LSL5(J.."X&I5MOU
/,3RLSH5WU5 ^7-<W%= @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@]WM6PDID_7>@#I*"2</M6>S!!(*Z^1<SOWFM%OC 46M#Y
%:B$F2D"JSD2MSX:LSH5I"X+KR82[&9/ST9PC 8Q"IV[%IRT.+3G3=[^OS9AGA0 YVU&Z6-,@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@\F53PDID]WM6#)""1LOF4-/W''Y6^2\''UQDUGIQ(M-[R7.K6?L#L5I"$*LSH5K"<2H2P''O#=B^7-<QDUG@0HB X>W"8.K*[OA4-["SD5OC 8OWE5]
Z6-,@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@Z''A2P4UG^GI8_7.A.+"=3=[]"X&J(ZV(UU%[@0HBYVI(-LKHZ&-,I2D%K"<2
KR42L3P8VU)\_G1=JB$,@0HB^H"S\7M4*:.+0,3OK"<2N#(>YV!!)YVU&@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@[&9/ST9P
 HBA_G%>&Y2]2\7_#9JS 82P^G>CB0 IGQ4!!$I^Y%IRTR$-NM3$=PTUHVU)[[''E2U5]YC0<QFA X"YJVZ&5..K6?(*&+KR42]'']7XV!!*VU)[@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@^'');TEESZ6-, XFDXV!!*(*2;-[2>]7]8%YV[NCX<@0HBM3 9^W);\7U7W&U&W&U&Z6-,RUARG!!4!!
BP(KXVE# (RF\7);.LOH_W5>RT)M(JB RT)LV51]@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@!!(ZGV5)\Q4!!J%)*"VE%[^'')<
1L_I_8RH^G);^XVOH2H"@0HBJR$,SUMUT%MTS$5NNC :FA$[B0(KNC8?#(6NZ''A2''I2])Z*-T%MT XFD 8ZFOS=B[F1-@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@"X&JZ6U)NC46^8VI HBDST9P%Y>!!''*>9ZV90_''9?^'');I2\''D1LSCP0ME1 [B0(KC08OF!!0\O4AB"H^I]WQ9_G1=/;?@
ZGQ>R4=Q&Y& S%UWPDEE!!(ZG@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@!!HRE!!HREQD<5R$-L$)JYWU9 T5)[)+J7''Y^]YV%,
^G!!9 8NDUEUWP$UJO39BM#-AST9RYV-,!!(^G]WQ9\GY7+Z6.$9NUST9P]XBE_W9>LSH5X6I%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@!!(ZGZ61,KB40XFE""X&JR$9PX&Q%)JR%$Y:([&=0\WE2_8FB_H"L!!XFG\G2F"(*Q_W5>[V9.\''%9*J"+$IFRO4IDV5-]!!YJ[N#,>O4AC
 ''>D@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"(*K!!HREVU%\I"\+Z6--Z''M5K#T6U%!!Y%I>.(*J#"(*M[GM4YV=1
YV=1]WM6ZV)-]W%=$IBS):V''_7>GLCH3JSD2^W%:R41MMST9\WE2"(*K@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@!!HRE ''>CRT!!MI"\*VE=!!P4QFG"H$O4AB[F1-"H&P$)NS H2Q!!X:T$H*P$IBW 9BZ (JIV5Y\G1<#C 4NT5-\R41MJ20/X6Q%!!HRE@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"(*K 8BERD!!LJB$,P$ECJ2\*FA$]I"\*Q$]IT5QUX6),\7A5]7]8X6Q%RD%K
LSH5F!!,^B $JKR,.N#0>J20/VU)\!!HRE@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@$IBP
 8BES5ARKRX)G"P&I2\+L#L7M3 ;Q4]JUUQWTUASTUITTUITO4ACMCT8KR81G2D$JBD$M3\<VU)\!!HRE@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@$IBP!!XVFX&M$PDECJ",.I"\*Q$UHUD5SXU!!_UD5SUEMTUEUVSD5OOC9@I2$+I2<0SD5O
\''I3!!HRE@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"(*K!!XVF^W%:
V%-\QTYIOSX:KB40J"L&I2 +J"L&J",.KR<2OS9@S$=QX&%*^7-<"(*K@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@!!XVF"(*K^7-<\GA1XVI#U5]YSD5PUUYXVE!!ZX&%*\WE2!!HRE!!HRE@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@') ; mask:((Depth1Image new) width: 43; height: 70; photometric:(#blackIs0); bitsPerSample:(#[1]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_
@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@A<@@@_@@C>@@@_@@G?@@@_@@G?@@@_@@_?@@@_@@??8@@_@A??>@@_@C???@@_
@G??? @_@O???0@_@_???8@_@_???8@_@????<@_@????<@_@????<@_A????<@_A????<@_A????<@_A????<@_A????<@_A????<@_A????<@_A????<@_
A????8@_@????8@_@????8@_@_???0@_@O??? @_@G???@@_@C??>@@_@A??<@@_@@_?0@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_
@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_@@@@@@@_') ; yourself); yourself]
! !

!RedLamp methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    "Invoked when an object that I depend upon sends a change notification."

    changedObject == model ifTrue:[
        self invalidate.
        ^ self
    ].
    super update:something with:aParameter from:changedObject
! !

!RedLamp methodsFor:'drawing'!

redrawX:x y:y width:w height:h
    "called to redraw a part of the widgets area. x/y define the origin, w/h the size of
     that area. The clipping region has already been set by the caller, so even if the code
     below draws outside the redraw-area, it will not affect what is on the screen. 
     Therefore, the example below can fill the rectangle in the redraw area, but still draw
     the cross in the outside regions."

    |img|

    model value ifTrue:[
        img := onImage        
    ] ifFalse:[
        img := offImage
    ].
    img displayOn:self x:0 y:0.
! !

!RedLamp methodsFor:'initialization & release'!

initialize
    super initialize.

    onImage := self class onImage onDevice:device.
    offImage := self class offImage onDevice:device.

    "
     self new open
    "
! !

!RedLamp methodsFor:'queries'!

preferredExtent
    ^ offImage extent
! !

!RedLamp class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libwidg3/RedLamp.st,v 1.1 2009/05/20 07:28:26 cg Exp $'
! !
