Object subclass:#FactorialExample
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'demos-Standalone-applications'
!

!FactorialExample class methodsFor:'documentation'!

documentation
"
    a non-graphical demo application;
    when built, it creates an executable which 
    (depending on the startup selector) either
    simply outputs the value of 50 factorial,
    or asks for a number,
    or takes its command line argument.

    This demo only makes sense to show how a non-GUI
    standalone application is built - 
    - within the ST/X environment, its probably useless.

    [build with:]
	cd projects/factorial; make

    [execute with:]
	cd projects/factorial; fact50
	cd projects/factorial; factI
	cd projects/factorial; factA 50

    [start with:]
	FactorialExample start50
	FactorialExample startInteractive
	FactorialExample startArg
"
! !

!FactorialExample class methodsFor:'startup'!

hello
    'Hello world - this is a nonGraphical smalltalk standAlone application' printCR.
    '' printCR.
!

start50
    self hello.

    '50 factorial is: ' print. 50 factorial printCR.
!

startInteractive
    |line num|

    self hello.

    [true] whileTrue:[
        'Enter a number: ' print.
	line := Stdin nextLine.
 	num := Number readFrom:line onError:nil.
	num isNil ifTrue:[
	    'Bad input' errorPrintCR.
	] ifFalse:[
	    num print. ' factorial is: ' print. num factorial printCR.
	]
    ]
!

startArg
    |num|

    Smalltalk commandLineArguments isEmpty ifTrue:[
	('usage: ' , Smalltalk commandName , ' number.') errorPrintCR.
	^ self.
    ].

    num := Number readFrom:(Smalltalk commandLineArguments first) onError:nil.
    num isNil ifTrue:[
	'Bad Argument' errorPrintCR.
    ] ifFalse:[
	num factorial printCR.
    ]
! !

!FactorialExample class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/projects/factorial/FactorialExample.st,v 1.4 2002/11/11 11:48:04 cg Exp $'
! !
