"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:projects/stscript' }"

ApplicationDefinition subclass:#stx_projects_stscript
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_projects_stscript class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    well, everyone asked for it, so here it is:
    a simple to use scripting executable for smalltalk.
    (although those who read the documentation and looked into the system
     must have seen this 10 years ago in the goodies/rdoit directory... sigh).

    [Author:]
        Claus Gittinger

    [startWith:]
        dont start it here - its useless.
        Its only useful as a standAlone executable:
        see projects/stscript for more info
"
! !

!stx_projects_stscript class methodsFor:'description'!

isGUIApplication
    ^ false
!

preRequisites
    ^ #(
        #'stx:libbasic'    "ApplicationDefinition - superclass of stx_projects_stscript "
        #'stx:libcomp'
    )

    "Modified: / 06-12-2006 / 15:50:18 / cg"
!

subProjects
    ^ #(
)
! !

!stx_projects_stscript class methodsFor:'description - contents'!

classNamesAndAttributes
    ^ #(
        "<className> or (<className> attributes...) in load order"
        #'stx_projects_stscript'
    )

    "Modified: / 05-12-2006 / 18:36:17 / cg"
!

extensionMethodNames
    ^ #(
    )
! !

!stx_projects_stscript class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in nt.def / bc.def"

    ^ 'Smalltalk/X STXScript'

    "Modified: / 05-12-2006 / 18:16:33 / cg"
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2006\nCopyright eXept Software AG 1998-2006'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'STXScript'

    "Modified: / 05-12-2006 / 18:16:12 / cg"
! !

!stx_projects_stscript class methodsFor:'description - startup'!

startupClassName
    ^ #stx_projects_stscript

    "Modified: / 05-12-2006 / 18:36:23 / cg"
!

startupSelector
    ^ #main

    "Modified: / 05-12-2006 / 18:35:31 / cg"
! !

!stx_projects_stscript class methodsFor:'directives'!

requireFeatures:listOfFeatures
    "process a directive-line; that's a comment-directive starting with ''{require:''.
     This is a callback from the scanner."

    listOfFeatures do:[:eachFeature |
        eachFeature = 'GUI' ifTrue:[
            Smalltalk loadPackage:'stx:libbasic2'.
            Smalltalk loadPackage:'stx:libview'.
            Smalltalk loadPackage:'stx:libview2'.
            Smalltalk loadPackage:'stx:libwidg'.
            Smalltalk loadPackage:'stx:libwidg2'.
            Smalltalk loadPackage:'stx:libui'.
            Smalltalk openDisplay.
        ].
        eachFeature = 'IDE' ifTrue:[
            Smalltalk loadPackage:'stx:libtool'.
            Smalltalk loadPackage:'stx:libtool2'.
            Smalltalk openDisplay.
        ].
    ].

    "Created: / 06-12-2006 / 16:17:20 / cg"
    "Modified (comment): / 06-12-2011 / 13:34:50 / cg"
! !

!stx_projects_stscript class methodsFor:'startup'!

main
    |prompt doDebug argv argStream arg argIdx expr file anythingDone
     beSilent|

    Smalltalk isStandAloneApp ifFalse:[
        ^ self
    ].

    Smalltalk beSTScript:true.

    Inspector := InspectorView ? MiniInspector.
    "/ Smalltalk at:#IgnoreHalt put:true.
    anythingDone := false.
    prompt := 'ST> '.
    doDebug := false.
    beSilent := self infoPrinting not.

    argv := Smalltalk commandLineArguments.
    argv notEmptyOrNil ifTrue:[
        argStream := argv copy readStream.
        argIdx := 1.
        [argStream atEnd] whileFalse:[
            arg := argStream next.

            (arg asLowercase = '-d' or:[arg = '--debug']) ifTrue:[
                argv removeAtIndex:argIdx.
                doDebug := true.
                Smalltalk loadPackage:'stx:libbasic2'.
                Smalltalk loadPackage:'stx:libview'.
                Smalltalk loadPackage:'stx:libview2'.
                Smalltalk loadPackage:'stx:libwidg'.
                Smalltalk loadPackage:'stx:libwidg2'.
                Smalltalk loadPackage:'stx:libui'.
                Smalltalk loadPackage:'stx:libtool'.
                Smalltalk loadPackage:'stx:libtool2'.
                Smalltalk openDisplay.
                Debugger := DebugView.
                Inspector := InspectorView.
                Object infoPrinting:true.
                ObjectMemory infoPrinting:true.
                ObjectMemory debugPrinting:true.
                "/ Smalltalk at:#IgnoreHalt put:false.
            ] ifFalse:[ (arg asLowercase = '-e' or:[arg = '--eval']) ifTrue:[
                argv removeAtIndex:argIdx.
                argv removeAtIndex:argIdx.
                expr := argStream next.
                Compiler evaluate:expr.
                anythingDone := true.
            ] ifFalse:[ (arg asLowercase = '-f' or:[arg = '--file' or:[arg = '--execute']]) ifTrue:[
                argv removeAtIndex:argIdx.
                argv removeAtIndex:argIdx.
                file := argStream next.
                file = '-' ifTrue:[
                    self saveReadEvalPrint:true prompt:nil.
                ] ifFalse:[
                    file asFilename exists ifTrue:[
                        Smalltalk fileIn:file silent:beSilent.
                    ] ifFalse:[
                        Stderr nextPutLine:('Error: missing file: ', file).
                    ].
                ].
                Smalltalk exit.
            ] ifFalse:[ (arg asLowercase = '-h' or:[arg = '--help']) ifTrue:[
                self printUsage.
                Smalltalk exit.
            ] ifFalse:[ (arg asLowercase = '-V' or:[arg = '--version']) ifTrue:[
                Stderr nextPutLine:('ST/X %1 %2' bindWith:Smalltalk versionString with:Smalltalk versionDate).
                Stderr nextPutLine:(Smalltalk copyrightString).
                Smalltalk exit.
            ] ifFalse:[ (arg asLowercase = '-p' or:[arg = '--prompt']) ifTrue:[
                argv removeAtIndex:argIdx.
                prompt := nil.
            ] ifFalse:[ arg = '-' ifTrue:[
                argv removeAtIndex:argIdx.
                anythingDone ifFalse:[
                    Stdin fileIn.
                    Smalltalk exit.
                ].
            ] ifFalse:[
                argv removeAtIndex:argIdx.
                arg asFilename exists ifTrue:[
                    Smalltalk fileIn:arg silent:beSilent
                ] ifFalse:[
                    Stderr nextPutLine:('Error: missing file: ', arg).
                ].
                Smalltalk exit.
            ]]]]]]].
        ].
    ].

    anythingDone ifFalse:[
        self saveReadEvalPrint:false prompt:prompt.
    ].

    "
     self main
    "

    "Created: / 05-12-2006 / 18:36:04 / cg"
    "Modified: / 06-12-2011 / 13:29:57 / cg"
!

printUsage
    Stderr nextPutLine:'usage: stscript [--help] [--silent] [--debug] [--eval expr] [--file file.st] argv'.
    Stderr nextPutLine:'  options:'.
    Stderr nextPutLine:'    --help ......... print this message and exit'.
    Stderr nextPutLine:'    --version ...... print the version info and exit'.
    Stderr nextPutLine:'    --prompt ....... no interactive prompt'.
    Stderr nextPutLine:'    --infoPrint .... be more verbose'.
    Stderr nextPutLine:'    --debug ........ allow debugging'.
    Stderr nextPutLine:'    --eval expr .... evaluate expression'.
    Stderr nextPutLine:'    --file file .... script file'.
    Stderr nextPutLine:'  Shortcuts for lazybones:'.
    Stderr nextPutLine:'    -h ............. same as --help'.
    Stderr nextPutLine:'    -v ............. same as --version'.
    Stderr nextPutLine:'    -q ............. same as --silent'.
    Stderr nextPutLine:'    -e expr ........ same as --eval'.
    Stderr nextPutLine:'    -f file ........ same as --file'.
    Stderr nextPutLine:'    -d ............. same as --debug'.
    Stderr nextPutLine:'  Without any expression or file argument, a read-eval-print loop is executed.'.
    Stderr nextPutLine:'  This reads and evaluates chunks separated by an empty line until EOF.'.
    Stderr cr.

    "Created: / 05-12-2006 / 19:36:51 / cg"
    "Modified: / 05-12-2006 / 21:10:56 / cg"
!

printUsage2
    Stderr nextPutAll:'Please enter chunks separated by an empty line. Finish with EOF '.
    OperatingSystem isMSDOSlike ifTrue:[
        Stderr nextPutAll:'(Ctrl-z).'.
    ] ifFalse:[
        Stderr nextPutAll:'(Ctrl-d).'.
    ].
    Stderr nextPutAll:' Type "?" for help.'.
    Stderr cr.
    Stderr cr.

    "Created: / 05-12-2006 / 20:03:33 / cg"
    "Modified: / 07-12-2006 / 19:17:14 / cg"
!

saveReadEvalPrint:chunkFormat prompt:prompt
    |reader|

    prompt notNil ifTrue:[
        self printUsage2.
    ].

    reader := ReadEvalPrintLoop new.
    reader prompt:prompt.
    reader doChunkFormat:false.

    reader readEvalPrintLoop.

    "Modified: / 07-12-2006 / 19:32:48 / cg"
! !

!stx_projects_stscript class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/projects/stscript/stx_projects_stscript.st,v 1.55 2011/12/06 12:38:26 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/projects/stscript/stx_projects_stscript.st,v 1.55 2011/12/06 12:38:26 cg Exp $'
! !
