/*
 * $Header: /cvs/stx/stx/stc/cpu_i386.h,v 1.10 2010/04/07 14:33:07 cg Exp $
 */

/*
 * COPYRIGHT (c) 1995 by Claus Gittinger
 *              All Rights Reserved
 *
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

#ifndef __CPU_I386_H__
# define __CPU_I386_H__


# ifdef __amd64__
#  define CPU_DEFINE "-D__amd64__"
# else
#  define CPU_DEFINE "-D__i386__"
# endif

# define __CPU__386__           386
# define __CPU__486__           486
# define __CPU__586__           586
# define __CPU__686__           686
# define __CPU__AMD64__         1064

# if !defined(__DEFAULT_CPU__)
#  ifdef __amd64__
#   define __DEFAULT_CPU__        __CPU__AMD64__
#  else
#   define __DEFAULT_CPU__        __CPU__586__
#  endif
# endif

# ifndef __POINTER_SIZE__
#  if defined(__amd64__)
#   define __POINTER_SIZE__  8
#  else
#   define __POINTER_SIZE__  4
#  endif
# endif

# define SIGNED_SHIFTS
# if !defined(__LSBFIRST__)
#  define __LSBFIRST__
# endif

# if !defined(HAS_SIGNED_CHAR)
#  define HAS_SIGNED_CHAR
# endif

# define TRADITIONAL_STACK_FRAME
# define ARG_ORDER_NORMAL

# if (__POINTER_SIZE__ == 4)
#  ifndef stx_longrestart
#   define stx_longrestart(j)         stx_longjmp(j, 0)
#   define HAVE_LONGRESTART
#  endif
# endif

# if defined(__GNUC__) && (__POINTER_SIZE__ == 4)

#  if !defined(__NO_ARITH_MACROS__)
/*
 * ADD_IO_IO -> int-object + int-object
 * ADD_IO_I  -> int-object + integer
 * SUB_IO_IO -> int-object - int-object
 * SUB_IO_I  -> int-object - integer
 */
#  if !defined(SYSV4) && !defined(POSITIVE_ADDRESSES)
    /*
     * sysv4's as cannot handle local labels
     */
#   if defined(ELF) && defined(__SHAREDLIBCODE__)
#    define _ADD_IO_IO(__op1, __op2)            \
    ({                                          \
        int __rslt;                             \
        asm("decl  %%eax                \n      \
             addl  %2,%%eax             \n      \
             jno   0f                   \n      \
             call  __MKLARGEINTov_a@PLT \n      \
        0:                              \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op1)), "g" ((int)(__op2)) \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#    define _ADD_IO_2(__op)                      \
    ({                                          \
        int __rslt;                             \
        asm("decl  %%eax                \n      \
             addl  %%eax,%%eax          \n      \
             jno   0f                   \n      \
             call  __MKLARGEINTovM1@PLT \n      \
        0:                              \n      \
             incl  %%eax                \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op))  \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })


#    define _ADD_IO_I(__op1, __int2)              \
    ({                                          \
        int __rslt;                             \
        asm("addl  %2,%%eax             \n      \
             jno   0f                   \n      \
             call  __MKLARGEINTov_a@PLT \n      \
        0:                              \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op1)), "g" (((int)(__int2))<<1) \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#    define _SUB_IO_IO(__op1, __op2)             \
    ({                                          \
        int __rslt;                             \
        asm("subl  %2,%%eax             \n      \
             jno   0f                   \n      \
             call  __MKLARGEINTov_s1@PLT \n     \
        0:                              \n      \
             incl  %%eax                \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op1)), "g" ((int)(__op2)) \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#    define _SUB_IO_I(__op1, __int2)              \
    ({                                          \
        int __rslt;                             \
        asm("subl  %2,%%eax             \n      \
             jno   0f                   \n      \
             call  __MKLARGEINTov_s@PLT \n      \
        0:                              \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op1)), "g" (((int)(__int2))<<1) \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#   else /* not ELF or not SHAREDLIBCODE */

#    define _ADD_IO_IO(__op1, __op2)              \
    ({                                          \
        int __rslt;                             \
        asm(".globl ___MKLARGEINTov_a   \n      \
             decl  %%eax                \n      \
             addl  %2,%%eax             \n      \
             jno   0f                   \n      \
             call  ___MKLARGEINTov_a    \n      \
        0:                              \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op1)), "g" ((int)(__op2)) \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#    define _ADD_IO_2(__op)                      \
    ({                                          \
        int __rslt;                             \
        asm(".globl ___MKLARGEINTovM1   \n      \
             decl  %%eax                \n      \
             addl  %%eax,%%eax          \n      \
             jno   0f                   \n      \
             call  ___MKLARGEINTovM1    \n      \
        0:                              \n      \
             incl  %%eax                \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op))  \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#    define _ADD_IO_I(__op1, __int2)              \
    ({                                          \
        int __rslt;                             \
        asm(".globl ___MKLARGEINTov_a   \n      \
             addl  %2,%%eax             \n      \
             jno   0f                   \n      \
             call  ___MKLARGEINTov_a    \n      \
        0:                              \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op1)), "g" (((int)(__int2))<<1) \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#    define _SUB_IO_IO(__op1, __op2)             \
    ({                                          \
        int __rslt;                             \
        asm(".globl ___MKLARGEINTov_s1  \n      \
             subl  %2,%%eax             \n      \
             jno   0f                   \n      \
             call  ___MKLARGEINTov_s1   \n      \
        0:                              \n      \
             incl  %%eax                \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op1)), "g" ((int)(__op2)) \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#    define _SUB_IO_I(__op1, __int2)              \
    ({                                          \
        int __rslt;                             \
        asm(".globl ___MKLARGEINTov_s   \n      \
             subl  %2,%%eax             \n      \
             jno   0f                   \n      \
             call  ___MKLARGEINTov_s    \n      \
        0:                              \n      \
                        "  : "=a" (__rslt)      \
                           : "0" ((int)(__op1)), "g" (((int)(__int2))<<1) \
                           : "cc");             \
        (OBJ)__rslt;                            \
     })

#   endif /* ELF, SHAREDLIBCODE */
#  endif /* !SYSV4 */
#  endif /* NO_ARITH_MACROS */

#  define __getStack__()                                          \
        ({                                                         \
            int __rslt;                                            \
            asm("movl %%esp,%0" : "=r" (__rslt) : /* no input */); \
            __rslt;                                                \
        })

#  if __POINTER_SIZE__ == 8
#   define __switchStack__(sp)                                            \
        asm volatile ("movq %0, %%rsp" : /* no output */ : "r" (sp) );
#  else
#   define __switchStack__(sp)                                            \
        asm volatile ("movl %0, %%esp" : /* no output */ : "r" (sp) );
#  endif

#  if !defined(__IN_STC__)

#   if defined(ELF)

#    if defined(__IN_VM__) && defined(__STATIC_LIBRUN__)
#     if !defined(__SHAREDLIBCODE__)
#      define __SHAREDLIBCODE__
#     endif
#    endif

/*
 * disabled for sharedLibs, because the leal below does add an extra PC_RELATIVE
 * text relocation entry (i386 does not support pc-relative addressing)
 * that causes a copy on write of the text page when ld.so relocates the sharedLib
 * at startup time (thus leads to long startup delays).
 * In order to make it PIC, we need a call anyway, so the inline setjmp
 * would not be much faster than the regular qsetjmp function.
 */
#    ifndef __SHAREDLIBCODE__

    /*
     * SYSV4 does not support local labels, so use __LINE__
     */
#     define stx_setjmp(jmpbuf)                      \
        ({                                      \
            int __rslt;                         \
            asm volatile("                  \n  \
                 movl  %%ebx, 0(%1)         \n  \
                 movl  %%esi, 4(%1)         \n  \
                 movl  %%edi, 8(%1)         \n  \
                 movl  %%ebp, 12(%1)        \n  \
                 movl  %%esp, 16(%1)        \n  \
                 leal  LM%2, %%ecx            \n  \
                 movl  %%ecx, 20(%1)        \n  \
                 xorl  %%eax, %%eax         \n  \
            LM%2:                           \n  \
                "  : "=a" (__rslt)              \
                   : "0" ((char *)(jmpbuf)), "p" (__LINE__) \
                   : "ecx","edx" );             \
            __rslt;                             \
        })

#    endif /* not SHAREDLIBCODE */

#   else /* !defined(ELF) */

#    define setjmp_VERSION4 /* works */


#    ifdef setjmp_VERSION5
     /*
      * eliminates the setjmp-return-value check
      * (requires that longreturn is available)
      */
#     define stx_setjmp(jmpbuf)                      \
        ({                                      \
            int __rslt;                         \
            asm volatile("                  \n  \
                 movl  %%ebx, 0(%1)         \n  \
                 movl  %%esi, 4(%1)         \n  \
                 movl  %%edi, 8(%1)         \n  \
                 movl  %%ebp, 12(%1)        \n  \
                 movl  %%esp, 16(%1)        \n  \
                 leal  0f, %%ecx            \n  \
                 movl  %%ecx, 20(%1)        \n  \
                 jmp   9f                   \n  \
            0:                              \n  \
                "  : "=a" (__rslt)              \
                   : "0" ((char *)(jmpbuf))     \
                   : "ecx","edx" );             \
            __rslt;                             \
        })

#     define __CONT__                            \
         asm volatile("9:");

#    endif /* setjmp_VERSION5 */


#    ifdef setjmp_VERSION4
#     define stx_setjmp(jmpbuf)                      \
        ({                                      \
            int __rslt;                         \
            asm volatile("                  \n  \
                 movl  %%ebx, 0(%1)         \n  \
                 movl  %%esi, 4(%1)         \n  \
                 movl  %%edi, 8(%1)         \n  \
                 movl  %%ebp, 12(%1)        \n  \
                 movl  %%esp, 16(%1)        \n  \
                 leal  0f, %%ecx            \n  \
                 movl  %%ecx, 20(%1)        \n  \
                 xorl  %%eax, %%eax         \n  \
            0:                              \n  \
                "  : "=a" (__rslt)              \
                   : "0" ((char *)(jmpbuf))     \
                   : "ecx","edx" );             \
            __rslt;                             \
        })

#    endif /* setjmp_VERSION4 */


#    ifdef __OPTSPACE2__
     /*
      * nope - redefine it to call setjmp
      * this requires some more cycles, though
      */
#     undef __CONT__
#    endif

#   endif /* not ELF */
#  endif /* not STC */
# endif /* 32bit & GNUC */

# ifndef stx_setjmp
#  define stx_setjmp(j)      qsetjmp(j)
# endif
# ifndef stx_longjmp
#  define stx_longjmp(j,v)   qlongjmp(j,v)
# endif
# ifndef stx_longrestart
#  define stx_longrestart(j) qlongjmp(j,0)
# endif

#endif /* __CPU_I386_H__ */
