/*
 * $Header: /cvs/stx/stx/stc/cpu_mc68k.h,v 1.3 2007/01/17 18:53:31 cg Exp $
 */

/*
 * COPYRIGHT (c) 1995 by Claus Gittinger
 *              All Rights Reserved
 *
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

#ifndef __CPU_MC68K_H__
# define __CPU_MC68K_H__



# define CPU_DEFINE "-D__mc68k__"

# define __CPU__m68000__        68000
# define __CPU__m68010__        68010
# define __CPU__m68020__        68020
# define __CPU__m68030__        68030
# define __CPU__m68040__        68040
# define __DEFAULT_CPU__        __CPU__m68020__

# define SIGNED_SHIFTS
# define ARG_ORDER_NORMAL

# if !defined(__MSBFIRST__)
#  define __MSBFIRST__
# endif

# if !defined(HAS_SIGNED_CHAR)
#  define HAS_SIGNED_CHAR
# endif

/*
 * ADD_IO_IO -> int-object + int-object
 * ADD_IO_I  -> int-object + integer
 * SUB_IO_IO -> int-object - int-object
 * SUB_IO_I  -> int-object - integer
 */
# if defined(__GNUC__) && defined(POSITIVE_ADDRESSES)
#  define _ADD_IO_IO(__op1, __op2)               \
    ({                                          \
	int __rslt;                             \
	asm(".globl MKLARGEINTov_a      \n      \
	     movel %1,%0                \n      \
	     addl  %2,%0                \n      \
	     bvc   0f                   \n      \
	     movel %0,d0                \n      \
	     bsr   MKLARGEINTov_a       \n      \
	     movel d0,%0                \n      \
	     bra   1f                   \n      \
	0:                              \n      \
	     orib  #16,ccr              \n      \
	     roxrl #1,%0                \n      \
	1:                              \n      \
			"  : "&=d" (__rslt)     \
			   : "g" (((int)(__op1))<<1), "g" (((int)(__op2))<<1) \
			   : "d0" CC_GLOB);     \
	(OBJ)__rslt;                            \
     })

#  define _ADD_IO_I(__op1, __int2)       _ADD_IO_IO(__op1, __int2)

#  define _RANGE_1(i) ((((i)<<1) >= 1) && (((i)<<1) <= 8))
#  define _ADD_IO_I_1(__op1, __int2)             \
    ({                                          \
	int __rslt;                             \
	asm(".globl MKLARGEINTov_a      \n      \
	     movel %1,%0                \n      \
	     addql %2,%0                \n      \
	     bvc   0f                   \n      \
	     movel %0,d0                \n      \
	     bsr   MKLARGEINTov_a       \n      \
	     movel d0,%0                \n      \
	     bra   1f                   \n      \
	0:                              \n      \
	     orib  #16,ccr              \n      \
	     roxrl #1,%0                \n      \
	1:                              \n      \
			"  : "&=d" (__rslt)     \
			   : "g" (((int)(__op1))<<1), "i" (((__int2))<<1) \
			   : "d0" CC_GLOB);     \
	(OBJ)__rslt;                            \
     })

#  define _SUB_IO_IO(__op1, __op2)              \
    ({                                          \
	int __rslt;                             \
	asm(".globl MKLARGEINTov_s      \n      \
	     movel %1,%0                \n      \
	     subl  %2,%0                \n      \
	     bvc   0f                   \n      \
	     movel %0,d0                \n      \
	     bsr   MKLARGEINTov_s       \n      \
	     movel d0,%0                \n      \
	     bra   1f                   \n      \
	0:                              \n      \
	     orib  #16,ccr              \n      \
	     roxrl #1,%0                \n      \
	1:                              \n      \
			"  : "&=d" (__rslt)     \
			   : "g" (((int)(__op1))<<1), "g" (((int)(__op2))<<1) \
			   : "d0" CC_GLOB);     \
	(OBJ)__rslt;                            \
     })

#  define _SUB_IO_I(__op1, __op2)        _SUB_IO_IO(__op1, __op2)

#  define _SUB_IO_I_1(__op1, __int2)             \
    ({                                          \
	int __rslt;                             \
	asm(".globl MKLARGEINTov_s      \n      \
	     movel %1,%0                \n      \
	     subql %2,%0                \n      \
	     bvc   0f                   \n      \
	     movel %0,d0                \n      \
	     bsr   MKLARGEINTov_s       \n      \
	     movel d0,%0                \n      \
	     bra   1f                   \n      \
	0:                              \n      \
	     orib  #16,ccr              \n      \
	     roxrl #1,%0                \n      \
	1:                              \n      \
			"  : "&=d" (__rslt)     \
			   : "g" (((int)(__op1))<<1), "i" (((__int2))<<1) \
			   : "d0" CC_GLOB);     \
	(OBJ)__rslt;                            \
     })

# endif /* __GNUC__ && POSITIVE_ADDRESSES */

/*
 * block move macros - make some things slightly faster (but not much)
 */

# if defined(__GNUC__)
/*
 * mc68k can use moveml for block-moves
 */
#  define MOVE4LONGS(src, dst)                                \
      asm ("moveml %1@,#0x000f                            \n \
	    moveml #0x000f,%0@"                              \
	   : /* no output */                                 \
	   : "a" ((char *)dst)                               \
	   , "a"  ((char *)src)                              \
	   : "d0", "d1", "d2", "d3"                          \
	  );

#  define __getStack__()                                          \
	({                                                         \
	    int __rslt;                                            \
	    asm("movl sp,%0" : "=a" (__rslt) : /* no input */);    \
	    __rslt;                                                \
	})

/*
 * stack switching - switch to a new stack
 */
#  define __switchStack__(sp)                                     \
	asm volatile ("movl %0, sp" : /* no output */ : "a" (sp) );

# endif


#endif /* __CPU_MC68K_H__ */
