/*
 * $Header: /cvs/stx/stx/stc/cpu_sparc.h,v 1.4 2007/01/18 15:35:01 cg Exp $
 */

/*
 * COPYRIGHT (c) 1995 by Claus Gittinger
 *              All Rights Reserved
 *
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

#ifndef __CPU_SPARC_H__
# define __CPU_SPARC_H__



# define CPU_DEFINE "-D__sparc__"

# define __CPU__sparcV7__       70
# define __CPU__sparcV8__       80
# define __CPU__sparcV8_plus__  81
# define __CPU__sparcV9__       90
# define __DEFAULT_CPU__        __CPU__sparcV8__

# ifndef __POINTER_SIZE__
#  if defined(__sparc64__)
#   define __POINTER_SIZE__  8
#  endif
# endif

# if 0
#  define INT_TAG_ZERO
#  define N_TAG_BITS 2
# endif

# define SIGNED_SHIFTS

# if !defined(__MSBFIRST__)
#  define __MSBFIRST__
# endif

# if !defined(HAS_SIGNED_CHAR)
#  define HAS_SIGNED_CHAR
# endif

# define EASY_VAR_ARGS

# define stx_setjmp(j)      _setjmp(j)
# define stx_longjmp(j,v)   _longjmp(j,v)
# define stx_longrestart(j) _longrestart(j)
# define HAVE_LONGRESTART

/*
 * ADD_IO_IO -> int-object + int-object
 * ADD_IO_I  -> int-object + integer
 * SUB_IO_IO -> int-object - int-object
 * SUB_IO_I  -> int-object - integer
 */

# if defined(__GNUC__) && !defined(INT_TAG_ZERO) && (__POINTER_SIZE__ == 4)
#  define _ADD_IO_IO(__op1, __op2)               \
    ({                                          \
	int __rslt;                             \
	asm(".globl __MKLARGEINTov_a         \n \
	     sub   %1, %%lo(1), %%o0         \n \
	     addcc %%o0,%2,%%o0              \n \
	     bvc   0f                        \n \
	     mov   %%o0, %0                  \n \
	     call  __MKLARGEINTov_a          \n \
	     nop                             \n \
	     mov   %%o0,%0                   \n \
	0:                                   \n \
	    "   : "=r" (__rslt)                 \
		: "r" (__op1), "r" (__op2)      \
		: "o0","cc");                   \
	(OBJ)__rslt;                            \
     })

#  define _ADD_IO_I(__op1, __int2)               \
     ({                                         \
	int __rslt;                             \
	asm(".globl __MKLARGEINTov_a         \n \
	     addcc %1,%2,%%o0                \n \
	     bvc   0f                        \n \
	     mov   %%o0, %0                  \n \
	     call  __MKLARGEINTov_a          \n \
	     nop                             \n \
	     mov   %%o0,%0                   \n \
	0:                                   \n \
	    "   : "=r" (__rslt)                 \
		: "r" (__op1), "r" (__int2<<N_TAG_BITS)      \
		: "o0", "cc");                  \
	(OBJ)__rslt;                            \
     })

#  define _SUB_IO_IO(__op1, __op2)               \
    ({                                          \
	int __rslt;                             \
	asm(".globl __MKLARGEINTov_s         \n \
	     sub   %2, %%lo(1), %%o0         \n \
	     subcc %1, %%o0, %%o0            \n \
	     bvc   0f                        \n \
	     mov   %%o0, %0                  \n \
	     call  __MKLARGEINTov_s          \n \
	     nop                             \n \
	     mov   %%o0,%0                   \n \
	0:                                   \n \
	    "   : "=r" (__rslt)                 \
		: "r" (__op1), "r" (__op2)      \
		: "o0", "cc");                  \
	(OBJ)__rslt;                            \
     })

#  define _SUB_IO_I(__op1, __int2)               \
     ({                                         \
	int __rslt;                             \
	asm(".globl __MKLARGEINTov_s         \n \
	     subcc %1,%2,%%o0                \n \
	     bvc   0f                        \n \
	     mov   %%o0, %0                  \n \
	     call  __MKLARGEINTov_s          \n \
	     nop                             \n \
	     mov   %%o0,%0                   \n \
	0:                                   \n \
	    "   : "=r" (__rslt)                 \
		: "r" (__op1), "r" (__int2<<N_TAG_BITS)      \
		: "o0", "cc");                  \
	(OBJ)__rslt;                            \
     })
# endif

/*
 * block move macros - make some things slightly faster (but not much)
 */

/*
 * sparc can use double-load/store for block-moves
 * but: works only if double aligned
 * Claus: disabled those macros; they may be slow
 * on sparcV9 systems, where ldd is emulated.
 * Sigh: ldx is ONLY available on sparcV9, so it cannot
 * be used.
 */
# if defined(sparcV9) && defined(__GNUC__)
#  define MOVE4LONGS(src, dst)                                \
      asm ("ldd [%1],%%o2                                  \n \
	    std %%o2,[%0]                                  \n \
	    ldd [%1+8],%%o2                                \n \
	    std %%o2,[%0+8]                                \n \
	   "                                                  \
	   : /* no output */                                  \
	   : "r" ((char *)dst)  , "r" ((char *)src)           \
	   : "o2", "o3"                                       \
	  );

#  define MOVE8LONGS(src, dst)                                \
      asm ("ldd [%1],%%o2                                  \n \
	    std %%o2,[%0]                                  \n \
	    ldd [%1+8],%%o2                                \n \
	    std %%o2,[%0+8]                                \n \
	    ldd [%1+16],%%o2                               \n \
	    std %%o2,[%0+16]                               \n \
	    ldd [%1+24],%%o2                               \n \
	    std %%o2,[%0+24]                               \n \
	   "                                                  \
	   : /* no output */                                  \
	   : "r" ((char *)dst)  , "r" ((char *)src)           \
	   : "o2", "o3"                                       \
	  );

#  define MOVE16LONGS(src, dst)                               \
      asm ("ldd [%1],%%o2                                  \n \
	    std %%o2,[%0]                                  \n \
	    ldd [%1+8],%%o2                                \n \
	    std %%o2,[%0+8]                                \n \
	    ldd [%1+16],%%o2                               \n \
	    std %%o2,[%0+16]                               \n \
	    ldd [%1+24],%%o2                               \n \
	    std %%o2,[%0+24]                               \n \
	    ldd [%1+32],%%o2                               \n \
	    std %%o2,[%0+32]                               \n \
	    ldd [%1+40],%%o2                               \n \
	    std %%o2,[%0+40]                               \n \
	    ldd [%1+48],%%o2                               \n \
	    std %%o2,[%0+48]                               \n \
	    ldd [%1+56],%%o2                               \n \
	    std %%o2,[%0+56]                               \n \
	   "                                                  \
	   : /* no output */                                  \
	   : "r" ((char *)dst)  , "r" ((char *)src)           \
	   : "o2", "o3"                                       \
	  );
# endif /* sparcV9 */

#endif /* __CPU_SPARC_H__ */
