/*
 * $Header: /cvs/stx/stx/stc/stcIntern.h,v 1.112 2012/01/23 14:46:02 cg Exp $
 */
/*
 * COPYRIGHT (c) 1988 by Claus Gittinger
 *              All Rights Reserved
 *
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */
/*
 * common definitions for stc - compiler and runtime library
 * Will be later replaced by an interactive program or self-configuration
 * (well I hope it will :-)
 */

#ifndef __STCINTERN_H__
# define __STCINTERN_H__

#define METHOD_IN_CONTEXT               /* you have to remove the instvar in context if you disable this */
#define SUPPORT_EXTERNAL_LOOKUP
#define LOOKUP_OBJECT_IN_BEHAVIOR      /* you have to remove the instvar in behavior if you disable this */
#define LOOKUP_OBJECT_IN_METHOD        /* you have to remove the instvar in method if you disable this */

#define xxxMETHOD_IN_ILC
#define xxSELECTOR_IN_METHOD            /* not really needed - once we have the mclass, getting the selector is easy */
#define ANNOTATION_IN_METHOD          /* leave that in the annotatedMethod */



/*
 * these two can no longer be turned off ...
 */
#define THIS_CONTEXT
#define STACK_PROBES

#define __UNROLL_LOOPS__

/*
 * map all ns32k cpus to ns32k
 */
#ifndef ns32k
# if defined(ns32032) || defined(ns32332) || defined(ns32532)
#  define ns32k
# endif
# if defined(ns32016) || defined(ns32000)
#  define ns32k
# endif
#endif

#if defined(alpha64) || defined(__alpha64__)
# define __alpha__
# ifndef alpha64
#  define alpha64
# endif
# ifndef __alpha64__
#  define __alpha64__
# endif
#endif

#if defined(__alpha) || defined(__alpha__)
# ifndef alpha
#  define alpha
# endif
# ifndef __alpha__
#  define __alpha__
# endif
#endif

/*
 * sun3 stands for sunos and 68k cpu
 */
#if defined(sun3)
# ifndef sunos
#  define sunos
# endif
# ifndef mc68k
#  define mc68k
# endif
# ifndef __mc68k__
#  define __mc68k__
# endif
#endif

/*
 * sun386i stands for sunos4.x and 386 cpu
 */
#if defined(sun386i)
# ifndef sunos
#  define sunos
# endif
# ifndef i386
#  define i386
# endif
# ifndef __i386__
#  define __i386__
# endif
#endif

/*
 * solaris / solaris2_0 stand for SYSV4 and sparc cpu
 * sun4 stands for sunos and sparc cpu
 */
#ifdef solaris2_0
# ifndef solaris
#  define solaris
# endif
#endif
#ifdef solaris
# ifndef SYSV4
#  define SYSV4
# endif
#endif

#if defined(sun4) || defined(sun5)
# ifndef solaris
#  ifndef sunos
#   define sunos
#  endif
# endif
# if !defined(__x86__) && !defined(__i386__) && !defined(i386)
#  ifndef sparc
#   define sparc
#  endif
#  ifndef __sparc__
#   define __sparc__
#  endif
# endif
#endif

/*
 * NEXT stands for BSD-like, mach and 68k cpu
 * (maybe this will change when new NeXTs arrive)
 * late news: forget it !
 */
#if defined(NEXT)
# if !defined(mc68k) && !defined(__mc68k__) && !defined(i386) && !defined(__i386__) && !defined(hppa) && !defined(__hppa__) && !defined(sparc) && !defined(__sparc__)
   /* default to 68k if not stated otherwise */
#  define mc68k
#  define __mc68k__
# endif
# ifndef BSD
#  define BSD
# endif
# ifndef MACH
#  define MACH
# endif
#endif

#if defined(OSX) || defined(__osx__)
# define MACH
# if !defined(i386) && !defined(__i386__)
#  define powerPC
#  define __powerPC__
# endif
#endif

/*
 * amd is also a kind of 386 cpu
 */
#if defined(__amd64__)
# ifndef __i386__
#  define __i386__
# endif
#endif

#if defined(__amd64_mode32__)
# ifdef __amd64__
#  undef __amd64__
# endif
# ifndef __i386__
#  define __i386__
# endif
#endif

/*
 * WIN32, WINNT stand for i386, if not stated otherwise
 */
#if defined(WINNT)
# ifndef WIN32
#  define WIN32
# endif
#endif

#if defined(WIN32)
# ifdef WIN32THREADS
#if 0
#  define __PROBE__(f, arg)
#  define __PROBE_N__(f, arg, n)
#endif
# endif
# if !defined(i386) && !defined(__i386__) && !defined(mips) && !defined(__mips__) && !defined(alpha) && !defined(__alpha__)
#  define i386
#  define __i386__
# endif
#endif

/*
 * ultrix
 */
#if defined(ultrix4_4)
# define ultrix
#endif

/*
 * sunos 4.x is bsd like
 */
#if defined(sunos) && !defined(solaris)
# define BSD
#endif

#if defined (solaris) || defined(solaris2_0)
# undef BSD
#endif

/*
 * sinix and dynix are sometimes bsd like
 */
#if defined(sinix) || defined(dynix)
# if defined(ATT)
#  define SYSV
# else
#  define BSD
# endif
#endif

/*
 * hpux is SYSV-like
 */
#if defined(hpux10) || defined(hpux11)
# ifndef hpux
#  define hpux
# endif
#endif

#if defined(hpux)
# define SYSV3
#endif

/*
 * irix5 is a sys5.4
 */
#if defined(IRIX5)
# define SYSV4
# define IRIS
#endif

#if defined(unixware)
# define SYSV4
#endif

#if defined(SYSV4) && !defined(solaris)
# if defined(i386) || defined(__i386__)
#  define SYSV4i386
#  ifndef __ASSEMBLER__
/*
 * some defines in this file collide with definitions in
 * function prototypes. So we include the function prototypes before
 * redefining the symbols.
 */
#   include <string.h>
#   include <memory.h>
#  endif
# endif
#endif

/*
 * sco and isc are always SYS5-like
 */
#if defined(sco2_3) || defined(sco3_2)
# ifndef sco
#  define sco
# endif
#endif

#if defined(sco) || defined(isc3_2)
# ifndef __i386__
#  define __i386__
# endif
# define SYSV3
#endif

/*
 * unify vax and __vax__
 */
#if defined(VAX) || defined(__VAX__) || defined(vax) || defined(__vax__)
# ifndef __vax__
#  define __vax__
# endif
# ifndef vax
#  define vax
# endif
#endif

/*
 * unify i386 and __i386__
 */
#if defined(i386) || defined(__i386__) || defined(__x86__)
# ifndef __i386__
#  define __i386__
# endif
# ifndef i386
#  define i386
# endif
#endif

/*
 * unify ia64 and __ia64__
 */
#if defined(ia64) || defined(__ia64__)
# ifndef __ia64__
#  define __ia64__
# endif
# ifndef ia64
#  define ia64
# endif
#endif

/*
 * unify sparc and __sparc__
 */
#if defined(sparc) || defined(__sparc__)
# ifndef __sparc__
#  define __sparc__
# endif
# ifndef sparc
#  define sparc
# endif
#endif

/*
 * unify powerPC and __powerPC__
 */
#if defined(powerPC) || defined(__powerPC__)
# ifndef __powerPC__
#  define __powerPC__
# endif
# ifndef powerPC
#  define powerPC
# endif
#endif

/*
 * unify mips and __mips__
 */
#if defined(mips) || defined(__mips__)
# ifndef __mips__
#  define __mips__
# endif
# ifndef mips
#  define mips
# endif
#endif

/*
 * unify mc68k and __mc68k__
 */
#if defined(mc68k) || defined(__mc68k__)
# ifndef __mc68k__
#  define __mc68k__
# endif
# ifndef mc68k
#  define mc68k
# endif
#endif

/*
 * unify mc88k and __mc88k__
 */
#if defined(mc88k) || defined(__mc88k__)
# ifndef __mc88k__
#  define __mc88k__
# endif
# ifndef mc88k
#  define mc88k
# endif
#endif

/*
 * unify s390 and __s390__
 */
#if defined(s390) || defined(__s390__)
# ifndef __s390__
#  define __s390__
# endif
# ifndef s390
#  define s390
# endif
#endif

/*
 * unify arm and __arm__
 */
#if defined(arm) || defined(__arm__)
# ifndef __arm__
#  define __arm__
# endif
# ifndef arm
#  define arm
# endif
#endif

/*
 * unify hppa and __hppa__
 */
#if defined(hppa) || defined(__hppa__)
# ifndef __hppa__
#  define __hppa__
# endif
# ifndef hppa
#  define hppa
# endif
#endif

/*
 * unify transputer and __transputer__
 */
#if defined(transputer) || defined(__transputer__)
# ifndef __transputer__
#  define __transputer__
# endif
# ifndef transputer
#  define transputer
# endif
#endif

/*
 * SVR4 is a SYS5
 */
#if defined(SYSV4)
# define SYSV
#endif

#if defined(SYSV3)
# define SYSV
#endif

#if defined(_AIX) && !defined(aix)
# define aix
#endif
#if defined(aix) && !defined(_AIX)
# define _AIX
#endif

/*
 * interactive made a horrible mess in /usr/include
 */
#if defined(isc3_2) && defined(__STDC__)
# undef __STDC__
#endif

/*
 * osf is bsd-like
 */
#if defined __osf__
# define BSD
#endif

/*
 * vms
 */
#if defined(__openVMS__)
# ifndef __VMS__
#  define __VMS__
# endif
#endif
#if defined(__vms__) || defined(__VMS__) || defined(vms) || defined(VMS)
# ifndef __VMS__
#  define __VMS__
# endif
#endif

/*
 * everything else is a UNIX
 */
#ifndef UNIX
# if !defined(VMS) && !defined(WIN32) && !defined(MACOS) && !defined(BEOS)
#  define UNIX
# endif
#endif

/*
 * ################# machine specific stuff - moved into separate include file ######################
 */
#ifdef IRIS
# include "sgiIntern.h"
#endif

#ifdef NEXT
# include "nextIntern.h"
#endif

#ifdef LINUX
# include "linuxIntern.h"
#endif

#ifdef FREEBSD
# include "freeBSDIntern.h"
#endif

#ifdef ultrix
# include "ultrixIntern.h"
#endif

#ifdef hpux
# include "hpuxIntern.h"
#endif

#ifdef _AIX
# include "aixIntern.h"
#endif

#if defined(SYSV4i386)
# include "sysv4i386Intern.h"
#endif

#if defined(realIX)
# include "realIXIntern.h"
#endif

#if defined(sunos) || defined(solaris)
# include "sunIntern.h"
#endif

#if defined(__qnx__)
# include "qnxIntern.h"
#endif

#if defined(MAC)
# include "macIntern.h"
#endif

#if defined(WIN32) || defined(WINNT)
# if defined(__BORLANDC__)
#  define EXPORT    __export
#  define FASTCALL  __fastcall
# else
#  if defined(__VISUALC__)
#   define EXPORT    /* nothing */
#   define FASTCALL  __fastcall
#  else
#   define EXPORT   /* nothing */
#   define FASTCALL /* nothing */
#  endif
# endif
# include "ntIntern.h"
#else
# define EXPORT   /* nothing */
# define FASTCALL /* nothing */
# define DLL_EXPORT  /* as nothing - redefined for win32 */
# define DLL_IMPORT  /* as nothing - redefined for win32 */
#endif

#if defined(alpha)
# include "alphaIntern.h"
#endif


#if defined(__GNUC__) && !defined(NO_SECTION_ATTRIBUTES)
# if (__GNUC__  == 2 && __GNUC_MINOR__ >= 7) || __GNUC__ > 2
#  undef INIT_TEXT_SECTION
#  define INIT_TEXT_SECTION __attribute__((section(".stxitext")))
# endif
#endif /* GNUC */

#if !defined(INIT_TEXT_SECTION)
# define INIT_TEXT_SECTION /* nothing */
#endif

/*
 * ################# machine/compiler dependencies ######################
 */

/*
 * value found in cpuType ...
 */
#define __CPU_UNKNOWN__         0

#if defined(__i386__) || defined(__x86__)
# include "cpu_i386.h"
#endif

#ifdef __hppa__
# include "cpu_hppa.h"
#endif

#if defined(__rs6k__) || defined(__powerPC__)
# include "cpu_power.h"
#endif

#if defined(__alpha__)
# include "cpu_alpha.h"
#endif

#if defined(__mc68k__)
# include "cpu_mc68k.h"
#endif

#if defined(__mips__)
# include "cpu_mips.h"
#endif

#if defined(__sparc__)
# include "cpu_sparc.h"
#endif

#if defined(__s390__)
# include "cpu_s390.h"
#endif

#if defined(__vax__)
# include "cpu_vax.h"
#endif

#ifndef __DEFAULT_CPU__
# define __DEFAULT_CPU__        __CPU_UNKNOWN__
#endif

/*
 * library stuff ..
 * none of these is needed to compile and run ST/X. But some turn on
 * alternative/better implementations for specific operations.
 *
 * define HAS_OPENDIR if your libc has the opendir function
 *     (if not defined, smalltalk uses a pipe to 'ls' to get the info)
 * define HAS_RENAME if your libc has the opendir function
 *     (if not defined, smalltalk uses link/unlink)
 * define HAS_UNAME or HAS_GETHOSTNAME if your libc has the corresponding function
 *     (if not defined, smalltalk uses a pipe to 'hostname')
 * and so on ...
 */

#if defined(SYSV4) && !defined(IRIX5) && !defined(SYSV4i386) && !defined(solaris)
# define LONGFILENAMES
# define HAS_GETTIMEOFDAY
# define HAS_OPENDIR
# define HAS_RENAME
# define HAS_UNAME
# define HAS_DEV_ZERO
# define HAS_SYSCONF
# define HAS_MMAP
# define HAS_MPROTECT
# define HAS_REALPATH
# define HAS_STRCOLL
# define HAS_SIGACTION
#endif


/*
 * fall back - will be removed
 */
#if !defined(HAS_RENAME)
# if defined(BSD)
#  define HAS_RENAME
# endif
#endif

/*
 * name a type, where sizeof(type) == sizeof(structure *)
 * On most 32bit machines this is int, but there might be machines around
 * using short integers.
 *
 * defining it as != int is untested - there might be places in the code,
 * where I forgot to replace int by INT - watch out.
 *
 * If there is no such type on your machine - forget it
 * or rewrite the macros in stc.h (and maybe much more) - sorry.
 */
#ifndef __POINTER_SIZE__
# define __POINTER_SIZE__   4
#endif

# if __POINTER_SIZE__ == 8
#  define STX_INT       long
#  define STX_INT_SHIFT 3
# else
#  define STX_INT       int
#  define STX_INT_SHIFT 2
# endif

#ifndef INT
# define INT            STX_INT
# define INT_SHIFT      STX_INT_SHIFT
#endif

#ifdef __GNUC__
# define HAS_LONGLONG 1
#endif

/*
 * does your compiler produce a.out or coff or anything else ?
 * hope its a.out - currently only supported format in internal Compiler
 */
#if defined(sunos)
# if defined(sun386i)
#  define COFF
# else
#  define A_DOT_OUT
# endif
#endif

#if defined(sinix) && defined(BSD)
# define A_DOT_OUT
#endif

#if defined(sco) && defined(__GNUC__) && defined(private_gcc)
# define A_DOT_OUT
#endif

#if defined(LINUX)
# define A_DOT_OUT
#endif

#if defined(sco3_2)
# define COFF
#endif

#if defined(dynix) && defined(i386) && defined(BSD)
# define A_DOT_OUT
#endif

#if defined(MACH)
# define MACH_O
#endif

/*
 * fallback, knowing that all SYSV4 systems use ELF
 * all SYSV3 systems use COFF
 */
#if !defined(ELF) && !defined(COFF) && !defined(A_DOT_OUT) && !defined(MACH_O)
# if defined(SYSV)
#  if defined(SYSV4)
#   define ELF
#  else
#   define COFF
#  endif
# endif
#endif

/*
 * does your compiler limit the number of valid chars in an identifier
 */
#if defined(sco) || defined(microsoft)
# define SHORTNAMES
#endif

#if defined(sinix) && defined(ATT)
# define SHORTNAMES
#endif

/*
 * does your machine preserve sign bit when doing right shifts ? (see stc.h)
 * EFFECT -> slower value-fetch value from SmallInteger objects if left undef.
 */
#ifndef SIGNED_SHIFTS
# if defined(someCPUWithSignedShifts)
#  define SIGNED_SHIFTS
# endif
#endif

#if defined(someMachineWithLSBFirst)
# define __LSBFIRST__
#endif
#if defined(someMachineWithMSBFirst)
# define __MSBFIRST__
#endif

#if defined(MSBFIRST) && !defined(LSBFIRST)
# ifndef __MSBFIRST__
#  define __MSBFIRST__
# endif
#else
# if defined(LSBFIRST) && !defined(MSBFIRST)
#  ifndef __LSBFIRST__
#   define __LSBFIRST__
#  endif
# endif
#endif

#if defined(__MSBFIRST) && !defined(__LSBFIRST)
# ifndef __MSBFIRST__
#  define __MSBFIRST__
# endif
#else
# if defined(__LSBFIRST) && !defined(__MSBFIRST)
#  ifndef __LSBFIRST__
#   define __LSBFIRST__
#  endif
# endif
#endif

#if defined(__LSBFIRST__)
# define LSBFIRST
# define __LSBFIRST
#endif
#if defined(__MSBFIRST__)
# define MSBFIRST
# define __MSBFIRST
#endif
#if defined(__LSBFIRST__) && defined(__MSBFIRST__)
error both LSB and MSB - this should not happen.
#endif

#ifdef sun3
# define __HAS_ALIGN2__
#endif

/*
 * define this if cpu passes arguments by pushing them onto a stack
 * (in contrast to register window machines)
 * EFFECT -> can fill context lazy from arguments
 */
#ifdef NO_TRADITIONAL_STACK_FRAME
# undef TRADITIONAL_STACK_FRAME
#endif

/*
 * define this, if arguments are stored reverse on the stack and
 * stack grows downward.
 * i.e. last argument is pushed first, having highest address
 * EFFECT -> can fill context lazy from arguments
 */
#ifdef someMachine
# define ARG_ORDER_NORMAL
#endif

#ifdef someOtherMachine
# define ARG_ORDER_REVERSE
#endif

/*
 * define this, if VAR-ARGS are always possible without special
 * declaration (I think this is always true for TRADITIONAL_STACK_FRAME)
 * EFFECT -> faster calling in some places
 */
#ifndef EASY_VAR_ARGS
# if defined(TRADITIONAL_STACK_FRAME)
#  define EASY_VAR_ARGS
# endif
#endif

/*
 * instead of writing foo / sizeof(long)
 * it is better on some machines to use a shift
 * (the compiler seems to not detect power-of-two divisions ...)
 * This is hidden in the following macros ...
 */
#if !defined(__BYTES2OBJS__) || !defined(__OBJS2BYTES__)

# if defined(USE_SHIFT_FOR_DIVISION_AND_MULTIPLICATION)
#  define __BYTES2OBJS__(x)  ((x) >> INT_SHIFT)
#  define __OBJS2BYTES__(x)  ((x) << INT_SHIFT)
# else
#  define __BYTES2OBJS__(x)  ((x) / sizeof(OBJ))
#  define __OBJS2BYTES__(x)  ((x) * sizeof(OBJ))
# endif
#endif

#ifdef OLD
/*
 * old: generates two conditional branches
 * may generate shorter code sequence on old CPUs (68k)
 */
# define __ISVALIDINTEGER(i)    (((i) >= _MIN_INT) && ((i) <= _MAX_INT))
#else
/*
 * new: another instruction, but only one branch
 * better on modern pipelined CPUs
 */
# define __ISVALIDINTEGER(i)    (((INT)(i) ^ ((INT)(i)<<1)) >= 0)
#endif

/*
 * default macros - no asm support
 * (these work always)
 *
 * ADD_IO_IO -> int-object + int-object
 * ADD_IO_I  -> int-object + integer
 * SUB_IO_IO -> int-object - int-object
 * SUB_IO_I  -> int-object - integer
 */
#ifndef _ADD_IO_IO
# define _ADD_IO_IO(a,b)        \
    ((__tttI = (__smallIntegerVal(a) + __smallIntegerVal(b))), \
     __ISVALIDINTEGER(__tttI) \
     ? __MKSMALLINT(__tttI) : __MKLARGEINT(__tttI))
# define _ADD_IO_I(a,b) \
    ((__tttI = (__smallIntegerVal(a) + b)), \
     __ISVALIDINTEGER(__tttI) \
     ? __MKSMALLINT(__tttI) : __MKLARGEINT(__tttI))
#endif

#ifndef _SUB_IO_IO
# define _SUB_IO_IO(a,b)        \
    ((__tttI = (__smallIntegerVal(a) - __smallIntegerVal(b))), \
     __ISVALIDINTEGER(__tttI) \
     ? __MKSMALLINT(__tttI) : __MKLARGEINT(__tttI))
# define _SUB_IO_I(a,b) \
    ((__tttI = (__smallIntegerVal(a) - b)), \
     __ISVALIDINTEGER(__tttI) \
     ? __MKSMALLINT(__tttI) : __MKLARGEINT(__tttI))
#endif

#ifndef _ADD_IO_2
# define _ADD_IO_2(a) _ADD_IO_IO(a,a)
#endif

#ifdef LATER

#if TAG_INT==1
# define _ADD_IO_1(op)   (((op) != __MKSMALLINT(_MAX_INT)) \
			 ? (OBJ)((INT)(op) + (INT)(__MASKSMALLINT(1))) \
			 : __minPositiveLargeInteger)

# define _SUB_IO_1(op)   (((op) != __MKSMALLINT(_MIN_INT)) \
			 ? (OBJ)((INT)(op) - (INT)(__MASKSMALLINT(1))) \
			 : __maxNegativeLargeInteger)
#else  /* TAG_INT != 1 */
# define _ADD_IO_1(op)   ((op == __MKSMALLINT(_MAX_INT)) \
			 ? __minPositiveLargeInteger \
			 : __MKSMALLINT(__smallIntegerVal(op) + 1))

# define _SUB_IO_1(op)   ((op == __MKSMALLINT(_MIN_INT)) \
			 ? __maxNegativeLargeInteger \
			 : __MKSMALLINT(__smallIntegerVal(op) - 1))
#endif /* TAG_INT != 1 */

#else /* !LATER */

# define _ADD_IO_1(op)  _ADD_IO_I(op, 1)
# define _SUB_IO_1(op)  _SUB_IO_I(op, 1)
#endif /* !LATER */

#ifndef __ALIGN__
# define __ALIGN__ sizeof(int)
#endif

/*
 * workaround for a bug in the gnu (1.34) compiler, which does not like
 * (double) casts in initializers.
 * (other compilers need the casts - oh well)
 */
#ifdef __GNUC__
# define NO_CAST_IN_INITIALIZER
#endif

/*
 * workaround for optimizing compilers (gnu-1.39 and above) compilers,
 * which do not honor volatile keyword in some constellations:
 * It may be due to the evaluation sequence, which computes left-to-
 * right and therefore computes the address on the left of an assignment
 * first ...
 *
 *   f(x)
 *      volatile OBJ x;
 *   {
 *      struct {
 *          OBJ *pX;
 *          ...
 *      } y;
 *
 *      y.pX = &x;
 *      x->field = g(&y);        -- changes *(y->pX)
 *      -- access is through old-x (in register)
 *
 * the workaround is to introduce another temporary (funny - it will be
 * optimized away !) ala:
 *
 *      OBJ ttt;
 *
 *      ttt = g(&y);
 *      x->field = ttt;
 */
#if defined(__GNUC__) || defined(SOME_OTHER_COMPILERS)
# define ASSIGNMENT_ORDER_CARES
#endif

#if defined(PCS) && defined(__mips__)
# define ASSIGNMENT_ORDER_CARES
#endif

/* just to make sure ... */
#ifndef ASSIGNMENT_ORDER_CARES
# define ASSIGNMENT_ORDER_CARES
#endif

/*
 * some c-compilers need an extern declaration (which is wrong)
 * others want static (which is correct),
 * when referencing a static before its definition.
 * define to be either: static, extern or empty.
 * if you don't know what to put in here, try compiling libbasic first
 * and watch for compiler barking about redeclaration of endOfModule.
 * (see definition/use of *endOfModule in resulting c-file)
 */
#ifndef FORWARD_STATIC

# ifdef __GNUC__
#  define FORWARD_STATIC static
# endif

# if defined(sinix) && defined(ATT)
#  define FORWARD_STATIC static
# endif

# if defined(isc3_2) && !defined(__GNUC__)
#  define FORWARD_STATIC extern
# endif

# if defined(sco3_2)
#  define FORWARD_STATIC extern
# endif

# if defined(hpux) && !defined(__GNUC__)
#  define FORWARD_STATIC int
# endif

# if defined(solaris) && !defined(__GNUC__)
#  define FORWARD_STATIC int
# endif

# if defined(PCS) && defined(__mips__)
#  define FORWARD_STATIC int
# endif

# if defined(IRIX5)
#  define FORWARD_STATIC static
# endif

# if defined(_AIX) && !defined(__GNUC__)
#  define FORWARD_STATIC int
# endif

# if defined(_ANSI_) || defined(__STDC__)
#  undef FORWARD_STATIC
#  define FORWARD_STATIC static
# endif

# ifndef FORWARD_STATIC
#  define FORWARD_STATIC extern
# endif
#endif

#ifndef MODULE_STATIC
# define MODULE_STATIC static
#endif

/*
 * define this to use the __classes list for initialization
 * instead of searching for classes;
 * effect: faster initialization
 */
#define INIT_CLASS_LIST

#ifndef INIT_CLASS_LIST
 /*
  * if you run into deep trouble with any of
  * FORWARD_STATIC, NO_CAST_IN_INITIALIZER or  STATIC_DATA_IS_LINEAR
  * you can also turn the whole mess off with:
  */
# if defined(compilerWhichMakesTrouble) || defined(microsoft)
#  define NO_MODULE_CHAINING
# endif
#endif

#ifdef UPDATE_WHOLE_STACK
/*
 * assume that if we ever implement UPDATE_WHOLE_STACK,
 * we dont care for what the compiler does
 */
# define VOLATILE       /* as nothing */
#else
/*
 * heavily optimizing compilers might move automatics and/or arguments
 * into registers - which we don't want here since gc moves them around
 * - hope your compiler has volatile keyword for that ...
 */
# ifdef COMPILER_DOES_NOT_SUPPORT_VOLATILE
#  define VOLATILE      /* as nothing */
# else
#  define VOLATILE      volatile
# endif
#endif

/*
 * define this, if your linker has an -A option (incremental linking)
 */
#if defined(ultrix) && defined(__mips__)
# define CAN_LINK_INCREMENTAL
#endif

#if defined(dynix) && defined(__i386__)
# define CAN_LINK_INCREMENTAL
#endif

#if defined(sunos) && defined(__i386__)
# define CAN_LINK_INCREMENTAL
#endif

#if defined(sunos) && defined(__sparc__)
# define CAN_LINK_INCREMENTAL
#endif

#if defined(LINUX)
# define CAN_LINK_INCREMENTAL
#endif

/*
 * define this, if you need separate I&D spaces
 */
/* #define NEED_SEPARATE_ID */

/*
 * define this, if you can execute code in data-space
 */
#if defined(ultrix) || defined(sco) || defined(sinix) || defined(dynix)
# define CAN_USE_DATA_FOR_TEXT
#endif

#if defined(sunos)
# define CAN_USE_DATA_FOR_TEXT
#endif

#if defined(NeXT) && defined(mc68k)
# define CAN_USE_DATA_FOR_TEXT
#endif

#if defined(LINUX)
# define CAN_USE_DATA_FOR_TEXT
#endif

/*
 * defines passed on for compilation
 * (see libbasic/Compiler.st for its use)
 */
#ifndef CPU_DEFINE
# define CPU_DEFINE "-DunknownCPU"
#endif

#ifndef OS_DEFINE

# ifdef ultrix
#  define OS_DEFINE "-Dultrix"
# endif

# ifdef sinix
#  ifdef BSD
#   define OS_DEFINE "-Dsinix -DBSD"
#  else
#   define OS_DEFINE "-Dsinix -DATT"
#  endif
# endif

# ifdef dynix
#  ifdef BSD
#   define OS_DEFINE "-Ddynix -DBSD"
#  else
#   define OS_DEFINE "-Ddynix -DATT"
#  endif
# endif

# ifdef sco
#  ifdef sco2_3
#   define OS_DEFINE "-Dsco2_3"
#  else
#   ifdef sco3_2
#    define OS_DEFINE "-Dsco3_2"
#   else
#    define OS_DEFINE "-Dsco"
#   endif
#  endif
# endif

# ifdef PCS
#  define OS_DEFINE "-DPCS"
# endif

# ifdef MVS
#  define OS_DEFINE "-DMVS"
# endif

# ifdef OS2
#  define OS_DEFINE "-DOS2"
# endif

# ifdef MSWIN
#  define OS_DEFINE "-DMSWIN"
# endif

# ifdef __linux__
#  define OS_DEFINE "-D__linux__"
# endif

# ifndef OS_DEFINE
#  define OS_DEFINE "-DunknownOS"
# endif
#endif

/*
 * ####################### configuration ###########################
 */
/*
 * do we want a method cache - YES
 *
 * EFFECT -> runs much slower if undefined
 * (should only be undefd for debugging/statistics)
 */
#define METHOD_CACHE
#define BIG_CACHE

/*
 * some code alternatives (run autoconf to see if its worth doing it)
 *
 * for strings:
 * define FAST_STRING_MEMSET,           if memset is fastest
 * define FAST_STRING_MEMSET_UNROLLED,  if inline-loop is fastest
 *
 * for avg size objects:
 * define FAST_OBJECT_MEMSET,                  if memset is fastest
 * define FAST_OBJECT_MEMSET_WORDS_UNROLLED    if an unrolled loop using longs is fastest
 * define FAST_OBJECT_MEMSET_DOUBLES_UNROLLED  if an unrolled loop using doubles is fastest
 * define FAST_OBJECT_MEMSET_LONGLONG_UNROLLED if an unrolled loop using longlong is fastest
 *
 * for large objects:
 * define FAST_ARRAY_MEMSET,                  if memset is fastest
 * define FAST_ARRAY_MEMSET_WORDS_UNROLLED    if an unrolled loop using longs is fastest
 * define FAST_ARRAY_MEMSET_DOUBLES_UNROLLED  if an unrolled loop using doubles is fastest
 * define FAST_ARRAY_MEMSET_LONGLONG_UNROLLED if an unrolled loop using longlong is fastest
 *
 * define FAST_MEMCPY,       if memcpy-ing is faster than inline-word-loop
 * define FAST_MEMCHR,       if memchr is faster than inline-search
 *
 * EFFECT -> do not expect too much :-)
 * can usually be left unspecified, if in doubt
 * (system will use inline code for small objects, memXXX for large ones)
 */
#ifndef LINUX /* already in linuxIntern */
# ifdef i386
#  if defined(__GNUC__)
#   define FAST_MEMCPY4
#  endif
#  define FAST_STRING_MEMSET
#  define FAST_OBJECT_MEMSET4
#  define FAST_ARRAY_MEMSET4
#  define FAST_MEMCHR
# endif
#endif

#ifdef sco
# define bcopy(src, dst, size)  memcpy(dst, src, size)
#endif

#ifdef __transputer__
# define FAST_MEMCPY
# define bcopy(src, dst, size)  memcpy(dst, src, size)
#endif

#ifdef PCS
# define FAST_MEMSET
# define FAST_MEMCHR
#endif

#if defined(delta88)
# define FAST_MEMSET
# define FAST_MEMSET_WORDS
#endif

#ifdef __sparc__
# undef FAST_MEMSET
# undef FAST_MEMSET_WORDS
# define FAST_MEMSET_UNROLLED
# define FAST_MEMSET_WORDS_UNROLLED
# define FAST_ARRAY_MEMSET_LONGLONG_UNROLLED
# define FAST_MEMCHR
#endif

#ifdef solaris
# define bcopy(src, dst, size)  memcpy(dst, src, size)
# define bzero(dst, count)      memset(dst, 0, count)
#endif

/*
 * some machines do not have strchr, bcopy etc
 */
#ifdef SOME_MACHINE
# define strchr                 index
# define bcopy(src, dst, size)  memcpy(dst, src, size)
# define memset                 .....
#endif

/*
 * if you have a stupid c-compiler, which does no cse (! GNU),
 * you probably want to have heavily used variables in registers;
 * those should define REGISTER as register - others leave it.
 */
#ifndef __GNUC__
# define REGISTER   register
#else
# define REGISTER   /* as nothing */
#endif

/*
 * there should be no need to change this (very kludgy !)
 * see (librun/init.c for its use)
 */
#define MAGIC1          0x01234567
#define MAGIC2          0xAFFEABCD
#define MAGIC3          MAGIC1
#define MAGIC4          MAGIC2

#define __CODE_MAGIC__  0xFEEDBEEF
#define __CODE_RMAGIC__ 0xBEEFFEED

#define MTHD_NORMAL     0
#define MTHD_PROTECTED  1
#define MTHD_PRIVATE    2
#define MTHD_IGNORED    3

#ifndef __ASSEMBLER__

/*
 * some optimized functions
 * can all be left as is - performance win is not spectacular
 */
# ifdef SOME_MACHINE
   /*
    * you may define an assembler function for bcopy-ing blocks of long words
    */
   extern asm_bcopy4();
   extern asm_memset4();
#  define bcopy4(src,dst,sz)     asm_bcopy4(src,dst,sz)
#  define memset4(dst,val,sz)    asm_memset4(dst,val,sz)
# endif

/*
 * most machines provide more info in case of a signal
 * than is defined in posix - make use of that info if
 * possible ...
 */
# if defined(__mc68k__) && defined(NeXT)
#  define SIGARGS        sigNo, sigType, sigContext
#  define SIGARGS_DECL   struct sigcontext *sigContext;
#  define SIGARG_SIGNO   sigNo
# endif

# ifndef SIGARGS
#  ifdef WIN32
#   define SIGARGS        sigNo, sigContext
#   define SIGARGS_DECL   CONTEXT *sigContext;
#   define SIGARG_SIGNO   sigNo
#  else
#   define SIGARGS        sigNo
#   define SIGARGS_DECL   /* nothing */
#   define SIGARG_SIGNO   sigNo
#  endif
# endif

/*
 * block move macros - make some things slightly faster (but not much)
 */
# ifndef MOVE4LONGS
#  define MOVE4LONGS(src, dst)                                \
      *dst = *src;                                            \
      *(dst+1) = *(src+1);                                    \
      *(dst+2) = *(src+2);                                    \
      *(dst+3) = *(src+3);
# endif

# ifndef __CONT__
#  define __CONT__ /* nothing */
# endif

/*
 * stack probing
 */
# if defined(STACK_GROWS_UPWARD)
#  define __LT__    >
#  define __MINUS__ +
#  define __LIMIT__     __stackTop__
#  define __ON_C__      ((char *)-1)
# else
#  define __LT__    <
#  define __MINUS__ -
#  define __LIMIT__     __stackBottom__
#  define __ON_C__      ((char *)0)
# endif

extern char *__LIMIT__;

# if defined(__getStack__)

#  define __PROBE__(f, arg)                                    \
	if ((char *)__getStack__() <= (char *)__stackBottom__) \
	    return (OBJ)__STACK_HANDLER__(f, &(arg));

#  define __PROBE_N__(f, arg, n)                                     \
	if (((char *)__getStack__()-(n)) <= (char *)__stackBottom__) \
	    return (OBJ)__STACK_HANDLER_N__(f, &(arg), n);

# endif /* __i386__ || __mc68k__ */

/*
 * for stack machines (use addr of 1st arg)
 */
# if defined(TRADITIONAL_STACK_FRAME)
#   ifndef __PROBE__
#    define __PROBE__(f, arg)                          \
	if ((char *)(&(arg)) __LT__ (char *)__LIMIT__) \
	    return (OBJ)__STACK_HANDLER__(f, &(arg));
#   endif

#   ifndef __PROBE_N__
#    define __PROBE_N__(f, arg,n)                                       \
	if (((char *)(&(arg))__MINUS__(n)) __LT__ (char *)__LIMIT__)    \
	    return (OBJ)__STACK_HANDLER_N__(f, &(arg), n);
#   endif

#   ifndef __PROBE_U__
#    define __PROBE_U__(f, arg)                        \
	if (__LIMIT__ != __ON_C__)                     \
	    return (OBJ)__STACK_HANDLER_U__(f, &(arg));
#   endif

#   ifndef __PROBE_NN__
#    define __PROBE_NN__(f,arg,n)        __PROBE_N__(f,arg,n)
#   endif

# else /* generic (checking on context) for non-stack machines */
#  define __GENERIC_PROBE__
# endif

#endif /* __ASSEMBLER__ */

/*
 * stupid
 */
#ifndef N_TAG_BITS
# define N_TAG_BITS 1
#endif

#if (__POINTER_SIZE__ == 8)
# define _MAX_INT       (INT)(0x3FFFFFFFFFFFFFFFL >> (N_TAG_BITS - 1))
# define _MIN_INT       (INT)(- _MAX_INT - 1)
# define N_INT_BITS     (64 - N_TAG_BITS)
# define HW_SIGN_BIT    0x8000000000000000L
# define HW_HALF_MASK   0xFFFFFFFFL
# define HW_HALF_NBITS  32
#else
# define _MAX_INT       (INT)(0x3FFFFFFF >> (N_TAG_BITS - 1))
# define _MIN_INT       (INT)(- _MAX_INT - 1)
# define N_INT_BITS     (32 - N_TAG_BITS)
# define HW_SIGN_BIT    0x80000000
# define HW_HALF_MASK   0xFFFF
# define HW_HALF_NBITS  16
#endif

#if 0
/* computes _intVal(ep) * 2 */
#ifdef POSITIVE_ADDRESSES
# if N_TAG_BITS == 1
#  define __smallIntegerVal2(i)         ((INT)(i) << 1)
# endif
#else
# if N_TAG_BITS == 1
#  if TAG_INT==1
#   define __smallIntegerVal2(i)         ((INT)(i) & ~TAG_INT)
#  else
#   if TAG_INT==0
#    define __smallIntegerVal2(i)        ((INT)(i))
#   endif
#  endif
# endif
#endif
#ifdef __smallIntegerVal2
# define _intVal2(i)         __smallIntegerVal2(i)
#endif
#endif

#endif /* __STCINTERN_H__ */
