"{ Package: 'stx:goodies/smaCC/tests' }"

"{ NameSpace: SmaCC }"

SmaCCParser subclass:#JavaParser
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SmaCC-Example Parsers'
!


!JavaParser class methodsFor:'generated-accessing'!

scannerClass
	^JavaScanner
! !

!JavaParser class methodsFor:'generated-comments'!

parserDefinitionComment

	"goal : compilation_unit
	;

# 19.3) Lexical Structure.
literal :       <INTEGER_LITERAL>
	|       <FLOATING_POINT_LITERAL>
	|       <BOOLEAN_LITERAL>
#       |       ""true""
#       |       ""false""
	|       <CHARACTER_LITERAL>
	|       <STRING_LITERAL>
	|       <NULL_LITERAL>
	;

# 19.4) Types, Values, and Variables
type    :       primitive_type
	|       reference_type
	;
primitive_type :
		numeric_type
	|       ""boolean""
	;
numeric_type:   integral_type
	|       floating_point_type
	;
integral_type : 
		""byte"" 
	|       ""short"" 
	|       ""int"" 
	|       ""long"" 
	|       ""char"" 
	;
floating_point_type : 
		""float"" 
	|       ""double""
	;

reference_type :
		class_or_interface_type
	|       array_type
	;
class_or_interface_type : name;

class_type :    class_or_interface_type;
interface_type : class_or_interface_type;               

array_type :    primitive_type dims
	|       name dims
	;

# 19.5) Names
name    :       simple_name
	|       qualified_name
	;
simple_name :   <IDENTIFIER>
	;
qualified_name :
		name ""."" <IDENTIFIER>
	;

# 19.6) ""package""s
compilation_unit :
		package_declaration_opt 
		import_declarations_opt
		type_declarations_opt
		;
package_declaration_opt : package_declaration | ;
import_declarations_opt : import_declarations | ;
type_declarations_opt   : type_declarations   | ;

import_declarations : 
		import_declaration
	|       import_declarations import_declaration
	;
type_declarations : 
		type_declaration
	|       type_declarations type_declaration
	;
package_declaration : 
		""package"" name "";""
	;
import_declaration : 
		single_type_import_declaration
	|       type_import_on_demand_declaration
	;
single_type_import_declaration : 
		""import"" name "";""
	;
type_import_on_demand_declaration :
		""import"" name ""."" ""*"" "";""
	;
type_declaration :
		class_declaration
	|       interface_declaration
	|       "";""
	;

# 19.7) Productions used only in the LALR(1) grammar
modifiers_opt:
	|       modifiers
	;
modifiers :     modifier
	|       modifiers modifier
	;
modifier :      ""public"" | ""protected"" | ""private""
	|       ""static""
	|       ""abstract"" | ""final"" | ""native"" | ""synchronized"" | ""transient"" | ""volatile""
	|       ""strictfp"" # note that semantic analysis must check that the
			 # context of the modifier allows strictfp.
	;

# 19.8) Classes

# 19.8.1) Class Declaration:
class_declaration : 
	modifiers_opt ""class"" <IDENTIFIER> super_opt interfaces_opt class_body
	;
super : ""extends"" class_type
	;
super_opt :     
	|       super
	;
interfaces :    ""implements"" interface_type_list
	;
interfaces_opt:
	|       interfaces 
	;
interface_type_list : 
		interface_type
	|       interface_type_list "","" interface_type
	;
class_body :    ""{"" class_body_declarations_opt ""}"" 
	;
class_body_declarations_opt : 
	|       class_body_declarations ;
class_body_declarations : 
		class_body_declaration
	|       class_body_declarations class_body_declaration
	;
class_body_declaration :
		class_member_declaration
	|       static_initializer
	|       constructor_declaration
	|       block
	;
class_member_declaration :
		field_declaration
	|       method_declaration
	# repeat the prod for 'class_declaration' here: 
	|       modifiers_opt ""class"" <IDENTIFIER> super_opt interfaces_opt class_body
	|       interface_declaration
	|       "";""
	;

# 19.8.2) Field Declarations
field_declaration : 
		modifiers_opt type variable_declarators "";""
	;
variable_declarators :
		variable_declarator
	|       variable_declarators "","" variable_declarator
	;
variable_declarator :
		variable_declarator_id
	|       variable_declarator_id ""="" variable_initializer
	;
variable_declarator_id :
		<IDENTIFIER>
	|       variable_declarator_id ""["" ""]""
	;
variable_initializer :
		expression
	|       array_initializer
	;

# 19.8.3) Method Declarations
method_declaration :
		method_header method_body
	;
method_header :
		modifiers_opt type method_declarator throws_opt
	|       modifiers_opt ""void"" method_declarator throws_opt
	;
method_declarator :
		<IDENTIFIER> ""("" formal_parameter_list_opt "")""
	|       method_declarator ""["" ""]"" # deprecated
	# be careful; the above production also allows 'void foo() []'
	;
formal_parameter_list_opt :
	|       formal_parameter_list
	;
formal_parameter_list :
		formal_parameter
	|       formal_parameter_list "","" formal_parameter
	;
formal_parameter :
		type variable_declarator_id
	|       ""final"" type variable_declarator_id
	;
throws_opt :    
	|       throws
	;
throws :        ""throws"" class_type_list
	;
class_type_list :
		class_type
	|       class_type_list "","" class_type
	;
method_body :   block
	|       "";""
	;

# 19.8.4) Static Initializers
static_initializer :
		""static"" block
	;

# 19.8.5) Constructor Declarations
constructor_declaration :
		modifiers_opt constructor_declarator throws_opt 
			constructor_body
	;
constructor_declarator :
		simple_name ""("" formal_parameter_list_opt "")""
	;
constructor_body :
		""{"" explicit_constructor_invocation
			block_statements ""}""
	|       ""{"" explicit_constructor_invocation ""}""
	|       ""{"" block_statements ""}""
	|       ""{"" ""}""
	;
explicit_constructor_invocation :
		""this"" ""("" argument_list_opt "")"" "";""
	|       ""super"" ""("" argument_list_opt "")"" "";""
	|       primary ""."" ""this"" ""("" argument_list_opt "")"" "";""
	|       primary ""."" ""super"" ""("" argument_list_opt "")"" "";""
	;

# 19.9) Interfaces

# 19.9.1) Interface Declarations
interface_declaration :
		modifiers_opt ""interface"" <IDENTIFIER> extends_interfaces_opt 
			interface_body
	;
extends_interfaces_opt :
	|       extends_interfaces
	;
extends_interfaces :
		""extends"" interface_type
	|       extends_interfaces "","" interface_type
	;
interface_body :
		""{"" interface_member_declarations_opt ""}""
	;
interface_member_declarations_opt :
	|       interface_member_declarations
	;
interface_member_declarations :
		interface_member_declaration
	|       interface_member_declarations interface_member_declaration
	;
interface_member_declaration :
		constant_declaration
	|       abstract_method_declaration
	|       class_declaration
	|       interface_declaration
	;
constant_declaration :
		field_declaration
	# need to semantically check that modifiers of field declaration
	# include only PUBLIC, ""static"", or ""final"".  Other modifiers are
	# disallowed.
	;
abstract_method_declaration :
		method_header "";""
	;

# 19.10) Arrays
array_initializer :
		""{"" variable_initializers "","" ""}""
	|       ""{"" variable_initializers ""}""
	|       ""{"" "","" ""}""
	|       ""{"" ""}""
	;
variable_initializers :
		variable_initializer
	|       variable_initializers "","" variable_initializer
	;

# 19.11) Blocks and Statements
block : ""{"" block_statements_opt ""}""
	;
block_statements_opt :
	|       block_statements
	;
block_statements :
		block_statement
	|       block_statements block_statement
	;
block_statement :
		local_variable_declaration_statement
	|       statement
	|       class_declaration
	|       interface_declaration
	;
local_variable_declaration_statement :
		local_variable_declaration "";""
	;
local_variable_declaration :
		type variable_declarators
	|       ""final"" type variable_declarators
	;
statement :     statement_without_trailing_substatement
	|       labeled_statement
	|       if_then_statement
	|       if_then_else_statement
	|       while_statement
	|       for_statement
	;
statement_no_short_if :
		statement_without_trailing_substatement
	|       labeled_statement_no_short_if
	|       if_then_else_statement_no_short_if
	|       while_statement_no_short_if
	|       for_statement_no_short_if
	;
statement_without_trailing_substatement :
		block
	|       empty_statement
	|       expression_statement
	|       switch_statement
	|       do_statement
	|       break_statement
	|       continue_statement
	|       return_statement
	|       synchronized_statement
	|       throw_statement
	|       try_statement
	;
empty_statement :
		"";""
	;
labeled_statement :
		<IDENTIFIER> "":"" statement
	;
labeled_statement_no_short_if :
		<IDENTIFIER> "":"" statement_no_short_if
	;
expression_statement :
		statement_expression "";""
	;
statement_expression :
		assignment
	|       preincrement_expression
	|       predecrement_expression
	|       postincrement_expression
	|       postdecrement_expression
	|       method_invocation
	|       class_instance_creation_expression
	;
if_then_statement :
		""if"" ""("" expression "")"" statement
	;
if_then_else_statement :
		""if"" ""("" expression "")"" statement_no_short_if 
			""else"" statement
	;
if_then_else_statement_no_short_if :
		""if"" ""("" expression "")"" statement_no_short_if
			""else"" statement_no_short_if
	;
switch_statement :
		""switch"" ""("" expression "")"" switch_block
	;
switch_block :
		""{"" switch_block_statement_groups switch_labels ""}""
	|       ""{"" switch_block_statement_groups ""}""
	|       ""{"" switch_labels ""}""
	|       ""{"" ""}""
	;
switch_block_statement_groups :
		switch_block_statement_group
	|       switch_block_statement_groups switch_block_statement_group
	;
switch_block_statement_group :
		switch_labels block_statements
	;
switch_labels :
		switch_label
	|       switch_labels switch_label
	;
switch_label :
		""case"" constant_expression "":""
	|       ""default"" "":""
	;

while_statement :
		""while"" ""("" expression "")"" statement
	;
while_statement_no_short_if :
		""while"" ""("" expression "")"" statement_no_short_if
	;
do_statement :
		""do"" statement ""while"" ""("" expression "")"" "";""
	;
for_statement :
		""for"" ""("" for_init_opt "";"" expression_opt "";""
			for_update_opt "")"" statement
	;
for_statement_no_short_if :
		""for"" ""("" for_init_opt "";"" expression_opt "";""
			for_update_opt "")"" statement_no_short_if
	;
for_init_opt :
	|       for_init
	;
for_init :      statement_expression_list
	|       local_variable_declaration
	;
for_update_opt :
	|       for_update
	;
for_update :    statement_expression_list
	;
statement_expression_list :
		statement_expression
	|       statement_expression_list "","" statement_expression
	;

identifier_opt : 
	|       <IDENTIFIER>
	;

break_statement :
		""break"" identifier_opt "";""
	;

continue_statement :
		""continue"" identifier_opt "";""
	;
return_statement :
		""return"" expression_opt "";""
	;
throw_statement :
		""throw"" expression "";""
	;
synchronized_statement :
		""synchronized"" ""("" expression "")"" block
	;
try_statement :
		""try"" block catches
	|       ""try"" block catches_opt finally
	;
catches_opt :
	|       catches
	;
catches :       catch_clause
	|       catches catch_clause
	;
catch_clause :
		""catch"" ""("" formal_parameter "")"" block
	;
finally :       ""finally"" block
	;

# 19.12) Expressions
primary :       primary_no_new_array
	|       array_creation_expression
	;
primary_no_new_array :
		literal
	|       ""this""
	|       ""("" expression "")""
	|       class_instance_creation_expression
	|       field_access
	|       method_invocation
	|       array_access
	|       primitive_type ""."" ""class""
	|       ""void"" ""."" ""class""
	|       array_type ""."" ""class""
	|       name ""."" ""class""
	|       name ""."" ""this""
	;
class_instance_creation_expression :
		""new"" class_type ""("" argument_list_opt "")""
	|       ""new"" class_type ""("" argument_list_opt "")"" class_body
	|       primary ""."" ""new"" <IDENTIFIER>
			""("" argument_list_opt "")""
	|       primary ""."" ""new"" <IDENTIFIER>
			""("" argument_list_opt "")"" class_body
	;
argument_list_opt :
	|       argument_list
	;
argument_list :
		expression
	|       argument_list "","" expression
	;
array_creation_expression :
		""new"" primitive_type dim_exprs dims_opt
	|       ""new"" class_or_interface_type dim_exprs dims_opt
	|       ""new"" primitive_type dims array_initializer
	|       ""new"" class_or_interface_type dims array_initializer
	;
dim_exprs :     dim_expr
	|       dim_exprs dim_expr
	;
dim_expr :      ""["" expression ""]""
	;
dims_opt :
	|       dims
	;
dims :  ""["" ""]""
	|       dims ""["" ""]""
	;
field_access :
		primary ""."" <IDENTIFIER>
	|       ""super"" ""."" <IDENTIFIER>
	|       name ""."" ""super"" ""."" <IDENTIFIER>
	;
method_invocation :
		name ""("" argument_list_opt "")""
	|       primary ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	|       ""super"" ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	|       name ""."" ""super"" ""."" <IDENTIFIER> ""("" argument_list_opt "")""
	;
array_access :
		name ""["" expression ""]""
	|       primary_no_new_array ""["" expression ""]""
	;
postfix_expression :
		primary
	|       name
	|       postincrement_expression
	|       postdecrement_expression
	;
postincrement_expression :
		postfix_expression ""++""
	;
postdecrement_expression :
		postfix_expression ""--""
	;
unary_expression :
		preincrement_expression
	|       predecrement_expression
	|       ""+"" unary_expression
	|       ""-"" unary_expression
	|       unary_expression_not_plus_minus
	;
preincrement_expression :
		""++"" unary_expression
	;
predecrement_expression :
		""--"" unary_expression
	;
unary_expression_not_plus_minus :
		postfix_expression
	|       ""~"" unary_expression
	|       ""!!"" unary_expression
	|       cast_expression
	;
cast_expression :
		""("" primitive_type dims_opt "")"" unary_expression
	|       ""("" expression "")"" unary_expression_not_plus_minus
	|       ""("" name dims "")"" unary_expression_not_plus_minus
	;
multiplicative_expression :
		unary_expression
	|       multiplicative_expression ""*"" unary_expression
	|       multiplicative_expression ""/"" unary_expression
	|       multiplicative_expression ""%"" unary_expression
	;
additive_expression :
		multiplicative_expression
	|       additive_expression ""+"" multiplicative_expression
	|       additive_expression ""-"" multiplicative_expression
	;
shift_expression :
		additive_expression
	|       shift_expression ""<<"" additive_expression
	|       shift_expression "">>"" additive_expression
	|       shift_expression "">>>"" additive_expression
	;
relational_expression :
		shift_expression
	|       relational_expression ""<"" shift_expression
	|       relational_expression "">"" shift_expression
	|       relational_expression ""<="" shift_expression
	|       relational_expression "">="" shift_expression
	|       relational_expression ""instanceof"" reference_type
	;
equality_expression :
		relational_expression
	|       equality_expression ""=="" relational_expression
	|       equality_expression ""!!="" relational_expression
	;
and_expression :
		equality_expression
	|       and_expression ""&"" equality_expression
	;
exclusive_or_expression :
		and_expression
	|       exclusive_or_expression ""^"" and_expression
	;
inclusive_or_expression :
		exclusive_or_expression
	|       inclusive_or_expression ""|"" exclusive_or_expression
	;
conditional_and_expression :
		inclusive_or_expression
	|       conditional_and_expression ""&&"" inclusive_or_expression
	;
conditional_or_expression :
		conditional_and_expression
	|       conditional_or_expression ""||"" conditional_and_expression
	;
conditional_expression :
		conditional_or_expression
	|       conditional_or_expression ""?"" expression 
			"":"" conditional_expression
	;
assignment_expression :
		conditional_expression
	|       assignment
	;
assignment :    left_hand_side assignment_operator assignment_expression
	;
left_hand_side :
		name
	|       field_access
	|       array_access
	;
assignment_operator :
		""=""
	|       ""*=""
	|       ""/=""
	|       ""%=""
	|       ""+=""
	|       ""-=""
	|       ""<<=""
	|       "">>=""
	|       "">>>=""
	|       ""&=""
	|       ""^=""
	|       ""|=""
	;
expression_opt :
	|       expression
	;
expression :    assignment_expression
	;
constant_expression :
		expression
	;"
! !

!JavaParser class methodsFor:'generated-starting states'!

startingStateForgoal
	^1
! !

!JavaParser methodsFor:'generated-tables'!

reduceTable
	^#(
#(103 1 #reduceFor:)
#(103 1 #reduceFor:)
#(104 1 #reduceFor:)
#(104 1 #reduceFor:)
#(104 1 #reduceFor:)
#(104 1 #reduceFor:)
#(104 1 #reduceFor:)
#(105 1 #reduceFor:)
#(105 1 #reduceFor:)
#(106 1 #reduceFor:)
#(106 1 #reduceFor:)
#(107 1 #reduceFor:)
#(108 2 #reduceFor:)
#(108 2 #reduceFor:)
#(109 1 #reduceFor:)
#(109 1 #reduceFor:)
#(110 1 #reduceFor:)
#(111 1 #reduceFor:)
#(112 2 #reduceFor:)
#(112 3 #reduceFor:)
#(113 1 #reduceFor:)
#(114 3 #reduceFor:)
#(115 1 #reduceFor:)
#(115 1 #reduceFor:)
#(115 1 #reduceFor:)
#(115 1 #reduceFor:)
#(115 1 #reduceFor:)
#(115 1 #reduceFor:)
#(116 1 #reduceFor:)
#(116 0 #reduceFor:)
#(117 1 #reduceFor:)
#(117 0 #reduceFor:)
#(118 1 #reduceFor:)
#(118 0 #reduceFor:)
#(119 3 #reduceFor:)
#(120 1 #reduceFor:)
#(120 2 #reduceFor:)
#(121 1 #reduceFor:)
#(121 2 #reduceFor:)
#(122 1 #reduceFor:)
#(122 1 #reduceFor:)
#(123 1 #reduceFor:)
#(123 1 #reduceFor:)
#(123 1 #reduceFor:)
#(124 3 #reduceFor:)
#(125 5 #reduceFor:)
#(126 6 #reduceFor:)
#(127 5 #reduceFor:)
#(128 1 #reduceFor:)
#(129 0 #reduceFor:)
#(129 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(130 1 #reduceFor:)
#(131 0 #reduceFor:)
#(131 1 #reduceFor:)
#(132 0 #reduceFor:)
#(132 1 #reduceFor:)
#(133 3 #reduceFor:)
#(134 2 #reduceFor:)
#(135 1 #reduceFor:)
#(135 3 #reduceFor:)
#(136 2 #reduceFor:)
#(137 0 #reduceFor:)
#(137 1 #reduceFor:)
#(138 1 #reduceFor:)
#(138 2 #reduceFor:)
#(139 1 #reduceFor:)
#(139 1 #reduceFor:)
#(139 1 #reduceFor:)
#(139 1 #reduceFor:)
#(140 1 #reduceFor:)
#(140 1 #reduceFor:)
#(140 6 #reduceFor:)
#(140 1 #reduceFor:)
#(140 1 #reduceFor:)
#(141 2 #reduceFor:)
#(142 4 #reduceFor:)
#(143 3 #reduceFor:)
#(144 4 #reduceFor:)
#(145 2 #reduceFor:)
#(146 1 #reduceFor:)
#(146 3 #reduceFor:)
#(147 1 #reduceFor:)
#(147 3 #reduceFor:)
#(148 1 #reduceFor:)
#(148 3 #reduceFor:)
#(149 1 #reduceFor:)
#(149 1 #reduceFor:)
#(150 1 #reduceFor:)
#(151 4 #reduceFor:)
#(151 3 #reduceFor:)
#(151 3 #reduceFor:)
#(151 2 #reduceFor:)
#(152 4 #reduceFor:)
#(152 4 #reduceFor:)
#(153 1 #reduceFor:)
#(153 1 #reduceFor:)
#(154 4 #reduceFor:)
#(154 3 #reduceFor:)
#(155 0 #reduceFor:)
#(155 1 #reduceFor:)
#(156 0 #reduceFor:)
#(156 1 #reduceFor:)
#(157 1 #reduceFor:)
#(157 3 #reduceFor:)
#(158 2 #reduceFor:)
#(158 3 #reduceFor:)
#(159 2 #reduceFor:)
#(160 1 #reduceFor:)
#(160 3 #reduceFor:)
#(161 4 #reduceFor:)
#(162 4 #reduceFor:)
#(162 3 #reduceFor:)
#(162 3 #reduceFor:)
#(162 2 #reduceFor:)
#(163 5 #reduceFor:)
#(163 5 #reduceFor:)
#(163 7 #reduceFor:)
#(163 7 #reduceFor:)
#(164 1 #reduceFor:)
#(164 2 #reduceFor:)
#(165 0 #reduceFor:)
#(165 1 #reduceFor:)
#(166 1 #reduceFor:)
#(166 1 #reduceFor:)
#(167 0 #reduceFor:)
#(167 1 #reduceFor:)
#(168 3 #reduceFor:)
#(169 2 #reduceFor:)
#(169 3 #reduceFor:)
#(170 0 #reduceFor:)
#(170 1 #reduceFor:)
#(171 1 #reduceFor:)
#(171 2 #reduceFor:)
#(172 1 #reduceFor:)
#(172 1 #reduceFor:)
#(172 1 #reduceFor:)
#(172 1 #reduceFor:)
#(173 1 #reduceFor:)
#(174 2 #reduceFor:)
#(175 1 #reduceFor:)
#(175 3 #reduceFor:)
#(176 0 #reduceFor:)
#(176 1 #reduceFor:)
#(177 1 #reduceFor:)
#(177 1 #reduceFor:)
#(177 1 #reduceFor:)
#(177 1 #reduceFor:)
#(178 2 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(179 1 #reduceFor:)
#(180 1 #reduceFor:)
#(180 1 #reduceFor:)
#(181 2 #reduceFor:)
#(181 3 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(182 1 #reduceFor:)
#(183 3 #reduceFor:)
#(184 5 #reduceFor:)
#(185 7 #reduceFor:)
#(186 5 #reduceFor:)
#(187 9 #reduceFor:)
#(188 3 #reduceFor:)
#(189 7 #reduceFor:)
#(190 5 #reduceFor:)
#(191 9 #reduceFor:)
#(192 1 #reduceFor:)
#(192 1 #reduceFor:)
#(192 1 #reduceFor:)
#(192 1 #reduceFor:)
#(192 1 #reduceFor:)
#(193 1 #reduceFor:)
#(194 2 #reduceFor:)
#(195 5 #reduceFor:)
#(196 7 #reduceFor:)
#(197 3 #reduceFor:)
#(198 3 #reduceFor:)
#(199 3 #reduceFor:)
#(200 5 #reduceFor:)
#(201 3 #reduceFor:)
#(202 3 #reduceFor:)
#(202 4 #reduceFor:)
#(203 1 #reduceFor:)
#(203 1 #reduceFor:)
#(203 1 #reduceFor:)
#(203 1 #reduceFor:)
#(203 1 #reduceFor:)
#(203 1 #reduceFor:)
#(203 1 #reduceFor:)
#(204 3 #reduceFor:)
#(205 2 #reduceFor:)
#(206 2 #reduceFor:)
#(207 2 #reduceFor:)
#(208 2 #reduceFor:)
#(209 4 #reduceFor:)
#(209 6 #reduceFor:)
#(209 6 #reduceFor:)
#(209 8 #reduceFor:)
#(210 5 #reduceFor:)
#(210 6 #reduceFor:)
#(210 7 #reduceFor:)
#(210 8 #reduceFor:)
#(211 4 #reduceFor:)
#(211 3 #reduceFor:)
#(211 3 #reduceFor:)
#(211 2 #reduceFor:)
#(212 1 #reduceFor:)
#(212 2 #reduceFor:)
#(213 1 #reduceFor:)
#(213 2 #reduceFor:)
#(214 2 #reduceFor:)
#(215 3 #reduceFor:)
#(215 2 #reduceFor:)
#(216 1 #reduceFor:)
#(217 0 #reduceFor:)
#(217 1 #reduceFor:)
#(218 0 #reduceFor:)
#(218 1 #reduceFor:)
#(219 0 #reduceFor:)
#(219 1 #reduceFor:)
#(220 1 #reduceFor:)
#(220 1 #reduceFor:)
#(221 1 #reduceFor:)
#(221 3 #reduceFor:)
#(222 1 #reduceFor:)
#(223 0 #reduceFor:)
#(223 1 #reduceFor:)
#(224 1 #reduceFor:)
#(224 2 #reduceFor:)
#(225 0 #reduceFor:)
#(225 1 #reduceFor:)
#(226 2 #reduceFor:)
#(227 5 #reduceFor:)
#(228 1 #reduceFor:)
#(228 1 #reduceFor:)
#(228 3 #reduceFor:)
#(228 1 #reduceFor:)
#(228 1 #reduceFor:)
#(228 1 #reduceFor:)
#(228 1 #reduceFor:)
#(228 3 #reduceFor:)
#(228 3 #reduceFor:)
#(228 3 #reduceFor:)
#(228 3 #reduceFor:)
#(228 3 #reduceFor:)
#(229 4 #reduceFor:)
#(229 4 #reduceFor:)
#(229 4 #reduceFor:)
#(229 4 #reduceFor:)
#(230 3 #reduceFor:)
#(230 3 #reduceFor:)
#(230 5 #reduceFor:)
#(231 4 #reduceFor:)
#(231 4 #reduceFor:)
#(232 1 #reduceFor:)
#(232 3 #reduceFor:)
#(233 1 #reduceFor:)
#(233 2 #reduceFor:)
#(234 0 #reduceFor:)
#(234 1 #reduceFor:)
#(235 3 #reduceFor:)
#(236 1 #reduceFor:)
#(236 1 #reduceFor:)
#(236 1 #reduceFor:)
#(236 1 #reduceFor:)
#(237 1 #reduceFor:)
#(237 1 #reduceFor:)
#(237 2 #reduceFor:)
#(237 2 #reduceFor:)
#(237 1 #reduceFor:)
#(238 1 #reduceFor:)
#(238 2 #reduceFor:)
#(238 2 #reduceFor:)
#(238 1 #reduceFor:)
#(239 5 #reduceFor:)
#(239 4 #reduceFor:)
#(239 5 #reduceFor:)
#(240 1 #reduceFor:)
#(240 3 #reduceFor:)
#(240 3 #reduceFor:)
#(240 3 #reduceFor:)
#(241 1 #reduceFor:)
#(241 3 #reduceFor:)
#(241 3 #reduceFor:)
#(242 1 #reduceFor:)
#(242 3 #reduceFor:)
#(242 3 #reduceFor:)
#(242 3 #reduceFor:)
#(243 1 #reduceFor:)
#(243 3 #reduceFor:)
#(243 3 #reduceFor:)
#(243 3 #reduceFor:)
#(243 3 #reduceFor:)
#(243 3 #reduceFor:)
#(244 1 #reduceFor:)
#(244 3 #reduceFor:)
#(244 3 #reduceFor:)
#(245 1 #reduceFor:)
#(245 3 #reduceFor:)
#(246 1 #reduceFor:)
#(246 3 #reduceFor:)
#(247 1 #reduceFor:)
#(247 3 #reduceFor:)
#(248 1 #reduceFor:)
#(248 3 #reduceFor:)
#(249 1 #reduceFor:)
#(249 3 #reduceFor:)
#(250 1 #reduceFor:)
#(250 5 #reduceFor:)
#(251 1 #reduceFor:)
#(251 1 #reduceFor:)
#(252 1 #reduceFor:)
#(252 1 #reduceFor:)
#(252 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(253 1 #reduceFor:)
#(256 1 #reduceFor:)
#(257 3 #reduceFor:)
#(258 1 #reduceFor:)
#(258 2 #reduceFor:)
#(259 1 #reduceFor:)
#(259 1 #reduceFor:)
)
!

transitionTable
	^#(
#[1 0 122 0 9 0 122 0 11 0 122 0 12 0 122 0 18 0 122 0 22 0 9 0 29 0 122 0 30 0 122 0 35 0 122 0 36 0 122 0 37 0 122 0 38 0 122 0 39 0 122 0 40 0 122 0 42 0 122 0 43 0 122 0 44 0 13 0 116 0 17 0 119 0 122 0 254 0 21 1 0 0 25 1 1]
#[1 0 29 0 99 0 33 0 109 0 37 0 113 0 41 0 114]
#[1 0 130 0 9 0 130 0 11 0 130 0 12 0 130 0 18 0 130 0 22 0 130 0 30 0 130 0 35 0 130 0 36 0 130 0 37 0 130 0 38 0 130 0 39 0 130 0 40 0 45 0 42 0 130 0 43 0 130 0 44 0 49 0 117 0 53 0 120 0 57 0 122 0 61 0 124 0 65 0 125 0 130 0 254]
#[0 0 118 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 42 0 43 0 44 0 254]
#[0 0 0 0 254]
#[0 5 118 0 254]
#[0 0 86 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 10 0 15 0 16 0 21 0 30 0 34 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92 0 99]
#[1 0 69 0 30 0 73 0 34]
#[0 0 62 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 10 0 15 0 16 0 21 0 30 0 34 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92 0 99]
#[0 0 66 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 10 0 15 0 16 0 21 0 30 0 34 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92 0 99]
#[1 0 29 0 99 0 77 0 109 0 37 0 113 0 41 0 114]
#[1 0 202 0 9 0 81 0 11 0 202 0 12 0 85 0 18 0 89 0 22 0 93 0 30 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 0 113 0 39 0 117 0 40 0 121 0 43 0 125 0 44 0 129 0 118 0 133 0 121 0 137 0 123 0 141 0 126 0 145 0 127 0 149 0 129 0 153 0 130 0 138 0 254 0 157 1 2]
#[1 0 126 0 9 0 126 0 11 0 126 0 12 0 126 0 18 0 126 0 22 0 126 0 30 0 126 0 35 0 126 0 36 0 126 0 37 0 126 0 38 0 126 0 39 0 126 0 40 0 45 0 42 0 126 0 43 0 126 0 44 0 161 0 122 0 61 0 124 0 65 0 125 0 126 0 254]
#[0 0 146 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 42 0 43 0 44 0 254]
#[0 0 162 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 42 0 43 0 44 0 254]
#[0 0 166 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 42 0 43 0 44 0 254]
#[0 0 142 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 42 0 43 0 44 0 254]
#[0 0 165 0 99]
#[1 0 169 0 30 0 173 0 34]
#[0 0 246 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 238 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 250 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 178 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 254]
#[0 0 242 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 222 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 218 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 234 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 230 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 226 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 214 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 210 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 5 122 0 254]
#[1 0 202 0 9 0 81 0 11 0 202 0 12 0 85 0 18 0 89 0 22 0 93 0 30 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 0 113 0 39 0 117 0 40 0 121 0 43 0 125 0 44 0 177 0 123 0 141 0 126 0 145 0 127 0 149 0 129 0 153 0 130 0 134 0 254 0 157 1 2]
#[0 0 154 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 254]
#[0 0 170 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 254]
#[0 0 174 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 254]
#[1 0 181 0 9 0 185 0 12]
#[0 5 126 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 0 206 0 9 0 81 0 11 0 206 0 12 0 206 0 17 0 85 0 18 0 89 0 22 0 206 0 24 0 206 0 25 0 206 0 26 0 206 0 27 0 206 0 28 0 206 0 31 0 206 0 32 0 206 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 0 113 0 39 0 117 0 40 0 121 0 43 0 125 0 44 0 206 0 99 0 189 0 130]
#[0 0 150 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 42 0 43 0 44 0 254]
#[0 0 90 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 10 0 15 0 16 0 21 0 30 0 34 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92 0 99]
#[0 0 182 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 42 0 43 0 44 0 254]
#[1 0 193 0 45 0 165 0 99]
#[0 0 158 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 254]
#[0 0 197 0 99]
#[0 0 201 0 99]
#[0 5 130 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 0 205 0 30]
#[1 0 254 0 1 0 254 0 2 0 209 0 8 0 213 0 131 0 217 0 134]
#[1 2 30 0 1 0 221 0 8 0 225 0 167 0 229 0 169]
#[0 0 186 0 9 0 11 0 12 0 18 0 22 0 30 0 35 0 36 0 37 0 38 0 39 0 40 0 42 0 43 0 44 0 254]
#[1 0 29 0 99 0 233 0 107 0 237 0 109 0 241 0 110 0 37 0 113 0 41 0 114]
#[1 1 6 0 1 0 245 0 2 0 249 0 132 0 253 0 136]
#[0 1 2 0 1 0 2]
#[1 0 29 0 99 1 1 0 107 0 237 0 109 1 5 0 111 0 37 0 113 0 41 0 114]
#[1 1 9 0 1 1 13 0 168]
#[1 2 34 0 1 1 17 0 6]
#[0 0 70 0 1 0 2 0 6 0 30]
#[1 0 50 0 1 0 50 0 2 0 50 0 6 0 50 0 7 0 50 0 10 0 50 0 30 0 73 0 34]
#[0 1 18 0 1 0 2]
#[1 0 29 0 99 1 1 0 107 0 237 0 109 1 21 0 111 0 37 0 113 0 41 0 114 1 25 0 135]
#[1 1 29 0 1 1 33 0 133]
#[0 1 10 0 1]
#[0 0 74 0 1 0 6]
#[0 2 42 0 1 0 6]
#[1 2 50 0 4 0 202 0 9 0 81 0 11 0 202 0 12 0 202 0 17 0 85 0 18 0 89 0 22 0 202 0 24 0 202 0 25 0 202 0 26 0 202 0 27 0 202 0 28 0 202 0 31 0 202 0 32 0 202 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 0 113 0 39 0 117 0 40 0 121 0 43 0 125 0 44 0 202 0 99 1 37 0 126 1 41 0 127 1 45 0 129 0 153 0 130 1 49 0 144 1 53 0 152 1 57 0 170 1 61 0 171 1 65 0 172 1 69 0 173 1 73 0 174 0 157 1 2]
#[0 0 194 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 254]
#[1 0 29 0 99 1 1 0 107 0 237 0 109 1 77 0 111 0 37 0 113 0 41 0 114]
#[0 1 22 0 1 0 6]
#[1 1 30 0 1 1 81 0 6]
#[1 1 85 0 1 1 34 0 4 0 202 0 9 0 81 0 11 0 202 0 12 0 202 0 17 0 85 0 18 0 89 0 22 0 202 0 24 0 202 0 25 0 202 0 26 0 202 0 27 0 202 0 28 1 89 0 30 0 202 0 31 0 202 0 32 0 202 0 33 0 97 0 35 1 93 0 36 0 105 0 37 0 109 0 38 0 113 0 39 0 117 0 40 0 121 0 43 0 125 0 44 0 202 0 99 1 97 0 127 1 101 0 129 0 153 0 130 1 105 0 137 1 109 0 138 1 113 0 139 1 117 0 140 1 121 0 141 1 125 0 142 1 129 0 143 1 133 0 144 1 137 0 145 1 141 0 152 0 157 1 2]
#[0 0 190 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 254]
#[0 2 74 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 2 78 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 0 181 0 9 0 185 0 12 1 145 0 17 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 0 29 0 99 1 181 0 103 1 185 0 104 1 189 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 1 209 0 180 1 213 1 3]
#[0 2 82 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 217 0 30]
#[0 1 221 0 4]
#[1 2 54 0 4 0 202 0 9 0 81 0 11 0 202 0 12 0 202 0 17 0 85 0 18 0 89 0 22 0 202 0 24 0 202 0 25 0 202 0 26 0 202 0 27 0 202 0 28 0 202 0 31 0 202 0 32 0 202 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 0 113 0 39 0 117 0 40 0 121 0 43 0 125 0 44 0 202 0 99 1 37 0 126 1 41 0 127 1 45 0 129 0 153 0 130 1 49 0 144 1 53 0 152 1 225 0 172 1 69 0 173 1 73 0 174 0 157 1 2]
#[0 2 58 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 2 66 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 2 70 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 2 46 0 1 0 6]
#[1 0 29 0 99 1 1 0 107 0 237 0 109 1 229 0 111 0 37 0 113 0 41 0 114]
#[1 1 85 0 1 2 98 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 1 237 0 13 1 241 0 17 1 245 0 18 1 249 0 19 0 89 0 22 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 2 113 0 164 2 117 0 166 2 121 0 176 2 125 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[0 1 82 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 1 85 0 1 0 222 0 9 0 222 0 11 0 222 0 12 0 222 0 17 0 222 0 18 0 222 0 22 0 222 0 24 0 222 0 25 0 222 0 26 0 222 0 27 0 222 0 28 0 222 0 31 0 222 0 32 0 222 0 33 0 222 0 35 0 222 0 36 0 222 0 37 0 222 0 38 0 222 0 39 0 222 0 40 0 222 0 43 0 222 0 44 0 222 0 99 3 9 0 143]
#[0 1 78 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 3 13 0 9 0 185 0 12 1 145 0 17 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 0 29 0 99 1 181 0 103 1 185 0 104 1 189 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 3 17 0 113 0 41 0 114 3 21 0 161 1 209 0 180 1 213 1 3]
#[0 3 25 0 4]
#[1 1 85 0 1 1 38 0 4 0 202 0 9 0 81 0 11 0 202 0 12 0 202 0 17 0 85 0 18 0 89 0 22 0 202 0 24 0 202 0 25 0 202 0 26 0 202 0 27 0 202 0 28 1 89 0 30 0 202 0 31 0 202 0 32 0 202 0 33 0 97 0 35 1 93 0 36 0 105 0 37 0 109 0 38 0 113 0 39 0 117 0 40 0 121 0 43 0 125 0 44 0 202 0 99 1 97 0 127 1 101 0 129 0 153 0 130 3 29 0 139 1 117 0 140 1 121 0 141 1 125 0 142 1 129 0 143 1 133 0 144 1 137 0 145 1 141 0 152 0 157 1 2]
#[0 1 42 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 50 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 54 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 58 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 62 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 66 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 70 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 1 85 0 1 3 33 0 30 3 37 0 143 3 41 0 153]
#[1 3 45 0 99 3 49 0 154]
#[0 0 26 0 10 0 21 0 34 0 99]
#[0 0 22 0 10 0 21 0 34 0 99]
#[0 0 10 0 10 0 21 0 34 0 99]
#[0 0 6 0 10 0 21 0 34 0 99]
#[0 0 30 0 10 0 21 0 34 0 99]
#[0 0 18 0 10 0 21 0 34 0 99]
#[0 0 14 0 10 0 21 0 34 0 99]
#[0 5 138 0 10 0 21 0 34 0 99]
#[0 0 46 0 10 0 21 0 34 0 99]
#[0 0 42 0 10 0 21 0 34 0 99]
#[1 3 53 0 99 3 57 0 146 3 61 0 147 3 65 0 148 3 69 0 154]
#[0 5 134 0 10 0 21 0 34 0 99]
#[0 2 150 0 4 0 5 0 6 0 16 0 21 0 30 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 69 0 82 0 99]
#[0 2 154 0 4 0 5 0 6 0 16 0 21 0 30 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 69 0 82 0 99]
#[1 0 50 0 4 0 50 0 5 0 50 0 6 3 73 0 10 0 50 0 16 0 50 0 21 0 50 0 30 0 73 0 34 0 50 0 48 0 50 0 49 0 50 0 50 0 50 0 51 0 50 0 52 0 50 0 53 0 50 0 55 0 50 0 56 0 50 0 57 0 50 0 58 0 50 0 64 0 50 0 69 0 50 0 82 0 50 0 99 3 77 0 112]
#[0 0 38 0 99]
#[1 3 73 0 10 0 34 0 99 3 81 0 112]
#[0 2 86 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 2 38 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 254]
#[0 2 62 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 26 0 1 0 6]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 3 113 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 3 213 0 34]
#[0 3 217 0 34]
#[1 3 221 0 7 0 238 0 9 0 238 0 11 0 238 0 12 0 238 0 18 0 238 0 22 0 238 0 35 0 238 0 36 0 238 0 37 0 238 0 38 0 238 0 39 0 238 0 40 0 238 0 43 0 238 0 44]
#[0 4 6 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 3 10 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 0 230 0 9 0 230 0 11 0 230 0 12 0 230 0 18 0 230 0 22 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 0 230 0 35 0 230 0 36 0 230 0 37 0 230 0 38 0 230 0 39 0 230 0 40 0 230 0 43 0 230 0 44 0 29 0 99 1 181 0 103 1 185 0 104 3 225 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 1 209 0 180 1 213 1 3]
#[0 3 229 0 7]
#[0 3 233 0 7]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 3 190 0 30 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 3 237 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 3 241 0 218 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 3 226 0 30 3 245 0 99 3 249 0 223]
#[1 1 85 0 1 3 253 0 143]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 4 1 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 4 5 0 107 0 237 0 109 4 9 0 110 0 37 0 113 0 41 0 114 4 13 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 4 29 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[1 3 226 0 30 3 245 0 99 4 33 0 223]
#[0 4 37 0 7]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 4 45 0 179 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 4 49 0 7]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 4 53 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[0 0 94 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 0 98 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 0 102 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 0 106 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 0 110 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 0 114 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 0 86 0 3 0 86 0 7 0 86 0 10 0 86 0 15 4 57 0 16 0 86 0 34 0 86 0 47 0 86 0 54 0 86 0 59 0 86 0 60 0 86 0 61 0 86 0 62 0 86 0 63 0 86 0 66 0 86 0 67 0 86 0 68 0 86 0 77 0 86 0 89 0 86 0 99]
#[1 4 61 0 99 4 65 0 146 3 61 0 147 3 65 0 148]
#[1 4 69 0 34 2 154 0 99]
#[1 5 58 0 3 4 73 0 7 4 77 0 10 5 58 0 15 4 81 0 34 5 58 0 47 5 58 0 54 5 58 0 59 5 58 0 60 5 58 0 61 5 58 0 62 5 58 0 63 5 58 0 66 5 58 0 67 5 58 0 68 4 118 0 77 4 118 0 89 0 50 0 99 3 77 0 112]
#[0 4 2 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 2 114 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 118 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 166 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 85 0 1 2 102 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 1 237 0 13 1 241 0 17 1 245 0 18 1 249 0 19 0 89 0 22 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 2 117 0 166 4 85 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[1 4 114 0 4 4 114 0 5 4 114 0 6 4 114 0 16 4 114 0 21 4 114 0 30 4 89 0 34 4 114 0 45 4 114 0 48 4 114 0 49 4 114 0 50 4 114 0 51 4 114 0 52 4 114 0 53 4 114 0 55 4 114 0 56 4 114 0 57 4 114 0 58 4 114 0 64 4 114 0 65 4 114 0 69 4 114 0 77 4 114 0 82 4 114 0 83 4 114 0 85 4 114 0 86 4 114 0 87 4 114 0 89 4 114 0 91 4 114 0 92]
#[0 4 93 0 4]
#[0 2 6 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 106 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 110 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 97 0 30]
#[0 2 126 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 130 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 134 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 138 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 142 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 146 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 170 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 174 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 178 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 182 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 186 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 190 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 194 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 198 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 202 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 206 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 101 0 30]
#[0 3 54 0 6 0 21 0 30]
#[0 3 58 0 6 0 21 0 30]
#[0 3 62 0 6 0 21 0 30]
#[1 3 66 0 6 3 66 0 21 3 66 0 30 4 122 0 77 4 122 0 89]
#[1 3 70 0 6 3 70 0 21 3 70 0 30 4 126 0 77 4 126 0 89]
#[1 3 74 0 6 4 22 0 10 3 74 0 21 3 74 0 30 4 22 0 34 4 22 0 77 4 22 0 89]
#[1 3 78 0 6 4 14 0 10 3 78 0 21 3 78 0 30 4 14 0 34 4 14 0 77 4 14 0 89]
#[1 2 22 0 4 2 22 0 5 2 22 0 6 4 105 0 10 2 22 0 16 2 22 0 21 2 22 0 30 2 22 0 34 2 22 0 45 2 22 0 48 2 22 0 49 2 22 0 50 2 22 0 51 2 22 0 52 2 22 0 53 2 22 0 55 2 22 0 56 2 22 0 57 2 22 0 58 2 22 0 64 2 22 0 65 2 22 0 69 2 22 0 77 2 22 0 82 2 22 0 83 2 22 0 85 2 22 0 86 2 22 0 87 2 22 0 89 2 22 0 91 2 22 0 92]
#[0 2 26 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 5 62 0 3 4 18 0 4 4 18 0 5 4 18 0 6 4 18 0 10 5 62 0 15 4 18 0 16 4 18 0 21 4 18 0 30 4 18 0 34 4 18 0 45 5 62 0 47 4 18 0 48 4 18 0 49 4 18 0 50 4 18 0 51 4 18 0 52 4 18 0 53 5 62 0 54 4 18 0 55 4 18 0 56 4 18 0 57 4 18 0 58 5 62 0 59 5 62 0 60 5 62 0 61 5 62 0 62 5 62 0 63 4 18 0 64 4 18 0 65 5 62 0 66 5 62 0 67 5 62 0 68 4 18 0 69 4 18 0 77 4 18 0 82 4 18 0 83 4 18 0 85 4 18 0 86 4 18 0 87 4 18 0 89 4 18 0 91 4 18 0 92]
#[1 5 66 0 3 4 26 0 4 4 26 0 5 4 26 0 6 4 26 0 10 5 66 0 15 4 26 0 16 4 26 0 21 4 26 0 30 4 26 0 34 4 26 0 45 5 66 0 47 4 26 0 48 4 26 0 49 4 26 0 50 4 26 0 51 4 26 0 52 4 26 0 53 5 66 0 54 4 26 0 55 4 26 0 56 4 26 0 57 4 26 0 58 5 66 0 59 5 66 0 60 5 66 0 61 5 66 0 62 5 66 0 63 4 26 0 64 4 26 0 65 5 66 0 66 5 66 0 67 5 66 0 68 4 26 0 69 4 26 0 77 4 26 0 82 4 26 0 83 4 26 0 85 4 26 0 86 4 26 0 87 4 26 0 89 4 26 0 91 4 26 0 92]
#[1 4 109 0 77 4 113 0 89]
#[1 4 117 0 3 4 121 0 15 4 125 0 47 4 129 0 54 4 133 0 59 4 137 0 60 4 141 0 61 4 145 0 62 4 149 0 63 4 153 0 66 4 157 0 67 4 161 0 68 4 165 0 253]
#[1 3 73 0 10 4 169 0 34 0 34 0 99 3 81 0 112]
#[0 1 86 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 4 173 0 99]
#[1 4 177 0 7 0 62 0 10 0 62 0 34 0 62 0 99]
#[1 1 182 0 1 4 181 0 20 4 185 0 155 4 189 0 159]
#[0 1 14 0 1 0 4 0 5 0 6 0 7 0 9 0 10 0 11 0 12 0 13 0 16 0 17 0 18 0 19 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 34 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 45 0 46 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 82 0 83 0 85 0 86 0 87 0 88 0 89 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99 0 254]
#[0 1 46 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 170 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 166 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 1 102 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 4 193 0 7]
#[1 1 182 0 1 4 197 0 10 4 181 0 20 1 182 0 30 4 201 0 155 4 189 0 159]
#[1 1 122 0 3 1 122 0 6 4 193 0 7 1 122 0 10 1 122 0 30]
#[1 4 205 0 6 4 209 0 30]
#[0 1 106 0 6 0 30]
#[1 4 213 0 3 1 114 0 6 4 217 0 10 1 114 0 30]
#[1 1 182 0 1 4 197 0 10 4 181 0 20 1 182 0 30 4 221 0 155 4 189 0 159]
#[0 4 225 0 5]
#[1 0 58 0 4 0 58 0 5 0 58 0 6 4 229 0 10 0 58 0 16 0 58 0 21 0 58 0 30 0 58 0 34 0 58 0 48 0 58 0 49 0 58 0 50 0 58 0 51 0 58 0 52 0 58 0 53 0 58 0 55 0 58 0 56 0 58 0 57 0 58 0 58 0 58 0 64 0 58 0 69 0 58 0 82 0 58 0 99]
#[1 0 54 0 4 0 54 0 5 0 54 0 6 4 229 0 10 0 54 0 16 0 54 0 21 0 54 0 30 0 54 0 34 0 54 0 48 0 54 0 49 0 54 0 50 0 54 0 51 0 54 0 52 0 54 0 53 0 54 0 55 0 54 0 56 0 54 0 57 0 54 0 58 0 54 0 64 0 54 0 69 0 54 0 82 0 54 0 99]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 233 0 109 0 37 0 113 0 41 0 114 2 97 0 115 4 237 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 4 241 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 4 245 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 4 249 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 4 253 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 5 1 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[0 4 69 0 34]
#[1 5 58 0 3 4 118 0 4 4 118 0 5 4 118 0 6 4 73 0 7 4 77 0 10 5 58 0 15 4 118 0 16 4 118 0 21 4 118 0 30 4 81 0 34 4 118 0 45 5 58 0 47 4 118 0 48 4 118 0 49 4 118 0 50 4 118 0 51 4 118 0 52 4 118 0 53 5 58 0 54 4 118 0 55 4 118 0 56 4 118 0 57 4 118 0 58 5 58 0 59 5 58 0 60 5 58 0 61 5 58 0 62 5 58 0 63 4 118 0 64 4 118 0 65 5 58 0 66 5 58 0 67 5 58 0 68 4 118 0 69 4 118 0 77 4 118 0 82 4 118 0 83 4 118 0 85 4 118 0 86 4 118 0 87 4 118 0 89 4 118 0 91 4 118 0 92 3 77 0 112]
#[0 5 5 0 21]
#[0 5 54 0 4 0 5 0 6 0 16 0 21 0 30]
#[0 4 130 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 134 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 122 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 4 126 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 4 22 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 4 14 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 4 150 0 4 4 150 0 5 4 150 0 6 4 150 0 16 4 150 0 21 4 150 0 30 4 150 0 45 4 150 0 48 4 150 0 49 4 150 0 50 4 150 0 51 4 150 0 52 4 150 0 53 4 150 0 55 4 150 0 56 4 150 0 57 4 150 0 58 4 150 0 64 4 150 0 65 4 150 0 69 4 109 0 77 4 150 0 82 4 150 0 83 4 150 0 85 4 150 0 86 4 150 0 87 4 113 0 89 4 150 0 91 4 150 0 92]
#[0 4 178 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 146 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 162 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[1 4 194 0 4 4 194 0 5 4 194 0 6 4 194 0 16 4 194 0 21 4 194 0 30 5 9 0 45 4 194 0 48 4 194 0 49 4 194 0 50 4 194 0 51 4 194 0 52 4 194 0 53 4 194 0 55 4 194 0 56 4 194 0 57 4 194 0 58 4 194 0 64 4 194 0 65 4 194 0 69 4 194 0 82 5 13 0 83 4 194 0 85 4 194 0 86 5 17 0 87 4 194 0 91 4 194 0 92]
#[1 4 206 0 4 4 206 0 5 4 206 0 6 4 206 0 16 4 206 0 21 4 206 0 30 4 206 0 48 4 206 0 49 4 206 0 50 4 206 0 51 4 206 0 52 4 206 0 53 4 206 0 55 4 206 0 56 4 206 0 57 4 206 0 58 4 206 0 64 4 206 0 65 4 206 0 69 4 206 0 82 4 206 0 85 4 206 0 86 5 21 0 91 5 25 0 92]
#[1 4 222 0 4 4 222 0 5 4 222 0 6 4 222 0 16 4 222 0 21 4 222 0 30 4 222 0 48 4 222 0 49 4 222 0 50 4 222 0 51 4 222 0 52 4 222 0 53 4 222 0 55 4 222 0 56 4 222 0 57 4 222 0 58 4 222 0 64 5 29 0 65 4 222 0 69 4 222 0 82 5 33 0 85 5 37 0 86]
#[1 4 246 0 4 4 246 0 5 4 246 0 6 4 246 0 16 4 246 0 21 4 246 0 30 4 246 0 48 4 246 0 49 4 246 0 50 4 246 0 51 4 246 0 52 4 246 0 53 5 41 0 55 5 45 0 56 4 246 0 57 5 49 0 58 4 246 0 64 5 53 0 69 5 57 0 82]
#[1 5 2 0 4 5 2 0 5 5 2 0 6 5 2 0 16 5 2 0 21 5 2 0 30 5 2 0 48 5 61 0 49 5 2 0 50 5 2 0 51 5 2 0 52 5 65 0 53 5 2 0 57 5 2 0 64]
#[1 5 10 0 4 5 10 0 5 5 10 0 6 5 10 0 16 5 10 0 21 5 10 0 30 5 69 0 48 5 10 0 50 5 10 0 51 5 10 0 52 5 10 0 57 5 10 0 64]
#[1 5 18 0 4 5 18 0 5 5 18 0 6 5 18 0 16 5 18 0 21 5 18 0 30 5 18 0 50 5 73 0 51 5 18 0 52 5 18 0 57 5 18 0 64]
#[1 5 26 0 4 5 26 0 5 5 26 0 6 5 26 0 16 5 26 0 21 5 26 0 30 5 77 0 50 5 26 0 52 5 26 0 57 5 26 0 64]
#[1 5 34 0 4 5 34 0 5 5 34 0 6 5 34 0 16 5 34 0 21 5 34 0 30 5 34 0 52 5 81 0 57 5 34 0 64]
#[1 5 42 0 4 5 42 0 5 5 42 0 6 5 42 0 16 5 42 0 21 5 42 0 30 5 85 0 52 5 89 0 64]
#[0 5 50 0 4 0 5 0 6 0 16 0 21 0 30]
#[0 1 138 0 4 0 5 0 6 0 16 0 21 0 30]
#[1 3 73 0 10 4 169 0 34 3 81 0 112]
#[0 5 93 0 99]
#[0 5 97 0 9]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 101 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 4 61 0 99 5 105 0 146 3 61 0 147 3 65 0 148]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 109 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 113 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 3 194 0 30]
#[0 5 117 0 30]
#[0 3 230 0 30]
#[0 5 121 0 30]
#[1 5 125 0 73 3 242 0 81 5 129 0 224 5 133 0 225 5 137 0 227]
#[0 5 141 0 30]
#[1 0 70 0 7 5 145 0 10 5 149 0 112 5 153 0 233 5 157 0 235]
#[0 5 161 0 7]
#[1 5 145 0 10 5 165 0 112 5 169 0 233 5 157 0 235]
#[1 4 118 0 4 4 118 0 5 4 118 0 6 4 73 0 7 4 77 0 10 4 118 0 16 4 118 0 21 4 118 0 30 4 81 0 34 4 118 0 45 4 118 0 48 4 118 0 49 4 118 0 50 4 118 0 51 4 118 0 52 4 118 0 53 4 118 0 55 4 118 0 56 4 118 0 57 4 118 0 58 4 118 0 64 4 118 0 65 4 118 0 69 4 118 0 77 4 118 0 82 4 118 0 83 4 118 0 85 4 118 0 86 4 118 0 87 4 118 0 89 4 118 0 91 4 118 0 92 3 77 0 112]
#[0 4 18 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 4 26 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 3 86 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 5 173 0 30]
#[1 1 233 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 3 182 0 30 1 169 0 31 1 173 0 32 1 177 0 33 5 177 0 39 2 29 0 76 2 33 0 77 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 1 209 0 180 5 181 0 181 5 185 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 5 189 0 217 5 193 0 220 5 197 0 221 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 5 1 3]
#[0 3 221 0 7]
#[0 5 201 0 88]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 205 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 3 90 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 5 209 0 179 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 1 122 0 3 0 6 0 10 0 21 0 30]
#[1 4 205 0 6 2 158 0 30]
#[0 5 213 0 9]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 5 221 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 4 225 0 5 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 229 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 5 233 0 9 5 237 0 13 5 241 0 19 0 165 0 99]
#[0 2 10 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 5 245 0 76 5 249 0 99]
#[0 1 94 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 122 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 14 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 253 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 3 94 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 3 98 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 5 70 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 114 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 110 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 74 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 94 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 90 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 106 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 102 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 98 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 86 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 82 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 5 78 0 7 0 13 0 17 0 19 0 24 0 25 0 26 0 27 0 28 0 31 0 32 0 33 0 76 0 77 0 84 0 89 0 90 0 91 0 92 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 6 1 0 251 3 1 0 252 3 209 1 3]
#[0 6 5 0 9]
#[1 0 254 0 1 0 254 0 2 0 209 0 8 6 9 0 131 0 217 0 134]
#[1 1 190 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 6 13 0 39 0 29 0 99 1 181 0 103 1 185 0 104 6 17 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 6 21 0 156 6 25 0 157 6 29 0 158 1 209 0 180 1 213 1 3]
#[1 0 29 0 99 0 233 0 107 0 237 0 109 6 33 0 110 0 37 0 113 0 41 0 114 6 37 0 160]
#[1 6 41 0 1 6 45 0 162]
#[0 1 186 0 1 0 30]
#[1 1 190 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 6 13 0 39 0 29 0 99 1 181 0 103 1 185 0 104 6 17 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 6 49 0 156 6 25 0 157 6 29 0 158 1 209 0 180 1 213 1 3]
#[0 6 53 0 5]
#[0 1 162 0 1 0 30]
#[1 4 61 0 99 6 57 0 147 3 65 0 148]
#[0 1 98 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 6 61 0 1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 6 65 0 149 6 69 0 150 6 73 0 151 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 6 77 0 5]
#[0 1 158 0 1 0 30]
#[0 0 78 0 1 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92 0 99]
#[0 6 81 0 5]
#[1 5 58 0 3 4 73 0 7 4 77 0 10 5 58 0 15 4 118 0 21 4 81 0 34 4 118 0 45 5 58 0 47 4 118 0 48 4 118 0 49 4 118 0 50 4 118 0 51 4 118 0 52 4 118 0 53 5 58 0 54 4 118 0 55 4 118 0 56 4 118 0 57 4 118 0 58 5 58 0 59 5 58 0 60 5 58 0 61 5 58 0 62 5 58 0 63 4 118 0 64 4 118 0 65 5 58 0 66 5 58 0 67 5 58 0 68 4 118 0 69 4 118 0 77 4 118 0 82 4 118 0 83 4 118 0 85 4 118 0 86 4 118 0 87 4 118 0 89 4 118 0 91 4 118 0 92 6 85 0 112]
#[0 6 89 0 21]
#[1 3 73 0 10 4 102 0 21 4 169 0 34 6 93 0 112 6 97 0 234]
#[0 4 158 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 154 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 142 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 138 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 10 0 10 0 34 0 77 0 89]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 6 101 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 6 105 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 6 109 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 6 113 0 240 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 6 117 0 240 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 6 121 0 241 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 6 125 0 241 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 6 129 0 241 3 209 1 3]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 6 133 0 180 6 137 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 6 141 0 242 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 6 145 0 242 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 6 149 0 242 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 6 153 0 242 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 6 157 0 243 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 6 161 0 243 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 6 165 0 244 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 6 169 0 245 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 6 173 0 246 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 6 177 0 247 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 6 181 0 248 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 6 185 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 4 70 0 3 4 70 0 4 4 70 0 5 4 70 0 6 6 189 0 7 4 70 0 10 4 70 0 15 4 70 0 16 4 70 0 21 4 70 0 30 4 70 0 34 4 70 0 45 4 70 0 47 4 70 0 48 4 70 0 49 4 70 0 50 4 70 0 51 4 70 0 52 4 70 0 53 4 70 0 54 4 70 0 55 4 70 0 56 4 70 0 57 4 70 0 58 4 70 0 59 4 70 0 60 4 70 0 61 4 70 0 62 4 70 0 63 4 70 0 64 4 70 0 65 4 70 0 66 4 70 0 67 4 70 0 68 4 70 0 69 4 70 0 77 4 70 0 82 4 70 0 83 4 70 0 85 4 70 0 86 4 70 0 87 4 70 0 89 4 70 0 91 4 70 0 92]
#[0 4 34 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 6 193 0 21]
#[1 4 205 0 6 2 162 0 30]
#[0 6 197 0 21]
#[0 6 201 0 21]
#[0 3 34 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 30 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 6 205 0 7]
#[1 3 46 0 1 3 46 0 4 3 46 0 7 3 46 0 9 3 46 0 11 3 46 0 12 3 46 0 13 3 46 0 14 3 46 0 17 3 46 0 18 3 46 0 19 3 46 0 22 3 46 0 23 3 46 0 24 3 46 0 25 3 46 0 26 3 46 0 27 3 46 0 28 3 46 0 30 3 46 0 31 3 46 0 32 3 46 0 33 3 46 0 35 3 46 0 36 3 46 0 37 3 46 0 38 3 46 0 39 3 46 0 40 3 46 0 41 3 46 0 43 3 46 0 44 3 46 0 46 3 46 0 70 3 46 0 71 3 46 0 72 5 125 0 73 3 46 0 74 3 46 0 75 3 46 0 76 3 46 0 77 3 46 0 78 3 46 0 79 3 46 0 80 3 246 0 81 3 46 0 88 3 46 0 89 3 46 0 93 3 46 0 94 3 46 0 95 3 46 0 96 3 46 0 97 3 46 0 98 3 46 0 99 6 209 0 227]
#[1 6 213 0 81 6 217 0 226]
#[0 3 234 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 42 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 4 225 0 5 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 6 221 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 6 61 0 1 4 229 0 10 6 225 0 151]
#[1 4 102 0 4 4 102 0 5 4 102 0 6 5 145 0 10 4 102 0 16 4 102 0 21 4 102 0 30 4 102 0 34 4 102 0 45 4 102 0 48 4 102 0 49 4 102 0 50 4 102 0 51 4 102 0 52 4 102 0 53 4 102 0 55 4 102 0 56 4 102 0 57 4 102 0 58 4 102 0 64 4 102 0 65 4 102 0 69 4 102 0 77 4 102 0 82 4 102 0 83 4 102 0 85 4 102 0 86 4 102 0 87 4 102 0 89 4 102 0 91 4 102 0 92 6 229 0 112 6 233 0 234 6 237 0 235]
#[0 4 94 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 6 241 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 6 61 0 1 4 229 0 10 6 245 0 151]
#[1 4 102 0 4 4 102 0 5 4 102 0 6 5 145 0 10 4 102 0 16 4 102 0 21 4 102 0 30 4 102 0 34 4 102 0 45 4 102 0 48 4 102 0 49 4 102 0 50 4 102 0 51 4 102 0 52 4 102 0 53 4 102 0 55 4 102 0 56 4 102 0 57 4 102 0 58 4 102 0 64 4 102 0 65 4 102 0 69 4 102 0 77 4 102 0 82 4 102 0 83 4 102 0 85 4 102 0 86 4 102 0 87 4 102 0 89 4 102 0 91 4 102 0 92 6 229 0 112 6 249 0 234 6 237 0 235]
#[0 3 26 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 0 29 0 99 1 181 0 103 1 185 0 104 3 225 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 1 209 0 180 1 213 1 3]
#[0 3 210 0 30]
#[0 3 214 0 6 0 21 0 30]
#[0 6 253 0 30]
#[0 3 186 0 30]
#[1 7 1 0 6 3 206 0 30]
#[0 7 5 0 7]
#[0 7 9 0 21]
#[0 2 210 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 38 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 4 86 0 6 0 21]
#[0 7 13 0 21]
#[1 7 17 0 6 2 18 0 21]
#[0 7 21 0 5]
#[0 4 42 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 7 25 0 34]
#[0 4 46 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 7 29 0 99]
#[1 4 66 0 3 4 66 0 4 4 66 0 5 4 66 0 6 7 33 0 7 4 66 0 10 4 66 0 15 4 66 0 16 4 66 0 21 4 66 0 30 4 66 0 34 4 66 0 45 4 66 0 47 4 66 0 48 4 66 0 49 4 66 0 50 4 66 0 51 4 66 0 52 4 66 0 53 4 66 0 54 4 66 0 55 4 66 0 56 4 66 0 57 4 66 0 58 4 66 0 59 4 66 0 60 4 66 0 61 4 66 0 62 4 66 0 63 4 66 0 64 4 66 0 65 4 66 0 66 4 66 0 67 4 66 0 68 4 66 0 69 4 66 0 77 4 66 0 82 4 66 0 83 4 66 0 85 4 66 0 86 4 66 0 87 4 66 0 89 4 66 0 91 4 66 0 92]
#[0 7 37 0 5]
#[0 3 82 0 4 0 5 0 6 0 16 0 21 0 30]
#[0 4 30 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 1 6 0 1 0 245 0 2 7 41 0 132 0 253 0 136]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 0 29 0 99 1 181 0 103 1 185 0 104 7 45 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 1 209 0 180 1 213 1 3]
#[1 4 61 0 99 7 49 0 148]
#[0 7 53 0 21]
#[1 7 57 0 6 1 194 0 21]
#[0 1 198 0 6 0 21]
#[0 1 218 0 1 0 6 0 30]
#[1 1 214 0 1 7 61 0 6 1 214 0 30]
#[1 1 85 0 1 7 65 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 7 69 0 13 1 241 0 17 1 245 0 18 7 73 0 19 0 89 0 22 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 7 77 0 163 7 81 0 164 7 85 0 166 2 125 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[0 1 90 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 7 89 0 21]
#[0 1 178 0 1 0 10 0 20 0 30]
#[0 1 110 0 6 0 30]
#[1 6 61 0 1 7 93 0 4 7 97 0 6 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 7 101 0 149 6 69 0 150 6 73 0 151 2 117 0 166 7 105 0 175 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 1 118 0 6 0 30]
#[0 1 130 0 4 0 6 0 30]
#[0 1 134 0 4 0 6 0 30]
#[0 1 126 0 3 0 6 0 10 0 21 0 30]
#[0 0 82 0 1 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92 0 99]
#[1 4 229 0 10 7 109 0 21 0 58 0 34]
#[1 4 10 0 4 4 10 0 5 4 10 0 6 3 85 0 7 4 10 0 10 1 237 0 13 4 10 0 16 1 241 0 17 1 249 0 19 4 10 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 4 10 0 30 1 169 0 31 1 173 0 32 1 177 0 33 4 10 0 34 4 10 0 45 4 10 0 48 4 10 0 49 4 10 0 50 4 10 0 51 4 10 0 52 4 10 0 53 4 10 0 55 4 10 0 56 4 10 0 57 4 10 0 58 4 10 0 64 4 10 0 65 4 10 0 69 2 29 0 76 4 10 0 77 4 10 0 82 4 10 0 83 3 89 0 84 4 10 0 85 4 10 0 86 4 10 0 87 4 10 0 89 3 93 0 90 4 10 0 91 4 10 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 7 113 0 238 3 157 0 239 3 209 1 3]
#[1 4 229 0 10 4 106 0 21 0 54 0 34]
#[0 7 117 0 21]
#[0 4 182 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 186 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 190 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[1 4 202 0 4 4 202 0 5 4 202 0 6 4 202 0 16 4 202 0 21 4 202 0 30 5 9 0 45 4 202 0 48 4 202 0 49 4 202 0 50 4 202 0 51 4 202 0 52 4 202 0 53 4 202 0 55 4 202 0 56 4 202 0 57 4 202 0 58 4 202 0 64 4 202 0 65 4 202 0 69 4 202 0 82 5 13 0 83 4 202 0 85 4 202 0 86 5 17 0 87 4 202 0 91 4 202 0 92]
#[1 4 198 0 4 4 198 0 5 4 198 0 6 4 198 0 16 4 198 0 21 4 198 0 30 5 9 0 45 4 198 0 48 4 198 0 49 4 198 0 50 4 198 0 51 4 198 0 52 4 198 0 53 4 198 0 55 4 198 0 56 4 198 0 57 4 198 0 58 4 198 0 64 4 198 0 65 4 198 0 69 4 198 0 82 5 13 0 83 4 198 0 85 4 198 0 86 5 17 0 87 4 198 0 91 4 198 0 92]
#[1 4 218 0 4 4 218 0 5 4 218 0 6 4 218 0 16 4 218 0 21 4 218 0 30 4 218 0 48 4 218 0 49 4 218 0 50 4 218 0 51 4 218 0 52 4 218 0 53 4 218 0 55 4 218 0 56 4 218 0 57 4 218 0 58 4 218 0 64 4 218 0 65 4 218 0 69 4 218 0 82 4 218 0 85 4 218 0 86 5 21 0 91 5 25 0 92]
#[1 4 214 0 4 4 214 0 5 4 214 0 6 4 214 0 16 4 214 0 21 4 214 0 30 4 214 0 48 4 214 0 49 4 214 0 50 4 214 0 51 4 214 0 52 4 214 0 53 4 214 0 55 4 214 0 56 4 214 0 57 4 214 0 58 4 214 0 64 4 214 0 65 4 214 0 69 4 214 0 82 4 214 0 85 4 214 0 86 5 21 0 91 5 25 0 92]
#[1 4 210 0 4 4 210 0 5 4 210 0 6 4 210 0 16 4 210 0 21 4 210 0 30 4 210 0 48 4 210 0 49 4 210 0 50 4 210 0 51 4 210 0 52 4 210 0 53 4 210 0 55 4 210 0 56 4 210 0 57 4 210 0 58 4 210 0 64 4 210 0 65 4 210 0 69 4 210 0 82 4 210 0 85 4 210 0 86 5 21 0 91 5 25 0 92]
#[0 4 242 0 4 0 5 0 6 0 16 0 21 0 30 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 69 0 82]
#[1 3 73 0 10 3 81 0 112]
#[1 4 238 0 4 4 238 0 5 4 238 0 6 4 238 0 16 4 238 0 21 4 238 0 30 4 238 0 48 4 238 0 49 4 238 0 50 4 238 0 51 4 238 0 52 4 238 0 53 4 238 0 55 4 238 0 56 4 238 0 57 4 238 0 58 4 238 0 64 5 29 0 65 4 238 0 69 4 238 0 82 5 33 0 85 5 37 0 86]
#[1 4 230 0 4 4 230 0 5 4 230 0 6 4 230 0 16 4 230 0 21 4 230 0 30 4 230 0 48 4 230 0 49 4 230 0 50 4 230 0 51 4 230 0 52 4 230 0 53 4 230 0 55 4 230 0 56 4 230 0 57 4 230 0 58 4 230 0 64 5 29 0 65 4 230 0 69 4 230 0 82 5 33 0 85 5 37 0 86]
#[1 4 234 0 4 4 234 0 5 4 234 0 6 4 234 0 16 4 234 0 21 4 234 0 30 4 234 0 48 4 234 0 49 4 234 0 50 4 234 0 51 4 234 0 52 4 234 0 53 4 234 0 55 4 234 0 56 4 234 0 57 4 234 0 58 4 234 0 64 5 29 0 65 4 234 0 69 4 234 0 82 5 33 0 85 5 37 0 86]
#[1 4 226 0 4 4 226 0 5 4 226 0 6 4 226 0 16 4 226 0 21 4 226 0 30 4 226 0 48 4 226 0 49 4 226 0 50 4 226 0 51 4 226 0 52 4 226 0 53 4 226 0 55 4 226 0 56 4 226 0 57 4 226 0 58 4 226 0 64 5 29 0 65 4 226 0 69 4 226 0 82 5 33 0 85 5 37 0 86]
#[1 4 250 0 4 4 250 0 5 4 250 0 6 4 250 0 16 4 250 0 21 4 250 0 30 4 250 0 48 4 250 0 49 4 250 0 50 4 250 0 51 4 250 0 52 4 250 0 53 5 41 0 55 5 45 0 56 4 250 0 57 5 49 0 58 4 250 0 64 5 53 0 69 5 57 0 82]
#[1 4 254 0 4 4 254 0 5 4 254 0 6 4 254 0 16 4 254 0 21 4 254 0 30 4 254 0 48 4 254 0 49 4 254 0 50 4 254 0 51 4 254 0 52 4 254 0 53 5 41 0 55 5 45 0 56 4 254 0 57 5 49 0 58 4 254 0 64 5 53 0 69 5 57 0 82]
#[1 5 6 0 4 5 6 0 5 5 6 0 6 5 6 0 16 5 6 0 21 5 6 0 30 5 6 0 48 5 61 0 49 5 6 0 50 5 6 0 51 5 6 0 52 5 65 0 53 5 6 0 57 5 6 0 64]
#[1 5 14 0 4 5 14 0 5 5 14 0 6 5 14 0 16 5 14 0 21 5 14 0 30 5 69 0 48 5 14 0 50 5 14 0 51 5 14 0 52 5 14 0 57 5 14 0 64]
#[1 5 22 0 4 5 22 0 5 5 22 0 6 5 22 0 16 5 22 0 21 5 22 0 30 5 22 0 50 5 73 0 51 5 22 0 52 5 22 0 57 5 22 0 64]
#[1 5 30 0 4 5 30 0 5 5 30 0 6 5 30 0 16 5 30 0 21 5 30 0 30 5 77 0 50 5 30 0 52 5 30 0 57 5 30 0 64]
#[1 5 38 0 4 5 38 0 5 5 38 0 6 5 38 0 16 5 38 0 21 5 38 0 30 5 38 0 52 5 81 0 57 5 38 0 64]
#[0 7 121 0 16]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 7 125 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 1 85 0 1 7 129 0 143]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 7 133 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 7 137 0 79 2 45 0 80 7 141 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 145 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 7 149 0 179 7 153 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 7 157 0 188 7 161 0 189 7 165 0 190 7 169 0 191 7 173 0 192 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[1 7 177 0 1 7 181 0 211]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 6 13 0 39 0 29 0 99 1 181 0 103 1 185 0 104 6 17 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 7 185 0 158 1 209 0 180 1 213 1 3]
#[0 3 238 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 85 0 1 7 189 0 143]
#[0 3 50 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 7 193 0 5]
#[0 4 62 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 4 106 0 4 4 106 0 5 4 106 0 6 4 229 0 10 4 106 0 16 4 106 0 21 4 106 0 30 4 106 0 34 4 106 0 45 4 106 0 48 4 106 0 49 4 106 0 50 4 106 0 51 4 106 0 52 4 106 0 53 4 106 0 55 4 106 0 56 4 106 0 57 4 106 0 58 4 106 0 64 4 106 0 65 4 106 0 69 4 106 0 77 4 106 0 82 4 106 0 83 4 106 0 85 4 106 0 86 4 106 0 87 4 106 0 89 4 106 0 91 4 106 0 92]
#[0 4 54 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 4 98 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 7 197 0 21]
#[0 4 58 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 4 50 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 3 190 0 30 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 3 237 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 7 201 0 218 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 1 233 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 7 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 7 209 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 7 213 0 179 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 3 102 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 7 217 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 4 78 0 3 0 4 0 5 0 6 0 10 0 15 0 16 0 21 0 30 0 34 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 7 221 0 99]
#[0 7 225 0 7]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 7 229 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 4 82 0 3 0 4 0 5 0 6 0 10 0 15 0 16 0 21 0 30 0 34 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 1 29 0 1 7 233 0 133]
#[1 4 61 0 99 7 237 0 148]
#[1 1 206 0 6 4 217 0 10 1 206 0 21]
#[0 1 226 0 1 0 20]
#[1 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 6 13 0 39 0 29 0 99 1 181 0 103 1 185 0 104 6 17 0 105 1 193 0 106 1 197 0 107 1 201 0 108 1 205 0 109 0 37 0 113 0 41 0 114 7 241 0 158 1 209 0 180 1 213 1 3]
#[1 0 29 0 99 0 233 0 107 0 237 0 109 7 245 0 110 0 37 0 113 0 41 0 114]
#[0 1 242 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 7 249 0 7 3 213 0 34]
#[1 7 253 0 7 4 6 0 10 4 6 0 34 4 6 0 77 4 6 0 89]
#[1 1 85 0 1 8 1 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 1 237 0 13 1 241 0 17 1 245 0 18 1 249 0 19 0 89 0 22 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 8 5 0 164 2 117 0 166 2 125 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[1 1 85 0 1 8 9 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 1 237 0 13 1 241 0 17 1 245 0 18 1 249 0 19 0 89 0 22 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 2 117 0 166 4 85 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[1 8 13 0 34 4 114 0 77 4 114 0 89]
#[0 1 174 0 1 0 10 0 20 0 30]
#[0 1 154 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 8 17 0 4]
#[0 2 90 0 4 0 6]
#[1 8 21 0 4 8 25 0 6]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 3 89 0 84 3 93 0 90 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 8 29 0 238 3 157 0 239 3 209 1 3]
#[0 4 170 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 8 33 0 237 3 153 0 238 3 157 0 239 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 4 17 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 4 21 0 230 4 25 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 8 37 0 250 3 209 1 3]
#[0 8 41 0 21]
#[0 3 38 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 8 45 0 7]
#[0 8 49 0 7]
#[0 8 53 0 7]
#[1 0 86 0 3 0 86 0 7 0 86 0 10 0 86 0 15 8 57 0 16 0 86 0 34 0 86 0 47 0 86 0 54 0 86 0 59 0 86 0 60 0 86 0 61 0 86 0 62 0 86 0 63 0 86 0 66 0 86 0 67 0 86 0 68 0 86 0 77 0 86 0 89]
#[0 2 214 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 2 126 0 1 2 126 0 4 2 126 0 7 2 126 0 9 2 126 0 11 2 126 0 12 2 126 0 13 2 246 0 14 2 126 0 17 2 126 0 18 2 126 0 19 2 126 0 22 2 126 0 23 2 126 0 24 2 126 0 25 2 126 0 26 2 126 0 27 2 126 0 28 2 126 0 30 2 126 0 31 2 126 0 32 2 126 0 33 2 126 0 35 2 126 0 36 2 126 0 37 2 126 0 38 2 126 0 39 2 126 0 40 2 126 0 41 2 126 0 43 2 126 0 44 2 126 0 46 2 126 0 70 2 126 0 71 2 126 0 72 2 126 0 74 2 126 0 75 2 126 0 76 2 126 0 77 2 126 0 78 2 126 0 79 2 126 0 80 2 126 0 88 2 126 0 89 2 126 0 93 2 126 0 94 2 126 0 95 2 126 0 96 2 126 0 97 2 126 0 98 2 126 0 99]
#[0 2 250 0 14]
#[0 2 254 0 14]
#[0 3 2 0 14]
#[0 3 6 0 14]
#[0 8 61 0 14]
#[1 8 65 0 4 8 69 0 23 8 73 0 41 8 77 0 212 8 81 0 213 8 85 0 214 8 89 0 215]
#[0 3 18 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 8 93 0 21]
#[0 3 250 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 110 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 1 29 0 1 3 118 0 4 3 118 0 5 3 118 0 6 3 118 0 10 3 118 0 16 3 118 0 21 3 118 0 30 3 118 0 34 3 118 0 45 3 118 0 48 3 118 0 49 3 118 0 50 3 118 0 51 3 118 0 52 3 118 0 53 3 118 0 55 3 118 0 56 3 118 0 57 3 118 0 58 3 118 0 64 3 118 0 65 3 118 0 69 3 118 0 77 3 118 0 82 3 118 0 83 3 118 0 85 3 118 0 86 3 118 0 87 3 118 0 89 3 118 0 91 3 118 0 92 8 97 0 133]
#[0 8 101 0 30]
#[0 3 218 0 6 0 21 0 30]
#[0 8 105 0 21]
#[0 2 222 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 4 90 0 6 0 21]
#[1 4 74 0 3 4 74 0 4 4 74 0 5 4 74 0 6 8 109 0 7 4 74 0 10 4 74 0 15 4 74 0 16 4 74 0 21 4 74 0 30 4 74 0 34 4 74 0 45 4 74 0 47 4 74 0 48 4 74 0 49 4 74 0 50 4 74 0 51 4 74 0 52 4 74 0 53 4 74 0 54 4 74 0 55 4 74 0 56 4 74 0 57 4 74 0 58 4 74 0 59 4 74 0 60 4 74 0 61 4 74 0 62 4 74 0 63 4 74 0 64 4 74 0 65 4 74 0 66 4 74 0 67 4 74 0 68 4 74 0 69 4 74 0 77 4 74 0 82 4 74 0 83 4 74 0 85 4 74 0 86 4 74 0 87 4 74 0 89 4 74 0 91 4 74 0 92]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 8 113 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 8 117 0 21]
#[0 1 74 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 1 210 0 6 4 217 0 10 1 210 0 21]
#[0 1 202 0 6 0 21]
#[0 1 222 0 1 0 6 0 30]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 8 121 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 8 125 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 1 234 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 1 85 0 1 8 129 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 1 237 0 13 1 241 0 17 1 245 0 18 1 249 0 19 0 89 0 22 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 2 117 0 166 4 85 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[0 1 238 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[1 8 133 0 13 8 137 0 19 5 245 0 76 5 249 0 99]
#[0 1 150 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 1 146 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 6 61 0 1 8 141 0 4 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 8 145 0 149 6 69 0 150 6 73 0 151 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 4 174 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 4 166 0 4 0 5 0 6 0 16 0 21 0 30 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 82 0 83 0 85 0 86 0 87 0 91 0 92]
#[0 5 46 0 4 0 5 0 6 0 16 0 21 0 30]
#[0 3 110 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 8 149 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 1 233 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 3 182 0 30 1 169 0 31 1 173 0 32 1 177 0 33 5 177 0 39 2 29 0 76 2 33 0 77 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 1 209 0 180 5 181 0 181 5 185 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 8 153 0 217 5 193 0 220 5 197 0 221 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 5 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 8 157 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 7 133 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 7 137 0 79 2 45 0 80 7 141 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 145 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 5 209 0 179 7 153 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 7 157 0 188 7 161 0 189 7 165 0 190 7 169 0 191 8 161 0 192 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 8 165 0 179 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 3 146 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 8 169 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 8 173 0 216 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 8 177 0 16]
#[1 8 181 0 4 8 69 0 23 8 73 0 41 8 185 0 213 8 189 0 214 8 89 0 215]
#[1 1 85 0 1 8 193 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 1 237 0 13 1 241 0 17 1 245 0 18 1 249 0 19 0 89 0 22 8 69 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 8 73 0 41 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 8 197 0 164 2 117 0 166 2 125 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 8 201 0 215 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[0 3 150 0 4 0 23 0 41]
#[0 3 158 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 85 0 1 8 205 0 143]
#[0 3 122 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[1 1 233 0 7 1 237 0 13 1 241 0 17 1 249 0 19 3 198 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 5 185 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 8 209 0 219 8 213 0 221 8 217 0 222 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 8 221 0 30]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 8 225 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[0 8 229 0 21]
#[0 3 106 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 8 233 0 21]
#[0 8 237 0 21]
#[0 1 230 0 1 0 4 0 9 0 11 0 12 0 17 0 18 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 99]
#[0 8 241 0 7]
#[0 8 245 0 7]
#[0 1 142 0 4 0 5 0 6 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 2 94 0 4 0 6]
#[0 8 249 0 21]
#[0 8 253 0 30]
#[0 9 1 0 21]
#[0 2 230 0 14]
#[0 2 218 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 178 0 16]
#[0 9 5 0 16]
#[0 3 174 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 138 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 85 0 1 9 9 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 1 237 0 13 1 241 0 17 1 245 0 18 1 249 0 19 0 89 0 22 8 69 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 8 73 0 41 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 8 197 0 164 2 117 0 166 2 125 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 8 201 0 215 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[0 3 154 0 4 0 23 0 41]
#[0 3 142 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 85 0 1 3 166 0 4 1 233 0 7 0 202 0 9 0 81 0 11 0 202 0 12 1 237 0 13 1 241 0 17 1 245 0 18 1 249 0 19 0 89 0 22 3 166 0 23 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 0 97 0 35 0 101 0 36 0 105 0 37 0 109 0 38 2 1 0 39 0 117 0 40 3 166 0 41 0 121 0 43 0 125 0 44 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 2 85 0 105 1 193 0 106 1 197 0 107 2 89 0 108 2 93 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 101 0 126 2 105 0 127 0 149 0 129 0 153 0 130 2 109 0 143 2 117 0 166 4 85 0 177 2 129 0 178 2 133 0 179 1 209 0 180 2 137 0 181 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 0 157 1 2 3 5 1 3]
#[0 3 162 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 254 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 13 0 21]
#[1 7 1 0 6 3 222 0 21]
#[0 3 202 0 21]
#[0 3 22 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 17 0 21]
#[1 1 29 0 1 3 126 0 4 3 126 0 5 3 126 0 6 3 126 0 10 3 126 0 16 3 126 0 21 3 126 0 30 3 126 0 34 3 126 0 45 3 126 0 48 3 126 0 49 3 126 0 50 3 126 0 51 3 126 0 52 3 126 0 53 3 126 0 55 3 126 0 56 3 126 0 57 3 126 0 58 3 126 0 64 3 126 0 65 3 126 0 69 3 126 0 77 3 126 0 82 3 126 0 83 3 126 0 85 3 126 0 86 3 126 0 87 3 126 0 89 3 126 0 91 3 126 0 92 9 21 0 133]
#[0 9 25 0 30]
#[0 9 29 0 30]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 9 33 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 2 14 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 5 217 0 150 9 37 0 165 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 5 225 0 232 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 7 133 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 7 137 0 79 2 45 0 80 7 141 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 145 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 7 149 0 179 7 153 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 7 157 0 188 7 161 0 189 7 165 0 190 7 169 0 191 9 41 0 192 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[1 3 85 0 7 1 237 0 13 1 241 0 17 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 3 190 0 30 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 3 89 0 84 2 53 0 89 3 93 0 90 3 97 0 91 3 101 0 92 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 3 237 0 150 2 117 0 166 3 117 0 204 3 121 0 205 3 125 0 206 3 129 0 207 3 133 0 208 3 137 0 209 3 141 0 210 9 45 0 218 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 3 145 0 236 3 149 0 237 3 153 0 238 3 157 0 239 3 161 0 240 3 165 0 241 3 169 0 242 3 173 0 243 3 177 0 244 3 181 0 245 3 185 0 246 3 189 0 247 3 193 0 248 3 197 0 249 3 201 0 250 3 205 0 251 3 1 0 252 3 209 1 3]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 7 133 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 7 137 0 79 2 45 0 80 7 141 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 145 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 7 213 0 179 7 153 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 7 157 0 188 7 161 0 189 7 165 0 190 7 169 0 191 9 49 0 192 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 3 170 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 3 134 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 14 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 2 5 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 2 41 0 79 2 45 0 80 2 49 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 2 81 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 9 53 0 179 2 141 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 3 114 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 3 130 0 4 0 5 0 6 0 10 0 16 0 21 0 30 0 34 0 45 0 48 0 49 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 64 0 65 0 69 0 77 0 82 0 83 0 85 0 86 0 87 0 89 0 91 0 92]
#[0 1 250 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 1 246 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 57 0 21]
#[0 9 61 0 21]
#[0 9 65 0 14]
#[0 9 69 0 30]
#[0 2 238 0 14]
#[0 2 226 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 41 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 9 73 0 30]
#[0 9 77 0 30]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 7 133 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 7 137 0 79 2 45 0 80 7 141 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 145 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 8 165 0 179 7 153 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 7 157 0 188 7 161 0 189 7 165 0 190 7 169 0 191 9 81 0 192 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[1 1 233 0 7 1 237 0 13 1 241 0 17 1 249 0 19 3 198 0 21 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 169 0 31 1 173 0 32 1 177 0 33 2 29 0 76 2 33 0 77 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 0 29 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 117 0 166 5 185 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 9 85 0 219 8 213 0 221 8 217 0 222 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 2 2 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 1 254 0 1 0 4 0 7 0 9 0 11 0 12 0 13 0 17 0 18 0 19 0 22 0 24 0 25 0 26 0 27 0 28 0 30 0 31 0 32 0 33 0 35 0 36 0 37 0 38 0 39 0 40 0 43 0 44 0 46 0 70 0 71 0 72 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 88 0 89 0 93 0 94 0 95 0 96 0 97 0 98 0 99]
#[0 2 234 0 14]
#[0 9 89 0 21]
#[1 1 85 0 1 1 233 0 7 1 237 0 13 1 241 0 17 4 41 0 18 1 249 0 19 1 149 0 24 1 153 0 25 1 157 0 26 1 161 0 27 1 165 0 28 1 253 0 30 1 169 0 31 1 173 0 32 1 177 0 33 7 133 0 46 2 9 0 70 2 13 0 71 2 17 0 72 2 21 0 74 2 25 0 75 2 29 0 76 2 33 0 77 2 37 0 78 7 137 0 79 2 45 0 80 7 141 0 88 2 53 0 89 2 57 0 93 2 61 0 94 2 65 0 95 2 69 0 96 2 73 0 97 2 77 0 98 7 145 0 99 1 181 0 103 1 185 0 104 1 193 0 106 3 105 0 108 3 109 0 109 0 37 0 113 0 41 0 114 2 97 0 115 2 109 0 143 2 117 0 166 9 53 0 179 7 153 0 182 2 145 0 183 2 149 0 184 2 153 0 185 2 157 0 186 2 161 0 187 7 157 0 188 7 161 0 189 7 165 0 190 7 169 0 191 9 93 0 192 2 165 0 193 2 169 0 194 2 173 0 195 2 177 0 196 2 181 0 197 2 185 0 198 2 189 0 199 2 193 0 200 2 197 0 201 2 201 0 202 2 205 0 203 2 209 0 204 2 213 0 205 2 217 0 206 2 221 0 207 2 225 0 208 2 229 0 209 2 233 0 210 2 237 0 228 2 241 0 229 2 245 0 230 2 249 0 231 2 253 0 236 3 1 0 252 3 209 1 3]
#[0 2 242 0 14]
)
! !

!JavaParser class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/smaCC/tests/JavaParser.st,v 1.5 2006/07/14 09:57:20 cg Exp $'
! !
