"{ NameSpace: Benchmarks }"

UnaryConstraint subclass:#StayConstraint
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'benchmarks-DeltaBlue'
!

StayConstraint comment:'I mark variables that should, with some level of preference, stay the same. I have one method with zero inputs and one output, which does nothing. Planners may exploit the fact that, if I am satisfied, my output will not change during plan execution. This is called "stay optimization."'!


!StayConstraint class methodsFor:'instance creation'!

var: aVariable strength: strengthSymbol
	"Install a stay constraint with the given strength on the given variable."

	^(self new) var: aVariable strength: strengthSymbol! !

!StayConstraint methodsFor:'execution'!

execute
	"Stay constraints do nothing."! !

!StayConstraint methodsFor:'queries'!

includeInPlan
	"Stay constraints have no effect other than to control the planning process."

	^false! !

!StayConstraint class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/benchmarks/deltaBlue/StayConstraint.st,v 1.4 1997/01/03 17:39:06 cg Exp $'
! !
