/*
 * $Header: /cvs/stx/stx/librun/asmhelp.c,v 1.160 2011/08/03 17:52:51 stefan Exp $
 */

#define NO_ASM_STOREINST

#ifdef __ASSEMBLER__

#include <stcIntern.h>
#include <stcVMoffsets.h>
#undef EXPORT

#if defined(__FIXBASE__)
# ifdef ADDR_true
#  define true               ADDR_true
#  define false              ADDR_false
#  define SmallInteger       ADDR_SmallInteger
#  define UndefinedObject    ADDR_UndefinedObject
#  define Float              ADDR_Float
#  define ShortFloat         ADDR_ShortFloat
#  define trueStruct         ADDR_trueStruct
#  define falseStruct        ADDR_falseStruct
#  define __newEndPtr        ADDR___newEndPtr__
#  define __newNextPtr       ADDR___newNextPtr__
#  define __newSpace         ADDR___newSpace__
#  define __stackBottom__    ADDR___stackBottom__
#  define __stackTop__       ADDR___stackTop__
#  define __new              ADDR___new
#  define Context            ADDR_Context
#  define BlockContext       ADDR_BlockContext
# endif
#endif

#include "codeEntry.h"


/*
 * define this, if ILC's class is always updated,
 * and directed calls always patch it correctly.
 * If so, the searchClass arg needs not to be checked.
 * For now, this cannot be left undefined.
 */
#define CHECK_SEARCHCLASS

/*
 * the only function that MUST be defined here is __switchStack__.
 * if not defined, Process support is impossible
 * (i.e. the system will run PureEventDriven)
 *
 * with GNUC, __switchStack__ is inline coded
 *
 * all other functions are optional and will more or less
 * speedup the system (actually, dont expect too much ;-)
 * Corresponding C-versions are found in utils.c
 */

/*------------------------------------------------------------------
 *
 * MACHINE: i386
 *
 *------------------------------------------------------------------*/
#if defined(__i386__) && !defined(__amd64__)

/* # define USE_JCXZ this does not work - why ? */
# define PILC_EARLY     /* 8ns of 204ns (4%) saving in instVar-access ;-) on 133Mhz P5 */
# define PILC_EARLY2    /* does not make a difference ... */

# if defined(SYSV4) || defined(ELF) || defined(__FIXBASE__) /* { */
#  define FLOAT           Float
#  define SHORTFLOAT      ShortFloat
#  define SMALLINTEGER    SmallInteger
#  define UNDEFINEDOBJECT UndefinedObject
#  define TRUE            true
#  define FALSE           false
#  define STACKBOTTOM     __stackBottom__
#  define NEWNEXTPTR      __newNextPtr
#  define NEWENDPTR       __newEndPtr
#  define NEWSPACE        __newSpace
#  define CPUID           __cpuid
#  define IS386CPU        __is386CPU
# else /* } { */
#  ifdef __DIRECTVMDATA__ /* { */
#   define FLOAT           _Float
#   define SHORTFLOAT      _ShortFloat
#   define SMALLINTEGER    _SmallInteger
#   define UNDEFINEDOBJECT _UndefinedObject
#   define TRUE            _true
#   define FALSE           _false
#   define STACKBOTTOM     ___stackBottom__
#   define NEWNEXTPTR      ___newNextPtr
#   define NEWENDPTR       ___newEndPtr
#   define NEWSPACE        ___newSpace
#   define CPUID           ___cpuid
#   define IS386CPU        ___is386CPU
#  endif /* } */
# endif /* } */

# if defined(SYSV4) || defined(ELF) /* { */

#  ifdef __STATIC_LIBRUN__ /* { */

#   define MKFLOAT      __MKFLOAT
#   define MKSFLOAT     __MKSFLOAT
#   define MKLARGEINT   __MKLARGEINT
#   define NEW          __new
#   define SEND0        _SEND0
#   define SEND1        _SEND1
#   define SEND2        _SEND2
#   define SEND3        _SEND3
#   define SEND4        _SEND4
#   define SEND5        _SEND5
#   define SEND6        _SEND6
#   define SEND7        _SEND7
#   define SEND8        _SEND8
#   define SEND9        _SEND9
#   define SEND10       _SEND10
#   define SEND11       _SEND11
#   define SEND12       _SEND12
#   define SEND13       _SEND13
#   define SEND14       _SEND14
#   define SEND15       _SEND15

#  else /* non static link } { */
    /*
     * cannot do PLT calls, since %ebx is not setup correctly
     * must call via FIX-table, or else use static calls
     */
#   ifdef THIS_DOES_NOT_WORK /* { */

#    define MKFLOAT     __MKFLOAT@PLT
#    define MKSFLOAT    __MKSFLOAT@PLT
#    define MKLARGEINT  __MKLARGEINT@PLT
#    define NEW         __new@PLT
#    define SEND0       _SEND0@PLT
#    define SEND1       _SEND1@PLT
#    define SEND2       _SEND2@PLT
#    define SEND3       _SEND3@PLT
#    define SEND4       _SEND4@PLT
#    define SEND5       _SEND5@PLT
#    define SEND6       _SEND6@PLT
#    define SEND7       _SEND7@PLT
#    define SEND8       _SEND8@PLT
#    define SEND9       _SEND9@PLT
#    define SEND10      _SEND10@PLT
#    define SEND11      _SEND11@PLT
#    define SEND12      _SEND12@PLT
#    define SEND13      _SEND13@PLT
#    define SEND14      _SEND14@PLT
#    define SEND15      _SEND15@PLT

#   else /* } { */

#    if defined(__FIXBASE__)
#     define USE_FIXBASE_CALLS
#    endif

#    define MKFLOAT     __MKFLOAT
#    define MKSFLOAT    __MKSFLOAT
#    define MKLARGEINT  __MKLARGEINT
#    define NEW         __new
#    define SEND0       _SEND0
#    define SEND1       _SEND1
#    define SEND2       _SEND2
#    define SEND3       _SEND3
#    define SEND4       _SEND4
#    define SEND5       _SEND5
#    define SEND6       _SEND6
#    define SEND7       _SEND7
#    define SEND8       _SEND8
#    define SEND9       _SEND9
#    define SEND10      _SEND10
#    define SEND11      _SEND11
#    define SEND12      _SEND12
#    define SEND13      _SEND13
#    define SEND14      _SEND14
#    define SEND15      _SEND15

#   endif /* } */

#  endif /* non static link } */

# else /* non-ELF; direct call with additional underscore } { */

#  define __STATIC_LIBRUN__
#  define MKFLOAT       ___MKFLOAT
#  define MKSFLOAT      ___MKSFLOAT
#  define MKLARGEINT    ___MKLARGEINT
#  define SEND0         __SEND0
#  define SEND1         __SEND1
#  define SEND2         __SEND2
#  define SEND3         __SEND3
#  define SEND4         __SEND4
#  define SEND5         __SEND5
#  define SEND6         __SEND6
#  define SEND7         __SEND7
#  define SEND8         __SEND8
#  define SEND9         __SEND9
#  define SEND10        __SEND10
#  define SEND11        __SEND11
#  define SEND12        __SEND12
#  define SEND13        __SEND13
#  define SEND14        __SEND14
#  define SEND15        __SEND15
#  define SENDN         __SENDN
#  define NEW           ___new
#  define __ySTACK_HANDLER__ ___ySTACK_HANDLER__

	.text

	.globl  MKLARGEINT
	.globl  NEW
# endif /* to ELF or not to ELF } */


# undef ALIGN
# define ALIGN   .align 4

/*
 * ---------------------------------------------------
 */
# if !defined(__GNUC__) /* { */
	/*
	 * in GNUC, this is inline coded
	 */
	.text
	.globl  __switchStack__
	ALIGN
__switchStack__:
	popl    %edx
	movl    0(%esp),%eax
	movl    %eax, %esp
	pushl   %edx
	ret
#endif /* } */

/*
 * ---------------------------------------------------
 */
	.globl IS386CPU
IS386CPU:
	pushfl
	popl    %eax
	movl    %eax,%ecx
	xorl    $0x040000,%eax
	pushl   %eax
	popfl
	pushfl
	popl    %eax
	xorl    %ecx,%eax
	jz      itsA386

	pushl   %ecx
	popfl
	movl    %ecx,%eax
	xorl    $0x200000,%eax
	pushl   %eax
	popfl
	pushfl
	popl    %eax
	xorl    %ecx,%eax
	je      itsA386
	movl    $0, %eax
	ret
itsA386:
	movl    $1,%eax
	ret

/*
 * ---------------------------------------------------
 */
	.globl CPUID
CPUID:
	push %eax               /* ptr at 4(esp); eax-arg at 8(esp) */
	push %ebx
	push %ecx
	push %edx
	push %edi               /* ptr at 24(esp); eax-arg at 28(esp) */
	mov  28(%esp), %eax
	cpuid
	mov  24(%esp), %edi
	mov  %eax, 0(%edi)
	mov  %ebx, 4(%edi)
	mov  %ecx, 8(%edi)
	mov  %edx, 12(%edi)
	pop  %edi
	pop  %edx
	pop  %ecx
	pop  %ebx
	pop  %eax
	ret


/*
 * ---------------------------------------------------
 */
#if defined(__GNUC__) /* { */

/*
 * entry to c-function MKLARGEINT() to be called
 * from inline asm code. sigh: SYSV4 does not add an initial '_'
 * notice, when we arrive here, the value in eax resulted from
 * an overflow when doing (val << 1) OP ((val2 << 1)+1);
 * therefore, an rcrl is req'd to adjust before MKLARGE can be
 * called.
 */
	.text

/*
 * overflow after addition
 */
	ALIGN
# if defined(ELF)
	.globl  __MKLARGEINTov_a
__MKLARGEINTov_a:
# else
	.globl  ___MKLARGEINTov_a
___MKLARGEINTov_a:
# endif

	pushl   %ebx
	pushl   %ecx
	pushl   %edx
	rcrl    %eax
	pushl   %eax
# if defined(USE_FIXBASE_CALLS)
	movl    ADDR___MKLARGEINT, %eax
	call    *%eax
# else
	call    MKLARGEINT
# endif
	addl    $4,%esp
	popl    %edx
	popl    %ecx
	popl    %ebx
	ret

/*
 * overflow after addition req's result minus 1 (incremented in macro)
 */
	ALIGN
# if defined(ELF)
	.globl  __MKLARGEINTovM1
__MKLARGEINTovM1:
# else
	.globl  ___MKLARGEINTovM1
___MKLARGEINTovM1:
# endif

	pushl   %ebx
	pushl   %ecx
	pushl   %edx
	rcrl    %eax
	pushl   %eax
# if defined(USE_FIXBASE_CALLS)
	movl    ADDR___MKLARGEINT, %eax
	call    *%eax
# else
	call    MKLARGEINT
# endif
	addl    $4,%esp
	popl    %edx
	popl    %ecx
	popl    %ebx
	decl    %eax    /* will be incremented - see ADD_IO_2 macro */
	ret


/*
 * overflow after subtraction
 */
	ALIGN
# if defined(ELF)
	.globl  __MKLARGEINTov_s
__MKLARGEINTov_s:
# else
	.globl  ___MKLARGEINTov_s
___MKLARGEINTov_s:
# endif

	pushl   %ebx
	pushl   %ecx
	pushl   %edx
	cmc
	rcrl    %eax
	pushl   %eax
# if defined(USE_FIXBASE_CALLS)
	movl    ADDR___MKLARGEINT, %eax
	call    *%eax
# else
	call    MKLARGEINT
# endif
	addl    $4,%esp
	popl    %edx
	popl    %ecx
	popl    %ebx
	ret

/*
 * overflow after subtraction; req's result minus 1 (incremented in macro)
 */
	ALIGN
# if defined(ELF)
	.globl  __MKLARGEINTov_s1
__MKLARGEINTov_s1:
# else
	.globl  ___MKLARGEINTov_s1
___MKLARGEINTov_s1:
# endif

	pushl   %ebx
	pushl   %ecx
	pushl   %edx
	cmc
	rcrl    %eax
	pushl   %eax
# if defined(USE_FIXBASE_CALLS)
	movl    ADDR___MKLARGEINT, %eax
	call    *%eax
# else
	call    MKLARGEINT
# endif
	addl    $4,%esp
	popl    %edx
	popl    %ecx
	popl    %ebx

	decl    %eax    /* will be incremented - see SUB_IO_IO macro */
	ret             /* notice: we operate on a pointer here ...  */

#endif /* GNUC } */

/*
 * ---------------------------------------------------
 */

# if !defined(ELF) || defined(__FIXBASE__)

#  if defined(NEWNEXTPTR) /* { */

#   if (!defined(SYSV4) && !defined(ELF)) || defined(__FIXBASE__) /* { */
	/*
	 * access fix-struct vars either directly or via FIXBASE
	 */
	.globl MKFLOAT
	ALIGN
MKFLOAT:
	movl NEWNEXTPTR,%eax    /* __newNextPtr+20 >= __newEndPtr ? */
	leal 20(%eax),%edx
	cmpl %edx,NEWENDPTR
	jbe  mkfl2

	movl $20,4(%eax)        /* newFLoat->o_size */

	xorl %ecx,%ecx
	movb NEWSPACE,%cl
	movl %ecx,8(%eax)       /* newFLoat->o_space & flags */

	movl %edx,NEWNEXTPTR    /* update __newEndPtr */
mkfl1:
	movl FLOAT,%ecx
	movl 4(%esp),%edx
	movl %ecx,(%eax)        /* newFloat->o_class */
	movl 8(%esp),%ecx
	movl %edx,12(%eax)      /* floatVal(newFloat) */
	movl %ecx,16(%eax)
	ret                     /* newFloat in eax */

	.align 4
mkfl2:
	pushl $20
#   ifdef USE_FIXBASE_CALLS
	movl    ADDR___new, %eax
	call     *%eax
#   else
	call NEW
#   endif
	addl $4,%esp
	jmp  mkfl1

/*
 * ---------------------------------------------------
 */
#  if 0
	/*
	 * cannot do this, since a float is always
	 * passed as a double on the stack.
	 * ...
	 */
	.globl MKSFLOAT
	ALIGN
MKSFLOAT:
	movl NEWNEXTPTR,%eax    /* __newNextPtr+16 >= __newEndPtr ? */
	leal 16(%eax),%edx
	cmpl %edx,NEWENDPTR
	jbe  mksfl2

	movl $16,4(%eax)        /* newFLoat->o_size */

	xorl %ecx,%ecx
	movb NEWSPACE,%cl
	movl %ecx,8(%eax)       /* newFLoat->o_space & flags */

	movl %edx,NEWNEXTPTR    /* update __newEndPtr */
mksfl1:
	movl SHORTFLOAT,%ecx
	movl 4(%esp),%edx
	movl %ecx,(%eax)        /* newFloat->o_class */
	movl %edx,12(%eax)      /* floatVal(newFloat) */
	ret                     /* newFloat in eax */

	.align 4
mksfl2:
	pushl $16
#   ifdef USE_FIXBASE_CALLS
	movl    ADDR___new, %eax
	call     *%eax
#   else
	call NEW
#   endif
	addl $4,%esp
	jmp  mksfl1
#   endif

#  endif /* } */
# endif /* } */
#endif /* } */

# if !defined(SYSV4) && !defined(ELF) /* { */

/*
 * calls to the following XXX_eax , XXX_ebx etc
 * are generated by i386fix.awk, which removes
 * pushes of a register followed by a call to
 * that function.
 * This saves some code in the executable (5-10%)
 * (but usually does not speed it up ...)
 */

/*
 * like __interruptL, but expects arg in %eax
 * (tiny code saver, saving a push/pop)
 */
	.globl ___interruptL_eax
___interruptL_eax:
	pushl   %eax
	call    ___interruptL
	addl $4,%esp
	ret

/*
 * like __gstore, but expects arg in %ebx, %edx or %eax
 * (tiny code saver, saving a push/pop)
 */
	.globl ___gstore_edx
	.globl ___gstore_eax
	.globl ___gstore_ebx
	ALIGN
___gstore_ebx:
	pushl   %ebx
	call    ___gstore
	addl $4,%esp
	ret

	ALIGN
___gstore_edx:
	pushl   %edx
	call    ___gstore
	addl $4,%esp
	ret

	ALIGN
___gstore_eax:
	pushl   %eax
	call    ___gstore
	addl $4,%esp
	ret

	.data
_spc_snd0:
	.long __SEND0
	.long 0         /* class */
	.long 1         /* link */
	.long 1         /* lineNr & type = ANY; lNr=0 */
	.long 0         /* poly */
_spc_snd1:
	.long __SEND1
	.long 0         /* class */
	.long 1         /* link */
	.long 1         /* lineNr & type = ANY; lNr=0*/
	.long 0         /* poly */
_spc_snd2:
	.long __SEND2
	.long 0         /* class */
	.long 1         /* link */
	.long 1         /* lineNr & type = ANY; lNr=0*/
	.long 0         /* poly */
_spc_snd3:
	.long __SEND3
	.long 0         /* class */
	.long 1         /* link */
	.long 1         /* lineNr & type = ANY; lNr=0*/
	.long 0         /* poly */

	.text
	.align 4
	.globl ___SSEND0_Ieax
	.globl ___SSEND1_Ieax
	.globl ___SSEND2_Ieax
	.globl ___SSEND3_Ieax
___SSEND0_Ieax:
	movl    (%eax), %eax
	jmp     ___SSEND0_eax
___SSEND1_Ieax:
	movl    (%eax), %eax
	jmp     ___SSEND1_eax
___SSEND2_Ieax:
	movl    (%eax), %eax
	jmp     ___SSEND2_eax
___SSEND3_Ieax:
	movl    (%eax), %eax
	jmp     ___SSEND3_eax

	.align 4
	.globl ___SSEND0
	.globl ___SSEND0_eax
	.globl ___SSEND0_ebx
	.globl ___SSEND0_edx
/*
 * like __SSEND0, but expects last arg (rec) in %ebx, %edx or %eax
 * on entry, stack is:
 *      lineNr
 *      selector
 *      return
 */
___SSEND0_ebx:
	movl %ebx, %edx
	/* extra move is faster than a jump */
___SSEND0_edx:
	movl %edx, %eax
	/* fall into */
___SSEND0_eax:
	movl 8(%esp),%ecx       /* linenr */
	addl %ecx,%ecx
	movl ADDR___thisContext,%edx /* thisContext->c_lineNr = lNr */
	orb $1,%cl
	movl %ecx,OFFS__BYTEOFFS_CONTEXT_LINENO(%edx)

	pushl $_spc_snd0        /* pilc */
	pushl $0                /* search */
	movl 12(%esp),%ecx      /* =4(esp); selector */
	pushl %ecx              /* selector */
	pushl %eax              /* receiver (from %eax) */
	call __SEND0
	addl $16,%esp
	ret


/*
 * like __SSEND1, but expects last arg (rec) in %ebx, %edx or %eax
 * on entry, stack is:
 *      arg
 *      lineNr
 *      selector
 *      return
 */
	.globl  ___SSEND1_ebx
	.globl  ___SSEND1_edx
	.globl  ___SSEND1_eax
___SSEND1_ebx:
	movl %ebx, %edx
	/* extra move is faster than a jump */
___SSEND1_edx:
	movl %edx, %eax
	/* fall into */
___SSEND1_eax:
	movl 8(%esp),%ecx       /* linenr */
	addl %ecx,%ecx
	movl ADDR___thisContext,%edx
	orb $1,%cl
	movl %ecx,OFFS__BYTEOFFS_CONTEXT_LINENO(%edx)

	movl    12(%esp),%ecx   /* arg */
	pushl   %ecx
	pushl $_spc_snd1        /* pilc */
	pushl $0                /* search */
	movl 16(%esp),%ecx      /* =4(esp); selector */
	pushl %ecx              /* selector */
	pushl %eax              /* receiver (from %eax) */
	call __SEND1
	addl $20,%esp
	ret

/*
 * like __SSEND2, but expects last arg (rec) in %ebx, %edx or %eax
 * on entry, stack is:
 *      arg2
 *      arg1
 *      lineNr
 *      selector
 *      return
 */
	.globl  ___SSEND2_ebx
	.globl  ___SSEND2_edx
	.globl  ___SSEND2_eax
___SSEND2_ebx:
	movl %ebx, %edx
	/* extra move is faster than a jump */
___SSEND2_edx:
	movl %edx, %eax
	/* fall into */
___SSEND2_eax:
	movl 8(%esp),%ecx       /* linenr */
	addl %ecx,%ecx
	movl ADDR___thisContext,%edx
	orb $1,%cl
	movl %ecx,OFFS__BYTEOFFS_CONTEXT_LINENO(%edx)

	movl    16(%esp),%ecx   /* arg2 */
	pushl   %ecx
	movl    16(%esp),%ecx   /* arg1 (was 12(esp) before the push */
	pushl   %ecx
	pushl $_spc_snd2        /* pilc */
	pushl $0                /* search */
	movl 20(%esp),%ecx      /* =4(esp); selector */
	pushl %ecx              /* selector */
	pushl %eax              /* receiver (from %eax) */
	call __SEND2
	addl $24,%esp
	ret

/*
 * like __SSEND3, but expects last arg (rec) in %ebx, %edx or %eax
 * on entry, stack is:
 *      arg3
 *      arg2
 *      arg1
 *      lineNr
 *      selector
 *      return
 */
	.globl  ___SSEND3_ebx
	.globl  ___SSEND3_edx
	.globl  ___SSEND3_eax
___SSEND3_ebx:
	movl %ebx, %edx
	/* extra move is faster than a jump */
___SSEND3_edx:
	movl %edx, %eax
	/* fall into */
___SSEND3_eax:
	movl 8(%esp),%ecx       /* linenr */
	addl %ecx,%ecx
	movl ADDR___thisContext,%edx
	orb $1,%cl
	movl %ecx,OFFS__BYTEOFFS_CONTEXT_LINENO(%edx)

	movl    20(%esp),%ecx   /* arg3 */
	pushl   %ecx
	movl    20(%esp),%ecx   /* arg2 (was 16(esp) before the push */
	pushl   %ecx
	movl    20(%esp),%ecx   /* arg1 (was 12(esp) before the push */
	pushl   %ecx
	pushl $_spc_snd1        /* pilc */
	pushl $0                /* search */
	movl 24(%esp),%ecx      /* =4(esp); selector */
	pushl %ecx              /* selector */
	pushl %eax              /* receiver (from %eax) */
	call __SEND3
	addl $28,%esp
	ret

___SSEND0:
	movl 4(%esp),%eax       /* receiver */

	movl 12(%esp),%ecx      /* lineNr */
	addl %ecx,%ecx
	movl ADDR___thisContext,%edx
	orb $1,%cl
	movl %ecx,OFFS__BYTEOFFS_CONTEXT_LINENO(%edx)

	pushl $_spc_snd0
	pushl $0
	movl 16(%esp),%ecx      /* =8(esp); selector */
	pushl %ecx
	pushl %eax
	call __SEND0
	addl $16,%esp
	ret


/*
 * like ___MKREALCONTEXT4, but expects arg in %eax/%edx/%ebx
 * (tiny code saver, saving a push & pop)
 *
 * calls to this are generated by i386fix from:
 *
 *      pushl %eax / %edx / %ebx
 *      call  __MKREALCONTEXT4
 *      addl  $4, %esp
 *
 * ->   call  __MKREALCONTEXT4_eax / __MKREALCONTEXT4_edx / __MKREALCONTEXT4_ebx
 *
 */
	.align 4
	.globl ___MKREALCONTEXT4
	.globl ___MKREALCONTEXT4_eax
	.globl ___MKREALCONTEXT4_edx
	.globl ___MKREALCONTEXT4_ebx

___MKREALCONTEXT4:
	movl 4(%esp),%edx               /* retVal */
	jmp  1f

___MKREALCONTEXT4_ebx:
	movl %ebx, %eax
	/* another move is faster than a jump ... */
___MKREALCONTEXT4_eax:
	movl %eax, %edx
	/* fall into */
___MKREALCONTEXT4_edx:
1:
	movl ADDR___thisContext,%ecx    /* thisContext = thisContext->c_sender */
	movl OFFS__BYTEOFFS_CONTEXT_SENDER/* was: 16 */ (%ecx),%eax
	movl %eax,ADDR___thisContext

	movl %edx,OFFS__BYTEOFFS_CONTEXT_RETVAL(%ecx)              /* thisContext->c_retval */

	pushl %ecx
	call ___MKREALCONTEXT           /* newCon = MKREALCONTEXT(previous-thisContext) */
#ifdef OLD
	movl %eax,%ecx
	movl OFFS__BYTEOFFS_CONTEXT_RETVAL(%ecx),%eax              /* newCon->c_retVal */
	addl $4,%esp
#else
	popl %ecx                       /* con (prev, on stack) */
	movl OFFS__BYTEOFFS_CONTEXT_RETVAL(%ecx),%eax              /* con->c_retVal */
#endif
	ret

/*
 * like ___MKREALCONTEXT5, but expects arg in %eax / %edx
 * (tiny code saver, saving a push & pop)
 */
	.globl ___MKREALCONTEXT5_eax
	.globl ___MKREALCONTEXT5_ebx
	.globl ___MKREALCONTEXT5_edx
___MKREALCONTEXT5_ebx:
	movl    %ebx, %edx
	/* another move is faster than a jump ... */
___MKREALCONTEXT5_edx:
	movl    %edx, %eax
	/* fall into */
___MKREALCONTEXT5_eax:
	movl    ADDR___thisContext,%ecx /* thisContext */
	testb   $2,12(%ecx)             /* special ? */
	jne     ___MKREALCONTEXT4_eax
					/* no */
	movl    OFFS__BYTEOFFS_CONTEXT_SENDER(%ecx),%edx           /* thisContext = thisContext->c_sender */
	movl    %edx,ADDR___thisContext
	ret

# else /* sysv4 or elf } { */

 /*
  * ... to be done: above code for ELF based systems ...
  */

# endif /* not sysv and not ELF } */

/*
 * modified setjmp: slightly faster than original
 * ---> not used on non-ELF systems, since setjmp is inlined anyway
 */
# if defined(SYSV4) || defined(ELF)
#  define QSETJMP qsetjmp
#  define QLONGJMP qlongjmp
# else
#  define QSETJMP _qsetjmp
#  define QLONGJMP _qlongjmp
# endif

	.globl  QSETJMP
	ALIGN
QSETJMP:
	popl    %edx            /* ret */
	movl    (%esp), %eax    /* jmpbuf */
	movl    %ebx , (%eax)   /* save bx */
	movl    %esi , 4(%eax)  /* save si */
	movl    %edi , 8(%eax)  /* save di */
	movl    %ebp , 12(%eax) /* save bp */
	movl    %esp , 16(%eax) /* save sp */
	movl    %edx , 20(%eax) /* save pc */
	xorl    %eax,%eax
	jmp     *%edx

/*
 * modified longjmp: allow passing a value of 0
 * also slightly faster than original
 */
	.globl  QLONGJMP
	ALIGN
QLONGJMP:
	movl   4(%esp),%ecx   /* jmpbuf */
	movl   8(%esp),%eax   /* retval */
	movl   (%ecx),%ebx
	movl   4(%ecx),%esi
	movl   8(%ecx),%edi
	movl   12(%ecx),%ebp
	movl   16(%ecx),%esp
	jmp    *20(%ecx)

/*
 * stack-check entry for blocks
 */
#ifdef ELF
	.globl  __CHECKs__
__CHECKs__:
#else
	.globl  ___CHECKs__
___CHECKs__:
#endif
#   ifndef STACKBOTTOM
	movl    _P__stackBottom__, %eax
	movl    0(%eax), %eax
	cmpl    %esp, %eax
#   else
	cmpl    %esp, STACKBOTTOM
#   endif
	jae     __check1

	/*
	 * return inline into block
	 */
	ret

__check1:
#   ifdef USE_FIXBASE_CALLS
	movl    ADDR___ySTACK_HANDLER__, %eax
	jmp     *%eax
#   else
	jmp     __ySTACK_HANDLER__
#   endif


# if !defined(__FIXBASE__)
#  if !defined(__DIRECTVMDATA__)
#   define NO_ASM
#  endif
# endif

# if !defined(NO_ASM) /* { */

#  if defined(SYSV4) || defined(ELF) /* { */
#   define STOREINST0   __storeInst0
#   define STOREINST1   __storeInst1
#   define STOREINST2   __storeInst2
#   define STOREINST3   __storeInst3
#   define STOREINST4   __storeInst4
#   define STOREINST5   __storeInst5
#   define RETSELF      __retSelf
#   define RETSELF1     __retSelf1
#   define RETTRUE      __retTrue
#   define RETFALSE     __retFalse
#   define RETNIL       __retNil
#   define RETINST0     __retInst0
#   define RETINST1     __retInst1
#   define RETINST2     __retInst2
#   define RETINST3     __retInst3
#   define RETINST4     __retInst4
#   define RETINST5     __retInst5
#   define RETINST6     __retInst6
#   define RETINST7     __retInst7
#   define RETINST8     __retInst8
#   define RETINST9     __retInst9
#   define RETINST10    __retInst10
#   define RETINST11    __retInst11
#   define RETINST12    __retInst12
#   define RETINST13    __retInst13
#   define RETINST14    __retInst14
#   define RETINST15    __retInst15
#   define RETINST16    __retInst16
#   define RETINST17    __retInst17
#   define RETINST18    __retInst18
#   define RETINST19    __retInst19
#   define RETINST20    __retInst20
#   define RETINST21    __retInst21
#   define RETINST22    __retInst22
#   define RETINST23    __retInst23
#   define RETINST24    __retInst24
#   define RETINST25    __retInst25
#   define RETINST26    __retInst26
#   define RETINST27    __retInst27
#   define RETINST28    __retInst28
#   define RETINST29    __retInst29
#   define RETINST30    __retInst30

#  else /* not ELF } { */

#   define STOREINST0   ___storeInst0
#   define STOREINST1   ___storeInst1
#   define STOREINST2   ___storeInst2
#   define STOREINST3   ___storeInst3
#   define STOREINST4   ___storeInst4
#   define STOREINST5   ___storeInst5
#   define RETSELF      ___retSelf
#   define RETSELF1     ___retSelf1
#   define RETTRUE      ___retTrue
#   define RETFALSE     ___retFalse
#   define RETNIL       ___retNil
#   define RETINST0     ___retInst0
#   define RETINST1     ___retInst1
#   define RETINST2     ___retInst2
#   define RETINST3     ___retInst3
#   define RETINST4     ___retInst4
#   define RETINST5     ___retInst5
#   define RETINST6     ___retInst6
#   define RETINST7     ___retInst7
#   define RETINST8     ___retInst8
#   define RETINST9     ___retInst9
#   define RETINST10    ___retInst10
#   define RETINST11    ___retInst11
#   define RETINST12    ___retInst12
#   define RETINST13    ___retInst13
#   define RETINST14    ___retInst14
#   define RETINST15    ___retInst15
#   define RETINST16    ___retInst16
#   define RETINST17    ___retInst17
#   define RETINST18    ___retInst18
#   define RETINST19    ___retInst19
#   define RETINST20    ___retInst20
#   define RETINST21    ___retInst21
#   define RETINST22    ___retInst22
#   define RETINST23    ___retInst23
#   define RETINST24    ___retInst24
#   define RETINST25    ___retInst25
#   define RETINST26    ___retInst26
#   define RETINST27    ___retInst27
#   define RETINST28    ___retInst28
#   define RETINST29    ___retInst29
#   define RETINST30    ___retInst30

#  endif /* ELF } */

#  ifdef falseStruct
#   define LOAD_FALSE(reg)      leal    falseStruct, reg
#   define LOAD_TRUE(reg)       leal    trueStruct, reg
#  else
#   define LOAD_FALSE(reg)      movl    FALSE, reg
#   define LOAD_TRUE(reg)       movl    TRUE, reg
#  endif

#  ifdef USE_FIXBASE_CALLS

    /* dont combine them using a backslash - many assemblers do not like that */

#   define JUMP_SEND0_1 movl ADDR__SEND0, %eax
#   define JUMP_SEND0_2 jmp *%eax

#   define JUMP_SEND1_1 movl ADDR__SEND1, %eax
#   define JUMP_SEND1_2 jmp *%eax

#  else

#   define JUMP_SEND0_1 jmp SEND0
#   define JUMP_SEND0_2

#   define JUMP_SEND1_1 jmp SEND1
#   define JUMP_SEND1_2

#  endif

/* --------------------------------------------------------------- */
	/*
	 * code shared by all "^ self" methods (0-args)
	 */

	/* non-nil entry */
	ALIGN
#  if defined(__STATIC_LIBRUN__) || defined(__CODE_RMAGIC__)
	/* non-nil receiver entry */
L8d:
	movl    O_RECEIVER(%esp),%eax
	movl    0(%eax), %ecx           /* _Class(rec) */
	movl    O_PILC(%esp), %edx      /* pIlc */
	cmpl    4(%edx), %ecx           /* _Class(rec) == pIlc->ilc_class */
	jne     L1d                     /* continue checking srchclass */
	ret

	ALIGN
L4d:    movl    O_RECEIVER(%esp),%eax
	ret

	ALIGN
#   if defined(__CODE_RMAGIC__)
	.long   L4d - RETSELF   /* checked */
	.long   L8d - RETSELF   /* realObject */
	.long   __CODE_RMAGIC__
#   else
	.long   L4d             /* checked */
	.long   L8d             /* realObject */
	.long   __CODE_MAGIC__
#   endif
#  else
	.long   0
#  endif

	.globl RETSELF
RETSELF:
	/* general entry */
	movl    O_RECEIVER(%esp),%ecx   /* _isNonNilObject(rec) ? */
#  ifdef PILC_EARLY
	movl    O_PILC(%esp), %edx
#  endif
	movl    %ecx, %eax
#  ifdef POSITIVE_ADDRESSES     /* tag in sign-bit */
	shl     %ecx                    /* tag in CF */
#  else                         /* tag in low bit */
	shr     %ecx                    /* tag in CF */
#  endif
#  ifdef PILC_EARLY
#   ifdef PILC_EARLY2
	movl    4(%edx), %edx           /* pIlc->ilc_class - does not clobber flags */
#   endif
#  else
	movl    O_PILC(%esp), %edx      /* pIlc - does not clobber flags */
#  endif
	jna     L2d                     /* if CF (i.e. integer) or ZF (i.e. nil) */

	movl    0(%eax), %ecx           /* _Class(rec) */
#  ifdef PILC_EARLY2
	cmpl    %edx, %ecx              /* == pIlc->ilc_class ? */
#  else
	cmpl    4(%edx), %ecx           /* == pIlc->ilc_class ? */
#  endif
	jne     L1d
	ret

	ALIGN
L1d:
	movl    O_SRCHCLASS(%esp), %ecx /* (sClass != nil) ? */
#  ifndef USE_JCXZ
	testl   %ecx, %ecx
	je      callSend0
#  else
	jcxz    callSend0d
#  endif
	ret

	ALIGN
L2d:
#  ifndef PILC_EARLY2
	movl    4(%edx), %edx           /* pIlc->ilc_class - does not clobber flags */
#  endif
	jnc     L3d                     /* if nil */
	cmpl    %edx, SMALLINTEGER      /* pIlc->ilc_class == SmallInteger ? */
	jne     L1d
	ret

	ALIGN
L3d:
	cmpl    %edx, UNDEFINEDOBJECT   /* pIlc->ilc_class == UndefinedObject ? */
	jne     L1d
	ret

#  ifdef USE_JCXZ
	ALIGN
callSend0d:
	JUMP_SEND0_1
	JUMP_SEND0_2
#  endif


/* --------------------------------------------------------------- */

	/*
	 * code shared by all "^ true" methods
	 */
	/* non-nil entry */
	ALIGN
#  if defined(__STATIC_LIBRUN__) || defined(__CODE_RMAGIC__)
L8a:
	movl    O_RECEIVER(%esp),%eax
	movl    0(%eax), %ecx           /* _Class(rec) */
	movl    O_PILC(%esp), %edx      /* pIlc */
	cmpl    4(%edx), %ecx           /* _Class(rec) == pIlc->ilc_class */
	jne     L1a                     /* continue checking srchclass */
L4a:
	LOAD_TRUE( %eax )
	ret

	ALIGN
#   if defined(__CODE_RMAGIC__)
	.long   L4a - RETTRUE   /* checked */
	.long   L8a - RETTRUE   /* realObject */
	.long   __CODE_RMAGIC__
#   else
	.long   L4a             /* checked */
	.long   L8a             /* realObject */
	.long   __CODE_MAGIC__
#   endif
#  else
	.long 0
#  endif

	.globl RETTRUE
RETTRUE:
	/* general entry */
	movl    O_RECEIVER(%esp),%ecx   /* _isNonNilObject(rec) ? */
#  ifdef PILC_EARLY
	movl    O_PILC(%esp), %edx
#  endif
	movl    %ecx, %eax
#  ifdef POSITIVE_ADDRESSES     /* tag in sign-bit */
	shl     %ecx                    /* tag in CF */
#  else                         /* tag in low bit */
	shr     %ecx                    /* tag in CF */
#  endif
#  ifndef PILC_EARLY
	movl    O_PILC(%esp), %edx      /* pIlc - does not clobber flags */
#  endif
	jna     L2a                     /* if CF (i.e. integer) or ZF (i.e. nil) */

	movl    0(%eax), %ecx           /* _Class(rec) */
	cmpl    4(%edx), %ecx           /* _Class(rec) == pIlc->ilc_class */
	jne     L1a
	LOAD_TRUE( %eax )
	ret

	ALIGN
L1a:
	movl    O_SRCHCLASS(%esp), %ecx /* (sClass != nil) ? */
#  ifndef USE_JCXZ
	testl   %ecx, %ecx
	je      callSend0
#  else
	jcxz    callSend0a
#  endif
	LOAD_TRUE( %eax )
	ret

	ALIGN
L2a:
	movl    4(%edx), %edx           /* pIlc->ilc_class - does not clobber flags */
	jnc     L3a
	cmpl    %edx, SMALLINTEGER      /* pIlc->ilc_class == SmallInteger ? */
	jne     L1a
	LOAD_TRUE( %eax )
	ret

	ALIGN
L3a:
	cmpl    %edx, UNDEFINEDOBJECT   /* pIlc->ilc_class == UndefinedObject ? */
	jne     L1a
	LOAD_TRUE( %eax )
	ret


	ALIGN
#  ifdef USE_JCXZ
callSend0a:
#  endif
callSend0:
	JUMP_SEND0_1
	JUMP_SEND0_2

/* --------------------------------------------------------------- */


	/*
	 * code shared by all "^ false" methods
	 */
	/* non-nil entry */
	ALIGN
#  if defined(__STATIC_LIBRUN__) || defined(__CODE_RMAGIC__)
L8b:
	movl    O_RECEIVER(%esp),%eax
	movl    0(%eax), %ecx           /* _Class(rec) */
	movl    O_PILC(%esp), %edx      /* pIlc */
	cmpl    4(%edx), %ecx           /* _Class(rec) == pIlc->ilc_class */
	jne     L1b                     /* continue checking srchclass */
L4b:
	LOAD_FALSE( %eax )
	ret

	ALIGN
#   if defined(__CODE_RMAGIC__)
	.long   L4b - RETFALSE  /* checked */
	.long   L8b - RETFALSE  /* realObject */
	.long   __CODE_RMAGIC__
#   else
	.long   L4b             /* checked */
	.long   L8b             /* realObject */
	.long   __CODE_MAGIC__
#   endif
#  else
	.long   0
#  endif

	.globl RETFALSE
RETFALSE:
	/* general entry */
	movl    O_RECEIVER(%esp),%ecx   /* _isNonNilObject(rec) ? */
#  ifdef PILC_EARLY
	movl    O_PILC(%esp), %edx
#  endif
	movl    %ecx, %eax
#  ifdef POSITIVE_ADDRESSES     /* tag in sign-bit */
	shl     %ecx                    /* tag in CF */
#  else                         /* tag in low bit */
	shr     %ecx                    /* tag in CF */
#  endif
#  ifndef PILC_EARLY
	movl    O_PILC(%esp), %edx      /* pIlc - flags are not affected */
#  endif
	jna     L2b                     /* if CF (i.e. integer) or ZF (i.e. nil) */

	movl    0(%eax), %ecx           /* _Class(rec) */
	cmpl    4(%edx), %ecx           /* _Class(rec) == pIlc->ilc_class */
	jne     L1b
	LOAD_FALSE( %eax )
	ret

	ALIGN
L1b:
	movl    O_SRCHCLASS(%esp), %ecx /* (sClass != nil) ? */
#  ifndef USE_JCXZ
	testl   %ecx, %ecx
	je      callSend0
#  else
	jcxz    callSend0b
#  endif
	LOAD_FALSE( %eax )
	ret

	ALIGN
L2b:
	movl    4(%edx), %edx           /* pilc->class - flags are not affected */
	jnc     L3b                     /* this checks receiver for being nil ! */

	cmpl    %edx, SMALLINTEGER      /* pIlc->ilc_class == SmallInteger ? */
	jne     L1b
	LOAD_FALSE( %eax )
	ret

	ALIGN
L3b:
	cmpl    %edx, UNDEFINEDOBJECT   /* pIlc->ilc_class == UndefinedObject ? */
	jne     L1b
	LOAD_FALSE( %eax )
	ret

#  ifdef USE_JCXZ
	ALIGN
callSend0b:
	JUMP_SEND0_1
	JUMP_SEND0_2
#  endif

/* --------------------------------------------------------------- */

	/*
	 * code shared by all "^ nil" methods
	 */
	ALIGN

#  if defined(__STATIC_LIBRUN__) || defined(__CODE_RMAGIC__)
L8c:
	/* non-nil entry */
	movl    O_RECEIVER(%esp),%eax
	movl    0(%eax), %ecx           /* _Class(rec) */
	movl    O_PILC(%esp), %edx      /* pIlc */
	cmpl    4(%edx), %ecx           /* _Class(rec) == pIlc->ilc_class */
	jne     L1c                     /* continue checking srchclass */
L4c:
	xorl    %eax,%eax
	ret

	ALIGN
#   if defined(__CODE_RMAGIC__)
	.long   L4c - RETNIL    /* checked */
	.long   L8c - RETNIL    /* realObject */
	.long   __CODE_RMAGIC__
#   else
	.long   L4c             /* checked */
	.long   L8c             /* realObject */
	.long   __CODE_MAGIC__
#   endif
#  else
	.long   0
#  endif

	.globl RETNIL
RETNIL:
	/* general entry */
	movl    O_RECEIVER(%esp),%ecx   /* _isNonNilObject(rec) ? */
#  ifdef PILC_EARLY
	movl    O_PILC(%esp), %edx
#  endif
	movl    %ecx, %eax
#  ifdef POSITIVE_ADDRESSES             /* tag in sign-bit */
	shl     %ecx                        /* tag now in CF */
#  else                                 /* tag in low bit */
	shr     %ecx                        /* tag in CF */
#  endif
#  ifndef PILC_EARLY
	movl    O_PILC(%esp), %edx      /* pIlc - does not clobber flags */
#  endif
	jna     L2c                     /* if CF (i.e. integer) or ZF (i.e. nil) */

	movl    0(%eax), %ecx           /* _Class(rec) */
	cmpl    4(%edx), %ecx           /* _Class(rec) == pIlc->ilc_class */
	jne     L1c
	xorl    %eax,%eax
	ret

	ALIGN
L1c:
	movl    O_SRCHCLASS(%esp), %ecx /* (sClass != nil) ? */
#  ifndef USE_JCXZ
	testl   %ecx, %ecx
	je      callSend0
#  else
	jcxz    callSend0c
#  endif
	xorl    %eax,%eax
	ret

	ALIGN
L2c:
	movl    4(%edx), %edx           /* pIlc->ilc_class - does not clobber flags */
	jnc     L3c
	cmpl    %edx, SMALLINTEGER      /* pIlc->ilc_class == SmallInteger ? */
	jne     L1c
	xorl    %eax,%eax
	ret

	ALIGN
L3c:
	cmpl    %edx, UNDEFINEDOBJECT   /* pIlc->ilc_class == UndefinedObject ? */
	jne     L1c
	xorl    %eax,%eax
	ret

#  ifdef USE_JCXZ
	ALIGN
callSend0c:
	JUMP_SEND0_1
	JUMP_SEND0_2
#  endif

/* --------------------------------------------------------------- */

	/*
	 * code shared by all "^ self" methods (1-args)
	 */

	/* non-nil entry */
	ALIGN
#  if defined(__STATIC_LIBRUN__) || defined(__CODE_RMAGIC__)
	/* non-nil receiver entry */
L8e:
	movl    O_RECEIVER(%esp),%eax
	movl    0(%eax), %ecx           /* _Class(rec) */
	movl    O_PILC(%esp), %edx      /* pIlc */
	cmpl    4(%edx), %ecx           /* _Class(rec) == pIlc->ilc_class */
	jne     L1e                     /* continue checking srchclass */
	ret

	ALIGN
L4e:    movl    O_RECEIVER(%esp),%eax
	ret

	ALIGN
#   if defined(__CODE_RMAGIC__)
	.long   L4e - RETSELF1  /* checked */
	.long   L8e - RETSELF1  /* realObject */
	.long   __CODE_RMAGIC__
#   else
	.long   L4e             /* checked */
	.long   L8e             /* realObject */
	.long   __CODE_MAGIC__
#   endif
#  else
	.long   0
#  endif

	.globl RETSELF1
RETSELF1:
	/* general entry */
	movl    O_RECEIVER(%esp),%ecx   /* _isNonNilObject(rec) ? */
#  ifdef PILC_EARLY
	movl    O_PILC(%esp), %edx
#  endif
	movl    %ecx, %eax
#  ifdef POSITIVE_ADDRESSES     /* tag in sign-bit */
	shl     %ecx                    /* tag in CF */
#  else                         /* tag in low bit */
	shr     %ecx                    /* tag in CF */
#  endif
#  ifndef PILC_EARLY
	movl    O_PILC(%esp), %edx      /* pIlc - does not clobber flags */
#  endif
	jna     L2e                     /* if CF (i.e. integer) or ZF (i.e. nil) */

	movl    0(%eax), %ecx           /* _Class(rec) */
	cmpl    4(%edx), %ecx           /* == pIlc->ilc_class ? */
	jne     L1e
	ret

	ALIGN
L1e:
	movl    O_SRCHCLASS(%esp), %ecx /* (sClass != nil) ? */
#  ifndef USE_JCXZ
	testl   %ecx, %ecx
	je      callSend1
#  else
	jcxz    callSend1
#  endif
	ret

	ALIGN
L2e:
	movl    4(%edx), %edx           /* pIlc->ilc_class - does not clobber flags */
	jnc     L3e                     /* if nil */
	cmpl    %edx, SMALLINTEGER      /* pIlc->ilc_class == SmallInteger ? */
	jne     L1e
	ret

	ALIGN
L3e:
	cmpl    %edx, UNDEFINEDOBJECT   /* pIlc->ilc_class == UndefinedObject ? */
	jne     L1e
	ret

	ALIGN
callSend1:
	JUMP_SEND1_1
	JUMP_SEND1_2

/* --------------------------------------------------------------- */

#ifndef NO_ASM_STOREINST

	ALIGN
	.globl STOREINST0
STOREINST0:
	movl 4(%esp), %eax      /* target-object */
	movl 8(%esp), %ecx      /* value */
	movl %ecx,%edx
	movl %ecx,12(%eax)      /* store */
#ifdef POSITIVE_ADDRESSES
	shl  %edx                    /* tag in CF */
#else
	shr  %edx                    /* tag in CF */
#endif
	ja   store0a
	movl %ecx,%eax          /* not (zero (nil) or carry (integer)) */
	ret
store0a:
	movb 8(%ecx),%dl        /* qSpace(val) */
	cmpb %dl,8(%eax)        /* qSpace(target) */
	jb   store0b
	movl %ecx,%eax
	ret

store0b:
	jmp  __store@PLT



	ALIGN
	.globl STOREINST1
STOREINST1:
	movl 4(%esp), %eax      /* target-object */
	movl 8(%esp), %ecx      /* value */
	movl %ecx,%edx
	movl %ecx,16(%eax)      /* store */
#ifdef POSITIVE_ADDRESSES
	shl  %edx                    /* tag in CF */
#else
	shr  %edx                    /* tag in CF */
#endif
	ja   store0a
	movl %ecx,%eax          /* zero (nil) or carry (integer) */
	ret

	ALIGN
	.globl STOREINST2
STOREINST2:
	movl 4(%esp), %eax      /* target-object */
	movl 8(%esp), %ecx      /* value */
	movl %ecx,%edx
	movl %ecx,20(%eax)      /* store */
#ifdef POSITIVE_ADDRESSES
	shl  %edx                    /* tag in CF */
#else
	shr  %edx                    /* tag in CF */
#endif
	ja   store0a
	movl %ecx,%eax          /* zero (nil) or carry (integer) */
	ret

	ALIGN
	.globl STOREINST3
STOREINST3:
	movl 4(%esp), %eax      /* target-object */
	movl 8(%esp), %ecx      /* value */
	movl %ecx,%edx
	movl %ecx,24(%eax)      /* store */
#ifdef POSITIVE_ADDRESSES
	shl  %edx                    /* tag in CF */
#else
	shr  %edx                    /* tag in CF */
#endif
	ja   store0a
	movl %ecx,%eax          /* zero (nil) or carry (integer) */
	ret

	ALIGN
	.globl STOREINST4
STOREINST4:
	movl 4(%esp), %eax      /* target-object */
	movl 8(%esp), %ecx      /* value */
	movl %ecx,%edx
	movl %ecx,28(%eax)      /* store */
#ifdef POSITIVE_ADDRESSES
	shl  %edx                    /* tag in CF */
#else
	shr  %edx                    /* tag in CF */
#endif
	ja   store0a
	movl %ecx,%eax          /* zero (nil) or carry (integer) */
	ret

	ALIGN
	.globl STOREINST5
STOREINST5:
	movl 4(%esp), %eax      /* target-object */
	movl 8(%esp), %ecx      /* value */
	movl %ecx,%edx
	movl %ecx,32(%eax)      /* store */
#ifdef POSITIVE_ADDRESSES
	shl  %edx                    /* tag in CF */
#else
	shr  %edx                    /* tag in CF */
#endif
	ja   store0a
	movl %ecx,%eax          /* zero (nil) or carry (integer) */
	ret

#endif /* NO_ASM_STOREINST */

/* ------------------ retinst shared code ------------------ */

#       define  NAME    RETINST0
#       define  LABEL   RETINST0:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI0_##lab
#  endif
#       define  OFFSET  12
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST1
#       define  LABEL   RETINST1:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI1_##lab
#  endif
#       define  OFFSET  16
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST2
#       define  LABEL   RETINST2:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI2_##lab
#  endif
#       define  OFFSET  20
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST3
#       define  LABEL   RETINST3:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI3_##lab
#  endif
#       define  OFFSET  24
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST4
#       define  LABEL   RETINST4:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI4_##lab
#  endif
#       define  OFFSET  28
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST5
#       define  LABEL   RETINST5:
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) RI5_##lab
#  endif
#       define  OFFSET  32
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST6
#       define  LABEL   RETINST6:
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) RI6_##lab
#  endif
#       define  OFFSET  36
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST7
#       define  LABEL   RETINST7:
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) RI7_##lab
#  endif
#       define  OFFSET  40
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST8
#       define  LABEL   RETINST8:
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) RI8_##lab
#  endif
#       define  OFFSET  44
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST9
#       define  LABEL   RETINST9:
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) RI9_##lab
#  endif
#       define  OFFSET  48
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST10
#       define  LABEL   RETINST10:
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) RI10_##lab
#  endif
#       define  OFFSET  52
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST11
#       define  LABEL   RETINST11:
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) RI11_##lab
#  endif
#       define  OFFSET  56
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST12
#       define  LABEL   RETINST12:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI12_##lab
#  endif
#       define  OFFSET  60
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST13
#       define  LABEL   RETINST13:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI13_##lab
#  endif
#       define  OFFSET  64
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST14
#       define  LABEL   RETINST14:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI14_##lab
#  endif
#       define  OFFSET  68
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST15
#       define  LABEL   RETINST15:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI15_##lab
#  endif
#       define  OFFSET  72
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST16
#       define  LABEL   RETINST16:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI16_##lab
#  endif
#       define  OFFSET  76
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST17
#       define  LABEL   RETINST17:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI17_##lab
#  endif
#       define  OFFSET  80
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST18
#       define  LABEL   RETINST18:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI18_##lab
#  endif
#       define  OFFSET  84
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST19
#       define  LABEL   RETINST19:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI19_##lab
#  endif
#       define  OFFSET  88
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST20
#       define  LABEL   RETINST20:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI20_##lab
#  endif
#       define  OFFSET  92
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST21
#       define  LABEL   RETINST21:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI21_##lab
#  endif
#       define  OFFSET  96
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST22
#       define  LABEL   RETINST22:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI22_##lab
#  endif
#       define  OFFSET  100
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST23
#       define  LABEL   RETINST23:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI23_##lab
#  endif
#       define  OFFSET  104
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST24
#       define  LABEL   RETINST24:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI24_##lab
#  endif
#       define  OFFSET  108
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST25
#       define  LABEL   RETINST25:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI25_##lab
#  endif
#       define  OFFSET  112
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST26
#       define  LABEL   RETINST26:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI26_##lab
#  endif
#       define  OFFSET  116
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST27
#       define  LABEL   RETINST27:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI27_##lab
#  endif
#       define  OFFSET  120
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST28
#       define  LABEL   RETINST28:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI28_##lab
#  endif
#       define  OFFSET  124
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST29
#       define  LABEL   RETINST29:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI29_##lab
#  endif
#       define  OFFSET  128
#       define  RETINST
#       include "codeEntry.h"

#       define  NAME    RETINST30
#       define  LABEL   RETINST30:
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) RI30_##lab
#  endif
#       define  OFFSET  132
#       define  RETINST
#       include "codeEntry.h"

# endif /* NOASM } */

/*
 * code saver: ilc-miss check prolog
 *
 * to be called via
 *   jsr __ILCCHECK__
 * before method is entered
 * this code is for NonNil-nonSmallInt classes only
 *
 * entry: args on stack
 *      a1
 *      pIlc
 *      search
 *      sel
 *      rec
 *      return-addr
 *      CHECK-returnADDR
 *
 * normally, this code is inlined into the method, but
 * when compiled with +optspace, a call to this function
 * is generated instead.
 */

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) ILC0_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK0__
#       define  ILC_LABEL       __ILC_CHECK0__:
#       define  ILC_NAME2       __ILC_CHECK0s__
#       define  ILC_LABEL2      __ILC_CHECK0s__:
#       define  POLY_LABEL      __POLY_CHECK0__
#       define  POLY_LABEL2     __POLY_CHECK0s__
# else
#       define  ILC_NAME        ___ILC_CHECK0__
#       define  ILC_LABEL       ___ILC_CHECK0__:
#       define  ILC_NAME2       ___ILC_CHECK0s__
#       define  ILC_LABEL2      ___ILC_CHECK0s__:
#       define  POLY_LABEL      ___POLY_CHECK0__
#       define  POLY_LABEL2     ___POLY_CHECK0s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND0
#       define  SEND_MISS       SEND0
#       define  ILCCHECK
#       include "codeEntry.h"


# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#       define ASMLABEL(lab,dir) ILC1_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK1__
#       define  ILC_LABEL       __ILC_CHECK1__:
#       define  ILC_NAME2       __ILC_CHECK1s__
#       define  ILC_LABEL2      __ILC_CHECK1s__:
#       define  POLY_LABEL      __POLY_CHECK1__
#       define  POLY_LABEL2     __POLY_CHECK1s__
# else
#       define  ILC_NAME        ___ILC_CHECK1__
#       define  ILC_LABEL       ___ILC_CHECK1__:
#       define  ILC_NAME2       ___ILC_CHECK1s__
#       define  ILC_LABEL2      ___ILC_CHECK1s__:
#       define  POLY_LABEL      ___POLY_CHECK1__
#       define  POLY_LABEL2     ___POLY_CHECK1s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND1
#       define  SEND_MISS       SEND1
#       define  ILCCHECK
#       include "codeEntry.h"


# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC2_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK2__
#       define  ILC_LABEL       __ILC_CHECK2__:
#       define  ILC_NAME2       __ILC_CHECK2s__
#       define  ILC_LABEL2      __ILC_CHECK2s__:
#       define  POLY_LABEL      __POLY_CHECK2__
#       define  POLY_LABEL2     __POLY_CHECK2s__
# else
#       define  ILC_NAME        ___ILC_CHECK2__
#       define  ILC_LABEL       ___ILC_CHECK2__:
#       define  ILC_NAME2       ___ILC_CHECK2s__
#       define  ILC_LABEL2      ___ILC_CHECK2s__:
#       define  POLY_LABEL      ___POLY_CHECK2__
#       define  POLY_LABEL2     ___POLY_CHECK2s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND2
#       define  SEND_MISS       SEND2
#       define  ILCCHECK
#       include "codeEntry.h"


# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC3_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK3__
#       define  ILC_LABEL       __ILC_CHECK3__:
#       define  ILC_NAME2       __ILC_CHECK3s__
#       define  ILC_LABEL2      __ILC_CHECK3s__:
#       define  POLY_LABEL      __POLY_CHECK3__
#       define  POLY_LABEL2     __POLY_CHECK3s__
# else
#       define  ILC_NAME        ___ILC_CHECK3__
#       define  ILC_LABEL       ___ILC_CHECK3__:
#       define  ILC_NAME2       ___ILC_CHECK3s__
#       define  ILC_LABEL2      ___ILC_CHECK3s__:
#       define  POLY_LABEL      ___POLY_CHECK3__
#       define  POLY_LABEL2     ___POLY_CHECK3s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND3
#       define  SEND_MISS       SEND3
#       define  ILCCHECK
#       include "codeEntry.h"


# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC4_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK4__
#       define  ILC_LABEL       __ILC_CHECK4__:
#       define  ILC_NAME2       __ILC_CHECK4s__
#       define  ILC_LABEL2      __ILC_CHECK4s__:
#       define  POLY_LABEL      __POLY_CHECK4__
#       define  POLY_LABEL2     __POLY_CHECK4s__
# else
#       define  ILC_NAME        ___ILC_CHECK4__
#       define  ILC_LABEL       ___ILC_CHECK4__:
#       define  ILC_NAME2       ___ILC_CHECK4s__
#       define  ILC_LABEL2      ___ILC_CHECK4s__:
#       define  POLY_LABEL      ___POLY_CHECK4__
#       define  POLY_LABEL2     ___POLY_CHECK4s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND4
#       define  SEND_MISS       SEND4
#       define  ILCCHECK
#       include "codeEntry.h"


# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC5_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK5__
#       define  ILC_LABEL       __ILC_CHECK5__:
#       define  ILC_NAME2       __ILC_CHECK5s__
#       define  ILC_LABEL2      __ILC_CHECK5s__:
#       define  POLY_LABEL      __POLY_CHECK5__
#       define  POLY_LABEL2     __POLY_CHECK5s__
# else
#       define  ILC_NAME        ___ILC_CHECK5__
#       define  ILC_LABEL       ___ILC_CHECK5__:
#       define  ILC_NAME2       ___ILC_CHECK5s__
#       define  ILC_LABEL2      ___ILC_CHECK5s__:
#       define  POLY_LABEL      ___POLY_CHECK5__
#       define  POLY_LABEL2     ___POLY_CHECK5s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND5
#       define  SEND_MISS       SEND5
#       define  ILCCHECK
#       include "codeEntry.h"


# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC6_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK6__
#       define  ILC_LABEL       __ILC_CHECK6__:
#       define  ILC_NAME2       __ILC_CHECK6s__
#       define  ILC_LABEL2      __ILC_CHECK6s__:
#       define  POLY_LABEL      __POLY_CHECK6__
#       define  POLY_LABEL2     __POLY_CHECK6s__
# else
#       define  ILC_NAME        ___ILC_CHECK6__
#       define  ILC_LABEL       ___ILC_CHECK6__:
#       define  ILC_NAME2       ___ILC_CHECK6s__
#       define  ILC_LABEL2      ___ILC_CHECK6s__:
#       define  POLY_LABEL      ___POLY_CHECK6__
#       define  POLY_LABEL2     ___POLY_CHECK6s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND6
#       define  SEND_MISS       SEND6
#       define  ILCCHECK
#       include "codeEntry.h"


# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC7_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK7__
#       define  ILC_LABEL       __ILC_CHECK7__:
#       define  ILC_NAME2       __ILC_CHECK7s__
#       define  ILC_LABEL2      __ILC_CHECK7s__:
#       define  POLY_LABEL      __POLY_CHECK7__
#       define  POLY_LABEL2     __POLY_CHECK7s__
# else
#       define  ILC_NAME        ___ILC_CHECK7__
#       define  ILC_LABEL       ___ILC_CHECK7__:
#       define  ILC_NAME2       ___ILC_CHECK7s__
#       define  ILC_LABEL2      ___ILC_CHECK7s__:
#       define  POLY_LABEL      ___POLY_CHECK7__
#       define  POLY_LABEL2     ___POLY_CHECK7s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND7
#       define  SEND_MISS       SEND7
#       define  ILCCHECK
#       include "codeEntry.h"

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC8_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK8__
#       define  ILC_LABEL       __ILC_CHECK8__:
#       define  ILC_NAME2       __ILC_CHECK8s__
#       define  ILC_LABEL2      __ILC_CHECK8s__:
#       define  POLY_LABEL      __POLY_CHECK8__
#       define  POLY_LABEL2     __POLY_CHECK8s__
# else
#       define  ILC_NAME        ___ILC_CHECK8__
#       define  ILC_LABEL       ___ILC_CHECK8__:
#       define  ILC_NAME2       ___ILC_CHECK8s__
#       define  ILC_LABEL2      ___ILC_CHECK8s__:
#       define  POLY_LABEL      ___POLY_CHECK8__
#       define  POLY_LABEL2     ___POLY_CHECK8s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND8
#       define  SEND_MISS       SEND8
#       define  ILCCHECK
#       include "codeEntry.h"

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC9_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK9__
#       define  ILC_LABEL       __ILC_CHECK9__:
#       define  ILC_NAME2       __ILC_CHECK9s__
#       define  ILC_LABEL2      __ILC_CHECK9s__:
#       define  POLY_LABEL      __POLY_CHECK9__
#       define  POLY_LABEL2     __POLY_CHECK9s__
# else
#       define  ILC_NAME        ___ILC_CHECK9__
#       define  ILC_LABEL       ___ILC_CHECK9__:
#       define  ILC_NAME2       ___ILC_CHECK9s__
#       define  ILC_LABEL2      ___ILC_CHECK9s__:
#       define  POLY_LABEL      ___POLY_CHECK9__
#       define  POLY_LABEL2     ___POLY_CHECK9s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND9
#       define  SEND_MISS       SEND9
#       define  ILCCHECK
#       include "codeEntry.h"

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC10_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK10__
#       define  ILC_LABEL       __ILC_CHECK10__:
#       define  ILC_NAME2       __ILC_CHECK10s__
#       define  ILC_LABEL2      __ILC_CHECK10s__:
#       define  POLY_LABEL      __POLY_CHECK10__
#       define  POLY_LABEL2     __POLY_CHECK10s__
# else
#       define  ILC_NAME        ___ILC_CHECK10__
#       define  ILC_LABEL       ___ILC_CHECK10__:
#       define  ILC_NAME2       ___ILC_CHECK10s__
#       define  ILC_LABEL2      ___ILC_CHECK10s__:
#       define  POLY_LABEL      ___POLY_CHECK10__
#       define  POLY_LABEL2     ___POLY_CHECK10s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND10
#       define  SEND_MISS       SEND10
#       define  ILCCHECK
#       include "codeEntry.h"

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC11_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK11__
#       define  ILC_LABEL       __ILC_CHECK11__:
#       define  ILC_NAME2       __ILC_CHECK11s__
#       define  ILC_LABEL2      __ILC_CHECK11s__:
#       define  POLY_LABEL      __POLY_CHECK11__
#       define  POLY_LABEL2     __POLY_CHECK11s__
# else
#       define  ILC_NAME        ___ILC_CHECK11__
#       define  ILC_LABEL       ___ILC_CHECK11__:
#       define  ILC_NAME2       ___ILC_CHECK11s__
#       define  ILC_LABEL2      ___ILC_CHECK11s__:
#       define  POLY_LABEL      ___POLY_CHECK11__
#       define  POLY_LABEL2     ___POLY_CHECK11s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND11
#       define  SEND_MISS       SEND11
#       define  ILCCHECK
#       include "codeEntry.h"

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC12_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK12__
#       define  ILC_LABEL       __ILC_CHECK12__:
#       define  ILC_NAME2       __ILC_CHECK12s__
#       define  ILC_LABEL2      __ILC_CHECK12s__:
#       define  POLY_LABEL      __POLY_CHECK12__
#       define  POLY_LABEL2     __POLY_CHECK12s__
# else
#       define  ILC_NAME        ___ILC_CHECK12__
#       define  ILC_LABEL       ___ILC_CHECK12__:
#       define  ILC_NAME2       ___ILC_CHECK12s__
#       define  ILC_LABEL2      ___ILC_CHECK12s__:
#       define  POLY_LABEL      ___POLY_CHECK12__
#       define  POLY_LABEL2     ___POLY_CHECK12s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND12
#       define  SEND_MISS       SEND12
#       define  ILCCHECK
#       include "codeEntry.h"

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC13_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK13__
#       define  ILC_LABEL       __ILC_CHECK13__:
#       define  ILC_NAME2       __ILC_CHECK13s__
#       define  ILC_LABEL2      __ILC_CHECK13s__:
#       define  POLY_LABEL      __POLY_CHECK13__
#       define  POLY_LABEL2     __POLY_CHECK13s__
# else
#       define  ILC_NAME        ___ILC_CHECK13__
#       define  ILC_LABEL       ___ILC_CHECK13__:
#       define  ILC_NAME2       ___ILC_CHECK13s__
#       define  ILC_LABEL2      ___ILC_CHECK13s__:
#       define  POLY_LABEL      ___POLY_CHECK13__
#       define  POLY_LABEL2     ___POLY_CHECK13s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND13
#       define  SEND_MISS       SEND13
#       define  ILCCHECK
#       include "codeEntry.h"

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC14_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK14__
#       define  ILC_LABEL       __ILC_CHECK14__:
#       define  ILC_NAME2       __ILC_CHECK14s__
#       define  ILC_LABEL2      __ILC_CHECK14s__:
#       define  POLY_LABEL      __POLY_CHECK14__
#       define  POLY_LABEL2     __POLY_CHECK14s__
# else
#       define  ILC_NAME        ___ILC_CHECK14__
#       define  ILC_LABEL       ___ILC_CHECK14__:
#       define  ILC_NAME2       ___ILC_CHECK14s__
#       define  ILC_LABEL2      ___ILC_CHECK14s__:
#       define  POLY_LABEL      ___POLY_CHECK14__
#       define  POLY_LABEL2     ___POLY_CHECK14s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND14
#       define  SEND_MISS       SEND14
#       define  ILCCHECK
#       include "codeEntry.h"

# if defined(SYSV4) || defined(ELF)
#  if defined(SYSV4)
#        define ASMLABEL(lab,dir) ILC15_##lab
#  endif
#       define  ILC_NAME        __ILC_CHECK15__
#       define  ILC_LABEL       __ILC_CHECK15__:
#       define  ILC_NAME2       __ILC_CHECK15s__
#       define  ILC_LABEL2      __ILC_CHECK15s__:
#       define  POLY_LABEL      __POLY_CHECK15__
#       define  POLY_LABEL2     __POLY_CHECK15s__
# else
#       define  ILC_NAME        ___ILC_CHECK15__
#       define  ILC_LABEL       ___ILC_CHECK15__:
#       define  ILC_NAME2       ___ILC_CHECK15s__
#       define  ILC_LABEL2      ___ILC_CHECK15s__:
#       define  POLY_LABEL      ___POLY_CHECK15__
#       define  POLY_LABEL2     ___POLY_CHECK15s__
# endif
#       define  ADDR_SEND_MISS  ADDR__SEND15
#       define  SEND_MISS       SEND15
#       define  ILCCHECK
#       include "codeEntry.h"

#endif /* __i386__ && 32bit */



/*------------------------------------------------------------------
 *
 * MACHINE: NeXT (68k)
 *
 *------------------------------------------------------------------*/
#ifdef __mc68k__

	.text
	.globl  ___retSelf
#       define  QUICKENTRY_OP
#       define  OPERATION       movel   R_RECEIVER,d0
#       include "codeEntry.h"
___retSelf:
#       define  ENTRY0
#       include "codeEntry.h"
	movel   sp@(O_RECEIVER),d0
	rts

	.globl  ___retSelf1
#       define QUICKENTRY_OP
#       define  OPERATION       movel   R_RECEIVER,d0
#       include "codeEntry.h"
___retSelf1:
#       define  ENTRY1
#       include "codeEntry.h"
	movel   sp@(O_RECEIVER),d0
	rts

	.globl  ___retSelf2
#       define QUICKENTRY_OP
#       define  OPERATION       movel   R_RECEIVER,d0
#       include "codeEntry.h"
___retSelf2:
#       define  ENTRY2
#       include "codeEntry.h"
	movel   sp@(O_RECEIVER),d0
	rts

	.globl  ___retSelf3
#       define QUICKENTRY_OP
#       define  OPERATION       movel   R_RECEIVER,d0
#       include "codeEntry.h"
___retSelf3:
#       define  ENTRY3
#       include "codeEntry.h"
	movel   sp@(O_RECEIVER),d0
	rts

	.globl  ___retNil
	.globl ___bRetNil
#       define  QUICKENTRY_OP
#       define  OPERATION       clrl   d0
#       include "codeEntry.h"
___retNil:
#       define  ENTRY0
#       include "codeEntry.h"
___bRetNil:
	clrl    d0
	rts

	.globl  ___ret0
	.globl  ___bRet0
#       define  QUICKENTRY_OP
#       define  OPERATION       movel   \#0x80000000, d0
#       include "codeEntry.h"
___ret0:
#       define  ENTRY0
#       include "codeEntry.h"
___bRet0:
	movel   #0x80000000, d0
	rts

	.globl  ___retTrue
	.globl  ___bRetTrue
#       define  QUICKENTRY_OP
# if !defined(__DIRECTVMDATA__)
#       define  OPERATION1      movel   _Ptrue, a0
#       define  OPERATION2      movel   a0@, d0
# else
#       define  OPERATION       movel   _true, d0
# endif
#       include "codeEntry.h"
___retTrue:
#       define  ENTRY0
#       include "codeEntry.h"
___bRetTrue:
# if !defined(__DIRECTVMDATA__)
	movel   _Ptrue, a0
	movel   a0@, d0
# else
	movel   _true,d0
# endif
	rts

	.globl  ___retFalse
	.globl  ___bRetFalse
#       define QUICKENTRY_OP
# if !defined(__DIRECTVMDATA__)
#       define  OPERATION1      movel   _Pfalse, a0
#       define  OPERATION2      movel   a0@, d0
# else
#       define  OPERATION       movel   _false, d0
# endif
#       include "codeEntry.h"
___retFalse:
#       define  ENTRY0
#       include "codeEntry.h"
___bRetFalse:
# if !defined(__DIRECTVMDATA__)
	movel   _Pfalse, a0
	movel   a0@, d0
# else
	movel   _false,d0
# endif
	rts

#       define LABEL    ___retInst0
#       define OFFSET   12
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst1
#       define OFFSET   16
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst2
#       define OFFSET   20
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst3
#       define OFFSET   24
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst4
#       define OFFSET   28
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst5
#       define OFFSET   32
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst6
#       define OFFSET   36
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst7
#       define OFFSET   40
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst8
#       define OFFSET   44
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst9
#       define OFFSET   48
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst10
#       define OFFSET   52
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst11
#       define OFFSET   56
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst12
#       define OFFSET   60
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst13
#       define OFFSET   64
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst14
#       define OFFSET   68
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst15
#       define OFFSET   72
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst16
#       define OFFSET   76
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst17
#       define OFFSET   80
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst18
#       define OFFSET   84
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst19
#       define OFFSET   88
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst20
#       define OFFSET   92
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst21
#       define OFFSET   96
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst22
#       define OFFSET   100
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst23
#       define OFFSET   104
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst24
#       define OFFSET   108
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst25
#       define OFFSET   112
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst26
#       define OFFSET   116
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst27
#       define OFFSET   120
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst28
#       define OFFSET   124
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst29
#       define OFFSET   128
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst30
#       define OFFSET   132
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst0
#       define OFFSET   12
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst1
#       define OFFSET   16
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst2
#       define OFFSET   20
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst3
#       define OFFSET   24
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst4
#       define OFFSET   28
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst5
#       define OFFSET   32
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst6
#       define OFFSET   36
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst7
#       define OFFSET   40
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst8
#       define OFFSET   44
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst9
#       define OFFSET   48
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst10
#       define OFFSET   52
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst11
#       define OFFSET   56
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst12
#       define OFFSET   60
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst13
#       define OFFSET   64
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst14
#       define OFFSET   68
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst15
#       define OFFSET   72
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst16
#       define OFFSET   76
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst17
#       define OFFSET   80
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst18
#       define OFFSET   84
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst19
#       define OFFSET   88
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst20
#       define OFFSET   92
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst21
#       define OFFSET   96
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst22
#       define OFFSET   100
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst23
#       define OFFSET   104
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst24
#       define OFFSET   108
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst25
#       define OFFSET   112
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst26
#       define OFFSET   116
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst27
#       define OFFSET   120
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst28
#       define OFFSET   124
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst29
#       define OFFSET   128
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst30
#       define OFFSET   132
#       define SETINST
#       include "codeEntry.h"

	.globl  MKLARGEINT
	.globl  ___MKLARGEINT
MKLARGEINT:
	movel   d1,sp@-
	movel   a0,sp@-
	movel   d0,sp@-
	jbsr    ___MKLARGEINT
	addw    #4, sp
	movel   sp@+, a0
	movel   sp@+, d1
	rts

/*
 * overflow after addition
 */
	.globl  MKLARGEINTov_a
MKLARGEINTov_a:
	movel   d1,sp@-
	movel   a0,sp@-
	movel   d0,sp@-
	jbsr    ___MKLARGEINT
	addw    #4, sp
	movel   sp@+, a0
	movel   sp@+, d1
	rts

/*
 * overflow after subtraction
 */
	.globl  MKLARGEINTov_s
MKLARGEINTov_s:
	movel   d1,sp@-
	movel   a0,sp@-
	movel   d0,sp@-
	jbsr    ___MKLARGEINT
	addw    #4, sp
	movel   sp@+, a0
	movel   sp@+, d1
	rts

# ifdef THIS_CONTEXT
#  ifndef VERSION2
	.globl  _qsetjmp
_qsetjmp:
	movel   sp@(0x4:w),a0
	movel   sp@,a0@(0xc:w)
	lea     sp@(0x4:w),a1
	movel   a1,a0@(0x8:w)
	clrl    a0@(0x10:w)
/*  08 0c 10 14 18 1c 20 24 28 2c 30 34 38 3c 40 */
/*  pc sp 0  xx d2 d3 d4 d5 d6 d7 a2 a3 a4 a5 a6 */

	moveml  d2/d3/d4/d5/d6/d7/a2/a3/a4/a5/a6,a0@(0x18:w)

	movel   #0xbeeffeed,a0@(0x98:w)         /* this may be NeXT specific */
	moveq   #0,d0
	rts

	.globl  _qlongjmp
_qlongjmp:
	movel   sp@(0x4:w),a0
	movel   a0@(0x8:w),a1
	movel   sp@(0x8:w),d0
	moveal  a1,sp
	moveml  a0@(0x18:w),d2/d3/d4/d5/d6/d7/a2/a3/a4/a5/a6
	movel   a0@(0xc:w),a0
	jmp     a0@

	.globl  _qlongrestart
_qlongrestart:
	movel   sp@(0x4:w),a0
	movel   a0@(0x8:w),a1
	moveq   #0,d0
	moveal  a1,sp
	moveml  a0@(0x18:w),d2/d3/d4/d5/d6/d7/a2/a3/a4/a5/a6
	movel   a0@(0xc:w),a0
	jmp     a0@

#  else /* VERSION 2 */
	.globl  _qsetjmp
_qsetjmp:
	movel   sp@(0x4:w),a0
	movel   sp@,a0@(0xc:w)
	lea     sp@(0x4:w),a1
	movel   a1,a0@(0x8:w)
/*  08 0c 10 14 18 1c 20 24 28 2c 30 34 38 3c 40 */
/*  pc sp xx xx xx d3 d4 a2 a3 a6 xx xx xx xx xx */

	moveml  d3/d4/a2/a3/a6,a0@(0x1c:w)

	moveq   #0,d0
	rts

	.globl  _qlongjmp
_qlongjmp:
	movel   sp@(0x4:w),a0
	movel   a0@(0x8:w),a1
	movel   sp@(0x8:w),d0
	moveal  a1,sp
	moveml  a0@(0x1c:w),d3/d4/a2/a3/a6
	movel   a0@(0xc:w),a0
	jmp     a0@

	.globl  _qlongrestart
_qlongrestart:
	movel   sp@(0x4:w),a0
	movel   a0@(0x8:w),a1
	moveq   #0,d0
	moveal  a1,sp
	moveml  a0@(0x1c:w),d3/d4/a2/a3/a6
	movel   a0@(0xc:w),a0
	jmp     a0@

#  endif /* version2 */

# else /* not THIS_CONTEXT */

	.globl  _qsetjmp
_qsetjmp:
	movel   sp@(0x4:w),a0
	movel   sp@,a0@(0xc:w)
	lea     sp@(0x4:w),a1
	movel   a1,a0@(0x8:w)
	clrl    a0@(0x10:w)
	moveml  d2/d3/d4/d5/d6/d7/a2/a3/a4/a5/a6,a0@(0x18:w)
	movel   #0xbeeffeed,a0@(0x98:w)         /* this may be NeXT specific */
	moveq   #0,d0
	rts
# endif /* not THIS_CONTEXT */

/*
 * code saver: ilc-miss check prolog
 *
 * to be called via
 *   jsr __ILCCHECK__
 * before method is entered
 * this code is for NonNil-nonSmallInt classes only
 *
 * entry: args on stack
 *      a1
 *      pIlc
 *      search
 *      sel
 *      rec
 *      return-addr
 *      CHECK-returnADDR
 *
 * normally, this code is inlined into the method, but
 * when compiled with +optspace, a call to this function
 * is generated instead.
 */

#       define  ILC_LABEL       ___ILC_CHECK0__
#       define  POLY_LABEL      ___POLY_CHECK0__
#       define  SEND_MISS       __SEND0
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK1__
#       define  POLY_LABEL      ___POLY_CHECK1__
#       define  SEND_MISS       __SEND1
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK2__
#       define  POLY_LABEL      ___POLY_CHECK2__
#       define  SEND_MISS       __SEND2
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK3__
#       define  POLY_LABEL      ___POLY_CHECK3__
#       define  SEND_MISS       __SEND3
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK4__
#       define  POLY_LABEL      ___POLY_CHECK4__
#       define  SEND_MISS       __SEND4
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK5__
#       define  POLY_LABEL      ___POLY_CHECK5__
#       define  SEND_MISS       __SEND5
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK6__
#       define  POLY_LABEL      ___POLY_CHECK6__
#       define  SEND_MISS       __SEND6
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK7__
#       define  POLY_LABEL      ___POLY_CHECK7__
#       define  SEND_MISS       __SEND7
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK8__
#       define  POLY_LABEL      ___POLY_CHECK8__
#       define  SEND_MISS       __SEND8
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK9__
#       define  POLY_LABEL      ___POLY_CHECK9__
#       define  SEND_MISS       __SEND9
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK10__
#       define  POLY_LABEL      ___POLY_CHECK10__
#       define  SEND_MISS       __SEND10
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK11__
#       define  POLY_LABEL      ___POLY_CHECK11__
#       define  SEND_MISS       __SEND11
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK12__
#       define  POLY_LABEL      ___POLY_CHECK12__
#       define  SEND_MISS       __SEND12
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK13__
#       define  POLY_LABEL      ___POLY_CHECK13__
#       define  SEND_MISS       __SEND13
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK14__
#       define  POLY_LABEL      ___POLY_CHECK14__
#       define  SEND_MISS       __SEND14
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK15__
#       define  POLY_LABEL      ___POLY_CHECK15__
#       define  SEND_MISS       __SEND15
#       define  ILCCHECK
#       include "codeEntry.h"

#endif /* __mc68k__ */


/*------------------------------------------------------------------
 *
 * MACHINE: mc88k
 *
 *------------------------------------------------------------------*/

#ifdef mc88k

# ifdef NO_ASM
#  define NO_ASM_RET_INST
# endif


# define noop           or r0,r0,r0

# define RECEIVER       r2
# define SELECTOR       r3
# define SRCHCLASS      r4
# define PILC           r5
# define TMP1           r12
# define TMP2           r13

	text
	align   16
	global  ___switchStack__
___switchStack__:
#ifdef OLD
	or       r31,r0,r2
	jmp      r1
#else
	jmp.n    r1
	or       r31,r0,r2
#endif


# ifndef NO_ASM_RET_INST

#       define LABEL    ___retInst0
#       define LABEL1   La0
#       define OFFSET   12
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst1
#       define LABEL1   La1
#       define OFFSET   16
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst2
#       define LABEL1   La2
#       define OFFSET   20
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst3
#       define LABEL1   La3
#       define OFFSET   24
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst4
#       define LABEL1   La4
#       define OFFSET   28
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst5
#       define LABEL1   La5
#       define OFFSET   32
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst6
#       define LABEL1   La6
#       define OFFSET   36
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst7
#       define LABEL1   La7
#       define OFFSET   40
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst8
#       define LABEL1   La8
#       define OFFSET   44
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst9
#       define LABEL1   La9
#       define OFFSET   48
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst10
#       define LABEL1   La10
#       define OFFSET   52
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst11
#       define LABEL1   La11
#       define OFFSET   56
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst12
#       define LABEL1   La12
#       define OFFSET   60
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst13
#       define LABEL1   La13
#       define OFFSET   64
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst14
#       define LABEL1   La14
#       define OFFSET   68
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst15
#       define LABEL1   La15
#       define OFFSET   72
#       define RETINST
#       include "codeEntry.h"

goSend0:
	br      __SEND0

#       define LABEL    ___retInst16
#       define LABEL1   La16
#       define OFFSET   76
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst17
#       define LABEL1   La17
#       define OFFSET   80
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst18
#       define LABEL1   La18
#       define OFFSET   84
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst19
#       define LABEL1   La19
#       define OFFSET   88
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst20
#       define LABEL1   La20
#       define OFFSET   92
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst21
#       define LABEL1   La21
#       define OFFSET   96
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst22
#       define LABEL1   La22
#       define OFFSET   100
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst23
#       define LABEL1   La23
#       define OFFSET   104
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst24
#       define LABEL1   La24
#       define OFFSET   108
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst25
#       define LABEL1   La25
#       define OFFSET   112
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst26
#       define LABEL1   La26
#       define OFFSET   116
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst27
#       define LABEL1   La27
#       define OFFSET   120
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst28
#       define LABEL1   La28
#       define OFFSET   124
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst29
#       define LABEL1   La29
#       define OFFSET   128
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst30
#       define LABEL1   La30
#       define OFFSET   132
#       define RETINST
#       include "codeEntry.h"

# endif /* NO_ASM_RETINST */

#       define  ILC_NAME        ___ILC_CHECK0__
#       define  ILC_NAME_s      ___ILC_CHECK0s__
#       define  LABEL1          Lia0
#       define  LABEL2          Lib0
#       define  LABEL3          Lic0
#       define  SEND_MISS       __SEND0
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK1__
#       define  ILC_NAME_s      ___ILC_CHECK1s__
#       define  LABEL1          Lia1
#       define  LABEL2          Lib1
#       define  LABEL3          Lic1
#       define  SEND_MISS       __SEND1
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK2__
#       define  ILC_NAME_s      ___ILC_CHECK2s__
#       define  LABEL1          Lia2
#       define  LABEL2          Lib2
#       define  LABEL3          Lic2
#       define  SEND_MISS       __SEND2
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK3__
#       define  ILC_NAME_s      ___ILC_CHECK3s__
#       define  LABEL1          Lia3
#       define  LABEL2          Lib3
#       define  LABEL3          Lic3
#       define  SEND_MISS       __SEND3
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK4__
#       define  ILC_NAME_s      ___ILC_CHECK4s__
#       define  LABEL1          Lia4
#       define  LABEL2          Lib4
#       define  LABEL3          Lic4
#       define  SEND_MISS       __SEND4
#       define  ILCCHECK
#       include "codeEntry.h"

/*
 * NO ILC_CHECK if more than 8 overall args are to
 * be passed (ySTACK_HANDLERb only handles register args)
 */
#       define  ILC_NAME        ___ILC_CHECK5__
#       define  LABEL1          Lia5
#       define  LABEL2          Lib5
#       define  LABEL3          Lic5
#       define  SEND_MISS       __SEND5
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK6__
#       define  LABEL1          Lia6
#       define  LABEL2          Lib6
#       define  LABEL3          Lic6
#       define  SEND_MISS       __SEND6
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK7__
#       define  LABEL1          Lia7
#       define  LABEL2          Lib7
#       define  LABEL3          Lic7
#       define  SEND_MISS       __SEND7
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK8__
#       define  LABEL1          Lia8
#       define  LABEL2          Lib8
#       define  LABEL3          Lic8
#       define  SEND_MISS       __SEND8
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK9__
#       define  LABEL1          Lia9
#       define  LABEL2          Lib9
#       define  LABEL3          Lic9
#       define  SEND_MISS       __SEND9
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK10__
#       define  LABEL1          Lia10
#       define  LABEL2          Lib10
#       define  LABEL3          Lic10
#       define  SEND_MISS       __SEND10
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK11__
#       define  LABEL1          Lia11
#       define  LABEL2          Lib11
#       define  LABEL3          Lic11
#       define  SEND_MISS       __SEND11
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK12__
#       define  LABEL1          Lia12
#       define  LABEL2          Lib12
#       define  LABEL3          Lic12
#       define  SEND_MISS       __SEND12
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK13__
#       define  LABEL1          Lia13
#       define  LABEL2          Lib13
#       define  LABEL3          Lic13
#       define  SEND_MISS       __SEND13
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK14__
#       define  LABEL1          Lia14
#       define  LABEL2          Lib14
#       define  LABEL3          Lic14
#       define  SEND_MISS       __SEND14
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        ___ILC_CHECK15__
#       define  LABEL1          Lia15
#       define  LABEL2          Lib15
#       define  LABEL3          Lic15
#       define  SEND_MISS       __SEND15
#       define  ILCCHECK
#       include "codeEntry.h"

#endif /* mc88k */

/*------------------------------------------------------------------
 *
 * MACHINE: rs6000 + aix
 *
 *------------------------------------------------------------------*/

#if defined(rs6k) || defined(powerPC)
# if defined(aix)
	.set r0,0
	.set r1,1
	.set r2,2
	.set r3,3
	.set r4,4
	.set r5,5
	.set r6,6
	.set r7,7
	.set r12,12
	.set r11,11
	.set r13,13

	.set SP,1
	.set LR,8
	.set BO_ALWAYS,20
	.set CR0_LT,0


	.globl  .__switchStack__
.__switchStack__:
	mr      r1, r3          # set stack
	br

	.globl .__pwr_flushDataCacheLineFor__
.__pwr_flushDataCacheLineFor__:
	clf     r0, r3
	br

	.globl .__ppc_flushDataCacheLineFor__
.__ppc_flushDataCacheLineFor__:
	dcbf    r0, r3
	sync
	icbi    r0, r3
	br

	.globl .__pwr_flushInstructionPrefetch__
.__pwr_flushInstructionPrefetch__:
	ics
	br

	.globl .__ppc_flushInstructionPrefetch__
.__ppc_flushInstructionPrefetch__:
	isync
	br

/*
 * aix's original longjump does too much testing ...
 * (not allowing longjmp if the targets frame address is
 *  lower than the current one. Thus, this has to be reimplemented
 *  here to allow for our spaghetti-stack implementation to work)
 */
#undef _longjmp
#undef longjmp
#undef _setjmp
#undef setjmp

/* #define ST_0_R1 */
	.globl  ._longjmp
	.globl  .longjmp

.longjmp:
._longjmp:
	l     r13,0xc(r3)
	l     r5,0x8(r3)
	l     r1,0xc(r3)        /* stack ptr */
#ifdef ST_0_R1
	l     r7,0xf8(r3)
	st    r7,0x0(r1)
#endif
	l     r2,0x10(r3)       /* TOC ptr */
/*
 *      bl   jmprestfpr
 */
	mtlr  r5                /* return address */
	lm    r13,0x14(r3)      /* GPRs */
	l     r5,0x60(r3)       /* condition code */
	mtcrf 0x38,r5
	mr    r3,r4             /* retval from arg2 */
	br

	.globl  .longrestart

#ifdef NOT_NEEDED /* longjmp handles 0-argument */
._longrestart:
	l     r13,0xc(r3)
	l     r5,0x8(r3)
	l     r1,0xc(r3)        /* stack ptr */
#ifdef ST_0_R1
	l     r7,0xf8(r3)
	st    r7,0x0(r1)
#endif
	l     r2,0x10(r3)       /* TOC ptr */
/*
 *      bl   jmprestfpr
 */
	mtlr  r5                /* return address */
	lm    r13,0x14(r3)      /* GPRs */
	l     r5,0x60(r3)       /* condition code */
	mtcrf 0x38,r5
	lil   r3,0x0            /* return zero */
	br
#endif /* NOT_NEEDED */

	.globl ._setjmp
	.globl .setjmp

._setjmp:
.setjmp:
	mfcr  r4                /* condition code */
	st    r4,0x60(r3)
	mflr  r4                /* return addr */
	st    r1,0xc(r3)        /* stack pointer */
#ifdef ST_0_R1
	l     r7,0x0(r1)
	st    r7,0xf8(r3)
#endif
	st    r2,0x10(r3)       /* TOC ptr */
	st    r4,0x8(r3)        /* return addr */
	stm   r13,0x14(r3)      /* GPRs */
	mtlr  r4
	lil   r3,0x0            /* return zero */
	br

# define RECEIVER       r3
# define SELECTOR       r4
# define SRCHCLASS      r5
# define PILC           r6
# define MARG0          r7
# define MARG1          r8
# define MARG2          r9
# define MARG3          r10

# ifdef ASM_RET_INST0
	.globl  .__retInst0
	.extern ._SEND0{PR}
	.extern _SEND0{DS}

.__retInst0:
#  if TAG_INT == 1
	cmpi    0,RECEIVER,0    /* receiver isNil ? */
	beq     __L2

	andi.   r0,1,RECEIVER   /* smallInteger ? (receiver & 1 -> r0) */
	bne     __L2
#  else
	cmpi    0, RECEIVER, 0
	ble     __L2
#  endif

	l       r0, 4(PILC)     /* pilc->ilc_class */
	l       r7, 0(RECEIVER) /* _qClass(receiver) */
	cmpl    0,r0,r7
	bne     __L1            /* nope */

	l       r3,12(RECEIVER) /* fetch instvar0 */
	br                      /* return */

__L1:
	cmpi    0,SRCHCLASS,0   /* searchclass notNil ? */
	beq     __L2

	l       r3, 12(RECEIVER) /* fetch instvar0 */
	br

	/* continue in SEND0 */
__L2:
	/* TODO:
	/* ... load r2  <- _SEND0[1] */
	/* ... load r11 <- _SEND[1]  */
	b       ._SEND0{PR}

	.globl  __retInst0{DS}
	.csect  __retInst0{DS}
	.long   .__retInst0             # "\0\0\0\214"
/*        .long   TOC{TC0}                # "\0\0\003\230" */
	.long   0x00000000
	.long   0x00000000              # "\0\0\0\0"
#endif /* ASM_RET_INST0 */


#       define  ILC_NAME        .__ILC_CHECK0__
#       define  LABEL1          __Lia0
#       define  LABEL2          __Lib0
#       define  LABEL3          __Lic0
#       define  SEND_MISS       ._SEND0{PR}
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        .__ILC_CHECK1__
#       define  LABEL1          __Lia1
#       define  LABEL2          __Lib1
#       define  LABEL3          __Lic1
#       define  SEND_MISS       ._SEND1{PR}
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        .__ILC_CHECK2__
#       define  LABEL1          __Lia2
#       define  LABEL2          __Lib2
#       define  LABEL3          __Lic2
#       define  SEND_MISS       ._SEND2{PR}
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        .__ILC_CHECK3__
#       define  LABEL1          __Lia3
#       define  LABEL2          __Lib3
#       define  LABEL3          __Lic3
#       define  SEND_MISS       ._SEND3{PR}
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_NAME        .__ILC_CHECK4__
#       define  LABEL1          __Lia4
#       define  LABEL2          __Lib4
#       define  LABEL3          __Lic4
#       define  SEND_MISS       ._SEND4{PR}
#       define  ILCCHECK
#       include "codeEntry.h"


	.globl  __ILC_CHECK0__{DS}
	.csect  __ILC_CHECK0__{DS}
	.long   .__ILC_CHECK0__             # "\0\0\0\214"
/*        .long   TOC{TC0}                # "\0\0\003\230" */
	.long   0x00000000
	.long   0x00000000              # "\0\0\0\0"

	.globl  __ILC_CHECK1__{DS}
	.csect  __ILC_CHECK1__{DS}
	.long   .__ILC_CHECK1__             # "\0\0\0\214"
/*        .long   TOC{TC0}                # "\0\0\003\230" */
	.long   0x00000000
	.long   0x00000000              # "\0\0\0\0"

	.globl  __ILC_CHECK2__{DS}
	.csect  __ILC_CHECK2__{DS}
	.long   .__ILC_CHECK2__             # "\0\0\0\214"
/*        .long   TOC{TC0}                # "\0\0\003\230" */
	.long   0x00000000
	.long   0x00000000              # "\0\0\0\0"

	.globl  __ILC_CHECK3__{DS}
	.csect  __ILC_CHECK3__{DS}
	.long   .__ILC_CHECK3__             # "\0\0\0\214"
/*        .long   TOC{TC0}                # "\0\0\003\230" */
	.long   0x00000000
	.long   0x00000000              # "\0\0\0\0"

	.globl  __ILC_CHECK4__{DS}
	.csect  __ILC_CHECK4__{DS}
	.long   .__ILC_CHECK4__             # "\0\0\0\214"
/*        .long   TOC{TC0}                # "\0\0\003\230" */
	.long   0x00000000
	.long   0x00000000              # "\0\0\0\0"

# endif /* aix */

# ifdef OSX
	.section __TEXT,__text,regular,pure_instructions
	.align  2

	.globl  ___switchStack__
___switchStack__:
	mr      r1, r3
	blr

	.align  2
	.globl ___ppc_flushDataCacheLineFor__
___ppc_flushDataCacheLineFor__:
	dcbf    0, r3
	sync
	icbi    0, r3
	blr

	.align  2
	.globl ___ppc_flushInstructionPrefetch__
___ppc_flushInstructionPrefetch__:
	isync
	blr

# endif /* OSX */
#endif /* rs6k || powerPC */

/*------------------------------------------------------------------
 *
 * MACHINE: alpha
 *
 *------------------------------------------------------------------*/

#ifdef alpha

# include <machine/pal.h>

# define NO_ASM


# define REG_ARG0       $16
# define REG_ARG1       $17
# define REG_ARG2       $18
# define REG_ARG3       $19
# define REG_RETURN     $0
# define REG_T0         $1
# define REG_T1         $2
# define REG_T2         $3
# define REG_T3         $4
# define REG_T4         $5
# define REG_T5         $6
# define REG_T6         $7
# define REG_T7         $8

# define REG_S0         $9
# define REG_S1         $10
# define REG_S2         $11
# define REG_S3         $12
# define REG_S4         $13
# define REG_S5         $14
# define REG_S6         $15

# define REG_LINK       $26
# define REG_ZERO       $31
# define REG_SP         $30

# define REG_RECEIVER   REG_ARG0
# define REG_SELECTOR   REG_ARG1
# define REG_SEARCH     REG_ARG2
# define REG_PILC       REG_ARG3

	.globl  __switchStack__

# ifdef __alpha64__
__switchStack__:
	addq    REG_ARG0, 0, REG_SP
	ret     REG_ZERO, (REG_LINK), 1
	nop
	nop

__switchStackAndJump__:
	addq    REG_ARG0, 0, REG_SP
	jmp     REG_ZERO, (REG_ARG1), 0
	nop
	nop
# else
__switchStack__:
	addl    REG_ARG0, 0, REG_SP
	ret     REG_ZERO, (REG_LINK), 1
	nop
	nop

__switchStackAndJump__:
	addl    REG_ARG0, 0, REG_SP
	ret     REG_ZERO, (REG_LINK), 1
	nop
	nop
# endif /* __alpha64__ */

	/*
	 * REG_ARG0 points to jmp_buf.
	 * see jmpBuf slots in setjmp.h
	 */
# define JB_PC          16      /* +2 quads */

# define JB_V0          32      /* +4 quads */
# define JB_T0          40      /* +5 quads */
# define JB_T1          48      /* +6 quads */
# define JB_T2          56      /* +7 quads */
# define JB_T3          64      /* +8 quads */
# define JB_T4          72      /* +9 quads */
# define JB_T5          80      /* +10 quads */
# define JB_T6          88      /* +11 quads */
# define JB_T7          96      /* +12 quads */
# define JB_S0          104     /* +13 quads */
# define JB_S1          112     /* +14 quads */
# define JB_S2          120     /* +15 quads */
# define JB_S3          128     /* +16 quads */
# define JB_S4          136     /* +17 quads */
# define JB_S5          144     /* +18 quads */
# define JB_S6          152     /* +19 quads */
# define JB_A0          160     /* +20 quads */
# define JB_A1          168     /* +21 quads */
# define JB_A2          176     /* +22 quads */
# define JB_A3          184     /* +23 quads */
# define JB_A4          192     /* +24 quads */
# define JB_A5          200     /* +25 quads */
# define JB_T8          208     /* +26 quads */
# define JB_T9          216     /* +27 quads */
# define JB_T10         224     /* +28 quads */
# define JB_T11         232     /* +29 quads */
# define JB_RA          240     /* +30 quads */
# define JB_PV          248     /* +31 quads */
# define JB_AT          256     /* +32 quads */
# define JB_GP          264     /* +33 quads */
# define JB_SP          272     /* +34 quads */

	.globl  __qsetjmp
__qsetjmp:
	stq     REG_S0, JB_S0(REG_ARG0)
	stq     REG_S1, JB_S1(REG_ARG0)
	stq     REG_S2, JB_S2(REG_ARG0)
	stq     REG_S3, JB_S3(REG_ARG0)
	stq     REG_S4, JB_S4(REG_ARG0)
	stq     REG_S5, JB_S5(REG_ARG0)
	stq     REG_S6, JB_S6(REG_ARG0)
	stq     REG_SP, JB_SP(REG_ARG0)
	stq     REG_LINK, JB_RA(REG_ARG0)
	bis     REG_ZERO, REG_ZERO, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
	nop
	nop
	nop

	.globl  __qlongjmp
	/* return through jmpBuf, return passed value */
__qlongjmp:
	ldq     REG_S0, JB_S0(REG_ARG0)
	ldq     REG_S1, JB_S1(REG_ARG0)
	ldq     REG_S2, JB_S2(REG_ARG0)
	ldq     REG_S3, JB_S3(REG_ARG0)
	ldq     REG_S4, JB_S4(REG_ARG0)
	ldq     REG_S5, JB_S5(REG_ARG0)
	ldq     REG_S6, JB_S6(REG_ARG0)
	ldq     REG_SP, JB_SP(REG_ARG0)
	ldq     REG_LINK, JB_RA(REG_ARG0)
	bis     REG_ZERO, REG_ARG1, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
	nop
	nop
	nop

	.globl  __qlongrestart
	/* restart through jmpBuf, re-return 0 */
__qlongrestart:
	ldq     REG_S0, JB_S0(REG_ARG0)
	ldq     REG_S1, JB_S1(REG_ARG0)
	ldq     REG_S2, JB_S2(REG_ARG0)
	ldq     REG_S3, JB_S3(REG_ARG0)
	ldq     REG_S4, JB_S4(REG_ARG0)
	ldq     REG_S5, JB_S5(REG_ARG0)
	ldq     REG_S6, JB_S6(REG_ARG0)
	ldq     REG_SP, JB_SP(REG_ARG0)
	ldq     REG_LINK, JB_RA(REG_ARG0)
	bis     REG_ZERO, REG_ZERO, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
	nop
	nop
	nop

	.globl  __mb
__mb:
	mb
	ret             REG_ZERO, (REG_LINK), 1
	nop

	.globl  __wmb
__wmb:
	wmb
	ret             REG_ZERO, (REG_LINK), 1
	nop

	.globl  __call_pal_imb
__call_pal_imb:
	wmb
	mb
	call_pal        PAL_imb
	mb
	wmb
	ret             REG_ZERO, (REG_LINK), 1
	nop

#if 0
	/*
	 * only faster for long aligned strings ...
	 */
	.globl  qstrlen
qstrlen:
	or      REG_ZERO, REG_ARG0, REG_T2
loop:
	ldq     REG_T0, 0(REG_ARG0)
	lda     REG_ARG0, 8(REG_ARG0)
	cmpbge  REG_ZERO, REG_T0, REG_T1
	beq     REG_T1, loop

	subq    REG_ARG0, REG_T2, REG_ARG0
	/*
	 * now, REG_ARG0 - REG_T2
	 * is 8 too many ...
	 * and we have to check which byte
	 * was zero.
	 */

	blbs    REG_T1, byte0
	sra     REG_T1, 1, REG_T1
	blbs    REG_T1, byte1
	sra     REG_T1, 1, REG_T1
	blbs    REG_T1, byte2
	sra     REG_T1, 1, REG_T1
	blbs    REG_T1, byte3
	sra     REG_T1, 1, REG_T1
	blbs    REG_T1, byte4
	sra     REG_T1, 1, REG_T1
	blbs    REG_T1, byte5
	sra     REG_T1, 1, REG_T1
	blbs    REG_T1, byte6
byte7:
	subq    REG_ARG0, 1, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
byte6:
	subq    REG_ARG0, 2, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
byte5:
	subq    REG_ARG0, 3, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
byte4:
	subq    REG_ARG0, 4, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
byte3:
	subq    REG_ARG0, 5, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
byte2:
	subq    REG_ARG0, 6, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
byte1:
	subq    REG_ARG0, 7, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
byte0:
	subq    REG_ARG0, 8, REG_RETURN
	ret     REG_ZERO, (REG_LINK), 1
#endif


# if !defined(NO_ASM) /* { */

/* OHEADER is:
 *   int64      class
 *   int32      size
 *   int32      size
 *   instVar0           <- offset = 16
 */
#  ifdef __alpha64__
	.text
	.align  4
	.globl  __xretInst0
__xretInst0:
	ldq     REG_T0, 8(REG_PILC)
	blbs    REG_RECEIVER, retInst0_9
	beq     REG_RECEIVER, retInst0_9
	ldq     REG_T1, 0(REG_RECEIVER)
	bne     REG_SEARCH, retInst0_8
	cmpeq   REG_T0, REG_T1, REG_T2
	beq     REG_T2, retInst0_9
retInst0_8:
	ldq     REG_RETURN, 16(REG_RECEIVER)
	ret     REG_ZERO, (REG_LINK), 1
	nop
	nop
	nop

retInst0_9:
	ldgp    $gp, 0($27)
	lda     $sp, -16($sp)
	stq     REG_LINK, 0($sp)

	jsr     REG_LINK, _SEND0
	ldgp    $gp, 0(REG_LINK)
	nop
	nop

	ldq     REG_LINK, 0($sp)
	lda     $sp, 16($sp)
	ret     REG_ZERO, (REG_LINK), 1
	nop
	nop
	nop
#  endif /* __alpha64__ */

# endif /* not NO_ASM } */

#endif /* alpha */

/*------------------------------------------------------------------
 *
 * MACHINE: sparc
 *
 *------------------------------------------------------------------*/

#ifdef sparc

# ifndef SYSV4
#  include <sun4/trap.h>
# endif

# ifndef ST_FLUSH_WINDOWS
#  define ST_FLUSH_WINDOWS 0x3
# endif

# if defined(SYSV4)
#  if !defined(__GNUC__)

	.text

	.align 4
	.type    __switchStack__,#function
	.type    __switchStackNo__,#function

	.globl  __switchStack__
	.globl  __switchStackNoFlush__
__switchStack__:
	ta      ST_FLUSH_WINDOWS
__switchStackNoFlush__:
	mov     %o0, %sp
	retl
	nop

	.globl  __getG1__
	.globl  __getG2__
	.globl  __getG3__
	.globl  __setG1__
	.globl  __setG2__
	.globl  __setG3__
	.type    __getG1__,#function
	.type    __getG2__,#function
	.type    __getG3__,#function
	.type    __setG1__,#function
	.type    __setG2__,#function
	.type    __setG3__,#function
__getG1__:
	retl
	mov     %g1, %o0

__getG2__:
	retl
	mov     %g2, %o0

__getG3__:
	retl
	mov     %g3, %o0

__setG1__:
	retl
	mov     %o0, %g1

__setG2__:
	retl
	mov     %o0, %g2

__setG3__:
	retl
	mov     %o0, %g3

#  endif /* not __GNUC__ */

	.text
	.globl  __flushInstructionMemory__
	.type   __flushInstructionMemory__,#function
__flushInstructionMemory__:
	iflush  %o0 + 0
	retl
	nop

/*
 * entry to c-function MKLARGEINT() to be called
 * from inline asm code. sigh: SYSV4 does not add an initial '_'
 * notice, when we arrive here, the value in o0 resulted from
 * an overflow when doing (val << 1) OP ((val2 << 1)+1)
 */
	.text
	.globl  __MKLARGEINTov
	.type   __MKLARGEINTov,#function

__MKLARGEINTov:
	bcs     1f
	srl     %o0, 1, %o0
#  ifdef ADDR___MKLARGEINT
	sethi   %hi(ADDR___MKLARGEINT), %g2
	ld      [%g2+%lo(ADDR___MKLARGEINT)], %g2
	jmp     %g2
#  else
	sethi   %hi(__MKLARGEINT), %g2
	jmp     %g2+%lo(__MKLARGEINT)
#  endif
	nop

1:
	sethi   %hi(0x80000000), %g2
	or      %o0, %g2, %o0
#  ifdef ADDR___MKLARGEINT
	sethi   %hi(ADDR___MKLARGEINT), %g2
	ld      [%g2+%lo(ADDR___MKLARGEINT)], %g2
	jmp     %g2
#  else
	sethi   %hi(__MKLARGEINT), %g2
	jmp     %g2+%lo(__MKLARGEINT)
#  endif
	nop


	.globl  __MKLARGEINTov_a
	.type   __MKLARGEINTov_a,#function

__MKLARGEINTov_a:
	bcs     1f
	srl     %o0, 1, %o0
#  ifdef ADDR___MKLARGEINT
	sethi   %hi(ADDR___MKLARGEINT), %g2
	ld      [%g2+%lo(ADDR___MKLARGEINT)], %g2
	jmp     %g2
#  else
	sethi   %hi(__MKLARGEINT), %g2
	jmp     %g2+%lo(__MKLARGEINT)
#  endif
	nop

1:
	sethi   %hi(0x80000000), %g2
#  ifdef ADDR___MKLARGEINT
	sethi   %hi(ADDR___MKLARGEINT), %g1
	ld      [%g1+%lo(ADDR___MKLARGEINT)], %g1
	jmp     %g1
#  else
	sethi   %hi(__MKLARGEINT), %g1
	jmp     %g1+%lo(__MKLARGEINT)
#  endif
	or      %o0, %g2, %o0


	.globl  __MKLARGEINTov_s
	.type   __MKLARGEINTov_s,#function
__MKLARGEINTov_s:
	bcc     1f
	srl     %o0, 1, %o0

#  ifdef ADDR___MKLARGEINT
	sethi   %hi(ADDR___MKLARGEINT), %g2
	ld      [%g2+%lo(ADDR___MKLARGEINT)], %g2
	jmp     %g2
#  else
	sethi   %hi(__MKLARGEINT), %g2
	jmp     %g2+%lo(__MKLARGEINT)
#  endif
	nop

1:
	sethi   %hi(0x80000000), %g2
#  ifdef ADDR___MKLARGEINT
	sethi   %hi(ADDR___MKLARGEINT), %g1
	ld      [%g1+%lo(ADDR___MKLARGEINT)], %g1
	jmp     %g1
#  else
	sethi   %hi(__MKLARGEINT), %g1
	jmp     %g1+%lo(__MKLARGEINT)
#  endif
	or      %o0, %g2, %o0


__flushRegisterWindows:
	ta      ST_FLUSH_WINDOWS
	retl
	nop
/*
 * jmo_buf is: 4-onsstack, 8-sigmask, c-sp, 10-pc, 14-npc, 18-psr, 1c-g1, 20-o0, 24-wbcnt (sigcontext).
 * since -in our case- onstack, sigmask, o0 and wbcnt are always 0, dont store
 * them
 */

/*
 * WARNING - NEW_SETJMP requires change in mcompiler.c's
 * stack-setup code generation.
 */
#ifdef sunos
# define OLD_SETJMP
#endif
#define OLD_SETJMP

	.text
#ifdef solaris
	.globl  setjmp
	.type   setjmp,#function
setjmp:
#endif
	.globl  _setjmp
	.type   _setjmp,#function
_setjmp:
#ifdef OLD_SETJMP
/*        st      %g0, [%o0]       */
/*        st      %g0, [%o0 + 0x4] */
	st      %sp, [%o0 + 0x8]
	add     %o7, 0x8, %g1
	st      %g1, [%o0 + 0xc]
	add     %g1, 0x4, %g1
	st      %g1, [%o0 + 0x10]
/*        st      %g0, [%o0 + 0x14] */
# ifdef OLD
	st      %g0, [%o0 + 0x18]
# endif
	jmp     %o7 + 0x8
	clr     %o0
#else /* NEW_SETJMP */
	clr  [ %o0 ]
	st  %sp, [ %o0 + 4 ]
	add  %o7, 8, %o1
	st  %o1, [ %o0 + 8 ]
	st  %fp, [ %o0 + 0xc ]
	st  %i7, [ %o0 + 0x10 ]
	retl
	mov  %g0, %o0
#endif

#ifdef solaris
	.globl  longjmp
	.type   longjmp,#function
longjmp:
#endif
	.globl  _longjmp
	.type   _longjmp,#function
_longjmp:
#ifdef OLD_SETJMP
	ta      ST_FLUSH_WINDOWS
	sub     %sp, 0x40, %sp
	ld      [%o0 + 0x8], %fp
	ld      [%o0 + 0xc], %g1
	orcc    %g0, %o1, %g0
	bne     __skip
	sub     %g1, 0x8, %o7
	mov     0x1, %o1
__skip: jmp     %o7 + 0x8
	restore %o1, 0x0, %o0
#else /* NEW_SETJMP */
	ta      ST_FLUSH_WINDOWS
	ld  [ %o0 + 4 ], %o2
	ldd  [ %o2 ], %l0
	ldd  [ %o2 + 8 ], %l2
	ldd  [ %o2 + 0x10 ], %l4
	ldd  [ %o2 + 0x18 ], %l6
	ldd  [ %o2 + 0x20 ], %i0
	ldd  [ %o2 + 0x28 ], %i2
	ldd  [ %o2 + 0x30 ], %i4
	ld  [ %o0 + 0xc ], %fp
	mov  %o2, %sp
	ld  [ %o0 + 0x10 ], %i7
	ld  [ %o0 + 8 ], %o3
	tst  %o1
	bne  __skip
	sub  %o3, 8, %o7
	mov  1, %o1
__skip:
	retl
	mov  %o1, %o0
#endif

#ifdef solaris
	.globl  longrestart
	.type   _longrestart,#function
longrestart:
#endif
	.globl  _longrestart
	.type   _longrestart,#function
_longrestart:
#ifdef OLD_SETJMP
	ta      ST_FLUSH_WINDOWS
	sub     %sp, 0x40, %sp
	ld      [%o0 + 0x8], %fp
	ld      [%o0 + 0xc], %g1
	sub     %g1, 0x8, %o7
	mov     0, %o1
	jmp     %o7 + 0x8
	restore %o1, 0x0, %o0
#else /* NEW_SETJMP */
	ta      ST_FLUSH_WINDOWS
	ld  [ %o0 + 4 ], %o2
	ldd  [ %o2 ], %l0
	ldd  [ %o2 + 8 ], %l2
	ldd  [ %o2 + 0x10 ], %l4
	ldd  [ %o2 + 0x18 ], %l6
	ldd  [ %o2 + 0x20 ], %i0
	ldd  [ %o2 + 0x28 ], %i2
	ldd  [ %o2 + 0x30 ], %i4
	ld  [ %o0 + 0xc ], %fp
	mov  %o2, %sp
	ld  [ %o0 + 0x10 ], %i7
	ld  [ %o0 + 8 ], %o3
	retl
	mov  %o1, %o0
#endif


	.globl  __retTrue
	.globl  __retFalse
	.globl  __retNil
	.globl  __ret0


#       define ENTRY_OP
#ifdef __FIXBASE__
#       define OPERATION1       sethi   %hi(trueStruct),%o0
#       define OPERATION2       or      %o0,%lo(trueStruct),%o0
#else
#       define OPERATION1       sethi   %hi(true),%g2
#       define OPERATION2       ld      [%g2+%lo(true)],%o0
#endif
#       define LABEL            __retTrue
#       define RESEND           _SEND0
#       define ADDR_RESEND      ADDR__SEND0
#       include "codeEntry.h"

#       define ENTRY_OP
#ifdef __FIXBASE__
#       define OPERATION1       sethi   %hi(falseStruct),%o0
#       define OPERATION2       or      %o0,%lo(falseStruct),%o0
#else
#       define OPERATION1       sethi   %hi(false),%g2
#       define OPERATION2       ld      [%g2+%lo(false)],%o0
#endif
#       define LABEL            __retFalse
#       define RESEND           _SEND0
#       define ADDR_RESEND      ADDR__SEND0
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       mov %g0,%o0
#       define LABEL            __retNil
#       define RESEND           _SEND0
#       define ADDR_RESEND      ADDR__SEND0
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       or      %g0, 1, %o0
#       define LABEL            __ret0
#       define RESEND           _SEND0
#       define ADDR_RESEND      ADDR__SEND0
#       include "codeEntry.h"

	.globl  __bRetTrue
	.globl  __bRetFalse
	.globl  __bRetNil
	.globl  __bRet0

__bRetTrue:
	sethi   %hi(true),%g2
	retl
	ld      [%g2+%lo(true)],%o0

__bRetFalse:
	sethi   %hi(false),%g2
	retl
	ld      [%g2+%lo(false)],%o0

__bRetNil:
	retl
	mov     %g0, %o0

__bRet0:
	retl
	or      %g0, 1, %o0

	.globl  __retSelf

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       nop
#       define LABEL            __retSelf
#       define RESEND           _SEND0
#       define ADDR_RESEND      ADDR__SEND0
#       include "codeEntry.h"

	.globl  __retSelf1
	.globl  __retSelf2
	.globl  __retSelf3

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       nop
#       define LABEL            __retSelf1
#       define RESEND           _SEND1
#       define ADDR_RESEND      ADDR__SEND1
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       nop
#       define LABEL            __retSelf2
#       define RESEND           _SEND2
#       define ADDR_RESEND      ADDR__SEND2
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       nop
#       define LABEL            __retSelf3
#       define RESEND           _SEND3
#       define ADDR_RESEND      ADDR__SEND3
#       include "codeEntry.h"


	.globl  __retArg1_0
#       define QUICKENTRY_OP
#       define  OPERATION       mov %o4, %o0
#       include "codeEntry.h"
__retArg1_0:
#       define ENTRY1
#       include "codeEntry.h"
	retl
	mov     %o4, %o0

	.globl  __retArg2_0
#       define QUICKENTRY_OP
#       define  OPERATION       mov %o4, %o0
#       include "codeEntry.h"
__retArg2_0:
#       define ENTRY2
#       include "codeEntry.h"
	retl
	mov     %o4, %o0

	.globl  __retArg2_1
#       define QUICKENTRY_OP
#       define  OPERATION       mov %o5, %o0
#       include "codeEntry.h"
__retArg2_1:
#       define ENTRY2
#       include "codeEntry.h"
	retl
	mov     %o5, %o0

#       define LABEL    __retInst0
#       define OFFSET   12
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst1
#       define OFFSET   16
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst2
#       define OFFSET   20
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst3
#       define OFFSET   24
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst4
#       define OFFSET   28
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst5
#       define OFFSET   32
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst6
#       define OFFSET   36
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst7
#       define OFFSET   40
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst8
#       define OFFSET   44
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst9
#       define OFFSET   48
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst10
#       define OFFSET   52
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst11
#       define OFFSET   56
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst12
#       define OFFSET   60
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst13
#       define OFFSET   64
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst14
#       define OFFSET   68
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst15
#       define OFFSET   72
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst16
#       define OFFSET   76
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst17
#       define OFFSET   80
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst18
#       define OFFSET   84
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst19
#       define OFFSET   88
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst20
#       define OFFSET   92
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst21
#       define OFFSET   96
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst22
#       define OFFSET   100
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst23
#       define OFFSET   104
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst24
#       define OFFSET   108
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst25
#       define OFFSET   112
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst26
#       define OFFSET   116
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst27
#       define OFFSET   120
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst28
#       define OFFSET   124
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst29
#       define OFFSET   128
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst30
#       define OFFSET   132
#       define RETINST
#       include "codeEntry.h"


#       define LABEL    __setInst0
#       define OFFSET   12
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst1
#       define OFFSET   16
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst2
#       define OFFSET   20
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst3
#       define OFFSET   24
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst4
#       define OFFSET   28
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst5
#       define OFFSET   32
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst6
#       define OFFSET   36
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst7
#       define OFFSET   40
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst8
#       define OFFSET   44
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst9
#       define OFFSET   48
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst10
#       define OFFSET   52
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst11
#       define OFFSET   56
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst12
#       define OFFSET   60
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst13
#       define OFFSET   64
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst14
#       define OFFSET   68
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst15
#       define OFFSET   72
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst16
#       define OFFSET   76
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst17
#       define OFFSET   80
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst18
#       define OFFSET   84
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst19
#       define OFFSET   88
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst20
#       define OFFSET   92
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst21
#       define OFFSET   96
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst22
#       define OFFSET   100
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst23
#       define OFFSET   104
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst24
#       define OFFSET   108
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst25
#       define OFFSET   112
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst26
#       define OFFSET   116
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst27
#       define OFFSET   120
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst28
#       define OFFSET   124
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst29
#       define OFFSET   128
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    __setInst30
#       define OFFSET   132
#       define SETINST
#       include "codeEntry.h"

/*
 * code saver: ilc-miss check prolog
 *
 * to be called via
 *   mov  %o7,%g1
 *   call __ILCCHECK__
 * before method is entered
 * this code is for NonNil-nonSmallInt classes only
 *
 * entry: o0 receiver
 *        o1 selector
 *        o2 searchclass
 *        o3 pIlc
 *        o4.. args
 *        g1 original return addr
 *
 * normally, this code is inlined into the method, but
 * when compiled with +optspace, a call to this function
 * is generated instead.
 */

#       define  ILC_LABEL       __ILC_CHECK0__
#       define  ILC_LABEL_s     __ILC_CHECK0s__
#       define  POLY_LABEL      __POLY_CHECK0__
#       define  SEND_MISS       _SEND0
#       define  ADDR_SEND_MISS  ADDR__SEND0
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK1__
#       define  ILC_LABEL_s     __ILC_CHECK1s__
#       define  POLY_LABEL      __POLY_CHECK1__
#       define  SEND_MISS       _SEND1
#       define  ADDR_SEND_MISS  ADDR__SEND1
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK2__
#       define  ILC_LABEL_s     __ILC_CHECK2s__
#       define  POLY_LABEL      __POLY_CHECK2__
#       define  SEND_MISS       _SEND2
#       define  ADDR_SEND_MISS  ADDR__SEND2
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK3__
#       define  ILC_LABEL_s     __ILC_CHECK3s__
#       define  POLY_LABEL      __POLY_CHECK3__
#       define  SEND_MISS       _SEND3
#       define  ADDR_SEND_MISS  ADDR__SEND3
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK4__
#       define  ILC_LABEL_s     __ILC_CHECK4s__
#       define  POLY_LABEL      __POLY_CHECK4__
#       define  SEND_MISS       _SEND4
#       define  ADDR_SEND_MISS  ADDR__SEND4
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK5__
#       define  ILC_LABEL_s     __ILC_CHECK5s__
#       define  POLY_LABEL      __POLY_CHECK5__
#       define  SEND_MISS       _SEND5
#       define  ADDR_SEND_MISS  ADDR__SEND5
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK6__
#       define  ILC_LABEL_s     __ILC_CHECK6s__
#       define  POLY_LABEL      __POLY_CHECK6__
#       define  SEND_MISS       _SEND6
#       define  ADDR_SEND_MISS  ADDR__SEND6
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK7__
#       define  ILC_LABEL_s     __ILC_CHECK7s__
#       define  POLY_LABEL      __POLY_CHECK7__
#       define  SEND_MISS       _SEND7
#       define  ADDR_SEND_MISS  ADDR__SEND7
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK8__
#       define  ILC_LABEL_s     __ILC_CHECK8s__
#       define  POLY_LABEL      __POLY_CHECK8__
#       define  SEND_MISS       _SEND8
#       define  ADDR_SEND_MISS  ADDR__SEND8
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK9__
#       define  ILC_LABEL_s     __ILC_CHECK9s__
#       define  POLY_LABEL      __POLY_CHECK9__
#       define  SEND_MISS       _SEND9
#       define  ADDR_SEND_MISS  ADDR__SEND9
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK10__
#       define  ILC_LABEL_s     __ILC_CHECK10s__
#       define  POLY_LABEL      __POLY_CHECK10__
#       define  SEND_MISS       _SEND10
#       define  ADDR_SEND_MISS  ADDR__SEND10
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK11__
#       define  ILC_LABEL_s     __ILC_CHECK11s__
#       define  POLY_LABEL      __POLY_CHECK11__
#       define  SEND_MISS       _SEND11
#       define  ADDR_SEND_MISS  ADDR__SEND11
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK12__
#       define  ILC_LABEL_s     __ILC_CHECK12s__
#       define  POLY_LABEL      __POLY_CHECK12__
#       define  SEND_MISS       _SEND12
#       define  ADDR_SEND_MISS  ADDR__SEND12
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK13__
#       define  ILC_LABEL_s     __ILC_CHECK13s__
#       define  POLY_LABEL      __POLY_CHECK13__
#       define  SEND_MISS       _SEND13
#       define  ADDR_SEND_MISS  ADDR__SEND13
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK14__
#       define  ILC_LABEL_s     __ILC_CHECK14s__
#       define  POLY_LABEL      __POLY_CHECK14__
#       define  SEND_MISS       _SEND14
#       define  ADDR_SEND_MISS  ADDR__SEND14
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       __ILC_CHECK15__
#       define  ILC_LABEL_s     __ILC_CHECK15s__
#       define  POLY_LABEL      __POLY_CHECK15__
#       define  SEND_MISS       _SEND15
#       define  ADDR_SEND_MISS  ADDR__SEND15
#       define  ILCCHECK
#       include "codeEntry.h"

# else /* not SYSV4 */

#  ifdef ADDR_true
#   define _true              ADDR_true
#   define _false             ADDR_false
#   define _SmallInteger      ADDR_SmallInteger
#   define _UndefinedObject   ADDR_UndefinedObject
#   define _Float             ADDR_Float
#   define _trueStruct        ADDR_trueStruct
#   define _falseStruct       ADDR_falseStruct
#   define ___newEndPtr       ADDR___newEndPtr__
#   define ___newNextPtr      ADDR___newNextPtr__
#   define ___newSpace        ADDR___newSpace__
#   define ___stackBottom__   ADDR___stackBottom__
#  endif

#  if !defined(__GNUC__)

	.globl  ___switchStack__
___switchStack__:
	ta      ST_FLUSH_WINDOWS
	mov     %o0, %sp
	retl
	nop

	.globl  ___getG1__
	.globl  ___getG2__
	.globl  ___getG3__
	.globl  ___setG1__
	.globl  ___setG2__
	.globl  ___setG3__
___getG1__:
	retl
	mov     %g1, %o0

___getG2__:
	retl
	mov     %g2, %o0

___getG3__:
	retl
	mov     %g3, %o0

___setG1__:
	retl
	mov     %o0, %g1

___setG2__:
	retl
	mov     %o0, %g2

___setG3__:
	retl
	mov     %o0, %g3


#  ifdef PROCESS_C_COMPILED_WITH_CC
	/*
	 * this is only req'd if process.c is
	 * not compiled with gcc
	 * (but it is in all configurations)
	 */
	.globl ___ySTACK_HANDLER__
	.globl ___STACK_HANDLER__
	.globl ___argSav__
	.globl ___pArgsAbove6__
___ySTACK_HANDLER__:
	mov %g1,%g3
	mov %o7,%g1
	add %g1, 8, %g1
	mov %g3,%o7

	sethi %hi(___argSav__),%g2
	or %g2,%lo(___argSav__),%g2

	st %o0, [%g2+0]         /* a1 */
	st %o1, [%g2+4]         /* a2 */
	st %o2, [%g2+8]         /* a3 */
	st %o3, [%g2+12]        /* a4 */
	st %o4, [%g2+16]        /* a5 */
	st %o5, [%g2+20]        /* a6 */

	add %sp, 92, %o0        /* addr of a9 */
	sethi %hi(___pArgsAbove6__),%g2
	st %o0, [%g2+%lo(___pArgsAbove6__)]

	b  ___STACK_HANDLER__
	mov %g1,%o0
#  endif /* PROCESS_C_COMPILED_WITH_CC */

# endif /* not GNUC */

	.globl ___flushInstructionMemory__
___flushInstructionMemory__:
	iflush   %o0 + 0
	retl
	nop

/*
 * backward compatibilty; will vanish
 * (_MKLARGEINT has been renamed to __MKLARGEINT)
 */
	.globl  ___MKLARGEINT
	.globl  __MKLARGEINT
__MKLARGEINT:
	sethi   %hi(___MKLARGEINT), %g2
	jmp     %g2+%lo(___MKLARGEINT)
	nop

#ifdef NO_LONGER_NEEDED
	.globl  MKLARGEINT
MKLARGEINT:
	save %sp,-112,%sp

	mov     %g2, %o0
	call    ___MKLARGEINT, 0
	mov     %o0, %g2
	ret
	restore
#endif

	.globl  __MKLARGEINTov
__MKLARGEINTov:
	bcs     1f
	srl     %o0, 1, %o0
	sethi   %hi(___MKLARGEINT), %g2
	jmp     %g2+%lo(___MKLARGEINT)
	nop

1:
	sethi   %hi(0x80000000), %g2
	or      %o0, %g2, %o0
	sethi   %hi(___MKLARGEINT), %g2
	jmp     %g2+%lo(___MKLARGEINT)
	nop


	.globl  __MKLARGEINTov_a
__MKLARGEINTov_a:
	bcs     1f
	srl     %o0, 1, %o0
	sethi   %hi(___MKLARGEINT), %g2
	jmp     %g2+%lo(___MKLARGEINT)
	nop

1:
	sethi   %hi(0x80000000), %g2
	or      %o0, %g2, %o0
	sethi   %hi(___MKLARGEINT), %g2
	jmp     %g2+%lo(___MKLARGEINT)
	nop


	.globl  __MKLARGEINTov_s
__MKLARGEINTov_s:
	bcc     1f
	srl     %o0, 1, %o0
	sethi   %hi(___MKLARGEINT), %g2
	jmp     %g2+%lo(___MKLARGEINT)
	nop

1:
	sethi   %hi(0x80000000), %g2
	or      %o0, %g2, %o0
	sethi   %hi(___MKLARGEINT), %g2
	jmp     %g2+%lo(___MKLARGEINT)
	nop


	.globl ___flushRegisterWindows
___flushRegisterWindows:
__flushRegisterWindows:
	ta      ST_FLUSH_WINDOWS
	retl
	nop

# ifdef sunos
/*
 * jmo_buf is: 4-onsstack, 8-sigmask, c-sp, 10-pc, 14-npc, 18-psr, 1c-g1, 20-o0, 24-wbcnt (sigcontext).
 * since -in our case- onstack, sigmask, o0 and wbcnt are always 0, dont store
 * them
 */
	.globl  __setjmp
__setjmp:
/*        st      %g0, [%o0]       */
/*        st      %g0, [%o0 + 0x4] */
	st      %sp, [%o0 + 0x8]
	add     %o7, 0x8, %g1
	st      %g1, [%o0 + 0xc]
	add     %g1, 0x4, %g1
	st      %g1, [%o0 + 0x10]
/*        st      %g0, [%o0 + 0x14] */
#ifdef OLD
	st      %g0, [%o0 + 0x18]
#endif
	jmp     %o7 + 0x8
	clr     %o0

	.globl  __longjmp
__longjmp:
	ta      ST_FLUSH_WINDOWS
	sub     %sp, 0x40, %sp
	ld      [%o0 + 0x8], %fp
	ld      [%o0 + 0xc], %g1
	orcc    %g0, %o1, %g0
	bne     __skip
	sub     %g1, 0x8, %o7
	mov     0x1, %o1
__skip: jmp     %o7 + 0x8
	restore %o1, 0x0, %o0

	.globl  __longrestart
__longrestart:
	ta      ST_FLUSH_WINDOWS
	sub     %sp, 0x40, %sp
	ld      [%o0 + 0x8], %fp
	ld      [%o0 + 0xc], %g1
	sub     %g1, 0x8, %o7
	mov     0, %o1
	jmp     %o7 + 0x8
	restore %o1, 0x0, %o0

# endif /* sunos */

	.globl  ___retTrue
	.globl  ___retFalse
	.globl  ___retNil
	.globl  ___ret0

#       define ENTRY_OP
#       define OPERATION1       sethi   %hi(_true),%g2
#       define OPERATION2       ld      [%g2+%lo(_true)],%o0
#       define LABEL            ___retTrue
#       define RESEND           __SEND0
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       sethi   %hi(_false),%g2
#       define OPERATION2       ld      [%g2+%lo(_false)],%o0
#       define LABEL            ___retFalse
#       define RESEND           __SEND0
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       mov %g0,%o0
#       define LABEL            ___retNil
#       define RESEND           __SEND0
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       or      %g0, 1, %o0
#       define LABEL            ___ret0
#       define RESEND           __SEND0
#       include "codeEntry.h"

	.globl  ___bRetTrue
	.globl  ___bRetFalse
	.globl  ___bRetNil
	.globl  ___bRet0

___bRetTrue:
	sethi   %hi(_true),%g2
	retl
	ld      [%g2+%lo(_true)],%o0

___bRetFalse:
	sethi   %hi(_false),%g2
	retl
	ld      [%g2+%lo(_false)],%o0

___bRetNil:
	retl
	mov     %g0, %o0

___bRet0:
	retl
	or      %g0, 1, %o0

	.globl  ___retSelf

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       nop
#       define LABEL            ___retSelf
#       define RESEND           __SEND0
#       include "codeEntry.h"

	.globl  ___retSelf1
	.globl  ___retSelf2
	.globl  ___retSelf3

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       nop
#       define LABEL            ___retSelf1
#       define RESEND           __SEND1
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       nop
#       define LABEL            ___retSelf2
#       define RESEND           __SEND2
#       include "codeEntry.h"

#       define ENTRY_OP
#       define OPERATION1       ;
#       define OPERATION2       nop
#       define LABEL            ___retSelf3
#       define RESEND           __SEND3
#       include "codeEntry.h"


	.globl  ___retArg1_0
#       define QUICKENTRY_OP
#       define  OPERATION       mov %o4, %o0
#       include "codeEntry.h"
___retArg1_0:
#       define ENTRY1
#       include "codeEntry.h"
	retl
	mov     %o4, %o0

	.globl  ___retArg2_0
#       define QUICKENTRY_OP
#       define  OPERATION       mov %o4, %o0
#       include "codeEntry.h"
___retArg2_0:
#       define ENTRY2
#       include "codeEntry.h"
	retl
	mov     %o4, %o0

	.globl  ___retArg2_1
#       define QUICKENTRY_OP
#       define  OPERATION       mov %o5, %o0
#       include "codeEntry.h"
___retArg2_1:
#       define ENTRY2
#       include "codeEntry.h"
	retl
	mov     %o5, %o0

#       define LABEL    ___retInst0
#       define OFFSET   12
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst1
#       define OFFSET   16
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst2
#       define OFFSET   20
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst3
#       define OFFSET   24
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst4
#       define OFFSET   28
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst5
#       define OFFSET   32
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst6
#       define OFFSET   36
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst7
#       define OFFSET   40
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst8
#       define OFFSET   44
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst9
#       define OFFSET   48
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst10
#       define OFFSET   52
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst11
#       define OFFSET   56
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst12
#       define OFFSET   60
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst13
#       define OFFSET   64
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst14
#       define OFFSET   68
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst15
#       define OFFSET   72
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst16
#       define OFFSET   76
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst17
#       define OFFSET   80
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst18
#       define OFFSET   84
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst19
#       define OFFSET   88
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst20
#       define OFFSET   92
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst21
#       define OFFSET   96
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst22
#       define OFFSET   100
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst23
#       define OFFSET   104
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst24
#       define OFFSET   108
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst25
#       define OFFSET   112
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst26
#       define OFFSET   116
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst27
#       define OFFSET   120
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst28
#       define OFFSET   124
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst29
#       define OFFSET   128
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    ___retInst30
#       define OFFSET   132
#       define RETINST
#       include "codeEntry.h"


#       define LABEL    ___setInst0
#       define OFFSET   12
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst1
#       define OFFSET   16
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst2
#       define OFFSET   20
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst3
#       define OFFSET   24
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst4
#       define OFFSET   28
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst5
#       define OFFSET   32
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst6
#       define OFFSET   36
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst7
#       define OFFSET   40
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst8
#       define OFFSET   44
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst9
#       define OFFSET   48
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst10
#       define OFFSET   52
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst11
#       define OFFSET   56
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst12
#       define OFFSET   60
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst13
#       define OFFSET   64
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst14
#       define OFFSET   68
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst15
#       define OFFSET   72
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst16
#       define OFFSET   76
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst17
#       define OFFSET   80
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst18
#       define OFFSET   84
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst19
#       define OFFSET   88
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst20
#       define OFFSET   92
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst21
#       define OFFSET   96
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst22
#       define OFFSET   100
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst23
#       define OFFSET   104
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst24
#       define OFFSET   108
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst25
#       define OFFSET   112
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst26
#       define OFFSET   116
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst27
#       define OFFSET   120
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst28
#       define OFFSET   124
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst29
#       define OFFSET   128
#       define SETINST
#       include "codeEntry.h"

#       define LABEL    ___setInst30
#       define OFFSET   132
#       define SETINST
#       include "codeEntry.h"

/*
 * code saver: ilc-miss check prolog
 *
 * to be called via
 *   mov  %o7,%g1
 *   call __ILCCHECK__
 * before method is entered
 * this code is for NonNil-nonSmallInt classes only
 *
 * entry: o0 receiver
 *        o1 selector
 *        o2 searchclass
 *        o3 pIlc
 *        o4.. args
 *        g1 original return addr
 *
 * normally, this code is inlined into the method, but
 * when compiled with +optspace, a call to this function
 * is generated instead.
 */

#       define  ILC_LABEL       ___ILC_CHECK0__
#       define  ILC_LABEL_s     ___ILC_CHECK0s__
#       define  POLY_LABEL      ___POLY_CHECK0__
#       define  SEND_MISS       __SEND0
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK1__
#       define  ILC_LABEL_s     ___ILC_CHECK1s__
#       define  POLY_LABEL      ___POLY_CHECK1__
#       define  SEND_MISS       __SEND1
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK2__
#       define  ILC_LABEL_s     ___ILC_CHECK2s__
#       define  POLY_LABEL      ___POLY_CHECK2__
#       define  SEND_MISS       __SEND2
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK3__
#       define  ILC_LABEL_s     ___ILC_CHECK3s__
#       define  POLY_LABEL      ___POLY_CHECK3__
#       define  SEND_MISS       __SEND3
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK4__
#       define  ILC_LABEL_s     ___ILC_CHECK4s__
#       define  POLY_LABEL      ___POLY_CHECK4__
#       define  SEND_MISS       __SEND4
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK5__
#       define  ILC_LABEL_s     ___ILC_CHECK5s__
#       define  POLY_LABEL      ___POLY_CHECK5__
#       define  SEND_MISS       __SEND5
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK6__
#       define  ILC_LABEL_s     ___ILC_CHECK6s__
#       define  POLY_LABEL      ___POLY_CHECK6__
#       define  SEND_MISS       __SEND6
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK7__
#       define  ILC_LABEL_s     ___ILC_CHECK7s__
#       define  POLY_LABEL      ___POLY_CHECK7__
#       define  SEND_MISS       __SEND7
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK8__
#       define  ILC_LABEL_s     ___ILC_CHECK8s__
#       define  POLY_LABEL      ___POLY_CHECK8__
#       define  SEND_MISS       __SEND8
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK9__
#       define  ILC_LABEL_s     ___ILC_CHECK9s__
#       define  POLY_LABEL      ___POLY_CHECK9__
#       define  SEND_MISS       __SEND9
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK10__
#       define  ILC_LABEL_s     ___ILC_CHECK10s__
#       define  POLY_LABEL      ___POLY_CHECK10__
#       define  SEND_MISS       __SEND10
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK11__
#       define  ILC_LABEL_s     ___ILC_CHECK11s__
#       define  POLY_LABEL      ___POLY_CHECK11__
#       define  SEND_MISS       __SEND11
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK12__
#       define  ILC_LABEL_s     ___ILC_CHECK12s__
#       define  POLY_LABEL      ___POLY_CHECK12__
#       define  SEND_MISS       __SEND12
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK13__
#       define  ILC_LABEL_s     ___ILC_CHECK13s__
#       define  POLY_LABEL      ___POLY_CHECK13__
#       define  SEND_MISS       __SEND13
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK14__
#       define  ILC_LABEL_s     ___ILC_CHECK14s__
#       define  POLY_LABEL      ___POLY_CHECK14__
#       define  SEND_MISS       __SEND14
#       define  ILCCHECK
#       include "codeEntry.h"

#       define  ILC_LABEL       ___ILC_CHECK15__
#       define  ILC_LABEL_s     ___ILC_CHECK15s__
#       define  POLY_LABEL      ___POLY_CHECK15__
#       define  SEND_MISS       __SEND15
#       define  ILCCHECK
#       include "codeEntry.h"

# endif /* SYSV4 */

#endif /* sparc */

/*------------------------------------------------------------------
 *
 * MACHINE: mips
 *
 *------------------------------------------------------------------*/
#ifdef __mips__

# ifndef RECEIVER
#  define       RECEIVER        $4
#  define       SELECTOR        $5
#  define       SRCHCLASS       $6
#  define       PILC            $7
#  define       RETVAL          $2
# endif

	.text

# ifdef IRIX5
	.globl  __switchStackAndJump__
	.align 5
__switchStackAndJump__:
	.set noreorder
	move    $sp, $4
	move    $25, $5
	j       $25
	move    $4, $6
	.set reorder

# else /* IRIX4, PCS or Ultrix */
	.globl  __switchStack__
	.align 5
__switchStack__:
	.set noreorder
	move    $sp, $4
	j       $31
	nop
	.set reorder
# endif /* IRIX5 */

#ifdef NO_ASM
/* # define NO_ASM_BRET_0 */
/* # define NO_ASM_BRET_NIL */
/* # define NO_ASM_BRET_TRUE */
/* # define NO_ASM_BRET_FALSE */
/* # define NO_ASM_RET_INST */
/* # define NO_ASM_RET_SELF */
/* # define NO_ASM_RET_NIL */
/* # define NO_ASM_RET_TRUE */
/* # define NO_ASM_RET_FALSE */
#endif

/*
 * fetch pilc->class early, to avoid pipeline stall
 * On Indy (without secondary cache) this speeds up
 *     send from 1800ns to 900ns
 *     send0 from 1280ns to 300ns
 * i.e. saves about 900ns (obviously there is a cache miss here)
 * (even with a cache hit, this avoids a pipeline stall)
 */
#define PRE_FETCH

#ifdef IRIX5
# define TMP1 $2
# define TMP2 $3
# define PRE_FETCH_V2
#else
# define TMP1 $2
# define TMP2 $14
#endif

	.text

#ifndef NO_ASM_RET_SELF
	.globl  __retSelf
	.align 5

# ifndef IRIX5
#  ifndef PRE_FETCH
	.word   2f              /* checked */
	.word   9f              /* realobject receiver */
	.word   __CODE_MAGIC__
#  endif
# endif

__retSelf:
# ifdef IRIX5
	.set     noreorder
	.cpload $25
	.set     reorder
# endif
# ifdef PRE_FETCH
#  ifdef PRE_FETCH_V2
	lw      TMP2, 4(PILC)          /* pilc->ilc_class */
	ble     RECEIVER, 0, 3f     /* if receiver <= 0 */
	lw      TMP1, 0(RECEIVER)    /* fetch class */
	bne     SRCHCLASS, 0, 2f    /* if searchclass ~~ nil */
	bne     TMP1, TMP2, callSend0 /* if class ~~ ilc_class */
#  else
	bne     SRCHCLASS, 0, 2f    /* if searchclass ~~ nil */
	lw      TMP2, 4(PILC)          /* pilc->ilc_class */
	ble     RECEIVER, 0, 3f     /* if receiver <= 0 */
9:
	lw      TMP1, 0(RECEIVER)    /* fetch class */
	bne     TMP1, TMP2, callSend0 /* if class ~~ ilc_class */
#  endif /* PRE_FETCH_V2 */
2:
	move    RETVAL, RECEIVER    /* return receiver */
	j       $31
3:
#  ifdef PRE_FETCH_V2
	bne     SRCHCLASS, 0, 2b
#  endif
	beq     RECEIVER, 0, 4f     /* if receiver is nil */
#if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#else
	lw      TMP1, SmallInteger   /* ilc_class == SmallInteger ? */
#endif
	bne     TMP1, TMP2, callSend0 /* if class ~~ ilc_class */
	move    RETVAL, RECEIVER    /* return receiver */
	j       $31
4:
#if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#else
	lw      TMP1, UndefinedObject/* ilc_class == UndefinedObject ? */
#endif
	bne     TMP1, TMP2, callSend0 /* if class ~~ ilc_class */
	move    RETVAL, RECEIVER    /* return receiver */
	j       $31

# else
	bne     SRCHCLASS, 0, 2f    /* if searchclass ~~ nil */
	ble     RECEIVER, 0, 3f     /* if receiver <= 0 */
9:
	lw      TMP1, 0(RECEIVER)    /* fetch class */
	lw      TMP2, 4(PILC)          /* fetch pilc->ilc_class */
	bne     TMP1, TMP2, callSend0  /* if class ~~ ilc_class */
2:
	move    RETVAL, RECEIVER    /* return receiver */
	j       $31
3:
	lw      TMP2, 4(PILC)          /* fetch pilc->ilc_class */
#  ifdef NIL_FIRST
	bne     RECEIVER, 0, 4f      /* if receiver non-nil */
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject /* ilc_class == UndefinedObject ? */
#   endif
	bne     TMP1, TMP2, callSend0  /* if ~~ */
	move    RETVAL, RECEIVER     /* return receiver */
	j       $31
4:
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger    /* ilc_class == SmallInteger ? */
#   endif
	bne     TMP1, TMP2, callSend0  /* if ~~ */
	move    RETVAL, RECEIVER     /* return receiver */
	j       $31
#  else
	beq     RECEIVER, 0, 4f      /* if receiver is nil */
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger    /* ilc_class == SmallInteger ? */
#   endif
	bne     TMP1, TMP2, callSend0  /* if ~~ */
	move    RETVAL, RECEIVER    /* return receiver */
	j       $31
4:
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject /* ilc_class == UndefinedObject ? */
#   endif
	bne     TMP1, TMP2, callSend0  /* if ~~ */
	move    RETVAL, RECEIVER    /* return receiver */
	j       $31
#  endif /* NIL_FIRST */
# endif /* PRE_FETCH */
#endif /* NO_ASM_RETSELF */

	.align 5
callSend0:
#ifdef IRIX5
	la      $25, _SEND0
	j       $25
#else
	j       _SEND0
#endif


#ifndef NO_ASM_BRET_0
	.align 5
	.globl  __bRet0
__bRet0:
	li      RETVAL, 0x80000000
	j       $31
#endif /* NO_ASM_BRET_0 */


#ifndef NO_ASM_BRET_NIL
	.globl  __bRetNil
	.align 5
__bRetNil:
#ifdef NOTDEF
# ifdef IRIX5
	.set     noreorder
	.cpload $25
	.set     reorder
# endif
#endif
	move    RETVAL, $0
	j       $31
#endif /* NO_ASM_BRET_NIL */


#ifndef NO_ASM_RET_NIL
	.globl  __retNil
	.align 5
# ifndef IRIX5
#  ifndef PRE_FETCH
	.word   2f              /* checked */
	.word   9f              /* realobject receiver */
	.word   __CODE_MAGIC__
#  endif
# endif

__retNil:
# ifdef IRIX5
	.set     noreorder
	.cpload $25
	.set     reorder
# endif
# ifdef PRE_FETCH
	lw      TMP2, 4(PILC)
	bne     SRCHCLASS, 0, 2f
	ble     RECEIVER, 0, 3f
9:
	lw      TMP1, 0(RECEIVER)
	bne     TMP1, TMP2, callSend0
2:
	move    RETVAL, $0
	j       $31
3:
	bne     RECEIVER, 0, 4f
#  if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#  else
	lw      TMP1, UndefinedObject
#  endif
	bne     TMP1, TMP2, callSend0
	move    RETVAL, $0
	j       $31
4:
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
	move    RETVAL, $0
	j       $31
# else
	bne     SRCHCLASS, 0, 2f
	ble     RECEIVER, 0, 3f
9:
	lw      TMP1, 0(RECEIVER)
	lw      TMP2, 4(PILC)
	bne     TMP1, TMP2, callSend0
2:
	move    RETVAL, $0
	j       $31
3:
	lw      TMP2, 4(PILC)
	bne     RECEIVER, 0, 4f
#  if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#  else
	lw      TMP1, UndefinedObject
#  endif
	bne     TMP1, TMP2, callSend0
	move    RETVAL, $0
	j       $31
4:
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
	move    RETVAL, $0
	j       $31
# endif
#endif /* NO_ASM_RET_NIL */



#ifndef NO_ASM_BRET_TRUE
	.globl  __bRetTrue
	.align 5
__bRetTrue:
# ifdef IRIX5
	.set     noreorder
	.cpload $25
	.set     reorder
# endif
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
#endif


#ifndef NO_ASM_RET_TRUE
	.globl  __retTrue
	.align 5
# ifndef IRIX5
#  ifndef PRE_FETCH
	.word   2f              /* checked */
	.word   9f              /* realobject receiver */
	.word   __CODE_MAGIC__
#  endif
# endif
__retTrue:
# ifdef IRIX5
	.set     noreorder
	.cpload $25
	.set     reorder
# endif
# ifdef PRE_FETCH
	lw      TMP2, 4(PILC)
	bne     SRCHCLASS, 0, 2f
	ble     RECEIVER, 0, 3f
9:
	lw      TMP1, 0(RECEIVER)
	bne     TMP1, TMP2, callSend0
2:
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
3:
#  ifdef NIL_FIRST
	bne     RECEIVER, 0, 4f
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
4:
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
#  else
	beq     RECEIVER, 0, 4f
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
4:
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
#  endif /* NIL_FIRST */
# else /* NO PREFETCH */
	bne     SRCHCLASS, 0, 2f
	ble     RECEIVER, 0, 3f
9:
	lw      TMP1, 0(RECEIVER)
	lw      TMP2, 4(PILC)
	bne     TMP1, TMP2, callSend0
2:
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
3:
	lw      TMP2, 4(PILC)
#  ifdef NIL_FIRST
	bne     RECEIVER, 0, 4f
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
4:
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
#  else
	beq     RECEIVER, 0, 4f
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
4:
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(true) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Ptrue
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, true
# endif
	j       $31
#  endif /* NIL_FIRST */
# endif /* PRE_FETCH */
#endif /* NO_ASM_RET_TRUE */

#ifndef NO_ASM_BRET_FALSE
	.globl  __bRetFalse
	.align 5
__bRetFalse:
# ifdef IRIX5
	.set     noreorder
	.cpload $25
	.set     reorder
# endif
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
#endif /* NO_ASM_BRET_FALSE */


#ifndef NO_ASM_RET_FALSE
	.globl  __retFalse
	.align 5
# ifndef IRIX5
#  ifndef PRE_FETCH
	.word   2f              /* checked */
	.word   9f              /* realobject receiver */
	.word   __CODE_MAGIC__
#  endif
# endif
__retFalse:
# ifdef IRIX5
	.set     noreorder
	.cpload $25
	.set     reorder
# endif
# ifdef PRE_FETCH
	lw      TMP2, 4(PILC)
	bne     SRCHCLASS, 0, 2f
	ble     RECEIVER, 0, 3f
9:
	lw      TMP1, 0(RECEIVER)
	bne     TMP1, TMP2, callSend0
2:
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
3:
#  ifdef NIL_FIRST
	bne     RECEIVER, 0, 4f
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
4:
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
#  else
	beq     RECEIVER, 0, 4f
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
4:
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
#  endif /* NIL_FIRST */
# else /* no PRE_FETCH */
	bne     SRCHCLASS, 0, 2f
	ble     RECEIVER, 0, 3f
9:
	lw      TMP1, 0(RECEIVER)
	lw      TMP2, 4(PILC)
	bne     TMP1, TMP2, callSend0
2:
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
3:
	lw      TMP2, 4(PILC)
#  ifdef NIL_FIRST
	bne     RECEIVER, 0, 4f
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
4:
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
#  else
	beq     RECEIVER, 0, 4f
#   if !defined(SmallInteger) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PSmallInteger
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, SmallInteger
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
4:
#   if !defined(UndefinedObject) && !defined(__DIRECTVMDATA__)
	lw      TMP1, PUndefinedObject
	lw      TMP1, 0(TMP1)
#   else
	lw      TMP1, UndefinedObject
#   endif
	bne     TMP1, TMP2, callSend0
# if !defined(false) && !defined(__DIRECTVMDATA__)
	lw      RETVAL, Pfalse
	lw      RETVAL, 0(RETVAL)
# else
	lw      RETVAL, false
# endif
	j       $31
#  endif /* NIL_FIRST */
# endif /* PRE_FETCH */
#endif /* NO_ASM_RET_FALSE */


#ifndef NO_ASM_RET_INST

#       define LABEL    __retInst0
#       define OFFSET   12
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst1
#       define OFFSET   16
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst2
#       define OFFSET   20
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst3
#       define OFFSET   24
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst4
#       define OFFSET   28
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst5
#       define OFFSET   32
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst6
#       define OFFSET   36
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst7
#       define OFFSET   40
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst8
#       define OFFSET   44
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst9
#       define OFFSET   48
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst10
#       define OFFSET   52
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst11
#       define OFFSET   56
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst12
#       define OFFSET   60
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst13
#       define OFFSET   64
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst14
#       define OFFSET   68
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst15
#       define OFFSET   72
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst16
#       define OFFSET   76
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst17
#       define OFFSET   80
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst18
#       define OFFSET   84
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst19
#       define OFFSET   88
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst20
#       define OFFSET   92
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst21
#       define OFFSET   96
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst22
#       define OFFSET   100
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst23
#       define OFFSET   104
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst24
#       define OFFSET   108
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst25
#       define OFFSET   112
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst26
#       define OFFSET   116
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst27
#       define OFFSET   120
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst28
#       define OFFSET   124
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst29
#       define OFFSET   128
#       define RETINST
#       include "codeEntry.h"

#       define LABEL    __retInst30
#       define OFFSET   132
#       define RETINST
#       include "codeEntry.h"

#endif /* NO_ASM_RET_INST */

/*
 * default jmp_buf is 128 words (i.e. 1/2 kbytes)
 * this is way too much, and we use a shorter jmp_buf
 * here.
 */

#ifndef O_SP
/*
 * default values ....
 */
# define O_SP   8
# define O_R31  12
# define O_R16  20
# define O_R17  24
# define O_R18  28
# define O_R19  32
# define O_R20  36
# define O_R21  40
# define O_R22  44
# define O_R23  48
# define O_R30  52
# define O_R2   104
#endif

/*
 * to avoid rld conflicts (which take some load-time),
 * better call qsetjmp/qlongjmp instead of setjmp/longjmp
 * It works, though
 */
	.text
	.set noreorder
	.align  5
	.globl  _qsetjmp
_qsetjmp:
#ifndef IRIX5
	.globl  _setjmp
_setjmp:
#endif
	sw      $sp,O_SP($4)
	sw      $31,O_R31($4)
	sw      $16,O_R16($4)
	sw      $17,O_R17($4)
	sw      $18,O_R18($4)
	sw      $19,O_R19($4)
	sw      $20,O_R20($4)
	sw      $21,O_R21($4)
	sw      $22,O_R22($4)
	sw      $23,O_R23($4)
	sw      $30,O_R30($4)
#if 0
	/* Q: is this needed ? */
	sw      $2, O_R2($4)
#endif
	j       $31
	move    $2, $0

/*
 * like a longjmp, but allows returning 0
 */
	.text
	.globl  _qlongjmp
	.align  5
_qlongjmp:
#ifndef IRIX5
	.globl  _longjmp
_longjmp:
#endif
#if 0
	/* Q: is this needed ? */
	lw      $2, O_R2($4)
#endif
	lw      $31,O_R31($4)
	lw      $sp,O_SP($4)
	lw      $16,O_R16($4)
	lw      $17,O_R17($4)
	lw      $18,O_R18($4)
	lw      $19,O_R19($4)
	lw      $20,O_R20($4)
	lw      $21,O_R21($4)
	lw      $22,O_R22($4)
	lw      $23,O_R23($4)
	lw      $30,O_R30($4)
	j       $31
	move    $2, $5

/*
 * like a longjmp, but returns 0
 */
	.text
	.globl  _longrestart
	.align  5
_longrestart:
#if 0
	/* Q: is this needed ? */
	lw      $2, O_R2($4)
#endif
	lw      $31,O_R31($4)
	lw      $sp,O_SP($4)
	lw      $16,O_R16($4)
	lw      $17,O_R17($4)
	lw      $18,O_R18($4)
	lw      $19,O_R19($4)
	lw      $20,O_R20($4)
	lw      $21,O_R21($4)
	lw      $22,O_R22($4)
	lw      $23,O_R23($4)
	lw      $30,O_R30($4)
	j       $31
	move    $2, $0


	.set reorder

# ifdef NOTDEF
	.text
	.align 5
	.globl  qsetjmp
qsetjmp:
	cfc1    $2,$31
	cfc1    $2,$31
	sw      $31,12($4)
	sw      $sp,8($4)
	sw      $2,104($4)
	sw      $30,52($4)
	sw      $16,20($4)
	sw      $17,24($4)
	sw      $18,28($4)
	sw      $19,32($4)
	sw      $20,36($4)
	sw      $21,40($4)
	sw      $22,44($4)
	sw      $23,48($4)
/*      swc1    $f21,56(a0)  */
/*      swc1    $f20,60(a0)  */
/*      swc1    $f23,64(a0)  */
/*      swc1    $f22,68(a0)  */
/*      swc1    $f25,72(a0)  */
/*      swc1    $f24,76(a0)  */
/*      swc1    $f27,80(a0)  */
/*      swc1    $f26,84(a0)  */
/*      swc1    $f29,88(a0)  */
/*      swc1    $f28,92(a0)  */
/*      swc1    $f31,96(a0)  */
/*      swc1    $f30,100(a0)  */

	jr      $31
	move    $2,$0


	.text
	.globl qlongjmp
	.align 5
qlongjmp:
	lw      $2,104($4)
	lw      $31,12($4)
	ctc1    $2,$31
	lw      $sp,8($4)
	lw      $30,52($4)
	lw      $16,20($4)
	lw      $17,24($4)
	lw      $18,28($4)
	lw      $19,32($4)
	lw      $20,36($4)
	lw      $21,40($4)
	lw      $22,44($4)
	lw      $23,48($4)
/*
	lwc1    $f21,56($4)
	lwc1    $f20,60($4)
	lwc1    $f23,64($4)
	lwc1    $f22,68($4)
	lwc1    $f25,72($4)
	lwc1    $f24,76($4)
	lwc1    $f27,80($4)
	lwc1    $f26,84($4)
	lwc1    $f29,88($4)
	lwc1    $f28,92($4)
	lwc1    $f31,96($4)
	lwc1    $f30,100($4)
*/
	move    $2,$5
	bne     $2,$0,lab
	li      $2,1
lab:
	j       $31
# endif /* NOTDEF */
#endif /* __mips__ */

/*------------------------------------------------------------------
 *
 * MACHINE: hp pa-risc
 *
 *------------------------------------------------------------------*/

#ifdef __hppa__

/*
 * r26 receiver
 * r25 selector
 * r24 selector
 * r23 pilc
 */

#       undef ALIGN
#       undef ACCESS
#       undef CODE_ONLY
#       undef CODE
#       undef DATA
#       undef LR
#       undef RR

	.IMPORT SmallInteger,DATA
	.IMPORT UndefinedObject,DATA

	.SPACE $TEXT$
	.SUBSPA $LIT$,QUAD=0,ALIGN=8,ACCESS=44
	.SUBSPA $CODE$,QUAD=0,ALIGN=8,ACCESS=44,CODE_ONLY
	.IMPORT $global$,DATA
	.IMPORT $$dyncall,MILLICODE
	.SPACE $TEXT$
	.SUBSPA $CODE$

	.align 4
	.EXPORT __flushInstructionCache__,CODE
	.EXPORT __flushInstructionCache__,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
__flushInstructionCache__
	fic       %r0(%r26)
	bv,n      0(%r2)

	.align 4
	.EXPORT __flushInstructionCache0__,CODE
	.EXPORT __flushInstructionCache0__,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
__flushInstructionCache0__
	fic       %r0(%sr0, %r26)
	bv,n      0(%r2)

	.align 4
	.EXPORT __flushInstructionCache4__,CODE
	.EXPORT __flushInstructionCache4__,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
__flushInstructionCache4__
	fic       %r0(%sr4, %r26)
	bv,n      0(%r2)

	.align 4
	.EXPORT __flushDataCache__,CODE
	.EXPORT __flushDataCache__,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
__flushDataCache__
	fdc       %r0(%r26)
	bv,n      0(%r2)

	.align 4
	.EXPORT __flushDataCache0__,CODE
	.EXPORT __flushDataCache0__,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
__flushDataCache0__
	fdc       %r0(%sr0, %r26)
	bv,n      0(%r2)


	.align 4
	.export __newFlushCache__,ENTRY
__newFlushCache__
	.proc
	.callinfo

	.enter
	ldsid   (%r26), %r23    /* get space id from short pointer */
	mtsp    %r23, %sr2      /* stick it in scratch space reg */

	depi    0,31,4,%r26     /* align address to cache line */
	addi    15,%r25,%r25    /* align size upwards */
	depi    0,31,4,%r25
	ldi     16,%r22         /* r22 := minimum cache line size */
	ldi     -16,%r21        /* r21 := -(minimum cache line size) */

fic_loop
	fdc     0(%sr2,%r26)
	sync
	/* fic can't use short pointer so
	 * use the space reg set up above
	 */
	fic,m   %r22(%sr2,%r26)

	nop                     /* 7 cycle delay. See programming note */
	nop                     /* for SYNC in arch. ref. manual */
	nop
	nop
	nop
	nop
	nop

	addb,>= %r21,%r25,fic_loop  /* add stride to count, branch */
	nop
       .leave
       .procend

	.align 4
	.EXPORT __switchStack__,CODE
	.EXPORT __switchStack__,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
__switchStack__
	copy      %r26, %r30
	bv,n      0(%r2)

	.align 4
	.EXPORT qqsetjmp,CODE
	.EXPORT qqsetjmp,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
qqsetjmp
#ifdef NOTDEF
	stw     %rp,0(%arg0)
	stw     %sp,4(%arg0)

	stw     %r3,16(%arg0)
	stw     %r4,20(%arg0)
	stw     %r5,24(%arg0)
	stw     %r6,28(%arg0)
	stw     %r7,32(%arg0)
	stw     %r8,36(%arg0)

	bv      0(%rp)
	or      %r0,%r0,%ret0

	.align 4
#endif
	.EXPORT qsetjmp,CODE
	.EXPORT qsetjmp,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
qsetjmp
	stw     %rp,0(%arg0)
	stw     %sp,4(%arg0)

	stw     %r3,16(%arg0)
	stw     %r4,20(%arg0)
	stw     %r5,24(%arg0)
	stw     %r6,28(%arg0)
	stw     %r7,32(%arg0)
	stw     %r8,36(%arg0)
	stw     %r9,40(%arg0)
	stw     %r10,44(%arg0)
	stw     %r11,48(%arg0)
	stw     %r12,52(%arg0)
	stw     %r13,56(%arg0)
	stw     %r14,60(%arg0)
	stw     %r15,64(%arg0)
	stw     %r16,68(%arg0)
	stw     %r17,72(%arg0)
	stw     %r18,76(%arg0)

 stw  %r19, 80(%arg0)
#if 1
 mfsp %sr3, %r1
 stw  %r1,84(%arg0)
#endif

#if 1
/* testing */
 mfsp %sr0, %r1
 stw  %r1,88(%arg0)
/* end */
#endif

	bv      0(%rp)
	or      %r0,%r0,%ret0

	.EXPORT qlongjmp,CODE
	.EXPORT qlongjmp,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
qlongjmp
	ldw     0(%arg0), %rp
	ldw     4(%arg0), %sp

	ldw     16(%arg0), %r3
	ldw     20(%arg0), %r4
	ldw     24(%arg0), %r5
	ldw     28(%arg0), %r6
	ldw     32(%arg0), %r7
	ldw     36(%arg0), %r8
	ldw     40(%arg0), %r9
	ldw     44(%arg0), %r10
	ldw     48(%arg0), %r11
	ldw     52(%arg0), %r12
	ldw     56(%arg0), %r13
	ldw     60(%arg0), %r14
	ldw     64(%arg0), %r15
	ldw     68(%arg0), %r16
	ldw     72(%arg0), %r17
	ldw     76(%arg0), %r18

 ldw  80(%arg0), %r19

#if 1
 ldw  84(%arg0), %r1
 mtsp %r1, %sr3
#endif

#if 1
/* testing */
 ldw  88(%arg0), %r1
 mtsp %r1, %sr0
/* end */
#endif
	bv      0(%rp)
	copy    %arg1, %ret0

	.EXPORT qlongrestart,CODE
	.EXPORT qlongrestart,ENTRY,PRIV_LEV=3,ARGW0=GR,RTNVAL=GR
qlongrestart
	ldw     0(%arg0), %rp
	ldw     4(%arg0), %sp

	ldw     16(%arg0), %r3
	ldw     20(%arg0), %r4
	ldw     24(%arg0), %r5
	ldw     28(%arg0), %r6
	ldw     32(%arg0), %r7
	ldw     36(%arg0), %r8
	ldw     40(%arg0), %r9
	ldw     44(%arg0), %r10
	ldw     48(%arg0), %r11
	ldw     52(%arg0), %r12
	ldw     56(%arg0), %r13
	ldw     60(%arg0), %r14
	ldw     64(%arg0), %r15
	ldw     68(%arg0), %r16
	ldw     72(%arg0), %r17
	ldw     76(%arg0), %r18

 ldw  80(%arg0), %r19
#if 1
 ldw  84(%arg0),%r1
 mtsp %r1, %sr3
#endif

#if 1
/* testing */
 ldw  88(%arg0), %r1
 mtsp %r1, %sr0
/* end */
#endif
	bv      0(%rp)
	or      %r0,%r0,%ret0

# ifndef NO_ASM

#       define LABEL __retInst0
#       define L1 L$0000
#       define L2 L$0001
#       define OFFSET   12
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst1
#       define L1 L$0100
#       define L2 L$0101
#       define OFFSET   16
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst2
#       define L1 L$0200
#       define L2 L$0201
#       define OFFSET   20
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst3
#       define L1 L$0300
#       define L2 L$0301
#       define OFFSET   24
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst4
#       define L1 L$0400
#       define L2 L$0401
#       define OFFSET   28
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst5
#       define L1 L$0500
#       define L2 L$0501
#       define OFFSET   32
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst6
#       define L1 L$0600
#       define L2 L$0601
#       define OFFSET   36
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst7
#       define L1 L$0700
#       define L2 L$0701
#       define OFFSET   40
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst8
#       define L1 L$0800
#       define L2 L$0801
#       define OFFSET   44
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst9
#       define L1 L$0900
#       define L2 L$0901
#       define OFFSET   48
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst10
#       define L1 L$1000
#       define L2 L$1001
#       define OFFSET   52
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst11
#       define L1 L$1100
#       define L2 L$1101
#       define OFFSET   56
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst12
#       define L1 L$1200
#       define L2 L$1201
#       define OFFSET   60
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst13
#       define L1 L$1300
#       define L2 L$1301
#       define OFFSET   64
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst14
#       define L1 L$1400
#       define L2 L$1401
#       define OFFSET   68
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst15
#       define L1 L$1500
#       define L2 L$1501
#       define OFFSET   72
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst16
#       define L1 L$1600
#       define L2 L$1601
#       define OFFSET   76
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst17
#       define L1 L$1700
#       define L2 L$1701
#       define OFFSET   80
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst18
#       define L1 L$1800
#       define L2 L$1801
#       define OFFSET   84
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst19
#       define L1 L$1900
#       define L2 L$1901
#       define OFFSET   88
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst20
#       define L1 L$2000
#       define L2 L$2001
#       define OFFSET   92
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst21
#       define L1 L$2100
#       define L2 L$2101
#       define OFFSET   96
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst22
#       define L1 L$2200
#       define L2 L$2201
#       define OFFSET   100
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst23
#       define L1 L$2300
#       define L2 L$2301
#       define OFFSET   104
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst24
#       define L1 L$2400
#       define L2 L$2401
#       define OFFSET   108
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst25
#       define L1 L$2500
#       define L2 L$2501
#       define OFFSET   112
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst26
#       define L1 L$2600
#       define L2 L$2601
#       define OFFSET   116
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst27
#       define L1 L$2700
#       define L2 L$2701
#       define OFFSET   120
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst28
#       define L1 L$2800
#       define L2 L$2801
#       define OFFSET   124
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst29
#       define L1 L$2900
#       define L2 L$2901
#       define OFFSET   128
#       define RETINST
#       include "codeEntry.h"

#       define LABEL __retInst30
#       define L1 L$3000
#       define L2 L$3001
#       define OFFSET   132
#       define RETINST
#       include "codeEntry.h"

# endif /* NO_ASM */
#endif /* __hppa__ */

#endif /* __ASSEMBLER__ */
