"
 COPYRIGHT (c) 2009 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libwidg3' }"

View subclass:#VUMeter
	instanceVariableNames:'isPowerOn powerOffImage powerOnImage'
	classVariableNames:''
	poolDictionaries:''
	category:'Views-Misc'
!

!VUMeter class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2009 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    nice display of a measurement value or simular...
    model value must be 0..1

    [author:]
        cg (cg@CG-VOSTRO)

    [instance variables:]

    [class variables:]

    [see also:]

"
!

examples
"
 Notice that everything between [exBegin] and [exEnd] is extracted by the html-doc generator
 to create nicely formatted and clickable executable examples in the generated html-doc.
 (see the browsers class-documentation menu items for more)

 trying the widget as standAlone view:
                                                        [exBegin]
    VUMeter new open
                                                        [exEnd]

 embedded in another view:
                                                        [exBegin]
    |top v|

    top := StandardSystemView new.
    top extent:300@300.
    v := VUMeter new.
    v origin:10@10 corner:150@150.
    top add:v.
    top open
                                                        [exEnd]

                                                        [exBegin]
    |m top v stop|

    m := 0 asValue.

    top := StandardSystemView new.
    top extent:300@300.
    v := VUMeter new.
    v model:m.
    v origin:10@10 corner:150@150.
    top add:v.
    top open.

    stop := false asValue.
    (Button label:'stop') model:stop; open.
    [
        [stop value] whileFalse:[
          0 to:1 by:0.1 do:[:v  |
            m value:v.
            Delay waitForSeconds:0.5
          ]
        ].
        top destroy.
    ] fork.
                                                        [exEnd]

"
! !

!VUMeter class methodsFor:'image specs'!

offImage
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self offImage inspect
     ImageEditor openOnClass:self andSelector:#offImage
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:'VUMeter class offImage'
        ifAbsentPut:[(Depth8Image new) width: 150; height: 144; photometric:(#palette); bitsPerSample:(#[8]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
F!!(ZF!!DZF!!(ZF!!(ZF!!(SE@ IBPTEAPTEAPXEAP$IBP$IBP$IBP$IB@\IBP$IB@@BBP$IB@ BA0$HBP$EBP IB@ H@  IBP BBP$HB@HIB@ HB@$IBP$IBP$I
BPTEAP$HB@ HBP$ED@HBA1PIBP$IB@ HBP$IB@$GB@ EB@@GBPTEAPTFA TIBP$IAPXSA XSDQ$ZF!!(ZFQ$ZDQDZDQ(ZF XH@ DC@PPDA@PDA@DD@0LC@0LD
A@PDA@PDA@PA@PDA@PPA@PDA@0LD@PDCA@PDA@PCA@PCA@DAA@PCA@PD@0PAA@PCA@PDA@PD@0LA@PPDA@PC@0PDA@DDA@PD@0DA@PDDA@PDA@PDA@PDA@LA
A@LC@PDAA@LC@0L@@@L@@@@B@@HEBPTRDQ$ZF!!(ZFQ(QDQHPF!!DPAP B@@LGA0\H@ H@@@LG@@HB@ HB@ HB@ HB@ HBA0\H@0\G@ @@@ @CA0@B@ H@@ HB
B@ CA@PDA@LCA@PD@0PDA@PCA@PDA@PDA@P@@ LCA0\GA0 B@@@@@ HB@0LCB@@CA0 @@ HB@ HB@  @@@LB@ \H@@HIB@ IBP GA0HC@@@HAQLPD <ZF!!(Z
F!!DPFQ@RDQLTAQLEAPXEBPTEAPXEA TTE@$IBP$EBP$IBP$IBPTEE@TSAPTFB@XEAPXIBP$EB@XHA TEAQLIAPTEA XFAPXEAPTFA TEAPTEAPTEAPTIAP$T
APTEBP FBP$IB@TEAQPIBPTSBP\EA TEBP$EAPTEAQPEAQPEBQLEE@TFAQPTA TIAP$FA!!PSD!!DYF!!XZFQDRDQ@RD@XFD1T5N#X3L2<-LA(.K"4WE2<-KS@5
LB</K2</K2</LB<.K24/LB4-KR4-KR40K3@-L28/KR<0LC@3KR40LCL0K3@0LCL0LB<0K280LC@-LB4-KR4-LB<-KR43L3@-KR<WK2<-KR</E1\/KSL.LB83
K"83K1\/E24-KQ\/K240LA$PE@ IBP$FD1DYFQ(ZFQ@YDQ@PEAL3M3<=K!!TTD!!@SD!!PYDQPTBPTED0XTEAPTEAPTD1LTA XTAQLTD1PTEAPTEAPTE@XTA XE
APTTA TTE@TFA TSD0TSAPTTD0TEE@TTEAPSD1LSD1LSD1PED1LTEAPTA!!PTEALSD1PSEAPPD1HPDAPPDALSD1PTA XPDALSD1HPD!!@SD1PFA $FD1HQFQ(Z
FQDQFQHSD2<8PCDZB@HGB@ HAP\PE@$HB@$HB@$EB@ HB@ HB@\GA0 HB@ IBP$IBP$IBP$HB@ HB@ HAPTHBP$HB@ HBP$HBP HBP$HB@$HBP$IBP$HB@ H
B@ HA0$IBP$IBP IBP HB@$IBP HB@ IBP$HBP HBP$IBP HBP$EAPTEAPTIAPTTAQPFA $EA!!LRDQ$ZFQDQDQHSE3&/L!!LG@@THBP$IAP PD@ FB@TEBPTE
APTEAPTEAPTEAPTEAPTEA TEAPTEAPTEAPTEAPTEA!!PGBPTEAPTIBP$EAPTEAPTIBPTEAPTIAPTEAPTEAPTEAPTEBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPXFAPTEA!!PEBPTTBPTEAPTEAP$EA XSD!!$ZFQDQDQHSESD6FPHHAP FAPTEAP$PAP$EAP$IAPTEBP$IBP$IBP$EAP$IBPTEAP$IBP$IBP$IBP$EAPTE
BPTIBP$EAPTIBP$IBPTEBP$IBP$EAP$IBP$EAPTEAPTEAPTIBP$IBP$EBPTEAP$IBPTIAPTEBP$IAPTEAPTEAPTEAP$IBPTTBP$SAP$EAPTFA $EAPXTDADZ
FQDQDQLTE"8UAP FBP\EBPTEAPTQAPTEAPTEA XEBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPXEAP$EAPTEAPTEBP$IAPTEAP$IBPTEAPTIBP$IBP$I
BP$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IAPTEAPTEBP$IAPTEAPTFA THBPXFA XEAPTEAPTFD1DYFQDQDQLTD1DS@ @EAPTEBPTEAPTEAPTEAP$IAPTI
APTEAPTEAPTEAPTEAPXEAPTEAPTEAPTEAP$IAPTEBP$EBP$IBPTIBP$IBP$IBP$IAPTIBP$IBP$EAPTEAPTEAP$IBP$IBP$IAPTEAPTEAPTEAPTEAPTFE@ E
APTEAPTED0TIA XTBP$IA XFA TEAPTEAPTFD1HYF!!@QDQLTAP IA!!LEBQLHBPTEAPTEAPTEAPTEAPTIAPTEAPTEAPTIBP$EAPTEBPTEAPTEAPTEAPTEAPTE
AP$EBP$IBPTEBPTEAPTEAPTEA TEBPTEAP$IBP$IBP$IBP$IAPTEAP$IAPTEAPTEAPTEAP$EAPTEE@HIBPTEAP$HAPTEBP IAP$FA XFA XFA XFA XFD1HY
FQ$QDAPFAPTEB@TFAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IAPTEAP$EAPTEAPTIA TIAPTFA XFAPTEA XEAP$IBP$IB@ HBP$IBPTEAPTFA XE
APTIBPTEBP$IBP$IBP$IAPTEAPTEAPTEAPTIAPTEAPTEAPTEAPTEAPTIAPTEAPXFA XFAPTIAP$ED1@RFQDQDAPIB@XIAPTEA TEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEBPTEAPTEAP$IAPTEA!!PEBPTIB@\G@0HA@0LC@0LC@0LC@@@@@ LC@0\BB@$IAPTEA $IBP$IAPTEBP$IBP$IBP$EAPTEAPTEAPTE
APTEAPTEBP$IBPTEAPTEAPXFA XFAPTIAP$ED1LRFQDQD1PEBAPIAP$EAPTEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTIAPXFA TEAPXEAP$IAPTFAPTIB@ H
A0HA@0PC@0DC@0@@@@@@@@@@@0LC@PDAA@L@@@@B@@HIAPTEAPTEAP$IBP$IBP$IBP$EAPTEAPTEAP$IBPTEAPTEBP$EAPTEBP$EAPTFA XFA TEAP$ED1LR
DQDQD1PIAQPIBP$EAPTFAPTFEALEBPTEAPTEAPTEAPTEAPTEAPTIAPXFAPTEAPXFA TEAPTEBP G@0DC@0D@A@HC@ HIBP$IBP$IAPTEBP GA0 @@@@CA@LA
A@H@@@HIAPTFAP$IBP$IBP$EAPTEAPTEBP$EAP$IAPTFAPTIBPTEAPTEBP$EAPTFA XFA XEA $ED1LRDQDRD1LIAQPIBP$EAPTEAPXEEAPEBPTEAPTEAPTE
APTEAPTEAPTEAPXFAPTEA $EA!!PIBP\@@ DC@@HCB@ IB@$IA $TAPXFA XTEAPTDA@PAQPIB@THB@\G@ HB@0D@A0HGAPTEAPTEAPTEAPTEAPTIBPTEAPTE
APXTBPTIAPTFA XFAP$EAPTEA XFA XEA $ED1LRDQDRD1LIAQPIAP$EAPTEAQPHEAPSB@TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEA TEB@ G@ DD@@@GA0$E
APXTD1LSD!!@RDQ@YD!!HQDQXYF!!DVD!!@PDAHRD0XFB@ GB@@DA@D@A0$IAPTEAPTEBP$EAPTIAPTEA!!PIA TTAP IA XFE@XFAPTIAPTEA XFA XEA $ED1@R
DQDRD1LIAQPIAPTEA TEBQPHAPXEAP EAPXFAPTEAPTEAPTEAPTEAPTEAPTEAP$HA0DCA@\@BPTFA!!PSDAHYF!!XWK2<-LB8.K#L5MST2L3L3K"8/KR4/F!!HP
C1LSA $HA0\B@0LCBP$EAPTEBP$EAPTEAPTFA THAPTIAP$EA XFA XFAPTIBPTEA XFA TEA $ED1@QDQDRD1LIA TIAPTFA TIBPXHBAPFA  EAPXFAPTE
APTEAPTEAPTEAPTEA XEBPLC@ LB@ $ED1@RD!!DZE2<0K#T2L#P1KCD,M#X7M3$8NC\7KCD,L#D3MSL/K1XZFPXPAPTHA0\C@0@BBPTEAPTEAPTEAPXFAP$E
B@$EE@$EA XFA XEAP$IBPTEA XFA TEAP$EDAHQFQDRD1LEE@ FAPTFAPTIB@$FD0$HB@XFAPTEAPTFA TEAQPEBPXIAQPFBPHB@P\CA0 IA TPD0<UE"<.
L3D1KCX,N#49!!30<!!4@>!!4@>!!6^GO#0<KC4,NR04M#T3L2<VDQLPBP\G@ P@A0 IBPXGBP$EAPTEAPTFA XEB@TEAPXTA XFAP$IBPTEA XEAPXEBP$ID1DQ
FQDRDALEE@ FAPTFBPTEAPTEA  EAPXEAPTEAPTFA TEBPTHAPTEBP GA0@C@  IAPXTD!!$YES@.L3D,M# 8NH\>O:8<+32/OJ8>+32/NJ<<+(!!''!!3>GPC8=
OS ,M#D.L24ZE!!@SA  G@0L@@@ EAPTHBP$EE@ FA TEAPTEAPXTA XFAP$IBPTEA TEAPTEBP$ID1DQFQDRDALEE@ EBPTFBPTEAPXEAPTEAPTEAPTEAPXF
A TIBPTFAPTIBP\B@P\GAPXFEA$YE#@0MCP,NS$>OX^/OJ>HY:>H+8"/"J>H+8"/"J>HY8"/+8!!''!!6^GY3 >OR07KCP3L2<UC1LE@@H@@0LEBPXEB@$IA TE
A TEAPTEAPXFA XFAP$IAPTEAPTEBPTEAP$IEAHRFQDRD!!LEE@ EBPTFBPTEA XEAP$EAPTEAPTEAPXFA TEA!!PEB@TB@0L@@@\TA XYFQT3L"01NS 8!!3>.
O6^H+:>H+:>H+:>/+:>/+:>/+:>H+:>/+8"/+3>.O8".OS48NS 7KCT5LA(ZD1PBA0@CB@XFAP EBPTEAPTEAPTEAPXFA XFAP$EAPTEAPTIBPTEAP$IEAHP
F!!@RD!!LEE@ EBPTFBPTFA XEAP$EAP$EAPTEAPXFE@TEBP EBP\D@@LHA TPDQXVL3D,N#0=!!3=''"J>/"J>/+:>/+:>/+:>/+:>/+:>/+:>/+:>H+:>/+8"/
+8"/PH]''!!6^HOS ,LR8.F!!XSA HB@0@IE@THBPTEAPTEAPTEAPXFA XFAPTEAPTEAP$IBPTEAPTIEAHPF!!@RD!!LEE@ EBPTFBPTFA TEAP$EAP$EAPTEAPTE
B@XHA \G@ PB@ \FEA@VF#L2KC$=!!3=''"J>/"J>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+8!!''"FZHY#^HNB02L28ZF XEA0\GBPXFA TE
APTEAPTEA XFA TFA TEAPTEAPTIBPXEAPTED1HPF!!@RD!!LEE@ FAPTFBPTEAPTEAPTEBPTEAPTEAP$EAP EA0\A@ LIA!!PRE!!T5MB09OH]''"J=''"J>/+:>/
+:>/+:>/+:>/+<2/4:?S+=N/4:?O+:>/+:>/+:>/+:>/+:>/"J<?"FZHO#08KCP.K!!(YD@TGA0$EA TEAPTEAPTIA XFAPTFA TEAPTEAPTEAPXEAPTED1DR
F!!@RD!!@IAPTFAPTFAPTEAPTEAPTEBPTEAPTEAPTHBP$IA0HD@ TFD1DVK#T,OS6GY8"/Y8"/+:>/+:>/+:?L+=N/4:?S+:>/+:>/+:>/4:?R+:>/+:>/+:>/
+:>/+:>/+:>/"J=''!!6^GOS4,M#@UE!!@IA0\IAPTEAPTEAPTIA XFAPTFA TEAPTEAPTEAPXEAPTED1DRF!!$YD@XEAP$EAPTEAPTEA XEAP$EAP$IAPTEAPTF
AP$GA0\IAQLRC2<3KC(<OX!!''"J>/+:>/+:>/+:>/+:?M+=R/5J?V+=Z/4++T+:>/5*?T+=R/5J>/4*?S+:>/+:>/+:>/+:>/"J<?Y( =KCX2LB<PA  B@@ E
A TIAPTEA XFA XFAPTEAPTEAPXFA XFA TEDA$OF!!(ZD!!PHE@$EAPTEAPTEAPXEAPTEAPTIBPTFA TIA0HGB@$ED1D/LCP,M3:.O:=''"J>/+:>/+:>/+:?L
+:?T+:>:5Z?T+=R:6J>/6J>:5J?X+;*/5+*/4*?S+=N/+<>/+:>/+:>/+8"/Y8\>OR06LS@VDAPI@  IAPXEBP$EA XFA XFA TEAPTEAPXFA TEA XFDADR
F!!DVD1LEE@$EAPTEAPTEAPTEAPTEAPTIBPTTAP\G@@HGAPXSFR<2LR0=O3>/O*>/+:>/+:>/+:>/3J?R+=R/5J?T+=Z/5*>/5K+Z+:?X+=Z:5-*/6*?U+=R/
.-N/+=J/+:>/+:>/+:>H+6^GO#89KCD5KQ(SAP\GBPXFBP$EAPTFA XFA TEAPTEAPTFA TEA XFDADRFQ$QDQ@HE@$EAPTEAPTEAPTEAPTFA XEAPTIBP @
A0 ED1HZKSH,M34?Y("/"J>/+:>/+:?O+=N/4*?T+=R:5*?X+=V:5Z?V-L2:5]"/4:>/5+*/5*?V+=R/5J?R.-N/4:?M+:>/+:>/+8"/O(]@OS\,L#@ZDP$G
A0TFAP$HAPTEA XFA XEAPTEAPTEAPXEAPTEDA$YDQHQD!!@HE@$EAPTFAPTEAPTEAPXFA TFA  EBP\GBPTSDQX-L"0=O(^/O:>/+:>/+:>/+:?R+=J/.*?T
+=Z/5Z?X.-V/6*?X.-[Z+=K[.-Z/6J?T6-Z:6*>/5J?T+=J/3J?R+<6/+:>/+8"/Y8\?OC ,LSX-K1HFB@\IA XIAPTEA XFA XEAPTEAPTEAPXEAPTED!!$O
DQDRDA@HE@$EAPTFA TEAPTEAPXFAPTFAP HA0 IAQPQE3@2NS:GY8"/+:>/+:>/+:>/+:?R+;+T+=R/5+*/6]*/+:?[+="/+=.GKR:/+=*/5[+Y+:?U+=V/
5K+T+=[S.*?S+=J/+:>/+:>/"F^GY8\=NR05MR<ZA HBAPXEAPTFA XFA TFA TEAPTEAPTEA XFD!!$QF!!DPDA@HA XEAPXFA XEAPTEAPXFAPTHAP$GA0$F
DADWMSD7OC>GY:>H+:>/+:>/+:>/4*?T+=R/5++Z+="/5:<,C2?U.-"/5= ,MA&G6:>:6+R/K23U5Z?T+="/4++V+=Z/+=N/+:>/+:>/"J>GY8 >OR0:M#L0
F!!PHA0TFA XFA XFA TFA XEAPTEAPXEA XED1DRF!!$PDA@HA TEAPXFA XEAPTEAPXEAP EBP\GB@XSF!!\3KC\<!!6^H+:>/+:>/+:>/+:>/4++V+=*/6J?X
+=.:5]*/L!!V/6++Z+:?V41&/.-./6M =BCF:6J?X.-"/6*;L4:?T+=J/+:>/+:>/+6^GY8\>O3\,NSD2L@<F@ \EA XFA XFAPTFA XEAPTEAQPFAP$IEAHR
E!!$RDAPFA XEAPTFA XEBP$EA!!PEAQPH@@\IA!!@OKST:NC0>"J=@+:>/+:>/+<6/+=J:3Z>GE:?M6K+[+=./6*?X+!!B/5-[[L@?OER3X5]"/KCG)K"3X5*?Y
+:?WK@$/5J?V+=R/4:?L+:>H+:>HY8^/OX\=NB01L#LUA \GD1LFAQPFAPXFA TEAPTEAPXFAP$ED1DZF!!(YD!!LFA XEAPTFA XEAP$EA!!PFA THA0 EA!!DW
L3D8OX]''"J>/+:>/+:>/3J>/4*>/5-LPK:?X+="/6:?YNANG5#@36;+Z+:<,@R:/5MV/L#^/K8_V5[+X-MR/FS$Z+=J:+=J/3\6/3Z>/"J>/O:<=+34=NB09
L#H0C0XIA!!LTA XFAPTFA TEAPTEAPXEAPTED1DZF!!(YD!!LFA XEAPTFA XFAPTEA XFA  GB@TFDA\5LS\<O8^/Y8"/+<:/+=B/4*>:5J>/6MX/D2:/+="/
6K+Z+:>/D!!RG5:?Y5-VGLR2/5K+X..&/K8_Y5Z>/.-V/DZ<F+=*/+=N/5*>/+:>/+8"/O:<<!!:<8!!3<8KCX4L@<TBPXSE@TEA TFA XFAPTEAPXEAPTED1HO
F!!$YD!!LFA XEAPTFA XFA TEA XFAP\GBPXPF#@1NC2.O&^H+:>/+:>/3]R/!!<6/+=[Z+:87"B8,5[+Y+=":6M''U+,/X4:?[.-''Y6;+W-MOY+;+Y+:?X+="/
5Z>/C3T25Z>/6-Z:+3?R+:>/+:>/"J=''"J9@O(]''KC(:MB<OAP$FD0XFA TFA XFA XEAPXEAPTFD1HQF!!$YD!!LFA XEAPTFA XFA XFA XEBP\HAQLZKSP,
OC"/"J>/+:>/+<2/+3@SBZ?T+;+VKA(,M1X26J?[+=":6Z?Z5:?T6-"/6;*/OJ?U.-.45M*/+=*:6+R:+=Z/DP>H6Z>:5*<,K!!V/O!!X1+8"/Y8"/"F^GY8\?
O209M"8UD TIEAPFA TEAPXFA XFAPXEAPTFD1HQF!!(YD!!LFA XEAPTFA XFA XTA TIA0$IE@</L"07O32/O*>/+:>/+:>/+3$,K:>:4*?X+8#XKR:/6+*/
6M*43]/X+3V/5M^:6M"4K:?X.-R/6MX5!!=&/6*?U.-_Z+:?Z.-R/+=X,AABGM @,3J>/+8"/+6^H+3:.NC4,M#P3E1LIAQLSA TEAPXFA XEAPXEAPTFDADQ
E!!(YD!!LTA XEAPTFA XFA XFA $HA0TTDQ\5M# =!!6^H+:>/+:>/+:?O6*?LFZ?V+=J:6-Z/:]Z:6Z?X6;+Z.-*:53Z.5=+[6[+WM*?[6>2:6](5+=&:6*?[
+;*/+=WR+:?X+=V/F#2/KA[R+8"/+:>/+:>HY8"/O(\>KCX3LAXFBPXSA TIAPTFA XEAPXEAPTTD!!DOEQXYD!!LTA XEAPTFA XFA XFAP$HA0TPE#@4KC0>
!!6^/"J>/+:>/+:>/+3Z/FZ;S5MZ/4-"/6*<,5++W+=./9]/Y.#D6+8\>OC47DCH7KC4>+( -+=+X6M":6Z<7O[*/6:>/5J>/+<7SF"3P+=B/+:>/+:>H+3>.
OH!!@NB05L#@RA0$SA $IAPTFA XEAPXEAPTTD!!$YEQXVDQPFA XEAPTFA XEA XEBP\HBPXZLCP,OS6H+#:/+:<?+:>/+<6/KAN/L"3V.-*/6*?V4-X/+=_Z
5]R/!!3 2MR8VM"0=OR0>+22HKC<2KB8.K3@2KJ>/6+PW+=[V+=R/5MOS+=J.D*?N+:>/+8#T+:>/+8"/PFZHNC ,L3LUD@@BD@\EAPTEA XFAPXFA TID1(0
EQXZDQPFA XEAPTFA XEA XEBP IAQ@WMSX,NH]''"J>/+3\FDZ?L+<7R.*?V+:?U+=WV4++Z+=$,"J<,K"84KC:/+:>G6M+Y6>WMF"3W5=+[58\<4*>.M#HU
LHL%!!:?L5MV:+:?R+:?N"J>/+:>/3H\,L:>/"J>/"FX<NC$8KB8/D@\GD0 EAPTEA XFAPXFA TFDA(WE!!(ZD!!PFA XEAPTFA XEA XEBP EEA(0L"08"FZH
+:<74!!\/L Z/5J>/5MZ/4*>G5-R:6:?U+:<UC3JH+:?Z6]/Z5S@A+=Z:5-+RAP?Y5Z?X+0\F+=S[6-.:+2 ''IRT%!!8"/6Z>/L(_T+=N/+:>/3STBD*<2A#R.
2J<8O34,M"80K0X@A $IBP$EA XFA XFAPTTD <YF!!(YD!!LFA XEAPTFA XFA XEBP$TD"<2M#\?!!6^H+:<SL( O"C@,5*?V+:?V+=P.!!>3Z+28,E3L>4*<U
M]_W+;+);H\,3M&/9Z>/4=R/+=/Z.#4=5]V:+=SY+ VG"B %IRVB!!:>/K&^/+;+L+:>/5"0PK:<,L1Z/+8]''!!6\4M200LA$HBAPEAPTEAPXEAPXEAPXSD!!DY
F!!(QD!!LFA XEAPTFA XFA XEB@TPF"81M3 ?!!:=''"L4QBZ<3E2<V5Z?U6J>/5-J/L:88K8\8+=+X5J<HC=N/6M^/6M#W/]KZ+1XZOR0GMK+Z6KSS6*?Y6++[
O@\"5;R:!!8L%IRT''JL7!!+:>/+<6/3Z>/+8 ,D#J/4J>HY( =NCD5MQTEA1PFAPTEAPTEAPTEAPXTD <ZF!!(QD!!LFA XEAPTFA XFA TIB@XQE3H,OS2.OH"/
+8"/MP?NM!!B.3Z>/+=R/6-Z/A#@,"N''Y6;+)+=Z.3#PO"N2/5;+Z6++,+1$QMB4>C=K[5[*/6M*.L:?V+,;Z3Z?U+=R. 2 %IXNG3=R/+:>/3J?PKP\/NJ>/
+3>/OX\>OR02L"4SA0XTA TEAPTEBPTEA XFDA$UF!!XYD!!@FA XEAPTFA XFA TIB@XZLCP,OC2GY8"/+3 <+2<U6L3V+=ST+=#R+283KJ?X6M#X6:?U+!!H/
"AT1E:?Y+=":6J?Z5@<QLR>/D*>/5++Y+:<UBZ<1DB3S"J?U+:?T+:>GJBT%JJ;I5*>/4:?SM@$2+:>/"J>/O#<=OR01L28PB@TTA XEAPTEAPTEAPXTD!!$U
F!!XYD!!@FA XEAPTFA XEA TIBAPVK#D8O$B.O:>H+1XV+:<8+:<7+:?T5Z<,KS^/6MZ/6-[V5-+LM1X,O2>.DJ?Z5-./6K+W+1(=K1H<F*?Z5*>:6;P6K*<V
L3T,D2>/4:?R+<6/5(^CIRVC+:?S+3&/3X\8+:>/+8!!''+8\>OR0:MSLYA0TTA XEA XFAPXFAPXSDQ$ZF!!(YFQDFA XFAPTEAPXEE@THAQHWMSD8OQLRKJ=''
+8_O+:?M.-P1L=*/"B<,!!32/6J?R6-+X5-KU!!0T-EQ(9K3#X.-"/6Z?W+1(TKC FMJ?X.-"/5](0M204M2<RO >/3Z?S+=J/+;+N!!2 %IXOU!!3A''5J>:+:>H
+6Z_+3:/NS ,MB40A  SA XFA XEAPXIAPXFD!!(YEQDQDQHFA XFAPTEAPXEE@TGBQH/L#4,M1@5AS"/+<2/+=N/+:?VK3 2EZ?VL0FG5]#X+=+Z6MWV+1L,
L3PPFX_)6+*45-KX5*:/3]*G4=#X+=V:6+(W+#P.L2</!!1&/4*>/+:>/4:?T.*>GI2T(I3>/+:?L+:>/+:=''KH 1O#\,M#@UAPTSA XFA XEAPXIAPXFD!!XZ
EQDQD!!@FA XFAPTEAPXEA TGAQD-LSH/K0</N ZG3Z>/+:?M+=[UL X=4-KT+#^/K0>/4=WZ6-"/6B8YDJ>H+=OU+=R:6*?V5-[V.-''Z-MN:6J?Z+;(?3S T
K20ULR6/5*>/4*>/4*>/4++S!!3H%IX_L+:>/+:>/+8"/E T/OC\,LSP-APXSA XFA XEAPXIAPXFD!!TUF!!$QD!!@FA XFAPTEA XEA THAQD0LQDSDR4OK1H1
+:>/+:?L4:</K#2/+=Z/+32/A"0Y5++Y6-"/5J?R+=''[6-[T.-*/6K+T+="/5Z?Z.-R/6*?X+=W[.-T?+:<QC:?S+=J/5J>/+=J/+:?T+;*GJBT(!!=Z/+:>H
+6^GE L4OQ$VL3H-APTSA XFA XEAPTIAPXFD!!(VDQDYFQ@FA XEAPTFA XEE@TIA!!$-LQT1K!!\?K0=''+:>/3:>/"A\,40<A+<7XOPFHK6XYOZ?Z5MST5*?V
6*?R.-V/6-"/6J?[.-"/5;+U+=":6J?X.-*/5*?T6K+M+=KZ+=J/.-N/+=J/4*>/+=N:"B\%JH^/+:>/+:<>LR09"@<QMCP/AP$SA XFA XEAPTEAPXFD!!$Z
DQDYFQLFA XEAPXFA XEE@XIA!!$-MC5&FQ@UNZ>/+:>/+<<8FX#V+8 5+:>/!!1L4L1\,K="/5-[T5Z>:6+SS.-./6*?X.-"/6*?Z+=Z/6KSS.-"4.-Z/5[+Z
+:?R6K+T+:?R+:?R.,6/+=J:+:>/4:>GIRT(+:>/"J>/"FX:MQ@OLST/A TSA XFA XEAPXEAPTTD!!$ZF!!DYDQLFA XEAPXFA XEE@TIA!!$0LS@VM0PO2J>/
+:>/3B8/NX"/6*?Z+=OYOR8HK28TL++X5-[V5*?Z+=&/+=*/6;+X+="/5Z?T.-V/5*?U+=R:+=Z:+="/5M"/+=R/+=Z/5J>/3K+M3J?R+:>/+:?L!!2T%K("/
+8_L+1(UE"44NCD0A TSA XFA XEAPXEBPTSDQ(ZE!!$YD XTA XEAPXFA XEE@THAQ$0M"8RO#BHY8"/!!=Z/ESJ/F F.L!!Z/+=J/+ \IK=N/5J>:5Z?T5-*:
-L6:6KSS+:?Z+=Z/6;+Z+=./6J?U.-V/+="/5*>:5Z?V+=Z/4+*/5*>/3Z?S+:?S+=N/+:>/4*<'' B>G3:>H+3(QC3X?MC@-APXSA XFA XEAQPEBPTRF!!XU
F!!$QDQLEAPTEAPTEAPTFE@THA <0MB0<!!6^HOB:/+:<YL*?SM3KJFR4P!!=#L+:>/+:?S.-"/5*>/4:?V.-*/5[+V+="/5++U+=*/5Z?V+=R:5Z?T+=R:5J>/
5Z?T+=R/5J>/4*>/4*?R+:>/+:>/+:>/+<:HMRT''"J<3MZ<8"C87KCL0B@TSA XFA XEAPXEBPTPD!!DVF!!(YD!!LFAPTEAPTEAPTFE@THA <0MB0=OC:."CT-
M2<,4*?O+1X,E#X=C<>/3Z?R+=Z/6*>:5Z?T.-KT+=[R+=*/6++T+=*/5Z?U+=V/5J?U+=R/5J>/5-J/5J>:+=J/+=J/+:>/4*>/+:>/+:>/+:>/+:>/+8L%
FR 5KJ<>OC ,LST0B@TSA XFA XEAPTEAPXRFQ(WFQ(YD!!LFA TEAPTEAPXFE@THA <0LR08OH]''+8 ,C3F/4K*/E!!XVK <=D#K[+=R/5++U+=R/5++Z+=+V
.-*/5++V+=*/6*?U+=V/+=V/5*?T+=R/5J?R+=J/.-J/+;+R+:?R+:>/+:>/+:>/+:?M+<>/+:>/+:<(IR4<Y:>GO#49KB80B@TSA XFA XEAPTEBPTSD!!DZ
FQ(ZD!!PFA XEAPTEA XFE@THA <0MC\<OX]''"J>/NL6/+<>/M:<5M( OE*;P+:>/5J>/+=R/6*?[+=*/6*?Z+=*/6*>/6*?V+=Z/+=J/.*?R+;*/4*>:+:?R
+=J/4*?R+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>HKH_O+38?!!349KB80B@TSA XFA XEAPTEBPTTDAHQFQ(YD@XFA XEAPTEA XFE@THA <0MB0<NH^/OJ>/
+8"/+:?M+:<2E3\>+=N/+=R/5J?R+=Z/+:?Z+=Z/5*?V+=Z/5*>/5Z>:+=J/.*?S+:>/4*>/+=J/4*?R+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/
+:>H+#!!''M3\9KB80B@TSA XFA XEAPTIAPXSDQ(ZFQ(YDAPFA XEAPTEA XEA TGA!!D-MB08OX^/O*>H+:>/+:>/+<4,@Q*/4:>/5*>:5J?R+;+T+:>/5*?S
.*?T+=J/.-*/+=J/+=J/4*?R+=J/+=J/+=J/4*>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/4:>/+:>/+8"/Y:>H+8\>OC4,N"80B@TSA XFA XEAPTIAPTFDQ(Z
FQ$QD!!LFA XEAPTEA XEA $GAQD-L#X=O#6GY8"/+:>/+:?O+:>HKJ?M+:?V+:>/+:>/4*?T+=Z/3]J/4*?R+:?T+:?R+:?R+:>/+:>/+:>/+:>/+:>/+:>/
+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+4BH+3<>OS\,N"80B@TSA XFA XEAPTIBP$ED!!(OFQDRD!!@FA XFA XFA XEA $GAQD-MB07ODBGY:>H
+:>/+:>/+:?P3Z?S+:>/+=J/+=J/5J>/+:?V+=J/+:>/+:>/4*>/4*>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/
"J>/Y("GOC ,N"80B@TSA XFA XEAPTIBPTFFQ\UFQ$QDAPFA XEAPXFA XEA THAQD-L"0,OS:H+#>/+8"/+8"/+:>/+:>/+:>/+=N/+=J/+=J/4:>/+:>/
+:>/+:>/+:>/+:>/4*>/+:>/4*>/3J>/3Z>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/"J>HY8!!&NS86KB8-A TSA XFA XEAPTEAPTFD!!$Y
FQ$QDAPFA XEAPXFA XFA THAQD-MSX9O(]''"F^H+:>/+8"/+:>/+:>/+:>/+:?L+<2/+=N/3Z>/+=J/4*>/+:>/4+*/+:>/+:>/+:>/+:>/+:>/3:>/+:>/
4*>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/"F^/"F^GOC 1N#L-A XSA XFA XEAPTEAPTFD!!$OFQ$QD!!LFA XEAPXFA XFA THAQD-L"06OH]''"J=''
"J>H+:>H+:>/+:>/+:>/+:>/+:>/+:>/3J>/+=R/+=N/+:>/+:>/+:?L+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/"J>/
+8!!''!!7*GOC ,MB8/A XSA XFA XEAPTEAP$FD!!$YFQ$QD!!LFA XEAPXFA XFA TIAQD-L20:OH]''"J8?+8!!''"J>/"J>/"J>/+:>/+:>/+:>/+:>/+:>/+:>/
+8"/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/"J>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/"J=''+8"/!!6^GNC ,MB8/APTSA XFA XEAPTEAP$FD!!$O
FQ$QDALFA XEAPXFA XFA TIAQD-L206OC1@O*<=+8"/PH"/+8"/+:>H+:>/+:>/+:>/+:>/+<>/+:>/4*>/+:>/+:>/+:>/+:>/3J>/+:>/+:>/+:?L+:>/
+:>/+:>/+:>/+:>/+:>/+:>/+:>H+:>H+:>/"J=@+4B/ND@>OS 4M"8UAPTSA XFA XEAPTEAP$FD!!$YFQ$QDAPFA XEAPXFA XEAPTHAQH/L3X6NS8=NJ8=
+36."F^H+6^H+6^H+:>H+:>/+:>/+:>/+:>/+:>H3:?J3*>HY:>H+:<<+:<2+36/+:>HY22/NC:H+6^HO*>/+8"/+8"/+8"/+8"/+8"/+:>H+:>/"J>/O:>H
Y8^/O#<>NB06LR8UAPTSA XFA XEAPTEBP$FD!!$YFQDRDAPFA XEAPXFA XEAP$HAQH/K#D1M34=NH]''!!3>/!!6^H!!6^H+8!!''"J>/"J>/+:>/+:>/+:>/"B04
E3T5K"43L3L,M28/NB0IK!!T0MCX-EQH5C1XUL3D0C8"/Y8"/+:>H+:>/+8"/+:>H+:>/"J>/"J>HY:>HY8]''!!6\,OR06MR8UAPTSA XFA XEAPXEBP$FD!!$O
DQDRD0XFA XEAPXFA XEAP$HBQH/K#H,M#48OH]@"FZHO8]''"J8<+8]''"J>/"J>/+:>/+:>/"J>/+2<OA1T,A TSD!!D,OQTU"FXYN#LZEAPTD1T=K8 2C2<.
AR3J+:>H+:>H+8"/+:>H+:>/"J>/O8"/Y8"/"F^G^(]''!!38<NS\,MS@/APTSA XFA XEAPXEBP$FD!!$YFQDPD1PFA TEAQPSE@XEA $GBQ@UK#T1KC$=OS4<
!!3<?Y8]''"FZHY8".O#>/O("/O:>HY:>/"F^/"B8/E1X,MAX,DSHOESLVDQ@VM"<UMCHZC1D-KQ(VK!!HVDAZG2*=''"J=''+8!!''"J=''"J=''"J>HY8".O:<>+#:/
OC>GY3(,NB01LS@UBPTSE@XFA XEAPXIAPXFD!!$YFQDPE@XEA XEAPXFA XFA TGBQ@UK"81KC(=NS4=OC2GO31@!!6^HY#"H+36G+3>.OJ>HY8"/+32/+208
OS ,NC 8M#\:M# 4LSX,"B0:OX\:LSH,L#T7!!3 <M3*/OZ>GY8".O:<?Y8"/O:8?Y8^/O(!!&"F^HY8]@O3<<OB08M3\4L28ZA0XSE@XEAPTEBPXEAPTFD!!$O
F!!DPD0XEA XEAPTEA XFA TGBQLULCL2KCX8NB0=NC4=OS4>!!38<!!6\7!!7*GY8!!''!!6^H+#=''"C>GY8"/"J<?+#2/MC6/NJ8="FX=+36GO&^GO3:/OZ8>+3^.
''6ZHO6^GY8!!&"F^GY8!!&"F^GY8!!&"F^G"FZHPD@?O308M3 ,M205MS@YA0XTA XEAPTEA XEAPTFDA$YF!!$RDAPFA XFAPTIAPTFA TGBALVKST5KCX6M3 ,
OS$=KH\<OC8?M8]''!!3<<O8]''"FZHY8]''"F^GPC:.OX!!''!!39@PC2GO#0?OS08OS4=KC =OR0>M4@>O30?!!6^G+36HY(!!''!!6^HY(!!''!!6^HPH]''!!4A&"C<?O3>G
O#47NC\,N"03L24YA0XTE@XFAPTFA XEBPTFDADOF!!DRDALFA XFAP$IAPTFA TGBAPZK3L5MCD,M#\7NC\=NS4=OS48OS$=OS4=OS4>OC<8!!6^GO:<=!!38>
O3\=OS4=OS0,N#\8KC ,KC\,OC08OS 8OS0<OX]''!!6\9+36HO32GO3<<!!3<?OC<?PC8?O30?OC4=OS0=KH\8M20,L#P3L2<Z@ TSD1PFAPTIBPXEBPTFD!!DY
DQHPD1PEA XFAP$IAPTFA TGA0XOE3@.MSP4KCX,M"06NS\,NR09NS\7M3\8NC4,NC\<NC08KC4=M38=M34,OS4=OSX:KCX,M#D7KC\,KCP,M# ,NR09OS =
NC8,KC08NC48NC =OS48NC 8NC 8NB0=NS ,NB08M3\7KCX2K#H3L1XYB@XTA TEAPTEBPXEBPTTD!!DZDQHPDAPEA XEAP$IAPXFA TGA0XQER<-K#@5L#L4
MSH2KCP4MCD,LSD,LR01KCD,LR09KCD7M20=KC$,M"06LSD,LS(6KCH.LSL6MSD2L#L,MC(6LR06KCX,M#$7KC$,NR09KC$,NR09KC$,NR09KB06KCX1KC(,
MCP4MR82L3L/K1TPBQPRD0TEAPXFAPTFBPTSD!!$VFQDRD!!LFA XEBP$EAPXFA TGA0TQE!!\WKS@.LCL3L3T5MSH.L#L2L#H,L3P4L#T2L#H2MCP4LSH,MSP2
LR8,MCL4MCP2K#H0L"8.K"85MR83MST5LR82MCT2M#H,LSD1LR01LSD,LR01KCD,LSD1MCP2L#H,L#H2L"82L3T3K28VC1DSBQLWFQLFA XEBPTFBPTSDQ$U
FQ$QDAPFAPXEAP$IAPXFA XIA0 SFQ(VE2</K2</LC@0KS@-LCL3L283L28.K#L3L3L3L3T2L#T5MST5MSL3K#@-AP\HD0 PD1HPD!!@SBQLRDQDZLB8.KS@3
MST2K#T2L3H2K#H3L#L2L3H.MST3L3L3L283L3T3L240KR</F!!TUF!!HEBR47KQPIA TIAPXEBPTFDAHQFQ$QDAPFA XEAP$EAPXFA XIA0 EEALPDAHYDA$R
DQDQDQDYC1$ZEQTUEQTUEQTOEQ(ZF!!(UEQTUEQTUEP<UF!!(QA XFE@HEAPXIBP$EA0TIBP$ED!!HZF <UF!!$UE1T/ER<VER<ZE1TWE!!TUEQT/E"<VK1XVE!!XO
FQDZF <ZD!!@FA THDS >E0TEAPXFBPTIBP$FD!!DODQDQDAPFA XEBP$EA XEAPTIB@\B@ @B@ HGA0\GA0\GA0\GA0 BB@ HB@ HA0 GA0\GB@$IBP$IBP$H
B@ H@0HHA1HQD0XQDAHSD!!LPBQLFA $@B@\GA0\GB@$IBP\IB@$IA0 IBP$IBP HB@\HA0 @@@@@@@HHB@ IBP\HA@HHBP\IK$@8DP$FAPTTBPTIBP$FD!!$Z
DQDQDAPFA XEBP$EA XEA!!PSE@XEAPTIBP$IBP$IBP$IBP$IB@$GA0\GA0\GA0$IBP$IBP$IBP$IBP$IBP\EBP\G@@XF@ \SAPTIAP$E@@XEA TBBP\HB@ I
BP$IBP\HBP$HB@ IBP$IBP$IBP$IB@ HB@ HBP$IBP$IBP IAPXIBP$VOT@/A TSBP$FBPTEAPTFDADZDQDRDAPFA XEBPTEA XEA!!PFAPTTD1@SD1PTEAPS
EAPTE@XFA XTEAPTEAPTE@XFA XFA XFA XFA XFA XFA XFA0XFBP\RAP$IAP$IBQ@IB@\BA!!PEAPXFEAPSD1PSD1LSEALSEAPTEAPTA XEA XFEAPSD1PF
A XTD1PTA XFDR4:OSLFAPXFAP$IBPTEAPTFDADZDQDRDAPFA XEAPTFA XIAPXFA!!HULCL.K#@0LC@0LC@0LC@0LB4.K"8.K"8.K#@0LC@0LB4-KR40LB4-
KR4/E1\VA XEB@ QA TEAP$EBQHIB@$IDQ(/K24-LC@0LC@0K"80LC@0LC@0LC@0LC@0K"83MST5MR80LC@.L28.LB45N#(2E \IA XEA TIBP$IBPTTD!!$Z
DQDRDAPFA XEAPXFA TFA TIBPTSD!!LSD1LSD1LSD1LSEAPTA XTEAPTEAPTEAPTD1LTE@XFA XTEAPFA XFAPXFA0TEA0HQAP$EBP$IBAHIBP$@APXEAPXT
EAPTE@XFEAPFA XTEAPTEAPTA XFA XFEAPTEALSEALSD1LSA XTA TEBP$FA TIAPTIAP$IBPTSDQ$ZDQDRDAPFA TEAPXFA TEAPTEA TEBPTEAPTEAPTE
APTEAP$IBP$IBP$IBP$IBPTEAPTEBP$IBP$IBP$IBP$GA0HG@@XFA0HQAP$EAP$IA1HIBP$CA0\GB@$IBP$IBP$EAPTEAPTEBP$IBP$IBP$EAPTEAPTIBP$I
BP$IAP$IBPTFB@TTAQPEAPTEAP$IAPTEBPXSDQDQFQDRD!!LFA XEAPTFAPTEAPTEAPXFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$I
BP$IA0\G@@XEB@\QAP$EAPTEBADIB@$@A0 HB@$IAPTEBPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBPTEBPTFD1HQ
FQDRDALFA XEAPTFAPTEAPTEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IA0\G@@XEB@\QAP$EAPTEBADIB@$@A0 HB@$I
APTEBPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBPTEBPTFDADODQHRDAPFA XEAPTFAPTEAPTEAPTFA TEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IA0\G@@XEB@\QAP$EAPTEBADIB@$@A0 HB@$IAPTEBPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBPTE
APTEAPTEAPTEAPTEAPTEAP$IBP$IBPTEAPTFDADZDQDRD1PFA XEAPTFAPTEAPTEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$I
BP$IA0\G@@XEB@\QAP$EAPTEBADIB@$@A0 HB@$IAPTIBPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBPTEAPTEAPTEBPTEAPTEAP$EAP$IBP$IBP$EAP$EDADY
DQDRD0XFA XEAPTFAPTEAPTEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IA0\G@@XEB@\QAP$EAPTEBADIB@$@A0 HB@$I
APTIBPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBPTEAPTEAPTEBPTEAPTEAP$EAP$IBP$IBP$EBP$ED1DYDQDRD0XFA XEAPTFAPTEAPTEAPTFA TEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IA0\G@@XEB@\QAP$EAPTEBADIB@$@A0 HB@$IAPTEBPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBPTE
APTEAPTEAPTEAPTEAPTEAP$IBP$IBPTEBP$ED!!DQDQDQD0XFA XEAPTFAPTEAPTEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$I
BP$IA0\G@@XEB@\QAP$EAPTEBADIB@$@A0 HB@$IAPTEBPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBPTEBP$FDQ$Q
DQDQD0XFA XEAPTFAPTEAPTEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IA0\G@@XEB@\QAP$EAPTEBADIB@$@A0 HB@$I
APTEBPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBPTEBP$SFQ(QDQDRD!!LEA XFAPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBPTEAP$EBP IB@\G@@XIB@$PBPTEBPTEA1HIAP @BPTGA0$IAPTIBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$I
BPTEAPTEA XFA TEAPTIBP$IBP$IBPXEBP\SDADZDQDQD!!@FA XFAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBPTEBP$I
BP IA0\G@@XEB@$RBPTEBP$IA1DIAP @A0 GB@$IAPTEBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$IBPTEAPTEA XFA TEAPTIBP$IBP$IBP$HBP$SDA$O
FQDQD!!LFA XFAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBPTEBP$IBP IA0\G@@XEB@\QAP$EAP$IA1$IBP$@@ \GB@$I
APTEAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$IBPTEAPTEA XFA TEAPTIBP$IBP$IBP$IAPTTEADQFQDRD!!LEA XFAPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP HA0\G@@XEB@\YAP EA TEA1(IB@$BA0 GB@$IAPTEAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$I
BPTEAPTEA XFA TIBP$IBP$IBP$IBPXIAP$EA!!$YDQHRD!!@FA XFAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEA XFAP$I
BP\HA0\G@@XEB@$ZAP EAPTFBQXIB@$BA0$HB@$IBPTEAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$IAPTEAPTEAPXFA TIBP$IBP$IBP$IBPTHAP$ED1XU
DQHRD!!LFA XFAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEA!!PFAP$IBP GA0\G@ XEB@XZAP$IBP$EA!!XIBP$@@ \GB@ I
BP$EAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTFAPTIBPTIBP$IBP$IBPTIAP$TD1(ZFQDRD!!PEA XFAPTEAPTFA XFA XFA TEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPXEBP IBP GA0\G@ XEB@TQBP$IBP$EAQDHAP$@@ \GA0 HBP$IAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTE
APTEAPTEBPTEAPTEAPTIBP$IBP$IBPTEAP$SD1DQFQDQD!!LFA XFAPTEAPTFA XFA XFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBPTIB@ I
BP GA0\G@!!PEB@\SA0TEBPTEA1LBA T@A0 GA0\HB@$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTIBP$EAPTEAPTIBP$IBP$IBP$IBP\SD1DO
FQDRD!!LFA XEAPTEAPXFA TEA XEBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$HB@\HA0$DA!!\FBPTIBP$EAPTIAP$EAP$B@@HG@ \H
A0$EBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$EAPTEAPTIBP$EAPTEAPTEAPTEAPTIBPTIBP$FDADYFQDQDQLEA XEAPTEAPXFAPTEA XEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBP HB@\B@0@GF#@SB@$IBPTEAPTIAP$IBP B@@HG@ \HA0$EBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$E
APTEAPTIBP$EAPTEAPTEAPTEAPTIBPTEBPTFD!!DYFQ$YFQ@EA XEAPTEAPXFAPTEA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBP H
B@\HAPXRE!!$EA0$IAPTEAPTEBP$HBPTEAPXG@ \HA0 EBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$EAPTEAPTIBP$EAPTEAPTEAPTEAPTIBPTEBPTTD!!DO
FQ$YFQ@EA XEAPTEAPXEAPTEA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP HB@\@A!!PSD0 GBP IAPTIBP$EA TIBPTEAPTG@@\H
A0 IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$EAPTEAPTIBP$IAPTEAPTEAPTEAPTIBPTEAPTSD!!$YFQ$QDQLEA XEAPTEAPXEAPTEAPXEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP HB@\CA  HBP\IBP$EAPTIBPTEAP$IB@ IB@\G@@\IB@ IAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$E
APTEAPTIBP$IAPTEAPTEAPTEAPTIBPTEAPTSD!!$YF!!$QD!!LFA XEAPTEAPXEAPTEAPXEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBP H
B@\@D0$HAP$EBPTEAP$IBP$IBP$IB@$IBP H@@HIB@\IAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$EAPTEAPTIBP$EAPTEAPTEAPTEAPTIBPTEBPTTD!!DO
F!!$QD!!LFA XEAPTEAPXEAPTEAPXEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBP HB@\DA TGBP IBP$G@ @@@@@@BPTFAPTIBP\H@@HI
B@\IAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$EAPTEAPTIBP$EAPTEAPTEAPTEAPTIBPTEBPTFD!!DYF!!(QD!!LFA XEAPTEAPXEBP$EAPXEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBP HB@\@A TIAP$IB@HCA@DA@PDA@@\EBP$EBP H@@HIB@\IAPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBP$E
APTEAPTIBP$EAPTEAPTEAPTEAPTIBPTIBP$FDADYF!!$QD!!LFA XEAPTEAPXEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP G
A0\BAPTIBPTI@@LA@P@HA0LD@PHEAP$EAP$I@@\HA0$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IAPTEAPTEBP$EAPTEAPTEAPTEAPTEAPXEAPTFD1DZ
FQ$QDAPFA XEAPTEAPXEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP GA0\@APTIBPTG@@PA@P@GB@@D@PLHAP$IAP$I@@\H
A0$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBPTFD1DZFQ$RD0XFA XEAPTEAPXEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP HA0\@APXIBP$B@0D@A XGA0\C@PDBAP$IBP$I@@\HA0$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$I
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPXEAPXSD!!$UF!!$RE@XFA XEAPTEAPXEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IBP H
A0\@A XHBP$C@PDPK!!\G@@ B@0DCBP$IBP I@@\HA0$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPXEAPXSDQ(W
F!!$RE@XEA XEAPTEAPXEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IAP$IBP HA0\@A XHBP D@PLQMQ\G@0$H@ PCBPTIBP I@@\H
A0$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBPTTD1DZF!!$RE@XFA XEAPTEAPXEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IAP$IBP$HB@\@A TGBP D@PLFDQLBA0$GA0LD@ TIB@$I@@\HA0$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$I
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBPTTD1DOFQHSE@XFA XEAPTEAPXEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IAPTIBP$H
B@\@A TGBP D@PLBB@\BA0 B@ LAA@$EB@$I@@\HA0$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPXEAPXSD!!DZ
DQ@SE@XFA XEAPTEAPXEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IAPTIBP$HB@\@E@TGBP D@PP@A0 G@ HB@@LA@P$EA0$I@@\H
A0$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IAPTEAPTEBP$EAPTEAPTEAPTEAPTEAPTIBPXSDADZDQHFAPTFA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP GA0 @A XHBPTB@PPC@@HG@ @C@0@ABQ$IBP$I@@\HA0$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTIBPTEBPTTD!!$ZF!!$RE@XFA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP G
A0 @APXHBPTG@0DAA@@GA0@CA@PAF#TT@ $I@@\HA0$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBPTEBPTTD!!$Z
EQXYD0XFA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP GA0 CAPXHBPTIA0DA@PLGB@@A@PDPMATHAPTI@@\H
A0$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBPTEBPTTD!!$ZF!!(QD0XEA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IBP GA0 @APXHB@TEAPHCA@PC@0PAA@T5MPTBA \I@@\HA0$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTIBPTEBPTSDQ$ZFQDPA TEA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IBP G
A0 @APXHB@$EAPXI@@DA@PL@FSL-AP$EA0$I@@\HA0$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBPTEAPXSDQ(U
FQDSE@XFA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP GA0 @APXHB@$IBPTEA XSDQX/K1TE@0$EA0XI@@\H
A0$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBPTEAPXSDQ(UFQDRD0XFA XEAPTEAPTFA XFA XFA TEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP GA0 @APTHBP$IBP\IA!!PSD1HRA \GAP$HAP\I@@\HA0$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTIBPTEAPTSDQ$ZF!!$QD0XEA XEAPTEAPTFA XFA XFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP G
A0 @BPTHBP$HB@ IB@ GA0\G@ TIA0\GAP I@@\HA0$IBPTEAPTEAPTEBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBPXEAPTTD!!DY
FQ$QD0TEA XEBP$FA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$HA0\IBP$IBP$IBP HB@ HB@ HB@ HB@ HB@ @@@HG
B@$IBP$EAPTEAPTEAPTEAPTEAPTIBP$EAPTEBPTEAPTEAPTEAPTEAPTEAPTIAPTEBP$IAPTIBPTSDQ$ZFQ$QD0TEAPXFAP$EA XEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTIBP$IBP$IBP$IBP$IBP$IBP$IBP GA0\@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@B@ \GB@$IAP$EAPTEAPTEBP$IBP$IBP$IAPTEAPTEAP$I
BP$IBP$IAPTEAPTEAPTEAPTIBP$IAPTIBPTSD!!$ZFQ$QD@XEBPTFAP$EAPXEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTI
BP @@@@@@@@@@@@@@@@@@@@@@0LC@0LC@0LB@ \GB@$IBP$IBP$IBPTEAPTEAPTEAPTIAPTEAPTEAPTEAPTEAPTEAPTEBP$EAPTEAP$IBPTEAP$IAPXSD!!DY
FQ$YD!!PEBPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$IBP$IBP$IBP$IBP$IBP$HA0\GA0\GA0\GA0\GA0\GA0\GB@ HB@ HB@ B@ \G
B@ IBP$IBP$IBP$IBP$IBP$IBP$IBPTEAPTEAP$IBP$IBP$IAPTIBP$IAPTEAP$IAPTEAP IAPXPD!!DYFQ$YDQLFAP$IAPXFA TEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBP$IB@ HB@ HB@ HB@ HB@ HB@ HA0\GA0\GA0\GA0\HBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTIA0\IAQLRDQ$YFQ$YDQ@FAP GBPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTFA XFA XFA XFA XFA XFAPTEAPTE
BP$HB@ HB@ HB@\GA0\GA0\GBP$IBP$IBP$HB@ IBP$IBPTEAPTEAPTEA XFA XFA XEAPTEAPTEAPXFA XFA XFAPTEAPTEAPTEAPTIBP\B@@\IA!!LRDQ$Y
FQDYFQHSA $GA0 GB@$HB@ HB@ HB@ HB@ HB@ HA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\B@ HGA0\GA0\GA0HB@ HB@ HB@ HB@ HB@ HB@ \G
A0\GA0\GA0\GB@ HA0\GA0\GA0\GB@ HBP HB@\GA0\GA0\GB@ HA0\HB@ HB@\G@@@@@@$ZF!!HQDQ$YDQDQFQDSD0TIA0@C@0H@@@@@@@@@@@@@@@@@@@@@
@0LC@0LC@0L@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0@@@@@@@@@@@@@@@@@@@@@@@@@@
@@@@@@@@@@@C@0LC@@@@@@LC@0LBA0TZF!!HQDQ$YFQ(ZFQDQD1PFBP\B@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@C@@@@@@@@@0@@@@@@@@@@@0@@@@@@
@@L@@0LC@0LC@0LC@0L@@@@@@@@@@0LC@0@C@0LC@@@@@@LC@@@C@0L@@@@@@@@@@@@@@@@B@ @@@@@@@@@@@@@@@0LC@0LC@0L@@0LC@@HIF!!(ZD!!DQDQ$Z
FQ$YF!!(ZF!!(ZAP$IB@\GA0\GA0HB@ HB@ HB@ HB@ HB@ HB@ HB@ HB@ HB@ HB@ HB@ HB@ HBA0\B@ HB@ HB@ HBA0@@@ HB@ HBA0\B@ @B@ HB@ HB
@ HB@ \HB@ GA0\GA0\GA0\GA0\HB@ HB@ HB@ HB@ HB@ HA0\GA0\GA0\GA0 HBA(ZF!!(PD!!DQDQ$ZDQ$YFQ(ZF!!(ZF!!(ZAPTIBP$IBP$HB@ HB@ HB@ H
B@ HB@ HB@ HB@ HB@ HB@$IBP$IBP$IB@ IBP$IB@ IBP$IBP$IBP HB@ HBP$IBP$IB@ HB@$HB@ HBP$IBPTFA TEBP$IBP$IBP$IBP$EAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTZF!!(ZF!!(ZF!!(RD!!DQFQ$ZDQDQDQDQF!!(SA!!(ZF!!(ZF TEAPTEAP$IBP$IBP$IBP$IBP$IBP$EAP$IBP$EAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPXFA XEAPTEA XFA XFA XEAPXFA XEAPXFA XFA XFA XFA XZF!!(ZF!!(ZF!!(ZF!!HRD!!DYFQ(Z
') ; colorMapFromArray:#[10 10 10 0 0 0 13 13 13 6 6 6 3 3 3 26 26 26 30 30 30 16 16 16 20 20 20 23 23 23 0 0 63 0 51 0 0 51 63 51 0 0 51 0 63 51 51 0 40 40 40 46 46 46 43 43 43 36 36 36 33 33 33 60 60 60 57 57 57 63 63 63 51 51 63 50 50 50 53 53 53 0 0 127 0 51 127 51 0 127 51 51 127 0 102 0 0 102 63 51 102 0 51 102 63 0 102 127 51 102 127 102 0 0 102 0 63 102 51 0 102 51 63 102 0 127 102 51 127 102 102 0 102 102 63 70 70 70 77 77 77 67 67 67 73 73 73 93 93 93 87 87 87 80 80 80 90 90 90 83 83 83 97 97 97 107 107 107 110 110 110 104 104 104 100 100 100 102 102 127 117 117 117 114 114 114 120 120 120 124 124 124 127 127 127 0 0 191 0 51 191 51 0 191 51 51 191 0 0 255 0 51 255 51 0 255 51 51 255 0 102 191 51 102 191 0 102 255 51 102 255 102 0 191 102 51 191 102 0 255 102 51 255 102 102 191 102 102 255 0 153 0 0 153 63 51 153 0 51 153 63 0 153 127 51 153 127 0 204 0 0 204 63 0 255 0 0 255 63 51 204 0 51 204 63 51 255 0 51 255 63 0 204 127 0 255 127 51 204 127 51 255 127 102 153 0 102 153 63 102 153 127 102 204 0 102 204 63 102 255 0 102 255 63 102 204 127 102 255 127 0 153 191 51 153 191 0 153 255 51 153 255 0 204 191 0 255 191 51 204 191 51 255 191 0 204 255 0 255 255 51 204 255 51 255 255 102 153 191 102 153 255 102 204 191 102 255 191 102 204 255 102 255 255 153 0 0 153 0 63 153 51 0 153 51 63 153 0 127 153 51 127 153 102 0 153 102 63 153 102 127 204 0 0 204 0 63 204 51 0 204 51 63 255 0 0 255 0 63 255 51 0 255 51 63 204 0 127 204 51 127 255 0 127 255 51 127 204 102 0 204 102 63 255 102 0 255 102 63 204 102 127 255 102 127 153 0 191 153 51 191 153 0 255 153 51 255 153 102 191 153 102 255 204 0 191 204 51 191 255 0 191 255 51 191 204 0 255 204 51 255 255 0 255 255 51 255 204 102 191 255 102 191 204 102 255 255 102 255 153 153 0 153 153 63 153 153 127 153 204 0 153 204 63 153 255 0 153 255 63 153 204 127 153 255 127 204 153 0 204 153 63 255 153 0 255 153 63 204 153 127 255 153 127 204 204 0 204 204 63 204 255 0 204 255 63 255 204 0 255 204 63 255 255 0 255 255 63 204 204 127 204 255 127 255 204 127 255 255 127 130 130 130 140 140 140 137 137 137 134 134 134 154 154 154 157 157 157 144 144 144 150 150 150 147 147 147 153 153 191 164 164 164 161 161 161 167 167 167 174 174 174 171 171 171 191 191 191 181 181 181 187 187 187 177 177 177 184 184 184 153 153 255 153 204 191 153 255 191 153 204 255 153 255 255 204 153 191 255 153 191 204 153 255 255 153 255 204 204 191 204 255 191 255 204 191 255 255 191 194 194 194 204 204 204 201 201 201 197 197 197]; yourself]
!

onImage
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self onImage inspect
     ImageEditor openOnClass:self andSelector:#onImage
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:'VUMeter class onImage'
        ifAbsentPut:[(Depth8Image new) width: 150; height: 144; photometric:(#palette); bitsPerSample:(#[8]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA
@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA
@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA
@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDAD!!@PA TEAPTEBPTEA TEAPTEA TIA XFAPTEAPTEAPTEAPTEBPTEAPTEAP$IAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTFAPTEAPTEAPXEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTFAPTEAQLTD DA@PDA@PDA
@PDA@PDA@Q(TE@\EB@TTAP$EAPTFE@ TAP EA XEA TEAPTEA XEAPTEA!!PIAQPIAPTFE@TIAPTEA XFAPTEAPTTBPTEA TEAPTEAPTFA TEA XEA!!LHAPTE
APTEAPTEA XEAPTEAPTEAPTEAPTFA XFAPTEAPXFAPXFA XFAPTEAPTEAPXTBPTEB@$IBQHRFPDA@PDA@PDA@PDAD!!@SDQT5N#$3MST3KR4-LB83MR8/L28.
K2</K2<0K"4.LCL0K#L-K24/ER<-K3@0LB<0L28.L3@.KR4.K"4-K#@0L28/LB</L28-LCT3L3H3L24-LC@3KR<3K"85L3@-K#@0L3L-LC@3L3L3L3L0LC@-
K3@.LC@-KR40LC@0LB4/K1(RE@ EAPXSD!!$A@PDA@PDA@PDVA!!D/NZ<8K!!XTDALSD1LPDA@PD1@SD1LSD1LSDAPFA XTD1@PD1LSD1LPDALSD1LSDA@SD1@P
DALSD1LSD1LSD1@TA!!PFA!!PTA!!LPDA@TEAPFD1LSD@XFE@XSDA@PDA@SD1@PD1LSDA@PDA@PD1@PDALPD!!@SD1LSD1LSD1LSD1@RDA@EAP EBP ED1HQ@PDA
@PDA@PDSD289OSXY@ \IBP$IBP$IBP$IBP$IBP$IBP$HB@ HB@$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IB@ HB@ HB@ IBP$IB@ GA0 IBP$H
B@ GB@$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IB@ IBP$IBP$IBP$IB@ HBPTEAP IA!!@R@PDA@PDA@PDTF#(8LQLH@!!PHAPTEAPTEAPTEBP$IBP$I
BP$IBP$IBP$EAP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTIBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$EAP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$IBPTE
AP$IBP$EBP$IBP$IBP$IBP$IBP$IAP IAQPR@PDA@PDA@Q@SK3X1EP\IEAPHAPTEAPTEAPTEAPDEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPXFA XFA XFAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTFA TEAP$IBP$IBPXSD DA
@PDA@QHSESL/AP\FB@ HAPTEAPTEAPTEAPTEBP$IBP$IBP$IBP$EAPTEAP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBP$IBP$IAPTEAPTEAPTEAPTE
BP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBPTEBP$IAPTEBP$IBP$IBP$IBP$IBP$IBPTIBPTSD DA@PDA@Q@PEAPTA0 FA0TEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTIBP$IBP$IBPTIBPTSD DA@PDA@QPFA0THE@THBPTEAPTEAPTEAPTEAPTIBP$IBP$IBP$IBP$EAPTEBP$IBP$IBP$EAPTEBP$IBP$I
BP$EAPTEAPTEAPXFA XFA XFBP$EAPTEAPTIBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBPTEAP$IBP$EAPTIBP$IBP$IBP$EAPTEAP$IBPTEBPTTD@DA
@PDA@PXEAQLH@ TEAPTFA XFA XFA XFA XEAPTEAPTEAPTEAPTFA XFAPTEAPTEAPTFA XFAPTEAPTEAPTFA XFA XFA $IBP$IBP$IAPTFA XFE@THAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTIAPTEA XTAP EAPXTAP$EAPTEAPTEAPTIBP$IBP$IBPTEBPTFD0DA@PDA@Q@FAPTEAPTEAPXEAPTEAPTEAPXFAPTEAPTE
BPXFAPTFA XFA XFA TIBPTEBP$IBPTEBP$EA XFA TEBP GA0\@@@LC@@@@@@@C@@@@@ \GA0\IBPTEAPTIBP$EAPTEAPXFAPTEAPTEAPTEAPTEAP$IAP$I
AP$IAPTEBP$EAPTEAPTEAPTIBP$IBPTIBPTFD0DA@PDA@QHFA XEAPTEAPXEAPTEAPTEAPXFA TEAPTEAPXFAPTFA XEAPXFA TEAPTEAPTEAPXFE@XEAP$G
@ @B@@@@@@H@@@@@@ HG@ HB@ HB@@@@@0LC@0@@A0$EAPTFA XEAP$IBP$EAPTEAPTEAPTEAP$IBP$IAPTEAPTEBP$EAPTEAPTEAP$IBP$IBPTIBPTFD0DA
@PDA@QHFA XEAPTEAPXEAPTEAPTEAPXFA XFA XFAPXFAPTEA TEAPTEAPTEAP$IAPXFA XEAP$G@ @C@0L@@@\HAPXSD1LSD1@RD!!HRDALSE@XEBP B@@LC
@0@@@  HBPTEBP$IBP$IAPTEAPTFAPTEAP$IBP$IBPTEAPTEBP$EAPTEAPTEAP$IBP$IBPTEBPTFD0DA@PDA@QDFA XEAPTEAPXFAPTEAPTEA XFA XFA XF
A XFAP$EAPTFA XFA TEAPTEA XFBP G@0L@@@\HAPXPD!!DZER<-KR4-KS@0LC@0LB4-K1\UE!!(QD@XEB@H@@0@@@@\HBPTFAPTIBP$EA XEAPTEAP$IBP$I
BP$IBPTEBP$EAPTEAPTEAP$IBP$IBPTEBPTFD0DA@PDA@QHFA XEAPTEAPXFAPTEAPTEA XFA XFA XFA XFBP$EAPTFA XFA XFA!!LFAP$G@ @@@@\ED1HO
ER<0LCL5L#P1LSD,LSD,M#X,LR01MCH3L#T3LB<UC1@FAPHG@ @@A0$EAPTEAPTEAPXIBPTEAPTEAP$IBP$IBPTEBP$EAPTEAPTEAP$IBP$IBPTEBPTFD0DA
@PDA@Q@FA XEAPTEAPXFA TEAPTFA XFA XFA XFA XEBP$EAPTEAPXFA XFA $H@ L@@ $ED!!DVE24.L#P4LR0:NC4>OH\>O8]''"H!!&"H!!&"C0=NB07KCH.
L3@ZEQ@PB@ CA@@B@ $EA XFAP$IBP$IAPTEAP$IBPTEAPTEBP$EAPTEAPTEAP$IBP$IBPTEBPTFD0DA@PDA@QLFA XEAPTEAPXFA TEAPTFA XFA XFA XF
A XEBPTFA TEAPXFA TIBP@@@@\ID1$VKR82LR06KC4=OJ:H+:>/+:>/3J>/+<:/+<:/+:>/+8"/O#<<NB02L3L.F!!$TB@\G@@HGBPTEAPTIBP$IBPTEAP$I
APTEAPTEBP$EAPTEAPTEAP$IBP$IBPTEBPTFD0DA@PDA@QLFA XEAPTEAPXFA XEAPXFA XFA XFA XFE@XEBPTFA TFA XFAP B@@\IA!!HZK3@5MCD,M35@
+&^/3,6/4:?T5-J:6-WT4-[V5-[V.-SS+=R/+:>/"F^GOC$7KB8.F!!PT@0\BA0 IA XEAPTIBP$IBP$IAPTEAPTEBP$EAPTEAPTEAP$IBP$IBPTEBPTFE@DA
@PDA@PXFA XEAPTEA XFA XEAPXFA!!PFAPTFA XFAPTEAPXFA!!PFE@XI@@@GBQPQER40MR06OX]''+:>/3;+T5++Z6M+[1M#[6\S[5<SX5<SU6-/Z.-"/5Z?T
+:>/+:>HO34,MS@VC1@IA0@BBQPIAPTEBPTIBPTEAPTEAPTEBP$EAPTIBP$EAPTIBP$IBPTIBP$FE@DA@PDA@QPFA XEAPTEA XFA XEAPXFA!!PFA XFA XF
E@XEBP$IA!!PFAP\@@@ TDQ\-L3H6KH!!''+:>/3]R:6]''D5]_W6^WY;NWW;M_W6]_W6=/W1M+W6M#D5]WZ.-V/+=N/+:>GOS\6LB<YD0TG@ \EA XEBP$IBPTE
APTEAPTEAPTFA XEAPTEAPTEBP$IAPTIBP$FE@DA@PDA@QPFA XEAPTEA XFA XFA XFA XFA XFEAPTD1PEBP$EAPXHA0\GAQHWKST4KC =+:?I3M[X1M+W
1M''%5>3%:_G%;OG,9^W%9^W%9^W):]_W6]/W5>3Y1M+X.-*/3]N/+8!!&N#$3KQ(SB@@GBPTEAPTEBP$IBP$EAPTEBPTEAPTEAPTIAP$IBP$IBPTIBP$FE@DA
@PDA@QPFA XEAPTEA XFA XFA XFA XFA XTD1PTE@XFA XFBP\BB@XRE"45MB09!!<&/+<3V6K+W;M_,9^319^31<_G0<^7-;^7-;^7-<_G1<_G%9^W%:^''W
6\S[6K+Y+="/5J>/+8\=KCP-C1LBA0 EA XEBP$IBP$IAPTEAPTEAP$IBPTEBPTIBP$IBPTIBP$FE@DA@PDA@QPFA XEAPTEA XFA XFA!!PTEAPFA XTD1PT
APXTA TIA0HID1(-L3P,M3>/+<3S6-V:9^3+9^W%<^7%;>_/;>?.;^_/;>?/;>?/;>?/<^?'';_C19^W1:]_W5<SY6=&:6*?S+:>/OS86K"<SAP\GBPTEAP$I
BP$IAPTEA XFA TEAPTEAPTEAPTEAPTIBP$FE@DA@PDA@QPFA XEAPTEA XFA XFEAPTEAPFA!!PTEAPFBPXFBPH@B@XYE282LR0?+,./4++Y6>'',:\S,<_C/
9>?.;>?/;>7.;.;.;.;.;.;.;.;-9>?/;>?-;\S19^W%9^''W1M_W6;+X+=R/+:<=KCX.F!!PB@@HHAP EAPTEAP$IA XFAP$IBPTEAPTEAPXFAPTIBP$FE@DA
@PDA@QPFA XEAPTEA XEA XTEALSEAPTA!!PTE@XEBP$IA0HID!!X.L#D,OJ:_+:?V-M[X6>3D;OC-;<[.;.;-;.;.=.;.=.;6;/[.=.;.;>_.;.;.;.7D;?G-
<OC%9_G)9^WW6\S[.-&/+:>/"D@=LR<SBP\GA $IB@TEBP$IBP$EBP$IAPTPAPTEAQPEAPTIBP$FE@DA@PDA@QPFA XEAPTEA XEA XTD1LSD1LTEAPTA XE
AP\@@@$QK3L4KC&/O:>/4++Z6=_W9^''19>?/;>?.;>_6;/[6;/[69?W6=/[.=.;6;/[.;.?-;^?-;>?-;_C/1OC0<^W%;N''W1MWU.-R/+:<<NR00D@$@@0XI
BP EBP$IBPTEAPTEAPTEAPTEAPTEAPTIBP$FE@DA@PDA@QPSA XEAPTFA XFEALTEALSD0TFE@XFA TH@@@@BQ$/K#P7O8_L+=J/6K+,1M_)<_G-;/C'';.;6
;/[69?_/=.;6=/_''=/_6=._7;.;(9>;6;^;6<N_.<^?-9>7/;>W,9^3)6]/Y/][R4:>/"C<,L!!TS@ @GA THAPTFAPTEA XTAPTEAPTEAPTEBPTIBPTEA DA
@PDA@PXFA TEAPTFA XEA!!LTA!!PSEAPFA XFA $G@@\FFR42KC^/+:?S5++Y5;SX;NW%9>7.;/[6=/[6;/[6=^;(9>#6=_[6:N_6;.#.=>_7=/W.;.#/;/[.
;._/;?G0<_C-9>W,1M_W6M/X.-R/3J<=NSP/D \HBPTEAPTEAPTEAPXFAPTEAPTPAQLEAPTIBPTEA DA@PDA@PXFA TEAPXFA XEEALSEALSEALFAPXTAP\@
A0XYKSP:OJ>/3-KZ6M+Y5=_%9^W0;^?6;>;6=._7=/[6:O[6=.;7=^#''=__6=/[5=__6=_W6;>_6;/[.;/[/;>?1;_C-;>W%<^''%5=/Y-NF/5J>/"C81K!!HE
A0$FA TIAPTEAPXFAPTEAPTEAPTFAPTIBP$EA DA@PDA@QPSA TEAPXFA XFEALSD1LSE@XFA!!LFB@HBDA(-L"0<Y:?P4;+Y6[7X:^W);OC.;>7.=/W6=_[7
=_W59?W6:O[5=/[(;?W(=._7=?[6:N?/=?_6=.;6;/[/;>;6;/[1;_C-9_G%9^''X6]&:5Z>/+:<,NS@YBP\FE@XEAPTEAPTEA XSD0TED0XEAPTEBP$EA DA
@PDA@QPTA XEAPTFA XEEALTEALSE@XTD0XH@ $SK3L4KDB/+<?U6<SZ5>3):^W1<N7'';/[.=/_5=?[.=^#6=^#85>;(=/[6=.#UE"3/=?_(;/[(;.7''=?[7
=.;.=.7-;>;.;/C/<^7%9^3W1M+Y.-*/+<>/NC\3C0\HBPTFAPTEAPTEA XSD0TSA TEBPTEBP$EA DA@PDA@PTFE@XEAPTFA XEA XFA XFA!!PSA $BBAH/
L3D8PJ>/4;+X5]_,5>''%9^W'';.71;/W5=?[.=__7=/[6=?Z.E"39:O[6:N:/+3N/:O[6=.#1KH_:=_W69?_7=/W69>;/=/G/;>?D;NWY:\SY6;+X+:>/+3 6
MP<IA0$TAPTEAPTEAPTTD0TEA TIBPXEAP$EA DA@PDA@PTFA XEAPTFA XEA XFAPXTEAPFAP ID"42LS5&2MN:5]+W5>''W:^319>W1;>7/=/[.=/W5=.;7
=/[6=_W[+2;7=/W5=.?.;#V::O[7=>#VA(_;=/[5=/[69<S1:O[-;.;.<OG-<_G%;N3D6-.:6*>/+:<=KB8RBP EAPTEAPTEAPTFEALTA XEA XFAP$IAPDA
@PDA@PXFA TEAPXFA XFD1LFA!!LSD0XEB@$PK3H4OZ>/+=[X6LSW;NW)<_C-;?C/9>;/=.6:KJ?7:O[6=>#7:N?561+1:O[(NB?/KJ;7=^#.!!=S6M:?7=/[6
9>#/+0<89^#/9>?/;.;F;_C09^3%1M#Z6;+R+:>HO203D $GAPTEAPTEAPTEAQLSE@XFEAPFAP$IAPDA@PDA@PTFA XEAPXFA XFAPXFAQLPA XGA1LWLCD<
+,+S5K+W5>W%5>''''<N?/1N_-;>7/9?TWL^W:=?W6=>#7+2?[=3 8=_[(<^:GBB3%=?W7OH_(MZ?>=/[6=.#0K:<0<N?6=.?'';>;1;\S-1N3,;LSX6].:4*>/
+3 7MP<BBPXFBP$EAPTFAQPSD1PFA XFAPTEA DA@PDA@PTFA XEAPXFA XFA!!LSA!!LPA $EA!!$0L"2/+=CT6\SX;NW,9>?-<LS.=.;/<^;.;?T3C231=>#7
=/[6;\SVLAV/:O;(>^#[OJ;W>.#7>.#8L-_7=/_7=.;WM],0<N#/=.;6;.;6;N7);_C%9]_Y1M#V.-Z/+:87M"<TA0\FB@TEAPTEAPXTE@XFA XEAP$EA DA
@PDA@PXFA XEAPXFA XFA!!LSEALSAP SF#@1M3>/3]+Z5=_%9_G1;>?D;/[W+>?0=_[/=.&/5R2.>N;7:OW6=>#>../>=_W7=?_7=>#7=/W6=?W(:^?5=/[/
=?^:L#:G=?_.=^#'';++.;.#,;\S%:^WW6<SZ6*>/3:>HO3D-A0\IA TIAQPEAPXFA XFAPXEBP$IAPDA@PDA@PXFA XEAPXFA XFAPXFA XEA0$QKSP,"J?S
6-+W9^W%<N7.1N?.;8\VC>?-;^W6+!!CT5CT8:O_7=>#7:O[;:OC7:O/7:O[7+/G7:OW(=?[%=_[6=__7:O./L!!_[=?[(;?Z/L"3963R.<^_09^W)5=/[6K+T
+:>/!!301FPXGAPXEBPTEAPTEAPTEAPTEBP$IAPDA@PDA@PXFA XEAPXFA XFAPTEA XIA1LVMR0<+:?U6LSX9_C-;>;/9>;-;:87KN''/;/[%9^3-NCG1=^#7
=/_(=/_5=(_%=?_6=>#:KN3>:O[6;. =1O;7=?W(;.#9;OG(=_[5=/V.@Q''U!!0CM;/G09^W%:]''D5-Z:5Z>/+3 ,K!!$HA0XFBP EAPTEAPTEAPTEBP$IAPDA
@PDA@PXFA XEAPXFA XSA TEE@XEAQ(-L#"/+<7X6.''%9^7/<N_/=/[-=.?-K._5;^75;.;7=>;(>__7=>#7=/W6:C;1:O_(=?W(O_[6=.#>>. =<^#6=/[(
;/_,9_W6=?_6=._[KL3.+3O.<N?%<NW%;M/X6]&:6J>/+8 ?M24FA0TTA $EAPTEAPTEAPTEBP$IAPDA@PDA@PTFA XEAPXFA XFD0XFA TFD"42KH"/5J?,
1M_%<^7'';?[6;>?''9Z?1L+S''=.;.=.;7;.:.?/[7=?_7:O+>=8_L9]*/+:>/E8_L+:?U:;(,;_;7=>#6=>"G5__7:O[/=?[/9_;.KJ?5<NW-<OG%9^''W6=^:
6:?L+:<>OSXZB@ EA TEAPTEAPTEAPTEBP$IAPDA@PDA@PTFA XEAPXFA XEEAPFAP$TF#L6O*?M5K+%5>''0;>71;.;6=/[("AW1!!:?.;.;6;/[.:NT,;/_(
=?[%.*<=PB09+8"/+:>/4,7S+:>GY8 ,KC^.+=/0:OT,;?_6;.#5=/[''=?[WI?G.;^?1;_C19^WW:]^:6;+V+:>/N"05D@\IAPTEAPTEAPTEAPTEBP$IAPDA
@PDA@PTTA TEAPTFA XEA XEB@XYKSD=+,;T6=_D5>W%=+\RL.76=/W7=_[6<OG6=>;D;.;.=?V.3?B/+#X>+,7%<M&/:O+(=>#5L(_<=>#>:M+T=]&:+38,
NH\''&.W.:O_5=_W.=._%9^_.;.7-;:>/NM_,1N''Z+=./4:>/"C8,K0$BAQPIBP$IAPTEBPTEBP$IAPDA@PDA@PTFA TEAPTFA XEA XEAQLUL20>+:?R1M#Y
5>^4;#4=!!3O7=_[71O_(;.>.=?[.;.76=-(,L8_O;N;:=>#9:C\C6^#5=__/A#K7=?_(<ALE;.#7=>#6;H\( HBC%-''(;/[6+-O6;/W61O['';#8HE]$=C:;Y
6=/Z.,2/+3\6MQDIBPXEBP$IAPTEAPTEBP$IAPDA@PDA@PXFA TEAPTEA XFA XEEAD-L#2/+=SX6>3,<N<.!!>TO9SR/=__(=^?6=/X,5/[5;Z<3KC:/;_\<
NN#>=?_7:M^.;?_(=.;%;.7%;.#>=Z>/=?_.:N?:52^/8X2@ HBC->_%KN37;.;6;>?1=Z8RL=&/M"?W1MKX+=N/+8 >KATTA0TEAP$EAPTEAPTEBP$IAPDA
@PDA@QPFA XEAPTEA XFA TEDAX5KC:/+=#Y1M/%:^T5A>V/LC0,=_[6=?_6=/Z:Y/"/KH_0;/_(=><TK?_.:O;:=/_(?.#6;3LO5:<FOO_5=.#7=_[(9?[:
+0F/=.#''.(2@ HNB"O[7;.?''9>?D;;+X;=..DX_+6[+Y+=N/+:<7KCLRA0TEAPTEAPTEAPTEBP$IAPDA@PDA@QLTA XEAPTEAPXFA TEDR<4NJ>/4;+W:>''0
;/GY+1W8+!![Z=?[7=^?7=.#*K22H;^;(>>#7>.;D>S8/+?/7=>#5=?_(5207!!3"/K.?(=_[.:O[-KOW>9^_9=^;(=?[''%(N@ H_"=?W/1N_6;^?1O P43.''%
:^''D4=Z:+:<8OSPZ@ $FAPTEAPTEAPTEBP$IAPDA@PDA@QLTA XEAPTEAPTFA TEFS@1OJ>/5-_);N30<NV:=#D,>/[7:O[6:N#9;*85+>?(>/+(=_+(6#@-
6SH?L.#.=^#7:N;(=2<S+3GZK.''7:O_5:N4.D>:GE:?>-N_7=>[>=.^: 8B@#K+(=.7D;.;-OPX8;/GD6-^:5:?R+:>GNC(/A0XFAPTEAPTEAPTEBP$IAPDA
@PDA@PXFA XEAPTEAPTEE@TFF#L,Y:?S6=.:<^7-;#L2;.>:=_V/9^#.=?Z/KJ?-:OW.:O3(?_3>+26/6SO0C=_(>/_(=>#75R3TMSV:MN76=/_6=/^.L/@/
+3N/B3K6=._5=/_&;+.B HBG5?[1=*;X=+)&5>''%6]^46+*/+:>/M3X.BPTFAPTIAPTEAPTEBP$IAPDA@PDA@PTFA XEAPTEAPTEE@TFE#T9+:?T+3P.+.;%
;\S0=/[7=^"/M>#:."2/5K+7=?_(>_/;:O;<6PT2LSN/O*?::OW5:OW5="8O+<0PKO_7=/_(=_^GY<493SP5+2;,:O''(9?[''=?_6-8N@ I[7+3O%;?G.<LS)
1M+Y5;+X+:>/NC$5D0\FAPTIBPTEAPTEBP$IAPDA@PDA@PTFA XEAPTEAPXED0TEE#H8+<?X+1B/A*?.;^_6=.;6=.;5!!:<?KM/7K@SZ:O#(;.#5>>#7;!!Z/
KC<.C=+>=?_7=__(=?F:=^#[=?[6=/_6=/T06J>GPCT,5R_9:N;5=/_6=.76=.^V 8BC =_6<_C-:?C[9].:6MRH5J>/!!342A XFA TEAPTEAPXEAP$IA DA
@PDA@PTFA XEAPTEAPXED0TEE3P,+:<.OR4:42?Y;>;.=._6=>#:+1GS=>#75:;WKB;-:N;(?.#::J<QK.3%6/W(=__(=>#5=?_7=>#5=/[6=?[6=/^/=*<O
L,02!!375=/[6=/[6;?[.1N;''8YZ@IY[/<\S)9^3,:^WZLAL45(_LY#X,AP$FA TEAPTEAPXEAP$IA DA@PDA@PTFA XEAPTEAPXED0TFER2H+1XUF(\0OP>/
=^W''=>;.=><8KM/W=^;7<^WZK*<W=/;7=/[6=_Z.5?+(=/;7=?_7:OW6=^#(=__7=/W6=/[5=_W6:O#U;OD0E]''(;/[6;/[69?[.=/[.;>^7 XBG5/[,1.''W
6=^:KP\,3#@-!!3<1F \FA TEAPTEA XEA $EE@DA@PDA@PTFA XEAPTEAPXED0TFK3RG3B2/NC'',K"3W=.7.=/[(.#F.=#LA5>#(3P_YE>0.+?_5=_W7=?W6
;?[6=?W6=?_5=/[(>_[5=__6=/[6=/[6=/[6=/W6:O_,<O[(;/W''=^;6=.?.=.;D;/[.1H2@I;+%9^W%1M"/O:<?5CLQNFX/AP\FA XEAPTFA XEA TEE@DA
@PDA@PTFA XEAPTEAPXIE@TEE20?+<3WKCT,3>7/9_[/;.:/KM_6=:<=;__7+0Z/"CJ/K.#9=__7=?_7=>#5=?[5=?_7=?_7=/W5=/W5=/[6=/[6=/[6=_[7
=.;(=?[6;?_6=_[6;.;'';>?.;?C/;.:V BVV<OB:;^2:6J?LM1P3"C8,BP\FA XEAPTFA!!PEA TEE@DA@PDA@PTFA XEAPTEAPXID0TFE3FG3Z8:+0DZ<^W0
;._/=:824-#6=^#8:O_6.# TLS /+/[7:O_7=?_.=?[6=/[(=/[7=?[6=_W5=/[6=/[6=/[6=/[5=/[6:OC.=._6=/[6=/[-;.;.9>;''<N;''9^;..(B@!!=_D
:[+%6#@-L3B/+3P6DP$FA TEAPTEA XEA TEE@DA@PDA@PTFA XEAPTEAPXED0XFK3X>+20U4(_%:^W-<_[.KC#6K GW+2?%:N;(6!!LWMO_Z:OW5=>#5:O_.
:N_(=?W(=/[6=/[(:O['':OW6=._7=^_7=^_7:OW6=.#''=/[7;/[.;/[/;/[.<^?.9?G1;>_%;;*C HO''6^''[.*<OEZ>/O:85B@TFA TEAPTEAPXEA TEE@DA
@PDA@PTFA XEAPTEAPXFD@XFK20=+:?X6>'')."3%=_@,!!?_>+:?%EX\U:__7=.36:_W7=?_7=?W6=/[.:O[6=/[69>#6=._7=?[5=/[5=/W6=?W6=?W(;/[''
=.;6;/[6;.;6;/[.;.;.;.;.<N?''<N7%9_[D 2VC6.T,O-Z/5J>/"C0,A \FA TEAPTEAPXEA $EE@DA@PDA@PTFA XEAPTEAPTFAP EE3ZG3:?U6-_%;J83
6R2/=>?5;C^/L*?MK>?(=/[7=?_7=.#6=.;(=^#9=_W''=?[7=^;(=/[''=?W6=/[6=/[6=._7=/[6;/W6;/[.=.;6;/[.9?[.9>;.;/C'';^?-<OC0<NW%;H\%
#H\/+=^44J>/+3$2A \FA TEAPTEA XEA TED0DA@PDA@PTFA XEAPTEAPTFA $FK3X?+:?T6<S)<]^.EZ?6=.;.KB4."CB/LZ?5=?_7=?_6=?[6=/[69>#9
:O#(=/[6:N_7=/[7=/[69?_6=/[6=_[6=.;6=/[''=_[/=._6;>;6;>_.;.;/<OC/;>?1;_C01NW%;N^GIR#Z:[+T+:>/"C<1A \FA TEAPTEA XEA TEE@DA
@PDA@PTFA XEAPTEAPTFE@XSE3D>+:?U6-/)<N715>W59_[6+.&/+=\UE.''/:O[(=/[7=/[69?_(>_''6=/[''=?_6=_['':O[69?_7=_W5=/[6=/[6=.;6=/[.
=.;.=.?.;.?'';.;.;.?09>?/1.7-;_C0<_G,;NWU%-W%6K+U+:>/+201D0$FA TEAPTEA XEA $EE@DA@PDA@P$FA TEAPTEAPTFE@TTK3D>+:?V6<SZ9^W0
=/G/=.76;/ZGLZ?X;?[(9?[5=._7=^_(=/[(=/[6=/[7=/[''=?_6=_[6=/[6=/[6=/[6=/[.=/[6;?[/;.;/9>;.;.;.;.;.;?C0;<S/<^70<OC01OG,1N''+
9]^:6Z?T.*>/+3\4A  FA TEAPTEA XEA TEA DA@PDA@P$FA TEAPTFA XFA $FK20=+:?T6.'',;NW%9^;/;._.=_Z.@SO1:NW6=?[6=/_6=/W6=/[6=/[6
=/[69?_5=/W6=.;6=/[6=/[6=/[6;?[.=.?6;>_.;.;.;.;.;.;.;.7'';?C/;>W-;\[0<OC19^W%:^WD6M.46Z?V+:>/"C<1D0TFA TEAPTEA XEA TEA DA
@PDA@P$FA TEAPTFA XFAP FE3X=+:?S6M#):^W%;._%;^;'';>;W!!?+.=?[''=/[5=/[5=/[6=/[''=?[6=._7=/[6=/[/=/[.=.;6;.;.;.?.9?[/;.?'';.;.
;.;.;.?/;>7'';?C/<N?'';^7-<OC0<LS1<^''%:]#%;M''D5MWZ+:>/!!3<1D0XIA TEAPTEA XFE@TEA DA@PDA@P$EA TEAPTFA XFA $FE3D=+:?R.-_D5>3,
;>W69>76;/[5=.;(<__.;/[6=/[6=/[69?W.=?[6=/[6=,S6=.;6;/[/;.?'';.;.;.;.;.;.;.;.;.;.;.7'';^?09>?/<N?'';_G/1N70<LS0<OG%<^''D:]#D
6MWZ.-6/+<:/O302E@XIA TEAPTEA!!PFE@TEA DA@PDA@P$EA TEAPTFA XFE@XSK3D=+:?T6=#W;OG1;\[-;>_/;^_.=/[/;/[''=?[6=/[6=/[6=/[6;>;7
=?_.;/[6;.;6;>;.;.;.;.;.;.;.;.;.;.;.;.;/<N70;>_/;>?0;?G-<^7'';_CD<OC0<_G%9^''W5=_D:[+Y.*?U.-B/!!381E@TFA TEAPTEA!!PFD0XEA DA
@PDA@P$FA TFBPTTA XFE@TFE3D=+:?M6M#D6^W%9^7-<N?-;>?/;>_6;>;6;/[6=/[6=.;6;/W''=.;.;.;6;.?/9>70;.?61.;/;>?/9>?.9^;/9>7/;<[%
;>W/<^?/;_G-9?C-<_C0<OC0<OGD9^W%5=_W6]/W6LSV6K+T+:>/OS41A  FA TEA XFA XEAPTEA DA@PDA@P$FA TFBPTTAPTEA TFE3P=+:?M6-[Y;N''%
<OG-;^_/<N_.;>7.;.;6;.;6;/[/=.;69>;.;._6=/[09?[.=.;'';._/;?[1;^_%;?G/<^;%;.71<^?''9_G0<N70;_C0<OC0<LS0<_G1<^W,9^W)5=_Y6\S[
6M.:6J?R+:>/OS45A  FAPTEAPTEBPXEAPTEA DA@PDA@P$FA TFBPTFAPTEA TFE3P8+:>/6-+Z;N'',9^W''9^7'';>?0;^_.;.;-;>7.;.;.;.;.;/[/;.;.
<N_/;/[09>70;^;D<_C1<N?0;<S-9>W/1OG0;_C1;,[%;>W0<OC0<LS1<_G%9^W)9^3%:^''W5=''D6=_D5-*/6J?R+:>HY#X3D0 FA TEAPTEBPXFAPTEA DA
@PDA@P$FA TFAPTFBP$IA TFE3P8"J?S5++W5>3W;NW1<^7-;^W/<N?/;>_/;^_.;^_.;^7-;^_-;.7-;^7-<N_/;>7/<N719^W.;<S1;^W1;<S0<N;''9^?0
;,S/9^W0<LS1<_G%:^W)9^3);LSW5=_W6]/W1MW[.-&/6*?M+:>HY#X2D0 TA XFA XFAQPFAPTEA DA@PDA@P$FA TFAPTFBP$IA TFESH<+,*/6-#Z5=_W
9^W19_C1;_C/1N?'';>?1;/G/<N?'';?G/;<[.;,S%<N''%;]_+<]_%;N''D:]^76>''+:_CD6M+D5[++<NV:5?G1<OGD<_G%;NW,9^3):^''W5=_Y6]''D6-_[1M#X
.-&/5Z?M+:>HY#D2AP SA TEAPXFEAPFAPTEA DA@PDA@P$FA TFBPTFAPTEA TFESH,+:>/5-Z::^'')1N'',<^W%<OG0<^7-<N?D;>_-;_G-<^7F9_C/<Z8=
MH]@MCX<KB2/5#VG6*<OM"07+(".LCBGK#H,!!6\,K]_D:_G,9^''%:^3D5=_W5=_W6]''D5]''[5<SZ6K+W-MJ:5Z>/+:<=OB0.E@ FAPTIAPXFA XFAPTEA DA
@PDA@P$FA TFBPTTAPTFE@TFE#H9+:>/3]V::\SX:]_,1N319^W%9^W01OC1<OCD<OG01.W09^;%9R00ECK,ESHVECJ/+2445]L2+20.E!!P.D3SYO]X=K#6G
BZ?.6^''W:]_W5=_W1M#Y6<S[5=#[6\SX6<SV6K+Z.-"/4*>/+8".NS(3E@ FA TEAPXEAPXEAPTEA DA@PDA@P$FA TFBPTTA XFD0TEE#H,"J>/4:?U6M#D
6.'')5>3%:^''%<\S%9^W%9^W%9^W%9^W%;OG)<CD,L3WSLSN/LB0.L3\/MSTU5CH0+8 2E3VGKR05M#H-F#O,6]_W6]''D6-_W6LS[5<SU6\SX6=''D4-":6[SR
.-V/+:>/+8!!''!!3$3A TTA XTE@XFAPXEAPTEA DA@PDA@P$FA TEAPTFA XEA $FEST,O:>/3:?T.-#[1MWW1M''W5>WW5=_W5=_W5>''):^''):^'',5=_W1M[R
.-R/4# <"J>/O]Z/!!:>/3J>/3=Z/+32/+3"/5J>/5[+Z6LSX6]/W1M#W6=''D4-/[6K+W.-#X.-*:5]V/5Z?R+:>/+8\?NCD5D0$FA XSD!!PED0XEAPTEA DA
@PDA@P$FA XEAPTEA XFA $FE#L,O*>/+<7T.-#Z1M[Z6\SY5<SY6]''Y5=_W5=''Y6]''Y6]''Y6>3W5=_Y;M_)6=#Y6=#X6]#X.-+[6-W[.-/U6K+Y6]/[:[+W
5:?)6<SU6LSV6LSU6-+[6;+Y6;+Y6K+X+="/6*>:5*>/+:>/"F^GNCD5A $EAPTFD@XEA XEAPTEE@DA@PDA@P$FA XEAPTEAPXFA TEF#@,NH"/+:?S+=[V
.-*:6[SU6-/D5-/[1MWY1M+[1M[[6<SU6\SZ6<ST6<SV.-./6K+X+:?T.-*/+:?V+;+T6*?X.*?X5[+Y6;+Z5++[5]*:6M*:6K+Z6*?X.-"/6J?Z+=Z/5J>/
+:>/+:>/"C<=KCD.A TFA TEA XEAPXEAPTEE@DA@PDA@P$FA XFAP$IAPXFA TEFR<4OS:.'':>/+:?T+="/6++[.-#X.-&:6[ST6++[6<SV5-/D5MV:6-":
6*?Z+="/6J?X+:?T+:>/+:>/+:>/+:>/5*>/4:?T+=Z:6J?Z.-"/6*?X+=R/5*?V+=Z/5J>/+:>/+:>/+:>/+8!!&"C08KCL0BPXSE@XEAPTEA TEAPTEE@DA
@PDA@P$FA XFAP$IAPXFAP$EDR<2KC4>+8"/+:?L+=R/5*?U+=V/6J?V5MOV5K+X5-KU.-WV.-"/5Z?X+=*/5Z?R+=J/+:>/+:>/+:>/+:>/+:>/+:>/+:?R
+=R/5J>/+=R/.*?R+:>/4*>/+:>/+:>/+:>/+:>/"J>HY8 ?OS ,L#@0B@TFA XEBPTFA TEAPTEE@DA@PDA@P$FA XEAPTEAPXFAP$ED!!T5MC4=Y("/+:>/
+:>/+:>/+<2/3J?S+=N:4*>/4*?T+:?R+=R/+:>/+:>/+:>/+:>H+:>HY8^/OH!!&"J<<+:>H+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+:>/+8"/+8!!&
"F^GY3$<KCD1L#L/B@$SA XFAPTFAPTEAPTEE@DA@PDA@P$FA XEAPTEA XFAPTED1(0MR0:OC8>O*8>"F^/"J>/"J>/+8"/+:>/+:>/+8"/+:>/+:>/+:>/
+8".2:>/"F^/"F^GPC2HY8 >O3<>!!6\7"C=&"J=''"J>/+8"/+3>/"F^/"J>/"J=@"F^H+3:GY8 >PC8>OC4,NB0:KCH.L3@Y@!!D/DPXFAPTEAPTEAPTFE@DA
@PDA@P$FA TEAPTFA XFAPTFD0</LCP1KC =NC0?O8]''!!6^HY( ?+#6/OZ8<"F^H+3>/OJ<<+#6/OX]''OC0?O30>LALRC2<UK2<VFQ(/E2</E#@1NS$=O#5@
O38?O#<>O8]''!!6^GO#1@O#8?OC<8O#4=M34,NC4,M3\,KCX2L3T.K1$TBCT9K1LEAPTFAPTEAPTFE@DA@PDA@PTFA XEAP$IAPXFA TFA!!@YE#@.MSH4MCP1
M#D,LR06LS(6NSP,M#(,M"0:KCX,L"02N#D,M#H2L"03MCH.D!!LFE@$FAPTIA $FA0TIB@ TK3T2MCP1LSD1MB01M#P6L#D1LSP2M#H5L#P2MSH4L#L2L3T5
MSL3K1\/K1(VE!!PIDS(>F TFA TIA TEBPTFD0DA@PDA@P$FA XEAP$EAPXFA XFAP$IBPTFA!!PTEAPTEAPSD1PSD1PTD1LSD1LSD1LSD1PTE@XFA TTEAPF
BPTIA XTAQHQD!!PRD1HSDAPPBPXFA $BAPTEA XFEAPFAPTFBP$IBP FAQLEBPTEAP$IA XFBPXHA XEAP FB@\IAPTHA0 PMS89DPTEAP$IAPTEBPTFD0DA
@PDA@P$FA XEAPTEAPXEA!!LSD0XEBPTEAPTEAP$IAPTEAPTEBP$IBP$IBP$IBP$IBP$HB@ HBP$IB@ HA0 IAP H@!!PTBP FBPTIAP E@@$IAP$BB@\IBP$I
BP$IBP HB@$IBP IB@ HB@ HB@$IBP IB@$HB@TGAP HBPTEB@XTBPTWM6\ZA $EAPTEAPTEBPTFD0DA@PDA@PTFA XEAPTEA XEAPXFA!!PPD!!@SEALSD1LS
DAHRDA@SD1LSD1LSD1LSD1LSEAPTEAPTA XFA XFA XEA!!PSBQPFAP$SAPTEAP$EAQLEBP BA!!LFA XFA XFA XFA XFA XFEAPFA XFEAPTA XFEAPSD1LT
A XFEALSD0XTD"47M3LT@0$EAQPEAPTEBPTFD0DA@PDA@PTFA XEAPTEA XEAPTED1DWKST3K"83MST5L3L3L3L3K"8.K"8.K"8.K"8.LB8-KR4-K2</LC@0
LB<UKR</DAPEBP SBP$IBP$EBALIBP$HDQ\/KR40LB4-K3L3L3L3L3L3LB8/LC@0K3@.K3@0K#@0L3L3KR<0K#@0K"43LS\1E LEB@TEAPXEBPTEAPTFD0DA
@PDA@PTFA XEAPTFA XFAP$IBPTSD!!DQD!!HRD!!@PDA@RD!!HRD!!HPDA@PDA@PDA@SD1LSD1LSD1@TEAPFAQLTA XSAPXEA $QAPTEAPTEBAHEAP$@A!!@FEALP
DALTA!!LSD1LSD1LSD1@PE@TSD1PPDA@SDAHRD!!@PDA@FA!!HRD!!LSD0XIBPTEBPTIAQPFA XEAPTTD@DA@PDA@PTFA XEAPXFA TEAPTEAPTFA TEAP$IB@ H
APTEAPTEAPTEAPTEAPTEAP$IBP$IBP$IB@ HB@ IB@ IB@\H@ TEAP$QBP$EAP$EBAHEAP$DA0 GA0 IBP$IB@$IBPTEBP$IBP HBP$IBP$IBPTEAPTEAPTI
B@ IBPTEA TEA!!LSA XEBPTIAQLFA XFAPXTD@DA@PDA@PTEA XEAPXFA TEAPTEAP$EAPXTE@XEAPTFEAPTEAPTEAPFA XFA XFA XFA XFA XEAPTEAPTE
BP$IAP$IA0XFBP$QBP$EAP$EBQHHBP$DA0\IBP$EAPTEAPTEAPTEAPTEAPTEAPTEA XEAPXFA XFA XFA XFA!!PTBQLTA XFAPTFAPXEEALEBPXFAPXSD DA
@PDA@PTFA TEAPXFA XIBPTEAPTEBPTEA XEAPTIA XFA XFA XFA XFA XEAPXFA TEAPTEBPTEAPTIBP IBPTIA1PEBP QBP$IBP$EA1DIBP$CA0$HBPTE
BP$EAPTEAPTEAPTEAPTEAPTEAPTFA XEAPTEAPXEBP$EAPXFAPTEEALFAPTIAQPSD0XFA XFAPXSD DA@PDA@P$FA XEAPTEAPTEAPTEAPTEAPTFA XFAPTI
A XFA XFA XFA XFA XEAPXFA TEAPTEAPTEAPTIBP EBPTIA1PEBP QBP$EBP$EA1DIBP$CA0$HBPTEBP$EAPTEAPTEAPTEAPTEAPTEAPTFAPTEAPTEAPTE
BP$EA XFAPTEA XEAPTEA!!LSE@XEAPXFAPXSD DA@PDA@P$FA XEAPTIBP$EAP$IBPTFA XFA XFAPTIA XFA XFA XFA XFA XEAPXEAPTEAPTEAPTEAPTI
BP$EAPTIA1LFAP\QAPTEBP$EA1DIBP$CA0$HBPTEBP$EAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEA TEAPTEAPTEAPTEAPTFA XFA!!LSE@XEBPXEAPXTD DA
@PDA@P$FA XEAPTEAPTEAP$IBPTFE@XFA XFAP$IAPTFA XFA XFA XFA TEAPTEAPTEAPTEAPTEAP$IBP$FAPTIA1LFAP\QAPTEAP$EA1DIBP$CA0$HBPTE
BP$EAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPXFA $EAPTEAPTFAPTEAPXEAPXFA!!LSA TEBPTEAPTTD DA@PDA@P$FA XEAPTEAPTEAPTEAPTFA XFA XFAPTI
APTEA XFA XFA XFA TEAPTEAPTEAPTEAPTEBP$IBPTFAPTIA1LFAP\QAPTFAP$EA1DIBP$CA0$HBPTEBP$EAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPXFA $E
APTEBPTEAPTEAPTEAPXEA!!PTA TEAPTEAPTTD DA@PDA@P$FA XEAPTEAPTIBPTEAPTEAPTEAPXEAPTIAPTEAPXFA XFA XFA XEAPTEAPXEAPTEAPTEBPTE
BPXFAPTIA1LFBP\QAPTFAP$EA1DIBP$CA0$HBPTEBP$EAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEA TEAPTEAPTEAPTEAPTEAPTEA XTA XEAPTEAPTTD DA
@PDA@PTFA XEAPTEAPTIAPTEAPTEAP$EAPTEAPTIAPTEAPTFA XFA XFA XEAPXFA XFAPTEAPTIBP$IBP$FAP$IBALFBP\QAPTEAP$EA1DIBP$CA0$HBPTE
BP$EAPTEAPTEAPTEAPTEAPTEAPTFAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEA XFA TEAPTEAPXSD DA@PDA@PTFA XEAP$IBP$EAP$IBPTEAP$IAPTEAPTE
APTEAPTFA XFA XFA XEAPXFA XFAPTEAPTIAP$IBP$EBP$IBALFBP QAPTEAP$EA1DIBP$CA0$HBPTEBP$EAPTEAPTEAPTEAPTEAPTEAPTFA XEAPTEAPTE
BPTEAPTEAPTEAPTEAPXEA XFA TEAPTEAPXSD DA@PDA@P EA XEAPTEAPTIBP$IAPTEAPTEAPTEAP$IAPTEA XFAPTFA XFA XFAPXFAPTEAPTEBPXEBP$I
BP$IAPXEA0XEBPTQBPTIBPTEBAHHAP CB@$IBP$EAPTEBPTEAPTEAPTEBPTEAPTEAPTEAP$EAPXFAPTEBPTEAPTEAPTEAPTEE@TEA!!PFAPXFAPXEAPTTD DA
@PDA@P$TA XEAPTEAPTIBP$EAPTEAPTEAPTEAPTIAPTEA XFAPTFA XFA XEAPXEAPTEAPTEBPTEBP$IBP$IAP$G@@XIBP QBP$IAPTEBADIAP$CA0 IBP$I
APTEBPTEAPTEAPTEBPTEAPTEAPTEAPTEAPXEAPTEBPTEAPTEAPTEAPTFA TEA!!PFAPXFAPXEAPTTD DA@PDA@PTSA XEAPTEAPTIBPTEAPTEAPTEA XEAPTE
APTEA XFAPTFA XFA XEAPTEAPTEAPTEAPTEBPTIBPXIBP G@@XEB@\QBP$EAP$IA1$IBP$@@ \IBP$IAPTEBPTEAPTEAPTEBPTEAPTEAPTEAPTEAPTEAPTI
AQLEAPTEAPTEAPTEAPTEAQPFAPXFAPXEAPTTD DA@PDA@P$FA XEAPTEAPTEAPTEAPTEAPXFA XEAPTEAPTEAPTFA XEA XFA TEAPTEAPTEAPTEAPTEBPTF
BP$IB@$IA1LFBP\YAP EAP$IA1(IB@$GA0$HBP$IBPTEAPTEAPTEAPTEBPTEAPTEAPTEAPTEAPTEAPTIAPTEAPTEAQLSAQPSA $EA!!PFAPXFAPXEAPTTD DA
@PDA@P$FA XEAPTEAPTEAPTEAPTEA XFA XEAPTEAPTEAPTEA XEA XFA TEAPTEAPTEAPTEAPTIBP$EBP$HBPTIA1LFBP$ZAP EAP$EBQXEB@$GA0$HB@$I
BPTEAPTEAPTEAPTEBPTEAPTEAPTEAPTEAPTEAPTIAPTEA TEAPTEAQLEE@$EA!!PFAPXFAPXEAPTTD@DA@PDA@P$SA XEAPTEAPTEAPTEAPTEA TEA XEAPTE
APTEAPTEA XFA XFA XEAPTEAPTEAPTEBP$IBP$EBP$IAPTG@APEB@TYAP$EBP$EA!!XEBP$@A0\GB@$IBPTEAPTEAPTEAPTEBPTEAPTEAPTEAPTEAP$EAPTE
APTEAPTED0XEAPTEA $EA!!PFAPXFAPXEAPTFD@DA@PDA@P$TA XEAPTEAPTEAPTEAPTEAPTEAPTEAPTIAPTEAPTEA XFA XFA XEAPTEAPTEAPTEBP$IBPTE
APTEBP$GA1HFA0TRBPTEBP$EAQ$IAP$@@ \GB@ IBPTEAPTEAPTEAPTEBPTEAPTEAPTEAPTEBP$IAP$EAPTEAPTEAPTEA TEAP$EA!!PFAPXFAPXEAPTFD@DA
@PDA@P$EA XEAPTEAPTIAPTEAPTEAPTEAPTEAP$IA TEAPTEA XFA XFA XFAPTEAPTEAPTEBP$IAPXFA XIBP\HAQ(PA0$SA0TEBP$EA1LGAP$@A0\GA0 I
BPTEAPTEAPTEAPTEBPTEAPTEAPTEAPTEBPTIAP$FAPTEAPTEEAPEE@TEAPTEA!!PFAPXFAPXEAPTFD@DA@PDA@PTFA XEAP$IBP$IBP$IAPXFAPTEAPTEAPTI
A TEAPTEAPTEAPTEAPXFA TEAPTEAPTIAP$IBPTFAPTIA0L@E3LFBPTIBP$IBP$IAP$IAP$G@@@G@0\IBPTIAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTF
APTEAPTEAPTEAPTEAPTEA XFA XEAPXEBPTFD@DA@PDA@PTFA XEAP$IBP$IBP$EAPXFAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTFA TEAPTEAPTIBP$IAPTF
APTGAQLQK1$GBP$IBPTEAPTEAP$IAPTEA!!PG@0\IBPTIAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$FAPTEAPTEAPTEA TEAPTEAPXFA XEAPXEBPTFD@DA
@PDA@PTFA XEAP$IBP$IBP$EAPTEAPXFAPTEAPTEAPTEAPTEAPTEAPTEAPTFA TEAPTEAPTIBP$EAPXFAPTHEALSD0$GD0$IBPTEAP$IAP$IBP$IAPXH@@\I
BPTIAPTEAPTEAPTEAPTIBPTEAPTEAPTEAPTEAP$FAPTEA TEAPTFA XFAP$EAPTFA TEAPXEBPTFD@DA@PDA@P$FA XEAP$IBP$IBP$EAPTEAPXFA TEAPTE
APTEAPTEAPTEAPTEAPTFA TEAPTEAP$IBP$EA XEAP$@A $HB@ EAPTEAPTIBP$IAPTEBP$GA0\H@@\IBPTIAPTEAPTEAPTEAPTIBP$EAPTEAPTEAPTEAPTF
APTEAPTEAPXFAPTEAP$EAPTEAPTEAPXEBPTFD@DA@PDA@P$FA XEAP$IBP$IAPTEAPTEAPXFA TEAPTEAPTEAPTEAPTEAPTEAPTFA TEAPTEAP$IBP$EA XE
AP$GE@$IAPTFA0TEBP$IBP$EBPTFAPTIBP$I@@\IBPTIAPTEAPTEAPTEAPTEBPTEAPTEAPTEAPTEAPTFA TEAPTEE@XEAPTEAP$EAPTEAPTEAPXEBPTFD@DA
@PDA@P$FA XEAP$IBP$IAPTEAPTEAPXFAPTEAPTEAPTEAPTEAPTEAPTEAPTFA TEAPTEAPTIBPTEA XEBP$IA TEAP\EAP$HA0@@@0@@BPTEAP$IAPTI@@ I
BPTIAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEA TEAPTEAPXEAPTEAP$EAPTEAPTEAPXEBPTFD@DA@PDA@P$FA XEAP$IBP$IAPTEAPTEAPTEAPTEAPTE
APTEAPTEAPTEAPTEAPTFA TEAPTEAPTIBPTFA TEBP$@APTEAP$HAP\@@0DA@PDD@  EBP$IBP I@@ IBPTIAPTEAPTEAPTEAPTEAPTEAPXFAPTEAPTEA XE
A TEAPTFD0XEAPTEAP$EBP$IAPTEA XEBPTFD@DA@PDA@P$FA XEAP$IBP$IAPTEAP$EAPTEAPTEAPTIAPTEAPTEAPTEAPTEAPTFA TEAPTEAPTIBPTFA TE
BP$HD0XGAQPIA0LD@PDD@0@G@PHEAPTEBP I@  IB@TIAPTEAPTEAPTEAPTEAPTEA XFAPTEAPTEA TEAPTEAPTED0XEAPTEAPTIBP$IBPTEA XEBPTFD@DA
@PDA@P$FA XEAP$IAPTEAPTEAPTFA XFAPTEAPTEA XFAPTEAPTFA XFA XFA TEAP$IBPTEAP$IBPTEAP$GE@XIAPTG@@PAA@\G@@\GA0PIA $IBP$I@@ I
B@TIAPTEAPTEAPTEAPTEAPTEA XFA TFD1PEA TFAQLEAPTFA XEAPTIBP$EAPTEAPTEAPXEAPTED0DA@PDA@P$FA XEAP$IBPTEAPTEAPTEA XFAPTEAPTE
A TEAPTEAPTEAPTEAPTEAPTEAP$IBPTEAP$IBPTEAP$GE@XIAPTB@0P@D1\QB@ G@@DBAP$IBP$I@@ IB@TIAPTEAPTEAPTEAPTEAPTEAPXFA TFD1PEAQLE
A TEAPXFA TEAPTEAPTEAPTEAPTEAPXEAPTFD0DA@PDA@P FA XEAP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBPTEAP$IBPTE
AP$GE@XIAPT@A@LRLS4-A0HG@@D@BPTEBP I@@ IB@TIAPTEAPTEAPTEA TEAPTEAPTFA TFD0XEAQPFAPXEAPTFAPTEAPTEAPTIBPTEAPTIBPTEBPTFD0DA
@PDA@P EA XEAP$IBPTEAPTIBPTEAPTEAPXEAPTIAPTEAPTEAPTEAPTEAPTEAPTEAP$IBPTEBP$IAPTEAP$GE@XIAPTC@PHYM# Z@0@G@@PCBPXFBP I@@ I
B@TIAPTEAPTEAPTEA TEAPTEAPXFAPTFE@XEAQPFA XEAPTEAPTEAPTEAPTIBPTEAPTIBPTEBP$FD0DA@PDA@P FA XEAP$IBPTEAPTIBPTEAPTEAPXEAPTI
APTEAPTEAPTEAPTEAPTEAPTEAP$IBPTEBP$IAPTEAP$GE@XIAPTC@P\FD!!DH@@$GA0LA@ TEBP$I@@ IB@TIAPTEAPTEAPTEAPTEAPTEA XFAPTFA TEAPXT
EAPFA TEAPTEAPTEAPTIAPTEAPTEBPTIBP$FD@DA@PDA@P FA XEAP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAP$IBPTEBP$EAPTE
AP$GE@XIAPTC@PLGA0H@@ TGB@@AA@$IBP$I@@ IB@TIAPTEAPTEAPTEAPTEAPTEA XFAPTFA TEAPXTD1PFA TIAPTEAPTEAPTEAPTEAPTEAPTIBP$FD@DA
@PDA@P EA XEAP$IBPTEAPTEAPTEA XFAPTEAPTEAPTEAPTEAPXEAPTEAPTEAPTEAP$IBPTEBP$EAPXEAP$GE@XIAPT@@PDGA0\G@@\B@ @A@0TEBP$I@@ I
B@TIAPTEAPTEAPTEAPTEAPTEA XFBPTTAPTEAPXTE@XEAPTIAPTEAPTEAPTEAPTEAPTEAPXEBP$FD@DA@PDA@P\EA XEAP$IBPTEAPTEAPTFA XFAPTEAPTE
APTEAPTFA XEAPTEAPTEAPTEAP$IBPTEBP$EA XEAP$GE@XIAPT@A@PG@@HH@@LC@0LAA1@FBP$I@@ IB@TIAPTEAPTEAPTEA TEAPTEAPTFBPTTAPTEAPXT
A TIAPTIAPTEAPTEAPTFA TEAPTFA XEBP$FD@DA@PDA@P\TA XEAP$IAPTEAPTEAPXFAPXFA TEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$EA XE
AP$GD0XEA XI@0DCA0\@@0PCA@DAF#HT@ TI@@\IB@TIAP$IBPTEAPTEA TEAPTIAQPEAPTEA XEAPXFA XEAPTEBP$IAPTEA XEAPTEAPTEAPTIBPTSD DA
@PDA@P FA XEAP$IBPTIAPTIAPXFBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBPTEA XEAP$GE@TIAPTE@ L@@ \@@0PA@0DPM!!XGA \I@@\I
B@TIAP$IBPTEAPTEA TEAPTIAQPEAPTEA XEAPXFA TEAPTEAP$IAPTEAPXEAPTEAPXFA TEBPTTD DA@PDA@P EA XEAP$IBPTIBP$IAPTEAP$IBPTEAPTE
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBPTEA XEAP$GE@TIAPTFBP@C@0PDA@PD@PX5K  CA TI@@\IB@TIAP$IAPTEAPTEAPTEAPTIAPXFAPTEA TEBPTE
APTEAPTEAPTEAPTEAPTFA XFA XEAPTEBPTTD@DA@PDA@P$FA XEAP$IBPTIAP$IAPTFAP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBPTFA XE
AP$GE@XEAPTFAPTIA0PA@PPCFS@-AP FBP$I@@\IB@TIAPTEAPTEAPTEAP$EAPTIAPXFAPTEAPTEBPTEAPTEAPTIAPTEAPTEAPTEAPTEAPTEAPTEBPTFD0DA
@PDA@P$FA XEAP$IBPTEAPTEAPTFE@$IAPTEAP$EAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTFA XEBP$GE@XEAP$EAPXFA XSD!!X/MQDFBP$EB@$I@@\I
B@TIAPTEAPTEAPTEAP$IAPTIBPXFAPTEAPTEBPTEAPTEAP$IAPTEAPTEAPTEAPTEAPTIBPTEBPTFD0DA@PDA@P\IA XEAP$IBPTEAPTEAPTFD0$IAPTEBP$E
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBPTEA XEBP$GA XEAP$IBP$IBPXSD!!DQA HIAP$GA0XI@@\IB@TIAPTEAPTEAP$IAP$IAPTIAPXEAPTEAPTEBPTE
APTEAPTEAPTEAPTEAPTEAPTEBP$IBPTEAPTFD0DA@PDA@P FA XEAP$IBPTEBPTEAPTFD0$IBP$EAP$EBPTEAPTEAP$EAPTEAPTEAPTEAPTEAPTEBPTEA TE
BP GA TEAP$IBP$IB@$IBP GA0TIB@XFA0\I@@\IB@TIAPTEAPTEBP$IAPTIAP$IAPXEAPTEAPTEBPTEAPTEAPTEAP$IAPTEAPXEAPTEAPTEBPTEAPTFD0DA
@PDA@P\FA XEAP$IBPTEBP$EAPTFBP$FB@$EAP$EBPTEAPTEAP$EAPTEAPTEAPTEAPTEAPTEBPTEAPTIBP GAP$IAP$IBP$IBP GA0 IBP IBP\GBP$I@@\I
B@TIAPTEAPTEBP$IAPTIAP$IAPXEAPTEAPTEAP$EAPTEAPTEBP$IAPTEA XFA XFAPTEAPTEAPTFD@DA@PDA@P$EA XEBP$EAP$EAPTEAP$EBP$IAPXIAPTI
BP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IAPTIBP$HB@ B@ HB@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@HGB@$IBPTEAPTEAPTEBP$IBP$IBP$IBPTEAPTIBPTE
APTEAPTEBP$IAPTEAPTFA XEAPTEA TEAP$E@PDA@PDA@P$EBPTEBP$IAP$EAPTEAPTFBP$IAPXIAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$I
BP C@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0L@@ \HBP$EAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEBP$EAPTEA XEAPTEAPTEAPTEAP$E@PDA
@PDA@P$EB@TFAPTEAPTIBP$EBP$FBP$IAPTIAP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$HB@ IB@ HB@ HB@ HB@ HB@ HB@ HB@ HB@ GA0\G
B@$IBPTEAPTEAPTEBP$IBP$IBP$IBP$EAP$IBPTEAPTEAPTEBP$IAPTEAPTEAPTEAPTEBP EAPTF@PDA@PDA@PTFBPTEAPXFAPTIBPTEAPTTBP$EAPTIAP$E
APTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTIBP$IBP$GA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\HB@ HBP$IAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTE
APTEAPTEBPTEAPTFA XFA XFA TIB@@HA!!PA@PDA@PDA@PDEAP$GB@TEAP$EAPTFAPTFDAHEA TIAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTE
BP$EAP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBP$IBPTEAPTEAPTEAPTEAPTEAPTEAPTEAPTFA TEAPTEAPTEAPTEAPTEA XFA XFA TEAP$G@@@HA!!PA@PDA
@PDA@PDTAP B@ \GA0\HA0\HA0\GBPTGB@\GB@HGA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\G@ HB@ @@@@@@@@@@@@@@@@@@@@@GA0HG
A0\GA0\GA0\GA0\GA0\GA0\GA0\GA0\HB@\GA0\GA0\GA0\GA0\GA0 HBP$IB@ GA0H@@0\EA DA@PDA@PDA@PDABP$HA0@C@0@C@0PC@0LC@0LD@0PC@@PC
@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LDA@PC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC
@0LC@0LC@0LC@0L@@@@@@@@@@@@@@@ F@PDA@PDA@PDA@PDA@P$FBP@DA@@CA@PC@@LDA@PD@0PC@@PC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC
@0LCA@PDA@PDA@LC@0LC@0LC@0LC@0LC@0LDA@LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0LC@0@@@@@D@0LC@0@GB@DA@PDA@PDA
@PDA@PDA@PDAB@$EBP\B@ H@@0@GBP@@@@LC@0LC@@@@@@@@@@@C@0@@@0L@@0@@@0LD@0@@@0@GA0@C@0@C@@@@@0LC@@@C@0L@@@@C@0LC@0LC@0LC@0LC
@0@@@@@@@@@@@@LC@0@@@@HG@ @C@@@@@0L@@@@@@@LC@@@@@@HG@ HGA0@GA0\GA0$A@PDA@PDA@PDA@PDA@PDA@PDA@PDIA TGBP$IBP HBP$IBP IBPTE
B@ HB@ HB@ GA0TEA0\HA0 IBP$IB@$IA0 IBP GA0\GA0 IB@\GA0 GA0\HBP GA0\GA0\GA0\HB@ HBP$IAP HA0\HB@ HA0\HB@ GA0 GA0 HA0\HB@$I
BPTEBP$IB@$IBP$EAP$HF DA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA
@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA
') ; colorMapFromArray:#[10 10 10 0 0 0 13 13 13 6 6 6 3 3 3 26 26 26 30 30 30 16 16 16 20 20 20 23 23 23 0 0 63 0 51 0 0 51 63 51 0 0 51 0 63 51 51 0 40 40 40 46 46 46 43 43 43 36 36 36 33 33 33 60 60 60 57 57 57 63 63 63 51 51 63 50 50 50 53 53 53 0 0 127 0 51 127 51 0 127 51 51 127 0 102 0 0 102 63 51 102 0 51 102 63 0 102 127 51 102 127 102 0 0 102 0 63 102 51 0 102 51 63 102 0 127 102 51 127 102 102 0 102 102 63 70 70 70 77 77 77 67 67 67 73 73 73 93 93 93 87 87 87 80 80 80 90 90 90 83 83 83 97 97 97 107 107 107 110 110 110 104 104 104 100 100 100 102 102 127 117 117 117 114 114 114 120 120 120 124 124 124 127 127 127 0 0 191 0 51 191 51 0 191 51 51 191 0 0 255 0 51 255 51 0 255 51 51 255 0 102 191 51 102 191 0 102 255 51 102 255 102 0 191 102 51 191 102 0 255 102 51 255 102 102 191 102 102 255 0 153 0 0 153 63 51 153 0 51 153 63 0 153 127 51 153 127 0 204 0 0 204 63 0 255 0 0 255 63 51 204 0 51 204 63 51 255 0 51 255 63 0 204 127 0 255 127 51 204 127 51 255 127 102 153 0 102 153 63 102 153 127 102 204 0 102 204 63 102 255 0 102 255 63 102 204 127 102 255 127 0 153 191 51 153 191 0 153 255 51 153 255 0 204 191 0 255 191 51 204 191 51 255 191 0 204 255 0 255 255 51 204 255 51 255 255 102 153 191 102 153 255 102 204 191 102 255 191 102 204 255 102 255 255 153 0 0 153 0 63 153 51 0 153 51 63 153 0 127 153 51 127 153 102 0 153 102 63 153 102 127 204 0 0 204 0 63 204 51 0 204 51 63 255 0 0 255 0 63 255 51 0 255 51 63 204 0 127 204 51 127 255 0 127 255 51 127 204 102 0 204 102 63 255 102 0 255 102 63 204 102 127 255 102 127 153 0 191 153 51 191 153 0 255 153 51 255 153 102 191 153 102 255 204 0 191 204 51 191 255 0 191 255 51 191 204 0 255 204 51 255 255 0 255 255 51 255 204 102 191 255 102 191 204 102 255 255 102 255 153 153 0 153 153 63 153 153 127 153 204 0 153 204 63 153 255 0 153 255 63 153 204 127 153 255 127 204 153 0 204 153 63 255 153 0 255 153 63 204 153 127 255 153 127 204 204 0 204 204 63 204 255 0 204 255 63 255 204 0 255 204 63 255 255 0 255 255 63 204 204 127 204 255 127 255 204 127 255 255 127 130 130 130 140 140 140 137 137 137 134 134 134 154 154 154 157 157 157 144 144 144 150 150 150 147 147 147 153 153 191 164 164 164 161 161 161 167 167 167 174 174 174 171 171 171 191 191 191 181 181 181 187 187 187 177 177 177 184 184 184 153 153 255 153 204 191 153 255 191 153 204 255 153 255 255 204 153 191 255 153 191 204 153 255 255 153 255 204 204 191 204 255 191 255 204 191 255 255 191 194 194 194 204 204 204 201 201 201 197 197 197 214 214 214 221 221 221 218 218 218 211 211 211 208 208 208 204 204 255 204 255 255 255 204 255 234 234 234 231 231 231 238 238 238 224 224 224 228 228 228 244 244 244 248 248 248 251 251 251 255 255 255 241 241 241]; yourself]
!

poti1
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self poti1 inspect
     ImageEditor openOnClass:self andSelector:#poti1
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:'VUMeter class poti1'
        ifAbsentPut:[(Depth8Image new) width: 112; height: 121; photometric:(#palette); bitsPerSample:(#[8]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
D1DQD1PPEAPTD!!HRDQLQDA@PD!!DRD!!HPD1@PDA@SD!!LSD@XRD1HSD!!HYDALED1@RE!! RD!!@RD@XWDQHSD1DVD1@PEAHFA!!LTFQ$PDQ@RD!!$PDAHQD!!DRDQHP
DQDSD1LYFAHPDQDPDA@PDA@PDA$RDAHSD1LPDA@SD1@PDQ@SE@XSDAHPD!!@SEADTD!!LSD1LRD1HPDQ@ZD1@RD!! RDA@TD1@PD1DRDAHFDPXZDA$UDPXQDQ X
FQLRDA@PD!!LSDADPD1@PD!!HRD!!LPD1HSEALSD!! RFQ$PFQ@YDA@PDQLQD!!HQD1@PDADSD!!HPD1@PD1HREALFDA@SEALUDAHPD1@PD1@YD1HFFPXSD0 FFAPP
BPXEAQH@A XXFALTDALTA \EE@$PA!!HQDALREA@PDQLQD!!HRDALSD1@PDAPRD1DPDALQD!!@RFQDRD!!$QD1DQD1HPDA@TD1PRD!!@PA XTDA@QDALQDALPD1HR
E!!@PD!!@TEADYD!!LRD1@IK3TUA!!LHLC(;NC,5K3TFF@HEL!!(5N$A@OQH-K \TDALQDAHRDAHPDA@PFAHQDA@YDA$PDALPD!!DSA!!PSD!!LSDA@TDQDQDADQDQ@T
EALSD1LTEAHSD1DREAHTDAPQDQ@TEALRDADSDA@SD1@RFADPBI?)MPXQFM/>=/''>3]WZEPXF5-''I<^?9;.1Q5-XPD1DPFALQFA@QD1PRD1 RDA@QD!!LTD!!LP
EA@PDQLPD1LSD1LPDA@SDA@YDA@PDQLRD1LSDALYD!!$SD!!@TA!!PSD1HTD!!PEDQ@PEALSDA@TEAHTD0A:;34SDASR:SX5TQ_O=W(BD>3[^.-@L#X2FN''WEAHP
D1TQEA@SD!!LTEALPDA@RD!!LTA!!@RD!!LPD1@PD!!HPDA@PDA@SDQHPDA@PD!!HPD1PPEADSD!!PSD1LSDQ@SFQLPEA@ZD@XIA TQD!!LPFALSDAT@''>89AQ P6^(3
LSPPK>+XBG++PDC,N1\VFA#Y:1HXFAHQE@XSD1LRDQHXD!! QD!!@QD1DTDADQDAPTD1HYDALRD1@RD!!HRD!!@PD1HSDA@FEA@TD1@TDAHPD1LPDA@SD1$PD1PS
DAHTA!!LRA!!@TDALXB\;/N@@XD=G::/#<5AKM51#S<Q#P=_[.?-(-5^$TFAHXF!! XD!!LPDALTA!!PSD1@TD1DRDQHPD1DRD!!DPDALSD1PFBPXHAQPRD TRDQPF
D!!LRD!!@PD1@TEAPSD1LSDA@PDAPSDQDQDADQDA@PD1HHEASL;S\GD1SZ:UE''PB<IT_A:6-XE3OA:NL9QF.+WAQLSD!!@RDADYDQ XDAPRFA YDAPPD!!DYD!!LR
DQ@QFQHPD XGA0DA@PDA@@TFD!!PTA XTD!!DPDALTA XFDAHFDAPSD1DTEALSDADRDADRD1@ZFQHS2N06BP S6](T@0$GD1_,;_A@@\3+L0LBBP''W41LTAPTQ
D!!DSD1LQDA QFQ(RFQHRDAHRDADQD1@PD1LRD@XE@@DA@PDA@PDCBQDSE@XPE@XPEALREA@SD1PSDA@RDALQDAPPDA@TD!!LTDA$FD1HSA\''>:]/YPM#/5M[*
4#TB3?/,E!!SM>N''Z6]P;:^7T5\</D0TQDQ@TEA@YDQ@QDA@PDA@PDA@TD!!@PFQ@PEA@H@@DA@PDA@PDC@PDQDAHSDA@SDAPRDALQD1HSD!!HYDAHPDA(QFA Q
DQPTEAPRD1PPD T:5^'',:,''I:^/-<]T.A2?T2QPHN-/,;N+,2\?[5>3ZMQHSDADRFADQDALPDA@PDALREAPRD!!@QDQ RFQ@F@ DA@PDA@PDA@PDAD!!LQDQLT
A!!PPEADPD!!@PD!!LSD1HRDQ@PFA@PEA@FAQLPEAHVFADPA!!LFA1@EAQXXB@\VA!!HPD!! QDPTSDQDWEPHEA!!LPE@\ED1LSD1DQDA@SDQLRDQHYDA$RDA@RD!!$X
FQHF@@DA@PPCEA@T@PDD@Q@QD1LTA!!PTD1@RD1DPD!!HSA!!PSD!!PRD1LED0XTD0XTDADPD1PTDQ@SDQDRD1@SD1XQFALQFQLHD1PTDQ$RD!!DYE@XSDQ@ZFR<R
DAPEDALYFQ@PD1@YFADZD!!HRDQ(ZDALSB@DA@PL@AAD/D0LA@ PSD!!HRDALTDA@PD!!@RDQLSD XPDAHQD!!HPD!!HQFA PDAHRD1@RD!!HRE1LXD1PXF@XXDQHX
DQ(VDQXYFADPF!!DFDQDZF!!(SFA@YDQDPFQ YDAPQFQ@RDQHPD1$PFA(XD!!LPF@$@@PPC@PDA@@DA@P@GAPXTDA@XDALRD!!HPEA@RDQ@PDA$YDAPTEAPRDQLT
A XPD0XSDA@YFQHQDA@SD1@QD!!PTA!!LEE TRDA@QDQ@RD1HSDQ$YDALYE!!LPD1@PDALSD!!@REALSDQPSFAHPA!!LPD XGB@HC@0@C@P@A@R<R@ATPDA@TDADP
D!!PTD!!DSD!!LTFA(RFA@QDAHSDA@RDAHRDA@PDAHRDAHPD!!HXDQ$RFQLQEQ VD!!PTKQ@XDA@PD!!DPDA$YDQDQDQ QDQDQFA$YDADRD!!LPD1LTD!!HRD1@XD!!(S
BP YM$@.@@DA@P@/L#LXDAHRE@XRDAHFDAPPD1LSD!!PQDAHPDA@RDALFEADYD!!@PFQ@PDALRD1HQDQ@PDA@PEAPRBQ@XA $PD!!DSDQDQDAHQDQHQDQDXDA@P
D!!LRDQDPDAHRDADPD1HRDA@TD!!@YDP$EFSP=KPDA@PDA@"81A!!@FDALRD1PRA XPEAHSDALEA!!PTDAHSDQLTD1LTD!!PTDA@PD!!@SD1LTD1HPDADQDA(EFASN
<-H0A!!@PD1HRD1PSDQHPD!!HQDQ$PD!!DYD!!DQDAHQFADQFA(RD1@PD0TFDA TA0PGD@$A@PDA@PDED!!DFA!!LSDQ@TA!!@SDAPREAPRA!!PPDALQDQ$TD!!LSD1LT
EAPPDAPTEAHSEAHQD!!DRF!!@PBQP/6^/YP@TTDA@TD!!LSEAHPDA@PD!!@QD!!DQDA$PDQHQDALRD1@RDA@SD!!HTEA@PA  D@P\H@P EA $BAPLSEAPSEAHSDA@P
DQ@TDALRD1@SDAHPDQDREALRDAPFEA@PD1LSDALSD@XRD1@RDQDQDA F''=\34W(EEADYD1DPDALSD1LQDA@YDADTD!!@RDA@PDQDREAPTDQPPD1@XDA@PDA@S
APDCB@\BA!!LEAP\DFALTD!!PTD!! QDALQD!!@SDALRD1DPDQPTEAHSD1HRD1LSD!!HRD!!HSD1@FD1HRD1@RD XRA3?[N-SLEAHPFQ@PDA@SD!!@SD1$PD!!HQDQDQ
FADQFQDRD!!HQD!!DRD!!DTEALSEAHXFAPA@PD@@PL@@0HA@Q@TA!!@SDQLSD!!LSD!!@PDA@SD!!@XDQHTD1PPDALRD1DPD1@PDALSD1HQDAHXD1DYDQHXD@T.5>;Y
P@ PDQ@SD1DPD!!HTD!!@RD1PRD1LPFQ@QD1PPEAHYD!!$SE!! RA TPD0XSA!!LPB@PA@PDA@@DA@@XQDA@RFAPPD1@PD1LSD1PPEA@RD!!@PD0XSA TPBP TA!!@R
DALQD0XFDAHPFA YDQDSD1HSD4CY^ XTFATSD1 VDQHYD1HTD1@QD!!PSDQHSD!!XQD!!HEDA$SE@TSE!! QEALRD!! PDADF@@DA@PD@B@XFD!!@QDA@SD!!PTDAPT
EADSD1LSD!!HRD!!@SD1LPDPT/M!! TFADPDALFA!!LXD!!HRDAHRD1HFDQ$I@1PSFQ@FD!!$SDALPDA@PDA$QD1HSDA$SDA$TN"4SDQHQDADPD!!DSD1HTEAHSD!!@Y
DAPFE@XPD1@RDADPEAHSDA@QD@XFD!!PPD!!LSDQDPD1LSDQ@ZE@H/5>,2D1LFD1PTDADSDQLRDQDSDQDWE!!$PFDA@D1 RD!!DXFQ@RDQ@PD!! YDALQF!!LXL!!@X
4>)@AQXUD!!HQDQ TEA@SDALQDA PDALXD!!LRD1DPDALRD!!PSD1LTD!! PD1@PD1PSEAHSD1LPDAHR@@THK>3*LALRD!!HRFA$XFA@QDQHQDQDQDQPSD#G9;3@S
D!!$QDADXDQDRDALRD1LREAHYOM 5E]''-3 HUE!!HPDAPSFAPTD1HXD!!HPD1LTEADRFQ@YD!!DVD!!LTDAPSD1HSD1HRD!!HSD1@SD1DPDALREB?T3QH95#LFFADR
D1LQD1LPDA RFQ$PD!!@RFPXW<^4-D1DXDADZD!!PRDA@SD1@YDAHSPO#=5CX044@GEQDFEALPEA PA XSD!!LTA!!@TDALRD!!(YDA@SD1@PEA@TD1PPD1LQDALQ
DADPDALQDAHSD0X26]XXNN-@BAPFD1LSA!!LTD!!HYD!!DQDQPXF!!PEK?#0FAHSDA@XF!!@SA!!@SFQ QD!!@PA2?N43,YA-/HA!!LTDQ SE!!@SDAHRD1@SD1PTD1@T
DADTD1LFEAPRD1@FDA@SEAPPEADSDQDSD!!DSD1LSEA@FAQ@QAS''UM \PDAHSDQ(VDQHRDQDQD1LSAP$GFCC)63@EEAHTEALFA XTDADRDAHPDPX@A"4SBR;V
NA@FDA XD1XRFA@XE!!@FD1DPDALSD1PPDALPD!!DXDQ@TA!!PSD1HPDALPDALSD!!PSD1PPD1PSDAHFE@XSF!!LTEAHRD1@PDQLQDQLSD1LSD1@1L@TS<N0RA"86
F@\TD TQD0XFEAPTA $PE@$FD0XIF!!DRDALFA!!HSDA REA@TD@XSDA@TDA@XDALRFQ YD XSD1LSDA@SD1LPAPTTD!!LTDAHPDA@PDQDTEALFD!!PTNSTDEPXT
APXTA!!LID1KPMPDP6=@AA]'',D0SS5@XHK<,TE@HIEALSD@XFF XQM  ZD!!PSDA@XDALTEAPPA!!@PDAPXDQPSD1LFEAHPD1DPDAPRDA@TEAPTEALFA!!PPDA@T
D0XPEAPQD1HSD@XFAQPELN''XF  GD1@EDQH;E0TT2EDF@)<8@0#J2PPCN3HABC/HB@\FN1@HA $FEA@T4],2A!!DFDALRDA@PDA@PDAHSFAHSA TTDA@XD!!HP
D!! RDA@SF!!HRD!!LSD1LTD0XRD1HRD1LPEADSDALRD!!LSE@TFAQ+U;C,BD1 /AP\X3S(DA3T3@PDYFPDAE3@A@Q X@PD0L @DLL(F@APXA TGMOC,DPTPDALF
DAPRDA@FDA@RDA@SEAHRD1HSEA@TD1@RD!!LTEADQDQLRD1LPEADRDQHREAHTFQ@PDA@QDAPIDAPTEAPHK=#XE0HSTSPE@C :@PDRK0DAA0$A@PTP@PD@@ DA
F@TA@3\.@P@0P@ GA]S[M@PQBQ@SEALTEAPTAPXTDA@FDAPEEAPSDALPD XSDA@SEAPRDAHPE@XSDAPPDADRDQLYD!!PTEALFD0XTA!!@HAQPFAPU:53<DA4A@
@0PRMP\AA0TA@PDA@PDC@PDD@0DA@P DA@P.BPDHPC,@@#7[2P SD@ FA XPE@XSA!!PSDAPPA XTE@XTD!!PTD1@SD1@PDA SD!!@SD1LRE@XPA XRD1HPDALT
EALTA XSEA@SA0TS@ TBF]ORF@DQNAPG@1(G@PDA@PDA@PDA@PD@@PDA@PPA@PDH@ PDA#,E@QO[5"4GE@LFA XED1@PA XRFAHPEALPD!!LXDADTAQPEEA@T
DQDXD!!HPFAHPDA@SD1PSA XPD!!LTE@XFDAPPEAPTAPXSAPTY@ $:6#\A@R40@PDC@PDA@PDA@PDA@0DAK/;)E DA@PDAA@DA@P V@P@55C8@B@$ED0$TEALE
D0XTDQHTDA@SA!!LEA!!@SDADPD!!LTD!!@SD1PYDADQDALSEAH/DQLPA!!PTA!!@SEALFA TFA TFA TXNQ$AA,;SD0DI@ DG@PDD@PDA@PDA@PDAAJ?R6ATA@PDA
@PDA@PDCA@DG27(G@0$1K0HTA!!PEBPTFE@TFBQPSE@XFDA@PD!!@SDQPFDADYD1DRDQPTEA@HEAHSD1PFA"<HF $FD0XFD1LFDQ(IBP\FBC1@@ D/22<A@PDA
@PDA@PDA@PDA@PDA@PDA@@LA@@DA@PDA@PDA@PDCBS0SA@D=''1@EAP IAQPPD@$GD!!LIEA@FAQ /D0 EE@XRD1@RDALPD1HSE@XPD1@YA!!PRD $RAPTVD!!PT
D!!PFD1PHD1\S@ TS''3DC@QP@@PDA@PDA@PDA@PDA@PDAA@@A@PDA@PDA@PDD@PDA@PDA@PPD@0DXOCLI@A@SA!!PSB@$XD1HPA TTEALFA TIDPXEDAHSD!!HP
EAHRD@TFDA@TD1@EDQHGEB4TD1LSA!!@SAP$ID0 /3!!\DA1T:APDD@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PPAK1TD@PY:FP\FD1@S
BQLTA XFBQLRE PPDAHGF"<TD1DPEALPD!!PFD!!@TEAPPD@HFD@$HBQ FE@XFD0$ID0TED,''TFPDCAP@D@0DA@PDA@PDA@PDA@PDA@PDA@P\A@PDA@ DA@PDA
@PDA@PDA@PPA@P$A@QD?Y1(GA0TTD1PSAQ@RD!!@PD0XGAPXQFA@GD@TFD XSDAHFEAHRFQHQD0 16MWND@XHE@TPD@TED1 VA0\XY8 FA@DA@PDA@PDA@PDA
@PDA@PDA@PDA@PLA@PDI@PDAA@DA@PDA@PDA@PDA@PDA@P@221PH@A@VAPTSEAPTD TSD0\Q3L$3B@THDQ@TD1@FD!!HPD!!DREAXRD0TFN<;N5Q(PAQLPE@XT
AQLX43H@@0T2D DDA@DA@PDA@PDA@PDA@PDA@PDA@PDA@SW9@PPD@ DA@0DA@PDA@PDA@PDA@PPAF!!H@@Q\?LAPSA0 FBPTSK3@P2,;L4!!XYDQ PD1HPA XT
DQHQD!!LPA!!H3MP\R2-TXAR<SA!!LSAP$FD4CTE0LH@PDA@PDD@PDA@PDA@PDA@PDA@PDA@PDC@S#:=_0G@PDA@PDA@PDA@PDA@PDA@PDA@PLDA1I:+0$AE@ T
A!!PEK\;RM!!HQ^-XRAQTRD@TFD@TED1DQD1LRD@H/5M\3''=T0A!!PEFA@FA XE@ @HN]HR@0DD@P@A@PDA@PDA@PDA@PDA@PDA@PDA@PG;>?+<: DA@PDA@PDA
@PDA@PDA@PPA@PHA@@H>N @IBPDF@ \HBSWZ;C\H2<4-BALQEAPTA!!HTD1$RD1PPDAPRE#@53>3ZM1@ED@ GD!!LTM3TG@ L.F DA@PDA@PDA@PDA@PDA@PDA
@PDA@PDA@PDAM_/:=1PA@PDA@PDA@PDA@PDA@PDA@PDA@PDAB@XC@QH1D0PSD@H@E3DGO=+OEQLRD@XSE@XFD1LQD1LPDADPA!!PSA#_R47(SD,-@@AHHBDCW
OQDA@PPA@@DC@PDA@PDA@PDA@@DA@PDA@PDC@PDCB@@RNQ(A@P\A@PDC@PDA@PDA@PDA@PDA@PDA@PDA@3GR2@XUB@D/M1(BASGR6#8/A!!HXDAPFA!!PTD!!LF
A!!LRDQ@FAP PAPTS@B?,;]P2@1@SE=M@APPA@P@A@PDA@PDA@PDA@PDA@PDA@PLA@PDDAP$CA0@@D@D@A@DC@0DC@PD@@PDA@PDA@PDA@PDC@R;KMPTH@1A@
;MT-AQPPD!!LFEALTA!!PPA XFD0XZD0XSDA@PDA@FFAPSK1LRM]K1:<<QBPLRLP$A@PDD@PDA@PDA@PDA@PPA@P\A@PDABMK=?_+=?_3=?^T5@P$A@PDE@PDA
@PLA@PDA@PDA@PDA@PPQEPLABR7M<ML2FQ@SD@TED0TPDADTA XFAQ@TDQ YEALEDALPD1@RD0XHBPTF^-O-53$@@ @A@PDA@PDA@PDA@PDA@PDA@0PA@PS/
?/3<=?3=?_3<?_76?_+<N@LC@PLA@0DA@PDA@PDA@PDA@PDA@PDALL#W6T@SD1PGFP$SDQHEAQPTE@XSA!!LFDA$RFQ$PEAPRDPTID!! SEA QAPD/2-_X4@$A
@PDA@PDA@PDA@PDA@PDA@ DD@_7:?_/:>?7>=_7=?_+=?_7;?O/:3@DA@PD@A0DA@PDA@PDA@PDA@PDAE,7U23@FEAXYAQDSBP IFQ YAQ@SD1@TA XPEALP
DA@XFQHXA $EA XTD1DBD0X/5N$T@PDA@PDA@PDA@PDA@PDA@PDA;?/;=?/;?_+<?_7<?O7=?_7:>?7=?_3;D0P@@PDC@PDA@PDA@PDA@PDA@C#OK!!DCD1$E
EAHSEA@RAQLEA!!@SDQHSE@XTD XSEA@RD1HFBQ RAQ@SEAHSE0$F@1PH@PDA@PDA@PDA@PDA@PDA@PDI?__;?_/=>?7<?_7<?_7;?O/=?_3==_7<>/3Y@P C
@PDA@PDA@PDA@PDA@PDABPLCAR<PD!! FD@XPEALZD@ XD1@RD1@SD!!@PDQHSEALQEALSDAPEA!!PTD\7YO T@@PDA@PDA@PDA@PDA@PDCA@D8?_+=?_/<?_7=
?_7=?_7=?_7=?_7=?_7=?_3=?_8A@PLAA@LA@0DA@PDD@PDA@PDGD,?PK0XED XFBQPPDAPSEAHFDAPPD0XREADPD1DYD1LSEALPD1DFBPTVOL7JF@DA@PDA
@PDA@PDA@PDA@PGN?O7;>?/=?_7=?_7=?_7=?_7=?_7=?_7=?_+=?__:?PDC@ DA@PDA@PDA@PDA@PD@K-I@D XYDAPHE@TFD1@TEAPSD@XPEA@SD!!PSDA@P
D!!LFD1@FA!!HTA1@SA TSK0TD@PDA@PDA@PDA@ DA@0@=>?/:?O7=?_7=?_7=?_7=?_7<?_7=?_7=?_7==_7<?_3=@@PA@PPA@PDA@PDA@PDA@Q\HD0TFA TQ
D XSDAPPA XSD1LTEAHTA!!HPD1PFA!!PSE@XPD0XTB@$3D X@@@ A@PPA@PDA@PDA@PDA@PDH?_+;?_/;?_7=?_7=?_7=?_7<?O7=?_7=?_7=?O7=>?3=?N(C
@PHA@PPA@PDA@PDA@PDAAP@IE1\EBALPDA@TD1LFEAPPEALPEAPRDALTEAPTD!!@ED1PFFQPPMM''TNA(C@PDA@PDA@PDA@PDA@P\A?_/;?/+=>?7=?_7=?_7=
?_7<?O3=?_7=?_7=?_3<>?7==?7=N DB@PDA@PDA@PDA@PDA@PL04L06A!!PXDALPD1LSA!!LFDA@FA!!@RDALSDADXD!!LFA!!LTEADSDAXZ2-X=A@DA@PDA@PDA
@PDA@P\A6_75=?/<?_/=?_7=?_7=?_7=?O3<?_7=?_7=?_7=?_3=>?77?_$GA@LD@PDA@PDA@PDA@PP3"G(/E@TQ@ XRDALFD@XPE@XPEA@PD!!HSD1@VFA@P
A!!LPD1LQD0THD0@BE@HA@PDA@PDA@PDA@PPA@/;9=?/=>/7;?_7=?_7=?_7=?_3<?O7=?_7=?_7=?_7=?__=?_+<2 DG@PDD@PPA@PPA@PDA@ XHAQHEAQHF
EAHSEADPAQHTD1HSEAPYDQDRFA(RDALTEALPAQPPE@$@E@LA@PPA@PDA@PDA@PDA@_C7?_/7?_+=>?/;?_7=?_7=?_3<?O3=?_7=?_7=?_7<>/7<?O7=?O0C
@P@AA@PD@PDA@PDA@PDF@@\SE@XPD1@TD!!@PD@TTDQHREALSD!!HPD1LSE1LPA!!@SD0TRPM[NPCTA@PDA@PDA@PDA@PDA@PK7>?/;>?7<?O3=>?/;>?/;>?/;
>?/;>?/<?_7=?_7=?_7=?O7<?O3=:PDB@PD@@PDA@PDA@PDABS@=3C4SD1DPE@TPA XTD@ TD1HSEADPEAPZDAHFA!!@FA!!LIBR<;PL1:@PDA@PDA@PDA@PDA
@PF_?_3=?_3=?O3;?O+:?O+<?O3<?O3<?O7=?_3<?O3<?O3<?_3=?O7<<?TD@PLC@0DA@PDA@PDA@Q]@PC,UBQDPD1@PD!!PFE@TPD!!(PAPXXFQHPD1HSD!!PT
A!!@XD@XTBPDIE@DA@PDA@PDA@PDA@PDA>O3<?_7=?O7=?O3=?O3=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=F D@@0PA@PDA@PDA@PDA@0\HE@$GDA@P
DA@ED0XQDP IA XZDA@ZF!!@PDA EA XEA  @A $S@@DA@@DA@PDA@PDA@PDA@_/:?O/=?O7=?_7=?_7=?O7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_33>7(A
@PDAA@DA@PDA@PDA@PTTA0\ED1@SD1LRDALRFA(ZFA@EA!!$XDALIE@TRDQ(YEA RK''+P23$F@PDA@PDA@PDA@PDA@QW>>_38?O;=?_7=?_7=?_3=?_7=?_7=
?_7=?_7=?O3<?O7=?_7=?O/5>.?,@0DA@PDA@PDA@PDAA0LPL3(:E0XFEALRDQDQDQ$PD@XFD0 ZE $QMC\.D1DEEALQEAY@4MSPEP@A@PDA@PDA@PDA@PE@
<OG6:_W5<?/<<?7=<?7=?_7=?_7=?_7<<?7=?_7=<?7=<?3:=_#.;_'');0DA@@DC@PDA@PDA@PDAL<3MPA(FE@XPD1HSEAPFDR8XDATXD@XHMM[15Q HD!!$S
D@ BE@ GE@DA@PDA@PDA@PDA@0PA3>'')7=W0;>;6=_;>?OO=?_7=?_7=?_7=?O3=<?7=?O3>?/W8;>/]6]/_5?HA@PHAA@DA@PDA@PDAA@TFB@ GD@XTD@XS
D1 WA3+L6S4FD1DQ@1\94M,0A TIA1PFB@$A@PTA@PDA@PDA@PDD@@@CAG+Y5=+T5>7];M?/>_'':=?/3?_7=?_7=?_7=?_/>=_''8<N/_:^3[:]_U4-/2@ DA
@PPA@PDA@PDA@PDC@@LFB@$EAQPTD1T1^!!D.K][NBADIL,8XE=#+DPXY3]+S4-GP3<+KA0DA@PDA@PDD@ HD@0GL4]/Q4]S]6N''Y7^/-7>31=_/=?O3=?_7<
?/W/;M''Z6N+W6-[)4^3Q5]WU6@$J@PD@A@DA@PDA@PDAES+H2TCOPH 9D1@<5-''ND3CU4APUD-SX2#$26G(BK=[1<OC+:?C0:R<D@PDA@PPBA@@@A@@A^-[Y
4]WT7=+Y6-/_5=''W:^3->^;5=_+>:.3Y5=''Z6N''W6MW\67+Y4-W\6M,E@PLA@0PA@PDA@PDA@S#X4-/,6^+*5SLFES?ME#LXL\0VA!!PRD3G1:]T4BQ@-LC@0
L3HUK"<D@PDA@PL@A0DC@0P@@W+M6=ST6-?Z6=+Y;M?*:/C-=_/:?O7=?O+7=/#25=+Z5=''[5]!!:6MGZ4-S_A DD@PLA@PDA@PDA@PDRLA\-F!!X3MR8S@0XU
K !!:4-WRE!!HUDALEM$@4A!!TEEAPSD1PR@!!LF@PPH@PDAA0HAA@LD@@D;6-''T6-+[7=''+7?''9>_W:?/7=?_7=?_3=>?+;=_C2;?#_6]/)6-?Q6=WQ: LA@@LA
@0DA@PP@@0DA@PPID \FBPXFD1DVF!!DSFS(7E0TVD!!$XE!!\PD0TRDQHYD TTL3@8NADA@PDC@P\IA@DD@0LAMM/_5-''_:>+-;/''>?O7:?_/<?O3<?_7<>//<
?O3<?O3:=.;-7>316M?[5-<D@0PB@ @D@0 SD0XE@Q 0DAXZD1LPD!!HSEAPTF@TEBQ@FE!!HSAQ@UDQDVE1DPEAHXL]+,5L02@@DA@PDGB@DA@PDC@QG);^3_
;?[3=/;<>?3=?_7;?_7=?_7=?_7=?_7=?_3=?_O>?/''0;^+_<N3ZA@\C@ \B@0LGAPTH@P@?6-+RM!!DPD!!DQD XPD@ SE!!LSAQPYDA$TBQDUDQPQD!!LRD!! 0
E1XFA0DA@PDA@@\A@PDAA@DB6_[/;/_5>?/:?_7=?_3<?_7=?_7=?_3;?O/<?O7=?_3<?_37<?[5<OK6^ D@@0@BA0HCA@DA@PDAD1H.MQLEDA@RD1$SD@XS
EALSEA(VFQ@FEA@PD!!(ZD1(QD!!LTD1PS@ $A@PDA@PLI@@DA@PLA@]''7>/+7<?+=>?7<?O3=?_3<?O7=?_7=?_7=?_7=?_7=?O33?O7;=/;.=3@A@P\B@0\I
A0LA@PDD@P$E@1HPEADPFQHSD1LRDQDPDADRAQHQEQ(UFQLRD!!DQF!!XRE@XQK34:@PDD@PDAK0DA@@DAA@D4>//;?O''<?_7=?_7=?_7=?_7=?_7=?_7=?_7=
?_7=>/7<?_7:?O3;>?XG@ @G@@ EBQHC@PDA@P\;E0TRDQ$SD!!LQD!!HPEAPPEA@PDALSD1$QFQ@PDAD/D@XSEA 86-WV2@ A@PD@@PFHEPDD@@DA@_+=?__=
>/7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_3<>?+;?O3<?O/W@P\SD XTA1HI@PDA@PD36MSU^ XFD!!DPDA$PD1LPDALSD1@PD0XPDA@PDQ(XFQLPDQ@TLC$.
D!!L@A@LA@PLD@V\/@PD@@0SO?_3=?O/=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?/7=?O/:?/+;APLZD0$TBQPAFPDAA@DD@@X-M#DZDADSDQ@PDA@SD1LS
D1LSD1LQDA$PD!!DZDAPYD!!LSDQ@FD0LIA DA@PDC@PPA2A@A@P\AAO3:?_7<?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_/=?_3=?_7=>@LEB@ S@ @AMPDA
A@DA@P\ID0TSD!!LQD!!LSD1LRD XTDQ PD0XRD!!$PD1@PD1PTDA@QD1HXDP 0"G(B@PLC@PDA@PGU@PHAD@ON>?3=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=
?_/=?__<?O/:?@@@D1(GAP$BE3DA@PDA@QQ@EPTSFAHXDAHSD1@PD1DPD!!HRFA@RF!!DYDADPDADTEAPYF!!(SD#CV6]OHA0DD@PDD@PDA@_\AA @A@_/=?//=
?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7>?_3=?O;;?D@DDP@E@ HHKT@A@ PA@PDV5M/TLPTHD!!LSDQ@PDA PFA@QEAHQDAXQDQ(RF!!HYDA TDA RA!! 62#PS
E@PD@@DA@PDA@PDF6PDB@@TA?/7;?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_75?_3:?_TCE@\F@@X44CDE@PDG@PDAB@ 4^#PYDQ(PD!!@PDAHRDQ SDAPT
DQ@YDA@ZFQHYDALSDADRD@XTDA@TA1@FA@DA@PDA@PDA@S?T@PLGACG;?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_/=>?7:?_T@D@\EAQQ''2@DA@PLD@PLA
@P$HD0TVD0XEAQ@SDADSDAHQD!!@PDQ RE!!XREADRDQHPD1HXA!!HREQPTASCO5SHA@PDA@PDA@PDA;1$DD0\A3?+=?_/<?_7;?O7=?_7=?_3;?_/=?_/;?_3;
?_+=?_\AD1PSAA+9L0DA@PDD@PDC@S5@E!!LSEA@EF!!HRFALPD0TRD1@FDAPSD1DRD1PTD1@PDA RFAHVEAPPDMOZ5''(@A@@D@PDA@PDAA@G6APXUD D8>/_=
?_W;?_3=?_7=>?;<?_+=?_7=?_3;?_7=>?0H@A(S@S3;EPDD@PDA@PDA@P@23M+KEPXVD!!DXDQPFDA RDA ZFQHXF!!HYD1@PFQ@PDA@PA!!HPDQ@RD1U@P@$A
D@ A@PDA@PDA@PDA3-,HBQHS@3S=?O3=>/7;>?7<>?7=?_;=?_+5?_7<?_3=>/0DBB4I@#3<L@DC@PDA@PHA@PDCA1D:2#DHD1 RD1 SD1@SDA SDALSD!!LR
DQHXDQ(RDAHPD!! ZFQDPFQHQFQLSEC_M@PDA@PDAA@DA@PO:3Q\ZE1LA@_+==?79?_7=?_/:>?7=?_7=?_7:=?7=>38DD1(Y@#7=D@LA@PLA@PLA@PDRPADI
E@HFE!!XEFQ@PD!!HPD0XPD1PRD!!@QD1 RD!!$PFQ@SD1LTDA@FAPXYAR8IK-+.:# AA@DA@PDA@PDANO7,+245K!!DAF/7<?_;=?/+=?_3:?_7>>?7<?_7<<@LH
FS(/@\?=L@DA@ LA@PDA@PDB5./UN!!HFDQLTF!!DXF!!PFFA@FAQDQD1@PDQHXDAHPD1DYDALZE!!DSDA\QD TZ3O''66S(I@PDAA@DA@PD@@PO;>?#+4=[IMPHD
A/7=?O7=>?+=?_3=>/7=?O+S@@HQOS<6M-#7^ DA@PDA@PDA@PDA@#WM;N3TL1PXE!!DPEAHXE@XID1 PA!!@TEADPDALPD!!HPDADQE!!HPF!!@REAE:9_C-^ \F
EAXD@PLA@PDA@PD@6/3==_36;/#S31\A@";X?_7:?_7;>/7<^ DDKS+I5M/V^-[760@A@PLA@P@A@0DAA@LDA$C)<]]:D XZE XPD!!@XDQDQD!!DPD!!@YDADS
DAHPE@XQFA(IE,8;FR;)?/WSDQPPFW+ZDPDA@PDD@PDA@QG==_7:?O#5>^?-4#<2E1HTBPLC@ TRE3T:^-_7?/[-;>;>>0PA@PDA@P@A@PDA@S/TF TIE,;1
>-,.D0XXE@$ZM#DZEADSD!!@SD!!@QDA@PDADZDAPRB\3840H.;^09E1@IM]SY^ @A@PDA@PDA@PDA>/+;?_35=/W5=/''.;MI''M3\6LSX9NL''X<_C->_#7<O/8
?QLA@PDA@PDA@PDA@PP36M 9A  TN^+-N \/2R4@M^+XBQPPDA@PDAHXD!!PTFQHQD0X/DSWW:<<SD!!$QD!!HBK]+YE @HF@DA@PDA@P\ABPS.?_+5>?;5=?''-
;./Z39<>NF_N5M#*>^7-;/_8>O+7>/@D@PPA@PDA@PDA@PDREA#M4Q\QEA@WMQD/5N7JF-O83PXRD!! YD1DPD1@YEA@PA!!L25]''V<OWWE1DRD1PTDADUE1LE
L=+N@PDA@PDA@0DAA=S;?OW>=>?5?O[;>/3<>.;/;_C0:/G1>OW7=?C>?/(C@PLA@PDA@PDA@P_YM PGD3HQF!!DSAPTPM]S75C;5?^,ZEQDQFAHRFQHPEAPX
FQHFDS2_Y=K05R<UD1 ZF!!(QE@$SM\7*F@DD@PDA@@DD@PDAD>'';?_3=?.7.;N3,9^?8=?/9>N?->OW6;?[=?_49@P\A@P A@PDA@PPQ4= ;DP\TDAPPFQLV
D!!@05!! 86=W1M@XQD!!HQDQ$YDA@FD1HZE \IA HS^( GAQXPDQ@PF!!XVE?CVDPHFMPDA@PDA@PDC@@DA@!!\U@0D@@PDDA@DA@AH02^''7>/[9?/77?N0A@PDA
@PDA@PDA@PLRD0[S;C$QDQHYD!!DSFQ$ID!!TXFP\>30 XDQHXDQDQD!!@RDQHTEADRFALVD1PPDR<QF!!HSDQLGECA@E0XG2=\<@PHA@PDA@PPA@P$C@PDA@P@A
@PLD@PDA@PDA@1U''6MWOE0LD@PDD@PD@@PLA@PCO3Q@EDD@:DA@QEQHYDA@QD1TVDQ@IEQ(PD1HPDADQDQDRA!!$XE@TSAQDZE1@TD1PSEADYF!!HQFQ@FA TE
^-_HBP\A@PLA@PDA@PPA@PPD@@LA@ PA@PLB@0DC@0DA@PDA@PDA@PDG@PLA@PDA@PLH2-SIAP$PA!!$PDQPTD!!DTD TPDQ PDADFA XFDQ@QDQ YD!!@TD1LZ
F@XPAQLREADXDAXPEA@SA!!PQDQ(EM]/MA!!HY5ATA@PDA@PDA@PLC@PDA@@DA@PDA@PDA@PDA@PDA@PDAA@DA@PDAA@DC@S =B@KI;L$SD!!(FF!!PSD!!$PD!!(Q
A!!HSFQPQLALUD!!XVFA$QD!!$PEADRDQ@RD@XTDADRD!!LYD!!@PDAHQDQ$XD3CJF@$H4=T0@P@A@PPA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA
@QCT4!! HD,81DQLPFA@SDAPPD1HRDQ@QDADXFQDYD!!@PD!!@SD!!DPDQLSEADSDAHRFQHPDAHSDQHRD!!HQDA@QD!!LQFPX@2M\7@#WXP@DA@PDA@PDA@PDA@PDA
@PDA@PDA@PDA@PDA@PDA@PDA@PDE3B8BL]+PLALRD!!HSD XSDA@SEAHPDAHPD1LSD1@SD1LPD1HPDADQD!!DTD1PPDA$QFQ@YDAHQDA@QDQDRD!!DQD!!@PD@XZ
LM_RBP_S>,4@@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PLA@PDG^/W[E ]@63 TAQLYFADRDR<PFQ@PDA@QDQHPD1HSD1@PDAHTDAHRDQDPDQDQFQHQ
DAHSD!!HQDA ZDQDYD!!HPDQLPA!!@FA!!D0F@\7;>,.DP$I@PDA@PDA@PDA@PDA@PDA@PDA@PDA@PDAA@DA@PHG@27*>]@@D3<-DADQD!!HPDA@YD!!HRDQHRDA@Q
DQ$PDA@PF!!PPEALPDQDZD!!@XDQ$QD1HQD1LTDAHZF!!DQDA@RDALSK1 ZF  TD!!LY5?;PD1HEEQ@F@0DA@PDA@PDA@PDA@PDA@PDA@PDA@PDA@@TQE1$EPN70
L@\QD1@QEA@QD!!LPEALSD1LSD1LSD!!@PD1HQD1@TD1@RDALTDQLPDALTDAHYD1LSEADPD!!HPDA@PDALRD0TQD1HXD!!XHPN;-K0TRDQDUDQLTBPHC@PDA@PDA
@PDA@PDA@PDA@P@RECLWEALRA!!KW<=@PBQDRDQ@YDQ(QFQDPD1@PDQDPDAHSDA@QD1LTD1@RD!!@PD!!@RD1PFA!!DQD!!HSFALPDAPRD1HSD1@SD1@RDALPK1 T
EN/.3 $QE2<REAPQF!!XREAPEAP\B@@PC@0 GB@$SD1HRF@$PA XQDA@GPO#-L!!@XDQHSDQ@SA!!DQD1@QDQ@QD!!@SD1@PDA@SDQLQDA@SDQLRDAHRD!!DYD@TS
DAHYEAHTFALSEA@PD1LPD $XA  RA<+76S@XD1LSEQDXD0XFEAHQDA@PDAHPDQDSD1DQDA@PFQ@FDA@ZD TQD!!A:>=HFD1HQD1PPF!!HSA!!PSDQHSE@XPD1LS
D1LPD!!$PEALPD!!@QDQPSFQHPD1LSDQ@RDQLPD1LPD!! YD1HSFR<GEQPHBQ#+?S8EDAHRDQDQD!!HRDAHRD!!LSD1LPDA RD!!PPD1@ZF!!$RDA$RDQHRDAHFL_G5
LQ SD!! ZAQ TEA@XFQPEA!!(XFA PEAPZFAHTDQLZK1 SEA@RD!!LRD!!LPDALSD!!LQDA@PDADRD!!@TDAHZD!!LQLS 75L0/AQHRDADRFQ@RD1LPD!!HSD1HRDQLQ
DQLPEALQFQ@PDAHRD1DPDA@SFAOQ6C SDQ\WE3,-AQ YD1LSEA@SFQ@YD1HTDQ@PEALTEA$RDA@RDA@PEAHPDA@SEA@PDA@PDADSD XPEADRD1$FN.;84C@X
APTQDALQD1DTDAPTD1LQDADQDQ@PD1@SD!!@PD1HRDAHPDA@PFQHRDPXEFQHRK!!HH5N;,N1$QFQPYFA(ZD!!DPDQLPD1HTDA@YD!!DPDA@TDA$SD!!@RDQ@SD!!LS
D1LSDALSEAHRDA@RD!!@QA,7-PCLBBPXRDQ@SFQ@REAHSD!!DRDQDQDQ@PDALSDQDPDADQD1HQDA@PDQ@PFQLEFA@PK]X;E=_[LQPSA!!PTD!!$PD1LSD1@PDQ$P
D1@PDQDRD1HYDAHRDALQDA@PEADSE@XPEALSDQ@PD!!HRD!!HRLAGP:>3+FQLQF!!LRDA$SD!!HYF!!(XDQDQD!!HQD!!HRDA@PD!!@QDADQD1LPEA@SEAHEK0XQLM#8
;L?X:_E@BQTSDQHPDAPQDQ@TD!!DRD!!@SDAPTDALRDA@RD1DSD1LRDQPSEAHFDAPQDQLQDAHRDAPFK>/02S@6:3\SDADRDA$RD1PRDQ$RDADQDADSD1$RDALT
D!!@SDA@SDA@PDALTD1PRD1 SAQQ@;MX5NCCZ6P@WEATXDA@RFADYEADRFQLTDA@FEA@PD1LSD!!HRD!!LREAPRDALPD1@PD1@SEAHSDQLFAPHYE\''0:= 5D1@S
DQHRD1HREALSDAHRDA@SD1PSDQLSEAHQD1HTD!!LQFQ@QD1@PD!!@IE!! FD4@ZM^3W:=PEFA RD1@SDA@PDALQD1LTD!!LSDQDSDA@TA!!HPD1DFEALPDQ@PFQHP
D!!@FEALPEALRDA@RDP /5ML:A!!HQDA$RDAPQFADPDAPRD!!DRD1@TDAHTEA@QFADQEADPD!!@QD1HSDAHXF@\PDA@QD0U@6$@SFALSEA@RD!!@RDA@YD1@SD1@S
D1(SBA@SD@XQDQLXE!! QEAPREAHPDADYDQHYDA$YDALSEA@QEAPFD1DQFADQD!!HSD!!HRD!!LREA@FD!!LFD1@PD1 QD!!$SDQDRDA(YDAPRD1DTE@XSD1@RDQHE
APXSD1HPD1 YDQ ZFA(PD1@QFADPFQHFDQ$XDQ PD1@FEALTDA@QDQ@SD1HRDAHQDADRD!!PPEAHPD!!@FA!!@YDQDQD1HSDQDQD1LPD1PPDALRD1DTDALPFQ@P
D1PTD1LPEADSDALQDAHRFA(ZDQ$PFA$QDQDQD!!@QD!!HSDQHREAHRD1LPD1DPFQ RDA@QDP@a') ; colorMapFromArray:#[10 10 10 0 0 0 13 13 13 6 6 6 3 3 3 26 26 26 30 30 30 16 16 16 20 20 20 23 23 23 0 0 63 0 51 0 0 51 63 51 0 0 51 0 63 51 51 0 40 40 40 46 46 46 43 43 43 36 36 36 33 33 33 60 60 60 57 57 57 63 63 63 51 51 63 50 50 50 53 53 53 0 0 127 0 51 127 51 0 127 51 51 127 0 102 0 0 102 63 51 102 0 51 102 63 0 102 127 51 102 127 102 0 0 102 0 63 102 51 0 102 51 63 102 0 127 102 51 127 102 102 0 102 102 63 70 70 70 77 77 77 67 67 67 73 73 73 93 93 93 87 87 87 80 80 80 90 90 90 83 83 83 97 97 97 107 107 107 110 110 110 104 104 104 100 100 100 102 102 127 117 117 117 114 114 114 120 120 120 124 124 124 127 127 127 0 0 191 0 51 191 51 0 191 51 51 191 0 0 255 0 51 255 51 0 255 51 51 255 0 102 191 51 102 191 0 102 255 51 102 255 102 0 191 102 51 191 102 0 255 102 51 255 102 102 191 102 102 255 0 153 0 0 153 63 51 153 0 51 153 63 0 153 127 51 153 127 0 204 0 0 204 63 0 255 0 0 255 63 51 204 0 51 204 63 51 255 0 51 255 63 0 204 127 0 255 127 51 204 127 51 255 127 102 153 0 102 153 63 102 153 127 102 204 0 102 204 63 102 255 0 102 255 63 102 204 127 102 255 127 0 153 191 51 153 191 0 153 255 51 153 255 0 204 191 0 255 191 51 204 191 51 255 191 0 204 255 0 255 255 51 204 255 51 255 255 102 153 191 102 153 255 102 204 191 102 255 191 102 204 255 102 255 255 153 0 0 153 0 63 153 51 0 153 51 63 153 0 127 153 51 127 153 102 0 153 102 63 153 102 127 204 0 0 204 0 63 204 51 0 204 51 63 255 0 0 255 0 63 255 51 0 255 51 63 204 0 127 204 51 127 255 0 127 255 51 127 204 102 0 204 102 63 255 102 0 255 102 63 204 102 127 255 102 127 153 0 191 153 51 191 153 0 255 153 51 255 153 102 191 153 102 255 204 0 191 204 51 191 255 0 191 255 51 191 204 0 255 204 51 255 255 0 255 255 51 255 204 102 191 255 102 191 204 102 255 255 102 255 153 153 0 153 153 63 153 153 127 153 204 0 153 204 63 153 255 0 153 255 63 153 204 127 153 255 127 204 153 0 204 153 63 255 153 0 255 153 63 204 153 127 255 153 127 204 204 0 204 204 63 204 255 0 204 255 63 255 204 0 255 204 63 255 255 0 255 255 63 204 204 127 204 255 127 255 204 127 255 255 127 130 130 130 140 140 140 137 137 137 134 134 134 154 154 154 157 157 157 144 144 144 150 150 150 147 147 147 153 153 191 164 164 164 161 161 161 167 167 167 174 174 174 171 171 171 191 191 191 181 181 181 187 187 187 177 177 177 184 184 184 153 153 255 153 204 191 153 255 191 153 204 255 153 255 255 204 153 191 255 153 191 204 153 255 255 153 255 204 204 191 204 255 191 255 204 191 255 255 191 194 194 194 204 204 204 201 201 201 197 197 197 214 214 214 221 221 221 218 218 218 211 211 211 208 208 208 204 204 255 204 255 255 255 204 255 234 234 234 231 231 231 238 238 238 224 224 224 228 228 228 244 244 244 248 248 248 251 251 251 255 255 255 241 241 241]; yourself]
!

poti2
    "This resource specification was automatically generated
     by the ImageEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the ImageEditor may not be able to read the specification."

    "
     self poti2 inspect
     ImageEditor openOnClass:self andSelector:#poti2
     Icon flushCachedIcons
    "

    <resource: #image>

    ^Icon
        constantNamed:'VUMeter class poti2'
        ifAbsentPut:[(Depth8Image new) width: 109; height: 111; photometric:(#palette); bitsPerSample:(#[8]); samplesPerPixel:(1); bits:(ByteArray fromPackedString:'
KR40KQT-K24-K"8WK24-KSL-K3@-K"<0K2<0KS@0LC@/K3@0K2</E2</K24/K2</K2<VK1\/K2</K"</ER<-LC@UK240KR<-K2<ULC@.K24UKS@-KR4WE3@.
L3@/LC@0K2</E240K2<5MS@3LB8/K2</K1T0K"<WKR8/K2</K2</E3@0K24/LB<0E24-LB4/E2</K2</K2</K2</K2</E"4ZE!!T/K2</LB4-E240K2</KS@0
LB8.E1\/E2</K240KR<UE240LB40LC@WEQTWK2</ER40LC@/KR</ER</K2<0ER<WE2<VK2</K2</K1\UKS@.K3@ULC@/KR<WK24/K2</K2</FB</K1TVK24/
F"<UF"<-E"<-KQTUER<-E!!\VK1X-K24/E240K2<0K!!\/K2</KQT/K"80KR4WLB4/LB<WK1\WK24-K"</K2<0LB<VE2</K2</K2</K2</E3@0L28.K"8.KR4W
K1T/K2</K2</E2</K2<-KR</FB<0L2</ER4UK1\WE24ULB</ES@WFB<VK#@VE24-E1\/E"<0K3L-LB4-KQT.LB8-K1\/LB<XE28/K24/K2</K2</E"4-K2</
K2</K28/LC@0E3@0LA\/LC@3K!!\0K1\UK1TUER<VKR</K2</K1WM>N5:FQT-E2<WK3@/LC@-LAT/LB4-KQ\/LB<-E3@-LC@0LB<-LB8-F!!\/K"<UE24WKQX0
KR<UKQX0LB<-KR<0LB40K240KS@/K"8WLB8-LC@3K24-LA\3K2</E24UEQTWER</K2</F"</K2<X5>+JL1$-K"<WE1TZE2<WK2</ER40LB40K#@-E!!X0K!!\/
KR4-ER<VKR</E2<WE24UK24WE1\/F!!T-K"</K2</K24/K2<-KR</LB40LB4-KR8-LCT2K#LUL3L-K"4/K2</KR4-KR</K1X/K2</E=''/:-(XLB<.K240E2<0
E2</KR4WK"80E#@/E3@-KR4WLA\-K2<-L1\0E2<VKQ\/K1\0KR4-E24VE28-KR</K2</K2<ZK2</K2</K2<.KR</K2<UK!!T.K2<0E2</K2</K2</K2<UK2</
K2</K1UQE\3YER4VKS@/KR8WEQ\WK2<UK24VE2</E2<.LC@.K2<UE2<WKR8VLA\0E1\0E!!\WK1T-K2<WE2</K2</K2</K2<-K2</K2</K2<ZLB</KR</E"<V
LCT-E2<UK#@-K1(UK1X/K2</K3@/K2<.;N3[6Q WK1T/KR<UER</KQX-E2</E"<WKR8-KS@0K1(/ER<WKR<-ER<WE2<0LAX-K24UK2</FB4/ER</K2<-K2</
K28/K2</K2<-K2</K2</LB</K!!XVK2<2K3L-K2</K2<-K"4/K2</K2</DDCX5"4XK"</LB4-E3@/E3@/LB4/E3@-K24WFB<-L1\WK1\0LC@-KS@-K1\/K2<U
KR40KS@WKR4ULB4/L2<0KR</ER</E"4/K2</K3L-KR</K2</K1(VMR8VK"</KR4-K24-E"<ZK1 /K24-KR<TD1LULA\UE24-LB4-E2<-E!!\/E2</LA\ZK#T5
FATUK#L.LB<WE2<-KR<UER<0K1X-E1\/K2<UK2<0LB</K2</K24-K3@/K2</K2</K2</LB<-K3@VO_GLK1(/K2</K2<UE24-K2</K2<ZK1(-E<''YMQ$/K"4-
LC@-KR4VKQ\/E"<0E1TWL=S6:3DWLAX-K280LB4/K24ULB4WK3@0K24/KQT/EQ\XK2</K"4-KR<0LB4/K28-K2</K2</K2</K2</E-''-4!!D0K"</K2<ULAT/
K1(3KR4.K2<-K2?*?W(PK24.E1\/EQ\0ER4ZLA\WF#@2E7+)4<42L1 0E1TUKR<-K"<0K2<0LC@UL3@/K280K24WLC@0LB</K2</LC@/LB</K2</K2</K"43
KR</K=KW6,4WK24.K2</KS@/K2<-KR</K2<-K2<X:?+KF#@WES@-K3T3E1TWFB4WLB<WDQ+L=>''0N1@-KR<-LA\-KR40LA\-EQ\/K2<-E2<WK1X/K1\3KSL/
K2<.K"</K24/K2</K"</K2</K2</E"?*;_W0MR<0K24/K"4ZK2</K2</K1(UKR</E/G:2Q(/K#@-LC@ULCL-LATWE24WKR<X3>8::]L-LC@WK3@0E1\WK24V
EQT-KR4UE2<0K2<WK3@-KS@/KR<.K2<UKR4.K3@/K2<-K"</K2</K2<ZN''++5R<UKQT/K2</ER4/E"</F"</K1TXE!!W+>4@TE"<UKR<WER4UE!!\VE24-FA\/
E4C*;N1:FR4-KR4/K2</KR</K1\0E24VK24-K24UKQ\WKR40KR</K2</K2<.K2<-LB4/K2<-K"</KR4-K1(-OCLXE1X.K#@WKR</K1(/E"40FQ\<2!!(/:/-@
D#):K!!\WKQT-K1XWLC@WLB<0LA Y^-/RF!!T0KR4-KR</LB8/E24WK3@0KR4/K1XWER4WKS@5KR8/K"4/LB<0K"4/K2</K2<-K2</K2</K2<0FB4/"G(-K3@/
KR40F"8XK27R6Q U5N(VE^/>OACN;28RO-$8K1(-EQ\-KR80E!!@92!!\VEQX.K"4-LC@0KR4-K#@0E24-KR4-E1\WK2</K3@/LC@/K2</K2</K2</K2</K28/
K2</K2</K2</LB40MOG;3QD0K3@/E27M5AXZ5^4WD=W0K!![]?#8P3^,0D\+*N!!L16S$.E3@UE1X5<O5:DB80KQ\0KR40LB4-KR4-LB4-ER40K"8.K2<WK1\-
ER</E"</K2</K2</KS@/K240KST/LB</K24-K1\.K1#L?N45K2<:M!!TV6^$UF\71MQ+S;24R:?0=D-K-E1+U:1XQ3OX1F!!T5K1(W2O3-LC@/L1\-LB4/KS@0
LC@WKS@-KQT/KQT/E3@.K3@UK1T0LC@.K2<-KS@/K2</KR4/KR<-KR<-LB<ZLC@.EQXVK_'':3AH/:^(.F''+*NAL:<G(FPO@1E./=N@3Z<A\W;M$UFN3)F!!GJ
;S(XK.7<3Q@/ES@-KR4-KS@0LB4/KR<0K2<WEQ\-K1\/K!!\/K1XVL3L/K2</K2</KS@/K2</K2</K2</KR8.K24/K2<3EQ!!:>? 2DG+-O!!D4:-TYL-X8AQH-
A DQE \ADQ GD-_LDS[*5!!DV:^(ZF]O;<QDUK"4-KS@.K3@0E24/K1\-E2</LB8WER<UKR<WE1\WK280K2</LB</K2</K2</K2</K2</K1(/F!!\/KR<0LB8W
K=_<6AHU<]$UE>''XD @F@ DBA0 G@@@HA0\DA0LAA0\06S(SPN9:ECG>>,$XEQX-E24-KR8WLC@0KQ\-KR4-KR4-K2<-KS@/E3@/EQT/K2</LB8/K2</K2</
K"4-K28/K2</LB</K3@/K1T.E!!)@=>47D]G1LP$PBPL@@ @HA0\BA0$I@ \IA0TGAPHD@0\@B]O.K!!]:?/DQFATWEQ -KR</K1\0LB<0KR40E2</K2<-K24-
E2<0K#@0LB83K"</K2</K2<0KR4-LC@/K2</K24-K2</KQX06=PYFM7;6QH0N1LCA0L@BPHIB@$FA0$GA0\HA0$BAP\HA @G@@PSE0T8=?$=D#KZ"B4-K1X/
E"<-ER4-K1\/K2<WK1\-LA\WK24WKR4WLCL0K24/K2</K2<0K3@0K2</K2</K2</K2<VK2</K]S9NA 9=/ XA@PCAP\I@ HBB@\EA0 HBP IAP GB@ EB@\I
B@$G@ PAL?_]EA#Z=#XVKQ\-LC@-LC@0EQ\WKS@.K1T-K2<-KR<0LB<VE1 -K2</K2</K2</LB40LB</K2</K2</K#T0K2<6E1$.;N0WCC4:@@@EBP @@ \E
B@@CBP\H@ THA0 IBPTBAPTGBPHHB@ GB@LEAQ):;<,XKSH3K280LC@0K3@WK"40E3@WK28WK24/LB4-E1\ULB</K24-K2</K2<-K"</K2</K2<-LB<VKR8:
:-XRFC#/3APC@0DIB@ GA0 GA0\H@ \IBP$E@!!LI@ TH@ DAA@\GB@ I@@TIA0@G:]$VFCK,6QX/E!!\WKR4/E28WK2<0KR<0E240KQ\/KS@VKR40KR8/K2</
K1\XFQ\0K2<0K28-K1\3KR4/FMO031 WN!!\@@@$HA0$BB@ GBP@HA0$IB@\HAP$CD.''>?__96Z<B@P\H@ $@E@@HA0$TFB;W<CHUK2<-K3@/E"<UK24-DR<X
K3@-LB<-E2<0E!!\/K2<ZL"8/K1 .5M(7DR</K3@/K24WK3@2DR<W5^(=DP\DAP$AB@ GBP GAP IE@@HAP FBPDP:_7>?/W:=_#:>3DAAP@HB@$@B@HB@@WX
;SX0E280D#T0K2</K2<QL4@>NATVLC@-LC@-ESLWL3@-KR<XK"<V4>;,63H-K2<0K1\WK!!]Q:=TZDCCM^ P@E@@CA \GA  TA0\E@@$TD0\H@Q[%?O/<>/+;
=?/:?OW=M@DI@@ @A \GB@HGM''(RFSG,42<UK24/FB<0ES3*;.9@ES@0KS@-E3@-E24/KS@XKR8/L29Q6^,/E3@.KR<0K!!X-FL316S@PD0$BBPHIAP\IA0$H
B@TEA \G@0DGOO[7?__>?/[<>?+:>?W=;/(3@QPCE@HGB@$GB@DHF#_,:3,UE2</K240E"<-K][0EQ\/E24WE2<0K3@/ER<UK#T/LB4VMN//L#@UK3@0K2</
E!!XU^-_XE \IA0$IBP HD0 B@0PA@PDBMMW5>/3<>/;>>?_:=?/5?/3==__8;28DB@TGBPHBB@HEAAG+;CXQEQ\/K1\/FC@0E#[+^!!$VLA\-K"<ULB4UE285
KSLWMR<VPG(<:3,WFADUK!!X33=X5F!!)@^ XBAP$EBP HAPDV6^W1=/;=?O+:?O+7=_/9=?/8=?+:=?+7>_W6=_;7N@LG@ $HB@TGB@LGN"<UE#+LMB4/KQT-
EQ#R<R</ES@0KR<WKR8/ER4-LB4/K24ZL<''8;]$3K=#TLQH.D,776#PQE@XBA0\BB@ IB@ON?O7<?_+;>?W<?O#):?''5?/3;?/7=>?7<>/[7>O;>=?7T@0 F
@@XGA LTB@LREW+,;SP/K!!@=3#TV6=(PLB8-E24/KR<.K3L.LB80K2<-KQT0M$@.FCS6>./PF"4ZT^3WN!!PBB@TEB@\GAPS[?__;?O/>>/W-9][Z:.3X2$@7
O\$>N%GJ^,+[:_C.=?''.?_ E@PXEB@TGBP\E@4C053@UF#CT=?7LDS$1E3@-K3@3LC@/K1XZK280L3@-KR80LA UL24UPM''<<=,4E!!D/33,BA0TBBP IBPO+
?_#;>//6=_W66=[SPCSR>?/;>?7=?_7<>?7ZDSOP3\''Z7^/9?MLA@0 IA0HHBPLWY1$SETC*>/7ZMB40K#@/LC@ULB<0LB8XLC@.K#@.L28.LB80K#@5E1 .
3_#:>L03F!!DIB@ EB@ EB@#L?_#7>/W8;_G.6\44O_3<?O3<?_7=?_7=?O/;:O7<3QU:+5D=2^/7=30A@PTFA0 H@@TVM-S9>.,<KQHWEQTWLC@0LB4-LB4-
MR40KQ\-LB80LC@.K3LWLC@5K1T14/W>6SXEB@\IB@TGAP G?^/6>/#>;.7-6#$<=?7=>?7=?_7=?_7=?_/=?_3:?_3<+1[L^#\:2MK:=4@A@P$FAP\BO?C7
=]PUE"<.L1\0K"43K"<.K"<WE24WLC@0K#L-K"4.KS@-L28WL3L0LAY@5.;OAPLFBP FA0$FDO7+>]''.>M/Z4AG>>?7=>/7<?_7=?_7=?_7<?_7=?O7=>?3=
K8!!:O3(2PM+7?M,C@@$G@3;55CHZK24/K3L.LC@5KS@0KR40LC@-LC@/E2<-LC@0KR8/LA\0K#@3NCLQD241E0 HA0 IBPTEA##;>M_*6\?TNC[:?_/=?_7=
?_7=?_7=?_7=?O3<?_3=?_3<>/46NMQ:NTA:3-#6?Q(DBPLBK1XQEQ\WK"8-K#H/EQXVK3@/K#L0K#@3E3@WLB4WKR<-LA\-KSLWK]W963PRD \@AQLHAP\E
A KZ>-WS3DA@M##=>?7;>/3=>/7=?_7=?_7=?_3=?O7=?_7=?O3<?Z<14''*HPL7M6O;<@0@EB@\-M-+.O#@WK"<UE28WK240K!!\0E2<3LC@.K3@3L24-LB8.
L"<.KQ(:4>++O0TGA HTAPTIB@XC<M-@TSY@KTC;?_3=?O7<?_7=?_7=?_7=?_7=?_/<?_7=?O3:?O+=+2;P^''*H5]''L=^TAA0 G^.305CLVLC@/E3@/LB<.
K2<UK2<0K1\3K#@0LB4.K#@/E2<WK24/E1 /PC,E@ $GAPXHD0\FA? :MCX$KSG;?O7<?_7<?_7<?O7=?_7=?_7=?O3<?O3;?_3<?^#==?1''N,-:NW*/2\''/
FP$B@2=@L@0/K3LWK1\/ER</K2<WE280KQX.KS@5L280LB8.K"85K245MAT/E!!DSBP\IAP EBPXIEA_[K#P5M@K;>/7<?_7=?_7=?_7=?_7=?_7=?_7=?_7=
?_7=?_7:?_/<>!!X<M#H0M%D8O>,CA0$GF!!\ZE3TVKR<VK2<-K1\-K"40K1\XE3@-LC@-KR</KR40LA\02^?W^"4YBPTEBPTEE@THD@ONM1\-L0W<>?7<?_7=
?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_/<?_7<>/7:@B82K"81OS+LD0 HBQP13>3UMAT/KR40LA\0K"<VK280E2</K2<WLB4-KS@.LB<-K2=Q4=''YNP$GAPTF
B@XEBQL@5QD-E1E@?_3;?_/=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7<?_/:?]PRE3@-FCL9N!!HHA0H-:?CXOA$WMS@WKR4-KQ\0LA\0E1$/K24/K3@0
LC@.K#L/E24ZDQ XLQXIAPTIE@XEBQLGKS4QK1\E?_/=?_7<?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=>?3=>/3=?_+<AQX/K1\/IB<RB@$BBCP3F!!T/K#@-
LB4-K3@0KS@-KS@ZER</KR<0K2<0LA\/LA\XK1XVK1$FA0TFAQPIE@$FA3<ZF!!(Q^/;=?O7:?O7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7<?_7:?O7=?M(Z
F!!XWK1\WBP\EA  RE"<WE1XWK1\0E3@3K#@WE28WE"</F"4UES@/LB<0K1\WPN7,Y3DVA TSAP EA!!PEA1D9DA$VBO7=?O7=?_3=?_7=?_7=?_7=?_7=?_7=
?_7=?_7=?_7=?_/=?_3<?O+=AQ(WCA@VF \FAP\BD3!!:4,40E3L0KR40K#@-KR4/KQ(0LC@VK2<-K2<0K#@-E3M:3^''1M!!LHAQPSAP$EAP$0E!!HQF!![3?O7<
?_7:?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?O7=?_3=?O7=?S\VFQDPFQLIBP F@AG,:-%:K1XWES@0KR<0LB<-LA\ZL24/K2<-K24VK3@UE2<VFAD/EQ(@
APXED0TEAP$RMQ@QDPWM?_7;?_3;?O7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_3<?_3<?_3=?_;,D1$ZF!!HPB@ HBP\HLB8YE1T/KQ\-KR<-LB4WE3@3K3L/
K2</K2</K!! 0K3@VE!!HYEQ$PAPTFA XEE@TFMQLSDQDH>O/==_3=>?3<?O3<?O3<?O7<?O7=?_7<?_/<?_3<?_7=?_7<?_77=_[.?  QD!!XZD@\HBPHEBA@U
F!!(UK24-K"8WKR</LB</KQ 0EQX0D"<0E3L.K1XZL=GZ3#8WD TFE@XEAPXTE1TTDQLRB_O9>//<?//=?O3<?_3<?_7<?O3<?O3<?O3<?O7<?_7=?_3<?/+>
>_#2;/$LD1LQDQPHA0 IA0@-N&_IM!!XWK!!\.L1 /K1\5LB40K!!\/FR4XF#@VER<0E3OT5>3*4ALEA!!LFAP$FE1\SDAHTDQC=<?;8=?''9=_[;?_7=?_3=?_7=
?_7<?O7<?O3<?O3<>?73=_W5>M?15=''-K!!LPD1LSA  GB@\INN707T@VLB<WE1\WLAXWK3LWER</M]#*5SH3K!!TWE1XZE1\WEQ$SAQPSA TED3LRD1DSD1P$
>.//>?''_;^+.=/W7=_O:?_7=?_7=?O3=?_3=?_+:?O/6<M?1;^7W6=''Z73 FD0TEA  IAP\G@1(3E24WE1\-K1\-K<;OMA WFCH/K3#W^-]''D1$YD!!TZF!!DQ
FQDPD0TFE@TEEADREAPRDAHH^/#Y5=?*;M?07>7-7>3/</W:>//=?_7=?O33=/W9;>;.;]7,6=7+7=W,5]]:@0XFD1HGA0\GAP\SF!!(ZFQ$QFQ$WE''+R6=PV
K1\XLB<0K3[TO!!(U3M''Z6M+X6-WRMALIAPXIAQPYA!!HSD!!LSBG+06-_,6>3_6^''_<^/Y7=#+;>?9=_3=?O/6<?C0;-?,;.7_;MWW:=#V7=GYP@\TBPTTBP\G
B@ CE&_J2L!!''"L8?K1%:5M[SK1T/F"8WFC_*41\VLN3:>O[7>O''5>G(EB@TFBPTTDPTPEA@TD UQ?./X7_K+7^++;_C_:.;2=/3;>/7=?_3<?O7>=/;8<O[-
<N/Z7>/X6-+V6W(@DALHD0XIA0 GBCS5=/C-=/''7>T@T3N+T:Q\-ER</E#S+5V\VL1X3TS]J^#-QORH/A  EA TEA!!@HDQHFDAHH^/+/:=_-<M?0;_W7>_''=
?/O<?_/=?_3=?_3<>?3<?O3<>/''/;N?.:]?,5=]@BAHSAQLEB@$IB@LZ^''+O^,1:4-D-D]SVN>07DR8-K1 ?:>/XN1\/EQXOFQHYFQ(RFPXEAP HBP$TEA@S
EA@RD!!''3:?_/;?#9=_/<?O7=?_7=?O7=?_7=?_7=?_7=?_7=?O7<>?W>>N++<N+6LP ZAQPED@ IA0TIAQHZD1(ZF!!XVE1E:6N+TEQ\.KST0FATUL1TZKR</
K1$QK#L2M"8EB@$IAPXEE@TSDA@RD!!PG>?#8;/37>/+=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?O3;?OW6>_;.?AXED1PTEA$HA0 G@1(5EQX/E"40E3@Z
FC(1K!!T0E1XUK2<WE"4VK3@WE24VMM''/;>%:A0 IB@ IBPXED1LSD1@F@?3<>?W=>/7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7<>?7=?O3<?_(GDADR
A TPB@ I@ \7<_G+Y1DVK2<UMQT/EQT.E1XUK1 /E1 -LC@-E2<VKST;NSL/D!!PHBP$GA0\IE@XTD1LPD0#+?O7=?_3<?O7=?_7=?_7=?_7=?_7=?_7=?_7=
?_7=?_7<?O3<?_7=>/35BQLTE@XFAP$IBPT@E##P3S /ER</K24-LB<0E2<5LB8/E2</LB4/K1\0ER<VE!!DYF!!(SB@ IBP$HB@TEEA@PDA@TM_7<?O3<?O3=
?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7<?O3<?O3<?O7:5PXPAPXTA!!PSB@HEA1DYF!!(UEQ\VLB8/LB<WL24.KS@0ER4.LB4WEQ\WE1\WE!!DUKSH:EPTGA0$F
AP IBPXSD1LSD@[=?_+=?_3<?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?O3=?_3<?_3:?QLID1LSA!!HFBP EB@\5E1DQKSL0LB</L280E3L3LB4-K!!\/K3@0
KR<-KQT/E!!X76>++6R<FA0\HAP$HAPTEAPXTD1HQ5_7<?_3=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7<?_7=?_7=?_0@FQPSA XFA!!PIA0PW;N3U^!!(V
LB80K1XUL1TUK3@WF!!\/ER</E1\UER40E2<YN-IQLA QBP EBP$HB@ FAPTTD1LSFQO;?_/=?_3=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?_7=?O7=?_7=?_45
A!!HSD0XSE@XI@ $ID3+M6MT/ER4XE1\WK24WL2<0LA\-K28/K2</E"<-E2<WE1$SFQ$YDALBB@XHBP$IBPTEA!!PSDA$E6_+=?O3;?_7;?O7;>?7=?_7=?_7=
?_7=?_7=?_7=?O3<?_3<?O3<D1@SEALFD0XEE@$IBA@YFQX-KQ\/E28UER40ER<WFA\XL#@/K2</K1XUK2<UFQ(/F!!$YM#4WA  HB@ GBP$EAPTFEALQFPC3
?O3;?O3=?_7<?_7;?_7=?_7=?_7=?_7=?_7=?_7:?_7<?O3<K  VD1@PEALTAPHGBAP.EQTUE28.K1X/E!!\WKQ\/LA\WE"<VK2</K2</K2</FB<YDCGZ:>3V
E0\HBP GAP IBPTEA!!PSDA$PE?7<?O3=>/3=?_7=>?7=?_7=?_7=?_7=?_7=?_7:?_7>?_3=5 @SF!!PQA TTB@ IAPPW:=U:M!!$UE1 WE2</E2<-ER40E1(/
F"</K2</K1TXF"<ZK1X85,8/DALPAP\IBP HB@$IBPTFEA@ODP_T>?3<?_7=?O3=?O7=?_7=?_7=?_7=?_7=?_7=?_/=?_7<?@LRDQLED XSEALI@0 EAS/I
;L<.E"4WKQ\/K2<WK2<ZE3@WK2<-K2</K2</E!! VE2<XFQ XDQLQD0TFB@\GB@ IBP$EAPXSD <X@N?=?O+<?O7<?_7<?_7=?_7=?_7=?_7=?_7=?_7=>?7=
?PDPDQHSA!!PTD0$HBAPGBQ@YF"40E1\-E2<VE!!\/ER<WE1\VE"8/K2</K2</K1(-E2<-LB8VFQ <43 SB@$EB@ HB@ IBPTEE@<SEA\B;_O=>/;;>?3=>?7=
?_7=?_7=?_7=?_7=?_7<>?7<?PDPDQ@SE@XEAP\GBPTH@3T9F!!\ZK3@/E1\0KR4UEQ\/ER4.KQ$/F"4VF"<-F!!TWE#@0EQXWDC7X:-X2E@ G@@ HB@ HB@$E
APXID!!HSDQSY?/3>>?/:?_7=?_7=?_7=?_7=?_7=?_7=?_7:?PDSF!!LPA  IBP GAPTB@ T?9]-''K1XWKQX/E1T-LB4/KR4/KQ\WLB8-K2</K"4/K1XXK1XW
E3CN6CLSA XTA HIB@ HB@ IAPTHEAPEFQHKA$C5?O+=?_3=?_7=?_7=?_7=?_7=?_7=?_7<; PSDQHSAPXHBPHIBPHGB@$HDS[T:S,/K2<WK1TZK24WLA\-
E2<WK24/F"<ZK24-KR<ZK2<VE"<WE!!LYF#L>K TGB@$GB@ IBP\IAP$ED!!LSBPLCEO/=?_3=?_7=?_7<?_3<?_7<?_7>?_3<LPHSFQLPD@XIBP$HBP$GA0HE
FQ(RFR8UE2<-KQ\0K2<VK2<UE24-LB40L2<0E1(UE"</K2</K2<VDQ$XKS;,<S(EA0$HA0 HB@ IE@ SE@$TAOC=>0LHL?O;?O7<?_7=?_7<?O/=?_;;?O;I
B@HFDQ@PD@$HA0 HA0 GA0HGO_GMKQDWKQT/E24.E"40K1T-K1XUE"<-EST/K28-K2</E"</FATUEQPVL]+.:,<UAQLBB@\IB@\GA0TIAP$TBS#=?N#:AAHD
F/+<<?7=?_3=?_7=?_+<=SHD@ XRDQPTDALGB@$HB@ GA0 E@#S+;]X7DQ$/K1\VLC@ZE2<-EQ(UK1\UE24/K2</K1(WE!! UF"<.D!! -3^?05CXQEADTB@\B
B@ GBP HA $HD0H/?_/(; DSB1LGBPP36/_<?O/<:''(G@PHHD1HSE@XTD@XGA0 IA0\GA0\HA0XQL]K/:-X1DAX/ESLVKR</KR<UE!!\0K1T0KQT-E!!(/LB<V
K2</FQ#I:>;[PA PDSGMMPXGB@THA0$IB@\E@ TE@?_=>0DSD1LKDA@KA \@@0@@@@LHBQ@SEAHSEAPFA $GB@$IBP\GB@ IA1\2E1HZO-+.:=P0F!!TRE!!TU
K2<WE2<-LCL-E#T/K2</E"4XE#_VLQL4;O#NE1 VFDC[3Q$IBP\IBP\HB@\HE@ TE@@G@PPIEAPSAP,EAQLPD0XTD1@SD!!PKD0XED0XFA TGA0\@AP$GBP G
BP@7:\8VDQ(-3>79PB?R57(ZE2<-E2<0EQX-KR</K2</K1 UK3[X:#4QES$1K1 UE7+%21DEDQDG@ $HB@ IB@THA!!DFB@TID0TSA  GAQPTE@XTD1PFE@$F
D0 ID0XIAPTIB@\GB@ G@ \@@!!PED37[5R8XE!!H2^"8:6L/VMAT-KQ\/LB4UE1\0E!!\WF"</LB<VN-P7E!!\-E!!(/K1H;M!!HYDS47D HHB@\GBPTGAP$IE@$E
BP EBP IB@ HA XEAPTEBPXTBPTEAP IAPXIA0 G@ \IA0\EA0X-KQDRLW(3E1\UE1(S^,056G(QK3@/ER4-E1\WE240K2</K2<RFB7YOQXVKQ\UE!!\YE!!TQ
DW+%NAPFBP\BAP@TFQP@A0XCAP HB@ HA0\HB@ HB@ IBP$EAP$IBP$IB@$GB@ H@@ HA0\GA0HR5=TYF!!(YF"4/K24WDR;[5^-@DQ(WE24WE3@.F!!T/F"</
K2</K2<.6C4/KR8WE3@-KR<YK-O,Y0XPD@TG@ D@+-/1L@DDAP\HB@ HB@ HB@ HB@ HB@ HAP$IBP$IBP FA TGB@ I@  GB@\HDB;[5CTYK1\UF!!\WK1\U
4L''ULQ\UE2<-LA\WLAT-K2<-K2<XK2</K384E1\/E2<WK"4WESST^ HQDL(4B@LI@S7(># @A0\EB@ GA0\GB@ HB@ HB@ HA0$IB@ HB@ HBP HA0 HB@\E
@  6KQLYLM,8EQ\/FAT0K1TXL-[Y3QTWE!!XWK"4-EQ\XK"40KR4/F"<-E!!XUFA\WK3@0E1TWE1\ZE!!DQE,7VF@$I@@$ANV\A@P HA@HHA0\GA0 HB@ HB@ H
B@\HB@ HB@ HA0 GB@ EBP IAAPIO=$2D!!D/KQ WLB<UKQXWK1X0K3@UK24/ER<ZER<WE2</K1 /F!!X/F!!TVK1T0KQ\UE!!XVF!!(UK24RE<7+M@TIL1@HA0DA
@ LH@ \BB@\GA0\HB@\GA0 HB@ HB@ HB@ GA0 GA0 BA0$GBADSD1+R6STZFA(ULAXVK1 0E2<UE24/K1 /K1\VK1T.K1X-K1T/E"</KR</K1\WK1TWE24W
KR<0EQXVESCXNP QM]L3A1LEBPHI@@ @@  GA0\GB@ GA0\GA0 HB@\HB@ GA0 HBP\EAPHIBAQ:M1\FK]U:D3@UER<UK1\/KR<-K2</E!!X-KR<-KQ\/E1\/
K1X/LB</K2<VFAT0KS@WE3@3ER4UE240FA(WFATSE]SJDQLUK  EB@ @AP HB@ HB@ HA0\GA0 HB@ GB@ HB@\HB@ BB@\IE1DGM-\7DA(ZF!!\UKQ\UKR4Z
EQX/K24/K24WE1\WE3@.E2<0KR<.LB</F"</K2</KQ\WLC@/EQX/K2<XE1 WEQ XFL7[F@T/6L EA0 IBPHHB@ HB@ HB@ HB@ GA0\GA0 HB@ HB@ GAP$B
K]WIEAI:6R<YEQ UEQ(WEQX-LC@0LA\-K"<0E2<WFATWKQTUE3@0KR<UK2</K2</K2</EQTWEQX-K2<XK1\/K1TZFQ!!@L!!PQ4>$;D@ TAP BB@ HB@$IB@\H
B@ GA0\GB@ GA0\HB@ GB@$FD1+Z;CDSE]@2F!!T0E"4WK1\WE3@/K1\/E1 WK2</LATWK24/KQ\UKQTUK2</K2</E"4/EQ\0KR4/ER</FATZE!!XQE2<XEQ$R
O^''UEPXPE@XIAP$HA0\HB@ HA0\HA0\GA0 IBP HB@ HBPTSD1@QO?CTFQ$UEQT-FR<XER<-EQ\-K1\WEQ\/LC@0ES@0LB80K2<-E"<UK2</K2</K2</K2</
K1\WLB</K1(/E!!TVF"<-E1 PK=W0PAPSE!!LRE@XEBP GA0\GA0\GA0 GA0 HB@ HB@$EEALPF!!(ZDQ[[;S QEQ\/E1\XE24/E1\/E1\-K2<-LC@/KQ\/KR40
EQ\UKQ\/K2</K2</KR4.K1 /K2<-K2</K2<ZKQT/K2</FA /DW+%6B<RFAXQFAHQDALFAP$HBP$GB@ HB@ IBP\HBPTTDADZF!!\UK1TSY>+XFA\/EQ(-E1\U
E1T/KR40LC@/K"<UEQ\/KQ\VKQ\WLAXVK24/K2</K2</K2</K2</K1T.KR4-K2</F"</E"<XFR?1=T@FEQ\XEQ(/E!!DRFQ@PEALFBP$IBP$EAPTSDAHQDQ$Z
EQXWER4-E#KY=7(SK2<0EQ\/K1\WKR4/K"<UK24-E"4/K2<UE1\/KS@0LB4/K2</K2</E"</F"4-KR8/KR4-K"<0K2</K24/K1+R>=$UER<UK1TXK1TZEQ U
F!!XZFQXVDQ(VFQXVE!!$UEQ\VE!!XUE1\/KS@V^.?/MQ(WES@ULC@-LC@/E1\-E1\WLA\0E2</K2<WE2</K#@-KR</KST-K2</LB</K2</K2<0LC@0K2</K2</
FAX/5?U:D"8/K2</K1T/K2<-K2</K2<VF"<ZK1TVEQXWK1X/K2<UKQ\WK24WD"?*?$@QE!!$0F#@-E3@0E24/KR4UE24-LAT.E3@WKQ\0KQ\VKR</K2</K2</
K2</K1(-K2</K2</K2</K2</DCX<K3IQFQ\-K24/ER4/KS@/K1(/E"</K1X/K2</F!!T-E"</K2<VES@-KQT/ESLXLW(0FR81FC@0LA\/E"40K1(-LB4-E2<W
K1\/E1\-E2<0K24/K1\/LB<-K2</K2</K2</K24-K2</K2</F,/->M$UK1\-LB4WKR</K240K2</K2</K1T.L2</K2</K2</K2</ER4WKS@/K3@-K3?,O#[+
:-TZES@/LC@.K1\/K24WKQXWKQT0KR4-KR4WLB4/K2<UK28.K2</K2</K"<0LB</K2</K28/K!!WV6G+%NQTVLB</KS@0KR4-K2</K3@-KR</K3@/K2</K2</
K2</LB4WL2<-LC@/K3C*>3?O6G+%K!!\WLA\WLC@-EQ\VE2</KR4WE!!T-KR<-KR<WE2<WE"<0K2</K2</LB<0KR4/K2</K2</K2<X6L$.;D@VL3L3K#@-E1\/
LB40K"8/K2</K1TZE!!(-K2</K1(WE2</LB<0LB4/K2<VN-\86-P1:3 WE1\/ES@0K1X/KQ\-E24ULC@-KR4-E1\WK240K3@-K2</K"4-K2</K2</K2</K2</
K2</D]/RPN%@E"43KS@0KR</EQT0K#@/E2<-KQT0KR</K2</K2</K1T/E24WK1\0K#@.K#C,^-KML_@1ES@WKR</E!!\-ES@WKQ\/ES@0E1\WLB4WK2</K2</
K2</K2</K2</K2</K2</K2</K3@0KQ[H<^3[LA\/E"40K283LB4/F!!\/E1\/K24UKS@/K2</K1T/K2<ULC@-ER4WE240K"<16W+J<^3,E!!X/E24/LC@-LA\W
K2<VKS@/E!!\/EQX/KQTVE1\ZK1\WKR</K2<-K"</K2</K"</K2<-K24/EW+PN1$.LB</EQ\UE24-E2</KR4.L2<0KS@-E1\ZEQ\VK1XVK1\WE3@0LA\UEQTX
LC82E-KZNA\-K3@0E1T-K24/E1\/ER4UKR4/K1T/E!!X-ER<-KR<0KR</K2<0K2</K2</K2</K2</K2</K2<XE!!X-K1TWKSL-LC@0K2<WER<WK24VE1\-EQ(-
K#@3E1\0K2<WKR4-K2<0K"<-E!!\.K1 WFB<XK24-KR4-E24ULC@/KQTUE2<UE"4-LB</K1X/E"4/KR<VK2</K2</K2</K2</K2</K2</LB<XK3T0K!!X.LB<0
LB4VE"4/KR4UE1\/K2<0K1\UE3@UFC@/E"<WE"<WE1TUF"40K3@-ES@.E1T/LAXWLB8-LAT-KQ\-E1\WLC@WE1\/KS@/E!!\WL3@/E#@.K2<0KR4/K2</LB</
KS@/K2</K1(-K28/EQ\0LATWLB<0K2</L1XWK3@/ER</K2</K2</K2</K3@UK1X0K1\WK3@/KQT0LB4/KR8-K1\UKR<VK24/KQT/ER<-K1X-K1XXE1\WK1\-
KR<-KS@-LB4-K#@0K2</K"<-LB<-KR<-K2</LB</K2</K2</LCL/K2</LB<-KR</LB</K2</K2</K2</K3@/EQTWE1T-LC@0LC@0LC@0E2<-KR40EQTUEQ\-
E24-LA\-E"<UE3@-E1\/K1TVE1T/K3@/K2<-K"4-LCT0K"</ER<-LB</K2</K2<0K3@-K240L24/E1\-KR4UK2</KR4/K2</K28/K2</K2</K2<-LB</KQTV
K240E1TUE1\WE24/EQ\0KS@.K24-K3@-KR<UE1T/E2<0ER<-KR</') ; colorMapFromArray:#[10 10 10 0 0 0 13 13 13 6 6 6 3 3 3 26 26 26 30 30 30 16 16 16 20 20 20 23 23 23 0 0 63 0 51 0 0 51 63 51 0 0 51 0 63 51 51 0 40 40 40 46 46 46 43 43 43 36 36 36 33 33 33 60 60 60 57 57 57 63 63 63 51 51 63 50 50 50 53 53 53 0 0 127 0 51 127 51 0 127 51 51 127 0 102 0 0 102 63 51 102 0 51 102 63 0 102 127 51 102 127 102 0 0 102 0 63 102 51 0 102 51 63 102 0 127 102 51 127 102 102 0 102 102 63 70 70 70 77 77 77 67 67 67 73 73 73 93 93 93 87 87 87 80 80 80 90 90 90 83 83 83 97 97 97 107 107 107 110 110 110 104 104 104 100 100 100 102 102 127 117 117 117 114 114 114 120 120 120 124 124 124 127 127 127 0 0 191 0 51 191 51 0 191 51 51 191 0 0 255 0 51 255 51 0 255 51 51 255 0 102 191 51 102 191 0 102 255 51 102 255 102 0 191 102 51 191 102 0 255 102 51 255 102 102 191 102 102 255 0 153 0 0 153 63 51 153 0 51 153 63 0 153 127 51 153 127 0 204 0 0 204 63 0 255 0 0 255 63 51 204 0 51 204 63 51 255 0 51 255 63 0 204 127 0 255 127 51 204 127 51 255 127 102 153 0 102 153 63 102 153 127 102 204 0 102 204 63 102 255 0 102 255 63 102 204 127 102 255 127 0 153 191 51 153 191 0 153 255 51 153 255 0 204 191 0 255 191 51 204 191 51 255 191 0 204 255 0 255 255 51 204 255 51 255 255 102 153 191 102 153 255 102 204 191 102 255 191 102 204 255 102 255 255 153 0 0 153 0 63 153 51 0 153 51 63 153 0 127 153 51 127 153 102 0 153 102 63 153 102 127 204 0 0 204 0 63 204 51 0 204 51 63 255 0 0 255 0 63 255 51 0 255 51 63 204 0 127 204 51 127 255 0 127 255 51 127 204 102 0 204 102 63 255 102 0 255 102 63 204 102 127 255 102 127 153 0 191 153 51 191 153 0 255 153 51 255 153 102 191 153 102 255 204 0 191 204 51 191 255 0 191 255 51 191 204 0 255 204 51 255 255 0 255 255 51 255 204 102 191 255 102 191 204 102 255 255 102 255 153 153 0 153 153 63 153 153 127 153 204 0 153 204 63 153 255 0 153 255 63 153 204 127 153 255 127 204 153 0 204 153 63 255 153 0 255 153 63 204 153 127 255 153 127 204 204 0 204 204 63 204 255 0 204 255 63 255 204 0 255 204 63 255 255 0 255 255 63 204 204 127 204 255 127 255 204 127 255 255 127 130 130 130 140 140 140 137 137 137 134 134 134 154 154 154 157 157 157 144 144 144 150 150 150 147 147 147 153 153 191 164 164 164 161 161 161 167 167 167 174 174 174 171 171 171 191 191 191 181 181 181 187 187 187 177 177 177 184 184 184 153 153 255 153 204 191 153 255 191 153 204 255 153 255 255 204 153 191 255 153 191 204 153 255 255 153 255 204 204 191 204 255 191 255 204 191 255 255 191 194 194 194 204 204 204 201 201 201 197 197 197 214 214 214 221 221 221 218 218 218 211 211 211 208 208 208 204 204 255 204 255 255 255 204 255 234 234 234 231 231 231 238 238 238 224 224 224 228 228 228 244 244 244 248 248 248 251 251 251 255 255 255 241 241 241]; yourself]
! !

!VUMeter methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    "Invoked when an object that I depend upon sends a change notification."

    "stub code automatically generated - please change as required"

    changedObject == model ifTrue:[
        self invalidate.
        ^ self
    ].
    super update:something with:aParameter from:changedObject
! !

!VUMeter methodsFor:'drawing'!

redrawValue
    |v org rad scaleX scaleY x y|

    org := 75@84.
    scaleX := 55.
    scaleY := 50.

    v := model value ? 0.
    v := v clampBetween:0 and:1.

    "/ map 0..1 into 0..pi scaling and shifting the phase
    rad := v * (Float pi*0.8) - (Float pi*0.9).

    x := rad cos * scaleX.
    y := rad sin * scaleY.

    self lineWidth:2.
    self paint:(Color grey:50).
    self displayLineFrom:org to:org+(x@y).
    self lineWidth:1.
    self paint:(Color grey:20).
    self displayLineFrom:org to:org+(x@y).

    "
     |m v|

     m := 0 asValue.
     v := self new.
     v model:m.
     m inspect.
     v open.
    "
!

redrawX:x y:y width:w height:h
    "called to redraw a part of the widgets area. x/y define the origin, w/h the size of
     that area. The clipping region has already been set by the caller, so even if the code
     below draws outside the redraw-area, it will not affect what is on the screen. 
     Therefore, the example below can fill the rectangle in the redraw area, but still draw
     the cross in the outside regions."

    |img|

    isPowerOn ifTrue:[
        img := powerOnImage        
    ] ifFalse:[
        img := powerOffImage
    ].
    img displayOn:self x:0 y:0.
    self redrawValue.
! !

!VUMeter methodsFor:'initialization & release'!

initialize
    super initialize.

    isPowerOn isNil ifTrue:[ isPowerOn := true ].
    powerOnImage := self class onImage onDevice:device.
    powerOffImage := self class offImage onDevice:device.

    self viewBackground:(Color rgbValue:16r333433)

    "
     self new open
    "
! !

!VUMeter methodsFor:'queries'!

preferredExtent
    ^ powerOnImage extent
! !

!VUMeter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libwidg3/VUMeter.st,v 1.7 2009/09/15 12:53:17 cg Exp $'
! !
